;
; ---------------------------------------------------------------------------
; 	This file is generated by The Interactive Disassembler (IDA)	    
; 	Copyright (c) 2003 by DataRescue sa/nv,	<ida@datarescue.com>	    
;   Licensed to: Michael Wolski - Personal Use	(1-user	Standard 07/2003)   
; ---------------------------------------------------------------------------
;
; File Name   :	C:\SKDisasm\SONICNUC.BIN
; Format      :	Binary File
; Base Address:	0000h Range: 0000h - 200000h Loaded length: 200000h
;
; 2006-12-31 - Original	buildable disassembly, labeling, and formatting	by Stealth
; Please list any revisions

; Processor:	    68000
; Target Assembler: 680x0 Assembler in MRI compatible mode
; This file should be compiled with "as	-M"

; ---------------------------------------------------------------------------
		cpu 68000
		include "sonic3k.macrosetup.asm"	; include a few basic macros
		include "sonic3k.macros.asm"		; include some simplifying macros and functions
; ---------------------------------------------------------------------------
; Assembly options:

Sonic3_Complete = 1
; If 1, includes all required Sonic 3 data in order to assemble a smaller version of S3K (with all redundancies removed)

strip_padding = 0|Sonic3_Complete
; If 1, strips all unnecessary padding

Size_of_Snd_driver_guess = $14A0
; Approximate size of compressed sound driver. Change when appropriate
; ---------------------------------------------------------------------------

StartOfROM:
	if * <> 0
		fatal "StartOfROM was $\{*} but it should be 0"
	endif

Vectors:	dc.l Vectors, EntryPoint, ErrorTrap, ErrorTrap	; 0
		dc.l ErrorTrap,	ErrorTrap, ErrorTrap, ErrorTrap	; 4
		dc.l ErrorTrap,	ErrorTrap, ErrorTrap, ErrorTrap	; 8
		dc.l ErrorTrap,	ErrorTrap, ErrorTrap, ErrorTrap	; 12
		dc.l ErrorTrap,	ErrorTrap, ErrorTrap, ErrorTrap	; 16
		dc.l ErrorTrap,	ErrorTrap, ErrorTrap, ErrorTrap	; 20
		dc.l ErrorTrap,	ErrorTrap, ErrorTrap, ErrorTrap	; 24
		dc.l $FFFFFFF6, ErrorTrap, $FFFFFFF0, ErrorTrap ; 28
		dc.l ErrorTrap,	ErrorTrap, ErrorTrap, ErrorTrap	; 32
		dc.l ErrorTrap,	ErrorTrap, ErrorTrap, ErrorTrap	; 36
		dc.l ErrorTrap,	ErrorTrap, ErrorTrap, ErrorTrap	; 40
		dc.l ErrorTrap,	ErrorTrap, ErrorTrap, ErrorTrap	; 44
		dc.l ErrorTrap,	ErrorTrap, ErrorTrap, ErrorTrap	; 48
		dc.l ErrorTrap,	ErrorTrap, ErrorTrap, ErrorTrap	; 52
		dc.l ErrorTrap,	ErrorTrap, ErrorTrap, ErrorTrap	; 56
		dc.l ErrorTrap,	ErrorTrap, ErrorTrap, ErrorTrap	; 60
Header:		dc.b "SEGA GENESIS    "
Copyright:	dc.b "(C)SEGA 1994.JUN"
Domestic_Name:	dc.b "SONIC & KNUCKLES                                "
Overseas_Name:	dc.b "SONIC & KNUCKLES                                "
Serial_Number:	dc.b "GM MK-1563 -00"
Checksum:	dc.w $DFB3
Input:		dc.b "J               "
ROMStartLoc:	dc.l StartOfROM
ROMEndLoc:	dc.l EndOfROM-1
RAMStartLoc:	dc.l $FF0000
RAMEndLoc:	dc.l $FFFFFF
RAM_Info:	dc.b "  "
		dc.l %100000001000000010000000100000
		dc.b $20
		dc.b $20
CartRAMEndLoc:	dc.l $20202020
Modem_Info:	dc.b "  "
		dc.b "          "
Unknown_Header:	dc.b	0,   0,	$20, $20, $20, $20, $20, $20,	0,   0,	  0,   0,   0, $1F, $FF, $FF ; 0	;CHECKLATER (ROM Bank Info)
		dc.b  $20, $20,	$20, $20, $20, $20, $20, $20, $52, $4F,	$20, $20, $30,	 0,   0, $33 ; 16
		dc.b  $FF, $FF,	$30,   0,   0, $33, $FF, $FF ; 32
Country_Code:	dc.b "JUE             "
; ---------------------------------------------------------------------------

ErrorTrap:
		nop
		nop
		nop

EntryPoint:
		lea	($FFFFFE00).w,sp
		tst.l	($A10008).l
		bne.s	+
		tst.w	($A1000C).l
+
		bne.s	Init_SkipPowerOn	; in case of a soft reset
		lea	InitArray(pc),a5
		movem.w	(a5)+,d5-d7
		movem.l	(a5)+,a0-a4
		move.b	$A10001-$A11100(a1),d0
		andi.b	#$F,d0
		beq.s	SkipSecurity
		move.l	#'SEGA',$A14000-$A11100(a1)

SkipSecurity:
		move.w	(a4),d0
		moveq	#0,d0
		movea.l	d0,a6
		move.l	a6,usp
		moveq	#23,d1

Init_VDPRegs:
		move.b	(a5)+,d5
		move.w	d5,(a4)
		add.w	d7,d5
		dbf	d1,Init_VDPRegs	; set all 24 registers
		move.l	(a5)+,(a4)
		move.w	d0,(a3)
		move.w	d7,(a1)
		move.w	d7,(a2)		; Z80 bus request + reset cancel

WaitForZ80:
		btst	d0,(a1)
		bne.s	WaitForZ80
		moveq	#$25,d2

Init_SoundRAM:
		move.b	(a5)+,(a0)+
		dbf	d2,Init_SoundRAM
		move.w	d0,(a2)
		move.w	d0,(a1)
		move.w	d7,(a2)

Init_ClearRAM:
		move.l	d0,-(a6)		; Clear normal RAM
		dbf	d6,Init_ClearRAM
		move.l	(a5)+,(a4)
		move.l	(a5)+,(a4)
		moveq	#bytesToLcnt($80),d3

Init_ClearCRAM:
		move.l	d0,(a3)			; Clear CRAM
		dbf	d3,Init_ClearCRAM
		move.l	(a5)+,(a4)
		moveq	#bytesToLcnt($50),d4

Init_ClearVSRAM:
		move.l	d0,(a3)			; Clear VSRAM
		dbf	d4,Init_ClearVSRAM
		moveq	#3,d5

Init_InputPSG:
		move.b	(a5)+,$C00011-$C00000(a3)
		dbf	d5,Init_InputPSG
		move.w	d0,(a2)
		movem.l	(a6),d0-a6
		move	#$2700,sr

Init_SkipPowerOn:
		bra.s	Test_LockOn
; ---------------------------------------------------------------------------
InitArray:	dc.w $8000			; d5 - VDP command template
		dc.w bytesToLcnt($10000)	; d6
		dc.w $0100			; d7 - VDP command increment
		dc.l $A00000		; a0
		dc.l $A11100	; a1
		dc.l $A11200		; a2
		dc.l $C00000	; a3
		dc.l $C00004	; a4
		dc.b 4			; Command $8004 - HInt off, Enable HV counter read
		dc.b $14		; Command $8114 - Display off, VInt off, DMA on, PAL off
		dc.b $30		; Command $8230 - Scroll A Address $C000
		dc.b $3C		; Command $833C - Window Address $F000
		dc.b 7			; Command $8407 - Scroll B Address $E000
		dc.b $6C		; Command $856C - Sprite Table Addres $D800
		dc.b 0			; Command $8600 - Null
		dc.b 0			; Command $8700 - Background color Pal 0 Color 0
		dc.b 0			; Command $8800 - Null
		dc.b 0			; Command $8900 - Null
		dc.b $FF		; Command $8AFF - Hint timing $FF scanlines
		dc.b 0			; Command $8B00 - Ext Int off, VScroll full, HScroll full
		dc.b $81		; Command $8C81 - 40 cell mode, shadow/highlight off, no interlace
		dc.b $37		; Command $8D37 - HScroll Table Address $DC00
		dc.b 0			; Command $8E00 - Null
		dc.b 1			; Command $8F01 - VDP auto increment 1 byte
		dc.b 1			; Command $9001 - 64x32 cell scroll size
		dc.b 0			; Command $9100 - Window H left side, Base Point 0
		dc.b 0			; Command $9200 - Window V upside, Base Point 0
		dc.b $FF		; Command $93FF - DMA Length Counter $FFFF
		dc.b $FF		; Command $94FF - See above
		dc.b 0			; Command $9500 - DMA Source Address $0
		dc.b 0			; Command $9600 - See above
		dc.b $80		; Command $9700	- See above + VRAM fill mode
		dc.l vdpComm($0000,VRAM,DMA)
		dc.b $AF,  1,$D9,$1F,$11,$27,  0,$21
		dc.b $26,  0,$F9,$77,$ED,$B0,$DD,$E1
		dc.b $FD,$E1,$ED,$47,$ED,$4F,$D1,$E1
		dc.b $F1,  8,$D9,$C1,$D1,$E1,$F1,$F9
		dc.b $F3,$ED,$56,$36,$E9,$E9
		; Above is Z80 code
		dc.l $81048F02		; Commands $8104, $8F02 - Disable DMA, VDP auto increment 2 bytes
		dc.l vdpComm($0000,CRAM,WRITE)
		dc.l vdpComm($0000,VSRAM,WRITE)
		dc.b $9F
		dc.b $BF
		dc.b $DF
		dc.b $FF			; Above 4 bytes are PSG inputs
; ---------------------------------------------------------------------------

Test_LockOn:
		tst.w	($C00004).l
		move.w	#$4EF9,($FFFFFFF0).w	; machine code for jmp
		move.l	#VInt,($FFFFFFF2).w
		move.w	#$4EF9,($FFFFFFF6).w
		move.l	#HInt,($FFFFFFF8).w

-		move.w	($C00004).l,d1
		btst	#1,d1
		bne.s	-	; wait till a DMA is completed
		lea	($FF0000).l,a6
		moveq	#0,d7
		move.w	#bytesToLcnt($FE00),d6

-		move.l	d7,(a6)+
		dbf	d6,-

	if Sonic3_Complete
		moveq	#0,d1
		bra.w	SonicAndKnucklesStartup
	else
		move.b	#0,($A130F1).l		; disable SRAM access
		lea	(SegaHeadersText).l,a1
		moveq	#1,d4	; test for both MEGA DRIVE and GENESIS

Test_SystemString:
		lea	(LockonHeader).l,a0
		moveq	#0,d3
		moveq	#$F,d2

$$compareChars:
		move.b	(a1)+,d0
		cmp.b	(a0)+,d0
		beq.s	$$matchingChar
		moveq	#1,d3

$$matchingChar:
		dbf	d2,$$compareChars
		tst.b	d3
		beq.s	DetermineWhichGame
		dbf	d4,Test_SystemString

		moveq	#-1,d1
		move.l	(SegaHeadersText).l,d0		; test to see if SEGA is at the locked on ROM's $100
		cmp.l	(LockonHeader).l,d0
		bne.w	SonicAndKnucklesStartup

DetermineWhichGame:
		lea	(LockonSerialsText).l,a1
		moveq	#3,d1	; 3 Sonic 2 headers, 1 Sonic 3 header

$$compareSerials:
		lea	(LockonSerialNumber).l,a0
		moveq	#0,d3
		moveq	#$D,d2

$$compareChars:
		move.b	(a1)+,d0
		cmp.b	(a0)+,d0
		beq.s	$$matchingChar
		moveq	#1,d3

$$matchingChar:
		dbf	d2,$$compareChars
		tst.b	d3
		beq.s	S2orS3LockedOn
		dbf	d1,$$compareSerials
		bra.s	BlueSpheresStartup
; ---------------------------------------------------------------------------

S2orS3LockedOn:
		tst.w	d1
		beq.w	SonicAndKnucklesStartup
		move.b	#1,($A130F1).l
		jmp	($300000).l				; May be changed at a later date to become compatible with S2K disassembly
; ---------------------------------------------------------------------------
LockonSerialsText:
		dc.b "GM 00001051-00"   ; Sonic 2 REV00/1/2
		dc.b "GM 00001051-01"
		dc.b "GM 00001051-02"
		dc.b "GM MK-1079 -00"	; Sonic 3

SegaHeadersText:
		dc.b "SEGA MEGA DRIVE "
		dc.b "SEGA GENESIS    "
; ---------------------------------------------------------------------------

BlueSpheresStartup:
		bsr.s	Test_Checksum
		move.b	d4,($FFFFFF9F).w
		bsr.w	Init_VDP
		bsr.w	SndDrvInit
		bsr.w	Init_Controllers
		move.b	#0,($FFFFFFA1).w
		move.b	#$2C,($FFFFF600).w
		bra.w	GameLoop
	endif

; ---------------------------------------------------------------------------
; Checksum testing subroutine
; The instructions to loop over the entire ROM and branch to the incorrect
; checksum routine have been NOPed out, so this is quite useless
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Test_Checksum:
		btst	#6,($A1000D).l
		beq.s	+
		cmpi.l	#'SM&K',($FFFFFFFC).w
		beq.w	Test_Checksum_Done
+
		movea.l	#ErrorTrap,a6
		move.l	(ROMEndLoc).w,d6
		moveq	#0,d7
		add.w	(a6)+,d7
		cmp.l	a6,d6
		nop
		nop
		cmp.w	(Checksum).w,d7
		nop
		nop
		lea	($FFFFFE00).w,a6
		moveq	#0,d7
		move.w	#bytesToLcnt($1F0),d6

-		move.l	d7,(a6)+
		dbf	d6,-	; clear RAM from $FFFE00 to $FFFFEF
		move.b	($A10001).l,d6
		andi.b	#$C0,d6
		move.b	d6,($FFFFFFD8).w
		move.l	#'SM&K',($FFFFFFFC).w

Test_Checksum_Done:
		rts
; End of function Test_Checksum

; ---------------------------------------------------------------------------

SonicAndKnucklesStartup:
		bsr.s	Test_Checksum
		move.w	d1,($FFFFFFAE).w
		bsr.w	DetectPAL
		bsr.w	Init_VDP
		bsr.w	SndDrvInit
		bsr.w	Init_Controllers
		jsr	(SRAM_Load).l
		move.b	#0,($FFFFF600).w

GameLoop:
		move.b	($FFFFF600).w,d0
		andi.w	#$7C,d0
		movea.l	GameModes(pc,d0.w),a0
		jsr	(a0)
		bra.s	GameLoop
; ---------------------------------------------------------------------------
GameModes:	dc.l Sega_Screen		;   0
		dc.l Title_Screen		;   4
		dc.l Level			;   8
		dc.l Level			;  $C
		dc.l JumpToSegaScreen		; $10
		dc.l ContinueScreen		; $14
		dc.l JumpToSegaScreen		; $18
		dc.l LevelSelect_S2Options	; $1C
		dc.l S3Credits			; $20
		dc.l LevelSelect_S2Options	; $24
		dc.l LevelSelect_S2Options	; $28
		dc.l BlueSpheresTitle		; $2C
		dc.l BlueSpheresResults		; $30
		dc.l SpecialStage		; $34
		dc.l Competition_Menu		; $38
		dc.l Competition_PlayerSelect	; $3C
		dc.l Competition_LevelSelect	; $40
		dc.l Competition_Results	; $44
		dc.l SpecialStage_Results	; $48
		dc.l SaveScreen			; $4C
		dc.l TimeAttack_Records		; $50
; ---------------------------------------------------------------------------

JumpToSegaScreen:
		move.b	#0,($FFFFF600).w
		rts
; ---------------------------------------------------------------------------

; unused/dead code
; weird routine, makes the screen go haywire pretty much
; ChecksumError2:
		move.l	d1,-(sp)
		bsr.w	Init_VDP
		move.l	(sp)+,d1

ChecksumError2_Loop:
		move.l	#vdpComm($0000,CRAM,WRITE),($C00004).l
		move.w	d7,($C00000).l
		addq.w	#1,d7
		bra.s	ChecksumError2_Loop
; ---------------------------------------------------------------------------

; unused/dead code
; ChecksumError:
		move.l	#vdpComm($0000,CRAM,WRITE),($C00004).l
		moveq	#$3F,d7

-		move.w	#$E,($C00000).l
		dbf	d7,-	; fill entire CRAM with red

ChecksumError_Loop:
		bra.s	ChecksumError_Loop

; =============== S U B R O U T I N E =======================================


DetectPAL:
		lea	($C00004).l,a5
		move.w	#$8174,(a5)		; VDP Command $8174 - Display on, VInt on, DMA on, PAL off
		moveq	#0,d0

$$waitForVBlankStart:
		move.w	(a5),d1
		andi.w	#8,d1
		beq.s	$$waitForVBlankStart

$$waitForVBlankEnd:
		move.w	(a5),d1
		andi.w	#8,d1
		bne.s	$$waitForVBlankEnd	; Wait for VBlank to run once

$$waitForNextVBlank:
		addq.w	#1,d0
		move.w	(a5),d1
		andi.w	#8,d1
		beq.s	$$waitForNextVBlank
		move.w	d0,($FFFFFFD6).w	; Count cycles between VBlanks (likely to detect PAL systems and/or for other timing mechanisms
		rts
; End of function DetectPAL

; ---------------------------------------------------------------------------
; Vertical interrupt handler
; ---------------------------------------------------------------------------

VInt:
		nop
		movem.l	d0-a6,-(sp)
		tst.b	($FFFFF62A).w
		beq.w	VInt_0_Main

-		move.w	($C00004).l,d0
		andi.w	#8,d0
		beq.s	-	; wait until vertical blanking is taking place

		move.l	#vdpComm($0000,VSRAM,WRITE),($C00004).l
		move.l	($FFFFF616).w,($C00000).l
		btst	#6,($FFFFFFD8).w
		beq.s	+	; branch if it's not a PAL system
		move.w	#$700,d0
-		dbf	d0,-	; otherwise, waste a bit of time here

+
		move.b	($FFFFF62A).w,d0
		move.b	#0,($FFFFF62A).w
		move.w	#1,($FFFFF644).w		; Allow H Interrupt code to run
		andi.w	#$3E,d0
		move.w	VInt_Table(pc,d0.w),d0
		jsr	VInt_Table(pc,d0.w)

VInt_Done:
		addq.l	#1,($FFFFFE0C).w
		movem.l	(sp)+,d0-a6
		rte
; ---------------------------------------------------------------------------
VInt_Table:	dc.w VInt_0-VInt_Table
		dc.w VInt_2-VInt_Table
		dc.w VInt_4-VInt_Table
		dc.w VInt_6-VInt_Table
		dc.w VInt_8-VInt_Table
		dc.w VInt_A_C-VInt_Table
		dc.w VInt_A_C-VInt_Table
		dc.w VInt_E-VInt_Table
		dc.w VInt_10-VInt_Table
		dc.w VInt_12-VInt_Table
		dc.w VInt_14-VInt_Table
		dc.w VInt_16-VInt_Table
		dc.w VInt_18-VInt_Table
		dc.w VInt_1A-VInt_Table
		dc.w VInt_1C-VInt_Table
		dc.w VInt_1E-VInt_Table
; ---------------------------------------------------------------------------

VInt_0:
		addq.w	#4,sp

VInt_0_Main:
		addq.w	#1,($FFFFF628).w

		; branch if a level or demo is running
		cmpi.b	#$88,($FFFFF600).w
		beq.s	VInt_0_Level
		cmpi.b	#$8C,($FFFFF600).w
		beq.s	VInt_0_Level
		cmpi.b	#8,($FFFFF600).w
		beq.s	VInt_0_Level
		cmpi.b	#$C,($FFFFF600).w
		beq.s	VInt_0_Level

		bra.s	VInt_Done	; otherwise, return from V-int
; ---------------------------------------------------------------------------

VInt_0_Level:
		tst.b	($FFFFF730).w
		beq.w	VInt_0_NoWater
		move.w	($C00004).l,d0
		btst	#6,($FFFFFFD8).w
		beq.s	+	; branch if it isn't a PAL system
		move.w	#$700,d0
-		dbf	d0,-	; otherwise waste a bit of time here

+
		move.w	#1,($FFFFF644).w
		stopZ80
		tst.b	($FFFFF64E).w
		bne.s	VInt_0_FullyUnderwater
		dma68kToVDP $FFFFFC00,$0000,$80,CRAM
		bra.s	VInt_0_Water_Cont
; ---------------------------------------------------------------------------

VInt_0_FullyUnderwater:
		dma68kToVDP $FFFFF080,$0000,$80,CRAM

VInt_0_Water_Cont:
		move.w	($FFFFF624).w,(a5)
		startZ80
		bra.w	VInt_Done
; ---------------------------------------------------------------------------

VInt_0_NoWater:
		move.w	($C00004).l,d0
		btst	#6,($FFFFFFD8).w
		beq.s	+	; branch if it isn't a PAL system
		move.w	#$700,d0
-		dbf	d0,-	; otherwise, waste a bit of time here

+
		move.w	#1,($FFFFF644).w
		move.w	($FFFFF624).w,($C00004).l
		stopZ80

		tst.w	($FFFFFFE8).w
		beq.s	VInt_0_Done
		move.l	#vdpComm($0000,VSRAM,WRITE),($C00004).l
		move.l	($FFFFF616).w,($C00000).l
		tst.w	($FFFFEF3C).w
		beq.s	+
		dma68kToVDP $FFFFF800,$F800,$280,VRAM
		bra.s	VInt_0_Done
+
		dma68kToVDP $FF7880,$F800,$280,VRAM

VInt_0_Done:
		startZ80
		bra.w	VInt_Done
; ---------------------------------------------------------------------------

VInt_2:
		bsr.w	Do_ControllerPal
		tst.w	($FFFFF614).w
		beq.w	+
		subq.w	#1,($FFFFF614).w
+
		rts
; ---------------------------------------------------------------------------

VInt_14:
		move.b	($FFFFFE0F).w,d0
		andi.w	#$F,d0
		bne.s	+	; run the following code once every 16 frames

		stopZ80
		bsr.w	Poll_Controllers
		startZ80
+
		tst.w	($FFFFF614).w
		beq.w	+
		subq.w	#1,($FFFFF614).w
+
		jmp	(Set_Kos_Bookmark).l
; ---------------------------------------------------------------------------

VInt_4:
		bsr.w	TitleAnim_FlipBuffer
		bsr.w	Do_ControllerPal
		move.w	($FFFFF604).w,($FFFFF748).w
		bsr.w	Process_Nem_Queue
		tst.w	($FFFFF614).w
		beq.w	+
		subq.w	#1,($FFFFF614).w
+
		rts
; ---------------------------------------------------------------------------

VInt_6:
		bsr.w	Do_ControllerPal
		rts
; ---------------------------------------------------------------------------

VInt_10:
		cmpi.b	#$34,($FFFFF600).w
		beq.w	VInt_1C		; If in a special stage, branch

VInt_8:
		stopZ80
		bsr.w	Poll_Controllers
		tst.b	($FFFFF666).w
		beq.s	VInt_8_NoFlash

		; flash screen white when Hyper Sonic's double jump move is used
		subq.b	#1,($FFFFF666).w
		lea	($C00000).l,a6
		move.l	#vdpComm($0000,CRAM,WRITE),($C00004).l
		move.w	#$EEE,d0
		move.w	#$1F,d1

-		move.w	d0,(a6)
		dbf	d1,-	; fill entire first and second palette lines with white
		move.w	#0,(a6)	; keep backdrop black
		move.w	#$1E,d1

-		move.w	d0,(a6)
		dbf	d1,-	; fill remaining colours with white
		bra.s	VInt_8_Cont
; ---------------------------------------------------------------------------

VInt_8_NoFlash:
		tst.b	($FFFFF64E).w
		bne.s	+
		dma68kToVDP $FFFFFC00,$0000,$80,CRAM
		bra.s	++
+
		dma68kToVDP $FFFFF080,$0000,$80,CRAM
+
		move.w	($FFFFF624).w,(a5)

VInt_8_Cont:
		dma68kToVDP $FFFFE000,$F000,$380,VRAM
		tst.w	($FFFFFFE8).w
		beq.s	++
		tst.w	($FFFFEF3E).w
		beq.s	+
		clr.w	($FFFFEF3E).w
		eori.w	#$FFFF,($FFFFEF3C).w	; a not.w would've accomplished the same thing ...
+
		tst.w	($FFFFEF3C).w
		bne.s	+
		dma68kToVDP $FF7880,$F800,$280,VRAM
		bra.s	++
+
		dma68kToVDP $FFFFF800,$F800,$280,VRAM
+
		bsr.w	Process_DMA_Queue
		move.l	($FFFFF61E).w,($FFFFEE3A).w
		jsr	(SpecialVInt_Function).l
		jsr	(VInt_DrawLevel).l
		startZ80
		move	#$2300,sr
		tst.b	($FFFFF730).w
		beq.s	+
		cmpi.b	#92,($FFFFF625).w	; is H-int occuring on or below line 92?
		bcc.s	+	; if it is, branch
		move.b	#1,($FFFFF64F).w
		jmp	(Set_Kos_Bookmark).l
+
		bsr.s	Do_Updates
		jmp	(Set_Kos_Bookmark).l

; =============== S U B R O U T I N E =======================================


Do_Updates:
		jsr	(UpdateHUD).l
		move.w	#0,($FFFFF628).w
		bsr.w	Process_Nem_Queue_2
		tst.w	($FFFFF614).w
		beq.w	+
		subq.w	#1,($FFFFF614).w
+
		rts
; End of function Do_Updates

; ---------------------------------------------------------------------------

VInt_A_C:
		stopZ80
		bsr.w	Poll_Controllers
		tst.b	($FFFFF64E).w
		bne.s	+
		dma68kToVDP $FFFFFC00,$0000,$80,CRAM
		bra.s	++
+
		dma68kToVDP $FFFFF080,$0000,$80,CRAM
+
		move.w	($FFFFF624).w,(a5)
		dma68kToVDP $FFFFE000,$F000,$380,VRAM
		tst.w	($FFFFFFE8).w
		beq.s	++
		tst.w	($FFFFEF3E).w
		beq.s	+
		clr.w	($FFFFEF3E).w
		eori.w	#$FFFF,($FFFFEF3C).w
+
		tst.w	($FFFFEF3C).w
		bne.s	+
		dma68kToVDP $FF7880,$F800,$280,VRAM
		bra.s	++
+
		dma68kToVDP $FFFFF800,$F800,$280,VRAM
+
		bsr.w	Process_DMA_Queue
		move.l	($FFFFF61E).w,($FFFFEE3A).w
		startZ80
		bsr.w	Process_Nem_Queue
		jmp	(Set_Kos_Bookmark).l
; ---------------------------------------------------------------------------

VInt_E:
		bsr.w	Do_ControllerPal
		move.b	#$E,($FFFFF62A).w
		rts
; ---------------------------------------------------------------------------

VInt_12:
		bsr.w	Do_ControllerPal
		move.w	($FFFFF624).w,(a5)
		bra.w	Process_Nem_Queue
; ---------------------------------------------------------------------------

VInt_18:
		stopZ80
		bsr.w	Poll_Controllers

		dma68kToVDP $FFFFFC00,$0000,$80,CRAM
		dma68kToVDP $FFFFF800,$F800,$280,VRAM
		dma68kToVDP $FFFFE000,$F000,$380,VRAM

		bclr	#0,($FFFFFA88).w
		beq.s	+
		dma68kToVDP $FF2000,$C000,$2000,VRAM
+
		bsr.w	Process_DMA_Queue
		startZ80
		rts
; ---------------------------------------------------------------------------

VInt_16:
		stopZ80
		bsr.w	Poll_Controllers

		dma68kToVDP $FFFFFC00,$0000,$80,CRAM
		dma68kToVDP $FFFFF800,$F800,$280,VRAM
		dma68kToVDP $FFFFE000,$F000,$380,VRAM

		bsr.w	Process_DMA_Queue
		startZ80
		bsr.w	Process_Nem_Queue
		tst.w	($FFFFF614).w
		beq.w	+
		subq.w	#1,($FFFFF614).w
+
		jmp	(Set_Kos_Bookmark).l
; ---------------------------------------------------------------------------

VInt_1A:
		bsr.w	Do_ControllerPal
		move.w	($FFFFF604).w,($FFFFF748).w
		bsr.w	Process_Nem_Queue
		tst.w	($FFFFF614).w
		beq.w	+
		subq.w	#1,($FFFFF614).w
+
		jmp	(Set_Kos_Bookmark).l
; ---------------------------------------------------------------------------

VInt_1C:
		bsr.w	Rotate_SSPal
		bsr.w	Do_ControllerPal
		bsr.w	Update_SSMap
		tst.w	($FFFFF614).w
		beq.w	+
		subq.w	#1,($FFFFF614).w
+
		jmp	(Set_Kos_Bookmark).l
; ---------------------------------------------------------------------------

VInt_1E:
		bsr.s	Do_ControllerPal
		movea.l	($FFFFEF44).w,a0
		jsr	(a0)
		bsr.w	Process_Nem_Queue_2
		jmp	(Set_Kos_Bookmark).l

; =============== S U B R O U T I N E =======================================


Do_ControllerPal:
		stopZ80
		bsr.w	Poll_Controllers
		tst.b	($FFFFF64E).w
		bne.s	+
		dma68kToVDP $FFFFFC00,$0000,$80,CRAM
		bra.s	++
+
		dma68kToVDP $FFFFF080,$0000,$80,CRAM
+
		dma68kToVDP $FFFFF800,$F800,$280,VRAM
		dma68kToVDP $FFFFE000,$F000,$380,VRAM
		bsr.w	Process_DMA_Queue
		startZ80
		rts
; End of function Do_ControllerPal

; ---------------------------------------------------------------------------
		jmp	($FFFFFFF6).w

; ---------------------------------------------------------------------------
; Horizontal interrupt handler for Competition Mode
; ---------------------------------------------------------------------------

HInt:
		tst.w	($FFFFF644).w
		beq.w	HInt_Done
		move.w	#0,($FFFFF644).w
		move.l	a5,-(sp)
		move.l	d0,-(sp)

-		move.w	($C00004).l,d0
		andi.w	#4,d0	; is horizontal blanking occuring?
		beq.s	-	; if not, wait until it is

		move.w	($FFFFF60E).w,d0
		andi.b	#$BF,d0
		move.w	d0,($C00004).l	; blank the display
		move.l	#vdpComm($0000,VSRAM,WRITE),($C00004).l
		move.l	($FFFFEE3A).w,($C00000).l
		stopZ80
		tst.w	($FFFFEF3C).w
		beq.s	+
		dma68kToVDP $FF7B00,$F800,$280,VRAM
		bra.s	++
+
		dma68kToVDP $FF7D80,$F800,$280,VRAM
+
		startZ80

-		move.w	($C00004).l,d0
		andi.w	#4,d0	; is a horizontal blank occuring?
		beq.s	-	; if not, wait
		move.w	($FFFFF60E).w,d0
		ori.b	#$40,d0
		move.w	d0,($C00004).l	; enable display
		move.l	(sp)+,d0
		movea.l	(sp)+,a5

HInt_Done:
		rte

; ---------------------------------------------------------------------------
; Used for water levels apart from Hydrocity, for uneven water surfaces
; ---------------------------------------------------------------------------

HInt3:
		tst.w	($FFFFF644).w
		beq.s	HInt3_Done
		move.w	#0,($FFFFF644).w
		movem.l	d0-d1/a0-a2,-(sp)

		lea	($C00000).l,a1
		move.w	#$8AFF,4(a1)		; Reset HInt timing
		stopZ80
		movea.l	($FFFFF62E).w,a2
		moveq	#$C,d0
-		dbf	d0,-	; waste a few cycles here

		move.w	(a2)+,d1
		move.b	($FFFFF625).w,d0
		subi.b	#200,d0	; is H-int occuring below line 200?
		bcs.s	$$transferColors	; if it is, branch
		sub.b	d0,d1
		bcs.s	$$skipTransfer

$$transferColors:
		move.w	(a2)+,d0
		lea	($FFFFF080).w,a0
		adda.w	d0,a0
		addi.w	#$C000,d0
		swap	d0
		move.l	d0,4(a1)	; write to CRAM at appropriate address
		move.l	(a0)+,(a1)	; transfer two colors
		move.w	(a0)+,(a1)	; transfer the third color
		nop
		nop
		moveq	#$24,d0

$$wasteSomeCycles:
		dbf	d0,$$wasteSomeCycles
		dbf	d1,$$transferColors	; repeat for number of colors

$$skipTransfer:
		startZ80
		movem.l	(sp)+,d0-d1/a0-a2
		tst.b	($FFFFF64F).w
		bne.s	HInt3_Do_Updates

HInt3_Done:
		rte
; ---------------------------------------------------------------------------

HInt3_Do_Updates:
		clr.b	($FFFFF64F).w
		movem.l	d0-a6,-(sp)
		jsr	(Do_Updates).l
		movem.l	(sp)+,d0-a6
		rte

; ---------------------------------------------------------------------------
; Identical to HInt3 except it transfers colors from the above water palette
; Seems to be unused
; ---------------------------------------------------------------------------

HInt5:
		tst.w	($FFFFF644).w		; Seems to be a compliment to HInt 3, but doesn't seem to be usedj
		beq.s	HInt5_Done
		move.w	#0,($FFFFF644).w
		movem.l	d0-d1/a0-a2,-(sp)

		lea	($C00000).l,a1
		move.w	#$8AFF,4(a1)
		stopZ80
		movea.l	($FFFFF62E).w,a2
		moveq	#$C,d0
-		dbf	d0,-

		move.w	(a2)+,d1
		move.b	($FFFFF625).w,d0
		subi.b	#200,d0
		bcs.s	$$transferColors
		sub.b	d0,d1
		bcs.s	$$skipTransfer

$$transferColors:
		move.w	(a2)+,d0
		lea	($FFFFFC00).w,a0
		adda.w	d0,a0
		addi.w	#$C000,d0
		swap	d0
		move.l	d0,4(a1)
		move.l	(a0)+,(a1)
		move.w	(a0)+,(a1)
		nop
		nop
		moveq	#$24,d0

$$wasteSomeCycles:
		dbf	d0,$$wasteSomeCycles
		dbf	d1,$$transferColors

$$skipTransfer:
		startZ80
		movem.l	(sp)+,d0-d1/a0-a2
		tst.b	($FFFFF64F).w
		bne.s	HInt5_Do_Updates

HInt5_Done:
		rte
; ---------------------------------------------------------------------------

HInt5_Do_Updates:
		clr.b	($FFFFF64F).w
		movem.l	d0-a6,-(sp)
		jsr	(Do_Updates).l
		movem.l	(sp)+,d0-a6
		rte

; ---------------------------------------------------------------------------
; Identical to HInt3, except for faster systems
; ---------------------------------------------------------------------------

HInt4:
		tst.w	($FFFFF644).w
		beq.s	Hint4_Done
		move.w	#0,($FFFFF644).w
		movem.l	d0-d1/a0-a2,-(sp)

		lea	($C00000).l,a1
		move.w	#$8AFF,4(a1)
		stopZ80
		movea.l	($FFFFF62E).w,a2
		moveq	#$1B,d0
-		dbf	d0,-

		move.w	(a2)+,d1
		move.b	($FFFFF625).w,d0
		subi.b	#200,d0
		bcs.s	$$transferColors
		sub.b	d0,d1
		bcs.s	$$skipTransfer

$$transferColors:
		move.w	(a2)+,d0
		lea	($FFFFF080).w,a0
		adda.w	d0,a0
		addi.w	#$C000,d0
		swap	d0
		move.l	d0,4(a1)
		move.l	(a0)+,(a1)
		move.w	(a0)+,(a1)
		nop
		moveq	#$33,d0

$$wasteSomeCycles:
		dbf	d0,$$wasteSomeCycles
		dbf	d1,$$transferColors

$$skipTransfer:
		startZ80
		movem.l	(sp)+,d0-d1/a0-a2
		tst.b	($FFFFF64F).w
		bne.s	HInt4_Do_Updates

Hint4_Done:
		rte
; ---------------------------------------------------------------------------

HInt4_Do_Updates:
		clr.b	($FFFFF64F).w
		movem.l	d0-a6,-(sp)
		jsr	(Do_Updates).l
		movem.l	(sp)+,d0-a6
		rte

; ---------------------------------------------------------------------------
; Identical to HInt5, except for faster systems
; ---------------------------------------------------------------------------

HInt_6:
		tst.w	($FFFFF644).w
		beq.s	HInt6_Done
		move.w	#0,($FFFFF644).w
		movem.l	d0-d1/a0-a2,-(sp)

		lea	($C00000).l,a1
		move.w	#$8AFF,4(a1)
		stopZ80
		movea.l	($FFFFF62E).w,a2
		moveq	#$1B,d0
-		dbf	d0,-

		move.w	(a2)+,d1
		move.b	($FFFFF625).w,d0
		subi.b	#200,d0
		bcs.s	$$transferColors
		sub.b	d0,d1
		bcs.s	$$skipTransfer

$$transferColors:
		move.w	(a2)+,d0
		lea	($FFFFFC00).w,a0
		adda.w	d0,a0
		addi.w	#$C000,d0
		swap	d0
		move.l	d0,4(a1)
		move.l	(a0)+,(a1)
		move.w	(a0)+,(a1)
		nop
		moveq	#$33,d0

$$wasteSomeCycles:
		dbf	d0,$$wasteSomeCycles
		dbf	d1,$$transferColors

$$skipTransfer:
		startZ80
		movem.l	(sp)+,d0-d1/a0-a2
		tst.b	($FFFFF64F).w
		bne.s	HInt6_Do_Updates

HInt6_Done:
		rte
; ---------------------------------------------------------------------------

HInt6_Do_Updates:
		clr.b	($FFFFF64F).w
		movem.l	d0-a6,-(sp)
		jsr	(Do_Updates).l
		movem.l	(sp)+,d0-a6
		rte

; ---------------------------------------------------------------------------
; Copies the entire water palette to CRAM, used only in Hydrocity
; ---------------------------------------------------------------------------

HInt2:
		move	#$2700,sr
		tst.w	($FFFFF644).w
		beq.s	HInt2_Done
		move.w	#0,($FFFFF644).w
		movem.l	a0-a1,-(sp)

		lea	($C00000).l,a1
		move.w	#$8ADF,4(a1)
		lea	($FFFFF080).w,a0
		move.l	#vdpComm($0000,CRAM,WRITE),4(a1)
	rept 32
		move.l	(a0)+,(a1)
	endm
		movem.l	(sp)+,a0-a1
		tst.b	($FFFFF64F).w
		bne.s	HInt2_Do_Updates

HInt2_Done:
		rte
; ---------------------------------------------------------------------------

HInt2_Do_Updates:
		clr.b	($FFFFF64F).w
		movem.l	d0-a6,-(sp)
		bsr.w	Do_Updates
		movem.l	(sp)+,d0-a6
		rte

; =============== S U B R O U T I N E =======================================


Init_Controllers:
		stopZ80
		moveq	#$40,d0
		move.b	d0,($A10009).l
		move.b	d0,($A1000B).l
		move.b	d0,($A1000D).l
		startZ80
		rts
; End of function Init_Controllers


; =============== S U B R O U T I N E =======================================


Poll_Controllers:
		lea	($FFFFF604).w,a0
		lea	($A10003).l,a1
		bsr.s	Poll_Controller	; poll first controller
		addq.w	#2,a1	; poll second controller
; End of function Poll_Controllers


; =============== S U B R O U T I N E =======================================


Poll_Controller:
		move.b	#0,(a1)			; Poll controller data port
		nop
		nop
		move.b	(a1),d0			; Get controller port data (start/A)
		lsl.b	#2,d0
		andi.b	#$C0,d0
		move.b	#$40,(a1)		; Poll controller data port again
		nop
		nop
		move.b	(a1),d1			; Get controller port data (B/C/Dpad)
		andi.b	#$3F,d1
		or.b	d1,d0			; Fuse together into one controller bit array
		not.b	d0
		move.b	(a0),d1			; Get press button data
		eor.b	d0,d1			; Toggle off buttons that are being held
		move.b	d0,(a0)+		; Put raw controller input (for held buttons) in F604/F606
		and.b	d0,d1
		move.b	d1,(a0)+		; Put pressed controller input in F605/F607
		rts
; End of function Poll_Controller


; =============== S U B R O U T I N E =======================================


Init_VDP:
		lea	($C00004).l,a0
		lea	($C00000).l,a1
		lea	(VDP_register_values).l,a2
		moveq	#18,d7

$$setRegisters:
		move.w	(a2)+,(a0)
		dbf	d7,$$setRegisters
		move.w	(VDP_register_values+2).l,d0	; get command for register #1
		move.w	d0,($FFFFF60E).w	; and store it in RAM (for easy display blanking/enabling)
		move.w	#$8ADF,($FFFFF624).w
		moveq	#0,d0
		move.l	#vdpComm($0000,VSRAM,WRITE),($C00004).l
		move.w	d0,(a1)
		move.w	d0,(a1)
		move.l	#vdpComm($0000,CRAM,WRITE),($C00004).l
		move.w	#$3F,d7

$$clearCRAM:
		move.w	d0,(a1)
		dbf	d7,$$clearCRAM
		clr.l	($FFFFF616).w
		clr.l	($FFFFF61A).w
		move.l	d1,-(sp)
		dmaFillVRAM 0,$0000,$10000	; clear entire VRAM
		move.l	(sp)+,d1
		rts
; End of function Init_VDP

; ---------------------------------------------------------------------------
VDP_register_values:
		dc.w $8004 ; H-int disabled
		dc.w $8134 ; V-int enabled, display blanked, DMA enabled, 224 line display
		dc.w $8230 ; Scroll A PNT base $C000
		dc.w $8320 ; Window PNT base $8000
		dc.w $8407 ; Scroll B PNT base $E000
		dc.w $857C ; Sprite attribute table base $F800
		dc.w $8600
		dc.w $8700 ; Backdrop color is color 0 of the first palette line
		dc.w $8800
		dc.w $8900
		dc.w $8A00
		dc.w $8B00 ; Full-screen horizontal and vertical scrolling
		dc.w $8C81 ; 40 cell wide display, no interlace
		dc.w $8D3C ; Horizontal scroll table base $F000
		dc.w $8E00
		dc.w $8F02 ; Auto-ncrement is 2
		dc.w $9001 ; Scroll planes are 64x32 cells
		dc.w $9100
		dc.w $9200 ; Window disabled

; =============== S U B R O U T I N E =======================================


Clear_DisplayData:
		stopZ80
		dmaFillVRAM 0,$0000,$40

		tst.w	($FFFFFFE8).w
		beq.s	Clear_DisplayData_No2P
		dmaFillVRAM 0,$8000,$4000
		bra.s	Clear_DisplayData_Cont
; ---------------------------------------------------------------------------

Clear_DisplayData_No2P:
		dmaFillVRAM 0,$C000,$1000	; clear plane A PNT
		dmaFillVRAM 0,$E000,$1000	; clear plane B PNT

Clear_DisplayData_Cont:
		clr.l	($FFFFF616).w
		clr.l	($FFFFF61A).w
		clearRAM $FFFFF800,$284
		clearRAM $FFFFE000,$404

		startZ80
		rts
; End of function Clear_DisplayData


; =============== S U B R O U T I N E =======================================


SndDrvInit:
		nop
		move.w	#$100,($A11100).l
		move.w	#$100,($A11200).l	; release Z80 reset
		lea	(Z80_Snd_Driver).l,a0
		lea	($A00000).l,a1
		bsr.w	Kos_Decomp
	if Sonic3_Complete=0
		lea	(Z80_Snd_Driver2).l,a0
	endif
		lea	($A01300).l,a1
		bsr.w	Kos_Decomp
		
		lea	(Z80_Blank_Dat).l,a0
		lea	($A01C00).l,a1
		move.w	#$F,d0

-		move.b	(a0)+,(a1)+
		dbf	d0,-
		btst	#6,($FFFFFFD8).w
		beq.s	+
		move.b	#1,($A01C02).l	; set PAL mode flag
+
		move.w	#0,($A11200).l	; reset Z80
		nop
		nop
		nop
		nop
		move.w	#$100,($A11200).l	; release reset
		startZ80
		rts
; End of function SndDrvInit

; ---------------------------------------------------------------------------
Z80_Blank_Dat:	dc.b  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

; ---------------------------------------------------------------------------
; Always replaces an index previous passed to this function
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Play_Sound:
		stopZ80
		move.b	d0,($A01C0A).l
		startZ80
		rts
; End of function Play_Sound

; ---------------------------------------------------------------------------
; plays a sound if the source object is on-screen
; unused/dead code, left over from Sonic 2
; Play_Sound_Local:
		tst.b	4(a0)
		bpl.s	Play_Sound_2_Done

; ---------------------------------------------------------------------------
; Can handle up to two different indexes in one frame
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Play_Sound_2:
		stopZ80
		cmp.b	($A01C0B).l,d0
		beq.s	++
		tst.b	($A01C0B).l
		bne.s	+
		move.b	d0,($A01C0B).l
		startZ80
		rts
+
		move.b	d0,($A01C0C).l
+
		startZ80

Play_Sound_2_Done:
		rts
; End of function Play_Sound_2


; =============== S U B R O U T I N E =======================================


Change_Music_Tempo:
		stopZ80
		move.b	d0,($A01C08).l
		startZ80
		rts
; End of function Change_Music_Tempo


; =============== S U B R O U T I N E =======================================


Pause_Game:
		nop
		tst.w	($FFFFEF72).w
		beq.s	Pause_Main
		rts
; ---------------------------------------------------------------------------

Pause_Main:
		tst.b	($FFFFFE12).w
		beq.w	Pause_Unpause
		tst.w	($FFFFF63A).w
		bne.s	+
		move.b	($FFFFF605).w,d0
		andi.b	#$80,d0	; is Start pressed?
		beq.w	Pause_NoPause	; if not, branch
+
		move.w	#1,($FFFFF63A).w
		stopZ80
		move.b	#1,($A01C10).l	; Pause the music
		startZ80

Pause_Loop:
		move.b	#$10,($FFFFF62A).w
		bsr.w	Wait_VSync
		tst.b	($FFFFFFE1).w
		beq.s	Pause_NoSlowMo
		btst	#6,($FFFFF605).w
		beq.s	Pause_ChkFrameAdvance	; branch if A isn't pressed
		move.b	#4,($FFFFF600).w
		nop
		bra.s	Pause_ResumeMusic
; ---------------------------------------------------------------------------

Pause_ChkFrameAdvance:
		btst	#4,($FFFFF604).w
		bne.s	Pause_FrameAdvance	; branch if B is held
		btst	#5,($FFFFF605).w
		bne.s	Pause_FrameAdvance	; branch if C is pressed

Pause_NoSlowMo:
		cmpi.b	#$E,($FFFFFE10).w
		bcs.s	Pause_ChkStart	; if the zone is below ALZ
		cmpi.b	#$12,($FFFFFE10).w
		bhi.s	Pause_ChkStart	; if the zone is above EMZ
		tst.b	($FFFFFF8B).w
		bpl.s	Pause_ChkStart
		btst	#4,($FFFFF605).w
		beq.s	Pause_ChkStart
		move.b	#$C0,($FFFFF600).w	; If in time attack mode, go back to 2P menu if B is pressed
		bra.s	Pause_ResumeMusic
; ---------------------------------------------------------------------------

Pause_ChkStart:
		move.b	($FFFFF605).w,d0
		andi.b	#$80,d0
		beq.s	Pause_Loop

Pause_ResumeMusic:
		stopZ80
		move.b	#$80,($A01C10).l	; Unpause music
		startZ80

Pause_Unpause:
		move.w	#0,($FFFFF63A).w

Pause_NoPause:
		rts
; ---------------------------------------------------------------------------

Pause_FrameAdvance:
		move.w	#1,($FFFFF63A).w
		stopZ80
		move.b	#$80,($A01C10).l	; Unpause music
		startZ80
		rts	; advance by a single frame
; End of function Pause_Game

; ---------------------------------------------------------------------------
; Copies a plane map to a plane PNT
; Inputs:
; a1 = map address
; d0 = VDP command to write to the PNT
; d1 = number of cells in a row - 1
; d2 = number of cell rows - 1
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Plane_Map_To_VRAM:
		lea	($C00000).l,a6
		move.l	#$800000,d4	; row increment value

-		move.l	d0,4(a6)
		move.w	d1,d3

-		move.w	(a1)+,(a6)
		dbf	d3,-	; copy one row
		add.l	d4,d0	; move onto next row
		dbf	d2,--	; and copy it
		rts
; End of function Plane_Map_To_VRAM

; ---------------------------------------------------------------------------
; Copies a plane map to a plane PNT, used for a 128-cell wide plane
; Inputs:
; a1 = map address
; d0 = VDP command to write to the PNT
; d1 = number of cells in a row - 1
; d2 = number of cell rows - 1
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Plane_Map_To_VRAM_2:
		lea	($C00000).l,a6
		move.l	#$1000000,d4	; row increment value

-		move.l	d0,4(a6)
		move.w	d1,d3

-		move.w	(a1)+,(a6)
		dbf	d3,-	; copy one row
		add.l	d4,d0	; move onto next row
		dbf	d2,--	; and copy it
		rts
; End of function Plane_Map_To_VRAM_2

; ---------------------------------------------------------------------------
; Adds art to the DMA queue
; Inputs:
; d1 = source address
; d2 = destination VRAM address
; d3 = number of words to transfer
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Add_To_DMA_Queue:
	if Sonic3_Complete
		btst	#23,d1
		bne.s	Add_To_DMA_Queue_Do
		movem.l	d4-d5,-(sp)
		movem.l	d1-d3,-(sp)
		moveq	#0,d5
		move.l	d1,d4
		andi.l	#$FFFF,d3
		add.l	d3,d4
		add.l	d3,d4
		subq.l	#1,d4	; get address of last byte to be DMAed
		andi.l	#$FFFF8000,d1
		andi.l	#$FFFF8000,d4
		cmp.l	d1,d4	; has an $8000-byte boundary been crossed?
		bne.s	Add_To_DMA_Queue2	; if it has, branch
		movem.l	(sp)+,d1-d3
		movem.l	(sp)+,d4-d5
		bra.s	Add_To_DMA_Queue_Do	; otherwise, proceed normally

Add_To_DMA_Queue2:
		movem.l	(sp),d1-d3
		move.l	d4,d3
		sub.l	d1,d3
		move.w	d3,d5
		lsr.w	#1,d3	; get length of first DMA
		bsr.s	Add_To_DMA_Queue_Do
		movem.l	(sp)+,d1-d3
		move.l	d4,d1	; get source address for second DMA
		add.w	d5,d2	; get destination address for second DMA
		lsr.w	#1,d5
		sub.w	d5,d3	; get length of second DMA
		movem.l	(sp)+,d4-d5

Add_To_DMA_Queue_Do:
	endif

		movea.l	($FFFFFBFC).w,a1
		cmpa.w	#$FBFC,a1	; is the queue full?
		beq.s	Add_To_DMA_Queue_Done	; if it is, return

		move.w	#$9300,d0
		move.b	d3,d0
		move.w	d0,(a1)+	; command to specify transfer length in words & $00FF
		move.w	#$9400,d0
		lsr.w	#8,d3
		move.b	d3,d0
		move.w	d0,(a1)+	; command to specify transfer length in words & $FF00

		move.w	#$9500,d0
		lsr.l	#1,d1
		move.b	d1,d0
		move.w	d0,(a1)+	; command to specify transfer source & $0001FE
		move.w	#$9600,d0
		lsr.l	#8,d1
		move.b	d1,d0
		move.w	d0,(a1)+	; command to specify transfer source & $01FE00
		move.w	#$9700,d0
		lsr.l	#8,d1
		andi.b	#$7F,d1
		move.b	d1,d0
		move.w	d0,(a1)+	; command to specify transfer source & $FE0000

		andi.l	#$FFFF,d2
		lsl.l	#2,d2
		lsr.w	#2,d2
		swap	d2
		ori.l	#vdpComm($0000,VRAM,DMA),d2
		move.l	d2,(a1)+	; command to specify transfer destination and begin DMA

		move.l	a1,($FFFFFBFC).w	; set new free slot address
		cmpa.w	#$FBFC,a1	; has the end of the queue been reached?
		beq.s	Add_To_DMA_Queue_Done	; if it has, branch
		move.w	#0,(a1)	; place stop token at the end of the queue

Add_To_DMA_Queue_Done:
		rts
; End of function Add_To_DMA_Queue


; =============== S U B R O U T I N E =======================================


Process_DMA_Queue:
		lea	($C00004).l,a5
		lea	($FFFFFB00).w,a1

$$loop:
		move.w	(a1)+,d0	; has a stop token been encountered?
		beq.s	$$stop	; if it has, branch
		move.w	d0,(a5)
		move.w	(a1)+,(a5)
		move.w	(a1)+,(a5)
		move.w	(a1)+,(a5)
		move.w	(a1)+,(a5)
		move.w	(a1)+,(a5)
		move.w	(a1)+,(a5)
		cmpa.w	#$FBFC,a1	; has the end of the queue been reached?
		bne.s	$$loop	; if not, loop

$$stop:
		move.w	#0,($FFFFFB00).w
		move.l	#$FFFFFB00,($FFFFFBFC).w
		rts
; End of function Process_DMA_Queue

; ---------------------------------------------------------------------------
; Nemesis decompression subroutine, decompresses art directly to VRAM
; Inputs:
; a0 = art address
; a VDP command to write to the destination VRAM address must be issued
; before calling this routine
; See http://www.segaretro.org/Nemesis_compression for format description
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Nem_Decomp:
		movem.l	d0-a1/a3-a5,-(sp)
		lea	(Nem_PCD_WriteRowToVDP).l,a3
		lea	($C00000).l,a4	; write all rows to the VDP data port
		bra.s	Nem_Decomp_Main
; End of function Nem_Decomp

; ---------------------------------------------------------------------------
; Nemesis decompression subroutine, decompresses art to RAM
; Inputs:
; a0 = art address
; a4 = destination RAM address
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Nem_Decomp_To_RAM:
		movem.l	d0-a1/a3-a5,-(sp)
		lea	(Nem_PCD_WriteRowToRAM).l,a3
; End of function Nem_Decomp_To_RAM

; ---------------------------------------------------------------------------
; Main Nemesis decompression subroutine
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Nem_Decomp_Main:
		lea	($FFFFAA00).w,a1
		move.w	(a0)+,d2	; get number of patterns
		lsl.w	#1,d2
		bcc.s	+	; branch if the sign bit isn't set
		adda.w	#Nem_PCD_WriteRowToVDP_XOR-Nem_PCD_WriteRowToVDP,a3	; otherwise the file uses XOR mode
+
		lsl.w	#2,d2	; get number of 8-pixel rows in the uncompressed data
		movea.w	d2,a5	; and store it in a5 because there aren't any spare data registers
		moveq	#8,d3	; 8 pixels in a pattern row
		moveq	#0,d2
		moveq	#0,d4
		bsr.w	Nem_Build_Code_Table
		move.b	(a0)+,d5	; get first byte of compressed data
		asl.w	#8,d5	; shift up by a byte
		move.b	(a0)+,d5	; get second byte of compressed data
		move.w	#$10,d6	; set initial shift value
		bsr.s	Nem_Process_Compressed_Data
		movem.l	(sp)+,d0-a1/a3-a5
		rts
; End of function Nem_Decomp_Main

; ---------------------------------------------------------------------------
; Part of the Nemesis decompressor, processes the actual compressed data
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================

; PCD is used throughout this subroutine as an initialism for Process_Compressed_Data
Nem_Process_Compressed_Data:
		move.w	d6,d7
		subq.w	#8,d7	; get shift value
		move.w	d5,d1
		lsr.w	d7,d1	; shift so that high bit of the code is in bit position 7
		cmpi.b	#%11111100,d1	; are the high 6 bits set?
		bcc.s	Nem_PCD_InlineData	; if they are, it signifies inline data
		andi.w	#$FF,d1
		add.w	d1,d1
		move.b	(a1,d1.w),d0	; get the length of the code in bits
		ext.w	d0
		sub.w	d0,d6	; subtract from shift value so that the next code is read next time around
		cmpi.w	#9,d6	; does a new byte need to be read?
		bcc.s	+	; if not, branch
		addq.w	#8,d6
		asl.w	#8,d5
		move.b	(a0)+,d5	; read next byte
+
		move.b	1(a1,d1.w),d1
		move.w	d1,d0
		andi.w	#$F,d1	; get palette index for pixel
		andi.w	#$F0,d0

Nem_PCD_GetRepeatCount:
		lsr.w	#4,d0	; get repeat count

Nem_PCD_WritePixel:
		lsl.l	#4,d4	; shift up by a nybble
		or.b	d1,d4	; write pixel
		subq.w	#1,d3	; has an entire 8-pixel row been written?
		bne.s	Nem_PCD_WritePixel_Loop	; if not, loop
		jmp	(a3)	; otherwise, write the row to its destination
; ---------------------------------------------------------------------------

Nem_PCD_NewRow:
		moveq	#0,d4	; reset row
		moveq	#8,d3	; reset nybble counter

Nem_PCD_WritePixel_Loop:
		dbf	d0,Nem_PCD_WritePixel
		bra.s	Nem_Process_Compressed_Data
; ---------------------------------------------------------------------------

Nem_PCD_InlineData:
		subq.w	#6,d6	; 6 bits needed to signal inline data
		cmpi.w	#9,d6
		bcc.s	+
		addq.w	#8,d6
		asl.w	#8,d5
		move.b	(a0)+,d5
+
		subq.w	#7,d6	; and 7 bits needed for the inline data itself
		move.w	d5,d1
		lsr.w	d6,d1	; shift so that low bit of the code is in bit position 0
		move.w	d1,d0
		andi.w	#$F,d1	; get palette index for pixel
		andi.w	#$70,d0	; high nybble is repeat count for pixel
		cmpi.w	#9,d6
		bcc.s	Nem_PCD_GetRepeatCount
		addq.w	#8,d6
		asl.w	#8,d5
		move.b	(a0)+,d5
		bra.s	Nem_PCD_GetRepeatCount
; ---------------------------------------------------------------------------

Nem_PCD_WriteRowToVDP:
		move.l	d4,(a4)	; write 8-pixel row
		subq.w	#1,a5
		move.w	a5,d4	; have all the 8-pixel rows been written?
		bne.s	Nem_PCD_NewRow	; if not, branch
		rts	; otherwise the decompression is finished
; ---------------------------------------------------------------------------

Nem_PCD_WriteRowToVDP_XOR:
		eor.l	d4,d2	; XOR the previous row by the current row
		move.l	d2,(a4)	; and write the result
		subq.w	#1,a5
		move.w	a5,d4
		bne.s	Nem_PCD_NewRow
		rts
; ---------------------------------------------------------------------------

Nem_PCD_WriteRowToRAM:
		move.l	d4,(a4)+
		subq.w	#1,a5
		move.w	a5,d4
		bne.s	Nem_PCD_NewRow
		rts
; ---------------------------------------------------------------------------

Nem_PCD_WriteRowToRAM_XOR:
		eor.l	d4,d2
		move.l	d2,(a4)+
		subq.w	#1,a5
		move.w	a5,d4
		bne.s	Nem_PCD_NewRow
		rts
; End of function Nem_Process_Compressed_Data

; ---------------------------------------------------------------------------
; Part of the Nemesis decompressor, builds the code table (in RAM)
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================

; BCT is used throughout this subroutine as an initialism for Build_Code_Table
Nem_Build_Code_Table:
		move.b	(a0)+,d0	; read first byte

Nem_BCT_ChkEnd:
		cmpi.b	#$FF,d0	; has the end of the code table description been reached?
		bne.s	Nem_BCT_NewPalIndex	; if not, branch
		rts	; otherwise, this subroutine's work is done
; ---------------------------------------------------------------------------

Nem_BCT_NewPalIndex:
		move.w	d0,d7

Nem_BCT_Loop:
		move.b	(a0)+,d0	; read next byte
		cmpi.b	#$80,d0	; sign bit being set signifies a new palette index
		bcc.s	Nem_BCT_ChkEnd	; a bmi could have been used instead of a compare and bcc
		move.b	d0,d1
		andi.w	#$F,d7	; get palette index
		andi.w	#$70,d1	; get repeat count for palette index
		or.w	d1,d7	; combine the two
		andi.w	#$F,d0	; get the length of the code in bits
		move.b	d0,d1
		lsl.w	#8,d1
		or.w	d1,d7	; combine with palette index and repeat count to form code table entry
		moveq	#8,d1
		sub.w	d0,d1	; is the code 8 bits long?
		bne.s	Nem_BCT_ShortCode	; if not, a bit of extra processing is needed
		move.b	(a0)+,d0	; get code
		add.w	d0,d0	; each code gets a word-sized entry in the table
		move.w	d7,(a1,d0.w)	; store the entry for the code
		bra.s	Nem_BCT_Loop	; repeat
; ---------------------------------------------------------------------------

; the Nemesis decompressor uses prefix-free codes (no valid code is a prefix of a longer code)
; e.g. if 10 is a valid 2-bit code, 110 is a valid 3-bit code but 100 isn't
; also, when the actual compressed data is processed the high bit of each code is in bit position 7
; so the code needs to be bit-shifted appropriately over here before being used as a code table index
; additionally, the code needs multiple entries in the table because no masking is done during compressed data processing
; so if 11000 is a valid code then all indices of the form 11000XXX need to have the same entry
Nem_BCT_ShortCode:
		move.b	(a0)+,d0	; get code
		lsl.w	d1,d0	; shift so that high bit is in bit position 7
		add.w	d0,d0	; get index into code table
		moveq	#1,d5
		lsl.w	d1,d5
		subq.w	#1,d5	; d5 = 2^d1 - 1

Nem_BCT_ShortCode_Loop:
		move.w	d7,(a1,d0.w)	; store entry
		addq.w	#2,d0	; increment index
		dbf	d5,Nem_BCT_ShortCode_Loop	; repeat for required number of entries
		bra.s	Nem_BCT_Loop
; End of function Nem_Build_Code_Table

; ---------------------------------------------------------------------------
; Adds pattern load requests to the Nemesis decompression queue
; Input: d0 = ID of the PLC to load
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Load_PLC:
		movem.l	a1-a2,-(sp)
		lea	(Offs_PLC).l,a1
		add.w	d0,d0
		move.w	(a1,d0.w),d0
		lea	(a1,d0.w),a1
		lea	($FFFFF680).w,a2

$$findFreeSlot:
		tst.l	(a2)	; is the current slot in the queue free?
		beq.s	$$getPieceCount	; if it is, branch
		addq.w	#6,a2	; otherwise check the next slot
		bra.s	$$findFreeSlot
; ---------------------------------------------------------------------------

$$getPieceCount:
		move.w	(a1)+,d0
		bmi.s	$$done

$$queuePieces:
		move.l	(a1)+,(a2)+	; store compressed data location
		move.w	(a1)+,(a2)+	; store destination in VRAM
		dbf	d0,$$queuePieces

$$done:
		movem.l	(sp)+,a1-a2
		rts
; End of function Load_PLC

; ---------------------------------------------------------------------------
; Loads a raw PLC from ROM
; Input: a1 = address of the PLC
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Load_PLC_Raw:
		lea	($FFFFF680).w,a2

$$findFreeSlot:
		tst.l	(a2)
		beq.s	$$getPieceCount
		addq.w	#6,a2
		bra.s	$$findFreeSlot
; ---------------------------------------------------------------------------

$$getPieceCount:
		move.w	(a1)+,d0
		bmi.s	$$done

$$queuePieces:
		move.l	(a1)+,(a2)+
		move.w	(a1)+,(a2)+
		dbf	d0,$$queuePieces

$$done:
		rts
; End of function Load_PLC_Raw

; ---------------------------------------------------------------------------
; Adds pattern load requests to the Nemesis decompression queue
; Differs from Load_PLC in that it clears the queue before loading
; Input: d0 = ID of the PLC to load
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Load_PLC_2:
		movem.l	a1-a2,-(sp)		; This differs from Load_PLC in that it overrides any PLCs already in the queue
		lea	(Offs_PLC).l,a1
		add.w	d0,d0
		move.w	(a1,d0.w),d0
		lea	(a1,d0.w),a1
		bsr.s	Clear_Nem_Queue
		lea	($FFFFF680).w,a2
		move.w	(a1)+,d0
		bmi.s	$$done

$$queuePieces:
		move.l	(a1)+,(a2)+
		move.w	(a1)+,(a2)+
		dbf	d0,$$queuePieces

$$done:
		movem.l	(sp)+,a1-a2
		rts
; End of function Load_PLC_2

; ---------------------------------------------------------------------------
; Clears the Nemesis decompression queue and its associated variables
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Clear_Nem_Queue:
		lea	($FFFFF680).w,a2
		moveq	#bytesToLcnt($80),d0	; clear till the end of Nem_decomp_vars

-		clr.l	(a2)+
		dbf	d0,-
		rts
; End of function Clear_Nem_Queue

; ---------------------------------------------------------------------------
; Initializes Nemesis decompression queue processing
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Process_Nem_Queue_Init:
		tst.l	($FFFFF680).w
		beq.s	++	; return if the queue is empty
		tst.w	($FFFFF6F8).w
		bne.s	++	; return if processing of a previous piece is still going on
		movea.l	($FFFFF680).w,a0
		lea	(Nem_PCD_WriteRowToVDP).l,a3
		nop
		lea	($FFFFAA00).w,a1
		move.w	(a0)+,d2
		bpl.s	+
		adda.w	#Nem_PCD_WriteRowToVDP_XOR-Nem_PCD_WriteRowToVDP,a3
+
		andi.w	#$7FFF,d2
		bsr.w	Nem_Build_Code_Table
		move.b	(a0)+,d5
		asl.w	#8,d5
		move.b	(a0)+,d5
		moveq	#$10,d6
		moveq	#0,d0
		move.l	a0,($FFFFF680).w
		move.l	a3,($FFFFF6E0).w
		move.l	d0,($FFFFF6E4).w
		move.l	d0,($FFFFF6E8).w
		move.l	d0,($FFFFF6EC).w
		move.l	d5,($FFFFF6F0).w
		move.l	d6,($FFFFF6F4).w
		move.w	d2,($FFFFF6F8).w
+
		rts
; End of function Process_Nem_Queue_Init

; ---------------------------------------------------------------------------
; Processes the first piece on the Nemesis decompression queue
; Decompresses 6 patterns per frame
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Process_Nem_Queue:
		tst.w	($FFFFF6F8).w
		beq.w	Process_Nem_Queue_Done
		move.w	#6,($FFFFF6FA).w	; decompress 6 patterns per frame
		moveq	#0,d0
		move.w	($FFFFF684).w,d0
		addi.w	#6*$20,($FFFFF684).w	; increment by 6 patterns' worth of data
		bra.s	Process_Nem_Queue_Main
; End of function Process_Nem_Queue

; ---------------------------------------------------------------------------
; Processes the first piece on the Nemesis decompression queue
; Decompresses 3 patterns per frame
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Process_Nem_Queue_2:
		tst.w	($FFFFF6F8).w
		beq.s	Process_Nem_Queue_Done
		move.w	#3,($FFFFF6FA).w	; decompress 3 patterns per frame
		moveq	#0,d0
		move.w	($FFFFF684).w,d0
		addi.w	#3*$20,($FFFFF684).w	; increment by 3 patterns' worth of data
; End of function Process_Nem_Queue_2

; ---------------------------------------------------------------------------
; Main Nemesis decompression queue processor
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Process_Nem_Queue_Main:
		lea	($C00004).l,a4
		lsl.l	#2,d0
		lsr.w	#2,d0
		ori.w	#$4000,d0
		swap	d0	; d0 = VDP command word to write to VRAM destination
		move.l	d0,(a4)
		subq.w	#4,a4	; a4 = $C00000
		movea.l	($FFFFF680).w,a0
		movea.l	($FFFFF6E0).w,a3
		move.l	($FFFFF6E4).w,d0
		move.l	($FFFFF6E8).w,d1
		move.l	($FFFFF6EC).w,d2
		move.l	($FFFFF6F0).w,d5
		move.l	($FFFFF6F4).w,d6
		lea	($FFFFAA00).w,a1

Process_Nem_Queue_Loop:
		movea.w	#8,a5	; decompress all 8 rows in a pattern
		bsr.w	Nem_PCD_NewRow
		subq.w	#1,($FFFFF6F8).w	; have all the patterns been decompressed?
		beq.s	Process_Nem_Queue_ShiftUp	; if yes, shift all other queue entries up
		subq.w	#1,($FFFFF6FA).w	; has the current frame's worth of patterns been decompressed?
		bne.s	Process_Nem_Queue_Loop	; if not, loop
		move.l	a0,($FFFFF680).w
		move.l	a3,($FFFFF6E0).w
		move.l	d0,($FFFFF6E4).w
		move.l	d1,($FFFFF6E8).w
		move.l	d2,($FFFFF6EC).w
		move.l	d5,($FFFFF6F0).w
		move.l	d6,($FFFFF6F4).w

Process_Nem_Queue_Done:
		rts
; ---------------------------------------------------------------------------

; this routine is idiotic because:
; a) it doesn't copy the VRAM location for the last entry in the queue
; b) it doesn't actually mark the last slot in the queue as clear
; so basically don't store an entry in the last slot unless you want the game to screw up to high heaven
Process_Nem_Queue_ShiftUp:
		lea	($FFFFF680).w,a0
		moveq	#$15,d0

-		move.l	6(a0),(a0)+
		dbf	d0,-
		rts
; End of function Process_Nem_Queue_Main

; ---------------------------------------------------------------------------
		lea	(Offs_PLC).l,a1
		add.w	d0,d0
		move.w	(a1,d0.w),d0
		lea	(a1,d0.w),a1

; ---------------------------------------------------------------------------
; Loads a raw PLC from the ROM and decompresses it immediately
; Input: a1 = the address of the PLC
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Load_PLC_Immediate:
		move.w	(a1)+,d1

$$decompPieces:
		movea.l	(a1)+,a0	; get source address
		moveq	#0,d0
		move.w	(a1)+,d0	; get destination VRAM address
		lsl.l	#2,d0
		lsr.w	#2,d0
		ori.w	#$4000,d0
		swap	d0	; d0 = VDP command to write to destination
		move.l	d0,($C00004).l
		bsr.w	Nem_Decomp
		dbf	d1,$$decompPieces
		rts
; End of function Load_PLC_Immediate

; ---------------------------------------------------------------------------
; Enigma decompression subroutine
; Inputs:
; a0 = compressed data location
; a1 = destination (in RAM)
; d0 = starting art tile
; See http://www.segaretro.org/Enigma_compression for format description
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Eni_Decomp:
		movem.l	d0-d7/a1-a5,-(sp)
		movea.w	d0,a3	; store starting art tile
		move.b	(a0)+,d0
		ext.w	d0
		movea.w	d0,a5	; store number of bits in inline copy value
		move.b	(a0)+,d4
		lsl.b	#3,d4	; store PCCVH flags bitfield
		movea.w	(a0)+,a2
		adda.w	a3,a2	; store incremental copy word
		movea.w	(a0)+,a4
		adda.w	a3,a4	; store literal copy word
		move.b	(a0)+,d5
		asl.w	#8,d5
		move.b	(a0)+,d5	; get first word in format list
		moveq	#$10,d6		; initial shift value

Eni_Decomp_Loop:
		moveq	#7,d0	; assume a format list entry is 7 bits
		move.w	d6,d7
		sub.w	d0,d7
		move.w	d5,d1
		lsr.w	d7,d1
		andi.w	#$7F,d1	; get format list entry
		move.w	d1,d2	; and copy it
		cmpi.w	#$40,d1	; is the high bit of the entry set?
		bcc.s	+
		moveq	#6,d0	; if it isn't, the entry is actually 6 bits
		lsr.w	#1,d2
+
		bsr.w	Eni_Decomp_FetchByte
		andi.w	#$F,d2	; get repeat count
		lsr.w	#4,d1
		add.w	d1,d1
		jmp	Eni_Decomp_Index(pc,d1.w)
; ---------------------------------------------------------------------------

Eni_Decomp_00:
		move.w	a2,(a1)+	; copy incremental copy word
		addq.w	#1,a2	; increment it
		dbf	d2,Eni_Decomp_00	; repeat
		bra.s	Eni_Decomp_Loop
; ---------------------------------------------------------------------------

Eni_Decomp_01:
		move.w	a4,(a1)+	; copy literal copy word
		dbf	d2,Eni_Decomp_01	; repeat
		bra.s	Eni_Decomp_Loop
; ---------------------------------------------------------------------------

Eni_Decomp_100:
		bsr.w	Eni_Decomp_FetchInlineValue

-		move.w	d1,(a1)+	; copy inline value
		dbf	d2,-	; repeat
		bra.s	Eni_Decomp_Loop
; ---------------------------------------------------------------------------

Eni_Decomp_101:
		bsr.w	Eni_Decomp_FetchInlineValue

-		move.w	d1,(a1)+	; copy inline value
		addq.w	#1,d1	; increment
		dbf	d2,-	; repeat
		bra.s	Eni_Decomp_Loop
; ---------------------------------------------------------------------------

Eni_Decomp_110:
		bsr.w	Eni_Decomp_FetchInlineValue

-		move.w	d1,(a1)+	; copy inline value
		subq.w	#1,d1	; decrement
		dbf	d2,-	; repeat
		bra.s	Eni_Decomp_Loop
; ---------------------------------------------------------------------------

Eni_Decomp_111:
		cmpi.w	#$F,d2
		beq.s	Eni_Decomp_Done

-		bsr.w	Eni_Decomp_FetchInlineValue	; fetch new inline value
		move.w	d1,(a1)+	; copy it
		dbf	d2,-	; and repeat
		bra.s	Eni_Decomp_Loop
; ---------------------------------------------------------------------------

Eni_Decomp_Index:
		bra.s	Eni_Decomp_00
; ---------------------------------------------------------------------------
		bra.s	Eni_Decomp_00
; ---------------------------------------------------------------------------
		bra.s	Eni_Decomp_01
; ---------------------------------------------------------------------------
		bra.s	Eni_Decomp_01
; ---------------------------------------------------------------------------
		bra.s	Eni_Decomp_100
; ---------------------------------------------------------------------------
		bra.s	Eni_Decomp_101
; ---------------------------------------------------------------------------
		bra.s	Eni_Decomp_110
; ---------------------------------------------------------------------------
		bra.s	Eni_Decomp_111
; ---------------------------------------------------------------------------

Eni_Decomp_Done:
		subq.w	#1,a0	; go back by one byte
		cmpi.w	#$10,d6
		bne.s	+
		subq.w	#1,a0	; and another one if needed
+
		move.w	a0,d0
		lsr.w	#1,d0
		bcc.s	+
		addq.w	#1,a0	; make sure it's an even address
+
		movem.l	(sp)+,d0-d7/a1-a5
		rts
; End of function Eni_Decomp

; ---------------------------------------------------------------------------
; Part of the Enigma decompressor
; Fetches an inline copy value and stores it in d1
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Eni_Decomp_FetchInlineValue:
		move.w	a3,d3	; copy starting art tile
		move.b	d4,d1	; copy PCCVH bitfield
		add.b	d1,d1	; is the priority bit set?
		bcc.s	+	; if not, branch
		subq.w	#1,d6
		btst	d6,d5	; is the priority bit set in the inline render flags?
		beq.s	+	; if not, branch
		ori.w	#$8000,d3	; otherwise set priority bit in art tile
+
		add.b	d1,d1	; is the high palette line bit set?
		bcc.s	+	; if not, branch
		subq.w	#1,d6
		btst	d6,d5
		beq.s	+
		addi.w	#$4000,d3
+
		add.b	d1,d1	; is the low palette line bit set?
		bcc.s	+	; if not, branch
		subq.w	#1,d6
		btst	d6,d5
		beq.s	+
		addi.w	#$2000,d3
+
		add.b	d1,d1	; is the vertical flip flag set?
		bcc.s	+	; if not, branch
		subq.w	#1,d6
		btst	d6,d5
		beq.s	+
		ori.w	#$1000,d3
+
		add.b	d1,d1	; is the horizontal flip flag set?
		bcc.s	+	; if not, branch
		subq.w	#1,d6
		btst	d6,d5
		beq.s	+
		ori.w	#$800,d3
+
		move.w	d5,d1
		move.w	d6,d7
		sub.w	a5,d7	; subtract length in bits of inline copy value
		bcc.s	$$enoughBits	; branch if a new word doesn't need to be read
		move.w	d7,d6
		addi.w	#$10,d6
		neg.w	d7	; calculate bit deficit
		lsl.w	d7,d1	; and make space for that many bits
		move.b	(a0),d5	; get next byte
		rol.b	d7,d5	; and rotate the required bits into the lowest positions
		add.w	d7,d7
		and.w	Eni_Decomp_Masks-2(pc,d7.w),d5
		add.w	d5,d1	; combine upper bits with lower bits

$$maskValue:
		move.w	a5,d0	; get length in bits of inline copy value
		add.w	d0,d0
		and.w	Eni_Decomp_Masks-2(pc,d0.w),d1	; mask value appropriately
		add.w	d3,d1	; add starting art tile
		move.b	(a0)+,d5
		lsl.w	#8,d5
		move.b	(a0)+,d5	; get next word
		rts
; ---------------------------------------------------------------------------

$$enoughBits:
		beq.s	$$justEnough	; if the word has been exactly exhausted, branch
		lsr.w	d7,d1	; get inline copy value
		move.w	a5,d0
		add.w	d0,d0
		and.w	Eni_Decomp_Masks-2(pc,d0.w),d1	; and mask it appropriately
		add.w	d3,d1	; add starting art tile
		move.w	a5,d0
		bra.s	Eni_Decomp_FetchByte
; ---------------------------------------------------------------------------

$$justEnough:
		moveq	#$10,d6	; reset shift value
		bra.s	$$maskValue
; End of function Eni_Decomp_FetchInlineValue

; ---------------------------------------------------------------------------
Eni_Decomp_Masks:
		dc.w     1
		dc.w     3
		dc.w     7
		dc.w    $F
		dc.w   $1F
		dc.w   $3F
		dc.w   $7F
		dc.w   $FF
		dc.w  $1FF
		dc.w  $3FF
		dc.w  $7FF
		dc.w  $FFF
		dc.w $1FFF
		dc.w $3FFF
		dc.w $7FFF
		dc.w $FFFF

; ---------------------------------------------------------------------------
; Part of the Enigma decompressor, fetches the next byte if needed
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Eni_Decomp_FetchByte:
		sub.w	d0,d6	; subtract length of current entry from shift value so that next entry is read next time around
		cmpi.w	#9,d6	; does a new byte need to be read?
		bcc.s	+	; if not, branch
		addq.w	#8,d6
		asl.w	#8,d5
		move.b	(a0)+,d5
+
		rts
; End of function Eni_Decomp_FetchByte

; ---------------------------------------------------------------------------
; Kosinski decompression subroutine
; Inputs:
; a0 = compressed data location
; a1 = destination
; See http://www.segaretro.org/Kosinski_compression for format description
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Kos_Decomp:
		subq.l	#2,sp	; make space for two bytes on the stack
		move.b	(a0)+,1(sp)
		move.b	(a0)+,(sp)
		move.w	(sp),d5	; copy first description field
		moveq	#$F,d4	; 16 bits in a byte

Kos_Decomp_Loop:
		lsr.w	#1,d5	; bit which is shifted out goes into C flag
		move	sr,d6
		dbf	d4,Kos_Decomp_ChkBit
		move.b	(a0)+,1(sp)
		move.b	(a0)+,(sp)
		move.w	(sp),d5	; get next description field if needed
		moveq	#$F,d4	; reset bit counter

Kos_Decomp_ChkBit:
		move	d6,ccr	; was the bit set?
		bcc.s	Kos_Decomp_RLE	; if not, branch (C flag clear means bit was clear)
		move.b	(a0)+,(a1)+	; otherwise, copy byte as-is
		bra.s	Kos_Decomp_Loop
; ---------------------------------------------------------------------------

Kos_Decomp_RLE:
		moveq	#0,d3
		lsr.w	#1,d5	; get next bit
		move	sr,d6
		dbf	d4,Kos_Decomp_ChkBit2
		move.b	(a0)+,1(sp)
		move.b	(a0)+,(sp)
		move.w	(sp),d5
		moveq	#$F,d4

Kos_Decomp_ChkBit2:
		move	d6,ccr	; was the bit set?
		bcs.s	Kos_Decomp_SeparateRLE	; if it was, branch
		lsr.w	#1,d5	; bit which is shifted out goes into X flag
		dbf	d4,+
		move.b	(a0)+,1(sp)
		move.b	(a0)+,(sp)
		move.w	(sp),d5
		moveq	#$F,d4
+
		roxl.w	#1,d3	; get high repeat count bit (shift X flag in)
		lsr.w	#1,d5
		dbf	d4,+
		move.b	(a0)+,1(sp)
		move.b	(a0)+,(sp)
		move.w	(sp),d5
		moveq	#$F,d4
+
		roxl.w	#1,d3	; get low repeat count bit
		addq.w	#1,d3	; increment repeat count
		moveq	#-1,d2
		move.b	(a0)+,d2	; calculate offset
		bra.s	Kos_Decomp_RLELoop
; ---------------------------------------------------------------------------

Kos_Decomp_SeparateRLE:
		move.b	(a0)+,d0	; get first byte
		move.b	(a0)+,d1	; get second byte
		moveq	#-1,d2
		move.b	d1,d2
		lsl.w	#5,d2
		move.b	d0,d2	; calculate offset
		andi.w	#7,d1	; does a third byte need to be read?
		beq.s	Kos_Decomp_SeparateRLE2	; if it does, branch
		move.b	d1,d3	; copy repeat count
		addq.w	#1,d3	; and increment it

Kos_Decomp_RLELoop:
		move.b	(a1,d2.w),d0
		move.b	d0,(a1)+	; copy appropriate byte
		dbf	d3,Kos_Decomp_RLELoop	; and repeat the copying
		bra.s	Kos_Decomp_Loop
; ---------------------------------------------------------------------------

Kos_Decomp_SeparateRLE2:
		move.b	(a0)+,d1
		beq.s	Kos_Decomp_Done	; 0 indicates end of compressed data
		cmpi.b	#1,d1
		beq.w	Kos_Decomp_Loop	; 1 indicates a new description needs to be read
		move.b	d1,d3	; otherwise, copy repeat count
		bra.s	Kos_Decomp_RLELoop
; ---------------------------------------------------------------------------

Kos_Decomp_Done:
		addq.l	#2,sp	; restore stack pointer to original state
		rts
; End of function Kos_Decomp

; ---------------------------------------------------------------------------
; Adds a Kosinski Moduled archive to the module queue
; Inputs:
; a1 = address of the archive
; d2 = destination in VRAM
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Queue_Kos_Module:
		lea	($FFFFFF64).w,a2
		tst.l	(a2)	; is the first slot free?
		beq.s	Process_Kos_Module_Queue_Init	; if it is, branch
		addq.w	#6,a2	; otherwise, check next slot

$$findFreeSlot:
		tst.l	(a2)
		beq.s	$$freeSlotFound
		addq.w	#6,a2
		bra.s	$$findFreeSlot
; ---------------------------------------------------------------------------

$$freeSlotFound:
		move.l	a1,(a2)+	; store source address
		move.w	d2,(a2)+	; store destination VRAM address
		rts
; End of function Queue_Kos_Module

; ---------------------------------------------------------------------------
; Initializes processing of the first module on the queue
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Process_Kos_Module_Queue_Init:
		move.w	(a1)+,d3	; get uncompressed size
		cmpi.w	#$A000,d3
		bne.s	+
		move.w	#$8000,d3	; $A000 means $8000 for some reason
+
		lsr.w	#1,d3
		move.w	d3,d0
		rol.w	#5,d0
		andi.w	#$1F,d0	; get number of complete modules
		move.b	d0,($FFFFFF60).w
		andi.l	#$7FF,d3	; get size of last module in words
		bne.s	+	; branch if it's non-zero
		subq.b	#1,($FFFFFF60).w	; otherwise decrement the number of modules
		move.l	#$800,d3	; and take the size of the last module to be $800 words
+
		move.w	d3,($FFFFFF62).w
		move.w	d2,($FFFFFF68).w
		move.l	a1,($FFFFFF64).w
		addq.b	#1,($FFFFFF60).w	; store total number of modules
		rts
; End of function Process_Kos_Module_Queue_Init

; ---------------------------------------------------------------------------
; Processes the first module on the queue
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Process_Kos_Module_Queue:
		tst.b	($FFFFFF60).w
		bne.s	$$modulesLeft

$$done:
		rts
; ---------------------------------------------------------------------------

$$modulesLeft:
		bmi.s	$$decompressionStarted
		cmpi.w	#4,($FFFFFF0E).w
		bcc.s	$$done	; branch if the Kosinski decompression queue is full
		movea.l	($FFFFFF64).w,a1
		lea	($FFFFD000).w,a2
		bsr.w	Queue_Kos	; add current module to decompression queue
		ori.b	#$80,($FFFFFF60).w	; and set bit to signify decompression in progress
		rts
; ---------------------------------------------------------------------------

$$decompressionStarted:
		tst.w	($FFFFFF0E).w
		bne.s	$$done	; branch if the decompression isn't complete

		; otherwise, DMA the decompressed data to VRAM
		andi.b	#$7F,($FFFFFF60).w
		move.l	#$800,d3
		subq.b	#1,($FFFFFF60).w
		bne.s	+	; branch if it isn't the last module
		move.w	($FFFFFF62).w,d3
+
		move.w	($FFFFFF68).w,d2
		move.w	d2,d0
		add.w	d3,d0
		add.w	d3,d0
		move.w	d0,($FFFFFF68).w	; set new destination
		move.l	($FFFFFF64).w,d0
		move.l	($FFFFFF40).w,d1
		sub.l	d1,d0
		andi.l	#$F,d0
		add.l	d0,d1	; round to the nearest $10 boundary
		move.l	d1,($FFFFFF64).w	; and set new source
		move.l	#$FFFFD000,d1
		andi.l	#$FFFFFF,d1
		jsr	(Add_To_DMA_Queue).l
		tst.b	($FFFFFF60).w
		bne.s	+	; return if this wasn't the last module
		lea	($FFFFFF64).w,a0
		lea	($FFFFFF6A).w,a1
		move.l	(a1)+,(a0)+	; otherwise, shift all entries up
		move.w	(a1)+,(a0)+
		move.l	(a1)+,(a0)+
		move.w	(a1)+,(a0)+
		move.l	(a1)+,(a0)+
		move.w	(a1)+,(a0)+
		move.l	#0,(a0)+	; and mark the last slot as free
		move.w	#0,(a0)+
		move.l	($FFFFFF64).w,d0
		beq.s	+	; return if the queue is now empty
		movea.l	d0,a1
		move.w	($FFFFFF68).w,d2
		jmp	(Process_Kos_Module_Queue_Init).l
+
		rts
; End of function Process_Kos_Module_Queue

; ---------------------------------------------------------------------------
; Adds Kosinski-compressed data to the decompression queue
; Inputs:
; a1 = compressed data address
; a2 = decompression destination in RAM
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Queue_Kos:
		move.w	($FFFFFF0E).w,d0
		lsl.w	#3,d0
		lea	($FFFFFF40).w,a3
		move.l	a1,(a3,d0.w)	; store source
		move.l	a2,4(a3,d0.w)	; store destination
		addq.w	#1,($FFFFFF0E).w
		rts
; End of function Queue_Kos

; ---------------------------------------------------------------------------
; Checks if V-int occured in the middle of Kosinski queue processing
; and stores the location from which processing is to resume if it did
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Set_Kos_Bookmark:
		tst.w	($FFFFFF0E).w
		bpl.s	+	; branch if a decompression wasn't in progress
		move.l	$42(sp),d0	; check address V-int is supposed to rte to
		cmpi.l	#Process_Kos_Queue_Main,d0
		bcs.s	+
		cmpi.l	#Process_Kos_Queue_Done,d0
		bcc.s	+
		move.l	$42(sp),($FFFFFF3A).w
		move.l	#Backup_Kos_Registers,$42(sp)	; force V-int to rte here instead if needed
+
		rts
; End of function Set_Kos_Bookmark

; ---------------------------------------------------------------------------
; Processes the first entry in the Kosinski decompression queue
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Process_Kos_Queue:
		tst.w	($FFFFFF0E).w
		beq.w	Process_Kos_Queue_Done
		bmi.w	Restore_Kos_Bookmark	; branch if a decompression was interrupted by V-int

Process_Kos_Queue_Main:
		ori.w	#$8000,($FFFFFF0E).w	; set sign bit to signify decompression in progress
		movea.l	($FFFFFF40).w,a0
		movea.l	($FFFFFF44).w,a1

		; what follows is identical to the normal Kosinski decompressor except for using Kos_description_field instead of the stack
		lea	($FFFFFF3E).w,a2
		move.b	(a0)+,1(a2)
		move.b	(a0)+,(a2)
		move.w	(a2),d5
		moveq	#$F,d4

Process_Kos_Queue_Loop:
		lsr.w	#1,d5
		move	sr,d6
		dbf	d4,Process_Kos_Queue_ChkBit
		move.b	(a0)+,1(a2)
		move.b	(a0)+,(a2)
		move.w	(a2),d5
		moveq	#$F,d4

Process_Kos_Queue_ChkBit:
		move	d6,ccr
		bcc.s	Process_Kos_Queue_RLE
		move.b	(a0)+,(a1)+
		bra.s	Process_Kos_Queue_Loop
; ---------------------------------------------------------------------------

Process_Kos_Queue_RLE:
		moveq	#0,d3
		lsr.w	#1,d5
		move	sr,d6
		dbf	d4,Process_Kos_Queue_ChkBit2
		move.b	(a0)+,1(a2)
		move.b	(a0)+,(a2)
		move.w	(a2),d5
		moveq	#$F,d4

Process_Kos_Queue_ChkBit2:
		move	d6,ccr
		bcs.s	Process_Kos_Queue_SeparateRLE
		lsr.w	#1,d5
		dbf	d4,+
		move.b	(a0)+,1(a2)
		move.b	(a0)+,(a2)
		move.w	(a2),d5
		moveq	#$F,d4
+
		roxl.w	#1,d3
		lsr.w	#1,d5
		dbf	d4,+
		move.b	(a0)+,1(a2)
		move.b	(a0)+,(a2)
		move.w	(a2),d5
		moveq	#$F,d4
+
		roxl.w	#1,d3
		addq.w	#1,d3
		moveq	#-1,d2
		move.b	(a0)+,d2
		bra.s	Process_Kos_Queue_RLELoop
; ---------------------------------------------------------------------------

Process_Kos_Queue_SeparateRLE:
		move.b	(a0)+,d0
		move.b	(a0)+,d1
		moveq	#-1,d2
		move.b	d1,d2
		lsl.w	#5,d2
		move.b	d0,d2
		andi.w	#7,d1
		beq.s	Process_Kos_Queue_SeparateRLE2
		move.b	d1,d3
		addq.w	#1,d3

Process_Kos_Queue_RLELoop:
		move.b	(a1,d2.w),d0
		move.b	d0,(a1)+
		dbf	d3,Process_Kos_Queue_RLELoop
		bra.s	Process_Kos_Queue_Loop
; ---------------------------------------------------------------------------

Process_Kos_Queue_SeparateRLE2:
		move.b	(a0)+,d1
		beq.s	Process_Kos_Queue_EndReached
		cmpi.b	#1,d1
		beq.w	Process_Kos_Queue_Loop
		move.b	d1,d3
		bra.s	Process_Kos_Queue_RLELoop
; ---------------------------------------------------------------------------

Process_Kos_Queue_EndReached:
		move.l	a0,($FFFFFF40).w
		move.l	a1,($FFFFFF44).w
		andi.w	#$7FFF,($FFFFFF0E).w	; clear decompression in progress bit
		subq.w	#1,($FFFFFF0E).w
		beq.s	Process_Kos_Queue_Done	; branch if there aren't any entries remaining in the queue
		lea	($FFFFFF40).w,a0
		lea	($FFFFFF48).w,a1	; otherwise, shift all entries up
		move.l	(a1)+,(a0)+
		move.l	(a1)+,(a0)+
		move.l	(a1)+,(a0)+
		move.l	(a1)+,(a0)+
		move.l	(a1)+,(a0)+
		move.l	(a1)+,(a0)+

Process_Kos_Queue_Done:
		rts
; ---------------------------------------------------------------------------

Restore_Kos_Bookmark:
		movem.l	($FFFFFF10).w,d0-d6/a0-a2
		move.l	($FFFFFF3A).w,-(sp)
		move.w	($FFFFFF38).w,-(sp)
		rte
; ---------------------------------------------------------------------------

Backup_Kos_Registers:
		move	sr,($FFFFFF38).w
		movem.l	d0-d6/a0-a2,($FFFFFF10).w
		rts
; End of function Process_Kos_Queue

; ---------------------------------------------------------------------------
; Called at the end of each frame to perform vertical synchronization
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Wait_VSync:
		move	#$2300,sr

-		tst.b	($FFFFF62A).w
		bne.s	-	; wait until V-int's run
		rts
; End of function Wait_VSync

; ---------------------------------------------------------------------------
; Generates a pseudo-random number in d0
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


Random_Number:
		move.l	($FFFFF636).w,d1
		tst.w	d1
		bne.s	+
		move.l	#$2A6D365B,d1	; reset seed if needed
+
		move.l	d1,d0
		asl.l	#2,d1
		add.l	d0,d1
		asl.l	#3,d1
		add.l	d0,d1
		move.w	d1,d0
		swap	d1
		add.w	d1,d0
		move.w	d0,d1
		swap	d1
		move.l	d1,($FFFFF636).w
		rts
; End of function Random_Number

; ---------------------------------------------------------------------------
; Calculates the sine and cosine of the angle in d0 (360 degrees = 256)
; Returns the sine in d0 and the cosine in d1 (both multiplied by $100)
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


GetSineCosine:
		andi.w	#$FF,d0
		add.w	d0,d0
		addi.w	#$40*2,d0	; $40 = 90 degrees, sin(x+90) = cos(x)
		move.w	SineTable(pc,d0.w),d1
		subi.w	#$40*2,d0
		move.w	SineTable(pc,d0.w),d0
		rts
; End of function GetSineCosine

; ---------------------------------------------------------------------------
SineTable:	binclude "Levels\Misc\sine.bin"

; ---------------------------------------------------------------------------
; Calculates the arctangent of y/x and returns it in d0 (360 degrees = 256)
; Inputs: d1 = input x, d2 = input y
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


GetArcTan:
		movem.l	d3-d4,-(sp)
		moveq	#0,d3
		moveq	#0,d4
		move.w	d1,d3
		move.w	d2,d4
		or.w	d3,d4
		beq.s	GetArcTan_Zero	; special case when both x and y are zero
		move.w	d2,d4
		tst.w	d3
		bpl.s	+
		neg.w	d3
+
		tst.w	d4
		bpl.s	+
		neg.w	d4
+
		cmp.w	d3,d4
		bcc.s	+	; if |y| >= |x|
		lsl.l	#8,d4
		divu.w	d3,d4
		moveq	#0,d0
		move.b	ArcTanTable(pc,d4.w),d0
		bra.s	++
+
		lsl.l	#8,d3
		divu.w	d4,d3
		moveq	#$40,d0
		sub.b	ArcTanTable(pc,d3.w),d0	; arctan(y/x) = 90 - arctan(x/y)
+
		tst.w	d1
		bpl.s	+
		neg.w	d0
		addi.w	#$80,d0	; place angle in appropriate quadrant
+
		tst.w	d2
		bpl.s	+
		neg.w	d0
		addi.w	#$100,d0	; place angle in appropriate quadrant
+
		movem.l	(sp)+,d3-d4
		rts
; ---------------------------------------------------------------------------

GetArcTan_Zero:
		move.w	#$40,d0	; angle = 90 degrees
		movem.l	(sp)+,d3-d4
		rts
; End of function GetArcTan

; ---------------------------------------------------------------------------
ArcTanTable:	binclude "Levels\Misc\arctan.bin"
; ---------------------------------------------------------------------------

AnPal_Load:
		bsr.w	SuperSonic_PalFlash
		moveq	#0,d2
		moveq	#0,d0
		move.w	($FFFFFE10).w,d0
		ror.b	#1,d0
		lsr.w	#6,d0
		move.w	OffsAnPal(pc,d0.w),d0
		jmp	OffsAnPal(pc,d0.w)
; ---------------------------------------------------------------------------
		rts
; ---------------------------------------------------------------------------
OffsAnPal:	dc.w AnPal_AIZ1-OffsAnPal
		dc.w AnPal_AIZ2-OffsAnPal
		dc.w AnPal_HCZ1-OffsAnPal
		dc.w AnPal_None2-OffsAnPal
		dc.w AnPal_None-OffsAnPal
		dc.w AnPal_None-OffsAnPal
		dc.w AnPal_CNZ-OffsAnPal
		dc.w AnPal_CNZ-OffsAnPal
		dc.w AnPal_FBZ-OffsAnPal
		dc.w AnPal_FBZ-OffsAnPal
		dc.w AnPal_ICZ-OffsAnPal
		dc.w AnPal_ICZ-OffsAnPal
		dc.w AnPal_LBZ1-OffsAnPal
		dc.w AnPal_LBZ2-OffsAnPal
		dc.w AnPal_None-OffsAnPal
		dc.w AnPal_None-OffsAnPal
		dc.w AnPal_SOZ1-OffsAnPal
		dc.w AnPal_SOZ2-OffsAnPal
		dc.w AnPal_LRZ1-OffsAnPal
		dc.w AnPal_LRZ2-OffsAnPal
		dc.w AnPal_None-OffsAnPal
		dc.w AnPal_None-OffsAnPal
		dc.w AnPal_DEZ1-OffsAnPal
		dc.w AnPal_DEZ2-OffsAnPal
		dc.w AnPal_None-OffsAnPal
		dc.w AnPal_None-OffsAnPal
		dc.w AnPal_None-OffsAnPal
		dc.w AnPal_None-OffsAnPal
		dc.w AnPal_None-OffsAnPal
		dc.w AnPal_None-OffsAnPal
		dc.w AnPal_BPZ-OffsAnPal
		dc.w AnPal_BPZ-OffsAnPal
		dc.w AnPal_None-OffsAnPal
		dc.w AnPal_None-OffsAnPal
		dc.w AnPal_CGZ-OffsAnPal
		dc.w AnPal_CGZ-OffsAnPal
		dc.w AnPal_EMZ-OffsAnPal
		dc.w AnPal_EMZ-OffsAnPal
		dc.w AnPal_None-OffsAnPal
		dc.w AnPal_None-OffsAnPal
		dc.w AnPal_Pachinko-OffsAnPal
		dc.w AnPal_Pachinko-OffsAnPal
		dc.w AnPal_Slots-OffsAnPal
		dc.w AnPal_Slots-OffsAnPal
		dc.w AnPal_LRZ3-OffsAnPal
		dc.w AnPal_HPZ_A-OffsAnPal
		dc.w AnPal_None-OffsAnPal
		dc.w AnPal_HPZ_A-OffsAnPal
; ---------------------------------------------------------------------------

AnPal_None:
		rts

; =============== S U B R O U T I N E =======================================


AnPal_AIZ1:
		move.b	($FFFFF72E).w,d0
		bne.s	loc_221E
		subq.w	#1,($FFFFF634).w
		bpl.s	locret_221C
		move.w	#7,($FFFFF634).w
		move.w	($FFFFF632).w,d0
		addq.w	#8,($FFFFF632).w
		andi.w	#$18,d0
		lea	(AnPal_PalAIZ1_1).l,a0
		move.l	(a0,d0.w),($FFFFFC56).w
		move.l	4(a0,d0.w),($FFFFFC5A).w
		tst.b	($FFFFF650).w
		bne.s	locret_221C
		move.w	($FFFFF652).w,d0
		addq.w	#6,($FFFFF652).w
		cmpi.w	#$30,($FFFFF652).w
		bcs.s	loc_220A
		move.w	#0,($FFFFF652).w

loc_220A:
		lea	(AnPal_PalAIZ1_2).l,a0
		move.l	(a0,d0.w),($FFFFFC78).w
		move.w	4(a0,d0.w),($FFFFFC7C).w

locret_221C:
		rts
; ---------------------------------------------------------------------------

loc_221E:
		subq.w	#1,($FFFFF634).w
		bpl.s	locret_227A
		move.w	#9,($FFFFF634).w
		move.w	($FFFFF632).w,d0
		addq.w	#8,($FFFFF632).w
		cmpi.w	#$50,($FFFFF632).w
		bcs.s	loc_2240
		move.w	#0,($FFFFF632).w

loc_2240:
		lea	(AnPal_PalAIZ1_3).l,a0
		move.l	(a0,d0.w),($FFFFFC64).w

loc_224C:
		move.l	4(a0,d0.w),($FFFFFC68).w
		move.w	($FFFFF652).w,d0
		addq.w	#6,($FFFFF652).w
		cmpi.w	#$3C,($FFFFF652).w
		bcs.s	loc_2268
		move.w	#0,($FFFFF652).w

loc_2268:
		lea	(AnPal_PalAIZ1_4).l,a0
		move.l	(a0,d0.w),($FFFFFC7A).w
		move.w	4(a0,d0.w),($FFFFFC7E).w

locret_227A:
		rts
; End of function AnPal_AIZ1

; ---------------------------------------------------------------------------

AnPal_AIZ2:
		subq.w	#1,($FFFFF634).w
		bpl.s	loc_22F6
		move.w	#5,($FFFFF634).w
		move.w	($FFFFF632).w,d0
		addq.w	#8,($FFFFF632).w
		andi.w	#$18,d0
		lea	(AnPal_PalAIZ2_1).l,a0
		move.l	(a0,d0.w),($FFFFFC78).w
		move.l	4(a0,d0.w),($FFFFFC7C).w
		move.w	($FFFFF652).w,d0
		addq.w	#6,($FFFFF652).w
		cmpi.w	#$30,($FFFFF652).w
		bcs.s	loc_22BC
		move.w	#0,($FFFFF652).w

loc_22BC:
		lea	(AnPal_PalAIZ2_2).l,a0
		cmpi.w	#$3800,($FFFFEE78).w
		bcs.s	loc_22D0
		lea	(AnPal_PalAIZ2_3).l,a0

loc_22D0:
		move.w	(a0,d0.w),($FFFFFC48).w
		move.w	2(a0,d0.w),($FFFFFC50).w
		move.w	4(a0,d0.w),($FFFFFC76).w
		move.w	#$A0E,($FFFFFC5C).w
		cmpi.w	#$1C0,($FFFFEE78).w
		bcc.s	loc_22F6
		move.w	4(a0,d0.w),($FFFFFC5C).w

loc_22F6:
		subq.w	#1,($FFFFF658).w
		bpl.s	locret_2332
		move.w	#1,($FFFFF658).w
		move.w	($FFFFF654).w,d0
		addq.w	#2,($FFFFF654).w
		cmpi.w	#$34,($FFFFF654).w
		bcs.s	loc_2318
		move.w	#0,($FFFFF654).w

loc_2318:
		lea	(AnPal_PalAIZ2_4).l,a0
		cmpi.w	#$3800,($FFFFEE78).w
		bcs.s	loc_232C
		lea	(AnPal_PalAIZ2_5).l,a0

loc_232C:
		move.w	(a0,d0.w),($FFFFFC62).w

locret_2332:
		rts

; =============== S U B R O U T I N E =======================================


AnPal_HCZ1:
		subq.w	#1,($FFFFF634).w
		bpl.s	locret_2380
		move.w	#7,($FFFFF634).w
		tst.b	($FFFFF650).w
		beq.s	loc_234C
		move.w	#0,($FFFFF634).w

loc_234C:
		lea	(AnPal_PalHCZ1).l,a0
		move.w	($FFFFF632).w,d0
		addq.w	#8,($FFFFF632).w
		cmpi.w	#$20,($FFFFF632).w
		bcs.s	loc_2368
		move.w	#0,($FFFFF632).w

loc_2368:
		move.l	(a0,d0.w),($FFFFFC46).w
		move.l	4(a0,d0.w),($FFFFFC4A).w
		move.l	(a0,d0.w),($FFFFF0C6).w
		move.l	4(a0,d0.w),($FFFFF0CA).w

locret_2380:
		rts
; End of function AnPal_HCZ1

; ---------------------------------------------------------------------------

AnPal_None2:
		rts
; ---------------------------------------------------------------------------

AnPal_CNZ:
		subq.w	#1,($FFFFF634).w
		bpl.s	loc_23CA
		move.w	#3,($FFFFF634).w
		lea	(AnPal_PalCNZ_1).l,a0
		move.w	($FFFFF632).w,d0
		addq.w	#6,($FFFFF632).w
		cmpi.w	#$60,($FFFFF632).w
		bcs.s	loc_23AC
		move.w	#0,($FFFFF632).w

loc_23AC:
		move.l	(a0,d0.w),($FFFFFC72).w
		move.w	4(a0,d0.w),($FFFFFC76).w
		lea	(AnPal_PalCNZ_2).l,a0
		move.l	(a0,d0.w),($FFFFF0F2).w
		move.w	4(a0,d0.w),($FFFFF0F6).w

loc_23CA:
		lea	(AnPal_PalCNZ_3).l,a0
		move.w	($FFFFF652).w,d0
		addq.w	#6,($FFFFF652).w
		cmpi.w	#$B4,($FFFFF652).w
		bcs.s	loc_23E6
		move.w	#0,($FFFFF652).w

loc_23E6:
		move.l	(a0,d0.w),($FFFFFC52).w
		move.w	4(a0,d0.w),($FFFFFC56).w
		lea	(AnPal_PalCNZ_4).l,a0
		move.l	(a0,d0.w),($FFFFF0D2).w
		move.w	4(a0,d0.w),($FFFFF0D6).w
		subq.w	#1,($FFFFF658).w
		bpl.s	locret_243E
		move.w	#2,($FFFFF658).w
		lea	(AnPal_PalCNZ_5).l,a0
		move.w	($FFFFF654).w,d0
		addq.w	#4,($FFFFF654).w
		cmpi.w	#$40,($FFFFF654).w
		bcs.s	loc_242C
		move.w	#0,($FFFFF654).w

loc_242C:
		move.l	(a0,d0.w),($FFFFFC4E).w
		lea	(AnPal_PalCNZ_5).l,a0
		move.l	(a0,d0.w),($FFFFF0CE).w

locret_243E:
		rts
; ---------------------------------------------------------------------------

AnPal_FBZ:
		tst.b	($FFFFFE05).w
		bne.s	locret_244C
		bchg	#0,($FFFFF7C1).w

locret_244C:
		rts
; ---------------------------------------------------------------------------

AnPal_ICZ:
		subq.w	#1,($FFFFF634).w
		bpl.s	loc_247C
		move.w	#5,($FFFFF634).w
		lea	(AnPal_PalICZ_1).l,a0
		move.w	($FFFFF632).w,d0
		addq.w	#4,($FFFFF632).w
		cmpi.w	#$40,($FFFFF632).w
		bcs.s	loc_2476
		move.w	#0,($FFFFF632).w

loc_2476:
		move.l	(a0,d0.w),($FFFFFC5C).w

loc_247C:
		subq.w	#1,($FFFFF658).w
		bpl.s	loc_24B0
		move.w	#9,($FFFFF658).w
		lea	(AnPal_PalICZ_2).l,a0
		move.w	($FFFFF652).w,d0
		addq.w	#4,($FFFFF652).w
		cmpi.w	#$48,($FFFFF652).w
		bcs.s	loc_24A4
		move.w	#0,($FFFFF652).w

loc_24A4:
		tst.w	($FFFFEEE8).w
		beq.s	loc_24B0
		move.l	(a0,d0.w),($FFFFFC7C).w

loc_24B0:
		subq.w	#1,($FFFFF65A).w
		bpl.s	locret_2506
		move.w	#7,($FFFFF65A).w
		lea	(AnPal_PalICZ_3).l,a0
		move.w	($FFFFF654).w,d0
		addq.w	#4,($FFFFF654).w
		cmpi.w	#$18,($FFFFF654).w
		bcs.s	loc_24D8
		move.w	#0,($FFFFF654).w

loc_24D8:
		tst.w	($FFFFEEE8).w
		beq.s	loc_24E4
		move.l	(a0,d0.w),($FFFFFC78).w

loc_24E4:
		lea	(AnPal_PalICZ_4).l,a0
		move.w	($FFFFF656).w,d0
		addq.w	#4,($FFFFF656).w
		cmpi.w	#$40,($FFFFF656).w
		bcs.s	loc_2500
		move.w	#0,($FFFFF656).w

loc_2500:
		move.l	(a0,d0.w),($FFFFFC58).w

locret_2506:
		rts
; ---------------------------------------------------------------------------

AnPal_LBZ1:
		lea	(AnPal_PalLBZ1).l,a0
		bra.s	loc_2516
; ---------------------------------------------------------------------------

AnPal_LBZ2:
		lea	(AnPal_PalLBZ2).l,a0

loc_2516:
		subq.w	#1,($FFFFF634).w
		bpl.s	locret_2544
		move.w	#3,($FFFFF634).w
		move.w	($FFFFF632).w,d0
		addq.w	#6,($FFFFF632).w
		cmpi.w	#$12,($FFFFF632).w
		bcs.s	loc_2538
		move.w	#0,($FFFFF632).w

loc_2538:
		move.l	(a0,d0.w),($FFFFFC50).w
		move.w	4(a0,d0.w),($FFFFFC54).w

locret_2544:
		rts
; ---------------------------------------------------------------------------

AnPal_SOZ1:
		subq.w	#1,($FFFFF65A).w
		bpl.s	locret_257A
		move.w	#5,($FFFFF65A).w
		lea	(AnPal_PalSOZ1).l,a0
		move.w	($FFFFF654).w,d0
		addq.w	#8,($FFFFF654).w
		cmpi.w	#$20,($FFFFF654).w
		bcs.s	loc_256E
		move.w	#0,($FFFFF654).w

loc_256E:
		move.l	(a0,d0.w),($FFFFFC58).w
		move.l	4(a0,d0.w),($FFFFFC5C).w

locret_257A:
		rts
; ---------------------------------------------------------------------------
		move.w	#$383,($FFFFF634).w
		move.b	#0,($FFFFF7C3).w
		move.w	($FFFFF656).w,d0
		neg.b	d0
		move.b	d0,($FFFFF650).w
		move.w	#0,($FFFFF658).w

AnPal_SOZ2:
		subq.w	#1,($FFFFF634).w
		bpl.s	loc_25C4

loc_259E:
		move.w	#$383,($FFFFF634).w
		cmpi.b	#5,($FFFFF7C3).w
		bcc.s	loc_25C4
		addq.b	#1,($FFFFF7C3).w
		btst	#0,($FFFFF7C3).w
		bne.s	loc_25C4
		move.b	#2,($FFFFF650).w
		move.w	#0,($FFFFF658).w

loc_25C4:
		tst.b	($FFFFF650).w
		beq.s	loc_262C
		subq.w	#1,($FFFFF658).w
		bpl.s	loc_262C
		move.w	#3,($FFFFF658).w
		tst.b	($FFFFF650).w
		bmi.s	loc_25EC
		subq.b	#1,($FFFFF650).w
		addi.w	#$34,($FFFFF652).w
		addq.w	#1,($FFFFF656).w
		bra.s	loc_25FA
; ---------------------------------------------------------------------------

loc_25EC:
		addq.b	#1,($FFFFF650).w
		subi.w	#$34,($FFFFF652).w
		subq.w	#1,($FFFFF656).w

loc_25FA:
		move.w	($FFFFF652).w,d0
		lea	(AnPal_PalSOZ2_Light).l,a0
		lea	(a0,d0.w),a0
		lea	($FFFFFC42).w,a1
		moveq	#$A,d0

loc_260E:
		move.w	(a0)+,(a1)+
		dbf	d0,loc_260E
		lea	($FFFFFC62).w,a1
		moveq	#$E,d0

loc_261A:
		move.w	(a0)+,(a1)+
		dbf	d0,loc_261A
		move.w	($FFFFF654).w,d0
		subq.w	#1,($FFFFF65A).w
		bpl.s	loc_264E
		bra.s	loc_2632
; ---------------------------------------------------------------------------

loc_262C:
		subq.w	#1,($FFFFF65A).w
		bpl.s	locret_266A

loc_2632:
		move.w	#5,($FFFFF65A).w
		move.w	($FFFFF654).w,d0
		addq.w	#8,($FFFFF654).w
		cmpi.w	#$20,($FFFFF654).w
		bcs.s	loc_264E
		move.w	#0,($FFFFF654).w

loc_264E:
		lea	(AnPal_PalSOZ1).l,a0
		move.w	($FFFFF656).w,d1
		lsl.w	#5,d1
		lea	(a0,d1.w),a0
		move.l	(a0,d0.w),($FFFFFC58).w
		move.l	4(a0,d0.w),($FFFFFC5C).w

locret_266A:
		rts
; ---------------------------------------------------------------------------

AnPal_LRZ1:
		subq.w	#1,($FFFFF634).w
		bpl.s	loc_26C2
		move.w	#$F,($FFFFF634).w
		move.w	($FFFFF632).w,d0
		addq.w	#8,($FFFFF632).w
		cmpi.w	#$80,($FFFFF632).w
		bcs.s	loc_268E
		move.w	#0,($FFFFF632).w

loc_268E:
		lea	(AnPal_PalLRZ12_1).l,a0
		move.l	(a0,d0.w),($FFFFFC42).w
		move.l	4(a0,d0.w),($FFFFFC46).w
		move.w	($FFFFF652).w,d0
		addq.w	#4,($FFFFF652).w
		cmpi.w	#$1C,($FFFFF652).w
		bcs.s	loc_26B6
		move.w	#0,($FFFFF652).w

loc_26B6:
		lea	(AnPal_PalLRZ12_2).l,a0
		move.l	(a0,d0.w),($FFFFFC62).w

loc_26C2:
		subq.w	#1,($FFFFF658).w
		bpl.s	locret_26F0
		move.w	#7,($FFFFF658).w
		move.w	($FFFFF654).w,d0
		addq.w	#2,($FFFFF654).w
		cmpi.w	#$22,($FFFFF654).w
		bcs.s	loc_26E4
		move.w	#0,($FFFFF654).w

loc_26E4:
		lea	(AnPal_PalLRZ1_3).l,a0
		move.w	(a0,d0.w),($FFFFFC56).w

locret_26F0:
		rts
; ---------------------------------------------------------------------------

AnPal_LRZ2:
		subq.w	#1,($FFFFF634).w
		bpl.s	loc_2748
		move.w	#$F,($FFFFF634).w
		move.w	($FFFFF632).w,d0
		addq.w	#8,($FFFFF632).w
		cmpi.w	#$80,($FFFFF632).w
		bcs.s	loc_2714
		move.w	#0,($FFFFF632).w

loc_2714:
		lea	(AnPal_PalLRZ12_1).l,a0
		move.l	(a0,d0.w),($FFFFFC42).w
		move.l	4(a0,d0.w),($FFFFFC46).w
		move.w	($FFFFF652).w,d0
		addq.w	#4,($FFFFF652).w
		cmpi.w	#$1C,($FFFFF652).w
		bcs.s	loc_273C
		move.w	#0,($FFFFF652).w

loc_273C:
		lea	(AnPal_PalLRZ12_2).l,a0
		move.l	(a0,d0.w),($FFFFFC62).w

loc_2748:
		subq.w	#1,($FFFFF658).w
		bpl.s	locret_277C
		move.w	#$F,($FFFFF658).w
		move.w	($FFFFF654).w,d0
		addq.w	#8,($FFFFF654).w
		cmpi.w	#$100,($FFFFF654).w
		bcs.s	loc_276A
		move.w	#0,($FFFFF654).w

loc_276A:
		lea	(AnPal_PalLRZ2_3).l,a0
		move.l	(a0,d0.w),($FFFFFC76).w
		move.l	(a0,d0.w),($FFFFFC7A).w

locret_277C:
		rts
; ---------------------------------------------------------------------------

AnPal_DEZ1:
		subq.w	#1,($FFFFF65A).w
		bpl.s	AnPal_DEZ2
		move.w	#$F,($FFFFF65A).w
		move.w	($FFFFF654).w,d0
		addq.w	#8,($FFFFF654).w
		cmpi.w	#$30,($FFFFF654).w
		bcs.s	loc_27A0
		move.w	#0,($FFFFF654).w

loc_27A0:
		lea	(AnPal_PalDEZ1).l,a0
		move.l	(a0,d0.w),($FFFFFC78).w
		move.l	4(a0,d0.w),($FFFFFC7C).w

AnPal_DEZ2:
		subq.w	#1,($FFFFF634).w
		bpl.s	loc_27E0
		move.w	#4,($FFFFF634).w
		move.w	($FFFFF632).w,d0
		addq.w	#4,($FFFFF632).w
		cmpi.w	#$30,($FFFFF632).w
		bcs.s	loc_27D4
		move.w	#0,($FFFFF632).w

loc_27D4:
		lea	(AnPal_PalDEZ12_1).l,a0
		move.l	(a0,d0.w),($FFFFFC5A).w

loc_27E0:
		subq.w	#1,($FFFFF658).w
		bpl.s	locret_2818
		move.w	#$13,($FFFFF658).w
		move.w	($FFFFF652).w,d0
		addi.w	#$A,($FFFFF652).w
		cmpi.w	#$28,($FFFFF652).w
		bcs.s	loc_2804
		move.w	#0,($FFFFF652).w

loc_2804:
		lea	(AnPal_PalDEZ12_2).l,a0
		lea	(a0,d0.w),a0
		lea	($FFFFFC50).w,a1
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		move.w	(a0)+,(a1)+

locret_2818:
		rts
; ---------------------------------------------------------------------------

AnPal_BPZ:
		subq.w	#1,($FFFFF634).w
		bpl.s	loc_284E
		move.w	#7,($FFFFF634).w

loc_2826:
		lea	(AnPal_PalBPZ_1).l,a0
		move.w	($FFFFF632).w,d0
		addq.w	#6,($FFFFF632).w
		cmpi.w	#$12,($FFFFF632).w
		bcs.s	loc_2842
		move.w	#0,($FFFFF632).w

loc_2842:
		move.l	(a0,d0.w),($FFFFFC5A).w
		move.w	4(a0,d0.w),($FFFFFC5E).w

loc_284E:
		subq.w	#1,($FFFFF658).w
		bpl.s	locret_2882
		move.w	#$11,($FFFFF658).w
		lea	(AnPal_PalBPZ_2).l,a0
		move.w	($FFFFF652).w,d0
		addq.w	#6,($FFFFF652).w
		cmpi.w	#$7E,($FFFFF652).w
		bcs.s	loc_2876
		move.w	#0,($FFFFF652).w

loc_2876:
		move.l	(a0,d0.w),($FFFFFC64).w
		move.w	4(a0,d0.w),($FFFFFC68).w

locret_2882:
		rts
; ---------------------------------------------------------------------------

AnPal_CGZ:
		subq.w	#1,($FFFFF634).w
		bpl.s	locret_28B8
		move.w	#9,($FFFFF634).w
		lea	(AnPal_PalCGZ).l,a0
		move.w	($FFFFF632).w,d0
		addq.w	#8,($FFFFF632).w
		cmpi.w	#$50,($FFFFF632).w
		bcs.s	loc_28AC
		move.w	#0,($FFFFF632).w

loc_28AC:
		move.l	(a0,d0.w),($FFFFFC44).w
		move.l	4(a0,d0.w),($FFFFFC48).w

locret_28B8:
		rts
; ---------------------------------------------------------------------------

AnPal_EMZ:
		subq.w	#1,($FFFFF634).w
		bpl.s	loc_28E8
		move.w	#7,($FFFFF634).w
		lea	(AnPal_PalEMZ_1).l,a0
		move.w	($FFFFF632).w,d0
		addq.w	#2,($FFFFF632).w
		cmpi.w	#$3C,($FFFFF632).w
		bcs.s	loc_28E2
		move.w	#0,($FFFFF632).w

loc_28E2:
		move.w	4(a0,d0.w),($FFFFFC5C).w

loc_28E8:
		subq.w	#1,($FFFFF658).w
		bpl.s	locret_2916
		move.w	#$1F,($FFFFF658).w
		lea	(AnPal_PalEMZ_2).l,a0
		move.w	($FFFFF652).w,d0
		addq.w	#4,($FFFFF652).w
		cmpi.w	#$34,($FFFFF652).w
		bcs.s	loc_2910
		move.w	#0,($FFFFF652).w

loc_2910:
		move.l	(a0,d0.w),($FFFFFC72).w

locret_2916:
		rts
; ---------------------------------------------------------------------------

AnPal_Pachinko:
		subq.w	#1,($FFFFF634).w
		bpl.s	loc_2952
		move.w	#0,($FFFFF634).w
		move.w	($FFFFF632).w,d0
		addi.w	#$E,($FFFFF632).w
		cmpi.w	#$FC,($FFFFF632).w
		bcs.s	loc_293C
		move.w	#0,($FFFFF632).w

loc_293C:
		lea	($FFFF7800).l,a0
		lea	($FFFFFC70).w,a1
		lea	(a0,d0.w),a0
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		move.w	(a0)+,(a1)+

loc_2952:
		subq.w	#1,($FFFFF658).w
		bpl.s	locret_29A6
		move.w	#3,($FFFFF658).w
		move.w	($FFFFF652).w,d0
		addi.w	#$A,($FFFFF652).w
		cmpi.w	#$3E8,($FFFFF652).w
		bcs.s	loc_2976
		move.w	#0,($FFFFF652).w

loc_2976:
		lea	($FFFF78FC).l,a0
		lea	($FFFFFC42).w,a1
		lea	(a0,d0.w),a0
		move.l	$50(a0),(a1)+
		move.l	$54(a0),(a1)+
		move.w	$58(a0),(a1)+
		move.l	$28(a0),(a1)+
		move.l	$2C(a0),(a1)+
		move.w	$30(a0),(a1)+
		move.l	(a0),(a1)+
		move.l	4(a0),(a1)+
		move.w	8(a0),(a1)+

locret_29A6:
		rts
; ---------------------------------------------------------------------------

AnPal_Slots:
		tst.b	($FFFFF650).w
		bmi.s	locret_29F0
		bne.s	loc_29F2
		subq.w	#1,($FFFFF634).w
		bpl.s	locret_29F0
		move.w	#3,($FFFFF634).w
		move.w	($FFFFF632).w,d0
		addq.w	#8,($FFFFF632).w
		cmpi.w	#$40,($FFFFF632).w
		bcs.s	loc_29D2
		move.w	#0,($FFFFF632).w

loc_29D2:
		lea	(AnPal_PalSlots_1).l,a0
		move.l	(a0,d0.w),($FFFFFC54).w
		move.l	4(a0,d0.w),($FFFFFC58).w
		move.w	#$E02,($FFFFFC5C).w
		move.w	#$E02,($FFFFFC7C).w

locret_29F0:

		rts
; ---------------------------------------------------------------------------

loc_29F2:
		subq.w	#1,($FFFFF658).w
		bpl.s	locret_2A4E
		move.w	#0,($FFFFF658).w
		move.w	($FFFFF652).w,d0
		addq.w	#8,($FFFFF652).w
		cmpi.w	#$78,($FFFFF652).w
		bcs.s	loc_2A14
		move.w	#0,($FFFFF652).w

loc_2A14:
		lea	(AnPal_PalSlots_2).l,a0
		move.l	(a0,d0.w),($FFFFFC54).w
		move.l	4(a0,d0.w),($FFFFFC58).w
		move.w	($FFFFF654).w,d0
		addq.w	#2,($FFFFF654).w
		cmpi.w	#$C,($FFFFF654).w
		bcs.s	loc_2A3C
		move.w	#0,($FFFFF654).w

loc_2A3C:
		lea	(AnPal_PalSlots_3).l,a0
		move.w	(a0,d0.w),($FFFFFC5C).w
		move.w	(a0,d0.w),($FFFFFC7C).w

locret_2A4E:
		rts
; ---------------------------------------------------------------------------

AnPal_LRZ3:
		tst.b	($FFFFF650).w
		bmi.s	locret_2ABE
		subq.w	#1,($FFFFF634).w
		bpl.s	loc_2A8A
		move.w	#$F,($FFFFF634).w
		move.w	($FFFFF632).w,d0
		addq.w	#8,($FFFFF632).w
		cmpi.w	#$80,($FFFFF632).w
		bcs.s	loc_2A78
		move.w	#0,($FFFFF632).w

loc_2A78:
		lea	(AnPal_PalLRZ12_1).l,a0
		move.l	(a0,d0.w),($FFFFFC42).w
		move.l	4(a0,d0.w),($FFFFFC46).w

loc_2A8A:
		tst.b	($FFFFF650).w
		beq.s	locret_2ABE
		subq.w	#1,($FFFFF658).w
		bpl.s	locret_2ABE
		move.w	#7,($FFFFF658).w
		move.w	($FFFFF654).w,d0
		addq.w	#4,($FFFFF654).w
		cmpi.w	#$3C,($FFFFF654).w
		bcs.s	loc_2AB2
		move.w	#0,($FFFFF654).w

loc_2AB2:
		lea	(AnPal_PalLRZ3).l,a0
		move.l	(a0,d0.w),($FFFFFC78).w

locret_2ABE:

		rts
; ---------------------------------------------------------------------------

AnPal_HPZ_A:
		tst.b	($FFFFF650).w
		bne.s	locret_2AF4
		subq.w	#1,($FFFFF634).w
		bpl.s	locret_2AF4
		move.w	#7,($FFFFF634).w
		move.w	($FFFFF632).w,d0
		addq.w	#4,($FFFFF632).w
		cmpi.w	#$28,($FFFFF632).w
		bcs.s	loc_2AE8
		move.w	#0,($FFFFF632).w

loc_2AE8:
		lea	(AnPal_PalHPZ).l,a0
		move.l	(a0,d0.w),($FFFFFC62).w

locret_2AF4:

		rts
; ---------------------------------------------------------------------------
AnPal_PalAIZ1_1:	dc.w $EE8,$EE2,$EA4,$E64,$EE2,$EA4,$E64,$EE8,$EA4,$E64,$EE8,$EE2,$E64,$EE8,$EE2,$EA4

AnPal_PalAIZ1_3:	dc.w $EEC,$EEE,$EE8,$E40,$EEC,$EE8,$EE8,$EEE,$EEA,$E86,$EE8,$EE8,$EE8,$E40,$EE8,$E86
					dc.w $EE6,$EEE,$EE8,$E40,$EEA,$EE8,$EE8,$EEE,$EE8,$E86,$EE8,$EE8,$EE8,$E40,$EE8,$E86
					dc.w $EE6,$EEE,$EE8,$E40,$EE8,$EE8,$EE8,$EEE,$EEA,$E86,$EE8,$EE8,$EEC,$E40,$EE8,$E86
					dc.w $EEC,$EEE,$EE8,$E40,$EEC,$EE8,$EE8,$EEE,$EEC,$E86,$EE8,$EE8,$EEC,$E40,$EE8,$E86

AnPal_PalAIZ1_4:	dc.w $CEC,$CEE,$EEE,$CEE,$EEE,$EEE,$EEE,$EEE,$EEE,$EEE,$EEE,$EEE,$EEE,$EEE,$EEE,$EEE
					dc.w $EEE,$EEE,$EEE,$EEE,$EEE,$EE8,$EEE,$EEE,$EE8,$EE8,$EEE,$EE8,$EE8,$EE8,$EE8,$EE8
					dc.w $EE8,$EE8,$EE8,$EE8,$EE8,$EE8,$EE8,$EE8,$EE8,$AEC,$EE8,$AEC,$CEC,$AEC,$CEC,$CEC

AnPal_PalAIZ1_2:	dc.w $EA4,$E60,$EE2,$EA4,$EE8,$EA4,$E60,$EE8,$EEE,$E60,$EE2,$EE2,$EE8,$EA4,$EA4,$EE2
					dc.w $E60,$E60,$EE2,$E60,$EEE,$EE2,$E60,$EE8

AnPal_PalAIZ2_1:	dc.w $EE8,$EE2,$EC4,$EA4,$EE2,$EC4,$EA4,$EE8,$EC4,$EA4,$EE8,$EE2,$EA4,$EE8,$EE2,$EC4

AnPal_PalAIZ2_2:	dc.w  $24, $44,	$8E, $26, $46, $AE, $24, $48, $8E, $26,	$4A, $AE, $24, $4C, $8E, $26
					dc.w  $4A, $AE,	$24, $48, $8E, $24, $46, $8E

AnPal_PalAIZ2_3:	dc.w  $24, $44,	 $C, $26, $46,	$E, $24, $48,  $C, $26,	$4A,  $E, $24, $4C,  $C, $26
					dc.w  $4A,  $E,	$24, $48,  $C, $24, $46,  $C

AnPal_PalAIZ2_4:	dc.w  $6E, $6E,	$6E, $6E,$28E,$4AE,$6AE,$8CE,$8EE,$AEE,$AEE,$AEE,$AEE,$AEE,$8EE,$8EE
					dc.w $8EE,$8EE,$8CE,$8CE,$8CE,$6AE,$6AE,$4AE,$4AE,$28E

AnPal_PalAIZ2_5:	dc.w   $C,  $C,	 $C,  $C, $2C,	$E, $2E, $4E, $6E, $8E,	$8E, $8E, $8E, $8E, $6E, $4E
					dc.w  $4E, $4E,	$2E, $2E, $2E,	$E,  $E, $2C, $2C, $2C

AnPal_PalHCZ1:	dc.w $EC8,$EC0,$EA0,$E80,$EC0,$EA0,$E80,$EC8,$EA0,$E80,$EC8,$EC0,$E80,$EC8,$EC0,$EA0

AnPal_PalCNZ_1:	dc.w	0, $66,	$EE, $22, $44, $CC, $44, $22, $AA, $66,	  0, $88, $88,	 0, $66, $AA
				dc.w  $22, $44,	$CC, $44, $22, $EE, $66,   0, $EE, $88,	  0, $CC, $AA, $22, $AA, $CC
				dc.w  $44, $88,	$EE, $66, $66, $EE, $88, $44, $CC, $AA,	$22, $AA, $CC,	 0, $88, $EE

AnPal_PalCNZ_3:	dc.w $E20, $8A,$C0E,$C42, $6C,$E0E,$A64, $4C,$E0C,$884,	$2E,$E0A,$6A6,	$E,$E08,$4C6
				dc.w $20E,$E06,$2E8,$40E,$E04, $E8,$60E,$E02, $C8,$80E,$E00, $AA,$A0E,$E00, $8A,$C0E
				dc.w $E20, $6C,$E0E,$C42, $4C,$E0C,$A64, $2E,$E0A,$884,	 $E,$E08,$6A6,$20E,$E06,$4C6
				dc.w $40E,$E04,$2E8,$60E,$E02, $E8,$80E,$E00, $C8,$A0E,$E00, $AA,$C0E,$E20, $8A,$E0E
				dc.w $C42, $6C,$E0C,$A64, $4C,$E0A,$884, $2E,$E08,$6A6,	 $E,$E06,$4C6,$20E,$E04,$2E8
				dc.w $40E,$E02,	$E8,$60E,$E00, $C8,$80E,$E00, $AA,$A0E

AnPal_PalCNZ_5:	dc.w $2E0,$ECE,$4E2,$EAC,$6E4,$E8A,$8E6,$E68,$AE8,$E46,$CEA,$E24,$EEC,$E02,$EEE,$E00
				dc.w $EEC,$E02,$CEA,$E24,$AE8,$E46,$8E6,$E68,$6E4,$E8A,$4E2,$EAC,$2E0,$ECE, $E0,$EEE

AnPal_PalCNZ_2:	dc.w $800,$800,$886,$800,$800,$864,$800,$800,$842,$800,$800,$820,$820,$800,$800,$842
				dc.w $800,$800,$864,$800,$800,$886,$800,$800,$886,$820,$800,$864,$842,$800,$842,$864
				dc.w $800,$820,$886,$800,$800,$886,$820,$800,$864,$842,$800,$842,$864,$800,$820,$886

AnPal_PalCNZ_4:	dc.w $E20,$E8A,$E0A,$E42,$E6A,$E0A,$E64,$E4A,$E0A,$E84,$E2A,$E0A,$EA6,$E0A,$E08,$EC6
				dc.w $E0A,$E06,$EE8,$E0A,$E04,$EE8,$E0A,$E02,$EC8,$E0A,$E00,$EAA,$E0A,$E00,$E8A,$E0A
				dc.w $E20,$E6A,$E0A,$C42,$E4A,$E0A,$E64,$E2A,$E0A,$E84,$E0A,$E08,$EA6,$E0A,$E06,$EC6
				dc.w $E0A,$E04,$EE8,$E0A,$E02,$EE8,$E0A,$E00,$EC8,$E0A,$E00,$EAA,$E0A,$E20,$E8A,$E0A
				dc.w $E42,$E6A,$E0A,$E64,$E4A,$E0A,$E84,$E2A,$E08,$EA6,$E0A,$E06,$EC6,$E0A,$E04,$EE8
				dc.w $E0A,$E02,$EE8,$E0A,$E00,$EC8,$E0A,$E00,$EAA,$E0A,$840,$ECA,$862,$EAA,$884,$E88
				dc.w $8A6,$E66,$AE8,$E44,$CEA,$E22,$EEC,$E00,$EEC,$E00,$EEC,$E00,$CEA,$E22,$AE8,$E44
				dc.w $8A6,$E66,$884,$E88,$862,$EAA,$840,$ECA,$822,$ECA

AnPal_PalICZ_1:	dc.w $E62,$E20,$E44,$E20,$E44,$E00,$E42,$E00,$E62,$C00,$E82,$A00,$EA2,$C00,$EC0,$E00
				dc.w $EE0,$E20,$EE4,$E00,$EE4,$C00,$EE4,$A00,$EE0,$800,$EC2,$A00,$EA2,$C00,$E82,$E20

AnPal_PalICZ_2:	dc.w $E06,$E08,$E04,$E06,$C04,$E04,$C02,$C04,$A02,$C02,$A00,$A02,$800,$A00,$600,$800
				dc.w $600,$800,$600,$800,$600,$800,$800,$A00,$A00,$A02,$A02,$C02,$C02,$C04,$C04,$E04
				dc.w $E04,$E06,$E06,$E08

AnPal_PalICZ_3:	dc.w $840,$EEA,$860,$EE0,$A80,$EC0,$EC0,$A80,$A80,$EC0,$860,$EE0

AnPal_PalICZ_4:	dc.w  $E8,$CEC,	$C8,$AEA, $C8,$AEA, $A6,$6E8, $A6,$6E8,	$84, $E8, $84, $E8, $82, $C8
				dc.w  $64, $A6,	$64, $A6, $82, $C8, $84, $E8, $A6,$6E8,	$C8,$AEA, $E8,$CEC, $E8,$CEC

AnPal_PalLBZ1:	dc.w $8E0, $C0,	$80, $C0, $80,$8E0, $80,$8E0, $C0

AnPal_PalLBZ2:	dc.w $EEA,$EA4,$C62,$EA4,$C62,$EEA,$C62,$EEA,$EA4

AnPal_PalSOZ1:	dc.w $2CE,$6CE,	$AE, $6C, $6C,$2CE,$6CE, $AE, $AE, $6C,$2CE,$6CE,$6CE, $AE, $6C,$2CE
				dc.w $28A,$6AC,	$8A, $48, $48,$28A,$6AC, $8A, $8A, $48,$28A,$6AC,$6AC, $8A, $48,$28A
				dc.w $468,$668,$248, $26, $26,$468,$668,$248,$248, $26,$468,$668,$668,$248, $26,$468
				dc.w $424,$846,$224,$222,$222,$424,$846,$224,$224,$222,$424,$846,$846,$224,$222,$424
				dc.w $602,$824,$402,$200,$200,$602,$824,$402,$402,$200,$602,$824,$824,$402,$200,$602

AnPal_PalSOZ2_Light:	dc.w $EEE

AnPal_PalSOZ2_Light_2:	dc.w $8EE,$4EE,	$CE,$24C,   6,	 0,$CEA,$886,$424, $E0,$EEE,$AEE,$6EE,$4AC, $68, $46
						dc.w  $22,$8AA,$468,$224,   2,$28E,$4EE, $8C,  $C,$8CE,$6CC,$4AC, $8A,$248,   4,   0
						dc.w $8A8,$664,$422, $80,$CEE,$ACC,$6CC,$48A,$266, $46,	$22,$ACC,$468,$224,   2,$28E
						dc.w $6EE,$28C,$22C,$2CE,$28A,$268,$246,$224,$202,   0,$464,$222,$200, $40,$ACE,$8AA
						dc.w $688,$468,$244, $24, $22,$CCC,$468,$224,	2,$26C,$6EE,$28C,$24C,$88A,$668,$646
						dc.w $424,$224,$202,   0,$444,$222,$200, $40,$8CE,$888,$666,$446,$222, $22, $22,$EEE
						dc.w $468,$224,	  2,$26A,$6EE,$48C,$26C,$C46,$824,$804,$402,$202,$200,	 0,$422,$402
						dc.w $200, $40,$6AE,$664,$422,$402,$200,   0,	0,$EEE,$466,$224,   0, $46,$6EE,$48C
						dc.w $26A

AnPal_PalLRZ12_1:	dc.w  $EE, $AE,	$6E,  $E, $AE, $6E,  $E, $EE, $6E,  $E,	$EE,$2CE, $2E,$8EE,$4EE, $6E
					dc.w $AEE,$6EE,	$8E, $4E,$4EE, $6E, $2E,$8EE, $6E,  $E,	$EE,$2CE,  $E, $EE,$2CE, $6E
					dc.w  $EE, $AE,	$6E,  $E, $8E, $4E,  $C, $CE, $2E,  $A,	$AC, $6E,   8, $8E, $4C,  $C
					dc.w  $AC, $6E,	$2E,  $A, $8E, $4E,  $C, $CE, $6E,  $E,	$EE, $AE,  $E, $EE, $AE, $6E

AnPal_PalLRZ12_2:	dc.w $224,$224,$224,$424,$224,$426,$426,$224,$424,$224,$224,$224,$224,$224,$224,$422
					dc.w $422,$422

AnPal_PalLRZ1_3:	dc.w $624,$624,$624,$624,$624,$624,$626,$626,$826,$826,$826,$826,$826,$826,$826,$626
					dc.w $626

AnPal_PalLRZ2_3:	dc.w $824,$C44,$E2A,$EAE,$824,$C44,$E2A,$EAE,$824,$C44,$E2A,$EAE,$824,$C44,$E48,$EAC
					dc.w $822,$C44,$E66,$EAA,$822,$C44,$E66,$EAA,$822,$C44,$E66,$EAA,$842,$C64,$EA4,$EC6
					dc.w $642,$A82,$CC2,$EE0,$642,$A82,$CC2,$EE0,$642,$A82,$CC2,$EE0,$642,$882,$AC2,$CE0
					dc.w $642,$682,$8C2,$8E0,$642,$682,$8C2,$8E0,$642,$682,$8C2,$8E0,$642,$486,$4C8,$4E8
					dc.w $442,$288,$2CA,$2EC,$442,$288,$2CC,$2EE,$442,$288,$2CA,$2EC,$642,$486,$4C8,$4E8
					dc.w $642,$682,$8C2,$8E0,$642,$882,$AC2,$CE0,$642,$A82,$CC2,$EE0,$842,$C64,$EA4,$EC6
					dc.w $822,$C44,$E66,$EAA,$824,$C44,$E48,$EAC,$824,$C44,$E2A,$EAE,$826,$C46,$E4A,$E8E
					dc.w $624,$A48,$C6C,$E6E,$624,$A48,$C6C,$E6E,$624,$A48,$C6C,$E6E,$826,$C46,$E4A,$E8E

AnPal_PalDEZ12_1:	dc.w  $E0,   0,	  0,$E0E,$E00,	 0,   0, $EE,  $E,   0,	  0,$EE0,$EE0,	 0,   0,  $E
					dc.w  $EE,   0,	  0,$E00,$E0E,	 0,   0, $E0

AnPal_PalDEZ12_2:	dc.w  $8E, $6C,	$4A, $28,$6AE,$28C,$26A, $4A,$226,$4AC,$48A,$468,$248,$424,$4AA,$28C
					dc.w $26A, $4A,$226,$4AC

AnPal_PalDEZ1:	dc.w $8AC,$68A,$468,$246,$246,$8AC,$68A,$468,$468,$246,$8AC,$68A,$68A,$468,$246,$8AC
				dc.w $468,$246,$8AC,$68A,$246,$8AC,$68A,$468

AnPal_PalBPZ_1:	dc.w  $EE, $AE,	$6C, $AE, $6E, $EE, $6E, $EE, $AE

AnPal_PalBPZ_2:	dc.w $EE0,$E0E,	$EE,$EA0,$A0E, $EA,$E60,$60E, $E6,$E20,$20E, $E2,$E02, $2E,$2E0,$E06
				dc.w  $6E,$6E0,$E0A, $AE,$AE0,$E0E, $EE,$EE0,$A0E, $EA,$EA0,$60E, $E6,$E60,$20E, $E2
				dc.w $E20, $2E,$2E0,$E02, $6E,$6E0,$E06, $AE,$AE0,$E0A,	$EE,$EE0,$E0E, $EA,$EA0,$A0E
				dc.w  $E6,$E60,$60E, $E2,$E20,$20E,$2E0,$E02, $2E,$6E0,$E06, $6E,$AE0,$E0A, $AE

AnPal_PalCGZ:	dc.w   $E,   8,	  4,$EEE,  $C,	 6,   2,$CCE,  $A,   4,	  0,$AAE,   8,	 2,   0,$88E
				dc.w	6,   0,	  0,$66E,   4,	 0,   0,$44E,	6,   0,	  0,$66E,   8,	 2,   0,$88E
				dc.w   $A,   4,	  2,$AAE,  $C,	 6,   4,$CCE

AnPal_PalEMZ_1:	dc.w	6,   8,	 $A,  $C,  $E,	$E,  $E,  $E,  $C,  $A,	  8,   6,   6,	 6,   6,   8
				dc.w   $A,  $C,	 $E,  $E,  $E,	$C,  $A,   8,	6,   8,	 $A,  $A,  $A,	 8

AnPal_PalEMZ_2:	dc.w	0,  $E,	  2,  $C,   4,	$A,   6,   8,	8,   6,	 $A,   4,  $C,	 2,  $E,   0
				dc.w   $C,   2,	 $A,   4,   8,	 6,   6,   8,	4,  $A,	  2,  $C

AnPal_PalSlots_1:	dc.w  $46,$488,$2EE, $8A, $68,$26A,$EEE, $AC, $8A, $46,$488,$2EE, $AC, $68,$26A,$EEE
					dc.w $2EE, $8A,	$46,$488,$EEE, $AC, $68,$26A,$48A,$2EE,	$8A, $46,$268,$EEE, $AC, $68

AnPal_PalSlots_2:	dc.w $268,$EEE,	$AC, $68,$EEE,$EEE,$EEE,$EEE,$48A,$2EE,	$8A, $46, $EE, $EE, $EE, $EE
					dc.w $EEE, $AC,	$68,$26A,$EEE,$EEE,$EEE,$EEE,$2EE, $8A,	$46,$488,$E0E,$E0E,$E0E,$E0E
					dc.w  $AC, $68,$26A,$EEE,$EEE,$EEE,$EEE,$EEE, $8A, $46,$488,$2EE,$EE0,$EE0,$EE0,$EE0
					dc.w  $68,$26A,$EEE, $AC,$EEE,$EEE,$EEE,$EEE, $46,$488,$2EE, $8A, $E0, $E0, $E0, $E0

AnPal_PalSlots_3:	dc.w $E02,$E24,$E46,$E68,$E8A,$EAC

AnPal_PalLRZ3:	dc.w $424, $AE,$424, $AE,$424, $AE,$426, $8E,$428, $6E,$42A, $4E,$42C, $2E,$42E,  $E
				dc.w $42E,  $E,$42E,  $E,$42C, $2E,$42A, $4E,$428, $6E,$426, $8E,$424, $AE

AnPal_PalHPZ:	dc.w   $E,  $A,	 $E,  $A,  $E,	$A,  $E,  $A,  $C,   8,	 $A,   6,   8,	 4,   8,   4
				dc.w   $A,   6,	 $C,   8

; =============== S U B R O U T I N E =======================================


SuperSonic_PalFlash:

		move.b	($FFFFF65F).w,d0
		beq.w	locret_37EC
		bmi.w	loc_3854
		subq.b	#1,d0
		bne.w	loc_37EE
		subq.b	#1,($FFFFF65E).w
		bpl.w	locret_37EC
		move.b	#1,($FFFFF65E).w
		cmpi.w	#2,($FFFFFF08).w
		bcs.s	loc_3792
		move.b	#-1,($FFFFF65F).w
		move.w	#0,($FFFFF65C).w
		move.b	#0,($FFFFF668).w
		move.b	#0,($FFFFB02E).w
		rts
; ---------------------------------------------------------------------------

loc_3792:
		lea	(AnPal_SuperSonic_1).l,a0
		move.w	($FFFFF65C).w,d0
		addq.w	#6,($FFFFF65C).w
		cmpi.w	#$24,($FFFFF65C).w
		bcs.s	loc_37B4
		move.b	#-1,($FFFFF65F).w
		move.b	#0,($FFFFB02E).w

loc_37B4:
		lea	($FFFFFC04).w,a1
		move.l	(a0,d0.w),(a1)+
		move.w	4(a0,d0.w),(a1)
		tst.b	($FFFFF730).w
		beq.s	locret_37EC
		lea	(AnPal_SuperSonic_2).l,a0
		tst.b	($FFFFFE10).w
		beq.s	loc_37E0
		cmpi.b	#5,($FFFFFE10).w
		beq.s	loc_37E0
		lea	(AnPal_SuperSonic_3).l,a0

loc_37E0:
		lea	($FFFFF084).w,a1
		move.l	(a0,d0.w),(a1)+
		move.w	4(a0,d0.w),(a1)

locret_37EC:
		rts
; ---------------------------------------------------------------------------

loc_37EE:
		cmpi.w	#2,($FFFFFF08).w
		bcc.s	loc_3820
		subq.b	#1,($FFFFF65E).w
		bpl.s	locret_37EC
		move.b	#3,($FFFFF65E).w
		lea	(AnPal_SuperSonic_1).l,a0
		move.w	($FFFFF65C).w,d0
		subq.w	#6,($FFFFF65C).w
		bcc.s	loc_381E
		move.b	#0,($FFFFF65C).w
		move.b	#0,($FFFFF65F).w

loc_381E:
		bra.s	loc_37B4
; ---------------------------------------------------------------------------

loc_3820:
		moveq	#0,d0
		move.w	d0,($FFFFF65C).w
		move.b	d0,($FFFFF65F).w
		move.b	d0,($FFFFF668).w
		cmpi.w	#3,($FFFFFF08).w
		bcc.s	loc_384A
		lea	(AnPal_SuperSonic_5).l,a0
		bsr.w	sub_3914
		lea	(AnPal_SuperSonic_1).l,a0
		bra.w	loc_396C
; ---------------------------------------------------------------------------

loc_384A:
		lea	(AnPal_SuperSonic_7).l,a0
		bra.w	loc_396C
; ---------------------------------------------------------------------------

loc_3854:
		cmpi.w	#2,($FFFFFF08).w
		beq.w	loc_38E8
		cmpi.w	#3,($FFFFFF08).w
		beq.w	loc_393C
		tst.b	($FFFFFE19).w
		bmi.s	loc_389C

loc_386E:

		subq.b	#1,($FFFFF65E).w
		bpl.w	locret_37EC
		move.b	#6,($FFFFF65E).w
		lea	(AnPal_SuperSonic_1).l,a0
		move.w	($FFFFF65C).w,d0
		addq.w	#6,($FFFFF65C).w
		cmpi.w	#$36,($FFFFF65C).w
		bcs.s	loc_3898
		move.w	#$24,($FFFFF65C).w

loc_3898:
		bra.w	loc_37B4
; ---------------------------------------------------------------------------

loc_389C:
		subq.b	#1,($FFFFF65E).w
		bpl.w	locret_37EC
		move.b	#4,($FFFFF65E).w
		lea	(AnPal_SuperSonic_4).l,a0
		move.w	($FFFFF65C).w,d0
		addq.w	#6,($FFFFF65C).w
		cmpi.w	#$48,($FFFFF65C).w
		bcs.s	loc_38C6
		move.w	#0,($FFFFF65C).w

loc_38C6:
		lea	($FFFFFC04).w,a1
		move.l	(a0,d0.w),(a1)+
		move.w	4(a0,d0.w),(a1)
		tst.b	($FFFFF730).w
		beq.w	locret_37EC
		lea	($FFFFF084).w,a1
		move.l	(a0,d0.w),(a1)+
		move.w	4(a0,d0.w),(a1)
		rts
; ---------------------------------------------------------------------------

loc_38E8:
		subq.b	#1,($FFFFF669).w
		bpl.w	loc_386E
		move.b	#$B,($FFFFF669).w
		lea	(AnPal_SuperSonic_5).l,a0
		moveq	#0,d0
		move.b	($FFFFF668).w,d0
		addq.b	#6,($FFFFF668).w
		cmpi.b	#$24,($FFFFF668).w
		bcs.s	sub_3914
		move.b	#0,($FFFFF668).w
; End of function SuperSonic_PalFlash


; =============== S U B R O U T I N E =======================================


sub_3914:
		lea	($FFFFFC10).w,a1
		move.l	(a0,d0.w),(a1)+
		move.w	4(a0,d0.w),2(a1)
		tst.b	($FFFFF730).w
		beq.w	loc_386E
		lea	($FFFFF090).w,a1
		move.l	(a0,d0.w),(a1)+
		move.w	4(a0,d0.w),2(a1)
		bra.w	loc_386E
; End of function sub_3914

; ---------------------------------------------------------------------------

loc_393C:
		subq.b	#1,($FFFFF65E).w
		bpl.w	locret_37EC
		move.b	#2,($FFFFF65E).w
		lea	(AnPal_SuperSonic_6).l,a0
		move.w	($FFFFF65C).w,d0
		addq.w	#6,($FFFFF65C).w
		cmpi.w	#$3C,($FFFFF65C).w
		bcs.s	loc_396C
		move.w	#0,($FFFFF65C).w
		move.b	#$E,($FFFFF65E).w

loc_396C:
		lea	($FFFFFC04).w,a1
		move.l	(a0,d0.w),(a1)+
		move.w	4(a0,d0.w),(a1)
		tst.b	($FFFFF730).w
		beq.w	locret_37EC
		lea	($FFFFF084).w,a1
		move.l	(a0,d0.w),(a1)+
		move.w	4(a0,d0.w),(a1)
		rts
; ---------------------------------------------------------------------------
AnPal_SuperSonic_1:	dc.w $E66,$C42,$822,$E88,$C66,$844,$EAA,$C88,$A66,$ECC,$EAA,$C88,$EEE,$ECC,$EAA,$EEE
					dc.w $EEE,$EEE,$CEE,$CEE,$AEE,$AEE,$8EE,$6CC,$8EE, $EE,	$AA,$AEE,$8EE,$6CC

AnPal_SuperSonic_2:	dc.w $A82,$860,$640,$E88,$C66,$844,$EAA,$C88,$A66,$ECC,$EAA,$C88,$EEE,$ECC,$EAA,$EEE
					dc.w $EEE,$EEE,$CEE,$CEC,$AEC,$AEC,$8EC,$6CA,$8EC,$4EA,$4A8,$CEE,$CEC,$AEC

AnPal_SuperSonic_3:	dc.w $C66,$A44,$624,$E88,$C66,$844,$EAA,$C88,$A66,$ECC,$EAA,$C88,$EEE,$ECC,$EAA
					dc.w $EEE,$EEE,$EEE,$CEE,$CEC,$AEC,$AEC,$8EC,$6CA,$8EC,$4EA,$4A8,$CEE,$CEC,$AEC

AnPal_SuperSonic_4:	dc.w $EEC,$ECA,$EA8,$EEE,$EEE,$EEE,$CEC,$AEA,$2E0,$EEE,$EEE,$EEE,$AEC,$4EC, $CC,$EEE
					dc.w $EEE,$EEE,$CEE,$8EE,$4CE,$EEE,$EEE,$EEE,$EEE,$CCE,$AAE,$EEE,$EEE,$EEE,$EEE,$ECE
					dc.w $CAC,$EEE,$EEE,$EEE

AnPal_SuperSonic_5:	dc.w  $AE, $8E,$46A,$4CE,$2AE,$46A,$8CE,$4CE,$46C,$AEE,$8CE,$48E,$8CE,$4CE,$46C,$4CE
					dc.w $2AE,$46A

AnPal_SuperSonic_6:	dc.w $A6E,$64E,$428,$C8E,$86E,$64A,$EAE,$A8E,$86C,$ECE,$CAE,$A8E,$EEE,$ECE,$CAE,$ECE
					dc.w $CAE,$A8E,$EAE,$A8E,$86C,$C8E,$86E,$64A,$A6E,$64E,$428,$84E,$40C,$206

AnPal_SuperSonic_7:	dc.w $64E,$20C,$206

; =============== S U B R O U T I N E =======================================


Pal_FadeFromBlack:
		move.w	#$3F,($FFFFF626).w
		jsr	Pal_FillBlack(pc)
		move.w	#$15,d4

loc_3AFE:
		move.b	#$12,($FFFFF62A).w
		bsr.w	Wait_VSync
		bsr.s	Pal_FromBlack
		bsr.w	Process_Nem_Queue_Init
		dbf	d4,loc_3AFE
		rts
; End of function Pal_FadeFromBlack


; =============== S U B R O U T I N E =======================================


Pal_FromBlack:
		moveq	#0,d0
		lea	($FFFFFC00).w,a0
		lea	($FFFFFC80).w,a1
		move.b	($FFFFF626).w,d0
		adda.w	d0,a0
		adda.w	d0,a1
		move.b	($FFFFF627).w,d0

loc_3B2A:
		bsr.s	Pal_AddColor
		dbf	d0,loc_3B2A
		tst.b	($FFFFF730).w
		beq.s	locret_3B52
		moveq	#0,d0
		lea	($FFFFF080).w,a0
		lea	($FFFFF000).w,a1
		move.b	($FFFFF626).w,d0
		adda.w	d0,a0
		adda.w	d0,a1
		move.b	($FFFFF627).w,d0

loc_3B4C:
		bsr.s	Pal_AddColor
		dbf	d0,loc_3B4C

locret_3B52:
		rts
; End of function Pal_FromBlack


; =============== S U B R O U T I N E =======================================


Pal_AddColor:
		move.w	(a1)+,d2
		move.w	(a0),d3
		cmp.w	d2,d3
		beq.s	loc_3B7C
		move.w	d3,d1
		addi.w	#$200,d1
		cmp.w	d2,d1
		bhi.s	loc_3B6A
		move.w	d1,(a0)+
		rts
; ---------------------------------------------------------------------------

loc_3B6A:
		move.w	d3,d1
		addi.w	#$20,d1
		cmp.w	d2,d1
		bhi.s	loc_3B78
		move.w	d1,(a0)+
		rts
; ---------------------------------------------------------------------------

loc_3B78:
		addq.w	#2,(a0)+
		rts
; ---------------------------------------------------------------------------

loc_3B7C:
		addq.w	#2,a0
		rts
; End of function Pal_AddColor


; =============== S U B R O U T I N E =======================================


Pal_FillBlack:
		cmpi.w	#$D01,($FFFFFE10).w
		beq.w	Pal_FillWhite
		cmpi.w	#$1701,($FFFFFE10).w
		beq.w	Pal_FillWhite				; If one of either Sky Sanctuary Knuckles level or the hyper emerald special stage arena, branch
		moveq	#0,d0
		lea	($FFFFFC00).w,a0
		move.b	($FFFFF626).w,d0
		adda.w	d0,a0
		moveq	#0,d1
		move.b	($FFFFF627).w,d0

loc_3BA6:
		move.w	d1,(a0)+
		tst.b	($FFFFF730).w
		beq.s	loc_3BB2
		move.w	d1,-$B82(a0)

loc_3BB2:
		dbf	d0,loc_3BA6
		rts
; End of function Pal_FillBlack


; =============== S U B R O U T I N E =======================================


Animate_Palette:
		tst.w	($FFFFEE50).w
		bmi.s	locret_3BE2
		beq.s	loc_3BDC
		subq.w	#1,($FFFFEE50).w
		cmpi.w	#$D01,($FFFFFE10).w
		beq.w	Pal_FromWhite
		cmpi.w	#$1701,($FFFFFE10).w
		beq.w	Pal_FromWhite
		bra.w	Pal_FromBlack
; ---------------------------------------------------------------------------

loc_3BDC:
		jmp	(AnPal_Load).l
; ---------------------------------------------------------------------------

locret_3BE2:
		rts
; End of function Animate_Palette


; =============== S U B R O U T I N E =======================================


Pal_FadeToBlack:

		move.w	#$3F,($FFFFF626).w
		move.w	#$15,d4

loc_3BEE:
		move.b	#$12,($FFFFF62A).w
		bsr.w	Wait_VSync
		bsr.s	Pal_ToBlack
		bsr.w	Process_Nem_Queue_Init
		dbf	d4,loc_3BEE
		rts
; End of function Pal_FadeToBlack


; =============== S U B R O U T I N E =======================================


Pal_ToBlack:

		moveq	#0,d0
		lea	($FFFFFC00).w,a0
		move.b	($FFFFF626).w,d0
		adda.w	d0,a0
		move.b	($FFFFF627).w,d0

loc_3C14:
		bsr.s	Pal_DecColor
		dbf	d0,loc_3C14
		moveq	#0,d0
		lea	($FFFFF080).w,a0
		move.b	($FFFFF626).w,d0
		adda.w	d0,a0
		move.b	($FFFFF627).w,d0

loc_3C2A:
		bsr.s	Pal_DecColor
		dbf	d0,loc_3C2A
		rts
; End of function Pal_ToBlack


; =============== S U B R O U T I N E =======================================


Pal_DecColor:
		move.w	(a0),d2
		beq.s	loc_3C5E
		move.w	d2,d1
		andi.w	#$E,d1
		beq.s	loc_3C42
		subq.w	#2,(a0)+
		rts
; ---------------------------------------------------------------------------

loc_3C42:
		move.w	d2,d1
		andi.w	#$E0,d1
		beq.s	loc_3C50
		subi.w	#$20,(a0)+
		rts
; ---------------------------------------------------------------------------

loc_3C50:
		move.w	d2,d1
		andi.w	#$E00,d1
		beq.s	loc_3C5E
		subi.w	#$200,(a0)+
		rts
; ---------------------------------------------------------------------------

loc_3C5E:
		addq.w	#2,a0
		rts
; End of function Pal_DecColor


; =============== S U B R O U T I N E =======================================


Pal_FillWhite:
		moveq	#0,d0
		lea	($FFFFFC00).w,a0
		move.b	($FFFFF626).w,d0
		adda.w	d0,a0
		move.w	#$EEE,d1
		move.b	($FFFFF627).w,d0

loc_3C76:
		move.w	d1,(a0)+
		dbf	d0,loc_3C76
		clr.w	($FFFFFACE).w
		rts
; End of function Pal_FillWhite


; =============== S U B R O U T I N E =======================================


Pal_FromBlackWhite:

		move.w	#$3F,($FFFFF626).w
		bsr.s	Pal_FillWhite
		move.w	#$15,d4

loc_3C8E:
		move.b	#$12,($FFFFF62A).w
		bsr.w	Wait_VSync
		bsr.s	Pal_FromWhite
		bsr.w	Process_Nem_Queue_Init
		dbf	d4,loc_3C8E
		rts
; End of function Pal_FromBlackWhite


; =============== S U B R O U T I N E =======================================


Pal_FromWhite:
		subq.w	#1,($FFFFFACE).w
		bpl.s	locret_3CEE
		move.w	#2,($FFFFFACE).w
		moveq	#0,d0
		lea	($FFFFFC00).w,a0
		lea	($FFFFFC80).w,a1
		move.b	($FFFFF626).w,d0
		adda.w	d0,a0
		adda.w	d0,a1
		move.b	($FFFFF627).w,d0

loc_3CC6:
		bsr.s	Pal_DecColor2
		dbf	d0,loc_3CC6
		tst.b	($FFFFF730).w
		beq.s	locret_3CEE
		moveq	#0,d0
		lea	($FFFFF080).w,a0
		lea	($FFFFF000).w,a1
		move.b	($FFFFF626).w,d0
		adda.w	d0,a0
		adda.w	d0,a1
		move.b	($FFFFF627).w,d0

loc_3CE8:
		bsr.s	Pal_DecColor2
		dbf	d0,loc_3CE8

locret_3CEE:
		rts
; End of function Pal_FromWhite


; =============== S U B R O U T I N E =======================================


Pal_DecColor2:
		move.b	(a1)+,d2
		andi.b	#$E,d2
		move.b	(a0),d3
		andi.b	#$E,d3
		cmp.b	d2,d3
		bls.s	loc_3D02
		subq.b	#2,d3

loc_3D02:
		move.b	d3,(a0)+
		move.b	(a1)+,d1
		move.b	d1,d2
		andi.b	#$E0,d1
		move.b	(a0),d3
		move.b	d3,d5
		andi.b	#$E0,d3
		cmp.b	d1,d3
		bls.s	loc_3D1C
		subi.b	#$20,d3

loc_3D1C:
		andi.b	#$E,d2
		andi.b	#$E,d5
		cmp.b	d2,d5
		bls.s	loc_3D2A
		subq.b	#2,d5

loc_3D2A:
		or.b	d5,d3
		move.b	d3,(a0)+
		rts
; End of function Pal_DecColor2


; =============== S U B R O U T I N E =======================================


Pal_FadeToWhite:

		move.w	#$3F,($FFFFF626).w
		move.w	#$15,d4

loc_3D3A:
		move.b	#$12,($FFFFF62A).w
		bsr.w	Wait_VSync
		bsr.s	Pal_ToWhite
		bsr.w	Process_Nem_Queue_Init
		dbf	d4,loc_3D3A
		rts
; End of function Pal_FadeToWhite


; =============== S U B R O U T I N E =======================================


Pal_ToWhite:

		moveq	#0,d0
		lea	($FFFFFC00).w,a0
		move.b	($FFFFF626).w,d0
		adda.w	d0,a0
		move.b	($FFFFF627).w,d0

loc_3D60:
		bsr.s	Pal_AddColor2
		dbf	d0,loc_3D60
		moveq	#0,d0
		lea	($FFFFF080).w,a0
		move.b	($FFFFF626).w,d0
		adda.w	d0,a0
		move.b	($FFFFF627).w,d0

loc_3D76:
		bsr.s	Pal_AddColor2
		dbf	d0,loc_3D76
		rts
; End of function Pal_ToWhite


; =============== S U B R O U T I N E =======================================


Pal_AddColor2:
		move.w	(a0),d2
		cmpi.w	#$EEE,d2
		beq.s	loc_3DBA
		move.w	d2,d1
		andi.w	#$E,d1
		cmpi.w	#$E,d1
		beq.s	loc_3D96
		addq.w	#2,(a0)+
		rts
; ---------------------------------------------------------------------------

loc_3D96:
		move.w	d2,d1
		andi.w	#$E0,d1
		cmpi.w	#$E0,d1
		beq.s	loc_3DA8
		addi.w	#$20,(a0)+
		rts
; ---------------------------------------------------------------------------

loc_3DA8:
		move.w	d2,d1
		andi.w	#$E00,d1
		cmpi.w	#$E00,d1
		beq.s	loc_3DBA
		addi.w	#$200,(a0)+
		rts
; ---------------------------------------------------------------------------

loc_3DBA:
		addq.w	#2,a0
		rts
; End of function Pal_AddColor2


; =============== S U B R O U T I N E =======================================


LoadPalette:

		lea	(PalPoint).l,a1
		lsl.w	#3,d0
		adda.w	d0,a1
		movea.l	(a1)+,a2
		movea.w	(a1)+,a3
		adda.w	#$80,a3
		move.w	(a1)+,d7

loc_3DD2:
		move.l	(a2)+,(a3)+
		dbf	d7,loc_3DD2
		rts
; End of function LoadPalette


; =============== S U B R O U T I N E =======================================


LoadPalette_Immediate:

		lea	(PalPoint).l,a1
		lsl.w	#3,d0
		adda.w	d0,a1
		movea.l	(a1)+,a2
		movea.w	(a1)+,a3
		move.w	(a1)+,d7

loc_3DEA:
		move.l	(a2)+,(a3)+
		dbf	d7,loc_3DEA
		rts
; End of function LoadPalette_Immediate


; =============== S U B R O U T I N E =======================================


LoadPalette2:
		lea	(PalPoint).l,a1
		lsl.w	#3,d0
		adda.w	d0,a1
		movea.l	(a1)+,a2
		movea.w	(a1)+,a3
		suba.w	#$B80,a3
		move.w	(a1)+,d7

loc_3E06:
		move.l	(a2)+,(a3)+
		dbf	d7,loc_3E06
		rts
; End of function LoadPalette2


; =============== S U B R O U T I N E =======================================


LoadPalette2_Immediate:
		lea	(PalPoint).l,a1
		lsl.w	#3,d0
		adda.w	d0,a1
		movea.l	(a1)+,a2
		movea.w	(a1)+,a3
		suba.w	#$C00,a3
		move.w	(a1)+,d7

loc_3E22:
		move.l	(a2)+,(a3)+
		dbf	d7,loc_3E22
		rts
; End of function LoadPalette2_Immediate

; ---------------------------------------------------------------------------

Sega_Screen:
		move.b	#4,($FFFFF600).w
		rts
; ---------------------------------------------------------------------------

Title_Screen:
		moveq	#-$1F,d0
		bsr.w	Play_Sound			; Fade music if any is playing
		clr.w	($FFFFFF0E).w
		lea	($FFFFFF10).w,a1
		moveq	#0,d0
		move.w	#$1A,d1

loc_3E46:
		move.l	d0,(a1)+			; Clear FFFF10-FFFF7B
		dbf	d1,loc_3E46
		bsr.w	Clear_Nem_Queue
		clr.w	($FFFFFE10).w		; Clear zone/act index
		bsr.w	Pal_FadeToBlack		; Fade out
		move	#$2700,sr
		lea	($C00004).l,a6
		move.w	#$8004,(a6)			; Command $8004 - Disable HInt, HV Counter
		move.w	#$8230,(a6)			; Command $8230 - Nametable A at $C000
		move.w	#$8407,(a6)			; Command $8407 - Nametable B at $E000
		move.w	#$9001,(a6)			; Command $9001 - 64x32 cell nametable area
		move.w	#$9200,(a6)			; Command $9200 - Window V position at default
		move.w	#$8B03,(a6)			; Command $8B03 - Vscroll full, HScroll line-based
		move.w	#$8700,(a6)			; Command $8700 - BG color is Pal 0 Color 0
		clr.b	($FFFFF64E).w
		clr.b	($FFFFF730).w		; Both water flags cleared
		move.w	#$8C81,(a6)			; Command $8C81 - 40cell screen size, no interlacing, no s/h
		bsr.w	Clear_DisplayData
		lea	($FFFFAC00).w,a1
		moveq	#0,d0
		move.w	#$FF,d1

loc_3E98:
		move.l	d0,(a1)+			; Clear object display array
		dbf	d1,loc_3E98
		lea	($FFFFB000).w,a1
		moveq	#0,d0
		move.w	#$7FF,d1

loc_3EA8:
		move.l	d0,(a1)+			; Clear SST array
		dbf	d1,loc_3EA8
		lea	($FFFFF700).w,a1
		moveq	#0,d0
		move.w	#$3F,d1

loc_3EB8:
		move.l	d0,(a1)+			; Clear active play variables
		dbf	d1,loc_3EB8
		lea	($FFFFEE00).w,a1
		moveq	#0,d0
		move.w	#$3F,d1

loc_3EC8:
		move.l	d0,(a1)+			; Clear play positional values
		dbf	d1,loc_3EC8
		jsr	(Init_SpriteTable).l		; Initialize the sprite table
		lea	($FFFFFC00).w,a1
		moveq	#0,d0
		move.w	#$3F,d1

loc_3EDE:
		move.l	d0,(a1)+			; Clear main palette
		dbf	d1,loc_3EDE
		moveq	#0,d0
		move.b	d0,($FFFFFE2A).w
		move.b	d0,($FFFFFE48).w
		move.w	d0,($FFFFFE08).w
		move.w	d0,($FFFFFFD0).w
		move.w	d0,($FFFFF634).w
		move.w	d0,($FFFFFFE8).w
		move.b	d0,($FFFFF711).w
		move.b	d0,($FFFFFFDA).w
		move.w	d0,($FFFFFFE8).w
		move.w	d0,($FFFFFFE4).w
		move.w	d0,($FFFFFFE6).w
		move.b	d0,($FFFFFFD4).w
		move.w	#$167,($FFFFF614).w		; Wait on title screen for six seconds
		clr.w	($FFFFFB00).w
		move.l	#$FFFFFB00,($FFFFFBFC).w	; Clear DMA queue
		nop
		nop
		nop
		nop
		nop
		nop
		tst.w	($FFFFFFAE).w
		bne.w	SK_Alone_Title_Screen
		lea	(ArtKos_S3TitleSonic1).l,a0	;S3DATA
		lea	($FFFF0000).l,a1
		bsr.w	Kos_Decomp
		move.w	a1,d3
		lsr.w	#1,d3
		move.l	#$FF0000,d1
		move.w	#0,d2
		jsr	(Add_To_DMA_Queue).l		; DMA Sega logo+Sonic art data 1 to $0 in VRAM
		lea	($FFFF8000).w,a1
		lea	(MapEni_S3TitleSonic1).l,a0	;S3DATA
		move.w	#0,d0
		bsr.w	Eni_Decomp			; Decompress Enigma mappings
		tst.b	($FFFFFFD8).w
		bmi.s	loc_3F7E
		moveq	#0,d0
		move.l	d0,($FFFF83AC).w		; Do something to the mappings if an overseas model. Not sure what

loc_3F7E:
		lea	($FFFF8000).w,a1
		move.l	#$40000003,d0
		moveq	#$27,d1
		moveq	#$1B,d2
		jsr	(Plane_Map_To_VRAM).l		; Copy screen mappings to VRAM
		lea	(Pal_TitleSonic1).l,a0
		lea	($FFFFFC80).w,a1
		moveq	#7,d0

loc_3F9E:
		move.l	(a0)+,(a1)+				; Fill 2 palette lines with title screen data
		dbf	d0,loc_3F9E
		move.w	#$F0,($FFFFF614).w
		move.w	($FFFFF60E).w,d0
		ori.b	#$40,d0
		move.w	d0,($C00004).l			; Turn the display on
		bsr.w	Pal_FadeFromBlack		; Fade in to logo
		moveq	#-1,d0
		bsr.w	Play_Sound
		move.w	#$B4,($FFFFF614).w		; Set to wait for 3 seconds

Wait_SegaS3K:
		move.b	#$14,($FFFFF62A).w
		bsr.w	Wait_VSync				; Wait for SEGA sound
		move.b	($FFFFF605).w,d0
		andi.b	#$80,d0
		bne.w	loc_3FE4				; If start was pressed, skip ahead
		tst.w	($FFFFF614).w
		bne.s	Wait_SegaS3K

loc_3FE4:
		moveq	#-2,d0
		bsr.w	Play_Sound				; Stop SEGA sound
		lea	(Pal_Title).l,a1

loc_3FF0:
		move.b	#2,($FFFFF62A).w
		bsr.w	Wait_VSync
		lea	($FFFFFC00).w,a2
		move.l	(a1)+,(a2)+

loc_4000:
		move.l	(a1)+,(a2)+
		move.l	(a1)+,(a2)+
		move.w	(a1)+,(a2)+
		tst.w	-$E(a1)					; Wait for BG color to turn to black
		bne.s	loc_3FF0
		clr.w	($FFFFF660).w
		clr.w	($FFFFF662).w
		move.b	#-1,($FFFFFFBC).w
		move.b	#0,($FFFFFFBD).w
		move.w	#1,($FFFFFFBE).w		; Set initial variables for Sonic animation page flipping
		moveq	#1,d0
		bsr.w	TitleSonic_LoadFrame
		move.w	#$384,($FFFFF614).w		; Set to wait 15 seconds (900 frames in NTSC)
		btst	#6,($FFFFFFD8).w
		beq.s	loc_4040
		move.w	#$2EE,($FFFFF614).w		; Set to wait 15 seconds (750 frames in PAL)

loc_4040:
		lea	(ArtKos_S3TitleSonic8).l,a1
		lea	($FFFF0000).l,a2
		jsr	(Queue_Kos).l				; Queue frame 8 of data into a2 since frame 1 is already in VRAM
		moveq	#$25,d0
		bsr.w	Play_Sound				; Start playing the title screen music

Wait_TitleS3K:
		move.b	#4,($FFFFF62A).w
		jsr	(Process_Kos_Queue).l
		bsr.w	Wait_VSync
		bsr.w	Iterate_TitleSonicFrame
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		bsr.w	Process_Nem_Queue_Init
		move.b	($FFFFF605).w,d0
		andi.b	#$80,d0
		bne.w	loc_4090			; If start was pressed, skip straight to title
		cmpi.w	#$C,($FFFFFFBE).w
		bcs.s	Wait_TitleS3K		; If last frame was reached, don't repeat

loc_4090:
		move.w	#$C,($FFFFFFBE).w
		lea	($FFFFFC00).w,a1
		moveq	#$3F,d1

loc_409C:
		move.w	#$EEE,(a1)+
		dbf	d1,loc_409C				; Flash palette white
		move.b	#3,($FFFFFFBD).w
		move.b	#4,($FFFFF62A).w
		bsr.w	Wait_VSync
		lea	(ArtKos_S3TitleSonicD).l,a0	;S3DATA
		lea	($FFFF0000).l,a1
		bsr.w	Kos_Decomp
		move.w	a1,d3
		lsr.w	#1,d3
		move.l	#$FFFF0000,d1
		move.w	#0,d2
		andi.l	#$FFFFFF,d1
		jsr	(Add_To_DMA_Queue).l		; Load Sonic art frame 14
		lea	($FFFF8000).w,a1
		lea	(MapEni_S3TitleSonicD).l,a0
		move.w	#$8000,d0
		bsr.w	Eni_Decomp
		lea	($FFFF8000).w,a1
		move.l	#$40000003,d0
		moveq	#$27,d1
		moveq	#$1B,d2
		jsr	(Plane_Map_To_VRAM).l		; Load Sonic mapping frame 14 to $C000 VRAM
		lea	($FFFF8000).w,a1
		lea	(MapEni_S3TitleBg).l,a0
		move.w	#$4000,d0
		bsr.w	Eni_Decomp
		lea	($FFFF8000).w,a1
		move.l	#$60000003,d0
		moveq	#$27,d1
		moveq	#$1B,d2
		jsr	(Plane_Map_To_VRAM).l		; Load S3K Title BG to $E000 VRAM
		move.b	#4,($FFFFF62A).w
		bsr.w	Wait_VSync
		lea	(Pal_TitleSonicD).l,a0		; Title palette
		lea	($FFFFFC80).w,a1
		moveq	#$1F,d0

loc_4140:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_4140
		move.l	#$60000002,($C00004).l	; to VRAM $A000
		lea	(ArtNem_Title_S3Banner).l,a0
		bsr.w	Nem_Decomp
		move.l	#$50000003,($C00004).l	; to VRAM $D000
		lea	(ArtNem_TitleScreenText).l,a0
		bsr.w	Nem_Decomp
		move.l	#$40000002,($C00004).l	; to VRAM $8000
		lea	(ArtNem_Title_SonicSprites).l,a0
		bsr.w	Nem_Decomp
		move.l	#$58000002,($C00004).l	; to VRAM $9800
		lea	(ArtNem_Title_ANDKnuckles).l,a0
		bsr.w	Nem_Decomp
		move.l	#Obj_TitleBanner,($FFFFB000).w
		move.l	#Obj_TitleSelection,($FFFFB04A).w
		move.l	#Obj_TitleCopyright,($FFFFB0DE).w
		move.l	#Obj_TitleSonicFinger,($FFFFB128).w
		move.l	#Obj_TitleSonicWink,($FFFFB172).w
		move.l	#Obj_TitleTailsPlane,($FFFFB1BC).w
		move.l	#Obj_TitleANDKnuckles,($FFFFB206).w		; Load all applicable title objects
		move.b	#0,($FFFFFFBD).w

loc_41D4:

		move.b	#4,($FFFFF62A).w
		bsr.w	Wait_VSync
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		bsr.w	Process_Nem_Queue_Init
		tst.l	($FFFFB094).w
		beq.s	loc_41D4			; Don't do anything at all until banner has finished moving
		tst.w	($FFFFF614).w
		beq.w	loc_4278			; If the timer has run out, go do the level demos
		move.b	($FFFFF605).w,d0
		or.b	($FFFFF607).w,d0
		andi.b	#$80,d0
		beq.w	loc_41D4			; Repeat until start has been pressed on either controller
		move.b	#$C,($FFFFF600).w
		move.b	#3,($FFFFFE12).w
		move.b	#3,($FFFFFEC6).w	;CHECKLATER
		moveq	#0,d0
		move.w	d0,($FFFFFE20).w
		move.l	d0,($FFFFFE22).w
		move.l	d0,($FFFFFE26).w
		move.w	d0,($FFFFFED0).w
		move.l	d0,($FFFFFED2).w
		move.l	d0,($FFFFFED6).w
		move.b	d0,($FFFFFE18).w
		move.l	#$1388,($FFFFFFC0).w
		move.l	#$1388,($FFFFFFC4).w	;CHECKLATER
		moveq	#-$1F,d0
		bsr.w	Play_Sound_2			; Fade out the title screen music
		moveq	#0,d0
		move.b	($FFFFFF86).w,d0		; Selection is stored here.
		bne.w	loc_4264
		move.b	#$4C,($FFFFF600).w		; Game Mode 4C is the save select
		rts
; ---------------------------------------------------------------------------

loc_4264:
		subq.b	#1,d0
		bne.s	loc_4270
		move.b	#$38,($FFFFF600).w		; Game Mode 38 is Competition mode
		rts
; ---------------------------------------------------------------------------

loc_4270:
		move.b	#$28,($FFFFF600).w		; Game Mode 28 is the level select
		rts
; ---------------------------------------------------------------------------

loc_4278:
		moveq	#-$1F,d0
		bsr.w	Play_Sound_2			; Fade out music
		move.w	($FFFFFFD2).w,d0		; Get index of current demo to run
		move.w	d0,($FFFFEF7A).w
		andi.w	#7,d0
		add.w	d0,d0
		lea	DemoLevels(pc),a0
		move.w	(a0,d0.w),d0
		move.w	d0,($FFFFFE10).w		; Load level index to the appropriate variables
		move.w	d0,($FFFFEE4E).w
		move.w	d0,($FFFFFE2C).w
		move.w	($FFFFFFD2).w,d1
		addq.w	#1,d1
		tst.w	($FFFFFFAE).w
		bne.s	loc_42C0		; If playing only Sonic and Knuckles, branch
		cmpi.w	#3,d1
		bne.s	loc_42B6
		moveq	#4,d1
		bra.s	loc_42C8
; ---------------------------------------------------------------------------

loc_42B6:
		cmpi.w	#7,d1
		bcs.s	loc_42C8
		moveq	#0,d1
		bra.s	loc_42C8
; ---------------------------------------------------------------------------

loc_42C0:
		cmpi.w	#3,d1
		bcs.s	loc_42C8
		moveq	#0,d1

loc_42C8:

		move.w	d1,($FFFFFFD2).w
		tst.w	d0
		bpl.s	loc_4300			; Branch if we are indeed playing a level
		move.b	#$34,($FFFFF600).w	; Do the special stage demo
		move.b	#1,($FFFFFE16).w
		move.b	#1,($FFFFFFBB).w
		move.b	#7,($FFFFFE10).w
		clr.w	($FFFFFFB0).w
		clr.l	($FFFFFFB2).w
		clr.w	($FFFFFFB6).w
		clr.b	($FFFFFFB8).w
		move.b	#2,($FFFFFFB3).w
		bra.s	loc_4306
; ---------------------------------------------------------------------------

loc_4300:
		move.b	#8,($FFFFF600).w	; We're about to perform a level demo

loc_4306:
		move.w	#1,($FFFFFFD0).w
		move.b	#3,($FFFFFE12).w
		move.b	#3,($FFFFFEC6).w
		moveq	#0,d0
		move.w	d0,($FFFFFE20).w
		move.l	d0,($FFFFFE22).w
		move.l	d0,($FFFFFE26).w
		move.w	d0,($FFFFFED0).w
		move.l	d0,($FFFFFED2).w
		move.l	d0,($FFFFFED6).w
		move.l	#$1388,($FFFFFFC0).w
		move.l	#$1388,($FFFFFFC4).w
		rts
; ---------------------------------------------------------------------------
DemoLevels:	dc.w 0			; Angel Island
			dc.w $100		; Hydrocity
			dc.w $200		; Marble Garden
			dc.w $700		; Mushroom Hill
			dc.w $400		; Flying Battery
			dc.w $800		; Sandopolis
			dc.w $FFFF

; ---------------------------------------------------------------------------


TitleAnim_FlipBuffer:
		tst.b	($FFFFFFBD).w
		bne.s	loc_43AC
		move.b	#3,($FFFFFFBD).w
		cmpi.w	#$C,($FFFFFFBE).w
		bcc.s	loc_43B2
		move.b	#3,($FFFFFFBD).w
		lea	($FFFFFC80).w,a0
		lea	($FFFFFC00).w,a1
		moveq	#$F,d0

loc_4376:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_4376
		eori.b	#-1,($FFFFFFBC).w
		tst.b	($FFFFFFBC).w
		beq.s	loc_439A
		move.w	#$8406,($C00004).l		; Nametable B Address $C000
		move.w	#$8230,($C00004).l		; Nametable A Address $C000
		rts
; ---------------------------------------------------------------------------

loc_439A:
		move.w	#$8407,($C00004).l		; Nametable B Address $E000
		move.w	#$8238,($C00004).l		; Nametable A Address $E000
		rts
; ---------------------------------------------------------------------------

loc_43AC:
		subq.b	#1,($FFFFFFBD).w
		rts
; ---------------------------------------------------------------------------

loc_43B2:
		lea	($FFFFFC80).w,a0
		lea	($FFFFFC00).w,a1
		moveq	#$1F,d0

loc_43BC:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_43BC
		move.w	#$8407,($C00004).l		; Nametable B Address $E000
		move.w	#$8230,($C00004).l		; Nametable B Address $C000
		rts
; End of function sub_4352


; =============== S U B R O U T I N E =======================================


Iterate_TitleSonicFrame:
		cmpi.b	#1,($FFFFFFBD).w
		bne.s	locret_43F0
		move.w	($FFFFFFBE).w,d0
		move.b	SonicFrameIndex(pc,d0.w),d0
		ext.w	d0
		bmi.s	loc_43F2
		bsr.w	TitleSonic_LoadFrame
		addq.w	#1,($FFFFFFBE).w

locret_43F0:
		rts
; ---------------------------------------------------------------------------

loc_43F2:
		move.w	#$C,($FFFFFFBE).w
		move.b	#3,($FFFFFFBD).w
		rts
; End of function Iterate_TitleSonicFrame

; ---------------------------------------------------------------------------
SonicFrameIndex:	dc.b	1,   2,	  3,   4,   5,	 6,   7,   8,	9,  $A,	 $B, $FF

; =============== S U B R O U T I N E =======================================


TitleSonic_LoadFrame:
		move.w	d0,d7
		add.w	d0,d0
		add.w	d0,d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		lea	(TitleSonic_Frames).l,a2
		lea	(a2,d0.w),a2
		move.w	#$2C60,d3
		move.l	(a2)+,d0				; Art data
		cmpi.w	#7,d7
		beq.s	loc_4446
		bcs.s	loc_4466
		andi.l	#$FFFFFF,d0
		movea.l	d0,a0
		lea	($FFFF0000).l,a1
		bsr.w	Kos_Decomp
		move.w	a1,d3
		lsr.w	#1,d3

loc_4446:
		move.l	#$FFFF0000,d1
		move.w	#0,d2
		tst.b	($FFFFFFBC).w		; FFFFBC toggles on and off so that each animation frame could alternate locations for a sort of makeshift double-buffering
		beq.s	loc_445A
		move.w	#$6000,d2

loc_445A:
		andi.l	#$FFFFFF,d1
		jsr	(Add_To_DMA_Queue).l

loc_4466:
		movea.l	(a2)+,a0			; Palette data address
		lea	($FFFFFC80).w,a1
		moveq	#$F,d0

loc_446E:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_446E
		tst.b	($FFFFFFBC).w
		bne.s	loc_44B8
		lea	($FFFF8000).w,a1			; Buffer 1
		movea.l	(a2)+,a0				; Enigma Mappings
		move.w	#0,d0
		bsr.w	Eni_Decomp
		cmpi.w	#7,d7
		bcc.s	loc_449A
		tst.b	($FFFFFFD8).w
		bmi.s	loc_449A
		moveq	#0,d0
		move.l	d0,($FFFF83AC).w

loc_449A:
		move	#$2700,sr
		lea	($FFFF8000).w,a1
		move.l	#$40000003,d0			; to $C000 in VRAM, Nametable A
		moveq	#$27,d1
		moveq	#$1B,d2
		jsr	(Plane_Map_To_VRAM).l
		move	#$2300,sr
		rts
; ---------------------------------------------------------------------------

loc_44B8:
		lea	($FFFF8000).w,a1			; Buffer 2
		movea.l	(a2)+,a0				; Enigma Mappings
		move.w	#$300,d0
		cmpi.w	#7,d7
		bcc.s	loc_44CC
		move.w	#0,d0

loc_44CC:
		bsr.w	Eni_Decomp
		cmpi.w	#7,d7
		bcc.s	loc_44E2
		tst.b	($FFFFFFD8).w
		bmi.s	loc_44E2
		moveq	#0,d0
		move.l	d0,($FFFF83AC).w

loc_44E2:
		move	#$2700,sr
		lea	($FFFF8000).w,a1
		move.l	#$60000003,d0			; to $E000 in VRAM Nametable B
		moveq	#$27,d1
		moveq	#$1B,d2
		jsr	(Plane_Map_To_VRAM).l
		move	#$2300,sr
		rts
; End of function TitleSonic_LoadFrame

; ---------------------------------------------------------------------------
TitleSonic_Frames:dc.l ArtKos_S3TitleSonic1	;S3DATA
		dc.l Pal_TitleSonic1
		dc.l MapEni_S3TitleSonic1				;S3DATA
		dc.l ArtKos_S3TitleSonic1				;S3DATA
		dc.l Pal_TitleSonic2
		dc.l MapEni_S3TitleSonic2				;S3DATA
		dc.l ArtKos_S3TitleSonic1				;S3DATA
		dc.l Pal_TitleSonic3
		dc.l MapEni_S3TitleSonic3				;S3DATA
		dc.l ArtKos_S3TitleSonic1				;S3DATA
		dc.l Pal_TitleSonic4
		dc.l MapEni_S3TitleSonic4				;S3DATA
		dc.l ArtKos_S3TitleSonic1				;S3DATA
		dc.l Pal_TitleSonic5
		dc.l MapEni_S3TitleSonic5				;S3DATA
		dc.l ArtKos_S3TitleSonic1				;S3DATA
		dc.l Pal_TitleSonic6
		dc.l MapEni_S3TitleSonic6				;S3DATA
		dc.l ArtKos_S3TitleSonic1				;S3DATA
		dc.l Pal_TitleSonic7
		dc.l MapEni_S3TitleSonic7				;S3DATA
		dc.l ArtKos_S3TitleSonic8				;S3DATA
		dc.l Pal_TitleSonic8
		dc.l MapEni_S3TitleSonic8				;S3DATA
		dc.l ArtKos_S3TitleSonic9				;S3DATA
		dc.l Pal_TitleSonic9
		dc.l MapEni_S3TitleSonic9				;S3DATA
		dc.l ArtKos_S3TitleSonicA				;S3DATA
		dc.l Pal_TitleSonicA
		dc.l MapEni_S3TitleSonicA				;S3DATA
		dc.l ArtKos_S3TitleSonicB				;S3DATA
		dc.l Pal_TitleSonicB
		dc.l MapEni_S3TitleSonicB				;S3DATA
		dc.l ArtKos_S3TitleSonicC				;S3DATA
		dc.l Pal_TitleSonicC
		dc.l MapEni_S3TitleSonicC				;S3DATA
		dc.l ArtKos_S3TitleSonicD				;S3DATA
		dc.l Pal_TitleSonicD
		dc.l MapEni_S3TitleSonicD				;S3DATA
Pal_Title:	binclude "General\Title\Palettes\S3.bin"

Pal_TitleSonic1:binclude "General\Title\Palettes\S3 Sonic 1.bin"


Pal_TitleSonic2:binclude "General\Title\Palettes\S3 Sonic 2.bin"

Pal_TitleSonic3:binclude "General\Title\Palettes\S3 Sonic 3.bin"

Pal_TitleSonic4:binclude "General\Title\Palettes\S3 Sonic 4.bin"

Pal_TitleSonic5:binclude "General\Title\Palettes\S3 Sonic 5.bin"

Pal_TitleSonic6:binclude "General\Title\Palettes\S3 Sonic 6.bin"

Pal_TitleSonic7:binclude "General\Title\Palettes\S3 Sonic 7.bin"

Pal_TitleSonic8:binclude "General\Title\Palettes\S3 Sonic 8.bin"

Pal_TitleSonic9:binclude "General\Title\Palettes\S3 Sonic 9.bin"

Pal_TitleSonicA:binclude "General\Title\Palettes\S3 Sonic A.bin"

Pal_TitleSonicB:binclude "General\Title\Palettes\S3 Sonic B.bin"

Pal_TitleSonicC:binclude "General\Title\Palettes\S3 Sonic C.bin"

Pal_TitleSonicD:binclude "General\Title\Palettes\S3 Sonic D.bin"


; ---------------------------------------------------------------------------

Obj_TitleBanner:
		move.l	#Map_S3TitleBanner,$C(a0)
		move.w	#$E500,$A(a0)		; Origin at $A000
		move.w	#$80,8(a0)
		move.b	#$80,7(a0)
		move.b	#$40,6(a0)
		move.w	#$120,$10(a0)
		move.w	#$F0,$14(a0)
		move.w	#$400,$1A(a0)
		move.l	#$FFA00000,$30(a0)
		move.l	#Obj_TitleBanner_Main,(a0)

Obj_TitleBanner_Main:
		move.b	$34(a0),d2
		move.w	$1A(a0),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$30(a0)
		move.w	$30(a0),d0
		move.b	#0,$34(a0)
		move.w	#$40,d1
		cmpi.w	#0,d0
		blt.s	loc_48B4
		bne.s	loc_48AA
		cmpi.w	#$FFA5,$1A(a0)
		bne.s	loc_48AA
		move.l	#Obj_TitleBanner_Display,(a0)
		move.l	#Obj_TitleTM,($FFFFB094).w
		bra.s	loc_48C2
; ---------------------------------------------------------------------------

loc_48AA:

		move.b	#$FF,$34(a0)
		move.w	#$FFC0,d1

loc_48B4:
		add.w	d1,$1A(a0)
		cmp.b	$34(a0),d2
		beq.s	loc_48C2
		asr	$1A(a0)

loc_48C2:

		move.w	$30(a0),d0
		neg.w	d0
		addi.w	#$D4,d0
		move.w	d0,$14(a0)
		cmpi.w	#$10,($FFFFF616).w		; Raise title screen Y position to make room for the &KNUCKLES
		beq.s	Obj_TitleBanner_Display
		addq.w	#1,($FFFFF616).w

Obj_TitleBanner_Display:

		subq.b	#1,$24(a0)
		bpl.s	loc_48F2
		move.b	#9,$24(a0)
		addq.b	#4,$23(a0)
		andi.b	#$1C,$23(a0)

loc_48F2:
		moveq	#0,d0
		move.b	$23(a0),d0
		move.l	Pal_TitleWaterRot(pc,d0.w),($FFFFFCDA).w
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Pal_TitleWaterRot:	binclude "General\Title\Palettes\S3 Water Anim.bin"
; ---------------------------------------------------------------------------

Obj_TitleTM:
		move.l	#Map_S3TitleBanner,$C(a0)		;S3DATA
		move.w	#$E500,$A(a0)		; Start at $A000
		move.w	#$188,$10(a0)
		move.w	#$EC,$14(a0)
		move.w	#$80,8(a0)
		move.b	#$C,7(a0)
		move.b	#4,6(a0)
		move.b	#1,$22(a0)
		move.l	#Obj_TitleTM_Display,(a0)

Obj_TitleTM_Display:
		tst.b	($FFFFFFD8).w
		bpl.s	locret_4968
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_4968:
		rts
; ---------------------------------------------------------------------------

Obj_TitleANDKnuckles:
		move.l	#Map_TitleANDKnuckles,$C(a0)
		move.w	#$E4C0,$A(a0)		; Start at $9800
		move.w	#$120,$10(a0)
		move.w	#$108,$14(a0)
		move.w	#$80,8(a0)
		move.b	#$54,7(a0)
		move.b	#$C,6(a0)
		move.l	#Obj_TitleANDKnuckles_Display,(a0)

Obj_TitleANDKnuckles_Display:
		move.w	($FFFFB014).w,d0
		addi.w	#$5C,d0
		move.w	d0,$14(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Map_TitleANDKnuckles:	include "General\Title\Map - S3 ANDKnuckles.asm"

; ---------------------------------------------------------------------------

OldDebugCode:
		lea	(OldDebugCodeDat).l,a1
		move.w	($FFFFFFE6).w,d0
		adda.w	d0,a1
		move.b	($FFFFF749).w,d0
		andi.b	#$7F,d0
		beq.s	locret_4A10
		move.b	($FFFFF748).w,d0
		cmp.b	(a1),d0
		bne.s	loc_4A0A
		addq.w	#1,($FFFFFFE6).w
		tst.b	1(a1)
		bne.s	locret_4A10
		move.w	#$101,($FFFFFFE2).w
		moveq	#-$47,d0
		bsr.w	Play_Sound_2

loc_4A0A:
		move.w	#0,($FFFFFFE6).w

locret_4A10:

		rts
; ---------------------------------------------------------------------------
OldDebugCodeDat:dc.b $20
		dc.b $30
		dc.b $70
		dc.b $10
		dc.b $50
		dc.b $70
		dc.b $40
		dc.b $60
		dc.b $70
		dc.b $71
		dc.b $72
		dc.b 0
; ---------------------------------------------------------------------------

Obj_TitleCopyright:
		move.l	#Map_TitleScreenText,$C(a0)
		move.w	#$E680,$A(a0)		; Start at $D000 VRAM
		move.w	#$158,$10(a0)
		move.w	#$14C,$14(a0)
		move.w	#$80,8(a0)
		move.b	#$C,7(a0)
		move.b	#4,6(a0)
		move.b	#3,$22(a0)
		move.l	#Obj_TitleCopyright_Display,(a0)

Obj_TitleCopyright_Display:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_TitleSelection:
		move.w	#$F0,$10(a0)
		move.w	#$140,$14(a0)
		move.l	#Map_TitleScreenText,$C(a0)
		move.w	#$C680,$A(a0)		; Start at $D000 VRAM
		andi.b	#1,($FFFFFF86).w
		move.b	($FFFFFF86).w,$22(a0)
		move.l	#Obj_TitleSelection_Main,(a0)

Obj_TitleSelection_Main:
		moveq	#0,d2
		move.b	($FFFFFF86).w,d2
		move.b	($FFFFF605).w,d0
		or.b	($FFFFF607).w,d0
		btst	#0,d0
		beq.s	loc_4AAE
		subq.b	#1,d2
		bcc.s	loc_4AAE
		move.b	#2,d2
		tst.b	($FFFFFFE0).w		; If level select is on, maximum choices are 3
		bne.s	loc_4AAE
		move.b	#1,d2

loc_4AAE:

		btst	#1,d0
		beq.s	loc_4AC8
		addq.b	#1,d2
		tst.b	($FFFFFFE0).w		; See above
		bne.s	loc_4AC0
		andi.b	#1,d2

loc_4AC0:
		cmpi.b	#3,d2
		bcs.s	loc_4AC8
		moveq	#0,d2

loc_4AC8:

		move.b	d2,$22(a0)
		move.b	d2,($FFFFFF86).w
		andi.b	#3,d0
		beq.s	loc_4ADE
		moveq	#$5B,d0
		jsr	(Play_Sound_2).l		; Only play sound if selection was changed

loc_4ADE:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_TitleSonicFinger:
		move.l	#Map_TitleSonicAnim,$C(a0)
		move.w	#$A400,$A(a0)		; Start at $8000 VRAM
		move.w	#$148,$10(a0)
		move.w	#$DC,$14(a0)
		move.w	#$180,8(a0)
		move.b	#$18,7(a0)
		move.b	#$1C,6(a0)
		move.l	#Obj_TitleSonicFinger_Display,(a0)

Obj_TitleSonicFinger_Display:
		move.w	#$DC,d0
		sub.w	($FFFFF616).w,d0
		move.w	d0,$14(a0)
		lea	(Ani_TitleSonicFinger).l,a1
		jsr	(Animate_Sprite).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Ani_TitleSonicFinger:	include "General\Title\Anim - S3 Sonic Finger.asm"

; ---------------------------------------------------------------------------

Obj_TitleSonicWink:
		move.l	#Map_TitleSonicAnim,$C(a0)
		move.w	#$A400,$A(a0)		; Start at $8000 VRAM
		move.w	#$F8,$10(a0)
		move.w	#$C8,$14(a0)
		move.w	#$180,8(a0)
		move.b	#$10,7(a0)
		move.b	#$18,6(a0)
		move.l	#Obj_TitleSonicWink_Display,(a0)

Obj_TitleSonicWink_Display:
		move.w	#$C8,d0
		sub.w	($FFFFF616).w,d0
		move.w	d0,$14(a0)
		lea	(Ani_TitleSonicWink).l,a1
		jsr	(Animate_SpriteIrregularDelay).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Ani_TitleSonicWink:	include "General\Title\Anim - S3 Sonic Wink.asm"

; ---------------------------------------------------------------------------

Obj_TitleTailsPlane:
		move.l	#Map_TitleTailsPlane,$C(a0)
		move.w	#$6400,$A(a0)		; Start at $8000 VRAM
		move.w	#0,$10(a0)
		move.w	#$C0,$14(a0)
		move.w	#$380,8(a0)
		move.b	#$18,7(a0)
		move.b	#8,6(a0)
		move.l	#Obj_TitleTailsPlane_Main,(a0)

Obj_TitleTailsPlane_Main:
		tst.b	$30(a0)
		bne.s	loc_4C0A
		addq.w	#1,$10(a0)
		cmpi.w	#$240,$10(a0)
		bne.s	loc_4C08
		move.b	#1,$30(a0)
		bset	#0,$2A(a0)
		move.w	#$D0,$14(a0)

loc_4C08:
		bra.s	loc_4C28
; ---------------------------------------------------------------------------

loc_4C0A:
		subq.w	#1,$10(a0)
		cmpi.w	#0,$10(a0)
		bne.s	loc_4C28
		move.b	#0,$30(a0)
		bclr	#0,$2A(a0)
		move.w	#$C0,$14(a0)

loc_4C28:

		lea	(Ani_TitleTailsPlane).l,a1
		jsr	(Animate_Sprite).l
		tst.b	4(a0)
		bpl.s	loc_4C3E
		bsr.w	S3_Level_Select_Code

loc_4C3E:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Ani_TitleTailsPlane:	include "General\Title\Anim - S3 Tails Plane.asm"


; =============== S U B R O U T I N E =======================================


S3_Level_Select_Code:

		rts
; End of function S3_Level_Select_Code

; ---------------------------------------------------------------------------
		lea	(LSelect3CodeDat).l,a1
		move.w	($FFFFFFE4).w,d0
		adda.w	d0,a1
		move.b	($FFFFF749).w,d0
		andi.b	#$7F,d0
		beq.s	locret_4C90
		move.b	($FFFFF748).w,d0
		cmp.b	(a1),d0
		bne.s	loc_4C8A
		addq.w	#1,($FFFFFFE4).w
		tst.b	1(a1)
		bne.s	locret_4C90
		move.w	#$101,($FFFFFFE0).w
		move.w	#$101,($FFFFFFE2).w
		moveq	#$33,d0
		bsr.w	Play_Sound_2

loc_4C8A:
		move.w	#0,($FFFFFFE4).w

locret_4C90:

		rts
; ---------------------------------------------------------------------------
LSelect3CodeDat:dc.b 1
		dc.b 1
		dc.b 2
		dc.b 2
		dc.b 1
		dc.b 1
		dc.b 1
		dc.b 1
		dc.b 0
		dc.b 0
Map_TitleScreenText:	include "General\Title\Map - S3 Screen Text.asm"

ArtNem_TitleScreenText:binclude "General\Title\Nemesis Art\SK Screen Text.bin"

Map_TitleSonicAnim:	include "General\Title\Map - S3 Sonic Anim.asm"

Map_TitleTailsPlane:	include "General\Title\Map - S3 Tails Plane.asm"

; ---------------------------------------------------------------------------

SK_Alone_Title_Screen:
		lea	(ArtKos_SKTitleScreenBG).l,a0
		lea	($FFFF0000).l,a1
		bsr.w	Kos_Decomp
		lea	(ArtKos_BigSEGA).l,a0
		bsr.w	Kos_Decomp
		lea	(ArtKos_SKTitle_SonicFall).l,a0		; Get title BG, Sega logo, and Sonic falling frame going
		bsr.w	Kos_Decomp
		move.w	a1,d3
		lsr.w	#1,d3
		move.l	#$FF0000,d1
		move.w	#0,d2
		move.w	#$E20,d3
		jsr	(Add_To_DMA_Queue).l		; DMA the BG first to $0 in VRAM
		move.l	#$FF1C40,d1
		move.w	#$9380,d2
		move.w	#$1640,d3
		jsr	(Add_To_DMA_Queue).l		; Then DMA the logo and Sonic falling frame to $9380 in VRAM
		lea	($FFFF4E00).l,a1
		lea	(ArtKos_SKTitle_DeathEgg).l,a0
		bsr.w	Kos_Decomp
		move.l	#$FF4E00,d1
		move.w	#$D000,d2
		move.w	#$720,d3
		jsr	(Add_To_DMA_Queue).l		; DMA the Death Egg title screen art to $D000 in VRAM
		lea	($FFFF5D00).l,a1
		lea	(ArtKos_SKTitle_Mountain).l,a0
		bsr.w	Kos_Decomp
		move.l	#$FF5D00,d1
		move.w	#$F400,d2
		move.w	#$150,d3
		jsr	(Add_To_DMA_Queue).l		; DMA the little section of mountain that is drawn above the Death Egg
		lea	($FFFF7400).l,a1
		lea	(MapEni_SKTitle_Sega).l,a0	; Get the SEGA logo mappings
		move.w	#$849C,d0
		bsr.w	Eni_Decomp
		tst.b	($FFFFFFD8).w
		bmi.s	loc_5122
		move.w	#$A49C,d0
		move.w	d0,($FFFF775C).l
		move.w	d0,($FFFF775E).l
		move.w	d0,($FFFF7760).l
		move.w	d0,($FFFF77AC).l
		move.w	d0,($FFFF77AE).l
		move.w	d0,($FFFF77B0).l		; Remove the TM from the Sega logo if on a Japan console

loc_5122:
		lea	($FFFF7400).l,a1
		move.l	#$40000003,d0
		moveq	#$27,d1
		moveq	#$1B,d2
		jsr	(Plane_Map_To_VRAM).l		; Copy Sega logo mappings to VRAM location $C000
		lea	($FFFF7CC0).l,a1
		lea	(MapEni_SKTitle_Background).l,a0
		move.w	#0,d0
		bsr.w	Eni_Decomp
		lea	($FFFF7CC0).l,a1
		move.l	#$60000003,d0
		bsr.w	RAM_Map_Data_To_VDP		; Copy SK Title Background mappings to VRAM location $E000
		lea	($FFFF8580).w,a1
		lea	(MapEni_SKTitle_Frame1).l,a0
		move.w	#$80E2,d0
		bsr.w	Eni_Decomp
		lea	($FFFF8E40).w,a1
		lea	(MapEni_SKTitle_Frame2).l,a0
		move.w	#$80E2,d0
		bsr.w	Eni_Decomp
		lea	($FFFF9700).w,a1
		lea	(MapEni_SKTitle_Frame3).l,a0
		move.w	#$80E2,d0
		bsr.w	Eni_Decomp
		lea	($FFFF9FC0).w,a1
		lea	(MapEni_SKTitle_Frame4).l,a0
		move.w	#$80E2,d0
		bsr.w	Eni_Decomp
		lea	(ArtKos_SKTitle_SonKnuxHand).l,a1
		lea	($FFFF4800).l,a2
		jsr	(Queue_Kos).l		; Queue the Sonic/Knuckles hand animation art
		lea	($FFFFFC80).w,a1
		moveq	#3,d1

loc_51BC:
		move.w	#0,(a1)+
		moveq	#$E,d0

loc_51C2:
		move.w	#$EEE,(a1)+		; Set up the palette to full white
		dbf	d0,loc_51C2
		dbf	d1,loc_51BC
		lea	(Pal_SKTitle_SegaBG).l,a0
		lea	($FFFFFCA0).w,a1
		moveq	#7,d0

loc_51DA:
		move.l	(a0)+,(a1)+		; Load Sega palette into the first F colors of pal line 1
		dbf	d0,loc_51DA
		move.w	#$B4,($FFFFF614).w	; Set vsync timer to 3 seconds (180 frames NTSC)
		btst	#6,($FFFFFFD8).w
		beq.s	loc_51F4
		move.w	#$96,($FFFFF614).w	; Set vsync timer to 3 seconds (150 frames PAL)

loc_51F4:
		move.w	($FFFFF60E).w,d0
		ori.b	#$40,d0
		move.w	d0,($C00004).l		; Turn the display on
		bsr.w	Pal_FadeFromBlack	; Fade to Sega screen
		moveq	#-1,d0				; SEGA sound
		bsr.w	Play_Sound

loc_520C:

		move.b	#$14,($FFFFF62A).w
		jsr	(Process_Kos_Queue).l
		bsr.w	Wait_VSync
		jsr	(Process_Kos_Module_Queue).l
		tst.b	($FFFFFF60).w
		bne.s	loc_520C			; Don't allow the game to continue until the Knuckles art has been decompressed
		move.b	($FFFFF605).w,d0
		andi.b	#$80,d0
		bne.w	loc_523A			; If start is pressed afterwards, skip to next part of title
		tst.w	($FFFFF614).w
		bne.s	loc_520C			; Otherwise, wait for vsync timer to run out

loc_523A:
		moveq	#-2,d0
		bsr.w	Play_Sound			; Stop the SEGA sound if necessary
		lea	(Pal_SKTitle_Sonic).l,a0
		lea	($FFFFFC80).w,a1
		moveq	#$1F,d0

loc_524C:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_524C				; Load the Sonic palette and Sega palette
		lea	(ArtKosM_SonicKnuxStand).l,a1
		move.w	#$1C40,d2
		jsr	(Queue_Kos_Module).l	; Cue the art Sonic and Knuckles standing
		move.w	#$3F,($FFFFF626).w
		move.w	#$16,($FFFFEE50).w	; Number of frames to fade from white
		move.l	#Obj_SKTitle_SonicFall,($FFFFB000).w
		move.l	#Obj_SKTitle_DeathEgg,($FFFFB04A).w
		move.l	#Obj_SKTitle_Mountain,($FFFFB094).w
		moveq	#$25,d0
		bsr.w	Play_Sound			; Play the title screen music
		move.b	#3,($FFFFFE12).w
		move.w	#$438,($FFFFF614).w	; 18 second delay (1080 frames NTSC)
		btst	#6,($FFFFFFD8).w
		beq.s	loc_52A6
		move.w	#$384,($FFFFF614).w	; 18 second delay (900 frames PAL)

loc_52A6:

		move.b	#$1A,($FFFFF62A).w
		jsr	(Process_Kos_Queue).l
		bsr.w	Wait_VSync
		tst.w	($FFFFEE50).w
		beq.s	loc_52C4
		subq.w	#1,($FFFFEE50).w
		bsr.w	Pal_FromWhite		; Fade from white for set number of frames

loc_52C4:
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		bsr.w	SKTitle_DeformBG
		jsr	(Process_Kos_Module_Queue).l
		move.b	($FFFFF605).w,d0
		andi.b	#$80,d0
		bne.w	loc_52F0			; If start is pressed, branch
		tst.l	($FFFFB0DE).w		; test if banner object has been created
		beq.s	loc_52A6			; If not, continue with the above
		bra.w	loc_537C
; ---------------------------------------------------------------------------

loc_52F0:
		tst.w	($FFFFEE50).w
		bne.s	loc_52A6			; If palette fade hasn't completed, go back
		lea	($FFFFB128).w,a0
		bsr.w	Obj_SKTitle_HandAnim	; Initialize Hand animation object
		move.l	#Obj_SKTitle_DeathEggShake,($FFFFB04A).w	; Change Death Egg object to second phase
		move.w	#$140,($FFFFB078).l
		move.w	#$70,($FFFFB07C).l		; Set its proper position
		move.w	#3,($FFFFEEC0).w		; Put title routine counter to max
		moveq	#0,d0
		move.w	d0,($FFFFEECC).w		; Turn off shaking
		move.w	#$100,d0
		move.w	d0,($FFFFF618).w
		move.w	d0,($FFFFF618).w
		move.w	d0,($FFFFEE7C).w
		move.w	d0,($FFFFEE64).w		; Set all Y scrolls to $100
		lea	(Pal_SKTitle_Knux).l,a0
		lea	($FFFFFC20).w,a2
		moveq	#7,d0

loc_5342:
		move.l	(a0),$80(a2)
		move.l	(a0)+,(a2)+				; Change to Knuckles palette
		dbf	d0,loc_5342
		bsr.w	SKTitle_DeformBG		; Deform the BG to apply the changes
		move.b	#$1A,($FFFFF62A).w
		bsr.w	Wait_VSync				; Refresh the screen
		move	#$2700,sr
		lea	($FFFF7CC0).l,a1
		move.l	#$60000003,d0
		moveq	#$27,d1
		moveq	#$1B,d2
		jsr	(Plane_Map_To_VRAM).l		; Load the background
		lea	($FFFFB000).w,a0
		bsr.w	Obj_SKTitle_SonicFallFinish		; Finish the sonic fall object
loc_537C:

		move.b	#$1A,($FFFFF62A).w
		jsr	(Process_Kos_Queue).l
		bsr.w	Wait_VSync
		tst.w	($FFFFEE50).w
		beq.s	loc_539A
		subq.w	#1,($FFFFEE50).w
		bsr.w	Pal_FromWhite

loc_539A:
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		bsr.w	SKTitle_DeformBG
		jsr	(Process_Kos_Module_Queue).l
		bsr.w	S3_Level_Select_Code	; This routine is dummied out
		tst.l	($FFFFB172).w
		beq.s	loc_537C			; If menu object isn't loaded, branch
		tst.w	($FFFFF614).w
		beq.w	loc_546C			; If timer has run out, branch forward
		move.b	($FFFFF605).w,d0
		andi.b	#$80,d0
		beq.w	loc_537C			; If start is not pressed, branch back
		move.b	#$C,($FFFFF600).w	; Play a level
		move.b	#3,($FFFFFE12).w
		move.b	#3,($FFFFFEC6).w
		moveq	#0,d0
		move.w	d0,($FFFFFE20).w
		move.l	d0,($FFFFFE22).w
		move.l	d0,($FFFFFE26).w
		move.w	d0,($FFFFFED0).w
		move.l	d0,($FFFFFED2).w
		move.l	d0,($FFFFFED6).w
		move.b	d0,($FFFFFE18).w
		move.l	#$1388,($FFFFFFC0).w
		move.l	#$1388,($FFFFFFC4).w
		moveq	#-$1F,d0
		bsr.w	Play_Sound_2
		moveq	#0,d0
		move.b	($FFFFFF86).w,d0
		cmpi.b	#2,d0
		bcc.w	loc_5464
		add.w	d0,d0
		addq.w	#1,d0
		move.w	d0,($FFFFFF0A).w
		move.w	#$700,d0
		move.w	d0,($FFFFFE10).w
		move.w	d0,($FFFFEE4E).w
		move.w	d0,($FFFFFE2C).w
		clr.w	($FFFFFE16).w
		clr.w	($FFFFFFB0).w
		clr.l	($FFFFFFB2).w
		clr.w	($FFFFFFB6).w
		clr.b	($FFFFFFB8).w
		clr.l	($FFFFFF92).w
		clr.l	($FFFFE660).w
		tst.b	($FFFFFFE0).w
		beq.s	locret_546A
		btst	#6,($FFFFF604).w
		beq.s	locret_546A

loc_5464:
		move.b	#$28,($FFFFF600).w

locret_546A:

		rts
; ---------------------------------------------------------------------------

loc_546C:
		moveq	#-$1F,d0			; Start demo by fading out music
		bsr.w	Play_Sound_2
		move.w	($FFFFFFD2).w,d0	; Get demo number
		cmpi.w	#3,d0
		bcc.s	loc_547E
		moveq	#3,d0

loc_547E:
		move.w	d0,($FFFFFFD2).w
		move.w	d0,($FFFFEF7A).w
		andi.w	#7,d0
		add.w	d0,d0
		lea	DemoLevels(pc),a0
		move.w	(a0,d0.w),d0		; Get the right demo level
		move.w	d0,($FFFFFE10).w
		move.w	d0,($FFFFEE4E).w
		move.w	d0,($FFFFFE2C).w	; Move it to various level ID locations
		move.w	($FFFFFFD2).w,d1
		addq.w	#1,d1
		cmpi.w	#7,d1
		bcs.s	loc_54AE
		moveq	#3,d1

loc_54AE:
		move.w	d1,($FFFFFFD2).w
		tst.w	d0
		bpl.s	loc_54E0
		move.b	#$34,($FFFFF600).w	; Special stage
		move.b	#1,($FFFFFE16).w
		move.b	#1,($FFFFFFBB).w
		move.b	#7,($FFFFFE10).w
		clr.w	($FFFFFFB0).w
		clr.l	($FFFFFFB2).w
		clr.w	($FFFFFFB6).w
		clr.b	($FFFFFFB8).w
		bra.s	loc_54F0
; ---------------------------------------------------------------------------

loc_54E0:
		cmpi.w	#$700,d0
		bne.s	loc_54EA
		jsr	Prep_MHZDemo(pc)			; If doing Mushroom Hill demo, do this routine

loc_54EA:
		move.b	#8,($FFFFF600).w

loc_54F0:
		move.w	#1,($FFFFFFD0).w
		move.b	#3,($FFFFFE12).w
		move.b	#3,($FFFFFEC6).w
		moveq	#0,d0
		move.w	d0,($FFFFFE20).w
		move.l	d0,($FFFFFE22).w
		move.l	d0,($FFFFFE26).w
		move.w	d0,($FFFFFED0).w
		move.l	d0,($FFFFFED2).w
		move.l	d0,($FFFFFED6).w
		move.l	#$1388,($FFFFFFC0).w
		move.l	#$1388,($FFFFFFC4).w
		rts

; =============== S U B R O U T I N E =======================================


Prep_MHZDemo:
		move.w	#$6F4,($FFFFFE2E).w
		move.w	#$9EC,($FFFFFE30).w
		move.b	#1,($FFFFFE2A).w
		move.b	#1,($FFFFFE2B).w
		move.w	d0,($FFFFFE2C).w
		move.w	d0,($FFFFFF9A).w
		move.w	#$680,($FFFFFE38).w
		move.w	#$C0D,($FFFFFE3A).w
		clr.w	($FFFFFE32).w
		clr.b	($FFFFFE43).w
		clr.l	($FFFFFE34).w
		clr.b	($FFFFFE46).w
		move.w	#$AA0,($FFFFFE44).w
		move.w	#$680,($FFFFFE3C).w
		move.w	#$98C,($FFFFFE3E).w
		move.w	#$1000,($FFFFFE40).w
		clr.b	($FFFFFE42).w
		rts
; End of function Prep_MHZDemo

; ---------------------------------------------------------------------------
Pal_SKTitle_Sonic:	binclude "General\Title\Palettes\SK Sonic.bin"	;5588.bin"

Pal_SKTitle_SegaBG:	binclude "General\Title\Palettes\SK Sega and BG.bin"	;55A8.bin"

Pal_SKTitle_Knux:	binclude "General\Title\Palettes\SK Knuckles.bin"	;5608.bin"


; ---------------------------------------------------------------------------

Obj_SKTitle_SonicFall:
		move.l	#Map_SKTitle_SonicFall,$C(a0)
		move.w	#$4EF,$A(a0)
		move.w	#$E8,$10(a0)
		move.w	#$16,$14(a0)	; Set position of falling Sonic sprite
		move.w	#$80,8(a0)
		move.b	#$68,7(a0)
		move.b	#$70,6(a0)		; Set effective size of sprite
		move.l	#Obj_SKTitle_SonicFallMain,(a0)

Obj_SKTitle_SonicFallMain:
		cmpi.w	#$F0,$14(a0)
		beq.s	loc_5666
		addq.w	#1,$14(a0)		; Slowly move Sonic downwards

loc_5666:
		cmpi.w	#3,($FFFFEEC0).w
		bne.s	loc_56AA		; Wait until the proper phase of the title sequence
		ori.w	#$8000,$A(a0)	; Modify the priority of the sprite
		cmpi.w	#$E0,($FFFFEE7C).w
		bcc.s	loc_56B0		; If the foreground Y is past $E0, branch
		addq.w	#8,($FFFFEE7C).w	; Otherwise scroll foreground by 8 pixels
		cmpi.w	#$C8,($FFFFEE7C).w
		bne.s	loc_5698
		lea	(ArtKosM_SonicLand).l,a1 ; Once foreground has hit C8 Y
		move.w	#$8C40,d2
		jsr	(Queue_Kos_Module).l	; Queue the landing frames into VRAM

loc_5698:
		lea	($FFFF8580).w,a1		; First frame data (Knuckles only)
		move.l	#$40000003,d0
		move.w	($FFFFEE7C).w,d1
		bsr.w	Copy_Map_Line_To_VRAM	; Since the nametable is only 32 tiles high, we can't copy the first foreground mapping frame for Sonic and Knuckles wholesale.
										; We set up each line of mappings data every time the screen scrolls down further

loc_56AA:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_56B0:
		bne.s	loc_56D4
		move	#$2700,sr		; Only do this when screen scrolling has his E0 Y
		lea	($FFFF8E40).w,a1	; Second frame data (Sonic lands)
		move.l	#$40000003,d0
		moveq	#$27,d1
		moveq	#$1B,d2
		jsr	(Plane_Map_To_VRAM).l	; Copy the frame data
		move	#$2300,sr
		move.b	#6,$24(a0)			; Set up an internal timer

loc_56D4:
		cmpi.w	#$100,($FFFFEE7C).w
		beq.s	loc_56E2			; When screen has hit $100 Y, branch
		addq.w	#8,($FFFFEE7C).w
		rts
; ---------------------------------------------------------------------------

loc_56E2:
		move.l	#Obj_SKTitle_SonicFallLand,(a0)

Obj_SKTitle_SonicFallLand:
		subq.b	#1,$24(a0)
		bpl.s	locret_5716
		move	#$2700,sr
		lea	($FFFF9700).w,a1	; Get third mapping frame (Sonic starting to stand)
		move.l	#$40000003,d0
		moveq	#$27,d1
		moveq	#$1B,d2
		jsr	(Plane_Map_To_VRAM).l
		move	#$2300,sr
		move.b	#4,$24(a0)
		move.l	#Obj_SKTitle_SonicFallLand_2,(a0)

locret_5716:
		rts
; ---------------------------------------------------------------------------

Obj_SKTitle_SonicFallLand_2:
		subq.b	#1,$24(a0)
		bpl.s	Obj_SKTitle_SonicFallEnd

; =============== S U B R O U T I N E =======================================


Obj_SKTitle_SonicFallFinish:
		move	#$2700,sr
		lea	($FFFF9FC0).w,a1		; Get last mapping frame (Sonic and Knuckles standing properly)
		move.l	#$40000003,d0
		moveq	#$27,d1
		moveq	#$1B,d2
		jsr	(Plane_Map_To_VRAM).l
		move	#$2300,sr
		lea	(ArtKosM_SKTitle_Banner).l,a1
		move.w	#$9DC0,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_SKTitle_Menu).l,a1
		move.w	#$8C40,d2
		jsr	(Queue_Kos_Module).l					; Set up the banner and menu graphics to replace the landing graphics
		move.l	#Obj_SKTitle_Banner,($FFFFB0DE).w
		move.b	#$1E,($FFFFB102).w					; $24 of object set to $1E
		move.l	#Obj_SKTitle_SonicFallEnd,(a0)		; Disable object

Obj_SKTitle_SonicFallEnd:

		rts
; End of function Obj_SKTitle_SonicFallFinish

; ---------------------------------------------------------------------------

Obj_SKTitle_DeathEgg:
		move.l	#Map_SKTitle_DeathEgg,$C(a0)
		move.w	#$4680,$A(a0)
		move.w	#$140,$10(a0)
		move.w	#$B0,$14(a0)
		move.w	#$180,8(a0)
		move.b	#$40,7(a0)
		move.b	#$40,6(a0)
		move.l	#Obj_SKTitle_DeathEggMain,(a0)

Obj_SKTitle_DeathEggMain:
		cmpi.w	#$F0,$14(a0)
		beq.s	loc_57D8				; If death egg has reached volcano, branch
		addi.l	#$8000,$14(a0)			; Move death egg sprite downward
		cmpi.w	#$100,($FFFFEE64).w
		beq.s	loc_57D2
		addq.w	#1,($FFFFEE64).w		; Scroll screen downwards
		lea	($FFFF7CC0).l,a1
		move.l	#$60000003,d0
		move.w	($FFFFEE64).w,d1
		bsr.w	Copy_Map_Line_To_VRAM		; Update second nametable with background mappings as the screen scrolls down

loc_57D2:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_57D8:
		move.l	$10(a0),$2E(a0)
		move.l	$14(a0),$32(a0)			; Backup position values
		move.w	#$8000,($FFFFEE66).w
		move.w	#$22,($FFFFEED2).w
		move.w	#1,($FFFFEEC0).w
		move.w	#$1E,($FFFFEECC).w
		move.l	#Obj_SKTitle_DeathEggShake,(a0)

Obj_SKTitle_DeathEggShake:

		bsr.w	SKTitle_ScreenShake
		cmpi.w	#$100,($FFFFEE64).w
		beq.s	loc_5832
		subi.l	#$8000,$32(a0)			; Move Death Egg backwards to keep up with scroll
		addi.l	#$8000,($FFFFEE64).w
		lea	($FFFF7CC0).l,a1
		move.l	#$60000003,d0
		move.w	($FFFFEE64).w,d1
		bsr.w	Copy_Map_Line_To_VRAM	; Continue drawing mapping lines

loc_5832:
		move.w	$2E(a0),d0
		move.w	$32(a0),d1
		tst.w	($FFFFEECC).w
		beq.s	loc_5848
		sub.w	($FFFFEE68).w,d0
		sub.w	($FFFFEE6C).w,d1		; Shake Death Egg along with screen

loc_5848:
		move.w	d0,$10(a0)
		move.w	d1,$14(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_SKTitle_Mountain:
		move.l	#Map_SKTitle_Mountain,$C(a0)		; The top of the mountain is a sprite so it can cover the death egg
		move.w	#$67A0,$A(a0)
		move.w	#$100,8(a0)
		move.b	#$30,7(a0)
		move.b	#8,6(a0)
		move.l	#Obj_SKTitle_MountainMain,(a0)

Obj_SKTitle_MountainMain:
		move.w	#$140,d0
		move.w	#$1A8,d1
		sub.w	($FFFFEE60).w,d0
		sub.w	($FFFFEE64).w,d1
		tst.w	($FFFFEECC).w
		beq.s	loc_589A
		sub.w	($FFFFEE68).w,d0
		sub.w	($FFFFEE6C).w,d1

loc_589A:
		move.w	d0,$10(a0)
		move.w	d1,$14(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_SKTitle_Banner:
		subq.b	#1,$24(a0)
		beq.s	loc_58B0		; Wait for the timer to finish
		rts
; ---------------------------------------------------------------------------

loc_58B0:
		move.l	#Map_SKTitle_Banner,$C(a0)
		move.w	#$84EE,$A(a0)
		move.w	#0,8(a0)
		move.b	#$7C,7(a0)
		move.b	#$28,6(a0)	; Set up sprite size and priority
		move.w	#$120,$10(a0)
		move.w	#$180,$14(a0)	; Position sprite below the screen
		move.w	#$400,$1A(a0)	; Set up Y velocity
		move.l	#-$600000,$30(a0)	; Set up Y position offset
		move.l	#Obj_SKTitle_BannerMain,(a0)

Obj_SKTitle_BannerMain:
		move.b	$34(a0),d2
		move.w	$1A(a0),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$30(a0)	; Add velocity to Y offset
		move.w	$30(a0),d0
		move.b	#0,$34(a0)	; Set direction toggle flag
		move.w	#$40,d1
		cmpi.w	#0,d0
		blt.s	loc_5950	; If offset is negative, branch
		bne.s	loc_5946	; If offset is positive and nonzero, branch
		cmpi.w	#$FFA5,$1A(a0)
		bne.s	loc_5946	; Branch if the velocity isn't small enough
		move.l	#Obj_SKTitle_BannerDisplay,(a0)
		move.l	#Obj_SKTitle_Icon,($FFFFB172).w
		move.l	#Obj_SKTitle_Icon2,($FFFFB1BC).w
		move.l	#Obj_SKTitle_TM,($FFFFB206).w
		move.l	#Obj_SKTitle_Copyright,($FFFFB250).w		; Set up menu items and the like
		bra.s	loc_595E
; ---------------------------------------------------------------------------

loc_5946:

		move.b	#-1,$34(a0)		; This is all to perform the bobbing motion into place
		move.w	#$FFC0,d1

loc_5950:
		add.w	d1,$1A(a0)
		cmp.b	$34(a0),d2
		beq.s	loc_595E
		asr	$1A(a0)

loc_595E:

		move.w	$30(a0),d0
		neg.w	d0
		addi.w	#$118,d0
		move.w	d0,$14(a0)

Obj_SKTitle_BannerDisplay:
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


Obj_SKTitle_HandAnim:

		move.l	#$FFFF4800,d1
		move.w	#$1C60,d2
		move.w	#$30,d3
		jsr	(Add_To_DMA_Queue).l
		move.l	#$FFFF4E40,d1
		move.w	#$1CC0,d2
		move.w	#$290,d3
		jsr	(Add_To_DMA_Queue).l	; Load the correct initial art
		move.b	#$B4,$30(a0)
		move.l	#Obj_SKTitle_HandAnimMain,(a0)

Obj_SKTitle_HandAnimMain:
		lea	(SKTitle_AnimSmile).l,a1
		lea	$30(a0),a2
		bsr.w	SKTitle_AnimateHands
		bmi.s	loc_59D0
		lea	($FFFF4800).l,a1
		lea	(a1,d0.w),a1
		move.l	a1,d1
		move.w	#$1C60,d2
		move.w	#$30,d3
		jsr	(Add_To_DMA_Queue).l

loc_59D0:
		lea	(SKTitle_AnimFinger).l,a1
		lea	$32(a0),a2
		bsr.w	SKTitle_AnimateHands
		bmi.s	loc_59FA
		lea	($FFFF4920).l,a1
		lea	(a1,d0.w),a1
		move.l	a1,d1
		move.w	#$1CC0,d2
		move.w	#$290,d3
		jsr	(Add_To_DMA_Queue).l

loc_59FA:
		lea	(SKTitle_AnimKnuckle1).l,a1
		lea	$34(a0),a2
		bsr.w	SKTitle_AnimateHands
		bmi.s	loc_5A24
		lea	($FFFF5880).l,a1
		lea	(a1,d0.w),a1
		move.l	a1,d1
		move.w	#$21E0,d2
		move.w	#$2F0,d3
		jsr	(Add_To_DMA_Queue).l

loc_5A24:
		lea	(SKTitle_AnimKnuckle2).l,a1
		lea	$36(a0),a2
		bsr.w	SKTitle_AnimateHands
		bmi.s	locret_5A4E
		lea	($FFFF6A20).l,a1
		lea	(a1,d0.w),a1
		move.l	a1,d1
		move.w	#$27C0,d2
		move.w	#$140,d3
		jsr	(Add_To_DMA_Queue).l

locret_5A4E:
		rts
; End of function Obj_SKTitle_HandAnim


; =============== S U B R O U T I N E =======================================


SKTitle_AnimateHands:
		subq.b	#1,(a2)
		bcc.s	loc_5A6C
		move.b	(a1),(a2)
		moveq	#0,d1
		move.b	1(a2),d1
		move.b	1(a1,d1.w),d0
		bmi.s	loc_5A70

loc_5A62:
		addq.b	#1,1(a2)
		ext.w	d0
		lsl.w	#5,d0
		rts
; ---------------------------------------------------------------------------

loc_5A6C:
		moveq	#-1,d0
		rts
; ---------------------------------------------------------------------------

loc_5A70:
		addq.b	#1,d0
		bne.s	loc_5A80
		move.b	#0,1(a2)
		move.b	1(a1),d0
		bra.s	loc_5A62
; ---------------------------------------------------------------------------

loc_5A80:
		addq.b	#1,d0
		bne.s	loc_5A6C
		move.b	2(a1,d1.w),d0
		sub.b	d0,1(a2)
		sub.b	d0,d1
		move.b	1(a1,d1.w),d0
		bra.s	loc_5A62
; End of function sub_5A50

; ---------------------------------------------------------------------------
SKTitle_AnimSmile:	dc.b	5,   0,	  3,   6, $FE,	 1
SKTitle_AnimFinger:	dc.b    3, $29, $29, $29, $29, $29, $29, $29, $29, $29, $29, $29, $29, $29, $29, $29, $29, $29, $29, $29
		dc.b  $29, $29, $29, $29, $29, $29, $29, $29, $29, $29, $29, $29, $29,   0,   0, $29, $52, $29,   0, $29
		dc.b  $52, $29,   0, $29, $52, $29, $FF
SKTitle_AnimKnuckle1:	dc.b	3,   0,	  0,   0,   0,	 0,   0,   0,	0, $2F,	$5E, $2F,   0, $2F, $5E, $2F, $FF

SKTitle_AnimKnuckle2:	dc.b	3,   0,	  0, $14, $28, $14,   0,   0, $FF,   0

; ---------------------------------------------------------------------------

Obj_SKTitle_Icon:
		move.w	#$108,$10(a0)
		move.w	#$150,$14(a0)
		move.w	$10(a0),$44(a0)
		move.w	$14(a0),$46(a0)
		move.l	#Map_SKTitle_Icon,$C(a0)
		move.w	#$8462,$A(a0)
		bset	#6,4(a0)		; Turn on multi-sprite mode
		lea	$18(a0),a2
		move.w	#2,$16(a0)
		move.w	$10(a0),(a2)+
		move.w	$14(a0),(a2)+	; First sprite is the sonic/knuckles icon
		move.w	#0,(a2)+
		andi.b	#1,($FFFFFF86).w
		move.b	($FFFFFF86).w,d0
		ror.b	#1,d0
		move.b	d0,$26(a0)
		move.b	#8,$27(a0)
		move.l	#Obj_SKTitle_IconDisplay,(a0)

Obj_SKTitle_IconDisplay:
		moveq	#0,d2
		move.b	($FFFFFF86).w,d2	; Get current selection
		move.b	$26(a0),d0
		andi.b	#$7F,d0
		bne.s	loc_5B9E			; If selection is currently, being rotated, branch
		move.b	($FFFFF605).w,d0
		btst	#0,d0
		beq.s	loc_5B6E
		subq.b	#8,$26(a0)			; if down was pressed, rotate backwards
		move.b	#-8,$27(a0)
		subq.b	#1,d2
		bcc.s	loc_5B6E
		move.b	#1,d2

loc_5B6E:

		btst	#1,d0
		beq.s	loc_5B8C
		addq.b	#8,$26(a0)			; if up was pressed, rotate forward
		move.b	#8,$27(a0)
		addq.b	#1,d2
		andi.b	#1,d2
		cmpi.b	#3,d2
		bcs.s	loc_5B8C
		moveq	#0,d2

loc_5B8C:

		move.b	d2,($FFFFFF86).w	; Move selection
		andi.b	#3,d0
		beq.s	loc_5B9E
		moveq	#$5B,d0
		jsr	(Play_Sound_2).l		; Only play sound if selection was made

loc_5B9E:

		move.b	$26(a0),d0
		andi.b	#$7F,d0
		beq.s	loc_5BB0
		move.b	$27(a0),d0			; Perform rotation if necessary
		add.b	d0,$26(a0)

loc_5BB0:
		move.b	$26(a0),d0			; Get rotation angle
		addi.b	#$98,d0
		jsr	(GetSineCosine).l
		muls.w	#5,d1
		muls.w	#5,d0
		asr.l	#8,d1
		asr.l	#8,d0				; Convert to X/Y coordinates
		move.w	d1,d3
		move.w	d0,d2
		add.w	$44(a0),d1
		add.w	$46(a0),d0
		neg.w	d3
		neg.w	d2
		add.w	$44(a0),d3
		add.w	$46(a0),d2
		moveq	#0,d4
		moveq	#2,d5
		move.b	$26(a0),d6
		subi.b	#$A0,d6
		bpl.s	loc_5BF6
		exg	d1,d3		; Exchange attributes of Sonic/Knuckles text sprites depending on the rotation angle
		exg	d0,d2
		exg	d4,d5

loc_5BF6:
		addq.b	#1,d5
		lea	$18(a0),a2
		move.w	d1,(a2)+
		move.w	d0,(a2)+
		move.w	d4,(a2)+
		move.w	d3,(a2)+
		move.w	d2,(a2)+
		move.b	d5,1(a2)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_SKTitle_Icon2:
		move.w	#$D0,$10(a0)
		move.w	#$14C,$14(a0)
		move.l	#Map_SKTitle_Icon,$C(a0)
		move.w	#$8462,$A(a0)
		move.b	($FFFFFF86).w,d0
		move.b	d0,$20(a0)
		move.b	d0,$21(a0)
		move.b	#1,$23(a0)
		move.l	#Obj_SKTitle_Icon2Display,(a0)

Obj_SKTitle_Icon2Display:
		move.b	($FFFFFF86).w,$20(a0)
		lea	(Ani_SKTitle_Icon).l,a1
		jsr	(Animate_Sprite).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Ani_SKTitle_Icon:	include "General\Title\Anim - SK Icon.asm"

; ---------------------------------------------------------------------------

Obj_SKTitle_TM:
		move.l	#Map_SKTitle_TM,$C(a0)
		move.w	#$8462,$A(a0)
		move.w	#$1A2,$10(a0)
		move.w	#$11D,$14(a0)
		move.w	#$80,8(a0)
		move.b	#8,7(a0)
		move.b	#4,6(a0)
		move.l	#Obj_SKTitle_TMDisplay,(a0)

Obj_SKTitle_TMDisplay:
		tst.b	($FFFFFFD8).w
		bpl.s	locret_5CAE
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_5CAE:
		rts
; ---------------------------------------------------------------------------

Obj_SKTitle_Copyright:
		move.l	#Map_SKTitle_Copyright,$C(a0)
		move.w	#$8462,$A(a0)
		move.w	#$17F,$10(a0)
		move.w	#$152,$14(a0)
		move.w	#$80,8(a0)
		move.b	#$2C,7(a0)
		move.b	#4,6(a0)
		move.l	#Obj_SKTitle_CopyrightDisplay,(a0)

Obj_SKTitle_CopyrightDisplay:
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


Copy_Map_Line_To_VRAM:

		subi.w	#$10,d1
		bcs.s	locret_5D22
		move.w	d1,d3
		andi.w	#7,d3
		bne.s	locret_5D22
		andi.w	#$F8,d1
		move.w	d1,d2
		add.w	d1,d1
		move.w	d1,d3
		lsl.w	#2,d1
		add.w	d3,d1
		lea	(a1,d1.w),a1
		lsl.w	#4,d2
		swap	d0
		add.w	d2,d0
		swap	d0
		moveq	#$27,d3
		lea	($C00000).l,a6
		move	#$2700,sr
		bsr.s	sub_5D42
		move	#$2300,sr

locret_5D22:
		rts
; End of function Copy_Map_Line_To_VRAM


; =============== S U B R O U T I N E =======================================


RAM_Map_Data_To_VDP:
		lea	($C00000).l,a6
		moveq	#$27,d1
		moveq	#$1F,d2

loc_5D2E:
		movea.l	a1,a2
		move.w	d1,d3
		bsr.s	sub_5D42
		movea.l	a2,a1
		addi.l	#$800000,d0
		dbf	d2,loc_5D2E
		rts
; End of function RAM_Map_Data_To_VDP


; =============== S U B R O U T I N E =======================================


sub_5D42:
		move.l	d0,4(a6)

loc_5D46:
		move.w	(a1)+,(a6)
		dbf	d3,loc_5D46
		rts
; End of function sub_5D42


; =============== S U B R O U T I N E =======================================


ClearVRAMArea:
		lea	($C00000).l,a6
		move.l	d0,4(a6)
		moveq	#0,d0

loc_5D5A:
		move.l	d0,(a6)
		dbf	d3,loc_5D5A
		rts
; End of function ClearVRAMArea


; =============== S U B R O U T I N E =======================================


SKTitle_ScreenShake:
		tst.w	($FFFFEECC).w
		beq.s	locret_5D92			; If timer has run out, don't do anything
		subq.w	#1,($FFFFEECC).w
		bne.s	loc_5D72
		addq.w	#1,($FFFFEEC0).w	; Increment title routine counter when this is done

loc_5D72:
		move.w	($FFFFFE0E).w,d0
		andi.w	#$3F,d0				; Get frame counter then AND it for offset
		lea	(SKTitle_ShakeOffsets).l,a1
		lea	(a1,d0.w),a1
		moveq	#0,d0
		move.b	(a1)+,d0
		move.w	d0,($FFFFEE6C).w
		move.b	(a1)+,d0
		move.w	d0,($FFFFEE68).w

locret_5D92:
		rts
; End of function SKTitle_ScreenShake


; =============== S U B R O U T I N E =======================================


SKTitle_DeformBG:

		move.w	($FFFFEE7C).w,($FFFFF616).w
		move.w	($FFFFEE64).w,($FFFFF618).w		; Move BG position values to their proper spots
		moveq	#0,d2
		tst.w	($FFFFEECC).w
		beq.s	loc_5DB8
		move.w	($FFFFEE6C).w,d0
		add.w	d0,($FFFFF616).w
		add.w	d0,($FFFFF618).w				; Shake the screen by the proper offsets if screen shaking is on
		move.w	($FFFFEE68).w,d2				; Move shake X amount to d2

loc_5DB8:
		lea	($FFFFE000).w,a1
		move.w	($FFFFEEC0).w,d0
		bne.s	loc_5DE0

loc_5DC2:
		move.w	#$DF,d1							; If routine counter is zero
		move.w	($FFFFEE78).w,d0
		add.w	d2,d0
		neg.w	d0
		swap	d0
		move.w	($FFFFEE60).w,d0
		add.w	d2,d0
		neg.w	d0

loc_5DD8:
		move.l	d0,(a1)+						; Do normal deformation, nothing special
		dbf	d1,loc_5DD8
		rts
; ---------------------------------------------------------------------------

loc_5DE0:
		subq.w	#1,d0
		bne.s	loc_5E0E
		add.w	($FFFFEE60).w,d2				; If routine counter is 1
		neg.w	d2
		move.w	#$6F,d3

loc_5DEE:
		jsr	(Random_Number).l
		andi.w	#7,d0
		move.w	d0,(a1)+		; Shake the scanlines of the foreground (SEGA logo) by random amounts to simulate static
		move.w	d2,(a1)+
		swap	d0
		andi.w	#7,d0
		neg.w	d0
		move.w	d0,(a1)+
		move.w	d2,(a1)+
		dbf	d3,loc_5DEE
		rts
; ---------------------------------------------------------------------------

loc_5E0E:
		subq.w	#1,d0
		bne.s	loc_5DC2
		subq.w	#1,($FFFFEED2).w		; If routine counter is 2
		bne.s	loc_5E52
		addq.w	#1,($FFFFEEC0).w		; If above timer has expired
		move	#$2700,sr
		move.l	#$45000003,d0
		move.w	#$FF,d3
		bsr.w	ClearVRAMArea			; Clear the Sega logo mappings from foreground
		move	#$2300,sr
		lea	(Pal_SKTitle_Knux).l,a0
		lea	($FFFFFC20).w,a2
		moveq	#7,d0

loc_5E3E:
		move.l	(a0)+,(a2)+				; Load the knuckles palette into the final line
		dbf	d0,loc_5E3E
		move.l	#Obj_SKTitle_HandAnim,($FFFFB128).w	; Start hand animations
		moveq	#0,d2
		bra.w	loc_5DC2				; Then do normal deformation
; ---------------------------------------------------------------------------

loc_5E52:
		move.w	($FFFFEE60).w,d2
		neg.w	d2
		move.w	#$6F,d3

loc_5E5C:
		jsr	(Random_Number).l
		addq.w	#8,(a1)			; On every other line, alternate between moving the line randomly to the left and randomly to the right
		andi.w	#7,d0			; The result is a staticy phaseout effect of the SEGA logo
		add.w	d0,(a1)
		cmpi.w	#$FC,(a1)
		blt.s	loc_5E74
		move.w	#$FC,(a1)

loc_5E74:
		addq.w	#2,a1
		move.w	d2,(a1)+
		subq.w	#8,(a1)
		swap	d0
		andi.w	#7,d0
		sub.w	d0,(a1)
		cmpi.w	#-$104,(a1)
		bgt.s	loc_5E8C
		move.w	#-$104,(a1)

loc_5E8C:
		addq.w	#2,a1
		move.w	d2,(a1)+
		dbf	d3,loc_5E5C
		rts
; End of function SKTitle_DeformBG

; ---------------------------------------------------------------------------
SKTitle_ShakeOffsets:	dc.b	1,   2,	  1,   3,   1,	 2,   2,   1,	2,   3,	  1,   2,   1,	 2,   0,   0
						dc.b	2,   0,	  3,   2,   2,	 3,   2,   2,	1,   3,	  0,   0,   1,	 0,   1,   3
						dc.b	1,   2,	  1,   3,   1,	 2,   2,   1,	2,   3,	  1,   2,   1,	 2,   0,   0
						dc.b	2,   0,	  3,   2,   2,	 3,   2,   2,	1,   3,	  0,   0,   1,	 0,   1,   3,  1,   2
	even
Map_SKTitle_Icon:	include "General\Title\Map - SK Icon.asm"		;5ED8.asm"
	even
Map_SKTitle_TM:	include "General\Title\Map - SK TM.asm"			;5F62.asm"
	even
Map_SKTitle_Copyright:	include "General\Title\Map - SK Copyright.asm"	;5F6C.asm"
	even
	if Sonic3_Complete=0
LevelMusic_Playlist:binclude "Sound\Music\Music playlist.bin"
	else
	endif

; ---------------------------------------------------------------------------

Level:


		bset	#7,($FFFFF600).w		; Set bit 7 of F600 is indicate that we're loading the level
		tst.w	($FFFFFFD0).w
		bmi.s	loc_5FC4
		moveq	#-$1F,d0				; If a demo
		bsr.w	Play_Sound_2

loc_5FC4:
		clr.w	($FFFFEF72).w
		clr.w	($FFFFFF0E).w
		lea	($FFFFFF10).w,a1
		moveq	#0,d0
		move.w	#$1A,d1

loc_5FD6:
		move.l	d0,(a1)+				; Clear the KosM bytes
		dbf	d1,loc_5FD6
		bsr.w	Clear_Nem_Queue				; Clear PLCs
		cmpi.w	#$D01,($FFFFFE10).w
		beq.s	loc_5FFC
		tst.b	($FFFFFF97).w
		beq.s	loc_5FF6
		cmpi.w	#$1701,($FFFFFE10).w
		beq.s	loc_5FFC

loc_5FF6:
		bsr.w	Pal_FadeToBlack			; If any normal level
		bra.s	loc_6000
; ---------------------------------------------------------------------------

loc_5FFC:

		bsr.w	Pal_FadeToWhite			; If level being loaded is the special stage arena or an ending

loc_6000:
		tst.w	($FFFFFFD0).w
		bmi.w	loc_60DE				; Skip ahead if FFFFD0 is negative (?)
		move	#$2700,sr
		bsr.w	Clear_DisplayData		; Clear the screen
		move	#$2300,sr
		moveq	#0,d0
		move.w	d0,($FFFFFE04).w
		tst.b	($FFFFFE2A).w
		beq.s	loc_6040				; If no lampost was set, branch
		tst.b	($FFFFFE48).w
		bne.s	loc_6034				; Otherwise, ensure that the proper level ID is set to account for levels that use multiple ones in an act
		move.w	($FFFFFE2C).w,($FFFFFE10).w
		move.w	($FFFFFF9A).w,($FFFFEE4E).w
		bra.s	loc_6040
; ---------------------------------------------------------------------------

loc_6034:
		move.w	($FFFFFE4A).w,($FFFFFE10).w
		move.w	($FFFFFF9C).w,($FFFFEE4E).w

loc_6040:

		move.w	($FFFFFE10).w,d0
		bne.s	loc_6058
		cmpi.w	#2,($FFFFFF08).w		; If level is Angel Island 1
		bcc.s	loc_6054
		tst.b	($FFFFFE2A).w			; If character is Sonic
		beq.s	loc_6058				; And no lamppost is set

loc_6054:
		move.w	#$D00,d0				; Set the level ID to skip the intro

loc_6058:

		cmpi.w	#$401,($FFFFFE10).w
		bne.s	loc_6068
		cmpi.b	#6,($FFFFFE2A).w
		beq.s	loc_6088				; If level is Flying Battery 2 and lamppost is 6 or above (presumably the one before the boss) don't bother loading level PLCs

loc_6068:
		ror.b	#1,d0
		lsr.w	#4,d0
		andi.w	#$1F8,d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d0,d1
		lea	(LevelLoadBlock).l,a2
		moveq	#0,d0
		move.b	(a2,d1.w),d0			; Get the first PLC number for the level
		beq.s	loc_6088
		bsr.w	Load_PLC

loc_6088:

		bsr.w	LevelLoad_ActiveCharacter
		tst.b	($FFFFFE2A).w
		bne.w	loc_60B4
		cmpi.w	#0,($FFFFFE10).w
		bne.s	loc_60B4
		cmpi.w	#2,($FFFFFF08).w
		bcc.s	loc_60B4
		moveq	#1,d0					; If in AIZ intro
		jsr	(Load_PLC_2).l
		moveq	#$A,d0
		bsr.w	Load_PLC					; Load the AIZ Intro graphics
		bra.s	loc_60DE
; ---------------------------------------------------------------------------

loc_60B4:

		moveq	#6,d0
		tst.w	($FFFFFFE8).w
		bne.s	loc_60DA
		moveq	#5,d0
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_60DA
		moveq	#1,d0
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_60DA
		moveq	#7,d0
		tst.b	($FFFFFFD8).w
		bmi.s	loc_60DA
		moveq	#$52,d0

loc_60DA:

		bsr.w	Load_PLC

loc_60DE:

		lea	($FFFFAC00).w,a1
		moveq	#0,d0
		move.w	#$FF,d1

loc_60E8:
		move.l	d0,(a1)+
		dbf	d1,loc_60E8
		lea	($FFFFB000).w,a1
		moveq	#0,d0
		move.w	#$7FF,d1

loc_60F8:
		move.l	d0,(a1)+
		dbf	d1,loc_60F8
		lea	($FFFFF628).w,a1
		moveq	#0,d0
		move.w	#$15,d1

loc_6108:
		move.l	d0,(a1)+
		dbf	d1,loc_6108
		lea	($FFFFF700).w,a1
		moveq	#0,d0
		move.w	#$3F,d1

loc_6118:
		move.l	d0,(a1)+
		dbf	d1,loc_6118
		lea	($FFFFFE6E).w,a1
		moveq	#0,d0
		move.w	#$12,d1

loc_6128:
		move.l	d0,(a1)+
		dbf	d1,loc_6128
		lea	($FFFFFA80).w,a1
		moveq	#0,d0
		move.w	#$1F,d1

loc_6138:
		move.l	d0,(a1)+
		dbf	d1,loc_6138
		jsr	(Init_SpriteTable).l
		lea	($C00004).l,a6
		move.w	#$8B03,(a6)
		move.w	#$8230,(a6)
		move.w	#$8407,(a6)
		move.w	#$857C,(a6)
		move.w	#$9001,(a6)
		move.w	#$8004,(a6)
		move.w	#$9200,(a6)
		move.w	#$8720,(a6)
		move.w	#$8C81,(a6)
		tst.b	($FFFFFFE2).w
		beq.s	loc_6182
		btst	#6,($FFFFF604).w
		beq.s	loc_6182
		move.b	#1,($FFFFFFDA).w

loc_6182:

		move.w	#$8AFF,($FFFFF624).w
		tst.w	($FFFFFFE8).w
		beq.s	loc_61BE
		move.w	#$4EF9,($FFFFFFF6).w
		move.l	#HInt,($FFFFFFF8).w
		move.w	#$8014,(a6)
		move.w	#$8220,(a6)
		move.w	#$8405,(a6)
		move.w	#$8A6B,($FFFFF624).w
		move.w	#$9003,(a6)
		cmpi.b	#$F,($FFFFFE10).w
		bne.s	loc_61BE
		move.w	#$9011,(a6)

loc_61BE:

		move.w	($FFFFF624).w,(a6)
		clr.w	($FFFFFB00).w
		move.l	#$FFFFFB00,($FFFFFBFC).w
		moveq	#3,d0
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_61DA
		moveq	#5,d0

loc_61DA:
		bsr.w	LoadPalette_Immediate
		bsr.w	CheckLevelForWater
		lea	($FFFFF0A0).w,a1
		moveq	#0,d0
		move.w	#$17,d1

loc_61EC:
		move.l	d0,(a1)+
		dbf	d1,loc_61EC
		tst.b	($FFFFF730).w
		beq.s	loc_61FC
		move.w	#$8014,(a6)

loc_61FC:
		tst.w	($FFFFFFD0).w
		bmi.w	loc_6310
		moveq	#0,d0
		move.w	($FFFFFE10).w,d0
		ror.b	#1,d0
		lsr.w	#7,d0
		lea	(LevelMusic_Playlist).l,a1
		move.b	(a1,d0.w),d0
		cmpi.w	#1,($FFFFFE10).w
		bne.s	loc_622A
		cmpi.b	#3,($FFFFFE2A).w
		bne.s	loc_622A
		moveq	#1,d0

loc_622A:

		cmpi.w	#$700,($FFFFFE10).w
		bne.s	loc_6248
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_6248
		tst.w	($FFFFFFAE).w
		beq.s	loc_6248
		tst.b	($FFFFFE2A).w
		bne.s	loc_6248
		moveq	#$1F,d0

loc_6248:

		move.w	d0,($FFFFFF90).w
		bsr.w	Play_Sound
		tst.w	($FFFFFE10).w
		bne.s	loc_6268
		cmpi.w	#2,($FFFFFF08).w
		bcc.s	loc_62B6
		tst.b	($FFFFFE2A).w
		beq.w	loc_62FE
		bra.s	loc_62B6
; ---------------------------------------------------------------------------

loc_6268:
		cmpi.w	#$700,($FFFFFE10).w
		bne.s	loc_62B6
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_62B6
		tst.w	($FFFFFFAE).w
		beq.s	loc_62B6
		tst.b	($FFFFFE2A).w
		bne.s	loc_62B6
		move	#$2700,sr
		move.l	#$70000002,($C00004).l
		lea	(ArtNem_Squirrel).l,a0
		jsr	(Nem_Decomp).l
		move.l	#$72400002,($C00004).l
		lea	(ArtNem_Chicken).l,a0
		jsr	(Nem_Decomp).l
		bra.s	loc_62FE
; ---------------------------------------------------------------------------

loc_62B6:

		cmpi.w	#$1701,($FFFFFE10).w
		beq.s	loc_62FE
		tst.b	($FFFFEE5E).w
		bne.s	loc_62FE
		move.l	#Obj_TitleCard,($FFFFB250).w

loc_62CC:

		move.b	#$C,($FFFFF62A).w
		jsr	(Process_Kos_Queue).l
		bsr.w	Wait_VSync
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		bsr.w	Process_Nem_Queue_Init
		jsr	(Process_Kos_Module_Queue).l
		tst.w	($FFFFB298).w
		bne.s	loc_62CC
		tst.l	($FFFFF680).w
		bne.s	loc_62CC

loc_62FE:

		clr.b	($FFFFEE5E).w
		move	#$2700,sr
		jsr	(sub_DE9C).l
		move	#$2300,sr

loc_6310:
		moveq	#3,d0
		bsr.w	LoadPalette
		jsr	(Get_LevelSizeStart).l
		jsr	(Restart_From_Starpost).l
		bsr.w	LoadLevelLoadBlock
		jsr	(LoadLevelLoadBlock2).l
		move	#$2700,sr
		jsr	(j_LevelSetup).l
		move	#$2300,sr
		jsr	(Animate_Init).l
		bsr.w	LoadSolids
		bsr.w	Handle_Onscreen_Water_Height
		move.w	($FFFFF606).w,($FFFFFF7C).w
		move.w	#0,($FFFFF602).w
		move.w	#0,($FFFFF66A).w
		move.w	#0,($FFFFF604).w
		move.w	#0,($FFFFF606).w
		move.b	#1,($FFFFF7CA).w
		move.b	#1,($FFFFF7CB).w
		move.b	#0,($FFFFF711).w
		tst.b	($FFFFF730).w
		beq.s	loc_63A4
		cmpi.b	#1,($FFFFFE10).w
		beq.s	loc_638E
		cmpi.b	#1,($FFFFFE10).w
		bne.s	loc_63A4

loc_638E:
		move.l	#Obj_HCZWaveSplash,($FFFFCF82).w
		move.l	#Obj_HCZWaterSplash,($FFFFB172).w
		move.b	#1,($FFFFB19E).w

loc_63A4:

		cmpi.b	#7,($FFFFFE10).w
		bne.s	loc_63B4
		move.l	#Obj_MHZ_Pollen_Spawner,($FFFFB128).w

loc_63B4:
		moveq	#0,d0
		tst.b	($FFFFFE2A).w
		bne.s	loc_6404
		move.w	d0,($FFFFFE20).w
		move.l	d0,($FFFFFE22).w
		move.b	d0,($FFFFFE1B).w
		move.w	d0,($FFFFFED0).w
		move.l	d0,($FFFFFED2).w
		move.b	d0,($FFFFFE47).w
		cmpi.w	#$1600,($FFFFFE10).w
		beq.s	loc_6400
		cmpi.w	#$1700,($FFFFFE10).w
		beq.s	loc_6400
		cmpi.w	#$1701,($FFFFFE10).w
		beq.s	loc_6404
		cmpi.b	#$16,($FFFFFE10).w
		bcc.s	loc_63FC
		cmpi.b	#$13,($FFFFFE10).w
		bcc.s	loc_6404

loc_63FC:
		move.b	d0,($FFFFFF96).w

loc_6400:

		move.b	d0,($FFFFFF97).w

loc_6404:

		move.b	d0,($FFFFFE1A).w
		move.w	d0,($FFFFFE08).w
		move.w	d0,($FFFFFE02).w
		move.b	d0,($FFFFF622).w
		move.b	d0,($FFFFF623).w
		move.w	d0,($FFFFFEC8).w
		move.w	d0,($FFFFFECA).w
		move.w	d0,($FFFFFECC).w
		move.w	d0,($FFFFFECE).w
		move.w	d0,($FFFFFEDE).w
		move.b	d0,($FFFFFE65).w
		move.b	d0,($FFFFFE19).w
		bsr.w	sub_76E6
		move.b	#1,($FFFFFE1F).w
		move.b	#1,($FFFFFE1D).w
		move.b	#1,($FFFFFE1E).w
		move.b	#1,($FFFFF711).w
		cmpi.w	#$D01,($FFFFFE10).w
		beq.s	loc_6460
		cmpi.w	#$1701,($FFFFFE10).w
		bne.s	loc_6468

loc_6460:
		clr.b	($FFFFFE1E).w
		clr.b	($FFFFF711).w

loc_6468:
		bsr.w	SpawnLevelMainSprites
		jsr	(Load_Sprites).l
		jsr	(Load_Rings).l
		jsr	(Draw_LRZ_Special_Rock_Sprites).l
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		jsr	(Animate_Tiles).l
		move.w	#$708,($FFFFF614).w
		bsr.w	LoadWaterPalette
		lea	($FFFFF0A0).w,a1
		moveq	#0,d0
		move.w	#$17,d1

loc_64A4:
		move.l	d0,(a1)+
		dbf	d1,loc_64A4
		move.b	#0,($FFFFF7CA).w
		move.b	#0,($FFFFF7CB).w
		jsr	GetDemoPtr(pc)
		tst.w	($FFFFFFE8).w
		bne.w	loc_663A
		tst.w	($FFFFFE10).w
		bne.s	loc_64CE

loc_64C8:
		tst.b	($FFFFFE2A).w
		beq.s	loc_64DC

loc_64CE:
		cmpi.b	#$E,($FFFFFE10).w
		bcc.s	loc_64DC
		jsr	(PLCLoad_AnimalsAndExplosion).l

loc_64DC:

		move.w	#$202F,($FFFFF626).w
		jsr	(Pal_FillBlack).l
		move.w	#$16,($FFFFEE50).w
		move.w	#$16,($FFFFB27E).w
		move.w	#$7F00,($FFFFF604).w
		move.w	#$7F00,($FFFFF606).w
		andi.b	#$7F,($FFFFFE2A).w
		bclr	#7,($FFFFF600).w

LevelLoop:

		bsr.w	Pause_Game
		move.b	#8,($FFFFF62A).w
		jsr	(Process_Kos_Queue).l
		bsr.w	Wait_VSync
		addq.w	#1,($FFFFFE04).w
		bsr.w	Demo_PlayRecord
		jsr	(Animate_Palette).l
		jsr	(SpecialEvents).l
		jsr	(Load_Sprites).l
		jsr	(Process_Sprites).l
		tst.w	($FFFFFE02).w
		bne.w	Level
		jsr	(Restart_From_Starpost).l
		jsr	(ScreenEvents).l
		bsr.w	Handle_Onscreen_Water_Height
		jsr	(Load_Rings).l
		cmpi.b	#9,($FFFFFE10).w
		bne.s	Level_NotLRZ
		jsr	(Draw_LRZ_Special_Rock_Sprites).l

Level_NotLRZ:
		jsr	(Animate_Tiles).l
		bsr.w	Process_Nem_Queue_Init
		jsr	(Process_Kos_Module_Queue).l
		bsr.w	sub_773C
		bsr.w	sub_77D2
		jsr	(Render_Sprites).l
		cmpi.b	#$15,($FFFFFE10).w
		bne.s	Level_NotSlots
		jsr	(Ending_4B356).l
		jsr	(Slots_CycleOptions).l

Level_NotSlots:
		cmpi.b	#8,($FFFFF600).w
		beq.s	DemoMode
		cmpi.b	#$C,($FFFFF600).w
		beq.w	LevelLoop
		rts
; ---------------------------------------------------------------------------

DemoMode:
		tst.w	($FFFFFE02).w
		bne.s	loc_65D0
		tst.w	($FFFFF614).w
		beq.s	loc_65D0
		cmpi.b	#8,($FFFFF600).w
		beq.w	LevelLoop
		move.b	#0,($FFFFF600).w
		rts
; ---------------------------------------------------------------------------

loc_65D0:

		cmpi.b	#8,($FFFFF600).w
		bne.s	loc_65E0
		move.b	#0,($FFFFF600).w
		rts
; ---------------------------------------------------------------------------

loc_65E0:
		move.w	#$3C,($FFFFF614).w
		move.w	#$3F,($FFFFF626).w
		clr.w	($FFFFF794).w

loc_65F0:
		move.b	#8,($FFFFF62A).w
		bsr.w	Wait_VSync
		bsr.w	Demo_PlayRecord
		jsr	(Process_Sprites).l
		jsr	(Restart_From_Starpost).l
		jsr	(ScreenEvents).l
		jsr	(Render_Sprites).l
		jsr	(Load_Sprites).l
		jsr	(Process_Kos_Module_Queue).l
		subq.w	#1,($FFFFF794).w
		bpl.s	loc_6632
		move.w	#2,($FFFFF794).w
		bsr.w	Pal_ToBlack

loc_6632:
		tst.w	($FFFFF614).w
		bne.s	loc_65F0
		rts
; ---------------------------------------------------------------------------

loc_663A:
		move.w	#0,($FFFFFF7E).w
		tst.b	($FFFFFFE2).w
		beq.s	loc_665A
		move.b	($FFFFFF7C).w,d0
		cmpi.b	#$A0,d0
		bne.s	loc_665A
		move.w	($FFFFFF84).w,d0
		lsl.w	#8,d0
		move.w	d0,($FFFFFF7E).w

loc_665A:

		move.w	#$3F,($FFFFF626).w
		jsr	(Pal_FillBlack).l
		move.w	#$16,($FFFFEE50).w
		move.w	#0,($FFFFFF7C).w
		bclr	#7,($FFFFF600).w

loc_6678:

		bsr.w	Pause_Game
		move.b	#8,($FFFFF62A).w
		jsr	(Process_Kos_Queue).l
		bsr.w	Wait_VSync
		addq.w	#1,($FFFFFE04).w
		move.w	#4,-(sp)
		bra.s	loc_66DA
; ---------------------------------------------------------------------------

loc_6696:
		move.w	($FFFFFF7E).w,d0
		add.w	d0,($FFFFFF7C).w
		bcc.s	loc_66EA
		bsr.w	Pause_Game
		move.w	#$100,($A11100).l
		bsr.w	Poll_Controllers
		move.w	#0,($A11100).l
		move.w	#0,($FFFFFB00).w
		move.l	#$FFFFFB00,($FFFFFBFC).w
		lea	($FFFFAC00).w,a5

loc_66CA:
		move.w	#0,(a5)
		lea	$80(a5),a5
		cmpa.l	#$FFFFB000,a5
		bcs.s	loc_66CA

loc_66DA:
		bsr.w	Demo_PlayRecord
		jsr	(Process_Sprites).l
		jsr	(Restart_From_Starpost).l

loc_66EA:
		subq.w	#1,(sp)
		bne.s	loc_6696
		addq.w	#2,sp
		tst.w	($FFFFFE02).w
		bne.w	Level
		jsr	(ScreenEvents).l
		jsr	(Animate_Tiles).l
		jsr	(Render_Sprites).l
		jsr	(Animate_Palette).l
		bsr.w	Process_Nem_Queue_Init
		jsr	(Process_Kos_Module_Queue).l
		cmpi.b	#8,($FFFFF600).w
		beq.s	loc_672E
		cmpi.b	#$C,($FFFFF600).w
		beq.w	loc_6678
		rts
; ---------------------------------------------------------------------------

loc_672E:
		tst.w	($FFFFFE02).w
		bne.s	loc_674C
		tst.w	($FFFFF614).w
		beq.s	loc_674C
		cmpi.b	#8,($FFFFF600).w
		beq.w	loc_6678
		move.b	#0,($FFFFF600).w
		rts
; ---------------------------------------------------------------------------

loc_674C:

		cmpi.b	#8,($FFFFF600).w
		bne.s	loc_675C
		move.b	#0,($FFFFF600).w
		rts
; ---------------------------------------------------------------------------

loc_675C:
		move.w	#$3C,($FFFFF614).w
		move.w	#$3F,($FFFFF626).w
		clr.w	($FFFFF794).w

loc_676C:
		move.b	#8,($FFFFF62A).w
		bsr.w	Wait_VSync
		bsr.w	Demo_PlayRecord
		jsr	(Process_Sprites).l
		jsr	(Restart_From_Starpost).l
		jsr	(ScreenEvents).l
		jsr	(Render_Sprites).l
		jsr	(Load_Sprites).l
		jsr	(Process_Kos_Module_Queue).l
		subq.w	#1,($FFFFF794).w
		bpl.s	loc_67AE
		move.w	#2,($FFFFF794).w
		bsr.w	Pal_ToBlack

loc_67AE:
		tst.w	($FFFFF614).w
		bne.s	loc_676C
		rts

; =============== S U B R O U T I N E =======================================


LevelLoad_ActiveCharacter:
		cmpi.b	#$88,($FFFFF600).w
		beq.s	loc_67CC
		tst.w	($FFFFFFE8).w
		bne.s	loc_67CC
		move.w	($FFFFFF0A).w,($FFFFFF08).w		; Move selected character to active character
		rts
; ---------------------------------------------------------------------------

loc_67CC:
		move.w	#3,($FFFFFF08).w			; If loading a demo OR 2P mode enabled (?)
		cmpi.b	#7,($FFFFFE10).w
		beq.s	locret_67EC
		move.w	#0,($FFFFFF08).w
		tst.w	($FFFFFFAE).w
		beq.s	locret_67EC
		move.w	#1,($FFFFFF08).w

locret_67EC:
		rts
; End of function LevelLoad_ActiveCharacter


; =============== S U B R O U T I N E =======================================


SpawnLevelMainSprites:
		move.l	#Obj_Level_6C2C,($FFFFB094).w
		bsr.w	SpawnLevelMainSprites_SpawnPlayers
		bsr.w	SpawnLevelMainSprites_SpawnPowerup
		tst.b	($FFFFFE2A).w
		bne.w	locret_69B6
		tst.b	($FFFFFE48).w
		bne.w	locret_69B6
		lea	($FFFFB000).w,a1
		lea	($FFFFB04A).w,a2
		cmpi.w	#0,($FFFFFE10).w
		bne.s	loc_6834
		cmpi.w	#2,($FFFFFF08).w
		bcc.s	locret_6832
		move.l	#Obj_84,($FFFFB172).w
		clr.b	($FFFFF711).w

locret_6832:
		rts
; ---------------------------------------------------------------------------

loc_6834:
		cmpi.w	#$100,($FFFFFE10).w
		bne.s	loc_6886
		move.b	#$1B,$20(a1)
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_685C
		move.w	#$2121,$20(a1)
		move.b	#1,$23(a1)
		move.b	#0,$24(a0)

loc_685C:
		bset	#1,$2A(a1)
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_6870
		move.b	#1,$40(a1)

loc_6870:
		tst.l	(a2)
		beq.s	loc_6886
		move.b	#$1B,$20(a2)
		bset	#1,$2A(a2)
		move.b	#1,$40(a2)

loc_6886:
		cmpi.w	#$900,($FFFFFE10).w
		bne.s	loc_6896
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_68A6

loc_6896:
		cmpi.w	#$1600,($FFFFFE10).w
		beq.s	loc_68A6
		cmpi.w	#$200,($FFFFFE10).w
		bne.s	loc_68C2

loc_68A6:
		move.b	#$1B,$20(a1)
		bset	#1,$2A(a1)
		tst.l	(a2)
		beq.s	loc_68C2
		move.b	#$1B,$20(a2)
		bset	#1,$2A(a2)

loc_68C2:
		cmpi.w	#$700,($FFFFFE10).w
		bne.s	loc_68D0
		tst.w	($FFFFFFAE).w
		beq.s	loc_68D8

loc_68D0:
		cmpi.w	#$300,($FFFFFE10).w
		bne.s	loc_690A

loc_68D8:
		cmpi.w	#1,($FFFFFF08).w
		bne.s	loc_68FC
		move.l	#Obj_Tails,($FFFFB04A).w
		move.w	($FFFFB010).w,($FFFFB05A).w
		move.w	($FFFFB014).w,($FFFFB05E).w
		move.w	#0,($FFFFF708).w
		bra.s	loc_690A
; ---------------------------------------------------------------------------

loc_68FC:
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_690A
		move.w	#$20,($FFFFF708).w

loc_690A:
		cmpi.w	#$500,($FFFFFE10).w
		bne.s	loc_692E
		cmpi.w	#2,($FFFFFF08).w
		bcs.s	loc_6926
		bne.s	loc_692E
		move.l	#Obj_LevelIntroICZ1Tails,($FFFFB172).w
		bra.s	loc_692E
; ---------------------------------------------------------------------------

loc_6926:
		move.l	#Obj_LevelIntroICZ1,($FFFFB172).w

loc_692E:
		cmpi.w	#$600,($FFFFFE10).w
		bne.s	loc_693E
		move.l	#Obj_LevelIntro_PlayerLaunchFromGround,($FFFFB172).w

loc_693E:
		cmpi.w	#$700,($FFFFFE10).w
		bne.s	loc_695A
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_695A
		move.b	#$1B,$20(a1)
		bset	#1,$2A(a1)

loc_695A:
					; SpawnLevelMainSprites+15Ej
		cmpi.w	#$800,($FFFFFE10).w
		bne.s	loc_6986
		move.l	#Obj_LevelIntro_PlayerFallIntoGround,($FFFFB172).w
		move.b	#2,$20(a1)
		bset	#1,$2A(a1)
		tst.l	(a2)
		beq.s	loc_6986
		move.b	#2,$20(a2)
		bset	#1,$2A(a2)

loc_6986:
					; SpawnLevelMainSprites+18Aj
		cmpi.w	#$300,($FFFFFE10).w
		beq.s	loc_69A6
		cmpi.w	#$B00,($FFFFFE10).w
		beq.s	loc_69AE
		cmpi.w	#$1601,($FFFFFE10).w
		beq.s	loc_69AE
		cmpi.w	#$900,($FFFFFE10).w
		bne.s	locret_69B6

loc_69A6:
		cmpi.w	#3,($FFFFFF08).w
		bne.s	locret_69B6

loc_69AE:
					; SpawnLevelMainSprites+1AEj
		move.l	#Obj_LevelIntro_PlayerRun,($FFFFB172).w

locret_69B6:
					; SpawnLevelMainSprites+1Cj ...
		rts
; End of function SpawnLevelMainSprites


; =============== S U B R O U T I N E =======================================


SpawnLevelMainSprites_SpawnPowerup:
		cmpi.w	#$D01,($FFFFFE10).w
		beq.s	locret_6A00
		cmpi.b	#$13,($FFFFFE10).w
		beq.s	loc_69E0
		cmpi.b	#$14,($FFFFFE10).w
		beq.s	loc_69E0
		cmpi.b	#$16,($FFFFFE10).w
		bcc.s	loc_69E0
		cmpi.b	#$E,($FFFFFE10).w
		bcc.s	locret_6A00

loc_69E0:
					; SpawnLevelMainSprites_SpawnPowerup+16j ...
		lea	($FFFFB000).w,a1
		move.b	($FFFFFE47).w,d0
		clr.b	($FFFFFE47).w
		andi.b	#$70,d0
		bne.s	loc_6A02
		move.b	($FFFFFF96).w,d0
		clr.b	($FFFFFF96).w
		andi.b	#$70,d0
		bne.s	loc_6A02

locret_6A00:
					; SpawnLevelMainSprites_SpawnPowerup+26j
		rts
; ---------------------------------------------------------------------------

loc_6A02:
					; SpawnLevelMainSprites_SpawnPowerup+46j
		btst	#4,d0
		beq.s	loc_6A28
		andi.b	#$8E,$2B(a1)
		bset	#0,$2B(a1)
		bset	#4,$2B(a1)
		move.l	#Obj_Fire_Shield,($FFFFCCE8).w
		move.w	a1,($FFFFCD2A).w
		rts
; ---------------------------------------------------------------------------

loc_6A28:
		btst	#5,d0
		beq.s	loc_6A4E
		andi.b	#$8E,$2B(a1)
		bset	#0,$2B(a1)
		bset	#5,$2B(a1)
		move.l	#Obj_Lightning_Shield,($FFFFCCE8).w
		move.w	a1,($FFFFCD2A).w
		rts
; ---------------------------------------------------------------------------

loc_6A4E:
		btst	#6,d0
		beq.s	locret_6A74
		andi.b	#$8E,$2B(a1)
		bset	#0,$2B(a1)
		bset	#6,$2B(a1)
		move.l	#Obj_Bubble_Shield,($FFFFCCE8).w
		move.w	a1,($FFFFCD2A).w
		rts
; ---------------------------------------------------------------------------

locret_6A74:
		rts
; End of function SpawnLevelMainSprites_SpawnPowerup


; =============== S U B R O U T I N E =======================================


SpawnLevelMainSprites_SpawnPlayers:
		cmpi.w	#$1300,($FFFFFE10).w
		bcs.s	loc_6A8A
		cmpi.w	#$1600,($FFFFFE10).w
		bcc.s	loc_6A8A
		clr.b	($FFFFFE1E).w

loc_6A8A:
					; SpawnLevelMainSprites_SpawnPlayers+Ej
		cmpi.w	#$1400,($FFFFFE10).w
		bne.s	loc_6AB8
		move.l	#Obj_PachinkoEnergyTrap,($FFFFB172).w
		move.w	#$78,($FFFFB182).w
		move.w	#$F30,($FFFFB186).w
		move.w	($FFFFFE32).w,($FFFFFE20).w
		move.b	($FFFFFE43).w,($FFFFFE1B).w
		move.b	#1,($FFFFFE1D).w

loc_6AB8:
		cmpi.b	#$15,($FFFFFE10).w
		beq.w	loc_6B76
		tst.w	($FFFFFFE8).w
		bne.w	loc_6B94
		move.w	($FFFFFF08).w,d0
		bne.s	loc_6B1E
		move.l	#Obj_Sonic,($FFFFB000).w
		move.l	#Obj_DashDust,($FFFFCC54).w
		move.l	#Obj_Insta_Shield,($FFFFCCE8).w
		move.w	#$B000,($FFFFCD2A).w
		move.l	#Obj_Tails,($FFFFB04A).w
		move.w	($FFFFB010).w,($FFFFB05A).w
		move.w	($FFFFB014).w,($FFFFB05E).w
		subi.w	#$20,($FFFFB05A).w
		addi.w	#4,($FFFFB05E).w
		move.l	#Obj_DashDust,($FFFFCC9E).w
		move.w	#0,($FFFFF708).w
		rts
; ---------------------------------------------------------------------------

loc_6B1E:
		subq.w	#1,d0
		bne.s	loc_6B42
		move.l	#Obj_Sonic,($FFFFB000).w
		move.l	#Obj_DashDust,($FFFFCC54).w
		move.l	#Obj_Insta_Shield,($FFFFCCE8).w
		move.w	#$B000,($FFFFCD2A).w
		rts
; ---------------------------------------------------------------------------

loc_6B42:
		subq.w	#1,d0
		bne.s	loc_6B64
		move.l	#Obj_Tails,($FFFFB000).w
		move.l	#Obj_DashDust,($FFFFCC9E).w
		addi.w	#4,($FFFFB014).w
		move.w	#0,($FFFFF708).w
		rts
; ---------------------------------------------------------------------------

loc_6B64:
		move.l	#Obj_Knuckles,($FFFFB000).w
		move.l	#Obj_DashDust,($FFFFCC54).w
		rts
; ---------------------------------------------------------------------------

loc_6B76:
		moveq	#0,d0
		move.b	d0,($FFFFE408).w
		move.w	d0,($FFFFE406).w
		move.l	#Obj_Sonic_RotatingSlotBonus,($FFFFB000).w
		jsr	(sub_4B6AA).l
		st	($FFFFEE30).w
		rts
; ---------------------------------------------------------------------------

loc_6B94:
		move.b	($FFFFFFEA).w,d0
		bsr.s	sub_6BD8
		move.l	d1,($FFFFB000).w
		move.b	($FFFFFFEA).w,($FFFFB038).w
		move.w	($FFFFB010).w,($FFFFB05A).w
		move.w	($FFFFB014).w,($FFFFB05E).w
		move.l	#Obj_DashDust2P,($FFFFCC54).w
		tst.b	($FFFFEF49).w
		beq.s	loc_6BD6
		move.b	($FFFFFFEB).w,d0
		bsr.s	sub_6BD8
		move.l	d1,($FFFFB04A).w
		move.b	($FFFFFFEB).w,($FFFFB082).w
		move.l	#Obj_DashDust2P,($FFFFCC9E).w

loc_6BD6:
		bra.s	loc_6BF6
; End of function SpawnLevelMainSprites_SpawnPlayers


; =============== S U B R O U T I N E =======================================


sub_6BD8:
		tst.b	d0
		bne.s	loc_6BE2
		move.l	#Obj_Sonic2P,d1

loc_6BE2:
		subq.b	#1,d0
		bne.s	loc_6BEE
		move.l	#Obj_Tails2P,d1
		rts
; ---------------------------------------------------------------------------

loc_6BEE:
		move.l	#Obj_Sonic2P,d1
		rts
; End of function sub_6BD8

; ---------------------------------------------------------------------------

loc_6BF6:
		lea	($FFFFFCA0).w,a2
		lea	(Pal_Level_2P).l,a1
		move.w	#$F,d0

loc_6C04:
		move.w	(a1)+,(a2)+
		dbf	d0,loc_6C04
		rts
; ---------------------------------------------------------------------------
Pal_Level_2P:	binclude "Levels\Misc\Palettes\2P Level Secondary.bin"

; ---------------------------------------------------------------------------

Obj_Level_6C2C:
		move.w	#0,($FFFFE380).w
		rts

; =============== S U B R O U T I N E =======================================


Handle_Onscreen_Water_Height:
		tst.b	($FFFFF730).w
		beq.w	loc_6C9C
		tst.b	($FFFFEE30).w
		bne.s	loc_6C52
		cmpi.b	#6,($FFFFB005).w
		bcc.s	loc_6C52
		bsr.w	sub_6F4A
		bsr.w	DynamicWaterHeight

loc_6C52:
		clr.b	($FFFFF64E).w
		moveq	#0,d0
		add.w	($FFFFF648).w,d0
		move.w	d0,($FFFFF646).w
		cmpi.w	#$100,($FFFFFE10).w
		bne.s	loc_6C70
		cmpi.w	#$900,($FFFFEE78).w
		bcs.s	loc_6C86

loc_6C70:
		move.w	($FFFFF646).w,d0
		sub.w	($FFFFEE7C).w,d0
		beq.s	loc_6C80
		bcc.s	loc_6C8E
		tst.w	d0
		bpl.s	loc_6C8E

loc_6C80:
		move.b	#1,($FFFFF64E).w

loc_6C86:
		move.b	#-1,($FFFFF625).w
		rts
; ---------------------------------------------------------------------------

loc_6C8E:
		cmpi.w	#$DF,d0
		bcs.s	loc_6C98
		move.w	#$FF,d0

loc_6C98:
		move.b	d0,($FFFFF625).w

loc_6C9C:
		bsr.w	sub_714E
		rts
; End of function Handle_Onscreen_Water_Height

; ---------------------------------------------------------------------------
		clr.b	($FFFFF64E).w
		move.w	($FFFFF648).w,($FFFFF646).w
		move.l	#HInt3,($FFFFFFF8).w
		cmpi.w	#$1000,($FFFFFFD6).w
		bcs.s	loc_6CC4
		move.l	#HInt4,($FFFFFFF8).w

loc_6CC4:
		move.w	($FFFFF646).w,d0
		sub.w	($FFFFEE7C).w,d0
		beq.s	loc_6CDC
		bcc.s	loc_6D18
		tst.w	d0
		bpl.s	loc_6D18
		addi.w	#$1E0,d0
		beq.s	loc_6CDC
		bcs.s	loc_6CEA

loc_6CDC:

		move.b	#1,($FFFFF64E).w
		move.b	#-1,($FFFFF625).w
		rts
; ---------------------------------------------------------------------------

loc_6CEA:
		cmpi.w	#$DF,d0
		bcs.s	loc_6CF4
		move.w	#$FF,d0

loc_6CF4:
		move.b	d0,($FFFFF625).w
		move.b	#1,($FFFFF64E).w
		move.l	#HInt5,($FFFFFFF8).w
		cmpi.w	#$1000,($FFFFFFD6).w
		bcs.s	loc_6D16
		move.l	#HInt_6,($FFFFFFF8).w

loc_6D16:
		bra.s	loc_6D26
; ---------------------------------------------------------------------------

loc_6D18:

		cmpi.w	#$DF,d0
		bcs.s	loc_6D22
		move.w	#$FF,d0

loc_6D22:
		move.b	d0,($FFFFF625).w

loc_6D26:
		bsr.w	sub_714E
		rts
; ---------------------------------------------------------------------------
StartingWaterHeights:	binclude "Levels\Misc\StartingWaterHeights.bin"


; =============== S U B R O U T I N E =======================================


DynamicWaterHeight:
		moveq	#0,d0
		move.w	($FFFFFE10).w,d0
		ror.b	#1,d0
		lsr.w	#6,d0
		andi.w	#-2,d0
		move.w	off_6D9C(pc,d0.w),d0
		jsr	off_6D9C(pc,d0.w)
		moveq	#0,d1
		move.b	($FFFFF64C).w,d1
		move.w	($FFFFF64A).w,d0
		sub.w	($FFFFF648).w,d0
		beq.s	locret_6D9A
		bcc.s	loc_6D96
		neg.w	d1

loc_6D96:
		add.w	d1,($FFFFF648).w

locret_6D9A:
		rts
; End of function DynamicWaterHeight

; ---------------------------------------------------------------------------
off_6D9C:	dc.w locret_6DDC-off_6D9C

		dc.w loc_6DDE-off_6D9C
		dc.w loc_6E82-off_6D9C
		dc.w loc_6E9C-off_6D9C
		dc.w locret_6ECA-off_6D9C
		dc.w locret_6ECA-off_6D9C
		dc.w locret_6ECA-off_6D9C
		dc.w locret_6ECA-off_6D9C
		dc.w locret_6ECA-off_6D9C
		dc.w locret_6ECA-off_6D9C
		dc.w locret_6ECA-off_6D9C
		dc.w locret_6ECA-off_6D9C
		dc.w loc_6ECC-off_6D9C
		dc.w loc_6EE8-off_6D9C
		dc.w locret_6F1A-off_6D9C
		dc.w locret_6F1A-off_6D9C
		dc.w locret_6F1A-off_6D9C
		dc.w locret_6F1A-off_6D9C
		dc.w locret_6F1A-off_6D9C
		dc.w locret_6F1A-off_6D9C
		dc.w locret_6F1A-off_6D9C
		dc.w locret_6F1A-off_6D9C
		dc.w locret_6F1A-off_6D9C
		dc.w locret_6F1A-off_6D9C
		dc.w locret_6F1A-off_6D9C
		dc.w locret_6F1A-off_6D9C
		dc.w locret_6F1A-off_6D9C
		dc.w loc_6F1C-off_6D9C
		dc.w locret_6F1A-off_6D9C
		dc.w locret_6F1A-off_6D9C
		dc.w locret_6F1A-off_6D9C
		dc.w locret_6F1A-off_6D9C
; ---------------------------------------------------------------------------

locret_6DDC:
		rts
; ---------------------------------------------------------------------------

loc_6DDE:
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_6DF6
		cmpi.w	#$820,($FFFFEE12).w
		beq.s	locret_6E6C
		cmpi.w	#$3B60,($FFFFEE78).w
		bcc.s	locret_6E6C

loc_6DF6:
		cmpi.w	#$2440,($FFFFEE78).w
		bcc.s	loc_6E14
		cmpi.w	#$618,($FFFFF64A).w
		bne.s	locret_6E6C
		move.w	#$528,($FFFFF64A).w
		move.b	#2,($FFFFF64C).w
		rts
; ---------------------------------------------------------------------------

loc_6E14:
		tst.b	($FFFFF7E0).w
		bne.s	loc_6E28
		cmpi.w	#$2850,($FFFFEE78).w
		bcs.s	locret_6E6C
		move.b	#1,($FFFFF7E0).w

loc_6E28:
		cmpi.w	#$618,($FFFFF64A).w
		beq.s	locret_6E6C
		cmpi.w	#$2900,($FFFFEE78).w
		bcc.s	loc_6E52
		move.w	#-1,($FFFFEECC).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_6E52
		move.l	#Obj_6E6E,(a1)
		move.b	#$B4,$24(a1)

loc_6E52:

		lea	($FFFF8024).w,a3
		moveq	#3,d1

loc_6E58:
		movea.w	(a3),a1
		move.b	#0,$4E(a1)
		addq.w	#4,a3
		dbf	d1,loc_6E58
		move.w	#$618,($FFFFF64A).w

locret_6E6C:

		rts
; ---------------------------------------------------------------------------

Obj_6E6E:
		subq.b	#1,$24(a0)
		beq.s	loc_6E76
		rts
; ---------------------------------------------------------------------------

loc_6E76:
		move.w	#0,($FFFFEECC).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_6E82:
		lea	(dword_6E8C).l,a1
		bra.w	loc_6F2C
; ---------------------------------------------------------------------------
dword_6E8C:	dc.l $85000900
		dc.l $86802A00
		dc.l $86803500
		dc.l $86A0FFFF
; ---------------------------------------------------------------------------

loc_6E9C:
		tst.b	($FFFFFAA2).w
		beq.s	loc_6EA4
		rts
; ---------------------------------------------------------------------------

loc_6EA4:
		lea	(dword_6EBA).l,a1
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_6F2C
		lea	(dword_6EC2).l,a1
		bra.s	loc_6F2C
; ---------------------------------------------------------------------------
dword_6EBA:	dc.l $7003E00
		dc.l $7E0FFFF
dword_6EC2:	dc.l $7004100
		dc.l $8360FFFF
; ---------------------------------------------------------------------------

locret_6ECA:
		rts
; ---------------------------------------------------------------------------

loc_6ECC:
		lea	(dword_6ED4).l,a1
		bra.s	loc_6F2C
; ---------------------------------------------------------------------------
dword_6ED4:	dc.l $8B000E00
		dc.l $8A001980
		dc.l $8A002340
		dc.l $8AC82C00
		dc.l $8FF0FFFF
; ---------------------------------------------------------------------------

loc_6EE8:
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_6EF2
		rts
; ---------------------------------------------------------------------------

loc_6EF2:
		tst.b	($FFFFF7C2).w
		bne.s	loc_6F00
		lea	(dword_6F12).l,a1
		bra.s	loc_6F2C
; ---------------------------------------------------------------------------

loc_6F00:
		move.w	($FFFFEE7C).w,d0
		cmp.w	($FFFFF648).w,d0
		bcs.s	locret_6F10
		move.w	#$660,($FFFFF648).w

locret_6F10:
		rts
; ---------------------------------------------------------------------------
dword_6F12:	dc.l $8FF00D80
		dc.l $8B20FFFF
; ---------------------------------------------------------------------------

locret_6F1A:
		rts
; ---------------------------------------------------------------------------

loc_6F1C:
		cmpi.w	#$1DE0,($FFFFEE78).w
		bcs.s	locret_6F2A
		move.w	#$510,($FFFFF64A).w

locret_6F2A:
		rts
; ---------------------------------------------------------------------------

loc_6F2C:

		move.w	($FFFFEE78).w,d0

loc_6F30:
		move.l	(a1)+,d1
		cmp.w	d1,d0
		bhi.s	loc_6F30
		swap	d1
		tst.w	d1
		bpl.s	loc_6F44
		andi.w	#$7FFF,d1
		move.w	d1,($FFFFF648).w

loc_6F44:
		move.w	d1,($FFFFF64A).w
		rts

; =============== S U B R O U T I N E =======================================


sub_6F4A:
		tst.w	($FFFFFE08).w
		bne.w	locret_705A
		cmpi.b	#1,($FFFFFE10).w
		bne.w	locret_705A
		cmpi.w	#2,($FFFFFF08).w
		beq.s	loc_6F82
		lea	($FFFFF7C8).w,a3
		lea	($FFFFB000).w,a1
		move.b	($FFFFF602).w,d6
		moveq	#0,d5
		bsr.s	HCZ_WaterTunnels
		addq.w	#1,a3
		lea	($FFFFB04A).w,a1
		move.b	($FFFFF66A).w,d6
		moveq	#1,d5
		bra.s	HCZ_WaterTunnels
; ---------------------------------------------------------------------------

loc_6F82:
		lea	($FFFFF7C9).w,a3
		lea	($FFFFB000).w,a1
		move.b	($FFFFF602).w,d6
		moveq	#0,d5
; End of function sub_6F4A


; =============== S U B R O U T I N E =======================================


HCZ_WaterTunnels:
		lea	(HCZ1_WaterTunLocs).l,a2
		tst.b	($FFFFFE11).w
		beq.s	loc_6FA2
		lea	(HCZ2_WaterTunLocs).l,a2

loc_6FA2:
		move.w	(a2)+,d2

loc_6FA4:
		move.w	$10(a1),d0
		cmp.w	(a2),d0
		bcs.w	loc_7046
		cmp.w	4(a2),d0
		bcc.w	loc_7046
		move.w	$14(a1),d1
		cmp.w	2(a2),d1
		bcs.w	loc_7046
		cmp.w	6(a2),d1
		bcc.s	loc_7046
		cmpi.b	#4,5(a1)
		bcc.w	loc_7058
		btst	d5,($FFFFF7C7).w
		bne.s	locret_702E
		tst.b	$2E(a1)
		bne.s	loc_7058
		move.b	#1,(a3)
		move.w	8(a2),d0
		move.w	d0,$18(a1)
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$10(a1)
		move.w	$A(a2),d1
		move.w	d1,$1A(a1)
		ext.l	d1
		lsl.l	#8,d1
		add.l	d1,$14(a1)
		move.b	#$F,$20(a1)
		bset	#1,$2A(a1)
		move.b	#0,$2F(a1)
		tst.b	$C(a2)
		bne.s	loc_7030
		btst	#0,d6
		beq.s	loc_7024
		subq.w	#1,$14(a1)

loc_7024:
		btst	#1,d6
		beq.s	locret_702E
		addq.w	#1,$14(a1)

locret_702E:
		rts
; ---------------------------------------------------------------------------

loc_7030:
		btst	#2,d6
		beq.s	loc_703A
		subq.w	#1,$10(a1)

loc_703A:
		btst	#3,d6
		beq.s	locret_7044
		addq.w	#1,$10(a1)

locret_7044:
		rts
; ---------------------------------------------------------------------------

loc_7046:
		adda.w	#$E,a2
		dbf	d2,loc_6FA4
		tst.b	(a3)
		beq.s	locret_705A
		move.b	#$1A,$20(a1)

loc_7058:
		clr.b	(a3)

locret_705A:
		rts
; End of function HCZ_WaterTunnels

; ---------------------------------------------------------------------------
HCZ1_WaterTunLocs:	dc.w	 $E  
		dc.w   $380,  $580,  $5A0,  $5C0,  $3F0,	$FFE0,	   0	; Min X, Min Y, Max X, Max Y, X Velo, Y Velo, Player can influence which axis flag (Set = X, Clear = Y)
		dc.w   $5A0,  $560,  $A80,  $5C0,  $3F0, $FFF0,	    0 
		dc.w   $1400, $A80, $15A0,  $AC0,  $400,     0,     0	
		dc.w   $15A0,	$A40, $1960,  $AC0,  $400, $FFC0,     0 
		dc.w   $1990,	 $780, $19E0, $7F0,	 0, $FC00,  $100 
		dc.w   $1990,  $7F0,	$19F0,	$878, $FEC0, $FC00,  $100 
		dc.w   $1990,  $878, $19F0,	 $8FD,	$140, $FC00,  $100 
		dc.w   $1990,  $8FD, $19F0,  $978,	$FEC0, $FC00,  $100 
		dc.w   $1990,  $978, $19F0,  $A10,  $100,	$FC00,	$100
		dc.w   $1960,  $A10, $19D0,  $A80,  $300, $FD80,	 $100 
		dc.w   $2B00,  $800, $2C20,  $840,  $400,     0,     0
		dc.w   $2C20,	$7C0, $2EE0,  $840,  $400, $FFC0,     0 
		dc.w   $2EE0,	 $790, $2F50,  $800,  $300, $FD00,  $100 
		dc.w   $2F00,  $700,	$2F70,	$790, $100, $FC00,  $100 
		dc.w   $2F30,  $680, $2F70,	 $700,	   0, $FC00,  $100
HCZ2_WaterTunLocs:	dc.w	  1
		dc.w   $3980,  $800, $3AA0,  $840,  $400,	    0,	   0 
		dc.w   $3AA0,  $7C0, $3F00,  $840,  $400, $FFC0,	    0


; =============== S U B R O U T I N E =======================================


sub_714E:

		cmpi.w	#$101,($FFFFFE10).w
		beq.s	loc_716A
		cmpi.w	#$500,($FFFFFE10).w
		beq.s	loc_71D2
		cmpi.b	#8,($FFFFFE10).w
		beq.w	loc_72FA
		rts
; ---------------------------------------------------------------------------

loc_716A:
		lea	($FFFFB000).w,a1
		move.b	($FFFFF602).w,d2
		bsr.s	sub_717C
		lea	($FFFFB04A).w,a1
		move.b	($FFFFF66A).w,d2
; End of function sub_714E


; =============== S U B R O U T I N E =======================================


sub_717C:
		btst	#1,$2A(a1)
		bne.s	loc_71B8
		cmpi.b	#$C,$46(a1)
		beq.s	loc_71B8
		lea	($FFFF8000).w,a2
		move.w	$14(a1),d0
		lsr.w	#5,d0
		and.w	($FFFFEEAE).w,d0
		move.w	8(a2,d0.w),d0
		move.w	$10(a1),d1
		lsr.w	#7,d1
		add.w	d1,d0
		movea.w	d0,a2
		move.b	(a2),d0
		lea	byte_7498(pc),a2
		moveq	#9,d1

loc_71B0:
		cmp.b	-(a2),d0
		dbeq	d1,loc_71B0
		beq.s	loc_71CC

loc_71B8:
		tst.b	$2B(a1)
		bpl.s	locret_71CA
		move.w	#5,$32(a1)
		andi.b	#$7F,$2B(a1)

locret_71CA:
		rts
; ---------------------------------------------------------------------------

loc_71CC:
		moveq	#-8,d0
		bra.w	loc_723E
; End of function sub_717C

; ---------------------------------------------------------------------------

loc_71D2:
		lea	($FFFFB000).w,a1
		move.b	($FFFFF602).w,d2
		bsr.s	sub_71E4
		lea	($FFFFB04A).w,a1
		move.b	($FFFFF66A).w,d2

; =============== S U B R O U T I N E =======================================


sub_71E4:
		btst	#1,$2A(a1)
		bne.s	loc_7220
		btst	#3,$2A(a1)
		bne.s	loc_7220
		lea	($FFFF8000).w,a2
		move.w	$14(a1),d0
		lsr.w	#5,d0
		and.w	($FFFFEEAE).w,d0
		move.w	8(a2,d0.w),d0
		move.w	$10(a1),d1
		lsr.w	#7,d1
		add.w	d1,d0
		movea.w	d0,a2
		move.b	(a2),d0
		lea	byte_74A2(pc),a2
		moveq	#9,d1

loc_7218:
		cmp.b	-(a2),d0
		dbeq	d1,loc_7218
		beq.s	loc_7234

loc_7220:
		tst.b	$2B(a1)
		bpl.s	locret_7232
		move.w	#5,$32(a1)
		andi.b	#$7F,$2B(a1)

locret_7232:
		rts
; ---------------------------------------------------------------------------

loc_7234:
		lea	(byte_74A2).l,a2
		move.b	(a2,d1.w),d0

loc_723E:
		beq.s	loc_728A
		move.b	$1C(a1),d1
		tst.b	d0
		bpl.s	loc_7254
		cmp.b	d0,d1
		ble.s	loc_725E
		subi.w	#$40,$1C(a1)
		bra.s	loc_725E
; ---------------------------------------------------------------------------

loc_7254:
		cmp.b	d0,d1
		bge.s	loc_725E
		addi.w	#$40,$1C(a1)

loc_725E:
		bclr	#0,$2A(a1)
		tst.b	d1
		bpl.s	loc_726E
		bset	#0,$2A(a1)

loc_726E:
		move.b	#$1B,$20(a1)
		cmpi.b	#5,($FFFFFE10).w
		bne.s	loc_7282
		move.b	#$19,$20(a1)

loc_7282:
		ori.b	#$80,$2B(a1)
		rts
; ---------------------------------------------------------------------------

loc_728A:
		move.w	#4,d1
		move.w	$1C(a1),d0
		btst	#2,d2
		beq.s	loc_72AC
		move.b	#0,$20(a1)
		bset	#0,$2A(a1)
		sub.w	d1,d0
		tst.w	d0
		bpl.s	loc_72AC
		sub.w	d1,d0

loc_72AC:
		btst	#3,d2
		beq.s	loc_72C6
		move.b	#0,$20(a1)
		bclr	#0,$2A(a1)
		add.w	d1,d0
		tst.w	d0
		bmi.s	loc_72C6
		add.w	d1,d0

loc_72C6:
		move.w	#4,d1
		tst.w	d0
		beq.s	loc_72EE
		bmi.s	loc_72E0
		sub.w	d1,d0
		bhi.s	loc_72DE
		move.w	#0,d0
		move.b	#5,$20(a1)

loc_72DE:
		bra.s	loc_72EE
; ---------------------------------------------------------------------------

loc_72E0:
		add.w	d1,d0
		bhi.s	loc_72EE
		move.w	#0,d0
		move.b	#5,$20(a1)

loc_72EE:
		move.w	d0,$1C(a1)
		ori.b	#$80,$2B(a1)
		rts
; End of function sub_71E4

; ---------------------------------------------------------------------------

loc_72FA:
		lea	($FFFFB000).w,a1
		move.b	($FFFFF602).w,d2
		bsr.s	sub_730C
		lea	($FFFFB04A).w,a1
		move.b	($FFFFF66A).w,d2

; =============== S U B R O U T I N E =======================================


sub_730C:
		btst	#1,$2A(a1)
		bne.s	loc_734A
		btst	#3,$2A(a1)
		bne.s	loc_734A
		lea	($FFFF8000).w,a2
		moveq	#$14,d0
		add.w	$14(a1),d0
		lsr.w	#5,d0
		and.w	($FFFFEEAE).w,d0
		move.w	8(a2,d0.w),d0
		move.w	$10(a1),d1
		lsr.w	#7,d1
		add.w	d1,d0
		movea.w	d0,a2
		move.b	(a2),d0
		lea	byte_74BD(pc),a2
		moveq	#$10,d1

loc_7342:
		cmp.b	-(a2),d0
		dbeq	d1,loc_7342
		beq.s	loc_7384

loc_734A:
		tst.b	$2B(a1)
		bpl.s	locret_7382
		move.w	#5,$32(a1)
		andi.b	#$7F,$2B(a1)
		btst	#1,$2A(a1)
		bne.s	locret_7382
		move.b	$44(a1),$1E(a1)
		move.b	$45(a1),$1F(a1)
		bclr	#2,$2A(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$20(a1)

locret_7382:
		rts
; ---------------------------------------------------------------------------

loc_7384:
		add.w	d1,d1
		lea	(byte_74BD).l,a2
		move.b	(a2,d1.w),d0
		move.b	1(a2,d1.w),d1
		bne.w	loc_7448

loc_7398:

		move.b	$1C(a1),d1
		tst.b	d0
		bpl.s	loc_73C8
		cmp.b	d0,d1
		ble.s	loc_73EE
		subi.w	#$40,$1C(a1)
		tst.b	$2B(a1)
		bmi.s	loc_73EE
		tst.w	$1C(a1)
		bmi.s	loc_73EE
		asr	$1C(a1)
		cmpi.b	#-8,d0
		bne.s	loc_73EE
		move.w	#0,$1C(a1)
		bra.s	loc_73EE
; ---------------------------------------------------------------------------

loc_73C8:
		cmp.b	d0,d1
		bge.s	loc_73EE
		addi.w	#$40,$1C(a1)
		tst.b	$2B(a1)
		bmi.s	loc_73EE
		tst.w	$1C(a1)
		bpl.s	loc_73EE
		asr	$1C(a1)
		cmpi.b	#8,d0
		bne.s	loc_73EE
		move.w	#0,$1C(a1)

loc_73EE:
		tst.b	d1
		beq.s	loc_7402
		bclr	#0,$2A(a1)
		tst.b	d1
		bpl.s	loc_7402
		bset	#0,$2A(a1)

loc_7402:
		move.b	#$19,$20(a1)
		move.b	$1E(a1),d0
		subi.b	#$E,d0
		ext.w	d0
		add.w	d0,$14(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		bclr	#2,$2A(a1)
		bclr	#4,$2A(a1)
		ori.b	#$80,$2B(a1)
		move.b	($FFFFFE0F).w,d0
		andi.b	#$F,d0
		bne.s	locret_7446
		moveq	#-$38,d0
		jsr	(Play_Sound_2).l

locret_7446:
		rts
; ---------------------------------------------------------------------------

loc_7448:
		cmpi.b	#1,d1
		bne.s	loc_7462
		move.w	$10(a1),d1
		andi.w	#$7F,d1
		cmpi.w	#$40,d1
		bcs.w	loc_7398
		bra.w	loc_734A
; ---------------------------------------------------------------------------

loc_7462:
		cmpi.b	#2,d1
		bne.s	loc_747C
		move.w	$10(a1),d1
		andi.w	#$7F,d1
		cmpi.w	#$40,d1
		bcc.w	loc_7398
		bra.w	loc_734A
; ---------------------------------------------------------------------------

loc_747C:
		moveq	#-8,d0
		cmpi.b	#$C,$46(a1)
		beq.w	loc_7398
		moveq	#8,d0
		bra.w	loc_7398
; End of function sub_730C

; ---------------------------------------------------------------------------
		dc.b  $1C, $72,	$83, $84, $8B, $91, $9F, $A0, $A5, $A6
byte_7498:	dc.b  $2E, $C6,	$33, $C5, $24, $2A, $44, $1F, $27, $2B

byte_74A2:	dc.b  $F8, $F8,	  8,   8, $F4, $F4, $F4,  $C,  $C,  $C,	 $F, $13, $14, $15, $16, $17, $35, $6C,	$6D, $76
		dc.b  $77, $7E, $7F, $85, $8A, $8C, $90

byte_74BD:	dc.b  $F8,   0,	$F8,   0, $FA,	 1, $FA,   2, $F8,   0,	$F8,   0, $F8,	 0,   6,   1,	0,   3,	  6,   2
		dc.b    8,   0,   8,   0,   8,   0,   8,   0,   8,   0,   0,   3, $F8,   0,   0
WaterTransition_AIZ1:	dc.w $F
		dc.w 2
		dc.w $68
		dc.w $62
		dc.w $42
		dc.w $48
		dc.w $4E
		dc.w $54
		dc.w 8
		dc.w $E
		dc.w $14
		dc.w $1A
		dc.w $34
		dc.w $22
		dc.w $3A
		dc.w $2E
		dc.w $28
WaterTransition_AIZ2:	dc.w $12
		dc.w $6E
		dc.w $68
		dc.w 2
		dc.w $48
		dc.w $42
		dc.w $4E
		dc.w $5A
		dc.w $54
		dc.w $62
		dc.w $74
		dc.w 8
		dc.w $E
		dc.w $14
		dc.w $1A
		dc.w $34
		dc.w $22
		dc.w $3A
		dc.w $2E
		dc.w $28
WaterTransition_CNZ2ICZ2:	dc.w $13
		dc.w $6E
		dc.w $68
		dc.w $7A
		dc.w $74
		dc.w $62
		dc.w 2
		dc.w $42
		dc.w $48
		dc.w $4E
		dc.w $5A
		dc.w 8
		dc.w $E
		dc.w $14
		dc.w $1A
		dc.w $34
		dc.w $22
		dc.w $3A
		dc.w $2E
		dc.w $28
		dc.w $54
WaterTransition_HCZLBZ1:	dc.w $13
		dc.w 2
		dc.w $74
		dc.w $62
		dc.w $68
		dc.w $6E
		dc.w $42
		dc.w $48
		dc.w $7A
		dc.w $5A
		dc.w $54
		dc.w 8
		dc.w $E
		dc.w $14
		dc.w $1A
		dc.w $2E
		dc.w $34
		dc.w $28
		dc.w $3A
		dc.w $22
		dc.w $4E
WaterTransition_LBZ2:	dc.w $13
		dc.w 2
		dc.w $6E
		dc.w $68
		dc.w $7A
		dc.w $62
		dc.w $74
		dc.w $42
		dc.w $48
		dc.w $5A
		dc.w $54
		dc.w 8
		dc.w $E
		dc.w $14
		dc.w $1A
		dc.w $2E
		dc.w $34
		dc.w $28
		dc.w $3A
		dc.w $22
		dc.w $4E
		dc.w $13
		dc.w 2
		dc.w 8
		dc.w $E
		dc.w $14
		dc.w $1A
		dc.w $42
		dc.w $48
		dc.w $4E
		dc.w $54
		dc.w $5A
		dc.w $62
		dc.w $68
		dc.w $6E
		dc.w $74
		dc.w $7A
		dc.w $22
		dc.w $28
		dc.w $2E
		dc.w $34
		dc.w $3A

; =============== S U B R O U T I N E =======================================


GetDemoPtr:

		move.w	($FFFFEF7A).w,d0
		lsl.w	#2,d0
		movea.l	DemoPtrs(pc,d0.w),a0
		move.b	(a0)+,($FFFFEF78).w
		move.l	a0,($FFFFEF52).w
		clr.b	($FFFFEF79).w
		move.w	#$8000,($FFFFF604).w
		move.w	#$8000,($FFFFF606).w
		st	($FFFFEF50).w
		rts
; End of function GetDemoPtr

; ---------------------------------------------------------------------------
DemoPtrs:	include "Levels\Misc\Demo pointers.asm"

; =============== S U B R O U T I N E =======================================


Demo_PlayRecord:

		tst.w	($FFFFFFD0).w
		bne.s	loc_761E
		rts
; ---------------------------------------------------------------------------

loc_761E:
		move.b	($FFFFF605).w,d0
		andi.b	#$80,d0
		beq.s	loc_762E
		move.b	#4,($FFFFF600).w

loc_762E:
		movea.l	($FFFFEF52).w,a0
		cmpi.b	#4,($FFFFFE10).w
		beq.s	loc_765E
		cmpi.b	#7,($FFFFFE10).w
		bcc.s	loc_765E
		move.b	($FFFFEF50).w,d1
		andi.b	#$80,d1
		or.b	-1(a0),d1
		move.b	($FFFFF604).w,d0
		andi.b	#$80,d0
		sne	($FFFFEF50).w
		or.b	(a0)+,d0
		bra.s	loc_768C
; ---------------------------------------------------------------------------

loc_765E:
					; Demo_PlayRecord+2Aj
		move.b	(a0),d2
		subq.b	#1,($FFFFEF78).w
		bcc.s	loc_766E
		addq.w	#2,a0
		move.b	-1(a0),($FFFFEF78).w

loc_766E:
		move.b	($FFFFEF50).w,d1
		andi.b	#$80,d1
		or.b	($FFFFEF79).w,d1
		move.b	d2,($FFFFEF79).w
		move.b	($FFFFF604).w,d0
		andi.b	#$80,d0
		sne	($FFFFEF50).w
		or.b	d2,d0

loc_768C:
		move.b	d0,($FFFFF604).w
		eor.b	d0,d1
		and.b	d0,d1
		move.b	d1,($FFFFF605).w
		move.w	#$8080,d0
		and.w	d0,($FFFFF606).w
		move.l	a0,($FFFFEF52).w
		rts
; End of function Demo_PlayRecord


; =============== S U B R O U T I N E =======================================


LoadSolids:

		moveq	#0,d0
		move.w	($FFFFFE10).w,d0
		ror.b	#1,d0
		lsr.w	#5,d0
		lea	(SolidIndexes).l,a1
		adda.l	d0,a1
		move.l	(a1),d0
		move.l	d0,($FFFFF7B4).w
	if Sonic3_Complete=0
		cmpi.l	#$260000,d0
	else
		cmpi.l	#$200000,d0
	endif
		bcs.s	LoadSolids_SK_Interleaved_Format
		addi.l	#$600,d0
		move.l	d0,($FFFFF7B8).w
		move.l	($FFFFF7B4).w,($FFFFF796).w
		rts
; ---------------------------------------------------------------------------

LoadSolids_SK_Interleaved_Format:
		addq.l	#1,d0
		move.l	d0,($FFFFF7B8).w
		move.l	($FFFFF7B4).w,($FFFFF796).w
		rts
; End of function LoadSolids


; =============== S U B R O U T I N E =======================================


sub_76E6:
		lea	($FFFFFE6E).w,a1
		lea	(word_76FA).l,a2
		moveq	#$20,d1

loc_76F2:
		move.w	(a2)+,(a1)+
		dbf	d1,loc_76F2
		rts
; End of function sub_76E6

; ---------------------------------------------------------------------------
word_76FA:	dc.w $7D
		dc.w $80
		dc.w 0
		dc.w $80
		dc.w 0
		dc.w $80
		dc.w 0
		dc.w $80
		dc.w 0
		dc.w $80
		dc.w 0
		dc.w $80
		dc.w 0
		dc.w $80
		dc.w 0
		dc.w $80
		dc.w 0
		dc.w $80
		dc.w 0
		dc.w $3848
		dc.w $EE
		dc.w $2080
		dc.w $B4
		dc.w $3080
		dc.w $10E
		dc.w $5080
		dc.w $1C2
		dc.w $7080
		dc.w $276
		dc.w $80
		dc.w 0
		dc.w $4000
		dc.w $FE

; =============== S U B R O U T I N E =======================================


sub_773C:
		tst.w	($FFFFFFE8).w
		bne.s	loc_774A
		cmpi.b	#6,($FFFFB005).w
		bcc.s	locret_7790

loc_774A:
		lea	($FFFFFE6E).w,a1
		lea	(word_7792).l,a2
		move.w	(a1)+,d3
		moveq	#$F,d1

loc_7758:
		move.w	(a2)+,d2
		move.w	(a2)+,d4
		btst	d1,d3
		bne.s	loc_7774
		move.w	2(a1),d0
		add.w	d2,d0
		move.w	d0,2(a1)
		add.w	d0,(a1)
		cmp.b	(a1),d4
		bhi.s	loc_7786
		bset	d1,d3
		bra.s	loc_7786
; ---------------------------------------------------------------------------

loc_7774:
		move.w	2(a1),d0
		sub.w	d2,d0
		move.w	d0,2(a1)
		add.w	d0,(a1)
		cmp.b	(a1),d4
		bls.s	loc_7786
		bclr	d1,d3

loc_7786:
		addq.w	#4,a1
		dbf	d1,loc_7758
		move.w	d3,($FFFFFE6E).w

locret_7790:
		rts
; End of function sub_773C

; ---------------------------------------------------------------------------
word_7792:	dc.w 2
		dc.w $10
		dc.w 2
		dc.w $18
		dc.w 2
		dc.w $20
		dc.w 2
		dc.w $30
		dc.w 4
		dc.w $20
		dc.w 8
		dc.w 8
		dc.w 8
		dc.w $40
		dc.w 4
		dc.w $40
		dc.w 2
		dc.w $38
		dc.w 2
		dc.w $38
		dc.w 2
		dc.w $20
		dc.w 3
		dc.w $30
		dc.w 5
		dc.w $50
		dc.w 7
		dc.w $70
		dc.w 2
		dc.w $40
		dc.w 2
		dc.w $40

; =============== S U B R O U T I N E =======================================


sub_77D2:
		subq.b	#1,($FFFFFEB2).w
		bpl.s	loc_77E8
		move.b	#7,($FFFFFEB2).w
		addq.b	#1,($FFFFFEB3).w
		andi.b	#3,($FFFFFEB3).w

loc_77E8:
		tst.b	($FFFFFEB6).w
		beq.s	loc_780A
		moveq	#0,d0
		move.b	($FFFFFEB6).w,d0
		add.w	($FFFFFEB8).w,d0
		move.w	d0,($FFFFFEB8).w
		rol.w	#7,d0
		andi.w	#3,d0
		move.b	d0,($FFFFFEB7).w
		subq.b	#1,($FFFFFEB6).w

loc_780A:
		addi.w	#$180,($FFFFFEBA).w
		rts
; End of function sub_77D2


; =============== S U B R O U T I N E =======================================


LoadLevelLoadBlock:
		move.w	($FFFFFE10).w,d0
		bne.s	loc_782A
		cmpi.w	#2,($FFFFFF08).w
		bcc.s	loc_7826
		tst.b	($FFFFFE2A).w
		beq.s	loc_782A

loc_7826:
		move.w	#$D00,d0

loc_782A:
					; LoadLevelLoadBlock+12j
		ror.b	#1,d0
		lsr.w	#4,d0
		andi.w	#$1F8,d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		lea	(LevelLoadBlock).l,a4
		lea	(a4,d0.w),a4
		move.l	(a4)+,d0
		andi.l	#$FFFFFF,d0
		move.l	d0,d7
		movea.l	d0,a1
		move.w	(a1),d4
		move.w	#0,d2
		jsr	(Queue_Kos_Module).l
		move.l	(a4)+,d0
		andi.l	#$FFFFFF,d0
		cmp.l	d0,d7
		beq.s	loc_7870
		movea.l	d0,a1
		move.w	d4,d2
		jsr	(Queue_Kos_Module).l

loc_7870:
					; LoadLevelLoadBlock+7Cj
		move.b	#$C,($FFFFF62A).w
		jsr	(Process_Kos_Queue).l
		bsr.w	Wait_VSync
		bsr.w	Process_Nem_Queue_Init
		jsr	(Process_Kos_Module_Queue).l
		tst.b	($FFFFFF60).w
		bne.s	loc_7870
		rts
; End of function LoadLevelLoadBlock


; =============== S U B R O U T I N E =======================================


CheckLevelForWater:

		cmpi.w	#0,($FFFFFE10).w
		beq.s	loc_78F2
		cmpi.w	#1,($FFFFFE10).w
		bne.s	loc_78B2
		cmpi.w	#1,($FFFFEE4E).w
		bne.s	loc_78F2
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_78F2

loc_78B2:
		cmpi.b	#1,($FFFFFE10).w
		beq.s	loc_78F2
		cmpi.w	#$301,($FFFFFE10).w
		bne.s	loc_78CA
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_78F2

loc_78CA:
		cmpi.w	#$501,($FFFFFE10).w
		beq.s	loc_78F2
		cmpi.w	#$601,($FFFFFE10).w
		beq.s	loc_78F2
		move.w	#$1000,d0
		move.w	d0,($FFFFF646).w
		move.w	d0,($FFFFF648).w
		move.w	d0,($FFFFF64A).w
		move.b	#0,($FFFFF730).w
		rts
; ---------------------------------------------------------------------------

loc_78F2:
					; CheckLevelForWater+16j ...
		move.b	#1,($FFFFF730).w
		move.w	#0,($FFFFFFE8).w
		tst.b	($FFFFF730).w
		beq.s	LoadWaterPalette
		move.w	#$4EF9,($FFFFFFF6).w
		move.l	#HInt2,($FFFFFFF8).w
		cmpi.b	#1,($FFFFFE10).w
		beq.s	loc_7932
		move.l	#HInt3,($FFFFFFF8).w
		cmpi.w	#$1000,($FFFFFFD6).w
		bcs.s	loc_7932
		move.l	#HInt4,($FFFFFFF8).w

loc_7932:
					; CheckLevelForWater+96j
		move.l	#WaterTransition_AIZ1,($FFFFF62E).w
		moveq	#0,d0
		move.w	($FFFFFE10).w,d0
		ror.b	#1,d0
		lsr.w	#6,d0
		andi.w	#$FFFE,d0
		lea	(StartingWaterHeights).l,a1
		move.w	(a1,d0.w),d0
		move.w	d0,($FFFFF646).w
		move.w	d0,($FFFFF648).w
		move.w	d0,($FFFFF64A).w
		clr.b	($FFFFF64D).w
		clr.b	($FFFFF64E).w
		move.b	#1,($FFFFF64C).w
; End of function CheckLevelForWater


; =============== S U B R O U T I N E =======================================


LoadWaterPalette:
		tst.b	($FFFFF730).w
		beq.w	locret_7A20
		moveq	#$2B,d0
		cmpi.w	#0,($FFFFFE10).w
		beq.w	loc_7A00
		moveq	#$2C,d0
		move.l	#WaterTransition_AIZ2,($FFFFF62E).w
		cmpi.w	#1,($FFFFFE10).w
		beq.s	loc_7A00
		moveq	#$31,d0
		move.l	#WaterTransition_HCZLBZ1,($FFFFF62E).w
		cmpi.w	#$100,($FFFFFE10).w
		beq.s	loc_7A00
		moveq	#$32,d0
		move.l	#WaterTransition_HCZLBZ1,($FFFFF62E).w
		cmpi.w	#$101,($FFFFFE10).w
		beq.s	loc_7A00
		moveq	#$3A,d0
		move.l	#WaterTransition_CNZ2ICZ2,($FFFFF62E).w
		cmpi.w	#$301,($FFFFFE10).w
		beq.s	loc_7A00
		moveq	#$39,d0
		move.l	#WaterTransition_CNZ2ICZ2,($FFFFF62E).w
		cmpi.w	#$501,($FFFFFE10).w
		beq.s	loc_7A00
		moveq	#$2D,d0
		move.l	#WaterTransition_HCZLBZ1,($FFFFF62E).w
		cmpi.w	#$600,($FFFFFE10).w
		beq.s	loc_7A00
		moveq	#$2E,d0
		move.l	#WaterTransition_LBZ2,($FFFFF62E).w
		cmpi.w	#$601,($FFFFFE10).w
		beq.s	loc_7A00
		nop

loc_7A00:
		move.w	d0,d1
		bsr.w	LoadPalette2
		move.w	d1,d0
		bsr.w	LoadPalette2_Immediate
		tst.b	($FFFFFE2A).w
		beq.s	loc_7A18
		move.b	($FFFFFE42).w,($FFFFF64E).w

loc_7A18:
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_7A22

locret_7A20:
		rts
; ---------------------------------------------------------------------------

loc_7A22:
		moveq	#0,d0
		move.b	($FFFFFE10).w,d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		add.w	d0,d0
		lea	Pal_WaterKnux(pc,d0.w),a1
		move.l	(a1),($FFFFF084).w
		move.w	4(a1),($FFFFF088).w
		move.l	(a1),($FFFFF004).w
		move.w	4(a1),($FFFFF008).w
		rts
; End of function LoadWaterPalette

; ---------------------------------------------------------------------------
Pal_WaterKnux:	binclude "Levels\Misc\Palettes\Water Knuckles Patch.bin"
; ---------------------------------------------------------------------------

LevelSelect_S2Options:
		clr.w	($FFFFFE10).w
		bsr.w	Pal_FadeToBlack
		move	#$2700,sr
		move.w	($FFFFF60E).w,d0
		andi.b	#$BF,d0
		move.w	d0,($C00004).l
		bsr.w	Clear_DisplayData
		lea	($C00004).l,a6
		move.w	#$8004,(a6)
		move.w	#$8230,(a6)
		move.w	#$8407,(a6)
		move.w	#$8230,(a6)
		move.w	#$8700,(a6)
		move.w	#$8C81,(a6)
		move.w	#$9001,(a6)
		move.w	#$8B00,(a6)
		lea	($FFFFAC00).w,a1
		moveq	#0,d0
		move.w	#$FF,d1

loc_7AC2:
		move.l	d0,(a1)+
		dbf	d1,loc_7AC2
		lea	($FFFFB000).w,a1
		moveq	#0,d0
		move.w	#$7FF,d1

loc_7AD2:
		move.l	d0,(a1)+
		dbf	d1,loc_7AD2
		clr.w	($FFFFFB00).w
		move.l	#$FFFFFB00,($FFFFFBFC).w
		move.l	#$42000000,($C00004).l
		lea	(ArtNem_S22POptions).l,a0
		bsr.w	Nem_Decomp
		lea	($FFFF0000).l,a1
		lea	(MapEni_S22POptions).l,a0
		move.w	#$6000,d0
		bsr.w	Eni_Decomp
		lea	($FFFF0000).l,a1
		move.l	#$60000003,d0
		moveq	#$27,d1
		moveq	#$1B,d2
		jsr	(Plane_Map_To_VRAM).l
		lea	($FFFF0000).l,a3
		move.w	#$45F,d1

loc_7B2C:
		move.w	#0,(a3)+
		dbf	d1,loc_7B2C
		lea	($FFFF0000).l,a3
		lea	(byte_80E6).l,a1
		lea	(word_80C4).l,a5
		moveq	#0,d0
		move.w	#$10,d1

loc_7B4C:
		move.w	(a5)+,d3
		lea	(a3,d3.w),a2
		moveq	#0,d2
		move.b	(a1)+,d2
		move.w	d2,d3

loc_7B58:
		move.b	(a1)+,d0
		move.w	d0,(a2)+
		dbf	d2,loc_7B58
		move.w	#$D,d2
		sub.w	d3,d2
		bcs.s	loc_7B70

loc_7B68:
		move.w	#0,(a2)+
		dbf	d2,loc_7B68

loc_7B70:
		move.w	#$11,(a2)
		lea	$50(a2),a2
		move.w	#$12,(a2)
		dbf	d1,loc_7B4C
		move.w	#0,(a2)
		lea	-$50(a2),a2
		move.w	#$1A,(a2)
		move.w	#$13,($FFFF018A).l
		move.w	#$14,($FFFF01DA).l
		lea	($FFFF0000).l,a1
		move.l	#$40000003,d0
		moveq	#$27,d1
		moveq	#$1B,d2
		jsr	(Plane_Map_To_VRAM).l
		moveq	#0,d3
		bsr.w	sub_8012
		clr.w	($FFFFFF08).w
		clr.w	($FFFFFF02).w
		clr.b	($FFFFF711).w
		clr.w	($FFFFF7F0).w
		lea	(AniPLC_SONICMILES).l,a2
		jsr	(AnimateTiles_DoAniPLC).l
		moveq	#4,d0
		bsr.w	LoadPalette
		lea	($FFFFFC40).w,a1
		lea	($FFFFFCC0).w,a2
		moveq	#7,d1

loc_7BE4:
		move.l	(a1),(a2)+
		clr.l	(a1)+
		dbf	d1,loc_7BE4
		moveq	#$2F,d0
		jsr	(Play_Sound).l
		move.w	#$707,($FFFFF614).w
		clr.w	($FFFFFFE8).w
		clr.l	($FFFFEE78).w
		clr.l	($FFFFEE7C).w
		clr.l	($FFFFE660).w
		clr.l	($FFFFFF92).w
		clr.b	($FFFFFE2A).w
		clr.b	($FFFFFE48).w
		clr.b	($FFFFFFD4).w
		nop
		nop
		nop
		nop
		nop
		nop
		clr.w	($FFFFFFE4).w
		clr.w	($FFFFFFE6).w
		move.b	#$16,($FFFFF62A).w
		bsr.w	Wait_VSync
		move.w	($FFFFF60E).w,d0
		ori.b	#$40,d0
		move.w	d0,($C00004).l
		bsr.w	Pal_FadeFromBlack

loc_7C4A:

		move.b	#$16,($FFFFF62A).w
		bsr.w	Wait_VSync
		move	#$2700,sr
		moveq	#0,d3
		bsr.w	sub_7F62
		bsr.w	sub_7E64
		move.w	#$6000,d3
		bsr.w	sub_7F62
		move	#$2300,sr
		lea	(AniPLC_SONICMILES).l,a2
		jsr	(AnimateTiles_DoAniPLC).l
		move.b	($FFFFF605).w,d0
		or.b	($FFFFF607).w,d0
		andi.b	#$80,d0
		bne.s	loc_7C8C
		bra.w	loc_7C4A
; ---------------------------------------------------------------------------

loc_7C8C:
		tst.w	($FFFFFFAE).w
		beq.s	loc_7CA0
		cmpi.w	#3,($FFFFFF0A).w
		bcc.s	loc_7CA0
		move.w	#1,($FFFFFF0A).w

loc_7CA0:

		move.w	($FFFFFF0A).w,($FFFFFF08).w
		lea	LS_Level_Order(pc),a1
		move.w	($FFFFFF82).w,d0
		add.w	d0,d0
		move.w	(a1,d0.w),d0
		bmi.w	loc_7D64
		cmpi.w	#$5555,d0
		beq.w	loc_7C4A
		move.b	#3,($FFFFFE12).w
		move.b	#0,($FFFFFFBB).w
		cmpi.w	#$4000,d0
		beq.w	loc_7D14
		cmpi.w	#$4001,d0
		bne.w	loc_7D6C
		move.b	#1,($FFFFFFBB).w

loc_7CE2:

		move.b	#$34,($FFFFF600).w
		tst.w	($FFFFFFAE).w
		beq.s	locret_7D12
		cmpi.w	#$400,($FFFFFE10).w
		beq.s	locret_7D12
		cmpi.w	#$700,($FFFFFE10).w
		bcc.s	locret_7D12
		move.w	#$700,d0
		move.w	d0,($FFFFFE10).w
		move.w	d0,($FFFFEE4E).w
		move.w	d0,($FFFFFE2C).w
		move.w	d0,($FFFFFF9A).w

locret_7D12:

		rts
; ---------------------------------------------------------------------------

loc_7D14:
		tst.w	($FFFFFFAE).w
		beq.s	loc_7CE2
		move.b	#1,($FFFFFFBB).w
		bra.s	loc_7CE2
; ---------------------------------------------------------------------------
LS_Level_Order:	dc.w	0
		dc.w	1
		dc.w $100
		dc.w $101
		dc.w $200
		dc.w $201
		dc.w $300
		dc.w $301
		dc.w $500
		dc.w $501
		dc.w $600
		dc.w $601
		dc.w $700
		dc.w $701
		dc.w $400
		dc.w $401
		dc.w $800
		dc.w $801
		dc.w $900
		dc.w $901
		dc.w $1600
		dc.w $1601
		dc.w $A00
		dc.w $A01
		dc.w $B00
		dc.w $B01
		dc.w $C00
		dc.w $1700
		dc.w $1400
		dc.w $1500
		dc.w $4000
		dc.w $4001
		dc.w $FFFF
; ---------------------------------------------------------------------------

loc_7D64:
		move.b	#0,($FFFFF600).w
		rts
; ---------------------------------------------------------------------------

loc_7D6C:
		tst.w	($FFFFFFE2).w
		bne.s	loc_7DBA
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_7D9E
		cmpi.w	#$A00,d0
		beq.s	loc_7D92
		cmpi.w	#$C00,d0
		beq.s	loc_7D92
		cmpi.w	#$1600,d0
		beq.s	loc_7D92
		cmpi.w	#$1700,d0
		bne.s	loc_7D9E

loc_7D92:

		moveq	#-$4E,d0
		jsr	(Play_Sound_2).l
		bra.w	loc_7C4A
; ---------------------------------------------------------------------------

loc_7D9E:

		cmpi.w	#3,($FFFFFF08).w
		bcc.s	loc_7DAC
		cmpi.w	#$A01,d0
		beq.s	loc_7D92

loc_7DAC:
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_7DBA
		cmpi.w	#$C00,d0
		beq.s	loc_7D92

loc_7DBA:

		tst.w	($FFFFFFAE).w
		beq.s	loc_7DD6
		move.w	d0,d1
		move.b	#0,d1
		cmpi.w	#$400,d1
		beq.s	loc_7DD6
		cmpi.w	#$700,d1
		bcc.s	loc_7DD6
		move.w	#$700,d0

loc_7DD6:

		andi.w	#$3FFF,d0
		move.w	d0,($FFFFFE10).w
		move.w	d0,($FFFFEE4E).w
		move.w	d0,($FFFFFE2C).w
		move.w	d0,($FFFFFF9A).w
		move.w	#$1000,d0
		move.w	d0,($FFFFFE44).w
		move.w	d0,($FFFFFE62).w
		move.b	#$C,($FFFFF600).w
		move.b	#3,($FFFFFE12).w
		move.b	#3,($FFFFFEC6).w
		moveq	#0,d0
		move.w	d0,($FFFFFE20).w
		move.l	d0,($FFFFFE22).w
		move.l	d0,($FFFFFE26).w
		move.w	d0,($FFFFFED0).w
		move.l	d0,($FFFFFED2).w
		move.l	d0,($FFFFFED6).w
		move.b	d0,($FFFFFE18).w
		move.w	d0,($FFFFFFD0).w
		move.l	#$1388,($FFFFFFC0).w
		move.l	#$1388,($FFFFFFC4).w
		moveq	#-$1F,d0
		jsr	(Play_Sound_2).l
		moveq	#0,d0
		move.w	d0,($FFFFFF8A).w
		move.w	d0,($FFFFFFE8).w
		cmpi.b	#$E,($FFFFFE10).w
		bcs.s	locret_7E62
		cmpi.b	#$13,($FFFFFE10).w
		bcc.s	locret_7E62
		move.w	#1,($FFFFFFE8).w

locret_7E62:

		rts

; =============== S U B R O U T I N E =======================================


sub_7E64:
		move.b	($FFFFF605).w,d1
		andi.b	#3,d1
		bne.s	loc_7E74
		subq.w	#1,($FFFFFF80).w
		bpl.s	loc_7EAA

loc_7E74:
		move.w	#$B,($FFFFFF80).w
		move.b	($FFFFF604).w,d1
		andi.b	#3,d1
		beq.s	loc_7EAA
		move.w	($FFFFFF82).w,d0
		btst	#0,d1
		beq.s	loc_7E94
		subq.w	#1,d0
		bcc.s	loc_7E94
		moveq	#$20,d0

loc_7E94:
		btst	#1,d1
		beq.s	loc_7EA4
		addq.w	#1,d0
		cmpi.w	#$21,d0
		bcs.s	loc_7EA4
		moveq	#0,d0

loc_7EA4:
		move.w	d0,($FFFFFF82).w
		rts
; ---------------------------------------------------------------------------

loc_7EAA:
		cmpi.w	#$20,($FFFFFF82).w
		bne.s	loc_7F08
		move.w	($FFFFFF84).w,d0
		move.b	($FFFFF605).w,d1
		btst	#2,d1
		beq.s	loc_7EC6
		subq.b	#1,d0
		bcc.s	loc_7EC6
		moveq	#0,d0

loc_7EC6:
		btst	#3,d1
		beq.s	loc_7ED6
		addq.b	#1,d0
		cmpi.w	#$100,d0
		bcs.s	loc_7ED6
		moveq	#0,d0

loc_7ED6:
		btst	#6,d1
		beq.s	loc_7EE4
		addi.b	#$10,d0
		andi.b	#$FF,d0

loc_7EE4:
		move.w	d0,($FFFFFF84).w
		btst	#5,d1
		beq.s	loc_7EF8
		move.w	($FFFFFF84).w,d0
		jsr	(Play_Sound).l

loc_7EF8:
		btst	#4,d1
		beq.s	locret_7F06
		moveq	#-$1D,d0
		jsr	(Play_Sound).l

locret_7F06:
		rts
; ---------------------------------------------------------------------------

loc_7F08:
		move.b	($FFFFF605).w,d1
		andi.b	#$C,d1
		beq.s	loc_7F1E
		move.w	($FFFFFF82).w,d0
		move.b	byte_7F22(pc,d0.w),d0
		move.w	d0,($FFFFFF82).w

loc_7F1E:
		bra.s	loc_7F46
; ---------------------------------------------------------------------------
		rts
; ---------------------------------------------------------------------------
byte_7F22:	dc.b  $12, $13, $14, $15, $16, $17, $18, $19, $1A, $1B, $1C, $1D, $1E, $1F, $20, $20, $20, $20,   0,   1
		dc.b    2,   3,   4,   5,   6,   7,   8,   9,  $A,  $B,  $C,  $D,  $E,  $F, $10, $11
; ---------------------------------------------------------------------------

loc_7F46:
		btst	#5,($FFFFF605).w
		beq.s	locret_7F60
		addq.w	#1,($FFFFFF0A).w
		cmpi.w	#4,($FFFFFF0A).w
		bcs.s	locret_7F60
		move.w	#0,($FFFFFF0A).w

locret_7F60:
		rts
; End of function sub_7E64


; =============== S U B R O U T I N E =======================================


sub_7F62:

		lea	($FFFF0000).l,a4
		lea	(byte_8040).l,a5
		lea	($C00000).l,a6
		moveq	#0,d0
		move.w	($FFFFFF82).w,d0
		lsl.w	#2,d0
		lea	(a5,d0.w),a3
		moveq	#0,d0
		move.b	(a3),d0
		mulu.w	#$50,d0
		moveq	#0,d1
		move.b	1(a3),d1
		add.w	d1,d0
		lea	(a4,d0.w),a1
		moveq	#0,d1
		move.b	(a3),d1
		lsl.w	#7,d1
		add.b	1(a3),d1
		addi.w	#$C000,d1
		lsl.l	#2,d1
		lsr.w	#2,d1
		ori.w	#$4000,d1
		swap	d1
		move.l	d1,4(a6)
		moveq	#$E,d2

loc_7FB2:
		move.w	(a1)+,d0
		add.w	d3,d0
		move.w	d0,(a6)
		dbf	d2,loc_7FB2
		addq.w	#2,a3
		moveq	#0,d0
		move.b	(a3),d0
		beq.s	loc_7FF6
		mulu.w	#$50,d0
		moveq	#0,d1
		move.b	1(a3),d1
		add.w	d1,d0
		lea	(a4,d0.w),a1
		moveq	#0,d1
		move.b	(a3),d1
		lsl.w	#7,d1
		add.b	1(a3),d1
		addi.w	#$C000,d1
		lsl.l	#2,d1
		lsr.w	#2,d1
		ori.w	#$4000,d1
		swap	d1
		move.l	d1,4(a6)
		move.w	(a1)+,d0
		add.w	d3,d0
		move.w	d0,(a6)

loc_7FF6:
		cmpi.w	#$20,($FFFFFF82).w
		bne.s	loc_8002
		bra.w	sub_8012
; ---------------------------------------------------------------------------

loc_8002:
		move.l	#$419C0003,($C00004).l
		move.w	($FFFFFF0A).w,d0
		bra.s	loc_8020
; End of function sub_7F62


; =============== S U B R O U T I N E =======================================


sub_8012:

		move.l	#$4B460003,($C00004).l
		move.w	($FFFFFF84).w,d0

loc_8020:
		move.b	d0,d2
		lsr.b	#4,d0
		bsr.s	sub_8028
		move.b	d2,d0
; End of function sub_8012


; =============== S U B R O U T I N E =======================================


sub_8028:
		andi.w	#$F,d0
		cmpi.b	#$A,d0
		bcs.s	loc_8036
		addi.b	#4,d0

loc_8036:
		addi.b	#$10,d0
		add.w	d3,d0
		move.w	d0,(a6)
		rts
; End of function sub_8028

; ---------------------------------------------------------------------------
byte_8040:	dc.b	1,   6,	  1, $24
		dc.b	1,   6,	  2, $24
		dc.b	4,   6,	  4, $24
		dc.b	4,   6,	  5, $24
		dc.b	7,   6,	  7, $24
		dc.b	7,   6,	  8, $24
		dc.b   $A,   6,	 $A, $24
		dc.b   $A,   6,	 $B, $24
		dc.b   $D,   6,	 $D, $24
		dc.b   $D,   6,	 $E, $24
		dc.b  $10,   6,	$10, $24
		dc.b  $10,   6,	$11, $24
		dc.b  $13,   6,	$13, $24
		dc.b  $13,   6,	$14, $24
		dc.b  $16,   6,	$16, $24
		dc.b  $16,   6,	$17, $24
		dc.b  $19,   6,	$19, $24
		dc.b  $19,   6,	$1A, $24
		dc.b	1, $2C,	  1, $4A
		dc.b	1, $2C,	  2, $4A
		dc.b	4, $2C,	  4, $4A
		dc.b	4, $2C,	  5, $4A
		dc.b	7, $2C,	  7, $4A
		dc.b	7, $2C,	  8, $4A
		dc.b   $A, $2C,	 $A, $4A
		dc.b   $A, $2C,	 $B, $4A
		dc.b   $D, $2C,	 $D, $4A
		dc.b   $D, $2C,	 $E, $4A
		dc.b  $10, $2C,	$10, $4A
		dc.b  $10, $2C,	$11, $4A
		dc.b  $13, $2C,	$13, $4A
		dc.b  $13, $2C,	$14, $4A
		dc.b  $16, $2C,	$16, $4A
word_80C4:	dc.w $56

		dc.w $146
		dc.w $236
		dc.w $326
		dc.w $416
		dc.w $506
		dc.w $5F6
		dc.w $6E6
		dc.w $7D6
		dc.w $7C
		dc.w $16C
		dc.w $25C
		dc.w $34C
		dc.w $43C
		dc.w $52C
		dc.w $61C
		dc.w $70C
byte_80E6:	dc.b   $B, $1E, $2B, $24, $22, $29,   0, $26, $30, $29, $1E, $2B, $21,   8, $25, $36, $21, $2F, $2C, $20
		dc.b  $26, $31, $36,  $C, $2A, $1E, $2F, $1F, $29, $22,   0, $24, $1E, $2F, $21, $22, $2B,  $D, $20, $1E
		dc.b  $2F, $2B, $26, $33, $1E, $29,   0, $2B, $26, $24, $25, $31,   5, $26, $20, $22, $20, $1E, $2D,  $A
		dc.b  $29, $1E, $32, $2B, $20, $25,   0, $1F, $1E, $30, $22,  $C, $2A, $32, $30, $25, $2F, $2C, $2C, $2A
		dc.b    0, $25, $26, $29, $29,  $D, $23, $29, $36, $26, $2B, $24,   0, $1F, $1E, $31, $31, $22, $2F, $36
		dc.b    9, $30, $1E, $2B, $21, $2C, $2D, $2C, $29, $26, $30,   8, $29, $1E, $33, $1E,   0, $2F, $22, $22
		dc.b  $23,   8, $29, $1E, $33, $1E,   0, $2F, $22, $22, $23,  $C, $30, $28, $36,   0, $30, $1E, $2B, $20
		dc.b  $31, $32, $1E, $2F, $36,   7, $21, $22, $1E, $31, $25, $22, $24, $24,  $B, $31, $25, $22,   0, $21
		dc.b  $2C, $2C, $2A, $30, $21, $1E, $36,   4, $1F, $2C, $2B, $32, $30,  $C, $30, $2D, $22, $20, $26, $1E
		dc.b  $29,   0, $30, $31, $1E, $24, $22,  $C, $30, $2C, $32, $2B, $21,   0, $31, $22, $30, $31,   0,   0
		dc.b  $1A,   0
AniPLC_SONICMILES:	dc.w	0
		dc.l	ArtUnc_SONICMILES+$FF000000
		dc.w	$20
		dc.b	6
		dc.b	$A
		dc.b	0, $C7
		dc.b	$A, 5
		dc.b	$14, 5
		dc.b	$1E, $C7
		dc.b	$14, 5
		dc.b	$A,	5
; ---------------------------------------------------------------------------

SpecialStage:
		moveq	#-$1E,d0
		bsr.w	Play_Sound
		clr.w	($FFFFFF0E).w
		lea	($FFFFFF10).w,a1
		moveq	#0,d0
		move.w	#$1A,d1

loc_81DA:
		move.l	d0,(a1)+
		dbf	d1,loc_81DA
		bsr.w	Clear_Nem_Queue
		bsr.w	Pal_FadeToWhite
		move	#$2700,sr
		lea	($C00004).l,a6
		move.w	#$8004,(a6)
		move.w	#$8230,(a6)
		move.w	#$8407,(a6)
		move.w	#$9001,(a6)
		move.w	#$9200,(a6)
		move.w	#$8B00,(a6)
		move.w	#$8720,(a6)
		clr.b	($FFFFF64E).w
		move.w	#$8C81,(a6)
		bsr.w	Clear_DisplayData
		lea	($FFFFAC00).w,a1
		moveq	#0,d0
		move.w	#$FF,d1

loc_8224:
		move.l	d0,(a1)+
		dbf	d1,loc_8224
		lea	($FFFFB000).w,a1
		moveq	#0,d0
		move.w	#$7FF,d1

loc_8234:
		move.l	d0,(a1)+
		dbf	d1,loc_8234
		lea	($FFFFFE6E).w,a1
		moveq	#0,d0
		move.w	#$12,d1

loc_8244:
		move.l	d0,(a1)+
		dbf	d1,loc_8244
		lea	($FFFFE400).w,a1
		moveq	#0,d0
		move.w	#$3F,d1

loc_8254:
		move.l	d0,(a1)+
		dbf	d1,loc_8254
		moveq	#0,d0
		move.l	d0,($FFFFFE66).w
		move.l	d0,($FFFFFE6A).w
		jsr	(Init_SpriteTable).l
		clr.w	($FFFFFB00).w
		move.l	#$FFFFFB00,($FFFFFBFC).w
		lea	(Pal_SStage_Main).l,a1
		lea	($FFFFFC80).w,a2
		move.w	#$3F,d0

loc_8284:
		move.w	(a1)+,(a2)+
		dbf	d0,loc_8284
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_82A6

loc_8292:
		lea	(Pal_SStage_Knux).l,a1
		lea	($FFFFFC90).w,a2
		move.w	#7,d0

loc_82A0:
		move.w	(a1)+,(a2)+
		dbf	d0,loc_82A0

loc_82A6:
		move.l	#$40000000,($C00004).l
		lea	(ArtNem_SStageLayout).l,a0
		bsr.w	Nem_Decomp
		bsr.w	sub_85B0
		lea	($FFFF5500).l,a1
		lea	(MapEni_SStageLayout).l,a0
		move.w	#0,d0
		bsr.w	Eni_Decomp
		lea	($FFFF5500).l,a1
		move.l	#$40000003,d0
		moveq	#$27,d1
		moveq	#$1B,d2
		jsr	(Plane_Map_To_VRAM).l
		move.l	#$50000003,($C00004).l
		lea	(ArtNem_SStageSphere).l,a0

loc_82F8:
		bsr.w	Nem_Decomp
		move.l	#$74E00002,($C00004).l
		lea	(ArtNem_SStageRing).l,a0
		bsr.w	Nem_Decomp
		move.l	#$73600002,($C00004).l
		lea	(ArtNem_SStageBG).l,a0
		bsr.w	Nem_Decomp
		move.l	#$6BE00002,($C00004).l
		lea	(ArtNem_GetBlueSpheres).l,a0
		bsr.w	Nem_Decomp
		move.l	#$5F000003,($C00004).l
		lea	(ArtNem_GBSArrow).l,a0
		bsr.w	Nem_Decomp
		move.l	#$70200003,($C00004).l
		lea	(ArtNem_SStageDigits).l,a0
		bsr.w	Nem_Decomp
		lea	(ArtNem_SStageDigits).l,a0
		lea	($FFFFE020).w,a4
		bsr.w	Nem_Decomp_To_RAM
		move.l	#$71200002,($C00004).l
		lea	(ArtNem_SStageIcons).l,a0
		bsr.w	Nem_Decomp
		move.l	#$74000003,($C00004).l
		lea	(ArtNem_SStageShadow).l,a0
		bsr.w	Nem_Decomp
		lea	(SSNum000_Map).l,a1
		move.l	#$40840003,d0
		moveq	#7,d1
		moveq	#2,d2
		jsr	(Plane_Map_To_VRAM).l
		lea	(SSNum000_Map).l,a1
		move.l	#$40BC0003,d0
		moveq	#7,d1
		moveq	#2,d2
		jsr	(Plane_Map_To_VRAM).l
		lea	($FFFF0000).l,a1
		lea	(MapEni_SStageBG).l,a0
		move.w	#$459B,d0
		bsr.w	Eni_Decomp
		lea	($FFFF0000).l,a1
		move.l	#$60000003,d0
		moveq	#$3F,d1
		moveq	#$1F,d2
		jsr	(Plane_Map_To_VRAM).l
		lea	(SStageKos_PerspectiveMaps).l,a0
		lea	($FFFF0000).l,a1
		bsr.w	Kos_Decomp
		bsr.w	sub_9EA0
		bsr.w	Load_SSSprite_Mappings
		clr.b	($FFFFF711).w
		move.b	#$FF,($FFFFE43C).w
		move.b	#$80,($FFFFE43D).w
		move.w	#$1000,($FFFFE444).w
		move.w	#$708,($FFFFE43E).w
		tst.b	($FFFFFFD4).w
		beq.s	loc_842C
		move.w	#$A8C,($FFFFE43E).w

loc_842C:
		move.w	#0,($FFFFEE80).w
		move.w	#0,($FFFFEE84).w
		move.w	#-1,($FFFFEEAA).w
		move.l	#Obj_SStage_8FAA,($FFFFB000).w
		tst.w	($FFFFFF08).w
		bne.s	loc_8454
		move.l	#Obj_SStage_9212,($FFFFB04A).w

loc_8454:
		move.l	#Obj_SStage_8DF8,($FFFFB094).w
		move.l	#Obj_SStage_8E40,($FFFFB0DE).w
		jsr	(Process_Sprites).l
		bsr.w	Animate_SSRings
		bsr.w	sub_9DDE
		jsr	(Render_Sprites).l
		jsr	Draw_SSSprites(pc)
		bsr.w	sub_9D5E
		move.b	#1,($FFFFE433).w
		move.b	#$1C,($FFFFF62A).w
		bsr.w	Wait_VSync
		move.b	#0,($FFFFE433).w
		move.w	#$8C89,($C00004).l
		move.w	#$708,($FFFFF614).w
		jsr	(GetDemoPtr).l
		moveq	#$1C,d0
		bsr.w	Play_Sound
		move.w	($FFFFF60E).w,d0
		ori.b	#$40,d0
		move.w	d0,($C00004).l
		bsr.w	Pal_FromBlackWhite

loc_84C2:
		bsr.w	Pause_Game
		move.b	#$1C,($FFFFF62A).w
		jsr	(Process_Kos_Queue).l
		bsr.w	Wait_VSync
		addq.w	#1,($FFFFFE04).w
		jsr	(Demo_PlayRecord).l
		jsr	(Process_Sprites).l
		bsr.w	Animate_SSRings
		bsr.w	sub_9DDE
		jsr	(Render_Sprites).l
		jsr	Draw_SSSprites(pc)
		bsr.w	sub_94D6
		bsr.w	sub_9D5E
		bsr.w	sub_9B62
		bsr.w	Process_Nem_Queue_Init
		jsr	(Process_Kos_Module_Queue).l
		tst.w	($FFFFFFD0).w
		beq.s	loc_851A
		tst.w	($FFFFF614).w
		beq.s	loc_8522

loc_851A:
		cmpi.b	#$34,($FFFFF600).w
		beq.s	loc_84C2

loc_8522:
		tst.w	($FFFFFFD0).w
		beq.s	loc_852E
		move.b	#0,($FFFFF600).w

loc_852E:
		move.w	#$3C,($FFFFF614).w
		move.w	#$3F,($FFFFF626).w
		clr.w	($FFFFF794).w

loc_853E:
		move.b	#$1C,($FFFFF62A).w
		bsr.w	Wait_VSync
		jsr	(Demo_PlayRecord).l
		jsr	(Process_Sprites).l
		bsr.w	Animate_SSRings
		bsr.w	sub_9DDE
		jsr	(Render_Sprites).l
		jsr	Draw_SSSprites(pc)
		bsr.w	sub_9D5E
		bsr.w	sub_9B62
		bsr.w	Process_Nem_Queue_Init
		jsr	(Process_Kos_Module_Queue).l
		subq.w	#1,($FFFFF794).w
		bpl.s	loc_8588
		move.w	#2,($FFFFF794).w
		bsr.w	Pal_ToWhite

loc_8588:
		tst.w	($FFFFF614).w
		bne.s	loc_853E
		rts
; ---------------------------------------------------------------------------
SSLayoutOffs_RAM:dc.l $FFFF0000
		dc.l $FFFF0408
		dc.l $FFFF0810
		dc.l $FFFF0C18
		dc.l $FFFF1020
		dc.l $FFFF1428
		dc.l $FFFF1830
		dc.l $FFFF1C38

; =============== S U B R O U T I N E =======================================


sub_85B0:
		tst.b	($FFFFFFD4).w
		bne.w	loc_86C8
		lea	(SSCompressedLayoutPtrs).l,a0
		movea.l	(a0),a0
		lea	($FFFF0000).l,a1
		bsr.w	Kos_Decomp
		lea	(SStageLayoutPtrs).l,a2
		move.b	($FFFFFFB0).w,d3
		tst.w	($FFFFFFAE).w
		beq.s	loc_85E4
		lea	(SSLayoutOffs_RAM).l,a2
		moveq	#0,d2
		bra.s	loc_85F4
; ---------------------------------------------------------------------------

loc_85E4:
		move.b	($FFFFFFBB).w,d2
		beq.s	loc_85F4
		lea	(SSLayoutOffs_RAM).l,a2
		move.b	($FFFFFFB1).w,d3

loc_85F4:
		tst.b	($FFFFFFE2).w
		beq.s	loc_8606
		move.w	($FFFFFF84).w,d0
		btst	#6,($FFFFF604).w
		bne.s	loc_8630

loc_8606:
		moveq	#0,d0
		move.b	($FFFFFE16).w,d0
		cmpi.b	#7,d3
		bcc.s	loc_8630
		moveq	#5,d1
		lea	($FFFFFFB2).w,a1
		add.b	d2,d2

loc_861A:
		cmp.b	(a1,d0.w),d2
		beq.s	loc_8630
		addq.w	#1,d0
		cmpi.w	#7,d0
		bcs.s	loc_861A
		moveq	#0,d0
		dbf	d1,loc_861A
		moveq	#7,d0

loc_8630:
		andi.w	#7,d0
		move.b	d0,($FFFFFE16).w
		move.w	d0,d1
		lsl.w	#2,d0
		movea.l	(a2,d0.w),a2
		tst.w	($FFFFFFAE).w
		bne.s	loc_8652
		tst.b	($FFFFFFBB).w
		bne.s	loc_8652
	if Sonic3_Complete=0
		adda.l	#LockOnROM_Start,a2
	else
		adda.l	#0,a2
	endif

loc_8652:
		lea	($FFFFF000).w,a3
		moveq	#0,d2
		move.w	#$3F,d0

loc_865C:
		move.l	d2,(a3)+
		dbf	d0,loc_865C
		move.w	#$FF,d0

loc_8666:
		move.l	(a2)+,(a3)+
		dbf	d0,loc_8666
		move.w	#$3F,d0

loc_8670:
		move.l	d2,(a3)+
		dbf	d0,loc_8670
		move.w	(a2)+,($FFFFE426).w
		move.w	(a2)+,($FFFFE422).w
		move.w	(a2)+,($FFFFE424).w
		move.w	(a2)+,($FFFFE442).w
		lsl.w	#4,d1
		lea	(SS_Pal_Map_Ptrs).l,a1
		lea	($FFFFFC80).w,a2
		movea.l	4(a1,d1.w),a1
		tst.w	($FFFFFFAE).w
		bne.s	loc_86A2
		tst.b	($FFFFFFBB).w
		beq.s	loc_86A6

loc_86A2:
		lea	$130(a1),a1

loc_86A6:
		move.l	a1,($FFFFE446).w
		move.l	(a1)+,$70(a2)
		move.l	(a1)+,$74(a2)
		move.l	(a1)+,$78(a2)
		move.l	(a1)+,$7C(a2)
		move.l	$10(a1),$50(a2)
		move.w	$14(a1),$54(a2)
		rts
; ---------------------------------------------------------------------------

loc_86C8:
		lea	(SSCompressedLayoutPtrs).l,a0
		movea.l	4(a0),a0
		lea	($FFFF0000).l,a1
		bsr.w	Kos_Decomp
		lea	($FFFFF000).w,a3
		moveq	#0,d2
		move.w	#$17F,d0

loc_86E6:
		move.l	d2,(a3)+
		dbf	d0,loc_86E6
		move.b	#0,($FFFFFE16).w
		move.w	#$4000,($FFFFE426).w
		move.w	#$1000,($FFFFE422).w
		move.w	#$300,($FFFFE424).w
		clr.w	($FFFFE442).w
		clr.w	($FFFFFFAC).w
		lea	($FFFFFFA2).w,a4
		lea	word_87BA(pc),a1
		moveq	#3,d7

loc_8716:
		lea	($FFFF0000).l,a2
		move.b	(a4)+,d0
		andi.w	#$7F,d0
		moveq	#0,d1
		move.b	(a2,d0.w),d1
		add.w	d1,($FFFFE442).w
		lea	$80(a2),a2
		moveq	#0,d1
		move.b	(a2,d0.w),d1
		add.w	d1,($FFFFFFAC).w
		lea	$80(a2),a2
		lsl.w	#8,d0
		lea	(a2,d0.w),a2
		move.w	(a1)+,d3
		move.w	(a1)+,d4
		move.w	(a1)+,d5
		move.w	(a1)+,d0
		lea	($FFFFF100).w,a3
		lea	(a3,d0.w),a3
		moveq	#$F,d0

loc_8756:
		move.w	d4,d2
		moveq	#$F,d1

loc_875A:
		move.b	(a2,d2.w),(a3)+
		add.w	d3,d2
		dbf	d1,loc_875A
		lea	$10(a3),a3
		add.w	d5,d4
		dbf	d0,loc_8756
		dbf	d7,loc_8716
		moveq	#0,d1
		move.b	($FFFFFFA4).w,d1
		move.w	d1,d2
		andi.w	#7,d1
		lsl.w	#4,d1
		lea	(SS_Pal_Map_Ptrs).l,a1
		lea	($FFFFFC80).w,a2
		movea.l	4(a1,d1.w),a1
		andi.w	#8,d2
		beq.s	loc_8798
		lea	$130(a1),a1

loc_8798:
		move.l	a1,($FFFFE446).w
		move.l	(a1)+,$70(a2)
		move.l	(a1)+,$74(a2)
		move.l	(a1)+,$78(a2)

loc_87A8:
		move.l	(a1)+,$7C(a2)
		move.l	$10(a1),$50(a2)
		move.w	$14(a1),$54(a2)
		rts
; End of function sub_85B0

; ---------------------------------------------------------------------------
word_87BA:	dc.w 1
		dc.w 0
		dc.w $10
		dc.w 0
		dc.w $FFFF
		dc.w $F
		dc.w $10
		dc.w $10
		dc.w 1
		dc.w $F0
		dc.w $FFF0
		dc.w $200
		dc.w $FFFF
		dc.w $FF
		dc.w $FFF0
		dc.w $210

; =============== S U B R O U T I N E =======================================


Rotate_SSPal:
		tst.b	($FFFFE433).w
		bne.s	locret_8818
		move.w	($FFFFE420).w,d0
		cmpi.w	#$10,d0
		bcs.s	loc_87F8
		tst.b	($FFFFE42A).w
		bpl.s	locret_8818
		move.b	($FFFFE42F).w,d0
		andi.w	#$F,d0

loc_87F8:
		andi.w	#$E,d0
		neg.w	d0
		addi.w	#$10,d0
		movea.l	($FFFFE446).w,a1
		lea	(a1,d0.w),a1
		lea	($FFFFFC70).w,a2
		move.w	#7,d0

loc_8812:
		move.w	(a1)+,(a2)+
		dbf	d0,loc_8812

locret_8818:
		rts
; End of function Rotate_SSPal


; =============== S U B R O U T I N E =======================================


Update_SSMap:
		lea	($C00000).l,a6
		lea	(SS_Pal_Map_Ptrs).l,a1
		move.w	($FFFFE420).w,d0
		cmp.b	($FFFFE42C).w,d0
		beq.s	loc_8876
		move.b	d0,($FFFFE42C).w
		lsl.w	#3,d0
		movea.l	(a1,d0.w),a3
		lea	$10E(a3),a1
		move.l	#$419E0003,($C00004).l		; VRAM write $C19E
		moveq	#9,d1

loc_884A:
		move.w	(a1)+,(a6)
		dbf	d1,loc_884A
		lea	$140(a3),a3
		move.l	#$42000003,d0		; VRAM write $C200
		moveq	#$27,d1
		moveq	#$17,d2
		move.l	#$800000,d4

loc_8864:
		move.l	d0,4(a6)
		move.w	d1,d3

loc_886A:
		move.w	(a3)+,(a6)
		dbf	d3,loc_886A
		add.l	d4,d0
		dbf	d2,loc_8864

loc_8876:
		tst.b	($FFFFE43C).w
		beq.s	loc_8890
		move.b	#0,($FFFFE43C).w
		move.l	#$40860003,d0		; VRAM write $C086
		move.w	($FFFFE438).w,d1
		bsr.w	Draw_SSNum

loc_8890:
		tst.b	($FFFFE43D).w
		bpl.s	locret_88B4

loc_8896:
		bclr	#7,($FFFFE43D).w
		move.l	#$40BE0003,d0		; VRAM write $C0BE
		move.w	($FFFFE43A).w,d1
		tst.b	($FFFFFFD4).w
		beq.s	loc_88B0
		move.w	($FFFFE442).w,d1

loc_88B0:
		bsr.w	Draw_SSNum

locret_88B4:
		rts
; End of function Update_SSMap

; ---------------------------------------------------------------------------
SS_Pal_Map_Ptrs:dc.l $FFFF5500
		dc.l Pal_SStage_3_1
		dc.l $FFFF5DC0
		dc.l Pal_SStage_3_1
		dc.l $FFFF5500
		dc.l Pal_SStage_3_2
		dc.l $FFFF5DC0
		dc.l Pal_SStage_3_2
		dc.l $FFFF5500
		dc.l Pal_SStage_3_3
		dc.l $FFFF5DC0
		dc.l Pal_SStage_3_3
		dc.l $FFFF5500
		dc.l Pal_SStage_3_4
		dc.l $FFFF5DC0
		dc.l Pal_SStage_3_4
		dc.l $FFFF5500
		dc.l Pal_SStage_3_5
		dc.l $FFFF5DC0
		dc.l Pal_SStage_3_5
		dc.l $FFFF5500
		dc.l Pal_SStage_3_6
		dc.l $FFFF5DC0
		dc.l Pal_SStage_3_6
		dc.l $FFFF5500
		dc.l Pal_SStage_3_7
		dc.l $FFFF5DC0
		dc.l Pal_SStage_3_7
		dc.l $FFFF5500
		dc.l Pal_SStage_3_8
		dc.l $FFFF5DC0
		dc.l Pal_SStage_3_8
		dc.l $FFFF9B00
		dc.l Pal_SStage_3_1
		dc.l $FFFF9240
		dc.l Pal_SStage_3_1
		dc.l $FFFF8980
		dc.l Pal_SStage_3_1
		dc.l $FFFF80C0
		dc.l Pal_SStage_3_1
		dc.l $FFFF7800
		dc.l Pal_SStage_3_1
		dc.l $FFFF6F40
		dc.l Pal_SStage_3_1
		dc.l $FFFF6680
		dc.l Pal_SStage_3_1
Pal_SStage_Main:		binclude "General\Special Stage\Palettes\Main.bin"

Pal_SStage_Knux:		binclude "General\Special Stage\Palettes\Knux Patch.bin"

Pal_SStage_3_1:		binclude "General\Special Stage\Palettes\3-1.bin"

Pal_SStage_3_2:		binclude "General\Special Stage\Palettes\3-2.bin"

Pal_SStage_3_3:		binclude "General\Special Stage\Palettes\3-3.bin"

Pal_SStage_3_4:		binclude "General\Special Stage\Palettes\3-4.bin"

Pal_SStage_3_5:		binclude "General\Special Stage\Palettes\3-5.bin"

Pal_SStage_3_6:		binclude "General\Special Stage\Palettes\3-6.bin"

Pal_SStage_3_7:		binclude "General\Special Stage\Palettes\3-7.bin"

Pal_SStage_3_8:		binclude "General\Special Stage\Palettes\3-8.bin"

Pal_SStage_K_1:		binclude "General\Special Stage\Palettes\K-1.bin"

Pal_SStage_K_2:		binclude "General\Special Stage\Palettes\K-2.bin"

Pal_SStage_K_3:		binclude "General\Special Stage\Palettes\K-3.bin"

Pal_SStage_K_4:		binclude "General\Special Stage\Palettes\K-4.bin"

Pal_SStage_K_5:		binclude "General\Special Stage\Palettes\K-5.bin"

Pal_SStage_K_6:		binclude "General\Special Stage\Palettes\K-6.bin"

Pal_SStage_K_7:		binclude "General\Special Stage\Palettes\K-7.bin"

Pal_SStage_K_8:		binclude "General\Special Stage\Palettes\K-8.bin"


; =============== S U B R O U T I N E =======================================


Draw_SSNum:
		lea	(SSNum_Precision).l,a2
		moveq	#2,d6
		lea	SSNum_Map(pc),a1

loc_8C6A:
		moveq	#0,d2
		move.w	(a2)+,d3

loc_8C6E:
		sub.w	d3,d1
		bcs.s	loc_8C76
		addq.w	#1,d2
		bra.s	loc_8C6E
; ---------------------------------------------------------------------------

loc_8C76:
		add.w	d3,d1
		move.l	d0,4(a6)
		add.w	d2,d2
		add.w	d2,d2
		lea	(a1,d2.w),a3
		move.l	(a3),(a6)
		addi.l	#$800000,d0
		move.l	d0,4(a6)
		move.l	$28(a3),(a6)
		addi.l	#$800000,d0
		move.l	d0,4(a6)
		move.l	$50(a3),(a6)
		subi.l	#$FC0000,d0
		dbf	d6,loc_8C6A
		rts
; End of function Draw_SSNum

; ---------------------------------------------------------------------------
SSNum_Precision:	dc.w $64
		dc.w $A
		dc.w 1		;0			1			2			3			4		 5			6			7		  8			9
SSNum_Map:	dc.l  $C781CF81, $C782C783, $C781CF81, $C781CF81, $C784C785, $C786C787, $C781CF81, $CF87C788, $C781CF81, $C781CF81
			dc.l  $C78ACF8A, $C78BC78C, $C78DC78E, $C78FC790, $C791C792, $C793C794, $C795C796, $C797C798, $C799CF99, $DF96DF95
			dc.l  $D781DF81, $C79BD783, $DF88D787, $D781DF81, $C79CC79D, $D781DF81, $D781DF81, $C79EC79F, $D781DF81, $D781DF81
SSNum000_Map:dc.w  $CF89, $C781, $CF81, $C781, $CF81, $C781, $CF81, $C789
				dc.w  $CF9A, $C78A, $CF8A, $C78A, $CF8A, $C78A, $CF8A, $C79A
				dc.w  $DF89, $D781, $DF81, $D781, $DF81, $D781, $DF81, $D789

; =============== S U B R O U T I N E =======================================


Create_New_Sprite2:
		movea.l	a0,a1
		move.w	#$CF82,d0
		sub.w	a0,d0
		lsr.w	#6,d0
		move.b	Find_First_Sprite_Table(pc,d0.w),d0
		bmi.s	locret_8D76

loc_8D6C:
		lea	$4A(a1),a1
		tst.l	(a1)
		dbeq	d0,loc_8D6C

locret_8D76:
		rts
; End of function Create_New_Sprite2

; ---------------------------------------------------------------------------
Find_First_Sprite_Table:
		dc.b  $FF,   0,   1,   2,   3,   4,   5,   5,   6,   7,   8,   9,  $A,  $B,  $B,  $C,  $D,  $E,  $F, $10
		dc.b  $11, $12, $12, $13, $14, $15, $16, $17, $18, $18, $19, $1A, $1B, $1C, $1D, $1E, $1E, $1F, $20, $21
		dc.b  $22, $23, $24, $25, $25, $26, $27, $28, $29, $2A, $2B, $2B, $2C, $2D, $2E, $2F, $30, $31, $32, $32
		dc.b  $33, $34, $35, $36, $37, $38, $38, $39, $3A, $3B, $3C, $3D, $3E, $3E, $3F, $40, $41, $42, $43, $44
		dc.b  $45, $45, $46, $47, $48, $49, $4A, $4B, $4B, $4C, $4D, $4E, $4F, $50, $51, $52, $52, $53, $54, $55
		dc.b  $56, $57, $58, $58, $59, $5A, $5B, $5C, $5D, $5E, $5E, $5F, $60, $61, $62, $63, $64, $65, $65, $66
		dc.b  $67, $68, $69, $6A, $6B, $6B, $6C, $6D
; ---------------------------------------------------------------------------

Obj_SStage_8DF8:
		move.b	#$80,7(a0)
		move.b	#$80,6(a0)
		move.w	#0,8(a0)
		move.l	#Map_SSIcons,$C(a0)
		move.w	#$C589,$A(a0)
		move.w	#$120,$10(a0)
		move.w	#$94,$14(a0)
		move.l	#loc_8E2A,(a0)

loc_8E2A:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Map_SSIcons:	include "General\Special Stage\Map - Icons.asm"

; ---------------------------------------------------------------------------

Obj_SStage_8E40:
		jsr	(Create_New_Sprite2).l
		bne.w	loc_8E5C
		move.l	#loc_8E5C,(a1)
		bset	#0,$2A(a1)
		move.b	#1,$22(a1)

loc_8E5C:

		move.b	#$80,7(a0)
		move.b	#$80,6(a0)
		move.w	#0,8(a0)
		move.l	#Map_GetBlueSpheres,$C(a0)
		move.w	#$A55F,$A(a0)
		move.w	#$120,$10(a0)
		move.w	#$E8,$14(a0)
		move.w	#$B4,$32(a0)
		move.l	#loc_8E94,(a0)

loc_8E94:
		tst.w	$32(a0)
		beq.s	loc_8EA4
		subq.w	#1,$32(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8EA4:
		cmpi.w	#$C0,$30(a0)
		bcs.s	loc_8ECA
		move.l	#loc_8EEC,(a0)
		addq.b	#2,$22(a0)
		tst.w	($FFFFE428).w
		bne.s	loc_8ED0
		move.b	#1,($FFFFE431).w
		move.b	#1,($FFFFE450).w
		bra.s	loc_8ED0
; ---------------------------------------------------------------------------

loc_8ECA:
		addi.w	#$10,$30(a0)

loc_8ED0:

		move.w	$30(a0),d0
		btst	#0,$2A(a0)
		bne.s	loc_8EDE
		neg.w	d0

loc_8EDE:
		addi.w	#$120,d0
		move.w	d0,$10(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8EEC:
		tst.w	($FFFFE442).w
		beq.s	loc_8EF4
		rts
; ---------------------------------------------------------------------------

loc_8EF4:
		subi.w	#$10,$30(a0)
		bne.s	loc_8F08
		move.l	#loc_8F24,(a0)
		move.w	#$B4,$32(a0)

loc_8F08:
		move.w	$30(a0),d0
		btst	#0,$2A(a0)
		bne.s	loc_8F16
		neg.w	d0

loc_8F16:
		addi.w	#$120,d0
		move.w	d0,$10(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8F24:
		tst.w	$32(a0)
		beq.s	loc_8F34
		subq.w	#1,$32(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8F34:
		cmpi.w	#$C0,$30(a0)
		bcc.s	loc_8F42
		addi.w	#$10,$30(a0)

loc_8F42:
		move.w	$30(a0),d0
		btst	#0,$2A(a0)
		bne.s	loc_8F50
		neg.w	d0

loc_8F50:
		addi.w	#$120,d0
		move.w	d0,$10(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Map_GetBlueSpheres:	include "General\Special Stage\Map - Get Blue Spheres.asm"

; ---------------------------------------------------------------------------

Obj_SStage_8FAA:
		move.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$200,8(a0)
		move.l	#Map_SStageSonic,$C(a0)
		move.w	#$87D4,$A(a0)
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_8FFA
		move.l	#Map_SStageTails,$C(a0)
		move.w	#$A7EB,$A(a0)
		jsr	(Create_New_Sprite2).l
		bne.w	loc_8FFA
		move.l	#Obj_SStage_9444,(a1)
		move.w	a0,$3E(a1)

loc_8FFA:

		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_9010
		move.l	#Map_SStageKnuckles,$C(a0)
		move.w	#$87D4,$A(a0)

loc_9010:
		move.w	#$A0,$30(a0)
		move.w	#$70,$32(a0)
		move.w	#0,$34(a0)
		move.w	#$F800,$36(a0)
		move.w	#0,$38(a0)
		bsr.w	sub_950C
		move.b	#$FF,$3A(a0)
		move.l	#loc_903E,(a0)

loc_903E:
		tst.w	($FFFFE43E).w
		beq.s	loc_907E
		subq.w	#1,($FFFFE43E).w
		bne.s	loc_907E
		move.w	#$708,($FFFFE43E).w
		tst.b	($FFFFFFD4).w
		beq.s	loc_905C
		move.w	#$A8C,($FFFFE43E).w

loc_905C:
		cmpi.w	#$2000,($FFFFE444).w
		beq.s	loc_907E
		addi.w	#$400,($FFFFE444).w
		move.b	($FFFFE444).w,d0
		subi.b	#$20,d0
		neg.b	d0
		add.b	d0,d0
		addq.b	#8,d0
		jsr	(Change_Music_Tempo).l

loc_907E:

		bsr.w	sub_9580
		moveq	#$C,d0
		move.w	($FFFFE428).w,d1
		beq.s	loc_90A8
		asr.w	#5,d1
		add.w	d1,$24(a0)
		moveq	#0,d0
		move.b	$24(a0),d0
		bpl.s	loc_909E
		addi.b	#$C,d0
		bra.s	loc_90A8
; ---------------------------------------------------------------------------

loc_909E:
		cmpi.b	#$C,d0
		bcs.s	loc_90A8
		subi.b	#$C,d0

loc_90A8:

		move.b	d0,$24(a0)
		lea	(byte_91E8).l,a1
		tst.b	($FFFFE432).w
		bpl.s	loc_90CC
		lea	(byte_91F6).l,a1
		move.w	($FFFFE428).w,d1
		bne.s	loc_90CC
		move.b	($FFFFFE05).w,d0
		andi.w	#3,d0

loc_90CC:

		move.b	(a1,d0.w),$22(a0)
		tst.b	($FFFFE44C).w
		bne.s	loc_90EE
		move.w	($FFFFF604).w,d0
		andi.w	#$70,d0
		beq.s	loc_90EE
		tst.b	($FFFFE432).w
		bmi.s	loc_90EE
		move.b	#1,($FFFFE432).w

loc_90EE:

		move.b	($FFFFE426).w,d0
		andi.b	#$3F,d0
		bne.w	loc_9152
		cmpi.b	#1,($FFFFE432).w
		bne.s	loc_911E
		move.l	#-$100000,$40(a0)
		move.b	#$80,($FFFFE432).w
		move.b	#0,($FFFFE42A).w
		moveq	#$62,d0
		jsr	(Play_Sound_2).l

loc_911E:
		tst.b	($FFFFE432).w
		bpl.s	loc_9152
		move.l	$3C(a0),d0
		add.l	$40(a0),d0
		bmi.s	loc_9138
		moveq	#0,d0
		move.l	d0,$40(a0)
		move.b	d0,($FFFFE432).w

loc_9138:
		move.w	($FFFFE444).w,d1
		ext.l	d1
		lsl.l	#4,d1
		add.l	d1,$40(a0)
		move.l	d0,$3C(a0)
		swap	d0
		addi.w	#-$800,d0
		move.w	d0,$36(a0)

loc_9152:

		bsr.w	sub_950C
		bsr.w	sub_953E
		jsr	(Draw_Sprite).l
		lea	(PLC_SStageSonic).l,a2
		move.l	#ArtUnc_SStageSonic,d6
		move.w	#$FA80,d4
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_918A
		lea	(PLC_SStageTails).l,a2
		move.l	#ArtUnc_SStageTails,d6
		move.w	#$FD60,d4
		bra.s	SStage_PLCLoad_91A2
; ---------------------------------------------------------------------------

loc_918A:
		cmpi.w	#3,($FFFFFF08).w
		bne.s	SStage_PLCLoad_91A2
		lea	(PLC_SStageKnuckles).l,a2
		move.l	#ArtUnc_SStageKnuckles,d6
		move.w	#-$580,d4

SStage_PLCLoad_91A2:

		moveq	#0,d0
		move.b	$22(a0),d0
		cmp.b	$3A(a0),d0
		beq.s	locret_91E6
		move.b	d0,$3A(a0)
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d5
		subq.w	#1,d5
		bmi.s	locret_91E6

loc_91BE:
		moveq	#0,d1
		move.w	(a2)+,d1
		move.w	d1,d3
		lsr.w	#8,d3
		andi.w	#$F0,d3
		addi.w	#$10,d3
		andi.w	#$FFF,d1
		lsl.l	#5,d1
		add.l	d6,d1
		move.w	d4,d2
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		dbf	d5,loc_91BE

locret_91E6:

		rts
; ---------------------------------------------------------------------------
byte_91E8:	dc.b	2,   6,	  7,   8,   7,	 6,   2,   3,	4,   5,	  4,   3,   1,	 0


byte_91F6:	dc.b	9,  $B,	 $A,  $B,   9,	$B,  $A,  $B,	9,  $B,	 $A,  $B,  $B,	 0

byte_9204:	dc.b	9,  $A,	 $B,   9,  $A,	$B,   9,  $A,  $B,   9,	 $A,  $B,  $B,	 0

; ---------------------------------------------------------------------------

Obj_SStage_9212:
		move.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$180,8(a0)
		move.l	#Map_SStageTails,$C(a0)
		move.w	#$A7EB,$A(a0)
		move.w	#$A0,$30(a0)
		move.w	#$70,$32(a0)
		move.w	#0,$34(a0)
		move.w	#-$800,$36(a0)
		move.w	#-$20,$38(a0)
		move.b	#$FF,$3A(a0)
		bsr.w	sub_93E2
		jsr	(Create_New_Sprite2).l
		bne.w	loc_9274
		move.l	#Obj_SStage_9444,(a1)
		move.w	a0,$3E(a1)

loc_9274:
		move.l	#loc_927A,(a0)

loc_927A:
		moveq	#$C,d0
		move.w	($FFFFE428).w,d1
		beq.s	loc_92A0
		asr.w	#5,d1
		add.w	d1,$24(a0)
		moveq	#0,d0
		move.b	$24(a0),d0
		bpl.s	loc_9296
		addi.b	#$C,d0
		bra.s	loc_92A0
; ---------------------------------------------------------------------------

loc_9296:
		cmpi.b	#$C,d0
		bcs.s	loc_92A0
		subi.b	#$C,d0

loc_92A0:

		move.b	d0,$24(a0)
		lea	(byte_91E8).l,a1
		tst.b	($FFFFE440).w
		beq.s	loc_92C4
		lea	(byte_9204).l,a1
		move.w	($FFFFE428).w,d1
		bne.s	loc_92C4
		move.b	($FFFFFE05).w,d0
		andi.w	#3,d0

loc_92C4:

		move.b	(a1,d0.w),$22(a0)
		bsr.w	sub_9402
		cmpi.b	#5,$44(a0)
		bne.s	loc_9304
		tst.b	($FFFFE44C).w
		bne.s	loc_9304
		tst.b	($FFFFE440).w
		bmi.s	loc_9304
		move.b	($FFFFE426).w,d0
		andi.b	#$3F,d0
		bne.w	loc_9304
		move.l	#$FFE80000,$40(a0)
		move.b	#$81,($FFFFE440).w
		moveq	#-$4F,d0
		jsr	(Play_Sound_2).l

loc_9304:

		bsr.w	sub_937C
		andi.w	#$70,d0
		beq.s	loc_932A
		tst.b	($FFFFE440).w
		bne.s	loc_932A
		move.l	#$FFF00000,$40(a0)
		move.b	#$80,($FFFFE440).w
		moveq	#$62,d0
		jsr	(Play_Sound_2).l

loc_932A:

		tst.b	($FFFFE440).w
		bpl.s	loc_935E
		move.l	$3C(a0),d0
		add.l	$40(a0),d0
		bmi.s	loc_9344
		moveq	#0,d0
		move.l	d0,$40(a0)
		move.b	d0,($FFFFE440).w

loc_9344:
		move.w	($FFFFE444).w,d1
		ext.l	d1
		lsl.l	#4,d1
		add.l	d1,$40(a0)
		move.l	d0,$3C(a0)
		swap	d0
		addi.w	#-$800,d0
		move.w	d0,$36(a0)

loc_935E:
		bsr.w	sub_953E
		jsr	(Draw_Sprite).l
		lea	(PLC_SStageTails).l,a2
		move.l	#ArtUnc_SStageTails,d6
		move.w	#$FD60,d4
		bra.w	SStage_PLCLoad_91A2

; =============== S U B R O U T I N E =======================================


sub_937C:
		move.w	($FFFFEE26).w,d0
		lea	($FFFFE500).w,a1
		lea	(a1,d0.w),a1
		move.w	($FFFFF604).w,(a1)
		move.b	($FFFFE432).w,2(a1)
		addq.b	#4,($FFFFEE27).w
		move.b	($FFFFF606).w,d0
		andi.b	#$7F,d0
		beq.s	loc_93A6
		move.w	#$258,($FFFFF702).w

loc_93A6:
		tst.w	($FFFFF702).w
		beq.s	loc_93B6
		subq.w	#1,($FFFFF702).w
		move.w	($FFFFF606).w,d0
		rts
; ---------------------------------------------------------------------------

loc_93B6:
		lea	($FFFFE500).w,a1
		move.w	#4,d1
		lsl.b	#2,d1
		move.w	($FFFFEE26).w,d0
		sub.b	d1,d0
		move.b	2(a1,d0.w),d2
		subq.b	#4,d0
		move.b	2(a1,d0.w),d1
		moveq	#0,d0
		cmpi.b	#-$7F,d2
		beq.s	locret_93E0
		tst.b	d1
		bpl.s	locret_93E0
		move.w	#$70,d0

locret_93E0:
		rts
; End of function sub_937C


; =============== S U B R O U T I N E =======================================


sub_93E2:
		lea	($FFFFE500).w,a2
		move.w	#$3F,d0

loc_93EA:
		move.l	#0,(a2)+
		dbf	d0,loc_93EA
		move.w	#0,($FFFFEE26).w
		move.w	#0,($FFFFF702).w
		rts
; End of function sub_93E2


; =============== S U B R O U T I N E =======================================


sub_9402:
		lea	($FFFFF100).w,a1
		move.w	($FFFFE422).w,d0
		addi.w	#$80,d0
		lsr.w	#8,d0
		andi.w	#$1F,d0
		move.w	($FFFFE424).w,d1
		addi.w	#$80,d1
		lsr.w	#8,d1
		andi.w	#$1F,d1
		lsl.w	#5,d1
		or.b	d0,d1
		lea	(a1,d1.w),a1
		lea	$44(a0),a2
		move.b	1(a2),(a2)
		move.b	2(a2),1(a2)
		move.b	3(a2),2(a2)
		move.b	(a1),3(a2)
		rts
; End of function sub_9402

; ---------------------------------------------------------------------------

Obj_SStage_9444:

		move.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$100,8(a0)
		move.l	#Map_SStageTailstails,$C(a0)
		move.w	#$A7B0,$A(a0)
		move.w	#$A0,$30(a0)
		move.w	#$70,$32(a0)
		move.b	#-1,$3A(a0)
		move.b	#1,$22(a0)
		move.l	#loc_9488,(a0)

loc_9488:
		movea.w	$3E(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		move.w	#$2AAA,d0
		move.w	($FFFFE428).w,d1
		bmi.s	loc_94A4
		add.w	d1,d0

loc_94A4:
		add.w	d0,$24(a0)
		bcc.s	loc_94BC
		move.b	$22(a0),d0
		addq.b	#1,d0
		cmpi.b	#$F,d0
		bcs.s	loc_94B8
		moveq	#1,d0

loc_94B8:
		move.b	d0,$22(a0)

loc_94BC:
		jsr	(Draw_Sprite).l
		lea	(PLC_SStageTailstails).l,a2
		move.l	#ArtUnc_SStageTailstails,d6
		move.w	#$F600,d4
		bra.w	SStage_PLCLoad_91A2

; =============== S U B R O U T I N E =======================================


sub_94D6:
		lea	(word_94FC).l,a3
		move.w	(a3)+,(a6)+
		move.b	(a3)+,(a6)+
		addq.w	#1,a3
		addq.w	#1,a6
		move.w	(a3)+,(a6)+
		move.w	(a3)+,(a6)+
		tst.w	($FFFFFF08).w
		bne.s	locret_94FA
		move.w	(a3)+,(a6)+
		move.b	(a3)+,(a6)+
		addq.w	#1,a3
		addq.w	#1,a6
		move.w	(a3)+,(a6)+
		move.w	(a3)+,(a6)+

locret_94FA:
		rts
; End of function sub_94D6

; ---------------------------------------------------------------------------
word_94FC:	dc.w $116
		dc.w $F0A
		dc.w $E7A0
		dc.w $110
		dc.w $127
		dc.w $F0B
		dc.w $E7A0
		dc.w $110

; =============== S U B R O U T I N E =======================================


sub_950C:

		move.w	($FFFFE404).w,d0
		lea	($FFFFE40E).w,a1
		bsr.w	GetScalars2
		move.w	($FFFFE402).w,d0
		lea	($FFFFE40A).w,a1
		bsr.w	GetScalars2
		move.w	($FFFFE400).w,d0
		lea	($FFFFE406).w,a1
		bsr.w	GetScalars2
		move.w	#$E0,d0
		lea	($FFFFE41C).w,a1
		bsr.w	GetScalars2
		rts
; End of function sub_950C


; =============== S U B R O U T I N E =======================================


sub_953E:

		move.w	$34(a0),d1
		move.w	$36(a0),d2
		move.w	$38(a0),d0
		bsr.w	sub_A1DC
		bsr.w	sub_A1B2
		bsr.w	sub_A188
		addi.w	#$100,d0
		addi.w	#$980,d2
		bsr.w	sub_A206
		ext.l	d1
		lsl.l	#8,d1
		divs.w	d0,d1
		ext.l	d2
		lsl.l	#8,d2
		divs.w	d0,d2
		add.w	$30(a0),d1
		move.w	d1,$10(a0)
		add.w	$32(a0),d2
		move.w	d2,$14(a0)
		rts
; End of function sub_953E


; =============== S U B R O U T I N E =======================================


sub_9580:
		tst.b	($FFFFE433).w
		beq.s	loc_95AE
		cmpi.b	#$61,($FFFFE433).w
		bcc.s	loc_959A
		moveq	#8,d1
		add.b	d1,($FFFFE426).w
		addq.b	#1,($FFFFE433).w
		rts
; ---------------------------------------------------------------------------

loc_959A:
		move.w	($FFFFE422).w,d0
		or.w	($FFFFE424).w,d0
		andi.w	#$E0,d0
		beq.s	loc_95AE
		move.b	#0,($FFFFE433).w

loc_95AE:
		move.w	($FFFFE422).w,d3
		btst	#6,($FFFFE426).w
		bne.s	loc_95BE
		move.w	($FFFFE424).w,d3

loc_95BE:
		moveq	#0,d2
		move.b	($FFFFE42A).w,d1
		beq.s	loc_95F4
		andi.w	#$E0,d3
		bne.s	loc_95F4
		tst.b	($FFFFE432).w
		bmi.s	loc_9600
		add.b	d1,($FFFFE426).w
		move.b	($FFFFE426).w,d0
		andi.b	#$3F,d0
		bne.w	locret_972C
		move.b	#0,($FFFFE42A).w
		tst.w	($FFFFE428).w
		beq.s	loc_95F4
		move.b	#1,($FFFFE430).w

loc_95F4:
		andi.w	#$E0,d3
		beq.s	loc_9600
		move.b	#0,($FFFFE430).w

loc_9600:
		move.b	($FFFFF604).w,d1
		move.w	($FFFFE428).w,d2
		tst.b	($FFFFE44C).w
		bne.w	loc_96FA
		tst.b	($FFFFE42B).w
		bne.s	loc_9658
		btst	#0,d1
		beq.s	loc_9628
		move.b	#1,($FFFFE431).w
		move.b	#1,($FFFFE450).w

loc_9628:
		tst.b	($FFFFE431).w
		bne.s	loc_964A
		tst.b	($FFFFE450).w
		beq.s	loc_9658
		tst.w	d2
		bpl.s	loc_964A
		move.w	($FFFFE444).w,d3
		neg.w	d3
		subi.w	#$200,d2
		cmp.w	d3,d2
		bgt.s	loc_9658
		move.w	d3,d2
		bra.s	loc_9658
; ---------------------------------------------------------------------------

loc_964A:
		move.w	($FFFFE444).w,d3
		addi.w	#$200,d2
		cmp.w	d3,d2
		blt.s	loc_9658
		move.w	d3,d2

loc_9658:
		tst.b	($FFFFE430).w
		bne.s	loc_9676
		btst	#2,d1
		beq.s	loc_966A
		move.b	#4,($FFFFE42A).w

loc_966A:
		btst	#3,d1
		beq.s	loc_9676
		move.b	#-4,($FFFFE42A).w

loc_9676:
		move.w	d2,($FFFFE428).w
		tst.b	($FFFFE42B).w
		beq.s	loc_96FA
		move.w	($FFFFE422).w,d0
		btst	#6,($FFFFE426).w
		bne.s	loc_9690
		move.w	($FFFFE424).w,d0

loc_9690:
		andi.w	#$E0,d0
		bne.s	loc_96D4
		move.w	($FFFFE422).w,d0
		addi.w	#$80,d0
		lsr.w	#8,d0
		andi.w	#$1F,d0
		move.w	($FFFFE424).w,d1
		addi.w	#$80,d1
		lsr.w	#8,d1
		andi.w	#$1F,d1
		lsl.w	#5,d1
		or.b	d0,d1
		cmp.w	($FFFFE44E).w,d1
		beq.s	loc_96D4
		move.b	#0,($FFFFE42B).w
		move.w	($FFFFE444).w,d2
		tst.w	($FFFFE428).w
		bmi.s	loc_96CE
		neg.w	d2

loc_96CE:
		move.w	d2,($FFFFE428).w
		rts
; ---------------------------------------------------------------------------

loc_96D4:

		move.w	($FFFFE428).w,d2
		bne.s	loc_96F8
		move.b	#0,($FFFFE42B).w
		move.b	#1,($FFFFE431).w
		move.w	($FFFFE444).w,d2
		tst.w	($FFFFE428).w
		bmi.s	loc_96F2
		neg.w	d2

loc_96F2:
		move.w	d2,($FFFFE428).w
		bra.s	loc_96FA
; ---------------------------------------------------------------------------

loc_96F8:
		neg.w	d2

loc_96FA:
		cmpi.b	#$81,($FFFFE432).w
		bne.s	loc_9704
		add.w	d2,d2

loc_9704:
		move.b	($FFFFE426).w,d0
		jsr	(GetSineCosine).l
		muls.w	d2,d0
		muls.w	d2,d1
		swap	d0
		sub.w	d0,($FFFFE422).w
		swap	d1
		sub.w	d1,($FFFFE424).w
		tst.b	($FFFFE432).w
		bmi.s	locret_972C
		tst.b	($FFFFE44C).w
		bne.s	locret_972C
		bsr.s	sub_972E

locret_972C:

		rts
; End of function sub_9580


; =============== S U B R O U T I N E =======================================


sub_972E:
		lea	($FFFFF100).w,a1
		move.w	($FFFFE422).w,d0
		addi.w	#$80,d0
		lsr.w	#8,d0
		andi.w	#$1F,d0
		move.w	($FFFFE424).w,d1
		addi.w	#$80,d1
		lsr.w	#8,d1
		andi.w	#$1F,d1
		lsl.w	#5,d1
		or.b	d0,d1
		lea	(a1,d1.w),a1
		move.b	(a1),d2
		beq.w	locret_98AE
		cmpi.b	#1,d2
		bne.s	loc_97AA
		move.w	($FFFFE422).w,d0
		or.w	($FFFFE424).w,d0
		andi.w	#$E0,d0
		bne.s	locret_97A8
		tst.b	($FFFFE433).w
		bne.s	locret_97A8
		move.b	#1,($FFFFE433).w
		move.b	#$48,($FFFFF600).w
		tst.b	($FFFFFFD4).w
		beq.s	loc_978E
		move.b	#$2C,($FFFFF600).w

loc_978E:
		tst.b	($FFFFFE48).w
		beq.s	loc_97A0
		move.w	($FFFFFE4A).w,($FFFFFE10).w
		ori.b	#$80,($FFFFFE2A).w

loc_97A0:
		moveq	#$6A,d0
		jsr	(Play_Sound_2).l

locret_97A8:
		rts
; ---------------------------------------------------------------------------

loc_97AA:
		cmpi.b	#2,d2
		bne.s	loc_97C8
		bsr.w	sub_9DCA
		bne.s	loc_97BE
		move.b	#2,(a2)
		move.l	a1,4(a2)

loc_97BE:
		moveq	#$65,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_97C8:
		cmpi.b	#3,d2
		bne.s	loc_97EE
		tst.b	($FFFFE42B).w
		bne.s	loc_97EE
		move.w	d1,($FFFFE44E).w
		move.b	#1,($FFFFE42B).w
		move.b	#0,($FFFFE431).w
		moveq	#-$56,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_97EE:
		cmpi.b	#5,d2
		bne.s	loc_9822
		tst.b	($FFFFE44C).w
		bne.s	loc_9822
		tst.b	($FFFFE432).w
		bmi.s	loc_9822
		move.b	($FFFFE426).w,d0
		andi.b	#$3F,d0
		bne.w	loc_9822
		move.l	#$FFE80000,$40(a0)
		move.b	#$81,($FFFFE432).w
		moveq	#-$4F,d0
		jsr	(Play_Sound_2).l

loc_9822:
		cmpi.b	#4,d2
		bne.w	locret_98AE
		bsr.w	sub_9DCA
		bne.s	loc_9838
		move.b	#1,(a2)
		move.l	a1,4(a2)

loc_9838:
		tst.w	($FFFFE442).w
		beq.s	loc_984C
		subq.w	#1,($FFFFE442).w
		bne.s	loc_984C
		moveq	#$68,d0
		jsr	(Play_Sound).l

loc_984C:

		addi.w	#1,($FFFFE43A).w
		bset	#7,($FFFFE43D).w
		moveq	#$33,d0
		tst.b	($FFFFFFD4).w
		bne.s	loc_98A6
		cmpi.w	#$32,($FFFFE43A).w
		bcs.s	loc_987E
		bset	#0,($FFFFE43D).w
		bne.s	loc_987E
		addq.b	#1,($FFFFFE18).w
		move.w	#-$54,d0
		jmp	(Play_Sound).l
; ---------------------------------------------------------------------------

loc_987E:

		moveq	#$33,d0
		cmpi.w	#$64,($FFFFE43A).w
		bcs.s	loc_98A6
		bset	#1,($FFFFE43D).w
		beq.s	loc_98A0
		cmpi.w	#$C8,($FFFFE43A).w
		bcs.s	loc_98A6
		bset	#2,($FFFFE43D).w
		bne.s	loc_98A6

loc_98A0:
		addq.b	#1,($FFFFFE12).w
		moveq	#-$47,d0

loc_98A6:

		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

locret_98AE:
		rts
; End of function sub_972E

; ---------------------------------------------------------------------------
word_98B0:	dc.w $18
		dc.w 6
		dc.w 1
		dc.w $1F
		dc.w $FFFF
		dc.w $1F
		dc.w 0
		dc.w 0
		dc.w 8
		dc.w 6
		dc.w $FFFF
		dc.w $1F
		dc.w $FFFF
		dc.w $1F
		dc.w 0
		dc.w 0
		dc.w 8
		dc.w $1A
		dc.w $FFFF
		dc.w $1F
		dc.w 1
		dc.w $1F
		dc.w 0
		dc.w 0
		dc.w $18
		dc.w $1A
		dc.w 1
		dc.w $1F
		dc.w 1
		dc.w $1F
		dc.w 0
		dc.w 0

; =============== S U B R O U T I N E =======================================


Draw_SSSprites:

		move.b	($FFFFE426).w,d0
		andi.w	#$C0,d0
		lsr.w	#2,d0
		lea	word_98B0(pc,d0.w),a5
		moveq	#0,d1
		move.b	($FFFFE422).w,d1
		move.w	($FFFFE422).w,d0
		addi.w	#$100,d0
		move.w	($FFFFE424).w,d2
		andi.w	#$100,d2
		add.w	d2,d0
		btst	#6,($FFFFE426).w
		bne.s	loc_9930
		move.b	($FFFFE424).w,d1
		move.w	($FFFFE424).w,d0
		move.w	($FFFFE422).w,d2
		andi.w	#$100,d2
		add.w	d2,d0

loc_9930:
		tst.b	($FFFFE426).w
		bmi.s	loc_9946
		neg.w	d0
		addi.w	#$1F,d0
		move.w	d0,d2
		andi.w	#$E0,d2
		beq.s	loc_9946
		addq.b	#1,d1

loc_9946:
		andi.w	#$1E0,d0
		lsr.w	#5,d0
		move.w	d0,($FFFFE420).w
		move.b	d0,($FFFFE42F).w
		move.b	($FFFFE426).w,d0
		andi.w	#$38,d0
		beq.s	loc_9968
		lsr.w	#3,d0
		addi.w	#$F,d0
		move.w	d0,($FFFFE420).w

loc_9968:
		lea	(Draw_SSSprite_Normal).l,a0
		tst.w	($FFFFE44A).w
		beq.s	loc_997A
		lea	(Draw_SSSprite_FlyAway).l,a0

loc_997A:
		btst	#6,($FFFFE426).w
		bne.w	loc_9A3C
		move.w	2(a5),d5
		add.w	d1,d5
		and.w	$A(a5),d5
		move.w	($FFFFE420).w,d0
		add.w	d0,d0
		add.w	d0,d0
		lea	($FFFF0000).l,a1
		movea.l	(a1,d0.w),a1
		lea	($FFFFF100).w,a2
		lea	($FFFFE480).w,a4
		lea	($FFFFF800).w,a6
		moveq	#$4F,d7
		moveq	#0,d6
		move.b	($FFFFF62C).w,d6
		sub.b	d6,d7
		lsl.w	#3,d6
		adda.w	d6,a6
		moveq	#$F,d2

loc_99BC:
		move.w	(a5),d4
		moveq	#0,d0
		move.b	($FFFFE422).w,d0
		add.w	d0,d4
		and.w	6(a5),d4
		moveq	#$E,d3

loc_99CC:
		move.w	d5,d0
		lsl.w	#5,d0
		or.b	d4,d0
		move.b	(a2,d0.w),d0
		beq.s	loc_9A20
		move.w	(a1),d1
		andi.w	#$7C,d1
		beq.s	loc_9A20
		lsr.w	#2,d1
		subq.w	#6,d1
		cmpi.w	#$10,d1
		bcc.s	loc_9A20
		add.w	d1,d1
		andi.w	#$FF,d0
		lsl.w	#3,d0
		movea.l	(a4,d0.w),a3
		move.w	4(a4,d0.w),d6
		cmpi.w	#$54,(a1)
		bcs.s	loc_9A04
		andi.w	#$7FFF,d6

loc_9A04:
		move.w	6(a4,d0.w),d0
		add.w	d0,d0
		bcc.s	loc_9A0E
		moveq	#0,d1

loc_9A0E:
		add.w	d0,d1
		adda.w	(a3,d1.w),a3
		move.w	(a3)+,d1
		subq.w	#1,d1
		bmi.s	loc_9A20
		jsr	(a0)
		tst.w	d7
		bmi.s	locret_9A3A

loc_9A20:
		addq.w	#6,a1
		add.w	4(a5),d4
		and.w	6(a5),d4
		dbf	d3,loc_99CC
		add.w	8(a5),d5
		and.w	$A(a5),d5
		dbf	d2,loc_99BC

locret_9A3A:
		rts
; ---------------------------------------------------------------------------

loc_9A3C:
		move.w	2(a5),d5
		add.w	d1,d5
		and.w	$A(a5),d5
		move.w	($FFFFE420).w,d0
		add.w	d0,d0
		add.w	d0,d0
		lea	($FFFF0000).l,a1
		movea.l	(a1,d0.w),a1
		lea	($FFFFF100).w,a2
		lea	($FFFFE480).w,a4
		lea	($FFFFF800).w,a6
		moveq	#$4F,d7
		moveq	#0,d6
		move.b	($FFFFF62C).w,d6
		sub.b	d6,d7
		lsl.w	#3,d6
		adda.w	d6,a6
		moveq	#$F,d2

loc_9A74:
		move.w	(a5),d4
		moveq	#0,d0
		move.b	($FFFFE424).w,d0
		add.w	d0,d4
		and.w	6(a5),d4
		moveq	#$E,d3

loc_9A84:
		move.w	d4,d0
		lsl.w	#5,d0
		or.b	d5,d0
		move.b	(a2,d0.w),d0
		beq.s	loc_9AD8
		move.w	(a1),d1
		andi.w	#$7C,d1
		beq.s	loc_9AD8
		lsr.w	#2,d1
		subq.w	#6,d1
		cmpi.w	#$10,d1
		bcc.s	loc_9AD8
		add.w	d1,d1
		andi.w	#$FF,d0
		lsl.w	#3,d0
		movea.l	(a4,d0.w),a3
		move.w	4(a4,d0.w),d6
		cmpi.w	#$54,(a1)
		bcs.s	loc_9ABC
		andi.w	#$7FFF,d6

loc_9ABC:
		move.w	6(a4,d0.w),d0
		add.w	d0,d0
		bcc.s	loc_9AC6
		moveq	#0,d1

loc_9AC6:
		add.w	d0,d1
		adda.w	(a3,d1.w),a3
		move.w	(a3)+,d1
		subq.w	#1,d1
		bmi.s	loc_9AD8
		jsr	(a0)
		tst.w	d7
		bmi.s	locret_9AF2

loc_9AD8:

		addq.w	#6,a1
		add.w	4(a5),d4
		and.w	6(a5),d4
		dbf	d3,loc_9A84
		add.w	8(a5),d5
		and.w	$A(a5),d5
		dbf	d2,loc_9A74

locret_9AF2:
		rts
; End of function Draw_SSSprites

; ---------------------------------------------------------------------------

Draw_SSSprite_Normal:

		move.b	(a3)+,d0
		ext.w	d0
		add.w	4(a1),d0
		move.w	d0,(a6)+
		move.b	(a3)+,(a6)+
		addq.w	#1,a6
		move.w	(a3)+,d0
		add.w	d6,d0
		move.w	d0,(a6)+
		move.w	(a3)+,d0
		add.w	2(a1),d0
		move.w	d0,(a6)+
		subq.w	#1,d7
		dbmi	d1,Draw_SSSprite_Normal
		rts
; ---------------------------------------------------------------------------

Draw_SSSprite_FlyAway:

		move.b	(a3)+,d0
		ext.w	d0
		add.w	4(a1),d0
		sub.w	($FFFFE44A).w,d0
		move.w	d0,(a6)+
		move.b	(a3)+,(a6)+
		addq.w	#1,a6
		move.w	(a3)+,d0
		add.w	d6,d0
		move.w	d0,(a6)+
		move.w	(a3)+,d0
		add.w	2(a1),d0
		move.w	d1,-(sp)
		subi.w	#$120,d0
		move.w	($FFFFE44A).w,d1
		addi.w	#$100,d1
		muls.w	d1,d0
		asr.l	#8,d0
		addi.w	#$120,d0
		cmpi.w	#$1D0,d0
		bcs.s	loc_9B56
		move.w	#1,d0

loc_9B56:
		move.w	(sp)+,d1
		move.w	d0,(a6)+
		subq.w	#1,d7
		dbmi	d1,Draw_SSSprite_FlyAway
		rts

; =============== S U B R O U T I N E =======================================


sub_9B62:

		move.b	($FFFFE44C).w,d1
		beq.w	locret_9D1C
		subq.b	#1,d1
		bne.w	loc_9C5C
		cmpi.w	#$100,($FFFFE44A).w
		bcc.s	loc_9BA6
		addq.w	#2,($FFFFE44A).w
		cmpi.w	#2,($FFFFE44A).w
		bne.s	loc_9B8C
		moveq	#$66,d0
		jsr	(Play_Sound).l

loc_9B8C:
		cmpi.w	#$40,($FFFFE44A).w
		bcs.s	locret_9BA4
		addq.w	#1,($FFFFE44A).w
		cmpi.w	#$80,($FFFFE44A).w
		bcs.s	locret_9BA4
		addq.w	#1,($FFFFE44A).w

locret_9BA4:
		rts
; ---------------------------------------------------------------------------

loc_9BA6:
		addq.b	#1,($FFFFE44C).w
		lea	($FFFFF100).w,a1
		move.w	#$FF,d0

loc_9BB2:
		move.l	#0,(a1)+
		dbf	d0,loc_9BB2
		move.b	($FFFFE426).w,d0
		jsr	(GetSineCosine).l
		move.w	($FFFFE422).w,d2
		move.w	($FFFFE424).w,d3
		asl.w	#3,d0
		asl.w	#3,d1
		sub.w	d0,d2
		sub.w	d1,d3
		lea	($FFFFF100).w,a1
		move.w	d2,d0
		addi.w	#$80,d0
		lsr.w	#8,d0
		andi.w	#$1F,d0
		move.w	d3,d1
		addi.w	#$80,d1
		lsr.w	#8,d1
		andi.w	#$1F,d1
		lsl.w	#5,d1
		or.b	d0,d1
		move.b	#$B,(a1,d1.w)
		tst.b	($FFFFFFBB).w
		beq.s	loc_9C08
		move.b	#$D,(a1,d1.w)

loc_9C08:
		move.w	d1,($FFFFE44E).w
		move.w	#$800,($FFFFE428).w
		move.b	#$78,($FFFFE44D).w
		moveq	#0,d0
		move.b	($FFFFFE16).w,d0
		tst.b	($FFFFFFD4).w
		beq.s	loc_9C28
		move.b	($FFFFFFA4).w,d0

loc_9C28:
		andi.w	#7,d0
		lea	(Pal_SStage_Emeralds).l,a1
		lsl.w	#3,d0
		lea	(a1,d0.w),a1
		lea	($FFFFFC64).w,a2
		move.l	(a1)+,(a2)+
		move.l	(a1)+,(a2)+
		lea	(ArtKosM_SStageChaosEmerald).l,a1
		tst.b	($FFFFFFBB).w
		beq.s	loc_9C52
		lea	(ArtKosM_SStageSuperEmerald).l,a1

loc_9C52:
		move.w	#$B4E0,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

loc_9C5C:
		subq.b	#1,d1
		bne.s	loc_9C80
		tst.b	($FFFFFF60).w
		bne.s	locret_9C7E
		move.w	#0,($FFFFE44A).w
		subq.b	#1,($FFFFE44D).w
		bne.s	locret_9C7E
		addq.b	#1,($FFFFE44C).w
		moveq	#$2B,d0
		jsr	(Play_Sound).l

locret_9C7E:

		rts
; ---------------------------------------------------------------------------

loc_9C80:
		subq.b	#1,d1
		bne.w	locret_9D1C
		move.w	($FFFFE422).w,d0
		addi.w	#$80,d0
		lsr.w	#8,d0
		andi.w	#$1F,d0
		move.w	($FFFFE424).w,d1
		addi.w	#$80,d1
		lsr.w	#8,d1
		andi.w	#$1F,d1
		lsl.w	#5,d1
		or.b	d0,d1
		cmp.w	($FFFFE44E).w,d1
		bne.s	locret_9D1C
		move.w	($FFFFE422).w,d0
		or.w	($FFFFE424).w,d0
		andi.w	#$E0,d0
		bne.s	locret_9D1C
		tst.b	($FFFFFFD4).w
		bne.s	loc_9CE6
		lea	($FFFFFFB0).w,a2
		move.b	($FFFFFFBB).w,d2
		beq.s	loc_9CCE
		lea	($FFFFFFB1).w,a2

loc_9CCE:
		cmpi.b	#7,(a2)
		bcc.s	loc_9CE6
		addq.b	#1,(a2)
		lea	($FFFFFFB2).w,a1
		moveq	#0,d0
		move.b	($FFFFFE16).w,d0
		bset	#0,(a1,d0.w)

loc_9CE6:

		addq.b	#1,($FFFFE44C).w
		move.b	#1,($FFFFE433).w
		move.b	#$48,($FFFFF600).w
		tst.b	($FFFFFFD4).w
		beq.s	loc_9D02
		move.b	#$30,($FFFFF600).w

loc_9D02:
		tst.b	($FFFFFE48).w
		beq.s	loc_9D14
		move.w	($FFFFFE4A).w,($FFFFFE10).w
		ori.b	#$80,($FFFFFE2A).w

loc_9D14:
		moveq	#$6A,d0
		jsr	(Play_Sound_2).l

locret_9D1C:
		rts
; End of function sub_9B62

; ---------------------------------------------------------------------------
Pal_SStage_Emeralds:	binclude "General\Special Stage\Palettes\Emeralds.bin"


; =============== S U B R O U T I N E =======================================


sub_9D5E:

		move.w	($FFFFE422).w,d0
		sub.w	($FFFFE434).w,d0
		btst	#6,($FFFFE426).w
		bne.s	loc_9D76
		move.w	($FFFFE424).w,d0
		sub.w	($FFFFE436).w,d0

loc_9D76:
		tst.b	($FFFFE426).w
		bmi.s	loc_9D7E
		neg.w	d0

loc_9D7E:
		asr.w	#2,d0
		add.w	d0,($FFFFF618).w
		moveq	#0,d1
		move.b	($FFFFE426).w,d1
		asl.w	#2,d1
		move.w	d1,($FFFFE002).w
		move.w	($FFFFE422).w,($FFFFE434).w
		move.w	($FFFFE424).w,($FFFFE436).w
		rts
; End of function sub_9D5E


; =============== S U B R O U T I N E =======================================


Animate_SSRings:

		lea	($FFFFE487).w,a1
		subq.b	#1,($FFFFFEB2).w
		bpl.s	loc_9DC2
		move.b	#7,($FFFFFEB2).w
		addi.b	#$10,($FFFFFEB3).w
		cmpi.b	#$30,($FFFFFEB3).w
		bcs.s	loc_9DC2
		move.b	#0,($FFFFFEB3).w

loc_9DC2:
		move.b	($FFFFFEB3).w,$20(a1)
		rts
; End of function Animate_SSRings


; =============== S U B R O U T I N E =======================================


sub_9DCA:
		lea	($FFFFA400).w,a2
		move.w	#$1F,d0

loc_9DD2:
		tst.b	(a2)
		beq.s	locret_9DDC
		addq.w	#8,a2
		dbf	d0,loc_9DD2

locret_9DDC:
		rts
; End of function sub_9DCA


; =============== S U B R O U T I N E =======================================


sub_9DDE:

		lea	($FFFFA400).w,a0
		move.w	#$1F,d7

loc_9DE6:
		moveq	#0,d0
		move.b	(a0),d0
		beq.s	loc_9DF4
		lsl.w	#2,d0
		movea.l	loc_9DF6+2(pc,d0.w),a1
		jsr	(a1)

loc_9DF4:
		addq.w	#8,a0

loc_9DF6:
		dbf	d7,loc_9DE6
		rts
; End of function sub_9DDE

; ---------------------------------------------------------------------------
		dc.l loc_9E04
		dc.l loc_9E34
; ---------------------------------------------------------------------------

loc_9E04:
		subq.b	#1,2(a0)
		bpl.s	locret_9E2C
		move.b	#5,2(a0)
		moveq	#0,d0
		move.b	3(a0),d0
		addq.b	#1,3(a0)
		movea.l	4(a0),a1
		move.b	byte_9E2E(pc,d0.w),d0
		move.b	d0,(a1)
		bne.s	locret_9E2C
		clr.l	(a0)
		clr.l	4(a0)

locret_9E2C:

		rts
; ---------------------------------------------------------------------------
byte_9E2E:	dc.b	6,   7,	  8,   9,   0,	 0
; ---------------------------------------------------------------------------

loc_9E34:
		subq.b	#1,2(a0)
		bpl.s	locret_9E86
		move.b	#9,2(a0)
		movea.l	4(a0),a1
		cmpi.b	#2,(a1)
		bne.s	loc_9E62
		bsr.w	sub_9E88
		move.b	#$A,(a1)
		bsr.s	sub_9EBC
		beq.s	locret_9E60
		move.b	#4,(a1)
		clr.l	(a0)
		clr.l	4(a0)

locret_9E60:
		rts
; ---------------------------------------------------------------------------

loc_9E62:
		move.b	#0,2(a0)
		move.w	($FFFFE422).w,d0
		or.w	($FFFFE424).w,d0
		andi.w	#$E0,d0
		beq.s	locret_9E86
		cmpi.b	#$A,(a1)
		bne.s	loc_9E80
		move.b	#1,(a1)

loc_9E80:
		clr.l	(a0)
		clr.l	4(a0)

locret_9E86:

		rts

; =============== S U B R O U T I N E =======================================


sub_9E88:

		move.w	d0,-(sp)
		move.b	#-1,($FFFFE43C).w
		subq.w	#1,($FFFFE438).w
		bne.s	loc_9E9C
		move.b	#1,($FFFFE44C).w

loc_9E9C:
		move.w	(sp)+,d0
		rts
; End of function sub_9E88


; =============== S U B R O U T I N E =======================================


sub_9EA0:
		lea	($FFFFF100).w,a3
		moveq	#0,d1
		move.w	#$3FF,d0

loc_9EAA:
		cmpi.b	#2,(a3)+
		bne.s	loc_9EB2
		addq.w	#1,d1

loc_9EB2:
		dbf	d0,loc_9EAA
		move.w	d1,($FFFFE438).w
		rts
; End of function sub_9EA0


; =============== S U B R O U T I N E =======================================


sub_9EBC:
		lea	($FFFFF100).w,a2
		move.l	a1,d5
		sub.l	a2,d5
		bsr.s	sub_9F44
		moveq	#0,d6
		move.l	a5,d1
		lea	($FFFFA500).w,a4
		sub.l	a4,d1
		beq.s	locret_9F42

loc_9ED2:
		move.w	(a4)+,d5
		lea	(word_A0CA).l,a3
		move.w	#7,d0

loc_9EDE:
		move.w	(a3)+,d2
		add.w	d5,d2
		andi.w	#$3FF,d2
		cmpi.b	#2,(a2,d2.w)
		bne.s	loc_9EFC
		bsr.w	sub_9E88
		move.b	#4,(a2,d2.w)
		move.w	d2,(a5)+
		addq.w	#2,d1

loc_9EFC:
		dbf	d0,loc_9EDE
		subq.w	#2,d1
		bne.s	loc_9ED2
		move.l	a5,d1
		lea	($FFFFA500).w,a4
		sub.l	a4,d1
		beq.s	locret_9F42

loc_9F0E:
		move.w	(a4)+,d5
		lea	(word_A0CA).l,a3
		move.w	#7,d0

loc_9F1A:
		move.w	(a3)+,d2
		add.w	d5,d2
		andi.w	#$3FF,d2
		cmpi.b	#1,(a2,d2.w)
		bne.s	loc_9F30
		move.b	#4,(a2,d2.w)

loc_9F30:
		dbf	d0,loc_9F1A
		subq.w	#2,d1
		bne.s	loc_9F0E
		moveq	#-$47,d0
		jsr	(Play_Sound_2).l
		moveq	#1,d1

locret_9F42:
		rts
; End of function sub_9EBC


; =============== S U B R O U T I N E =======================================


sub_9F44:
		lea	($FFFFA500).w,a5
		lea	(word_A0CA).l,a3
		moveq	#0,d2
		move.w	#7,d0

loc_9F54:
		move.w	(a3)+,d1
		add.w	d5,d1
		andi.w	#$3FF,d1
		cmpi.b	#$A,(a2,d1.w)
		bne.s	loc_9F6A
		move.b	#1,(a2,d1.w)

loc_9F6A:
		cmpi.b	#2,(a2,d1.w)
		bne.s	loc_9F74
		addq.w	#1,d2

loc_9F74:
		dbf	d0,loc_9F54
		tst.w	d2
		beq.w	locret_A076
		moveq	#0,d2
		move.w	d5,d1
		moveq	#$F,d3

loc_9F84:
		addq.w	#1,d2
		addi.w	#-1,d1
		tst.b	(a2,d1.w)
		beq.s	loc_9F94
		dbf	d3,loc_9F84

loc_9F94:
		move.w	d5,d1
		moveq	#$F,d3

loc_9F98:
		addq.w	#1,d2
		addi.w	#1,d1
		tst.b	(a2,d1.w)
		beq.s	loc_9FA8
		dbf	d3,loc_9F98

loc_9FA8:
		cmpi.w	#4,d2
		bcs.w	locret_A076
		moveq	#0,d2
		move.w	d5,d1
		moveq	#$F,d3

loc_9FB6:
		addq.w	#1,d2
		addi.w	#$FFE0,d1
		tst.b	(a2,d1.w)
		beq.s	loc_9FC6
		dbf	d3,loc_9FB6

loc_9FC6:
		move.w	d5,d1
		moveq	#$F,d3

loc_9FCA:
		addq.w	#1,d2
		addi.w	#$20,d1
		tst.b	(a2,d1.w)
		beq.s	loc_9FDA
		dbf	d3,loc_9FCA

loc_9FDA:
		cmpi.w	#4,d2
		bcs.w	locret_A076
		lea	($FFFFA600).w,a4
		lea	(word_A0DA).l,a3
		moveq	#0,d6
		moveq	#0,d3
		moveq	#6,d4
		add.w	d3,d4
		move.w	d5,d0

loc_9FF6:

		move.w	(a3,d4.w),d1
		add.w	d0,d1
		andi.w	#$3FF,d1
		move.b	(a2,d1.w),d2
		cmpi.b	#$8A,d2
		beq.s	loc_A078
		cmpi.b	#1,d2
		bne.s	loc_A054
		cmpi.w	#2,d6
		bcs.s	loc_A034
		move.w	d1,d2
		sub.w	-6(a4),d2
		cmpi.w	#-1,d2
		beq.s	loc_A054
		cmpi.w	#1,d2
		beq.s	loc_A054
		cmpi.w	#$20,d2
		beq.s	loc_A054
		cmpi.w	#-$20,d2
		beq.s	loc_A054

loc_A034:
		ori.b	#$80,(a2,d0.w)
		move.b	d3,(a4)+
		move.b	d4,(a4)+
		move.w	d0,(a4)+
		addq.w	#1,d6
		move.w	d4,d3
		subq.w	#2,d3
		andi.w	#6,d3
		move.w	#4,d4
		add.w	d3,d4
		move.w	d1,d0
		bra.s	loc_9FF6
; ---------------------------------------------------------------------------

loc_A054:
		subq.w	#2,d4
		cmp.w	d3,d4
		bge.s	loc_9FF6

loc_A05A:
		moveq	#0,d3
		moveq	#0,d4
		move.w	-(a4),d0
		move.b	-(a4),d4
		move.b	-(a4),d3
		subq.w	#1,d6
		bcs.s	locret_A076
		andi.b	#$7F,(a2,d0.w)
		subq.w	#2,d4
		cmp.w	d3,d4
		bge.s	loc_9FF6
		bra.s	loc_A05A
; ---------------------------------------------------------------------------

locret_A076:
		rts
; ---------------------------------------------------------------------------

loc_A078:
		movem.l	d0/d3-d4/d6/a4,-(sp)
		sub.w	d5,d0
		move.w	d0,d4
		neg.w	d4
		lea	($FFFFA606).w,a4
		move.w	(a4),d2
		sub.w	d5,d2
		move.w	d5,d3

loc_A08C:
		move.w	(a4)+,d0
		addq.w	#2,a4
		sub.w	d3,d0
		cmp.w	d2,d0
		bne.s	loc_A09A
		add.w	d0,d3
		bra.s	loc_A08C
; ---------------------------------------------------------------------------

loc_A09A:
		cmp.w	d4,d0
		beq.s	loc_A0A4
		cmp.w	d4,d2
		beq.s	loc_A0A4
		add.w	d2,d0

loc_A0A4:

		add.w	d5,d0
		cmpi.b	#2,(a2,d0.w)
		beq.s	loc_A0B8
		cmpi.b	#4,(a2,d0.w)
		beq.s	loc_A0C4
		bra.s	loc_A0C4
; ---------------------------------------------------------------------------

loc_A0B8:
		bsr.w	sub_9E88
		move.b	#4,(a2,d0.w)
		move.w	d0,(a5)+

loc_A0C4:

		movem.l	(sp)+,d0/d3-d4/d6/a4
		bra.s	loc_A054
; End of function sub_9F44

; ---------------------------------------------------------------------------
word_A0CA:	dc.w $FFDF
		dc.w $FFE0
		dc.w $FFE1
		dc.w $FFFF
		dc.w 1
		dc.w $1F
		dc.w $20
		dc.w $21
word_A0DA:	dc.w $FFFF
		dc.w $FFE0
		dc.w 1
		dc.w $20
		dc.w $FFFF
		dc.w $FFE0

; =============== S U B R O U T I N E =======================================


Load_SSSprite_Mappings:
		lea	($FFFFE480).w,a1
		lea	(MapPtr_A10A).l,a0
		moveq	#$D,d1

loc_A0F2:
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		dbf	d1,loc_A0F2
		lea	($FFFFA400).w,a1
		move.w	#$3F,d1

loc_A102:
		clr.l	(a1)+
		dbf	d1,loc_A102
		rts
; End of function Load_SSSprite_Mappings

; ---------------------------------------------------------------------------
MapPtr_A10A:	dc.l Map_SStageSphere
		dc.l $86800000
		dc.l Map_SStageSphere
		dc.l $86800000
		dc.l Map_SStageSphere
		dc.l $C6800000
		dc.l Map_SStageSphere
		dc.l $A6800000
		dc.l Map_SStageRing
		dc.l $C5A70000
		dc.l Map_SStageSphere
		dc.l $E6800000
		dc.l Map_SStageRing
		dc.l $C5A78030
		dc.l Map_SStageRing
		dc.l $C5A78031
		dc.l Map_SStageRing
		dc.l $C5A78032
		dc.l Map_SStageRing
		dc.l $C5A78033
		dc.l Map_SStageSphere
		dc.l $C6800000
		dc.l Map_SStageChaosEmerald
		dc.l $E5A70000
		dc.l Map_SStageSphere
		dc.l $C6800000
		dc.l Map_SStageSuperEmerald
		dc.l $E5A70000
; ---------------------------------------------------------------------------
		ext.l	d1
		lsl.l	#8,d1
		divs.w	d0,d1
		ext.l	d2
		lsl.l	#8,d2
		divs.w	d0,d2
		rts

; =============== S U B R O U T I N E =======================================


sub_A188:
		swap	d0
		move.w	d1,d3
		move.w	d2,d4
		move.w	($FFFFE40E).w,d0
		muls.w	d0,d3
		muls.w	d0,d4
		move.w	($FFFFE410).w,d0
		muls.w	d0,d1
		muls.w	d0,d2
		sub.l	d4,d1
		add.l	d1,d1
		add.l	d1,d1
		swap	d1
		add.l	d3,d2
		add.l	d2,d2
		add.l	d2,d2
		swap	d2
		swap	d0
		rts
; End of function sub_A188


; =============== S U B R O U T I N E =======================================


sub_A1B2:
		swap	d2
		move.w	d0,d3
		move.w	d1,d4
		move.w	($FFFFE40A).w,d2
		muls.w	d2,d3
		muls.w	d2,d4
		move.w	($FFFFE40C).w,d2
		muls.w	d2,d0
		muls.w	d2,d1
		sub.l	d4,d0
		add.l	d0,d0
		add.l	d0,d0
		swap	d0
		add.l	d3,d1
		add.l	d1,d1
		add.l	d1,d1
		swap	d1
		swap	d2
		rts
; End of function sub_A1B2


; =============== S U B R O U T I N E =======================================


sub_A1DC:
		swap	d1
		move.w	d0,d3
		move.w	d2,d4
		move.w	($FFFFE406).w,d1
		muls.w	d1,d3
		muls.w	d1,d4
		move.w	($FFFFE408).w,d1
		muls.w	d1,d0
		muls.w	d1,d2
		sub.l	d4,d0
		add.l	d0,d0
		add.l	d0,d0
		swap	d0
		add.l	d3,d2
		add.l	d2,d2
		add.l	d2,d2
		swap	d2
		swap	d1
		rts
; End of function sub_A1DC


; =============== S U B R O U T I N E =======================================


sub_A206:
		swap	d1
		move.w	d0,d3
		move.w	d2,d4
		move.w	($FFFFE41C).w,d1
		muls.w	d1,d3
		muls.w	d1,d4
		move.w	($FFFFE41E).w,d1
		muls.w	d1,d0
		muls.w	d1,d2
		sub.l	d4,d0
		add.l	d0,d0
		add.l	d0,d0
		swap	d0
		add.l	d3,d2
		add.l	d2,d2
		add.l	d2,d2
		swap	d2
		swap	d1
		rts
; End of function sub_A206


; =============== S U B R O U T I N E =======================================


sub_A230:

		add.w	d0,d0
		addi.w	#$80,d0
		andi.w	#$1FE,d0
		move.w	ScalarTable2(pc,d0.w),d1
		subi.w	#$80,d0
		andi.w	#$1FE,d0
		move.w	ScalarTable2(pc,d0.w),d0
		rts
; End of function sub_A230


; =============== S U B R O U T I N E =======================================


GetScalars2:
		add.w	d0,d0
		andi.w	#$1FE,d0
		move.w	ScalarTable2(pc,d0.w),(a1)+
		addi.w	#$80,d0
		andi.w	#$1FE,d0
		move.w	ScalarTable2(pc,d0.w),(a1)+
		rts
; End of function GetScalars2

; ---------------------------------------------------------------------------
ScalarTable2:	dc.w	  0,  $192,  $324,  $4B5,  $646,  $7D6,	 $964,	$AF1,  $C7C,  $E06,  $F8D, $1112, $1294, $1413,	$1590, $1709
		dc.w  $187E, $19EF, $1B5D, $1CC6, $1E2B, $1F8C,	$20E7, $223D, $238E, $24DA, $2620, $2760, $289A, $29CE,	$2AFB, $2C21
		dc.w  $2D41, $2E5A, $2F6C, $3076, $3179, $3274,	$3368, $3453, $3537, $3612, $36E5, $37B0, $3871, $392B,	$39DB, $3A82
		dc.w  $3B21, $3BB6, $3C42, $3CC5, $3D3F, $3DAF,	$3E15, $3E72, $3EC5, $3F0F, $3F4F, $3F85, $3FB1, $3FD4,	$3FEC, $3FFB
		dc.w  $4000, $3FFB, $3FEC, $3FD4, $3FB1, $3F85,	$3F4F, $3F0F, $3EC5, $3E72, $3E15, $3DAF, $3D3F, $3CC5,	$3C42, $3BB6
		dc.w  $3B21, $3A82, $39DB, $392B, $3871, $37B0,	$36E5, $3612, $3537, $3453, $3368, $3274, $3179, $3076,	$2F6C, $2E5A
		dc.w  $2D41, $2C21, $2AFB, $29CE, $289A, $2760,	$2620, $24DA, $238E, $223D, $20E7, $1F8C, $1E2B, $1CC6,	$1B5D, $19EF
		dc.w  $187E, $1709, $1590, $1413, $1294, $1112,	 $F8D,	$E06,  $C7C,  $AF1,  $964,  $7D6,  $646,  $4B5,	 $324,	$192
		dc.w	  0, $FE6E, $FCDC, $FB4B, $F9BA, $F82A,	$F69C, $F50F, $F384, $F1FA, $F073, $EEEE, $ED6C, $EBED,	$EA70, $E8F7
		dc.w  $E782, $E611, $E4A3, $E33A, $E1D5, $E074,	$DF19, $DDC3, $DC72, $DB26, $D9E0, $D8A0, $D766, $D632,	$D505, $D3DF
		dc.w  $D2BF, $D1A6, $D094, $CF8A, $CE87, $CD8C,	$CC98, $CBAD, $CAC9, $C9EE, $C91B, $C850, $C78F, $C6D5,	$C625, $C57E
		dc.w  $C4DF, $C44A, $C3BE, $C33B, $C2C1, $C251,	$C1EB, $C18E, $C13B, $C0F1, $C0B1, $C07B, $C04F, $C02C,	$C014, $C005
		dc.w  $C000, $C005, $C014, $C02C, $C04F, $C07B,	$C0B1, $C0F1, $C13B, $C18E, $C1EB, $C251, $C2C1, $C33B,	$C3BE, $C44A
		dc.w  $C4DF, $C57E, $C625, $C6D5, $C78F, $C850,	$C91B, $C9EE, $CAC9, $CBAD, $CC98, $CD8C, $CE87, $CF8A,	$D094, $D1A6
		dc.w  $D2BF, $D3DF, $D505, $D632, $D766, $D8A0,	$D9E0, $DB26, $DC72, $DDC3, $DF19, $E074, $E1D5, $E33A,	$E4A3, $E611
		dc.w  $E782, $E8F7, $EA70, $EBED, $ED6C, $EEEE,	$F073, $F1FA, $F384, $F50F, $F69C, $F82A, $F9BA, $FB4B,	$FCDC, $FE6E
Map_SStageSphere:	include "General\Special Stage\Map - Sphere.asm"

Map_SStageRing:	include "General\Special Stage\Map - Ring.asm"

Map_SStageChaosEmerald:	include "General\Special Stage\Map - Chaos Emerald.asm"

Map_SStageSuperEmerald:	include "General\Special Stage\Map - Super Emerald.asm"

; ---------------------------------------------------------------------------

locret_A85C:

		rts
; ---------------------------------------------------------------------------

Competition_Menu:
		bsr.w	Pal_FadeToBlack
		move	#$2700,sr
		move.w	($FFFFF60E).w,d0
		andi.b	#$BF,d0
		move.w	d0,($C00004).l
		jsr	(Clear_DisplayData).l
		lea	($C00004).l,a6
		move.w	#$8004,(a6)
		move.w	#$8230,(a6)
		move.w	#$8407,(a6)
		move.w	#$8730,(a6)
		move.w	#$8B00,(a6)
		move.w	#$8C81,(a6)
		move.w	#$9011,(a6)
		jsr	sub_C02A(pc)
		lea	($FFFFAC00).w,a1
		moveq	#0,d0
		move.w	#$FF,d1

loc_A8AA:
		move.l	d0,(a1)+
		dbf	d1,loc_A8AA
		lea	($FFFFB000).w,a1
		moveq	#0,d0
		move.w	#$7FF,d1

loc_A8BA:
		move.l	d0,(a1)+
		dbf	d1,loc_A8BA
		clr.w	($FFFFFB00).w
		move.l	#$FFFFFB00,($FFFFFBFC).w
		clr.w	($FFFFFE04).w
		cmpi.b	#3,($FFFFEF48).w
		bcs.s	loc_A8DC
		clr.b	($FFFFEF48).w

loc_A8DC:
		lea	(MapEni_S3MenuBG).l,a0
		lea	($FFFF0000).l,a1
		move.w	#$6001,d0
		jsr	(Eni_Decomp).l
		lea	($FFFF0000).l,a1
		move.l	#$60000003,d0
		moveq	#$27,d1
		moveq	#$1B,d2
		jsr	(Plane_Map_To_VRAM).l
		lea	(ArtKos_S3MenuBG).l,a0
		lea	($FFFF0000).l,a1
		movea.w	#$20,a2
		jsr	KosArt_To_VDP(pc)
		move.l	#locret_A85C,($FFFFEF44).w
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		lea	(ArtKos_CompetitionLevel).l,a0
		lea	($FFFF0000).l,a1
		movea.w	#$53E0,a2
		jsr	KosArt_To_VDP(pc)
		lea	(ArtKos_CompetitionMode).l,a0
		movea.w	#$6940,a2
		jsr	KosArt_To_VDP(pc)
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		lea	(Pal_Competition1).l,a0
		lea	($FFFFFC80).w,a1
		moveq	#$17,d0

loc_A96A:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_A96A
		lea	(Pal_CompetitionMenuBG).l,a0
		moveq	#7,d0

loc_A978:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_A978
		lea	($FFFFB000).w,a0
		lea	ObjDat_AB48(pc),a1
		move.w	(a1)+,d0

loc_A988:
		move.l	(a1)+,(a0)
		move.w	#$34A,$A(a0)
		move.l	#Map_CompetitionObject,$C(a0)
		move.w	(a1)+,$10(a0)
		move.w	(a1)+,$14(a0)
		move.b	(a1)+,$22(a0)
		move.b	(a1)+,$2E(a0)
		lea	$4A(a0),a0
		dbf	d0,loc_A988
		jsr	(Init_SpriteTable).l
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		moveq	#$2D,d0
		jsr	(Play_Sound).l
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		move.w	($FFFFF60E).w,d0
		ori.b	#$40,d0
		move.w	d0,($C00004).l
		bsr.w	Pal_FadeFromBlack

loc_A9E8:
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		addq.w	#1,($FFFFFE04).w
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		move.b	($FFFFF605).w,d0
		or.b	($FFFFF607).w,d0
		move.b	d0,d1
		andi.b	#-$10,d1
		beq.w	loc_AAA6
		btst	#4,d1
		bne.s	loc_AA2E
		moveq	#0,d2
		move.b	($FFFFEF48).w,d2
		add.w	d2,d2
		jmp	loc_AA28(pc,d2.w)
; ---------------------------------------------------------------------------

loc_AA28:
		bra.s	loc_AA36
; ---------------------------------------------------------------------------
		bra.s	loc_AA54
; ---------------------------------------------------------------------------
		bra.s	loc_AA74
; ---------------------------------------------------------------------------

loc_AA2E:
		move.b	#4,($FFFFF600).w
		rts
; ---------------------------------------------------------------------------

loc_AA36:
		clr.b	($FFFFFF8B).w
		move.b	($FFFFEF4E).w,($FFFFFF8A).w
		move.b	($FFFFF607).w,d0
		andi.b	#$E0,d0
		sne	($FFFFEF49).w
		move.b	#$3C,($FFFFF600).w
		bra.s	loc_AA8E
; ---------------------------------------------------------------------------

loc_AA54:
		move.b	#3,($FFFFFF8B).w
		move.b	($FFFFEF4E).w,($FFFFFF8A).w
		move.b	($FFFFF607).w,d0
		andi.b	#$E0,d0
		sne	($FFFFEF49).w
		move.b	#$40,($FFFFF600).w
		bra.s	loc_AA8E
; ---------------------------------------------------------------------------

loc_AA74:
		move.b	($FFFFF605).w,d2
		andi.w	#$E0,d2
		beq.s	loc_AAA6
		move.w	#-1,($FFFFFF8A).w
		clr.b	($FFFFEF49).w
		move.b	#-$40,($FFFFF600).w

loc_AA8E:

		lea	($FF7800).l,a1
		moveq	#0,d0
		moveq	#9,d1

loc_AA98:
		move.l	d0,(a1)+
		dbf	d1,loc_AA98
		moveq	#$63,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

loc_AAA6:

		moveq	#0,d2
		move.b	($FFFFEF48).w,d1
		lsr.w	#1,d0
		bcc.s	loc_AABA
		moveq	#$5B,d2
		subq.b	#1,d1
		bcc.s	loc_AACA
		moveq	#3,d1
		bra.s	loc_AACA
; ---------------------------------------------------------------------------

loc_AABA:
		lsr.w	#1,d0
		bcc.s	loc_AACA
		moveq	#$5B,d2
		addq.b	#1,d1
		cmpi.b	#3,d1
		bls.s	loc_AACA
		moveq	#0,d1

loc_AACA:

		move.b	d1,($FFFFEF48).w
		move.w	d2,d0
		beq.s	loc_AAD8
		jsr	(Play_Sound_2).l

loc_AAD8:
		bra.w	loc_A9E8
; ---------------------------------------------------------------------------

Obj_Competition_AADC:

		move.b	$2E(a0),d0
		bmi.s	loc_AAFA
		andi.w	#$9FFF,$A(a0)
		move.w	#$2000,d1
		cmp.b	($FFFFEF48).w,d0
		bne.s	loc_AAF6
		move.w	#$4000,d1

loc_AAF6:
		or.w	d1,$A(a0)

loc_AAFA:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_Competition_AB00:
		cmpi.b	#1,($FFFFEF48).w
		bhi.s	locret_AB46
		move.b	($FFFFF605).w,d0
		or.b	($FFFFF607).w,d0
		andi.w	#$C,d0
		beq.s	loc_AB26
		tst.b	($FFFFEF4E).w
		seq	($FFFFEF4E).w
		moveq	#$5B,d0
		jsr	(Play_Sound_2).l

loc_AB26:
		move.w	#$15C,d0
		tst.b	($FFFFEF4E).w
		beq.s	loc_AB34
		addi.w	#$20,d0

loc_AB34:
		move.w	d0,$10(a0)
		btst	#3,($FFFFFE05).w
		beq.s	locret_AB46
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_AB46:

		rts
; ---------------------------------------------------------------------------
ObjDat_AB48:	dc.w 6
		dc.l Obj_Competition_AADC
		dc.w $114
		dc.w $A0
		dc.b 0
		dc.b 0
		dc.l Obj_Competition_AADC
		dc.w $10C
		dc.w $C0
		dc.b 1
		dc.b 1
		dc.l Obj_Competition_AADC
		dc.w $108
		dc.w $E0
		dc.b 2
		dc.b 2
		dc.l Obj_Competition_AADC
		dc.w $13C
		dc.w $120
		dc.b 3
		dc.b 3
		dc.l Obj_Competition_AADC
		dc.w $164
		dc.w $B0
		dc.b 4
		dc.b $FF
		dc.l Obj_Competition_AADC
		dc.w $184
		dc.w $B0
		dc.b 5
		dc.b $FF
		dc.l Obj_Competition_AB00
		dc.w 0
		dc.w $A8
		dc.b 6
		dc.b $FF
; ---------------------------------------------------------------------------

Competition_LevelSelect:
		bsr.w	Pal_FadeToBlack
		move	#$2700,sr
		move.w	($FFFFF60E).w,d0
		andi.b	#$BF,d0
		move.w	d0,($C00004).l
		jsr	(Clear_DisplayData).l
		lea	($C00004).l,a6
		move.w	#$8004,(a6)
		move.w	#$8230,(a6)
		move.w	#$8407,(a6)
		move.w	#$8700,(a6)
		move.w	#$8B00,(a6)
		move.w	#$8C89,(a6)
		move.w	#$9011,(a6)
		jsr	sub_C02A(pc)
		lea	($FFFFAC00).w,a1
		moveq	#0,d0
		move.w	#$FF,d1

loc_ABDC:
		move.l	d0,(a1)+
		dbf	d1,loc_ABDC
		lea	($FFFFB000).w,a1
		moveq	#0,d0
		move.w	#$7FF,d1

loc_ABEC:
		move.l	d0,(a1)+
		dbf	d1,loc_ABEC
		clr.w	($FFFFFB00).w
		move.l	#$FFFFFB00,($FFFFFBFC).w
		clr.w	($FFFFFE04).w
		clr.w	($FFFFFFE8).w
		clr.b	($FFFFF711).w
		move.w	#-1,($FFFFEEE2).w
		clr.w	($FFFFEEE4).w
		clr.w	($FFFFEEE6).w
		lea	(MapEni_S3MenuBG).l,a0
		lea	($FFFF0000).l,a1
		move.w	#1,d0
		jsr	(Eni_Decomp).l
		lea	($FFFF0000).l,a1
		move.l	#$60000003,d0
		moveq	#$27,d1
		moveq	#$1B,d2
		jsr	(Plane_Map_To_VRAM).l
		lea	(MapEni_CompetitionLevBorder).l,a0
		lea	($FFFF0000).l,a1
		move.w	#$829F,d0
		jsr	(Eni_Decomp).l
		lea	(MapEni_CompetitionLevImage).l,a0
		lea	($FFFF1000).l,a1
		move.w	#$E29F,d0
		jsr	(Eni_Decomp).l
		lea	(MapEni_CompetitionLevName).l,a0
		lea	($FFFF2000).l,a1
		move.w	#$A29F,d0
		jsr	(Eni_Decomp).l
		lea	VRAMDatList_CompetitionLevelSelect(pc),a0
		jsr	Copy_Listed_Data_To_VRAM(pc)
		jsr	sub_AFB2(pc)
		mulu.w	#$48,d0
		move.w	d0,($FFFFF616).w
		jsr	sub_B006(pc)
		jsr	sub_B036(pc)
		lea	(ArtKos_S3MenuBG).l,a0
		lea	($FFFF0000).l,a1
		movea.w	#$20,a2
		jsr	KosArt_To_VDP(pc)
		move.l	#locret_A85C,($FFFFEF44).w
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		lea	(ArtKos_CompetitionLevel).l,a0
		lea	($FFFF0000).l,a1
		movea.w	#$53E0,a2
		jsr	KosArt_To_VDP(pc)
		lea	(ArtKos_CompetitionPlayer).l,a0
		movea.w	#$B920,a2
		jsr	KosArt_To_VDP(pc)
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		lea	(Pal_CompetitionMenuBG).l,a0
		lea	($FFFFFC80).w,a1
		moveq	#7,d0

loc_AD04:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_AD04
		lea	(Pal_Competition2).l,a0
		moveq	#$17,d0

loc_AD12:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_AD12
		lea	($FFFFB000).w,a0
		lea	ObjDat_CompetitionMatchRace(pc),a1
		tst.b	($FFFFF600).w
		bpl.s	loc_AD2A
		lea	ObjDat_CompetitionTimeAttack(pc),a1

loc_AD2A:
		move.w	(a1)+,d0

loc_AD2C:
		move.l	(a1)+,(a0)
		move.l	#Map_CompetitionSelect,$C(a0)
		move.w	(a1),$10(a0)
		move.w	(a1)+,$12(a0)
		move.w	(a1),$14(a0)
		move.w	(a1)+,$16(a0)
		move.w	(a1)+,d1
		addi.w	#$829F,d1
		move.w	d1,$A(a0)
		move.b	(a1)+,$22(a0)
		move.b	(a1)+,$2E(a0)
		lea	$4A(a0),a0
		dbf	d0,loc_AD2C
		moveq	#0,d0
		move.b	($FFFFFFEA).w,d0
		mulu.w	#$55,d0
		addi.b	#$40,d0
		move.b	d0,($FFFFB0C2).w
		tst.b	($FFFFF600).w
		bmi.s	loc_AD8A
		moveq	#0,d0
		move.b	($FFFFFFEB).w,d0
		mulu.w	#$55,d0
		addi.b	#$40,d0
		move.b	d0,($FFFFB234).w

loc_AD8A:
		jsr	(Init_SpriteTable).l
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		jsr	sub_C0AE(pc)
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		lea	($FFFFB378).w,a0
		move.l	#loc_AF58,(a0)
		move.l	#Map_CompetitionSelect,$C(a0)
		addi.w	#$C29F,$A(a0)
		move.w	#$B0,$10(a0)
		moveq	#$2D,d0
		jsr	(Play_Sound).l
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		move.w	($FFFFF60E).w,d0
		ori.b	#$40,d0
		move.w	d0,($C00004).l
		jsr	(Pal_FadeFromBlack).l

loc_ADF2:

		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		addq.w	#1,($FFFFFE04).w
		jsr	(Process_Sprites).l
		jsr	sub_C0AE(pc)
		jsr	(Render_Sprites).l
		move.b	($FFFFEEE4).w,d0
		beq.s	loc_AE1E
		move.b	d0,($FFFFF600).w
		rts
; ---------------------------------------------------------------------------

loc_AE1E:
		move.w	($FFFFEEE2).w,d0
		tst.b	($FFFFEF49).w
		bne.s	loc_AE2A
		lsr.w	#8,d0

loc_AE2A:
		tst.w	d0
		beq.s	loc_AE4A
		move.w	($FFFFE000).w,d0
		beq.s	loc_ADF2
		cmpi.w	#-$58,d0
		bne.s	loc_AE42
		move.l	#loc_AFC8,($FFFFEF44).w

loc_AE42:
		addq.w	#8,d0
		move.w	d0,($FFFFE000).w
		bra.s	loc_ADF2
; ---------------------------------------------------------------------------

loc_AE4A:
		cmpi.w	#-$58,($FFFFE000).w
		beq.s	loc_AE58
		subq.w	#8,($FFFFE000).w
		bra.s	loc_ADF2
; ---------------------------------------------------------------------------

loc_AE58:
		moveq	#8,d0
		move.w	($FFFFEEE6).w,d1
		beq.s	loc_AE6E
		bpl.s	loc_AE64
		neg.w	d0

loc_AE64:
		add.w	d0,($FFFFF616).w
		sub.w	d0,($FFFFEEE6).w
		bra.s	loc_ADF2
; ---------------------------------------------------------------------------

loc_AE6E:
		move.b	($FFFFF605).w,d1
		moveq	#0,d2
		tst.b	($FFFFEF49).w
		beq.s	loc_AE7E
		move.b	($FFFFF607).w,d2

loc_AE7E:
		btst	#4,d2
		beq.s	loc_AE8C
		sf	($FFFFB235).w
		st	($FFFFEEE3).w

loc_AE8C:
		btst	#4,d1
		beq.s	loc_AE9A
		sf	($FFFFB0C3).w
		st	($FFFFEEE2).w

loc_AE9A:
		or.b	d2,d1
		move.b	d1,d2
		andi.w	#3,d2
		beq.s	loc_AEF2
		lea	($FFFFEF4A).w,a0
		lsr.w	#1,d2
		bcs.s	loc_AED2
		cmpi.b	#4,(a0)
		beq.s	loc_AEF2
		moveq	#$5B,d0
		jsr	(Play_Sound_2).l
		addq.b	#1,(a0)
		cmpi.b	#4,(a0)
		beq.s	loc_AEF2
		cmpi.b	#1,(a0)
		beq.s	loc_AEF2
		move.w	#$48,($FFFFEEE6).w
		bra.w	loc_ADF2
; ---------------------------------------------------------------------------

loc_AED2:
		tst.b	(a0)
		beq.s	loc_AEF2
		moveq	#$5B,d0
		jsr	(Play_Sound_2).l
		subq.b	#1,(a0)
		beq.s	loc_AEF2
		cmpi.b	#3,(a0)
		beq.s	loc_AEF2
		move.w	#-$48,($FFFFEEE6).w
		bra.w	loc_ADF2
; ---------------------------------------------------------------------------

loc_AEF2:

		andi.w	#$E0,d1
		beq.w	loc_ADF2
		moveq	#$63,d0
		jsr	(Play_Sound_2).l
		moveq	#0,d0
		move.b	($FFFFEF4A).w,d0
		move.b	Comp_ZoneList(pc,d0.w),($FFFFFE10).w
		clr.b	($FFFFFE11).w
		jsr	sub_C104(pc)
		move.b	#$C,($FFFFF600).w
		rts
; ---------------------------------------------------------------------------
Comp_ZoneList:	dc.b   $E
		dc.b   $F
		dc.b  $11
		dc.b  $10
		dc.b  $12
		dc.b  $FF
; ---------------------------------------------------------------------------

Obj_Competition_ZoneSelect:

		cmpi.w	#-$58,($FFFFE000).w
		bne.s	locret_AF56
		tst.w	($FFFFEEE6).w
		bne.s	locret_AF56
		moveq	#0,d0
		move.b	($FFFFEF4A).w,d0
		mulu.w	#$48,d0
		addi.w	#$AC,d0
		sub.w	($FFFFF616).w,d0
		move.w	d0,$14(a0)
		btst	#3,($FFFFFE05).w
		beq.s	locret_AF56
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_AF56:

		rts
; ---------------------------------------------------------------------------

loc_AF58:
		cmpi.w	#-$58,($FFFFE000).w
		bne.s	loc_AF9E
		tst.w	($FFFFEEE6).w
		bne.s	loc_AF9E
		moveq	#0,d0
		move.b	($FFFFEF4A).w,d0
		mulu.w	#$48,d0
		addi.w	#$A8,d0
		sub.w	($FFFFF616).w,d0
		move.w	d0,$14(a0)
		move.b	($FFFFEF4A).w,d0
		addq.b	#6,d0
		move.b	d0,$22(a0)
		jsr	(Draw_Sprite).l
		moveq	#0,d0
		move.b	($FFFFEF4A).w,d0
		lsl.w	#5,d0
		lea	(Pal_Competition4).l,a1
		adda.w	d0,a1
		bra.s	loc_AFA4
; ---------------------------------------------------------------------------

loc_AF9E:

		lea	(Pal_Competition3).l,a1

loc_AFA4:
		lea	($FFFFFC40).w,a2
		moveq	#7,d0

loc_AFAA:
		move.l	(a1)+,(a2)+
		dbf	d0,loc_AFAA
		rts

; =============== S U B R O U T I N E =======================================


sub_AFB2:

		moveq	#0,d0
		move.b	($FFFFEF4A).w,d0
		subq.w	#1,d0
		bcc.s	loc_AFBE
		moveq	#0,d0

loc_AFBE:
		cmpi.w	#2,d0
		bls.s	locret_AFC6
		moveq	#2,d0

locret_AFC6:
		rts
; End of function sub_AFB2

; ---------------------------------------------------------------------------

loc_AFC8:
		move.l	#locret_A85C,($FFFFEF44).w
		move.l	#$42040003,d0
		lea	($C00000).l,a6
		move.l	#$80008000,d1
		move.w	#$8F80,4(a6)
		moveq	#8,d2

loc_AFEA:
		moveq	#$12,d3
		move.l	d0,4(a6)

loc_AFF0:
		move.l	d1,(a6)
		dbf	d3,loc_AFF0
		addi.l	#$20000,d0
		dbf	d2,loc_AFEA
		move.w	#$8F02,4(a6)

; =============== S U B R O U T I N E =======================================


sub_B006:
		bsr.s	sub_AFB2
		mulu.w	#$48,d0
		addi.w	#$20,d0
		lsl.w	#4,d0
		addi.w	#$C004,d0
		move.w	d0,d7
		tst.b	($FFFFF600).w
		bmi.s	loc_B02E
		jsr	sub_C04C(pc)
		move.w	d7,d0
		addi.w	#$600,d0
		jmp	sub_C04C(pc)
; ---------------------------------------------------------------------------
		rts
; ---------------------------------------------------------------------------

loc_B02E:
		addi.w	#$300,d0
		jmp	sub_C04C(pc)
; End of function sub_B006


; =============== S U B R O U T I N E =======================================


sub_B036:
		move.w	#-$3D2E,d7
		move.l	($FFFFE600).w,d6
		bsr.s	sub_B066
		addi.w	#$480,d7
		move.l	($FFFFE610).w,d6
		bsr.s	sub_B066
		addi.w	#$480,d7
		move.l	($FFFFE630).w,d6
		bsr.s	sub_B066
		addi.w	#$480,d7
		move.l	($FFFFE620).w,d6
		bsr.s	sub_B066
		addi.w	#$480,d7
		move.l	($FFFFE640).w,d6
; End of function sub_B036


; =============== S U B R O U T I N E =======================================


sub_B066:
		moveq	#0,d5
		lsl.l	#8,d6
		moveq	#2,d3

loc_B06C:
		rol.l	#8,d6
		moveq	#0,d0
		move.b	d6,d0
		jsr	(LevResults_GetDecimalScore).l
		move.b	d1,d5
		lsl.l	#8,d5
		dbf	d3,loc_B06C
		lea	($FFFFF100).w,a1
		lea	(MapUnc_CompetitionNumbers).l,a2
		moveq	#0,d0
		bsr.s	sub_B0C2
		st	d0
		bsr.s	sub_B0C2
		moveq	#$A,d1
		bsr.s	sub_B0D4
		bsr.s	sub_B0C2
		bsr.s	sub_B0C2
		moveq	#$B,d1
		bsr.s	sub_B0D4
		bsr.s	sub_B0C2
		bsr.s	sub_B0C2
		lea	($FFFFF100).w,a1
; End of function sub_B066


; =============== S U B R O U T I N E =======================================


sub_B0A6:

		move.w	d7,d0
		swap	d0
		clr.w	d0
		swap	d0
		lsl.l	#2,d0
		lsr.w	#2,d0
		ori.w	#$4000,d0
		swap	d0
		moveq	#7,d1
		moveq	#1,d2
		jmp	(Plane_Map_To_VRAM).l
; End of function sub_B0A6


; =============== S U B R O U T I N E =======================================


sub_B0C2:
		rol.l	#4,d5
		move.w	d5,d1
		andi.w	#$F,d1
		bne.s	sub_B0D4
		tst.w	d0
		bne.s	sub_B0D4
		moveq	#$C,d1
		st	d0
; End of function sub_B0C2


; =============== S U B R O U T I N E =======================================


sub_B0D4:
		add.w	d1,d1
		add.w	d1,d1
		move.w	(a2,d1.w),(a1)+
		move.w	2(a2,d1.w),$E(a1)
		rts
; End of function sub_B0D4


; =============== S U B R O U T I N E =======================================


sub_B0E4:
		lea	(byte_37E52).l,a1
		moveq	#0,d0
		move.b	d6,d0
		move.b	(a1,d0.w),d6
		rts
; End of function sub_B0E4

; ---------------------------------------------------------------------------
VRAMDatList_CompetitionLevelSelect:dc.w $18
		dc.l $FFFF0000
		dc.w $C098
		dc.w $1A
		dc.w 8
		dc.l $FFFF0000
		dc.w $C518
		dc.w $1A
		dc.w 8
		dc.l $FFFF0000
		dc.w $C998
		dc.w $1A
		dc.w 8
		dc.l $FFFF0000
		dc.w $CE18
		dc.w $1A
		dc.w 8
		dc.l $FFFF0000
		dc.w $D298
		dc.w $1A
		dc.w 8
		dc.l $FFFF1180
		dc.w $C11A
		dc.w 7
		dc.w 5
		dc.l $FFFF1120
		dc.w $C59A
		dc.w 7
		dc.w 5
		dc.l $FFFF1000
		dc.w $CA1A
		dc.w 7
		dc.w 5
		dc.l $FFFF1060
		dc.w $CE9A
		dc.w 7
		dc.w 5
		dc.l $FFFF10C0
		dc.w $D31A
		dc.w 7
		dc.w 5
		dc.l $FFFF2000
		dc.w $C1AC
		dc.w $E
		dc.w 4
		dc.l $FFFF2258
		dc.w $C62C
		dc.w $E
		dc.w 4
		dc.l $FFFF2096
		dc.w $CAAC
		dc.w $E
		dc.w 4
		dc.l $FFFF21C2
		dc.w $CF2C
		dc.w $E
		dc.w 4
		dc.l $FFFF212C
		dc.w $D3AC
		dc.w $E
		dc.w 4
		dc.l MapUnc_CompetitionTimeBorder
		dc.w $C0CE
		dc.w $B
		dc.w 8
		dc.l MapUnc_CompetitionTimeBorder
		dc.w $C54E
		dc.w $B
		dc.w 8
		dc.l MapUnc_CompetitionTimeBorder
		dc.w $C9CE
		dc.w $B
		dc.w 8
		dc.l MapUnc_CompetitionTimeBorder
		dc.w $CE4E
		dc.w $B
		dc.w 8
		dc.l MapUnc_CompetitionTimeBorder
		dc.w $D2CE
		dc.w $B
		dc.w 8
		dc.l MapUnc_CompetitionBESTTIME
		dc.w $C1D0
		dc.w 8
		dc.w 1
		dc.l MapUnc_CompetitionBESTTIME
		dc.w $C650
		dc.w 8
		dc.w 1
		dc.l MapUnc_CompetitionBESTTIME
		dc.w $CAD0
		dc.w 8
		dc.w 1
		dc.l MapUnc_CompetitionBESTTIME
		dc.w $CF50
		dc.w 8
		dc.w 1
		dc.l MapUnc_CompetitionBESTTIME
		dc.w $D3D0
		dc.w 8
		dc.w 1
ObjDat_CompetitionMatchRace:	dc.w $B
		dc.l Obj_Competition_ZoneSelect
		dc.w $F4
		dc.w 0
		dc.w 0
		dc.b 2
		dc.b 0
		dc.l Obj_Competition_StaticSprite
		dc.w $B0
		dc.w $A9
		dc.w $2000
		dc.b 3
		dc.b 0
		dc.l Obj_Competition_1PSelect
		dc.w $B5
		dc.w $C1
		dc.w 0
		dc.b 0
		dc.b 0
		dc.l Obj_CompetitionPlayerSprite
		dc.w $B5
		dc.w $D5
		dc.w 0
		dc.b 0
		dc.b 0
		dc.l Obj_CompetitionPlayerSprite
		dc.w $B5
		dc.w $D5
		dc.w 0
		dc.b 2
		dc.b 1
		dc.l Obj_CompetitionPlayerSprite
		dc.w $B5
		dc.w $D5
		dc.w 0
		dc.b 1
		dc.b 2
		dc.l Obj_Competition_StaticSprite
		dc.w $B2
		dc.w $109
		dc.w $2000
		dc.b 4
		dc.b 0
		dc.l Obj_Competition_2PSelect
		dc.w $B5
		dc.w $121
		dc.w 0
		dc.b 0
		dc.b 0
		dc.l Obj_CompetitionPlayerSprite2P
		dc.w $B5
		dc.w $135
		dc.w 0
		dc.b 0
		dc.b 0
		dc.l Obj_CompetitionPlayerSprite2P
		dc.w $B5
		dc.w $135
		dc.w 0
		dc.b 2
		dc.b 1
		dc.l Obj_CompetitionPlayerSprite2P
		dc.w $B5
		dc.w $135
		dc.w 0
		dc.b 1
		dc.b 2
		dc.l Obj_Competition_PRESSSTART
		dc.w $B1
		dc.w $126
		dc.w $2000
		dc.b 5
		dc.b 0
ObjDat_CompetitionTimeAttack:	dc.w 5
		dc.l Obj_Competition_ZoneSelect
		dc.w $F4
		dc.w $30
		dc.w 0
		dc.b 2
		dc.b 0
		dc.l Obj_Competition_StaticSprite
		dc.w $B0
		dc.w 0
		dc.w $2000
		dc.b 3
		dc.b 0
		dc.l Obj_Competition_1PSelect
		dc.w $B5
		dc.w $F1
		dc.w 0
		dc.b 0
		dc.b 0
		dc.l Obj_CompetitionPlayerSprite
		dc.w $B5
		dc.w $101
		dc.w 0
		dc.b 0
		dc.b 0
		dc.l Obj_CompetitionPlayerSprite
		dc.w $B5
		dc.w $101
		dc.w 0
		dc.b 2
		dc.b 1
		dc.l Obj_CompetitionPlayerSprite
		dc.w $B5
		dc.w $101
		dc.w 0
		dc.b 1
		dc.b 2
; ---------------------------------------------------------------------------

Competition_PlayerSelect:
		jsr	(Pal_FadeToBlack).l
		move	#$2700,sr
		move.w	($FFFFF60E).w,d0
		andi.b	#$BF,d0
		move.w	d0,($C00004).l
		jsr	(Clear_DisplayData).l
		lea	($C00004).l,a6
		move.w	#$8004,(a6)
		move.w	#$8230,(a6)
		move.w	#$8407,(a6)
		move.w	#$8700,(a6)
		move.w	#$8B00,(a6)
		move.w	#$8C89,(a6)
		move.w	#$9011,(a6)
		jsr	sub_C02A(pc)
		move.w	#$C220,d0
		jsr	sub_C04C(pc)
		move.w	#$C820,d0
		jsr	sub_C04C(pc)
		lea	($FFFFAC00).w,a1
		moveq	#0,d0
		move.w	#$FF,d1

loc_B32A:
		move.l	d0,(a1)+
		dbf	d1,loc_B32A
		lea	($FFFFB000).w,a1
		moveq	#0,d0
		move.w	#$7FF,d1

loc_B33A:
		move.l	d0,(a1)+
		dbf	d1,loc_B33A
		clr.w	($FFFFFB00).w
		move.l	#$FFFFFB00,($FFFFFBFC).w
		clr.w	($FFFFFE04).w
		move.w	#-1,($FFFFEEE2).w
		clr.w	($FFFFEEE4).w
		lea	(MapEni_S3MenuBG).l,a0
		lea	($FFFF0000).l,a1
		move.w	#1,d0
		jsr	(Eni_Decomp).l
		lea	($FFFF0000).l,a1
		move.l	#$60000003,d0
		moveq	#$27,d1
		moveq	#$1B,d2
		jsr	(Plane_Map_To_VRAM).l
		lea	(ArtKos_S3MenuBG).l,a0
		lea	($FFFF0000).l,a1
		movea.w	#$20,a2
		jsr	KosArt_To_VDP(pc)
		move.l	#locret_A85C,($FFFFEF44).w
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		lea	(ArtKos_CompetitionLevel).l,a0
		lea	($FFFF0000).l,a1
		movea.w	#$53E0,a2
		jsr	KosArt_To_VDP(pc)
		lea	(ArtKos_CompetitionPlayer).l,a0
		movea.w	#$B920,a2
		jsr	KosArt_To_VDP(pc)
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		lea	(Pal_CompetitionMenuBG).l,a0
		lea	($FFFFFC80).w,a1
		moveq	#7,d0

loc_B3E8:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_B3E8
		lea	(Pal_Competition2).l,a0
		moveq	#$17,d0

loc_B3F6:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_B3F6
		lea	($FFFFB04A).w,a0
		lea	ObjDat_B6C8(pc),a1
		move.w	(a1)+,d0

loc_B406:
		move.l	(a1)+,(a0)
		move.l	#Map_CompetitionSelect,$C(a0)
		move.w	(a1),$10(a0)
		move.w	(a1)+,$12(a0)
		move.w	(a1),$14(a0)
		move.w	(a1)+,$16(a0)
		move.w	(a1)+,d1
		addi.w	#$829F,d1
		move.w	d1,$A(a0)
		move.b	(a1)+,$22(a0)
		move.b	(a1)+,$2E(a0)
		lea	$4A(a0),a0
		dbf	d0,loc_B406
		moveq	#0,d0
		move.b	($FFFFFFEA).w,d0
		mulu.w	#$55,d0
		addi.b	#$40,d0
		move.b	d0,($FFFFB0C2).w
		moveq	#0,d0
		move.b	($FFFFFFEB).w,d0
		mulu.w	#$55,d0
		addi.b	#$40,d0
		move.b	d0,($FFFFB234).w
		jsr	(Init_SpriteTable).l
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		jsr	sub_C0AE(pc)
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		moveq	#$2D,d0
		jsr	(Play_Sound).l
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		move.w	($FFFFF60E).w,d0
		ori.b	#$40,d0
		move.w	d0,($C00004).l
		jsr	(Pal_FadeFromBlack).l

loc_B4A8:
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		addq.w	#1,($FFFFFE04).w
		jsr	(Process_Sprites).l
		jsr	sub_C0AE(pc)
		jsr	(Render_Sprites).l
		move.b	($FFFFEEE4).w,d0
		beq.s	loc_B4D4
		move.b	d0,($FFFFF600).w
		rts
; ---------------------------------------------------------------------------

loc_B4D4:
		move.w	($FFFFEEE2).w,d0
		tst.b	($FFFFEF49).w
		bne.s	loc_B4E0
		lsr.w	#8,d0

loc_B4E0:
		tst.w	d0
		bne.s	loc_B4A8
		move.w	#$E00,($FFFFFE10).w
		jsr	sub_C104(pc)
		move.b	#$C,($FFFFF600).w
		rts
; ---------------------------------------------------------------------------

Obj_Competition_StaticSprite:


		move.w	$12(a0),d0
		add.w	($FFFFE000).w,d0
		move.w	d0,$10(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_Competition_2PSelect:

		lea	($FFFFF607).w,a1
		lea	($FFFFEEE3).w,a2
		lea	($FFFFFFEB).w,a3
		tst.b	($FFFFEF49).w
		bne.s	loc_B538
		tst.w	($FFFFEEE6).w
		bne.s	loc_B526
		tst.b	(a1)
		smi	($FFFFEF49).w

loc_B526:
		moveq	#0,d0
		bra.w	loc_B638
; ---------------------------------------------------------------------------

Obj_Competition_1PSelect:

		lea	($FFFFF605).w,a1
		lea	($FFFFEEE2).w,a2
		lea	($FFFFFFEA).w,a3

loc_B538:
		tst.w	($FFFFE000).w
		bne.w	loc_B626
		tst.b	$2F(a0)
		beq.s	loc_B558
		btst	#4,(a1)
		beq.w	loc_B626
		sf	$2F(a0)
		st	(a2)
		bra.w	loc_B626
; ---------------------------------------------------------------------------

loc_B558:
		tst.b	$30(a0)
		bne.s	loc_B5D0
		move.b	(a1),d0
		andi.w	#$C,d0
		beq.w	loc_B602
		move.l	d0,-(sp)
		moveq	#-$3D,d0
		jsr	(Play_Sound_2).l
		move.l	(sp)+,d0
		clr.b	$34(a0)
		move.b	$2E(a0),$35(a0)
		btst	#2,d0
		bne.s	loc_B5AC
		move.b	#1,$30(a0)
		move.b	(a3),d0
		addq.b	#1,d0
		cmpi.b	#2,d0
		bls.s	loc_B596
		moveq	#0,d0

loc_B596:
		move.b	d0,(a3)
		mulu.w	#$55,d0
		bne.s	loc_B5A2
		move.w	#$100,d0

loc_B5A2:
		addi.w	#$40,d0
		move.w	d0,$32(a0)
		bra.s	loc_B5D0
; ---------------------------------------------------------------------------

loc_B5AC:
		move.b	#-1,$30(a0)
		move.b	(a3),d0
		subq.b	#1,d0
		bcc.s	loc_B5BA
		moveq	#2,d0

loc_B5BA:
		move.b	d0,(a3)
		mulu.w	#$55,d0
		cmpi.w	#$80,d0
		bcs.s	loc_B5C8
		ext.w	d0

loc_B5C8:
		addi.w	#$40,d0
		move.w	d0,$32(a0)

loc_B5D0:

		move.w	$34(a0),d0
		move.w	$32(a0),d1
		tst.b	$30(a0)
		bmi.s	loc_B5EC
		addq.w	#5,d0
		cmp.w	d0,d1
		bgt.s	loc_B5F8
		move.w	d1,d0
		clr.b	$30(a0)
		bra.s	loc_B5F8
; ---------------------------------------------------------------------------

loc_B5EC:
		subq.w	#5,d0
		cmp.w	d0,d1
		blt.s	loc_B5F8
		move.w	d1,d0
		clr.b	$30(a0)

loc_B5F8:

		move.w	d0,$34(a0)
		move.b	d0,$2E(a0)
		bra.s	loc_B626
; ---------------------------------------------------------------------------

loc_B602:
		btst	#4,(a1)
		beq.s	loc_B610
		move.b	#$38,($FFFFEEE4).w
		bra.s	loc_B626
; ---------------------------------------------------------------------------

loc_B610:
		move.b	(a1),d0
		andi.w	#$E0,d0
		beq.s	loc_B626
		st	$2F(a0)
		sf	(a2)
		moveq	#$63,d0
		jsr	(Play_Sound_2).l

loc_B626:

		moveq	#1,d0
		tst.b	$2F(a0)
		bne.s	loc_B638
		move.w	($FFFFFE04).w,d0
		lsr.w	#3,d0
		andi.w	#1,d0

loc_B638:

		move.b	d0,$22(a0)
		move.w	$12(a0),d0
		add.w	($FFFFE000).w,d0
		move.w	d0,$10(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_CompetitionPlayerSprite2P:

		tst.b	($FFFFEF49).w
		bne.s	Obj_CompetitionPlayerSprite
		rts
; ---------------------------------------------------------------------------

Obj_CompetitionPlayerSprite:

		move.l	#Map_CompetitionPlayerSprite,$C(a0)
		move.w	#$25C9,$A(a0)
		moveq	#0,d0
		moveq	#-$55,d1
		moveq	#0,d2
		move.b	$2E(a0),d2

loc_B66E:
		addi.w	#$4A,d0
		addi.w	#$55,d1
		dbf	d2,loc_B66E
		neg.w	d0
		move.b	$2E(a0,d0.w),d0
		add.b	d1,d0
		jsr	(GetSineCosine).l
		asr.w	#4,d1
		add.w	$12(a0),d1
		add.w	($FFFFE000).w,d1
		move.w	d1,$10(a0)
		asr.w	#5,d0
		add.w	$16(a0),d0
		move.w	d0,$14(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_Competition_PRESSSTART:

		tst.b	($FFFFEF49).w
		bne.s	locret_B6C6
		btst	#5,($FFFFFE05).w
		beq.s	locret_B6C6
		move.w	$12(a0),d0
		add.w	($FFFFE000).w,d0
		move.w	d0,$10(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_B6C6:

		rts
; ---------------------------------------------------------------------------
ObjDat_B6C8:	dc.w $A
		dc.l Obj_Competition_StaticSprite
		dc.w $120
		dc.w $A9
		dc.w $2000
		dc.b 3
		dc.b 0
		dc.l Obj_Competition_1PSelect
		dc.w $125
		dc.w $C1
		dc.w 0
		dc.b 0
		dc.b 0
		dc.l Obj_CompetitionPlayerSprite
		dc.w $125
		dc.w $D5
		dc.w 0
		dc.b 0
		dc.b 0
		dc.l Obj_CompetitionPlayerSprite
		dc.w $125
		dc.w $D5
		dc.w 0
		dc.b 2
		dc.b 1
		dc.l Obj_CompetitionPlayerSprite
		dc.w $125
		dc.w $D5
		dc.w 0
		dc.b 1
		dc.b 2
		dc.l Obj_Competition_StaticSprite
		dc.w $122
		dc.w $109
		dc.w $2000
		dc.b 4
		dc.b 0
		dc.l Obj_Competition_2PSelect
		dc.w $125
		dc.w $121
		dc.w 0
		dc.b 0
		dc.b 0
		dc.l Obj_CompetitionPlayerSprite2P
		dc.w $125
		dc.w $135
		dc.w 0
		dc.b 0
		dc.b 0
		dc.l Obj_CompetitionPlayerSprite2P
		dc.w $125
		dc.w $135
		dc.w 0
		dc.b 2
		dc.b 1
		dc.l Obj_CompetitionPlayerSprite2P
		dc.w $125
		dc.w $135
		dc.w 0
		dc.b 1
		dc.b 2
		dc.l Obj_Competition_PRESSSTART
		dc.w $121
		dc.w $126
		dc.w $2000
		dc.b 5
		dc.b 0
; ---------------------------------------------------------------------------

Competition_Results:
		jsr	(Pal_FadeToBlack).l
		move	#$2700,sr
		move.w	($FFFFF60E).w,d0
		andi.b	#$BF,d0
		move.w	d0,($C00004).l
		jsr	(Clear_DisplayData).l
		lea	($C00004).l,a6
		move.w	#$8004,(a6)
		move.w	#$8230,(a6)
		move.w	#$8407,(a6)
		move.w	#$8700,(a6)
		move.w	#$8B00,(a6)
		move.w	#$8C89,(a6)
		move.w	#$9011,(a6)
		jsr	sub_C02A(pc)
		move.w	#$C1AA,d0
		jsr	sub_C04C(pc)
		move.w	#$C82A,d0
		jsr	sub_C04C(pc)
		lea	($FFFFAC00).w,a1
		moveq	#0,d0
		move.w	#$FF,d1

loc_B7AC:
		move.l	d0,(a1)+
		dbf	d1,loc_B7AC
		lea	($FFFFB000).w,a1
		moveq	#0,d0
		move.w	#$7FF,d1

loc_B7BC:
		move.l	d0,(a1)+
		dbf	d1,loc_B7BC
		clr.w	($FFFFFB00).w
		move.l	#$FFFFFB00,($FFFFFBFC).w
		clr.w	($FFFFFE04).w
		clr.w	($FFFFFFE8).w
		clr.b	($FFFFF711).w
		move.w	#$1E,($FFFFEEE8).w
		lea	(MapEni_S3MenuBG).l,a0
		lea	($FFFF0000).l,a1
		move.w	#1,d0
		jsr	(Eni_Decomp).l
		lea	(MapEni_CompetitionResultsLED).l,a0
		lea	($FFFF1000).l,a1
		move.w	#$A34A,d0
		jsr	(Eni_Decomp).l
		lea	VRAMDatList_BBAC(pc),a0
		jsr	Copy_Listed_Data_To_VRAM(pc)
		jsr	sub_BA04(pc)
		lea	(ArtKos_S3MenuBG).l,a0
		lea	($FFFF0000).l,a1
		movea.w	#$20,a2
		jsr	KosArt_To_VDP(pc)
		move.l	#locret_A85C,($FFFFEF44).w
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		lea	(ArtKos_CompetitionLevel).l,a0
		lea	($FFFF0000).l,a1
		movea.w	#$53E0,a2
		jsr	KosArt_To_VDP(pc)
		lea	(ArtKos_CompetitionResults).l,a0
		movea.w	#$6940,a2
		jsr	KosArt_To_VDP(pc)
		lea	(ArtKos_CompetitionPlayer).l,a0
		movea.w	#$B920,a2
		jsr	KosArt_To_VDP(pc)
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		lea	(Pal_CompetitionMenuBG).l,a0
		lea	($FFFFFC80).w,a1
		moveq	#7,d0

loc_B888:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_B888
		lea	(Pal_Competition2).l,a0
		moveq	#$F,d0

loc_B896:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_B896
		lea	(Pal_CompetitionResults).l,a0
		moveq	#7,d0

loc_B8A4:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_B8A4
		lea	($FFFFB000).w,a0
		lea	ObjDat_BB4A(pc),a1
		move.w	(a1)+,d0

loc_B8B4:
		move.l	(a1)+,(a0)
		move.l	#Map_CompetitionSelect,$C(a0)
		move.w	(a1),$10(a0)
		move.w	(a1)+,$12(a0)
		move.w	(a1),$14(a0)
		move.w	(a1)+,$16(a0)
		move.w	(a1)+,d1
		addi.w	#$829F,d1
		move.w	d1,$A(a0)
		move.b	(a1)+,$22(a0)
		move.b	(a1)+,$2E(a0)
		lea	$4A(a0),a0
		dbf	d0,loc_B8B4
		jsr	(Init_SpriteTable).l
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		moveq	#$28,d0
		jsr	(Play_Sound).l
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		move.w	($FFFFF60E).w,d0
		ori.b	#$40,d0
		move.w	d0,($C00004).l
		jsr	(Pal_FadeFromBlack).l

loc_B922:
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		addq.w	#1,($FFFFFE04).w
		move.w	($FFFFEEA0).w,d7
		beq.s	loc_B952
		btst	#3,($FFFFFE05).w
		bne.s	loc_B94A
		lea	($FFFFF120).w,a1
		jsr	sub_B0A6(pc)
		bra.s	loc_B952
; ---------------------------------------------------------------------------

loc_B94A:
		move.l	($FFFFEE98).w,d6
		jsr	sub_B066(pc)

loc_B952:

		tst.w	($FFFFEEE8).w
		beq.s	loc_B95E
		subq.w	#1,($FFFFEEE8).w
		bra.s	loc_B996
; ---------------------------------------------------------------------------

loc_B95E:
		move.b	($FFFFF605).w,d0
		tst.b	($FFFFEF49).w
		beq.s	loc_B96C
		or.b	($FFFFF607).w,d0

loc_B96C:
		move.w	($FFFFE000).w,d1
		beq.s	loc_B97A
		cmpi.w	#$FF78,d1
		beq.s	loc_B988
		bra.s	loc_B980
; ---------------------------------------------------------------------------

loc_B97A:
		andi.w	#$E0,d0
		beq.s	loc_B996

loc_B980:
		subq.w	#8,d1
		move.w	d1,($FFFFE000).w
		bra.s	loc_B996
; ---------------------------------------------------------------------------

loc_B988:
		andi.w	#$E0,d0
		beq.s	loc_B996
		move.b	#$38,($FFFFF600).w
		rts
; ---------------------------------------------------------------------------

loc_B996:

		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		bra.w	loc_B922
; ---------------------------------------------------------------------------

Obj_Competition_B9A6:

		move.l	#Map_CompetitionPlayerSprite,$C(a0)
		move.w	#$A5C9,$A(a0)
		move.b	($FFFFFFEA).w,d0
		tst.b	$2E(a0)
		beq.s	loc_B9C2
		move.b	($FFFFFFEB).w,d0

loc_B9C2:
		move.b	d0,$22(a0)
		jmp	Obj_Competition_StaticSprite(pc)
; ---------------------------------------------------------------------------

Obj_Competition_B9CA:

		move.w	#$A34A,$A(a0)
		move.b	($FFFFEEA2).w,d0
		move.b	($FFFFEEA3).w,d1
		tst.b	$2E(a0)
		beq.s	loc_B9E0
		exg	d0,d1

loc_B9E0:
		moveq	#$D,d2
		cmp.b	d0,d1
		beq.s	loc_B9EC
		bcs.s	loc_B9EA
		addq.w	#1,d2

loc_B9EA:
		subq.b	#2,d2

loc_B9EC:
		move.b	d2,$22(a0)
		cmpi.b	#$B,d2
		bne.w	Obj_Competition_StaticSprite
		btst	#3,($FFFFFE05).w
		bne.w	Obj_Competition_StaticSprite
		rts

; =============== S U B R O U T I N E =======================================


sub_BA04:
		lea	($FF7800).l,a0
		move.w	#$C15A,d7
		jsr	sub_BAEE(pc)
		move.w	#$C7DA,d7
		jsr	sub_BAEE(pc)
		lea	($FF7800).l,a0
		jsr	sub_BB04(pc)
		move.w	#$C65A,d7
		move.l	d6,($FFFFEE98).w
		move.w	d7,($FFFFEEA0).w
		jsr	sub_B066(pc)
		jsr	sub_BB04(pc)
		move.w	#$CCDA,d7
		cmp.l	($FFFFEE98).w,d6
		bhi.s	loc_BA52
		bne.s	loc_BA4A
		clr.w	($FFFFEEA0).w
		bra.s	loc_BA52
; ---------------------------------------------------------------------------

loc_BA4A:
		move.l	d6,($FFFFEE98).w
		move.w	d7,($FFFFEEA0).w

loc_BA52:
		jsr	sub_B066(pc)
		clr.w	($FFFFEEA2).w
		lea	($FF7800).l,a0
		move.l	#$41480003,d5
		moveq	#4,d7

loc_BA68:
		lea	(MapUnc_ResultsWin).l,a1
		lea	(MapUnc_ResultsLose).l,a2
		addq.b	#1,($FFFFEEA2).w
		move.l	(a0)+,d0
		cmp.l	$10(a0),d0
		beq.s	loc_BA8E
		bcs.s	loc_BA9A
		exg	a1,a2
		subq.b	#1,($FFFFEEA2).w
		addq.b	#1,($FFFFEEA3).w
		bra.s	loc_BA9A
; ---------------------------------------------------------------------------

loc_BA8E:
		lea	(MapUnc_ResultsTie).l,a1
		movea.l	a1,a2
		subq.b	#1,($FFFFEEA2).w

loc_BA9A:
		move.l	d5,d0
		moveq	#1,d1
		moveq	#1,d2
		jsr	(Plane_Map_To_VRAM).l
		movea.l	a2,a1
		move.l	d5,d0
		addi.l	#$6800000,d0
		moveq	#1,d1
		moveq	#1,d2
		jsr	(Plane_Map_To_VRAM).l
		addi.l	#$1000000,d5
		dbf	d7,loc_BA68
		move.w	($FFFFEEA0).w,d7
		beq.s	locret_BAEC
		move.l	($FFFFEE98).w,d6
		jsr	sub_B066(pc)
		lea	($FFFFF100).w,a0
		lea	$20(a0),a1
		moveq	#$F,d0

loc_BADC:
		move.w	(a0)+,d1
		andi.w	#$9FFF,d1
		ori.w	#$6000,d1
		move.w	d1,(a1)+
		dbf	d0,loc_BADC

locret_BAEC:
		rts
; End of function sub_BA04


; =============== S U B R O U T I N E =======================================


sub_BAEE:
		moveq	#4,d0

loc_BAF0:

		move.w	d0,-(sp)
		move.l	(a0)+,d6
		jsr	sub_B066(pc)
		addi.w	#$100,d7
		move.w	(sp)+,d0
		dbf	d0,loc_BAF0
		rts
; End of function sub_BAEE


; =============== S U B R O U T I N E =======================================


sub_BB04:
		clr.l	($FFFFEF40).w
		moveq	#4,d7

loc_BB0A:
		move.l	(a0)+,d6
		lea	($FFFFEF44).w,a1
		add.b	d6,-(a1)
		cmpi.b	#$64,(a1)
		bcs.s	loc_BB20
		subi.b	#$64,(a1)
		addq.b	#1,-1(a1)

loc_BB20:
		lsr.l	#8,d6
		add.b	d6,-(a1)
		cmpi.b	#$3C,(a1)
		bcs.s	loc_BB32
		subi.b	#$3C,(a1)
		addq.b	#1,-1(a1)

loc_BB32:
		lsr.l	#8,d6
		add.b	d6,-(a1)
		cmpi.b	#$64,(a1)
		bcs.s	loc_BB40
		move.b	#$63,(a1)

loc_BB40:
		dbf	d7,loc_BB0A
		move.l	($FFFFEF40).w,d6
		rts
; End of function sub_BB04

; ---------------------------------------------------------------------------
ObjDat_BB4A:	dc.w 7
		dc.l Obj_Competition_StaticSprite
		dc.w $148
		dc.w $A1
		dc.w $2000
		dc.b 3
		dc.b 0
		dc.l Obj_Competition_StaticSprite
		dc.w $14D
		dc.w $B9
		dc.w 0
		dc.b 0
		dc.b 0
		dc.l Obj_Competition_B9A6
		dc.w $14D
		dc.w $D3
		dc.w 0
		dc.b 0
		dc.b 0
		dc.l Obj_Competition_B9CA
		dc.w $CC
		dc.w $BC
		dc.w 0
		dc.b 0
		dc.b 0
		dc.l Obj_Competition_StaticSprite
		dc.w $14A
		dc.w $109
		dc.w $2000
		dc.b 4
		dc.b 0
		dc.l Obj_Competition_StaticSprite
		dc.w $14D
		dc.w $121
		dc.w 0
		dc.b 0
		dc.b 0
		dc.l Obj_Competition_B9A6
		dc.w $14D
		dc.w $13B
		dc.w 0
		dc.b 0
		dc.b 1
		dc.l Obj_Competition_B9CA
		dc.w $CC
		dc.w $124
		dc.w 0
		dc.b 0
		dc.b 1
VRAMDatList_BBAC:dc.w 8
		dc.l $FFFF0000
		dc.w $E000
		dc.w $27
		dc.w $1B
		dc.l $FFFF1000
		dc.w $C204
		dc.w $E
		dc.w 5
		dc.l $FFFF1000
		dc.w $C884
		dc.w $E
		dc.w 5
		dc.l MapUnc_CompetitionResultsLetters
		dc.w $C142
		dc.w 1
		dc.w 9
		dc.l MapUnc_CompetitionResultsLetters
		dc.w $C7C2
		dc.w 1
		dc.w 9
		dc.l MapUnc_CompetitionResultsDividers
		dc.w $C152
		dc.w 3
		dc.w 9
		dc.l MapUnc_CompetitionResultsDividers
		dc.w $C7D2
		dc.w 3
		dc.w 9
		dc.l MapUnc_CompetitionResultsTOTAL
		dc.w $C650
		dc.w 4
		dc.w 1
		dc.l MapUnc_CompetitionResultsTOTAL
		dc.w $CCD0
		dc.w 4
		dc.w 1
; ---------------------------------------------------------------------------

TimeAttack_Records:
		jsr	(Pal_FadeToBlack).l
		move	#$2700,sr
		move.w	($FFFFF60E).w,d0
		andi.b	#$BF,d0
		move.w	d0,($C00004).l
		jsr	(Clear_DisplayData).l
		lea	($C00004).l,a6
		move.w	#$8004,(a6)
		move.w	#$8230,(a6)
		move.w	#$8407,(a6)
		move.w	#$8700,(a6)
		move.w	#$8B00,(a6)
		move.w	#$8C89,(a6)
		move.w	#$9011,(a6)
		jsr	sub_C02A(pc)
		move.w	#$C1AA,d0
		jsr	sub_C04C(pc)
		lea	($FFFFAC00).w,a1
		moveq	#0,d0
		move.w	#$FF,d1

loc_BC5E:
		move.l	d0,(a1)+
		dbf	d1,loc_BC5E
		lea	($FFFFB000).w,a1
		moveq	#0,d0
		move.w	#$7FF,d1

loc_BC6E:
		move.l	d0,(a1)+
		dbf	d1,loc_BC6E
		clr.w	($FFFFFB00).w
		move.l	#$FFFFFB00,($FFFFFBFC).w
		clr.w	($FFFFFE04).w
		clr.w	($FFFFFFE8).w
		clr.b	($FFFFF711).w
		move.w	#$1E,($FFFFEEE8).w
		move.w	#$FF78,($FFFFE000).w
		lea	(MapEni_S3MenuBG).l,a0
		lea	($FFFF0000).l,a1
		move.w	#1,d0
		jsr	(Eni_Decomp).l
		lea	VRAMDatList_BF96(pc),a0
		jsr	Copy_Listed_Data_To_VRAM(pc)
		moveq	#0,d0
		move.b	($FFFFFE10).w,d0
		subi.w	#$E,d0
		lsl.w	#2,d0
		lea	CompTimeAttack_LevelNameMaps(pc),a1
		movea.l	(a1,d0.w),a1
		move.l	#$48260003,d0
		moveq	#$C,d1
		moveq	#1,d2
		jsr	(Plane_Map_To_VRAM).l
		jsr	sub_BEB2(pc)
		move.l	#$71A00002,($C00004).l
		lea	(ArtNem_ContinueDigits).l,a0
		jsr	(Nem_Decomp).l
		move.l	#$74200002,($C00004).l
		lea	(ArtNem_S38x16Font).l,a0
		jsr	(Nem_Decomp).l
		lea	(ArtKos_S3MenuBG).l,a0
		lea	($FFFF0000).l,a1
		movea.w	#$20,a2
		jsr	KosArt_To_VDP(pc)
		move.l	#locret_A85C,($FFFFEF44).w
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		lea	(ArtKos_CompetitionLevel).l,a0
		lea	($FFFF0000).l,a1
		movea.w	#$53E0,a2
		jsr	KosArt_To_VDP(pc)
		lea	(ArtKos_CompetitionResults).l,a0
		movea.w	#$6940,a2
		jsr	KosArt_To_VDP(pc)
		lea	(ArtKos_CompetitionPlayer).l,a0
		movea.w	#$B920,a2
		jsr	KosArt_To_VDP(pc)
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		lea	(ArtKos_SSResultsGeneral).l,a0
		lea	($FFFF0020).l,a1
		jsr	(Kos_Decomp).l
		lea	(ArtKos_SSResultsTKIcons).l,a0
		jsr	(Kos_Decomp).l
		move	#$2700,sr
		move.l	#$6E400002,($C00004).l
		lea	($FFFF0F60).l,a0
		lea	($C00000).l,a6
		move.w	#$D7,d0

loc_BDAA:
		move.l	(a0)+,(a6)
		dbf	d0,loc_BDAA
		lea	(Pal_CompetitionMenuBG).l,a0
		lea	($FFFFFC80).w,a1
		moveq	#7,d0

loc_BDBC:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_BDBC
		lea	(Pal_Competition2).l,a0
		moveq	#$F,d0

loc_BDCA:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_BDCA
		lea	(Pal_CompetitionTimeAttack).l,a0
		moveq	#7,d0

loc_BDD8:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_BDD8
		lea	($FFFFB000).w,a0
		lea	ObjDat_BF58(pc),a1
		move.w	(a1)+,d0

loc_BDE8:
		move.l	(a1)+,(a0)
		move.l	#Map_CompetitionSelect,$C(a0)
		move.w	(a1),$10(a0)
		move.w	(a1)+,$12(a0)
		move.w	(a1),$14(a0)
		move.w	(a1)+,$16(a0)
		move.w	(a1)+,d1
		addi.w	#$829F,d1
		move.w	d1,$A(a0)
		move.b	(a1)+,$22(a0)
		move.b	(a1)+,$2E(a0)
		lea	$4A(a0),a0
		dbf	d0,loc_BDE8
		jsr	(Init_SpriteTable).l
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		moveq	#$28,d0
		jsr	(Play_Sound).l
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		move.w	($FFFFF60E).w,d0
		ori.b	#$40,d0
		move.w	d0,($C00004).l
		jsr	(Pal_FadeFromBlack).l

loc_BE56:
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		addq.w	#1,($FFFFFE04).w
		move.w	($FFFFEEA0).w,d7
		beq.s	loc_BE86
		btst	#3,($FFFFFE05).w
		bne.s	loc_BE7E
		lea	($FFFFF120).w,a1
		jsr	sub_B0A6(pc)
		bra.s	loc_BE86
; ---------------------------------------------------------------------------

loc_BE7E:
		move.l	($FFFFEE98).w,d6
		jsr	sub_B066(pc)

loc_BE86:

		tst.w	($FFFFEEE8).w
		beq.s	loc_BE92
		subq.w	#1,($FFFFEEE8).w
		bra.s	loc_BEA4
; ---------------------------------------------------------------------------

loc_BE92:
		move.b	($FFFFF605).w,d0
		andi.w	#$E0,d0
		beq.s	loc_BEA4
		move.b	#$C0,($FFFFF600).w
		rts
; ---------------------------------------------------------------------------

loc_BEA4:

		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		bra.s	loc_BE56

; =============== S U B R O U T I N E =======================================


sub_BEB2:
		lea	($FF7828).l,a0
		move.w	#$C15A,d7
		moveq	#5,d0
		jsr	loc_BAF0(pc)
		moveq	#0,d0
		move.b	($FFFFFE10).w,d0
		subi.w	#$E,d0
		lsl.w	#4,d0
		lea	($FFFFE600).w,a0
		adda.w	d0,a0
		move.w	#$C95A,d7
		move.l	(a0)+,d6
		jsr	sub_B066(pc)
		addi.w	#$180,d7
		move.l	(a0)+,d6
		jsr	sub_B066(pc)
		addi.w	#$180,d7
		move.l	(a0)+,d6
		jsr	sub_B066(pc)
		clr.w	($FFFFEEA0).w
		rts
; End of function sub_BEB2

; ---------------------------------------------------------------------------

Obj_Competition_BEF8:

		move.l	#Map_Results,$C(a0)
		move.w	#$9FD5,$A(a0)
		moveq	#0,d0
		move.b	($FFFFFE10).w,d0
		subi.w	#$E,d0
		lsl.w	#4,d0
		lea	($FFFFE600).w,a1
		lea	$C(a1,d0.w),a1
		moveq	#0,d0
		move.b	$2E(a0),d0
		move.b	(a1,d0.w),d0
		cmpi.w	#2,d0
		bne.s	loc_BF30
		addi.w	#$2000,$A(a0)

loc_BF30:
		addi.w	#$29,d0
		move.b	d0,$22(a0)
		move.l	#loc_BF3E,(a0)

loc_BF3E:
		move.b	($FFFFEE5A).w,d0
		cmp.b	$2E(a0),d0
		bne.s	loc_BF50
		btst	#3,($FFFFFE05).w
		beq.s	locret_BF56

loc_BF50:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_BF56:
		rts
; ---------------------------------------------------------------------------
ObjDat_BF58:	dc.w 4
		dc.l Obj_Competition_StaticSprite
		dc.w $14D
		dc.w $B9
		dc.w 0
		dc.b 0
		dc.b 0
		dc.l Obj_Competition_B9A6
		dc.w $14D
		dc.w $CB
		dc.w 0
		dc.b 0
		dc.b 0
		dc.l Obj_Competition_BEF8
		dc.w $130
		dc.w $120
		dc.w 0
		dc.b 0
		dc.b 0
		dc.l Obj_Competition_BEF8
		dc.w $130
		dc.w $138
		dc.w 0
		dc.b 0
		dc.b 1
		dc.l Obj_Competition_BEF8
		dc.w $130
		dc.w $150
		dc.w 0
		dc.b 0
		dc.b 2
VRAMDatList_BF96:dc.w 8
		dc.l $FFFF0000
		dc.w $E000
		dc.w $27
		dc.w $1B
		dc.l MapUnc_CompetitionLAPNum
		dc.w $C144
		dc.w 4
		dc.w 9
		dc.l MapUnc_CompetitionResultsDividers
		dc.w $C152
		dc.w 3
		dc.w 9
		dc.l MapUnc_CompetitionResultsTOTAL
		dc.w $C650
		dc.w 4
		dc.w 1
		dc.l MapUnc_CompetitionResultsDividers
		dc.w $C952
		dc.w 3
		dc.w 1
		dc.l MapUnc_CompetitionResultsDividers
		dc.w $CAD2
		dc.w 3
		dc.w 1
		dc.l MapUnc_CompetitionResultsDividers
		dc.w $CC52
		dc.w 3
		dc.w 1
		dc.l MapUnc_CompetitionRECORDS
		dc.w $C92C
		dc.w 6
		dc.w 1
		dc.l MapUnc_Competition1st2nd3rd
		dc.w $C944
		dc.w 2
		dc.w 7
CompTimeAttack_LevelNameMaps:dc.l MapUnc_CompetitionAZURELAKE
		dc.l MapUnc_CompetitionBALLOONPARK
		dc.l MapUnc_CompetitionDESERTPALACE
		dc.l MapUnc_CompetitionCHROMEGADGET
		dc.l MapUnc_CompetitionENDLESSMINE

; =============== S U B R O U T I N E =======================================


KosArt_To_VDP:

		movea.l	a1,a3
		jsr	(Kos_Decomp).l
		move.l	a3,d1
		andi.l	#$FFFFFF,d1
		move.l	a1,d3
		sub.l	a3,d3
		lsr.l	#1,d3
		move.w	a2,d2
		movea.l	a1,a3
		jsr	(Add_To_DMA_Queue).l
		movea.l	a3,a1
		rts
; End of function KosArt_To_VDP


; =============== S U B R O U T I N E =======================================


sub_C02A:

		move.l	#$80008000,d0
		move.w	#$7FF,d1
		move.l	#$40000003,($C00004).l
		lea	($C00000).l,a6

loc_C044:
		move.l	d0,(a6)
		dbf	d1,loc_C044
		rts
; End of function sub_C02A


; =============== S U B R O U T I N E =======================================


sub_C04C:
		moveq	#7,d2
		lea	($C00000).l,a6
		moveq	#0,d1

loc_C056:
		move.w	d0,d3
		bsr.s	sub_C068
		addi.w	#$80,d0
		andi.w	#$DFFF,d0
		dbf	d2,loc_C056
		rts
; End of function sub_C04C


; =============== S U B R O U T I N E =======================================


sub_C068:
		swap	d3
		clr.w	d3
		swap	d3
		lsl.l	#2,d3
		lsr.w	#2,d3
		ori.w	#$4000,d3
		swap	d3
		move.l	d3,4(a6)
		move.l	d1,(a6)
		move.l	d1,(a6)
		move.l	d1,(a6)
		move.l	d1,(a6)
		move.w	d1,(a6)
		rts
; End of function sub_C068


; =============== S U B R O U T I N E =======================================


Copy_Listed_Data_To_VRAM:

		move.w	(a0)+,d7

loc_C08A:
		movea.l	(a0)+,a1
		move.w	(a0)+,d0
		swap	d0
		clr.w	d0
		swap	d0
		lsl.l	#2,d0
		lsr.w	#2,d0
		ori.w	#$4000,d0
		swap	d0
		move.w	(a0)+,d1
		move.w	(a0)+,d2
		jsr	(Plane_Map_To_VRAM).l
		dbf	d7,loc_C08A
		rts
; End of function Copy_Listed_Data_To_VRAM


; =============== S U B R O U T I N E =======================================


sub_C0AE:

		lea	($FFFFB0DE).w,a0
		bsr.s	sub_C0B8
		lea	($FFFFB250).w,a0
; End of function sub_C0AE


; =============== S U B R O U T I N E =======================================


sub_C0B8:
		lea	$4A(a0),a1
		lea	$4A(a1),a2
		bsr.s	sub_C0EA
		bsr.s	sub_C0EA
		move.w	#$80,8(a0)
		move.w	#$100,8(a1)
		move.w	#$180,8(a2)
		bset	#7,$A(a0)
		bclr	#7,$A(a1)
		bclr	#7,$A(a2)
		rts
; End of function sub_C0B8


; =============== S U B R O U T I N E =======================================


sub_C0EA:
		move.w	$14(a0),d0
		cmp.w	$14(a1),d0
		bgt.s	loc_C0F6
		exg	a0,a1

loc_C0F6:
		move.w	$14(a1),d0
		cmp.w	$14(a2),d0
		bgt.s	locret_C102
		exg	a1,a2

locret_C102:
		rts
; End of function sub_C0EA


; =============== S U B R O U T I N E =======================================


sub_C104:

		move.w	#1,($FFFFFFE8).w
		bra.s	loc_C110
; ---------------------------------------------------------------------------

loc_C10C:

		clr.w	($FFFFFFE8).w

loc_C110:
		move.b	#3,($FFFFFE12).w
		move.b	#3,($FFFFFEC6).w
		moveq	#0,d0
		move.b	d0,($FFFFFE2A).w
		move.b	d0,($FFFFFE48).w
		move.w	d0,($FFFFFE20).w
		move.l	d0,($FFFFFE22).w
		move.l	d0,($FFFFFE26).w
		move.w	d0,($FFFFFED0).w
		move.l	d0,($FFFFFED2).w
		move.l	d0,($FFFFFED6).w
		move.b	d0,($FFFFFE18).w
		move.l	#$1388,($FFFFFFC0).w
		move.l	#$1388,($FFFFFFC4).w
		rts
; End of function sub_C104


; =============== S U B R O U T I N E =======================================


SRAM_Load:
		tst.w	($FFFFFFAE).w
		bne.w	locret_C260		; Don't bother if we're playing only Sonic and Knuckles
		clr.w	($FFFFEF56).w	; No interrupt shenanigans needed
		lea	($200011).l,a0
		lea	($2000BD).l,a1
		lea	($FFFFE600).w,a2
		moveq	#$29,d0
		move.w	#$4C44,d1		; RAM integrity value
		jsr	Get_From_SRAM(pc)
		beq.s	loc_C190		; If the data read was successful, branch
		lea	SaveData_GeneralDefault(pc),a0
		lea	($FFFFE600).w,a1
		moveq	#$28,d0

loc_C186:
		move.w	(a0)+,(a1)+		; Reset the general save data to the default
		dbf	d0,loc_C186
		jsr	Write_SaveGeneral2(pc)	; Write default data back to SRAM

loc_C190:
		lea	($200281).l,a0
		lea	($20032D).l,a1
		lea	($FFFFE6AC).w,a2
		moveq	#$29,d0
		move.w	#$4244,d1		; RAM integrity value for save game data
		jsr	Get_From_SRAM(pc)
		bne.s	loc_C1C0		; If the data read was not successful, branch
		lea	($FFFFE6AC).w,a0
		moveq	#7,d0

loc_C1B2:
		tst.b	(a0)
		bpl.w	loc_C256		; If any of the save files are active, then we're done here
		lea	$A(a0),a0
		dbf	d0,loc_C1B2			; if not then we load them up with default data

loc_C1C0:
		lea	SaveData_GameDefault(pc),a0
		lea	($FFFFE6AC).w,a1
		moveq	#$28,d0

loc_C1CA:
		move.w	(a0)+,(a1)+
		dbf	d0,loc_C1CA			; Write default game data
		lea	($200169).l,a0
		lea	($2001F5).l,a1
		lea	($FF0000).l,a2		; Attempt to see if there's any existing S3 save data
		moveq	#$19,d0
		move.w	#$4244,d1
		jsr	Get_From_SRAM(pc)
		bne.s	loc_C252		; If write was not successful, branch
		lea	($FFFFE6AC).w,a0	; If there's valid data from Sonic 3, we'll now go through the process of migrating it to SK
		lea	($FF0000).l,a1
		lea	SaveData_S3LevRef(pc),a2
		moveq	#5,d0

loc_C1FE:
		tst.b	(a1)
		bmi.s	loc_C248		; If not an active save slot, branch
		clr.b	(a0)
		move.b	1(a1),4(a0)		; Special stage ring memory migration
		move.b	7(a1),5(a0)
		move.b	2(a1),d1
		lsl.b	#4,d1
		move.b	d1,2(a0)		; Character ID is stored differently
		moveq	#0,d1
		move.b	3(a1),d1
		move.b	(a2,d1.w),3(a0)	; Current level IDs are changed slightly between S3 and SK and need to be converted
		move.b	4(a1),d1
		or.b	d1,2(a0)		; The last completed special stage was previously its own byte
		move.b	6(a1),d1
		moveq	#0,d2
		moveq	#6,d3

loc_C236:
		lsl.b	#1,d1
		bcc.s	loc_C23E
		ori.w	#1,d2

loc_C23E:
		lsl.w	#2,d2
		dbf	d3,loc_C236
		move.w	d2,6(a0)	; The chaos/super emerald data is interleaved in SK and needs to be converted

loc_C248:
		lea	$A(a0),a0
		addq.w	#8,a1
		dbf	d0,loc_C1FE

loc_C252:
		jsr	Write_SaveGame(pc)

loc_C256:
		clr.w	($FFFFEF4C).w
		move.b	#1,($FFFFEF4B).w

locret_C260:
		rts
; End of function SRAM_Load

; ---------------------------------------------------------------------------
SaveData_GeneralDefault:	dc.w  $8000,	 0, $8000,     0, $8000,     0,	    1,	$200, $8000,	 0, $8000,     0, $8000,     0,	    1,	$200

		dc.w  $8000,	 0, $8000,     0, $8000,     0,	    1,	$200, $8000,	 0, $8000,     0, $8000,     0,	    1,	$200
		dc.w  $8000,	 0, $8000,     0, $8000,     0,	    1,	$200, $4C44
SaveData_GameDefault:	dc.w  $8000,	 0,	0,     0,  $300, $8000,	    0,	   0,	  0,  $300, $8000,     0,     0,     0,	 $300, $8000

		dc.w	  0,	 0,	0,  $300, $8000,     0,	    0,	   0,  $300, $8000,	0,     0,     0,  $300,	$8000,	   0
		dc.w	  0,	 0,  $300, $8000,     0,     0,	    0,	$300, $4244
SaveData_S3LevRef:	dc.b 0
		dc.b 1
		dc.b 2
		dc.b 3
		dc.b 0
		dc.b 4
		dc.b 5
		dc.b 6

; =============== S U B R O U T I N E =======================================


Get_From_SRAM:
					; SRAM_Load+52t ...
		movea.l	a2,a3
		move.w	d0,d2
		bsr.s	Read_SRAM
		beq.s	locret_C31E
		movea.l	a1,a0
		movea.l	a3,a2
		move.w	d2,d0
		bsr.s	Read_SRAM

locret_C31E:
		rts
; End of function Get_From_SRAM


; =============== S U B R O U T I N E =======================================


Read_SRAM:
		tst.w	($FFFFEF56).w
		beq.s	loc_C32A
		move	#$2700,sr		; Disable interrupts if EF56 is set

loc_C32A:
		move.b	#1,($A130F1).l	; Access SRAM
		movea.l	a2,a6
		move.w	d0,d6

loc_C336:
		movep.w	0(a0),d3
		move.w	d3,(a2)+		; Read data from SRAM
		addq.w	#4,a0
		dbf	d0,loc_C336
		move.b	#0,($A130F1).l	; No longer access SRAM
		tst.w	($FFFFEF56).w
		beq.s	loc_C354
		move	#$2300,sr		; Restore interrupts if EF56 is set

loc_C354:
		subq.w	#1,d6
		bsr.s	Create_SRAMChecksum	; Get the checksum of the given data
		cmp.w	(a6),d7		; Compare the result
		bne.s	locret_C360
		cmp.w	-2(a6),d1	; Also compare the data before with the data given in d1

locret_C360:
		rts
; End of function Read_SRAM


; =============== S U B R O U T I N E =======================================


Create_SRAMChecksum:
		moveq	#0,d7

loc_C364:
		move.w	(a6)+,d5
		eor.w	d5,d7
		lsr.w	#1,d7
		bcc.s	loc_C370
		eori.w	#$8810,d7

loc_C370:
		dbf	d6,loc_C364
		rts
; End of function Create_SRAMChecksum


; =============== S U B R O U T I N E =======================================


Write_SRAM:

		movea.l	a2,a6
		move.w	d0,d6
		subq.w	#1,d6
		bsr.s	Create_SRAMChecksum
		move.w	d7,(a6)
		tst.w	($FFFFEF56).w
		beq.s	loc_C38A
		move	#$2700,sr		; If EF56 is set, disable interrupts while saving is occuring

loc_C38A:
		move.b	#1,($A130F1).l	; Send I/O signal to SRAM, mapping it to $200001
		movea.l	a2,a3
		move.w	d0,d1

loc_C396:
		move.w	(a2)+,d2
		movep.w	d2,0(a0)	; Copy data to SRAM
		addq.w	#4,a0
		dbf	d0,loc_C396

loc_C3A2:
		move.w	(a3)+,d2
		movep.w	d2,0(a1)	; Copy data to backup SRAM
		addq.w	#4,a1
		dbf	d1,loc_C3A2
		move.b	#0,($A130F1).l	; Stop SRAM access
		tst.w	($FFFFEF56).w
		beq.s	locret_C3C0
		move	#$2300,sr		; Restore interrupts if EF56 was set

locret_C3C0:
		rts
; End of function Write_SRAM


; =============== S U B R O U T I N E =======================================


Write_SaveGeneral:
		st	($FFFFEF56).w
; End of function Write_SaveGeneral


; =============== S U B R O U T I N E =======================================


Write_SaveGeneral2:
		move.l	a0,-(sp)
		move.w	d7,-(sp)
		lea	($200011).l,a0		; Save general SRAM
		lea	($2000BD).l,a1		; Save general Backup SRAM
		lea	($FFFFE600).w,a2	; Save general RAM
		moveq	#$29,d0
		bsr.s	Write_SRAM
		move.w	(sp)+,d7
		movea.l	(sp)+,a0
		rts
; End of function Write_SaveGeneral2


; =============== S U B R O U T I N E =======================================


Write_SaveGame:

		move.l	a0,-(sp)
		move.w	d7,-(sp)
		lea	($200281).l,a0		; Save game SRAM
		lea	($20032D).l,a1		; Save game backup SRAM
		lea	($FFFFE6AC).w,a2	; Save game RAM
		moveq	#$29,d0
		jsr	Write_SRAM(pc)
		move.w	(sp)+,d7
		movea.l	(sp)+,a0
		rts
; End of function Write_SaveGame

; ---------------------------------------------------------------------------
SaveGame_NextLevel:	dc.b    1,   1,   2,   2,   3,   3,   4,   4,   8,   8,   5,   5,   6,   6,   7,   7,   9,   9,  $A,  $A
		dc.b   $C,  $C,  $D,  $D,  $E,  $E,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0
		dc.b    0,   0,   0,   0,  $A,  $B,  $D,   0

; =============== S U B R O U T I N E =======================================


SaveGame:

		tst.w	($FFFFFFAE).w
		bne.w	loc_C4CC			; If this is SK, saving is disabled
		move.l	($FFFFE660).w,d0
		beq.w	loc_C4CC			; If not playing on a save file, get out
		movea.l	d0,a1
		move.w	($FFFFFE10).w,d0
		ror.b	#1,d0
		lsr.w	#7,d0
		move.b	SaveGame_NextLevel(pc,d0.w),d0
		move.b	(a1),d1
		andi.w	#3,d1
		beq.s	loc_C464
		cmp.b	3(a1),d0		; If game is complete, make it uncomplete if last level is less than the current level
		bcs.s	loc_C4B4		; Think of, say, getting all the super emeralds then going to Doomsday on a completed save file
		andi.b	#-4,(a1)

loc_C464:
		move.b	d0,3(a1)			; Move next level into current level
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_C478
		cmpi.b	#$C,d0
		bcs.s	loc_C4B0
		bra.s	loc_C498		; If playing as Knuckles and level code is Death egg or higher, make it a completed save file
; ---------------------------------------------------------------------------

loc_C478:
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_C488
		cmpi.b	#$D,d0
		bcs.s	loc_C4B0
		bra.s	loc_C498		; If playing as Knuckles and level code is Doomsday or higher, make it a completed save file
; ---------------------------------------------------------------------------

loc_C488:
		cmpi.b	#$D,d0
		bhi.s	loc_C498		; If next level above Doomsday's code, make it a completed save file
		bne.s	loc_C4B0
		cmpi.b	#7,($FFFFFFB0).w	; If next level IS Doomsday but the emeralds aren't collected, make it a completed save file
		bcc.s	loc_C4B0

loc_C498:
		moveq	#1,d0
		cmpi.b	#7,($FFFFFFB0).w
		bcs.s	loc_C4AE		; code 1 is completed without all emeralds
		addq.b	#1,d0
		cmpi.b	#7,($FFFFFFB1).w
		bcs.s	loc_C4AE		; code 2 is completed with all chaos emeralds
		addq.b	#1,d0			; code 3 is completed with all super emeralds

loc_C4AE:
		move.b	d0,(a1)

loc_C4B0:
		clr.w	4(a1)			; Clear the special stage ring collection memory

loc_C4B4:
		move.b	($FFFFFE12).w,d0		; Get number of lives
		cmpi.b	#$63,d0
		bls.s	loc_C4C0
		moveq	#$63,d0

loc_C4C0:
		move.b	d0,8(a1)				; Put number of lives into memory
		move.b	d0,($FFFFFE12).w
		jsr	Write_SaveGame(pc)

loc_C4CC:
		clr.l	($FFFFFF92).w		; Clear special stage ring collection RAM
		rts
; End of function SaveGame


; =============== S U B R O U T I N E =======================================


SaveGame_SpecialStage:

		tst.w	($FFFFFFAE).w
		bne.s	locret_C530			; If playing Sonic and Knuckles, don't bother
		move.l	($FFFFE660).w,d0
		beq.s	locret_C530
		movea.l	d0,a1				; Get address of save slot
		tst.b	($FFFFFFBB).w
		bne.s	loc_C4F8
		andi.b	#-$10,2(a1)
		move.b	($FFFFFE16).w,d0
		andi.b	#$F,d0
		or.b	d0,2(a1)			; Write last played special stage only if Sonic 3 special stages are in effect

loc_C4F8:
		lea	($FFFFFFB2).w,a2
		moveq	#0,d0
		moveq	#6,d1

loc_C500:
		move.b	(a2)+,d2
		andi.b	#3,d2
		or.b	d2,d0
		lsl.w	#2,d0
		dbf	d1,loc_C500
		move.w	d0,6(a1)		; Compress emerald collection RAM and put it into Save Game
		move.w	($FFFFFF94).w,4(a1)	; Special stage entry ring memory is copied as well
		move.b	($FFFFFE18).w,d0
		cmpi.b	#$63,d0
		bls.s	loc_C524
		moveq	#$63,d0

loc_C524:
		move.b	d0,9(a1)		; Save number of continues
		move.b	d0,($FFFFFE18).w
		jmp	Write_SaveGame(pc)
; ---------------------------------------------------------------------------

locret_C530:
		rts
; End of function SaveGame_SpecialStage


; =============== S U B R O U T I N E =======================================


SaveGame_LivesContinues:

		tst.w	($FFFFFFAE).w
		bne.s	locret_C56C		; If playing Sonic and Knuckles, don't bother
		move.l	($FFFFE660).w,d0
		beq.s	locret_C56C
		movea.l	d0,a1
		move.b	($FFFFFE12).w,d0
		cmpi.b	#$63,d0
		bls.s	loc_C54C
		moveq	#$63,d0

loc_C54C:
		move.b	d0,8(a1)		; Save number of lives
		move.b	d0,($FFFFFE12).w
		move.b	($FFFFFE18).w,d0
		cmpi.b	#$63,d0
		bls.s	loc_C560
		moveq	#$63,d0

loc_C560:
		move.b	d0,9(a1)		; Save number of continues
		move.b	d0,($FFFFFE18).w
		jmp	Write_SaveGame(pc)
; ---------------------------------------------------------------------------

locret_C56C:
		rts
; End of function SaveGame_LivesContinues

; ---------------------------------------------------------------------------

locret_C56E:
		rts
; ---------------------------------------------------------------------------

SaveScreen:
		jsr	(Pal_FadeToBlack).l
		move	#$2700,sr
		move.w	($FFFFF60E).w,d0
		andi.b	#$BF,d0
		move.w	d0,($C00004).l
		jsr	(Clear_DisplayData).l
		lea	($C00004).l,a5
		move.w	#$8F01,(a5)
		move.l	#$940F93FF,(a5)
		move.w	#$9780,(a5)
		move.l	#$50000083,(a5)
		move.w	#0,($C00000).l

loc_C5B0:
		move.w	(a5),d1
		btst	#1,d1
		bne.s	loc_C5B0
		move.w	#$8F02,(a5)
		lea	($C00004).l,a6
		move.w	#$8004,(a6)
		move.w	#$8238,(a6)
		move.w	#$8338,(a6)
		move.w	#$8406,(a6)
		move.w	#$8700,(a6)
		move.w	#$8B00,(a6)
		move.w	#$8C81,(a6)
		move.w	#$9003,(a6)
		move.w	#$9280,(a6)
		lea	($FFFFAC00).w,a1
		moveq	#0,d0
		move.w	#$FF,d1

loc_C5F0:
		move.l	d0,(a1)+
		dbf	d1,loc_C5F0
		lea	($FFFFB000).w,a1
		moveq	#0,d0
		move.w	#$7FF,d1

loc_C600:
		move.l	d0,(a1)+
		dbf	d1,loc_C600
		clr.w	($FFFFFB00).w
		move.l	#$FFFFFB00,($FFFFFBFC).w
		clr.w	($FFFFFE04).w
		clr.w	($FFFFEEE2).w
		clr.w	($FFFFEEE4).w
		lea	(MapEni_S3MenuBG).l,a0
		lea	($FFFF0000).l,a1
		move.w	#1,d0
		jsr	(Eni_Decomp).l
		lea	($FFFF0000).l,a1
		move.l	#$60000003,d0
		moveq	#$27,d1
		moveq	#$1B,d2
		jsr	(Plane_Map_To_VRAM).l
		lea	(MapEni_SaveScreen_Layout).l,a0
		lea	($FFFF0000).l,a1
		move.w	#$829F,d0
		jsr	(Eni_Decomp).l
		lea	word_CD58(pc),a0
		jsr	sub_C866(pc)
		move.l	#$6C400002,($C00004).l
		lea	(ArtNem_S22POptions).l,a0
		jsr	(Nem_Decomp).l
		lea	byte_DB1C(pc),a1
		move.w	#$CC06,d0
		jsr	sub_D9F4(pc)
		move.w	#$CC0C,d0
		jsr	sub_D9F4(pc)
		move.w	#$CCEC,d0
		jsr	sub_D9F4(pc)
		lea	(ArtKos_S3MenuBG).l,a0
		lea	($FFFF0000).l,a1
		movea.w	#$20,a2
		jsr	(KosArt_To_VDP).l
		move.l	#locret_C56E,($FFFFEF44).w
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		lea	(ArtKos_SaveScreenMisc).l,a0
		lea	($FFFF0000).l,a1
		movea.w	#$53E0,a2
		jsr	KosArt_To_VDP(pc)
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		lea	(ArtKos_SaveScreen).l,a0
		lea	($FFFF0000).l,a1
		movea.w	#$8A80,a2
		jsr	KosArt_To_VDP(pc)
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		lea	(Pal_SaveMenuBG).l,a0
		lea	($FFFFFC80).w,a1
		moveq	#7,d0

loc_C710:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_C710
		lea	Pal_Save_Chars(pc),a0
		moveq	#$F,d0

loc_C71C:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_C71C
		lea	($FFFFB000).w,a0
		lea	ObjDat_SaveScreen(pc),a1
		moveq	#$B,d0

loc_C72C:
		move.l	(a1)+,(a0)
		move.w	#$829F,$A(a0)
		move.l	#Map_SaveScreen,$C(a0)
		move.w	(a1),$10(a0)
		move.w	(a1)+,$12(a0)
		move.w	(a1)+,$14(a0)
		move.b	(a1)+,$22(a0)
		move.b	(a1)+,$2E(a0)
		move.b	#$40,4(a0)
		lea	$4A(a0),a0
		dbf	d0,loc_C72C
		jsr	(Init_SpriteTable).l
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		lea	($FFFFFC60).w,a0
		lea	($FFFFFCE0).w,a1
		moveq	#7,d0

loc_C77A:
		move.l	(a0),(a1)+
		clr.l	(a0)+
		dbf	d0,loc_C77A
		lea	(ArtKos_SaveScreenS3Zone).l,a0
		lea	($FFFF0000).l,a1
		jsr	(Kos_Decomp).l
		lea	($FFFF2BC0).l,a0
		lea	($FFFF2300).l,a1
		move.w	#$22F,d0

loc_C7A4:
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		dbf	d0,loc_C7A4
		lea	(ArtKos_SaveScreenSKZone).l,a0
		jsr	(Kos_Decomp).l
		lea	(ArtKos_SaveScreenPortrait).l,a0
		jsr	(Kos_Decomp).l
		lea	-$8C0(a1),a0
		move.w	#$14F,d0

loc_C7CC:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_C7CC
		moveq	#$2F,d0
		jsr	(Play_Sound).l
		move.l	#loc_C890,($FFFFEF44).w
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		move.w	($FFFFF60E).w,d0
		ori.b	#$40,d0
		move.w	d0,($C00004).l
		jsr	(Pal_FadeFromBlack).l

loc_C802:
		move.b	#$1E,($FFFFF62A).w
		jsr	(Wait_VSync).l
		addq.w	#1,($FFFFFE04).w
		jsr	(Process_Sprites).l
		move.w	($FFFFEE80).w,d0
		neg.w	d0
		move.w	d0,($FFFFE002).w
		jsr	(Render_Sprites).l
		lea	($FFFFFC42).w,a0
		moveq	#$E,d0
		move.w	($FFFFE666).w,d1
		addq.w	#1,d1
		cmpi.w	#3,d1
		bcs.s	loc_C83C
		moveq	#0,d1

loc_C83C:
		move.w	d1,($FFFFE666).w
		beq.s	loc_C84E
		lea	Pal_Save_Emeralds(pc),a1

loc_C846:
		move.w	(a1)+,(a0)+
		dbf	d0,loc_C846
		bra.s	loc_C856
; ---------------------------------------------------------------------------

loc_C84E:

		move.w	#$EEE,(a0)+
		dbf	d0,loc_C84E

loc_C856:
		cmpi.b	#$4C,($FFFFF600).w
		beq.s	loc_C802
		moveq	#-$51,d0
		jmp	(Play_Sound_2).l

; =============== S U B R O U T I N E =======================================


sub_C866:
		move.w	(a0)+,d7

loc_C868:
		movea.l	(a0)+,a1
		move.w	(a0)+,d0
		bsr.s	sub_C87E
		move.w	(a0)+,d1
		move.w	(a0)+,d2
		jsr	(Plane_Map_To_VRAM_2).l
		dbf	d7,loc_C868
		rts
; End of function sub_C866


; =============== S U B R O U T I N E =======================================


sub_C87E:
		swap	d0
		clr.w	d0
		swap	d0
		lsl.l	#2,d0
		lsr.w	#2,d0
		ori.w	#$4000,d0
		swap	d0
		rts
; End of function sub_C87E

; ---------------------------------------------------------------------------

loc_C890:
		move.w	($FFFFFE04).w,d0
		andi.w	#$C,d0
		lea	(MapPtrs_SaveScreenStatic).l,a2
		movea.l	(a2,d0.w),a2
	if Sonic3_Complete=0
		adda.l	#LockOnROM_Start,a2
	else
		adda.l	#0,a2
	endif
		move.w	#$C21A,d7
		lea	($FFFFE6AC).w,a0
		moveq	#7,d6

loc_C8B2:
		lea	(MapUnc_SaveScreenNEW).l,a1
		tst.b	(a0)
		bmi.s	loc_C8BE
		movea.l	a2,a1

loc_C8BE:
		move.w	d7,d0
		bsr.s	sub_C87E
		moveq	#9,d1
		moveq	#6,d2
		jsr	(Plane_Map_To_VRAM_2).l
		addi.w	#$1A,d7
		lea	$A(a0),a0
		dbf	d6,loc_C8B2
		lea	($FFFFB128).w,a3
		move.w	#$CA20,d7
		lea	($FFFFE6AC).w,a0
		moveq	#7,d3

loc_C8E6:
		move.w	d7,d0
		subq.w	#2,d0
		jsr	sub_C87E(pc)
		move.l	d0,4(a6)
		move.w	#$82B1,(a6)
		lea	byte_DB2B(pc),a1
		tst.b	(a0)
		bmi.s	loc_C946
		lea	byte_DB36(pc),a1
		move.b	$3A(a3),d0
		cmp.b	$37(a3),d0
		bne.s	loc_C912
		tst.b	$3B(a3)
		bne.s	loc_C946

loc_C912:
		lea	byte_DB31(pc),a1
		move.w	d7,d0
		subq.w	#2,d0
		jsr	sub_D9F4(pc)
		move.w	$36(a3),d0
		add.w	d0,d0
		moveq	#0,d1
		move.b	byte_C95E(pc,d0.w),d1
		bpl.s	loc_C932
		move.w	#$8000,d1
		bra.s	loc_C936
; ---------------------------------------------------------------------------

loc_C932:
		addi.w	#$A562,d1

loc_C936:
		move.w	d1,(a6)
		moveq	#0,d1
		move.b	byte_C95F(pc,d0.w),d1
		addi.w	#$A562,d1
		move.w	d1,(a6)
		bra.s	loc_C94C
; ---------------------------------------------------------------------------

loc_C946:

		move.w	d7,d0
		jsr	sub_D9F4(pc)

loc_C94C:
		addi.w	#$1A,d7
		lea	$A(a0),a0
		lea	$4A(a3),a3
		dbf	d3,loc_C8E6
		bra.s	loc_C97A
; ---------------------------------------------------------------------------
byte_C95E:	dc.b $FF
byte_C95F:	dc.b	1, $FF
		dc.b	2, $FF
		dc.b	3, $FF
		dc.b	4, $FF
		dc.b	5, $FF
		dc.b	6, $FF
		dc.b	7, $FF
		dc.b	8, $FF
		dc.b	9,   1
		dc.b	0,   1
		dc.b	1,   1
		dc.b	2,   1
		dc.b	3,   1
		dc.b	4
; ---------------------------------------------------------------------------

loc_C97A:
		lea	word_DA8A(pc),a2
		lea	($FFFFB128).w,a3
		move.w	#$D220,d7
		lea	($FFFFE6AC).w,a0
		moveq	#7,d6

loc_C98C:
		move.w	$34(a3),d0
		bne.s	loc_C994
		moveq	#1,d0

loc_C994:
		tst.b	(a0)
		bpl.s	loc_C99A
		moveq	#0,d0

loc_C99A:
		lsl.w	#5,d0
		movea.l	a2,a1
		adda.w	d0,a1
		move.w	d7,d0
		bsr.w	sub_C87E
		moveq	#2,d1
		moveq	#4,d2
		jsr	(Plane_Map_To_VRAM_2).l
		tst.b	(a0)
		bpl.s	loc_C9CC
		lea	word_DB08(pc),a1
		move.w	d7,d0
		addq.w	#6,d0
		bsr.w	sub_C87E
		moveq	#1,d1
		moveq	#4,d2
		jsr	(Plane_Map_To_VRAM_2).l
		bra.s	loc_CA02
; ---------------------------------------------------------------------------

loc_C9CC:
		move.b	$3E(a3),d0
		jsr	sub_CA14(pc)
		move.w	d7,d0
		addq.w	#6,d0
		bsr.w	sub_C87E
		moveq	#1,d1
		moveq	#1,d2
		jsr	(Plane_Map_To_VRAM_2).l
		move.b	$3F(a3),d0
		jsr	sub_CA14(pc)
		move.w	d7,d0
		addi.w	#$306,d0
		bsr.w	sub_C87E
		moveq	#1,d1
		moveq	#1,d2
		jsr	(Plane_Map_To_VRAM_2).l

loc_CA02:
		addi.w	#$1A,d7
		lea	$A(a0),a0
		lea	$4A(a3),a3
		dbf	d6,loc_C98C
		rts

; =============== S U B R O U T I N E =======================================


sub_CA14:

		moveq	#0,d1

loc_CA16:
		addq.w	#1,d1
		subi.b	#$A,d0
		bcc.s	loc_CA16
		subq.w	#1,d1
		addi.b	#$A,d0
		lea	($FFFFEEEA).w,a1
		lsl.w	#2,d1
		bne.s	loc_CA2E
		moveq	#$28,d1

loc_CA2E:
		move.w	word_CA4C(pc,d1.w),(a1)
		move.w	word_CA4E(pc,d1.w),4(a1)
		andi.w	#$FF,d0
		lsl.w	#2,d0
		move.w	word_CA4C(pc,d0.w),2(a1)
		move.w	word_CA4E(pc,d0.w),6(a1)
		rts
; End of function sub_CA14

; ---------------------------------------------------------------------------
word_CA4C:	dc.w $A49A
word_CA4E:	dc.w $A49B
		dc.w $A49C
		dc.w $A49D
		dc.w $A49E
		dc.w $A49F
		dc.w $A4A0
		dc.w $A4A1
		dc.w $A4A2
		dc.w $A4A3
		dc.w $A4A4
		dc.w $A4A5
		dc.w $A4A6
		dc.w $A4A7
		dc.w $A4A8
		dc.w $A4A9
		dc.w $A4AA
		dc.w $A4AB
		dc.w $A4AC
		dc.w $A4AD
		dc.w $8000
		dc.w $8000
Pal_Save_Chars:	binclude "General\Save Menu\Palettes\Chars.bin"

Pal_Save_Emeralds:	binclude "General\Save Menu\Palettes\Emeralds.bin"

Pal_Save_FinishCard1:	binclude "General\Save Menu\Palettes\Finish Card 1.bin"
Pal_Save_FinishCard2:	binclude "General\Save Menu\Palettes\Finish Card 2.bin"
Pal_Save_FinishCard3:	binclude "General\Save Menu\Palettes\Finish Card 3.bin"

Pal_Save_ZoneCard1:		binclude "General\Save Menu\Palettes\Zone Card 1.bin"
Pal_Save_ZoneCard2:		binclude "General\Save Menu\Palettes\Zone Card 2.bin"
Pal_Save_ZoneCard3:		binclude "General\Save Menu\Palettes\Zone Card 3.bin"
Pal_Save_ZoneCard4:		binclude "General\Save Menu\Palettes\Zone Card 4.bin"
Pal_Save_ZoneCard5:		binclude "General\Save Menu\Palettes\Zone Card 5.bin"
Pal_Save_ZoneCard6:		binclude "General\Save Menu\Palettes\Zone Card 6.bin"
Pal_Save_ZoneCard7:		binclude "General\Save Menu\Palettes\Zone Card 7.bin"
Pal_Save_ZoneCard8:		binclude "General\Save Menu\Palettes\Zone Card 8.bin"
Pal_Save_ZoneCard9:		binclude "General\Save Menu\Palettes\Zone Card 9.bin"
Pal_Save_ZoneCardA:		binclude "General\Save Menu\Palettes\Zone Card A.bin"
Pal_Save_ZoneCardB:		binclude "General\Save Menu\Palettes\Zone Card B.bin"
Pal_Save_ZoneCardC:		binclude "General\Save Menu\Palettes\Zone Card C.bin"
Pal_Save_ZoneCardD:		binclude "General\Save Menu\Palettes\Zone Card D.bin"
Pal_Save_ZoneCardE:		binclude "General\Save Menu\Palettes\Zone Card E.bin"
Pal_Save_ZoneCardF:		binclude "General\Save Menu\Palettes\Zone Card F.bin"
Pal_Save_ZoneCard10:	binclude "General\Save Menu\Palettes\Zone Card 10.bin"
Pal_Save_ZoneCard11:	binclude "General\Save Menu\Palettes\Zone Card 11.bin"
Pal_Save_ZoneCard12:	binclude "General\Save Menu\Palettes\Zone Card 12.bin"

word_CD58:	dc.w $11
		dc.l $FFFF0222
		dc.w $C102
		dc.w $A
		dc.w $B
		dc.l $FFFF0000
		dc.w $C118
		dc.w $C
		dc.w $14
		dc.l $FFFF0000
		dc.w $C132
		dc.w $C
		dc.w $14
		dc.l $FFFF0000
		dc.w $C14C
		dc.w $C
		dc.w $14
		dc.l $FFFF0000
		dc.w $C166
		dc.w $C
		dc.w $14
		dc.l $FFFF0000
		dc.w $C180
		dc.w $C
		dc.w $14
		dc.l $FFFF0000
		dc.w $C19A
		dc.w $C
		dc.w $14
		dc.l $FFFF0104
		dc.w $CE18
		dc.w $C
		dc.w $A
		dc.l $FFFF0104
		dc.w $CE32
		dc.w $C
		dc.w $A
		dc.l $FFFF0104
		dc.w $CE4C
		dc.w $C
		dc.w $A
		dc.l $FFFF0104
		dc.w $CE66
		dc.w $C
		dc.w $A
		dc.l $FFFF0104
		dc.w $CE80
		dc.w $C
		dc.w $A
		dc.l $FFFF0104
		dc.w $CE9A
		dc.w $C
		dc.w $A
		dc.l $FFFF0000
		dc.w $C1B4
		dc.w $C
		dc.w $14
		dc.l $FFFF0000
		dc.w $C1CE
		dc.w $C
		dc.w $14
		dc.l $FFFF0222
		dc.w $C1E8
		dc.w $A
		dc.w $B
		dc.l $FFFF0104
		dc.w $CEB4
		dc.w $C
		dc.w $A
		dc.l $FFFF0104
		dc.w $CECE
		dc.w $C
		dc.w $A
Map_SaveScreen:	include "General\Save Menu\Map - Save Screen General.asm"

ObjDat_SaveScreen:dc.l Draw_Sprite
		dc.w $120
		dc.w $14C
		dc.b 3
		dc.b 0
		dc.l Obj_SaveScreen_D1B6
		dc.w $120
		dc.w $E2
		dc.b 1
		dc.b 0
		dc.l Obj_SaveScreen_D782
		dc.w $448
		dc.w $D8
		dc.b $D
		dc.b 0
		dc.l Obj_SaveScreen_D30C
		dc.w $B0
		dc.w $C8
		dc.b 0
		dc.b 0
		dc.l Obj_SaveScreen_D39E
		dc.w $110
		dc.w $108
		dc.b 0
		dc.b 0
		dc.l Obj_SaveScreen_D39E
		dc.w $178
		dc.w $108
		dc.b 0
		dc.b 1
		dc.l Obj_SaveScreen_D39E
		dc.w $1E0
		dc.w $108
		dc.b 0
		dc.b 2
		dc.l Obj_SaveScreen_D39E
		dc.w $248
		dc.w $108
		dc.b 0
		dc.b 3
		dc.l Obj_SaveScreen_D39E
		dc.w $2B0
		dc.w $108
		dc.b 0
		dc.b 4
		dc.l Obj_SaveScreen_D39E
		dc.w $318
		dc.w $108
		dc.b 0
		dc.b 5
		dc.l Obj_SaveScreen_D39E
		dc.w $380
		dc.w $108
		dc.b 0
		dc.b 6
		dc.l Obj_SaveScreen_D39E
		dc.w $3E8
		dc.w $108
		dc.b 0
		dc.b 7
; ---------------------------------------------------------------------------

Obj_SaveScreen_D1B6:
		move.w	#$A8,d0
		moveq	#0,d1
		moveq	#0,d2
		move.b	($FFFFEF4B).w,d2
		subq.w	#1,d2
		bcs.s	loc_D1E6

loc_D1C6:
		moveq	#$C,d4

loc_D1C8:
		addq.w	#8,d0
		cmpi.w	#$120,d0
		bls.s	loc_D1DE
		subq.w	#8,d0
		addq.w	#8,d1
		cmpi.w	#$2C0,d1
		bls.s	loc_D1DE
		subq.w	#8,d1
		addq.w	#8,d0

loc_D1DE:

		dbf	d4,loc_D1C8
		dbf	d2,loc_D1C6

loc_D1E6:
		move.w	d0,$12(a0)
		move.w	d1,($FFFFEE80).w
		neg.w	d1
		move.w	d1,($FFFFE002).w
		move.l	#loc_D1FA,(a0)

loc_D1FA:
		tst.w	($FFFFEEE4).w
		bne.s	loc_D212
		btst	#4,($FFFFF605).w
		beq.s	loc_D212
		move.b	#4,($FFFFF600).w
		bra.w	loc_D2CE
; ---------------------------------------------------------------------------

loc_D212:

		tst.w	($FFFFEEE2).w
		bne.w	loc_D2CE
		tst.w	$30(a0)
		bne.s	loc_D28A
		moveq	#0,d0
		btst	#2,($FFFFF605).w
		beq.s	loc_D254
		tst.w	($FFFFEEE4).w
		beq.s	loc_D238
		cmpi.b	#1,($FFFFEF4B).w
		beq.s	loc_D254

loc_D238:
		tst.b	($FFFFEF4B).w
		beq.s	loc_D254
		subq.b	#1,($FFFFEF4B).w
		moveq	#-$49,d0
		tst.w	($FFFFEEE4).w
		beq.s	loc_D24C
		moveq	#$7B,d0

loc_D24C:
		jsr	(Play_Sound_2).l
		moveq	#-8,d0

loc_D254:

		btst	#3,($FFFFF605).w
		beq.s	loc_D27A
		cmpi.b	#9,($FFFFEF4B).w
		beq.s	loc_D27A
		addq.b	#1,($FFFFEF4B).w
		moveq	#-$49,d0
		tst.w	($FFFFEEE4).w
		beq.s	loc_D272
		moveq	#$7B,d0

loc_D272:
		jsr	(Play_Sound_2).l
		moveq	#8,d0

loc_D27A:

		move.w	d0,$2E(a0)
		beq.s	loc_D288
		move.w	#$D,$30(a0)
		bra.s	loc_D28A
; ---------------------------------------------------------------------------

loc_D288:
		bra.s	loc_D2CE
; ---------------------------------------------------------------------------

loc_D28A:

		move.w	$12(a0),d0
		move.w	($FFFFEE80).w,d1
		move.w	$2E(a0),d2
		bmi.s	loc_D2B0
		add.w	d2,d0
		cmpi.w	#$120,d0
		bls.s	loc_D2C2
		sub.w	d2,d0
		add.w	d2,d1
		cmpi.w	#$2C0,d1
		bls.s	loc_D2C2
		sub.w	d2,d1
		add.w	d2,d0
		bra.s	loc_D2C2
; ---------------------------------------------------------------------------

loc_D2B0:
		add.w	d2,d0
		cmpi.w	#$120,d0
		bcc.s	loc_D2C2
		sub.w	d2,d0
		add.w	d2,d1
		bpl.s	loc_D2C2
		sub.w	d2,d1
		add.w	d2,d0

loc_D2C2:

		move.w	d0,$12(a0)
		move.w	d1,($FFFFEE80).w
		subq.w	#1,$30(a0)

loc_D2CE:

		moveq	#8,d2
		move.b	($FFFFEF4B).w,d1
		beq.s	loc_D2E0
		neg.w	d2
		cmpi.b	#9,d1
		beq.s	loc_D2E0
		moveq	#0,d2

loc_D2E0:

		add.w	$12(a0),d2
		move.w	d2,$10(a0)
		moveq	#2,d0
		cmpi.w	#$F0,d2
		bcs.s	loc_D2F8
		cmpi.w	#$148,d2
		bhi.s	loc_D2F8
		moveq	#1,d0

loc_D2F8:

		move.b	d0,$22(a0)
		btst	#2,($FFFFFE05).w
		beq.s	locret_D30A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_D30A:
		rts
; ---------------------------------------------------------------------------

Obj_SaveScreen_D30C:
		move.b	#$F,$1D(a0)
		move.w	($FFFFEF4C).w,d0
		addq.w	#4,d0
		move.b	d0,$22(a0)
		tst.b	($FFFFEF4B).w
		bne.s	loc_D396
		move.w	($FFFFB078).w,d0
		or.w	($FFFFEEE4).w,d0
		bne.s	loc_D396
		move.b	($FFFFF605).w,d0
		andi.w	#$E0,d0
		beq.s	loc_D376
		move.b	#$C,($FFFFF600).w
		move.w	($FFFFEF4C).w,($FFFFFF0A).w
		clr.w	($FFFFFE10).w
		clr.w	($FFFFEE4E).w
		clr.w	($FFFFFE16).w
		clr.w	($FFFFFFB0).w
		clr.l	($FFFFFFB2).w
		clr.w	($FFFFFFB6).w
		clr.b	($FFFFFFB8).w
		clr.l	($FFFFFF92).w
		clr.b	($FFFFFFBA).w
		clr.l	($FFFFE660).w
		jsr	(loc_C10C).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_D376:
		move.w	($FFFFEF4C).w,d0
		jsr	sub_D6D0(pc)
		move.w	d0,($FFFFEF4C).w
		addq.w	#4,d0
		move.b	d0,$22(a0)
		move.w	#1,$16(a0)
		btst	#4,($FFFFFE05).w
		bne.s	loc_D39A

loc_D396:

		clr.w	$16(a0)

loc_D39A:
		bra.w	loc_D69E
; ---------------------------------------------------------------------------

Obj_SaveScreen_D39E:

		jsr	(Create_New_Sprite3).l
		bne.s	loc_D3B0
		move.l	#loc_D70C,(a1)
		move.w	a0,$48(a1)

loc_D3B0:
		moveq	#0,d0
		move.b	$2E(a0),d0
		mulu.w	#$A,d0
		addi.l	#$FFFFE6AC,d0
		move.l	d0,$30(a0)
		movea.l	d0,a1
		move.b	2(a1),d0
		lsr.b	#4,d0
		move.b	d0,$35(a0)
		move.b	3(a1),d0
		move.b	d0,$37(a0)
		move.b	d0,$3A(a0)
		move.b	(a1),d0
		andi.b	#3,d0
		move.b	d0,$3B(a0)
		move.w	6(a1),d0
		lea	($FFFFFFB2).w,a2
		jsr	sub_DA1E(pc)
		move.b	d1,$3C(a0)
		move.b	d2,$3D(a0)
		tst.b	9(a1)
		bne.s	loc_D41A
		cmpi.b	#3,8(a1)
		bcc.s	loc_D41A
		move.b	#3,8(a1)
		move.l	a1,-(sp)
		st	($FFFFEF56).w
		jsr	Write_SaveGame(pc)
		movea.l	(sp)+,a1

loc_D41A:

		move.b	8(a1),$3E(a0)
		move.b	9(a1),$3F(a0)
		move.l	#loc_D42C,(a0)

loc_D42C:
		clr.w	$16(a0)
		movea.l	$30(a0),a1
		move.b	($FFFFEF4B).w,d0
		subq.b	#1,d0
		cmp.b	$2E(a0),d0
		beq.s	loc_D458
		move.b	3(a1),$37(a0)
		clr.w	$38(a0)

loc_D44A:

		move.w	$34(a0),d0
		addq.w	#4,d0
		move.b	d0,$22(a0)
		bra.w	loc_D69E
; ---------------------------------------------------------------------------

loc_D458:
		tst.b	(a1)
		bmi.w	loc_D5FE
		move.w	$36(a0),d1
		jsr	sub_D96A(pc)
		move.b	#$17,$23(a0)
		move.w	$36(a0),d1
		cmp.b	$3A(a0),d1
		bne.s	loc_D4A4
		move.b	$3B(a0),d0
		beq.s	loc_D4A4
		addq.b	#1,$23(a0)
		cmpi.b	#1,d0
		beq.s	loc_D496
		addq.b	#1,$23(a0)
		cmpi.b	#2,d0
		beq.s	loc_D496
		addq.b	#2,$23(a0)
		bra.s	loc_D4A4
; ---------------------------------------------------------------------------

loc_D496:

		cmpi.w	#1,$34(a0)
		bls.s	loc_D4A4
		move.b	#$23,$23(a0)

loc_D4A4:

		tst.w	$38(a0)
		bne.s	loc_D4B6
		tst.b	$3B(a0)
		beq.w	loc_D534
		st	$38(a0)

loc_D4B6:
		tst.w	($FFFFB078).w
		bne.s	loc_D44A
		tst.w	($FFFFEEE4).w
		beq.s	loc_D4D0
		clr.b	$1D(a0)
		move.w	#2,$16(a0)
		bra.w	loc_D44A
; ---------------------------------------------------------------------------

loc_D4D0:
		moveq	#$B,d6
		cmpi.w	#3,$34(a0)
		beq.s	loc_D4EE
		moveq	#$C,d6
		cmpi.w	#2,$34(a0)
		beq.s	loc_D4EE
		cmpi.b	#2,$3B(a0)
		bcs.s	loc_D4EE
		moveq	#$D,d6

loc_D4EE:

		moveq	#0,d2
		move.w	$36(a0),d1
		move.b	($FFFFF605).w,d0
		btst	#1,d0
		beq.s	loc_D508
		moveq	#$5B,d2
		subq.w	#1,d1
		bpl.s	loc_D518
		move.w	d6,d1
		bra.s	loc_D518
; ---------------------------------------------------------------------------

loc_D508:
		btst	#0,d0
		beq.s	loc_D518
		moveq	#$5B,d2
		addq.w	#1,d1
		cmp.w	d6,d1
		bls.s	loc_D518
		moveq	#0,d1

loc_D518:

		move.w	d1,$36(a0)
		move.l	d2,d0
		jsr	(Play_Sound_2).l
		move.b	#$1A,$1D(a0)
		btst	#4,($FFFFFE05).w
		beq.s	loc_D53C
		bra.s	loc_D540
; ---------------------------------------------------------------------------

loc_D534:
		tst.w	($FFFFB078).w
		bne.w	loc_D44A

loc_D53C:
		clr.b	$1D(a0)

loc_D540:
		move.w	#2,$16(a0)
		tst.w	($FFFFEEE4).w
		bne.w	loc_D44A
		move.b	($FFFFF605).w,d0
		andi.w	#$E0,d0
		beq.w	loc_D44A
		move.w	4(a1),($FFFFFF94).w
		move.b	3(a1),d0
		tst.b	$3B(a0)
		beq.s	loc_D57A
		move.w	$36(a0),d0
		cmp.b	$3A(a0),d0
		bcc.w	loc_D44A
		clr.l	($FFFFFF92).w

loc_D57A:
		jsr	sub_DA4E(pc)
		move.w	d0,($FFFFFE10).w
		move.w	d0,($FFFFEE4E).w
		moveq	#0,d0
		move.b	2(a1),d0
		lsr.b	#4,d0
		move.w	d0,($FFFFFF0A).w
		move.b	2(a1),d0
		andi.b	#$F,d0
		move.b	d0,($FFFFFE16).w
		move.w	6(a1),d0
		lea	($FFFFFFB2).w,a2
		jsr	sub_DA1E(pc)
		move.b	d1,($FFFFFFB0).w
		move.b	d2,($FFFFFFB1).w
		move.l	a1,($FFFFE660).w
		jsr	(loc_C10C).l
		move.b	8(a1),d0
		beq.s	loc_D5CE
		cmpi.b	#3,d0
		bcc.s	loc_D5DE
		tst.b	9(a1)
		bne.s	loc_D5DE

loc_D5CE:
		move.b	#3,8(a1)
		subq.b	#1,9(a1)
		bcc.s	loc_D5DE
		clr.b	9(a1)

loc_D5DE:

		move.b	8(a1),($FFFFFE12).w
		move.b	9(a1),($FFFFFE18).w
		st	($FFFFEF56).w
		jsr	Write_SaveGame(pc)
		move.b	#$C,($FFFFF600).w
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_D5FE:
		move.b	#$F,$1D(a0)
		clr.b	$23(a0)
		move.w	($FFFFB078).w,d0
		or.w	($FFFFEEE4).w,d0
		bne.w	loc_D44A
		move.b	($FFFFF605).w,d0
		andi.w	#$E0,d0
		beq.s	loc_D67A
		move.b	#$C,($FFFFF600).w
		clr.l	(a1)
		clr.l	4(a1)
		move.w	#$300,8(a1)
		move.w	$34(a0),d0
		move.w	d0,($FFFFFF0A).w
		lsl.b	#4,d0
		move.b	d0,2(a1)
		clr.w	($FFFFFE10).w
		clr.w	($FFFFEE4E).w
		clr.w	($FFFFFE16).w
		clr.w	($FFFFFFB0).w
		clr.l	($FFFFFFB2).w
		clr.w	($FFFFFFB6).w
		clr.b	($FFFFFFB8).w
		clr.l	($FFFFFF92).w
		clr.b	($FFFFFFBA).w
		move.l	a1,($FFFFE660).w
		jsr	(loc_C10C).l
		st	($FFFFEF56).w
		jsr	Write_SaveGame(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_D67A:
		move.w	$34(a0),d0
		jsr	sub_D6D0(pc)
		move.w	d0,$34(a0)
		addq.w	#4,d0
		move.b	d0,$22(a0)
		move.w	#1,$16(a0)
		btst	#4,($FFFFFE05).w
		bne.s	loc_D69E
		clr.w	$16(a0)

loc_D69E:

		move.w	$12(a0),d0
		sub.w	($FFFFEE80).w,d0
		move.w	d0,$10(a0)
		move.w	$14(a0),d1
		move.w	d0,$18(a0)
		move.w	d1,$1A(a0)
		move.w	d0,$1E(a0)
		move.w	d1,$20(a0)
		cmpi.b	#$1A,$1D(a0)
		bne.s	loc_D6CA
		subq.w	#8,$1A(a0)

loc_D6CA:
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_D6D0:

		moveq	#0,d2
		tst.w	($FFFFB07A).w
		bne.s	loc_D6FA
		move.b	($FFFFF605).w,d1
		lsr.w	#1,d1
		bcc.s	loc_D6EE
		moveq	#$5B,d2
		addq.w	#1,d0
		cmpi.w	#3,d0
		bls.s	loc_D6FA
		moveq	#0,d0
		bra.s	loc_D6FA
; ---------------------------------------------------------------------------

loc_D6EE:
		lsr.w	#1,d1
		bcc.s	loc_D6FA
		moveq	#$5B,d2
		subq.w	#1,d0
		bpl.s	loc_D6FA
		moveq	#3,d0

loc_D6FA:
		tst.w	d2
		beq.s	locret_D70A
		move.l	d0,-(sp)
		move.l	d2,d0
		jsr	(Play_Sound_2).l
		move.l	(sp)+,d0

locret_D70A:
		rts
; End of function sub_D6D0

; ---------------------------------------------------------------------------

loc_D70C:
		move.b	#$40,4(a0)
		move.w	#$829F,$A(a0)
		move.l	#Map_SaveScreen,$C(a0)
		move.b	#$40,7(a0)
		move.w	#7,$16(a0)
		movea.w	$48(a0),a1
		movea.l	$30(a1),a2
		move.w	6(a2),d4
		move.w	$10(a1),d0
		move.w	$14(a1),d1
		move.w	d0,$10(a0)
		move.w	d1,$14(a0)
		lea	$18(a0),a1
		moveq	#$10,d2
		moveq	#6,d3

loc_D750:
		clr.b	5(a1)
		moveq	#0,d6
		rol.w	#2,d4
		move.w	d4,d5
		andi.w	#3,d5
		beq.s	loc_D774
		cmpi.w	#3,d5
		bne.s	loc_D768
		moveq	#$C,d6

loc_D768:
		add.b	d2,d6
		move.w	d0,(a1)
		move.w	d1,2(a1)
		move.b	d6,5(a1)

loc_D774:
		addq.w	#1,d2
		addq.w	#6,a1
		dbf	d3,loc_D750
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_SaveScreen_D782:
		moveq	#0,d0
		move.b	5(a0),d0
		jmp	loc_D78C(pc,d0.w)
; ---------------------------------------------------------------------------

loc_D78C:
		bra.w	loc_D7A4
; ---------------------------------------------------------------------------
		bra.w	loc_D7C0
; ---------------------------------------------------------------------------
		bra.w	loc_D7EA
; ---------------------------------------------------------------------------
		bra.w	loc_D884
; ---------------------------------------------------------------------------
		bra.w	loc_D8A4
; ---------------------------------------------------------------------------
		bra.w	loc_D8C4
; ---------------------------------------------------------------------------

loc_D7A4:
		move.b	#$40,4(a0)
		move.b	#$30,7(a0)
		move.w	#1,$16(a0)
		move.b	#8,$1D(a0)
		addq.b	#4,5(a0)

loc_D7C0:
		cmpi.b	#9,($FFFFEF4B).w
		bne.w	loc_D8A0
		move.b	($FFFFF605).w,d0
		andi.w	#$E0,d0
		beq.w	loc_D8A0
		moveq	#$63,d0
		jsr	(Play_Sound_2).l
		st	($FFFFEEE4).w
		addq.b	#4,5(a0)
		bra.w	loc_D8A0
; ---------------------------------------------------------------------------

loc_D7EA:
		jsr	sub_D912(pc)
		jsr	sub_D94A(pc)
		tst.w	($FFFFB078).w
		bne.s	loc_D83C
		move.b	($FFFFF605).w,d0
		btst	#4,d0
		bne.s	loc_D854
		andi.w	#$E0,d0
		beq.s	loc_D83C
		cmpi.b	#9,($FFFFEF4B).w
		beq.s	loc_D854
		moveq	#0,d0
		move.b	($FFFFEF4B).w,d0
		subq.w	#1,d0
		mulu.w	#$A,d0
		addi.l	#$FFFFE6AC,d0
		move.l	d0,$2E(a0)
		movea.l	d0,a1
		tst.b	(a1)
		bmi.s	loc_D854
		moveq	#$63,d0
		jsr	(Play_Sound_2).l
		st	($FFFFEEE2).w
		addq.b	#8,5(a0)

loc_D83C:

		move.w	($FFFFB05A).w,d0
		move.w	d0,$10(a0)
		move.w	d0,$18(a0)
		move.w	$14(a0),$1A(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_D854:

		clr.b	$24(a0)
		clr.b	$23(a0)
		clr.b	$25(a0)
		clr.b	$28(a0)
		move.b	#$D,$22(a0)
		move.b	#8,$1D(a0)
		move.w	($FFFFB05A).w,d0
		add.w	($FFFFEE80).w,d0
		move.w	d0,$12(a0)
		addq.b	#4,5(a0)
		bra.w	loc_D69E
; ---------------------------------------------------------------------------

loc_D884:
		clr.w	($FFFFEEE4).w
		move.w	$12(a0),d0
		cmpi.w	#$448,d0
		bcs.s	loc_D89A
		move.b	#4,5(a0)
		bra.s	loc_D8A0
; ---------------------------------------------------------------------------

loc_D89A:
		addq.w	#8,d0
		move.w	d0,$12(a0)

loc_D8A0:

		bra.w	loc_D69E
; ---------------------------------------------------------------------------

loc_D8A4:
		jsr	sub_D912(pc)
		jsr	sub_D94A(pc)
		cmpi.b	#$B,$1D(a0)
		bne.s	loc_D8BE
		move.b	#$C,$1D(a0)
		addq.b	#4,5(a0)

loc_D8BE:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_D8C4:
		jsr	sub_D912(pc)
		btst	#3,($FFFFF605).w
		bne.s	loc_D8FE
		btst	#2,($FFFFF605).w
		beq.s	loc_D90C
		moveq	#$68,d0
		jsr	(Play_Sound_2).l
		movea.l	$2E(a0),a1
		move.w	#$8000,(a1)
		clr.l	2(a1)
		clr.w	6(a1)
		move.w	#$300,8(a1)
		st	($FFFFEF56).w
		jsr	Write_SaveGame(pc)

loc_D8FE:
		move.b	#8,5(a0)
		clr.w	($FFFFEEE2).w
		bra.w	loc_D854
; ---------------------------------------------------------------------------

loc_D90C:
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_D912:

		subq.b	#1,$24(a0)
		bpl.s	locret_D938
		move.b	#5,$24(a0)

loc_D91E:
		moveq	#0,d0
		move.b	$23(a0),d0
		addq.b	#1,$23(a0)
		move.b	byte_D93A(pc,d0.w),d0
		bpl.s	loc_D934
		clr.b	$23(a0)
		bra.s	loc_D91E
; ---------------------------------------------------------------------------

loc_D934:
		move.b	d0,$22(a0)

locret_D938:
		rts
; End of function sub_D912

; ---------------------------------------------------------------------------
byte_D93A:	dc.b   $D,  $E,	 $D,  $E,  $D,	$E,  $D,  $E,  $D,  $E,	 $D,  $D,  $D,	$D, $FF,   0

; =============== S U B R O U T I N E =======================================


sub_D94A:

		subq.b	#1,$25(a0)
		bpl.s	locret_D968
		move.b	#3,$25(a0)
		addq.b	#1,$28(a0)
		move.b	$28(a0),d0
		andi.b	#3,d0
		addq.b	#8,d0
		move.b	d0,$1D(a0)

locret_D968:
		rts
; End of function sub_D94A


; =============== S U B R O U T I N E =======================================


sub_D96A:
		cmp.b	$3A(a0),d1
		bne.s	loc_D9A2
		tst.b	$3B(a0)
		beq.s	loc_D9A2
		cmpi.w	#1,$34(a0)
		bls.s	loc_D9C8
		cmpi.b	#3,$3B(a0)
		beq.s	loc_D9C8
		moveq	#$E,d1
		cmpi.w	#3,$34(a0)
		beq.s	loc_D992
		addq.w	#2,d1

loc_D992:
		cmpi.b	#1,$3B(a0)
		beq.s	loc_D99C
		addq.w	#1,d1

loc_D99C:
		move.w	#$A380,d2
		bra.s	loc_D9A6
; ---------------------------------------------------------------------------

loc_D9A2:
		move.w	#$B740,d2

loc_D9A6:
		move.l	a1,-(sp)
		move.w	d1,-(sp)
		mulu.w	#$8C0,d1
		addi.l	#$FFFF0000,d1
		move.w	#$460,d3
		jsr	(Add_To_DMA_Queue).l
		move.w	(sp)+,d0
		movea.l	(sp)+,a1
		lea	Pal_Save_ZoneCard1(pc),a2
		bra.s	loc_D9E2
; ---------------------------------------------------------------------------

loc_D9C8:
		lea	Pal_Save_FinishCard1(pc),a2
		moveq	#0,d0
		cmpi.b	#1,$3B(a0)
		beq.s	loc_D9E2
		addq.w	#1,d0
		cmpi.b	#2,$3B(a0)
		beq.s	loc_D9E2
		addq.w	#1,d0

loc_D9E2:
		lsl.w	#5,d0
		adda.w	d0,a2
		lea	($FFFFFC60).w,a3
		moveq	#7,d0

loc_D9EC:
		move.l	(a2)+,(a3)+
		dbf	d0,loc_D9EC
		rts
; End of function sub_D96A


; =============== S U B R O U T I N E =======================================


sub_D9F4:

		lea	($C00000).l,a6
		jsr	sub_C87E(pc)
		move.l	d0,4(a6)
		move.w	#$A552,d5
		moveq	#0,d6

loc_DA08:
		move.b	(a1)+,d6
		bne.s	loc_DA12
		move.w	#$8000,(a6)
		bra.s	loc_DA08
; ---------------------------------------------------------------------------

loc_DA12:
		bmi.s	locret_DA1C
		move.w	d5,d4
		add.w	d6,d4
		move.w	d4,(a6)
		bra.s	loc_DA08
; ---------------------------------------------------------------------------

locret_DA1C:
		rts
; End of function sub_D9F4


; =============== S U B R O U T I N E =======================================


sub_DA1E:

		clr.b	($FFFFFFBA).w
		moveq	#0,d1
		moveq	#0,d2
		moveq	#6,d3

loc_DA28:
		rol.w	#2,d0
		move.w	d0,d4
		andi.w	#3,d4
		move.b	d4,(a2)+
		beq.s	loc_DA3E
		addq.w	#1,d1
		cmpi.w	#3,d4
		bne.s	loc_DA3E
		addq.w	#1,d2

loc_DA3E:
		cmpi.w	#2,d4
		bcs.s	loc_DA48
		st	($FFFFFFBA).w

loc_DA48:
		dbf	d3,loc_DA28
		rts
; End of function sub_DA1E


; =============== S U B R O U T I N E =======================================


sub_DA4E:
		cmpi.w	#3,$34(a0)
		bne.s	loc_DA62
		cmpi.b	#$B,d0
		bne.s	loc_DA62
		move.w	#$A01,d0
		bra.s	locret_DA6C
; ---------------------------------------------------------------------------

loc_DA62:
		andi.w	#$F,d0
		add.w	d0,d0
		move.w	LevelList_DA6E(pc,d0.w),d0

locret_DA6C:
		rts
; End of function sub_DA4E

; ---------------------------------------------------------------------------
LevelList_DA6E:	dc.w 0
		dc.w $100
		dc.w $200
		dc.w $300
		dc.w $500
		dc.w $600
		dc.w $700
		dc.w $400
		dc.w $800
		dc.w $900
		dc.w $1601
		dc.w $A00
		dc.w $B00
		dc.w $C00
word_DA8A:	dc.w $8000
		dc.w $8000
		dc.w $8000
		dc.w $8000
		dc.w $8000
		dc.w $8000
		dc.w $8000
		dc.w $8000
		dc.w $8000
		dc.w $8000
		dc.w $8000
		dc.w $8000
		dc.w $8000
		dc.w $8000
		dc.w $8000
		dc.w 0
		dc.w $A4C2
		dc.w $A4C4
		dc.w $A4AE
		dc.w $A4C3
		dc.w $A4C5
		dc.w $A4AF
		dc.w $A4B0
		dc.w $A4B3
		dc.w $A000
		dc.w $A4B1
		dc.w $A4B4
		dc.w $A4AE
		dc.w $A4B2
		dc.w $A4B5
		dc.w $A4AF
		dc.w 0
		dc.w $A4C6
		dc.w $A4C8
		dc.w $A4AE
		dc.w $A4C7
		dc.w $A4C9
		dc.w $A4AF
		dc.w $A4B6
		dc.w $A4B9
		dc.w $A000
		dc.w $A4B7
		dc.w $A4BA
		dc.w $A4AE
		dc.w $A4B8
		dc.w $A4BB
		dc.w $A4AF
		dc.w 0
		dc.w $A4CA
		dc.w $A4CC
		dc.w $A4AE
		dc.w $A4CB
		dc.w $A4CD
		dc.w $A4AF
		dc.w $A4BC
		dc.w $A4BF
		dc.w $A000
		dc.w $A4BD
		dc.w $A4C0
		dc.w $A4AE
		dc.w $A4BE
		dc.w $A4C1
		dc.w $A4AF
word_DB08:	dc.w $8000
		dc.w $8000
		dc.w $8000
		dc.w $8000
		dc.w $8000
		dc.w $8000
		dc.w $8000
		dc.w $8000
		dc.w $8000
		dc.w $8000
byte_DB1C:	dc.b  $2B, $2C,	$FF, $30, $1E, $33, $22, $FF, $21, $22,	$29, $22, $31, $22, $FF

byte_DB2B:	dc.b	0,   0,	  0,   0,   0, $FF
byte_DB31:	dc.b  $37, $2C,	$2B, $22, $FF
byte_DB36:	dc.b  $20, $29,	$22, $1E, $2F, $FF

; =============== S U B R O U T I N E =======================================


sub_DB3C:
		tst.w	($FFFFFFDA).w
		bne.s	sub_DB44
		rts
; End of function sub_DB3C


; =============== S U B R O U T I N E =======================================


sub_DB44:
					; Render_Sprites+1Ep
		cmpi.b	#$16,($FFFFFE10).w
		bcc.s	loc_DB68
		cmpi.b	#$13,($FFFFFE10).w
		bcs.s	loc_DB68
		moveq	#8,d4
		btst	#3,($FFFFFE05).w
		bne.s	loc_DB84
		tst.w	($FFFFFE20).w
		bne.s	loc_DB84
		addq.w	#2,d4
		bra.s	loc_DB84
; ---------------------------------------------------------------------------

loc_DB68:
		moveq	#0,d4
		btst	#3,($FFFFFE05).w
		bne.s	loc_DB84
		tst.w	($FFFFFE20).w
		bne.s	loc_DB7A
		addq.w	#2,d4

loc_DB7A:
		cmpi.b	#9,($FFFFFE23).w
		bne.s	loc_DB84
		addq.w	#4,d4

loc_DB84:
		move.b	($FFFFF711).w,d0
		ext.w	d0
		bpl.s	loc_DB92
		addq.w	#8,d0
		move.b	d0,($FFFFF711).w

loc_DB92:
		addi.w	#$8F,d0
		move.w	#$108,d1
		move.w	#$86CA,d5
		lea	off_DBB6(pc),a1
		adda.w	(a1,d4.w),a1
		move.w	(a1)+,d4
		subq.w	#1,d4
		bmi.s	locret_DBB2
		jmp	(sub_1AF6C).l
; ---------------------------------------------------------------------------

locret_DBB2:
		rts
; End of function sub_DB44


; =============== S U B R O U T I N E =======================================


nullsub_2:
		rts
; End of function nullsub_2

; ---------------------------------------------------------------------------
off_DBB6:	dc.w word_DBC2-off_DBB6

		dc.w word_DC00-off_DBB6
		dc.w word_DC32-off_DBB6
		dc.w word_DC6A-off_DBB6
		dc.w word_DC96-off_DBB6
		dc.w word_DCB6-off_DBB6
word_DBC2:	dc.w $A
		dc.b $80
		dc.b $D
		dc.w $2000
		dc.w 0
		dc.b $80
		dc.b $D
		dc.w $2018
		dc.w $20
		dc.b $80
		dc.b $D
		dc.w $2020
		dc.w $40
		dc.b $90
		dc.b $D
		dc.w $2010
		dc.w 0
		dc.b $90
		dc.b $D
		dc.w $2028
		dc.w $28
		dc.b $A0
		dc.b $D
		dc.w $2008
		dc.w 0
		dc.b $A0
		dc.b 1
		dc.w $2000
		dc.w $20
		dc.b $A0
		dc.b 9
		dc.w $2030
		dc.w $30
		dc.b $40
		dc.b 5
		dc.w $10A
		dc.w 0
		dc.b $40
		dc.b $D
		dc.w $210E
		dc.w $10
word_DC00:	dc.w 8
		dc.b $80
		dc.b $D
		dc.w $2000
		dc.w 0
		dc.b $80
		dc.b $D
		dc.w $2018
		dc.w $20
		dc.b $80
		dc.b $D
		dc.w $2020
		dc.w $40
		dc.b $90
		dc.b $D
		dc.w $2010
		dc.w 0
		dc.b $90
		dc.b $D
		dc.w $2028
		dc.w $28
		dc.b $A0
		dc.b 9
		dc.w $2030
		dc.w $30
		dc.b $40
		dc.b 5
		dc.w $10A
		dc.w 0
		dc.b $40
		dc.b $D
		dc.w $210E
		dc.w $10
word_DC32:	dc.w 9
		dc.b $80
		dc.b $D
		dc.w $2000
		dc.w 0
		dc.b $80
		dc.b $D
		dc.w $2018
		dc.w $20
		dc.b $80
		dc.b $D
		dc.w $2020
		dc.w $40
		dc.b $90
		dc.b $D
		dc.w $2028
		dc.w $28
		dc.b $A0
		dc.b $D
		dc.w $2008
		dc.w 0
		dc.b $A0
		dc.b 1
		dc.w $2000
		dc.w $20
		dc.b $A0
		dc.b 9
		dc.w $2030
		dc.w $30
		dc.b $40
		dc.b 5
		dc.w $10A
		dc.w 0
		dc.b $40
		dc.b $D
		dc.w $210E
		dc.w $10
word_DC6A:	dc.w 7
		dc.b $80
		dc.b $D
		dc.w $2000
		dc.w 0
		dc.b $80
		dc.b $D
		dc.w $2018
		dc.w $20
		dc.b $80
		dc.b $D
		dc.w $2020
		dc.w $40
		dc.b $90
		dc.b $D
		dc.w $2028
		dc.w $28
		dc.b $A0
		dc.b 9
		dc.w $2030
		dc.w $30
		dc.b $40
		dc.b 5
		dc.w $10A
		dc.w 0
		dc.b $40
		dc.b $D
		dc.w $210E
		dc.w $10
word_DC96:	dc.w 5
		dc.b $80
		dc.b $D
		dc.w $2008
		dc.w 0
		dc.b $80
		dc.b 1
		dc.w $2000
		dc.w $20
		dc.b $80
		dc.b 9
		dc.w $2030
		dc.w $30
		dc.b $40
		dc.b 5
		dc.w $10A
		dc.w 0
		dc.b $40
		dc.b $D
		dc.w $210E
		dc.w $10
word_DCB6:	dc.w 3
		dc.b $80
		dc.b 9
		dc.w $2030
		dc.w $30
		dc.b $40
		dc.b 5
		dc.w $10A
		dc.w 0
		dc.b $40
		dc.b $D
		dc.w $210E
		dc.w $10

; =============== S U B R O U T I N E =======================================


HUD_AddToScore:

		move.b	#1,($FFFFFE1F).w
		lea	($FFFFFE26).w,a3
		add.l	d0,(a3)				; Add to score
		move.l	#$F423F,d1			; 9999990 maximum points
		cmp.l	(a3),d1
		bhi.s	loc_DCE2
		move.l	d1,(a3)

loc_DCE2:
		move.l	(a3),d0
		cmp.l	($FFFFFFC0).w,d0	; If score is greater than next 50000 point increment
		bcs.s	locret_DD04
		addi.l	#$1388,($FFFFFFC0).w
		addq.b	#1,($FFFFFE12).w	; Give an additional extra life
		addq.b	#1,($FFFFFE1C).w
		move.w	#$2A,d0				; Play the 1up song
		jmp	(Play_Sound).l
; ---------------------------------------------------------------------------

locret_DD04:
		rts
; End of function HUD_AddToScore


; =============== S U B R O U T I N E =======================================


UpdateHUD:
		nop
		lea	($C00000).l,a6
		tst.w	($FFFFFFE8).w
		bne.w	loc_DE7E
		tst.w	($FFFFFE08).w
		bne.w	loc_DDF4
		tst.b	($FFFFFE1F).w
		beq.s	loc_DD36
		clr.b	($FFFFFE1F).w
		move.l	#$5C800003,d0
		move.l	($FFFFFE26).w,d1
		bsr.w	DrawSixDigitNumber

loc_DD36:
		tst.b	($FFFFFE1D).w
		beq.s	loc_DD56
		bpl.s	loc_DD42
		bsr.w	HUD_LoadZero

loc_DD42:
		clr.b	($FFFFFE1D).w
		move.l	#$5F400003,d0
		moveq	#0,d1
		move.w	($FFFFFE20).w,d1
		bsr.w	DrawThreeDigitNumber

loc_DD56:
		tst.b	($FFFFFE1E).w
		bpl.s	loc_DD64
		move.b	#1,($FFFFFE1E).w
		bra.s	loc_DD9E
; ---------------------------------------------------------------------------

loc_DD64:
		beq.s	loc_DDBE
		tst.w	($FFFFF63A).w
		bne.s	loc_DDBE
		lea	($FFFFFE22).w,a1
		cmpi.l	#$93B3B,(a1)+
		beq.w	UpdateHUD_TimeOver
		addq.b	#1,-(a1)
		cmpi.b	#60,(a1)
		bcs.s	loc_DDBE
		move.b	#0,(a1)
		addq.b	#1,-(a1)
		cmpi.b	#60,(a1)
		bcs.s	loc_DD9E
		move.b	#0,(a1)
		addq.b	#1,-(a1)
		cmpi.b	#9,(a1)
		bcs.s	loc_DD9E
		move.b	#9,(a1)

loc_DD9E:
		move.l	#$5E400003,d0
		moveq	#0,d1
		move.b	($FFFFFE23).w,d1
		bsr.w	DrawSingleDigitNumber
		move.l	#$5EC00003,d0
		moveq	#0,d1
		move.b	($FFFFFE24).w,d1
		bsr.w	DrawTwoDigitNumber

loc_DDBE:
		tst.b	($FFFFFE1C).w
		beq.s	locret_DDCC
		clr.b	($FFFFFE1C).w
		bsr.w	HUD_Lives

locret_DDCC:
		rts
; ---------------------------------------------------------------------------

UpdateHUD_TimeOver:
		clr.b	($FFFFFE1E).w
		lea	($FFFFB000).w,a0
		cmpi.b	#6,5(a0)
		bcc.s	loc_DDEC
		cmpi.b	#$15,($FFFFFE10).w
		beq.s	loc_DDEC
		movea.l	a0,a2
		bsr.w	Kill_Character

loc_DDEC:
		move.b	#1,($FFFFFE1A).w
		rts
; ---------------------------------------------------------------------------

loc_DDF4:
		bsr.w	sub_DEFC
		tst.b	($FFFFFE1D).w
		beq.s	loc_DE18
		bpl.s	loc_DE04
		bsr.w	HUD_LoadZero

loc_DE04:
		clr.b	($FFFFFE1D).w
		move.l	#$5F400003,d0
		moveq	#0,d1
		move.w	($FFFFFE20).w,d1
		bsr.w	DrawThreeDigitNumber

loc_DE18:
		move.l	#$5E400003,d0
		moveq	#0,d1
		move.w	($FFFFF628).w,d1
		bsr.w	DrawSingleDigitNumber
		move.l	#$5EC00003,d0
		moveq	#0,d1
		move.b	($FFFFF62C).w,d1
		bsr.w	DrawTwoDigitNumber
		tst.b	($FFFFFE1C).w
		beq.s	loc_DE46
		clr.b	($FFFFFE1C).w
		bsr.w	HUD_Lives

loc_DE46:
		tst.w	($FFFFF63A).w
		bne.s	locret_DE7C
		lea	($FFFFFE22).w,a1
		cmpi.l	#$93B3B,(a1)+
		nop
		addq.b	#1,-(a1)
		cmpi.b	#$3C,(a1)
		bcs.s	locret_DE7C
		move.b	#0,(a1)
		addq.b	#1,-(a1)
		cmpi.b	#$3C,(a1)
		bcs.s	locret_DE7C
		move.b	#0,(a1)
		addq.b	#1,-(a1)
		cmpi.b	#9,(a1)
		bcs.s	locret_DE7C
		move.b	#9,(a1)

locret_DE7C:
		rts
; ---------------------------------------------------------------------------

loc_DE7E:
		tst.w	($FFFFFFDA).w
		bne.w	sub_DEFC
		rts
; End of function UpdateHUD


; =============== S U B R O U T I N E =======================================


HUD_LoadZero:
		move.l	#$5F400003,($C00004).l
		lea	byte_DEF8(pc),a2
		move.w	#2,d2
		bra.s	loc_DEBE
; End of function HUD_LoadZero


; =============== S U B R O U T I N E =======================================


sub_DE9C:
		lea	($C00000).l,a6
		bsr.w	HUD_Lives
		tst.w	($FFFFFFE8).w
		bne.s	locret_DEEA
		move.l	#$5C400003,($C00004).l
		lea	byte_DEEC(pc),a2
		move.w	#$E,d2

loc_DEBE:
		lea	byte_E18A(pc),a1

loc_DEC2:
		move.w	#$F,d1
		move.b	(a2)+,d0
		bmi.s	loc_DEDE
		ext.w	d0
		lsl.w	#5,d0
		lea	(a1,d0.w),a3

loc_DED2:
		move.l	(a3)+,(a6)
		dbf	d1,loc_DED2

loc_DED8:
		dbf	d2,loc_DEC2
		rts
; ---------------------------------------------------------------------------

loc_DEDE:
		move.l	#0,(a6)
		dbf	d1,loc_DEDE
		bra.s	loc_DED8
; ---------------------------------------------------------------------------

locret_DEEA:
		rts
; End of function sub_DE9C

; ---------------------------------------------------------------------------
byte_DEEC:	dc.b $16		;
		dc.b $FF
		dc.b $FF
		dc.b $FF
		dc.b $FF
		dc.b $FF
		dc.b $FF
		dc.b 0
		dc.b 0
		dc.b $14
		dc.b 0
		dc.b 0
byte_DEF8:	dc.b $FF
		dc.b $FF
		dc.b 0
		dc.b 0

; =============== S U B R O U T I N E =======================================


sub_DEFC:
		move.l	#$5C400003,($C00004).l
		move.w	($FFFFEE78).w,d1
		swap	d1
		move.w	($FFFFB010).w,d1
		bsr.s	sub_DF1C
		move.w	($FFFFEE7C).w,d1
		swap	d1
		move.w	($FFFFB014).w,d1
; End of function sub_DEFC


; =============== S U B R O U T I N E =======================================


sub_DF1C:
		moveq	#7,d6
		lea	(byte_E5CA).l,a1

loc_DF24:
		rol.w	#4,d1
		move.w	d1,d2
		andi.w	#$F,d2
		cmpi.w	#$A,d2
		bcs.s	loc_DF36
		addi.w	#7,d2

loc_DF36:
		lsl.w	#5,d2
		lea	(a1,d2.w),a3
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		swap	d1
		dbf	d6,loc_DF24
		rts
; End of function sub_DF1C

; ---------------------------------------------------------------------------
		lea	($FFFF8000).w,a1
		move.w	($FFFFB010).w,d3
		move.w	($FFFFB014).w,d2
		move.w	d2,d0
		lsr.w	#5,d0
		and.w	($FFFFEEAE).w,d0
		move.w	8(a1,d0.w),d0
		move.w	d3,d1
		lsr.w	#3,d1
		move.w	d1,d4
		lsr.w	#4,d1
		add.w	d1,d0
		moveq	#-1,d1
		clr.w	d1
		movea.w	d0,a1
		move.b	(a1),d1
		rts

; =============== S U B R O U T I N E =======================================


DrawThreeDigitNumber:
					; UpdateHUD+10Ep
		lea	(dword_E04C).l,a2
		moveq	#2,d6
		bra.s	loc_DF92
; End of function DrawThreeDigitNumber


; =============== S U B R O U T I N E =======================================


DrawSixDigitNumber:
		lea	(dword_E040).l,a2
		moveq	#5,d6

loc_DF92:
		moveq	#0,d4
		lea	byte_E18A(pc),a1

loc_DF98:
		moveq	#0,d2
		move.l	(a2)+,d3

loc_DF9C:
		sub.l	d3,d1
		bcs.s	loc_DFA4
		addq.w	#1,d2
		bra.s	loc_DF9C
; ---------------------------------------------------------------------------

loc_DFA4:
		add.l	d3,d1
		tst.w	d2
		beq.s	loc_DFAE
		move.w	#1,d4

loc_DFAE:
		tst.w	d4
		beq.s	loc_DFDC
		lsl.w	#6,d2
		move.l	d0,4(a6)
		lea	(a1,d2.w),a3
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)

loc_DFDC:
		addi.l	#$400000,d0
		dbf	d6,loc_DF98
		rts
; End of function DrawSixDigitNumber

; ---------------------------------------------------------------------------
		move.l	#$5F800003,($C00004).l
		lea	($C00000).l,a6
		lea	(dword_E050).l,a2
		moveq	#1,d6
		moveq	#0,d4
		lea	byte_E18A(pc),a1

loc_E006:
		moveq	#0,d2
		move.l	(a2)+,d3

loc_E00A:
		sub.l	d3,d1
		bcs.s	loc_E012
		addq.w	#1,d2
		bra.s	loc_E00A
; ---------------------------------------------------------------------------

loc_E012:
		add.l	d3,d1
		lsl.w	#6,d2
		lea	(a1,d2.w),a3
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		dbf	d6,loc_E006
		rts
; ---------------------------------------------------------------------------
dword_E040:	dc.l $186A0
		dc.l $2710
dword_E048:	dc.l $3E8
dword_E04C:	dc.l $64
dword_E050:	dc.l $A
dword_E054:	dc.l 1

; =============== S U B R O U T I N E =======================================


DrawSingleDigitNumber:
					; UpdateHUD+11Ep
		lea	(dword_E054).l,a2
		moveq	#0,d6
		bra.s	loc_E06A
; End of function DrawSingleDigitNumber


; =============== S U B R O U T I N E =======================================


DrawTwoDigitNumber:
					; UpdateHUD+12Ep
		lea	(dword_E050).l,a2
		moveq	#1,d6

loc_E06A:
		moveq	#0,d4
		lea	byte_E18A(pc),a1

loc_E070:
		moveq	#0,d2
		move.l	(a2)+,d3

loc_E074:
		sub.l	d3,d1
		bcs.s	loc_E07C
		addq.w	#1,d2
		bra.s	loc_E074
; ---------------------------------------------------------------------------

loc_E07C:
		add.l	d3,d1
		tst.w	d2
		beq.s	loc_E086
		move.w	#1,d4

loc_E086:
		lsl.w	#6,d2
		move.l	d0,4(a6)
		lea	(a1,d2.w),a3
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		addi.l	#$400000,d0
		dbf	d6,loc_E070
		rts
; End of function DrawTwoDigitNumber

; ---------------------------------------------------------------------------
		lea	(dword_E048).l,a2
		moveq	#3,d6
		moveq	#0,d4
		lea	byte_E18A(pc),a1

loc_E0CA:
		moveq	#0,d2
		move.l	(a2)+,d3

loc_E0CE:
		sub.l	d3,d1
		bcs.s	loc_E0D6
		addq.w	#1,d2
		bra.s	loc_E0CE
; ---------------------------------------------------------------------------

loc_E0D6:
		add.l	d3,d1
		tst.w	d2
		beq.s	loc_E0E0
		move.w	#1,d4

loc_E0E0:
		tst.w	d4
		beq.s	loc_E110
		lsl.w	#6,d2
		lea	(a1,d2.w),a3
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)

loc_E10A:
		dbf	d6,loc_E0CA
		rts
; ---------------------------------------------------------------------------

loc_E110:
		moveq	#$F,d5

loc_E112:
		move.l	#0,(a6)
		dbf	d5,loc_E112
		bra.s	loc_E10A

; =============== S U B R O U T I N E =======================================


HUD_Lives:
					; UpdateHUD+13Cp ...
		move.l	#$7BA00003,d0
		moveq	#0,d1
		move.b	($FFFFFE12).w,d1
		lea	(dword_E050).l,a2
		moveq	#1,d6
		moveq	#0,d4
		lea	byte_E48A(pc),a1

loc_E138:
		move.l	d0,4(a6)
		moveq	#0,d2
		move.l	(a2)+,d3

loc_E140:
		sub.l	d3,d1
		bcs.s	loc_E148
		addq.w	#1,d2
		bra.s	loc_E140
; ---------------------------------------------------------------------------

loc_E148:
		add.l	d3,d1
		tst.w	d2
		beq.s	loc_E152
		move.w	#1,d4

loc_E152:
		tst.w	d4
		beq.s	loc_E178

loc_E156:
		lsl.w	#5,d2
		lea	(a1,d2.w),a3
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)
		move.l	(a3)+,(a6)

loc_E16C:
		addi.l	#$400000,d0
		dbf	d6,loc_E138
		rts
; ---------------------------------------------------------------------------

loc_E178:
		tst.w	d6
		beq.s	loc_E156
		moveq	#7,d5

loc_E17E:
		move.l	#0,(a6)
		dbf	d5,loc_E17E
		bra.s	loc_E16C
; End of function HUD_Lives

; ---------------------------------------------------------------------------
byte_E18A:	dc.b    0,   0,   0,   0,   1, $11, $1F,   0, $11, $11, $11, $F0, $11, $FF, $11, $F0, $11, $F0, $11, $F0
		dc.b  $11, $F0, $11, $F0, $11, $F0, $11, $F0, $11, $F0, $11, $F0, $11, $F0, $11, $F0, $11, $11, $11, $F0
		dc.b    1, $11, $1F,   0,  $F, $FF, $F0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0
		dc.b    0,   0,   0,   0,   0,   0,   0,   0,   0, $11, $F0,   0,   1, $11, $F0,   0,   0, $11, $F0,   0
		dc.b    0, $11, $F0,   0,   0, $11, $F0,   0,   0, $11, $F0,   0,   0, $11, $F0,   0,   0, $11, $F0,   0
		dc.b    0, $11, $F0,   0,   0, $11, $F0,   0,   0, $FF, $F0,   0,   0,   0,   0,   0,   0,   0,   0,   0
		dc.b    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1, $11, $1F,   0, $11, $11, $11, $F0
		dc.b  $11, $FF, $11, $F0, $FF, $F1, $11, $F0,   0, $11, $1F,   0,   1, $11, $F0,   0, $11, $1F,   0,   0
		dc.b  $11, $1F,   0,   0, $11, $11, $11, $F0, $11, $11, $11, $F0, $FF, $FF, $FF, $F0,   0,   0,   0,   0
		dc.b    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1, $11, $1F,   0
		dc.b  $11, $11, $11, $F0, $11, $FF, $11, $F0, $FF, $F0, $11, $F0,   0, $11, $1F,   0,   0, $11, $1F,   0
		dc.b    0, $FF, $11, $F0, $11, $F0, $11, $F0, $11, $11, $11, $F0,   1, $11, $1F,   0,  $F, $FF, $F0,   0
		dc.b    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0
		dc.b    0,   1, $1F,   0,   0, $11, $1F,   0,   1, $11, $1F,   0,   1, $11, $1F,   0, $11, $F1, $1F,   0
		dc.b  $11, $F1, $1F,   0, $11, $11, $11, $F0, $11, $11, $11, $F0, $FF, $F1, $1F, $F0,   0,   1, $1F,   0
		dc.b    0,  $F, $FF,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0
		dc.b    0,   0,   0,   0, $11, $11, $11, $F0, $11, $11, $11, $F0, $11, $FF, $FF, $F0, $11, $F0,   0,   0
		dc.b  $11, $11, $1F,   0, $11, $11, $11, $F0, $FF, $FF, $11, $F0, $11, $F0, $11, $F0, $11, $11, $11, $F0
		dc.b  $F1, $11, $1F,   0,  $F, $FF, $F0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0
		dc.b    0,   0,   0,   0,   0,   0,   0,   0,   1, $11, $1F,   0, $11, $11, $11, $F0, $11, $FF, $11, $F0
		dc.b  $11, $F0, $FF, $F0, $11, $11, $1F,   0, $11, $11, $11, $F0, $11, $FF, $11, $F0, $11, $F0, $11, $F0
		dc.b  $11, $11, $11, $F0,   1, $11, $1F,   0,  $F, $FF, $F0,   0,   0,   0,   0,   0,   0,   0,   0,   0
		dc.b    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, $11, $11, $11, $F0, $11, $11, $11, $F0
		dc.b  $FF, $FF, $11, $F0,   0,   1, $1F,   0,   0,   1, $1F,   0,   0, $11, $F0,   0,   0, $11, $F0,   0
		dc.b    0, $11, $F0,   0,   0, $11, $F0,   0,   0, $11, $F0,   0,   0, $FF, $F0,   0,   0,   0,   0,   0
		dc.b    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1, $11, $1F,   0
		dc.b  $11, $11, $11, $F0, $11, $FF, $11, $F0, $11, $F0, $11, $F0,   1, $11, $1F,   0,   1, $11, $1F,   0
		dc.b  $11, $FF, $11, $F0, $11, $F0, $11, $F0, $11, $11, $11, $F0,   1, $11, $1F,   0,  $F, $FF, $F0,   0
		dc.b    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0
		dc.b    1, $11, $1F,   0, $11, $11, $11, $F0, $11, $FF, $11, $F0, $11, $F0, $11, $F0, $11, $11, $11, $F0
		dc.b    1, $11, $11, $F0,  $F, $FF, $11, $F0, $11, $F0, $11, $F0, $11, $11, $11, $F0,   1, $11, $1F,   0
		dc.b   $F, $FF, $F0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0
		dc.b    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, $11, $F0,   0,   0, $11, $F0,   0
		dc.b    0, $FF, $F0,   0,   0,   0,   0,   0,   0, $11, $F0,   0,   0, $11, $F0,   0,   0, $FF, $F0,   0
		dc.b    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0
		dc.b    0,   0,   0,   0,   0,   0,   0,   0, $55, $55, $55, $E0, $55, $55, $55, $E0, $55, $EE, $EE, $E0
		dc.b  $55, $E0,   0,   0, $11, $11, $1E,   0, $11, $11, $1E,   0, $55, $EE, $EE,   0, $55, $E0,   0,   0
		dc.b  $55, $55, $55, $E0, $55, $55, $55, $E0, $EE, $EE, $EE, $E0,   0,   0,   0,   0,   0,   0,   0,   0
		dc.b    0,   0,   0,   0,   0,   0,   0,   0
byte_E48A:	dc.b    0,   0,   0,   0,   0, $CC, $CC, $F0,   1, $1F, $F1, $1F,   1, $1F,   1, $1F,   1, $1F,   1, $1F
		dc.b    1, $1F,   1, $1F,   0, $CC, $CC, $F0,   0, $FF, $FF,   0,   0,   0,   0,   0,   0,  $C, $CF,   0
		dc.b    0, $11, $1F,   0,   0, $F1, $1F,   0,   0,   1, $1F,   0,   0,   1, $1F,   0,   0,  $C, $CF,   0
		dc.b    0,  $F, $FF,   0,   0,   0,   0,   0,   0, $CC, $CC, $F0,   0, $FF, $F1, $1F,   0,   0, $11, $FF
		dc.b    0,   1, $1F, $F0,   0, $11, $FF, $F0,  $C, $CC, $CC, $CF,  $F, $FF, $FF, $FF,   0,   0,   0,   0
		dc.b    0, $CC, $CC, $F0,   0, $FF, $F1, $1F,   0,   1, $11, $F0,   0,  $F, $F1, $1F,   1, $1F,   1, $1F
		dc.b    0, $CC, $CC, $F0,   0, $FF, $FF,   0,   0,   0,   0,   0,   0,   0, $CC, $F0,   0,   1, $11, $F0
		dc.b    0, $1F, $11, $F0,   1, $1F, $11, $F0,   1, $11, $11, $1F,  $F, $FF, $CC, $FF,   0,   0, $FF, $F0
		dc.b    0,   0,   0,   0,  $C, $CC, $CC, $CF,   1, $1F, $FF, $FF,   1, $11, $11, $F0,  $F, $FF, $F1, $1F
		dc.b    1, $1F,   1, $1F,   0, $CC, $CC, $F0,   0, $FF, $FF,   0,   0,   0,   0,   0,   0, $CC, $CC, $F0
		dc.b    1, $1F, $FF, $F0,   1, $11, $11, $F0,   1, $1F, $F1, $1F,   1, $1F,   1, $1F,   0, $CC, $CC, $F0
		dc.b    0, $FF, $FF,   0,   0,   0,   0,   0,  $C, $CC, $CC, $CF,  $F, $FF, $F1, $1F,   0,   0, $11, $F0
		dc.b    0,   1, $1F,   0,   0, $11, $F0,   0,   0, $CC, $F0,   0,   0, $FF, $F0,   0,   0,   0,   0,   0
		dc.b    0, $CC, $CC, $F0,   1, $1F, $F1, $1F,   0, $11, $11, $F0,   1, $1F, $F1, $1F,   1, $1F,   1, $1F
		dc.b    0, $CC, $CC, $F0,   0, $FF, $FF,   0,   0,   0,   0,   0,   0, $CC, $CC, $F0,   1, $1F, $F1, $1F
		dc.b    1, $1F,   1, $1F,   0, $11, $11, $1F,   0, $FF, $F1, $1F,   0, $CC, $CC, $F0,   0, $FF, $FF,   0
byte_E5CA:	dc.b  $FF, $11, $1F, $FF, $F1, $FF, $11, $FF, $11, $FF, $F1, $1F, $11, $FF, $F1, $1F, $11, $FF, $F1, $1F
		dc.b  $F1, $1F, $F1, $FF, $FF, $11, $1F, $FF, $FF, $FF, $FF, $FF, $FF, $F1, $1F, $FF, $FF, $11, $1F, $FF
		dc.b  $FF, $F1, $1F, $FF, $FF, $F1, $1F, $FF, $FF, $F1, $1F, $FF, $FF, $F1, $1F, $FF, $F1, $11, $11, $1F
		dc.b  $FF, $FF, $FF, $FF, $F1, $11, $11, $FF, $11, $FF, $F1, $1F, $FF, $FF, $11, $1F, $FF, $11, $11, $FF
		dc.b  $F1, $11, $1F, $FF, $11, $1F, $FF, $FF, $11, $11, $11, $1F, $FF, $FF, $FF, $FF, $F1, $11, $11, $1F
		dc.b  $FF, $FF, $11, $FF, $FF, $F1, $1F, $FF, $FF, $11, $11, $FF, $FF, $FF, $F1, $1F, $11, $FF, $F1, $1F
		dc.b  $F1, $11, $11, $FF, $FF, $FF, $FF, $FF, $FF, $F1, $11, $FF, $FF, $11, $11, $FF, $F1, $1F, $11, $FF
		dc.b  $11, $FF, $11, $FF, $11, $11, $11, $1F, $FF, $FF, $11, $FF, $FF, $FF, $11, $FF, $FF, $FF, $FF, $FF
		dc.b  $11, $11, $11, $FF, $11, $FF, $FF, $FF, $11, $11, $11, $FF, $FF, $FF, $F1, $1F, $FF, $FF, $F1, $1F
		dc.b  $11, $FF, $F1, $1F, $F1, $11, $11, $FF, $FF, $FF, $FF, $FF, $FF, $11, $11, $FF, $F1, $1F, $FF, $FF
		dc.b  $11, $FF, $FF, $FF, $11, $11, $11, $FF, $11, $FF, $F1, $1F, $11, $FF, $F1, $1F, $F1, $11, $11, $FF
		dc.b  $FF, $FF, $FF, $FF, $11, $11, $11, $1F, $11, $FF, $F1, $1F, $FF, $FF, $11, $FF, $FF, $F1, $1F, $FF
		dc.b  $FF, $11, $FF, $FF, $FF, $11, $FF, $FF, $FF, $11, $FF, $FF, $FF, $FF, $FF, $FF, $F1, $11, $1F, $FF
		dc.b  $11, $FF, $F1, $FF, $11, $1F, $F1, $FF, $F1, $11, $1F, $FF, $1F, $F1, $11, $1F, $1F, $FF, $F1, $1F
		dc.b  $F1, $11, $11, $FF, $FF, $FF, $FF, $FF, $F1, $11, $11, $FF, $11, $FF, $F1, $1F, $11, $FF, $F1, $1F
		dc.b  $F1, $11, $11, $1F, $FF, $FF, $F1, $1F, $FF, $FF, $11, $FF, $F1, $11, $1F, $FF, $FF, $FF, $FF, $FF
		dc.b  $FF, $F1, $1F, $FF, $FF, $11, $11, $1F, $F1, $1F, $FF, $FF, $FF, $11, $11, $FF, $FF, $FF, $F1, $1F
		dc.b  $F1, $11, $11, $FF, $FF, $F1, $1F, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF
		dc.b  $FF, $FF, $FF, $FF, $F1, $11, $11, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF
		dc.b  $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $F1, $11, $11, $FF, $FF, $FF, $FF, $FF
		dc.b  $F1, $11, $11, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF
		dc.b  $FF, $FF, $1F, $FF, $FF, $FF, $11, $FF, $F1, $11, $11, $1F, $F1, $11, $11, $1F, $FF, $FF, $11, $FF
		dc.b  $FF, $FF, $1F, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $1F, $FF, $FF, $FF, $11, $FF
		dc.b  $F1, $11, $11, $1F, $F1, $11, $11, $1F, $FF, $FF, $11, $FF, $FF, $FF, $1F, $FF, $FF, $FF, $FF, $FF
		dc.b  $F1, $1F, $F1, $1F, $F1, $1F, $F1, $1F, $F1, $1F, $F1, $1F, $FF, $11, $11, $FF, $FF, $F1, $1F, $FF
		dc.b  $FF, $F1, $1F, $FF, $FF, $F1, $1F, $FF, $FF, $FF, $FF, $FF, $11, $11, $11, $1F, $FF, $FF, $11, $1F
		dc.b  $FF, $F1, $11, $FF, $FF, $11, $1F, $FF, $F1, $11, $FF, $FF, $11, $1F, $FF, $FF, $11, $11, $11, $1F
		dc.b  $FF, $FF, $FF, $FF, $FF, $11, $1F, $FF, $F1, $1F, $11, $FF, $11, $FF, $F1, $1F, $11, $FF, $F1, $1F
		dc.b  $11, $11, $11, $1F, $11, $FF, $F1, $1F, $11, $FF, $F1, $1F, $FF, $FF, $FF, $FF, $11, $11, $11, $FF
		dc.b  $11, $FF, $F1, $1F, $11, $FF, $F1, $1F, $11, $11, $11, $FF, $11, $FF, $F1, $1F, $11, $FF, $F1, $1F
		dc.b  $11, $11, $11, $FF, $FF, $FF, $FF, $FF, $FF, $11, $11, $FF, $F1, $1F, $F1, $1F, $11, $FF, $FF, $FF
		dc.b  $11, $FF, $FF, $FF, $11, $FF, $FF, $FF, $F1, $1F, $F1, $1F, $FF, $11, $11, $FF, $FF, $FF, $FF, $FF
		dc.b  $11, $11, $1F, $FF, $11, $FF, $11, $FF, $11, $FF, $F1, $1F, $11, $FF, $F1, $1F, $11, $FF, $F1, $1F
		dc.b  $11, $FF, $11, $FF, $11, $11, $1F, $FF, $FF, $FF, $FF, $FF, $11, $11, $11, $1F, $11, $FF, $FF, $FF
		dc.b  $11, $FF, $FF, $FF, $11, $11, $1F, $FF, $11, $FF, $FF, $FF, $11, $FF, $FF, $FF, $11, $11, $11, $1F
		dc.b  $FF, $FF, $FF, $FF, $11, $11, $11, $1F, $11, $FF, $FF, $FF, $11, $FF, $FF, $FF, $11, $11, $1F, $FF
		dc.b  $11, $FF, $FF, $FF, $11, $FF, $FF, $FF, $11, $FF, $FF, $FF, $FF, $FF, $FF, $FF

; =============== S U B R O U T I N E =======================================


Load_Rings:

		moveq	#0,d0
		move.b	($FFFFF710).w,d0
		move.w	off_E8B8(pc,d0.w),d0
		jmp	off_E8B8(pc,d0.w)
; End of function Load_Rings

; ---------------------------------------------------------------------------
off_E8B8:	dc.w loc_E8BE-off_E8B8

		dc.w loc_E942-off_E8B8
		dc.w loc_E9CA-off_E8B8
; ---------------------------------------------------------------------------

loc_E8BE:
		addq.b	#2,($FFFFF710).w
		bsr.w	sub_EB1A
		cmpi.b	#$14,($FFFFFE10).w
		beq.s	loc_E904
		movea.l	($FFFFEE42).w,a1
		lea	($FFFFE700).w,a2
		move.w	($FFFFEE78).w,d4
		subq.w	#8,d4
		bhi.s	loc_E8E6
		moveq	#1,d4
		bra.s	loc_E8E6
; ---------------------------------------------------------------------------

loc_E8E2:
		addq.w	#4,a1
		addq.w	#2,a2

loc_E8E6:

		cmp.w	(a1),d4
		bhi.s	loc_E8E2
		move.l	a1,($FFFFEE42).w
		move.w	a2,($FFFFEE4A).w
		addi.w	#$150,d4
		bra.s	loc_E8FA
; ---------------------------------------------------------------------------

loc_E8F8:
		addq.w	#4,a1

loc_E8FA:
		cmp.w	(a1),d4
		bhi.s	loc_E8F8
		move.l	a1,($FFFFEE46).w
		rts
; ---------------------------------------------------------------------------

loc_E904:
		addq.b	#2,($FFFFF710).w
		movea.l	($FFFFEE42).w,a1
		lea	($FFFF8600).w,a2
		move.w	($FFFFEE7C).w,d4
		subq.w	#8,d4
		bhi.s	loc_E920
		moveq	#1,d4
		bra.s	loc_E920
; ---------------------------------------------------------------------------

loc_E91C:
		addq.w	#4,a1
		addq.w	#2,a2

loc_E920:

		cmp.w	2(a1),d4
		bhi.s	loc_E91C
		move.l	a1,($FFFFEE42).w
		move.w	a2,($FFFFEE4A).w
		addi.w	#$F0,d4
		bra.s	loc_E936
; ---------------------------------------------------------------------------

loc_E934:
		addq.w	#4,a1

loc_E936:
		cmp.w	2(a1),d4
		bhi.s	loc_E934
		move.l	a1,($FFFFEE46).w
		rts
; ---------------------------------------------------------------------------

loc_E942:
		bsr.s	sub_E994
		movea.l	($FFFFEE42).w,a1
		movea.w	($FFFFEE4A).w,a2
		move.w	($FFFFEE78).w,d4
		subq.w	#8,d4
		bhi.s	loc_E95C
		moveq	#1,d4
		bra.s	loc_E95C
; ---------------------------------------------------------------------------

loc_E958:
		addq.w	#4,a1
		addq.w	#2,a2

loc_E95C:

		cmp.w	(a1),d4
		bhi.s	loc_E958
		bra.s	loc_E966
; ---------------------------------------------------------------------------

loc_E962:
		subq.w	#4,a1
		subq.w	#2,a2

loc_E966:
		cmp.w	-4(a1),d4
		bls.s	loc_E962
		move.l	a1,($FFFFEE42).w
		move.w	a2,($FFFFEE4A).w
		movea.l	($FFFFEE46).w,a2
		addi.w	#$150,d4
		bra.s	loc_E980
; ---------------------------------------------------------------------------

loc_E97E:
		addq.w	#4,a2

loc_E980:
		cmp.w	(a2),d4
		bhi.s	loc_E97E
		bra.s	loc_E988
; ---------------------------------------------------------------------------

loc_E986:
		subq.w	#4,a2

loc_E988:
		cmp.w	-4(a2),d4
		bls.s	loc_E986
		move.l	a2,($FFFFEE46).w
		rts

; =============== S U B R O U T I N E =======================================


sub_E994:

		lea	($FFFFEF80).w,a2
		move.w	(a2)+,d1
		subq.w	#1,d1
		bcs.s	locret_E9C8

loc_E99E:
		move.w	(a2)+,d0
		beq.s	loc_E99E
		movea.w	d0,a1
		subq.b	#1,(a1)
		bne.s	loc_E9C4
		move.b	#6,(a1)
		addq.b	#1,1(a1)
		cmpi.b	#8,1(a1)
		bne.s	loc_E9C4
		move.w	#-1,(a1)
		clr.w	-2(a2)
		subq.w	#1,($FFFFEF80).w

loc_E9C4:
		dbf	d1,loc_E99E

locret_E9C8:
		rts
; End of function sub_E994

; ---------------------------------------------------------------------------

loc_E9CA:
		bsr.s	sub_E994
		movea.l	($FFFFEE42).w,a1
		movea.w	($FFFFEE4A).w,a2
		move.w	($FFFFEE7C).w,d4
		subq.w	#8,d4
		bhi.s	loc_E9E4
		moveq	#1,d4
		bra.s	loc_E9E4
; ---------------------------------------------------------------------------

loc_E9E0:
		addq.w	#4,a1
		addq.w	#2,a2

loc_E9E4:

		cmp.w	2(a1),d4
		bhi.s	loc_E9E0
		bra.s	loc_E9F0
; ---------------------------------------------------------------------------

loc_E9EC:
		subq.w	#4,a1
		subq.w	#2,a2

loc_E9F0:
		cmp.w	-2(a1),d4
		bls.s	loc_E9EC
		move.l	a1,($FFFFEE42).w
		move.w	a2,($FFFFEE4A).w
		movea.l	($FFFFEE46).w,a2
		addi.w	#$F0,d4
		bra.s	loc_EA0A
; ---------------------------------------------------------------------------

loc_EA08:
		addq.w	#4,a2

loc_EA0A:
		cmp.w	2(a2),d4
		bhi.s	loc_EA08
		bra.s	loc_EA14
; ---------------------------------------------------------------------------

loc_EA12:
		subq.w	#4,a2

loc_EA14:
		cmp.w	-2(a2),d4
		bls.s	loc_EA12
		move.l	a2,($FFFFEE46).w
		rts

; =============== S U B R O U T I N E =======================================


Test_Ring_Collisions:
		cmpi.b	#$5A,$34(a0)
		bcc.w	locret_EAE4
		movea.l	($FFFFEE42).w,a1
		movea.l	($FFFFEE46).w,a2
		cmpa.l	a1,a2
		beq.w	locret_EAE4
		movea.w	($FFFFEE4A).w,a4
		btst	#5,$2B(a0)
		beq.s	Test_Ring_Collisions_NoAttraction
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		subi.w	#$40,d2
		subi.w	#$40,d3
		move.w	#6,d1
		move.w	#$C,d6
		move.w	#$80,d4
		move.w	#$80,d5
		bra.s	Test_Ring_Collisions_NextRing
; ---------------------------------------------------------------------------

Test_Ring_Collisions_NoAttraction:
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		subi.w	#8,d2
		moveq	#0,d5
		move.b	$1E(a0),d5
		subq.b	#3,d5
		sub.w	d5,d3
		move.w	#6,d1
		move.w	#$C,d6
		move.w	#$10,d4
		add.w	d5,d5

Test_Ring_Collisions_NextRing:
					; Test_Ring_Collisions+C0j
		tst.w	(a4)
		bne.w	loc_EADA
		move.w	(a1),d0
		sub.w	d1,d0
		sub.w	d2,d0
		bcc.s	loc_EAA0
		add.w	d6,d0
		bcs.s	loc_EAA6
		bra.w	loc_EADA
; ---------------------------------------------------------------------------

loc_EAA0:
		cmp.w	d4,d0
		bhi.w	loc_EADA

loc_EAA6:
		move.w	2(a1),d0
		sub.w	d1,d0
		sub.w	d3,d0
		bcc.s	loc_EAB8
		add.w	d6,d0
		bcs.s	loc_EABE
		bra.w	loc_EADA
; ---------------------------------------------------------------------------

loc_EAB8:
		cmp.w	d5,d0
		bhi.w	loc_EADA

loc_EABE:
		btst	#5,$2B(a0)
		bne.s	Test_Ring_Collisions_AttractRing

loc_EAC6:
		move.w	#$604,(a4)
		bsr.s	sub_EAE6
		lea	($FFFFEF82).w,a3

loc_EAD0:
		tst.w	(a3)+
		bne.s	loc_EAD0
		move.w	a4,-(a3)
		addq.w	#1,($FFFFEF80).w

loc_EADA:
					; Test_Ring_Collisions+7Cj ...
		addq.w	#4,a1
		addq.w	#2,a4
		cmpa.l	a1,a2
		bne.w	Test_Ring_Collisions_NextRing

locret_EAE4:
					; Test_Ring_Collisions+14j
		rts
; End of function Test_Ring_Collisions


; =============== S U B R O U T I N E =======================================


sub_EAE6:
		subq.w	#1,($FFFFFF04).w
		jmp	(GiveRing).l
; End of function sub_EAE6

; ---------------------------------------------------------------------------

Test_Ring_Collisions_AttractRing:
		movea.l	a1,a3
		jsr	(Create_New_Sprite).l
		bne.w	loc_EB16
		move.l	#Obj_Attracted_Ring,(a1)
		move.w	(a3),$10(a1)
		move.w	2(a3),$14(a1)
		move.w	a4,$30(a1)
		move.w	#-1,(a4)
		rts
; ---------------------------------------------------------------------------

loc_EB16:
		movea.l	a3,a1
		bra.s	loc_EAC6

; =============== S U B R O U T I N E =======================================


sub_EB1A:
		moveq	#0,d0
		tst.b	($FFFFFF97).w
		bne.s	loc_EB30
		lea	($FFFFE700).w,a1
		move.w	#$FF,d1

loc_EB2A:
		move.l	d0,(a1)+
		dbf	d1,loc_EB2A

loc_EB30:
		lea	($FFFFEF80).w,a1
		moveq	#$1F,d1

loc_EB36:
		move.l	d0,(a1)+
		dbf	d1,loc_EB36
		cmpi.b	#$14,($FFFFFE10).w
		bne.s	loc_EB52
		lea	($FFFF8600).w,a1
		move.w	#$FF,d1

loc_EB4C:
		move.l	d0,(a1)+
		dbf	d1,loc_EB4C

loc_EB52:
		move.w	($FFFFFE10).w,d0
		ror.b	#1,d0
		lsr.w	#5,d0
		lea	(RingLocPtrs).l,a1
		movea.l	(a1,d0.w),a1
		move.l	a1,($FFFFEE42).w
		addq.w	#4,a1
		moveq	#0,d5
		move.w	#$1FE,d0

loc_EB70:
		tst.l	(a1)+
		bmi.s	loc_EB7A
		addq.w	#1,d5
		dbf	d0,loc_EB70

loc_EB7A:
		move.w	d5,($FFFFFF04).w
		move.w	#0,($FFFFFF06).w
		rts
; End of function sub_EB1A


; =============== S U B R O U T I N E =======================================


sub_EB86:
		movea.l	($FFFFEE42).w,a0
		move.l	($FFFFEE46).w,d2
		sub.l	a0,d2
		beq.s	locret_EBEC
		movea.w	($FFFFEE4A).w,a4
		lea	word_EBEE(pc),a1
		move.w	4(a3),d4
		move.w	#$F0,d5
		move.w	($FFFFEEAA).w,d3

loc_EBA6:
		tst.w	(a4)+
		bmi.s	loc_EBE6
		move.w	2(a0),d1
		sub.w	d4,d1
		addq.w	#8,d1
		and.w	d3,d1
		cmp.w	d5,d1
		bcc.s	loc_EBE6
		addi.w	#$78,d1
		move.w	(a0),d0
		sub.w	(a3),d0
		addi.w	#$80,d0
		move.b	-1(a4),d6
		bne.s	loc_EBCE
		move.b	($FFFFFEB3).w,d6

loc_EBCE:
		lsl.w	#3,d6
		lea	(a1,d6.w),a2
		add.w	(a2)+,d1
		move.w	d1,(a6)+
		move.w	(a2)+,d6
		move.b	d6,(a6)
		addq.w	#2,a6
		move.w	(a2)+,(a6)+
		add.w	(a2)+,d0
		move.w	d0,(a6)+
		subq.w	#1,d7

loc_EBE6:
		addq.w	#4,a0
		subq.w	#4,d2
		bne.s	loc_EBA6

locret_EBEC:
		rts
; End of function sub_EB86

; ---------------------------------------------------------------------------
word_EBEE:	dc.w  $FFF8,	 5
		dc.w  $26BC, $FFF8
		dc.w  $FFF8,	 5
		dc.w  $26C0, $FFF8
		dc.w  $FFF8,	 1
		dc.w  $26C4, $FFFC
		dc.w  $FFF8,	 5
		dc.w  $2EC0, $FFF8
		dc.w  $FFF8,	 5
		dc.w  $26C6, $FFF8
		dc.w  $FFF8,	 5
		dc.w  $3EC6, $FFF8
		dc.w  $FFF8,	 5
		dc.w  $2EC6, $FFF8
		dc.w  $FFF8,	 5
		dc.w  $36C6, $FFF8

; =============== S U B R O U T I N E =======================================


Player_AnglePos:

		move.l	($FFFFF7B4).w,($FFFFF796).w
		cmpi.b	#$C,$46(a0)
		beq.s	loc_EC42
		move.l	($FFFFF7B8).w,($FFFFF796).w

loc_EC42:
		move.b	$46(a0),d5
		btst	#3,$2A(a0)
		beq.s	loc_EC5A
		moveq	#0,d0
		move.b	d0,($FFFFF768).w
		move.b	d0,($FFFFF76A).w
		rts
; ---------------------------------------------------------------------------

loc_EC5A:
		moveq	#3,d0
		move.b	d0,($FFFFF768).w
		move.b	d0,($FFFFF76A).w
		move.b	$26(a0),d0
		addi.b	#$20,d0
		bpl.s	loc_EC7C
		move.b	$26(a0),d0
		bpl.s	loc_EC76
		subq.b	#1,d0

loc_EC76:
		addi.b	#$20,d0
		bra.s	loc_EC88
; ---------------------------------------------------------------------------

loc_EC7C:
		move.b	$26(a0),d0
		bpl.s	loc_EC84
		addq.b	#1,d0

loc_EC84:
		addi.b	#$1F,d0

loc_EC88:
		andi.b	#$C0,d0
		cmpi.b	#$40,d0
		beq.w	Player_WalkVertL
		cmpi.b	#$80,d0
		beq.w	Player_WalkCeiling
		cmpi.b	#$C0,d0
		beq.w	Player_WalkVertR
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1E(a0),d0
		ext.w	d0
		add.w	d0,d2
		move.b	$1F(a0),d0
		ext.w	d0
		add.w	d0,d3
		lea	($FFFFF768).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindFloor
		move.w	d1,-(sp)
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1E(a0),d0
		ext.w	d0
		add.w	d0,d2
		move.b	$1F(a0),d0
		ext.w	d0
		neg.w	d0
		add.w	d0,d3
		lea	($FFFFF76A).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindFloor
		move.w	(sp)+,d0
		bsr.w	Player_Angle
		tst.w	d1
		beq.s	locret_ED12
		bpl.s	loc_ED14
		cmpi.w	#-$E,d1
		blt.s	locret_ED12
		add.w	d1,$14(a0)

locret_ED12:
					; Player_AnglePos+DEj
		rts
; ---------------------------------------------------------------------------

loc_ED14:
		tst.b	$3C(a0)
		bne.s	loc_ED32
		move.b	$18(a0),d0
		bpl.s	loc_ED22
		neg.b	d0

loc_ED22:
		addq.b	#4,d0
		cmpi.b	#$E,d0
		bcs.s	loc_ED2E
		move.b	#$E,d0

loc_ED2E:
		cmp.b	d0,d1
		bgt.s	loc_ED38

loc_ED32:
		add.w	d1,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_ED38:
		bset	#1,$2A(a0)
		bclr	#5,$2A(a0)
		move.b	#1,$21(a0)
		rts
; End of function Player_AnglePos


; =============== S U B R O U T I N E =======================================


Player_Angle:

		move.w	d0,d3
		move.b	($FFFFF76A).w,d2
		cmp.w	d0,d1
		ble.s	loc_ED5E
		move.b	($FFFFF768).w,d2
		move.w	d1,d3
		move.w	d0,d1

loc_ED5E:
		btst	#0,d2
		bne.s	loc_ED7A
		move.b	d2,d0
		sub.b	$26(a0),d0
		bpl.s	loc_ED6E
		neg.b	d0

loc_ED6E:
		cmpi.b	#$20,d0
		bcc.s	loc_ED7A
		move.b	d2,$26(a0)
		rts
; ---------------------------------------------------------------------------

loc_ED7A:
					; Player_Angle+26j
		move.b	$26(a0),d2
		addi.b	#$20,d2
		andi.b	#$C0,d2
		move.b	d2,$26(a0)
		rts
; End of function Player_Angle

; ---------------------------------------------------------------------------

Player_WalkVertR:
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1F(a0),d0
		ext.w	d0
		neg.w	d0
		add.w	d0,d2
		move.b	$1E(a0),d0
		ext.w	d0
		add.w	d0,d3
		lea	($FFFFF768).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindWall
		move.w	d1,-(sp)
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1F(a0),d0
		ext.w	d0
		add.w	d0,d2
		move.b	$1E(a0),d0
		ext.w	d0
		add.w	d0,d3
		lea	($FFFFF76A).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindWall
		move.w	(sp)+,d0
		bsr.w	Player_Angle
		tst.w	d1
		beq.s	locret_EE00
		bpl.s	loc_EE22
		cmpi.w	#-$E,d1
		blt.s	loc_EE0E
		tst.b	$41(a0)
		bne.s	loc_EE02
		add.w	d1,$10(a0)

locret_EE00:

		rts
; ---------------------------------------------------------------------------

loc_EE02:
		subq.b	#1,$41(a0)
		move.b	#$C0,$26(a0)
		rts
; ---------------------------------------------------------------------------

loc_EE0E:
		tst.w	($FFFFFE10).w
		bne.s	locret_EE00
		move.b	#$C0,$26(a0)
		move.b	#3,$41(a0)
		rts
; ---------------------------------------------------------------------------

loc_EE22:
		tst.b	$3C(a0)
		bne.s	loc_EE40
		move.b	$1A(a0),d0
		bpl.s	loc_EE30
		neg.b	d0

loc_EE30:
		addq.b	#4,d0
		cmpi.b	#$E,d0
		bcs.s	loc_EE3C
		move.b	#$E,d0

loc_EE3C:
		cmp.b	d0,d1
		bgt.s	loc_EE46

loc_EE40:
		add.w	d1,$10(a0)
		rts
; ---------------------------------------------------------------------------

loc_EE46:
		bset	#1,$2A(a0)
		bclr	#5,$2A(a0)
		move.b	#1,$21(a0)
		rts
; ---------------------------------------------------------------------------

Player_WalkCeiling:
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1E(a0),d0
		ext.w	d0
		sub.w	d0,d2
		eori.w	#$F,d2
		move.b	$1F(a0),d0
		ext.w	d0
		add.w	d0,d3
		lea	($FFFFF768).w,a4
		movea.w	#-$10,a3
		move.w	#$800,d6
		bsr.w	FindFloor
		move.w	d1,-(sp)
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1E(a0),d0
		ext.w	d0
		sub.w	d0,d2
		eori.w	#$F,d2
		move.b	$1F(a0),d0
		ext.w	d0
		sub.w	d0,d3
		lea	($FFFFF76A).w,a4
		movea.w	#-$10,a3
		move.w	#$800,d6
		bsr.w	FindFloor
		move.w	(sp)+,d0
		bsr.w	Player_Angle
		tst.w	d1
		beq.s	locret_EECE
		bpl.s	loc_EED0
		cmpi.w	#-$E,d1
		blt.s	locret_EECE
		sub.w	d1,$14(a0)

locret_EECE:

		rts
; ---------------------------------------------------------------------------

loc_EED0:
		tst.b	$3C(a0)
		bne.s	loc_EEEE
		move.b	$18(a0),d0
		bpl.s	loc_EEDE
		neg.b	d0

loc_EEDE:
		addq.b	#4,d0
		cmpi.b	#$E,d0
		bcs.s	loc_EEEA
		move.b	#$E,d0

loc_EEEA:
		cmp.b	d0,d1
		bgt.s	loc_EEF4

loc_EEEE:
		sub.w	d1,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_EEF4:
		bset	#1,$2A(a0)
		bclr	#5,$2A(a0)
		move.b	#1,$21(a0)
		rts
; ---------------------------------------------------------------------------

Player_WalkVertL:
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1F(a0),d0
		ext.w	d0
		sub.w	d0,d2
		move.b	$1E(a0),d0
		ext.w	d0
		sub.w	d0,d3
		eori.w	#$F,d3
		lea	($FFFFF768).w,a4
		movea.w	#-$10,a3
		move.w	#$400,d6
		bsr.w	FindWall
		move.w	d1,-(sp)
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1F(a0),d0
		ext.w	d0
		add.w	d0,d2
		move.b	$1E(a0),d0
		ext.w	d0
		sub.w	d0,d3
		eori.w	#$F,d3
		lea	($FFFFF76A).w,a4
		movea.w	#-$10,a3
		move.w	#$400,d6
		bsr.w	FindWall
		move.w	(sp)+,d0
		bsr.w	Player_Angle
		tst.w	d1
		beq.s	locret_EF7C
		bpl.s	loc_EF7E
		cmpi.w	#-$E,d1
		blt.s	locret_EF7C
		sub.w	d1,$10(a0)

locret_EF7C:

		rts
; ---------------------------------------------------------------------------

loc_EF7E:
		tst.b	$3C(a0)
		bne.s	loc_EF9C
		move.b	$1A(a0),d0
		bpl.s	loc_EF8C
		neg.b	d0

loc_EF8C:
		addq.b	#4,d0
		cmpi.b	#$E,d0
		bcs.s	loc_EF98
		move.b	#$E,d0

loc_EF98:
		cmp.b	d0,d1
		bgt.s	loc_EFA2

loc_EF9C:
		sub.w	d1,$10(a0)
		rts
; ---------------------------------------------------------------------------

loc_EFA2:
		bset	#1,$2A(a0)
		bclr	#5,$2A(a0)
		move.b	#1,$21(a0)
		rts
; ---------------------------------------------------------------------------

GetFloorPosition_BG:

		lea	($FFFF8000).w,a1
		move.w	d2,d0
		lsr.w	#5,d0
		and.w	($FFFFEEAE).w,d0
		move.w	$A(a1,d0.w),d0
		move.w	d3,d1
		lsr.w	#3,d1
		move.w	d1,d4
		lsr.w	#4,d1
		add.w	d1,d0
		moveq	#-1,d1
		clr.w	d1
		movea.w	d0,a1
		move.b	(a1),d1
		add.w	d1,d1
		move.w	ChunkAddrArray(pc,d1.w),d1
		move.w	d2,d0
		andi.w	#$70,d0
		add.w	d0,d1
		andi.w	#$E,d4
		add.w	d4,d1
		movea.l	d1,a1
		rts
; ---------------------------------------------------------------------------

GetFloorPosition_FG:
		lea	($FFFF8000).w,a1
		move.w	d2,d0
		lsr.w	#5,d0
		and.w	($FFFFEEAE).w,d0
		move.w	8(a1,d0.w),d0
		move.w	d3,d1
		lsr.w	#3,d1
		move.w	d1,d4
		lsr.w	#4,d1
		add.w	d1,d0
		moveq	#-1,d1
		clr.w	d1
		movea.w	d0,a1
		move.b	(a1),d1
		add.w	d1,d1
		move.w	ChunkAddrArray(pc,d1.w),d1
		move.w	d2,d0
		andi.w	#$70,d0
		add.w	d0,d1
		andi.w	#$E,d4
		add.w	d4,d1
		movea.l	d1,a1
		rts
; ---------------------------------------------------------------------------
ChunkAddrArray:	dc.w	 0,  $80, $100,	$180, $200, $280, $300,	$380, $400, $480, $500,	$580, $600, $680, $700,	$780
		dc.w  $800, $880, $900,	$980, $A00, $A80, $B00,	$B80, $C00, $C80, $D00,	$D80, $E00, $E80, $F00,	$F80
		dc.w $1000,$1080,$1100,$1180,$1200,$1280,$1300,$1380,$1400,$1480,$1500,$1580,$1600,$1680,$1700,$1780
		dc.w $1800,$1880,$1900,$1980,$1A00,$1A80,$1B00,$1B80,$1C00,$1C80,$1D00,$1D80,$1E00,$1E80,$1F00,$1F80
		dc.w $2000,$2080,$2100,$2180,$2200,$2280,$2300,$2380,$2400,$2480,$2500,$2580,$2600,$2680,$2700,$2780
		dc.w $2800,$2880,$2900,$2980,$2A00,$2A80,$2B00,$2B80,$2C00,$2C80,$2D00,$2D80,$2E00,$2E80,$2F00,$2F80
		dc.w $3000,$3080,$3100,$3180,$3200,$3280,$3300,$3380,$3400,$3480,$3500,$3580,$3600,$3680,$3700,$3780
		dc.w $3800,$3880,$3900,$3980,$3A00,$3A80,$3B00,$3B80,$3C00,$3C80,$3D00,$3D80,$3E00,$3E80,$3F00,$3F80
		dc.w $4000,$4080,$4100,$4180,$4200,$4280,$4300,$4380,$4400,$4480,$4500,$4580,$4600,$4680,$4700,$4780
		dc.w $4800,$4880,$4900,$4980,$4A00,$4A80,$4B00,$4B80,$4C00,$4C80,$4D00,$4D80,$4E00,$4E80,$4F00,$4F80
		dc.w $5000,$5080,$5100,$5180,$5200,$5280,$5300,$5380,$5400,$5480,$5500,$5580,$5600,$5680,$5700,$5780
		dc.w $5800,$5880,$5900,$5980,$5A00,$5A80,$5B00,$5B80,$5C00,$5C80,$5D00,$5D80,$5E00,$5E80,$5F00,$5F80
		dc.w $6000,$6080,$6100,$6180,$6200,$6280,$6300,$6380,$6400,$6480,$6500,$6580,$6600,$6680,$6700,$6780
		dc.w $6800,$6880,$6900,$6980,$6A00,$6A80,$6B00,$6B80,$6C00,$6C80,$6D00,$6D80,$6E00,$6E80,$6F00,$6F80
		dc.w $7000,$7080,$7100,$7180,$7200,$7280,$7300,$7380,$7400,$7480,$7500,$7580,$7600,$7680,$7700,$7780
		dc.w $7800,$7880,$7900,$7980,$7A00,$7A80,$7B00,$7B80,$7C00,$7C80,$7D00,$7D80,$7E00,$7E80,$7F00,$7F80

; =============== S U B R O U T I N E =======================================


FindFloor:
		lea	(GetFloorPosition_FG).l,a5
		tst.b	($FFFFF664).w
		beq.s	sub_F264
		bsr.s	sub_F264
		move.b	(a4),1(a4)
		move.w	d1,-(sp)
		sub.w	($FFFFEE3E).w,d3
		sub.w	($FFFFEE40).w,d2
		lea	(GetFloorPosition_BG).l,a5
		bsr.s	sub_F264
		add.w	($FFFFEE3E).w,d3
		add.w	($FFFFEE40).w,d2
		move.w	(sp)+,d0
		cmp.w	d0,d1
		ble.s	locret_F262
		move.b	1(a4),(a4)
		move.w	d0,d1

locret_F262:
		rts
; End of function FindFloor


; =============== S U B R O U T I N E =======================================


sub_F264:
		jsr	(a5)
		move.w	(a1),d0
		move.w	d0,d4
		andi.w	#$3FF,d0
		beq.s	loc_F274
		btst	d5,d4
		bne.s	loc_F282

loc_F274:
		add.w	a3,d2
		bsr.w	sub_F30C
		sub.w	a3,d2
		addi.w	#$10,d1
		rts
; ---------------------------------------------------------------------------

loc_F282:
		movea.l	($FFFFF796).w,a2
		add.w	d0,d0
		move.b	(a2,d0.w),d0
		andi.w	#$FF,d0
		beq.s	loc_F274
		lea	(AngleArray).l,a2
		move.b	(a2,d0.w),(a4)
		lsl.w	#4,d0
		move.w	d3,d1
		btst	#$A,d4
		beq.s	loc_F2AA
		not.w	d1
		neg.b	(a4)

loc_F2AA:
		btst	#$B,d4
		beq.s	loc_F2BA
		addi.b	#$40,(a4)
		neg.b	(a4)
		subi.b	#$40,(a4)

loc_F2BA:
		andi.w	#$F,d1
		add.w	d0,d1
		lea	(HeightMaps).l,a2
		move.b	(a2,d1.w),d0
		ext.w	d0
		eor.w	d6,d4
		btst	#$B,d4
		beq.s	loc_F2D6
		neg.w	d0

loc_F2D6:
		tst.w	d0
		beq.s	loc_F274
		bmi.s	loc_F2F2
		cmpi.b	#$10,d0
		beq.s	loc_F2FE
		move.w	d2,d1
		andi.w	#$F,d1
		add.w	d1,d0
		move.w	#$F,d1
		sub.w	d0,d1
		rts
; ---------------------------------------------------------------------------

loc_F2F2:
		move.w	d2,d1
		andi.w	#$F,d1
		add.w	d1,d0
		bpl.w	loc_F274

loc_F2FE:
		sub.w	a3,d2
		bsr.w	sub_F30C
		add.w	a3,d2
		subi.w	#$10,d1
		rts
; End of function sub_F264


; =============== S U B R O U T I N E =======================================


sub_F30C:
		jsr	(a5)
		move.w	(a1),d0
		move.w	d0,d4
		andi.w	#$3FF,d0
		beq.s	loc_F31C
		btst	d5,d4
		bne.s	loc_F32A

loc_F31C:
		move.w	#$F,d1
		move.w	d2,d0
		andi.w	#$F,d0
		sub.w	d0,d1
		rts
; ---------------------------------------------------------------------------

loc_F32A:
		movea.l	($FFFFF796).w,a2
		add.w	d0,d0
		move.b	(a2,d0.w),d0
		andi.w	#$FF,d0
		beq.s	loc_F31C
		lea	(AngleArray).l,a2
		move.b	(a2,d0.w),(a4)
		lsl.w	#4,d0
		move.w	d3,d1
		btst	#$A,d4
		beq.s	loc_F352
		not.w	d1
		neg.b	(a4)

loc_F352:
		btst	#$B,d4
		beq.s	loc_F362
		addi.b	#$40,(a4)
		neg.b	(a4)
		subi.b	#$40,(a4)

loc_F362:
		andi.w	#$F,d1
		add.w	d0,d1
		lea	(HeightMaps).l,a2
		move.b	(a2,d1.w),d0
		ext.w	d0
		eor.w	d6,d4
		btst	#$B,d4
		beq.s	loc_F37E
		neg.w	d0

loc_F37E:
		tst.w	d0
		beq.s	loc_F31C
		bmi.s	loc_F394
		move.w	d2,d1
		andi.w	#$F,d1
		add.w	d1,d0
		move.w	#$F,d1
		sub.w	d0,d1
		rts
; ---------------------------------------------------------------------------

loc_F394:
		move.w	d2,d1
		andi.w	#$F,d1
		add.w	d1,d0
		bpl.w	loc_F31C
		not.w	d1
		rts
; End of function sub_F30C

; ---------------------------------------------------------------------------

loc_F3A4:
		lea	(GetFloorPosition_FG).l,a5
		tst.b	($FFFFF664).w
		beq.s	sub_F3DE
		bsr.s	sub_F3DE
		move.b	(a4),1(a4)
		move.w	d1,-(sp)
		sub.w	($FFFFEE3E).w,d3
		sub.w	($FFFFEE40).w,d2
		lea	(GetFloorPosition_BG).l,a5
		bsr.s	sub_F3DE
		add.w	($FFFFEE3E).w,d3
		add.w	($FFFFEE40).w,d2
		move.w	(sp)+,d0
		cmp.w	d0,d1
		ble.s	locret_F3DC
		move.b	1(a4),(a4)
		move.w	d0,d1

locret_F3DC:
		rts

; =============== S U B R O U T I N E =======================================


sub_F3DE:

		jsr	(a5)
		move.w	(a1),d0
		move.w	d0,d4
		andi.w	#$3FF,d0
		beq.s	loc_F3EE
		btst	d5,d4
		bne.s	loc_F3F4

loc_F3EE:
		move.w	#$10,d1
		rts
; ---------------------------------------------------------------------------

loc_F3F4:
		movea.l	($FFFFF796).w,a2
		add.w	d0,d0
		move.b	(a2,d0.w),d0
		andi.w	#$FF,d0
		beq.s	loc_F3EE
		lea	(AngleArray).l,a2
		move.b	(a2,d0.w),(a4)
		lsl.w	#4,d0
		move.w	d3,d1
		btst	#$A,d4
		beq.s	loc_F41C
		not.w	d1
		neg.b	(a4)

loc_F41C:
		btst	#$B,d4
		beq.s	loc_F42C
		addi.b	#$40,(a4)
		neg.b	(a4)
		subi.b	#$40,(a4)

loc_F42C:
		andi.w	#$F,d1
		add.w	d0,d1
		lea	(HeightMaps).l,a2
		move.b	(a2,d1.w),d0
		ext.w	d0
		eor.w	d6,d4
		btst	#$B,d4
		beq.s	loc_F448
		neg.w	d0

loc_F448:
		tst.w	d0
		beq.s	loc_F3EE
		bmi.s	loc_F464
		cmpi.b	#$10,d0
		beq.s	loc_F470
		move.w	d2,d1
		andi.w	#$F,d1
		add.w	d1,d0
		move.w	#$F,d1
		sub.w	d0,d1
		rts
; ---------------------------------------------------------------------------

loc_F464:
		move.w	d2,d1
		andi.w	#$F,d1
		add.w	d1,d0
		bpl.w	loc_F3EE

loc_F470:
		sub.w	a3,d2
		bsr.w	sub_F30C
		add.w	a3,d2
		subi.w	#$10,d1
		rts
; End of function sub_F3DE


; =============== S U B R O U T I N E =======================================


FindWall:

		lea	(GetFloorPosition_FG).l,a5
		tst.b	($FFFFF664).w
		beq.s	sub_F4DC
		bsr.s	sub_F4DC
		move.b	(a4),1(a4)
		move.w	d1,-(sp)
		move.w	a3,d0
		bpl.s	loc_F4A4
		eori.w	#$F,d3
		sub.w	($FFFFEE3E).w,d3
		eori.w	#$F,d3
		bra.s	loc_F4A8
; ---------------------------------------------------------------------------

loc_F4A4:
		sub.w	($FFFFEE3E).w,d3

loc_F4A8:
		sub.w	($FFFFEE40).w,d2
		lea	(GetFloorPosition_BG).l,a5
		bsr.s	sub_F4DC
		move.w	a3,d0
		bpl.s	loc_F4C6
		eori.w	#$F,d3
		add.w	($FFFFEE3E).w,d3
		eori.w	#$F,d3
		bra.s	loc_F4CA
; ---------------------------------------------------------------------------

loc_F4C6:
		add.w	($FFFFEE3E).w,d3

loc_F4CA:
		add.w	($FFFFEE40).w,d2
		move.w	(sp)+,d0
		cmp.w	d0,d1
		ble.s	locret_F4DA
		move.b	1(a4),(a4)
		move.w	d0,d1

locret_F4DA:
		rts
; End of function FindWall


; =============== S U B R O U T I N E =======================================


sub_F4DC:
		jsr	(a5)
		move.w	(a1),d0
		move.w	d0,d4
		andi.w	#$3FF,d0
		beq.s	loc_F4EC
		btst	d5,d4
		bne.s	loc_F4FA

loc_F4EC:
		add.w	a3,d3
		bsr.w	sub_F584
		sub.w	a3,d3
		addi.w	#$10,d1
		rts
; ---------------------------------------------------------------------------

loc_F4FA:
		movea.l	($FFFFF796).w,a2
		add.w	d0,d0
		move.b	(a2,d0.w),d0
		andi.w	#$FF,d0
		beq.s	loc_F4EC
		lea	(AngleArray).l,a2
		move.b	(a2,d0.w),(a4)
		lsl.w	#4,d0
		move.w	d2,d1
		btst	#$B,d4
		beq.s	loc_F52A
		not.w	d1
		addi.b	#$40,(a4)
		neg.b	(a4)
		subi.b	#$40,(a4)

loc_F52A:
		btst	#$A,d4
		beq.s	loc_F532
		neg.b	(a4)

loc_F532:
		andi.w	#$F,d1
		add.w	d0,d1
		lea	(HeightMapsRot).l,a2
		move.b	(a2,d1.w),d0
		ext.w	d0
		eor.w	d6,d4
		btst	#$A,d4
		beq.s	loc_F54E
		neg.w	d0

loc_F54E:
		tst.w	d0
		beq.s	loc_F4EC
		bmi.s	loc_F56A
		cmpi.b	#$10,d0
		beq.s	loc_F576
		move.w	d3,d1
		andi.w	#$F,d1
		add.w	d1,d0
		move.w	#$F,d1
		sub.w	d0,d1
		rts
; ---------------------------------------------------------------------------

loc_F56A:
		move.w	d3,d1
		andi.w	#$F,d1
		add.w	d1,d0
		bpl.w	loc_F4EC

loc_F576:
		sub.w	a3,d3
		bsr.w	sub_F584
		add.w	a3,d3
		subi.w	#$10,d1
		rts
; End of function sub_F4DC


; =============== S U B R O U T I N E =======================================


sub_F584:
		jsr	(a5)
		move.w	(a1),d0
		move.w	d0,d4
		andi.w	#$3FF,d0
		beq.s	loc_F594
		btst	d5,d4
		bne.s	loc_F5A2

loc_F594:
		move.w	#$F,d1
		move.w	d3,d0
		andi.w	#$F,d0
		sub.w	d0,d1
		rts
; ---------------------------------------------------------------------------

loc_F5A2:
		movea.l	($FFFFF796).w,a2
		add.w	d0,d0
		move.b	(a2,d0.w),d0
		andi.w	#$FF,d0
		beq.s	loc_F594
		lea	(AngleArray).l,a2
		move.b	(a2,d0.w),(a4)
		lsl.w	#4,d0
		move.w	d2,d1
		btst	#$B,d4
		beq.s	loc_F5D2
		not.w	d1
		addi.b	#$40,(a4)
		neg.b	(a4)
		subi.b	#$40,(a4)

loc_F5D2:
		btst	#$A,d4
		beq.s	loc_F5DA
		neg.b	(a4)

loc_F5DA:
		andi.w	#$F,d1
		add.w	d0,d1
		lea	(HeightMapsRot).l,a2
		move.b	(a2,d1.w),d0
		ext.w	d0
		eor.w	d6,d4
		btst	#$A,d4
		beq.s	loc_F5F6
		neg.w	d0

loc_F5F6:
		tst.w	d0
		beq.s	loc_F594
		bmi.s	loc_F60C
		move.w	d3,d1
		andi.w	#$F,d1
		add.w	d1,d0
		move.w	#$F,d1
		sub.w	d0,d1
		rts
; ---------------------------------------------------------------------------

loc_F60C:
		move.w	d3,d1
		andi.w	#$F,d1
		add.w	d1,d0
		bpl.w	loc_F594
		not.w	d1
		rts
; End of function sub_F584


; =============== S U B R O U T I N E =======================================


sub_F61C:
					; Tails_InputAcceleration_Path+1CCp ...
		tst.w	($FFFFFFE8).w
		bne.w	sub_F6B4
		move.l	($FFFFF7B4).w,($FFFFF796).w
		cmpi.b	#$C,$46(a0)
		beq.s	loc_F638
		move.l	($FFFFF7B8).w,($FFFFF796).w

loc_F638:
		move.b	$47(a0),d5
		move.l	$10(a0),d3
		move.l	$14(a0),d2
		move.w	$18(a0),d1
		ext.l	d1
		asl.l	#8,d1
		add.l	d1,d3
		move.w	$1A(a0),d1
		tst.b	($FFFFF7C6).w
		beq.s	loc_F65A
		neg.w	d1

loc_F65A:
		ext.l	d1
		asl.l	#8,d1
		add.l	d1,d2
		swap	d2
		swap	d3

loc_F664:
		move.b	d0,($FFFFF768).w
		move.b	d0,($FFFFF76A).w
		move.b	d0,d1
		addi.b	#$20,d0
		bpl.s	loc_F680
		move.b	d1,d0
		bpl.s	loc_F67A
		subq.b	#1,d0

loc_F67A:
		addi.b	#$20,d0
		bra.s	loc_F68A
; ---------------------------------------------------------------------------

loc_F680:
		move.b	d1,d0
		bpl.s	loc_F686
		addq.b	#1,d0

loc_F686:
		addi.b	#$1F,d0

loc_F68A:
		andi.b	#$C0,d0
		beq.w	loc_F802
		cmpi.b	#$80,d0
		beq.w	loc_FBCE
		tst.w	($FFFFFFE8).w
		bne.s	loc_F6A8
		andi.b	#$38,d1
		bne.s	loc_F6A8
		addq.w	#8,d2

loc_F6A8:
		cmpi.b	#$40,d0
		beq.w	loc_FDA8
		bra.w	loc_FA88
; End of function sub_F61C


; =============== S U B R O U T I N E =======================================


sub_F6B4:
		move.l	($FFFFF7B4).w,($FFFFF796).w
		cmpi.b	#$C,$46(a0)
		beq.s	loc_F6C8
		move.l	($FFFFF7B8).w,($FFFFF796).w

loc_F6C8:
		move.b	$47(a0),d5
		move.l	$10(a0),d3
		move.l	$14(a0),d2
		move.w	$18(a0),d1
		ext.l	d1
		asl.l	#8,d1
		add.l	d1,d3
		move.w	$1A(a0),d1
		ext.l	d1
		asl.l	#8,d1
		add.l	d1,d2
		swap	d2
		swap	d3
		move.b	d0,($FFFFF768).w
		move.b	d0,($FFFFF76A).w
		move.b	d0,d1
		addi.b	#$20,d0
		bpl.s	loc_F708
		move.b	d1,d0
		bpl.s	loc_F702
		subq.b	#1,d0

loc_F702:
		addi.b	#$20,d0
		bra.s	loc_F712
; ---------------------------------------------------------------------------

loc_F708:
		move.b	d1,d0
		bpl.s	loc_F70E
		addq.b	#1,d0

loc_F70E:
		addi.b	#$1F,d0

loc_F712:
		andi.b	#$C0,d0
		beq.w	sub_F828
		cmpi.b	#$80,d0
		beq.w	sub_FBEE
		cmpi.b	#$40,d0
		beq.w	loc_FDC8
		bra.w	loc_FAA4
; End of function sub_F6B4


; =============== S U B R O U T I N E =======================================


sub_F72E:
					; Tails_Jump+2Ap ...
		move.l	($FFFFF7B4).w,($FFFFF796).w
		cmpi.b	#$C,$46(a0)
		beq.s	loc_F742
		move.l	($FFFFF7B8).w,($FFFFF796).w

loc_F742:
		move.b	$47(a0),d5
		move.b	d0,($FFFFF768).w
		move.b	d0,($FFFFF76A).w
		addi.b	#$20,d0
		andi.b	#$C0,d0
		cmpi.b	#$40,d0
		beq.w	sub_FCCA
		cmpi.b	#$80,d0
		beq.w	sub_FAF2
		cmpi.b	#$C0,d0
		beq.w	sub_F9BA
; End of function sub_F72E


; =============== S U B R O U T I N E =======================================


sub_F76E:
		move.l	($FFFFF7B4).w,($FFFFF796).w
		cmpi.b	#$C,$46(a0)
		beq.s	loc_F782
		move.l	($FFFFF7B8).w,($FFFFF796).w

loc_F782:
		move.b	$46(a0),d5
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1E(a0),d0
		ext.w	d0
		add.w	d0,d2
		move.b	$1F(a0),d0
		ext.w	d0
		add.w	d0,d3
		lea	($FFFFF768).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindFloor
		move.w	d1,-(sp)
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1E(a0),d0
		ext.w	d0
		add.w	d0,d2
		move.b	$1F(a0),d0
		ext.w	d0
		sub.w	d0,d3
		lea	($FFFFF76A).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindFloor
		move.w	(sp)+,d0
		move.b	#0,d2

loc_F7E2:
		move.b	($FFFFF76A).w,d3
		cmp.w	d0,d1
		ble.s	loc_F7F0
		move.b	($FFFFF768).w,d3
		exg	d0,d1

loc_F7F0:
		btst	#0,d3
		beq.s	locret_F7F8
		move.b	d2,d3

locret_F7F8:
		rts
; End of function sub_F76E

; ---------------------------------------------------------------------------
		move.w	$14(a0),d2
		move.w	$10(a0),d3

loc_F802:
		addi.w	#$A,d2
		lea	($FFFFF768).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindFloor
		move.b	#0,d2

loc_F81A:
		move.b	($FFFFF768).w,d3
		btst	#0,d3
		beq.s	locret_F826
		move.b	d2,d3

locret_F826:
		rts

; =============== S U B R O U T I N E =======================================


sub_F828:

		move.b	$1F(a0),d0
		ext.w	d0
		add.w	d0,d2
		lea	($FFFFF768).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindFloor
		move.b	#0,d2
		bra.s	loc_F81A
; End of function sub_F828


; =============== S U B R O U T I N E =======================================


sub_F846:

		move.w	$10(a0),d3
		move.w	$14(a0),d2
		subq.w	#4,d2
		move.l	($FFFFF7B4).w,($FFFFF796).w
		cmpi.b	#$D,$47(a0)
		beq.s	loc_F864
		move.l	($FFFFF7B8).w,($FFFFF796).w

loc_F864:
		lea	($FFFFF768).w,a4
		move.b	#0,(a4)
		movea.w	#$10,a3
		move.w	#0,d6
		move.b	$47(a0),d5
		movem.l	a4-a6,-(sp)
		bsr.w	FindFloor
		movem.l	(sp)+,a4-a6
		move.b	($FFFFF768).w,d3
		btst	#0,d3
		beq.s	locret_F892
		move.b	#0,d3

locret_F892:
		rts
; End of function sub_F846


; =============== S U B R O U T I N E =======================================


sub_F894:
		move.w	$10(a0),d3

loc_F898:
		move.w	$14(a0),d2
		moveq	#0,d0
		move.b	$1E(a0),d0
		ext.w	d0
		add.w	d0,d2
; End of function sub_F894


; =============== S U B R O U T I N E =======================================


sub_F8A6:
		move.l	($FFFFF7B4).w,($FFFFF796).w
		cmpi.b	#$C,$46(a0)
		beq.s	loc_F8BA
		move.l	($FFFFF7B8).w,($FFFFF796).w

loc_F8BA:
		lea	($FFFFF768).w,a4
		move.b	#0,(a4)
		movea.w	#$10,a3
		move.w	#0,d6
		move.b	$46(a0),d5
		movem.l	a4-a6,-(sp)
		bsr.w	FindFloor
		movem.l	(sp)+,a4-a6
		move.b	($FFFFF768).w,d3
		btst	#0,d3
		beq.s	locret_F8E8
		move.b	#0,d3

locret_F8E8:
		rts
; End of function sub_F8A6


; =============== S U B R O U T I N E =======================================


SonicOnObjHitFloor:

		move.w	$10(a1),d3
		move.w	$14(a1),d2
		moveq	#0,d0
		move.b	$1E(a1),d0
		ext.w	d0
		add.w	d0,d2
		move.l	($FFFFF7B4).w,($FFFFF796).w
		cmpi.b	#$C,$46(a1)
		beq.s	loc_F910
		move.l	($FFFFF7B8).w,($FFFFF796).w

loc_F910:
		lea	($FFFFF768).w,a4
		move.b	#0,(a4)
		movea.w	#$10,a3
		move.w	#0,d6
		move.b	$46(a1),d5
		bsr.w	FindFloor
		move.b	($FFFFF768).w,d3
		btst	#0,d3
		beq.s	locret_F936
		move.b	#0,d3

locret_F936:
		rts
; End of function SonicOnObjHitFloor


; =============== S U B R O U T I N E =======================================


ObjHitFloor:

		move.w	$10(a0),d3

ObjHitFloor2:

		move.w	$14(a0),d2		; Get object position
		move.b	$1E(a0),d0		; Get object height
		ext.w	d0
		add.w	d0,d2
		lea	($FFFFF768).w,a4
		move.b	#0,(a4)
		movea.w	#$10,a3
		move.w	#0,d6
		moveq	#$C,d5
		bsr.w	FindFloor
		move.b	($FFFFF768).w,d3
		btst	#0,d3
		beq.s	locret_F96C
		move.b	#0,d3

locret_F96C:
		rts
; End of function ObjHitFloor

; ---------------------------------------------------------------------------
		move.w	$10(a1),d3
		move.w	$14(a1),d2
		move.b	$1E(a1),d0
		ext.w	d0
		add.w	d0,d2
		lea	($FFFFF768).w,a4
		move.b	#0,(a4)
		movea.w	#$10,a3
		move.w	#0,d6
		moveq	#$C,d5
		bra.w	FindFloor

; =============== S U B R O U T I N E =======================================


sub_F994:
		move.w	$10(a0),d3
		move.w	$14(a0),d2
		move.b	$1E(a0),d0
		ext.w	d0
		add.w	d0,d2
		lea	($FFFFF768).w,a4
		move.b	#0,(a4)
		movea.w	#$10,a3
		move.w	#0,d6
		moveq	#$C,d5
		bra.w	loc_F3A4
; End of function sub_F994


; =============== S U B R O U T I N E =======================================


sub_F9BA:

		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1F(a0),d0
		ext.w	d0
		sub.w	d0,d2
		move.b	$1E(a0),d0
		ext.w	d0
		add.w	d0,d3
		lea	($FFFFF768).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindWall
		move.w	d1,-(sp)
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1F(a0),d0
		ext.w	d0
		add.w	d0,d2
		move.b	$1E(a0),d0
		ext.w	d0
		add.w	d0,d3
		lea	($FFFFF76A).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindWall
		move.w	(sp)+,d0
		move.b	#-$40,d2
		bra.w	loc_F7E2
; End of function sub_F9BA


; =============== S U B R O U T I N E =======================================


sub_FA1A:

		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1E(a0),d0
		ext.w	d0
		sub.w	d0,d2
		move.b	$1F(a0),d0
		ext.w	d0
		add.w	d0,d3
		lea	($FFFFF768).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindWall
		move.w	d1,-(sp)
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1E(a0),d0
		ext.w	d0
		add.w	d0,d2
		move.b	$1F(a0),d0

loc_FA5C:

		ext.w	d0
		add.w	d0,d3
		lea	($FFFFF76A).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindWall
		move.w	(sp)+,d0
		move.b	#-$40,d2
		bra.w	loc_F7E2
; End of function sub_FA1A


; =============== S U B R O U T I N E =======================================


sub_FA7A:

		move.w	$14(a0),d2
		move.w	$10(a0),d3
		tst.w	($FFFFFFE8).w
		bne.s	loc_FAA4

loc_FA88:
		addi.w	#$A,d3
		lea	($FFFFF768).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindWall
		move.b	#-$40,d2
		bra.w	loc_F81A
; ---------------------------------------------------------------------------

loc_FAA4:
		move.b	$1F(a0),d0
		ext.w	d0
		add.w	d0,d3
		lea	($FFFFF768).w,a4
		movea.w	#$10,a3
		move.w	#0,d6
		bsr.w	FindWall
		move.b	#-$40,d2
		bra.w	loc_F81A
; End of function sub_FA7A


; =============== S U B R O U T I N E =======================================


ObjHitWall:

		add.w	$10(a0),d3
		move.w	$14(a0),d2
		lea	($FFFFF768).w,a4
		move.b	#0,(a4)
		movea.w	#$10,a3
		move.w	#0,d6
		moveq	#$D,d5
		bsr.w	FindWall
		move.b	($FFFFF768).w,d3
		btst	#0,d3
		beq.s	locret_FAF0
		move.b	#-$40,d3

locret_FAF0:
		rts
; End of function ObjHitWall


; =============== S U B R O U T I N E =======================================


sub_FAF2:
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1E(a0),d0
		ext.w	d0
		sub.w	d0,d2
		eori.w	#$F,d2
		move.b	$1F(a0),d0
		ext.w	d0
		add.w	d0,d3
		lea	($FFFFF768).w,a4
		movea.w	#-$10,a3
		move.w	#$800,d6
		bsr.w	FindFloor
		move.w	d1,-(sp)
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1E(a0),d0
		ext.w	d0
		sub.w	d0,d2
		eori.w	#$F,d2
		move.b	$1F(a0),d0
		ext.w	d0
		sub.w	d0,d3
		lea	($FFFFF76A).w,a4
		movea.w	#-$10,a3
		move.w	#$800,d6
		bsr.w	FindFloor
		move.w	(sp)+,d0
		move.b	#-$80,d2
		bra.w	loc_F7E2
; End of function sub_FAF2


; =============== S U B R O U T I N E =======================================


sub_FB5A:

		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1E(a0),d0
		ext.w	d0
		sub.w	d0,d2
		eori.w	#$F,d2
		move.b	$1F(a0),d0
		ext.w	d0
		subq.w	#2,d0
		add.w	d0,d3
		lea	($FFFFF768).w,a4
		movea.w	#-$10,a3
		move.w	#$800,d6
		bsr.w	FindFloor
		move.w	d1,-(sp)
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1E(a0),d0
		ext.w	d0
		sub.w	d0,d2
		eori.w	#$F,d2
		move.b	$1F(a0),d0
		ext.w	d0
		subq.w	#2,d0
		sub.w	d0,d3
		lea	($FFFFF76A).w,a4
		movea.w	#-$10,a3
		move.w	#$800,d6
		bsr.w	FindFloor
		move.w	(sp)+,d0
		move.b	#-$80,d2
		bra.w	loc_F7E2
; End of function sub_FB5A

; ---------------------------------------------------------------------------
		move.w	$14(a0),d2
		move.w	$10(a0),d3

loc_FBCE:
		subi.w	#$A,d2
		eori.w	#$F,d2
		lea	($FFFFF768).w,a4
		movea.w	#-$10,a3
		move.w	#$800,d6
		bsr.w	FindFloor
		move.b	#-$80,d2
		bra.w	loc_F81A

; =============== S U B R O U T I N E =======================================


sub_FBEE:

		move.b	$1F(a0),d0
		ext.w	d0
		sub.w	d0,d2
		eori.w	#$F,d2
		lea	($FFFFF768).w,a4
		movea.w	#-$10,a3
		move.w	#$800,d6
		bsr.w	FindFloor
		move.b	#-$80,d2
		bra.w	loc_F81A
; End of function sub_FBEE


; =============== S U B R O U T I N E =======================================


ObjHitCeiling:

		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1E(a0),d0
		ext.w	d0
		sub.w	d0,d2
		eori.w	#$F,d2
		lea	($FFFFF768).w,a4
		movea.w	#-$10,a3
		move.w	#$800,d6
		moveq	#$D,d5
		bsr.w	FindFloor
		move.b	($FFFFF768).w,d3
		btst	#0,d3
		beq.s	locret_FC48
		move.b	#-$80,d3

locret_FC48:
		rts
; End of function ObjHitCeiling

; ---------------------------------------------------------------------------

loc_FC4A:
		move.w	$14(a0),d2
		moveq	#0,d0
		move.b	$1E(a0),d0
		ext.w	d0
		sub.w	d0,d2
		eori.w	#$F,d2

; =============== S U B R O U T I N E =======================================


sub_FC5C:
		move.l	($FFFFF7B4).w,($FFFFF796).w
		cmpi.b	#$C,$46(a0)
		beq.s	loc_FC70
		move.l	($FFFFF7B8).w,($FFFFF796).w

loc_FC70:
		lea	($FFFFF768).w,a4
		move.b	#0,(a4)
		movea.w	#-$10,a3
		move.w	#$800,d6
		move.b	$46(a0),d5
		movem.l	a4-a6,-(sp)
		bsr.w	FindFloor
		movem.l	(sp)+,a4-a6
		move.b	($FFFFF768).w,d3
		btst	#0,d3
		beq.s	locret_FC9E
		move.b	#0,d3

locret_FC9E:
		rts
; End of function sub_FC5C


; =============== S U B R O U T I N E =======================================


sub_FCA0:
		move.w	$10(a0),d3
		move.w	$14(a0),d2
		move.b	$1E(a0),d0
		ext.w	d0
		sub.w	d0,d2
		eori.w	#$F,d2
		lea	($FFFFF768).w,a4
		move.b	#0,(a4)
		movea.w	#-$10,a3
		move.w	#$800,d6
		moveq	#$C,d5
		bra.w	loc_F3A4
; End of function sub_FCA0


; =============== S U B R O U T I N E =======================================


sub_FCCA:

		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1F(a0),d0
		ext.w	d0
		sub.w	d0,d2
		move.b	$1E(a0),d0
		ext.w	d0
		sub.w	d0,d3
		eori.w	#$F,d3
		lea	($FFFFF768).w,a4
		movea.w	#-$10,a3
		move.w	#$400,d6
		bsr.w	FindWall
		move.w	d1,-(sp)
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1F(a0),d0
		ext.w	d0
		add.w	d0,d2
		move.b	$1E(a0),d0
		ext.w	d0
		sub.w	d0,d3
		eori.w	#$F,d3
		lea	($FFFFF76A).w,a4
		movea.w	#-$10,a3
		move.w	#$400,d6
		bsr.w	FindWall
		move.w	(sp)+,d0
		move.b	#$40,d2
		bra.w	loc_F7E2
; End of function sub_FCCA


; =============== S U B R O U T I N E =======================================


sub_FD32:

		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1E(a0),d0
		ext.w	d0
		sub.w	d0,d2
		move.b	$1F(a0),d0
		ext.w	d0
		sub.w	d0,d3
		eori.w	#$F,d3
		lea	($FFFFF768).w,a4
		movea.w	#-$10,a3
		move.w	#$400,d6
		bsr.w	FindWall
		move.w	d1,-(sp)
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		moveq	#0,d0
		move.b	$1E(a0),d0
		ext.w	d0
		add.w	d0,d2
		move.b	$1F(a0),d0
		ext.w	d0
		sub.w	d0,d3
		eori.w	#$F,d3
		lea	($FFFFF76A).w,a4
		movea.w	#-$10,a3
		move.w	#$400,d6
		bsr.w	FindWall
		move.w	(sp)+,d0
		move.b	#$40,d2
		bra.w	loc_F7E2
; End of function sub_FD32


; =============== S U B R O U T I N E =======================================


sub_FD9A:

		move.w	$14(a0),d2
		move.w	$10(a0),d3
		tst.w	($FFFFFFE8).w
		bne.s	loc_FDC8

loc_FDA8:
		subi.w	#$A,d3
		eori.w	#$F,d3
		lea	($FFFFF768).w,a4
		movea.w	#-$10,a3
		move.w	#$400,d6
		bsr.w	FindWall
		move.b	#$40,d2
		bra.w	loc_F81A
; ---------------------------------------------------------------------------

loc_FDC8:
		move.b	$1F(a0),d0
		ext.w	d0
		sub.w	d0,d3
		eori.w	#$F,d3
		lea	($FFFFF768).w,a4
		movea.w	#-$10,a3
		move.w	#$400,d6
		bsr.w	FindWall
		move.b	#$40,d2
		bra.w	loc_F81A
; End of function sub_FD9A


; =============== S U B R O U T I N E =======================================


sub_FDEC:

		move.l	($FFFFF7B4).w,($FFFFF796).w
		cmpi.b	#$C,$46(a0)
		beq.s	loc_FE00
		move.l	($FFFFF7B8).w,($FFFFF796).w

loc_FE00:
		move.w	$10(a0),d3
		move.w	$14(a0),d2
		move.b	$1E(a0),d0
		ext.w	d0
		sub.w	d0,d3
		eori.w	#$F,d3
		lea	($FFFFF768).w,a4

loc_FE18:
		move.b	#0,(a4)
		movea.w	#-$10,a3
		move.w	#$400,d6
		move.b	$47(a0),d5
		bsr.w	FindWall
		move.b	($FFFFF768).w,d3
		btst	#0,d3
		beq.s	locret_FE3A
		move.b	#$40,d3

locret_FE3A:
		rts
; End of function sub_FDEC


; =============== S U B R O U T I N E =======================================


ObjHitWall2:

		add.w	$10(a0),d3
		eori.w	#$F,d3
; End of function ObjHitWall2


; =============== S U B R O U T I N E =======================================


sub_FE44:

		move.w	$14(a0),d2
		lea	($FFFFF768).w,a4
		move.b	#0,(a4)
		movea.w	#-$10,a3
		move.w	#$400,d6
		moveq	#$D,d5
		bsr.w	FindWall
		move.b	($FFFFF768).w,d3
		btst	#0,d3
		beq.s	locret_FE6C
		move.b	#$40,d3

locret_FE6C:
		rts
; End of function sub_FE44


; =============== S U B R O U T I N E =======================================


sub_FE6E:

		nop
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		subi.w	#4,d2
		moveq	#0,d5
		move.b	$1E(a0),d5
		subq.b	#3,d5
		sub.w	d5,d3
		move.w	#8,d4
		add.w	d5,d5
		bra.s	loc_FF06
; ---------------------------------------------------------------------------

Test_Sprite_Collisions:

		nop
		jsr	(Test_Ring_Collisions).l
		bsr.w	sub_1041E
		tst.b	$38(a0)
		bne.s	Sprite_Collisions_No_InstaShield
		move.b	$2B(a0),d0
		andi.b	#$73,d0
		bne.s	Sprite_Collisions_No_InstaShield
		cmpi.b	#1,$2F(a0)
		bne.s	Sprite_Collisions_No_InstaShield
		move.b	$2B(a0),d0
		move.w	d0,-(sp)
		bset	#1,$2B(a0)
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		subi.w	#$18,d2
		subi.w	#$18,d3
		move.w	#$30,d4
		move.w	#$30,d5
		bsr.s	loc_FF06
		move.w	(sp)+,d0
		btst	#1,d0
		bne.s	loc_FEE6
		bclr	#1,$2B(a0)

loc_FEE6:
		moveq	#0,d0
		rts
; ---------------------------------------------------------------------------

Sprite_Collisions_No_InstaShield:
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		subi.w	#8,d2
		moveq	#0,d5
		move.b	$1E(a0),d5
		subq.b	#3,d5
		sub.w	d5,d3
		move.w	#$10,d4
		add.w	d5,d5

loc_FF06:
		lea	($FFFFE380).w,a4
		move.w	(a4)+,d6
		beq.s	locret_FF1C

loc_FF0E:
		movea.w	(a4)+,a1
		move.b	$28(a1),d0
		bne.s	loc_FF1E

loc_FF16:
		subq.w	#2,d6
		bne.s	loc_FF0E
		moveq	#0,d0

locret_FF1C:
		rts
; ---------------------------------------------------------------------------

loc_FF1E:
		andi.w	#$3F,d0
		add.w	d0,d0
		lea	byte_FF62(pc,d0.w),a2
		moveq	#0,d1
		move.b	(a2)+,d1
		move.w	$10(a1),d0
		sub.w	d1,d0
		sub.w	d2,d0
		bcc.s	loc_FF3E
		add.w	d1,d1
		add.w	d1,d0
		bcs.s	loc_FF42
		bra.s	loc_FF16
; ---------------------------------------------------------------------------

loc_FF3E:
		cmp.w	d4,d0
		bhi.s	loc_FF16

loc_FF42:
		moveq	#0,d1
		move.b	(a2)+,d1
		move.w	$14(a1),d0
		sub.w	d1,d0
		sub.w	d3,d0
		bcc.s	loc_FF5A
		add.w	d1,d1
		add.w	d1,d0
		bcs.w	loc_FFD4
		bra.s	loc_FF16
; ---------------------------------------------------------------------------

loc_FF5A:
		cmp.w	d5,d0
		bhi.s	loc_FF16
		bra.w	loc_FFD4
; ---------------------------------------------------------------------------
byte_FF62:	dc.b    4,   4, $14, $14,  $C, $14, $14,  $C,   4, $10,  $C, $12, $10, $10,   6,   6, $18,  $C,  $C, $10
		dc.b  $10,   8,   8,   8, $14, $10, $14,   8,  $E,  $E, $18, $18, $28, $10, $10, $18,   8, $10, $20, $70
		dc.b  $40, $20, $80, $20, $20, $20,   8,   8,   4,   4, $20,   8,  $C,  $C,   8,   4, $18,   4, $28,   4
		dc.b    4,   8,   4, $18,   4, $28, $18, $18, $18, $18,  $C, $18, $48,   8, $18, $28, $10,   4, $20,   2
		dc.b  $10, $1C,  $C, $24, $10,   2,   4, $40, $18, $40, $20, $10, $1C, $14, $10,   2, $10,   1,   2,   8
		dc.b  $10, $40,  $C,   4,   8,  $C, $28, $20, $40,   2, $60,   2, $28, $28
; ---------------------------------------------------------------------------

loc_FFD4:
		move.b	$28(a1),d1
		andi.b	#$C0,d1
		beq.w	loc_100BC
		cmpi.b	#$C0,d1
		beq.w	loc_103BA
		tst.b	d1
		bmi.w	Touch_ChkHurt
		move.b	$28(a1),d0
		andi.b	#$3F,d0
		cmpi.b	#6,d0
		beq.s	loc_1001A
		move.b	($FFFFB034).w,d0
		tst.w	($FFFFFFE8).w
		beq.s	loc_1000A
		move.b	$34(a0),d0

loc_1000A:
		cmpi.b	#$5A,d0
		bcc.w	locret_10018
		move.b	#4,5(a1)

locret_10018:
		rts
; ---------------------------------------------------------------------------

loc_1001A:
		move.w	$1A(a0),d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_10026
		neg.w	d0

loc_10026:
		btst	#1,4(a1)
		beq.s	loc_10036
		tst.w	d0
		beq.s	loc_10080
		bmi.s	loc_10080
		bra.s	loc_1003A
; ---------------------------------------------------------------------------

loc_10036:
		tst.w	d0
		bpl.s	loc_10080

loc_1003A:
		btst	#1,$2A(a1)
		beq.s	loc_10080
		btst	#1,4(a1)
		bne.s	loc_1005A
		move.w	$14(a0),d0
		subi.w	#$10,d0
		cmp.w	$14(a1),d0
		bcs.s	locret_100BA
		bra.s	loc_10068
; ---------------------------------------------------------------------------

loc_1005A:
		move.w	$14(a0),d0
		addi.w	#$10,d0
		cmp.w	$14(a1),d0
		bcc.s	locret_100BA

loc_10068:
		neg.w	$1A(a0)
		move.w	#-$180,$1A(a1)
		tst.b	$3C(a1)
		bne.s	locret_100BA
		move.b	#4,$3C(a1)
		rts
; ---------------------------------------------------------------------------

loc_10080:

		cmpa.w	#$B000,a0
		beq.s	loc_1008C
		tst.w	($FFFFFFE8).w
		beq.s	locret_100BA

loc_1008C:
		cmpi.b	#2,$20(a0)
		beq.s	loc_100AC
		cmpi.b	#2,$38(a0)
		bne.s	locret_100BA
		cmpi.b	#1,$2F(a0)
		beq.s	loc_100AC
		cmpi.b	#3,$2F(a0)
		bne.s	locret_100BA

loc_100AC:

		neg.w	$1A(a0)
		move.b	#4,5(a1)
		move.w	a0,$42(a1)

locret_100BA:

		rts
; ---------------------------------------------------------------------------

loc_100BC:
		btst	#1,$2B(a0)
		bne.s	loc_1012E
		cmpi.b	#9,$20(a0)
		beq.s	loc_1012E
		cmpi.b	#2,$20(a0)
		beq.s	loc_1012E
		cmpi.b	#2,$38(a0)
		bne.s	loc_100F0
		cmpi.b	#1,$2F(a0)
		beq.s	loc_1012E
		cmpi.b	#3,$2F(a0)
		beq.s	loc_1012E
		bra.w	Touch_ChkHurt
; ---------------------------------------------------------------------------

loc_100F0:
		cmpi.b	#1,$38(a0)
		bne.w	Touch_ChkHurt
		tst.b	$2F(a0)

loc_100FE:
		beq.w	Touch_ChkHurt
		btst	#6,$2A(a0)
		bne.w	Touch_ChkHurt
		move.w	$10(a0),d1
		move.w	$14(a0),d2
		sub.w	$10(a1),d1
		sub.w	$14(a1),d2
		jsr	(GetArcTan).l
		subi.b	#$20,d0
		cmpi.b	#$40,d0
		bcc.w	Touch_ChkHurt

loc_1012E:

		tst.b	$29(a1)
		beq.s	loc_1019A
		neg.w	$18(a0)
		neg.w	$1A(a0)
		neg.w	$1C(a0)
		move.b	$28(a1),$25(a1)
		move.w	a0,d0
		move.b	d0,$1C(a1)
		move.b	#0,$28(a1)
		subq.b	#1,$29(a1)
		bne.s	loc_1015E
		bset	#7,$2A(a1)

loc_1015E:
		cmpi.b	#2,$38(a0)
		bne.s	locret_10198
		cmpi.b	#1,$2F(a0)
		bne.s	locret_10198
		move.b	#2,$2F(a0)
		move.b	#$21,$20(a0)
		bclr	#0,$2A(a0)

loc_10180:
		tst.w	$18(a0)
		bmi.s	loc_1018C
		bset	#0,$2A(a0)

loc_1018C:
		move.b	$44(a0),$1E(a0)
		move.b	$45(a0),$1F(a0)

locret_10198:

		rts
; ---------------------------------------------------------------------------

loc_1019A:
		btst	#2,$2A(a1)
		beq.s	loc_101AC
		move.b	$3B(a1),d0
		movea.w	$3C(a1),a2
		bclr	d0,(a2)

loc_101AC:
		bset	#7,$2A(a1)
		moveq	#0,d0
		move.w	($FFFFF7D0).w,d0
		addq.w	#2,($FFFFF7D0).w
		cmpi.w	#6,d0
		bcs.s	loc_101C4
		moveq	#6,d0

loc_101C4:
		move.w	d0,$3E(a1)
		move.w	word_10216(pc,d0.w),d0
		cmpi.w	#$20,($FFFFF7D0).w
		bcs.s	loc_101DE
		move.w	#$3E8,d0
		move.w	#$A,$3E(a1)

loc_101DE:
		movea.w	a0,a3
		bsr.w	HUD_AddToScore
		move.l	#Obj_Explosion,(a1)
		move.b	#0,5(a1)
		tst.w	$1A(a0)
		bmi.s	loc_10206
		move.w	$14(a0),d0
		cmp.w	$14(a1),d0
		bcc.s	loc_1020E
		neg.w	$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_10206:
		addi.w	#$100,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_1020E:
		subi.w	#$100,$1A(a0)
		rts
; ---------------------------------------------------------------------------
word_10216:	dc.w $A
		dc.w $14
		dc.w $32
		dc.w $64
; ---------------------------------------------------------------------------

Touch_ChkHurt:

		move.b	$2B(a0),d0
		andi.b	#$73,d0
		beq.s	Touch_ChkHurt_NoPowerUp
		and.b	$2B(a1),d0
		bne.s	Touch_ChkHurt_Return
		btst	#0,$2B(a0)
		bne.s	Touch_ChkHurt_HaveShield

Touch_ChkHurt2:

		btst	#1,$2B(a0)
		beq.s	HurtSonic

Touch_ChkHurt_Return:

		moveq	#-1,d0
		rts
; ---------------------------------------------------------------------------

Touch_ChkHurt_NoPowerUp:
		cmpi.b	#1,$2F(a0)
		bne.s	Touch_ChkHurt2

Touch_ChkHurt_HaveShield:
		move.b	$2B(a1),d0
		andi.b	#8,d0
		beq.s	Touch_ChkHurt2

Touch_ChkHurt_Bounce_Projectile:
		move.w	$10(a0),d1
		move.w	$14(a0),d2
		sub.w	$10(a1),d1
		sub.w	$14(a1),d2
		jsr	(GetArcTan).l
		jsr	(GetSineCosine).l
		muls.w	#-$800,d1
		asr.l	#8,d1
		move.w	d1,$18(a1)
		muls.w	#-$800,d0
		asr.l	#8,d0
		move.w	d0,$1A(a1)
		clr.b	$28(a1)
		bra.s	Touch_ChkHurt_Return
; ---------------------------------------------------------------------------

HurtSonic:
		nop
		tst.b	$34(a0)
		bne.s	Touch_ChkHurt_Return
		movea.l	a1,a2

HurtSonic2:

		move.w	($FFFFFE20).w,d0
		cmpa.w	#$B000,a0
		beq.s	loc_102A8
		tst.w	($FFFFFFE8).w
		beq.s	loc_102E0
		move.w	($FFFFFED0).w,d0

loc_102A8:
		btst	#0,$2B(a0)
		bne.s	loc_102DA
		tst.b	$37(a0)
		bmi.s	loc_102E0
		tst.w	d0
		beq.w	loc_10350
		jsr	(Create_New_Sprite).l
		bne.s	loc_102DA
		move.l	#Obj_Bouncing_Ring,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	a0,$3E(a1)

loc_102DA:

		andi.b	#-$72,$2B(a0)

loc_102E0:

		move.b	#4,5(a0)
		jsr	(Player_TouchFloor).l
		bset	#1,$2A(a0)
		move.w	#-$400,$1A(a0)
		move.w	#-$200,$18(a0)
		btst	#6,$2A(a0)
		beq.s	loc_10312
		move.w	#-$200,$1A(a0)
		move.w	#-$100,$18(a0)

loc_10312:
		move.w	$10(a0),d0
		cmp.w	$10(a2),d0
		bcs.s	loc_10320
		neg.w	$18(a0)

loc_10320:
		move.w	#0,$1C(a0)
		move.b	#$1A,$20(a0)
		move.b	#$78,$34(a0)
		moveq	#$35,d0
		cmpi.l	#Obj_Spikes,(a2)
		bcs.s	loc_10346
		cmpi.l	#sub_24280,(a2)
		bcc.s	loc_10346
		moveq	#$37,d0

loc_10346:

		jsr	(Play_Sound_2).l
		moveq	#-1,d0
		rts
; ---------------------------------------------------------------------------

loc_10350:
		moveq	#$35,d0
		cmpi.l	#Obj_Spikes,(a2)
		bcs.s	loc_10364
		cmpi.l	#sub_24280,(a2)
		bcc.s	loc_10364
		moveq	#$37,d0

loc_10364:

		bra.s	loc_1036E
; ---------------------------------------------------------------------------

Kill_Character:

		tst.w	($FFFFFE08).w
		bne.s	loc_103B6
		moveq	#$35,d0

loc_1036E:
		clr.b	$2B(a0)
		clr.b	$37(a0)
		move.b	#6,5(a0)
		move.w	d0,-(sp)
		jsr	(Player_TouchFloor).l
		move.w	(sp)+,d0
		bset	#1,$2A(a0)
		move.w	#-$700,$1A(a0)
		move.w	#0,$18(a0)
		move.w	#0,$1C(a0)
		move.b	#$18,$20(a0)
		move.w	$A(a0),($FFFFFFCE).w
		bset	#7,$A(a0)
		jsr	(Play_Sound_2).l

loc_103B6:
		moveq	#-1,d0
		rts
; ---------------------------------------------------------------------------

loc_103BA:
		move.b	$28(a1),d1
		andi.b	#$3F,d1
		cmpi.b	#7,d1
		beq.s	loc_103FA
		cmpi.b	#6,d1
		beq.s	loc_103FA
		cmpi.b	#$A,d1
		beq.s	loc_103FA
		cmpi.b	#$C,d1
		beq.s	loc_103FA
		cmpi.b	#$15,d1
		beq.s	loc_103FA
		cmpi.b	#$16,d1
		beq.s	loc_103FA
		cmpi.b	#$17,d1
		beq.s	loc_103FA
		cmpi.b	#$18,d1
		beq.s	loc_103FA
		cmpi.b	#$21,d1
		beq.s	loc_103FA
		rts
; ---------------------------------------------------------------------------

loc_103FA:

		move.w	a0,d1
		subi.w	#$B000,d1
		beq.s	loc_10406
		addq.b	#1,$29(a1)

loc_10406:
		addq.b	#1,$29(a1)
		rts
; End of function sub_FE6E


; =============== S U B R O U T I N E =======================================


Add_SpriteToCollisionResponseList:

		lea	($FFFFE380).w,a1
		cmpi.w	#$7E,(a1)
		bcc.s	locret_1041C
		addq.w	#2,(a1)
		adda.w	(a1),a1
		move.w	a0,(a1)

locret_1041C:
		rts
; End of function Add_SpriteToCollisionResponseList


; =============== S U B R O U T I N E =======================================


sub_1041E:
		move.b	$2B(a0),d0
		andi.b	#$71,d0
		beq.s	locret_1045C
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		subi.w	#$18,d2
		subi.w	#$18,d3
		move.w	#$30,d4
		move.w	#$30,d5
		lea	($FFFFE380).w,a4
		move.w	(a4)+,d6
		beq.s	locret_1045C

loc_10448:
		movea.w	(a4)+,a1
		move.b	$28(a1),d0
		andi.b	#$C0,d0
		cmpi.b	#$80,d0
		beq.s	loc_1045E

loc_10458:

		subq.w	#2,d6
		bne.s	loc_10448

locret_1045C:

		rts
; ---------------------------------------------------------------------------

loc_1045E:
		move.b	$28(a1),d0
		andi.w	#$3F,d0
		beq.s	loc_10458
		add.w	d0,d0
		lea	(byte_FF62).l,a2
		lea	(a2,d0.w),a2
		moveq	#0,d1
		move.b	(a2)+,d1
		move.w	$10(a1),d0
		sub.w	d1,d0
		sub.w	d2,d0
		bcc.s	loc_1048A
		add.w	d1,d1
		add.w	d1,d0
		bcs.s	loc_1048E
		bra.s	loc_10458
; ---------------------------------------------------------------------------

loc_1048A:
		cmp.w	d4,d0
		bhi.s	loc_10458

loc_1048E:
		moveq	#0,d1
		move.b	(a2)+,d1
		move.w	$14(a1),d0
		sub.w	d1,d0
		sub.w	d3,d0
		bcc.s	loc_104A6
		add.w	d1,d1
		add.w	d1,d0
		bcs.w	loc_104AA
		bra.s	loc_10458
; ---------------------------------------------------------------------------

loc_104A6:
		cmp.w	d5,d0
		bhi.s	loc_10458

loc_104AA:
		move.b	$2B(a1),d0
		andi.b	#8,d0
		beq.s	loc_10458
		move.w	$10(a0),d1
		move.w	$14(a0),d2
		sub.w	$10(a1),d1
		sub.w	$14(a1),d2
		jsr	(GetArcTan).l
		jsr	(GetSineCosine).l
		muls.w	#-$800,d1
		asr.l	#8,d1
		move.w	d1,$18(a1)
		muls.w	#-$800,d0
		asr.l	#8,d0
		move.w	d0,$1A(a1)
		clr.b	$28(a1)
		rts
; End of function sub_1041E


; =============== S U B R O U T I N E =======================================


sub_104EA:

		movem.l	a2-a4,-(sp)
		lea	($FFFFE380).w,a4
		move.w	(a4)+,d6
		beq.s	loc_10506

loc_104F6:
		movea.w	(a4)+,a1
		move.b	$28(a1),d0
		beq.s	loc_10500
		bsr.s	sub_1050C

loc_10500:
		subq.w	#2,d6
		bne.s	loc_104F6
		moveq	#0,d0

loc_10506:
		movem.l	(sp)+,a2-a4

locret_1050A:
		rts
; End of function sub_104EA


; =============== S U B R O U T I N E =======================================


sub_1050C:
		tst.b	4(a1)
		bpl.s	locret_10524
		andi.b	#-$40,d0
		beq.s	loc_10526
		cmpi.b	#-$40,d0
		beq.w	loc_1059C
		tst.b	d0
		bmi.s	loc_1058E

locret_10524:
		rts
; ---------------------------------------------------------------------------

loc_10526:
		tst.b	$29(a1)
		beq.s	loc_1052E
		rts
; ---------------------------------------------------------------------------

loc_1052E:

		btst	#2,$2A(a1)
		beq.s	loc_10540
		move.b	$3B(a1),d0
		movea.w	$3C(a1),a2
		bclr	d0,(a2)

loc_10540:
		bset	#7,$2A(a1)
		moveq	#0,d0
		move.w	($FFFFF7D0).w,d0
		addq.w	#2,($FFFFF7D0).w
		cmpi.w	#6,d0
		bcs.s	loc_10558
		moveq	#6,d0

loc_10558:
		move.w	d0,$3E(a1)
		move.w	word_10586(pc,d0.w),d0
		cmpi.w	#$20,($FFFFF7D0).w
		bcs.s	loc_10572
		move.w	#$3E8,d0
		move.w	#$A,$3E(a1)

loc_10572:
		movea.w	a0,a3
		bsr.w	HUD_AddToScore
		move.l	#Obj_Explosion,(a1)
		move.b	#0,5(a1)

locret_10584:
		rts
; ---------------------------------------------------------------------------
word_10586:	dc.w $A
		dc.w $14
		dc.w $32
		dc.w $64
; ---------------------------------------------------------------------------

loc_1058E:
		move.b	$2B(a1),d0
		andi.b	#8,d0

loc_10596:
		bne.w	Touch_ChkHurt_Bounce_Projectile
		rts
; ---------------------------------------------------------------------------

loc_1059C:
		ori.b	#3,$29(a1)
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_105B6
		move.w	$10(a1),($FFFFB05A).w
		move.w	$14(a1),($FFFFB05E).w

loc_105B6:
		move.b	#2,($FFFFB06A).w
		bset	#1,($FFFFB074).w
		rts
; End of function sub_1050C

; ---------------------------------------------------------------------------

Obj_Sonic2P:
		cmpa.w	#$B000,a0
		bne.s	loc_105F2
		lea	($FFFFF760).w,a4
		lea	($FFFFEE2C).w,a5
		lea	($FFFFCC54).w,a6
		move.b	($FFFFB082).w,d0
		cmp.b	$38(a0),d0
		bne.s	loc_105E6
		bchg	#3,4(a0)

loc_105E6:
		tst.w	($FFFFFE08).w
		beq.s	loc_1060E
		jmp	(DebugMode).l
; ---------------------------------------------------------------------------

loc_105F2:
		lea	($FFFFFEC0).w,a4
		lea	($FFFFEE2E).w,a5
		lea	($FFFFCC9E).w,a6
		move.b	($FFFFB038).w,d0
		cmp.b	$38(a0),d0
		bne.s	loc_1060E
		bchg	#4,4(a0)

loc_1060E:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_1061C(pc,d0.w),d1
		jmp	off_1061C(pc,d1.w)
; ---------------------------------------------------------------------------
off_1061C:	dc.w loc_10628-off_1061C

		dc.w loc_10740-off_1061C; 1
		dc.w loc_122BE-off_1061C; 2
		dc.w loc_12390-off_1061C; 3
		dc.w loc_1257C-off_1061C; 4
		dc.w loc_12590-off_1061C; 5
; ---------------------------------------------------------------------------

loc_10628:
		addq.b	#2,5(a0)
		move.b	#$B,$1E(a0)
		move.b	#5,$1F(a0)
		move.b	#$B,$44(a0)
		move.b	#5,$45(a0)
		move.w	#$100,8(a0)
		move.b	#$C,7(a0)
		move.b	#$C,6(a0)
		move.b	#4,4(a0)
		lea	(Character_Speeds).l,a1
		moveq	#0,d0
		move.b	$38(a0),d0
		lsl.w	#3,d0
		lea	(a1,d0.w),a1
		move.w	(a1)+,(a4)
		move.w	(a1)+,2(a4)
		move.w	(a1)+,4(a4)
		tst.b	($FFFFFE2A).w
		bne.w	loc_10724
		move.b	#$C,$46(a0)
		move.b	#$D,$47(a0)
		cmpa.w	#$B000,a0
		bne.s	loc_106DC
		move.w	#$680,$A(a0)
		move.l	#Map_Sonic2P,$C(a0)
		tst.b	$38(a0)
		beq.s	loc_106B4
		move.l	#Map_Knuckles2P,$C(a0)
		addi.w	#$2000,$A(a0)

loc_106B4:
		cmpi.b	#$12,($FFFFFE10).w
		bne.s	loc_106C2
		ori.w	#$8000,$A(a0)

loc_106C2:
		move.w	$10(a0),($FFFFFE2E).w
		move.w	$14(a0),($FFFFFE30).w
		move.w	$A(a0),($FFFFFE38).w
		move.w	$46(a0),($FFFFFE3A).w
		bra.s	loc_10724
; ---------------------------------------------------------------------------

loc_106DC:
		move.w	#$6A0,$A(a0)
		move.l	#Map_Sonic2P,$C(a0)
		tst.b	$38(a0)
		beq.s	loc_106FE
		move.l	#Map_Knuckles2P,$C(a0)
		addi.w	#$2000,$A(a0)

loc_106FE:
		cmpi.b	#$12,($FFFFFE10).w
		bne.s	loc_1070C
		ori.w	#$8000,$A(a0)

loc_1070C:
		move.w	$10(a0),($FFFFFE4C).w
		move.w	$14(a0),($FFFFFE4E).w
		move.w	$A(a0),($FFFFFE56).w
		move.w	$46(a0),($FFFFFE58).w

loc_10724:

		move.b	#0,$30(a0)
		move.b	#4,$31(a0)
		move.b	#0,($FFFFFE19).w
		move.b	#$1E,$2C(a0)
		bsr.w	Reset_Player_Position_Array

loc_10740:
		tst.w	($FFFFFFDA).w
		beq.s	loc_10760
		cmpa.w	#$B000,a0
		bne.s	loc_10760
		btst	#4,($FFFFF605).w
		beq.s	loc_10760
		move.w	#1,($FFFFFE08).w
		clr.b	($FFFFF7CA).w
		rts
; ---------------------------------------------------------------------------

loc_10760:

		cmpa.w	#$B000,a0
		bne.s	loc_10774
		tst.b	($FFFFF7CA).w
		bne.s	loc_10780
		move.w	($FFFFF604).w,($FFFFF602).w
		bra.s	loc_10780
; ---------------------------------------------------------------------------

loc_10774:
		tst.b	($FFFFF7CB).w
		bne.s	loc_10780
		move.w	($FFFFF606).w,($FFFFF602).w

loc_10780:

		bsr.w	sub_10C98
		btst	#0,$2E(a0)
		bne.s	loc_1079E
		moveq	#0,d0
		move.b	$2A(a0),d0
		andi.w	#6,d0
		move.w	off_107EE(pc,d0.w),d1
		jsr	off_107EE(pc,d1.w)

loc_1079E:
		cmpi.w	#-$100,($FFFFEE18).w
		bne.s	loc_107AE
		move.w	($FFFFEEAA).w,d0
		and.w	d0,$14(a0)

loc_107AE:
		move.w	($FFFFEEA8).w,d0
		and.w	d0,$10(a0)
		addi.w	#$400,$10(a0)
		bsr.w	sub_10D66
		move.b	($FFFFF768).w,$3A(a0)
		move.b	($FFFFF76A).w,$3B(a0)
		btst	#1,$2E(a0)
		bne.s	loc_107DC
		bsr.w	Animate_SonicKnuckles_2P
		bsr.w	SonicKnuckles2P_Load_PLC

loc_107DC:
		move.b	$2E(a0),d0
		andi.b	#$A0,d0
		bne.s	locret_107EC
		jsr	(sub_FE6E).l

locret_107EC:
		rts
; ---------------------------------------------------------------------------
off_107EE:	dc.w loc_107F6-off_107EE

		dc.w loc_10868-off_107EE
		dc.w loc_10896-off_107EE
		dc.w loc_108B8-off_107EE
; ---------------------------------------------------------------------------

loc_107F6:
		move.b	($FFFFF603).w,d0
		andi.b	#$70,d0
		bne.s	loc_10844
		cmpi.b	#$A,$20(a0)
		beq.s	locret_10866
		cmpi.b	#$B,$20(a0)
		beq.s	locret_10866
		cmpi.b	#5,$20(a0)
		bne.s	loc_10844
		cmpi.b	#$1E,$23(a0)
		bcs.s	loc_10844
		bsr.w	sub_11DA6
		move.b	($FFFFF602).w,d0
		andi.b	#$7F,d0
		beq.s	loc_1085E
		move.b	#$A,$20(a0)
		cmpi.b	#$AC,$23(a0)
		bcs.s	loc_1085E
		move.b	#$B,$20(a0)
		bra.s	loc_1085E
; ---------------------------------------------------------------------------

loc_10844:

		bsr.w	sub_1094C
		bsr.w	sub_117DA
		bsr.w	sub_11DA6
		bsr.w	Sonic_InputAcceleration_Path
		bsr.w	sub_108E6
		jsr	(MoveSprite2).l

loc_1085E:

		bsr.w	Player_AnglePos
		bsr.w	sub_11E2A

locret_10866:

		rts
; ---------------------------------------------------------------------------

loc_10868:
		bsr.w	Sonic_InstaAndShieldMoves
		bsr.w	sub_1164E
		jsr	(MoveSprite).l
		btst	#6,$2A(a0)
		beq.s	loc_10884
		subi.w	#$28,$1A(a0)

loc_10884:
		bsr.w	sub_11E8C
		movem.l	a4-a6,-(sp)
		bsr.w	sub_11EEC
		movem.l	(sp)+,a4-a6
		rts
; ---------------------------------------------------------------------------

loc_10896:
		tst.b	$3D(a0)
		bne.s	loc_108A0
		bsr.w	sub_117DA

loc_108A0:
		bsr.w	sub_11DEE
		bsr.w	sub_11508
		jsr	(MoveSprite2).l
		bsr.w	Player_AnglePos
		bsr.w	sub_11E2A
		rts
; ---------------------------------------------------------------------------

loc_108B8:
		bsr.w	Sonic_InstaAndShieldMoves
		bsr.w	sub_1164E
		jsr	(MoveSprite).l
		btst	#6,$2A(a0)
		beq.s	loc_108D4
		subi.w	#$28,$1A(a0)

loc_108D4:
		bsr.w	sub_11E8C
		movem.l	a4-a6,-(sp)
		bsr.w	sub_11EEC
		movem.l	(sp)+,a4-a6
		rts

; =============== S U B R O U T I N E =======================================


sub_108E6:
		tst.b	$2B(a0)
		bmi.s	locret_1090C
		move.w	$1C(a0),d0
		bpl.s	loc_108F4
		neg.w	d0

loc_108F4:
		cmpi.w	#$80,d0
		bcs.s	locret_1090C
		move.b	($FFFFF602).w,d0
		andi.b	#$C,d0
		bne.s	locret_1090C
		btst	#1,($FFFFF602).w
		bne.s	loc_1090E

locret_1090C:

		rts
; ---------------------------------------------------------------------------

loc_1090E:
		btst	#2,$2A(a0)
		beq.s	loc_10918
		rts
; ---------------------------------------------------------------------------

loc_10918:
		bset	#2,$2A(a0)
		move.b	#7,$1E(a0)
		move.b	#3,$1F(a0)
		move.b	#2,$20(a0)
		addq.w	#4,$14(a0)
		move.w	#$3C,d0
		jsr	(Play_Sound_2).l
		tst.w	$1C(a0)
		bne.s	locret_1094A
		move.w	#$200,$1C(a0)

locret_1094A:
		rts
; End of function sub_108E6


; =============== S U B R O U T I N E =======================================


sub_1094C:
		tst.b	$3D(a0)
		bne.s	loc_10998
		cmpi.b	#8,$20(a0)
		bne.s	locret_10996
		move.b	($FFFFF603).w,d0
		andi.b	#$70,d0
		beq.w	locret_10996
		move.b	#9,$20(a0)
		move.w	#$FFAB,d0
		jsr	(Play_Sound_2).l
		addq.l	#4,sp
		move.b	#1,$3D(a0)
		move.w	#0,$3E(a0)
		cmpi.b	#$C,$2C(a0)
		bcs.s	loc_10992
		move.b	#2,$20(a6)

loc_10992:
		bsr.w	Player_AnglePos

locret_10996:

		rts
; ---------------------------------------------------------------------------

loc_10998:
		move.b	($FFFFF602).w,d0
		btst	#1,d0
		bne.w	loc_10A38
		move.b	#7,$1E(a0)
		move.b	#3,$1F(a0)
		move.b	#2,$20(a0)
		addq.w	#4,$14(a0)
		move.b	#0,$3D(a0)
		moveq	#0,d0
		move.b	$3E(a0),d0
		add.w	d0,d0
		move.w	word_10A14(pc,d0.w),$1C(a0)
		move.w	$1C(a0),d0
		subi.w	#$800,d0
		add.w	d0,d0
		andi.w	#$1F00,d0
		neg.w	d0
		addi.w	#$2000,d0
		lea	($FFFFEE24).w,a1
		cmpa.w	#$B000,a0
		beq.s	loc_109F0
		lea	($FFFFEE28).w,a1

loc_109F0:
		move.w	d0,(a1)
		btst	#0,$2A(a0)
		beq.s	loc_109FE
		neg.w	$1C(a0)

loc_109FE:
		bset	#2,$2A(a0)
		move.b	#0,$20(a6)
		moveq	#-$4A,d0
		jsr	(Play_Sound_2).l
		bra.s	loc_10A80
; ---------------------------------------------------------------------------
word_10A14:	dc.w $800
		dc.w $880
		dc.w $900
		dc.w $980
		dc.w $A00
		dc.w $A80
		dc.w $B00
		dc.w $B80
		dc.w $C00
		dc.w $B00
		dc.w $B80
		dc.w $C00
		dc.w $C80
		dc.w $D00
		dc.w $D80
		dc.w $E00
		dc.w $E80
		dc.w $F00
; ---------------------------------------------------------------------------

loc_10A38:
		tst.w	$3E(a0)
		beq.s	loc_10A50
		move.w	$3E(a0),d0
		lsr.w	#5,d0
		sub.w	d0,$3E(a0)
		bcc.s	loc_10A50
		move.w	#0,$3E(a0)

loc_10A50:

		move.b	($FFFFF603).w,d0
		andi.b	#$70,d0
		beq.w	loc_10A80
		move.w	#$900,$20(a0)
		move.w	#$FFAB,d0
		jsr	(Play_Sound_2).l
		addi.w	#$200,$3E(a0)
		cmpi.w	#$800,$3E(a0)
		bcs.s	loc_10A80
		move.w	#$800,$3E(a0)

loc_10A80:

		addq.l	#4,sp
		cmpi.w	#$60,(a5)
		beq.s	loc_10A8E
		bcc.s	loc_10A8C
		addq.w	#4,(a5)

loc_10A8C:
		subq.w	#2,(a5)

loc_10A8E:
		bsr.w	Player_AnglePos
		rts
; End of function sub_1094C

; ---------------------------------------------------------------------------

Obj_Sonic:
		lea	($FFFFF760).w,a4
		lea	($FFFFEE2C).w,a5
		lea	($FFFFCC54).w,a6
		tst.w	($FFFFFE08).w
		beq.s	loc_10ADE
		cmpi.b	#1,($FFFFFE09).w
		beq.s	loc_10AD8
		btst	#4,($FFFFF605).w
		beq.s	loc_10ABC
		move.w	#0,($FFFFFE08).w

loc_10ABC:
		addq.b	#1,$22(a0)
		cmpi.b	#$FB,$22(a0)
		bcs.s	loc_10ACE
		move.b	#0,$22(a0)

loc_10ACE:
		bsr.w	Sonic_Load_PLC
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_10AD8:
		jmp	(DebugMode).l
; ---------------------------------------------------------------------------

loc_10ADE:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_10AEC(pc,d0.w),d1
		jmp	off_10AEC(pc,d1.w)
; ---------------------------------------------------------------------------
off_10AEC:	dc.w loc_10AFA-off_10AEC

		dc.w loc_10BBA-off_10AEC; 1
		dc.w loc_122BE-off_10AEC; 2
		dc.w loc_12390-off_10AEC; 3
		dc.w loc_1257C-off_10AEC; 4
		dc.w loc_12590-off_10AEC; 5
		dc.w loc_125AC-off_10AEC; 6
; ---------------------------------------------------------------------------

loc_10AFA:
		addq.b	#2,5(a0)
		move.b	#$13,$1E(a0)
		move.b	#9,$1F(a0)
		move.b	#$13,$44(a0)
		move.b	#9,$45(a0)
		move.l	#Map_Sonic,$C(a0)
		move.w	#$100,8(a0)
		move.b	#$18,7(a0)
		move.b	#$18,6(a0)
		move.b	#4,4(a0)
		move.b	#0,$38(a0)
		move.w	#$600,(a4)
		move.w	#$C,2(a4)
		move.w	#$80,4(a4)
		tst.b	($FFFFFE2A).w
		bne.s	loc_10B84
		move.w	#$680,$A(a0)
		move.b	#$C,$46(a0)
		move.b	#$D,$47(a0)
		cmpi.b	#2,($FFFFFE48).w
		beq.s	loc_10B84
		move.w	$10(a0),($FFFFFE2E).w
		move.w	$14(a0),($FFFFFE30).w
		move.w	$A(a0),($FFFFFE38).w
		move.w	$46(a0),($FFFFFE3A).w

loc_10B84:

		move.b	#0,$30(a0)
		move.b	#4,$31(a0)
		move.b	#0,($FFFFFE19).w
		move.b	#$1E,$2C(a0)
		subi.w	#$20,$10(a0)
		addi.w	#4,$14(a0)
		bsr.w	Reset_Player_Position_Array
		addi.w	#$20,$10(a0)
		subi.w	#4,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_10BBA:
		tst.w	($FFFFFFDA).w
		beq.s	loc_10BF0
		bclr	#6,($FFFFF605).w
		beq.s	loc_10BCE
		eori.b	#1,($FFFFF7C6).w

loc_10BCE:
		btst	#4,($FFFFF605).w
		beq.s	loc_10BF0
		move.w	#1,($FFFFFE08).w
		clr.b	($FFFFF7CA).w
		btst	#5,($FFFFF604).w
		beq.s	locret_10BEE
		move.w	#2,($FFFFFE08).w

locret_10BEE:
		rts
; ---------------------------------------------------------------------------

loc_10BF0:

		tst.b	($FFFFF7CA).w
		bne.s	loc_10BFC
		move.w	($FFFFF604).w,($FFFFF602).w

loc_10BFC:
		btst	#0,$2E(a0)
		beq.s	loc_10C0C
		move.b	#0,$2F(a0)
		bra.s	loc_10C26
; ---------------------------------------------------------------------------

loc_10C0C:
		movem.l	a4-a6,-(sp)
		moveq	#0,d0
		move.b	$2A(a0),d0
		andi.w	#6,d0
		move.w	off_10C90(pc,d0.w),d1
		jsr	off_10C90(pc,d1.w)
		movem.l	(sp)+,a4-a6

loc_10C26:
		cmpi.w	#-$100,($FFFFEE18).w
		bne.s	loc_10C36
		move.w	($FFFFEEAA).w,d0
		and.w	d0,$14(a0)

loc_10C36:
		bsr.s	sub_10C98
		bsr.w	sub_11B30
		bsr.w	sub_10D66
		bsr.w	sub_10E26
		move.b	($FFFFF768).w,$3A(a0)
		move.b	($FFFFF76A).w,$3B(a0)
		tst.b	($FFFFF7C8).w
		beq.s	loc_10C62
		tst.b	$20(a0)
		bne.s	loc_10C62
		move.b	$21(a0),$20(a0)

loc_10C62:

		btst	#1,$2E(a0)
		bne.s	loc_10C7E
		bsr.w	Animate_Sonic
		tst.b	($FFFFF7C6).w
		beq.s	loc_10C7A
		eori.b	#2,4(a0)

loc_10C7A:
		bsr.w	Sonic_Load_PLC

loc_10C7E:
		move.b	$2E(a0),d0
		andi.b	#$A0,d0
		bne.s	locret_10C8E
		jsr	(Test_Sprite_Collisions).l

locret_10C8E:
		rts
; ---------------------------------------------------------------------------
off_10C90:	dc.w Sonic_Stand_Path-off_10C90

		dc.w Sonic_Stand_Freespace-off_10C90
		dc.w Sonic_Spin_Path-off_10C90
		dc.w Sonic_Spin_Freespace-off_10C90

; =============== S U B R O U T I N E =======================================


sub_10C98:

		move.b	$34(a0),d0
		beq.s	loc_10CA6
		subq.b	#1,$34(a0)
		lsr.b	#3,d0
		bcc.s	loc_10CAC

loc_10CA6:
		jsr	(Draw_Sprite).l

loc_10CAC:
		btst	#1,$2B(a0)
		beq.s	loc_10CE8
		tst.b	$35(a0)
		beq.s	loc_10CE8
		move.b	($FFFFFE05).w,d0
		andi.b	#7,d0
		bne.s	loc_10CE8
		subq.b	#1,$35(a0)
		bne.s	loc_10CE8
		tst.b	($FFFFF7AA).w
		bne.s	loc_10CE2
		cmpi.b	#$C,$2C(a0)
		bcs.s	loc_10CE2
		move.w	($FFFFFF90).w,d0
		jsr	(Play_Sound).l

loc_10CE2:

		bclr	#1,$2B(a0)

loc_10CE8:

		btst	#2,$2B(a0)
		beq.s	locret_10D40
		tst.b	$36(a0)
		beq.s	locret_10D40
		move.b	($FFFFFE05).w,d0
		andi.b	#7,d0
		bne.s	locret_10D40
		subq.b	#1,$36(a0)
		bne.s	locret_10D40
		tst.w	($FFFFFFE8).w
		bne.s	loc_10D42
		move.w	#$600,(a4)
		move.w	#$C,2(a4)
		move.w	#$80,4(a4)
		tst.b	($FFFFFE19).w
		beq.s	loc_10D32
		move.w	#$A00,(a4)
		move.w	#$30,2(a4)
		move.w	#$100,4(a4)

loc_10D32:
		bclr	#2,$2B(a0)
		moveq	#0,d0
		jmp	(Change_Music_Tempo).l
; ---------------------------------------------------------------------------

locret_10D40:

		rts
; ---------------------------------------------------------------------------

loc_10D42:
		lea	(Character_Speeds).l,a1
		moveq	#0,d0
		move.b	$38(a0),d0
		lsl.w	#3,d0
		lea	(a1,d0.w),a1
		move.w	(a1)+,(a4)
		move.w	(a1)+,2(a4)
		move.w	(a1)+,4(a4)
		bclr	#2,$2B(a0)
		rts
; End of function sub_10C98


; =============== S U B R O U T I N E =======================================


sub_10D66:

		tst.w	($FFFFFFE8).w
		bne.s	loc_10DA0
		cmpa.w	#$B000,a0
		bne.s	locret_10D9E
		move.w	($FFFFEE26).w,d0
		lea	($FFFFE500).w,a1
		lea	(a1,d0.w),a1
		move.w	$10(a0),(a1)+
		move.w	$14(a0),(a1)+
		addq.b	#4,($FFFFEE27).w
		lea	($FFFFE400).w,a1
		lea	(a1,d0.w),a1
		move.w	($FFFFF602).w,(a1)+
		move.b	$2A(a0),(a1)+
		move.b	$A(a0),(a1)+

locret_10D9E:
		rts
; ---------------------------------------------------------------------------

loc_10DA0:
		cmpa.w	#$B000,a0
		bne.s	loc_10DC0
		move.w	($FFFFEE26).w,d0
		lea	($FFFFE500).w,a1
		lea	(a1,d0.w),a1
		move.w	$10(a0),(a1)+
		move.w	$14(a0),(a1)+
		addq.b	#4,($FFFFEE27).w
		rts
; ---------------------------------------------------------------------------

loc_10DC0:
		move.w	($FFFFEE2A).w,d0
		lea	($FFFFE400).w,a1
		lea	(a1,d0.w),a1
		move.w	$10(a0),(a1)+
		move.w	$14(a0),(a1)+
		addq.b	#4,($FFFFEE2B).w
		rts
; End of function sub_10D66


; =============== S U B R O U T I N E =======================================


Reset_Player_Position_Array:

		cmpa.w	#$B000,a0
		bne.s	loc_10E04
		lea	($FFFFE500).w,a1
		lea	($FFFFE400).w,a2
		move.w	#$3F,d0

loc_10DEC:
		move.w	$10(a0),(a1)+
		move.w	$14(a0),(a1)+
		move.l	#0,(a2)+
		dbf	d0,loc_10DEC
		move.w	#0,($FFFFEE26).w

loc_10E04:
		tst.w	($FFFFFFE8).w
		beq.s	locret_10E24
		lea	($FFFFE400).w,a1
		move.w	#$3F,d0

loc_10E12:
		move.w	$10(a0),(a1)+
		move.w	$14(a0),(a1)+
		dbf	d0,loc_10E12
		move.w	#0,($FFFFEE2A).w

locret_10E24:
		rts
; End of function Reset_Player_Position_Array


; =============== S U B R O U T I N E =======================================


sub_10E26:
		tst.b	($FFFFF730).w
		bne.s	loc_10E2E

locret_10E2C:

		rts
; ---------------------------------------------------------------------------

loc_10E2E:
		move.w	($FFFFF646).w,d0
		cmp.w	$14(a0),d0
		bge.s	loc_10EA6
		bset	#6,$2A(a0)
		bne.s	locret_10E2C
		addq.b	#1,($FFFFF64D).w
		movea.l	a0,a1
		bsr.w	Player_ResetAirTimer
		move.l	#Obj_Air_CountDown,($FFFFCB2C).w
		move.b	#$81,($FFFFCB58).w
		move.l	a0,($FFFFCB6C).w
		move.w	#$300,(a4)
		move.w	#6,2(a4)
		move.w	#$40,4(a4)
		tst.b	($FFFFFE19).w
		beq.s	loc_10E82
		move.w	#$500,(a4)
		move.w	#$18,2(a4)
		move.w	#$80,4(a4)

loc_10E82:
		tst.b	$2E(a0)
		bne.s	locret_10E2C
		asr	$18(a0)
		asr	$1A(a0)
		asr	$1A(a0)
		beq.s	locret_10E2C
		move.w	#$100,$20(a6)
		move.w	#$39,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

loc_10EA6:
		bclr	#6,$2A(a0)
		beq.w	locret_10E2C
		addq.b	#1,($FFFFF64D).w
		movea.l	a0,a1
		bsr.w	Player_ResetAirTimer
		move.w	#$600,(a4)
		move.w	#$C,2(a4)
		move.w	#$80,4(a4)
		tst.b	($FFFFFE19).w
		beq.s	loc_10EE0
		move.w	#$A00,(a4)
		move.w	#$30,2(a4)
		move.w	#$100,4(a4)

loc_10EE0:
		cmpi.b	#4,5(a0)
		beq.s	loc_10EFC
		tst.b	$2E(a0)
		bne.s	loc_10EFC
		move.w	$1A(a0),d0
		cmpi.w	#-$400,d0
		blt.s	loc_10EFC
		asl	$1A(a0)

loc_10EFC:

		cmpi.b	#$1C,$20(a0)
		beq.w	locret_10E2C
		tst.w	$1A(a0)
		beq.w	locret_10E2C
		move.w	#$100,$20(a6)
		cmpi.w	#-$1000,$1A(a0)
		bgt.s	loc_10F22
		move.w	#-$1000,$1A(a0)

loc_10F22:
		move.w	#$39,d0
		jmp	(Play_Sound_2).l
; End of function sub_10E26

; ---------------------------------------------------------------------------

Sonic_Stand_Path:
		bsr.w	Player_Spindash
		bsr.w	sub_117DA
		bsr.w	sub_11DA6
		bsr.w	Sonic_InputAcceleration_Path
		bsr.w	Player_Spin
		bsr.w	Player_Check_Screen_Boundaries
		jsr	(MoveSprite_TestGravity2).l
		bsr.w	Call_Player_AnglePos
		bsr.w	sub_11E2A
		tst.b	($FFFFF664).w
		beq.s	locret_10F82
		bsr.w	sub_F846
		tst.w	d1
		bmi.w	Kill_Character
		movem.l	a4-a6,-(sp)
		bsr.w	sub_FD9A
		tst.w	d1
		bpl.s	loc_10F72
		sub.w	d1,$10(a0)

loc_10F72:
		bsr.w	sub_FA7A
		tst.w	d1
		bpl.s	loc_10F7E
		add.w	d1,$10(a0)

loc_10F7E:
		movem.l	(sp)+,a4-a6

locret_10F82:
		rts

; =============== S U B R O U T I N E =======================================


Call_Player_AnglePos:

		tst.b	($FFFFF7C6).w
		beq.w	Player_AnglePos
		move.b	$26(a0),d0
		addi.b	#$40,d0
		neg.b	d0
		subi.b	#$40,d0
		move.b	d0,$26(a0)
		bsr.w	Player_AnglePos
		move.b	$26(a0),d0
		addi.b	#$40,d0
		neg.b	d0
		subi.b	#$40,d0
		move.b	d0,$26(a0)
		rts
; End of function Call_Player_AnglePos

; ---------------------------------------------------------------------------

Sonic_Stand_Freespace:
		bsr.w	Sonic_InstaAndShieldMoves
		bsr.w	sub_1164E
		bsr.w	Player_Check_Screen_Boundaries
		jsr	(MoveSprite_TestGravity).l
		btst	#6,$2A(a0)
		beq.s	loc_10FD6
		subi.w	#$28,$1A(a0)

loc_10FD6:
		bsr.w	sub_11E8C
		bsr.w	sub_11EEC
		rts
; ---------------------------------------------------------------------------

Sonic_Spin_Path:
		tst.b	$3D(a0)
		bne.s	loc_10FEA
		bsr.w	sub_117DA

loc_10FEA:
		bsr.w	sub_11DEE
		bsr.w	sub_11508
		bsr.w	Player_Check_Screen_Boundaries
		jsr	(MoveSprite_TestGravity2).l
		bsr.w	Call_Player_AnglePos
		bsr.w	sub_11E2A
		tst.b	($FFFFF664).w
		beq.s	locret_11034
		bsr.w	sub_F846
		tst.w	d1
		bmi.w	Kill_Character
		movem.l	a4-a6,-(sp)
		bsr.w	sub_FD9A
		tst.w	d1
		bpl.s	loc_11024
		sub.w	d1,$10(a0)

loc_11024:
		bsr.w	sub_FA7A
		tst.w	d1
		bpl.s	loc_11030
		add.w	d1,$10(a0)

loc_11030:
		movem.l	(sp)+,a4-a6

locret_11034:
		rts
; ---------------------------------------------------------------------------

Sonic_Spin_Freespace:
		bsr.w	Sonic_InstaAndShieldMoves
		bsr.w	sub_1164E
		bsr.w	Player_Check_Screen_Boundaries
		jsr	(MoveSprite_TestGravity).l
		btst	#6,$2A(a0)
		beq.s	loc_11056
		subi.w	#$28,$1A(a0)

loc_11056:
		bsr.w	sub_11E8C
		bsr.w	sub_11EEC
		rts

; =============== S U B R O U T I N E =======================================


Sonic_InputAcceleration_Path:

		move.w	(a4),d6
		move.w	2(a4),d5
		move.w	4(a4),d4
		tst.b	$2B(a0)
		bmi.w	loc_11332
		tst.w	$32(a0)
		bne.w	loc_112EA
		btst	#2,($FFFFF602).w
		beq.s	loc_11086
		bsr.w	sub_113F6

loc_11086:
		btst	#3,($FFFFF602).w
		beq.s	loc_11092
		bsr.w	sub_11482

loc_11092:
		move.b	$26(a0),d0
		addi.b	#$20,d0
		andi.b	#-$40,d0
		bne.w	loc_112EA
		tst.w	$1C(a0)
		bne.w	loc_112EA
		bclr	#5,$2A(a0)
		move.b	#5,$20(a0)
		btst	#3,$2A(a0)
		beq.w	loc_11184
		movea.w	$42(a0),a1
		tst.b	$2A(a1)
		bmi.w	loc_11276
		moveq	#0,d1
		move.b	7(a1),d1
		move.w	d1,d2
		add.w	d2,d2
		subq.w	#2,d2
		add.w	$10(a0),d1
		sub.w	$10(a1),d1
		tst.b	($FFFFFE19).w
		bne.w	loc_110F6
		cmpi.w	#2,d1
		blt.s	loc_11146
		cmp.w	d2,d1
		bge.s	loc_11108
		bra.w	loc_11276
; ---------------------------------------------------------------------------

loc_110F6:
		cmpi.w	#2,d1
		blt.w	loc_11268
		cmp.w	d2,d1
		bge.w	loc_11258
		bra.w	loc_11276
; ---------------------------------------------------------------------------

loc_11108:
		btst	#0,$2A(a0)
		bne.s	loc_11128
		move.b	#6,$20(a0)
		addq.w	#6,d2
		cmp.w	d2,d1
		blt.w	loc_112EA
		move.b	#$C,$20(a0)
		bra.w	loc_112EA
; ---------------------------------------------------------------------------

loc_11128:
		bclr	#0,$2A(a0)
		move.b	#6,$20(a0)
		addq.w	#6,d2
		cmp.w	d2,d1
		blt.w	loc_112EA
		move.b	#$C,$20(a0)
		bra.w	loc_112EA
; ---------------------------------------------------------------------------

loc_11146:
		btst	#0,$2A(a0)
		beq.s	loc_11166
		move.b	#6,$20(a0)
		cmpi.w	#-4,d1
		bge.w	loc_112EA
		move.b	#$C,$20(a0)
		bra.w	loc_112EA
; ---------------------------------------------------------------------------

loc_11166:
		bset	#0,$2A(a0)
		move.b	#6,$20(a0)
		cmpi.w	#-4,d1
		bge.w	loc_112EA
		move.b	#$C,$20(a0)
		bra.w	loc_112EA
; ---------------------------------------------------------------------------

loc_11184:
		move.w	$10(a0),d3
		bsr.w	sub_12006
		cmpi.w	#$C,d1
		blt.w	loc_11276
		tst.b	($FFFFFE19).w
		bne.w	loc_11250
		cmpi.b	#3,$3A(a0)
		bne.s	loc_111F6
		btst	#0,$2A(a0)
		bne.s	loc_111CE
		move.b	#6,$20(a0)
		move.w	$10(a0),d3
		subq.w	#6,d3
		bsr.w	sub_12006
		cmpi.w	#$C,d1
		blt.w	loc_112EA
		move.b	#$C,$20(a0)
		bra.w	loc_112EA
; ---------------------------------------------------------------------------

loc_111CE:
		bclr	#0,$2A(a0)
		move.b	#6,$20(a0)
		move.w	$10(a0),d3
		subq.w	#6,d3
		bsr.w	sub_12006
		cmpi.w	#$C,d1
		blt.w	loc_112EA
		move.b	#$C,$20(a0)
		bra.w	loc_112EA
; ---------------------------------------------------------------------------

loc_111F6:
		cmpi.b	#3,$3B(a0)
		bne.s	loc_11276
		btst	#0,$2A(a0)
		beq.s	loc_11228
		move.b	#6,$20(a0)
		move.w	$10(a0),d3
		addq.w	#6,d3
		bsr.w	sub_12006
		cmpi.w	#$C,d1
		blt.w	loc_112EA
		move.b	#$C,$20(a0)
		bra.w	loc_112EA
; ---------------------------------------------------------------------------

loc_11228:
		bset	#0,$2A(a0)
		move.b	#6,$20(a0)
		move.w	$10(a0),d3
		addq.w	#6,d3
		bsr.w	sub_12006
		cmpi.w	#$C,d1
		blt.w	loc_112EA
		move.b	#$C,$20(a0)
		bra.w	loc_112EA
; ---------------------------------------------------------------------------

loc_11250:
		cmpi.b	#3,$3A(a0)
		bne.s	loc_11260

loc_11258:
		bclr	#0,$2A(a0)
		bra.s	loc_1126E
; ---------------------------------------------------------------------------

loc_11260:
		cmpi.b	#3,$3B(a0)
		bne.s	loc_11276

loc_11268:
		bset	#0,$2A(a0)

loc_1126E:
		move.b	#6,$20(a0)
		bra.s	loc_112EA
; ---------------------------------------------------------------------------

loc_11276:
					; Sonic_InputAcceleration_Path+92j ...
		btst	#1,($FFFFF602).w
		beq.s	loc_112B0
		move.b	#8,$20(a0)
		addq.b	#1,$39(a0)
		cmpi.b	#$78,$39(a0)
		bcs.s	loc_112F0
		move.b	#$78,$39(a0)
		tst.b	($FFFFF7C6).w
		bne.s	loc_112A6
		cmpi.w	#8,(a5)
		beq.s	loc_112FC
		subq.w	#2,(a5)
		bra.s	loc_112FC
; ---------------------------------------------------------------------------

loc_112A6:
		cmpi.w	#$D8,(a5)
		beq.s	loc_112FC
		addq.w	#2,(a5)
		bra.s	loc_112FC
; ---------------------------------------------------------------------------

loc_112B0:
		btst	#0,($FFFFF602).w
		beq.s	loc_112EA
		move.b	#7,$20(a0)
		addq.b	#1,$39(a0)
		cmpi.b	#$78,$39(a0)
		bcs.s	loc_112F0
		move.b	#$78,$39(a0)
		tst.b	($FFFFF7C6).w
		bne.s	loc_112E0
		cmpi.w	#$C8,(a5)
		beq.s	loc_112FC
		addq.w	#2,(a5)
		bra.s	loc_112FC
; ---------------------------------------------------------------------------

loc_112E0:
		cmpi.w	#$18,(a5)
		beq.s	loc_112FC
		subq.w	#2,(a5)
		bra.s	loc_112FC
; ---------------------------------------------------------------------------

loc_112EA:
					; Sonic_InputAcceleration_Path+3Ej ...
		move.b	#0,$39(a0)

loc_112F0:
					; Sonic_InputAcceleration_Path+268j
		cmpi.w	#$60,(a5)
		beq.s	loc_112FC
		bcc.s	loc_112FA
		addq.w	#4,(a5)

loc_112FA:
		subq.w	#2,(a5)

loc_112FC:
					; Sonic_InputAcceleration_Path+244j ...
		tst.b	($FFFFFE19).w
		beq.s	loc_11306
		move.w	#$C,d5

loc_11306:
		move.b	($FFFFF602).w,d0
		andi.b	#$C,d0
		bne.s	loc_11332
		move.w	$1C(a0),d0
		beq.s	loc_11332
		bmi.s	loc_11326
		sub.w	d5,d0
		bcc.s	loc_11320
		move.w	#0,d0

loc_11320:
		move.w	d0,$1C(a0)
		bra.s	loc_11332
; ---------------------------------------------------------------------------

loc_11326:
		add.w	d5,d0
		bcc.s	loc_1132E
		move.w	#0,d0

loc_1132E:
		move.w	d0,$1C(a0)

loc_11332:
					; Sonic_InputAcceleration_Path+2AEj ...
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		muls.w	$1C(a0),d1
		asr.l	#8,d1
		move.w	d1,$18(a0)
		muls.w	$1C(a0),d0
		asr.l	#8,d0
		move.w	d0,$1A(a0)

loc_11350:
		btst	#6,$2E(a0)
		bne.w	locret_113F4
		move.b	$26(a0),d0
		andi.b	#$3F,d0
		beq.s	loc_11370
		move.b	$26(a0),d0
		addi.b	#$40,d0
		bmi.w	locret_113F4

loc_11370:
		move.b	#$40,d1
		tst.w	$1C(a0)
		beq.s	locret_113F4
		bmi.s	loc_1137E
		neg.w	d1

loc_1137E:
		move.b	$26(a0),d0
		add.b	d1,d0
		move.w	d0,-(sp)
		bsr.w	sub_F61C
		move.w	(sp)+,d0
		tst.w	d1
		bpl.s	locret_113F4
		asl.w	#8,d1
		cmpi.b	#8,($FFFFFE10).w
		bne.s	loc_113A0
		tst.b	d0
		bpl.s	loc_113A0
		subq.b	#1,d0

loc_113A0:
					; Sonic_InputAcceleration_Path+33Cj
		addi.b	#$20,d0
		andi.b	#$C0,d0
		beq.s	loc_113F0
		cmpi.b	#$40,d0
		beq.s	loc_113D6
		cmpi.b	#$80,d0
		beq.s	loc_113D0
		add.w	d1,$18(a0)
		move.w	#0,$1C(a0)
		btst	#0,$2A(a0)
		bne.s	locret_113CE
		bset	#5,$2A(a0)

locret_113CE:
					; Sonic_InputAcceleration_Path+386j
		rts
; ---------------------------------------------------------------------------

loc_113D0:
		sub.w	d1,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_113D6:
		sub.w	d1,$18(a0)
		move.w	#0,$1C(a0)
		btst	#0,$2A(a0)
		beq.s	locret_113CE
		bset	#5,$2A(a0)
		rts
; ---------------------------------------------------------------------------

loc_113F0:
		add.w	d1,$1A(a0)

locret_113F4:
					; Sonic_InputAcceleration_Path+30Cj ...
		rts
; End of function Sonic_InputAcceleration_Path


; =============== S U B R O U T I N E =======================================


sub_113F6:
		move.w	$1C(a0),d0
		beq.s	loc_113FE
		bpl.s	loc_11430

loc_113FE:
		bset	#0,$2A(a0)
		bne.s	loc_11412
		bclr	#5,$2A(a0)
		move.b	#1,$21(a0)

loc_11412:
		sub.w	d5,d0
		move.w	d6,d1
		neg.w	d1
		cmp.w	d1,d0
		bgt.s	loc_11424
		add.w	d5,d0
		cmp.w	d1,d0
		ble.s	loc_11424
		move.w	d1,d0

loc_11424:

		move.w	d0,$1C(a0)
		move.b	#0,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_11430:
		sub.w	d4,d0
		bcc.s	loc_11438
		move.w	#-$80,d0

loc_11438:
		move.w	d0,$1C(a0)
		move.b	$26(a0),d0
		addi.b	#$20,d0
		andi.b	#$C0,d0
		bne.s	locret_11480
		cmpi.w	#$400,d0
		blt.s	locret_11480
		tst.b	$2D(a0)
		bmi.s	locret_11480
		move.w	#$36,d0
		jsr	(Play_Sound_2).l
		move.b	#$D,$20(a0)
		bclr	#0,$2A(a0)
		cmpi.b	#$C,$2C(a0)
		bcs.s	locret_11480
		move.b	#6,5(a6)
		move.b	#$15,$22(a6)

locret_11480:

		rts
; End of function sub_113F6


; =============== S U B R O U T I N E =======================================


sub_11482:
		move.w	$1C(a0),d0
		bmi.s	loc_114B6
		bclr	#0,$2A(a0)
		beq.s	loc_1149C
		bclr	#5,$2A(a0)
		move.b	#1,$21(a0)

loc_1149C:
		add.w	d5,d0
		cmp.w	d6,d0
		blt.s	loc_114AA
		sub.w	d5,d0
		cmp.w	d6,d0
		bge.s	loc_114AA
		move.w	d6,d0

loc_114AA:

		move.w	d0,$1C(a0)
		move.b	#0,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_114B6:
		add.w	d4,d0
		bcc.s	loc_114BE
		move.w	#$80,d0

loc_114BE:
		move.w	d0,$1C(a0)
		move.b	$26(a0),d0
		addi.b	#$20,d0
		andi.b	#$C0,d0
		bne.s	locret_11506
		cmpi.w	#-$400,d0
		bgt.s	locret_11506
		tst.b	$2D(a0)
		bmi.s	locret_11506
		move.w	#$36,d0
		jsr	(Play_Sound_2).l
		move.b	#$D,$20(a0)
		bset	#0,$2A(a0)
		cmpi.b	#$C,$2C(a0)
		bcs.s	locret_11506
		move.b	#6,5(a6)
		move.b	#$15,$22(a6)

locret_11506:

		rts
; End of function sub_11482


; =============== S U B R O U T I N E =======================================


sub_11508:

		move.w	(a4),d6
		asl.w	#1,d6
		move.w	2(a4),d5
		asr.w	#1,d5
		tst.b	($FFFFFE19).w
		beq.s	loc_1151C
		move.w	#6,d5

loc_1151C:
		move.w	#$20,d4
		tst.b	$3D(a0)
		bmi.w	loc_115C6
		tst.b	$2B(a0)
		bmi.w	loc_115C6
		tst.w	$32(a0)
		bne.s	loc_1154E
		btst	#2,($FFFFF602).w
		beq.s	loc_11542
		bsr.w	sub_11608

loc_11542:
		btst	#3,($FFFFF602).w
		beq.s	loc_1154E
		bsr.w	sub_1162C

loc_1154E:

		move.w	$1C(a0),d0
		beq.s	loc_11570
		bmi.s	loc_11564
		sub.w	d5,d0
		bcc.s	loc_1155E
		move.w	#0,d0

loc_1155E:
		move.w	d0,$1C(a0)
		bra.s	loc_11570
; ---------------------------------------------------------------------------

loc_11564:
		add.w	d5,d0
		bcc.s	loc_1156C
		move.w	#0,d0

loc_1156C:
		move.w	d0,$1C(a0)

loc_11570:

		move.w	$1C(a0),d0
		bpl.s	loc_11578
		neg.w	d0

loc_11578:
		cmpi.w	#$80,d0
		bcc.s	loc_115C6
		tst.b	$3D(a0)
		bne.s	loc_115B4
		bclr	#2,$2A(a0)
		move.b	$1E(a0),d0
		move.b	$44(a0),$1E(a0)
		move.b	$45(a0),$1F(a0)
		move.b	#5,$20(a0)
		sub.b	$44(a0),d0
		ext.w	d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_115AE
		neg.w	d0

loc_115AE:
		add.w	d0,$14(a0)
		bra.s	loc_115C6
; ---------------------------------------------------------------------------

loc_115B4:
		move.w	#$400,$1C(a0)
		btst	#0,$2A(a0)
		beq.s	loc_115C6
		neg.w	$1C(a0)

loc_115C6:

		cmpi.w	#$60,(a5)
		beq.s	loc_115D2
		bcc.s	loc_115D0
		addq.w	#4,(a5)

loc_115D0:
		subq.w	#2,(a5)

loc_115D2:
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		muls.w	$1C(a0),d0
		asr.l	#8,d0
		move.w	d0,$1A(a0)
		muls.w	$1C(a0),d1
		asr.l	#8,d1
		cmpi.w	#$1000,d1
		ble.s	loc_115F6
		move.w	#$1000,d1

loc_115F6:
		cmpi.w	#-$1000,d1
		bge.s	loc_11600
		move.w	#-$1000,d1

loc_11600:
		move.w	d1,$18(a0)
		bra.w	loc_11350
; End of function sub_11508


; =============== S U B R O U T I N E =======================================


sub_11608:
		move.w	$1C(a0),d0
		beq.s	loc_11610
		bpl.s	loc_1161E

loc_11610:
		bset	#0,$2A(a0)
		move.b	#2,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_1161E:
		sub.w	d4,d0
		bcc.s	loc_11626
		move.w	#-$80,d0

loc_11626:
		move.w	d0,$1C(a0)
		rts
; End of function sub_11608


; =============== S U B R O U T I N E =======================================


sub_1162C:
		move.w	$1C(a0),d0
		bmi.s	loc_11640
		bclr	#0,$2A(a0)
		move.b	#2,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_11640:
		add.w	d4,d0
		bcc.s	loc_11648
		move.w	#$80,d0

loc_11648:
		move.w	d0,$1C(a0)
		rts
; End of function sub_1162C


; =============== S U B R O U T I N E =======================================


sub_1164E:

		move.w	(a4),d6
		move.w	2(a4),d5
		asl.w	#1,d5
		btst	#4,$2A(a0)
		bne.s	loc_116A2
		move.w	$18(a0),d0
		btst	#2,($FFFFF602).w
		beq.s	loc_11682
		bset	#0,$2A(a0)
		sub.w	d5,d0
		move.w	d6,d1
		neg.w	d1
		cmp.w	d1,d0
		bgt.s	loc_11682
		add.w	d5,d0
		cmp.w	d1,d0
		ble.s	loc_11682
		move.w	d1,d0

loc_11682:

		btst	#3,($FFFFF602).w
		beq.s	loc_1169E
		bclr	#0,$2A(a0)
		add.w	d5,d0
		cmp.w	d6,d0
		blt.s	loc_1169E
		sub.w	d5,d0
		cmp.w	d6,d0
		bge.s	loc_1169E
		move.w	d6,d0

loc_1169E:

		move.w	d0,$18(a0)

loc_116A2:
		cmpi.w	#$60,(a5)
		beq.s	loc_116AE
		bcc.s	loc_116AC
		addq.w	#4,(a5)

loc_116AC:
		subq.w	#2,(a5)

loc_116AE:
		cmpi.w	#-$400,$1A(a0)
		bcs.s	locret_116DC
		move.w	$18(a0),d0
		move.w	d0,d1
		asr.w	#5,d1
		beq.s	locret_116DC
		bmi.s	loc_116D0
		sub.w	d1,d0
		bcc.s	loc_116CA
		move.w	#0,d0

loc_116CA:
		move.w	d0,$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_116D0:
		sub.w	d1,d0
		bcs.s	loc_116D8
		move.w	#0,d0

loc_116D8:
		move.w	d0,$18(a0)

locret_116DC:

		rts
; End of function sub_1164E


; =============== S U B R O U T I N E =======================================


Player_Check_Screen_Boundaries:

		move.l	$10(a0),d1
		move.w	$18(a0),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d1
		swap	d1
		move.w	($FFFFEE14).w,d0
		addi.w	#$10,d0
		cmp.w	d1,d0
		bhi.s	loc_11732
		move.w	($FFFFEE16).w,d0
		addi.w	#$128,d0
		cmp.w	d1,d0
		bcs.s	loc_11732

loc_11706:
		tst.b	($FFFFF665).w
		bne.s	locret_11720
		tst.b	($FFFFF7C6).w
		bne.s	loc_11722
		move.w	($FFFFEE1A).w,d0
		addi.w	#$E0,d0
		cmp.w	$14(a0),d0
		blt.s	loc_1172C

locret_11720:
					; Player_Check_Screen_Boundaries+4Cj
		rts
; ---------------------------------------------------------------------------

loc_11722:
		move.w	($FFFFEE18).w,d0
		cmp.w	$14(a0),d0
		blt.s	locret_11720

loc_1172C:
		jmp	(Kill_Character).l
; ---------------------------------------------------------------------------

loc_11732:
					; Player_Check_Screen_Boundaries+26j
		move.w	d0,$10(a0)
		move.w	#0,$12(a0)
		move.w	#0,$18(a0)
		move.w	#0,$1C(a0)
		bra.s	loc_11706
; End of function Player_Check_Screen_Boundaries


; =============== S U B R O U T I N E =======================================


Player_Spin:

		tst.b	$2B(a0)
		bmi.s	locret_1177E
		move.b	($FFFFF602).w,d0
		andi.b	#$C,d0
		bne.s	locret_1177E
		btst	#1,($FFFFF602).w
		beq.s	loc_11780
		move.w	$1C(a0),d0
		bpl.s	loc_1176A
		neg.w	d0

loc_1176A:
		cmpi.w	#$100,d0
		bcc.s	loc_11790
		btst	#3,$2A(a0)
		bne.s	locret_1177E
		move.b	#8,$20(a0)

locret_1177E:
					; Player_Spin+Ej ...
		rts
; ---------------------------------------------------------------------------

loc_11780:
		cmpi.b	#8,$20(a0)
		bne.s	locret_1177E
		move.b	#0,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_11790:
		btst	#2,$2A(a0)
		beq.s	loc_1179A
		rts
; ---------------------------------------------------------------------------

loc_1179A:
		bset	#2,$2A(a0)
		move.b	#$E,$1E(a0)
		move.b	#7,$1F(a0)
		move.b	#2,$20(a0)
		addq.w	#5,$14(a0)
		tst.b	($FFFFF7C6).w
		beq.s	loc_117C2
		subi.w	#$A,$14(a0)

loc_117C2:
		move.w	#$3C,d0
		jsr	(Play_Sound_2).l
		tst.w	$1C(a0)
		bne.s	locret_117D8
		move.w	#$200,$1C(a0)

locret_117D8:
		rts
; End of function Player_Spin


; =============== S U B R O U T I N E =======================================


sub_117DA:

		move.b	($FFFFF603).w,d0
		andi.b	#$70,d0
		beq.w	locret_118B2
		moveq	#0,d0
		move.b	$26(a0),d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_117FC
		addi.b	#$40,d0
		neg.b	d0
		subi.b	#$40,d0

loc_117FC:
		addi.b	#-$80,d0
		movem.l	a4-a6,-(sp)
		bsr.w	sub_F72E
		movem.l	(sp)+,a4-a6
		cmpi.w	#6,d1
		blt.w	locret_118B2
		move.w	#$680,d2
		tst.b	($FFFFFE19).w
		beq.s	loc_11822
		move.w	#$800,d2

loc_11822:
		btst	#6,$2A(a0)
		beq.s	loc_1182E
		move.w	#$380,d2

loc_1182E:
		moveq	#0,d0
		move.b	$26(a0),d0
		subi.b	#$40,d0
		jsr	(GetSineCosine).l
		muls.w	d2,d1
		asr.l	#8,d1
		add.w	d1,$18(a0)
		muls.w	d2,d0
		asr.l	#8,d0
		add.w	d0,$1A(a0)
		bset	#1,$2A(a0)
		bclr	#5,$2A(a0)
		addq.l	#4,sp
		move.b	#1,$40(a0)
		clr.b	$3C(a0)
		move.w	#$62,d0
		jsr	(Play_Sound_2).l
		move.b	$44(a0),$1E(a0)
		move.b	$45(a0),$1F(a0)
		btst	#2,$2A(a0)
		bne.s	loc_118B4
		move.b	#$E,$1E(a0)
		move.b	#7,$1F(a0)
		move.b	#2,$20(a0)
		bset	#2,$2A(a0)
		move.b	$1E(a0),d0
		sub.b	$44(a0),d0
		ext.w	d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_118AE
		neg.w	d0

loc_118AE:
		sub.w	d0,$14(a0)

locret_118B2:

		rts
; ---------------------------------------------------------------------------

loc_118B4:
		bset	#4,$2A(a0)
		rts
; End of function sub_117DA


; =============== S U B R O U T I N E =======================================


Sonic_InstaAndShieldMoves:

		tst.b	$40(a0)
		beq.s	loc_118EA
		move.w	#-$400,d1
		btst	#6,$2A(a0)
		beq.s	loc_118D2
		move.w	#-$200,d1

loc_118D2:
		cmp.w	$1A(a0),d1
		ble.w	loc_11900
		move.b	($FFFFF602).w,d0
		andi.b	#$70,d0
		bne.s	locret_118E8
		move.w	d1,$1A(a0)

locret_118E8:
		rts
; ---------------------------------------------------------------------------

loc_118EA:
		tst.b	$3D(a0)
		bne.s	locret_118FE
		cmpi.w	#-$FC0,$1A(a0)
		bge.s	locret_118FE
		move.w	#-$FC0,$1A(a0)

locret_118FE:

		rts
; ---------------------------------------------------------------------------

loc_11900:
		tst.b	$2F(a0)
		bne.w	locret_11A14
		move.b	($FFFFF603).w,d0
		andi.b	#$70,d0
		beq.w	locret_11A14
		bclr	#4,$2A(a0)
		tst.b	($FFFFFE19).w
		beq.s	loc_1192C
		bmi.w	loc_11A96
		move.b	#1,$2F(a0)
		rts
; ---------------------------------------------------------------------------

loc_1192C:
		btst	#1,$2B(a0)
		bne.w	locret_11A14
		btst	#4,$2B(a0)
		beq.s	loc_1197A
		move.b	#1,($FFFFCD08).w
		move.b	#1,$2F(a0)
		move.w	#$800,d0
		btst	#0,$2A(a0)
		beq.s	loc_11958
		neg.w	d0

loc_11958:
		move.w	d0,$18(a0)
		move.w	d0,$1C(a0)
		move.w	#0,$1A(a0)
		move.w	#$2000,($FFFFEE24).w
		bsr.w	Reset_Player_Position_Array
		move.w	#$43,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

loc_1197A:
		btst	#5,$2B(a0)
		beq.s	loc_119A2
		move.b	#1,($FFFFCD08).w
		move.b	#1,$2F(a0)
		move.w	#-$580,$1A(a0)
		clr.b	$40(a0)
		move.w	#$45,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

loc_119A2:
		btst	#6,$2B(a0)
		beq.s	loc_119D2
		move.b	#1,($FFFFCD08).w
		move.b	#1,$2F(a0)
		move.w	#0,$18(a0)
		move.w	#0,$1C(a0)
		move.w	#$800,$1A(a0)
		move.w	#$44,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

loc_119D2:
		cmpi.b	#7,($FFFFFFB1).w
		bcc.s	loc_119E8
		cmpi.b	#7,($FFFFFFB0).w
		bcs.s	loc_119F6
		tst.b	($FFFFFFBA).w
		bne.s	loc_119F6

loc_119E8:
		cmpi.w	#$32,($FFFFFE20).w
		bcs.s	loc_119F6
		tst.b	($FFFFFE1E).w
		bne.s	loc_11A16

loc_119F6:

		btst	#0,$2B(a0)
		bne.s	locret_11A14
		move.b	#1,($FFFFCD08).w
		move.b	#1,$2F(a0)
		move.w	#$42,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

locret_11A14:

		rts
; ---------------------------------------------------------------------------

loc_11A16:
		move.b	#1,($FFFFF65F).w
		move.b	#$F,($FFFFF65E).w
		move.w	#$3C,($FFFFF670).w
		move.l	#Map_SuperSonic,$C(a0)
		move.b	#$81,$2E(a0)
		move.b	#$1F,$20(a0)
		cmpi.b	#7,($FFFFFFB1).w
		bcs.s	loc_11A5C
		move.b	#-1,($FFFFFE19).w
		move.l	#Obj_HyperSonic_19348,($FFFFCD7C).w
		move.l	#Obj_HyperSonicKnux_Trail,($FFFFCBC0).w
		bra.s	loc_11A6A
; ---------------------------------------------------------------------------

loc_11A5C:
		move.b	#1,($FFFFFE19).w
		move.l	#Obj_SuperSonicKnux_Stars,($FFFFCBC0).w

loc_11A6A:
		move.w	#$A00,(a4)
		move.w	#$30,2(a4)
		move.w	#$100,4(a4)
		move.b	#0,$35(a0)
		bset	#1,$2B(a0)
		moveq	#-$61,d0
		jsr	(Play_Sound_2).l
		moveq	#$2C,d0
		jmp	(Play_Sound).l
; ---------------------------------------------------------------------------

loc_11A96:
		bsr.w	sub_104EA
		move.w	#$2000,($FFFFEE24).w
		bsr.w	Reset_Player_Position_Array
		move.b	#1,$2F(a0)
		move.b	#1,($FFFFCD9C).w
		moveq	#-$4A,d0
		jsr	(Play_Sound_2).l
		move.b	($FFFFF602).w,d0
		andi.w	#$F,d0
		beq.s	loc_11AE0
		cmpi.b	#$B,d0
		bcc.s	loc_11AE0
		lsl.w	#2,d0
		lea	loc_11AF6+4(pc,d0.w),a1
		move.w	(a1)+,d0
		move.w	d0,$18(a0)
		move.w	d0,$1C(a0)
		move.w	(a1)+,d0
		move.w	d0,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_11AE0:

		move.w	#$800,d0
		btst	#0,$2A(a0)
		beq.s	loc_11AEE
		neg.w	d0

loc_11AEE:
		move.w	d0,$18(a0)
		move.w	d0,$1C(a0)

loc_11AF6:
		move.w	#0,$1A(a0)
		rts
; End of function Sonic_InstaAndShieldMoves

; ---------------------------------------------------------------------------
		dc.w	  0, $F800
		dc.w	  0,  $800
		dc.w	  0,	 0
		dc.w  $F800,	 0
		dc.w  $F800, $F800
		dc.w  $F800,  $800
		dc.w	  0,	 0
		dc.w   $800,	 0
		dc.w   $800, $F800
		dc.w   $800,  $800
; ---------------------------------------------------------------------------

loc_11B26:
		tst.b	($FFFFF667).w
		beq.w	locret_11BDC
		bra.s	loc_11B38

; =============== S U B R O U T I N E =======================================


sub_11B30:

		tst.b	($FFFFFE19).w
		beq.w	locret_11BDC

loc_11B38:
		tst.b	($FFFFFE1E).w
		beq.s	loc_11B7C
		subq.w	#1,($FFFFF670).w
		bpl.w	locret_11BDC
		move.w	#$3C,($FFFFF670).w
		tst.w	($FFFFFE20).w
		beq.s	loc_11B7C
		ori.b	#1,($FFFFFE1D).w
		cmpi.w	#1,($FFFFFE20).w
		beq.s	loc_11B70
		cmpi.w	#$A,($FFFFFE20).w
		beq.s	loc_11B70
		cmpi.w	#$64,($FFFFFE20).w
		bne.s	loc_11B76

loc_11B70:

		ori.b	#$80,($FFFFFE1D).w

loc_11B76:
		subq.w	#1,($FFFFFE20).w
		bne.s	locret_11BDC

loc_11B7C:

		move.b	#2,($FFFFF65F).w
		move.w	#$1E,($FFFFF65C).w
		move.b	#0,($FFFFFE19).w
		move.b	#0,($FFFFF667).w
		move.b	#-1,($FFFFF766).w
		tst.b	$38(a0)
		bne.s	loc_11BA8
		move.l	#Map_Sonic,$C(a0)

loc_11BA8:
		move.b	#1,$21(a0)
		move.b	#1,$35(a0)
		move.w	#$600,(a4)
		move.w	#$C,2(a4)
		move.w	#$80,4(a4)
		btst	#6,$2A(a0)
		beq.s	locret_11BDC
		move.w	#$300,(a4)
		move.w	#6,2(a4)
		move.w	#$40,4(a4)

locret_11BDC:

		rts
; End of function sub_11B30


; =============== S U B R O U T I N E =======================================


Player_Spindash:

		tst.b	$3D(a0)
		bne.s	loc_11C5E
		cmpi.b	#8,$20(a0)
		bne.s	locret_11C5C
		move.b	($FFFFF603).w,d0
		andi.b	#$70,d0
		beq.w	locret_11C5C
		move.b	#9,$20(a0)
		move.w	#$FFAB,d0
		jsr	(Play_Sound_2).l
		addq.l	#4,sp
		move.b	#1,$3D(a0)
		move.w	#0,$3E(a0)
		cmpi.b	#$C,$2C(a0)
		bcs.s	loc_11C24
		move.b	#2,$20(a6)

loc_11C24:
		bsr.w	Player_Check_Screen_Boundaries
		bsr.w	Call_Player_AnglePos
		tst.b	($FFFFF664).w
		beq.s	locret_11C5C
		bsr.w	sub_F846
		tst.w	d1
		bmi.w	Kill_Character
		movem.l	a4-a6,-(sp)
		bsr.w	sub_FD9A
		tst.w	d1
		bpl.s	loc_11C4C
		sub.w	d1,$10(a0)

loc_11C4C:
		bsr.w	sub_FA7A
		tst.w	d1
		bpl.s	loc_11C58
		add.w	d1,$10(a0)

loc_11C58:
		movem.l	(sp)+,a4-a6

locret_11C5C:
					; Player_Spindash+16j ...
		rts
; ---------------------------------------------------------------------------

loc_11C5E:
		move.b	($FFFFF602).w,d0
		btst	#1,d0
		bne.w	loc_11D16
		move.b	#$E,$1E(a0)
		move.b	#7,$1F(a0)
		move.b	#2,$20(a0)
		addq.w	#5,$14(a0)
		tst.b	($FFFFF7C6).w
		beq.s	loc_11C8C
		subi.w	#$A,$14(a0)

loc_11C8C:
		move.b	#0,$3D(a0)
		moveq	#0,d0
		move.b	$3E(a0),d0
		add.w	d0,d0
		move.w	word_11CF2(pc,d0.w),$1C(a0)
		tst.b	($FFFFFE19).w
		beq.s	loc_11CAC
		move.w	word_11D04(pc,d0.w),$1C(a0)

loc_11CAC:
		move.w	$1C(a0),d0
		subi.w	#$800,d0
		add.w	d0,d0
		andi.w	#$1F00,d0
		neg.w	d0
		addi.w	#$2000,d0
		lea	($FFFFEE24).w,a1
		cmpa.w	#$B000,a0
		beq.s	loc_11CCE
		lea	($FFFFEE28).w,a1

loc_11CCE:
		move.w	d0,(a1)
		btst	#0,$2A(a0)
		beq.s	loc_11CDC
		neg.w	$1C(a0)

loc_11CDC:
		bset	#2,$2A(a0)
		move.b	#0,$20(a6)
		moveq	#-$4A,d0
		jsr	(Play_Sound_2).l
		bra.s	loc_11D5E
; ---------------------------------------------------------------------------
word_11CF2:	dc.w $800
		dc.w $880
		dc.w $900
		dc.w $980
		dc.w $A00
		dc.w $A80
		dc.w $B00
		dc.w $B80
		dc.w $C00
word_11D04:	dc.w $B00
		dc.w $B80
		dc.w $C00
		dc.w $C80
		dc.w $D00
		dc.w $D80
		dc.w $E00
		dc.w $E80
		dc.w $F00
; ---------------------------------------------------------------------------

loc_11D16:
		tst.w	$3E(a0)
		beq.s	loc_11D2E
		move.w	$3E(a0),d0
		lsr.w	#5,d0
		sub.w	d0,$3E(a0)
		bcc.s	loc_11D2E
		move.w	#0,$3E(a0)

loc_11D2E:
					; Player_Spindash+148j
		move.b	($FFFFF603).w,d0
		andi.b	#$70,d0
		beq.w	loc_11D5E
		move.w	#$900,$20(a0)
		move.w	#$FFAB,d0
		jsr	(Play_Sound_2).l
		addi.w	#$200,$3E(a0)
		cmpi.w	#$800,$3E(a0)
		bcs.s	loc_11D5E
		move.w	#$800,$3E(a0)

loc_11D5E:
					; Player_Spindash+158j	...
		addq.l	#4,sp
		cmpi.w	#$60,(a5)
		beq.s	loc_11D6C
		bcc.s	loc_11D6A
		addq.w	#4,(a5)

loc_11D6A:
		subq.w	#2,(a5)

loc_11D6C:
		bsr.w	Player_Check_Screen_Boundaries
		bsr.w	Call_Player_AnglePos
		tst.b	($FFFFF664).w
		beq.s	locret_11DA4
		bsr.w	sub_F846
		tst.w	d1
		bmi.w	Kill_Character
		movem.l	a4-a6,-(sp)
		bsr.w	sub_FD9A
		tst.w	d1
		bpl.s	loc_11D94
		sub.w	d1,$10(a0)

loc_11D94:
		bsr.w	sub_FA7A
		tst.w	d1
		bpl.s	loc_11DA0
		add.w	d1,$10(a0)

loc_11DA0:
		movem.l	(sp)+,a4-a6

locret_11DA4:
		rts
; End of function Player_Spindash


; =============== S U B R O U T I N E =======================================


sub_11DA6:

		move.b	$26(a0),d0
		addi.b	#$60,d0
		cmpi.b	#$C0,d0
		bcc.s	locret_11DDA
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		muls.w	#$20,d0
		asr.l	#8,d0
		tst.w	$1C(a0)
		beq.s	loc_11DDC
		bmi.s	loc_11DD6
		tst.w	d0
		beq.s	locret_11DD4
		add.w	d0,$1C(a0)

locret_11DD4:
		rts
; ---------------------------------------------------------------------------

loc_11DD6:
		add.w	d0,$1C(a0)

locret_11DDA:

		rts
; ---------------------------------------------------------------------------

loc_11DDC:
		move.w	d0,d1
		bpl.s	loc_11DE2
		neg.w	d1

loc_11DE2:
		cmpi.w	#$D,d1
		bcs.s	locret_11DDA
		add.w	d0,$1C(a0)
		rts
; End of function sub_11DA6


; =============== S U B R O U T I N E =======================================


sub_11DEE:

		move.b	$26(a0),d0
		addi.b	#$60,d0
		cmpi.b	#$C0,d0
		bcc.s	locret_11E28
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		muls.w	#$50,d0
		asr.l	#8,d0
		tst.w	$1C(a0)
		bmi.s	loc_11E1E
		tst.w	d0
		bpl.s	loc_11E18
		asr.l	#2,d0

loc_11E18:
		add.w	d0,$1C(a0)
		rts
; ---------------------------------------------------------------------------

loc_11E1E:
		tst.w	d0
		bmi.s	loc_11E24
		asr.l	#2,d0

loc_11E24:
		add.w	d0,$1C(a0)

locret_11E28:
		rts
; End of function sub_11DEE


; =============== S U B R O U T I N E =======================================


sub_11E2A:

		nop
		tst.b	$3C(a0)
		bne.s	locret_11E6E
		tst.w	$32(a0)
		bne.s	loc_11E86
		move.b	$26(a0),d0
		addi.b	#$18,d0
		cmpi.b	#$30,d0
		bcs.s	locret_11E6E
		move.w	$1C(a0),d0
		bpl.s	loc_11E4E
		neg.w	d0

loc_11E4E:
		cmpi.w	#$280,d0
		bcc.s	locret_11E6E
		move.w	#$1E,$32(a0)
		move.b	$26(a0),d0
		addi.b	#$30,d0
		cmpi.b	#$60,d0
		bcs.s	loc_11E70
		bset	#1,$2A(a0)

locret_11E6E:

		rts
; ---------------------------------------------------------------------------

loc_11E70:
		cmpi.b	#$30,d0
		bcs.s	loc_11E7E
		addi.w	#$80,$1C(a0)
		rts
; ---------------------------------------------------------------------------

loc_11E7E:
		subi.w	#$80,$1C(a0)
		rts
; ---------------------------------------------------------------------------

loc_11E86:
		subq.w	#1,$32(a0)
		rts
; End of function sub_11E2A


; =============== S U B R O U T I N E =======================================


sub_11E8C:

		move.b	$26(a0),d0
		beq.s	loc_11EA6
		bpl.s	loc_11E9C
		addq.b	#2,d0
		bcc.s	loc_11E9A
		moveq	#0,d0

loc_11E9A:
		bra.s	loc_11EA2
; ---------------------------------------------------------------------------

loc_11E9C:
		subq.b	#2,d0
		bcc.s	loc_11EA2
		moveq	#0,d0

loc_11EA2:

		move.b	d0,$26(a0)

loc_11EA6:
		move.b	$27(a0),d0
		beq.s	locret_11EEA
		tst.w	$1C(a0)
		bmi.s	loc_11ECA

loc_11EB2:
		move.b	$31(a0),d1
		add.b	d1,d0
		bcc.s	loc_11EC8
		subq.b	#1,$30(a0)
		bcc.s	loc_11EC8
		move.b	#0,$30(a0)
		moveq	#0,d0

loc_11EC8:

		bra.s	loc_11EE6
; ---------------------------------------------------------------------------

loc_11ECA:
		tst.b	$2D(a0)
		bmi.s	loc_11EB2
		move.b	$31(a0),d1
		sub.b	d1,d0
		bcc.s	loc_11EE6
		subq.b	#1,$30(a0)
		bcc.s	loc_11EE6
		move.b	#0,$30(a0)
		moveq	#0,d0

loc_11EE6:

		move.b	d0,$27(a0)

locret_11EEA:
		rts
; End of function sub_11E8C


; =============== S U B R O U T I N E =======================================


sub_11EEC:

		move.l	($FFFFF7B4).w,($FFFFF796).w
		cmpi.b	#$C,$46(a0)
		beq.s	loc_11F00
		move.l	($FFFFF7B8).w,($FFFFF796).w

loc_11F00:
		move.b	$47(a0),d5
		move.w	$18(a0),d1
		move.w	$1A(a0),d2
		jsr	(GetArcTan).l
		subi.b	#$20,d0
		andi.b	#$C0,d0
		cmpi.b	#$40,d0
		beq.w	loc_12012
		cmpi.b	#$80,d0
		beq.w	loc_1209E
		cmpi.b	#$C0,d0
		beq.w	loc_12102
		bsr.w	sub_FD9A
		tst.w	d1
		bpl.s	loc_11F44
		sub.w	d1,$10(a0)
		move.w	#0,$18(a0)

loc_11F44:
		bsr.w	sub_FA7A
		tst.w	d1
		bpl.s	loc_11F56
		add.w	d1,$10(a0)
		move.w	#0,$18(a0)

loc_11F56:
		bsr.w	sub_11FD6
		tst.w	d1
		bpl.s	locret_11FD4
		move.b	$1A(a0),d2
		addq.b	#8,d2
		neg.b	d2
		cmp.b	d2,d1
		bge.s	loc_11F6E
		cmp.b	d2,d0
		blt.s	locret_11FD4

loc_11F6E:
		move.b	d3,$26(a0)
		tst.b	($FFFFF7C6).w
		beq.s	loc_11F7A
		neg.w	d1

loc_11F7A:
		add.w	d1,$14(a0)
		move.b	d3,d0
		addi.b	#$20,d0
		andi.b	#$40,d0
		bne.s	loc_11FAE
		move.b	d3,d0
		addi.b	#$10,d0
		andi.b	#$20,d0
		beq.s	loc_11F9C
		asr	$1A(a0)
		bra.s	loc_11FC2
; ---------------------------------------------------------------------------

loc_11F9C:
		move.w	#0,$1A(a0)
		move.w	$18(a0),$1C(a0)
		bsr.w	Player_TouchFloor_Check_Spindash
		rts
; ---------------------------------------------------------------------------

loc_11FAE:
		move.w	#0,$18(a0)
		cmpi.w	#$FC0,$1A(a0)
		ble.s	loc_11FC2
		move.w	#$FC0,$1A(a0)

loc_11FC2:

		bsr.w	Player_TouchFloor_Check_Spindash
		move.w	$1A(a0),$1C(a0)
		tst.b	d3
		bpl.s	locret_11FD4
		neg.w	$1C(a0)

locret_11FD4:

		rts
; End of function sub_11EEC


; =============== S U B R O U T I N E =======================================


sub_11FD6:

		tst.b	($FFFFF7C6).w
		beq.w	sub_F76E
		bsr.w	sub_FAF2
		addi.b	#$40,d3
		neg.b	d3
		subi.b	#$40,d3
		rts
; End of function sub_11FD6


; =============== S U B R O U T I N E =======================================


sub_11FEE:

		tst.b	($FFFFF7C6).w
		beq.w	sub_FAF2
		bsr.w	sub_F76E
		addi.b	#$40,d3
		neg.b	d3
		subi.b	#$40,d3
		rts
; End of function sub_11FEE


; =============== S U B R O U T I N E =======================================


sub_12006:
					; Sonic_InputAcceleration_Path+158p ...
		tst.b	($FFFFF7C6).w
		beq.w	loc_F898
		bra.w	loc_FC4A
; End of function sub_12006

; ---------------------------------------------------------------------------

loc_12012:
		bsr.w	sub_FD9A
		tst.w	d1
		bpl.s	loc_1202A
		sub.w	d1,$10(a0)
		move.w	#0,$18(a0)
		move.w	$1A(a0),$1C(a0)

loc_1202A:
		bsr.w	sub_11FEE
		tst.w	d1
		bpl.s	loc_12068
		neg.w	d1
		cmpi.w	#$14,d1
		bcc.s	loc_12054
		tst.b	($FFFFF7C6).w
		beq.s	loc_12042
		neg.w	d1

loc_12042:
		add.w	d1,$14(a0)
		tst.w	$1A(a0)
		bpl.s	locret_12052
		move.w	#0,$1A(a0)

locret_12052:
		rts
; ---------------------------------------------------------------------------

loc_12054:
		bsr.w	sub_FA7A
		tst.w	d1
		bpl.s	locret_12066
		add.w	d1,$10(a0)
		move.w	#0,$18(a0)

locret_12066:
		rts
; ---------------------------------------------------------------------------

loc_12068:
		tst.b	($FFFFF7C8).w
		bne.s	loc_12074
		tst.w	$1A(a0)
		bmi.s	locret_1209C

loc_12074:
		bsr.w	sub_11FD6
		tst.w	d1
		bpl.s	locret_1209C
		tst.b	($FFFFF7C6).w
		beq.s	loc_12084
		neg.w	d1

loc_12084:
		add.w	d1,$14(a0)
		move.b	d3,$26(a0)
		move.w	#0,$1A(a0)
		move.w	$18(a0),$1C(a0)
		bsr.w	Player_TouchFloor_Check_Spindash

locret_1209C:

		rts
; ---------------------------------------------------------------------------

loc_1209E:
		bsr.w	sub_FD9A
		tst.w	d1
		bpl.s	loc_120B0
		sub.w	d1,$10(a0)
		move.w	#0,$18(a0)

loc_120B0:
		bsr.w	sub_FA7A
		tst.w	d1
		bpl.s	loc_120C2
		add.w	d1,$10(a0)
		move.w	#0,$18(a0)

loc_120C2:
		bsr.w	sub_11FEE
		tst.w	d1
		bpl.s	locret_12100
		tst.b	($FFFFF7C6).w
		beq.s	loc_120D2
		neg.w	d1

loc_120D2:
		sub.w	d1,$14(a0)
		move.b	d3,d0
		addi.b	#$20,d0
		andi.b	#$40,d0
		bne.s	loc_120EA
		move.w	#0,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_120EA:
		move.b	d3,$26(a0)
		bsr.w	Player_TouchFloor_Check_Spindash
		move.w	$1A(a0),$1C(a0)
		tst.b	d3
		bpl.s	locret_12100
		neg.w	$1C(a0)

locret_12100:

		rts
; ---------------------------------------------------------------------------

loc_12102:
		bsr.w	sub_FA7A
		tst.w	d1
		bpl.s	loc_1211A
		add.w	d1,$10(a0)
		move.w	#0,$18(a0)
		move.w	$1A(a0),$1C(a0)

loc_1211A:
		bsr.w	sub_11FEE
		tst.w	d1
		bpl.s	loc_1213C
		tst.b	($FFFFF7C6).w
		beq.s	loc_1212A
		neg.w	d1

loc_1212A:
		sub.w	d1,$14(a0)
		tst.w	$1A(a0)
		bpl.s	locret_1213A
		move.w	#0,$1A(a0)

locret_1213A:
		rts
; ---------------------------------------------------------------------------

loc_1213C:
		tst.b	($FFFFF7C8).w
		bne.s	loc_12148
		tst.w	$1A(a0)
		bmi.s	locret_12170

loc_12148:
		bsr.w	sub_11FD6
		tst.w	d1
		bpl.s	locret_12170
		tst.b	($FFFFF7C6).w
		beq.s	loc_12158
		neg.w	d1

loc_12158:
		add.w	d1,$14(a0)
		move.b	d3,$26(a0)
		move.w	#0,$1A(a0)
		move.w	$18(a0),$1C(a0)
		bsr.w	Player_TouchFloor_Check_Spindash

locret_12170:

		rts

; =============== S U B R O U T I N E =======================================


Player_TouchFloor_Check_Spindash:

		tst.b	$3D(a0)
		bne.s	loc_121D8
		move.b	#0,$20(a0)
; End of function Player_TouchFloor_Check_Spindash


; =============== S U B R O U T I N E =======================================


Player_TouchFloor:

		cmpi.b	#1,$38(a0)
		beq.w	Tails_TouchFloor
		cmpi.b	#2,$38(a0)
		beq.w	sub_17B24
		move.b	$1E(a0),d0
		move.b	$44(a0),$1E(a0)
		move.b	$45(a0),$1F(a0)
		btst	#2,$2A(a0)
		beq.s	loc_121D8
		bclr	#2,$2A(a0)
		move.b	#0,$20(a0)
		sub.b	$44(a0),d0
		ext.w	d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_121C4
		neg.w	d0

loc_121C4:
		move.w	d0,-(sp)
		move.b	$26(a0),d0
		addi.b	#$40,d0
		bpl.s	loc_121D2
		neg.w	(sp)

loc_121D2:
		move.w	(sp)+,d0
		add.w	d0,$14(a0)

loc_121D8:
		bclr	#1,$2A(a0)
		bclr	#5,$2A(a0)
		bclr	#4,$2A(a0)
		move.b	#0,$40(a0)
		move.w	#0,($FFFFF7D0).w
		move.b	#0,$27(a0)
		move.b	#0,$2D(a0)
		move.b	#0,$30(a0)
		move.b	#0,$39(a0)
		tst.b	$2F(a0)
		beq.s	locret_12230
		tst.b	$38(a0)
		bne.s	loc_1222A
		tst.b	($FFFFFE19).w
		bne.s	loc_1222A
		btst	#6,$2B(a0)
		beq.s	loc_1222A
		bsr.s	BubbleShield_Bounce

loc_1222A:
		move.b	#0,$2F(a0)

locret_12230:
		rts
; End of function Player_TouchFloor


; =============== S U B R O U T I N E =======================================


BubbleShield_Bounce:
		movem.l	d1-d2,-(sp)
		move.w	#$780,d2
		btst	#6,$2A(a0)
		beq.s	loc_12246
		move.w	#$400,d2

loc_12246:
		moveq	#0,d0
		move.b	$26(a0),d0
		subi.b	#$40,d0
		jsr	(GetSineCosine).l
		muls.w	d2,d1
		asr.l	#8,d1
		add.w	d1,$18(a0)
		muls.w	d2,d0
		asr.l	#8,d0
		add.w	d0,$1A(a0)
		movem.l	(sp)+,d1-d2
		bset	#1,$2A(a0)
		bclr	#5,$2A(a0)
		move.b	#1,$40(a0)
		clr.b	$3C(a0)
		move.b	#$E,$1E(a0)
		move.b	#7,$1F(a0)
		move.b	#2,$20(a0)
		bset	#2,$2A(a0)
		move.b	$1E(a0),d0
		sub.b	$44(a0),d0
		ext.w	d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_122AA
		neg.w	d0

loc_122AA:
		sub.w	d0,$14(a0)
		move.b	#2,($FFFFCD08).w
		move.w	#$44,d0
		jmp	(Play_Sound_2).l
; End of function BubbleShield_Bounce

; ---------------------------------------------------------------------------

loc_122BE:

		tst.w	($FFFFFFDA).w
		beq.s	loc_122D8
		btst	#4,($FFFFF605).w
		beq.s	loc_122D8
		move.w	#1,($FFFFFE08).w
		clr.b	($FFFFF7CA).w
		rts
; ---------------------------------------------------------------------------

loc_122D8:

		jsr	(MoveSprite_TestGravity2).l
		addi.w	#$30,$1A(a0)
		btst	#6,$2A(a0)
		beq.s	loc_122F2
		subi.w	#$20,$1A(a0)

loc_122F2:
		cmpi.w	#-$100,($FFFFEE18).w
		bne.s	loc_12302
		move.w	($FFFFEEAA).w,d0
		and.w	d0,$14(a0)

loc_12302:
		bsr.w	sub_12318
		bsr.w	Player_Check_Screen_Boundaries
		bsr.w	sub_10D66
		bsr.w	sub_125E0
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_12318:
		tst.b	($FFFFF665).w
		bne.s	loc_12344
		tst.b	($FFFFF7C6).w
		bne.s	loc_12336
		move.w	($FFFFEE1A).w,d0
		addi.w	#$E0,d0
		cmp.w	$14(a0),d0
		blt.w	loc_1238A
		bra.s	loc_12344
; ---------------------------------------------------------------------------

loc_12336:
		move.w	($FFFFEE18).w,d0
		cmp.w	$14(a0),d0
		blt.s	loc_12344
		bra.w	loc_1238A
; ---------------------------------------------------------------------------

loc_12344:

		movem.l	a4-a6,-(sp)
		bsr.w	sub_11EEC
		movem.l	(sp)+,a4-a6
		btst	#1,$2A(a0)
		bne.s	locret_12388
		moveq	#0,d0
		move.w	d0,$1A(a0)
		move.w	d0,$18(a0)
		move.w	d0,$1C(a0)
		move.b	d0,$2E(a0)
		move.b	#0,$20(a0)
		move.w	#$100,8(a0)
		move.b	#2,5(a0)
		move.b	#$78,$34(a0)
		move.b	#0,$3D(a0)

locret_12388:
		rts
; ---------------------------------------------------------------------------

loc_1238A:

		jmp	(Kill_Character).l
; End of function sub_12318

; ---------------------------------------------------------------------------

loc_12390:

		tst.w	($FFFFFFDA).w
		beq.s	loc_123AA
		btst	#4,($FFFFF605).w
		beq.s	loc_123AA
		move.w	#1,($FFFFFE08).w
		clr.b	($FFFFF7CA).w
		rts
; ---------------------------------------------------------------------------

loc_123AA:

		bsr.w	sub_123C2
		jsr	(MoveSprite_TestGravity).l
		bsr.w	sub_10D66
		bsr.w	sub_125E0
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_123C2:

		cmpa.w	#$B000,a0
		bne.s	loc_123D4
		move.w	($FFFFEE7C).w,d0
		move.b	#1,($FFFFEE0A).w
		bra.s	loc_123DE
; ---------------------------------------------------------------------------

loc_123D4:
		move.w	($FFFFEE7C).w,d0
		move.b	#1,($FFFFEE0B).w

loc_123DE:
		move.b	#0,$3D(a0)
		tst.b	($FFFFF7C6).w
		beq.s	loc_123FA
		subi.w	#$10,d0
		cmp.w	$14(a0),d0
		bge.w	loc_12410
		bra.w	locret_124C6
; ---------------------------------------------------------------------------

loc_123FA:
		addi.w	#$100,d0
		tst.w	($FFFFFFE8).w
		beq.s	loc_12408
		subi.w	#$70,d0

loc_12408:
		cmp.w	$14(a0),d0
		bge.w	locret_124C6

loc_12410:
		tst.w	($FFFFFFE8).w
		bne.w	loc_124C8
		cmpi.b	#1,$38(a0)
		bne.s	loc_12432
		cmpi.w	#2,($FFFFFF08).w
		beq.s	loc_12432
		move.b	#2,5(a0)
		bra.w	sub_13ECA
; ---------------------------------------------------------------------------

loc_12432:

		move.b	#8,5(a0)
		move.w	#$3C,$3E(a0)
		move.b	#0,($FFFFFF97).w
		addq.b	#1,($FFFFFE1C).w
		subq.b	#1,($FFFFFE12).w
		bne.s	loc_12498
		move.w	#0,$3E(a0)
		move.l	#loc_2D5C6,($FFFFB094).w
		move.l	#loc_2D5C6,($FFFFB0DE).w
		move.b	#0,($FFFFB0B6).w
		move.b	#1,($FFFFB100).w
		move.w	a0,($FFFFB0D2).w
		clr.b	($FFFFFE1A).w

loc_12478:
		clr.b	($FFFFFE1E).w
		clr.b	($FFFFFEC7).w
		move.b	#8,5(a0)
		move.w	#$27,d0
		jsr	(Play_Sound).l
		moveq	#3,d0
		jmp	(Load_PLC_2).l
; ---------------------------------------------------------------------------

loc_12498:
		tst.b	($FFFFFE1A).w
		beq.s	locret_124C6
		move.w	#0,$3E(a0)
		move.l	#loc_2D5C6,($FFFFB094).w
		move.l	#loc_2D5C6,($FFFFB0DE).w
		move.b	#2,($FFFFB0B6).w
		move.b	#3,($FFFFB100).w
		move.w	a0,($FFFFB0D2).w
		bra.s	loc_12478
; ---------------------------------------------------------------------------

locret_124C6:

		rts
; ---------------------------------------------------------------------------

loc_124C8:
		move.b	#2,5(a0)
		cmpa.w	#$B000,a0
		bne.s	loc_12502
		move.b	#0,($FFFFEE0A).w
		move.w	($FFFFFE2E).w,$10(a0)
		move.w	($FFFFFE30).w,$14(a0)
		move.w	($FFFFFE38).w,$A(a0)
		move.w	($FFFFFE3A).w,$46(a0)
		clr.w	($FFFFFE20).w
		clr.b	($FFFFFE1B).w
		move.b	#1,($FFFFF74A).w
		bra.s	loc_1252A
; ---------------------------------------------------------------------------

loc_12502:
		move.b	#0,($FFFFEE0B).w
		move.w	($FFFFFE4C).w,$10(a0)
		move.w	($FFFFFE4E).w,$14(a0)
		move.w	($FFFFFE56).w,$A(a0)
		move.w	($FFFFFE58).w,$46(a0)
		clr.w	($FFFFFED0).w
		move.b	#1,($FFFFF74B).w

loc_1252A:
		move.b	#0,$2E(a0)
		move.b	#5,$20(a0)
		move.w	#0,$18(a0)
		move.w	#0,$1A(a0)
		move.w	#0,$1C(a0)
		move.b	#2,$2A(a0)
		move.w	#0,$32(a0)
		move.w	#0,$3E(a0)
		clr.b	$36(a0)
		lea	(Character_Speeds).l,a1
		moveq	#0,d0
		move.b	$38(a0),d0
		lsl.w	#3,d0
		lea	(a1,d0.w),a1
		move.w	(a1)+,(a4)
		move.w	(a1)+,2(a4)
		move.w	(a1)+,4(a4)
		rts
; End of function sub_123C2

; ---------------------------------------------------------------------------

loc_1257C:

		tst.w	$3E(a0)
		beq.s	locret_1258E
		subq.w	#1,$3E(a0)
		bne.s	locret_1258E
		move.w	#1,($FFFFFE02).w

locret_1258E:

		rts
; ---------------------------------------------------------------------------

loc_12590:

		tst.w	($FFFFEE00).w
		bne.s	loc_125A2
		tst.w	($FFFFEE02).w
		bne.s	loc_125A2
		move.b	#2,5(a0)

loc_125A2:

		bsr.w	sub_125E0
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_125AC:
		tst.w	($FFFFFFDA).w
		beq.s	loc_125C6
		btst	#4,($FFFFF605).w
		beq.s	loc_125C6
		move.w	#1,($FFFFFE08).w
		clr.b	($FFFFF7CA).w
		rts
; ---------------------------------------------------------------------------

loc_125C6:

		jsr	(MoveSprite_TestGravity2).l
		addi.w	#$10,$1A(a0)
		bsr.w	sub_10D66
		bsr.w	sub_125E0
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_125E0:

		tst.w	($FFFFFFE8).w
		bne.s	loc_125F8
		bsr.s	Animate_Sonic
		tst.b	($FFFFF7C6).w
		beq.s	loc_125F4
		eori.b	#2,4(a0)

loc_125F4:
		bra.w	Sonic_Load_PLC
; ---------------------------------------------------------------------------

loc_125F8:
		bsr.w	Animate_SonicKnuckles_2P
		bra.w	SonicKnuckles2P_Load_PLC
; End of function sub_125E0


; =============== S U B R O U T I N E =======================================


Animate_Sonic:

		lea	(AniSonic).l,a1
		tst.b	($FFFFFE19).w
		beq.s	loc_12612
		lea	(AniSuperSonic).l,a1

loc_12612:
		moveq	#0,d0
		move.b	$20(a0),d0
		cmp.b	$21(a0),d0
		beq.s	loc_12634
		move.b	d0,$21(a0)
		move.b	#0,$23(a0)
		move.b	#0,$24(a0)
		bclr	#5,$2A(a0)

loc_12634:
		add.w	d0,d0
		adda.w	(a1,d0.w),a1
		move.b	(a1),d0
		bmi.s	loc_126A4
		move.b	$2A(a0),d1
		andi.b	#1,d1
		andi.b	#-4,4(a0)
		or.b	d1,4(a0)
		subq.b	#1,$24(a0)
		bpl.s	locret_12672
		move.b	d0,$24(a0)

loc_1265A:
					; Animate_Sonic+4A2j
		moveq	#0,d1
		move.b	$23(a0),d1
		move.b	1(a1,d1.w),d0
		cmpi.b	#-4,d0
		bcc.s	loc_12674

loc_1266A:
					; Animate_Sonic+96j
		move.b	d0,$22(a0)
		addq.b	#1,$23(a0)

locret_12672:
					; Animate_Sonic+440j ...
		rts
; ---------------------------------------------------------------------------

loc_12674:
		addq.b	#1,d0
		bne.s	loc_12684
		move.b	#0,$23(a0)
		move.b	1(a1),d0
		bra.s	loc_1266A
; ---------------------------------------------------------------------------

loc_12684:
		addq.b	#1,d0
		bne.s	loc_12698
		move.b	2(a1,d1.w),d0
		sub.b	d0,$23(a0)
		sub.b	d0,d1
		move.b	1(a1,d1.w),d0
		bra.s	loc_1266A
; ---------------------------------------------------------------------------

loc_12698:
		addq.b	#1,d0
		bne.s	locret_126A2
		move.b	2(a1,d1.w),$20(a0)

locret_126A2:
		rts
; ---------------------------------------------------------------------------

loc_126A4:
		addq.b	#1,d0
		bne.w	loc_12A2A
		moveq	#0,d0
		tst.b	$2D(a0)
		bmi.w	loc_127C0
		move.b	$27(a0),d0
		bne.w	loc_127C0
		moveq	#0,d1
		move.b	$26(a0),d0
		bmi.s	loc_126C8
		beq.s	loc_126C8
		subq.b	#1,d0

loc_126C8:
					; Animate_Sonic+C4j
		move.b	$2A(a0),d2
		andi.b	#1,d2
		bne.s	loc_126D4
		not.b	d0

loc_126D4:
		addi.b	#$10,d0
		bpl.s	loc_126DC
		moveq	#3,d1

loc_126DC:
		andi.b	#-4,4(a0)
		eor.b	d1,d2
		or.b	d2,4(a0)
		btst	#5,$2A(a0)
		bne.w	loc_12A72
		lsr.b	#4,d0
		andi.b	#6,d0
		move.w	$1C(a0),d2
		bpl.s	loc_12700
		neg.w	d2

loc_12700:
		tst.b	$2B(a0)
		bpl.w	loc_1270A
		add.w	d2,d2

loc_1270A:
		tst.b	($FFFFFE19).w
		bne.s	loc_12766
		lea	(byte_12AF8).l,a1
		cmpi.w	#$600,d2
		bcc.s	loc_12724
		lea	(byte_12AEE).l,a1
		add.b	d0,d0

loc_12724:
		add.b	d0,d0
		move.b	d0,d3
		moveq	#0,d1
		move.b	$23(a0),d1
		move.b	1(a1,d1.w),d0
		cmpi.b	#-1,d0
		bne.s	loc_12742
		move.b	#0,$23(a0)
		move.b	1(a1),d0

loc_12742:
		move.b	d0,$22(a0)
		add.b	d3,$22(a0)
		subq.b	#1,$24(a0)
		bpl.s	locret_12764
		neg.w	d2
		addi.w	#$800,d2
		bpl.s	loc_1275A
		moveq	#0,d2

loc_1275A:
		lsr.w	#8,d2
		move.b	d2,$24(a0)
		addq.b	#1,$23(a0)

locret_12764:
		rts
; ---------------------------------------------------------------------------

loc_12766:
		lea	(byte_12C84).l,a1
		cmpi.w	#$800,d2
		bcc.s	loc_1277E
		lea	(byte_12C7A).l,a1
		add.b	d0,d0
		add.b	d0,d0
		bra.s	loc_12780
; ---------------------------------------------------------------------------

loc_1277E:
		add.b	d0,d0

loc_12780:
		move.b	d0,d3
		moveq	#0,d1
		move.b	$23(a0),d1
		move.b	1(a1,d1.w),d0
		cmpi.b	#-1,d0
		bne.s	loc_1279C
		move.b	#0,$23(a0)
		move.b	1(a1),d0

loc_1279C:
		move.b	d0,$22(a0)
		add.b	d3,$22(a0)
		subq.b	#1,$24(a0)
		bpl.s	locret_127BE
		neg.w	d2
		addi.w	#$800,d2
		bpl.s	loc_127B4
		moveq	#0,d2

loc_127B4:
		lsr.w	#8,d2
		move.b	d2,$24(a0)
		addq.b	#1,$23(a0)

locret_127BE:
		rts
; ---------------------------------------------------------------------------

loc_127C0:
					; Animate_Sonic+B8j ...
		move.b	$2D(a0),d1
		andi.w	#$7F,d1
		bne.w	loc_12872
		move.b	$27(a0),d0
		moveq	#0,d1
		move.b	$2A(a0),d2
		andi.b	#1,d2
		bne.s	loc_1281E
		andi.b	#-4,4(a0)
		tst.b	$2D(a0)
		bpl.s	loc_12806
		cmpi.b	#$B,($FFFFFE10).w
		beq.s	loc_1280A
		cmpi.b	#4,($FFFFFE10).w
		beq.s	loc_1280A
		ori.b	#2,4(a0)
		neg.b	d0
		addi.b	#$8F,d0
		bra.s	loc_1280A
; ---------------------------------------------------------------------------

loc_12806:
		addi.b	#$B,d0

loc_1280A:
					; Animate_Sonic+1F6j ...
		divu.w	#$16,d0
		addi.b	#$31,d0
		move.b	d0,$22(a0)
		move.b	#0,$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_1281E:
		andi.b	#-4,4(a0)
		tst.b	$2D(a0)
		bpl.s	loc_1284E
		cmpi.b	#4,($FFFFFE10).w
		beq.s	loc_12842
		cmpi.b	#$B,($FFFFFE10).w
		beq.s	loc_12842
		cmpi.b	#7,($FFFFFE10).w
		bne.s	loc_1284E

loc_12842:
					; Animate_Sonic+238j
		ori.b	#1,4(a0)
		addi.b	#$B,d0
		bra.s	loc_1285A
; ---------------------------------------------------------------------------

loc_1284E:
					; Animate_Sonic+240j
		ori.b	#3,4(a0)
		neg.b	d0
		addi.b	#$8F,d0

loc_1285A:
		divu.w	#$16,d0
		addi.b	#$31,d0
		move.b	d0,$22(a0)
		move.b	#0,$24(a0)
		rts
; ---------------------------------------------------------------------------
byte_1286E:	dc.b 0
		dc.b $3D
		dc.b $49
		dc.b $49
; ---------------------------------------------------------------------------

loc_12872:
		move.b	byte_1286E(pc,d1.w),d3
		cmpi.b	#1,d1
		bne.s	loc_128CA
		move.b	$27(a0),d0
		moveq	#0,d1
		move.b	$2A(a0),d2
		andi.b	#1,d2
		bne.s	loc_128A8
		andi.b	#-4,4(a0)
		addi.b	#-8,d0
		divu.w	#$16,d0
		add.b	d3,d0
		move.b	d0,$22(a0)
		move.b	#0,$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_128A8:
		andi.b	#-4,4(a0)
		ori.b	#1,4(a0)
		addi.b	#-8,d0
		divu.w	#$16,d0
		add.b	d3,d0
		move.b	d0,$22(a0)
		move.b	#0,$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_128CA:
		cmpi.b	#2,d1
		bne.s	loc_12920
		move.b	$27(a0),d0
		moveq	#0,d1
		move.b	$2A(a0),d2
		andi.b	#1,d2
		bne.s	loc_128FC
		andi.b	#-4,4(a0)
		addi.b	#$B,d0
		divu.w	#$16,d0
		add.b	d3,d0
		move.b	d0,$22(a0)
		move.b	#0,$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_128FC:
		andi.b	#-4,4(a0)
		ori.b	#3,4(a0)
		neg.b	d0
		addi.b	#$8F,d0
		divu.w	#$16,d0
		add.b	d3,d0
		move.b	d0,$22(a0)
		move.b	#0,$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_12920:
		cmpi.b	#3,d1
		bne.s	loc_1297C
		move.b	$27(a0),d0
		moveq	#0,d1
		move.b	$2A(a0),d2
		andi.b	#1,d2
		bne.s	loc_1295A
		andi.b	#-4,4(a0)
		ori.b	#2,4(a0)
		neg.b	d0
		addi.b	#$8F,d0
		divu.w	#$16,d0
		add.b	d3,d0
		move.b	d0,$22(a0)
		move.b	#0,$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_1295A:
		andi.b	#-4,4(a0)
		ori.b	#1,4(a0)
		addi.b	#$B,d0
		divu.w	#$16,d0
		add.b	d3,d0
		move.b	d0,$22(a0)
		move.b	#0,$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_1297C:
		cmpi.b	#4,d1
		bne.s	loc_129F6
		move.b	$27(a0),d0
		moveq	#0,d1
		move.b	$2A(a0),d2
		andi.b	#1,d2
		bne.s	loc_129BC
		andi.b	#-4,4(a0)
		tst.b	$2D(a0)
		bpl.s	loc_129A4
		addi.b	#$B,d0
		bra.s	loc_129A8
; ---------------------------------------------------------------------------

loc_129A4:
		addi.b	#$B,d0

loc_129A8:
		divu.w	#$16,d0
		addi.b	#$31,d0
		move.b	d0,$22(a0)
		move.b	#0,$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_129BC:
		andi.b	#-4,4(a0)
		tst.b	$2D(a0)
		bpl.s	loc_129D6
		ori.b	#3,4(a0)
		neg.b	d0
		addi.b	#$8F,d0
		bra.s	loc_129E2
; ---------------------------------------------------------------------------

loc_129D6:
		ori.b	#3,4(a0)
		neg.b	d0
		addi.b	#$8F,d0

loc_129E2:
		divu.w	#$16,d0
		addi.b	#$31,d0
		move.b	d0,$22(a0)
		move.b	#0,$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_129F6:
		move.b	$27(a0),d0
		andi.b	#-4,4(a0)
		moveq	#0,d1
		move.b	$2A(a0),d2
		andi.b	#1,d2
		beq.s	loc_12A12
		ori.b	#1,4(a0)

loc_12A12:
		addi.b	#$B,d0
		divu.w	#$16,d0
		addi.b	#$31,d0
		move.b	d0,$22(a0)
		move.b	#0,$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_12A2A:
		move.b	$2A(a0),d1
		andi.b	#1,d1
		andi.b	#-4,4(a0)
		or.b	d1,4(a0)
		subq.b	#1,$24(a0)
		bpl.w	locret_12672
		move.w	$1C(a0),d2
		bpl.s	loc_12A4C
		neg.w	d2

loc_12A4C:
		lea	(byte_12B0C).l,a1
		cmpi.w	#$600,d2
		bcc.s	loc_12A5E
		lea	(byte_12B02).l,a1

loc_12A5E:
		neg.w	d2
		addi.w	#$400,d2
		bpl.s	loc_12A68
		moveq	#0,d2

loc_12A68:
		lsr.w	#8,d2
		move.b	d2,$24(a0)
		bra.w	loc_1265A
; ---------------------------------------------------------------------------

loc_12A72:
		subq.b	#1,$24(a0)
		bpl.w	locret_12672
		move.w	$1C(a0),d2
		bmi.s	loc_12A82
		neg.w	d2

loc_12A82:
		addi.w	#$800,d2
		bpl.s	loc_12A8A
		moveq	#0,d2

loc_12A8A:
		lsr.w	#6,d2
		move.b	d2,$24(a0)
		lea	(byte_12B16).l,a1
		tst.b	($FFFFFE19).w
		beq.s	loc_12AA2
		lea	(byte_12C8E).l,a1

loc_12AA2:
		bra.w	loc_1265A
; End of function Animate_Sonic

; ---------------------------------------------------------------------------
AniSonic:	include "General\Sprites\Sonic\Anim - Sonic.asm"

; =============== S U B R O U T I N E =======================================


Sonic_Load_PLC:

		moveq	#0,d0
		move.b	$22(a0),d0

Sonic_Load_PLC2:
		cmp.b	($FFFFF766).w,d0
		beq.s	locret_12D20
		move.b	d0,($FFFFF766).w
		lea	(PLC_Sonic).l,a2
		tst.b	($FFFFFE19).w
		beq.s	loc_12CD6
		lea	(PLC_SuperSonic).l,a2

loc_12CD6:
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d5
		subq.w	#1,d5
		bmi.s	locret_12D20
		move.w	#$D000,d4
		move.l	#ArtUnc_Sonic,d6
		cmpi.w	#$1B4,d0
		bcs.s	loc_12CF8
		move.l	#ArtUnc_Sonic_Extra,d6

loc_12CF8:
					; Sonic_Load_PLC+68j
		moveq	#0,d1
		move.w	(a2)+,d1
		move.w	d1,d3
		lsr.w	#8,d3
		andi.w	#$F0,d3
		addi.w	#$10,d3
		andi.w	#$FFF,d1
		lsl.l	#5,d1
		add.l	d6,d1
		move.w	d4,d2
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		dbf	d5,loc_12CF8

locret_12D20:
					; Sonic_Load_PLC+2Cj
		rts
; End of function Sonic_Load_PLC


; =============== S U B R O U T I N E =======================================


Tails_Carry_LoadPLC:

		tst.b	$38(a1)
		beq.s	Sonic_Load_PLC2
		cmpi.b	#1,$38(a1)
		beq.w	Tails_Load_PLC2
		bra.w	Knuckles_Load_PLC2
; End of function Tails_Carry_LoadPLC


; =============== S U B R O U T I N E =======================================


Animate_SonicKnuckles_2P:

		lea	(AniSonic2P).l,a1
		tst.b	$38(a0)
		beq.s	loc_12D48
		lea	(AniKnuckles2P).l,a1

loc_12D48:
		moveq	#0,d0
		move.b	$20(a0),d0
		cmp.b	$21(a0),d0
		beq.s	loc_12D6A
		move.b	d0,$21(a0)
		move.b	#0,$23(a0)
		move.b	#0,$24(a0)
		bclr	#5,$2A(a0)

loc_12D6A:
		add.w	d0,d0
		adda.w	(a1,d0.w),a1
		move.b	(a1),d0
		bmi.s	loc_12DDA
		move.b	$2A(a0),d1
		andi.b	#1,d1
		andi.b	#-4,4(a0)
		or.b	d1,4(a0)
		subq.b	#1,$24(a0)
		bpl.s	locret_12DA8
		move.b	d0,$24(a0)

loc_12D90:
					; Animate_SonicKnuckles_2P+24Aj
		moveq	#0,d1
		move.b	$23(a0),d1
		move.b	1(a1,d1.w),d0
		cmpi.b	#-4,d0
		bcc.s	loc_12DAA

loc_12DA0:
					; Animate_SonicKnuckles_2P+96j
		move.b	d0,$22(a0)
		addq.b	#1,$23(a0)

locret_12DA8:
					; Animate_SonicKnuckles_2P+1C2j ...
		rts
; ---------------------------------------------------------------------------

loc_12DAA:
		addq.b	#1,d0
		bne.s	loc_12DBA
		move.b	#0,$23(a0)
		move.b	1(a1),d0
		bra.s	loc_12DA0
; ---------------------------------------------------------------------------

loc_12DBA:
		addq.b	#1,d0
		bne.s	loc_12DCE
		move.b	2(a1,d1.w),d0
		sub.b	d0,$23(a0)
		sub.b	d0,d1
		move.b	1(a1,d1.w),d0
		bra.s	loc_12DA0
; ---------------------------------------------------------------------------

loc_12DCE:
		addq.b	#1,d0
		bne.s	locret_12DD8
		move.b	2(a1,d1.w),$20(a0)

locret_12DD8:
		rts
; ---------------------------------------------------------------------------

loc_12DDA:
		addq.b	#1,d0
		bne.w	loc_12EF4
		moveq	#0,d0
		move.b	$27(a0),d0
		bne.w	loc_12E8E
		moveq	#0,d1
		move.b	$26(a0),d0
		bmi.s	loc_12DF6
		beq.s	loc_12DF6
		subq.b	#1,d0

loc_12DF6:
					; Animate_SonicKnuckles_2P+BCj
		move.b	$2A(a0),d2
		andi.b	#1,d2
		bne.s	loc_12E02
		not.b	d0

loc_12E02:
		addi.b	#$10,d0
		bpl.s	loc_12E0A
		moveq	#3,d1

loc_12E0A:
		andi.b	#-4,4(a0)
		eor.b	d1,d2
		or.b	d2,4(a0)
		btst	#5,$2A(a0)
		bne.w	loc_12F3C
		lsr.b	#5,d0
		andi.b	#3,d0
		move.w	$1C(a0),d2
		bpl.s	loc_12E2E
		neg.w	d2

loc_12E2E:
		tst.b	$2B(a0)
		bpl.w	loc_12E38
		add.w	d2,d2

loc_12E38:
		move.b	d0,d3
		lea	(byte_1301A).l,a1
		cmpi.w	#$600,d2
		bcc.s	loc_12E4E
		lea	(byte_13014).l,a1
		add.b	d0,d0

loc_12E4E:
		add.b	d0,d3
		moveq	#0,d1
		move.b	$23(a0),d1
		move.b	1(a1,d1.w),d0
		cmpi.b	#-1,d0
		bne.s	loc_12E6A
		move.b	#0,$23(a0)
		move.b	1(a1),d0

loc_12E6A:
		move.b	d0,$22(a0)
		add.b	d3,$22(a0)
		subq.b	#1,$24(a0)
		bpl.s	locret_12E8C
		neg.w	d2
		addi.w	#$800,d2
		bpl.s	loc_12E82
		moveq	#0,d2

loc_12E82:
		lsr.w	#8,d2
		move.b	d2,$24(a0)
		addq.b	#1,$23(a0)

locret_12E8C:
		rts
; ---------------------------------------------------------------------------

loc_12E8E:
		move.b	$27(a0),d0
		moveq	#0,d1
		move.b	$2A(a0),d2
		andi.b	#1,d2
		bne.s	loc_12EBC
		andi.b	#-4,4(a0)
		addi.b	#$16,d0
		divu.w	#$2C,d0
		addi.b	#$15,d0
		move.b	d0,$22(a0)
		move.b	#0,$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_12EBC:
		andi.b	#-4,4(a0)
		tst.b	$2D(a0)
		bpl.s	loc_12ED4
		ori.b	#1,4(a0)
		addi.b	#$16,d0
		bra.s	loc_12EE0
; ---------------------------------------------------------------------------

loc_12ED4:
		ori.b	#3,4(a0)
		neg.b	d0
		addi.b	#$9A,d0

loc_12EE0:
		divu.w	#$2C,d0
		addi.b	#$15,d0
		move.b	d0,$22(a0)
		move.b	#0,$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_12EF4:
		subq.b	#1,$24(a0)
		bpl.w	locret_12DA8
		move.w	$1C(a0),d2
		bpl.s	loc_12F04
		neg.w	d2

loc_12F04:
		lea	(byte_13026).l,a1
		cmpi.w	#$600,d2
		bcc.s	loc_12F16
		lea	(byte_13020).l,a1

loc_12F16:
		neg.w	d2
		addi.w	#$400,d2
		bpl.s	loc_12F20
		moveq	#0,d2

loc_12F20:
		lsr.w	#8,d2
		move.b	d2,$24(a0)
		move.b	$2A(a0),d1
		andi.b	#1,d1
		andi.b	#-4,4(a0)
		or.b	d1,4(a0)
		bra.w	loc_12D90
; ---------------------------------------------------------------------------

loc_12F3C:
		subq.b	#1,$24(a0)
		bpl.w	locret_12DA8
		move.w	$1C(a0),d2
		bmi.s	loc_12F4C
		neg.w	d2

loc_12F4C:
		addi.w	#$800,d2
		bpl.s	loc_12F54
		moveq	#0,d2

loc_12F54:
		lsr.w	#6,d2
		lea	(byte_1302C).l,a1
		tst.b	$38(a0)
		beq.s	loc_12F6A
		lea	(byte_13032).l,a1
		lsr.w	#2,d2

loc_12F6A:
		move.b	d2,$24(a0)
		move.b	$2A(a0),d1
		andi.b	#1,d1
		andi.b	#-4,4(a0)
		or.b	d1,4(a0)
		bra.w	loc_12D90
; End of function Animate_SonicKnuckles_2P

; ---------------------------------------------------------------------------
AniSonic2P:	include "General\Sprites\Sonic\Anim - Sonic Knuckles 2P.asm"
; =============== S U B R O U T I N E =======================================


SonicKnuckles2P_Load_PLC:

		moveq	#0,d0
		move.b	$22(a0),d0
		lea	(PLC_Sonic2P).l,a2
		move.l	#ArtUnc_Sonic2P,d6
		tst.b	$38(a0)
		beq.s	loc_130BE
		lea	(PLC_Knuckles2P).l,a2
		move.l	#ArtUnc_Knuckles2P,d6

loc_130BE:
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d5
		subq.w	#1,d5
		bmi.s	locret_13100
		move.w	#$D000,d4
		cmpa.w	#$B000,a0
		beq.s	loc_130D8
		move.w	#$D400,d4

loc_130D8:
					; SonicKnuckles2P_Load_PLC+62j
		moveq	#0,d1
		move.w	(a2)+,d1
		move.w	d1,d3
		lsr.w	#8,d3
		andi.w	#$F0,d3
		addi.w	#$10,d3
		andi.w	#$FFF,d1
		lsl.l	#5,d1
		add.l	d6,d1
		move.w	d4,d2
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		dbf	d5,loc_130D8

locret_13100:
		rts
; End of function SonicKnuckles2P_Load_PLC

; ---------------------------------------------------------------------------

Obj_Tails2P:
		cmpa.w	#$B000,a0
		bne.s	loc_13130
		lea	($FFFFF760).w,a4
		lea	($FFFFEE2C).w,a5
		lea	($FFFFCC54).w,a6
		move.b	($FFFFB082).w,d0
		cmp.b	$38(a0),d0
		bne.s	loc_13124
		bchg	#3,4(a0)

loc_13124:
		tst.w	($FFFFFE08).w
		beq.s	loc_1314C
		jmp	(DebugMode).l
; ---------------------------------------------------------------------------

loc_13130:
		lea	($FFFFFEC0).w,a4
		lea	($FFFFEE2E).w,a5
		lea	($FFFFCC9E).w,a6
		move.b	($FFFFB038).w,d0
		cmp.b	$38(a0),d0
		bne.s	loc_1314C
		bchg	#4,4(a0)

loc_1314C:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_1315A(pc,d0.w),d1
		jmp	off_1315A(pc,d1.w)
; ---------------------------------------------------------------------------
off_1315A:	dc.w loc_13166-off_1315A

		dc.w loc_13274-off_1315A
		dc.w loc_1569C-off_1315A
		dc.w loc_1578E-off_1315A
		dc.w loc_157E0-off_1315A
		dc.w loc_157F4-off_1315A
; ---------------------------------------------------------------------------

loc_13166:
		addq.b	#2,5(a0)
		move.b	#$B,$1E(a0)
		move.b	#5,$1F(a0)
		move.b	#$B,$44(a0)
		move.b	#5,$45(a0)
		move.l	#Map_Tails_2P,$C(a0)
		move.w	#$100,8(a0)
		move.b	#$C,7(a0)
		move.b	#$C,6(a0)
		move.b	#$84,4(a0)
		move.b	#1,$38(a0)
		lea	(Character_Speeds).l,a1
		moveq	#0,d0
		move.b	$38(a0),d0
		lsl.w	#3,d0
		lea	(a1,d0.w),a1
		move.w	(a1)+,(a4)
		move.w	(a1)+,2(a4)
		move.w	(a1)+,4(a4)
		tst.b	($FFFFFE2A).w
		bne.w	loc_13250
		move.b	#$C,$46(a0)
		move.b	#$D,$47(a0)
		cmpa.w	#$B000,a0
		bne.s	loc_13218
		move.w	#$680,$A(a0)
		cmpi.b	#$12,($FFFFFE10).w
		bne.s	loc_131F2
		ori.w	#$8000,$A(a0)

loc_131F2:
		move.w	$10(a0),($FFFFFE2E).w
		move.w	$14(a0),($FFFFFE30).w
		move.w	$A(a0),($FFFFFE38).w
		move.w	$46(a0),($FFFFFE3A).w
		move.l	#Obj_Tails2P_Tail,($FFFFCBC0).w
		move.w	a0,($FFFFCBF0).w
		bra.s	loc_13250
; ---------------------------------------------------------------------------

loc_13218:
		move.w	#$6A0,$A(a0)
		cmpi.b	#$12,($FFFFFE10).w
		bne.s	loc_1322C
		ori.w	#$8000,$A(a0)

loc_1322C:
		move.w	$10(a0),($FFFFFE4C).w
		move.w	$14(a0),($FFFFFE4E).w
		move.w	$A(a0),($FFFFFE56).w
		move.w	$46(a0),($FFFFFE58).w
		move.l	#Obj_Tails2P_Tail,($FFFFCC0A).w
		move.w	a0,($FFFFCC3A).w

loc_13250:

		move.b	#0,$30(a0)
		move.b	#4,$31(a0)
		move.b	#$1E,$2C(a0)
		move.w	#0,($FFFFF708).w
		move.w	#$258,($FFFFF702).w
		move.w	#0,($FFFFF704).w

loc_13274:
		tst.w	($FFFFFFDA).w
		beq.s	loc_13294
		cmpa.w	#$B000,a0
		bne.s	loc_13294
		btst	#4,($FFFFF605).w
		beq.s	loc_13294
		move.w	#1,($FFFFFE08).w
		clr.b	($FFFFF7CA).w
		rts
; ---------------------------------------------------------------------------

loc_13294:

		cmpa.w	#$B000,a0
		bne.s	loc_132B4
		move.w	($FFFFF602).w,($FFFFF66A).w
		tst.b	($FFFFF7CA).w
		bne.s	loc_132C0
		move.w	($FFFFF604).w,($FFFFF66A).w
		move.w	($FFFFF604).w,($FFFFF602).w
		bra.s	loc_132C0
; ---------------------------------------------------------------------------

loc_132B4:
		tst.b	($FFFFF7CB).w
		bne.s	loc_132C0
		move.w	($FFFFF606).w,($FFFFF66A).w

loc_132C0:

		bsr.w	loc_138FE
		btst	#0,$2E(a0)
		bne.s	loc_132DE
		moveq	#0,d0
		move.b	$2A(a0),d0
		andi.w	#6,d0
		move.w	off_1332E(pc,d0.w),d1
		jsr	off_1332E(pc,d1.w)

loc_132DE:
		cmpi.w	#-$100,($FFFFEE18).w
		bne.s	loc_132EE
		move.w	($FFFFEEAA).w,d0
		and.w	d0,$14(a0)

loc_132EE:
		move.w	($FFFFEEA8).w,d0
		and.w	d0,$10(a0)
		addi.w	#$400,$10(a0)
		bsr.w	sub_10D66
		move.b	($FFFFF768).w,$3A(a0)
		move.b	($FFFFF76A).w,$3B(a0)
		btst	#1,$2E(a0)
		bne.s	loc_1331C
		bsr.w	Animate_Tails2P
		bsr.w	Tails2P_Load_PLC

loc_1331C:
		move.b	$2E(a0),d0
		andi.b	#$A0,d0
		bne.s	locret_1332C
		jsr	(sub_FE6E).l

locret_1332C:
		rts
; ---------------------------------------------------------------------------
off_1332E:	dc.w loc_13336-off_1332E

		dc.w loc_1335A-off_1332E
		dc.w loc_1346A-off_1332E
		dc.w loc_1348C-off_1332E
; ---------------------------------------------------------------------------

loc_13336:
		bsr.w	sub_13520
		bsr.w	Tails_Jump
		bsr.w	sub_11DA6
		bsr.w	Tails_InputAcceleration_Path
		bsr.w	sub_134BA
		jsr	(MoveSprite2).l
		bsr.w	Player_AnglePos
		bsr.w	sub_11E2A
		rts
; ---------------------------------------------------------------------------

loc_1335A:
		tst.b	$2F(a0)
		bne.s	loc_1338E
		bsr.w	Tails_JumpHeight
		bsr.w	Tails_InputAcceleration_Freespace
		jsr	(MoveSprite).l
		btst	#6,$2A(a0)
		beq.s	loc_1337C
		subi.w	#$28,$1A(a0)

loc_1337C:
		bsr.w	sub_11E8C
		movem.l	a4-a6,-(sp)
		bsr.w	sub_153C2
		movem.l	(sp)+,a4-a6
		rts
; ---------------------------------------------------------------------------

loc_1338E:
		bsr.w	sub_133AE
		bsr.w	Tails_InputAcceleration_Freespace
		jsr	(MoveSprite2).l
		bsr.w	sub_11E8C
		movem.l	a4-a6,-(sp)
		bsr.w	sub_153C2
		movem.l	(sp)+,a4-a6
		rts

; =============== S U B R O U T I N E =======================================


sub_133AE:
		move.b	($FFFFFE05).w,d0
		andi.b	#1,d0
		beq.s	loc_133C2
		tst.b	$25(a0)
		beq.s	loc_133C2
		subq.b	#1,$25(a0)

loc_133C2:
		cmpi.b	#1,$2F(a0)
		beq.s	loc_133EC
		cmpi.w	#-$100,$1A(a0)
		blt.s	loc_133E4
		subi.w	#$20,$1A(a0)
		addq.b	#1,$2F(a0)
		cmpi.b	#$20,$2F(a0)
		bne.s	loc_133EA

loc_133E4:
		move.b	#1,$2F(a0)

loc_133EA:
		bra.s	loc_1341E
; ---------------------------------------------------------------------------

loc_133EC:
		move.b	($FFFFF66B).w,d0
		andi.b	#$70,d0
		beq.s	loc_13418
		cmpi.w	#-$100,$1A(a0)
		blt.s	loc_13418
		tst.b	$25(a0)
		beq.s	loc_13418
		btst	#6,$2A(a0)
		beq.s	loc_13412
		tst.b	($FFFFF73E).w
		bne.s	loc_13418

loc_13412:
		move.b	#2,$2F(a0)

loc_13418:

		addi.w	#8,$1A(a0)

loc_1341E:
		move.w	($FFFFEE18).w,d0
		addi.w	#$10,d0
		cmp.w	$14(a0),d0
		blt.s	loc_13438
		tst.w	$1A(a0)
		bpl.s	loc_13438
		move.w	#0,$1A(a0)

loc_13438:

		tst.b	$25(a0)
		bne.s	loc_13454
		move.b	($FFFFFE05).w,d0
		addq.b	#8,d0
		andi.b	#$F,d0
		bne.s	locret_13452
		moveq	#-$45,d0
		jsr	(Play_Sound_2).l

locret_13452:
		rts
; ---------------------------------------------------------------------------

loc_13454:
		move.b	($FFFFFE05).w,d0
		addq.b	#8,d0
		andi.b	#$F,d0
		bne.s	locret_13468
		moveq	#-$46,d0
		jsr	(Play_Sound_2).l

locret_13468:
		rts
; End of function sub_133AE

; ---------------------------------------------------------------------------

loc_1346A:
		tst.b	$3D(a0)
		bne.s	loc_13474
		bsr.w	Tails_Jump

loc_13474:
		bsr.w	sub_11DEE
		bsr.w	sub_14D32
		jsr	(MoveSprite2).l
		bsr.w	Player_AnglePos
		bsr.w	sub_11E2A
		rts
; ---------------------------------------------------------------------------

loc_1348C:
		bsr.w	Tails_JumpHeight
		bsr.w	Tails_InputAcceleration_Freespace
		jsr	(MoveSprite).l
		btst	#6,$2A(a0)
		beq.s	loc_134A8
		subi.w	#$28,$1A(a0)

loc_134A8:
		bsr.w	sub_11E8C
		movem.l	a4-a6,-(sp)
		bsr.w	sub_153C2
		movem.l	(sp)+,a4-a6
		rts

; =============== S U B R O U T I N E =======================================


sub_134BA:
		tst.b	$2B(a0)
		bmi.s	locret_134E0
		move.w	$1C(a0),d0
		bpl.s	loc_134C8
		neg.w	d0

loc_134C8:
		cmpi.w	#$80,d0
		bcs.s	locret_134E0
		move.b	($FFFFF66A).w,d0
		andi.b	#$C,d0
		bne.s	locret_134E0
		btst	#1,($FFFFF66A).w
		bne.s	loc_134E2

locret_134E0:

		rts
; ---------------------------------------------------------------------------

loc_134E2:
		btst	#2,$2A(a0)
		beq.s	loc_134EC
		rts
; ---------------------------------------------------------------------------

loc_134EC:
		bset	#2,$2A(a0)
		move.b	#7,$1E(a0)
		move.b	#3,$1F(a0)
		move.b	#2,$20(a0)
		addq.w	#4,$14(a0)
		move.w	#$3C,d0
		jsr	(Play_Sound_2).l
		tst.w	$1C(a0)
		bne.s	locret_1351E
		move.w	#$200,$1C(a0)

locret_1351E:
		rts
; End of function sub_134BA


; =============== S U B R O U T I N E =======================================


sub_13520:
		tst.b	$3D(a0)
		bne.s	loc_13570
		cmpi.b	#8,$20(a0)
		bne.s	locret_1356E
		move.b	($FFFFF66B).w,d0
		andi.b	#$70,d0
		beq.w	locret_1356E
		move.b	#9,$20(a0)
		move.w	#$FFAB,d0
		jsr	(Play_Sound_2).l
		addq.l	#4,sp
		move.b	#1,$3D(a0)
		move.w	#0,$3E(a0)
		cmpi.b	#$C,$2C(a0)
		bcs.s	loc_13566
		move.b	#2,$20(a6)

loc_13566:
		bsr.w	Tails_Check_Screen_Boundaries
		bsr.w	Player_AnglePos

locret_1356E:

		rts
; ---------------------------------------------------------------------------

loc_13570:
		move.b	($FFFFF66A).w,d0
		btst	#1,d0
		bne.w	loc_13600
		move.b	#7,$1E(a0)
		move.b	#3,$1F(a0)
		move.b	#2,$20(a0)
		addq.w	#4,$14(a0)
		move.b	#0,$3D(a0)
		moveq	#0,d0
		move.b	$3E(a0),d0
		add.w	d0,d0
		move.w	word_135EE(pc,d0.w),$1C(a0)
		move.w	$1C(a0),d0
		subi.w	#$800,d0
		add.w	d0,d0
		andi.w	#$1F00,d0
		neg.w	d0
		addi.w	#$2000,d0
		lea	($FFFFEE24).w,a1
		cmpa.w	#$B000,a0
		beq.s	loc_135C8
		lea	($FFFFEE28).w,a1

loc_135C8:
		move.w	d0,(a1)
		btst	#0,$2A(a0)
		beq.s	loc_135D6
		neg.w	$1C(a0)

loc_135D6:
		bset	#2,$2A(a0)
		move.b	#0,$20(a6)
		move.w	#$FFB6,d0
		jsr	(Play_Sound_2).l
		bra.s	loc_13648
; ---------------------------------------------------------------------------
word_135EE:	dc.w $800
		dc.w $880
		dc.w $900
		dc.w $980
		dc.w $A00
		dc.w $A80
		dc.w $B00
		dc.w $B80
		dc.w $C00
; ---------------------------------------------------------------------------

loc_13600:
		tst.w	$3E(a0)
		beq.s	loc_13618
		move.w	$3E(a0),d0
		lsr.w	#5,d0
		sub.w	d0,$3E(a0)
		bcc.s	loc_13618
		move.w	#0,$3E(a0)

loc_13618:

		move.b	($FFFFF66B).w,d0
		andi.b	#$70,d0
		beq.w	loc_13648
		move.w	#$900,$20(a0)
		move.w	#$FFAB,d0
		jsr	(Play_Sound_2).l
		addi.w	#$200,$3E(a0)
		cmpi.w	#$800,$3E(a0)
		bcs.s	loc_13648
		move.w	#$800,$3E(a0)

loc_13648:

		addq.l	#4,sp
		cmpi.w	#$60,(a5)
		beq.s	loc_13656
		bcc.s	loc_13654
		addq.w	#4,(a5)

loc_13654:
		subq.w	#2,(a5)

loc_13656:
		bsr.w	Player_AnglePos
		rts
; End of function sub_13520

; ---------------------------------------------------------------------------

Obj_Tails:
					; SpawnLevelMainSprites_SpawnPlayers+78o ...
		lea	($FFFFFEC0).w,a4
		lea	($FFFFEE2E).w,a5
		lea	($FFFFCC9E).w,a6
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_136AE
		tst.w	($FFFFFE08).w
		beq.s	loc_136AE
		cmpi.b	#1,($FFFFFE09).w
		beq.s	loc_136A8
		btst	#4,($FFFFF605).w
		beq.s	loc_1368C
		move.w	#0,($FFFFFE08).w

loc_1368C:
		addq.b	#1,$22(a0)
		cmpi.b	#-5,$22(a0)
		bcs.s	loc_1369E
		move.b	#0,$22(a0)

loc_1369E:
		bsr.w	Tails_Load_PLC
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_136A8:
		jmp	(DebugMode).l
; ---------------------------------------------------------------------------

loc_136AE:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_136BC(pc,d0.w),d1
		jmp	off_136BC(pc,d1.w)
; ---------------------------------------------------------------------------
off_136BC:	dc.w loc_136CA-off_136BC

		dc.w loc_137C4-off_136BC
		dc.w loc_1569C-off_136BC
		dc.w loc_1578E-off_136BC
		dc.w loc_157E0-off_136BC
		dc.w loc_157F4-off_136BC
		dc.w loc_15810-off_136BC
; ---------------------------------------------------------------------------

loc_136CA:
		addq.b	#2,5(a0)
		move.b	#$F,$1E(a0)
		move.b	#9,$1F(a0)
		move.b	#$F,$44(a0)
		move.b	#9,$45(a0)
		move.l	#Map_Tails,$C(a0)
		move.w	#$100,8(a0)
		move.b	#$18,7(a0)
		move.b	#$18,6(a0)
		move.b	#$84,4(a0)
		move.b	#1,$38(a0)
		move.w	#$600,(a4)
		move.w	#$C,2(a4)
		move.w	#$80,4(a4)
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_1375E
		tst.b	($FFFFFE2A).w
		bne.s	loc_13776
		move.w	#$6A0,$A(a0)
		move.b	#$C,$46(a0)
		move.b	#$D,$47(a0)
		cmpi.b	#2,($FFFFFE48).w
		beq.s	loc_13776
		move.w	$10(a0),($FFFFFE2E).w
		move.w	$14(a0),($FFFFFE30).w
		move.w	$A(a0),($FFFFFE38).w
		move.w	$46(a0),($FFFFFE3A).w
		bra.s	loc_13776
; ---------------------------------------------------------------------------

loc_1375E:
		move.w	#$6A0,$A(a0)
		move.w	($FFFFB046).w,$46(a0)
		tst.w	($FFFFB00A).w
		bpl.s	loc_13776
		ori.w	#$8000,$A(a0)

loc_13776:

		move.b	#0,$30(a0)
		move.b	#4,$31(a0)
		move.b	#0,($FFFFF667).w
		move.b	#$1E,$2C(a0)
		cmpi.w	#$20,($FFFFF708).w
		beq.s	loc_137A4
		cmpi.w	#$12,($FFFFF708).w
		beq.s	loc_137A4
		move.w	#0,($FFFFF708).w

loc_137A4:

		move.w	#0,($FFFFF702).w
		move.w	#0,($FFFFF704).w
		move.l	#Obj_Tails_Tail,($FFFFCC0A).w
		move.w	a0,($FFFFCC3A).w
		move.b	($FFFFFE2A).w,($FFFFF746).w
		rts
; ---------------------------------------------------------------------------

loc_137C4:
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_13808
		tst.w	($FFFFFFDA).w
		beq.s	loc_13808
		bclr	#6,($FFFFF605).w
		beq.s	loc_137E0
		eori.b	#1,($FFFFF7C6).w

loc_137E0:
		btst	#4,($FFFFF605).w
		beq.s	loc_13808
		move.w	#1,($FFFFFE08).w
		clr.b	($FFFFF7CA).w
		btst	#5,($FFFFF604).w
		beq.s	locret_13806
		move.w	#2,($FFFFFE08).w
		move.b	#0,$20(a0)

locret_13806:
		rts
; ---------------------------------------------------------------------------

loc_13808:

		cmpa.w	#$B000,a0
		bne.s	loc_13830
		move.w	($FFFFF602).w,($FFFFF66A).w
		tst.b	($FFFFF7CA).w
		bne.s	loc_1384A
		move.w	($FFFFF604).w,($FFFFF66A).w
		move.w	($FFFFF604).w,($FFFFF602).w
		cmpi.w	#$1A,($FFFFF708).w
		bcc.s	loc_13840
		bra.s	loc_1384A
; ---------------------------------------------------------------------------

loc_13830:
		tst.b	($FFFFF7CB).w
		beq.s	loc_1383A
		bpl.s	loc_13840
		bra.s	loc_1384A
; ---------------------------------------------------------------------------

loc_1383A:
		move.w	($FFFFF606).w,($FFFFF66A).w

loc_13840:

		tst.w	($FFFFFFE8).w
		bne.s	loc_1384A
		bsr.w	sub_139CC

loc_1384A:

		btst	#0,$2E(a0)
		beq.s	loc_13872
		move.b	#0,$2F(a0)
		tst.b	($FFFFF73E).w
		beq.s	loc_1388C
		lea	($FFFFB000).w,a1
		clr.b	$2E(a1)
		bset	#1,$2A(a1)
		clr.w	($FFFFF73E).w
		bra.s	loc_1388C
; ---------------------------------------------------------------------------

loc_13872:
		movem.l	a4-a6,-(sp)
		moveq	#0,d0
		move.b	$2A(a0),d0
		andi.w	#6,d0
		move.w	off_138F6(pc,d0.w),d1
		jsr	off_138F6(pc,d1.w)
		movem.l	(sp)+,a4-a6

loc_1388C:

		cmpi.w	#-$100,($FFFFEE18).w
		bne.s	loc_1389C
		move.w	($FFFFEEAA).w,d0
		and.w	d0,$14(a0)

loc_1389C:
		bsr.s	loc_138FE
		bsr.w	loc_11B26
		bsr.w	sub_10D66
		bsr.w	sub_14632
		move.b	($FFFFF768).w,$3A(a0)
		move.b	($FFFFF76A).w,$3B(a0)
		tst.b	($FFFFF7C9).w
		beq.s	loc_138C8
		tst.b	$20(a0)
		bne.s	loc_138C8
		move.b	$21(a0),$20(a0)

loc_138C8:

		btst	#1,$2E(a0)
		bne.s	loc_138E4
		bsr.w	Animate_Tails
		tst.b	($FFFFF7C6).w
		beq.s	loc_138E0
		eori.b	#2,4(a0)

loc_138E0:
		bsr.w	Tails_Load_PLC

loc_138E4:
		move.b	$2E(a0),d0
		andi.b	#$A0,d0
		bne.s	locret_138F4
		jsr	(Test_Sprite_Collisions).l

locret_138F4:
		rts
; ---------------------------------------------------------------------------
off_138F6:	dc.w Tails_Stand_Path-off_138F6

		dc.w Tails_Stand_Freespace-off_138F6
		dc.w Tails_Spin_Path-off_138F6
		dc.w Tails_Spin_Freespace-off_138F6
; ---------------------------------------------------------------------------

loc_138FE:

		move.b	$34(a0),d0
		beq.s	loc_1390C
		subq.b	#1,$34(a0)
		lsr.b	#3,d0
		bcc.s	loc_13912

loc_1390C:
		jsr	(Draw_Sprite).l

loc_13912:
		btst	#1,$2B(a0)
		beq.s	loc_1394E
		tst.b	$35(a0)
		beq.s	loc_1394E
		move.b	($FFFFFE05).w,d0
		andi.b	#7,d0
		bne.s	loc_1394E
		subq.b	#1,$35(a0)
		bne.s	loc_1394E
		tst.b	($FFFFF7AA).w
		bne.s	loc_13948
		cmpi.b	#$C,$2C(a0)
		bcs.s	loc_13948
		move.w	($FFFFFF90).w,d0
		jsr	(Play_Sound).l

loc_13948:

		bclr	#1,$2B(a0)

loc_1394E:

		btst	#2,$2B(a0)
		beq.s	locret_139A6
		tst.b	$36(a0)
		beq.s	locret_139A6
		move.b	($FFFFFE05).w,d0
		andi.b	#7,d0
		bne.s	locret_139A6
		subq.b	#1,$36(a0)
		bne.s	locret_139A6
		tst.w	($FFFFFFE8).w
		bne.s	loc_139A8
		move.w	#$600,(a4)
		move.w	#$C,2(a4)
		move.w	#$80,4(a4)
		tst.b	($FFFFF667).w
		beq.s	loc_13998
		move.w	#$800,(a4)
		move.w	#$18,2(a4)
		move.w	#$C0,4(a4)

loc_13998:
		bclr	#2,$2B(a0)
		moveq	#0,d0
		jmp	(Change_Music_Tempo).l
; ---------------------------------------------------------------------------

locret_139A6:

		rts
; ---------------------------------------------------------------------------

loc_139A8:
		lea	(Character_Speeds).l,a1
		moveq	#0,d0
		move.b	$38(a0),d0
		lsl.w	#3,d0
		lea	(a1,d0.w),a1
		move.w	(a1)+,(a4)
		move.w	(a1)+,2(a4)
		move.w	(a1)+,4(a4)
		bclr	#2,$2B(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_139CC:
		move.b	($FFFFF66A).w,d0
		andi.b	#$7F,d0
		beq.s	loc_139DC
		move.w	#$258,($FFFFF702).w

loc_139DC:
		lea	($FFFFB000).w,a1
		move.w	($FFFFF708).w,d0
		move.w	off_139EC(pc,d0.w),d0
		jmp	off_139EC(pc,d0.w)
; End of function sub_139CC

; ---------------------------------------------------------------------------
off_139EC:	dc.w loc_13A10-off_139EC

		dc.w Tails_Catch_Up_Flying-off_139EC
		dc.w Tails_FlySwim_Unknown-off_139EC
		dc.w loc_13D4A-off_139EC
		dc.w loc_13F40-off_139EC
		dc.w locret_13FC0-off_139EC
		dc.w loc_13FC2-off_139EC
		dc.w loc_13FFA-off_139EC
		dc.w loc_1408A-off_139EC
		dc.w loc_140C6-off_139EC
		dc.w loc_140CE-off_139EC
		dc.w loc_14106-off_139EC
		dc.w loc_1414C-off_139EC
		dc.w loc_141F2-off_139EC
		dc.w loc_1421C-off_139EC
		dc.w loc_14254-off_139EC
		dc.w loc_1425C-off_139EC
		dc.w loc_14286-off_139EC
; ---------------------------------------------------------------------------

loc_13A10:
		tst.b	($FFFFF746).w
		bne.w	loc_13AF4
		cmpi.w	#0,($FFFFFE10).w
		bne.s	loc_13A32
		bsr.w	sub_13ECA
		move.w	#$A,($FFFFF708).w
		move.b	#-$7D,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_13A32:
		cmpi.w	#$100,($FFFFFE10).w
		beq.w	loc_13B12
		cmpi.w	#$200,($FFFFFE10).w
		beq.w	loc_13B12
		cmpi.w	#$300,($FFFFFE10).w
		bne.s	loc_13A74
		move.w	#$18,$10(a0)
		move.w	#$600,$14(a0)

loc_13A5A:
		move.w	#0,($FFFFF702).w
		move.w	#0,($FFFFF704).w
		move.b	#2,$2A(a0)
		move.w	#$C,($FFFFF708).w
		rts
; ---------------------------------------------------------------------------

loc_13A74:
		cmpi.w	#$500,($FFFFFE10).w
		bne.s	loc_13A8E
		bsr.w	sub_13ECA
		move.w	#$A,($FFFFF708).w
		move.b	#-$7D,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_13A8E:
		cmpi.w	#$600,($FFFFFE10).w
		beq.w	loc_13B12
		cmpi.w	#$700,($FFFFFE10).w
		bne.s	loc_13AB4
		tst.w	($FFFFFFAE).w
		bne.s	loc_13AB4
		move.w	#$D8,$10(a0)
		move.w	#$500,$14(a0)
		bra.s	loc_13A5A
; ---------------------------------------------------------------------------

loc_13AB4:

		cmpi.w	#$800,($FFFFFE10).w
		beq.w	loc_13B18
		cmpi.w	#$900,($FFFFFE10).w
		beq.w	loc_13B12
		cmpi.w	#$A00,($FFFFFE10).w
		bne.s	loc_13AE2
		bsr.w	sub_13ECA
		move.w	#$A,($FFFFF708).w
		move.b	#-$7D,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_13AE2:
		cmpi.w	#$1600,($FFFFFE10).w
		beq.w	loc_13B12
		cmpi.b	#$17,($FFFFFE10).w
		beq.s	loc_13B18

loc_13AF4:
		move.b	#0,$20(a0)
		move.w	#0,$18(a0)
		move.w	#0,$1A(a0)
		move.w	#0,$1C(a0)
		move.b	#0,$2A(a0)

loc_13B12:

		move.b	#0,$2E(a0)

loc_13B18:

		move.w	#6,($FFFFF708).w
		move.w	#0,($FFFFF704).w
		rts
; ---------------------------------------------------------------------------

Tails_Catch_Up_Flying:
		move.b	($FFFFF66A).w,d0
		andi.b	#$F0,d0
		bne.s	loc_13B50
		move.w	($FFFFFE04).w,d0
		andi.w	#$3F,d0
		bne.w	locret_13BF6
		tst.b	$2E(a1)
		bmi.w	locret_13BF6
		move.b	$2A(a1),d0
		andi.b	#$80,d0
		bne.w	locret_13BF6

loc_13B50:
		move.w	#4,($FFFFF708).w
		move.w	$10(a1),d0
		move.w	d0,$10(a0)
		move.w	d0,($FFFFF70A).w
		move.w	$14(a1),d0
		move.w	d0,($FFFFF70C).w
		subi.w	#$C0,d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_13B78
		addi.w	#$180,d0

loc_13B78:
		move.w	d0,$14(a0)
		ori.w	#$8000,$A(a0)
		move.w	#$100,8(a0)
		moveq	#0,d0
		move.w	d0,$18(a0)
		move.w	d0,$1A(a0)
		move.w	d0,$1C(a0)
		move.b	d0,$2D(a0)
		move.b	d0,$2F(a0)
		move.b	#2,$2A(a0)
		move.b	#$1E,$2C(a0)
		move.b	#-$7F,$2E(a0)
		move.b	d0,$30(a0)
		move.b	d0,$31(a0)
		move.w	d0,$32(a0)
		move.b	d0,$34(a0)
		move.b	d0,$35(a0)
		move.b	d0,$36(a0)
		move.b	d0,$37(a0)
		move.b	d0,$39(a0)
		move.w	d0,$3A(a0)
		move.b	d0,$3C(a0)
		move.b	d0,$3D(a0)
		move.b	d0,$3D(a0)
		move.w	d0,$3E(a0)
		move.b	d0,$40(a0)
		move.b	d0,$41(a0)
		move.b	#-$10,$25(a0)
		bsr.w	Tails_Set_Flying_Animation

locret_13BF6:

		rts
; ---------------------------------------------------------------------------

Tails_FlySwim_Unknown:
		tst.b	4(a0)
		bmi.s	loc_13C3A
		addq.w	#1,($FFFFF704).w
		cmpi.w	#$12C,($FFFFF704).w
		bcs.s	loc_13C50
		move.w	#0,($FFFFF704).w
		move.w	#2,($FFFFF708).w
		move.b	#-$7F,$2E(a0)
		move.b	#2,$2A(a0)
		move.w	#0,$10(a0)
		move.w	#0,$14(a0)
		move.b	#-$10,$25(a0)
		bsr.w	Tails_Set_Flying_Animation
		rts
; ---------------------------------------------------------------------------

loc_13C3A:
		move.b	#-$10,$25(a0)
		ori.b	#2,$2A(a0)
		bsr.w	Tails_Set_Flying_Animation
		move.w	#0,($FFFFF704).w

loc_13C50:
		lea	($FFFFE500).w,a2
		move.w	#$10,d2
		lsl.b	#2,d2
		addq.b	#4,d2
		move.w	($FFFFEE26).w,d3
		sub.b	d2,d3
		move.w	(a2,d3.w),($FFFFF70A).w
		move.w	2(a2,d3.w),($FFFFF70C).w
		move.w	$10(a0),d0
		sub.w	($FFFFF70A).w,d0
		beq.s	loc_13CBE
		move.w	d0,d2
		bpl.s	loc_13C7E
		neg.w	d2

loc_13C7E:
		lsr.w	#4,d2
		cmpi.w	#$C,d2
		bcs.s	loc_13C88
		moveq	#$C,d2

loc_13C88:
		move.b	$18(a1),d1
		bpl.s	loc_13C90
		neg.b	d1

loc_13C90:
		add.b	d1,d2
		addq.w	#1,d2
		tst.w	d0
		bmi.s	loc_13CAA
		bset	#0,$2A(a0)
		cmp.w	d0,d2
		bcs.s	loc_13CA6
		move.w	d0,d2
		moveq	#0,d0

loc_13CA6:
		neg.w	d2
		bra.s	loc_13CBA
; ---------------------------------------------------------------------------

loc_13CAA:
		bclr	#0,$2A(a0)
		neg.w	d0
		cmp.w	d0,d2
		bcs.s	loc_13CBA
		move.b	d0,d2
		moveq	#0,d0

loc_13CBA:

		add.w	d2,$10(a0)

loc_13CBE:
		moveq	#1,d2
		move.w	$14(a0),d1
		sub.w	($FFFFF70C).w,d1
		beq.s	loc_13CD2
		bmi.s	loc_13CCE
		neg.w	d2

loc_13CCE:
		add.w	d2,$14(a0)

loc_13CD2:
		lea	($FFFFE400).w,a2
		move.b	2(a2,d3.w),d2
		andi.b	#$80,d2
		bne.s	loc_13D42
		or.w	d0,d1
		bne.s	loc_13D42
		cmpi.b	#6,($FFFFB005).w
		bcc.s	loc_13D42
		move.w	#6,($FFFFF708).w
		move.b	#0,$2E(a0)
		move.b	#0,$20(a0)
		move.w	#0,$18(a0)
		move.w	#0,$1A(a0)
		move.w	#0,$1C(a0)
		andi.b	#$40,$2A(a0)
		ori.b	#2,$2A(a0)
		move.w	#0,$32(a0)
		andi.w	#$7FFF,$A(a0)
		tst.b	$A(a1)
		bpl.s	loc_13D34
		ori.w	#$8000,$A(a0)

loc_13D34:
		move.b	$46(a1),$46(a0)
		move.b	$47(a1),$47(a0)
		rts
; ---------------------------------------------------------------------------

loc_13D42:

		move.b	#-$7F,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_13D4A:
		cmpi.b	#6,($FFFFB005).w
		bcs.s	loc_13D78
		move.w	#4,($FFFFF708).w
		move.b	#0,$3D(a0)
		move.w	#0,$3E(a0)
		move.b	#-$7F,$2E(a0)
		move.b	#2,$2A(a0)
		move.b	#$20,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_13D78:
		bsr.w	sub_13EFC
		tst.w	($FFFFF702).w
		bne.w	loc_13EBE
		tst.b	$2E(a0)
		bmi.w	loc_13EBE
		tst.b	$37(a1)
		bmi.w	loc_13EBE
		tst.w	$32(a0)
		beq.s	loc_13DA6
		tst.w	$1C(a0)
		bne.s	loc_13DA6
		move.w	#8,($FFFFF708).w

loc_13DA6:

		lea	($FFFFE500).w,a2
		move.w	#$10,d1
		lsl.b	#2,d1
		addq.b	#4,d1
		move.w	($FFFFEE26).w,d0
		sub.b	d1,d0
		move.w	(a2,d0.w),d2
		btst	#3,$2A(a1)
		bne.s	loc_13DD0
		cmpi.w	#$400,$1C(a1)
		bge.s	loc_13DD0
		subi.w	#$20,d2

loc_13DD0:

		move.w	2(a2,d0.w),d3
		lea	($FFFFE400).w,a2
		move.w	(a2,d0.w),d1
		move.b	2(a2,d0.w),d4
		move.w	d1,d0
		btst	#5,$2A(a0)
		beq.s	loc_13DF2
		btst	#5,d4
		beq.w	loc_13E9C

loc_13DF2:
		sub.w	$10(a0),d2
		beq.s	loc_13E50
		bpl.s	loc_13E26
		neg.w	d2
		cmpi.w	#$30,d2
		bcs.s	loc_13E0A
		andi.w	#$F3F3,d1
		ori.w	#$404,d1

loc_13E0A:
		tst.w	$1C(a0)
		beq.s	loc_13E64
		btst	#0,$2A(a0)
		beq.s	loc_13E64
		btst	#0,$2E(a0)
		bne.s	loc_13E64
		subq.w	#1,$10(a0)
		bra.s	loc_13E64
; ---------------------------------------------------------------------------

loc_13E26:
		cmpi.w	#$30,d2
		bcs.s	loc_13E34
		andi.w	#$F3F3,d1
		ori.w	#$808,d1

loc_13E34:
		tst.w	$1C(a0)
		beq.s	loc_13E64
		btst	#0,$2A(a0)
		bne.s	loc_13E64
		btst	#0,$2E(a0)
		bne.s	loc_13E64
		addq.w	#1,$10(a0)
		bra.s	loc_13E64
; ---------------------------------------------------------------------------

loc_13E50:
		bclr	#0,$2A(a0)
		move.b	d4,d0
		andi.b	#1,d0
		beq.s	loc_13E64
		bset	#0,$2A(a0)

loc_13E64:

		tst.b	($FFFFF70F).w
		beq.s	loc_13E7C
		ori.w	#$7000,d1
		btst	#1,$2A(a0)
		bne.s	loc_13EB8
		move.b	#0,($FFFFF70F).w

loc_13E7C:
		move.w	($FFFFFE04).w,d0
		andi.w	#$FF,d0
		beq.s	loc_13E8C
		cmpi.w	#$40,d2
		bcc.s	loc_13EB8

loc_13E8C:
		sub.w	$14(a0),d3
		beq.s	loc_13EB8
		bpl.s	loc_13EB8
		neg.w	d3
		cmpi.w	#$20,d3
		bcs.s	loc_13EB8

loc_13E9C:
		move.b	($FFFFFE05).w,d0
		andi.b	#$3F,d0
		bne.s	loc_13EB8
		cmpi.b	#8,$20(a0)
		beq.s	loc_13EB8
		ori.w	#$7070,d1
		move.b	#1,($FFFFF70F).w

loc_13EB8:

		move.w	d1,($FFFFF66A).w
		rts
; ---------------------------------------------------------------------------

loc_13EBE:

		tst.w	($FFFFF702).w
		beq.s	locret_13EC8
		subq.w	#1,($FFFFF702).w

locret_13EC8:
		rts

; =============== S U B R O U T I N E =======================================


sub_13ECA:

		move.w	#0,($FFFFF702).w
		move.w	#0,($FFFFF704).w
		move.w	#2,($FFFFF708).w
		move.b	#-$7F,$2E(a0)
		move.b	#2,$2A(a0)
		move.w	#$7F00,$10(a0)
		move.w	#0,$14(a0)
		move.b	#0,$2F(a0)
		rts
; End of function sub_13ECA


; =============== S U B R O U T I N E =======================================


sub_13EFC:

		tst.b	4(a0)
		bmi.s	loc_13F28
		btst	#3,$2A(a0)
		beq.s	loc_13F18
		moveq	#0,d0
		movea.w	$42(a0),a3
		move.w	($FFFFF700).w,d0
		cmp.w	(a3),d0
		bne.s	loc_13F24

loc_13F18:
		addq.w	#1,($FFFFF704).w
		cmpi.w	#$12C,($FFFFF704).w
		bcs.s	loc_13F2E

loc_13F24:
		bra.w	sub_13ECA
; ---------------------------------------------------------------------------

loc_13F28:
		move.w	#0,($FFFFF704).w

loc_13F2E:
		btst	#3,$2A(a0)
		beq.s	locret_13F3E
		movea.w	$42(a0),a3
		move.w	(a3),($FFFFF700).w

locret_13F3E:
		rts
; End of function sub_13EFC

; ---------------------------------------------------------------------------

loc_13F40:
		bsr.w	sub_13EFC
		tst.w	($FFFFF702).w
		bne.w	locret_13FBE
		tst.w	$32(a0)
		bne.s	locret_13FBE
		tst.b	$3D(a0)
		bne.s	loc_13F94
		tst.w	$1C(a0)
		bne.s	locret_13FBE
		bclr	#0,$2A(a0)
		move.w	$10(a0),d0
		sub.w	$10(a1),d0
		bcs.s	loc_13F74
		bset	#0,$2A(a0)

loc_13F74:
		move.w	#$202,($FFFFF66A).w
		move.b	($FFFFFE05).w,d0
		andi.b	#$7F,d0
		beq.s	loc_13FA4
		cmpi.b	#8,$20(a0)
		bne.s	locret_13FBE
		move.w	#$7272,($FFFFF66A).w
		rts
; ---------------------------------------------------------------------------

loc_13F94:
		move.w	#$202,($FFFFF66A).w
		move.b	($FFFFFE05).w,d0
		andi.b	#$7F,d0
		bne.s	loc_13FB2

loc_13FA4:
		move.w	#0,($FFFFF66A).w
		move.w	#6,($FFFFF708).w
		rts
; ---------------------------------------------------------------------------

loc_13FB2:
		andi.b	#$1F,d0
		bne.s	locret_13FBE
		ori.w	#$7070,($FFFFF66A).w

locret_13FBE:

		rts
; ---------------------------------------------------------------------------

locret_13FC0:
		rts
; ---------------------------------------------------------------------------

loc_13FC2:
		move.b	#1,$2F(a0)
		move.b	#-$10,$25(a0)
		move.b	#2,$2A(a0)
		move.w	#$100,$18(a0)
		move.w	#0,$1A(a0)
		move.w	#0,$1C(a0)
		lea	($FFFFB000).w,a1
		bsr.w	sub_1459E
		move.b	#1,($FFFFF73E).w
		move.w	#$E,($FFFFF708).w

loc_13FFA:
		move.w	#0,($FFFFF702).w
		move.w	#0,($FFFFF66A).w
		move.b	($FFFFFE05).w,d0
		andi.b	#$1F,d0
		bne.s	loc_14016
		ori.w	#$808,($FFFFF66A).w

loc_14016:
		lea	($FFFFF73E).w,a2
		lea	($FFFFB000).w,a1
		btst	#1,$2A(a1)
		bne.s	loc_14082
		move.w	#6,($FFFFF708).w
		move.b	#0,$2E(a0)
		move.b	#0,$20(a0)
		move.w	#0,$18(a0)
		move.w	#0,$1A(a0)
		move.w	#0,$1C(a0)
		move.b	#2,$2A(a0)
		move.w	#0,$32(a0)
		andi.w	#$7FFF,$A(a0)
		tst.b	$A(a1)
		bpl.s	loc_14068
		ori.w	#-$8000,$A(a0)

loc_14068:
		move.b	$46(a1),$46(a0)
		move.b	$47(a1),$47(a0)
		cmpi.w	#1,($FFFFFF08).w
		bne.s	loc_14082
		move.w	#$10,($FFFFF708).w

loc_14082:

		move.w	($FFFFF604).w,d0
		bra.w	Tails_Carry_Sonic
; ---------------------------------------------------------------------------

loc_1408A:
		move.w	#0,($FFFFF702).w
		move.b	#-$10,$25(a0)
		move.w	#0,($FFFFF66A).w
		move.b	($FFFFFE05).w,d0
		andi.b	#$F,d0
		bne.s	loc_140AC
		ori.w	#$7878,($FFFFF66A).w

loc_140AC:
		tst.b	4(a0)
		bmi.s	locret_140C4
		moveq	#0,d0
		move.l	d0,(a0)
		move.w	d0,$10(a0)
		move.w	d0,$14(a0)
		move.w	#$A,($FFFFF708).w

locret_140C4:
		rts
; ---------------------------------------------------------------------------

loc_140C6:
		move.w	#0,($FFFFF66A).w
		rts
; ---------------------------------------------------------------------------

loc_140CE:
		move.b	#1,$2F(a0)
		move.b	#-$10,$25(a0)
		move.b	#2,$2A(a0)
		move.w	#0,$18(a0)
		move.w	#0,$1A(a0)
		move.w	#0,$1C(a0)
		lea	($FFFFB000).w,a1
		bsr.w	sub_1459E
		move.b	#1,($FFFFF73E).w
		move.w	#$16,($FFFFF708).w

loc_14106:
		move.w	#0,($FFFFF702).w
		move.b	#-$10,$25(a0)
		move.w	#0,($FFFFF66A).w
		move.b	($FFFFFE05).w,d0
		andi.b	#7,d0
		bne.s	loc_14128
		ori.w	#$7070,($FFFFF66A).w

loc_14128:
		move.w	($FFFFEE7C).w,d0
		addi.w	#$90,d0
		cmp.w	$14(a0),d0
		bcs.s	loc_1413C
		move.w	#$18,($FFFFF708).w

loc_1413C:
		lea	($FFFFF73E).w,a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF604).w,d0
		bra.w	Tails_Carry_Sonic
; ---------------------------------------------------------------------------

loc_1414C:
		move.b	#-$10,$25(a0)
		tst.w	($FFFFF702).w
		beq.s	loc_14164
		tst.b	($FFFFF73E).w
		bne.w	loc_141E2
		bra.w	loc_142E2
; ---------------------------------------------------------------------------

loc_14164:
		move.w	#0,($FFFFF66A).w
		tst.b	($FFFFF73E).w
		beq.w	loc_142E2
		clr.b	($FFFFFAAC).w
		btst	#1,($FFFFF604).w
		beq.s	loc_14198
		addq.b	#1,($FFFFF70E).w
		cmpi.b	#-$40,($FFFFF70E).w
		bcs.s	loc_141D2
		move.b	#0,($FFFFF70E).w
		ori.w	#$7070,($FFFFF66A).w
		bra.s	loc_141D2
; ---------------------------------------------------------------------------

loc_14198:
		btst	#0,($FFFFF604).w
		beq.s	loc_141BA
		addq.b	#1,($FFFFF70E).w
		cmpi.b	#$20,($FFFFF70E).w
		bcs.s	loc_141D2
		move.b	#0,($FFFFF70E).w
		ori.w	#$7070,($FFFFF66A).w
		bra.s	loc_141D2
; ---------------------------------------------------------------------------

loc_141BA:
		addq.b	#1,($FFFFF70E).w
		cmpi.b	#$58,($FFFFF70E).w
		bcs.s	loc_141D2
		move.b	#0,($FFFFF70E).w
		ori.w	#$7070,($FFFFF66A).w

loc_141D2:

		move.b	($FFFFF604).w,d0
		andi.b	#$C,d0
		or.b	($FFFFF66A).w,d0
		move.b	d0,($FFFFF66A).w

loc_141E2:
		lea	($FFFFF73E).w,a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF604).w,d0
		bra.w	Tails_Carry_Sonic
; ---------------------------------------------------------------------------

loc_141F2:
		move.b	#1,$2F(a0)
		move.b	#-$10,$25(a0)
		move.b	#2,$2A(a0)
		move.w	#0,$18(a0)
		move.w	#0,$1A(a0)
		move.w	#0,$1C(a0)
		move.w	#$1C,($FFFFF708).w

loc_1421C:
		move.w	#0,($FFFFF702).w
		move.b	#-$10,$25(a0)
		move.w	#0,($FFFFF66A).w
		move.b	($FFFFFE05).w,d0
		andi.b	#7,d0
		bne.s	loc_1423E
		ori.w	#$7070,($FFFFF66A).w

loc_1423E:
		move.w	($FFFFEE7C).w,d0
		addi.w	#$90,d0
		cmp.w	$14(a0),d0
		bcs.s	locret_14252
		move.w	#$1E,($FFFFF708).w

locret_14252:
		rts
; ---------------------------------------------------------------------------

loc_14254:
		move.b	#-$10,$25(a0)
		rts
; ---------------------------------------------------------------------------

loc_1425C:
		move.b	#1,$2F(a0)
		move.b	#-$10,$25(a0)
		move.b	#2,$2A(a0)
		move.w	#$100,$18(a0)
		move.w	#0,$1A(a0)
		move.w	#0,$1C(a0)
		move.w	#$22,($FFFFF708).w

loc_14286:
		move.w	#0,($FFFFF702).w
		move.w	#0,($FFFFF66A).w
		move.b	($FFFFFE05).w,d0
		andi.b	#$1F,d0
		bne.s	loc_142A2
		ori.w	#$808,($FFFFF66A).w

loc_142A2:
		btst	#1,$2A(a0)
		bne.s	locret_142E0
		move.w	#6,($FFFFF708).w
		move.b	#0,$2E(a0)
		move.b	#0,$20(a0)
		move.w	#0,$18(a0)
		move.w	#0,$1A(a0)
		move.w	#0,$1C(a0)
		move.b	#2,$2A(a0)
		move.w	#0,$32(a0)
		andi.w	#$7FFF,$A(a0)

locret_142E0:
		rts
; ---------------------------------------------------------------------------

loc_142E2:

		tst.b	($FFFFFAAC).w
		bne.s	loc_14362
		lea	($FFFFB000).w,a1
		tst.b	4(a1)
		bpl.s	loc_14330
		tst.w	($FFFFF702).w
		bne.w	loc_143AA
		cmpi.w	#$300,$1A(a1)
		bge.s	loc_14330
		move.w	#0,$18(a0)
		move.w	#0,($FFFFF66A).w
		cmpi.w	#$200,$1A(a0)
		bge.s	loc_14328
		addq.b	#1,($FFFFF70E).w
		cmpi.b	#$58,($FFFFF70E).w
		bcs.s	loc_1432E
		move.b	#0,($FFFFF70E).w

loc_14328:
		ori.w	#$7070,($FFFFF66A).w

loc_1432E:
		bra.s	loc_143AA
; ---------------------------------------------------------------------------

loc_14330:

		st	($FFFFFAAC).w
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		bpl.s	loc_14340
		neg.w	d1

loc_14340:
		lsr.w	#2,d1
		move.w	d1,d2
		lsr.w	#1,d2
		add.w	d2,d1
		move.w	d1,($FFFFFA94).w
		move.w	$10(a1),d1
		sub.w	$10(a0),d1
		bpl.s	loc_14358
		neg.w	d1

loc_14358:
		lsr.w	#2,d1
		move.w	d1,($FFFFFA92).w
		bra.w	loc_143AA
; ---------------------------------------------------------------------------

loc_14362:
		move.w	#0,($FFFFF66A).w
		lea	($FFFFB000).w,a1
		move.w	$10(a0),d0
		move.w	$14(a0),d1
		subi.w	#$10,d1
		move.w	($FFFFFA92).w,d2
		bclr	#0,$2A(a0)
		cmp.w	$10(a1),d0
		bcs.s	loc_14390
		bset	#0,$2A(a0)
		neg.w	d2

loc_14390:
		add.w	d2,$18(a0)
		cmp.w	$14(a1),d1
		bcc.s	loc_143AA
		move.w	($FFFFFA94).w,d2
		cmp.w	$14(a1),d1
		bcs.s	loc_143A6
		neg.w	d2

loc_143A6:
		add.w	d2,$1A(a0)

loc_143AA:

		lea	($FFFFF73E).w,a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF604).w,d0
		bra.w	*+4

; =============== S U B R O U T I N E =======================================


Tails_Carry_Sonic:

		tst.b	(a2)
		beq.w	loc_14534
		cmpi.b	#4,5(a1)
		bcc.w	loc_14466
		btst	#1,$2A(a1)
		beq.w	loc_1445A
		move.w	($FFFFF744).w,d1
		cmp.w	$18(a1),d1
		bne.s	loc_1445A
		move.w	($FFFFF74C).w,d1
		cmp.w	$1A(a1),d1
		bne.s	loc_14460
		tst.b	$2E(a1)
		bmi.s	loc_1446A
		andi.b	#$70,d0
		beq.w	loc_14474
		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$12,1(a2)
		andi.w	#$F00,d0
		beq.w	loc_14410
		move.b	#$3C,1(a2)

loc_14410:
		btst	#$A,d0
		beq.s	loc_1441C
		move.w	#-$200,$18(a1)

loc_1441C:
		btst	#$B,d0
		beq.s	loc_14428
		move.w	#$200,$18(a1)

loc_14428:
		move.w	#-$380,$1A(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		bclr	#4,$2A(a1)
		rts
; ---------------------------------------------------------------------------

loc_1445A:
		move.w	#-$100,$1A(a1)

loc_14460:
		move.b	#0,$40(a1)

loc_14466:
		clr.b	$2E(a1)

loc_1446A:
		clr.b	(a2)
		move.b	#$3C,1(a2)
		rts
; ---------------------------------------------------------------------------

loc_14474:
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$1C,$14(a1)
		tst.b	($FFFFF7C6).w
		beq.s	loc_14492
		subi.w	#$38,$14(a1)

loc_14492:
		andi.b	#-4,4(a1)
		andi.b	#-2,$2A(a1)
		move.b	$2A(a0),d0
		andi.b	#1,d0
		or.b	d0,4(a1)
		or.b	d0,$2A(a1)
		tst.b	($FFFFF7C6).w
		beq.s	loc_144BA
		eori.b	#2,4(a1)

loc_144BA:
		subq.b	#1,$24(a1)
		bpl.s	loc_144F8
		move.b	#$B,$24(a1)
		moveq	#0,d1
		move.b	$23(a1),d1
		addq.b	#1,$23(a1)
		move.b	byte_14522(pc,d1.w),d0
		cmpi.b	#-1,d0
		bne.s	loc_144E4
		move.b	#0,$23(a1)
		move.b	byte_14522(pc),d0

loc_144E4:
		move.b	d0,$22(a1)
		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2

loc_144F8:
		move.w	$18(a0),($FFFFB018).w
		move.w	$18(a0),($FFFFF744).w
		move.w	$1A(a0),($FFFFB01A).w
		move.w	$1A(a0),($FFFFF74C).w
		movem.l	d0-a6,-(sp)
		lea	($FFFFB000).w,a0
		bsr.w	sub_11EEC
		movem.l	(sp)+,d0-a6
		rts
; ---------------------------------------------------------------------------
byte_14522:	dc.b $91
		dc.b $91
		dc.b $90
		dc.b $90
		dc.b $90
		dc.b $90
		dc.b $90
		dc.b $90
		dc.b $92
		dc.b $92
		dc.b $92
		dc.b $92
		dc.b $92
		dc.b $92
		dc.b $91
		dc.b $91
		dc.b $FF
		dc.b 0
; ---------------------------------------------------------------------------

loc_14534:
		tst.b	1(a2)
		beq.s	loc_14542
		subq.b	#1,1(a2)
		bne.w	locret_1459C

loc_14542:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.w	locret_1459C
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		subi.w	#$20,d1
		tst.b	($FFFFF7C6).w
		beq.s	loc_1456C
		addi.w	#$50,d1

loc_1456C:
		cmpi.w	#$10,d1
		bcc.w	locret_1459C
		tst.b	$2E(a1)
		bne.s	locret_1459C
		cmpi.b	#4,5(a1)
		bcc.s	locret_1459C
		tst.w	($FFFFFE08).w
		bne.s	locret_1459C
		tst.b	$3D(a1)
		bne.s	locret_1459C
		bsr.s	sub_1459E
		moveq	#$4A,d0
		jsr	(Play_Sound_2).l
		move.b	#1,(a2)

locret_1459C:
					; Tails_Carry_Sonic+198j ...
		rts
; End of function Tails_Carry_Sonic


; =============== S U B R O U T I N E =======================================


sub_1459E:

		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		clr.w	$26(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$1C,$14(a1)
		move.w	#$2200,$20(a1)
		move.b	#0,$24(a1)
		move.b	#0,$23(a1)
		move.b	#3,$2E(a1)
		bset	#1,$2A(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$3D(a1)
		andi.b	#-4,4(a1)
		andi.b	#-2,$2A(a1)
		move.b	$2A(a0),d0
		andi.b	#1,d0
		or.b	d0,4(a1)
		or.b	d0,$2A(a1)
		move.w	$18(a0),($FFFFF744).w
		move.w	$18(a0),$18(a1)
		move.w	$1A(a0),($FFFFF74C).w
		move.w	$1A(a0),$1A(a1)
		tst.b	($FFFFF7C6).w
		beq.s	locret_14630
		subi.w	#$38,$14(a1)
		eori.b	#2,4(a1)

locret_14630:
		rts
; End of function sub_1459E


; =============== S U B R O U T I N E =======================================


sub_14632:
		tst.b	($FFFFF730).w
		bne.s	loc_1463A

locret_14638:

		rts
; ---------------------------------------------------------------------------

loc_1463A:
		move.w	($FFFFF646).w,d0
		cmp.w	$14(a0),d0
		bge.s	loc_146BA
		bset	#6,$2A(a0)
		bne.s	locret_14638
		addq.b	#1,($FFFFF64D).w
		movea.l	a0,a1
		bsr.w	Player_ResetAirTimer
		move.l	#Obj_Air_CountDown,($FFFFCB76).w
		move.b	#-$7F,($FFFFCBA2).w
		move.l	a0,($FFFFCBB6).w
		move.w	#$300,(a4)
		move.w	#6,2(a4)
		move.w	#$40,4(a4)
		tst.b	($FFFFF667).w
		beq.s	loc_1468E
		move.w	#$400,(a4)
		move.w	#$C,2(a4)
		move.w	#$60,4(a4)

loc_1468E:
		cmpi.w	#4,($FFFFF708).w
		beq.s	loc_1469C
		tst.b	$2E(a0)
		bne.s	locret_14638

loc_1469C:
		asr	$18(a0)
		asr	$1A(a0)
		asr	$1A(a0)
		beq.s	locret_14638
		move.w	#$100,$20(a6)
		move.w	#$39,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

loc_146BA:
		bclr	#6,$2A(a0)
		beq.w	locret_14638
		addq.b	#1,($FFFFF64D).w
		movea.l	a0,a1
		bsr.w	Player_ResetAirTimer
		move.w	#$600,(a4)
		move.w	#$C,2(a4)
		move.w	#$80,4(a4)
		tst.b	($FFFFF667).w
		beq.s	loc_146F4
		move.w	#$800,(a4)
		move.w	#$18,2(a4)
		move.w	#$C0,4(a4)

loc_146F4:
		cmpi.b	#4,5(a0)
		beq.s	loc_14718
		cmpi.w	#4,($FFFFF708).w
		beq.s	loc_1470A
		tst.b	$2E(a0)
		bne.s	loc_14718

loc_1470A:
		move.w	$1A(a0),d0
		cmpi.w	#-$400,d0
		blt.s	loc_14718
		asl	$1A(a0)

loc_14718:

		cmpi.b	#$1C,$20(a0)
		beq.w	locret_14638
		tst.w	$1A(a0)
		beq.w	locret_14638
		move.w	#$100,$20(a6)
		cmpi.w	#-$1000,$1A(a0)
		bgt.s	loc_1473E
		move.w	#-$1000,$1A(a0)

loc_1473E:
		move.w	#$39,d0
		jmp	(Play_Sound_2).l
; End of function sub_14632

; ---------------------------------------------------------------------------

Tails_Stand_Path:
		tst.b	($FFFFF73E).w
		beq.s	loc_14760
		lea	($FFFFB000).w,a1
		clr.b	$2E(a1)
		bset	#1,$2A(a1)
		clr.w	($FFFFF73E).w

loc_14760:
		bsr.w	Tails_Spindash
		bsr.w	Tails_Jump
		bsr.w	sub_11DA6
		bsr.w	Tails_InputAcceleration_Path
		bsr.w	Tails_Spin
		bsr.w	Tails_Check_Screen_Boundaries
		jsr	(MoveSprite_TestGravity2).l
		bsr.w	Call_Player_AnglePos
		bsr.w	sub_11E2A
		tst.b	($FFFFF664).w
		beq.s	locret_147B6
		bsr.w	sub_F846
		tst.w	d1
		bmi.w	Kill_Character
		movem.l	a4-a6,-(sp)
		bsr.w	sub_FD9A
		tst.w	d1
		bpl.s	loc_147A6
		sub.w	d1,$10(a0)

loc_147A6:
		bsr.w	sub_FA7A
		tst.w	d1
		bpl.s	loc_147B2
		add.w	d1,$10(a0)

loc_147B2:
		movem.l	(sp)+,a4-a6

locret_147B6:
		rts
; ---------------------------------------------------------------------------

Tails_Stand_Freespace:
		tst.b	$2F(a0)
		bne.s	Tails_FlyingSwimming
		bsr.w	Tails_JumpHeight
		bsr.w	Tails_InputAcceleration_Freespace
		bsr.w	Tails_Check_Screen_Boundaries
		jsr	(MoveSprite_TestGravity).l
		btst	#6,$2A(a0)
		beq.s	loc_147DE
		subi.w	#$28,$1A(a0)

loc_147DE:
		bsr.w	sub_11E8C
		bsr.w	sub_153C2
		rts
; ---------------------------------------------------------------------------

Tails_FlyingSwimming:
		bsr.w	Tails_Move_FlySwim
		bsr.w	Tails_InputAcceleration_Freespace
		bsr.w	Tails_Check_Screen_Boundaries
		jsr	(MoveSprite_TestGravity2).l
		bsr.w	sub_11E8C
		movem.l	a4-a6,-(sp)
		bsr.w	sub_153C2
		movem.l	(sp)+,a4-a6
		tst.w	($FFFFFF08).w
		bne.s	locret_14820
		lea	($FFFFF73E).w,a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF604).w,d0
		bsr.w	Tails_Carry_Sonic

locret_14820:
		rts

; =============== S U B R O U T I N E =======================================


Tails_Move_FlySwim:
		move.b	($FFFFFE05).w,d0
		andi.b	#1,d0
		beq.s	loc_14836
		tst.b	$25(a0)
		beq.s	loc_14836
		subq.b	#1,$25(a0)

loc_14836:
					; Tails_Move_FlySwim+Ej
		cmpi.b	#1,$2F(a0)
		beq.s	loc_14860
		cmpi.w	#-$100,$1A(a0)
		blt.s	loc_14858
		subi.w	#$20,$1A(a0)
		addq.b	#1,$2F(a0)
		cmpi.b	#$20,$2F(a0)
		bne.s	loc_1485E

loc_14858:
		move.b	#1,$2F(a0)

loc_1485E:
		bra.s	loc_14892
; ---------------------------------------------------------------------------

loc_14860:
		move.b	($FFFFF66B).w,d0
		andi.b	#$70,d0
		beq.s	loc_1488C
		cmpi.w	#-$100,$1A(a0)
		blt.s	loc_1488C
		tst.b	$25(a0)
		beq.s	loc_1488C
		btst	#6,$2A(a0)
		beq.s	loc_14886
		tst.b	($FFFFF73E).w
		bne.s	loc_1488C

loc_14886:
		move.b	#2,$2F(a0)

loc_1488C:
					; Tails_Move_FlySwim+4Ej ...
		addi.w	#8,$1A(a0)

loc_14892:
		move.w	($FFFFEE18).w,d0
		addi.w	#$10,d0
		cmp.w	$14(a0),d0
		blt.s	Tails_Set_Flying_Animation
		tst.w	$1A(a0)
		bpl.s	Tails_Set_Flying_Animation
		move.w	#0,$1A(a0)
; End of function Tails_Move_FlySwim


; =============== S U B R O U T I N E =======================================


Tails_Set_Flying_Animation:

		btst	#6,$2A(a0)
		bne.s	loc_14914
		moveq	#$20,d0
		tst.w	($FFFFFFE8).w
		bne.s	loc_148F4
		tst.w	$1A(a0)
		bpl.s	loc_148C4
		moveq	#$21,d0

loc_148C4:
		tst.b	($FFFFF73E).w
		beq.s	loc_148CC
		addq.b	#2,d0

loc_148CC:
		tst.b	$25(a0)
		bne.s	loc_148F4
		moveq	#$24,d0
		move.b	d0,$20(a0)
		tst.b	4(a0)
		bpl.s	locret_148F2
		move.b	($FFFFFE05).w,d0
		addq.b	#8,d0
		andi.b	#$F,d0
		bne.s	locret_148F2
		moveq	#-$45,d0
		jsr	(Play_Sound_2).l

locret_148F2:
					; Tails_Set_Flying_Animation+3Cj
		rts
; ---------------------------------------------------------------------------

loc_148F4:
					; Tails_Set_Flying_Animation+24j
		move.b	d0,$20(a0)
		tst.b	4(a0)
		bpl.s	locret_14912
		move.b	($FFFFFE05).w,d0
		addq.b	#8,d0
		andi.b	#$F,d0
		bne.s	locret_14912
		moveq	#-$46,d0
		jsr	(Play_Sound_2).l

locret_14912:
					; Tails_Set_Flying_Animation+5Cj
		rts
; ---------------------------------------------------------------------------

loc_14914:
		moveq	#$25,d0
		tst.w	$1A(a0)
		bpl.s	loc_1491E
		moveq	#$26,d0

loc_1491E:
		tst.b	($FFFFF73E).w
		beq.s	loc_14926
		moveq	#$27,d0

loc_14926:
		tst.b	$25(a0)
		bne.s	loc_1492E
		moveq	#$28,d0

loc_1492E:
		move.b	d0,$20(a0)
		rts
; End of function Tails_Set_Flying_Animation

; ---------------------------------------------------------------------------

Tails_Spin_Path:
		tst.b	($FFFFF73E).w
		beq.s	loc_1494C
		lea	($FFFFB000).w,a1
		clr.b	$2E(a1)
		bset	#1,$2A(a1)
		clr.w	($FFFFF73E).w

loc_1494C:
		tst.b	$3D(a0)
		bne.s	loc_14956
		bsr.w	Tails_Jump

loc_14956:
		bsr.w	sub_11DEE
		bsr.w	sub_14D32
		bsr.w	Tails_Check_Screen_Boundaries
		jsr	(MoveSprite_TestGravity2).l
		bsr.w	Call_Player_AnglePos
		bsr.w	sub_11E2A
		tst.b	($FFFFF664).w
		beq.s	locret_149A0
		bsr.w	sub_F846
		tst.w	d1
		bmi.w	Kill_Character
		movem.l	a4-a6,-(sp)
		bsr.w	sub_FD9A
		tst.w	d1
		bpl.s	loc_14990
		sub.w	d1,$10(a0)

loc_14990:
		bsr.w	sub_FA7A
		tst.w	d1
		bpl.s	loc_1499C
		add.w	d1,$10(a0)

loc_1499C:
		movem.l	(sp)+,a4-a6

locret_149A0:
		rts
; ---------------------------------------------------------------------------

Tails_Spin_Freespace:
		tst.b	($FFFFF73E).w
		beq.s	loc_149BA
		lea	($FFFFB000).w,a1
		clr.b	$2E(a1)
		bset	#1,$2A(a1)
		clr.w	($FFFFF73E).w

loc_149BA:
		bsr.w	Tails_JumpHeight
		bsr.w	Tails_InputAcceleration_Freespace
		bsr.w	Tails_Check_Screen_Boundaries
		jsr	(MoveSprite_TestGravity).l
		btst	#6,$2A(a0)
		beq.s	loc_149DA
		subi.w	#$28,$1A(a0)

loc_149DA:
		bsr.w	sub_11E8C
		bsr.w	sub_153C2
		rts

; =============== S U B R O U T I N E =======================================


Tails_InputAcceleration_Path:

		move.w	(a4),d6
		move.w	2(a4),d5
		move.w	4(a4),d4
		tst.b	$2B(a0)
		bmi.w	loc_14B5C
		tst.w	$32(a0)
		bne.w	loc_14B14
		btst	#2,($FFFFF66A).w
		beq.s	loc_14A0A
		bsr.w	sub_14C20

loc_14A0A:
		btst	#3,($FFFFF66A).w
		beq.s	loc_14A16
		bsr.w	sub_14CAC

loc_14A16:
		move.b	$26(a0),d0
		addi.b	#$20,d0
		andi.b	#$C0,d0
		bne.w	loc_14B14
		tst.w	$1C(a0)
		bne.w	loc_14B14
		bclr	#5,$2A(a0)
		move.b	#5,$20(a0)
		btst	#3,$2A(a0)
		beq.s	loc_14A6C
		movea.w	$42(a0),a1
		tst.b	$2A(a1)
		bmi.s	loc_14AA0
		moveq	#0,d1
		move.b	7(a1),d1
		move.w	d1,d2
		add.w	d2,d2
		subq.w	#4,d2
		add.w	$10(a0),d1
		sub.w	$10(a1),d1
		cmpi.w	#4,d1
		blt.s	loc_14A92
		cmp.w	d2,d1
		bge.s	loc_14A82
		bra.s	loc_14AA0
; ---------------------------------------------------------------------------

loc_14A6C:
		move.w	$10(a0),d3
		bsr.w	sub_12006
		cmpi.w	#$C,d1
		blt.s	loc_14AA0
		cmpi.b	#3,$3A(a0)
		bne.s	loc_14A8A

loc_14A82:
		bclr	#0,$2A(a0)
		bra.s	loc_14A98
; ---------------------------------------------------------------------------

loc_14A8A:
		cmpi.b	#3,$3B(a0)
		bne.s	loc_14AA0

loc_14A92:
		bset	#0,$2A(a0)

loc_14A98:
		move.b	#6,$20(a0)
		bra.s	loc_14B14
; ---------------------------------------------------------------------------

loc_14AA0:
					; Tails_InputAcceleration_Path+86j ...
		btst	#1,($FFFFF66A).w
		beq.s	loc_14ADA
		move.b	#8,$20(a0)
		addq.b	#1,$39(a0)
		cmpi.b	#$78,$39(a0)
		bcs.s	loc_14B1A
		move.b	#$78,$39(a0)
		tst.b	($FFFFF7C6).w
		bne.s	loc_14AD0
		cmpi.w	#8,(a5)
		beq.s	loc_14B26
		subq.w	#2,(a5)
		bra.s	loc_14B26
; ---------------------------------------------------------------------------

loc_14AD0:
		cmpi.w	#$D8,(a5)
		beq.s	loc_14B26
		addq.w	#2,(a5)
		bra.s	loc_14B26
; ---------------------------------------------------------------------------

loc_14ADA:
		btst	#0,($FFFFF66A).w
		beq.s	loc_14B14
		move.b	#7,$20(a0)
		addq.b	#1,$39(a0)
		cmpi.b	#$78,$39(a0)
		bcs.s	loc_14B1A
		move.b	#$78,$39(a0)
		tst.b	($FFFFF7C6).w
		bne.s	loc_14B0A
		cmpi.w	#$C8,(a5)
		beq.s	loc_14B26
		addq.w	#2,(a5)
		bra.s	loc_14B26
; ---------------------------------------------------------------------------

loc_14B0A:
		cmpi.w	#$18,(a5)
		beq.s	loc_14B26
		subq.w	#2,(a5)
		bra.s	loc_14B26
; ---------------------------------------------------------------------------

loc_14B14:
					; Tails_InputAcceleration_Path+3Ej ...
		move.b	#0,$39(a0)

loc_14B1A:
					; Tails_InputAcceleration_Path+10Ej
		cmpi.w	#$60,(a5)
		beq.s	loc_14B26
		bcc.s	loc_14B24
		addq.w	#4,(a5)

loc_14B24:
		subq.w	#2,(a5)

loc_14B26:
					; Tails_InputAcceleration_Path+EAj ...
		tst.b	($FFFFF667).w
		beq.s	loc_14B30
		move.w	#$C,d5

loc_14B30:
		move.b	($FFFFF66A).w,d0
		andi.b	#$C,d0
		bne.s	loc_14B5C
		move.w	$1C(a0),d0
		beq.s	loc_14B5C
		bmi.s	loc_14B50
		sub.w	d5,d0
		bcc.s	loc_14B4A
		move.w	#0,d0

loc_14B4A:
		move.w	d0,$1C(a0)
		bra.s	loc_14B5C
; ---------------------------------------------------------------------------

loc_14B50:
		add.w	d5,d0
		bcc.s	loc_14B58
		move.w	#0,d0

loc_14B58:
		move.w	d0,$1C(a0)

loc_14B5C:
					; Tails_InputAcceleration_Path+154j ...
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		muls.w	$1C(a0),d1
		asr.l	#8,d1
		move.w	d1,$18(a0)
		muls.w	$1C(a0),d0
		asr.l	#8,d0
		move.w	d0,$1A(a0)

loc_14B7A:
		btst	#6,$2E(a0)
		bne.w	locret_14C1E
		move.b	$26(a0),d0
		andi.b	#$3F,d0
		beq.s	loc_14B9A
		move.b	$26(a0),d0
		addi.b	#$40,d0
		bmi.w	locret_14C1E

loc_14B9A:
		move.b	#$40,d1
		tst.w	$1C(a0)
		beq.s	locret_14C1E
		bmi.s	loc_14BA8
		neg.w	d1

loc_14BA8:
		move.b	$26(a0),d0
		add.b	d1,d0
		move.w	d0,-(sp)
		bsr.w	sub_F61C
		move.w	(sp)+,d0
		tst.w	d1
		bpl.s	locret_14C1E
		asl.w	#8,d1
		cmpi.b	#8,($FFFFFE10).w
		bne.s	loc_14BCA
		tst.b	d0
		bpl.s	loc_14BCA
		subq.b	#1,d0

loc_14BCA:
					; Tails_InputAcceleration_Path+1E2j
		addi.b	#$20,d0
		andi.b	#$C0,d0
		beq.s	loc_14C1A
		cmpi.b	#$40,d0
		beq.s	loc_14C00
		cmpi.b	#$80,d0
		beq.s	loc_14BFA
		add.w	d1,$18(a0)
		move.w	#0,$1C(a0)
		btst	#0,$2A(a0)
		bne.s	locret_14BF8
		bset	#5,$2A(a0)

locret_14BF8:
					; Tails_InputAcceleration_Path+22Cj
		rts
; ---------------------------------------------------------------------------

loc_14BFA:
		sub.w	d1,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_14C00:
		sub.w	d1,$18(a0)
		move.w	#0,$1C(a0)
		btst	#0,$2A(a0)
		beq.s	locret_14BF8
		bset	#5,$2A(a0)
		rts
; ---------------------------------------------------------------------------

loc_14C1A:
		add.w	d1,$1A(a0)

locret_14C1E:
					; Tails_InputAcceleration_Path+1B2j ...
		rts
; End of function Tails_InputAcceleration_Path


; =============== S U B R O U T I N E =======================================


sub_14C20:
		move.w	$1C(a0),d0
		beq.s	loc_14C28
		bpl.s	loc_14C5A

loc_14C28:
		bset	#0,$2A(a0)
		bne.s	loc_14C3C
		bclr	#5,$2A(a0)
		move.b	#1,$21(a0)

loc_14C3C:
		sub.w	d5,d0
		move.w	d6,d1
		neg.w	d1
		cmp.w	d1,d0
		bgt.s	loc_14C4E
		add.w	d5,d0
		cmp.w	d1,d0
		ble.s	loc_14C4E
		move.w	d1,d0

loc_14C4E:

		move.w	d0,$1C(a0)
		move.b	#0,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_14C5A:
		sub.w	d4,d0
		bcc.s	loc_14C62
		move.w	#-$80,d0

loc_14C62:
		move.w	d0,$1C(a0)
		move.b	$26(a0),d0
		addi.b	#$20,d0
		andi.b	#$C0,d0
		bne.s	locret_14CAA
		cmpi.w	#$400,d0
		blt.s	locret_14CAA
		tst.b	$2D(a0)
		bmi.s	locret_14CAA
		move.w	#$36,d0
		jsr	(Play_Sound_2).l
		move.b	#$D,$20(a0)
		bclr	#0,$2A(a0)
		cmpi.b	#$C,$2C(a0)
		bcs.s	locret_14CAA
		move.b	#6,5(a6)
		move.b	#$15,$22(a6)

locret_14CAA:

		rts
; End of function sub_14C20


; =============== S U B R O U T I N E =======================================


sub_14CAC:
		move.w	$1C(a0),d0
		bmi.s	loc_14CE0
		bclr	#0,$2A(a0)
		beq.s	loc_14CC6
		bclr	#5,$2A(a0)
		move.b	#1,$21(a0)

loc_14CC6:
		add.w	d5,d0
		cmp.w	d6,d0
		blt.s	loc_14CD4
		sub.w	d5,d0
		cmp.w	d6,d0
		bge.s	loc_14CD4
		move.w	d6,d0

loc_14CD4:

		move.w	d0,$1C(a0)
		move.b	#0,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_14CE0:
		add.w	d4,d0
		bcc.s	loc_14CE8
		move.w	#$80,d0

loc_14CE8:
		move.w	d0,$1C(a0)
		move.b	$26(a0),d0
		addi.b	#$20,d0
		andi.b	#$C0,d0
		bne.s	locret_14D30
		cmpi.w	#-$400,d0
		bgt.s	locret_14D30
		tst.b	$2D(a0)
		bmi.s	locret_14D30
		move.w	#$36,d0
		jsr	(Play_Sound_2).l
		move.b	#$D,$20(a0)
		bset	#0,$2A(a0)
		cmpi.b	#$C,$2C(a0)
		bcs.s	locret_14D30
		move.b	#6,5(a6)
		move.b	#$15,$22(a6)

locret_14D30:

		rts
; End of function sub_14CAC


; =============== S U B R O U T I N E =======================================


sub_14D32:

		move.w	(a4),d6
		asl.w	#1,d6
		move.w	2(a4),d5
		asr.w	#1,d5
		tst.b	($FFFFF667).w
		beq.s	loc_14D46
		move.w	#6,d5

loc_14D46:
		move.w	#$20,d4
		tst.b	$3D(a0)
		bmi.w	loc_14DF0
		tst.b	$2B(a0)
		bmi.w	loc_14DF0
		tst.w	$32(a0)
		bne.s	loc_14D78
		btst	#2,($FFFFF66A).w
		beq.s	loc_14D6C
		bsr.w	sub_14E32

loc_14D6C:
		btst	#3,($FFFFF66A).w
		beq.s	loc_14D78
		bsr.w	sub_14E56

loc_14D78:

		move.w	$1C(a0),d0
		beq.s	loc_14D9A
		bmi.s	loc_14D8E
		sub.w	d5,d0
		bcc.s	loc_14D88
		move.w	#0,d0

loc_14D88:
		move.w	d0,$1C(a0)
		bra.s	loc_14D9A
; ---------------------------------------------------------------------------

loc_14D8E:
		add.w	d5,d0
		bcc.s	loc_14D96
		move.w	#0,d0

loc_14D96:
		move.w	d0,$1C(a0)

loc_14D9A:

		move.w	$1C(a0),d0
		bpl.s	loc_14DA2
		neg.w	d0

loc_14DA2:
		cmpi.w	#$80,d0
		bcc.s	loc_14DF0
		tst.b	$3D(a0)
		bne.s	loc_14DDE
		bclr	#2,$2A(a0)
		move.b	$1E(a0),d0
		move.b	$44(a0),$1E(a0)
		move.b	$45(a0),$1F(a0)
		move.b	#5,$20(a0)
		sub.b	$44(a0),d0
		ext.w	d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_14DD8
		neg.w	d0

loc_14DD8:
		add.w	d0,$14(a0)
		bra.s	loc_14DF0
; ---------------------------------------------------------------------------

loc_14DDE:
		move.w	#$400,$1C(a0)
		btst	#0,$2A(a0)
		beq.s	loc_14DF0
		neg.w	$1C(a0)

loc_14DF0:

		cmpi.w	#$60,(a5)
		beq.s	loc_14DFC
		bcc.s	loc_14DFA
		addq.w	#4,(a5)

loc_14DFA:
		subq.w	#2,(a5)

loc_14DFC:
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		muls.w	$1C(a0),d0
		asr.l	#8,d0
		move.w	d0,$1A(a0)
		muls.w	$1C(a0),d1
		asr.l	#8,d1
		cmpi.w	#$1000,d1
		ble.s	loc_14E20
		move.w	#$1000,d1

loc_14E20:
		cmpi.w	#-$1000,d1
		bge.s	loc_14E2A
		move.w	#-$1000,d1

loc_14E2A:
		move.w	d1,$18(a0)
		bra.w	loc_14B7A
; End of function sub_14D32


; =============== S U B R O U T I N E =======================================


sub_14E32:
		move.w	$1C(a0),d0
		beq.s	loc_14E3A
		bpl.s	loc_14E48

loc_14E3A:
		bset	#0,$2A(a0)
		move.b	#2,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_14E48:
		sub.w	d4,d0
		bcc.s	loc_14E50
		move.w	#-$80,d0

loc_14E50:
		move.w	d0,$1C(a0)
		rts
; End of function sub_14E32


; =============== S U B R O U T I N E =======================================


sub_14E56:
		move.w	$1C(a0),d0
		bmi.s	loc_14E6A
		bclr	#0,$2A(a0)
		move.b	#2,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_14E6A:
		add.w	d4,d0
		bcc.s	loc_14E72
		move.w	#$80,d0

loc_14E72:
		move.w	d0,$1C(a0)
		rts
; End of function sub_14E56


; =============== S U B R O U T I N E =======================================


Tails_InputAcceleration_Freespace:

		move.w	(a4),d6
		move.w	2(a4),d5
		asl.w	#1,d5
		btst	#4,$2A(a0)
		bne.s	loc_14ECC
		move.w	$18(a0),d0
		btst	#2,($FFFFF66A).w
		beq.s	loc_14EAC
		bset	#0,$2A(a0)
		sub.w	d5,d0
		move.w	d6,d1
		neg.w	d1
		cmp.w	d1,d0
		bgt.s	loc_14EAC
		add.w	d5,d0
		cmp.w	d1,d0
		ble.s	loc_14EAC
		move.w	d1,d0

loc_14EAC:
					; Tails_InputAcceleration_Freespace+2Aj ...
		btst	#3,($FFFFF66A).w
		beq.s	loc_14EC8
		bclr	#0,$2A(a0)
		add.w	d5,d0
		cmp.w	d6,d0
		blt.s	loc_14EC8
		sub.w	d5,d0
		cmp.w	d6,d0
		bge.s	loc_14EC8
		move.w	d6,d0

loc_14EC8:
					; Tails_InputAcceleration_Freespace+46j ...
		move.w	d0,$18(a0)

loc_14ECC:
		cmpi.w	#$60,(a5)
		beq.s	loc_14ED8
		bcc.s	loc_14ED6
		addq.w	#4,(a5)

loc_14ED6:
		subq.w	#2,(a5)

loc_14ED8:
		cmpi.w	#-$400,$1A(a0)
		bcs.s	locret_14F06
		move.w	$18(a0),d0
		move.w	d0,d1
		asr.w	#5,d1
		beq.s	locret_14F06
		bmi.s	loc_14EFA
		sub.w	d1,d0
		bcc.s	loc_14EF4
		move.w	#0,d0

loc_14EF4:
		move.w	d0,$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_14EFA:
		sub.w	d1,d0
		bcs.s	loc_14F02
		move.w	#0,d0

loc_14F02:
		move.w	d0,$18(a0)

locret_14F06:
					; Tails_InputAcceleration_Freespace+70j
		rts
; End of function Tails_InputAcceleration_Freespace


; =============== S U B R O U T I N E =======================================


Tails_Check_Screen_Boundaries:

		move.l	$10(a0),d1
		move.w	$18(a0),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d1
		swap	d1
		move.w	($FFFFEE14).w,d0
		addi.w	#$10,d0
		cmp.w	d1,d0
		bhi.s	loc_14F5C
		move.w	($FFFFEE16).w,d0
		addi.w	#$128,d0
		cmp.w	d1,d0
		bcs.s	loc_14F5C

loc_14F30:
		tst.b	($FFFFF665).w
		bne.s	locret_14F4A
		tst.b	($FFFFF7C6).w
		bne.s	loc_14F4C
		move.w	($FFFFEE1A).w,d0
		addi.w	#$E0,d0
		cmp.w	$14(a0),d0
		blt.s	loc_14F56

locret_14F4A:
					; Tails_Check_Screen_Boundaries+4Cj
		rts
; ---------------------------------------------------------------------------

loc_14F4C:
		move.w	($FFFFEE18).w,d0
		cmp.w	$14(a0),d0
		blt.s	locret_14F4A

loc_14F56:
		jmp	(Kill_Character).l
; ---------------------------------------------------------------------------

loc_14F5C:
					; Tails_Check_Screen_Boundaries+26j
		move.w	d0,$10(a0)
		move.w	#0,$12(a0)
		move.w	#0,$18(a0)
		move.w	#0,$1C(a0)
		bra.s	loc_14F30
; End of function Tails_Check_Screen_Boundaries


; =============== S U B R O U T I N E =======================================


Tails_Spin:
		tst.b	$2B(a0)
		bmi.s	locret_14FA8
		move.b	($FFFFF66A).w,d0
		andi.b	#$C,d0
		bne.s	locret_14FA8
		btst	#1,($FFFFF66A).w
		beq.s	loc_14FAA
		move.w	$1C(a0),d0
		bpl.s	loc_14F94
		neg.w	d0

loc_14F94:
		cmpi.w	#$100,d0
		bcc.s	loc_14FBA
		btst	#3,$2A(a0)
		bne.s	locret_14FA8
		move.b	#8,$20(a0)

locret_14FA8:
		rts
; ---------------------------------------------------------------------------

loc_14FAA:
		cmpi.b	#8,$20(a0)
		bne.s	locret_14FA8
		move.b	#0,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_14FBA:
		btst	#2,$2A(a0)
		beq.s	loc_14FC4
		rts
; ---------------------------------------------------------------------------

loc_14FC4:
		bset	#2,$2A(a0)
		move.b	#$E,$1E(a0)
		move.b	#7,$1F(a0)
		move.b	#2,$20(a0)
		addq.w	#1,$14(a0)
		tst.b	($FFFFF7C6).w
		beq.s	loc_14FEA
		subq.w	#2,$14(a0)

loc_14FEA:
		move.w	#$3C,d0
		jsr	(Play_Sound_2).l
		tst.w	$1C(a0)
		bne.s	locret_15000
		move.w	#$200,$1C(a0)

locret_15000:
		rts
; End of function Tails_Spin


; =============== S U B R O U T I N E =======================================


Tails_Jump:

		move.b	($FFFFF66B).w,d0
		andi.b	#$70,d0
		beq.w	locret_150D0
		moveq	#0,d0
		move.b	$26(a0),d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_15024
		addi.b	#$40,d0
		neg.b	d0
		subi.b	#$40,d0

loc_15024:
		addi.b	#$80,d0
		movem.l	a4-a6,-(sp)
		bsr.w	sub_F72E
		movem.l	(sp)+,a4-a6
		cmpi.w	#6,d1
		blt.w	locret_150D0
		move.w	#$680,d2
		btst	#6,$2A(a0)
		beq.s	loc_1504C
		move.w	#$380,d2

loc_1504C:
		moveq	#0,d0
		move.b	$26(a0),d0
		subi.b	#$40,d0
		jsr	(GetSineCosine).l
		muls.w	d2,d1
		asr.l	#8,d1
		add.w	d1,$18(a0)
		muls.w	d2,d0
		asr.l	#8,d0
		add.w	d0,$1A(a0)
		bset	#1,$2A(a0)
		bclr	#5,$2A(a0)
		addq.l	#4,sp
		move.b	#1,$40(a0)
		clr.b	$3C(a0)
		move.w	#$62,d0
		jsr	(Play_Sound_2).l
		move.b	$44(a0),$1E(a0)
		move.b	$45(a0),$1F(a0)
		btst	#2,$2A(a0)
		bne.s	loc_150D2
		move.b	#$E,$1E(a0)
		move.b	#7,$1F(a0)
		move.b	#2,$20(a0)
		bset	#2,$2A(a0)
		move.b	$1E(a0),d0
		sub.b	$44(a0),d0
		ext.w	d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_150CC
		neg.w	d0

loc_150CC:
		sub.w	d0,$14(a0)

locret_150D0:
		rts
; ---------------------------------------------------------------------------

loc_150D2:
		bset	#4,$2A(a0)
		rts
; End of function Tails_Jump


; =============== S U B R O U T I N E =======================================


Tails_JumpHeight:

		tst.b	$40(a0)
		beq.s	loc_15106
		move.w	#-$400,d1
		btst	#6,$2A(a0)
		beq.s	loc_150F0
		move.w	#-$200,d1

loc_150F0:
		cmp.w	$1A(a0),d1
		ble.s	Tails_Test_For_Flight
		move.b	($FFFFF66A).w,d0
		andi.b	#$70,d0
		bne.s	locret_15104
		move.w	d1,$1A(a0)

locret_15104:
		rts
; ---------------------------------------------------------------------------

loc_15106:
		tst.b	$3D(a0)
		bne.s	locret_1511A
		cmpi.w	#-$FC0,$1A(a0)
		bge.s	locret_1511A
		move.w	#-$FC0,$1A(a0)

locret_1511A:
					; Tails_JumpHeight+38j
		rts
; ---------------------------------------------------------------------------

Tails_Test_For_Flight:
		tst.b	$2F(a0)
		bne.w	locret_151A2
		move.b	($FFFFF66B).w,d0
		andi.b	#$70,d0
		beq.w	locret_151A2
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_15156
		tst.b	($FFFFF667).w
		bne.s	loc_1515C
		cmpi.b	#7,($FFFFFFB1).w
		bcs.s	loc_1515C
		cmpi.w	#$32,($FFFFFE20).w
		bcs.s	loc_1515C
		tst.b	($FFFFFE1E).w
		bne.s	loc_151A4
		bra.s	loc_1515C
; ---------------------------------------------------------------------------

loc_15156:
		tst.w	($FFFFF702).w
		beq.s	locret_151A2

loc_1515C:
		btst	#2,$2A(a0)
		beq.s	loc_1518C
		bclr	#2,$2A(a0)
		move.b	$1E(a0),d1
		move.b	$44(a0),$1E(a0)
		move.b	$45(a0),$1F(a0)
		sub.b	$44(a0),d1
		ext.w	d1
		tst.b	($FFFFF7C6).w
		beq.s	loc_15188
		neg.w	d0

loc_15188:
		add.w	d1,$14(a0)

loc_1518C:
		bclr	#4,$2A(a0)
		move.b	#1,$2F(a0)
		move.b	#-$10,$25(a0)
		bsr.w	Tails_Set_Flying_Animation

locret_151A2:
					; Tails_JumpHeight+52j	...
		rts
; ---------------------------------------------------------------------------

loc_151A4:
		move.b	#1,($FFFFF65F).w
		move.b	#$F,($FFFFF65E).w
		move.b	#1,($FFFFF667).w
		move.w	#$3C,($FFFFF670).w
		move.b	#-$7F,$2E(a0)
		move.b	#$29,$20(a0)
		move.l	#Obj_HyperTails_Birds,($FFFFCD7C).w
		move.w	#$800,(a4)
		move.w	#$18,2(a4)
		move.w	#$C0,4(a4)
		move.b	#0,$35(a0)
		bset	#1,$2B(a0)
		moveq	#-$61,d0
		jsr	(Play_Sound_2).l
		moveq	#$2C,d0
		jmp	(Play_Sound).l
; End of function Tails_JumpHeight


; =============== S U B R O U T I N E =======================================


Tails_Spindash:
		tst.b	$3D(a0)
		bne.s	loc_1527C
		cmpi.b	#8,$20(a0)
		bne.s	locret_1527A
		move.b	($FFFFF66B).w,d0
		andi.b	#$70,d0
		beq.w	locret_1527A
		move.b	#9,$20(a0)
		move.w	#-$55,d0
		jsr	(Play_Sound_2).l
		addq.l	#4,sp
		move.b	#1,$3D(a0)
		move.w	#0,$3E(a0)
		cmpi.b	#$C,$2C(a0)
		bcs.s	loc_15242
		move.b	#2,$20(a6)

loc_15242:
		bsr.w	Tails_Check_Screen_Boundaries
		bsr.w	Call_Player_AnglePos
		tst.b	($FFFFF664).w
		beq.s	locret_1527A
		bsr.w	sub_F846
		tst.w	d1
		bmi.w	Kill_Character
		movem.l	a4-a6,-(sp)
		bsr.w	sub_FD9A
		tst.w	d1
		bpl.s	loc_1526A
		sub.w	d1,$10(a0)

loc_1526A:
		bsr.w	sub_FA7A
		tst.w	d1
		bpl.s	loc_15276
		add.w	d1,$10(a0)

loc_15276:
		movem.l	(sp)+,a4-a6

locret_1527A:
					; Tails_Spindash+16j ...
		rts
; ---------------------------------------------------------------------------

loc_1527C:
		move.b	($FFFFF66A).w,d0
		btst	#1,d0
		bne.w	loc_15332
		move.b	#$E,$1E(a0)
		move.b	#7,$1F(a0)
		move.b	#2,$20(a0)
		addq.w	#1,$14(a0)
		tst.b	($FFFFF7C6).w
		beq.s	loc_152A8
		subq.w	#2,$14(a0)

loc_152A8:
		move.b	#0,$3D(a0)
		moveq	#0,d0
		move.b	$3E(a0),d0
		add.w	d0,d0
		move.w	word_1530E(pc,d0.w),$1C(a0)
		tst.b	($FFFFF667).w
		beq.s	loc_152C8
		move.w	word_15320(pc,d0.w),$1C(a0)

loc_152C8:
		move.w	$1C(a0),d0
		subi.w	#$800,d0
		add.w	d0,d0
		andi.w	#$1F00,d0
		neg.w	d0
		addi.w	#$2000,d0
		lea	($FFFFEE24).w,a1
		cmpa.w	#$B000,a0
		beq.s	loc_152EA
		lea	($FFFFEE28).w,a1

loc_152EA:
		move.w	d0,(a1)
		btst	#0,$2A(a0)
		beq.s	loc_152F8
		neg.w	$1C(a0)

loc_152F8:
		bset	#2,$2A(a0)
		move.b	#0,$20(a6)
		moveq	#-$4A,d0
		jsr	(Play_Sound_2).l
		bra.s	loc_1537A
; ---------------------------------------------------------------------------
word_1530E:	dc.w $800
		dc.w $880
		dc.w $900
		dc.w $980
		dc.w $A00
		dc.w $A80
		dc.w $B00
		dc.w $B80
		dc.w $C00
word_15320:	dc.w $A00
		dc.w $A80
		dc.w $B00
		dc.w $B80
		dc.w $C00
		dc.w $C80
		dc.w $D00
		dc.w $D80
		dc.w $E00
; ---------------------------------------------------------------------------

loc_15332:
		tst.w	$3E(a0)
		beq.s	loc_1534A
		move.w	$3E(a0),d0
		lsr.w	#5,d0
		sub.w	d0,$3E(a0)
		bcc.s	loc_1534A
		move.w	#0,$3E(a0)

loc_1534A:
					; Tails_Spindash+146j
		move.b	($FFFFF66B).w,d0
		andi.b	#$70,d0
		beq.w	loc_1537A
		move.w	#$900,$20(a0)
		move.w	#$FFAB,d0
		jsr	(Play_Sound_2).l
		addi.w	#$200,$3E(a0)
		cmpi.w	#$800,$3E(a0)
		bcs.s	loc_1537A
		move.w	#$800,$3E(a0)

loc_1537A:
					; Tails_Spindash+156j ...
		addq.l	#4,sp
		cmpi.w	#$60,(a5)
		beq.s	loc_15388
		bcc.s	loc_15386
		addq.w	#4,(a5)

loc_15386:
		subq.w	#2,(a5)

loc_15388:
		bsr.w	Tails_Check_Screen_Boundaries
		bsr.w	Call_Player_AnglePos
		tst.b	($FFFFF664).w
		beq.s	locret_153C0
		bsr.w	sub_F846
		tst.w	d1
		bmi.w	Kill_Character
		movem.l	a4-a6,-(sp)
		bsr.w	sub_FD9A
		tst.w	d1
		bpl.s	loc_153B0
		sub.w	d1,$10(a0)

loc_153B0:
		bsr.w	sub_FA7A
		tst.w	d1
		bpl.s	loc_153BC
		add.w	d1,$10(a0)

loc_153BC:
		movem.l	(sp)+,a4-a6

locret_153C0:
		rts
; End of function Tails_Spindash


; =============== S U B R O U T I N E =======================================


sub_153C2:

		move.l	($FFFFF7B4).w,($FFFFF796).w
		cmpi.b	#$C,$46(a0)
		beq.s	loc_153D6
		move.l	($FFFFF7B8).w,($FFFFF796).w

loc_153D6:
		move.b	$47(a0),d5
		move.w	$18(a0),d1
		move.w	$1A(a0),d2
		jsr	(GetArcTan).l
		subi.b	#$20,d0
		andi.b	#$C0,d0
		cmpi.b	#$40,d0
		beq.w	loc_154AC
		cmpi.b	#$80,d0
		beq.w	loc_15538
		cmpi.b	#$C0,d0
		beq.w	loc_1559C
		bsr.w	sub_FD9A
		tst.w	d1
		bpl.s	loc_1541A
		sub.w	d1,$10(a0)
		move.w	#0,$18(a0)

loc_1541A:
		bsr.w	sub_FA7A
		tst.w	d1
		bpl.s	loc_1542C
		add.w	d1,$10(a0)
		move.w	#0,$18(a0)

loc_1542C:
		bsr.w	sub_11FD6
		tst.w	d1
		bpl.s	locret_154AA
		move.b	$1A(a0),d2
		addq.b	#8,d2
		neg.b	d2
		cmp.b	d2,d1
		bge.s	loc_15444
		cmp.b	d2,d0
		blt.s	locret_154AA

loc_15444:
		move.b	d3,$26(a0)
		tst.b	($FFFFF7C6).w
		beq.s	loc_15450
		neg.w	d1

loc_15450:
		add.w	d1,$14(a0)
		move.b	d3,d0
		addi.b	#$20,d0
		andi.b	#$40,d0
		bne.s	loc_15484
		move.b	d3,d0
		addi.b	#$10,d0
		andi.b	#$20,d0
		beq.s	loc_15472
		asr	$1A(a0)
		bra.s	loc_15498
; ---------------------------------------------------------------------------

loc_15472:
		move.w	#0,$1A(a0)
		move.w	$18(a0),$1C(a0)
		bsr.w	Tails_TouchFloor_Check_Spindash
		rts
; ---------------------------------------------------------------------------

loc_15484:
		move.w	#0,$18(a0)
		cmpi.w	#$FC0,$1A(a0)
		ble.s	loc_15498
		move.w	#$FC0,$1A(a0)

loc_15498:

		bsr.w	Tails_TouchFloor_Check_Spindash
		move.w	$1A(a0),$1C(a0)
		tst.b	d3
		bpl.s	locret_154AA
		neg.w	$1C(a0)

locret_154AA:

		rts
; ---------------------------------------------------------------------------

loc_154AC:
		bsr.w	sub_FD9A
		tst.w	d1
		bpl.s	loc_154C4
		sub.w	d1,$10(a0)
		move.w	#0,$18(a0)
		move.w	$1A(a0),$1C(a0)

loc_154C4:
		bsr.w	sub_11FEE
		tst.w	d1
		bpl.s	loc_15502
		neg.w	d1
		cmpi.w	#$14,d1
		bcc.s	loc_154EE
		tst.b	($FFFFF7C6).w
		beq.s	loc_154DC
		neg.w	d1

loc_154DC:
		add.w	d1,$14(a0)
		tst.w	$1A(a0)
		bpl.s	locret_154EC
		move.w	#0,$1A(a0)

locret_154EC:
		rts
; ---------------------------------------------------------------------------

loc_154EE:
		bsr.w	sub_FA7A
		tst.w	d1
		bpl.s	locret_15500
		add.w	d1,$10(a0)
		move.w	#0,$18(a0)

locret_15500:
		rts
; ---------------------------------------------------------------------------

loc_15502:
		tst.b	($FFFFF7C9).w
		bne.s	loc_1550E
		tst.w	$1A(a0)
		bmi.s	locret_15536

loc_1550E:
		bsr.w	sub_11FD6
		tst.w	d1
		bpl.s	locret_15536
		tst.b	($FFFFF7C6).w
		beq.s	loc_1551E
		neg.w	d1

loc_1551E:
		add.w	d1,$14(a0)
		move.b	d3,$26(a0)
		move.w	#0,$1A(a0)
		move.w	$18(a0),$1C(a0)
		bsr.w	Tails_TouchFloor_Check_Spindash

locret_15536:

		rts
; ---------------------------------------------------------------------------

loc_15538:
		bsr.w	sub_FD9A
		tst.w	d1
		bpl.s	loc_1554A
		sub.w	d1,$10(a0)
		move.w	#0,$18(a0)

loc_1554A:
		bsr.w	sub_FA7A
		tst.w	d1
		bpl.s	loc_1555C
		add.w	d1,$10(a0)
		move.w	#0,$18(a0)

loc_1555C:
		bsr.w	sub_11FEE
		tst.w	d1
		bpl.s	locret_1559A
		tst.b	($FFFFF7C6).w
		beq.s	loc_1556C
		neg.w	d1

loc_1556C:
		sub.w	d1,$14(a0)
		move.b	d3,d0
		addi.b	#$20,d0
		andi.b	#$40,d0
		bne.s	loc_15584
		move.w	#0,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_15584:
		move.b	d3,$26(a0)
		bsr.w	Tails_TouchFloor_Check_Spindash
		move.w	$1A(a0),$1C(a0)
		tst.b	d3
		bpl.s	locret_1559A
		neg.w	$1C(a0)

locret_1559A:

		rts
; ---------------------------------------------------------------------------

loc_1559C:
		bsr.w	sub_FA7A
		tst.w	d1
		bpl.s	loc_155B4
		add.w	d1,$10(a0)
		move.w	#0,$18(a0)
		move.w	$1A(a0),$1C(a0)

loc_155B4:
		bsr.w	sub_11FEE
		tst.w	d1
		bpl.s	loc_155D6
		tst.b	($FFFFF7C6).w
		beq.s	loc_155C4
		neg.w	d1

loc_155C4:
		sub.w	d1,$14(a0)
		tst.w	$1A(a0)
		bpl.s	locret_155D4
		move.w	#0,$1A(a0)

locret_155D4:
		rts
; ---------------------------------------------------------------------------

loc_155D6:
		tst.b	($FFFFF7C9).w
		bne.s	loc_155E2
		tst.w	$1A(a0)
		bmi.s	locret_1560A

loc_155E2:
		bsr.w	sub_11FD6
		tst.w	d1
		bpl.s	locret_1560A
		tst.b	($FFFFF7C6).w
		beq.s	loc_155F2
		neg.w	d1

loc_155F2:
		add.w	d1,$14(a0)
		move.b	d3,$26(a0)
		move.w	#0,$1A(a0)
		move.w	$18(a0),$1C(a0)
		bsr.w	Tails_TouchFloor_Check_Spindash

locret_1560A:

		rts
; End of function sub_153C2


; =============== S U B R O U T I N E =======================================


Tails_TouchFloor_Check_Spindash:
		tst.b	$3D(a0)
		bne.s	loc_1565E
		move.b	#0,$20(a0)
; End of function Tails_TouchFloor_Check_Spindash


; =============== S U B R O U T I N E =======================================


Tails_TouchFloor:
		move.b	$1E(a0),d0
		move.b	$44(a0),$1E(a0)
		move.b	$45(a0),$1F(a0)
		btst	#2,$2A(a0)
		beq.s	loc_1565E
		bclr	#2,$2A(a0)
		move.b	#0,$20(a0)
		sub.b	$44(a0),d0
		ext.w	d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_1564A
		neg.w	d0

loc_1564A:
		move.w	d0,-(sp)
		move.b	$26(a0),d0
		addi.b	#$40,d0
		bpl.s	loc_15658
		neg.w	(sp)

loc_15658:
		move.w	(sp)+,d0
		add.w	d0,$14(a0)

loc_1565E:
					; Tails_TouchFloor+16j
		bclr	#1,$2A(a0)
		bclr	#5,$2A(a0)
		bclr	#4,$2A(a0)
		move.b	#0,$40(a0)
		move.w	#0,($FFFFF7D0).w
		move.b	#0,$27(a0)
		move.b	#0,$2D(a0)
		move.b	#0,$30(a0)
		move.b	#0,$39(a0)
		move.b	#0,$2F(a0)
		rts
; End of function Tails_TouchFloor

; ---------------------------------------------------------------------------

loc_1569C:

		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_156BE
		tst.w	($FFFFFFDA).w
		beq.s	loc_156BE
		btst	#4,($FFFFF605).w
		beq.s	loc_156BE
		move.w	#1,($FFFFFE08).w
		clr.b	($FFFFF7CA).w
		rts
; ---------------------------------------------------------------------------

loc_156BE:

		tst.b	($FFFFF73E).w
		beq.s	loc_156D6
		lea	($FFFFB000).w,a1
		clr.b	$2E(a1)
		bset	#1,$2A(a1)
		clr.w	($FFFFF73E).w

loc_156D6:
		jsr	(MoveSprite_TestGravity2).l
		addi.w	#$30,$1A(a0)
		btst	#6,$2A(a0)
		beq.s	loc_156F0
		subi.w	#$20,$1A(a0)

loc_156F0:
		cmpi.w	#-$100,($FFFFEE18).w
		bne.s	loc_15700
		move.w	($FFFFEEAA).w,d0
		and.w	d0,$14(a0)

loc_15700:
		bsr.w	sub_15716
		bsr.w	Tails_Check_Screen_Boundaries
		bsr.w	sub_10D66
		bsr.w	sub_15842
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_15716:
		tst.b	($FFFFF665).w
		bne.s	loc_15742
		tst.b	($FFFFF7C6).w
		bne.s	loc_15734
		move.w	($FFFFEE1A).w,d0
		addi.w	#$E0,d0
		cmp.w	$14(a0),d0
		blt.w	loc_15788
		bra.s	loc_15742
; ---------------------------------------------------------------------------

loc_15734:
		move.w	($FFFFEE18).w,d0
		cmp.w	$14(a0),d0
		blt.s	loc_15742
		bra.w	loc_15788
; ---------------------------------------------------------------------------

loc_15742:

		movem.l	a4-a6,-(sp)
		bsr.w	sub_153C2
		movem.l	(sp)+,a4-a6
		btst	#1,$2A(a0)
		bne.s	locret_15786
		moveq	#0,d0
		move.w	d0,$1A(a0)
		move.w	d0,$18(a0)
		move.w	d0,$1C(a0)
		move.b	d0,$2E(a0)
		move.b	#0,$20(a0)
		move.w	#$100,8(a0)
		move.b	#2,5(a0)
		move.b	#$78,$34(a0)
		move.b	#0,$3D(a0)

locret_15786:
		rts
; ---------------------------------------------------------------------------

loc_15788:

		jmp	(Kill_Character).l
; End of function sub_15716

; ---------------------------------------------------------------------------

loc_1578E:

		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_157B0
		tst.w	($FFFFFFDA).w
		beq.s	loc_157B0
		btst	#4,($FFFFF605).w
		beq.s	loc_157B0
		move.w	#1,($FFFFFE08).w
		clr.b	($FFFFF7CA).w
		rts
; ---------------------------------------------------------------------------

loc_157B0:

		tst.b	($FFFFF73E).w
		beq.s	loc_157C8
		lea	($FFFFB000).w,a1
		clr.b	$2E(a1)
		bset	#1,$2A(a1)
		clr.w	($FFFFF73E).w

loc_157C8:
		bsr.w	sub_123C2
		jsr	(MoveSprite_TestGravity).l
		bsr.w	sub_10D66
		bsr.w	sub_15842
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_157E0:

		tst.w	$3E(a0)
		beq.s	locret_157F2
		subq.w	#1,$3E(a0)
		bne.s	locret_157F2
		move.w	#1,($FFFFFE02).w

locret_157F2:

		rts
; ---------------------------------------------------------------------------

loc_157F4:

		tst.w	($FFFFEE04).w
		bne.s	loc_15806
		tst.w	($FFFFEE06).w
		bne.s	loc_15806
		move.b	#2,5(a0)

loc_15806:

		bsr.w	sub_15842
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_15810:
		tst.b	($FFFFF73E).w
		beq.s	loc_15828
		lea	($FFFFB000).w,a1
		clr.b	$2E(a1)
		bset	#1,$2A(a1)
		clr.w	($FFFFF73E).w

loc_15828:
		jsr	(MoveSprite_TestGravity2).l
		addi.w	#$10,$1A(a0)
		bsr.w	sub_10D66
		bsr.w	sub_15842
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_15842:

		tst.w	($FFFFFFE8).w
		bne.s	loc_1585A
		bsr.s	Animate_Tails
		tst.b	($FFFFF7C6).w
		beq.s	loc_15856
		eori.b	#2,4(a0)

loc_15856:
		bra.w	Tails_Load_PLC
; ---------------------------------------------------------------------------

loc_1585A:
		bsr.w	Animate_Tails2P
		bra.w	Tails2P_Load_PLC
; End of function sub_15842


; =============== S U B R O U T I N E =======================================


Animate_Tails:

		lea	(AniTails).l,a1

loc_15868:
		moveq	#0,d0
		move.b	$20(a0),d0
		cmp.b	$21(a0),d0
		beq.s	loc_1588A
		move.b	d0,$21(a0)
		move.b	#0,$23(a0)
		move.b	#0,$24(a0)
		bclr	#5,$2A(a0)

loc_1588A:
		add.w	d0,d0
		adda.w	(a1,d0.w),a1
		move.b	(a1),d0
		bmi.s	loc_158FA
		move.b	$2A(a0),d1
		andi.b	#1,d1
		andi.b	#-4,4(a0)
		or.b	d1,4(a0)
		subq.b	#1,$24(a0)
		bpl.s	locret_158C8
		move.b	d0,$24(a0)
; End of function Animate_Tails


; =============== S U B R O U T I N E =======================================


sub_158B0:

		moveq	#0,d1
		move.b	$23(a0),d1
		move.b	1(a1,d1.w),d0
		cmpi.b	#-4,d0
		bcc.s	loc_158CA

loc_158C0:

		move.b	d0,$22(a0)
		addq.b	#1,$23(a0)

locret_158C8:

		rts
; ---------------------------------------------------------------------------

loc_158CA:
		addq.b	#1,d0
		bne.s	loc_158DA
		move.b	#0,$23(a0)
		move.b	1(a1),d0
		bra.s	loc_158C0
; ---------------------------------------------------------------------------

loc_158DA:
		addq.b	#1,d0
		bne.s	loc_158EE
		move.b	2(a1,d1.w),d0
		sub.b	d0,$23(a0)
		sub.b	d0,d1
		move.b	1(a1,d1.w),d0
		bra.s	loc_158C0
; ---------------------------------------------------------------------------

loc_158EE:
		addq.b	#1,d0
		bne.s	locret_158F8
		move.b	2(a1,d1.w),$20(a0)

locret_158F8:
		rts
; End of function sub_158B0

; ---------------------------------------------------------------------------

loc_158FA:
		addq.b	#1,d0
		bne.w	loc_159C8
		moveq	#0,d0
		tst.b	$2D(a0)
		bmi.w	loc_127C0
		move.b	$27(a0),d0
		bne.w	loc_127C0
		moveq	#0,d1
		move.b	$26(a0),d0
		bmi.s	loc_1591E
		beq.s	loc_1591E
		subq.b	#1,d0

loc_1591E:

		move.b	$2A(a0),d2
		andi.b	#1,d2
		bne.s	loc_1592A
		not.b	d0

loc_1592A:
		addi.b	#$10,d0
		bpl.s	loc_15932
		moveq	#3,d1

loc_15932:
		andi.b	#-4,4(a0)
		eor.b	d1,d2
		or.b	d2,4(a0)
		btst	#5,$2A(a0)
		bne.w	loc_15A14
		lsr.b	#4,d0
		andi.b	#6,d0
		move.w	$1C(a0),d2
		bpl.s	loc_15956
		neg.w	d2

loc_15956:
		tst.b	$2B(a0)
		bpl.w	loc_15960
		add.w	d2,d2

loc_15960:
		move.b	d0,d3
		add.b	d3,d3
		add.b	d3,d3
		lea	(AniTails00).l,a1
		cmpi.w	#$600,d2
		bcs.s	loc_1598A
		lea	(AniTails01).l,a1
		move.b	d0,d3
		add.b	d3,d3
		cmpi.w	#$700,d2
		bcs.s	loc_1598A
		lea	(AniTails1F).l,a1
		move.b	d0,d3

loc_1598A:

		moveq	#0,d1
		move.b	$23(a0),d1
		move.b	1(a1,d1.w),d0
		cmpi.b	#-1,d0
		bne.s	loc_159A4
		move.b	#0,$23(a0)
		move.b	1(a1),d0

loc_159A4:
		move.b	d0,$22(a0)
		add.b	d3,$22(a0)
		subq.b	#1,$24(a0)
		bpl.s	locret_159C6
		neg.w	d2
		addi.w	#$800,d2
		bpl.s	loc_159BC
		moveq	#0,d2

loc_159BC:
		lsr.w	#8,d2
		move.b	d2,$24(a0)
		addq.b	#1,$23(a0)

locret_159C6:
		rts
; ---------------------------------------------------------------------------

loc_159C8:
		addq.b	#1,d0
		bne.s	loc_15A3C
		move.b	$2A(a0),d1
		andi.b	#1,d1
		andi.b	#-4,4(a0)
		or.b	d1,4(a0)
		subq.b	#1,$24(a0)
		bpl.w	locret_158C8
		move.w	$1C(a0),d2
		bpl.s	loc_159EE
		neg.w	d2

loc_159EE:
		lea	(AniTails03).l,a1
		cmpi.w	#$600,d2
		bcc.s	loc_15A00
		lea	(AniTails02).l,a1

loc_15A00:
		neg.w	d2
		addi.w	#$400,d2
		bpl.s	loc_15A0A
		moveq	#0,d2

loc_15A0A:
		lsr.w	#8,d2
		move.b	d2,$24(a0)
		bra.w	sub_158B0
; ---------------------------------------------------------------------------

loc_15A14:
		subq.b	#1,$24(a0)
		bpl.w	locret_158C8
		move.w	$1C(a0),d2
		bmi.s	loc_15A24
		neg.w	d2

loc_15A24:
		addi.w	#$800,d2
		bpl.s	loc_15A2C
		moveq	#0,d2

loc_15A2C:
		lsr.w	#6,d2
		move.b	d2,$24(a0)
		lea	(AniTails04).l,a1
		bra.w	sub_158B0
; ---------------------------------------------------------------------------

loc_15A3C:
		subq.b	#1,$24(a0)
		bpl.w	locret_158C8
		move.w	$18(a2),d1
		move.w	$1A(a2),d2
		jsr	(GetArcTan).l
		cmpi.b	#$15,($FFFFFE10).w
		bne.s	loc_15A5E
		add.b	($FFFFE400).w,d0

loc_15A5E:
		moveq	#0,d1
		move.b	$2A(a0),d2
		andi.b	#1,d2
		bne.s	loc_15A6E
		not.b	d0
		bra.s	loc_15A72
; ---------------------------------------------------------------------------

loc_15A6E:
		addi.b	#$80,d0

loc_15A72:
		addi.b	#$10,d0
		bpl.s	loc_15A7A
		moveq	#3,d1

loc_15A7A:
		andi.b	#-4,4(a0)
		eor.b	d1,d2
		or.b	d2,4(a0)
		tst.b	($FFFFF7C6).w
		beq.s	loc_15A92
		eori.b	#2,4(a0)

loc_15A92:
		lsr.b	#3,d0
		andi.b	#$C,d0
		move.b	d0,d3
		lea	(AniTails_Tail03).l,a1
		move.b	#3,$24(a0)
		bsr.w	sub_158B0
		add.b	d3,$22(a0)
		rts
; ---------------------------------------------------------------------------
AniTails:	include "General\Sprites\Tails\Anim - Tails.asm"

; ---------------------------------------------------------------------------

Tails_Tail_Load_PLC:
		moveq	#0,d0
		move.b	$22(a0),d0
		cmp.b	($FFFFF7DF).w,d0
		beq.w	locret_15CCE
		move.b	d0,($FFFFF7DF).w
		lea	(PLC_Tails_Tail).l,a2
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d5
		subq.w	#1,d5
		bmi.s	locret_15CCE
		move.w	#-$2A00,d4
		move.l	#ArtUnc_Tails_Tail,d6
		bra.s	loc_15CA6

; =============== S U B R O U T I N E =======================================


Tails_Load_PLC:

		moveq	#0,d0
		move.b	$22(a0),d0

Tails_Load_PLC2:
		cmp.b	($FFFFF7DE).w,d0
		beq.s	locret_15CCE
		move.b	d0,($FFFFF7DE).w
		lea	(PLC_Tails).l,a2
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d5
		subq.w	#1,d5
		bmi.s	locret_15CCE
		move.w	#$D400,d4
		move.l	#ArtUnc_Tails,d6
		cmpi.w	#$1A2,d0
		bcs.s	loc_15CA6
		move.l	#ArtUnc_Tails_Extra,d6

loc_15CA6:
					; Tails_Load_PLC+30j ...
		moveq	#0,d1
		move.w	(a2)+,d1
		move.w	d1,d3
		lsr.w	#8,d3
		andi.w	#$F0,d3
		addi.w	#$10,d3
		andi.w	#$FFF,d1
		lsl.l	#5,d1
		add.l	d6,d1
		move.w	d4,d2
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		dbf	d5,loc_15CA6

locret_15CCE:

		rts
; End of function Tails_Load_PLC


; =============== S U B R O U T I N E =======================================


Animate_Tails2P:

		lea	(Ani_Tails2P).l,a1

Animate_Tails_Tail2P:
		moveq	#0,d0
		move.b	$20(a0),d0
		cmp.b	$21(a0),d0
		beq.s	loc_15CF8
		move.b	d0,$21(a0)
		move.b	#0,$23(a0)
		move.b	#0,$24(a0)
		bclr	#5,$2A(a0)

loc_15CF8:
		add.w	d0,d0
		adda.w	(a1,d0.w),a1
		move.b	(a1),d0
		bmi.s	loc_15D68
		move.b	$2A(a0),d1
		andi.b	#1,d1
		andi.b	#-4,4(a0)
		or.b	d1,4(a0)
		subq.b	#1,$24(a0)
		bpl.s	locret_15D36
		move.b	d0,$24(a0)
; End of function Animate_Tails2P


; =============== S U B R O U T I N E =======================================


sub_15D1E:

		moveq	#0,d1
		move.b	$23(a0),d1
		move.b	1(a1,d1.w),d0
		cmpi.b	#-$10,d0
		bcc.s	loc_15D38

loc_15D2E:

		move.b	d0,$22(a0)
		addq.b	#1,$23(a0)

locret_15D36:

		rts
; ---------------------------------------------------------------------------

loc_15D38:
		addq.b	#1,d0
		bne.s	loc_15D48
		move.b	#0,$23(a0)
		move.b	1(a1),d0
		bra.s	loc_15D2E
; ---------------------------------------------------------------------------

loc_15D48:
		addq.b	#1,d0
		bne.s	loc_15D5C
		move.b	2(a1,d1.w),d0
		sub.b	d0,$23(a0)
		sub.b	d0,d1
		move.b	1(a1,d1.w),d0
		bra.s	loc_15D2E
; ---------------------------------------------------------------------------

loc_15D5C:
		addq.b	#1,d0
		bne.s	locret_15D66
		move.b	2(a1,d1.w),$20(a0)

locret_15D66:
		rts
; End of function sub_15D1E

; ---------------------------------------------------------------------------

loc_15D68:
		addq.b	#1,d0
		bne.w	loc_15E82
		moveq	#0,d0
		move.b	$27(a0),d0
		bne.w	loc_15E1C
		moveq	#0,d1
		move.b	$26(a0),d0
		bmi.s	loc_15D84
		beq.s	loc_15D84
		subq.b	#1,d0

loc_15D84:

		move.b	$2A(a0),d2
		andi.b	#1,d2
		bne.s	loc_15D90
		not.b	d0

loc_15D90:
		addi.b	#$10,d0
		bpl.s	loc_15D98
		moveq	#3,d1

loc_15D98:
		andi.b	#-4,4(a0)
		eor.b	d1,d2
		or.b	d2,4(a0)
		btst	#5,$2A(a0)
		bne.w	loc_15ECE
		lsr.b	#5,d0
		andi.b	#3,d0
		move.w	$1C(a0),d2
		bpl.s	loc_15DBC
		neg.w	d2

loc_15DBC:
		tst.b	$2B(a0)
		bpl.w	loc_15DC6
		add.w	d2,d2

loc_15DC6:
		move.b	d0,d3
		lea	(byte_15FA8).l,a1
		cmpi.w	#$600,d2
		bcc.s	loc_15DDC
		lea	(byte_15FA2).l,a1
		add.b	d0,d0

loc_15DDC:
		add.b	d0,d3
		moveq	#0,d1
		move.b	$23(a0),d1
		move.b	1(a1,d1.w),d0
		cmpi.b	#-1,d0
		bne.s	loc_15DF8
		move.b	#0,$23(a0)
		move.b	1(a1),d0

loc_15DF8:
		move.b	d0,$22(a0)
		add.b	d3,$22(a0)
		subq.b	#1,$24(a0)
		bpl.s	locret_15E1A
		neg.w	d2
		addi.w	#$800,d2
		bpl.s	loc_15E10
		moveq	#0,d2

loc_15E10:
		lsr.w	#8,d2
		move.b	d2,$24(a0)
		addq.b	#1,$23(a0)

locret_15E1A:
		rts
; ---------------------------------------------------------------------------

loc_15E1C:
		move.b	$27(a0),d0
		moveq	#0,d1
		move.b	$2A(a0),d2
		andi.b	#1,d2
		bne.s	loc_15E4A
		andi.b	#-4,4(a0)
		addi.b	#$16,d0
		divu.w	#$2C,d0
		addi.b	#$15,d0
		move.b	d0,$22(a0)
		move.b	#0,$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_15E4A:
		andi.b	#-4,4(a0)
		tst.b	$2D(a0)
		bpl.s	loc_15E62
		ori.b	#1,4(a0)
		addi.b	#$16,d0
		bra.s	loc_15E6E
; ---------------------------------------------------------------------------

loc_15E62:
		ori.b	#3,4(a0)
		neg.b	d0
		addi.b	#$9A,d0

loc_15E6E:
		divu.w	#$2C,d0
		addi.b	#$15,d0
		move.b	d0,$22(a0)
		move.b	#0,$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_15E82:
		subq.b	#1,$24(a0)
		bpl.w	locret_15D36
		addq.b	#1,d0
		bne.s	loc_15F08
		move.w	$1C(a0),d2
		bpl.s	loc_15E96
		neg.w	d2

loc_15E96:
		lea	(byte_15FB3).l,a1
		cmpi.w	#$600,d2
		bcc.s	loc_15EA8
		lea	(byte_15FAE).l,a1

loc_15EA8:
		neg.w	d2
		addi.w	#$400,d2
		bpl.s	loc_15EB2
		moveq	#0,d2

loc_15EB2:
		lsr.w	#8,d2
		move.b	d2,$24(a0)
		move.b	$2A(a0),d1
		andi.b	#1,d1
		andi.b	#-4,4(a0)
		or.b	d1,4(a0)
		bra.w	sub_15D1E
; ---------------------------------------------------------------------------

loc_15ECE:
		subq.b	#1,$24(a0)
		bpl.w	locret_15D36
		move.w	$1C(a0),d2
		bmi.s	loc_15EDE
		neg.w	d2

loc_15EDE:
		addi.w	#$800,d2
		bpl.s	loc_15EE6
		moveq	#0,d2

loc_15EE6:
		lsr.w	#6,d2
		move.b	d2,$24(a0)
		lea	(byte_15FB8).l,a1
		move.b	$2A(a0),d1
		andi.b	#1,d1
		andi.b	#-4,4(a0)
		or.b	d1,4(a0)
		bra.w	sub_15D1E
; ---------------------------------------------------------------------------

loc_15F08:
		move.w	$18(a2),d1
		move.w	$1A(a2),d2
		jsr	(GetArcTan).l
		moveq	#0,d1
		move.b	$2A(a0),d2
		andi.b	#1,d2
		bne.s	loc_15F26
		not.b	d0
		bra.s	loc_15F2A
; ---------------------------------------------------------------------------

loc_15F26:
		addi.b	#$80,d0

loc_15F2A:
		addi.b	#$10,d0
		bpl.s	loc_15F32
		moveq	#3,d1

loc_15F32:
		andi.b	#-4,4(a0)
		eor.b	d1,d2
		or.b	d2,4(a0)
		lsr.b	#5,d0
		andi.b	#3,d0
		move.b	d0,d3
		add.b	d0,d0
		add.b	d0,d3
		lea	(byte_162D2).l,a1
		move.b	#3,$24(a0)
		bsr.w	sub_15D1E
		add.b	d3,$22(a0)
		rts
; ---------------------------------------------------------------------------
Ani_Tails2P:	include "General\Sprites\Tails\Anim - Tails 2P.asm"


; =============== S U B R O U T I N E =======================================


Tails2P_Tail_Load_PLC:
		moveq	#0,d0
		move.b	$22(a0),d0
		lea	(DPLC_Tails2P_Tail).l,a2
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d5
		subq.w	#1,d5
		bmi.s	locret_160A4
		move.l	#ArtUnc_Tails2P_Tail,d6
		move.w	#$D600,d4
		cmpa.w	#$CC0A,a0
		beq.s	loc_1607C
		move.w	#$D200,d4
		bra.s	loc_1607C
; End of function Tails2P_Tail_Load_PLC


; =============== S U B R O U T I N E =======================================


Tails2P_Load_PLC:

		moveq	#0,d0
		move.b	$22(a0),d0
		lea	(PLC_Tails2P).l,a2
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d5
		subq.w	#1,d5
		bmi.s	locret_160A4
		move.l	#ArtUnc_Tails2P,d6
		move.w	#$D000,d4
		cmpa.w	#$B000,a0
		beq.s	loc_1607C
		move.w	#$D400,d4

loc_1607C:
					; Tails2P_Tail_Load_PLC+2Cj ...
		moveq	#0,d1
		move.w	(a2)+,d1
		move.w	d1,d3
		lsr.w	#8,d3
		andi.w	#$F0,d3
		addi.w	#$10,d3
		andi.w	#$FFF,d1
		lsl.l	#5,d1
		add.l	d6,d1
		move.w	d4,d2
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		dbf	d5,loc_1607C

locret_160A4:
					; Tails2P_Load_PLC+16j
		rts
; End of function Tails2P_Load_PLC

; ---------------------------------------------------------------------------

Obj_Tails_Tail:

		move.l	#Map_Tails_Tail,$C(a0)
		move.w	#$6B0,$A(a0)
		move.w	#$100,8(a0)
		move.b	#$18,7(a0)
		move.b	#$18,6(a0)
		move.b	#4,4(a0)
		move.l	#loc_160D2,(a0)

loc_160D2:
		movea.w	$30(a0),a2
		move.b	$26(a2),$26(a0)
		move.b	$2A(a2),$2A(a0)
		move.w	$10(a2),$10(a0)
		move.w	$14(a2),$14(a0)
		move.w	8(a2),8(a0)
		andi.w	#$7FFF,$A(a0)
		tst.w	$A(a2)
		bpl.s	loc_16106
		ori.w	#$8000,$A(a0)

loc_16106:
		moveq	#0,d0
		move.b	$20(a2),d0
		btst	#5,$2A(a2)
		beq.s	loc_1612C
		tst.b	($FFFFF7C9).w
		bne.s	loc_1612C
		cmpi.b	#$A9,$22(a2)
		bcs.s	loc_1612C
		cmpi.b	#$AC,$22(a2)
		bhi.s	loc_1612C
		moveq	#4,d0

loc_1612C:

		cmp.b	$34(a0),d0
		beq.s	loc_1613C
		move.b	d0,$34(a0)
		move.b	byte_16164(pc,d0.w),$20(a0)

loc_1613C:
		lea	(AniTails_Tail).l,a1
		bsr.w	loc_15868
		tst.b	($FFFFF7C6).w
		beq.s	loc_1615A
		cmpi.b	#3,$20(a0)
		beq.s	loc_1615A
		eori.b	#2,4(a0)

loc_1615A:

		bsr.w	Tails_Tail_Load_PLC
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
byte_16164:	dc.b    0,   0,   3,   3,   9,   1,   0,   2,   1,   7,   0,   0,   0,   8,   0,   0,   0,   0,   0,   0
		dc.b   $A,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  $B,  $C,  $B,  $C,  $B,   0,   0,   0
		dc.b    0,   0,   0,   0,   0,   0,   0,   0,   0,   0
AniTails_Tail:	include "General\Sprites\Tails\Anim - Tails Tail.asm"

; ---------------------------------------------------------------------------

Obj_Tails2P_Tail:

		move.l	#Map_Tails2P_Tail,$C(a0)
		move.w	#$6B0,$A(a0)
		cmpa.w	#$CC0A,a0
		beq.s	loc_16214
		move.w	#$690,$A(a0)

loc_16214:
		move.w	#$100,8(a0)
		move.b	#$18,7(a0)
		move.b	#$18,6(a0)
		move.b	#4,4(a0)
		move.l	#loc_16232,(a0)

loc_16232:
		movea.w	$30(a0),a2
		move.b	$26(a2),$26(a0)
		move.b	$2A(a2),$2A(a0)
		move.w	$10(a2),$10(a0)
		move.w	$14(a2),$14(a0)
		move.w	8(a2),8(a0)
		andi.w	#$7FFF,$A(a0)
		tst.w	$A(a2)
		bpl.s	loc_16266
		ori.w	#$8000,$A(a0)

loc_16266:
		moveq	#0,d0
		move.b	$20(a2),d0
		btst	#5,$2A(a2)
		beq.s	loc_1627C
		cmpi.b	#5,d0
		beq.s	loc_1627C
		moveq	#4,d0

loc_1627C:

		cmp.b	$34(a0),d0
		beq.s	loc_1628C
		move.b	d0,$34(a0)
		move.b	byte_162A0(pc,d0.w),$20(a0)

loc_1628C:
		lea	(Ani_Tails2P_Tail).l,a1
		bsr.w	Animate_Tails_Tail2P
		bsr.w	Tails2P_Tail_Load_PLC
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
byte_162A0:	dc.b    0,   0,   3,   3,   0,   1,   1,   1,   1,   0,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0
		dc.b    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0
Ani_Tails2P_Tail:include "General\Sprites\Tails\Anim - Tails 2P Tail.asm"

; ---------------------------------------------------------------------------

Obj_MGZ2_BossTransition:
		cmpi.w	#2,($FFFFFF08).w
		beq.w	loc_163D0
		move.w	($FFFFEE78).w,d0
		addi.w	#$40,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d0
		addi.w	#$100,d0
		move.w	d0,$14(a0)
		lea	($FFFFB04A).w,a1
		tst.b	4(a1)
		bmi.s	loc_16328
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		subq.w	#1,$14(a1)
		move.l	#Obj_Tails,($FFFFB04A).w
		move.w	#$12,($FFFFF708).w
		move.w	#0,($FFFFF73E).w

loc_16328:
		move.w	#$168,$30(a0)
		move.l	#loc_16334,(a0)

loc_16334:
		subq.w	#1,$30(a0)
		bne.s	loc_16340
		move.l	#loc_16340,(a0)

loc_16340:

		tst.b	($FFFFF73E).w
		bne.s	loc_16384
		lea	($FFFFB000).w,a1
		move.w	$14(a0),d0
		cmp.w	$14(a1),d0
		bcc.s	loc_16384
		move.w	d0,$14(a1)
		move.w	#0,$18(a1)
		move.w	#0,$1A(a1)
		move.w	#0,$1C(a1)
		move.b	#0,$3D(a1)
		cmpi.w	#$14,($FFFFF708).w
		bcs.s	loc_1637E
		move.w	$10(a1),$10(a0)

loc_1637E:
		move.b	#2,5(a1)

loc_16384:

		tst.b	($FFFFB004).w
		bmi.s	locret_163CE
		cmpi.b	#2,($FFFFB005).w
		bne.s	locret_163CE
		lea	($FFFFB04A).w,a1
		move.w	$14(a0),d0
		cmp.w	$14(a1),d0
		bcc.s	locret_163CE
		move.w	#$12,($FFFFF708).w
		tst.w	$30(a0)
		bne.s	locret_163CE
		move.w	d0,$14(a1)
		move.b	#2,5(a1)
		move.b	#0,$2E(a1)
		move.b	#0,$3D(a1)
		move.w	$10(a0),$10(a1)
		move.w	#$14,($FFFFF708).w

locret_163CE:

		rts
; ---------------------------------------------------------------------------

loc_163D0:
		move.w	($FFFFEE78).w,d0
		addi.w	#$40,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d0
		addi.w	#$100,d0
		move.w	d0,$14(a0)
		move.w	#$168,$30(a0)
		move.l	#loc_163F4,(a0)

loc_163F4:
		subq.w	#1,$30(a0)
		bne.s	loc_1640A
		move.l	#loc_1640A,(a0)
		lea	($FFFFB000).w,a1
		move.w	$10(a0),$10(a1)

loc_1640A:

		lea	($FFFFB000).w,a1
		move.w	$14(a0),d0
		cmp.w	$14(a1),d0
		bcc.s	locret_16442
		move.w	d0,$14(a1)
		addq.w	#8,$14(a1)
		tst.w	$30(a0)
		bne.s	locret_16442
		move.w	d0,$14(a1)
		move.b	#2,5(a1)
		move.b	#0,$2E(a1)
		move.b	#0,$3D(a1)
		move.w	#$1A,($FFFFF708).w

locret_16442:

		rts
; ---------------------------------------------------------------------------

Obj_Knuckles:
		lea	($FFFFF760).w,a4
		lea	($FFFFEE2C).w,a5
		lea	($FFFFCC54).w,a6
		tst.w	($FFFFFE08).w
		beq.s	loc_1648E
		cmpi.b	#1,($FFFFFE09).w
		beq.s	loc_16488
		btst	#4,($FFFFF605).w
		beq.s	loc_1646C
		move.w	#0,($FFFFFE08).w

loc_1646C:
		addq.b	#1,$22(a0)
		cmpi.b	#-5,$22(a0)
		bcs.s	loc_1647E
		move.b	#0,$22(a0)

loc_1647E:
		bsr.w	Knuckles_Load_PLC
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_16488:
		jmp	(DebugMode).l
; ---------------------------------------------------------------------------

loc_1648E:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_1649C(pc,d0.w),d1
		jmp	off_1649C(pc,d1.w)
; ---------------------------------------------------------------------------
off_1649C:	dc.w loc_164AA-off_1649C

		dc.w loc_1656C-off_1649C; 1
		dc.w loc_17BB6-off_1649C; 2
		dc.w loc_17C88-off_1649C; 3
		dc.w loc_17CBA-off_1649C; 4
		dc.w loc_17CCE-off_1649C; 5
		dc.w loc_17CEA-off_1649C; 6
; ---------------------------------------------------------------------------

loc_164AA:
		addq.b	#2,5(a0)
		move.b	#$13,$1E(a0)
		move.b	#9,$1F(a0)
		move.b	#$13,$44(a0)
		move.b	#9,$45(a0)
		move.l	#Map_Knuckles,$C(a0)
		move.w	#$100,8(a0)
		move.b	#$18,7(a0)
		move.b	#$18,6(a0)
		move.b	#4,4(a0)
		move.b	#2,$38(a0)
		move.w	#$600,(a4)
		move.w	#$C,2(a4)
		move.w	#$80,4(a4)
		tst.b	($FFFFFE2A).w
		bne.s	loc_16534
		move.w	#$680,$A(a0)
		move.b	#$C,$46(a0)
		move.b	#$D,$47(a0)
		cmpi.b	#2,($FFFFFE48).w
		beq.s	loc_16534
		move.w	$10(a0),($FFFFFE2E).w
		move.w	$14(a0),($FFFFFE30).w
		move.w	$A(a0),($FFFFFE38).w
		move.w	$46(a0),($FFFFFE3A).w

loc_16534:

		move.b	#0,$30(a0)
		move.b	#4,$31(a0)
		move.b	#0,($FFFFFE19).w
		move.b	#$1E,$2C(a0)
		subi.w	#$20,$10(a0)
		addi.w	#4,$14(a0)
		jsr	(Reset_Player_Position_Array).l
		addi.w	#$20,$10(a0)
		subi.w	#4,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_1656C:
		tst.w	($FFFFFFDA).w
		beq.s	loc_165A2
		bclr	#6,($FFFFF605).w
		beq.s	loc_16580
		eori.b	#1,($FFFFF7C6).w

loc_16580:
		btst	#4,($FFFFF605).w
		beq.s	loc_165A2
		move.w	#1,($FFFFFE08).w
		clr.b	($FFFFF7CA).w
		btst	#5,($FFFFF604).w
		beq.s	locret_165A0
		move.w	#2,($FFFFFE08).w

locret_165A0:
		rts
; ---------------------------------------------------------------------------

loc_165A2:

		tst.b	($FFFFF7CA).w
		bne.s	loc_165AE
		move.w	($FFFFF604).w,($FFFFF602).w

loc_165AE:
		btst	#0,$2E(a0)
		beq.s	loc_165BE
		move.b	#0,$2F(a0)
		bra.s	loc_165D8
; ---------------------------------------------------------------------------

loc_165BE:
		movem.l	a4-a6,-(sp)
		moveq	#0,d0
		move.b	$2A(a0),d0
		andi.w	#6,d0
		move.w	off_16642(pc,d0.w),d1
		jsr	off_16642(pc,d1.w)
		movem.l	(sp)+,a4-a6

loc_165D8:
		cmpi.w	#$FF00,($FFFFEE18).w
		bne.s	loc_165E8
		move.w	($FFFFEEAA).w,d0
		and.w	d0,$14(a0)

loc_165E8:
		bsr.s	sub_1664A
		bsr.w	sub_11B30
		bsr.w	sub_10D66
		bsr.w	sub_166EE
		move.b	($FFFFF768).w,$3A(a0)
		move.b	($FFFFF76A).w,$3B(a0)
		tst.b	($FFFFF7C8).w
		beq.s	loc_16614
		tst.b	$20(a0)
		bne.s	loc_16614
		move.b	$21(a0),$20(a0)

loc_16614:

		btst	#1,$2E(a0)
		bne.s	loc_16630
		bsr.w	Animate_Knuckles
		tst.b	($FFFFF7C6).w
		beq.s	loc_1662C
		eori.b	#2,4(a0)

loc_1662C:
		bsr.w	Knuckles_Load_PLC

loc_16630:
		move.b	$2E(a0),d0
		andi.b	#-$60,d0
		bne.s	locret_16640
		jsr	(Test_Sprite_Collisions).l

locret_16640:
		rts
; ---------------------------------------------------------------------------
off_16642:	dc.w Knux_Stand_Path-off_16642

		dc.w Knux_Stand_Freespace-off_16642
		dc.w Knux_Spin_Path-off_16642
		dc.w Knux_Spin_Freespace-off_16642

; =============== S U B R O U T I N E =======================================


sub_1664A:
		move.b	$34(a0),d0
		beq.s	loc_16658
		subq.b	#1,$34(a0)
		lsr.b	#3,d0
		bcc.s	loc_1665E

loc_16658:
		jsr	(Draw_Sprite).l

loc_1665E:
		btst	#1,$2B(a0)
		beq.s	loc_1669A
		tst.b	$35(a0)
		beq.s	loc_1669A
		move.b	($FFFFFE05).w,d0
		andi.b	#7,d0
		bne.s	loc_1669A
		subq.b	#1,$35(a0)
		bne.s	loc_1669A
		tst.b	($FFFFF7AA).w
		bne.s	loc_16694
		cmpi.b	#$C,$2C(a0)
		bcs.s	loc_16694
		move.w	($FFFFFF90).w,d0
		jsr	(Play_Sound).l

loc_16694:

		bclr	#1,$2B(a0)

loc_1669A:

		btst	#2,$2B(a0)
		beq.s	locret_166EC
		tst.b	$36(a0)
		beq.s	locret_166EC
		move.b	($FFFFFE05).w,d0
		andi.b	#7,d0
		bne.s	locret_166EC
		subq.b	#1,$36(a0)
		bne.s	locret_166EC
		move.w	#$600,(a4)
		move.w	#$C,2(a4)
		move.w	#$80,4(a4)
		tst.b	($FFFFFE19).w
		beq.s	loc_166DE
		move.w	#$800,(a4)
		move.w	#$18,2(a4)
		move.w	#$C0,4(a4)

loc_166DE:
		bclr	#2,$2B(a0)
		moveq	#0,d0
		jmp	(Change_Music_Tempo).l
; ---------------------------------------------------------------------------

locret_166EC:

		rts
; End of function sub_1664A


; =============== S U B R O U T I N E =======================================


sub_166EE:
		tst.b	($FFFFF730).w
		bne.s	loc_166F6

locret_166F4:

		rts
; ---------------------------------------------------------------------------

loc_166F6:
		move.w	($FFFFF646).w,d0
		cmp.w	$14(a0),d0
		bge.s	loc_1676E
		bset	#6,$2A(a0)
		bne.s	locret_166F4
		addq.b	#1,($FFFFF64D).w
		movea.l	a0,a1
		bsr.w	Player_ResetAirTimer
		move.l	#Obj_Air_CountDown,($FFFFCB2C).w
		move.b	#-$7F,($FFFFCB58).w
		move.l	a0,($FFFFCB6C).w
		move.w	#$300,(a4)
		move.w	#6,2(a4)
		move.w	#$40,4(a4)
		tst.b	($FFFFFE19).w
		beq.s	loc_1674A
		move.w	#$400,(a4)
		move.w	#$C,2(a4)
		move.w	#$60,4(a4)

loc_1674A:
		tst.b	$2E(a0)
		bne.s	locret_166F4
		asr	$18(a0)
		asr	$1A(a0)
		asr	$1A(a0)
		beq.s	locret_166F4
		move.w	#$100,$20(a6)
		move.w	#$39,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

loc_1676E:
		bclr	#6,$2A(a0)
		beq.w	locret_166F4
		addq.b	#1,($FFFFF64D).w
		movea.l	a0,a1
		bsr.w	Player_ResetAirTimer
		move.w	#$600,(a4)
		move.w	#$C,2(a4)
		move.w	#$80,4(a4)
		tst.b	($FFFFFE19).w
		beq.s	loc_167A8
		move.w	#$800,(a4)
		move.w	#$18,2(a4)
		move.w	#$C0,4(a4)

loc_167A8:
		cmpi.b	#4,5(a0)
		beq.s	loc_167C4
		tst.b	$2E(a0)
		bne.s	loc_167C4
		move.w	$1A(a0),d0
		cmpi.w	#-$400,d0
		blt.s	loc_167C4
		asl	$1A(a0)

loc_167C4:

		cmpi.b	#$1C,$20(a0)
		beq.w	locret_166F4
		tst.w	$1A(a0)
		beq.w	locret_166F4
		move.w	#$100,$20(a6)
		cmpi.w	#-$1000,$1A(a0)
		bgt.s	loc_167EA
		move.w	#-$1000,$1A(a0)

loc_167EA:
		move.w	#$39,d0
		jmp	(Play_Sound_2).l
; End of function sub_166EE

; ---------------------------------------------------------------------------

Knux_Stand_Path:
		bsr.w	Player_Spindash
		bsr.w	Knux_Jump
		bsr.w	sub_11DA6
		bsr.w	Knux_InputAcceleration_Path
		bsr.w	Player_Spin
		bsr.w	Player_Check_Screen_Boundaries
		jsr	(MoveSprite_TestGravity2).l
		bsr.w	Call_Player_AnglePos
		bsr.w	sub_11E2A
		tst.b	($FFFFF664).w
		beq.s	locret_1684A
		bsr.w	sub_F846
		tst.w	d1
		bmi.w	Kill_Character
		movem.l	a4-a6,-(sp)
		bsr.w	sub_FD9A
		tst.w	d1
		bpl.s	loc_1683A
		sub.w	d1,$10(a0)

loc_1683A:
		bsr.w	sub_FA7A
		tst.w	d1
		bpl.s	loc_16846
		add.w	d1,$10(a0)

loc_16846:
		movem.l	(sp)+,a4-a6

locret_1684A:
		rts
; ---------------------------------------------------------------------------

Knux_Stand_Freespace:
		tst.b	$2F(a0)
		bne.s	loc_1687C
		bsr.w	Knux_JumpHeight
		bsr.w	sub_17680
		bsr.w	Player_Check_Screen_Boundaries
		jsr	(MoveSprite_TestGravity).l
		btst	#6,$2A(a0)
		beq.s	loc_16872
		subi.w	#$28,$1A(a0)

loc_16872:
		bsr.w	sub_11E8C
		bsr.w	sub_11EEC
		rts
; ---------------------------------------------------------------------------

loc_1687C:
		bsr.w	sub_16FF6
		bsr.w	Player_Check_Screen_Boundaries
		jsr	(MoveSprite_TestGravity2).l
		bsr.w	sub_16890

locret_1688E:
		rts

; =============== S U B R O U T I N E =======================================


sub_16890:
		move.b	$2F(a0),d0
		beq.s	locret_1688E
		cmpi.b	#2,d0
		beq.w	loc_16A8E
		cmpi.b	#3,d0
		beq.w	loc_16B06
		cmpi.b	#4,d0
		beq.w	loc_16BB6
		cmpi.b	#5,d0
		beq.w	loc_16F6C
		bsr.w	sub_1793E
		btst	#1,($FFFFF74E).w
		beq.s	loc_1690E
		btst	#5,($FFFFF74E).w
		bne.w	loc_1696C
		move.b	($FFFFF602).w,d0
		andi.b	#$70,d0
		bne.s	loc_1690A
		move.b	#2,$2F(a0)
		move.b	#$21,$20(a0)
		bclr	#0,$2A(a0)
		tst.w	$18(a0)
		bpl.s	loc_168F4
		bset	#0,$2A(a0)

loc_168F4:
		asr	$18(a0)
		asr	$18(a0)
		move.b	$44(a0),$1E(a0)
		move.b	$45(a0),$1F(a0)
		rts
; ---------------------------------------------------------------------------

loc_1690A:
		bra.w	sub_16FA8
; ---------------------------------------------------------------------------

loc_1690E:
		bclr	#0,$2A(a0)
		tst.w	$18(a0)
		bpl.s	loc_16920
		bset	#0,$2A(a0)

loc_16920:
		move.b	$26(a0),d0
		addi.b	#$20,d0
		andi.b	#$C0,d0
		beq.s	loc_1693E
		move.w	$1C(a0),$18(a0)
		move.w	#0,$1A(a0)
		bra.w	sub_17B24
; ---------------------------------------------------------------------------

loc_1693E:
		move.b	#3,$2F(a0)
		move.b	#-$34,$22(a0)
		move.b	#$7F,$24(a0)
		move.b	#0,$23(a0)
		cmpi.b	#$C,$2C(a0)
		bcs.s	locret_1696A
		move.b	#6,5(a6)
		move.b	#$15,$22(a6)

locret_1696A:
		rts
; ---------------------------------------------------------------------------

loc_1696C:
		tst.b	($FFFFF74F).w
		bmi.w	loc_16A6E
		move.b	$47(a0),d5
		move.b	$25(a0),d0
		addi.b	#$40,d0
		bpl.s	loc_16996
		bset	#0,$2A(a0)
		bsr.w	sub_FCCA
		or.w	d0,d1
		bne.s	loc_16A00
		addq.w	#1,$10(a0)
		bra.s	loc_169A6
; ---------------------------------------------------------------------------

loc_16996:
		bclr	#0,$2A(a0)
		bsr.w	sub_F9BA
		or.w	d0,d1
		bne.w	loc_16A58

loc_169A6:

		moveq	#$4A,d0
		tst.b	($FFFFFE19).w
		bpl.s	loc_169C2
		cmpi.w	#$480,$1C(a0)
		bcs.s	loc_169C2
		move.w	#$14,($FFFFEF66).w
		bsr.w	sub_104EA
		moveq	#$49,d0

loc_169C2:

		jsr	(Play_Sound_2).l
		move.w	#0,$1C(a0)
		move.w	#0,$18(a0)
		move.w	#0,$1A(a0)
		move.b	#4,$2F(a0)
		move.b	#-$49,$22(a0)
		move.b	#$7F,$24(a0)
		move.b	#0,$23(a0)
		move.b	#3,$25(a0)
		move.w	$10(a0),$12(a0)
		rts
; ---------------------------------------------------------------------------

loc_16A00:
		move.w	$10(a0),d3
		move.b	$1E(a0),d0
		ext.w	d0
		sub.w	d0,d3
		subq.w	#1,d3
		tst.b	($FFFFF7C6).w
		bne.s	loc_16A34

loc_16A14:
		move.w	$14(a0),d2
		subi.w	#$B,d2
		jsr	(sub_F8A6).l
		tst.w	d1
		bmi.s	loc_16A6E
		cmpi.w	#$C,d1
		bcc.s	loc_16A6E
		add.w	d1,$14(a0)
		bra.w	loc_169A6
; ---------------------------------------------------------------------------

loc_16A34:

		move.w	$14(a0),d2
		addi.w	#$B,d2
		eori.w	#$F,d2
		jsr	(sub_FC5C).l
		tst.w	d1
		bmi.s	loc_16A6E
		cmpi.w	#$C,d1
		bcc.s	loc_16A6E
		sub.w	d1,$14(a0)
		bra.w	loc_169A6
; ---------------------------------------------------------------------------

loc_16A58:
		move.w	$10(a0),d3
		move.b	$1E(a0),d0
		ext.w	d0
		add.w	d0,d3
		addq.w	#1,d3
		tst.b	($FFFFF7C6).w
		bne.s	loc_16A34
		bra.s	loc_16A14
; ---------------------------------------------------------------------------

loc_16A6E:

		move.b	#2,$2F(a0)
		move.b	#$21,$20(a0)
		move.b	$44(a0),$1E(a0)
		move.b	$45(a0),$1F(a0)
		bset	#1,($FFFFF74E).w
		rts
; ---------------------------------------------------------------------------

loc_16A8E:
		bsr.w	sub_17680
		addi.w	#$38,$1A(a0)
		btst	#6,$2A(a0)
		beq.s	loc_16AA6
		subi.w	#$28,$1A(a0)

loc_16AA6:
		bsr.w	sub_1793E
		btst	#1,($FFFFF74E).w
		bne.s	locret_16B04
		move.w	#0,$1C(a0)
		move.w	#0,$18(a0)
		move.w	#0,$1A(a0)
		move.b	$1E(a0),d0
		sub.b	$44(a0),d0
		ext.w	d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_16AD6
		neg.w	d0

loc_16AD6:
		add.w	d0,$14(a0)
		moveq	#$4C,d0
		jsr	(Play_Sound_2).l
		move.b	$26(a0),d0
		addi.b	#$20,d0
		andi.b	#$C0,d0
		beq.s	loc_16AF4
		bra.w	sub_17B24
; ---------------------------------------------------------------------------

loc_16AF4:
		bsr.w	sub_17B24
		move.w	#$F,$32(a0)
		move.b	#$23,$20(a0)

locret_16B04:
		rts
; ---------------------------------------------------------------------------

loc_16B06:
		move.b	($FFFFF602).w,d0
		andi.b	#$70,d0
		beq.s	loc_16B2A
		tst.w	$18(a0)
		bpl.s	loc_16B22
		addi.w	#$20,$18(a0)
		bmi.s	loc_16B20
		bra.s	loc_16B2A
; ---------------------------------------------------------------------------

loc_16B20:
		bra.s	loc_16B64
; ---------------------------------------------------------------------------

loc_16B22:
		subi.w	#$20,$18(a0)
		bpl.s	loc_16B64

loc_16B2A:

		move.w	#0,$1C(a0)
		move.w	#0,$18(a0)
		move.w	#0,$1A(a0)
		move.b	$1E(a0),d0
		sub.b	$44(a0),d0
		ext.w	d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_16B4E
		neg.w	d0

loc_16B4E:
		add.w	d0,$14(a0)
		bsr.w	sub_17B24
		move.w	#$F,$32(a0)
		move.b	#$22,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_16B64:

		bsr.w	sub_1793E
		bsr.w	sub_11FD6
		cmpi.w	#$E,d1
		bge.s	loc_16B96
		tst.b	($FFFFF7C6).w
		beq.s	loc_16B7A
		neg.w	d1

loc_16B7A:
		add.w	d1,$14(a0)
		move.b	d3,$26(a0)
		move.b	($FFFFFE05).w,d0
		andi.b	#7,d0
		bne.s	locret_16B94
		moveq	#$7E,d0
		jsr	(Play_Sound_2).l

locret_16B94:
		rts
; ---------------------------------------------------------------------------

loc_16B96:
		move.b	#2,$2F(a0)
		move.b	#$21,$20(a0)
		move.b	$44(a0),$1E(a0)
		move.b	$45(a0),$1F(a0)
		bset	#1,($FFFFF74E).w
		rts
; ---------------------------------------------------------------------------

loc_16BB6:
		tst.b	($FFFFF74F).w
		bmi.w	loc_16ED2
		move.w	$10(a0),d0
		cmp.w	$12(a0),d0
		bne.w	loc_16ED2
		btst	#3,$2A(a0)
		bne.w	loc_16ED2
		move.w	#0,$1C(a0)
		move.w	#0,$18(a0)
		move.w	#0,$1A(a0)
		move.l	($FFFFF7B4).w,($FFFFF796).w
		cmpi.b	#$D,$47(a0)
		beq.s	loc_16BFA
		move.l	($FFFFF7B8).w,($FFFFF796).w

loc_16BFA:
		move.b	$47(a0),d5
		moveq	#0,d1
		btst	#0,($FFFFF602).w
		beq.w	loc_16D10
		tst.b	($FFFFF7C6).w
		bne.w	loc_16DA8
		move.w	$14(a0),d2
		subi.w	#$B,d2
		bsr.w	sub_16F4E
		cmpi.w	#4,d1
		bge.w	loc_16EBA
		tst.w	d1
		bne.w	loc_16E60
		move.b	$47(a0),d5
		move.w	$14(a0),d2
		subq.w	#8,d2
		move.w	$10(a0),d3
		bsr.w	sub_FBEE
		tst.w	d1
		bpl.s	loc_16C4C
		sub.w	d1,$14(a0)
		moveq	#1,d1
		bra.w	loc_16E10
; ---------------------------------------------------------------------------

loc_16C4C:
		subq.w	#1,$14(a0)
		tst.b	($FFFFFE19).w
		beq.s	loc_16C5A
		subq.w	#1,$14(a0)

loc_16C5A:
		moveq	#1,d1
		move.w	($FFFFEE18).w,d0
		cmpi.w	#-$100,d0
		beq.w	loc_16E10
		addi.w	#$10,d0
		cmp.w	$14(a0),d0
		ble.w	loc_16E10
		move.w	d0,$14(a0)
		bra.w	loc_16E10
; ---------------------------------------------------------------------------

loc_16C7C:
		cmpi.b	#$BD,$22(a0)
		bne.s	loc_16C9E
		move.b	#$B7,$22(a0)
		subq.w	#3,$14(a0)
		subq.w	#3,$10(a0)
		btst	#0,$2A(a0)
		beq.s	loc_16C9E
		addq.w	#6,$10(a0)

loc_16C9E:

		move.w	$14(a0),d2
		subi.w	#$B,d2
		bsr.w	sub_16F4E
		tst.w	d1
		bne.w	loc_16ED2
		move.b	$46(a0),d5
		move.w	$14(a0),d2
		subi.w	#9,d2
		move.w	$10(a0),d3
		bsr.w	sub_FBEE
		tst.w	d1
		bpl.s	loc_16CFC
		sub.w	d1,$14(a0)
		move.b	($FFFFF768).w,d0
		addi.b	#$40,d0
		neg.b	d0
		subi.b	#$40,d0
		move.b	d0,$26(a0)
		move.w	#0,$1C(a0)
		move.w	#0,$18(a0)
		move.w	#0,$1A(a0)
		bsr.w	sub_17B24
		move.b	#5,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_16CFC:
		subq.w	#1,$14(a0)
		tst.b	($FFFFFE19).w
		beq.s	loc_16D0A
		subq.w	#1,$14(a0)

loc_16D0A:
		moveq	#-1,d1
		bra.w	loc_16E10
; ---------------------------------------------------------------------------

loc_16D10:
		btst	#1,($FFFFF602).w
		beq.w	loc_16E10
		tst.b	($FFFFF7C6).w
		bne.w	loc_16C7C
		cmpi.b	#$BD,$22(a0)
		bne.s	loc_16D44
		move.b	#$B7,$22(a0)
		addq.w	#3,$14(a0)
		subq.w	#3,$10(a0)
		btst	#0,$2A(a0)
		beq.s	loc_16D44
		addq.w	#6,$10(a0)

loc_16D44:

		move.w	$14(a0),d2
		addi.w	#$B,d2
		bsr.w	sub_16F4E
		tst.w	d1
		bne.w	loc_16ED2
		move.b	$46(a0),d5
		move.w	$14(a0),d2
		addi.w	#9,d2
		move.w	$10(a0),d3
		bsr.w	sub_F828
		tst.w	d1
		bpl.s	loc_16D96

loc_16D6E:
		add.w	d1,$14(a0)
		move.b	($FFFFF768).w,$26(a0)
		move.w	#0,$1C(a0)
		move.w	#0,$18(a0)
		move.w	#0,$1A(a0)
		bsr.w	sub_17B24
		move.b	#5,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_16D96:
		addq.w	#1,$14(a0)
		tst.b	($FFFFFE19).w
		beq.s	loc_16DA4
		addq.w	#1,$14(a0)

loc_16DA4:
		moveq	#-1,d1
		bra.s	loc_16E10
; ---------------------------------------------------------------------------

loc_16DA8:
		move.w	$14(a0),d2
		addi.w	#$B,d2
		bsr.w	sub_16F4E
		cmpi.w	#4,d1
		bge.w	loc_16EBA
		tst.w	d1
		bne.w	loc_16E60
		move.b	$47(a0),d5
		move.w	$14(a0),d2
		addq.w	#8,d2
		move.w	$10(a0),d3
		bsr.w	sub_F828
		tst.w	d1
		bpl.s	loc_16DE2
		add.w	d1,$14(a0)
		moveq	#1,d1
		bra.w	loc_16E10
; ---------------------------------------------------------------------------

loc_16DE2:
		addq.w	#1,$14(a0)
		tst.b	($FFFFFE19).w
		beq.s	loc_16DF0
		addq.w	#1,$14(a0)

loc_16DF0:
		moveq	#1,d1
		cmpi.w	#-$100,($FFFFEE18).w
		beq.w	loc_16E10
		move.w	($FFFFEE1A).w,d0
		addi.w	#$D0,d0
		cmp.w	$14(a0),d0
		bge.w	loc_16E10
		move.w	d0,$14(a0)

loc_16E10:

		move.b	($FFFFF602).w,d0
		andi.b	#3,d0
		bne.s	loc_16E34
		move.b	$46(a0),d5
		move.w	$14(a0),d2
		addi.w	#9,d2
		move.w	$10(a0),d3
		bsr.w	sub_F828
		tst.w	d1
		bmi.w	loc_16D6E

loc_16E34:
		tst.w	d1
		beq.s	loc_16E60
		subq.b	#1,$25(a0)
		bpl.s	loc_16E60
		move.b	#3,$25(a0)
		add.b	$22(a0),d1
		cmpi.b	#$B7,d1
		bcc.s	loc_16E52
		move.b	#$BC,d1

loc_16E52:
		cmpi.b	#$BC,d1
		bls.s	loc_16E5C
		move.b	#$B7,d1

loc_16E5C:
		move.b	d1,$22(a0)

loc_16E60:

		move.b	#$20,$24(a0)
		move.b	#0,$23(a0)
		move.w	($FFFFF602).w,d0
		andi.w	#$70,d0
		beq.s	locret_16EB8
		move.w	#-$380,$1A(a0)
		move.w	#$400,$18(a0)
		bchg	#0,$2A(a0)
		bne.s	loc_16E8E
		neg.w	$18(a0)

loc_16E8E:
		bset	#1,$2A(a0)
		move.b	#1,$40(a0)
		move.b	#$E,$1E(a0)
		move.b	#7,$1F(a0)
		move.b	#2,$20(a0)
		bset	#2,$2A(a0)
		move.b	#0,$2F(a0)

locret_16EB8:
		rts
; ---------------------------------------------------------------------------

loc_16EBA:

		move.b	#5,$2F(a0)
		cmpi.b	#-$43,$22(a0)
		beq.s	locret_16ED0
		move.b	#0,$25(a0)
		bsr.s	sub_16EFE

locret_16ED0:
		rts
; ---------------------------------------------------------------------------

loc_16ED2:

		move.b	#2,$2F(a0)
		move.w	#$2121,$20(a0)
		move.b	#$CB,$22(a0)
		move.b	#7,$24(a0)
		move.b	#1,$23(a0)
		move.b	$44(a0),$1E(a0)
		move.b	$45(a0),$1F(a0)
		rts
; End of function sub_16890


; =============== S U B R O U T I N E =======================================


sub_16EFE:

		moveq	#0,d0
		move.b	$25(a0),d0
		lea	byte_16F3E(pc,d0.w),a1
		move.b	(a1)+,$22(a0)
		move.b	(a1)+,d0
		ext.w	d0
		btst	#0,$2A(a0)
		beq.s	loc_16F1A
		neg.w	d0

loc_16F1A:
		add.w	d0,$10(a0)
		move.b	(a1)+,d1
		ext.w	d1
		tst.b	($FFFFF7C6).w
		beq.s	loc_16F2A
		neg.w	d1

loc_16F2A:
		add.w	d1,$14(a0)
		move.b	(a1)+,$24(a0)
		addq.b	#4,$25(a0)
		move.b	#0,$23(a0)
		rts
; End of function sub_16EFE

; ---------------------------------------------------------------------------
byte_16F3E:	dc.b  $BD,   3,	$FD,   6, $BE,	 8, $F6,   6, $BF, $F8,	$F4,   6, $D2,	 8, $FB,   6

; =============== S U B R O U T I N E =======================================


sub_16F4E:

		move.b	$47(a0),d5
		btst	#0,$2A(a0)
		bne.s	loc_16F62
		move.w	$10(a0),d3
		bra.w	loc_FAA4
; ---------------------------------------------------------------------------

loc_16F62:
		move.w	$10(a0),d3
		subq.w	#1,d3
		bra.w	loc_FDC8
; End of function sub_16F4E

; ---------------------------------------------------------------------------

loc_16F6C:
		tst.b	$24(a0)
		bne.s	locret_16FA6
		bsr.w	sub_16EFE
		cmpi.b	#$10,$25(a0)
		bne.s	locret_16FA6
		move.w	#0,$1C(a0)
		move.w	#0,$18(a0)
		move.w	#0,$1A(a0)
		btst	#0,$2A(a0)
		beq.s	loc_16F9C
		subq.w	#1,$10(a0)

loc_16F9C:
		bsr.w	sub_17B24
		move.b	#5,$20(a0)

locret_16FA6:

		rts

; =============== S U B R O U T I N E =======================================


sub_16FA8:
					; Knux_JumpHeight+DEp
		move.b	#$20,$24(a0)
		move.b	#0,$23(a0)
		move.w	#$2020,$20(a0)
		bclr	#5,$2A(a0)
		bclr	#0,$2A(a0)
		moveq	#0,d0
		move.b	$25(a0),d0
		addi.b	#$10,d0
		lsr.w	#5,d0
		move.b	byte_16FEE(pc,d0.w),d1
		move.b	d1,$22(a0)
		cmpi.b	#$C4,d1
		bne.s	locret_16FEC
		bset	#0,$2A(a0)
		move.b	#$C0,$22(a0)

locret_16FEC:
		rts
; End of function sub_16FA8

; ---------------------------------------------------------------------------
byte_16FEE:	dc.b $C0
		dc.b $C1
		dc.b $C2
		dc.b $C3
		dc.b $C4
		dc.b $C3
		dc.b $C2
		dc.b $C1

; =============== S U B R O U T I N E =======================================


sub_16FF6:
		cmpi.b	#1,$2F(a0)
		bne.w	loc_170B4
		move.w	$1C(a0),d0
		cmpi.w	#$400,d0
		bcc.s	loc_1700E
		addq.w	#8,d0
		bra.s	loc_17028
; ---------------------------------------------------------------------------

loc_1700E:
		cmpi.w	#$1800,d0
		bcc.s	loc_17028
		move.b	$25(a0),d1
		andi.b	#$7F,d1
		bne.s	loc_17028
		addq.w	#4,d0
		tst.b	($FFFFFE19).w
		beq.s	loc_17028
		addq.w	#8,d0

loc_17028:

		move.w	d0,$1C(a0)
		move.b	$25(a0),d0
		btst	#2,($FFFFF602).w
		beq.s	loc_17048
		cmpi.b	#$80,d0
		beq.s	loc_17048
		tst.b	d0
		bpl.s	loc_17044
		neg.b	d0

loc_17044:
		addq.b	#2,d0
		bra.s	loc_17066
; ---------------------------------------------------------------------------

loc_17048:

		btst	#3,($FFFFF602).w
		beq.s	loc_1705C
		tst.b	d0
		beq.s	loc_1705C
		bmi.s	loc_17058
		neg.b	d0

loc_17058:
		addq.b	#2,d0
		bra.s	loc_17066
; ---------------------------------------------------------------------------

loc_1705C:

		move.b	d0,d1
		andi.b	#$7F,d1
		beq.s	loc_17066
		addq.b	#2,d0

loc_17066:

		move.b	d0,$25(a0)
		move.b	$25(a0),d0

loc_1706E:
		jsr	(GetSineCosine).l
		muls.w	$1C(a0),d1
		asr.l	#8,d1
		move.w	d1,$18(a0)
		cmpi.w	#$80,$1A(a0)
		blt.s	loc_1708E
		subi.w	#$20,$1A(a0)
		bra.s	loc_17094
; ---------------------------------------------------------------------------

loc_1708E:
		addi.w	#$20,$1A(a0)

loc_17094:
		move.w	($FFFFEE18).w,d0
		cmpi.w	#-$100,d0
		beq.w	loc_170B4
		addi.w	#$10,d0
		cmp.w	$14(a0),d0
		ble.w	loc_170B4
		asr	$18(a0)
		asr	$1C(a0)

loc_170B4:

		cmpi.w	#$60,(a5)
		beq.s	locret_170C0
		bcc.s	loc_170BE
		addq.w	#4,(a5)

loc_170BE:
		subq.w	#2,(a5)

locret_170C0:
		rts
; End of function sub_16FF6

; ---------------------------------------------------------------------------

Knux_Spin_Path:
		tst.b	$3D(a0)
		bne.s	loc_170CC
		bsr.w	Knux_Jump

loc_170CC:
		bsr.w	sub_11DEE
		bsr.w	sub_1753A
		bsr.w	Player_Check_Screen_Boundaries
		jsr	(MoveSprite_TestGravity2).l
		bsr.w	Call_Player_AnglePos
		bsr.w	sub_11E2A
		tst.b	($FFFFF664).w
		beq.s	locret_17116
		bsr.w	sub_F846
		tst.w	d1
		bmi.w	Kill_Character
		movem.l	a4-a6,-(sp)
		bsr.w	sub_FD9A
		tst.w	d1
		bpl.s	loc_17106
		sub.w	d1,$10(a0)

loc_17106:
		bsr.w	sub_FA7A
		tst.w	d1
		bpl.s	loc_17112
		add.w	d1,$10(a0)

loc_17112:
		movem.l	(sp)+,a4-a6

locret_17116:
		rts
; ---------------------------------------------------------------------------

Knux_Spin_Freespace:
		bsr.w	Knux_JumpHeight
		bsr.w	sub_17680
		bsr.w	Player_Check_Screen_Boundaries
		jsr	(MoveSprite_TestGravity).l
		btst	#6,$2A(a0)
		beq.s	loc_17138
		subi.w	#$28,$1A(a0)

loc_17138:
		bsr.w	sub_11E8C
		bsr.w	sub_11EEC
		rts

; =============== S U B R O U T I N E =======================================


Knux_InputAcceleration_Path:
		move.w	(a4),d6
		move.w	2(a4),d5
		move.w	4(a4),d4
		tst.b	$2B(a0)
		bmi.w	loc_17364
		tst.w	$32(a0)
		bne.w	loc_1731C
		btst	#2,($FFFFF602).w
		beq.s	loc_17168
		bsr.w	sub_17428

loc_17168:
		btst	#3,($FFFFF602).w
		beq.s	loc_17174
		bsr.w	sub_174B4

loc_17174:
		move.b	$26(a0),d0
		addi.b	#$20,d0
		andi.b	#$C0,d0
		bne.w	loc_1731C
		tst.w	$1C(a0)
		bne.w	loc_1731C
		bclr	#5,$2A(a0)
		move.b	#5,$20(a0)
		btst	#3,$2A(a0)
		beq.w	loc_1722C
		movea.w	$42(a0),a1
		tst.b	$2A(a1)
		bmi.w	loc_172A8
		moveq	#0,d1
		move.b	7(a1),d1
		move.w	d1,d2
		add.w	d2,d2
		subq.w	#2,d2
		add.w	$10(a0),d1
		sub.w	$10(a1),d1
		cmpi.w	#2,d1
		blt.s	loc_171FE
		cmp.w	d2,d1
		bge.s	loc_171D0
		bra.w	loc_172A8
; ---------------------------------------------------------------------------

loc_171D0:
		btst	#0,$2A(a0)
		bne.s	loc_171E2
		move.b	#6,$20(a0)
		bra.w	loc_1731C
; ---------------------------------------------------------------------------

loc_171E2:
		bclr	#0,$2A(a0)
		move.b	#0,$24(a0)
		move.b	#4,$23(a0)
		move.w	#$606,$20(a0)
		bra.w	loc_1731C
; ---------------------------------------------------------------------------

loc_171FE:
		btst	#0,$2A(a0)
		beq.s	loc_17210
		move.b	#6,$20(a0)
		bra.w	loc_1731C
; ---------------------------------------------------------------------------

loc_17210:
		bset	#0,$2A(a0)
		move.b	#0,$24(a0)
		move.b	#4,$23(a0)
		move.w	#$606,$20(a0)
		bra.w	loc_1731C
; ---------------------------------------------------------------------------

loc_1722C:
		move.w	$10(a0),d3
		bsr.w	sub_12006
		cmpi.w	#$C,d1
		blt.w	loc_172A8
		cmpi.b	#3,$3A(a0)
		bne.s	loc_17272
		btst	#0,$2A(a0)
		bne.s	loc_17256
		move.b	#6,$20(a0)
		bra.w	loc_1731C
; ---------------------------------------------------------------------------

loc_17256:
		bclr	#0,$2A(a0)
		move.b	#0,$24(a0)
		move.b	#4,$23(a0)
		move.w	#$606,$20(a0)
		bra.w	loc_1731C
; ---------------------------------------------------------------------------

loc_17272:
		cmpi.b	#3,$3B(a0)
		bne.s	loc_172A8
		btst	#0,$2A(a0)
		beq.s	loc_1728C
		move.b	#6,$20(a0)
		bra.w	loc_1731C
; ---------------------------------------------------------------------------

loc_1728C:
		bset	#0,$2A(a0)
		move.b	#0,$24(a0)
		move.b	#4,$23(a0)
		move.w	#$606,$20(a0)
		bra.w	loc_1731C
; ---------------------------------------------------------------------------

loc_172A8:
					; Knux_InputAcceleration_Path+8Aj ...
		btst	#1,($FFFFF602).w
		beq.s	loc_172E2
		move.b	#8,$20(a0)
		addq.b	#1,$39(a0)
		cmpi.b	#$78,$39(a0)
		bcs.s	loc_17322
		move.b	#$78,$39(a0)
		tst.b	($FFFFF7C6).w
		bne.s	loc_172D8
		cmpi.w	#8,(a5)
		beq.s	loc_1732E
		subq.w	#2,(a5)
		bra.s	loc_1732E
; ---------------------------------------------------------------------------

loc_172D8:
		cmpi.w	#$D8,(a5)
		beq.s	loc_1732E
		addq.w	#2,(a5)
		bra.s	loc_1732E
; ---------------------------------------------------------------------------

loc_172E2:
		btst	#0,($FFFFF602).w
		beq.s	loc_1731C
		move.b	#7,$20(a0)
		addq.b	#1,$39(a0)
		cmpi.b	#$78,$39(a0)
		bcs.s	loc_17322
		move.b	#$78,$39(a0)
		tst.b	($FFFFF7C6).w
		bne.s	loc_17312
		cmpi.w	#$C8,(a5)
		beq.s	loc_1732E
		addq.w	#2,(a5)
		bra.s	loc_1732E
; ---------------------------------------------------------------------------

loc_17312:
		cmpi.w	#$18,(a5)
		beq.s	loc_1732E
		subq.w	#2,(a5)
		bra.s	loc_1732E
; ---------------------------------------------------------------------------

loc_1731C:
					; Knux_InputAcceleration_Path+3Ej ...
		move.b	#0,$39(a0)

loc_17322:
					; Knux_InputAcceleration_Path+1B8j
		cmpi.w	#$60,(a5)
		beq.s	loc_1732E
		bcc.s	loc_1732C
		addq.w	#4,(a5)

loc_1732C:
		subq.w	#2,(a5)

loc_1732E:
					; Knux_InputAcceleration_Path+194j ...
		tst.b	($FFFFFE19).w
		beq.s	loc_17338
		move.w	#$C,d5

loc_17338:
		move.b	($FFFFF602).w,d0
		andi.b	#$C,d0
		bne.s	loc_17364
		move.w	$1C(a0),d0
		beq.s	loc_17364
		bmi.s	loc_17358
		sub.w	d5,d0
		bcc.s	loc_17352
		move.w	#0,d0

loc_17352:
		move.w	d0,$1C(a0)
		bra.s	loc_17364
; ---------------------------------------------------------------------------

loc_17358:
		add.w	d5,d0
		bcc.s	loc_17360
		move.w	#0,d0

loc_17360:
		move.w	d0,$1C(a0)

loc_17364:
					; Knux_InputAcceleration_Path+1FEj ...
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		muls.w	$1C(a0),d1
		asr.l	#8,d1
		move.w	d1,$18(a0)
		muls.w	$1C(a0),d0
		asr.l	#8,d0
		move.w	d0,$1A(a0)

loc_17382:
		btst	#6,$2E(a0)
		bne.w	locret_17426
		move.b	$26(a0),d0
		andi.b	#$3F,d0
		beq.s	loc_173A2
		move.b	$26(a0),d0
		addi.b	#$40,d0
		bmi.w	locret_17426

loc_173A2:
		move.b	#$40,d1
		tst.w	$1C(a0)
		beq.s	locret_17426
		bmi.s	loc_173B0
		neg.w	d1

loc_173B0:
		move.b	$26(a0),d0
		add.b	d1,d0
		move.w	d0,-(sp)
		bsr.w	sub_F61C
		move.w	(sp)+,d0
		tst.w	d1
		bpl.s	locret_17426
		asl.w	#8,d1
		cmpi.b	#8,($FFFFFE10).w
		bne.s	loc_173D2
		tst.b	d0
		bpl.s	loc_173D2
		subq.b	#1,d0

loc_173D2:
					; Knux_InputAcceleration_Path+28Cj
		addi.b	#$20,d0
		andi.b	#$C0,d0
		beq.s	loc_17422
		cmpi.b	#$40,d0
		beq.s	loc_17408
		cmpi.b	#$80,d0
		beq.s	loc_17402
		add.w	d1,$18(a0)
		move.w	#0,$1C(a0)
		btst	#0,$2A(a0)
		bne.s	locret_17400
		bset	#5,$2A(a0)

locret_17400:
					; Knux_InputAcceleration_Path+2D6j
		rts
; ---------------------------------------------------------------------------

loc_17402:
		sub.w	d1,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_17408:
		sub.w	d1,$18(a0)
		move.w	#0,$1C(a0)
		btst	#0,$2A(a0)
		beq.s	locret_17400
		bset	#5,$2A(a0)
		rts
; ---------------------------------------------------------------------------

loc_17422:
		add.w	d1,$1A(a0)

locret_17426:
					; Knux_InputAcceleration_Path+25Cj ...
		rts
; End of function Knux_InputAcceleration_Path


; =============== S U B R O U T I N E =======================================


sub_17428:
		move.w	$1C(a0),d0
		beq.s	loc_17430
		bpl.s	loc_17462

loc_17430:
		bset	#0,$2A(a0)
		bne.s	loc_17444
		bclr	#5,$2A(a0)
		move.b	#1,$21(a0)

loc_17444:
		sub.w	d5,d0
		move.w	d6,d1
		neg.w	d1
		cmp.w	d1,d0
		bgt.s	loc_17456
		add.w	d5,d0
		cmp.w	d1,d0
		ble.s	loc_17456
		move.w	d1,d0

loc_17456:

		move.w	d0,$1C(a0)
		move.b	#0,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_17462:
		sub.w	d4,d0
		bcc.s	loc_1746A
		move.w	#-$80,d0

loc_1746A:
		move.w	d0,$1C(a0)
		move.b	$26(a0),d0
		addi.b	#$20,d0
		andi.b	#$C0,d0
		bne.s	locret_174B2
		cmpi.w	#$400,d0
		blt.s	locret_174B2
		tst.b	$2D(a0)
		bmi.s	locret_174B2
		move.w	#$36,d0
		jsr	(Play_Sound_2).l
		move.b	#$D,$20(a0)
		bclr	#0,$2A(a0)
		cmpi.b	#$C,$2C(a0)
		bcs.s	locret_174B2
		move.b	#6,5(a6)
		move.b	#$15,$22(a6)

locret_174B2:

		rts
; End of function sub_17428


; =============== S U B R O U T I N E =======================================


sub_174B4:
		move.w	$1C(a0),d0
		bmi.s	loc_174E8
		bclr	#0,$2A(a0)
		beq.s	loc_174CE
		bclr	#5,$2A(a0)
		move.b	#1,$21(a0)

loc_174CE:
		add.w	d5,d0
		cmp.w	d6,d0
		blt.s	loc_174DC
		sub.w	d5,d0
		cmp.w	d6,d0
		bge.s	loc_174DC
		move.w	d6,d0

loc_174DC:

		move.w	d0,$1C(a0)
		move.b	#0,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_174E8:
		add.w	d4,d0
		bcc.s	loc_174F0
		move.w	#$80,d0

loc_174F0:
		move.w	d0,$1C(a0)
		move.b	$26(a0),d0
		addi.b	#$20,d0
		andi.b	#$C0,d0
		bne.s	locret_17538
		cmpi.w	#$FC00,d0
		bgt.s	locret_17538
		tst.b	$2D(a0)
		bmi.s	locret_17538
		move.w	#$36,d0
		jsr	(Play_Sound_2).l
		move.b	#$D,$20(a0)
		bset	#0,$2A(a0)
		cmpi.b	#$C,$2C(a0)
		bcs.s	locret_17538
		move.b	#6,5(a6)
		move.b	#$15,$22(a6)

locret_17538:

		rts
; End of function sub_174B4


; =============== S U B R O U T I N E =======================================


sub_1753A:
		move.w	(a4),d6
		asl.w	#1,d6
		move.w	2(a4),d5
		asr.w	#1,d5
		tst.b	($FFFFFE19).w
		beq.s	loc_1754E
		move.w	#6,d5

loc_1754E:
		move.w	#$20,d4
		tst.b	$3D(a0)
		bmi.w	loc_175F8
		tst.b	$2B(a0)
		bmi.w	loc_175F8
		tst.w	$32(a0)
		bne.s	loc_17580
		btst	#2,($FFFFF602).w
		beq.s	loc_17574
		bsr.w	sub_1763A

loc_17574:
		btst	#3,($FFFFF602).w
		beq.s	loc_17580
		bsr.w	sub_1765E

loc_17580:

		move.w	$1C(a0),d0
		beq.s	loc_175A2
		bmi.s	loc_17596
		sub.w	d5,d0
		bcc.s	loc_17590
		move.w	#0,d0

loc_17590:
		move.w	d0,$1C(a0)
		bra.s	loc_175A2
; ---------------------------------------------------------------------------

loc_17596:
		add.w	d5,d0
		bcc.s	loc_1759E
		move.w	#0,d0

loc_1759E:
		move.w	d0,$1C(a0)

loc_175A2:

		move.w	$1C(a0),d0
		bpl.s	loc_175AA
		neg.w	d0

loc_175AA:
		cmpi.w	#$80,d0
		bcc.s	loc_175F8
		tst.b	$3D(a0)
		bne.s	loc_175E6
		bclr	#2,$2A(a0)
		move.b	$1E(a0),d0
		move.b	$44(a0),$1E(a0)
		move.b	$45(a0),$1F(a0)
		move.b	#5,$20(a0)
		sub.b	$44(a0),d0
		ext.w	d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_175E0
		neg.w	d0

loc_175E0:
		add.w	d0,$14(a0)
		bra.s	loc_175F8
; ---------------------------------------------------------------------------

loc_175E6:
		move.w	#$400,$1C(a0)
		btst	#0,$2A(a0)
		beq.s	loc_175F8
		neg.w	$1C(a0)

loc_175F8:

		cmpi.w	#$60,(a5)
		beq.s	loc_17604
		bcc.s	loc_17602
		addq.w	#4,(a5)

loc_17602:
		subq.w	#2,(a5)

loc_17604:
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		muls.w	$1C(a0),d0
		asr.l	#8,d0
		move.w	d0,$1A(a0)
		muls.w	$1C(a0),d1
		asr.l	#8,d1
		cmpi.w	#$1000,d1
		ble.s	loc_17628
		move.w	#$1000,d1

loc_17628:
		cmpi.w	#-$1000,d1
		bge.s	loc_17632
		move.w	#-$1000,d1

loc_17632:
		move.w	d1,$18(a0)
		bra.w	loc_17382
; End of function sub_1753A


; =============== S U B R O U T I N E =======================================


sub_1763A:
		move.w	$1C(a0),d0
		beq.s	loc_17642
		bpl.s	loc_17650

loc_17642:
		bset	#0,$2A(a0)
		move.b	#2,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_17650:
		sub.w	d4,d0
		bcc.s	loc_17658
		move.w	#-$80,d0

loc_17658:
		move.w	d0,$1C(a0)
		rts
; End of function sub_1763A


; =============== S U B R O U T I N E =======================================


sub_1765E:
		move.w	$1C(a0),d0
		bmi.s	loc_17672
		bclr	#0,$2A(a0)
		move.b	#2,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_17672:
		add.w	d4,d0
		bcc.s	loc_1767A
		move.w	#$80,d0

loc_1767A:
		move.w	d0,$1C(a0)
		rts
; End of function sub_1765E


; =============== S U B R O U T I N E =======================================


sub_17680:

		move.w	(a4),d6
		move.w	2(a4),d5
		asl.w	#1,d5
		btst	#4,$2A(a0)
		bne.s	loc_176D4
		move.w	$18(a0),d0
		btst	#2,($FFFFF602).w
		beq.s	loc_176B4
		bset	#0,$2A(a0)
		sub.w	d5,d0
		move.w	d6,d1
		neg.w	d1
		cmp.w	d1,d0
		bgt.s	loc_176B4
		add.w	d5,d0
		cmp.w	d1,d0
		ble.s	loc_176B4
		move.w	d1,d0

loc_176B4:

		btst	#3,($FFFFF602).w
		beq.s	loc_176D0
		bclr	#0,$2A(a0)
		add.w	d5,d0
		cmp.w	d6,d0
		blt.s	loc_176D0
		sub.w	d5,d0
		cmp.w	d6,d0
		bge.s	loc_176D0
		move.w	d6,d0

loc_176D0:

		move.w	d0,$18(a0)

loc_176D4:
		cmpi.w	#$60,(a5)
		beq.s	loc_176E0
		bcc.s	loc_176DE
		addq.w	#4,(a5)

loc_176DE:
		subq.w	#2,(a5)

loc_176E0:
		cmpi.w	#-$400,$1A(a0)
		bcs.s	locret_1770E
		move.w	$18(a0),d0
		move.w	d0,d1
		asr.w	#5,d1
		beq.s	locret_1770E
		bmi.s	loc_17702
		sub.w	d1,d0
		bcc.s	loc_176FC
		move.w	#0,d0

loc_176FC:
		move.w	d0,$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_17702:
		sub.w	d1,d0
		bcs.s	loc_1770A
		move.w	#0,d0

loc_1770A:
		move.w	d0,$18(a0)

locret_1770E:

		rts
; End of function sub_17680


; =============== S U B R O U T I N E =======================================


Knux_Jump:

		move.b	($FFFFF603).w,d0
		andi.b	#$70,d0
		beq.w	locret_177E0
		moveq	#0,d0
		move.b	$26(a0),d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_17732
		addi.b	#$40,d0
		neg.b	d0
		subi.b	#$40,d0

loc_17732:
		addi.b	#-$80,d0
		movem.l	a4-a6,-(sp)
		jsr	(sub_F72E).l
		movem.l	(sp)+,a4-a6
		cmpi.w	#6,d1
		blt.w	locret_177E0
		move.w	#$600,d2
		btst	#6,$2A(a0)
		beq.s	loc_1775C
		move.w	#$300,d2

loc_1775C:
		moveq	#0,d0
		move.b	$26(a0),d0
		subi.b	#$40,d0
		jsr	(GetSineCosine).l
		muls.w	d2,d1
		asr.l	#8,d1
		add.w	d1,$18(a0)
		muls.w	d2,d0
		asr.l	#8,d0
		add.w	d0,$1A(a0)
		bset	#1,$2A(a0)
		bclr	#5,$2A(a0)
		addq.l	#4,sp
		move.b	#1,$40(a0)
		clr.b	$3C(a0)
		move.w	#$62,d0
		jsr	(Play_Sound_2).l
		move.b	$44(a0),$1E(a0)
		move.b	$45(a0),$1F(a0)
		btst	#2,$2A(a0)
		bne.s	loc_177E2
		move.b	#$E,$1E(a0)
		move.b	#7,$1F(a0)
		move.b	#2,$20(a0)
		bset	#2,$2A(a0)
		move.b	$1E(a0),d0
		sub.b	$44(a0),d0
		ext.w	d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_177DC
		neg.w	d0

loc_177DC:
		sub.w	d0,$14(a0)

locret_177E0:
					; Knux_Jump+38j
		rts
; ---------------------------------------------------------------------------

loc_177E2:
		bset	#4,$2A(a0)
		rts
; End of function Knux_Jump


; =============== S U B R O U T I N E =======================================


Knux_JumpHeight:

		tst.b	$40(a0)
		beq.s	loc_17818
		move.w	#-$400,d1
		btst	#6,$2A(a0)
		beq.s	loc_17800
		move.w	#-$200,d1

loc_17800:
		cmp.w	$1A(a0),d1
		ble.w	Knux_Test_For_Glide
		move.b	($FFFFF602).w,d0
		andi.b	#$70,d0
		bne.s	locret_17816
		move.w	d1,$1A(a0)

locret_17816:
		rts
; ---------------------------------------------------------------------------

loc_17818:
		tst.b	$3D(a0)
		bne.s	locret_1782C
		cmpi.w	#-$FC0,$1A(a0)
		bge.s	locret_1782C
		move.w	#-$FC0,$1A(a0)

locret_1782C:
					; Knux_JumpHeight+3Aj
		rts
; ---------------------------------------------------------------------------

Knux_Test_For_Glide:
		tst.b	$2F(a0)
		bne.w	locret_178CC
		move.b	($FFFFF603).w,d0
		andi.b	#$70,d0
		beq.w	locret_178CC
		tst.b	($FFFFFE19).w
		bne.s	loc_1786C
		cmpi.b	#7,($FFFFFFB1).w
		bcc.s	loc_1785E
		cmpi.b	#7,($FFFFFFB0).w
		bcs.s	loc_1786C
		tst.b	($FFFFFFBA).w
		bne.s	loc_1786C

loc_1785E:
		cmpi.w	#$32,($FFFFFE20).w
		bcs.s	loc_1786C
		tst.b	($FFFFFE1E).w
		bne.s	loc_178CE

loc_1786C:
		bclr	#2,$2A(a0)
		move.b	#$A,$1E(a0)
		move.b	#$A,$1F(a0)
		bclr	#4,$2A(a0)
		move.b	#1,$2F(a0)
		addi.w	#$200,$1A(a0)
		bpl.s	loc_17898
		move.w	#0,$1A(a0)

loc_17898:
		moveq	#0,d1
		move.w	#$400,d0
		move.w	d0,$1C(a0)
		btst	#0,$2A(a0)
		beq.s	loc_178AE
		neg.w	d0
		moveq	#-$80,d1

loc_178AE:
		move.w	d0,$18(a0)
		move.b	d1,$25(a0)
		move.w	#0,$26(a0)
		move.b	#0,($FFFFF74E).w
		bset	#1,($FFFFF74E).w
		bsr.w	sub_16FA8

locret_178CC:
					; Knux_JumpHeight+54j
		rts
; ---------------------------------------------------------------------------

loc_178CE:
		move.b	#1,($FFFFF65F).w
		move.b	#$F,($FFFFF65E).w
		move.w	#$3C,($FFFFF670).w
		move.b	#-$7F,$2E(a0)
		move.b	#$1F,$20(a0)
		cmpi.b	#7,($FFFFFFB1).w
		bcs.s	loc_17904
		move.b	#-1,($FFFFFE19).w
		move.l	#Obj_HyperSonicKnux_Trail,($FFFFCBC0).w
		bra.s	loc_17912
; ---------------------------------------------------------------------------

loc_17904:
		move.b	#1,($FFFFFE19).w
		move.l	#Obj_SuperSonicKnux_Stars,($FFFFCBC0).w

loc_17912:
		move.w	#$800,(a4)
		move.w	#$18,2(a4)
		move.w	#$C0,4(a4)
		move.b	#0,$35(a0)
		bset	#1,$2B(a0)
		moveq	#-$61,d0
		jsr	(Play_Sound_2).l
		moveq	#$2C,d0
		jmp	(Play_Sound).l
; End of function Knux_JumpHeight


; =============== S U B R O U T I N E =======================================


sub_1793E:

		move.l	($FFFFF7B4).w,($FFFFF796).w
		cmpi.b	#$C,$46(a0)
		beq.s	loc_17952
		move.l	($FFFFF7B8).w,($FFFFF796).w

loc_17952:
		move.b	$47(a0),d5
		move.w	$18(a0),d1
		move.w	$1A(a0),d2
		jsr	(GetArcTan).l
		subi.b	#$20,d0
		andi.b	#$C0,d0
		cmpi.b	#$40,d0
		beq.w	loc_179DA
		cmpi.b	#$80,d0
		beq.w	loc_17A62
		cmpi.b	#$C0,d0
		beq.w	loc_17AB0
		bsr.w	sub_FD9A
		tst.w	d1
		bpl.s	loc_1799C
		sub.w	d1,$10(a0)
		move.w	#0,$18(a0)
		bset	#5,($FFFFF74E).w

loc_1799C:
		bsr.w	sub_FA7A
		tst.w	d1
		bpl.s	loc_179B4
		add.w	d1,$10(a0)
		move.w	#0,$18(a0)
		bset	#5,($FFFFF74E).w

loc_179B4:
		bsr.w	sub_11FD6
		tst.w	d1
		bpl.s	locret_179D8
		tst.b	($FFFFF7C6).w
		beq.s	loc_179C4
		neg.w	d1

loc_179C4:
		add.w	d1,$14(a0)
		move.b	d3,$26(a0)
		move.w	#0,$1A(a0)
		bclr	#1,($FFFFF74E).w

locret_179D8:
		rts
; ---------------------------------------------------------------------------

loc_179DA:
		bsr.w	sub_FD9A
		tst.w	d1
		bpl.s	loc_179F2
		sub.w	d1,$10(a0)
		move.w	#0,$18(a0)
		bset	#5,($FFFFF74E).w

loc_179F2:
		bsr.w	sub_11FEE
		tst.w	d1
		bpl.s	loc_17A36
		neg.w	d1
		cmpi.w	#$14,d1
		bcc.s	loc_17A1C
		tst.b	($FFFFF7C6).w
		beq.s	loc_17A0A
		neg.w	d1

loc_17A0A:
		add.w	d1,$14(a0)
		tst.w	$1A(a0)
		bpl.s	locret_17A1A
		move.w	#0,$1A(a0)

locret_17A1A:
		rts
; ---------------------------------------------------------------------------

loc_17A1C:
		bsr.w	sub_FA7A
		tst.w	d1
		bpl.s	locret_17A34
		add.w	d1,$10(a0)
		move.w	#0,$18(a0)
		bset	#5,($FFFFF74E).w

locret_17A34:
		rts
; ---------------------------------------------------------------------------

loc_17A36:
		tst.w	$1A(a0)
		bmi.s	locret_17A60
		bsr.w	sub_11FD6
		tst.w	d1
		bpl.s	locret_17A60
		tst.b	($FFFFF7C6).w
		beq.s	loc_17A4C
		neg.w	d1

loc_17A4C:
		add.w	d1,$14(a0)
		move.b	d3,$26(a0)
		move.w	#0,$1A(a0)
		bclr	#1,($FFFFF74E).w

locret_17A60:

		rts
; ---------------------------------------------------------------------------

loc_17A62:
		bsr.w	sub_FD9A
		tst.w	d1
		bpl.s	loc_17A7A
		sub.w	d1,$10(a0)
		move.w	#0,$18(a0)
		bset	#5,($FFFFF74E).w

loc_17A7A:
		jsr	(sub_FA7A).l
		tst.w	d1
		bpl.s	loc_17A94
		add.w	d1,$10(a0)
		move.w	#0,$18(a0)
		bset	#5,($FFFFF74E).w

loc_17A94:
		bsr.w	sub_11FEE
		tst.w	d1
		bpl.s	locret_17AAE
		tst.b	($FFFFF7C6).w
		beq.s	loc_17AA4
		neg.w	d1

loc_17AA4:
		sub.w	d1,$14(a0)
		move.w	#0,$1A(a0)

locret_17AAE:
		rts
; ---------------------------------------------------------------------------

loc_17AB0:
		jsr	(sub_FA7A).l
		tst.w	d1
		bpl.s	loc_17ACA
		add.w	d1,$10(a0)
		move.w	#0,$18(a0)
		bset	#5,($FFFFF74E).w

loc_17ACA:
		bsr.w	sub_11FEE
		tst.w	d1
		bpl.s	loc_17AEC
		tst.b	($FFFFF7C6).w
		beq.s	loc_17ADA
		neg.w	d1

loc_17ADA:
		sub.w	d1,$14(a0)
		tst.w	$1A(a0)
		bpl.s	locret_17AEA
		move.w	#0,$1A(a0)

locret_17AEA:
		rts
; ---------------------------------------------------------------------------

loc_17AEC:
		tst.w	$1A(a0)
		bmi.s	locret_17B16
		bsr.w	sub_11FD6
		tst.w	d1
		bpl.s	locret_17B16
		tst.b	($FFFFF7C6).w
		beq.s	loc_17B02
		neg.w	d1

loc_17B02:
		add.w	d1,$14(a0)
		move.b	d3,$26(a0)
		move.w	#0,$1A(a0)
		bclr	#1,($FFFFF74E).w

locret_17B16:

		rts
; End of function sub_1793E

; ---------------------------------------------------------------------------
		tst.b	$3D(a0)
		bne.s	loc_17B6A
		move.b	#0,$20(a0)

; =============== S U B R O U T I N E =======================================


sub_17B24:
		move.b	$1E(a0),d0
		move.b	$44(a0),$1E(a0)
		move.b	$45(a0),$1F(a0)
		btst	#2,$2A(a0)
		beq.s	loc_17B6A
		bclr	#2,$2A(a0)
		move.b	#0,$20(a0)
		sub.b	$44(a0),d0
		ext.w	d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_17B56
		neg.w	d0

loc_17B56:
		move.w	d0,-(sp)
		move.b	$26(a0),d0
		addi.b	#$40,d0
		bpl.s	loc_17B64
		neg.w	(sp)

loc_17B64:
		move.w	(sp)+,d0
		add.w	d0,$14(a0)

loc_17B6A:

		bclr	#1,$2A(a0)
		bclr	#5,$2A(a0)
		bclr	#4,$2A(a0)
		move.b	#0,$40(a0)
		move.w	#0,($FFFFF7D0).w
		move.b	#0,$27(a0)
		move.b	#0,$2D(a0)
		move.b	#0,$30(a0)
		move.b	#0,$39(a0)
		move.b	#0,$2F(a0)
		cmpi.b	#$20,$20(a0)
		bcs.s	locret_17BB4
		move.b	#0,$20(a0)

locret_17BB4:
		rts
; End of function sub_17B24

; ---------------------------------------------------------------------------

loc_17BB6:
		tst.w	($FFFFFFDA).w
		beq.s	loc_17BD0
		btst	#4,($FFFFF605).w
		beq.s	loc_17BD0
		move.w	#1,($FFFFFE08).w
		clr.b	($FFFFF7CA).w
		rts
; ---------------------------------------------------------------------------

loc_17BD0:

		jsr	(MoveSprite_TestGravity2).l
		addi.w	#$30,$1A(a0)
		btst	#6,$2A(a0)
		beq.s	loc_17BEA
		subi.w	#$20,$1A(a0)

loc_17BEA:
		cmpi.w	#-$100,($FFFFEE18).w
		bne.s	loc_17BFA
		move.w	($FFFFEEAA).w,d0
		and.w	d0,$14(a0)

loc_17BFA:
		bsr.w	sub_17C10
		bsr.w	Player_Check_Screen_Boundaries
		bsr.w	sub_10D66
		bsr.w	sub_17D1E
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_17C10:
		tst.b	($FFFFF665).w
		bne.s	loc_17C3C
		tst.b	($FFFFF7C6).w
		bne.s	loc_17C2E
		move.w	($FFFFEE1A).w,d0
		addi.w	#$E0,d0
		cmp.w	$14(a0),d0
		blt.w	loc_17C82
		bra.s	loc_17C3C
; ---------------------------------------------------------------------------

loc_17C2E:
		move.w	($FFFFEE18).w,d0
		cmp.w	$14(a0),d0
		blt.s	loc_17C3C
		bra.w	loc_17C82
; ---------------------------------------------------------------------------

loc_17C3C:

		movem.l	a4-a6,-(sp)
		bsr.w	sub_11EEC
		movem.l	(sp)+,a4-a6
		btst	#1,$2A(a0)
		bne.s	locret_17C80
		moveq	#0,d0
		move.w	d0,$1A(a0)
		move.w	d0,$18(a0)
		move.w	d0,$1C(a0)
		move.b	d0,$2E(a0)
		move.b	#0,$20(a0)
		move.w	#$100,8(a0)
		move.b	#2,5(a0)
		move.b	#$78,$34(a0)
		move.b	#0,$3D(a0)

locret_17C80:
		rts
; ---------------------------------------------------------------------------

loc_17C82:

		jmp	(Kill_Character).l
; End of function sub_17C10

; ---------------------------------------------------------------------------

loc_17C88:
		tst.w	($FFFFFFDA).w
		beq.s	loc_17CA2
		btst	#4,($FFFFF605).w
		beq.s	loc_17CA2
		move.w	#1,($FFFFFE08).w
		clr.b	($FFFFF7CA).w
		rts
; ---------------------------------------------------------------------------

loc_17CA2:

		bsr.w	sub_123C2
		jsr	(MoveSprite_TestGravity).l
		bsr.w	sub_10D66
		bsr.w	sub_17D1E
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_17CBA:
		tst.w	$3E(a0)
		beq.s	locret_17CCC
		subq.w	#1,$3E(a0)
		bne.s	locret_17CCC
		move.w	#1,($FFFFFE02).w

locret_17CCC:

		rts
; ---------------------------------------------------------------------------

loc_17CCE:
		tst.w	($FFFFEE00).w
		bne.s	loc_17CE0
		tst.w	($FFFFEE02).w
		bne.s	loc_17CE0
		move.b	#2,5(a0)

loc_17CE0:

		bsr.w	sub_17D1E
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_17CEA:
		tst.w	($FFFFFFDA).w
		beq.s	loc_17D04
		btst	#4,($FFFFF605).w
		beq.s	loc_17D04
		move.w	#1,($FFFFFE08).w
		clr.b	($FFFFF7CA).w
		rts
; ---------------------------------------------------------------------------

loc_17D04:

		jsr	(MoveSprite_TestGravity2).l
		addi.w	#$10,$1A(a0)
		bsr.w	sub_10D66
		bsr.w	sub_17D1E
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_17D1E:

		bsr.s	Animate_Knuckles
		tst.b	($FFFFF7C6).w
		beq.s	loc_17D2C
		eori.b	#2,4(a0)

loc_17D2C:
		bra.w	Knuckles_Load_PLC
; End of function sub_17D1E


; =============== S U B R O U T I N E =======================================


Animate_Knuckles:
		lea	(AniKnuckles).l,a1
		moveq	#0,d0
		move.b	$20(a0),d0
		cmp.b	$21(a0),d0
		beq.s	loc_17D58
		move.b	d0,$21(a0)
		move.b	#0,$23(a0)
		move.b	#0,$24(a0)
		bclr	#5,$2A(a0)

loc_17D58:
		add.w	d0,d0
		adda.w	(a1,d0.w),a1
		move.b	(a1),d0
		bmi.s	loc_17DC8
		move.b	$2A(a0),d1
		andi.b	#1,d1
		andi.b	#-4,4(a0)
		or.b	d1,4(a0)
		subq.b	#1,$24(a0)
		bpl.s	locret_17D96
		move.b	d0,$24(a0)

loc_17D7E:
					; Animate_Knuckles+1C0j
		moveq	#0,d1
		move.b	$23(a0),d1
		move.b	1(a1,d1.w),d0
		cmpi.b	#-4,d0
		bcc.s	loc_17D98

loc_17D8E:
					; Animate_Knuckles+8Aj
		move.b	d0,$22(a0)
		addq.b	#1,$23(a0)

locret_17D96:
					; Animate_Knuckles+16Aj ...
		rts
; ---------------------------------------------------------------------------

loc_17D98:
		addq.b	#1,d0
		bne.s	loc_17DA8
		move.b	#0,$23(a0)
		move.b	1(a1),d0
		bra.s	loc_17D8E
; ---------------------------------------------------------------------------

loc_17DA8:
		addq.b	#1,d0
		bne.s	loc_17DBC
		move.b	2(a1,d1.w),d0
		sub.b	d0,$23(a0)
		sub.b	d0,d1
		move.b	1(a1,d1.w),d0
		bra.s	loc_17D8E
; ---------------------------------------------------------------------------

loc_17DBC:
		addq.b	#1,d0
		bne.s	locret_17DC6
		move.b	2(a1,d1.w),$20(a0)

locret_17DC6:
		rts
; ---------------------------------------------------------------------------

loc_17DC8:
		addq.b	#1,d0
		bne.w	loc_17E84
		moveq	#0,d0
		tst.b	$2D(a0)
		bmi.w	loc_127C0
		move.b	$27(a0),d0
		bne.w	loc_127C0
		moveq	#0,d1
		move.b	$26(a0),d0
		bmi.s	loc_17DEC
		beq.s	loc_17DEC
		subq.b	#1,d0

loc_17DEC:
					; Animate_Knuckles+B8j
		move.b	$2A(a0),d2
		andi.b	#1,d2
		bne.s	loc_17DF8
		not.b	d0

loc_17DF8:
		addi.b	#$10,d0
		bpl.s	loc_17E00
		moveq	#3,d1

loc_17E00:
		andi.b	#-4,4(a0)
		eor.b	d1,d2
		or.b	d2,4(a0)
		btst	#5,$2A(a0)
		bne.w	loc_17ECC
		lsr.b	#4,d0
		andi.b	#6,d0
		move.w	$1C(a0),d2
		bpl.s	loc_17E24
		neg.w	d2

loc_17E24:
		tst.b	$2B(a0)
		bpl.w	loc_17E2E
		add.w	d2,d2

loc_17E2E:
		lea	(byte_17F48).l,a1
		cmpi.w	#$600,d2
		bcc.s	loc_17E42
		lea	(byte_17F3E).l,a1
		add.b	d0,d0

loc_17E42:
		add.b	d0,d0
		move.b	d0,d3
		moveq	#0,d1
		move.b	$23(a0),d1
		move.b	1(a1,d1.w),d0
		cmpi.b	#-1,d0
		bne.s	loc_17E60
		move.b	#0,$23(a0)
		move.b	1(a1),d0

loc_17E60:
		move.b	d0,$22(a0)
		add.b	d3,$22(a0)
		subq.b	#1,$24(a0)
		bpl.s	locret_17E82
		neg.w	d2
		addi.w	#$800,d2
		bpl.s	loc_17E78
		moveq	#0,d2

loc_17E78:
		lsr.w	#8,d2
		move.b	d2,$24(a0)
		addq.b	#1,$23(a0)

locret_17E82:
		rts
; ---------------------------------------------------------------------------

loc_17E84:
		move.b	$2A(a0),d1
		andi.b	#1,d1
		andi.b	#-4,4(a0)
		or.b	d1,4(a0)
		subq.b	#1,$24(a0)
		bpl.w	locret_17D96
		move.w	$1C(a0),d2
		bpl.s	loc_17EA6
		neg.w	d2

loc_17EA6:
		lea	(byte_17F5C).l,a1
		cmpi.w	#$600,d2
		bcc.s	loc_17EB8
		lea	(byte_17F52).l,a1

loc_17EB8:
		neg.w	d2
		addi.w	#$400,d2
		bpl.s	loc_17EC2
		moveq	#0,d2

loc_17EC2:
		lsr.w	#8,d2
		move.b	d2,$24(a0)
		bra.w	loc_17D7E
; ---------------------------------------------------------------------------

loc_17ECC:
		subq.b	#1,$24(a0)
		bpl.w	locret_17D96
		move.w	$1C(a0),d2
		bmi.s	loc_17EDC
		neg.w	d2

loc_17EDC:
		addi.w	#$800,d2
		bpl.s	loc_17EE4
		moveq	#0,d2

loc_17EE4:
		lsr.w	#8,d2
		move.b	d2,$24(a0)
		lea	(byte_17F66).l,a1
		bra.w	loc_17D7E
; End of function Animate_Knuckles

; ---------------------------------------------------------------------------
AniKnuckles:	include "General\Sprites\Knuckles\Anim - Knuckles.asm"


; =============== S U B R O U T I N E =======================================


Knuckles_Load_PLC:

		moveq	#0,d0
		move.b	$22(a0),d0

Knuckles_Load_PLC2:
		cmp.b	($FFFFF766).w,d0
		beq.s	locret_18162
		move.b	d0,($FFFFF766).w
		move.w	#$D000,d4

loc_18122:
		lea	(PLC_Knuckles).l,a2
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d5
		subq.w	#1,d5
		bmi.s	locret_18162
		move.l	#ArtUnc_Knux,d6

loc_1813A:
		moveq	#0,d1
		move.w	(a2)+,d1
		move.w	d1,d3
		lsr.w	#8,d3
		andi.w	#$F0,d3
		addi.w	#$10,d3
		andi.w	#$FFF,d1
		lsl.l	#5,d1
		add.l	d6,d1
		move.w	d4,d2
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		dbf	d5,loc_1813A

locret_18162:
					; Knuckles_Load_PLC+24j
		rts
; End of function Knuckles_Load_PLC

; ---------------------------------------------------------------------------

Obj_Air_CountDown:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_18172(pc,d0.w),d1
		jmp	off_18172(pc,d1.w)
; ---------------------------------------------------------------------------
off_18172:	dc.w loc_18184-off_18172

		dc.w loc_181DC-off_18172
		dc.w loc_181E8-off_18172
		dc.w loc_18254-off_18172
		dc.w loc_1826C-off_18172
		dc.w Player_TestAirTimer-off_18172
		dc.w loc_18272-off_18172
		dc.w loc_182B2-off_18172
		dc.w loc_1826C-off_18172
; ---------------------------------------------------------------------------

loc_18184:
		addq.b	#2,5(a0)
		move.l	#Map_Bubbler,$C(a0)
		tst.b	$43(a0)
		beq.s	loc_1819E
		move.l	#Map_Bubbler2,$C(a0)

loc_1819E:
		move.w	#$45C,$A(a0)
		move.b	#-$7C,4(a0)
		move.b	#$10,7(a0)
		move.w	#$80,8(a0)
		move.b	$2C(a0),d0
		bpl.s	loc_181CC
		addq.b	#8,5(a0)
		andi.w	#$7F,d0
		move.b	d0,$37(a0)
		bra.w	Player_TestAirTimer
; ---------------------------------------------------------------------------

loc_181CC:
		move.b	d0,$20(a0)
		move.w	$10(a0),$34(a0)
		move.w	#-$100,$1A(a0)

loc_181DC:
		lea	(Ani_Shields).l,a1
		jsr	(Animate_Sprite).l

loc_181E8:
		move.w	($FFFFF646).w,d0
		cmp.w	$14(a0),d0
		bcs.s	loc_1820E
		move.b	#6,5(a0)
		addq.b	#7,$20(a0)
		cmpi.b	#$D,$20(a0)
		beq.s	loc_18254
		bcs.s	loc_18254
		move.b	#$D,$20(a0)
		bra.s	loc_18254
; ---------------------------------------------------------------------------

loc_1820E:
		tst.w	($FFFFF7C8).w
		beq.s	loc_18218
		addq.w	#4,$34(a0)

loc_18218:
		move.b	$26(a0),d0
		addq.b	#1,$26(a0)
		andi.w	#$7F,d0
		lea	(byte_1831E).l,a1
		move.b	(a1,d0.w),d0
		ext.w	d0
		add.w	$34(a0),d0
		move.w	d0,$10(a0)
		bsr.w	sub_182D2
		jsr	(MoveSprite2).l
		tst.b	4(a0)
		bpl.s	loc_1824E
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_1824E:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_18254:

		bsr.s	sub_182D2
		lea	(Ani_Shields).l,a1
		jsr	(Animate_Sprite).l
		bsr.w	AirCountdown_Load_Art
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_1826C:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_18272:
		movea.l	$40(a0),a2
		cmpi.b	#$C,$2C(a2)
		bhi.s	loc_182AC
		subq.w	#1,$3C(a0)
		bne.s	loc_18290
		move.b	#$E,5(a0)
		addq.b	#7,$20(a0)
		bra.s	loc_18254
; ---------------------------------------------------------------------------

loc_18290:
		lea	(Ani_Shields).l,a1
		jsr	(Animate_Sprite).l
		bsr.w	AirCountdown_Load_Art
		tst.b	4(a0)
		bpl.s	loc_182AC
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_182AC:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_182B2:
		movea.l	$40(a0),a2
		cmpi.b	#$C,$2C(a2)
		bhi.s	loc_1826C
		bsr.s	sub_182D2
		lea	(Ani_Shields).l,a1
		jsr	(Animate_Sprite).l
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_182D2:

		tst.w	$3C(a0)
		beq.s	locret_1831C
		subq.w	#1,$3C(a0)
		bne.s	locret_1831C
		cmpi.b	#7,$20(a0)
		bcc.s	locret_1831C
		move.w	#$F,$3C(a0)
		clr.w	$1A(a0)
		move.b	#-$80,4(a0)
		move.w	$10(a0),d0
		sub.w	($FFFFEE78).w,d0
		addi.w	#$80,d0
		move.w	d0,$10(a0)
		move.w	$14(a0),d0
		sub.w	($FFFFEE7C).w,d0
		addi.w	#$80,d0
		move.w	d0,$14(a0)
		move.b	#$C,5(a0)

locret_1831C:
		rts
; End of function sub_182D2

; ---------------------------------------------------------------------------
byte_1831E:	dc.b	0,   0,	  0,   0,   0,	 0,   1,   1,	1,   1,	  1,   2,   2,	 2,   2,   2


		dc.b	2,   2,	  3,   3,   3,	 3,   3,   3,	3,   3,	  3,   3,   3,	 3,   3,   3
		dc.b	3,   3,	  3,   3,   3,	 3,   3,   3,	3,   3,	  3,   3,   3,	 3,   3,   2
		dc.b	2,   2,	  2,   2,   2,	 2,   1,   1,	1,   1,	  1,   0,   0,	 0,   0,   0
		dc.b	0, $FF,	$FF, $FF, $FF, $FF, $FE, $FE, $FE, $FE,	$FE, $FD, $FD, $FD, $FD, $FD
		dc.b  $FD, $FD,	$FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC,	$FC, $FC, $FC, $FC, $FC, $FC
		dc.b  $FC, $FC,	$FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC,	$FC, $FC, $FC, $FC, $FC, $FD
		dc.b  $FD, $FD,	$FD, $FD, $FD, $FD, $FE, $FE, $FE, $FE,	$FE, $FF, $FF, $FF, $FF, $FF
		dc.b	0,   0,	  0,   0,   0,	 0,   1,   1,	1,   1,	  1,   2,   2,	 2,   2,   2
		dc.b	2,   2,	  3,   3,   3,	 3,   3,   3,	3,   3,	  3,   3,   3,	 3,   3,   3
		dc.b	3,   3,	  3,   3,   3,	 3,   3,   3,	3,   3,	  3,   3,   3,	 3,   3,   2
		dc.b	2,   2,	  2,   2,   2,	 2,   1,   1,	1,   1,	  1,   0,   0,	 0,   0,   0
		dc.b	0, $FF,	$FF, $FF, $FF, $FF, $FE, $FE, $FE, $FE,	$FE, $FD, $FD, $FD, $FD, $FD
		dc.b  $FD, $FD,	$FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC,	$FC, $FC, $FC, $FC, $FC, $FC
		dc.b  $FC, $FC,	$FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC,	$FC, $FC, $FC, $FC, $FC, $FD
		dc.b  $FD, $FD,	$FD, $FD, $FD, $FD, $FE, $FE, $FE, $FE,	$FE, $FF, $FF, $FF, $FF, $FF

; =============== S U B R O U T I N E =======================================


AirCountdown_Load_Art:

		moveq	#0,d1
		move.b	$22(a0),d1
		cmpi.b	#9,d1
		bcs.s	locret_18464
		cmpi.b	#$13,d1
		bcc.s	locret_18464
		cmp.b	$32(a0),d1
		beq.s	locret_18464
		move.b	d1,$32(a0)
		subi.w	#9,d1
		move.w	d1,d0
		add.w	d1,d1
		add.w	d0,d1
		lsl.w	#6,d1
		addi.l	#ArtUnc_AirCountDown,d1
		move.w	#-$400,d2
		tst.b	$43(a0)
		beq.s	loc_1845A
		move.w	#-$200,d2

loc_1845A:
		move.w	#$60,d3
		jsr	(Add_To_DMA_Queue).l

locret_18464:
					; AirCountdown_Load_Art+10j ...
		rts
; End of function AirCountdown_Load_Art

; ---------------------------------------------------------------------------

Player_TestAirTimer:

		movea.l	$40(a0),a2
		tst.w	$30(a0)
		bne.w	loc_1857C
		cmpi.b	#6,5(a2)
		bcc.w	locret_18680
		btst	#6,$2B(a2)
		bne.w	locret_18680
		tst.b	($FFFFFE19).w
		bmi.w	locret_18680
		btst	#6,$2A(a2)
		beq.w	locret_18680
		subq.w	#1,$3C(a0)
		bpl.w	loc_18594
		move.w	#$3B,$3C(a0)
		move.w	#1,$3A(a0)
		jsr	(Random_Number).l
		andi.w	#1,d0
		move.b	d0,$38(a0)
		moveq	#0,d0
		move.b	$2C(a2),d0
		cmpi.w	#$19,d0
		beq.s	loc_184FC
		cmpi.w	#$14,d0
		beq.s	loc_184FC
		cmpi.w	#$F,d0
		beq.s	loc_184FC
		cmpi.w	#$C,d0
		bhi.s	loc_1850A
		bne.s	loc_184E8
		tst.b	$43(a0)
		bne.s	loc_184E8
		moveq	#$31,d0
		jsr	(Play_Sound).l

loc_184E8:

		subq.b	#1,$36(a0)
		bpl.s	loc_1850A
		move.b	$37(a0),$36(a0)
		bset	#7,$3A(a0)
		bra.s	loc_1850A
; ---------------------------------------------------------------------------

loc_184FC:

		tst.b	$43(a0)
		bne.s	loc_1850A
		moveq	#-$57,d0
		jsr	(Play_Sound_2).l

loc_1850A:

		subq.b	#1,$2C(a2)
		bcc.w	loc_18592
		move.b	#-$7F,$2E(a2)
		move.w	#$3B,d0
		jsr	(Play_Sound_2).l
		move.b	#$A,$38(a0)
		move.w	#1,$3A(a0)
		move.w	#$78,$30(a0)
		movea.l	a2,a1
		bsr.w	Player_ResetAirTimer
		move.l	a0,-(sp)
		movea.l	a2,a0
		bsr.w	Player_TouchFloor
		move.b	#$17,$20(a0)
		bset	#1,$2A(a0)
		bset	#7,$A(a0)
		move.w	#0,$1A(a0)
		move.w	#0,$18(a0)
		move.w	#0,$1C(a0)
		move.b	#$C,5(a0)
		movea.l	(sp)+,a0
		cmpa.w	#$B000,a2
		bne.s	locret_1857A
		move.b	#1,($FFFFEE30).w

locret_1857A:
		rts
; ---------------------------------------------------------------------------

loc_1857C:
		move.b	#$17,$20(a2)
		subq.w	#1,$30(a0)
		bne.s	loc_18590
		move.b	#6,5(a2)
		rts
; ---------------------------------------------------------------------------

loc_18590:
		bra.s	loc_18594
; ---------------------------------------------------------------------------

loc_18592:
		bra.s	loc_185A4
; ---------------------------------------------------------------------------

loc_18594:

		tst.w	$3A(a0)
		beq.w	locret_18680
		subq.w	#1,$3E(a0)
		bpl.w	locret_18680

loc_185A4:
		jsr	(Random_Number).l
		andi.w	#$F,d0
		addq.w	#8,d0
		move.w	d0,$3E(a0)
		jsr	(Create_New_Sprite).l
		bne.w	locret_18680
		move.l	(a0),(a1)
		move.w	$10(a2),$10(a1)
		moveq	#6,d0
		btst	#0,$2A(a2)
		beq.s	loc_185D8
		neg.w	d0
		move.b	#$40,$26(a1)

loc_185D8:
		add.w	d0,$10(a1)
		move.w	$14(a2),$14(a1)
		move.l	$40(a0),$40(a1)
		move.b	#6,$2C(a1)
		tst.w	$30(a0)
		beq.w	loc_1862A
		andi.w	#7,$3E(a0)
		addi.w	#0,$3E(a0)
		move.w	$14(a2),d0
		subi.w	#$C,d0
		move.w	d0,$14(a1)
		jsr	(Random_Number).l
		move.b	d0,$26(a1)
		move.w	($FFFFFE04).w,d0
		andi.b	#3,d0
		bne.s	loc_18676
		move.b	#$E,$2C(a1)
		bra.s	loc_18676
; ---------------------------------------------------------------------------

loc_1862A:
		btst	#7,$3A(a0)
		beq.s	loc_18676
		moveq	#0,d2
		move.b	$2C(a2),d2
		cmpi.b	#$C,d2
		bcc.s	loc_18676
		lsr.w	#1,d2
		jsr	(Random_Number).l
		andi.w	#3,d0
		bne.s	loc_1865E
		bset	#6,$3A(a0)
		bne.s	loc_18676
		move.b	d2,$2C(a1)
		move.w	#$1C,$3C(a1)

loc_1865E:
		tst.b	$38(a0)
		bne.s	loc_18676
		bset	#6,$3A(a0)
		bne.s	loc_18676
		move.b	d2,$2C(a1)
		move.w	#$1C,$3C(a1)

loc_18676:

		subq.b	#1,$38(a0)
		bpl.s	locret_18680
		clr.w	$3A(a0)

locret_18680:

		rts

; =============== S U B R O U T I N E =======================================


Player_ResetAirTimer:

		cmpi.b	#$C,$2C(a1)
		bhi.s	loc_186BC
		cmpa.w	#$B000,a1
		bne.s	loc_186BC
		move.w	($FFFFFF90).w,d0
		btst	#1,$2B(a1)
		beq.s	loc_186A0
		move.w	#$2C,d0

loc_186A0:
		tst.b	($FFFFFE19).w
		beq.w	loc_186AC
		move.w	#$2C,d0

loc_186AC:
		tst.b	($FFFFF7AA).w
		beq.s	loc_186B6
		move.w	#$18,d0

loc_186B6:
		jsr	(Play_Sound).l

loc_186BC:
		move.b	#$1E,$2C(a1)
		rts
; End of function Player_ResetAirTimer

; ---------------------------------------------------------------------------
Ani_Shields:	include "General\Sprites\Shields\Anim - Shields.asm"

; ---------------------------------------------------------------------------

Obj_Shield_S2:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_18764(pc,d0.w),d1
		jmp	off_18764(pc,d1.w)
; ---------------------------------------------------------------------------
off_18764:	dc.w loc_18768-off_18764

		dc.w loc_1878C-off_18764
; ---------------------------------------------------------------------------

loc_18768:
		addq.b	#2,5(a0)
		move.l	#Map_Shield_S2,$C(a0)
		move.b	#4,4(a0)
		move.w	#$80,8(a0)
		move.b	#$18,7(a0)
		move.w	#$79C,$A(a0)

loc_1878C:
		movea.w	$42(a0),a2
		btst	#1,$2B(a2)
		bne.s	locret_187D6
		btst	#0,$2B(a2)
		beq.s	loc_187D8
		move.w	$10(a2),$10(a0)
		move.w	$14(a2),$14(a0)
		move.b	$2A(a2),$2A(a0)
		andi.w	#$7FFF,$A(a0)
		tst.w	$A(a2)
		bpl.s	loc_187C4
		ori.w	#$8000,$A(a0)

loc_187C4:
		lea	(Ani_Shield_S2).l,a1
		jsr	(Animate_Sprite).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_187D6:
		rts
; ---------------------------------------------------------------------------

loc_187D8:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
		dc.l byte_189ED
		dc.w $B
		dc.l byte_18A02
		dc.w $160D
		dc.l byte_18A1B
		dc.w $2C0D
; ---------------------------------------------------------------------------

Obj_Invincibility:

		move.l	#ArtUnc_Invincibility,d1
		move.w	#$F380,d2
		move.w	#$200,d3
		jsr	(Add_To_DMA_Queue).l
		moveq	#0,d2
		lea	loc_187D8(pc),a2
		lea	(a0),a1
		moveq	#3,d1

loc_1880E:
		move.l	#Obj_188E8,(a1)
		move.l	#Map_Invincibility,$C(a1)
		move.w	#$79C,$A(a1)
		move.w	#$80,8(a1)
		move.b	#4,4(a1)
		bset	#6,4(a1)
		move.b	#$10,7(a1)
		move.w	#2,$16(a1)
		move.w	$42(a0),$42(a1)
		move.b	d2,$36(a1)
		addq.w	#1,d2
		move.l	(a2)+,$30(a1)
		move.w	(a2)+,$34(a1)
		lea	$4A(a1),a1
		dbf	d1,loc_1880E
		move.l	#loc_18868,(a0)
		move.b	#4,$34(a0)

loc_18868:
		tst.b	($FFFFFE19).w
		bne.w	Delete_Current_Sprite
		tst.b	($FFFFF667).w
		bne.w	Delete_Current_Sprite
		movea.w	$42(a0),a1
		btst	#1,$2B(a1)
		beq.w	Delete_Current_Sprite
		move.w	$10(a1),d0
		move.w	d0,$10(a0)
		move.w	$14(a1),d1
		move.w	d1,$14(a0)
		lea	$18(a0),a2
		lea	byte_189E0(pc),a3
		moveq	#0,d5

loc_188A0:
		move.w	$38(a0),d2
		move.b	(a3,d2.w),d5
		bpl.s	loc_188B0
		clr.w	$38(a0)
		bra.s	loc_188A0
; ---------------------------------------------------------------------------

loc_188B0:
		addq.w	#1,$38(a0)
		lea	word_189A0(pc),a6
		move.b	$34(a0),d6
		jsr	sub_1898A(pc)
		move.w	d2,(a2)+
		move.w	d3,(a2)+
		move.w	d5,(a2)+
		addi.w	#$20,d6
		jsr	sub_1898A(pc)
		move.w	d2,(a2)+
		move.w	d3,(a2)+
		move.w	d5,(a2)+
		moveq	#$12,d0
		btst	#0,$2A(a1)
		beq.s	loc_188E0
		neg.w	d0

loc_188E0:
		add.b	d0,$34(a0)
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------

Obj_188E8:
		tst.b	($FFFFFE19).w
		bne.w	Delete_Current_Sprite
		tst.b	($FFFFF667).w
		bne.w	Delete_Current_Sprite
		movea.w	$42(a0),a1
		btst	#1,$2B(a1)
		beq.w	Delete_Current_Sprite
		lea	($FFFFEE26).w,a5
		lea	($FFFFE500).w,a6
		move.b	$36(a0),d1
		lsl.b	#2,d1
		move.w	d1,d2
		add.w	d1,d1
		add.w	d2,d1
		move.w	(a5),d0
		sub.b	d1,d0
		lea	(a6,d0.w),a2
		move.w	(a2)+,d0
		move.w	(a2)+,d1
		move.w	d0,$10(a0)
		move.w	d1,$14(a0)
		lea	$18(a0),a2
		movea.l	$30(a0),a3

loc_18936:
		move.w	$38(a0),d2
		move.b	(a3,d2.w),d5
		bpl.s	loc_18946
		clr.w	$38(a0)
		bra.s	loc_18936
; ---------------------------------------------------------------------------

loc_18946:
		swap	d5
		add.b	$35(a0),d2
		move.b	(a3,d2.w),d5
		addq.w	#1,$38(a0)
		lea	word_189A0(pc),a6
		move.b	$34(a0),d6
		jsr	sub_1898A(pc)
		move.w	d2,(a2)+
		move.w	d3,(a2)+
		move.w	d5,(a2)+
		addi.w	#$20,d6
		swap	d5
		jsr	sub_1898A(pc)
		move.w	d2,(a2)+
		move.w	d3,(a2)+
		move.w	d5,(a2)+
		moveq	#2,d0
		btst	#0,$2A(a1)
		beq.s	loc_18982
		neg.w	d0

loc_18982:
		add.b	d0,$34(a0)
		bra.w	Draw_Sprite

; =============== S U B R O U T I N E =======================================


sub_1898A:

		andi.w	#$3E,d6
		move.b	(a6,d6.w),d2
		move.b	1(a6,d6.w),d3
		ext.w	d2
		ext.w	d3
		add.w	d0,d2
		add.w	d1,d3
		rts
; End of function sub_1898A

; ---------------------------------------------------------------------------
word_189A0:	dc.w   $F00,  $F03,  $E06,  $D08,  $B0B,  $80D,	 $60E,	$30F,	$10, $FC0F, $F90E, $F70D, $F40B, $F208,	$F106, $F003


		dc.w  $F000, $F0FC, $F1F9, $F2F7, $F4F4, $F7F2,	$F9F1, $FCF0, $FFF0,  $3F0,  $6F1,  $8F2,  $BF4,  $DF7,	 $EF9,	$FFC
byte_189E0:	dc.b	8,   5,	  7,   6,   6,	 7,   5,   8,	6,   7,	  7,   6, $FF

byte_189ED:	dc.b    8,   7,   6,   5,   4,   3,   4,   5,   6,   7, $FF,   3,   4,   5,   6,   7,   8,   7,   6,   5
		dc.b    4

byte_18A02:	dc.b    8,   7,   6,   5,   4,   3,   2,   3,   4,   5,   6,   7, $FF,   2,   3,   4,   5,   6,   7,   8
		dc.b    7,   6,   5,   4,   3

byte_18A1B:	dc.b    7,   6,   5,   4,   3,   2,   1,   2,   3,   4,   5,   6, $FF,   1,   2,   3,   4,   5,   6,   7
		dc.b    6,   5,   4,   3,   2

Ani_Shield_S2:	include "General\Sprites\Shields\Anim - Shield S2.asm"

Map_Shield_S2:	include "General\Sprites\Shields\Map - Shield S2.asm"

Map_Invincibility:include "General\Sprites\Shields\Map - Invincibility.asm"

; ---------------------------------------------------------------------------

Obj_DashDust:
					; SpawnLevelMainSprites_SpawnPlayers+98o ...
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_18B4C(pc,d0.w),d1
		jmp	off_18B4C(pc,d1.w)
; ---------------------------------------------------------------------------
off_18B4C:	dc.w loc_18B54-off_18B4C

		dc.w loc_18BAA-off_18B4C; 1
		dc.w loc_18CB2-off_18B4C; 2
		dc.w loc_18CB6-off_18B4C; 3
; ---------------------------------------------------------------------------

loc_18B54:
		addq.b	#2,5(a0)
		move.l	#Map_DashDust,$C(a0)
		ori.b	#4,4(a0)
		move.w	#$80,8(a0)
		move.b	#$10,7(a0)
		move.w	#$7E0,$A(a0)
		move.w	#$B000,$42(a0)
		move.w	#$FC00,$40(a0)
		cmpa.w	#$CC54,a0
		beq.s	loc_18BAA
		move.b	#1,$38(a0)
		cmpi.w	#2,($FFFFFF08).w
		beq.s	loc_18BAA
		move.w	#$7F0,$A(a0)
		move.w	#$B04A,$42(a0)
		move.w	#$FE00,$40(a0)

loc_18BAA:


		movea.w	$42(a0),a2
		moveq	#0,d0
		move.b	$20(a0),d0
		add.w	d0,d0
		move.w	off_18BBE(pc,d0.w),d1
		jmp	off_18BBE(pc,d1.w)
; ---------------------------------------------------------------------------
off_18BBE:	dc.w loc_18C94-off_18BBE

		dc.w loc_18BC8-off_18BBE
		dc.w loc_18C20-off_18BBE
		dc.w loc_18C84-off_18BBE
		dc.w loc_18BEC-off_18BBE
; ---------------------------------------------------------------------------

loc_18BC8:
		move.w	($FFFFF646).w,$14(a0)
		tst.b	$21(a0)
		bne.w	loc_18C94
		move.w	$10(a2),$10(a0)
		move.b	#0,$2A(a0)
		andi.w	#$7FFF,$A(a0)
		bra.w	loc_18C94
; ---------------------------------------------------------------------------

loc_18BEC:
		tst.b	$21(a0)
		bne.s	loc_18C04
		move.w	$10(a2),$10(a0)
		move.b	#0,$2A(a0)
		andi.w	#$7FFF,$A(a0)

loc_18C04:
		lea	(Ani_DashSplashDrown).l,a1
		jsr	(Animate_Sprite).l
		move.l	#ArtUnc_SplashDrown,d6
		bsr.w	SplashDrown_Load_DPLC
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_18C20:
		cmpi.b	#$C,$2C(a2)
		bcs.w	loc_18CAA
		cmpi.b	#4,5(a2)
		bcc.s	loc_18CAA
		tst.b	$3D(a2)
		beq.s	loc_18CAA
		move.w	$10(a2),$10(a0)
		move.w	$14(a2),$14(a0)
		move.b	$2A(a2),$2A(a0)
		andi.b	#1,$2A(a0)
		moveq	#4,d1
		tst.b	($FFFFF7C6).w
		beq.s	loc_18C60
		ori.b	#2,$2A(a0)
		neg.w	d1

loc_18C60:
		tst.b	$38(a0)
		beq.s	loc_18C6A
		sub.w	d1,$14(a0)

loc_18C6A:
		tst.b	$21(a0)
		bne.s	loc_18C94
		andi.w	#$7FFF,$A(a0)
		tst.w	$A(a2)
		bpl.s	loc_18C94
		ori.w	#$8000,$A(a0)
		bra.s	loc_18C94
; ---------------------------------------------------------------------------

loc_18C84:
		cmpi.b	#$C,$2C(a2)
		bcs.s	loc_18CAA
		btst	#6,$2A(a0)
		bne.s	loc_18CAA

loc_18C94:

		lea	(Ani_DashSplashDrown).l,a1
		jsr	(Animate_Sprite).l
		bsr.w	DashDust_Load_DPLC
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_18CAA:

		move.b	#0,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_18CB2:
		bra.w	Delete_Current_Sprite
; ---------------------------------------------------------------------------

loc_18CB6:
		movea.w	$42(a0),a2
		moveq	#$10,d1
		cmpi.b	#$D,$20(a2)
		beq.s	loc_18CE4
		cmpi.b	#2,$38(a2)
		bne.s	loc_18CD6
		moveq	#6,d1
		cmpi.b	#3,$2F(a2)
		beq.s	loc_18CE4

loc_18CD6:
		move.b	#2,5(a0)
		move.b	#0,$36(a0)
		rts
; ---------------------------------------------------------------------------

loc_18CE4:

		subq.b	#1,$36(a0)
		bpl.s	loc_18D66
		move.b	#3,$36(a0)
		btst	#6,$2A(a2)
		bne.s	loc_18D66
		bsr.w	Create_New_Sprite
		bne.s	loc_18D66
		move.l	(a0),(a1)
		move.w	$10(a2),$10(a1)
		move.w	$14(a2),$14(a1)
		tst.b	$38(a0)
		beq.s	loc_18D14
		subq.w	#4,d1

loc_18D14:
		tst.b	($FFFFF7C6).w
		beq.s	loc_18D1C
		neg.w	d1

loc_18D1C:
		add.w	d1,$14(a1)
		move.b	#0,$2A(a1)
		move.b	#3,$20(a1)
		addq.b	#2,5(a1)
		move.l	$C(a0),$C(a1)
		move.b	4(a0),4(a1)
		move.w	#$80,8(a1)
		move.b	#4,7(a1)
		move.w	$A(a0),$A(a1)
		move.w	$42(a0),$42(a1)
		andi.w	#$7FFF,$A(a1)
		tst.w	$A(a2)
		bpl.s	loc_18D66
		ori.w	#$8000,$A(a1)

loc_18D66:

		bsr.s	DashDust_Load_DPLC
		rts

; =============== S U B R O U T I N E =======================================


DashDust_Load_DPLC:

		move.l	#ArtUnc_DashDust,d6

SplashDrown_Load_DPLC:
		moveq	#0,d0
		move.b	$22(a0),d0
		cmp.b	$34(a0),d0
		beq.s	locret_18DBE
		move.b	d0,$34(a0)
		lea	(DPLC_DashSplashDrown).l,a2
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d5
		subq.w	#1,d5
		bmi.s	locret_18DBE
		move.w	$40(a0),d4

loc_18D96:
		moveq	#0,d1
		move.w	(a2)+,d1
		move.w	d1,d3
		lsr.w	#8,d3
		andi.w	#$F0,d3
		addi.w	#$10,d3
		andi.w	#$FFF,d1
		lsl.l	#5,d1
		add.l	d6,d1
		move.w	d4,d2
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		dbf	d5,loc_18D96

locret_18DBE:
					; DashDust_Load_DPLC+26j
		rts
; End of function DashDust_Load_DPLC

; ---------------------------------------------------------------------------
Ani_DashSplashDrown:include "General\Sprites\Splash Drown\Anim - Dash Splash Drown.asm"

Map_DashDust:	include "General\Sprites\Dash Dust\Map - Dash Dust.asm"

DPLC_DashSplashDrown:include "General\Sprites\Splash Drown\DPLC - Dash Splash Drown.asm"


; ---------------------------------------------------------------------------

Obj_DashDust2P:
					; SpawnLevelMainSprites_SpawnPlayers+158o
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_18F94(pc,d0.w),d1
		jmp	off_18F94(pc,d1.w)
; ---------------------------------------------------------------------------
off_18F94:	dc.w loc_18F9C-off_18F94

		dc.w loc_18FD2-off_18F94
		dc.w loc_19060-off_18F94
		dc.w loc_19064-off_18F94
; ---------------------------------------------------------------------------

loc_18F9C:
		addq.b	#2,5(a0)
		move.l	#Map_DashDust2P,$C(a0)
		ori.b	#4,4(a0)
		move.w	#$80,8(a0)
		move.b	#$10,7(a0)
		move.w	#$7E0,$A(a0)
		move.w	#$B000,$42(a0)
		cmpa.w	#$CC54,a0
		beq.s	loc_18FD2
		move.w	#$B04A,$42(a0)

loc_18FD2:

		movea.w	$42(a0),a2
		moveq	#0,d0
		move.b	$20(a0),d0
		add.w	d0,d0
		move.w	off_18FE6(pc,d0.w),d1
		jmp	off_18FE6(pc,d1.w)
; ---------------------------------------------------------------------------
off_18FE6:	dc.w loc_18FEE-off_18FE6

		dc.w loc_18FEE-off_18FE6
		dc.w loc_18FF6-off_18FE6
		dc.w loc_1903E-off_18FE6
; ---------------------------------------------------------------------------

loc_18FEE:
		move.b	#0,$22(a0)
		bra.s	loc_19046
; ---------------------------------------------------------------------------

loc_18FF6:
		cmpi.b	#$C,$2C(a2)
		bcs.s	loc_19058
		cmpi.b	#4,5(a2)
		bcc.s	loc_19058
		tst.b	$3D(a2)
		beq.s	loc_19058
		move.w	$10(a2),$10(a0)
		move.w	$14(a2),$14(a0)
		move.b	$2A(a2),$2A(a0)
		andi.b	#1,$2A(a0)
		tst.b	$21(a0)
		bne.s	loc_19046
		andi.w	#$7FFF,$A(a0)
		tst.w	$A(a2)
		bpl.s	loc_19046
		ori.w	#$8000,$A(a0)
		bra.s	loc_19046
; ---------------------------------------------------------------------------

loc_1903E:
		cmpi.b	#$C,$2C(a2)
		bcs.s	loc_19058

loc_19046:

		lea	(Ani_DashDust2P).l,a1
		jsr	(Animate_Sprite).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_19058:

		move.b	#0,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_19060:
		bra.w	Delete_Current_Sprite
; ---------------------------------------------------------------------------

loc_19064:
		movea.w	$42(a0),a2
		cmpi.b	#$D,$20(a2)
		beq.s	loc_1907E
		move.b	#2,5(a0)
		move.b	#0,$36(a0)
		rts
; ---------------------------------------------------------------------------

loc_1907E:
		move.b	#0,$22(a0)
		subq.b	#1,$36(a0)
		bpl.s	locret_190F0
		move.b	#3,$36(a0)
		bsr.w	Create_New_Sprite
		bne.s	locret_190F0
		move.l	(a0),(a1)
		move.w	$10(a2),$10(a1)
		move.w	$14(a2),$14(a1)
		addi.w	#$C,$14(a1)
		move.b	#0,$2A(a1)
		move.b	#3,$20(a1)
		addq.b	#2,5(a1)
		move.l	$C(a0),$C(a1)
		move.b	4(a0),4(a1)
		move.w	#$80,8(a1)
		move.b	#4,7(a1)
		move.w	$A(a0),$A(a1)
		move.w	$42(a0),$42(a1)
		andi.w	#$7FFF,$A(a1)
		tst.w	$A(a2)
		bpl.s	locret_190F0
		ori.w	#$8000,$A(a1)

locret_190F0:

		rts
; ---------------------------------------------------------------------------
Ani_DashDust2P:	include "General\Sprites\Dash Dust\Anim - Dash Dust 2P.asm"

Map_DashDust2P:	include "General\Sprites\Dash Dust\Map - Dash Dust 2P.asm"

; ---------------------------------------------------------------------------

Obj_SuperSonicKnux_Stars:
					; Knux_JumpHeight+120o
		move.l	#ArtUnc_SuperSonicKnux_Stars,d1
		move.w	#$F380,d2
		move.w	#$1A0,d3
		jsr	(Add_To_DMA_Queue).l
		move.l	#Map_SuperSonicKnux_Stars,$C(a0)
		move.b	#4,4(a0)
		move.w	#$80,8(a0)
		move.b	#$18,7(a0)
		move.b	#$18,6(a0)
		move.w	#$79C,$A(a0)
		btst	#7,($FFFFB00A).w
		beq.s	loc_1919E
		bset	#7,$A(a0)

loc_1919E:
		move.l	#loc_191A4,(a0)

loc_191A4:
		tst.b	($FFFFFE19).w
		beq.w	loc_19230
		tst.b	$20(a0)
		beq.s	loc_191B6
		bsr.w	sub_19236

loc_191B6:
		tst.b	$34(a0)
		beq.s	loc_19200
		subq.b	#1,$24(a0)
		bpl.s	loc_191E8
		move.b	#1,$24(a0)
		addq.b	#1,$22(a0)
		cmpi.b	#6,$22(a0)
		bcs.s	loc_191E8
		move.b	#0,$22(a0)
		move.b	#0,$34(a0)
		move.b	#1,$35(a0)
		rts
; ---------------------------------------------------------------------------

loc_191E8:

		tst.b	$35(a0)
		bne.s	loc_191FA

loc_191EE:
		move.w	($FFFFB010).w,$10(a0)
		move.w	($FFFFB014).w,$14(a0)

loc_191FA:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_19200:
		tst.b	($FFFFB02E).w
		bne.s	loc_19222
		move.w	($FFFFB01C).w,d0
		bpl.s	loc_1920E
		neg.w	d0

loc_1920E:
		cmpi.w	#$800,d0
		bcs.s	loc_19222
		move.b	#0,$22(a0)
		move.b	#1,$34(a0)
		bra.s	loc_191EE
; ---------------------------------------------------------------------------

loc_19222:

		move.b	#0,$34(a0)
		move.b	#0,$35(a0)
		rts
; ---------------------------------------------------------------------------

loc_19230:
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_19236:
		move.b	#0,$20(a0)
		lea	($FFFFB000).w,a2
		moveq	#$F,d5
		move.w	#$488,d4

loc_19246:
		bsr.w	Create_New_Sprite
		bne.w	locret_192BE
		move.l	#Obj_SuperSonicKnux_Stars_Timer,(a1)
		move.w	$10(a2),$10(a1)
		move.w	$14(a2),$14(a1)
		move.l	#Map_SuperSonicKnux_Stars2,$C(a1)
		move.w	#$879C,$A(a1)
		move.b	#$84,4(a1)
		move.w	#$380,8(a1)
		move.b	#8,7(a1)
		move.b	#8,6(a1)
		tst.w	d4
		bmi.s	loc_192AE
		move.w	d4,d0
		jsr	(GetSineCosine).l
		move.w	d4,d2
		lsr.w	#8,d2
		asl.w	d2,d0
		asl.w	d2,d1
		move.w	d0,d2
		move.w	d1,d3
		addi.b	#$10,d4
		bcc.s	loc_192AE
		subi.w	#$80,d4
		bcc.s	loc_192AE
		move.w	#$488,d4

loc_192AE:

		move.w	d2,$18(a1)
		move.w	d3,$1A(a1)
		neg.w	d2
		neg.w	d4
		dbf	d5,loc_19246

locret_192BE:
		rts
; End of function sub_19236

; ---------------------------------------------------------------------------

Obj_SuperSonicKnux_Stars_Timer:
		tst.b	4(a0)
		bmi.s	loc_192CC
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_192CC:
		addq.b	#1,$22(a0)
		andi.b	#3,$22(a0)
		bsr.w	MoveSprite2
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------
Map_SuperSonicKnux_Stars:	include "General\Sprites\Shields\Map - Super Sonic Knuckles Stars.asm"
; ---------------------------------------------------------------------------

Obj_HyperSonic_19348:

		lea	(ArtKosM_HyperSonicStars).l,a1
		move.w	#$F380,d2
		jsr	(Queue_Kos_Module).l
		lea	(a0),a1
		moveq	#0,d0
		moveq	#0,d2
		moveq	#3,d1

loc_19360:
		move.l	#loc_1937C,(a1)
		move.b	d0,$26(a1)
		addi.b	#$40,d0
		addq.b	#1,d2
		move.b	d2,$24(a1)
		lea	$4A(a1),a1
		dbf	d1,loc_19360

loc_1937C:
		tst.b	($FFFFFF60).w
		beq.s	loc_19384

locret_19382:
		rts
; ---------------------------------------------------------------------------

loc_19384:
		subq.b	#1,$24(a0)
		bne.s	locret_19382
		move.l	#Map_HyperSonicStars,$C(a0)
		move.b	#4,4(a0)
		move.w	#$80,8(a0)
		move.b	#$18,7(a0)
		move.b	#$18,6(a0)
		move.w	#$79C,$A(a0)
		move.b	#6,$22(a0)
		cmpa.w	#$CD7C,a0
		beq.s	loc_193C4
		move.l	#loc_193EC,(a0)
		bra.s	loc_193EC
; ---------------------------------------------------------------------------

loc_193C4:
		move.l	#loc_193CA,(a0)

loc_193CA:
		tst.b	$20(a0)
		beq.s	loc_193EC
		clr.b	$20(a0)
		move.w	($FFFFB010).w,$10(a0)
		move.w	($FFFFB014).w,$14(a0)
		moveq	#2,d2
		bsr.w	HyperSonic_Create_Spark
		move.b	#4,($FFFFF666).w

loc_193EC:


		tst.b	($FFFFFE19).w
		beq.w	loc_19486
		subq.b	#1,$24(a0)
		bpl.s	loc_1941C
		move.b	#1,$24(a0)
		addq.b	#1,$22(a0)
		cmpi.b	#3,$22(a0)
		bcs.s	loc_1941C
		move.b	#0,$22(a0)
		moveq	#0,d0
		move.w	d0,$30(a0)
		move.w	d0,$34(a0)

loc_1941C:

		move.b	$26(a0),d0
		addi.b	#-$10,$26(a0)
		jsr	(GetSineCosine).l
		asl.w	#3,d0
		asl.w	#3,d1
		move.w	d0,$18(a0)
		move.w	d1,$1A(a0)
		move.w	$18(a0),d0
		add.w	d0,$30(a0)
		move.w	$1A(a0),d1
		add.w	d1,$34(a0)
		move.b	$30(a0),d2
		ext.w	d2
		btst	#0,($FFFFB02A).w
		beq.s	loc_19458
		neg.w	d2

loc_19458:
		move.b	$34(a0),d3
		ext.w	d3
		add.w	($FFFFB010).w,d2
		add.w	($FFFFB014).w,d3
		move.w	d2,$10(a0)
		move.w	d3,$14(a0)
		andi.w	#$7FFF,$A(a0)
		tst.b	($FFFFB00A).w
		bpl.s	loc_19480
		ori.w	#$8000,$A(a0)

loc_19480:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_19486:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
Map_HyperSonicStars:include "General\Sprites\Sonic\Map - Hyper Sonic Stars.asm"

; ---------------------------------------------------------------------------

Obj_Insta_Shield:
					; SpawnLevelMainSprites_SpawnPlayers+BCo ...
		move.l	#Map_InstaShield,$C(a0)
		move.l	#DPLC_InstaShield,$3C(a0)
		move.l	#ArtUnc_InstaShield,$38(a0)
		move.b	#4,4(a0)
		move.w	#$80,8(a0)
		move.b	#$18,7(a0)
		move.b	#$18,6(a0)
		move.w	#$79C,$A(a0)
		move.w	#$F380,$40(a0)
		btst	#7,($FFFFB00A).w
		beq.s	loc_19518
		bset	#7,$A(a0)

loc_19518:
		move.w	#1,$20(a0)
		move.b	#-1,$34(a0)
		move.l	#loc_1952A,(a0)

loc_1952A:
		movea.w	$42(a0),a2
		btst	#1,$2B(a2)
		bne.s	locret_195A4
		move.w	$10(a2),$10(a0)
		move.w	$14(a2),$14(a0)
		move.b	$2A(a2),$2A(a0)
		andi.b	#1,$2A(a0)
		tst.b	($FFFFF7C6).w
		beq.s	loc_1955A
		ori.b	#2,$2A(a0)

loc_1955A:
		andi.w	#$7FFF,$A(a0)
		tst.w	$A(a2)
		bpl.s	loc_1956C
		ori.w	#$8000,$A(a0)

loc_1956C:
		lea	(Ani_InstaShield).l,a1
		jsr	(Animate_Sprite).l
		cmpi.b	#7,$22(a0)
		bne.s	loc_1958C
		tst.b	$2F(a2)
		beq.s	loc_1958C
		move.b	#2,$2F(a2)

loc_1958C:

		tst.b	$22(a0)
		beq.s	loc_1959A
		cmpi.b	#3,$22(a0)
		bne.s	loc_1959E

loc_1959A:
		bsr.w	PLCLoad_Shields

loc_1959E:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_195A4:
		rts
; ---------------------------------------------------------------------------

Obj_Fire_Shield:

		move.l	#Map_FireShield,$C(a0)
		move.l	#DPLC_FireShield,$3C(a0)
		move.l	#ArtUnc_FireShield,$38(a0)
		move.b	#4,4(a0)
		move.w	#$80,8(a0)
		move.b	#$18,7(a0)
		move.b	#$18,6(a0)
		move.w	#$79C,$A(a0)
		move.w	#$F380,$40(a0)
		btst	#7,($FFFFB00A).w
		beq.s	loc_195F0
		bset	#7,$A(a0)

loc_195F0:
		move.w	#1,$20(a0)
		move.b	#-1,$34(a0)
		move.l	#loc_19602,(a0)

loc_19602:
		movea.w	$42(a0),a2
		btst	#1,$2B(a2)
		bne.w	locret_19690
		cmpi.b	#$1C,$20(a2)
		beq.s	locret_19690
		btst	#0,$2B(a2)
		beq.w	loc_196B4
		btst	#6,$2A(a2)
		bne.s	loc_19692
		move.w	$10(a2),$10(a0)
		move.w	$14(a2),$14(a0)
		tst.b	$20(a0)
		bne.s	loc_19666
		move.b	$2A(a2),$2A(a0)
		andi.b	#1,$2A(a0)
		tst.b	($FFFFF7C6).w
		beq.s	loc_19654
		ori.b	#2,$2A(a0)

loc_19654:
		andi.w	#$7FFF,$A(a0)
		tst.w	$A(a2)
		bpl.s	loc_19666
		ori.w	#$8000,$A(a0)

loc_19666:

		lea	(Ani_FireShield).l,a1
		jsr	(Animate_Sprite).l
		move.w	#$80,8(a0)
		cmpi.b	#$F,$22(a0)
		bcs.s	loc_19686
		move.w	#$200,8(a0)

loc_19686:
		bsr.w	PLCLoad_Shields
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_19690:

		rts
; ---------------------------------------------------------------------------

loc_19692:
		andi.b	#$8E,$2B(a2)
		jsr	(Create_New_Sprite).l
		bne.w	loc_196B4
		move.l	#Obj_FireShield_Dissipate,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)

loc_196B4:

		andi.b	#$8E,$2B(a2)
		move.l	#Obj_Insta_Shield,(a0)
		rts
; ---------------------------------------------------------------------------

Obj_Lightning_Shield:

		move.l	#ArtUnc_LightningShield_Sparks,d1
		move.w	#$F760,d2
		move.w	#$50,d3
		jsr	(Add_To_DMA_Queue).l
		move.l	#Map_LightningShield,$C(a0)
		move.l	#DPLC_LightningShield,$3C(a0)
		move.l	#ArtUnc_LightningShield,$38(a0)
		move.b	#4,4(a0)
		move.w	#$80,8(a0)
		move.b	#$18,7(a0)
		move.b	#$18,6(a0)
		move.w	#$79C,$A(a0)
		move.w	#$F380,$40(a0)
		btst	#7,($FFFFB00A).w
		beq.s	loc_19720
		bset	#7,$A(a0)

loc_19720:
		move.w	#1,$20(a0)
		move.b	#-1,$34(a0)
		move.l	#loc_19732,(a0)

loc_19732:
		movea.w	$42(a0),a2
		btst	#1,$2B(a2)
		bne.w	locret_197C4
		cmpi.b	#$1C,$20(a2)
		beq.s	locret_197C4
		btst	#0,$2B(a2)
		beq.s	loc_197CC
		btst	#6,$2A(a2)
		bne.s	loc_197C6
		move.w	$10(a2),$10(a0)
		move.w	$14(a2),$14(a0)
		move.b	$2A(a2),$2A(a0)
		andi.b	#1,$2A(a0)
		tst.b	($FFFFF7C6).w
		beq.s	loc_1977C
		ori.b	#2,$2A(a0)

loc_1977C:
		andi.w	#$7FFF,$A(a0)
		tst.w	$A(a2)
		bpl.s	loc_1978E
		ori.w	#$8000,$A(a0)

loc_1978E:
		tst.b	$20(a0)
		beq.s	loc_1979A
		bsr.s	LightningShield_Create_Spark
		clr.b	$20(a0)

loc_1979A:
		lea	(Ani_LightningShield).l,a1
		jsr	(Animate_Sprite).l
		move.w	#$80,8(a0)
		cmpi.b	#$E,$22(a0)
		bcs.s	loc_197BA
		move.w	#$200,8(a0)

loc_197BA:
		bsr.w	PLCLoad_Shields
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_197C4:

		rts
; ---------------------------------------------------------------------------

loc_197C6:
		tst.w	($FFFFEE50).w
		beq.s	LightningShield_FlashWater

loc_197CC:
		andi.b	#$8E,$2B(a2)
		move.l	#Obj_Insta_Shield,(a0)
		rts
; ---------------------------------------------------------------------------

LightningShield_FlashWater:
		move.l	#LightningShield_Destroy,(a0)
		andi.b	#$8E,$2B(a2)
		lea	($FFFFF080).w,a1
		lea	($FFFFF000).w,a2
		move.w	#$1F,d0

loc_197F2:
		move.l	(a1),(a2)+
		move.l	#$EEE0EEE,(a1)+
		dbf	d0,loc_197F2
		move.w	#0,-$40(a1)
		move.b	#3,$24(a0)
		rts

; =============== S U B R O U T I N E =======================================


LightningShield_Create_Spark:
		moveq	#1,d2
; End of function LightningShield_Create_Spark


; =============== S U B R O U T I N E =======================================


HyperSonic_Create_Spark:
		lea	(SparkVelocities).l,a2
		moveq	#3,d1

loc_19816:
		bsr.w	Create_New_Sprite
		bne.s	locret_19862
		move.l	#Obj_LightningShield_Spark,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.b	#4,4(a1)
		move.w	#$80,8(a1)
		move.b	#8,7(a1)
		move.b	#8,6(a1)
		move.b	d2,$20(a1)
		move.w	(a2)+,$18(a1)
		move.w	(a2)+,$1A(a1)
		dbf	d1,loc_19816

locret_19862:
		rts
; End of function HyperSonic_Create_Spark

; ---------------------------------------------------------------------------
SparkVelocities:dc.w  $FE00, $FE00
		dc.w   $200, $FE00
		dc.w  $FE00,  $200
		dc.w   $200,  $200
; ---------------------------------------------------------------------------

Obj_LightningShield_Spark:
		jsr	(MoveSprite2).l
		addi.w	#$18,$1A(a0)
		lea	(Ani_LightningShield).l,a1
		jsr	(Animate_Sprite).l
		tst.b	5(a0)
		bne.s	loc_19898
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_19898:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

LightningShield_Destroy:
		subq.b	#1,$24(a0)
		bpl.s	locret_198BC
		move.l	#Obj_Insta_Shield,(a0)
		lea	($FFFFF000).w,a1
		lea	($FFFFF080).w,a2
		move.w	#$1F,d0

loc_198B6:
		move.l	(a1)+,(a2)+
		dbf	d0,loc_198B6

locret_198BC:
		rts
; ---------------------------------------------------------------------------

Obj_Bubble_Shield:

		move.l	#Map_BubbleShield,$C(a0)
		move.l	#DPLC_BubbleShield,$3C(a0)
		move.l	#ArtUnc_BubbleShield,$38(a0)
		move.b	#4,4(a0)
		move.w	#$80,8(a0)
		move.b	#$18,7(a0)
		move.b	#$18,6(a0)
		move.w	#$79C,$A(a0)
		move.w	#$F380,$40(a0)
		btst	#7,($FFFFB00A).w
		beq.s	loc_19908
		bset	#7,$A(a0)

loc_19908:
		move.w	#1,$20(a0)
		move.b	#-1,$34(a0)
		movea.w	$42(a0),a1
		bsr.w	Player_ResetAirTimer
		move.l	#loc_19922,(a0)

loc_19922:
		movea.w	$42(a0),a2
		btst	#1,$2B(a2)
		bne.s	locret_1998A
		cmpi.b	#$1C,$20(a2)
		beq.s	locret_1998A
		btst	#0,$2B(a2)
		beq.s	loc_1998C
		move.w	$10(a2),$10(a0)
		move.w	$14(a2),$14(a0)
		move.b	$2A(a2),$2A(a0)
		andi.b	#1,$2A(a0)
		tst.b	($FFFFF7C6).w
		beq.s	loc_19962
		ori.b	#2,$2A(a0)

loc_19962:
		andi.w	#$7FFF,$A(a0)
		tst.w	$A(a2)
		bpl.s	loc_19974
		ori.w	#$8000,$A(a0)

loc_19974:
		lea	(Ani_BubbleShield).l,a1
		jsr	(Animate_Sprite).l
		bsr.w	PLCLoad_Shields
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_1998A:

		rts
; ---------------------------------------------------------------------------

loc_1998C:
		andi.b	#$8E,$2B(a2)
		move.l	#Obj_Insta_Shield,(a0)
		rts

; =============== S U B R O U T I N E =======================================


PLCLoad_Shields:

		moveq	#0,d0
		move.b	$22(a0),d0
		cmp.b	$34(a0),d0
		beq.s	locret_199E8
		move.b	d0,$34(a0)
		movea.l	$3C(a0),a2
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d5
		subq.w	#1,d5
		bmi.s	locret_199E8
		move.w	$40(a0),d4

loc_199BE:
		moveq	#0,d1
		move.w	(a2)+,d1
		move.w	d1,d3
		lsr.w	#8,d3
		andi.w	#$F0,d3
		addi.w	#$10,d3
		andi.w	#$FFF,d1
		lsl.l	#5,d1
		add.l	$38(a0),d1
		move.w	d4,d2
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		dbf	d5,loc_199BE

locret_199E8:
					; PLCLoad_Shields+1Ej
		rts
; End of function PLCLoad_Shields

; ---------------------------------------------------------------------------
Ani_InstaShield:include "General\Sprites\Shields\Anim - Insta-Shield.asm"

Ani_FireShield:	include "General\Sprites\Shields\Anim - Fire Shield.asm"

Ani_LightningShield:include "General\Sprites\Shields\Anim - Lightning Shield.asm"

Ani_BubbleShield:include "General\Sprites\Shields\Anim - Bubble Shield.asm"

Map_FireShield:	include "General\Sprites\Shields\Map - Fire Shield.asm"

DPLC_FireShield:include "General\Sprites\Shields\DPLC - Fire Shield.asm"

Map_LightningShield:include "General\Sprites\Shields\Map - Lightning Shield.asm"

DPLC_LightningShield:include "General\Sprites\Shields\DPLC - Lightning Shield.asm"

Map_BubbleShield:include "General\Sprites\Shields\Map - Bubble Shield.asm"

DPLC_BubbleShield:include "General\Sprites\Shields\DPLC - Bubble Shield.asm"

Map_InstaShield:include "General\Sprites\Shields\Map - Insta-Shield.asm"

DPLC_InstaShield:include "General\Sprites\Shields\DPLC - Insta-Shield.asm"

; ---------------------------------------------------------------------------

Obj_HyperTails_Birds:

		lea	(ArtKosM_SuperTailsBirds).l,a1
		move.w	#$D000,d2
		jsr	(Queue_Kos_Module).l
		lea	(a0),a1
		moveq	#0,d0
		moveq	#3,d1

loc_1A186:
		move.l	#loc_1A19C,(a1)
		move.b	d0,$34(a1)
		addi.b	#$40,d0
		lea	$4A(a1),a1
		dbf	d1,loc_1A186

loc_1A19C:
		tst.b	($FFFFFF60).w
		beq.s	loc_1A1A4
		rts
; ---------------------------------------------------------------------------

loc_1A1A4:
		move.l	#Map_SuperTails_Birds,$C(a0)
		move.b	#4,4(a0)
		move.w	#$80,8(a0)
		move.b	#8,7(a0)
		move.b	#8,6(a0)
		move.w	#$8680,$A(a0)
		move.w	($FFFFB010).w,$10(a0)
		move.w	($FFFFB014).w,$14(a0)
		subi.w	#$C0,$10(a0)
		subi.w	#$C0,$14(a0)
		move.w	#0,$18(a0)
		move.w	#0,$1A(a0)
		move.l	#loc_1A1F4,(a0)

loc_1A1F4:
		tst.b	($FFFFF667).w
		bne.s	loc_1A226
		moveq	#0,d0
		move.w	d0,($FFFFB05A).w
		move.w	d0,($FFFFB05E).w
		move.b	d0,($FFFFB06A).w
		tst.b	$30(a0)
		beq.s	loc_1A216
		movea.w	$42(a0),a1
		move.b	d0,$2D(a1)

loc_1A216:
		move.b	d0,$30(a0)
		move.b	#$78,$32(a0)
		move.l	#loc_1A276,(a0)

loc_1A226:
		bsr.s	sub_1A292

loc_1A228:
		bsr.w	sub_1A37A
		addi.b	#2,$34(a0)
		tst.w	$18(a0)
		beq.s	loc_1A248
		bpl.s	loc_1A242
		bset	#0,4(a0)
		bra.s	loc_1A248
; ---------------------------------------------------------------------------

loc_1A242:
		bclr	#0,4(a0)

loc_1A248:

		andi.b	#-3,4(a0)
		tst.b	($FFFFF7C6).w
		beq.s	loc_1A25A
		ori.b	#2,4(a0)

loc_1A25A:
		subq.b	#1,$24(a0)
		bpl.s	loc_1A270
		move.b	#1,$24(a0)
		addq.b	#1,$22(a0)
		andi.b	#1,$22(a0)

loc_1A270:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_1A276:
		move.w	($FFFFB010).w,d2
		move.w	($FFFFB014).w,d3
		subi.w	#$C0,d2
		subi.w	#$C0,d3
		tst.b	4(a0)
		bmi.s	loc_1A228
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_1A292:
		tst.b	$30(a0)
		bne.s	loc_1A2D6
		tst.b	$32(a0)
		beq.s	loc_1A2A4
		subq.b	#1,$32(a0)
		bra.s	loc_1A2AC
; ---------------------------------------------------------------------------

loc_1A2A4:
		bsr.w	sub_1A3FE
		tst.w	d1
		bne.s	loc_1A2D6

loc_1A2AC:
		move.b	$34(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#3,d0
		asr.w	#4,d1
		move.w	($FFFFB010).w,d2
		move.w	($FFFFB014).w,d3
		subi.w	#$20,d3
		tst.b	($FFFFF7C6).w
		beq.s	loc_1A2D0
		addi.w	#$40,d3

loc_1A2D0:
		add.w	d0,d2
		add.w	d1,d3
		rts
; ---------------------------------------------------------------------------

loc_1A2D6:

		movea.w	$42(a0),a1
		move.w	$10(a1),d2
		move.w	$14(a1),d3
		tst.b	4(a1)
		bpl.s	loc_1A30A
		move.w	$10(a0),d0
		sub.w	d2,d0
		addi.w	#$C,d0
		cmpi.w	#$18,d0
		bcc.s	locret_1A31C
		move.w	$14(a0),d1
		sub.w	d3,d1
		addi.w	#$C,d1
		cmpi.w	#$18,d1
		bcc.s	locret_1A31C
		bsr.s	sub_1A31E

loc_1A30A:
		move.b	#0,$2D(a1)
		move.b	#0,$30(a0)
		move.b	#$78,$32(a0)

locret_1A31C:

		rts
; End of function sub_1A292


; =============== S U B R O U T I N E =======================================


sub_1A31E:
		move.b	$28(a1),d0
		beq.s	locret_1A330
		andi.b	#$C0,d0
		beq.s	loc_1A332
		cmpi.b	#$C0,d0
		beq.s	loc_1A360

locret_1A330:
		rts
; ---------------------------------------------------------------------------

loc_1A332:
		tst.b	$29(a1)
		beq.s	loc_1A35A
		move.b	$28(a1),$25(a1)
		move.w	#$B04A,d0
		move.b	d0,$1C(a1)
		move.b	#0,$28(a1)
		subq.b	#1,$29(a1)
		bne.s	loc_1A358
		bset	#7,$2A(a1)

loc_1A358:
		bra.s	loc_1A366
; ---------------------------------------------------------------------------

loc_1A35A:
		jmp	(loc_1052E).l
; ---------------------------------------------------------------------------

loc_1A360:
		ori.b	#2,$29(a1)

loc_1A366:
		move.w	$10(a0),($FFFFB05A).w
		move.w	$14(a0),($FFFFB05E).w
		move.b	#2,($FFFFB06A).w
		rts
; End of function sub_1A31E


; =============== S U B R O U T I N E =======================================


sub_1A37A:
		move.w	#$20,d1
		cmp.w	$10(a0),d2
		bge.s	loc_1A392
		neg.w	d1
		tst.w	$18(a0)
		bmi.s	loc_1A39C
		add.w	d1,d1
		add.w	d1,d1
		bra.s	loc_1A39C
; ---------------------------------------------------------------------------

loc_1A392:
		tst.w	$18(a0)
		bpl.s	loc_1A39C
		add.w	d1,d1
		add.w	d1,d1

loc_1A39C:

		add.w	d1,$18(a0)
		and.w	($FFFFEEAA).w,d3
		move.w	#$20,d1
		sub.w	$14(a0),d3
		bcc.s	loc_1A3CA
		cmpi.w	#-$500,d3
		ble.s	loc_1A3D0

loc_1A3B4:
		cmpi.w	#-$1000,$1A(a0)
		ble.s	loc_1A3D8

loc_1A3BC:
		neg.w	d1
		tst.w	$1A(a0)
		bmi.s	loc_1A3E2
		add.w	d1,d1
		add.w	d1,d1
		bra.s	loc_1A3E2
; ---------------------------------------------------------------------------

loc_1A3CA:
		cmpi.w	#$500,d3
		bge.s	loc_1A3B4

loc_1A3D0:
		cmpi.w	#$1000,$1A(a0)
		bge.s	loc_1A3BC

loc_1A3D8:
		tst.w	$1A(a0)
		bpl.s	loc_1A3E2
		add.w	d1,d1
		add.w	d1,d1

loc_1A3E2:

		add.w	d1,$1A(a0)
		jsr	(MoveSprite2).l
		move.w	($FFFFEEBC).w,d0
		sub.w	d0,$10(a0)
		move.w	($FFFFEEAA).w,d0
		and.w	d0,$14(a0)
		rts
; End of function sub_1A37A


; =============== S U B R O U T I N E =======================================


sub_1A3FE:
		moveq	#0,d1
		lea	($FFFFE380).w,a4
		move.w	(a4)+,d6
		beq.s	locret_1A432
		moveq	#0,d0
		addq.b	#2,($FFFFF66C).w
		cmp.b	($FFFFF66C).w,d6
		bhi.s	loc_1A41A
		move.b	#0,($FFFFF66C).w

loc_1A41A:
		move.b	($FFFFF66C).w,d0
		sub.w	d0,d6
		lea	(a4,d0.w),a4

loc_1A424:
		movea.w	(a4)+,a1
		move.b	$28(a1),d0
		beq.s	loc_1A42E
		bsr.s	sub_1A434

loc_1A42E:
		subq.w	#2,d6
		bne.s	loc_1A424

locret_1A432:
		rts
; End of function sub_1A3FE


; =============== S U B R O U T I N E =======================================


sub_1A434:
		tst.b	4(a1)
		bpl.s	locret_1A44C
		tst.b	$2D(a1)
		bne.s	locret_1A44C
		andi.b	#$C0,d0
		beq.s	loc_1A44E
		cmpi.b	#$C0,d0
		beq.s	loc_1A44E

locret_1A44C:
		rts
; ---------------------------------------------------------------------------

loc_1A44E:

		move.b	#-1,$2D(a1)
		move.w	a1,$42(a0)
		move.b	#1,$30(a0)
		moveq	#1,d1
		moveq	#2,d6
		rts
; End of function sub_1A434

; ---------------------------------------------------------------------------
Map_SuperTails_Birds:include "General\Sprites\Tails\Map - Super Tails birds.asm"

; ---------------------------------------------------------------------------

Obj_HyperSonicKnux_Trail:
					; Knux_JumpHeight+110o	...
		move.l	#Map_Knuckles,$C(a0)
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_1A4AC
		move.l	#Map_SuperSonic,$C(a0)

loc_1A4AC:
		move.w	#$680,$A(a0)
		move.w	#$100,8(a0)
		move.b	#$18,7(a0)
		move.b	#$18,6(a0)
		move.b	#4,4(a0)
		move.l	#loc_1A4D0,(a0)

loc_1A4D0:
		tst.b	($FFFFFE19).w
		beq.w	Delete_Current_Sprite
		moveq	#$C,d1
		btst	#0,($FFFFFE05).w
		beq.s	loc_1A4E4
		moveq	#$14,d1

loc_1A4E4:
		move.w	($FFFFEE26).w,d0
		lea	($FFFFE500).w,a1
		sub.b	d1,d0
		lea	(a1,d0.w),a1
		move.w	(a1)+,$10(a0)
		move.w	(a1)+,$14(a0)
		lea	($FFFFE400).w,a1

loc_1A4FE:
		move.b	3(a1,d0.w),$A(a0)
		move.b	($FFFFB022).w,$22(a0)
		move.b	($FFFFB004).w,4(a0)
		move.w	($FFFFB008).w,8(a0)
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------

Obj_Ring:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_1A528(pc,d0.w),d1
		jmp	off_1A528(pc,d1.w)
; ---------------------------------------------------------------------------
off_1A528:	dc.w loc_1A532-off_1A528

		dc.w loc_1A568-off_1A528; 1
		dc.w loc_1A572-off_1A528; 2
		dc.w loc_1A584-off_1A528; 3
		dc.w loc_1A592-off_1A528; 4
; ---------------------------------------------------------------------------

loc_1A532:
		addq.b	#2,5(a0)
		move.l	#Map_Ring,$C(a0)
		move.w	#$A6BC,$A(a0)
		move.b	#4,4(a0)
		move.w	#$100,8(a0)
		move.b	#$47,$28(a0)
		move.b	#8,7(a0)
		tst.w	($FFFFFFE8).w
		beq.s	loc_1A568
		move.w	#$63D2,$A(a0)

loc_1A568:

		move.b	($FFFFFEB3).w,$22(a0)
		bra.w	loc_1B662
; ---------------------------------------------------------------------------

loc_1A572:
		addq.b	#2,5(a0)
		move.b	#0,$28(a0)
		move.w	#$80,8(a0)
		bsr.s	GiveRing

loc_1A584:
		lea	(Ani_RingSparkle).l,a1
		bsr.w	Animate_Sprite
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------

loc_1A592:
		bra.w	Delete_Current_Sprite

; =============== S U B R O U T I N E =======================================


GiveRing:
		cmpi.w	#999,($FFFFFEC8).w
		bcc.s	loc_1A5A2
		addq.w	#1,($FFFFFEC8).w

loc_1A5A2:
		move.w	#$33,d0
		cmpi.w	#999,($FFFFFE20).w
		bcc.s	loc_1A5E8
		addq.w	#1,($FFFFFE20).w
		ori.b	#1,($FFFFFE1D).w
		cmpi.w	#100,($FFFFFE20).w
		bcs.s	loc_1A5E8
		bset	#1,($FFFFFE1B).w
		beq.s	loc_1A5D8
		cmpi.w	#200,($FFFFFE20).w
		bcs.s	loc_1A5E8
		bset	#2,($FFFFFE1B).w
		bne.s	loc_1A5E8

loc_1A5D8:
		addq.b	#1,($FFFFFE12).w
		addq.b	#1,($FFFFFE1C).w
		moveq	#$2A,d0
		jmp	(Play_Sound).l
; ---------------------------------------------------------------------------

loc_1A5E8:
		jmp	(Play_Sound_2).l
; End of function GiveRing

; ---------------------------------------------------------------------------
		rts
; ---------------------------------------------------------------------------

loc_1A5F0:
		cmpi.w	#999,($FFFFFECA).w
		bcc.s	loc_1A5FC
		addq.w	#1,($FFFFFECA).w

loc_1A5FC:
		cmpi.w	#999,($FFFFFED0).w
		bcc.s	loc_1A608
		addq.w	#1,($FFFFFED0).w

loc_1A608:
		tst.w	($FFFFFFE8).w
		beq.s	loc_1A5A2
		ori.b	#1,($FFFFFEBE).w
		move.w	#$33,d0
		cmpi.w	#100,($FFFFFED0).w
		bcs.s	loc_1A644
		bset	#1,($FFFFFEBF).w
		beq.s	loc_1A638
		cmpi.w	#200,($FFFFFED0).w
		bcs.s	loc_1A644
		bset	#2,($FFFFFEBF).w
		bne.s	loc_1A644

loc_1A638:
		addq.b	#1,($FFFFFEC6).w
		moveq	#$2A,d0
		jmp	(Play_Sound).l
; ---------------------------------------------------------------------------

loc_1A644:

		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

Obj_Bouncing_Ring:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_1A658(pc,d0.w),d1
		jmp	off_1A658(pc,d1.w)
; ---------------------------------------------------------------------------
off_1A658:	dc.w loc_1A67A-off_1A658

		dc.w loc_1A75C-off_1A658
		dc.w loc_1A7C2-off_1A658
		dc.w loc_1A7D6-off_1A658
		dc.w loc_1A7E4-off_1A658
; ---------------------------------------------------------------------------

Obj_Bouncing_Ring_Reverse_Gravity:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_1A670(pc,d0.w),d1
		jmp	off_1A670(pc,d1.w)
; ---------------------------------------------------------------------------
off_1A670:	dc.w loc_1A67A-off_1A670

		dc.w loc_1A7E8-off_1A670
		dc.w loc_1A7C2-off_1A670
		dc.w loc_1A7D6-off_1A670
		dc.w loc_1A7E4-off_1A670
; ---------------------------------------------------------------------------

loc_1A67A:

		move.l	#Obj_Bouncing_Ring,d6
		tst.b	($FFFFF7C6).w
		beq.s	loc_1A68C
		move.l	#Obj_Bouncing_Ring_Reverse_Gravity,d6

loc_1A68C:
		movea.l	a0,a1
		moveq	#0,d5
		move.w	($FFFFFE20).w,d5
		tst.b	$3F(a0)
		beq.s	loc_1A69E
		move.w	($FFFFFED0).w,d5

loc_1A69E:
		moveq	#$20,d0
		cmp.w	d0,d5
		bcs.s	loc_1A6A6
		move.w	d0,d5

loc_1A6A6:
		subq.w	#1,d5
		move.w	#$288,d4
		bra.s	loc_1A6B6
; ---------------------------------------------------------------------------

loc_1A6AE:
		bsr.w	Create_New_Sprite3
		bne.w	loc_1A738

loc_1A6B6:
		move.l	d6,(a1)
		addq.b	#2,5(a1)
		move.b	#8,$1E(a1)
		move.b	#8,$1F(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.l	#Map_Ring,$C(a1)
		move.w	#$A6BC,$A(a1)
		move.b	#$84,4(a1)
		move.w	#$180,8(a1)
		move.b	#$47,$28(a1)
		move.b	#8,7(a1)
		move.b	#-1,($FFFFFEB6).w
		tst.w	d4
		bmi.s	loc_1A728
		move.w	d4,d0
		jsr	(GetSineCosine).l
		move.w	d4,d2
		lsr.w	#8,d2
		asl.w	d2,d0
		asl.w	d2,d1
		move.w	d0,d2
		move.w	d1,d3
		addi.b	#$10,d4
		bcc.s	loc_1A728
		subi.w	#$80,d4
		bcc.s	loc_1A728
		move.w	#$288,d4

loc_1A728:

		move.w	d2,$18(a1)
		move.w	d3,$1A(a1)
		neg.w	d2
		neg.w	d4
		dbf	d5,loc_1A6AE

loc_1A738:
		move.w	#$FFB9,d0
		jsr	(Play_Sound_2).l
		move.w	#0,($FFFFFE20).w
		move.b	#$80,($FFFFFE1D).w
		move.b	#0,($FFFFFE1B).w
		tst.b	($FFFFF7C6).w
		bne.w	loc_1A7E8

loc_1A75C:
		move.b	($FFFFFEB7).w,$22(a0)
		bsr.w	MoveSprite2
		addi.w	#$18,$1A(a0)
		bmi.s	loc_1A7B0
		move.b	($FFFFFE0F).w,d0
		add.b	d7,d0
		andi.b	#7,d0
		bne.s	loc_1A7B0
		tst.b	4(a0)
		bpl.s	loc_1A79C
		jsr	(sub_F994).l
		tst.w	d1
		bpl.s	loc_1A79C
		add.w	d1,$14(a0)
		move.w	$1A(a0),d0
		asr.w	#2,d0
		sub.w	d0,$1A(a0)
		neg.w	$1A(a0)

loc_1A79C:

		tst.b	($FFFFFEB6).w
		beq.s	loc_1A7E4
		move.w	($FFFFEE1A).w,d0
		addi.w	#$E0,d0
		cmp.w	$14(a0),d0
		bcs.s	loc_1A7E4

loc_1A7B0:

		jsr	(Add_SpriteToCollisionResponseList).l
		move.w	($FFFFEEBC).w,d0
		sub.w	d0,$10(a0)
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------

loc_1A7C2:

		addq.b	#2,5(a0)
		move.b	#0,$28(a0)
		move.w	#$80,8(a0)
		bsr.w	GiveRing

loc_1A7D6:

		lea	(Ani_RingSparkle).l,a1
		bsr.w	Animate_Sprite
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------

loc_1A7E4:

		bra.w	Delete_Current_Sprite
; ---------------------------------------------------------------------------

loc_1A7E8:

		move.b	($FFFFFEB7).w,$22(a0)
		bsr.w	MoveSprite_TestGravity2
		addi.w	#$18,$1A(a0)
		bmi.s	loc_1A83C
		move.b	($FFFFFE0F).w,d0
		add.b	d7,d0
		andi.b	#7,d0
		bne.s	loc_1A83C
		tst.b	4(a0)
		bpl.s	loc_1A828
		jsr	(sub_FCA0).l
		tst.w	d1
		bpl.s	loc_1A828
		sub.w	d1,$14(a0)
		move.w	$1A(a0),d0
		asr.w	#2,d0
		sub.w	d0,$1A(a0)
		neg.w	$1A(a0)

loc_1A828:

		tst.b	($FFFFFEB6).w
		beq.s	loc_1A7E4
		move.w	($FFFFEE1A).w,d0
		addi.w	#$E0,d0
		cmp.w	$14(a0),d0
		bcs.s	loc_1A7E4

loc_1A83C:

		jsr	(Add_SpriteToCollisionResponseList).l
		move.w	($FFFFEEBC).w,d0
		sub.w	d0,$10(a0)
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------

Obj_Attracted_Ring:
		move.l	#Map_Ring,$C(a0)
		move.w	#$A6BC,$A(a0)
		move.b	#4,4(a0)
		move.w	#$100,8(a0)
		move.b	#$47,$28(a0)
		move.b	#8,7(a0)
		move.b	#8,6(a0)
		move.b	#8,$1E(a0)
		move.b	#8,$1F(a0)
		move.l	#loc_1A88C,(a0)

loc_1A88C:
		tst.b	5(a0)
		bne.s	AttractedRing_GiveRing
		bsr.w	AttractedRing_Move
		btst	#5,($FFFFB02B).w
		bne.s	loc_1A8B0
		move.l	#Obj_Bouncing_Ring,(a0)
		move.b	#2,5(a0)
		move.b	#-1,($FFFFFEB6).w

loc_1A8B0:
		subq.b	#1,$24(a0)
		bpl.s	loc_1A8C6
		move.b	#3,$24(a0)
		addq.b	#1,$22(a0)
		andi.b	#3,$22(a0)

loc_1A8C6:
		move.w	$10(a0),d0
		andi.w	#$FF80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_1A8E4
		jsr	(Add_SpriteToCollisionResponseList).l
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------

loc_1A8E4:
		move.w	$48(a0),d0
		beq.s	loc_1A8F0
		movea.w	d0,a2
		bclr	#7,(a2)

loc_1A8F0:
		move.w	(Vectors+$30).w,d0
		beq.s	loc_1A8FC
		movea.w	d0,a2
		move.w	#0,(a2)

loc_1A8FC:
		bra.w	Delete_Current_Sprite
; ---------------------------------------------------------------------------

AttractedRing_GiveRing:
		move.b	#0,$28(a0)
		move.w	#$80,8(a0)
		subq.w	#1,($FFFFFF04).w
		bsr.w	GiveRing
		move.l	#loc_1A920,(a0)
		move.b	#0,5(a0)

loc_1A920:
		tst.b	5(a0)
		bne.s	loc_1A934
		lea	(Ani_RingSparkle).l,a1
		bsr.w	Animate_Sprite
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------

loc_1A934:
		bra.w	Delete_Current_Sprite

; =============== S U B R O U T I N E =======================================


AttractedRing_Move:
		move.w	#$30,d1
		move.w	($FFFFB010).w,d0
		cmp.w	$10(a0),d0
		bcc.s	loc_1A954
		neg.w	d1
		tst.w	$18(a0)
		bmi.s	loc_1A95E
		add.w	d1,d1
		add.w	d1,d1
		bra.s	loc_1A95E
; ---------------------------------------------------------------------------

loc_1A954:
		tst.w	$18(a0)
		bpl.s	loc_1A95E
		add.w	d1,d1
		add.w	d1,d1

loc_1A95E:
					; AttractedRing_Move+1Aj ...
		add.w	d1,$18(a0)
		move.w	#$30,d1
		move.w	($FFFFB014).w,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_1A97E
		neg.w	d1
		tst.w	$1A(a0)
		bmi.s	loc_1A988
		add.w	d1,d1
		add.w	d1,d1
		bra.s	loc_1A988
; ---------------------------------------------------------------------------

loc_1A97E:
		tst.w	$1A(a0)
		bpl.s	loc_1A988
		add.w	d1,d1
		add.w	d1,d1

loc_1A988:
					; AttractedRing_Move+44j ...
		add.w	d1,$1A(a0)
		jmp	(MoveSprite2).l
; End of function AttractedRing_Move

; ---------------------------------------------------------------------------
Ani_RingSparkle:	include "General\Sprites\Ring\Anim - Ring Sparkle.asm"

Map_Ring:	include "General\Sprites\Ring\Map - Ring.asm"

; ---------------------------------------------------------------------------

loc_1A9EE:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_1A9FC(pc,d0.w),d1
		jmp	off_1A9FC(pc,d1.w)
; ---------------------------------------------------------------------------
off_1A9FC:	dc.w loc_1AA02-off_1A9FC

		dc.w loc_1AA56-off_1A9FC
		dc.w loc_1AA62-off_1A9FC
; ---------------------------------------------------------------------------

loc_1AA02:
		moveq	#0,d1
		move.w	$3C(a0),d1
		swap	d1
		move.l	$34(a0),d0
		sub.l	d1,d0
		asr.l	#4,d0
		sub.l	d0,$34(a0)
		move.w	$34(a0),$10(a0)
		moveq	#0,d1
		move.w	$3E(a0),d1
		swap	d1
		move.l	$38(a0),d0
		sub.l	d1,d0
		asr.l	#4,d0
		sub.l	d0,$38(a0)
		move.w	$38(a0),$14(a0)
		lea	Ani_Ring(pc),a1
		bsr.w	Animate_Sprite
		subq.w	#1,$40(a0)
		bne.w	Draw_Sprite
		movea.l	$2E(a0),a1
		subq.w	#1,(a1)
		bsr.w	GiveRing
		addi.b	#2,5(a0)

loc_1AA56:
		lea	Ani_RingSparkle(pc),a1
		bsr.w	Animate_Sprite
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------

loc_1AA62:
		bra.w	Delete_Current_Sprite
; ---------------------------------------------------------------------------
Ani_Ring:	include "General\Sprites\Ring\Anim - Ring.asm"


; =============== S U B R O U T I N E =======================================


Init_SpriteTable:
		clr.w	($FFFFEF3A).w
		clr.l	($FFFFEF3C).w
		tst.w	($FFFFFFE8).w
		beq.s	loc_1AA9E
		lea	($FFFFF800).w,a0
		bsr.s	Init_SpriteTable2
		bsr.s	Init_SpriteTable_2Player
		lea	($FF7880).l,a0
		bsr.s	Init_SpriteTable2
		bsr.s	Init_SpriteTable_2Player
		lea	($FF7B00).l,a0
		bsr.s	Init_SpriteTable2
		lea	($FF7D80).l,a0
		bra.s	Init_SpriteTable2
; ---------------------------------------------------------------------------

loc_1AA9E:
		lea	($FFFFF800).w,a0
; End of function Init_SpriteTable


; =============== S U B R O U T I N E =======================================


Init_SpriteTable2:

		moveq	#0,d0
		moveq	#1,d1
		moveq	#$4F,d7

loc_1AAA8:
		move.w	d0,(a0)
		move.b	d1,3(a0)
		addq.w	#1,d1
		addq.w	#8,a0
		dbf	d7,loc_1AAA8
		move.b	d0,-5(a0)
		rts
; End of function Init_SpriteTable2


; =============== S U B R O U T I N E =======================================


Init_SpriteTable_2Player:

		lea	-$280(a0),a0
		move.l	#$EB0301,(a0)+
		move.l	#1,(a0)+
		move.l	#$EB0302,(a0)+
		move.l	#0,(a0)
		rts
; End of function Init_SpriteTable_2Player


; =============== S U B R O U T I N E =======================================


Process_Sprites:

		tst.b	($FFFFF623).w
		bne.s	locret_1AB0C
		lea	($FFFFB000).w,a0
		tst.w	($FFFFFFE8).w
		bne.s	loc_1AAFA
		cmpi.b	#$C,($FFFFB005).w
		beq.s	loc_1AAFA
		cmpi.b	#6,($FFFFB005).w
		bcc.s	loc_1AB0E

loc_1AAFA:
					; Process_Sprites+16j
		moveq	#$6D,d7
; End of function Process_Sprites


; =============== S U B R O U T I N E =======================================


sub_1AAFC:

		move.l	(a0),d0
		beq.s	loc_1AB04
		movea.l	d0,a1
		jsr	(a1)

loc_1AB04:
		lea	$4A(a0),a0
		dbf	d7,sub_1AAFC

locret_1AB0C:
		rts
; End of function sub_1AAFC

; ---------------------------------------------------------------------------

loc_1AB0E:
		moveq	#3,d7
		bsr.s	sub_1AAFC
		moveq	#$59,d7
		bsr.s	sub_1AB1A
		moveq	#$F,d7
		bra.s	sub_1AAFC

; =============== S U B R O U T I N E =======================================


sub_1AB1A:

		move.l	(a0),d0
		beq.s	loc_1AB28
		tst.b	4(a0)
		bpl.s	loc_1AB28
		jsr	Draw_Sprite(pc)

loc_1AB28:
		lea	$4A(a0),a0
		dbf	d7,sub_1AB1A
		rts
; End of function sub_1AB1A


; =============== S U B R O U T I N E =======================================


MoveSprite:

		move.w	$18(a0),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$10(a0)
		move.w	$1A(a0),d0
		addi.w	#$38,$1A(a0)
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$14(a0)
		rts
; End of function MoveSprite


; =============== S U B R O U T I N E =======================================


MoveSprite2:

		move.w	$18(a0),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$10(a0)
		move.w	$1A(a0),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$14(a0)
		rts
; End of function MoveSprite2


; =============== S U B R O U T I N E =======================================


MoveSprite_TestGravity:

		tst.b	($FFFFF7C6).w
		beq.s	MoveSprite
		move.w	$18(a0),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$10(a0)
		move.w	$1A(a0),d0
		addi.w	#$38,$1A(a0)
		neg.w	d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$14(a0)
		rts
; End of function MoveSprite_TestGravity


; =============== S U B R O U T I N E =======================================


MoveSprite_TestGravity2:

		tst.b	($FFFFF7C6).w
		beq.s	MoveSprite2
		move.w	$18(a0),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$10(a0)
		move.w	$1A(a0),d0
		neg.w	d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$14(a0)
		rts
; End of function MoveSprite_TestGravity2


; =============== S U B R O U T I N E =======================================


Delete_Current_Sprite:

		movea.l	a0,a1
; End of function Delete_Current_Sprite


; =============== S U B R O U T I N E =======================================


Delete_Referenced_Sprite:

		moveq	#$11,d0
		moveq	#0,d1

loc_1ABBC:
		move.l	d1,(a1)+
		dbf	d0,loc_1ABBC
		move.w	d1,(a1)+
		rts
; End of function Delete_Referenced_Sprite


; =============== S U B R O U T I N E =======================================


Draw_Sprite:

		lea	($FFFFAC00).w,a1
		adda.w	8(a0),a1

loc_1ABCE:
		cmpi.w	#$7E,(a1)
		bcc.s	loc_1ABDC
		addq.w	#2,(a1)
		adda.w	(a1),a1
		move.w	a0,(a1)

locret_1ABDA:
		rts
; ---------------------------------------------------------------------------

loc_1ABDC:
		cmpa.w	#$AF80,a1
		beq.s	locret_1ABDA
		adda.w	#$80,a1
		bra.s	loc_1ABCE
; End of function Draw_Sprite


; =============== S U B R O U T I N E =======================================


Animate_Sprite:

		moveq	#0,d0
		move.b	$20(a0),d0
		cmp.b	$21(a0),d0
		beq.s	loc_1AC00
		move.b	d0,$21(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)

loc_1AC00:
		subq.b	#1,$24(a0)
		bcc.s	locret_1AC36
		add.w	d0,d0
		adda.w	(a1,d0.w),a1
		move.b	(a1),$24(a0)
		moveq	#0,d1
		move.b	$23(a0),d1
		move.b	1(a1,d1.w),d0
		bmi.s	loc_1AC38

loc_1AC1C:
		move.b	d0,$22(a0)
		move.b	$2A(a0),d1
		andi.b	#3,d1
		andi.b	#-4,4(a0)
		or.b	d1,4(a0)
		addq.b	#1,$23(a0)

locret_1AC36:
		rts
; ---------------------------------------------------------------------------

loc_1AC38:
		addq.b	#1,d0			; Code FF - Repeat animation from beginning
		bne.s	loc_1AC48
		move.b	#0,$23(a0)
		move.b	1(a1),d0
		bra.s	loc_1AC1C
; ---------------------------------------------------------------------------

loc_1AC48:
		addq.b	#1,d0			; Code FE - Repeat animation from earlier point
		bne.s	loc_1AC5C
		move.b	2(a1,d1.w),d0
		sub.b	d0,$23(a0)
		sub.b	d0,d1
		move.b	1(a1,d1.w),d0
		bra.s	loc_1AC1C
; ---------------------------------------------------------------------------

loc_1AC5C:
		addq.b	#1,d0			; Code FD - Start new animation
		bne.s	loc_1AC68
		move.b	2(a1,d1.w),$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_1AC68:
		addq.b	#1,d0			; Code FC - Increment routine counter
		bne.s	loc_1AC7A
		addq.b	#2,5(a0)
		clr.b	$24(a0)
		addq.b	#1,$23(a0)
		rts
; ---------------------------------------------------------------------------

loc_1AC7A:
		addq.b	#1,d0			; Code FB - Move offscreen (?)
		bne.s	locret_1AC86
		move.w	#$7F00,$10(a0)
		rts
; ---------------------------------------------------------------------------

locret_1AC86:
		rts
; End of function Animate_Sprite


; =============== S U B R O U T I N E =======================================


Animate_SpriteIrregularDelay:

		moveq	#0,d0
		move.b	$20(a0),d0
		cmp.b	$21(a0),d0
		beq.s	loc_1ACA0
		move.b	d0,$21(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)

loc_1ACA0:
		subq.b	#1,$24(a0)
		bcc.s	locret_1ACDA
		add.w	d0,d0
		adda.w	(a1,d0.w),a1
		moveq	#0,d1
		move.b	$23(a0),d1
		add.w	d1,d1
		move.b	(a1,d1.w),d0
		bmi.s	loc_1ACDC

loc_1ACBA:
		move.b	1(a1,d1.w),$24(a0)
		move.b	d0,$22(a0)
		move.b	$2A(a0),d1
		andi.b	#3,d1
		andi.b	#-4,4(a0)
		or.b	d1,4(a0)
		addq.b	#1,$23(a0)

locret_1ACDA:
		rts
; ---------------------------------------------------------------------------

loc_1ACDC:
		addq.b	#1,d0
		bne.s	loc_1ACEA
		moveq	#0,d1
		move.b	d1,$23(a0)
		move.b	(a1),d0
		bra.s	loc_1ACBA
; ---------------------------------------------------------------------------

loc_1ACEA:
		addq.b	#1,d0
		bne.s	loc_1AD00
		move.b	1(a1,d1.w),d0
		sub.b	d0,$23(a0)
		add.w	d0,d0
		sub.b	d0,d1
		move.b	(a1,d1.w),d0
		bra.s	loc_1ACBA
; ---------------------------------------------------------------------------

loc_1AD00:
		addq.b	#1,d0
		bne.s	loc_1AD0C
		move.b	1(a1,d1.w),$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_1AD0C:
		addq.b	#1,d0
		bne.s	locret_1AD1E
		addq.b	#2,5(a0)
		clr.b	$24(a0)
		addq.b	#1,$23(a0)
		rts
; ---------------------------------------------------------------------------

locret_1AD1E:
		rts
; End of function Animate_SpriteIrregularDelay


; =============== S U B R O U T I N E =======================================


Render_Sprites:

		tst.w	($FFFFFFE8).w
		bne.w	loc_1B1F4
		moveq	#$4F,d7
		moveq	#0,d6
		lea	($FFFFAC00).w,a5
		lea	($FFFFEE80).w,a3
		lea	($FFFFF800).w,a6
		tst.b	($FFFFF711).w
		beq.s	loc_1AD4A
		jsr	(sub_DB44).l
		jsr	(sub_EB86).l

loc_1AD4A:
		tst.w	(a5)
		beq.w	loc_1ADE6
		lea	2(a5),a4

loc_1AD54:
		movea.w	(a4)+,a0
		andi.b	#$7F,4(a0)
		move.b	4(a0),d6
		move.w	$10(a0),d0
		move.w	$14(a0),d1
		btst	#6,d6
		bne.w	loc_1AE58
		btst	#2,d6
		beq.s	loc_1ADB2
		moveq	#0,d2
		move.b	7(a0),d2
		sub.w	(a3),d0
		move.w	d0,d3
		add.w	d2,d3
		bmi.s	loc_1ADE0
		move.w	d0,d3
		sub.w	d2,d3
		cmpi.w	#$140,d3
		bge.s	loc_1ADE0
		addi.w	#$80,d0
		sub.w	4(a3),d1
		move.b	6(a0),d2
		add.w	d2,d1
		and.w	($FFFFEEAA).w,d1
		move.w	d2,d3
		add.w	d2,d2
		addi.w	#$E0,d2
		cmp.w	d2,d1
		bcc.s	loc_1ADE0
		addi.w	#$80,d1
		sub.w	d3,d1

loc_1ADB2:
		ori.b	#$80,4(a0)
		tst.w	d7
		bmi.s	loc_1ADE0
		movea.l	$C(a0),a1
		moveq	#0,d4
		btst	#5,d6
		bne.s	loc_1ADD8
		move.b	$22(a0),d4
		add.w	d4,d4
		adda.w	(a1,d4.w),a1
		move.w	(a1)+,d4
		subq.w	#1,d4
		bmi.s	loc_1ADE0

loc_1ADD8:
		move.w	$A(a0),d5
		jsr	sub_1AF6C(pc)

loc_1ADE0:
					; Render_Sprites+6Cj ...
		subq.w	#2,(a5)
		bne.w	loc_1AD54

loc_1ADE6:
		cmpa.l	#$FFFFAC00,a5
		bne.s	loc_1ADFC
		cmpi.b	#9,($FFFFFE10).w
		bne.s	loc_1ADFC
		jsr	(sub_1CB68).l

loc_1ADFC:
					; Render_Sprites+D4j
		lea	$80(a5),a5
		cmpa.l	#$FFFFB000,a5
		bcs.w	loc_1AD4A
		move.w	d7,d6
		bmi.s	loc_1AE18
		moveq	#0,d0

loc_1AE10:
		move.w	d0,(a6)
		addq.w	#8,a6
		dbf	d7,loc_1AE10

loc_1AE18:
		subi.w	#$4F,d6
		neg.w	d6
		move.b	d6,($FFFFF62C).w
		tst.w	($FFFFEF3A).w
		beq.s	locret_1AE56
		cmpi.b	#6,($FFFFB005).w
		bcc.s	loc_1AE34
		clr.w	($FFFFEF3A).w

loc_1AE34:
		lea	($FFFFF7FC).w,a0
		move.w	#$7C0,d0
		moveq	#$4E,d1

loc_1AE3E:
					; Render_Sprites+134j
		addq.w	#8,a0
		cmp.w	(a0),d0
		dbeq	d1,loc_1AE3E
		bne.s	locret_1AE56
		move.w	#1,2(a0)
		clr.w	$A(a0)
		subq.w	#1,d1
		bpl.s	loc_1AE3E

locret_1AE56:
					; Render_Sprites+126j
		rts
; ---------------------------------------------------------------------------

loc_1AE58:
		btst	#2,d6
		bne.s	loc_1AEA2
		moveq	#0,d2
		move.b	7(a0),d2
		subi.w	#$80,d0
		move.w	d0,d3
		add.w	d2,d3
		bmi.w	loc_1ADE0
		move.w	d0,d3
		sub.w	d2,d3
		cmpi.w	#$140,d3
		bge.w	loc_1ADE0
		addi.w	#$80,d0
		move.b	6(a0),d2
		subi.w	#$80,d1
		move.w	d1,d3
		add.w	d2,d3
		bmi.w	loc_1ADE0
		move.w	d1,d3
		sub.w	d2,d3
		cmpi.w	#$E0,d3
		bge.w	loc_1ADE0
		addi.w	#$80,d1
		bra.s	loc_1AEE4
; ---------------------------------------------------------------------------

loc_1AEA2:
		moveq	#0,d2
		move.b	7(a0),d2
		sub.w	(a3),d0
		move.w	d0,d3
		add.w	d2,d3
		bmi.w	loc_1ADE0
		move.w	d0,d3
		sub.w	d2,d3
		cmpi.w	#$140,d3
		bge.w	loc_1ADE0
		addi.w	#$80,d0
		sub.w	4(a3),d1
		move.b	6(a0),d2
		add.w	d2,d1
		and.w	($FFFFEEAA).w,d1
		move.w	d2,d3
		add.w	d2,d2
		addi.w	#$E0,d2
		cmp.w	d2,d1
		bcc.w	loc_1ADE0
		addi.w	#$80,d1
		sub.w	d3,d1

loc_1AEE4:
		ori.b	#$80,4(a0)
		tst.w	d7
		bmi.w	loc_1ADE0
		move.w	$A(a0),d5
		movea.l	$C(a0),a2
		moveq	#0,d4
		move.b	$22(a0),d4
		beq.s	loc_1AF1C
		add.w	d4,d4
		lea	(a2),a1
		adda.w	(a1,d4.w),a1
		move.w	(a1)+,d4
		subq.w	#1,d4
		bmi.s	loc_1AF1C
		move.w	d6,d3
		jsr	sub_1B070(pc)
		move.w	d3,d6
		tst.w	d7
		bmi.w	loc_1ADE0

loc_1AF1C:
					; Render_Sprites+1ECj
		move.w	$16(a0),d3
		subq.w	#1,d3
		bcs.w	loc_1ADE0
		lea	$18(a0),a0

loc_1AF2A:
		move.w	(a0)+,d0
		move.w	(a0)+,d1
		btst	#2,d6
		beq.s	loc_1AF46
		sub.w	(a3),d0
		addi.w	#$80,d0
		sub.w	4(a3),d1
		addi.w	#$80,d1
		and.w	($FFFFEEAA).w,d1

loc_1AF46:
		addq.w	#1,a0
		moveq	#0,d4
		move.b	(a0)+,d4
		add.w	d4,d4
		lea	(a2),a1
		adda.w	(a1,d4.w),a1
		move.w	(a1)+,d4
		subq.w	#1,d4
		bmi.s	loc_1AF62
		move.w	d6,-(sp)
		jsr	sub_1B070(pc)
		move.w	(sp)+,d6

loc_1AF62:
		tst.w	d7
		dbmi	d3,loc_1AF2A
		bra.w	loc_1ADE0
; End of function Render_Sprites


; =============== S U B R O U T I N E =======================================


sub_1AF6C:

		lsr.b	#1,d6
		bcs.s	loc_1AF9E
		lsr.b	#1,d6
		bcs.w	loc_1B038

loc_1AF76:
		move.b	(a1)+,d2
		ext.w	d2
		add.w	d1,d2
		move.w	d2,(a6)+
		move.b	(a1)+,(a6)+
		addq.w	#1,a6
		move.w	(a1)+,d2
		add.w	d5,d2
		move.w	d2,(a6)+
		move.w	(a1)+,d2
		add.w	d0,d2
		andi.w	#$1FF,d2
		bne.s	loc_1AF94
		addq.w	#1,d2

loc_1AF94:
		move.w	d2,(a6)+
		subq.w	#1,d7
		dbmi	d4,loc_1AF76
		rts
; ---------------------------------------------------------------------------

loc_1AF9E:
		lsr.b	#1,d6
		bcs.s	loc_1AFE8

loc_1AFA2:
		move.b	(a1)+,d2
		ext.w	d2
		add.w	d1,d2
		move.w	d2,(a6)+
		move.b	(a1)+,d6
		move.b	d6,(a6)+
		addq.w	#1,a6
		move.w	(a1)+,d2
		add.w	d5,d2
		eori.w	#$800,d2
		move.w	d2,(a6)+
		move.w	(a1)+,d2
		neg.w	d2
		move.b	byte_1AFD8(pc,d6.w),d6
		sub.w	d6,d2
		add.w	d0,d2
		andi.w	#$1FF,d2
		bne.s	loc_1AFCE
		addq.w	#1,d2

loc_1AFCE:
		move.w	d2,(a6)+
		subq.w	#1,d7
		dbmi	d4,loc_1AFA2
		rts
; ---------------------------------------------------------------------------
byte_1AFD8:	dc.b 8
		dc.b 8
		dc.b 8
		dc.b 8
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $18
		dc.b $18
		dc.b $18
		dc.b $18
		dc.b $20
		dc.b $20
		dc.b $20
		dc.b $20
; ---------------------------------------------------------------------------

loc_1AFE8:

		move.b	(a1)+,d2
		ext.w	d2
		neg.w	d2
		move.b	(a1),d6
		move.b	byte_1B028(pc,d6.w),d6
		sub.w	d6,d2
		add.w	d1,d2
		move.w	d2,(a6)+
		move.b	(a1)+,d6
		move.b	d6,(a6)+
		addq.w	#1,a6
		move.w	(a1)+,d2
		add.w	d5,d2
		eori.w	#$1800,d2
		move.w	d2,(a6)+
		move.w	(a1)+,d2
		neg.w	d2
		move.b	byte_1AFD8(pc,d6.w),d6
		sub.w	d6,d2
		add.w	d0,d2
		andi.w	#$1FF,d2
		bne.s	loc_1B01E
		addq.w	#1,d2

loc_1B01E:
		move.w	d2,(a6)+
		subq.w	#1,d7
		dbmi	d4,loc_1AFE8
		rts
; ---------------------------------------------------------------------------
byte_1B028:	dc.b 8
		dc.b $10
		dc.b $18
		dc.b $20
		dc.b 8
		dc.b $10
		dc.b $18
		dc.b $20
		dc.b 8
		dc.b $10
		dc.b $18
		dc.b $20
		dc.b 8
		dc.b $10
		dc.b $18
		dc.b $20
; ---------------------------------------------------------------------------

loc_1B038:

		move.b	(a1)+,d2
		ext.w	d2
		neg.w	d2
		move.b	(a1)+,d6
		move.b	d6,2(a6)
		move.b	byte_1B028(pc,d6.w),d6
		sub.w	d6,d2
		add.w	d1,d2
		move.w	d2,(a6)+
		addq.w	#2,a6
		move.w	(a1)+,d2
		add.w	d5,d2
		eori.w	#$1000,d2
		move.w	d2,(a6)+
		move.w	(a1)+,d2
		add.w	d0,d2
		andi.w	#$1FF,d2
		bne.s	loc_1B066
		addq.w	#1,d2

loc_1B066:
		move.w	d2,(a6)+
		subq.w	#1,d7
		dbmi	d4,loc_1B038
		rts
; End of function sub_1AF6C


; =============== S U B R O U T I N E =======================================


sub_1B070:
					; Render_Sprites+23Ct ...
		lsr.b	#1,d6
		bcs.s	loc_1B0C2
		lsr.b	#1,d6
		bcs.w	loc_1B19C

loc_1B07A:

		move.b	(a1)+,d2
		ext.w	d2
		add.w	d1,d2
		cmpi.w	#$60,d2
		bls.s	loc_1B0BA
		cmpi.w	#$160,d2
		bcc.s	loc_1B0BA
		move.w	d2,(a6)+
		move.b	(a1)+,(a6)+
		addq.w	#1,a6
		move.w	(a1)+,d2
		add.w	d5,d2
		move.w	d2,(a6)+
		move.w	(a1)+,d2
		add.w	d0,d2
		cmpi.w	#$60,d2
		bls.s	loc_1B0B2
		cmpi.w	#$1C0,d2
		bcc.s	loc_1B0B2
		move.w	d2,(a6)+
		subq.w	#1,d7
		dbmi	d4,loc_1B07A
		rts
; ---------------------------------------------------------------------------

loc_1B0B2:

		subq.w	#6,a6
		dbf	d4,loc_1B07A
		rts
; ---------------------------------------------------------------------------

loc_1B0BA:

		addq.w	#5,a1
		dbf	d4,loc_1B07A
		rts
; ---------------------------------------------------------------------------

loc_1B0C2:
		lsr.b	#1,d6
		bcs.s	loc_1B12C

loc_1B0C6:

		move.b	(a1)+,d2
		ext.w	d2
		add.w	d1,d2
		cmpi.w	#$60,d2
		bls.s	loc_1B114
		cmpi.w	#$160,d2
		bcc.s	loc_1B114
		move.w	d2,(a6)+
		move.b	(a1)+,d6
		move.b	d6,(a6)+
		addq.w	#1,a6
		move.w	(a1)+,d2
		add.w	d5,d2
		eori.w	#$800,d2
		move.w	d2,(a6)+
		move.w	(a1)+,d2
		neg.w	d2
		move.b	byte_1B11C(pc,d6.w),d6
		sub.w	d6,d2
		add.w	d0,d2
		cmpi.w	#$60,d2
		bls.s	loc_1B10C
		cmpi.w	#$1C0,d2
		bcc.s	loc_1B10C
		move.w	d2,(a6)+
		subq.w	#1,d7
		dbmi	d4,loc_1B0C6
		rts
; ---------------------------------------------------------------------------

loc_1B10C:

		subq.w	#6,a6
		dbf	d4,loc_1B0C6
		rts
; ---------------------------------------------------------------------------

loc_1B114:

		addq.w	#5,a1
		dbf	d4,loc_1B0C6
		rts
; ---------------------------------------------------------------------------
byte_1B11C:	dc.b 8
		dc.b 8
		dc.b 8
		dc.b 8
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $18
		dc.b $18
		dc.b $18
		dc.b $18
		dc.b $20
		dc.b $20
		dc.b $20
		dc.b $20
; ---------------------------------------------------------------------------

loc_1B12C:

		move.b	(a1)+,d2
		ext.w	d2
		neg.w	d2
		move.b	(a1),d6
		move.b	byte_1B18C(pc,d6.w),d6
		sub.w	d6,d2
		add.w	d1,d2
		cmpi.w	#$60,d2
		bls.s	loc_1B184
		cmpi.w	#$160,d2
		bcc.s	loc_1B184
		move.w	d2,(a6)+
		move.b	(a1)+,d6
		move.b	d6,(a6)+
		addq.w	#1,a6
		move.w	(a1)+,d2
		add.w	d5,d2
		eori.w	#$1800,d2
		move.w	d2,(a6)+
		move.w	(a1)+,d2
		neg.w	d2
		move.b	byte_1B11C(pc,d6.w),d6
		sub.w	d6,d2
		add.w	d0,d2
		cmpi.w	#$60,d2
		bls.s	loc_1B17C
		cmpi.w	#$1C0,d2
		bcc.s	loc_1B17C
		move.w	d2,(a6)+
		subq.w	#1,d7
		dbmi	d4,loc_1B12C
		rts
; ---------------------------------------------------------------------------

loc_1B17C:

		subq.w	#6,a6
		dbf	d4,loc_1B12C
		rts
; ---------------------------------------------------------------------------

loc_1B184:

		addq.w	#5,a1
		dbf	d4,loc_1B12C
		rts
; ---------------------------------------------------------------------------
byte_1B18C:	dc.b 8
		dc.b $10
		dc.b $18
		dc.b $20
		dc.b 8
		dc.b $10
		dc.b $18
		dc.b $20
		dc.b 8
		dc.b $10
		dc.b $18
		dc.b $20
		dc.b 8
		dc.b $10
		dc.b $18
		dc.b $20
; ---------------------------------------------------------------------------

loc_1B19C:

		move.b	(a1)+,d2
		ext.w	d2
		neg.w	d2
		move.b	(a1)+,d6
		move.b	d6,2(a6)
		move.b	byte_1B18C(pc,d6.w),d6
		sub.w	d6,d2
		add.w	d1,d2
		cmpi.w	#$60,d2
		bls.s	loc_1B1EC
		cmpi.w	#$160,d2
		bcc.s	loc_1B1EC
		move.w	d2,(a6)+
		addq.w	#2,a6
		move.w	(a1)+,d2
		add.w	d5,d2
		eori.w	#$1000,d2
		move.w	d2,(a6)+
		move.w	(a1)+,d2
		add.w	d0,d2
		cmpi.w	#$60,d2
		bls.s	loc_1B1E4
		cmpi.w	#$1C0,d2
		bcc.s	loc_1B1E4
		move.w	d2,(a6)+
		subq.w	#1,d7
		dbmi	d4,loc_1B19C
		rts
; ---------------------------------------------------------------------------

loc_1B1E4:

		subq.w	#6,a6
		dbf	d4,loc_1B19C
		rts
; ---------------------------------------------------------------------------

loc_1B1EC:

		addq.w	#4,a1
		dbf	d4,loc_1B19C
		rts
; End of function sub_1B070

; ---------------------------------------------------------------------------

loc_1B1F4:
		moveq	#$4D,d7
		moveq	#0,d6
		lea	($FFFFAC00).w,a5
		lea	($FFFFEE80).w,a3
		lea	($FFFFF810).w,a6
		tst.w	($FFFFEF3C).w
		beq.s	loc_1B210
		lea	($FF7890).l,a6

loc_1B210:
		tst.b	($FFFFF711).w
		beq.s	loc_1B21C
		jsr	(sub_DB3C).l

loc_1B21C:

		move.b	1(a5),(a5)
		beq.w	loc_1B2C8
		lea	2(a5),a4

loc_1B228:
		movea.w	(a4)+,a0
		andi.b	#$7F,4(a0)
		move.b	4(a0),d6
		btst	#4,d6
		bne.w	loc_1B2C2
		move.w	$10(a0),d0
		move.w	$14(a0),d1
		btst	#6,d6
		bne.w	loc_1B3EC
		btst	#2,d6
		beq.s	loc_1B294
		moveq	#0,d2
		sub.w	(a3),d0
		move.b	7(a0),d2
		add.w	d2,d0
		and.w	($FFFFEEA8).w,d0
		move.w	d2,d3
		add.w	d2,d2
		addi.w	#$140,d2
		cmp.w	d2,d0
		bcc.s	loc_1B2C2
		addi.w	#$80,d0
		sub.w	d3,d0
		moveq	#0,d2
		sub.w	4(a3),d1
		move.b	6(a0),d2
		add.w	d2,d1
		and.w	($FFFFEEAA).w,d1
		move.w	d2,d3
		add.w	d2,d2
		addi.w	#$70,d2
		cmp.w	d2,d1
		bcc.s	loc_1B2C2
		addi.w	#$80,d1
		sub.w	d3,d1

loc_1B294:
		ori.b	#$80,4(a0)
		tst.w	d7
		bmi.s	loc_1B2C2
		movea.l	$C(a0),a1
		moveq	#0,d4
		btst	#5,d6
		bne.s	loc_1B2BA
		move.b	$22(a0),d4
		add.w	d4,d4
		adda.w	(a1,d4.w),a1
		move.w	(a1)+,d4
		subq.w	#1,d4
		bmi.s	loc_1B2C2

loc_1B2BA:
		move.w	$A(a0),d5
		jsr	sub_1AF6C(pc)

loc_1B2C2:

		subq.b	#2,(a5)
		bne.w	loc_1B228

loc_1B2C8:
		lea	$80(a5),a5
		cmpa.l	#$FFFFB000,a5
		bcs.w	loc_1B21C
		tst.w	d7
		bmi.s	loc_1B2E4
		moveq	#0,d0

loc_1B2DC:
		move.w	d0,(a6)
		addq.w	#8,a6
		dbf	d7,loc_1B2DC

loc_1B2E4:
		move.l	($FFFFAD02).w,d0
		cmpi.l	#$B000B04A,d0
		bne.s	loc_1B2F6
		swap	d0
		move.l	d0,($FFFFAD02).w

loc_1B2F6:
		moveq	#$4F,d7
		lea	($FFFFAC00).w,a5
		lea	($FFFFEE68).w,a3
		lea	($FF7B00).l,a6
		tst.w	($FFFFEF3C).w
		beq.s	loc_1B312
		lea	($FF7D80).l,a6

loc_1B312:
		tst.b	($FFFFF711).w
		beq.s	loc_1B31E
		jsr	(nullsub_2).l

loc_1B31E:

		tst.b	1(a5)
		beq.w	loc_1B3CA
		lea	2(a5),a4

loc_1B32A:
		movea.w	(a4)+,a0
		move.b	4(a0),d6
		btst	#3,d6
		bne.w	loc_1B3C2
		move.w	$10(a0),d0
		move.w	$14(a0),d1
		btst	#6,d6
		bne.w	loc_1B4B8
		btst	#2,d6
		beq.s	loc_1B390
		moveq	#0,d2
		sub.w	(a3),d0
		move.b	7(a0),d2
		add.w	d2,d0
		and.w	($FFFFEEA8).w,d0
		move.w	d2,d3
		add.w	d2,d2
		addi.w	#$140,d2
		cmp.w	d2,d0
		bcc.s	loc_1B3C2
		addi.w	#$80,d0
		sub.w	d3,d0
		moveq	#0,d2
		sub.w	4(a3),d1
		move.b	6(a0),d2
		add.w	d2,d1
		and.w	($FFFFEEAA).w,d1
		move.w	d2,d3
		add.w	d2,d2
		addi.w	#$70,d2
		cmp.w	d2,d1
		bcc.s	loc_1B3C2
		addi.w	#$80,d1
		sub.w	d3,d1

loc_1B390:
		addi.w	#$70,d1
		ori.b	#$80,4(a0)
		tst.w	d7
		bmi.s	loc_1B3C2
		movea.l	$C(a0),a1
		moveq	#0,d4
		btst	#5,d6
		bne.s	loc_1B3BA
		move.b	$22(a0),d4
		add.w	d4,d4
		adda.w	(a1,d4.w),a1
		move.w	(a1)+,d4
		subq.w	#1,d4
		bmi.s	loc_1B3C2

loc_1B3BA:
		move.w	$A(a0),d5
		jsr	sub_1AF6C(pc)

loc_1B3C2:

		subq.b	#2,1(a5)
		bne.w	loc_1B32A

loc_1B3CA:
		lea	$80(a5),a5
		cmpa.l	#$FFFFB000,a5
		bcs.w	loc_1B31E
		tst.w	d7
		bmi.s	loc_1B3E6
		moveq	#0,d0

loc_1B3DE:
		move.w	d0,(a6)
		addq.w	#8,a6
		dbf	d7,loc_1B3DE

loc_1B3E6:
		st	($FFFFEF3E).w
		rts
; ---------------------------------------------------------------------------

loc_1B3EC:
		moveq	#0,d2
		sub.w	(a3),d0
		move.b	7(a0),d2
		add.w	d2,d0
		and.w	($FFFFEEA8).w,d0
		move.w	d2,d3
		add.w	d2,d2
		addi.w	#$140,d2
		cmp.w	d2,d0
		bcc.w	loc_1B2C2
		addi.w	#$80,d0
		sub.w	d3,d0
		moveq	#0,d2
		sub.w	4(a3),d1
		move.b	6(a0),d2
		add.w	d2,d1
		and.w	($FFFFEEAA).w,d1
		move.w	d2,d3
		add.w	d2,d2
		addi.w	#$70,d2
		cmp.w	d2,d1
		bcc.w	loc_1B2C2
		addi.w	#$80,d1
		sub.w	d3,d1
		ori.b	#$80,4(a0)
		tst.w	d7
		bmi.w	loc_1B2C2
		move.w	$A(a0),d5
		movea.l	$C(a0),a2
		moveq	#0,d4
		move.b	$22(a0),d4
		beq.s	loc_1B46A
		add.w	d4,d4
		lea	(a2),a1
		adda.w	(a1,d4.w),a1
		move.w	(a1)+,d4
		subq.w	#1,d4
		bmi.s	loc_1B46A
		move.w	d6,d3
		jsr	sub_1B070(pc)
		move.w	d3,d6
		tst.w	d7
		bmi.w	loc_1B2C2

loc_1B46A:

		move.w	$16(a0),d3
		subq.w	#1,d3
		bcs.w	loc_1B2C2
		lea	$18(a0),a0

loc_1B478:
		move.w	(a0)+,d0
		sub.w	(a3),d0
		addi.w	#$80,d0
		and.w	($FFFFEEA8).w,d0
		move.w	(a0)+,d1
		sub.w	4(a3),d1
		addi.w	#$80,d1
		and.w	($FFFFEEAA).w,d1
		addq.w	#1,a0
		moveq	#0,d4
		move.b	(a0)+,d4
		add.w	d4,d4
		lea	(a2),a1
		adda.w	(a1,d4.w),a1
		move.w	(a1)+,d4
		subq.w	#1,d4
		bmi.s	loc_1B4AE
		move.w	d6,-(sp)
		jsr	sub_1B070(pc)
		move.w	(sp)+,d6

loc_1B4AE:
		tst.w	d7
		dbmi	d3,loc_1B478
		bra.w	loc_1B2C2
; ---------------------------------------------------------------------------

loc_1B4B8:
		moveq	#0,d2
		sub.w	(a3),d0
		move.b	7(a0),d2
		add.w	d2,d0
		and.w	($FFFFEEA8).w,d0
		move.w	d2,d3
		add.w	d2,d2
		addi.w	#$140,d2
		cmp.w	d2,d0
		bcc.w	loc_1B3C2
		addi.w	#$80,d0
		sub.w	d3,d0
		moveq	#0,d2
		sub.w	4(a3),d1
		move.b	6(a0),d2
		add.w	d2,d1
		and.w	($FFFFEEAA).w,d1
		move.w	d2,d3
		add.w	d2,d2
		addi.w	#$70,d2
		cmp.w	d2,d1
		bcc.w	loc_1B3C2
		addi.w	#$F0,d1
		sub.w	d3,d1
		ori.b	#$80,4(a0)
		tst.w	d7
		bmi.w	loc_1B3C2
		move.w	$A(a0),d5
		movea.l	$C(a0),a2
		moveq	#0,d4
		move.b	$22(a0),d4
		beq.s	loc_1B536
		add.w	d4,d4
		lea	(a2),a1
		adda.w	(a1,d4.w),a1
		move.w	(a1)+,d4
		subq.w	#1,d4
		bmi.s	loc_1B536
		move.w	d6,d3
		jsr	sub_1B070(pc)
		move.w	d3,d6
		tst.w	d7
		bmi.w	loc_1B3C2

loc_1B536:

		move.w	$16(a0),d3
		subq.w	#1,d3
		bcs.w	loc_1B3C2
		lea	$18(a0),a0

loc_1B544:
		move.w	(a0)+,d0
		sub.w	(a3),d0
		addi.w	#$80,d0
		and.w	($FFFFEEA8).w,d0
		move.w	(a0)+,d1
		sub.w	4(a3),d1
		addi.w	#$80,d1
		and.w	($FFFFEEAA).w,d1
		addi.w	#$70,d1
		addq.w	#1,a0
		moveq	#0,d4
		move.b	(a0)+,d4
		add.w	d4,d4
		lea	(a2),a1
		adda.w	(a1,d4.w),a1
		move.w	(a1)+,d4
		subq.w	#1,d4
		bmi.s	loc_1B57E
		move.w	d6,-(sp)
		jsr	sub_1B070(pc)
		move.w	(sp)+,d6

loc_1B57E:
		tst.w	d7
		dbmi	d3,loc_1B544
		bra.w	loc_1B3C2
; ---------------------------------------------------------------------------

Sprite_OnScreen_Test:

		move.w	$10(a0),d0
		andi.w	#$FF80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_1B5A0
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------

loc_1B5A0:
		move.w	$48(a0),d0
		beq.s	loc_1B5AC
		movea.w	d0,a2
		bclr	#7,(a2)

loc_1B5AC:
		bra.w	Delete_Current_Sprite
; ---------------------------------------------------------------------------

Sprite_OnScreen_Test2:

		andi.w	#$FF80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_1B5C4
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------

loc_1B5C4:
		move.w	$48(a0),d0
		beq.s	loc_1B5D0
		movea.w	d0,a2
		bclr	#7,(a2)

loc_1B5D0:
		bra.w	Delete_Current_Sprite

; =============== S U B R O U T I N E =======================================


Delete_Sprite_If_Not_In_Range:

		move.w	$10(a0),d0
		andi.w	#$FF80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_1B5EA
		rts
; ---------------------------------------------------------------------------

loc_1B5EA:
		move.w	$48(a0),d0
		beq.s	loc_1B5F6
		movea.w	d0,a2
		bclr	#7,(a2)

loc_1B5F6:
		bra.w	Delete_Current_Sprite
; End of function Delete_Sprite_If_Not_In_Range

; ---------------------------------------------------------------------------
		tst.w	($FFFFFFE8).w
		bne.s	loc_1B628
		move.w	$10(a0),d0
		andi.w	#$FF80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_1B618
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------

loc_1B618:
		move.w	$48(a0),d0
		beq.s	loc_1B624
		movea.w	d0,a2
		bclr	#7,(a2)

loc_1B624:
		bra.w	Delete_Current_Sprite
; ---------------------------------------------------------------------------

loc_1B628:
		move.w	$10(a0),d0
		andi.w	#$FF00,d0
		move.w	d0,d1
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$300,d0
		bhi.w	loc_1B642
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------

loc_1B642:
		sub.w	($FFFFF7DC).w,d1
		cmpi.w	#$300,d1
		bhi.w	loc_1B652
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------

loc_1B652:
		move.w	$48(a0),d0
		beq.s	loc_1B65E
		movea.w	d0,a2
		bclr	#7,(a2)

loc_1B65E:
		bra.w	Delete_Current_Sprite
; ---------------------------------------------------------------------------

loc_1B662:

		move.w	$10(a0),d0

loc_1B666:

		andi.w	#$FF80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_1B680
		jsr	(Add_SpriteToCollisionResponseList).l
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------

loc_1B680:
		move.w	$48(a0),d0
		beq.s	loc_1B68C
		movea.w	d0,a2
		bclr	#7,(a2)

loc_1B68C:
		bra.w	Delete_Current_Sprite

; =============== S U B R O U T I N E =======================================


Load_Sprites:

		moveq	#0,d0
		move.b	($FFFFF76C).w,d0
		jmp	loc_1B69A(pc,d0.w)
; End of function Load_Sprites

; ---------------------------------------------------------------------------

loc_1B69A:
		bra.w	loc_1B6A8
; ---------------------------------------------------------------------------
		bra.w	loc_1B7F2
; ---------------------------------------------------------------------------
		bra.w	loc_1B7F2
; ---------------------------------------------------------------------------
		rts
; ---------------------------------------------------------------------------

loc_1B6A8:
		move.l	#Sprite_ListingK,d0
		move.b	($FFFFFE10).w,d1
		cmpi.b	#$16,d1
		bcc.s	loc_1B6CA
		cmpi.b	#$E,d1
		bcc.s	loc_1B6C4
		cmpi.b	#7,d1
		bcc.s	loc_1B6CA

loc_1B6C4:
		move.l	#Sprite_Listing3,d0

loc_1B6CA:

		move.l	d0,($FFFFEF5A).w
		addq.b	#4,($FFFFF76C).w
		tst.b	($FFFFFF97).w
		bne.s	loc_1B6E8
		lea	($FFFFEB00).w,a0
		moveq	#0,d0
		move.w	#$BF,d1

loc_1B6E2:
		move.l	d0,(a0)+
		dbf	d1,loc_1B6E2

loc_1B6E8:
		move.w	($FFFFFE10).w,d0
		ror.b	#1,d0
		lsr.w	#5,d0

loc_1B6F0:
		lea	(SpriteLocPtrs).l,a0
		movea.l	(a0,d0.w),a0
		cmpi.w	#$1701,($FFFFFE10).w
		beq.s	loc_1B720
		cmpi.b	#$16,($FFFFFE10).w
		bcc.s	loc_1B76A

loc_1B70A:
		cmpi.b	#$14,($FFFFFE10).w
		beq.s	loc_1B76A
		cmpi.b	#$13,($FFFFFE10).w
		bcc.s	loc_1B720
		tst.w	($FFFFFFE8).w
		beq.s	loc_1B76A

loc_1B720:

		addq.b	#8,($FFFFF76C).w
		jsr	Create_New_Sprite(pc)
		bne.s	loc_1B74C
		lea	($FFFFF712).w,a3
		movea.l	($FFFFEF5A).w,a4
		move.w	#$800,d6
		cmpi.w	#$1701,($FFFFFE10).w
		bne.s	loc_1B742
		move.w	#$1780,d6

loc_1B742:

		cmp.w	(a0),d6
		bls.s	loc_1B74C
		jsr	sub_1BA0C(pc)
		beq.s	loc_1B742

loc_1B74C:

		clr.w	($FFFFF7DA).w
		cmpi.w	#$1701,($FFFFFE10).w
		bne.s	locret_1B768
		move.w	($FFFFEE78).w,d1
		subi.w	#$80,d1
		andi.w	#$FF80,d1
		move.w	d1,($FFFFF7DA).w

locret_1B768:
		rts
; ---------------------------------------------------------------------------

loc_1B76A:

		move.l	a0,($FFFFF772).w
		move.l	a0,($FFFFF776).w
		lea	($FFFFEB00).w,a3
		cmpi.b	#$14,($FFFFFE10).w
		bne.s	loc_1B78E
		lea	($FFFF8400).w,a3
		moveq	#$7F,d6

loc_1B784:
		clr.l	(a3)+
		dbf	d6,loc_1B784
		lea	($FFFF8400).w,a3

loc_1B78E:
		move.w	($FFFFEE78).w,d6
		subi.w	#$80,d6
		bcc.s	loc_1B79A
		moveq	#0,d6

loc_1B79A:
		andi.w	#$FF80,d6
		movea.l	($FFFFF772).w,a0

loc_1B7A2:
		cmp.w	(a0),d6
		bls.s	loc_1B7AC
		addq.w	#6,a0
		addq.w	#1,a3
		bra.s	loc_1B7A2
; ---------------------------------------------------------------------------

loc_1B7AC:
		move.l	a0,($FFFFF772).w
		move.w	a3,($FFFFF77A).w
		lea	($FFFFEB00).w,a3
		cmpi.b	#$14,($FFFFFE10).w
		bne.s	loc_1B7C4
		lea	($FFFF8400).w,a3

loc_1B7C4:
		movea.l	($FFFFF776).w,a0
		subi.w	#$80,d6
		bcs.s	loc_1B7D8

loc_1B7CE:
		cmp.w	(a0),d6
		bls.s	loc_1B7D8
		addq.w	#6,a0
		addq.w	#1,a3
		bra.s	loc_1B7CE
; ---------------------------------------------------------------------------

loc_1B7D8:

		move.l	a0,($FFFFF776).w
		move.w	a3,($FFFFF77C).w
		move.w	#-1,($FFFFF76E).w
		move.w	($FFFFEE7C).w,d0
		andi.w	#$FF80,d0
		move.w	d0,($FFFFF770).w

loc_1B7F2:

		move.w	($FFFFEE7C).w,d1
		subi.w	#$80,d1
		andi.w	#$FF80,d1
		move.w	d1,($FFFFEF64).w
		move.w	($FFFFEE78).w,d1
		subi.w	#$80,d1
		andi.w	#$FF80,d1
		move.w	d1,($FFFFF7DA).w
		movea.l	($FFFFEF5A).w,a4
		tst.w	($FFFFEE18).w
		bpl.s	loc_1B84A
		lea	loc_1BA40(pc),a6
		move.w	($FFFFEE7C).w,d3
		andi.w	#$FF80,d3
		move.w	d3,d4
		addi.w	#$200,d4
		subi.w	#$80,d3
		bpl.s	loc_1B83A
		and.w	($FFFFEEAA).w,d3
		bra.s	loc_1B864
; ---------------------------------------------------------------------------

loc_1B83A:
		move.w	($FFFFEEAA).w,d0
		addq.w	#1,d0
		cmp.w	d0,d4
		bls.s	loc_1B860
		and.w	($FFFFEEAA).w,d4
		bra.s	loc_1B864
; ---------------------------------------------------------------------------

loc_1B84A:
		move.w	($FFFFEE7C).w,d3
		andi.w	#-$80,d3
		move.w	d3,d4
		addi.w	#$200,d4
		subi.w	#$80,d3
		bpl.s	loc_1B860
		moveq	#0,d3

loc_1B860:

		lea	loc_1BA92(pc),a6

loc_1B864:

		move.w	#$FFF,d5
		move.w	($FFFFEE78).w,d6
		andi.w	#$FF80,d6
		cmp.w	($FFFFF76E).w,d6
		beq.w	loc_1B91A
		bge.s	loc_1B8D2
		move.w	d6,($FFFFF76E).w
		movea.l	($FFFFF776).w,a0
		movea.w	($FFFFF77C).w,a3
		subi.w	#$80,d6
		bcs.s	loc_1B8A8
		jsr	Create_New_Sprite(pc)
		bne.s	loc_1B8A8

loc_1B892:
		cmp.w	-6(a0),d6
		bge.s	loc_1B8A8
		subq.w	#6,a0
		subq.w	#1,a3
		jsr	(a6)
		bne.s	loc_1B8A4
		subq.w	#6,a0
		bra.s	loc_1B892
; ---------------------------------------------------------------------------

loc_1B8A4:
		addq.w	#6,a0
		addq.w	#1,a3

loc_1B8A8:

		move.l	a0,($FFFFF776).w
		move.w	a3,($FFFFF77C).w
		movea.l	($FFFFF772).w,a0
		movea.w	($FFFFF77A).w,a3
		addi.w	#$300,d6

loc_1B8BC:
		cmp.w	-6(a0),d6
		bgt.s	loc_1B8C8
		subq.w	#6,a0
		subq.w	#1,a3
		bra.s	loc_1B8BC
; ---------------------------------------------------------------------------

loc_1B8C8:
		move.l	a0,($FFFFF772).w
		move.w	a3,($FFFFF77A).w
		bra.s	loc_1B91A
; ---------------------------------------------------------------------------

loc_1B8D2:
		move.w	d6,($FFFFF76E).w
		movea.l	($FFFFF772).w,a0
		movea.w	($FFFFF77A).w,a3
		addi.w	#$280,d6
		jsr	Create_New_Sprite(pc)
		bne.s	loc_1B8F2

loc_1B8E8:
		cmp.w	(a0),d6
		bls.s	loc_1B8F2
		jsr	(a6)
		addq.w	#1,a3
		beq.s	loc_1B8E8

loc_1B8F2:

		move.l	a0,($FFFFF772).w
		move.w	a3,($FFFFF77A).w
		movea.l	($FFFFF776).w,a0
		movea.w	($FFFFF77C).w,a3
		subi.w	#$300,d6
		bcs.s	loc_1B912

loc_1B908:
		cmp.w	(a0),d6
		bls.s	loc_1B912
		addq.w	#6,a0
		addq.w	#1,a3
		bra.s	loc_1B908
; ---------------------------------------------------------------------------

loc_1B912:

		move.l	a0,($FFFFF776).w
		move.w	a3,($FFFFF77C).w

loc_1B91A:

		move.w	($FFFFEE7C).w,d6
		andi.w	#$FF80,d6
		move.w	d6,d3
		cmp.w	($FFFFF770).w,d6
		beq.w	loc_1B9FA
		bge.s	loc_1B956
		tst.w	($FFFFEE18).w
		bpl.s	loc_1B94C
		tst.w	d6
		bne.s	loc_1B940
		cmpi.w	#$80,($FFFFF770).w
		bne.s	loc_1B968

loc_1B940:

		subi.w	#$80,d3
		bpl.s	loc_1B982
		and.w	($FFFFEEAA).w,d3
		bra.s	loc_1B982
; ---------------------------------------------------------------------------

loc_1B94C:
		subi.w	#$80,d3
		bmi.w	loc_1B9FA
		bra.s	loc_1B982
; ---------------------------------------------------------------------------

loc_1B956:
		tst.w	($FFFFEE18).w
		bpl.s	loc_1B978
		tst.w	($FFFFF770).w
		bne.s	loc_1B968
		cmpi.w	#$80,d6
		bne.s	loc_1B940

loc_1B968:

		addi.w	#$180,d3
		cmp.w	($FFFFEEAA).w,d3
		bcs.s	loc_1B982
		and.w	($FFFFEEAA).w,d3
		bra.s	loc_1B982
; ---------------------------------------------------------------------------

loc_1B978:
		addi.w	#$180,d3
		cmp.w	($FFFFEEAA).w,d3
		bhi.s	loc_1B9FA

loc_1B982:

		jsr	Create_New_Sprite(pc)
		bne.s	loc_1B9FA
		move.w	d3,d4
		addi.w	#$80,d4
		move.w	#$FFF,d5
		movea.l	($FFFFF776).w,a0
		movea.w	($FFFFF77C).w,a3
		move.l	($FFFFF772).w,d7
		sub.l	a0,d7
		beq.s	loc_1B9FA
		addq.w	#2,a0

loc_1B9A4:
		tst.b	(a3)
		bmi.s	loc_1B9F2
		move.w	(a0),d1
		and.w	d5,d1
		cmp.w	d3,d1
		bcs.s	loc_1B9F2
		cmp.w	d4,d1
		bhi.s	loc_1B9F2
		bset	#7,(a3)
		move.w	-2(a0),$10(a1)
		move.w	(a0),d1
		move.w	d1,d2
		and.w	d5,d1
		move.w	d1,$14(a1)
		rol.w	#3,d2
		andi.w	#3,d2
		move.b	d2,4(a1)
		move.b	d2,$2A(a1)
		move.b	2(a0),d2
		add.w	d2,d2
		add.w	d2,d2
		move.l	(a4,d2.w),(a1)
		move.b	3(a0),$2C(a1)
		move.w	a3,$48(a1)
		jsr	CreateNewSprite4(pc)
		bne.s	loc_1B9FA

loc_1B9F2:

		addq.w	#6,a0
		addq.w	#1,a3
		subq.w	#6,d7
		bne.s	loc_1B9A4

loc_1B9FA:

		move.w	d6,($FFFFF770).w
		rts
; ---------------------------------------------------------------------------
		bset	#7,(a3)
		beq.s	sub_1BA0C
		addq.w	#6,a0
		moveq	#0,d1
		rts

; =============== S U B R O U T I N E =======================================


sub_1BA0C:

		move.w	(a0)+,$10(a1)
		move.w	(a0)+,d1
		move.w	d1,d2
		andi.w	#$FFF,d1
		move.w	d1,$14(a1)
		rol.w	#3,d2
		andi.w	#3,d2
		move.b	d2,4(a1)
		move.b	d2,$2A(a1)
		move.b	(a0)+,d2
		add.w	d2,d2
		add.w	d2,d2
		move.l	(a4,d2.w),(a1)
		move.b	(a0)+,$2C(a1)
		move.w	a3,$48(a1)
		bra.w	CreateNewSprite4
; ---------------------------------------------------------------------------

loc_1BA40:
		tst.b	(a3)
		bpl.s	loc_1BA4A
		addq.w	#6,a0
		moveq	#0,d1
		rts
; ---------------------------------------------------------------------------

loc_1BA4A:
		move.w	(a0)+,d7
		move.w	(a0)+,d1
		move.w	d1,d2
		bmi.s	loc_1BA62
		and.w	d5,d1
		cmp.w	d3,d1
		bcc.s	loc_1BA64
		cmp.w	d4,d1
		bls.s	loc_1BA64
		addq.w	#2,a0
		moveq	#0,d1
		rts
; ---------------------------------------------------------------------------

loc_1BA62:
		and.w	d5,d1

loc_1BA64:

		bset	#7,(a3)
		move.w	d7,$10(a1)
		move.w	d1,$14(a1)
		rol.w	#3,d2
		andi.w	#3,d2
		move.b	d2,4(a1)
		move.b	d2,$2A(a1)
		move.b	(a0)+,d2
		add.w	d2,d2
		add.w	d2,d2
		move.l	(a4,d2.w),(a1)
		move.b	(a0)+,$2C(a1)
		move.w	a3,$48(a1)
		bra.s	CreateNewSprite4
; ---------------------------------------------------------------------------

loc_1BA92:
		tst.b	(a3)
		bpl.s	loc_1BA9C
		addq.w	#6,a0
		moveq	#0,d1
		rts
; ---------------------------------------------------------------------------

loc_1BA9C:
		move.w	(a0)+,d7
		move.w	(a0)+,d1
		move.w	d1,d2
		bmi.s	loc_1BAB4
		and.w	d5,d1
		cmp.w	d3,d1
		bcs.s	loc_1BAAE
		cmp.w	d4,d1
		bls.s	loc_1BAB6

loc_1BAAE:
		addq.w	#2,a0
		moveq	#0,d1
		rts
; ---------------------------------------------------------------------------

loc_1BAB4:
		and.w	d5,d1

loc_1BAB6:
		bset	#7,(a3)
		move.w	d7,$10(a1)
		move.w	d1,$14(a1)
		rol.w	#3,d2
		andi.w	#3,d2
		move.b	d2,4(a1)
		move.b	d2,$2A(a1)
		move.b	(a0)+,d2
		add.w	d2,d2
		add.w	d2,d2
		move.l	(a4,d2.w),(a1)
		move.b	(a0)+,$2C(a1)
		move.w	a3,$48(a1)

CreateNewSprite4:

		subq.w	#1,d0
		bmi.s	locret_1BAF0

loc_1BAE6:
		lea	$4A(a1),a1
		tst.l	(a1)
		dbeq	d0,loc_1BAE6

locret_1BAF0:
		rts
; End of function sub_1BA0C


; =============== S U B R O U T I N E =======================================


Create_New_Sprite:

		lea	($FFFFB0DE).w,a1
		moveq	#$59,d0
		bra.s	loc_1BB0A
; ---------------------------------------------------------------------------

Create_New_Sprite3:

		movea.l	a0,a1
		move.w	#$CAE2,d0
		sub.w	a0,d0
		lsr.w	#6,d0
		move.b	byte_1BB16(pc,d0.w),d0
		bmi.s	locret_1BB14

loc_1BB0A:
		lea	$4A(a1),a1
		tst.l	(a1)
		dbeq	d0,loc_1BB0A

locret_1BB14:
		rts
; End of function Create_New_Sprite

; ---------------------------------------------------------------------------
byte_1BB16:	dc.b  $FF,   0,   1,   2,   3,   4,   5,   5,   6,   7,   8,   9,  $A,  $B,  $B,  $C,  $D,  $E,  $F, $10
		dc.b  $11, $12, $12, $13, $14, $15, $16, $17, $18, $18, $19, $1A, $1B, $1C, $1D, $1E, $1E, $1F, $20, $21
		dc.b  $22, $23, $24, $25, $25, $26, $27, $28, $29, $2A, $2B, $2B, $2C, $2D, $2E, $2F, $30, $31, $32, $32
		dc.b  $33, $34, $35, $36, $37, $38, $38, $39, $3A, $3B, $3C, $3D, $3E, $3E, $3F, $40, $41, $42, $43, $44
		dc.b  $45, $45, $46, $47, $48, $49, $4A, $4B, $4B, $4C, $4D, $4E, $4F, $50, $51, $52, $52, $53, $54, $55
		dc.b  $56, $57, $58, $58
; ---------------------------------------------------------------------------

Clear_SpriteRingMem:

		lea	($FFFFB0DE).w,a1
		moveq	#$59,d1

loc_1BB84:
		lea	$4A(a1),a1
		tst.l	(a1)
		beq.s	loc_1BB98
		move.w	$48(a1),d0
		beq.s	loc_1BB98
		movea.w	d0,a2
		bclr	#7,(a2)

loc_1BB98:

		dbf	d1,loc_1BB84
		lea	($FFFFEF80).w,a2
		move.w	(a2)+,d1
		subq.w	#1,d1
		bcs.s	locret_1BBBC

loc_1BBA6:

		move.w	(a2)+,d0
		beq.s	loc_1BBA6
		movea.w	d0,a1
		move.w	#-1,(a1)
		clr.w	-2(a2)
		subq.w	#1,($FFFFEF80).w
		dbf	d1,loc_1BBA6

locret_1BBBC:
		rts
; ---------------------------------------------------------------------------

loc_1BBBE:
		move.w	($FFFFEE78).w,d6
		addi.w	#$400,d6
		andi.w	#$FF80,d6
		cmp.w	($FFFFF76E).w,d6
		beq.w	locret_1BC5E
		bge.s	loc_1BC1C
		move.w	d6,($FFFFF76E).w
		movea.l	($FFFFF776).w,a1
		movea.w	($FFFFF77C).w,a3
		subi.w	#$80,d6
		bcs.s	loc_1BBF2

loc_1BBE6:
		cmp.w	-6(a1),d6
		bge.s	loc_1BBF2
		subq.w	#6,a1
		subq.w	#1,a3
		bra.s	loc_1BBE6
; ---------------------------------------------------------------------------

loc_1BBF2:

		move.l	a1,($FFFFF776).w
		move.w	a3,($FFFFF77C).w
		movea.l	($FFFFF772).w,a1
		movea.w	($FFFFF77A).w,a3
		addi.w	#$300,d6

loc_1BC06:
		cmp.w	-6(a1),d6
		bgt.s	loc_1BC12
		subq.w	#6,a1
		subq.w	#1,a3
		bra.s	loc_1BC06
; ---------------------------------------------------------------------------

loc_1BC12:
		move.l	a1,($FFFFF772).w
		move.w	a3,($FFFFF77A).w
		bra.s	locret_1BC5E
; ---------------------------------------------------------------------------

loc_1BC1C:
		move.w	d6,($FFFFF76E).w
		movea.l	($FFFFF772).w,a1
		movea.w	($FFFFF77A).w,a3
		addi.w	#$280,d6

loc_1BC2C:
		cmp.w	(a1),d6
		bls.s	loc_1BC36
		addq.w	#6,a1
		addq.w	#1,a3
		bra.s	loc_1BC2C
; ---------------------------------------------------------------------------

loc_1BC36:
		move.l	a1,($FFFFF772).w
		move.w	a3,($FFFFF77A).w
		movea.l	($FFFFF776).w,a1
		movea.w	($FFFFF77C).w,a3
		subi.w	#$300,d6
		bcs.s	loc_1BC56

loc_1BC4C:
		cmp.w	(a1),d6
		bls.s	loc_1BC56
		addq.w	#6,a1
		addq.w	#1,a3
		bra.s	loc_1BC4C
; ---------------------------------------------------------------------------

loc_1BC56:

		move.l	a1,($FFFFF776).w
		move.w	a3,($FFFFF77C).w

locret_1BC5E:

		rts

; =============== S U B R O U T I N E =======================================


Get_LevelSizeStart:
		clr.b	($FFFFEE30).w
		clr.b	($FFFFEE08).w
		clr.b	($FFFFEE0A).w
		clr.b	($FFFFEE0B).w
		clr.b	($FFFFEE39).w
		moveq	#0,d0
		move.b	d0,($FFFFEE33).w
		move.w	d0,($FFFFF660).w
		move.w	d0,($FFFFF662).w
		move.w	($FFFFFE10).w,d0
		ror.b	#1,d0
		lsr.w	#4,d0
		lea	LevelSizes(pc,d0.w),a0
		move.l	(a0)+,d0
		move.l	d0,($FFFFEE14).w
		move.l	d0,($FFFFEE0C).w
		move.l	d0,($FFFFEE1C).w
		move.l	(a0)+,d0
		move.l	d0,($FFFFEE18).w
		move.l	d0,($FFFFEE10).w
		move.l	d0,($FFFFEE20).w
		move.w	#$60,($FFFFEE2C).w
		move.w	#$60,($FFFFEE2E).w
		move.w	#-1,($FFFFEEA8).w
		move.w	#-1,($FFFFEEAA).w
		bra.w	loc_1BE46
; ---------------------------------------------------------------------------
LevelSizes:	dc.l  $13086000,      $390 	; AIZ1
		dc.l	  $4640,      $590		; AIZ2
		dc.l	  $6000,     $1000		; HCZ1
		dc.l	  $6000,     $1000		; HCZ2
		dc.l	  $6000, $FF001000		; MGZ1
		dc.l	  $6000,     $1000		; MGZ2
		dc.l	  $6000,      $B20		; CNZ1
		dc.l	  $6000,  $5801000		; CNZ2
		dc.l	  $2E60,      $B00		; FBZ1
		dc.l	  $6000,      $B00		; FBZ2
		dc.l	  $7000, $FF000800		; ICZ1
		dc.l	  $7000,      $B20		; ICZ2
		dc.l	  $6000,     $1000		; LBZ1
		dc.l	  $6000,      $B20		; LBZ2
		dc.l	  $4298,      $AA0		; MHZ1
		dc.l	$983C90,  $62009A0		; MHZ2
		dc.l	  $4310,      $B20		; SOZ1
		dc.l	  $6000, $FF000800		; SOZ2
		dc.l	  $2CC0,      $B20		; LRZ1
		dc.l   $9403EC0,      $B20		; LRZ2
		dc.l	  $19A0, $FF001000		; SSZ1
		dc.l	  $6000,      $400		; SSZ2
		dc.l	  $6000,      $B20		; DEZ1
		dc.l	  $6000,      $F10		; DEZ2
		dc.l	  $6000,     $1000		; DDZ
		dc.l	  $6000,     $1000		; DDZ
		dc.l	  $6000,     $1000		; AIZ Intro (?)
		dc.l	  $6000,     $1000		; Ending scene
		dc.l	  $12C0,  $1000190		; ALZ
		dc.l	  $12C0,  $1000190		; ALZ
		dc.l	  $12C0,  $2000390		; BPZ
		dc.l	  $12C0,  $2000390		; BPZ
		dc.l	  $12C0,  $1000190		; DPZ
		dc.l	  $12C0,  $1000190		; DPZ
		dc.l	  $12C0, $FF001000		; CGZ
		dc.l	  $12C0,       $90		; CGZ
		dc.l	  $12C0,  $1000190		; EMZ
		dc.l	  $12C0,  $1000190		; EMZ
		dc.l	$600060,      $240		; Gumball
		dc.l	$600060,      $240		; Gumball
		dc.l	   $140,      $F00		; Pachinko
		dc.l	   $140,      $F00		; Pachinko
		dc.l	  $6000,     $1000		; Slots
		dc.l	  $6000,     $1000		; Slots
		dc.l	   $EC0,      $430		; LRZ Boss
		dc.l	  $1880,      $B20		; HPZ
		dc.l	  $6000,   $200020		; DEZ Boss
		dc.l  $15001640,  $3200320		; Special Stage Arena (HPZ)
; ---------------------------------------------------------------------------

loc_1BE46:
		tst.b	($FFFFFE2A).w
		beq.s	loc_1BE5E
		jsr	(Load_Starpost_Settings).l
		move.w	($FFFFB010).w,d1
		move.w	($FFFFB014).w,d0
		bra.w	loc_1BF74
; ---------------------------------------------------------------------------

loc_1BE5E:
		move.w	($FFFFFE10).w,d0
		ror.b	#1,d0
		lsr.w	#5,d0
		lea	(Sonic_Start_Locations).l,a1
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_1BE7A
		lea	(Knux_Start_Locations).l,a1

loc_1BE7A:
		lea	(a1,d0.w),a1
		moveq	#0,d1
		move.w	(a1)+,d1
		move.w	d1,($FFFFB010).w
		moveq	#0,d0
		move.w	(a1),d0
		move.w	d0,($FFFFB014).w
		tst.b	($FFFFFE2A).w
		bne.w	loc_1BF74
		cmpi.w	#0,($FFFFFE10).w
		bne.s	loc_1BEC6
		cmpi.w	#2,($FFFFFF08).w
		bcc.s	loc_1BEC6
		move.w	#$40,d1				; If in Angel Island Zone and playing as Sonic, the start position is overridden for the intro
		move.w	d1,($FFFFB010).w
		move.w	#$420,d0
		move.w	d0,($FFFFB014).w
		move.w	#0,d1
		move.w	d1,($FFFFEE14).w
		move.w	d1,($FFFFEE0C).w
		move.w	d1,($FFFFEE1C).w

loc_1BEC6:

		cmpi.w	#$500,($FFFFFE10).w
		bne.s	loc_1BF1E
		cmpi.w	#2,($FFFFFF08).w
		bcs.s	loc_1BF1E
		bne.s	loc_1BF1E
		move.w	#$35A0,d1			; If in Ice Cap Act 1 and playing as Tails,
		move.w	d1,($FFFFEE14).w	; we use a different start position and different level sizes
		move.w	d1,($FFFFEE0C).w	; to skip the snowboarding sequence
		move.w	d1,($FFFFEE1C).w
		move.w	#$3780,d1
		move.w	d1,($FFFFB010).w
		move.w	#$36F0,d1
		move.w	d1,($FFFFEE78).w
		move.w	d1,($FFFFEE60).w
		move.w	#$1E0,d0
		move.w	d0,($FFFFB014).w
		move.w	#$200,d0
		move.w	d0,($FFFFEE18).w
		move.w	d0,($FFFFEE10).w
		move.w	d0,($FFFFEE20).w
		move.w	d0,($FFFFEE7C).w
		move.w	d0,($FFFFEE64).w
		rts
; ---------------------------------------------------------------------------

loc_1BF1E:

		cmpi.w	#$700,($FFFFFE10).w
		bne.s	loc_1BF48
		cmpi.w	#3,($FFFFFF08).w
		bcc.s	loc_1BF48
		tst.w	($FFFFFFAE).w
		bne.s	loc_1BF48
		move.w	#$C0,d2				; If playing as Sonic/Tails in MHZ 1 with Sonic 3 locked on, modify level size
		move.w	d2,($FFFFEE14).w
		move.w	d2,($FFFFEE0C).w
		move.w	d2,($FFFFEE1C).w
		move.w	#$160,d1

loc_1BF48:

		cmpi.w	#$1601,($FFFFFE10).w
		beq.s	loc_1BF70
		cmpi.w	#$B00,($FFFFFE10).w
		beq.s	loc_1BF70
		cmpi.w	#$900,($FFFFFE10).w
		beq.s	loc_1BF68
		cmpi.w	#$300,($FFFFFE10).w
		bne.s	loc_1BF74

loc_1BF68:
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_1BF74

loc_1BF70:

		addi.w	#$B0,d1		; Only if in Hidden Palace, in Death Egg 1, in Lava Reef 1 as Knuckles, in Carnival Night 1 as Knuckles
							; This is likely for level intros that start behind the camera

loc_1BF74:

		subi.w	#$A0,d1
		bcc.s	loc_1BF7C
		moveq	#0,d1

loc_1BF7C:
		tst.w	($FFFFFFE8).w
		bne.s	loc_1BF8C
		move.w	($FFFFEE16).w,d2
		cmp.w	d2,d1
		bcs.s	loc_1BF8C
		move.w	d2,d1

loc_1BF8C:

		move.w	d1,($FFFFEE78).w
		move.w	d1,($FFFFEE60).w
		subi.w	#$60,d0
		bcc.s	loc_1BF9C
		moveq	#0,d0

loc_1BF9C:
		cmp.w	($FFFFEE1A).w,d0
		blt.s	loc_1BFA6
		move.w	($FFFFEE1A).w,d0

loc_1BFA6:
		move.w	d0,($FFFFEE7C).w
		move.w	d0,($FFFFEE64).w
		rts
; End of function Get_LevelSizeStart


; =============== S U B R O U T I N E =======================================


Restart_From_Starpost:

		tst.b	($FFFFEE30).w
		beq.s	loc_1BFB8
		rts
; ---------------------------------------------------------------------------

loc_1BFB8:
		clr.w	($FFFFEE00).w
		clr.w	($FFFFEE02).w
		clr.w	($FFFFEE04).w
		clr.w	($FFFFEE06).w
		tst.w	($FFFFFFE8).w
		bne.w	loc_1C02C
		tst.b	($FFFFEE0A).w
		bne.s	loc_1C028
		lea	($FFFFB000).w,a0
		tst.b	($FFFFF676).w
		beq.s	loc_1BFF0
		move.b	#0,($FFFFF676).w
		move.w	#0,($FFFFEE24).w
		lea	($FFFFF668).w,a0

loc_1BFF0:
		lea	($FFFFEE78).w,a1
		lea	($FFFFEE14).w,a2
		lea	($FFFFEE00).w,a4
		lea	($FFFFEE24).w,a5
		lea	($FFFFE500).w,a6
		bsr.w	MoveCameraX
		lea	($FFFFEE7C).w,a1
		lea	($FFFFEE14).w,a2
		lea	($FFFFEE02).w,a4
		move.w	($FFFFEE2C).w,d3
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_1C024
		move.w	($FFFFEE2E).w,d3

loc_1C024:
		bsr.w	MoveCameraY

loc_1C028:
		bra.w	Do_ResizeEvents
; ---------------------------------------------------------------------------

loc_1C02C:
		tst.b	($FFFFEE0A).w
		bne.s	loc_1C06E
		lea	($FFFFB000).w,a0
		lea	($FFFFEE78).w,a1
		lea	($FFFFEE14).w,a2
		lea	($FFFFEE00).w,a4
		lea	($FFFFEE24).w,a5
		lea	($FFFFE500).w,a6
		bsr.w	MoveCameraX_2P
		lea	($FFFFEE7C).w,a1
		lea	($FFFFEE14).w,a2
		lea	($FFFFEE02).w,a4
		move.w	($FFFFEE2C).w,d3
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_1C06A
		move.w	($FFFFEE2E).w,d3

loc_1C06A:
		bsr.w	MoveCameraY

loc_1C06E:
		tst.b	($FFFFEE0B).w
		bne.s	loc_1C0A4
		lea	($FFFFB04A).w,a0
		lea	($FFFFEE60).w,a1
		lea	($FFFFEE1C).w,a2
		lea	($FFFFEE04).w,a4
		lea	($FFFFEE28).w,a5
		lea	($FFFFE400).w,a6
		bsr.w	MoveCameraX_2P
		lea	($FFFFEE64).w,a1
		lea	($FFFFEE1C).w,a2
		lea	($FFFFEE06).w,a4
		move.w	($FFFFEE2E).w,d3
		bsr.w	MoveCameraY

loc_1C0A4:
		bra.w	Do_ResizeEvents
; End of function Restart_From_Starpost


; =============== S U B R O U T I N E =======================================


MoveCameraX:
		move.w	(a1),d4
		tst.b	($FFFFF623).w
		bne.s	locret_1C0E6
		move.w	(a5),d1
		beq.s	loc_1C0D2
		subi.w	#$100,d1
		move.w	d1,(a5)
		moveq	#0,d1
		move.b	(a5),d1
		lsl.b	#2,d1
		addq.b	#4,d1
		move.w	2(a5),d0
		sub.b	d1,d0
		move.w	(a6,d0.w),d0
		andi.w	#$7FFF,d0
		bra.s	loc_1C0D6
; ---------------------------------------------------------------------------

loc_1C0D2:
		move.w	$10(a0),d0

loc_1C0D6:
		sub.w	(a1),d0
		subi.w	#$90,d0
		blt.s	loc_1C0E8
		subi.w	#$10,d0
		bge.s	loc_1C0FC
		clr.w	(a4)

locret_1C0E6:
		rts
; ---------------------------------------------------------------------------

loc_1C0E8:
		cmpi.w	#-$18,d0
		bgt.s	loc_1C0F2
		move.w	#-$18,d0

loc_1C0F2:
		add.w	(a1),d0
		cmp.w	(a2),d0
		bgt.s	loc_1C112
		move.w	(a2),d0
		bra.s	loc_1C112
; ---------------------------------------------------------------------------

loc_1C0FC:
		cmpi.w	#$18,d0
		bcs.s	loc_1C106
		move.w	#$18,d0

loc_1C106:
		add.w	(a1),d0
		cmp.w	2(a2),d0
		blt.s	loc_1C112
		move.w	2(a2),d0

loc_1C112:

		move.w	d0,d1
		sub.w	(a1),d1
		asl.w	#8,d1
		move.w	d0,(a1)
		move.w	d1,(a4)
		rts
; End of function MoveCameraX


; =============== S U B R O U T I N E =======================================


MoveCameraY:
		moveq	#0,d1
		move.w	$14(a0),d0
		sub.w	(a1),d0
		cmpi.w	#-$100,($FFFFEE18).w
		bne.s	loc_1C132
		and.w	($FFFFEEAA).w,d0

loc_1C132:
		btst	#2,$2A(a0)
		beq.s	loc_1C13C
		subq.w	#5,d0

loc_1C13C:
		move.w	d3,d1
		tst.w	($FFFFFFE8).w
		beq.s	loc_1C146
		lsr.w	#1,d1

loc_1C146:
		btst	#1,$2A(a0)
		beq.s	loc_1C164
		addi.w	#$20,d0
		sub.w	d1,d0
		bcs.s	loc_1C1B0
		subi.w	#$40,d0
		bcc.s	loc_1C1B0
		tst.b	($FFFFEE32).w
		bne.s	loc_1C1C2
		bra.s	loc_1C16E
; ---------------------------------------------------------------------------

loc_1C164:
		sub.w	d1,d0
		bne.s	loc_1C172
		tst.b	($FFFFEE32).w
		bne.s	loc_1C1C2

loc_1C16E:
		clr.w	(a4)
		rts
; ---------------------------------------------------------------------------

loc_1C172:
		cmpi.w	#$60,d3
		bne.s	loc_1C19E
		tst.b	($FFFFEE39).w
		bne.s	loc_1C1B0
		move.w	$1C(a0),d1
		bpl.s	loc_1C186
		neg.w	d1

loc_1C186:
		cmpi.w	#$800,d1
		bcc.s	loc_1C1B0
		move.w	#$600,d1
		cmpi.w	#6,d0
		bgt.s	loc_1C1FA
		cmpi.w	#-6,d0
		blt.s	loc_1C1D8
		bra.s	loc_1C1C8
; ---------------------------------------------------------------------------

loc_1C19E:
		move.w	#$200,d1
		cmpi.w	#2,d0
		bgt.s	loc_1C1FA
		cmpi.w	#-2,d0
		blt.s	loc_1C1D8
		bra.s	loc_1C1C8
; ---------------------------------------------------------------------------

loc_1C1B0:

		move.w	#$1800,d1
		cmpi.w	#$18,d0
		bgt.s	loc_1C1FA
		cmpi.w	#-$18,d0
		blt.s	loc_1C1D8
		bra.s	loc_1C1C8
; ---------------------------------------------------------------------------

loc_1C1C2:

		moveq	#0,d0
		move.b	d0,($FFFFEE32).w

loc_1C1C8:

		moveq	#0,d1
		move.w	d0,d1
		add.w	(a1),d1
		tst.w	d0
		bpl.w	loc_1C202
		bra.w	loc_1C1E2
; ---------------------------------------------------------------------------

loc_1C1D8:

		neg.w	d1
		ext.l	d1
		asl.l	#8,d1
		add.l	(a1),d1
		swap	d1

loc_1C1E2:
		cmp.w	4(a2),d1
		bgt.s	loc_1C21A
		cmpi.w	#-$100,d1
		bgt.s	loc_1C1F4
		and.w	($FFFFEEAA).w,d1
		bra.s	loc_1C21A
; ---------------------------------------------------------------------------

loc_1C1F4:
		move.w	4(a2),d1
		bra.s	loc_1C21A
; ---------------------------------------------------------------------------

loc_1C1FA:

		ext.l	d1
		asl.l	#8,d1
		add.l	(a1),d1
		swap	d1

loc_1C202:
		cmp.w	6(a2),d1
		blt.s	loc_1C21A
		move.w	($FFFFEEAA).w,d3
		addq.w	#1,d3
		sub.w	d3,d1
		bcs.s	loc_1C216
		sub.w	d3,(a1)
		bra.s	loc_1C21A
; ---------------------------------------------------------------------------

loc_1C216:
		move.w	6(a2),d1

loc_1C21A:

		move.w	(a1),d4
		swap	d1
		move.l	d1,d3
		sub.l	(a1),d3
		ror.l	#8,d3
		move.w	d3,(a4)
		move.l	d1,(a1)
		tst.w	($FFFFFFE8).w
		beq.s	locret_1C236
		swap	d1
		and.w	($FFFFEEAA).w,d1
		move.w	d1,(a1)

locret_1C236:
		rts
; End of function MoveCameraY


; =============== S U B R O U T I N E =======================================


MoveCameraX_2P:
					; Restart_From_Starpost+DCp
		move.w	(a1),d4
		tst.b	($FFFFF623).w
		bne.s	locret_1C27C
		move.w	(a5),d1
		beq.s	loc_1C262
		subi.w	#$100,d1
		move.w	d1,(a5)
		moveq	#0,d1
		move.b	(a5),d1
		lsl.b	#2,d1
		addq.b	#4,d1
		move.w	2(a5),d0
		sub.b	d1,d0
		move.w	(a6,d0.w),d0
		andi.w	#$7FFF,d0
		bra.s	loc_1C266
; ---------------------------------------------------------------------------

loc_1C262:
		move.w	$10(a0),d0

loc_1C266:
		move.w	($FFFFEEA8).w,d2
		sub.w	(a1),d0
		and.w	d2,d0
		subi.w	#$90,d0
		blt.s	loc_1C27E
		subi.w	#$10,d0
		bge.s	loc_1C28C
		clr.w	(a4)

locret_1C27C:
		rts
; ---------------------------------------------------------------------------

loc_1C27E:
		cmpi.w	#-$10,d0
		bgt.s	loc_1C288
		move.w	#-$10,d0

loc_1C288:
		add.w	(a1),d0
		bra.s	loc_1C298
; ---------------------------------------------------------------------------

loc_1C28C:
		cmpi.w	#$10,d0
		bcs.s	loc_1C296
		move.w	#$10,d0

loc_1C296:
		add.w	(a1),d0

loc_1C298:
		move.w	d0,d1
		sub.w	(a1),d1
		asl.w	#8,d1
		and.w	d2,d0
		addi.w	#$400,d0
		move.w	d0,(a1)
		move.w	d1,(a4)
		rts
; End of function MoveCameraX_2P


; =============== S U B R O U T I N E =======================================

; Attributes: thunk

j_LevelSetup:

		jmp	(LevelSetup).l
; End of function j_LevelSetup


; =============== S U B R O U T I N E =======================================


LoadLevelLoadBlock2:
		move.w	($FFFFFE10).w,d0
		bne.s	loc_1C2C8
		cmpi.w	#2,($FFFFFF08).w
		bcc.s	loc_1C2C4
		tst.b	($FFFFFE2A).w
		beq.s	loc_1C2C8

loc_1C2C4:
		move.w	#$D00,d0

loc_1C2C8:
					; LoadLevelLoadBlock2+12j
		ror.b	#1,d0
		lsr.w	#4,d0
		andi.w	#$1F8,d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		lea	(LevelLoadBlock).l,a2
		lea	(a2,d0.w),a2
		move.l	a2,-(sp)
		addq.w	#8,a2
		move.l	(a2)+,d0
		andi.l	#$FFFFFF,d0
		move.l	d0,d7
		movea.l	d0,a0
		lea	($FFFF9000).w,a1
		jsr	(Kos_Decomp).l
		move.l	(a2)+,d0
		andi.l	#$FFFFFF,d0
		cmp.l	d0,d7
		beq.s	loc_1C30E
		movea.l	d0,a0
		jsr	(Kos_Decomp).l

loc_1C30E:
		move.l	(a2)+,d0
		andi.l	#$FFFFFF,d0
		move.l	d0,d7
		movea.l	d0,a0
		lea	($FFFF0000).l,a1
		jsr	(Kos_Decomp).l
		move.l	(a2)+,d0
		andi.l	#$FFFFFF,d0
		cmp.l	d0,d7
		beq.s	loc_1C33A
		movea.l	d0,a0
		jsr	(Kos_Decomp).l

loc_1C33A:
		bsr.w	Load_Level
		movea.l	(sp)+,a2
		move.b	(a2),d1
		addq.w	#4,a2
		moveq	#0,d0
		move.b	(a2),d0
		beq.s	loc_1C354
		cmp.b	d0,d1
		beq.s	loc_1C354
		jsr	(Load_PLC).l

loc_1C354:
					; LoadLevelLoadBlock2+9Cj
		addq.w	#4,a2
		moveq	#0,d0
		move.b	(a2),d0
		jsr	(LoadPalette).l
		rts
; End of function LoadLevelLoadBlock2


; =============== S U B R O U T I N E =======================================


Load_Level:

		moveq	#0,d0
		move.w	($FFFFFE10).w,d0
		ror.b	#1,d0
		lsr.w	#5,d0
		andi.w	#$FC,d0
		lea	(LevelPtrs).l,a0
		movea.l	(a0,d0.w),a0
		lea	($FFFF8000).w,a1
		move.w	#$7FF,d2

loc_1C382:
		move.w	(a0)+,(a1)+
		dbf	d2,loc_1C382
		rts
; End of function Load_Level

; ---------------------------------------------------------------------------

Do_ResizeEvents:
		moveq	#0,d0
		move.w	($FFFFFE10).w,d0
		ror.b	#1,d0
		lsr.w	#6,d0
		andi.w	#$3E,d0
		move.w	LevelResizeArray(pc,d0.w),d0
		jsr	LevelResizeArray(pc,d0.w)
		moveq	#2,d1
		move.w	($FFFFEE12).w,d0
		sub.w	($FFFFEE1A).w,d0
		beq.s	locret_1C3CE
		bcc.s	loc_1C3D0
		neg.w	d1
		move.w	($FFFFEE7C).w,d0
		cmp.w	($FFFFEE12).w,d0
		bls.s	loc_1C3C4
		move.w	d0,($FFFFEE1A).w
		andi.w	#-2,($FFFFEE1A).w

loc_1C3C4:
		add.w	d1,($FFFFEE1A).w
		move.b	#1,($FFFFEE32).w

locret_1C3CE:
		rts
; ---------------------------------------------------------------------------

loc_1C3D0:
		move.w	($FFFFEE7C).w,d0
		addi.w	#8,d0
		cmp.w	($FFFFEE1A).w,d0
		bcs.s	loc_1C3EA
		btst	#1,($FFFFB02A).w
		beq.s	loc_1C3EA
		add.w	d1,d1
		add.w	d1,d1

loc_1C3EA:

		add.w	d1,($FFFFEE1A).w
		move.b	#1,($FFFFEE32).w
		rts
; ---------------------------------------------------------------------------
LevelResizeArray:	dc.w AIZ1_Resize-LevelResizeArray
		dc.w AIZ2_Resize-LevelResizeArray
		dc.w HCZ1_Resize-LevelResizeArray
		dc.w HCZ2_Resize-LevelResizeArray
		dc.w MGZ_Resize-LevelResizeArray
		dc.w MGZ_Resize-LevelResizeArray
		dc.w No_Resize2-LevelResizeArray
		dc.w No_Resize2-LevelResizeArray
		dc.w No_Resize2-LevelResizeArray
		dc.w No_Resize2-LevelResizeArray
		dc.w ICZ1_Resize-LevelResizeArray
		dc.w ICZ2_Resize-LevelResizeArray
		dc.w No_Resize-LevelResizeArray
		dc.w LBZ2_Resize-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
		dc.w No_Resize3-LevelResizeArray
; ---------------------------------------------------------------------------

AIZ1_Resize:
		moveq	#0,d0
		move.b	($FFFFEE33).w,d0
		move.w	off_1C464(pc,d0.w),d0
		jmp	off_1C464(pc,d0.w)
; ---------------------------------------------------------------------------
off_1C464:	dc.w loc_1C46E-off_1C464

		dc.w loc_1C4D0-off_1C464
		dc.w loc_1C550-off_1C464
		dc.w loc_1C5C6-off_1C464
		dc.w loc_1C602-off_1C464
; ---------------------------------------------------------------------------

loc_1C46E:
		move.b	#1,($FFFFF72E).w
		cmpi.w	#$1000,($FFFFEE78).w
		bcs.s	locret_1C4CE
		move.b	#0,($FFFFF72E).w
		move.w	($FFFFEE78).w,($FFFFEE14).w
		cmpi.w	#$1308,($FFFFEE78).w
		bcs.s	locret_1C4CE
		tst.b	($FFFFFE2A).w
		bne.s	loc_1C4A6
		cmpi.w	#2,($FFFFFF08).w
		bcc.s	loc_1C4A6
		moveq	#$B,d0
		jsr	(Load_PLC).l

loc_1C4A6:

		moveq	#$2A,d0
		jsr	(LoadPalette_Immediate).l
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_1C4C4
		lea	($FFFFFC70).w,a1
		lea	(word_4FAE4).l,a2
		move.l	(a2)+,(a1)+
		move.l	(a2),(a1)

loc_1C4C4:
		move.w	#2,($FFFFF708).w
		addq.b	#2,($FFFFEE33).w

locret_1C4CE:

		rts
; ---------------------------------------------------------------------------

loc_1C4D0:
		move.w	#$1308,($FFFFEE14).w
		cmpi.w	#$1400,($FFFFEE78).w
		bcs.s	locret_1C54E
		tst.b	($FFFFFE2A).w
		bne.s	loc_1C522
		cmpi.w	#2,($FFFFFF08).w
		bcc.s	loc_1C522
		lea	(AIZ1_16x16_MainLevel_Kos).l,a1
		lea	($FFFF9268).w,a2
		jsr	(Queue_Kos).l
		lea	(AIZ1_8x8_MainLevel_KosM).l,a1
		move.w	#$17C0,d2
		jsr	(Queue_Kos_Module).l
		st	($FFFFEEC6).w
		move.w	#$500,($FFFFF7F0).w
		move.w	#$500,($FFFFF7F2).w
		move.w	#$500,($FFFFF7F4).w

loc_1C522:

		move.b	#1,($FFFFFE2A).w
		move.w	#$13A0,($FFFFFE2E).w
		move.w	#$41A,($FFFFFE30).w
		jsr	(Save_Level_Data).l
		move.l	#0,($FFFFFE34).w
		moveq	#8,d0
		jsr	(Load_PLC).l
		addq.b	#2,($FFFFEE33).w

locret_1C54E:
		rts
; ---------------------------------------------------------------------------

loc_1C550:
		lea	(byte_1C60A).l,a1
		bsr.w	Resize_MaxYFromX
		move.w	#0,($FFFFEE18).w
		move.w	#$20E,($FFFFFCDE).w
		tst.b	($FFFFF600).w
		bmi.s	loc_1C578
		tst.w	($FFFFEE50).w
		bne.s	loc_1C578
		move.w	#$20E,($FFFFFC5E).w

loc_1C578:

		cmpi.w	#$2B00,($FFFFEE78).w
		bcs.s	loc_1C586
		move.w	#4,($FFFFFC5E).w

loc_1C586:
		cmpi.w	#$2C00,($FFFFEE78).w
		bcs.s	loc_1C594
		move.w	#$2E0,($FFFFEE18).w

loc_1C594:
		cmpi.w	#$2D80,($FFFFEE78).w
		bcs.s	locret_1C5C4
		move.w	#$C02,d0
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_1C5AE
		move.w	(word_4FAEA).l,d0

loc_1C5AE:
		move.w	d0,($FFFFFC5E).w
		move.w	#$2D80,($FFFFEE14).w
		moveq	#$5A,d0
		jsr	(Load_PLC).l
		addq.b	#2,($FFFFEE33).w

locret_1C5C4:
		rts
; ---------------------------------------------------------------------------

loc_1C5C6:
		lea	(byte_1C60A).l,a1
		bsr.w	Resize_MaxYFromX
		move.w	($FFFFEE78).w,($FFFFEE14).w
		cmpi.w	#$2E00,($FFFFEE78).w
		bcs.s	locret_1C600
		tst.b	($FFFFFF60).w
		bne.s	locret_1C600
		lea	(AIZ1_8x8_Flames_KosM).l,a1
		move.w	#$A000,d2
		jsr	(Queue_Kos_Module).l
		moveq	#$C,d0
		jsr	(Load_PLC).l
		addq.b	#2,($FFFFEE33).w

locret_1C600:

		rts
; ---------------------------------------------------------------------------

loc_1C602:
		move.w	($FFFFEE78).w,($FFFFEE14).w
		rts
; ---------------------------------------------------------------------------
byte_1C60A:	dc.b  $83, $90, $16, $50, $83, $B0, $1B,   0, $84, $30, $20,   0, $84, $C0, $2B,   0, $83, $B0, $2D, $80
		dc.b  $82, $E0, $FF, $FF
; ---------------------------------------------------------------------------

AIZ2_Resize:
		moveq	#0,d0
		move.b	($FFFFEE33).w,d0
		move.w	off_1C630(pc,d0.w),d0
		jmp	off_1C630(pc,d0.w)
; ---------------------------------------------------------------------------
off_1C630:	dc.w loc_1C64E-off_1C630	;0
		dc.w AIZ2_SonicResize1-off_1C630		;2
		dc.w AIZ2_SonicResize2-off_1C630		;4
		dc.w AIZ2_SonicResize3-off_1C630		;6
		dc.w AIZ2_SonicResize4-off_1C630		;8
		dc.w AIZ2_SonicResize5-off_1C630		;A
		dc.w AIZ2_SonicResize6-off_1C630		;C
		dc.w AIZ2_SonicResize7-off_1C630		;E
		dc.w AIZ2_SonicResizeEnd-off_1C630		;10
		dc.w AIZ2_KnuxResize1-off_1C630		;12
		dc.w AIZ2_KnuxResize2-off_1C630		;14
		dc.w AIZ2_KnuxResize3-off_1C630		;16
		dc.w AIZ2_KnuxResize4-off_1C630		;18
		dc.w AIZ2_KnuxResize5-off_1C630		;1A
		dc.w AIZ2_KnuxResizeEnd-off_1C630		;1C
; ---------------------------------------------------------------------------

loc_1C64E:
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_1C660
		move.b	#$12,($FFFFEE33).w		; If playing as Knuckles
		bra.w	AIZ2_KnuxResize1
; ---------------------------------------------------------------------------

loc_1C660:
		addq.b	#2,($FFFFEE33).w

AIZ2_SonicResize1:
		cmpi.w	#$2E0,($FFFFEE78).w
		bcs.s	locret_1C68E
		move.w	#$590,d0
		move.w	d0,($FFFFEE1A).w
		move.w	d0,($FFFFEE12).w
		addq.b	#2,($FFFFEE33).w		; Set level height to normal when past the open field
		cmpi.w	#1,($FFFFEE4E).w		; If non-internal level is not AIZ2, then the miniboss hasn't been defeated yet
		bne.s	locret_1C68E
		move.w	#$F50,($FFFFEE14).w		; Put $F50 as the start X
		addq.b	#2,($FFFFEE33).w

locret_1C68E:

		rts
; ---------------------------------------------------------------------------

AIZ2_SonicResize2:
		move.w	#$590,d0
		cmpi.w	#$ED0,($FFFFEE78).w
		bcs.s	loc_1C6A0
		move.w	#$2B8,d0		; Set level height to 2B8 when boss is approached.

loc_1C6A0:
		move.w	d0,($FFFFEE1A).w
		move.w	d0,($FFFFEE12).w
		cmpi.w	#$F50,($FFFFEE78).w
		bcs.s	locret_1C6DA
		move.w	#$F50,($FFFFEE14).w		; When boss has been reached, lock the screen
		tst.w	($FFFFFE08).w			; If in debug mode, don't load boss
		bne.s	loc_1C6D6
		jsr	(Create_New_Sprite).l
		bne.s	loc_1C6D6
		move.l	#Obj_AIZ_Miniboss,(a1)	; Make the miniboss
		move.w	#$11F0,$10(a1)
		move.w	#$289,$14(a1)			; Set the position for Sonic's area area

loc_1C6D6:

		addq.b	#2,($FFFFEE33).w

locret_1C6DA:
		rts
; ---------------------------------------------------------------------------

AIZ2_SonicResize3:
		cmpi.w	#$1500,($FFFFEE78).w
		bcs.s	locret_1C6F4
		move.w	#$630,($FFFFEE1A).w		; Set the level height to $630 when playing as Sonic past $1500
		move.w	#$630,($FFFFEE12).w
		addq.b	#2,($FFFFEE33).w

locret_1C6F4:
		rts
; ---------------------------------------------------------------------------

AIZ2_SonicResize4:
		cmpi.w	#$3C00,($FFFFEE78).w
		bcs.s	locret_1C744
		tst.b	($FFFFFF60).w			; When $3C00 X is passed
		bne.s	locret_1C744
		lea	(AIZ2_16x16_BomberShip_Kos).l,a1	; If KosM queue is clear
		lea	($FFFF9AB8).w,a2
		jsr	(Queue_Kos).l
		lea	(AIZ2_8x8_BomberShip_KosM).l,a1
		move.w	#$3F80,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_AIZ2Bombership2_8x8).l,a1
		move.w	#$A000,d2
		jsr	(Queue_Kos_Module).l				; Load all battleship art
		moveq	#$30,d0
		jsr	(LoadPalette_Immediate).l			; Load palette
		st	($FFFFEEC6).w						; Send signal to background event
		addq.b	#2,($FFFFEE33).w

locret_1C744:

		rts
; ---------------------------------------------------------------------------

AIZ2_SonicResize5:
		cmpi.w	#$3F00,($FFFFEE78).w
		bcs.s	locret_1C75E
		move.w	#$15A,d0				; When past $3F00 X, set top of level to $15A
		move.w	d0,($FFFFEE18).w
		move.w	d0,($FFFFEE10).w
		addq.b	#2,($FFFFEE33).w

locret_1C75E:
		rts
; ---------------------------------------------------------------------------

AIZ2_SonicResize6:
		cmpi.w	#$4000,($FFFFEE78).w
		bcs.s	locret_1C778
		move.w	#$15A,d0
		move.w	d0,($FFFFEE1A).w		; When past $4000 X, set bottom of level to $15A
		move.w	d0,($FFFFEE12).w
		addq.b	#2,($FFFFEE33).w

locret_1C778:
		rts
; ---------------------------------------------------------------------------

AIZ2_SonicResize7:
		cmpi.w	#$4160,($FFFFEE78).w
		bcs.s	AIZ2_SonicResizeEnd
		st	($FFFFEEC4).w				; When past $4160, send signal to screen event to start the battleship sequence
		addq.b	#2,($FFFFEE33).w

AIZ2_SonicResizeEnd:

		rts
; ---------------------------------------------------------------------------

AIZ2_KnuxResize1:

		cmpi.w	#$2E0,($FFFFEE78).w
		bcs.s	locret_1C7B6
		move.w	#$590,d0
		move.w	d0,($FFFFEE1A).w
		move.w	d0,($FFFFEE12).w		; Set level height to normal when past the open field
		addq.b	#2,($FFFFEE33).w
		cmpi.w	#1,($FFFFEE4E).w
		bne.s	locret_1C7B6
		move.w	#$1040,($FFFFEE14).w	; Knuckles boss is slightly more to the right than Sonic's
		addq.b	#2,($FFFFEE33).w

locret_1C7B6:

		rts
; ---------------------------------------------------------------------------

AIZ2_KnuxResize2:
		move.w	#$590,d0
		cmpi.w	#$E80,($FFFFEE78).w
		bcs.s	loc_1C7C8
		move.w	#$450,d0

loc_1C7C8:
		move.w	d0,($FFFFEE1A).w
		move.w	d0,($FFFFEE12).w
		cmpi.w	#$1040,($FFFFEE78).w
		bcs.s	locret_1C808
		move.w	#$1040,($FFFFEE14).w
		tst.w	($FFFFFE08).w
		bne.s	loc_1C7FE
		jsr	(Create_New_Sprite).l
		bne.s	loc_1C7FE
		move.l	#Obj_AIZ_Miniboss,(a1)
		move.w	#$11D0,$10(a1)			; Knuckles' version of the boss is further down obviously
		move.w	#$420,$14(a1)

loc_1C7FE:

		move.w	#$F80,($FFFFF64A).w
		addq.b	#2,($FFFFEE33).w

locret_1C808:
		rts
; ---------------------------------------------------------------------------

AIZ2_KnuxResize3:
		cmpi.w	#$11A0,($FFFFEE78).w
		bcs.s	locret_1C81C
		move.w	#$820,($FFFFEE12).w		; Set level height to $820 when playing as Knuckles
		addq.b	#2,($FFFFEE33).w

locret_1C81C:
		rts
; ---------------------------------------------------------------------------

AIZ2_KnuxResize4:
		cmpi.w	#$3B80,($FFFFEE78).w
		bcs.s	locret_1C868
		tst.b	($FFFFFF60).w
		bne.s	locret_1C868
		lea	(AIZ2_16x16_BomberShip_Kos).l,a1
		lea	($FFFF9AB8).w,a2
		jsr	(Queue_Kos).l
		lea	(AIZ2_8x8_BomberShip_KosM).l,a1
		move.w	#$3F80,d2
		jsr	(Queue_Kos_Module).l			; I'm guessing the art here is for the trees and/or the waterfall in the boss arena
		moveq	#$30,d0
		jsr	(LoadPalette_Immediate).l
		move.w	#$3B80,($FFFFEE14).w
		move.w	#$5DA,($FFFFEE12).w
		st	($FFFFEEC6).w					; Set the flag for the background event
		addq.b	#2,($FFFFEE33).w

locret_1C868:

		rts
; ---------------------------------------------------------------------------

AIZ2_KnuxResize5:
		move.w	#$3F80,d0
		cmp.w	($FFFFEE78).w,d0
		bhi.s	AIZ2_KnuxResizeEnd
		move.w	d0,($FFFFEE14).w
		addq.b	#2,($FFFFEE33).w

AIZ2_KnuxResizeEnd:

		rts
; ---------------------------------------------------------------------------

HCZ1_Resize:
		moveq	#0,d0
		move.b	($FFFFEE33).w,d0
		move.w	off_1C88C(pc,d0.w),d0
		jmp	off_1C88C(pc,d0.w)
; ---------------------------------------------------------------------------
off_1C88C:	dc.w loc_1C892-off_1C88C

		dc.w loc_1C8B8-off_1C88C
		dc.w locret_1C8F4-off_1C88C
; ---------------------------------------------------------------------------

loc_1C892:
		cmpi.w	#$360,($FFFFEE78).w
		bcc.s	locret_1C8B6
		cmpi.w	#$3E0,($FFFFEE7C).w
		bcs.s	locret_1C8B6
		lea	($FFFFFC70).w,a1
		move.w	#$B80,(a1)+
		move.w	#$240,(a1)+
		move.w	#$220,(a1)+
		addq.b	#2,($FFFFEE33).w

locret_1C8B6:

		rts
; ---------------------------------------------------------------------------

loc_1C8B8:
		cmpi.w	#$360,($FFFFEE78).w
		bcc.s	loc_1C8CE
		cmpi.w	#$3E0,($FFFFEE7C).w
		bcc.s	locret_1C8F2
		subq.b	#2,($FFFFEE33).w
		bra.s	loc_1C8E2
; ---------------------------------------------------------------------------

loc_1C8CE:
		cmpi.w	#$500,($FFFFEE7C).w
		bcs.s	locret_1C8F2
		cmpi.w	#$900,($FFFFEE78).w
		bcs.s	locret_1C8F2
		addq.b	#2,($FFFFEE33).w

loc_1C8E2:
		lea	($FFFFFC70).w,a1
		move.w	#$CEE,(a1)+
		move.w	#$ACE,(a1)+
		move.w	#$8A,(a1)+

locret_1C8F2:

		rts
; ---------------------------------------------------------------------------

locret_1C8F4:
		rts
; ---------------------------------------------------------------------------

HCZ2_Resize:
		moveq	#0,d0
		move.b	($FFFFEE33).w,d0
		move.w	off_1C904(pc,d0.w),d0
		jmp	off_1C904(pc,d0.w)
; ---------------------------------------------------------------------------
off_1C904:	dc.w loc_1C908-off_1C904

		dc.w locret_1C91A-off_1C904
; ---------------------------------------------------------------------------

loc_1C908:
		cmpi.w	#$C00,($FFFFEE78).w
		bcs.s	locret_1C918
		st	($FFFFEEC6).w
		addq.b	#2,($FFFFEE33).w

locret_1C918:
		rts
; ---------------------------------------------------------------------------

locret_1C91A:
		rts
; ---------------------------------------------------------------------------

MGZ_Resize:
		moveq	#0,d0
		move.b	($FFFFEE33).w,d0
		move.w	off_1C92A(pc,d0.w),d0
		jmp	off_1C92A(pc,d0.w)
; ---------------------------------------------------------------------------
off_1C92A:	dc.w loc_1C930-off_1C92A

		dc.w loc_1C96E-off_1C92A
		dc.w locret_1C9C8-off_1C92A
; ---------------------------------------------------------------------------

loc_1C930:
		move.w	($FFFFEE7C).w,d0
		cmpi.w	#$600,d0
		bcs.s	locret_1C96C
		cmpi.w	#$700,d0
		bcc.s	locret_1C96C
		cmpi.w	#$3A00,($FFFFEE78).w
		bcs.s	locret_1C96C
		move.w	#$6A0,d0
		move.w	d0,($FFFFEE18).w
		move.w	d0,($FFFFEE10).w
		move.w	d0,($FFFFEE1A).w
		move.w	d0,($FFFFEE12).w
		move.w	#$3C80,d0
		move.w	d0,($FFFFEE16).w
		move.w	d0,($FFFFEE0E).w
		addq.b	#2,($FFFFEE33).w

locret_1C96C:

		rts
; ---------------------------------------------------------------------------

loc_1C96E:
		cmpi.w	#$3A00,($FFFFEE78).w
		bcs.s	loc_1C9A8
		move.w	#$3C80,d0
		cmp.w	($FFFFEE78).w,d0
		bhi.s	locret_1C9C6
		move.w	d0,($FFFFEE14).w
		move.w	d0,($FFFFEE0C).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_1C9A2
		move.l	#Obj_A1_1_MGZ2_Boss,(a1)
		move.w	#$3D20,$10(a1)
		move.w	#$668,$14(a1)

loc_1C9A2:
		addq.b	#2,($FFFFEE33).w
		rts
; ---------------------------------------------------------------------------

loc_1C9A8:
		move.l	#$1000,d0
		move.l	d0,($FFFFEE18).w
		move.l	d0,($FFFFEE10).w
		move.w	#$6000,d0
		move.w	d0,($FFFFEE16).w
		move.w	d0,($FFFFEE0E).w
		subq.b	#2,($FFFFEE33).w

locret_1C9C6:
		rts
; ---------------------------------------------------------------------------

locret_1C9C8:
		rts
; ---------------------------------------------------------------------------

No_Resize2:
		rts
; ---------------------------------------------------------------------------

ICZ1_Resize:
		moveq	#0,d0
		move.b	($FFFFEE33).w,d0
		move.w	off_1C9DA(pc,d0.w),d0
		jmp	off_1C9DA(pc,d0.w)
; ---------------------------------------------------------------------------
off_1C9DA:	dc.w loc_1C9E0-off_1C9DA

		dc.w loc_1C9FA-off_1C9DA
		dc.w locret_1CA0C-off_1C9DA
; ---------------------------------------------------------------------------

loc_1C9E0:
		cmpi.w	#$3700,($FFFFEE78).w
		bcs.s	locret_1C9F8
		cmpi.w	#$68C,($FFFFEE7C).w
		bcs.s	locret_1C9F8
		st	($FFFFEEC6).w
		addq.b	#2,($FFFFEE33).w

locret_1C9F8:

		rts
; ---------------------------------------------------------------------------

loc_1C9FA:
		cmpi.w	#$3940,($FFFFEE78).w
		bcs.s	locret_1CA0A
		st	($FFFFEEC6).w
		addq.b	#2,($FFFFEE33).w

locret_1CA0A:
		rts
; ---------------------------------------------------------------------------

locret_1CA0C:
		rts
; ---------------------------------------------------------------------------

ICZ2_Resize:
		moveq	#0,d0
		move.b	($FFFFEE33).w,d0
		move.w	off_1CA1C(pc,d0.w),d0
		jmp	off_1CA1C(pc,d0.w)
; ---------------------------------------------------------------------------
off_1CA1C:	dc.w loc_1CA20-off_1CA1C

		dc.w locret_1CA3C-off_1CA1C
; ---------------------------------------------------------------------------

loc_1CA20:
		cmpi.w	#$740,($FFFFEE78).w
		bcs.s	locret_1CA3A
		cmpi.w	#$400,($FFFFEE7C).w
		bcc.s	locret_1CA3A
		move.w	#$740,($FFFFEE14).w
		addq.b	#2,($FFFFEE33).w

locret_1CA3A:

		rts
; ---------------------------------------------------------------------------

locret_1CA3C:
		rts
; ---------------------------------------------------------------------------

No_Resize:
		rts
; ---------------------------------------------------------------------------

LBZ2_Resize:
		moveq	#0,d0
		move.b	($FFFFEE33).w,d0
		move.w	off_1CA4E(pc,d0.w),d0
		jmp	off_1CA4E(pc,d0.w)
; ---------------------------------------------------------------------------
off_1CA4E:	dc.w loc_1CA52-off_1CA4E

		dc.w locret_1CAAA-off_1CA4E
; ---------------------------------------------------------------------------

loc_1CA52:
		cmpi.w	#$3BC0,($FFFFEE78).w
		bcs.s	locret_1CAA8
		cmpi.w	#$500,($FFFFEE7C).w
		bcs.s	locret_1CAA8
		addq.b	#2,($FFFFEE33).w
		lea	(LBZ2_16x16_DeathEgg_Kos).l,a1
		lea	($FFFF9000).w,a2
		jsr	(Queue_Kos).l
		lea	(LBZ2_128x128_DeathEgg_Kos).l,a1
		lea	($FFFF0000).l,a2
		jsr	(Queue_Kos).l
		lea	(LBZ2_8x8_DeathEgg_KosM).l,a1
		move.w	#0,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_LBZ2DeathEgg2_8x8).l,a1
		move.w	#$B400,d2
		jsr	(Queue_Kos_Module).l

locret_1CAA8:

		rts
; ---------------------------------------------------------------------------

locret_1CAAA:
		rts
; ---------------------------------------------------------------------------

No_Resize3:
		rts

; =============== S U B R O U T I N E =======================================


Resize_MaxYFromX:

		move.w	($FFFFEE78).w,d0

loc_1CAB2:
		move.l	(a1)+,d1
		cmp.w	d1,d0
		bhi.s	loc_1CAB2
		swap	d1
		tst.w	d1
		bpl.s	loc_1CAC6
		andi.w	#$7FFF,d1
		move.w	d1,($FFFFEE1A).w

loc_1CAC6:
		move.w	d1,($FFFFEE12).w
		rts
; End of function Resize_MaxYFromX


; =============== S U B R O U T I N E =======================================


Draw_LRZ_Special_Rock_Sprites:

		moveq	#0,d0
		move.b	($FFFFFE65).w,d0
		move.w	off_1CADA(pc,d0.w),d0
		jmp	off_1CADA(pc,d0.w)
; End of function Draw_LRZ_Special_Rock_Sprites

; ---------------------------------------------------------------------------
off_1CADA:	dc.w loc_1CADE-off_1CADA
		dc.w loc_1CB20-off_1CADA
; ---------------------------------------------------------------------------

loc_1CADE:
		addq.b	#2,($FFFFFE65).w
		lea	(LRZ1_Rock_Placement).l,a1
		tst.b	($FFFFFE11).w
		beq.s	loc_1CAF4
		lea	(LRZ2_Rock_Placement).l,a1

loc_1CAF4:
		move.w	($FFFFEE78).w,d4
		subq.w	#8,d4
		bhi.s	loc_1CB02
		moveq	#1,d4
		bra.s	loc_1CB02
; ---------------------------------------------------------------------------

loc_1CB00:
		addq.l	#6,a1

loc_1CB02:

		cmp.w	2(a1),d4
		bhi.s	loc_1CB00
		move.l	a1,($FFFFFE66).w
		addi.w	#$150,d4
		bra.s	loc_1CB14
; ---------------------------------------------------------------------------

loc_1CB12:
		addq.l	#6,a1

loc_1CB14:
		cmp.w	2(a1),d4
		bhi.s	loc_1CB12
		move.l	a1,($FFFFFE6A).w
		rts
; ---------------------------------------------------------------------------

loc_1CB20:
		movea.l	($FFFFFE66).w,a1
		move.w	($FFFFEE78).w,d4
		subq.w	#8,d4
		bhi.s	loc_1CB32
		moveq	#1,d4
		bra.s	loc_1CB32
; ---------------------------------------------------------------------------

loc_1CB30:
		addq.l	#6,a1

loc_1CB32:

		cmp.w	2(a1),d4
		bhi.s	loc_1CB30
		bra.s	loc_1CB3C
; ---------------------------------------------------------------------------

loc_1CB3A:
		subq.l	#6,a1

loc_1CB3C:
		cmp.w	-4(a1),d4
		bls.s	loc_1CB3A
		move.l	a1,($FFFFFE66).w
		movea.l	($FFFFFE6A).w,a2
		addi.w	#$150,d4
		bra.s	loc_1CB52
; ---------------------------------------------------------------------------

loc_1CB50:
		addq.l	#6,a2

loc_1CB52:
		cmp.w	2(a2),d4
		bhi.s	loc_1CB50
		bra.s	loc_1CB5C
; ---------------------------------------------------------------------------

loc_1CB5A:
		subq.l	#6,a2

loc_1CB5C:
		cmp.w	-4(a2),d4
		bls.s	loc_1CB5A
		move.l	a2,($FFFFFE6A).w
		rts

; =============== S U B R O U T I N E =======================================


sub_1CB68:
		movea.l	($FFFFFE66).w,a0
		move.l	($FFFFFE6A).w,d2
		sub.l	a0,d2
		beq.s	locret_1CBBC
		lea	word_1CBBE(pc),a1
		move.w	#$78,d3
		move.w	4(a3),d4
		move.w	#$F0,d5

loc_1CB84:
		move.w	4(a0),d1
		sub.w	d4,d1
		addq.w	#8,d1
		cmp.w	d5,d1
		bcc.s	loc_1CBB6
		add.w	d3,d1
		move.w	2(a0),d0
		sub.w	(a3),d0
		addi.w	#$80,d0
		move.w	(a0),d6
		lsl.w	#3,d6
		lea	(a1,d6.w),a2
		add.w	(a2)+,d1
		move.w	d1,(a6)+
		move.w	(a2)+,d6
		move.b	d6,(a6)
		addq.w	#2,a6
		move.w	(a2)+,(a6)+
		add.w	(a2)+,d0
		move.w	d0,(a6)+
		subq.w	#1,d7

loc_1CBB6:
		addq.l	#6,a0
		subq.w	#6,d2
		bne.s	loc_1CB84

locret_1CBBC:
		rts
; End of function sub_1CB68

; ---------------------------------------------------------------------------
word_1CBBE:	dc.w  $FFF8,	 5, $C088, $FFF8
		dc.w  $FFF8,	 5, $C08C, $FFF8
		dc.w  $FFF8,	 5, $C888, $FFF8
		dc.w  $FFF8,	 5, $C88C, $FFF8
		dc.w	  0,	 4, $C090, $FFF8
		dc.w	  0,	 4, $C092, $FFF8
		dc.w	  0,	 4, $C890, $FFF8
		dc.w	  0,	 4, $C892, $FFF8
		dc.w  $FFF8,	 5, $C094, $FFF8
		dc.w  $FFF8,	 5, $C098, $FFF8
		dc.w  $FFF8,	 5, $C09C, $FFF8
		dc.w  $FFF8,	 5, $C0A0, $FFF8
		dc.w  $FFF8,	 5, $C0A4, $FFF8
		dc.w  $FFF8,	 5, $C0A8, $FFF8
		dc.w  $FFF8,	 1, $C0AC,     0
		dc.w  $FFF8,	 5, $C0AE, $FFF8
		dc.w  $FFF8,	 5, $C0B2, $FFF8
		dc.w  $FFF8,	 5, $C0B6, $FFF8
		dc.w	  0,	 0, $C0BA,     0
		dc.w  $FFF8,	 5, $C894, $FFF8
		dc.w  $FFF8,	 5, $C898, $FFF8
		dc.w  $FFF8,	 5, $C89C, $FFF8
		dc.w  $FFF8,	 5, $C8A0, $FFF8
		dc.w	  0,	 0, $C8BA, $FFF8
		dc.w  $FFF8,	 5, $C0BB, $FFF8
		dc.w  $FFF8,	 5, $C0BF, $FFF8
		dc.w  $FFF8,	 5, $C0C3, $FFF8
		dc.w  $FFF8,	 5, $C0C7, $FFF8
		dc.w  $FFF8,	 5, $C0CB, $FFF8
		dc.w  $FFF8,	 5, $C0CF, $FFF8
; ---------------------------------------------------------------------------

Obj_PathSwap:

		move.l	#Map_PathSwap,$C(a0)
		move.w	#$26BC,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$40,7(a0)
		move.b	#$40,6(a0)
		move.w	#$280,8(a0)
		move.b	$2C(a0),d0
		btst	#2,d0
		beq.s	loc_1CD3C
		andi.w	#7,d0
		move.b	d0,$22(a0)
		andi.w	#3,d0
		add.w	d0,d0
		move.w	word_1CD34(pc,d0.w),$32(a0)
		move.w	$14(a0),d1
		lea	($FFFFB000).w,a1
		cmp.w	$14(a1),d1
		bcc.s	loc_1CD06
		move.b	#1,$34(a0)

loc_1CD06:
		lea	($FFFFB04A).w,a1
		cmp.w	$14(a1),d1
		bcc.s	loc_1CD16
		move.b	#1,$35(a0)

loc_1CD16:
		move.l	#loc_1CEF2,(a0)
		tst.w	($FFFFFFE8).w
		beq.w	loc_1CEF2
		move.l	#loc_1CF1A,(a0)
		move.w	#$63D2,$A(a0)
		bra.w	loc_1CF1A
; ---------------------------------------------------------------------------
word_1CD34:	dc.w $20
		dc.w $40
		dc.w $80
		dc.w $100
; ---------------------------------------------------------------------------

loc_1CD3C:
		andi.w	#3,d0
		move.b	d0,$22(a0)
		add.w	d0,d0
		move.w	word_1CD34(pc,d0.w),$32(a0)
		move.w	$10(a0),d1
		lea	($FFFFB000).w,a1
		cmp.w	$10(a1),d1
		bcc.s	loc_1CD60
		move.b	#1,$34(a0)

loc_1CD60:
		lea	($FFFFB04A).w,a1
		cmp.w	$10(a1),d1
		bcc.s	loc_1CD70
		move.b	#1,$35(a0)

loc_1CD70:
		move.l	#loc_1CD8A,(a0)
		tst.w	($FFFFFFE8).w
		beq.s	loc_1CD8A
		move.l	#loc_1CDB2,(a0)
		move.w	#$63D2,$A(a0)
		bra.s	loc_1CDB2
; ---------------------------------------------------------------------------

loc_1CD8A:

		tst.w	($FFFFFE08).w
		bne.w	loc_1CDAC
		move.w	$10(a0),d1
		lea	$34(a0),a2
		lea	($FFFFB000).w,a1
		bsr.s	sub_1CDDA
		lea	($FFFFB04A).w,a1
		bsr.s	sub_1CDDA
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_1CDAC:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_1CDB2:

		move.w	$10(a0),d1
		lea	$34(a0),a2
		lea	($FFFFB000).w,a1
		bsr.s	sub_1CDDA
		lea	($FFFFB04A).w,a1
		bsr.s	sub_1CDDA
		lea	($FFFFCB2C).w,a1
		tst.w	($FFFFFFDA).w
		beq.w	sub_1CDDA
		bsr.s	sub_1CDDA
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_1CDDA:

		tst.b	(a2)+
		bne.w	loc_1CE6C
		cmp.w	$10(a1),d1
		bhi.w	locret_1CEF0
		move.b	#1,-1(a2)
		move.w	$14(a0),d2
		move.w	d2,d3
		move.w	$32(a0),d4
		sub.w	d4,d2
		add.w	d4,d3
		move.w	$14(a1),d4
		cmp.w	d2,d4
		blt.w	locret_1CEF0
		cmp.w	d3,d4
		bge.w	locret_1CEF0
		move.b	$2C(a0),d0
		bpl.s	loc_1CE1C
		btst	#1,$2A(a1)
		bne.w	locret_1CEF0

loc_1CE1C:
		move.w	$10(a1),d2
		sub.w	d1,d2
		bcc.s	loc_1CE26
		neg.w	d2

loc_1CE26:
		cmpi.w	#$40,d2
		bcc.w	locret_1CEF0
		btst	#0,4(a0)
		bne.s	loc_1CE54
		move.b	#$C,$46(a1)
		move.b	#$D,$47(a1)
		btst	#3,d0
		beq.s	loc_1CE54
		move.b	#$E,$46(a1)
		move.b	#$F,$47(a1)

loc_1CE54:

		andi.w	#$7FFF,$A(a1)
		btst	#5,d0
		beq.w	locret_1CEF0
		ori.w	#$8000,$A(a1)
		bra.w	locret_1CEF0
; ---------------------------------------------------------------------------

loc_1CE6C:
		cmp.w	$10(a1),d1
		bls.w	locret_1CEF0
		move.b	#0,-1(a2)
		move.w	$14(a0),d2
		move.w	d2,d3
		move.w	$32(a0),d4
		sub.w	d4,d2
		add.w	d4,d3
		move.w	$14(a1),d4
		cmp.w	d2,d4
		blt.w	locret_1CEF0
		cmp.w	d3,d4
		bge.w	locret_1CEF0
		move.b	$2C(a0),d0
		bpl.s	loc_1CEA8
		btst	#1,$2A(a1)
		bne.w	locret_1CEF0

loc_1CEA8:
		move.w	$10(a1),d2
		sub.w	d1,d2
		bcc.s	loc_1CEB2
		neg.w	d2

loc_1CEB2:
		cmpi.w	#$40,d2
		bcc.s	locret_1CEF0
		btst	#0,4(a0)
		bne.s	loc_1CEDE
		move.b	#$C,$46(a1)
		move.b	#$D,$47(a1)
		btst	#4,d0
		beq.s	loc_1CEDE
		move.b	#$E,$46(a1)
		move.b	#$F,$47(a1)

loc_1CEDE:

		andi.w	#$7FFF,$A(a1)
		btst	#6,d0
		beq.s	locret_1CEF0
		ori.w	#$8000,$A(a1)

locret_1CEF0:

		rts
; End of function sub_1CDDA

; ---------------------------------------------------------------------------

loc_1CEF2:

		tst.w	($FFFFFE08).w
		bne.w	loc_1CF14
		move.w	$14(a0),d1
		lea	$34(a0),a2
		lea	($FFFFB000).w,a1
		bsr.s	sub_1CF42
		lea	($FFFFB04A).w,a1
		bsr.s	sub_1CF42
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_1CF14:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_1CF1A:

		move.w	$14(a0),d1
		lea	$34(a0),a2
		lea	($FFFFB000).w,a1
		bsr.s	sub_1CF42
		lea	($FFFFB04A).w,a1
		bsr.s	sub_1CF42
		lea	($FFFFCB2C).w,a1
		tst.w	($FFFFFFDA).w
		beq.w	sub_1CF42
		bsr.s	sub_1CF42
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_1CF42:

		tst.b	(a2)+
		bne.w	loc_1CFD4
		cmp.w	$14(a1),d1
		bhi.w	locret_1D058
		move.b	#1,-1(a2)
		move.w	$10(a0),d2
		move.w	d2,d3
		move.w	$32(a0),d4
		sub.w	d4,d2
		add.w	d4,d3
		move.w	$10(a1),d4
		cmp.w	d2,d4
		blt.w	locret_1D058
		cmp.w	d3,d4
		bge.w	locret_1D058
		move.b	$2C(a0),d0
		bpl.s	loc_1CF84
		btst	#1,$2A(a1)
		bne.w	locret_1D058

loc_1CF84:
		move.w	$14(a1),d2
		sub.w	d1,d2
		bcc.s	loc_1CF8E
		neg.w	d2

loc_1CF8E:
		cmpi.w	#$40,d2
		bcc.w	locret_1D058
		btst	#0,4(a0)
		bne.s	loc_1CFBC
		move.b	#$C,$46(a1)
		move.b	#$D,$47(a1)
		btst	#3,d0
		beq.s	loc_1CFBC
		move.b	#$E,$46(a1)
		move.b	#$F,$47(a1)

loc_1CFBC:

		andi.w	#$7FFF,$A(a1)
		btst	#5,d0
		beq.w	locret_1D058
		ori.w	#$8000,$A(a1)
		bra.w	locret_1D058
; ---------------------------------------------------------------------------

loc_1CFD4:
		cmp.w	$14(a1),d1
		bls.w	locret_1D058
		move.b	#0,-1(a2)
		move.w	$10(a0),d2
		move.w	d2,d3
		move.w	$32(a0),d4
		sub.w	d4,d2
		add.w	d4,d3
		move.w	$10(a1),d4
		cmp.w	d2,d4
		blt.w	locret_1D058
		cmp.w	d3,d4
		bge.w	locret_1D058
		move.b	$2C(a0),d0
		bpl.s	loc_1D010
		btst	#1,$2A(a1)
		bne.w	locret_1D058

loc_1D010:
		move.w	$14(a1),d2
		sub.w	d1,d2
		bcc.s	loc_1D01A
		neg.w	d2

loc_1D01A:
		cmpi.w	#$40,d2
		bcc.s	locret_1D058
		btst	#0,4(a0)
		bne.s	loc_1D046
		move.b	#$C,$46(a1)
		move.b	#$D,$47(a1)
		btst	#4,d0
		beq.s	loc_1D046
		move.b	#$E,$46(a1)
		move.b	#$F,$47(a1)

loc_1D046:

		andi.w	#$7FFF,$A(a1)
		btst	#6,d0
		beq.s	locret_1D058
		ori.w	#$8000,$A(a1)

locret_1D058:

		rts
; End of function sub_1CF42

; ---------------------------------------------------------------------------
Map_PathSwap:	include "General\Sprites\Level Misc\Map - Path Swap.asm"

; ---------------------------------------------------------------------------

Obj_3A_2:
		move.l	#Map_PathSwap,$C(a0)
		move.w	#$26BC,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$40,7(a0)
		move.b	#$40,6(a0)
		move.w	#$280,8(a0)
		move.b	$2C(a0),d0
		btst	#2,d0
		beq.s	loc_1D180
		andi.w	#7,d0
		move.b	d0,$22(a0)
		andi.w	#3,d0
		add.w	d0,d0
		move.w	word_1D178(pc,d0.w),$32(a0)
		move.w	$14(a0),d1
		lea	($FFFFB000).w,a1
		cmp.w	$14(a1),d1
		bcc.s	loc_1D15E
		move.b	#1,$34(a0)

loc_1D15E:
		lea	($FFFFB04A).w,a1
		cmp.w	$14(a1),d1
		bcc.s	loc_1D16E
		move.b	#1,$35(a0)

loc_1D16E:
		move.l	#loc_1D390,(a0)
		bra.w	loc_1D390
; ---------------------------------------------------------------------------
word_1D178:	dc.w $20
		dc.w $40
		dc.w $80
		dc.w $100
; ---------------------------------------------------------------------------

loc_1D180:
		andi.w	#3,d0
		move.b	d0,$22(a0)
		add.w	d0,d0
		move.w	word_1D178(pc,d0.w),$32(a0)
		move.w	$10(a0),d1
		lea	($FFFFB000).w,a1
		cmp.w	$10(a1),d1
		bcc.s	loc_1D1A4
		move.b	#1,$34(a0)

loc_1D1A4:
		lea	($FFFFB04A).w,a1
		cmp.w	$10(a1),d1
		bcc.s	loc_1D1B4
		move.b	#1,$35(a0)

loc_1D1B4:
		move.l	#loc_1D1BA,(a0)

loc_1D1BA:
		tst.w	($FFFFFE08).w
		bne.w	loc_1D1DC
		move.w	$10(a0),d1
		lea	$34(a0),a2
		lea	($FFFFB000).w,a1
		bsr.s	sub_1D1E2
		lea	($FFFFB04A).w,a1
		bsr.s	sub_1D1E2
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_1D1DC:
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_1D1E2:

		tst.b	(a2)+
		bne.w	loc_1D2BE
		cmp.w	$10(a1),d1
		bhi.w	locret_1D38E
		move.b	#1,-1(a2)
		move.w	$14(a0),d2
		move.w	d2,d3
		move.w	$32(a0),d4
		sub.w	d4,d2
		add.w	d4,d3
		move.w	$14(a1),d4
		cmp.w	d2,d4
		blt.w	locret_1D38E
		cmp.w	d3,d4
		bge.w	locret_1D38E
		move.b	$2C(a0),d0
		bpl.s	loc_1D224
		btst	#1,$2A(a1)
		bne.w	locret_1D38E

loc_1D224:
		move.w	$10(a1),d2
		sub.w	d1,d2
		bcc.s	loc_1D22E
		neg.w	d2

loc_1D22E:
		cmpi.w	#$40,d2
		bcc.w	locret_1D38E
		btst	#0,4(a0)
		bne.s	loc_1D2A6
		btst	#3,d0
		bne.s	loc_1D276
		cmpi.b	#$C,$46(a1)
		bne.s	loc_1D254
		move.b	#0,1(a2)
		bra.s	loc_1D268
; ---------------------------------------------------------------------------

loc_1D254:
		addq.b	#1,1(a2)
		cmpi.b	#2,1(a2)
		bne.s	loc_1D268
		move.b	#0,1(a2)
		bra.s	loc_1D2A6
; ---------------------------------------------------------------------------

loc_1D268:

		move.b	#$C,$46(a1)
		move.b	#$D,$47(a1)
		bra.s	loc_1D2A6
; ---------------------------------------------------------------------------

loc_1D276:
		cmpi.b	#$C,$46(a1)
		bne.s	loc_1D286
		move.b	#0,1(a2)
		bra.s	loc_1D2A6
; ---------------------------------------------------------------------------

loc_1D286:
		addq.b	#1,1(a2)
		cmpi.b	#2,1(a2)
		bne.s	loc_1D29A
		move.b	#0,1(a2)
		bra.s	loc_1D2A6
; ---------------------------------------------------------------------------

loc_1D29A:
		move.b	#$E,$46(a1)
		move.b	#$F,$47(a1)

loc_1D2A6:

		andi.w	#$7FFF,$A(a1)
		btst	#5,d0
		beq.w	locret_1D38E
		ori.w	#$8000,$A(a1)
		bra.w	locret_1D38E
; ---------------------------------------------------------------------------

loc_1D2BE:
		cmp.w	$10(a1),d1
		bls.w	locret_1D38E
		move.b	#0,-1(a2)
		move.w	$14(a0),d2
		move.w	d2,d3
		move.w	$32(a0),d4
		sub.w	d4,d2
		add.w	d4,d3
		move.w	$14(a1),d4
		cmp.w	d2,d4
		blt.w	locret_1D38E
		cmp.w	d3,d4
		bge.w	locret_1D38E
		move.b	$2C(a0),d0
		bpl.s	loc_1D2FA
		btst	#1,$2A(a1)
		bne.w	locret_1D38E

loc_1D2FA:
		move.w	$10(a1),d2
		sub.w	d1,d2
		bcc.s	loc_1D304
		neg.w	d2

loc_1D304:
		cmpi.w	#$40,d2
		bcc.w	locret_1D38E
		btst	#0,4(a0)
		bne.s	loc_1D37C
		btst	#4,d0
		bne.s	loc_1D34C
		cmpi.b	#$C,$46(a1)
		bne.s	loc_1D32A
		move.b	#0,1(a2)
		bra.s	loc_1D33E
; ---------------------------------------------------------------------------

loc_1D32A:
		addq.b	#1,1(a2)
		cmpi.b	#2,1(a2)
		bne.s	loc_1D33E
		move.b	#0,1(a2)
		bra.s	loc_1D37C
; ---------------------------------------------------------------------------

loc_1D33E:

		move.b	#$C,$46(a1)
		move.b	#$D,$47(a1)
		bra.s	loc_1D37C
; ---------------------------------------------------------------------------

loc_1D34C:
		cmpi.b	#$C,$46(a1)
		bne.s	loc_1D35C
		move.b	#0,1(a2)
		bra.s	loc_1D37C
; ---------------------------------------------------------------------------

loc_1D35C:
		addq.b	#1,1(a2)
		cmpi.b	#2,1(a2)
		bne.s	loc_1D370
		move.b	#0,1(a2)
		bra.s	loc_1D37C
; ---------------------------------------------------------------------------

loc_1D370:
		move.b	#$E,$46(a1)
		move.b	#$F,$47(a1)

loc_1D37C:

		andi.w	#$7FFF,$A(a1)
		btst	#6,d0
		beq.s	locret_1D38E
		ori.w	#$8000,$A(a1)

locret_1D38E:

		rts
; End of function sub_1D1E2

; ---------------------------------------------------------------------------

loc_1D390:

		tst.w	($FFFFFE08).w
		bne.w	loc_1D3B2
		move.w	$14(a0),d1
		lea	$34(a0),a2
		lea	($FFFFB000).w,a1
		bsr.s	sub_1D3B8
		lea	($FFFFB04A).w,a1
		bsr.s	sub_1D3B8
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_1D3B2:
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_1D3B8:

		tst.b	(a2)+
		bne.w	loc_1D494
		cmp.w	$14(a1),d1
		bhi.w	locret_1D564
		move.b	#1,-1(a2)
		move.w	$10(a0),d2
		move.w	d2,d3
		move.w	$32(a0),d4
		sub.w	d4,d2
		add.w	d4,d3
		move.w	$10(a1),d4
		cmp.w	d2,d4
		blt.w	locret_1D564
		cmp.w	d3,d4
		bge.w	locret_1D564
		move.b	$2C(a0),d0
		bpl.s	loc_1D3FA
		btst	#1,$2A(a1)
		bne.w	locret_1D564

loc_1D3FA:
		move.w	$14(a1),d2
		sub.w	d1,d2
		bcc.s	loc_1D404
		neg.w	d2

loc_1D404:
		cmpi.w	#$40,d2
		bcc.w	locret_1D564
		btst	#0,4(a0)
		bne.s	loc_1D47C
		btst	#3,d0
		bne.s	loc_1D44C
		cmpi.b	#$C,$46(a1)
		bne.s	loc_1D42A
		move.b	#0,1(a2)
		bra.s	loc_1D43E
; ---------------------------------------------------------------------------

loc_1D42A:
		addq.b	#1,1(a2)
		cmpi.b	#2,1(a2)
		bne.s	loc_1D43E
		move.b	#0,1(a2)
		bra.s	loc_1D47C
; ---------------------------------------------------------------------------

loc_1D43E:

		move.b	#$C,$46(a1)
		move.b	#$D,$47(a1)
		bra.s	loc_1D47C
; ---------------------------------------------------------------------------

loc_1D44C:
		cmpi.b	#$C,$46(a1)
		bne.s	loc_1D45C
		move.b	#0,1(a2)
		bra.s	loc_1D47C
; ---------------------------------------------------------------------------

loc_1D45C:
		addq.b	#1,1(a2)
		cmpi.b	#2,1(a2)
		bne.s	loc_1D470
		move.b	#0,1(a2)
		bra.s	loc_1D47C
; ---------------------------------------------------------------------------

loc_1D470:
		move.b	#$E,$46(a1)
		move.b	#$F,$47(a1)

loc_1D47C:

		andi.w	#$7FFF,$A(a1)
		btst	#5,d0
		beq.w	locret_1D564
		ori.w	#$8000,$A(a1)
		bra.w	locret_1D564
; ---------------------------------------------------------------------------

loc_1D494:
		cmp.w	$14(a1),d1
		bls.w	locret_1D564
		move.b	#0,-1(a2)
		move.w	$10(a0),d2
		move.w	d2,d3
		move.w	$32(a0),d4
		sub.w	d4,d2
		add.w	d4,d3
		move.w	$10(a1),d4
		cmp.w	d2,d4
		blt.w	locret_1D564
		cmp.w	d3,d4
		bge.w	locret_1D564
		move.b	$2C(a0),d0
		bpl.s	loc_1D4D0
		btst	#1,$2A(a1)
		bne.w	locret_1D564

loc_1D4D0:
		move.w	$14(a1),d2
		sub.w	d1,d2
		bcc.s	loc_1D4DA
		neg.w	d2

loc_1D4DA:
		cmpi.w	#$40,d2
		bcc.w	locret_1D564
		btst	#0,4(a0)
		bne.s	loc_1D552
		btst	#4,d0
		bne.s	loc_1D522
		cmpi.b	#$C,$46(a1)
		bne.s	loc_1D500
		move.b	#0,1(a2)
		bra.s	loc_1D514
; ---------------------------------------------------------------------------

loc_1D500:
		addq.b	#1,1(a2)
		cmpi.b	#2,1(a2)
		bne.s	loc_1D514
		move.b	#0,1(a2)
		bra.s	loc_1D552
; ---------------------------------------------------------------------------

loc_1D514:

		move.b	#$C,$46(a1)
		move.b	#$D,$47(a1)
		bra.s	loc_1D552
; ---------------------------------------------------------------------------

loc_1D522:
		cmpi.b	#$C,$46(a1)
		bne.s	loc_1D532
		move.b	#0,1(a2)
		bra.s	loc_1D552
; ---------------------------------------------------------------------------

loc_1D532:
		addq.b	#1,1(a2)
		cmpi.b	#2,1(a2)
		bne.s	loc_1D546
		move.b	#0,1(a2)
		bra.s	loc_1D552
; ---------------------------------------------------------------------------

loc_1D546:
		move.b	#$E,$46(a1)
		move.b	#$F,$47(a1)

loc_1D552:

		andi.w	#$7FFF,$A(a1)
		btst	#6,d0
		beq.s	locret_1D564
		ori.w	#$8000,$A(a1)

locret_1D564:

		rts
; End of function sub_1D3B8

; ---------------------------------------------------------------------------

Obj_Monitor:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_1D574(pc,d0.w),d1
		jmp	off_1D574(pc,d1.w)
; ---------------------------------------------------------------------------
off_1D574:	dc.w loc_1D57E-off_1D574

		dc.w loc_1D5DC-off_1D574
		dc.w loc_1D716-off_1D574
		dc.w loc_1D61E-off_1D574
		dc.w loc_1D61A-off_1D574
; ---------------------------------------------------------------------------

loc_1D57E:
		addq.b	#2,5(a0)
		move.b	#$F,$1E(a0)
		move.b	#$F,$1F(a0)
		move.l	#Map_Monitor,$C(a0)
		move.w	#$4C4,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$180,8(a0)
		move.b	#$E,7(a0)
		move.b	#$10,6(a0)
		move.w	$48(a0),d0
		beq.s	loc_1D5D0
		movea.w	d0,a2
		btst	#0,(a2)
		beq.s	loc_1D5D0
		move.b	#$B,$22(a0)
		move.l	#Sprite_OnScreen_Test,(a0)
		rts
; ---------------------------------------------------------------------------

loc_1D5D0:

		move.b	#$46,$28(a0)
		move.b	$2C(a0),$20(a0)

loc_1D5DC:
		bsr.s	sub_1D63A
		move.w	#$19,d1
		move.w	#$10,d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.w	sub_1D696
		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.w	sub_1D6C2
		jsr	(Add_SpriteToCollisionResponseList).l
		lea	(Ani_Monitor).l,a1
		bsr.w	Animate_Sprite

loc_1D61A:

		bra.w	Sprite_OnScreen_Test
; ---------------------------------------------------------------------------

loc_1D61E:

		cmpi.b	#$B,$22(a0)
		bne.s	loc_1D62C
		move.l	#loc_1D61A,(a0)

loc_1D62C:
		lea	(Ani_Monitor).l,a1
		bsr.w	Animate_Sprite
		bra.w	Sprite_OnScreen_Test

; =============== S U B R O U T I N E =======================================


sub_1D63A:
		move.b	$3C(a0),d0
		beq.s	locret_1D694
		btst	#1,4(a0)
		bne.s	loc_1D66C
		bsr.w	MoveSprite
		tst.w	$1A(a0)
		bmi.s	locret_1D694
		jsr	(ObjHitFloor).l
		tst.w	d1
		beq.s	loc_1D65E
		bpl.s	locret_1D694

loc_1D65E:
		add.w	d1,$14(a0)
		clr.w	$1A(a0)
		clr.b	$3C(a0)
		rts
; ---------------------------------------------------------------------------

loc_1D66C:
		bsr.w	MoveSprite2
		subi.w	#$38,$1A(a0)
		tst.w	$1A(a0)
		bpl.s	locret_1D694
		jsr	(ObjHitCeiling).l
		tst.w	d1
		beq.s	loc_1D688
		bpl.s	locret_1D694

loc_1D688:
		sub.w	d1,$14(a0)
		clr.w	$1A(a0)
		clr.b	$3C(a0)

locret_1D694:

		rts
; End of function sub_1D63A


; =============== S U B R O U T I N E =======================================


sub_1D696:
		btst	d6,$2A(a0)
		bne.s	loc_1D6DC
		cmpi.b	#2,$20(a1)
		beq.s	locret_1D6BC
		cmpi.b	#2,$38(a1)
		bne.s	loc_1D6BE
		cmpi.b	#1,$2F(a1)
		beq.s	locret_1D6BC
		cmpi.b	#3,$2F(a1)
		bne.s	loc_1D6BE

locret_1D6BC:

		rts
; ---------------------------------------------------------------------------

loc_1D6BE:

		bra.w	loc_1DF90
; End of function sub_1D696


; =============== S U B R O U T I N E =======================================


sub_1D6C2:
		btst	d6,$2A(a0)
		bne.s	loc_1D6DC
		tst.w	($FFFFFFE8).w
		beq.w	loc_1DF90
		cmpi.b	#2,$20(a1)
		bne.w	loc_1DF90
		rts
; ---------------------------------------------------------------------------

loc_1D6DC:
		move.w	d1,d2
		add.w	d2,d2
		btst	#1,$2A(a1)
		bne.s	loc_1D6F8
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	loc_1D6F8
		cmp.w	d2,d0
		bcs.s	loc_1D70C

loc_1D6F8:

		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)
		bclr	d6,$2A(a0)
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_1D70C:
		move.w	d4,d2
		bsr.w	sub_1E19C
		moveq	#0,d4
		rts
; End of function sub_1D6C2

; ---------------------------------------------------------------------------

loc_1D716:
		move.b	$2A(a0),d0
		andi.b	#$78,d0
		beq.s	loc_1D746
		move.b	d0,d1
		andi.b	#$28,d1
		beq.s	loc_1D734
		andi.b	#$D7,($FFFFB02A).w
		ori.b	#2,($FFFFB02A).w

loc_1D734:
		andi.b	#$50,d0
		beq.s	loc_1D746
		andi.b	#$D7,($FFFFB074).w
		ori.b	#2,($FFFFB074).w

loc_1D746:

		andi.b	#3,$2A(a0)
		move.b	#0,$28(a0)
		bsr.w	Create_New_Sprite3
		bne.s	loc_1D782
		move.l	#loc_1D7BA,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	$20(a0),$20(a1)
		move.b	4(a0),4(a1)
		move.b	$2A(a0),$2A(a1)
		move.w	$42(a0),$42(a1)

loc_1D782:
		bsr.w	Create_New_Sprite3
		bne.s	loc_1D79E
		move.l	#Obj_Explosion,(a1)
		addq.b	#2,5(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)

loc_1D79E:
		move.w	$48(a0),d0
		beq.s	loc_1D7AA
		movea.w	d0,a2
		bset	#0,(a2)

loc_1D7AA:
		move.b	#$A,$20(a0)
		move.l	#loc_1D61E,(a0)
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------

loc_1D7BA:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_1D7C8(pc,d0.w),d1
		jmp	off_1D7C8(pc,d1.w)
; ---------------------------------------------------------------------------
off_1D7C8:	dc.w loc_1D7CE-off_1D7C8

		dc.w loc_1D81A-off_1D7C8
		dc.w loc_1DB2E-off_1D7C8
; ---------------------------------------------------------------------------

loc_1D7CE:
		addq.b	#2,5(a0)
		move.w	#$84C4,$A(a0)
		ori.b	#$24,4(a0)
		move.w	#$180,8(a0)
		move.b	#8,7(a0)
		move.w	#-$300,$1A(a0)
		btst	#1,4(a0)
		beq.s	loc_1D7FC
		neg.w	$1A(a0)

loc_1D7FC:
		moveq	#0,d0
		move.b	$20(a0),d0
		addq.b	#1,d0
		move.b	d0,$22(a0)
		movea.l	#Map_Monitor,a1
		add.b	d0,d0
		adda.w	(a1,d0.w),a1
		addq.w	#2,a1
		move.l	a1,$C(a0)

loc_1D81A:
		bsr.s	sub_1D820
		bra.w	Draw_Sprite

; =============== S U B R O U T I N E =======================================


sub_1D820:
		btst	#1,4(a0)
		bne.s	loc_1D83C
		tst.w	$1A(a0)
		bpl.w	loc_1D850
		bsr.w	MoveSprite2
		addi.w	#$18,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_1D83C:
		tst.w	$1A(a0)
		bmi.w	loc_1D850
		bsr.w	MoveSprite2
		subi.w	#$18,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_1D850:

		addq.b	#2,5(a0)
		move.w	#$1D,$24(a0)
		movea.w	$42(a0),a1
		lea	($FFFFFECC).w,a2
		cmpa.w	#$B000,a1
		beq.s	loc_1D86C
		lea	($FFFFFECE).w,a2

loc_1D86C:
		moveq	#0,d0
		move.b	$20(a0),d0
		add.w	d0,d0
		move.w	off_1D87C(pc,d0.w),d0
		jmp	off_1D87C(pc,d0.w)
; End of function sub_1D820

; ---------------------------------------------------------------------------
off_1D87C:	dc.w loc_1D890-off_1D87C

		dc.w Monitor_Give_1up-off_1D87C
		dc.w loc_1D890-off_1D87C
		dc.w Monitor_Give_Rings-off_1D87C
		dc.w Monitor_Give_Super_Sneakers-off_1D87C
		dc.w Monitor_Give_Fire_Shield-off_1D87C
		dc.w Monitor_Give_Lightning_Shield-off_1D87C
		dc.w Monitor_Give_Bubble_Shield-off_1D87C
		dc.w Monitor_Give_Invincibility-off_1D87C
		dc.w Monitor_Give_SuperSonic-off_1D87C
; ---------------------------------------------------------------------------

loc_1D890:

		addq.w	#1,(a2)
		jmp	(sub_24280).l
; ---------------------------------------------------------------------------

Monitor_Give_1up:

		addq.w	#1,($FFFFFECC).w
		addq.b	#1,($FFFFFE12).w
		addq.b	#1,($FFFFFE1C).w
		moveq	#$2A,d0
		jmp	(Play_Sound).l
; ---------------------------------------------------------------------------

Monitor_Give_Rings:
		addq.w	#1,(a2)
		lea	($FFFFFE20).w,a2
		lea	($FFFFFE1D).w,a3
		lea	($FFFFFE1B).w,a4
		lea	($FFFFFEC8).w,a5
		addi.w	#$A,(a5)
		cmpi.w	#$3E7,(a5)
		bcs.s	loc_1D8CC
		move.w	#$3E7,(a5)

loc_1D8CC:
		addi.w	#$A,(a2)
		cmpi.w	#$3E7,(a2)
		bcs.s	loc_1D8DA
		move.w	#$3E7,(a2)

loc_1D8DA:
		ori.b	#1,(a3)
		cmpi.w	#$64,(a2)
		bcs.s	loc_1D8F6
		bset	#1,(a4)
		beq.s	loc_1D8FE
		cmpi.w	#$C8,(a2)
		bcs.s	loc_1D8F6
		bset	#2,(a4)
		beq.s	loc_1D8FE

loc_1D8F6:

		moveq	#$33,d0
		jmp	(Play_Sound).l
; ---------------------------------------------------------------------------

loc_1D8FE:

		cmpa.w	#$B000,a1
		beq.w	Monitor_Give_1up
		bra.w	loc_1D890
; ---------------------------------------------------------------------------

Monitor_Give_Super_Sneakers:
		addq.w	#1,(a2)
		bset	#2,$2B(a1)
		move.b	#$96,$36(a1)
		cmpa.w	#$B000,a1
		bne.s	loc_1D93A
		cmpi.w	#2,($FFFFFF08).w
		beq.s	loc_1D93A
		move.w	#$C00,($FFFFF760).w
		move.w	#$18,($FFFFF762).w
		move.w	#$80,($FFFFF764).w
		bra.s	loc_1D94C
; ---------------------------------------------------------------------------

loc_1D93A:

		move.w	#$C00,($FFFFFEC0).w
		move.w	#$18,($FFFFFEC2).w
		move.w	#$80,($FFFFFEC4).w

loc_1D94C:
		moveq	#8,d0
		jmp	(Change_Music_Tempo).l
; ---------------------------------------------------------------------------

Monitor_Give_Fire_Shield:
		addq.w	#1,(a2)
		andi.b	#$8E,$2B(a1)
		bset	#0,$2B(a1)
		bset	#4,$2B(a1)
		moveq	#$3E,d0
		jsr	(Play_Sound).l
		tst.b	$43(a0)
		bne.s	loc_1D984
		move.l	#Obj_Fire_Shield,($FFFFCCE8).w
		move.w	a1,($FFFFCD2A).w
		rts
; ---------------------------------------------------------------------------

loc_1D984:
		move.l	#Obj_Fire_Shield,($FFFFCD32).w
		move.w	a1,($FFFFCD74).w
		rts
; ---------------------------------------------------------------------------

Monitor_Give_Lightning_Shield:
		addq.w	#1,(a2)
		andi.b	#$8E,$2B(a1)
		bset	#0,$2B(a1)
		bset	#5,$2B(a1)
		moveq	#$41,d0
		jsr	(Play_Sound).l
		tst.b	$43(a0)
		bne.s	loc_1D9C2
		move.l	#Obj_Lightning_Shield,($FFFFCCE8).w
		move.w	a1,($FFFFCD2A).w
		rts
; ---------------------------------------------------------------------------

loc_1D9C2:
		move.l	#Obj_Lightning_Shield,($FFFFCD32).w
		move.w	a1,($FFFFCD74).w
		rts
; ---------------------------------------------------------------------------

Monitor_Give_Bubble_Shield:
		addq.w	#1,(a2)
		andi.b	#$8E,$2B(a1)
		bset	#0,$2B(a1)
		bset	#6,$2B(a1)
		moveq	#$3F,d0
		jsr	(Play_Sound).l
		tst.b	$43(a0)
		bne.s	loc_1DA00
		move.l	#Obj_Bubble_Shield,($FFFFCCE8).w
		move.w	a1,($FFFFCD2A).w
		rts
; ---------------------------------------------------------------------------

loc_1DA00:
		move.l	#Obj_Bubble_Shield,($FFFFCD32).w
		move.w	a1,($FFFFCD74).w
		rts
; ---------------------------------------------------------------------------

Monitor_Give_Invincibility:
		addq.w	#1,(a2)
		tst.b	($FFFFFE19).w
		bne.s	locret_1DA5E
		tst.b	($FFFFF667).w
		bne.s	locret_1DA5E
		bset	#1,$2B(a1)
		move.b	#$96,$35(a1)
		tst.b	($FFFFF7AA).w
		bne.s	loc_1DA3E
		cmpi.b	#$C,$2C(a1)
		bls.s	loc_1DA3E
		moveq	#$2C,d0
		jsr	(Play_Sound).l

loc_1DA3E:

		tst.b	$43(a0)
		bne.s	loc_1DA52
		move.l	#Obj_Invincibility,($FFFFCD7C).w
		move.w	a1,($FFFFCDBE).w
		rts
; ---------------------------------------------------------------------------

loc_1DA52:
		move.l	#Obj_Invincibility,($FFFFCEA4).w
		move.w	a1,($FFFFCEE6).w

locret_1DA5E:

		rts
; ---------------------------------------------------------------------------

Monitor_Give_SuperSonic:
		addq.w	#1,(a2)
		addi.w	#$32,($FFFFFE20).w
		move.b	#1,($FFFFF65F).w
		move.b	#$F,($FFFFF65E).w
		move.b	#1,($FFFFFE19).w
		move.w	#$3C,($FFFFF670).w
		move.w	#$800,($FFFFF760).w
		move.w	#$18,($FFFFF762).w
		move.w	#$C0,($FFFFF764).w
		move.b	#$1F,($FFFFB020).w
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_1DACE
		move.b	#0,($FFFFFE19).w
		move.b	#1,($FFFFF667).w
		move.b	#$29,($FFFFB020).w
		move.w	#$800,($FFFFFEC0).w
		move.w	#$18,($FFFFFEC2).w
		move.w	#$C0,($FFFFFEC4).w
		move.l	#Obj_HyperTails_Birds,($FFFFCD7C).w
		bra.s	loc_1DB0A
; ---------------------------------------------------------------------------

loc_1DACE:
		bcc.s	loc_1DB02
		move.l	#Map_SuperSonic,($FFFFB00C).w
		move.b	#-1,($FFFFFE19).w
		move.w	#$A00,($FFFFF760).w
		move.w	#$30,($FFFFF762).w
		move.w	#$100,($FFFFF764).w
		move.l	#Obj_HyperSonic_19348,($FFFFCD7C).w
		move.l	#Obj_HyperSonicKnux_Trail,($FFFFCBC0).w
		bra.s	loc_1DB0A
; ---------------------------------------------------------------------------

loc_1DB02:
		move.l	#Obj_HyperSonicKnux_Trail,($FFFFCBC0).w

loc_1DB0A:

		move.b	#$81,($FFFFB02E).w
		move.b	#0,($FFFFB035).w
		bset	#1,$2B(a1)
		moveq	#-$61,d0
		jsr	(Play_Sound_2).l
		moveq	#$2C,d0
		jmp	(Play_Sound).l
; ---------------------------------------------------------------------------
		rts
; ---------------------------------------------------------------------------

loc_1DB2E:
		subq.w	#1,$24(a0)
		bmi.w	Delete_Current_Sprite
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------
Ani_Monitor:	include "General\Sprites\Monitors\Anim - Monitor.asm"

Map_Monitor:	include "General\Sprites\Monitors\Map - Monitor.asm"


; =============== S U B R O U T I N E =======================================


SolidObjectFull:

		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.s	sub_1DC74
		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		tst.b	4(a1)
		bpl.w	locret_1DCB4
		addq.b	#1,d6
; End of function SolidObjectFull


; =============== S U B R O U T I N E =======================================


sub_1DC74:

		btst	d6,$2A(a0)
		beq.w	loc_1DF88
		move.w	d1,d2
		add.w	d2,d2
		btst	#1,$2A(a1)
		bne.s	loc_1DC98
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	loc_1DC98
		cmp.w	d2,d0
		bcs.s	loc_1DCAC

loc_1DC98:

		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)
		bclr	d6,$2A(a0)
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_1DCAC:
		move.w	d4,d2
		bsr.w	sub_1E19C
		moveq	#0,d4

locret_1DCB4:
		rts
; End of function sub_1DC74


; =============== S U B R O U T I N E =======================================


SolidObjectFull2:

		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.s	SolidObjectFull2_1P
		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		addq.b	#1,d6
; End of function SolidObjectFull2


; =============== S U B R O U T I N E =======================================


SolidObjectFull2_1P:

		btst	d6,$2A(a0)
		beq.w	loc_1DF90
		move.w	d1,d2
		add.w	d2,d2
		btst	#1,$2A(a1)
		bne.s	loc_1DCF0
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	loc_1DCF0
		cmp.w	d2,d0
		bcs.s	loc_1DD04

loc_1DCF0:

		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)
		bclr	d6,$2A(a0)
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_1DD04:
		move.w	d4,d2
		bsr.w	sub_1E19C
		moveq	#0,d4
		rts
; End of function SolidObjectFull2_1P


; =============== S U B R O U T I N E =======================================


sub_1DD0E:

		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.s	sub_1DD24
		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		addq.b	#1,d6
; End of function sub_1DD0E


; =============== S U B R O U T I N E =======================================


sub_1DD24:

		btst	d6,$2A(a0)
		beq.w	loc_1DECE
		move.w	d1,d2
		add.w	d2,d2
		btst	#1,$2A(a1)
		bne.s	loc_1DD48
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	loc_1DD48
		cmp.w	d2,d0
		bcs.s	loc_1DD5C

loc_1DD48:

		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)
		bclr	d6,$2A(a0)
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_1DD5C:
		move.w	d4,d2
		bsr.w	SolidObjSloped2
		move.w	d6,d4
		addi.b	#$11,d4
		bset	d4,d6
		moveq	#0,d4
		rts
; End of function sub_1DD24

; ---------------------------------------------------------------------------
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.s	sub_1DD84
		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		addq.b	#1,d6

; =============== S U B R O U T I N E =======================================


sub_1DD84:
		btst	d6,$2A(a0)
		beq.w	loc_1DF28
		move.w	d1,d2
		add.w	d2,d2
		btst	#1,$2A(a1)
		bne.s	loc_1DDA8
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	loc_1DDA8
		cmp.w	d2,d0
		bcs.s	loc_1DDBC

loc_1DDA8:

		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)
		bclr	d6,$2A(a0)
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_1DDBC:
		move.w	d4,d2
		bsr.w	SolidObjSloped4
		moveq	#0,d4
		rts
; End of function sub_1DD84


; =============== S U B R O U T I N E =======================================


sub_1DDC6:
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.s	sub_1DDDC
		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		addq.b	#1,d6
; End of function sub_1DDC6


; =============== S U B R O U T I N E =======================================


sub_1DDDC:
		btst	d6,$2A(a0)
		beq.w	loc_1DECE
		move.w	d1,d2
		add.w	d2,d2
		btst	#1,$2A(a1)
		bne.s	loc_1DE00
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	loc_1DE00
		cmp.w	d2,d0
		bcs.s	loc_1DE0E

loc_1DE00:

		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_1DE0E:
		move.w	d4,d2
		bsr.w	SolidObjSloped2
		move.w	d6,d4
		addi.b	#$11,d4
		bset	d4,d6
		moveq	#0,d4
		rts
; End of function sub_1DDDC


; =============== S U B R O U T I N E =======================================


SolidObjectFull_Offset:

		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.s	sub_1DE36
		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		addq.b	#1,d6
; End of function SolidObjectFull_Offset


; =============== S U B R O U T I N E =======================================


sub_1DE36:
		btst	d6,$2A(a0)
		beq.w	loc_1DE8C
		btst	#1,$2A(a1)
		bne.s	loc_1DE58
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	loc_1DE58
		add.w	d1,d1
		cmp.w	d1,d0
		bcs.s	loc_1DE6C

loc_1DE58:

		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)
		bclr	d6,$2A(a0)
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_1DE6C:
		move.w	$14(a0),d0
		sub.w	d2,d0
		add.w	d3,d0
		moveq	#0,d1
		move.b	$1E(a1),d1
		sub.w	d1,d0
		move.w	d0,$14(a1)
		sub.w	$10(a0),d4
		sub.w	d4,$10(a1)
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_1DE8C:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.w	loc_1E0A2
		move.w	d1,d4
		add.w	d4,d4
		cmp.w	d4,d0
		bhi.w	loc_1E0A2
		move.w	$14(a0),d5
		add.w	d3,d5
		move.b	$1E(a1),d3
		ext.w	d3
		add.w	d3,d2
		move.w	$14(a1),d3
		sub.w	d5,d3
		addq.w	#4,d3
		add.w	d2,d3
		bmi.w	loc_1E0A2
		move.w	d2,d4
		add.w	d4,d4
		cmp.w	d4,d3
		bcc.w	loc_1E0A2
		bra.w	loc_1DFFE
; ---------------------------------------------------------------------------

loc_1DECE:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.w	loc_1E0A2
		move.w	d1,d3
		add.w	d3,d3
		cmp.w	d3,d0
		bhi.w	loc_1E0A2
		move.w	d0,d5
		btst	#0,4(a0)
		beq.s	loc_1DEF4
		not.w	d5
		add.w	d3,d5

loc_1DEF4:
		lsr.w	#1,d5
		move.b	(a2,d5.w),d3
		sub.b	(a2),d3
		ext.w	d3
		move.w	$14(a0),d5
		sub.w	d3,d5
		move.b	$1E(a1),d3
		ext.w	d3
		add.w	d3,d2
		move.w	$14(a1),d3
		sub.w	d5,d3
		addq.w	#4,d3
		add.w	d2,d3
		bmi.w	loc_1E0A2
		move.w	d2,d4
		add.w	d4,d4
		cmp.w	d4,d3
		bcc.w	loc_1E0A2
		bra.w	loc_1DFFE
; ---------------------------------------------------------------------------

loc_1DF28:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.w	loc_1E0A2
		move.w	d1,d3
		add.w	d3,d3
		cmp.w	d3,d0
		bhi.w	loc_1E0A2
		move.w	d0,d5
		btst	#0,4(a0)
		beq.s	loc_1DF4E
		not.w	d5
		add.w	d3,d5

loc_1DF4E:
		andi.w	#-2,d5
		move.b	(a2,d5.w),d3
		move.b	1(a2,d5.w),d2
		ext.w	d2
		ext.w	d3
		move.w	$14(a0),d5
		sub.w	d3,d5
		move.w	$14(a1),d3
		sub.w	d5,d3
		move.b	$1E(a1),d5
		ext.w	d5
		add.w	d5,d3
		addq.w	#4,d3
		bmi.w	loc_1E0A2
		add.w	d5,d2
		move.w	d2,d4
		add.w	d5,d4
		cmp.w	d4,d3
		bcc.w	loc_1E0A2
		bra.w	loc_1DFFE
; ---------------------------------------------------------------------------

loc_1DF88:
		tst.b	4(a0)
		bpl.w	loc_1E0A2

loc_1DF90:

		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		move.w	d1,d3
		add.w	d3,d3
		cmp.w	d3,d0
		bhi.w	loc_1E0A2
		tst.b	($FFFFF7C6).w
		beq.s	loc_1DFD6
		move.b	$44(a1),d4
		ext.w	d4
		add.w	d2,d4
		move.b	$1E(a1),d3
		ext.w	d3
		add.w	d3,d2
		move.w	$14(a1),d3
		sub.w	$14(a0),d3
		neg.w	d3
		addq.w	#4,d3
		add.w	d2,d3
		andi.w	#$FFF,d3
		add.w	d2,d4
		cmp.w	d4,d3
		bcc.w	loc_1E0A2
		bra.s	loc_1DFFE
; ---------------------------------------------------------------------------

loc_1DFD6:
		move.b	$44(a1),d4
		ext.w	d4
		add.w	d2,d4
		move.b	$1E(a1),d3
		ext.w	d3
		add.w	d3,d2
		move.w	$14(a1),d3
		sub.w	$14(a0),d3
		addq.w	#4,d3
		add.w	d2,d3
		andi.w	#$FFF,d3
		add.w	d2,d4
		cmp.w	d4,d3
		bcc.w	loc_1E0A2

loc_1DFFE:

		tst.b	$2E(a1)
		bmi.w	loc_1E0A2
		cmpi.b	#6,5(a1)
		bcc.w	loc_1E0D0
		tst.w	($FFFFFE08).w
		bne.w	loc_1E0D0
		move.w	d0,d5
		cmp.w	d0,d1
		bcc.s	loc_1E026
		add.w	d1,d1
		sub.w	d1,d0
		move.w	d0,d5
		neg.w	d5

loc_1E026:
		move.w	d3,d1
		cmp.w	d3,d2
		bcc.s	loc_1E034
		subq.w	#4,d3
		sub.w	d4,d3
		move.w	d3,d1
		neg.w	d1

loc_1E034:
		cmp.w	d1,d5
		bhi.w	loc_1E0D4
		cmpi.w	#4,d1
		bls.w	loc_1E0D4

loc_1E042:
		tst.w	d0
		beq.s	loc_1E06E
		bmi.s	loc_1E050
		tst.w	$18(a1)
		bmi.s	loc_1E06E
		bra.s	loc_1E056
; ---------------------------------------------------------------------------

loc_1E050:
		tst.w	$18(a1)
		bpl.s	loc_1E06E

loc_1E056:
		move.w	#0,$1C(a1)
		move.w	#0,$18(a1)
		tst.b	$37(a1)
		bpl.s	loc_1E06E
		bset	#6,$37(a1)

loc_1E06E:

		sub.w	d0,$10(a1)
		btst	#1,$2A(a1)
		bne.s	loc_1E094
		move.l	d6,d4
		addq.b	#2,d4
		bset	d4,$2A(a0)
		bset	#5,$2A(a1)
		move.w	d6,d4
		addi.b	#$D,d4
		bset	d4,d6
		moveq	#1,d4
		rts
; ---------------------------------------------------------------------------

loc_1E094:
		bsr.s	sub_1E0C2
		move.w	d6,d4
		addi.b	#$D,d4
		bset	d4,d6
		moveq	#1,d4
		rts
; ---------------------------------------------------------------------------

loc_1E0A2:

		move.l	d6,d4
		addq.b	#2,d4
		btst	d4,$2A(a0)
		beq.s	loc_1E0D0
		cmpi.b	#2,$20(a1)
		beq.s	sub_1E0C2
		cmpi.b	#9,$20(a1)
		beq.s	sub_1E0C2
		move.w	#1,$20(a1)
; End of function sub_1DE36


; =============== S U B R O U T I N E =======================================


sub_1E0C2:

		move.l	d6,d4
		addq.b	#2,d4
		bclr	d4,$2A(a0)
		bclr	#5,$2A(a1)

loc_1E0D0:

		moveq	#0,d4
		rts
; End of function sub_1E0C2

; ---------------------------------------------------------------------------

loc_1E0D4:

		tst.w	d3
		bmi.s	loc_1E0E0
		cmpi.w	#$10,d3
		bcs.s	loc_1E154
		bra.s	loc_1E0A2
; ---------------------------------------------------------------------------

loc_1E0E0:
		btst	#1,$2A(a1)
		bne.s	loc_1E0F6
		tst.w	$1A(a1)
		beq.s	loc_1E126
		bpl.s	loc_1E10E
		tst.w	d3
		bpl.s	loc_1E10E
		bra.s	loc_1E0FC
; ---------------------------------------------------------------------------

loc_1E0F6:
		move.w	#0,$1C(a1)

loc_1E0FC:
		tst.b	($FFFFF7C6).w
		beq.s	loc_1E104
		neg.w	d3

loc_1E104:
		sub.w	d3,$14(a1)
		move.w	#0,$1A(a1)

loc_1E10E:

		tst.b	$37(a1)
		bpl.s	loc_1E11A
		bset	#5,$37(a1)

loc_1E11A:
		move.w	d6,d4
		addi.b	#$F,d4
		bset	d4,d6
		moveq	#-2,d4
		rts
; ---------------------------------------------------------------------------

loc_1E126:
		btst	#1,$2A(a1)
		bne.s	loc_1E10E
		move.w	d0,d4
		bpl.s	loc_1E134
		neg.w	d4

loc_1E134:
		cmpi.w	#$10,d4
		bcs.w	loc_1E042
		move.l	a0,-(sp)
		movea.l	a1,a0
		jsr	(Kill_Character).l
		movea.l	(sp)+,a0
		move.w	d6,d4
		addi.b	#$F,d4
		bset	d4,d6
		moveq	#-2,d4
		rts
; ---------------------------------------------------------------------------

loc_1E154:
		subq.w	#4,d3
		moveq	#0,d1
		move.b	7(a0),d1
		move.w	d1,d2
		add.w	d2,d2
		add.w	$10(a1),d1
		sub.w	$10(a0),d1
		bmi.s	loc_1E198
		cmp.w	d2,d1
		bcc.s	loc_1E198
		subq.w	#1,$14(a1)
		tst.b	($FFFFF7C6).w
		beq.s	loc_1E17E
		neg.w	d3
		addq.w	#2,$14(a1)

loc_1E17E:
		sub.w	d3,$14(a1)
		tst.w	$1A(a1)
		bmi.s	loc_1E198
		bsr.w	RideObject_SetRide
		move.w	d6,d4
		addi.b	#$11,d4
		bset	d4,d6
		moveq	#-1,d4
		rts
; ---------------------------------------------------------------------------

loc_1E198:

		moveq	#0,d4
		rts

; =============== S U B R O U T I N E =======================================


sub_1E19C:

		tst.b	($FFFFF7C6).w
		bne.s	loc_1E1AA
		move.w	$14(a0),d0
		sub.w	d3,d0
		bra.s	loc_1E1CA
; ---------------------------------------------------------------------------

loc_1E1AA:
		move.w	$14(a0),d0
		add.w	d3,d0
		bra.s	loc_1E1F4
; ---------------------------------------------------------------------------
		tst.b	($FFFFF7C6).w
		beq.s	loc_1E1C2
		move.w	$14(a0),d0
		addi.w	#9,d0
		bra.s	loc_1E1F4
; ---------------------------------------------------------------------------

loc_1E1C2:
		move.w	$14(a0),d0
		subi.w	#9,d0

loc_1E1CA:
		tst.b	$2E(a1)
		bmi.s	locret_1E1F2
		cmpi.b	#6,5(a1)
		bcc.s	locret_1E1F2
		tst.w	($FFFFFE08).w
		bne.s	locret_1E1F2
		moveq	#0,d1
		move.b	$1E(a1),d1
		sub.w	d1,d0
		move.w	d0,$14(a1)
		sub.w	$10(a0),d2
		sub.w	d2,$10(a1)

locret_1E1F2:

		rts
; ---------------------------------------------------------------------------

loc_1E1F4:

		tst.b	$2E(a1)
		bmi.s	locret_1E21C
		cmpi.b	#6,5(a1)
		bcc.s	locret_1E21C
		tst.w	($FFFFFE08).w
		bne.s	locret_1E21C
		moveq	#0,d1
		move.b	$1E(a1),d1

loc_1E20E:
		add.w	d1,d0
		move.w	d0,$14(a1)
		sub.w	$10(a0),d2
		sub.w	d2,$10(a1)

locret_1E21C:

		rts
; End of function sub_1E19C


; =============== S U B R O U T I N E =======================================


SolidObjSloped:
		btst	#3,$2A(a1)
		beq.s	locret_1E280
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		btst	#0,4(a0)
		beq.s	loc_1E23E
		not.w	d0
		add.w	d1,d0
		add.w	d1,d0

loc_1E23E:
		bra.s	loc_1E260
; End of function SolidObjSloped


; =============== S U B R O U T I N E =======================================


SolidObjSloped2:

		btst	#3,$2A(a1)
		beq.s	locret_1E280
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		lsr.w	#1,d0
		btst	#0,4(a0)
		beq.s	loc_1E260
		not.w	d0
		add.w	d1,d0

loc_1E260:

		move.b	(a2,d0.w),d1
		ext.w	d1
		move.w	$14(a0),d0
		sub.w	d1,d0
		moveq	#0,d1
		move.b	$1E(a1),d1
		sub.w	d1,d0
		move.w	d0,$14(a1)
		sub.w	$10(a0),d2
		sub.w	d2,$10(a1)

locret_1E280:
		rts
; End of function SolidObjSloped2


; =============== S U B R O U T I N E =======================================


SolidObjSloped4:
		btst	#3,$2A(a1)
		beq.s	locret_1E280
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		btst	#0,4(a0)
		beq.s	loc_1E2A0
		not.w	d0
		add.w	d1,d0

loc_1E2A0:
		andi.w	#-2,d0
		bra.s	loc_1E260
; End of function SolidObjSloped4


; =============== S U B R O U T I N E =======================================


SolidObjectTop:

		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.s	sub_1E2BC
		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		addq.b	#1,d6
; End of function SolidObjectTop


; =============== S U B R O U T I N E =======================================


sub_1E2BC:

		btst	d6,$2A(a0)
		beq.w	loc_1E42E
		move.w	d1,d2
		add.w	d2,d2
		btst	#1,$2A(a1)
		bne.s	loc_1E2E0
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	loc_1E2E0
		cmp.w	d2,d0
		bcs.s	loc_1E2F4

loc_1E2E0:

		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)
		bclr	d6,$2A(a0)
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_1E2F4:
		move.w	d4,d2
		bsr.w	sub_1E19C
		moveq	#0,d4
		rts
; End of function sub_1E2BC


; =============== S U B R O U T I N E =======================================


SolidObjectTopSloped2:

		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.s	sub_1E314
		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		addq.b	#1,d6
; End of function SolidObjectTopSloped2


; =============== S U B R O U T I N E =======================================


sub_1E314:
		btst	d6,$2A(a0)
		beq.w	SolidObjCheckSloped2
		move.w	d1,d2
		add.w	d2,d2
		btst	#1,$2A(a1)
		bne.s	loc_1E338
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	loc_1E338
		cmp.w	d2,d0
		bcs.s	loc_1E34C

loc_1E338:

		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)
		bclr	d6,$2A(a0)
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_1E34C:
		move.w	d4,d2
		bsr.w	SolidObjSloped2
		moveq	#0,d4
		rts
; End of function sub_1E314


; =============== S U B R O U T I N E =======================================


SolidObjectTopSloped:
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.s	sub_1E36C
		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		addq.b	#1,d6
; End of function SolidObjectTopSloped


; =============== S U B R O U T I N E =======================================


sub_1E36C:
		btst	d6,$2A(a0)
		beq.w	SolidObjCheckSloped
		move.w	d1,d2
		add.w	d2,d2
		btst	#1,$2A(a1)
		bne.s	loc_1E390
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	loc_1E390
		cmp.w	d2,d0
		bcs.s	loc_1E3A4

loc_1E390:

		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)
		bclr	d6,$2A(a0)
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_1E3A4:
		move.w	d4,d2
		bsr.w	SolidObjSloped
		moveq	#0,d4
		rts
; End of function sub_1E36C

; ---------------------------------------------------------------------------
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.s	sub_1E3C4
		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		addq.b	#1,d6

; =============== S U B R O U T I N E =======================================


sub_1E3C4:
		btst	d6,$2A(a0)
		bne.s	loc_1E3D6
		btst	#3,$2A(a1)
		bne.s	loc_1E402
		bra.w	loc_1E42E
; ---------------------------------------------------------------------------

loc_1E3D6:
		move.w	d1,d2
		add.w	d2,d2
		btst	#1,$2A(a1)
		bne.s	loc_1E3F2
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	loc_1E3F2
		cmp.w	d2,d0
		bcs.s	loc_1E406

loc_1E3F2:

		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)
		bclr	d6,$2A(a0)

loc_1E402:
		moveq	#0,d4

locret_1E404:
		rts
; ---------------------------------------------------------------------------

loc_1E406:
		move.w	d4,d2
		bsr.w	sub_1E19C
		moveq	#0,d4
		rts
; End of function sub_1E3C4


; =============== S U B R O U T I N E =======================================


sub_1E410:
		tst.w	$1A(a1)
		bmi.w	locret_1E4D4
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.w	locret_1E4D4
		cmp.w	d2,d0
		bcc.w	locret_1E4D4
		bra.s	loc_1E44C
; ---------------------------------------------------------------------------

loc_1E42E:
		tst.w	$1A(a1)
		bmi.w	locret_1E4D4
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.w	locret_1E4D4
		add.w	d1,d1
		cmp.w	d1,d0
		bcc.w	locret_1E4D4

loc_1E44C:
		tst.b	($FFFFF7C6).w
		bne.w	loc_1E4D6
		move.w	$14(a0),d0
		sub.w	d3,d0

loc_1E45A:

		move.w	$14(a1),d2
		move.b	$1E(a1),d1
		ext.w	d1
		add.w	d2,d1
		addq.w	#4,d1
		sub.w	d1,d0
		bhi.w	locret_1E4D4
		cmpi.w	#-$10,d0
		bcs.w	locret_1E4D4
		tst.b	$2E(a1)
		bmi.w	locret_1E4D4
		cmpi.b	#6,5(a1)
		bcc.w	locret_1E4D4
		add.w	d0,d2
		addq.w	#3,d2
		move.w	d2,$14(a1)
; End of function sub_1E410


; =============== S U B R O U T I N E =======================================


RideObject_SetRide:

		btst	#3,$2A(a1)
		beq.s	loc_1E4A0
		movea.w	$42(a1),a3
		bclr	d6,$2A(a3)

loc_1E4A0:
		move.w	a0,$42(a1)
		move.b	#0,$26(a1)
		move.w	#0,$1A(a1)
		move.w	$18(a1),$1C(a1)
		bset	#3,$2A(a1)
		bset	d6,$2A(a0)
		bclr	#1,$2A(a1)
		beq.s	locret_1E4D4
		move.l	a0,-(sp)
		movea.l	a1,a0
		jsr	(Player_TouchFloor).l
		movea.l	(sp)+,a0

locret_1E4D4:

		rts
; End of function RideObject_SetRide

; ---------------------------------------------------------------------------

loc_1E4D6:
		move.w	$14(a0),d0
		add.w	d3,d0
		move.w	$14(a1),d2
		move.b	$1E(a1),d1
		ext.w	d1
		neg.w	d1
		add.w	d2,d1
		subq.w	#4,d1
		sub.w	d0,d1
		bhi.s	locret_1E4D4
		cmpi.w	#-$10,d1
		bcs.s	locret_1E4D4
		tst.b	$2E(a1)
		bmi.s	locret_1E4D4
		cmpi.b	#6,5(a1)
		bcc.s	locret_1E4D4
		sub.w	d1,d2
		subq.w	#4,d2
		move.w	d2,$14(a1)
		bra.s	RideObject_SetRide
; ---------------------------------------------------------------------------

SolidObjCheckSloped2:
		tst.w	$1A(a1)
		bmi.w	locret_1E4D4
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	locret_1E4D4
		add.w	d1,d1
		cmp.w	d1,d0
		bcc.s	locret_1E4D4
		btst	#0,4(a0)
		beq.s	loc_1E534
		not.w	d0
		add.w	d1,d0

loc_1E534:
		lsr.w	#1,d0
		move.b	(a2,d0.w),d3
		ext.w	d3
		move.w	$14(a0),d0
		sub.w	d3,d0
		bra.w	loc_1E45A
; ---------------------------------------------------------------------------

SolidObjCheckSloped:
		tst.w	$1A(a1)
		bmi.w	locret_1E4D4
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.w	locret_1E4D4
		add.w	d1,d1
		cmp.w	d1,d0
		bcc.w	locret_1E4D4
		btst	#0,4(a0)
		beq.s	loc_1E570
		not.w	d0
		add.w	d1,d0

loc_1E570:
		move.b	(a2,d0.w),d3
		ext.w	d3
		move.w	$14(a0),d0
		sub.w	d3,d0
		bra.w	loc_1E45A

; =============== S U B R O U T I N E =======================================


CheckPlayerReleaseFromObj:

		lea	($FFFFB000).w,a1
		btst	#3,$2A(a0)
		beq.s	loc_1E5AE
		jsr	(SonicOnObjHitFloor).l
		tst.w	d1
		beq.s	loc_1E598
		bpl.s	loc_1E5AE

loc_1E598:
		lea	($FFFFB000).w,a1
		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)
		bclr	#3,$2A(a0)

loc_1E5AE:

		lea	($FFFFB04A).w,a1
		btst	#4,$2A(a0)
		beq.s	loc_1E5DC
		jsr	(SonicOnObjHitFloor).l
		tst.w	d1
		beq.s	loc_1E5C6
		bpl.s	loc_1E5DC

loc_1E5C6:
		lea	($FFFFB04A).w,a1
		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)
		bclr	#4,$2A(a0)

loc_1E5DC:

		moveq	#0,d4
		rts
; End of function CheckPlayerReleaseFromObj

; ---------------------------------------------------------------------------

Obj_Explosion:


		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_1E5EE(pc,d0.w),d1
		jmp	off_1E5EE(pc,d1.w)
; ---------------------------------------------------------------------------
off_1E5EE:	dc.w loc_1E5F6-off_1E5EE
		dc.w loc_1E61A-off_1E5EE
		dc.w loc_1E66E-off_1E5EE
		dc.w loc_1E626-off_1E5EE
; ---------------------------------------------------------------------------

loc_1E5F6:
		addq.b	#2,5(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_1E61A
		move.l	#Obj_Animal,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	$3E(a0),$3E(a1)

loc_1E61A:

		moveq	#$3D,d0
		jsr	(Play_Sound_2).l
		addq.b	#2,5(a0)

loc_1E626:
		move.l	#Map_Explosion,$C(a0)
		move.w	$A(a0),d0
		andi.w	#$8000,d0
		ori.w	#$5A0,d0
		move.w	d0,$A(a0)
		move.b	#4,4(a0)
		move.w	#$80,8(a0)
		move.b	#0,$28(a0)
		move.b	#$C,7(a0)
		move.b	#$C,6(a0)
		move.b	#3,$24(a0)

loc_1E662:
		move.b	#0,$22(a0)
		move.l	#loc_1E66E,(a0)

loc_1E66E:

		subq.b	#1,$24(a0)
		bpl.s	loc_1E688
		move.b	#7,$24(a0)
		addq.b	#1,$22(a0)
		cmpi.b	#5,$22(a0)
		beq.w	Delete_Current_Sprite

loc_1E688:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_FireShield_Dissipate:

		move.l	#Map_Explosion,$C(a0)
		move.w	#$5A0,$A(a0)
		move.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#$C,7(a0)
		move.b	#$C,6(a0)
		move.b	#3,$24(a0)
		move.b	#1,$22(a0)
		move.l	#loc_1E6C6,(a0)

loc_1E6C6:
		jsr	(MoveSprite2).l
		subq.b	#1,$24(a0)
		bpl.s	loc_1E6E6
		move.b	#3,$24(a0)
		addq.b	#1,$22(a0)
		cmpi.b	#5,$22(a0)
		beq.w	Delete_Current_Sprite

loc_1E6E6:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_1E6EC:

		move.l	#Map_Explosion,$C(a0)
		move.w	#$85A0,$A(a0)
		move.b	#4,4(a0)
		move.w	#$100,8(a0)
		move.b	#$C,7(a0)
		move.b	#$C,6(a0)
		move.b	#0,$22(a0)
		move.l	#loc_1E71E,(a0)

loc_1E71E:
		subq.b	#1,$24(a0)
		bmi.s	loc_1E726
		rts
; ---------------------------------------------------------------------------

loc_1E726:
		move.b	#3,$24(a0)
		move.l	#loc_1E732,(a0)

loc_1E732:
		jsr	(MoveSprite2).l
		subq.b	#1,$24(a0)
		bpl.s	loc_1E752
		move.b	#7,$24(a0)
		addq.b	#1,$22(a0)
		cmpi.b	#5,$22(a0)
		beq.w	Delete_Current_Sprite

loc_1E752:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Map_Explosion:	include "General\Sprites\Enemy Misc\Map - Explosion.asm"

; ---------------------------------------------------------------------------

Obj_09_1:
		move.l	#Map_AIZ1Tree,$C(a0)
		move.w	#$180,8(a0)
		move.b	#8,7(a0)
		move.b	#4,4(a0)
		move.w	#$4001,$A(a0)
		move.l	#loc_1E7B0,(a0)

loc_1E7B0:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_0A_1:
		move.l	#Map_AIZ1ZiplinePeg,$C(a0)
		move.w	#$380,8(a0)
		move.b	#$20,7(a0)
		move.b	#4,4(a0)
		move.w	#$4324,$A(a0)
		move.l	#loc_1E7DC,(a0)

loc_1E7DC:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_26:

		move.l	#Map_PathSwap,$C(a0)
		move.w	#$6BC,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$80,7(a0)
		move.b	#$80,6(a0)
		move.w	#$280,8(a0)
		move.b	$2C(a0),d0
		btst	#2,d0
		beq.s	loc_1E85C
		andi.w	#7,d0
		move.b	d0,$22(a0)
		andi.w	#3,d0
		add.w	d0,d0
		move.w	word_1E854(pc,d0.w),$32(a0)
		move.w	$14(a0),d1
		lea	($FFFFB000).w,a1
		cmp.w	$14(a1),d1
		bcc.s	loc_1E83A
		move.b	#1,$34(a0)

loc_1E83A:
		lea	($FFFFB04A).w,a1
		cmp.w	$14(a1),d1
		bcc.s	loc_1E84A
		move.b	#1,$35(a0)

loc_1E84A:
		move.l	#loc_1E9E6,(a0)
		bra.w	loc_1E9E6
; ---------------------------------------------------------------------------
word_1E854:	dc.w $20
		dc.w $40
		dc.w $80
		dc.w $100
; ---------------------------------------------------------------------------

loc_1E85C:
		andi.w	#3,d0
		move.b	d0,$22(a0)
		add.w	d0,d0
		move.w	word_1E854(pc,d0.w),$32(a0)
		move.w	$10(a0),d1
		lea	($FFFFB000).w,a1
		cmp.w	$10(a1),d1
		bcc.s	loc_1E880
		move.b	#1,$34(a0)

loc_1E880:
		lea	($FFFFB04A).w,a1
		cmp.w	$10(a1),d1
		bcc.s	loc_1E890
		move.b	#1,$35(a0)

loc_1E890:
		move.l	#loc_1E896,(a0)

loc_1E896:
		tst.w	($FFFFFE08).w
		bne.s	loc_1E8C0
		move.w	$10(a0),d1
		lea	$34(a0),a2
		lea	($FFFFB000).w,a1
		bsr.s	sub_1E8C6
		lea	($FFFFB04A).w,a1
		cmpi.w	#4,($FFFFF708).w
		beq.w	loc_1E8BA
		bsr.s	sub_1E8C6

loc_1E8BA:
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_1E8C0:
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_1E8C6:

		tst.b	(a2)+
		bne.s	loc_1E944
		cmp.w	$10(a1),d1
		bhi.w	locret_1E9B4
		move.b	#1,-1(a2)
		move.w	$14(a0),d2
		move.w	d2,d3
		move.w	$32(a0),d4
		sub.w	d4,d2
		add.w	d4,d3
		move.w	$14(a1),d4
		cmp.w	d2,d4
		bcs.w	locret_1E9B4
		cmp.w	d3,d4
		bcc.w	locret_1E9B4
		btst	#5,$2C(a0)
		beq.s	loc_1E908
		btst	#1,$2A(a1)
		bne.w	locret_1E9B4

loc_1E908:
		btst	#0,4(a0)
		bne.s	loc_1E934
		btst	#4,$2C(a0)
		bne.s	loc_1E930
		move.w	#$580,$1C(a1)
		move.b	#1,$3D(a1)
		tst.b	$2C(a0)
		bpl.s	loc_1E930
		move.b	#$81,$3D(a1)

loc_1E930:

		bra.w	loc_1E9B6
; ---------------------------------------------------------------------------

loc_1E934:
		btst	#4,$2C(a0)
		bne.s	locret_1E9B4
		move.b	#0,$3D(a1)
		rts
; ---------------------------------------------------------------------------

loc_1E944:
		cmp.w	$10(a1),d1
		bls.s	locret_1E9B4
		move.b	#0,-1(a2)
		move.w	$14(a0),d2
		move.w	d2,d3
		move.w	$32(a0),d4
		sub.w	d4,d2
		add.w	d4,d3
		move.w	$14(a1),d4
		cmp.w	d2,d4
		bcs.s	locret_1E9B4
		cmp.w	d3,d4
		bcc.s	locret_1E9B4
		btst	#5,$2C(a0)
		beq.s	loc_1E97C
		btst	#1,$2A(a1)
		bne.w	locret_1E9B4

loc_1E97C:
		btst	#0,4(a0)
		beq.s	loc_1E9A6
		btst	#4,$2C(a0)
		bne.s	loc_1E9A4
		move.w	#-$580,$1C(a1)
		move.b	#1,$3D(a1)
		tst.b	$2C(a0)
		bpl.s	loc_1E9A4
		move.b	#$81,$3D(a1)

loc_1E9A4:

		bra.s	loc_1E9B6
; ---------------------------------------------------------------------------

loc_1E9A6:
		btst	#4,$2C(a0)
		bne.s	locret_1E9B4
		move.b	#0,$3D(a1)

locret_1E9B4:

		rts
; ---------------------------------------------------------------------------

loc_1E9B6:
		btst	#2,$2A(a1)
		beq.s	loc_1E9C0
		rts
; ---------------------------------------------------------------------------

loc_1E9C0:
		bset	#2,$2A(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		addq.w	#5,$14(a1)
		moveq	#$3C,d0
		jsr	(Play_Sound_2).l
		rts
; End of function sub_1E8C6

; ---------------------------------------------------------------------------

loc_1E9E6:

		tst.w	($FFFFFE08).w
		bne.s	loc_1EA0E
		move.w	$14(a0),d1
		lea	$34(a0),a2
		lea	($FFFFB000).w,a1
		bsr.s	sub_1EA14
		lea	($FFFFB04A).w,a1
		cmpi.w	#4,($FFFFF708).w
		beq.s	loc_1EA08
		bsr.s	sub_1EA14

loc_1EA08:
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_1EA0E:
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_1EA14:

		tst.b	(a2)+
		bne.w	loc_1EAB0
		cmp.w	$14(a1),d1
		bhi.w	locret_1EB30
		move.b	#1,-1(a2)
		move.w	$10(a0),d2
		move.w	d2,d3
		move.w	$32(a0),d4
		sub.w	d4,d2
		add.w	d4,d3
		move.w	$10(a1),d4
		cmp.w	d2,d4
		bcs.w	locret_1EB30
		cmp.w	d3,d4
		bcc.w	locret_1EB30
		btst	#5,$2C(a0)
		beq.s	loc_1EA58
		btst	#1,$2A(a1)
		bne.w	locret_1EB30

loc_1EA58:
		btst	#0,4(a0)
		bne.s	loc_1EA9E
		btst	#4,$2C(a0)
		bne.s	loc_1EA9A
		move.b	#1,$3D(a1)
		tst.b	$2C(a0)
		bpl.s	loc_1EA7A
		move.b	#$81,$3D(a1)

loc_1EA7A:
		btst	#6,$2C(a0)
		beq.s	loc_1EA9A
		bclr	#1,$2A(a1)
		move.b	#$40,$26(a1)
		move.w	$1A(a1),$1C(a1)
		move.w	#0,$18(a1)

loc_1EA9A:

		bra.w	loc_1E9B6
; ---------------------------------------------------------------------------

loc_1EA9E:
		btst	#4,$2C(a0)
		bne.w	locret_1EB30
		move.b	#0,$3D(a1)
		rts
; ---------------------------------------------------------------------------

loc_1EAB0:
		cmp.w	$14(a1),d1
		bls.s	locret_1EB30
		move.b	#0,-1(a2)
		move.w	$10(a0),d2
		move.w	d2,d3
		move.w	$32(a0),d4
		sub.w	d4,d2
		add.w	d4,d3
		move.w	$10(a1),d4
		cmp.w	d2,d4
		bcs.s	locret_1EB30
		cmp.w	d3,d4
		bcc.s	locret_1EB30
		btst	#5,$2C(a0)
		beq.s	loc_1EAE8
		btst	#1,$2A(a1)
		bne.w	locret_1EB30

loc_1EAE8:
		btst	#0,4(a0)
		beq.s	loc_1EB22
		btst	#4,$2C(a0)
		bne.s	loc_1EB1E
		move.b	#1,$3D(a1)
		tst.b	$2C(a0)
		bpl.s	loc_1EB0A
		move.b	#$81,$3D(a1)

loc_1EB0A:
		btst	#6,$2C(a0)
		beq.s	loc_1EB1E
		bclr	#1,$2A(a1)
		move.b	#$40,$26(a1)

loc_1EB1E:

		bra.w	loc_1E9B6
; ---------------------------------------------------------------------------

loc_1EB22:
		btst	#4,$2C(a0)
		bne.s	locret_1EB30
		move.b	#0,$3D(a1)

locret_1EB30:

		rts
; End of function sub_1EA14

; ---------------------------------------------------------------------------
byte_1EB32:	dc.b $96
		dc.b $94
		dc.b $95
		dc.b 0
; ---------------------------------------------------------------------------

Obj_27:

		moveq	#0,d0
		move.b	$2C(a0),d0
		move.b	byte_1EB32(pc,d0.w),$28(a0)
		move.l	#Map_Obj27,$C(a0)
		tst.w	($FFFFFE08).w
		beq.s	loc_1EB58
		move.l	#Map_Obj27_2,$C(a0)

loc_1EB58:
		move.w	#$86BC,$A(a0)
		move.b	#$84,4(a0)
		move.b	#$80,7(a0)
		move.b	#$80,6(a0)
		move.w	#$200,8(a0)
		move.b	$2C(a0),$22(a0)
		move.l	#loc_1EB82,(a0)

loc_1EB82:
		tst.w	($FFFFFFE8).w
		bne.s	loc_1EB9C
		move.w	$10(a0),d0
		andi.w	#$FF80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_1EBAA

loc_1EB9C:
		tst.w	($FFFFFE08).w
		beq.s	locret_1EBA8
		jsr	(Draw_Sprite).l

locret_1EBA8:
		rts
; ---------------------------------------------------------------------------

loc_1EBAA:

		move.w	$48(a0),d0
		beq.s	loc_1EBB6
		movea.w	d0,a2
		bclr	#7,(a2)

loc_1EBB6:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
Map_Obj27:	include "General\Sprites\Unused\Map - Obj27 Unused.asm"

Map_Obj27_2:	include "General\Sprites\Unused\Map - Obj27 Unused 2.asm"

; ---------------------------------------------------------------------------

Obj_28_Invisible_Barrier:

		move.l	#Map_InvisibleBlock,$C(a0)
		move.w	#$86BC,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$200,8(a0)
		bset	#7,$2A(a0)
		move.b	$2C(a0),d0
		move.b	d0,d1
		andi.w	#$F0,d0
		addi.w	#$10,d0
		lsr.w	#1,d0
		move.b	d0,7(a0)
		andi.w	#$F,d1
		addq.w	#1,d1
		lsl.w	#3,d1
		move.b	d1,6(a0)
		tst.w	($FFFFFFE8).w
		beq.s	loc_1EC66
		move.l	#loc_1ECAA,(a0)
		bra.s	loc_1ECAA
; ---------------------------------------------------------------------------

loc_1EC66:
		move.l	#loc_1EC6C,(a0)

loc_1EC6C:
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		bsr.w	SolidObjectFull2
		move.w	$10(a0),d0
		andi.w	#$FF80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_1EBAA
		tst.w	($FFFFFE08).w
		beq.s	locret_1ECA8
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_1ECA8:
		rts
; ---------------------------------------------------------------------------

loc_1ECAA:

		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		bra.w	SolidObjectFull2
; ---------------------------------------------------------------------------
Map_InvisibleBlock:include "General\Sprites\Level Misc\Map - Invisible Block.asm"

byte_1ED1A:	dc.b $14
		dc.b $28
		dc.b $20
		dc.b 0
		dc.b $24
		dc.b $48
		dc.b $30
		dc.b 1
		dc.b $34
		dc.b $68
		dc.b $40
		dc.b 2
; ---------------------------------------------------------------------------

Obj_BreakableBar:

		move.l	#Map_BreakableBar,$C(a0)
		move.w	#$43CA,$A(a0)
		move.b	#4,4(a0)
		move.w	#$200,8(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,d1
		andi.b	#$F,d0
		mulu.w	#$3C,d0
		move.w	d0,$30(a0)
		andi.w	#$30,d1
		lsr.w	#2,d1
		lea	byte_1ED1A(pc,d1.w),a1
		tst.b	$2C(a0)
		bpl.s	loc_1ED8E
		moveq	#0,d0
		move.b	(a1)+,d0
		move.w	d0,$36(a0)
		move.b	(a1)+,d0
		move.w	d0,$38(a0)
		move.b	(a1)+,7(a0)
		move.b	#4,6(a0)
		move.b	(a1)+,d0
		addq.b	#4,d0
		move.b	d0,$22(a0)
		move.l	#loc_1EF64,(a0)
		bra.w	loc_1EF64
; ---------------------------------------------------------------------------

loc_1ED8E:
		moveq	#0,d0
		move.b	(a1)+,d0
		move.w	d0,$36(a0)
		move.b	(a1)+,d0
		move.w	d0,$38(a0)
		move.b	#4,7(a0)
		move.b	(a1)+,6(a0)
		move.b	(a1)+,$22(a0)
		move.l	#loc_1EDB0,(a0)

loc_1EDB0:
		lea	$32(a0),a2
		tst.w	$30(a0)
		beq.s	loc_1EDC6
		tst.w	(a2)
		beq.s	loc_1EDC6
		subq.w	#1,$30(a0)
		beq.w	loc_1EEEC

loc_1EDC6:

		lea	($FFFFB000).w,a1
		move.w	($FFFFF604).w,d1
		moveq	#0,d2
		bsr.s	sub_1EDEC
		addq.w	#1,a2
		lea	($FFFFB04A).w,a1
		move.w	($FFFFF606).w,d1
		moveq	#1,d2
		bsr.s	sub_1EDEC
		tst.b	$3A(a0)
		bne.w	loc_1EEEC
		bra.w	Sprite_OnScreen_Test

; =============== S U B R O U T I N E =======================================


sub_1EDEC:

		tst.b	(a2)
		beq.s	loc_1EE4E
		move.w	$14(a0),d0
		sub.w	$36(a0),d0
		btst	#8,d1
		beq.s	loc_1EE0C
		subq.w	#1,$14(a1)
		cmp.w	$14(a1),d0
		bcs.s	loc_1EE0C
		move.w	d0,$14(a1)

loc_1EE0C:

		add.w	$38(a0),d0
		btst	#9,d1
		beq.s	loc_1EE24
		addq.w	#1,$14(a1)
		cmp.w	$14(a1),d0
		bcc.s	loc_1EE24
		move.w	d0,$14(a1)

loc_1EE24:

		andi.w	#$70,d1
		beq.w	locret_1EEEA
		clr.b	(a2)
		move.b	#$3C,2(a2)
		bclr	d2,($FFFFF7C7).w
		andi.b	#-2,$2E(a1)
		btst	#6,$2C(a0)
		bne.s	locret_1EE4C
		move.b	#1,$3A(a0)

locret_1EE4C:
		rts
; ---------------------------------------------------------------------------

loc_1EE4E:
		tst.b	2(a2)
		beq.s	loc_1EE5A
		subq.b	#1,2(a2)
		rts
; ---------------------------------------------------------------------------

loc_1EE5A:
		moveq	#0,d1
		move.b	6(a0),d1
		move.w	$14(a0),d0
		sub.w	d1,d0
		move.w	$14(a1),d2
		cmp.w	d0,d2
		bcs.s	locret_1EEEA
		add.w	d1,d0
		add.w	d1,d0
		cmp.w	d0,d2
		bcc.s	locret_1EEEA
		move.w	$10(a0),d0
		addi.w	#$14,d0
		cmp.w	$10(a1),d0
		bcc.s	locret_1EEEA
		addi.w	#$10,d0
		cmp.w	$10(a1),d0
		bcs.s	locret_1EEEA
		cmpi.b	#4,5(a1)
		bcc.s	locret_1EEEA
		tst.b	$2E(a1)
		bne.s	locret_1EEEA
		move.w	$14(a0),d0
		sub.w	$36(a0),d0
		cmp.w	$14(a1),d0
		bcs.s	loc_1EEAE
		move.w	d0,$14(a1)

loc_1EEAE:
		add.w	$38(a0),d0
		cmp.w	$14(a1),d0
		bcc.s	loc_1EEBC
		move.w	d0,$14(a1)

loc_1EEBC:
		clr.w	$18(a1)
		clr.w	$1A(a1)
		move.w	$10(a0),d0
		addi.w	#$14,d0
		move.w	d0,$10(a1)
		bclr	#0,$2A(a1)
		move.b	#$11,$20(a1)
		move.b	#1,$2E(a1)
		bset	d2,($FFFFF7C7).w
		move.b	#1,(a2)

locret_1EEEA:

		rts
; End of function sub_1EDEC

; ---------------------------------------------------------------------------

loc_1EEEC:

		tst.b	$32(a0)
		beq.s	loc_1EEF8
		andi.b	#-2,($FFFFB02E).w

loc_1EEF8:
		tst.b	$33(a0)
		beq.s	loc_1EF04
		andi.b	#-2,($FFFFB078).w

loc_1EF04:
		clr.b	($FFFFF7C7).w
		clr.w	$32(a0)
		move.l	#loc_1EF3E,(a0)
		move.b	#3,$22(a0)
		move.w	#$400,$18(a0)
		move.w	#0,$1A(a0)
		lea	(word_1F108).l,a4
		lea	(byte_1F0F0).l,a2
		moveq	#0,d1
		move.b	6(a0),d1
		lsr.w	#2,d1
		subq.w	#1,d1
		bsr.w	sub_1F188

loc_1EF3E:

		tst.b	$3F(a0)
		beq.s	loc_1EF4A
		subq.b	#1,$3F(a0)
		bra.s	loc_1EF56
; ---------------------------------------------------------------------------

loc_1EF4A:
		jsr	(MoveSprite2).l
		addi.w	#8,$1A(a0)

loc_1EF56:
		tst.b	4(a0)
		bpl.w	loc_1EBAA
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_1EF64:

		lea	$32(a0),a2
		tst.w	$30(a0)
		beq.s	loc_1EF7A
		tst.w	(a2)
		beq.s	loc_1EF7A
		subq.w	#1,$30(a0)
		beq.w	loc_1F09A

loc_1EF7A:

		lea	($FFFFB000).w,a1
		move.w	($FFFFF604).w,d1
		moveq	#0,d2
		bsr.s	sub_1EFA0
		addq.w	#1,a2
		lea	($FFFFB04A).w,a1
		move.w	($FFFFF606).w,d1
		moveq	#1,d2
		bsr.s	sub_1EFA0
		tst.b	$3A(a0)
		bne.w	loc_1F09A
		bra.w	Sprite_OnScreen_Test

; =============== S U B R O U T I N E =======================================


sub_1EFA0:

		tst.b	(a2)
		beq.s	loc_1F002
		move.w	$10(a0),d0
		sub.w	$36(a0),d0
		btst	#$A,d1
		beq.s	loc_1EFC0
		subq.w	#1,$10(a1)
		cmp.w	$10(a1),d0
		bcs.s	loc_1EFC0
		move.w	d0,$10(a1)

loc_1EFC0:

		add.w	$38(a0),d0
		btst	#$B,d1
		beq.s	loc_1EFD8
		addq.w	#1,$10(a1)
		cmp.w	$10(a1),d0
		bcc.s	loc_1EFD8
		move.w	d0,$10(a1)

loc_1EFD8:

		andi.w	#$70,d1
		beq.w	locret_1F098
		clr.b	(a2)
		move.b	#$3C,2(a2)
		bclr	d2,($FFFFF7C7).w
		andi.b	#-2,$2E(a1)
		btst	#6,$2C(a0)
		bne.s	locret_1F000
		move.b	#1,$3A(a0)

locret_1F000:
		rts
; ---------------------------------------------------------------------------

loc_1F002:
		tst.b	2(a2)
		beq.s	loc_1F00E
		subq.b	#1,2(a2)
		rts
; ---------------------------------------------------------------------------

loc_1F00E:
		moveq	#0,d1
		move.b	7(a0),d1
		move.w	$10(a0),d0
		sub.w	d1,d0
		move.w	$10(a1),d2
		cmp.w	d0,d2
		bcs.s	locret_1F098
		add.w	d1,d0
		add.w	d1,d0
		cmp.w	d0,d2
		bcc.s	locret_1F098
		move.w	$14(a0),d0
		subi.w	#$14,d0
		cmp.w	$14(a1),d0
		bcc.s	locret_1F098
		addi.w	#$10,d0
		cmp.w	$14(a1),d0
		bcs.s	locret_1F098
		cmpi.b	#4,5(a1)
		bcc.s	locret_1F098
		tst.b	$2E(a1)
		bne.s	locret_1F098
		move.w	$10(a0),d0
		sub.w	$36(a0),d0
		cmp.w	$10(a1),d0
		bcs.s	loc_1F062
		move.w	d0,$10(a1)

loc_1F062:
		add.w	$38(a0),d0
		cmp.w	$10(a1),d0
		bcc.s	loc_1F070
		move.w	d0,$10(a1)

loc_1F070:
		clr.w	$18(a1)
		clr.w	$1A(a1)
		move.w	$14(a0),d0
		subi.w	#$14,d0
		move.w	d0,$14(a1)
		move.b	#$14,$20(a1)
		move.b	#1,$2E(a1)
		bset	d2,($FFFFF7C7).w
		move.b	#1,(a2)

locret_1F098:

		rts
; End of function sub_1EFA0

; ---------------------------------------------------------------------------

loc_1F09A:

		tst.b	$32(a0)
		beq.s	loc_1F0A6
		andi.b	#-2,($FFFFB02E).w

loc_1F0A6:
		tst.b	$33(a0)
		beq.s	loc_1F0B2
		andi.b	#-2,($FFFFB078).w

loc_1F0B2:
		clr.b	($FFFFF7C7).w
		clr.w	$32(a0)
		move.l	#loc_1EF3E,(a0)
		move.b	#7,$22(a0)
		move.w	#0,$18(a0)
		move.w	#-$400,$1A(a0)
		lea	(word_1F148).l,a4
		lea	(byte_1F0F0).l,a2
		moveq	#0,d1
		move.b	7(a0),d1
		lsr.w	#2,d1
		subq.w	#1,d1
		bsr.w	sub_1F188
		bra.w	loc_1EF3E
; ---------------------------------------------------------------------------
byte_1F0F0:	dc.b    7,   5,   2,   0,   1,   3,   4,   6,   7,   5,   2,   0,   1,   3,   4,   6,   8,   9,  $A,  $B
		dc.b   $C,  $D,  $E,  $F

word_1F108:	dc.w	  0, $FFE4
		dc.w	  0, $FFEC
		dc.w	  0, $FFF4
		dc.w	  0, $FFFC
		dc.w	  0,	 4
		dc.w	  0,	$C
		dc.w	  0,   $14
		dc.w	  0,   $1C
		dc.w	  0,   $24
		dc.w	  0, $FFDC
		dc.w	  0,   $2C
		dc.w	  0, $FFD4
		dc.w	  0,   $34
		dc.w	  0, $FFCC
		dc.w	  0,   $3C
		dc.w	  0, $FFC4
word_1F148:	dc.w  $FFE4,	 0
		dc.w  $FFEC,	 0
		dc.w  $FFF4,	 0
		dc.w  $FFFC,	 0
		dc.w	  4,	 0
		dc.w	 $C,	 0
		dc.w	$14,	 0
		dc.w	$1C,	 0
		dc.w	$24,	 0
		dc.w  $FFDC,	 0
		dc.w	$2C,	 0
		dc.w  $FFD4,	 0
		dc.w	$34,	 0
		dc.w  $FFCC,	 0
		dc.w	$3C,	 0
		dc.w  $FFC4,	 0

; =============== S U B R O U T I N E =======================================


sub_1F188:

		move.w	$10(a0),d2
		move.w	$14(a0),d3
		move.w	8(a0),d4
		movea.l	a0,a1
		bra.s	loc_1F1A0
; ---------------------------------------------------------------------------

loc_1F198:
		jsr	(Create_New_Sprite3).l
		bne.s	loc_1F1FA

loc_1F1A0:
		move.l	(a0),(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.b	#$84,4(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	(a4)+,d0
		add.w	d2,d0
		move.w	d0,$10(a1)
		move.w	(a4)+,d0
		add.w	d3,d0
		move.w	d0,$14(a1)
		move.w	d4,8(a1)
		move.b	#4,7(a1)
		move.b	#4,6(a1)
		move.b	$22(a0),$22(a1)
		move.w	$18(a0),$18(a1)
		move.w	$1A(a0),$1A(a1)
		move.b	(a2)+,$3F(a1)
		dbf	d1,loc_1F198

loc_1F1FA:
		moveq	#$59,d0
		jmp	(Play_Sound_2).l
; End of function sub_1F188

; ---------------------------------------------------------------------------

Obj_HCZWaveSplash:
		move.l	#Map_HCZWaveSplash,$C(a0)
		move.w	#$842E,$A(a0)
		move.b	#4,4(a0)
		move.b	#$80,7(a0)
		move.b	#8,6(a0)
		bset	#6,4(a0)
		move.w	#1,$16(a0)
		lea	$18(a0),a2
		move.w	$10(a0),(a2)
		addi.w	#$C0,(a2)+
		move.w	$14(a0),(a2)+
		move.l	#loc_1F244,(a0)

loc_1F244:
		move.w	($FFFFEE78).w,d1
		andi.w	#$FFE0,d1
		addi.w	#$60,d1
		btst	#0,($FFFFFE05).w
		beq.s	loc_1F25C
		addi.w	#$20,d1

loc_1F25C:
		move.w	d1,$10(a0)
		move.w	($FFFFF646).w,d1
		move.w	d1,$14(a0)
		lea	$18(a0),a2
		move.w	$10(a0),(a2)
		addi.w	#$C0,(a2)+
		move.w	$14(a0),(a2)+
		tst.b	$32(a0)
		bne.s	loc_1F296
		tst.b	($FFFFF603).w
		bmi.s	loc_1F28A
		tst.b	($FFFFF66B).w
		bpl.s	loc_1F2A6

loc_1F28A:
		addq.b	#3,$22(a0)
		move.b	#1,$32(a0)
		bra.s	loc_1F2C4
; ---------------------------------------------------------------------------

loc_1F296:
		tst.w	($FFFFF63A).w
		bne.s	loc_1F2C4
		move.b	#0,$32(a0)
		subq.b	#3,$22(a0)

loc_1F2A6:
		subq.b	#1,$24(a0)
		bpl.s	loc_1F2C4
		move.b	#9,$24(a0)
		addq.b	#1,$22(a0)
		cmpi.b	#4,$22(a0)
		bcs.s	loc_1F2C4
		move.b	#1,$22(a0)

loc_1F2C4:

		move.b	$22(a0),1(a2)
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------
Map_HCZWaveSplash:include "Levels\HCZ\Misc Object Data\Map - Wave Splash.asm"

byte_1F38A:	dc.b $10
		dc.b $10
		dc.b $20
		dc.b $10
		dc.b $30
		dc.b $10
		dc.b $40
		dc.b $10
; ---------------------------------------------------------------------------

Obj_HCZBlock:

		moveq	#0,d0
		move.b	$2C(a0),d0
		move.b	d0,$22(a0)
		add.w	d0,d0
		lea	byte_1F38A(pc,d0.w),a1
		move.b	(a1)+,7(a0)
		move.b	(a1)+,6(a0)
		move.l	#Map_HCZBlock,$C(a0)
		move.w	#$43D4,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.l	#loc_1F3CA,(a0)

loc_1F3CA:
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		bsr.w	SolidObjectFull2
		bra.w	Sprite_OnScreen_Test
; ---------------------------------------------------------------------------

Obj_6D_2:
		bset	#5,$2B(a0)
		bra.s	Obj_InvisibleHurtBlockHorizontal
; ---------------------------------------------------------------------------

Obj_6E_2:
		bset	#4,$2B(a0)

Obj_InvisibleHurtBlockHorizontal:

		move.l	#Map_InvisibleBlock,$C(a0)
		move.w	#$86BC,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$200,8(a0)
		bset	#7,$2A(a0)
		move.b	$2C(a0),d0
		move.b	d0,d1
		andi.w	#$F0,d0
		addi.w	#$10,d0
		lsr.w	#1,d0
		move.b	d0,7(a0)
		andi.w	#$F,d1
		addq.w	#1,d1
		lsl.w	#3,d1
		move.b	d1,6(a0)
		btst	#0,$2A(a0)
		beq.s	loc_1F448
		move.l	#loc_1F4C4,(a0)
		rts
; ---------------------------------------------------------------------------

loc_1F448:
		btst	#1,$2A(a0)
		beq.s	loc_1F458
		move.l	#loc_1F528,(a0)
		rts
; ---------------------------------------------------------------------------

loc_1F458:
		move.l	#loc_1F45E,(a0)

loc_1F45E:
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		bsr.w	SolidObjectFull2
		move.b	$2A(a0),d6
		andi.b	#$18,d6
		beq.s	loc_1F4A2
		move.b	d6,d0
		andi.b	#8,d0
		beq.s	loc_1F494
		lea	($FFFFB000).w,a1
		bsr.w	sub_1F58C

loc_1F494:
		andi.b	#$10,d6
		beq.s	loc_1F4A2
		lea	($FFFFB04A).w,a1
		bsr.w	sub_1F58C

loc_1F4A2:

		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_1EBAA
		tst.w	($FFFFFE08).w
		beq.s	locret_1F4C2
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_1F4C2:
		rts
; ---------------------------------------------------------------------------

loc_1F4C4:
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		bsr.w	SolidObjectFull2
		swap	d6
		andi.w	#3,d6
		beq.s	loc_1F506
		move.b	d6,d0
		andi.b	#1,d0
		beq.s	loc_1F4F8
		lea	($FFFFB000).w,a1
		bsr.w	sub_1F58C

loc_1F4F8:
		andi.b	#2,d6
		beq.s	loc_1F506
		lea	($FFFFB04A).w,a1
		bsr.w	sub_1F58C

loc_1F506:

		move.w	$10(a0),d0
		andi.w	#$FF80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_1EBAA
		tst.w	($FFFFFE08).w
		beq.s	locret_1F526
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_1F526:
		rts
; ---------------------------------------------------------------------------

loc_1F528:
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		bsr.w	SolidObjectFull2
		swap	d6
		andi.w	#$C,d6
		beq.s	loc_1F56A
		move.b	d6,d0
		andi.b	#4,d0
		beq.s	loc_1F55C
		lea	($FFFFB000).w,a1
		bsr.w	sub_1F58C

loc_1F55C:
		andi.b	#8,d6
		beq.s	loc_1F56A
		lea	($FFFFB04A).w,a1
		bsr.w	sub_1F58C

loc_1F56A:

		move.w	$10(a0),d0
		andi.w	#$FF80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_1EBAA
		tst.w	($FFFFFE08).w
		beq.s	locret_1F58A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_1F58A:
		rts

; =============== S U B R O U T I N E =======================================


sub_1F58C:

		move.b	$2B(a0),d0
		andi.b	#$73,d0
		and.b	$2B(a1),d0
		bne.s	locret_1F59E
		bsr.w	sub_24280

locret_1F59E:
		rts
; End of function sub_1F58C

; ---------------------------------------------------------------------------

Obj_InvisibleHurtBlockVertical:

		move.l	#Map_InvisibleBlock,$C(a0)
		move.w	#$86BC,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$200,8(a0)
		bset	#7,$2A(a0)
		move.b	$2C(a0),d0
		move.b	d0,d1
		andi.w	#$F0,d0
		addi.w	#$10,d0
		lsr.w	#1,d0
		move.b	d0,7(a0)
		andi.w	#$F,d1
		addq.w	#1,d1
		lsl.w	#3,d1
		move.b	d1,6(a0)
		btst	#0,$2A(a0)
		beq.s	loc_1F5F0
		move.l	#loc_1F66C,(a0)
		rts
; ---------------------------------------------------------------------------

loc_1F5F0:
		btst	#1,$2A(a0)
		beq.s	loc_1F600
		move.l	#loc_1F6D0,(a0)
		rts
; ---------------------------------------------------------------------------

loc_1F600:
		move.l	#loc_1F606,(a0)

loc_1F606:
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		bsr.w	SolidObjectFull2
		move.b	$2A(a0),d6
		andi.b	#$18,d6
		beq.s	loc_1F64A
		move.b	d6,d0
		andi.b	#8,d0
		beq.s	loc_1F63C
		lea	($FFFFB000).w,a1
		bsr.w	sub_1F734

loc_1F63C:
		andi.b	#$10,d6
		beq.s	loc_1F64A
		lea	($FFFFB04A).w,a1
		bsr.w	sub_1F734

loc_1F64A:

		move.w	$10(a0),d0
		andi.w	#$FF80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_1EBAA
		tst.w	($FFFFFE08).w
		beq.s	locret_1F66A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_1F66A:
		rts
; ---------------------------------------------------------------------------

loc_1F66C:
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		bsr.w	SolidObjectFull2
		swap	d6
		andi.w	#3,d6
		beq.s	loc_1F6AE
		move.b	d6,d0
		andi.b	#1,d0
		beq.s	loc_1F6A0
		lea	($FFFFB000).w,a1
		bsr.w	sub_1F734

loc_1F6A0:
		andi.b	#2,d6
		beq.s	loc_1F6AE
		lea	($FFFFB04A).w,a1
		bsr.w	sub_1F734

loc_1F6AE:

		move.w	$10(a0),d0
		andi.w	#$FF80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_1EBAA
		tst.w	($FFFFFE08).w
		beq.s	locret_1F6CE
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_1F6CE:
		rts
; ---------------------------------------------------------------------------

loc_1F6D0:
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		bsr.w	SolidObjectFull2
		swap	d6
		andi.w	#$C,d6
		beq.s	loc_1F712
		move.b	d6,d0
		andi.b	#4,d0
		beq.s	loc_1F704
		lea	($FFFFB000).w,a1
		bsr.w	sub_1F734

loc_1F704:
		andi.b	#8,d6
		beq.s	loc_1F712
		lea	($FFFFB04A).w,a1
		bsr.w	sub_1F734

loc_1F712:

		move.w	$10(a0),d0
		andi.w	#$FF80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_1EBAA
		tst.w	($FFFFFE08).w
		beq.s	locret_1F732
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_1F732:
		rts

; =============== S U B R O U T I N E =======================================


sub_1F734:

		move.w	d6,-(sp)
		move.l	a0,-(sp)
		movea.l	a1,a0
		jsr	(Kill_Character).l
		movea.l	(sp)+,a0
		move.w	(sp)+,d6
		rts
; End of function sub_1F734

; ---------------------------------------------------------------------------

Obj_03_1:
		move.b	#$D0,7(a0)
		move.l	#loc_1F752,(a0)

loc_1F752:
		bsr.w	sub_1F7B8
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		bne.s	loc_1F7B2
		tst.w	$38(a0)
		beq.s	loc_1F7B2
		subq.w	#1,$38(a0)
		bne.s	loc_1F77A
		move.w	#$1300,($FFFFEE14).w
		move.w	#$4000,($FFFFEE16).w
		bra.s	loc_1F7B2
; ---------------------------------------------------------------------------

loc_1F77A:
		cmpi.w	#$1300,($FFFFEE14).w
		beq.s	loc_1F796
		cmpi.w	#$2D00,($FFFFB010).w
		bcs.s	loc_1F792
		move.w	#$1300,($FFFFEE14).w
		bra.s	loc_1F796
; ---------------------------------------------------------------------------

loc_1F792:
		subq.w	#4,($FFFFEE14).w

loc_1F796:

		cmpi.w	#$4000,($FFFFEE16).w
		beq.s	loc_1F7B2
		cmpi.w	#$2D00,($FFFFB010).w
		bcc.s	loc_1F7AE
		move.w	#$4000,($FFFFEE16).w
		bra.s	loc_1F7B2
; ---------------------------------------------------------------------------

loc_1F7AE:
		addq.w	#4,($FFFFEE16).w

loc_1F7B2:

		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_1F7B8:
		lea	($FFFFB000).w,a1
		lea	$30(a0),a2
		moveq	#3,d6
		bsr.s	sub_1F7CE
		lea	($FFFFB04A).w,a1
		lea	$34(a0),a2
		addq.b	#1,d6
; End of function sub_1F7B8


; =============== S U B R O U T I N E =======================================


sub_1F7CE:
		btst	d6,$2A(a0)
		bne.w	loc_1F85C
		btst	#1,$2A(a1)
		bne.w	locret_1F85A
		move.w	$10(a1),d0
		addi.w	#$10,d0
		sub.w	$10(a0),d0
		bcs.s	locret_1F85A
		cmpi.w	#$40,d0
		bge.s	locret_1F85A
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		cmpi.w	#-$5A,d0
		blt.s	locret_1F85A
		cmpi.w	#$A0,d0
		bgt.s	locret_1F85A
		cmpi.w	#$600,$18(a1)
		blt.s	locret_1F85A
		tst.b	$2E(a1)
		bne.s	locret_1F85A
		bsr.w	RideObject_SetRide
		move.l	#0,(a2)
		bset	#6,$2E(a1)
		bset	#1,$2E(a1)
		move.b	#0,$20(a1)
		cmpa.w	#$B000,a1
		bne.s	locret_1F85A
		jsr	(Create_New_Sprite3).l
		bne.w	loc_1F848
		move.l	#Obj_AIZ1TreeRevealControl,(a1)

loc_1F848:
		move.w	#$2C60,($FFFFEE14).w
		move.w	#$2C60,($FFFFEE16).w
		move.w	#$3C,$38(a0)

locret_1F85A:

		rts
; ---------------------------------------------------------------------------

loc_1F85C:
		move.w	$1C(a1),d0
		bpl.s	loc_1F864
		neg.w	d0

loc_1F864:
		cmpi.w	#$600,d0
		bcs.w	loc_1F8FE
		btst	#1,$2A(a1)
		bne.s	loc_1F88C
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$90,d0
		bmi.s	AIZTree_FallOff
		cmpi.w	#$130,d0
		bls.w	AIZTree_SetPlayerPos
		bra.s	AIZTree_FallOff
; ---------------------------------------------------------------------------

loc_1F88C:

		cmpi.w	#$2C99,$10(a1)
		bcc.s	loc_1F8A0
		move.w	#$2C99,$10(a1)
		move.w	#$400,$18(a1)

loc_1F8A0:
		cmpi.w	#$2D66,$10(a1)
		bcs.s	AIZTree_FallOff
		move.w	#$2D66,$10(a1)
		move.w	#-$400,$18(a1)

AIZTree_FallOff:
		bset	#1,$2A(a1)
		bclr	#2,$2A(a1)
		move.b	#$13,$1E(a1)
		move.b	#9,$1F(a1)
		move.w	#1,$20(a1)
		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		move.b	#0,$30(a1)
		move.b	#4,$31(a1)
		bclr	#6,$2E(a1)
		bclr	#1,$2E(a1)
		asr	$18(a1)
		asr	$1A(a1)
		rts
; ---------------------------------------------------------------------------

loc_1F8FE:
		cmpi.w	#$400,(a2)
		bcc.s	AIZTree_FallOff
		move.l	d6,-(sp)
		move.l	a1,-(sp)
		bsr.s	AIZTree_SetPlayerPos
		movea.l	(sp)+,a1
		move.l	(sp)+,d6
		bra.s	AIZTree_FallOff
; End of function sub_1F7CE

; ---------------------------------------------------------------------------
		bra.w	loc_1F88C

; =============== S U B R O U T I N E =======================================


AIZTree_SetPlayerPos:

		btst	#3,$2A(a1)
		beq.w	locret_1F85A
		move.w	$1C(a1),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,(a2)
		bmi.s	AIZTree_FallOff
		cmpi.w	#$400,(a2)
		bcs.s	loc_1F93C
		move.w	#$1300,($FFFFEE14).w
		move.w	#$4000,($FFFFEE16).w

loc_1F93C:
		move.w	$10(a1),d2
		move.w	(a2),d0
		lsr.w	#1,d0
		jsr	(GetSineCosine).l
		muls.w	#$7000,d0
		swap	d0
		add.w	$10(a0),d0
		move.w	d0,$10(a1)
		sub.w	d2,d0
		asl.w	#8,d0
		move.w	d0,$18(a1)
		move.w	$14(a1),d2
		move.w	(a2),d0
		lsr.w	#2,d0
		neg.w	d0
		addi.w	#$90,d0
		add.w	$14(a0),d0
		move.w	d0,$14(a1)
		sub.w	d2,d0
		asl.w	#8,d0
		move.w	d0,$1A(a1)
		moveq	#0,d0
		move.w	(a2),d0
		lsr.w	#1,d0
		divu.w	#$B,d0
		move.b	byte_1F99A(pc,d0.w),$22(a1)
		moveq	#0,d0
		move.b	$22(a1),d0
		jmp	(Tails_Carry_LoadPLC).l
; End of function AIZTree_SetPlayerPos

; ---------------------------------------------------------------------------
byte_1F99A:	dc.b  $69, $6A, $6B, $77, $6C, $6C, $6D, $6D, $6E, $6E, $6F, $6F, $70, $70, $71, $71, $72, $72, $73, $73
		dc.b  $74, $74, $75, $75, $76, $76, $77, $77, $6C, $6C, $6D, $6D, $6E, $6E, $6F, $6F, $70, $70, $71, $71
		dc.b  $72, $72, $73, $73, $74, $74, $75, $75, $6B, $6B, $6A, $6A, $69, $69
byte_1F9D0:	dc.b  $18, $27, $18, $17, $18,  $F,  $E,  $F, $10, $28, $28, $10, $28, $10, $10, $20
; ---------------------------------------------------------------------------

Obj_AIZLRZEMZRock:

		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,d2
		lsr.w	#4,d0
		andi.b	#7,d0
		move.b	d0,$22(a0)
		add.w	d0,d0
		move.b	byte_1F9D0(pc,d0.w),7(a0)
		move.b	byte_1F9D0+1(pc,d0.w),d1
		move.b	d1,6(a0)
		move.b	d1,$1E(a0)
		move.l	#Map_AIZRock,$C(a0)
		move.w	#$2333,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$200,8(a0)
		move.w	$10(a0),$2E(a0)
		move.w	#$40,$42(a0)
		cmpi.w	#1,($FFFFFE10).w
		bne.s	loc_1FA42
		move.l	#Map_AIZRock2,$C(a0)
		move.w	#$42E9,$A(a0)

loc_1FA42:
		cmpi.w	#$1200,($FFFFFE10).w
		bne.s	loc_1FA5E
		move.l	#Map_EMZRock,$C(a0)
		move.w	#$E300,$A(a0)
		move.b	#0,$22(a0)

loc_1FA5E:
		cmpi.b	#9,($FFFFFE10).w
		bne.s	loc_1FA8C
		move.l	#Map_LRZBreakableRock,$C(a0)
		move.w	#$40D3,$A(a0)
		addq.b	#4,$22(a0)
		tst.b	($FFFFFE11).w
		beq.s	loc_1FA8C
		move.l	#Map_LRZBreakableRock2,$C(a0)
		move.w	#$640D,$A(a0)

loc_1FA8C:

		andi.w	#$F,d2
		cmpi.w	#$F,d2
		bne.s	loc_1FAA0
		move.l	#loc_20002,(a0)
		bra.w	loc_20002
; ---------------------------------------------------------------------------

loc_1FAA0:
		move.l	#loc_1FAF2,(a0)
		btst	#2,$2C(a0)
		beq.s	loc_1FAB8
		move.l	#loc_1FD08,(a0)
		bra.w	loc_1FD08
; ---------------------------------------------------------------------------

loc_1FAB8:
		btst	#3,$2C(a0)
		beq.s	loc_1FACA
		move.l	#loc_1FF48,(a0)
		bra.w	loc_1FF48
; ---------------------------------------------------------------------------

loc_1FACA:
		move.w	$48(a0),d0
		beq.s	loc_1FAF2
		movea.w	d0,a2
		move.b	(a2),d0
		andi.w	#$7F,d0
		beq.s	loc_1FAF2
		sub.w	d0,$10(a0)
		neg.w	d0
		addi.w	#$40,d0
		move.w	d0,$42(a0)
		jsr	(ObjHitFloor).l
		add.w	d1,$14(a0)

loc_1FAF2:


		move.w	($FFFFF7D0).w,$38(a0)
		move.b	($FFFFB020).w,$32(a0)
		move.b	($FFFFB06A).w,$33(a0)
		move.b	($FFFFB02A).w,$3A(a0)
		move.b	($FFFFB074).w,$3B(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		btst	#1,$2C(a0)
		beq.s	loc_1FB3A
		bsr.w	sub_200A2

loc_1FB3A:
		btst	#0,$2C(a0)
		beq.s	loc_1FB4C
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		bne.s	loc_1FB62

loc_1FB4C:

		tst.w	($FFFFFFE8).w
		bne.s	loc_1FB5C
		move.w	$2E(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_1FB5C:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_1FB62:
		cmpi.b	#$18,d0
		bne.s	loc_1FB90
		cmpi.b	#2,$32(a0)
		beq.s	loc_1FB78
		cmpi.b	#2,$33(a0)
		bne.s	loc_1FB4C

loc_1FB78:
		lea	($FFFFB000).w,a1
		move.b	$32(a0),d0
		bsr.s	sub_1FBA8
		lea	($FFFFB04A).w,a1
		move.b	$33(a0),d0
		bsr.s	sub_1FBA8
		bra.w	loc_1FBF8
; ---------------------------------------------------------------------------

loc_1FB90:
		move.b	d0,d1
		andi.b	#8,d1
		beq.s	loc_1FBE0
		cmpi.b	#2,$32(a0)
		bne.s	loc_1FB4C
		lea	($FFFFB000).w,a1
		bsr.s	sub_1FBAE
		bra.s	loc_1FBF8

; =============== S U B R O U T I N E =======================================


sub_1FBA8:

		cmpi.b	#2,d0
		bne.s	loc_1FBCC
; End of function sub_1FBA8


; =============== S U B R O U T I N E =======================================


sub_1FBAE:
		bset	#2,$2A(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		move.w	#-$300,$1A(a1)

loc_1FBCC:
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		move.b	#2,5(a1)
		rts
; End of function sub_1FBAE

; ---------------------------------------------------------------------------

loc_1FBE0:
		andi.b	#$10,d0
		beq.w	loc_1FB4C
		cmpi.b	#2,$33(a0)
		bne.w	loc_1FB4C
		lea	($FFFFB04A).w,a1
		bsr.s	sub_1FBAE

loc_1FBF8:

		move.w	$38(a0),($FFFFF7D0).w
		andi.b	#$E7,$2A(a0)
		tst.w	($FFFFFFE8).w
		bne.w	loc_1FC9C
		move.l	#loc_1FC16,(a0)
		bsr.w	sub_2011E

loc_1FC16:

		cmpi.b	#9,($FFFFFE10).w
		beq.s	loc_1FC60
		move.l	#loc_1FC24,(a0)

loc_1FC24:
		subq.b	#1,$24(a0)
		bpl.s	loc_1FC42
		move.b	#2,$24(a0)
		move.b	$22(a0),d0
		addq.b	#1,d0
		cmpi.b	#7,d0
		bcs.s	loc_1FC3E
		moveq	#3,d0

loc_1FC3E:
		move.b	d0,$22(a0)

loc_1FC42:
		jsr	(MoveSprite2).l
		addi.w	#$18,$1A(a0)
		tst.b	4(a0)
		bpl.s	loc_1FC5A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_1FC5A:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_1FC60:
		move.l	#loc_1FC66,(a0)

loc_1FC66:

		subq.b	#1,$24(a0)
		bpl.s	loc_1FC84
		move.b	#7,$24(a0)
		move.b	$22(a0),d0
		addq.b	#1,d0
		andi.b	#3,d0
		add.b	$3C(a0),d0
		move.b	d0,$22(a0)

loc_1FC84:
		jsr	(MoveSprite2).l
		addi.w	#$18,$1A(a0)
		tst.b	4(a0)
		bpl.s	loc_1FC5A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_1FC9C:
		bsr.s	sub_1FCC8
		move.b	#3,$22(a0)
		move.l	#loc_1FCAE,(a0)
		bsr.w	sub_2011E

loc_1FCAE:

		jsr	(MoveSprite2).l
		addi.w	#$18,$1A(a0)
		tst.b	4(a0)
		bpl.w	loc_1FC5A
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_1FCC8:

		jsr	(Create_New_Sprite3).l
		bne.w	locret_1FCF0
		moveq	#$48,d0

loc_1FCD4:
		move.w	(a0,d0.w),(a1,d0.w)
		subq.w	#2,d0
		bcc.s	loc_1FCD4
		move.l	(a0),$44(a1)
		move.l	#loc_1FCF2,(a1)
		move.b	#7,$22(a1)
		moveq	#0,d0

locret_1FCF0:
		rts
; End of function sub_1FCC8

; ---------------------------------------------------------------------------

loc_1FCF2:
		tst.b	4(a0)
		bmi.s	loc_1FD02
		move.l	$44(a0),(a0)
		move.b	#0,$22(a0)

loc_1FD02:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_1FD08:

		move.w	($FFFFB018).w,$30(a0)
		move.w	($FFFFB062).w,$36(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		bsr.w	SolidObjectFull
		swap	d6
		andi.w	#3,d6
		bne.s	loc_1FD4E

loc_1FD38:

		tst.w	($FFFFFFE8).w
		bne.s	loc_1FD48
		move.w	$2E(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_1FD48:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_1FD4E:
		lea	($FFFFB000).w,a1
		move.w	$30(a0),d1
		move.w	d6,d0
		andi.w	#1,d0
		beq.w	loc_1FDEA
		tst.b	$2C(a0)
		bpl.s	loc_1FD72
		cmpi.b	#2,$38(a1)
		beq.s	loc_1FDA4
		bra.w	loc_1FDEA
; ---------------------------------------------------------------------------

loc_1FD72:
		tst.b	($FFFFFE19).w
		bne.s	loc_1FDA4
		cmpi.b	#2,$38(a1)
		beq.s	loc_1FDA4
		btst	#4,$2B(a1)
		bne.s	loc_1FD90
		btst	#5,$2A(a0)
		beq.s	loc_1FDEA

loc_1FD90:
		cmpi.b	#2,$20(a1)
		bne.s	loc_1FDEA
		move.w	d1,d0
		bpl.s	loc_1FD9E
		neg.w	d0

loc_1FD9E:
		cmpi.w	#$480,d0
		bcs.s	loc_1FDEA

loc_1FDA4:

		bclr	#5,$2A(a0)
		bsr.w	sub_1FE34
		btst	#6,$2A(a0)
		beq.w	loc_1FD38
		lea	($FFFFB04A).w,a1
		cmpi.b	#2,$38(a1)
		beq.s	loc_1FDCE
		cmpi.b	#2,$20(a1)
		bne.w	loc_1FD38

loc_1FDCE:
		move.w	$36(a0),$18(a1)
		move.w	$18(a1),$1C(a1)
		bclr	#6,$2A(a0)
		bclr	#5,$2A(a1)
		bra.w	loc_1FD38
; ---------------------------------------------------------------------------

loc_1FDEA:

		lea	($FFFFB04A).w,a1
		move.w	$36(a0),d1
		btst	#6,$2A(a0)
		beq.w	loc_1FD38
		tst.b	$2C(a0)
		bpl.s	loc_1FE0E
		cmpi.b	#2,$38(a1)
		beq.s	loc_1FE2E
		bra.w	loc_1FD38
; ---------------------------------------------------------------------------

loc_1FE0E:
		cmpi.b	#2,$38(a1)
		beq.s	loc_1FE2E
		cmpi.b	#2,$20(a1)
		bne.w	loc_1FD38
		move.w	d1,d0
		bpl.s	loc_1FE26
		neg.w	d0

loc_1FE26:
		cmpi.w	#$480,d0
		bcs.w	loc_1FD38

loc_1FE2E:

		bclr	#6,$2A(a0)

; =============== S U B R O U T I N E =======================================


sub_1FE34:
		bsr.w	sub_1FF1E
		tst.w	($FFFFFFE8).w
		bne.w	loc_1FECE
		move.w	d1,$18(a1)
		addq.w	#4,$10(a1)
		lea	(word_202F4).l,a4
		move.w	$10(a0),d0
		cmp.w	$10(a1),d0
		bcs.s	loc_1FE64
		subi.w	#8,$10(a1)
		lea	(word_20314).l,a4

loc_1FE64:
		move.w	$18(a1),$1C(a1)
		bclr	#5,$2A(a1)
		cmpi.b	#2,$38(a1)
		bne.s	loc_1FE9E
		cmpi.b	#1,$2F(a1)
		bne.s	loc_1FE9E
		move.b	#2,$2F(a1)
		move.b	#$21,$20(a1)
		bclr	#0,$2A(a1)
		tst.w	$18(a1)
		bpl.s	loc_1FE9E
		bset	#0,$2A(a1)

loc_1FE9E:

		moveq	#0,d0
		move.b	$22(a0),d0
		cmpi.b	#9,($FFFFFE10).w
		bne.s	loc_1FEBE
		subq.b	#4,d0
		move.l	#loc_1FC66,(a0)
		add.w	d0,d0
		bsr.w	sub_201DE
		bra.w	loc_1FC66
; ---------------------------------------------------------------------------

loc_1FEBE:
		move.l	#loc_1FC16,(a0)
		add.w	d0,d0
		bsr.w	sub_2013A
		bra.w	loc_1FC16
; ---------------------------------------------------------------------------

loc_1FECE:
		move.w	d1,$18(a1)
		addq.w	#4,$10(a1)
		lea	(word_20370).l,a4
		move.w	$10(a0),d0
		cmp.w	$10(a1),d0
		bcs.s	loc_1FEF2
		subi.w	#8,$10(a1)
		lea	(word_20388).l,a4

loc_1FEF2:
		move.w	$18(a1),$1C(a1)
		bclr	#5,$2A(a1)
		bsr.w	sub_1FCC8
		move.l	#loc_1FCAE,(a0)
		move.b	#3,$22(a0)
		moveq	#0,d0
		move.b	$22(a0),d0
		add.w	d0,d0
		bsr.w	sub_2013A
		bra.w	loc_1FCAE
; End of function sub_1FE34


; =============== S U B R O U T I N E =======================================


sub_1FF1E:
		bclr	#3,$2A(a0)
		beq.s	loc_1FF32
		bset	#1,($FFFFB02A).w
		bclr	#3,($FFFFB02A).w

loc_1FF32:
		bclr	#4,$2A(a0)
		beq.s	locret_1FF46
		bset	#1,($FFFFB074).w
		bclr	#3,($FFFFB074).w

locret_1FF46:
		rts
; End of function sub_1FF1E

; ---------------------------------------------------------------------------

loc_1FF48:

		move.w	($FFFFB01A).w,$30(a0)
		move.w	($FFFFB064).w,$36(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		swap	d6
		andi.w	#$C,d6
		bne.s	loc_1FF84
		move.w	$2E(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_1FF84:
		move.b	d6,d0
		andi.b	#4,d0
		beq.s	loc_1FFA8
		lea	($FFFFB000).w,a1
		move.w	$30(a0),$1A(a1)
		andi.b	#8,d6
		beq.s	loc_1FFC4
		lea	($FFFFB04A).w,a1
		move.w	$36(a0),$1A(a1)
		bra.s	loc_1FFC4
; ---------------------------------------------------------------------------

loc_1FFA8:
		andi.b	#8,d6
		beq.s	loc_1FFBA
		lea	($FFFFB04A).w,a1
		move.w	$36(a0),$1A(a1)
		bra.s	loc_1FFC4
; ---------------------------------------------------------------------------

loc_1FFBA:
		move.w	$2E(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_1FFC4:

		btst	#3,$2A(a0)
		beq.s	loc_1FFDC
		lea	($FFFFB000).w,a1
		bset	#1,$2A(a1)

loc_1FFD6:
		bclr	#3,$2A(a1)

loc_1FFDC:
		btst	#4,$2A(a0)
		beq.s	loc_1FFF4
		lea	($FFFFB04A).w,a1
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)

loc_1FFF4:
		move.l	#loc_1FC16,(a0)
		bsr.w	sub_2011E
		bra.w	loc_1FC16
; ---------------------------------------------------------------------------

loc_20002:

		move.w	($FFFFF7D0).w,$38(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		move.b	$2A(a0),d0
		andi.b	#8,d0
		bne.s	loc_20036

loc_20030:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_20036:
		lea	($FFFFB000).w,a1
		cmpi.b	#2,$38(a1)
		bne.s	loc_20030
		bsr.s	sub_20056
		btst	#4,$2A(a0)
		beq.s	loc_20088
		lea	($FFFFB04A).w,a1
		bsr.s	sub_20056
		bra.w	loc_20088

; =============== S U B R O U T I N E =======================================


sub_20056:
		bset	#2,$2A(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		move.w	#-$300,$1A(a1)
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)

loc_20080:
		move.b	#2,5(a1)
		rts
; End of function sub_20056

; ---------------------------------------------------------------------------

loc_20088:

		move.w	$38(a0),($FFFFF7D0).w
		andi.b	#$E7,$2A(a0)
		move.l	#loc_1FC16,(a0)
		bsr.w	sub_2011E
		bra.w	loc_1FC16

; =============== S U B R O U T I N E =======================================


sub_200A2:
		move.b	$2A(a0),d3
		andi.b	#$60,d3
		beq.w	locret_200CA
		move.w	$10(a0),d2
		lea	($FFFFB000).w,a1
		move.b	$3A(a0),d0
		moveq	#5,d6
		bsr.s	sub_200CC
		lea	($FFFFB04A).w,a1
		move.b	$3B(a0),d0
		moveq	#6,d6
		bsr.s	sub_200CC

locret_200CA:
		rts
; End of function sub_200A2


; =============== S U B R O U T I N E =======================================


sub_200CC:

		btst	d6,d3
		beq.s	locret_2011C
		cmp.w	$10(a1),d2
		bcc.s	locret_2011C
		btst	#5,d0
		beq.s	locret_2011C
		subq.w	#1,$40(a0)
		bpl.s	locret_2011C
		move.w	#$10,$40(a0)
		tst.w	$42(a0)
		beq.s	locret_2011C
		subq.w	#1,$42(a0)
		subq.w	#1,$10(a0)
		subq.w	#1,$10(a1)
		jsr	(ObjHitFloor).l
		add.w	d1,$14(a0)
		move.w	$48(a0),d0
		beq.s	locret_2011C
		movea.w	d0,a2
		move.b	$43(a0),d0
		subi.b	#$40,d0
		neg.b	d0
		move.b	d0,(a2)
		bset	#7,(a2)

locret_2011C:
		rts
; End of function sub_200CC


; =============== S U B R O U T I N E =======================================


sub_2011E:

		cmpi.b	#9,($FFFFFE10).w
		beq.w	loc_201C4
		moveq	#0,d0
		move.b	$22(a0),d0
		add.w	d0,d0
		lea	(off_202E4).l,a4
		adda.w	(a4,d0.w),a4
; End of function sub_2011E


; =============== S U B R O U T I N E =======================================


sub_2013A:

		lea	(off_2026E).l,a3
		adda.w	(a3,d0.w),a3
		move.w	(a3)+,d1
		move.l	(a0),d4
		move.b	4(a0),d5
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		move.w	#3,d6
		movea.l	a0,a1
		bra.s	loc_20162
; ---------------------------------------------------------------------------

loc_2015C:
		bsr.w	Create_New_Sprite3
		bne.s	loc_201BC

loc_20162:
		move.l	d4,(a1)

loc_20164:
		move.l	$C(a0),$C(a1)
		move.b	d5,4(a1)
		move.b	(a3)+,d0
		ext.w	d0
		add.w	d2,d0
		move.w	d0,$10(a1)
		move.b	(a3)+,d0
		ext.w	d0
		add.w	d3,d0
		move.w	d0,$14(a1)
		move.w	$A(a0),$A(a1)
		ori.w	#$8000,$A(a1)
		move.w	#$80,8(a1)
		move.b	#$18,7(a1)
		move.b	#$18,7(a1)
		move.w	(a4)+,$18(a1)
		move.w	(a4)+,$1A(a1)
		move.b	d6,$22(a1)
		addq.b	#1,d6
		cmpi.b	#7,d6
		bcs.s	loc_201B8
		move.w	#3,d6

loc_201B8:
		dbf	d1,loc_2015C

loc_201BC:
		moveq	#$59,d0
		jmp	(Play_Sound_2).l
; End of function sub_2013A

; ---------------------------------------------------------------------------

loc_201C4:
		move.l	#loc_1FC66,(a0)
		moveq	#0,d0
		move.b	$22(a0),d0
		subq.b	#4,d0
		add.w	d0,d0
		lea	(off_202E4).l,a4
		adda.w	(a4,d0.w),a4

; =============== S U B R O U T I N E =======================================


sub_201DE:
		lea	(off_2026E).l,a3
		adda.w	(a3,d0.w),a3
		move.w	(a3)+,d1
		move.l	(a0),d4
		move.b	4(a0),d5
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		move.w	#3,d6
		movea.l	a0,a1
		bra.s	loc_20206
; ---------------------------------------------------------------------------

loc_20200:
		bsr.w	Create_New_Sprite3
		bne.s	loc_20266

loc_20206:
		move.l	d4,(a1)
		move.l	$C(a0),$C(a1)
		move.b	d5,4(a1)
		move.b	(a3)+,d0
		ext.w	d0
		add.w	d2,d0
		move.w	d0,$10(a1)
		move.b	(a3)+,d0
		ext.w	d0
		add.w	d3,d0
		move.w	d0,$14(a1)
		move.w	$A(a0),$A(a1)
		ori.w	#$8000,$A(a1)
		move.w	#$80,8(a1)
		move.b	#$20,7(a1)
		move.b	#$20,7(a1)
		move.w	(a4)+,$18(a1)
		move.w	(a4)+,$1A(a1)
		move.b	(a3)+,$22(a1)
		move.b	$22(a1),d0
		andi.b	#-4,d0
		move.b	d0,$3C(a1)
		move.b	#7,$24(a1)
		dbf	d1,loc_20200

loc_20266:
		moveq	#$59,d0
		jmp	(Play_Sound_2).l
; End of function sub_201DE

; ---------------------------------------------------------------------------
off_2026E:	dc.w word_2027E-off_2026E
		dc.w word_20290-off_2026E
		dc.w word_2029C-off_2026E
		dc.w word_202A6-off_2026E
		dc.w word_202B4-off_2026E
		dc.w word_202C8-off_2026E
		dc.w word_202C8-off_2026E
		dc.w word_202DC-off_2026E
word_2027E:	dc.w 7
		dc.w $F8E8
		dc.w $BE4
		dc.w $FCF4
		dc.w $CFC
		dc.w $F404
		dc.w $40C
		dc.w $F41C
		dc.w $C1C
word_20290:	dc.w 4
		dc.w $FCF4
		dc.w $BF4
		dc.w $FCFC
		dc.w $F40C
		dc.w $C0C
word_2029C:	dc.w 3
		dc.w $FCFC
		dc.w $CFC
		dc.w $F404
		dc.w $C04
word_202A6:	dc.w 5
		dc.w $F8F8
		dc.w $8F8
		dc.w $F800
		dc.w $800
		dc.w $F808
		dc.w $808
word_202B4:	dc.w 5
		dc.w $10
		dc.w $600
		dc.w 7
		dc.w $F8F0
		dc.w $108
		dc.w $2000
		dc.w $E8
		dc.w $600
		dc.w $1B07
word_202C8:	dc.w 5
		dc.w $803
		dc.w $7F8
		dc.w $FB01
		dc.w $F008
		dc.w $1E8
		dc.w 7
		dc.w 0
		dc.w $618
		dc.w 6
word_202DC:	dc.w 1
		dc.w $10
		dc.w $100
		dc.w $F000
off_202E4:	dc.w word_202F4-off_202E4

		dc.w word_20334-off_202E4
		dc.w word_20348-off_202E4
		dc.w word_20358-off_202E4
		dc.w word_203A0-off_202E4
		dc.w word_203C0-off_202E4
		dc.w word_203C0-off_202E4
		dc.w word_203A0-off_202E4
word_202F4:	dc.w $FD00

		dc.w $FD00
		dc.w $FD40
		dc.w $FD80
		dc.w $FD40
		dc.w $FD80
		dc.w $FD80
		dc.w $FE00
		dc.w $FD80
		dc.w $FE80
		dc.w $FDC0
		dc.w $FE80
		dc.w $FDC0
		dc.w $FF00
		dc.w $FE00
		dc.w $FF00
word_20314:	dc.w $2C0
		dc.w $FD80
		dc.w $300
		dc.w $FD00
		dc.w $280
		dc.w $FE00
		dc.w $2C0
		dc.w $FD80
		dc.w $240
		dc.w $FE80
		dc.w $280
		dc.w $FE80
		dc.w $200
		dc.w $FF00
		dc.w $240
		dc.w $FF00
word_20334:	dc.w $FE00
		dc.w $FE00
		dc.w $200
		dc.w $FE00
		dc.w $FF00
		dc.w $FE20
		dc.w $FE50
		dc.w $FE40
		dc.w $1C0
		dc.w $FE40
word_20348:	dc.w $FF00
		dc.w $FE00
		dc.w $100
		dc.w $FE20
		dc.w $FE50
		dc.w $FE40
		dc.w $1C0
		dc.w $FE40
word_20358:	dc.w $FF50
		dc.w $FE20
		dc.w $B0
		dc.w $FE30
		dc.w $FF80
		dc.w $FE00
		dc.w $80
		dc.w $FE20
		dc.w $FF28
		dc.w $FE40
		dc.w $E0
		dc.w $FE40
word_20370:	dc.w $FD40
		dc.w $FD80
		dc.w $FD80
		dc.w $FE00
		dc.w $FD80
		dc.w $FE80
		dc.w $FDC0
		dc.w $FE80
		dc.w $FDC0
		dc.w $FF00
		dc.w $FE00
		dc.w $FF00
word_20388:	dc.w $2C0
		dc.w $FD80
		dc.w $280
		dc.w $FE00
		dc.w $280
		dc.w $FE80
		dc.w $240
		dc.w $FE80
		dc.w $240
		dc.w $FF00
		dc.w $200
		dc.w $FF00
word_203A0:	dc.w $FD00
		dc.w $FD00
		dc.w $FD40
		dc.w $FD80
		dc.w $FD40
		dc.w $FD80
		dc.w $FD80
		dc.w $FE00
		dc.w $FD80
		dc.w $FE80
		dc.w $FDC0
		dc.w $FE80
		dc.w $FDC0
		dc.w $FF00
		dc.w $FE00
		dc.w $FF00
word_203C0:	dc.w $C0
		dc.w $FE20
		dc.w $FF80
		dc.w $FE60
		dc.w $FF60
		dc.w $FEA0
		dc.w $FF00
		dc.w $FE20
		dc.w $40
		dc.w $FE40
		dc.w $100
		dc.w $FE20
Map_LRZBreakableRock:include "Levels\LRZ\Misc Object Data\Map - Breakable Rock.asm"

Map_LRZBreakableRock2:include "Levels\LRZ\Misc Object Data\Map - Breakable Rock 2.asm"

; ---------------------------------------------------------------------------

Obj_CollapsingPlatform:

		move.l	#Map_AIZCollapsingPlatform,$C(a0)
		move.w	#$4001,$A(a0)
		cmpi.w	#1,($FFFFFE10).w
		bne.s	loc_20522
		move.l	#Map_AIZCollapsingPlatform2,$C(a0)
		move.w	#$4001,$A(a0)

loc_20522:
		move.l	#byte_20CB6,$30(a0)
		move.l	#byte_20E9E,$3C(a0)
		move.b	#$3C,7(a0)
		move.b	#$20,6(a0)
		cmpi.b	#5,($FFFFFE10).w
		bne.s	loc_20570
		move.l	#Map_ICZCollapsingBridge,$C(a0)
		move.w	#$4001,$A(a0)
		move.l	#byte_20CD4,$30(a0)
		move.l	#byte_20EDE,$3C(a0)
		move.b	#$30,7(a0)
		move.b	#$30,6(a0)

loc_20570:
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#7,$38(a0)
		move.b	$2C(a0),$22(a0)
		ori.b	#$80,$2A(a0)
		move.l	#loc_20594,(a0)

loc_20594:
		tst.b	$3A(a0)
		beq.s	loc_205A6
		tst.b	$38(a0)
		beq.w	loc_20C24
		subq.b	#1,$38(a0)

loc_205A6:
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	sub_205B6
		move.b	#1,$3A(a0)

; =============== S U B R O U T I N E =======================================


sub_205B6:

		moveq	#0,d1
		move.b	7(a0),d1
		movea.l	$3C(a0),a2
		move.w	$10(a0),d4
		jsr	(SolidObjectTopSloped2).l
		bra.w	Sprite_OnScreen_Test
; End of function sub_205B6

; ---------------------------------------------------------------------------

loc_205CE:
		subq.b	#1,$38(a0)
		bne.s	loc_205DA
		move.l	#loc_20620,(a0)

loc_205DA:
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------

loc_205DE:
		bsr.w	sub_205B6
		subq.b	#1,$38(a0)
		bne.s	locret_2061E
		move.l	#loc_20620,(a0)
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.s	sub_205FC
		lea	($FFFFB04A).w,a1
		moveq	#4,d6

; =============== S U B R O U T I N E =======================================


sub_205FC:
		btst	d6,$2A(a0)
		beq.s	locret_2061E
		bclr	d6,$2A(a0)
		bclr	#3,$2A(a1)
		bclr	#5,$2A(a1)
		bset	#1,$2A(a1)
		move.b	#1,$21(a1)

locret_2061E:

		rts
; End of function sub_205FC

; ---------------------------------------------------------------------------

loc_20620:

		tst.b	4(a0)
		bpl.w	Delete_Current_Sprite
		bsr.w	MoveSprite
		bra.w	Draw_Sprite
; ---------------------------------------------------------------------------

Obj_CollapsingBridge:

		move.l	#loc_2095E,(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		cmpi.b	#6,($FFFFFE10).w
		bne.s	loc_206B8
		move.b	$2C(a0),d0
		andi.w	#$3F,d0
		add.w	d0,d0
		add.w	d0,d0
		addq.w	#8,d0
		bcc.s	loc_2065E
		move.b	#-1,d0

loc_2065E:
		move.b	d0,$38(a0)
		btst	#6,$2C(a0)
		bne.s	loc_20696
		move.l	#Map_LBZCollapsingBridge,$C(a0)
		move.w	#$4001,$A(a0)
		move.b	#$40,7(a0)
		move.b	#$10,6(a0)
		move.l	#LBZBridgeCollapse_TimerArray,$30(a0)
		move.l	#LBZBridgeCollapse_TimerFlipArray,$34(a0)
		bra.s	loc_206B8
; ---------------------------------------------------------------------------

loc_20696:
		move.l	#Map_LBZCollapsingLedge,$C(a0)
		move.w	#$4001,$A(a0)
		move.b	#$20,7(a0)
		move.b	#$30,6(a0)
		move.l	#LBZLedgeCollapse_TimerArray,$30(a0)

loc_206B8:

		cmpi.b	#1,($FFFFFE10).w
		bne.w	loc_20752
		move.l	#Map_HCZCollapsingBridge,$C(a0)
		move.w	#$C001,$A(a0)
		move.b	$2C(a0),d0
		bpl.s	loc_206EA
		move.b	d0,d1
		andi.b	#$F,d1
		move.b	d1,$40(a0)
		move.l	#loc_20AF6,(a0)
		andi.b	#$70,d0

loc_206EA:
		move.b	d0,d1
		andi.w	#$F,d0
		lsl.w	#4,d0
		addq.w	#8,d0
		move.b	d0,$38(a0)
		andi.w	#$F0,d1
		lsr.w	#2,d1
		lea	byte_20722(pc,d1.w),a1
		move.b	(a1)+,7(a0)
		move.b	(a1)+,6(a0)
		move.b	(a1)+,$22(a0)
		move.b	(a1)+,$2C(a0)
		add.w	d1,d1
		lea	off_20732(pc,d1.w),a1
		move.l	(a1)+,$30(a0)
		move.l	(a1)+,$34(a0)
		bra.s	loc_20752
; ---------------------------------------------------------------------------
byte_20722:	dc.b $40
		dc.b $10
		dc.b 0
		dc.b $80
		dc.b $50
		dc.b $10
		dc.b 3
		dc.b $80
		dc.b $40
		dc.b $10
		dc.b 6
		dc.b 0
		dc.b $50
		dc.b $20
		dc.b 9
		dc.b $80
off_20732:	dc.l byte_20D22
		dc.l byte_20D32
		dc.l byte_20D42
		dc.l byte_20D56
		dc.l byte_20D6A
		dc.l byte_20D6A
		dc.l byte_20D79
		dc.l byte_20D91
; ---------------------------------------------------------------------------

loc_20752:

		cmpi.b	#2,($FFFFFE10).w
		bne.s	loc_207D4
		move.l	#Map_MGZCollapsingBridge,$C(a0)
		move.w	#$4001,$A(a0)
		move.b	$2C(a0),d0
		move.b	d0,d1
		andi.w	#$F,d0
		lsl.w	#4,d0
		addq.w	#8,d0
		move.b	d0,$38(a0)
		andi.w	#$F0,d1
		lsr.w	#2,d1
		lea	byte_207B0(pc,d1.w),a1
		move.b	(a1)+,7(a0)
		move.b	(a1)+,6(a0)
		move.b	(a1)+,$22(a0)
		move.b	(a1)+,$2C(a0)
		add.w	d1,d1
		lea	off_207BC(pc,d1.w),a1
		move.l	(a1)+,$30(a0)
		move.l	(a1)+,$34(a0)
		cmpi.w	#$10,d1
		bne.s	loc_207D4
		move.l	#loc_209D0,(a0)
		rts
; ---------------------------------------------------------------------------
byte_207B0:	dc.b $40
		dc.b $20
		dc.b 0
		dc.b $80
		dc.b $30
		dc.b $20
		dc.b 3
		dc.b $80
		dc.b $40
		dc.b $20
		dc.b 6
		dc.b $80
off_207BC:	dc.l byte_20DA9
		dc.l byte_20DC9
		dc.l byte_20DE9
		dc.l byte_20E01
		dc.l byte_20DA9
		dc.l byte_20DC9
; ---------------------------------------------------------------------------

loc_207D4:

		cmpi.b	#5,($FFFFFE10).w
		bne.s	loc_20834
		move.b	$2C(a0),d0
		bpl.s	loc_207F6
		move.b	d0,d1
		andi.b	#$F,d1
		move.b	d1,$40(a0)
		move.l	#loc_20AF6,(a0)
		andi.b	#$70,d0

loc_207F6:
		move.b	d0,d1
		andi.w	#$F,d0
		lsl.w	#4,d0
		addq.w	#8,d0
		move.b	d0,$38(a0)
		move.l	#Map_ICZCollapsingBridge,$C(a0)
		move.w	#$4001,$A(a0)
		move.b	#$50,7(a0)
		move.b	#$38,6(a0)
		move.l	#byte_20E19,$30(a0)
		move.l	#byte_20E45,$34(a0)
		move.b	#3,$22(a0)

loc_20834:
		cmpi.b	#$16,($FFFFFE10).w
		bne.s	loc_2084C
		move.l	#Map_HPZCollapsingBridge,$C(a0)
		move.w	#$4001,$A(a0)
		bra.s	loc_20862
; ---------------------------------------------------------------------------

loc_2084C:
		cmpi.b	#9,($FFFFFE10).w
		bne.s	loc_208A6
		move.l	#Map_LRZCollapsingPlatform,$C(a0)
		move.w	#$4090,$A(a0)

loc_20862:
		move.b	$2C(a0),d0
		move.b	d0,d1
		andi.w	#$F,d0
		lsl.w	#4,d0
		addq.w	#8,d0
		move.b	d0,$38(a0)
		andi.w	#$70,d1
		lsr.w	#2,d1
		lea	byte_2089A(pc,d1.w),a1
		move.b	(a1)+,7(a0)
		move.b	(a1)+,6(a0)
		move.b	(a1)+,$22(a0)
		add.w	d1,d1
		lea	off_2089E(pc,d1.w),a1
		move.l	(a1)+,$30(a0)
		move.l	(a1)+,$34(a0)
		bra.s	loc_208A6
; ---------------------------------------------------------------------------
byte_2089A:	dc.b $20
		dc.b $18
		dc.b 0
		dc.b $80
off_2089E:	dc.l byte_20E85
		dc.l byte_20E91
; ---------------------------------------------------------------------------

loc_208A6:

		cmpi.b	#4,($FFFFFE10).w
		bne.s	loc_20904
		move.l	#Map_FBZCollapsingBridge,$C(a0)

loc_208B6:
		move.w	#$4001,$A(a0)
		move.b	$2C(a0),d0
		move.b	d0,d1
		andi.w	#$F,d0
		lsl.w	#4,d0
		addq.w	#8,d0
		move.b	d0,$38(a0)
		andi.w	#$F0,d1
		lsr.w	#2,d1
		lea	byte_208F8(pc,d1.w),a1
		move.b	(a1)+,7(a0)
		move.b	(a1)+,6(a0)
		move.b	(a1)+,$22(a0)
		move.b	(a1)+,$2C(a0)
		add.w	d1,d1
		lea	off_208FC(pc,d1.w),a1
		move.l	(a1)+,$30(a0)
		move.l	(a1)+,$34(a0)
		bra.s	loc_20904
; ---------------------------------------------------------------------------
byte_208F8:	dc.b $40
		dc.b $20
		dc.b 0
		dc.b $80
off_208FC:	dc.l byte_20DA9
		dc.l byte_20DC9
; ---------------------------------------------------------------------------

loc_20904:

		cmpi.b	#8,($FFFFFE10).w
		bne.s	loc_2095E
		move.l	#Map_SOZCollapsingBridge,$C(a0)
		move.w	#$4001,$A(a0)
		move.b	$2C(a0),d0
		move.b	d0,d1
		andi.w	#$F,d0
		lsl.w	#4,d0
		addq.w	#8,d0
		move.b	d0,$38(a0)
		andi.w	#$70,d1
		lsr.w	#2,d1
		lea	byte_20952(pc,d1.w),a1
		move.b	(a1)+,7(a0)
		move.b	(a1)+,6(a0)
		move.b	(a1)+,$22(a0)
		add.w	d1,d1
		lea	off_20956(pc,d1.w),a1
		move.l	(a1)+,$30(a0)
		move.l	(a1)+,$34(a0)
		bra.s	loc_2095E
; ---------------------------------------------------------------------------
byte_20952:	dc.b $20
		dc.b $30
		dc.b 0
		dc.b $80
off_20956:	dc.l byte_20E71
		dc.l byte_20E7B
; ---------------------------------------------------------------------------

loc_2095E:


		tst.b	$3A(a0)
		beq.s	loc_209A8
		tst.b	$38(a0)
		bne.s	loc_209A4
		movea.l	$30(a0),a4
		tst.b	$2C(a0)
		bpl.s	loc_209A0
		move.b	$2A(a0),d0		; If BIT 7 of subtype set, collapse platform in direction dependent on player position
		andi.b	#$18,d0
		beq.s	loc_209A0
		move.w	($FFFFB010).w,d1
		andi.b	#8,d0
		bne.s	loc_2098C
		move.w	($FFFFB05A).w,d1

loc_2098C:
		cmp.w	$10(a0),d1
		bcc.s	loc_209A0
		movea.l	$34(a0),a4
		bchg	#0,$2A(a0)
		addq.b	#1,$22(a0)

loc_209A0:

		bra.w	loc_20C12
; ---------------------------------------------------------------------------

loc_209A4:
		subq.b	#1,$38(a0)

loc_209A8:
		move.b	$2A(a0),d0		; Check if player is standing on platform
		andi.b	#$18,d0
		beq.s	loc_209B8
		move.b	#1,$3A(a0)		; Turn on collapsing timer

loc_209B8:

		moveq	#0,d1
		move.b	7(a0),d1
		move.w	#$10,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		bra.w	Sprite_OnScreen_Test
; ---------------------------------------------------------------------------

loc_209D0:
		moveq	#0,d1
		move.b	7(a0),d1
		move.w	#$10,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	loc_20A52
		move.b	($FFFFB037).w,d1
		andi.b	#8,d0
		bne.s	loc_209FC
		move.b	($FFFFB081).w,d1

loc_209FC:
		tst.b	d1
		bpl.s	loc_20A52
		bclr	#3,$2A(a0)
		beq.s	loc_20A12
		lea	($FFFFB000).w,a1
		bclr	#3,$2A(a1)

loc_20A12:
		bclr	#4,$2A(a0)
		beq.s	loc_20A24
		lea	($FFFFB04A).w,a1
		bclr	#3,$2A(a1)

loc_20A24:
		lea	(word_20A76).l,a4
		addq.b	#1,$22(a0)
		move.w	#$80,8(a0)
		move.l	#loc_20A56,(a0)
		jsr	(sub_216B0).l
		move.w	$48(a0),d0
		beq.s	loc_20A50
		movea.w	d0,a1
		bclr	#7,(a1)
		clr.w	$48(a0)

loc_20A50:
		bra.s	loc_20A56
; ---------------------------------------------------------------------------

loc_20A52:

		bra.w	Sprite_OnScreen_Test
; ---------------------------------------------------------------------------

loc_20A56:

		jsr	(MoveSprite2).l
		addi.w	#$18,$1A(a0)
		tst.b	4(a0)
		bpl.w	loc_20A70
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_20A70:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
word_20A76:	dc.w $FC00
		dc.w $F600
		dc.w $FD00
		dc.w $F600
		dc.w $FE00
		dc.w $F600
		dc.w $FF00
		dc.w $F600
		dc.w $100
		dc.w $F600
		dc.w $200
		dc.w $F600
		dc.w $300
		dc.w $F600
		dc.w $400
		dc.w $F600
		dc.w $FC40
		dc.w $F700
		dc.w $FD40
		dc.w $F700
		dc.w $FE40
		dc.w $F700
		dc.w $FF40
		dc.w $F700
		dc.w $C0
		dc.w $F700
		dc.w $1C0
		dc.w $F700
		dc.w $2C0
		dc.w $F700
		dc.w $3C0
		dc.w $F700
		dc.w $FC80
		dc.w $F800
		dc.w $FD80
		dc.w $F800
		dc.w $FE80
		dc.w $F800
		dc.w $FF80
		dc.w $F800
		dc.w $80
		dc.w $F800
		dc.w $180
		dc.w $F800
		dc.w $280
		dc.w $F800
		dc.w $380
		dc.w $F800
		dc.w $FCC0
		dc.w $F900
		dc.w $FDC0
		dc.w $F900
		dc.w $FEC0
		dc.w $F900
		dc.w $FFC0
		dc.w $F900
		dc.w $40
		dc.w $F900
		dc.w $140
		dc.w $F900
		dc.w $240
		dc.w $F900
		dc.w $340
		dc.w $F900
; ---------------------------------------------------------------------------

loc_20AF6:

		tst.b	$3A(a0)
		beq.s	loc_20B40
		tst.b	$38(a0)
		bne.s	loc_20B3C
		movea.l	$30(a0),a4
		tst.b	$2C(a0)
		bpl.s	loc_20B38
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	loc_20B38
		move.w	($FFFFB010).w,d1
		andi.b	#8,d0
		bne.s	loc_20B24
		move.w	($FFFFB05A).w,d1

loc_20B24:
		cmp.w	$10(a0),d1
		bcc.s	loc_20B38
		movea.l	$34(a0),a4
		bchg	#0,$2A(a0)
		addq.b	#1,$22(a0)

loc_20B38:

		bra.w	loc_20C12
; ---------------------------------------------------------------------------

loc_20B3C:
		subq.b	#1,$38(a0)

loc_20B40:
		move.b	$40(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		lea	(a3,d0.w),a3
		tst.b	(a3)
		beq.s	loc_20B5E
		move.b	#1,$3A(a0)
		clr.w	$48(a0)

loc_20B5E:
		bra.w	loc_209B8
; ---------------------------------------------------------------------------

Obj_PlatformCollapseWait:
		subq.b	#1,$38(a0)
		bne.s	loc_20B6E
		move.l	#Obj_PlatformCollapseFall,(a0)

loc_20B6E:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_PlatformCollapseFall:

		tst.b	4(a0)
		bpl.s	loc_20B86
		jsr	(MoveSprite).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_20B86:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_PlatformCollapseWaitHandlePlayer:
		subq.b	#1,$38(a0)
		bne.s	loc_20B98
		move.l	#Obj_PlatformCollapseFall,(a0)

loc_20B98:
		move.b	$38(a0),d3
		movea.l	$30(a0),a2
		moveq	#0,d1
		move.b	7(a0),d1
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.s	Check_CollapsePlayerRelease
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.s	Check_CollapsePlayerRelease
		bra.w	Sprite_OnScreen_Test

; =============== S U B R O U T I N E =======================================


Check_CollapsePlayerRelease:

		btst	d6,$2A(a0)
		beq.s	locret_20C10
		move.w	d1,d2
		add.w	d2,d2
		btst	#1,$2A(a1)
		bne.s	loc_20BF4
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	loc_20BF4
		cmp.w	d2,d0
		bcc.s	loc_20BF4
		btst	#0,$2A(a0)
		beq.s	loc_20BE8
		neg.w	d0
		add.w	d2,d0

loc_20BE8:
		lsr.w	#4,d0
		move.b	(a2),d2
		sub.b	(a2,d0.w),d2
		cmp.b	d2,d3
		bhi.s	locret_20C10

loc_20BF4:

		bclr	d6,$2A(a0)
		bclr	#3,$2A(a1)
		bclr	#5,$2A(a1)
		bset	#1,$2A(a1)
		move.b	#1,$21(a1)

locret_20C10:

		rts
; End of function Check_CollapsePlayerRelease

; ---------------------------------------------------------------------------

loc_20C12:

		move.l	#Obj_PlatformCollapseWaitHandlePlayer,(a0)
		move.l	#Obj_PlatformCollapseWait,d4
		addq.b	#1,$22(a0)
		bra.s	loc_20C38
; ---------------------------------------------------------------------------

loc_20C24:
		move.l	#loc_205DE,(a0)
		move.l	#loc_205CE,d4
		addq.b	#2,$22(a0)
		movea.l	$30(a0),a4

loc_20C38:
		moveq	#0,d0
		move.b	$22(a0),d0
		add.w	d0,d0
		movea.l	$C(a0),a3
		adda.w	(a3,d0.w),a3
		move.w	(a3)+,d1
		subq.w	#1,d1
		bset	#5,4(a0)
		move.b	4(a0),d5
		movea.l	a0,a1
		bra.s	loc_20C64
; ---------------------------------------------------------------------------

loc_20C5A:
		bsr.w	Create_New_Sprite3
		bne.s	loc_20C98
		addq.w	#6,a3
		move.l	d4,(a1)

loc_20C64:
		move.l	a3,$C(a1)
		move.b	d5,4(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	$A(a0),$A(a1)
		move.w	8(a0),8(a1)
		move.b	7(a0),7(a1)
		move.b	6(a0),6(a1)
		move.b	(a4)+,$38(a1)
		dbf	d1,loc_20C5A

loc_20C98:
		jsr	(Draw_Sprite).l
		move.w	$48(a0),d0
		beq.s	loc_20CAE
		movea.w	d0,a1
		bclr	#7,(a1)
		clr.w	$48(a0)

loc_20CAE:
		moveq	#$59,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------
byte_20CB6:	dc.b  $30, $2C, $28, $24, $20, $1C, $2E, $2A, $26, $22, $1E, $1A, $2C, $28, $24, $20, $1C, $18, $2A, $26
		dc.b  $22, $1E, $1A, $16, $28, $24, $20, $1C, $18, $14
byte_20CD4:	dc.b  $30, $2C, $28, $24, $20, $1C, $2E, $2A, $26, $22, $1E, $1A, $2C, $28, $24, $20, $1C, $18, $2A, $26
		dc.b  $22, $1E, $1A, $16, $28, $24, $20, $1C, $18, $14, $12, $10
LBZBridgeCollapse_TimerArray:	dc.b  $20, $1C,	$18, $14, $10,	$C,   8,   4, $1E, $1A,	$16, $12,  $E,	$A,   6,   2
LBZBridgeCollapse_TimerFlipArray:	dc.b  $20,   4,	  8,  $C, $10, $14, $18, $1C,	2,   6,	 $A,  $E, $12, $16, $1A, $1E
LBZLedgeCollapse_TimerArray:	dc.b  $20, $18,	$10,   8, $1E, $16,  $E,   6, $1C, $14,	 $C,   4, $1A, $12
byte_20D22:	dc.b  $20, $1C,	$18, $14, $10,	$C,   8,   4, $1E, $1A,	$16, $12,  $E,	$A,   6,   2
byte_20D32:	dc.b  $20,   4,	  8,  $C, $10, $14, $18, $1C,	2,   6,	 $A,  $E, $12, $16, $1A, $1E
byte_20D42:	dc.b  $28, $24,	$20, $1C, $18, $14, $10,  $C,	8,   4,	$26, $22, $1E, $1A, $16, $12,  $E,  $A,	  6,   2
byte_20D56:	dc.b  $28,   4,	  8,  $C, $10, $14, $18, $1C, $20, $24,	  2,   6,  $A,	$E, $12, $16, $1A, $1E,	$22, $26
byte_20D6A:	dc.b  $1C,   4,	  8,  $C, $10, $14, $18,   2,	6,  $A,	 $E, $12, $16, $1A, $1E
byte_20D79:	dc.b  $30, $2A, $24, $1E, $18, $12,  $C,   6, $2E, $28, $22, $1C, $16, $10,  $A,   4, $2C, $26, $20, $1A
		dc.b  $14,  $E,   8,   2
byte_20D91:	dc.b  $30,   6,  $C, $12, $18, $1E, $24, $2A,   4,  $A, $10, $16, $1C, $22, $28, $2E,   2,   8,  $E, $14
		dc.b  $1A, $20, $26, $2C
byte_20DA9:	dc.b  $40, $38, $30, $28, $20, $18, $10,   8, $3E, $36, $2E, $26, $1E, $16,  $E,   6, $3C, $34, $2C, $24
		dc.b  $1C, $14,  $C,   4, $3A, $32, $2A, $22, $1A, $12,  $A,   2
byte_20DC9:	dc.b  $40,   8, $10, $18, $20, $28, $30, $38,   6,  $E, $16, $1E, $26, $2E, $36, $3E,   4,  $C, $14, $1C
		dc.b  $24, $2C, $34, $3C,   2,  $A, $12, $1A, $22, $2A, $32, $3A
byte_20DE9:	dc.b  $30, $28, $20, $18, $10,   8, $2E, $26, $1E, $16,  $E,   6, $2C, $24, $1C, $14,  $C,   4, $2A, $22
		dc.b  $1A, $12,  $A,   2
byte_20E01:	dc.b  $30,   8, $10, $18, $20, $28,   6,  $E, $16, $1E, $26, $2E,   4,  $C, $14, $1C, $24, $2C,   2,  $A
		dc.b  $12, $1A, $22, $2A
byte_20E19:	dc.b  $28, $24, $20, $1C, $18, $14, $10,  $C,   8,   4, $27, $23, $1F, $1B, $17, $13,  $F,  $B,   7,   3
		dc.b  $26, $22, $1E, $1A, $16, $12,  $E,  $A,   6,   2, $25, $21, $1D, $19, $15, $11,  $D,   9,   5,   1
		dc.b    4,   3,   2,   1
byte_20E45:	dc.b  $28,   4,   8,  $C, $10, $14, $18, $1C, $20, $24,   3,   7,  $B,  $F, $13, $17, $1B, $1F, $23, $27
		dc.b    2,   6,  $A,  $E, $12, $16, $1A, $1E, $22, $26,   1,   5,   9,  $D, $11, $15, $19, $1D, $21, $25
		dc.b    1,   2,   3,   4
byte_20E71:	dc.b  $20, $18,	$10,   8, $1E, $16, $1C, $14, $1A, $12
byte_20E7B:	dc.b  $20,   8,	$10, $18,   6,	$E,   4,  $C,	2,  $A
byte_20E85:	dc.b  $18, $12,	 $C,   6, $16, $10,  $A,   4, $14,  $E,	  8,   2
byte_20E91:	dc.b  $18,   6,	 $C, $12,   4,	$A, $10, $16,	2,   8,	 $E, $14,   0
byte_20E9E:	dc.b  $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F, $1F
		dc.b  $1F, $1F, $1E, $1E, $1D, $1D, $1C, $1C, $1B, $1B, $1A, $1A, $19, $19, $18, $18, $17, $17, $16, $16
		dc.b  $15, $15, $14, $14, $13, $13, $12, $12, $11, $11, $10, $10,  $F,  $F,  $E,  $E,  $E,  $E,  $E,  $E
		dc.b   $E,  $E,  $E,  $E
byte_20EDE:	dc.b  $30, $30, $30, $30, $30, $30, $30, $30, $30, $30, $30, $30, $2F, $2F, $2F, $2F, $2F, $2F, $2F, $2F
		dc.b  $2F, $2F, $2F, $2F, $2E, $2E, $2E, $2E, $2E, $2E, $2E, $2E, $2D, $2D, $2D, $2D, $2D, $2D, $2D, $2D
		dc.b  $2D, $2D, $2D, $2D, $2D, $2C, $2B, $2A

Map_LRZCollapsingPlatform:include "Levels\LRZ\Misc Object Data\Map - Collapsing Platform.asm"


Map_HPZCollapsingBridge:include "Levels\HPZ\Misc Object Data\Map - Collapsing Bridge.asm"

Map_FBZCollapsingBridge:include "Levels\FBZ\Misc Object Data\Map - Collapsing Bridge.asm"

Map_SOZCollapsingBridge:include "Levels\SOZ\Misc Object Data\Map - Collapsing Bridge.asm"

; ---------------------------------------------------------------------------

Obj_BreakableWall:

		move.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.l	#loc_21568,(a0)
		move.b	$2C(a0),d0
		bpl.s	loc_21340
		tst.b	($FFFFF7E0).w
		beq.s	loc_21340
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_21340:

		andi.b	#$F,d0
		move.b	d0,$22(a0)
		move.l	#Map_AIZBreakableWall,$C(a0)
		move.w	#$4001,$A(a0)
		move.b	#$10,7(a0)
		move.b	#$28,6(a0)
		move.l	#word_2193A,$34(a0)
		move.l	#word_2196A,$38(a0)
		cmpi.b	#1,($FFFFFE10).w
		bne.s	loc_213D6
		move.l	#Map_HCZBreakableWall,$C(a0)
		move.w	#$6001,$A(a0)
		move.b	#$10,7(a0)
		move.b	#$20,6(a0)
		move.l	#word_2199A,$34(a0)
		move.l	#word_219BA,$38(a0)
		cmpi.b	#2,$22(a0)
		bne.s	loc_213D6
		move.w	#$4350,$A(a0)
		move.b	#$18,7(a0)
		move.b	#$20,6(a0)
		move.l	#word_2199A,$34(a0)
		move.l	#word_219BA,$38(a0)
		move.l	#loc_21818,(a0)
		rts
; ---------------------------------------------------------------------------

loc_213D6:

		cmpi.b	#2,($FFFFFE10).w
		bne.s	loc_21428
		move.l	#Map_MGZBreakableWall,$C(a0)
		move.w	#$4001,$A(a0)
		move.b	#$20,7(a0)
		move.b	#$28,6(a0)
		move.l	#word_21A2A,$34(a0)
		move.l	#word_219DA,$38(a0)
		btst	#4,$2C(a0)
		beq.s	loc_21418
		move.l	#loc_21818,(a0)
		rts
; ---------------------------------------------------------------------------

loc_21418:
		cmpi.b	#2,$22(a0)
		bne.s	loc_21428
		move.l	#loc_2172E,(a0)
		rts
; ---------------------------------------------------------------------------

loc_21428:

		cmpi.b	#3,($FFFFFE10).w
		bne.s	loc_2146A
		move.l	#Map_CNZSOZBreakableWall,$C(a0)
		move.w	#$4420,$A(a0)
		move.b	#$10,7(a0)
		move.b	#$20,6(a0)
		move.l	#word_21A7A,$34(a0)
		move.l	#word_21A9A,$38(a0)
		cmpi.b	#2,$22(a0)
		bne.s	loc_2146A
		move.l	#loc_21818,(a0)
		rts
; ---------------------------------------------------------------------------

loc_2146A:

		cmpi.b	#6,($FFFFFE10).w
		bne.s	loc_214A4
		move.l	#Map_LBZBreakableWall,$C(a0)
		move.w	#$22EA,$A(a0)
		move.b	#$10,7(a0)
		move.b	#$20,6(a0)
		move.l	#word_2199A,$34(a0)
		move.l	#word_219BA,$38(a0)
		move.l	#loc_21818,(a0)
		rts
; ---------------------------------------------------------------------------

loc_214A4:
		cmpi.b	#7,($FFFFFE10).w
		bne.s	loc_214DE
		move.l	#Map_MHZBreakableWall,$C(a0)
		move.w	#$434B,$A(a0)
		move.b	#$10,7(a0)
		move.b	#$20,6(a0)
		move.l	#word_21A7A,$34(a0)
		move.l	#word_21A9A,$38(a0)
		move.l	#loc_21818,(a0)
		rts
; ---------------------------------------------------------------------------

loc_214DE:
		cmpi.b	#8,($FFFFFE10).w
		bne.s	loc_21536
		move.l	#Map_CNZSOZBreakableWall,$C(a0)
		move.w	#$448C,$A(a0)
		move.b	#$10,7(a0)
		move.b	#$20,6(a0)
		move.l	#word_21A7A,$34(a0)
		move.l	#word_21A9A,$38(a0)
		move.l	#loc_21818,(a0)
		cmpi.b	#4,$22(a0)
		bne.s	locret_21534
		move.b	#$30,6(a0)
		move.l	#word_2193A,$34(a0)
		move.l	#word_2196A,$38(a0)

locret_21534:
		rts
; ---------------------------------------------------------------------------

loc_21536:
		cmpi.b	#9,($FFFFFE10).w
		bne.s	loc_21568
		move.l	#Map_LRZBreakableWall,$C(a0)
		move.w	#$640D,$A(a0)
		move.b	#$10,7(a0)
		move.b	#$20,6(a0)
		move.l	#word_21A7A,$34(a0)
		move.l	#word_21A9A,$38(a0)

loc_21568:

		move.w	($FFFFB018).w,$30(a0)
		move.w	($FFFFB062).w,$32(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		tst.b	$2C(a0)
		bpl.s	loc_215A4
		tst.b	($FFFFF7E0).w
		beq.s	loc_215AC
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_215A4:
		swap	d6
		andi.w	#3,d6
		bne.s	loc_215B2

loc_215AC:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_215B2:
		lea	($FFFFB000).w,a1
		move.w	$30(a0),d1
		move.w	d6,d0
		andi.w	#1,d0
		beq.s	loc_2162A
		tst.b	($FFFFFE19).w
		bne.s	loc_215F4
		cmpi.b	#2,$38(a1)
		beq.s	loc_215F4
		btst	#4,$2B(a1)
		bne.s	loc_215E0
		btst	#5,$2A(a0)
		beq.s	loc_2162A

loc_215E0:
		cmpi.b	#2,$20(a1)
		bne.s	loc_2162A
		move.w	d1,d0
		bpl.s	loc_215EE
		neg.w	d0

loc_215EE:
		cmpi.w	#$480,d0
		bcs.s	loc_2162A

loc_215F4:

		bclr	#5,$2A(a0)
		bsr.s	sub_2165A
		btst	#6,$2A(a0)
		beq.s	loc_215AC
		lea	($FFFFB04A).w,a1
		cmpi.b	#2,$20(a1)
		bne.s	loc_215AC
		move.w	$32(a0),$18(a1)
		move.w	$18(a1),$1C(a1)
		bclr	#6,$2A(a0)
		bclr	#5,$2A(a1)
		bra.s	loc_215AC
; ---------------------------------------------------------------------------

loc_2162A:

		lea	($FFFFB04A).w,a1
		move.w	$32(a0),d1
		btst	#6,$2A(a0)
		beq.w	loc_215AC
		cmpi.b	#2,$20(a1)
		bne.w	loc_215AC
		move.w	d1,d0
		bpl.s	loc_2164C
		neg.w	d0

loc_2164C:
		cmpi.w	#$480,d0
		bcs.w	loc_215AC
		bclr	#6,$2A(a0)

; =============== S U B R O U T I N E =======================================


sub_2165A:
		move.w	d1,$18(a1)
		addq.w	#4,$10(a1)
		movea.l	$34(a0),a4
		move.w	$10(a0),d0
		cmp.w	$10(a1),d0
		bcs.s	loc_2167A
		subi.w	#8,$10(a1)
		movea.l	$38(a0),a4

loc_2167A:
		move.w	$18(a1),$1C(a1)
		bclr	#5,$2A(a1)
		move.l	#loc_21692,(a0)
		addq.b	#1,$22(a0)
		bsr.s	sub_216B0

loc_21692:


		jsr	(MoveSprite2).l
		addi.w	#$70,$1A(a0)
		tst.b	4(a0)
		bpl.s	loc_216AA
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_216AA:
		jmp	(Delete_Current_Sprite).l
; End of function sub_2165A


; =============== S U B R O U T I N E =======================================


sub_216B0:

		moveq	#$59,d0
		jsr	(Play_Sound_2).l
		move.w	#$80,8(a0)

loc_216BE:
		moveq	#0,d0
		move.b	$22(a0),d0
		add.w	d0,d0
		movea.l	$C(a0),a3
		adda.w	(a3,d0.w),a3
		move.w	(a3)+,d1
		subq.w	#1,d1
		bset	#5,4(a0)
		move.l	(a0),d4
		move.b	4(a0),d5
		movea.l	a0,a1
		bra.s	loc_216EC
; ---------------------------------------------------------------------------

loc_216E2:
		jsr	(Create_New_Sprite3).l
		bne.s	locret_2172C
		addq.w	#6,a3

loc_216EC:
		move.l	d4,(a1)
		move.l	a3,$C(a1)
		move.b	d5,4(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	$A(a0),$A(a1)
		ori.w	#$8000,$A(a1)
		move.b	8(a0),8(a1)
		move.b	7(a0),7(a1)
		move.b	6(a0),6(a1)
		move.w	(a4)+,$18(a1)
		move.w	(a4)+,$1A(a1)
		dbf	d1,loc_216E2

locret_2172C:
		rts
; End of function sub_216B0

; ---------------------------------------------------------------------------

loc_2172E:
		move.w	($FFFFB018).w,$30(a0)
		move.w	($FFFFB062).w,$32(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		swap	d6
		andi.b	#3,d6
		beq.w	loc_217E8
		move.b	d6,d0
		andi.b	#1,d0
		beq.s	loc_217BC
		lea	($FFFFB000).w,a1
		bclr	#6,$37(a1)
		beq.s	loc_217BC
		move.w	$30(a0),$18(a1)
		move.w	$18(a1),$1C(a1)
		bclr	#5,$2A(a1)
		bclr	#5,$2A(a0)
		bsr.s	sub_217EE
		andi.b	#2,d6
		beq.s	loc_217E8
		lea	($FFFFB04A).w,a1
		bclr	#6,$37(a1)
		beq.s	loc_217E8
		move.w	$32(a0),$18(a1)
		move.w	$18(a1),$1C(a1)
		bclr	#5,$2A(a1)
		bclr	#6,$2A(a0)
		bra.s	loc_217E8
; ---------------------------------------------------------------------------

loc_217BC:

		andi.b	#2,d6
		beq.s	loc_217E8
		lea	($FFFFB04A).w,a1
		bclr	#6,$37(a1)
		beq.s	loc_217E8
		move.w	$32(a0),$18(a1)
		move.w	$18(a1),$1C(a1)
		bclr	#5,$2A(a1)
		bclr	#6,$2A(a0)
		bsr.s	sub_217EE

loc_217E8:

		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_217EE:

		movea.l	$34(a0),a4
		move.w	$10(a0),d0
		cmp.w	$10(a1),d0
		bcs.s	loc_21806
		subi.w	#8,$10(a1)
		movea.l	$38(a0),a4

loc_21806:
		move.l	#loc_21692,(a0)
		addq.b	#1,$22(a0)
		bsr.w	sub_216B0
		bra.w	loc_21692
; End of function sub_217EE

; ---------------------------------------------------------------------------

loc_21818:

		move.w	($FFFFB018).w,$30(a0)
		move.w	($FFFFB062).w,$32(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		tst.b	$2C(a0)
		bpl.s	loc_21854
		tst.b	($FFFFF7E0).w
		beq.s	loc_2185C
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_21854:
		swap	d6
		andi.w	#3,d6
		bne.s	loc_21862

loc_2185C:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_21862:
		lea	($FFFFB000).w,a1
		move.w	$30(a0),d1
		move.w	d6,d0
		andi.w	#1,d0
		beq.s	loc_218B0
		cmpi.b	#2,$38(a1)
		bne.s	loc_218B0
		bclr	#5,$2A(a0)
		bsr.s	sub_218CE
		btst	#6,$2A(a0)
		beq.s	loc_2185C
		lea	($FFFFB04A).w,a1
		cmpi.b	#2,$38(a1)
		bne.s	loc_2185C
		move.w	$32(a0),$18(a1)
		move.w	$18(a1),$1C(a1)
		bclr	#6,$2A(a0)
		bclr	#5,$2A(a1)
		bra.s	loc_2185C
; ---------------------------------------------------------------------------

loc_218B0:

		lea	($FFFFB04A).w,a1
		move.w	$32(a0),d1
		btst	#6,$2A(a0)
		beq.s	loc_2185C
		cmpi.b	#2,$38(a1)
		bne.s	loc_2185C
		bclr	#6,$2A(a0)

; =============== S U B R O U T I N E =======================================


sub_218CE:
		move.w	d1,$18(a1)
		addq.w	#4,$10(a1)
		movea.l	$34(a0),a4
		move.w	$10(a0),d0
		cmp.w	$10(a1),d0
		bcs.s	loc_218EE
		subi.w	#8,$10(a1)
		movea.l	$38(a0),a4

loc_218EE:
		move.w	$18(a1),$1C(a1)
		bclr	#5,$2A(a1)
		cmpi.b	#2,$38(a1)
		bne.s	loc_21928
		cmpi.b	#1,$2F(a1)
		bne.s	loc_21928
		move.b	#2,$2F(a1)
		move.b	#$21,$20(a1)
		bclr	#0,$2A(a1)
		tst.w	$18(a1)
		bpl.s	loc_21928
		bset	#0,$2A(a1)

loc_21928:

		move.l	#loc_21692,(a0)
		addq.b	#1,$22(a0)
		bsr.w	sub_216B0
		bra.w	loc_21692
; End of function sub_218CE

; ---------------------------------------------------------------------------
word_2193A:	dc.w $400

		dc.w $FB00
		dc.w $600
		dc.w $FA00
		dc.w $600
		dc.w $FF00
		dc.w $800
		dc.w $FE00
		dc.w $680
		dc.w 0
		dc.w $880
		dc.w 0
		dc.w $600
		dc.w $100
		dc.w $800
		dc.w $200
		dc.w $400
		dc.w $500
		dc.w $600
		dc.w $600
		dc.w $300
		dc.w $600
		dc.w $500
		dc.w $700
word_2196A:	dc.w $FA00

		dc.w $FA00
		dc.w $FC00
		dc.w $FB00
		dc.w $F800
		dc.w $FE00
		dc.w $FA00
		dc.w $FF00
		dc.w $F780
		dc.w 0
		dc.w $F980
		dc.w 0
		dc.w $F800
		dc.w $200
		dc.w $FA00
		dc.w $100
		dc.w $FA00
		dc.w $600
		dc.w $FC00
		dc.w $500
		dc.w $FB00
		dc.w $700
		dc.w $FD00
		dc.w $600
word_2199A:	dc.w $400

		dc.w $FB00
		dc.w $600
		dc.w $FA00
		dc.w $600
		dc.w $FF00
		dc.w $800
		dc.w $FE00
		dc.w $600
		dc.w $100
		dc.w $800
		dc.w $200
		dc.w $400
		dc.w $500
		dc.w $600
		dc.w $600
word_219BA:	dc.w $FA00

		dc.w $FA00
		dc.w $FC00
		dc.w $FB00
		dc.w $F800
		dc.w $FE00
		dc.w $FA00
		dc.w $FF00
		dc.w $F800
		dc.w $200
		dc.w $FA00
		dc.w $100
		dc.w $FA00
		dc.w $600
		dc.w $FC00
		dc.w $500
word_219DA:	dc.w $400
		dc.w $FB00
		dc.w $500
		dc.w $FA80
		dc.w $600
		dc.w $FA00
		dc.w $700
		dc.w $F980
		dc.w $600
		dc.w $FF00
		dc.w $700
		dc.w $FE80
		dc.w $800
		dc.w $FE00
		dc.w $900
		dc.w $FD80
		dc.w $680
		dc.w 0
		dc.w $780
		dc.w 0
		dc.w $880
		dc.w 0
		dc.w $980
		dc.w 0
		dc.w $600
		dc.w $100
		dc.w $700
		dc.w $180
		dc.w $800
		dc.w $200
		dc.w $900
		dc.w $280
		dc.w $400
		dc.w $500
		dc.w $500
		dc.w $580
		dc.w $600
		dc.w $600
		dc.w $700
		dc.w $680
word_21A2A:	dc.w $F900
		dc.w $F980
		dc.w $FA00
		dc.w $FA00
		dc.w $FB00
		dc.w $FA80
		dc.w $FC00
		dc.w $FB00
		dc.w $F700
		dc.w $FD80
		dc.w $F800
		dc.w $FE00
		dc.w $F900
		dc.w $FE80
		dc.w $FA00
		dc.w $FF00
		dc.w $F680
		dc.w 0
		dc.w $F780
		dc.w 0
		dc.w $F880
		dc.w 0
		dc.w $F980
		dc.w 0
		dc.w $F700
		dc.w $280
		dc.w $F800
		dc.w $200
		dc.w $F900
		dc.w $180
		dc.w $FA00
		dc.w $100
		dc.w $F900
		dc.w $680
		dc.w $FA00
		dc.w $600
		dc.w $FB00
		dc.w $580
		dc.w $FC00
		dc.w $500
word_21A7A:	dc.w $400

		dc.w $FB00
		dc.w $600
		dc.w $FA00
		dc.w $600
		dc.w $FF00
		dc.w $800
		dc.w $FE00
		dc.w $600
		dc.w $100
		dc.w $800
		dc.w $200
		dc.w $400
		dc.w $500
		dc.w $600
		dc.w $600
word_21A9A:	dc.w $FA00

		dc.w $FA00
		dc.w $FC00
		dc.w $FB00
		dc.w $F800
		dc.w $FE00
		dc.w $FA00
		dc.w $FF00
		dc.w $F800
		dc.w $200
		dc.w $FA00
		dc.w $100
		dc.w $FA00
		dc.w $600
		dc.w $FC00
		dc.w $500
Map_CNZSOZBreakableWall:include "Levels\CNZ\Misc Object Data\Map - (&SOZ) Breakable Wall.asm"

Map_MHZBreakableWall:include "Levels\MHZ\Misc Object Data\Map - Breakable Wall.asm"

Map_LRZBreakableWall:include "Levels\LRZ\Misc Object Data\Map - Breakable Wall.asm"

; ---------------------------------------------------------------------------

Obj_AIZRideVine:

		movea.l	a0,a1
		move.l	#loc_21D28,(a1)
		bsr.w	sub_21D00
		move.b	#$21,$22(a1)
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		moveq	#0,d1
		move.b	$2C(a0),d1
		andi.w	#$7F,d1
		lsl.w	#4,d1
		add.w	d2,d1
		move.w	d1,$46(a0)
		moveq	#3,d1
		addq.w	#1,d1
		jsr	(Create_New_Sprite3).l
		bne.w	loc_21CFE
		move.w	a1,$3E(a0)
		move.l	#loc_21F80,(a1)
		move.w	a0,$3C(a1)
		bra.s	loc_21CD0
; ---------------------------------------------------------------------------

loc_21CB8:
		jsr	(Create_New_Sprite3).l
		bne.w	loc_21CFE
		move.l	#loc_22014,(a1)
		move.w	a2,$3C(a1)
		move.w	a1,$3E(a2)

loc_21CD0:
		movea.l	a1,a2
		bsr.s	sub_21D00
		move.w	d2,$10(a1)
		move.w	d3,$14(a1)
		addi.w	#$10,d3
		addq.w	#1,$36(a0)
		move.w	$36(a0),$36(a1)
		dbf	d1,loc_21CB8
		move.l	#Obj_AIZRideVineHandle,(a1)
		move.b	#$20,$22(a1)
		move.w	a1,$40(a0)

loc_21CFE:

		bra.s	loc_21D28

; =============== S U B R O U T I N E =======================================


sub_21D00:

		move.b	#4,4(a1)
		move.b	#8,7(a1)
		move.b	#8,6(a1)
		move.w	#$200,8(a1)
		move.l	#Map_AIZMHZRideVine,$C(a1)
		move.w	#$41B,$A(a1)
		rts
; End of function sub_21D00

; ---------------------------------------------------------------------------

loc_21D28:

		movea.w	$40(a0),a1
		tst.w	$32(a1)
		beq.s	loc_21D48
		move.l	#loc_21D4C,(a0)
		movea.w	$3E(a0),a1
		move.w	#1,$2E(a1)
		move.w	#0,$38(a1)

loc_21D48:
		bra.w	loc_21F38
; ---------------------------------------------------------------------------

loc_21D4C:
		addi.l	#$80000,$10(a0)
		addi.l	#$20000,$14(a0)
		move.w	$10(a0),d0
		cmp.w	$46(a0),d0
		bcs.w	loc_21DEE
		tst.b	$2C(a0)
		bpl.s	loc_21DC2
		move.l	#loc_21DF2,(a0)
		move.w	#$800,$18(a0)
		move.w	#$200,$1A(a0)
		move.l	#Map_AnimatedStillSprites,$C(a0)
		move.w	#$62E9,$A(a0)
		move.b	#8,7(a0)
		move.b	#$C,6(a0)
		move.b	#0,$22(a0)
		move.w	#1,$20(a0)
		movea.w	$40(a0),a1
		lea	$32(a1),a2
		tst.b	(a2)
		beq.s	loc_21DB6
		move.b	#$81,(a2)

loc_21DB6:
		addq.w	#1,a2
		tst.b	(a2)
		beq.s	loc_21DC0
		move.b	#$81,(a2)

loc_21DC0:
		bra.s	loc_21DEE
; ---------------------------------------------------------------------------

loc_21DC2:
		move.l	#loc_21E14,(a0)
		movea.w	$3E(a0),a1
		move.l	#loc_21FE8,(a1)
		move.w	#0,$3A(a1)
		movea.w	$40(a0),a1
		move.w	#1,$30(a1)
		move.w	#0,$26(a0)
		move.w	#$400,$3A(a0)

loc_21DEE:

		bra.w	loc_21F38
; ---------------------------------------------------------------------------

loc_21DF2:
		jsr	(MoveSprite).l
		tst.b	4(a0)
		bmi.s	loc_21E04
		move.w	#$7FF0,$10(a0)

loc_21E04:
		lea	(Ani_AnimatedStillSprites).l,a1
		jsr	(Animate_Sprite).l
		bra.w	loc_21F38
; ---------------------------------------------------------------------------

loc_21E14:
		movea.w	$40(a0),a1
		move.w	$3A(a0),d0
		move.b	$26(a0),d1
		ext.w	d1
		bpl.s	loc_21E26
		neg.w	d1

loc_21E26:
		add.w	d1,d1
		sub.w	d1,d0
		sub.w	d0,$26(a0)
		tst.w	$32(a1)
		bne.s	loc_21E68
		move.b	$26(a0),d0
		addq.b	#8,d0
		cmpi.b	#$10,d0
		bcc.s	loc_21E68
		move.l	#loc_21E6C,(a0)
		move.w	#0,$42(a0)
		move.w	#$FD00,$44(a0)
		move.w	#$1000,$38(a0)
		move.w	#0,$2E(a0)
		movea.w	$40(a0),a1
		move.w	#2,$30(a1)

loc_21E68:

		bra.w	loc_21F38
; ---------------------------------------------------------------------------

loc_21E6C:
		moveq	#0,d2
		move.b	$38(a0),d2
		move.w	$44(a0),d0
		move.w	#0,d1
		tst.w	$2E(a0)
		bne.s	loc_21EC4
		add.w	d2,d0
		move.w	d0,$44(a0)
		add.w	d0,$42(a0)
		cmp.b	$42(a0),d1
		bgt.s	loc_21EEE
		asr.w	#4,d0
		sub.w	d0,$44(a0)
		move.w	#1,$2E(a0)
		cmpi.w	#$C00,$38(a0)
		beq.s	loc_21EAC
		subi.w	#$40,$38(a0)
		bra.s	loc_21EEE
; ---------------------------------------------------------------------------

loc_21EAC:

		move.l	#loc_21F0A,(a0)
		move.w	#0,$38(a0)
		movea.w	$40(a0),a1
		move.w	#0,$30(a1)
		bra.s	loc_21EEE
; ---------------------------------------------------------------------------

loc_21EC4:
		sub.w	d2,d0
		move.w	d0,$44(a0)
		add.w	d0,$42(a0)
		cmp.b	$42(a0),d1
		ble.s	loc_21EEE
		asr.w	#4,d0
		sub.w	d0,$44(a0)
		move.w	#0,$2E(a0)
		cmpi.w	#$C00,$38(a0)
		beq.s	loc_21EAC
		subi.w	#$40,$38(a0)

loc_21EEE:

		move.w	$42(a0),d0
		move.w	d0,$26(a0)
		asr.w	#3,d0
		move.w	d0,$3A(a0)
		movea.w	$3E(a0),a1
		move.w	$3A(a0),$3A(a1)
		bra.w	loc_21F38
; ---------------------------------------------------------------------------

loc_21F0A:
		move.b	$38(a0),d0
		addi.w	#$200,$38(a0)
		jsr	(GetSineCosine).l
		asl.w	#2,d0
		cmpi.w	#$400,d0
		bne.s	loc_21F26
		move.w	#$3FF,d0

loc_21F26:
		move.w	d0,$26(a0)
		move.w	d0,$3A(a0)
		movea.w	$3E(a0),a1
		move.w	$3A(a0),$3A(a1)

loc_21F38:

		move.w	$10(a0),d0
		andi.w	#$FF80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_21F52
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_21F52:
		move.w	$36(a0),d2
		subq.w	#1,d2
		bcs.s	loc_21F6E
		movea.w	$3E(a0),a2

loc_21F5E:
		movea.l	a2,a1
		movea.w	$3E(a1),a2
		jsr	(Delete_Referenced_Sprite).l
		dbf	d2,loc_21F5E

loc_21F6E:
		move.w	$48(a0),d0
		beq.s	loc_21F7A
		movea.w	d0,a2
		bclr	#7,(a2)

loc_21F7A:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_21F80:
		tst.w	$2E(a0)
		bne.s	loc_21FA8
		move.b	$38(a0),d0
		addi.w	#$200,$38(a0)
		jsr	(GetSineCosine).l
		asl.w	#2,d0
		cmpi.w	#$400,d0
		bne.s	loc_21FA2
		move.w	#$3FF,d0

loc_21FA2:
		move.w	d0,$3A(a0)
		bra.s	loc_21FBE
; ---------------------------------------------------------------------------

loc_21FA8:
		move.b	$38(a0),d0
		addi.w	#$100,$38(a0)
		jsr	(GetSineCosine).l
		asl.w	#3,d0
		move.w	d0,$3A(a0)

loc_21FBE:
		move.w	$3A(a0),d0
		move.w	d0,$26(a0)
		move.b	$26(a0),d0
		addq.b	#4,d0
		lsr.b	#3,d0
		move.b	d0,$22(a0)
		movea.w	$3C(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_21FE8:
		movea.w	$3C(a0),a1
		move.w	$26(a1),$26(a0)
		move.b	$26(a0),d0
		addq.b	#4,d0
		lsr.b	#3,d0
		move.b	d0,$22(a0)
		movea.w	$3C(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_22014:
		movea.w	$3C(a0),a1
		move.w	$3A(a1),$3A(a0)
		move.w	$26(a1),d0
		add.w	$3A(a0),d0
		move.w	d0,$26(a0)
		move.b	$26(a0),d0
		addq.b	#4,d0
		lsr.b	#3,d0
		move.b	d0,$22(a0)
		bsr.w	sub_22040
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_22040:

		movea.w	$3C(a0),a1
		move.b	$26(a1),d0
		addq.b	#4,d0
		andi.b	#-8,d0
		jsr	(GetSineCosine).l
		neg.w	d0
		addi.w	#8,d0
		addi.w	#8,d1
		asr.w	#4,d0
		asr.w	#4,d1
		add.w	$10(a1),d0
		move.w	d0,$10(a0)
		add.w	$14(a1),d1
		move.w	d1,$14(a0)
		rts
; End of function sub_22040

; ---------------------------------------------------------------------------

Obj_AIZRideVineHandle:
		move.w	$10(a0),d4
		move.w	$14(a0),d5
		bsr.w	sub_22040
		cmp.w	$10(a0),d4
		beq.s	loc_2208A
		move.w	d4,$42(a0)

loc_2208A:
		cmp.w	$14(a0),d5
		beq.s	loc_22094
		move.w	d5,$44(a0)

loc_22094:
		lea	$32(a0),a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF602).w,d0
		bsr.s	sub_220C2
		lea	($FFFFB04A).w,a1
		addq.w	#1,a2
		move.w	($FFFFF66A).w,d0
		bsr.s	sub_220C2
		tst.w	$32(a0)
		beq.s	loc_220BA
		tst.w	$30(a0)
		bne.s	locret_220C0

loc_220BA:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_220C0:
		rts

; =============== S U B R O U T I N E =======================================


sub_220C2:

		tst.b	(a2)
		beq.w	loc_222F4
		bmi.w	loc_2217E
		tst.b	4(a1)
		bpl.w	loc_22190
		cmpi.b	#4,5(a1)
		bcc.w	loc_22190
		move.b	d0,d1
		andi.b	#$70,d1
		beq.w	loc_221EC
		clr.b	$2E(a1)
		clr.b	(a2)
		cmpi.w	#1,$30(a0)
		beq.s	loc_2215C
		move.w	$10(a0),d1
		sub.w	$42(a0),d1
		asl.w	#7,d1
		move.w	d1,$18(a1)
		move.w	$14(a0),d1
		sub.w	$44(a0),d1
		asl.w	#7,d1
		move.w	d1,$1A(a1)
		move.b	#$3C,2(a2)
		btst	#$A,d0
		beq.s	loc_22124
		move.w	#-$200,$18(a1)

loc_22124:
		btst	#$B,d0
		beq.s	loc_22130
		move.w	#$200,$18(a1)

loc_22130:
		addi.w	#-$380,$1A(a1)

loc_22136:
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		rts
; ---------------------------------------------------------------------------

loc_2215C:
		move.b	#$3C,2(a2)
		movea.w	$3C(a0),a3
		move.b	$26(a3),d0
		jsr	(GetSineCosine).l
		asl.w	#3,d1
		move.w	d1,$18(a1)
		asl.w	#3,d0
		move.w	d0,$1A(a1)
		bra.s	loc_22136
; ---------------------------------------------------------------------------

loc_2217E:
		move.w	#$300,$18(a1)
		move.w	#$200,$1A(a1)
		bset	#1,$2A(a1)

loc_22190:

		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$3C,2(a2)
		rts
; End of function sub_220C2


; =============== S U B R O U T I N E =======================================


sub_2219E:
		cmpa.w	#$B000,a1
		bne.s	locret_221E0
		tst.b	d0
		beq.s	locret_221E0
		moveq	#0,d1
		move.b	$25(a0),d1
		cmp.b	byte_221E2(pc,d1.w),d0
		bne.s	loc_221DA
		addq.b	#1,$25(a0)
		move.b	byte_221E3(pc,d1.w),d1
		bne.s	locret_221E0
		moveq	#0,d1
		subi.w	#$20,d1
		movea.w	d1,a4
		moveq	#1,d1
		move.b	d1,(a4)
		move.b	d1,1(a4)
		move.w	d0,d1
		moveq	#$33,d0
		jsr	(Play_Sound_2).l
		move.w	d1,d0

loc_221DA:
		move.b	#0,$25(a0)

locret_221E0:
		rts
; End of function sub_2219E

; ---------------------------------------------------------------------------
byte_221E2:	dc.b 4
byte_221E3:	dc.b 4
		dc.b 4
		dc.b 8
		dc.b 8
		dc.b 8
		dc.b 1
		dc.b 1
		dc.b 1
		dc.b 0
; ---------------------------------------------------------------------------

loc_221EC:
		tst.w	$30(a0)
		bne.s	loc_22258
		bsr.s	sub_2219E
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$14,$14(a1)
		movea.w	$3C(a0),a3
		moveq	#0,d0
		move.b	$26(a3),d0
		btst	#0,$2A(a1)
		beq.s	loc_2221A
		neg.b	d0

loc_2221A:
		addq.b	#8,d0
		lsr.w	#4,d0
		move.b	byte_22248(pc,d0.w),$22(a1)

loc_22224:
		move.b	$2A(a1),d1
		andi.b	#1,d1
		andi.b	#-4,4(a1)
		or.b	d1,4(a1)
		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2
		rts
; ---------------------------------------------------------------------------
byte_22248:	dc.b $91
		dc.b $91
		dc.b $90
		dc.b $90
		dc.b $90
		dc.b $90
		dc.b $90
		dc.b $90
		dc.b $92
		dc.b $92
		dc.b $92
		dc.b $92
		dc.b $92
		dc.b $92
		dc.b $91
		dc.b $91
; ---------------------------------------------------------------------------

loc_22258:
		movea.w	$3C(a0),a3
		moveq	#0,d0
		move.b	$26(a3),d0
		btst	#0,$2A(a1)
		beq.s	loc_2226C
		neg.b	d0

loc_2226C:
		addi.b	#$10,d0
		lsr.w	#5,d0
		add.w	d0,d0
		move.b	byte_222D4(pc,d0.w),$22(a1)
		move.b	#0,$20(a1)
		andi.w	#-2,d0
		move.b	byte_222E4(pc,d0.w),d2
		move.b	byte_222E5(pc,d0.w),d3
		ext.w	d2
		ext.w	d3
		btst	#0,$2A(a1)
		beq.s	loc_2229A
		neg.w	d2

loc_2229A:
		movea.w	$3C(a0),a3
		move.b	$26(a3),d0
		addq.b	#4,d0
		andi.b	#-8,d0
		jsr	(GetSineCosine).l
		neg.w	d0
		addi.w	#8,d0
		addi.w	#8,d1
		asr.w	#4,d0
		asr.w	#4,d1
		add.w	$10(a3),d0
		add.w	d2,d0
		move.w	d0,$10(a1)
		add.w	$14(a3),d1
		add.w	d3,d1
		move.w	d1,$14(a1)
		bra.w	loc_22224
; ---------------------------------------------------------------------------
byte_222D4:	dc.b $78
		dc.b $78
		dc.b $7F
		dc.b $7F
		dc.b $7E
		dc.b $7E
		dc.b $7D
		dc.b $7D
		dc.b $7C
		dc.b $7C
		dc.b $7B
		dc.b $7B
		dc.b $7A
		dc.b $7A
		dc.b $79
		dc.b $79
byte_222E4:	dc.b 0
byte_222E5:	dc.b $18
		dc.b $EE
		dc.b $13
		dc.b $E8
		dc.b 0
		dc.b $EE
		dc.b $ED
		dc.b 0
		dc.b $E8
		dc.b $12
		dc.b $ED
		dc.b $18
		dc.b 0
		dc.b $12
		dc.b $13
; ---------------------------------------------------------------------------

loc_222F4:
		tst.b	2(a2)
		beq.s	loc_22302
		subq.b	#1,2(a2)
		bne.w	locret_2237C

loc_22302:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.w	locret_2237C
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		cmpi.w	#$18,d1
		bcc.w	locret_2237C
		tst.b	$2E(a1)
		bne.s	locret_2237C
		cmpi.b	#4,5(a1)
		bcc.s	locret_2237C
		tst.w	($FFFFFE08).w
		bne.s	locret_2237C
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$14,$14(a1)
		move.b	#$14,$20(a1)
		move.b	#0,$3D(a1)
		move.b	#3,$2E(a1)
		andi.b	#-3,4(a1)
		move.b	#1,(a2)
		moveq	#$4A,d0
		jsr	(Play_Sound_2).l

locret_2237C:

		rts
; ---------------------------------------------------------------------------

Obj_AIZGiantRideVine:
		movea.l	a0,a1
		move.l	#loc_22442,(a1)
		bsr.w	sub_2241A
		move.b	#$21,$22(a1)
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		move.b	$2C(a0),d1
		andi.w	#$F,d1
		jsr	(Create_New_Sprite3).l
		bne.w	loc_22418
		move.w	#-$1B0,$44(a1)
		move.w	#$800,$38(a1)
		move.w	a1,$3E(a0)
		move.l	#loc_2248A,(a1)
		move.w	a0,$3C(a1)
		move.b	$2C(a0),d0
		andi.b	#-$10,d0
		move.b	d0,$42(a1)
		bra.s	loc_223EA
; ---------------------------------------------------------------------------

loc_223D2:
		jsr	(Create_New_Sprite3).l
		bne.w	loc_22418
		move.l	#loc_2251E,(a1)
		move.w	a2,$3C(a1)
		move.w	a1,$3E(a2)

loc_223EA:
		movea.l	a1,a2
		bsr.s	sub_2241A
		move.w	d2,$10(a1)
		move.w	d3,$14(a1)
		addi.w	#$10,d3
		addq.w	#1,$36(a0)
		move.w	$36(a0),$36(a1)
		dbf	d1,loc_223D2
		move.l	#loc_2257E,(a1)
		move.b	#$20,$22(a1)
		move.w	a1,$40(a0)

loc_22418:

		bra.s	loc_22442

; =============== S U B R O U T I N E =======================================


sub_2241A:

		move.b	#4,4(a1)
		move.b	#8,7(a1)
		move.b	#8,6(a1)
		move.w	#$200,8(a1)
		move.l	#Map_AIZMHZRideVine,$C(a1)
		move.w	#$41B,$A(a1)
		rts
; End of function sub_2241A

; ---------------------------------------------------------------------------

loc_22442:

		move.w	$10(a0),d0
		andi.w	#$FF80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_2245C
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2245C:
		move.w	$36(a0),d2
		subq.w	#1,d2
		bcs.s	loc_22478
		movea.w	$3E(a0),a2

loc_22468:
		movea.l	a2,a1
		movea.w	$3E(a1),a2
		jsr	(Delete_Referenced_Sprite).l
		dbf	d2,loc_22468

loc_22478:
		move.w	$48(a0),d0
		beq.s	loc_22484
		movea.w	d0,a2
		bclr	#7,(a2)

loc_22484:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2248A:
		tst.b	(a0)
		bne.s	loc_224BC
		move.b	($FFFFFEBA).w,d0
		add.b	$42(a0),d0
		jsr	(GetSineCosine).l
		muls.w	#$2C,d0
		move.w	d0,$26(a0)
		asr.w	#3,d0
		move.w	d0,$3A(a0)
		move.b	$26(a0),d0
		addq.b	#4,d0
		lsr.b	#3,d0
		move.b	d0,$22(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_224BC:
		moveq	#0,d2
		move.b	$38(a0),d2
		move.w	$44(a0),d0
		move.w	#0,d1
		tst.w	$2E(a0)
		bne.s	loc_224E8
		add.w	d2,d0
		move.w	d0,$44(a0)
		add.w	d0,$42(a0)
		cmp.b	$42(a0),d1
		bgt.s	loc_224FE
		move.w	#1,$2E(a0)
		bra.s	loc_224FE
; ---------------------------------------------------------------------------

loc_224E8:
		sub.w	d2,d0
		move.w	d0,$44(a0)
		add.w	d0,$42(a0)
		cmp.b	$42(a0),d1
		ble.s	loc_224FE
		move.w	#0,$2E(a0)

loc_224FE:

		move.w	$42(a0),d0
		move.w	d0,$26(a0)
		asr.w	#3,d0
		move.w	d0,$3A(a0)
		move.b	$26(a0),d0
		addq.b	#4,d0
		lsr.b	#3,d0
		move.b	d0,$22(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2251E:
		movea.w	$3C(a0),a1
		move.w	$3A(a1),$3A(a0)
		move.w	$26(a1),d0
		add.w	$3A(a0),d0
		move.w	d0,$26(a0)
		move.b	$26(a0),d0
		addq.b	#4,d0
		lsr.b	#3,d0
		move.b	d0,$22(a0)
		bsr.w	sub_2254A
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_2254A:

		movea.w	$3C(a0),a1
		move.b	$26(a1),d0
		addq.b	#4,d0
		andi.b	#-8,d0
		jsr	(GetSineCosine).l
		neg.w	d0
		addi.w	#8,d0
		addi.w	#8,d1
		asr.w	#4,d0
		asr.w	#4,d1
		add.w	$10(a1),d0
		move.w	d0,$10(a0)
		add.w	$14(a1),d1
		move.w	d1,$14(a0)
		rts
; End of function sub_2254A

; ---------------------------------------------------------------------------

loc_2257E:
		move.w	$10(a0),d4
		move.w	$14(a0),d5
		bsr.w	sub_2254A
		cmp.w	$10(a0),d4
		beq.s	loc_22594
		move.w	d4,$42(a0)

loc_22594:
		cmp.w	$14(a0),d5
		beq.s	loc_2259E
		move.w	d5,$44(a0)

loc_2259E:
		lea	$32(a0),a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF602).w,d0
		bsr.w	sub_220C2
		lea	($FFFFB04A).w,a1
		addq.w	#1,a2
		move.w	($FFFFF66A).w,d0
		bsr.w	sub_220C2
		tst.w	$32(a0)
		beq.s	loc_225C8
		tst.w	$30(a0)
		bne.s	locret_225CE

loc_225C8:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_225CE:
		rts
; ---------------------------------------------------------------------------

Obj_MHZSwingVine:

		movea.l	a0,a1
		move.l	#loc_2267E,(a1)
		bsr.w	sub_22656
		move.b	#$23,$22(a1)
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		moveq	#0,d1
		addq.w	#1,d1
		jsr	(Create_New_Sprite3).l
		bne.w	loc_22654
		move.w	a1,$3E(a0)
		move.l	#loc_2286C,(a1)
		move.w	a0,$3C(a1)
		bra.s	loc_2261A
; ---------------------------------------------------------------------------

loc_22608:
		jsr	(Create_New_Sprite3).l

loc_2260E:
		bne.w	loc_22654
		move.w	a2,$3C(a1)
		move.w	a1,$3E(a2)

loc_2261A:
		movea.l	a1,a2
		bsr.s	sub_22656
		move.w	d2,$10(a1)
		move.w	d3,$14(a1)
		addi.w	#$10,d3
		addq.w	#1,$36(a0)
		move.w	$36(a0),$36(a1)
		dbf	d1,loc_22608
		move.l	#loc_228CC,(a1)
		move.b	#$22,$22(a1)
		move.w	$10(a1),$42(a1)
		move.w	$14(a1),$44(a1)
		move.w	a1,$40(a0)

loc_22654:

		bra.s	loc_2267E

; =============== S U B R O U T I N E =======================================


sub_22656:

		move.b	#4,4(a1)
		move.b	#8,7(a1)
		move.b	#8,6(a1)
		move.w	#$200,8(a1)
		move.l	#Map_AIZMHZRideVine,$C(a1)
		move.w	#$455,$A(a1)
		rts
; End of function sub_22656

; ---------------------------------------------------------------------------

loc_2267E:

		movea.w	$40(a0),a1
		tst.w	$32(a1)
		beq.s	loc_226AC
		bmi.s	loc_22690
		tst.b	$33(a1)
		bpl.s	loc_226AC

loc_22690:
		move.l	#loc_226B0,(a0)
		movea.w	$40(a0),a1
		move.w	#1,$30(a1)
		move.w	#0,$26(a0)
		move.w	#$800,$3A(a0)

loc_226AC:

		bra.w	loc_22824
; ---------------------------------------------------------------------------

loc_226B0:

		movea.w	$40(a0),a1
		move.w	$3A(a0),d0
		move.b	$26(a0),d1
		ext.w	d1
		bpl.s	loc_226C2
		neg.w	d1

loc_226C2:
		add.w	d1,d1
		sub.w	d1,d0
		sub.w	d0,$26(a0)
		move.b	$26(a0),d0
		andi.b	#-8,d0
		cmpi.b	#$40,d0
		bne.s	loc_226E0
		moveq	#$7E,d0
		jsr	(Play_Sound_2).l

loc_226E0:
		move.w	#$200,8(a0)
		tst.w	$26(a0)
		bpl.s	loc_226F2
		move.w	#$280,8(a0)

loc_226F2:
		tst.b	$32(a1)
		beq.s	loc_2270A
		move.b	#1,($FFFFF676).w
		move.w	$10(a0),($FFFFF678).w
		move.w	$14(a0),($FFFFF67C).w

loc_2270A:
		tst.w	$32(a1)
		bne.s	loc_22744
		move.b	$26(a0),d0
		addq.b	#8,d0
		cmpi.b	#$10,d0
		bcc.s	loc_22744

loc_2271C:
		move.l	#loc_22748,(a0)
		move.w	#0,$42(a0)
		move.w	#-$300,$44(a0)
		move.w	#$1000,$38(a0)
		move.w	#0,$2E(a0)
		movea.w	$40(a0),a1
		move.w	#2,$30(a1)

loc_22744:

		bra.w	loc_22824
; ---------------------------------------------------------------------------

loc_22748:
		moveq	#0,d2
		move.b	$38(a0),d2
		move.w	$44(a0),d0
		move.w	#0,d1
		tst.w	$2E(a0)
		bne.s	loc_227AC
		add.w	d2,d0
		move.w	d0,$44(a0)
		add.w	d0,$42(a0)
		cmp.b	$42(a0),d1
		bgt.s	loc_227D6
		asr.w	#4,d0
		sub.w	d0,$44(a0)
		move.w	#1,$2E(a0)
		cmpi.w	#$C00,$38(a0)
		beq.s	loc_22788
		subi.w	#$40,$38(a0)
		bra.s	loc_227D6
; ---------------------------------------------------------------------------

loc_22788:

		move.l	#loc_2267E,(a0)
		move.w	#0,$38(a0)
		movea.w	$40(a0),a1
		move.w	#0,$30(a1)
		move.w	$10(a1),$42(a1)
		move.w	$14(a1),$44(a1)
		bra.s	loc_227D6
; ---------------------------------------------------------------------------

loc_227AC:
		sub.w	d2,d0
		move.w	d0,$44(a0)
		add.w	d0,$42(a0)
		cmp.b	$42(a0),d1
		ble.s	loc_227D6
		asr.w	#4,d0
		sub.w	d0,$44(a0)
		move.w	#0,$2E(a0)
		cmpi.w	#$C00,$38(a0)
		beq.s	loc_22788
		subi.w	#$40,$38(a0)

loc_227D6:

		move.w	$42(a0),d0
		move.w	d0,$26(a0)
		move.w	#$200,8(a0)
		tst.w	$26(a0)
		bpl.s	loc_227F0
		move.w	#$280,8(a0)

loc_227F0:
		asr.w	#3,d0
		move.w	d0,$3A(a0)
		movea.w	$3E(a0),a1
		move.w	$3A(a0),$3A(a1)
		movea.w	$40(a0),a1
		tst.w	$32(a1)
		beq.s	loc_22824
		bmi.s	loc_22812
		tst.b	$33(a1)
		bpl.s	loc_22824

loc_22812:
		move.l	#loc_226B0,(a0)
		move.w	#1,$30(a1)
		move.w	#$800,$3A(a0)

loc_22824:

		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_2283E
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2283E:
		move.w	$36(a0),d2
		subq.w	#1,d2
		bcs.s	loc_2285A
		movea.w	$3E(a0),a2

loc_2284A:
		movea.l	a2,a1
		movea.w	$3E(a1),a2
		jsr	(Delete_Referenced_Sprite).l
		dbf	d2,loc_2284A

loc_2285A:
		move.w	$48(a0),d0
		beq.s	loc_22866
		movea.w	d0,a2
		bclr	#7,(a2)

loc_22866:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2286C:
		movea.w	$3C(a0),a1
		move.w	$26(a1),$26(a0)
		move.b	$26(a0),d0
		addq.b	#4,d0
		lsr.b	#3,d0
		move.b	d0,$22(a0)
		movea.w	$3C(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_22898:
		movea.w	$3C(a0),a1
		move.b	$26(a1),d0
		addq.b	#4,d0
		andi.b	#-8,d0
		jsr	(GetSineCosine).l
		neg.w	d0
		addi.w	#8,d0
		addi.w	#8,d1
		asr.w	#4,d0
		asr.w	#4,d1

loc_228BA:
		add.w	$10(a1),d0
		move.w	d0,$10(a0)
		add.w	$14(a1),d1
		move.w	d1,$14(a0)
		rts
; End of function sub_22898

; ---------------------------------------------------------------------------

loc_228CC:
		move.w	$10(a0),d4
		move.w	$14(a0),d5

loc_228D4:
		bsr.w	sub_22898
		cmp.w	$10(a0),d4
		beq.s	loc_228E2
		move.w	d4,$42(a0)

loc_228E2:
		cmp.w	$14(a0),d5
		beq.s	loc_228EC
		move.w	d5,$44(a0)

loc_228EC:
		lea	$32(a0),a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF602).w,d0
		bsr.s	loc_2291A
		lea	($FFFFB04A).w,a1
		addq.w	#1,a2
		move.w	($FFFFF66A).w,d0
		bsr.s	loc_2291A
		tst.w	$32(a0)
		beq.s	loc_22912
		tst.w	$30(a0)
		bne.s	locret_22918

loc_22912:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_22918:
		rts
; ---------------------------------------------------------------------------

loc_2291A:

		tst.b	(a2)
		beq.w	loc_22AF8
		tst.b	4(a1)
		bpl.w	loc_229E4
		cmpi.b	#4,5(a1)
		bcc.w	loc_229E4
		tst.w	($FFFFFE08).w
		bne.w	loc_229E4
		andi.b	#$70,d0
		beq.w	loc_229F2
		clr.b	$2E(a1)
		clr.b	(a2)
		cmpi.w	#1,$30(a0)
		beq.s	loc_229B6
		move.w	$10(a0),d1
		sub.w	$42(a0),d1
		asl.w	#7,d1
		move.w	d1,$18(a1)
		move.w	$14(a0),d1
		sub.w	$44(a0),d1
		asl.w	#7,d1
		move.w	d1,$1A(a1)
		move.b	#$3C,2(a2)
		btst	#$A,d0
		beq.s	loc_2297E
		move.w	#-$200,$18(a1)

loc_2297E:
		btst	#$B,d0
		beq.s	loc_2298A
		move.w	#$200,$18(a1)

loc_2298A:
		addi.w	#-$380,$1A(a1)

loc_22990:
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		rts
; ---------------------------------------------------------------------------

loc_229B6:
		move.b	#$3C,2(a2)
		movea.w	$3C(a0),a3
		move.b	$26(a3),d0
		jsr	(GetSineCosine).l
		asl.w	#2,d1
		move.w	d1,d2
		asl.w	#1,d1
		add.w	d2,d1
		move.w	d1,$18(a1)
		asl.w	#2,d0
		move.w	d0,d2
		asl.w	#1,d0
		add.w	d2,d0
		move.w	d0,$1A(a1)
		bra.s	loc_22990
; ---------------------------------------------------------------------------

loc_229E4:

		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$3C,2(a2)
		rts
; ---------------------------------------------------------------------------

loc_229F2:
		tst.w	$30(a0)
		bne.s	loc_22A5C
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$14,$14(a1)
		movea.w	$3C(a0),a3
		moveq	#0,d0
		move.b	$26(a3),d0
		btst	#0,$2A(a1)
		beq.s	loc_22A1E
		neg.b	d0

loc_22A1E:
		addq.b	#8,d0
		lsr.w	#4,d0
		move.b	byte_22A4C(pc,d0.w),$22(a1)

loc_22A28:
		move.b	$2A(a1),d1
		andi.b	#1,d1
		andi.b	#-4,4(a1)
		or.b	d1,4(a1)
		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2
		rts
; ---------------------------------------------------------------------------
byte_22A4C:	dc.b $91
		dc.b $91
		dc.b $90
		dc.b $90
		dc.b $90
		dc.b $90
		dc.b $90
		dc.b $90
		dc.b $92
		dc.b $92
		dc.b $92
		dc.b $92
		dc.b $92
		dc.b $92
		dc.b $91
		dc.b $91
; ---------------------------------------------------------------------------

loc_22A5C:
		movea.w	$3C(a0),a3
		moveq	#0,d0
		move.b	$26(a3),d0
		btst	#0,$2A(a1)
		beq.s	loc_22A70
		neg.b	d0

loc_22A70:
		addi.b	#$10,d0
		lsr.w	#5,d0
		add.w	d0,d0
		move.b	byte_22AD8(pc,d0.w),$22(a1)
		move.b	#0,$20(a1)
		andi.w	#-2,d0
		move.b	byte_22AD8+$10(pc,d0.w),d2
		move.b	byte_22AE9(pc,d0.w),d3
		ext.w	d2
		ext.w	d3
		btst	#0,$2A(a1)
		beq.s	loc_22A9E
		neg.w	d2

loc_22A9E:
		movea.w	$3C(a0),a3
		move.b	$26(a3),d0
		addq.b	#4,d0
		andi.b	#-8,d0
		jsr	(GetSineCosine).l
		neg.w	d0
		addi.w	#8,d0
		addi.w	#8,d1
		asr.w	#4,d0
		asr.w	#4,d1
		add.w	$10(a3),d0
		add.w	d2,d0
		move.w	d0,$10(a1)
		add.w	$14(a3),d1
		add.w	d3,d1
		move.w	d1,$14(a1)
		bra.w	loc_22A28
; ---------------------------------------------------------------------------
byte_22AD8:	dc.b $78
		dc.b $78
		dc.b $7F
		dc.b $7F
		dc.b $7E
		dc.b $7E
		dc.b $7D
		dc.b $7D
		dc.b $7C
		dc.b $7C
		dc.b $7B
		dc.b $7B
		dc.b $7A
		dc.b $7A
		dc.b $79
		dc.b $79
		dc.b 0
byte_22AE9:	dc.b $18
		dc.b $EE
		dc.b $13
		dc.b $E8
		dc.b 0
		dc.b $EE
		dc.b $ED
		dc.b 0
		dc.b $E8
		dc.b $12
		dc.b $ED
		dc.b $18
		dc.b 0
		dc.b $12
		dc.b $13
; ---------------------------------------------------------------------------

loc_22AF8:
		tst.b	2(a2)
		beq.s	loc_22B06
		subq.b	#1,2(a2)
		bne.w	locret_22B9C

loc_22B06:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.w	locret_22B9C
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		cmpi.w	#$28,d1
		bcc.w	locret_22B9C
		move.w	$18(a1),d0
		cmpi.w	#$400,d0
		bge.s	loc_22B3C
		cmpi.w	#$18,d1
		bcc.w	locret_22B9C

loc_22B3C:

		tst.b	$2E(a1)
		bne.s	locret_22B9C
		cmpi.b	#4,5(a1)
		bcc.s	locret_22B9C
		tst.w	($FFFFFE08).w
		bne.s	locret_22B9C
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)

loc_22B68:
		addi.w	#$14,$14(a1)
		move.b	#$14,$20(a1)
		move.b	#0,$3D(a1)
		move.b	#3,$2E(a1)
		andi.b	#-3,4(a1)
		move.b	#1,(a2)
		cmpi.w	#$400,d0
		blt.s	loc_22B3C
		move.b	#-$7F,(a2)
		moveq	#$4A,d0
		jsr	(Play_Sound_2).l

locret_22B9C:

		rts
; ---------------------------------------------------------------------------
Map_AIZMHZRideVine:include "Levels\AIZ\Misc Object Data\Map - (&MHZ) Ride Vine.asm"


; =============== S U B R O U T I N E =======================================


Obj_Spring:

		move.l	#Map_Spring,$C(a0)
		move.w	#$4A4,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$200,8(a0)
		move.w	$10(a0),$32(a0)
		move.w	$14(a0),$34(a0)
		move.b	$2C(a0),d0
		lsr.w	#3,d0
		andi.w	#$E,d0
		move.w	off_22D4A(pc,d0.w),d0
		jmp	off_22D4A(pc,d0.w)
; End of function Obj_Spring

; ---------------------------------------------------------------------------
off_22D4A:	dc.w loc_22E8E-off_22D4A

		dc.w loc_22DB0-off_22D4A
		dc.w loc_22DEE-off_22D4A
		dc.w loc_22E28-off_22D4A
		dc.w loc_22E58-off_22D4A

; =============== S U B R O U T I N E =======================================


sub_22D54:
		move.l	#Map_Spring,$C(a0)
		move.w	#$4A4,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$200,8(a0)
		move.w	$10(a0),$32(a0)
		move.w	$14(a0),$34(a0)
		move.b	$2C(a0),d0
		lsr.w	#3,d0
		andi.w	#$E,d0
		move.w	off_22DA0(pc,d0.w),d0
		jsr	off_22DA0(pc,d0.w)
		move.w	#-$800,$30(a0)
		rts
; End of function sub_22D54

; ---------------------------------------------------------------------------
off_22DA0:	dc.w loc_22E8E-off_22DA0

		dc.w loc_22DB0-off_22DA0
		dc.w loc_22DEE-off_22DA0
		dc.w loc_22DB0-off_22DA0
		dc.w loc_22E8E-off_22DA0
		dc.w loc_22DEE-off_22DA0
		dc.w loc_22E8E-off_22DA0
		dc.w loc_22DEE-off_22DA0
; ---------------------------------------------------------------------------

loc_22DB0:

		move.b	#2,$20(a0)
		move.b	#3,$22(a0)
		move.w	#$4B4,$A(a0)
		move.b	#8,7(a0)
		move.l	#loc_23050,(a0)
		tst.w	($FFFFFFE8).w
		beq.w	loc_22EC4
		move.l	#Map_2PSpring,$C(a0)
		move.w	#$3AD,$A(a0)
		move.l	#loc_230DE,(a0)
		bra.w	loc_22EC4
; ---------------------------------------------------------------------------

loc_22DEE:

		tst.b	($FFFFF7C6).w
		bne.w	loc_22E96
		bset	#1,$2A(a0)

loc_22DFC:
		move.b	#6,$22(a0)
		move.l	#loc_23326,(a0)
		tst.w	($FFFFFFE8).w
		beq.w	loc_22EC4
		move.l	#loc_23374,(a0)
		move.l	#Map_2PSpring,$C(a0)
		move.w	#$391,$A(a0)
		bra.w	loc_22EC4
; ---------------------------------------------------------------------------

loc_22E28:
		move.b	#4,$20(a0)
		move.b	#7,$22(a0)
		move.w	#$43A,$A(a0)
		cmpi.b	#2,($FFFFFE10).w
		beq.s	loc_22E4A
		cmpi.b	#7,($FFFFFE10).w
		bne.s	loc_22E50

loc_22E4A:
		move.w	#$478,$A(a0)

loc_22E50:
		move.l	#loc_23490,(a0)
		bra.s	loc_22EC4
; ---------------------------------------------------------------------------

loc_22E58:
		move.b	#4,$20(a0)
		move.b	#$A,$22(a0)
		move.w	#$43A,$A(a0)
		cmpi.b	#2,($FFFFFE10).w
		beq.s	loc_22E7A
		cmpi.b	#7,($FFFFFE10).w
		bne.s	loc_22E80

loc_22E7A:
		move.w	#$478,$A(a0)

loc_22E80:
		bset	#1,$2A(a0)
		move.l	#loc_235D2,(a0)
		bra.s	loc_22EC4
; ---------------------------------------------------------------------------

loc_22E8E:

		tst.b	($FFFFF7C6).w
		bne.w	loc_22DFC

loc_22E96:
		move.l	#loc_22EF4,(a0)
		tst.w	($FFFFFFE8).w
		beq.s	loc_22EC4
		move.l	#loc_22F46,(a0)
		move.l	#Map_2PSpring,$C(a0)
		move.w	#$391,$A(a0)
		cmpi.b	#$12,($FFFFFE10).w
		bne.s	loc_22EC4
		ori.w	#-$8000,$A(a0)

loc_22EC4:

		move.b	$2C(a0),d0
		andi.w	#2,d0
		move.w	word_22EF0(pc,d0.w),$30(a0)
		btst	#1,d0
		beq.s	locret_22EEE
		move.l	#Map_Spring2,$C(a0)
		tst.w	($FFFFFFE8).w
		beq.s	locret_22EEE
		move.l	#Map_Spring3,$C(a0)

locret_22EEE:

		rts
; ---------------------------------------------------------------------------
word_22EF0:	dc.w $F000
		dc.w $F600
; ---------------------------------------------------------------------------

loc_22EF4:

		move.w	#$1B,d1
		move.w	#8,d2
		move.w	#$10,d3
		move.w	$10(a0),d4
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.w	SolidObjectFull2_1P
		btst	#3,$2A(a0)
		beq.s	loc_22F1C
		bsr.s	sub_22F98

loc_22F1C:
		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.w	SolidObjectFull2_1P
		btst	#4,$2A(a0)
		beq.s	loc_22F34
		bsr.s	sub_22F98

loc_22F34:
		lea	(Ani_Spring).l,a1
		jsr	(Animate_Sprite).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_22F46:


		move.w	#$13,d1
		move.w	#8,d2
		move.w	#$10,d3
		move.w	$10(a0),d4
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.w	SolidObjectFull2_1P
		btst	#3,$2A(a0)
		beq.s	loc_22F6E
		bsr.s	sub_22F98

loc_22F6E:
		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.w	SolidObjectFull2_1P
		btst	#4,$2A(a0)
		beq.s	loc_22F86
		bsr.s	sub_22F98

loc_22F86:
		lea	(Ani_Spring).l,a1
		jsr	(Animate_Sprite).l
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_22F98:

		move.w	#$100,$20(a0)
		addq.w	#8,$14(a1)
		tst.b	($FFFFF7C6).w
		beq.s	loc_22FAE
		subi.w	#$10,$14(a1)

loc_22FAE:
		move.w	$30(a0),$1A(a1)
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		clr.b	$40(a1)
		clr.b	$3D(a1)
		move.b	#$10,$20(a1)
		move.b	#2,5(a1)
		move.b	$2C(a0),d0
		bpl.s	loc_22FE0
		move.w	#0,$18(a1)

loc_22FE0:
		btst	#0,d0
		beq.s	loc_23020
		move.w	#1,$1C(a1)
		move.b	#1,$27(a1)
		move.b	#0,$20(a1)
		move.b	#0,$30(a1)
		move.b	#4,$31(a1)
		btst	#1,d0
		bne.s	loc_23010
		move.b	#1,$30(a1)

loc_23010:
		btst	#0,$2A(a1)
		beq.s	loc_23020
		neg.b	$27(a1)
		neg.w	$1C(a1)

loc_23020:

		andi.b	#$C,d0
		cmpi.b	#4,d0
		bne.s	loc_23036
		move.b	#$C,$46(a1)
		move.b	#$D,$47(a1)

loc_23036:
		cmpi.b	#8,d0
		bne.s	loc_23048
		move.b	#$E,$46(a1)
		move.b	#$F,$47(a1)

loc_23048:
		moveq	#-$4F,d0
		jmp	(Play_Sound_2).l
; End of function sub_22F98

; ---------------------------------------------------------------------------

loc_23050:

		move.w	#$13,d1
		move.w	#$E,d2
		move.w	#$F,d3
		move.w	$10(a0),d4
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.w	SolidObjectFull2_1P
		swap	d6
		andi.w	#1,d6
		beq.s	loc_23092
		move.b	$2A(a0),d1
		move.w	$10(a0),d0
		sub.w	$10(a1),d0
		bcs.s	loc_23088
		eori.b	#1,d1

loc_23088:
		andi.b	#1,d1
		bne.s	loc_23092
		bsr.w	sub_23190

loc_23092:

		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.w	SolidObjectFull2_1P
		swap	d6
		andi.w	#2,d6
		beq.s	loc_230C4
		move.b	$2A(a0),d1
		move.w	$10(a0),d0
		sub.w	$10(a1),d0
		bcs.s	loc_230BA
		eori.b	#1,d1

loc_230BA:
		andi.b	#1,d1
		bne.s	loc_230C4
		bsr.w	sub_23190

loc_230C4:

		bsr.w	sub_2326C
		lea	(Ani_Spring).l,a1
		jsr	(Animate_Sprite).l
		move.w	$32(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_230DE:


		move.w	#$F,d1
		move.w	#$C,d2
		move.w	#$D,d3
		move.w	$10(a0),d4
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.w	SolidObjectFull2_1P
		swap	d6
		andi.w	#1,d6
		beq.s	loc_2311E
		move.b	$2A(a0),d1
		move.w	$10(a0),d0
		sub.w	$10(a1),d0
		bcs.s	loc_23116
		eori.b	#1,d1

loc_23116:
		andi.b	#1,d1
		bne.s	loc_2311E
		bsr.s	sub_23160

loc_2311E:

		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.w	SolidObjectFull2_1P
		swap	d6
		andi.w	#2,d6
		beq.s	loc_2314E
		move.b	$2A(a0),d1
		move.w	$10(a0),d0
		sub.w	$10(a1),d0
		bcs.s	loc_23146
		eori.b	#1,d1

loc_23146:
		andi.b	#1,d1
		bne.s	loc_2314E
		bsr.s	sub_23160

loc_2314E:

		lea	(Ani_Spring).l,a1
		jsr	(Animate_Sprite).l
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_23160:

		move.w	#$300,$20(a0)
		move.w	$30(a0),$18(a1)
		addq.w	#4,$10(a1)
		bset	#0,$2A(a1)
		btst	#0,$2A(a0)
		bne.s	loc_2318E
		bclr	#0,$2A(a1)
		subi.w	#8,$10(a1)
		neg.w	$18(a1)

loc_2318E:
		bra.s	loc_231BE
; End of function sub_23160


; =============== S U B R O U T I N E =======================================


sub_23190:

		move.w	#$300,$20(a0)
		move.w	$30(a0),$18(a1)
		addq.w	#8,$10(a1)
		bset	#0,$2A(a1)
		btst	#0,$2A(a0)
		bne.s	loc_231BE
		bclr	#0,$2A(a1)
		subi.w	#$10,$10(a1)
		neg.w	$18(a1)

loc_231BE:

		move.w	#$F,$32(a1)
		move.w	$18(a1),$1C(a1)
		btst	#2,$2A(a1)
		bne.s	loc_231D8
		move.b	#0,$20(a1)

loc_231D8:
		move.b	$2C(a0),d0
		bpl.s	loc_231E4
		move.w	#0,$1A(a1)

loc_231E4:
		btst	#0,d0
		beq.s	loc_23224
		move.w	#1,$1C(a1)
		move.b	#1,$27(a1)
		move.b	#0,$20(a1)
		move.b	#1,$30(a1)
		move.b	#8,$31(a1)
		btst	#1,d0
		bne.s	loc_23214
		move.b	#3,$30(a1)

loc_23214:
		btst	#0,$2A(a1)
		beq.s	loc_23224
		neg.b	$27(a1)
		neg.w	$1C(a1)

loc_23224:

		andi.b	#$C,d0
		cmpi.b	#4,d0
		bne.s	loc_2323A
		move.b	#$C,$46(a1)
		move.b	#$D,$47(a1)

loc_2323A:
		cmpi.b	#8,d0
		bne.s	loc_2324C
		move.b	#$E,$46(a1)
		move.b	#$F,$47(a1)

loc_2324C:
		bclr	#5,$2A(a0)
		bclr	#6,$2A(a0)
		bclr	#5,$2A(a1)
		move.b	#0,$2F(a1)
		moveq	#-$4F,d0
		jmp	(Play_Sound_2).l
; End of function sub_23190


; =============== S U B R O U T I N E =======================================


sub_2326C:
		cmpi.b	#3,$20(a0)
		beq.w	locret_23324
		move.w	$10(a0),d0
		move.w	d0,d1
		addi.w	#$28,d1
		btst	#0,$2A(a0)
		beq.s	loc_2328E
		move.w	d0,d1
		subi.w	#$28,d0

loc_2328E:
		move.w	$14(a0),d2
		move.w	d2,d3
		subi.w	#$18,d2
		addi.w	#$18,d3
		lea	($FFFFB000).w,a1
		btst	#1,$2A(a1)
		bne.s	loc_232E2
		move.w	$1C(a1),d4
		btst	#0,$2A(a0)
		beq.s	loc_232B6
		neg.w	d4

loc_232B6:
		tst.w	d4
		bmi.s	loc_232E2
		move.w	$10(a1),d4
		cmp.w	d0,d4
		bcs.w	loc_232E2
		cmp.w	d1,d4
		bcc.w	loc_232E2
		move.w	$14(a1),d4
		cmp.w	d2,d4
		bcs.w	loc_232E2
		cmp.w	d3,d4
		bcc.w	loc_232E2
		move.w	d0,-(sp)
		bsr.w	sub_23190
		move.w	(sp)+,d0

loc_232E2:

		lea	($FFFFB04A).w,a1
		btst	#1,$2A(a1)
		bne.s	locret_23324
		move.w	$1C(a1),d4
		btst	#0,$2A(a0)
		beq.s	loc_232FC
		neg.w	d4

loc_232FC:
		tst.w	d4
		bmi.s	locret_23324
		move.w	$10(a1),d4
		cmp.w	d0,d4
		bcs.w	locret_23324
		cmp.w	d1,d4
		bcc.w	locret_23324
		move.w	$14(a1),d4
		cmp.w	d2,d4
		bcs.w	locret_23324
		cmp.w	d3,d4
		bcc.w	locret_23324
		bsr.w	sub_23190

locret_23324:

		rts
; End of function sub_2326C

; ---------------------------------------------------------------------------

loc_23326:

		move.w	#$1B,d1
		move.w	#8,d2
		move.w	#9,d3
		move.w	$10(a0),d4
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.w	SolidObjectFull2_1P
		cmpi.w	#-2,d4
		bne.s	loc_2334C
		bsr.s	sub_233CA

loc_2334C:
		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.w	SolidObjectFull2_1P
		cmpi.w	#-2,d4
		bne.s	loc_23362
		bsr.s	sub_233CA

loc_23362:
		lea	(Ani_Spring).l,a1
		jsr	(Animate_Sprite).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_23374:


		move.w	#$13,d1
		move.w	#8,d2
		move.w	#9,d3
		move.w	$10(a0),d4
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.w	SolidObjectFull2_1P
		cmpi.w	#-2,d4
		bne.s	loc_2339E
		subq.w	#4,$14(a1)
		bsr.s	loc_233DA

loc_2339E:
		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.w	SolidObjectFull2_1P
		cmpi.w	#-2,d4
		bne.s	loc_233B8
		subq.w	#4,$14(a1)
		bsr.s	loc_233DA

loc_233B8:
		lea	(Ani_Spring).l,a1
		jsr	(Animate_Sprite).l
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_233CA:

		subq.w	#8,$14(a1)
		tst.b	($FFFFF7C6).w
		beq.s	loc_233DA
		addi.w	#$10,$14(a1)

loc_233DA:

		move.w	#$100,$20(a0)
		move.w	$30(a0),$1A(a1)
		neg.w	$1A(a1)
		cmpi.w	#$1000,$1A(a1)
		bne.s	loc_233F8
		move.w	#$D00,$1A(a1)

loc_233F8:
		move.b	$2C(a0),d0
		bpl.s	loc_23404
		move.w	#0,$18(a1)

loc_23404:
		btst	#0,d0
		beq.s	loc_23444
		move.w	#1,$1C(a1)
		move.b	#1,$27(a1)
		move.b	#0,$20(a1)
		move.b	#0,$30(a1)
		move.b	#4,$31(a1)
		btst	#1,d0
		bne.s	loc_23434
		move.b	#1,$30(a1)

loc_23434:
		btst	#0,$2A(a1)
		beq.s	loc_23444
		neg.b	$27(a1)
		neg.w	$1C(a1)

loc_23444:

		andi.b	#$C,d0
		cmpi.b	#4,d0
		bne.s	loc_2345A
		move.b	#$C,$46(a1)
		move.b	#$D,$47(a1)

loc_2345A:
		cmpi.b	#8,d0
		bne.s	loc_2346C
		move.b	#$E,$46(a1)
		move.b	#$F,$47(a1)

loc_2346C:
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		clr.b	$40(a1)
		move.b	#2,5(a1)
		move.b	#0,$2F(a1)
		moveq	#-$4F,d0
		jmp	(Play_Sound_2).l
; End of function sub_233CA

; ---------------------------------------------------------------------------

loc_23490:

		move.w	#$1B,d1
		move.w	#$10,d2
		move.w	$10(a0),d4
		lea	byte_236EA(pc),a2
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.w	sub_1DD24
		btst	#3,$2A(a0)
		beq.s	loc_234B8
		bsr.s	sub_234E6

loc_234B8:
		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.w	sub_1DD24
		btst	#4,$2A(a0)
		beq.s	loc_234D0
		bsr.s	sub_234E6

loc_234D0:
		lea	(Ani_Spring).l,a1
		jsr	(Animate_Sprite).l
		move.w	$32(a0),d0
		jmp	(Sprite_OnScreen_Test2).l

; =============== S U B R O U T I N E =======================================


sub_234E6:

		btst	#0,$2A(a0)
		bne.s	loc_234FC
		move.w	$10(a0),d0
		subq.w	#4,d0
		cmp.w	$10(a1),d0
		bcs.s	loc_2350A
		rts
; ---------------------------------------------------------------------------

loc_234FC:
		move.w	$10(a0),d0
		addq.w	#4,d0
		cmp.w	$10(a1),d0
		bcc.s	loc_2350A
		rts
; ---------------------------------------------------------------------------

loc_2350A:

		move.w	#$500,$20(a0)
		move.w	$30(a0),$1A(a1)
		move.w	$30(a0),$18(a1)
		addq.w	#6,$14(a1)
		addq.w	#6,$10(a1)
		bset	#0,$2A(a1)
		btst	#0,$2A(a0)
		bne.s	loc_23542
		bclr	#0,$2A(a1)
		subi.w	#$C,$10(a1)
		neg.w	$18(a1)

loc_23542:
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		clr.b	$40(a1)
		move.b	#$10,$20(a1)
		move.b	#2,5(a1)
		move.b	$2C(a0),d0
		btst	#0,d0
		beq.s	loc_235A2
		move.w	#1,$1C(a1)
		move.b	#1,$27(a1)
		move.b	#0,$20(a1)
		move.b	#1,$30(a1)
		move.b	#8,$31(a1)
		btst	#1,d0
		bne.s	loc_23592
		move.b	#3,$30(a1)

loc_23592:
		btst	#0,$2A(a1)
		beq.s	loc_235A2
		neg.b	$27(a1)
		neg.w	$1C(a1)

loc_235A2:

		andi.b	#$C,d0
		cmpi.b	#4,d0
		bne.s	loc_235B8
		move.b	#$C,$46(a1)
		move.b	#$D,$47(a1)

loc_235B8:
		cmpi.b	#8,d0
		bne.s	loc_235CA
		move.b	#$E,$46(a1)
		move.b	#$F,$47(a1)

loc_235CA:
		moveq	#-$4F,d0
		jmp	(Play_Sound_2).l
; End of function sub_234E6

; ---------------------------------------------------------------------------

loc_235D2:

		move.w	#$1B,d1
		move.w	#$10,d2
		move.w	$10(a0),d4
		lea	byte_23706(pc),a2
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.w	sub_1DD24
		cmpi.w	#-2,d4
		bne.s	loc_235F8
		bsr.s	sub_23624

loc_235F8:
		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.w	sub_1DD24
		cmpi.w	#-2,d4
		bne.s	loc_2360E
		bsr.s	sub_23624

loc_2360E:
		lea	(Ani_Spring).l,a1
		jsr	(Animate_Sprite).l
		move.w	$32(a0),d0
		jmp	(Sprite_OnScreen_Test2).l

; =============== S U B R O U T I N E =======================================


sub_23624:

		move.w	#$500,$20(a0)
		move.w	$30(a0),$1A(a1)
		neg.w	$1A(a1)
		move.w	$30(a0),$18(a1)
		subq.w	#6,$14(a1)
		addq.w	#6,$10(a1)
		bset	#0,$2A(a1)
		btst	#0,$2A(a0)
		bne.s	loc_23660
		bclr	#0,$2A(a1)
		subi.w	#$C,$10(a1)
		neg.w	$18(a1)

loc_23660:
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		clr.b	$40(a1)
		move.b	#2,5(a1)
		move.b	$2C(a0),d0
		btst	#0,d0
		beq.s	loc_236BA
		move.w	#1,$1C(a1)
		move.b	#1,$27(a1)
		move.b	#0,$20(a1)
		move.b	#1,$30(a1)
		move.b	#8,$31(a1)
		btst	#1,d0
		bne.s	loc_236AA
		move.b	#3,$30(a1)

loc_236AA:
		btst	#0,$2A(a1)
		beq.s	loc_236BA
		neg.b	$27(a1)
		neg.w	$1C(a1)

loc_236BA:

		andi.b	#$C,d0
		cmpi.b	#4,d0
		bne.s	loc_236D0
		move.b	#$C,$46(a1)
		move.b	#$D,$47(a1)

loc_236D0:
		cmpi.b	#8,d0
		bne.s	loc_236E2
		move.b	#$E,$46(a1)
		move.b	#$F,$47(a1)

loc_236E2:
		moveq	#-$4F,d0
		jmp	(Play_Sound_2).l
; End of function sub_23624

; ---------------------------------------------------------------------------
byte_236EA:	dc.b $10
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $E
		dc.b $C
		dc.b $A
		dc.b 8
		dc.b 6
		dc.b 4
		dc.b 2
		dc.b 0
		dc.b $FE
		dc.b $FC
		dc.b $FC
		dc.b $FC
		dc.b $FC
		dc.b $FC
		dc.b $FC
		dc.b $FC
byte_23706:	dc.b $F4
		dc.b $F0
		dc.b $F0
		dc.b $F0
		dc.b $F0
		dc.b $F0
		dc.b $F0
		dc.b $F0
		dc.b $F0
		dc.b $F0
		dc.b $F0
		dc.b $F0
		dc.b $F2
		dc.b $F4
		dc.b $F6
		dc.b $F8
		dc.b $FA
		dc.b $FC
		dc.b $FE
		dc.b 0
		dc.b 2
		dc.b 4
		dc.b 4
		dc.b 4
		dc.b 4
		dc.b 4
		dc.b 4
		dc.b 4
Ani_Spring:	include "General\Sprites\Level Misc\Anim - Spring.asm"

Map_Spring:	include "General\Sprites\Level Misc\Map - Spring.asm"

Map_2PSpring: include "General\Sprites\Level Misc\Map - 2P Spring.asm"
; ---------------------------------------------------------------------------

Obj_RetractingSpring:

		bsr.w	Obj_Spring
		move.b	$2C(a0),d0
		lsr.w	#3,d0
		andi.w	#$E,d0
		move.w	off_239FA(pc,d0.w),d1
		jmp	off_239FA(pc,d1.w)
; ---------------------------------------------------------------------------
off_239FA:	dc.w loc_23A04-off_239FA

		dc.w loc_23A20-off_239FA
		dc.w loc_23A3C-off_239FA
		dc.w loc_23A58-off_239FA
		dc.w loc_23A88-off_239FA
; ---------------------------------------------------------------------------

loc_23A04:
		move.l	#loc_23A0A,(a0)

loc_23A0A:
		bsr.w	sub_23AB8
		moveq	#0,d0
		move.b	$36(a0),d0
		add.w	$34(a0),d0
		move.w	d0,$14(a0)
		bra.w	loc_22EF4
; ---------------------------------------------------------------------------

loc_23A20:
		move.l	#loc_23A26,(a0)

loc_23A26:
		bsr.w	sub_23AB8
		moveq	#0,d0
		move.b	$36(a0),d0
		add.w	$32(a0),d0
		move.w	d0,$10(a0)
		bra.w	loc_23050
; ---------------------------------------------------------------------------

loc_23A3C:
		move.l	#loc_23A42,(a0)

loc_23A42:
		bsr.w	sub_23AB8
		moveq	#0,d0
		move.b	$36(a0),d0
		add.w	$34(a0),d0
		move.w	d0,$14(a0)
		bra.w	loc_23326
; ---------------------------------------------------------------------------

loc_23A58:
		move.l	#loc_23A5E,(a0)

loc_23A5E:
		bsr.w	sub_23AB8
		moveq	#0,d0
		move.b	$36(a0),d0
		move.w	d0,d1
		btst	#0,$2A(a0)
		bne.s	loc_23A74
		neg.w	d0

loc_23A74:
		add.w	$32(a0),d0
		move.w	d0,$10(a0)
		add.w	$34(a0),d1
		move.w	d1,$14(a0)
		bra.w	loc_23490
; ---------------------------------------------------------------------------

loc_23A88:
		move.l	#loc_23A8E,(a0)

loc_23A8E:
		bsr.w	sub_23AB8
		moveq	#0,d0
		move.b	$36(a0),d0
		move.w	d0,d1
		btst	#0,$2A(a0)
		beq.s	loc_23AA4
		neg.w	d0

loc_23AA4:
		add.w	$32(a0),d0
		move.w	d0,$10(a0)
		add.w	$34(a0),d1
		move.w	d1,$14(a0)
		bra.w	loc_235D2

; =============== S U B R O U T I N E =======================================


sub_23AB8:

		tst.w	$3A(a0)
		beq.s	loc_23AD4
		subq.w	#1,$3A(a0)
		bne.s	locret_23B16
		tst.b	4(a0)
		bpl.s	locret_23B16
		moveq	#$52,d0
		jsr	(Play_Sound_2).l
		bra.s	locret_23B16
; ---------------------------------------------------------------------------

loc_23AD4:
		tst.w	$38(a0)
		beq.s	loc_23AF6
		subi.w	#$800,$36(a0)
		bcc.s	locret_23B16
		move.w	#0,$36(a0)
		move.w	#0,$38(a0)
		move.w	#$3C,$3A(a0)
		bra.s	locret_23B16
; ---------------------------------------------------------------------------

loc_23AF6:
		addi.w	#$800,$36(a0)
		cmpi.w	#$2000,$36(a0)
		bcs.s	locret_23B16
		move.w	#$2000,$36(a0)
		move.w	#1,$38(a0)
		move.w	#$3C,$3A(a0)

locret_23B16:

		rts
; End of function sub_23AB8

; ---------------------------------------------------------------------------
byte_23B18:	dc.b   $C,   8,	  0,   1
		dc.b   $C,   8,	  0,   0
		dc.b   $C,   8,	  0,   1
		dc.b	8,  $C,	  1,   0
		dc.b   $C,   8,	  2,   1
		dc.b   $C,   8,	  3,   1
		dc.b   $C,   8,	  2,   1
		dc.b   $C,   8,	  3,   1
; ---------------------------------------------------------------------------

Obj_2PRetractingSpring:

		jsr	(Create_New_Sprite3).l
		bne.w	loc_23C0E
		move.l	#loc_23ED0,(a1)
		move.l	#Map_2PRetractingSpring,$C(a1)
		move.w	#$391,$A(a1)
		cmpi.b	#$12,($FFFFFE10).w
		bne.s	loc_23B66
		move.l	#Map_2PRetractingSpring_2,$C(a1)

loc_23B66:
		move.b	$2C(a0),d0
		move.b	d0,$2C(a1)
		lsr.b	#2,d0
		andi.w	#$1C,d0
		lea	byte_23B18(pc,d0.w),a2
		move.b	(a2)+,7(a1)
		move.b	(a2)+,6(a1)
		move.b	(a2)+,d0
		move.b	d0,$22(a1)
		bne.s	loc_23B8E
		move.l	#loc_23F2A,(a1)

loc_23B8E:
		andi.b	#-$10,$2C(a0)
		move.b	(a2)+,d1
		or.b	d1,$2C(a0)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		moveq	#0,d2
		moveq	#0,d3
		cmpi.b	#1,d0
		bne.s	loc_23BC0
		moveq	#$C,d2
		btst	#0,$2A(a0)
		bne.s	loc_23BBC
		neg.w	d2

loc_23BBC:
		add.w	d2,$10(a1)

loc_23BC0:
		cmpi.b	#2,d0
		bne.s	loc_23BCC
		moveq	#$B,d3
		add.w	d3,$14(a1)

loc_23BCC:
		cmpi.b	#3,d0
		bne.s	loc_23BD8
		moveq	#-$B,d3
		add.w	d3,$14(a1)

loc_23BD8:
		move.w	d2,$30(a1)
		move.w	d3,$32(a1)
		bclr	#1,$2A(a0)
		beq.s	loc_23BEE
		move.b	#1,$3C(a0)

loc_23BEE:
		move.b	$2A(a0),$2A(a1)
		move.b	4(a0),4(a1)
		ori.b	#4,4(a1)
		move.w	#$200,8(a1)
		move.w	a0,$3E(a1)
		move.w	a1,$3E(a0)

loc_23C0E:
		bsr.w	sub_22D54

loc_23C12:

		move.b	$2C(a0),d0
		lsr.w	#3,d0
		andi.w	#$E,d0
		move.w	off_23C24(pc,d0.w),d1
		jmp	off_23C24(pc,d1.w)
; ---------------------------------------------------------------------------
off_23C24:	dc.w loc_23C34-off_23C24

		dc.w loc_23C50-off_23C24
		dc.w loc_23C6C-off_23C24
		dc.w loc_23C88-off_23C24
		dc.w loc_23CA4-off_23C24
		dc.w loc_23CC0-off_23C24
		dc.w loc_23CA4-off_23C24
		dc.w loc_23CC0-off_23C24
; ---------------------------------------------------------------------------

loc_23C34:
		move.l	#loc_23C3A,(a0)

loc_23C3A:
		bsr.w	sub_23CDC
		moveq	#0,d0
		move.b	$36(a0),d0
		add.w	$34(a0),d0
		move.w	d0,$14(a0)
		bra.w	loc_22F46
; ---------------------------------------------------------------------------

loc_23C50:
		move.l	#loc_23C56,(a0)

loc_23C56:
		bsr.w	sub_23CDC
		moveq	#0,d0
		move.b	$36(a0),d0
		add.w	$32(a0),d0
		move.w	d0,$10(a0)
		bra.w	loc_230DE
; ---------------------------------------------------------------------------

loc_23C6C:
		move.l	#loc_23C72,(a0)

loc_23C72:
		bsr.w	sub_23CDC
		moveq	#0,d0
		move.b	$36(a0),d0
		add.w	$34(a0),d0
		move.w	d0,$14(a0)
		bra.w	loc_23374
; ---------------------------------------------------------------------------

loc_23C88:
		move.l	#loc_23C8E,(a0)

loc_23C8E:
		bsr.w	sub_23CDC
		moveq	#0,d0
		move.b	$36(a0),d0
		add.w	$34(a0),d0
		move.w	d0,$14(a0)
		bra.w	loc_230DE
; ---------------------------------------------------------------------------

loc_23CA4:
		move.l	#loc_23CAA,(a0)

loc_23CAA:
		bsr.w	sub_23CDC
		moveq	#0,d0
		move.b	$36(a0),d0
		add.w	$32(a0),d0
		move.w	d0,$10(a0)
		bra.w	loc_22F46
; ---------------------------------------------------------------------------

loc_23CC0:
		move.l	#loc_23CC6,(a0)

loc_23CC6:
		bsr.w	sub_23CDC
		moveq	#0,d0
		move.b	$36(a0),d0
		add.w	$32(a0),d0
		move.w	d0,$10(a0)
		bra.w	loc_23374

; =============== S U B R O U T I N E =======================================


sub_23CDC:

		tst.b	$2C(a0)
		bmi.s	loc_23D42
		tst.w	$3A(a0)
		beq.s	loc_23CFE
		subq.w	#1,$3A(a0)
		bne.s	locret_23D40
		tst.b	4(a0)
		bpl.s	locret_23D40
		moveq	#$52,d0
		jsr	(Play_Sound_2).l
		bra.s	locret_23D40
; ---------------------------------------------------------------------------

loc_23CFE:
		tst.w	$38(a0)
		beq.s	loc_23D20
		subi.w	#$800,$36(a0)
		bcc.s	locret_23D40
		move.w	#0,$36(a0)
		move.w	#0,$38(a0)
		move.w	#$3C,$3A(a0)
		bra.s	locret_23D40
; ---------------------------------------------------------------------------

loc_23D20:
		addi.w	#$800,$36(a0)
		cmpi.w	#$1800,$36(a0)
		bcs.s	locret_23D40
		move.w	#$1800,$36(a0)
		move.w	#1,$38(a0)
		move.w	#$3C,$3A(a0)

locret_23D40:

		rts
; ---------------------------------------------------------------------------

loc_23D42:
		tst.b	$3C(a0)
		beq.w	loc_23E0C
		tst.w	$3A(a0)
		beq.s	loc_23D62
		subq.w	#1,$3A(a0)
		bne.w	locret_23E0A
		move.w	#0,$38(a0)
		bra.w	locret_23E0A
; ---------------------------------------------------------------------------

loc_23D62:
		tst.w	$38(a0)
		bne.w	loc_23DF0
		tst.w	$36(a0)
		beq.w	locret_23E0A
		subi.w	#$800,$36(a0)
		bhi.w	locret_23E0A
		move.w	#0,$36(a0)
		move.b	$2C(a0),d0
		andi.b	#$F0,d0
		cmpi.b	#$E0,d0
		bne.s	loc_23DBC
		addi.w	#$16,$14(a0)
		bchg	#1,$2A(a0)
		bchg	#1,4(a0)
		andi.b	#$F,$2C(a0)
		ori.b	#-$10,$2C(a0)
		move.l	#loc_23C12,(a0)
		movea.w	$3E(a0),a1
		neg.w	$32(a1)

loc_23DBC:
		cmpi.b	#-$10,d0
		bne.s	loc_23DEE
		subi.w	#$16,$14(a0)
		bchg	#1,$2A(a0)
		bchg	#1,4(a0)
		andi.b	#$F,$2C(a0)
		ori.b	#$E0,$2C(a0)
		move.l	#loc_23C12,(a0)
		movea.w	$3E(a0),a1
		neg.w	$32(a1)

loc_23DEE:
		bra.s	locret_23E0A
; ---------------------------------------------------------------------------

loc_23DF0:
		addi.w	#$800,$36(a0)
		cmpi.w	#$1800,$36(a0)
		bcs.s	locret_23E0A
		move.w	#$1800,$36(a0)
		move.w	#$B4,$3A(a0)

locret_23E0A:

		rts
; ---------------------------------------------------------------------------

loc_23E0C:
		tst.w	$3A(a0)
		beq.s	loc_23E24
		subq.w	#1,$3A(a0)
		bne.w	locret_23ECE
		move.w	#0,$38(a0)
		bra.w	locret_23ECE
; ---------------------------------------------------------------------------

loc_23E24:
		tst.w	$38(a0)
		beq.s	loc_23E44
		subi.w	#$800,$36(a0)
		bcc.w	locret_23ECE
		move.w	#0,$36(a0)
		move.w	#$B4,$3A(a0)
		bra.w	locret_23ECE
; ---------------------------------------------------------------------------

loc_23E44:
		cmpi.w	#$1800,$36(a0)
		beq.w	locret_23ECE
		addi.w	#$800,$36(a0)
		cmpi.w	#$1800,$36(a0)
		bcs.s	locret_23ECE
		move.w	#$1800,$36(a0)
		move.b	$2C(a0),d0
		andi.b	#$F0,d0
		cmpi.b	#$E0,d0
		bne.s	loc_23E9C
		addi.w	#$16,$14(a0)
		bchg	#1,$2A(a0)
		bchg	#1,4(a0)
		andi.b	#$F,$2C(a0)
		ori.b	#$F0,$2C(a0)
		move.l	#loc_23C12,(a0)
		movea.w	$3E(a0),a1
		neg.w	$32(a1)

loc_23E9C:
		cmpi.b	#$F0,d0
		bne.s	locret_23ECE
		subi.w	#$16,$14(a0)
		bchg	#1,$2A(a0)
		bchg	#1,4(a0)
		andi.b	#$F,$2C(a0)
		ori.b	#$E0,$2C(a0)
		move.l	#loc_23C12,(a0)
		movea.w	$3E(a0),a1
		neg.w	$32(a1)

locret_23ECE:

		rts
; End of function sub_23CDC

; ---------------------------------------------------------------------------

loc_23ED0:
		movea.w	$3E(a0),a1
		move.w	$10(a1),d2
		move.w	$14(a1),d3
		add.w	$30(a0),d2
		add.w	$32(a0),d3
		move.w	d2,$10(a0)
		move.w	d3,$14(a0)
		move.b	$2C(a0),d1
		bpl.s	loc_23F06
		andi.w	#$F,d1
		lea	($FFFFF7E0).w,a3
		tst.b	(a3,d1.w)
		beq.s	loc_23F06
		move.w	#1,$38(a1)

loc_23F06:

		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#7,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_23F2A:
		move.b	$2C(a0),d1
		bpl.s	locret_23F48
		andi.w	#$F,d1
		lea	($FFFFF7E0).w,a3
		tst.b	(a3,d1.w)
		beq.s	locret_23F48
		movea.w	$3E(a0),a1
		move.w	#1,$38(a1)

locret_23F48:

		rts
; ---------------------------------------------------------------------------
Map_2PRetractingSpring:	include "General\Sprites\Level Misc\Map - 2P Retracting Spring.asm"
byte_23F74:	dc.b $10
		dc.b $10
		dc.b $20
		dc.b $10
		dc.b $30
		dc.b $10
		dc.b $40
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $20
		dc.b $10
		dc.b $30
		dc.b $10
		dc.b $40
; ---------------------------------------------------------------------------

Obj_Spikes:

		ori.b	#4,4(a0)
		move.w	#$200,8(a0)
		move.b	$2C(a0),d0
		andi.w	#$F0,d0
		lsr.w	#3,d0
		tst.w	($FFFFFFE8).w
		bne.w	loc_24034
		lea	byte_23F74(pc,d0.w),a1
		move.b	(a1)+,7(a0)
		move.b	(a1)+,6(a0)
		move.l	#loc_24090,(a0)
		move.l	#Map_Spikes,$C(a0)
		move.w	#$49C,$A(a0)
		cmpi.b	#4,($FFFFFE10).w
		bne.s	loc_23FD0
		move.w	#$200,$A(a0)

loc_23FD0:
		lsr.w	#1,d0
		move.b	d0,$22(a0)
		cmpi.b	#4,d0
		bcs.s	loc_23FE8
		move.l	#loc_240E2,(a0)
		move.w	#$494,$A(a0)

loc_23FE8:
		move.b	$2A(a0),d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_23FF6
		eori.b	#2,d0

loc_23FF6:
		andi.b	#2,d0
		beq.s	loc_24002
		move.l	#loc_2413E,(a0)

loc_24002:
		move.w	#$20,$3C(a0)
		move.w	$10(a0),$30(a0)
		move.w	$14(a0),$32(a0)
		move.b	$2C(a0),d0
		andi.b	#$F,d0
		add.b	d0,d0
		move.b	d0,$2C(a0)
		rts
; ---------------------------------------------------------------------------
byte_24024:	dc.b   $C,  $C,	$18,  $C, $24,	$C, $30,  $C,  $C,  $C,	 $C, $18,  $C, $24,  $C, $30
; ---------------------------------------------------------------------------

loc_24034:
		lea	byte_24024(pc,d0.w),a1
		move.b	(a1)+,7(a0)
		move.b	(a1)+,6(a0)
		move.l	#loc_2418E,(a0)
		move.l	#Map_2PSpikes,$C(a0)
		move.w	#$391,$A(a0)
		lsr.w	#1,d0
		move.b	d0,$22(a0)
		cmpi.b	#4,d0
		bcs.s	loc_24066
		move.l	#loc_241DC,(a0)

loc_24066:
		btst	#1,$2A(a0)
		beq.s	loc_24074
		move.l	#loc_24234,(a0)

loc_24074:
		move.w	$10(a0),$30(a0)
		move.w	$14(a0),$32(a0)
		move.b	$2C(a0),d0
		andi.b	#$F,d0
		add.b	d0,d0
		move.b	d0,$2C(a0)
		rts
; ---------------------------------------------------------------------------

loc_24090:
		bsr.w	sub_242B6
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		bsr.w	SolidObjectFull
		move.b	$2A(a0),d6
		andi.b	#$18,d6
		beq.s	loc_240D8
		move.b	d6,d0
		andi.b	#8,d0
		beq.s	loc_240CA
		lea	($FFFFB000).w,a1
		bsr.w	sub_24280

loc_240CA:
		andi.b	#$10,d6
		beq.s	loc_240D8
		lea	($FFFFB04A).w,a1
		bsr.w	sub_24280

loc_240D8:

		move.w	$30(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_240E2:
		bsr.w	sub_242B6
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		bsr.w	SolidObjectFull
		swap	d6
		andi.w	#3,d6
		beq.s	loc_24134
		move.b	d6,d0
		andi.b	#1,d0
		beq.s	loc_24120
		lea	($FFFFB000).w,a1
		bsr.w	sub_24280
		bclr	#5,$2A(a0)

loc_24120:
		andi.b	#2,d6
		beq.s	loc_24134
		lea	($FFFFB04A).w,a1
		bsr.w	sub_24280
		bclr	#6,$2A(a0)

loc_24134:

		move.w	$30(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_2413E:
		bsr.w	sub_242B6
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		bsr.w	SolidObjectFull
		swap	d6
		andi.w	#$C,d6
		beq.s	loc_24184
		move.b	d6,d0
		andi.b	#4,d0
		beq.s	loc_24176
		lea	($FFFFB000).w,a1
		bsr.w	sub_24280

loc_24176:
		andi.b	#8,d6
		beq.s	loc_24184
		lea	($FFFFB04A).w,a1
		bsr.w	sub_24280

loc_24184:

		move.w	$30(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_2418E:
		bsr.w	sub_243BA
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#7,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		bsr.w	SolidObjectFull
		move.b	$2A(a0),d6
		andi.b	#$18,d6
		beq.s	loc_241D6
		move.b	d6,d0
		andi.b	#8,d0
		beq.s	loc_241C8
		lea	($FFFFB000).w,a1
		bsr.w	sub_24280

loc_241C8:
		andi.b	#$10,d6
		beq.s	loc_241D6
		lea	($FFFFB04A).w,a1
		bsr.w	sub_24280

loc_241D6:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_241DC:
		bsr.w	sub_243BA
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#7,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		bsr.w	SolidObjectFull
		swap	d6
		andi.w	#3,d6
		beq.s	loc_2422E
		move.b	d6,d0
		andi.b	#1,d0
		beq.s	loc_2421A
		lea	($FFFFB000).w,a1
		bsr.w	sub_24280
		bclr	#5,$2A(a0)

loc_2421A:
		andi.b	#2,d6
		beq.s	loc_2422E
		lea	($FFFFB04A).w,a1
		bsr.w	sub_24280
		bclr	#6,$2A(a0)

loc_2422E:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_24234:
		bsr.w	sub_243BA
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#7,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		bsr.w	SolidObjectFull
		swap	d6
		andi.w	#$C,d6
		beq.s	loc_2427A
		move.b	d6,d0
		andi.b	#4,d0
		beq.s	loc_2426C
		lea	($FFFFB000).w,a1
		bsr.w	sub_24280

loc_2426C:
		andi.b	#8,d6
		beq.s	loc_2427A
		lea	($FFFFB04A).w,a1
		bsr.w	sub_24280

loc_2427A:

		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_24280:

		btst	#1,$2B(a1)
		bne.s	locret_242B4
		tst.b	$34(a1)
		bne.s	locret_242B4
		cmpi.b	#4,5(a1)
		bcc.s	locret_242B4
		move.l	$14(a1),d3
		move.w	$1A(a1),d0
		ext.l	d0
		asl.l	#8,d0
		sub.l	d0,d3
		move.l	d3,$14(a1)
		movea.l	a0,a2
		movea.l	a1,a0
		jsr	(HurtSonic2).l
		movea.l	a2,a0

locret_242B4:
		rts
; End of function sub_24280


; =============== S U B R O U T I N E =======================================


sub_242B6:

		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	off_242C4(pc,d0.w),d1
		jmp	off_242C4(pc,d1.w)
; End of function sub_242B6

; ---------------------------------------------------------------------------
off_242C4:	dc.w locret_242CC-off_242C4

		dc.w loc_242CE-off_242C4
		dc.w loc_242E2-off_242C4
		dc.w loc_24356-off_242C4
; ---------------------------------------------------------------------------

locret_242CC:

		rts
; ---------------------------------------------------------------------------

loc_242CE:
		bsr.w	sub_242F6
		moveq	#0,d0
		move.b	$34(a0),d0
		add.w	$32(a0),d0
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_242E2:
		bsr.w	sub_242F6
		moveq	#0,d0
		move.b	$34(a0),d0
		add.w	$30(a0),d0
		move.w	d0,$10(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_242F6:

		tst.w	$38(a0)
		beq.s	loc_24312
		subq.w	#1,$38(a0)
		bne.s	locret_24354
		tst.b	4(a0)
		bpl.s	locret_24354
		moveq	#$52,d0
		jsr	(Play_Sound_2).l
		bra.s	locret_24354
; ---------------------------------------------------------------------------

loc_24312:
		tst.w	$36(a0)
		beq.s	loc_24334
		subi.w	#$800,$34(a0)
		bcc.s	locret_24354
		move.w	#0,$34(a0)
		move.w	#0,$36(a0)
		move.w	#$3C,$38(a0)
		bra.s	locret_24354
; ---------------------------------------------------------------------------

loc_24334:
		addi.w	#$800,$34(a0)
		cmpi.w	#$2000,$34(a0)
		bcs.s	locret_24354
		move.w	#$2000,$34(a0)
		move.w	#1,$36(a0)
		move.w	#$3C,$38(a0)

locret_24354:

		rts
; End of function sub_242F6

; ---------------------------------------------------------------------------

loc_24356:
		move.b	$2A(a0),d3
		andi.b	#$60,d3
		beq.s	loc_2437C
		move.w	$10(a0),d2
		lea	($FFFFB000).w,a1
		move.b	$3E(a0),d0
		moveq	#5,d6
		bsr.s	sub_2438A
		lea	($FFFFB04A).w,a1
		move.b	$3F(a0),d0
		moveq	#6,d6
		bsr.s	sub_2438A

loc_2437C:
		move.b	($FFFFB02A).w,$3E(a0)
		move.b	($FFFFB074).w,$3F(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_2438A:

		btst	d6,d3
		beq.s	locret_243B8
		cmp.w	$10(a1),d2
		bcs.s	locret_243B8
		btst	#5,d0
		beq.s	locret_243B8
		subq.w	#1,$3A(a0)
		bpl.s	locret_243B8
		move.w	#$10,$3A(a0)
		tst.w	$3C(a0)
		beq.s	locret_243B8
		subq.w	#1,$3C(a0)
		addq.w	#1,$10(a0)
		addq.w	#1,$10(a1)

locret_243B8:
		rts
; End of function sub_2438A


; =============== S U B R O U T I N E =======================================


sub_243BA:

		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_243C8(pc,d0.w),d1
		jmp	word_243C8(pc,d1.w)
; End of function sub_243BA

; ---------------------------------------------------------------------------
word_243C8:	dc.w locret_242CC-word_243C8

		dc.w loc_243CE-word_243C8
		dc.w loc_243E2-word_243C8
; ---------------------------------------------------------------------------

loc_243CE:
		bsr.w	sub_243F6
		moveq	#0,d0
		move.b	$34(a0),d0
		add.w	$32(a0),d0
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_243E2:
		bsr.w	sub_243F6
		moveq	#0,d0
		move.b	$34(a0),d0
		add.w	$30(a0),d0
		move.w	d0,$10(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_243F6:

		tst.w	$38(a0)
		beq.s	loc_24412
		subq.w	#1,$38(a0)
		bne.s	locret_24454
		tst.b	4(a0)
		bpl.s	locret_24454
		moveq	#$52,d0
		jsr	(Play_Sound_2).l
		bra.s	locret_24454
; ---------------------------------------------------------------------------

loc_24412:
		tst.w	$36(a0)
		beq.s	loc_24434
		subi.w	#$800,$34(a0)
		bcc.s	locret_24454
		move.w	#0,$34(a0)
		move.w	#0,$36(a0)
		move.w	#$3C,$38(a0)
		bra.s	locret_24454
; ---------------------------------------------------------------------------

loc_24434:
		addi.w	#$800,$34(a0)
		cmpi.w	#$1800,$34(a0)
		bcs.s	locret_24454
		move.w	#$1800,$34(a0)
		move.w	#1,$36(a0)
		move.w	#$3C,$38(a0)

locret_24454:

		rts
; End of function sub_243F6

; ---------------------------------------------------------------------------
Map_Spikes:	include "General\Sprites\Level Misc\Map - Spikes.asm"

Map_2PSpikes:	include "General\2P Zone\Map - Spikes.asm"


; =============== S U B R O U T I N E =======================================


Init_ArtScaling:
		moveq	#0,d1
		move.w	d1,($FFFFF740).w
		movea.w	d1,a0
		movea.w	d1,a1
		movea.w	d1,a2
		movea.w	d1,a3
		movea.w	d1,a4
		movea.w	d1,a5
		lea	($FFFFE000).w,a6
		move.w	#$F,d1

loc_24618:
		movem.l	a0-a5,-(a6)
		movem.l	a0-a5,-(a6)
		movem.l	a0-a5,-(a6)
		movem.l	a0-a5,-(a6)
		movem.l	a0-a5,-(a6)
		movem.l	a0-a5,-(a6)
		movem.l	a0-a5,-(a6)
		movem.l	a0-a5,-(a6)
		movem.l	a0-a5,-(a6)
		movem.l	a0-a5,-(a6)
		movem.l	a0-a3,-(a6)
		dbf	d1,loc_24618
		rts
; End of function Init_ArtScaling

; ---------------------------------------------------------------------------
word_2464A:	dc.w $100
		dc.w $FC
		dc.w $90
		dc.w $90
		dc.w $40
		dc.w $40
		dc.w $40
		dc.w $3C
		dc.w $3C
		dc.w $3C
		dc.w $3C
		dc.w $3C
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $C
		dc.w $C
		dc.w $C
		dc.w $C

; =============== S U B R O U T I N E =======================================


sub_2468A:
		moveq	#0,d1
		move.b	$40(a0),d1
		cmpi.b	#$1C,d1
		bcs.s	loc_2469A
		move.b	#$1C,d1		; Maximum 28 different "scales"

loc_2469A:
		move.b	d1,$22(a0)	; Scale level correlates with mapping frame
		add.w	d1,d1
		move.w	word_2464A(pc,d1.w),d1
		move.w	($FFFFF740).w,d2
		add.w	d1,d2
		cmpi.w	#$80,d2
		bhi.s	loc_246D2
		sub.w	d1,d2
		movem.l	d1/d5-a0/a2/a4,-(sp)
		lea	($FFFFD000).w,a2
		add.w	d2,d0
		move.w	d0,$A(a0)
		lsl.w	#5,d2
		adda.w	d2,a2
		bsr.s	sub_246DA
		movem.l	(sp)+,d1/d5-a0/a2/a4
		add.w	d1,($FFFFF740).w
		rts
; ---------------------------------------------------------------------------
		rts
; ---------------------------------------------------------------------------

loc_246D2:
		bclr	#7,4(a0)
		rts
; End of function sub_2468A


; =============== S U B R O U T I N E =======================================


sub_246DA:
		moveq	#0,d0
		move.b	$40(a0),d0		; Scale factor
		moveq	#0,d1
		move.b	$20(a0),d1
		movea.l	$42(a0),a1		; Scaled art address
		ror.w	#4,d1
		adda.l	d1,a1
		movea.l	a1,a0
		adda.w	#$1000,a0
		addi.w	#4,d0
		move.w	d0,d4
		lsr.w	#3,d4
		move.w	d0,d5
		ror.w	#3,d5
		andi.w	#$E000,d5
		move.w	#$F0,d6
		swap	d6
		move.w	#$F,d7
		swap	d7
		tst.w	d4
		beq.w	loc_249BA		; If modified scale factor smaller than 8, branch
		cmpi.w	#1,d4
		bne.s	loc_2472A		; If modified scale factor is not between 8-$10, branch
		tst.w	d5
		beq.w	loc_2493E		; If modified scale factor is 8, branch
		cmpi.w	#$2000,d5
		beq.w	loc_248B8		; If modified scale factor is 9, branch

loc_2472A:
		move.w	d4,d2			; All other instances. Scale factor/8 to d2
		swap	d2
		move.w	d5,d2
		lsr.l	#8,d2			; Combine with other scale factor to create final result: Scale factor << 5
		move.l	#$400000,d0
		divu.w	d2,d0
		lsr.w	#8,d0
		lsr.w	#3,d0
		subq.w	#1,d0			; Divide 400000 by modified scale factor << 5, subtract 1
		movea.w	d0,a5			; Note the result in a5
		moveq	#0,d2
		moveq	#0,d3
		lea	loc_2479C(pc),a6

loc_2474A:
		move.w	#$1F,d7

loc_2474E:
		swap	d7
		swap	d3
		move.w	#0,d2
		move.w	#0,d3
		movea.l	a2,a4
		move.w	a5,d6
		bmi.s	loc_24770

loc_24760:
		swap	d6
		jsr	(a6)
		swap	d6
		dbf	d6,loc_24760
		cmpi.w	#$40,d2
		bcc.s	loc_24778

loc_24770:
		swap	d6
		jsr	sub_24802(pc)
		swap	d6

loc_24778:
		swap	d3
		add.w	d5,d3
		bcc.s	loc_24782
		adda.w	#$40,a1

loc_24782:
		move.w	d4,d0
		lsl.w	#6,d0
		adda.w	d0,a1
		cmpa.l	a0,a1
		bcc.s	locret_2479A
		addq.w	#4,a2
		swap	d7
		dbf	d7,loc_2474E
		lea	$380(a2),a2
		bra.s	loc_2474A
; ---------------------------------------------------------------------------

locret_2479A:
		rts
; ---------------------------------------------------------------------------

loc_2479C:
		move.b	(a1,d2.w),d0
		add.w	d5,d3
		addx.w	d4,d2
		move.b	(a1,d2.w),d1
		add.w	d5,d3
		addx.w	d4,d2
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		move.b	(a1,d2.w),d0
		add.w	d5,d3
		addx.w	d4,d2
		move.b	(a1,d2.w),d1
		add.w	d5,d3
		addx.w	d4,d2
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		move.b	(a1,d2.w),d0
		add.w	d5,d3
		addx.w	d4,d2
		move.b	(a1,d2.w),d1
		add.w	d5,d3
		addx.w	d4,d2
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		move.b	(a1,d2.w),d0
		add.w	d5,d3
		addx.w	d4,d2
		move.b	(a1,d2.w),d1
		add.w	d5,d3
		addx.w	d4,d2
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		lea	$7C(a4),a4
		rts
; End of function sub_246DA


; =============== S U B R O U T I N E =======================================


sub_24802:
		move.b	(a1,d2.w),d0
		add.w	d5,d3
		addx.w	d4,d2
		cmpi.w	#$40,d2
		bcs.s	loc_24814
		move.b	#0,d0

loc_24814:
		move.b	(a1,d2.w),d1
		add.w	d5,d3
		addx.w	d4,d2
		cmpi.w	#$40,d2
		bcs.s	loc_24826
		move.b	#0,d1

loc_24826:
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		move.b	(a1,d2.w),d0
		add.w	d5,d3
		addx.w	d4,d2
		cmpi.w	#$40,d2
		bcs.s	loc_24840
		move.b	#0,d0

loc_24840:
		move.b	(a1,d2.w),d1
		add.w	d5,d3
		addx.w	d4,d2
		cmpi.w	#$40,d2
		bcs.s	loc_24852
		move.b	#0,d1

loc_24852:
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		move.b	(a1,d2.w),d0
		add.w	d5,d3
		addx.w	d4,d2
		cmpi.w	#$40,d2
		bcs.s	loc_2486C
		move.b	#0,d0

loc_2486C:
		move.b	(a1,d2.w),d1
		add.w	d5,d3
		addx.w	d4,d2
		cmpi.w	#$40,d2
		bcs.s	loc_2487E
		move.b	#0,d1

loc_2487E:
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		move.b	(a1,d2.w),d0
		add.w	d5,d3
		addx.w	d4,d2
		cmpi.w	#$40,d2
		bcs.s	loc_24898
		move.b	#0,d0

loc_24898:
		move.b	(a1,d2.w),d1
		add.w	d5,d3
		addx.w	d4,d2
		cmpi.w	#$40,d2
		bcs.s	loc_248AA
		move.b	#0,d1

loc_248AA:
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		lea	$7C(a4),a4
		rts
; End of function sub_24802

; ---------------------------------------------------------------------------

loc_248B8:
		moveq	#0,d3
		lsl.w	#6,d4
		lea	loc_24906(pc),a6
		move.w	#1,d7

loc_248C4:
		swap	d7
		move.w	#$1F,d6

loc_248CA:
		swap	d6
		movea.l	a1,a3
		movea.l	a2,a4
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		move.b	(a3)+,d0
		and.b	d6,d0
		move.b	d0,(a4)+
		add.w	d5,d3
		bcc.s	loc_248EC
		lea	$40(a1),a1

loc_248EC:
		adda.w	d4,a1
		cmpa.l	a0,a1
		bcc.s	locret_24904
		addq.w	#4,a2
		swap	d6
		dbf	d6,loc_248CA
		lea	$380(a2),a2
		swap	d7
		dbf	d7,loc_248C4

locret_24904:
		rts
; ---------------------------------------------------------------------------

loc_24906:
		move.b	(a3)+,d0
		move.b	(a3)+,d1
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		move.b	(a3)+,d0
		move.b	(a3)+,d1
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		move.b	(a3)+,d0
		move.b	(a3)+,d1
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		move.b	(a3)+,d0
		move.b	(a3)+,d1
		addq.w	#1,a3
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		lea	$7C(a4),a4
		rts
; ---------------------------------------------------------------------------

loc_2493E:
		moveq	#0,d3
		lsl.w	#6,d4
		lea	loc_24984(pc),a6
		move.w	#1,d7

loc_2494A:
		swap	d7
		move.w	#$1F,d6

loc_24950:
		swap	d6
		movea.l	a1,a3
		movea.l	a2,a4
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		add.w	d5,d3
		bcc.s	loc_2496E
		lea	$40(a1),a1

loc_2496E:
		adda.w	d4,a1
		addq.w	#4,a2
		swap	d6
		dbf	d6,loc_24950
		lea	$380(a2),a2
		swap	d7
		dbf	d7,loc_2494A
		rts
; ---------------------------------------------------------------------------

loc_24984:
		move.b	(a3)+,d0
		move.b	(a3)+,d1
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		move.b	(a3)+,d0
		move.b	(a3)+,d1
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		move.b	(a3)+,d0
		move.b	(a3)+,d1
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		move.b	(a3)+,d0
		move.b	(a3)+,d1
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		lea	$7C(a4),a4
		rts
; ---------------------------------------------------------------------------

loc_249BA:
		cmpi.w	#$E000,d5
		bne.w	loc_24A3C
		lea	loc_24A10(pc),a6
		moveq	#0,d3
		lsl.w	#6,d4
		move.w	#2,d7

loc_249CE:
		swap	d7
		move.w	#$1F,d6

loc_249D4:
		swap	d6
		movea.l	a1,a3
		movea.l	a2,a4
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		move.b	(a3),(a4)
		add.w	d5,d3
		bcc.s	loc_249F6
		lea	$40(a1),a1

loc_249F6:
		adda.w	d4,a1
		cmpa.l	a0,a1
		bcc.s	locret_24A0E
		addq.w	#4,a2
		swap	d6
		dbf	d6,loc_249D4
		lea	$580(a2),a2
		swap	d7
		dbf	d7,loc_249CE

locret_24A0E:
		rts
; ---------------------------------------------------------------------------

loc_24A10:
		move.b	(a3)+,(a4)+
		move.b	(a3)+,d0
		move.b	(a3)+,d1
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		move.b	(a3)+,d0
		move.b	(a3)+,d1
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		move.b	(a3)+,d0
		move.b	(a3)+,d1
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		lea	$7C(a4),a4
		rts
; ---------------------------------------------------------------------------

loc_24A3C:
		cmpi.w	#$C000,d5
		bne.w	loc_24AC6
		moveq	#0,d3
		lsl.w	#6,d4
		lea	loc_24AA4(pc),a6
		move.w	#3,d7

loc_24A50:
		swap	d7
		move.w	#$1F,d6

loc_24A56:
		swap	d6
		movea.l	a1,a3
		movea.l	a2,a4
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		jsr	(a6)
		move.b	(a3)+,(a4)+
		move.b	(a3)+,d0
		move.b	(a3)+,d1
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		move.b	(a3),d0
		move.b	d0,(a4)
		add.w	d5,d3
		bcc.s	loc_24A8A
		lea	$40(a1),a1

loc_24A8A:
		adda.w	d4,a1
		cmpa.l	a0,a1
		bcc.s	locret_24AA2
		addq.w	#4,a2
		swap	d6
		dbf	d6,loc_24A56
		lea	$580(a2),a2
		swap	d7
		dbf	d7,loc_24A50

locret_24AA2:
		rts
; ---------------------------------------------------------------------------

loc_24AA4:
		move.b	(a3)+,(a4)+
		move.b	(a3)+,d0
		move.b	(a3)+,d1
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		move.b	(a3)+,(a4)+
		move.b	(a3)+,d0
		move.b	(a3)+,d1
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		lea	$7C(a4),a4
		rts
; ---------------------------------------------------------------------------

loc_24AC6:
		cmpi.w	#$A000,d5
		bne.w	loc_24B60
		moveq	#0,d3
		lsl.w	#6,d4
		lea	loc_24B4A(pc),a5
		lea	loc_24B32(pc),a6
		move.w	#3,d7

loc_24ADE:
		swap	d7
		move.w	#$1F,d6

loc_24AE4:
		swap	d6
		movea.l	a1,a3
		movea.l	a2,a4
		jsr	(a5)
		jsr	(a6)
		jsr	(a5)
		jsr	(a6)
		jsr	(a5)
		jsr	(a6)
		jsr	(a5)
		jsr	(a6)
		jsr	(a5)
		jsr	(a6)
		jsr	(a5)
		jsr	(a6)
		move.w	(a3)+,(a4)+
		move.b	(a3)+,d0
		move.b	(a3)+,d1
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		add.w	d5,d3
		bcc.s	loc_24B18
		lea	$40(a1),a1

loc_24B18:
		adda.w	d4,a1
		cmpa.l	a0,a1
		bcc.s	locret_24B30
		addq.w	#4,a2
		swap	d6
		dbf	d6,loc_24AE4
		lea	$780(a2),a2
		swap	d7
		dbf	d7,loc_24ADE

locret_24B30:
		rts
; ---------------------------------------------------------------------------

loc_24B32:
		move.b	(a3)+,(a4)+
		move.b	(a3)+,(a4)+
		move.b	(a3)+,d0
		move.b	(a3)+,d1
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		move.b	(a3)+,(a4)+
		lea	$7C(a4),a4
		rts
; ---------------------------------------------------------------------------

loc_24B4A:
		move.w	(a3)+,(a4)+
		move.b	(a3)+,d0
		move.b	(a3)+,d1
		and.b	d6,d0
		and.b	d7,d1
		or.b	d1,d0
		move.b	d0,(a4)+
		move.b	(a3)+,(a4)+
		lea	$7C(a4),a4
		rts
; ---------------------------------------------------------------------------

loc_24B60:
		moveq	#0,d3
		lsl.w	#6,d4
		moveq	#3,d7

loc_24B66:
		move.w	#$1F,d6

loc_24B6A:
		movea.l	a1,a3
		movea.l	a2,a4
		move.l	(a3)+,(a4)
		lea	$80(a4),a4
		move.l	(a3)+,(a4)
		lea	$80(a4),a4
		move.l	(a3)+,(a4)
		lea	$80(a4),a4
		move.l	(a3)+,(a4)
		lea	$80(a4),a4
		move.l	(a3)+,(a4)
		lea	$80(a4),a4
		move.l	(a3)+,(a4)
		lea	$80(a4),a4
		move.l	(a3)+,(a4)
		lea	$80(a4),a4
		move.l	(a3)+,(a4)
		lea	$80(a4),a4
		move.l	(a3)+,(a4)
		lea	$80(a4),a4
		move.l	(a3)+,(a4)
		lea	$80(a4),a4
		move.l	(a3)+,(a4)
		lea	$80(a4),a4
		move.l	(a3)+,(a4)
		lea	$80(a4),a4
		move.l	(a3)+,(a4)
		lea	$80(a4),a4
		move.l	(a3)+,(a4)
		lea	$80(a4),a4
		move.l	(a3)+,(a4)
		lea	$80(a4),a4
		move.l	(a3)+,(a4)
		lea	$80(a4),a4
		add.w	d5,d3
		bcc.s	loc_24BD6
		lea	$40(a1),a1

loc_24BD6:
		adda.w	d4,a1
		addq.w	#4,a2
		dbf	d6,loc_24B6A
		lea	$780(a2),a2
		dbf	d7,loc_24B66
		rts
; ---------------------------------------------------------------------------
Map_ScaledArt:	include "General\Sprites\Level Misc\Map - Scaled Art.asm"

; ---------------------------------------------------------------------------

Obj_0E:

		lea	($FFFFB000).w,a1
		bsr.s	sub_24D9A
		lea	($FFFFB04A).w,a1
		bsr.s	sub_24D9A
		move.w	$10(a0),d0
		andi.w	#$FF80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_24D88
		rts
; ---------------------------------------------------------------------------

loc_24D88:
		move.w	$48(a0),d0
		beq.s	loc_24D94
		movea.w	d0,a2
		bclr	#7,(a2)

loc_24D94:
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_24D9A:

		btst	#1,$2A(a1)
		bne.w	locret_24E32
		move.w	$10(a1),d0
		addi.w	#$10,d0
		sub.w	$10(a0),d0
		bcs.w	locret_24E32
		cmpi.w	#$20,d0
		bge.w	locret_24E32
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		cmpi.w	#-$14,d0
		blt.s	locret_24E32
		cmpi.w	#$20,d0
		bgt.s	locret_24E32
		tst.b	$2E(a1)
		bne.s	locret_24E32
		btst	#0,$2A(a0)
		bne.s	loc_24DEE
		cmpi.w	#$400,$18(a1)
		blt.s	locret_24E32
		addi.w	#$400,$18(a1)
		bra.s	loc_24DFC
; ---------------------------------------------------------------------------

loc_24DEE:
		cmpi.w	#-$400,$18(a1)
		bgt.s	locret_24E32
		subi.w	#$400,$18(a1)

loc_24DFC:
		move.w	#-$700,$1A(a1)
		bset	#1,$2A(a1)
		move.b	#2,5(a1)
		move.w	#1,$1C(a1)
		move.b	#1,$27(a1)
		move.b	#0,$20(a1)
		move.b	#0,$30(a1)
		move.b	#4,$31(a1)
		move.b	#5,$2D(a1)

locret_24E32:

		rts
; End of function sub_24D9A

; ---------------------------------------------------------------------------
byte_24E34:	dc.b $20
		dc.b 8
		dc.b 0
		dc.b 0
		dc.b $20
		dc.b 8
		dc.b 1
		dc.b 0
; ---------------------------------------------------------------------------

Obj_LBZMovingPlatform:

		move.l	#Map_LBZMovingPlatform,$C(a0)
		move.w	#$43C3,$A(a0)
		move.b	#4,4(a0)
		move.w	#$180,8(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		bpl.s	loc_24E6E
		andi.w	#$7F,d0
		lsl.w	#4,d0
		move.w	d0,$38(a0)
		moveq	#$17,d0
		move.b	d0,$2C(a0)

loc_24E6E:
		lsr.w	#2,d0
		andi.w	#$1C,d0
		lea	byte_24E34(pc,d0.w),a2
		move.b	(a2)+,7(a0)
		move.b	(a2)+,6(a0)
		move.b	(a2)+,$22(a0)
		move.w	$10(a0),$30(a0)
		move.w	$10(a0),$32(a0)
		move.w	$14(a0),$34(a0)
		move.b	$2A(a0),$2E(a0)
		move.w	#$280,$42(a0)
		move.w	$10(a0),$44(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		subq.w	#8,d0
		bcs.s	loc_24EDE
		cmpi.w	#4,d0
		bcc.s	loc_24ED2
		lsl.w	#2,d0
		lea	($FFFFFE9A).w,a2
		lea	(a2,d0.w),a2
		tst.w	(a2)
		bpl.s	loc_24EDE
		bchg	#0,$2E(a0)
		bra.s	loc_24EDE
; ---------------------------------------------------------------------------

loc_24ED2:
		move.w	#$380,$42(a0)
		addi.w	#$100,$44(a0)

loc_24EDE:

		move.b	$2C(a0),d0
		andi.b	#$F,d0
		add.b	d0,d0
		move.b	d0,$2C(a0)
		move.l	#loc_24EF2,(a0)

loc_24EF2:
		move.w	$10(a0),-(sp)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	off_24F58(pc,d0.w),d1
		jsr	off_24F58(pc,d1.w)
		move.w	(sp)+,d4
		tst.b	4(a0)
		bpl.s	loc_24F1C
		moveq	#0,d1
		move.b	7(a0),d1
		move.w	#9,d3
		jsr	(SolidObjectTop).l

loc_24F1C:

		move.w	$44(a0),d0
		andi.w	#$FF80,d0
		sub.w	($FFFFF7DA).w,d0
		cmp.w	$42(a0),d0
		bhi.w	loc_24F36
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_24F36:
		tst.b	$3D(a0)
		beq.s	loc_24F46
		movea.w	$3E(a0),a1
		jsr	(Delete_Referenced_Sprite).l

loc_24F46:
		move.w	$48(a0),d0
		beq.s	loc_24F52
		movea.w	d0,a2
		bclr	#7,(a2)

loc_24F52:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
off_24F58:	dc.w loc_24F90-off_24F58
		dc.w loc_24FC8-off_24F58
		dc.w loc_24FD4-off_24F58
		dc.w loc_24FF6-off_24F58
		dc.w loc_25002-off_24F58
		dc.w loc_25024-off_24F58
		dc.w loc_2503E-off_24F58
		dc.w loc_2505C-off_24F58
		dc.w loc_25278-off_24F58
		dc.w loc_2528A-off_24F58
		dc.w loc_2529A-off_24F58
		dc.w loc_252AA-off_24F58
		dc.w loc_250AC-off_24F58
		dc.w loc_25108-off_24F58
		dc.w loc_25132-off_24F58
off_24F76:	dc.w loc_24F90-off_24F76
		dc.w loc_24FC8-off_24F76
		dc.w loc_24FD4-off_24F76
		dc.w loc_24FF6-off_24F76
		dc.w loc_25002-off_24F76
		dc.w loc_25024-off_24F76
		dc.w loc_2503E-off_24F76
		dc.w loc_251E4-off_24F76
		dc.w loc_25278-off_24F76
		dc.w loc_2528A-off_24F76
		dc.w loc_2529A-off_24F76
		dc.w loc_252AA-off_24F76
		dc.w loc_250AC-off_24F76
; ---------------------------------------------------------------------------

loc_24F90:

		move.b	$2A(a0),d0
		andi.b	#$18,d0
		bne.s	loc_24FA6
		tst.b	$3A(a0)
		beq.s	loc_24FB2
		subq.b	#4,$3A(a0)
		bra.s	loc_24FB2
; ---------------------------------------------------------------------------

loc_24FA6:
		cmpi.b	#$40,$3A(a0)
		beq.s	loc_24FB2
		addq.b	#4,$3A(a0)

loc_24FB2:

		move.b	$3A(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#6,d0
		add.w	$34(a0),d0
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_24FC8:

		move.w	#$40,d1
		moveq	#0,d0
		move.b	($FFFFFE78).w,d0
		bra.s	sub_24FDE
; ---------------------------------------------------------------------------

loc_24FD4:

		move.w	#$80,d1
		moveq	#0,d0
		move.b	($FFFFFE8C).w,d0

; =============== S U B R O U T I N E =======================================


sub_24FDE:

		btst	#0,$2A(a0)
		beq.s	loc_24FEA
		neg.w	d0
		add.w	d1,d0

loc_24FEA:
		move.w	$30(a0),d1
		add.w	d0,d1
		move.w	d1,$10(a0)
		rts
; End of function sub_24FDE

; ---------------------------------------------------------------------------

loc_24FF6:

		move.w	#$40,d1
		moveq	#0,d0
		move.b	($FFFFFE78).w,d0
		bra.s	loc_2500C
; ---------------------------------------------------------------------------

loc_25002:

		move.w	#$80,d1
		moveq	#0,d0
		move.b	($FFFFFE8C).w,d0

loc_2500C:

		btst	#0,$2A(a0)
		beq.s	loc_25018
		neg.w	d0
		add.w	d1,d0

loc_25018:
		move.w	$34(a0),d1
		sub.w	d0,d1
		move.w	d1,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_25024:

		move.w	#$80,d1
		moveq	#0,d0
		move.b	($FFFFFE8C).w,d0
		bsr.s	sub_24FDE
		move.w	#$40,d1
		moveq	#0,d0
		move.b	($FFFFFE8C).w,d0
		lsr.b	#1,d0
		bra.s	loc_2500C
; ---------------------------------------------------------------------------

loc_2503E:

		move.w	#$80,d1
		moveq	#0,d0
		move.b	($FFFFFE8C).w,d0
		neg.w	d0
		add.w	d1,d0
		bsr.s	sub_24FDE
		move.w	#$40,d1
		moveq	#0,d0
		move.b	($FFFFFE8C).w,d0
		lsr.b	#1,d0
		bra.s	loc_2500C
; ---------------------------------------------------------------------------

loc_2505C:
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		bne.s	loc_2507C
		move.w	$38(a0),d2
		move.w	$36(a0),d1
		beq.s	locret_250AA
		subq.w	#4,d1
		bcc.s	loc_25076
		moveq	#0,d1

loc_25076:
		move.w	d1,$36(a0)
		bra.s	loc_25090
; ---------------------------------------------------------------------------

loc_2507C:
		move.w	$38(a0),d2
		move.w	$36(a0),d1
		addq.w	#2,d1
		cmp.w	d2,d1
		bcs.s	loc_2508C
		move.w	d2,d1

loc_2508C:
		move.w	d1,$36(a0)

loc_25090:
		move.w	$32(a0),d0
		sub.w	d1,d0
		move.w	d0,$10(a0)
		move.w	d0,$30(a0)
		lsr.w	#1,d1
		move.w	$34(a0),d0
		sub.w	d1,d0
		move.w	d0,$14(a0)

locret_250AA:
		rts
; ---------------------------------------------------------------------------

loc_250AC:

		move.w	#$7F,d2
		tst.b	$3C(a0)
		bne.s	loc_250D2
		move.w	$40(a0),d1
		addq.w	#4,d1
		move.w	d1,$40(a0)
		add.w	d1,$36(a0)
		cmp.b	$36(a0),d2
		bhi.s	loc_250EC
		move.b	#1,$3C(a0)
		bra.s	loc_250EC
; ---------------------------------------------------------------------------

loc_250D2:
		move.w	$40(a0),d1
		subq.w	#4,d1
		move.w	d1,$40(a0)
		add.w	d1,$36(a0)
		cmp.b	$36(a0),d2
		bls.s	loc_250EC
		move.b	#0,$3C(a0)

loc_250EC:

		moveq	#0,d0
		move.b	$36(a0),d0
		btst	#0,$2A(a0)
		beq.s	loc_250FE
		neg.w	d0
		add.w	d2,d0

loc_250FE:
		add.w	$30(a0),d0
		move.w	d0,$10(a0)
		rts
; ---------------------------------------------------------------------------

loc_25108:
		tst.w	$3A(a0)
		bne.s	loc_25120
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	locret_2511E
		move.w	#$1E,$3A(a0)

locret_2511E:

		rts
; ---------------------------------------------------------------------------

loc_25120:
		subq.w	#1,$3A(a0)
		bne.s	locret_2511E
		move.w	#$20,$3A(a0)
		addq.b	#2,$2C(a0)
		rts
; ---------------------------------------------------------------------------

loc_25132:
		tst.w	$3A(a0)
		beq.s	loc_25160
		subq.w	#1,$3A(a0)
		bne.s	loc_25160
		bclr	#3,$2A(a0)
		beq.s	loc_2514C
		lea	($FFFFB000).w,a1
		bsr.s	sub_25194

loc_2514C:
		bclr	#4,$2A(a0)
		beq.s	loc_2515A
		lea	($FFFFB04A).w,a1
		bsr.s	sub_25194

loc_2515A:
		move.l	#loc_251AE,(a0)

loc_25160:

		move.l	$14(a0),d3
		move.w	$1A(a0),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d3
		move.l	d3,$14(a0)
		addi.w	#$38,$1A(a0)
		move.w	($FFFFEE1A).w,d0
		addi.w	#$120,d0
		cmp.w	$14(a0),d0
		bcc.s	locret_25192
		move.w	#$7F00,$10(a0)
		move.w	#$7F00,$44(a0)

locret_25192:
		rts

; =============== S U B R O U T I N E =======================================


sub_25194:

		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		move.b	#2,5(a1)
		move.w	$1A(a0),$1A(a1)
		rts
; End of function sub_25194

; ---------------------------------------------------------------------------

loc_251AE:
		move.l	$14(a0),d3
		move.w	$1A(a0),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d3
		move.l	d3,$14(a0)
		addi.w	#$38,$1A(a0)
		move.w	($FFFFEE1A).w,d0
		addi.w	#$120,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_251E0
		move.w	#$7F00,$10(a0)
		move.w	#$7F00,$44(a0)

loc_251E0:
		bra.w	loc_24F1C
; ---------------------------------------------------------------------------

loc_251E4:
		tst.b	$3C(a0)
		bne.s	loc_25202
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	locret_25200
		move.b	#1,$3C(a0)
		move.b	#$C,$1E(a0)

locret_25200:
		rts
; ---------------------------------------------------------------------------

loc_25202:
		jsr	(MoveSprite2).l
		moveq	#8,d1
		move.w	$34(a0),d0
		subi.w	#$80,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_2521E
		neg.w	d1
		add.w	d1,$1A(a0)

loc_2521E:
		jsr	(ObjHitCeiling).l
		tst.w	d1
		bpl.s	loc_25236
		sub.w	d1,$14(a0)
		clr.b	$3C(a0)
		clr.w	$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_25236:
		btst	#3,$2A(a0)
		beq.s	loc_25256
		move.l	a0,-(sp)
		lea	($FFFFB000).w,a0
		jsr	(sub_F846).l
		tst.w	d1
		bpl.s	loc_25254
		jsr	(Kill_Character).l

loc_25254:
		movea.l	(sp)+,a0

loc_25256:
		btst	#4,$2A(a0)
		beq.s	locret_25276
		move.l	a0,-(sp)
		lea	($FFFFB04A).w,a0
		jsr	(sub_F846).l
		tst.w	d1
		bpl.s	loc_25274
		jsr	(Kill_Character).l

loc_25274:
		movea.l	(sp)+,a0

locret_25276:
		rts
; ---------------------------------------------------------------------------

loc_25278:

		move.w	#$10,d1
		moveq	#0,d0
		move.b	($FFFFFE98).w,d0
		lsr.w	#1,d0
		move.w	($FFFFFE9A).w,d3
		bra.s	loc_252B8
; ---------------------------------------------------------------------------

loc_2528A:

		move.w	#$30,d1
		moveq	#0,d0
		move.b	($FFFFFE9C).w,d0
		move.w	($FFFFFE9E).w,d3
		bra.s	loc_252B8
; ---------------------------------------------------------------------------

loc_2529A:

		move.w	#$50,d1
		moveq	#0,d0
		move.b	($FFFFFEA0).w,d0
		move.w	($FFFFFEA2).w,d3
		bra.s	loc_252B8
; ---------------------------------------------------------------------------

loc_252AA:

		move.w	#$70,d1
		moveq	#0,d0
		move.b	($FFFFFEA4).w,d0
		move.w	($FFFFFEA6).w,d3

loc_252B8:

		tst.w	d3
		bne.s	loc_252C6
		addq.b	#1,$2E(a0)
		andi.b	#3,$2E(a0)

loc_252C6:
		move.b	$2E(a0),d2
		andi.b	#3,d2
		bne.s	loc_252E6
		sub.w	d1,d0
		add.w	$30(a0),d0
		move.w	d0,$10(a0)
		neg.w	d1
		add.w	$34(a0),d1
		move.w	d1,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_252E6:
		subq.b	#1,d2
		bne.s	loc_25304
		subq.w	#1,d1
		sub.w	d1,d0
		neg.w	d0
		add.w	$34(a0),d0
		move.w	d0,$14(a0)
		addq.w	#1,d1
		add.w	$30(a0),d1
		move.w	d1,$10(a0)
		rts
; ---------------------------------------------------------------------------

loc_25304:
		subq.b	#1,d2
		bne.s	loc_25322
		subq.w	#1,d1
		sub.w	d1,d0
		neg.w	d0
		add.w	$30(a0),d0
		move.w	d0,$10(a0)
		addq.w	#1,d1
		add.w	$34(a0),d1
		move.w	d1,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_25322:
		sub.w	d1,d0
		add.w	$34(a0),d0
		move.w	d0,$14(a0)
		neg.w	d1
		add.w	$30(a0),d1
		move.w	d1,$10(a0)
		rts
; ---------------------------------------------------------------------------
Map_LBZMovingPlatform:include "Levels\LBZ\Misc Object Data\Map - Moving Platform.asm"

; ---------------------------------------------------------------------------

Obj_1D_1:
		jsr	(Create_New_Sprite3).l
		bne.w	loc_253BE
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	$2A(a0),$2A(a1)
		move.l	#Map_LBZPlatformUndersideUnused,$C(a1)
		move.w	#$42EA,$A(a1)
		move.b	#4,4(a1)
		move.w	#$180,8(a1)
		move.b	#$20,7(a1)
		move.b	#$10,6(a1)
		move.w	a0,$3E(a1)
		move.l	#loc_253C2,(a1)
		move.w	a1,$3E(a0)
		move.b	#1,$3D(a0)

loc_253BE:
		bra.w	Obj_LBZMovingPlatform
; ---------------------------------------------------------------------------

loc_253C2:
		move.w	$10(a0),d4
		movea.w	$3E(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		sub.w	$10(a1),d4
		bsr.s	sub_253E2
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_253E2:
		lea	$33(a0),a2
		lea	($FFFFB04A).w,a1
		move.w	($FFFFF606).w,d0
		bsr.s	i
		lea	($FFFFB000).w,a1
		subq.w	#1,a2
		move.w	($FFFFF604).w,d0
; End of function sub_253E2


; =============== S U B R O U T I N E =======================================


i:
		tst.b	(a2)
		beq.w	loc_25476
		tst.b	4(a1)
		bpl.s	loc_25456
		cmpi.b	#4,5(a1)
		bcc.s	loc_25456
		andi.b	#$70,d0
		beq.w	loc_25464
		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$12,2(a2)
		andi.w	#$F00,d0
		beq.w	loc_25430
		move.b	#$3C,2(a2)

loc_25430:
		btst	#$A,d0
		beq.s	loc_2543C
		move.w	#-$200,$18(a1)

loc_2543C:
		btst	#$B,d0
		beq.s	loc_25448
		move.w	#$200,$18(a1)

loc_25448:
		move.w	#-$380,$1A(a1)
		bset	#1,$2A(a1)
		rts
; ---------------------------------------------------------------------------

loc_25456:
		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$3C,2(a2)
		rts
; ---------------------------------------------------------------------------

loc_25464:
		sub.w	d4,$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$24,$14(a1)
		rts
; ---------------------------------------------------------------------------

loc_25476:
		tst.b	2(a2)
		beq.s	loc_25484
		subq.b	#1,2(a2)
		bne.w	locret_254E8

loc_25484:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$1C,d0
		cmpi.w	#$38,d0
		bcc.w	locret_254E8
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		subi.w	#$18,d1
		cmpi.w	#$18,d1
		bcc.w	locret_254E8
		tst.b	$2E(a1)
		bne.s	locret_254E8
		cmpi.b	#4,5(a1)
		bcc.s	locret_254E8
		tst.w	($FFFFFE08).w
		bne.s	locret_254E8
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$24,$14(a1)
		move.b	#$14,$20(a1)
		move.b	#1,$2E(a1)
		move.b	#1,(a2)

locret_254E8:
		rts
; End of function i

; ---------------------------------------------------------------------------
Map_LBZPlatformUndersideUnused:	include "Levels\LBZ\Misc Object Data\Map - Floating Platform Underside (Unused).asm"

byte_254FA:	dc.b $20
		dc.b $20
		dc.b 0
		dc.b 0
		dc.b $18
		dc.b $C
		dc.b 0
		dc.b 0
		dc.b $20
		dc.b $14
		dc.b 0
		dc.b 0
; ---------------------------------------------------------------------------

Obj_FloatingPlatform:

		cmpi.w	#0,($FFFFFE10).w
		bne.s	loc_2551C
		move.l	#Map_AIZFloatingPlatform,$C(a0)
		move.w	#$43F7,$A(a0)

loc_2551C:
		cmpi.w	#1,($FFFFFE10).w
		bne.s	loc_25532
		move.l	#Map_AIZFloatingPlatform,$C(a0)
		move.w	#$4440,$A(a0)

loc_25532:
		cmpi.b	#1,($FFFFFE10).w
		bne.s	loc_25548
		move.l	#Map_HCZFloatingPlatform,$C(a0)
		move.w	#$441D,$A(a0)

loc_25548:
		cmpi.b	#2,($FFFFFE10).w
		bne.s	loc_2555E
		move.l	#Map_MGZFloatingPlatform,$C(a0)
		move.w	#$4001,$A(a0)

loc_2555E:
		move.b	#4,4(a0)
		move.w	#$180,8(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#2,d0
		andi.w	#$1C,d0
		lea	byte_254FA(pc,d0.w),a2
		move.b	(a2)+,7(a0)
		move.b	(a2)+,6(a0)
		move.b	(a2)+,$22(a0)
		move.w	$10(a0),$30(a0)
		move.w	$10(a0),$32(a0)
		move.w	$14(a0),$34(a0)
		move.b	$2A(a0),$2E(a0)
		move.w	#$280,$42(a0)
		move.w	$10(a0),$44(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		subq.w	#8,d0
		bcs.s	loc_255E0
		cmpi.w	#4,d0
		bcc.s	loc_255D4
		lsl.w	#2,d0
		lea	($FFFFFE9A).w,a2
		lea	(a2,d0.w),a2
		tst.w	(a2)
		bpl.s	loc_255E0
		bchg	#0,$2E(a0)
		bra.s	loc_255E0
; ---------------------------------------------------------------------------

loc_255D4:
		move.w	#$380,$42(a0)
		addi.w	#$100,$44(a0)

loc_255E0:

		move.b	$2C(a0),d0
		andi.b	#$F,d0
		add.b	d0,d0
		move.b	d0,$2C(a0)
		move.l	#loc_255F4,(a0)

loc_255F4:
		move.w	$10(a0),-(sp)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lea	(off_24F76).l,a1
		move.w	(a1,d0.w),d1
		jsr	(a1,d1.w)
		move.w	(sp)+,d4
		tst.b	4(a0)
		bpl.s	loc_25628
		moveq	#0,d1
		move.b	7(a0),d1
		moveq	#0,d3
		move.b	6(a0),d3
		addq.w	#1,d3
		jsr	(SolidObjectTop).l

loc_25628:
		move.w	$44(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmp.w	$42(a0),d0
		bhi.w	loc_25642
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_25642:
		move.w	$48(a0),d0
		beq.s	loc_2564E
		movea.w	d0,a2
		bclr	#7,(a2)

loc_2564E:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
Map_MGZFloatingPlatform:include "Levels\MGZ\Misc Object Data\Map - Floating Platform.asm"

Map_HCZFloatingPlatform:include "Levels\HCZ\Misc Object Data\Map - Floating Platform.asm"

Map_AIZFloatingPlatform:include "Levels\AIZ\Misc Object Data\Map - Floating Platform.asm"

; ---------------------------------------------------------------------------

Obj_HCZSnakeBlocks:

		move.l	#Map_HCZFloatingPlatform,$C(a0)
		move.w	#$28,$A(a0)
		move.b	#4,4(a0)
		move.w	#$180,8(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.b	#1,$22(a0)
		move.w	$10(a0),$30(a0)
		move.w	$14(a0),$34(a0)
		move.b	$2A(a0),$2E(a0)
		moveq	#1,d0
		move.b	$2C(a0),d1
		bpl.s	loc_25706
		neg.w	d0

loc_25706:
		move.b	d0,$40(a0)
		andi.b	#$7F,d1
		move.b	d1,$26(a0)
		move.w	#$280,$42(a0)
		move.w	$10(a0),$44(a0)
		move.l	#loc_25724,(a0)

loc_25724:
		bsr.s	sub_25770
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		move.w	$44(a0),d0
		andi.w	#$FF80,d0
		sub.w	($FFFFF7DA).w,d0
		cmp.w	$42(a0),d0
		bhi.w	loc_2575E
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2575E:
		move.w	$48(a0),d0
		beq.s	loc_2576A
		movea.w	d0,a2
		bclr	#7,(a2)

loc_2576A:
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_25770:
		move.b	$40(a0),d0
		bpl.s	loc_2579A
		add.b	d0,$26(a0)
		bcs.s	loc_25786
		subq.b	#1,$2E(a0)
		andi.b	#3,$2E(a0)

loc_25786:
		move.w	#$40,d2
		move.b	$26(a0),d0
		cmpi.b	#$80,d0
		bcc.s	loc_257BC
		move.b	#$80,d0
		bra.s	loc_257BC
; ---------------------------------------------------------------------------

loc_2579A:
		add.b	d0,$26(a0)
		bne.s	loc_257AA
		addq.b	#1,$2E(a0)
		andi.b	#3,$2E(a0)

loc_257AA:
		move.w	#$40,d2
		move.b	$26(a0),d0
		cmpi.b	#$80,d0
		bcc.s	loc_257BC
		move.b	#$80,d0

loc_257BC:

		jsr	(GetSineCosine).l
		asr.w	#2,d1
		move.b	$2E(a0),d3
		andi.b	#3,d3
		bne.s	loc_257E2
		add.w	$30(a0),d1
		move.w	d1,$10(a0)
		neg.w	d2
		add.w	$34(a0),d2
		move.w	d2,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_257E2:
		subq.b	#1,d3
		bne.s	loc_257F8
		add.w	$34(a0),d1
		move.w	d1,$14(a0)
		add.w	$30(a0),d2
		move.w	d2,$10(a0)
		rts
; ---------------------------------------------------------------------------

loc_257F8:
		subq.b	#1,d3
		bne.s	loc_25810
		neg.w	d1
		add.w	$30(a0),d1
		move.w	d1,$10(a0)
		add.w	$34(a0),d2
		move.w	d2,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_25810:
		neg.w	d1
		add.w	$34(a0),d1
		move.w	d1,$14(a0)
		neg.w	d2
		add.w	$30(a0),d2
		move.w	d2,$10(a0)
		rts
; End of function sub_25770

; ---------------------------------------------------------------------------
byte_25826:	dc.b $20
		dc.b $20
		dc.b 0
		dc.b 0
		dc.b $20
		dc.b $20
		dc.b 1
		dc.b 0
; ---------------------------------------------------------------------------

Obj_LRZSolidMovingPlatforms:

		move.l	#Map_LRZSolidMovingPlatforms,$C(a0)
		move.w	#$4090,$A(a0)
		move.b	#4,4(a0)
		move.w	#$180,8(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#2,d0
		andi.w	#$1C,d0
		lea	byte_25826(pc,d0.w),a2
		move.b	(a2)+,7(a0)
		move.b	(a2)+,6(a0)
		move.b	(a2)+,$22(a0)
		move.w	$10(a0),$30(a0)
		move.w	$14(a0),$34(a0)
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		add.w	d0,d0
		move.w	off_258BC(pc,d0.w),d0
		lea	off_258BC(pc,d0.w),a1
		move.l	a1,$42(a0)
		move.l	#loc_2588C,(a0)

loc_2588C:
		move.w	$10(a0),-(sp)
		movea.l	$42(a0),a1
		jsr	(a1)
		move.w	(sp)+,d4
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		jsr	(SolidObjectFull).l
		move.w	$30(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------
off_258BC:	dc.w locret_258CE-off_258BC

		dc.w loc_258D0-off_258BC
		dc.w loc_258DC-off_258BC
		dc.w loc_25924-off_258BC
		dc.w loc_258FA-off_258BC
		dc.w loc_25906-off_258BC
		dc.w loc_25938-off_258BC
		dc.w loc_2594C-off_258BC
		dc.w loc_25960-off_258BC
; ---------------------------------------------------------------------------

locret_258CE:

		rts
; ---------------------------------------------------------------------------

loc_258D0:

		moveq	#0,d0
		move.b	($FFFFFE78).w,d0
		subi.w	#$20,d0
		bra.s	loc_258E6
; ---------------------------------------------------------------------------

loc_258DC:

		moveq	#0,d0
		move.b	($FFFFFE8C).w,d0
		subi.w	#$40,d0

loc_258E6:
		btst	#0,$2A(a0)
		beq.s	loc_258F0
		neg.w	d0

loc_258F0:
		add.w	$30(a0),d0
		move.w	d0,$10(a0)
		rts
; ---------------------------------------------------------------------------

loc_258FA:

		moveq	#0,d0
		move.b	($FFFFFE78).w,d0
		subi.w	#$20,d0
		bra.s	loc_25910
; ---------------------------------------------------------------------------

loc_25906:

		moveq	#0,d0
		move.b	($FFFFFE8C).w,d0
		subi.w	#$40,d0

loc_25910:
		btst	#0,$2A(a0)
		beq.s	loc_2591A
		neg.w	d0

loc_2591A:
		add.w	$34(a0),d0
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_25924:

		move.w	#$5F,d2
		bsr.s	sub_25974
		subi.w	#$60,d0
		add.w	$30(a0),d0
		move.w	d0,$10(a0)
		rts
; ---------------------------------------------------------------------------

loc_25938:

		move.w	#$5F,d2
		bsr.s	sub_25974
		subi.w	#$60,d0
		add.w	$34(a0),d0
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_2594C:

		move.w	#$7F,d2
		bsr.s	sub_25974
		subi.w	#$80,d0
		add.w	$30(a0),d0
		move.w	d0,$10(a0)
		rts
; ---------------------------------------------------------------------------

loc_25960:

		move.w	#$7F,d2
		bsr.s	sub_25974
		subi.w	#$80,d0
		add.w	$34(a0),d0
		move.w	d0,$14(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_25974:

		tst.b	$3C(a0)
		bne.s	loc_25996
		move.w	$40(a0),d1
		addq.w	#4,d1
		move.w	d1,$40(a0)
		add.w	d1,$36(a0)
		cmp.b	$36(a0),d2
		bhi.s	loc_259B0
		move.b	#1,$3C(a0)
		bra.s	loc_259B0
; ---------------------------------------------------------------------------

loc_25996:
		move.w	$40(a0),d1
		subq.w	#4,d1
		move.w	d1,$40(a0)
		add.w	d1,$36(a0)
		cmp.b	$36(a0),d2
		bls.s	loc_259B0
		move.b	#0,$3C(a0)

loc_259B0:

		moveq	#0,d0
		move.b	$36(a0),d0
		btst	#0,$2A(a0)
		beq.s	locret_259C2
		neg.w	d0
		add.w	d2,d0

locret_259C2:
		rts
; End of function sub_25974

; ---------------------------------------------------------------------------
Map_LRZSolidMovingPlatforms:include "Levels\LRZ\Misc Object Data\Map - Solid Moving Platforms.asm"


; ---------------------------------------------------------------------------

Obj_DEZFloatingPlatform:

		move.l	#Map_DEZFloatingPlatform,$C(a0)
		move.w	#$233A,$A(a0)
		move.b	#4,4(a0)
		move.w	#$200,8(a0)
		move.b	#$20,7(a0)
		move.b	#$10,6(a0)
		move.w	$10(a0),$30(a0)
		move.w	$14(a0),$34(a0)
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		add.w	d0,d0
		move.w	word_25AB8(pc,d0.w),d0
		lea	word_25AB8(pc,d0.w),a1
		move.l	a1,$42(a0)
		move.l	#loc_25A7E,(a0)

loc_25A7E:
		move.w	$10(a0),-(sp)
		movea.l	$42(a0),a1
		jsr	(a1)
		move.w	(sp)+,d4
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		jsr	(SolidObjectFull).l
		addq.b	#1,$22(a0)
		andi.b	#1,$22(a0)
		move.w	$30(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------
word_25AB8:	dc.w locret_258CE-word_25AB8

		dc.w loc_258D0-word_25AB8
		dc.w loc_258DC-word_25AB8
		dc.w loc_25924-word_25AB8
		dc.w loc_258FA-word_25AB8
		dc.w loc_25906-word_25AB8
		dc.w loc_25938-word_25AB8
		dc.w loc_2594C-word_25AB8
		dc.w loc_25960-word_25AB8
Map_DEZFloatingPlatform:include "Levels\DEZ\Misc Object Data\Map - Floating Platform.asm"

byte_25AF0:	dc.b $10
		dc.b $18
		dc.b $20
		dc.b $38
		dc.b $40
		dc.b $68
; ---------------------------------------------------------------------------

Obj_12_1:
		move.l	#Map_LBZUnusedElevator,$C(a0)
		move.w	#$43C3,$A(a0)
		move.b	#4,4(a0)
		move.w	#$200,8(a0)
		move.b	#$30,7(a0)
		move.b	#8,6(a0)
		move.w	$14(a0),$32(a0)
		move.w	#$8000,$16(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#4,d0
		andi.w	#$F,d0
		move.b	byte_25AF0(pc,d0.w),d0
		lsl.w	#3,d0
		move.w	d0,$38(a0)
		sub.w	d0,$14(a0)
		btst	#0,$2A(a0)
		beq.s	loc_25B56
		add.w	d0,d0
		add.w	d0,$14(a0)
		move.b	#1,$34(a0)

loc_25B56:
		move.l	#loc_25B5C,(a0)

loc_25B5C:
		move.w	$36(a0),d0
		move.w	off_25B92(pc,d0.w),d1
		jsr	off_25B92(pc,d1.w)
		tst.b	4(a0)
		bpl.s	loc_25B8C
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l

loc_25B8C:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
off_25B92:	dc.w loc_25B9A-off_25B92

		dc.w loc_25BB8-off_25B92
		dc.w loc_25BE4-off_25B92
		dc.w loc_25C02-off_25B92
; ---------------------------------------------------------------------------

loc_25B9A:
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		tst.b	(a3,d0.w)
		beq.s	locret_25BB6
		move.w	#$8000,$16(a0)
		addq.w	#2,$36(a0)

locret_25BB6:
		rts
; ---------------------------------------------------------------------------

loc_25BB8:
		bsr.w	sub_25C2E
		tst.w	$1A(a0)
		bne.s	locret_25BE2
		addq.w	#2,$36(a0)
		move.w	d0,$14(a0)
		move.w	$38(a0),d0
		sub.w	d0,$14(a0)
		btst	#0,$2A(a0)
		bne.s	locret_25BE2
		add.w	d0,d0
		add.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

locret_25BE2:

		rts
; ---------------------------------------------------------------------------

loc_25BE4:
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		tst.b	(a3,d0.w)
		bne.s	locret_25C00
		move.w	#$8000,$16(a0)
		addq.w	#2,$36(a0)

locret_25C00:
		rts
; ---------------------------------------------------------------------------

loc_25C02:
		bsr.w	sub_25C2E
		tst.w	$1A(a0)
		bne.s	locret_25C2C
		clr.w	$36(a0)
		move.w	d0,$14(a0)
		move.w	$38(a0),d0
		sub.w	d0,$14(a0)
		btst	#0,$2A(a0)
		beq.s	locret_25C2C
		add.w	d0,d0
		add.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

locret_25C2C:

		rts

; =============== S U B R O U T I N E =======================================


sub_25C2E:

		move.w	$14(a0),d2
		moveq	#8,d1
		tst.b	$34(a0)
		bne.s	loc_25C7C
		add.w	d1,$1A(a0)
		move.w	$1A(a0),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$14(a0)
		move.w	$32(a0),d0
		cmp.w	$14(a0),d0
		bhi.s	locret_25CBC
		beq.s	loc_25C6C
		sub.w	d0,d2
		neg.w	d2
		add.w	d0,d2
		move.w	d2,$14(a0)
		neg.w	$16(a0)
		move.b	#1,$34(a0)
		bra.s	locret_25CBC
; ---------------------------------------------------------------------------

loc_25C6C:
		neg.w	$16(a0)
		add.w	d1,$1A(a0)
		move.b	#1,$34(a0)
		bra.s	locret_25CBC
; ---------------------------------------------------------------------------

loc_25C7C:
		sub.w	d1,$1A(a0)
		move.w	$1A(a0),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$14(a0)
		move.w	$32(a0),d0
		cmp.w	$14(a0),d0
		bcs.s	locret_25CBC
		beq.s	loc_25CAE
		sub.w	d0,d2
		neg.w	d2
		add.w	d0,d2
		move.w	d2,$14(a0)
		neg.w	$16(a0)
		move.b	#0,$34(a0)
		bra.s	locret_25CBC
; ---------------------------------------------------------------------------

loc_25CAE:
		neg.w	$16(a0)
		sub.w	d1,$1A(a0)
		move.b	#0,$34(a0)

locret_25CBC:

		rts
; End of function sub_25C2E

; ---------------------------------------------------------------------------

Obj_LBZExplodingTrigger:

		move.l	#Map_LBZExplodingTrigger,$C(a0)
		move.w	#$4433,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$280,8(a0)
		move.b	#-$3A,$28(a0)
		move.l	#loc_25CF0,(a0)

loc_25CF0:
		move.b	$29(a0),d0
		beq.w	loc_25D26
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		lea	(a3,d0.w),a3
		moveq	#0,d3
		lea	($FFFFB000).w,a1
		bclr	#0,$29(a0)
		beq.s	loc_25D18
		bsr.s	sub_25D2C

loc_25D18:
		lea	($FFFFB04A).w,a1
		bclr	#1,$29(a0)
		beq.s	loc_25D26
		bsr.s	sub_25D2C

loc_25D26:

		jmp	(loc_1B662).l

; =============== S U B R O U T I N E =======================================


sub_25D2C:

		cmpi.b	#2,$20(a1)
		bne.s	locret_25D52
		neg.w	$18(a1)
		neg.w	$1A(a1)
		bchg	d3,(a3)
		move.l	#Obj_Explosion,(a0)
		move.b	#2,5(a0)
		clr.b	$28(a0)
		clr.b	$29(a0)

locret_25D52:
		rts
; End of function sub_25D2C

; ---------------------------------------------------------------------------

Obj_MGZDashTrigger:

		move.l	#Map_MGZDashTrigger,$C(a0)
		move.w	#$235F,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$280,8(a0)
		bset	#6,4(a0)
		move.w	#1,$16(a0)
		lea	$18(a0),a2
		move.w	$10(a0),(a2)+
		move.w	$14(a0),(a2)+
		move.w	#0,(a2)+
		move.l	#loc_25D9C,(a0)

loc_25D9C:
		move.w	#$1B,d1
		move.w	#$10,d2
		move.w	$10(a0),d4
		lea	(byte_25F0E).l,a2
		jsr	(sub_1DD0E).l
		swap	d6
		andi.w	#$33,d6
		beq.s	loc_25E22
		move.b	d6,d0
		andi.b	#$11,d0
		beq.s	loc_25DF0
		lea	($FFFFB000).w,a1
		cmpi.b	#9,$20(a1)
		bne.s	loc_25DF0
		move.w	#$3C,$30(a0)
		move.b	#1,$32(a0)
		move.b	$2A(a1),d0
		add.b	$2A(a0),d0
		andi.b	#1,d0
		bne.s	loc_25DF0
		move.b	#-1,$32(a0)

loc_25DF0:

		andi.b	#$22,d6
		beq.s	loc_25E22
		lea	($FFFFB04A).w,a1
		cmpi.b	#9,$20(a1)
		bne.s	loc_25E22
		move.w	#$3C,$30(a0)
		move.b	#1,$32(a0)
		move.b	$2A(a1),d0
		add.b	$2A(a0),d0
		andi.b	#1,d0
		bne.s	loc_25E22
		move.b	#-1,$32(a0)

loc_25E22:

		tst.w	$30(a0)
		beq.s	loc_25EA0
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		lea	(a3,d0.w),a3
		subq.w	#1,$30(a0)
		bne.s	loc_25E4A
		move.b	#0,(a3)
		move.b	#0,$22(a0)
		bra.s	loc_25EA0
; ---------------------------------------------------------------------------

loc_25E4A:
		move.b	#1,(a3)
		move.b	$2A(a0),d6
		andi.w	#$18,d6
		beq.s	loc_25E72
		move.w	d6,d0
		andi.w	#8,d0
		beq.s	loc_25E66
		lea	($FFFFB000).w,a1
		bsr.s	sub_25EA6

loc_25E66:
		andi.w	#$10,d6
		beq.s	loc_25E72
		lea	($FFFFB04A).w,a1
		bsr.s	sub_25EA6

loc_25E72:

		subq.b	#1,$24(a0)
		bpl.s	loc_25E8C
		move.b	#1,$24(a0)
		move.b	$32(a0),d0
		add.b	d0,$1D(a0)
		andi.b	#3,$1D(a0)

loc_25E8C:
		tst.b	$22(a0)
		beq.s	loc_25E9A
		move.b	#0,$22(a0)
		bra.s	loc_25EA0
; ---------------------------------------------------------------------------

loc_25E9A:
		move.b	#4,$22(a0)

loc_25EA0:

		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_25EA6:

		move.w	$10(a0),d1
		subi.w	#$10,d1
		btst	#0,$2A(a0)
		beq.s	loc_25EBA
		addi.w	#$20,d1

loc_25EBA:
		move.w	$14(a0),d2
		addi.w	#$10,d2
		sub.w	$10(a1),d1
		sub.w	$14(a1),d2
		jsr	(GetArcTan).l
		jsr	(GetSineCosine).l
		muls.w	#-$700,d1
		asr.l	#8,d1
		move.w	d1,$18(a1)
		muls.w	#-$700,d0
		asr.l	#8,d0
		move.w	d0,$1A(a1)
		bset	#1,$2A(a1)
		bclr	#4,$2A(a1)
		bclr	#5,$2A(a1)
		clr.b	$40(a1)
		clr.b	$3D(a1)
		moveq	#$7B,d0
		jsr	(Play_Sound_2).l
		rts
; End of function sub_25EA6

; ---------------------------------------------------------------------------
byte_25F0E:	dc.b $10
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $10
		dc.b $F
		dc.b $F
		dc.b $E
		dc.b $E
		dc.b $D
		dc.b $C
		dc.b $A
		dc.b 8
		dc.b 6
		dc.b 4
		dc.b 0
		dc.b $FC
		dc.b $F8
		dc.b $F6
		dc.b $F6
		dc.b $F6
		dc.b $F6
		dc.b $F6
		dc.b $F6
byte_25F2A:	dc.b  $48,   0,	  8, $40,  0,   0,	 $A,   8	; X offset, Y offset, X width, Y width, init routine counter, init mapping frame, second routine counter, second mapping frame
		dc.b	0, $48,	$40,   8,  0,   8,	 $A, $10
		dc.b  $B8,   0,	  8, $40,  0,   0,	 $A,   8
		dc.b	0, $48,	$40,   8,  0, $10,	 $A, $18
		dc.b	0, $48,	$40,   8,  6,   8,	  4, $10
		dc.b  $48,   0,	  8, $40,  6,   0,	  4,   8
		dc.b	0, $48,	$40,   8,  6, $10,	  4, $18
		dc.b  $B8,   0,	  8, $40,  6,   0,	  4,   8
; ---------------------------------------------------------------------------

Obj_LBZTriggerBridge:

		move.b	$2C(a0),d0
		move.b	d0,d1
		andi.w	#$F,d1
		tst.b	$34(a0)
		bne.s	loc_25F86
		lea	($FFFFF7E0).w,a3
		tst.b	(a3,d0.w)
		beq.s	loc_25F86
		addq.w	#4,d0

loc_25F86:

		lsr.b	#1,d0
		andi.w	#$38,d0
		lea	byte_25F2A(pc,d0.w),a1
		move.l	#Map_LBZTriggerBridge,$C(a0)
		move.w	#$43C3,$A(a0)
		move.b	#4,4(a0)
		move.w	#$200,8(a0)
		move.w	$10(a0),$30(a0)
		move.w	$14(a0),$32(a0)
		move.b	(a1)+,d0
		ext.w	d0
		add.w	$30(a0),d0
		move.w	d0,$10(a0)
		move.b	(a1)+,d0
		ext.w	d0
		add.w	$32(a0),d0
		move.w	d0,$14(a0)
		move.b	(a1)+,7(a0)
		move.b	(a1)+,6(a0)
		moveq	#0,d0
		move.b	(a1)+,d0
		move.w	d0,$36(a0)
		move.b	(a1)+,$22(a0)
		tst.b	$34(a0)
		beq.s	loc_25FF8
		move.b	(a1)+,d0
		move.w	d0,$36(a0)
		move.b	(a1)+,$22(a0)
		move.b	#0,$34(a0)

loc_25FF8:
		move.l	#loc_25FFE,(a0)

loc_25FFE:
		move.w	$36(a0),d0
		move.w	off_26038(pc,d0.w),d1
		jsr	off_26038(pc,d1.w)
		tst.b	4(a0)
		bpl.s	loc_2602E
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull2).l

loc_2602E:
		move.w	$30(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------
off_26038:	dc.w loc_26044-off_26038
		dc.w loc_2609E-off_26038
		dc.w loc_260B0-off_26038
		dc.w loc_260D2-off_26038
		dc.w loc_2609E-off_26038
		dc.w loc_260C0-off_26038
; ---------------------------------------------------------------------------

loc_26044:
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		tst.b	(a3,d0.w)
		beq.s	locret_2609C
		addq.b	#1,$22(a0)
		move.w	#7,$38(a0)
		addq.w	#2,$36(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	locret_2609C
		move.l	#Obj_LBZTriggerBridge,(a1)
		move.w	$30(a0),$10(a1)
		move.w	$32(a0),$14(a1)
		move.b	$2C(a0),d0
		addi.b	#$40,d0
		andi.b	#$7F,d0
		move.b	d0,$2C(a1)
		move.w	#8,$38(a1)
		move.b	#1,$34(a1)

locret_2609C:

		rts
; ---------------------------------------------------------------------------

loc_2609E:
		addq.b	#1,$22(a0)
		subq.w	#1,$38(a0)
		bne.s	locret_260AE
		move.w	#$7FFF,$10(a0)

locret_260AE:
		rts
; ---------------------------------------------------------------------------

loc_260B0:
		subq.b	#1,$22(a0)
		subq.w	#1,$38(a0)
		bne.s	locret_260BE
		addq.w	#2,$36(a0)

locret_260BE:
		rts
; ---------------------------------------------------------------------------

loc_260C0:
		subq.b	#1,$22(a0)
		subq.w	#1,$38(a0)
		bne.s	locret_260D0
		move.w	#0,$36(a0)

locret_260D0:
		rts
; ---------------------------------------------------------------------------

loc_260D2:
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		tst.b	(a3,d0.w)
		bne.s	locret_2612A
		addq.b	#1,$22(a0)
		move.w	#7,$38(a0)
		addq.w	#2,$36(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	locret_2612A
		move.l	#Obj_LBZTriggerBridge,(a1)
		move.w	$30(a0),$10(a1)
		move.w	$32(a0),$14(a1)
		move.b	$2C(a0),d0
		addi.b	#$40,d0
		andi.b	#$7F,d0
		move.b	d0,$2C(a1)
		move.w	#8,$38(a1)
		move.b	#1,$34(a1)

locret_2612A:

		rts
; ---------------------------------------------------------------------------
byte_2612C:	dc.b $10
		dc.b 0
		dc.b $A
		dc.b 0
; ---------------------------------------------------------------------------

Obj_LBZPlayerLauncher:

		move.l	#Map_LBZPlayerLauncher,$C(a0)
		move.w	#$43C3,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$20,7(a0)
		move.w	#$80,8(a0)
		move.b	$2C(a0),d0
		andi.w	#2,d0
		move.w	byte_2612C(pc,d0.w),$34(a0)
		move.l	#loc_26164,(a0)

loc_26164:
		move.w	$10(a0),d0
		move.w	d0,d1
		subi.w	#$10,d0
		addi.w	#$10,d1
		move.w	$14(a0),d2
		move.w	d2,d3
		subi.w	#$10,d2
		addi.w	#$10,d3
		lea	($FFFFB000).w,a1
		btst	#1,$2A(a1)
		bne.s	loc_261B8
		move.w	$10(a1),d4
		cmp.w	d0,d4
		bcs.w	loc_261B8
		cmp.w	d1,d4
		bcc.w	loc_261B8
		move.w	$14(a1),d4
		cmp.w	d2,d4
		bcs.w	loc_261B8
		cmp.w	d3,d4
		bcc.w	loc_261B8
		move.w	d0,-(sp)
		lea	$38(a0),a2
		bsr.w	sub_261F2
		move.w	(sp)+,d0

loc_261B8:

		lea	($FFFFB04A).w,a1
		btst	#1,$2A(a1)
		bne.s	loc_261EC
		move.w	$10(a1),d4
		cmp.w	d0,d4
		bcs.w	loc_261EC
		cmp.w	d1,d4
		bcc.w	loc_261EC
		move.w	$14(a1),d4
		cmp.w	d2,d4
		bcs.w	loc_261EC
		cmp.w	d3,d4
		bcc.w	loc_261EC
		lea	$3A(a0),a2
		bsr.w	sub_261F2

loc_261EC:

		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_261F2:

		tst.w	(a2)
		bne.s	loc_26220
		move.l	a1,-(sp)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_2621E
		move.l	#Obj_2629C,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	4(a0),4(a1)
		move.w	a2,$3C(a1)

loc_2621E:
		movea.l	(sp)+,a1

loc_26220:
		addq.w	#1,(a2)
		cmpi.w	#4,(a2)
		beq.s	loc_26244
		move.w	$18(a1),d0
		btst	#0,4(a0)
		beq.s	loc_26236
		neg.w	d0

loc_26236:
		tst.w	d0
		bpl.s	locret_26242
		asr	$1C(a1)
		asr	$18(a1)

locret_26242:
		rts
; ---------------------------------------------------------------------------

loc_26244:
		move.w	$18(a1),d0
		btst	#0,$2A(a0)
		beq.s	loc_26252
		neg.w	d0

loc_26252:
		cmpi.w	#$1000,d0
		bge.s	loc_26294
		move.w	$34(a0),$18(a1)
		bclr	#0,$2A(a1)
		btst	#0,$2A(a0)
		beq.s	loc_26276
		bset	#0,$2A(a1)
		neg.w	$18(a1)

loc_26276:
		move.w	#$F,$32(a1)
		move.w	$18(a1),$1C(a1)
		bclr	#5,$2A(a0)
		bclr	#6,$2A(a0)
		bclr	#5,$2A(a1)

loc_26294:
		moveq	#-$4F,d0
		jmp	(Play_Sound_2).l
; End of function sub_261F2

; ---------------------------------------------------------------------------

Obj_2629C:
		move.l	#Map_LBZPlayerLauncher,$C(a0)
		move.w	#$43C3,$A(a0)
		ori.b	#4,4(a0)
		move.b	#8,7(a0)
		move.w	#$80,8(a0)
		move.w	$10(a0),$30(a0)
		addi.w	#$10,$14(a0)
		move.w	$14(a0),$32(a0)
		move.b	#1,$22(a0)
		move.b	#-$80,$40(a0)
		bset	#6,4(a0)
		move.w	#4,$16(a0)
		move.l	#loc_262EC,(a0)

loc_262EC:
		move.w	$36(a0),d0
		move.w	off_26302(pc,d0.w),d1
		jsr	off_26302(pc,d1.w)
		bsr.w	sub_26338
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
off_26302:	dc.w loc_26306-off_26302

		dc.w loc_26322-off_26302
; ---------------------------------------------------------------------------

loc_26306:
		addi.b	#$10,$40(a0)
		cmpi.b	#$D0,$40(a0)
		bne.s	locret_26320
		movea.w	$3C(a0),a2
		move.w	#0,(a2)
		addq.w	#2,$36(a0)

locret_26320:
		rts
; ---------------------------------------------------------------------------

loc_26322:
		subi.b	#4,$40(a0)
		cmpi.b	#$80,$40(a0)
		bne.s	locret_26336
		move.w	#$7F00,$30(a0)

locret_26336:
		rts

; =============== S U B R O U T I N E =======================================


sub_26338:
		move.b	$40(a0),d0
		btst	#0,4(a0)
		beq.s	loc_2634A
		neg.b	d0
		addi.b	#$80,d0

loc_2634A:
		jsr	(GetSineCosine).l
		move.w	$32(a0),d2
		move.w	$30(a0),d3
		moveq	#0,d6
		move.w	$16(a0),d6
		subq.w	#1,d6
		bcs.s	locret_263A8
		swap	d0
		swap	d1
		asr.l	#4,d0
		asr.l	#4,d1
		moveq	#0,d4
		moveq	#0,d5
		add.l	d0,d4
		add.l	d1,d5
		lea	$18(a0),a2

loc_26376:
		movem.l	d4-d5,-(sp)
		swap	d4
		swap	d5
		add.w	d2,d4
		add.w	d3,d5
		move.w	d5,(a2)+
		move.w	d4,(a2)+
		movem.l	(sp)+,d4-d5
		add.l	d0,d4
		add.l	d1,d5
		addq.w	#1,a2
		move.b	#1,(a2)+
		dbf	d6,loc_26376
		swap	d4
		swap	d5
		add.w	d2,d4
		add.w	d3,d5
		move.w	d5,$10(a0)
		move.w	d4,$14(a0)

locret_263A8:
		rts
; End of function sub_26338


; =============== S U B R O U T I N E =======================================


sub_263AA:

		move.l	#Map_LBZFlameThrower,$C(a1)
		move.w	#$43AC,$A(a1)
		move.b	#$10,7(a1)
		move.b	#$10,6(a1)
		ori.b	#4,4(a1)
		move.w	#$200,8(a1)
		rts
; End of function sub_263AA

; ---------------------------------------------------------------------------

Obj_LBZFlameThrower:

		movea.l	a0,a1
		bsr.s	sub_263AA
		move.l	#loc_263DC,(a0)

loc_263DC:
		move.b	($FFFFFE0F).w,d0
		add.b	$2C(a0),d0
		andi.b	#$7F,d0
		bne.s	loc_2643C
		jsr	(Create_New_Sprite3).l
		bne.w	loc_2643C
		move.l	#Obj_26460,(a1)
		bsr.s	sub_263AA
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	$2A(a0),$2A(a1)
		move.b	#-$63,$28(a1)
		bset	#4,$2B(a1)
		addi.w	#$40,$10(a1)
		btst	#0,$2A(a0)
		beq.s	loc_2642E
		subi.w	#$80,$10(a1)

loc_2642E:
		tst.b	4(a0)
		bpl.s	loc_2643C
		moveq	#$43,d0
		jsr	(Play_Sound_2).l

loc_2643C:

		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_26460:
		lea	(Ani_LBZFlameThrower).l,a1
		jsr	(Animate_Sprite).l
		tst.b	5(a0)
		beq.s	loc_26478
		move.w	#$7FFF,$10(a0)

loc_26478:
		jmp	(loc_1B662).l
; ---------------------------------------------------------------------------
Ani_LBZFlameThrower:	include "Levels\LBZ\Misc Object Data\Anim - Flame Thrower.asm"

LBZRideGrapple_Range:	dc.w   $A08,  $C78	;0
		dc.w  $1208,  $14F8		;1
		dc.w  $1A08,  $1BB8		;2
		dc.w  $1C48,  $2078		;3
		dc.w  $2688,  $2878		;4
		dc.w  $2988,  $2DF8		;5
		dc.w  $2F88,  $3178		;6
		dc.w   $E68,  $1098		;7
		dc.w   $CE8,  $1498		;8
		dc.w   $E68,  $1398		;9
		dc.w  $20E8,  $2418		;A
		dc.w  $2B08,  $2E98		;B
		dc.w  $39E8,  $3C98		;C
; ---------------------------------------------------------------------------

Obj_LBZRideGrapple:

		move.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.w	#$80,8(a0)
		move.b	#$20,6(a0)
		move.w	$10(a0),$38(a0)
		move.b	$2C(a0),d0
		andi.w	#$7F,d0
		lsl.w	#2,d0
		move.l	LBZRideGrapple_Range(pc,d0.w),$34(a0)
		move.l	#Map_LBZRideGrapple,$C(a0)
		move.w	#$2433,$A(a0)
		jsr	(Create_New_Sprite3).l
		bne.s	loc_26566
		move.l	#loc_2668E,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.b	4(a0),4(a1)
		move.w	8(a0),8(a1)
		bset	#6,4(a1)
		move.b	#$10,7(a1)
		move.b	#$20,6(a1)
		moveq	#6,d1
		move.w	d1,$16(a1)
		subq.b	#1,d1
		lea	$18(a1),a2

loc_2654C:
		move.w	$10(a1),(a2)+
		move.w	$14(a1),(a2)+
		move.w	#1,(a2)+
		dbf	d1,loc_2654C
		move.b	#2,$22(a1)
		move.w	a1,$3C(a0)

loc_26566:
		move.l	#loc_2656C,(a0)

loc_2656C:

		bsr.w	sub_2682E
		bsr.w	sub_26694
		tst.w	$30(a0)
		beq.s	loc_26588
		cmpi.w	#$28,$3A(a0)
		bne.s	loc_26588
		move.l	#loc_265DC,(a0)

loc_26588:

		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_265A2
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_265A2:
		move.w	$38(a0),d0
		andi.w	#$FF80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_265BC
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_265BC:
		move.w	$48(a0),d0
		beq.s	loc_265C8
		movea.w	d0,a2
		bclr	#7,(a2)

loc_265C8:
		move.w	$3C(a0),d0
		beq.s	loc_265D6
		movea.w	d0,a1
		jsr	(Delete_Referenced_Sprite).l

loc_265D6:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_265DC:
		jsr	(MoveSprite2).l
		btst	#0,$2A(a0)
		beq.s	loc_265FE
		subi.w	#$20,$18(a0)
		tst.w	$18(a0)
		bmi.s	loc_26610
		subi.w	#$60,$18(a0)
		bra.s	loc_26610
; ---------------------------------------------------------------------------

loc_265FE:
		addi.w	#$20,$18(a0)
		tst.w	$18(a0)
		bpl.s	loc_26610
		addi.w	#$60,$18(a0)

loc_26610:

		move.w	$10(a0),d0
		move.w	$34(a0),d1
		cmp.w	d1,d0
		bhi.s	loc_2662E
		move.w	d1,$10(a0)
		bsr.s	sub_26654
		tst.w	$18(a0)
		bpl.s	loc_2662E
		move.w	#0,$18(a0)

loc_2662E:

		move.w	$36(a0),d1
		cmp.w	d1,d0
		bcs.s	loc_26648
		move.w	d1,$10(a0)
		bsr.s	sub_26654
		tst.w	$18(a0)
		bmi.s	loc_26648
		move.w	#0,$18(a0)

loc_26648:

		bsr.w	sub_2682E
		bsr.w	sub_26694
		bra.w	loc_26588

; =============== S U B R O U T I N E =======================================


sub_26654:

		tst.b	$2C(a0)
		bmi.s	locret_2668C
		lea	$30(a0),a2
		lea	($FFFFB000).w,a1
		bsr.s	sub_2666A
		lea	($FFFFB04A).w,a1
		addq.w	#1,a2
; End of function sub_26654


; =============== S U B R O U T I N E =======================================


sub_2666A:
		tst.b	(a2)
		beq.s	locret_2668C
		move.w	$18(a0),$18(a1)
		move.w	#0,$1A(a1)
		bset	#1,$2A(a1)
		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$3C,2(a2)

locret_2668C:
		rts
; End of function sub_2666A

; ---------------------------------------------------------------------------

loc_2668E:
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_26694:

		movea.w	$3C(a0),a3
		lea	$31(a0),a2
		lea	($FFFFB04A).w,a1
		move.w	($FFFFF66A).w,d0
		bsr.s	sub_266B0
		lea	($FFFFB000).w,a1
		subq.w	#1,a2
		move.w	($FFFFF602).w,d0
; End of function sub_26694


; =============== S U B R O U T I N E =======================================


sub_266B0:
		tst.b	(a2)
		beq.w	loc_267A4
		tst.b	4(a1)
		bpl.s	loc_26718
		cmpi.b	#4,5(a1)
		bcc.s	loc_26718
		andi.b	#$70,d0
		beq.w	loc_26726
		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$12,2(a2)
		andi.w	#$F00,d0
		beq.w	loc_266E6
		move.b	#$3C,2(a2)

loc_266E6:
		move.w	$18(a0),$18(a1)
		move.w	#-$380,$1A(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		rts
; ---------------------------------------------------------------------------

loc_26718:

		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$3C,2(a2)
		rts
; ---------------------------------------------------------------------------

loc_26726:
		btst	#$A,d0
		beq.s	loc_26732
		bset	#0,$2A(a1)

loc_26732:
		btst	#$B,d0
		beq.s	loc_2673E
		bclr	#0,$2A(a1)

loc_2673E:
		move.b	$2A(a1),$2A(a0)
		move.b	$2A(a1),d0
		andi.b	#1,d0
		andi.b	#-2,4(a1)
		or.b	d0,4(a1)
		move.w	$10(a3),$10(a1)
		move.w	$14(a3),$14(a1)
		addi.w	#$24,$14(a1)

loc_26768:
		moveq	#0,d0
		move.b	$26(a0),d0
		btst	#0,$2A(a1)
		beq.s	loc_26778
		neg.b	d0

loc_26778:
		addq.b	#8,d0
		lsr.w	#4,d0
		move.b	byte_26794(pc,d0.w),$22(a1)
		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2
		rts
; ---------------------------------------------------------------------------
byte_26794:	dc.b $91
		dc.b $91
		dc.b $90
		dc.b $90
		dc.b $90
		dc.b $90
		dc.b $90
		dc.b $90
		dc.b $92
		dc.b $92
		dc.b $92
		dc.b $92
		dc.b $92
		dc.b $92
		dc.b $91
		dc.b $91
; ---------------------------------------------------------------------------

loc_267A4:
		tst.b	2(a2)
		beq.s	loc_267B2
		subq.b	#1,2(a2)
		bne.w	locret_2682C

loc_267B2:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.w	locret_2682C
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		subi.w	#$18,d1
		cmpi.w	#$18,d1
		bcc.w	locret_2682C
		tst.b	$2E(a1)
		bne.s	locret_2682C
		cmpi.b	#4,5(a1)
		bcc.s	locret_2682C
		tst.w	($FFFFFE08).w
		bne.s	locret_2682C
		move.b	$2A(a1),$2A(a0)
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$24,$14(a1)
		move.b	#$14,$20(a1)
		move.b	#0,$3D(a1)
		move.b	#3,$2E(a1)
		move.b	#1,(a2)
		bra.w	loc_26768
; ---------------------------------------------------------------------------

locret_2682C:

		rts
; End of function sub_266B0


; =============== S U B R O U T I N E =======================================


sub_2682E:

		tst.w	$30(a0)
		beq.s	loc_26842
		move.w	$3A(a0),d2
		cmpi.w	#$28,d2
		beq.s	loc_26868
		addq.w	#1,d2
		bra.s	loc_26864
; ---------------------------------------------------------------------------

loc_26842:
		move.w	$3A(a0),d2
		beq.s	loc_2684C
		subq.w	#1,d2
		bne.s	loc_26864

loc_2684C:
		clr.w	$26(a0)
		clr.b	$40(a0)
		clr.w	$3E(a0)
		move.w	#0,$18(a0)
		move.l	#loc_2656C,(a0)

loc_26864:

		move.w	d2,$3A(a0)

loc_26868:
		mulu.w	#$33,d2
		move.w	$18(a0),d0
		bne.s	loc_268AC
		tst.b	$40(a0)
		bne.s	loc_26892
		move.w	$3E(a0),d1
		addi.w	#$40,d1
		move.w	d1,$3E(a0)
		add.w	d1,$26(a0)
		bmi.s	loc_268AA
		move.b	#1,$40(a0)
		bra.s	loc_268AA
; ---------------------------------------------------------------------------

loc_26892:
		move.w	$3E(a0),d1
		subi.w	#$40,d1
		move.w	d1,$3E(a0)
		add.w	d1,$26(a0)
		bpl.s	loc_268AA
		move.b	#0,$40(a0)

loc_268AA:

		bra.s	loc_268EC
; ---------------------------------------------------------------------------

loc_268AC:
		neg.w	d0
		asl.w	#2,d0
		sub.w	$26(a0),d0
		bge.s	loc_268C6
		cmpi.w	#-$3000,$26(a0)
		ble.s	loc_268C6
		subi.w	#$180,$26(a0)
		bra.s	loc_268D4
; ---------------------------------------------------------------------------

loc_268C6:

		cmpi.w	#$3000,$26(a0)
		bge.s	loc_268D4
		addi.w	#$180,$26(a0)

loc_268D4:

		move.b	#0,$40(a0)
		tst.w	$18(a0)
		bpl.s	loc_268E6
		move.b	#1,$40(a0)

loc_268E6:
		move.w	#0,$3E(a0)

loc_268EC:
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		muls.w	d2,d0
		muls.w	d2,d1
		move.l	$10(a0),d2
		move.l	$14(a0),d3
		movea.w	$3C(a0),a1
		moveq	#5,d4
		lea	$18(a1),a2

loc_2690C:
		swap	d2
		swap	d3
		move.w	d2,(a2)+
		move.w	d3,(a2)+
		addq.w	#2,a2
		swap	d2
		swap	d3
		add.l	d0,d2
		add.l	d1,d3
		dbf	d4,loc_2690C
		move.w	$36(a1),$10(a1)
		move.w	$38(a1),$14(a1)
		rts
; End of function sub_2682E

; ---------------------------------------------------------------------------
Map_LBZRideGrapple:include "Levels\LBZ\Misc Object Data\Map - Ride Grapple.asm"

; ---------------------------------------------------------------------------

Obj_LBZCupElevator:

		move.l	#Map_LBZCupElevator,$C(a0)
		move.w	#$440D,$A(a0)
		move.b	#4,4(a0)
		move.w	#$80,8(a0)
		move.b	#$20,7(a0)
		move.b	#$10,6(a0)
		btst	#6,$2C(a0)			; BIT 6
		beq.s	loc_2698A
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_2698A
		move.w	#$7F00,$10(a0)		; Set this object to be deleted if bit 6 is set and Knuckles is playing

loc_2698A:

		move.w	$10(a0),$30(a0)
		move.w	$14(a0),$32(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_26A50
		move.l	#Obj_LBZCupElevatorAttach,(a1)
		move.l	#Map_LBZCupElevator,$C(a1)
		move.w	#$440D,$A(a1)
		move.b	#4,4(a1)
		move.w	#$80,8(a1)
		move.b	#$20,7(a1)
		move.b	#$10,6(a1)
		move.w	$10(a0),$10(a1)
		move.w	$10(a0),$30(a1)
		move.w	$14(a0),$14(a1)
		move.b	#1,$22(a1)
		addi.w	#$18,$10(a1)
		btst	#0,$2A(a0)
		bne.s	loc_269F8
		subi.w	#$30,$10(a1)		; Set position based on orientation of original object

loc_269F8:
		move.w	a0,$40(a1)
		move.w	a1,$42(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_26A50
		move.l	#Obj_LBZCupElevatorBase,(a1)
		move.l	#Map_LBZCupElevator,$C(a1)
		move.w	#$440D,$A(a1)
		move.b	#4,4(a1)
		move.w	#$100,8(a1)
		move.b	#$20,7(a1)
		move.b	#$10,6(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	#2,$22(a1)
		move.w	a0,$40(a1)
		move.w	a1,$40(a0)

loc_26A50:

		moveq	#0,d0
		move.b	$2C(a0),d0		; BITS 3-0
		andi.w	#$F,d0
		lsl.w	#5,d0			; Multiples of $60
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		move.w	d0,$38(a0)
		move.w	#0,$26(a0)
		addi.w	#$40,$10(a0)
		btst	#0,$2A(a0)
		bne.s	loc_26A86
		subi.w	#$80,$10(a0)
		move.w	#$8080,$26(a0)

loc_26A86:
		move.b	$2C(a0),d1		; BITS 5-4
		andi.w	#$30,d1
		beq.s	loc_26AAC
		move.w	d0,$3A(a0)		; If any bit set, elevator is moving downward.
		add.w	d0,$32(a0)
		move.w	#6,$36(a0)
		btst	#0,$2C(a0)
		beq.s	loc_26AAC
		addi.b	#$80,$27(a0)

loc_26AAC:

		move.l	#Obj_LBZCupElevatorMain,(a0)

Obj_LBZCupElevatorMain:
		bsr.w	LBZCupElevator_Action
		move.w	$10(a0),d4
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#2,d1
		add.w	$30(a0),d1
		move.w	d1,$10(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		lea	$3C(a0),a2
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		move.w	($FFFFF602).w,d0
		movem.l	d1-d4,-(sp)
		bsr.w	LBZCupElevator_PlayerControl
		movem.l	(sp)+,d1-d4
		lea	$3D(a0),a2
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		move.w	($FFFFF66A).w,d0
		bsr.w	LBZCupElevator_PlayerControl
		bra.w	loc_26E78

; =============== S U B R O U T I N E =======================================


LBZCupElevator_Action:
		move.w	$36(a0),d0
		move.w	off_26B1E(pc,d0.w),d1
		jmp	off_26B1E(pc,d1.w)
; End of function LBZCupElevator_Action

; ---------------------------------------------------------------------------
off_26B1E:	dc.w LBZCupElev_WaitEnter-off_26B1E	;0
		dc.w LBZCupElev_MoveUp-off_26B1E		;2
		dc.w LBZCupElev_WaitExit1-off_26B1E		;4
		dc.w LBZCupElev_WaitEnter-off_26B1E		;6
		dc.w LBZCupElev_MoveDown-off_26B1E		;8
		dc.w LBZCupElev_WaitExit2-off_26B1E		;A
		dc.w LBZCupElev_Spin1-off_26B1E			;C
		dc.w LBZCupElev_Fling1-off_26B1E		;E
		dc.w LBZCupElev_Fling2-off_26B1E		;10
		dc.w LBZCupElev_Spin2-off_26B1E			;12
		dc.w LBZCupElev_Fling3-off_26B1E		;14
; ---------------------------------------------------------------------------

LBZCupElev_WaitEnter:
		tst.w	$3C(a0)
		beq.s	locret_26B44
		move.w	#1,$34(a0)
		addq.w	#2,$36(a0)

locret_26B44:
		rts
; ---------------------------------------------------------------------------

LBZCupElev_MoveUp:
		move.w	$3A(a0),d0
		cmp.w	$38(a0),d0
		bne.s	loc_26B78
		tst.b	$2C(a0)
		bpl.s	loc_26B66
		move.w	#$C,$36(a0)
		move.w	#$600,$2E(a0)
		bra.w	LBZCupElev_Spin1
; ---------------------------------------------------------------------------

loc_26B66:
		move.w	#$80,8(a0)
		move.w	#0,$34(a0)
		addq.w	#2,$36(a0)
		rts
; ---------------------------------------------------------------------------

loc_26B78:
		addq.w	#4,$3A(a0)
		move.w	$3A(a0),d0
		move.w	d0,d1
		mulu.w	#$155,d0
		lsr.w	#8,d0
		add.b	$27(a0),d0
		move.b	d0,$26(a0)
		move.w	$32(a0),d0
		sub.w	d1,d0
		move.w	d0,$14(a0)
		cmpi.w	#$200,8(a0)
		bne.s	loc_26BB8
		tst.b	$26(a0)
		bpl.s	locret_26BB6
		move.w	#$80,8(a0)
		moveq	#$72,d0
		jsr	(Play_Sound_2).l

locret_26BB6:
		rts
; ---------------------------------------------------------------------------

loc_26BB8:
		tst.b	$26(a0)
		bmi.s	locret_26BCC
		move.w	#$200,8(a0)
		moveq	#$72,d0
		jsr	(Play_Sound_2).l

locret_26BCC:
		rts
; ---------------------------------------------------------------------------

LBZCupElev_WaitExit1:
		tst.w	$3C(a0)
		bne.s	locret_26BD8
		addq.w	#2,$36(a0)

locret_26BD8:
		rts
; ---------------------------------------------------------------------------

LBZCupElev_MoveDown:
		tst.w	$3A(a0)
		bne.s	loc_26C08
		tst.b	$2C(a0)
		bpl.s	loc_26BF6
		move.w	#$12,$36(a0)
		move.w	#$600,$2E(a0)
		bra.w	LBZCupElev_Spin1
; ---------------------------------------------------------------------------

loc_26BF6:
		move.w	#$80,8(a0)
		move.w	#0,$34(a0)
		addq.w	#2,$36(a0)
		rts
; ---------------------------------------------------------------------------

loc_26C08:
		subq.w	#4,$3A(a0)
		move.w	$3A(a0),d0
		move.w	d0,d1
		mulu.w	#$155,d0
		lsr.w	#8,d0
		add.b	$27(a0),d0
		move.b	d0,$26(a0)
		move.w	$32(a0),d0
		sub.w	d1,d0
		move.w	d0,$14(a0)
		cmpi.w	#$200,8(a0)
		bne.s	loc_26C48
		tst.b	$26(a0)
		bpl.s	locret_26C46
		move.w	#$80,8(a0)
		moveq	#$72,d0
		jsr	(Play_Sound_2).l

locret_26C46:
		rts
; ---------------------------------------------------------------------------

loc_26C48:
		tst.b	$26(a0)
		bmi.s	locret_26C5C
		move.w	#$200,8(a0)
		moveq	#$72,d0
		jsr	(Play_Sound_2).l

locret_26C5C:
		rts
; ---------------------------------------------------------------------------

LBZCupElev_WaitExit2:
		tst.w	$3C(a0)
		bne.s	locret_26C6A
		move.w	#0,$36(a0)

locret_26C6A:
		rts
; ---------------------------------------------------------------------------

LBZCupElev_Spin1:


		cmpi.w	#$1000,$2E(a0)
		bne.s	loc_26CC4
		btst	#0,$2A(a0)
		bne.s	loc_26CA0
		move.b	$26(a0),d0
		addi.b	#$40,d0
		cmpi.b	#$F0,d0
		bcs.s	loc_26CCA
		move.b	#$C0,$26(a0)
		movea.w	$42(a0),a1
		move.w	#$7FFF,$30(a1)
		addq.w	#2,$36(a0)
		rts
; ---------------------------------------------------------------------------

loc_26CA0:
		move.b	$26(a0),d0
		addi.b	#$C0,d0
		cmpi.b	#$F0,d0
		bcs.s	loc_26CCA
		move.b	#$40,$26(a0)
		movea.w	$42(a0),a1
		move.w	#$7FFF,$30(a1)
		addq.w	#4,$36(a0)
		rts
; ---------------------------------------------------------------------------

loc_26CC4:
		addi.w	#$10,$2E(a0)

loc_26CCA:

		move.b	$2E(a0),d0
		add.b	d0,$26(a0)
		cmpi.w	#$200,8(a0)
		bne.s	loc_26CF0
		tst.b	$26(a0)
		bpl.s	locret_26CEE
		move.w	#$80,8(a0)
		moveq	#$72,d0
		jsr	(Play_Sound_2).l

locret_26CEE:
		rts
; ---------------------------------------------------------------------------

loc_26CF0:
		tst.b	$26(a0)
		bmi.s	locret_26D04
		move.w	#$200,8(a0)
		moveq	#$72,d0
		jsr	(Play_Sound_2).l

locret_26D04:
		rts
; ---------------------------------------------------------------------------

LBZCupElev_Spin2:
		cmpi.w	#$1000,$2E(a0)
		bne.s	loc_26D32
		move.b	$26(a0),d0
		addi.b	#$B0,d0
		cmpi.b	#$F0,d0
		bcs.s	loc_26D38
		move.b	#$40,$26(a0)
		movea.w	$42(a0),a1
		move.w	#$7FFF,$30(a1)
		addq.w	#2,$36(a0)
		rts
; ---------------------------------------------------------------------------

loc_26D32:
		addi.w	#$10,$2E(a0)

loc_26D38:
		move.b	$2E(a0),d0
		sub.b	d0,$26(a0)
		cmpi.w	#$200,8(a0)
		bne.s	loc_26D5E
		tst.b	$26(a0)
		bpl.s	locret_26D5C
		move.w	#$80,8(a0)
		moveq	#$72,d0
		jsr	(Play_Sound_2).l

locret_26D5C:
		rts
; ---------------------------------------------------------------------------

loc_26D5E:
		tst.b	$26(a0)
		bmi.s	locret_26D72
		move.w	#$200,8(a0)
		moveq	#$72,d0
		jsr	(Play_Sound_2).l

locret_26D72:
		rts
; ---------------------------------------------------------------------------

LBZCupElev_Fling1:
		cmpi.w	#$16C0,$30(a0)
		bcs.s	loc_26D90
		move.w	#$16C0,$30(a0)
		move.w	#-$200,$18(a0)
		move.w	#0,$1A(a0)
		bra.s	loc_26DE0
; ---------------------------------------------------------------------------

loc_26D90:
		addi.w	#$10,$30(a0)
		rts
; ---------------------------------------------------------------------------

LBZCupElev_Fling2:
		cmpi.w	#$2AE0,$30(a0)
		bhi.s	loc_26DB4
		move.w	#$2AE0,$30(a0)
		move.w	#$200,$18(a0)
		move.w	#0,$1A(a0)
		bra.s	loc_26DE0
; ---------------------------------------------------------------------------

loc_26DB4:
		subi.w	#$10,$30(a0)
		rts
; ---------------------------------------------------------------------------

LBZCupElev_Fling3:
		cmpi.w	#$2B20,$30(a0)
		bcs.s	loc_26DD8
		move.w	#$2B20,$30(a0)
		move.w	#-$200,$18(a0)
		move.w	#0,$1A(a0)
		bra.s	loc_26DE0
; ---------------------------------------------------------------------------

loc_26DD8:
		addi.w	#$10,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_26DE0:

		move.l	#Obj_LBZElevatorCupFlicker,(a0)
		moveq	#$35,d0
		jsr	(Play_Sound_2).l
		lea	$3C(a0),a2
		lea	($FFFFB000).w,a1
		move.w	#-$300,d0
		bsr.s	sub_26E08
		lea	$3D(a0),a2
		lea	($FFFFB04A).w,a1
		move.w	#-$400,d0

; =============== S U B R O U T I N E =======================================


sub_26E08:
		move.b	#$12,2(a2)
		tst.b	(a2)
		beq.s	locret_26E52
		move.b	#4,5(a1)		; Hit animation
		bclr	#3,$2A(a1)
		bclr	#5,$2A(a1)		; Player is not standing on/pushing an object
		bset	#1,$2A(a1)
		move.w	d0,$1A(a1)
		move.w	#-$200,$18(a1)	; Set speed of player
		btst	#0,$2A(a0)
		beq.s	loc_26E46
		neg.w	$18(a1)			; Reverse direction depending on flip
		bset	#0,$2A(a1)

loc_26E46:
		move.w	#0,$1C(a1)		; Zero out inertia
		move.b	#$1A,$20(a1)	; Set falling animation

locret_26E52:
		rts
; End of function sub_26E08

; ---------------------------------------------------------------------------

Obj_LBZElevatorCupFlicker:
		jsr	(MoveSprite).l
		tst.b	4(a0)
		bmi.s	loc_26E66
		move.w	#$7FFF,$10(a0)

loc_26E66:
		move.b	($FFFFFE05).w,d0
		andi.b	#1,d0
		beq.s	locret_26E76
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

locret_26E76:
		rts
; ---------------------------------------------------------------------------

loc_26E78:
		move.w	$30(a0),d0
		andi.w	#$FF80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_26E92
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_26E92:
		move.w	$48(a0),d0
		beq.s	loc_26E9E
		movea.w	d0,a2
		bclr	#7,(a2)

loc_26E9E:
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.s	LBZCupElevator_ReleasePlayer
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.s	LBZCupElevator_ReleasePlayer
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


LBZCupElevator_ReleasePlayer:

		bclr	d6,$2A(a0)
		beq.w	locret_26ED8
		move.w	#$100,8(a1)
		clr.b	$2E(a1)
		bclr	#3,$2A(a1)
		bclr	#5,$2A(a1)
		bset	#1,$2A(a1)

locret_26ED8:
		rts
; End of function LBZCupElevator_ReleasePlayer


; =============== S U B R O U T I N E =======================================


LBZCupElevator_PlayerControl:

		tst.b	(a2)
		bne.s	loc_26F46	; If player is inside cup, branch
		tst.b	2(a2)
		beq.s	loc_26EEA	; If timer has run out, branch
		subq.b	#1,2(a2)
		rts
; ---------------------------------------------------------------------------

loc_26EEA:
		move.b	$26(a0),d0
		subi.b	#$20,d0
		cmpi.b	#$40,d0
		bcs.w	locret_2702C	; Only be solid when in proper angle position
		jsr	SolidObjectFull2_1P
		btst	d6,$2A(a0)
		beq.w	locret_2702C	; If player is not standing on elevator, don't bother
		tst.w	$34(a0)
		bne.s	loc_26F26		; If $34 is set, then initiate elevator regardless of proximity to center
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#8,d0
		bmi.w	locret_2702C
		cmpi.w	#$10,d0
		bcc.w	locret_2702C	; Otherwise only initiate elevator when close to center

loc_26F26:
		move.b	#1,(a2)			; Elevator on
		move.b	#3,$2E(a1)		; Sonic is under control of object and is not animated by normal function
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)			; Clear momentum of character
		move.b	#0,$20(a1)		; Null animation number
		bra.w	loc_26FF4
; ---------------------------------------------------------------------------

loc_26F46:
		tst.b	4(a1)
		bpl.w	loc_26FD4		; If player is offscreen somehow, branch
		cmpi.b	#4,5(a1)
		bcc.s	loc_26FD4		; If player is in hit routine, branch
		andi.b	#$70,d0
		beq.w	loc_26FF4		; If jump hasn't been pressed, branch
		tst.b	($FFFFFAA9).w
		bne.w	loc_26FF4		; If controller is disabled, branch
		move.w	#$100,8(a1)		; Reset character priority
		clr.b	$2E(a1)			; Sonic is under player control once more
		bclr	d6,$2A(a0)		; Release Solid object
		bclr	#3,$2A(a1)
		bclr	#5,$2A(a1)		; Release player from object
		bset	#1,$2A(a1)
		move.b	#0,$40(a1)		; Not jumping (?)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)		; Reset height/width
		move.b	#2,$20(a1)		; Set jumping animation
		bset	#2,$2A(a1)		; Set character in air
		bclr	#4,$2A(a1)		; Full air control to player
		move.b	#0,(a2)			; Turn off elevator
		move.b	#$12,2(a2)		; Set cooldown timer so that elevator won't restart instantly
		btst	#$A,d0
		beq.s	loc_26FC0
		move.w	#-$200,$18(a1)	; Set left speed if holding left on controller

loc_26FC0:
		btst	#$B,d0
		beq.s	loc_26FCC
		move.w	#$200,$18(a1)	; Set right speed if holding right on controller

loc_26FCC:
		move.w	#-$480,$1A(a1)	; Set jump speed regardless
		rts
; ---------------------------------------------------------------------------

loc_26FD4:

		bclr	d6,$2A(a0)		; Release player if offscreen somehow
		bclr	#3,$2A(a1)
		move.w	#$100,8(a1)
		clr.b	$2E(a1)
		move.b	#0,(a2)
		move.b	#$3C,2(a2)
		rts
; ---------------------------------------------------------------------------

loc_26FF4:

		move.w	$10(a0),$10(a1)	; Match character position to cup position
		move.w	$14(a0),d0
		subi.w	#$10,d0
		move.w	d0,$14(a1)
		move.w	#$280,8(a1)		; Set character priority
		move.b	$26(a0),d0
		addi.b	#$20,d0
		cmpi.b	#$C0,d0
		bcs.s	loc_27020
		move.w	#$100,8(a1)		; If correct angle range, set priority higher

loc_27020:
		moveq	#0,d0
		move.b	$26(a0),d0
		jmp	(loc_32610).l
; ---------------------------------------------------------------------------

locret_2702C:

		rts
; End of function LBZCupElevator_PlayerControl

; ---------------------------------------------------------------------------

Obj_LBZCupElevatorBase:
		movea.w	$40(a0),a1
		move.w	$14(a1),$14(a0)
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_LBZCupElevatorAttach:
		movea.w	$40(a0),a1
		move.w	$14(a1),$14(a0)
		move.b	$26(a1),$26(a0)		; Match angle and Y position to parent object
		move.w	#$180,8(a0)
		move.b	$26(a0),d0			; If angle is positive object has lower priority
		bpl.s	loc_27060
		move.w	#$100,8(a0)

loc_27060:
		andi.b	#-2,4(a0)
		subi.b	#$40,d0
		bpl.s	loc_27072
		ori.b	#1,4(a0)	; Flip object if angle-$40 is negative

loc_27072:
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		move.w	d1,d2
		add.w	d1,d1
		add.w	d2,d1
		asr.w	#5,d1
		add.w	$30(a0),d1
		move.w	d1,$10(a0)
		move.w	$30(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

Obj_LBZCupElevatorPole:

		move.l	#Map_LBZCupElevator,$C(a0)
		move.w	#$440D,$A(a0)
		move.b	#4,4(a0)
		move.w	#$180,8(a0)
		move.b	#8,7(a0)
		move.b	#$30,6(a0)
		move.w	$10(a0),$30(a0)
		move.w	$14(a0),$32(a0)
		move.b	#3,$22(a0)
		btst	#6,$2C(a0)
		beq.s	loc_270E4
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_270E4
		move.w	#$7F00,$10(a0)

loc_270E4:

		move.b	$2C(a0),d0
		andi.b	#$3F,d0
		beq.s	loc_270FA
		move.b	#$60,6(a0)
		move.b	#4,$22(a0)

loc_270FA:
		move.l	#loc_27100,(a0)

loc_27100:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_1A_1:
		move.l	#Map_LBZUnusedUnknown,$C(a0)
		move.w	#$43C3,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$40,7(a0)
		move.b	#$40,6(a0)
		move.w	#$200,8(a0)
		move.b	#$80,$42(a0)
		move.b	#1,$22(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_27190
		move.l	#loc_271E0,(a1)
		move.l	#Map_LBZUnusedUnknown,$C(a1)
		move.w	#$43C3,$A(a1)
		ori.b	#4,4(a1)
		move.b	#$40,7(a1)
		move.b	#$40,6(a1)
		move.w	#$200,8(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	#$80,$42(a1)
		bset	#6,4(a1)
		move.w	#6,$16(a1)
		move.w	a0,$3C(a1)

loc_27190:
		move.b	#$10,$42(a0)
		move.l	#loc_2719C,(a0)

loc_2719C:
		btst	#4,($FFFFF606).w
		beq.s	loc_271AA
		move.b	#0,$42(a0)

loc_271AA:
		btst	#5,($FFFFF606).w
		beq.s	loc_271B8
		addi.b	#1,$42(a0)

loc_271B8:
		btst	#6,($FFFFF606).w
		beq.s	loc_271C6
		subi.b	#1,$42(a0)

loc_271C6:
		moveq	#0,d1
		move.b	7(a0),d1
		moveq	#8,d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		bsr.w	sub_27270
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_271E0:
		movea.w	$3C(a0),a1
		move.b	$42(a1),$42(a0)
		bsr.w	sub_271F4
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_271F4:
		move.b	$42(a0),d0
		jsr	(GetSineCosine).l
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		swap	d0
		swap	d1
		asr.l	#5,d0
		asr.l	#5,d1
		move.l	d0,d4
		move.l	d1,d5
		add.l	d0,d0
		add.l	d1,d1
		movem.l	d0-d5,-(sp)
		add.l	d0,d4
		add.l	d1,d5
		lea	$18(a0),a2
		moveq	#2,d6

loc_27224:
		movem.l	d4-d5,-(sp)
		swap	d4
		swap	d5
		add.w	d2,d4
		add.w	d3,d5
		move.w	d5,(a2)+
		move.w	d4,(a2)+
		movem.l	(sp)+,d4-d5
		add.l	d0,d4
		add.l	d1,d5
		addq.w	#2,a2
		dbf	d6,loc_27224
		movem.l	(sp)+,d0-d5
		neg.l	d4
		neg.l	d5
		sub.l	d0,d4
		sub.l	d1,d5
		moveq	#2,d6

loc_27250:
		movem.l	d4-d5,-(sp)
		swap	d4
		swap	d5
		add.w	d2,d4
		add.w	d3,d5
		move.w	d5,(a2)+
		move.w	d4,(a2)+
		movem.l	(sp)+,d4-d5
		sub.l	d0,d4
		sub.l	d1,d5
		addq.w	#2,a2
		dbf	d6,loc_27250
		rts
; End of function sub_271F4


; =============== S U B R O U T I N E =======================================


sub_27270:
		lea	(Vectors+$30).w,a2
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d3,-(sp)
		bsr.s	sub_2728E
		movem.l	(sp)+,d1-d3
		lea	(Vectors+$34).w,a2
		lea	($FFFFB04A).w,a1
		addq.b	#1,d6
; End of function sub_27270


; =============== S U B R O U T I N E =======================================


sub_2728E:
		btst	d6,$2A(a0)
		beq.w	loc_2734C
		move.w	$1C(a1),d0
		move.b	$42(a0),d4
		addi.b	#$40,d4
		bpl.s	loc_272A6
		neg.w	d0

loc_272A6:
		add.w	d0,(a2)
		btst	#1,$2A(a1)
		bne.s	loc_272D4
		move.b	$42(a0),d0
		jsr	(GetSineCosine).l
		tst.w	d1
		bmi.s	loc_272C0
		neg.w	d1

loc_272C0:
		asr.w	#2,d1
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		cmp.w	d1,d0
		blt.s	loc_272D4
		neg.w	d1
		cmp.w	d1,d0
		blt.s	loc_272E8

loc_272D4:

		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)
		bclr	d6,$2A(a0)
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_272E8:
		bsr.w	sub_272F0
		moveq	#0,d4
		rts
; End of function sub_2728E


; =============== S U B R O U T I N E =======================================


sub_272F0:

		move.w	d3,d5
		move.b	$42(a0),d0
		jsr	(GetSineCosine).l
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		move.w	(a2),d4
		muls.w	d4,d0
		muls.w	d4,d1
		swap	d0
		swap	d1
		add.w	d0,d2
		add.w	d1,d3
		move.b	$42(a0),d0
		move.b	d0,d1
		addi.b	#$40,d1
		bpl.s	loc_27322
		addi.b	#$80,d0

loc_27322:
		move.b	d0,$26(a1)
		moveq	#0,d1
		move.b	$1E(a1),d1
		add.w	d1,d5
		lsl.w	#8,d5
		jsr	(GetSineCosine).l
		muls.w	d5,d0
		muls.w	d5,d1
		swap	d0
		swap	d1
		add.w	d0,d3
		sub.w	d1,d2
		move.w	d2,$14(a1)
		move.w	d3,$10(a1)
		rts
; End of function sub_272F0

; ---------------------------------------------------------------------------

loc_2734C:
		tst.w	$1A(a1)
		bmi.w	locret_273E2
		move.b	$42(a0),d0
		jsr	(GetSineCosine).l
		move.w	d0,d4
		move.w	d1,d2
		tst.w	d1
		bmi.s	loc_27368
		neg.w	d1

loc_27368:
		asr.w	#2,d1
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		cmp.w	d1,d0
		blt.s	locret_273E2
		neg.w	d1
		cmp.w	d1,d0
		bge.s	locret_273E2
		swap	d0
		divs.w	d2,d0
		move.w	d0,(a2)
		neg.w	d4
		muls.w	d4,d0
		swap	d0
		move.w	d3,d5
		add.w	d0,d3
		move.w	$14(a0),d0
		sub.w	d3,d0
		move.w	$14(a1),d2
		move.b	$1E(a1),d1
		ext.w	d1
		add.w	d2,d1
		addq.w	#4,d1
		sub.w	d1,d0
		bhi.s	locret_273E2
		cmpi.w	#-$10,d0
		bcs.s	locret_273E2
		tst.b	$2E(a1)
		bmi.s	locret_273E2
		cmpi.b	#6,5(a1)
		bcc.s	locret_273E2
		move.b	$42(a0),d0
		move.b	d0,d1
		addi.b	#$40,d1
		bpl.s	loc_273C8
		addi.b	#$80,d0

loc_273C8:
		jsr	(GetSineCosine).l
		muls.w	#$1B00,d0
		swap	d0
		sub.w	d0,(a2)
		move.w	d5,d3
		bsr.w	sub_272F0
		jmp	(RideObject_SetRide).l
; ---------------------------------------------------------------------------

locret_273E2:

		rts
; ---------------------------------------------------------------------------

Obj_LBZPipePlug:

		move.b	#$10,$1E(a0)
		move.l	#Map_LBZPipePlug,$C(a0)
		move.w	#$42E6,$A(a0)
		move.b	#$10,7(a0)
		move.b	#$20,6(a0)
		move.l	#word_276D8,$3C(a0)
		move.b	#4,4(a0)
		move.w	#$200,8(a0)
		move.b	#7,$22(a0)
		move.l	#loc_27424,(a0)

loc_27424:
		move.w	($FFFFB018).w,$30(a0)
		move.w	($FFFFB062).w,$32(a0)
		move.w	#$1B,d1
		move.w	#$20,d2
		move.w	#$21,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		move.b	$2A(a0),d0
		andi.b	#$60,d0
		bne.s	loc_27456

loc_27450:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_27456:
		lea	($FFFFB000).w,a1
		move.w	$30(a0),d1
		btst	#5,$2A(a0)
		beq.s	loc_274A2
		cmpi.b	#2,$20(a1)
		bne.s	loc_274A2
		move.w	d1,d0
		bpl.s	loc_27474
		neg.w	d0

loc_27474:
		cmpi.w	#$480,d0
		bcs.s	loc_274A2
		bclr	#6,$2A(a0)
		beq.s	loc_274D6
		lea	($FFFFB04A).w,a2
		bclr	#5,$2A(a2)
		cmpi.b	#2,$20(a2)
		bne.s	loc_274D6
		move.w	$32(a0),$18(a2)
		move.w	$18(a2),$1C(a2)
		bra.s	loc_274D6
; ---------------------------------------------------------------------------

loc_274A2:

		lea	($FFFFB04A).w,a1
		move.w	$32(a0),d1
		btst	#6,$2A(a0)
		beq.s	loc_27450
		cmpi.b	#2,$20(a1)
		bne.s	loc_27450
		move.w	d1,d0
		bpl.s	loc_274C0
		neg.w	d0

loc_274C0:
		cmpi.w	#$480,d0
		bcs.w	loc_27450
		bclr	#6,$2A(a0)
		beq.s	loc_274D6
		bclr	#5,($FFFFB074).w

loc_274D6:

		bclr	#5,$2A(a0)
		beq.s	loc_274E4
		bclr	#5,($FFFFB02A).w

loc_274E4:
		move.w	d1,$18(a1)
		addq.w	#4,$10(a1)
		lea	(word_276D8).l,a4
		move.w	$10(a0),d0
		cmp.w	$10(a1),d0
		bcs.s	loc_27508
		subi.w	#8,$10(a1)
		lea	(word_27718).l,a4

loc_27508:
		move.w	$18(a1),$1C(a1)
		move.b	$2C(a0),d1
		beq.s	loc_2758A
		cmpi.b	#$1F,d1
		bne.s	loc_27534
		move.b	#1,($FFFFF7C2).w
		move.w	#$660,($FFFFF64A).w
		tst.b	($FFFFFE19).w
		beq.s	loc_2755E
		move.b	#2,($FFFFF64C).w
		bra.s	loc_2755E
; ---------------------------------------------------------------------------

loc_27534:
		jsr	(Create_New_Sprite3).l
		bne.w	loc_2758A
		move.l	#Obj_AutomaticTunnelDelayed,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addq.w	#2,$14(a1)
		move.b	#7,$24(a1)
		move.b	d1,$2C(a1)

loc_2755E:

		jsr	(Create_New_Sprite3).l
		bne.w	loc_2758A
		move.l	#Obj_TunnelExhaustControl,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		subi.w	#$20,$14(a1)
		move.w	#1,$1A(a1)
		move.b	d1,$2C(a1)

loc_2758A:

		move.l	#loc_27592,(a0)
		bsr.s	sub_275F2

loc_27592:
		jsr	(MoveSprite2).l
		addi.w	#$18,$1A(a0)
		tst.b	4(a0)
		bpl.w	loc_275AC
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_275AC:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_275B2:
		moveq	#0,d0
		move.b	$23(a0),$22(a0)
		addq.b	#1,$23(a0)
		cmpi.b	#6,$23(a0)
		bcs.s	loc_275CC
		move.b	#0,$23(a0)

loc_275CC:
		jsr	(MoveSprite2).l
		addi.w	#$18,$1A(a0)
		tst.b	4(a0)
		bpl.w	loc_275AC
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
byte_275E6:	dc.b 0
		dc.b 1
		dc.b 2
		dc.b 3
		dc.b 5
		dc.b 0
		dc.b 0
		dc.b 1
		dc.b 2
		dc.b 3
		dc.b 5
		dc.b 0

; =============== S U B R O U T I N E =======================================


sub_275F2:
		lea	(byte_275E6).l,a5
		moveq	#0,d0
		move.b	$22(a0),d0
		add.w	d0,d0
		movea.l	$C(a0),a3
		lea	$1A(a3),a2
		adda.w	(a3,d0.w),a2
		move.l	#loc_275B2,d4
		move.b	4(a0),d5
		moveq	#$B,d1

loc_27618:
		jsr	(Create_New_Sprite3).l
		bne.w	loc_276D0
		move.l	d4,(a1)
		move.l	a3,$C(a1)
		move.b	d5,4(a1)
		move.w	$A(a0),$A(a1)
		move.b	8(a0),8(a1)
		move.b	7(a0),7(a1)
		move.w	(a4)+,$18(a1)
		move.w	(a4)+,$1A(a1)
		move.b	(a5)+,$22(a1)
		move.b	$22(a1),$23(a1)
		move.b	(a2),d0
		addq.w	#4,a2
		ext.w	d0
		add.w	$14(a0),d0
		move.w	d0,$14(a1)
		move.w	(a2)+,d0
		add.w	$10(a0),d0
		move.w	d0,$10(a1)
		dbf	d1,loc_27618
		moveq	#0,d0
		move.b	$22(a0),d0
		add.w	d0,d0
		movea.l	$C(a0),a3
		adda.w	(a3,d0.w),a3
		move.w	(a3)+,d1
		subq.w	#1,d1
		moveq	#3,d1
		bset	#5,4(a0)
		move.l	(a0),d4
		move.b	4(a0),d5
		movea.l	a0,a1
		bra.s	loc_2769C
; ---------------------------------------------------------------------------

loc_27692:
		jsr	(Create_New_Sprite3).l
		bne.s	loc_276D0
		addq.w	#6,a3

loc_2769C:
		move.l	d4,(a1)
		move.l	a3,$C(a1)
		move.b	d5,4(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	$A(a0),$A(a1)
		move.b	8(a0),8(a1)
		move.b	7(a0),7(a1)
		move.w	(a4)+,$18(a1)
		move.w	(a4)+,$1A(a1)
		dbf	d1,loc_27692

loc_276D0:

		moveq	#$59,d0
		jmp	(Play_Sound_2).l
; End of function sub_275F2

; ---------------------------------------------------------------------------
word_276D8:	dc.w  $FC80, $FDC0

		dc.w  $FD00, $FDB0
		dc.w  $FD80, $FDA0
		dc.w  $FE00, $FDA0
		dc.w  $FE80, $FDB0
		dc.w  $FF00, $FDC0
		dc.w  $FC80, $FF40
		dc.w  $FD00, $FF30
		dc.w  $FD80, $FF20
		dc.w  $FE00, $FF20
		dc.w  $FE80, $FF30
		dc.w  $FF00, $FF40
		dc.w  $FC00, $FD40
		dc.w  $FF00, $FD40
		dc.w  $FC00, $FF80
		dc.w  $FF00, $FF80
word_27718:	dc.w   $100, $FDC0
		dc.w   $180, $FDB0
		dc.w   $200, $FDA0
		dc.w   $280, $FDA0
		dc.w   $300, $FDB0
		dc.w   $380, $FDC0
		dc.w   $100, $FF40
		dc.w   $180, $FF30
		dc.w   $200, $FF20
		dc.w   $280, $FF20
		dc.w   $300, $FF30
		dc.w   $380, $FF40
		dc.w   $100, $FD40
		dc.w   $400, $FD40
		dc.w   $100, $FF80
		dc.w   $400, $FF80

; =============== S U B R O U T I N E =======================================


Animate_Tiles:

		moveq	#0,d0
		move.w	($FFFFFE10).w,d0
		ror.b	#1,d0
		lsr.w	#5,d0
		andi.w	#$FC,d0
		move.w	Offs_AniPLC(pc,d0.w),d1
		lea	Offs_AniFunc(pc,d1.w),a2
		move.w	Offs_AniFunc(pc,d0.w),d0
		jmp	Offs_AniFunc(pc,d0.w)
; End of function Animate_Tiles

; ---------------------------------------------------------------------------
		rts
; ---------------------------------------------------------------------------
Offs_AniFunc:	dc.w AnimateTiles_AIZ1-Offs_AniFunc

Offs_AniPLC:	dc.w AniPLC_AIZ1-Offs_AniFunc
		dc.w AnimateTiles_AIZ2-Offs_AniFunc
		dc.w AniPLC_AIZ2-Offs_AniFunc
		dc.w AnimateTiles_HCZ1-Offs_AniFunc
		dc.w AniPLC_HCZ1-Offs_AniFunc
		dc.w AnimateTiles_HCZ2-Offs_AniFunc
		dc.w AniPLC_HCZ2-Offs_AniFunc
		dc.w AnimateTiles_MGZ-Offs_AniFunc
		dc.w AniPLC_MGZ-Offs_AniFunc
		dc.w AnimateTiles_MGZ-Offs_AniFunc
		dc.w AniPLC_MGZ-Offs_AniFunc
		dc.w AnimateTiles_CNZ-Offs_AniFunc
		dc.w AniPLC_CNZ-Offs_AniFunc
		dc.w AnimateTiles_CNZ-Offs_AniFunc
		dc.w AniPLC_CNZ-Offs_AniFunc
		dc.w AnimateTiles_DoAniPLC-Offs_AniFunc
		dc.w AniPLC_FBZ1-Offs_AniFunc
		dc.w AnimateTiles_DoAniPLC-Offs_AniFunc
		dc.w AniPLC_FBZ2-Offs_AniFunc
		dc.w AnimateTiles_ICZ-Offs_AniFunc
		dc.w AniPLC_ICZ-Offs_AniFunc
		dc.w AnimateTiles_ICZ-Offs_AniFunc
		dc.w AniPLC_ICZ-Offs_AniFunc
		dc.w AnimateTiles_LBZ1-Offs_AniFunc
		dc.w AniPLC_LBZ1-Offs_AniFunc
		dc.w AnimateTiles_LBZ2-Offs_AniFunc
		dc.w AniPLC_LBZ2-Offs_AniFunc
		dc.w AnimateTiles_MHZ-Offs_AniFunc
		dc.w AniPLC_MHZ-Offs_AniFunc
		dc.w AnimateTiles_MHZ-Offs_AniFunc
		dc.w AniPLC_MHZ-Offs_AniFunc
		dc.w AnimateTiles_SOZ1-Offs_AniFunc
		dc.w AniPLC_LRZ1-Offs_AniFunc
		dc.w AnimateTiles_SOZ2-Offs_AniFunc
		dc.w AniPLC_LRZ1-Offs_AniFunc
		dc.w AnimateTiles_LRZ1-Offs_AniFunc
		dc.w AniPLC_LRZ1-Offs_AniFunc
		dc.w AnimateTiles_LRZ2-Offs_AniFunc
		dc.w AniPLC_LRZ2-Offs_AniFunc
		dc.w AnimateTiles_DoAniPLC-Offs_AniFunc
		dc.w AniPLC_SSZ-Offs_AniFunc
		dc.w AnimateTiles_SSZ2_ALZ-Offs_AniFunc
		dc.w AniPLC_SSZ-Offs_AniFunc
		dc.w AnimateTiles_DoAniPLC-Offs_AniFunc
		dc.w AniPLC_DEZ-Offs_AniFunc
		dc.w AnimateTiles_DoAniPLC-Offs_AniFunc
		dc.w AniPLC_DEZ-Offs_AniFunc
		dc.w AnimateTiles_SSZ2_ALZ-Offs_AniFunc
		dc.w AniPLC_ALZ-Offs_AniFunc
		dc.w AnimateTiles_SSZ2_ALZ-Offs_AniFunc
		dc.w AniPLC_ALZ-Offs_AniFunc
		dc.w AnimateTiles_SSZ2_ALZ-Offs_AniFunc
		dc.w AniPLC_ALZ-Offs_AniFunc
		dc.w AnimateTiles_SSZ2_ALZ-Offs_AniFunc
		dc.w AniPLC_ALZ-Offs_AniFunc
		dc.w AnimateTiles_DoAniPLC-Offs_AniFunc
		dc.w AniPLC_ALZ-Offs_AniFunc
		dc.w AnimateTiles_DoAniPLC-Offs_AniFunc
		dc.w AniPLC_ALZ-Offs_AniFunc
		dc.w AnimateTiles_DoAniPLC-Offs_AniFunc
		dc.w AniPLC_BPZ-Offs_AniFunc
		dc.w AnimateTiles_DoAniPLC-Offs_AniFunc
		dc.w AniPLC_BPZ-Offs_AniFunc
		dc.w AnimateTiles_DPZ-Offs_AniFunc
		dc.w AniPLC_DPZ-Offs_AniFunc
		dc.w AnimateTiles_DPZ-Offs_AniFunc
		dc.w AniPLC_DPZ-Offs_AniFunc
		dc.w AnimateTiles_SSZ2_ALZ-Offs_AniFunc
		dc.w AniPLC_NULL-Offs_AniFunc
		dc.w AnimateTiles_SSZ2_ALZ-Offs_AniFunc
		dc.w AniPLC_NULL-Offs_AniFunc
		dc.w AnimateTiles_SSZ2_ALZ-Offs_AniFunc
		dc.w AniPLC_NULL-Offs_AniFunc
		dc.w AnimateTiles_SSZ2_ALZ-Offs_AniFunc
		dc.w AniPLC_NULL-Offs_AniFunc
		dc.w AnimateTiles_Gumball-Offs_AniFunc
		dc.w AniPLC_NULL-Offs_AniFunc
		dc.w AnimateTiles_Gumball-Offs_AniFunc
		dc.w AniPLC_NULL-Offs_AniFunc
		dc.w AnimateTiles_Pachinko-Offs_AniFunc
		dc.w AniPLC_Pachinko-Offs_AniFunc
		dc.w AnimateTiles_Pachinko-Offs_AniFunc
		dc.w AniPLC_Pachinko-Offs_AniFunc
		dc.w AnimateTiles_SSZ2_ALZ-Offs_AniFunc
		dc.w AniPLC_NULL-Offs_AniFunc
		dc.w AnimateTiles_SSZ2_ALZ-Offs_AniFunc
		dc.w AniPLC_NULL-Offs_AniFunc
		dc.w AnimateTiles_LRZ3-Offs_AniFunc
		dc.w AniPLC_NULL-Offs_AniFunc
		dc.w AnimateTiles_DoAniPLC-Offs_AniFunc
		dc.w AniPLC_HPZ-Offs_AniFunc
		dc.w AnimateTiles_SSZ2_ALZ-Offs_AniFunc
		dc.w AnimateTiles_NULL3-Offs_AniFunc
		dc.w AnimateTiles_DoAniPLC-Offs_AniFunc
		dc.w AniPLC_HPZ-Offs_AniFunc
; ---------------------------------------------------------------------------

AnimateTiles_SSZ2_ALZ:
		rts
; ---------------------------------------------------------------------------

AnimateTiles_AIZ1:
		tst.b	($FFFFF7AA).w
		bne.s	locret_27848
		tst.b	($FFFFEE33).w
		bne.w	AnimateTiles_DoAniPLC

locret_27848:
		rts
; ---------------------------------------------------------------------------

AnimateTiles_AIZ2:
		tst.b	($FFFFF7AA).w
		bne.s	locret_2787E
		cmpi.w	#$1C0,($FFFFEE78).w
		bcc.w	AnimateTiles_DoAniPLC
		lea	($FFFFF7F0).w,a3
		addq.w	#2,a2
		moveq	#0,d6
		bsr.w	loc_286EE
		clr.l	(a3)
		clr.l	(a3)
		move.l	#ArtUnc_AniAIZ2_FirstTree,d1
		move.w	#$1940,d2
		move.w	#$230,d3
		jmp	(Add_To_DMA_Queue).l
; ---------------------------------------------------------------------------

locret_2787E:
		rts
; ---------------------------------------------------------------------------

AnimateTiles_HCZ1:
		tst.b	($FFFFEEE8).w
		beq.s	loc_27888
		rts
; ---------------------------------------------------------------------------
; ---------------------------------------------------------------------------
; This section determines which	tiles to load at what position to simulate a
; waterline extending into the background
; ---------------------------------------------------------------------------

loc_27888:
		lea	($FFFFF7F4).w,a3

loc_2788C:

		moveq	#0,d1
		move.w	($FFFFEEE2).w,d1
		cmp.w	(a3),d1
		beq.w	loc_2797A
		move.w	d1,(a3)
		tst.w	d1
		beq.w	loc_2797E
		bpl.w	loc_27912
		addi.w	#$60,d1
		bcc.w	loc_2797A
		move.w	d1,d0
		add.w	d1,d1
		add.w	d0,d1
		lsl.w	#5,d1
		lea	($FFFF7C00).l,a4
		lea	(HCZ_WaterlineScroll_Data).l,a5
		adda.w	d1,a5
		move.w	#$5F,d1

loc_278C6:
		moveq	#0,d0
		move.b	(a5)+,d0
		add.w	d0,d0
		add.w	d0,d0
		lea	(ArtUnc_AniHCZ1_WaterlineBelow).l,a0
		adda.w	d0,a0
		move.l	(a0),(a4)
		lea	$600(a0),a0
		lea	$180(a4),a4
		move.l	(a0),(a4)
		lea	-$17C(a4),a4
		dbf	d1,loc_278C6
		move.l	#$FFFF7C00,d1
		move.w	#$5B80,d2
		move.w	#$180,d3
		jsr	(Add_To_DMA_Queue).l
		tst.w	2(a3)
		bmi.s	loc_2790E
		move.w	#-1,2(a3)
		bsr.w	AniHCZ_FixLowerBG

loc_2790E:
		bra.w	loc_2797A
; ---------------------------------------------------------------------------

loc_27912:
		neg.w	d1
		addi.w	#$60,d1
		bcc.s	loc_2797A
		move.w	d1,d0
		add.w	d1,d1
		add.w	d0,d1
		lsl.w	#5,d1
		lea	($FFFF7C00).l,a4
		lea	(HCZ_WaterlineScroll_Data).l,a5
		adda.w	d1,a5
		move.w	#$5F,d1

loc_27934:
		moveq	#0,d0
		move.b	(a5)+,d0
		add.w	d0,d0
		add.w	d0,d0
		lea	(ArtUnc_AniHCZ1_WaterlineAbove).l,a0
		adda.w	d0,a0
		move.l	(a0),(a4)
		lea	$600(a0),a0
		lea	$180(a4),a4
		move.l	(a0),(a4)
		lea	-$17C(a4),a4
		dbf	d1,loc_27934
		move.l	#$FFFF7C00,d1
		move.w	#$5E80,d2
		move.w	#$180,d3
		jsr	(Add_To_DMA_Queue).l
		tst.w	2(a3)
		beq.s	loc_2797A
		move.w	#0,2(a3)
		bsr.s	AniHCZ_FixUpperBG

loc_2797A:

		bra.w	AnimateTiles_DoAniPLC
; ---------------------------------------------------------------------------

loc_2797E:

		move.w	#1,(a3)
		bsr.s	AniHCZ_FixLowerBG

; ---------------------------------------------------------------------------
; When the special waterline goes below	water, this routine loads tiles	to
; fix the background area that was affected when the waterline was above
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


AniHCZ_FixUpperBG:

		move.l	#ArtUnc_FixHCZ1_UpperBG1,d1
		move.w	#$5B80,d2
		move.w	#$C0,d3
		jsr	(Add_To_DMA_Queue).l
		move.l	#ArtUnc_FixHCZ1_UpperBG2,d1
		move.w	#$5D00,d2
		move.w	#$C0,d3
		jmp	(Add_To_DMA_Queue).l
; End of function AniHCZ_FixUpperBG

; ---------------------------------------------------------------------------
; When the special waterline goes above	water, this routine loads tiles	to
; fix the background area that was affected when the waterline was below
; ---------------------------------------------------------------------------

; =============== S U B R O U T I N E =======================================


AniHCZ_FixLowerBG:

		move.l	#ArtUnc_FixHCZ1_LowerBG1,d1
		move.w	#$5E80,d2
		move.w	#$C0,d3
		jsr	(Add_To_DMA_Queue).l
		move.l	#ArtUnc_FixHCZ1_LowerBG2,d1
		move.w	#$6000,d2
		move.w	#$C0,d3
		jmp	(Add_To_DMA_Queue).l
; End of function AniHCZ_FixLowerBG


; =============== S U B R O U T I N E =======================================


sub_279D4:
		lea	(AniPLC_HCZ1).l,a2
		lea	($FFFFF7F4).w,a3
		move.w	($FFFFEEE2).w,d1
		beq.s	loc_2797E
		bpl.s	loc_27A1C
		addi.w	#$60,d1
		bcc.s	loc_279F2
		bsr.s	AniHCZ_FixLowerBG
		bra.w	loc_2788C
; ---------------------------------------------------------------------------

loc_279F2:
		bsr.s	AniHCZ_FixLowerBG
		move.l	#ArtUnc_AniHCZ1_WaterlineBelow,d1
		move.w	#$5B80,d2
		move.w	#$C0,d3
		jsr	(Add_To_DMA_Queue).l
		move.l	#ArtUnc_AniHCZ1_WaterlineBelow2,d1
		move.w	#$5D00,d2
		move.w	#$C0,d3
		jmp	(Add_To_DMA_Queue).l
; ---------------------------------------------------------------------------

loc_27A1C:
		neg.w	d1
		addi.w	#$60,d1
		bcc.s	loc_27A2C
		bsr.w	AniHCZ_FixUpperBG
		bra.w	loc_2788C
; ---------------------------------------------------------------------------

loc_27A2C:
		bsr.w	AniHCZ_FixUpperBG
		move.l	#ArtUnc_AniHCZ1_WaterlineAbove,d1
		move.w	#$5E80,d2
		move.w	#$C0,d3
		jsr	(Add_To_DMA_Queue).l
		move.l	#ArtUnc_AniHCZ1_WaterlineAbove2,d1
		move.w	#$6000,d2
		move.w	#$C0,d3
		jmp	(Add_To_DMA_Queue).l
; End of function sub_279D4

; ---------------------------------------------------------------------------

AnimateTiles_HCZ2:
		lea	($FFFFF7F0).w,a3
		moveq	#0,d1
		move.w	($FFFFEEE4).w,d1
		andi.w	#$1F,d1
		cmp.b	1(a3),d1
		beq.s	loc_27AB4
		move.b	d1,1(a3)
		move.w	d1,d2
		andi.w	#7,d1
		lsl.w	#7,d1
		move.l	d1,d5
		andi.w	#$18,d2
		move.w	d2,d0
		lsl.w	#2,d2
		add.w	d2,d1
		lsr.w	#1,d0
		lea	word_27AB8(pc,d0.w),a4
		lea	(ArtUnc_AniHCZ2_SmallBGLine).l,a0
		move.w	#$5A40,d4
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		move.l	d5,d1
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		beq.s	loc_27AB4
		jsr	(Add_To_DMA_Queue).l

loc_27AB4:

		addq.w	#2,a3
		bra.s	loc_27AC8
; ---------------------------------------------------------------------------
word_27AB8:	dc.w $40
		dc.w 0
		dc.w $30
		dc.w $10
		dc.w $20
		dc.w $20
		dc.w $10
		dc.w $30
; ---------------------------------------------------------------------------

loc_27AC8:
		moveq	#0,d1
		move.w	($FFFFEEE4).w,d1
		andi.w	#$1F,d1
		cmp.b	1(a3),d1
		beq.s	loc_27B20
		move.b	d1,1(a3)
		move.w	d1,d2
		andi.w	#7,d1
		lsl.w	#8,d1
		move.l	d1,d5
		andi.w	#$18,d2
		move.w	d2,d0
		lsl.w	#3,d2
		add.w	d2,d1
		lsr.w	#1,d0
		lea	word_27B24(pc,d0.w),a4
		lea	(ArtUnc_AniHCZ2_2).l,a0
		move.w	#$5AC0,d4
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		move.l	d5,d1
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		beq.s	loc_27B20
		jsr	(Add_To_DMA_Queue).l

loc_27B20:

		addq.w	#2,a3
		bra.s	loc_27B34
; ---------------------------------------------------------------------------
word_27B24:	dc.w $80
		dc.w 0
		dc.w $60
		dc.w $20
		dc.w $40
		dc.w $40
		dc.w $20
		dc.w $60
; ---------------------------------------------------------------------------

loc_27B34:
		moveq	#0,d1
		move.w	($FFFFEEE6).w,d1
		andi.w	#$1F,d1
		cmp.b	1(a3),d1
		beq.s	loc_27B8C
		move.b	d1,1(a3)
		move.w	d1,d2
		andi.w	#7,d1
		ror.w	#7,d1
		move.l	d1,d5
		andi.w	#$18,d2
		move.w	d2,d0
		lsl.w	#4,d2
		add.w	d2,d1
		lsr.w	#1,d0
		lea	word_27B90(pc,d0.w),a4
		lea	(ArtUnc_AniHCZ2_3).l,a0
		move.w	#$5BC0,d4
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		move.l	d5,d1
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		beq.s	loc_27B8C
		jsr	(Add_To_DMA_Queue).l

loc_27B8C:

		addq.w	#2,a3
		bra.s	loc_27BA0
; ---------------------------------------------------------------------------
word_27B90:	dc.w $100
		dc.w 0
		dc.w $C0
		dc.w $40
		dc.w $80
		dc.w $80
		dc.w $40
		dc.w $C0
; ---------------------------------------------------------------------------

loc_27BA0:
		moveq	#0,d1
		move.w	($FFFFEEE6).w,d1
		andi.w	#$3F,d1
		cmp.b	1(a3),d1
		beq.s	loc_27C06
		move.b	d1,1(a3)
		neg.w	d1
		move.w	d1,d2
		andi.w	#7,d1
		ror.w	#7,d1
		move.w	d1,d0
		add.w	d0,d0
		add.w	d0,d1
		move.l	d1,d5
		not.w	d2
		andi.w	#$38,d2
		move.w	d2,d0
		lsl.w	#3,d2
		add.w	d2,d1
		add.w	d2,d2
		add.w	d2,d1
		lsr.w	#1,d0
		lea	word_27C0C(pc,d0.w),a4
		lea	(ArtUnc_AniHCZ2_4).l,a0
		move.w	#$5DC0,d4
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		move.l	d5,d1
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		beq.s	loc_27C06
		jsr	(Add_To_DMA_Queue).l

loc_27C06:

		addq.w	#2,a3
		bra.w	loc_286E8
; ---------------------------------------------------------------------------
word_27C0C:	dc.w $300
		dc.w 0
		dc.w $2A0
		dc.w $60
		dc.w $240
		dc.w $C0
		dc.w $1E0
		dc.w $120
		dc.w $180
		dc.w $180
		dc.w $120
		dc.w $1E0
		dc.w $C0
		dc.w $240
		dc.w $60
		dc.w $2A0
; ---------------------------------------------------------------------------

AnimateTiles_MGZ:
		tst.b	($FFFFF7AA).w
		beq.w	AnimateTiles_DoAniPLC
		rts
; ---------------------------------------------------------------------------

AnimateTiles_CNZ:
		lea	($FFFFF7F0).w,a3
		moveq	#0,d1
		move.w	($FFFFEEE2).w,d1
		sub.w	($FFFFEE8C).w,d1
		andi.w	#$3F,d1
		cmp.b	1(a3),d1
		beq.s	loc_27C96
		move.b	d1,1(a3)
		move.w	d1,d2
		andi.w	#7,d1
		ror.w	#6,d1
		move.l	d1,d5
		andi.w	#$38,d2
		move.w	d2,d0
		lsl.w	#4,d2
		add.w	d2,d1
		lsr.w	#1,d0
		lea	word_27C9C(pc,d0.w),a4
		lea	(ArtUnc_AniCNZ__6).l,a0
		move.w	#$6100,d4
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		move.l	d5,d1
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		beq.s	loc_27C96
		jsr	(Add_To_DMA_Queue).l

loc_27C96:

		addq.w	#2,a3
		bra.w	loc_286E8
; ---------------------------------------------------------------------------
word_27C9C:	dc.w $200
		dc.w 0
		dc.w $1C0
		dc.w $40
		dc.w $180
		dc.w $80
		dc.w $140
		dc.w $C0
		dc.w $100
		dc.w $100
		dc.w $C0
		dc.w $140
		dc.w $80
		dc.w $180
		dc.w $40
		dc.w $1C0
word_27CBC:	dc.w $100
		dc.w 0
		dc.w $C0
		dc.w $40
		dc.w $80
		dc.w $80
		dc.w $40
		dc.w $C0
; ---------------------------------------------------------------------------

AnimateTiles_ICZ:
		lea	($FFFFF7F0).w,a3
		moveq	#0,d0
		move.w	($FFFFEEE2).w,d0
		sub.w	($FFFFEE8C).w,d0
		andi.w	#$1F,d0
		cmp.b	1(a3),d0
		beq.s	loc_27D32
		move.b	d0,1(a3)
		move.l	d0,d1
		move.w	d0,d2
		andi.w	#7,d1
		ror.w	#7,d1
		move.l	d1,d5
		andi.w	#$18,d2
		move.w	d2,d0
		lsl.w	#4,d2
		add.w	d2,d1
		lsr.w	#1,d0
		lea	word_27CBC(pc,d0.w),a4
		lea	(ArtUnc_AniICZ__1).l,a0
		move.w	#$21C0,d4
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		move.l	d5,d1
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		beq.s	loc_27D32
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l

loc_27D32:

		addq.w	#2,a3
		tst.b	($FFFFFE11).w
		bne.w	loc_27DF8
		moveq	#0,d1
		move.w	($FFFFEE90).w,d1
		sub.w	($FFFFEEE4).w,d1
		neg.w	d1
		andi.w	#$3F,d1
		cmp.b	1(a3),d1
		beq.w	loc_27DF8
		move.b	d1,1(a3)
		add.w	d1,d1
		add.w	d1,d1
		addi.l	#ArtUnc_AniICZ__2,d1
		move.w	#$2440,d2
		move.w	#$80,d3
		jsr	(Add_To_DMA_Queue).l
		moveq	#0,d1
		move.w	($FFFFEE90).w,d1
		move.w	($FFFFEEE4).w,d0
		asr.w	#1,d0
		sub.w	d0,d1
		asr.w	#1,d0
		sub.w	d0,d1
		neg.w	d1
		andi.w	#$1F,d1
		add.w	d1,d1
		add.w	d1,d1
		addi.l	#ArtUnc_AniICZ__3,d1
		move.w	#$2540,d2
		move.w	#$40,d3
		jsr	(Add_To_DMA_Queue).l
		moveq	#0,d1
		move.w	($FFFFEE90).w,d1
		move.w	($FFFFEEE4).w,d0
		asr.w	#1,d0
		sub.w	d0,d1
		neg.w	d1
		andi.w	#$F,d1
		add.w	d1,d1
		add.w	d1,d1
		addi.l	#ArtUnc_AniICZ__4,d1
		move.w	#$25C0,d2
		move.w	#$20,d3
		jsr	(Add_To_DMA_Queue).l
		moveq	#0,d1
		move.w	($FFFFEE90).w,d1
		move.w	($FFFFEEE4).w,d0
		asr.w	#2,d0
		sub.w	d0,d1
		neg.w	d1
		andi.w	#7,d1
		add.w	d1,d1
		add.w	d1,d1
		addi.l	#ArtUnc_AniICZ__5,d1
		move.w	#$2600,d2
		move.w	#$10,d3
		jsr	(Add_To_DMA_Queue).l

loc_27DF8:

		addq.w	#2,a3
		bra.w	loc_286E8
; ---------------------------------------------------------------------------
		rts
; ---------------------------------------------------------------------------

AnimateTiles_LBZ1:
		lea	($FFFFF7F0).w,a3
		subq.b	#1,(a3)
		bcc.s	loc_27E34
		move.b	#3,(a3)
		moveq	#0,d0
		move.b	1(a3),d0
		addq.b	#1,1(a3)
		andi.b	#$F,1(a3)
		ror.w	#7,d0
		move.l	#ArtUnc_AniLBZ__0,d1
		add.l	d0,d1
		move.w	#$2C00,d2
		move.w	#$100,d3
		jsr	(Add_To_DMA_Queue).l

loc_27E34:
		addq.w	#2,a3
		moveq	#0,d0
		move.w	($FFFFEEE2).w,d0
		sub.w	($FFFFEE8C).w,d0
		andi.w	#$1F,d0
		cmp.b	1(a3),d0
		beq.s	loc_27EBC
		move.b	d0,1(a3)
		moveq	#0,d1
		move.w	d0,d2
		andi.w	#7,d0
		move.l	d0,d6
		lsl.w	#7,d0
		move.w	d0,d1
		lsl.w	#2,d0
		add.w	d0,d1
		move.l	d1,d5
		andi.w	#$18,d2
		move.w	d2,d0
		lsl.w	#2,d2
		add.w	d2,d1
		lsl.w	#2,d2
		add.w	d2,d1
		lsr.w	#1,d0
		lea	word_27EE0(pc,d0.w),a4
		lea	(ArtUnc_AniLBZ1_1).l,a0
		move.w	#$6A00,d4
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		move.l	d5,d1
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		beq.s	loc_27EA4
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l

loc_27EA4:
		move.l	d6,d1
		lsl.w	#5,d1
		lea	(ArtUnc_AniLBZ1_2).l,a0
		add.l	a0,d1
		move.w	d4,d2
		move.w	#$10,d3
		jsr	(Add_To_DMA_Queue).l

loc_27EBC:
		addq.w	#2,a3
		tst.w	(a3)+
		bne.s	loc_27ECE
		cmpi.b	#1,1(a3)
		beq.s	loc_27ED2
		move.w	#0,(a3)

loc_27ECE:
		bsr.w	loc_286E8

loc_27ED2:
		lea	($FFFFF7FC).w,a3
		lea	(AniPLC_LBZSpec).l,a2
		bra.w	loc_286E8
; ---------------------------------------------------------------------------
word_27EE0:	dc.w $140
		dc.w 0
		dc.w $F0
		dc.w $50
		dc.w $A0
		dc.w $A0
		dc.w $50
		dc.w $F0
; ---------------------------------------------------------------------------

AnimateTiles_LBZ2:
		lea	($FFFFF7F0).w,a3
		tst.b	$F(a3)
		bne.s	loc_27F64
		subq.b	#1,(a3)
		bcc.s	loc_27F2A
		move.b	#3,(a3)
		moveq	#0,d0
		move.b	1(a3),d0
		addq.b	#1,1(a3)
		andi.b	#$F,1(a3)
		ror.w	#7,d0
		move.l	#ArtUnc_AniLBZ__0,d1
		add.l	d0,d1
		move.w	#$2C00,d2
		move.w	#$100,d3
		jsr	(Add_To_DMA_Queue).l

loc_27F2A:
		addq.w	#2,a3
		moveq	#0,d1
		move.w	($FFFFEEE4).w,d1
		sub.w	($FFFFEE8C).w,d1
		andi.w	#$F,d1
		cmp.b	1(a3),d1
		beq.s	loc_27F5A
		move.b	d1,1(a3)
		lsl.w	#6,d1
		addi.l	#ArtUnc_AniLBZ2_2,d1
		move.w	#$5C60,d2
		move.w	#$20,d3
		jsr	(Add_To_DMA_Queue).l

loc_27F5A:
		addq.w	#2,a3
		bsr.s	sub_27F66
		addq.w	#4,a3
		bra.w	loc_286E8
; ---------------------------------------------------------------------------

loc_27F64:
		addq.w	#4,a3

; =============== S U B R O U T I N E =======================================


sub_27F66:

		moveq	#0,d1
		move.w	($FFFFEEE2).w,d1
		cmp.w	(a3),d1
		beq.w	locret_28048
		move.w	d1,(a3)
		tst.w	d1
		beq.w	loc_2804A
		bpl.w	loc_27FE4
		addi.w	#$40,d1
		bcc.w	locret_28048
		lsl.w	#6,d1
		lea	($FFFF7E00).l,a4
		lea	(LBZ_WaterlineScroll_Data).l,a5
		adda.w	d1,a5
		move.w	#$3F,d1

loc_27F9A:
		moveq	#0,d0
		move.b	(a5)+,d0
		add.w	d0,d0
		add.w	d0,d0
		lea	(ArtUnc_AniLBZ2_WaterlineBelow).l,a0
		adda.w	d0,a0
		move.l	(a0),(a4)
		lea	$100(a0),a0
		lea	$100(a4),a4
		move.l	(a0),(a4)
		lea	-$FC(a4),a4
		dbf	d1,loc_27F9A
		move.l	#$FFFF7E00,d1
		move.w	#$5860,d2
		move.w	#$100,d3
		jsr	(Add_To_DMA_Queue).l
		tst.w	2(a3)
		beq.s	locret_27FE2
		move.w	#0,2(a3)
		bsr.w	sub_28066

locret_27FE2:
		rts
; ---------------------------------------------------------------------------

loc_27FE4:
		neg.w	d1
		addi.w	#$40,d1
		bcc.s	locret_28048
		lsl.w	#6,d1
		lea	($FFFF7E00).l,a4
		lea	(LBZ_WaterlineScroll_Data).l,a5
		adda.w	d1,a5
		move.w	#$3F,d1

loc_28000:
		moveq	#0,d0
		move.b	(a5)+,d0
		add.w	d0,d0
		add.w	d0,d0
		lea	(ArtUnc_AniLBZ2_WaterlineAbove).l,a0
		adda.w	d0,a0
		move.l	(a0),(a4)
		lea	$100(a0),a0
		lea	$100(a4),a4
		move.l	(a0),(a4)
		lea	-$FC(a4),a4
		dbf	d1,loc_28000
		move.l	#$FFFF7E00,d1
		move.w	#$5A60,d2
		move.w	#$100,d3
		jsr	(Add_To_DMA_Queue).l
		tst.w	2(a3)
		bmi.s	locret_28046
		move.w	#-1,2(a3)
		bsr.s	sub_28052

locret_28046:
		rts
; ---------------------------------------------------------------------------

locret_28048:

		rts
; ---------------------------------------------------------------------------

loc_2804A:

		move.w	#1,2(a3)
		bsr.s	sub_28066
; End of function sub_27F66


; =============== S U B R O U T I N E =======================================


sub_28052:

		move.l	#ArtUnc_AniLBZ2_LowerBG,d1
		move.w	#$5860,d2
		move.w	#$100,d3
		jmp	(Add_To_DMA_Queue).l
; End of function sub_28052


; =============== S U B R O U T I N E =======================================


sub_28066:

		move.l	#ArtUnc_AniLBZ2_UpperBG,d1
		move.w	#$5A60,d2
		move.w	#$100,d3
		jmp	(Add_To_DMA_Queue).l
; End of function sub_28066


; =============== S U B R O U T I N E =======================================


sub_2807A:

		lea	($FFFFF7F4).w,a3
		move.w	#1,2(a3)
		move.w	($FFFFEEE2).w,d1
		beq.s	loc_2804A
		bpl.s	loc_280A6
		bsr.s	sub_28066
		move.l	#ArtUnc_AniLBZ2_WaterlineBelow,d1
		move.w	#$5860,d2
		move.w	#$100,d3
		jsr	(Add_To_DMA_Queue).l
		bra.w	sub_27F66
; ---------------------------------------------------------------------------

loc_280A6:
		bsr.s	sub_28052
		bra.w	sub_27F66
; End of function sub_2807A

; ---------------------------------------------------------------------------

AnimateTiles_MHZ:
		lea	($FFFFF7F0).w,a3
		moveq	#0,d0
		move.w	($FFFFEEE4).w,d0
		sub.w	($FFFFEE8C).w,d0
		andi.w	#$1F,d0
		cmp.b	1(a3),d0
		beq.s	loc_28110
		move.b	d0,1(a3)
		moveq	#0,d1
		move.w	d0,d2
		andi.w	#7,d0
		lsl.w	#8,d0
		move.w	d0,d1
		move.l	d1,d5
		andi.w	#$18,d2
		move.w	d2,d0
		lsl.w	#3,d2
		add.w	d2,d1
		lsr.w	#1,d0
		lea	word_28114(pc,d0.w),a4
		lea	(ArtUnc_AniMHZ__BG).l,a0
		move.w	#$3700,d4
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		move.l	d5,d1
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		beq.s	loc_28110
		jsr	(Add_To_DMA_Queue).l

loc_28110:

		addq.w	#2,a3
		bra.s	loc_28124
; ---------------------------------------------------------------------------
word_28114:	dc.w $80
		dc.w 0
		dc.w $60
		dc.w $20
		dc.w $40
		dc.w $40
		dc.w $20
		dc.w $60
; ---------------------------------------------------------------------------

loc_28124:
		moveq	#0,d1
		move.w	($FFFFEEE2).w,d1
		sub.w	($FFFFEE8C).w,d1
		andi.w	#$3F,d1
		cmp.b	1(a3),d1
		beq.s	loc_28180
		move.b	d1,1(a3)
		move.w	d1,d2
		andi.w	#7,d1
		ror.w	#6,d1
		move.l	d1,d5
		andi.w	#$38,d2
		move.w	d2,d0
		lsl.w	#4,d2
		add.w	d2,d1
		lsr.w	#1,d0
		lea	word_28198(pc,d0.w),a4
		lea	(ArtUnc_AniMHZ__BG2).l,a0
		move.w	#$3AA0,d4
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		move.l	d5,d1
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		beq.s	loc_28180
		jsr	(Add_To_DMA_Queue).l

loc_28180:

		addq.w	#2,a3
		move.b	($FFFFF7FF).w,d0
		addq.b	#2,d0
		cmpi.b	#$58,d0
		bcs.s	loc_28190
		moveq	#0,d0

loc_28190:
		move.b	d0,($FFFFF7FF).w
		bra.w	loc_286E8
; ---------------------------------------------------------------------------
word_28198:	dc.w $200
		dc.w 0
		dc.w $1C0
		dc.w $40
		dc.w $180
		dc.w $80
		dc.w $140
		dc.w $C0
		dc.w $100
		dc.w $100
		dc.w $C0
		dc.w $140
		dc.w $80
		dc.w $180
		dc.w $40
		dc.w $1C0
word_281B8:	dc.w $C0
		dc.w 0
		dc.w $90
		dc.w $30
		dc.w $60
		dc.w $60
		dc.w $30
		dc.w $90
; ---------------------------------------------------------------------------

AnimateTiles_SOZ1:
		lea	($FFFFF7F0).w,a3
		moveq	#0,d0
		move.w	($FFFFEEE2).w,d0
		sub.w	($FFFFEE8C).w,d0
		andi.w	#$1F,d0
		cmp.b	1(a3),d0
		beq.s	locret_2825A
		move.b	d0,1(a3)
		moveq	#0,d1
		move.w	d0,d2
		andi.w	#7,d0
		lsl.w	#7,d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		move.w	d0,d1
		move.l	d1,d5
		andi.w	#$18,d2
		move.w	d2,d0
		lsl.w	#2,d2
		add.w	d2,d1
		add.w	d2,d2
		add.w	d2,d1
		lsr.w	#1,d0
		lea	word_281B8(pc,d0.w),a4
		lea	(ArtUnc_AniSOZ1_BG).l,a0
		move.w	#$6600,d4
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		move.l	d5,d1
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		beq.s	loc_28236
		jsr	(Add_To_DMA_Queue).l

loc_28236:
		moveq	#0,d1
		move.b	1(a3),d1
		lsl.w	#6,d1
		move.w	d1,d0
		add.w	d1,d1
		add.w	d0,d1
		lea	(ArtUnc_AniSOZ1_BG2).l,a0
		add.l	a0,d1
		move.w	#$6780,d2
		move.w	#$60,d3
		jsr	(Add_To_DMA_Queue).l

locret_2825A:
		rts
; ---------------------------------------------------------------------------

AnimateTiles_SOZ2:
		lea	($FFFFF7F0).w,a3
		subq.b	#1,(a3)
		bpl.s	locret_282B2
		move.b	#7,(a3)
		moveq	#0,d0

loc_2826A:
		move.b	1(a3),d0
		addq.b	#1,1(a3)
		cmpi.b	#2,d0
		bcs.s	loc_2827E
		move.b	#0,1(a3)

loc_2827E:
		move.w	($FFFFF656).w,d1
		andi.w	#6,d1
		move.w	d1,d2
		lsr.w	#1,d2
		add.w	d2,d1
		cmpi.w	#6,d1
		beq.s	loc_28294
		add.w	d0,d1

loc_28294:
		lsl.w	#6,d1
		move.w	d1,d0
		add.w	d1,d1
		add.w	d0,d1
		lea	(ArtUnc_AniSOZ2_BG).l,a0
		add.l	a0,d1
		move.w	#$6600,d2
		move.w	#$60,d3
		jsr	(Add_To_DMA_Queue).l

locret_282B2:
		rts
; ---------------------------------------------------------------------------

AnimateTiles_LRZ3:
		move.w	#$2E00,d4
		move.w	#$3280,d6
		bra.s	loc_282D0
; ---------------------------------------------------------------------------

AnimateTiles_LRZ1:
		move.w	#$6400,d4
		move.w	#$6880,d6
		bra.s	loc_282D0
; ---------------------------------------------------------------------------

AnimateTiles_LRZ2:
		move.w	#$6400,d4
		move.w	#$6880,d6

loc_282D0:

		lea	($FFFFF7F0).w,a3
		moveq	#0,d0
		move.w	($FFFFEEE4).w,d0
		sub.w	($FFFFEE8C).w,d0
		subq.w	#1,d0
		divu.w	#$30,d0
		swap	d0
		cmp.b	1(a3),d0
		beq.s	loc_2833C
		move.b	d0,1(a3)
		moveq	#0,d1
		move.w	d0,d2
		andi.w	#7,d0
		lsl.w	#7,d0
		move.w	d0,d1
		lsl.w	#3,d0
		add.w	d0,d1
		move.l	d1,d5
		andi.w	#$38,d2
		move.w	d2,d0
		lsl.w	#3,d2
		add.w	d2,d1
		add.w	d2,d2
		add.w	d2,d1
		lsr.w	#1,d0
		lea	word_2834C(pc,d0.w),a4
		lea	(ArtUnc_AniLRZ__BG).l,a0
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		move.l	d5,d1
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		beq.s	loc_2833C
		jsr	(Add_To_DMA_Queue).l

loc_2833C:

		cmpi.b	#$16,($FFFFFE10).w
		beq.s	locret_2834A
		addq.w	#2,a3
		bra.w	loc_28364
; ---------------------------------------------------------------------------

locret_2834A:
		rts
; ---------------------------------------------------------------------------
word_2834C:	dc.w $240
		dc.w 0
		dc.w $1E0
		dc.w $60
		dc.w $180
		dc.w $C0
		dc.w $120
		dc.w $120
		dc.w $C0
		dc.w $180
		dc.w $60
		dc.w $1E0
; ---------------------------------------------------------------------------

loc_28364:
		moveq	#0,d0
		move.w	($FFFFEEE2).w,d0
		sub.w	($FFFFEE8C).w,d0
		andi.w	#$1F,d0
		cmp.b	1(a3),d0
		beq.s	loc_283CC
		move.b	d0,1(a3)
		moveq	#0,d1
		move.w	d0,d2
		andi.w	#7,d0
		lsl.w	#7,d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		move.w	d0,d1
		move.l	d1,d5
		andi.w	#$18,d2
		move.w	d2,d0
		lsl.w	#2,d2
		add.w	d2,d1
		add.w	d2,d2
		add.w	d2,d1
		lsr.w	#1,d0
		lea	word_283D2(pc,d0.w),a4
		lea	(ArtUnc_AniLRZ__BG2).l,a0
		move.w	d6,d4
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		move.l	d5,d1
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		beq.s	loc_283CC
		jsr	(Add_To_DMA_Queue).l

loc_283CC:

		addq.w	#2,a3
		bra.w	loc_286E8
; ---------------------------------------------------------------------------
word_283D2:	dc.w $C0
		dc.w 0
		dc.w $90
		dc.w $30
		dc.w $60
		dc.w $60
		dc.w $30
		dc.w $90
; ---------------------------------------------------------------------------

AnimateTiles_DPZ:
		lea	($FFFFF7F0).w,a3
		moveq	#0,d1
		move.w	($FFFFEEE2).w,d1
		sub.w	($FFFFEE8C).w,d1
		andi.w	#$3F,d1
		cmp.b	1(a3),d1
		beq.s	loc_28442
		move.b	d1,1(a3)
		move.w	d1,d2
		andi.w	#7,d1
		ror.w	#6,d1
		move.l	d1,d5
		andi.w	#$38,d2
		move.w	d2,d0
		lsl.w	#4,d2
		add.w	d2,d1
		lsr.w	#1,d0
		lea	word_28446(pc,d0.w),a4
		lea	(ArtUnc_AniDPZ__BG).l,a0
		move.w	#$2A60,d4
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		move.l	d5,d1
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		beq.s	loc_28442
		jsr	(Add_To_DMA_Queue).l

loc_28442:

		addq.w	#2,a3
		bra.s	loc_28466
; ---------------------------------------------------------------------------
word_28446:	dc.w $200
		dc.w 0
		dc.w $1C0
		dc.w $40
		dc.w $180
		dc.w $80
		dc.w $140
		dc.w $C0
		dc.w $100
		dc.w $100
		dc.w $C0
		dc.w $140
		dc.w $80
		dc.w $180
		dc.w $40
		dc.w $1C0
; ---------------------------------------------------------------------------

loc_28466:
		moveq	#0,d1
		move.w	($FFFFEEE4).w,d1
		sub.w	($FFFFEE70).w,d1
		andi.w	#$3F,d1
		cmp.b	1(a3),d1
		beq.s	loc_284C2
		move.b	d1,1(a3)
		move.w	d1,d2
		andi.w	#7,d1
		ror.w	#6,d1
		move.l	d1,d5
		andi.w	#$38,d2
		move.w	d2,d0
		lsl.w	#4,d2
		add.w	d2,d1
		lsr.w	#1,d0
		lea	word_28446(pc,d0.w),a4
		lea	(ArtUnc_AniDPZ__BG).l,a0
		move.w	#$2E60,d4
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		move.l	d5,d1
		add.l	a0,d1
		move.w	d4,d2
		move.w	(a4)+,d3
		beq.s	loc_284C2
		jsr	(Add_To_DMA_Queue).l

loc_284C2:

		addq.w	#2,a3
		bra.w	loc_286E8
; ---------------------------------------------------------------------------

AnimateTiles_Gumball:
		lea	($FFFFF7F0).w,a3
		moveq	#0,d1
		move.w	($FFFFEEE2).w,d1
		sub.w	($FFFFEE90).w,d1
		andi.w	#$1F,d1
		cmp.b	1(a3),d1
		beq.s	locret_284FC
		move.b	d1,1(a3)
		add.w	d1,d1
		add.w	d1,d1
		addi.l	#ArtUnc_AniGumball,d1
		move.w	#$A80,d2
		move.w	#$40,d3
		jsr	(Add_To_DMA_Queue).l

locret_284FC:
		rts
; ---------------------------------------------------------------------------

AnimateTiles_Pachinko:
		lea	($FFFFF7F0).w,a4
		tst.b	2(a4)
		bne.w	loc_285EE
		move.w	4(a4),d0
		subq.w	#4,4(a4)
		andi.w	#$7F,4(a4)
		lea	($FFFF6000).l,a2
		lea	(a2,d0.w),a2
		lea	($FFFF7000).l,a3
		move.w	#$80,d2
		moveq	#2,d1

loc_2852E:
		moveq	#3,d0

loc_28530:
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		move.l	(a2)+,(a3)+
		lea	(a2,d2.w),a2
		dbf	d0,loc_28530
		lea	$80(a3),a3
		dbf	d1,loc_2852E
		lea	($FFFF7200).l,a3
		moveq	#0,d7
		moveq	#2,d6

loc_2858A:
		moveq	#3,d5

loc_2858C:
		lea	($FFFF7000).l,a1
		movea.l	a1,a2
		adda.w	word_285CE(pc,d7.w),a1
		adda.w	word_285D6(pc,d7.w),a2
		moveq	#-1,d2
		moveq	#0,d3
		moveq	#7,d4

loc_285A2:
		move.l	(a1)+,d0
		and.l	d2,d0
		move.l	(a2)+,d1
		and.l	d3,d1
		or.l	d1,d0
		move.l	d0,(a3)+
		asl.l	#4,d2
		asl.l	#4,d3
		ori.w	#$F,d3
		dbf	d4,loc_285A2
		addq.w	#2,d7
		dbf	d5,loc_2858C
		lea	$200(a3),a3
		dbf	d6,loc_2858A
		addq.b	#1,2(a4)
		bra.s	loc_28624
; ---------------------------------------------------------------------------
word_285CE:	dc.w $180
		dc.w $120
		dc.w $C0
		dc.w $60
word_285D6:	dc.w $400
		dc.w $3A0
		dc.w $340
		dc.w $2E0
		dc.w $680
		dc.w $620
		dc.w $5C0
		dc.w $560
		dc.w $180
		dc.w $120
		dc.w $C0
		dc.w $60
; ---------------------------------------------------------------------------

loc_285EE:
		bsr.s	sub_2863E
		addq.b	#1,2(a4)
		cmpi.b	#4,2(a4)
		bcs.s	loc_28624
		move.b	#0,2(a4)
		addi.w	#$280,(a4)
		cmpi.w	#$5000,(a4)
		bcs.s	loc_28610
		move.w	#0,(a4)

loc_28610:
		move.l	#$FFFF7000,d1
		move.w	#$1D20,d2
		move.w	#$3C0,d3
		jsr	(Add_To_DMA_Queue).l

loc_28624:

		lea	(AniPLC_Pachinko).l,a2
		lea	($FFFFF7F6).w,a3
		bra.w	loc_286E8
; ---------------------------------------------------------------------------
byte_28632:	dc.b $50
		dc.b 5
		dc.b $A0
		dc.b $A
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b $A0
		dc.b $A
		dc.b $50
		dc.b 5

; =============== S U B R O U T I N E =======================================


sub_2863E:
		lea	($FFFF7000).l,a3
		moveq	#0,d0
		move.b	2(a4),d0
		subq.b	#1,d0
		move.w	d0,d3
		lsl.w	#7,d0
		move.w	d0,d1
		lsl.w	#2,d0
		add.w	d1,d0
		adda.w	d0,a3
		lsl.w	#2,d3
		lea	byte_28632(pc,d3.w),a1
		move.b	(a1)+,d3
		move.b	(a1)+,d4
		move.b	(a1)+,d5
		move.b	(a1)+,d6
		lea	($FFFF1000).l,a1
		adda.w	(a4),a1
		move.w	#$1FF,d2

loc_28672:
		move.b	(a1)+,d0
		beq.s	loc_28694
		move.b	d0,d1
		andi.b	#-$10,d0
		beq.s	loc_28686
		andi.b	#$F,(a3)
		add.b	d3,d0
		or.b	d0,(a3)

loc_28686:
		andi.b	#$F,d1
		beq.s	loc_28694
		andi.b	#-$10,(a3)
		add.b	d4,d1
		or.b	d1,(a3)

loc_28694:

		addq.w	#1,a3
		dbf	d2,loc_28672
		move.w	#$7F,d2

loc_2869E:
		move.b	(a1)+,d0
		beq.s	loc_286DC
		move.b	d0,d1
		andi.b	#-$10,d0
		beq.s	loc_286BE
		bmi.s	loc_286B6
		andi.b	#$F,(a3)
		add.b	d3,d0
		or.b	d0,(a3)
		bra.s	loc_286BE
; ---------------------------------------------------------------------------

loc_286B6:
		andi.b	#$F,(a3)
		sub.b	d5,d0
		or.b	d0,(a3)

loc_286BE:

		andi.b	#$F,d1
		beq.s	loc_286DC
		btst	#3,d1
		bne.s	loc_286D4
		andi.b	#-$10,(a3)
		add.b	d4,d1
		or.b	d1,(a3)
		bra.s	loc_286DC
; ---------------------------------------------------------------------------

loc_286D4:
		andi.b	#-$10,(a3)
		sub.b	d6,d1
		or.b	d1,(a3)

loc_286DC:

		addq.w	#1,a3
		dbf	d2,loc_2869E
		rts
; End of function sub_2863E


; =============== S U B R O U T I N E =======================================


AnimateTiles_DoAniPLC:

		lea	($FFFFF7F0).w,a3

loc_286E8:

		move.w	(a2)+,d6
		bpl.s	loc_286EE
		rts
; ---------------------------------------------------------------------------

loc_286EE:
					; AnimateTiles_DoAniPLC+6j ...
		subq.b	#1,(a3)
		bcc.s	loc_28734
		moveq	#0,d0
		move.b	1(a3),d0
		cmp.b	6(a2),d0
		bcs.s	loc_28704
		moveq	#0,d0
		move.b	d0,1(a3)

loc_28704:
		addq.b	#1,1(a3)
		move.b	(a2),(a3)
		bpl.s	loc_28712
		add.w	d0,d0
		move.b	9(a2,d0.w),(a3)

loc_28712:
		move.b	8(a2,d0.w),d0
		lsl.w	#5,d0
		move.w	4(a2),d2
		move.l	(a2),d1
		andi.l	#$FFFFFF,d1
		add.l	d0,d1
		moveq	#0,d3
		move.b	7(a2),d3
		lsl.w	#4,d3
		jsr	(Add_To_DMA_Queue).l

loc_28734:
		move.b	6(a2),d0
		tst.b	(a2)
		bpl.s	loc_2873E
		add.b	d0,d0

loc_2873E:
		addq.b	#1,d0
		andi.w	#$FE,d0
		lea	8(a2,d0.w),a2
		addq.w	#2,a3
		dbf	d6,loc_286EE
		rts
; End of function AnimateTiles_DoAniPLC

; ---------------------------------------------------------------------------
AniPLC_AIZ1:	dc.w 2
		dc.l ArtUnc_AniAIZ1_0-$1000000
		dc.w $5CC0
		dc.b 9
		dc.b $C
		dc.b  $3C, $4F
		dc.b  $30,   5
		dc.b  $18,   5
		dc.b   $C,   5
		dc.b	0, $4F
		dc.b   $C,   3
		dc.b  $18,   3
		dc.b  $24,   1
		dc.b  $30,   1
		dc.l ArtUnc_AniAIZ1_0-$1000000
		dc.w $5E40
		dc.b 8
		dc.b $C
		dc.b  $18,   5
		dc.b  $24,   5
		dc.b  $30,   5
		dc.b  $3C, $27
		dc.b	0,   5
		dc.b   $C,   5
		dc.b  $18,   5
		dc.b  $24,   5
		dc.l ArtUnc_AniAIZ1_1-$1000000
		dc.w $5FC0
		dc.b 8
		dc.b 6
		dc.b	0,   7
		dc.b	6,   3
		dc.b   $C,   3
		dc.b  $12,   3
		dc.b  $18,   7
		dc.b  $12,   3
		dc.b   $C,   3
		dc.b	6,   3
AniPLC_AIZ2:	dc.w 4
		dc.l ArtUnc_AniAIZ2_0+$3000000
		dc.w $1660
		dc.b 4
		dc.b $17
		dc.b	0, $17
		dc.b  $2E, $45
		dc.l ArtUnc_AniAIZ2_1-$1000000
		dc.w $1940
		dc.b 9
		dc.b $C
		dc.b  $3C, $4F
		dc.b  $30,   5
		dc.b  $18,   5
		dc.b   $C,   5
		dc.b	0, $4F
		dc.b   $C,   3
		dc.b  $18,   3
		dc.b  $24,   1
		dc.b  $30,   1
		dc.l ArtUnc_AniAIZ2_1-$1000000
		dc.w $1AC0
		dc.b 8
		dc.b $C
		dc.b  $18,   5
		dc.b  $24,   5
		dc.b  $30,   5
		dc.b  $3C, $27
		dc.b	0,   5
		dc.b   $C,   5
		dc.b  $18,   5
		dc.b  $24,   5
		dc.l ArtUnc_AniAIZ2_2+$3000000
		dc.w $1C40
		dc.b 4
		dc.b 4
		dc.b	0,   4
		dc.b	8,  $C
		dc.l ArtUnc_AniAIZ2_3+$3000000
		dc.w $1CC0
		dc.b 4
		dc.b $18
		dc.b	0, $18
		dc.b  $30, $48
AniPLC_HCZ1:	dc.w 1
		dc.l ArtUnc_AniHCZ1_0-$1000000
		dc.w $6180
		dc.b 3
		dc.b $24
		dc.b	0,   2
		dc.b  $24,   1
		dc.b  $48,   2
		dc.l ArtUnc_AniHCZ__1-$1000000
		dc.w $22A0
		dc.b $10
		dc.b 6
		dc.b	0,   4
		dc.b	6,   3
		dc.b   $C,   2
		dc.b  $12,   1
		dc.b  $18,   0
		dc.b  $1E,   1
		dc.b  $24,   2
		dc.b  $2A,   3
		dc.b  $30,   4
		dc.b  $2A,   3
		dc.b  $24,   2
		dc.b  $1E,   1
		dc.b  $18,   0
		dc.b  $12,   1
		dc.b   $C,   2
		dc.b	6,   3
AniPLC_HCZ2:	dc.w 1
		dc.l ArtUnc_AniHCZ2_0+$3000000
		dc.w $4BC0
		dc.b 4
		dc.b $15
		dc.b	0, $15
		dc.b  $2A, $3F
		dc.l ArtUnc_AniHCZ__1-$1000000
		dc.w $22A0
		dc.b $10
		dc.b 6
		dc.b	0,   4
		dc.b	6,   3
		dc.b   $C,   2
		dc.b  $12,   1
		dc.b  $18,   0
		dc.b  $1E,   1
		dc.b  $24,   2
		dc.b  $2A,   3
		dc.b  $30,   4
		dc.b  $2A,   3
		dc.b  $24,   2
		dc.b  $1E,   1
		dc.b  $18,   0
		dc.b  $12,   1
		dc.b   $C,   2
		dc.b	6,   3
AniPLC_MGZ:	dc.w 1
		dc.l ArtUnc_AniMGZ__0+$9000000
		dc.w $4440
		dc.b 6
		dc.b $30
		dc.b	0, $30
		dc.b  $60, $90
		dc.b  $C0, $F0
		dc.l ArtUnc_AniMGZ__1-$1000000
		dc.w $4A40
		dc.b 4
		dc.b 1
		dc.b	0,   7
		dc.b	1,  $E
		dc.b	2,   7
		dc.b	1,  $E
AniPLC_CNZ:	dc.w 6
		dc.l ArtUnc_AniCNZ__0+$3000000
		dc.w $5640
		dc.b $10
		dc.b 9
		dc.b	0, $12
		dc.b  $24, $36
		dc.b  $48, $5A
		dc.b  $6C, $7E
		dc.b	9, $1B
		dc.b  $2D, $3F
		dc.b  $51, $63
		dc.b  $75, $87
		dc.l ArtUnc_AniCNZ__0+$3000000
		dc.w $5760
		dc.b $10
		dc.b 9
		dc.b	9, $1B
		dc.b  $2D, $3F
		dc.b  $51, $63
		dc.b  $75, $87
		dc.b	0, $12
		dc.b  $24, $36
		dc.b  $48, $5A
		dc.b  $6C, $7E
		dc.l ArtUnc_AniCNZ__1+$3000000
		dc.w $5880
		dc.b $10
		dc.b $10
		dc.b	0, $10
		dc.b  $20, $30
		dc.b  $40, $50
		dc.b  $60, $70
		dc.b  $80, $90
		dc.b  $A0, $B0
		dc.b  $C0, $D0
		dc.b  $E0, $F0
		dc.l ArtUnc_AniCNZ__2+$3000000
		dc.w $5A80
		dc.b 8
		dc.b $20
		dc.b	0, $20
		dc.b  $40, $60
		dc.b  $80, $A0
		dc.b  $C0, $E0
		dc.l ArtUnc_AniCNZ__3+$3000000
		dc.w $5E80
		dc.b 8
		dc.b $10
		dc.b	0, $10
		dc.b  $20, $30
		dc.b  $40, $50
		dc.b  $60, $70
		dc.l ArtUnc_AniCNZ__4+$3000000
		dc.w $6080
		dc.b 6
		dc.b 4
		dc.b	0,   4
		dc.b	8,   0
		dc.b	4,   8
		dc.l ArtUnc_AniCNZ__5+$1000000
		dc.w $6500
		dc.b 4
		dc.b $14
		dc.b	0, $14
		dc.b  $28, $3C
AniPLC_FBZ1:	dc.w 4
		dc.l ArtUnc_AniFBZ__0+$3F000000
		dc.w $4200
		dc.b 2
		dc.b $20
		dc.b   0 ;
		dc.b   0 ;
		dc.l ArtUnc_AniFBZ__1+$7000000
		dc.w $4600
		dc.b 6
		dc.b 8
		dc.b	0,   8
		dc.b  $10,   0
		dc.b	8, $10
		dc.l ArtUnc_AniFBZ__2+$1000000
		dc.w $4700
		dc.b 8
		dc.b $10
		dc.b	0, $10
		dc.b  $20, $30
		dc.b  $40, $50
		dc.b  $60, $70
		dc.l ArtUnc_AniFBZ__3+$7000000
		dc.w $4000
		dc.b 2
		dc.b 8
		dc.b	0,   8
		dc.l ArtUnc_AniFBZ__4+$7000000
		dc.w $4100
		dc.b 6
		dc.b 8
		dc.b	0,   8
		dc.b  $10,   0
		dc.b	8, $10
AniPLC_FBZ2:	dc.w 4
		dc.l ArtUnc_AniFBZ__0+$1000000
		dc.w $4200
		dc.b 8
		dc.b $20
		dc.b	0, $20
		dc.b  $40, $60
		dc.b  $80, $A0
		dc.b  $C0, $E0
		dc.l ArtUnc_AniFBZ__1+$7000000
		dc.w $4600
		dc.b 6
		dc.b 8
		dc.b	0,   8
		dc.b  $10,   0
		dc.b	8, $10
		dc.l ArtUnc_AniFBZ__2+$1000000
		dc.w $4700
		dc.b 8
		dc.b $10
		dc.b	0, $10
		dc.b  $20, $30
		dc.b  $40, $50
		dc.b  $60, $70
		dc.l ArtUnc_AniFBZ__3+$7000000
		dc.w $4000
		dc.b 2
		dc.b 8
		dc.b	0,   8
		dc.l ArtUnc_AniFBZ__4+$7000000
		dc.w $4100
		dc.b 6
		dc.b 8
		dc.b	0,   8
		dc.b  $10,   0
		dc.b	8, $10
AniPLC_ICZ:	dc.w 0
		dc.l ArtUnc_AniICZ__0+$3000000
		dc.w $23C0
		dc.b 8
		dc.b 4
		dc.b	0,   4
		dc.b	8,  $C
		dc.b  $10, $14
		dc.b  $18, $1C
AniPLC_LBZ1:	dc.w 0
		dc.l ArtUnc_AniLBZ1_0+$2000000
		dc.w $6CA0
		dc.b 4
		dc.b 8
		dc.b	0,   8
		dc.b  $10, $18
AniPLC_LBZSpec:	dc.w 1
		dc.l ArtUnc_AniLBZ2_0+$7000000
		dc.w $2E00
		dc.b 4
		dc.b 5
		dc.b	0,   5
		dc.b   $A,  $F
		dc.l ArtUnc_AniLBZ2_1+$7000000
		dc.w $2EA0
		dc.b 6
		dc.b 4
		dc.b	0,   4
		dc.b	8,  $C
		dc.b  $10, $14
AniPLC_LBZ2:	dc.w 1
		dc.l ArtUnc_AniLBZ2_0+$7000000
		dc.w $2E00
		dc.b 4
		dc.b 5
		dc.b	0,   5
		dc.b   $A,  $F
		dc.l ArtUnc_AniLBZ2_1+$7000000
		dc.w $2EA0
		dc.b 6
		dc.b 4
		dc.b	0,   4
		dc.b	8,  $C
		dc.b  $10, $14
AniPLC_MHZ:	dc.w 3
		dc.l ArtUnc_AniMHZ__0-$1000000
		dc.w $4A0
		dc.b $14
		dc.b 4
		dc.b	0, $18
		dc.b	4,   0
		dc.b	0,   0
		dc.b	4,   0
		dc.b	8,   0
		dc.b	4,   0
		dc.b	8,   0
		dc.b   $C,   0
		dc.b	8,   0
		dc.b   $C,   0
		dc.b	8,   0
		dc.b   $C,   0
		dc.b  $10,   0
		dc.b   $C,   0
		dc.b  $10,   0
		dc.b  $14,   0
		dc.b  $10,   0
		dc.b  $14, $31
		dc.b	0,   0
		dc.b  $14,   0
		dc.l ArtUnc_AniMHZ__1-$1000000
		dc.w $320
		dc.b $C
		dc.b 4
		dc.b	0, $1D
		dc.b	4,   0
		dc.b	0,   0
		dc.b	4,   0
		dc.b	0,   0
		dc.b	4,   0
		dc.b	0,   0
		dc.b	4,   1
		dc.b	8, $1D
		dc.b   $C,   4
		dc.b  $10,   4
		dc.b  $14,   4
		dc.l ArtUnc_AniMHZ__2-$1000000
		dc.w $BA0
		dc.b 8
		dc.b 8
		dc.b	0,   4
		dc.b	8,   4
		dc.b  $10,   6
		dc.b	8,   4
		dc.b	0,   4
		dc.b  $18,   4
		dc.b  $20,   6
		dc.b  $18,   4
		dc.l ArtUnc_AniMHZ__3-$1000000
		dc.w $3A0
		dc.b 8
		dc.b 8
		dc.b  $10,   6
		dc.b	8,   4
		dc.b	0,   4
		dc.b  $18,   4
		dc.b  $20,   6
		dc.b  $18,   4
		dc.b	0,   4
		dc.b	8,   4
AniPLC_LRZ1:	dc.w 1
		dc.l ArtUnc_AniLRZ1_0+$5000000
		dc.w $6A80
		dc.b 4
		dc.b 4
		dc.b	0,   4
		dc.b	8,  $C
		dc.l ArtUnc_AniLRZ1_1+$5000000
		dc.w $6A00
		dc.b 4
		dc.b 4
		dc.b	0,   4
		dc.b	8,  $C
AniPLC_LRZ2:	dc.w 1
		dc.l ArtUnc_AniLRZ2_0-$1000000
		dc.w $6B00
		dc.b 3
		dc.b 6
		dc.b	0,   2
		dc.b	6,   2
		dc.b   $C,   1
		dc.l ArtUnc_AniLRZ2_1+$1000000
		dc.w $6A00
		dc.b 8
		dc.b 8
		dc.b	0, $38
		dc.b  $30, $28
		dc.b  $20, $18
		dc.b  $10,   8
AniPLC_SSZ:	dc.w 5
		dc.l ArtUnc_AniSSZ__0+$7000000
		dc.w $3E60
		dc.b 4
		dc.b $24
		dc.b	0, $24
		dc.b  $48, $6C
		dc.l ArtUnc_AniSSZ__1+$7000000
		dc.w $42E0
		dc.b 4
		dc.b 8
		dc.b	0,   8
		dc.b  $10, $18
		dc.l ArtUnc_AniSSZ__2+$7000000
		dc.w $43E0
		dc.b 3
		dc.b 8
		dc.b	0,   8
		dc.b  $10, $18
		dc.l ArtUnc_AniSSZ__3+$2000000
		dc.w $3B20
		dc.b 4
		dc.b 9
		dc.b	0,   9
		dc.b  $12, $1B
		dc.l ArtUnc_AniSSZ__4+$2000000
		dc.w $3C40
		dc.b 4
		dc.b 4
		dc.b	0,   4
		dc.b	8,  $C
		dc.l ArtUnc_AniSSZ__5+$2000000
		dc.w $3CC0
		dc.b 4
		dc.b $D
		dc.b	0,  $D
		dc.b  $1A, $27
AniPLC_DEZ:	dc.w 7
		dc.l ArtUnc_AniDEZ__0
		dc.w $1C80
		dc.b 2
		dc.b 2
		dc.b	0,   2
		dc.l ArtUnc_AniDEZ__1+$1000000
		dc.w $3E80
		dc.b 6
		dc.b $1E
		dc.b	0, $1E
		dc.b  $3C,   0
		dc.b  $1E, $3C
		dc.l ArtUnc_AniDEZ__2+$3000000
		dc.w $1D80
		dc.b 8
		dc.b 4
		dc.b	0,   4
		dc.b	8,  $C
		dc.b  $10, $14
		dc.b  $18, $1C
		dc.l ArtUnc_AniDEZ__3-$1000000
		dc.w $BE0
		dc.b 4
		dc.b 6
		dc.b	0,   9
		dc.b	6,   4
		dc.b   $C,   9
		dc.b	6,   4
		dc.l ArtUnc_AniDEZ__4+$4000000
		dc.w $960
		dc.b 4
		dc.b 2
		dc.b	0,   2
		dc.b	4,   2
		dc.l ArtUnc_AniDEZ__5+$4000000
		dc.w $D60
		dc.b 6
		dc.b 3
		dc.b	0,   3
		dc.b	6,   0
		dc.b	3,   6
		dc.l ArtUnc_AniDEZ__6+$1000000
		dc.w $500
		dc.b 2
		dc.b 8
		dc.b	0,   8
		dc.l ArtUnc_AniDEZ__7
		dc.w $4DA0
		dc.b $84
		dc.b 5
		dc.b	0, $2D
		dc.b	0, $2D
		dc.b	0, $2D
		dc.b	0, $2D
		dc.b	0, $2D
		dc.b	0, $2D
		dc.b	5, $2D
		dc.b	5, $2D
		dc.b	5, $2D
		dc.b	5, $2D
		dc.b	5, $2D
		dc.b	5, $2D
		dc.b   $A, $2D
		dc.b   $A, $2D
		dc.b   $A, $2D
		dc.b   $A, $2D
		dc.b   $A, $2D
		dc.b   $A, $2D
		dc.b   $F, $2D
		dc.b   $F, $2D
		dc.b   $F, $2D
		dc.b   $F, $2D
		dc.b   $F, $2D
		dc.b   $F, $2D
		dc.b  $14, $2D
		dc.b  $14, $2D
		dc.b  $14, $2D
		dc.b  $14, $2D
		dc.b  $14, $2D
		dc.b  $14, $2D
		dc.b  $19, $2D
		dc.b  $19, $2D
		dc.b  $19, $2D
		dc.b  $19, $2D
		dc.b  $19, $2D
		dc.b  $19, $2D
		dc.b  $1E, $2D
		dc.b  $1E, $2D
		dc.b  $1E, $2D
		dc.b  $1E, $2D
		dc.b  $1E, $2D
		dc.b  $1E, $2D
		dc.b  $23, $2D
		dc.b  $23, $2D
		dc.b  $23, $2D
		dc.b  $23, $2D
		dc.b  $23, $2D
		dc.b  $23, $2D
		dc.b  $28, $2D
		dc.b  $28, $2D
		dc.b  $28, $2D
		dc.b  $28, $2D
		dc.b  $28, $2D
		dc.b  $28, $2D
		dc.b  $28, $2D
		dc.b  $28, $2D
		dc.b  $28, $2D
		dc.b  $28, $2D
		dc.b  $28, $2D
		dc.b  $28, $2D
		dc.b  $28, $2D
		dc.b  $28, $2D
		dc.b  $28, $2D
		dc.b  $28, $2D
		dc.b  $28, $2D
		dc.b  $28, $2D
AniPLC_ALZ:	dc.w 0
		dc.l ArtUnc_AniALZ+$9000000
		dc.w $4700
		dc.b 3
		dc.b $10
		dc.b	0, $10
		dc.b  $20,   0
AniPLC_BPZ:	dc.w 3
		dc.l ArtUnc_AniBPZ__0+$7000000
		dc.w $2300
		dc.b 6
		dc.b 7
		dc.b	0,   7
		dc.b   $E, $15
		dc.b  $1C, $23
		dc.l ArtUnc_AniBPZ__1+$5000000
		dc.w $23E0
		dc.b $A
		dc.b 8
		dc.b	0,   8
		dc.b  $10, $18
		dc.b  $20,   0
		dc.b	8, $10
		dc.b  $18, $20
		dc.l ArtUnc_AniBPZ__2+$2000000
		dc.w $24E0
		dc.b 2
		dc.b 3
		dc.b	0,   3
		dc.l ArtUnc_AniBPZ__3+$4000000
		dc.w $2540
		dc.b 2
		dc.b 1
		dc.b	0,   1
AniPLC_DPZ:	dc.w 0
		dc.l ArtUnc_AniDPZ+$B000000
		dc.w $28E0
		dc.b 5
		dc.b $C
		dc.b	0,  $C
		dc.b  $18, $24
		dc.b  $30,   0
AniPLC_Pachinko:dc.w 0

		dc.l ArtUnc_AniPachinko
		dc.w $24A0
		dc.b 8
		dc.b $26
		dc.b  $26,   0
		dc.b  $4C,   0
		dc.b  $72,   0
		dc.b  $98,   0
AniPLC_NULL:	dc.w $FFFF
AniPLC_HPZ:	dc.w 3
		dc.l ArtUnc_AniHPZ__0+$2000000
		dc.w $5A00
		dc.b 8
		dc.b 3
		dc.b	0,   3
		dc.b	6,   9
		dc.b   $C,  $F
		dc.b  $12, $15
		dc.l ArtUnc_AniHPZ__1+$3000000
		dc.w $5A60
		dc.b 6
		dc.b 2
		dc.b	0,   2
		dc.b	4,   6
		dc.b	8,  $A
		dc.l ArtUnc_AniHPZ__2+$2000000
		dc.w $5AA0
		dc.b 8
		dc.b 4
		dc.b	0,   4
		dc.b	8,  $C
		dc.b  $10, $14
		dc.b  $18, $1C
		dc.l ArtUnc_AniHPZ__3+$3000000
		dc.w $5B20
		dc.b 6
		dc.b 3
		dc.b	0,   3
		dc.b	6,   9
		dc.b   $C,  $F
; ---------------------------------------------------------------------------

AnimateTiles_NULL3:
		rts

; =============== S U B R O U T I N E =======================================


Animate_Init:
		cmpi.w	#$100,($FFFFFE10).w
		bne.s	loc_28C8C
		bsr.w	sub_279D4

loc_28C8C:
		cmpi.w	#$101,($FFFFFE10).w
		bne.s	loc_28CA0
		move.b	#$20,($FFFFF7F1).w
		move.b	#$40,($FFFFF7F3).w

loc_28CA0:
		cmpi.b	#3,($FFFFFE10).w
		bne.s	loc_28CD8
		move.b	#$40,($FFFFF7F1).w
		move.b	#0,($FFFFF7F2).w
		move.b	#0,($FFFFF7F4).w
		move.b	#0,($FFFFF7F6).w
		move.b	#2,($FFFFF7F8).w
		move.b	#2,($FFFFF7FA).w
		move.b	#2,($FFFFF7FC).w
		move.b	#1,($FFFFF7FE).w

loc_28CD8:
		cmpi.w	#$600,($FFFFFE10).w
		bne.s	loc_28CE6
		move.b	#$20,($FFFFF7F3).w

loc_28CE6:
		cmpi.w	#$601,($FFFFFE10).w
		bne.s	loc_28CF8
		bsr.w	sub_2807A
		move.b	#$10,($FFFFF7F1).w

loc_28CF8:
		cmpi.b	#7,($FFFFFE10).w
		bne.s	loc_28D0C
		move.b	#$20,($FFFFF7F1).w
		move.b	#$40,($FFFFF7F3).w

loc_28D0C:
		cmpi.b	#8,($FFFFFE10).w
		bne.s	loc_28D1A
		move.b	#-1,($FFFFF7F1).w

loc_28D1A:
		cmpi.w	#$900,($FFFFFE10).w
		bne.s	loc_28D2E
		move.b	#-1,($FFFFF7F1).w
		move.b	#-1,($FFFFF7F3).w

loc_28D2E:
		cmpi.w	#$1000,($FFFFFE10).w
		bne.s	loc_28D42
		move.b	#$40,($FFFFF7F1).w
		move.b	#$40,($FFFFF7F3).w

loc_28D42:
		cmpi.b	#$14,($FFFFFE10).w
		bne.s	loc_28DA2
		lea	(ArtKos_PachinkoBG1).l,a0
		lea	($FFFF1000).l,a1
		jsr	(Kos_Decomp).l
		lea	(ArtKos_PachinkoBG2).l,a0
		lea	($FFFF7000).l,a1
		jsr	(Kos_Decomp).l
		lea	($FFFF6000).l,a1
		lea	($FFFF7000).l,a2
		moveq	#$B,d0

loc_28D7C:
		moveq	#$1F,d1

loc_28D7E:
		move.l	(a2),$80(a1)
		move.l	(a2)+,(a1)+
		dbf	d1,loc_28D7E
		lea	$80(a1),a1
		dbf	d0,loc_28D7C
		lea	(PalKos_Pachinko).l,a0
		lea	($FFFF7800).l,a1
		jsr	(Kos_Decomp).l

loc_28DA2:
		cmpi.w	#$1600,($FFFFFE10).w
		bne.s	locret_28DB6
		move.b	#-1,($FFFFF7F1).w
		move.b	#-1,($FFFFF7F3).w

locret_28DB6:
		rts
; End of function Animate_Init

; ---------------------------------------------------------------------------

Obj_LBZSpinLauncher:

		move.l	#Map_LBZSpinLauncher,$C(a0)
		move.w	#$42EA,$A(a0)
		move.b	#$20,7(a0)
		move.b	#$20,6(a0)
		ori.b	#4,4(a0)
		move.w	#$80,8(a0)
		move.l	#loc_28DE4,(a0)

loc_28DE4:
		move.w	#$2B,d1
		move.w	#$10,d2
		move.w	$10(a0),d4
		lea	(byte_28FF4).l,a2
		lea	$2E(a0),a4
		tst.b	(a4)
		beq.s	loc_28E02
		subq.b	#1,(a4)
		bra.s	loc_28E1E
; ---------------------------------------------------------------------------

loc_28E02:
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		jsr	(sub_1DD24).l
		cmpi.w	#-2,d4
		bne.s	loc_28E1A
		bsr.s	sub_28E76

loc_28E1A:
		movem.l	(sp)+,d1-d4

loc_28E1E:
		addq.w	#1,a4
		tst.b	(a4)
		beq.s	loc_28E28
		subq.b	#1,(a4)
		bra.s	loc_28E3C
; ---------------------------------------------------------------------------

loc_28E28:
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		jsr	(sub_1DD24).l
		cmpi.w	#-2,d4
		bne.s	loc_28E3C
		bsr.s	sub_28E76

loc_28E3C:

		move.b	$2A(a0),d6
		andi.b	#$18,d6
		beq.s	loc_28E70
		move.b	d6,d0
		andi.b	#8,d0
		beq.s	loc_28E5C
		lea	$2E(a0),a4
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.w	sub_28F40

loc_28E5C:
		andi.b	#$10,d6
		beq.s	loc_28E70
		lea	$2F(a0),a4
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.w	sub_28F40

loc_28E70:

		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_28E76:

		btst	#0,$2A(a0)
		bne.s	loc_28EDE
		move.w	$10(a1),d0
		sub.w	$10(a0),d0

loc_28E86:
		addi.w	#$18,d0
		cmpi.w	#$30,d0
		bcc.s	locret_28EDC
		move.w	$10(a0),d0
		addi.w	#$10,d0
		move.w	d0,$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	#0,$18(a1)
		move.w	#-$A00,$1A(a1)
		move.w	#$800,$1C(a1)
		bset	#1,$2A(a1)
		move.b	#0,$40(a1)
		bset	#2,$2A(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		move.b	#$10,(a4)

locret_28EDC:

		rts
; ---------------------------------------------------------------------------

loc_28EDE:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		neg.w	d0
		addi.w	#$18,d0
		cmpi.w	#$30,d0
		bcc.s	locret_28EDC
		move.w	$10(a0),d0
		subi.w	#$10,d0
		move.w	d0,$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	#0,$18(a1)
		move.w	#-$A00,$1A(a1)
		move.w	#$800,$1C(a1)
		bset	#1,$2A(a1)
		move.b	#0,$40(a1)
		bset	#2,$2A(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		move.b	#$10,(a4)
		rts
; End of function sub_28E76


; =============== S U B R O U T I N E =======================================


sub_28F40:

		btst	#0,$2A(a0)
		bne.s	loc_28F9C
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		cmpi.w	#$20,d0
		bcc.s	locret_28EDC
		move.w	$10(a0),d0
		addi.w	#$10,d0
		move.w	d0,$10(a1)
		move.w	#0,$18(a1)
		move.w	#0,$1A(a1)
		move.w	#0,$1C(a1)
		bset	#1,$2A(a1)
		move.b	#0,$40(a1)
		bclr	#3,$2A(a1)
		bclr	#2,$2A(a1)
		move.b	#0,$20(a1)
		bclr	d6,$2A(a0)
		move.b	#$20,(a4)
		rts
; ---------------------------------------------------------------------------

loc_28F9C:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		neg.w	d0
		cmpi.w	#$20,d0
		bcc.w	locret_28EDC
		move.w	$10(a0),d0
		subi.w	#$10,d0
		move.w	d0,$10(a1)
		move.w	#0,$18(a1)
		move.w	#0,$1A(a1)
		move.w	#0,$1C(a1)
		bset	#1,$2A(a1)
		move.b	#0,$40(a1)
		bclr	#3,$2A(a1)
		bclr	#2,$2A(a1)
		move.b	#0,$20(a1)
		bclr	d6,$2A(a0)
		move.b	#$20,(a4)
		rts
; End of function sub_28F40

; ---------------------------------------------------------------------------
byte_28FF4:	dc.b $11
		dc.b $11
		dc.b $11
		dc.b $11
		dc.b $11
		dc.b $11
		dc.b $11
		dc.b $12
		dc.b $13
		dc.b $14
		dc.b $15
		dc.b $16
		dc.b $17
		dc.b $18
		dc.b $19
		dc.b $1A
		dc.b $1B
		dc.b $1C
		dc.b $1D
		dc.b $1E
		dc.b $1F
		dc.b $20
		dc.b $21
		dc.b $21
		dc.b $21
		dc.b $21
		dc.b $21
		dc.b $21
		dc.b $21
		dc.b $21
		dc.b $21
		dc.b $21
		dc.b $21
		dc.b $21
		dc.b $21
		dc.b $21
		dc.b $21
		dc.b $21
		dc.b $21
		dc.b $21
		dc.b $21
		dc.b $21
		dc.b $21
		dc.b $21
; ---------------------------------------------------------------------------

Obj_LBZLoweringGrapple:

		move.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.w	#$80,8(a0)
		move.b	#-$80,6(a0)
		move.w	$14(a0),$3C(a0)
		move.l	#Map_LBZLoweringGrapple,$C(a0)
		move.w	#$42EA,$A(a0)
		move.b	$2C(a0),d0
		andi.w	#$7F,d0
		lsl.w	#3,d0
		move.w	d0,$2E(a0)
		move.w	#2,$3A(a0)
		move.b	$2C(a0),d0
		bpl.s	loc_29080
		move.w	$2E(a0),d0
		move.w	d0,$38(a0)
		move.b	#1,$36(a0)
		add.w	d0,$14(a0)
		lsr.w	#4,d0
		addq.w	#1,d0
		move.b	d0,$22(a0)

loc_29080:
		move.l	#loc_29086,(a0)

loc_29086:
		tst.b	$36(a0)
		beq.s	loc_29094
		tst.w	$30(a0)
		bne.s	loc_290AA
		bra.s	loc_2909A
; ---------------------------------------------------------------------------

loc_29094:
		tst.w	$30(a0)
		beq.s	loc_290AA

loc_2909A:
		move.w	$38(a0),d2
		cmp.w	$2E(a0),d2
		beq.s	loc_290CE
		add.w	$3A(a0),d2
		bra.s	loc_290B4
; ---------------------------------------------------------------------------

loc_290AA:

		move.w	$38(a0),d2
		beq.s	loc_290CE
		sub.w	$3A(a0),d2

loc_290B4:
		move.w	d2,$38(a0)
		move.w	$3C(a0),d0
		add.w	d2,d0
		move.w	d0,$14(a0)
		move.w	d2,d0
		beq.s	loc_290CA
		lsr.w	#4,d0
		addq.w	#1,d0

loc_290CA:
		move.b	d0,$22(a0)

loc_290CE:

		lea	$30(a0),a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF602).w,d0
		bsr.w	sub_290F2
		lea	($FFFFB04A).w,a1
		addq.w	#1,a2
		move.w	($FFFFF66A).w,d0
		bsr.w	sub_290F2
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_290F2:

		tst.b	(a2)
		beq.w	loc_29194
		tst.b	4(a1)
		bpl.s	loc_29178
		cmpi.b	#4,5(a1)
		bcc.s	loc_29178
		andi.b	#$70,d0
		beq.w	loc_29186
		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$12,2(a2)
		andi.w	#$F00,d0
		beq.w	loc_29128
		move.b	#$3C,2(a2)

loc_29128:
		btst	#$A,d0
		beq.s	loc_29134
		move.w	#-$200,$18(a1)

loc_29134:
		btst	#$B,d0
		beq.s	loc_29140
		move.w	#$200,$18(a1)

loc_29140:
		move.w	#-$380,$1A(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$27(a1)
		rts
; ---------------------------------------------------------------------------

loc_29178:

		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$3C,2(a2)
		rts
; ---------------------------------------------------------------------------

loc_29186:
		move.w	$14(a0),$14(a1)
		addi.w	#$94,$14(a1)
		rts
; ---------------------------------------------------------------------------

loc_29194:
		tst.b	2(a2)
		beq.s	loc_291A2
		subq.b	#1,2(a2)
		bne.w	locret_29214

loc_291A2:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.w	locret_29214
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		subi.w	#$88,d1
		cmpi.w	#$18,d1
		bcc.w	locret_29214
		tst.b	$2E(a1)
		bmi.s	locret_29214
		cmpi.b	#4,5(a1)
		bcc.s	locret_29214
		tst.w	($FFFFFE08).w
		bne.s	locret_29214
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$94,$14(a1)
		move.b	#$14,$20(a1)
		move.b	#1,$2E(a1)
		move.b	#1,(a2)
		moveq	#$5B,d0
		jsr	(Play_Sound_2).l

locret_29214:

		rts
; End of function sub_290F2

; ---------------------------------------------------------------------------

Obj_MGZLBZSmashingPillar:

		move.l	#Map_LBZSmashingSpikes,$C(a0)
		move.w	#$4455,$A(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$80,8(a0)
		cmpi.b	#2,($FFFFFE10).w
		bne.s	loc_2925E
		move.l	#Map_MGZSmashingPillar,$C(a0)
		move.w	#$4001,$A(a0)
		move.b	#$20,7(a0)
		move.b	#$28,6(a0)
		move.w	#$280,8(a0)

loc_2925E:
		move.b	#4,4(a0)
		move.w	$14(a0),$30(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#3,d0
		move.w	d0,$38(a0)
		move.l	#loc_2927C,(a0)

loc_2927C:
		tst.b	$32(a0)
		bne.s	loc_292C8
		move.w	$1A(a0),d0
		addi.w	#$80,$1A(a0)
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$34(a0)
		move.w	$34(a0),d2
		cmp.w	$38(a0),d2
		bcs.s	loc_292DC
		clr.w	$1A(a0)
		move.w	$38(a0),$34(a0)
		move.b	#1,$32(a0)
		tst.b	4(a0)
		bpl.s	loc_292DC
		moveq	#$5F,d0
		cmpi.b	#2,($FFFFFE10).w
		beq.s	loc_292C0
		moveq	#-$6A,d0

loc_292C0:
		jsr	(Play_Sound_2).l
		bra.s	loc_292DC
; ---------------------------------------------------------------------------

loc_292C8:
		move.w	$34(a0),d2
		beq.s	loc_292D6
		subq.w	#1,d2
		move.w	d2,$34(a0)
		bra.s	loc_292DC
; ---------------------------------------------------------------------------

loc_292D6:
		move.b	#0,$32(a0)

loc_292DC:

		move.w	$30(a0),d0
		add.w	$34(a0),d0
		move.w	d0,$14(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		swap	d6
		andi.w	#$C,d6
		bne.s	loc_29314
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_29314:
		move.b	d6,d0
		andi.b	#4,d0
		beq.s	loc_29324
		lea	($FFFFB000).w,a1
		bsr.w	sub_24280

loc_29324:
		andi.b	#8,d6
		beq.s	loc_29332
		lea	($FFFFB04A).w,a1
		bsr.w	sub_24280

loc_29332:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_LBZGateLaser:

		move.l	#Map_LBZGateLaser,$C(a0)
		move.w	#$42EA,$A(a0)
		move.b	#$1C,7(a0)
		move.b	#4,6(a0)
		ori.b	#4,4(a0)
		move.w	#$180,8(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,d1
		andi.w	#$F,d0
		lsl.w	#3,d0
		add.w	$14(a0),d0
		move.w	d0,$2E(a0)
		lsr.b	#1,d1
		andi.w	#$78,d1
		addq.w	#8,d1
		move.w	d1,$32(a0)
		move.l	#loc_29386,(a0)

loc_29386:
		subq.w	#1,$30(a0)
		bpl.s	loc_293CA
		move.w	$32(a0),$30(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_293CA
		bsr.s	sub_293D0
		jsr	(Create_New_Sprite3).l
		bne.w	loc_293CA
		bsr.s	sub_293D0
		move.w	#$80,8(a1)
		move.b	#2,$22(a1)
		move.b	#-$68,$28(a1)
		move.l	#loc_29416,(a1)
		moveq	#-$58,d0
		jsr	(Play_Sound_2).l

loc_293CA:

		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_293D0:

		move.l	#loc_2941C,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	$2E(a0),$2E(a1)
		move.l	#Map_LBZGateLaser,$C(a1)
		move.w	#$42EA,$A(a1)
		move.b	#$1C,7(a1)
		move.b	#4,6(a1)
		move.b	4(a0),4(a1)
		move.b	#1,$22(a1)
		move.w	#$180,8(a1)
		rts
; End of function sub_293D0

; ---------------------------------------------------------------------------

loc_29416:
		jsr	(Add_SpriteToCollisionResponseList).l

loc_2941C:
		move.b	($FFFFFE05).w,d0
		andi.b	#1,d0
		bne.s	loc_2942C
		bchg	#1,4(a0)

loc_2942C:
		move.w	$14(a0),d0
		addq.w	#4,$14(a0)
		cmp.w	$2E(a0),d0
		bcs.s	loc_29440
		move.w	#$7FF0,$10(a0)

loc_29440:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_22_1:
		move.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$280,8(a0)
		move.b	#-$29,$28(a0)
		move.l	#loc_2946A,(a0)

loc_2946A:
		tst.w	$30(a0)
		beq.s	loc_2947E
		subq.w	#1,$30(a0)
		bne.s	loc_294D6
		move.w	#0,($FFFFF7F4).w
		bra.s	loc_294FC
; ---------------------------------------------------------------------------

loc_2947E:
		tst.b	$29(a0)
		beq.s	loc_294FC
		clr.b	$29(a0)
		move.w	#$81,$30(a0)
		move.w	#1,($FFFFF7F4).w
		btst	#0,$2C(a0)
		bne.s	locret_294D4

; =============== S U B R O U T I N E =======================================


sub_2949C:
		jsr	(Create_New_Sprite3).l
		bne.s	locret_294D4
		move.l	#Obj_Flybot767,(a1)
		lea	($FFFFB000).w,a2
		move.w	$10(a2),$10(a1)
		move.w	$14(a2),$14(a1)
		move.b	$2C(a0),d0
		add.w	d0,d0
		add.w	d0,d0
		andi.w	#$C,d0
		move.l	word_29508(pc,d0.w),d0
		add.w	d0,$14(a1)
		swap	d0
		add.w	d0,$10(a1)

locret_294D4:

		rts
; End of function sub_2949C

; ---------------------------------------------------------------------------

loc_294D6:
		btst	#0,$2C(a0)
		beq.s	loc_294E8
		cmpi.w	#$41,$30(a0)
		bne.s	loc_294E8
		bsr.s	sub_2949C

loc_294E8:

		move.w	$30(a0),d0
		andi.b	#$1F,d0
		bne.s	locret_294FA
		moveq	#-$7A,d0
		jsr	(Play_Sound_2).l

locret_294FA:
		rts
; ---------------------------------------------------------------------------

loc_294FC:

		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------
word_29508:	dc.w $C0, $FFA0
		dc.w $C0, $FFA0
		dc.w $FF40, $FFA0
		dc.w $FF40, $FFA0
; ---------------------------------------------------------------------------

Obj_23_1:
		move.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#-$80,6(a0)
		move.b	#0,8(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#3,d0
		move.w	d0,$2E(a0)
		move.l	#loc_29542,(a0)

loc_29542:
		move.w	$10(a0),d1
		move.w	d1,d2
		subi.w	#$10,d1
		addi.w	#$10,d2
		move.w	$14(a0),d3
		move.w	d3,d4
		sub.w	$2E(a0),d3
		add.w	$2E(a0),d4
		lea	($FFFFB000).w,a1
		bsr.s	sub_29570
		lea	($FFFFB04A).w,a1
		bsr.s	sub_29570
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_29570:

		move.w	$10(a1),d0
		cmp.w	d1,d0
		bcs.s	locret_295C0
		cmp.w	d2,d0
		bcc.s	locret_295C0
		move.w	$14(a1),d0
		cmp.w	d3,d0
		bcs.s	locret_295C0
		cmp.w	d4,d0
		bcc.s	locret_295C0
		cmpi.b	#$1A,$20(a1)
		beq.s	locret_295C0
		move.w	#0,$18(a1)
		move.w	#$400,$1A(a1)
		move.w	#0,$1C(a1)
		bset	#1,$2A(a1)
		move.b	#0,$40(a1)
		bclr	#3,$2A(a1)
		bclr	#2,$2A(a1)
		move.b	#$1A,$20(a1)

locret_295C0:
		rts
; End of function sub_29570

; ---------------------------------------------------------------------------

Obj_AutomaticTunnelDelayed:
		subq.b	#1,$24(a0)
		bmi.s	loc_295CA
		rts
; ---------------------------------------------------------------------------

loc_295CA:
		move.b	#0,$24(a0)

Obj_AutomaticTunnel:

		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.w	#$280,8(a0)
		move.l	#loc_295E8,(a0)

loc_295E8:
		lea	($FFFFB000).w,a1
		lea	$30(a0),a4
		bsr.s	sub_2960E
		lea	($FFFFB04A).w,a1
		lea	$3A(a0),a4
		bsr.s	sub_2960E
		move.b	$30(a0),d0
		add.b	$3A(a0),d0
		beq.s	loc_29608		; As long as this object is attached to a character, do not destroy it
		rts
; ---------------------------------------------------------------------------

loc_29608:
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_2960E:

		moveq	#0,d0
		move.b	(a4),d0
		move.w	AutoTunnel_Index(pc,d0.w),d0
		jmp	AutoTunnel_Index(pc,d0.w)
; End of function sub_2960E

; ---------------------------------------------------------------------------
AutoTunnel_Index:	dc.w Obj_AutoTunnelInit-AutoTunnel_Index
		dc.w Obj_AutoTunnelRun-AutoTunnel_Index
		dc.w Obj_AutoTunnelLastMove-AutoTunnel_Index
; ---------------------------------------------------------------------------

Obj_AutoTunnelInit:
		tst.w	($FFFFFE08).w
		bne.w	locret_296D2		; If debug mode is on, don't bother
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.w	locret_296D2
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		addi.w	#$18,d1
		cmpi.w	#$28,d1
		bcc.w	locret_296D2		; Only activate if player is in range
		tst.b	$2E(a1)
		bne.s	locret_296D2		; If under control of another object, don't activate
		addq.b	#2,(a4)
		move.b	#$81,$2E(a1)		; Lock this object to Sonic/Tails
		move.b	#2,$20(a1)			; Set player to rolling animation
		clr.b	$40(a1)				; Ensure they're no longer jumping
		move.w	#$800,$1C(a1)
		move.w	#0,$18(a1)
		move.w	#0,$1A(a1)			; Null actual velocity but make player very fast
		bclr	#5,$2A(a0)
		bclr	#5,$2A(a1)
		bset	#1,$2A(a1)			;Player is not pushing anything and not in the air
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)		;Lock player's position to object's position
		clr.b	1(a4)
		bsr.w	AutoTunnel_GetPath		; Get the first path of the tunnel
		moveq	#$3C,d0
		jsr	(Play_Sound_2).l
		btst	#5,$2C(a0)
		beq.s	locret_296D2
		tst.b	($FFFFFE11).w		; If bit 5 of object subtype is set and we're in an act 2
		beq.s	locret_296D2
		bclr	#4,$2B(a1)
		beq.s	loc_296C4
		bclr	#0,$2B(a1)

loc_296C4:
		bclr	#5,$2B(a1)
		beq.s	locret_296D2
		bclr	#0,$2B(a1)			; Disable fire/lightning shields. This is probably for the water tunnels in LBZ2

locret_296D2:

		rts
; ---------------------------------------------------------------------------

Obj_AutoTunnelRun:
		subq.b	#1,2(a4)
		bhi.w	loc_29768
		movea.l	6(a4),a2		; If timer has exhausted, get address of path data
		move.w	(a2)+,d4
		move.w	d4,$10(a1)
		move.w	(a2)+,d5
		move.w	d5,$14(a1)		; Get the new starting position
		tst.b	$2C(a0)
		bpl.s	loc_296F4
		subq.w	#8,a2			; See if we're going backwards

loc_296F4:
		move.l	a2,6(a4)		; Replace address of path
		subq.w	#4,4(a4)
		beq.s	loc_2970A		; If path has exhausted, branch
		move.w	(a2)+,d4
		move.w	(a2)+,d5
		move.w	#$1000,d2
		bra.w	AutoTunnel_CalcSpeed		; Get new velocity
; ---------------------------------------------------------------------------

loc_2970A:
		addq.b	#2,(a4)			; Go to next routine
		move.b	#2,2(a4)
		andi.w	#$FFF,$14(a1)	; Make sure the player's Y position remains valid
		btst	#6,$2C(a0)		; If bit 6 is not set
		bne.s	loc_2972C
		move.w	#0,$18(a1)		; Then stop player movement. Otherwise he'll continue moving
		move.w	#0,$1A(a1)

loc_2972C:
		moveq	#-$7F,d0
		jsr	(Play_Sound_2).l	; Play that nifty little cannon shooting sound
		btst	#5,$2C(a0)
		beq.s	loc_29768
		movea.l	a1,a2			; If bit 5 set (for LBZ2, again), make the waterfall
		jsr	(Create_New_Sprite3).l
		bne.w	loc_29766
		move.l	#Obj_TunnelExhaustControl,(a1)
		move.w	$10(a2),$10(a1)
		move.w	$14(a2),$14(a1)
		move.w	$18(a2),$18(a1)
		move.w	$1A(a2),$1A(a1)

loc_29766:
		movea.l	a2,a1

loc_29768:

		move.l	$10(a1),d2		; Perform movement
		move.l	$14(a1),d3
		move.w	$18(a1),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d2
		move.w	$1A(a1),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d3			; Add velocity to player
		move.l	d2,$10(a1)
		move.l	d3,$14(a1)
		rts
; ---------------------------------------------------------------------------

Obj_AutoTunnelLastMove:
		subq.b	#1,2(a4)
		bne.s	loc_2979A		; This is the last movement
		clr.b	$2E(a1)
		clr.b	(a4)

loc_2979A:
		addi.w	#$38,$1A(a1)	; Reapply gravity
		bra.s	loc_29768

; =============== S U B R O U T I N E =======================================


AutoTunnel_GetPath:

		move.b	$2C(a0),d0
		bpl.s	loc_297D6
		andi.w	#$1F,d0			; If negative, then the path is reversed
		add.w	d0,d0
		add.w	d0,d0
		lea	(AutoTunnel_Data).l,a2
		movea.l	(a2,d0.w),a2	; Get address of movement data
		move.w	(a2)+,d0
		subq.w	#4,d0
		move.w	d0,4(a4)
		lea	(a2,d0.w),a2
		move.w	(a2)+,d4
		move.w	d4,$10(a1)
		move.w	(a2)+,d5
		move.w	d5,$14(a1)		; Set absolute position of player
		subq.w	#8,a2
		bra.s	loc_2980C
; ---------------------------------------------------------------------------

loc_297D6:
		cmpi.b	#$10,d0
		bne.s	loc_297E6
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_297E6
		moveq	#0,d0			; If playing as tails, use path 0 when doing path $10

loc_297E6:

		andi.w	#$1F,d0
		add.w	d0,d0
		add.w	d0,d0
		lea	(AutoTunnel_Data).l,a2
		movea.l	(a2,d0.w),a2
		move.w	(a2)+,4(a4)
		subq.w	#4,4(a4)
		move.w	(a2)+,d4
		move.w	d4,$10(a1)
		move.w	(a2)+,d5
		move.w	d5,$14(a1)		; Set absolute position of player

loc_2980C:
		move.l	a2,6(a4)
		move.w	(a2)+,d4
		move.w	(a2)+,d5		; Get next position
		move.w	#$1000,d2

AutoTunnel_CalcSpeed:

		moveq	#0,d0
		move.w	d2,d3
		move.w	d4,d0
		sub.w	$10(a1),d0
		bge.s	loc_29828
		neg.w	d0
		neg.w	d2				; Change X velocity depending on direction of destination

loc_29828:
		moveq	#0,d1
		move.w	d5,d1
		sub.w	$14(a1),d1
		bge.s	loc_29836
		neg.w	d1
		neg.w	d3				; Change Y velocity depending on direction of destination

loc_29836:
		cmp.w	d0,d1
		bcs.s	loc_29868
		moveq	#0,d1			; If X distance is less than Y distance
		move.w	d5,d1
		sub.w	$14(a1),d1
		swap	d1
		divs.w	d3,d1
		moveq	#0,d0
		move.w	d4,d0
		sub.w	$10(a1),d0
		beq.s	loc_29854
		swap	d0
		divs.w	d1,d0

loc_29854:
		move.w	d0,$18(a1)		; Calculate and set X velocity assuming a Y velocity of $10 pixels
		move.w	d3,$1A(a1)
		tst.w	d1
		bpl.s	loc_29862
		neg.w	d1

loc_29862:
		move.w	d1,2(a4)		; The quotient of the distance/speed produces a proper timer used for movement
		rts
; ---------------------------------------------------------------------------

loc_29868:
		moveq	#0,d0			; If Y distance is less than X distance
		move.w	d4,d0
		sub.w	$10(a1),d0
		swap	d0
		divs.w	d2,d0
		moveq	#0,d1
		move.w	d5,d1
		sub.w	$14(a1),d1
		beq.s	loc_29882
		swap	d1
		divs.w	d0,d1

loc_29882:
		move.w	d1,$1A(a1)	; Calculate and set Y velocity assuming a X velocity of $10 pixels
		move.w	d2,$18(a1)
		tst.w	d0
		bpl.s	loc_29890
		neg.w	d0

loc_29890:
		move.w	d0,2(a4)	; See above
		rts
; End of function AutoTunnel_GetPath

; ---------------------------------------------------------------------------

Obj_TunnelExhaustControl:

		move.l	#Map_TunnelExhaust,$C(a0)
		move.w	#$42EA,$A(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		ori.b	#4,4(a0)
		move.w	#$180,8(a0)
		tst.b	$2C(a0)
		beq.s	loc_298CC
		move.l	#Obj_TunnelExContinuous,(a0)
		bra.w	Obj_TunnelExContinuous
; ---------------------------------------------------------------------------

loc_298CC:
		move.w	#$3C,$30(a0)
		tst.w	$1A(a0)
		beq.s	loc_298E2
		bmi.s	loc_298F4
		move.w	#6,$26(a0)		; $26 is 6 if moving downward, 0 if moving upward
		bra.s	loc_298F4
; ---------------------------------------------------------------------------

loc_298E2:
		move.w	#$C,$26(a0)		; If vertical movement is null
		tst.w	$18(a0)
		bmi.s	loc_298F4
		move.w	#$12,$26(a0)	; $26 is $C if X velocity is to the left, $12 if to the right

loc_298F4:

		tst.b	($FFFFFE11).w
		bne.s	loc_29904
		move.l	#Obj_TunnelExSmoke,(a0)		; If in act 1, just make smoke
		bra.w	Obj_TunnelExSmoke
; ---------------------------------------------------------------------------

loc_29904:
		move.l	#Obj_TunnelExhaustControlMain,(a0)	; If in act 2

Obj_TunnelExhaustControlMain:
		subq.w	#1,$2E(a0)
		bpl.s	loc_29980
		move.w	#3,$2E(a0)		; Make a new exhaust sprite every 4 frames
		jsr	(Create_New_Sprite3).l
		bne.w	loc_29980
		move.l	#Obj_TunnelExhaustUp,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.l	#Map_TunnelExhaust,$C(a1)
		move.w	#$42EA,$A(a1)
		move.b	#$10,7(a1)
		move.b	#$10,6(a1)
		move.w	#$380,8(a1)
		move.w	$26(a0),d0
		cmpi.w	#6,d0
		bne.s	loc_29962
		move.l	#Obj_TunnelExhaustDown,(a1)	; If moving downward, change the object to use

loc_29962:
		lea	word_29992(pc,d0.w),a2
		move.w	(a2)+,$18(a1)
		move.w	(a2)+,$1A(a1)
		move.b	(a2)+,4(a1)
		move.b	(a2)+,$22(a1)
		bne.s	loc_29980
		move.l	#Obj_TunnelExhaustHorz,(a1)
		bsr.s	sub_299AA

loc_29980:

		subq.w	#1,$30(a0)		; Continue doing this until timer runs out
		bpl.s	loc_2998C
		move.w	#$7FF0,$10(a0)

loc_2998C:
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------
word_29992:	dc.w 0	; X velocity
		dc.w $FA00	; Y velocity
		dc.b $86	; Flip value
		dc.b 1		; Mapping frame
		dc.w 0
		dc.w $400
		dc.b $84
		dc.b 1
		dc.w $FA00
		dc.w 0
		dc.b $85
		dc.b 0
		dc.w $600
		dc.w 0
		dc.b $84
		dc.b 0

; =============== S U B R O U T I N E =======================================


sub_299AA:
		moveq	#0,d0			; Slow down exhaust trickle over time
		move.w	$30(a0),d0
		subi.w	#$3C,d0
		neg.w	d0
		lsl.w	#4,d0
		tst.w	$18(a1)
		bmi.s	loc_299C0
		neg.w	d0

loc_299C0:
		add.w	d0,$18(a1)
		rts
; End of function sub_299AA

; ---------------------------------------------------------------------------

Obj_TunnelExhaustUp:
		move.b	($FFFFFE05).w,d0
		andi.b	#1,d0
		bne.s	loc_299D6
		bchg	#0,4(a0)	; Change X flip every 2 frames

loc_299D6:
		jsr	(MoveSprite).l
		tst.b	4(a0)
		bmi.s	loc_299EE	; If on-screen, branch
		tst.w	$1A(a0)
		bmi.s	loc_299EE	; If vertical velocity is going upwards, branch
		move.w	#$7FF0,$10(a0)	; Ensure that the object is definitely offscreen

loc_299EE:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_TunnelExhaustDown:
		move.b	($FFFFFE05).w,d0
		andi.b	#1,d0
		bne.s	loc_29A04
		bchg	#0,4(a0)	; Change X flip every 2 frames

loc_29A04:
		jsr	(MoveSprite).l
		tst.b	4(a0)
		bmi.s	loc_29A1E	; If on-screen, branch
		cmpi.w	#$C00,$1A(a0)
		blt.s	loc_29A1E	; If vertical velocity is less than $C00, branch
		move.w	#$7FF0,$10(a0)

loc_29A1E:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_TunnelExhaustHorz:
		move.b	($FFFFFE05).w,d0
		andi.b	#1,d0
		bne.s	loc_29A34
		bchg	#1,4(a0)

loc_29A34:
		jsr	(MoveSprite).l
		tst.b	4(a0)
		bmi.s	loc_29A4E
		cmpi.w	#$600,$1A(a0)
		blt.s	loc_29A4E
		move.w	#$7FF0,$10(a0)

loc_29A4E:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_TunnelExContinuous:

		move.b	($FFFFFE05).w,d0	; This control object creates new sprites continuously
		andi.b	#3,d0
		bne.s	loc_29AB8
		jsr	(Create_New_Sprite3).l		; Create a new sprite every four frames
		bne.w	loc_29AB8
		move.l	#Obj_TunnelExhaustTimed,(a1)	; This is a timed exhaust (the short waterfalls in LBZ2 for example)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.l	#Map_TunnelExhaust,$C(a1)
		move.w	#$42EA,$A(a1)
		move.b	#$10,7(a1)
		move.b	#$10,6(a1)
		move.w	#$380,8(a1)
		move.w	#0,$18(a1)
		move.w	#$400,$1A(a1)
		move.b	#$84,4(a1)
		move.b	#1,$22(a1)
		move.w	#$B,$2E(a1)

loc_29AB8:

		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

Obj_TunnelExhaustTimed:
		subq.w	#1,$2E(a0)
		bpl.s	loc_29AD0
		move.w	#$B,$2E(a0)
		move.w	#$7FF0,$10(a0)

loc_29AD0:
		move.b	($FFFFFE05).w,d0
		andi.b	#1,d0
		bne.s	loc_29AE0
		bchg	#0,4(a0)

loc_29AE0:
		jsr	(MoveSprite).l
		tst.b	4(a0)
		bmi.s	loc_29AF2
		move.w	#$7FF0,$10(a0)

loc_29AF2:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_TunnelExSmoke:

		move.b	($FFFFFE05).w,d0
		andi.b	#3,d0
		bne.s	loc_29B2A
		jsr	(Create_New_Sprite3).l
		bne.w	loc_29B2A
		move.l	#Obj_FireShield_Dissipate,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	$18(a0),$18(a1)
		move.w	$1A(a0),$1A(a1)

loc_29B2A:

		subq.w	#1,$30(a0)
		bpl.s	loc_29B36
		move.w	#$7FF0,$10(a0)

loc_29B36:
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------
		move.l	#Map_TunnelExhaust,$C(a0)
		move.w	#$42EA,$A(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		ori.b	#4,4(a0)
		move.w	#$180,8(a0)
		move.w	#$78,$30(a0)
		move.l	#loc_29B6E,(a0)

loc_29B6E:
		tst.b	$32(a0)
		bne.s	loc_29BE8
		subq.w	#1,$2E(a0)
		bpl.s	loc_29BE8
		move.w	#3,$2E(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_29BE8
		move.l	#loc_29C00,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.l	#Map_TunnelExhaust,$C(a1)
		move.w	#$42EA,$A(a1)
		move.b	#$10,7(a1)
		move.b	#$10,6(a1)
		move.w	#$380,8(a1)
		ori.b	#4,4(a1)
		bset	#0,4(a1)
		move.w	#-$800,$18(a1)
		moveq	#0,d0
		move.b	$2C(a0),d0
		addq.w	#1,d0
		add.w	d0,d0
		move.w	d0,$2E(a1)
		addi.w	#$10,$10(a1)
		move.b	#-$3A,$28(a1)

loc_29BE8:

		subq.w	#1,$30(a0)
		bpl.s	loc_29BFA
		move.w	#$78,$30(a0)
		eori.b	#-1,$32(a0)

loc_29BFA:
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_29C00:
		move.b	($FFFFFE05).w,d0
		andi.b	#1,d0
		bne.s	loc_29C10
		bchg	#1,4(a0)

loc_29C10:
		jsr	(MoveSprite2).l
		subq.w	#1,$2E(a0)
		bpl.s	loc_29C22
		move.w	#$7FF0,$10(a0)

loc_29C22:
		move.b	$29(a0),d0
		beq.w	loc_29C46
		lea	($FFFFB000).w,a1
		bclr	#0,$29(a0)
		beq.s	loc_29C38
		bsr.s	sub_29C4C

loc_29C38:
		lea	($FFFFB04A).w,a1
		bclr	#1,$29(a0)
		beq.s	loc_29C46
		bsr.s	sub_29C4C

loc_29C46:

		jmp	(loc_1B662).l

; =============== S U B R O U T I N E =======================================


sub_29C4C:

		tst.b	$2E(a1)
		bne.s	locret_29C88
		move.w	$14(a0),$14(a1)
		cmpi.w	#-$1000,$18(a1)
		beq.s	locret_29C88
		move.b	#$1A,$20(a1)
		clr.b	$40(a1)
		move.w	#0,$1C(a1)
		move.w	#-$1000,$18(a1)
		move.w	#0,$1A(a1)
		bclr	#5,$2A(a1)
		bset	#1,$2A(a1)

locret_29C88:

		rts
; End of function sub_29C4C

; ---------------------------------------------------------------------------
Map_TunnelExhaust:	include "Levels\LBZ\Misc Object Data\Map - (&LRZ) Tunnel Exhaust.asm"

; ---------------------------------------------------------------------------

Obj_LBZTubeElevator:

		move.l	#Map_LBZTubeElevator,$C(a0)
		move.w	#$2455,$A(a0)
		move.b	#$18,7(a0)
		move.b	#$30,6(a0)
		ori.b	#4,4(a0)
		move.w	#$80,8(a0)
		move.w	$10(a0),$44(a0)
		move.w	$14(a0),$46(a0)
		btst	#6,$2C(a0)
		beq.s	loc_29CEC
		move.b	#0,$22(a0)			; If BIT 6 of subtype set, the elevator remains closed
		move.b	#0,$26(a0)
		move.l	#Obj_LBZTubeElevatorClosed,(a0)
		bra.s	Obj_LBZTubeElevatorClosed
; ---------------------------------------------------------------------------

loc_29CEC:
		jsr	(Create_New_Sprite3).l
		bne.w	loc_29D38
		move.l	#loc_29DEC,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.l	#Map_LBZTubeElevator,$C(a1)
		move.w	#$2455,$A(a1)
		move.b	#$18,7(a1)
		move.b	#$18,6(a1)
		ori.b	#4,4(a1)
		move.w	#$280,8(a1)
		move.b	#6,$22(a1)
		move.w	a0,$42(a1)

loc_29D38:
		move.b	#2,$22(a0)
		move.b	#2,$26(a0)
		move.l	#Obj_LBZTubeElevatorActive,(a0)

Obj_LBZTubeElevatorActive:

		bsr.w	LBZTubeElevator_Action
		lea	($FFFFB000).w,a1
		lea	$38(a0),a2
		bsr.w	LBZTubeElevator_CheckPlayer
		lea	($FFFFB04A).w,a1
		addq.w	#1,a2
		bsr.w	LBZTubeElevator_CheckPlayer
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_LBZTubeElevatorClosed:

		lea	($FFFFB000).w,a1
		btst	#3,$2A(a1)
		beq.s	loc_29D8E
		tst.b	$2E(a1)
		beq.s	loc_29D8E
		movea.w	$42(a1),a2
		cmpi.l	#Obj_LBZTubeElevatorActive,(a2)
		bne.s	loc_29D8E
		move.w	#$7FF0,$10(a0)

loc_29D8E:

		lea	$2E(a0),a4
		addq.b	#2,1(a4)
		move.b	1(a4),d0
		cmpi.b	#-$50,d0
		bcs.s	loc_29DAA
		cmpi.b	#-$30,d0
		bcc.s	loc_29DAA
		addi.b	#$20,d0

loc_29DAA:

		move.b	d0,1(a4)
		jsr	(GetSineCosine).l
		cmpi.w	#$100,d0
		bne.s	loc_29DBC
		subq.w	#1,d0

loc_29DBC:
		asr.w	#6,d0
		move.w	$46(a0),d2
		sub.w	d0,d2
		move.w	d2,$14(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_29DEC:
		movea.w	$42(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		tst.b	4(a1)
		bpl.s	loc_29E16
		moveq	#0,d0
		move.b	$22(a1),d0
		move.b	byte_29E1C(pc,d0.w),d0
		ext.w	d0
		add.w	$10(a1),d0
		move.w	d0,$10(a0)

loc_29E16:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
byte_29E1C:	dc.b 0
		dc.b $F8
		dc.b $F8
		dc.b 0
		dc.b 8
		dc.b 8

; =============== S U B R O U T I N E =======================================


LBZTubeElevator_Action:
		lea	$2E(a0),a4
		movea.l	a0,a1
		moveq	#0,d0
		move.b	(a4),d0
		move.w	LBZTubeElevator_Index(pc,d0.w),d0
		jmp	LBZTubeElevator_Index(pc,d0.w)
; End of function LBZTubeElevator_Action

; ---------------------------------------------------------------------------
LBZTubeElevator_Index:	dc.w LBZTubeElevator_WaitPlayer-LBZTubeElevator_Index
		dc.w LBZTubeElevator_StartSpin-LBZTubeElevator_Index
		dc.w LBZTubeElevator_MovePath-LBZTubeElevator_Index
		dc.w LBZTubeElevator_SlowSpin-LBZTubeElevator_Index
		dc.w LBZTubeElevator_WaitExit-LBZTubeElevator_Index
		dc.w LBZTubeElevator_EndSpin-LBZTubeElevator_Index
		dc.w LBZTubeElevator_Closed-LBZTubeElevator_Index
; ---------------------------------------------------------------------------

LBZTubeElevator_WaitPlayer:
		cmpi.w	#$200,$38(a0)
		beq.s	loc_29E52
		cmpi.w	#$202,$38(a0)
		bne.s	loc_29E5E

loc_29E52:
		addq.b	#2,(a4)
		moveq	#$3C,d0
		jsr	(Play_Sound_2).l
		bra.s	LBZTubeElevator_StartSpin
; ---------------------------------------------------------------------------

loc_29E5E:
		addq.b	#2,1(a4)
		move.b	1(a4),d0
		cmpi.b	#-$50,d0
		bcs.s	loc_29E76
		cmpi.b	#-$30,d0
		bcc.s	loc_29E76
		addi.b	#$20,d0

loc_29E76:

		move.b	d0,1(a4)
		jsr	(GetSineCosine).l
		cmpi.w	#$100,d0
		bne.s	loc_29E88
		subq.w	#1,d0

loc_29E88:
		asr.w	#6,d0
		move.w	$46(a0),d2
		sub.w	d0,d2
		move.w	d2,$14(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		move.w	#8,d2
		move.w	#$20,d3
		move.w	$10(a0),d4
		jsr	SolidObjectFull_Offset
		rts
; ---------------------------------------------------------------------------

LBZTubeElevator_StartSpin:

		move.w	$22(a0),d0		; Get current mapping frame +
		sub.w	$3C(a0),d0
		bcc.s	loc_29EC0
		addi.w	#$600,d0

loc_29EC0:
		move.w	d0,$22(a0)
		move.w	$26(a0),d0
		sub.w	$3C(a0),d0
		bcc.s	loc_29ED2
		addi.w	#$C00,d0

loc_29ED2:
		move.w	d0,$26(a0)
		cmpi.w	#$180,$3C(a0)	; Accelerate speed of spinning
		bcc.s	loc_29F1C		; When maxed out, branch
		addq.w	#2,$3C(a0)

loc_29EE2:
		move.b	1(a4),d0		; Increment bobbing angle
		addq.b	#2,1(a4)
		jsr	(GetSineCosine).l
		asr.w	#6,d0
		move.w	$46(a0),d2
		sub.w	d0,d2
		move.w	d2,$14(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		rts
; ---------------------------------------------------------------------------

loc_29F1C:
		addq.b	#2,(a4)			; Next routine
		move.w	#$180,$3C(a0)
		clr.b	1(a4)
		bsr.w	AutoTunnel_GetPath	; Get auto tunnel path
		move.b	#1,($FFFFEE39).w	; Y camera follows Sonic differently
		bra.s	loc_29EE2
; ---------------------------------------------------------------------------

LBZTubeElevator_MovePath:
		move.w	$22(a0),d0		; Continuing spinning mapping frame
		sub.w	$3C(a0),d0
		bcc.s	loc_29F42
		addi.w	#$600,d0

loc_29F42:
		move.w	d0,$22(a0)
		move.w	$26(a0),d0
		sub.w	$3C(a0),d0
		bcc.s	loc_29F54
		addi.w	#$C00,d0

loc_29F54:
		move.w	d0,$26(a0)
		subq.b	#1,2(a4)
		bhi.w	loc_29FA6
		movea.l	6(a4),a2		; Check for new path
		move.w	(a2)+,d4
		move.w	d4,$10(a1)
		move.w	(a2)+,d5
		move.w	d5,$14(a1)
		move.l	a2,6(a4)
		subq.w	#4,4(a4)
		beq.s	loc_29F86
		move.w	(a2)+,d4
		move.w	(a2)+,d5
		move.w	#$1000,d2
		bra.w	AutoTunnel_CalcSpeed	; Recalc speed
; ---------------------------------------------------------------------------

loc_29F86:
		addq.b	#2,(a4)				; If end of path reached, next routine
		move.w	#0,$18(a1)
		move.w	#0,$1A(a1)			; Null momentum of player
		move.w	$14(a0),$46(a0)		; Backup Y position
		clr.b	1(a4)				; Zero out angle
		move.b	#0,($FFFFEE39).w	; Restore normal Camera Y follow
		rts
; ---------------------------------------------------------------------------

loc_29FA6:
		move.l	$10(a1),d2			; Move tube elevator based on autotunnel speed
		move.l	$14(a1),d3
		move.w	$18(a1),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d2
		move.w	$1A(a1),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d3
		move.l	d2,$10(a1)
		move.l	d3,$14(a1)
		rts
; ---------------------------------------------------------------------------

LBZTubeElevator_SlowSpin:
		move.w	$22(a0),d0
		sub.w	$3C(a0),d0
		bcc.s	loc_29FDA
		addi.w	#$600,d0

loc_29FDA:
		move.w	d0,$22(a0)
		move.w	$26(a0),d0
		sub.w	$3C(a0),d0		; Spin spin spinning
		bcc.s	loc_29FEC
		addi.w	#$C00,d0

loc_29FEC:
		move.w	d0,$26(a0)
		cmpi.w	#8,$3C(a0)
		bne.s	loc_2A014
		cmpi.b	#2,$22(a0)		; When minimum speed reached and correct rotation on tube
		bne.s	LBZTubeElevator_WaitExit
		addq.b	#2,(a4)			; Next routine
		move.w	$48(a0),d0
		beq.s	loc_2A012
		movea.w	d0,a2
		bclr	#7,(a2)			; Restore jump control on player
		clr.w	$48(a0)

loc_2A012:
		bra.s	LBZTubeElevator_WaitExit
; ---------------------------------------------------------------------------

loc_2A014:
		subq.w	#4,$3C(a0)	; Subtract spin speed

LBZTubeElevator_WaitExit:


		addq.b	#2,1(a4)	; Change bobbing angle
		move.b	1(a4),d0
		cmpi.b	#-$50,d0
		bcs.s	loc_2A030
		cmpi.b	#-$30,d0
		bcc.s	loc_2A030
		addi.b	#$20,d0

loc_2A030:

		move.b	d0,1(a4)
		jsr	(GetSineCosine).l
		cmpi.w	#$100,d0
		bne.s	loc_2A042
		subq.w	#1,d0

loc_2A042:
		asr.w	#6,d0
		move.w	$46(a0),d2
		sub.w	d0,d2
		move.w	d2,$14(a0)	; Apply bobbing motion
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		move.w	#8,d2
		move.w	#$20,d3
		move.w	$10(a0),d4
		jsr	SolidObjectFull_Offset
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		bne.s	locret_2A07C
		addq.b	#2,(a4)		; When player is no longer standing on object, next routine
		move.b	#0,$24(a0)

locret_2A07C:
		rts
; ---------------------------------------------------------------------------

LBZTubeElevator_EndSpin:
		subq.b	#1,$24(a0)
		bpl.s	LBZTubeElevator_Closed
		move.b	#$F,$24(a0)
		addq.b	#1,$22(a0)	; Spin object until closed frame is on
		cmpi.b	#6,$22(a0)
		bcs.s	loc_2A09E
		move.b	#0,$22(a0)
		addq.b	#2,(a4)

loc_2A09E:
		addq.b	#1,$26(a0)
		cmpi.b	#6,$26(a0)
		bcs.s	LBZTubeElevator_Closed
		move.b	#0,$26(a0)

LBZTubeElevator_Closed:


		addq.b	#2,1(a4)	; Add to bobbing angle
		move.b	1(a4),d0
		cmpi.b	#-$50,d0
		bcs.s	loc_2A0C8
		cmpi.b	#-$30,d0
		bcc.s	loc_2A0C8
		addi.b	#$20,d0

loc_2A0C8:

		move.b	d0,1(a4)
		jsr	(GetSineCosine).l
		cmpi.w	#$100,d0
		bne.s	loc_2A0DA
		subq.w	#1,d0

loc_2A0DA:
		asr.w	#6,d0
		move.w	$46(a0),d2
		sub.w	d0,d2
		move.w	d2,$14(a0)		; Apply bobbing offset
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	SolidObjectFull		; Fully closed
		rts

; =============== S U B R O U T I N E =======================================


LBZTubeElevator_CheckPlayer:

		move.b	(a2),d0
		bne.w	loc_2A1B6
		tst.w	($FFFFFE08).w
		bne.w	locret_2A1B4	; Do nothing if currently in debug state
		cmpa.w	#$B04A,a1
		bne.s	loc_2A128
		btst	#4,$2A(a0)
		beq.s	loc_2A128
		tst.b	-1(a2)
		bne.s	loc_2A164

loc_2A128:

		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addq.w	#3,d0
		btst	#0,$2A(a0)
		beq.s	loc_2A13E
		addi.w	#$A,d0

loc_2A13E:
		cmpi.w	#$10,d0
		bcc.s	locret_2A1B4
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		addi.w	#$20,d1
		cmpi.w	#$40,d1			; Check if in range
		bcc.s	locret_2A1B4
		tst.b	$2E(a1)
		bne.s	locret_2A1B4	; If player is already under control, skip all this.
		btst	#1,$2A(a1)
		bne.s	locret_2A1B4	; If player is upside down, skip all this

loc_2A164:
		addq.b	#2,(a2)
		move.b	#$83,$2E(a1)	; Object control of player, control of animation too
		move.b	#0,$20(a1)		; Clear player animation
		clr.b	$40(a1)
		move.w	#0,$1C(a1)
		move.w	#0,$18(a1)
		move.w	#0,$1A(a1)		; Null momentum
		bclr	#5,$2A(a0)
		bclr	#5,$2A(a1)		; Not pushing
		bclr	#1,$2A(a1)		; Ensure player is right-side up
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),d0		; Match player position to object position
		addi.w	#$18,d0
		moveq	#0,d1
		move.b	$1E(a1),d1
		sub.w	d1,d0
		move.w	d0,$14(a1)

locret_2A1B4:

		rts
; ---------------------------------------------------------------------------

loc_2A1B6:
		subq.b	#2,d0			; If player already inside
		bne.w	locret_2A230
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),d0
		addi.w	#$18,d0
		moveq	#0,d1
		move.b	$1E(a1),d1
		sub.w	d1,d0
		move.w	d0,$14(a1)		; Match player position
		cmpi.b	#8,$2E(a0)
		bne.s	loc_2A1EC
		bset	#0,$2A(a1)
		move.b	#0,$2E(a1)
		addq.b	#2,(a2)

loc_2A1EC:
		moveq	#0,d0
		move.b	$26(a0),d0
		move.b	LBZTubeElevator_PlayerFrame(pc,d0.w),$22(a1)
		andi.b	#-4,4(a1)
		move.b	LBZTubeElevator_PlayerFlip(pc,d0.w),d0
		or.b	d0,4(a1)
		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2
		rts
; ---------------------------------------------------------------------------
LBZTubeElevator_PlayerFrame:	dc.b $55
		dc.b $59
		dc.b $5A
		dc.b $5B
		dc.b $5A
		dc.b $59
		dc.b $55
		dc.b $56
		dc.b $57
		dc.b $58
		dc.b $57
		dc.b $56
LBZTubeElevator_PlayerFlip:	dc.b 0
		dc.b 1
		dc.b 1
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 1
		dc.b 1
		dc.b 1
		dc.b 0
		dc.b 0
		dc.b 0
; ---------------------------------------------------------------------------

locret_2A230:
		rts
; End of function LBZTubeElevator_CheckPlayer

; ---------------------------------------------------------------------------
word_2A232:	dc.w 1
		dc.w 3
		dc.w 7
		dc.w $F
		dc.w $1F
		dc.w $3F
		dc.w $7F
		dc.w $FF
		dc.w $1FF
		dc.w $3FF
		dc.w $7FF
		dc.w $FFF
		dc.w $1FFF
		dc.w $3FFF
		dc.w $7FFF
		dc.w $FFFF
; ---------------------------------------------------------------------------

Obj_AIZDisappearingFloor:

		move.b	$2C(a0),d0
		move.b	d0,d1
		andi.w	#$F,d0
		move.w	d0,d2
		add.w	d0,d0
		move.w	word_2A232(pc,d0.w),$32(a0)
		subq.w	#3,d2
		bcc.s	loc_2A26C
		moveq	#0,d2

loc_2A26C:
		lsr.w	#4,d1
		andi.w	#$F,d1
		lsl.w	d2,d1
		move.w	d1,$34(a0)
		move.l	#Map_AIZDisappearingFloor,$C(a0)
		move.w	#$42E9,$A(a0)
		move.w	#$4001,$A(a0)
		move.b	#$20,7(a0)
		move.b	#$18,6(a0)
		move.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.w	($FFFFFE04).w,d0
		add.w	$34(a0),d0
		and.w	$32(a0),d0
		beq.s	loc_2A2D0
		subi.w	#$C8,d0
		bcc.s	loc_2A2D0
		neg.w	d0
		move.b	d0,$24(a0)
		move.b	#0,$23(a0)
		move.w	#$202,$20(a0)
		move.b	#5,$22(a0)

loc_2A2D0:

		move.l	#loc_2A2D6,(a0)

loc_2A2D6:
		move.w	($FFFFFE04).w,d0
		add.w	$34(a0),d0
		and.w	$32(a0),d0
		bne.w	loc_2A300
		move.w	#$100,$20(a0)
		move.b	#0,$36(a0)
		tst.b	4(a0)
		bpl.s	loc_2A300
		moveq	#$4B,d0
		jsr	(Play_Sound_2).l

loc_2A300:

		lea	(Ani_AIZDisappearingFloor).l,a1
		jsr	(Animate_SpriteIrregularDelay).l
		cmpi.b	#5,$22(a0)
		bne.s	loc_2A366
		tst.b	$36(a0)
		bne.s	loc_2A366
		move.b	#1,$36(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_2A366
		move.l	#loc_2A36C,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.l	#Map_AIZDisappearingFloor2,$C(a1)
		move.w	#$62E9,$A(a1)
		move.b	#$28,7(a1)
		move.b	#$20,6(a1)
		move.b	#4,4(a1)
		move.w	#$200,8(a1)
		move.w	a0,$3C(a1)

loc_2A366:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_2A36C:
		movea.w	$3C(a0),a1
		cmpi.b	#3,$22(a1)
		bne.s	loc_2A37E
		move.w	#$7FF0,$10(a0)

loc_2A37E:
		subq.b	#1,$24(a0)
		bpl.s	loc_2A394
		move.b	#3,$24(a0)
		addq.b	#1,$22(a0)
		andi.b	#3,$22(a0)

loc_2A394:
		move.w	#$2B,d1
		move.w	#$18,d2
		move.w	#$19,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
Ani_AIZDisappearingFloor:	include "Levels\AIZ\Misc Object Data\Anim - Disappearing Floor.asm"

; ---------------------------------------------------------------------------

Obj_CorkFloor:

		move.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.l	#Map_AIZCorkFloor,$C(a0)
		move.w	#$4001,$A(a0)
		move.b	#$10,7(a0)

loc_2A3F0:
		move.b	#$28,6(a0)
		move.l	#word_2A8B0,$3C(a0)
		cmpi.w	#1,($FFFFFE10).w
		bne.s	loc_2A41A
		move.l	#Map_AIZCorkFloor2,$C(a0)
		move.w	#$4001,$A(a0)
		move.b	#$2C,6(a0)

loc_2A41A:
		cmpi.b	#3,($FFFFFE10).w
		bne.s	loc_2A444
		move.l	#Map_CNZCorkFloor,$C(a0)
		move.w	#$4430,$A(a0)
		move.b	#$20,7(a0)
		move.b	#$20,6(a0)
		move.l	#word_2A8E0,$3C(a0)

loc_2A444:
		cmpi.b	#4,($FFFFFE10).w
		bne.s	loc_2A46E
		move.l	#Map_FBZCorkFloor,$C(a0)
		move.w	#$243A,$A(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.l	#word_2A884,$3C(a0)

loc_2A46E:
		cmpi.b	#5,($FFFFFE10).w
		bne.s	loc_2A4C2
		move.l	#Map_ICZCorkFloor,$C(a0)
		move.w	#$4001,$A(a0)
		move.b	#$10,7(a0)
		move.b	#$24,6(a0)
		move.b	$2C(a0),d0
		move.b	d0,d1
		andi.b	#$F,d0
		move.b	d0,$22(a0)
		andi.b	#$10,d1
		bne.s	loc_2A4AE
		move.l	#loc_2A6D4,(a0)
		bra.w	loc_2A6D4
; ---------------------------------------------------------------------------

loc_2A4AE:
		move.l	#word_2A884,$3C(a0)
		move.w	#$43B6,$A(a0)
		move.b	#$10,6(a0)

loc_2A4C2:
		cmpi.b	#6,($FFFFFE10).w
		bne.s	loc_2A4EC
		move.l	#Map_LBZCorkFloor,$C(a0)
		move.w	#$4001,$A(a0)
		move.b	#$20,7(a0)
		move.b	#$20,6(a0)
		move.l	#word_2A8E0,$3C(a0)

loc_2A4EC:
		tst.b	$2C(a0)
		bne.s	loc_2A4FC
		move.l	#loc_2A618,(a0)
		bra.w	loc_2A618
; ---------------------------------------------------------------------------

loc_2A4FC:
		move.l	#loc_2A502,(a0)

loc_2A502:
		move.w	($FFFFF7D0).w,$38(a0)
		move.b	($FFFFB020).w,$34(a0)
		move.b	($FFFFB06A).w,$36(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		move.b	$2A(a0),d0
		andi.w	#$18,d0
		bne.s	loc_2A542

loc_2A53C:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_2A542:
		cmpi.b	#$18,d0
		bne.s	loc_2A570
		cmpi.b	#2,$34(a0)
		beq.s	loc_2A558
		cmpi.b	#2,$36(a0)
		bne.s	loc_2A53C

loc_2A558:
		lea	($FFFFB000).w,a1
		move.b	$34(a0),d0
		bsr.s	sub_2A588
		lea	($FFFFB04A).w,a1
		move.b	$36(a0),d0
		bsr.s	sub_2A588
		bra.w	loc_2A5D8
; ---------------------------------------------------------------------------

loc_2A570:
		move.b	d0,d1
		andi.b	#8,d1
		beq.s	loc_2A5C0
		cmpi.b	#2,$34(a0)
		bne.s	loc_2A53C
		lea	($FFFFB000).w,a1
		bsr.s	sub_2A58E
		bra.s	loc_2A5D8

; =============== S U B R O U T I N E =======================================


sub_2A588:

		cmpi.b	#2,d0
		bne.s	loc_2A5AC
; End of function sub_2A588


; =============== S U B R O U T I N E =======================================


sub_2A58E:

		bset	#2,$2A(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		move.w	#-$300,$1A(a1)

loc_2A5AC:
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		move.b	#2,5(a1)
		rts
; End of function sub_2A58E

; ---------------------------------------------------------------------------

loc_2A5C0:
		andi.b	#$10,d0
		beq.w	loc_2A53C
		cmpi.b	#2,$36(a0)
		bne.w	loc_2A53C
		lea	($FFFFB04A).w,a1
		bsr.s	sub_2A58E

loc_2A5D8:

		move.w	$38(a0),($FFFFF7D0).w
		andi.b	#-$19,$2A(a0)
		movea.l	$3C(a0),a4
		addq.b	#1,$22(a0)
		move.l	#loc_2A5F8,(a0)
		jsr	(sub_216B0).l

loc_2A5F8:


		jsr	(MoveSprite2).l
		addi.w	#$18,$1A(a0)
		tst.b	4(a0)
		bpl.w	loc_2A612
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2A612:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2A618:

		move.w	($FFFFB01A).w,$30(a0)
		move.w	($FFFFB064).w,$32(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		swap	d6
		andi.w	#$C,d6
		bne.s	loc_2A650
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_2A650:
		move.b	d6,d0
		andi.b	#4,d0
		beq.s	loc_2A674
		lea	($FFFFB000).w,a1
		move.w	$30(a0),$1A(a1)
		andi.b	#8,d6
		beq.s	loc_2A68C
		lea	($FFFFB04A).w,a1
		move.w	$32(a0),$1A(a1)
		bra.s	loc_2A68C
; ---------------------------------------------------------------------------

loc_2A674:
		andi.b	#8,d6
		beq.s	loc_2A686
		lea	($FFFFB04A).w,a1
		move.w	$32(a0),$1A(a1)
		bra.s	loc_2A68C
; ---------------------------------------------------------------------------

loc_2A686:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_2A68C:

		btst	#3,$2A(a0)
		beq.s	loc_2A6A4
		lea	($FFFFB000).w,a1
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)

loc_2A6A4:
		btst	#4,$2A(a0)
		beq.s	loc_2A6BC
		lea	($FFFFB04A).w,a1
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)

loc_2A6BC:
		movea.l	$3C(a0),a4
		addq.b	#1,$22(a0)
		move.l	#loc_2A5F8,(a0)
		jsr	(sub_216B0).l
		bra.w	loc_2A5F8
; ---------------------------------------------------------------------------

loc_2A6D4:

		move.w	($FFFFF7D0).w,$38(a0)
		move.b	($FFFFB020).w,$34(a0)
		move.b	($FFFFB06A).w,$36(a0)
		lea	(byte_2A894).l,a2
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	$10(a0),d4
		jsr	(sub_1DDC6).l
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		bne.s	loc_2A716

loc_2A710:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_2A716:
		cmpi.b	#$18,d0
		bne.s	loc_2A77A
		cmpi.b	#2,$34(a0)
		bne.s	loc_2A732
		tst.b	$2C(a0)
		bmi.s	loc_2A762
		cmpi.b	#$E,($FFFFB046).w
		beq.s	loc_2A762

loc_2A732:
		move.b	#$C,($FFFFB046).w
		move.b	#$D,($FFFFB047).w
		cmpi.b	#2,$36(a0)
		bne.s	loc_2A754
		tst.b	$2C(a0)
		bmi.s	loc_2A762
		cmpi.b	#$E,($FFFFB090).w
		beq.s	loc_2A762

loc_2A754:
		move.b	#$C,($FFFFB090).w
		move.b	#$D,($FFFFB091).w
		bra.s	loc_2A710
; ---------------------------------------------------------------------------

loc_2A762:

		lea	($FFFFB000).w,a1
		move.b	$34(a0),d0
		bsr.s	sub_2A7B0
		lea	($FFFFB04A).w,a1
		move.b	$36(a0),d0
		bsr.s	sub_2A7B0
		bra.w	loc_2A816
; ---------------------------------------------------------------------------

loc_2A77A:
		move.b	d0,d1
		andi.b	#8,d1
		beq.s	loc_2A7E2
		cmpi.b	#2,$34(a0)
		bne.s	loc_2A798
		tst.b	$2C(a0)
		bmi.s	loc_2A7A8
		cmpi.b	#$E,($FFFFB046).w
		beq.s	loc_2A7A8

loc_2A798:
		move.b	#$C,($FFFFB046).w
		move.b	#$D,($FFFFB047).w
		bra.w	loc_2A710
; ---------------------------------------------------------------------------

loc_2A7A8:

		lea	($FFFFB000).w,a1
		bsr.s	sub_2A7B6
		bra.s	loc_2A816

; =============== S U B R O U T I N E =======================================


sub_2A7B0:

		cmpi.b	#2,d0
		bne.s	loc_2A7CE
; End of function sub_2A7B0


; =============== S U B R O U T I N E =======================================


sub_2A7B6:

		bset	#2,$2A(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)

loc_2A7CE:
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		move.b	#2,5(a1)
		rts
; End of function sub_2A7B6

; ---------------------------------------------------------------------------

loc_2A7E2:
		andi.b	#$10,d0
		beq.w	loc_2A710
		cmpi.b	#2,$36(a0)
		bne.s	loc_2A800
		tst.b	$2C(a0)
		bmi.s	loc_2A810
		cmpi.b	#$E,($FFFFB090).w
		beq.s	loc_2A810

loc_2A800:
		move.b	#$C,($FFFFB090).w
		move.b	#$D,($FFFFB091).w
		bra.w	loc_2A710
; ---------------------------------------------------------------------------

loc_2A810:

		lea	($FFFFB04A).w,a1
		bsr.s	sub_2A7B6

loc_2A816:

		move.w	$38(a0),($FFFFF7D0).w
		andi.b	#-$19,$2A(a0)
		lea	(word_2A84C).l,a4
		moveq	#0,d0
		move.b	$22(a0),d0
		addq.b	#1,$22(a0)
		move.l	d0,d1
		add.w	d0,d0
		add.w	d0,d0
		lea	(a4,d0.w),a4
		move.l	#loc_2A5F8,(a0)
		jsr	(sub_216B0).l
		bra.w	loc_2A5F8
; ---------------------------------------------------------------------------
word_2A84C:	dc.w $FEC0,$F600
		dc.w  $140,$F600
		dc.w $FEE0,$F700
		dc.w  $120,$F700
		dc.w $FF00,$F800
		dc.w  $100,$F800
		dc.w $FF20,$F900
		dc.w   $E0,$F900
		dc.w $FF40,$FA00
		dc.w   $C0,$FA00
		dc.w $FF60,$FA80
		dc.w   $A0,$FA80
		dc.w $FF80,$FB00
		dc.w   $80,$FB00
word_2A884:	dc.w $FE00,$FE00

		dc.w  $200,$FE00
		dc.w $FF00,$FF00
		dc.w  $100,$FF00
byte_2A894:	dc.b $23, $23
		dc.b $22, $22
		dc.b $21, $21
		dc.b $20, $1F
		dc.b $1F, $1E
		dc.b $1E, $1D
		dc.b $1D, $1C
		dc.b $1B, $1B
		dc.b $1A, $1A
		dc.b $19, $19
		dc.b $17, $16
		dc.b $15, $15
		dc.b $14, $14
		dc.b $13, $13
word_2A8B0:	dc.w $FF00,$FE00

		dc.w  $100,$FE00
		dc.w $FF20,$FE40
		dc.w   $E0,$FE40
		dc.w $FF40,$FE80
		dc.w   $C0,$FE80
		dc.w $FF60,$FEC0
		dc.w   $A0,$FEC0
		dc.w $FF80,$FF00
		dc.w   $80,$FF00
		dc.w $FFA0,$FF40
		dc.w   $60,$FF40
word_2A8E0:	dc.w $FC00,$FC00

		dc.w $FE00,$FC00
		dc.w  $200,$FC00
		dc.w  $400,$FC00
		dc.w $FC40,$FC40
		dc.w $FE40,$FC40
		dc.w  $1C0,$FC40
		dc.w  $3C0,$FC40
		dc.w $FC80,$FC80
		dc.w $FE80,$FC80
		dc.w  $180,$FC80
		dc.w  $380,$FC80
		dc.w $FCC0,$FCC0
		dc.w $FEC0,$FCC0
		dc.w  $140,$FCC0
		dc.w  $340,$FCC0
Map_FBZCorkFloor:include "Levels\FBZ\Misc Object Data\Map - Cork Floor.asm"

; ---------------------------------------------------------------------------

Obj_AIZFlippingBridge:

		move.l	#Map_AIZFlippingBridge,$C(a0)
		move.w	#$42E9,$A(a0)
		move.b	#-$80,7(a0)
		move.b	#4,6(a0)
		move.b	#4,4(a0)
		move.w	#$200,8(a0)
		move.w	$14(a0),$30(a0)
		move.l	#word_2AAF2,$32(a0)
		move.b	$2C(a0),d0
		bpl.s	loc_2A98E
		move.l	#word_2AB72,$32(a0)

loc_2A98E:
		move.b	d0,d1
		andi.w	#$F,d0
		addi.w	#$10,d0
		move.b	d0,$37(a0)
		lsr.b	#4,d1
		andi.w	#7,d1
		move.b	d1,$25(a0)
		moveq	#1,d1
		btst	#0,$2A(a0)
		beq.s	loc_2A9B6
		moveq	#-1,d1
		subq.b	#1,$37(a0)

loc_2A9B6:
		move.b	d1,$36(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_2AA50
		move.l	#loc_2AA78,(a1)
		move.l	#Map_AIZFlippingBridge,$C(a1)
		move.w	#$42E9,$A(a1)
		move.b	#4,4(a1)
		move.b	#-$80,7(a1)
		move.b	#$40,6(a1)
		move.w	#$200,8(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		bset	#6,4(a1)
		move.w	#8,$16(a1)
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		subi.w	#$70,d3
		addi.w	#$20,d2
		move.w	#8,d4
		tst.b	$2C(a0)
		bpl.s	loc_2AA2A
		subi.w	#$10,d2
		move.w	#4,d4

loc_2AA2A:
		moveq	#0,d1
		lea	$18(a1),a2
		move.w	$16(a1),d6
		subq.w	#1,d6

loc_2AA36:
		move.w	d3,(a2)+
		move.w	d2,(a2)+
		move.w	d1,(a2)+
		addq.w	#2,d1
		andi.w	#$F,d1
		addi.w	#$20,d3
		sub.w	d4,d2
		dbf	d6,loc_2AA36
		move.w	a1,$3C(a0)

loc_2AA50:
		move.l	#loc_2AA56,(a0)

loc_2AA56:
		movea.w	$3C(a0),a3
		bsr.w	sub_2AA7E
		moveq	#0,d1
		move.b	7(a0),d1
		movea.l	$32(a0),a2
		move.w	$10(a0),d4
		jsr	(sub_2ABF2).l
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_2AA78:
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_2AA7E:
		subq.b	#1,$24(a0)
		bpl.s	locret_2AAC8
		move.b	$25(a0),$24(a0)
		lea	$1D(a3),a2
		move.w	$16(a3),d6
		subq.w	#1,d6
		move.b	$37(a0),d2
		move.b	$36(a0),d1
		bmi.s	loc_2AACA

loc_2AA9E:
		add.b	d1,(a2)
		cmp.b	(a2),d2
		bhi.s	loc_2AAA8
		move.b	#0,(a2)

loc_2AAA8:
		addq.w	#6,a2
		dbf	d6,loc_2AA9E
		tst.b	4(a3)
		bpl.s	locret_2AAC8
		move.b	($FFFFFE05).w,d0
		addq.b	#3,d0
		andi.b	#7,d0
		bne.s	locret_2AAC8
		moveq	#$4C,d0
		jsr	(Play_Sound_2).l

locret_2AAC8:

		rts
; ---------------------------------------------------------------------------

loc_2AACA:

		add.b	d1,(a2)
		bcs.s	loc_2AAD0
		move.b	d2,(a2)

loc_2AAD0:
		addq.w	#6,a2
		dbf	d6,loc_2AACA
		tst.b	4(a3)
		bpl.s	locret_2AAF0
		move.b	($FFFFFE05).w,d0
		addq.b	#3,d0
		andi.b	#7,d0
		bne.s	locret_2AAF0
		moveq	#$4C,d0
		jsr	(Play_Sound_2).l

locret_2AAF0:

		rts
; End of function sub_2AA7E

; ---------------------------------------------------------------------------
word_2AAF2:	dc.w  $E4E4, $E4E4
		dc.w  $E4E4, $E4E4
		dc.w  $E4E4, $E4E4
		dc.w  $E4E4, $E4E4
		dc.w  $ECEC, $ECEC
		dc.w  $ECEC, $ECEC
		dc.w  $ECEC, $ECEC
		dc.w  $ECEC, $ECEC
		dc.w  $F4F4, $F4F4
		dc.w  $F4F4, $F4F4
		dc.w  $F4F4, $F4F4
		dc.w  $F4F4, $F4F4
		dc.w  $FCFC, $FCFC
		dc.w  $FCFC, $FCFC
		dc.w  $FCFC, $FCFC
		dc.w  $FCFC, $FCFC
		dc.w   $404,  $404
		dc.w   $404,  $404
		dc.w   $404,  $404
		dc.w   $404,  $404
		dc.w   $C0C,  $C0C
		dc.w   $C0C,  $C0C
		dc.w   $C0C,  $C0C
		dc.w   $C0C,  $C0C
		dc.w  $1414, $1414
		dc.w  $1414, $1414
		dc.w  $1414, $1414
		dc.w  $1414, $1414
		dc.w  $1C1C, $1C1C
		dc.w  $1C1C, $1C1C
		dc.w  $1C1C, $1C1C
		dc.w  $1C1C, $1C1C
word_2AB72:	dc.w  $F4F4, $F4F4
		dc.w  $F4F4, $F4F4
		dc.w  $F4F4, $F4F4
		dc.w  $F4F4, $F4F4
		dc.w  $F8F8, $F8F8
		dc.w  $F8F8, $F8F8
		dc.w  $F8F8, $F8F8
		dc.w  $F8F8, $F8F8
		dc.w  $FCFC, $FCFC
		dc.w  $FCFC, $FCFC
		dc.w  $FCFC, $FCFC
		dc.w  $FCFC, $FCFC
		dc.w	  0,	 0
		dc.w	  0,	 0
		dc.w	  0,	 0
		dc.w	  0,	 0
		dc.w   $404,  $404
		dc.w   $404,  $404
		dc.w   $404,  $404
		dc.w   $404,  $404
		dc.w   $808,  $808
		dc.w   $808,  $808
		dc.w   $808,  $808
		dc.w   $808,  $808
		dc.w   $C0C,  $C0C
		dc.w   $C0C,  $C0C
		dc.w   $C0C,  $C0C
		dc.w   $C0C,  $C0C
		dc.w  $1010, $1010
		dc.w  $1010, $1010
		dc.w  $1010, $1010
		dc.w  $1010, $1010

; =============== S U B R O U T I N E =======================================


sub_2ABF2:
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		bsr.s	sub_2AC08
		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		addq.b	#1,d6
; End of function sub_2ABF2


; =============== S U B R O U T I N E =======================================


sub_2AC08:
		btst	d6,$2A(a0)
		beq.s	loc_2AC5E
		move.w	d1,d2
		add.w	d2,d2
		btst	#1,$2A(a1)
		bne.s	loc_2AC2A
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	loc_2AC2A
		cmp.w	d2,d0
		bcs.s	loc_2AC3E

loc_2AC2A:

		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)
		bclr	d6,$2A(a0)
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_2AC3E:
		lsr.w	#5,d0
		add.w	d0,d0
		move.w	d0,d3
		add.w	d0,d0
		add.w	d3,d0
		move.b	$1D(a3,d0.w),d0
		cmpi.b	#5,d0
		bcs.s	loc_2AC2A
		move.w	d4,d2
		jsr	(SolidObjSloped2).l
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_2AC5E:
		tst.w	$1A(a1)
		bmi.s	locret_2ACDA
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	locret_2ACDA
		add.w	d1,d1
		cmp.w	d1,d0
		bcc.s	locret_2ACDA
		btst	#0,4(a0)
		beq.s	loc_2AC82
		not.w	d0
		add.w	d1,d0

loc_2AC82:
		move.w	d0,d4
		lsr.w	#1,d0
		move.b	(a2,d0.w),d3
		ext.w	d3
		move.w	$14(a0),d0
		sub.w	d3,d0
		move.w	$14(a1),d2
		move.b	$1E(a1),d1
		ext.w	d1
		add.w	d2,d1
		addq.w	#4,d1
		sub.w	d1,d0
		bhi.s	locret_2ACDA
		cmpi.w	#-$10,d0
		bcs.s	locret_2ACDA
		tst.b	$2E(a1)
		bne.s	locret_2ACDA
		cmpi.b	#6,5(a1)
		bcc.s	locret_2ACDA
		lsr.w	#5,d4
		add.w	d4,d4
		move.w	d4,d1
		add.w	d4,d4
		add.w	d1,d4
		move.b	$1D(a3,d4.w),d4
		cmpi.b	#5,d4
		bcs.s	locret_2ACDA
		add.w	d0,d2
		addq.w	#3,d2
		move.w	d2,$14(a1)
		jmp	(RideObject_SetRide).l
; ---------------------------------------------------------------------------

locret_2ACDA:

		rts
; End of function sub_2AC08

; ---------------------------------------------------------------------------

Obj_AIZCollapsingLogBridge:

		move.b	$2C(a0),d0
		bmi.w	loc_2ADA8
		move.b	d0,$36(a0)
		addi.b	#$30,d0
		move.b	d0,$35(a0)
		move.b	#8,$37(a0)
		move.l	#Map_AIZCollapsingLogBridge,$C(a0)
		move.w	#$42E9,$A(a0)
		move.b	#$5A,7(a0)
		move.b	#8,6(a0)
		move.b	#4,4(a0)
		move.w	#$200,8(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_2AD9E
		move.l	#loc_2AEB4,(a1)
		move.l	#Map_AIZCollapsingLogBridge,$C(a1)
		move.w	#$42E9,$A(a1)
		ori.b	#4,4(a1)
		move.b	#$5A,7(a1)
		move.b	#8,6(a1)
		move.w	#$200,8(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		bset	#6,4(a1)
		move.w	#6,$16(a1)
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		subi.w	#$4B,d3
		lea	$18(a1),a2
		move.w	$16(a1),d6
		subq.w	#1,d6
		move.w	#1,4(a2)

loc_2AD86:
		move.w	d3,(a2)+
		move.w	d2,(a2)+
		addq.w	#2,a2
		addi.w	#$1E,d3
		dbf	d6,loc_2AD86
		move.w	#2,-2(a2)
		move.w	a1,$3C(a0)

loc_2AD9E:
		move.l	#loc_2AE70,(a0)
		bra.w	loc_2AE70
; ---------------------------------------------------------------------------

loc_2ADA8:
		andi.b	#$7F,d0
		move.b	d0,$36(a0)
		addi.b	#$30,d0
		move.b	d0,$35(a0)
		move.b	#8,$37(a0)
		move.l	#Map_AIZDrawBridgeFire,$C(a0)
		move.w	#-$3D17,$A(a0)
		move.b	#$60,7(a0)
		move.b	#8,6(a0)
		move.b	#4,4(a0)
		move.w	#$200,8(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_2AE66
		move.l	#loc_2AEB4,(a1)
		move.l	#Map_AIZDrawBridgeFire,$C(a1)
		move.w	#-$3D17,$A(a1)
		ori.b	#4,4(a1)
		move.b	#$60,7(a1)
		move.b	#8,6(a1)
		move.w	#$200,8(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		bset	#6,4(a1)
		move.w	#6,$16(a1)
		move.w	$14(a0),d2
		move.w	$10(a0),d3
		subi.w	#$50,d3
		lea	$18(a1),a2
		move.w	$16(a1),d6
		subq.w	#1,d6
		move.w	#1,4(a2)

loc_2AE4E:
		move.w	d3,(a2)+
		move.w	d2,(a2)+
		addq.w	#2,a2
		addi.w	#$20,d3
		dbf	d6,loc_2AE4E
		move.w	#2,-2(a2)
		move.w	a1,$3C(a0)

loc_2AE66:
		move.l	#loc_2AEE2,(a0)
		bra.w	loc_2AEE2
; ---------------------------------------------------------------------------

loc_2AE70:

		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	loc_2AE98
		move.b	$35(a0),$34(a0)
		move.b	$36(a0),d2
		move.b	$37(a0),d3
		move.l	#loc_2AF70,(a0)
		move.l	#loc_2AEBA,d4
		bsr.w	sub_2AFFE

loc_2AE98:
		moveq	#0,d1
		move.b	7(a0),d1
		moveq	#0,d3
		move.b	6(a0),d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_2AEB4:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_2AEBA:
		tst.b	$34(a0)
		beq.s	loc_2AECA
		subq.b	#1,$34(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2AECA:
		jsr	(MoveSprite).l
		tst.b	4(a0)
		bpl.s	loc_2AEDC
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2AEDC:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2AEE2:

		tst.b	($FFFFFAA2).w
		beq.s	loc_2AF06
		move.b	$35(a0),$34(a0)
		move.b	$36(a0),d2
		move.b	$37(a0),d3
		move.l	#loc_2AF70,(a0)
		move.l	#loc_2AF22,d4
		bsr.w	sub_2AFFE

loc_2AF06:
		moveq	#0,d1
		move.b	7(a0),d1
		moveq	#0,d3
		move.b	6(a0),d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_2AF22:
		tst.b	$34(a0)
		beq.s	loc_2AF3A
		subq.b	#1,$34(a0)
		bne.s	loc_2AF34
		move.b	#3,$22(a0)

loc_2AF34:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2AF3A:
		subq.b	#1,$24(a0)
		bpl.s	loc_2AF58
		move.b	#3,$24(a0)
		addq.b	#1,$22(a0)
		cmpi.b	#8,$22(a0)
		bcs.s	loc_2AF58
		move.b	#3,$22(a0)

loc_2AF58:

		jsr	(MoveSprite).l
		tst.b	4(a0)
		bpl.s	loc_2AF6A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2AF6A:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2AF70:

		subq.b	#1,$34(a0)
		bne.s	loc_2AF7C
		move.l	#loc_2B452,(a0)

loc_2AF7C:
		move.b	$34(a0),d3
		moveq	#0,d1
		move.b	7(a0),d1
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.s	sub_2AF9C
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.s	sub_2AF9C
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_2AF9C:

		btst	d6,$2A(a0)
		beq.s	locret_2AFFC
		move.w	d1,d2
		add.w	d2,d2
		btst	#1,$2A(a1)
		bne.s	loc_2AFE0
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	loc_2AFE0
		cmp.w	d2,d0
		bcc.s	loc_2AFE0
		btst	#0,$2A(a0)
		beq.s	loc_2AFCA
		neg.w	d0
		add.w	d2,d0

loc_2AFCA:
		lsr.w	#5,d0
		add.w	d0,d0
		add.w	d0,d0
		add.w	d0,d0
		add.b	$36(a0),d0
		move.b	$35(a0),d2
		sub.b	d0,d2
		cmp.b	d2,d3
		bhi.s	locret_2AFFC

loc_2AFE0:

		bclr	d6,$2A(a0)
		bclr	#3,$2A(a1)
		bclr	#5,$2A(a1)
		bset	#1,$2A(a1)
		move.b	#1,$21(a1)

locret_2AFFC:

		rts
; End of function sub_2AF9C


; =============== S U B R O U T I N E =======================================


sub_2AFFE:

		movea.w	$3C(a0),a3
		lea	$18(a3),a2
		move.w	$16(a3),d6
		subq.w	#1,d6
		bclr	#6,4(a3)
		movea.l	a3,a1
		bra.s	loc_2B01E
; ---------------------------------------------------------------------------

loc_2B016:
		jsr	(Create_New_Sprite3).l
		bne.s	loc_2B05C

loc_2B01E:
		move.l	d4,(a1)

loc_2B020:
		move.l	$C(a3),$C(a1)
		move.b	4(a3),4(a1)
		move.w	$A(a3),$A(a1)

loc_2B032:
		move.w	8(a3),8(a1)
		move.b	7(a3),7(a1)
		move.b	6(a3),6(a1)
		move.w	(a2)+,$10(a1)
		move.w	(a2)+,$14(a1)
		move.w	(a2)+,d0
		move.b	d0,$22(a1)
		move.b	d2,$34(a1)
		add.b	d3,d2
		dbf	d6,loc_2B016

loc_2B05C:
		move.w	#0,$18(a3)
		move.w	#0,$1A(a3)
		moveq	#$59,d0
		jmp	(Play_Sound_2).l
; End of function sub_2AFFE

; ---------------------------------------------------------------------------
Map_AIZCollapsingLogBridge:include "Levels\AIZ\Misc Object Data\Map - Collapsing Log Bridge.asm"


Map_AIZDrawBridgeFire:	include "Levels\AIZ\Misc Object Data\Map - Draw Bridge Fire.asm"

; ---------------------------------------------------------------------------

Obj_AIZDrawBridge:

		move.l	#Map_AIZDrawBridge,$C(a0)
		move.w	#-$3D17,$A(a0)
		move.b	#4,4(a0)
		move.w	#$280,8(a0)

loc_2B144:
		move.b	#8,7(a0)
		move.b	#$60,6(a0)
		ori.b	#-$80,$2A(a0)
		move.w	$10(a0),$30(a0)
		move.w	$14(a0),$32(a0)

loc_2B162:
		subi.w	#$68,$14(a0)
		move.b	#-$40,$38(a0)
		moveq	#-$10,d4
		btst	#1,$2A(a0)
		beq.s	loc_2B186
		addi.w	#$D0,$14(a0)
		move.b	#$40,$38(a0)
		neg.w	d4

loc_2B186:
		move.w	#$200,d1
		btst	#0,$2A(a0)
		beq.s	loc_2B194
		neg.w	d1

loc_2B194:
		move.w	d1,$34(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_2B266
		move.l	#loc_2B380,(a1)

loc_2B1A8:
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.w	8(a0),8(a1)
		move.b	#4,4(a1)

loc_2B1C0:
		bset	#6,4(a1)
		move.b	#$40,7(a1)
		move.b	#$40,6(a1)

loc_2B1D2:
		move.w	$30(a0),d2
		move.w	$32(a0),d3
		moveq	#8,d1
		move.w	d1,$16(a1)
		subq.w	#1,d1
		lea	$18(a1),a2

loc_2B1E6:
		add.w	d4,d3
		move.w	d2,(a2)+
		move.w	d3,(a2)+
		move.w	#1,(a2)+
		dbf	d1,loc_2B1E6
		move.w	$30(a1),$10(a1)
		move.w	$32(a1),$14(a1)
		move.w	a1,$3C(a0)
		jsr	(Create_New_Sprite3).l
		bne.s	loc_2B266
		move.l	#loc_2B380,(a1)

loc_2B212:
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.w	8(a0),8(a1)
		move.b	#4,4(a1)

loc_2B22A:
		bset	#6,4(a1)
		move.b	#$40,7(a1)
		move.b	#$40,6(a1)
		moveq	#4,d1
		move.w	d1,$16(a1)
		subq.w	#1,d1
		lea	$18(a1),a2

loc_2B248:
		add.w	d4,d3
		move.w	d2,(a2)+
		move.w	d3,(a2)+
		move.w	#1,(a2)+
		dbf	d1,loc_2B248
		move.w	$18(a1),$10(a1)
		move.w	$1A(a1),$14(a1)
		move.w	a1,$3E(a0)

loc_2B266:

		move.l	#loc_2B26C,(a0)

loc_2B26C:
		tst.b	($FFFFFAA3).w
		beq.s	loc_2B2B0
		tst.b	$36(a0)
		bne.s	loc_2B2B0
		move.b	#1,$36(a0)
		moveq	#$56,d0
		jsr	(Play_Sound_2).l
		move.w	#$68,d1
		btst	#0,$2A(a0)
		beq.s	loc_2B294
		neg.w	d1

loc_2B294:
		move.w	$30(a0),$10(a0)
		move.w	$32(a0),$14(a0)
		add.w	d1,$10(a0)
		move.b	#$60,7(a0)
		move.b	#8,6(a0)

loc_2B2B0:

		tst.b	$36(a0)
		beq.s	loc_2B2E2
		tst.b	$38(a0)
		beq.s	loc_2B2C4
		cmpi.b	#-$80,$38(a0)
		bne.s	loc_2B2DA

loc_2B2C4:
		move.b	#0,$36(a0)
		moveq	#$56,d0
		jsr	(Play_Sound_2).l
		move.l	#loc_2B2E8,(a0)
		bra.s	loc_2B2E2
; ---------------------------------------------------------------------------

loc_2B2DA:
		move.w	$34(a0),d0
		add.w	d0,$38(a0)

loc_2B2E2:

		bsr.w	sub_2B386
		bra.s	loc_2B304
; ---------------------------------------------------------------------------

loc_2B2E8:
		tst.b	($FFFFFAA9).w
		beq.s	loc_2B304
		move.l	#loc_2B452,(a0)
		move.b	#$E,$34(a0)
		move.l	#loc_2B42A,d4
		bra.w	loc_2B498
; ---------------------------------------------------------------------------

loc_2B304:

		move.w	#$13,d1
		move.w	#$60,d2
		move.w	#$61,d3
		move.b	$38(a0),d0
		beq.s	loc_2B322
		cmpi.b	#$40,d0
		beq.s	loc_2B32E
		cmpi.b	#-$40,d0
		beq.s	loc_2B32E

loc_2B322:
		move.w	#$6B,d1
		move.w	#8,d2
		move.w	#8,d3

loc_2B32E:

		move.w	$10(a0),d4
		jsr	(SolidObjectFull2).l
		move.w	$30(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_2B352
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2B352:
		move.w	$3C(a0),d0
		beq.s	loc_2B360
		movea.w	d0,a1
		jsr	(Delete_Referenced_Sprite).l

loc_2B360:
		move.w	$3E(a0),d0
		beq.s	loc_2B36E
		movea.w	d0,a1
		jsr	(Delete_Referenced_Sprite).l

loc_2B36E:
		move.w	$48(a0),d0
		beq.s	loc_2B37A
		movea.w	d0,a2
		bclr	#7,(a2)

loc_2B37A:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2B380:

		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_2B386:
		tst.b	$36(a0)
		beq.w	locret_2B428
		moveq	#0,d0
		moveq	#0,d1
		move.b	$38(a0),d0
		jsr	(GetSineCosine).l
		move.w	$32(a0),d2
		move.w	$30(a0),d3
		moveq	#0,d6
		movea.w	$3C(a0),a1
		move.w	$16(a1),d6
		subq.w	#1,d6
		bcs.s	locret_2B428
		swap	d0
		swap	d1
		asr.l	#4,d0
		asr.l	#4,d1
		move.l	d0,d4
		move.l	d1,d5
		lea	$18(a1),a2

loc_2B3C2:
		movem.l	d4-d5,-(sp)
		swap	d4
		swap	d5
		add.w	d2,d4
		add.w	d3,d5
		move.w	d5,(a2)+
		move.w	d4,(a2)+
		movem.l	(sp)+,d4-d5
		add.l	d0,d4
		add.l	d1,d5
		addq.w	#2,a2
		dbf	d6,loc_2B3C2
		move.w	$30(a1),$10(a1)
		move.w	$32(a1),$14(a1)
		moveq	#0,d6
		movea.w	$3E(a0),a1
		move.w	$16(a1),d6
		subq.w	#1,d6

loc_2B3F8:
		bcs.s	locret_2B428
		lea	$18(a1),a2

loc_2B3FE:
		movem.l	d4-d5,-(sp)
		swap	d4
		swap	d5
		add.w	d2,d4
		add.w	d3,d5
		move.w	d5,(a2)+
		move.w	d4,(a2)+
		movem.l	(sp)+,d4-d5
		add.l	d0,d4
		add.l	d1,d5
		addq.w	#2,a2
		dbf	d6,loc_2B3FE
		move.w	$18(a1),$10(a1)
		move.w	$1A(a1),$14(a1)

locret_2B428:

		rts
; End of function sub_2B386

; ---------------------------------------------------------------------------

loc_2B42A:
		tst.b	$34(a0)
		beq.s	loc_2B43A
		subq.b	#1,$34(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2B43A:
		jsr	(MoveSprite).l
		tst.b	4(a0)
		bpl.s	loc_2B44C
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2B44C:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2B452:

		tst.b	$34(a0)
		beq.s	loc_2B45E
		subq.b	#1,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_2B45E:
		bclr	#3,$2A(a0)
		beq.s	loc_2B478
		bclr	#3,($FFFFB02A).w
		bset	#1,($FFFFB02A).w
		move.b	#$1B,($FFFFB020).w

loc_2B478:
		bclr	#4,$2A(a0)
		beq.s	loc_2B492
		bclr	#3,($FFFFB074).w
		bset	#1,($FFFFB074).w
		move.b	#$1B,($FFFFB06A).w

loc_2B492:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2B498:
		move.w	$3C(a0),d0
		beq.s	loc_2B4A2
		movea.w	d0,a3
		bsr.s	loc_2B4AE

loc_2B4A2:
		move.w	$3E(a0),d0
		beq.s	locret_2B4AC
		movea.w	d0,a3
		bsr.s	loc_2B4AE

locret_2B4AC:
		rts
; ---------------------------------------------------------------------------

loc_2B4AE:

		lea	(byte_2B548).l,a4
		lea	$18(a3),a2
		move.w	$16(a3),d6
		subq.w	#1,d6
		bclr	#6,4(a3)
		movea.l	a3,a1
		bra.s	loc_2B4D0
; ---------------------------------------------------------------------------

loc_2B4C8:
		jsr	(Create_New_Sprite3).l
		bne.s	loc_2B534

loc_2B4D0:
		move.l	d4,(a1)
		move.l	$C(a3),$C(a1)
		move.b	4(a3),4(a1)
		move.w	$A(a3),$A(a1)
		move.w	8(a3),8(a1)
		move.b	7(a3),7(a1)
		move.b	6(a3),6(a1)
		move.w	8(a3),8(a1)
		move.w	(a2)+,$10(a1)
		move.w	(a2)+,$14(a1)
		move.w	(a2)+,d0
		move.b	d0,$22(a1)
		move.b	(a4)+,$34(a1)
		movea.l	a1,a5
		jsr	(Create_New_Sprite3).l
		bne.s	loc_2B534
		move.l	#loc_1E6EC,(a1)
		move.w	$10(a5),$10(a1)
		move.w	$14(a5),$14(a1)
		move.b	-1(a4),$24(a1)
		dbf	d6,loc_2B4C8

loc_2B534:

		move.w	#0,$18(a3)
		move.w	#0,$1A(a3)
		moveq	#-$7D,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------
byte_2B548:	dc.b 8
		dc.b $10
		dc.b $C
		dc.b $E
		dc.b 6
		dc.b $A
		dc.b 4
		dc.b 2
		dc.b 8
		dc.b $10
		dc.b $C
		dc.b $E
		dc.b 6
		dc.b $A
		dc.b 4
		dc.b 2
Map_AIZDrawBridge:include "Levels\AIZ\Misc Object Data\Map - Drawbridge.asm"

word_2B566:	dc.w 1
		dc.w 3
		dc.w 7
		dc.w $F
		dc.w $1F
		dc.w $3F
		dc.w $7F
		dc.w $FF
		dc.w $1FF
		dc.w $3FF
		dc.w $7FF
		dc.w $FFF
		dc.w $1FFF
		dc.w $3FFF
		dc.w $7FFF
		dc.w $FFFF
; ---------------------------------------------------------------------------

Obj_AIZFallingLog:

		cmpi.w	#$26B0,$10(a0)
		beq.s	loc_2B596
		cmpi.w	#$2700,$10(a0)
		bne.s	loc_2B5A2

loc_2B596:
		tst.b	($FFFFF7E0).w
		beq.s	loc_2B5A2
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2B5A2:

		move.b	$2C(a0),d0
		move.b	d0,d1
		andi.w	#$F,d0
		move.w	d0,d2
		add.w	d0,d0
		move.w	word_2B566(pc,d0.w),$32(a0)
		subq.w	#3,d2
		bcc.s	loc_2B5BC
		moveq	#0,d2

loc_2B5BC:
		lsr.w	#4,d1
		andi.w	#$F,d1
		lsl.w	d2,d1
		move.w	d1,$34(a0)

;loc_2B5C8:
		move.b	#4,4(a0)
		move.l	#loc_2B5D4,(a0)

loc_2B5D4:
		move.w	($FFFFFE04).w,d0

;loc_2B5D8:
		add.w	$34(a0),d0
		and.w	$32(a0),d0

;loc_2B5E0:
		bne.w	loc_2B69A
		jsr	(Create_New_Sprite3).l
		bne.w	loc_2B69A
		move.l	#loc_2B6A0,(a1)
		move.w	$10(a0),$10(a1)

;loc_2B5FA:
		move.w	$14(a0),$14(a1)
		move.l	#Map_AIZFallingLog2,$C(a1)
		move.w	#$42E9,$A(a1)
		tst.b	($FFFFFE11).w
		bne.s	loc_2B622
		move.l	#Map_AIZFallingLog,$C(a1)

;loc_2B61C:
		move.w	#$43CF,$A(a1)

loc_2B622:
		move.b	#$18,7(a1)
		move.b	#8,6(a1)
		move.b	#4,4(a1)
		move.w	#$280,8(a1)
		movea.l	a1,a2
		jsr	(Create_New_Sprite3).l
		bne.w	loc_2B69A
		move.l	#loc_2B72C,(a1)

;loc_2B64C:
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)

;loc_2B658:
		move.l	#Map_AIZFallingLogSplash2,$C(a1)
		move.w	#$62E9,$A(a1)
		tst.b	($FFFFFE11).w
		bne.s	loc_2B67A

;loc_2B66C:
		move.l	#Map_AIZFallingLogSplash,$C(a1)
		move.w	#$43CF,$A(a1)

loc_2B67A:
		move.b	#$20,7(a1)

;loc_2B680:
		move.b	#$10,6(a1)
		move.b	#4,4(a1)

;loc_2B68C:
		move.w	#$200,8(a1)
		move.w	a2,$3C(a1)
		move.w	a1,$3C(a2)

loc_2B69A:

		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_2B6A0:
		addq.w	#1,$14(a0)
		move.w	$14(a0),d0
		cmp.w	($FFFFF646).w,d0
		bcs.s	loc_2B6BA
		move.l	#loc_2B6BC,(a0)
		move.b	#$3B,$24(a0)

loc_2B6BA:
		bra.s	loc_2B6D8
; ---------------------------------------------------------------------------

loc_2B6BC:
		subq.b	#1,$24(a0)
		bpl.s	loc_2B6C8
		move.w	#$7FF0,$10(a0)

loc_2B6C8:
		move.b	$24(a0),d0
		andi.b	#3,d0
		bne.s	loc_2B6D8
		bchg	#0,$36(a0)

loc_2B6D8:

		moveq	#0,d1
		move.b	7(a0),d1
		moveq	#8,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_2B70C
		tst.b	$36(a0)
		bne.s	locret_2B70A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_2B70A:
		rts
; ---------------------------------------------------------------------------

loc_2B70C:
		move.w	$3C(a0),d0
		beq.s	loc_2B71A
		movea.w	d0,a1
		jsr	(Delete_Referenced_Sprite).l

loc_2B71A:
		move.w	$48(a0),d0
		beq.s	loc_2B726
		movea.w	d0,a2
		bclr	#7,(a2)

loc_2B726:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2B72C:
		movea.w	$3C(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		subq.b	#1,$24(a0)
		bpl.s	loc_2B752
		move.b	#3,$24(a0)
		addq.b	#1,$22(a0)
		andi.b	#3,$22(a0)

loc_2B752:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_AIZSpikedLog:

		move.l	#Map_AIZSpikedLog,$C(a0)
		move.w	#$42E9,$A(a0)
		move.b	#$18,7(a0)
		move.b	#8,6(a0)
		move.b	#4,4(a0)
		move.w	#$200,8(a0)
		move.w	$14(a0),$30(a0)
		move.b	($FFFFF64D).w,$36(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_2B7AE
		move.l	#loc_2B8EE,(a1)
		move.b	#4,4(a1)
		move.b	#-$64,$28(a1)
		move.w	a0,$3C(a1)
		move.w	a1,$3C(a0)

loc_2B7AE:
		move.l	#loc_2B7B4,(a0)

loc_2B7B4:
		tst.b	$34(a0)
		bmi.s	loc_2B7E8
		move.b	$36(a0),d0
		cmp.b	($FFFFF64D).w,d0
		beq.s	loc_2B7D2
		move.b	($FFFFF64D).w,$36(a0)
		move.b	#-$7F,$34(a0)
		bra.s	loc_2B7E8
; ---------------------------------------------------------------------------

loc_2B7D2:
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		bne.s	loc_2B7E8
		tst.b	$32(a0)
		beq.s	loc_2B81A
		subq.b	#4,$32(a0)
		bra.s	loc_2B81A
; ---------------------------------------------------------------------------

loc_2B7E8:

		tst.b	$34(a0)
		bne.s	loc_2B806

loc_2B7EE:
		move.b	$23(a0),$35(a0)
		move.b	#0,$23(a0)
		move.b	#0,$24(a0)
		move.b	#1,$34(a0)

loc_2B806:
		cmpi.b	#$40,$32(a0)
		beq.s	loc_2B814
		addq.b	#4,$32(a0)
		bra.s	loc_2B81A
; ---------------------------------------------------------------------------

loc_2B814:
		andi.b	#$7F,$34(a0)

loc_2B81A:

		move.b	$32(a0),d0

loc_2B81E:
		jsr	(GetSineCosine).l
		asr.w	#5,d0
		add.w	$30(a0),d0
		move.w	d0,$14(a0)
		tst.b	$34(a0)
		beq.s	loc_2B864
		subq.b	#1,$24(a0)
		bpl.s	loc_2B896
		move.b	#3,$24(a0)
		subq.b	#1,$22(a0)
		andi.b	#$F,$22(a0)
		addq.b	#1,$23(a0)
		cmpi.b	#$10,$23(a0)
		bcs.s	loc_2B896
		move.b	$35(a0),$23(a0)
		move.b	#0,$34(a0)

loc_2B862:
		bra.s	loc_2B896
; ---------------------------------------------------------------------------

loc_2B864:
		subq.b	#1,$24(a0)
		bpl.s	loc_2B896
		move.b	#$17,$24(a0)
		moveq	#0,d0
		move.b	$23(a0),d0
		addq.b	#1,$23(a0)
		move.b	byte_2B88E(pc,d0.w),$22(a0)
		move.b	byte_2B88F(pc,d0.w),d0
		bpl.s	loc_2B88C
		move.b	#0,$23(a0)

loc_2B88C:
		bra.s	loc_2B896
; ---------------------------------------------------------------------------
byte_2B88E:	dc.b 7
byte_2B88F:	dc.b 8
		dc.b 9
		dc.b $A
		dc.b 9
		dc.b 8
		dc.b $FF
		dc.b 0
; ---------------------------------------------------------------------------

loc_2B896:

		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_2B8CE
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2B8CE:
		move.w	$3C(a0),d0
		beq.s	loc_2B8DC
		movea.w	d0,a1
		jsr	(Delete_Referenced_Sprite).l

loc_2B8DC:
		move.w	$48(a0),d0
		beq.s	loc_2B8E8
		movea.w	d0,a2
		bclr	#7,(a2)

loc_2B8E8:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2B8EE:
		movea.w	$3C(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		moveq	#0,d0
		move.b	$22(a1),d0
		move.b	byte_2B918(pc,d0.w),d0
		beq.s	locret_2B916
		ext.w	d0
		add.w	d0,$14(a0)
		jmp	(Add_SpriteToCollisionResponseList).l
; ---------------------------------------------------------------------------

locret_2B916:
		rts
; ---------------------------------------------------------------------------
byte_2B918:	dc.b $F4
		dc.b $F4
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b $C
		dc.b $C
		dc.b $C
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b $F4
; ---------------------------------------------------------------------------

Obj_StillSprite:

		move.l	#Map_StillSprites,$C(a0)
		ori.b	#4,4(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.b	d0,$22(a0)
		add.w	d0,d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		lea	word_2B968(pc,d0.w),a1
		move.w	(a1)+,$A(a0)
		move.w	(a1)+,8(a0)
		move.b	(a1)+,7(a0)
		move.b	(a1)+,6(a0)
		move.l	#loc_2B962,(a0)

loc_2B962:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
word_2B968:	dc.w $42E9		; 0 AIZ2 Bridge Post
		dc.w $300
		dc.b $C
		dc.b $C
		dc.w $42E9			; 1 AIZ2 Large Rope Twist Tie
		dc.w $300
		dc.b $10
		dc.b 8
		dc.w $42E9			; 2 AIZ2 Rope Twist tie
		dc.w $300
		dc.b 8
		dc.b 4
		dc.w $4001			; 3 AIZ2 Tie Top Sprite
		dc.w $300
		dc.b 8
		dc.b 8
		dc.w $6001			; 4 AIZ2 Waterfall sprite
		dc.w $300
		dc.b 8
		dc.b $20
		dc.w $C2E9			; 5 AIZ2 Bridge Post (Different Palette)
		dc.w $300
		dc.b $C
		dc.b $C
		dc.w $C001			; 6 128x128 HCZ Waterfall
		dc.w 0
		dc.b $40
		dc.b $40
		dc.w $C001			; 7 128x64 HCZ Waterfall
		dc.w 0
		dc.b $40
		dc.b $20
		dc.w $4001			; 8 128x32 HCZ Waterfall
		dc.w $300
		dc.b $40
		dc.b $10
		dc.w $C001			; 9 Stagger Down HCZ Waterfall
		dc.w 0
		dc.b $40
		dc.b $40
		dc.w $C001			; A Stagger Up HCZ Waterfall
		dc.w 0
		dc.b $40
		dc.b $60
		dc.w $4451			; B MGZ Signpost Left
		dc.w $300
		dc.b $10
		dc.b $18
		dc.w $4451			; C MGZ Signpost Right
		dc.w $300
		dc.b $10
		dc.b $18
		dc.w $4451			; D MGZ Signpost Up
		dc.w $300
		dc.b $10
		dc.b $18
		dc.w $4451			; E MGZ Signpost Down
		dc.w $300
		dc.b $10
		dc.b $18
		dc.w $C368			; F HCZ2 Tube Bend 1
		dc.w 0
		dc.b 8
		dc.b $30
		dc.w $C379			; 10 HCZ2 Tube Bend 2
		dc.w 0
		dc.b $30
		dc.b $18
		dc.w $C399			; 11 HCZ2 Tube Bend 3
		dc.w 0
		dc.b $C
		dc.b $10
		dc.w $C3A4			; 12 HCZ2 Tube Crossover
		dc.w 0
		dc.b $20
		dc.b $34
		dc.w $4038			; 13 HCZ2 Bridge Post
		dc.w $300
		dc.b 4
		dc.b $10
		dc.w $440D			; 14 LBZ Cup Elevator Pole Top
		dc.w $300
		dc.b 8
		dc.b 8
		dc.w $2433			; 15 LBZ Steel Girder Low Priority
		dc.w $300
		dc.b $10
		dc.b $40
		dc.w $2433			; 16 LBZ Large Steel Girder
		dc.w $300
		dc.b $10
		dc.b $80
		dc.w $2433			; 17 LBZ Steel Girder High Priority
		dc.w $80
		dc.b $10
		dc.b $40
		dc.w $C357			; 18 MHZ Cliff Edge
		dc.w $80
		dc.b 4
		dc.b $10
		dc.w $C357			; 19 MHZ Cliff Edge 2
		dc.w $80
		dc.b 4
		dc.b $10
		dc.w $C357			; 1A MHZ Grass
		dc.w $80
		dc.b $10
		dc.b 4
		dc.w $E40E			; 1B MHZ Wood Column Bottom
		dc.w $80
		dc.b $10
		dc.b 8
		dc.w $E40E			; 1C MHZ Wood Column Top
		dc.w $80
		dc.b $10
		dc.b 8
		dc.w $441E			; 1D MHZ Parachute Vines
		dc.w $200
		dc.b $10
		dc.b 8
		dc.w $347			; 1E Diagonal Spring Pedestal
		dc.w $280
		dc.b 8
		dc.b 8
		dc.w $C3A1			; 1F LRZ Horizontal Gear Rail Small (Unused)
		dc.w $180
		dc.b $10
		dc.b 4
		dc.w $C3A1			; 20 LRZ Horizontal Gear Rail Medium (Unused)
		dc.w $180
		dc.b $20
		dc.b 4
		dc.w $C3A1			; 21 LRZ Horizontal Gear Rail Large (Unused)
		dc.w $180
		dc.b $30
		dc.b 4
		dc.w $C0D3			; 22 LRZ Foreground Rock Ceiling
		dc.w $80
		dc.b $10
		dc.b $10
		dc.w $A3A1			; 23 LRZ Gear Rail Top
		dc.w $180
		dc.b 4
		dc.b $10
		dc.w $A3A1			; 24 LRZ Gear Rail Small
		dc.w $180
		dc.b 4
		dc.b $20
		dc.w $A3A1			; 25 LRZ Gear Rail Large
		dc.w $180
		dc.b 4
		dc.b $40
		dc.w $A3A1			; 26 LRZ Gear Rail Bottom
		dc.w $180
		dc.b 4
		dc.b $10
		dc.w $4379			; 27 FBZ Single Metal Hanger
		dc.w $80
		dc.b 8
		dc.b $14
		dc.w $4379			; 28 FBZ Two Metal Hangers
		dc.w $80
		dc.b $18
		dc.b $14
		dc.w $4379			; 29 FBZ Three Metal Hangers
		dc.w $80
		dc.b $28
		dc.b $14
		dc.w $4379			; 2A FBZ Four Metal Hangers
		dc.w $80
		dc.b $38
		dc.b $14
		dc.w $2443			; 2B Unknown?
		dc.w $300
		dc.b 4
		dc.b $10
		dc.w $2339			; 2C FBZ2 Spider Rail
		dc.w 0
		dc.b $40
		dc.b 4
		dc.w $2339			; 2D FBZ2 Spider Rail Low Priority
		dc.w $280
		dc.b $40
		dc.b 4
		dc.w $C001			; 2E SOZ Indoor Sloped Edge
		dc.w $100
		dc.b $10
		dc.b 8
		dc.w $3AF			; 2F SOZ2 Sand Cork Holder
		dc.w 0
		dc.b $10
		dc.b 4
		dc.w $23FF			; 30 DEZ Horizontal Beam Platform Shooter
		dc.w $280
		dc.b 8
		dc.b $C
		dc.w $23FF			; 31 DEZ Vertical Beam Platform Shooter
		dc.w $280
		dc.b $C
		dc.b 8
		dc.w $2385			; 32 DEZ Light Tunnel Post
		dc.w $80
		dc.b $10
		dc.b $24
Map_StillSprites:include "Levels\Misc\Map - Still Sprites.asm"

; ---------------------------------------------------------------------------

Obj_AnimatedStillSprite:

		move.l	#Map_AnimatedStillSprites,$C(a0)
		ori.b	#4,4(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.b	d0,$20(a0)
		add.w	d0,d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		lea	word_2BF6C(pc,d0.w),a1
		move.w	(a1)+,$A(a0)
		move.w	(a1)+,8(a0)
		move.b	(a1)+,7(a0)
		move.b	(a1)+,6(a0)
		move.l	#loc_2BF5A,(a0)

loc_2BF5A:
		lea	(Ani_AnimatedStillSprites).l,a1
		jsr	(Animate_Sprite).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
word_2BF6C:	dc.w $62E9
		dc.w $300
		dc.b 8
		dc.b $C
		dc.w $62E9
		dc.w $300
		dc.b 8
		dc.b $C
		dc.w $C0D3
		dc.w $200
		dc.b $10
		dc.b 4
		dc.w $240D
		dc.w $300
		dc.b $10
		dc.b 4
		dc.w $440F
		dc.w $300
		dc.b 4
		dc.b 4
		dc.w $440F
		dc.w $300
		dc.b $14
		dc.b 4
		dc.w $440F
		dc.w $300
		dc.b $34
		dc.b 4
		dc.w $440F
		dc.w $300
		dc.b $54
		dc.b 4
Ani_AnimatedStillSprites:	include "Levels\Misc\Anim - Animated Still Sprites.asm"

Map_AnimatedStillSprites:include "Levels\Misc\Map - Animated Still Sprites.asm"

; ---------------------------------------------------------------------------

Obj_AIZForegroundPlant:

		move.l	#Map_AIZForegroundPlant,$C(a0)
		ori.b	#4,4(a0)
		move.w	$10(a0),$30(a0)
		move.w	$14(a0),$32(a0)
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		move.b	d0,$22(a0)
		add.w	d0,d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		lea	word_2C242(pc,d0.w),a1
		move.w	(a1)+,$A(a0)
		move.w	(a1)+,8(a0)
		move.b	(a1)+,7(a0)
		move.b	(a1)+,6(a0)
		move.b	$2C(a0),d0
		lsr.w	#2,d0
		andi.w	#$3C,d0
		move.l	off_2C24E(pc,d0.w),(a0)
		rts
; ---------------------------------------------------------------------------
word_2C242:	dc.w $C333
		dc.w 0
		dc.b $20
		dc.b $30
		dc.w $C333
		dc.w 0
		dc.b $20
		dc.b $3C
off_2C24E:	dc.l loc_2C26A
		dc.l loc_2C270
		dc.l loc_2C2A6
		dc.l loc_2C2DC
		dc.l loc_2C312
		dc.l loc_2C348
		dc.l loc_2C37A
; ---------------------------------------------------------------------------

loc_2C26A:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_2C270:
		move.w	$30(a0),d1
		move.w	d1,d2
		subi.w	#$A0,d1
		sub.w	($FFFFEE78).w,d1
		asr.w	#4,d1
		add.w	d2,d1
		move.w	d1,$10(a0)
		move.w	$32(a0),d1
		move.w	d1,d2
		subi.w	#$70,d1
		sub.w	($FFFFEE7C).w,d1
		asr.w	#4,d1
		add.w	d2,d1
		move.w	d1,$14(a0)
		move.w	$30(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_2C2A6:
		move.w	$30(a0),d1
		move.w	d1,d2
		subi.w	#$A0,d1
		sub.w	($FFFFEE78).w,d1
		asr.w	#3,d1
		add.w	d2,d1
		move.w	d1,$10(a0)
		move.w	$32(a0),d1
		move.w	d1,d2
		subi.w	#$70,d1
		sub.w	($FFFFEE7C).w,d1
		asr.w	#3,d1
		add.w	d2,d1
		move.w	d1,$14(a0)
		move.w	$30(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_2C2DC:
		move.w	$30(a0),d1
		move.w	d1,d2
		subi.w	#$A0,d1
		sub.w	($FFFFEE78).w,d1
		asr.w	#2,d1
		add.w	d2,d1
		move.w	d1,$10(a0)
		move.w	$32(a0),d1
		move.w	d1,d2
		subi.w	#$70,d1
		sub.w	($FFFFEE7C).w,d1
		asr.w	#2,d1
		add.w	d2,d1
		move.w	d1,$14(a0)
		move.w	$30(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_2C312:
		move.w	$30(a0),d1
		move.w	d1,d2
		subi.w	#$A0,d1
		sub.w	($FFFFEE78).w,d1
		asr.w	#1,d1
		add.w	d2,d1
		move.w	d1,$10(a0)
		move.w	$32(a0),d1
		move.w	d1,d2
		subi.w	#$70,d1
		sub.w	($FFFFEE7C).w,d1
		asr.w	#1,d1
		add.w	d2,d1
		move.w	d1,$14(a0)
		move.w	$30(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_2C348:
		move.w	$30(a0),d1
		move.w	d1,d2
		subi.w	#$A0,d1
		sub.w	($FFFFEE78).w,d1
		add.w	d2,d1
		move.w	d1,$10(a0)
		move.w	$32(a0),d1
		move.w	d1,d2
		subi.w	#$70,d1
		sub.w	($FFFFEE7C).w,d1
		add.w	d2,d1
		move.w	d1,$14(a0)
		move.w	$30(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_2C37A:
		move.w	$30(a0),d1
		move.w	d1,d2
		subi.w	#$A0,d1
		sub.w	($FFFFEE78).w,d1
		add.w	d1,d1
		add.w	d2,d1
		move.w	d1,$10(a0)
		move.w	$32(a0),d1
		move.w	d1,d2
		subi.w	#$70,d1
		sub.w	($FFFFEE7C).w,d1
		add.w	d2,d1
		move.w	d1,$14(a0)
		move.w	$30(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

Obj_31_1:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,$32(a0)
		neg.w	d0
		move.w	d0,$30(a0)
		move.b	#-$80,7(a0)
		move.l	#loc_2C3CA,(a0)

loc_2C3CA:
		lea	($FFFFB000).w,a1
		lea	($FFFFF7B0).w,a2
		moveq	#3,d6
		bsr.s	sub_2C3E8
		lea	($FFFFB04A).w,a1
		lea	($FFFFF7B1).w,a2
		addq.b	#1,d6
		bsr.s	sub_2C3E8
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_2C3E8:

		btst	d6,$2A(a0)
		bne.w	loc_2C46E
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		cmp.w	$30(a0),d0
		blt.s	locret_2C46C
		cmp.w	$32(a0),d0
		bge.s	locret_2C46C

loc_2C404:
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$53,d0
		cmpi.w	#$A6,d0
		bcc.s	locret_2C46C
		cmpi.w	#$53,d0
		bcc.s	loc_2C424
		tst.w	$1A(a1)
		bmi.s	locret_2C46C
		bra.s	loc_2C42C
; ---------------------------------------------------------------------------

loc_2C424:
		cmpi.w	#$38,$1A(a1)
		bgt.s	locret_2C46C

loc_2C42C:
		cmpi.b	#6,5(a1)
		bcc.s	locret_2C46C
		tst.w	($FFFFFE08).w
		bne.s	locret_2C46C
		cmpi.w	#8,d0
		bcc.s	loc_2C444
		move.b	#-$7F,(a2)

loc_2C444:
		cmpi.w	#$9E,d0
		bcs.s	loc_2C44E
		move.b	#1,(a2)

loc_2C44E:
		jsr	(RideObject_SetRide).l
		move.b	#-$80,$2D(a1)
		move.w	#1,$20(a1)
		tst.w	$1C(a1)
		bne.s	locret_2C46C
		move.w	#1,$1C(a1)

locret_2C46C:

		rts
; ---------------------------------------------------------------------------

loc_2C46E:
		btst	#1,$2A(a1)
		bne.s	loc_2C4A8
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		cmp.w	$30(a0),d0
		blt.s	loc_2C48A
		cmp.w	$32(a0),d0
		blt.s	loc_2C4BA

loc_2C48A:

		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		move.b	#0,$30(a1)
		move.b	#4,$31(a1)
		bset	#1,$2A(a1)
		rts
; ---------------------------------------------------------------------------

loc_2C4A8:
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		bmi.s	loc_2C48A
		move.w	#$400,$1A(a1)
		bra.s	loc_2C48A
; ---------------------------------------------------------------------------

loc_2C4BA:
		btst	#3,$2A(a1)
		beq.s	locret_2C46C
		move.b	(a2),d0
		jsr	(GetSineCosine).l
		moveq	#0,d2
		move.b	$1E(a1),d2
		lsl.w	#8,d2
		addi.w	#$4000,d2
		muls.w	d2,d1
		swap	d1
		add.w	$14(a0),d1
		move.w	d1,$14(a1)
		move.b	(a2),d0
		addi.b	#-$80,d0
		move.b	d0,$27(a1)
		addq.b	#2,(a2)
		move.b	#-$80,$2D(a1)
		tst.w	$1C(a1)
		bne.s	loc_2C506
		move.w	#1,$1C(a1)
		move.b	#-$7F,$2D(a1)

loc_2C506:
		bset	#7,$A(a1)
		tst.b	d0
		bpl.s	locret_2C516
		bclr	#7,$A(a1)

locret_2C516:
		rts
; End of function sub_2C3E8

; ---------------------------------------------------------------------------

Obj_Button:

		tst.w	($FFFFFFE8).w
		bne.w	loc_2C696
		move.l	#Map_Button,$C(a0)
		move.w	#$456,$A(a0)
		cmpi.b	#1,($FFFFFE10).w
		bne.s	loc_2C544
		move.l	#Map_Button2,$C(a0)
		move.w	#$2426,$A(a0)

loc_2C544:
		cmpi.b	#3,($FFFFFE10).w
		bne.s	loc_2C55A
		move.l	#Map_CNZButton,$C(a0)
		move.w	#$441A,$A(a0)

loc_2C55A:
		cmpi.b	#4,($FFFFFE10).w
		bne.s	loc_2C568
		move.w	#$500,$A(a0)

loc_2C568:
		cmpi.b	#9,($FFFFFE10).w
		bne.s	loc_2C58A
		move.l	#Map_LRZButton,$C(a0)
		move.w	#$63A1,$A(a0)
		tst.b	($FFFFFE11).w
		beq.s	loc_2C58A
		move.w	#$2429,$A(a0)

loc_2C58A:

		move.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#8,6(a0)
		move.w	#$200,8(a0)
		addq.w	#4,$14(a0)
		btst	#5,$2C(a0)
		beq.s	loc_2C5B8
		move.l	#loc_2C62C,(a0)
		bra.w	loc_2C62C
; ---------------------------------------------------------------------------

loc_2C5B8:
		move.l	#loc_2C5BE,(a0)

loc_2C5BE:
		tst.b	4(a0)
		bpl.s	loc_2C626
		move.w	#$1B,d1
		move.w	#4,d2
		move.w	#5,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		move.b	#0,$22(a0)
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3

loc_2C5EC:
		lea	(a3,d0.w),a3
		moveq	#0,d3
		btst	#6,$2C(a0)
		beq.s	loc_2C5FC
		moveq	#7,d3

loc_2C5FC:
		move.b	$2A(a0),d0
		andi.b	#$18,d0

loc_2C604:
		bne.s	loc_2C612
		btst	#4,$2C(a0)
		bne.s	loc_2C626
		bclr	d3,(a3)
		bra.s	loc_2C626
; ---------------------------------------------------------------------------

loc_2C612:
		tst.b	(a3)
		bne.s	loc_2C61E
		moveq	#$5B,d0
		jsr	(Play_Sound_2).l

loc_2C61E:
		bset	d3,(a3)
		move.b	#1,$22(a0)

loc_2C626:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_2C62C:

		tst.b	4(a0)
		bpl.s	loc_2C690
		move.w	#$10,d1
		move.w	#6,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		move.b	#0,$22(a0)
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		lea	(a3,d0.w),a3
		moveq	#0,d3
		btst	#6,$2C(a0)
		beq.s	loc_2C666
		moveq	#7,d3

loc_2C666:
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		bne.s	loc_2C67C
		btst	#4,$2C(a0)
		bne.s	loc_2C690
		bclr	d3,(a3)
		bra.s	loc_2C690
; ---------------------------------------------------------------------------

loc_2C67C:
		tst.b	(a3)
		bne.s	loc_2C688
		moveq	#$5B,d0
		jsr	(Play_Sound_2).l

loc_2C688:
		bset	d3,(a3)
		move.b	#1,$22(a0)

loc_2C690:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_2C696:
		move.l	#Map_2PButton,$C(a0)
		move.w	#$3AD,$A(a0)
		move.b	#4,4(a0)
		move.b	#$C,7(a0)
		move.w	#$200,8(a0)
		addq.w	#4,$14(a0)
		move.l	#loc_2C6C0,(a0)

loc_2C6C0:
		move.w	#$13,d1
		move.w	#4,d2
		move.w	#5,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		move.b	#0,$22(a0)
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		lea	(a3,d0.w),a3
		moveq	#0,d3
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		bne.s	loc_2C704
		btst	#4,$2C(a0)
		bne.s	loc_2C718
		bclr	d3,(a3)
		bra.s	loc_2C718
; ---------------------------------------------------------------------------

loc_2C704:
		tst.b	(a3)
		bne.s	loc_2C710
		moveq	#$5B,d0
		jsr	(Play_Sound_2).l

loc_2C710:
		bset	d3,(a3)
		move.b	#1,$22(a0)

loc_2C718:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Map_Button:	include "General\Sprites\Buttons\Map - Button.asm"

Map_LRZButton:	include "Levels\LRZ\Misc Object Data\Map - Button.asm"

; ---------------------------------------------------------------------------

Obj_Animal:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_2C786(pc,d0.w),d1
		jmp	off_2C786(pc,d1.w)
; ---------------------------------------------------------------------------
off_2C786:	dc.w loc_2C8B8-off_2C786

		dc.w loc_2C9E0-off_2C786
		dc.w loc_2CA3C-off_2C786
		dc.w loc_2CA7C-off_2C786
		dc.w loc_2CA3C-off_2C786
		dc.w loc_2CA3C-off_2C786
		dc.w loc_2CA3C-off_2C786
		dc.w loc_2CA7C-off_2C786
		dc.w loc_2CA3C-off_2C786
		dc.w loc_2CA7C-off_2C786
		dc.w loc_2CA3C-off_2C786
		dc.w loc_2CA3C-off_2C786
		dc.w loc_2CA3C-off_2C786
		dc.w loc_2CA3C-off_2C786
		dc.w loc_2CB02-off_2C786
		dc.w loc_2CB24-off_2C786
		dc.w loc_2CB24-off_2C786
		dc.w loc_2CB44-off_2C786
		dc.w loc_2CB80-off_2C786
		dc.w loc_2CBDC-off_2C786
		dc.w loc_2CBFC-off_2C786
		dc.w loc_2CBDC-off_2C786
		dc.w loc_2CBFC-off_2C786
		dc.w loc_2CBDC-off_2C786
		dc.w loc_2CC3C-off_2C786
		dc.w loc_2CB9C-off_2C786
byte_2C7BA:	dc.b 5

		dc.b 1
		dc.b 0
		dc.b 3
		dc.b 5
		dc.b 1
		dc.b 0
		dc.b 5
		dc.b 6
		dc.b 5
		dc.b 2
		dc.b 3
		dc.b 5
		dc.b 1
		dc.b 6
		dc.b 1
		dc.b 0
		dc.b 1
		dc.b 5
		dc.b 1
		dc.b 0
		dc.b 5
		dc.b 6
		dc.b 1
		dc.b 6
		dc.b 5
		dc.b 5
		dc.b 1
		dc.b 5
		dc.b 1
		dc.b 5
		dc.b 1
		dc.b 5
		dc.b 1
		dc.b 5
		dc.b 1
		dc.b 5
		dc.b 1
		dc.b 5
		dc.b 1
		dc.b 5
		dc.b 1
		dc.b 5
		dc.b 1
		dc.b 5
		dc.b 1
		dc.b 5
		dc.b 1
word_2C7EA:	dc.w $FE00

		dc.w $FC00
		dc.l Map_Animals5
		dc.w $FE00
		dc.w $FD00
		dc.l Map_Animals1
		dc.w $FE80
		dc.w $FD00
		dc.l Map_Animals5
		dc.w $FEC0
		dc.w $FE80
		dc.l Map_Animals4
		dc.w $FE40
		dc.w $FD00
		dc.l Map_Animals3
		dc.w $FD00
		dc.w $FC00
		dc.l Map_Animals1
		dc.w $FD80
		dc.w $FC80
		dc.l Map_Animals2
		dc.w $FD80
		dc.w $FD00
		dc.l Map_Animals1
		dc.w $FE00
		dc.w $FC80
		dc.l Map_Animals2
		dc.w $FD40
		dc.w $FD00
		dc.l Map_Animals2
		dc.w $FEC0
		dc.w $FE00
		dc.l Map_Animals2
		dc.w $FE00
		dc.w $FD00
		dc.l Map_Animals2
word_2C84A:	dc.w $FBC0, $FC00
		dc.w $FBC0, $FC00
		dc.w $FBC0, $FC00
		dc.w $FD00, $FC00
		dc.w $FD00, $FC00
		dc.w $FE80, $FD00
		dc.w $FE80, $FD00
		dc.w $FEC0, $FE80
		dc.w $FE40, $FD00
		dc.w $FE00, $FD00
		dc.w $FD80, $FC80
off_2C876:	dc.l Map_Animals1
		dc.l Map_Animals1
		dc.l Map_Animals1
		dc.l Map_Animals5
		dc.l Map_Animals5
		dc.l Map_Animals5
		dc.l Map_Animals5
		dc.l Map_Animals4
		dc.l Map_Animals3
		dc.l Map_Animals1
		dc.l Map_Animals2
word_2C8A2:	dc.w $5A5
		dc.w $5A5
		dc.w $5A5
		dc.w $553
		dc.w $553
		dc.w $573
		dc.w $573
		dc.w $585
		dc.w $593
		dc.w $565
		dc.w $5B3
; ---------------------------------------------------------------------------

loc_2C8B8:
		tst.b	$2C(a0)
		beq.w	loc_2C924
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		move.b	d0,5(a0)
		subi.w	#$14,d0
		move.w	word_2C8A2(pc,d0.w),$A(a0)
		add.w	d0,d0
		move.l	off_2C876(pc,d0.w),$C(a0)
		lea	word_2C84A(pc),a1
		move.w	(a1,d0.w),$32(a0)
		move.w	(a1,d0.w),$18(a0)
		move.w	2(a1,d0.w),$34(a0)
		move.w	2(a1,d0.w),$1A(a0)
		move.b	#$C,$1E(a0)
		move.b	#4,4(a0)
		bset	#0,4(a0)
		move.w	#$300,8(a0)
		move.b	#8,7(a0)
		move.b	#7,$24(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2C924:
		addq.b	#2,5(a0)
		jsr	(Random_Number).l
		move.w	#$580,$A(a0)
		andi.w	#1,d0
		beq.s	loc_2C940
		move.w	#$592,$A(a0)

loc_2C940:
		moveq	#0,d1
		move.b	($FFFFFE10).w,d1
		add.w	d1,d1
		add.w	d0,d1
		lea	byte_2C7BA(pc),a1
		move.b	(a1,d1.w),d0
		move.b	d0,$30(a0)
		lsl.w	#3,d0
		lea	word_2C7EA(pc),a1
		adda.w	d0,a1
		move.w	(a1)+,$32(a0)
		move.w	(a1)+,$34(a0)
		move.l	(a1)+,$C(a0)
		move.b	#$C,$1E(a0)
		move.b	#4,4(a0)
		bset	#0,4(a0)
		move.w	#$300,8(a0)
		move.b	#8,7(a0)
		move.b	#7,$24(a0)
		move.b	#2,$22(a0)
		move.w	#-$400,$1A(a0)
		tst.b	$38(a0)
		bne.s	loc_2C9CA
		jsr	(Create_New_Sprite).l
		bne.s	loc_2C9C4
		move.l	#Obj_EnemyScore,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	$3E(a0),d0
		lsr.w	#1,d0
		move.b	d0,$22(a1)

loc_2C9C4:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2C9CA:
		move.b	#$1C,5(a0)
		clr.w	$18(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2C9DA:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2C9E0:
		tst.b	4(a0)
		bpl.s	loc_2C9DA
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.s	loc_2CA36
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_2CA36
		add.w	d1,$14(a0)
		move.w	$32(a0),$18(a0)
		move.w	$34(a0),$1A(a0)
		move.b	#1,$22(a0)
		move.b	$30(a0),d0
		add.b	d0,d0
		addq.b	#4,d0
		move.b	d0,5(a0)
		tst.b	$38(a0)
		beq.s	loc_2CA36
		btst	#4,($FFFFFE0F).w
		beq.s	loc_2CA36
		neg.w	$18(a0)
		bchg	#0,4(a0)

loc_2CA36:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2CA3C:

		jsr	(MoveSprite).l
		move.b	#1,$22(a0)
		tst.w	$1A(a0)
		bmi.s	loc_2CA68
		move.b	#0,$22(a0)
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_2CA68
		add.w	d1,$14(a0)
		move.w	$34(a0),$1A(a0)

loc_2CA68:

		tst.b	$2C(a0)
		bne.s	loc_2CAE4
		tst.b	4(a0)
		bpl.w	loc_2C9DA
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2CA7C:

		jsr	(MoveSprite2).l
		addi.w	#$18,$1A(a0)
		tst.w	$1A(a0)
		bmi.s	loc_2CABA
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_2CABA
		add.w	d1,$14(a0)
		move.w	$34(a0),$1A(a0)
		tst.b	$2C(a0)
		beq.s	loc_2CABA
		cmpi.b	#$A,$2C(a0)
		beq.s	loc_2CABA
		neg.w	$18(a0)
		bchg	#0,4(a0)

loc_2CABA:

		subq.b	#1,$24(a0)
		bpl.s	loc_2CAD0
		move.b	#1,$24(a0)
		addq.b	#1,$22(a0)
		andi.b	#1,$22(a0)

loc_2CAD0:
		tst.b	$2C(a0)
		bne.s	loc_2CAE4
		tst.b	4(a0)
		bpl.w	loc_2C9DA
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2CAE4:

		move.w	$10(a0),d0
		sub.w	($FFFFB010).w,d0
		bcs.s	loc_2CAFC
		subi.w	#$180,d0
		bpl.s	loc_2CAFC
		tst.b	4(a0)
		bpl.w	loc_2C9DA

loc_2CAFC:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2CB02:
		tst.b	4(a0)
		bpl.w	loc_2C9DA
		subq.w	#1,$36(a0)
		bne.w	loc_2CB1E
		move.b	#2,5(a0)
		move.w	#$80,8(a0)

loc_2CB1E:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2CB24:
		bsr.w	sub_2CCD2
		bcc.s	loc_2CB40
		move.w	$32(a0),$18(a0)
		move.w	$34(a0),$1A(a0)
		move.b	#$E,5(a0)
		bra.w	loc_2CA7C
; ---------------------------------------------------------------------------

loc_2CB40:
		bra.w	loc_2CAE4
; ---------------------------------------------------------------------------

loc_2CB44:
		bsr.w	sub_2CCD2
		bpl.s	loc_2CB7C
		clr.w	$18(a0)
		clr.w	$32(a0)
		jsr	(MoveSprite2).l
		addi.w	#$18,$1A(a0)
		bsr.w	sub_2CC92
		bsr.w	sub_2CCBA
		subq.b	#1,$24(a0)
		bpl.s	loc_2CB7C
		move.b	#1,$24(a0)
		addq.b	#1,$22(a0)
		andi.b	#1,$22(a0)

loc_2CB7C:

		bra.w	loc_2CAE4
; ---------------------------------------------------------------------------

loc_2CB80:
		bsr.w	sub_2CCD2
		bpl.s	loc_2CBD8
		move.w	$32(a0),$18(a0)
		move.w	$34(a0),$1A(a0)
		move.b	#4,5(a0)
		bra.w	loc_2CA3C
; ---------------------------------------------------------------------------

loc_2CB9C:
		jsr	(MoveSprite).l
		move.b	#1,$22(a0)
		tst.w	$1A(a0)
		bmi.s	loc_2CBD8
		move.b	#0,$22(a0)
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_2CBD8
		not.b	$2D(a0)
		bne.s	loc_2CBCE
		neg.w	$18(a0)
		bchg	#0,4(a0)

loc_2CBCE:
		add.w	d1,$14(a0)
		move.w	$34(a0),$1A(a0)

loc_2CBD8:

		bra.w	loc_2CAE4
; ---------------------------------------------------------------------------

loc_2CBDC:
		bsr.w	sub_2CCD2
		bpl.s	loc_2CBF8
		clr.w	$18(a0)
		clr.w	$32(a0)
		jsr	(MoveSprite).l
		bsr.w	sub_2CC92
		bsr.w	sub_2CCBA

loc_2CBF8:
		bra.w	loc_2CAE4
; ---------------------------------------------------------------------------

loc_2CBFC:
		bsr.w	sub_2CCD2
		bpl.s	loc_2CC38
		jsr	(MoveSprite).l
		move.b	#1,$22(a0)
		tst.w	$1A(a0)
		bmi.s	loc_2CC38
		move.b	#0,$22(a0)
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_2CC38
		neg.w	$18(a0)
		bchg	#0,4(a0)
		add.w	d1,$14(a0)
		move.w	$34(a0),$1A(a0)

loc_2CC38:

		bra.w	loc_2CAE4
; ---------------------------------------------------------------------------

loc_2CC3C:
		bsr.w	sub_2CCD2
		bpl.s	loc_2CC8E
		jsr	(MoveSprite2).l
		addi.w	#$18,$1A(a0)
		tst.w	$1A(a0)
		bmi.s	loc_2CC78
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_2CC78
		not.b	$2D(a0)
		bne.s	loc_2CC6E
		neg.w	$18(a0)
		bchg	#0,4(a0)

loc_2CC6E:
		add.w	d1,$14(a0)
		move.w	$34(a0),$1A(a0)

loc_2CC78:

		subq.b	#1,$24(a0)
		bpl.s	loc_2CC8E
		move.b	#1,$24(a0)

loc_2CC84:
		addq.b	#1,$22(a0)
		andi.b	#1,$22(a0)

loc_2CC8E:

		bra.w	loc_2CAE4

; =============== S U B R O U T I N E =======================================


sub_2CC92:

		move.b	#1,$22(a0)
		tst.w	$1A(a0)
		bmi.s	locret_2CCB8
		move.b	#0,$22(a0)
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	locret_2CCB8
		add.w	d1,$14(a0)
		move.w	$34(a0),$1A(a0)

locret_2CCB8:

		rts
; End of function sub_2CC92


; =============== S U B R O U T I N E =======================================


sub_2CCBA:

		bset	#0,4(a0)
		move.w	$10(a0),d0
		sub.w	($FFFFB010).w,d0
		bcc.s	locret_2CCD0
		bclr	#0,4(a0)

locret_2CCD0:
		rts
; End of function sub_2CCBA


; =============== S U B R O U T I N E =======================================


sub_2CCD2:

		move.w	($FFFFB010).w,d0
		sub.w	$10(a0),d0
		subi.w	#$B8,d0
		rts
; End of function sub_2CCD2

; ---------------------------------------------------------------------------

Obj_EnemyScore:

		move.l	#Map_EnemyScore,$C(a0)
		move.w	#-$7A1C,$A(a0)
		move.b	#4,4(a0)
		move.w	#$80,8(a0)
		move.b	#8,7(a0)
		move.w	#-$300,$1A(a0)
		move.l	#loc_2CD0C,(a0)

loc_2CD0C:
		tst.w	$1A(a0)
		bpl.w	loc_2C9DA
		jsr	(MoveSprite2).l
		addi.w	#$18,$1A(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_Difficulty_2CD26:
		lea	ChildObjDat_2CD36(pc),a2
		jsr	(CreateChild6_Simple).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
ChildObjDat_2CD36:dc.w 3
		dc.l loc_2CD3C
; ---------------------------------------------------------------------------

loc_2CD3C:
		move.l	#loc_2CD6E,(a0)
		move.l	#Map_Animals1,$C(a0)
		move.w	#$22C1,$A(a0)
		lea	word_2CD5E(pc),a1
		bsr.w	sub_2CE76
		jmp	(sub_6001E).l
; ---------------------------------------------------------------------------
word_2CD5E:	dc.w	$C0,   $A0
		dc.w	$A8,   $C8
		dc.w	$D0,   $B8
		dc.w	$D8,   $D0
; ---------------------------------------------------------------------------

loc_2CD6E:
		subq.w	#1,$2E(a0)
		bpl.s	loc_2CD7A
		move.l	#loc_2CD84,(a0)

loc_2CD7A:
		bsr.w	sub_2CEA2
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2CD84:
		bsr.w	sub_2CEA2
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_Difficulty_2CD9A:
		lea	ChildObjDat_2CDAA(pc),a2
		jsr	(CreateChild6_Simple).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
ChildObjDat_2CDAA:dc.w 3
		dc.l loc_2CDB0
; ---------------------------------------------------------------------------

loc_2CDB0:
		move.l	#loc_2CDEA,(a0)
		move.l	#Map_Animals2,$C(a0)
		move.w	#$22CF,$A(a0)
		bset	#0,4(a0)
		lea	word_2CDDA(pc),a1
		bsr.w	sub_2CE76
		move.w	$14(a0),$3A(a0)
		rts
; ---------------------------------------------------------------------------
word_2CDDA:	dc.w $160, $130
		dc.w $180, $120
		dc.w $1A0, $128
		dc.w $178, $138
; ---------------------------------------------------------------------------

loc_2CDEA:

		jsr	(MoveSprite).l
		move.b	#1,$22(a0)
		tst.w	$1A(a0)
		bmi.s	loc_2CE26
		move.b	#0,$22(a0)
		move.w	$14(a0),d0
		cmp.w	$3A(a0),d0
		bcs.s	loc_2CE26
		move.w	$3A(a0),$14(a0)
		jsr	(Random_Number).l
		andi.w	#$1FF,d0
		addi.w	#$100,d0
		neg.w	d0
		move.w	d0,$1A(a0)

loc_2CE26:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_Difficulty_2CE2C:
		lea	ChildObjDat_2CE3C(pc),a2
		jsr	(CreateChild6_Simple).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
ChildObjDat_2CE3C:dc.w 3
		dc.l loc_2CE42
; ---------------------------------------------------------------------------

loc_2CE42:
		move.l	#loc_2CDEA,(a0)
		move.l	#Map_Animals5,$C(a0)
		move.w	#$22E1,$A(a0)
		lea	word_2CE66(pc),a1
		bsr.w	sub_2CE76
		move.w	$14(a0),$3A(a0)
		rts
; ---------------------------------------------------------------------------
word_2CE66:	dc.w $C0, $110
		dc.w $A8, $128
		dc.w $C0, $130
		dc.w $D8, $138

; =============== S U B R O U T I N E =======================================


sub_2CE76:

		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		adda.w	d0,a1
		move.w	(a1)+,$10(a0)
		move.w	(a1)+,$14(a0)
		add.w	d0,d0
		move.w	d0,$2E(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$200,8(a0)
		rts
; End of function sub_2CE76


; =============== S U B R O U T I N E =======================================


sub_2CEA2:

		subq.b	#1,$24(a0)
		bpl.s	locret_2CEB8
		move.b	#2,$24(a0)
		addq.b	#1,$22(a0)
		andi.b	#1,$22(a0)

locret_2CEB8:
		rts
; End of function sub_2CEA2

; ---------------------------------------------------------------------------
Map_Animals1:	include "General\Sprites\Animals\Map - Animals 1.asm"

Map_Animals2:	include "General\Sprites\Animals\Map - Animals 2.asm"

Map_Animals3:	include "General\Sprites\Animals\Map - Animals 3.asm"

Map_Animals4:	include "General\Sprites\Animals\Map - Animals 4.asm"

Map_Animals5:	include "General\Sprites\Animals\Map - Animals 5.asm"

Map_EnemyScore:	include "General\Sprites\Enemy Misc\Map - Enemy Points.asm"

; ---------------------------------------------------------------------------

Obj_StarPost:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_2CFB6(pc,d0.w),d1
		jmp	off_2CFB6(pc,d1.w)
; ---------------------------------------------------------------------------
off_2CFB6:	dc.w loc_2CFC0-off_2CFB6

		dc.w loc_2D012-off_2CFB6
		dc.w loc_2D0F8-off_2CFB6
		dc.w loc_2D10A-off_2CFB6
		dc.w loc_2D47E-off_2CFB6
; ---------------------------------------------------------------------------

loc_2CFC0:
		addq.b	#2,5(a0)
		move.l	#Map_StarPost,$C(a0)
		move.w	#$5EC,$A(a0)
		move.b	#4,4(a0)
		move.b	#8,7(a0)
		move.b	#$28,6(a0)
		move.w	#$280,8(a0)
		movea.w	$48(a0),a2
		btst	#0,(a2)
		bne.s	loc_2D008
		move.b	($FFFFFE2A).w,d1
		andi.b	#$7F,d1
		move.b	$2C(a0),d2
		andi.b	#$7F,d2
		cmp.b	d2,d1
		bcs.s	loc_2D012

loc_2D008:
		bset	#0,(a2)
		move.b	#2,$20(a0)

loc_2D012:

		tst.w	($FFFFFE08).w
		bne.w	loc_2D0F8
		lea	($FFFFB000).w,a3
		move.b	($FFFFFE2A).w,d1
		bsr.s	sub_2D028
		bra.w	loc_2D0F8

; =============== S U B R O U T I N E =======================================


sub_2D028:
		andi.b	#$7F,d1
		move.b	$2C(a0),d2
		andi.b	#$7F,d2
		cmp.b	d2,d1
		bcc.w	loc_2D0EA
		move.w	$10(a3),d0
		sub.w	$10(a0),d0
		addi.w	#8,d0
		cmpi.w	#$10,d0
		bcc.w	locret_2D0E8
		move.w	$14(a3),d0
		sub.w	$14(a0),d0
		addi.w	#$40,d0
		cmpi.w	#$68,d0
		bcc.w	locret_2D0E8
		moveq	#$63,d0
		jsr	(Play_Sound_2).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_2D0D0
		move.l	#Obj_StarPost,(a1)
		move.b	#6,5(a1)
		move.w	$10(a0),$30(a1)
		move.w	$14(a0),$32(a1)
		subi.w	#$14,$32(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.b	#4,4(a1)
		move.b	#8,7(a1)
		move.b	#8,6(a1)
		move.w	#$200,8(a1)
		move.b	#2,$22(a1)
		move.w	#$20,$36(a1)
		move.w	a0,$3E(a1)
		cmpi.w	#20,($FFFFFE20).w
		bcs.s	loc_2D0D0
		bsr.w	sub_2D3C8

loc_2D0D0:

		move.b	#1,$20(a0)
		bsr.w	sub_2D164
		move.b	#4,5(a0)
		movea.w	$48(a0),a2
		bset	#0,(a2)

locret_2D0E8:

		rts
; ---------------------------------------------------------------------------

loc_2D0EA:
		tst.b	$20(a0)
		bne.s	locret_2D0F6
		move.b	#2,$20(a0)

locret_2D0F6:
		rts
; End of function sub_2D028

; ---------------------------------------------------------------------------

loc_2D0F8:


		lea	(Ani_Starpost).l,a1
		jsr	(Animate_Sprite).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_2D10A:
		subq.w	#1,$36(a0)
		bpl.s	loc_2D12E
		movea.w	$3E(a0),a1
		cmpi.l	#Obj_StarPost,(a1)
		bne.s	loc_2D128
		move.b	#2,$20(a1)
		move.b	#0,$22(a1)

loc_2D128:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2D12E:
		move.b	$26(a0),d0
		subi.b	#$10,$26(a0)
		subi.b	#$40,d0
		jsr	(GetSineCosine).l
		muls.w	#$C00,d1
		swap	d1
		add.w	$30(a0),d1
		move.w	d1,$10(a0)
		muls.w	#$C00,d0
		swap	d0
		add.w	$32(a0),d0
		move.w	d0,$14(a0)
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_2D164:
		move.b	$2C(a0),($FFFFFE2A).w
		move.w	$10(a0),($FFFFFE2E).w
		move.w	$14(a0),($FFFFFE30).w
; End of function sub_2D164


; =============== S U B R O U T I N E =======================================


Save_Level_Data:

		move.b	($FFFFFE2A).w,($FFFFFE2B).w
		move.w	($FFFFFE10).w,($FFFFFE2C).w
		move.w	($FFFFEE4E).w,($FFFFFF9A).w
		move.w	($FFFFB00A).w,($FFFFFE38).w
		move.w	($FFFFB046).w,($FFFFFE3A).w
		move.w	($FFFFFE20).w,($FFFFFE32).w
		move.b	($FFFFFE1B).w,($FFFFFE43).w
		move.l	($FFFFFE22).w,($FFFFFE34).w
		move.b	($FFFFEE33).w,($FFFFFE46).w
		move.w	($FFFFEE1A).w,($FFFFFE44).w
		move.w	($FFFFEE78).w,($FFFFFE3C).w
		move.w	($FFFFEE7C).w,($FFFFFE3E).w
		move.w	($FFFFF648).w,($FFFFFE40).w
		move.b	($FFFFF64E).w,($FFFFFE42).w
		rts
; End of function Save_Level_Data


; =============== S U B R O U T I N E =======================================


Save_Level_Data2:
		move.b	($FFFFFE2A).w,($FFFFFE49).w
		move.w	($FFFFFE10).w,($FFFFFE4A).w
		move.w	($FFFFEE4E).w,($FFFFFF9C).w
		move.w	$10(a0),($FFFFFE4C).w
		move.w	$14(a0),($FFFFFE4E).w
		move.w	($FFFFB00A).w,($FFFFFE56).w
		move.w	($FFFFB046).w,($FFFFFE58).w
		move.w	($FFFFFE20).w,($FFFFFE50).w
		move.b	($FFFFFE1B).w,($FFFFFE61).w
		move.l	($FFFFFE22).w,($FFFFFE52).w
		move.b	($FFFFEE33).w,($FFFFFE64).w
		move.w	($FFFFEE1A).w,($FFFFFE62).w
		move.w	($FFFFEE78).w,($FFFFFE5A).w
		move.w	($FFFFEE7C).w,($FFFFFE5C).w
		move.w	($FFFFF648).w,($FFFFFE5E).w
		move.b	($FFFFF64E).w,($FFFFFE60).w
		move.b	($FFFFB02B).w,($FFFFFF96).w
		rts
; End of function Save_Level_Data2


; =============== S U B R O U T I N E =======================================


Load_Starpost_Settings:
		tst.b	($FFFFFE48).w
		bne.w	loc_2D2C2
		move.b	($FFFFFE2B).w,($FFFFFE2A).w
		move.w	($FFFFFE2C).w,($FFFFFE10).w
		move.w	($FFFFFF9A).w,($FFFFEE4E).w
		move.w	($FFFFFE2E).w,($FFFFB010).w
		move.w	($FFFFFE30).w,($FFFFB014).w
		move.w	($FFFFFE32).w,($FFFFFE20).w
		move.b	($FFFFFE43).w,($FFFFFE1B).w
		tst.b	($FFFFFF97).w
		bne.s	loc_2D274
		clr.w	($FFFFFE20).w
		clr.b	($FFFFFE1B).w

loc_2D274:
		move.l	($FFFFFE34).w,($FFFFFE22).w
		move.b	#$3B,($FFFFFE25).w
		subq.b	#1,($FFFFFE24).w
		move.w	($FFFFFE38).w,($FFFFB00A).w
		move.w	($FFFFFE3A).w,($FFFFB046).w
		move.b	($FFFFFE46).w,($FFFFEE33).w
		move.w	($FFFFFE44).w,($FFFFEE1A).w
		move.w	($FFFFFE44).w,($FFFFEE12).w
		move.w	($FFFFFE3C).w,($FFFFEE78).w
		move.w	($FFFFFE3E).w,($FFFFEE7C).w
		tst.b	($FFFFF730).w
		beq.s	locret_2D2C0
		move.w	($FFFFFE40).w,($FFFFF648).w
		move.b	($FFFFFE42).w,($FFFFF64E).w

locret_2D2C0:
		rts
; ---------------------------------------------------------------------------

loc_2D2C2:
		clr.b	($FFFFFE48).w
		move.w	($FFFFFE4A).w,($FFFFFE10).w
		move.w	($FFFFFF9C).w,($FFFFEE4E).w
		move.w	($FFFFFE4C).w,($FFFFB010).w
		move.w	($FFFFFE4E).w,($FFFFB014).w
		move.w	($FFFFFE50).w,($FFFFFE20).w
		move.b	($FFFFFE61).w,($FFFFFE1B).w
		move.l	($FFFFFE52).w,($FFFFFE22).w
		move.b	#$3B,($FFFFFE25).w
		subq.b	#1,($FFFFFE24).w
		move.w	($FFFFFE56).w,($FFFFB00A).w
		move.w	($FFFFFE58).w,($FFFFB046).w
		move.b	($FFFFFE64).w,($FFFFEE33).w
		move.w	($FFFFFE62).w,($FFFFEE1A).w
		move.w	($FFFFFE62).w,($FFFFEE12).w
		move.w	($FFFFFE5A).w,($FFFFEE78).w
		move.w	($FFFFFE5C).w,($FFFFEE7C).w
		tst.b	($FFFFF730).w
		beq.s	locret_2D336
		move.w	($FFFFFE5E).w,($FFFFF648).w
		move.b	($FFFFFE60).w,($FFFFF64E).w

locret_2D336:
		rts
; End of function Load_Starpost_Settings

; ---------------------------------------------------------------------------
Ani_Starpost:	include "General\Sprites\Starpost\Anim - Starpost.asm"

Map_StarPost:	include "General\Sprites\Starpost\Map - Starpost.asm"

Map_StarpostStars:	include "General\Sprites\Starpost\Map - Starpost Stars.asm"

; =============== S U B R O U T I N E =======================================


sub_2D3C8:
		moveq	#3,d1
		moveq	#0,d2

loc_2D3CC:
		jsr	(Create_New_Sprite).l
		bne.s	loc_2D436
		move.l	(a0),(a1)
		move.l	#Map_StarpostStars,$C(a1)
		move.w	#$5EC,$A(a1)
		move.b	#4,4(a1)
		move.b	#8,5(a1)
		move.w	$10(a0),d0
		move.w	d0,$10(a1)
		move.w	d0,$30(a1)
		move.w	$14(a0),d0
		subi.w	#$30,d0
		move.w	d0,$14(a1)
		move.w	d0,$32(a1)
		move.w	8(a0),8(a1)
		move.b	#8,7(a1)
		move.b	#1,$22(a1)
		move.w	#-$400,$18(a1)
		move.w	#0,$1A(a1)
		move.w	d2,$34(a1)
		addi.w	#$40,d2
		dbf	d1,loc_2D3CC

loc_2D436:
		lea	(ArtKosM_StarPostStars3).l,a1
		move.w	($FFFFFE20).w,d0
		subi.w	#20,d0
		divu.w	#15,d0
		ext.l	d0
		moveq	#2,d2
		tst.w	($FFFFFFAE).w
		bne.s	loc_2D454
		moveq	#3,d2

loc_2D454:
		divu.w	d2,d0
		swap	d0
		tst.w	d0
		beq.s	loc_2D474
		lea	(ArtKosM_StarPost_Stars1).l,a1
		cmpi.w	#1,d0
		beq.s	loc_2D474
		tst.w	($FFFFFFAE).w
		bne.s	loc_2D474
		lea	(ArtKosM_StarPostStars2).l,a1

loc_2D474:

		move.w	#-$4280,d2
		jmp	(Queue_Kos_Module).l
; End of function sub_2D3C8

; ---------------------------------------------------------------------------

loc_2D47E:
		move.b	$29(a0),d0
		beq.w	loc_2D50A
		andi.b	#1,d0
		beq.s	loc_2D506
		move.b	#2,($FFFFFE48).w
		move.w	#$1500,d1
		move.w	($FFFFFE32).w,d0
		subi.w	#$14,d0
		divu.w	#$F,d0
		ext.l	d0
		moveq	#2,d2
		tst.w	($FFFFFFAE).w
		bne.s	loc_2D4AE
		moveq	#3,d2

loc_2D4AE:
		divu.w	d2,d0
		swap	d0
		tst.w	d0
		beq.s	loc_2D4CA
		move.w	#$1400,d1
		cmpi.w	#1,d0
		beq.s	loc_2D4CA
		tst.w	($FFFFFFAE).w
		bne.s	loc_2D4CA
		move.w	#$1300,d1

loc_2D4CA:

		move.w	d1,($FFFFFE10).w
		move.w	d1,($FFFFEE4E).w
		move.w	($FFFFFE20).w,($FFFFFE32).w
		move.b	($FFFFFE1B).w,($FFFFFE43).w
		move.b	#0,($FFFFFE2A).w
		move.b	#1,($FFFFFE02).w
		move.b	($FFFFB02B).w,d0
		andi.b	#$71,d0
		move.b	d0,($FFFFFF96).w
		move.b	d0,($FFFFFE47).w
		move.b	#1,($FFFFFF97).w
		jsr	(Clear_SpriteRingMem).l

loc_2D506:
		clr.b	$29(a0)

loc_2D50A:
		addi.w	#$A,$34(a0)
		move.w	$34(a0),d0
		andi.w	#$FF,d0
		jsr	(GetSineCosine).l
		asr.w	#5,d0
		asr.w	#3,d1
		move.w	d1,d3
		move.w	$34(a0),d2
		andi.w	#$3E0,d2
		lsr.w	#5,d2
		moveq	#2,d5
		moveq	#0,d4
		cmpi.w	#$10,d2
		ble.s	loc_2D53A
		neg.w	d1

loc_2D53A:
		andi.w	#$F,d2
		cmpi.w	#8,d2
		ble.s	loc_2D54A
		neg.w	d2
		andi.w	#7,d2

loc_2D54A:

		lsr.w	#1,d2
		beq.s	loc_2D550
		add.w	d1,d4

loc_2D550:
		asl.w	#1,d1
		dbf	d5,loc_2D54A
		asr.w	#4,d4
		add.w	d4,d0
		addq.w	#1,$36(a0)
		move.w	$36(a0),d1
		cmpi.w	#$80,d1
		beq.s	loc_2D574
		bgt.s	loc_2D57A

loc_2D56A:
		muls.w	d1,d0
		muls.w	d1,d3
		asr.w	#7,d0
		asr.w	#7,d3
		bra.s	loc_2D58C
; ---------------------------------------------------------------------------

loc_2D574:
		move.b	#-$28,$28(a0)

loc_2D57A:
		cmpi.w	#$180,d1
		ble.s	loc_2D58C
		neg.w	d1
		addi.w	#$200,d1
		bmi.w	loc_2D5C0
		bra.s	loc_2D56A
; ---------------------------------------------------------------------------

loc_2D58C:

		move.w	$30(a0),d2
		add.w	d3,d2
		move.w	d2,$10(a0)
		move.w	$32(a0),d2
		add.w	d0,d2
		move.w	d2,$14(a0)
		addq.b	#1,$23(a0)
		move.b	$23(a0),d0
		andi.w	#6,d0
		lsr.w	#1,d0
		cmpi.b	#3,d0
		bne.s	loc_2D5B6
		moveq	#1,d0

loc_2D5B6:
		move.b	d0,$22(a0)
		jmp	(loc_1B662).l
; ---------------------------------------------------------------------------

loc_2D5C0:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2D5C6:

		tst.l	($FFFFF680).w
		beq.s	loc_2D5CE
		rts
; ---------------------------------------------------------------------------

loc_2D5CE:
		tst.b	$22(a0)
		bne.s	loc_2D5DE
		st	($FFFFEF56).w
		jsr	(SaveGame_LivesContinues).l

loc_2D5DE:
		move.w	#$50,$10(a0)
		btst	#0,$22(a0)
		beq.s	loc_2D5F2
		move.w	#$1F0,$10(a0)

loc_2D5F2:
		move.w	#$F0,$14(a0)
		move.l	#Map_GameOver,$C(a0)
		move.w	#-$7864,$A(a0)
		move.w	#0,8(a0)
		move.l	#loc_2D612,(a0)

loc_2D612:
		moveq	#$10,d1
		cmpi.w	#$120,$10(a0)
		beq.s	loc_2D62A
		bcs.s	loc_2D620
		neg.w	d1

loc_2D620:
		add.w	d1,$10(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2D62A:
		move.w	#$1E0,$24(a0)
		move.l	#loc_2D638,(a0)
		rts
; ---------------------------------------------------------------------------

loc_2D638:
		move.w	#0,($FFFFE380).w
		btst	#0,$22(a0)
		bne.w	loc_2D68A
		move.b	($FFFFF605).w,d0
		or.b	($FFFFF607).w,d0
		andi.b	#-$10,d0
		bne.s	loc_2D666
		tst.w	$24(a0)
		beq.s	loc_2D666
		subq.w	#1,$24(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2D666:

		tst.b	($FFFFFE1A).w
		bne.s	loc_2D680
		move.b	#$14,($FFFFF600).w
		tst.b	($FFFFFE18).w
		bne.s	loc_2D68A
		move.b	#0,($FFFFF600).w
		bra.s	loc_2D68A
; ---------------------------------------------------------------------------

loc_2D680:
		clr.l	($FFFFFE34).w
		move.w	#1,($FFFFFE02).w

loc_2D68A:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_TitleCard:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	TitleCard_Index(pc,d0.w),d1
		jmp	TitleCard_Index(pc,d1.w)
; ---------------------------------------------------------------------------
TitleCard_Index:	dc.w Obj_TitleCardInit-TitleCard_Index
		dc.w Obj_TitleCardCreate-TitleCard_Index
		dc.w Obj_TitleCardWait-TitleCard_Index
		dc.w Obj_TitleCardWait2-TitleCard_Index
; ---------------------------------------------------------------------------

Obj_TitleCardInit:
		cmpi.w	#$D01,($FFFFFE10).w
		beq.s	loc_2D6C2			; if we're in the ending, don't show title card
		cmpi.b	#$E,($FFFFFE10).w
		bcs.s	loc_2D6C8			; If in any of the 2P stages, don't show title card
		cmpi.b	#$12,($FFFFFE10).w
		bhi.s	loc_2D6C8
		st	$44(a0)

loc_2D6C2:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2D6C8:

		lea	(ArtKosM_TitleCardRedAct).l,a1
		move.w	#$A000,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_TitleCardSKZone).l,a1
		tst.w	($FFFFFFAE).w
		bne.s	loc_2D6EA
		lea	(ArtKosM_TitleCardS3KZone).l,a1

loc_2D6EA:
		move.w	#$A200,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_TitleCardNum2).l,a1
		cmpi.w	#$1600,($FFFFFE10).w
		beq.s	loc_2D716
		cmpi.w	#$1700,($FFFFFE10).w
		beq.s	loc_2D716		; Death Egg Boss and LRZ Boss show act 2
		tst.b	($FFFFEE4F).w
		bne.s	loc_2D716
		lea	(ArtKosM_TitleCardNum1).l,a1

loc_2D716:

		move.w	#$A7A0,d2
		jsr	(Queue_Kos_Module).l
		lea	TitleCard_LevelGfx(pc),a1
		moveq	#9,d0
		cmpi.w	#$1600,($FFFFFE10).w	; If in LRZ's boss, set it to Lava Reef's card
		beq.s	loc_2D746
		moveq	#$D,d0
		cmpi.w	#$1601,($FFFFFE10).w	; If in Hidden Palace, set it to its card
		beq.s	loc_2D746
		moveq	#$B,d0
		cmpi.w	#$1700,($FFFFFE10).w	; If in Death Egg boss, set it to Death Egg's card
		beq.s	loc_2D746
		move.b	($FFFFEE4E).w,d0		; Otherwise, just use current zone

loc_2D746:

		lsl.w	#2,d0
		movea.l	(a1,d0.w),a1
		move.w	#$A9A0,d2
		jsr	(Queue_Kos_Module).l
		move.w	#$5A,$2E(a0)			; Set wait value
		clr.w	$32(a0)
		st	$48(a0)
		addq.b	#2,5(a0)
		rts
; ---------------------------------------------------------------------------

Obj_TitleCardCreate:
		tst.b	($FFFFFF60).w
		bne.w	locret_2D802		; Wait for KosM queue to clear
		jsr	(Create_New_Sprite3).l
		bne.w	locret_2D802
		cmpi.b	#$16,($FFFFFE10).w
		beq.s	loc_2D79A
		cmpi.w	#$1700,($FFFFFE10).w
		beq.s	loc_2D79A
		lea	ObjArray_TtlCardBonus(pc),a2
		moveq	#1,d1
		cmpi.b	#$13,($FFFFFE10).w
		bcc.s	loc_2D7AC

loc_2D79A:

		lea	ObjArray_TtlCard(pc),a2
		moveq	#3,d1
		tst.b	$44(a0)
		beq.s	loc_2D7AC
		lea	ObjArray_TtlCard2(pc),a2
		moveq	#0,d1

loc_2D7AC:

		addq.w	#1,$30(a0)
		move.l	(a2)+,(a1)
		move.w	(a2)+,$46(a1)
		move.w	(a2)+,$10(a1)
		move.w	(a2)+,$14(a1)
		move.b	(a2)+,$22(a1)
		move.b	(a2)+,7(a1)
		move.w	(a2)+,d2
		move.b	d2,$28(a1)
		move.b	#$40,4(a1)
		move.l	#Map_TitleCard,$C(a1)
		move.w	a0,$48(a1)
		jsr	(CreateNewSprite4).l
		dbne	d1,loc_2D7AC
		tst.b	$3E(a0)
		beq.s	loc_2D7FE
		cmpi.b	#6,($FFFFFE10).w
		bne.s	loc_2D7FE
		moveq	#$25,d0			; If title card is mid-level and it's in LBZ, load the LBZ 2 misc art
		jsr	(Load_PLC).l

loc_2D7FE:

		addq.b	#2,5(a0)

locret_2D802:

		rts
; ---------------------------------------------------------------------------

Obj_TitleCardWait:
		tst.w	$34(a0)
		beq.s	loc_2D810
		clr.w	$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_2D810:
		tst.w	$3E(a0)
		beq.s	loc_2D84C
		clr.l	($FFFFFE22).w		; If using in-level title card
		clr.w	($FFFFFE20).w		; Reset HUD rings and timer
		clr.w	($FFFFFEC8).w		; Reset number of collected rings
		clr.b	($FFFFFE1B).w		; Reset extra life ring flag
		clr.l	($FFFFFED2).w
		clr.w	($FFFFFED0).w		; Reset actual rings and timer values
		clr.w	($FFFFFECA).w
		st	($FFFFFE1E).w
		st	($FFFFFE1D).w			; Start updating timer and rings again
		move.b	#$1E,($FFFFB02C).w
		move.b	#$1E,($FFFFB076).w	; Reset air
		jsr	(Obj_PlayLevelMusic).l		; Play music

loc_2D84C:
		clr.w	$48(a0)
		addq.b	#2,5(a0)
		rts
; ---------------------------------------------------------------------------

Obj_TitleCardWait2:
		tst.w	$2E(a0)
		beq.s	loc_2D862
		subq.w	#1,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_2D862:
		tst.w	$30(a0)
		beq.s	loc_2D86E
		addq.w	#1,$32(a0)
		rts
; ---------------------------------------------------------------------------

loc_2D86E:
		tst.b	$44(a0)
		bne.s	loc_2D8DC
		cmpi.w	#$801,($FFFFFE10).w
		bne.s	loc_2D88A
		jsr	(Create_New_Sprite).l
		bne.s	loc_2D88A
		move.l	#Obj_SOZ_Ghosts,(a1)	; If new level is Sandopolis 2, then load the ghosts

loc_2D88A:

		cmpi.b	#$16,($FFFFFE10).w
		beq.s	loc_2D8A2
		cmpi.w	#$1700,($FFFFFE10).w
		beq.s	loc_2D8A2
		cmpi.b	#$13,($FFFFFE10).w
		bcc.s	loc_2D8DC

loc_2D8A2:

		tst.w	$3E(a0)
		beq.s	loc_2D8AE
		st	($FFFFFAAA).w	; If in-level, set end of title card flag. No need to reload PLCs
		bra.s	loc_2D8CA
; ---------------------------------------------------------------------------

loc_2D8AE:
		cmpi.b	#$C,($FFFFFE10).w
		beq.s	loc_2D8DC
		cmpi.w	#$1700,($FFFFFE10).w
		beq.s	loc_2D8DC
		lea	(PLC_SpikesSprings).l,a1		; Reload spikes in all but DEZ boss and Doomsday
		jsr	(Load_PLC_Raw).l

loc_2D8CA:
		cmpi.w	#$1700,($FFFFFE10).w
		beq.s	loc_2D8DC
		jsr	LoadEnemyArt(pc)		; Load animals and enemies in all but DEZ boss
		jsr	(PLCLoad_AnimalsAndExplosion).l

loc_2D8DC:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_TitleCardRedBanner:
		movea.w	$48(a0),a1
		move.w	$32(a1),d0
		beq.s	loc_2D90A
		tst.b	4(a0)
		bmi.s	loc_2D8FC
		subq.w	#1,$30(a1)
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2D8FC:
		cmp.b	$28(a0),d0
		bcs.s	loc_2D920
		subi.w	#$20,$14(a0)
		bra.s	loc_2D920
; ---------------------------------------------------------------------------

loc_2D90A:
		move.w	$14(a0),d0
		cmp.w	$46(a0),d0
		beq.s	loc_2D920
		addi.w	#$10,d0
		move.w	d0,$14(a0)
		st	$34(a1)

loc_2D920:

		move.b	#$70,6(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_TitleCardName:
		move.b	($FFFFEE4E).w,d0
		add.b	d0,$22(a0)
		moveq	#$D,d0
		cmpi.w	#$1600,($FFFFFE10).w
		beq.s	loc_2D952
		moveq	#$11,d0
		cmpi.w	#$1601,($FFFFFE10).w
		beq.s	loc_2D952
		moveq	#$F,d0
		cmpi.w	#$1700,($FFFFFE10).w
		bne.s	loc_2D956

loc_2D952:

		move.b	d0,$22(a0)

loc_2D956:
		move.l	#Obj_TitleCardElement,(a0)

Obj_TitleCardElement:

		movea.w	$48(a0),a1
		move.w	$32(a1),d0
		beq.s	loc_2D984
		tst.b	4(a0)
		bmi.s	loc_2D976
		subq.w	#1,$30(a1)
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2D976:
		cmp.b	$28(a0),d0
		bcs.s	loc_2D99A
		addi.w	#$20,$10(a0)
		bra.s	loc_2D99A
; ---------------------------------------------------------------------------

loc_2D984:
		move.w	$10(a0),d0
		cmp.w	$46(a0),d0
		beq.s	loc_2D99A
		subi.w	#$10,d0
		move.w	d0,$10(a0)
		st	$34(a1)

loc_2D99A:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_TitleCardAct:
		move.l	#Obj_TitleCardElement,(a0)
		cmpi.b	#$A,($FFFFFE10).w
		beq.s	loc_2D9BE
		cmpi.b	#$C,($FFFFFE10).w
		beq.s	loc_2D9BE
		cmpi.w	#$1601,($FFFFFE10).w
		bne.s	Obj_TitleCardElement

loc_2D9BE:

		movea.w	$48(a0),a1		; Sky Sanctuary, Doomsday, and Hidden Palace do not have act numbers
		subq.w	#1,$30(a1)
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_TitleCardElement2:
		clr.b	4(a0)			; I'm not entirely sure what this is used for
		movea.w	$48(a0),a1
		move.w	$32(a1),d0
		beq.s	loc_2D9FA
		cmpi.w	#$20C,$10(a0)
		bcs.s	loc_2D9EC
		subq.w	#1,$30(a1)
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2D9EC:
		cmp.b	$28(a0),d0
		bcs.s	loc_2DA10
		addi.w	#$20,$10(a0)
		bra.s	loc_2DA10
; ---------------------------------------------------------------------------

loc_2D9FA:
		move.w	$10(a0),d0
		cmp.w	$46(a0),d0
		beq.s	loc_2DA10
		subi.w	#$10,d0
		move.w	d0,$10(a0)
		st	$34(a1)

loc_2DA10:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
TitleCard_LevelGfx:	dc.l ArtKosM_AIZTitleCard
		dc.l ArtKosM_HCZTitleCard
		dc.l ArtKosM_MGZTitleCard
		dc.l ArtKosM_CNZTitleCard
		dc.l ArtKosM_FBZTitleCard
		dc.l ArtKosM_ICZTitleCard
		dc.l ArtKosM_LBZTitleCard
		dc.l ArtKosM_MHZTitleCard
		dc.l ArtKosM_SOZTitleCard
		dc.l ArtKosM_LRZTitleCard
		dc.l ArtKosM_SSZTitleCard
		dc.l ArtKosM_DEZTitleCard
		dc.l ArtKosM_DDZTitleCard
		dc.l ArtKosM_HPZTitleCard
		dc.l ArtKosM_ALZTitleCard
		dc.l ArtKosM_BPZTitleCard
		dc.l ArtKosM_DPZTitleCard
		dc.l ArtKosM_CGZTitleCard
		dc.l ArtKosM_EMZTitleCard
		dc.l ArtKosM_BonusTitleCard
		dc.l ArtKosM_BonusTitleCard
		dc.l ArtKosM_BonusTitleCard
ObjArray_TtlCard:	dc.l Obj_TitleCardName
		dc.w $120
		dc.w $260
		dc.w $E0
		dc.b 4
		dc.b $80
		dc.w 3
		dc.l Obj_TitleCardElement
		dc.w $17C
		dc.w $2FC
		dc.w $100
		dc.b 3
		dc.b $24
		dc.w 5
		dc.l Obj_TitleCardAct
		dc.w $184
		dc.w $344
		dc.w $120
		dc.b 2
		dc.b $1C
		dc.w 7
		dc.l Obj_TitleCardRedBanner
		dc.w $C0
		dc.w $E0
		dc.w $10
		dc.b 1
		dc.b 0
		dc.w 1
ObjArray_TtlCard2:	dc.l Obj_TitleCardElement2
		dc.w $15C
		dc.w $21C
		dc.w $BC
		dc.b $12
		dc.b $80
		dc.w 1
ObjArray_TtlCardBonus:	dc.l Obj_TitleCardElement
		dc.w $C8
		dc.w $188
		dc.w $E8
		dc.b $13
		dc.b $80
		dc.w 1
		dc.l Obj_TitleCardElement
		dc.w $128
		dc.w $1E8
		dc.w $E8
		dc.b $14
		dc.b $80
		dc.w 1
; ---------------------------------------------------------------------------

Obj_LevelResults:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	LevelResults_Index(pc,d0.w),d1
		jmp	LevelResults_Index(pc,d1.w)
; ---------------------------------------------------------------------------
LevelResults_Index:	dc.w Obj_LevelResultsInit-LevelResults_Index

		dc.w Obj_LevelResultsCreate-LevelResults_Index
		dc.w Obj_LevelResultsWait-LevelResults_Index
		dc.w Obj_LevelResultsWait2-LevelResults_Index
; ---------------------------------------------------------------------------

Obj_LevelResultsInit:
		moveq	#-$1F,d0
		jsr	(Play_Sound).l				; Fade music
		lea	(ArtKosM_ResultsGeneral).l,a1
		move.w	#$A400,d2
		jsr	(Queue_Kos_Module).l			; General art for
		lea	(ArtKosM_TitleCardNum2).l,a1
		moveq	#-1,d0

loc_2DB06:
		cmpi.w	#$1600,($FFFFFE10).w
		beq.s	loc_2DB1C				; If this is the LRZ2 boss, use the 2 digit
		tst.b	($FFFFEE4F).w
		bne.s	loc_2DB1C
		lea	(ArtKosM_TitleCardNum1).l,a1	; Otherwise, use the 1 digit if internal act number is 0
		moveq	#0,d0

loc_2DB1C:

		move.w	d0,$2C(a0)
		move.w	#-$5300,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_ResultsSONIC).l,a1		; Select character name to use based on character of course
		cmpi.w	#1,($FFFFFF08).w
		bls.s	loc_2DB58
		lea	(ArtKosM_ResultsKNUCKLES).l,a1
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_2DB58
		lea	(ArtKosM_ResultsMILES).l,a1
		tst.b	($FFFFFFD8).w
		bpl.s	loc_2DB58
		lea	(ArtKosM_ResultsTAILS).l,a1

loc_2DB58:

		move.w	#$AF00,d2
		tst.w	$2C(a0)
		beq.s	loc_2DB66
		move.w	#$B400,d2

loc_2DB66:
		jsr	(Queue_Kos_Module).l		; Load character name graphics
		clr.b	($FFFFFE1E).w		; Ensure timer isn't being updated currently
		moveq	#0,d0
		move.b	($FFFFFE23).w,d0
		mulu.w	#$3C,d0
		moveq	#0,d1
		move.b	($FFFFFE24).w,d1
		add.w	d1,d0
		cmpi.w	#$257,d0
		bne.s	loc_2DB90
		move.w	#$2710,($FFFFF7D2).w	; If clock is at 9:59 give an automatic 100000 point time bonus
		bra.s	loc_2DBA8
; ---------------------------------------------------------------------------

loc_2DB90:
		divu.w	#$1E,d0		; Divide time by 30
		moveq	#7,d1
		cmp.w	d1,d0		; If result is above 7, make it 7
		bcs.s	loc_2DB9C
		move.w	d1,d0

loc_2DB9C:
		add.w	d0,d0
		lea	TimeBonus(pc),a1
		move.w	(a1,d0.w),($FFFFF7D2).w	; Get the time bonus

loc_2DBA8:
		move.w	($FFFFFE20).w,d0
		mulu.w	#$A,d0
		move.w	d0,($FFFFF7D4).w	; Get the ring bonus
		clr.w	($FFFFFF8E).w
		move.w	#$168,$2E(a0)		; Wait 6 seconds before starting score counting sequence
		move.w	#$C,$30(a0)
		addq.b	#2,5(a0)
		rts
; ---------------------------------------------------------------------------

Obj_LevelResultsCreate:
		tst.b	($FFFFFF60).w
		bne.s	locret_2DC34		; Don't load the objects until the art has been loaded
		jsr	(Create_New_Sprite3).l
		bne.s	locret_2DC34
		lea	ObjArray_LevResults(pc),a2
		moveq	#$B,d1		; Make 12 objects

loc_2DBDE:
		move.l	(a2)+,(a1)
		move.w	(a2)+,$46(a1)
		move.w	(a2)+,$10(a1)
		spl	5(a1)
		move.w	(a2)+,$14(a1)
		move.b	(a2)+,$22(a1)
		move.b	(a2)+,7(a1)
		move.w	(a2)+,d2
		move.b	d2,$28(a1)
		move.b	#$40,4(a1)
		move.l	#Map_Results,$C(a1)
		move.w	a0,$48(a1)
		jsr	(CreateNewSprite4).l
		dbne	d1,loc_2DBDE
		addq.b	#2,5(a0)
		tst.b	($FFFFEE4F).w
		bne.s	locret_2DC34		; If this is act 2, branch
		move.b	($FFFFEE4E).w,d0
		beq.s	locret_2DC34		; If this is Angel Island, branch
		cmpi.b	#5,d0
		beq.s	locret_2DC34		; If this is Ice Cap Zone, branch
		st	($FFFFEEC6).w			; Set the background event flag for the given level (presumably for transitions)

locret_2DC34:

		rts
; ---------------------------------------------------------------------------

Obj_LevelResultsWait:
		tst.w	$2E(a0)
		beq.s	loc_2DC5C
		subq.w	#1,$2E(a0)
		cmpi.w	#$121,$2E(a0)
		bne.s	locret_2DC9E			; Play after eh, a second or so
		move.b	#$1E,($FFFFB02C).w		; Reset air for Hydrocity
		move.b	#$1E,($FFFFB076).w
		moveq	#$29,d0
		jmp	(Play_Sound).l				; Play level complete theme
; ---------------------------------------------------------------------------

loc_2DC5C:
		moveq	#0,d0
		tst.w	($FFFFF7D2).w
		beq.s	loc_2DC6E
		addi.w	#$A,d0
		subi.w	#$A,($FFFFF7D2).w		; Get 100 points from the time bonus

loc_2DC6E:
		tst.w	($FFFFF7D4).w
		beq.s	loc_2DC7E
		addi.w	#$A,d0
		subi.w	#$A,($FFFFF7D4).w		; Get 100 points from the ring bonus

loc_2DC7E:
		add.w	d0,($FFFFFF8E).w		; Add to total score for level
		tst.w	d0
		beq.s	loc_2DCA0			; Branch once score has finished counting down
		jsr	(HUD_AddToScore).l			; Add to actual score
		move.w	($FFFFFE04).w,d0
		andi.w	#3,d0
		bne.s	locret_2DC9E
		moveq	#$5B,d0				; Every four frames play the score countdown sound
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

locret_2DC9E:

		rts
; ---------------------------------------------------------------------------

loc_2DCA0:
		moveq	#-$50,d0			; Play the cash register sound
		jsr	(Play_Sound_2).l
		cmpi.w	#$A00,($FFFFFE10).w
		beq.s	loc_2DCB6
		tst.w	$2C(a0)
		beq.s	loc_2DCC0

loc_2DCB6:
		st	($FFFFEF56).w		; If in act 2 or Sky Sanctuary, save the game
		jsr	(SaveGame).l

loc_2DCC0:
		move.w	#$5A,$2E(a0)	; Set wait amount
		addq.b	#2,5(a0)

Obj_LevelResultsWait2:
		tst.w	$2E(a0)
		beq.s	loc_2DCD6
		subq.w	#1,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_2DCD6:
		tst.w	$30(a0)			; Wait for title screen objects to disappear
		beq.s	loc_2DCE2
		addq.w	#1,$32(a0)
		rts
; ---------------------------------------------------------------------------

loc_2DCE2:
		move.b	($FFFFFE10).w,d0
		cmpi.b	#$A,d0
		beq.s	loc_2DCF8
		cmpi.b	#$16,d0
		beq.s	loc_2DCF8
		tst.b	($FFFFEE4F).w
		beq.s	loc_2DD06

loc_2DCF8:

		clr.b	($FFFFFAA8).w		; Act 2 (or Sky Sanctuary or LRZ boss)
		st	($FFFFFAAA).w			; Stop level results flag and set title card finished flag
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2DD06:
		move.b	#1,($FFFFEE4F).w	; Change to act 2 if in act 1

loc_2DD0C:
		clr.b	($FFFFFE2A).w
		clr.b	($FFFFFE48).w
		clr.b	($FFFFFAA8).w
		cmpi.b	#8,($FFFFFE10).w
		beq.s	loc_2DD38
		cmpi.b	#$B,($FFFFFE10).w
		beq.s	loc_2DD38			; Neither Sandopolis 1 nor Death Egg 1 immediately show title cards
		move.l	#Obj_TitleCard,(a0)	; Change current object to title card
		clr.b	5(a0)
		st	$3E(a0)
		rts
; ---------------------------------------------------------------------------

loc_2DD38:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_LevResultsCharName:
		cmpi.w	#2,($FFFFFF08).w
		beq.s	loc_2DD62
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_2DD7E
		addq.b	#3,$22(a0)		; Knuckles frame
		moveq	#$30,d0
		sub.w	d0,$10(a0)
		sub.w	d0,$46(a0)		; Sprite is offset slightly to the left
		add.b	d0,7(a0)		; Increase width by said amount
		bra.s	loc_2DD7E
; ---------------------------------------------------------------------------

loc_2DD62:
		addq.b	#1,$22(a0)		; Miles frame
		tst.b	($FFFFFFD8).w
		bpl.s	loc_2DD7E
		addq.b	#1,$22(a0)		; Tails frame
		moveq	#8,d0
		add.w	d0,$10(a0)
		add.w	d0,$46(a0)
		sub.b	d0,7(a0)		; Offset like above

loc_2DD7E:

		moveq	#0,d0
		movea.w	$48(a0),a1
		tst.w	$2C(a1)
		beq.s	loc_2DD8E
		move.w	#$28,d0

loc_2DD8E:
		move.w	d0,$A(a0)		; Offset VRAM depending on act number
		move.l	#Obj_LevResultsGeneral,(a0)

Obj_LevResultsGeneral:

		jsr	LevelResults_MoveElement(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_LevelResultsTimeBonus:
		jsr	LevelResults_MoveElement(pc)
		move.w	($FFFFF7D2).w,d0
		bra.s	loc_2DDBE
; ---------------------------------------------------------------------------

Obj_LevelResultsRingBonus:
		jsr	LevelResults_MoveElement(pc)
		move.w	($FFFFF7D4).w,d0
		bra.s	loc_2DDBE
; ---------------------------------------------------------------------------

Obj_LevelResultsTotal:
		jsr	LevelResults_MoveElement(pc)
		move.w	($FFFFFF8E).w,d0

loc_2DDBE:

		bsr.s	LevResults_DisplayScore
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


LevResults_DisplayScore:

		move.w	#7,$16(a0)
		jsr	LevResults_GetDecimalScore(pc)
		rol.l	#4,d1
		lea	$18(a0),a1
		move.w	$10(a0),d2
		subi.w	#$38,d2
		move.w	$14(a0),d3
		moveq	#0,d4
		moveq	#6,d5

loc_2DDE6:
		move.w	d2,(a1)+
		move.w	d3,(a1)+
		addq.w	#1,a1
		rol.l	#4,d1
		move.w	d1,d0
		andi.w	#$F,d0
		beq.s	loc_2DDF8
		moveq	#1,d4

loc_2DDF8:
		add.w	d4,d0
		move.b	d0,(a1)+
		addq.w	#8,d2
		dbf	d5,loc_2DDE6
		rts
; End of function LevResults_DisplayScore


; =============== S U B R O U T I N E =======================================


LevelResults_MoveElement:

		movea.w	$48(a0),a1
		move.w	$32(a1),d0
		beq.s	loc_2DE38
		tst.b	4(a0)
		bmi.s	loc_2DE20
		subq.w	#1,$30(a1)			; If offscreen, subtract from number of elements and delete
		addq.w	#4,sp
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2DE20:
		cmp.b	$28(a0),d0		; Level element moving out. Test if value of parent queue matches given queue value
		bcs.s	locret_2DE4E
		move.w	#-$20,d0		; If so, move out
		tst.b	5(a0)
		beq.s	loc_2DE32
		neg.w	d0				; Change direction depending on where it came from

loc_2DE32:
		add.w	$10(a0),d0
		bra.s	loc_2DE4A
; ---------------------------------------------------------------------------

loc_2DE38:
		moveq	#$10,d1			; Level element moving in
		move.w	$10(a0),d0
		cmp.w	$46(a0),d0
		beq.s	loc_2DE4A		; If X position has reached destination, don't do anything else
		blt.s	loc_2DE48		; See which direction it needs to go
		neg.w	d1

loc_2DE48:
		add.w	d1,d0			; Add speed to X amount

loc_2DE4A:

		move.w	d0,$10(a0)

locret_2DE4E:
		rts
; End of function LevelResults_MoveElement


; =============== S U B R O U T I N E =======================================


LevResults_GetDecimalScore:

		clr.l	($FFFFEF40).w
		lea	TimeBonus(pc),a1
		moveq	#$F,d2

loc_2DE5A:
		ror.w	#1,d0
		bcs.s	loc_2DE62
		subq.w	#3,a1
		bra.s	loc_2DE70
; ---------------------------------------------------------------------------

loc_2DE62:
		lea	($FFFFEF44).w,a2
		addi.w	#0,d0
		abcd	-(a1),-(a2)
		abcd	-(a1),-(a2)
		abcd	-(a1),-(a2)

loc_2DE70:
		dbf	d2,loc_2DE5A
		move.l	($FFFFEF40).w,d1
		rts
; End of function LevResults_GetDecimalScore

; ---------------------------------------------------------------------------
		dc.b 3, $27, $68
		dc.b 1, $63, $84
		dc.b 0, $81, $92
		dc.b 0, $40, $96
		dc.b 0, $20, $48
		dc.b 0, $10, $24
		dc.b 0, 5, $12
		dc.b 0, 2, $56
		dc.b 0, 1, $28
		dc.b 0, 0, $64
		dc.b 0, 0, $32
		dc.b 0, 0, $16
		dc.b 0, 0, 8
		dc.b 0, 0, 4
		dc.b 0, 0, 2
		dc.b 0, 0, 1
TimeBonus:	dc.w  $1388, $1388,  $3E8,  $1F4,  $190,  $12C,	  $64,	  $A


ObjArray_LevResults:	dc.l Obj_LevResultsCharName		; Object address
		dc.w $E0			; X destination
		dc.w $FDE0			; X position
		dc.w $B8			; Y position
		dc.b $13			; Mapping frame
		dc.b $48			; Width
		dc.w 1				; Place in exit queue
		dc.l Obj_LevResultsGeneral
		dc.w $130
		dc.w $FE30
		dc.w $B8
		dc.b $11
		dc.b $30
		dc.w 1
		dc.l Obj_LevResultsGeneral
		dc.w $E8
		dc.w $468
		dc.w $CC
		dc.b $10
		dc.b $70
		dc.w 3
		dc.l Obj_LevResultsGeneral
		dc.w $160
		dc.w $4E0
		dc.w $BC
		dc.b $F
		dc.b $38
		dc.w 3
		dc.l Obj_LevResultsGeneral
		dc.w $C0
		dc.w $4C0
		dc.w $F0
		dc.b $E
		dc.b $20
		dc.w 5
		dc.l Obj_LevResultsGeneral
		dc.w $E8
		dc.w $4E8
		dc.w $F0
		dc.b $C
		dc.b $30
		dc.w 5
		dc.l Obj_LevelResultsTimeBonus
		dc.w $178
		dc.w $578
		dc.w $F0
		dc.b 1
		dc.b $40
		dc.w 5
		dc.l Obj_LevResultsGeneral
		dc.w $C0
		dc.w $500
		dc.w $100
		dc.b $D
		dc.b $20
		dc.w 7
		dc.l Obj_LevResultsGeneral
		dc.w $E8
		dc.w $528
		dc.w $100
		dc.b $C
		dc.b $30
		dc.w 7
		dc.l Obj_LevelResultsRingBonus
		dc.w $178
		dc.w $5B8
		dc.w $100
		dc.b 1
		dc.b $40
		dc.w 7
		dc.l Obj_LevResultsGeneral
		dc.w $D4
		dc.w $554
		dc.w $11C
		dc.b $B
		dc.b $30
		dc.w 9
		dc.l Obj_LevelResultsTotal
		dc.w $178
		dc.w $5F8
		dc.w $11C
		dc.b 1
		dc.b $40
		dc.w 9
; ---------------------------------------------------------------------------

locret_2DF62:
		rts
; ---------------------------------------------------------------------------

SpecialStage_Results:
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		move.b	($FFFFFE16).w,d0
		move.b	d0,($FFFFEF6E).w
		move.b	($FFFFEF70).w,d1
		beq.s	loc_2DF82
		andi.b	#$7F,d1
		move.b	d1,d0
		bra.s	loc_2DF8C
; ---------------------------------------------------------------------------

loc_2DF82:
		addq.b	#1,d0
		cmpi.b	#7,d0
		bcs.s	loc_2DF8C
		moveq	#0,d0

loc_2DF8C:

		move.b	d0,($FFFFFE16).w
		move	#$2700,sr
		move.w	($FFFFF60E).w,d0
		andi.b	#-$41,d0
		move.w	d0,($C00004).l
		jsr	(Clear_DisplayData).l
		lea	($C00004).l,a6
		move.w	#-$7FFC,(a6)
		move.w	#-$7DD0,(a6)
		move.w	#-$7BF9,(a6)
		move.w	#-$74FD,(a6)
		move.w	#-$737F,(a6)
		move.w	#-$6FFF,(a6)
		lea	($FFFFAC00).w,a1
		moveq	#0,d0
		move.w	#$FF,d1

loc_2DFD0:
		move.l	d0,(a1)+
		dbf	d1,loc_2DFD0
		lea	($FFFFB000).w,a1
		moveq	#0,d0
		move.w	#$7FF,d1

loc_2DFE0:
		move.l	d0,(a1)+
		dbf	d1,loc_2DFE0
		clr.w	($FFFFFB00).w
		move.l	#-$500,($FFFFFBFC).w
		clr.w	($FFFFEF56).w
		jsr	(SaveGame_SpecialStage).l
		clr.w	($FFFFFFE8).w

loc_2E000:
		clr.w	($FFFFF100).w

loc_2E004:
		clr.w	($FFFFEEA6).w

loc_2E008:
		clr.b	($FFFFFE1E).w

loc_2E00C:
		clr.w	($FFFFEE50).w
		move.w	($FFFFFE10).w,($FFFFEF6A).w
		lea	PLC_2E310(pc),a1
		jsr	(Load_PLC_Raw).l
		lea	(ArtKosM_ResultsGeneral).l,a1
		move.w	#-$4900,d2
		jsr	(Queue_Kos_Module).l
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_2E04E
		lea	(ArtKosM_SSResultsSUPERk).l,a1
		cmpi.b	#7,($FFFFFFB1).w
		bcs.s	loc_2E06A
		lea	(ArtKosM_SSResultsHYPERk).l,a1
		bra.s	loc_2E06A
; ---------------------------------------------------------------------------

loc_2E04E:
		lea	(ArtKosM_SSResultsSUPER).l,a1
		cmpi.w	#2,($FFFFFF08).w
		beq.s	loc_2E06A
		cmpi.b	#7,($FFFFFFB1).w
		bcs.s	loc_2E06A
		lea	(ArtKosM_SSResultsHYPER).l,a1

loc_2E06A:

		move.w	#-$5E20,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_ResultsSONIC).l,a1
		cmpi.w	#1,($FFFFFF08).w
		bls.s	loc_2E0A2
		lea	(ArtKosM_ResultsKNUCKLES).l,a1
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_2E0A2
		lea	(ArtKosM_ResultsMILES).l,a1
		tst.b	($FFFFFFD8).w
		bpl.s	loc_2E0A2
		lea	(ArtKosM_ResultsTAILS).l,a1

loc_2E0A2:

		move.w	#-$61E0,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_SSResults).l,a1
		move.w	#-$5BA0,d2
		jsr	(Queue_Kos_Module).l
		move.l	#locret_2DF62,($FFFFEF44).w

loc_2E0C4:

		move.b	#$1E,($FFFFF62A).w
		jsr	(Process_Kos_Queue).l
		jsr	(Wait_VSync).l
		jsr	(Process_Nem_Queue_Init).l
		jsr	(Process_Kos_Module_Queue).l
		tst.b	($FFFFFF60).w
		bne.s	loc_2E0C4
		tst.l	($FFFFF680).w
		bne.s	loc_2E0C4
		jsr	(sub_DE9C).l
		move.b	#1,($FFFFFE1F).w
		lea	Pal_Results(pc),a0
		lea	($FFFFFC00).w,a1
		moveq	#$1F,d0

loc_2E104:
		move.l	(a0),(a1)+
		move.l	(a0)+,$7C(a1)
		dbf	d0,loc_2E104

loc_2E10E:
		jsr	sub_2E2C0(pc)
		tst.w	($FFFFFFAE).w
		bne.w	loc_2E226
		tst.b	($FFFFFFBB).w
		beq.w	loc_2E226
		lea	Pal_Results(pc),a0
		lea	($FFFFFC00).w,a1
		moveq	#7,d0

loc_2E12C:
		move.l	(a0)+,d1
		move.l	d1,$A0(a1)
		move.l	d1,$20(a1)
		move.l	d1,$80(a1)
		move.l	d1,(a1)+
		dbf	d0,loc_2E12C
		jsr	sub_2E2C0(pc)
		lea	(Pal_HPZ_B).l,a0
		lea	($FFFFFC40).w,a1
		moveq	#$F,d0

loc_2E150:
		move.l	#$CCC0CCC,(a1)+
		move.l	(a0)+,$7C(a1)
		dbf	d0,loc_2E150
		lea	(Layout_HPZ).l,a0
		lea	($FFFF8000).w,a1
		move.w	#$3FF,d0

loc_2E16C:
		move.l	(a0)+,(a1)+
		dbf	d0,loc_2E16C
		lea	(HPZ_128x128_Primary_Kos).l,a0
		lea	($FFFF0000).l,a1
		jsr	(Kos_Decomp).l
		lea	(HPZ_128x128_Secondary_Kos).l,a0
		jsr	(Kos_Decomp).l
		lea	(HPZ_16x16_Primary_Kos).l,a0
		lea	($FFFF9000).w,a1
		jsr	(Kos_Decomp).l
		lea	(HPZ_16x16_Secondary_Kos).l,a0
		jsr	(Kos_Decomp).l
		lea	(ArtKosM_HPZ_Primary).l,a1
		move.w	(a1),d4
		move.w	#0,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_HPZ_Secondary).l,a1
		move.w	d4,d2
		jsr	(Queue_Kos_Module).l
		moveq	#$48,d0
		jsr	(Load_PLC).l
		move.w	#$1701,($FFFFFE10).w
		move.w	#$15A0,($FFFFEE78).w
		move.w	#$240,($FFFFEE7C).w
		clr.b	($FFFFF76C).w
		jsr	(Load_Sprites).l
		moveq	#0,d0
		move.b	($FFFFEF6E).w,d0
		add.w	d0,d0
		lea	word_2E398(pc),a0
		move.w	(a0,d0.w),($FFFFEE78).w
		move	#$2700,sr
		jsr	(j_LevelSetup).l
		move	#$2300,sr
		tst.w	($FFFFE438).w
		bne.s	loc_2E226
		move.b	($FFFFEF6E).w,d0
		ori.b	#-$80,d0
		move.b	d0,($FFFFFAC0).w
		st	($FFFFFAC1).w

loc_2E226:

		jsr	(Init_SpriteTable).l
		move.w	#$98,($FFFFEF68).w
		st	($FFFFEF6C).w
		move.l	#loc_2E3B8,($FFFFB940).w
		move.w	($FFFFF60E).w,d0
		ori.b	#$40,d0
		move.w	d0,($C00004).l

loc_2E24C:
		move.b	#8,($FFFFF62A).w
		jsr	(Process_Kos_Queue).l
		jsr	(Wait_VSync).l
		addq.w	#1,($FFFFFE04).w
		move.w	($FFFFE666).w,d1
		addq.w	#1,d1
		cmpi.w	#3,d1
		bcs.s	loc_2E270
		moveq	#0,d1

loc_2E270:
		move.w	d1,($FFFFE666).w
		jsr	(Process_Sprites).l
		tst.w	($FFFFFFAE).w
		bne.s	loc_2E28C
		tst.b	($FFFFFFBB).w
		beq.s	loc_2E28C
		jsr	(ScreenEvents).l

loc_2E28C:

		jsr	(Render_Sprites).l
		jsr	(Process_Nem_Queue_Init).l
		jsr	(Process_Kos_Module_Queue).l
		tst.w	($FFFFEE50).w
		beq.s	loc_2E2B0
		bmi.s	loc_2E2B0
		subq.w	#1,($FFFFEE50).w
		jsr	(Pal_FromWhite).l

loc_2E2B0:

		cmpi.b	#$48,($FFFFF600).w
		beq.s	loc_2E24C
		move.w	($FFFFEF6A).w,($FFFFFE10).w
		rts

; =============== S U B R O U T I N E =======================================


sub_2E2C0:

		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_2E2F6
		lea	($FFFFFC04).w,a0
		move.l	#$84E040C,d0
		move.l	d0,$80(a0)
		move.l	d0,(a0)+
		move.l	#$2060080,d0
		tst.w	($FFFFFFAE).w
		bne.s	loc_2E2EE
		tst.b	($FFFFFFBB).w
		beq.s	loc_2E2EE
		move.w	#$EE,d0

loc_2E2EE:

		move.l	d0,$80(a0)
		move.l	d0,(a0)
		bra.s	locret_2E30E
; ---------------------------------------------------------------------------

loc_2E2F6:
		tst.w	($FFFFFFAE).w
		bne.s	locret_2E30E
		tst.b	($FFFFFFBB).w
		beq.s	locret_2E30E
		move.w	#$EE,($FFFFFC2A).w

loc_2E308:
		move.w	#$EE,($FFFFFCAA).w

locret_2E30E:

		rts
; End of function sub_2E2C0

; ---------------------------------------------------------------------------
PLC_2E310:	dc.w 0
		dc.l ArtNem_Ring
		dc.w $D780
Pal_Results:	binclude "General\Results\Palettes\Main.bin"


word_2E398:	dc.w $15A0

		dc.w $1540
		dc.w $1600
		dc.w $1500
		dc.w $1640
		dc.w $14B0
		dc.w $1690
		dc.w $15A0
		dc.w $368
		dc.w $3A0
		dc.w $3A0
		dc.w $350
		dc.w $350
		dc.w $390
		dc.w $390
		dc.w $368
; ---------------------------------------------------------------------------

loc_2E3B8:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_2E3C6(pc,d0.w),d1
		jmp	off_2E3C6(pc,d1.w)
; ---------------------------------------------------------------------------
off_2E3C6:	dc.w loc_2E3DA-off_2E3C6

		dc.w loc_2E410-off_2E3C6
		dc.w loc_2E4D6-off_2E3C6
		dc.w loc_2E512-off_2E3C6
		dc.w loc_2E5C0-off_2E3C6
		dc.w loc_2E5E0-off_2E3C6
		dc.w loc_2E5F4-off_2E3C6
		dc.w loc_2E616-off_2E3C6
		dc.w loc_2E746-off_2E3C6
		dc.w loc_2E7DA-off_2E3C6
; ---------------------------------------------------------------------------

loc_2E3DA:
		lea	$4A(a0),a1
		lea	ObjDat2_2E834(pc),a2
		moveq	#$12,d1
		jsr	sub_2E802(pc)
		move.w	($FFFFE43A).w,d0
		mulu.w	#$A,d0
		move.w	d0,($FFFFF7D4).w
		clr.w	($FFFFF7D2).w
		tst.w	($FFFFE442).w
		bne.s	loc_2E404
		move.w	#$1388,($FFFFF7D2).w

loc_2E404:
		move.w	#$168,$2E(a0)
		addq.b	#2,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_2E410:
		tst.w	$2E(a0)
		beq.s	loc_2E484
		subq.w	#1,$2E(a0)
		bne.s	loc_2E474
		tst.w	($FFFFFFAE).w
		bne.s	loc_2E474
		tst.b	($FFFFFFBB).w
		beq.s	loc_2E474
		tst.w	($FFFFE438).w
		bne.s	loc_2E474
		move.w	#$3F,($FFFFF626).w
		move.w	#$16,($FFFFEE50).w
		lea	($FFFFFC00).w,a1
		move.w	#$EEE,$42(a1)
		move.w	#$EEE,$44(a1)
		move.w	#$EEE,$4C(a1)
		move.w	#$EEE,$62(a1)
		move.w	#$EEE,$66(a1)
		move.w	#$EEE,$6E(a1)
		move.w	#$EEE,$70(a1)
		move.w	#$EEE,$7C(a1)
		move.w	#$EEE,$7E(a1)

loc_2E474:

		cmpi.w	#$121,$2E(a0)
		bne.s	locret_2E4C2
		moveq	#$29,d0
		jmp	(Play_Sound).l
; ---------------------------------------------------------------------------

loc_2E484:
		moveq	#0,d0
		tst.w	($FFFFF7D2).w
		beq.s	loc_2E496
		addi.w	#$A,d0
		subi.w	#$A,($FFFFF7D2).w

loc_2E496:
		tst.w	($FFFFF7D4).w
		beq.s	loc_2E4A6
		addi.w	#$A,d0
		subi.w	#$A,($FFFFF7D4).w

loc_2E4A6:
		tst.w	d0
		beq.s	loc_2E4C4
		jsr	(HUD_AddToScore).l
		move.w	($FFFFFE04).w,d0
		andi.w	#3,d0
		bne.s	locret_2E4C2
		moveq	#$5B,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

locret_2E4C2:

		rts
; ---------------------------------------------------------------------------

loc_2E4C4:
		moveq	#-$50,d0
		jsr	(Play_Sound_2).l
		move.w	#$78,$2E(a0)
		addq.b	#2,5(a0)

loc_2E4D6:
		cmpi.w	#$32,($FFFFE43A).w
		bcs.s	loc_2E50E
		tst.w	$2E(a0)
		beq.s	loc_2E4EA
		subq.w	#1,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_2E4EA:
		clr.w	($FFFFEEE0).w
		jsr	(Create_New_Sprite3).l
		bne.s	loc_2E50E
		move.w	a1,($FFFFEEE0).w
		move.l	#loc_2EBE8,(a1)
		move.w	#$10E,$2E(a0)
		moveq	#-$54,d0
		jsr	(Play_Sound_2).l

loc_2E50E:

		addq.b	#2,5(a0)

loc_2E512:
		tst.w	($FFFFFFAE).w
		bne.s	loc_2E534
		tst.b	($FFFFFFBB).w
		beq.s	loc_2E534
		tst.w	($FFFFE438).w
		bne.s	loc_2E534
		move.w	#$3C,$2E(a0)
		move.b	#$E,5(a0)
		bra.w	loc_2E616
; ---------------------------------------------------------------------------

loc_2E534:

		tst.w	$2E(a0)
		beq.s	loc_2E540
		subq.w	#1,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_2E540:
		tst.w	($FFFFE438).w
		bne.s	loc_2E5B8
		cmpi.b	#7,($FFFFFFB0).w
		bcs.s	loc_2E5B8
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_2E570
		cmpi.w	#1,($FFFFFF08).w
		bls.s	loc_2E570
		cmpi.b	#4,($FFFFEF6A).w
		beq.s	loc_2E586
		cmpi.b	#7,($FFFFEF6A).w
		bcs.s	loc_2E5B8
		bra.s	loc_2E586
; ---------------------------------------------------------------------------

loc_2E570:

		tst.w	($FFFFFFAE).w
		bne.s	loc_2E58C
		cmpi.b	#4,($FFFFEF6A).w
		beq.s	loc_2E586
		cmpi.b	#7,($FFFFEF6A).w
		bcs.s	loc_2E58C

loc_2E586:

		move.b	#$A,5(a0)

loc_2E58C:

		lea	($FFFFBD96).w,a1
		moveq	#4,d0

loc_2E592:
		move.l	#loc_2EC1E,(a1)
		lea	$4A(a1),a1
		dbf	d0,loc_2E592
		move.w	#4,($FFFFBE58).w
		move.w	#4,($FFFFBEEC).w
		move.w	#5,$30(a0)
		addq.b	#2,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_2E5B8:

		move.b	#$C,($FFFFF600).w
		rts
; ---------------------------------------------------------------------------

loc_2E5C0:
		tst.w	$30(a0)
		bne.s	locret_2E5DE
		lea	($FFFFBD96).w,a1
		lea	ObjDat2_2E918(pc),a2
		moveq	#5,d1
		jsr	sub_2E802(pc)
		move.w	#$F0,$2E(a0)
		addq.b	#2,5(a0)

locret_2E5DE:
		rts
; ---------------------------------------------------------------------------

loc_2E5E0:
		tst.w	$2E(a0)
		beq.s	loc_2E5EC
		subq.w	#1,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_2E5EC:
		move.b	#$C,($FFFFF600).w
		rts
; ---------------------------------------------------------------------------

loc_2E5F4:
		tst.w	$30(a0)
		bne.s	locret_2E614
		lea	($FFFFBD96).w,a1
		lea	ObjDat2_2E960(pc),a2
		moveq	#2,d1
		jsr	sub_2E802(pc)
		move.w	#$F0,$2E(a0)
		move.b	#$A,5(a0)

locret_2E614:
		rts
; ---------------------------------------------------------------------------

loc_2E616:

		tst.w	$2E(a0)
		beq.s	loc_2E622
		subq.w	#1,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_2E622:
		move.w	($FFFFEE7C).w,d0
		cmpi.w	#$320,d0
		bcc.w	loc_2E6EA
		addq.w	#1,d0
		move.w	d0,($FFFFEE7C).w
		cmpi.w	#$2A0,d0
		bne.w	locret_2E744
		moveq	#4,d0
		cmpi.w	#$32,($FFFFE43A).w
		bcs.s	loc_2E65C
		move.w	($FFFFEEE0).w,d1
		beq.s	loc_2E65A
		movea.w	d1,a1
		move.l	#loc_2EC4A,(a1)
		move.w	#$14,$2E(a1)

loc_2E65A:
		addq.w	#1,d0

loc_2E65C:
		move.w	d0,$30(a0)
		lea	($FFFFB98A).w,a1

loc_2E664:
		move.l	#loc_2EC1E,(a1)
		lea	$4A(a1),a1
		dbf	d0,loc_2E664
		moveq	#2,d0
		cmpi.b	#7,($FFFFFFB1).w
		bcs.s	loc_2E67E
		addq.w	#2,d0

loc_2E67E:
		add.w	d0,$30(a0)
		lea	($FFFFBD96).w,a1

loc_2E686:
		move.l	#loc_2EC1E,(a1)
		lea	$4A(a1),a1
		dbf	d0,loc_2E686
		addq.w	#2,$30(a0)
		lea	($FFFFB98A).w,a1
		move.w	#8,$2E(a1)
		move.w	#$C,$78(a1)
		move.w	#$C,$C2(a1)
		move.w	#$10,$10C(a1)
		move.w	#$10,$156(a1)
		cmpi.w	#$32,($FFFFE43A).w
		bcs.s	loc_2E6C8
		move.w	#$14,$1A0(a1)

loc_2E6C8:
		clr.w	$AA(a1)
		clr.w	$13E(a1)
		lea	($FFFFBD96).w,a1
		move.w	#4,$C2(a1)
		cmpi.b	#7,($FFFFFFB1).w
		bcs.s	loc_2E6E8
		move.w	#4,$156(a1)

loc_2E6E8:
		bra.s	locret_2E744
; ---------------------------------------------------------------------------

loc_2E6EA:
		move.l	#ArtUnc_Invincibility,d1
		move.w	#-$C80,d2
		move.w	#$200,d3
		jsr	(Add_To_DMA_Queue).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_2E72E
		moveq	#0,d1
		moveq	#0,d2
		moveq	#7,d3

loc_2E70C:
		move.l	#loc_2ECD0,(a1)
		move.w	d1,$2E(a1)
		move.w	d2,$30(a1)
		move.w	a0,$34(a1)
		addi.w	#$10,d1
		addq.w	#1,d2
		jsr	(CreateNewSprite4).l
		dbne	d3,loc_2E70C

loc_2E72E:
		move.w	#$1E,$2E(a0)
		clr.w	$30(a0)
		addq.b	#2,5(a0)
		moveq	#-$48,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

locret_2E744:

		rts
; ---------------------------------------------------------------------------

loc_2E746:
		tst.w	$30(a0)
		beq.w	locret_2E7D8
		bmi.s	loc_2E75C
		st	$30(a0)
		moveq	#-$64,d0
		jsr	(Play_Sound_2).l

loc_2E75C:
		cmpi.b	#7,($FFFFFFB1).w
		bcc.s	loc_2E772
		move.w	#$3C,$2E(a0)
		move.b	#$A,5(a0)
		bra.s	locret_2E7D8
; ---------------------------------------------------------------------------

loc_2E772:
		tst.w	$2E(a0)
		beq.s	loc_2E77E
		subq.w	#1,$2E(a0)
		bra.s	locret_2E7D8
; ---------------------------------------------------------------------------

loc_2E77E:
		moveq	#1,d0
		cmpi.w	#$15A0,($FFFFEE78).w
		beq.s	loc_2E792
		bcs.s	loc_2E78C
		neg.w	d0

loc_2E78C:
		add.w	d0,($FFFFEE78).w
		bra.s	locret_2E7D8
; ---------------------------------------------------------------------------

loc_2E792:
		jsr	(Create_New_Sprite).l
		bne.s	loc_2E7C6
		moveq	#0,d1
		moveq	#0,d2
		moveq	#7,d3

loc_2E7A0:
		move.l	#loc_2ECD0,(a1)
		move.w	d1,$2E(a1)
		move.w	d2,$30(a1)
		move.w	a0,$34(a1)
		st	$36(a1)
		addi.w	#$10,d1
		addq.w	#1,d2
		jsr	(CreateNewSprite4).l
		dbne	d3,loc_2E7A0

loc_2E7C6:
		move.w	#$78,$2E(a0)
		addq.b	#2,5(a0)
		moveq	#-$48,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

locret_2E7D8:

		rts
; ---------------------------------------------------------------------------

loc_2E7DA:
		tst.w	$2E(a0)
		beq.s	loc_2E7E6
		subq.w	#1,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_2E7E6:
		lea	($FFFFC280).w,a1
		lea	ObjDat2_2E984(pc),a2
		moveq	#6,d1
		jsr	sub_2E802(pc)
		move.w	#$168,$2E(a0)
		move.b	#$A,5(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_2E802:

		move.l	(a2)+,(a1)

loc_2E804:
		move.w	(a2)+,$46(a1)
		move.w	(a2)+,$10(a1)

loc_2E80C:
		move.w	(a2)+,$14(a1)
		move.b	(a2)+,$22(a1)
		move.b	(a2)+,7(a1)
		move.b	#$40,4(a1)
		move.l	#Map_Results,$C(a1)
		move.w	a0,$48(a1)
		lea	$4A(a1),a1
		dbf	d1,sub_2E802
		rts
; End of function sub_2E802

; ---------------------------------------------------------------------------
ObjDat2_2E834:	dc.l loc_2EA1E
		dc.w $120
		dc.w $4E0
		dc.w $100
		dc.b $17
		dc.b $60
		dc.l loc_2EA1E
		dc.w $C0
		dc.w $4C0
		dc.w $118
		dc.b $18
		dc.b $58
		dc.l loc_2EA5A
		dc.w $178
		dc.w $578
		dc.w $118
		dc.b 1
		dc.b $40
		dc.l loc_2EA1E
		dc.w $C0
		dc.w $500
		dc.w $128
		dc.b $19
		dc.b $40
		dc.l loc_2EA64
		dc.w $178
		dc.w $5B8
		dc.w $128
		dc.b 1
		dc.b $40
		dc.l loc_2EA7C
		dc.w $C0
		dc.w $540
		dc.w $138
		dc.b $1A
		dc.b $48
		dc.l loc_2EAA6
		dc.w $120
		dc.w $120
		dc.w $D0
		dc.b $1B
		dc.b 0
		dc.l loc_2EAA6
		dc.w $110
		dc.w $110
		dc.w $E8
		dc.b $1C
		dc.b 1
		dc.l loc_2EAA6
		dc.w $130
		dc.w $130
		dc.w $E8
		dc.b $1D
		dc.b 2
		dc.l loc_2EAA6
		dc.w $100
		dc.w $100
		dc.w $D0
		dc.b $1E
		dc.b 3
		dc.l loc_2EAA6
		dc.w $140
		dc.w $140
		dc.w $D0
		dc.b $1F
		dc.b 4
		dc.l loc_2EAA6
		dc.w $F0
		dc.w $F0
		dc.w $E8
		dc.b $20
		dc.b 5
		dc.l loc_2EAA6
		dc.w $150
		dc.w $150
		dc.w $E8
		dc.b $21
		dc.b 6
		dc.l loc_2EAC8
		dc.w $120
		dc.w $460
		dc.w $A0
		dc.b $22
		dc.b $60
		dc.l loc_2EAD8
		dc.w $D4
		dc.w $394
		dc.w $98
		dc.b $13
		dc.b $48
		dc.l loc_2EB30
		dc.w $124
		dc.w $3E4
		dc.w $98
		dc.b $23
		dc.b $48
		dc.l loc_2EB64
		dc.w $120
		dc.w $460
		dc.w $B0
		dc.b $24
		dc.b $64
		dc.l loc_2EBA4
		dc.w $114
		dc.w $3D4
		dc.w $98
		dc.b $25
		dc.b $20
		dc.l loc_2EBCC
		dc.w $118
		dc.w $458
		dc.w $B0
		dc.b $26
		dc.b $10
ObjDat2_2E918:	dc.l loc_2EA10
		dc.w $C0
		dc.w $3C0
		dc.w $98
		dc.b $27
		dc.b $38
		dc.l loc_2EAF6
		dc.w $100
		dc.w $400
		dc.w $98
		dc.b $13
		dc.b $48
		dc.l loc_2EA3E
		dc.w $150
		dc.w $450
		dc.w $98
		dc.b $3A
		dc.b $30
		dc.l loc_2EA10
		dc.w $C0
		dc.w $440
		dc.w $B0
		dc.b $28
		dc.b $20
		dc.l loc_2E9F6
		dc.w $E8
		dc.w $468
		dc.w $B0
		dc.b $12
		dc.b $50
		dc.l loc_2EAF6
		dc.w $138
		dc.w $4B8
		dc.w $B0
		dc.b $13
		dc.b $48
ObjDat2_2E960:	dc.l loc_2EAF6
		dc.w $B8
		dc.w $3B8
		dc.w $98
		dc.b $13
		dc.b $48
		dc.l loc_2EA3E
		dc.w $148
		dc.w $448
		dc.w $98
		dc.b $2E
		dc.b $40
		dc.l loc_2EA50
		dc.w $120
		dc.w $4A0
		dc.w $B0
		dc.b $2F
		dc.b $60
ObjDat2_2E984:	dc.l loc_2EA10
		dc.w $C0
		dc.w $3C0
		dc.w $124
		dc.b $2C
		dc.b $38
		dc.l loc_2EAF6
		dc.w $100
		dc.w $400
		dc.w $124
		dc.b $13
		dc.b $48
		dc.l loc_2EA3E
		dc.w $150
		dc.w $450
		dc.w $124
		dc.b $2D
		dc.b $30
		dc.l loc_2EA10
		dc.w $C0
		dc.w $440
		dc.w $13C
		dc.b $35
		dc.b $20
		dc.l loc_2E9F6
		dc.w $E8
		dc.w $468
		dc.w $13C
		dc.b $12
		dc.b $50
		dc.l loc_2EAF6
		dc.w $138
		dc.w $4B8
		dc.w $13C
		dc.b $13
		dc.b $48
		dc.l loc_2E9D8
		dc.w 0
		dc.w 0
		dc.w 0
		dc.b 0
		dc.b 0
; ---------------------------------------------------------------------------

loc_2E9D8:
		move.w	-$3A(a0),d0
		cmp.w	-4(a0),d0
		bne.s	locret_2E9F4
		clr.b	($FFFFFAC1).w
		moveq	#$68,d0
		jsr	(Play_Sound_2).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

locret_2E9F4:
		rts
; ---------------------------------------------------------------------------

loc_2E9F6:

		tst.w	($FFFFFFAE).w
		bne.s	loc_2EA10
		tst.b	($FFFFFFBB).w
		beq.s	loc_2EA10
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_2EA10
		move.w	#$2000,$A(a0)

loc_2EA10:

		jsr	sub_2EC80(pc)
		add.w	d0,$10(a0)
		add.w	d0,$46(a0)
		bra.s	loc_2EA4A
; ---------------------------------------------------------------------------

loc_2EA1E:

		tst.w	($FFFFFFAE).w
		bne.s	loc_2EA4A
		tst.b	($FFFFFFBB).w
		beq.s	loc_2EA4A
		addi.b	#$1A,$22(a0)
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_2EA4A
		addq.b	#5,$22(a0)
		bra.s	loc_2EA4A
; ---------------------------------------------------------------------------

loc_2EA3E:

		jsr	sub_2EC80(pc)
		sub.w	d0,$10(a0)
		sub.w	d0,$46(a0)

loc_2EA4A:

		move.l	#loc_2EA50,(a0)

loc_2EA50:


		jsr	LevelResults_MoveElement(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2EA5A:
		jsr	LevelResults_MoveElement(pc)
		move.w	($FFFFF7D4).w,d0
		bra.s	loc_2EA6C
; ---------------------------------------------------------------------------

loc_2EA64:
		jsr	LevelResults_MoveElement(pc)
		move.w	($FFFFF7D2).w,d0

loc_2EA6C:
		jsr	LevResults_DisplayScore(pc)
		move.w	($FFFFEF68).w,$A(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2EA7C:
		cmpi.w	#$32,($FFFFE43A).w
		bcs.w	loc_2EC7A
		tst.w	($FFFFFFAE).w
		bne.s	loc_2EA4A
		tst.b	($FFFFFFBB).w
		beq.s	loc_2EA4A
		addi.b	#$1A,$22(a0)
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_2EA4A
		addq.b	#5,$22(a0)
		bra.s	loc_2EA4A
; ---------------------------------------------------------------------------

loc_2EAA6:

		lea	($FFFFFFB2).w,a1
		moveq	#0,d0
		move.b	7(a0),d0
		cmpi.b	#1,(a1,d0.w)
		bne.w	loc_2EC7A
		tst.w	($FFFFE666).w
		beq.s	locret_2EAC6
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_2EAC6:
		rts
; ---------------------------------------------------------------------------

loc_2EAC8:
		tst.w	($FFFFE438).w
		beq.w	loc_2EC7A
		jsr	sub_2ECBC(pc)
		bra.w	loc_2EA50
; ---------------------------------------------------------------------------

loc_2EAD8:
		tst.w	($FFFFE438).w
		bne.w	loc_2EC7A
		jsr	sub_2ECA8(pc)
		cmpi.b	#7,(a1)
		bcs.s	loc_2EAF6
		subi.w	#$10,$10(a0)
		subi.w	#$10,$46(a0)

loc_2EAF6:

		jsr	sub_2EC80(pc)
		add.w	d0,$10(a0)
		add.w	d0,$46(a0)
		add.b	d1,$22(a0)
		move.w	#-$87,$A(a0)
		tst.w	($FFFFFFAE).w
		bne.w	loc_2EA4A
		tst.b	($FFFFFFBB).w
		beq.w	loc_2EA4A
		cmpi.w	#3,($FFFFFF08).w
		bne.w	loc_2EA4A
		addi.w	#$2000,$A(a0)
		bra.w	loc_2EA4A
; ---------------------------------------------------------------------------

loc_2EB30:
		tst.w	($FFFFE438).w
		bne.w	loc_2EC7A
		jsr	sub_2ECBC(pc)
		jsr	sub_2EC80(pc)
		sub.w	d0,$10(a0)
		sub.w	d0,$46(a0)
		jsr	sub_2ECA8(pc)
		cmpi.b	#7,(a1)
		bcs.w	loc_2EA4A
		subi.w	#$10,$10(a0)
		subi.w	#$10,$46(a0)
		bra.w	loc_2EA4A
; ---------------------------------------------------------------------------

loc_2EB64:
		tst.w	($FFFFE438).w
		bne.w	loc_2EC7A
		jsr	sub_2ECBC(pc)
		tst.w	($FFFFFFAE).w
		bne.s	loc_2EB7C
		tst.b	($FFFFFFBB).w
		bne.s	loc_2EB88

loc_2EB7C:
		cmpi.b	#7,($FFFFFFB0).w
		bcs.w	loc_2EA4A
		bra.s	loc_2EB98
; ---------------------------------------------------------------------------

loc_2EB88:
		move.b	#$30,$22(a0)
		cmpi.b	#7,($FFFFFFB1).w
		bcs.w	loc_2EA4A

loc_2EB98:
		subq.w	#8,$10(a0)
		subq.w	#8,$46(a0)
		bra.w	loc_2EA4A
; ---------------------------------------------------------------------------

loc_2EBA4:
		tst.w	($FFFFE438).w
		bne.w	loc_2EC7A
		jsr	sub_2ECBC(pc)
		jsr	sub_2ECA8(pc)
		cmpi.b	#7,(a1)
		bcs.w	loc_2EC7A
		jsr	sub_2EC80(pc)
		sub.w	d0,$10(a0)
		sub.w	d0,$46(a0)
		bra.w	loc_2EA4A
; ---------------------------------------------------------------------------

loc_2EBCC:
		tst.w	($FFFFE438).w
		bne.w	loc_2EC7A
		jsr	sub_2ECBC(pc)
		jsr	sub_2ECA8(pc)
		cmpi.b	#7,(a1)
		bcs.w	loc_2EC7A
		bra.w	loc_2EA50
; ---------------------------------------------------------------------------

loc_2EBE8:
		move.l	#Map_Results,$C(a0)
		move.w	#$17C,$10(a0)
		move.w	#$14C,$14(a0)
		move.w	($FFFFFF08).w,d0
		subq.w	#1,d0
		bcc.s	loc_2EC06
		moveq	#0,d0

loc_2EC06:
		addi.w	#$29,d0
		move.b	d0,$22(a0)
		btst	#3,($FFFFFE05).w
		beq.s	locret_2EC1C
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_2EC1C:
		rts
; ---------------------------------------------------------------------------

loc_2EC1E:

		tst.w	$2E(a0)
		beq.s	loc_2EC2A
		subq.w	#1,$2E(a0)
		bra.s	loc_2EC44
; ---------------------------------------------------------------------------

loc_2EC2A:
		tst.b	4(a0)
		bmi.s	loc_2EC3E
		movea.w	$48(a0),a1
		subq.w	#1,$30(a1)
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2EC3E:
		addi.w	#$20,$10(a0)

loc_2EC44:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2EC4A:
		tst.w	$2E(a0)
		beq.s	loc_2EC56
		subq.w	#1,$2E(a0)
		bra.s	loc_2EC6A
; ---------------------------------------------------------------------------

loc_2EC56:
		cmpi.w	#$1CC,$10(a0)
		bcs.s	loc_2EC64
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2EC64:
		addi.w	#$20,$10(a0)

loc_2EC6A:
		btst	#3,($FFFFFE05).w
		beq.s	locret_2EC78
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_2EC78:
		rts
; ---------------------------------------------------------------------------

loc_2EC7A:

		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_2EC80:

		moveq	#0,d0
		moveq	#0,d1
		cmpi.w	#1,($FFFFFF08).w
		bls.s	locret_2ECA6
		moveq	#-$18,d0
		moveq	#3,d1
		cmpi.w	#3,($FFFFFF08).w
		beq.s	locret_2ECA6
		moveq	#0,d0
		moveq	#1,d1
		tst.b	($FFFFFFD8).w
		bpl.s	locret_2ECA6
		moveq	#4,d0
		moveq	#2,d1

locret_2ECA6:

		rts
; End of function sub_2EC80


; =============== S U B R O U T I N E =======================================


sub_2ECA8:

		lea	($FFFFFFB0).w,a1
		tst.w	($FFFFFFAE).w
		bne.s	locret_2ECBA
		tst.b	($FFFFFFBB).w
		beq.s	locret_2ECBA
		addq.w	#1,a1

locret_2ECBA:
		rts
; End of function sub_2ECA8


; =============== S U B R O U T I N E =======================================


sub_2ECBC:

		tst.w	($FFFFFFAE).w
		bne.s	loc_2ECC8
		tst.b	($FFFFFFBB).w
		bne.s	locret_2ECCE

loc_2ECC8:
		move.w	#$6000,$A(a0)

locret_2ECCE:
		rts
; End of function sub_2ECBC

; ---------------------------------------------------------------------------

loc_2ECD0:

		move.l	#loc_2ED2A,(a0)
		move.b	#$44,4(a0)
		move.w	#-$7864,$A(a0)
		move.l	#Map_Invincibility,$C(a0)
		moveq	#0,d0
		move.b	($FFFFEF6E).w,d0
		add.w	d0,d0
		lea	word_2E398(pc),a1
		move.w	(a1,d0.w),d1
		addi.w	#$A0,d1
		move.w	d1,$10(a0)
		move.w	$10(a1,d0.w),$14(a0)
		move.w	#2,$16(a0)
		move.w	#-$2000,$32(a0)
		tst.w	$36(a0)
		beq.s	loc_2ED2A
		move.w	#$1640,$10(a0)
		move.w	#$340,$14(a0)
		clr.w	$32(a0)

loc_2ED2A:

		move.w	$2E(a0),d0
		jsr	(GetSineCosine).l
		move.w	$32(a0),d2
		tst.w	d1
		smi	d3
		bpl.s	loc_2ED40
		neg.w	d1

loc_2ED40:
		mulu.w	d2,d1
		swap	d1
		tst.b	d3
		beq.s	loc_2ED4A
		neg.w	d1

loc_2ED4A:
		tst.w	d0
		smi	d3
		bpl.s	loc_2ED52
		neg.w	d0

loc_2ED52:
		mulu.w	d2,d0
		swap	d0
		tst.b	d3
		beq.s	loc_2ED5C
		neg.w	d0

loc_2ED5C:
		move.w	$30(a0),d2
		addq.w	#1,d2
		cmpi.w	#8,d2
		bls.s	loc_2ED6A
		moveq	#0,d2

loc_2ED6A:
		move.w	d2,$30(a0)
		lea	$18(a0),a1
		move.w	$10(a0),d3
		add.w	d1,d3
		move.w	d3,(a1)+
		move.w	$14(a0),d3
		add.w	d0,d3
		move.w	d3,(a1)+
		move.w	d2,(a1)+
		neg.w	d1
		add.w	$10(a0),d1
		move.w	d1,(a1)+
		neg.w	d0
		add.w	$14(a0),d0
		move.w	d0,(a1)+
		move.w	d2,(a1)+
		addq.w	#2,$2E(a0)
		tst.w	$36(a0)
		bne.s	loc_2EDBC
		subi.w	#$100,$32(a0)
		bcs.s	loc_2EDAE
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2EDAE:
		movea.w	$34(a0),a1
		st	$31(a1)
		clr.b	($FFFFFAC0).w
		bra.s	loc_2EDCA
; ---------------------------------------------------------------------------

loc_2EDBC:
		addi.w	#$100,$32(a0)
		bcs.s	loc_2EDCA
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2EDCA:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
Map_GameOver:	include "General\Sprites\Game Over\Map - Game Over.asm"

Map_TitleCard:	include "General\Title\Map - S3 card.asm"

Map_Results:	include "General\Sprites\Results\Map - Results.asm"


; =============== S U B R O U T I N E =======================================


LoadEnemyArt:

		lea	off_2F7BE(pc),a6
		move.w	#$D00,d0
		cmpi.b	#$16,($FFFFFE10).w
		beq.s	loc_2F798
		move.w	#$E00,d0
		cmpi.w	#$1700,($FFFFFE10).w
		bne.s	loc_2F79E

loc_2F798:
		move.b	($FFFFFE11).w,d0
		bra.s	loc_2F7A2
; ---------------------------------------------------------------------------

loc_2F79E:
		move.w	($FFFFFE10).w,d0

loc_2F7A2:
		ror.b	#1,d0
		lsr.w	#6,d0
		adda.w	(a6,d0.w),a6
		move.w	(a6)+,d6
		bmi.s	locret_2F7BC

loc_2F7AE:
		movea.l	(a6)+,a1
		move.w	(a6)+,d2
		jsr	(Queue_Kos_Module).l
		dbf	d6,loc_2F7AE

locret_2F7BC:
		rts
; End of function LoadEnemyArt

; ---------------------------------------------------------------------------
off_2F7BE:	dc.w PLCKosM_AIZ-off_2F7BE

		dc.w PLCKosM_AIZ-off_2F7BE
		dc.w PLCKosM_HCZ1-off_2F7BE
		dc.w PLCKosM_HCZ2-off_2F7BE
		dc.w PLCKosM_MGZ1-off_2F7BE
		dc.w PLCKosM_MGZ2-off_2F7BE
		dc.w PLCKosM_CNZ-off_2F7BE
		dc.w PLCKosM_CNZ-off_2F7BE
		dc.w PLCKosM_FBZ-off_2F7BE
		dc.w PLCKosM_FBZ-off_2F7BE
		dc.w PLCKosM_ICZ-off_2F7BE
		dc.w PLCKosM_ICZ-off_2F7BE
		dc.w PLCKosM_LBZ-off_2F7BE
		dc.w PLCKosM_LBZ-off_2F7BE
		dc.w PLCKosM_MHZ1-off_2F7BE
		dc.w PLCKosM_MHZ2-off_2F7BE
		dc.w PLCKosM_SOZ-off_2F7BE
		dc.w PLCKosM_SOZ-off_2F7BE
		dc.w PLCKosM_LRZ-off_2F7BE
		dc.w PLCKosM_LRZ-off_2F7BE
		dc.w PLCKosM_SSZ-off_2F7BE
		dc.w PLCKosM_SSZ-off_2F7BE
		dc.w PLCKosM_DEZ-off_2F7BE
		dc.w PLCKosM_DEZ-off_2F7BE
		dc.w PLCKosM_DDZ-off_2F7BE
		dc.w PLCKosM_DDZ-off_2F7BE
		dc.w PLCKosM_Pachinko-off_2F7BE
		dc.w PLCKosM_Pachinko-off_2F7BE
		dc.w PLCKosM_Slots-off_2F7BE
		dc.w PLCKosM_Slots-off_2F7BE
PLCKosM_AIZ:	dc.w 2
		dc.l ArtKosM_AIZ_MonkeyDude
		dc.w $A900
		dc.l ArtKosM_AIZ_Tulipon
		dc.w $A540
		dc.l ArtKosM_AIZ_CaterkillerJr
		dc.w $ABE0
PLCKosM_HCZ1:	dc.w 3
		dc.l ArtKosM_Blastoid
		dc.w $A720
		dc.l ArtKosM_TurboSpiker
		dc.w $A000
		dc.l ArtKosM_MegaChopper
		dc.w $A9A0
		dc.l ArtKosM_Pointdexter
		dc.w $AB20
PLCKosM_HCZ2:	dc.w 3
		dc.l ArtKosM_Jawz
		dc.w $A720
		dc.l ArtKosM_TurboSpiker
		dc.w $A000
		dc.l ArtKosM_MegaChopper
		dc.w $A9A0
		dc.l ArtKosM_Pointdexter
		dc.w $AB20
PLCKosM_MGZ1:	dc.w 2
		dc.l ArtKosM_Spiker
		dc.w $A600
		dc.l ArtKosM_MGZMiniboss
		dc.w $A9E0
		dc.l ArtKosM_MGZEndBossDebris
		dc.w $AE00
PLCKosM_MGZ2:	dc.w 1
		dc.l ArtKosM_Spiker
		dc.w $A600
		dc.l ArtKosM_Mantis
		dc.w $A9E0
PLCKosM_CNZ:	dc.w 3
		dc.l ArtKosM_Sparkle
		dc.w $A480
		dc.l ArtKosM_Batbot
		dc.w $AA40
		dc.l ArtKosM_ClamerShot
		dc.w $AE00
		dc.l ArtKosM_CNZBalloon
		dc.w $AE80
PLCKosM_FBZ:	dc.w 2
		dc.l ArtKosM_Blaster
		dc.w $A0C0
		dc.l ArtKosM_Technosqueek
		dc.w $A5C0
		dc.l ArtKosM_FBZButton
		dc.w $A000
PLCKosM_ICZ:	dc.w 1
		dc.l ArtKosM_ICZSnowdust
		dc.w $AB00
		dc.l ArtKosM_StarPointer
		dc.w $A900
PLCKosM_LBZ:	dc.w 3
		dc.l ArtKosM_SnailBlaster
		dc.w $A480
		dc.l ArtKosM_Orbinaut
		dc.w $ADC0
		dc.l ArtKosM_Ribot
		dc.w $A8E0
		dc.l ArtKosM_Corkey
		dc.w $AB00
PLCKosM_MHZ1:	dc.w 2
		dc.l ArtKosM_Madmole
		dc.w $A8A0
		dc.l ArtKosM_Mushmeanie
		dc.w $ADA0
		dc.l ArtKosM_Dragonfly
		dc.w $A700
PLCKosM_MHZ2:	dc.w 3
		dc.l ArtKosM_CluckoidArrow
		dc.w $A440
		dc.l ArtKosM_Madmole
		dc.w $A8A0
		dc.l ArtKosM_Mushmeanie
		dc.w $ADA0
		dc.l ArtKosM_Dragonfly
		dc.w $A700
PLCKosM_SOZ:	dc.w 2
		dc.l ArtKosM_Skorp
		dc.w $A6C0
		dc.l ArtKosM_Sandworm
		dc.w $AAE0
		dc.l ArtKosM_Rockn
		dc.w $A000
PLCKosM_LRZ:	dc.w 2
		dc.l ArtKosM_FirewormSegments
		dc.w $A240
		dc.l ArtKosM_Iwamodoki
		dc.w $A600
		dc.l ArtKosM_Toxomister
		dc.w $AC40
PLCKosM_SSZ:	dc.w 0
		dc.l ArtKosM_EggRoboBadnik
		dc.w $A000
PLCKosM_DEZ:	dc.w 1
		dc.l ArtKosM_Spikebonker
		dc.w $A000
		dc.l ArtKosM_Chainspike
		dc.w $A840
PLCKosM_DDZ:	dc.w 0
		dc.l ArtKosM_EggRoboBadnik
		dc.w $A000
PLCKosM_Pachinko:dc.w 0
		dc.l ArtKosM_Teleporter
		dc.w $A5C0
PLCKosM_Slots:	dc.w $FFFF
; ---------------------------------------------------------------------------

Obj_Bubbler:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_2F946(pc,d0.w),d1
		jmp	off_2F946(pc,d1.w)
; ---------------------------------------------------------------------------
off_2F946:	dc.w loc_2F952-off_2F946

		dc.w loc_2F9B0-off_2F946
		dc.w loc_2F9CA-off_2F946
		dc.w loc_2FA2C-off_2F946
		dc.w loc_2FA4A-off_2F946
		dc.w loc_2FA50-off_2F946
; ---------------------------------------------------------------------------

loc_2F952:
		addq.b	#2,5(a0)
		move.l	#Map_Bubbler,$C(a0)
		move.w	#$45C,$A(a0)
		move.b	#-$7C,4(a0)
		move.b	#$10,7(a0)
		move.w	#$80,8(a0)
		move.b	$2C(a0),d0
		bpl.s	loc_2F996
		addq.b	#8,5(a0)
		andi.w	#$7F,d0
		move.b	d0,$32(a0)
		move.b	d0,$33(a0)
		move.b	#8,$20(a0)
		bra.w	loc_2FA50
; ---------------------------------------------------------------------------

loc_2F996:
		move.b	d0,$20(a0)
		move.w	$10(a0),$30(a0)
		move.w	#-$88,$1A(a0)
		jsr	(Random_Number).l
		move.b	d0,$26(a0)

loc_2F9B0:
		lea	(Ani_Bubbler).l,a1
		jsr	(Animate_Sprite).l
		cmpi.b	#6,$22(a0)
		bne.s	loc_2F9CA
		move.b	#1,$2E(a0)

loc_2F9CA:

		move.w	($FFFFF646).w,d0
		cmp.w	$14(a0),d0
		bcs.s	loc_2F9E2
		move.b	#6,5(a0)
		addq.b	#4,$20(a0)
		bra.w	loc_2FA2C
; ---------------------------------------------------------------------------

loc_2F9E2:
		move.b	$26(a0),d0
		addq.b	#1,$26(a0)
		andi.w	#$7F,d0
		lea	(byte_1831E).l,a1
		move.b	(a1,d0.w),d0
		ext.w	d0
		add.w	$30(a0),d0
		move.w	d0,$10(a0)
		tst.b	$2E(a0)
		beq.s	loc_2FA14
		bsr.w	sub_2FBA8
		cmpi.b	#6,5(a0)
		beq.s	loc_2FA2C

loc_2FA14:
		jsr	(MoveSprite2).l
		tst.b	4(a0)
		bpl.s	loc_2FA26
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2FA26:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2FA2C:


		lea	(Ani_Bubbler).l,a1
		jsr	(Animate_Sprite).l
		tst.b	4(a0)
		bpl.s	loc_2FA44
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_2FA44:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2FA4A:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2FA50:

		tst.w	$36(a0)
		bne.s	loc_2FAB2
		move.w	($FFFFF646).w,d0
		cmp.w	$14(a0),d0
		bcc.w	loc_2FB5C
		tst.b	4(a0)
		bpl.w	loc_2FB5C
		subq.w	#1,$38(a0)
		bpl.w	loc_2FB50
		move.w	#1,$36(a0)

loc_2FA78:
		jsr	(Random_Number).l
		move.w	d0,d1
		andi.w	#7,d0
		cmpi.w	#6,d0
		bcc.s	loc_2FA78
		move.b	d0,$34(a0)
		andi.w	#$C,d1
		lea	(byte_2FB96).l,a1
		adda.w	d1,a1
		move.l	a1,$3C(a0)
		subq.b	#1,$32(a0)
		bpl.s	loc_2FAB0
		move.b	$33(a0),$32(a0)
		bset	#7,$36(a0)

loc_2FAB0:
		bra.s	loc_2FABA
; ---------------------------------------------------------------------------

loc_2FAB2:
		subq.w	#1,$38(a0)
		bpl.w	loc_2FB50

loc_2FABA:
		jsr	(Random_Number).l
		andi.w	#$1F,d0
		move.w	d0,$38(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_2FB34
		move.l	(a0),(a1)
		move.w	$10(a0),$10(a1)
		jsr	(Random_Number).l
		andi.w	#$F,d0
		subq.w	#8,d0
		add.w	d0,$10(a1)
		move.w	$14(a0),$14(a1)
		moveq	#0,d0
		move.b	$34(a0),d0
		movea.l	$3C(a0),a2
		move.b	(a2,d0.w),$2C(a1)
		btst	#7,$36(a0)

loc_2FB04:
		beq.s	loc_2FB34
		jsr	(Random_Number).l
		andi.w	#3,d0
		bne.s	loc_2FB20
		bset	#6,$36(a0)
		bne.s	loc_2FB34
		move.b	#2,$2C(a1)

loc_2FB20:
		tst.b	$34(a0)
		bne.s	loc_2FB34
		bset	#6,$36(a0)
		bne.s	loc_2FB34
		move.b	#2,$2C(a1)

loc_2FB34:

		subq.b	#1,$34(a0)
		bpl.s	loc_2FB50
		jsr	(Random_Number).l
		andi.w	#$7F,d0
		addi.w	#$80,d0
		add.w	d0,$38(a0)
		clr.w	$36(a0)

loc_2FB50:

		lea	(Ani_Bubbler).l,a1
		jsr	(Animate_Sprite).l

loc_2FB5C:

		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_2FB7E
		move.w	($FFFFF646).w,d0
		cmp.w	$14(a0),d0
		bcs.w	loc_2FB90
		rts
; ---------------------------------------------------------------------------

loc_2FB7E:
		move.w	$48(a0),d0
		beq.s	loc_2FB8A
		movea.w	d0,a2
		bclr	#7,(a2)

loc_2FB8A:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2FB90:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
byte_2FB96:	dc.b 0
		dc.b 1
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 1
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 1
		dc.b 0
		dc.b 1
		dc.b 0
		dc.b 0
		dc.b 1
		dc.b 0

; =============== S U B R O U T I N E =======================================


sub_2FBA8:
		lea	($FFFFB000).w,a1
		bsr.s	loc_2FBB2
		lea	($FFFFB04A).w,a1
; End of function sub_2FBA8


loc_2FBB2:
		tst.b	$2E(a1)
		bmi.w	locret_2FC7C
		move.w	$10(a1),d0
		move.w	$10(a0),d1
		subi.w	#$10,d1
		cmp.w	d0,d1
		bcc.w	locret_2FC7C
		addi.w	#$20,d1
		cmp.w	d0,d1
		bcs.w	locret_2FC7C
		move.w	$14(a1),d0
		move.w	$14(a0),d1
		cmp.w	d0,d1
		bcc.w	locret_2FC7C
		addi.w	#$10,d1
		cmp.w	d0,d1
		bcs.w	locret_2FC7C
		btst	#6,$2B(a1)
		bne.w	locret_2FC7C
		jsr	(Player_ResetAirTimer).l
		moveq	#$38,d0
		jsr	(Play_Sound_2).l

loc_2FC06:
		clr.w	$18(a1)

loc_2FC0A:
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		move.b	#$15,$20(a1)
		move.w	#$23,$32(a1)
		move.b	#0,$40(a1)
		bclr	#5,$2A(a1)
		bclr	#4,$2A(a1)
		btst	#2,$2A(a1)
		beq.w	loc_2FC6A
		cmpi.l	#Obj_Sonic,(a1)
		bne.s	loc_2FC5A
		bclr	#2,$2A(a1)
		move.b	#$13,$1E(a1)
		move.b	#9,$1F(a1)
		subq.w	#5,$14(a1)
		bra.s	loc_2FC6A
; ---------------------------------------------------------------------------

loc_2FC5A:
		move.b	#$F,$1E(a1)
		move.b	#9,$1F(a1)
		subq.w	#1,$14(a1)

loc_2FC6A:

		cmpi.b	#6,5(a0)
		beq.s	locret_2FC7C
		move.b	#6,5(a0)
		addq.b	#4,$20(a0)

locret_2FC7C:

		rts
; ---------------------------------------------------------------------------
Ani_Bubbler:	include "General\Sprites\Bubbles\Anim - Bubbler.asm"

Map_Bubbler:	include "General\Sprites\Bubbles\Map - Bubbler.asm"

; ---------------------------------------------------------------------------

Obj_37_1:
		move.l	#Map_HCZWaterRush,$C(a0)
		ori.b	#4,4(a0)
		move.w	#$437A,$A(a0)
		move.b	#4,4(a0)
		move.w	#$80,8(a0)
		move.b	#$40,7(a0)
		move.b	#$20,6(a0)
		move.b	#2,$22(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_2FE28
		move.l	#loc_2FEB2,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		subi.w	#$30,$10(a1)
		move.l	#Map_HCZWaterRushBlock,$C(a1)
		move.w	#$43D4,$A(a1)
		move.b	#$10,7(a1)
		move.b	#$20,6(a1)
		move.b	#4,4(a1)
		move.w	#$280,8(a1)
		move.b	#1,$22(a1)
		move.w	a1,$3C(a0)

loc_2FE28:
		move.b	#3,($FFFFF7C7).w
		move.l	#loc_2FE34,(a0)

loc_2FE34:
		tst.b	($FFFFF7E0).w
		beq.s	loc_2FE58
		move.b	#3,$22(a0)
		move.b	#1,$24(a0)
		move.l	#loc_2FE5E,(a0)
		move.b	#0,($FFFFF7C7).w
		move.b	#1,($FFFFF650).w

loc_2FE58:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_2FE5E:
		subq.b	#1,$24(a0)
		bpl.s	loc_2FE9E
		move.b	#1,$24(a0)
		addq.b	#1,$22(a0)
		cmpi.b	#2,$22(a0)
		bne.s	loc_2FE98
		addi.w	#$20,$10(a0)
		cmpi.w	#$580,$10(a0)
		bne.s	loc_2FE98
		cmpi.w	#$5A0,$14(a0)
		bne.s	loc_2FE98
		subi.w	#$20,$10(a0)
		subi.w	#$20,$14(a0)

loc_2FE98:

		andi.b	#1,$22(a0)

loc_2FE9E:
		cmpi.w	#$980,$10(a0)
		bcs.s	loc_2FEAC
		move.w	#$7F00,$10(a0)

loc_2FEAC:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_2FEB2:
		tst.b	($FFFFF7E0).w
		beq.s	loc_2FED2
		move.l	#loc_2FEBE,(a0)

loc_2FEBE:
		subi.w	#$10,$14(a0)
		cmpi.w	#$560,$14(a0)
		bne.s	loc_2FED2
		move.w	#$7F00,$10(a0)

loc_2FED2:

		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_HCZWaterWall:

		tst.b	$2C(a0)
		beq.s	loc_2FF04
		move.l	#loc_30294,(a0)
		rts
; ---------------------------------------------------------------------------

loc_2FF04:
		move.w	($FFFFB014).w,d0
		cmpi.w	#$500,d0
		bcc.s	loc_2FF14
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_2FF14:
		lea	(ArtKosM_HCZGeyserHorz).l,a1
		move.w	#-$6000,d2
		jsr	(Queue_Kos_Module).l
		move.l	#loc_2FF2A,(a0)

loc_2FF2A:
		tst.b	($FFFFFF60).w
		beq.s	loc_2FF32
		rts
; ---------------------------------------------------------------------------

loc_2FF32:
		ori.b	#4,4(a0)

loc_2FF38:
		move.w	#$300,8(a0)
		move.l	#Map_HCZWaterWall,$C(a0)
		move.w	#$4500,$A(a0)
		move.b	#-$80,7(a0)
		move.b	#$20,6(a0)
		bset	#6,4(a0)
		move.w	#1,$16(a0)
		lea	$18(a0),a2
		move.w	$10(a0),(a2)+
		move.w	$14(a0),(a2)+
		move.w	#$20,$30(a0)
		move.l	#loc_2FF7C,(a0)

loc_2FF7C:
		move.w	($FFFFB010).w,d0
		subi.w	#$60,d0
		cmp.w	$10(a0),d0
		bcs.w	loc_30006
		move.l	#loc_3003C,(a0)
		moveq	#$57,d0
		jsr	(Play_Sound_2).l
		lea	(byte_3000C).l,a3
		move.w	$10(a0),d2
		addi.w	#$60,d2

loc_2FFA8:
		move.w	$14(a0),d3
		moveq	#7,d1

loc_2FFAE:
		jsr	(Create_New_Sprite3).l
		bne.s	loc_30006
		move.l	#loc_3011A,(a1)

loc_2FFBC:
		move.l	#Map_HCZWaterWallDebris,$C(a1)
		move.w	#$4558,$A(a1)
		move.b	#-$7C,4(a1)
		move.b	(a3)+,d0
		ext.w	d0
		add.w	d2,d0
		move.w	d0,$10(a1)
		move.b	(a3)+,d0
		ext.w	d0
		add.w	d3,d0
		move.w	d0,$14(a1)
		move.w	#$380,8(a1)
		move.b	#$18,7(a1)
		move.b	#$18,6(a1)
		move.w	(a3)+,$18(a1)
		move.w	(a3)+,$1A(a1)

loc_2FFFE:
		move.b	d1,$22(a1)

loc_30002:
		dbf	d1,loc_2FFAE

loc_30006:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
byte_3000C:	dc.b 0
		dc.b $E8
		dc.w $400
		dc.w $FF80
		dc.b 0
		dc.b $F8
		dc.w $600
		dc.w $FFC0
		dc.b 0
		dc.b 8
		dc.w $600
		dc.w $40
		dc.b 0
		dc.b $18
		dc.w $400
		dc.w $80
		dc.b 0
		dc.b $E8
		dc.w $300
		dc.w $FC80
		dc.b 0
		dc.b $F8
		dc.w $400
		dc.w $FCC0
		dc.b 0
		dc.b 8
		dc.w $300
		dc.w $100
		dc.b 0
		dc.b $18
		dc.w $500
		dc.w $FF00
; ---------------------------------------------------------------------------

loc_3003C:
		tst.w	$30(a0)
		beq.s	loc_3004A
		subq.w	#1,$30(a0)
		addq.w	#8,$10(a0)

loc_3004A:
		jsr	(Create_New_Sprite3).l
		bne.w	loc_300C8
		move.l	#loc_301DE,(a1)
		move.l	$C(a0),$C(a1)
		move.b	#-$7C,4(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	($FFFFFE04).w,d0
		jsr	(Random_Number).l
		move.w	d0,d1
		andi.w	#$F,d0
		lsl.w	#3,d0
		subi.w	#$50,d0
		add.w	d0,$10(a1)
		addi.w	#$18,$14(a1)
		move.w	#$4530,$A(a1)
		lsr.w	#4,d1
		andi.w	#3,d1
		bne.s	loc_300A6
		move.w	#$45C,$A(a1)

loc_300A6:
		move.b	d1,$20(a1)
		move.w	#$380,8(a1)
		move.b	#$18,7(a1)
		move.b	#$18,6(a1)
		move.w	#$400,$18(a1)
		move.w	#0,$1A(a1)

loc_300C8:
		lea	$18(a0),a2
		move.w	$10(a0),(a2)+
		move.w	$14(a0),(a2)+
		tst.b	4(a0)
		bmi.s	loc_30100
		clr.b	($FFFFF650).w
		move.w	#-$1D,d0
		jsr	(Play_Sound_2).l
		move.w	#-$1C,d0
		jsr	(Play_Sound_2).l
		move.w	#$96,$30(a0)
		move.l	#loc_30106,(a0)
		rts
; ---------------------------------------------------------------------------

loc_30100:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_30106:

		subq.w	#1,$30(a0)
		bmi.s	loc_3010E
		rts
; ---------------------------------------------------------------------------

loc_3010E:
		jsr	(LoadEnemyArt).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_3011A:

		subq.b	#1,$24(a0)
		bpl.s	loc_30130
		move.b	#2,$24(a0)
		addq.b	#1,$22(a0)
		andi.b	#7,$22(a0)

loc_30130:
		jsr	(MoveSprite2).l
		addi.w	#$38,$1A(a0)
		move.w	($FFFFF646).w,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_301A2
		move.w	#0,$1A(a0)
		asr	$18(a0)
		asr	$18(a0)
		move.l	#loc_301A8,(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_301A2
		move.l	#loc_3023E,(a1)
		move.l	#Map_HCZWaterWall,$C(a1)
		move.w	#$2530,$A(a1)
		move.b	#-$7C,4(a1)

loc_3017E:
		move.w	$10(a0),$10(a1)
		move.w	($FFFFF646).w,$14(a1)
		move.w	#$200,8(a1)
		move.b	#$18,7(a1)
		move.b	#$18,6(a1)
		move.b	#8,$20(a1)

loc_301A2:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_301A8:
		subq.b	#1,$24(a0)
		bpl.s	loc_301BE
		move.b	#9,$24(a0)
		addq.b	#1,$22(a0)
		andi.b	#7,$22(a0)

loc_301BE:
		jsr	(MoveSprite2).l
		addi.w	#8,$1A(a0)
		tst.b	4(a0)
		bpl.w	loc_301D8
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_301D8:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_301DE:
		jsr	(MoveSprite2).l
		addi.w	#$28,$1A(a0)
		move.w	($FFFFF646).w,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_30202
		move.w	d0,$14(a0)
		move.l	#loc_3021C,(a0)
		addq.b	#4,$20(a0)

loc_30202:
		tst.b	4(a0)
		bpl.w	loc_301D8
		lea	(Ani_HCZWaterWall).l,a1
		jsr	(Animate_Sprite).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_3021C:
		tst.b	4(a0)
		bpl.w	loc_301D8
		lea	(Ani_HCZWaterWall).l,a1
		jsr	(Animate_Sprite).l
		tst.b	5(a0)
		bne.w	loc_301D8
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_3023E:
		tst.b	4(a0)
		bpl.w	loc_301D8
		lea	(Ani_HCZWaterWall).l,a1
		jsr	(Animate_SpriteIrregularDelay).l
		tst.b	5(a0)
		bne.w	loc_301D8
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Ani_HCZWaterWall:	include "Levels\HCZ\Misc Object Data\Anim - Water Wall.asm"

; ---------------------------------------------------------------------------

loc_30294:
		move.w	($FFFFB010).w,d0
		addi.w	#$30,d0
		sub.w	$10(a0),d0
		cmpi.w	#$60,d0
		bcc.s	loc_302B8
		move.w	($FFFFB014).w,d0
		addi.w	#$40,d0
		sub.w	$14(a0),d0
		cmpi.w	#$10,d0
		bcs.s	loc_302BE

loc_302B8:
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_302BE:
		lea	(ArtKosM_HCZGeyserVert).l,a1
		move.w	#-$6000,d2
		jsr	(Queue_Kos_Module).l
		move.b	#1,$22(a0)
		move.b	#-$7F,($FFFFB02E).w
		move.b	#-$7F,($FFFFB078).w
		move.l	#loc_302E6,(a0)

loc_302E6:
		tst.b	($FFFFFF60).w
		beq.s	loc_302FA
		subi.w	#8,($FFFFB014).w
		subi.w	#8,($FFFFB05E).w
		rts
; ---------------------------------------------------------------------------

loc_302FA:
		ori.b	#4,4(a0)
		move.w	#$300,8(a0)
		move.l	#Map_HCZWaterWall,$C(a0)
		move.w	#$4500,$A(a0)
		move.b	#$20,7(a0)
		move.b	#$60,6(a0)
		move.w	#$60,$30(a0)
		move.b	#$1C,($FFFFB020).w
		move.b	#$1C,($FFFFB06A).w
		move.l	#loc_30338,(a0)

loc_30338:
		tst.w	$30(a0)
		beq.s	loc_30346
		subq.w	#1,$30(a0)
		subq.w	#8,$14(a0)

loc_30346:
		subi.w	#8,($FFFFB014).w
		subi.w	#8,($FFFFB05E).w
		cmpi.w	#$28,$30(a0)
		bhi.w	locret_303E8
		move.b	#$1A,($FFFFB020).w
		move.b	#$1A,($FFFFB06A).w
		move.l	#loc_3041A,(a0)
		moveq	#$57,d0
		jsr	(Play_Sound_2).l
		move.b	#1,($FFFFF650).w
		lea	(byte_303EA).l,a3
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		subi.w	#$80,d3
		moveq	#7,d1

loc_30390:
		jsr	(Create_New_Sprite3).l
		bne.s	locret_303E8
		move.l	#loc_3011A,(a1)
		move.l	#Map_HCZWaterWallDebris,$C(a1)
		move.w	#$4558,$A(a1)
		move.b	#-$7C,4(a1)
		move.b	(a3)+,d0
		ext.w	d0
		add.w	d2,d0
		move.w	d0,$10(a1)
		move.b	(a3)+,d0
		ext.w	d0
		add.w	d3,d0
		move.w	d0,$14(a1)
		move.w	#$280,8(a1)
		move.b	#$18,7(a1)
		move.b	#$18,6(a1)
		move.w	(a3)+,$18(a1)
		move.w	(a3)+,$1A(a1)
		move.b	d1,$22(a1)

loc_303E4:
		dbf	d1,loc_30390

locret_303E8:

		rts
; ---------------------------------------------------------------------------
byte_303EA:	dc.b $E8

		dc.b 0
		dc.w $FE00
		dc.w $F500
		dc.b $F8
		dc.b 0
		dc.w $FF00
		dc.w $F400
		dc.b $E8
		dc.b 0
		dc.w $FC00
		dc.w $F800
		dc.b $F8
		dc.b 0
		dc.w $FD00
		dc.w $F600
		dc.b 8
		dc.b 0
word_30404:	dc.w $300
		dc.w $F400
		dc.b $18
		dc.b 0
		dc.w $400
word_3040C:	dc.w $F500
		dc.b 8
		dc.b 0
		dc.w $100
		dc.w $F600
		dc.b $18
		dc.b 0
		dc.w $200
		dc.w $F800
; ---------------------------------------------------------------------------

loc_3041A:
		tst.w	$30(a0)
		beq.s	loc_30470
		move.w	#-$A00,$1A(a0)
		subq.w	#1,$30(a0)

loc_3042A:
		bne.s	loc_30470
		move.l	#loc_3052A,(a0)
		lea	($FFFFB000).w,a1
		move.b	#0,$2E(a1)
		move.w	#0,$18(a1)
		move.w	#-$C00,$1A(a1)
		move.b	#0,$40(a1)
		lea	($FFFFB04A).w,a1
		move.b	#0,$2E(a1)
		move.w	#0,$18(a1)
		move.w	#-$C00,$1A(a1)
		move.b	#0,$40(a1)
		move.w	#-$800,$1A(a0)

loc_30470:

		subi.w	#$A,($FFFFB014).w
		subi.w	#$A,($FFFFB05E).w
		jsr	(MoveSprite2).l
		addi.w	#$48,$1A(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_304D4
		jsr	(Random_Number).l
		move.w	d0,d1
		move.w	d0,d2
		bsr.s	sub_304DA
		addi.w	#$10,$10(a1)
		andi.w	#$F,d1
		lsl.w	#6,d1
		move.w	d1,$18(a1)
		move.w	#-$700,$1A(a1)
		move.w	d0,d2
		jsr	(Create_New_Sprite3).l
		bne.w	loc_304D4
		bsr.s	sub_304DA
		subi.w	#$10,$10(a1)
		neg.w	d1
		move.w	d1,$18(a1)
		move.w	#-$700,$1A(a1)

loc_304D4:

		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_304DA:

		move.l	#loc_301DE,(a1)
		move.l	$C(a0),$C(a1)
		move.b	#-$7C,4(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		subi.w	#$50,$14(a1)
		move.w	#$380,8(a1)

loc_30504:
		move.b	#$18,7(a1)
		move.b	#$18,6(a1)
		move.w	#$4530,$A(a1)
		lsr.w	#4,d2
		andi.w	#3,d2
		bne.s	loc_30524
		move.w	#$45C,$A(a1)

loc_30524:
		move.b	d2,$20(a1)
		rts
; End of function sub_304DA

; ---------------------------------------------------------------------------

loc_3052A:
		tst.b	4(a0)
		bmi.s	loc_3056E
		move.w	#-$1C,d0
		jsr	(Play_Sound_2).l
		move.w	#-$1D,d0
		jsr	(Play_Sound_2).l
		move.w	#-$1C,d0
		jsr	(Play_Sound_2).l
		move.b	#0,($FFFFF650).w
		move.w	$48(a0),d0
		beq.s	loc_30560
		movea.w	d0,a2
		bclr	#7,(a2)

loc_30560:
		move.w	#$1E,$30(a0)
		move.l	#loc_30106,(a0)
		rts
; ---------------------------------------------------------------------------

loc_3056E:
		jsr	(MoveSprite2).l
		addi.w	#$48,$1A(a0)
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_HCZCGZFan:

		tst.w	($FFFFFFE8).w
		bne.w	loc_309CC
		movea.l	a0,a1
		tst.b	$2C(a0)
		bpl.s	loc_30602
		jsr	(Create_New_Sprite3).l
		bne.w	locret_3064C
		move.l	#loc_30850,(a0)
		move.w	$10(a0),$10(a1)
		move.w	$10(a0),$40(a0)
		move.w	$14(a0),$14(a1)
		addi.w	#$1C,$14(a0)
		move.l	#Map_HCZWaterRushBlock,$C(a0)
		move.w	#$43D4,$A(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.w	a1,$3C(a0)
		move.b	$2C(a0),d0

loc_305E6:
		andi.w	#$30,d0
		add.w	d0,d0
		move.w	d0,$3A(a0)
		move.b	$2C(a0),$2C(a1)
		bclr	#5,$2C(a1)
		bset	#4,$2C(a1)

loc_30602:
		move.l	#Map_HCZFan,$C(a1)
		move.w	#$240B,$A(a1)
		ori.b	#4,4(a1)
		move.w	#$200,8(a1)
		move.b	#$10,7(a1)
		move.b	#$C,6(a1)
		move.w	$10(a1),$40(a1)
		move.b	$2C(a1),d0
		andi.w	#$F,d0
		addq.w	#8,d0
		lsl.w	#4,d0
		move.w	d0,$36(a1)
		addi.w	#$30,d0
		move.w	d0,$38(a1)
		move.l	#loc_3064E,(a1)

locret_3064C:
		rts
; ---------------------------------------------------------------------------

loc_3064E:
		move.b	$2C(a0),d0
		btst	#5,d0
		beq.s	loc_3066C
		tst.b	($FFFFF7E0).w
		beq.w	loc_30774
		bclr	#5,$2C(a0)
		bset	#4,$2C(a0)

loc_3066C:
		tst.b	$42(a0)
		bne.s	loc_306A2
		btst	#4,$2C(a0)
		bne.s	loc_306C2
		subq.w	#1,$30(a0)
		bpl.s	loc_3069A
		move.w	#0,$34(a0)
		move.w	#$78,$30(a0)

loc_3068C:
		bchg	#0,$32(a0)
		beq.s	loc_3069A
		move.w	#$B4,$30(a0)

loc_3069A:

		tst.b	$32(a0)
		beq.w	loc_306C2

loc_306A2:
		subq.b	#1,$24(a0)
		bpl.w	loc_30774
		cmpi.w	#$400,$34(a0)
		bcc.w	loc_30774
		addi.w	#$2A,$34(a0)
		move.b	$34(a0),$24(a0)
		bra.s	loc_306E0
; ---------------------------------------------------------------------------

loc_306C2:

		lea	($FFFFB000).w,a1
		bsr.w	loc_3077E
		lea	($FFFFB04A).w,a1
		bsr.w	loc_3077E
		subq.b	#1,$24(a0)
		bpl.w	loc_306F2
		move.b	#0,$24(a0)

loc_306E0:
		addq.b	#1,$22(a0)
		cmpi.b	#5,$22(a0)
		bcs.s	loc_306F2
		move.b	#0,$22(a0)

loc_306F2:

		tst.b	4(a0)
		bpl.s	loc_3070C
		move.b	($FFFFFE05).w,d0
		addq.b	#1,d0
		andi.b	#$F,d0
		bne.s	loc_3070C
		moveq	#-$3F,d0
		jsr	(Play_Sound_2).l

loc_3070C:

		btst	#6,$2C(a0)
		beq.s	loc_30774
		move.b	($FFFFFE05).w,d0
		andi.b	#3,d0
		bne.s	loc_30774
		jsr	(Create_New_Sprite).l
		bne.s	loc_30774
		move.l	#loc_30834,(a1)
		move.l	#Map_Bubbler,$C(a1)
		move.w	#$45C,$A(a1)
		move.b	#-$7C,4(a1)
		move.b	#4,7(a1)
		move.b	#4,7(a1)
		move.w	#$300,8(a1)
		move.w	$10(a0),$10(a1)
		jsr	(Random_Number).l
		andi.w	#$F,d0
		subq.w	#8,d0
		add.w	d0,$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	#-$800,$1A(a1)

loc_30774:

		move.w	$40(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_3077E:

		cmpi.b	#4,5(a1)
		bcc.w	locret_3081C
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$18,d0
		cmpi.w	#$30,d0
		bcc.w	locret_3081C
		moveq	#0,d1
		move.b	($FFFFFE84).w,d1
		add.w	$14(a1),d1
		add.w	$36(a0),d1
		sub.w	$14(a0),d1
		bcs.s	locret_3081C
		cmp.w	$38(a0),d1
		bcc.s	locret_3081C
		tst.b	$2E(a1)
		bne.s	loc_3081E
		sub.w	$36(a0),d1
		bcs.s	loc_307C6
		not.w	d1
		add.w	d1,d1

loc_307C6:
		add.w	$36(a0),d1
		neg.w	d1
		asr.w	#6,d1

loc_307CE:
		add.w	d1,$14(a1)
		bset	#1,$2A(a1)
		bclr	#4,$2A(a1)
		move.w	#0,$1A(a1)
		move.b	#0,$2F(a1)
		move.b	#0,$40(a1)
		btst	#6,$2C(a0)
		bne.s	loc_30826
		move.w	#1,$1C(a1)
		tst.b	$27(a1)
		bne.s	locret_3081C
		move.b	#1,$27(a1)

loc_3080A:
		move.b	#0,$20(a1)
		move.b	#$7F,$30(a1)
		move.b	#8,$31(a1)

locret_3081C:

		rts
; ---------------------------------------------------------------------------

loc_3081E:
		move.w	#1,$1C(a1)
		rts
; ---------------------------------------------------------------------------

loc_30826:
		move.w	#1,$1C(a1)
		move.b	#$F,$20(a1)
		rts
; ---------------------------------------------------------------------------

loc_30834:
		move.w	($FFFFF646).w,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_3084A
		jsr	(MoveSprite2).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_3084A:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_30850:
		movea.w	$3C(a0),a1
		move.w	($FFFFB014).w,d0
		sub.w	$14(a0),d0
		bcs.s	loc_3088E
		cmpi.w	#$20,d0
		blt.s	loc_308B8
		tst.b	$42(a1)
		bne.s	loc_3087E
		move.b	#1,$42(a1)
		move.w	#0,$34(a1)
		moveq	#$58,d0
		jsr	(Play_Sound_2).l

loc_3087E:
		move.w	$3A(a0),d1
		cmp.w	$30(a0),d1
		beq.s	loc_308B8
		addq.w	#8,$30(a0)
		bra.s	loc_308B8
; ---------------------------------------------------------------------------

loc_3088E:
		cmpi.w	#-$30,d0
		bge.s	loc_308B8
		tst.b	$42(a1)
		beq.s	loc_308AE
		move.b	#0,$42(a1)
		move.b	#0,$24(a1)
		moveq	#$58,d0
		jsr	(Play_Sound_2).l

loc_308AE:
		tst.w	$30(a0)
		beq.s	loc_308B8
		subq.w	#8,$30(a0)

loc_308B8:

		move.w	$30(a0),d0
		btst	#0,$2A(a0)
		beq.s	loc_308C6
		neg.w	d0

loc_308C6:
		add.w	$40(a0),d0
		move.w	d0,$10(a0)
		move.w	d0,$10(a1)
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		move.w	$40(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

Obj_HCZLargeFan:

		move.w	($FFFFB010).w,d0
		subi.w	#$20,d0
		cmp.w	$10(a0),d0
		bcs.s	loc_3091A
		move.w	($FFFFB014).w,d0
		subi.w	#$20,d0
		sub.w	$14(a0),d0
		cmpi.w	#$40,d0
		bcs.s	loc_30926

loc_3091A:
		move.b	#3,($FFFFF7C7).w
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_30926:
		lea	(ArtKosM_HCZLargeFan).l,a1
		move.w	#-$6000,d2
		jsr	(Queue_Kos_Module).l
		move.l	#loc_3093C,(a0)

loc_3093C:
		tst.b	($FFFFFF60).w
		beq.s	loc_30944
		rts
; ---------------------------------------------------------------------------

loc_30944:
		ori.b	#4,4(a0)
		move.w	#$200,8(a0)

loc_30950:
		move.l	#Map_HCZLargeFan,$C(a0)
		move.w	#$2500,$A(a0)
		move.b	#$18,7(a0)
		move.b	#$20,6(a0)
		move.w	#8,$30(a0)
		moveq	#$58,d0
		jsr	(Play_Sound_2).l
		move.l	#loc_3097E,(a0)

loc_3097E:
		tst.w	$30(a0)
		beq.s	loc_30994
		addq.w	#8,$14(a0)
		subq.w	#1,$30(a0)
		bne.s	loc_30994
		move.b	#0,($FFFFF7C7).w

loc_30994:

		move.b	($FFFFFE05).w,d0
		andi.b	#$F,d0
		bne.s	loc_309A6
		moveq	#-$40,d0
		jsr	(Play_Sound_2).l

loc_309A6:
		subq.b	#1,$24(a0)
		bpl.w	loc_309C6
		move.b	#0,$24(a0)
		addq.b	#1,$22(a0)
		cmpi.b	#5,$22(a0)
		bcs.s	loc_309C6
		move.b	#0,$22(a0)

loc_309C6:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_309CC:
		move.l	#Map_CGZFan,$C(a0)
		move.w	#$6300,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$200,8(a0)
		move.b	#$10,7(a0)
		move.b	#4,6(a0)
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		addq.w	#8,d0
		lsl.w	#4,d0
		move.w	d0,$36(a0)
		addi.w	#$30,d0
		move.w	d0,$38(a0)
		move.l	#loc_30A10,(a0)

loc_30A10:
		lea	($FFFFB000).w,a1
		bsr.w	sub_30A38
		lea	($FFFFB04A).w,a1
		bsr.w	sub_30A38
		addq.b	#1,$22(a0)
		cmpi.b	#3,$22(a0)
		bcs.s	loc_30A32
		move.b	#0,$22(a0)

loc_30A32:
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_30A38:

		cmpi.b	#4,5(a1)
		bcc.w	locret_30ACE
		tst.b	$2E(a1)
		bne.w	locret_30ACE
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$14,d0
		cmpi.w	#$28,d0
		bcc.s	locret_30ACE
		moveq	#0,d1
		move.b	($FFFFFE84).w,d1
		add.w	$14(a1),d1

loc_30A66:
		add.w	$36(a0),d1
		sub.w	$14(a0),d1
		bcs.s	locret_30ACE
		cmp.w	$38(a0),d1
		bcc.s	locret_30ACE
		sub.w	$36(a0),d1
		bcs.s	loc_30A80
		not.w	d1
		add.w	d1,d1

loc_30A80:
		add.w	$36(a0),d1
		neg.w	d1
		asr.w	#6,d1
		add.w	d1,$14(a1)
		bset	#1,$2A(a1)
		bclr	#4,$2A(a1)
		move.w	#0,$1A(a1)
		move.b	#0,$2F(a1)
		move.b	#0,$40(a1)
		move.w	#1,$1C(a1)
		tst.b	$27(a1)
		bne.s	locret_30ACE
		move.b	#1,$27(a1)
		move.b	#0,$20(a1)
		move.b	#$7F,$30(a1)
		move.b	#8,$31(a1)

locret_30ACE:
		rts
; End of function sub_30A38

; ---------------------------------------------------------------------------

Obj_HCZHandLauncher:

		ori.b	#4,4(a0)
		move.w	#$200,8(a0)
		move.l	#Map_HCZHandLauncher,$C(a0)
		move.w	#$23E4,$A(a0)
		move.b	#$20,7(a0)
		move.b	#$40,6(a0)
		move.w	$14(a0),$32(a0)
		move.b	#6,$22(a0)
		move.w	#$50,$30(a0)
		bset	#7,$2A(a0)

loc_30B0E:
		jsr	(Create_New_Sprite3).l
		bne.s	loc_30B52
		move.l	#loc_30DEC,(a1)
		move.l	#Map_HCZHandLauncher,$C(a1)
		move.w	#$23E4,$A(a1)
		move.b	4(a0),4(a1)
		move.b	#$20,7(a1)
		move.b	#$30,7(a1)
		move.w	#$280,8(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	a0,$3C(a1)

loc_30B52:
		move.l	#loc_30B58,(a0)

loc_30B58:

		move.w	$10(a0),d1
		subi.w	#$20,d1
		move.w	($FFFFB010).w,d0
		sub.w	d1,d0
		cmpi.w	#$40,d0
		bcs.s	loc_30B78
		move.w	($FFFFB05A).w,d0
		sub.w	d1,d0
		cmpi.w	#$40,d0
		bcc.s	loc_30BD6

loc_30B78:
		tst.b	$34(a0)
		beq.s	loc_30BB0
		move.b	#7,$22(a0)
		move.w	#$80,8(a0)
		tst.w	$36(a0)
		beq.s	loc_30B96
		subq.w	#1,$36(a0)
		bra.s	loc_30BD0
; ---------------------------------------------------------------------------

loc_30B96:
		tst.w	$30(a0)
		beq.s	loc_30BA2
		subq.w	#8,$30(a0)
		bra.s	loc_30BD0
; ---------------------------------------------------------------------------

loc_30BA2:
		move.l	#loc_30C06,(a0)
		move.w	#$3B,$36(a0)
		bra.s	loc_30BD0
; ---------------------------------------------------------------------------

loc_30BB0:
		move.w	#$13,$36(a0)
		move.b	#6,$22(a0)
		move.w	#$200,8(a0)
		cmpi.w	#$18,$30(a0)
		bls.s	loc_30BD0
		subq.w	#8,$30(a0)
		bra.s	loc_30BE2
; ---------------------------------------------------------------------------

loc_30BD0:

		bsr.w	sub_30CE0
		bra.s	loc_30BE2
; ---------------------------------------------------------------------------

loc_30BD6:
		cmpi.w	#$50,$30(a0)
		beq.s	loc_30BE2
		addq.w	#8,$30(a0)

loc_30BE2:

		move.w	$30(a0),d0
		add.w	$32(a0),d0
		move.w	d0,$14(a0)
		move.w	#$20,d1
		move.w	#$11,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_30C06:
		tst.w	$36(a0)
		beq.s	loc_30C16
		subq.w	#1,$36(a0)
		bsr.w	sub_30CE0
		bra.s	loc_30C50
; ---------------------------------------------------------------------------

loc_30C16:
		cmpi.w	#$50,$30(a0)
		bne.s	loc_30C34
		move.b	#0,$34(a0)
		move.l	#loc_30B58,(a0)
		moveq	#-$4A,d0
		jsr	(Play_Sound_2).l
		bra.s	loc_30C50
; ---------------------------------------------------------------------------

loc_30C34:
		cmpi.w	#$18,$30(a0)
		bne.s	loc_30C4C
		bsr.w	sub_30C7C
		move.b	#6,$22(a0)
		move.w	#$200,8(a0)

loc_30C4C:
		addq.w	#8,$30(a0)

loc_30C50:

		move.w	$30(a0),d0
		add.w	$32(a0),d0
		move.w	d0,$14(a0)
		cmpi.w	#$18,$30(a0)
		bhi.s	loc_30C76
		move.w	#$20,d1
		move.w	#$11,d3

loc_30C6C:
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l

loc_30C76:
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_30C7C:
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.w	sub_30C8C
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
; End of function sub_30C7C


; =============== S U B R O U T I N E =======================================


sub_30C8C:
		bclr	d6,$35(a0)
		beq.s	loc_30CCC
		move.w	#$1000,$1C(a1)
		move.w	#$1000,$18(a1)
		move.w	#0,$1A(a1)
		btst	#0,$2A(a0)
		beq.s	loc_30CB4

loc_30CAC:
		neg.w	$1C(a1)
		neg.w	$18(a1)

loc_30CB4:
		move.b	#0,$20(a1)
		move.b	#0,$2E(a1)
		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		rts
; ---------------------------------------------------------------------------

loc_30CCC:
		bclr	d6,$2A(a0)
		beq.s	locret_30CDE
		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)

locret_30CDE:
		rts
; End of function sub_30C8C


; =============== S U B R O U T I N E =======================================


sub_30CE0:

		lea	($FFFFB000).w,a1
		moveq	#3,d6
		move.b	($FFFFF603).w,d0
		bsr.w	sub_30CF8
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		move.b	($FFFFF66B).w,d0
; End of function sub_30CE0


; =============== S U B R O U T I N E =======================================


sub_30CF8:
		btst	d6,$35(a0)
		beq.s	loc_30D4E
		andi.b	#$70,d0
		beq.s	locret_30D4C
		bclr	d6,$35(a0)
		bclr	d6,$2A(a0)
		move.w	#$800,$1C(a1)
		move.w	#$800,$18(a1)
		move.w	#-$400,$1A(a1)
		btst	#0,$2A(a0)
		beq.s	loc_30D2E
		neg.w	$1C(a1)
		neg.w	$18(a1)

loc_30D2E:
		move.b	#0,$2E(a1)
		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)
		tst.b	$35(a0)
		bne.s	locret_30D4C
		move.b	#0,$34(a0)

locret_30D4C:

		rts
; ---------------------------------------------------------------------------

loc_30D4E:
		btst	d6,$2A(a0)
		beq.w	locret_30DEA
		tst.b	$34(a0)
		bne.s	loc_30D6E
		move.w	$10(a1),d0
		addi.w	#8,d0
		sub.w	$10(a0),d0
		cmpi.w	#$10,d0
		bcc.s	locret_30DEA

loc_30D6E:
		tst.b	$2E(a1)
		bne.s	locret_30DEA
		tst.w	($FFFFFE08).w
		bne.s	locret_30DEA
		bset	d6,$35(a0)
		moveq	#$3C,d0
		jsr	(Play_Sound_2).l
		move.b	#0,$20(a1)
		move.b	#$13,$1E(a1)
		move.b	#9,$1F(a1)
		bclr	#2,$2A(a1)
		cmpi.l	#Obj_Tails,(a1)
		bne.s	loc_30DAC
		move.b	#$F,$1E(a1)

loc_30DAC:
		move.b	#1,$2E(a1)
		bclr	#5,$2A(a1)
		move.w	$10(a0),$10(a1)
		subq.w	#2,$10(a1)
		move.w	#$1000,$1C(a1)
		bclr	#0,$2A(a1)
		btst	#0,$2A(a0)
		beq.s	loc_30DE4
		addq.w	#4,$10(a1)
		neg.w	$1C(a1)
		bset	#0,$2A(a1)

loc_30DE4:
		move.b	#1,$34(a0)

locret_30DEA:

		rts
; End of function sub_30CF8

; ---------------------------------------------------------------------------

loc_30DEC:
		movea.w	$3C(a0),a1
		move.w	$14(a1),$14(a0)
		cmpi.w	#$18,$30(a1)
		bls.s	loc_30E00
		rts
; ---------------------------------------------------------------------------

loc_30E00:
		addq.b	#1,$22(a0)
		cmpi.b	#6,$22(a0)
		bcs.s	loc_30E12
		move.b	#0,$22(a0)

loc_30E12:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
byte_30E18:	dc.b $10
		dc.b $20
		dc.w $43D4
		dc.b 8
		dc.b $20
		dc.w $4416
		dc.b $10
		dc.b $20
		dc.w $236B
; ---------------------------------------------------------------------------

Obj_Door:

		moveq	#0,d0
		move.b	$2C(a0),d0
		bmi.w	loc_30FD2
		move.b	d0,$22(a0)
		add.w	d0,d0
		add.w	d0,d0
		lea	byte_30E18(pc,d0.w),a1
		move.b	(a1)+,7(a0)
		move.b	(a1)+,6(a0)
		move.w	(a1)+,$A(a0)
		move.l	#Map_HCZCNZDEZDoor,$C(a0)
		ori.b	#4,4(a0)
		move.w	#$300,8(a0)
		move.w	$14(a0),$32(a0)
		move.w	$10(a0),d2
		move.w	d2,d3
		subi.w	#$200,d2
		addi.w	#$18,d3
		btst	#0,$2A(a0)
		beq.s	loc_30E7E
		subi.w	#-$1E8,d2
		addi.w	#$1E8,d3

loc_30E7E:
		move.w	d2,$34(a0)
		move.w	d3,$36(a0)
		move.l	#loc_30E8C,(a0)

loc_30E8C:
		btst	#0,$2A(a0)
		bne.s	loc_30EA8
		move.w	$34(a0),d2
		move.w	$10(a0),d3
		tst.b	$38(a0)
		beq.s	loc_30EBA
		move.w	$36(a0),d3
		bra.s	loc_30EBA
; ---------------------------------------------------------------------------

loc_30EA8:
		move.w	$10(a0),d2

loc_30EAC:
		move.w	$36(a0),d3
		tst.b	$38(a0)
		beq.s	loc_30EBA
		move.w	$34(a0),d2

loc_30EBA:

		move.w	$32(a0),d4
		move.w	d4,d5
		subi.w	#$20,d4
		addi.w	#$20,d5
		move.b	#0,$38(a0)
		lea	($FFFFB000).w,a1
		bsr.w	sub_30F58
		lea	($FFFFB04A).w,a1
		bsr.s	sub_30F58
		tst.b	$38(a0)
		beq.s	loc_30F0A
		cmpi.w	#$40,$30(a0)
		beq.s	loc_30F34
		addq.w	#8,$30(a0)
		cmpi.w	#$40,$30(a0)
		bne.s	loc_30F28
		moveq	#$58,d0
		cmpi.b	#$B,($FFFFFE10).w
		bne.s	loc_30F02
		moveq	#$58,d0

loc_30F02:
		jsr	(Play_Sound_2).l
		bra.s	loc_30F28
; ---------------------------------------------------------------------------

loc_30F0A:
		tst.w	$30(a0)
		beq.s	loc_30F34
		subq.w	#8,$30(a0)
		bne.s	loc_30F28
		moveq	#$58,d0
		cmpi.b	#$B,($FFFFFE10).w
		bne.s	loc_30F22
		moveq	#$58,d0

loc_30F22:
		jsr	(Play_Sound_2).l

loc_30F28:

		move.w	$32(a0),d0
		sub.w	$30(a0),d0
		move.w	d0,$14(a0)

loc_30F34:

		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_30F58:

		move.w	$10(a1),d0
		cmp.w	d2,d0
		blt.w	locret_30F84
		cmp.w	d3,d0
		bcc.w	locret_30F84
		move.w	$14(a1),d0
		cmp.w	d4,d0
		bcs.w	locret_30F84
		cmp.w	d5,d0
		bcc.w	locret_30F84
		tst.b	$2E(a1)
		bmi.s	locret_30F84
		move.b	#1,$38(a0)

locret_30F84:
		rts
; End of function sub_30F58

; ---------------------------------------------------------------------------
Map_HCZCNZDEZDoor:include "Levels\HCZ\Misc Object Data\Map - (&CNZ &DEZ) Door.asm"

byte_30FCE:	dc.b $20
		dc.b 8
		dc.w $4416
; ---------------------------------------------------------------------------

loc_30FD2:
		andi.w	#$7F,d0
		move.b	d0,$22(a0)
		add.w	d0,d0
		add.w	d0,d0
		lea	byte_30FCE(pc,d0.w),a1
		move.b	(a1)+,7(a0)
		move.b	(a1)+,6(a0)
		move.w	(a1)+,$A(a0)
		move.l	#Map_CNZDoorHorizontal,$C(a0)
		ori.b	#4,4(a0)
		move.w	#$200,8(a0)
		move.w	$10(a0),$32(a0)

loc_31008:
		move.w	$14(a0),d2
		move.w	d2,d3

loc_3100E:
		subi.w	#$100,d2

loc_31012:
		addi.w	#$18,d3

loc_31016:
		btst	#1,$2A(a0)
		beq.s	loc_31026
		subi.w	#-$E8,d2
		addi.w	#$E8,d3

loc_31026:
		move.w	d2,$34(a0)
		move.w	d3,$36(a0)
		move.l	#loc_31034,(a0)

loc_31034:
		btst	#1,$2A(a0)
		bne.s	loc_31050
		move.w	$34(a0),d2
		move.w	$14(a0),d3
		tst.b	$38(a0)
		beq.s	loc_31062
		move.w	$36(a0),d3
		bra.s	loc_31062
; ---------------------------------------------------------------------------

loc_31050:
		move.w	$14(a0),d2
		move.w	$36(a0),d3
		tst.b	$38(a0)
		beq.s	loc_31062
		move.w	$34(a0),d2

loc_31062:

		move.w	$32(a0),d4
		move.w	d4,d5
		subi.w	#$20,d4
		addi.w	#$20,d5

loc_31070:
		move.b	#0,$38(a0)
		lea	($FFFFB000).w,a1
		bsr.s	sub_310DA
		lea	($FFFFB04A).w,a1
		bsr.s	sub_310DA
		tst.b	$38(a0)
		beq.s	loc_31096
		cmpi.w	#$40,$30(a0)
		beq.s	loc_310B6
		addq.w	#8,$30(a0)
		bra.s	loc_310A0
; ---------------------------------------------------------------------------

loc_31096:
		tst.w	$30(a0)
		beq.s	loc_310B6
		subq.w	#8,$30(a0)

loc_310A0:
		move.w	$30(a0),d0
		btst	#0,$2A(a0)
		beq.s	loc_310AE
		neg.w	d0

loc_310AE:
		add.w	$32(a0),d0

loc_310B2:
		move.w	d0,$10(a0)

loc_310B6:

		moveq	#0,d1
		move.b	7(a0),d1

loc_310BC:
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l

loc_310D4:
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_310DA:

		move.w	$14(a1),d0
		cmp.w	d2,d0
		blt.w	locret_31106

loc_310E4:
		cmp.w	d3,d0
		bcc.w	locret_31106
		move.w	$10(a1),d0
		cmp.w	d4,d0
		bcs.w	locret_31106
		cmp.w	d5,d0
		bcc.w	locret_31106
		tst.b	$2E(a1)
		bmi.s	locret_31106
		move.b	#1,$38(a0)

locret_31106:
		rts
; End of function sub_310DA

; ---------------------------------------------------------------------------
Map_CNZDoorHorizontal:include "Levels\CNZ\Misc Object Data\Map - Door Horizontal.asm"

word_31124:	dc.w   $B28,  $CD8
		dc.w   $BA8,  $CD8
		dc.w   $BA8,  $CD8
		dc.w   $EA8, $1058
		dc.w  $11A8, $12D8
		dc.w  $1928, $19D8
		dc.w  $21A8, $2358
		dc.w  $21A8, $2358
		dc.w  $22A8, $2458
		dc.w  $23A8, $2558
		dc.w  $2528, $26D8
		dc.w  $26A8, $27D8
		dc.w  $26A8, $2958
		dc.w  $2728, $28D8
		dc.w  $3328, $3458
		dc.w  $3328, $33D8
; ---------------------------------------------------------------------------

Obj_HCZConveyorBelt:
		lea	($FFFFCFE0).w,a1
		moveq	#0,d0
		move.b	$2C(a0),d0
		tst.b	(a1,d0.w)
		beq.s	loc_31186
		move.w	$48(a0),d0
		beq.s	loc_31180
		movea.w	d0,a2
		bclr	#7,(a2)

loc_31180:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_31186:
		move.b	#1,(a1,d0.w)
		andi.w	#$F,d0
		lsl.w	#2,d0
		lea	word_31124(pc,d0.w),a1
		move.w	(a1)+,d0
		move.w	d0,$3C(a0)
		btst	#0,$2A(a0)
		bne.s	loc_311A6
		subq.w	#8,d0

loc_311A6:
		move.w	d0,$40(a0)
		move.w	(a1)+,d0
		move.w	d0,$3E(a0)
		btst	#0,$2A(a0)
		beq.s	loc_311BA
		addq.w	#8,d0

loc_311BA:
		move.w	d0,$42(a0)
		move.l	#loc_311C4,(a0)

loc_311C4:
		lea	$32(a0),a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF602).w,d1

loc_311D0:
		moveq	#0,d2
		bsr.s	sub_31226
		addq.w	#1,a2
		lea	($FFFFB04A).w,a1
		move.w	($FFFFF66A).w,d1
		moveq	#1,d2
		bsr.s	sub_31226
		move.w	($FFFFF7DA).w,d1
		move.w	$3C(a0),d0
		andi.w	#-$80,d0

loc_311EE:
		subi.w	#$280,d0
		cmp.w	d0,d1
		bcs.s	loc_31204
		move.w	$3E(a0),d0
		andi.w	#-$80,d0
		cmp.w	d0,d1
		bhi.s	loc_31204
		rts
; ---------------------------------------------------------------------------

loc_31204:

		lea	($FFFFCFE0).w,a1
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.b	#0,(a1,d0.w)
		move.w	$48(a0),d0
		beq.s	loc_31220
		movea.w	d0,a2
		bclr	#7,(a2)

loc_31220:
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_31226:

		tst.b	(a2)
		beq.w	loc_31322
		tst.w	($FFFFFE08).w
		bne.w	loc_312D4
		cmpi.b	#4,5(a1)
		bcc.w	loc_312D4

loc_3123E:
		btst	#$A,d1
		beq.s	loc_31260
		subq.w	#1,$10(a1)
		subq.b	#1,6(a2)
		bpl.s	loc_31260
		move.b	#7,6(a2)
		addi.b	#$10,8(a2)
		andi.b	#$10,8(a2)

loc_31260:

		btst	#$B,d1
		beq.s	loc_31282
		addq.w	#1,$10(a1)
		subq.b	#1,6(a2)
		bpl.s	loc_31282
		move.b	#7,6(a2)
		addi.b	#$10,8(a2)

loc_3127C:
		andi.b	#$10,8(a2)

loc_31282:

		andi.w	#$70,d1
		bne.w	loc_312C0
		moveq	#2,d0
		btst	#0,$2A(a0)
		beq.s	loc_31296
		neg.w	d0

loc_31296:
		add.w	d0,$10(a1)
		move.w	$10(a1),d0
		cmp.w	$40(a0),d0
		bcs.s	loc_312D4
		cmp.w	$42(a0),d0
		bcc.s	loc_312D4
		bsr.w	sub_3145A
		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2
		rts
; ---------------------------------------------------------------------------

loc_312C0:
		move.w	#-$500,$1A(a1)
		btst	#6,$2A(a1)
		beq.s	loc_312D4
		move.w	#-$200,$1A(a1)

loc_312D4:

		clr.b	(a2)
		move.b	#$3C,2(a2)
		btst	#6,$2A(a1)
		beq.s	loc_312EA
		move.b	#$5A,2(a2)

loc_312EA:
		andi.b	#-4,$2E(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)

loc_312FC:
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)

loc_31308:
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$27(a1)
		rts
; ---------------------------------------------------------------------------

loc_31322:
		tst.b	2(a2)
		beq.s	loc_3132E
		subq.b	#1,2(a2)
		rts
; ---------------------------------------------------------------------------

loc_3132E:
		move.w	$10(a1),d0
		cmp.w	$40(a0),d0
		bcs.w	locret_313D4
		cmp.w	$42(a0),d0
		bcc.w	locret_313D4
		cmpi.w	#1,$1C(a1)
		beq.w	loc_313D6
		move.w	$14(a0),d0
		addi.w	#$14,d0
		cmp.w	$14(a1),d0
		bcc.s	locret_313D4
		addi.w	#$10,d0
		cmp.w	$14(a1),d0
		bcs.s	locret_313D4
		tst.w	($FFFFFE08).w
		bne.s	locret_313D4
		cmpi.b	#4,5(a1)
		bcc.s	locret_313D4

loc_31372:
		tst.b	$2E(a1)
		bne.s	locret_313D4
		tst.w	$1A(a1)
		bmi.s	locret_313D4
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		andi.b	#-4,4(a1)
		move.w	$14(a0),d0
		addi.w	#$14,d0
		move.w	d0,$14(a1)
		move.b	#0,$20(a1)
		move.b	#3,$2E(a1)
		move.b	#$63,$22(a1)
		move.b	#0,4(a2)
		move.b	#0,6(a2)

loc_313BA:
		move.b	#0,8(a2)
		move.b	#1,(a2)
		moveq	#0,d0

loc_313C6:
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2

locret_313D4:

		rts
; ---------------------------------------------------------------------------

loc_313D6:
		move.w	$14(a0),d0
		subi.w	#$14,d0
		cmp.w	$14(a1),d0
		bcc.s	locret_313D4
		addi.w	#$10,d0
		cmp.w	$14(a1),d0
		bcs.s	locret_313D4
		tst.w	($FFFFFE08).w
		bne.s	locret_313D4
		cmpi.b	#4,5(a1)
		bcc.s	locret_313D4
		tst.b	$2E(a1)
		bne.s	locret_313D4
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		andi.b	#-4,4(a1)
		move.w	$14(a0),d0
		subi.w	#$14,d0
		move.w	d0,$14(a1)
		move.b	#0,$20(a1)
		move.b	#3,$2E(a1)
		move.b	#$65,$22(a1)
		move.b	#-$80,4(a2)
		move.b	#0,6(a2)

loc_3143E:
		move.b	#0,8(a2)
		move.b	#1,(a2)
		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2
		rts
; End of function sub_31226


; =============== S U B R O U T I N E =======================================


sub_3145A:
		tst.w	$1C(a1)
		bne.s	loc_31480
		move.b	4(a2),d0
		beq.s	loc_3147E
		bpl.s	loc_31472
		addi.b	#6,d0
		bcc.s	loc_31470
		moveq	#0,d0

loc_31470:
		bra.s	loc_3147A
; ---------------------------------------------------------------------------

loc_31472:
		subi.b	#6,d0
		bcc.s	loc_3147A
		moveq	#0,d0

loc_3147A:

		move.b	d0,4(a2)

loc_3147E:
		bra.s	loc_314AA
; ---------------------------------------------------------------------------

loc_31480:
		clr.w	$1C(a1)
		move.b	4(a2),d0
		subi.b	#-$80,d0
		beq.s	loc_314AA
		bpl.s	loc_3149A
		addi.b	#6,d0
		bcc.s	loc_31498
		moveq	#0,d0

loc_31498:
		bra.s	loc_314A2
; ---------------------------------------------------------------------------

loc_3149A:
		subi.b	#6,d0
		bcc.s	loc_314A2
		moveq	#0,d0

loc_314A2:

		addi.b	#-$80,d0
		move.b	d0,4(a2)

loc_314AA:

		moveq	#0,d0
		move.b	4(a2),d0
		lsr.b	#4,d0
		add.b	8(a2),d0
		move.b	byte_314D2(pc,d0.w),d1
		move.b	d1,$22(a1)
		andi.w	#$F,d0
		move.b	byte_314F2(pc,d0.w),d1
		ext.w	d1
		add.w	$14(a0),d1
		move.w	d1,$14(a1)
		rts
; End of function sub_3145A

; ---------------------------------------------------------------------------
byte_314D2:	dc.b  $94, $63, $64, $64, $65, $65, $65, $66, $66, $66, $66, $67, $67, $67, $68, $68, $95, $63, $64, $64
		dc.b  $65, $65, $65, $66, $66, $66, $66, $67, $67, $67, $68, $68
byte_314F2:	dc.b  $14, $14,	 $B,  $B, $F1, $F1, $F1, $EC, $EC, $EC,	$EC, $F4, $F4, $F4, $FE, $FE
; ---------------------------------------------------------------------------

Obj_HCZConveryorSpike:

		moveq	#0,d0
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lsl.w	#2,d0
		lea	word_31124(pc),a1
		lea	(a1,d0.w),a1
		move.w	(a1)+,$3C(a0)
		move.w	(a1)+,$3E(a0)
		move.l	#Map_HCZConveyorSpike,$C(a0)
		move.w	#$243E,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#$C,7(a0)
		move.b	#$C,6(a0)
		move.b	#-$75,$28(a0)
		move.w	$10(a0),$30(a0)

loc_31550:
		move.w	$14(a0),$32(a0)
		btst	#0,$2A(a0)
		beq.s	loc_3156E

loc_3155E:
		addi.w	#$18,$14(a0)
		move.l	#loc_315D2,(a0)
		bra.w	loc_315D2
; ---------------------------------------------------------------------------

loc_3156E:
		subi.w	#$18,$14(a0)
		move.w	#$40,$26(a0)
		move.l	#loc_31580,(a0)

loc_31580:

		addq.w	#2,$10(a0)
		move.w	$10(a0),d0
		cmp.w	$3E(a0),d0
		bne.s	loc_3159A
		move.l	#loc_3159E,(a0)

loc_31594:
		move.w	$10(a0),$30(a0)

loc_3159A:
		bra.w	loc_31626
; ---------------------------------------------------------------------------

loc_3159E:
		subq.w	#2,$26(a0)
		andi.w	#$7E,$26(a0)
		move.w	$26(a0),d0
		bne.s	loc_315B4
		move.l	#loc_315D2,(a0)

loc_315B4:
		lea	word_31664(pc),a1
		move.w	(a1,d0.w),d1
		move.w	$20(a1,d0.w),d2
		add.w	$30(a0),d1
		add.w	$32(a0),d2
		move.w	d1,$10(a0)
		move.w	d2,$14(a0)
		bra.s	loc_31626
; ---------------------------------------------------------------------------

loc_315D2:

		subq.w	#2,$10(a0)
		move.w	$10(a0),d0
		cmp.w	$3C(a0),d0
		bne.s	loc_315EC
		move.l	#loc_315EE,(a0)
		move.w	$10(a0),$30(a0)

loc_315EC:
		bra.s	loc_31626
; ---------------------------------------------------------------------------

loc_315EE:
		subq.w	#2,$26(a0)
		andi.w	#$7E,$26(a0)
		move.w	$26(a0),d0
		cmpi.w	#$40,$26(a0)
		bne.s	loc_3160A
		move.l	#loc_31580,(a0)

loc_3160A:
		lea	word_31664(pc),a1
		move.w	(a1,d0.w),d1
		move.w	$20(a1,d0.w),d2
		add.w	$30(a0),d1
		add.w	$32(a0),d2
		move.w	d1,$10(a0)
		move.w	d2,$14(a0)

loc_31626:

		move.w	($FFFFF7DA).w,d1

loc_3162A:
		move.w	$3C(a0),d0
		andi.w	#-$80,d0
		subi.w	#$280,d0
		cmp.w	d0,d1
		bcs.s	loc_31652
		move.w	$3E(a0),d0
		andi.w	#-$80,d0
		cmp.w	d0,d1
		bhi.s	loc_31652
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_31652:

		move.w	$48(a0),d0
		beq.s	loc_3165E
		movea.w	d0,a2

loc_3165A:
		bclr	#7,(a2)

loc_3165E:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
word_31664:	dc.w 0

		dc.w 2
		dc.w 4
		dc.w 6
		dc.w 9
		dc.w $B
		dc.w $D
		dc.w $F
		dc.w $10
		dc.w $12
		dc.w $13
		dc.w $15
		dc.w $16
		dc.w $16
		dc.w $17
		dc.w $17
		dc.w $18
		dc.w $17
		dc.w $17
		dc.w $16
		dc.w $16
		dc.w $15
		dc.w $13
		dc.w $12
		dc.w $10
		dc.w $F
		dc.w $D
		dc.w $B
		dc.w 9
		dc.w 6
		dc.w 4
		dc.w 2
		dc.w 0
		dc.w $FFFD
		dc.w $FFFB
		dc.w $FFF9
		dc.w $FFF6
		dc.w $FFF4
		dc.w $FFF2
		dc.w $FFF0
		dc.w $FFEF
		dc.w $FFED
		dc.w $FFEC
		dc.w $FFEA
		dc.w $FFE9
		dc.w $FFE9
		dc.w $FFE8
		dc.w $FFE8
		dc.w $FFE8
		dc.w $FFE8
		dc.w $FFE8
		dc.w $FFE9
		dc.w $FFE9
		dc.w $FFEA
		dc.w $FFEC
		dc.w $FFED
		dc.w $FFEF
		dc.w $FFF0
		dc.w $FFF2
		dc.w $FFF4
		dc.w $FFF6
		dc.w $FFF9
		dc.w $FFFB
		dc.w $FFFD
word_316E4:	dc.w 0
		dc.w 2
		dc.w 4
		dc.w 6
		dc.w 9
		dc.w $B
		dc.w $D
		dc.w $F
		dc.w $10
		dc.w $12
		dc.w $13
		dc.w $15
		dc.w $16
		dc.w $16
		dc.w $17
		dc.w $17
; ---------------------------------------------------------------------------

Obj_CNZBalloon:

		move.l	#Map_CNZBalloon,$C(a0)
		move.w	#$351,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#$10,7(a0)
		move.b	#$20,6(a0)
		move.b	#-$29,$28(a0)
		move.w	$14(a0),$32(a0)
		move.b	$2C(a0),d0
		add.b	d0,d0
		andi.b	#$E,d0
		move.b	d0,$20(a0)
		jsr	(Random_Number).l

loc_3174A:
		move.b	d0,$26(a0)
		move.l	#loc_31754,(a0)

loc_31754:
		tst.b	$29(a0)
		beq.s	loc_31776
		lea	($FFFFB000).w,a1
		bclr	#0,$29(a0)
		beq.s	loc_31768
		bsr.s	sub_317AE

loc_31768:
		lea	($FFFFB04A).w,a1
		bclr	#1,$29(a0)
		beq.s	loc_31776
		bsr.s	sub_317AE

loc_31776:

		lea	(Ani_CNZBalloon).l,a1
		jsr	(Animate_Sprite).l
		tst.b	(Vectors+5).w
		beq.s	loc_3178E
		move.w	#$7F00,$10(a0)

loc_3178E:
		moveq	#0,d0
		move.b	$26(a0),d0
		addq.b	#1,$26(a0)
		jsr	(GetSineCosine).l
		asr.w	#5,d0
		add.w	$32(a0),d0
		move.w	d0,$14(a0)
		jmp	(loc_1B662).l

; =============== S U B R O U T I N E =======================================


sub_317AE:

		move.w	#-$700,$1A(a1)
		bset	#1,$2A(a1)
		bclr	#4,$2A(a1)

loc_317C0:
		bclr	#5,$2A(a1)
		clr.b	$40(a1)
		move.b	#0,$2E(a1)
		bset	#0,$20(a0)
		tst.b	$2C(a0)
		bpl.s	loc_31808
		move.w	#-$380,$1A(a1)
		tst.b	($FFFFF730).w
		beq.s	loc_31808
		tst.b	$34(a0)
		bne.s	loc_31808
		lea	(word_3185A).l,a2
		bsr.s	sub_3181E
		bsr.s	sub_3181E
		bsr.s	sub_3181E
		bsr.s	sub_3181E
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)

loc_31808:

		tst.b	$34(a0)
		bne.s	locret_3181C
		moveq	#$77,d0
		jsr	(Play_Sound_2).l
		move.b	#1,$34(a0)

locret_3181C:
		rts
; End of function sub_317AE


; =============== S U B R O U T I N E =======================================


sub_3181E:

		jsr	(Create_New_Sprite).l
		bne.s	locret_31858

loc_31826:
		move.l	#Obj_Bubbler,(a1)
		move.w	$10(a0),$10(a1)
		jsr	(Random_Number).l
		move.w	d0,d1
		andi.w	#$F,d0
		subq.w	#8,d0
		add.w	d0,$10(a1)
		move.w	$14(a0),$14(a1)
		andi.w	#$F,d1
		subq.w	#8,d1
		add.w	d1,$14(a1)
		move.b	(a2)+,$2C(a1)

locret_31858:
		rts
; End of function sub_3181E

; ---------------------------------------------------------------------------
word_3185A:	dc.w	  0,  $103
Ani_CNZBalloon:	include "Levels\CNZ\Misc Object Data\Anim - Balloon.asm"

; ---------------------------------------------------------------------------

Obj_CNZCannon:

		move.l	#Map_CNZCannon,$C(a0)
		move.w	#$4374,$A(a0)
		move.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#$30,7(a0)
		move.b	#$30,6(a0)
		move.b	#9,$22(a0)
		bset	#6,4(a0)
		move.w	#1,$16(a0)
		lea	$18(a0),a2
		move.w	$10(a0),(a2)+
		move.w	$14(a0),(a2)+
		move.w	#4,(a2)

loc_318EC:
		move.l	#loc_318F2,(a0)

loc_318F2:
		bsr.s	sub_3192C
		lea	$30(a0),a2
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		move.w	($FFFFF602).w,d1
		bsr.w	sub_319F4
		addq.w	#1,a2
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		move.w	($FFFFF66A).w,d1
		cmpi.w	#2,($FFFFF708).w
		bne.s	loc_3191E
		move.b	#0,(a2)

loc_3191E:
		bsr.w	sub_319F4
		bsr.w	sub_31B18
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_3192C:
		move.w	$34(a0),d0
		bne.s	loc_31944
		move.w	#$10,d1
		move.w	#$29,d3
		move.w	$10(a0),d4
		jmp	(SolidObjectTop).l
; ---------------------------------------------------------------------------

loc_31944:
		subq.w	#1,d0
		bne.s	loc_31974
		move.b	$26(a0),d0
		addq.b	#2,$26(a0)
		jsr	(GetSineCosine).l
		addi.w	#$120,d0
		lsr.w	#6,d0
		move.b	d0,$1D(a0)
		move.b	($FFFFFE05).w,d0
		andi.b	#$1F,d0
		bne.s	locret_31972
		moveq	#-$39,d0
		jsr	(Play_Sound_2).l

locret_31972:
		rts
; ---------------------------------------------------------------------------

loc_31974:
		subq.w	#1,d0
		bne.s	loc_319CE
		subq.w	#1,$36(a0)
		bpl.s	loc_31984

loc_3197E:
		move.w	#3,$34(a0)

loc_31984:
		move.b	($FFFFFE05).w,d0
		andi.b	#3,d0
		bne.s	locret_319CC
		jsr	(Create_New_Sprite3).l
		bne.w	locret_319CC
		move.l	#Obj_FireShield_Dissipate,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		subi.w	#$18,$14(a1)
		move.b	$1D(a0),d0

loc_319B4:
		lsl.b	#4,d0
		addi.b	#-$80,d0
		jsr	(GetSineCosine).l
		asl.w	#3,d1
		asl.w	#3,d0

loc_319C4:
		move.w	d1,$18(a1)
		move.w	d0,$1A(a1)

locret_319CC:

		rts
; ---------------------------------------------------------------------------

loc_319CE:
		move.b	$26(a0),d0
		addq.b	#2,$26(a0)
		jsr	(GetSineCosine).l
		addi.w	#$120,d0
		lsr.w	#6,d0

loc_319E2:
		move.b	d0,$1D(a0)
		cmpi.b	#4,d0
		bne.s	locret_319F2
		move.w	#0,$34(a0)

locret_319F2:
		rts
; End of function sub_3192C


; =============== S U B R O U T I N E =======================================


sub_319F4:

		move.b	(a2),d0
		bne.s	loc_31A4C
		bclr	d6,$2A(a0)
		beq.s	locret_31A4A
		bclr	#3,$2A(a1)
		move.w	$10(a0),$10(a1)
		move.w	#$380,8(a1)
		move.w	#0,$18(a1)
		move.w	#0,$1A(a1)
		move.w	#0,$1C(a1)
		move.b	#-$7F,$2E(a1)
		bset	#2,$2A(a1)
		bset	#1,$2A(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		move.b	#1,(a2)

locret_31A4A:
		rts
; ---------------------------------------------------------------------------

loc_31A4C:
		subq.b	#1,d0
		bne.s	loc_31A7C
		move.w	$1A(a1),d0
		addi.w	#$38,$1A(a1)
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$14(a1)
		move.w	$14(a0),d0
		cmp.w	$14(a1),d0
		bcc.s	locret_31A7A
		move.w	d0,$14(a1)
		move.b	#$1C,$20(a1)
		move.b	#2,(a2)

locret_31A7A:
		rts
; ---------------------------------------------------------------------------

loc_31A7C:
		subq.b	#1,d0
		bne.w	loc_31B06
		cmpi.w	#2,$34(a0)
		beq.s	loc_31AA6
		cmpi.w	#$200,$30(a0)
		beq.s	loc_31A9A
		cmpi.w	#$202,$30(a0)
		bne.s	loc_31AA0

loc_31A9A:
		move.w	#1,$34(a0)

loc_31AA0:
		andi.w	#$70,d1
		beq.s	locret_31B04

loc_31AA6:
		move.b	$1D(a0),d0
		lsl.b	#4,d0
		addi.b	#-$80,d0
		jsr	(GetSineCosine).l
		asl.w	#4,d1
		asl.w	#4,d0
		move.w	d1,$18(a1)
		move.w	d0,$1A(a1)
		move.w	d1,$1C(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		subi.w	#$18,$14(a1)
		move.b	#0,$2E(a1)
		bset	#1,$2A(a1)
		clr.b	$40(a1)
		move.b	#2,$20(a1)

loc_31AEE:
		move.w	#2,$34(a0)
		move.w	#$F,$36(a0)
		move.b	#3,(a2)

loc_31AFE:
		move.b	#8,2(a2)

locret_31B04:
		rts
; ---------------------------------------------------------------------------

loc_31B06:
		subq.b	#1,2(a2)
		bne.s	locret_31B16
		move.w	#$100,8(a1)
		move.b	#0,(a2)

locret_31B16:
		rts
; End of function sub_319F4


; =============== S U B R O U T I N E =======================================


sub_31B18:
		tst.b	4(a0)
		bpl.s	locret_31B70
		moveq	#0,d0
		move.b	$1D(a0),d0
		cmp.b	$2E(a0),d0
		beq.s	locret_31B70
		move.b	d0,$2E(a0)
		lea	(DPLC_CNZCannon).l,a2
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d5
		subq.w	#1,d5
		bmi.s	locret_31B70
		move.w	#-$7700,d4

loc_31B44:
		moveq	#0,d1
		move.w	(a2)+,d1
		move.w	d1,d3
		lsr.w	#8,d3
		andi.w	#$F0,d3
		addi.w	#$10,d3
		andi.w	#$FFF,d1
		lsl.l	#5,d1
		addi.l	#ArtUnc_CNZCannon,d1
		move.w	d4,d2
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		dbf	d5,loc_31B44

locret_31B70:

		rts
; End of function sub_31B18

; ---------------------------------------------------------------------------
DPLC_CNZCannon:	include "General\Sprites\CNZ Cannon\DPLC - CNZ Cannon.asm"

; ---------------------------------------------------------------------------

Obj_CNZRisingPlatform:

		move.l	#Map_CNZRisingPlatform,$C(a0)
		move.w	#$43BE,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#$30,7(a0)
		move.b	#$10,6(a0)
		move.b	#6,$1E(a0)
		move.l	#loc_31BD0,(a0)

loc_31BD0:
		bsr.s	sub_31C0A

loc_31BD2:
		move.w	#$30,d1
		move.w	#$11,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		lea	(Ani_CNZRisingPlatform).l,a1
		jsr	(Animate_Sprite).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
Ani_CNZRisingPlatform:	include "Levels\CNZ\Misc Object Data\Anim - Rising Platform.asm"


; =============== S U B R O U T I N E =======================================


sub_31C0A:
		move.b	$30(a0),d0
		bne.s	loc_31C4C
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	loc_31C26
		move.b	#1,$30(a0)
		move.w	#$100,$20(a0)

loc_31C26:
		tst.w	$1A(a0)
		beq.s	locret_31C4A
		jsr	(MoveSprite2).l
		addi.w	#8,$1A(a0)
		tst.w	$1A(a0)
		bmi.s	locret_31C4A
		move.w	#0,$1A(a0)
		move.w	#$200,$20(a0)

locret_31C4A:

		rts
; ---------------------------------------------------------------------------

loc_31C4C:
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	loc_31C86
		jsr	(MoveSprite2).l
		cmpi.w	#$200,$1A(a0)
		bge.s	loc_31C6A

loc_31C64:
		addi.w	#$18,$1A(a0)

loc_31C6A:
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	locret_31C84
		add.w	d1,$14(a0)
		move.l	#loc_31BD2,(a0)
		move.w	#$200,$20(a0)

locret_31C84:
		rts
; ---------------------------------------------------------------------------

loc_31C86:
		neg.w	$1A(a0)
		subi.w	#$80,$1A(a0)
		move.b	#0,$30(a0)
		moveq	#$75,d0
		jmp	(Play_Sound_2).l
; End of function sub_31C0A

; ---------------------------------------------------------------------------

Obj_CNZTrapDoor:

		move.l	#Map_CNZTrapDoor,$C(a0)
		move.w	#$43F0,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$80,8(a0)
		move.b	#$20,7(a0)
		move.b	#8,6(a0)
		move.l	#loc_31CCA,(a0)

loc_31CCA:
		lea	($FFFFB000).w,a1
		bsr.s	sub_31CFA
		lea	($FFFFB04A).w,a1
		bsr.s	sub_31CFA
		move.w	#$20,d1
		move.w	#9,d3
		move.w	$10(a0),d4

loc_31CE2:
		jsr	(SolidObjectTop).l
		lea	(Ani_CNZTrapDoor).l,a1
		jsr	(Animate_Sprite).l
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_31CFA:

		move.w	$10(a0),d0
		sub.w	$10(a1),d0
		addi.w	#$20,d0
		cmpi.w	#$40,d0
		bcc.s	locret_31D2C
		move.w	$14(a0),d0
		sub.w	$14(a1),d0
		addi.w	#$20,d0
		cmpi.w	#$20,d0
		bcc.s	locret_31D2C
		move.b	#1,$20(a0)
		moveq	#$76,d0
		jsr	(Play_Sound_2).l

locret_31D2C:

		rts
; End of function sub_31CFA

; ---------------------------------------------------------------------------
Ani_CNZTrapDoor:	include "Levels\CNZ\Misc Object Data\Anim - Trap Door.asm"

; ---------------------------------------------------------------------------

Obj_CNZLightBulb:

		move.l	#Map_CNZLightBulb,$C(a0)
		move.w	#$4404,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)

loc_31D60:
		tst.b	($FFFFF730).w
		bne.s	loc_31D6E
		move.l	#loc_31D8A,(a0)
		bra.s	loc_31D8A
; ---------------------------------------------------------------------------

loc_31D6E:
		move.l	#loc_31D74,(a0)

loc_31D74:
		move.w	($FFFFF646).w,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_31D8A
		move.b	#1,$22(a0)
		move.l	#loc_31D8A,(a0)

loc_31D8A:


		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_CNZHoverFan:

		move.l	#Map_CNZHoverFan,$C(a0)
		move.w	#$43E8,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	$10(a0),$30(a0)
		move.b	$2C(a0),d0
		move.b	d0,d1
		andi.w	#$F,d0
		addq.w	#4,d0
		lsl.w	#4,d0
		move.w	d0,$36(a0)
		addi.w	#$30,d0
		move.w	d0,$38(a0)
		andi.w	#$70,d1
		addi.w	#$18,d1
		move.w	d1,$32(a0)
		add.w	d1,d1
		move.w	d1,$34(a0)
		move.b	$2C(a0),d0
		bmi.s	loc_31DF8
		move.l	#loc_31E68,(a0)
		bra.w	loc_31E68
; ---------------------------------------------------------------------------

loc_31DF8:
		andi.w	#$70,d0
		move.w	d0,d1
		lsr.w	#4,d0
		move.b	d0,$22(a0)
		addi.b	#$10,d1
		move.b	d1,7(a0)
		btst	#0,$2A(a0)
		bne.s	loc_31E1E
		move.l	#loc_31E36,(a0)
		bra.w	loc_31E36
; ---------------------------------------------------------------------------

loc_31E1E:
		move.l	#loc_31E24,(a0)

loc_31E24:
		moveq	#0,d0
		move.b	($FFFFFE7C).w,d0
		subi.w	#$30,d0
		add.w	$30(a0),d0
		move.w	d0,$10(a0)

loc_31E36:

		moveq	#0,d6
		lea	($FFFFB000).w,a1
		bsr.w	sub_31E96
		lea	($FFFFB04A).w,a1
		bsr.w	sub_31E96
		tst.w	d6
		beq.s	loc_31E5E
		move.b	($FFFFFE05).w,d0
		andi.b	#$1F,d0
		bne.s	loc_31E5E
		moveq	#$72,d0
		jsr	(Play_Sound_2).l

loc_31E5E:

		move.w	$30(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_31E68:

		moveq	#0,d6
		lea	($FFFFB000).w,a1
		bsr.w	sub_31E96
		lea	($FFFFB04A).w,a1
		bsr.w	sub_31E96
		tst.w	d6
		beq.s	loc_31E90
		move.b	($FFFFFE05).w,d0
		andi.b	#$1F,d0
		bne.s	loc_31E90
		moveq	#$72,d0
		jsr	(Play_Sound_2).l

loc_31E90:

		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_31E96:

		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	$32(a0),d0
		cmp.w	$34(a0),d0
		bcc.w	locret_31F2E
		moveq	#0,d1
		move.b	($FFFFFE84).w,d1
		add.w	$14(a1),d1
		add.w	$36(a0),d1
		sub.w	$14(a0),d1
		bcs.s	locret_31F2E
		cmp.w	$38(a0),d1
		bcc.s	locret_31F2E
		cmpi.b	#4,5(a1)
		bcc.w	locret_31F2E
		tst.b	$2E(a1)
		bne.s	locret_31F2E
		sub.w	$36(a0),d1
		bcs.s	loc_31EDE
		not.w	d1
		add.w	d1,d1

loc_31EDE:
		add.w	$36(a0),d1
		neg.w	d1
		asr.w	#4,d1
		add.w	d1,$14(a1)
		bset	#1,$2A(a1)
		bclr	#4,$2A(a1)
		move.w	#0,$1A(a1)
		move.b	#0,$2F(a1)
		move.b	#0,$40(a1)
		moveq	#1,d6
		move.w	#1,$1C(a1)
		tst.b	$27(a1)
		bne.s	locret_31F2E
		move.b	#1,$27(a1)
		move.b	#0,$20(a1)
		move.b	#$7F,$30(a1)
		move.b	#8,$31(a1)

locret_31F2E:

		rts
; End of function sub_31E96

; ---------------------------------------------------------------------------

Obj_48_1:

		move.b	$2C(a0),d0
		beq.s	loc_31F46
		add.b	d0,d0
		move.b	d0,$34(a0)
		move.l	#loc_31FF4,(a0)
		bra.w	loc_31FF4
; ---------------------------------------------------------------------------

loc_31F46:
		move.l	#loc_31F4C,(a0)

loc_31F4C:
		lea	($FFFFB000).w,a1
		bsr.w	sub_31F62
		lea	($FFFFB04A).w,a1
		bsr.w	sub_31F62
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_31F62:

		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		btst	#0,$2A(a0)
		bne.s	loc_31F74
		neg.w	d0

loc_31F74:
		addi.w	#$50,d0
		cmpi.w	#$A0,d0
		bcc.s	locret_31FF2
		move.w	$14(a1),d1
		addi.w	#$20,d1
		sub.w	$14(a0),d1
		bcs.s	locret_31FF2
		cmpi.w	#$40,d1
		bcc.s	locret_31FF2
		cmpi.b	#4,5(a1)
		bcc.s	locret_31FF2
		tst.b	$2E(a1)
		bne.s	locret_31FF2
		subi.w	#$50,d0
		bcc.s	loc_31FC2
		not.w	d0
		move.w	#$1000,$1C(a1)
		btst	#0,$2A(a0)
		bne.s	loc_31FBA
		neg.w	$1C(a1)

loc_31FBA:
		move.w	$1C(a1),$18(a1)
		rts
; ---------------------------------------------------------------------------

loc_31FC2:
		add.w	d0,d0
		addi.w	#$60,d0
		btst	#0,$2A(a0)
		bne.s	loc_31FD2
		neg.w	d0

loc_31FD2:
		neg.b	d0
		asr.w	#4,d0
		add.w	d0,$10(a1)
		move.w	$36(a0),d0
		bne.s	loc_31FE8
		moveq	#$74,d0
		jsr	(Play_Sound_2).l

loc_31FE8:
		addq.w	#1,$36(a0)
		andi.w	#$1F,$36(a0)

locret_31FF2:

		rts
; End of function sub_31F62

; ---------------------------------------------------------------------------

loc_31FF4:

		lea	$30(a0),a2
		lea	($FFFFB000).w,a1
		bsr.w	sub_32010
		addq.w	#1,a2
		lea	($FFFFB04A).w,a1
		bsr.w	sub_32010
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_32010:

		move.b	(a2),d0
		bne.w	loc_3209C
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$18,d0
		cmpi.w	#$30,d0
		bcc.s	locret_3209A

loc_32028:
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		addi.w	#$30,d1
		cmpi.w	#$50,d1
		bcc.s	locret_3209A
		cmpi.b	#4,5(a1)
		bcc.s	locret_3209A
		tst.b	$2E(a1)
		bne.s	locret_3209A
		subi.w	#$50,d1
		neg.w	d1
		cmpi.w	#$40,d1
		bcs.s	loc_3206A
		move.b	#1,(a2)
		move.b	$34(a0),2(a2)
		move.w	d0,-(sp)
		moveq	#$73,d0
		jsr	(Play_Sound_2).l
		move.w	(sp)+,d0

loc_3206A:
		asr.w	#2,d1
		cmpi.b	#1,$38(a1)
		beq.s	loc_32076
		asr.w	#1,d1

loc_32076:
		sub.w	d1,$14(a1)
		moveq	#1,d2
		cmpi.w	#$18,d0
		beq.s	loc_3208A
		bcs.s	loc_32086
		neg.w	d2

loc_32086:
		add.w	d2,$10(a1)

loc_3208A:
		bset	#1,$2A(a1)
		move.b	#$F,$20(a1)
		clr.b	$40(a1)

locret_3209A:

		rts
; ---------------------------------------------------------------------------

loc_3209C:
		subq.b	#1,d0
		bne.s	locret_320E0
		subq.b	#1,2(a2)
		beq.s	loc_320D4

loc_320A6:
		subi.w	#8,$14(a1)
		moveq	#1,d2
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		beq.s	loc_320C0
		bcs.s	loc_320BC
		neg.w	d2

loc_320BC:
		add.w	d2,$10(a1)

loc_320C0:
		move.w	#0,$18(a1)

loc_320C6:
		move.w	#0,$1C(a1)
		move.w	#0,$1A(a1)
		rts
; ---------------------------------------------------------------------------

loc_320D4:
		move.w	#-$800,$1A(a1)
		move.b	#0,(a2)
		rts
; ---------------------------------------------------------------------------

locret_320E0:
		rts
; End of function sub_32010

; ---------------------------------------------------------------------------
word_320E2:	dc.w $4E0
		dc.w $6F0
		dc.w $870
		dc.w $9C0
		dc.w $AE0
		dc.w $C00
		dc.w $CF0
		dc.w $DE0
; ---------------------------------------------------------------------------

Obj_CNZCylinder:

		cmpi.w	#$17E0,$10(a0)
		bne.s	loc_32108
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_32108

loc_32102:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_32108:

		move.b	$2C(a0),d0
		move.b	d0,d1
		lsr.b	#3,d1

loc_32110:
		andi.w	#$E,d1
		move.w	word_320E2(pc,d1.w),d1
		move.w	d1,$3E(a0)
		add.w	d0,d0
		andi.w	#$1E,d0
		move.w	d0,$3A(a0)
		move.l	#Map_CNZCylinder,$C(a0)
		move.w	#$438E,$A(a0)
		move.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#$20,7(a0)
		move.b	#$20,6(a0)
		move.w	$10(a0),$2E(a0)
		move.w	$14(a0),$30(a0)
		move.b	$2C(a0),d0
		move.b	d0,d1
		andi.b	#$F,d0
		subi.b	#$A,d0
		andi.b	#3,d0
		move.b	d0,$44(a0)
		andi.w	#$F0,d1
		lsl.w	#2,d1
		btst	#0,$2A(a0)
		beq.s	loc_3217E
		neg.w	d1

loc_3217E:
		move.w	d1,$46(a0)

loc_32182:
		move.l	#loc_32188,(a0)

loc_32188:
		bsr.s	sub_321E2
		lea	$32(a0),a2
		lea	($FFFFB000).w,a1
		moveq	#3,d6

loc_32194:
		move.w	($FFFFF602).w,d5
		bsr.w	sub_324C0
		addq.w	#4,a2
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		move.w	($FFFFF66A).w,d5
		bsr.w	sub_324C0
		move.w	#$2B,d1
		move.w	#$20,d2
		move.w	#$21,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		subq.b	#1,$24(a0)
		bpl.s	loc_321D8

loc_321C8:
		move.b	#1,$24(a0)
		addq.b	#1,$22(a0)
		andi.b	#3,$22(a0)

loc_321D8:
		move.w	$2E(a0),d0

loc_321DC:
		jmp	(Sprite_OnScreen_Test2).l

; =============== S U B R O U T I N E =======================================


sub_321E2:
		move.w	$3A(a0),d0
		move.w	off_321EE(pc,d0.w),d0
		jmp	off_321EE(pc,d0.w)
; End of function sub_321E2

; ---------------------------------------------------------------------------
off_321EE:	dc.w loc_32208-off_321EE

		dc.w loc_322F0-off_321EE
		dc.w loc_3230E-off_321EE
		dc.w loc_3232C-off_321EE
		dc.w loc_32350-off_321EE
		dc.w loc_3236E-off_321EE
		dc.w loc_3238C-off_321EE
		dc.w loc_323AA-off_321EE
		dc.w loc_323CE-off_321EE
		dc.w loc_323EC-off_321EE
		dc.w loc_323EC-off_321EE
		dc.w loc_323EC-off_321EE
		dc.w loc_323EC-off_321EE
; ---------------------------------------------------------------------------

loc_32208:
		move.w	$3C(a0),d1
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		cmp.w	d1,d0
		beq.s	loc_32254
		move.w	d0,$3C(a0)
		sub.w	d1,d0
		bcs.s	loc_32254
		move.w	$1A(a0),d0
		bpl.s	loc_32228
		neg.w	d0

loc_32228:
		cmpi.w	#$200,d0
		bcc.s	loc_32254
		move.w	$14(a0),d0
		sub.w	$30(a0),d0
		addi.w	#$40,d0
		cmpi.w	#$80,d0
		bcc.s	loc_32254
		addi.w	#$400,$1A(a0)
		move.w	$3E(a0),d0
		cmp.w	$1A(a0),d0
		bgt.s	loc_32254
		move.w	d0,$1A(a0)

loc_32254:

		jsr	(MoveSprite2).l
		moveq	#0,d5
		btst	#3,$2A(a0)
		beq.s	loc_32268
		move.b	($FFFFF602).w,d5

loc_32268:
		btst	#4,$2A(a0)
		beq.s	loc_32274
		or.b	($FFFFF66A).w,d5

loc_32274:
		move.w	$14(a0),d0
		sub.w	$30(a0),d0
		beq.s	loc_322DA
		bcc.s	loc_322AC
		move.w	$3E(a0),d0
		cmp.w	$1A(a0),d0
		ble.s	locret_322EE
		addi.w	#$20,$1A(a0)
		tst.w	$1A(a0)
		bmi.s	loc_322A4
		btst	#1,d5
		beq.s	loc_322AA
		addi.w	#$20,$1A(a0)
		bra.s	loc_322AA
; ---------------------------------------------------------------------------

loc_322A4:
		addi.w	#$10,$1A(a0)

loc_322AA:

		bra.s	locret_322EE
; ---------------------------------------------------------------------------

loc_322AC:
		move.w	$3E(a0),d0
		neg.w	d0
		cmp.w	$1A(a0),d0
		bge.s	locret_322EE
		subi.w	#$20,$1A(a0)
		tst.w	$1A(a0)
		bpl.s	loc_322D2
		btst	#0,d5
		beq.s	loc_322D8
		subi.w	#$20,$1A(a0)
		bra.s	loc_322D8
; ---------------------------------------------------------------------------

loc_322D2:
		subi.w	#$10,$1A(a0)

loc_322D8:

		bra.s	locret_322EE
; ---------------------------------------------------------------------------

loc_322DA:
		move.w	$1A(a0),d0
		bpl.s	loc_322E2
		neg.w	d0

loc_322E2:
		cmpi.w	#$80,d0
		bcc.s	locret_322EE
		move.w	#0,$1A(a0)

locret_322EE:

		rts
; ---------------------------------------------------------------------------

loc_322F0:
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#3,d0
		add.w	$2E(a0),d0
		move.w	d0,$10(a0)
		move.w	$46(a0),d0
		add.w	d0,$26(a0)
		rts
; ---------------------------------------------------------------------------

loc_3230E:
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#2,d0
		add.w	$2E(a0),d0
		move.w	d0,$10(a0)
		move.w	$46(a0),d0
		add.w	d0,$26(a0)
		rts
; ---------------------------------------------------------------------------

loc_3232C:
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#2,d0
		move.w	d0,d1
		asr.w	#1,d0
		add.w	d1,d0
		add.w	$2E(a0),d0
		move.w	d0,$10(a0)
		move.w	$46(a0),d0
		add.w	d0,$26(a0)
		rts
; ---------------------------------------------------------------------------

loc_32350:
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#1,d0
		add.w	$2E(a0),d0
		move.w	d0,$10(a0)
		move.w	$46(a0),d0
		add.w	d0,$26(a0)
		rts
; ---------------------------------------------------------------------------

loc_3236E:
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#3,d0
		add.w	$30(a0),d0
		move.w	d0,$14(a0)
		move.w	$46(a0),d0
		add.w	d0,$26(a0)
		rts
; ---------------------------------------------------------------------------

loc_3238C:
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#2,d0
		add.w	$30(a0),d0
		move.w	d0,$14(a0)
		move.w	$46(a0),d0
		add.w	d0,$26(a0)
		rts
; ---------------------------------------------------------------------------

loc_323AA:
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#2,d0
		move.w	d0,d1
		asr.w	#1,d0
		add.w	d1,d0
		add.w	$30(a0),d0
		move.w	d0,$14(a0)
		move.w	$46(a0),d0
		add.w	d0,$26(a0)
		rts
; ---------------------------------------------------------------------------

loc_323CE:
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#1,d0
		add.w	$30(a0),d0
		move.w	d0,$14(a0)
		move.w	$46(a0),d0
		add.w	d0,$26(a0)
		rts
; ---------------------------------------------------------------------------

loc_323EC:
		move.w	$46(a0),d0
		bpl.s	loc_3242E
		add.w	d0,$26(a0)
		move.b	$26(a0),d0
		cmpi.b	#-$80,d0
		bcc.s	loc_32416
		andi.b	#$7F,d0
		addi.b	#-$80,d0
		move.b	d0,$26(a0)
		subq.b	#1,$44(a0)
		andi.b	#3,$44(a0)

loc_32416:
		move.w	#$20,d2
		move.b	$26(a0),d0
		cmpi.b	#-$80,d0
		bcc.s	loc_32456
		move.b	#-$80,d0
		move.b	d0,$26(a0)
		bra.s	loc_32456
; ---------------------------------------------------------------------------

loc_3242E:
		add.w	d0,$26(a0)
		move.b	$26(a0),d0
		cmpi.b	#-$80,d0
		bcc.s	loc_32452
		andi.b	#$7F,d0
		addi.b	#-$80,d0
		move.b	d0,$26(a0)
		addq.b	#1,$44(a0)
		andi.b	#3,$44(a0)

loc_32452:
		move.w	#$20,d2

loc_32456:

		jsr	(GetSineCosine).l
		asr.w	#3,d1
		move.b	$44(a0),d3
		andi.b	#3,d3
		bne.s	loc_3247C
		add.w	$2E(a0),d1
		move.w	d1,$10(a0)
		neg.w	d2
		add.w	$30(a0),d2
		move.w	d2,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_3247C:
		subq.b	#1,d3
		bne.s	loc_32492
		add.w	$30(a0),d1
		move.w	d1,$14(a0)
		add.w	$2E(a0),d2
		move.w	d2,$10(a0)
		rts
; ---------------------------------------------------------------------------

loc_32492:
		subq.b	#1,d3
		bne.s	loc_324AA
		neg.w	d1
		add.w	$2E(a0),d1
		move.w	d1,$10(a0)
		add.w	$30(a0),d2
		move.w	d2,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_324AA:
		neg.w	d1
		add.w	$30(a0),d1
		move.w	d1,$14(a0)
		neg.w	d2
		add.w	$2E(a0),d2
		move.w	d2,$10(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_324C0:

		move.b	(a2),d0
		bne.s	loc_32538
		btst	d6,$2A(a0)
		beq.s	locret_32536
		move.b	#0,1(a2)
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		bpl.s	loc_324E2
		neg.w	d0
		move.b	#-$80,1(a2)

loc_324E2:
		move.b	d0,2(a2)
		move.w	#0,$18(a1)
		move.w	#0,$1A(a1)
		move.w	#0,$1C(a1)
		move.b	#3,$2E(a1)

loc_324FE:
		move.b	$44(a1),$1E(a1)
		move.b	$45(a1),$1F(a1)

loc_3250A:
		bclr	#2,$2A(a1)
		bclr	#1,$2A(a1)
		bclr	#5,$2A(a1)

loc_3251C:
		bclr	#4,$2A(a1)
		move.b	#0,$40(a1)
		move.b	#0,$20(a1)
		move.b	#1,(a2)
		bra.w	loc_3260A
; ---------------------------------------------------------------------------

locret_32536:
		rts
; ---------------------------------------------------------------------------

loc_32538:
		tst.b	4(a1)
		bpl.w	loc_325F2
		cmpi.b	#4,5(a1)
		bcc.w	loc_325F2
		btst	d6,$2A(a0)
		beq.w	loc_32604
		moveq	#0,d0
		move.b	1(a2),d0
		jsr	(GetSineCosine).l
		addi.w	#$100,d0
		asr.w	#2,d0
		move.b	d0,3(a2)
		moveq	#0,d2

loc_3256A:
		move.w	2(a2),d2
		muls.w	d2,d1

loc_32570:
		swap	d1
		add.w	$10(a0),d1
		move.w	d1,$10(a1)
		addq.b	#2,1(a2)
		move.w	#$100,8(a1)
		move.b	$35(a0),d0

loc_32588:
		cmp.b	3(a2),d0
		bls.s	loc_32594
		move.w	#$80,8(a1)

loc_32594:
		move.w	#0,$1C(a1)
		move.w	$1A(a0),d0
		bpl.s	loc_325A2
		neg.w	d0

loc_325A2:
		btst	#1,$2A(a1)
		bne.s	loc_325B6
		cmpi.w	#$480,d0
		bcs.s	loc_325B6
		move.w	#$800,$1C(a1)

loc_325B6:

		andi.b	#$70,d5

loc_325BA:
		beq.s	loc_3260A
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		move.w	$1A(a0),$1A(a1)
		addi.w	#-$680,$1A(a1)
		move.w	#0,$18(a1)
		move.w	#0,$1C(a1)

loc_325F2:

		bset	#1,$2A(a1)
		move.w	#$100,8(a1)
		move.b	#0,$2E(a1)

loc_32604:
		move.b	#0,(a2)
		rts
; ---------------------------------------------------------------------------

loc_3260A:

		moveq	#0,d0
		move.b	1(a2),d0

loc_32610:					; Used by LBZ cup elevator
		addi.b	#$B,d0
		divu.w	#$16,d0
		move.b	PlayerTwistFrames(pc,d0.w),$22(a1)
		andi.b	#-4,4(a1)
		move.b	PlayerTwistFlip(pc,d0.w),d0
		or.b	d0,4(a1)
		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2
		rts
; End of function sub_324C0

; ---------------------------------------------------------------------------
PlayerTwistFrames:	dc.b $55
		dc.b $59
		dc.b $5A
		dc.b $5B
		dc.b $5A
		dc.b $59
		dc.b $55
		dc.b $56
		dc.b $57
		dc.b $58
		dc.b $57
		dc.b $56
PlayerTwistFlip:	dc.b 0
		dc.b 1
		dc.b 1
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 1
		dc.b 1
		dc.b 1
		dc.b 0
		dc.b 0
		dc.b 0
; ---------------------------------------------------------------------------

Obj_HCZSpinningColumn:

		move.l	#Map_HCZSpinningColumn,$C(a0)
		move.w	#$4040,$A(a0)
		move.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#$10,7(a0)
		move.b	#$20,6(a0)
		move.w	$10(a0),$2E(a0)
		move.w	$14(a0),$30(a0)
		move.b	$2C(a0),d0
		move.w	d0,d1
		add.w	d0,d0
		andi.w	#6,d0
		move.w	d0,$3A(a0)
		andi.w	#$F0,d1
		move.w	d1,$40(a0)
		move.w	#1,$42(a0)
		cmpi.w	#$E0,d1
		bne.s	loc_326B0

loc_326AC:
		neg.w	$42(a0)

loc_326B0:
		move.l	#loc_326B6,(a0)

loc_326B6:
		bsr.s	sub_32712
		lea	$32(a0),a2
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		move.w	($FFFFF602).w,d5
		bsr.w	sub_32784
		addq.w	#4,a2
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		move.w	($FFFFF66A).w,d5
		bsr.w	sub_32784
		move.w	#$1B,d1
		move.w	#$20,d2
		move.w	#$21,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		subq.b	#1,$24(a0)
		bpl.s	loc_32708
		move.b	#7,$24(a0)
		subq.b	#1,$22(a0)
		bcc.s	loc_32708
		move.b	#2,$22(a0)

loc_32708:

		move.w	$2E(a0),d0
		jmp	(Sprite_OnScreen_Test2).l

; =============== S U B R O U T I N E =======================================


sub_32712:
		move.w	$3A(a0),d0
		move.w	off_3271E(pc,d0.w),d0
		jmp	off_3271E(pc,d0.w)
; End of function sub_32712

; ---------------------------------------------------------------------------
off_3271E:	dc.w locret_32724-off_3271E

		dc.w loc_32726-off_3271E
		dc.w loc_32766-off_3271E
; ---------------------------------------------------------------------------

locret_32724:
		rts
; ---------------------------------------------------------------------------

loc_32726:
		move.w	$42(a0),d1
		bmi.s	loc_3273E
		move.w	$40(a0),d0
		add.w	d1,d0
		cmpi.w	#$E0,d0
		bne.s	loc_3273C
		neg.w	$42(a0)

loc_3273C:
		bra.s	loc_3274A
; ---------------------------------------------------------------------------

loc_3273E:
		move.w	$40(a0),d0
		add.w	d1,d0
		bne.s	loc_3274A
		neg.w	$42(a0)

loc_3274A:

		move.w	d0,$40(a0)
		subi.w	#$70,d0
		btst	#0,$2A(a0)
		beq.s	loc_3275C
		neg.w	d0

loc_3275C:
		add.w	$2E(a0),d0
		move.w	d0,$10(a0)
		rts
; ---------------------------------------------------------------------------

loc_32766:
		moveq	#0,d0

loc_32768:
		move.b	($FFFFFE8C).w,d0
		btst	#0,$2A(a0)
		beq.s	loc_3277A
		neg.w	d0
		addi.w	#$80,d0

loc_3277A:
		add.w	$30(a0),d0
		move.w	d0,$14(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_32784:

		move.b	(a2),d0
		bne.s	loc_327FC
		btst	d6,$2A(a0)
		beq.s	locret_327FA
		move.b	#0,1(a2)
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		bpl.s	loc_327A6
		neg.w	d0
		move.b	#-$80,1(a2)

loc_327A6:
		move.b	d0,2(a2)
		move.w	#0,$18(a1)
		move.w	#0,$1A(a1)
		move.w	#0,$1C(a1)
		move.b	#3,$2E(a1)
		move.b	$44(a1),$1E(a1)
		move.b	$45(a1),$1F(a1)
		bclr	#2,$2A(a1)
		bclr	#1,$2A(a1)
		bclr	#5,$2A(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$40(a1)
		move.b	#0,$20(a1)
		move.b	#1,(a2)
		bra.w	loc_3260A
; ---------------------------------------------------------------------------

locret_327FA:
		rts
; ---------------------------------------------------------------------------

loc_327FC:
		tst.b	4(a1)
		bpl.w	loc_328AC
		cmpi.b	#4,5(a1)
		bcc.w	loc_328AC

loc_3280E:
		btst	d6,$2A(a0)
		beq.w	loc_328BE
		tst.b	2(a2)
		beq.s	loc_32820
		subq.b	#1,2(a2)

loc_32820:
		moveq	#0,d0
		move.b	1(a2),d0
		jsr	(GetSineCosine).l
		addi.w	#$100,d0
		asr.w	#2,d0
		move.b	d0,3(a2)
		moveq	#0,d2
		move.w	2(a2),d2
		muls.w	d2,d1
		swap	d1
		add.w	$10(a0),d1
		move.w	d1,$10(a1)
		addq.b	#2,1(a2)
		move.w	#0,$1C(a1)
		move.w	$1A(a0),d0
		bpl.s	loc_3285A
		neg.w	d0

loc_3285A:
		btst	#1,$2A(a1)
		bne.s	loc_3286E
		cmpi.w	#$480,d0
		bcs.s	loc_3286E
		move.w	#$800,$1C(a1)

loc_3286E:

		andi.b	#$70,d5
		beq.w	loc_3260A
		move.b	#1,$40(a1)

loc_3287C:
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		move.w	$1A(a0),$1A(a1)

loc_3289A:
		addi.w	#-$680,$1A(a1)
		move.w	#0,$18(a1)

loc_328A6:
		move.w	#0,$1C(a1)

loc_328AC:

		bset	#1,$2A(a1)
		move.w	#$100,8(a1)
		move.b	#0,$2E(a1)

loc_328BE:
		move.b	#0,(a2)
		rts
; End of function sub_32784

; ---------------------------------------------------------------------------

Obj_49_1:
		move.b	#$60,$32(a0)
		move.l	#loc_328D0,(a0)

loc_328D0:
		lea	$36(a0),a2
		lea	($FFFFB000).w,a1
		bsr.s	sub_328E8
		addq.w	#1,a2
		lea	($FFFFB04A).w,a1
		bsr.s	sub_328E8
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_328E8:

		moveq	#0,d2
		move.b	$32(a0),d2
		move.w	d2,d3
		add.w	d3,d3
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d2,d0
		cmp.w	d3,d0
		bcc.s	loc_3291A

loc_32900:
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		add.w	d2,d1
		cmp.w	d3,d1
		bcc.s	loc_3291A
		btst	#1,$2A(a1)
		beq.s	loc_32926
		clr.b	(a2)
		rts
; ---------------------------------------------------------------------------

loc_3291A:

		tst.b	(a2)
		beq.s	locret_32924
		clr.b	$3C(a1)
		clr.b	(a2)

locret_32924:
		rts
; ---------------------------------------------------------------------------

loc_32926:
		tst.b	(a2)
		bne.s	loc_3294C
		move.b	#1,(a2)
		btst	#2,$2A(a1)
		bne.s	loc_3293A
		clr.b	$20(a1)

loc_3293A:
		bclr	#5,$2A(a1)
		move.b	#1,$21(a1)
		move.b	#1,$3C(a1)

loc_3294C:
		move.w	$1C(a1),d0
		btst	#0,$2A(a0)
		beq.s	loc_32974
		cmpi.w	#-$400,d0
		ble.s	loc_32966
		move.w	#-$400,$1C(a1)
		rts
; ---------------------------------------------------------------------------

loc_32966:
		cmpi.w	#-$F00,d0
		bge.s	locret_32972
		move.w	#-$F00,$1C(a1)

locret_32972:
		rts
; ---------------------------------------------------------------------------

loc_32974:
		cmpi.w	#$400,d0
		bge.s	loc_32982
		move.w	#$400,$1C(a1)
		rts
; ---------------------------------------------------------------------------

loc_32982:
		cmpi.w	#$F00,d0
		ble.s	locret_3298E
		move.w	#$F00,$1C(a1)

locret_3298E:
		rts
; End of function sub_328E8

; ---------------------------------------------------------------------------

Obj_4B_1:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,$34(a0)
		add.w	d0,d0
		move.w	d0,$32(a0)
		move.l	#loc_329A6,(a0)

loc_329A6:
		lea	($FFFFB000).w,a1
		bsr.s	sub_329B8
		lea	($FFFFB04A).w,a1
		bsr.s	sub_329B8
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_329B8:

		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	$34(a0),d0
		cmp.w	$32(a0),d0
		bcc.s	locret_329E4
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		addi.w	#$14,d1
		cmpi.w	#$28,d1
		bcc.s	locret_329E4

loc_329DC:
		cmpi.b	#4,5(a1)
		bcs.s	loc_329E6

locret_329E4:

		rts
; ---------------------------------------------------------------------------

loc_329E6:
		move.w	#-$800,$18(a1)
		move.w	#-$800,$1A(a1)
		bset	#0,$2A(a1)
		btst	#0,$2A(a0)
		bne.s	loc_32A0A
		bclr	#0,$2A(a1)
		neg.w	$18(a1)

loc_32A0A:
		btst	#1,$2A(a0)
		beq.s	loc_32A16
		neg.w	$1A(a1)

loc_32A16:
		move.w	#$F,$32(a1)
		move.w	$18(a1),$1C(a1)

loc_32A22:
		btst	#2,$2A(a1)
		bne.s	loc_32A30
		move.b	#0,$20(a1)

loc_32A30:
		tst.b	$27(a1)
		bne.s	loc_32A5A
		move.b	#1,$27(a1)
		move.b	#0,$20(a1)
		move.b	#3,$30(a1)
		move.b	#8,$31(a1)
		btst	#0,$2A(a1)
		beq.s	loc_32A5A
		neg.b	$27(a1)

loc_32A5A:

		clr.b	$40(a1)
		bset	#1,$2A(a1)
		bclr	#4,$2A(a1)
		bclr	#5,$2A(a1)
		moveq	#$7B,d0
		jmp	(Play_Sound_2).l
; End of function sub_329B8

; ---------------------------------------------------------------------------

Obj_4F_1:
		move.b	$2C(a0),d0
		lsl.w	#3,d0
		move.b	d0,7(a0)
		move.w	$14(a0),$30(a0)
		move.b	#$30,$38(a0)
		move.b	#$30,$3A(a0)
		bset	#7,$2A(a0)
		move.l	#loc_32B8C,(a0)
		tst.w	($FFFFFFE8).w
		bne.w	loc_32B8C
		move.l	#loc_32AAE,(a0)

loc_32AAE:

		tst.w	($FFFFFE08).w
		bne.w	loc_32B62
		lea	($FFFFB000).w,a1
		btst	#3,$2A(a0)
		bne.s	loc_32AEA

loc_32AC2:
		cmpi.b	#$30,$38(a0)
		bcc.s	loc_32ACE
		addq.b	#2,$38(a0)

loc_32ACE:
		btst	#3,$2A(a1)
		beq.s	loc_32AF4
		movea.w	$42(a1),a2
		cmpi.l	#loc_32AAE,(a2)

loc_32AE0:
		bne.s	loc_32AF4
		move.b	$38(a2),$38(a0)
		bra.s	loc_32AF4
; ---------------------------------------------------------------------------

loc_32AEA:
		tst.b	$38(a0)
		beq.s	loc_32B68
		subq.b	#1,$38(a0)

loc_32AF4:

		moveq	#0,d1
		move.b	7(a0),d1
		moveq	#0,d3
		move.b	$38(a0),d3
		moveq	#3,d6
		move.w	$10(a0),d4
		jsr	(sub_1E2BC).l
		lea	($FFFFB04A).w,a1
		btst	#4,$2A(a0)
		bne.s	loc_32B40
		cmpi.b	#$30,$3A(a0)
		bcc.s	loc_32B24
		addq.b	#2,$3A(a0)

loc_32B24:
		btst	#3,$2A(a1)
		beq.s	loc_32B4A
		movea.w	$42(a1),a2
		cmpi.l	#loc_32AAE,(a2)
		bne.s	loc_32B4A
		move.b	$3A(a2),$3A(a0)
		bra.s	loc_32B4A
; ---------------------------------------------------------------------------

loc_32B40:
		tst.b	$3A(a0)
		beq.s	loc_32B70
		subq.b	#1,$3A(a0)

loc_32B4A:

		moveq	#0,d1
		move.b	7(a0),d1
		moveq	#0,d3
		move.b	$3A(a0),d3
		moveq	#4,d6
		move.w	$10(a0),d4
		jsr	(sub_1E2BC).l

loc_32B62:
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_32B68:
		move.b	#$30,$38(a0)
		bra.s	loc_32B76
; ---------------------------------------------------------------------------

loc_32B70:
		move.b	#$30,$3A(a0)

loc_32B76:
		not.b	d1
		and.b	d1,$2A(a0)
		move.l	a0,-(sp)
		movea.l	a0,a2
		movea.l	a1,a0

loc_32B82:
		jsr	(Kill_Character).l
		movea.l	(sp)+,a0
		rts
; ---------------------------------------------------------------------------

loc_32B8C:

		tst.w	($FFFFFE08).w
		bne.w	locret_32C44
		lea	($FFFFB000).w,a1
		btst	#3,$2A(a0)
		bne.s	loc_32BC8
		cmpi.b	#$30,$38(a0)
		bcc.s	loc_32BAC

loc_32BA8:
		addq.b	#2,$38(a0)

loc_32BAC:
		btst	#3,$2A(a1)
		beq.s	loc_32BD2
		movea.w	$42(a1),a2
		cmpi.l	#loc_32AAE,(a2)
		bne.s	loc_32BD2
		move.b	$38(a2),$38(a0)
		bra.s	loc_32BD2
; ---------------------------------------------------------------------------

loc_32BC8:
		tst.b	$38(a0)
		beq.s	loc_32C46
		subq.b	#1,$38(a0)

loc_32BD2:

		moveq	#0,d1
		move.b	7(a0),d1
		moveq	#0,d3
		move.b	$38(a0),d3
		lsr.w	#1,d3
		moveq	#3,d6
		move.w	$10(a0),d4
		jsr	(sub_1E2BC).l
		lea	($FFFFB04A).w,a1
		btst	#4,$2A(a0)
		bne.s	loc_32C20
		cmpi.b	#$30,$3A(a0)
		bcc.s	loc_32C04
		addq.b	#2,$3A(a0)

loc_32C04:
		btst	#3,$2A(a1)
		beq.s	loc_32C2A
		movea.w	$42(a1),a2
		cmpi.l	#loc_32AAE,(a2)
		bne.s	loc_32C2A

loc_32C18:
		move.b	$3A(a2),$3A(a0)
		bra.s	loc_32C2A
; ---------------------------------------------------------------------------

loc_32C20:
		tst.b	$3A(a0)
		beq.s	loc_32C4E
		subq.b	#1,$3A(a0)

loc_32C2A:

		moveq	#0,d1
		move.b	7(a0),d1
		moveq	#0,d3
		move.b	$3A(a0),d3

loc_32C36:
		lsr.w	#1,d3
		moveq	#4,d6
		move.w	$10(a0),d4
		jsr	(sub_1E2BC).l

locret_32C44:
		rts
; ---------------------------------------------------------------------------

loc_32C46:
		move.b	#$30,$38(a0)
		bra.s	loc_32C54
; ---------------------------------------------------------------------------

loc_32C4E:
		move.b	#$30,$3A(a0)

loc_32C54:
		not.b	d1
		and.b	d1,$2A(a0)
		move.l	a0,-(sp)
		movea.l	a0,a2
		movea.l	a1,a0
		jsr	(Kill_Character).l
		movea.l	(sp)+,a0
		rts
; ---------------------------------------------------------------------------

Obj_5D_1:
		move.b	#8,7(a0)
		move.b	#$40,6(a0)
		move.b	$2C(a0),d0
		lsr.b	#4,d0
		andi.b	#7,d0
		move.b	d0,$22(a0)
		beq.s	loc_32C8C
		move.b	#-$80,6(a0)

loc_32C8C:
		move.l	#loc_32C92,(a0)

loc_32C92:
		move.w	#$10,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		jsr	SolidObjectFull2_1P
		cmpi.b	#1,d4
		bne.s	loc_32CDC

loc_32CBA:
		btst	#1,$2A(a1)
		beq.s	loc_32CDC
		move.b	$2A(a0),d1
		move.w	$10(a0),d0
		sub.w	$10(a1),d0
		bcs.s	loc_32CD4
		eori.b	#1,d1

loc_32CD4:
		andi.b	#1,d1
		bne.s	loc_32CDC
		bsr.s	sub_32D16

loc_32CDC:

		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		jsr	SolidObjectFull2_1P
		cmpi.b	#1,d4
		bne.s	locret_32D14
		btst	#1,$2A(a1)
		beq.s	locret_32D14
		move.b	$2A(a0),d1
		move.w	$10(a0),d0
		sub.w	$10(a1),d0
		bcs.s	loc_32D0C
		eori.b	#1,d1

loc_32D0C:
		andi.b	#1,d1
		bne.s	locret_32D14
		bsr.s	sub_32D16

locret_32D14:

		rts

; =============== S U B R O U T I N E =======================================


sub_32D16:

		cmpi.b	#4,5(a1)
		bcs.s	loc_32D20
		rts
; ---------------------------------------------------------------------------

loc_32D20:
		move.w	#-$800,$18(a1)
		move.w	#$400,$1A(a1)
		bset	#0,$2A(a1)
		btst	#0,$2A(a0)
		bne.s	loc_32D44
		bclr	#0,$2A(a1)
		neg.w	$18(a1)

loc_32D44:
		move.w	#$F,$32(a1)
		move.w	$18(a1),$1C(a1)
		btst	#2,$2A(a1)
		bne.s	loc_32D5E
		move.b	#0,$20(a1)

loc_32D5E:
		move.b	$2C(a0),d0
		bpl.s	loc_32D6A
		move.w	#0,$1A(a1)

loc_32D6A:
		btst	#0,d0
		beq.s	loc_32DAA
		move.w	#1,$1C(a1)
		move.b	#1,$27(a1)
		move.b	#0,$20(a1)

loc_32D82:
		move.b	#1,$30(a1)
		move.b	#8,$31(a1)
		btst	#1,d0
		bne.s	loc_32D9A
		move.b	#3,$30(a1)

loc_32D9A:
		btst	#0,$2A(a1)
		beq.s	loc_32DAA
		neg.b	$27(a1)
		neg.w	$1C(a1)

loc_32DAA:

		andi.b	#$C,d0
		cmpi.b	#4,d0
		bne.s	loc_32DC0
		move.b	#$C,$46(a1)
		move.b	#$D,$47(a1)

loc_32DC0:
		cmpi.b	#8,d0
		bne.s	loc_32DD2
		move.b	#$E,$46(a1)
		move.b	#$F,$47(a1)

loc_32DD2:
		bclr	#5,$2A(a0)
		bclr	#6,$2A(a0)
		bclr	#5,$2A(a1)
		bclr	#4,$2A(a1)
		moveq	#$7B,d0
		jmp	(Play_Sound_2).l
; End of function sub_32D16

; ---------------------------------------------------------------------------

Obj_Bumper:

		move.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$80,8(a0)

loc_32E0A:
		move.b	#-$29,$28(a0)

loc_32E10:
		move.w	$10(a0),$30(a0)
		move.w	$14(a0),$32(a0)
		cmpi.b	#$14,($FFFFFE10).w
		bne.s	loc_32E3C
		move.l	#Map_PachinkoBumper,$C(a0)
		move.w	#$62CD,$A(a0)
		move.l	#loc_32EF0,(a0)
		bra.w	loc_32EF0
; ---------------------------------------------------------------------------

loc_32E3C:
		tst.w	($FFFFFFE8).w
		beq.s	loc_32E5A
		move.l	#Map_2PBumper,$C(a0)
		move.w	#$2300,$A(a0)
		move.l	#loc_32FF0,(a0)
		bra.w	loc_32FF0
; ---------------------------------------------------------------------------

loc_32E5A:
		move.l	#Map_Bumper,$C(a0)
		move.w	#$4364,$A(a0)
		move.l	#loc_32EAA,(a0)
		move.b	$2C(a0),d0
		beq.s	loc_32EAA
		move.b	d0,$26(a0)
		move.l	#loc_32E7E,(a0)

loc_32E7E:
		move.b	($FFFFFE05).w,d0
		btst	#0,$2A(a0)
		beq.s	loc_32E8C
		neg.b	d0

loc_32E8C:
		add.b	$26(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#2,d1
		asr.w	#2,d0
		add.w	$30(a0),d1
		add.w	$32(a0),d0
		move.w	d1,$10(a0)
		move.w	d0,$14(a0)

loc_32EAA:

		tst.b	$29(a0)
		beq.s	loc_32EB4
		bsr.w	sub_32F34

loc_32EB4:
		lea	(Ani_PachinkoBumper).l,a1
		jsr	(Animate_Sprite).l
		move.w	$30(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_32EDE
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_32EDE:
		move.w	$48(a0),d0
		beq.s	loc_32EEA
		movea.w	d0,a2
		bclr	#7,(a2)

loc_32EEA:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_32EF0:

		tst.b	$29(a0)
		beq.s	loc_32EF8
		bsr.s	sub_32F34

loc_32EF8:
		lea	(Ani_PachinkoBumper).l,a1
		jsr	(Animate_Sprite).l
		move.w	$14(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFEF64).w,d0
		cmpi.w	#$200,d0
		bhi.s	loc_32F22
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_32F22:
		move.w	$48(a0),d0
		beq.s	loc_32F2E
		movea.w	d0,a2
		bclr	#7,(a2)

loc_32F2E:
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_32F34:

		lea	($FFFFB000).w,a1
		bclr	#0,$29(a0)
		beq.s	loc_32F42
		bsr.s	sub_32F56

loc_32F42:
		lea	($FFFFB04A).w,a1
		bclr	#1,$29(a0)
		beq.s	loc_32F50
		bsr.s	sub_32F56

loc_32F50:
		clr.b	$29(a0)
		rts
; End of function sub_32F34


; =============== S U B R O U T I N E =======================================


sub_32F56:

		move.w	$10(a0),d1
		move.w	$14(a0),d2
		sub.w	$10(a1),d1
		sub.w	$14(a1),d2
		jsr	(GetArcTan).l

loc_32F6C:
		move.b	($FFFFFE04).w,d1
		andi.w	#3,d1
		add.w	d1,d0
		jsr	(GetSineCosine).l
		muls.w	#-$700,d1
		asr.l	#8,d1

loc_32F82:
		move.w	d1,$18(a1)

loc_32F86:
		muls.w	#-$700,d0
		asr.l	#8,d0
		move.w	d0,$1A(a1)
		bset	#1,$2A(a1)

loc_32F96:
		bclr	#4,$2A(a1)
		bclr	#5,$2A(a1)
		clr.b	$40(a1)
		move.b	#1,$20(a0)
		moveq	#-$56,d0
		jsr	(Play_Sound_2).l
		move.w	$48(a0),d0
		beq.s	loc_32FC4
		movea.w	d0,a2
		cmpi.b	#-$76,(a2)
		bcc.s	locret_32FEE
		addq.b	#1,(a2)

loc_32FC4:
		moveq	#1,d0
		movea.w	a1,a3
		jsr	(HUD_AddToScore).l
		jsr	(Create_New_Sprite).l
		bne.s	locret_32FEE
		move.l	#Obj_EnemyScore,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	#4,$22(a1)

locret_32FEE:

		rts
; End of function sub_32F56

; ---------------------------------------------------------------------------

loc_32FF0:

		tst.b	$29(a0)
		beq.w	loc_3307C
		lea	($FFFFB000).w,a1

loc_32FFC:
		bclr	#0,$29(a0)
		beq.s	loc_33006
		bsr.s	sub_3301C

loc_33006:
		lea	($FFFFB04A).w,a1
		bclr	#1,$29(a0)
		beq.s	loc_33014
		bsr.s	sub_3301C

loc_33014:
		clr.b	$29(a0)
		bra.w	loc_3307C

; =============== S U B R O U T I N E =======================================


sub_3301C:

		move.w	$10(a0),d1
		move.w	$14(a0),d2
		sub.w	$10(a1),d1
		sub.w	$14(a1),d2
		jsr	(GetArcTan).l
		move.b	($FFFFFE04).w,d1
		andi.w	#3,d1
		add.w	d1,d0
		jsr	(GetSineCosine).l
		muls.w	#-$700,d1
		asr.l	#8,d1
		move.w	d1,$18(a1)
		muls.w	#-$700,d0
		asr.l	#8,d0
		move.w	d0,$1A(a1)
		bset	#1,$2A(a1)
		bclr	#4,$2A(a1)
		bclr	#5,$2A(a1)
		clr.b	$40(a1)
		move.b	#1,$20(a0)
		moveq	#$7B,d0
		jsr	(Play_Sound_2).l
		rts
; End of function sub_3301C

; ---------------------------------------------------------------------------

loc_3307C:

		lea	(Ani_PachinkoBumper).l,a1
		jsr	(Animate_Sprite).l
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Ani_PachinkoBumper:	include "Levels\Pachinko\Misc Object Data\Anim - Bumper.asm"

Map_PachinkoBumper:include "Levels\Pachinko\Misc Object Data\Map - Bumper.asm"

; ---------------------------------------------------------------------------

Obj_4C_1:
		lea	($FFFFB000).w,a1
		lea	$30(a0),a4
		bsr.s	sub_330EE
		lea	($FFFFB04A).w,a1
		lea	$3A(a0),a4
		bsr.s	sub_330EE
		move.b	$30(a0),d0
		add.b	$3A(a0),d0
		beq.s	loc_330E8
		rts
; ---------------------------------------------------------------------------

loc_330E8:
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_330EE:

		moveq	#0,d0
		move.b	(a4),d0
		move.w	off_330FA(pc,d0.w),d0
		jmp	off_330FA(pc,d0.w)
; End of function sub_330EE

; ---------------------------------------------------------------------------
off_330FA:	dc.w loc_33102-off_330FA

		dc.w loc_3318E-off_330FA
		dc.w loc_331CA-off_330FA
		dc.w loc_3320E-off_330FA
; ---------------------------------------------------------------------------

loc_33102:
		tst.w	($FFFFFE08).w
		bne.w	locret_3318C
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$40,d0
		cmpi.w	#$80,d0
		bcc.s	locret_3318C
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		addi.w	#$10,d1
		cmpi.w	#$20,d1
		bcc.s	locret_3318C
		tst.b	$2E(a1)
		bne.s	locret_3318C
		addq.b	#2,(a4)
		move.b	#-$7F,$2E(a1)
		move.b	#2,$20(a1)
		move.w	#$800,$1C(a1)
		move.w	#0,$18(a1)
		move.w	#0,$1A(a1)
		bclr	#5,$2A(a1)
		bset	#1,$2A(a1)
		clr.b	1(a4)
		moveq	#$30,d1
		cmpi.w	#$40,d0
		bcc.s	loc_33174
		neg.w	d1
		move.b	#-$80,1(a4)

loc_33174:
		add.w	$10(a0),d1
		move.w	d1,$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	#$3C,d0
		jsr	(Play_Sound_2).l

locret_3318C:

		rts
; ---------------------------------------------------------------------------

loc_3318E:
		move.b	1(a4),d0
		addq.b	#8,1(a4)
		jsr	(GetSineCosine).l
		asr.w	#3,d1
		move.w	d1,d0
		asr.w	#1,d1
		add.w	d1,d0
		add.w	$10(a0),d0
		move.w	d0,$10(a1)
		moveq	#0,d0
		btst	#0,($FFFFFE21).w
		beq.s	loc_331BA
		move.w	#$80,d0

loc_331BA:
		cmp.b	1(a4),d0
		bne.s	locret_331C8
		addq.b	#2,(a4)
		move.w	#$C0,2(a4)

locret_331C8:
		rts
; ---------------------------------------------------------------------------

loc_331CA:
		move.b	1(a4),d0
		addi.b	#$C,1(a4)
		jsr	(GetSineCosine).l
		asr.w	#3,d1
		move.w	d1,d0
		asr.w	#1,d1
		add.w	d1,d0
		add.w	$10(a0),d0
		move.w	d0,$10(a1)
		addq.w	#2,$14(a1)
		subq.w	#1,2(a4)
		bne.s	locret_3320C
		moveq	#0,d0
		move.w	$10(a0),d1
		sub.w	$10(a1),d1
		bcc.s	loc_33202
		moveq	#1,d0

loc_33202:
		add.b	$2C(a0),d0
		bsr.w	sub_33272
		addq.b	#2,(a4)

locret_3320C:
		rts
; ---------------------------------------------------------------------------

loc_3320E:
		subq.b	#1,2(a4)
		bpl.s	loc_3323A
		movea.l	6(a4),a2
		move.w	(a2)+,d4
		move.w	d4,$10(a1)
		move.w	(a2)+,d5
		move.w	d5,$14(a1)
		move.l	a2,6(a4)
		subq.w	#4,4(a4)
		beq.s	loc_33260
		move.w	(a2)+,d4
		move.w	(a2)+,d5
		move.w	#$C00,d2
		bra.w	loc_332A2
; ---------------------------------------------------------------------------

loc_3323A:

		move.l	$10(a1),d2
		move.l	$14(a1),d3
		move.w	$18(a1),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d2
		move.w	$1A(a1),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d3
		move.l	d2,$10(a1)
		move.l	d3,$14(a1)
		rts
; ---------------------------------------------------------------------------

loc_33260:
		andi.w	#$FFF,$14(a1)
		clr.b	(a4)
		clr.b	$2E(a1)
		clr.b	$40(a1)
		bra.s	loc_3323A

; =============== S U B R O U T I N E =======================================


sub_33272:
		andi.w	#$F,d0
		add.w	d0,d0
		lea	(off_33320).l,a2
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,4(a4)
		subq.w	#4,4(a4)
		move.w	(a2)+,d4
		move.w	d4,$10(a1)
		move.w	(a2)+,d5
		move.w	d5,$14(a1)
		move.l	a2,6(a4)
		move.w	(a2)+,d4
		move.w	(a2)+,d5
		move.w	#$C00,d2

loc_332A2:
		moveq	#0,d0
		move.w	d2,d3
		move.w	d4,d0
		sub.w	$10(a1),d0
		bge.s	loc_332B2
		neg.w	d0
		neg.w	d2

loc_332B2:
		moveq	#0,d1
		move.w	d5,d1
		sub.w	$14(a1),d1
		bge.s	loc_332C0
		neg.w	d1
		neg.w	d3

loc_332C0:
		cmp.w	d0,d1
		bcs.s	loc_332F2
		moveq	#0,d1
		move.w	d5,d1
		sub.w	$14(a1),d1
		swap	d1
		divs.w	d3,d1
		moveq	#0,d0
		move.w	d4,d0
		sub.w	$10(a1),d0
		beq.s	loc_332DE
		swap	d0
		divs.w	d1,d0

loc_332DE:
		move.w	d0,$18(a1)
		move.w	d3,$1A(a1)
		tst.w	d1
		bpl.s	loc_332EC
		neg.w	d1

loc_332EC:
		move.w	d1,2(a4)
		rts
; ---------------------------------------------------------------------------

loc_332F2:
		moveq	#0,d0
		move.w	d4,d0
		sub.w	$10(a1),d0
		swap	d0
		divs.w	d2,d0
		moveq	#0,d1
		move.w	d5,d1
		sub.w	$14(a1),d1
		beq.s	loc_3330C
		swap	d1
		divs.w	d0,d1

loc_3330C:
		move.w	d1,$1A(a1)
		move.w	d2,$18(a1)
		tst.w	d0
		bpl.s	loc_3331A
		neg.w	d0

loc_3331A:
		move.w	d0,2(a4)
		rts
; End of function sub_33272

; ---------------------------------------------------------------------------
off_33320:	dc.w word_33328-off_33320

		dc.w word_33336-off_33320
		dc.w word_33344-off_33320
		dc.w word_33352-off_33320
word_33328:	dc.w $C
		dc.w $1390
		dc.w $2D0
		dc.w $1230
		dc.w $2D0
		dc.w $1230
		dc.w $300
word_33336:	dc.w $C
		dc.w $13F0
		dc.w $2D0
		dc.w $1560
		dc.w $2D0
		dc.w $1560
		dc.w $280
word_33344:	dc.w $C
		dc.w $2090
		dc.w $650
		dc.w $2030
		dc.w $650
		dc.w $2030
		dc.w $680
word_33352:	dc.w $C
		dc.w $20F0
		dc.w $650
		dc.w $21E0
		dc.w $650
		dc.w $21E0
		dc.w $600
; ---------------------------------------------------------------------------

Obj_CNZBarberPoleSprite:

		tst.b	$2C(a0)
		beq.s	loc_33370
		move.l	#loc_335A8,(a0)
		bra.w	loc_335A8
; ---------------------------------------------------------------------------

loc_33370:
		move.l	#loc_33376,(a0)

loc_33376:

		lea	$30(a0),a2
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.s	sub_33392
		addq.w	#6,a2
		lea	($FFFFB04A).w,a1
		addq.b	#1,d6
		bsr.s	sub_33392
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_33392:

		btst	d6,$2A(a0)
		bne.w	loc_334B6
		btst	#3,$2A(a1)
		bne.w	loc_3342A
		moveq	#0,d0
		move.b	$1F(a1),d0
		neg.w	d0
		add.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$40,d0
		cmpi.w	#$A0,d0
		bcc.s	locret_33428
		subi.w	#$61,d0
		moveq	#0,d1
		move.b	$1E(a1),d1
		add.w	$14(a1),d1
		sub.w	$14(a0),d1
		sub.w	d0,d1
		cmpi.w	#$10,d1
		bcc.s	locret_33428
		tst.b	$2E(a1)
		bne.s	locret_33428
		tst.w	($FFFFFE08).w
		bne.s	locret_33428
		btst	#1,$2A(a1)

loc_333EA:
		beq.s	loc_333F2
		tst.w	$1A(a1)
		bmi.s	locret_33428

loc_333F2:
		move.l	$10(a1),(a2)
		move.w	(a2),d0
		sub.w	$10(a0),d0
		addi.w	#$40,d0
		move.w	d0,(a2)
		move.w	#0,4(a2)
		subi.w	#$18,d0
		cmpi.w	#$70,d0
		bcc.s	loc_33418
		move.w	#1,4(a2)

loc_33418:
		bsr.w	sub_337D8
		move.b	#$20,$26(a1)

loc_33422:
		move.b	#2,$2D(a1)

locret_33428:

		rts
; ---------------------------------------------------------------------------

loc_3342A:
		moveq	#0,d0
		move.b	$1F(a1),d0
		neg.w	d0
		add.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$30,d0
		cmpi.w	#$80,d0
		bcc.s	locret_334B4
		subi.w	#$51,d0
		moveq	#0,d1
		move.b	$1E(a1),d1
		add.w	$14(a1),d1
		sub.w	$14(a0),d1
		sub.w	d0,d1
		cmpi.w	#$10,d1
		bcc.s	locret_334B4
		tst.b	$2E(a1)
		bne.s	locret_334B4
		btst	#1,$2A(a1)
		beq.s	loc_33472
		tst.w	$1A(a1)
		bmi.s	locret_334B4

loc_33472:
		movea.w	$42(a1),a3
		cmpi.l	#loc_33376,(a3)
		bne.s	locret_334B4
		move.l	$10(a1),(a2)
		move.w	(a2),d0
		sub.w	$10(a0),d0
		addi.w	#$40,d0
		move.w	d0,(a2)
		move.w	#0,4(a2)
		subi.w	#$20,d0
		cmpi.w	#$60,d0
		bcc.s	loc_334A4
		move.w	#1,4(a2)

loc_334A4:
		bsr.w	sub_337D8
		move.b	#$20,$26(a1)
		move.b	#2,$2D(a1)

locret_334B4:

		rts
; ---------------------------------------------------------------------------

loc_334B6:
		tst.w	4(a2)
		bne.s	loc_334D2
		move.w	$1C(a1),d0
		bpl.s	loc_334C4
		neg.w	d0

loc_334C4:
		cmpi.w	#$118,d0
		bcc.s	loc_334D2
		bset	#1,$2A(a1)
		bra.s	loc_334FA
; ---------------------------------------------------------------------------

loc_334D2:

		btst	#1,$2A(a1)
		bne.s	loc_334FA
		move.w	$18(a1),d0
		ext.l	d0
		lsl.l	#6,d0
		move.l	d0,d1
		add.l	d0,d0
		add.l	d1,d0
		add.l	d0,(a2)
		moveq	#0,d0
		move.b	$1F(a1),d0
		neg.w	d0
		add.w	(a2),d0
		cmpi.w	#$A0,d0
		bcs.s	loc_33518

loc_334FA:

		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		move.b	#0,$30(a1)
		move.b	#4,$31(a1)
		andi.w	#$7FFF,$A(a1)
		rts
; ---------------------------------------------------------------------------

loc_33518:
		btst	#3,$2A(a1)
		beq.w	locret_335A6
		move.w	d0,d2
		subi.b	#$10,d0
		bcc.s	loc_33532
		move.w	#0,4(a2)
		moveq	#0,d0

loc_33532:
		cmpi.b	#-$80,d0
		bcs.s	loc_33542
		move.w	#0,4(a2)
		move.w	#$80,d0

loc_33542:
		andi.w	#$7FFF,$A(a1)
		cmpi.b	#$34,d0
		bcc.s	loc_33554
		ori.w	#-$8000,$A(a1)

loc_33554:
		tst.w	4(a2)
		beq.s	loc_3355C
		moveq	#0,d0

loc_3355C:
		add.w	d0,d0
		move.b	d0,$27(a1)
		jsr	(GetSineCosine).l
		move.w	d1,d4
		asr.w	#4,d1
		move.w	d1,d3
		add.w	d2,d1
		add.w	$10(a0),d1
		subi.w	#$50,d1
		moveq	#0,d0
		move.b	$1F(a1),d0
		muls.w	d4,d0
		asr.w	#8,d0
		add.w	d0,d1
		move.w	d1,$10(a1)
		move.w	d2,d0
		subi.w	#$51,d0
		move.w	$14(a0),d2
		sub.w	d3,d2
		add.w	d0,d2
		moveq	#0,d1
		move.b	$1E(a1),d1
		muls.w	d4,d1
		asr.w	#8,d1
		sub.w	d1,d2
		move.w	d2,$14(a1)

locret_335A6:
		rts
; End of function sub_33392

; ---------------------------------------------------------------------------

loc_335A8:

		lea	$30(a0),a2
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.s	sub_335C4
		addq.w	#6,a2
		lea	($FFFFB04A).w,a1
		addq.b	#1,d6
		bsr.s	sub_335C4
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_335C4:

		btst	d6,$2A(a0)
		bne.w	loc_336E4
		btst	#3,$2A(a1)
		bne.w	loc_3365A
		moveq	#0,d0
		move.b	$1F(a1),d0
		add.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$60,d0
		cmpi.w	#$A0,d0
		bcc.s	locret_33658
		subi.w	#$3E,d0
		moveq	#0,d1
		move.b	$1E(a1),d1
		add.w	$14(a1),d1
		sub.w	$14(a0),d1
		add.w	d0,d1
		cmpi.w	#$10,d1
		bcc.s	locret_33658
		tst.b	$2E(a1)
		bne.s	locret_33658
		tst.w	($FFFFFE08).w
		bne.s	locret_33658
		btst	#1,$2A(a1)
		beq.s	loc_33622
		tst.w	$1A(a1)
		bmi.s	locret_33658

loc_33622:
		move.l	$10(a1),(a2)
		move.w	(a2),d0
		sub.w	$10(a0),d0
		addi.w	#$60,d0
		move.w	d0,(a2)
		move.w	#0,4(a2)
		subi.w	#$18,d0
		cmpi.w	#$70,d0
		bcc.s	loc_33648
		move.w	#1,4(a2)

loc_33648:
		bsr.w	sub_337D8
		move.b	#-$20,$26(a1)
		move.b	#3,$2D(a1)

locret_33658:

		rts
; ---------------------------------------------------------------------------

loc_3365A:
		moveq	#0,d0
		move.b	$1F(a1),d0
		add.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$50,d0
		cmpi.w	#$80,d0
		bcc.s	locret_336E2
		subi.w	#$2E,d0
		moveq	#0,d1
		move.b	$1E(a1),d1
		add.w	$14(a1),d1
		sub.w	$14(a0),d1
		add.w	d0,d1
		cmpi.w	#$10,d1
		bcc.s	locret_336E2
		tst.b	$2E(a1)
		bne.s	locret_336E2
		btst	#1,$2A(a1)
		beq.s	loc_336A0
		tst.w	$1A(a1)
		bmi.s	locret_336E2

loc_336A0:
		movea.w	$42(a1),a3
		cmpi.l	#loc_335A8,(a3)
		bne.s	locret_336E2
		move.l	$10(a1),(a2)
		move.w	(a2),d0
		sub.w	$10(a0),d0
		addi.w	#$60,d0
		move.w	d0,(a2)
		move.w	#0,4(a2)
		subi.w	#$20,d0
		cmpi.w	#$60,d0
		bcc.s	loc_336D2
		move.w	#1,4(a2)

loc_336D2:
		bsr.w	sub_337D8
		move.b	#-$20,$26(a1)
		move.b	#3,$2D(a1)

locret_336E2:

		rts
; ---------------------------------------------------------------------------

loc_336E4:
		tst.w	4(a2)
		bne.s	loc_33700
		move.w	$1C(a1),d0
		bpl.s	loc_336F2
		neg.w	d0

loc_336F2:
		cmpi.w	#$118,d0
		bcc.s	loc_33700
		bset	#1,$2A(a1)
		bra.s	loc_33726
; ---------------------------------------------------------------------------

loc_33700:

		btst	#1,$2A(a1)
		bne.s	loc_33726
		move.w	$18(a1),d0
		ext.l	d0
		lsl.l	#6,d0
		move.l	d0,d1
		add.l	d0,d0
		add.l	d1,d0
		add.l	d0,(a2)
		moveq	#0,d0
		move.b	$1F(a1),d0
		add.w	(a2),d0
		cmpi.w	#$A0,d0
		bcs.s	loc_33744

loc_33726:

		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		move.b	#0,$30(a1)
		move.b	#4,$31(a1)
		andi.w	#$7FFF,$A(a1)
		rts
; ---------------------------------------------------------------------------

loc_33744:
		btst	#3,$2A(a1)
		beq.w	locret_337D6
		move.w	d0,d2
		subi.b	#$10,d0
		bcc.s	loc_3375E
		move.w	#0,4(a2)
		moveq	#0,d0

loc_3375E:
		cmpi.b	#-$80,d0
		bcs.s	loc_3376E
		move.w	#0,4(a2)
		move.w	#$80,d0

loc_3376E:
		andi.w	#$7FFF,$A(a1)
		cmpi.b	#$4C,d0
		bcs.s	loc_33780
		ori.w	#-$8000,$A(a1)

loc_33780:
		tst.w	4(a2)
		beq.s	loc_33788
		moveq	#0,d0

loc_33788:
		neg.b	d0
		add.w	d0,d0
		move.b	d0,$27(a1)
		jsr	(GetSineCosine).l
		move.w	d1,d4
		asr.w	#4,d1
		move.w	d1,d3
		neg.w	d1
		add.w	d2,d1
		add.w	$10(a0),d1
		subi.w	#$50,d1
		moveq	#0,d0
		move.b	$1F(a1),d0
		muls.w	d4,d0
		asr.w	#8,d0
		sub.w	d0,d1
		move.w	d1,$10(a1)
		move.w	d2,d0
		subi.w	#$4E,d0
		move.w	$14(a0),d2
		sub.w	d3,d2
		sub.w	d0,d2
		moveq	#0,d1
		move.b	$1E(a1),d1
		muls.w	d4,d1
		asr.w	#8,d1
		sub.w	d1,d2
		move.w	d2,$14(a1)

locret_337D6:
		rts
; End of function sub_335C4


; =============== S U B R O U T I N E =======================================


sub_337D8:

		btst	#3,$2A(a1)
		beq.s	loc_337E8
		movea.w	$42(a1),a3
		bclr	d6,$2A(a3)

loc_337E8:
		move.w	a0,$42(a1)
		btst	#1,$2A(a1)
		beq.s	loc_33824
		move.w	#0,$1A(a1)
		move.w	$18(a1),$1C(a1)
		move.l	a0,-(sp)
		movea.l	a1,a0
		move.w	a0,d1
		subi.w	#-$5000,d1
		bne.s	loc_3381C
		cmpi.w	#2,($FFFFFF08).w
		beq.s	loc_3381C
		jsr	(Player_TouchFloor).l
		bra.s	loc_33822
; ---------------------------------------------------------------------------

loc_3381C:

		jsr	(Tails_TouchFloor).l

loc_33822:
		movea.l	(sp)+,a0

loc_33824:
		bset	#3,$2A(a1)
		bclr	#1,$2A(a1)
		bset	d6,$2A(a0)
		rts
; End of function sub_337D8

; ---------------------------------------------------------------------------

Obj_4E_1:
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#3,d0
		move.w	d0,$38(a0)
		add.w	d0,d0
		move.w	d0,$3A(a0)
		moveq	#1,d1
		btst	#0,$2A(a0)
		bne.s	loc_33854
		neg.w	d1

loc_33854:
		move.w	d1,$1A(a0)
		move.l	#loc_3385E,(a0)

loc_3385E:
		lea	($FFFFB000).w,a1
		lea	$30(a0),a2
		moveq	#3,d6
		move.w	($FFFFF602).w,d5
		bsr.s	sub_338C4
		lea	($FFFFB04A).w,a1
		lea	$34(a0),a2
		addq.b	#1,d6
		move.w	($FFFFF66A).w,d5
		bsr.s	sub_338C4
		move.b	($FFFFFE05).w,d0
		andi.b	#$3F,d0
		bne.s	loc_338BE
		move.w	$10(a0),d0
		sub.w	($FFFFEE78).w,d0
		addi.w	#$40,d0
		cmpi.w	#$1C0,d0
		bcc.s	loc_338BE

loc_3389A:
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		add.w	$38(a0),d0
		addi.w	#$40,d0
		move.w	$3A(a0),d1
		addi.w	#$80,d1
		cmp.w	d1,d0
		bcc.s	loc_338BE
		moveq	#-$3A,d0
		jsr	(Play_Sound_2).l

loc_338BE:

		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_338C4:

		btst	d6,$2A(a0)
		bne.w	loc_339A0
		tst.b	1(a2)
		beq.s	loc_338D8
		subq.b	#1,1(a2)
		rts
; ---------------------------------------------------------------------------

loc_338D8:
		moveq	#0,d1
		move.b	$1E(a1),d1
		addi.w	#$44,d1
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		add.w	d1,d1
		cmp.w	d1,d0
		bcc.w	locret_3399E
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		add.w	$38(a0),d0
		cmp.w	$3A(a0),d0
		bcc.w	locret_3399E
		tst.b	$2E(a1)
		bne.w	locret_3399E
		tst.w	($FFFFFE08).w
		bne.w	locret_3399E
		subi.w	#$10,d0
		bcc.s	loc_33922
		sub.w	d0,$14(a1)

loc_33922:
		btst	#1,$2A(a1)
		beq.w	loc_33958
		tst.b	$26(a1)
		beq.s	loc_3394C
		bclr	#1,$2A(a1)
		move.w	$1C(a1),d0
		bpl.s	loc_33940
		neg.w	d0

loc_33940:
		cmpi.w	#$400,d0
		bcc.s	loc_33958
		bset	#1,$2A(a1)

loc_3394C:
		move.b	#1,1(a2)
		bset	#0,$2E(a1)

loc_33958:

		bsr.w	sub_33C34
		move.b	#-$80,(a2)
		move.b	#-$40,$26(a1)
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		bcs.s	loc_3397A
		move.b	#$40,$26(a1)
		move.b	#0,(a2)

loc_3397A:
		bclr	#0,$2A(a1)
		bclr	#0,4(a1)
		bclr	#1,4(a1)
		bset	#6,$2E(a1)
		bset	#1,$2E(a1)
		move.b	#0,$20(a1)

locret_3399E:

		rts
; ---------------------------------------------------------------------------

loc_339A0:
		tst.b	1(a2)
		bne.w	loc_33ADE
		tst.w	($FFFFFE08).w
		bne.s	loc_33A0E
		move.w	$1C(a1),d0
		bpl.s	loc_339B6
		neg.w	d0

loc_339B6:
		cmpi.w	#$300,d0
		bcc.s	loc_339CC
		move.b	#1,1(a2)
		bset	#0,$2E(a1)
		bra.w	loc_33ADE
; ---------------------------------------------------------------------------

loc_339CC:
		btst	#1,$2A(a1)
		beq.s	loc_339FC
		move.w	#-$800,$18(a1)
		move.w	#-$200,$1A(a1)
		bset	#0,$2A(a1)
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		bcs.s	loc_33A0E
		neg.w	$18(a1)
		bclr	#0,$2A(a1)
		bra.s	loc_33A0E
; ---------------------------------------------------------------------------

loc_339FC:
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		add.w	$38(a0),d0
		cmp.w	$3A(a0),d0
		bcs.s	loc_33A50

loc_33A0E:

		move.b	#0,$26(a1)
		bclr	#2,$2A(a1)
		move.b	#$13,$1E(a1)
		move.b	#9,$1F(a1)
		move.w	#1,$20(a1)
		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		bclr	#6,$2E(a1)
		bclr	#1,$2E(a1)
		andi.w	#$7FFF,$A(a1)
		move.b	#$10,1(a2)
		rts
; ---------------------------------------------------------------------------

loc_33A50:
		move.w	$1A(a0),d1
		bpl.s	loc_33A5C
		cmpi.w	#$10,d0
		bls.s	loc_33A60

loc_33A5C:
		add.w	d1,$14(a1)

loc_33A60:
		subi.w	#$10,d0
		bcc.s	loc_33A6A
		sub.w	d0,$14(a1)

loc_33A6A:
		moveq	#0,d0
		move.b	(a2),d0
		addq.b	#4,(a2)
		jsr	(GetSineCosine).l
		move.w	d1,d3
		asr.w	#2,d1
		add.w	$10(a0),d1
		moveq	#0,d0
		move.b	$1E(a1),d0
		muls.w	d3,d0
		asr.w	#8,d0
		add.w	d0,d1
		move.w	d1,$10(a1)
		moveq	#0,d0
		move.b	(a2),d0
		andi.w	#$7FFF,$A(a1)
		cmpi.b	#-$80,d0
		bcs.s	loc_33AA4
		ori.w	#-$8000,$A(a1)

loc_33AA4:
		addi.b	#$40,d0
		neg.b	d0
		andi.w	#$FF,d0
		divu.w	#$B,d0
		move.b	RawAni_33AC6(pc,d0.w),$22(a1)
		moveq	#0,d0
		move.b	$22(a1),d0
		jmp	(Tails_Carry_LoadPLC).l
; ---------------------------------------------------------------------------
		rts
; ---------------------------------------------------------------------------
RawAni_33AC6:	dc.b  $76, $76, $77, $77, $6C, $6C, $6D, $6D, $6E, $6E, $6F, $6F, $70, $70, $71, $71, $72, $72, $73, $73
		dc.b  $74, $74, $75, $75
; ---------------------------------------------------------------------------

loc_33ADE:

		tst.w	($FFFFFE08).w
		bne.s	loc_33B62
		andi.w	#$70,d5
		beq.s	loc_33B1E
		bset	#1,$2A(a1)
		move.b	#0,$40(a1)
		move.w	#-$800,$18(a1)
		move.w	#-$200,$1A(a1)
		bset	#0,$2A(a1)
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		bcs.s	loc_33B62
		neg.w	$18(a1)
		bclr	#0,$2A(a1)
		bra.s	loc_33B62
; ---------------------------------------------------------------------------

loc_33B1E:
		btst	#1,$2A(a1)
		bne.s	loc_33B62
		move.w	$14(a1),d0
		sub.w	$14(a0),d0

loc_33B2E:
		add.w	$38(a0),d0
		cmp.w	$3A(a0),d0
		bcs.s	loc_33BAA
		bne.s	loc_33B62
		move.b	(a2),d0
		andi.b	#$7F,d0
		bne.s	loc_33BBA
		move.w	#-$100,$18(a1)
		move.w	#0,$1A(a1)
		tst.b	(a2)
		bmi.s	loc_33B56
		neg.w	$18(a1)

loc_33B56:
		move.w	$18(a1),$1C(a1)
		bset	#1,$2A(a1)

loc_33B62:

		move.b	#0,$26(a1)
		bclr	#2,$2A(a1)
		move.b	#$13,$1E(a1)
		move.b	#9,$1F(a1)
		move.w	#1,$20(a1)
		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		bclr	#6,$2E(a1)
		bclr	#1,$2E(a1)
		bclr	#0,$2E(a1)
		andi.w	#$7FFF,$A(a1)
		move.b	#$10,1(a2)
		rts
; ---------------------------------------------------------------------------

loc_33BAA:
		move.w	$1A(a0),d1
		bpl.s	loc_33BB6
		cmpi.w	#$10,d0
		bls.s	loc_33BBA

loc_33BB6:
		add.w	d1,$14(a1)

loc_33BBA:

		moveq	#0,d0
		move.b	(a2),d0
		addq.b	#4,(a2)
		jsr	(GetSineCosine).l
		move.w	d1,d3
		asr.w	#2,d1
		add.w	$10(a0),d1
		moveq	#0,d0
		move.b	$1E(a1),d0
		muls.w	d3,d0
		asr.w	#8,d0
		add.w	d0,d1
		move.w	d1,$10(a1)
		moveq	#0,d0
		move.b	(a2),d0
		andi.w	#$7FFF,$A(a1)
		cmpi.b	#-$80,d0
		bcs.s	loc_33BF4
		ori.w	#-$8000,$A(a1)

loc_33BF4:
		addi.b	#$40,d0
		neg.b	d0
		andi.w	#$FF,d0
		divu.w	#$B,d0
		move.b	RawAni_33C1C(pc,d0.w),$22(a1)
		move.b	#0,$20(a1)
		moveq	#0,d0
		move.b	$22(a1),d0
		jmp	(Tails_Carry_LoadPLC).l
; End of function sub_338C4

; ---------------------------------------------------------------------------
		rts
; ---------------------------------------------------------------------------
RawAni_33C1C:	dc.b  $5E, $5E, $5E, $5F, $5F, $5F, $5F, $60, $60, $60, $60, $60, $61, $61, $61, $61, $5C, $5C, $5C, $5C
		dc.b  $5D, $5D, $5D, $5D

; =============== S U B R O U T I N E =======================================


sub_33C34:

		btst	#3,$2A(a1)
		beq.s	loc_33C44
		movea.w	$42(a1),a3
		bclr	d6,$2A(a3)

loc_33C44:
		move.w	a0,$42(a1)
		btst	#1,$2A(a1)
		beq.s	loc_33C62
		move.w	#0,$18(a1)
		move.l	a0,-(sp)
		movea.l	a1,a0
		jsr	(Player_TouchFloor).l
		movea.l	(sp)+,a0

loc_33C62:
		bset	#3,$2A(a1)
		bclr	#1,$2A(a1)
		bset	d6,$2A(a0)
		rts
; End of function sub_33C34

; ---------------------------------------------------------------------------

Obj_50_1:
		moveq	#0,d0
		move.b	$2C(a0),d0

loc_33C7A:
		lsl.w	#4,d0
		move.w	d0,$3C(a0)
		move.l	#loc_33C86,(a0)

loc_33C86:
		lea	($FFFFB000).w,a1
		lea	$30(a0),a2
		moveq	#3,d6
		move.w	($FFFFF602).w,d5
		bsr.s	sub_33CAC
		lea	($FFFFB04A).w,a1
		lea	$36(a0),a2
		addq.b	#1,d6
		move.w	($FFFFF66A).w,d5
		bsr.s	sub_33CAC
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_33CAC:

		btst	d6,$2A(a0)
		bne.w	loc_33D8A

loc_33CB4:
		tst.b	4(a2)
		beq.s	loc_33CE6
		subq.b	#1,4(a2)
		bne.s	loc_33CC6
		bclr	#0,$2E(a1)

loc_33CC6:
		move.w	$18(a1),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$10(a1)
		move.w	$1A(a1),d0
		addi.w	#$38,$1A(a1)
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$14(a1)
		rts
; ---------------------------------------------------------------------------

loc_33CE6:
		moveq	#0,d1
		move.b	$1E(a1),d1
		addi.w	#$24,d1
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		add.w	d1,d1
		cmp.w	d1,d0
		bcc.w	locret_33D88
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		cmpi.w	#$20,d0
		bcc.s	locret_33D88
		tst.b	$2E(a1)
		bne.s	locret_33D88
		tst.w	($FFFFFE08).w
		bne.s	locret_33D88
		btst	#1,$2A(a1)
		bne.s	locret_33D88
		move.b	$26(a1),d0
		andi.b	#$7F,d0
		cmpi.w	#$40,d0
		bne.s	locret_33D88
		move.l	$14(a1),(a2)
		move.w	(a2),d0
		sub.w	$14(a0),d0
		move.w	d0,(a2)
		bsr.w	sub_33C34
		move.b	#-$40,$26(a1)
		bclr	#0,4(a1)
		move.b	#-$80,5(a2)
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		bcs.s	loc_33D70
		move.b	#$40,$26(a1)
		bset	#0,4(a1)
		move.b	#0,5(a2)

loc_33D70:
		bset	#1,4(a1)
		bset	#6,$2E(a1)
		bset	#1,$2E(a1)
		move.b	#0,$20(a1)

locret_33D88:

		rts
; ---------------------------------------------------------------------------

loc_33D8A:
		tst.w	($FFFFFE08).w
		bne.w	loc_33E7A
		andi.w	#$70,d5
		beq.s	loc_33DDC
		move.b	#8,4(a2)
		bset	#0,$2E(a1)
		bset	#1,$2A(a1)
		move.b	#0,$40(a1)
		move.w	#-$800,$18(a1)
		move.w	#-$200,$1A(a1)
		bset	#0,$2A(a1)
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		bcs.w	loc_33E7A
		neg.w	$18(a1)
		bclr	#0,$2A(a1)
		bra.w	loc_33E7A
; ---------------------------------------------------------------------------

loc_33DDC:
		move.w	$1C(a1),d0
		bpl.s	loc_33DF2
		neg.w	d0
		cmpi.w	#$400,d0
		bcc.s	loc_33DFE
		move.w	#-$400,$1C(a1)
		bra.s	loc_33DFE
; ---------------------------------------------------------------------------

loc_33DF2:
		cmpi.w	#$400,d0
		bcc.s	loc_33DFE
		move.w	#$400,$1C(a1)

loc_33DFE:

		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		cmp.w	$3C(a0),d0
		bcs.w	loc_33EBE
		move.w	$1C(a1),d0
		bpl.s	loc_33E2A
		neg.w	d0
		cmpi.w	#$C00,d0
		bcs.s	loc_33E3C
		move.w	#-$C00,$1C(a1)
		move.w	#$C00,$1A(a1)
		bra.s	loc_33E3C
; ---------------------------------------------------------------------------

loc_33E2A:
		cmpi.w	#$C00,d0
		bcs.s	loc_33E3C
		move.w	#$C00,$1C(a1)
		move.w	#$C00,$1A(a1)

loc_33E3C:

		move.w	$1A(a1),d0
		ext.l	d0
		lsl.l	#6,d0
		move.l	d0,d1
		add.l	d0,d0
		add.l	d1,d0
		add.l	(a2),d0
		swap	d0
		moveq	#0,d2
		mulu.w	#$155,d0
		lsr.l	#8,d0
		move.w	d0,d2
		add.b	5(a2),d0
		jsr	(GetSineCosine).l
		move.w	d1,d3
		asr.w	#3,d1
		add.w	$10(a0),d1
		moveq	#0,d0
		move.b	$1E(a1),d0
		muls.w	d3,d0
		asr.w	#8,d0
		add.w	d0,d1
		move.w	d1,$10(a1)

loc_33E7A:

		btst	#0,$2A(a0)
		beq.s	loc_33E88
		addi.b	#-$80,$26(a1)

loc_33E88:
		bclr	#2,$2A(a1)
		move.b	#$13,$1E(a1)
		move.b	#9,$1F(a1)
		move.w	#1,$20(a1)
		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		bclr	#6,$2E(a1)
		bclr	#1,$2E(a1)
		andi.w	#$7FFF,$A(a1)
		rts
; ---------------------------------------------------------------------------

loc_33EBE:
		move.w	$1C(a1),d0
		bpl.s	loc_33EDA
		neg.w	d0
		cmpi.w	#$C00,d0
		bcs.s	loc_33EEC
		move.w	#-$C00,$1C(a1)
		move.w	#$C00,$1A(a1)
		bra.s	loc_33EEC
; ---------------------------------------------------------------------------

loc_33EDA:
		cmpi.w	#$C00,d0
		bcs.s	loc_33EEC
		move.w	#$C00,$1C(a1)
		move.w	#$C00,$1A(a1)

loc_33EEC:

		move.w	$1A(a1),d0
		ext.l	d0
		lsl.l	#6,d0
		move.l	d0,d1
		add.l	d0,d0
		add.l	d1,d0
		add.l	d0,(a2)
		moveq	#0,d0
		moveq	#0,d2
		move.w	(a2),d0
		mulu.w	#$155,d0
		lsr.l	#8,d0
		move.w	d0,d2
		add.b	5(a2),d0
		jsr	(GetSineCosine).l
		move.w	d1,d3
		asr.w	#3,d1
		add.w	$10(a0),d1
		moveq	#0,d0
		move.b	$1E(a1),d0
		muls.w	d3,d0
		asr.w	#8,d0
		add.w	d0,d1
		move.w	d1,$10(a1)
		move.w	(a2),d0
		add.w	$14(a0),d0

loc_33F32:
		move.w	d0,$14(a1)
		moveq	#0,d0
		andi.w	#$7FFF,$A(a1)
		cmpi.b	#-$80,d2
		bcc.s	loc_33F4A
		ori.w	#-$8000,$A(a1)

loc_33F4A:
		subi.b	#$40,d2
		neg.b	d2
		andi.w	#$FF,d2
		divu.w	#$B,d2
		move.b	byte_33F6C(pc,d2.w),$22(a1)
		moveq	#0,d0
		move.b	$22(a1),d0
		jmp	(Tails_Carry_LoadPLC).l
; End of function sub_33CAC

; ---------------------------------------------------------------------------
		rts
; ---------------------------------------------------------------------------
byte_33F6C:	dc.b  $76, $76, $77, $77, $6C, $6C, $6D, $6D, $6E, $6E, $6F, $6F, $70, $70, $71, $71, $72, $72, $73, $73
		dc.b  $74, $74, $75, $75
; ---------------------------------------------------------------------------

Obj_MGZSwingingPlatform:

		move.l	#Map_MGZSwingingPlatform,$C(a0)
		move.w	#$435F,$A(a0)
		move.b	#4,4(a0)
		move.b	#$18,7(a0)
		move.b	#$C,6(a0)
		move.w	#$200,8(a0)
		move.w	$10(a0),$30(a0)
		move.w	$14(a0),$32(a0)
		move.b	#2,$22(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_3401C
		move.l	#loc_3406E,(a1)
		move.l	#Map_MGZSwingingPlatform,$C(a1)
		move.w	#$435F,$A(a1)
		move.b	#4,4(a1)
		move.b	#$50,7(a1)
		move.b	#$50,6(a1)
		move.w	#$280,8(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		btst	#1,$2A(a0)
		bne.s	loc_3400C
		move.b	#1,$22(a1)

loc_3400C:
		bset	#6,4(a1)
		move.w	#4,$16(a1)
		move.w	a1,$3C(a0)

loc_3401C:
		moveq	#1,d0
		btst	#0,$2A(a0)
		beq.s	loc_34028
		neg.w	d0

loc_34028:
		move.b	d0,$36(a0)
		move.b	$2C(a0),d0
		move.b	d0,$34(a0)
		move.l	#loc_3403A,(a0)

loc_3403A:
		move.w	$10(a0),-(sp)
		movea.w	$3C(a0),a1
		bsr.w	sub_34074
		move.b	$36(a0),d0
		add.b	d0,$34(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		moveq	#0,d3
		move.b	6(a0),d3
		addq.w	#1,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectTop).l
		move.w	$30(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_3406E:
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_34074:
		move.b	$34(a0),d0
		jsr	(GetSineCosine).l
		move.w	$32(a0),d2
		move.w	$30(a0),d3
		swap	d0
		swap	d1
		asr.l	#4,d0
		asr.l	#4,d1
		move.l	d0,d4
		move.l	d1,d5
		lea	$18(a1),a2
		move.w	$16(a1),d6
		subq.w	#1,d6

loc_3409C:
		movem.l	d4-d5,-(sp)
		swap	d4
		swap	d5
		add.w	d2,d4
		add.w	d3,d5
		move.w	d5,(a2)+
		move.w	d4,(a2)+
		movem.l	(sp)+,d4-d5
		add.l	d0,d4
		add.l	d1,d5
		addq.w	#2,a2
		dbf	d6,loc_3409C
		swap	d4
		swap	d5
		add.w	d2,d4
		add.w	d3,d5
		move.w	d5,$10(a0)
		move.w	d4,$14(a0)
		rts
; End of function sub_34074

; ---------------------------------------------------------------------------

Obj_MGZSwingingSpikeBall:

		move.l	#Map_MGZSwingingSpikeBall,$C(a0)
		move.w	#$235F,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$20,7(a0)
		move.b	#$20,6(a0)
		move.w	#$200,8(a0)
		move.w	$10(a0),$30(a0)
		move.w	$14(a0),$32(a0)
		move.b	#3,$22(a0)
		move.b	#-$71,$28(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_34180
		move.l	#loc_34244,(a1)
		move.l	#Map_MGZSwingingSpikeBall,$C(a1)
		move.w	#$235F,$A(a1)
		move.b	4(a0),4(a1)
		move.b	#$50,7(a1)
		move.b	#$50,6(a1)
		move.w	#$280,8(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		bset	#6,4(a1)
		move.w	#4,$16(a1)
		lea	$18(a1),a2
		move.w	$16(a1),d0

loc_34160:
		move.w	$10(a0),(a2)+
		move.w	$14(a0),(a2)+
		move.w	#0,(a2)+
		dbf	d0,loc_34160
		move.w	#1,-2(a2)
		move.b	#1,$22(a1)
		move.w	a1,$3C(a0)

loc_34180:
		move.b	$2C(a0),d0
		beq.s	loc_341A6
		move.w	#2,-2(a2)
		move.b	#2,$22(a1)
		move.w	#-$8000,$34(a0)
		move.w	#$100,$36(a0)
		move.l	#loc_341FA,(a0)
		bra.s	loc_341FA
; ---------------------------------------------------------------------------

loc_341A6:
		moveq	#2,d0
		btst	#1,$2A(a0)
		beq.s	loc_341B2
		neg.w	d0

loc_341B2:
		move.b	d0,$36(a0)
		move.l	#loc_341BC,(a0)

loc_341BC:
		movea.w	$3C(a0),a1
		bsr.w	sub_3424A
		move.b	$34(a0),d2
		move.b	$36(a0),d0
		add.b	d0,$34(a0)
		tst.b	4(a0)
		bpl.s	loc_341F0
		move.b	$34(a0),d0
		eor.b	d0,d2
		andi.b	#$40,d2
		beq.s	loc_341F0
		andi.b	#$40,d0
		beq.s	loc_341F0
		moveq	#-$37,d0
		jsr	(Play_Sound_2).l

loc_341F0:

		move.w	$30(a0),d0
		jmp	(loc_1B666).l
; ---------------------------------------------------------------------------

loc_341FA:

		movea.w	$3C(a0),a1
		bsr.w	sub_342A6
		move.b	$34(a0),d2
		bpl.s	loc_34210
		addi.w	#$10,$36(a0)
		bra.s	loc_34216
; ---------------------------------------------------------------------------

loc_34210:
		subi.w	#$10,$36(a0)

loc_34216:
		move.w	$36(a0),d0
		add.w	d0,$34(a0)
		tst.b	4(a0)
		bpl.s	loc_3423E
		move.b	$34(a0),d0
		eor.b	d0,d2
		andi.b	#$40,d2
		beq.s	loc_3423E
		andi.b	#$40,d0
		beq.s	loc_3423E
		moveq	#-$37,d0
		jsr	(Play_Sound_2).l

loc_3423E:

		jmp	(loc_1B662).l
; ---------------------------------------------------------------------------

loc_34244:
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_3424A:
		move.w	#$200,8(a0)
		move.b	#0,$22(a1)
		move.w	#5,$16(a1)
		move.b	$34(a0),d0
		bpl.s	loc_34274
		move.w	#$300,8(a0)
		move.b	#1,$22(a1)
		move.w	#4,$16(a1)

loc_34274:
		jsr	(GetSineCosine).l
		move.w	$30(a0),d3
		swap	d1
		asr.l	#4,d1
		move.l	d1,d5
		lea	$18(a1),a2
		moveq	#3,d6

loc_3428A:
		move.l	d5,d4
		swap	d4
		add.w	d3,d4
		move.w	d4,(a2)+
		add.l	d1,d5
		addq.w	#4,a2
		dbf	d6,loc_3428A
		add.l	d1,d5
		swap	d5
		add.w	d3,d5
		move.w	d5,$10(a0)
		rts
; End of function sub_3424A


; =============== S U B R O U T I N E =======================================


sub_342A6:
		move.w	#$200,8(a0)
		move.b	#0,$22(a1)
		move.w	#5,$16(a1)
		move.b	$34(a0),d0
		bpl.s	loc_342D0
		move.w	#$300,8(a0)
		move.b	#2,$22(a1)
		move.w	#4,$16(a1)

loc_342D0:
		jsr	(GetSineCosine).l
		move.w	$32(a0),d3
		swap	d1
		asr.l	#4,d1
		move.l	d1,d5
		lea	$1A(a1),a2
		moveq	#3,d6

loc_342E6:
		move.l	d5,d4
		swap	d4
		add.w	d3,d4
		move.w	d4,(a2)+
		add.l	d1,d5
		addq.w	#4,a2
		dbf	d6,loc_342E6
		add.l	d1,d5
		swap	d5
		add.w	d3,d5
		move.w	d5,$14(a0)
		rts
; End of function sub_342A6

; ---------------------------------------------------------------------------

Obj_MGZHeadTrigger:

		move.l	#Map_MGZHeadTrigger,$C(a0)
		move.w	#-$5C01,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#$10,7(a0)
		move.b	#$38,6(a0)
		move.b	#2,$22(a0)
		move.b	#$17,$28(a0)
		move.b	#3,$29(a0)
		bset	#6,4(a0)
		move.w	#1,$16(a0)
		lea	$18(a0),a2
		move.w	$10(a0),(a2)+
		move.w	$14(a0),(a2)+
		move.w	#6,(a2)+
		btst	#0,$2A(a0)
		bne.s	loc_34364
		move.w	#$C0,$30(a0)

loc_34364:
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		tst.b	(a3,d0.w)
		beq.s	loc_34388
		move.b	#1,$34(a0)
		move.b	#0,$22(a0)
		move.b	#0,$28(a0)

loc_34388:
		move.l	#loc_3438E,(a0)

loc_3438E:
		tst.b	$34(a0)
		bne.w	loc_34512
		move.w	($FFFFB010).w,d0
		sub.w	$10(a0),d0
		add.w	$30(a0),d0
		cmpi.w	#$C0,d0
		bcc.s	loc_343C6
		move.w	($FFFFB014).w,d0
		sub.w	$14(a0),d0
		addi.w	#$80,d0
		cmpi.w	#$C0,d0
		bcc.s	loc_343C6
		tst.b	$20(a0)
		bne.s	loc_343C6
		move.w	#$100,$20(a0)

loc_343C6:

		tst.b	$28(a0)
		bne.w	loc_3447C
		tst.w	$32(a0)
		beq.s	loc_343E6
		subq.w	#1,$32(a0)
		bne.w	loc_3447C
		move.b	#$17,$28(a0)
		bra.w	loc_3447C
; ---------------------------------------------------------------------------

loc_343E6:
		move.w	#$3C,$32(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_34474
		move.l	#loc_34536,(a1)
		tst.b	$29(a0)
		bne.s	loc_34432
		move.l	#Obj_Explosion,(a1)
		move.w	#-$8000,$A(a1)
		move.b	#2,5(a1)
		move.b	#1,$34(a0)
		move.b	#0,$22(a0)
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		move.b	#1,(a3,d0.w)

loc_34432:
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	4(a0),4(a1)
		andi.b	#-$41,4(a1)
		move.b	$2A(a0),$2A(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.w	#$200,8(a1)
		move.b	#8,7(a1)
		move.b	#8,6(a1)
		move.b	#2,$20(a1)

loc_34474:
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l

loc_3447C:

		lea	(Ani_MGZHeadTrigger).l,a1
		jsr	(Animate_Sprite).l
		tst.b	5(a0)
		beq.w	loc_34512
		clr.b	5(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_34512
		move.l	#loc_34518,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$10,$10(a1)
		addi.w	#$20,$14(a1)
		move.b	4(a0),4(a1)
		andi.b	#-$41,4(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		andi.w	#$7FFF,$A(a1)
		move.w	#$300,8(a1)
		move.b	#$10,7(a1)
		move.b	#4,6(a1)
		move.b	#-$65,$28(a1)
		move.w	#-$400,$18(a1)
		btst	#0,$2A(a0)
		beq.s	loc_3450A
		neg.w	$18(a1)
		subi.w	#$20,$10(a1)

loc_3450A:
		moveq	#$67,d0
		jsr	(Play_Sound_2).l

loc_34512:

		jmp	(loc_1B662).l
; ---------------------------------------------------------------------------

loc_34518:
		tst.b	4(a0)
		bpl.s	loc_34530
		jsr	(MoveSprite2).l
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_34530:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_34536:
		lea	(Ani_MGZHeadTrigger).l,a1
		jsr	(Animate_Sprite).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
Ani_MGZHeadTrigger:	include "Levels\MGZ\Misc Object Data\Anim - Head Trigger.asm"

byte_34568:	dc.b  $40, $1E,	  0, $40, $20, $40,   1, $40, $20, $40,	  1, $40
; ---------------------------------------------------------------------------

Obj_MGZTriggerPlatform:

		move.b	$2C(a0),d1
		andi.w	#$F0,d1
		lsr.w	#2,d1
		lea	byte_34568(pc,d1.w),a1
		move.b	(a1)+,7(a0)
		move.b	(a1)+,6(a0)
		move.b	(a1)+,$22(a0)
		moveq	#0,d0
		move.b	(a1)+,d0
		move.w	d0,$30(a0)
		lsr.w	#2,d1
		move.w	d1,$34(a0)
		move.l	#Map_MGZTriggerPlatform,$C(a0)
		move.w	#$4001,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.w	$10(a0),$36(a0)
		tst.w	d1
		beq.s	loc_345FA
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		tst.b	(a3,d0.w)
		beq.s	loc_345F0
		move.w	$34(a0),d0
		btst	#0,$2A(a0)
		beq.s	loc_345E0
		neg.w	d0

loc_345E0:

		add.w	d0,$14(a0)
		subq.w	#1,$30(a0)
		bne.s	loc_345E0
		move.b	#-1,$32(a0)

loc_345F0:
		move.l	#loc_3466E,(a0)
		bra.w	loc_3466E
; ---------------------------------------------------------------------------

loc_345FA:
		move.l	#loc_34600,(a0)

loc_34600:
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		tst.b	(a3,d0.w)
		beq.s	loc_34646
		moveq	#2,d0
		btst	#0,$2A(a0)
		beq.s	loc_3461E
		neg.w	d0

loc_3461E:
		add.w	d0,$10(a0)
		move.w	#-1,($FFFFEECC).w
		subq.w	#1,$30(a0)
		bne.s	loc_34646
		move.w	#$7F00,$10(a0)
		move.w	#$7F00,$36(a0)
		move.w	#0,$48(a0)
		move.w	#0,($FFFFEECC).w

loc_34646:

		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		move.w	$36(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_3466E:

		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		tst.b	(a3,d0.w)
		beq.s	loc_3468C
		tst.b	$32(a0)
		bmi.s	loc_346BE
		move.b	#1,$32(a0)

loc_3468C:
		tst.b	$32(a0)
		beq.s	loc_346BE
		bmi.s	loc_346BE
		move.w	$34(a0),d0
		btst	#0,$2A(a0)
		beq.s	loc_346A2
		neg.w	d0

loc_346A2:
		add.w	d0,$14(a0)
		move.w	#-1,($FFFFEECC).w
		subq.w	#1,$30(a0)
		bne.s	loc_346BE
		move.b	#-1,$32(a0)
		move.w	#0,($FFFFEECC).w

loc_346BE:

		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_MGZMovingSpikePlatform:

		move.l	#Map_MGZMovingSpikePlatform,$C(a0)
		move.w	#$4001,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$200,8(a0)
		move.b	#$18,7(a0)
		move.b	#$30,6(a0)
		move.w	$10(a0),$30(a0)
		move.w	$14(a0),$32(a0)
		btst	#0,$2A(a0)
		beq.s	loc_34722
		move.b	#1,$34(a0)

loc_34722:
		move.l	#loc_34728,(a0)

loc_34728:
		move.w	$10(a0),-(sp)
		tst.b	$34(a0)
		bne.s	loc_3474C
		addq.w	#1,$10(a0)
		move.w	$30(a0),d0
		addi.w	#$50,d0
		cmp.w	$10(a0),d0
		bne.s	loc_34764
		move.b	#1,$34(a0)
		bra.s	loc_34764
; ---------------------------------------------------------------------------

loc_3474C:
		subq.w	#1,$10(a0)
		move.w	$30(a0),d0
		subi.w	#$50,d0
		cmp.w	$10(a0),d0
		bne.s	loc_34764
		move.b	#0,$34(a0)

loc_34764:

		moveq	#0,d0
		move.b	($FFFFFE80).w,d0
		add.w	$32(a0),d0
		move.w	d0,$14(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectFull).l
		swap	d6
		andi.w	#3,d6
		beq.s	loc_347E0
		move.b	d6,d0
		andi.b	#1,d0
		beq.s	loc_347BC
		bclr	#5,$2A(a0)
		lea	($FFFFB000).w,a1
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$28,d0
		bmi.s	loc_347BC
		jsr	(sub_24280).l

loc_347BC:

		andi.b	#2,d6
		beq.s	loc_347E0
		bclr	#6,$2A(a0)
		lea	($FFFFB04A).w,a1
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$28,d0
		bmi.s	loc_347E0
		jsr	(sub_24280).l

loc_347E0:

		subq.b	#1,$24(a0)
		bpl.s	loc_347F6
		move.b	#7,$24(a0)
		addq.b	#1,$22(a0)
		andi.b	#3,$22(a0)

loc_347F6:
		move.w	$30(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

Obj_MGZPulley:

		move.l	#Map_MGZPulley,$C(a0)
		move.w	#$235F,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$20,7(a0)
		move.b	#$20,6(a0)
		move.w	#$280,8(a0)
		bset	#6,4(a0)
		move.w	#1,$16(a0)
		lea	$18(a0),a2
		move.w	$10(a0),(a2)+
		move.w	$14(a0),(a2)+
		move.w	#0,(a2)+
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#3,d0
		move.w	d0,$40(a0)
		move.w	d0,$3C(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_348FA
		move.l	#loc_34BEE,(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.b	4(a0),4(a1)
		move.b	#$60,7(a1)
		move.b	#-$40,6(a1)
		move.w	#$300,8(a1)
		move.w	$10(a0),$12(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		subi.w	#$78,$10(a1)
		btst	#0,$2A(a0)
		beq.s	loc_348AC
		addi.w	#$F0,$10(a1)

loc_348AC:
		addi.w	#$D0,$14(a1)
		bset	#6,4(a1)
		move.w	#8,$16(a1)
		lea	$18(a1),a2
		moveq	#7,d0
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		subi.w	#$C,d2
		subi.w	#8,d3
		subi.w	#$18,d2
		addi.w	#$30,d3

loc_348DC:
		move.w	d2,(a2)+
		move.w	d3,(a2)+
		move.w	#5,(a2)+
		subi.w	#$18,d2
		addi.w	#$30,d3
		dbf	d0,loc_348DC
		move.w	#6,-2(a2)
		move.w	a1,$3E(a0)

loc_348FA:
		move.l	#loc_34900,(a0)

loc_34900:
		moveq	#0,d4
		tst.b	$38(a0)
		bne.s	loc_34928
		move.w	$3C(a0),d0
		cmp.w	$40(a0),d0
		beq.s	loc_3498E
		bcc.s	loc_3491E
		addq.w	#2,$3C(a0)
		move.b	#-1,d4
		bra.s	loc_34966
; ---------------------------------------------------------------------------

loc_3491E:
		move.b	#1,d4
		subq.w	#2,$3C(a0)
		bra.s	loc_34966
; ---------------------------------------------------------------------------

loc_34928:
		tst.w	$34(a0)
		bne.s	loc_34946
		tst.w	$3C(a0)
		beq.s	loc_3498E
		move.b	#1,d4
		subq.w	#4,$3C(a0)
		bcc.s	loc_34966
		move.w	#0,$3C(a0)
		bra.s	loc_34966
; ---------------------------------------------------------------------------

loc_34946:
		subq.w	#1,$34(a0)
		cmpi.w	#$C,$34(a0)
		bcs.s	loc_3498E
		move.w	$40(a0),d0
		addq.w	#8,d0
		cmp.w	$3C(a0),d0
		beq.s	loc_3498E
		addq.w	#2,$3C(a0)
		move.b	#-1,d4

loc_34966:

		subq.b	#1,$24(a0)
		bpl.s	loc_3497C
		move.b	#1,$24(a0)
		add.b	d4,$1D(a0)
		andi.b	#3,$1D(a0)

loc_3497C:
		tst.b	$22(a0)
		bne.s	loc_3498E
		tst.w	d4
		beq.s	loc_34994
		move.b	#4,$22(a0)
		bra.s	loc_34994
; ---------------------------------------------------------------------------

loc_3498E:

		move.b	#0,$22(a0)

loc_34994:

		bsr.w	sub_34B22
		bsr.w	sub_349A2
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_349A2:
		lea	$38(a0),a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF604).w,d0
		bsr.s	sub_349BA
		addq.w	#1,a2
		lea	($FFFFB04A).w,a1
		move.w	($FFFFF606).w,d0
; End of function sub_349A2


; =============== S U B R O U T I N E =======================================


sub_349BA:
		tst.b	(a2)
		beq.w	loc_34A5A
		tst.b	4(a1)
		bpl.s	loc_34A1A
		cmpi.b	#4,5(a1)
		bcc.s	loc_34A1A
		andi.b	#$70,d0
		beq.w	loc_34A28
		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$3C,2(a2)
		move.w	#-$400,$18(a1)
		btst	#0,$2A(a0)
		beq.s	loc_349F4
		neg.w	$18(a1)

loc_349F4:
		move.w	#-$600,$1A(a1)
		bset	#1,$2A(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		rts
; ---------------------------------------------------------------------------

loc_34A1A:

		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$3C,2(a2)
		rts
; ---------------------------------------------------------------------------

loc_34A28:
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		subi.w	#$26,d2
		addi.w	#$2E,d3
		move.w	$3C(a0),d0
		add.w	d0,d3
		lsr.w	#1,d0
		btst	#0,$2A(a0)
		beq.s	loc_34A4E
		addi.w	#$4C,d2
		neg.w	d0

loc_34A4E:
		sub.w	d0,d2
		move.w	d2,$10(a1)
		move.w	d3,$14(a1)
		rts
; ---------------------------------------------------------------------------

loc_34A5A:
		tst.b	2(a2)
		beq.s	loc_34A68
		subq.b	#1,2(a2)
		bne.w	locret_34B20

loc_34A68:
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		subi.w	#$26,d2
		addi.w	#$2E,d3
		move.w	$3C(a0),d0
		add.w	d0,d3
		lsr.w	#1,d0
		btst	#0,$2A(a0)
		beq.s	loc_34A8E
		addi.w	#$4C,d2
		neg.w	d0

loc_34A8E:
		sub.w	d0,d2
		move.w	$10(a1),d0
		sub.w	d2,d0
		addi.w	#$C,d0
		cmpi.w	#$18,d0
		bcc.w	locret_34B20
		move.w	$14(a1),d1
		sub.w	d3,d1
		addi.w	#$C,d1
		cmpi.w	#$18,d1
		bcc.w	locret_34B20
		tst.b	$2E(a1)
		bne.s	locret_34B20
		cmpi.b	#4,5(a1)
		bcc.s	locret_34B20
		tst.w	($FFFFFE08).w
		bne.s	locret_34B20
		move.w	$18(a1),d0
		btst	#0,$2A(a0)
		beq.s	loc_34AD6
		neg.w	d0

loc_34AD6:
		tst.w	d0
		bpl.s	locret_34B20
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		move.w	d2,$10(a1)
		move.w	d3,$14(a1)
		move.b	#$B,$20(a1)
		move.b	#1,$2E(a1)
		bclr	#0,$2A(a1)
		btst	#0,$2A(a0)
		beq.s	loc_34B0E
		bset	#0,$2A(a1)

loc_34B0E:
		move.w	#$10,$34(a0)
		move.b	#1,(a2)
		moveq	#$64,d0
		jsr	(Play_Sound_2).l

locret_34B20:

		rts
; End of function sub_349BA


; =============== S U B R O U T I N E =======================================


sub_34B22:
		btst	#0,$2A(a0)
		bne.s	loc_34B8C
		movea.w	$3E(a0),a1
		moveq	#0,d0
		move.w	$3C(a0),d0
		addi.w	#$18,d0
		divu.w	#$30,d0
		move.w	d0,$16(a1)
		move.w	d0,d1
		lea	$18(a1),a2
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		subi.w	#$C,d2
		subi.w	#8,d3
		swap	d0
		cmpi.w	#8,d1
		bne.s	loc_34B66
		move.w	#$30,d0
		moveq	#7,d1
		bra.s	loc_34B6A
; ---------------------------------------------------------------------------

loc_34B66:
		addq.w	#1,$16(a1)

loc_34B6A:
		add.w	d0,d3
		lsr.w	#1,d0
		sub.w	d0,d2

loc_34B70:
		move.w	d2,(a2)+
		move.w	d3,(a2)+
		move.w	#5,(a2)+
		subi.w	#$18,d2
		addi.w	#$30,d3
		dbf	d1,loc_34B70
		move.w	#6,-2(a2)
		rts
; ---------------------------------------------------------------------------

loc_34B8C:
		movea.w	$3E(a0),a1
		moveq	#0,d0
		move.w	$3C(a0),d0
		addi.w	#$18,d0
		divu.w	#$30,d0
		move.w	d0,$16(a1)
		move.w	d0,d1
		lea	$18(a1),a2
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		addi.w	#$C,d2
		subi.w	#8,d3
		swap	d0
		cmpi.w	#8,d1
		bne.s	loc_34BC8
		move.w	#$30,d0
		moveq	#7,d1
		bra.s	loc_34BCC
; ---------------------------------------------------------------------------

loc_34BC8:
		addq.w	#1,$16(a1)

loc_34BCC:
		add.w	d0,d3
		lsr.w	#1,d0
		add.w	d0,d2

loc_34BD2:
		move.w	d2,(a2)+
		move.w	d3,(a2)+
		move.w	#5,(a2)+
		addi.w	#$18,d2
		addi.w	#$30,d3
		dbf	d1,loc_34BD2
		move.w	#6,-2(a2)
		rts
; End of function sub_34B22

; ---------------------------------------------------------------------------

loc_34BEE:
		move.w	$12(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

Obj_MGZTopPlatform:

		move.l	#Map_MGZTopPlatform,$C(a0)
		move.w	#$235F,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#$18,7(a0)
		move.b	#$C,6(a0)
		move.b	#$1F,$1E(a0)
		move.b	#$18,$1F(a0)
		move.b	#$1F,$44(a0)
		move.b	#$18,$45(a0)
		move.w	$10(a0),$30(a0)
		move.w	$14(a0),$32(a0)
		move.b	#$C,$46(a0)
		move.b	#$D,$47(a0)
		move.l	#loc_34C54,(a0)

loc_34C54:
		lea	($FFFFB000).w,a1
		lea	$40(a0),a4
		move.w	($FFFFF602).w,d5
		moveq	#3,d6
		bsr.w	sub_34EEC
		lea	($FFFFB04A).w,a1
		lea	$42(a0),a4
		move.w	($FFFFF66A).w,d5
		moveq	#4,d6
		bsr.w	sub_34EEC
		tst.b	$2C(a0)
		bne.w	loc_34D62
		btst	#1,$2A(a0)
		beq.w	loc_34D0E
		cmpi.w	#$200,$1A(a0)
		bge.s	loc_34C98
		addi.w	#8,$1A(a0)

loc_34C98:
		jsr	(MoveSprite2).l
		subi.w	#$13,$14(a0)
		move.l	a1,-(sp)
		jsr	(sub_3526A).l
		movea.l	(sp)+,a1
		addi.w	#$13,$14(a0)
		tst.b	$2D(a0)
		beq.s	loc_34CD0
		move.w	#0,$1A(a0)
		move.w	#0,$18(a0)
		bclr	#1,$2A(a0)
		bra.w	loc_34D62
; ---------------------------------------------------------------------------

loc_34CD0:
		btst	#1,$2A(a0)
		bne.w	loc_34D62
		move.w	$18(a0),d0
		bpl.s	loc_34CE2
		neg.w	d0

loc_34CE2:
		cmpi.w	#$40,d0
		bcs.s	loc_34D62
		move.w	#$800,d1
		cmpi.w	#$100,d0
		bcs.s	loc_34CF6
		move.w	#$C00,d1

loc_34CF6:
		tst.w	$18(a0)
		bpl.s	loc_34CFE
		neg.w	d1

loc_34CFE:
		move.w	d1,$18(a0)
		move.w	d1,$1C(a0)
		move.b	#1,$34(a0)
		bra.s	loc_34D62
; ---------------------------------------------------------------------------

loc_34D0E:
		tst.b	$35(a0)
		beq.s	loc_34D1E
		bsr.w	sub_35868
		addq.w	#4,$24(a0)
		bra.s	loc_34D62
; ---------------------------------------------------------------------------

loc_34D1E:
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		muls.w	$1C(a0),d1
		asr.l	#8,d1
		move.w	d1,$18(a0)
		muls.w	$1C(a0),d0
		asr.l	#8,d0
		move.w	d0,$1A(a0)
		bsr.s	h
		jsr	(MoveSprite2).l
		tst.b	$2D(a0)
		bne.s	loc_34D4E
		bsr.w	sub_34E6E

loc_34D4E:
		addq.w	#4,$24(a0)
		tst.w	$1C(a0)
		bne.s	loc_34D5E
		move.b	#0,$34(a0)

loc_34D5E:
		bsr.w	sub_35666

loc_34D62:

		lea	($FFFFB000).w,a1
		lea	$40(a0),a4
		moveq	#3,d6
		bsr.w	sub_35202
		lea	($FFFFB04A).w,a1
		lea	$42(a0),a4
		moveq	#4,d6
		bsr.w	sub_35202
		move.w	$24(a0),d0
		asr.w	#3,d0
		andi.w	#1,d0
		move.b	d0,$22(a0)
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_34D92:
		jsr	(MoveSprite).l
		addq.w	#4,$24(a0)
		move.w	$24(a0),d0
		asr.w	#3,d0
		andi.w	#1,d0
		move.b	d0,$22(a0)
		tst.b	4(a0)
		bmi.s	loc_34DB6
		move.w	#$7F00,$10(a0)

loc_34DB6:
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


h:
		move.b	#$40,d1
		tst.w	$1C(a0)
		beq.s	locret_34E36
		bmi.s	loc_34DCA
		neg.w	d1

loc_34DCA:
		move.b	$26(a0),d0
		add.b	d1,d0
		move.w	d0,-(sp)
		move.b	#$13,$1E(a0)
		move.b	#$18,$1F(a0)
		subi.w	#$C,$14(a0)
		jsr	(sub_F6B4).l
		addi.w	#$C,$14(a0)
		move.w	(sp)+,d0
		tst.w	d1
		bpl.s	locret_34E36
		asl.w	#8,d1
		addi.b	#$20,d0
		andi.b	#-$40,d0
		beq.s	loc_34E68
		cmpi.b	#$40,d0
		beq.s	loc_34E3E
		cmpi.b	#-$80,d0
		beq.s	loc_34E38
		addi.b	#$30,d3
		cmpi.b	#$60,d3
		bcs.s	locret_34E36
		add.w	d1,$18(a0)
		move.w	#0,$1A(a0)
		move.w	#0,$1C(a0)
		btst	#0,$2A(a0)
		bne.s	locret_34E36
		bset	#5,$2A(a0)

locret_34E36:
		rts
; ---------------------------------------------------------------------------

loc_34E38:
		sub.w	d1,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_34E3E:
		addi.b	#$30,d3
		cmpi.b	#$60,d3
		bcs.s	locret_34E36
		sub.w	d1,$18(a0)
		move.w	#0,$1A(a0)
		move.w	#0,$1C(a0)
		btst	#0,$2A(a0)
		beq.s	locret_34E36
		bset	#5,$2A(a0)
		rts
; ---------------------------------------------------------------------------

loc_34E68:
		add.w	d1,$1A(a0)
		rts
; End of function h


; =============== S U B R O U T I N E =======================================


sub_34E6E:
		move.b	#$C,$1E(a0)
		move.b	#$A,$1F(a0)
		moveq	#3,d0
		move.b	d0,($FFFFF768).w
		move.b	d0,($FFFFF76A).w
		jsr	(sub_F76E).l
		tst.b	d3
		bpl.s	loc_34E9A
		cmpi.b	#-$1E,d3
		bcc.s	loc_34EA4
		move.b	#-$1E,d3
		bra.s	loc_34EA4
; ---------------------------------------------------------------------------

loc_34E9A:
		cmpi.b	#$1E,d3
		bls.s	loc_34EA4
		move.b	#$1E,d3

loc_34EA4:

		move.b	d3,$26(a0)
		tst.w	d1
		beq.s	locret_34EB8
		bpl.s	loc_34EBA
		cmpi.w	#-$E,d1
		blt.s	locret_34EB8
		add.w	d1,$14(a0)

locret_34EB8:

		rts
; ---------------------------------------------------------------------------

loc_34EBA:
		move.b	$18(a0),d0
		bpl.s	loc_34EC2
		neg.b	d0

loc_34EC2:
		addq.b	#4,d0
		cmpi.b	#$E,d0
		bcs.s	loc_34ECE
		move.b	#$E,d0

loc_34ECE:
		cmp.b	d0,d1
		bgt.s	loc_34ED8
		add.w	d1,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_34ED8:
		bset	#1,$2A(a0)
		bclr	#5,$2A(a0)
		move.b	#0,$34(a0)
		rts
; End of function sub_34E6E


; =============== S U B R O U T I N E =======================================


sub_34EEC:

		moveq	#0,d0
		move.b	(a4),d0
		move.w	off_34EF8(pc,d0.w),d0
		jmp	off_34EF8(pc,d0.w)
; End of function sub_34EEC

; ---------------------------------------------------------------------------
off_34EF8:	dc.w loc_34F04-off_34EF8

		dc.w loc_34F4C-off_34EF8
		dc.w loc_34FBC-off_34EF8
		dc.w loc_34F00-off_34EF8
; ---------------------------------------------------------------------------

loc_34F00:
		clr.w	(a4)
		rts
; ---------------------------------------------------------------------------

loc_34F04:
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(sub_1DC74).l
		btst	d6,$2A(a0)
		bne.s	loc_34F2A
		rts
; ---------------------------------------------------------------------------

loc_34F2A:
		tst.b	$37(a1)
		bmi.s	locret_34F4A
		addq.b	#2,(a4)
		move.b	#0,1(a4)
		move.w	$10(a0),d0
		sub.w	$10(a1),d0
		bcc.s	loc_34F48
		move.b	#1,1(a4)

loc_34F48:
		bra.s	loc_34F6A
; ---------------------------------------------------------------------------

locret_34F4A:
		rts
; ---------------------------------------------------------------------------

loc_34F4C:
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(sub_1DC74).l

loc_34F6A:
		btst	d6,$2A(a0)
		bne.s	loc_34F72
		clr.b	(a4)

loc_34F72:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		tst.b	1(a4)
		beq.s	loc_34F84
		addi.w	#$F,d0

loc_34F84:
		cmpi.w	#$10,d0
		bcc.s	locret_34FBA
		move.w	$10(a0),$10(a1)
		move.b	$44(a1),d0
		addi.b	#$18,d0
		move.b	d0,$1E(a1)
		bset	#0,$2E(a1)
		move.b	#-$80,$37(a1)
		bclr	d6,$2A(a0)
		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)
		addq.b	#2,(a4)

locret_34FBA:
		rts
; ---------------------------------------------------------------------------

loc_34FBC:
		tst.b	4(a1)
		bpl.s	loc_3500A
		cmpi.b	#4,5(a1)
		bcc.w	loc_3500A
		tst.w	($FFFFFE08).w
		bne.s	loc_3500A
		move.w	d5,d0
		andi.w	#$70,d0
		beq.w	loc_35028
		move.w	#-$680,$1A(a1)
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		move.w	#$62,d0
		jsr	(Play_Sound_2).l

loc_3500A:

		bclr	#0,$2E(a1)
		move.b	#0,$37(a1)
		bset	#1,$2A(a1)
		clr.b	(a4)
		cmpa.w	#-$5000,a1
		beq.w	sub_3519A

locret_35026:
		rts
; ---------------------------------------------------------------------------

loc_35028:
		move.w	d5,d0
		andi.w	#$C00,d0
		bne.s	loc_35048
		tst.w	$18(a0)
		beq.s	loc_35048
		bclr	#0,$2A(a1)
		tst.w	$18(a0)
		bpl.s	loc_35048
		bset	#0,$2A(a1)

loc_35048:

		move.b	$44(a1),d0
		addi.b	#$18,d0
		move.b	d0,$1E(a1)
		cmpa.w	#-$4FB6,a1
		bne.s	loc_3505C
		rts
; ---------------------------------------------------------------------------

loc_3505C:
		move.l	a0,-(sp)
		movea.l	a1,a0
		move.w	d5,d3
		cmpi.b	#$10,$20(a0)
		beq.s	loc_35070
		jsr	(sub_35504).l

loc_35070:
		jsr	(Player_Check_Screen_Boundaries).l
		jsr	(MoveSprite2).l
		movea.l	(sp)+,a0
		cmpi.b	#$10,$20(a1)
		bne.s	loc_350A6
		move.w	$18(a1),$18(a0)
		move.w	$1A(a1),$1A(a0)
		addi.w	#$38,$1A(a1)
		bset	#1,$2A(a0)
		move.b	#0,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_350A6:
		bclr	#6,$37(a1)
		beq.s	loc_350BA
		move.w	#0,$1C(a0)
		move.w	#0,$18(a0)

loc_350BA:
		bclr	#5,$37(a1)
		beq.s	loc_350C8
		move.w	#0,$1A(a0)

loc_350C8:
		move.w	$18(a0),$18(a1)
		move.w	$1A(a0),$1A(a1)
		move.w	$46(a1),$46(a0)
		tst.b	$34(a0)
		bne.w	locret_35026
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		beq.w	loc_35170
		bcc.w	loc_35130
		cmpi.w	#-$200,$18(a0)
		ble.s	loc_3510A

loc_350FA:
		add.w	d0,$18(a0)
		add.w	d0,$18(a0)
		add.w	d0,$18(a0)
		add.w	d0,$18(a0)

loc_3510A:
		add.w	d0,$24(a0)
		move.w	$18(a0),d0
		bpl.s	loc_35128
		asr.w	#4,d0
		subi.w	#8,$1A(a0)
		cmpi.w	#-$100,$1A(a0)
		ble.s	loc_35128
		add.w	d0,$1A(a0)

loc_35128:

		bset	#1,$2A(a0)
		rts
; ---------------------------------------------------------------------------

loc_35130:
		cmpi.w	#$200,$18(a0)
		bge.s	loc_35148
		add.w	d0,$18(a0)
		add.w	d0,$18(a0)
		add.w	d0,$18(a0)
		add.w	d0,$18(a0)

loc_35148:
		add.w	d0,$24(a0)
		move.w	$18(a0),d0
		bmi.s	loc_35168
		neg.w	d0
		asr.w	#4,d0
		subi.w	#8,$1A(a0)
		cmpi.w	#-$100,$1A(a0)
		ble.s	loc_35168
		add.w	d0,$1A(a0)

loc_35168:

		bset	#1,$2A(a0)
		rts
; ---------------------------------------------------------------------------

loc_35170:
		moveq	#1,d0
		tst.w	$18(a0)
		beq.s	loc_35180
		bmi.s	loc_3517C
		neg.w	d0

loc_3517C:
		add.w	d0,$18(a0)

loc_35180:
		add.w	d0,$24(a0)
		tst.w	$1A(a0)
		bpl.s	locret_3518E
		clr.w	$1A(a0)

locret_3518E:
		rts
; ---------------------------------------------------------------------------
		clr.w	$18(a0)
		clr.w	$1A(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_3519A:

		move.l	#loc_34D92,(a0)
		lea	($FFFFB000).w,a2
		cmpi.b	#4,$40(a0)
		bne.s	loc_351BE
		bclr	#0,$2E(a2)
		move.b	#0,$37(a2)
		bset	#1,$2A(a2)

loc_351BE:
		tst.b	$40(a0)
		beq.s	loc_351CA
		bclr	#3,$2A(a2)

loc_351CA:
		lea	($FFFFB04A).w,a2
		cmpi.b	#4,$42(a0)
		bne.s	loc_351E8
		bclr	#0,$2E(a2)
		move.b	#0,$37(a2)
		bset	#1,$2A(a2)

loc_351E8:
		tst.b	$42(a0)
		beq.s	loc_351F4

loc_351EE:
		bclr	#3,$2A(a2)

loc_351F4:
		move.b	#6,$40(a0)
		move.b	#6,$42(a0)
		rts
; End of function sub_3519A


; =============== S U B R O U T I N E =======================================


sub_35202:

		btst	#3,$2A(a1)
		bne.s	loc_35232
		cmpi.b	#4,(a4)
		bcs.s	locret_35230
		move.w	$14(a0),d0
		subi.w	#$C,d0
		moveq	#0,d1
		move.b	$44(a1),d1
		sub.w	d1,d0
		move.w	d0,$14(a1)
		move.w	$10(a0),$10(a1)
		move.b	#0,$2D(a0)

locret_35230:
		rts
; ---------------------------------------------------------------------------

loc_35232:
		cmpi.b	#4,(a4)
		bcs.s	locret_35268
		movea.w	$42(a1),a2
		cmpi.l	#loc_32AAE,(a2)
		bne.s	loc_35248
		bsr.w	sub_3519A

loc_35248:
		move.w	$10(a0),$10(a1)
		move.w	$14(a1),d0
		moveq	#0,d1
		move.b	$44(a1),d1
		add.w	d1,d0
		addi.w	#$D,d0
		move.w	d0,$14(a0)
		move.b	#1,$2D(a0)

locret_35268:
		rts
; End of function sub_35202


; =============== S U B R O U T I N E =======================================


sub_3526A:
		move.l	($FFFFF7B4).w,($FFFFF796).w
		cmpi.b	#$C,$46(a0)
		beq.s	loc_3527E
		move.l	($FFFFF7B8).w,($FFFFF796).w

loc_3527E:
		move.b	$47(a0),d5
		move.w	$18(a0),d1
		move.w	$1A(a0),d2
		jsr	(GetArcTan).l
		subi.b	#$20,d0
		andi.b	#-$40,d0
		cmpi.b	#$40,d0
		beq.w	loc_3536E
		cmpi.b	#-$80,d0
		beq.w	loc_353F8
		cmpi.b	#-$40,d0
		beq.w	loc_3547A
		move.b	#$C,$1E(a0)
		move.b	#$18,$1F(a0)
		jsr	(sub_FD32).l
		tst.w	d1
		bpl.s	loc_352D0
		sub.w	d1,$10(a0)
		move.w	#0,$18(a0)

loc_352D0:
		jsr	(sub_FA1A).l
		tst.w	d1
		bpl.s	loc_352E4
		add.w	d1,$10(a0)
		move.w	#0,$18(a0)

loc_352E4:
		move.b	#$1F,$1E(a0)
		move.b	#$A,$1F(a0)
		jsr	(sub_F76E).l
		tst.w	d1
		bpl.s	locret_3536C
		move.b	$1A(a0),d2
		addq.b	#8,d2
		neg.b	d2
		cmp.b	d2,d1
		bge.s	loc_3530A
		cmp.b	d2,d0
		blt.s	locret_3536C

loc_3530A:
		add.w	d1,$14(a0)
		move.b	d3,$26(a0)
		bclr	#1,$2A(a0)
		move.b	#0,$2D(a0)
		move.b	d3,d0
		addi.b	#$20,d0
		andi.b	#$40,d0
		bne.s	loc_3534A
		move.b	d3,d0
		addi.b	#$10,d0
		andi.b	#$20,d0
		beq.s	loc_3533C
		asr	$1A(a0)
		bra.s	loc_3535E
; ---------------------------------------------------------------------------

loc_3533C:
		move.w	#0,$1A(a0)
		move.w	$18(a0),$1C(a0)
		rts
; ---------------------------------------------------------------------------

loc_3534A:
		move.w	#0,$18(a0)
		cmpi.w	#$FC0,$1A(a0)
		ble.s	loc_3535E
		move.w	#$FC0,$1A(a0)

loc_3535E:

		move.w	$1A(a0),$1C(a0)
		tst.b	d3
		bpl.s	locret_3536C
		neg.w	$1C(a0)

locret_3536C:

		rts
; ---------------------------------------------------------------------------

loc_3536E:
		move.b	#$C,$1E(a0)
		move.b	#$18,$1F(a0)
		jsr	(sub_FD32).l
		tst.w	d1
		bpl.s	loc_3539E
		sub.w	d1,$10(a0)
		addi.b	#$30,d3
		cmpi.b	#$60,d3
		bcs.s	loc_3539E
		move.w	#0,$18(a0)

loc_35398:
		move.w	$1A(a0),$1C(a0)

loc_3539E:

		move.b	#$1F,$1E(a0)
		move.b	#$A,$1F(a0)
		jsr	(sub_FB5A).l
		tst.w	d1
		bpl.s	loc_353C6
		sub.w	d1,$14(a0)
		tst.w	$1A(a0)
		bpl.s	locret_353C4
		move.w	#0,$1A(a0)

locret_353C4:
		rts
; ---------------------------------------------------------------------------

loc_353C6:
		tst.w	$1A(a0)
		bmi.s	locret_353F6
		jsr	(sub_F76E).l
		tst.w	d1
		bpl.s	locret_353F6
		add.w	d1,$14(a0)
		move.b	d3,$26(a0)
		bclr	#1,$2A(a0)
		move.b	#0,$2D(a0)
		move.w	#0,$1A(a0)
		move.w	$18(a0),$1C(a0)

locret_353F6:

		rts
; ---------------------------------------------------------------------------

loc_353F8:
		move.b	#$C,$1E(a0)
		move.b	#$18,$1F(a0)
		jsr	(sub_FD32).l
		tst.w	d1
		bpl.s	loc_35418
		sub.w	d1,$10(a0)
		move.w	#0,$18(a0)

loc_35418:
		jsr	(sub_FA1A).l
		tst.w	d1
		bpl.s	loc_3542C
		add.w	d1,$10(a0)
		move.w	#0,$18(a0)

loc_3542C:
		move.b	#$1F,$1E(a0)
		move.b	#$A,$1F(a0)
		jsr	(sub_FB5A).l
		tst.w	d1
		bpl.s	locret_35478
		sub.w	d1,$14(a0)
		move.b	d3,d0
		addi.b	#$20,d0
		andi.b	#$40,d0
		bne.s	loc_3545A
		move.w	#0,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_3545A:
		move.b	d3,$26(a0)
		bclr	#1,$2A(a0)
		move.b	#0,$2D(a0)
		move.w	$1A(a0),$1C(a0)
		tst.b	d3
		bpl.s	locret_35478
		neg.w	$1C(a0)

locret_35478:

		rts
; ---------------------------------------------------------------------------

loc_3547A:
		move.b	#$C,$1E(a0)
		move.b	#$18,$1F(a0)
		jsr	(sub_FA1A).l
		tst.w	d1
		bpl.s	loc_354AA
		add.w	d1,$10(a0)
		addi.b	#$30,d3
		cmpi.b	#$60,d3
		bcs.s	loc_354AA
		move.w	#0,$18(a0)
		move.w	$1A(a0),$1C(a0)

loc_354AA:

		move.b	#$1F,$1E(a0)
		move.b	#$A,$1F(a0)
		jsr	(sub_FB5A).l
		tst.w	d1
		bpl.s	loc_354D2
		sub.w	d1,$14(a0)
		tst.w	$1A(a0)
		bpl.s	locret_354D0
		move.w	#0,$1A(a0)

locret_354D0:
		rts
; ---------------------------------------------------------------------------

loc_354D2:
		tst.w	$1A(a0)
		bmi.s	locret_35502
		jsr	(sub_F76E).l
		tst.w	d1
		bpl.s	locret_35502
		add.w	d1,$14(a0)
		move.b	d3,$26(a0)
		bclr	#1,$2A(a0)
		move.b	#0,$2D(a0)
		move.w	#0,$1A(a0)
		move.w	$18(a0),$1C(a0)

locret_35502:

		rts
; End of function sub_3526A


; =============== S U B R O U T I N E =======================================


sub_35504:
		move.w	#$600,d6
		move.w	#$C,d5
		move.w	#$80,d4
		btst	#$A,d3
		beq.s	loc_3551A
		bsr.w	sub_3555C

loc_3551A:
		btst	#$B,d3
		beq.s	loc_35524
		bsr.w	sub_355E4

loc_35524:
		move.w	d3,d0
		andi.w	#$C00,d0
		bne.s	loc_3554E
		move.w	$1C(a0),d0
		beq.s	loc_3554E
		bmi.s	loc_35542
		sub.w	d5,d0
		bcc.s	loc_3553C
		move.w	#0,d0

loc_3553C:
		move.w	d0,$1C(a0)
		bra.s	loc_3554E
; ---------------------------------------------------------------------------

loc_35542:
		add.w	d5,d0
		bcc.s	loc_3554A
		move.w	#0,d0

loc_3554A:
		move.w	d0,$1C(a0)

loc_3554E:

		move.w	$1C(a0),$18(a0)
		move.w	#0,$1A(a0)
		rts
; End of function sub_35504


; =============== S U B R O U T I N E =======================================


sub_3555C:
		move.w	$1C(a0),d0
		beq.s	loc_35564
		bpl.s	loc_35596

loc_35564:
		bset	#0,$2A(a0)
		bne.s	loc_35578
		bclr	#5,$2A(a0)
		move.b	#1,$21(a0)

loc_35578:
		sub.w	d5,d0
		move.w	d6,d1
		neg.w	d1
		cmp.w	d1,d0
		bgt.s	loc_3558A
		add.w	d5,d0
		cmp.w	d1,d0
		ble.s	loc_3558A
		move.w	d1,d0

loc_3558A:

		move.w	d0,$1C(a0)
		move.b	#0,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_35596:
		sub.w	d4,d0
		bcc.s	loc_3559E
		move.w	#-$80,d0

loc_3559E:
		move.w	d0,$1C(a0)
		move.b	$26(a0),d0
		addi.b	#$20,d0
		andi.b	#-$40,d0
		bne.s	locret_355E2
		cmpi.w	#$400,d0
		blt.s	locret_355E2
		move.b	#$D,$20(a0)
		bclr	#0,$2A(a0)
		move.w	#$36,d0
		jsr	(Play_Sound_2).l
		movea.l	a0,a2
		suba.w	#-$5000,a2
		adda.w	#-$33AC,a2
		move.b	#6,5(a2)
		move.b	#$15,$22(a2)

locret_355E2:

		rts
; End of function sub_3555C


; =============== S U B R O U T I N E =======================================


sub_355E4:
		move.w	$1C(a0),d0
		bmi.s	loc_35618
		bclr	#0,$2A(a0)
		beq.s	loc_355FE
		bclr	#5,$2A(a0)
		move.b	#1,$21(a0)

loc_355FE:
		add.w	d5,d0
		cmp.w	d6,d0
		blt.s	loc_3560C
		sub.w	d5,d0
		cmp.w	d6,d0
		bge.s	loc_3560C
		move.w	d6,d0

loc_3560C:

		move.w	d0,$1C(a0)
		move.b	#0,$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_35618:
		add.w	d4,d0
		bcc.s	loc_35620
		move.w	#$80,d0

loc_35620:
		move.w	d0,$1C(a0)
		move.b	$26(a0),d0
		addi.b	#$20,d0
		andi.b	#-$40,d0
		bne.s	locret_35664
		cmpi.w	#-$400,d0
		bgt.s	locret_35664
		move.b	#$D,$20(a0)
		bset	#0,$2A(a0)
		move.w	#$36,d0
		jsr	(Play_Sound_2).l
		movea.l	a0,a2
		suba.w	#-$5000,a2
		adda.w	#-$33AC,a2
		move.b	#6,5(a2)
		move.b	#$15,$22(a2)

locret_35664:

		rts
; End of function sub_355E4


; =============== S U B R O U T I N E =======================================


sub_35666:
		tst.w	($FFFFFE08).w
		bne.s	locret_356C8
		tst.b	$34(a0)
		beq.s	locret_356C8
		lea	(word_35784).l,a1
		tst.b	($FFFFFE11).w
		beq.s	loc_35684
		lea	(word_357F6).l,a1

loc_35684:
		move.w	(a1)+,d6
		move.w	$10(a0),d2
		move.w	$14(a0),d3

loc_3568E:
		move.w	(a1),d0
		sub.w	d2,d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.s	loc_356C0
		move.w	2(a1),d1
		sub.w	d3,d1
		addi.w	#$10,d1
		cmpi.w	#$20,d1
		bcc.s	loc_356C0
		move.w	$1C(a0),d0

loc_356B0:
		move.b	4(a1),d2
		andi.b	#$7F,d2
		beq.s	loc_356BC
		neg.w	d0

loc_356BC:
		tst.w	d0
		bpl.s	loc_356CA

loc_356C0:

		adda.w	#$10,a1
		dbf	d6,loc_3568E

locret_356C8:
		rts
; ---------------------------------------------------------------------------

loc_356CA:
		move.b	#1,$35(a0)
		move.w	4(a1),$3E(a0)
		addq.w	#6,a1
		move.w	(a1)+,d4
		move.w	d4,$30(a0)
		move.w	(a1)+,d5
		move.w	d5,d0
		move.b	$3F(a0),d1
		andi.b	#$7F,d1
		beq.s	loc_356EE
		sub.w	(a1),d0

loc_356EE:
		move.w	d0,$32(a0)
		move.l	a1,$36(a0)
		move.w	$1C(a0),d2
		bpl.s	loc_356FE
		neg.w	d2

loc_356FE:
		tst.w	d2
		bne.s	loc_35706
		move.w	#$800,d2

loc_35706:

		moveq	#0,d0
		move.w	d2,d3
		move.w	d4,d0
		sub.w	$10(a0),d0
		bge.s	loc_35716
		neg.w	d0
		neg.w	d2

loc_35716:
		moveq	#0,d1
		move.w	d5,d1
		sub.w	$14(a0),d1
		bge.s	loc_35724
		neg.w	d1
		neg.w	d3

loc_35724:
		cmp.w	d0,d1
		bcs.s	loc_35756
		moveq	#0,d1
		move.w	d5,d1
		sub.w	$14(a0),d1
		swap	d1
		divs.w	d3,d1
		moveq	#0,d0
		move.w	d4,d0
		sub.w	$10(a0),d0
		beq.s	loc_35742
		swap	d0
		divs.w	d1,d0

loc_35742:
		move.w	d0,$18(a0)
		move.w	d3,$1A(a0)
		tst.w	d1
		bpl.s	loc_35750
		neg.w	d1

loc_35750:
		move.w	d1,$3A(a0)
		rts
; ---------------------------------------------------------------------------

loc_35756:
		moveq	#0,d0
		move.w	d4,d0

loc_3575A:
		sub.w	$10(a0),d0
		swap	d0
		divs.w	d2,d0
		moveq	#0,d1
		move.w	d5,d1
		sub.w	$14(a0),d1
		beq.s	loc_35770
		swap	d1
		divs.w	d0,d1

loc_35770:
		move.w	d1,$1A(a0)
		move.w	d2,$18(a0)
		tst.w	d0
		bpl.s	loc_3577E
		neg.w	d0

loc_3577E:
		move.w	d0,$3A(a0)
		rts
; End of function sub_35666

; ---------------------------------------------------------------------------
word_35784:	dc.w	  6
		dc.w  $1BA0,   $C6,	0, $1C40
		dc.w	$E6,  $280, $1CE0,  $385
		dc.w  $1BA0,  $3C4, $8001, $1C40
		dc.w   $3A6,  $2C0, $1BA0,   $C6
		dc.w  $1CE0,  $385,  $101, $1C40
		dc.w   $366,  $280, $1BA0,   $C6
		dc.w  $2720,  $846,	0, $27C0
		dc.w   $866,  $200, $2860,  $A86
		dc.w  $2860,  $846,  $180, $27C0
		dc.w   $866,  $200, $2720,  $A86
		dc.w  $2720,  $A86,   $81, $27C0
		dc.w   $A66,  $200, $2860,  $846
		dc.w  $2860,  $A86,  $101, $27C0
		dc.w   $A66,  $200, $2720,  $846
word_357F6:	dc.w 6
		dc.w  $1760,  $546, $8180, $16C0
		dc.w   $566,  $140, $1760,  $6C5
		dc.w  $1760,  $6C5, $8181, $16C0
		dc.w   $6A6,  $140, $1760,  $546
		dc.w  $1620,  $6C4,   $81, $16C0
		dc.w   $6C6,  $180, $1760,  $546
		dc.w  $2AA0,  $444, $8000, $2B40
		dc.w   $466,  $2C0, $2AA0,  $744
		dc.w  $2BE0,  $446, $8180, $2B40
		dc.w   $466,  $2C0, $2BE0,  $746
		dc.w  $2AA0,  $744, $8001, $2B40
		dc.w   $726,  $2C0, $2AA0,  $444
		dc.w  $2BE0,  $746, $8181, $2B40
		dc.w   $726,  $2C0, $2BE0,  $446

; =============== S U B R O U T I N E =======================================


sub_35868:
		cmpi.b	#2,$35(a0)

loc_3586E:
		beq.s	loc_358E0
		subq.b	#1,$3A(a0)
		bpl.s	loc_358A8
		cmpi.b	#3,$35(a0)
		beq.s	loc_358CE
		move.w	#0,$3C(a0)
		move.b	#2,$35(a0)
		movea.l	$36(a0),a1
		move.w	(a1)+,d0
		move.w	d0,$2E(a0)
		move.b	$3F(a0),d1
		andi.b	#$7F,d1
		beq.s	loc_358A2
		move.w	d0,$3C(a0)

loc_358A2:
		move.l	a1,$36(a0)
		bra.s	loc_358E0
; ---------------------------------------------------------------------------

loc_358A8:
		move.l	$10(a0),d2
		move.l	$14(a0),d3
		move.w	$18(a0),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d2
		move.w	$1A(a0),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d3
		move.l	d2,$10(a0)
		move.l	d3,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_358CE:
		tst.b	$3E(a0)
		bpl.s	loc_358D8
		neg.w	$1C(a0)

loc_358D8:
		move.b	#0,$35(a0)
		rts
; ---------------------------------------------------------------------------

loc_358E0:

		move.w	$3C(a0),d0
		add.w	d0,d0
		tst.b	$3F(a0)
		bpl.s	loc_358EE
		neg.w	d0

loc_358EE:
		jsr	(GetSineCosine).l
		muls.w	#$5800,d0
		swap	d0
		add.w	$30(a0),d0
		move.w	d0,$10(a0)
		move.w	$32(a0),d0
		add.w	$3C(a0),d0
		move.w	d0,$14(a0)
		moveq	#2,d1
		move.w	$1C(a0),d0
		bpl.s	loc_35918
		neg.w	d0

loc_35918:
		cmpi.w	#$C00,d0
		bne.s	loc_35920
		moveq	#3,d1

loc_35920:
		move.b	$3F(a0),d0
		andi.b	#$7F,d0
		beq.s	loc_35932
		sub.w	d1,$3C(a0)
		bgt.s	locret_35962
		bra.s	loc_35940
; ---------------------------------------------------------------------------

loc_35932:
		add.w	d1,$3C(a0)

loc_35936:
		move.w	$2E(a0),d0
		cmp.w	$3C(a0),d0
		bhi.s	locret_35962

loc_35940:
		move.b	#3,$35(a0)
		movea.l	$36(a0),a2
		move.w	(a2)+,d4
		move.w	(a2)+,d5
		move.w	$1C(a0),d2
		bpl.s	loc_35956
		neg.w	d2

loc_35956:
		tst.w	d2
		bne.s	loc_3595E
		move.w	#$800,d2

loc_3595E:
		bra.w	loc_35706
; ---------------------------------------------------------------------------

locret_35962:

		rts
; End of function sub_35868

; ---------------------------------------------------------------------------
Map_MGZTopPlatform:include "Levels\MGZ\Misc Object Data\Map - Top Platform.asm"

; ---------------------------------------------------------------------------

Obj_MGZTopLauncher:

		move.l	#Map_MGZTopPlatform,$C(a0)
		move.w	#$43FF,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$200,8(a0)
		move.b	#$C,7(a0)
		move.b	#8,6(a0)
		move.b	#2,$22(a0)
		move.w	#$10,$30(a0)
		move.w	#$C00,d0
		btst	#0,$2A(a0)
		beq.s	loc_359CE
		neg.w	d0

loc_359CE:
		move.w	d0,$18(a0)
		jsr	(Create_New_Sprite3).l
		bne.s	loc_359EA
		move.l	#Obj_MGZTopPlatform,(a1)
		move.b	#1,$2C(a1)
		move.w	a1,$3E(a0)

loc_359EA:
		move.l	#loc_359F0,(a0)

loc_359F0:
		movea.w	$3E(a0),a1
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addq.w	#4,$24(a1)
		cmpi.b	#4,$40(a1)
		beq.s	loc_35A14
		cmpi.b	#4,$42(a1)
		bne.s	loc_35A1A

loc_35A14:
		move.l	#loc_35A20,(a0)

loc_35A1A:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_35A20:
		movea.w	$3E(a0),a1
		addq.w	#1,$14(a0)
		subq.w	#1,$30(a0)
		bne.s	loc_35A3A
		move.l	#loc_35A74,(a0)
		move.w	#$7F00,$10(a0)

loc_35A3A:
		cmpi.w	#4,$30(a0)
		beq.s	loc_35A56
		bcs.s	loc_35A74
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addq.w	#4,$24(a1)
		bra.s	loc_35A74
; ---------------------------------------------------------------------------

loc_35A56:
		move.w	$18(a0),d1
		move.w	d1,$18(a1)
		move.w	d1,$1C(a1)
		move.b	#1,$34(a1)
		bclr	#1,$2A(a1)
		move.b	#0,$2C(a1)

loc_35A74:


		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_CGZBladePlatform:

		move.l	#Map_CGZBladePlatform,$C(a0)
		move.w	#$6300,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#$20,7(a0)
		move.b	#8,6(a0)
		move.w	$14(a0),$32(a0)
		bset	#7,$2A(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_35B10
		move.l	#loc_35B90,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		subi.w	#$10,$10(a1)
		addi.w	#$C,$14(a1)
		move.b	#-$5A,$28(a1)
		move.w	a0,$3E(a1)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_35B10
		move.l	#loc_35BA6,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$10,$10(a1)
		addi.w	#$14,$14(a1)
		move.b	#-$5A,$28(a1)
		move.w	a0,$3E(a1)

loc_35B10:

		move.l	#loc_35B16,(a0)

loc_35B16:
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	loc_35B42
		move.w	#$80,d1
		cmpi.b	#$18,d0
		bne.s	loc_35B2E
		move.w	#$100,d1

loc_35B2E:
		add.w	d1,$36(a0)
		cmpi.w	#-$8000,$36(a0)
		bcs.s	loc_35B40
		move.w	#-$8000,$36(a0)

loc_35B40:
		bra.s	loc_35B56
; ---------------------------------------------------------------------------

loc_35B42:
		tst.w	$36(a0)
		beq.s	loc_35B56
		subi.w	#$100,$36(a0)
		bcc.s	loc_35B56
		move.w	#0,$36(a0)

loc_35B56:

		move.w	$32(a0),d0
		add.b	$36(a0),d0
		move.w	d0,$14(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#7,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		addq.b	#1,$22(a0)
		andi.b	#3,$22(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_35B90:
		movea.w	$3E(a0),a1
		move.w	$14(a1),$14(a0)
		addi.w	#8,$14(a0)
		jmp	(Add_SpriteToCollisionResponseList).l
; ---------------------------------------------------------------------------

loc_35BA6:
		movea.w	$3E(a0),a1
		move.w	$14(a1),$14(a0)
		addi.w	#$10,$14(a0)
		jmp	(Add_SpriteToCollisionResponseList).l
; ---------------------------------------------------------------------------
Map_CGZBladePlatform:include "Levels\CGZ\Misc Object Data\Map - Blade Platform.asm"

; ---------------------------------------------------------------------------

Obj_BPZElephantBlock:

		move.l	#Map_BPZElephantBlock,$C(a0)
		move.w	#$300,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#$30,7(a0)
		move.b	#$10,6(a0)
		move.w	$10(a0),$30(a0)
		bset	#6,4(a0)
		move.w	#1,$16(a0)
		lea	$18(a0),a2
		move.w	$10(a0),(a2)+
		move.w	$14(a0),(a2)+
		move.w	#0,(a2)+
		move.b	$2C(a0),d0
		lsl.w	#8,d0
		move.w	d0,$38(a0)
		bset	#7,$2A(a0)
		btst	#0,$2A(a0)
		beq.s	loc_35C6C
		move.w	d0,$34(a0)
		move.b	#1,$3A(a0)
		move.l	#loc_35CCA,(a0)
		bra.w	loc_35CCA
; ---------------------------------------------------------------------------

loc_35C6C:
		move.l	#loc_35C72,(a0)

loc_35C72:
		bsr.w	sub_35D22
		lea	$18(a0),a2
		move.w	$30(a0),d0
		move.b	$34(a0),d1
		ext.w	d1
		sub.w	d1,d0
		move.w	d0,(a2)
		move.w	$30(a0),d0
		asr.w	#1,d1
		sub.w	d1,d0
		move.w	d0,$10(a0)
		addq.w	#8,d1
		move.b	d1,7(a0)
		move.w	#0,4(a2)
		cmpi.w	#$20,d1
		bcs.s	loc_35CAC
		move.w	#1,4(a2)

loc_35CAC:
		addi.w	#7,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_35CCA:

		bsr.w	sub_35D22
		lea	$18(a0),a2
		move.w	$30(a0),d0
		move.b	$34(a0),d1
		ext.w	d1
		add.w	d1,d0
		move.w	d0,(a2)
		move.w	$30(a0),d0
		asr.w	#1,d1
		add.w	d1,d0
		move.w	d0,$10(a0)
		addq.w	#8,d1
		move.b	d1,7(a0)
		move.w	#0,4(a2)
		cmpi.w	#$20,d1
		bcs.s	loc_35D04
		move.w	#1,4(a2)

loc_35D04:
		addi.w	#7,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_35D22:

		tst.b	$3A(a0)
		bne.s	loc_35D44
		move.w	$38(a0),d0
		addi.w	#$80,$34(a0)
		cmp.w	$34(a0),d0
		bhi.s	loc_35D42
		move.w	d0,$34(a0)
		move.b	#1,$3A(a0)

loc_35D42:
		bra.s	locret_35D58
; ---------------------------------------------------------------------------

loc_35D44:
		subi.w	#$80,$34(a0)
		bhi.s	locret_35D58
		move.w	#0,$34(a0)
		move.b	#0,$3A(a0)

locret_35D58:

		rts
; End of function sub_35D22

; ---------------------------------------------------------------------------
Map_BPZElephantBlock:include "Levels\BPZ\Misc Object Data\Map - Elephant Block.asm"

; ---------------------------------------------------------------------------

Obj_BPZBalloon:

		move.l	#Map_BPZBalloon,$C(a0)
		move.w	#$6300,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$200,8(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.b	#-$29,$28(a0)
		move.l	#loc_35DB2,(a0)

loc_35DB2:
		tst.b	$29(a0)
		beq.w	loc_35E4C
		lea	($FFFFB000).w,a1
		bclr	#0,$29(a0)
		beq.s	loc_35DC8
		bsr.s	sub_35DDE

loc_35DC8:
		lea	($FFFFB04A).w,a1
		bclr	#1,$29(a0)
		beq.s	loc_35DD6
		bsr.s	sub_35DDE

loc_35DD6:
		clr.b	$29(a0)
		bra.w	loc_35E4C

; =============== S U B R O U T I N E =======================================


sub_35DDE:

		move.w	$10(a0),d1
		move.w	$14(a0),d2
		sub.w	$10(a1),d1
		sub.w	$14(a1),d2
		jsr	(GetArcTan).l
		move.b	d0,d1
		subi.b	#$20,d1
		cmpi.b	#$40,d1
		bcc.s	loc_35E0E
		move.w	#-$900,$1A(a1)
		move.b	#1,$20(a0)
		bra.s	loc_35E2E
; ---------------------------------------------------------------------------

loc_35E0E:
		jsr	(GetSineCosine).l
		muls.w	#-$480,d1
		asr.l	#8,d1
		move.w	d1,$18(a1)
		muls.w	#-$480,d0
		asr.l	#8,d0
		move.w	d0,$1A(a1)
		move.b	#2,$20(a0)

loc_35E2E:
		bset	#1,$2A(a1)
		bclr	#4,$2A(a1)
		bclr	#5,$2A(a1)
		clr.b	$40(a1)
		moveq	#$7B,d0
		jmp	(Play_Sound_2).l
; End of function sub_35DDE

; ---------------------------------------------------------------------------

loc_35E4C:

		lea	(Ani_BPZBalloon).l,a1
		jsr	(Animate_Sprite).l
		cmpi.b	#5,$22(a0)
		bcs.s	loc_35E6E
		cmpi.b	#7,$22(a0)
		bcc.s	loc_35E6E
		jsr	(Add_SpriteToCollisionResponseList).l

loc_35E6E:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Ani_BPZBalloon:	include "Levels\BPZ\Misc Object Data\Anim - Balloon.asm"

Map_BPZBalloon:	include "Levels\BPZ\Misc Object Data\Map - Balloon.asm"

; ---------------------------------------------------------------------------

Obj_DPZDisolvingSandBar:

		move.l	#Map_DPZDissolvingSandBar,$C(a0)
		move.w	#$4280,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$200,8(a0)
		move.b	#$20,7(a0)
		move.b	#$10,6(a0)
		tst.b	$2C(a0)
		beq.s	loc_35F7A
		move.l	#Map_DPZDissolvingSandBar2,$C(a0)
		move.b	#$30,7(a0)
		move.b	#$F,$3D(a0)

loc_35F7A:
		move.b	$3D(a0),$3C(a0)
		bset	#7,$2A(a0)
		move.l	#loc_35F8C,(a0)

loc_35F8C:
		tst.b	$20(a0)
		bne.s	loc_35FC6
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	loc_35FA2
		move.b	#1,$3A(a0)

loc_35FA2:
		tst.b	$3A(a0)
		beq.s	loc_35FC6
		subq.b	#1,$3C(a0)
		bpl.s	loc_35FC6
		tst.b	$20(a0)
		bne.s	loc_35FC6
		move.b	$3D(a0),$3C(a0)
		move.b	#0,$3A(a0)
		move.b	#1,$20(a0)

loc_35FC6:

		lea	(Ani_DPZDissolvingSandBar).l,a1
		jsr	(Animate_Sprite).l
		moveq	#0,d0
		move.b	$22(a0),d0
		move.b	byte_36026(pc,d0.w),d3
		bne.s	loc_36010
		lea	($FFFFB000).w,a1
		bclr	#3,$2A(a0)
		beq.s	loc_35FF6
		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)

loc_35FF6:
		lea	($FFFFB04A).w,a1
		bclr	#4,$2A(a0)
		beq.s	loc_3600E
		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)

loc_3600E:
		bra.s	loc_36020
; ---------------------------------------------------------------------------

loc_36010:
		moveq	#0,d1
		move.b	7(a0),d1
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l

loc_36020:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
byte_36026:	dc.b  $11, $11, $11, $11, $10,  $F,  $E,  $D,  $C,  $B,  $A,   9,   8,   7,   6,   5,   4,   3,   2,   1
		dc.b    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0
Ani_DPZDissolvingSandBar:	include "Levels\DPZ\Misc Object Data\Anim - Dissolving Sand Bar.asm"
Map_DPZDissolvingSandBar:	include "Levels\DPZ\Misc Object Data\Map - Dissolving Sand Bar.asm"

; ---------------------------------------------------------------------------

Obj_DPZButton:

		move.l	#Map_DPZButton,$C(a0)
		move.w	#$4280,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#$C,7(a0)
		move.b	#8,6(a0)
		move.l	#loc_362CE,(a0)

loc_362CE:
		move.w	#$C,d1
		move.w	#2,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		lea	($FFFFFC5C).w,a2
		move.b	#0,$22(a0)
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		lea	(a3,d0.w),a3
		moveq	#0,d3
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		bne.s	loc_36310
		bclr	d3,(a3)
		move.l	#$2E000A,(a2)
		bra.s	loc_3634A
; ---------------------------------------------------------------------------

loc_36310:
		tst.b	(a3)
		bne.s	loc_36322
		moveq	#$5B,d0
		jsr	(Play_Sound_2).l
		move.b	#0,$24(a0)

loc_36322:
		bset	d3,(a3)
		move.b	#1,$22(a0)
		subq.b	#1,$24(a0)
		bpl.s	loc_3634A
		move.b	#3,$24(a0)
		move.w	(a2),d0
		move.l	#$2E000A,(a2)
		cmpi.w	#$2E,d0
		bne.s	loc_3634A
		move.l	#$C2E0A0E,(a2)

loc_3634A:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Map_DPZButton:	include "Levels\DPZ\Misc Object Data\Map - Button.asm"

; ---------------------------------------------------------------------------

Obj_2PItem:

		move.l	#Map_2PItem,$C(a0)
		move.w	#$3C6,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#8,7(a0)
		move.b	#8,6(a0)
		move.b	#4,$1F(a0)
		move.b	#8,$1E(a0)
		move.w	$10(a0),$30(a0)
		move.w	$14(a0),$32(a0)
		move.b	$2C(a0),$26(a0)
		moveq	#1,d0
		bclr	#0,$2A(a0)
		beq.s	loc_363B4
		neg.b	d0

loc_363B4:
		move.b	d0,$27(a0)
		move.b	#3,$20(a0)
		move.b	#7,$20(a0)
		move.b	#-$39,$28(a0)
		move.l	#loc_363D0,(a0)

loc_363D0:

		bsr.s	sub_3643C
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		asl.w	#3,d1
		move.w	d1,d2
		add.w	d1,d1
		add.w	d1,d2
		add.w	d1,d1
		add.w	d2,d1
		asr.w	#8,d1
		add.w	$30(a0),d1
		and.w	($FFFFEEA8).w,d1
		addi.w	#$400,d1
		move.w	d1,$10(a0)
		asl.w	#3,d0
		move.w	d0,d2
		add.w	d0,d0
		add.w	d0,d2
		add.w	d0,d0
		add.w	d2,d0
		asr.w	#8,d0
		add.w	$32(a0),d0
		cmpi.w	#-$100,($FFFFEE18).w
		bne.s	loc_36418
		and.w	($FFFFEEAA).w,d0

loc_36418:
		move.w	d0,$14(a0)
		move.b	$27(a0),d0
		add.b	d0,$26(a0)
		lea	(Ani_2PItem).l,a1
		jsr	(Animate_Sprite).l
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_3643C:
		tst.b	$29(a0)
		beq.s	locret_36462
		lea	($FFFFB000).w,a2
		bclr	#0,$29(a0)
		beq.s	loc_36450
		bsr.s	sub_36464

loc_36450:
		lea	($FFFFB04A).w,a2
		bclr	#1,$29(a0)
		beq.s	loc_3645E
		bsr.s	sub_36464

loc_3645E:
		clr.b	$29(a0)

locret_36462:
		rts
; End of function sub_3643C


; =============== S U B R O U T I N E =======================================


sub_36464:

		moveq	#0,d0
		move.b	$20(a0),d0
		add.w	d0,d0
		move.w	off_36476(pc,d0.w),d0
		jsr	off_36476(pc,d0.w)
		rts
; End of function sub_36464

; ---------------------------------------------------------------------------
off_36476:	dc.w loc_36486-off_36476

		dc.w loc_364D8-off_36476
		dc.w loc_3652A-off_36476
		dc.w loc_365E8-off_36476
		dc.w loc_36612-off_36476
		dc.w loc_36652-off_36476
		dc.w loc_36676-off_36476
		dc.w locret_3669A-off_36476
; ---------------------------------------------------------------------------

loc_36486:
		bset	#2,$2B(a2)
		move.b	#$4B,$36(a2)
		cmpa.w	#-$5000,a2
		bne.s	loc_364AC
		move.w	#$C00,($FFFFF760).w
		move.w	#$18,($FFFFF762).w
		move.w	#$80,($FFFFF764).w
		bra.s	loc_364BE
; ---------------------------------------------------------------------------

loc_364AC:
		move.w	#$C00,($FFFFFEC0).w
		move.w	#$18,($FFFFFEC2).w
		move.w	#$80,($FFFFFEC4).w

loc_364BE:
		move.b	#7,$20(a0)
		move.b	#0,$28(a0)
		move.l	#loc_36A1A,d1
		moveq	#9,d2
		bsr.w	sub_36A38
		rts
; ---------------------------------------------------------------------------

loc_364D8:
		bset	#2,$2B(a2)
		move.b	#$4B,$36(a2)
		cmpa.w	#-$5000,a2
		bne.s	loc_364FE
		move.w	#$300,($FFFFF760).w
		move.w	#8,($FFFFF762).w
		move.w	#$20,($FFFFF764).w
		bra.s	loc_36510
; ---------------------------------------------------------------------------

loc_364FE:
		move.w	#$300,($FFFFFEC0).w
		move.w	#8,($FFFFFEC2).w
		move.w	#$20,($FFFFFEC4).w

loc_36510:
		move.b	#7,$20(a0)
		move.b	#0,$28(a0)
		move.l	#loc_36A1A,d1
		moveq	#9,d2
		bsr.w	sub_36A38
		rts
; ---------------------------------------------------------------------------

loc_3652A:
		lea	($FFFFB000).w,a2
		lea	($FFFFB04A).w,a3
		move.b	$2B(a2),d0
		move.b	$2B(a3),$2B(a2)
		move.b	d0,$2B(a3)
		move.b	$36(a2),d0
		move.b	$36(a3),$36(a2)
		move.b	d0,$36(a3)
		move.w	($FFFFF760).w,d0
		move.w	($FFFFF762).w,d1
		move.w	($FFFFF764).w,d2
		move.w	($FFFFFEC0).w,d3
		move.w	($FFFFFEC2).w,d4
		move.w	($FFFFFEC4).w,d5
		move.w	d0,-(sp)
		lea	(Character_Speeds).l,a1
		moveq	#0,d0
		move.b	$38(a2),d0
		lsl.w	#3,d0
		lea	(a1,d0.w),a1
		move.w	(a1)+,($FFFFF760).w
		move.w	(a1)+,($FFFFF762).w
		move.w	(a1)+,($FFFFF764).w
		lea	(Character_Speeds).l,a1
		moveq	#0,d0
		move.b	$38(a3),d0
		lsl.w	#3,d0
		lea	(a1,d0.w),a1
		move.w	(a1)+,($FFFFFEC0).w
		move.w	(a1)+,($FFFFFEC2).w
		move.w	(a1)+,($FFFFFEC4).w
		move.w	(sp)+,d0
		btst	#2,$2B(a2)
		beq.s	loc_365BA
		move.w	d3,($FFFFF760).w
		move.w	d4,($FFFFF762).w
		move.w	d5,($FFFFF764).w

loc_365BA:
		btst	#2,$2B(a3)
		beq.s	loc_365CE
		move.w	d0,($FFFFFEC0).w
		move.w	d1,($FFFFFEC2).w
		move.w	d2,($FFFFFEC4).w

loc_365CE:
		move.b	#7,$20(a0)
		move.b	#0,$28(a0)
		move.l	#loc_36A1A,d1
		moveq	#9,d2
		bsr.w	sub_36A38
		rts
; ---------------------------------------------------------------------------

loc_365E8:
		move.b	#7,$20(a0)
		move.b	#0,$28(a0)
		move.l	#loc_36A1A,d1
		moveq	#8,d2
		bsr.w	sub_36A38
		cmpa.w	#-$5000,a2
		bne.s	loc_3660C
		jmp	(GiveRing).l
; ---------------------------------------------------------------------------

loc_3660C:
		jmp	(loc_1A5F0).l
; ---------------------------------------------------------------------------

loc_36612:
		move.b	#7,$20(a0)
		clr.b	$28(a0)
		clr.b	$29(a0)
		lea	($FFFFCB2C).w,a1
		tst.l	(a1)
		moveq	#$2C,d0

loc_36628:
		move.w	(a0,d0.w),(a1,d0.w)
		subq.w	#2,d0
		bcc.s	loc_36628
		move.l	#loc_3669C,(a1)
		move.b	#4,$20(a1)
		move.w	$46(a2),$46(a1)
		tst.w	$A(a2)
		bpl.s	locret_36650
		ori.w	#-$8000,$A(a1)

locret_36650:
		rts
; ---------------------------------------------------------------------------

loc_36652:
		move.b	#7,$20(a0)
		clr.b	$28(a0)
		clr.b	$29(a0)
		move.l	#loc_366B6,d1
		moveq	#5,d2
		bsr.w	sub_36A38
		bne.s	locret_36674
		move.w	$46(a2),$46(a1)

locret_36674:
		rts
; ---------------------------------------------------------------------------

loc_36676:
		move.b	#7,$20(a0)
		clr.b	$28(a0)
		clr.b	$29(a0)
		move.l	#loc_366BE,d1
		moveq	#6,d2
		bsr.w	sub_36A38
		bne.s	locret_36698
		move.w	$46(a2),$46(a1)

locret_36698:
		rts
; ---------------------------------------------------------------------------

locret_3669A:
		rts
; ---------------------------------------------------------------------------

loc_3669C:
		move.w	#-$400,$1C(a0)
		move.b	#0,$26(a0)
		move.b	#0,$2A(a0)
		move.l	#loc_368AA,d2
		bra.s	loc_366C4
; ---------------------------------------------------------------------------

loc_366B6:
		move.l	#loc_367C2,d2
		bra.s	loc_366C4
; ---------------------------------------------------------------------------

loc_366BE:
		move.l	#loc_3670C,d2

loc_366C4:

		move.l	d2,-(sp)
		jsr	(MoveSprite).l
		jsr	(ObjHitFloor).l
		move.l	(sp)+,d2
		tst.w	d1
		bpl.s	loc_366E4
		add.w	d1,$14(a0)
		move.l	d2,(a0)
		move.b	#-$39,$28(a0)

loc_366E4:
		cmpi.w	#-$100,($FFFFEE18).w
		bne.s	loc_366F4
		move.w	($FFFFEEAA).w,d0
		and.w	d0,$14(a0)

loc_366F4:
		move.w	($FFFFEE1A).w,d0
		addi.w	#$60,d0
		cmp.w	$14(a0),d0
		bge.s	loc_36708
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_36708:
		bra.w	loc_36A1A
; ---------------------------------------------------------------------------

loc_3670C:
		tst.b	$29(a0)
		beq.s	loc_36732
		lea	($FFFFB000).w,a2
		bclr	#0,$29(a0)
		beq.s	loc_36720
		bsr.s	sub_3675E

loc_36720:
		lea	($FFFFB04A).w,a2
		bclr	#1,$29(a0)
		beq.s	loc_3672E
		bsr.s	sub_3675E

loc_3672E:
		clr.b	$29(a0)

loc_36732:
		lea	(Ani_2PItem).l,a1
		jsr	(Animate_Sprite).l
		tst.b	5(a0)
		beq.s	loc_3674A
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_3674A:
		cmpi.b	#9,$20(a0)
		beq.s	loc_36758
		jsr	(Add_SpriteToCollisionResponseList).l

loc_36758:
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_3675E:

		move.w	$46(a2),d0
		cmp.w	$46(a0),d0
		beq.s	loc_3676A
		rts
; ---------------------------------------------------------------------------

loc_3676A:
		move.b	#$A,$20(a0)
		move.w	#-$A00,$1A(a2)
		bset	#1,$2A(a2)
		bclr	#4,$2A(a2)
		bclr	#5,$2A(a2)
		clr.b	$40(a2)
		move.w	#1,$1C(a2)
		move.b	#1,$27(a2)
		move.b	#0,$20(a2)
		move.b	#0,$30(a2)
		move.b	#4,$31(a2)
		btst	#0,$2A(a2)
		beq.s	loc_367BA
		neg.b	$27(a2)
		neg.w	$1C(a2)

loc_367BA:
		moveq	#$7B,d0
		jmp	(Play_Sound_2).l
; End of function sub_3675E

; ---------------------------------------------------------------------------

loc_367C2:
		tst.b	$29(a0)
		beq.s	loc_367E8
		lea	($FFFFB000).w,a2
		bclr	#0,$29(a0)
		beq.s	loc_367D6
		bsr.s	sub_3684C

loc_367D6:
		lea	($FFFFB04A).w,a2
		bclr	#1,$29(a0)
		beq.s	loc_367E4
		bsr.s	sub_3684C

loc_367E4:
		clr.b	$29(a0)

loc_367E8:
		lea	(Ani_2PItem).l,a1
		jsr	(Animate_Sprite).l
		tst.b	$3C(a0)
		beq.s	loc_36834
		movea.w	$3E(a0),a1
		subq.b	#1,$3C(a0)
		beq.s	loc_36828
		move.w	#$20,d1
		move.w	$1C(a1),d0
		bpl.s	loc_3681C
		add.w	d1,$1C(a1)
		bcc.s	loc_36840
		move.w	#0,$1C(a1)
		bra.s	loc_36828
; ---------------------------------------------------------------------------

loc_3681C:
		sub.w	d1,$1C(a1)
		bcc.s	loc_36840
		move.w	#0,$1C(a1)

loc_36828:

		move.w	#5,$32(a1)
		andi.b	#$7F,$2B(a1)

loc_36834:
		tst.b	5(a0)
		beq.s	loc_36840
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_36840:

		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_3684C:

		move.w	$46(a2),d0
		cmp.w	$46(a0),d0
		bne.s	locret_368A8
		tst.b	$2B(a2)
		bmi.s	locret_368A8
		btst	#1,$2A(a2)
		bne.s	locret_368A8
		tst.w	$1C(a2)
		beq.s	locret_368A8
		move.b	#9,$20(a0)
		move.b	#0,$28(a0)
		move.w	#$200,d1
		move.w	$1C(a2),d0
		bpl.s	loc_36884
		neg.w	d0
		neg.w	d1

loc_36884:
		cmpi.w	#$200,d0
		bcc.s	loc_3688E
		add.w	d1,$1C(a2)

loc_3688E:
		asl	$1C(a2)
		move.b	#$1B,$20(a2)
		ori.b	#-$80,$2B(a2)
		move.w	a2,$3E(a0)
		move.b	#$3C,$3C(a0)

locret_368A8:
		rts
; End of function sub_3684C

; ---------------------------------------------------------------------------

loc_368AA:
		tst.b	$29(a0)
		beq.s	loc_368D0
		lea	($FFFFB000).w,a2
		bclr	#0,$29(a0)
		beq.s	loc_368BE
		bsr.s	sub_36906

loc_368BE:
		lea	($FFFFB04A).w,a2
		bclr	#1,$29(a0)
		beq.s	loc_368CC
		bsr.s	sub_36906

loc_368CC:
		clr.b	$29(a0)

loc_368D0:
		bsr.w	sub_36926
		move.b	$26(a0),d0
		addi.b	#$10,d0
		lsr.b	#5,d0
		addi.b	#$11,d0
		move.b	d0,$22(a0)
		move.w	($FFFFEE1A).w,d0
		addi.w	#$60,d0
		cmp.w	$14(a0),d0
		bge.s	loc_368FA
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_368FA:
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_36906:

		move.w	$46(a2),d0
		cmp.w	$46(a0),d0
		beq.s	loc_36912
		rts
; ---------------------------------------------------------------------------

loc_36912:
		move.l	#loc_36A1A,(a0)
		move.b	#$B,$20(a0)
		movea.l	a2,a1
		jmp	(sub_24280).l
; End of function sub_36906


; =============== S U B R O U T I N E =======================================


sub_36926:
		btst	#1,$2A(a0)
		bne.s	loc_36990
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		muls.w	$1C(a0),d1
		asr.l	#8,d1
		move.w	d1,$18(a0)
		muls.w	$1C(a0),d0
		asr.l	#8,d0
		move.w	d0,$1A(a0)
		jsr	(MoveSprite2).l
		move.w	($FFFFEEAA).w,d0
		and.w	d0,$14(a0)
		move.w	($FFFFEEA8).w,d0
		and.w	d0,$10(a0)
		addi.w	#$400,$10(a0)
		jsr	(Player_AnglePos).l
		move.b	$26(a0),d0
		bne.s	locret_3698E
		jsr	(sub_FDEC).l
		tst.w	d1
		bpl.s	locret_3698E
		sub.w	d1,$10(a0)
		move.l	#loc_36A1A,(a0)
		move.b	#$B,$20(a0)

locret_3698E:

		rts
; ---------------------------------------------------------------------------

loc_36990:
		subi.w	#$10,$18(a0)
		cmpi.w	#-$400,$18(a0)
		bgt.s	loc_369A4
		move.w	#-$400,$18(a0)

loc_369A4:
		jsr	(MoveSprite).l
		move.w	($FFFFEEAA).w,d0
		and.w	d0,$14(a0)
		move.w	($FFFFEEA8).w,d0
		and.w	d0,$10(a0)
		addi.w	#$400,$10(a0)
		jsr	(sub_F894).l
		tst.w	d1
		bpl.s	loc_369DC
		add.w	d1,$14(a0)
		bclr	#1,$2A(a0)
		move.b	#0,$26(a0)
		rts
; ---------------------------------------------------------------------------

loc_369DC:
		move.b	$26(a0),d0
		beq.s	loc_369F6
		bpl.s	loc_369EC
		addq.b	#2,d0
		bcc.s	loc_369F2
		moveq	#0,d0
		bra.s	loc_369F2
; ---------------------------------------------------------------------------

loc_369EC:
		subq.b	#2,d0
		bcc.s	loc_369F2
		moveq	#0,d0

loc_369F2:

		move.b	d0,$26(a0)

loc_369F6:
		move.b	$26(a0),d0
		bne.s	locret_36A18
		jsr	(sub_FDEC).l
		tst.w	d1
		bpl.s	locret_36A18
		sub.w	d1,$10(a0)
		move.l	#loc_36A1A,(a0)
		move.b	#$B,$20(a0)
		rts
; ---------------------------------------------------------------------------

locret_36A18:

		rts
; ---------------------------------------------------------------------------

loc_36A1A:

		lea	(Ani_2PItem).l,a1
		jsr	(Animate_Sprite).l
		tst.b	5(a0)
		beq.s	loc_36A32
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_36A32:
		jmp	(Draw_Sprite).l
; End of function sub_36926


; =============== S U B R O U T I N E =======================================


sub_36A38:

		jsr	(Create_New_Sprite3).l
		bne.w	locret_36A56
		moveq	#$2C,d0

loc_36A44:
		move.w	(a0,d0.w),(a1,d0.w)
		subq.w	#2,d0
		bcc.s	loc_36A44
		move.l	d1,(a1)
		move.b	d2,$20(a1)
		moveq	#0,d0

locret_36A56:
		rts
; End of function sub_36A38

; ---------------------------------------------------------------------------
Ani_2PItem:	include "General\2P Zone\Anim - Item.asm"

Map_2PItem:	include "General\2P Zone\Map - Item.asm"

; ---------------------------------------------------------------------------

Obj_2PGoalMarker:

		move.l	#Map_2PGoalMarker,$C(a0)
		move.w	#$6BC,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#8,7(a0)
		move.b	#$20,6(a0)
		move.w	$10(a0),$30(a0)
		move.w	$14(a0),$32(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#3,d0
		subi.w	#$14,d0
		move.w	d0,$38(a0)
		move.b	#5,($FFFFFEDA).w
		clr.w	($FFFFFEDC).w
		clr.w	($FFFFEEE6).w
		clr.b	($FFFFFE1E).w
		clr.l	($FFFFFE22).w
		clr.b	($FFFFFEC7).w
		clr.l	($FFFFFED2).w
		clr.w	($FFFFFE20).w
		clr.w	($FFFFFED0).w
		jsr	sub_36F5A(pc)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_36CE4
		move.l	#loc_37EC2,(a1)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_36CE4
		move.l	#loc_37EC2,(a1)
		move.b	#1,$2C(a1)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_36CE4
		move.l	#loc_3703A,(a1)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_36CE4
		move.l	#loc_3703A,(a1)
		move.b	#1,$2C(a1)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_36CE4
		move.l	#loc_3713A,(a1)
		move.w	#$120,$10(a1)
		move.w	#$B8,$14(a1)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_36CE4
		move.l	#loc_37C8E,(a1)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_36CE4
		move.l	#loc_37D00,(a1)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_36CE4
		move.l	#locret_3827A,(a1)

loc_36CE4:

		move.l	#loc_36CEA,(a0)

loc_36CEA:

		move.w	$10(a0),d1
		lea	$34(a0),a2
		lea	($FFFFB000).w,a1
		lea	($FFFFFEDC).w,a3
		lea	($FFFFF74A).w,a4
		lea	($FFFFFE22).w,a5
		lea	($FF7828).l,a6
		bsr.w	sub_36DFC
		lea	($FFFFB04A).w,a1
		lea	($FFFFFEDD).w,a3
		lea	($FFFFF74B).w,a4
		lea	($FFFFFED2).w,a5
		lea	($FF7840).l,a6
		bsr.w	sub_36DFC
		lea	(Ani_2PGoalMarker).l,a1
		jsr	(Animate_Sprite).l
		move.w	$36(a0),($FFFFEE5C).w
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_36D3E:
		subq.w	#1,$3C(a0)
		bne.w	loc_36DEA
		lea	($FFFFB000).w,a1
		move.w	($FFFFFE2E).w,$10(a1)
		move.w	($FFFFFE30).w,$14(a1)
		move.w	($FFFFFE38).w,$A(a1)
		move.w	($FFFFFE3A).w,$46(a1)
		move.w	#0,$18(a1)
		move.w	#0,$1A(a1)
		move.w	#0,$1C(a1)
		move.b	#2,$2A(a1)
		move.w	#0,$32(a1)
		tst.b	($FFFFEF49).w
		beq.s	loc_36DC0
		lea	($FFFFB04A).w,a1
		move.w	($FFFFFE4C).w,$10(a1)
		move.w	($FFFFFE4E).w,$14(a1)
		move.w	($FFFFFE56).w,$A(a1)
		move.w	($FFFFFE58).w,$46(a1)
		move.w	#0,$18(a1)
		move.w	#0,$1A(a1)
		move.w	#0,$1C(a1)
		move.b	#2,$2A(a1)
		move.w	#0,$32(a1)

loc_36DC0:
		clr.w	($FFFFFEDC).w
		clr.b	($FFFFFE1E).w
		clr.l	($FFFFFE22).w
		clr.b	($FFFFFEC7).w
		clr.l	($FFFFFED2).w
		clr.b	($FFFFF7CA).w
		clr.b	($FFFFF7CB).w
		jsr	sub_36F5A(pc)
		clr.w	($FFFFEEE6).w
		move.l	#loc_36CEA,(a0)

loc_36DEA:
		lea	(Ani_2PGoalMarker).l,a1
		jsr	(Animate_Sprite).l
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_36DFC:

		tst.b	(a4)
		bne.w	loc_36EFC
		tst.b	(a2)+
		bne.w	loc_36F0C
		cmp.w	$10(a1),d1
		bhi.w	locret_36F58
		move.b	#1,-1(a2)
		move.w	$14(a0),d2
		move.w	d2,d3
		sub.w	$38(a0),d2
		addi.w	#$14,d3
		move.w	$14(a1),d4
		cmp.w	d2,d4
		blt.w	locret_36F58
		cmp.w	d3,d4
		bge.w	locret_36F58
		move.w	$10(a1),d2
		sub.w	d1,d2
		bcc.s	loc_36E3E
		neg.w	d2

loc_36E3E:
		cmpi.w	#$20,d2
		bcc.w	locret_36F58
		cmpi.b	#$C,$46(a1)
		bne.s	locret_36E9A
		move.b	(a3),d0
		beq.s	loc_36E9C
		cmp.b	1(a2),d0
		bls.s	loc_36E98
		move.b	d0,1(a2)
		subq.b	#1,d0
		bmi.s	loc_36E7C
		cmpi.b	#5,d0
		bcc.s	loc_36E7C
		ext.w	d0
		lsl.w	#2,d0
		move.l	(a6,d0.w),d5
		move.l	$14(a6),d6
		jsr	sub_36F76(pc)
		move.l	d6,$14(a6)
		clr.l	(a5)

loc_36E7C:

		sub.w	$14(a0),d4
		neg.w	d4
		cmpi.w	#$14,d4
		bge.s	loc_36E98
		move.w	$3A(a0),d0
		andi.w	#$F,d0
		bsr.w	sub_36FAA
		addq.w	#2,$3A(a0)

loc_36E98:

		addq.b	#1,(a3)

locret_36E9A:
		rts
; ---------------------------------------------------------------------------

loc_36E9C:
		tst.b	1(a2)
		bne.s	loc_36E98
		tst.b	($FFFFFE1E).w
		bne.s	loc_36E98
		move.b	#1,($FFFFF7CA).w
		move.b	#1,($FFFFF7CB).w
		move.w	#0,($FFFFF602).w
		move.w	#0,($FFFFF66A).w
		move.l	#loc_36D3E,(a0)
		move.w	#$78,$3C(a0)
		st	($FFFFEEE6).w
		movea.l	a1,a6
		jsr	(Create_New_Sprite3).l
		bne.s	locret_36EFA
		move.l	#loc_374B8,(a1)
		move.b	#8,4(a1)
		cmpa.w	#-$5000,a6
		beq.s	loc_36EF2
		eori.b	#$18,4(a1)

loc_36EF2:
		moveq	#-$4E,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

locret_36EFA:
		rts
; ---------------------------------------------------------------------------

loc_36EFC:
		clr.b	(a4)
		move.b	#0,(a2)+
		subq.b	#1,(a3)
		bcc.s	locret_36F0A
		move.b	#0,(a3)

locret_36F0A:
		rts
; ---------------------------------------------------------------------------

loc_36F0C:
		cmp.w	$10(a1),d1
		bls.w	locret_36F58
		move.b	#0,-1(a2)
		move.w	$14(a0),d2
		move.w	d2,d3
		sub.w	$38(a0),d2
		addi.w	#$14,d3
		move.w	$14(a1),d4
		cmp.w	d2,d4
		blt.w	locret_36F58
		cmp.w	d3,d4
		bge.w	locret_36F58
		move.w	$10(a1),d2
		sub.w	d1,d2
		bcc.s	loc_36F42
		neg.w	d2

loc_36F42:
		cmpi.w	#$20,d2
		bcc.s	locret_36F58
		cmpi.b	#$C,$46(a1)
		bne.s	locret_36F58
		subq.b	#1,(a3)
		bcc.s	locret_36F58
		move.b	#0,(a3)

locret_36F58:

		rts
; End of function sub_36DFC


; =============== S U B R O U T I N E =======================================


sub_36F5A:

		lea	($FF7828).l,a1
		moveq	#$B,d0

loc_36F62:
		clr.l	(a1)+
		dbf	d0,loc_36F62
		clr.l	($FFFFEE52).w
		clr.l	($FFFFEE56).w
		st	($FFFFEE5A).w
		rts
; End of function sub_36F5A


; =============== S U B R O U T I N E =======================================


sub_36F76:

		add.b	d5,d6
		moveq	#0,d3
		cmpi.b	#$64,d6
		bcs.s	loc_36F86
		subi.b	#$64,d6
		moveq	#1,d3

loc_36F86:
		ror.l	#8,d5
		ror.l	#8,d6
		add.b	d3,d6
		add.b	d5,d6
		moveq	#0,d3
		cmpi.b	#$3C,d6
		bcs.s	loc_36F9C
		subi.b	#$3C,d6
		moveq	#1,d3

loc_36F9C:
		ror.l	#8,d5
		ror.l	#8,d6
		add.b	d3,d6
		add.b	d5,d6
		swap	d5
		swap	d6
		rts
; End of function sub_36F76


; =============== S U B R O U T I N E =======================================


sub_36FAA:
		tst.b	($FFFFFF8A).w
		bne.s	locret_36FD8
		lea	(byte_36FDA).l,a4
		adda.w	d0,a4
		lea	($FFFFB0DE).w,a1
		moveq	#$59,d0

loc_36FBE:
		lea	$4A(a1),a1
		cmpi.l	#loc_363D0,(a1)
		bne.s	loc_36FD4
		move.b	(a4)+,$20(a1)
		move.b	#-$39,$28(a1)

loc_36FD4:
		dbf	d0,loc_36FBE

locret_36FD8:
		rts
; End of function sub_36FAA

; ---------------------------------------------------------------------------
byte_36FDA:	dc.b    0,   1,   2,   3,   4,   5,   6,   0,   1,   2,   3,   4,   5,   6,   2,   3,   0,   1,   2,   3
		dc.b    4,   5,   6,   0

Ani_2PGoalMarker:	include "General\2P Zone\Anim - Goal Marker.asm"

Map_2PGoalMarker:include "General\2P Zone\Map - Goal Marker.asm"

; ---------------------------------------------------------------------------

loc_3703A:

		move.l	#Map_2PLapNumbers,$C(a0)
		move.w	#-$7900,$A(a0)
		move.w	#0,8(a0)
		move.b	#8,7(a0)
		move.b	#$C,6(a0)
		move.w	#$190,$10(a0)
		move.w	#$98,$14(a0)
		tst.b	$2C(a0)
		beq.s	loc_37086
		tst.b	($FFFFEF49).w
		bne.s	loc_37078
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_37078:
		bset	#4,4(a0)
		move.l	#loc_370B4,(a0)
		bra.s	loc_370B4
; ---------------------------------------------------------------------------

loc_37086:
		bset	#3,4(a0)

loc_3708C:
		move.l	#loc_37092,(a0)

loc_37092:
		move.b	($FFFFFEDC).w,d0
		cmp.b	($FFFFFEDA).w,d0
		ble.s	loc_370A0
		move.b	($FFFFFEDA).w,d0

loc_370A0:

		subi.b	#$A,d0
		bcc.s	loc_370A0
		addi.b	#$A,d0
		move.b	d0,$22(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_370B4:

		move.b	($FFFFFEDD).w,d0
		cmp.b	($FFFFFEDA).w,d0
		ble.s	loc_370C2
		move.b	($FFFFFEDA).w,d0

loc_370C2:

		subi.b	#$A,d0
		bcc.s	loc_370C2
		addi.b	#$A,d0
		move.b	d0,$22(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Map_2PLapNumbers:	include "General\2P Zone\Map - Lap Numbers.asm"

; ---------------------------------------------------------------------------

loc_3713A:

		move.l	#Map_2PNeonDisplay,$C(a0)
		move.w	#-$78AA,$A(a0)
		move.w	#0,8(a0)
		move.b	#-$80,7(a0)
		move.b	#$28,6(a0)
		move.l	#loc_3716C,(a0)
		tst.b	($FFFFEF49).w
		bne.s	loc_3716C
		bset	#3,4(a0)

loc_3716C:

		lea	(Ani_2PNeonDisplay).l,a1
		jsr	(Animate_Sprite).l
		cmpi.b	#1,$20(a0)
		bne.s	loc_371AE
		cmpi.b	#5,$24(a0)
		bne.s	loc_371AE
		moveq	#-$59,d0
		move.b	$23(a0),d1
		cmpi.b	#1,d1
		beq.s	loc_371A8
		cmpi.b	#$B,d1
		beq.s	loc_371A8
		cmpi.b	#$15,d1
		beq.s	loc_371A8
		moveq	#-$53,d0
		cmpi.b	#$1F,d1
		bne.s	loc_371AE

loc_371A8:

		jsr	(Play_Sound_2).l

loc_371AE:

		bsr.s	sub_371BE
		tst.w	($FFFFEEE6).w
		bne.s	locret_371BC
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_371BC:
		rts

; =============== S U B R O U T I N E =======================================


sub_371BE:
		move.b	$3A(a0),d0
		bne.s	loc_371F4
		tst.b	($FFFFF7CA).w
		beq.s	loc_371D8
		move.w	#1,$20(a0)
		move.b	#$A,$22(a0)
		rts
; ---------------------------------------------------------------------------

loc_371D8:
		cmpi.b	#3,$22(a0)
		bne.s	locret_371F2
		move.b	#1,($FFFFFE1E).w
		move.b	#1,($FFFFFEC7).w
		move.b	#1,$3A(a0)

locret_371F2:
		rts
; ---------------------------------------------------------------------------

loc_371F4:
		subq.b	#1,d0
		bne.w	loc_372D0
		move.l	#$93B63,d0
		cmp.l	($FFFFEE52).w,d0
		bls.s	loc_3720C
		cmp.l	($FFFFEE56).w,d0
		bhi.s	loc_37218

loc_3720C:
		move.b	#2,$3A(a0)
		move.w	#$78,($FFFFEEE8).w

loc_37218:
		move.b	($FFFFFEDA).w,d0
		cmp.b	($FFFFFEDC).w,d0
		bcc.s	loc_37292
		move.b	#3,$20(a0)
		tst.b	($FFFFEF49).w
		beq.s	loc_37232
		addq.b	#1,$20(a0)

loc_37232:
		bset	#3,4(a0)
		move.b	#2,$3A(a0)
		move.w	#$78,($FFFFEEE8).w
		tst.b	($FFFFEF49).w
		beq.s	loc_37256
		tst.b	($FFFFFF8B).w
		bne.s	loc_37256
		move.w	#$168,($FFFFEEE8).w

loc_37256:

		move.b	#-$80,($FFFFFE1E).w
		jsr	sub_37430(pc)
		moveq	#$6A,d0
		jsr	(Play_Sound_2).l
		move.b	($FFFFFEDA).w,d0
		cmp.b	($FFFFFEDD).w,d0
		bcc.s	loc_3728C
		move.b	#6,$20(a0)
		bclr	#3,4(a0)
		move.w	#$78,($FFFFEEE8).w
		move.b	#-$80,($FFFFFEC7).w
		rts
; ---------------------------------------------------------------------------

loc_3728C:
		bsr.w	sub_37406
		rts
; ---------------------------------------------------------------------------

loc_37292:
		cmp.b	($FFFFFEDD).w,d0
		bcc.s	locret_372CE
		move.b	#4,$20(a0)
		bset	#4,4(a0)
		move.b	#2,$3A(a0)
		move.w	#$78,($FFFFEEE8).w
		tst.b	($FFFFFF8B).w
		bne.s	loc_372BC
		move.w	#$168,($FFFFEEE8).w

loc_372BC:
		move.b	#-$80,($FFFFFEC7).w
		bsr.w	sub_37406
		moveq	#$6A,d0
		jsr	(Play_Sound_2).l

locret_372CE:
		rts
; ---------------------------------------------------------------------------

loc_372D0:
		subq.b	#1,d0
		bne.w	loc_373A4
		tst.b	($FFFFFF8B).w
		beq.s	loc_37308
		tst.b	($FFFFFE1E).w
		bpl.s	locret_37306
		tst.b	($FFFFEF49).w
		beq.s	loc_372EE
		tst.b	($FFFFFEC7).w
		bpl.s	locret_37306

loc_372EE:
		subq.w	#1,($FFFFEEE8).w
		bpl.s	locret_37306
		move.b	#$40,($FFFFF600).w
		tst.b	($FFFFFF8B).w
		bpl.s	locret_37306
		move.b	#$50,($FFFFF600).w

locret_37306:

		rts
; ---------------------------------------------------------------------------

loc_37308:
		move.b	($FFFFFEDC).w,d0
		tst.b	($FFFFFE1E).w
		bpl.s	loc_3731C
		move.b	($FFFFFEDD).w,d0
		tst.b	($FFFFFE1E).w
		bmi.s	loc_37322

loc_3731C:
		cmp.b	($FFFFFEDA).w,d0
		beq.s	loc_37328

loc_37322:
		subq.w	#1,($FFFFEEE8).w
		bmi.s	loc_3733C

loc_37328:
		cmpi.l	#$93B63,($FFFFEE52).w
		bcc.s	loc_3733C
		cmpi.l	#$93B63,($FFFFEE56).w
		bcs.s	locret_37398

loc_3733C:

		moveq	#0,d0
		move.b	($FFFFFE10).w,d0
		subi.b	#$E,d0
		move.b	byte_3739F(pc,d0.w),d0
		lea	($FF7800).l,a1
		move.l	($FFFFEE52).w,(a1,d0.w)
		move.l	($FFFFEE56).w,$14(a1,d0.w)
		tst.b	($FFFFFE1E).w
		bmi.s	loc_3736A
		move.l	#$93B63,(a1,d0.w)

loc_3736A:
		tst.b	($FFFFFEC7).w
		bmi.s	loc_37378
		move.l	#$93B63,$14(a1,d0.w)

loc_37378:
		move.b	($FFFFFE10).w,d0
		subi.b	#$E,d0
		move.b	byte_3739A(pc,d0.w),d0
		beq.s	loc_37392
		move.b	d0,($FFFFFE10).w
		move.b	#1,($FFFFFE02).w
		rts
; ---------------------------------------------------------------------------

loc_37392:
		move.b	#$44,($FFFFF600).w

locret_37398:
		rts
; ---------------------------------------------------------------------------
byte_3739A:	dc.b $F
		dc.b $11
		dc.b $12
		dc.b $10
		dc.b 0
byte_3739F:	dc.b 0
		dc.b 4
		dc.b $C
		dc.b 8
		dc.b $10
; ---------------------------------------------------------------------------

loc_373A4:
		move.b	($FFFFFEDA).w,d0
		cmp.b	($FFFFFEDC).w,d0
		bcc.s	loc_373D4
		tst.b	($FFFFFE1E).w
		bmi.s	loc_373D4
		move.b	#5,$20(a0)
		bset	#3,4(a0)
		move.b	#-$80,($FFFFFE1E).w
		move.w	#$78,($FFFFEEE8).w
		moveq	#$6A,d0
		jsr	(Play_Sound_2).l

loc_373D4:

		move.b	($FFFFFEDA).w,d0
		cmp.b	($FFFFFEDD).w,d0
		bcc.s	locret_37404
		tst.b	($FFFFFEC7).w
		bmi.s	locret_37404
		move.b	#5,$20(a0)
		bset	#4,4(a0)
		move.b	#-$80,($FFFFFEC7).w
		move.w	#$78,($FFFFEEE8).w
		moveq	#$6A,d0
		jsr	(Play_Sound_2).l

locret_37404:

		rts
; End of function sub_371BE


; =============== S U B R O U T I N E =======================================


sub_37406:

		jsr	(Create_New_Sprite3).l
		bne.w	locret_3742E
		move.l	#loc_3713A,(a1)
		move.w	#$120,$10(a1)
		move.w	#$B8,$14(a1)
		move.b	#2,$20(a1)
		move.b	#3,$3A(a1)

locret_3742E:
		rts
; End of function sub_37406


; =============== S U B R O U T I N E =======================================


sub_37430:
		tst.b	($FFFFFF8B).w
		bpl.w	locret_374B6
		moveq	#0,d0
		move.b	($FFFFFE10).w,d0
		subi.w	#$E,d0
		lsl.w	#4,d0
		lea	($FFFFE600).w,a1
		adda.w	d0,a1
		move.l	($FFFFEE52).w,d0
		cmp.l	(a1),d0
		bcc.s	loc_37476
		move.b	$D(a1),$E(a1)
		move.b	$C(a1),$D(a1)
		move.b	($FFFFFFEA).w,$C(a1)
		move.l	4(a1),8(a1)
		move.l	(a1),4(a1)
		move.l	d0,(a1)
		clr.b	($FFFFEE5A).w
		bra.s	loc_374B0
; ---------------------------------------------------------------------------

loc_37476:
		cmp.l	4(a1),d0
		bcc.s	loc_3749A
		move.b	$D(a1),$E(a1)
		move.b	($FFFFFFEA).w,$D(a1)
		move.l	4(a1),8(a1)
		move.l	d0,4(a1)
		move.b	#1,($FFFFEE5A).w
		bra.s	loc_374B0
; ---------------------------------------------------------------------------

loc_3749A:
		cmp.l	8(a1),d0
		bcc.s	locret_374B6
		move.b	($FFFFFFEA).w,$E(a1)
		move.l	d0,8(a1)
		move.b	#2,($FFFFEE5A).w

loc_374B0:

		jsr	(Write_SaveGeneral).l

locret_374B6:

		rts
; End of function sub_37430

; ---------------------------------------------------------------------------

loc_374B8:
		move.l	#Map_2PNeonDisplay,$C(a0)
		move.w	#-$78AA,$A(a0)
		move.w	#0,8(a0)
		move.b	#-$80,7(a0)
		move.b	#$28,6(a0)
		move.w	#$120,$10(a0)
		move.w	#$B8,$14(a0)
		move.b	#7,$20(a0)
		move.l	#loc_374F0,(a0)

loc_374F0:
		tst.w	($FFFFEEE6).w
		bne.s	loc_374FC
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_374FC:
		lea	(Ani_2PNeonDisplay).l,a1
		jsr	(Animate_Sprite).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Ani_2PNeonDisplay:	include "General\2P Zone\Anim - Neon Display.asm"

Map_2PNeonDisplay:	include "General\2P Zone\Map - Neon Display.asm"

; ---------------------------------------------------------------------------

loc_37C8E:
		move.l	#$FF7000,$C(a0)
		move.w	#-$7A00,$A(a0)
		move.w	#0,8(a0)
		move.b	#$40,7(a0)
		move.b	#$10,6(a0)
		move.w	#$C8,$10(a0)
		move.w	#$90,$14(a0)
		bset	#3,4(a0)
		lea	(word_37E8E).l,a1
		lea	($FF7000).l,a2
		move.w	#$19,d0

loc_37CD0:
		move.w	(a1)+,(a2)+
		dbf	d0,loc_37CD0
		move.l	#loc_37CDC,(a0)

loc_37CDC:
		lea	($FFFFFE26).w,a1
		lea	($FF700A).l,a2
		lea	($FFFFFE23).w,a3
		moveq	#0,d1
		move.b	($FFFFEE5C).w,d1
		lea	($FFFFFE1E).w,a4
		lea	($FFFFEE52).w,a5
		lea	($FF7828).l,a6
		bra.s	loc_37D7C
; ---------------------------------------------------------------------------

loc_37D00:
		tst.b	($FFFFEF49).w
		bne.s	loc_37D0C
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_37D0C:
		move.l	#$FF7080,$C(a0)
		move.w	#-$7A00,$A(a0)
		move.w	#0,8(a0)
		move.b	#$40,7(a0)
		move.b	#$10,6(a0)
		move.w	#$C8,$10(a0)
		move.w	#$90,$14(a0)
		bset	#4,4(a0)
		lea	(word_37E8E).l,a1
		lea	($FF7080).l,a2
		move.w	#$19,d0

loc_37D4E:
		move.w	(a1)+,(a2)+
		dbf	d0,loc_37D4E
		move.l	#loc_37D5A,(a0)

loc_37D5A:
		lea	($FFFFFED6).w,a1
		lea	($FF708A).l,a2
		lea	($FFFFFED3).w,a3
		moveq	#0,d1
		move.b	($FFFFEE5D).w,d1
		lea	($FFFFFEC7).w,a4
		lea	($FFFFEE56).w,a5
		lea	($FF7840).l,a6

loc_37D7C:
		tst.b	(a4)
		beq.s	loc_37DB0
		bmi.s	loc_37DB0
		cmpi.l	#$93B63,(a5)
		bcs.s	loc_37D96
		move.b	#-$80,(a4)
		move.l	#$93B63,(a5)
		bra.s	loc_37DD0
; ---------------------------------------------------------------------------

loc_37D96:
		addq.b	#1,-(a1)
		cmpi.b	#$3C,(a1)
		bcs.s	loc_37DB0
		move.b	#0,(a1)
		addq.b	#1,-(a1)
		cmpi.b	#$3C,(a1)
		bcs.s	loc_37DB0
		move.b	#0,(a1)
		addq.b	#1,-(a1)

loc_37DB0:

		move.l	-1(a3),d6
		jsr	(sub_B0E4).l
		cmpi.w	#5,d1
		bcc.s	loc_37DD0
		lsl.w	#2,d1
		move.l	d6,(a6,d1.w)
		move.l	$14(a6),d5
		jsr	sub_36F76(pc)
		move.l	d6,(a5)

loc_37DD0:

		addq.w	#1,a5
		lea	word_37E2A(pc),a1
		moveq	#0,d0
		move.b	(a5)+,d0
		lsl.w	#2,d0
		move.l	(a1,d0.w),(a2)+
		addq.w	#8,a2
		moveq	#0,d0
		move.b	(a5)+,d0
		moveq	#0,d2

loc_37DE8:
		subi.w	#$A,d0
		bcs.s	loc_37DF2
		addq.w	#4,d2
		bra.s	loc_37DE8
; ---------------------------------------------------------------------------

loc_37DF2:
		addi.w	#$A,d0
		move.l	(a1,d2.w),(a2)+
		addq.w	#2,a2
		lsl.w	#2,d0
		move.l	(a1,d0.w),(a2)+
		addq.w	#8,a2
		moveq	#0,d0
		move.b	(a5)+,d0
		moveq	#0,d2

loc_37E0A:
		subi.w	#$A,d0
		bcs.s	loc_37E14
		addq.w	#4,d2
		bra.s	loc_37E0A
; ---------------------------------------------------------------------------

loc_37E14:
		addi.w	#$A,d0
		move.l	(a1,d2.w),(a2)+
		addq.w	#2,a2
		lsl.w	#2,d0
		move.l	(a1,d0.w),(a2)+
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
word_37E2A:	dc.w  $F805,	 8
		dc.w  $F801,	$C
		dc.w  $F805,	$E
		dc.w  $F805,   $12
		dc.w  $F805,   $16
		dc.w  $F805,   $1A
		dc.w  $F805,   $1E
		dc.w  $F805,   $22
		dc.w  $F805,   $26
		dc.w  $F805,   $2A
byte_37E52:	dc.b    0,   1,   3,   5,   6,   8,  $A,  $B,  $D,  $F, $10, $12, $14, $15, $17, $19, $1A, $1C, $1E, $1F
		dc.b  $21, $23, $24, $26, $28, $29, $2B, $2D, $2E, $30, $32, $33, $35, $37, $38, $3A, $3C, $3D, $3F, $41
		dc.b  $42, $44, $46, $47, $49, $4B, $4C, $4E, $50, $51, $53, $55, $56, $58, $5A, $5B, $5D, $5F, $60, $62
word_37E8E:	dc.w 2

		dc.w 8
		dc.w $F80D
		dc.w 0
		dc.w $FFC0
		dc.w $F805
		dc.w 8
		dc.w $FFE8
		dc.w $F000
		dc.w $2E
		dc.w $FFF4
		dc.w $F805
		dc.w 8
		dc.w $FFFC
		dc.w $F805
		dc.w 8
		dc.w 8
		dc.w $F000
		dc.w $2F
		dc.w $14
		dc.w $F805
		dc.w 8
		dc.w $1C
		dc.w $F805
		dc.w 8
		dc.w $28
; ---------------------------------------------------------------------------

loc_37EC2:

		move.l	#Map_2PItemIcon,$C(a0)
		move.w	#-$78B0,$A(a0)
		move.w	#0,8(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$120,$10(a0)
		move.w	#$E0,$14(a0)
		tst.b	$2C(a0)
		beq.s	loc_37F0E
		tst.b	($FFFFEF49).w
		bne.s	loc_37F00
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_37F00:
		bset	#4,4(a0)
		move.l	#loc_37F42,(a0)
		bra.s	loc_37F42
; ---------------------------------------------------------------------------

loc_37F0E:
		bset	#3,4(a0)
		move.l	#loc_37F1A,(a0)

loc_37F1A:
		moveq	#0,d0
		tst.w	($FFFFFE20).w
		beq.s	loc_37F24
		moveq	#3,d0

loc_37F24:
		btst	#2,($FFFFB02B).w
		beq.s	loc_37F38
		moveq	#1,d0
		cmpi.w	#$C00,($FFFFF760).w
		beq.s	loc_37F38
		moveq	#2,d0

loc_37F38:

		move.b	d0,$22(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_37F42:

		moveq	#0,d0
		tst.w	($FFFFFED0).w
		beq.s	loc_37F4C
		moveq	#3,d0

loc_37F4C:
		btst	#2,($FFFFB075).w
		beq.s	loc_37F60
		moveq	#1,d0
		cmpi.w	#$C00,($FFFFFEC0).w
		beq.s	loc_37F60
		moveq	#2,d0

loc_37F60:

		move.b	d0,$22(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Map_2PItemIcon:	include "General\2P Zone\Map - Item Icon.asm"

; ---------------------------------------------------------------------------
		move.l	#Map_2PPosition,$C(a0)
		move.w	#-$78A2,$A(a0)
		move.w	#0,8(a0)
		move.b	#4,7(a0)
		move.b	#4,6(a0)
		tst.b	$2C(a0)
		beq.s	loc_38044
		tst.b	($FFFFEF49).w
		bne.s	loc_3801E
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_3801E:
		move.w	#$90,$10(a0)

loc_38024:
		move.w	#$84,$14(a0)
		move.w	($FFFFB05A).w,$30(a0)
		bset	#4,4(a0)
		move.b	#2,$22(a0)
		move.l	#loc_380BC,(a0)
		bra.s	loc_380BC
; ---------------------------------------------------------------------------

loc_38044:
		move.w	#$90,$10(a0)
		move.w	#$E8,$14(a0)
		move.w	($FFFFB010).w,$30(a0)
		bset	#3,4(a0)
		move.b	#1,$22(a0)

loc_38062:
		move.l	#loc_38068,(a0)

loc_38068:
		move.w	($FFFFB010).w,d0
		move.w	($FFFFFE2E).w,d1

loc_38070:
		tst.w	($FFFFEEE6).w
		beq.s	loc_38080
		move.w	#0,$34(a0)
		move.w	d1,$30(a0)

loc_38080:
		move.w	d0,d1
		sub.w	$30(a0),d0
		beq.s	loc_380A8
		bcc.s	loc_38096
		cmpi.w	#-$200,d0
		bge.s	loc_380A0
		addi.w	#$400,d0
		bra.s	loc_380A0
; ---------------------------------------------------------------------------

loc_38096:
		cmpi.w	#$200,d0
		blt.s	loc_380A0
		subi.w	#$400,d0

loc_380A0:

		add.w	d0,$34(a0)
		move.w	d1,$30(a0)

loc_380A8:
		move.w	$34(a0),d0
		asr.w	#6,d0
		addi.w	#$90,d0
		move.w	d0,$10(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_380BC:

		move.w	($FFFFB05A).w,d0
		move.w	($FFFFFE4C).w,d1
		bra.s	loc_38070
; ---------------------------------------------------------------------------
Map_2PPosition:	include "General\2P Zone\Map - Position Icons (Unused).asm"

; ---------------------------------------------------------------------------

Obj_EMZDripper:

		move.l	#Map_EMZDripper,$C(a0)
		move.w	#$6300,$A(a0)
		move.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#8,7(a0)
		move.b	#8,6(a0)
		move.b	#4,$1F(a0)
		move.b	#4,$1E(a0)
		btst	#0,$2A(a0)
		beq.s	loc_3814A
		move.w	#-$3D00,$A(a0)
		move.b	#3,$22(a0)
		move.l	#Draw_Sprite,(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_3814A:
		move.l	#loc_38150,(a0)

loc_38150:
		move.b	($FFFFFE05).w,d0
		add.b	$2C(a0),d0
		andi.b	#$7F,d0
		bne.s	loc_38188
		jsr	(Create_New_Sprite3).l
		bne.w	loc_38188
		moveq	#$2C,d0

loc_3816A:
		move.w	(a0,d0.w),(a1,d0.w)
		subq.w	#2,d0
		bcc.s	loc_3816A
		move.l	#loc_3818E,(a1)
		move.w	#$4300,$A(a1)
		move.b	#1,$22(a1)
		moveq	#0,d0

loc_38188:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_3818E:
		jsr	(MoveSprite2).l
		addi.w	#8,$1A(a0)
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_381C8
		move.l	#loc_38234,(a0)
		move.w	#$100,$18(a0)
		neg.w	$1A(a0)

loc_381B4:
		asr	$1A(a0)
		asr	$1A(a0)
		move.b	#2,$22(a0)
		bsr.s	sub_381F2
		bsr.s	sub_381F2
		bsr.s	sub_381F2

loc_381C8:
		cmpi.w	#-$100,($FFFFEE18).w
		bne.s	loc_381D8
		move.w	($FFFFEEAA).w,d0
		and.w	d0,$14(a0)

loc_381D8:
		move.w	($FFFFEE1A).w,d0
		addi.w	#$60,d0
		cmp.w	$14(a0),d0
		bge.s	loc_381EC
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_381EC:
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_381F2:

		jsr	(Create_New_Sprite3).l
		bne.w	locret_38232
		moveq	#$2C,d0

loc_381FE:
		move.w	(a0,d0.w),(a1,d0.w)
		subq.w	#2,d0
		bcc.s	loc_381FE
		jsr	(Random_Number).l
		move.w	d0,d1
		andi.w	#$1FF,d0
		subi.w	#$100,d0
		move.w	d0,$18(a1)
		rol.w	#4,d1
		andi.w	#$F,d1
		addi.w	#$1A,d1
		move.b	d1,$3C(a1)
		subi.w	#$10,$1A(a0)
		moveq	#0,d0

locret_38232:
		rts
; End of function sub_381F2

; ---------------------------------------------------------------------------

loc_38234:
		jsr	(MoveSprite2).l
		addi.w	#8,$1A(a0)
		subq.b	#1,$3C(a0)
		bne.s	loc_3824C
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_3824C:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Map_EMZDripper:	include "Levels\EMZ\Misc Object Data\Map - Dripper.asm"

; ---------------------------------------------------------------------------

locret_3827A:
		rts
; ---------------------------------------------------------------------------

Obj_WaterDrop:

		move.l	#Map_HCZWaterDrop,$C(a0)
		move.w	#$235C,$A(a0)
		ori.b	#4,4(a0)
		move.w	#0,8(a0)

loc_38296:
		move.b	#8,7(a0)
		move.b	#8,6(a0)
		move.b	#8,$1F(a0)
		move.b	#7,$1E(a0)
		move.b	#6,$22(a0)
		move.l	#loc_382BA,(a0)

loc_382BA:
		subq.w	#1,$30(a0)
		bpl.s	loc_382F6
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#2,d0
		move.w	d0,$30(a0)
		tst.b	4(a0)

loc_382D0:
		bpl.s	loc_382F6
		jsr	(Create_New_Sprite3).l
		bne.w	loc_382F6
		moveq	#$2C,d0

loc_382DE:
		move.w	(a0,d0.w),(a1,d0.w)
		subq.w	#2,d0
		bcc.s	loc_382DE
		move.l	#loc_382FC,(a1)
		move.b	#-$39,$28(a1)
		moveq	#0,d0

loc_382F6:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_382FC:
		tst.b	5(a0)
		beq.s	loc_38336
		jsr	(MoveSprite2).l
		addi.w	#8,$1A(a0)
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_38336
		add.w	d1,$14(a0)
		clr.w	$1A(a0)
		move.w	#$101,$20(a0)
		move.l	#loc_38336,(a0)
		move.b	#1,$24(a0)
		clr.b	$23(a0)

loc_38336:


		lea	(Ani_HCZWaterDrop).l,a1
		jsr	(Animate_Sprite).l
		cmpi.b	#4,5(a0)
		bne.s	loc_38350
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_38350:
		tst.b	$29(a0)
		beq.s	loc_38376
		lea	($FFFFB000).w,a2
		bclr	#0,$29(a0)
		beq.s	loc_38364
		bsr.s	sub_38382

loc_38364:
		lea	($FFFFB04A).w,a2
		bclr	#1,$29(a0)
		beq.s	loc_38372
		bsr.s	sub_38382

loc_38372:
		clr.b	$29(a0)

loc_38376:
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_38382:

		cmpi.b	#5,$20(a2)
		bne.s	loc_38390
		move.b	#0,$21(a2)

loc_38390:
		move.b	#1,$20(a0)
		move.l	#loc_38336,(a0)
		move.b	#0,$28(a0)
		move.b	#2,5(a0)
		rts
; End of function sub_38382

; ---------------------------------------------------------------------------
Ani_HCZWaterDrop:	include "Levels\HCZ\Misc Object Data\Anim - Water Drop.asm"

; ---------------------------------------------------------------------------

Obj_HCZWaterSplash:

		tst.b	$2C(a0)
		beq.s	loc_38432
		move.l	#Map_HCZWaterSplash2,$C(a0)
		move.w	#$36E,$A(a0)
		tst.b	($FFFFFE11).w
		beq.s	loc_383DC
		move.w	#$344,$A(a0)

loc_383DC:
		ori.b	#4,4(a0)
		move.w	#$300,8(a0)
		move.b	#-$60,7(a0)
		move.b	#-$80,6(a0)
		move.b	#-1,$31(a0)
		move.b	#0,$2A(a0)
		bset	#6,4(a0)
		move.w	#2,$16(a0)
		lea	$18(a0),a2
		move.w	$10(a0),(a2)+
		move.w	$14(a0),(a2)+
		move.w	#5,(a2)+
		move.w	$10(a0),(a2)+
		move.w	$14(a0),(a2)+
		move.w	#$505,(a2)+
		move.l	#loc_384B2,(a0)
		bra.w	loc_384B2
; ---------------------------------------------------------------------------

loc_38432:
		move.l	#Map_HCZWaterSplash,$C(a0)
		move.w	#$43B2,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$300,8(a0)
		move.b	#$28,7(a0)
		move.b	#$20,6(a0)
		move.b	#-1,$30(a0)
		move.l	#loc_38464,(a0)

loc_38464:
		subq.b	#1,$24(a0)
		bpl.s	loc_3847A
		move.b	#7,$24(a0)
		addq.b	#1,$22(a0)
		andi.b	#3,$22(a0)

loc_3847A:
		tst.b	4(a0)
		bpl.s	loc_384AC
		moveq	#0,d1
		move.b	$22(a0),d1
		cmp.b	$30(a0),d1
		beq.s	loc_384AC
		move.b	d1,$30(a0)
		lsl.w	#8,d1
		move.w	d1,d0
		add.w	d0,d0
		add.w	d0,d1
		addi.l	#ArtUnc_HCZWaterSplash,d1
		move.w	#$7640,d2
		move.w	#$180,d3
		jsr	(Add_To_DMA_Queue).l

loc_384AC:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_384B2:

		move.w	($FFFFB010).w,$10(a0)
		move.w	($FFFFF646).w,$14(a0)
		bsr.s	sub_38534
		tst.b	$2A(a0)
		beq.s	loc_384F8
		move.b	($FFFFFE05).w,d0
		addq.b	#2,d0
		andi.b	#$F,d0
		bne.s	loc_384DA
		moveq	#-$25,d0
		jsr	(Play_Sound_2).l

loc_384DA:
		subq.b	#1,$24(a0)
		bpl.s	loc_384F8
		move.b	#2,$24(a0)
		addq.b	#1,$30(a0)
		cmpi.b	#5,$30(a0)
		bcs.s	loc_384F8
		move.b	#0,$30(a0)

loc_384F8:

		moveq	#0,d1
		move.b	$30(a0),d1
		cmp.b	$31(a0),d1
		beq.s	loc_3852E
		move.b	d1,$31(a0)
		lsl.w	#7,d1
		move.w	d1,d0
		add.w	d0,d0
		add.w	d0,d1
		addi.l	#ArtUnc_HCZWaterSplash2,d1
		move.w	#$6DC0,d2
		tst.b	($FFFFFE11).w
		beq.s	loc_38524
		move.w	#$6880,d2

loc_38524:
		move.w	#$C0,d3
		jsr	(Add_To_DMA_Queue).l

loc_3852E:
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_38534:
		lea	($FFFFB000).w,a1
		lea	$18(a0),a2
		moveq	#3,d6
		move.w	($FFFFF602).w,d5
		bsr.s	sub_3857E
		bclr	#0,4(a0)
		btst	#0,$2A(a1)
		beq.s	loc_38558
		bset	#0,4(a0)

loc_38558:
		lea	($FFFFB04A).w,a1
		lea	$1E(a0),a2
		moveq	#4,d6
		move.w	($FFFFF66A).w,d5
		bsr.s	sub_3857E
		move.b	4(a0),d0
		add.b	$2A(a1),d0
		andi.b	#1,d0
		beq.s	locret_3857C
		move.b	#5,5(a2)

locret_3857C:
		rts
; End of function sub_38534


; =============== S U B R O U T I N E =======================================


sub_3857E:

		btst	d6,$2A(a0)
		bne.s	loc_385D2
		tst.w	$1A(a1)
		bne.s	locret_385D0
		moveq	#0,d1
		move.b	$1E(a1),d1
		add.w	$14(a1),d1
		addq.w	#1,d1
		cmp.w	($FFFFF646).w,d1
		bne.s	locret_385D0
		move.w	$18(a1),d0
		bpl.s	loc_385A4
		neg.w	d0

loc_385A4:
		cmpi.w	#$700,d0
		bcs.s	locret_385D0
		bset	d6,$2A(a0)
		move.w	$10(a1),(a2)
		move.w	($FFFFF646).w,2(a2)
		move.b	#0,5(a2)
		bclr	#0,$2A(a1)
		tst.w	$18(a1)
		bpl.s	locret_385D0
		bset	#0,$2A(a1)

locret_385D0:

		rts
; ---------------------------------------------------------------------------

loc_385D2:
		move.w	d5,d0
		andi.w	#$70,d0
		bne.s	loc_38652
		move.w	($FFFFF646).w,d0
		moveq	#0,d1
		move.b	$1E(a1),d1
		sub.w	d1,d0
		subq.w	#1,d0
		cmp.w	$14(a1),d0
		bhi.s	loc_38646
		move.w	$18(a1),d1
		bpl.s	loc_385F6
		neg.w	d1

loc_385F6:
		cmpi.w	#$700,d1
		bcs.s	loc_38646
		move.w	d0,$14(a1)
		move.w	#0,$1A(a1)
		move.w	$10(a1),(a2)
		move.w	($FFFFF646).w,2(a2)
		btst	#1,$2A(a1)
		beq.s	locret_38650
		andi.w	#$C00,d5
		bne.s	locret_38650
		move.w	#$C,d1
		move.w	$18(a1),d0
		beq.s	loc_38646
		bmi.s	loc_38638
		sub.w	d1,d0
		bcc.s	loc_38632
		move.w	#0,d0

loc_38632:
		move.w	d0,$18(a1)
		bra.s	locret_38650
; ---------------------------------------------------------------------------

loc_38638:
		add.w	d1,d0
		bcc.s	loc_38640
		move.w	#0,d0

loc_38640:
		move.w	d0,$18(a1)
		bra.s	locret_38650
; ---------------------------------------------------------------------------

loc_38646:

		bclr	d6,$2A(a0)
		move.b	#5,5(a2)

locret_38650:

		rts
; ---------------------------------------------------------------------------

loc_38652:
		bclr	d6,$2A(a0)
		move.b	#5,5(a2)
		move.w	#-$680,$1A(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		rts
; End of function sub_3857E

; ---------------------------------------------------------------------------

Obj_TensionBridge:

		move.l	#loc_387E0,(a0)
		move.l	#Map_TensionBridge,$C(a0)
		move.w	#$4038,$A(a0)
		move.w	#$200,8(a0)
		cmpi.b	#5,($FFFFFE10).w
		bne.s	loc_386D0
		move.l	#loc_38882,(a0)
		move.l	#Map_ICZTensionBridge,$C(a0)
		move.w	#$43B6,$A(a0)
		tst.b	$2C(a0)
		bpl.s	loc_386D0
		move.l	#loc_38946,(a0)
		andi.b	#$7F,$2C(a0)

loc_386D0:

		cmpi.b	#9,($FFFFFE10).w
		bne.s	loc_386DE
		move.w	#-$1EED,$A(a0)

loc_386DE:
		tst.b	$2C(a0)
		bpl.s	loc_386F0
		move.l	#loc_387B6,(a0)
		andi.b	#$7F,$2C(a0)

loc_386F0:
		move.b	#4,4(a0)
		move.b	#-$80,7(a0)
		move.b	#8,6(a0)
		move.w	$14(a0),d2
		move.w	d2,$3C(a0)
		move.w	$10(a0),d3
		lea	$2C(a0),a2
		moveq	#0,d1
		move.b	(a2),d1
		move.w	d1,d0
		lsr.w	#1,d0
		lsl.w	#4,d0
		sub.w	d0,d3
		swap	d1
		move.w	#8,d1
		bsr.s	sub_38756
		move.w	$30(a1),d0
		subq.w	#8,d0
		move.w	d0,$10(a1)
		move.l	a1,$30(a0)
		swap	d1
		subq.w	#8,d1
		bls.s	loc_38752
		move.w	d1,d4
		bsr.s	sub_38756
		move.l	a1,$34(a0)
		move.w	d4,d0
		add.w	d0,d0
		add.w	d4,d0
		move.w	$18(a1,d0.w),d0
		subq.w	#8,d0
		move.w	d0,$10(a1)

loc_38752:
		bra.w	loc_387E0

; =============== S U B R O U T I N E =======================================


sub_38756:

		jsr	(Create_New_Sprite3).l
		bne.s	locret_387B4
		move.l	#loc_3887C,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.b	4(a0),4(a1)
		move.w	8(a0),8(a1)
		bset	#6,4(a1)
		move.b	#$40,7(a1)
		move.b	#8,6(a1)
		move.w	d1,$16(a1)
		subq.b	#1,d1
		lea	$18(a1),a2

loc_387A4:
		move.w	d3,(a2)+
		move.w	d2,(a2)+
		move.w	#0,(a2)+
		addi.w	#$10,d3
		dbf	d1,loc_387A4

locret_387B4:
		rts
; End of function sub_38756

; ---------------------------------------------------------------------------

loc_387B6:
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		lea	(a3,d0.w),a3
		tst.b	(a3)
		beq.s	loc_387E0
		move.l	#loc_3890C,(a0)
		move.b	#$E,$34(a0)
		move.l	#loc_388E4,d4
		bra.w	loc_389C8
; ---------------------------------------------------------------------------

loc_387E0:


		move.b	$2A(a0),d0
		andi.b	#$18,d0
		bne.s	loc_387F6
		tst.b	$3E(a0)
		beq.s	loc_38822
		subq.b	#4,$3E(a0)
		bra.s	loc_3881E
; ---------------------------------------------------------------------------

loc_387F6:
		andi.b	#$10,d0
		beq.s	loc_38812
		move.b	$3F(a0),d0
		sub.b	$3B(a0),d0
		beq.s	loc_38812
		bcc.s	loc_3880E
		addq.b	#1,$3F(a0)
		bra.s	loc_38812
; ---------------------------------------------------------------------------

loc_3880E:
		subq.b	#1,$3F(a0)

loc_38812:

		cmpi.b	#$40,$3E(a0)
		beq.s	loc_3881E
		addq.b	#4,$3E(a0)

loc_3881E:

		bsr.w	sub_38CC2

loc_38822:
		moveq	#0,d1
		move.b	$2C(a0),d1
		lsl.w	#3,d1
		move.w	d1,d2
		addq.w	#8,d1
		add.w	d2,d2
		moveq	#8,d3
		move.w	$10(a0),d4
		bsr.w	sub_38A88

loc_3883A:

		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_3884E
		rts
; ---------------------------------------------------------------------------

loc_3884E:
		movea.l	$30(a0),a1

loc_38852:
		jsr	(Delete_Referenced_Sprite).l
		cmpi.b	#8,$2C(a0)
		bls.s	loc_3886A
		movea.l	$34(a0),a1
		jsr	(Delete_Referenced_Sprite).l

loc_3886A:
		move.w	$48(a0),d0
		beq.s	loc_38876
		movea.w	d0,a2
		bclr	#7,(a2)

loc_38876:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_3887C:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_38882:
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		bne.s	loc_38898
		tst.b	$3E(a0)
		beq.s	loc_388C4
		subq.b	#4,$3E(a0)
		bra.s	loc_388C0
; ---------------------------------------------------------------------------

loc_38898:
		andi.b	#$10,d0
		beq.s	loc_388B4
		move.b	$3F(a0),d0
		sub.b	$3B(a0),d0
		beq.s	loc_388B4
		bcc.s	loc_388B0
		addq.b	#1,$3F(a0)
		bra.s	loc_388B4
; ---------------------------------------------------------------------------

loc_388B0:
		subq.b	#1,$3F(a0)

loc_388B4:

		cmpi.b	#$40,$3E(a0)
		beq.s	loc_388C0
		addq.b	#4,$3E(a0)

loc_388C0:

		bsr.w	sub_38CC2

loc_388C4:
		moveq	#0,d1
		move.b	$2C(a0),d1
		lsl.w	#3,d1
		move.w	d1,d2
		addq.w	#8,d1
		add.w	d2,d2
		moveq	#8,d3

loc_388D4:
		move.w	$10(a0),d4
		bsr.w	sub_38A88
		bsr.w	sub_38C12
		bra.w	loc_3883A
; ---------------------------------------------------------------------------

loc_388E4:
		tst.b	$34(a0)
		beq.s	loc_388F4
		subq.b	#1,$34(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_388F4:
		jsr	(MoveSprite).l
		tst.b	4(a0)
		bpl.s	loc_38906
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_38906:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_3890C:
		tst.b	$34(a0)
		beq.s	loc_38918
		subq.b	#1,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_38918:
		bclr	#3,$2A(a0)
		beq.s	loc_3892C
		bclr	#3,($FFFFB02A).w
		bset	#1,($FFFFB02A).w

loc_3892C:
		bclr	#4,$2A(a0)
		beq.s	loc_38940
		bclr	#3,($FFFFB074).w
		bset	#1,($FFFFB074).w

loc_38940:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_38946:
		bsr.w	sub_38D74
		move.l	#loc_38950,(a0)

loc_38950:
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		bne.s	loc_38966
		tst.b	$3E(a0)
		beq.s	loc_389A8
		subq.b	#4,$3E(a0)
		bra.s	loc_389A4
; ---------------------------------------------------------------------------

loc_38966:
		moveq	#0,d1
		move.b	$2C(a0),d1
		lsl.w	#3,d1
		move.w	d1,d2
		addq.w	#8,d1
		add.w	d2,d2
		bsr.w	sub_38BD8
		move.b	$2A(a0),d0
		andi.b	#$10,d0
		beq.s	loc_38998
		move.b	$3F(a0),d0
		sub.b	$3B(a0),d0
		beq.s	loc_38998
		bcc.s	loc_38994
		addq.b	#1,$3F(a0)
		bra.s	loc_38998
; ---------------------------------------------------------------------------

loc_38994:
		subq.b	#1,$3F(a0)

loc_38998:

		cmpi.b	#$40,$3E(a0)
		beq.s	loc_389A4
		addq.b	#4,$3E(a0)

loc_389A4:

		bsr.w	sub_38D74

loc_389A8:
		moveq	#0,d1
		move.b	$2C(a0),d1
		lsl.w	#3,d1
		move.w	d1,d2
		addq.w	#8,d1
		add.w	d2,d2
		moveq	#8,d3
		move.w	$10(a0),d4
		bsr.w	sub_38B2A
		bsr.w	sub_38C12
		bra.w	loc_3883A
; ---------------------------------------------------------------------------

loc_389C8:
		movea.l	$30(a0),a3
		bsr.s	sub_389DE
		cmpi.b	#8,$2C(a0)
		bls.s	locret_389DC
		movea.l	$34(a0),a3
		bsr.s	sub_389DE

locret_389DC:
		rts

; =============== S U B R O U T I N E =======================================


sub_389DE:

		lea	(byte_38A78).l,a4
		lea	$18(a3),a2
		move.w	$16(a3),d6
		subq.w	#1,d6
		bclr	#6,4(a3)
		movea.l	a3,a1
		bra.s	loc_38A00
; ---------------------------------------------------------------------------

loc_389F8:
		jsr	(Create_New_Sprite3).l
		bne.s	loc_38A64

loc_38A00:
		move.l	d4,(a1)
		move.l	$C(a3),$C(a1)
		move.b	4(a3),4(a1)
		move.w	$A(a3),$A(a1)
		move.w	8(a3),8(a1)
		move.b	7(a3),7(a1)
		move.b	6(a3),6(a1)
		move.w	8(a3),8(a1)
		move.w	(a2)+,$10(a1)
		move.w	(a2)+,$14(a1)
		move.w	(a2)+,d0
		move.b	d0,$22(a1)
		move.b	(a4)+,$34(a1)
		movea.l	a1,a5
		jsr	(Create_New_Sprite3).l
		bne.s	loc_38A64
		move.l	#loc_1E6EC,(a1)
		move.w	$10(a5),$10(a1)
		move.w	$14(a5),$14(a1)
		move.b	-1(a4),$24(a1)
		dbf	d6,loc_389F8

loc_38A64:

		move.w	#0,$18(a3)
		move.w	#0,$1A(a3)
		moveq	#-$7D,d0
		jmp	(Play_Sound_2).l
; End of function sub_389DE

; ---------------------------------------------------------------------------
byte_38A78:	dc.b	8, $10,	 $C,  $E,   6,	$A,   4,   2
		dc.b	8, $10,	 $C,  $E,   6,	$A,   4,   2

; =============== S U B R O U T I N E =======================================


sub_38A88:

		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		moveq	#$3B,d5
		movem.l	d1-d4,-(sp)
		bsr.s	sub_38AA2
		movem.l	(sp)+,d1-d4
		lea	($FFFFB000).w,a1
		subq.b	#1,d6
		moveq	#$3F,d5
; End of function sub_38A88


; =============== S U B R O U T I N E =======================================


sub_38AA2:
		btst	d6,$2A(a0)
		beq.s	loc_38B06
		btst	#1,$2A(a1)
		bne.s	loc_38AC2
		moveq	#0,d0
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	loc_38AC2
		cmp.w	d2,d0
		bcs.s	loc_38AD0

loc_38AC2:

		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_38AD0:
		lsr.w	#4,d0
		move.b	d0,(a0,d5.w)
		movea.l	$30(a0),a2
		cmpi.w	#8,d0
		bcs.s	loc_38AE8
		movea.l	$34(a0),a2
		subi.w	#8,d0

loc_38AE8:
		add.w	d0,d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		move.w	$1A(a2,d0.w),d0
		subq.w	#8,d0
		moveq	#0,d1
		move.b	$1E(a1),d1
		sub.w	d1,d0
		move.w	d0,$14(a1)
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_38B06:
		move.w	d1,-(sp)
		jsr	(sub_1E410).l
		move.w	(sp)+,d1
		btst	d6,$2A(a0)
		beq.s	locret_38B28
		moveq	#0,d0
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		lsr.w	#4,d0
		move.b	d0,(a0,d5.w)

locret_38B28:
		rts
; End of function sub_38AA2


; =============== S U B R O U T I N E =======================================


sub_38B2A:
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		moveq	#$3B,d5
		movem.l	d1-d4,-(sp)
		bsr.s	sub_38B44
		movem.l	(sp)+,d1-d4
		lea	($FFFFB000).w,a1
		subq.b	#1,d6
		moveq	#$3F,d5
; End of function sub_38B2A


; =============== S U B R O U T I N E =======================================


sub_38B44:
		btst	d6,$2A(a0)
		beq.s	loc_38BA4
		btst	#1,$2A(a1)
		bne.s	loc_38B64
		moveq	#0,d0
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	loc_38B64
		cmp.w	d2,d0
		bcs.s	loc_38B72

loc_38B64:

		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_38B72:
		lsr.w	#4,d0
		movea.l	$30(a0),a2
		cmpi.w	#8,d0
		bcs.s	loc_38B86
		movea.l	$34(a0),a2
		subi.w	#8,d0

loc_38B86:
		add.w	d0,d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		move.w	$1A(a2,d0.w),d0
		subq.w	#8,d0
		moveq	#0,d1
		move.b	$1E(a1),d1
		sub.w	d1,d0
		move.w	d0,$14(a1)
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_38BA4:
		bsr.s	sub_38BA8
		rts
; End of function sub_38B44


; =============== S U B R O U T I N E =======================================


sub_38BA8:
		tst.w	$1A(a1)
		bmi.s	locret_38BD6
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	locret_38BD6
		cmp.w	d2,d0
		bcc.s	locret_38BD6
		lsr.w	#4,d0
		move.w	d0,d3
		add.w	d0,d0
		add.w	d0,d3
		neg.w	d3
		addq.w	#8,d3
		move.w	$14(a0),d0
		sub.w	d3,d0
		jmp	(loc_1E45A).l
; ---------------------------------------------------------------------------

locret_38BD6:

		rts
; End of function sub_38BA8


; =============== S U B R O U T I N E =======================================


sub_38BD8:
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		moveq	#$3B,d5
		bsr.s	sub_38BEA
		lea	($FFFFB000).w,a1
		subq.b	#1,d6
		moveq	#$3F,d5
; End of function sub_38BD8


; =============== S U B R O U T I N E =======================================


sub_38BEA:
		btst	d6,$2A(a0)
		beq.s	locret_38C10
		btst	#1,$2A(a1)
		bne.s	locret_38C10
		moveq	#0,d0
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	locret_38C10
		cmp.w	d2,d0
		bcc.s	locret_38C10
		lsr.w	#4,d0
		move.b	d0,(a0,d5.w)

locret_38C10:
		rts
; End of function sub_38BEA


; =============== S U B R O U T I N E =======================================


sub_38C12:

		movea.l	$30(a0),a1
		lea	$1D(a1),a1
		movea.l	$34(a0),a2
		lea	$1D(a2),a2
		moveq	#-2,d3
		moveq	#-2,d4
		move.b	$2A(a0),d0
		andi.w	#8,d0
		beq.s	loc_38C3E
		tst.w	($FFFFB018).w
		beq.s	loc_38C3E
		move.b	$3F(a0),d0
		bsr.w	sub_38C8E

loc_38C3E:

		move.b	$2A(a0),d0
		andi.w	#$10,d0
		beq.s	loc_38C56
		tst.w	($FFFFB062).w
		beq.s	loc_38C56
		move.b	$3B(a0),d0
		bsr.w	sub_38C8E

loc_38C56:

		movea.l	$30(a0),a1
		lea	$4D(a1),a2
		lea	$1D(a1),a1
		moveq	#0,d1
		move.b	$2C(a0),d1
		subq.b	#1,d1

loc_38C6A:
		tst.b	(a1)
		beq.s	loc_38C7A
		addq.b	#1,(a1)
		cmpi.b	#$C,(a1)
		bcs.s	loc_38C7A
		move.b	#0,(a1)

loc_38C7A:

		addq.w	#6,a1
		cmpa.w	a2,a1
		bne.s	loc_38C88
		movea.l	$34(a0),a1
		lea	$1D(a1),a1

loc_38C88:
		dbf	d1,loc_38C6A
		rts
; End of function sub_38C12


; =============== S U B R O U T I N E =======================================


sub_38C8E:

		cmpi.b	#8,d0
		bcc.s	loc_38CAA
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		add.w	d0,d0
		tst.b	(a1,d0.w)
		bne.s	locret_38CA8
		move.b	#1,(a1,d0.w)

locret_38CA8:
		rts
; ---------------------------------------------------------------------------

loc_38CAA:
		subq.w	#8,d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		add.w	d0,d0
		tst.b	(a2,d0.w)
		bne.s	locret_38CC0
		move.b	#1,(a2,d0.w)

locret_38CC0:
		rts
; End of function sub_38C8E


; =============== S U B R O U T I N E =======================================


sub_38CC2:

		move.b	$3E(a0),d0
		jsr	(GetSineCosine).l
		move.w	d0,d4
		lea	(BridgeBendData).l,a4
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#4,d0
		moveq	#0,d3
		move.b	$3F(a0),d3
		move.w	d3,d2
		add.w	d0,d3
		moveq	#0,d5
		lea	(loc_38DAA).l,a5
		move.b	(a5,d3.w),d5
		andi.w	#$F,d3
		lsl.w	#4,d3
		lea	(a4,d3.w),a3
		movea.l	$30(a0),a1
		lea	$4A(a1),a2
		lea	$1A(a1),a1

loc_38D08:
		moveq	#0,d0
		move.b	(a3)+,d0
		addq.w	#1,d0
		mulu.w	d5,d0
		mulu.w	d4,d0
		swap	d0
		add.w	$3C(a0),d0
		move.w	d0,(a1)
		addq.w	#6,a1
		cmpa.w	a2,a1
		bne.s	loc_38D28
		movea.l	$34(a0),a1
		lea	$1A(a1),a1

loc_38D28:
		dbf	d2,loc_38D08
		moveq	#0,d0
		move.b	$2C(a0),d0
		moveq	#0,d3
		move.b	$3F(a0),d3
		addq.b	#1,d3
		sub.b	d0,d3
		neg.b	d3
		bmi.s	locret_38D72
		move.w	d3,d2
		lsl.w	#4,d3
		lea	(a4,d3.w),a3
		adda.w	d2,a3
		subq.w	#1,d2
		bcs.s	locret_38D72

loc_38D4E:
		moveq	#0,d0
		move.b	-(a3),d0
		addq.w	#1,d0
		mulu.w	d5,d0
		mulu.w	d4,d0
		swap	d0
		add.w	$3C(a0),d0
		move.w	d0,(a1)
		addq.w	#6,a1
		cmpa.w	a2,a1
		bne.s	loc_38D6E
		movea.l	$34(a0),a1
		lea	$1A(a1),a1

loc_38D6E:
		dbf	d2,loc_38D4E

locret_38D72:

		rts
; End of function sub_38CC2


; =============== S U B R O U T I N E =======================================


sub_38D74:

		move.b	$3E(a0),d0
		jsr	(GetSineCosine).l
		move.w	d0,d4
		lea	(BridgeBendData).l,a4
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#4,d0
		moveq	#0,d3
		move.b	$3F(a0),d3
		move.w	d3,d2
		add.w	d0,d3
		moveq	#0,d5
		lea	(loc_38DAA).l,a5
		move.b	(a5,d3.w),d5
		andi.w	#$F,d3
		lsl.w	#4,d3

loc_38DAA:

		lea	(a4,d3.w),a3
		move.w	$3C(a0),d6
		movea.l	$30(a0),a1
		lea	$4A(a1),a2
		lea	$1A(a1),a1

loc_38DBE:
		moveq	#0,d0
		move.b	(a3)+,d0
		addq.w	#1,d0
		mulu.w	d5,d0
		mulu.w	d4,d0
		swap	d0
		add.w	d6,d0
		addq.w	#3,d6
		move.w	d0,(a1)
		addq.w	#6,a1
		cmpa.w	a2,a1
		bne.s	loc_38DDE
		movea.l	$34(a0),a1
		lea	$1A(a1),a1

loc_38DDE:
		dbf	d2,loc_38DBE
		moveq	#0,d0
		move.b	$2C(a0),d0
		moveq	#0,d3
		move.b	$3F(a0),d3
		addq.b	#1,d3
		sub.b	d0,d3
		neg.b	d3
		bmi.s	locret_38E28
		move.w	d3,d2
		lsl.w	#4,d3
		lea	(a4,d3.w),a3
		adda.w	d2,a3
		subq.w	#1,d2
		bcs.s	locret_38E28

loc_38E04:
		moveq	#0,d0
		move.b	-(a3),d0
		addq.w	#1,d0
		mulu.w	d5,d0
		mulu.w	d4,d0
		swap	d0
		add.w	d6,d0
		addq.w	#3,d6
		move.w	d0,(a1)
		addq.w	#6,a1
		cmpa.w	a2,a1
		bne.s	loc_38E24
		movea.l	$34(a0),a1
		lea	$1A(a1),a1

loc_38E24:
		dbf	d2,loc_38E04

locret_38E28:

		rts
; End of function sub_38D74

; ---------------------------------------------------------------------------
byte_38E2A:	dc.b	2,   4,	  6,   8,   8,	 6,   4,   2,	0,   0,	  0,   0,   0,	 0,   0,   0
		dc.b	2,   4,	  6,   8,  $A,	 8,   6,   4,	2,   0,	  0,   0,   0,	 0,   0,   0
		dc.b	2,   4,	  6,   8,  $A,	$A,   8,   6,	4,   2,	  0,   0,   0,	 0,   0,   0
		dc.b	2,   4,	  6,   8,  $A,	$C,  $A,   8,	6,   4,	  2,   0,   0,	 0,   0,   0
		dc.b	2,   4,	  6,   8,  $A,	$C,  $C,  $A,	8,   6,	  4,   2,   0,	 0,   0,   0
		dc.b	2,   4,	  6,   8,  $A,	$C,  $E,  $C,  $A,   8,	  6,   4,   2,	 0,   0,   0
		dc.b	2,   4,	  6,   8,  $A,	$C,  $E,  $E,  $C,  $A,	  8,   6,   4,	 2,   0,   0
		dc.b	2,   4,	  6,   8,  $A,	$C,  $E, $10,  $E,  $C,	 $A,   8,   6,	 4,   2,   0
		dc.b	2,   4,	  6,   8,  $A,	$C,  $E, $10, $10,  $E,	 $C,  $A,   8,	 6,   4,   2
BridgeBendData:	dc.b  $FF,   0,	  0,   0,   0,	 0,   0,   0,	0,   0,	  0,   0,   0,	 0,   0,   0

		dc.b  $B5, $FF,	  0,   0,   0,	 0,   0,   0,	0,   0,	  0,   0,   0,	 0,   0,   0
		dc.b  $7E, $DB,	$FF,   0,   0,	 0,   0,   0,	0,   0,	  0,   0,   0,	 0,   0,   0
		dc.b  $61, $B5,	$EC, $FF,   0,	 0,   0,   0,	0,   0,	  0,   0,   0,	 0,   0,   0
		dc.b  $4A, $93,	$CD, $F3, $FF,	 0,   0,   0,	0,   0,	  0,   0,   0,	 0,   0,   0
		dc.b  $3E, $7E,	$B0, $DB, $F6, $FF,   0,   0,	0,   0,	  0,   0,   0,	 0,   0,   0
		dc.b  $38, $6D,	$9D, $C5, $E4, $F8, $FF,   0,	0,   0,	  0,   0,   0,	 0,   0,   0
		dc.b  $31, $61,	$8E, $B5, $D4, $EC, $FB, $FF,	0,   0,	  0,   0,   0,	 0,   0,   0
		dc.b  $2B, $56,	$7E, $A2, $C1, $DB, $EE, $FB, $FF,   0,	  0,   0,   0,	 0,   0,   0
		dc.b  $25, $4A,	$73, $93, $B0, $CD, $E1, $F3, $FC, $FF,	  0,   0,   0,	 0,   0,   0
		dc.b  $1F, $44,	$67, $88, $A7, $BD, $D4, $E7, $F4, $FD,	$FF,   0,   0,	 0,   0,   0
		dc.b  $1F, $3E,	$5C, $7E, $98, $B0, $C9, $DB, $EA, $F6,	$FD, $FF,   0,	 0,   0,   0
		dc.b  $19, $38,	$56, $73, $8E, $A7, $BD, $D1, $E1, $EE,	$F8, $FE, $FF,	 0,   0,   0
		dc.b  $19, $38,	$50, $6D, $83, $9D, $B0, $C5, $D8, $E4,	$F1, $F8, $FE, $FF,   0,   0
		dc.b  $19, $31,	$4A, $67, $7E, $93, $A7, $BD, $CD, $DB,	$E7, $F3, $F9, $FE, $FF,   0
		dc.b  $19, $31,	$4A, $61, $78, $8E, $A2, $B5, $C5, $D4,	$E1, $EC, $F4, $FB, $FE, $FF
Map_ICZTensionBridge:include "Levels\ICZ\Misc Object Data\Map - ICZ Tension Bridge.asm"

Map_TensionBridge:include "Levels\Misc\Map - Tension Bridge.asm"

byte_39006:	dc.b	2,   4,	  4,   4,   4,	 4,  $C,   0

byte_3900E:	dc.b	2,   4,	  6,   6,   6,	 6,   8,   8,	8,   8,	 $A,  $A,   0,	 0


byte_3901C:	dc.b	2,   4,	  6,   6,   6,	 6,   8,   8,	8,   8,	 $A,   0

byte_39028:	dc.b	2,   4,	  6,   6,   6,	 6,   8,   8,	8,   8,	  8,   8,   8,	 8,   8,   8,	8,   8,	 $E,   0

word_3903C:	dc.w $840
		dc.w $120
		dc.l byte_39006
		dc.w $1540
		dc.w $620
		dc.l byte_3900E
		dc.w $1740
		dc.w $3A0
		dc.l byte_3900E
		dc.w $1CC0
		dc.w $620
		dc.l byte_39006
		dc.w $1FC0
		dc.w $2A0
		dc.l byte_3901C
		dc.w $24C0
		dc.w $220
		dc.l byte_39028
		dc.w $26C0
		dc.w $120
		dc.l byte_39006
		dc.w $3040
		dc.w $620
		dc.l byte_3900E
; ---------------------------------------------------------------------------

Obj_69_1:
		move.b	$2C(a0),d0
		andi.w	#$7F,d0
		lsl.w	#3,d0
		lea	word_3903C(pc,d0.w),a1
		move.w	(a1)+,$30(a0)
		move.w	(a1)+,$32(a0)
		move.l	(a1)+,$40(a0)
		move.l	#loc_3909C,(a0)

loc_3909C:
		lea	($FFFFB000).w,a1
		lea	$34(a0),a4
		bsr.s	sub_390C2
		lea	($FFFFB04A).w,a1
		lea	$3A(a0),a4
		bsr.s	sub_390C2
		move.b	$34(a0),d0
		add.b	$3A(a0),d0
		beq.s	loc_390BC
		rts
; ---------------------------------------------------------------------------

loc_390BC:
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_390C2:

		moveq	#0,d0
		move.b	(a4),d0
		move.w	off_390F2(pc,d0.w),d0
		jsr	off_390F2(pc,d0.w)
		tst.b	(a4)
		beq.s	locret_390F0
		bsr.w	sub_39208
		moveq	#0,d0
		move.w	2(a4),d0
		divu.w	#$60,d0
		movea.l	$40(a0),a2
		move.b	(a2,d0.w),(a4)
		bne.s	locret_390F0
		move.b	#0,$2E(a1)

locret_390F0:

		rts
; End of function sub_390C2

; ---------------------------------------------------------------------------
off_390F2:	dc.w loc_39102-off_390F2

		dc.w loc_3925C-off_390F2
		dc.w loc_392B6-off_390F2
		dc.w loc_392EE-off_390F2
		dc.w loc_3931E-off_390F2
		dc.w loc_3935E-off_390F2
		dc.w loc_3938E-off_390F2
		dc.w loc_393BE-off_390F2
; ---------------------------------------------------------------------------

loc_39102:
		tst.w	($FFFFFE08).w
		bne.w	locret_39196
		tst.b	$2C(a0)
		bmi.w	loc_39198
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#8,d0
		cmpi.w	#$10,d0
		bcc.s	locret_39196
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		cmpi.w	#$30,d1
		bcc.s	locret_39196
		tst.b	$2E(a1)
		bne.s	locret_39196
		btst	#0,$2A(a0)
		beq.s	loc_39152
		tst.w	$1C(a1)
		bpl.s	locret_39196
		tst.w	$18(a1)
		bpl.s	locret_39196
		neg.w	$1C(a1)
		bra.s	loc_39158
; ---------------------------------------------------------------------------

loc_39152:
		tst.w	$1C(a1)
		bmi.s	locret_39196

loc_39158:
		addq.b	#2,(a4)
		move.b	#1,$2E(a1)
		move.b	#2,$20(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		bclr	#5,$2A(a1)
		move.b	#$28,$26(a1)
		move.w	$14(a1),d1
		sub.w	$32(a0),d1
		move.w	d1,2(a4)

locret_39196:

		rts
; ---------------------------------------------------------------------------

loc_39198:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.s	locret_39196
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		addi.w	#$10,d1
		cmpi.w	#$10,d1
		bcc.s	locret_39196
		tst.b	$2E(a1)
		bne.s	locret_39196
		tst.w	$1C(a1)
		bpl.s	locret_39196
		addq.b	#2,(a4)
		move.b	#1,$2E(a1)
		move.b	#2,$20(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		bclr	#5,$2A(a1)
		move.b	#$28,$26(a1)
		move.w	$14(a1),d1
		sub.w	$32(a0),d1
		move.w	d1,2(a4)
		rts

; =============== S U B R O U T I N E =======================================


sub_39208:

		move.b	$26(a1),d0
		jsr	(GetSineCosine).l
		muls.w	$1C(a1),d1
		asr.l	#8,d1
		move.w	d1,$18(a1)
		muls.w	$1C(a1),d0
		asr.l	#8,d0
		move.w	d0,$1A(a1)
		move.b	$26(a1),d0
		jsr	(GetSineCosine).l
		muls.w	#$50,d0
		asr.l	#8,d0
		tst.w	$1C(a1)
		bmi.s	loc_39250
		tst.w	d0
		bpl.s	loc_39242
		asr.l	#2,d0

loc_39242:
		cmpi.w	#$1800,$1C(a1)
		bge.s	locret_3925A
		add.w	d0,$1C(a1)
		rts
; ---------------------------------------------------------------------------

loc_39250:
		tst.w	d0
		bmi.s	loc_39256
		asr.l	#2,d0

loc_39256:
		add.w	d0,$1C(a1)

locret_3925A:
		rts
; End of function sub_39208

; ---------------------------------------------------------------------------

loc_3925C:
		move.w	2(a4),d0
		subi.w	#$16,d0
		bcc.s	loc_39282
		tst.w	$1C(a1)
		bpl.s	loc_39280
		move.b	#0,(a4)
		move.b	#0,$2E(a1)
		move.b	#$70,$26(a1)
		bra.w	sub_39208
; ---------------------------------------------------------------------------

loc_39280:
		moveq	#0,d0

loc_39282:
		mulu.w	#$DD,d0
		lsr.w	#8,d0
		jsr	(GetSineCosine).l
		muls.w	#-$2800,d0
		swap	d0
		add.w	$30(a0),d0
		move.w	d0,$10(a1)
		move.w	2(a4),d0
		add.w	$32(a0),d0
		move.w	d0,$14(a1)
		move.w	$1A(a1),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,2(a4)
		rts
; ---------------------------------------------------------------------------

loc_392B6:
		move.w	2(a4),d0
		mulu.w	#$AA,d0
		asr.w	#8,d0
		jsr	(GetSineCosine).l
		muls.w	#-$2800,d0
		swap	d0
		add.w	$30(a0),d0
		move.w	d0,$10(a1)
		move.w	2(a4),d0
		add.w	$32(a0),d0
		move.w	d0,$14(a1)
		move.w	$1A(a1),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,2(a4)
		rts
; ---------------------------------------------------------------------------

loc_392EE:
		move.w	2(a4),d0
		subi.w	#$C0,d0
		muls.w	#$AA,d0
		asr.l	#8,d0
		add.w	$30(a0),d0
		move.w	d0,$10(a1)
		move.w	2(a4),d0
		add.w	$32(a0),d0
		move.w	d0,$14(a1)
		move.w	$1A(a1),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,2(a4)
		rts
; ---------------------------------------------------------------------------

loc_3931E:
		move.w	2(a4),d0
		subi.w	#$180,d0
		mulu.w	#$AA,d0
		asr.w	#8,d0
		jsr	(GetSineCosine).l
		muls.w	#-$2800,d0
		swap	d0
		addi.w	#$100,d0
		add.w	$30(a0),d0
		move.w	d0,$10(a1)
		move.w	2(a4),d0
		add.w	$32(a0),d0
		move.w	d0,$14(a1)
		move.w	$1A(a1),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,2(a4)
		rts
; ---------------------------------------------------------------------------

loc_3935E:
		move.w	2(a4),d0
		subi.w	#$240,d0
		muls.w	#$AA,d0
		asr.l	#8,d0
		add.w	$30(a0),d0
		move.w	d0,$10(a1)
		move.w	2(a4),d0
		add.w	$32(a0),d0
		move.w	d0,$14(a1)
		move.w	$1A(a1),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,2(a4)
		rts
; ---------------------------------------------------------------------------

loc_3938E:
		move.w	2(a4),d0
		subi.w	#$240,d0
		muls.w	#$AA,d0
		asr.l	#8,d0
		add.w	$30(a0),d0
		move.w	d0,$10(a1)
		move.w	2(a4),d0
		add.w	$32(a0),d0
		move.w	d0,$14(a1)
		move.w	$1A(a1),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,2(a4)
		rts
; ---------------------------------------------------------------------------

loc_393BE:
		move.w	2(a4),d0
		subi.w	#$540,d0
		muls.w	#$AA,d0
		asr.l	#8,d0
		add.w	$30(a0),d0
		move.w	d0,$10(a1)
		move.w	2(a4),d0
		add.w	$32(a0),d0
		move.w	d0,$14(a1)
		move.w	$1A(a1),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,2(a4)
		rts
; ---------------------------------------------------------------------------

loc_393EE:
		move.w	#$680,$A(a0)
		move.l	#Map_SonicSnowboard,$C(a0)
		move.w	#$100,8(a0)
		move.b	#$20,7(a0)
		move.b	#$20,6(a0)
		move.b	#4,4(a0)
		move.b	#6,$22(a0)
		move.w	#1,$20(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_39434
		move.l	#loc_398E0,(a1)
		move.w	a0,$30(a1)

loc_39434:
		move.l	#loc_3943A,(a0)

loc_3943A:
		lea	($FFFFB000).w,a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		btst	#1,$2A(a1)
		bne.s	loc_3945E
		move.b	#1,$20(a0)
		move.l	#loc_394A0,(a0)

loc_3945E:
		lea	(Ani_SonicSnowboard).l,a1
		jsr	(Animate_Sprite).l
		jsr	(sub_3968E).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Ani_SonicSnowboard:	include "General\Sprites\Sonic\Anim - Sonic Snowboard.asm"

; ---------------------------------------------------------------------------

loc_394A0:

		lea	($FFFFB000).w,a2
		move.w	$10(a2),$10(a0)
		move.w	$14(a2),$14(a0)
		moveq	#0,d0
		move.b	$26(a2),d0
		addq.b	#5,d0
		lsr.w	#4,d0
		move.b	byte_394F2(pc,d0.w),$20(a0)
		btst	#1,$2A(a2)
		beq.s	loc_39502
		move.b	#0,$20(a0)
		tst.w	$18(a2)
		beq.s	loc_394E2
		cmpi.w	#$1000,$18(a2)
		blt.s	loc_394E2
		move.w	#$1000,$18(a2)

loc_394E2:

		cmpi.w	#-$200,$1A(a2)
		bge.s	loc_39554
		move.w	#-$200,$1A(a2)
		bra.s	loc_39554
; ---------------------------------------------------------------------------
byte_394F2:	dc.b	4,   5,	  2,   1,   1,	 1,   1,   1,	0,   1,	  2,   0,   1,	 2,   0,   4
; ---------------------------------------------------------------------------

loc_39502:
		move.b	($FFFFFE05).w,d0
		andi.b	#$F,d0
		bne.s	loc_39514
		moveq	#-$38,d0
		jsr	(Play_Sound_2).l

loc_39514:
		cmpi.w	#$1310,$10(a2)
		bcs.s	loc_39554
		moveq	#1,d0
		cmpi.w	#$1330,$10(a2)
		bcs.s	loc_39538
		cmpi.w	#$2210,$10(a2)
		bcs.s	loc_39554
		cmpi.w	#$2230,$10(a2)
		bcc.s	loc_39554
		moveq	#2,d0

loc_39538:
		cmp.b	$36(a0),d0
		beq.s	loc_39554
		move.b	d0,$36(a0)
		move.b	#3,$2E(a2)
		move.l	#loc_395FE,(a0)
		move.w	#0,$34(a0)

loc_39554:

		lea	(Ani_SonicSnowboard).l,a1
		jsr	(Animate_Sprite).l
		cmpi.b	#8,$22(a0)
		bne.s	loc_39578
		cmpi.w	#$1000,$1C(a2)
		blt.s	loc_39578
		subi.w	#8,$1C(a2)
		bra.s	loc_39586
; ---------------------------------------------------------------------------

loc_39578:

		cmpi.w	#$1000,$1C(a2)
		bge.s	loc_39586
		move.w	#$1000,$1C(a2)

loc_39586:

		cmpi.w	#$3880,$10(a2)
		bcs.s	loc_395CC
		tst.w	$18(a2)
		bne.s	loc_395CC
		move.l	#loc_39676,(a0)
		bset	#1,$2A(a2)
		move.w	#-$200,$18(a2)
		move.w	#-$400,$1A(a2)
		move.b	#$19,$20(a2)
		move.b	#0,$2E(a2)
		move.w	#$14,($FFFFEECC).w
		moveq	#$5F,d0
		jsr	(Play_Sound_2).l
		move.w	#2,($FFFFF708).w

loc_395CC:

		btst	#1,$2A(a2)
		bne.s	loc_395F2
		move.b	$22(a0),d0
		cmp.b	$32(a0),d0
		beq.s	loc_395F2
		cmpi.b	#7,d0
		beq.s	loc_395EA
		cmpi.b	#8,d0
		bne.s	loc_395F2

loc_395EA:
		moveq	#$7E,d0
		jsr	(Play_Sound_2).l

loc_395F2:

		jsr	(sub_3968E).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_395FE:
		lea	($FFFFB000).w,a2
		move.w	$34(a0),d0
		addq.w	#6,$34(a0)
		lea	(ICZSnowboard_Slope1).l,a1
		cmpi.b	#1,$36(a0)
		beq.s	loc_3961E
		lea	(ICZSnowboard_Slope2).l,a1

loc_3961E:
		lea	(a1,d0.w),a1
		move.w	(a1)+,d0
		move.w	d0,$10(a0)
		move.w	d0,$10(a2)
		move.w	(a1)+,d0
		move.w	d0,$14(a0)
		move.w	d0,$14(a2)
		move.w	(a1)+,d0
		move.b	d0,$22(a0)
		tst.w	(a1)
		bpl.s	loc_39658
		move.b	#$E,$46(a2)
		move.b	#$F,$47(a2)
		move.b	#2,$2E(a2)
		move.l	#loc_394A0,(a0)

loc_39658:
		move.b	$22(a0),d0
		cmp.b	$32(a0),d0
		beq.s	loc_3966A
		moveq	#$7E,d0
		jsr	(Play_Sound_2).l

loc_3966A:
		jsr	(sub_3968E).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_39676:
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_3967C:
		move.w	#$6400,d4
		move.l	#ArtUnc_Snowboard,d6
		lea	(DPLC_Snowboard).l,a2
		bra.s	loc_3969E
; End of function sub_3967C


; =============== S U B R O U T I N E =======================================


sub_3968E:

		move.w	#-$3000,d4
		move.l	#ArtUnc_SonicSnowboard,d6
		lea	(DPLC_SonicSnowboard).l,a2

loc_3969E:
		moveq	#0,d0
		move.b	$22(a0),d0
		cmp.b	$32(a0),d0
		beq.s	locret_396E2
		move.b	d0,$32(a0)
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d5
		subq.w	#1,d5
		bmi.s	locret_396E2

loc_396BA:
		moveq	#0,d1
		move.w	(a2)+,d1
		move.w	d1,d3
		lsr.w	#8,d3
		andi.w	#$F0,d3
		addi.w	#$10,d3
		andi.w	#$FFF,d1
		lsl.l	#5,d1
		add.l	d6,d1
		move.w	d4,d2
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		dbf	d5,loc_396BA

locret_396E2:

		rts
; End of function sub_3968E

; ---------------------------------------------------------------------------

Obj_LevelIntroICZ1:
		lea	($FFFFB000).w,a1
		move.w	#$800,$18(a1)
		move.w	#$280,$1A(a1)
		move.w	#$800,$1C(a1)
		bset	#1,$2A(a1)
		move.b	#0,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		move.b	#1,($FFFFF7CA).w
		move.w	#0,($FFFFF602).w
		move.w	#0,($FFFFF604).w
		move.b	#0,$22(a1)
		move.b	#3,$2E(a1)
		move.b	#$1E,$24(a0)
		move.l	#Map_Snowboard,$C(a0)
		move.w	#$320,$A(a0)
		move.w	#$80,8(a0)
		move.b	#$20,7(a0)
		move.b	#$20,6(a0)
		move.b	#4,4(a0)
		move.b	#8,$22(a0)
		move.w	#$C0,$10(a0)
		move.w	#$170,$14(a0)
		move.l	#loc_39780,(a0)

loc_39780:
		subq.b	#1,$24(a0)
		bne.s	loc_39796
		lea	($FFFFB000).w,a2
		move.b	#0,$2E(a2)
		move.l	#loc_39796,(a0)

loc_39796:

		move.b	#1,($FFFFF7CA).w
		move.w	#0,($FFFFF602).w
		lea	($FFFFB000).w,a2
		cmpi.w	#$C0,$10(a2)
		bcs.s	loc_397C6
		move.w	#-$600,$1A(a0)
		move.w	#$400,$18(a2)
		move.w	#-$800,$1A(a2)
		move.l	#loc_397D2,(a0)

loc_397C6:

		jsr	(sub_3967C).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_397D2:
		lea	($FFFFB000).w,a2
		move.w	$10(a2),$10(a0)
		subq.b	#1,$24(a0)
		bpl.s	loc_397FA
		move.b	#1,$24(a0)
		addq.b	#1,$22(a0)
		cmpi.b	#9,$22(a0)
		bcs.s	loc_397FA
		move.b	#1,$22(a0)

loc_397FA:

		cmpi.w	#$184,$10(a2)
		bcs.s	loc_3983E
		move.b	#0,$22(a2)
		move.b	#2,$2E(a2)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_39836
		move.l	#loc_393EE,(a1)
		move.w	$10(a2),$10(a1)
		move.w	$14(a2),$14(a1)
		move.w	$18(a2),$18(a1)
		move.w	$1A(a2),$1A(a1)

loc_39836:
		move.l	#loc_3984E,(a0)
		rts
; ---------------------------------------------------------------------------

loc_3983E:
		jsr	(MoveSprite2).l
		addi.w	#$28,$1A(a0)
		bra.w	loc_397C6
; ---------------------------------------------------------------------------

loc_3984E:
		lea	($FFFFB000).w,a2
		move.w	$10(a2),$10(a0)
		move.w	$14(a2),$14(a0)
		move.w	($FFFFF604).w,d0
		andi.w	#-$F10,d0
		move.w	d0,($FFFFF602).w
		tst.b	$2E(a2)
		bne.s	locret_398A4
		move.b	#0,($FFFFF7CA).w
		move.l	#loc_398A6,(a0)
		addi.w	#$14,$14(a0)
		move.w	#-$200,$18(a0)
		move.w	#-$400,$1A(a0)
		move.b	#-$7C,4(a0)
		move.b	#1,$22(a0)
		move.b	#1,$24(a0)
		bra.w	loc_397C6
; ---------------------------------------------------------------------------

locret_398A4:
		rts
; ---------------------------------------------------------------------------

loc_398A6:
		tst.b	4(a0)
		bmi.s	loc_398B2
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_398B2:
		subq.b	#1,$24(a0)
		bpl.s	loc_398D0
		move.b	#1,$24(a0)
		addq.b	#1,$22(a0)
		cmpi.b	#9,$22(a0)
		bcs.s	loc_398D0
		move.b	#1,$22(a0)

loc_398D0:

		jsr	(MoveSprite2).l
		addi.w	#$28,$1A(a0)
		bra.w	loc_397C6
; ---------------------------------------------------------------------------

loc_398E0:
		move.l	#loc_398E6,(a0)

loc_398E6:
		movea.w	$30(a0),a3
		lea	($FFFFB000).w,a2
		tst.b	$2E(a2)
		bne.s	loc_398FA
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_398FA:
		btst	#1,$2A(a2)
		bne.s	locret_39922
		bsr.s	sub_39924
		bsr.s	sub_39924
		cmpi.b	#7,$22(a3)
		beq.s	loc_39916
		cmpi.b	#8,$22(a3)
		bne.s	locret_39922

loc_39916:
		bsr.s	sub_39924
		bsr.s	sub_39924
		bsr.s	sub_39924
		bsr.s	sub_39924
		bsr.s	sub_39924
		bsr.s	sub_39924

locret_39922:

		rts

; =============== S U B R O U T I N E =======================================


sub_39924:

		jsr	(Create_New_Sprite3).l
		bne.w	locret_399A4
		move.l	#loc_399A6,(a1)
		move.w	#$6B8,$A(a1)
		move.l	#Map_SnowboardDust,$C(a1)
		move.w	#$100,8(a1)
		move.b	#4,7(a1)
		move.b	#4,6(a1)
		move.b	#-$7C,4(a1)
		move.w	#1,$20(a1)
		move.w	$10(a2),$10(a1)
		move.w	$14(a2),$14(a1)
		addi.w	#$14,$14(a1)
		jsr	(Random_Number).l
		move.l	d0,d1
		andi.w	#$1FF,d0
		neg.w	d0
		subi.w	#$200,$1A(a1)
		move.w	d0,$1A(a1)
		move.w	#-$100,$18(a1)
		move.l	d1,d0
		andi.w	#$F,d0
		sub.w	d0,$10(a1)
		swap	d0
		andi.w	#$F,d0
		sub.w	d0,$14(a1)

locret_399A4:
		rts
; End of function sub_39924

; ---------------------------------------------------------------------------

loc_399A6:
		tst.b	4(a0)
		bpl.s	loc_399CA
		jsr	(MoveSprite2).l
		lea	(Ani_SnowboardDust).l,a1
		jsr	(Animate_Sprite).l
		tst.b	5(a0)
		bne.s	loc_399CA
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_399CA:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
Ani_SnowboardDust:	include "General\Sprites\Snowboard\Anim - Snowboard Dust.asm"

Map_SnowboardDust:	include "General\Sprites\Snowboard\Map - Snowboard Dust.asm"

ArtNem_SnowboardDust:	binclude "General\Sprites\Snowboard\Snowboard Dust.bin"


; ---------------------------------------------------------------------------

Obj_LevelIntro_PlayerLaunchFromGround:
		move.l	#loc_39A80,(a0)
		move.b	#1,($FFFFF7CA).w
		move.b	#1,($FFFFF7CB).w
		moveq	#0,d0
		move.w	d0,($FFFFF602).w
		move.w	d0,($FFFFF604).w
		move.w	d0,($FFFFF66A).w
		move.w	d0,($FFFFF606).w
		move.b	#$1E,$24(a0)
		lea	($FFFFB000).w,a1
		bsr.s	sub_39A78
		lea	($FFFFB04A).w,a1
		tst.l	(a1)
		beq.s	locret_39A7E

; =============== S U B R O U T I N E =======================================


sub_39A78:
		move.b	#3,$2E(a1)

locret_39A7E:
		rts
; End of function sub_39A78

; ---------------------------------------------------------------------------

loc_39A80:
		move.b	#1,($FFFFF7CA).w
		move.b	#1,($FFFFF7CB).w
		move.w	#0,($FFFFF602).w
		move.w	#0,($FFFFF66A).w
		subq.b	#1,$24(a0)
		beq.s	loc_39AA0
		rts
; ---------------------------------------------------------------------------

loc_39AA0:
		move.l	#loc_39AD2,(a0)
		lea	($FFFFB000).w,a1
		bsr.s	sub_39AB4
		lea	($FFFFB04A).w,a1
		tst.l	(a1)
		beq.s	locret_39AD0

; =============== S U B R O U T I N E =======================================


sub_39AB4:
		move.w	#-$B00,$1A(a1)
		bset	#1,$2A(a1)
		clr.b	$40(a1)
		move.b	#$10,$20(a1)
		move.b	#1,$2E(a1)

locret_39AD0:
		rts
; End of function sub_39AB4

; ---------------------------------------------------------------------------

loc_39AD2:
		move.b	#1,($FFFFF7CA).w
		move.b	#1,($FFFFF7CB).w
		move.w	#0,($FFFFF602).w
		move.w	#0,($FFFFF66A).w
		lea	($FFFFB000).w,a2
		cmpi.w	#$5C0,$14(a2)
		bcc.s	loc_39B3C
		move.b	#0,$2E(a2)
		move.w	#$400,($FFFFCC74).w
		move.w	#$5C0,($FFFFCC68).w
		lea	($FFFFB04A).w,a2
		tst.l	(a2)
		beq.s	loc_39B22
		move.b	#0,$2E(a2)
		move.w	#$400,($FFFFCCBE).w
		move.w	#$5C0,($FFFFCCB2).w

loc_39B22:
		moveq	#-$7E,d0
		jsr	(Play_Sound_2).l
		move.b	#0,($FFFFF7CA).w
		move.b	#0,($FFFFF7CB).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_39B3C:
		bsr.s	sub_39B46
		lea	($FFFFB04A).w,a2
		tst.l	(a2)
		beq.s	locret_39B64

; =============== S U B R O U T I N E =======================================


sub_39B46:
		move.w	$18(a2),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$10(a2)
		move.w	$1A(a2),d0
		addi.w	#$38,$1A(a2)
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$14(a2)

locret_39B64:
		rts
; End of function sub_39B46

; ---------------------------------------------------------------------------

Obj_LevelIntroICZ1Tails:
		lea	($FFFFB000).w,a1
		move.w	#$800,$18(a1)
		move.w	#$480,$1A(a1)
		move.w	#$800,$1C(a1)
		bset	#1,$2A(a1)
		move.b	#0,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		move.b	#3,$2E(a1)
		move.b	#1,($FFFFF7CA).w
		move.w	#0,($FFFFF602).w
		move.w	#0,($FFFFF604).w
		move.b	#$1E,$24(a0)
		move.l	#loc_39BC4,(a0)

loc_39BC4:
		move.b	#1,($FFFFF7CA).w
		move.w	#0,($FFFFF602).w
		move.w	#0,($FFFFF66A).w
		subq.b	#1,$24(a0)
		beq.s	loc_39BDE
		rts
; ---------------------------------------------------------------------------

loc_39BDE:
		lea	($FFFFB000).w,a2
		move.b	#0,$2E(a2)
		move.l	#loc_39BEE,(a0)

loc_39BEE:
		move.b	#1,($FFFFF7CA).w
		move.w	#0,($FFFFF602).w
		lea	($FFFFB000).w,a2
		cmpi.w	#$38F0,$10(a2)
		bcs.s	locret_39C4E
		bset	#1,$2A(a2)
		move.w	#-$200,$18(a2)
		move.w	#-$400,$1A(a2)
		move.b	#$19,$20(a2)
		move.b	#0,$2E(a2)
		move.b	#0,($FFFFF7CA).w
		move.w	#$14,($FFFFEECC).w
		move.w	#-$100,d0
		move.w	d0,($FFFFEE18).w
		move.w	d0,($FFFFEE10).w
		move.w	d0,($FFFFEE20).w
		moveq	#$5F,d0
		jsr	(Play_Sound_2).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

locret_39C4E:
		rts
; ---------------------------------------------------------------------------

Obj_LRZCollapsingBridge:

		move.l	#loc_39CA8,(a0)
		move.b	#4,4(a0)
		move.w	#$80,8(a0)
		move.l	#Map_LRZCollapsingBridge,$C(a0)
		move.w	#-$3F2D,$A(a0)
		move.b	$2C(a0),d0
		move.b	d0,d1
		andi.w	#$F,d0
		lsl.w	#4,d0
		addq.w	#8,d0
		move.b	d0,$30(a0)
		andi.w	#$F0,d1
		lsr.w	#2,d1
		lea	byte_39CA4(pc,d1.w),a1
		move.b	(a1)+,7(a0)
		move.b	(a1)+,6(a0)
		move.b	(a1)+,$22(a0)
		move.b	(a1)+,$2C(a0)
		move.b	#$1C,$1E(a0)
		bra.s	loc_39CA8
; ---------------------------------------------------------------------------
byte_39CA4:	dc.b $40
		dc.b $20
		dc.b 8
		dc.b 0
; ---------------------------------------------------------------------------

loc_39CA8:

		tst.b	$32(a0)
		beq.s	loc_39CBC
		tst.b	$30(a0)
		bne.s	loc_39CB8
		bra.w	loc_39D84
; ---------------------------------------------------------------------------

loc_39CB8:
		subq.b	#1,$30(a0)

loc_39CBC:
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	loc_39CCC
		move.b	#1,$32(a0)

loc_39CCC:
		moveq	#0,d1
		move.b	7(a0),d1
		moveq	#0,d3
		move.b	$1E(a0),d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_39CE8:
		moveq	#0,d1
		move.b	7(a0),d1
		moveq	#0,d3
		move.b	$1E(a0),d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		subq.b	#1,$30(a0)
		bne.s	locret_39D3C
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.s	sub_39D1A
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.s	sub_39D1A
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_39D1A:

		btst	d6,$2A(a0)
		beq.s	locret_39D3C
		bclr	d6,$2A(a0)
		bclr	#3,$2A(a1)
		bclr	#5,$2A(a1)
		bset	#1,$2A(a1)
		move.b	#1,$21(a1)

locret_39D3C:

		rts
; End of function sub_39D1A

; ---------------------------------------------------------------------------

loc_39D3E:
		tst.b	$30(a0)
		beq.s	loc_39D4E
		subq.b	#1,$30(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_39D4E:
		subq.b	#1,$24(a0)
		bpl.s	loc_39D6C
		move.b	#7,$24(a0)
		move.b	$22(a0),d0
		addq.b	#1,d0
		andi.b	#3,d0
		add.b	$34(a0),d0
		move.b	d0,$22(a0)

loc_39D6C:
		jsr	(MoveSprite).l
		tst.b	4(a0)
		bpl.s	loc_39D7E
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_39D7E:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_39D84:
		move.b	#$2A,$30(a0)
		lea	(word_39E20).l,a3
		move.l	#loc_39CE8,(a0)
		move.l	#loc_39D3E,d4
		move.w	(a3)+,d1
		move.b	4(a0),d5
		move.w	$10(a0),d2
		move.w	$14(a0),d3

loc_39DAA:
		jsr	(Create_New_Sprite3).l
		bne.s	loc_39E08
		move.l	d4,(a1)
		move.l	$C(a0),$C(a1)
		move.b	d5,4(a1)
		move.b	(a3)+,d0
		ext.w	d0
		add.w	d2,d0
		move.w	d0,$10(a1)
		move.b	(a3)+,d0
		ext.w	d0
		add.w	d3,d0
		move.w	d0,$14(a1)
		move.b	(a3)+,$22(a1)
		move.w	$A(a0),$A(a1)
		ori.w	#-$8000,$A(a1)
		move.w	#$80,8(a1)
		move.b	#$20,7(a1)
		move.b	#$20,7(a1)
		move.b	(a3)+,$30(a1)
		move.b	$22(a1),d0
		andi.b	#-4,d0
		move.b	d0,$34(a1)
		dbf	d1,loc_39DAA

loc_39E08:
		move.w	$48(a0),d0
		beq.s	loc_39E18
		movea.w	d0,a1
		bclr	#7,(a1)
		clr.w	$48(a0)

loc_39E18:
		moveq	#$59,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------
word_39E20:	dc.w $15
		dc.b  $E0,   4,	  7, $24
		dc.b	0,   8,	  6, $20
		dc.b  $20,   4,	  6, $22
		dc.b  $D0, $F0,	  7, $2C
		dc.b  $F0, $F0,	  6, $28
		dc.b  $10, $F0,	  7, $2A
		dc.b  $30, $F0,	  6, $26
		dc.b  $E0, $E8,	  0, $1E
		dc.b  $20, $E8,	  1, $1C
		dc.b  $C8,   0,	  0, $1A
		dc.b  $38,   0,	  1, $18
		dc.b  $D0, $10,	  0, $12
		dc.b  $30, $10,	  1, $10
		dc.b  $E8, $10,	  0,  $E
		dc.b  $18, $10,	  1,  $C
		dc.b  $F6, $14,	  0,  $A
		dc.b   $A, $14,	  1,   8
		dc.b	0, $18,	  0,   6
		dc.b  $E0, $18,	  0,   2
		dc.b  $20, $18,	  1,   4
		dc.b  $D4,  $C,	  4, $16
		dc.b  $2C,  $C,	  5, $14
Map_LRZCollapsingBridge:include "Levels\LRZ\Misc Object Data\Map - Collapsing Bridge.asm"

; ---------------------------------------------------------------------------

Obj_6F_1:
		move.b	$2C(a0),d0
		bpl.s	loc_39F48
		andi.w	#$7F,d0
		lsl.w	#3,d0
		move.w	d0,$2C(a0)
		move.l	#loc_3A0B0,(a0)
		bra.w	loc_3A0B0
; ---------------------------------------------------------------------------

loc_39F48:
		andi.w	#$7F,d0
		lsl.w	#3,d0
		move.w	d0,$2C(a0)
		move.l	#loc_39F58,(a0)

loc_39F58:
		move.w	$2C(a0),d4
		move.w	d4,d5
		add.w	d5,d5
		lea	($FFFFB000).w,a1
		lea	($FFFFF7B0).w,a2
		moveq	#3,d6
		bsr.s	sub_39F7E
		lea	($FFFFB04A).w,a1
		lea	($FFFFF7B1).w,a2
		addq.b	#1,d6
		bsr.s	sub_39F7E
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_39F7E:

		btst	d6,$2A(a0)
		bne.w	loc_3A01A
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d4,d0
		cmp.w	d5,d0
		bcc.w	locret_3A018
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$50,d0
		cmpi.w	#$18,d0
		bcc.s	loc_39FAE
		move.b	#$28,2(a2)

loc_39FAE:
		tst.b	2(a2)
		beq.s	loc_39FBA
		subq.b	#1,2(a2)
		rts
; ---------------------------------------------------------------------------

loc_39FBA:
		move.w	$14(a0),d0
		addi.w	#$3C,d0
		move.w	$14(a1),d2
		move.b	$1E(a1),d1
		ext.w	d1
		add.w	d2,d1
		addq.w	#4,d1
		sub.w	d1,d0
		bhi.s	locret_3A018
		cmpi.w	#-$10,d0
		bcs.s	locret_3A018
		cmpi.b	#6,5(a1)
		bcc.s	locret_3A018
		tst.w	($FFFFFE08).w
		bne.s	locret_3A018
		add.w	d0,d2
		addq.w	#3,d2
		move.w	d2,$14(a1)
		jsr	(RideObject_SetRide).l
		move.b	#-$80,$2D(a1)
		move.w	#1,$20(a1)
		move.b	#0,(a2)
		move.b	#0,2(a2)
		tst.w	$1C(a1)
		bne.s	locret_3A018
		move.w	#1,$1C(a1)

locret_3A018:

		rts
; ---------------------------------------------------------------------------

loc_3A01A:
		btst	#1,$2A(a1)
		bne.s	loc_3A054
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d4,d0
		cmp.w	d5,d0
		bcs.s	loc_3A06E

loc_3A030:

		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		move.b	#0,$30(a1)
		move.b	#4,$31(a1)
		bset	#1,$2A(a1)
		move.b	#0,$2D(a1)
		rts
; ---------------------------------------------------------------------------

loc_3A054:
		move.b	(a2),d0
		addi.b	#$20,d0
		cmpi.b	#$40,d0
		bcc.s	loc_3A066
		asr	$1A(a1)
		bra.s	loc_3A030
; ---------------------------------------------------------------------------

loc_3A066:
		move.w	#0,$1A(a1)
		bra.s	loc_3A030
; ---------------------------------------------------------------------------

loc_3A06E:
		btst	#3,$2A(a1)
		beq.s	locret_3A018
		move.b	(a2),d0
		jsr	(GetSineCosine).l
		muls.w	#$2800,d1
		swap	d1
		move.w	$14(a0),d2
		add.w	d1,d2
		moveq	#0,d1
		move.b	$1E(a1),d1
		subi.w	#$13,d1
		sub.w	d1,d2
		move.w	d2,$14(a1)
		move.b	(a2),d0
		move.b	d0,$27(a1)
		addq.b	#4,(a2)
		tst.w	$1C(a1)
		bne.s	locret_3A0AE
		move.w	#1,$1C(a1)

locret_3A0AE:
		rts
; End of function sub_39F7E

; ---------------------------------------------------------------------------

loc_3A0B0:

		move.w	$2C(a0),d4
		move.w	d4,d5
		add.w	d5,d5
		lea	($FFFFB000).w,a1
		lea	($FFFFF7B0).w,a2
		moveq	#3,d6
		bsr.s	sub_3A0D6
		lea	($FFFFB04A).w,a1
		lea	($FFFFF7B1).w,a2
		addq.b	#1,d6
		bsr.s	sub_3A0D6
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_3A0D6:

		btst	d6,$2A(a0)
		bne.w	loc_3A18E
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$80,d0
		cmpi.w	#$100,d0
		bcc.w	locret_3A18C
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		add.w	d4,d1
		cmp.w	d5,d1
		bcc.w	locret_3A18C
		cmpi.b	#6,5(a1)
		bcc.w	locret_3A18C
		tst.w	($FFFFFE08).w
		bne.w	locret_3A18C
		tst.b	$2E(a1)
		bmi.s	locret_3A18C
		cmpi.w	#$20,d0
		bcs.s	loc_3A126
		cmpi.w	#$E0,d0
		bcs.s	locret_3A18C

loc_3A126:
		bsr.w	sub_33C34
		move.b	#-$40,$26(a1)
		bclr	#0,4(a1)
		bclr	#0,$2A(a1)
		move.b	#0,(a2)
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		bcc.s	loc_3A14E
		move.b	#-$80,(a2)

loc_3A14E:
		move.w	$1A(a1),$1C(a1)
		neg.w	$1C(a1)
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		bcc.s	loc_3A16C
		move.b	#$40,$26(a1)
		neg.w	$1C(a1)

loc_3A16C:
		bset	#6,$2E(a1)
		bset	#1,$2E(a1)
		move.w	#1,$20(a1)
		move.b	#0,$27(a1)
		move.b	#0,2(a2)
		bra.s	loc_3A18E
; ---------------------------------------------------------------------------

locret_3A18C:

		rts
; ---------------------------------------------------------------------------

loc_3A18E:

		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		add.w	d4,d1
		cmp.w	d5,d1
		bcs.s	loc_3A1C6
		move.b	#0,$2E(a1)
		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		move.b	#1,$27(a1)
		move.b	#0,$30(a1)
		move.b	#4,$31(a1)
		bset	#1,$2A(a1)
		rts
; ---------------------------------------------------------------------------

loc_3A1C6:
		btst	#3,$2A(a1)
		beq.s	locret_3A18C
		bclr	#1,4(a1)
		tst.w	$1A(a1)
		bmi.s	loc_3A1E0
		bset	#1,4(a1)

loc_3A1E0:
		move.b	(a2),d0
		jsr	(GetSineCosine).l
		muls.w	#$6800,d1
		swap	d1
		move.w	$10(a0),d2
		add.w	d1,d2
		moveq	#0,d1
		move.b	$1E(a1),d1
		subi.w	#$13,d1
		sub.w	d1,d2
		move.w	d2,$10(a1)
		moveq	#0,d2
		move.b	(a2),d2
		addq.b	#4,(a2)
		divu.w	#$B,d2
		move.b	RawAni_3A220(pc,d2.w),$22(a1)
		moveq	#0,d0
		move.b	$22(a1),d0
		jmp	(Tails_Carry_LoadPLC).l
; End of function sub_3A0D6

; ---------------------------------------------------------------------------
RawAni_3A220:	dc.b  $6D, $6D, $6E, $6E, $6F, $6F, $70, $70, $71, $71, $72, $72, $73, $73, $74, $74, $75, $75, $76, $76
		dc.b  $77, $77, $6C, $6C, $6D, $6D
; ---------------------------------------------------------------------------

Obj_70_1_FBZ_Twisting_Cylinders:
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#8,d0
		move.w	d0,$40(a0)
		lsl.w	#2,d0
		move.w	d0,$42(a0)
		move.l	#loc_3A252,(a0)

loc_3A252:
		lea	($FFFFB000).w,a1
		lea	$30(a0),a2
		moveq	#3,d6
		bsr.s	sub_3A270
		lea	($FFFFB04A).w,a1
		lea	$38(a0),a2
		addq.b	#1,d6
		bsr.s	sub_3A270
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_3A270:

		btst	d6,$2A(a0)
		bne.w	loc_3A314
		btst	#1,$2A(a1)
		bne.w	locret_3A312
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		tst.w	$18(a1)
		bmi.s	loc_3A2A2
		cmpi.w	#-$B0,d0
		bgt.w	locret_3A312
		cmpi.w	#-$C0,d0
		blt.s	locret_3A312
		moveq	#0,d2
		bra.s	loc_3A2B0
; ---------------------------------------------------------------------------

loc_3A2A2:
		cmpi.w	#$B0,d0
		blt.s	locret_3A312
		cmpi.w	#$C0,d0
		bgt.s	locret_3A312
		moveq	#1,d2

loc_3A2B0:
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		addi.w	#$10,d1
		cmpi.w	#$20,d1
		bcc.s	locret_3A312
		move.w	$1C(a1),d0
		bpl.s	loc_3A2CA
		neg.w	d0

loc_3A2CA:
		cmpi.w	#$400,d0
		bcs.s	locret_3A312
		tst.b	$2E(a1)
		bne.s	locret_3A312
		moveq	#0,d3
		tst.b	$2C(a0)
		beq.s	loc_3A2F0
		btst	#0,$2A(a0)
		bne.s	loc_3A2EC
		tst.w	d2
		bne.s	locret_3A312
		bra.s	loc_3A2F0
; ---------------------------------------------------------------------------

loc_3A2EC:
		tst.w	d2
		beq.s	locret_3A312

loc_3A2F0:

		move.l	#0,(a2)
		move.b	d2,4(a2)
		move.w	d3,6(a2)
		bset	#1,$2A(a1)
		jsr	(RideObject_SetRide).l
		move.b	#$42,$2E(a1)
		bra.s	loc_3A314
; ---------------------------------------------------------------------------

locret_3A312:

		rts
; ---------------------------------------------------------------------------

loc_3A314:

		move.w	$1C(a1),d0
		bpl.s	loc_3A31C
		neg.w	d0

loc_3A31C:
		cmpi.w	#$400,d0
		bcs.s	loc_3A36E
		btst	#1,$2A(a1)
		bne.s	loc_3A36E
		tst.l	(a2)
		bne.w	loc_3A480
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$C0,d0
		bmi.s	loc_3A344
		cmpi.w	#$180,d0
		bcs.s	loc_3A3B4

loc_3A344:
		bclr	#2,$2A(a1)
		move.b	$44(a1),$1E(a1)
		move.b	$45(a1),$1F(a1)
		move.w	#1,$20(a1)
		move.b	#0,$2E(a1)
		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		rts
; ---------------------------------------------------------------------------

loc_3A36E:

		asr	$18(a1)
		bset	#1,$2A(a1)
		bclr	#2,$2A(a1)
		move.b	$44(a1),$1E(a1)
		move.b	$45(a1),$1F(a1)
		move.w	#1,$20(a1)
		move.b	#0,$2E(a1)
		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		move.b	#-$40,$27(a1)
		move.b	#0,$30(a1)
		move.b	#4,$31(a1)
		rts
; ---------------------------------------------------------------------------

loc_3A3B4:
		btst	#3,$2A(a1)
		beq.w	locret_3A312
		tst.b	$2C(a0)
		beq.s	loc_3A426
		tst.b	4(a2)
		bne.s	loc_3A3F2
		cmpi.w	#$C0,d0
		bcs.s	loc_3A426
		tst.w	$1C(a1)
		bmi.s	loc_3A426
		subi.w	#$C0,d0
		move.w	d0,(a2)
		move.w	#0,2(a2)
		bset	#0,4(a1)
		bset	#1,4(a1)
		bra.w	loc_3A480
; ---------------------------------------------------------------------------

loc_3A3F2:
		cmpi.w	#$C0,d0
		bcc.s	loc_3A426
		tst.w	$1C(a1)
		bpl.s	loc_3A426
		subi.w	#$C0,d0
		add.w	$42(a0),d0
		move.w	d0,(a2)
		move.w	#0,2(a2)
		move.w	$40(a0),d0
		neg.w	d0
		move.w	d0,6(a2)
		bclr	#0,4(a1)
		bclr	#1,4(a1)
		bra.s	loc_3A480
; ---------------------------------------------------------------------------

loc_3A426:

		lsr.w	#5,d0
		andi.w	#$F,d0
		move.b	byte_3A468(pc,d0.w),d1
		move.b	RawAni_3A474(pc,d0.w),$22(a1)
		ext.w	d1
		move.w	$14(a0),d2
		add.w	6(a2),d2
		add.w	d1,d2
		moveq	#0,d1
		move.b	$1E(a1),d1
		subi.w	#$13,d1
		sub.w	d1,d2
		move.w	d2,$14(a1)
		moveq	#0,d0
		move.b	d0,$20(a1)
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2
		rts
; ---------------------------------------------------------------------------
byte_3A468:	dc.b	4,   0,	  0,   0,   0,	 0,   0,   0,	0,   0,	  0,   4
RawAni_3A474:
		dc.b  $49, $54,	$53, $52, $53, $52, $53, $52, $53, $52,	$54, $49
; ---------------------------------------------------------------------------

loc_3A480:

		move.w	$1C(a1),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,(a2)
		bpl.s	loc_3A4B2
		move.l	#0,(a2)
		move.b	#0,4(a2)
		move.w	$40(a0),d0
		neg.w	d0
		move.w	d0,6(a2)
		bset	#0,4(a1)
		bclr	#1,4(a1)
		bra.w	loc_3A314
; ---------------------------------------------------------------------------

loc_3A4B2:
		move.w	(a2),d0
		cmp.w	$42(a0),d0
		bcs.s	loc_3A4DC
		move.l	#0,(a2)
		move.b	#1,4(a2)
		move.w	$40(a0),6(a2)
		bclr	#0,4(a1)
		bclr	#1,4(a1)
		bra.w	loc_3A314
; ---------------------------------------------------------------------------

loc_3A4DC:
		move.w	$10(a1),d2
		move.w	(a2),d0
		lsr.w	#1,d0
		jsr	(GetSineCosine).l
		muls.w	#$6800,d0
		swap	d0
		add.w	$10(a0),d0
		move.w	d0,$10(a1)
		sub.w	d2,d0
		asl.w	#8,d0
		move.w	d0,$18(a1)
		move.w	$14(a1),d2
		move.w	(a2),d0
		lsr.w	#2,d0
		add.w	6(a2),d0
		add.w	$14(a0),d0
		move.w	d0,$14(a1)
		sub.w	d2,d0
		asl.w	#8,d0
		move.w	d0,$1A(a1)
		moveq	#0,d0
		move.w	(a2),d0
		lsr.w	#1,d0
		andi.w	#$FF,d0
		tst.w	$1C(a1)
		bpl.s	loc_3A52E
		neg.b	d0

loc_3A52E:
		divu.w	#$B,d0
		move.b	RawAni_3A548(pc,d0.w),$22(a1)
		moveq	#0,d0
		move.b	d0,$20(a1)
		move.b	$22(a1),d0
		jmp	(Tails_Carry_LoadPLC).l
; End of function sub_3A270

; ---------------------------------------------------------------------------
RawAni_3A548:	dc.b  $70, $70, $71, $71, $72, $72, $73, $73, $74, $74, $75, $75, $76, $76, $77, $77, $6C, $6C, $6D, $6D
		dc.b  $6E, $6E, $6F, $6F, $70, $70, $71, $71, $72, $72, $73, $73, $74, $74, $75, $75
off_3A56C:	dc.l loc_3A620
		dc.l loc_3A63A
		dc.l loc_3A646
		dc.l loc_3A664
		dc.l loc_3A692
; ---------------------------------------------------------------------------

Obj_FBZFloatingPlatform:

		move.l	#Map_FBZFloatingPlatform,$C(a0)
		move.w	#$2383,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$20,7(a0)
		move.b	#$18,6(a0)
		move.w	#$280,8(a0)
		move.b	#-$74,$28(a0)
		move.w	$10(a0),$44(a0)
		move.w	$14(a0),$46(a0)
		move.b	$2C(a0),d0
		move.b	d0,d1
		andi.w	#$70,d0
		lsr.w	#2,d0
		move.l	off_3A56C(pc,d0.w),$40(a0)
		andi.w	#$F,d1
		lsl.w	#4,d1
		move.b	d1,$26(a0)
		move.l	#loc_3A5DA,(a0)

loc_3A5DA:
		move.w	$10(a0),-(sp)
		movea.l	$40(a0),a1
		jsr	(a1)
		move.w	#$2B,d1
		move.w	#$C,d2
		move.w	#-$D,d3
		move.w	(sp)+,d4
		jsr	SolidObjectFull_Offset
		subq.b	#1,$24(a0)
		bpl.s	loc_3A616
		move.b	#1,$24(a0)
		addq.b	#1,$22(a0)
		cmpi.b	#3,$22(a0)
		bcs.s	loc_3A616
		move.b	#0,$22(a0)

loc_3A616:

		move.w	$44(a0),d0
		jmp	(loc_1B666).l
; ---------------------------------------------------------------------------

loc_3A620:


		move.b	$27(a0),d0
		addq.b	#1,$27(a0)
		jsr	(GetSineCosine).l
		asr.w	#5,d0
		add.w	$46(a0),d0
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_3A63A:
		moveq	#0,d0
		move.b	($FFFFFE78).w,d0
		subi.w	#$20,d0
		bra.s	loc_3A650
; ---------------------------------------------------------------------------

loc_3A646:
		moveq	#0,d0
		move.b	($FFFFFE8C).w,d0
		subi.w	#$40,d0

loc_3A650:
		btst	#0,$2A(a0)
		beq.s	loc_3A65A
		neg.w	d0

loc_3A65A:
		add.w	$46(a0),d0
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_3A664:
		move.b	($FFFFFE05).w,d0
		btst	#0,$2A(a0)
		beq.s	loc_3A672
		neg.b	d0

loc_3A672:
		add.b	$26(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#2,d0
		asr.w	#2,d1
		add.w	$44(a0),d0
		move.w	d0,$10(a0)
		add.w	$46(a0),d1
		move.w	d1,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_3A692:
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	loc_3A620
		move.l	#loc_3A6A4,$40(a0)

loc_3A6A4:
		move.b	$27(a0),d0
		andi.b	#$7F,d0
		bne.w	loc_3A620
		move.l	#loc_3A6D0,$40(a0)
		move.b	#0,$27(a0)
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lsl.w	#1,d0
		addi.w	#$28,d0
		move.w	d0,$36(a0)

loc_3A6D0:
		move.w	$36(a0),d2
		subq.w	#1,d2
		tst.b	$30(a0)
		bne.s	loc_3A6F8
		move.w	$34(a0),d1
		addq.w	#4,d1
		move.w	d1,$34(a0)
		add.w	d1,$32(a0)
		cmp.b	$32(a0),d2
		bhi.s	loc_3A712
		move.b	#1,$30(a0)
		bra.s	loc_3A712
; ---------------------------------------------------------------------------

loc_3A6F8:
		move.w	$34(a0),d1
		subq.w	#4,d1
		move.w	d1,$34(a0)
		add.w	d1,$32(a0)
		cmp.b	$32(a0),d2
		bls.s	loc_3A712
		move.b	#0,$30(a0)

loc_3A712:

		moveq	#0,d0
		move.w	$32(a0),d0
		lsr.w	#6,d0
		btst	#0,$2A(a0)
		beq.s	loc_3A724
		neg.w	d0

loc_3A724:
		add.w	$46(a0),d0
		move.w	d0,$14(a0)
		tst.w	$34(a0)
		bne.s	locret_3A740
		move.w	$14(a0),$46(a0)
		move.l	#loc_3A620,$40(a0)

locret_3A740:
		rts
; ---------------------------------------------------------------------------
Map_FBZFloatingPlatform:include "Levels\FBZ\Misc Object Data\Map - Floating Platform.asm"

; ---------------------------------------------------------------------------

Obj_FBZ_ChainLink:

		move.b	$2C(a0),d0
		bpl.s	loc_3A7E6
		andi.w	#$3F,d0
		lsl.w	#4,d0
		move.w	d0,$3E(a0)
		move.l	#loc_3AA5A,(a0)
		bra.w	loc_3AA5A
; ---------------------------------------------------------------------------

loc_3A7E6:
		move.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.w	#$80,8(a0)
		move.b	#-$80,6(a0)
		move.w	$14(a0),$46(a0)
		move.l	#Map_FBZChainLink,$C(a0)
		move.w	#$4379,$A(a0)
		move.b	$2C(a0),d0
		andi.w	#$7F,d0
		lsl.w	#3,d0
		move.w	d0,$2E(a0)
		move.w	#2,$3C(a0)
		move.b	$2C(a0),d0
		bpl.s	loc_3A846
		move.w	$2E(a0),d0
		move.w	d0,$3A(a0)
		move.b	#1,$38(a0)
		add.w	d0,$14(a0)
		lsr.w	#4,d0
		addq.w	#1,d0
		move.b	d0,$22(a0)

loc_3A846:
		move.l	#loc_3A84C,(a0)

loc_3A84C:

		tst.b	$38(a0)
		beq.s	loc_3A85A
		tst.w	$30(a0)
		bne.s	loc_3A870
		bra.s	loc_3A860
; ---------------------------------------------------------------------------

loc_3A85A:
		tst.w	$30(a0)
		beq.s	loc_3A870

loc_3A860:
		move.w	$3A(a0),d2
		cmp.w	$2E(a0),d2
		beq.s	loc_3A894
		add.w	$3C(a0),d2
		bra.s	loc_3A87A
; ---------------------------------------------------------------------------

loc_3A870:

		move.w	$3A(a0),d2
		beq.s	loc_3A894
		sub.w	$3C(a0),d2

loc_3A87A:
		move.w	d2,$3A(a0)
		move.w	$46(a0),d0
		add.w	d2,d0
		move.w	d0,$14(a0)
		move.w	d2,d0
		beq.s	loc_3A890
		lsr.w	#4,d0
		addq.w	#1,d0

loc_3A890:
		move.b	d0,$22(a0)

loc_3A894:

		lea	$30(a0),a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF602).w,d0
		bsr.w	sub_3A8B8
		lea	($FFFFB04A).w,a1
		addq.w	#1,a2
		move.w	($FFFFF66A).w,d0
		bsr.w	sub_3A8B8
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_3A8B8:

		tst.b	(a2)
		beq.w	loc_3A9A6
		tst.b	4(a1)
		bpl.w	loc_3A954
		tst.w	($FFFFFE08).w
		bne.w	loc_3A954
		cmpi.b	#4,5(a1)
		bcc.s	loc_3A954
		andi.b	#$70,d0
		beq.w	loc_3A96E
		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$12,2(a2)
		andi.w	#$F00,d0
		beq.w	loc_3A8F8
		move.b	#$3C,2(a2)

loc_3A8F8:
		btst	#$A,d0
		beq.s	loc_3A904
		move.w	#-$200,$18(a1)

loc_3A904:
		btst	#$B,d0
		beq.s	loc_3A910
		move.w	#$200,$18(a1)

loc_3A910:
		move.w	#-$380,$1A(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$27(a1)
		bclr	#3,$2A(a1)
		move.w	#0,$42(a1)
		rts
; ---------------------------------------------------------------------------

loc_3A954:

		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$3C,2(a2)
		bclr	#3,$2A(a1)
		move.w	#0,$42(a1)
		rts
; ---------------------------------------------------------------------------

loc_3A96E:
		btst	#$A,d0
		beq.s	loc_3A97A
		bset	#0,$2A(a1)

loc_3A97A:
		btst	#$B,d0
		beq.s	loc_3A986
		bclr	#0,$2A(a1)

loc_3A986:
		move.b	$2A(a1),d0
		andi.b	#1,d0
		andi.b	#-2,4(a1)
		or.b	d0,4(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$9C,$14(a1)
		rts
; ---------------------------------------------------------------------------

loc_3A9A6:
		tst.b	2(a2)
		beq.s	loc_3A9B4
		subq.b	#1,2(a2)
		bne.w	locret_3AA58

loc_3A9B4:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.w	locret_3AA58
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		subi.w	#$90,d1
		cmpi.w	#$18,d1
		bcc.w	locret_3AA58
		tst.b	$2E(a1)
		bmi.s	locret_3AA58
		cmpi.b	#4,5(a1)
		bcc.s	locret_3AA58
		tst.w	($FFFFFE08).w
		bne.s	locret_3AA58
		btst	#3,$2A(a1)
		beq.s	loc_3AA18
		movea.w	$42(a1),a3
		cmpi.l	#loc_3AA5A,(a3)
		bne.s	loc_3AA18
		move.w	a2,d0
		sub.w	a0,d0
		adda.w	d0,a3
		tst.b	4(a3)
		bne.s	locret_3AA58
		clr.b	(a3)
		move.b	#$3C,2(a3)

loc_3AA18:

		move.w	a0,$42(a1)
		bset	#3,$2A(a1)
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$9C,$14(a1)
		move.b	#$14,$20(a1)
		move.b	#1,$2E(a1)
		move.b	#1,(a2)
		moveq	#$4A,d0
		jsr	(Play_Sound_2).l

locret_3AA58:

		rts
; ---------------------------------------------------------------------------

loc_3AA5A:

		lea	$30(a0),a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF602).w,d0
		bsr.w	sub_3AA7E
		lea	($FFFFB04A).w,a1
		addq.w	#1,a2
		move.w	($FFFFF66A).w,d0
		bsr.w	sub_3AA7E
		jmp	(Delete_Sprite_If_Not_In_Range).l
; End of function sub_3A8B8


; =============== S U B R O U T I N E =======================================


sub_3AA7E:

		tst.b	(a2)
		beq.w	loc_3AC86
		tst.b	4(a1)
		bpl.w	loc_3AB24
		tst.w	($FFFFFE08).w
		bne.w	loc_3AB24
		cmpi.b	#4,5(a1)
		bcc.w	loc_3AB24
		andi.b	#$70,d0
		beq.w	loc_3AB3E
		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$12,2(a2)
		andi.w	#$F00,d0
		beq.w	loc_3AAC0
		move.b	#$3C,2(a2)

loc_3AAC0:
		btst	#$A,d0
		beq.s	loc_3AACC
		move.w	#-$200,$18(a1)

loc_3AACC:
		btst	#$B,d0
		beq.s	loc_3AAD8
		move.w	#$200,$18(a1)

loc_3AAD8:
		move.w	#-$380,$1A(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		move.b	#-$6A,$22(a1)
		bset	#2,$2A(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$27(a1)
		bclr	#3,$2A(a1)
		move.w	#0,$42(a1)
		bra.w	loc_3AC26
; ---------------------------------------------------------------------------

loc_3AB24:

		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$3C,2(a2)
		bclr	#3,$2A(a1)
		move.w	#0,$42(a1)
		rts
; ---------------------------------------------------------------------------

loc_3AB3E:
		tst.b	4(a2)
		bne.s	loc_3ABBE

loc_3AB44:
		move.w	$3E(a0),d2
		subi.w	#$10,d2
		btst	#$A,d0
		beq.s	loc_3AB70
		bset	#0,$2A(a1)
		move.w	$10(a1),d1
		sub.w	$10(a0),d1
		add.w	d2,d1
		beq.s	loc_3AB70
		move.b	#4,4(a2)
		move.b	#1,2(a2)

loc_3AB70:

		btst	#$B,d0
		beq.s	loc_3AB9A
		bclr	#0,$2A(a1)
		move.w	$10(a1),d1
		sub.w	$10(a0),d1
		add.w	d2,d1
		add.w	d2,d2
		cmp.w	d2,d1
		beq.w	loc_3AB9A
		move.b	#4,4(a2)
		move.b	#0,2(a2)

loc_3AB9A:

		move.b	$2A(a1),d0
		andi.b	#1,d0
		andi.b	#-4,4(a1)
		or.b	d0,4(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$12,$14(a1)
		tst.b	4(a2)
		beq.s	loc_3AC26

loc_3ABBE:
		subq.b	#1,6(a2)
		bpl.s	loc_3AC26
		move.b	#7,6(a2)
		move.b	#0,$20(a1)
		moveq	#0,d1
		move.b	4(a2),d1
		cmpi.b	#2,d1
		bne.s	loc_3ABE4
		moveq	#$4A,d0
		jsr	(Play_Sound_2).l

loc_3ABE4:
		subq.w	#1,d1
		bne.s	loc_3ABEE
		move.b	#$14,$20(a1)

loc_3ABEE:
		add.b	8(a2),d1
		move.b	RawAni_3AC38(pc,d1.w),$22(a1)
		move.b	byte_3AC40(pc,d1.w),d1
		ext.w	d1
		tst.b	2(a2)
		beq.s	loc_3AC06
		neg.w	d1

loc_3AC06:
		add.w	d1,$10(a1)
		subq.b	#1,4(a2)
		bne.s	loc_3AC26
		bsr.s	sub_3AC48
		move.b	#0,6(a2)
		bchg	#2,8(a2)
		andi.w	#$C00,d0
		bne.w	loc_3AB44

loc_3AC26:

		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2
		rts
; End of function sub_3AA7E

; ---------------------------------------------------------------------------
RawAni_3AC38:	dc.b  $91, $81,	$80, $85, $91, $84, $83, $82
byte_3AC40:	dc.b	4,  $C,	 $A,   6,   4,	$C,  $C,   4

; =============== S U B R O U T I N E =======================================


sub_3AC48:
		btst	#6,$2C(a0)
		beq.s	locret_3AC84
		move.w	$3E(a0),d2
		subi.w	#$10,d2
		btst	#0,$2A(a0)
		beq.s	loc_3AC70
		move.w	$10(a1),d1
		sub.w	$10(a0),d1
		add.w	d2,d1
		bne.s	locret_3AC84
		bra.w	loc_3AB24
; ---------------------------------------------------------------------------

loc_3AC70:
		move.w	$10(a1),d1
		sub.w	$10(a0),d1
		add.w	d2,d1
		add.w	d2,d2
		cmp.w	d2,d1
		bne.s	locret_3AC84
		bra.w	loc_3AB24
; ---------------------------------------------------------------------------

locret_3AC84:

		rts
; End of function sub_3AC48

; ---------------------------------------------------------------------------

loc_3AC86:
		tst.b	2(a2)
		beq.s	loc_3AC94
		subq.b	#1,2(a2)
		bne.w	locret_3AD88

loc_3AC94:
		move.w	$3E(a0),d2
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d2,d0
		add.w	d2,d2
		cmp.w	d2,d0
		bcc.w	locret_3AD88
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		cmpi.w	#$18,d1
		bcc.w	locret_3AD88
		tst.b	$2E(a1)
		bmi.w	locret_3AD88
		cmpi.b	#4,5(a1)
		bcc.w	locret_3AD88
		tst.w	($FFFFFE08).w
		bne.w	locret_3AD88
		btst	#3,$2A(a1)
		beq.s	loc_3ACEA
		movea.w	$42(a1),a3
		cmpi.l	#loc_3A84C,(a3)
		beq.w	locret_3AD88

loc_3ACEA:
		andi.w	#-$20,d0
		btst	#6,$2C(a0)
		beq.s	loc_3AD10
		btst	#0,$2A(a0)
		beq.s	loc_3AD06
		tst.w	d0
		beq.w	locret_3AD88
		bra.s	loc_3AD10
; ---------------------------------------------------------------------------

loc_3AD06:
		subi.w	#$20,d2
		cmp.w	d2,d0
		beq.w	locret_3AD88

loc_3AD10:

		addi.w	#$10,d0
		sub.w	$3E(a0),d0
		add.w	$10(a0),d0
		move.w	d0,$10(a1)
		move.w	a0,$42(a1)
		bset	#3,$2A(a1)
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$12,$14(a1)
		move.b	#$14,$20(a1)
		move.b	#3,$2E(a1)
		andi.b	#-3,4(a1)
		move.b	#1,(a2)
		move.b	#0,2(a2)
		move.b	#0,4(a2)
		move.b	#0,6(a2)
		move.b	#-$6F,$22(a1)
		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2
		moveq	#$4A,d0

loc_3AD82:

		jsr	(Play_Sound_2).l

locret_3AD88:

		rts
; ---------------------------------------------------------------------------
Map_FBZChainLink:include "Levels\FBZ\Misc Object Data\Map - Chain Link.asm"

; ---------------------------------------------------------------------------

Obj_FBZMagneticSpikeBall:

		move.l	#Map_FBZMagneticSpikeBall,$C(a0)
		move.w	#$2443,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		tst.b	$2C(a0)
		beq.s	loc_3B16E
		bmi.s	loc_3B122
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.b	#-$66,$28(a0)
		move.l	#loc_1B662,(a0)
		jmp	(loc_1B662).l
; ---------------------------------------------------------------------------

loc_3B122:
		btst	#0,$2C(a0)
		bne.s	loc_3B146
		ori.w	#-$8000,$A(a0)
		move.b	#$30,7(a0)
		move.b	#8,6(a0)
		move.l	#loc_3B1FC,(a0)
		bra.w	loc_3B1FC
; ---------------------------------------------------------------------------

loc_3B146:
		move.w	#-$5BBE,$A(a0)

loc_3B14C:
		move.b	#$24,7(a0)
		move.b	#4,6(a0)
		move.b	#4,$22(a0)
		move.w	#$200,8(a0)
		move.l	#loc_3B238,(a0)
		bra.w	loc_3B238
; ---------------------------------------------------------------------------

loc_3B16E:
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.b	#$A,$1E(a0)
		move.b	#-$66,$28(a0)
		move.l	#loc_3B18C,(a0)

loc_3B18C:

		jsr	(MoveSprite2).l
		addi.w	#$58,$1A(a0)
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_3B1B2
		add.w	d1,$14(a0)
		move.w	#0,$1A(a0)
		move.l	#loc_3B1B2,(a0)

loc_3B1B2:

		tst.b	($FFFFF7C1).w
		beq.s	loc_3B1BE
		move.l	#loc_3B1C4,(a0)

loc_3B1BE:
		jmp	(loc_1B662).l
; ---------------------------------------------------------------------------

loc_3B1C4:
		jsr	(MoveSprite2).l
		subi.w	#$18,$1A(a0)
		jsr	(ObjHitCeiling).l
		tst.w	d1
		bpl.s	loc_3B1EA
		sub.w	d1,$14(a0)
		move.w	#0,$1A(a0)
		move.l	#loc_3B1EA,(a0)

loc_3B1EA:

		tst.b	($FFFFF7C1).w
		bne.s	loc_3B1F6
		move.l	#loc_3B18C,(a0)

loc_3B1F6:
		jmp	(loc_1B662).l
; ---------------------------------------------------------------------------

loc_3B1FC:

		tst.b	($FFFFF7C1).w
		beq.s	loc_3B232
		addq.b	#1,$22(a0)
		cmpi.b	#5,$22(a0)
		bcs.s	loc_3B214
		move.b	#1,$22(a0)

loc_3B214:
		move.b	($FFFFFE05).w,d0
		andi.b	#$F,d0
		bne.s	loc_3B22C
		tst.b	4(a0)
		bpl.s	loc_3B22C
		moveq	#-$27,d0
		jsr	(Play_Sound_2).l

loc_3B22C:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_3B232:
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_3B238:

		tst.b	($FFFFF7C1).w
		beq.s	loc_3B256
		addq.b	#1,$22(a0)
		cmpi.b	#7,$22(a0)
		bcs.s	loc_3B250
		move.b	#5,$22(a0)

loc_3B250:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_3B256:
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------
Map_FBZMagneticSpikeBall:include "Levels\FBZ\Misc Object Data\Map - Magnetic Spike Ball.asm"

; ---------------------------------------------------------------------------

Obj_FBZMagneticPlatform:

		move.l	#Map_FBZMagneticPlatform,$C(a0)
		move.w	#$2443,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$18,7(a0)
		move.b	#$10,6(a0)
		move.w	#$280,8(a0)
		move.b	#$F,$1E(a0)
		move.w	$14(a0),$46(a0)
		move.b	#-$73,$28(a0)
		moveq	#0,d1
		move.b	$2C(a0),d1
		lsl.w	#4,d1
		subi.w	#$20,d1
		move.w	d1,$2E(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_3B3BA
		move.l	#loc_3B482,(a1)
		move.l	$C(a0),$C(a1)

loc_3B354:
		move.w	$A(a0),$A(a1)
		move.b	4(a0),4(a1)
		move.b	#$10,7(a1)
		move.b	#-$80,6(a1)
		move.w	#$200,8(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		subi.w	#$70,$14(a1)
		moveq	#8,d0
		bset	#6,4(a1)
		move.w	d0,$16(a1)
		move.w	$14(a0),d1
		addi.w	#$C,d1
		lea	$18(a1),a2
		move.w	$16(a1),d0
		subq.w	#1,d0

loc_3B3A2:
		move.w	$10(a0),(a2)+
		move.w	d1,(a2)+
		move.w	#1,(a2)+
		dbf	d0,loc_3B3A2
		move.w	#3,$1C(a1)
		move.w	a1,$3C(a0)

loc_3B3BA:
		move.l	#loc_3B3C0,(a0)

loc_3B3C0:

		jsr	(MoveSprite2).l
		addi.w	#$58,$1A(a0)
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_3B3EC
		add.w	d1,$14(a0)
		move.w	#0,$1A(a0)
		move.b	#$10,$1E(a0)
		move.l	#loc_3B3EC,(a0)

loc_3B3EC:

		tst.b	($FFFFF7C1).w
		beq.s	loc_3B3F8
		move.l	#loc_3B3FA,(a0)

loc_3B3F8:
		bra.s	loc_3B462
; ---------------------------------------------------------------------------

loc_3B3FA:
		jsr	(MoveSprite2).l
		subi.w	#$18,$1A(a0)
		move.w	$46(a0),d0
		sub.w	$14(a0),d0
		cmp.w	$2E(a0),d0
		bcs.s	loc_3B436
		move.w	$46(a0),d0
		sub.w	$2E(a0),d0
		move.w	d0,$14(a0)
		move.w	#0,$1A(a0)
		move.l	#loc_3B450,(a0)
		moveq	#$7C,d0
		jsr	(Play_Sound_2).l
		bra.s	loc_3B450
; ---------------------------------------------------------------------------

loc_3B436:
		jsr	(ObjHitCeiling).l
		tst.w	d1
		bpl.s	loc_3B450
		sub.w	d1,$14(a0)
		move.w	#0,$1A(a0)
		move.l	#loc_3B450,(a0)

loc_3B450:


		tst.b	($FFFFF7C1).w
		bne.s	loc_3B462
		move.b	#$F,$1E(a0)
		move.l	#loc_3B3C0,(a0)

loc_3B462:

		bsr.w	sub_3B488
		move.w	#$23,d1
		move.w	#8,d2
		move.w	#-9,d3
		move.w	$10(a0),d4
		jsr	SolidObjectFull_Offset
		jmp	loc_1B662
; ---------------------------------------------------------------------------

loc_3B482:
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_3B488:
		movea.w	$3C(a0),a1
		lea	$20(a1),a2
		move.w	$14(a0),d2
		addi.w	#$18,d2
		move.w	$46(a0),d0
		sub.w	$14(a0),d0
		move.w	d0,d6
		addi.w	#$18,d6
		lsr.w	#5,d6
		addq.w	#1,d6
		cmpi.w	#8,d6
		bcs.s	loc_3B4B2
		moveq	#8,d6

loc_3B4B2:
		move.w	d6,$16(a1)
		subq.w	#2,d6
		bcs.s	locret_3B4DC

loc_3B4BA:
		move.w	d2,(a2)+
		move.w	#2,(a2)+
		addq.w	#2,a2
		addi.w	#$20,d2
		dbf	d6,loc_3B4BA
		subq.w	#8,d0
		andi.w	#$1F,d0
		cmpi.w	#$10,d0
		bcc.s	locret_3B4DC
		move.w	#1,-4(a2)

locret_3B4DC:

		rts
; End of function sub_3B488

; ---------------------------------------------------------------------------
Map_FBZMagneticPlatform:include "Levels\FBZ\Misc Object Data\Map - Magnetic Platform.asm"

; ---------------------------------------------------------------------------

Obj_FBZSnakePlatform:
		moveq	#$19,d2
		moveq	#2,d1

loc_3B538:
		jsr	(Create_New_Sprite3).l
		bne.w	loc_3B556
		move.l	#Obj_FBZSnakePlatformMain,(a1)
		move.b	d2,$24(a1)
		addi.b	#$18,d2
		move.b	$2C(a0),$2C(a1)

loc_3B556:
		dbf	d1,loc_3B538
		move.b	#1,$24(a0)
		move.l	#Obj_FBZSnakePlatformMain,(a0)

Obj_FBZSnakePlatformMain:

		move.l	#Map_FBZSnakePlatform,$C(a0)
		move.w	#$246B,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$C,7(a0)
		move.b	#$C,6(a0)
		move.w	#$280,8(a0)
		bset	#7,$2A(a0)
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		add.w	d0,d0
		add.w	d0,d0
		lea	(FBZSnakePlatform_Data).l,a2
		movea.l	(a2,d0.w),a2
		move.w	(a2)+,d1
		move.w	(a2)+,d0
		move.w	d0,$34(a0)
		sub.w	d1,d0
		andi.w	#-$80,d0
		addi.w	#$300,d0
		move.w	d0,$36(a0)
		move.l	a2,$30(a0)
		bsr.w	FBZSnake_ChangeDir
		move.l	#Obj_FBZSnakePlatformWait,(a0)

Obj_FBZSnakePlatformWait:
		subq.b	#1,$24(a0)
		bne.s	loc_3B60E
		move.l	#Obj_FBZSnakePlatformMove,(a0)

Obj_FBZSnakePlatformMove:

		move.w	$10(a0),-(sp)
		jsr	(MoveSprite2).l
		movea.l	$30(a0),a2
		move.w	(a2)+,d0
		cmp.w	$10(a0),d0
		bne.s	loc_3B5FA
		move.w	(a2)+,d0
		cmp.w	$14(a0),d0
		bne.s	loc_3B5FA
		bsr.w	FBZSnake_ChangeDir

loc_3B5FA:

		move.w	(sp)+,d4

loc_3B5FC:
		move.w	#$17,d1
		move.w	#$C,d2
		move.w	#$D,d3
		jsr	(SolidObjectFull).l

loc_3B60E:
		move.w	$34(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmp.w	$36(a0),d0
		bhi.w	loc_3B628
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_3B628:
		move.w	$48(a0),d0
		beq.s	loc_3B634
		movea.w	d0,a2
		bclr	#7,(a2)

loc_3B634:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_FBZSnakePlatformStopRestart:
		move.w	$10(a0),d4
		subq.w	#1,$38(a0)
		bne.s	loc_3B5FC
		move.l	#Obj_FBZSnakePlatformMove,(a0)
		bra.s	Obj_FBZSnakePlatformMove

; =============== S U B R O U T I N E =======================================


FBZSnake_ChangeDir:

		movea.l	$30(a0),a2
		move.w	(a2)+,d4
		move.w	d4,$10(a0)
		move.w	(a2)+,d5
		move.w	d5,$14(a0)
		move.l	a2,$30(a0)
		move.w	(a2)+,d4
		bmi.s	loc_3B6A0
		move.w	(a2)+,d5
		move.w	#$140,d0
		cmp.w	$10(a0),d4
		beq.s	loc_3B680
		bcc.s	loc_3B674
		neg.w	d0

loc_3B674:
		move.w	d0,$18(a0)
		move.w	#0,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_3B680:
		cmp.w	$14(a0),d5
		beq.s	loc_3B696
		bcc.s	loc_3B68A
		neg.w	d0

loc_3B68A:
		move.w	#0,$18(a0)
		move.w	d0,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_3B696:
		move.w	d0,$18(a0)
		move.w	d0,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_3B6A0:
		move.w	(a2),d0
		beq.s	loc_3B6AE
		move.w	d0,$38(a0)
		move.l	#Obj_FBZSnakePlatformStopRestart,(a0)

loc_3B6AE:
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		add.w	d0,d0
		add.w	d0,d0
		lea	(FBZSnakePlatform_Data).l,a2
		movea.l	(a2,d0.w),a2
		addq.w	#4,a2
		move.l	a2,$30(a0)
		bra.w	FBZSnake_ChangeDir
; End of function FBZSnake_ChangeDir

; ---------------------------------------------------------------------------
Map_FBZSnakePlatform:	include "Levels\FBZ\Misc Object Data\Map - Snake Platform.asm"

byte_3B6D8:	dc.b $18
byte_3B6D9:	dc.b $10
		dc.b $10
		dc.b 8
		dc.b $18
		dc.b $10
; ---------------------------------------------------------------------------

Obj_FBZBentPipe:

		move.l	#Map_FBZBentPipe,$C(a0)
		move.w	#$246B,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$200,8(a0)
		move.b	$2C(a0),d0
		move.b	d0,$22(a0)
		andi.w	#3,d0

loc_3B704:
		add.w	d0,d0
		move.b	byte_3B6D8(pc,d0.w),7(a0)
		move.b	byte_3B6D9(pc,d0.w),6(a0)
		move.l	#loc_3B718,(a0)

loc_3B718:
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
Map_FBZBentPipe:include "Levels\FBZ\Misc Object Data\Map - Bent Pipe.asm"

; ---------------------------------------------------------------------------

Obj_FBZRotatingPlatform:

		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lsl.w	#3,d0
		lea	byte_3B780(pc,d0.w),a2
		moveq	#0,d1
		move.b	(a2)+,d1
		move.b	(a2)+,d2
		movea.l	a0,a1
		bra.w	loc_3B802
; ---------------------------------------------------------------------------
byte_3B780:	dc.b	5,   0,	$5C, $44, $2C, $D4, $BC, $A4
		dc.b	5,   1,	$5C, $44, $2C, $D4, $BC, $A4
		dc.b	5, $21,	$5C, $44, $2C, $D4, $BC, $A4
		dc.b	3,   0,	$44, $2C, $D4, $BC,   0,   0
		dc.b	3,   1,	$44, $2C, $D4, $BC,   0,   0
		dc.b	3,   9,	$44, $2C, $D4, $BC,   0,   0
		dc.b	1,   0,	$2C, $D4,   0,	 0,   0,   0
		dc.b	1,   1,	$2C, $D4,   0,	 0,   0,   0
		dc.b	1,   3,	$2C, $D4,   0,	 0,   0,   0
		dc.b	2,   0,	$5C, $44, $2C,	 0,   0,   0
		dc.b	2,   1,	$5C, $44, $2C,	 0,   0,   0
		dc.b	1,   0,	$44, $2C,   0,	 0,   0,   0
		dc.b	1,   1,	$44, $2C,   0,	 0,   0,   0
		dc.b	0,   0,	$2C,   0,   0,	 0,   0,   0
		dc.b	0,   1,	$2C,   0,   0,	 0,   0,   0
; ---------------------------------------------------------------------------

loc_3B7F8:
		jsr	(Create_New_Sprite3).l
		bne.w	loc_3B866

loc_3B802:
		move.l	#loc_3B86A,(a1)
		move.l	#Map_FBZRotatingPlatform,$C(a1)
		move.w	#$246B,$A(a1)
		ori.b	#4,4(a1)
		move.b	#$C,7(a1)
		move.b	#$C,6(a1)
		move.w	#$280,8(a1)
		move.b	$2A(a0),$2A(a1)
		bset	#7,$2A(a1)
		move.w	$10(a0),$44(a1)
		move.w	$14(a0),$46(a1)
		move.b	(a2)+,$30(a1)
		lsr.b	#1,d2
		bcc.s	loc_3B866
		move.l	#loc_3B8C2,(a1)
		move.w	#$2443,$A(a1)
		move.b	#1,$22(a1)
		move.b	#-$7A,$28(a1)

loc_3B866:

		dbf	d1,loc_3B7F8

loc_3B86A:
		move.w	$10(a0),-(sp)
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		move.w	$30(a0),d2
		muls.w	d2,d1
		muls.w	d2,d0
		swap	d1
		swap	d0
		add.w	$44(a0),d1
		add.w	$46(a0),d0
		move.w	d1,$10(a0)
		move.w	d0,$14(a0)
		move.w	#$17,d1
		move.w	#$C,d2
		move.w	#$D,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectFull).l
		moveq	#1,d1
		btst	#0,$2A(a0)
		beq.s	loc_3B8B4
		neg.w	d1

loc_3B8B4:
		add.b	d1,$26(a0)
		move.w	$44(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_3B8C2:
		move.w	$10(a0),-(sp)
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		move.w	$30(a0),d2
		muls.w	d2,d1
		muls.w	d2,d0
		swap	d1
		swap	d0
		add.w	$44(a0),d1
		add.w	$46(a0),d0
		move.w	d1,$10(a0)
		move.w	d0,$14(a0)
		move.w	#$17,d1
		move.w	#$C,d2
		move.w	#$D,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectFull).l
		moveq	#1,d1
		btst	#0,$2A(a0)
		beq.s	loc_3B90C
		neg.w	d1

loc_3B90C:
		add.b	d1,$26(a0)
		move.w	$44(a0),d0
		jmp	(loc_1B666).l
; ---------------------------------------------------------------------------
Map_FBZRotatingPlatform:include "Levels\FBZ\Misc Object Data\Map - Rotating Platform.asm"

; ---------------------------------------------------------------------------

Obj_FBZDEZPlayerLauncher:

		move.l	#Map_FBZDEZPlayerLauncher,$C(a0)
		move.w	#$23B5,$A(a0)
		cmpi.b	#$B,($FFFFFE10).w
		bne.s	loc_3B956
		move.w	#$22FC,$A(a0)
		move.b	#1,$22(a0)

loc_3B956:
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$280,8(a0)
		move.w	$10(a0),$44(a0)
		move.l	#loc_3B97A,(a0)

loc_3B97A:

		tst.b	$30(a0)
		beq.s	loc_3B9AC
		subq.b	#1,$30(a0)
		bne.s	loc_3B998
		move.w	#0,$18(a0)
		move.l	#loc_3BA4A,(a0)
		move.b	#1,$32(a0)

loc_3B998:
		jsr	(MoveSprite2).l
		tst.b	$31(a0)
		beq.s	loc_3B9AC
		subq.b	#1,$31(a0)
		asl	$18(a0)

loc_3B9AC:

		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.s	sub_3B9D8
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.s	sub_3B9D8
		move.w	#$10,d1
		move.w	#3,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		move.w	$44(a0),d0
		jmp	(Sprite_OnScreen_Test2).l

; =============== S U B R O U T I N E =======================================


sub_3B9D8:

		btst	d6,$2A(a0)
		beq.s	locret_3BA48
		moveq	#4,d0
		move.w	#$100,d1
		bclr	#0,$2A(a1)
		btst	#0,$2A(a0)
		beq.s	loc_3B9FC

loc_3B9F2:
		bset	#0,$2A(a1)
		neg.w	d0
		neg.w	d1

loc_3B9FC:
		add.w	$10(a0),d0
		move.w	d0,$10(a1)
		tst.b	$32(a0)
		beq.s	loc_3BA1E
		move.b	#0,$20(a1)
		bset	#1,$2A(a1)
		move.w	#0,$1A(a1)
		rts
; ---------------------------------------------------------------------------

loc_3BA1E:
		move.w	$18(a0),d0
		move.w	d0,$18(a1)
		move.w	d0,$1C(a1)
		tst.b	$30(a0)
		bne.s	locret_3BA48
		move.w	d1,$18(a0)
		move.b	#$C,$30(a0)
		move.b	#4,$31(a0)
		moveq	#-$5E,d0
		jsr	(Play_Sound_2).l

locret_3BA48:

		rts
; End of function sub_3B9D8

; ---------------------------------------------------------------------------

loc_3BA4A:
		move.w	$10(a0),-(sp)
		moveq	#1,d1
		move.w	$10(a0),d0
		sub.w	$44(a0),d0
		bne.s	loc_3BA68
		move.l	#loc_3B97A,(a0)
		move.b	#0,$32(a0)
		bra.s	loc_3BA70
; ---------------------------------------------------------------------------

loc_3BA68:
		bcs.s	loc_3BA6C
		neg.w	d1

loc_3BA6C:
		add.w	d1,$10(a0)

loc_3BA70:
		move.w	#$10,d1
		move.w	#3,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectTop).l
		move.w	$44(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------
Map_FBZDEZPlayerLauncher:include "Levels\FBZ\Misc Object Data\Map - DEZ Player Launcher.asm"

word_3BAAA:	dc.w $7F
		dc.w $FF
		dc.w $1FF
		dc.w $3FF
; ---------------------------------------------------------------------------

Obj_FBZDisappearingPlatform:

		move.l	#Map_FBZDisappearingPlatform,$C(a0)
		move.w	#$23BA,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$280,8(a0)
		move.b	#2,$22(a0)
		move.b	$2C(a0),d0
		move.b	d0,d1
		andi.w	#$C,d0
		lsr.w	#1,d0
		move.w	word_3BAAA(pc,d0.w),d0
		move.w	d0,$32(a0)
		addq.w	#1,d0
		lsr.w	#4,d0
		andi.w	#$F0,d1
		lsr.w	#4,d1
		mulu.w	d1,d0
		move.w	d0,$30(a0)
		move.l	#loc_3BB08,(a0)

loc_3BB08:

		move.w	($FFFFFE04).w,d0
		add.w	$30(a0),d0

loc_3BB10:
		and.w	$32(a0),d0
		beq.s	loc_3BB1C
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_3BB1C:
		move.b	$2C(a0),d0
		andi.b	#3,d0

loc_3BB24:
		move.b	d0,$20(a0)
		move.b	#4,$21(a0)
		move.l	#loc_3BB34,(a0)

loc_3BB34:
		lea	(Ani_FBZDisappearingPlatform).l,a1
		jsr	(Animate_SpriteIrregularDelay).l
		tst.b	$22(a0)
		beq.s	loc_3BB6E
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.s	sub_3BB86
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.s	sub_3BB86
		tst.b	5(a0)
		beq.s	loc_3BB80

loc_3BB5C:
		clr.b	5(a0)
		move.b	#2,$22(a0)
		move.l	#loc_3BB08,(a0)
		bra.s	loc_3BB80
; ---------------------------------------------------------------------------

loc_3BB6E:
		move.w	#$1B,d1
		move.w	#$11,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l

loc_3BB80:

		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_3BB86:

		bclr	d6,$2A(a0)
		beq.s	locret_3BB98
		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)

locret_3BB98:
		rts
; End of function sub_3BB86

; ---------------------------------------------------------------------------
Ani_FBZDisappearingPlatform:	include "Levels\FBZ\Misc Object Data\Anim - Disappearing Platform.asm"

Map_FBZDisappearingPlatform:include "Levels\FBZ\Misc Object Data\Map - Disappearing Platform.asm"


byte_3BBE8:	dc.b 8
byte_3BBE9:	dc.b $20
		dc.b $20
		dc.b 8
		dc.b $40
		dc.b 8
; ---------------------------------------------------------------------------

Obj_FBZScrewDoor:

		move.b	$2C(a0),d0
		lsr.w	#4,d0
		andi.w	#7,d0
		move.b	d0,$20(a0)
		andi.w	#6,d0
		move.b	byte_3BBE8(pc,d0.w),7(a0)
		move.b	byte_3BBE9(pc,d0.w),6(a0)
		move.l	#Map_FBZScrewDoor,$C(a0)
		move.w	#$23D2,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.w	$10(a0),$44(a0)
		move.w	$14(a0),$46(a0)
		lea	(Ani_FBZScrewDoor).l,a1
		jsr	(Animate_Sprite).l
		tst.b	$2C(a0)
		bpl.s	loc_3BC6C
		move.w	$48(a0),d0
		beq.s	loc_3BC62
		movea.w	d0,a2
		btst	#0,(a2)
		beq.s	loc_3BC62
		addi.w	#$40,$14(a0)
		move.l	#loc_3BCF2,(a0)
		bra.w	loc_3BCF2
; ---------------------------------------------------------------------------

loc_3BC62:

		move.l	#loc_3BD1A,(a0)
		bra.w	loc_3BD1A
; ---------------------------------------------------------------------------

loc_3BC6C:
		move.l	#loc_3BC72,(a0)

loc_3BC72:
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		tst.b	(a3,d0.w)
		beq.s	loc_3BCF2
		move.l	#loc_3BC92,(a0)
		moveq	#-$71,d0
		jsr	(Play_Sound_2).l

loc_3BC92:

		addq.b	#1,$2E(a0)
		cmpi.b	#-$80,$2E(a0)
		bne.s	loc_3BCA4
		move.l	#loc_3BCF2,(a0)

loc_3BCA4:
		moveq	#0,d0
		move.b	$2E(a0),d0
		btst	#4,$2C(a0)
		beq.s	loc_3BCB4
		neg.w	d0

loc_3BCB4:
		btst	#5,$2C(a0)
		bne.s	loc_3BCDC
		btst	#6,$2C(a0)
		bne.s	loc_3BCDE
		asr.w	#1,d0
		add.w	$46(a0),d0
		move.w	d0,$14(a0)
		lea	(Ani_FBZScrewDoor).l,a1
		jsr	(Animate_Sprite).l
		bra.s	loc_3BCF2
; ---------------------------------------------------------------------------

loc_3BCDC:
		asr.w	#1,d0

loc_3BCDE:
		add.w	$44(a0),d0
		move.w	d0,$10(a0)
		lea	(Ani_FBZScrewDoor).l,a1
		jsr	(Animate_Sprite).l

loc_3BCF2:

		moveq	#0,d1

loc_3BCF4:
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3

loc_3BD06:
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		move.w	$44(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_3BD1A:

		lea	($FFFFB000).w,a1
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#-$20,d0
		cmpi.w	#$40,d0
		bcc.s	loc_3BCF2
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		btst	#0,$2A(a0)
		beq.s	loc_3BD42
		neg.w	d0

loc_3BD42:
		cmpi.w	#$40,d0
		blt.s	loc_3BCF2
		move.w	$48(a0),d0
		beq.s	loc_3BD54
		movea.w	d0,a2
		bset	#0,(a2)

loc_3BD54:
		move.l	#loc_3BC92,(a0)
		bra.w	loc_3BC92
; ---------------------------------------------------------------------------
Ani_FBZScrewDoor:	include "Levels\FBZ\Misc Object Data\Anim - Screw Door.asm"

Map_FBZScrewDoor:include "Levels\FBZ\Misc Object Data\Map - Screw Door.asm"

; ---------------------------------------------------------------------------

Obj_7B_1:
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#3,d0
		move.w	d0,$36(a0)
		move.l	#loc_3BF68,(a0)

loc_3BF68:
		lea	$30(a0),a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF602).w,d1
		bsr.s	sub_3BFA0
		addq.w	#1,a2
		lea	($FFFFB04A).w,a1
		move.w	($FFFFF66A).w,d1
		bsr.s	sub_3BFA0
		tst.b	$30(a0)
		beq.s	loc_3BF9A
		move.b	#1,($FFFFF676).w
		move.w	$10(a0),($FFFFF678).w
		move.w	($FFFFB014).w,($FFFFF67C).w

loc_3BF9A:
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_3BFA0:

		tst.b	(a2)
		beq.w	loc_3C0D0
		tst.w	($FFFFFE08).w
		bne.w	loc_3C096
		cmpi.b	#4,5(a1)
		bcc.w	loc_3C096
		tst.b	$2E(a1)
		bmi.w	loc_3C096
		btst	#8,d1
		beq.s	loc_3BFD8
		move.w	$14(a0),d0
		sub.w	$36(a0),d0
		cmp.w	$14(a1),d0
		bge.s	loc_3BFD8
		subq.w	#1,$14(a1)

loc_3BFD8:

		btst	#9,d1
		beq.s	loc_3BFEC
		move.w	$14(a0),d0
		cmp.w	$14(a1),d0
		ble.s	loc_3BFEC
		addq.w	#1,$14(a1)

loc_3BFEC:

		move.w	d1,d0
		andi.w	#$70,d0
		bne.w	loc_3C068
		addi.b	#8,4(a2)
		bsr.s	sub_3C010

loc_3BFFE:
		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2
		rts
; End of function sub_3BFA0


; =============== S U B R O U T I N E =======================================


sub_3C010:

		andi.w	#$7FFF,$A(a1)
		moveq	#0,d0
		move.b	4(a2),d0
		bmi.s	loc_3C024
		ori.w	#-$8000,$A(a1)

loc_3C024:
		lsr.b	#4,d0
		move.b	RawAni_3C048(pc,d0.w),d1
		move.b	d1,$22(a1)
		move.b	byte_3C058(pc,d0.w),d1
		ext.w	d1
		btst	#0,4(a1)
		beq.s	loc_3C03E
		neg.w	d1

loc_3C03E:
		add.w	$10(a0),d1
		move.w	d1,$10(a1)
		rts
; End of function sub_3C010

; ---------------------------------------------------------------------------
RawAni_3C048:	dc.b  $5C, $5C,	$5D, $5D, $5D, $5E, $5E, $5E, $5F, $5F,	$60, $60, $60, $61, $61, $61
byte_3C058:	dc.b  $18, $18,	  4,   4,   4, $F6, $F6, $F6, $E8, $E8,	$E8, $E8, $E8,	$A,  $A,  $A
; ---------------------------------------------------------------------------

loc_3C068:
		move.w	#$1000,$18(a1)
		btst	#$A,d1
		beq.s	loc_3C078
		neg.w	$18(a1)

loc_3C078:
		move.w	#-$100,$1A(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)

loc_3C096:

		clr.b	(a2)
		move.b	#$1E,2(a2)
		andi.b	#-4,$2E(a1)
		andi.w	#$7FFF,$A(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$27(a1)
		move.b	#0,$3D(a1)
		move.b	#0,$2F(a1)
		rts
; ---------------------------------------------------------------------------

loc_3C0D0:
		tst.b	2(a2)
		beq.s	loc_3C0DC
		subq.b	#1,2(a2)
		rts
; ---------------------------------------------------------------------------

loc_3C0DC:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$C,d0
		cmpi.w	#$18,d0
		bcc.w	locret_3C19A
		move.w	$36(a0),d1
		move.w	$14(a0),d0
		sub.w	$14(a1),d0
		addi.w	#$10,d0
		cmp.w	$36(a0),d0
		bcc.w	locret_3C19A
		tst.w	($FFFFFE08).w
		bne.w	locret_3C19A
		cmpi.b	#4,5(a1)
		bcc.w	locret_3C19A
		tst.b	$2E(a1)
		bne.w	locret_3C19A
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		andi.b	#-4,4(a1)
		move.b	$1E(a1),d0
		move.b	$44(a1),$1E(a1)
		move.b	$45(a1),$1F(a1)
		bclr	#2,$2A(a1)
		beq.s	loc_3C156
		sub.b	$44(a1),d0
		ext.w	d0
		add.w	d0,$14(a1)

loc_3C156:
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),d0
		cmp.w	$14(a1),d0
		bcc.s	loc_3C16A
		move.w	d0,$14(a1)

loc_3C16A:
		bset	#1,$2A(a1)
		bclr	#0,$2A(a1)
		move.b	#0,$20(a1)
		move.b	#3,$2E(a1)
		andi.b	#-3,4(a1)
		move.b	#-$20,4(a2)
		move.b	#1,(a2)
		bsr.w	sub_3C010
		bra.w	loc_3BFFE
; ---------------------------------------------------------------------------

locret_3C19A:

		rts
; ---------------------------------------------------------------------------
		dc.w 2
		dc.w 1
		dc.w $805
		dc.w $9036
		dc.w $FFF8
; ---------------------------------------------------------------------------

Obj_FBZPropeller:

		move.l	#Map_FBZPropeller,$C(a0)
		move.w	#$22E5,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$68,7(a0)
		move.b	#8,6(a0)
		move.w	#$280,8(a0)
		bset	#6,4(a0)
		move.w	#1,$16(a0)
		lea	$18(a0),a2
		move.w	$10(a0),(a2)+
		move.w	$14(a0),(a2)+
		move.w	#0,(a2)+
		move.l	#loc_3C1EE,(a0)

loc_3C1EE:
		lea	$1D(a0),a2
		addq.b	#1,(a2)
		andi.b	#3,(a2)
		moveq	#0,d0
		move.b	(a2),d0
		move.b	CollisionEffects_3C208(pc,d0.w),$28(a0)
		jmp	(loc_1B662).l
; ---------------------------------------------------------------------------
CollisionEffects_3C208:dc.b $B6
		dc.b 0
		dc.b $B6
		dc.b $B7
Map_FBZPropeller:include "Levels\FBZ\Misc Object Data\Map - Propeller.asm"

; ---------------------------------------------------------------------------

Obj_FBZPiston:

		move.l	#Map_FBZPiston,$C(a0)
		move.w	#$231B,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$20,7(a0)
		move.b	#$20,6(a0)
		move.w	#$280,8(a0)
		move.w	$10(a0),$44(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#3,d0
		move.w	d0,$34(a0)
		andi.w	#-$80,d0
		addi.w	#$200,d0
		move.w	d0,$36(a0)
		move.l	#loc_3C2A6,(a0)

loc_3C2A6:
		move.w	$10(a0),-(sp)
		tst.b	$30(a0)
		beq.s	loc_3C2BE
		subq.w	#2,$32(a0)
		bne.s	loc_3C2D2
		move.b	#0,$30(a0)
		bra.s	loc_3C2D2
; ---------------------------------------------------------------------------

loc_3C2BE:
		addq.w	#2,$32(a0)
		move.w	$34(a0),d0
		cmp.w	$32(a0),d0
		bne.s	loc_3C2D2
		move.b	#1,$30(a0)

loc_3C2D2:

		move.w	$32(a0),d0
		neg.w	d0
		add.w	$44(a0),d0
		move.w	d0,$10(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectFull).l
		move.w	$44(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmp.w	$36(a0),d0
		bhi.w	loc_3C316
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_3C316:
		move.w	$48(a0),d0
		beq.s	loc_3C322
		movea.w	d0,a2
		bclr	#7,(a2)

loc_3C322:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
Map_FBZPiston:	include "Levels\FBZ\Misc Object Data\Map - Piston.asm"

byte_3C344:	dc.b $10
byte_3C345:	dc.b $10
		dc.b $20
		dc.b $10
		dc.b $30
		dc.b $10
		dc.b $40
		dc.b $10
; ---------------------------------------------------------------------------

Obj_FBZPlatformBlocks:

		move.b	$2C(a0),d0
		lsr.w	#4,d0
		andi.w	#7,d0
		move.b	d0,$22(a0)
		add.w	d0,d0
		move.b	byte_3C344(pc,d0.w),7(a0)
		move.b	byte_3C345(pc,d0.w),6(a0)
		move.l	#Map_FBZPlatformBlocks,$C(a0)
		move.w	#$440D,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)

loc_3C382:
		move.w	$10(a0),$44(a0)
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lsl.w	#4,d0
		move.w	d0,$30(a0)
		bne.s	loc_3C3A2
		move.l	#loc_3C3EE,(a0)
		bra.w	loc_3C3EE
; ---------------------------------------------------------------------------

loc_3C3A2:
		move.l	#loc_3C3A8,(a0)

loc_3C3A8:
		move.w	($FFFFB014).w,d0
		sub.w	$14(a0),d0
		bcs.s	loc_3C3C8
		cmpi.w	#$20,d0
		blt.s	loc_3C3D8
		move.w	$30(a0),d1
		cmp.w	$32(a0),d1
		beq.s	loc_3C3D8
		addq.w	#8,$32(a0)
		bra.s	loc_3C3D8
; ---------------------------------------------------------------------------

loc_3C3C8:
		cmpi.w	#-$28,d0
		bge.s	loc_3C3D8
		tst.w	$32(a0)
		beq.s	loc_3C3D8
		subq.w	#8,$32(a0)

loc_3C3D8:

		move.w	$32(a0),d0
		btst	#0,$2A(a0)
		beq.s	loc_3C3E6
		neg.w	d0

loc_3C3E6:
		add.w	$44(a0),d0
		move.w	d0,$10(a0)

loc_3C3EE:

		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		move.w	$44(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------
Map_FBZPlatformBlocks:include "Levels\FBZ\Misc Object Data\Map - Platform Blocks.asm"

; ---------------------------------------------------------------------------

Obj_FBZMissileLauncher:

		move.l	#Map_FBZMissileLauncher,$C(a0)
		move.w	#-$5CD5,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)

loc_3C482:
		move.w	#$80,8(a0)
		move.b	$2C(a0),d0
		move.b	d0,d1
		andi.w	#$C,d0
		addi.w	#4,d0
		lsl.w	#2,d0
		move.w	d0,$30(a0)
		move.b	d1,d0
		andi.b	#3,d0
		move.b	d0,$34(a0)
		move.b	d0,$35(a0)
		andi.b	#$70,d1
		move.b	d1,$32(a0)
		tst.b	$2C(a0)
		bpl.s	loc_3C520
		jsr	(Create_New_Sprite3).l
		bne.w	loc_3C51A

loc_3C4C2:
		move.l	#loc_3C636,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$30,$10(a1)
		subi.w	#$30,$14(a1)
		move.w	$10(a0),$44(a1)
		move.b	4(a0),4(a1)
		move.l	$C(a0),$C(a1)
		move.w	#-$3CD5,$A(a1)
		move.w	#$100,8(a1)
		move.b	#$20,7(a1)

loc_3C504:
		move.b	#8,6(a1)
		move.b	#6,$22(a1)
		bset	#7,$2A(a1)
		move.w	a0,$3C(a1)

loc_3C51A:
		move.b	#5,$40(a0)

loc_3C520:
		move.l	#loc_3C526,(a0)

loc_3C526:
		tst.b	4(a0)
		bpl.w	loc_3C60C
		move.l	#loc_3C534,(a0)

loc_3C534:

		move.b	($FFFFFE05).w,d0
		add.b	$32(a0),d0
		bne.w	loc_3C60C
		move.w	#0,$2E(a0)
		move.b	#1,$22(a0)
		move.l	#loc_3C552,(a0)

loc_3C552:
		subq.w	#1,$2E(a0)
		bpl.w	loc_3C60C
		move.w	$30(a0),$2E(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_3C5F4
		move.l	#loc_3C6CC,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		subi.w	#4,$14(a1)

loc_3C582:
		move.w	$14(a0),$46(a1)
		subi.w	#$44,$46(a1)
		move.b	4(a0),4(a1)
		move.l	$C(a0),$C(a1)
		move.w	#-$5CD5,$A(a1)
		move.w	#$80,8(a1)
		move.b	#8,7(a1)
		move.b	#$24,6(a1)
		move.b	#$C,$1E(a1)
		move.b	#2,$22(a1)
		move.w	#-$600,$1A(a1)

loc_3C5C4:
		addi.w	#6,$14(a1)
		move.b	$2C(a0),$2C(a1)
		move.w	a0,$3C(a1)
		moveq	#0,d0
		move.b	$23(a0),d0
		andi.w	#$E,d0
		move.w	word_3C612(pc,d0.w),d0
		lsl.l	#8,d0
		move.l	d0,$36(a1)
		addq.b	#2,$23(a0)
		moveq	#$67,d0
		jsr	(Play_Sound_2).l

loc_3C5F4:
		subq.b	#1,$34(a0)
		bpl.s	loc_3C60C
		move.b	$35(a0),$34(a0)
		move.l	#loc_3C622,(a0)
		move.b	#7,$24(a0)

loc_3C60C:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
word_3C612:	dc.w $100
		dc.w $E0
		dc.w $120
		dc.w $140
		dc.w $100
		dc.w $E0
		dc.w $C0
		dc.w $E0
; ---------------------------------------------------------------------------

loc_3C622:
		subq.b	#1,$24(a0)
		bpl.s	loc_3C60C
		move.b	#0,$22(a0)
		move.l	#loc_3C534,(a0)
		bra.s	loc_3C60C
; ---------------------------------------------------------------------------

loc_3C636:
		movea.w	$3C(a0),a1
		tst.b	$40(a1)
		bne.s	loc_3C694
		lea	(word_3C6BC).l,a2
		moveq	#3,d1

loc_3C648:
		jsr	(Create_New_Sprite3).l
		bne.w	loc_3C67C
		move.l	#Obj_Explosion,(a1)
		move.b	#6,5(a1)
		move.w	#-$8000,$A(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	(a2)+,d0
		add.w	d0,$10(a1)
		move.w	(a2)+,d0
		add.w	d0,$14(a1)

loc_3C67C:
		dbf	d1,loc_3C648
		move.w	#$7F00,$10(a0)
		move.w	$10(a0),$44(a0)
		moveq	#-$7F,d0
		jsr	(Play_Sound_2).l

loc_3C694:
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		move.w	$44(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------
word_3C6BC:	dc.w $FFE8
		dc.w 2
		dc.w $FFF8
		dc.w $FFFC
		dc.w 8
		dc.w 4
		dc.w $18
		dc.w $FFFE
; ---------------------------------------------------------------------------

loc_3C6CC:
		jsr	(MoveSprite2).l
		tst.w	$1A(a0)
		bpl.s	loc_3C6F4
		addi.w	#$18,$1A(a0)
		bmi.s	loc_3C740
		move.b	#3,$22(a0)
		move.b	#-$62,$28(a0)
		andi.w	#$7FFF,$A(a0)
		bra.s	loc_3C740
; ---------------------------------------------------------------------------

loc_3C6F4:
		addi.w	#$10,$1A(a0)
		tst.b	$2C(a0)
		bmi.s	loc_3C716

loc_3C700:
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_3C740
		add.w	d1,$14(a0)
		move.l	#loc_3C768,(a0)
		bra.s	loc_3C740
; ---------------------------------------------------------------------------

loc_3C716:
		movea.w	$3C(a0),a1
		tst.b	$40(a1)
		beq.s	loc_3C700
		move.w	$46(a0),d0
		sub.w	$14(a0),d0
		bcc.s	loc_3C740
		add.w	d0,$14(a0)
		move.l	#loc_3C768,(a0)
		subq.b	#1,$40(a1)
		bne.s	loc_3C740
		andi.b	#$7F,$2C(a1)

loc_3C740:

		move.w	$1A(a0),d0
		bpl.s	loc_3C748
		neg.w	d0

loc_3C748:
		cmpi.w	#$1D0,d0
		bcc.s	loc_3C756
		move.l	$36(a0),d0
		add.l	d0,$10(a0)

loc_3C756:
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_3C768:

		addq.w	#4,$14(a0)
		move.l	#Obj_Explosion,(a0)
		move.b	#6,5(a0)
		clr.b	$28(a0)
		clr.b	$29(a0)
		moveq	#-$4C,d0
		jsr	(Play_Sound_2).l
		jmp	(Obj_Explosion).l
; ---------------------------------------------------------------------------
Map_FBZMissileLauncher:include "Levels\FBZ\Misc Object Data\Map - Missile Launcher.asm"

; ---------------------------------------------------------------------------

Obj_FBZWallMissile:

		move.l	#Map_FBZWallMissile,$C(a0)
		move.w	#$232B,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#4,6(a0)
		move.w	#$280,8(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#2,d0
		move.w	d0,$2E(a0)
		move.w	d0,$30(a0)
		move.l	#loc_3C828,(a0)

loc_3C828:

		tst.b	4(a0)
		bpl.w	loc_3C8B0
		subq.w	#1,$2E(a0)
		bpl.s	loc_3C8B0
		move.w	$30(a0),$2E(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_3C89C
		move.l	#loc_3C8D4,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	4(a0),4(a1)
		move.l	$C(a0),$C(a1)
		move.w	#$232B,$A(a1)
		move.w	#$300,8(a1)
		move.b	#$10,7(a1)
		move.b	#4,6(a1)
		move.b	#-$65,$28(a1)
		move.w	#$400,$18(a1)
		btst	#0,$2A(a0)
		bne.s	loc_3C894
		neg.w	$18(a1)

loc_3C894:
		moveq	#$67,d0
		jsr	(Play_Sound_2).l

loc_3C89C:
		move.l	#loc_3C8B6,(a0)
		move.b	#7,$22(a0)
		move.b	#$1F,$24(a0)
		bra.s	loc_3C8B6
; ---------------------------------------------------------------------------

loc_3C8B0:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_3C8B6:

		subq.b	#1,$24(a0)
		bpl.s	loc_3C8CE
		move.b	#7,$24(a0)
		subq.b	#1,$22(a0)
		bne.s	loc_3C8CE
		move.l	#loc_3C828,(a0)

loc_3C8CE:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_3C8D4:
		move.b	($FFFFFE05).w,d0
		andi.b	#3,d0
		bne.s	loc_3C8E8
		addq.b	#1,$22(a0)
		andi.b	#1,$22(a0)

loc_3C8E8:
		tst.b	4(a0)
		bpl.s	loc_3C900
		jsr	(MoveSprite2).l
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_3C900:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
Map_FBZWallMissile:	include "Levels\FBZ\Misc Object Data\Map - Wall Missile.asm"

; ---------------------------------------------------------------------------

Obj_FBZMine:

		move.l	#Map_FBZMine,$C(a0)
		move.w	#$40A,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$C,7(a0)
		move.b	#4,6(a0)
		move.w	#$80,8(a0)
		move.l	#loc_3C972,(a0)

loc_3C972:
		lea	($FFFFB000).w,a1
		bsr.s	sub_3C984
		lea	($FFFFB04A).w,a1
		bsr.s	sub_3C984
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_3C984:

		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.s	locret_3C9BA
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$18,d0
		cmpi.w	#$20,d0
		bcc.s	locret_3C9BA
		tst.w	($FFFFFE08).w
		bne.s	locret_3C9BA
		move.w	#$1E,$30(a0)
		move.l	#loc_3C9BC,(a0)

locret_3C9BA:

		rts
; End of function sub_3C984

; ---------------------------------------------------------------------------

loc_3C9BC:
		addq.b	#1,$22(a0)
		andi.b	#1,$22(a0)
		subq.w	#1,$30(a0)
		bpl.s	loc_3C9DE
		move.l	#loc_3C9E4,(a0)
		move.b	#-$75,$28(a0)
		jsr	(Add_SpriteToCollisionResponseList).l

loc_3C9DE:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_3C9E4:
		move.l	#Obj_Explosion,(a0)
		move.b	#6,5(a0)
		clr.b	$28(a0)
		clr.b	$29(a0)
		moveq	#-$4C,d0
		jsr	(Play_Sound_2).l
		jmp	(Obj_Explosion).l
; ---------------------------------------------------------------------------
Map_FBZMine:	include "Levels\FBZ\Misc Object Data\Map - Mine.asm"

; ---------------------------------------------------------------------------

Obj_FBZElevator:

		move.l	#loc_3CA20,(a0)

loc_3CA20:
		subq.w	#1,$30(a0)
		bpl.s	loc_3CA8C
		move.w	#$5F,$30(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_3CA8C
		move.l	#loc_3CA92,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.l	#Map_FBZElevator,$C(a1)
		move.w	#$42D2,$A(a1)
		ori.b	#4,4(a1)
		move.b	#$30,7(a1)
		move.b	#$20,6(a1)
		move.w	#$80,8(a1)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#3,d0
		move.w	d0,$30(a1)
		move.w	#1,$1A(a1)
		btst	#0,$2A(a0)
		bne.s	loc_3CA8C
		neg.w	$1A(a1)

loc_3CA8C:

		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_3CA92:
		subq.w	#1,$30(a0)
		bpl.s	loc_3CA9E
		move.w	#$7F00,$10(a0)

loc_3CA9E:
		move.w	$1A(a0),d0
		add.w	d0,$14(a0)
		move.w	#$3B,d1
		move.w	#$10,d2
		move.w	$10(a0),d4
		lea	(byte_3CAD0).l,a2
		jsr	(sub_1DD0E).l
		tst.w	$1A(a0)
		bmi.s	loc_3CACA
		jsr	(CheckPlayerReleaseFromObj).l

loc_3CACA:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
byte_3CAD0:	dc.b  $10, $10,	$10, $10, $10, $10, $10, $11, $12, $12,	$13, $13, $13, $14, $14, $14, $15, $15,	$15, $16

		dc.b  $16, $16,	$17, $17, $17, $18, $18, $18, $19, $19,	$19, $1A, $1A, $1A, $1B, $1B, $1B, $1C,	$1C, $1C
		dc.b  $1D, $1D,	$1D, $1E, $1E, $1E, $1F, $1F, $1F, $20,	$20, $20, $21, $21, $21, $21, $21, $21,	$21, $21
Map_FBZElevator:include "Levels\FBZ\Misc Object Data\Map - Elevator.asm"

; ---------------------------------------------------------------------------

Obj_FBZTrapSpring:

		move.l	#Map_FBZTrapSpring,$C(a0)
		move.w	#$30F,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$80,8(a0)
		move.l	#loc_3CB66,(a0)

loc_3CB66:
		move.w	($FFFFB014).w,d0
		sub.w	$14(a0),d0
		bcs.s	loc_3CB7E

loc_3CB70:
		cmpi.w	#$20,d0
		blt.s	loc_3CB8A
		move.b	#1,$20(a0)
		bra.s	loc_3CB8A
; ---------------------------------------------------------------------------

loc_3CB7E:
		cmpi.w	#-$10,d0
		bge.s	loc_3CB8A
		move.b	#0,$20(a0)

loc_3CB8A:

		lea	($FFFFB000).w,a1
		bclr	#3,$2A(a0)
		beq.s	loc_3CB98

loc_3CB96:
		bsr.s	sub_3CBCE

loc_3CB98:
		lea	($FFFFB04A).w,a1
		bclr	#4,$2A(a0)
		beq.s	loc_3CBA6
		bsr.s	sub_3CBCE

loc_3CBA6:
		move.w	#$1B,d1
		move.w	#8,d2
		move.w	#9,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		lea	(Ani_FBZTrapSpring).l,a1
		jsr	(Animate_Sprite).l
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_3CBCE:

		move.w	#-$1000,$1A(a1)
		move.b	$2C(a0),d0
		btst	#1,d0
		beq.s	loc_3CBE4
		move.w	#-$A00,$1A(a1)

loc_3CBE4:
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		clr.b	$40(a1)
		clr.b	$3D(a1)
		move.b	#$10,$20(a1)
		move.b	#2,5(a1)
		btst	#0,d0
		beq.s	loc_3CC44
		move.w	#1,$1C(a1)
		move.b	#1,$27(a1)
		move.b	#0,$20(a1)
		move.b	#0,$30(a1)
		move.b	#4,$31(a1)
		btst	#1,d0
		bne.s	loc_3CC34
		move.b	#1,$30(a1)

loc_3CC34:
		btst	#0,$2A(a1)
		beq.s	loc_3CC44
		neg.b	$27(a1)
		neg.w	$1C(a1)

loc_3CC44:

		moveq	#-$4F,d0
		jmp	(Play_Sound_2).l
; End of function sub_3CBCE

; ---------------------------------------------------------------------------
Ani_FBZTrapSpring:	include "Levels\FBZ\Misc Object Data\Anim - Trap Spring.asm"

Map_FBZTrapSpring:include "Levels\FBZ\Misc Object Data\Map - Trap Spring.asm"

; ---------------------------------------------------------------------------

Obj_FBZFlamethrower:

		move.l	#Map_FBZFlameThrower,$C(a0)
		move.w	#$41D,$A(a0)
		move.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$180,8(a0)
		bset	#6,4(a0)
		move.w	#3,$16(a0)
		lea	$18(a0),a2
		move.w	$10(a0),d0
		addq.w	#8,d0
		move.w	d0,(a2)+
		move.w	$14(a0),d1
		move.w	d1,(a2)+
		move.w	#0,(a2)+
		move.w	$10(a0),(a2)+
		move.w	d1,(a2)+
		move.w	#$11,(a2)+
		subi.w	#$10,d0
		move.w	d0,(a2)+
		move.w	d1,(a2)+
		move.w	#$10,(a2)+
		move.b	#1,$22(a0)
		move.b	$2C(a0),d0
		bpl.s	loc_3CCFA
		move.b	#3,$22(a0)

loc_3CCFA:
		andi.b	#$40,d0
		beq.s	loc_3CD26
		move.w	#2,$16(a0)
		btst	#0,$2A(a0)
		beq.s	loc_3CD1C
		lea	$18(a0),a2
		subi.w	#$10,(a2)
		move.b	#$10,5(a2)

loc_3CD1C:
		move.l	#loc_3CDB0,(a0)
		bra.w	loc_3CDB0
; ---------------------------------------------------------------------------

loc_3CD26:
		move.l	#loc_3CD2C,(a0)

loc_3CD2C:
		cmpi.b	#2,$22(a0)
		beq.w	loc_3CD8E
		subq.b	#1,$34(a0)
		bpl.s	loc_3CD4C
		move.b	#2,$34(a0)
		addq.b	#1,$35(a0)
		andi.b	#3,$35(a0)

loc_3CD4C:
		move.b	($FFFFFE05).w,d0
		move.b	d0,d1
		andi.b	#3,d0
		bne.w	loc_3CD8E
		andi.b	#$F,d1
		bne.s	loc_3CD6E
		tst.b	4(a0)
		bpl.s	loc_3CD6E
		moveq	#-$3E,d0
		jsr	(Play_Sound_2).l

loc_3CD6E:

		tst.b	4(a0)
		bpl.w	loc_3CD8E
		subq.b	#4,$2E(a0)
		andi.b	#$7F,$2E(a0)
		bsr.w	sub_3CEC0
		ori.b	#-$80,$2E(a0)
		bsr.w	sub_3CEC0

loc_3CD8E:

		bsr.w	sub_3CE7A
		move.w	#$1B,d1
		move.w	#8,d2
		move.w	#9,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		bsr.s	sub_3CE1A
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_3CDB0:

		cmpi.b	#2,$22(a0)
		beq.w	loc_3CDFC
		subq.b	#1,$34(a0)
		bpl.s	loc_3CDD0
		move.b	#2,$34(a0)
		addq.b	#1,$35(a0)
		andi.b	#3,$35(a0)

loc_3CDD0:
		move.b	($FFFFFE05).w,d0
		move.b	d0,d1
		andi.b	#3,d0
		bne.w	loc_3CDFC
		andi.b	#$F,d1
		bne.s	loc_3CDEC
		moveq	#-$3E,d0
		jsr	(Play_Sound_2).l

loc_3CDEC:
		tst.b	4(a0)
		bpl.w	loc_3CDFC
		addq.b	#2,$2E(a0)
		bsr.w	sub_3CEC0

loc_3CDFC:

		move.w	#$1B,d1
		move.w	#8,d2
		move.w	#9,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		bsr.s	sub_3CE1A
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_3CE1A:

		tst.b	$2C(a0)
		bmi.s	locret_3CE42
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	loc_3CE44
		tst.w	$30(a0)
		bne.s	loc_3CE52
		move.w	#$3C,$30(a0)
		move.b	#2,$22(a0)
		move.b	#0,$2E(a0)

locret_3CE42:

		rts
; ---------------------------------------------------------------------------

loc_3CE44:
		move.w	#0,$30(a0)
		move.b	#1,$22(a0)
		rts
; ---------------------------------------------------------------------------

loc_3CE52:
		subq.w	#1,$30(a0)
		bne.s	locret_3CE42
		lea	($FFFFB000).w,a1
		bclr	#3,$2A(a0)
		beq.s	loc_3CE68
		bsr.w	sub_3CBCE

loc_3CE68:
		lea	($FFFFB04A).w,a1
		bclr	#4,$2A(a0)
		beq.s	locret_3CE78
		bsr.w	sub_3CBCE

locret_3CE78:
		rts
; End of function sub_3CE1A


; =============== S U B R O U T I N E =======================================


sub_3CE7A:
		move.b	$2E(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#5,d1
		move.w	d1,d0
		lea	$18(a0),a2
		move.w	$10(a0),d2
		add.w	d2,d1
		move.w	d1,(a2)
		neg.w	d0
		add.w	d2,d0
		move.w	d0,$C(a2)
		cmpi.b	#-$40,$2E(a0)
		bcs.s	loc_3CEB2
		move.b	#0,5(a2)
		move.b	#$10,$11(a2)
		rts
; ---------------------------------------------------------------------------

loc_3CEB2:
		move.b	#$10,5(a2)
		move.b	#0,$11(a2)
		rts
; End of function sub_3CE7A


; =============== S U B R O U T I N E =======================================


sub_3CEC0:

		jsr	(Create_New_Sprite3).l
		bne.w	locret_3CF4A
		move.l	#loc_3CF90,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		subq.w	#4,$14(a1)
		move.b	4(a0),4(a1)
		move.l	$C(a0),$C(a1)

loc_3CEEC:
		move.w	#$41D,$A(a1)
		move.w	#$200,8(a1)
		move.b	#$C,7(a1)
		move.b	#$C,6(a1)
		move.b	#-$68,$28(a1)
		bset	#4,$2B(a1)
		btst	#6,$2C(a0)
		bne.s	loc_3CF4C
		move.b	$2E(a0),d0
		bpl.s	loc_3CF24
		move.w	#$80,8(a1)

loc_3CF24:
		jsr	(GetSineCosine).l
		move.w	d1,d0
		asl.w	#2,d1
		move.w	d1,$18(a1)
		asr.w	#4,d0
		add.w	d0,$10(a1)
		move.b	$35(a0),$23(a1)
		move.b	#4,$24(a1)
		move.b	#$C,$20(a1)

locret_3CF4A:
		rts
; ---------------------------------------------------------------------------

loc_3CF4C:
		move.b	$2E(a0),d0
		jsr	(GetSineCosine).l
		move.w	d1,d2
		asr.w	#1,d2
		add.w	d2,d1
		addi.w	#$280,d1
		move.w	d1,$18(a1)
		addi.w	#$10,$10(a1)
		btst	#0,$2A(a0)
		beq.s	loc_3CF7C
		neg.w	$18(a1)
		subi.w	#$20,$10(a1)

loc_3CF7C:
		move.b	$35(a0),$23(a1)
		move.b	#4,$24(a1)
		move.b	#$C,$20(a1)
		rts
; End of function sub_3CEC0

; ---------------------------------------------------------------------------

loc_3CF90:
		subq.b	#1,$24(a0)
		bpl.s	loc_3CFA2
		move.b	#5,$24(a0)
		subq.b	#4,$20(a0)
		beq.s	loc_3CFCA

loc_3CFA2:
		addq.b	#1,$23(a0)
		andi.b	#3,$23(a0)
		move.b	$20(a0),d0
		add.b	$23(a0),d0
		move.b	d0,$22(a0)
		jsr	(MoveSprite2).l
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_3CFCA:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
Map_FBZFlameThrower:include "Levels\FBZ\Misc Object Data\Map - Flamethrower.asm"

; ---------------------------------------------------------------------------

Obj_FBZSpiderCrane:

		move.l	#Map_FBZSpiderCrane,$C(a0)
		move.w	#$2339,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$18,7(a0)
		move.b	#$60,6(a0)
		move.w	#$80,8(a0)
		move.w	$10(a0),$44(a0)
		move.w	$14(a0),$46(a0)
		bset	#6,4(a0)
		move.w	#1,$16(a0)
		lea	$18(a0),a2
		move.w	$10(a0),(a2)+
		move.w	$14(a0),(a2)+
		move.w	#0,(a2)+
		move.b	#$A,$22(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#2,d0
		move.w	d0,$38(a0)
		move.l	#loc_3D0F6,(a0)

loc_3D0F6:
		lea	($FFFFB000).w,a1
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.s	loc_3D118
		tst.w	($FFFFFE08).w
		bne.s	loc_3D118
		move.l	#loc_3D11E,(a0)

loc_3D118:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_3D11E:
		cmpi.w	#$40,$34(a0)
		bcc.s	loc_3D12A
		addq.w	#1,$34(a0)

loc_3D12A:
		move.w	$34(a0),d0
		add.w	$46(a0),d0
		move.w	d0,$14(a0)
		move.w	$14(a0),$1A(a0)
		move.w	$34(a0),d0
		addq.w	#7,d0
		lsr.w	#3,d0
		move.b	d0,$1D(a0)
		lea	($FFFFB000).w,a1
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.w	loc_3D1AC
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		subi.w	#5,d0
		cmpi.w	#$14,d0
		bcc.w	loc_3D1AC
		btst	#1,$2A(a1)
		bne.s	loc_3D1AC
		move.b	#$E,$20(a1)
		move.b	#-$3F,$2E(a1)
		clr.b	$3D(a1)
		moveq	#0,d0
		move.b	d0,$2A(a1)
		move.w	d0,$18(a1)
		move.w	d0,$1A(a1)
		move.b	$44(a1),$1E(a1)
		move.b	$45(a1),$1F(a1)
		move.l	#loc_3D1B2,(a0)

loc_3D1AC:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_3D1B2:
		move.w	$10(a0),($FFFFB010).w
		move.w	$14(a0),d0
		addi.w	#$10,d0
		move.w	d0,($FFFFB014).w
		jsr	(Create_New_Sprite3).l
		bne.w	loc_3D20E
		move.l	#loc_3D2F6,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	4(a0),4(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.w	#$280,8(a1)
		move.b	#$18,7(a1)
		move.b	#$18,6(a1)
		move.b	#$B,$22(a1)
		move.w	a1,$3C(a0)

loc_3D20E:
		move.b	#9,$22(a0)
		move.l	#loc_3D220,(a0)
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_3D220:
		tst.w	$34(a0)
		beq.s	loc_3D232
		subq.w	#1,$34(a0)
		bne.s	loc_3D232
		move.l	#loc_3D278,(a0)

loc_3D232:

		move.w	$34(a0),d0
		add.w	$46(a0),d0
		move.w	d0,$14(a0)
		move.w	$14(a0),$1A(a0)
		move.w	$34(a0),d0
		addq.w	#7,d0
		lsr.w	#3,d0
		move.b	d0,$1D(a0)
		movea.w	$3C(a0),a1
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	$10(a0),($FFFFB010).w
		move.w	$14(a0),d0
		addi.w	#$10,d0
		move.w	d0,($FFFFB014).w
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_3D278:
		tst.b	$36(a0)
		bne.s	loc_3D29C
		addi.l	#$1000,$30(a0)
		move.w	$10(a0),d0
		sub.w	$44(a0),d0
		cmp.w	$38(a0),d0
		blt.s	loc_3D2D2
		move.b	#1,$36(a0)
		bra.s	loc_3D2D2
; ---------------------------------------------------------------------------

loc_3D29C:
		subi.l	#$1000,$30(a0)
		bne.s	loc_3D2D2
		lea	($FFFFB000).w,a1
		move.b	#0,$20(a1)
		move.b	#0,$2E(a1)
		bset	#1,$2A(a1)
		move.l	#loc_3D2F6,(a0)
		move.b	#$A,$22(a0)
		movea.w	$3C(a0),a1
		move.b	#0,$22(a1)

loc_3D2D2:

		move.l	$30(a0),d0
		add.l	d0,$10(a0)
		move.w	$10(a0),$18(a0)
		movea.w	$3C(a0),a1
		move.w	$10(a0),$10(a1)
		move.w	$10(a0),($FFFFB010).w
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_3D2F6:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
Map_FBZSpiderCrane:include "Levels\FBZ\Misc Object Data\Map - Spider Crane.asm"

; ---------------------------------------------------------------------------

Obj_FBZMagneticPendulum:

		move.l	#loc_3D4C2,(a0)
		move.b	#4,4(a0)
		move.b	#$10,6(a0)
		move.b	#$10,7(a0)
		move.w	#$180,8(a0)
		move.w	#$2323,$A(a0)
		move.l	#Map_FBZMagneticPendulum,$C(a0)
		jsr	(Create_New_Sprite3).l
		bne.s	loc_3D496
		move.w	a1,$44(a0)
		move.l	#loc_3D736,(a1)
		move.w	$10(a0),$12(a1)
		move.w	$14(a0),$16(a1)
		move.w	a0,$46(a1)

loc_3D496:
		moveq	#-$80,d0
		tst.b	$2C(a0)
		bpl.s	loc_3D4A8
		addi.w	#$40,d0
		move.b	#1,$22(a0)

loc_3D4A8:
		move.w	$48(a0),d1
		beq.s	loc_3D4BE
		movea.w	d1,a1
		btst	#0,(a1)
		beq.s	loc_3D4BE
		st	$2E(a0)
		addi.w	#$80,d0

loc_3D4BE:

		move.b	d0,$26(a0)

loc_3D4C2:
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bls.s	loc_3D506
		move.w	$44(a0),d0
		beq.s	loc_3D4E0
		movea.w	d0,a1
		st	5(a1)

loc_3D4E0:
		move.w	$48(a0),d0
		beq.s	loc_3D500
		movea.w	d0,a1
		move.b	$26(a0),d0
		tst.b	$2C(a0)
		bmi.s	loc_3D4F6
		addi.b	#$40,d0

loc_3D4F6:
		moveq	#0,d1
		tst.b	d0
		bmi.s	loc_3D4FE
		moveq	#1,d1

loc_3D4FE:
		move.b	d1,(a1)

loc_3D500:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_3D506:
		lea	($FFFFB000).w,a2
		tst.b	$2F(a0)

loc_3D50E:
		beq.w	loc_3D730
		bmi.s	loc_3D542
		move.w	$18(a2),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$10(a2)
		move.w	$1A(a2),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$14(a2)
		subq.b	#1,$2F(a0)
		bne.w	loc_3D730
		clr.b	$2E(a2)
		bclr	#1,$2A(a2)
		bra.w	loc_3D730
; ---------------------------------------------------------------------------

loc_3D542:
		move.w	$30(a0),d0
		add.w	d0,$26(a0)
		moveq	#6,d1
		move.b	$26(a0),d0
		subi.b	#$40,d0
		bmi.s	loc_3D558
		neg.w	d1

loc_3D558:
		add.w	d1,$30(a0)
		move.b	$26(a0),d0
		tst.b	$2C(a0)
		bpl.s	loc_3D594
		tst.w	$30(a0)
		bpl.s	loc_3D580
		tst.b	d0
		bpl.w	loc_3D640
		cmpi.b	#-$40,d0
		bhi.w	loc_3D640
		moveq	#-$40,d0
		moveq	#0,d1
		bra.s	loc_3D5C4
; ---------------------------------------------------------------------------

loc_3D580:
		tst.b	d0
		bmi.w	loc_3D640
		cmpi.b	#$40,d0
		bcs.w	loc_3D640
		moveq	#$40,d0
		moveq	#-1,d1
		bra.s	loc_3D5C4
; ---------------------------------------------------------------------------

loc_3D594:
		addi.b	#$40,d0
		tst.w	$30(a0)
		bpl.s	loc_3D5B2
		tst.b	d0
		bpl.w	loc_3D640
		cmpi.b	#-$40,d0
		bhi.w	loc_3D640
		moveq	#-$80,d0
		moveq	#0,d1
		bra.s	loc_3D5C4
; ---------------------------------------------------------------------------

loc_3D5B2:
		tst.b	d0
		bmi.w	loc_3D640
		cmpi.b	#$40,d0
		bcs.w	loc_3D640
		moveq	#0,d0
		moveq	#-1,d1

loc_3D5C4:

		move.b	d0,$26(a0)
		clr.b	$27(a0)
		move.b	d1,$2E(a0)
		clr.b	$2F(a0)
		moveq	#-$62,d0
		jsr	(Play_Sound_2).l
		tst.b	$32(a0)
		beq.w	loc_3D730
		clr.b	$32(a0)
		move.b	#1,$2F(a0)
		moveq	#0,d0
		move.w	$30(a0),d0
		bpl.s	loc_3D5F8
		neg.w	d0

loc_3D5F8:
		lsl.l	#8,d0
		divu.w	#$51,d0
		cmpi.w	#$100,d0
		bcc.s	loc_3D608
		move.w	#$100,d0

loc_3D608:
		tst.b	$2C(a0)
		bpl.s	loc_3D628
		clr.w	$1A(a2)
		neg.w	d0
		move.w	d0,$18(a2)
		move.w	d0,$1C(a2)
		tst.b	$26(a0)
		bmi.s	loc_3D648
		neg.w	$1C(a2)
		bra.s	loc_3D648
; ---------------------------------------------------------------------------

loc_3D628:
		clr.w	$18(a2)
		move.w	d0,$1A(a2)
		move.w	d0,$1C(a2)
		tst.b	$26(a0)
		bpl.s	loc_3D648
		neg.w	$1C(a2)
		bra.s	loc_3D648
; ---------------------------------------------------------------------------

loc_3D640:

		tst.b	$32(a0)
		beq.w	loc_3D730

loc_3D648:

		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		swap	d1
		clr.w	d1
		asr.l	#1,d1
		move.l	d1,d3
		asr.l	#3,d3
		add.l	d3,d1
		swap	d0
		clr.w	d0
		asr.l	#1,d0
		move.l	d0,d2
		asr.l	#3,d2
		add.l	d2,d0
		btst	#2,$2A(a2)
		bne.s	loc_3D67C
		asr.l	#2,d3
		add.l	d3,d1
		asr.l	#2,d2
		add.l	d2,d0
		bra.s	loc_3D684
; ---------------------------------------------------------------------------

loc_3D67C:
		asr.l	#4,d3
		sub.l	d3,d1
		asr.l	#4,d2
		sub.l	d2,d0

loc_3D684:
		swap	d1
		add.w	$10(a0),d1
		move.w	d1,$10(a2)
		swap	d0
		add.w	$14(a0),d0
		move.w	d0,$14(a2)
		move.b	$26(a0),d0
		addi.b	#$40,d0
		move.b	d0,$26(a2)
		tst.b	$32(a0)
		beq.w	loc_3D730
		move.b	$26(a0),d0
		addi.b	#$40,d0
		jsr	(GetSineCosine).l
		tst.w	$30(a0)
		bpl.s	loc_3D6C4
		neg.w	d1
		neg.w	d0

loc_3D6C4:
		move.w	d1,$18(a2)
		move.w	d0,$1A(a2)
		move.b	($FFFFF603).w,d0
		andi.w	#$70,d0
		beq.s	loc_3D730
		clr.b	$32(a0)
		clr.b	$2E(a2)
		clr.b	$3D(a2)
		bset	#1,$2A(a2)
		move.b	#1,$40(a2)
		bset	#2,$2A(a2)
		move.b	#2,$20(a2)
		move.b	#$E,$1E(a2)
		move.b	#7,$1F(a2)
		clr.w	$1C(a2)
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		move.w	d1,d3
		lsl.w	#3,d1
		sub.w	d3,d1
		move.w	d1,$18(a2)
		move.w	d0,d2
		lsl.w	#3,d0
		sub.w	d2,d0
		move.w	d0,$1A(a2)
		moveq	#$62,d0
		jsr	(Play_Sound_2).l

loc_3D730:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_3D736:
		move.l	#loc_3D78C,(a0)
		move.b	#4,4(a0)
		move.b	#$10,6(a0)
		move.b	#$10,7(a0)
		move.w	#$180,8(a0)
		move.w	#$2323,$A(a0)
		move.l	#Map_FBZMagneticPendulum,$C(a0)
		move.b	#3,$22(a0)
		jsr	(Create_New_Sprite3).l
		bne.s	loc_3D78C
		move.w	a1,$44(a0)
		move.l	#loc_3D908,(a1)
		move.w	$12(a0),$10(a1)
		move.w	$16(a0),$14(a1)
		move.w	$46(a0),$46(a1)

loc_3D78C:

		tst.b	5(a0)
		beq.s	loc_3D7A4
		move.w	$44(a0),d0
		beq.s	loc_3D79E
		movea.w	d0,a1
		st	5(a1)

loc_3D79E:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_3D7A4:
		movea.w	$46(a0),a1
		move.b	$26(a1),d0
		jsr	(GetSineCosine).l
		swap	d1
		clr.w	d1
		asr.l	#1,d1
		move.l	d1,d3
		asr.l	#3,d3
		sub.l	d3,d1
		swap	d1
		add.w	$12(a0),d1
		move.w	d1,$10(a0)
		swap	d0
		clr.w	d0
		asr.l	#1,d0
		move.l	d0,d3
		asr.l	#3,d3
		sub.l	d3,d0
		swap	d0
		add.w	$16(a0),d0
		move.w	d0,$14(a0)
		tst.b	$2F(a1)
		bne.w	loc_3D902
		lea	($FFFFB000).w,a2
		tst.b	$2E(a2)
		bne.w	loc_3D902
		cmpi.b	#4,5(a2)
		bcc.w	loc_3D902
		tst.w	($FFFFFE08).w
		bne.w	loc_3D902
		tst.b	$2C(a1)
		bpl.s	loc_3D87A
		tst.w	$18(a2)
		bmi.w	loc_3D902
		move.w	$10(a0),d0
		subq.w	#8,d0
		cmp.w	$10(a2),d0
		bhi.w	loc_3D902
		addi.w	#$18,d0
		cmp.w	$10(a2),d0
		bcs.w	loc_3D902
		moveq	#$1D,d0
		moveq	#$21,d1
		btst	#2,$2A(a2)
		bne.s	loc_3D848
		moveq	#$22,d0
		moveq	#$26,d1
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_3D848
		moveq	#$1E,d0
		moveq	#$22,d1

loc_3D848:

		tst.b	$2E(a1)
		beq.s	loc_3D858
		subq.w	#1,d0
		neg.w	d0
		subq.w	#1,d1
		neg.w	d1
		exg	d0,d1

loc_3D858:
		move.w	$14(a0),d2
		sub.w	d0,d2
		cmp.w	$14(a2),d2
		bcs.w	loc_3D902
		move.w	$14(a0),d2
		sub.w	d1,d2
		cmp.w	$14(a2),d2
		bhi.w	loc_3D902
		move.w	$18(a2),d0
		bra.s	loc_3D8E2
; ---------------------------------------------------------------------------

loc_3D87A:
		tst.w	$1A(a2)
		bpl.w	loc_3D902
		move.w	$14(a0),d0
		addq.w	#8,d0
		cmp.w	$14(a2),d0
		bcs.s	loc_3D902
		subi.w	#$18,d0
		cmp.w	$14(a2),d0
		bhi.s	loc_3D902
		moveq	#$1D,d0
		moveq	#$21,d1
		btst	#2,$2A(a2)
		bne.s	loc_3D8B4
		moveq	#$22,d0
		moveq	#$26,d1
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_3D8B4
		moveq	#$1E,d0
		moveq	#$22,d1

loc_3D8B4:

		tst.b	$2E(a1)
		beq.s	loc_3D8C4
		subq.w	#1,d0
		neg.w	d0
		subq.w	#1,d1
		neg.w	d1
		exg	d0,d1

loc_3D8C4:
		move.w	$10(a0),d2
		sub.w	d0,d2
		cmp.w	$10(a2),d2
		bcs.s	loc_3D902
		move.w	$10(a0),d2
		sub.w	d1,d2
		cmp.w	$10(a2),d2
		bhi.s	loc_3D902
		move.w	$1A(a2),d0
		neg.w	d0

loc_3D8E2:
		mulu.w	#$51,d0
		lsr.l	#8,d0
		tst.b	$2E(a1)
		beq.s	loc_3D8F0
		neg.w	d0

loc_3D8F0:
		st	$2F(a1)
		move.w	d0,$30(a1)
		st	$32(a1)
		move.b	#1,$2E(a2)

loc_3D902:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_3D908:
		move.l	#loc_3D93A,(a0)

loc_3D90E:
		move.b	#$44,4(a0)
		move.b	#$70,6(a0)
		move.b	#$70,7(a0)
		move.w	#$180,8(a0)
		move.w	#$2323,$A(a0)
		move.l	#Map_FBZMagneticPendulum,$C(a0)
		move.w	#5,$16(a0)

loc_3D93A:
		tst.b	5(a0)
		beq.s	loc_3D946
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_3D946:
		movea.w	$46(a0),a1
		move.w	$10(a0),d3
		swap	d3
		clr.w	d3
		move.w	$14(a0),d2
		swap	d2
		clr.w	d2
		move.b	$26(a1),d0
		jsr	(GetSineCosine).l
		swap	d1
		clr.w	d1
		asr.l	#4,d1
		swap	d0
		clr.w	d0
		asr.l	#4,d0
		add.l	d1,d3
		add.l	d0,d2
		move.l	d1,d5
		move.l	d0,d4
		asr.l	#2,d5
		asr.l	#2,d4
		add.l	d5,d3
		add.l	d4,d2
		asr.l	#2,d5
		asr.l	#2,d4
		add.l	d5,d1
		add.l	d4,d0
		lea	$18(a0),a1
		moveq	#4,d4

loc_3D98E:
		swap	d3
		swap	d2
		move.w	d3,(a1)+
		move.w	d2,(a1)+
		addq.w	#1,a1
		move.b	#2,(a1)+
		swap	d3
		swap	d2
		add.l	d1,d3
		add.l	d0,d2
		dbf	d4,loc_3D98E
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Map_FBZMagneticPendulum:include "Levels\FBZ\Misc Object Data\Map - Magnetic Pendulum.asm"

; ---------------------------------------------------------------------------

Obj_MHZ_Pollen_Spawner:
		cmpi.b	#$10,($FFFFF7C0).w
		bcc.s	locret_3DA22
		lea	$2E(a0),a3
		lea	($FFFFB000).w,a2
		bsr.s	sub_3DA24
		lea	($FFFFB04A).w,a2
		tst.b	4(a2)
		bpl.s	locret_3DA22
		lea	$30(a0),a3
		bsr.s	sub_3DA24

locret_3DA22:

		rts

; =============== S U B R O U T I N E =======================================


sub_3DA24:

		cmpi.b	#$C,$46(a2)
		bne.s	locret_3DA22
		btst	#1,$2A(a2)
		bne.w	loc_3DAC4
		jsr	(Random_Number).l
		andi.w	#3,d0
		bne.s	locret_3DA22
		move.w	(a3),d2
		beq.s	loc_3DA58
		move.w	#0,(a3)
		btst	#3,$2A(a2)
		bne.s	loc_3DA58
		cmpi.w	#$400,d2
		bcc.s	loc_3DACA

loc_3DA58:

		move.w	$18(a2),d2
		bpl.s	loc_3DA60
		neg.w	d2

loc_3DA60:
		cmpi.w	#$500,d2
		bcs.s	locret_3DAC2
		jsr	(Create_New_Sprite3).l
		bne.s	locret_3DAC2
		bsr.w	sub_3DB68
		ori.b	#4,4(a1)
		move.w	#0,8(a1)
		move.b	#4,7(a1)
		move.b	#4,6(a1)
		move.w	$10(a2),$10(a1)
		move.w	$14(a2),$14(a1)
		addi.w	#$10,$14(a1)
		subi.w	#$500,d2
		lsr.w	#4,d2
		addi.w	#$200,d2
		neg.w	d2
		move.w	d2,$1A(a1)
		swap	d0
		andi.w	#3,d0
		addq.w	#2,d0
		move.w	d0,$34(a1)
		move.l	#Obj_MHZ_Pollen,(a1)
		addq.b	#1,($FFFFF7C0).w

locret_3DAC2:

		rts
; ---------------------------------------------------------------------------

loc_3DAC4:
		move.w	$1A(a2),(a3)
		rts
; ---------------------------------------------------------------------------

loc_3DACA:
		move.w	#$100,d2
		lea	(word_3DB50).l,a4
		moveq	#5,d6

loc_3DAD6:
		jsr	(Create_New_Sprite3).l
		bne.s	loc_3DB4A
		bsr.w	sub_3DB68
		ori.b	#4,4(a1)
		move.w	#0,8(a1)
		move.b	#4,7(a1)
		move.b	#4,6(a1)
		move.w	$10(a2),$10(a1)
		move.w	$14(a2),$14(a1)
		addi.w	#$18,$14(a1)
		jsr	(Random_Number).l
		move.w	d0,$26(a1)
		andi.w	#$1FF,d0
		subi.w	#$100,d0
		add.w	(a4)+,d0
		move.w	d0,$18(a1)
		swap	d0
		andi.w	#$FF,d0
		add.w	d2,d0
		sub.w	(a4)+,d0
		neg.w	d0
		move.w	d0,$1A(a1)
		swap	d0
		andi.w	#3,d0
		addq.w	#2,d0
		move.w	d0,$34(a1)
		move.l	#loc_3DC18,(a1)
		addq.b	#1,($FFFFF7C0).w

loc_3DB4A:
		dbf	d6,loc_3DAD6
		rts
; End of function sub_3DA24

; ---------------------------------------------------------------------------
word_3DB50:	dc.w	$80,  $100
		dc.w   $100,   $C0
		dc.w   $180,   $80
		dc.w  $FF80,  $100
		dc.w  $FF00,   $C0
		dc.w  $FE80,   $80

; =============== S U B R O U T I N E =======================================


sub_3DB68:

		tst.b	($FFFFF7C1).w
		bne.s	loc_3DB7E
		move.l	#Map_MHZPollen,$C(a1)
		move.w	#-$1C98,$A(a1)
		rts
; ---------------------------------------------------------------------------

loc_3DB7E:
		move.b	$32(a0),d0
		addq.b	#1,$32(a0)
		andi.w	#7,d0
		move.b	byte_3DBB0(pc,d0.w),d0
		bne.s	loc_3DBA0
		move.l	#Map_MHZBigLeaves,$C(a1)
		move.w	#-$1C9D,$A(a1)
		rts
; ---------------------------------------------------------------------------

loc_3DBA0:
		move.l	#Map_MHZPollen,$C(a1)
		move.w	#-$1C9D,$A(a1)
		rts
; End of function sub_3DB68

; ---------------------------------------------------------------------------
byte_3DBB0:	dc.b 0
		dc.b 0
		dc.b 1
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 1
		dc.b 1
; ---------------------------------------------------------------------------

Obj_MHZ_Pollen:
		jsr	(MoveSprite2).l
		move.w	$34(a0),d0
		add.w	d0,d0
		add.w	d0,d0
		add.w	d0,$1A(a0)
		bmi.s	loc_3DBD8
		move.l	#loc_3DBE0,(a0)
		move.b	($FFFFFE05).w,$26(a0)

loc_3DBD8:
		bsr.s	sub_3DC3A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_3DBE0:

		move.b	$26(a0),d0
		addq.b	#4,$26(a0)
		jsr	(GetSineCosine).l
		move.w	d0,$18(a0)
		jsr	(MoveSprite2).l
		move.w	$34(a0),d0
		add.w	d0,$1A(a0)
		tst.b	4(a0)
		bmi.s	loc_3DC10
		move.w	#$7F00,$10(a0)
		subq.b	#1,($FFFFF7C0).w

loc_3DC10:
		bsr.s	sub_3DC3A
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_3DC18:
		jsr	(MoveSprite2).l
		move.w	$34(a0),d0
		add.w	d0,d0
		add.w	d0,d0
		add.w	d0,$1A(a0)
		bmi.s	loc_3DC32
		move.l	#loc_3DBE0,(a0)

loc_3DC32:
		bsr.s	sub_3DC3A
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_3DC3A:

		subq.b	#1,$24(a0)
		bpl.s	locret_3DC5A
		move.b	#7,$24(a0)
		addq.b	#1,$22(a0)
		andi.b	#1,$22(a0)
		tst.w	$18(a0)
		bpl.s	locret_3DC5A
		addq.b	#2,$22(a0)

locret_3DC5A:

		rts
; End of function sub_3DC3A

; ---------------------------------------------------------------------------
Map_MHZPollen:	include "Levels\MHZ\Misc Object Data\Map - Pollen Leaves.asm"

Map_MHZBigLeaves:	include "Levels\MHZ\Misc Object Data\Map - Big Leaves.asm"

; ---------------------------------------------------------------------------

Obj_03_2:
		move.b	#-$30,7(a0)
		btst	#0,$2A(a0)
		beq.s	loc_3DCB4
		move.l	#loc_3DE6A,(a0)
		bra.w	loc_3DE6A
; ---------------------------------------------------------------------------

loc_3DCB4:
		move.l	#loc_3DCBA,(a0)

loc_3DCBA:
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.s	sub_3DCD0
		lea	($FFFFB04A).w,a1
		addq.b	#1,d6
		bsr.s	sub_3DCD0
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_3DCD0:

		btst	d6,$2A(a0)
		bne.w	loc_3DD9E
		btst	#1,$2A(a1)
		bne.w	locret_3DD9C
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		tst.w	$18(a1)
		beq.w	locret_3DD9C
		bmi.s	loc_3DD48
		cmpi.w	#-$30,d0
		bgt.w	locret_3DD9C
		cmpi.w	#-$40,d0
		blt.w	locret_3DD9C
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		addi.w	#$30,d1
		cmpi.w	#$20,d1
		bcc.w	locret_3DD9C
		tst.b	$2E(a1)
		bne.s	locret_3DD9C
		bclr	#0,$2A(a1)
		jsr	(RideObject_SetRide).l
		move.b	#-$80,$2D(a1)
		move.w	#$14,$32(a1)
		move.w	$1C(a1),d0
		cmpi.w	#$600,d0
		bcc.s	locret_3DD9C
		move.w	#$600,$1C(a1)
		rts
; ---------------------------------------------------------------------------

loc_3DD48:
		cmpi.w	#$30,d0
		blt.s	locret_3DD9C
		cmpi.w	#$40,d0
		bgt.s	locret_3DD9C
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		subi.w	#$10,d1
		cmpi.w	#$20,d1
		bcc.s	locret_3DD9C
		tst.b	$2E(a1)
		bne.s	locret_3DD9C
		bset	#0,$2A(a1)
		jsr	(RideObject_SetRide).l
		move.b	#-$80,$27(a1)
		move.b	#-$80,$2D(a1)
		move.w	$1C(a1),d0
		neg.w	d0
		cmpi.w	#$600,d0
		bcc.s	locret_3DD9C
		move.w	#-$600,$1C(a1)
		move.w	#$14,$32(a1)

locret_3DD9C:

		rts
; ---------------------------------------------------------------------------

loc_3DD9E:
		move.w	$1C(a1),d0
		bpl.s	loc_3DDA6
		neg.w	d0

loc_3DDA6:
		cmpi.w	#$500,d0
		bcs.s	loc_3DE12
		btst	#1,$2A(a1)
		bne.s	loc_3DE18
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$40,d0
		bmi.s	loc_3DDF4
		cmpi.w	#$80,d0
		bcs.s	loc_3DE36
		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		move.b	#-$80,$26(a1)
		move.b	#0,$27(a1)
		move.b	#0,$2D(a1)
		neg.w	$1C(a1)
		neg.w	$18(a1)
		bset	#0,$2A(a1)
		rts
; ---------------------------------------------------------------------------

loc_3DDF4:
		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		move.b	#0,$26(a1)
		move.b	#0,$27(a1)
		move.b	#0,$2D(a1)
		rts
; ---------------------------------------------------------------------------

loc_3DE12:
		move.b	#0,$27(a1)

loc_3DE18:
		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		move.b	#0,$30(a1)
		move.b	#4,$31(a1)
		move.b	#0,$2D(a1)
		rts
; ---------------------------------------------------------------------------

loc_3DE36:
		btst	#3,$2A(a1)
		beq.w	locret_3DD9C
		move.w	d0,d2
		addi.b	#-$80,d0
		jsr	(GetSineCosine).l
		move.w	d1,d3
		asr.w	#4,d1
		add.w	$14(a0),d1
		moveq	#0,d0
		move.b	$1E(a1),d0
		muls.w	d3,d0
		asr.w	#8,d0
		add.w	d0,d1
		move.w	d1,$14(a1)
		move.b	d2,$27(a1)
		rts
; End of function sub_3DCD0

; ---------------------------------------------------------------------------

loc_3DE6A:

		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.s	sub_3DE80
		lea	($FFFFB04A).w,a1
		addq.b	#1,d6
		bsr.s	sub_3DE80
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_3DE80:

		btst	d6,$2A(a0)
		bne.w	loc_3DF48
		btst	#1,$2A(a1)
		bne.w	locret_3DEF2
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		tst.w	$18(a1)
		beq.w	locret_3DEF2
		bpl.s	loc_3DEF4
		cmpi.w	#$30,d0
		blt.s	locret_3DEF2
		cmpi.w	#$40,d0
		bgt.s	locret_3DEF2
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		addi.w	#$30,d1
		cmpi.w	#$20,d1
		bcc.s	locret_3DEF2
		tst.b	$2E(a1)
		bne.s	locret_3DEF2
		bset	#0,$2A(a1)
		jsr	(RideObject_SetRide).l
		move.b	#-$7C,$2D(a1)
		move.w	#$14,$32(a1)
		move.w	$1C(a1),d0
		neg.w	d0
		cmpi.w	#$600,d0
		bcc.s	locret_3DEF2
		move.w	#-$600,$1C(a1)

locret_3DEF2:

		rts
; ---------------------------------------------------------------------------

loc_3DEF4:
		cmpi.w	#-$30,d0
		bgt.s	locret_3DEF2
		cmpi.w	#-$40,d0
		blt.s	locret_3DEF2
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		subi.w	#$10,d1
		cmpi.w	#$20,d1
		bcc.s	locret_3DEF2
		tst.b	$2E(a1)
		bne.s	locret_3DEF2
		bclr	#0,$2A(a1)
		jsr	(RideObject_SetRide).l
		move.b	#-$80,$27(a1)
		move.b	#-$7C,$2D(a1)
		move.w	$1C(a1),d0
		cmpi.w	#$600,d0
		bcc.s	locret_3DEF2
		move.w	#$600,$1C(a1)
		move.w	#$14,$32(a1)
		rts
; ---------------------------------------------------------------------------

loc_3DF48:
		move.w	$1C(a1),d0
		bpl.s	loc_3DF50
		neg.w	d0

loc_3DF50:
		cmpi.w	#$500,d0
		bcs.s	loc_3DFBE
		btst	#1,$2A(a1)
		bne.s	loc_3DFC4
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$40,d0
		bmi.s	loc_3DF92
		cmpi.w	#$80,d0
		bcs.w	loc_3DFE2
		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		move.b	#0,$26(a1)
		move.b	#0,$27(a1)
		move.b	#0,$2D(a1)
		rts
; ---------------------------------------------------------------------------

loc_3DF92:
		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		move.b	#-$80,$26(a1)
		move.b	#0,$27(a1)
		move.b	#0,$2D(a1)
		neg.w	$1C(a1)
		neg.w	$18(a1)
		bclr	#0,$2A(a1)
		rts
; ---------------------------------------------------------------------------

loc_3DFBE:
		move.b	#0,$27(a1)

loc_3DFC4:
		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		move.b	#0,$30(a1)
		move.b	#4,$31(a1)
		move.b	#0,$2D(a1)
		rts
; ---------------------------------------------------------------------------

loc_3DFE2:
		btst	#3,$2A(a1)
		beq.w	locret_3DEF2
		move.w	d0,d2
		jsr	(GetSineCosine).l
		move.w	d1,d3
		asr.w	#4,d1
		add.w	$14(a0),d1
		moveq	#0,d0
		move.b	$1E(a1),d0
		muls.w	d3,d0
		asr.w	#8,d0
		add.w	d0,d1
		move.w	d1,$14(a1)

loc_3E00C:
		subi.b	#-$80,d2
		neg.b	d2
		move.b	d2,$27(a1)
		rts
; End of function sub_3DE80

; ---------------------------------------------------------------------------

Obj_MHZMushroomCap:

		move.w	#$80,8(a0)
		move.b	$2C(a0),d0
		bpl.s	loc_3E02A
		move.w	#$300,8(a0)

loc_3E02A:
		move.b	d0,d1
		move.w	#-$3C97,$A(a0)
		andi.b	#1,d0
		beq.s	loc_3E044
		move.w	#-$3C67,$A(a0)
		move.b	#$14,$36(a0)

loc_3E044:
		add.b	d1,d1
		bpl.s	loc_3E04E
		andi.w	#$7FFF,$A(a0)

loc_3E04E:
		move.l	#Map_MHZMushroomCap,$C(a0)
		ori.b	#4,4(a0)
		move.b	#$20,7(a0)
		move.b	#$10,6(a0)
		bset	#7,$2A(a0)
		move.w	$10(a0),$38(a0)
		move.w	$14(a0),$3A(a0)
		move.l	#loc_3E080,(a0)

loc_3E080:
		lea	(Ani_MHZMushroomCap).l,a1
		jsr	(Animate_Sprite).l
		tst.b	5(a0)
		beq.s	loc_3E0A2
		move.w	#0,$20(a0)
		move.b	#0,$23(a0)
		clr.b	5(a0)

loc_3E0A2:
		bsr.s	sub_3E0DE
		move.w	#$18,d1
		moveq	#0,d3
		move.b	$22(a0),d3
		move.b	byte_3E0DA(pc,d3.w),d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		lea	($FFFFB000).w,a1
		moveq	#$30,d5
		moveq	#3,d6
		bsr.w	sub_3E172
		lea	($FFFFB04A).w,a1
		moveq	#$32,d5
		moveq	#4,d6
		bsr.w	sub_3E172
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
byte_3E0DA:	dc.b $12
		dc.b 8
		dc.b $12
		dc.b $12

; =============== S U B R O U T I N E =======================================


sub_3E0DE:
		moveq	#0,d0
		move.b	($FFFFF7FF).w,d0
		add.b	$36(a0),d0
		lea	byte_3E106(pc,d0.w),a1
		move.b	(a1)+,d0
		ext.w	d0
		add.w	$38(a0),d0
		move.w	d0,$10(a0)
		move.b	(a1)+,d1
		ext.w	d1
		add.w	$3A(a0),d1
		move.w	d1,$14(a0)
		rts
; End of function sub_3E0DE

; ---------------------------------------------------------------------------
byte_3E106:	dc.b	0,   0
		dc.b	0,   0
		dc.b	0,   0
		dc.b	0,   0
		dc.b  $FF,   0
		dc.b  $FF,   0
		dc.b  $FF,   0
		dc.b  $FE,   0
		dc.b  $FE,   0
		dc.b  $FE,   0
		dc.b  $FD,   1
		dc.b  $FD,   1
		dc.b  $FD,   1
		dc.b  $FD,   1
		dc.b  $FD,   1
		dc.b  $FD,   1
		dc.b  $FE,   0
		dc.b  $FE,   0
		dc.b  $FE,   0
		dc.b  $FF,   0
		dc.b  $FF,   0
		dc.b  $FF,   0
		dc.b	0,   0
		dc.b	0,   0
		dc.b	0,   0
		dc.b	0,   0
		dc.b	1,   0
		dc.b	1,   0
		dc.b	1,   0
		dc.b	2,   0
		dc.b	2,   0
		dc.b	2,   0
		dc.b	3,   1
		dc.b	3,   1
		dc.b	3,   1
		dc.b	3,   1
		dc.b	3,   1
		dc.b	3,   1
		dc.b	2,   0
		dc.b	2,   0
		dc.b	2,   0
		dc.b	1,   0
		dc.b	1,   0
		dc.b	1,   0
		dc.b	0,   0
		dc.b	0,   0
		dc.b	0,   0
		dc.b	0,   0
		dc.b  $FF,   0
		dc.b  $FF,   0
		dc.b  $FF,   0
		dc.b  $FE,   0
		dc.b  $FE,   0
		dc.b  $FE,   0

; =============== S U B R O U T I N E =======================================


sub_3E172:

		btst	d6,$2A(a0)
		bne.s	loc_3E180
		move.w	$1A(a1),(a0,d5.w)
		rts
; ---------------------------------------------------------------------------

loc_3E180:
		move.b	#1,$20(a0)
		cmpi.b	#3,$22(a0)
		bne.s	locret_3E1D8
		move.w	(a0,d5.w),d0
		move.w	#$660,d1
		cmp.w	d1,d0
		blt.s	loc_3E1A6
		move.w	#$760,d1
		cmp.w	d1,d0
		blt.s	loc_3E1A6
		move.w	#$860,d1

loc_3E1A6:

		addi.w	#$20,d1
		neg.w	d1
		move.w	d1,$1A(a1)
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		clr.b	$40(a1)
		clr.b	$3D(a1)
		move.b	#$10,$20(a1)
		move.b	#2,5(a1)
		moveq	#-$79,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

locret_3E1D8:
		rts
; End of function sub_3E172

; ---------------------------------------------------------------------------
Ani_MHZMushroomCap:	include "Levels\MHZ\Misc Object Data\Anim - Mushroom Cap.asm"

Map_MHZMushroomCap:include "Levels\MHZ\Misc Object Data\Map - Mushroom Cap.asm"

; ---------------------------------------------------------------------------

Obj_MHZPulleyLift:

		move.l	#Map_MHZPulleyLift,$C(a0)
		move.w	#$424,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#$40,7(a0)
		move.b	#-$80,6(a0)
		bset	#6,4(a0)
		move.w	$14(a0),$3C(a0)
		moveq	#3,d1
		move.w	d1,$16(a0)
		subq.b	#1,d1
		lea	$18(a0),a2
		lea	word_3E29E(pc),a3

loc_3E280:
		move.w	(a3)+,d0
		add.w	$10(a0),d0
		move.w	d0,(a2)+
		move.w	(a3)+,d0
		add.w	$14(a0),d0
		move.w	d0,(a2)+
		move.w	(a3)+,(a2)+
		dbf	d1,loc_3E280
		move.b	#4,$22(a0)
		bra.s	loc_3E2B0
; ---------------------------------------------------------------------------
word_3E29E:	dc.w	  0,   $40,	0
		dc.w  $FFF0,   $78,	5
		dc.w	$10,   $78,	6
; ---------------------------------------------------------------------------

loc_3E2B0:
		jsr	(Create_New_Sprite3).l
		bne.w	loc_3E378
		move.l	#loc_3E472,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	$10(a0),$2E(a1)
		subi.w	#$32,$10(a1)
		addi.w	#$3A,$14(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		ori.b	#4,4(a1)
		move.w	8(a0),8(a1)
		move.b	#$C,7(a1)
		move.b	#$30,6(a1)
		move.w	a0,$46(a1)
		move.b	#2,$22(a1)
		move.w	#$34,$36(a1)
		jsr	(Create_New_Sprite3).l
		bne.s	loc_3E378
		move.l	#loc_3E472,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	$10(a0),$2E(a1)
		addi.w	#$32,$10(a1)
		addi.w	#$3A,$14(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		ori.b	#4,4(a1)
		bset	#0,4(a1)
		move.w	8(a0),8(a1)
		move.b	#$C,7(a1)
		move.b	#$30,6(a1)
		move.b	#2,$22(a1)
		move.w	#$36,$36(a1)
		move.w	a0,$46(a1)

loc_3E378:

		move.l	#loc_3E37E,(a0)

loc_3E37E:
		lea	$18(a0),a2
		move.w	$34(a0),d0
		add.w	$36(a0),d0
		lsr.w	#1,d0
		move.w	d0,d2
		neg.w	d0
		addi.w	#$40,d0
		move.b	#0,5(a2)
		cmpi.w	#$20,d0
		bhi.s	loc_3E3A6
		move.b	#1,5(a2)

loc_3E3A6:
		move.w	d0,d1
		move.w	d2,d3
		sub.w	$38(a0),d2
		beq.s	loc_3E422
		bcc.s	loc_3E3E6
		cmpi.w	#-4,d2
		beq.s	loc_3E3CC
		add.w	$14(a0),d0
		andi.w	#$E,d0
		cmpi.w	#2,d0
		bne.s	loc_3E422

loc_3E3C6:
		subq.w	#2,$14(a0)
		bra.s	loc_3E422
; ---------------------------------------------------------------------------

loc_3E3CC:
		add.w	$14(a0),d0
		andi.w	#$E,d0
		cmpi.w	#2,d0
		beq.s	loc_3E3C6
		cmpi.w	#4,d0
		bne.s	loc_3E422
		subq.w	#4,$14(a0)
		bra.s	loc_3E422
; ---------------------------------------------------------------------------

loc_3E3E6:
		cmpi.w	#4,d2
		beq.s	loc_3E40E
		add.w	$14(a0),d0

loc_3E3F0:
		move.w	d0,d2
		andi.w	#$E,d0
		bne.s	loc_3E422

loc_3E3F8:
		cmp.w	$3C(a0),d2
		beq.s	loc_3E422

loc_3E3FE:
		move.w	d2,$3C(a0)
		tst.b	$2C(a0)
		beq.s	loc_3E422
		subq.b	#1,$2C(a0)
		bra.s	loc_3E422
; ---------------------------------------------------------------------------

loc_3E40E:
		add.w	$14(a0),d0
		addq.w	#2,d0
		move.w	d0,d2
		andi.w	#$E,d0
		beq.s	loc_3E3F8
		move.w	d2,d0
		subq.w	#2,d0
		bra.s	loc_3E3F0
; ---------------------------------------------------------------------------

loc_3E422:

		move.w	d3,$38(a0)
		add.w	$14(a0),d1
		move.w	d1,d0
		move.w	d0,2(a2)
		addi.w	#$38,d0
		move.w	d0,8(a2)
		move.w	d0,$E(a2)
		andi.w	#$F,d1
		move.b	byte_3E462(pc,d1.w),d1
		addi.w	#$10,d1
		move.w	d1,d0
		neg.w	d0
		add.w	$10(a0),d0
		move.w	d0,6(a2)
		add.w	$10(a0),d1
		move.w	d1,$C(a2)
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
byte_3E462:	dc.b 0
		dc.b 8
		dc.b 8
		dc.b 8
		dc.b 8
		dc.b 8
		dc.b 7
		dc.b 6
		dc.b 5
		dc.b 4
		dc.b 3
		dc.b 2
		dc.b 1
		dc.b 0
		dc.b 0
		dc.b 0
; ---------------------------------------------------------------------------

loc_3E472:

		move.b	#0,$3A(a0)
		movea.w	$46(a0),a3
		move.w	$34(a0),d0
		subq.w	#6,d0
		add.w	$14(a3),d0
		move.w	d0,$14(a0)
		bsr.s	sub_3E4EC
		moveq	#$18,d1
		tst.b	$3A(a0)
		beq.s	loc_3E4AA
		tst.b	$2C(a3)
		beq.s	loc_3E4B6
		cmpi.w	#$40,$34(a0)
		beq.s	loc_3E4B6
		addq.w	#4,$34(a0)
		moveq	#$1C,d1
		bra.s	loc_3E4B6
; ---------------------------------------------------------------------------

loc_3E4AA:
		tst.w	$34(a0)
		beq.s	loc_3E4B6
		subq.w	#4,$34(a0)
		moveq	#$14,d1

loc_3E4B6:

		move.w	$36(a0),d0
		move.w	$34(a0),(a3,d0.w)
		move.b	#3,$22(a0)
		cmp.w	$34(a0),d1
		bhi.s	loc_3E4E2
		move.b	#2,$22(a0)
		addi.w	#$10,d1
		cmp.w	$34(a0),d1
		bhi.s	loc_3E4E2
		move.b	#7,$22(a0)

loc_3E4E2:

		move.w	$2E(a0),d0
		jmp	(Sprite_OnScreen_Test2).l

; =============== S U B R O U T I N E =======================================


sub_3E4EC:
		movea.w	$46(a0),a3
		lea	$31(a0),a2
		lea	($FFFFB04A).w,a1
		move.w	($FFFFF66A).w,d0
		bsr.s	sub_3E508
		lea	($FFFFB000).w,a1
		subq.w	#1,a2
		move.w	($FFFFF602).w,d0
; End of function sub_3E4EC


; =============== S U B R O U T I N E =======================================


sub_3E508:
		tst.b	(a2)
		beq.w	loc_3E682
		tst.b	4(a1)
		bpl.s	loc_3E58A
		cmpi.b	#4,5(a1)
		bcc.s	loc_3E58A
		tst.w	($FFFFFE08).w
		bne.s	loc_3E58A
		move.w	d0,d1
		andi.b	#$70,d1
		beq.w	loc_3E5F2
		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$12,2(a2)
		andi.w	#$F00,d0
		beq.w	loc_3E546
		move.b	#$3C,2(a2)

loc_3E546:
		btst	#$A,d0
		beq.s	loc_3E552
		move.w	#-$200,$18(a1)

loc_3E552:
		btst	#$B,d0
		beq.s	loc_3E55E
		move.w	#$200,$18(a1)

loc_3E55E:
		move.w	#-$380,$1A(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		rts
; ---------------------------------------------------------------------------

loc_3E58A:

		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$3C,2(a2)
		rts
; End of function sub_3E508


; =============== S U B R O U T I N E =======================================


sub_3E598:
		cmpa.w	#-$5000,a1
		bne.s	locret_3E5E6
		tst.b	d0
		beq.s	locret_3E5E6
		moveq	#0,d1
		move.b	$40(a0),d1
		cmp.b	byte_3E5E8(pc,d1.w),d0
		bne.s	loc_3E5E0
		addq.b	#1,$40(a0)
		move.b	byte_3E5E9(pc,d1.w),d1
		bne.s	locret_3E5E6
		moveq	#0,d1
		subi.w	#$20,d1
		movea.w	d1,a4
		tst.w	-$32(a4)
		bne.s	loc_3E5CC
		tst.w	(a4)
		beq.s	loc_3E5E0
		addq.w	#2,a4

loc_3E5CC:
		moveq	#1,d1
		move.b	d1,(a4)
		move.b	d1,1(a4)
		move.w	d0,d1
		moveq	#$33,d0
		jsr	(Play_Sound_2).l
		move.w	d1,d0

loc_3E5E0:

		move.b	#0,$40(a0)

locret_3E5E6:
		rts
; End of function sub_3E598

; ---------------------------------------------------------------------------
byte_3E5E8:	dc.b 4
byte_3E5E9:	dc.b 4
		dc.b 4
		dc.b 8
		dc.b 8
		dc.b 8
		dc.b 1
		dc.b 1
		dc.b 1
		dc.b 0
; ---------------------------------------------------------------------------

loc_3E5F2:
		bsr.s	sub_3E598
		btst	#$A,d0
		beq.s	loc_3E600
		bset	#0,$2A(a1)

loc_3E600:
		btst	#$B,d0
		beq.s	loc_3E60C
		bclr	#0,$2A(a1)

loc_3E60C:
		move.b	$2A(a1),d1
		andi.b	#1,d1
		andi.b	#-4,4(a1)
		or.b	d1,4(a1)
		move.b	#-$70,d1
		btst	#9,d0
		beq.s	loc_3E632
		move.b	#1,$3A(a0)
		move.b	#-$6F,d1

loc_3E632:
		btst	#1,d0
		beq.s	loc_3E646
		tst.b	$2C(a3)
		beq.s	loc_3E646
		moveq	#-$78,d0
		jsr	(Play_Sound_2).l

loc_3E646:

		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$42,$14(a1)

loc_3E658:
		move.w	$34(a0),d0
		beq.s	loc_3E66C
		move.b	#-$6F,d1
		cmpi.w	#$20,d0
		bcs.s	loc_3E66C
		move.b	#-$6E,d1

loc_3E66C:

		move.b	d1,$22(a1)
		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2
		rts
; ---------------------------------------------------------------------------

loc_3E682:
		tst.b	2(a2)
		beq.s	loc_3E690
		subq.b	#1,2(a2)
		bne.w	locret_3E71E

loc_3E690:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.w	locret_3E71E
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		subi.w	#$30,d1
		cmpi.w	#$18,d1
		bcc.w	locret_3E71E
		tst.b	$2E(a1)
		bne.s	locret_3E71E
		cmpi.b	#4,5(a1)
		bcc.s	locret_3E71E
		tst.w	($FFFFFE08).w
		bne.s	locret_3E71E
		tst.w	$1A(a1)
		beq.s	locret_3E71E
		bmi.s	locret_3E71E
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$42,$14(a1)
		move.b	#$14,$20(a1)
		move.b	#0,$3D(a1)
		move.b	#3,$2E(a1)
		andi.b	#-3,4(a1)
		move.b	#1,(a2)
		move.b	#-$70,d1
		moveq	#$4A,d0
		jsr	(Play_Sound_2).l
		bra.w	loc_3E658
; ---------------------------------------------------------------------------

locret_3E71E:

		rts
; ---------------------------------------------------------------------------
Map_MHZPulleyLift:include "Levels\MHZ\Misc Object Data\Map - Pulley Lift.asm"

; ---------------------------------------------------------------------------

Obj_MHZCurledVine:

		jsr	(Create_New_Sprite3).l
		bne.s	loc_3E89C
		move.l	#loc_3E9A6,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.l	#Map_MHZCurledVine,$C(a1)
		move.w	#$4353,$A(a1)
		ori.b	#4,4(a1)
		move.w	#$280,8(a1)
		move.b	#$40,7(a1)
		move.b	#$30,6(a1)
		bset	#6,4(a1)
		move.w	#8,$16(a1)
		move.l	#-$C0000,$32(a0)
		bset	#7,$2A(a0)
		move.w	a1,$46(a0)
		move.l	#loc_3E8A2,(a0)
		bra.s	loc_3E8A2
; ---------------------------------------------------------------------------

loc_3E89C:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_3E8A2:

		movea.w	$46(a0),a1
		moveq	#0,d1
		moveq	#0,d2
		move.b	$2A(a0),d1
		andi.b	#$18,d1
		beq.s	loc_3E8C4
		move.b	$36(a0),d1
		move.b	$37(a0),d2
		cmp.b	d1,d2
		bcs.s	loc_3E8C2
		move.b	d2,d1

loc_3E8C2:
		addq.b	#1,d1

loc_3E8C4:
		move.b	byte_3E8F6(pc,d1.w),d2
		move.w	d2,-(sp)
		lsl.w	#2,d1
		move.l	dword_3E8D2(pc,d1.w),d0
		bra.s	loc_3E900
; ---------------------------------------------------------------------------
dword_3E8D2:	dc.l $FFF40000
		dc.l $FFFA0000
		dc.l $FFFB0000
		dc.l $FFFC0000
		dc.l $FFFD0000
		dc.l $FFFE0000
		dc.l $FFFF0000
		dc.l $FFFF0000
		dc.l $FFFF0000
byte_3E8F6:	dc.b $40
		dc.b $40
		dc.b $40
		dc.b $40
		dc.b $50
		dc.b $60
		dc.b $70
		dc.b $80
		dc.b $80
		dc.b 0
; ---------------------------------------------------------------------------

loc_3E900:
		move.l	$32(a0),d4
		cmp.l	d0,d4
		beq.s	loc_3E918

loc_3E908:
		bcs.s	loc_3E912

loc_3E90A:
		subi.l	#$10000,d4
		bra.s	loc_3E918
; ---------------------------------------------------------------------------

loc_3E912:
		addi.l	#$10000,d4

loc_3E918:

		move.l	d4,$32(a0)
		move.l	d4,d1
		asr.l	#1,d1
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		subi.w	#$38,d2
		move.l	#$A0000,d5
		moveq	#7,d6
		lea	$18(a1),a2
		move.l	d1,-(sp)
		bra.s	loc_3E952
; ---------------------------------------------------------------------------

loc_3E93C:
		move.l	d1,-(sp)
		swap	d5
		move.w	d5,d0
		swap	d5
		jsr	(GetSineCosine).l
		asr.w	#4,d1
		asr.w	#4,d0
		add.w	d1,d2
		add.w	d0,d3

loc_3E952:
		move.w	d2,(a2)+
		move.w	d3,(a2)+
		addq.w	#2,a2
		add.l	d4,d5
		move.l	(sp)+,d1
		add.l	d1,d4
		dbf	d6,loc_3E93C
		move.w	(sp)+,d2
		move.w	#$40,d1
		moveq	#8,d3
		move.w	$10(a0),d4
		movea.l	a1,a2
		bsr.w	sub_3E9AC
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_3E98A
		rts
; ---------------------------------------------------------------------------

loc_3E98A:
		move.w	$48(a0),d0
		beq.s	loc_3E996
		movea.w	d0,a2
		bclr	#7,(a2)

loc_3E996:
		movea.w	$46(a0),a1
		jsr	(Delete_Referenced_Sprite).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_3E9A6:
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_3E9AC:
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		moveq	#$37,d5
		movem.l	d1-d4,-(sp)
		bsr.s	sub_3E9C6
		movem.l	(sp)+,d1-d4
		lea	($FFFFB000).w,a1
		subq.b	#1,d6
		moveq	#$36,d5
; End of function sub_3E9AC


; =============== S U B R O U T I N E =======================================


sub_3E9C6:
		btst	d6,$2A(a0)
		beq.s	loc_3EA1E
		btst	#1,$2A(a1)
		bne.s	loc_3E9E6
		moveq	#0,d0
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	loc_3E9E6
		cmp.w	d2,d0
		bcs.s	loc_3E9FA

loc_3E9E6:

		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		move.b	#0,(a0,d5.w)
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_3E9FA:
		lsr.w	#4,d0
		move.b	d0,(a0,d5.w)
		add.w	d0,d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		move.w	$1A(a2,d0.w),d0
		subq.w	#8,d0
		moveq	#0,d1
		move.b	$1E(a1),d1
		sub.w	d1,d0
		move.w	d0,$14(a1)
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_3EA1E:
		tst.w	$1A(a1)
		bmi.s	locret_3EA4A
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		bmi.s	locret_3EA4A
		cmp.w	d2,d0
		bcc.s	locret_3EA4A
		lsr.w	#4,d0
		add.w	d0,d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		move.w	$1A(a2,d0.w),d0
		subq.w	#8,d0
		jmp	(loc_1E45A).l
; ---------------------------------------------------------------------------

locret_3EA4A:

		rts
; End of function sub_3E9C6

; ---------------------------------------------------------------------------
Map_MHZCurledVine:include "Levels\MHZ\Misc Object Data\Map - Curled Vine.asm"

; ---------------------------------------------------------------------------

Obj_MHZStickyVine:

		jsr	(Create_New_Sprite3).l
		bne.s	loc_3EAC4
		move.l	#loc_3ED0A,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.l	#Map_MHZStickyVine,$C(a1)
		move.w	#$440A,$A(a1)
		ori.b	#4,4(a1)
		move.w	#$200,8(a1)
		move.b	#-$80,7(a1)
		move.b	#-$80,6(a1)
		bset	#6,4(a1)
		moveq	#8,d1
		move.w	d1,$16(a1)
		subq.b	#1,d1
		lea	$18(a1),a2

loc_3EAA8:
		move.w	$10(a0),(a2)+
		move.w	$14(a0),(a2)+
		move.w	#0,(a2)+
		dbf	d1,loc_3EAA8
		move.w	a1,$46(a0)
		move.l	#loc_3EACA,(a0)
		rts
; ---------------------------------------------------------------------------

loc_3EAC4:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_3EACA:

		lea	($FFFFB000).w,a1
		bsr.s	loc_3EADA
		lea	($FFFFB04A).w,a1
		bsr.s	loc_3EADA
		bra.w	loc_3EBF8
; ---------------------------------------------------------------------------

loc_3EADA:

		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$C,d0
		cmpi.w	#$18,d0
		bcc.w	locret_3EB24
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$18,d0
		cmpi.w	#$30,d0
		bcc.w	locret_3EB24
		tst.w	($FFFFFE08).w
		bne.s	locret_3EB24

loc_3EB08:
		cmpi.b	#4,5(a1)
		bcc.w	locret_3EB24
		tst.b	$2E(a1)
		bne.w	locret_3EB24
		move.l	#loc_3EB26,(a0)
		move.l	a1,$2E(a0)

locret_3EB24:

		rts
; ---------------------------------------------------------------------------

loc_3EB26:
		movea.l	$2E(a0),a1
		tst.b	$3D(a1)
		beq.s	loc_3EB3C
		move.b	#1,$3D(a0)
		move.b	#$10,$3E(a0)

loc_3EB3C:
		move.l	$10(a1),d0
		move.l	$14(a1),d1
		bsr.w	sub_3EC2A
		bsr.w	sub_3EC66
		bra.w	loc_3EBF8
; ---------------------------------------------------------------------------

loc_3EB50:
		movea.l	$2E(a0),a1
		move.l	$30(a0),d0
		move.l	$34(a0),d1
		bsr.w	sub_3EC2A
		move.w	$30(a0),d0
		sub.w	$10(a0),d0
		beq.s	loc_3EB7A
		bcc.s	loc_3EB74
		addq.w	#2,d0
		bcc.s	loc_3EB7A
		moveq	#0,d0
		bra.s	loc_3EB7A
; ---------------------------------------------------------------------------

loc_3EB74:
		subq.w	#2,d0
		bcc.s	loc_3EB7A
		moveq	#0,d0

loc_3EB7A:

		move.w	d0,d2
		add.w	$10(a0),d2
		move.w	d2,$30(a0)
		move.w	$34(a0),d1
		sub.w	$14(a0),d1
		beq.s	loc_3EBEE
		bcc.s	loc_3EBBA
		move.w	$1A(a0),d2
		addi.w	#$38,$1A(a0)
		ext.l	d2
		asl.l	#8,d2
		add.l	d2,$34(a0)
		move.w	$34(a0),d2
		cmp.w	$14(a0),d2
		bcs.s	loc_3EBEE
		move.w	$14(a0),$34(a0)
		move.w	#0,$1A(a0)
		bra.s	loc_3EBEE
; ---------------------------------------------------------------------------

loc_3EBBA:
		tst.w	$1A(a0)
		bpl.s	loc_3EBD4
		move.w	$1A(a0),d2
		addi.w	#$38,$1A(a0)
		ext.l	d2
		asl.l	#8,d2
		add.l	d2,$34(a0)
		bra.s	loc_3EBEE
; ---------------------------------------------------------------------------

loc_3EBD4:
		subq.w	#2,$34(a0)
		move.w	$34(a0),d2
		cmp.w	$14(a0),d2
		bcc.s	loc_3EBEE
		move.w	$14(a0),$34(a0)
		move.w	#0,$1A(a0)

loc_3EBEE:

		or.w	d0,d1
		bne.s	loc_3EBF8
		move.l	#loc_3EACA,(a0)

loc_3EBF8:

		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0

loc_3EC04:
		cmpi.w	#$280,d0

loc_3EC08:
		bhi.w	loc_3EC0E

locret_3EC0C:
		rts
; ---------------------------------------------------------------------------

loc_3EC0E:
		move.w	$48(a0),d0
		beq.s	loc_3EC1A
		movea.w	d0,a2
		bclr	#7,(a2)

loc_3EC1A:
		movea.w	$46(a0),a1
		jsr	(Delete_Referenced_Sprite).l
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_3EC2A:

		movea.w	$46(a0),a2
		move.l	$10(a0),d2
		move.l	$14(a0),d3
		sub.l	d2,d0
		sub.l	d3,d1
		movem.l	d0-d1,-(sp)
		asr.l	#3,d0
		asr.l	#3,d1
		lea	$48(a2),a3
		moveq	#7,d6
		bra.s	loc_3EC4E
; ---------------------------------------------------------------------------

loc_3EC4A:
		add.l	d0,d2
		add.l	d1,d3

loc_3EC4E:
		subq.w	#2,a3
		swap	d3
		move.w	d3,-(a3)
		swap	d3
		swap	d2
		move.w	d2,-(a3)
		swap	d2
		dbf	d6,loc_3EC4A
		movem.l	(sp)+,d1-d2
		rts
; End of function sub_3EC2A


; =============== S U B R O U T I N E =======================================


sub_3EC66:
		swap	d1
		swap	d2
		move.w	d1,d3
		bpl.s	loc_3EC70
		neg.w	d3

loc_3EC70:
		move.w	d2,d4
		bpl.s	loc_3EC76
		neg.w	d4

loc_3EC76:
		add.w	d4,d3
		add.w	d3,d3
		jsr	(GetArcTan).l
		jsr	(GetSineCosine).l
		muls.w	d3,d1
		muls.w	d3,d0
		asl.l	#1,d0
		asl.l	#2,d1
		sub.l	d1,$10(a1)
		btst	#1,$2A(a1)
		beq.s	loc_3ECAA
		sub.l	d0,$14(a1)
		tst.w	$1A(a1)
		bmi.s	loc_3ECCC
		asr	$18(a1)
		bra.s	loc_3ECCC
; ---------------------------------------------------------------------------

loc_3ECAA:
		asr.l	#8,d1
		tst.w	d1
		bpl.s	loc_3ECB2
		neg.w	d1

loc_3ECB2:
		move.w	$1C(a1),d0
		bpl.s	loc_3ECBA
		neg.w	d0

loc_3ECBA:
		cmpi.w	#$200,d0
		bcs.s	loc_3ECCC
		subi.w	#$10,d0
		cmp.w	d1,d0
		bcc.s	loc_3ECCC
		asr	$1C(a1)

loc_3ECCC:

		tst.b	$3D(a0)
		beq.s	loc_3ED02
		tst.b	$3D(a1)
		bne.s	loc_3ED02
		subq.b	#1,$3E(a0)
		bne.s	loc_3ED02
		move.l	$10(a1),$30(a0)
		move.l	$14(a1),$34(a0)
		move.w	#-$600,$1A(a0)
		move.b	#0,$3D(a0)
		move.b	#0,$3E(a0)
		move.l	#loc_3EB50,(a0)

loc_3ED02:

		bclr	#5,$2A(a1)
		rts
; End of function sub_3EC66

; ---------------------------------------------------------------------------

loc_3ED0A:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Map_MHZStickyVine:include "Levels\MHZ\Misc Object Data\Map - Sticky Vine.asm"

; ---------------------------------------------------------------------------

Obj_MHZSwingBarHorizontal:

		move.l	#Map_MHZSwingBarHorizontal,$C(a0)
		move.w	#$3F3,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#$20,7(a0)
		move.b	#4,6(a0)
		move.l	#loc_3ED46,(a0)

loc_3ED46:
		lea	$30(a0),a2
		lea	$3A(a0),a3
		lea	($FFFFB000).w,a1
		move.w	($FFFFF602).w,d1
		bsr.s	sub_3ED6E
		addq.w	#1,a2
		lea	$3C(a0),a3
		lea	($FFFFB04A).w,a1
		move.w	($FFFFF66A).w,d1
		bsr.s	sub_3ED6E
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_3ED6E:

		tst.b	(a2)
		beq.w	loc_3EECE
		tst.w	($FFFFFE08).w
		bne.w	loc_3EE2C
		cmpi.b	#4,5(a1)
		bcc.w	loc_3EE2C
		btst	#$A,d1
		beq.s	loc_3EDB6
		move.w	$10(a0),d0
		subi.w	#$16,d0
		cmp.w	$10(a1),d0
		bge.s	loc_3EDB6
		subq.w	#1,$10(a1)
		subq.b	#1,6(a2)
		bpl.s	loc_3EDB6
		move.b	#7,6(a2)
		addi.b	#$10,8(a2)
		andi.b	#$10,8(a2)

loc_3EDB6:

		btst	#$B,d1
		beq.s	loc_3EDE6
		move.w	$10(a0),d0
		addi.w	#$15,d0
		cmp.w	$10(a1),d0
		ble.s	loc_3EDE6
		addq.w	#1,$10(a1)
		subq.b	#1,6(a2)
		bpl.s	loc_3EDE6
		move.b	#7,6(a2)
		addi.b	#$10,8(a2)
		andi.b	#$10,8(a2)

loc_3EDE6:

		andi.w	#$70,d1
		bne.w	loc_3EE18
		cmpi.b	#$28,4(a2)
		beq.w	loc_3EE7A
		cmpi.b	#5,4(a2)

loc_3EDFE:
		beq.w	loc_3EEC2

loc_3EE02:
		bsr.w	sub_3EFBA
		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2
		rts
; ---------------------------------------------------------------------------

loc_3EE18:
		move.w	#-$500,$1A(a1)
		btst	#6,$2A(a1)
		beq.s	loc_3EE2C
		move.w	#-$200,$1A(a1)

loc_3EE2C:

		clr.b	(a2)
		move.b	#$1E,2(a2)
		btst	#6,$2A(a1)
		beq.s	loc_3EE42
		move.b	#$3C,2(a2)

loc_3EE42:
		andi.b	#-4,$2E(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$27(a1)
		rts
; ---------------------------------------------------------------------------

loc_3EE7A:
		move.w	#$1000,$20(a1)
		move.w	(a3),d0
		move.w	d0,d1
		asr.w	#1,d1
		add.w	d1,d0
		move.w	d0,$1A(a1)

loc_3EE8C:
		clr.b	(a2)
		move.b	#8,2(a2)
		andi.b	#-4,$2E(a1)
		bset	#1,$2A(a1)
		clr.b	$40(a1)
		clr.b	$3D(a1)
		move.b	#2,5(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$2F(a1)
		move.b	#0,$27(a1)
		rts
; ---------------------------------------------------------------------------

loc_3EEC2:
		move.w	#0,$20(a1)
		move.w	(a3),$1A(a1)
		bra.s	loc_3EE8C
; ---------------------------------------------------------------------------

loc_3EECE:
		tst.b	2(a2)
		beq.s	loc_3EEDA
		subq.b	#1,2(a2)
		rts
; ---------------------------------------------------------------------------

loc_3EEDA:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$16,d0
		cmpi.w	#$2C,d0
		bcc.w	locret_3EFB8
		move.w	$14(a0),d0
		addi.w	#$14,d0
		cmp.w	$14(a1),d0
		bcc.w	locret_3EFB8
		addi.w	#$10,d0

loc_3EF02:
		cmp.w	$14(a1),d0

loc_3EF06:
		bcs.w	locret_3EFB8

loc_3EF0A:
		tst.w	($FFFFFE08).w
		bne.w	locret_3EFB8
		cmpi.b	#4,5(a1)
		bcc.w	locret_3EFB8
		tst.b	$2E(a1)
		bne.w	locret_3EFB8
		move.w	$1A(a1),(a3)
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		andi.b	#-4,4(a1)
		move.w	$14(a0),d0
		addi.w	#$14,d0
		move.w	d0,$14(a1)
		move.b	#0,$20(a1)
		move.b	#3,$2E(a1)
		move.b	#-$6C,$22(a1)
		move.b	#0,4(a2)
		move.b	#0,6(a2)
		move.b	#0,8(a2)
		cmpi.w	#-$400,(a3)
		bgt.s	loc_3EF84
		move.b	#-$6B,$22(a1)
		move.b	#$20,4(a2)
		move.b	#$10,8(a2)
		bra.s	loc_3EF9C
; ---------------------------------------------------------------------------

loc_3EF84:
		cmpi.w	#$400,(a3)
		blt.s	loc_3EF9C
		move.b	#-$6B,$22(a1)
		move.b	#$21,4(a2)
		move.b	#$10,8(a2)

loc_3EF9C:

		move.b	#1,(a2)
		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2
		moveq	#$4A,d0
		jsr	(Play_Sound_2).l

locret_3EFB8:

		rts
; End of function sub_3ED6E


; =============== S U B R O U T I N E =======================================


sub_3EFBA:
		cmpi.w	#-$400,(a3)
		ble.s	loc_3EFE6
		cmpi.w	#$400,(a3)
		bge.s	loc_3EFE6
		move.b	4(a2),d0
		beq.s	loc_3EFE4
		bpl.s	loc_3EFD8
		addi.b	#6,d0
		bcc.s	loc_3EFD6
		moveq	#0,d0

loc_3EFD6:
		bra.s	loc_3EFE0
; ---------------------------------------------------------------------------

loc_3EFD8:
		subi.b	#6,d0
		bcc.s	loc_3EFE0
		moveq	#0,d0

loc_3EFE0:

		move.b	d0,4(a2)

loc_3EFE4:
		bra.s	loc_3EFF2
; ---------------------------------------------------------------------------

loc_3EFE6:
		move.b	4(a2),d0
		addi.b	#$C,d0
		move.b	d0,4(a2)

loc_3EFF2:
		moveq	#0,d0
		move.b	4(a2),d0
		lsr.b	#4,d0
		add.b	8(a2),d0

loc_3EFFE:
		move.b	RawAni_3F01A(pc,d0.w),d1

loc_3F002:
		move.b	d1,$22(a1)

loc_3F006:
		andi.w	#$F,d0

loc_3F00A:
		move.b	byte_3F03A(pc,d0.w),d1

loc_3F00E:
		ext.w	d1
		add.w	$14(a0),d1
		move.w	d1,$14(a1)
		rts
; End of function sub_3EFBA

; ---------------------------------------------------------------------------
RawAni_3F01A:	dc.b  $94, $63, $64, $64, $65, $65, $65, $66, $66, $66, $66, $67, $67, $67, $68, $68, $95, $63, $64, $64
		dc.b  $65, $65, $65, $66, $66, $66, $66, $67, $67, $67, $68, $68
byte_3F03A:	dc.b  $14, $14,	 $B,  $B, $F1, $F1, $F1, $EC, $EC, $EC,	$EC, $F4, $F4, $F4, $FE, $FE
Map_MHZSwingBarHorizontal:include "Levels\MHZ\Misc Object Data\Map - Swing Bar Horizontal.asm"


; ---------------------------------------------------------------------------

Obj_MHZSwingBarVertical:

		move.l	#Map_MHZSwingBarVertical,$C(a0)
		move.w	#$3F3,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$80,8(a0)
		move.b	#4,7(a0)
		move.b	#$20,6(a0)
		bset	#7,$2A(a0)
		move.l	#loc_3F08C,(a0)

loc_3F08C:
		moveq	#0,d1
		move.b	7(a0),d1
		move.w	#$21,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		lea	$30(a0),a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF602).w,d1
		bsr.s	sub_3F0D8
		addq.w	#1,a2
		lea	($FFFFB04A).w,a1
		move.w	($FFFFF66A).w,d1
		bsr.s	sub_3F0D8
		tst.b	$30(a0)
		beq.s	loc_3F0D2
		move.b	#1,($FFFFF676).w
		move.w	$10(a0),($FFFFF678).w
		move.w	($FFFFB014).w,($FFFFF67C).w

loc_3F0D2:
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_3F0D8:

		tst.b	(a2)
		beq.w	loc_3F246
		tst.w	($FFFFFE08).w
		bne.w	loc_3F17A
		cmpi.b	#4,5(a1)
		bcc.w	loc_3F17A
		andi.w	#$70,d1
		bne.w	loc_3F166
		cmpi.b	#-8,4(a2)
		beq.w	loc_3F1C8
		addi.b	#8,4(a2)
		bsr.s	sub_3F11C

loc_3F10A:

		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2
		rts
; End of function sub_3F0D8


; =============== S U B R O U T I N E =======================================


sub_3F11C:
		moveq	#0,d0
		move.b	4(a2),d0
		lsr.b	#4,d0
		move.b	RawAni_3F146(pc,d0.w),d1
		move.b	d1,$22(a1)
		move.b	byte_3F156(pc,d0.w),d1
		ext.w	d1
		btst	#0,4(a1)
		beq.s	loc_3F13C
		neg.w	d1

loc_3F13C:
		add.w	$10(a0),d1
		move.w	d1,$10(a1)
		rts
; End of function sub_3F11C

; ---------------------------------------------------------------------------
RawAni_3F146:	dc.b  $5C, $5C,	$5D, $5D, $5D, $5E, $5E, $5E, $5F, $5F,	$60, $60, $60, $61, $61, $61
byte_3F156:	dc.b  $12, $12,	  4,   4,   4, $F6, $F6, $F6, $EE, $EE,	$EE, $EE, $EE,	$A,  $A,  $A
; ---------------------------------------------------------------------------

loc_3F166:
		move.w	#-$500,$1A(a1)
		btst	#6,$2A(a1)
		beq.s	loc_3F17A
		move.w	#-$200,$1A(a1)

loc_3F17A:

		clr.b	(a2)
		move.b	#$1E,2(a2)
		btst	#6,$2A(a1)
		beq.s	loc_3F190
		move.b	#$3C,2(a2)

loc_3F190:
		andi.b	#-4,$2E(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$27(a1)
		rts
; ---------------------------------------------------------------------------

loc_3F1C8:
		move.w	#0,$20(a1)
		clr.b	(a2)
		move.b	#8,2(a2)
		andi.b	#-4,$2E(a1)
		move.w	$10(a0),$10(a1)
		move.w	#$1000,$18(a1)
		bclr	#0,$2A(a1)
		btst	#0,4(a1)
		beq.s	loc_3F200
		bset	#0,$2A(a1)
		neg.w	$18(a1)

loc_3F200:
		move.w	#$F,$32(a1)

loc_3F206:
		move.w	$18(a1),$1C(a1)

loc_3F20C:
		clr.b	$40(a1)
		clr.b	$3D(a1)
		move.b	#2,5(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$2F(a1)
		move.b	#0,$27(a1)
		move.b	#$24,$22(a1)
		cmpi.b	#1,$38(a1)
		bne.w	loc_3F10A
		move.b	#$E,$22(a1)
		bra.w	loc_3F10A
; ---------------------------------------------------------------------------

loc_3F246:
		tst.b	2(a2)
		beq.s	loc_3F252
		subq.b	#1,2(a2)
		rts
; ---------------------------------------------------------------------------

loc_3F252:
		move.w	$18(a1),d0
		bpl.s	loc_3F28C
		cmpi.w	#-$400,d0
		bgt.w	locret_3F35E
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$28,d0
		cmpi.w	#$18,d0
		bcc.w	locret_3F35E
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$20,d0
		cmpi.w	#$40,d0
		bcc.w	locret_3F35E
		moveq	#-$12,d2
		bra.s	loc_3F2BE
; ---------------------------------------------------------------------------

loc_3F28C:
		cmpi.w	#$400,d0
		blt.w	locret_3F35E
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		subi.w	#$10,d0
		cmpi.w	#$18,d0
		bcc.w	locret_3F35E
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$20,d0
		cmpi.w	#$40,d0
		bcc.w	locret_3F35E
		moveq	#$12,d2

loc_3F2BE:
		tst.w	($FFFFFE08).w
		bne.w	locret_3F35E
		cmpi.b	#4,5(a1)
		bcc.w	locret_3F35E
		tst.b	$2E(a1)
		bne.w	locret_3F35E
		btst	#1,$2A(a1)
		bne.w	locret_3F35E
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		andi.b	#-4,4(a1)
		move.b	$1E(a1),d0
		move.b	$44(a1),$1E(a1)

loc_3F2FE:
		move.b	$45(a1),$1F(a1)

loc_3F304:
		bclr	#2,$2A(a1)
		beq.s	loc_3F316

loc_3F30C:
		sub.b	$44(a1),d0
		ext.w	d0
		add.w	d0,$14(a1)

loc_3F316:
		move.w	$10(a0),d0
		add.w	d2,d0
		move.w	d0,$10(a1)
		move.b	#0,$20(a1)
		move.b	#3,$2E(a1)
		move.b	#$62,$22(a1)
		move.b	#8,4(a2)
		move.b	#1,(a2)
		tst.w	d2
		bpl.s	loc_3F346
		bset	#0,4(a1)

loc_3F346:
		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2
		moveq	#$4A,d0
		jsr	(Play_Sound_2).l

locret_3F35E:

		rts
; ---------------------------------------------------------------------------
Map_MHZSwingBarVertical:include "Levels\MHZ\Misc Object Data\Map - Swing Bar Vertical.asm"

; ---------------------------------------------------------------------------

Obj_MHZMushroomPlatform:

		move.l	#Map_MHZMushroomPlatform,$C(a0)
		move.w	#$43CD,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#$20,7(a0)
		move.b	#$20,6(a0)
		move.l	#loc_3F39C,(a0)

loc_3F39C:
		tst.b	$2E(a0)
		beq.s	loc_3F3CC
		tst.b	$2F(a0)
		beq.s	loc_3F3AE
		subq.b	#1,$2F(a0)
		bra.s	loc_3F3CC
; ---------------------------------------------------------------------------

loc_3F3AE:
		jsr	(MoveSprite2).l
		addi.w	#$28,$1A(a0)
		jsr	(CheckPlayerReleaseFromObj).l
		tst.b	4(a0)
		bmi.s	loc_3F3CC
		move.w	#$7F00,$10(a0)

loc_3F3CC:

		moveq	#0,d1
		move.b	7(a0),d1
		lea	(byte_3F42A).l,a2
		move.w	$10(a0),d4
		jsr	(SolidObjectTopSloped2).l
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	loc_3F40A
		move.b	#1,$20(a0)
		tst.b	$2C(a0)
		beq.s	loc_3F40A
		tst.b	$2E(a0)
		bne.s	loc_3F40A

loc_3F3FE:
		move.b	#1,$2E(a0)
		move.b	#$10,$2F(a0)

loc_3F40A:

		lea	(Ani_MHZMushroomPlatform).l,a1
		jsr	(Animate_Sprite).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
Ani_MHZMushroomPlatform:	include "Levels\MHZ\Misc Object Data\Anim - Mushroom Platform.asm"

byte_3F42A:	dc.b   $C,  $D,  $E,  $F, $10, $11, $12, $13, $13, $14, $14, $14, $14, $14, $14, $14, $14, $14, $14, $14
		dc.b  $14, $14, $14, $13, $13, $12, $11, $10,  $F,  $E,  $D,  $C

Map_MHZMushroomPlatform:include "Levels\MHZ\Misc Object Data\Map - Mushroom Platform.asm"

; ---------------------------------------------------------------------------

Obj_MHZMushroomParachute:

		move.l	#Map_MHZMushroomParachute,$C(a0)
		move.w	#-$3C33,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#$20,7(a0)
		move.b	#$20,6(a0)
		move.b	#$20,$1F(a0)
		move.b	#$18,$1E(a0)
		move.w	#$200,$1C(a0)
		move.b	#0,$26(a0)
		tst.b	$2C(a0)
		beq.s	loc_3F4FA
		move.b	#-$80,$26(a0)

loc_3F4FA:
		move.l	#loc_3F500,(a0)

loc_3F500:
		bsr.w	sub_3F5AA
		tst.b	$30(a0)
		beq.s	loc_3F516
		move.l	#loc_3F51C,(a0)
		move.w	#$300,$1A(a0)

loc_3F516:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_3F51C:

		bsr.w	sub_3F7E2
		jsr	(MoveSprite2).l
		bsr.w	sub_3F7AE
		bsr.s	sub_3F5AA
		move.w	$18(a0),$34(a0)
		move.w	$1A(a0),$36(a0)
		tst.w	$30(a0)
		bne.s	loc_3F544
		move.l	#loc_3F572,(a0)

loc_3F544:
		tst.b	4(a0)
		bmi.s	loc_3F56C
		move.w	#$7F00,$10(a0)
		tst.b	$30(a0)
		beq.s	loc_3F55E
		clr.w	($FFFFB042).w
		clr.b	($FFFFB02E).w

loc_3F55E:
		tst.b	$31(a0)
		beq.s	loc_3F56C
		clr.w	($FFFFB08C).w
		clr.b	($FFFFB078).w

loc_3F56C:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_3F572:

		bsr.w	sub_3F7E2
		jsr	(MoveSprite2).l
		tst.b	4(a0)
		bmi.s	loc_3F5A4
		move.w	#$7F00,$10(a0)
		tst.b	$30(a0)
		beq.s	loc_3F596
		clr.w	($FFFFB042).w
		clr.b	($FFFFB02E).w

loc_3F596:
		tst.b	$31(a0)
		beq.s	loc_3F5A4
		clr.w	($FFFFB08C).w
		clr.b	($FFFFB078).w

loc_3F5A4:

		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_3F5AA:

		lea	$31(a0),a2
		lea	($FFFFB04A).w,a1
		move.w	($FFFFF66A).w,d0
		bsr.s	sub_3F5C2
		lea	($FFFFB000).w,a1
		subq.w	#1,a2
		move.w	($FFFFF602).w,d0
; End of function sub_3F5AA


; =============== S U B R O U T I N E =======================================


sub_3F5C2:
		tst.b	(a2)
		beq.w	loc_3F6FE
		tst.b	4(a1)
		bpl.w	loc_3F660
		cmpi.b	#4,5(a1)
		bcc.w	loc_3F666
		tst.w	($FFFFFE08).w
		bne.w	loc_3F666
		move.w	$34(a0),d1
		cmp.w	$18(a1),d1
		bne.s	loc_3F660
		move.w	$36(a0),d1
		cmp.w	$1A(a1),d1
		bne.s	loc_3F660
		andi.b	#$70,d0
		beq.w	loc_3F678
		clr.w	$42(a1)
		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$12,2(a2)
		andi.w	#$F00,d0
		beq.w	loc_3F61C
		move.b	#$3C,2(a2)

loc_3F61C:
		btst	#$A,d0
		beq.s	loc_3F628
		move.w	#-$200,$18(a1)

loc_3F628:
		btst	#$B,d0
		beq.s	loc_3F634
		move.w	#$200,$18(a1)

loc_3F634:
		move.w	#-$380,$1A(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		rts
; ---------------------------------------------------------------------------

loc_3F660:

		move.w	#-$100,$1A(a1)

loc_3F666:

		clr.w	$42(a1)
		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$3C,2(a2)
		rts
; ---------------------------------------------------------------------------

loc_3F678:
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$25,$14(a1)
		move.w	$18(a0),$18(a1)
		move.w	$1A(a0),$1A(a1)
		movem.l	d0-a6,-(sp)
		movea.l	a1,a0

loc_3F69C:
		jsr	(sub_11EEC).l
		movem.l	(sp)+,d0-a6

loc_3F6A6:
		bclr	#0,$2A(a1)
		move.b	$26(a0),d0
		addi.b	#$40,d0
		bpl.s	loc_3F6BC
		bset	#0,$2A(a1)

loc_3F6BC:
		move.b	$2A(a1),d0
		andi.b	#1,d0
		andi.b	#-4,4(a1)
		or.b	d0,4(a1)
		moveq	#0,d0
		move.b	$26(a0),d0
		lsr.w	#4,d0
		move.b	RawAni_3F6EE(pc,d0.w),$22(a1)
		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2
		rts
; ---------------------------------------------------------------------------
RawAni_3F6EE:
		dc.b  $E4, $E5,	$E6, $E6, $E7, $E6, $E6, $E5, $E4, $E5,	$E6, $E6, $E7, $E6, $E6, $E5
; ---------------------------------------------------------------------------

loc_3F6FE:
		tst.b	2(a2)
		beq.s	loc_3F70C
		subq.b	#1,2(a2)
		bne.w	locret_3F7AC

loc_3F70C:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.w	locret_3F7AC
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		subi.w	#$25,d1
		cmpi.w	#$18,d1
		bcc.w	locret_3F7AC
		tst.b	$2E(a1)
		bne.s	locret_3F7AC
		cmpi.b	#4,5(a1)
		bcc.s	locret_3F7AC
		tst.w	($FFFFFE08).w
		bne.s	locret_3F7AC
		tst.w	$1A(a1)
		beq.s	locret_3F7AC
		bmi.s	locret_3F7AC
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$25,$14(a1)
		move.b	#0,$20(a1)
		move.b	#0,$3D(a1)
		move.b	#3,$2E(a1)
		andi.b	#-3,4(a1)
		move.b	#1,(a2)
		move.w	a0,$42(a1)
		move.w	#$80,8(a0)
		move.w	$18(a0),$18(a1)
		move.w	$1A(a0),$1A(a1)
		moveq	#$4A,d0
		jsr	(Play_Sound_2).l
		bra.w	loc_3F6A6
; ---------------------------------------------------------------------------

locret_3F7AC:

		rts
; End of function sub_3F5C2


; =============== S U B R O U T I N E =======================================


sub_3F7AE:
		move.l	($FFFFF7B4).w,($FFFFF796).w
		cmpi.b	#$D,$47(a0)
		beq.s	loc_3F7C2
		move.l	($FFFFF7B8).w,($FFFFF796).w

loc_3F7C2:
		moveq	#$D,d5
		jsr	(sub_FD32).l
		tst.w	d1
		bpl.s	loc_3F7D2
		sub.w	d1,$10(a0)

loc_3F7D2:
		jsr	(sub_FA1A).l
		tst.w	d1
		bpl.s	locret_3F7E0
		add.w	d1,$10(a0)

locret_3F7E0:
		rts
; End of function sub_3F7AE


; =============== S U B R O U T I N E =======================================


sub_3F7E2:

		move.b	$26(a0),d0
		tst.b	$30(a0)
		beq.s	loc_3F818
		btst	#2,($FFFFF602).w
		beq.s	loc_3F804
		cmpi.b	#-$80,d0
		beq.s	loc_3F804
		tst.b	d0
		bpl.s	loc_3F800
		neg.b	d0

loc_3F800:
		addq.b	#2,d0
		bra.s	loc_3F822
; ---------------------------------------------------------------------------

loc_3F804:

		btst	#3,($FFFFF602).w
		beq.s	loc_3F818

loc_3F80C:
		tst.b	d0

loc_3F80E:
		beq.s	loc_3F818
		bmi.s	loc_3F814
		neg.b	d0

loc_3F814:
		addq.b	#2,d0
		bra.s	loc_3F822
; ---------------------------------------------------------------------------

loc_3F818:

		move.b	d0,d1
		andi.b	#$7F,d1
		beq.s	loc_3F822
		addq.b	#2,d0

loc_3F822:

		move.b	d0,$26(a0)
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		muls.w	$1C(a0),d1
		asr.l	#8,d1
		move.w	d1,$18(a0)
		cmpi.w	#$80,$1A(a0)
		blt.s	loc_3F84A
		subi.w	#$20,$1A(a0)
		bra.s	locret_3F850
; ---------------------------------------------------------------------------

loc_3F84A:
		addi.w	#$20,$1A(a0)

locret_3F850:
		rts
; End of function sub_3F7E2

; ---------------------------------------------------------------------------
Map_MHZMushroomParachute:include "Levels\MHZ\Misc Object Data\Map - Mushroom Parachute.asm"

; ---------------------------------------------------------------------------

Obj_MHZMushroomCatapult:

		move.l	#Map_MHZMushroomCatapult,$C(a0)
		move.w	#$43CD,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#$20,7(a0)
		move.b	#$C,6(a0)
		move.w	$14(a0),$30(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_3F960
		move.l	#loc_3FA8E,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	$10(a0),$2E(a1)
		move.w	$14(a0),$30(a1)
		addi.w	#$40,$10(a1)
		tst.b	$2C(a0)
		beq.s	loc_3F8CE
		subi.w	#$80,$10(a1)

loc_3F8CE:
		subi.w	#$18,$14(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		ori.b	#4,4(a1)
		move.w	8(a0),8(a1)
		move.b	#$20,7(a1)
		move.b	#$C,6(a1)
		move.w	a0,$46(a1)
		move.w	#$18,$34(a1)
		move.w	a1,$46(a0)
		jsr	(Create_New_Sprite3).l
		bne.s	loc_3F960
		move.l	#loc_3FAC2,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	$10(a0),$2E(a1)
		move.w	$14(a1),$30(a1)
		subi.w	#$14,$14(a1)
		move.l	$C(a0),$C(a1)
		move.w	#$2420,$A(a1)
		ori.b	#4,4(a1)
		move.w	8(a0),8(a1)
		move.b	#$10,7(a1)
		move.b	#8,6(a1)
		move.b	#1,$22(a1)
		move.w	a0,$46(a1)

loc_3F960:

		move.l	#loc_3F966,(a0)

loc_3F966:
		movea.w	$46(a0),a1
		bsr.s	sub_3F996
		move.w	$34(a0),d0
		neg.w	d0
		add.w	$30(a0),d0
		move.w	d0,$14(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		lea	(byte_3FB50).l,a2
		move.w	$10(a0),d4
		jsr	(SolidObjectTopSloped2).l
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_3F996:
		move.w	$36(a0),d2
		tst.w	$32(a0)
		bne.s	loc_3F9E0
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	loc_3F9C0
		moveq	#0,d2
		tst.w	$34(a0)
		beq.s	loc_3F9C0
		move.b	#1,$32(a0)
		move.w	#0,$36(a0)
		bra.s	loc_3F9E0
; ---------------------------------------------------------------------------

loc_3F9C0:

		move.b	$2A(a1),d0
		andi.b	#$18,d0
		beq.s	loc_3F9E0
		moveq	#$18,d2
		cmpi.w	#$18,$34(a0)
		beq.s	loc_3F9E0
		move.b	#1,$33(a0)
		move.w	#$18,$36(a0)

loc_3F9E0:

		tst.w	d2
		bne.s	loc_3F9F0
		tst.w	$34(a0)
		beq.s	loc_3F9FE
		subq.w	#8,$34(a0)
		bra.s	locret_3F9FC
; ---------------------------------------------------------------------------

loc_3F9F0:
		cmpi.w	#$18,$34(a0)
		beq.s	loc_3FA42
		addq.w	#8,$34(a0)

locret_3F9FC:

		rts
; ---------------------------------------------------------------------------

loc_3F9FE:
		tst.b	$32(a0)
		beq.s	locret_3F9FC
		clr.w	$32(a0)
		move.b	$2A(a1),d0
		andi.b	#$18,d0
		bne.s	loc_3FA18
		clr.w	$3A(a0)
		rts
; ---------------------------------------------------------------------------

loc_3FA18:
		lea	($FFFFB000).w,a2
		moveq	#3,d6
		bsr.s	sub_3FA26
		lea	($FFFFB04A).w,a2
		moveq	#4,d6
; End of function sub_3F996


; =============== S U B R O U T I N E =======================================


sub_3FA26:
		btst	d6,$2A(a1)
		beq.s	locret_3F9FC
		move.w	#-$E80,d1
		cmpi.w	#$900,$3A(a0)
		bcc.s	loc_3FA3C
		move.w	#-$D00,d1

loc_3FA3C:
		move.w	d1,$1A(a2)
		bra.s	loc_3FA66
; End of function sub_3FA26

; ---------------------------------------------------------------------------

loc_3FA42:
		tst.b	$33(a0)
		beq.s	locret_3F9FC
		clr.w	$32(a0)
		lea	($FFFFB000).w,a2
		moveq	#3,d6
		bsr.s	sub_3FA5A
		lea	($FFFFB04A).w,a2
		moveq	#4,d6

; =============== S U B R O U T I N E =======================================


sub_3FA5A:
		btst	d6,$2A(a0)
		beq.s	locret_3F9FC
		move.w	#-$D00,$1A(a2)

loc_3FA66:
		bset	#1,$2A(a2)
		bclr	#3,$2A(a2)
		clr.b	$40(a2)
		clr.b	$3D(a2)
		move.b	#$10,$20(a2)
		move.b	#2,5(a2)
		moveq	#-$79,d0
		jmp	(Play_Sound_2).l
; End of function sub_3FA5A

; ---------------------------------------------------------------------------

loc_3FA8E:
		movea.w	$46(a0),a1
		move.w	$34(a1),d0
		subi.w	#$18,d0
		add.w	$30(a0),d0
		move.w	d0,$14(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		lea	(byte_3FB50).l,a2
		move.w	$10(a0),d4
		jsr	(SolidObjectTopSloped2).l
		move.w	$2E(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_3FAC2:

		movea.w	$46(a0),a1
		move.w	$34(a1),d0
		neg.w	d0
		add.w	$30(a0),d0
		subi.w	#$14,d0
		move.w	d0,$14(a0)
		cmpi.w	#$18,$34(a1)
		bne.s	loc_3FB06
		move.l	#loc_3FB0C,(a0)
		moveq	#-$52,d0
		jsr	(Play_Sound_2).l
		move.w	#$18,$36(a1)
		move.w	#-$800,$1A(a0)
		tst.w	$3A(a1)
		beq.s	loc_3FB06
		move.w	#-$A00,$1A(a0)

loc_3FB06:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_3FB0C:
		jsr	(MoveSprite).l
		movea.w	$46(a0),a1
		move.w	$34(a1),d0
		neg.w	d0
		add.w	$30(a0),d0
		subi.w	#$14,d0
		cmp.w	$14(a0),d0
		bhi.s	loc_3FB4A
		move.w	d0,$14(a0)
		move.l	#loc_3FAC2,(a0)
		move.w	#0,$36(a1)
		move.b	#1,$32(a1)
		move.w	$1A(a0),$3A(a1)
		clr.w	$1A(a0)

loc_3FB4A:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
byte_3FB50:	dc.b    4,   5,   6,   7,   8,   9,  $A,  $B,  $B,  $C,  $C,  $C,  $C,  $C,  $C,  $C,  $C,  $C,  $C,  $C
		dc.b   $C,  $C,  $C,  $B,  $B,  $A,   9,   8,   7,   6,   5,   4

Map_MHZMushroomCatapult:include "Levels\MHZ\Misc Object Data\Map - Mushroom Catapult.asm"

; ---------------------------------------------------------------------------

Obj_14_2:
		move.b	$2C(a0),d0
		andi.w	#$7F,d0
		lsl.w	#3,d0
		move.w	d0,$36(a0)
		addi.w	#$10,d0
		move.w	d0,$38(a0)
		move.l	#loc_3FBAC,(a0)

loc_3FBAC:
		moveq	#0,d2
		lea	($FFFFB000).w,a1
		bsr.w	sub_3FBC4
		lea	($FFFFB04A).w,a1
		bsr.w	sub_3FBC4
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_3FBC4:

		cmpi.b	#4,5(a1)
		bcc.w	locret_3FC74
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$40,d0
		cmpi.w	#$80,d0
		bcc.w	locret_3FC74
		tst.b	$2E(a1)
		bne.w	loc_3FC76
		moveq	#0,d1
		move.b	($FFFFFE84).w,d1
		add.w	$14(a1),d1
		addi.w	#$40,d1
		sub.w	$14(a0),d1
		bcs.s	locret_3FC74

loc_3FBFE:
		cmpi.w	#$50,d1
		bcc.s	locret_3FC74

loc_3FC04:
		subi.w	#$40,d1
		bcs.s	loc_3FC0E
		not.w	d1
		add.w	d1,d1

loc_3FC0E:
		addi.w	#$40,d1
		neg.w	d1
		asr.w	#6,d1
		add.w	d1,$14(a1)
		bset	#1,$2A(a1)
		bclr	#4,$2A(a1)
		move.w	#0,$1A(a1)
		move.b	#0,$2F(a1)
		move.b	#0,$40(a1)
		move.b	($FFFFFE0F).w,d0
		andi.b	#$F,d0
		bne.s	loc_3FC4A
		moveq	#-$32,d0
		jsr	(Play_Sound_2).l

loc_3FC4A:
		tst.b	$2C(a0)
		bmi.s	loc_3FCC6
		move.w	#1,$1C(a1)
		tst.b	$27(a1)
		bne.s	locret_3FC74
		move.b	#1,$27(a1)
		move.b	#0,$20(a1)
		move.b	#$7F,$30(a1)
		move.b	#8,$31(a1)

locret_3FC74:

		rts
; ---------------------------------------------------------------------------

loc_3FC76:
		movea.w	$42(a1),a3
		cmpi.l	#loc_3F51C,(a3)
		beq.s	loc_3FC8A
		cmpi.l	#loc_3F572,(a3)
		bne.s	locret_3FC74

loc_3FC8A:
		moveq	#0,d1
		move.b	($FFFFFE84).w,d1
		add.w	$14(a1),d1

loc_3FC94:
		add.w	$36(a0),d1
		sub.w	$14(a0),d1
		bcs.s	locret_3FC74
		cmp.w	$38(a0),d1
		bcc.s	locret_3FC74
		sub.w	$36(a0),d1
		bcs.s	loc_3FCAE
		not.w	d1
		add.w	d1,d1

loc_3FCAE:
		add.w	$36(a0),d1
		neg.w	d1
		asr.w	#6,d1
		add.w	d1,$14(a1)
		tst.w	d2
		bne.s	locret_3FC74
		moveq	#1,d2
		add.w	d1,$14(a3)
		rts
; ---------------------------------------------------------------------------

loc_3FCC6:
		move.w	#1,$1C(a1)
		move.b	#$F,$20(a1)
		rts
; End of function sub_3FBC4

; ---------------------------------------------------------------------------

Obj_38_2:
		moveq	#0,d0
		move.b	$2C(a0),d0
		andi.w	#$3F,d0
		lsl.w	#3,d0
		move.w	d0,$30(a0)
		add.w	d0,d0
		move.w	d0,$32(a0)
		move.b	$2C(a0),d0
		andi.b	#-$40,d0
		cmpi.b	#$40,d0
		bne.s	loc_3FD02

loc_3FCF8:
		move.l	#loc_3FE44,(a0)
		bra.w	loc_3FE44
; ---------------------------------------------------------------------------

loc_3FD02:
		cmpi.b	#-$80,d0
		bne.s	loc_3FD12

loc_3FD08:
		move.l	#loc_3FF80,(a0)
		bra.w	loc_3FF80
; ---------------------------------------------------------------------------

loc_3FD12:
		cmpi.b	#-$40,d0
		bne.s	loc_3FD22
		move.l	#loc_400CA,(a0)
		bra.w	loc_400CA
; ---------------------------------------------------------------------------

loc_3FD22:
		move.l	#loc_3FD28,(a0)

loc_3FD28:
		move.w	$30(a0),d2
		move.w	$32(a0),d3
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		move.w	($FFFFF602).w,d5
		bsr.s	sub_3FD4E
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		move.w	($FFFFF66A).w,d5
		bsr.s	sub_3FD4E
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_3FD4E:

		btst	d6,$2A(a0)
		bne.s	loc_3FDD0
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.s	locret_3FDCE
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		add.w	d2,d0
		cmp.w	d3,d0
		bcc.s	locret_3FDCE
		btst	#1,$2A(a1)
		beq.s	locret_3FDCE
		btst	#3,$2A(a1)
		bne.s	locret_3FDCE
		cmpi.b	#4,5(a1)
		bcc.s	locret_3FDCE
		tst.b	$2E(a1)
		bne.s	locret_3FDCE
		bset	#3,$2A(a1)
		bset	d6,$2A(a0)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$2F(a1)
		move.b	#0,$40(a1)
		asr	$1A(a1)
		asr	$18(a1)

locret_3FDCE:

		rts
; ---------------------------------------------------------------------------

loc_3FDD0:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.s	loc_3FDF8
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		add.w	d2,d0
		cmp.w	d3,d0
		bcc.s	loc_3FDF8
		btst	#1,$2A(a1)
		bne.s	loc_3FE04

loc_3FDF8:

		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		rts
; ---------------------------------------------------------------------------

loc_3FE04:
		andi.w	#$70,d5

loc_3FE08:
		beq.s	loc_3FE18
		move.w	#-$800,$1A(a1)
		moveq	#$62,d0
		jsr	(Play_Sound_2).l

loc_3FE18:
		tst.w	$1A(a1)
		bpl.s	loc_3FE2A
		asr	$18(a1)
		addi.w	#$68,$1A(a1)
		rts
; ---------------------------------------------------------------------------

loc_3FE2A:
		asr	$18(a1)
		move.w	#$A8,$1A(a1)
		btst	#1,$2A(a0)
		beq.s	locret_3FE42
		move.w	#-$198,$1A(a1)

locret_3FE42:
		rts
; End of function sub_3FD4E

; ---------------------------------------------------------------------------

loc_3FE44:

		move.w	$30(a0),d2
		move.w	$32(a0),d3
		lea	$34(a0),a2
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		move.w	($FFFFF602).w,d5
		bsr.s	sub_3FE70
		addq.w	#1,a2
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		move.w	($FFFFF66A).w,d5
		bsr.s	sub_3FE70
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_3FE70:

		tst.b	(a2)
		beq.s	loc_3FE78
		subq.b	#1,(a2)
		rts
; ---------------------------------------------------------------------------

loc_3FE78:
		btst	d6,$2A(a0)
		bne.w	loc_3FF02
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d2,d0
		cmp.w	d3,d0
		bcc.s	locret_3FF00
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.s	locret_3FF00
		btst	#1,$2A(a1)
		beq.s	locret_3FF00

loc_3FEA8:
		btst	#3,$2A(a1)
		bne.s	locret_3FF00
		cmpi.b	#4,5(a1)
		bcc.s	locret_3FF00
		tst.b	$2E(a1)
		bne.s	locret_3FF00
		tst.w	$1A(a1)
		bmi.s	locret_3FF00
		bset	#3,$2A(a1)
		bset	d6,$2A(a0)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$2F(a1)
		move.b	#0,$40(a1)
		asr	$1A(a1)
		asr	$18(a1)

locret_3FF00:

		rts
; ---------------------------------------------------------------------------

loc_3FF02:
		move.w	$10(a1),d0

loc_3FF06:
		sub.w	$10(a0),d0

loc_3FF0A:
		add.w	d2,d0
		cmp.w	d3,d0
		bcc.s	loc_3FF2A
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.s	loc_3FF2A
		btst	#1,$2A(a1)
		bne.s	loc_3FF3C

loc_3FF2A:

		move.w	#0,$1A(a1)
		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		rts
; ---------------------------------------------------------------------------

loc_3FF3C:
		andi.w	#$70,d5
		beq.s	loc_3FF60
		move.w	#$400,$1A(a1)
		move.b	#$1E,(a2)
		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		moveq	#$62,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_3FF60:
		move.w	#0,$1A(a1)
		asr	$18(a1)
		move.l	#$B000,d0
		btst	#0,$2A(a0)
		beq.s	loc_3FF7A
		neg.l	d0

loc_3FF7A:
		add.l	d0,$10(a1)
		rts
; End of function sub_3FE70

; ---------------------------------------------------------------------------

loc_3FF80:

		move.w	$30(a0),d2
		move.w	$32(a0),d3
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.s	loc_3FF9E
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.s	loc_3FF9E
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_3FF9E:

		btst	d6,$2A(a0)
		bne.w	loc_40042
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$20,d0
		cmpi.w	#$40,d0
		bcc.w	locret_40040
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		add.w	d2,d0
		cmp.w	d3,d0
		bcc.w	locret_40040
		btst	#3,$2A(a1)
		bne.w	locret_40040
		cmpi.b	#4,5(a1)
		bcc.s	locret_40040
		tst.b	$2E(a1)
		bne.s	locret_40040
		btst	#1,$2A(a0)
		bne.s	loc_3FFF2
		btst	#1,$2A(a1)
		beq.s	locret_40040

loc_3FFF2:
		bset	#1,$2A(a1)
		bset	#3,$2A(a1)

loc_3FFFE:
		bset	d6,$2A(a0)

loc_40002:
		bclr	#2,$2A(a1)
		bclr	#4,$2A(a1)

loc_4000E:
		move.b	#0,$2F(a1)
		move.b	#0,$40(a1)
		moveq	#1,d6

loc_4001C:
		move.w	#1,$1C(a1)

loc_40022:
		tst.b	$27(a1)
		bne.s	locret_40040
		move.b	#1,$27(a1)
		move.b	#0,$20(a1)

loc_40034:
		move.b	#$7F,$30(a1)
		move.b	#8,$31(a1)

locret_40040:

		rts
; ---------------------------------------------------------------------------

loc_40042:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$20,d0
		cmpi.w	#$40,d0
		bcc.s	loc_40078
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		add.w	d2,d0
		cmp.w	d3,d0
		bcc.s	loc_40078
		tst.b	$2E(a1)
		bne.s	loc_40078
		cmpi.b	#4,5(a1)
		bcc.s	loc_40078
		btst	#1,$2A(a1)
		bne.s	loc_40084

loc_40078:

		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		rts
; ---------------------------------------------------------------------------

loc_40084:
		move.b	#$7F,$30(a1)
		tst.w	$1A(a1)
		bpl.s	loc_400A6
		addi.w	#$68,$1A(a1)
		move.b	($FFFFFE05).w,d0
		andi.b	#7,d0
		bne.s	locret_400A4
		asr	$18(a1)

locret_400A4:
		rts
; ---------------------------------------------------------------------------

loc_400A6:
		move.w	#$A8,$1A(a1)
		btst	#1,$2A(a0)
		beq.s	loc_400BA
		move.w	#-$330,$1A(a1)

loc_400BA:
		move.b	($FFFFFE05).w,d0
		andi.b	#7,d0
		bne.s	locret_400C8
		asr	$18(a1)

locret_400C8:
		rts
; ---------------------------------------------------------------------------

loc_400CA:

		move.w	$30(a0),d2
		move.w	$32(a0),d3
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		move.w	($FFFFF602).w,d5
		bsr.s	sub_400F0
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		move.w	($FFFFF66A).w,d5
		bsr.s	sub_400F0
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_400F0:

		btst	d6,$2A(a0)
		bne.w	loc_401AC

loc_400F8:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d2,d0
		cmp.w	d3,d0
		bcc.w	locret_401A2

loc_40108:
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$33,d0
		cmpi.w	#$40,d0
		bcc.w	locret_401A2
		btst	#1,$2A(a1)
		beq.s	locret_401A2
		btst	#3,$2A(a1)
		bne.s	locret_401A2
		cmpi.b	#6,5(a1)
		bcc.s	locret_401A2
		tst.b	$2E(a1)
		bne.s	locret_401A2
		tst.w	$1A(a1)
		bmi.s	loc_401A4
		bset	#3,$2A(a1)
		bset	d6,$2A(a0)
		move.b	$44(a1),$1E(a1)
		move.b	$45(a1),$1F(a1)
		bclr	#2,$2A(a1)
		bclr	#2,$2A(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$20(a1)

loc_4016E:
		move.b	#0,$2F(a1)
		move.b	#0,$40(a1)
		asr	$18(a1)
		move.w	$18(a1),$1C(a1)
		asr	$1A(a1)
		cmpi.b	#2,5(a1)
		beq.s	locret_401A2
		move.b	#2,5(a1)
		move.b	#$78,$34(a1)
		move.b	#0,$3D(a1)

locret_401A2:

		rts
; ---------------------------------------------------------------------------

loc_401A4:
		addi.w	#$68,$1A(a1)
		rts
; ---------------------------------------------------------------------------

loc_401AC:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d2,d0
		cmp.w	d3,d0
		bcc.s	loc_401DA
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$33,d0
		cmpi.w	#$40,d0
		bcc.s	loc_401DA
		tst.b	$2E(a1)
		bne.s	loc_401DA
		btst	#1,$2A(a1)
		bne.s	loc_401E6

loc_401DA:

		bclr	#3,$2A(a1)

loc_401E0:
		bclr	d6,$2A(a0)
		rts
; ---------------------------------------------------------------------------

loc_401E6:
		andi.w	#$70,d5
		beq.s	loc_4023E
		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		move.w	#-$680,$1A(a1)
		cmpi.b	#2,$38(a1)
		bne.s	loc_4020A
		move.w	#-$600,$1A(a1)

loc_4020A:
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$2F(a1)
		move.b	#1,$40(a1)
		moveq	#$62,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_4023E:
		tst.w	$1A(a1)
		bpl.s	loc_40256
		asr	$18(a1)
		move.w	$18(a1),$1C(a1)
		addi.w	#$68,$1A(a1)
		rts
; ---------------------------------------------------------------------------

loc_40256:
		asr	$18(a1)
		move.w	$18(a1),$1C(a1)
		move.w	#$A8,$1A(a1)
		btst	#1,$2A(a0)
		beq.s	locret_40274
		move.w	#-$198,$1A(a1)

locret_40274:
		rts
; End of function sub_400F0

; ---------------------------------------------------------------------------

Obj_SOZSpawningSandBlocks:

		move.l	#Map_SOZSpawningSandBlocks,$C(a0)
		move.w	#$43C0,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$C,6(a0)
		move.w	#$200,8(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#3,d0
		add.w	d0,$10(a0)
		move.w	$10(a0),$44(a0)
		move.w	$14(a0),$46(a0)
		move.w	$44(a0),$30(a0)
		andi.w	#-$80,d0
		addi.w	#$300,d0
		move.w	d0,$32(a0)
		move.l	#loc_402CC,(a0)

loc_402CC:
		tst.w	$34(a0)
		beq.s	loc_402EE
		subq.w	#1,$34(a0)
		bne.w	locret_4036C
		tst.b	($FFFFFE84).w
		beq.s	loc_402EE
		move.w	#1,$34(a0)
		subq.w	#1,$36(a0)
		bra.w	locret_4036C
; ---------------------------------------------------------------------------

loc_402EE:

		moveq	#0,d0
		move.b	($FFFFFE84).w,d0
		add.w	$46(a0),d0
		move.w	d0,$14(a0)
		bsr.s	sub_40302

loc_402FE:
		bra.w	loc_403B0

; =============== S U B R O U T I N E =======================================


sub_40302:
		subq.w	#1,$36(a0)
		bpl.s	locret_4036C
		move.w	#$7F,$36(a0)
		jsr	(Create_New_Sprite).l
		bne.w	loc_40366
		move.l	#loc_4036E,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	4(a0),4(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.w	#$280,8(a1)
		move.b	#$18,7(a1)
		move.b	#$C,6(a1)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#4,d0
		move.w	d0,$34(a1)
		move.w	$30(a0),$30(a1)
		move.w	$32(a0),$32(a1)

loc_40366:
		move.w	#1,$34(a0)

locret_4036C:

		rts
; End of function sub_40302

; ---------------------------------------------------------------------------

loc_4036E:
		move.w	$10(a0),-(sp)
		jsr	(MoveSprite).l
		cmpi.w	#$200,$1A(a0)
		blt.s	loc_403A0
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_403A0
		add.w	d1,$14(a0)
		move.l	#loc_403DC,(a0)
		move.w	#-$100,$18(a0)
		move.w	#0,$1A(a0)

loc_403A0:

		move.w	(sp)+,d4

loc_403A2:

		move.w	#$18,d1
		move.w	#$D,d3
		jsr	(SolidObjectTop).l

loc_403B0:
		move.w	$30(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmp.w	$32(a0),d0
		bhi.w	loc_403CA
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_403CA:
		move.w	$48(a0),d0
		beq.s	loc_403D6
		movea.w	d0,a2
		bclr	#7,(a2)

loc_403D6:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_403DC:
		subq.w	#1,$34(a0)
		bne.s	loc_403F4
		move.w	$14(a0),$46(a0)
		move.w	#0,$18(a0)
		move.l	#loc_4040C,(a0)

loc_403F4:
		move.w	$10(a0),-(sp)
		jsr	(MoveSprite2).l

loc_403FE:
		jsr	(ObjHitFloor).l

loc_40404:
		add.w	d1,$14(a0)
		move.w	(sp)+,d4
		bra.s	loc_403A2
; ---------------------------------------------------------------------------

loc_4040C:
		jsr	(MoveSprite2).l
		addi.w	#8,$1A(a0)
		move.w	$46(a0),d0
		addi.w	#$12,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_40432
		move.w	#$7F00,$10(a0)
		move.w	#$7F00,$30(a0)

loc_40432:
		move.w	$10(a0),d4
		bra.w	loc_403A2
; ---------------------------------------------------------------------------
Map_SOZSpawningSandBlocks:include "Levels\SOZ\Misc Object Data\Map - Spawning Sand Blocks.asm"


; ---------------------------------------------------------------------------

Obj_3B_2:
		move.b	$2C(a0),d0
		andi.w	#$7F,d0
		lsl.w	#4,d0
		move.w	d0,$30(a0)
		move.l	#loc_4045E,(a0)

loc_4045E:
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.s	sub_40474
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.s	sub_40474
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_40474:

		btst	d6,$2A(a0)
		bne.w	loc_40508
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.w	locret_40506
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.s	locret_40506
		btst	#3,$2A(a1)
		bne.s	locret_40506
		cmpi.b	#4,5(a1)
		bcc.s	locret_40506
		tst.b	$2E(a1)
		bne.s	locret_40506
		cmpi.w	#$800,$1A(a1)
		blt.s	locret_40506
		bset	#3,$2A(a1)
		bset	d6,$2A(a0)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$2F(a1)
		move.b	#0,$40(a1)
		bset	#1,$2A(a1)
		move.b	#-$7F,$2E(a1)

loc_40500:
		move.w	#0,$18(a1)

locret_40506:

		rts
; ---------------------------------------------------------------------------

loc_40508:
		move.w	$18(a1),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$10(a1)
		move.w	$1A(a1),d0
		addi.w	#$38,$1A(a1)
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$14(a1)
		move.w	$14(a1),d0
		sub.w	$30(a0),d0
		cmp.w	$14(a0),d0
		blt.s	locret_40506
		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		move.b	#0,$2E(a1)
		rts
; End of function sub_40474

; ---------------------------------------------------------------------------

Obj_SOZPushableRock:

		move.l	#Map_SOZPushableRock,$C(a0)
		move.w	#$4455,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$C,6(a0)
		move.b	#$B,$1E(a0)
		move.w	#$280,8(a0)

Load_SOZ_Pushable_Rock_Track_Ride_Info:
		lea	(SOZRockRideInfo).l,a1
		moveq	#0,d0
		move.b	$2C(a0),d0
		andi.w	#$1F,d0
		add.w	d0,d0
		add.w	d0,d0
		movea.l	(a1,d0.w),a1
		move.w	(a1)+,$3A(a0)
		move.l	a1,$36(a0)
		tst.b	$2C(a0)
		bpl.s	loc_405A4
		move.w	a0,($FFFFF7C4).w
		move.l	#loc_405D6,(a0)
		bra.s	loc_405D6
; ---------------------------------------------------------------------------

loc_405A4:
		move.l	#loc_405AA,(a0)

loc_405AA:

		move.b	($FFFFB02A).w,$30(a0)
		move.b	($FFFFB074).w,$31(a0)
		move.w	#$1B,d1
		move.w	#$C,d2
		move.w	#$D,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		bsr.w	sub_406B4
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_405D6:

		bra.s	loc_405AA
; ---------------------------------------------------------------------------

loc_405D8:

		move.w	$10(a0),-(sp)
		jsr	(MoveSprite).l
		move.w	(sp)+,d4
		move.w	($FFFFEE1A).w,d0
		addi.w	#$120,d0
		cmp.w	$14(a0),d0
		bgt.s	loc_405FA
		move.w	#$7F00,d4
		move.w	d4,$10(a0)

loc_405FA:
		move.w	$3A(a0),d0
		cmp.w	$14(a0),d0
		bcc.s	loc_4063C
		move.w	d0,$14(a0)
		move.w	#0,$1A(a0)
		movea.l	$36(a0),a1
		move.w	(a1)+,d0
		bpl.s	loc_4061E
		move.l	#loc_406AE,(a0)
		bra.s	loc_4063C
; ---------------------------------------------------------------------------

loc_4061E:
		move.w	d0,$3A(a0)
		move.l	a1,$36(a0)
		move.l	#loc_40654,(a0)
		move.w	#$100,$18(a0)
		cmp.w	$10(a0),d0
		bcc.s	loc_4063C
		neg.w	$18(a0)

loc_4063C:

		move.w	#$1B,d1
		move.w	#$C,d2
		move.w	#$D,d3
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_40654:
		move.w	$10(a0),-(sp)
		jsr	(MoveSprite2).l
		move.w	(sp)+,d4
		move.b	($FFFFFE05).w,d0
		andi.b	#$1F,d0
		bne.s	loc_40672
		moveq	#$55,d0
		jsr	(Play_Sound_2).l

loc_40672:
		tst.w	$18(a0)
		bmi.s	loc_40684
		move.w	$3A(a0),d0
		cmp.w	$10(a0),d0
		bhi.s	loc_406AC
		bra.s	loc_4068E
; ---------------------------------------------------------------------------

loc_40684:
		move.w	$3A(a0),d0
		cmp.w	$10(a0),d0
		bcs.s	loc_406AC

loc_4068E:
		movea.l	$36(a0),a1
		move.w	(a1)+,d0
		bpl.s	loc_4069E
		move.l	#loc_406AE,(a0)
		bra.s	loc_4063C
; ---------------------------------------------------------------------------

loc_4069E:
		move.w	d0,$3A(a0)
		move.l	a1,$36(a0)
		move.l	#loc_405D8,(a0)

loc_406AC:

		bra.s	loc_4063C
; ---------------------------------------------------------------------------

loc_406AE:

		move.w	$10(a0),d4
		bra.s	loc_4063C

; =============== S U B R O U T I N E =======================================


sub_406B4:
		moveq	#0,d5
		move.b	$2A(a0),d3
		andi.b	#$60,d3
		beq.w	locret_406E2
		move.w	$10(a0),d2
		lea	($FFFFB000).w,a1
		move.b	$30(a0),d0
		moveq	#5,d6
		bsr.s	sub_406E4
		tst.w	d5
		bne.s	locret_406E2
		lea	($FFFFB04A).w,a1
		move.b	$31(a0),d0
		moveq	#6,d6
		bsr.s	sub_406E4

locret_406E2:

		rts
; End of function sub_406B4


; =============== S U B R O U T I N E =======================================


sub_406E4:

		btst	d6,d3
		beq.s	locret_4075C
		cmp.w	$10(a1),d2
		bcc.s	loc_40726
		btst	#5,d0
		beq.s	locret_4075C
		subq.w	#1,$32(a0)
		bpl.s	loc_40722
		move.w	#4,$32(a0)
		subq.w	#1,$10(a0)
		subq.w	#1,$10(a1)
		bsr.s	sub_4076E
		move.w	$10(a0),d3
		addi.w	#$10,d3
		jsr	(ObjHitFloor2).l
		cmpi.w	#$E,d1
		bgt.s	loc_4075E
		add.w	d1,$14(a0)

loc_40722:

		moveq	#1,d5
		rts
; ---------------------------------------------------------------------------

loc_40726:
		btst	#5,d0
		beq.s	locret_4075C
		subq.w	#1,$32(a0)
		bpl.s	loc_40722
		move.w	#4,$32(a0)
		addq.w	#1,$10(a0)
		addq.w	#1,$10(a1)
		bsr.s	sub_4076E
		move.w	$10(a0),d3
		subi.w	#$10,d3
		jsr	(ObjHitFloor2).l
		cmpi.w	#$E,d1
		bgt.s	loc_4075E
		add.w	d1,$14(a0)
		moveq	#1,d5

locret_4075C:
		rts
; ---------------------------------------------------------------------------

loc_4075E:

		bset	#1,$2A(a0)
		move.l	#loc_405D8,(a0)
		moveq	#1,d5
		rts
; End of function sub_406E4


; =============== S U B R O U T I N E =======================================


sub_4076E:

		moveq	#$69,d0
		jmp	(Play_Sound_2).l
; End of function sub_4076E

; ---------------------------------------------------------------------------
Map_SOZPushableRock:include "Levels\SOZ\Misc Object Data\Map - Pushable Rock.asm"

; ---------------------------------------------------------------------------

Obj_SOZSpringVine:

		move.l	#Map_SOZSpringVine,$C(a0)

loc_4078E:
		move.w	#$43C9,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$2C,7(a0)
		move.b	#$2C,6(a0)
		move.w	#$280,8(a0)
		bset	#7,$2A(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_40840
		move.l	#loc_40872,(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.b	4(a0),4(a1)
		move.b	#$40,7(a1)
		move.b	#$40,6(a1)
		move.w	#$200,8(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		moveq	#8,d0
		bset	#6,4(a1)
		move.w	d0,$16(a1)
		move.l	$10(a0),d1
		move.l	$14(a0),d2
		subi.l	#$280000,d1
		addi.l	#$280000,d2
		lea	$18(a1),a2
		move.w	$16(a1),d0
		subq.w	#1,d0

loc_4081C:
		swap	d1
		swap	d2
		move.w	d1,(a2)+
		move.w	d2,(a2)+
		swap	d1
		swap	d2
		move.w	#0,(a2)+
		addi.l	#$B504F,d1
		subi.l	#$B504F,d2
		dbf	d0,loc_4081C
		move.w	a1,$3C(a0)

loc_40840:
		addi.w	#$28,$14(a0)
		move.w	#$60,$30(a0)
		move.l	#loc_40852,(a0)

loc_40852:
		bsr.s	sub_40878
		bsr.w	sub_40A08
		move.w	#$30,d1
		lea	($FF8F00).l,a2
		move.w	$10(a0),d4
		jsr	(SolidObjectTopSloped).l
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_40872:
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_40878:
		moveq	#0,d4
		move.w	$30(a0),d5
		lea	$35(a0),a2
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.w	sub_4093E
		subq.w	#1,a2
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.w	sub_4093E
		move.w	d5,$30(a0)
		tst.b	$36(a0)
		bne.s	loc_408B6
		move.w	#$40,d0
		cmp.w	$32(a0),d4
		beq.s	locret_408B4
		bge.s	loc_408B0
		neg.w	d0

loc_408B0:
		add.w	d0,$32(a0)

locret_408B4:

		rts
; ---------------------------------------------------------------------------

loc_408B6:
		moveq	#0,d0
		move.b	$23(a0),d0
		addq.b	#2,$23(a0)
		move.w	word_408D4(pc,d0.w),d0
		move.w	d0,$32(a0)
		bne.s	locret_408B4
		move.b	d0,$36(a0)
		move.b	d0,$23(a0)
		rts
; End of function sub_40878

; ---------------------------------------------------------------------------
word_408D4:	dc.w $FF00
		dc.w $FF40
		dc.w $FF80
		dc.w $FFC0
		dc.w $FFFF
		dc.w $40
		dc.w $80
		dc.w $C0
		dc.w $100
		dc.w $C0
		dc.w $80
		dc.w $40
		dc.w 1
		dc.w $FFE0
		dc.w $FFC0
		dc.w $FFA0
		dc.w $FF80
		dc.w $FFA0
		dc.w $FFC0
		dc.w $FFE0
		dc.w $FFFF
		dc.w $10
		dc.w $20
		dc.w $30
		dc.w $40
		dc.w $30
		dc.w $20
		dc.w $10
		dc.w 1
		dc.w $FFF8
		dc.w $FFF0
		dc.w $FFE8
		dc.w $FFE0
		dc.w $FFE8
		dc.w $FFF0
		dc.w $FFF8
		dc.w $FFFF
		dc.w 4
		dc.w 8
		dc.w $C
		dc.w $10
		dc.w $C
		dc.w 8
		dc.w 4
		dc.w 1
		dc.w $FFFE
		dc.w $FFFC
		dc.w $FFFA
		dc.w $FFF8
		dc.w $FFFA
		dc.w $FFFC
		dc.w $FFFE
		dc.w 0

; =============== S U B R O U T I N E =======================================


sub_4093E:

		btst	d6,$2A(a0)
		bne.s	loc_4094A
		move.b	#0,(a2)
		rts
; ---------------------------------------------------------------------------

loc_4094A:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$30,d0
		cmpi.w	#$60,d0
		bcc.s	locret_409B8
		btst	#0,$2A(a0)
		beq.s	loc_4096A
		not.w	d0
		addi.w	#$60,d0

loc_4096A:
		move.w	d0,d5
		move.w	#-$100,d4
		tst.b	(a2)
		bne.s	loc_40982
		moveq	#1,d1
		cmpi.w	#$3C,d0
		bcc.s	loc_4097E
		neg.w	d1

loc_4097E:
		move.b	d1,(a2)
		rts
; ---------------------------------------------------------------------------

loc_40982:
		bpl.s	loc_40996
		cmpi.w	#$3C,d0
		bcs.s	locret_409B8
		move.b	#0,(a2)
		move.b	#1,$36(a0)
		bra.s	loc_409BA
; ---------------------------------------------------------------------------

loc_40996:
		moveq	#$18,d1
		btst	#0,$2A(a0)
		beq.s	loc_409A2
		not.w	d1

loc_409A2:
		sub.w	d1,$1C(a1)
		cmpi.w	#$3C,d0
		bcc.s	locret_409B8
		move.b	#0,(a2)
		move.b	#1,$36(a0)
		bra.s	loc_409BA
; ---------------------------------------------------------------------------

locret_409B8:

		rts
; ---------------------------------------------------------------------------

loc_409BA:

		move.w	#-$EF0,$1A(a1)
		move.w	#-$EF0,$18(a1)
		bset	#0,$2A(a1)
		btst	#0,$2A(a0)
		beq.s	loc_409DE
		bclr	#0,$2A(a1)
		neg.w	$18(a1)

loc_409DE:
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		clr.b	$40(a1)
		move.b	#$10,$20(a1)
		move.b	#2,5(a1)
		move.b	#0,$2F(a1)
		moveq	#-$4F,d0
		jmp	(Play_Sound_2).l
; End of function sub_4093E


; =============== S U B R O U T I N E =======================================


sub_40A08:
		move.w	$30(a0),d5
		beq.w	locret_40AA8
		lea	(byte_40AAA).l,a1
		moveq	#0,d0
		move.b	(a1,d5.w),d0
		muls.w	$32(a0),d0
		move.w	d5,d1
		ext.l	d1
		asl.l	#8,d1
		add.l	d1,d0

loc_40A28:
		move.l	d0,d4
		move.w	d5,d1
		divs.w	d1,d0
		ext.l	d0
		asl.l	#8,d0
		move.w	d1,d2
		subq.w	#1,d2
		lea	($FF8F00).l,a2
		moveq	#0,d3

loc_40A3E:
		move.b	d3,(a2)+
		swap	d3
		add.l	d0,d3
		swap	d3
		dbf	d2,loc_40A3E
		move.w	#$60,d2
		sub.w	d1,d2
		bls.s	loc_40A6E
		move.l	#$6000,d0
		sub.l	d4,d0
		divs.w	d2,d0
		ext.l	d0
		asl.l	#8,d0
		subq.w	#1,d2

loc_40A62:
		move.b	d3,(a2)+
		swap	d3
		add.l	d0,d3
		swap	d3
		dbf	d2,loc_40A62

loc_40A6E:
		lea	($FF8F06).l,a3
		move.w	$14(a0),d2
		addq.w	#6,d2
		movea.w	$3C(a0),a1
		lea	$1A(a1),a2
		moveq	#6,d3
		btst	#0,$2A(a0)
		beq.s	loc_40A92

loc_40A8C:
		lea	$44(a1),a2
		neg.w	d3

loc_40A92:
		moveq	#7,d0

loc_40A94:
		move.b	(a3),d1
		ext.w	d1
		neg.w	d1
		add.w	d2,d1
		move.w	d1,(a2)
		adda.w	d3,a2
		adda.w	#$C,a3
		dbf	d0,loc_40A94

locret_40AA8:
		rts
; End of function sub_40A08

; ---------------------------------------------------------------------------
byte_40AAA:	dc.b    0,   0,   1,   1,   2,   3,   3,   4,   5,   5,   6,   7,   7,   8,   9,   9,  $A,  $B,  $B,  $C
		dc.b   $D,  $D,  $E,  $F,  $F, $10, $11, $11, $12, $13, $13, $14, $15, $15, $16, $17, $17, $18, $19, $19
		dc.b  $1A, $1B, $1B, $1C, $1D, $1D, $1E, $1F, $1F, $20, $21, $21, $22, $23, $23, $24, $25, $25, $26, $27
		dc.b  $27, $28, $27, $27, $26, $25, $24, $23, $22, $21, $20, $1F, $1E, $1D, $1C, $1B, $1A, $19, $18, $17
		dc.b  $16, $15, $14, $13, $12, $11, $10,  $F,  $E,  $D,  $C,  $B,  $A,   9,   8,   7,   0,   0
Map_SOZSpringVine:include "Levels\SOZ\Misc Object Data\Map - Spring Vine.asm"

; ---------------------------------------------------------------------------

Obj_SOZRisingSandWall:

		move.l	#Map_SOZRisingSandWall,$C(a0)
		move.w	#$4432,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$C,7(a0)
		move.b	#$34,6(a0)
		move.w	#$280,8(a0)
		move.w	#$19,$30(a0)
		move.l	#loc_40B48,(a0)

loc_40B48:
		moveq	#0,d1
		move.b	$2C(a0),d1
		move.w	d1,d2
		add.w	d2,d2
		lea	($FFFFB000).w,a1
		bsr.s	sub_40B62
		lea	($FFFFB04A).w,a1
		bsr.s	sub_40B62
		bra.w	loc_40C0E

; =============== S U B R O U T I N E =======================================


sub_40B62:

		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d1,d0
		cmp.w	d2,d0
		bcc.w	locret_40BC8
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$A4,d0
		cmpi.w	#$C0,d0
		bcc.s	locret_40BC8
		tst.w	($FFFFFE08).w
		bne.s	locret_40BC8
		bset	#6,4(a0)
		move.w	#2,$16(a0)
		lea	$18(a0),a2
		move.w	$10(a0),(a2)+
		move.w	$14(a0),d0
		move.w	d0,(a2)+
		move.w	#9,(a2)+
		move.w	$10(a0),(a2)+
		move.w	$14(a0),(a2)+
		move.w	#0,(a2)+
		move.b	#3,$24(a0)
		moveq	#$47,d0
		jsr	(Play_Sound_2).l
		move.l	#loc_40BCA,(a0)

locret_40BC8:

		rts
; End of function sub_40B62

; ---------------------------------------------------------------------------

loc_40BCA:
		lea	$18(a0),a2
		subq.b	#1,$24(a0)
		bpl.s	loc_40BEC
		move.b	#3,$24(a0)
		addq.b	#1,$1D(a0)
		cmpi.b	#$D,$1D(a0)
		bcs.s	loc_40BEC
		move.b	#9,$1D(a0)

loc_40BEC:

		subq.w	#4,$14(a0)
		move.w	$14(a0),$20(a0)
		subq.w	#1,$30(a0)
		bpl.s	loc_40C0E
		bclr	#6,4(a0)
		move.w	#0,$16(a0)
		move.l	#loc_40C2A,(a0)

loc_40C0E:

		move.w	#$17,d1
		move.w	#$34,d2
		move.w	#$35,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_40C2A:
		move.w	#$17,d1
		move.w	#$34,d2
		move.w	#$35,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		swap	d6
		andi.w	#3,d6
		beq.w	loc_40CE6
		btst	#0,d6
		beq.s	loc_40C66
		lea	($FFFFB000).w,a1
		cmpi.b	#2,$20(a1)

loc_40C5A:
		bne.s	loc_40C66
		asr	$18(a1)
		asr	$1C(a1)
		bra.s	loc_40C80
; ---------------------------------------------------------------------------

loc_40C66:

		btst	#1,d6
		beq.s	loc_40CE6
		lea	($FFFFB04A).w,a1
		cmpi.b	#2,$20(a1)
		bne.s	loc_40CE6
		asr	$18(a1)
		asr	$1C(a1)

loc_40C80:
		moveq	#-$7E,d0
		jsr	(Play_Sound_2).l
		move.l	#loc_40CEC,(a0)
		move.b	#5,$24(a0)
		move.b	#1,$22(a0)
		lea	($FFFFB000).w,a1
		bclr	#3,$2A(a0)
		beq.s	loc_40CB2
		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)

loc_40CB2:
		bclr	#5,$2A(a0)
		beq.s	loc_40CC0
		bclr	#5,$2A(a1)

loc_40CC0:
		lea	($FFFFB04A).w,a1
		bclr	#4,$2A(a0)
		beq.s	loc_40CD8
		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)

loc_40CD8:
		bclr	#6,$2A(a0)
		beq.s	loc_40CE6
		bclr	#5,$2A(a1)

loc_40CE6:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_40CEC:
		subq.b	#1,$24(a0)
		bpl.s	loc_40D0A
		move.b	#5,$24(a0)
		addq.b	#1,$22(a0)
		cmpi.b	#9,$22(a0)
		bcs.s	loc_40D0A
		move.w	#$7F00,$10(a0)

loc_40D0A:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
Map_SOZRisingSandWall:include "Levels\SOZ\Misc Object Data\Map - Rising Sand Wall.asm"

; ---------------------------------------------------------------------------

Obj_SOZLightSwitch:

		move.b	#4,4(a0)
		move.b	#$18,7(a0)
		move.b	#$40,6(a0)
		move.w	#$80,8(a0)
		move.w	$14(a0),$46(a0)
		move.l	#Map_SOZLightSwitch,$C(a0)
		move.w	#$3AF,$A(a0)
		move.b	$2C(a0),d0
		andi.w	#$7F,d0
		lsl.w	#3,d0
		move.w	d0,$2E(a0)
		move.w	#2,$38(a0)
		move.b	#6,$22(a0)
		bset	#6,4(a0)
		move.w	#1,$16(a0)
		lea	$18(a0),a2
		move.w	$10(a0),(a2)+
		move.w	$14(a0),(a2)+
		move.w	#0,(a2)+
		move.l	#loc_40EC4,(a0)

loc_40EC4:
		tst.b	$34(a0)
		beq.s	loc_40ED2
		tst.w	$30(a0)
		bne.s	loc_40F0A
		bra.s	loc_40ED8
; ---------------------------------------------------------------------------

loc_40ED2:
		tst.w	$30(a0)
		beq.s	loc_40F0A

loc_40ED8:
		move.w	$36(a0),d2
		cmp.w	$2E(a0),d2
		beq.s	loc_40F2E
		add.w	$38(a0),d2
		cmp.w	$2E(a0),d2
		bne.s	loc_40F14
		move.w	#$383,($FFFFF634).w
		move.b	#0,($FFFFF7C3).w
		move.w	($FFFFF656).w,d0
		neg.b	d0
		move.b	d0,($FFFFF650).w
		move.w	#0,($FFFFF658).w
		bra.s	loc_40F14
; ---------------------------------------------------------------------------

loc_40F0A:

		move.w	$36(a0),d2
		beq.s	loc_40F2E
		sub.w	$38(a0),d2

loc_40F14:

		move.w	d2,$36(a0)
		move.w	$46(a0),d0
		add.w	d2,d0
		move.w	d0,$1A(a0)
		move.w	d2,d0
		beq.s	loc_40F2A
		lsr.w	#3,d0
		addq.w	#1,d0

loc_40F2A:
		move.b	d0,$1D(a0)

loc_40F2E:

		lea	$30(a0),a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF602).w,d0
		bsr.w	sub_40F52
		lea	($FFFFB04A).w,a1
		addq.w	#1,a2
		move.w	($FFFFF66A).w,d0
		bsr.w	sub_40F52
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_40F52:

		tst.b	(a2)
		beq.w	loc_4100E
		tst.b	4(a1)
		bpl.s	loc_40FD8
		cmpi.b	#4,5(a1)
		bcc.s	loc_40FD8
		andi.b	#$70,d0
		beq.w	loc_40FE6
		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$12,2(a2)
		andi.w	#$F00,d0
		beq.w	loc_40F88
		move.b	#$3C,2(a2)

loc_40F88:
		btst	#$A,d0
		beq.s	loc_40F94
		move.w	#-$200,$18(a1)

loc_40F94:
		btst	#$B,d0
		beq.s	loc_40FA0
		move.w	#$200,$18(a1)

loc_40FA0:
		move.w	#-$380,$1A(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$27(a1)
		rts
; ---------------------------------------------------------------------------

loc_40FD8:

		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$3C,2(a2)
		rts
; ---------------------------------------------------------------------------

loc_40FE6:
		tst.b	$2C(a0)
		bpl.s	loc_41000
		movem.l	a1-a2,-(sp)
		jsr	(SonicOnObjHitFloor).l
		movem.l	(sp)+,a1-a2
		tst.w	d1
		beq.s	loc_40FD8
		bmi.s	loc_40FD8

loc_41000:
		move.w	$1A(a0),$14(a1)
		addi.w	#$30,$14(a1)
		rts
; ---------------------------------------------------------------------------

loc_4100E:
		tst.b	2(a2)
		beq.s	loc_4101C
		subq.b	#1,2(a2)
		bne.w	locret_4108E

loc_4101C:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.w	locret_4108E
		move.w	$14(a1),d1
		sub.w	$1A(a0),d1
		subi.w	#$30,d1
		cmpi.w	#$18,d1
		bcc.w	locret_4108E
		tst.b	$2E(a1)
		bmi.s	locret_4108E
		cmpi.b	#4,5(a1)
		bcc.s	locret_4108E
		tst.w	($FFFFFE08).w
		bne.s	locret_4108E
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		move.w	$10(a0),$10(a1)
		move.w	$1A(a0),$14(a1)
		addi.w	#$30,$14(a1)

loc_41076:
		move.b	#$14,$20(a1)
		move.b	#1,$2E(a1)
		move.b	#1,(a2)
		moveq	#$5B,d0
		jsr	(Play_Sound_2).l

locret_4108E:

		rts
; End of function sub_40F52

; ---------------------------------------------------------------------------
Map_SOZLightSwitch:include "Levels\SOZ\Misc Object Data\Map - Light Switch.asm"

byte_4116A:	dc.b  $20, $40,	  0,   0
		dc.b  $20, $50,	  1, $30
		dc.b  $20, $50,	  2,  $C
; ---------------------------------------------------------------------------

Obj_SOZFloatingPillar:

		move.l	#Map_SOZFloatingPillar,$C(a0)
		move.w	#$4001,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.w	$10(a0),$44(a0)
		move.w	$14(a0),$46(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#2,d0

loc_411A4:
		andi.w	#$1C,d0
		lea	byte_4116A(pc,d0.w),a2
		move.b	(a2)+,7(a0)
		move.b	(a2)+,6(a0)
		move.b	(a2)+,$22(a0)
		move.b	(a2)+,$34(a0)
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		add.w	d0,d0
		move.w	off_41210(pc,d0.w),d0
		lea	off_41210(pc,d0.w),a1
		move.l	a1,$30(a0)
		move.l	#loc_411D8,(a0)

loc_411D8:
		move.w	$10(a0),-(sp)
		movea.l	$30(a0),a1
		jsr	(a1)
		move.w	(sp)+,d4
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		jsr	(SolidObjectFull).l
		swap	d6
		and.b	$34(a0),d6
		bne.s	loc_4121E

loc_41206:

		move.w	$44(a0),d0

loc_4120A:
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------
off_41210:	dc.w locret_4126E-off_41210

		dc.w loc_41270-off_41210
		dc.w loc_4127C-off_41210
		dc.w loc_41288-off_41210
		dc.w loc_412A8-off_41210
		dc.w loc_412B4-off_41210
		dc.w loc_412C0-off_41210
; ---------------------------------------------------------------------------

loc_4121E:
		cmpi.b	#1,$22(a0)
		bne.s	loc_4124A
		move.b	d6,d0
		andi.b	#$10,d0
		beq.s	loc_41238
		lea	($FFFFB000).w,a1
		jsr	(sub_24280).l

loc_41238:
		andi.b	#$20,d6
		beq.s	loc_41248
		lea	($FFFFB04A).w,a1
		jsr	(sub_24280).l

loc_41248:
		bra.s	loc_41206
; ---------------------------------------------------------------------------

loc_4124A:
		move.b	d6,d0

loc_4124C:
		andi.b	#4,d0
		beq.s	loc_4125C
		lea	($FFFFB000).w,a1
		jsr	(sub_24280).l

loc_4125C:
		andi.b	#8,d6
		beq.s	loc_4126C
		lea	($FFFFB04A).w,a1
		jsr	(sub_24280).l

loc_4126C:
		bra.s	loc_41206
; ---------------------------------------------------------------------------

locret_4126E:
		rts
; ---------------------------------------------------------------------------

loc_41270:
		moveq	#0,d0
		move.b	($FFFFFE78).w,d0
		subi.w	#$20,d0
		bra.s	loc_41294
; ---------------------------------------------------------------------------

loc_4127C:
		moveq	#0,d0
		move.b	($FFFFFE8C).w,d0
		subi.w	#$40,d0
		bra.s	loc_41294
; ---------------------------------------------------------------------------

loc_41288:
		moveq	#0,d0
		move.b	($FFFFFEA8).w,d0
		add.w	d0,d0
		subi.w	#$80,d0

loc_41294:

		btst	#0,$2A(a0)
		beq.s	loc_4129E
		neg.w	d0

loc_4129E:
		add.w	$44(a0),d0
		move.w	d0,$10(a0)
		rts
; ---------------------------------------------------------------------------

loc_412A8:
		moveq	#0,d0
		move.b	($FFFFFE78).w,d0
		subi.w	#$20,d0
		bra.s	loc_412CC
; ---------------------------------------------------------------------------

loc_412B4:
		moveq	#0,d0
		move.b	($FFFFFE8C).w,d0
		subi.w	#$40,d0
		bra.s	loc_412CC
; ---------------------------------------------------------------------------

loc_412C0:
		moveq	#0,d0
		move.b	($FFFFFEA8).w,d0
		add.w	d0,d0
		subi.w	#$80,d0

loc_412CC:

		btst	#0,$2A(a0)
		beq.s	loc_412D6
		neg.w	d0

loc_412D6:
		add.w	$46(a0),d0
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------
Map_SOZFloatingPillar:include "Levels\SOZ\Misc Object Data\Map - Floating Pillar.asm"

; ---------------------------------------------------------------------------

Obj_SOZSwingingPlatform:

		move.l	#Map_SOZSwingingPlatform,$C(a0)
		move.w	#$4001,$A(a0)
		move.b	#4,4(a0)
		move.b	#$20,7(a0)
		move.b	#$10,6(a0)
		move.w	#$280,8(a0)
		move.w	$10(a0),$44(a0)
		move.w	$14(a0),$46(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_414E6
		move.l	#Draw_Sprite,(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.b	#4,4(a1)
		move.b	#$60,7(a1)
		move.b	#$60,6(a1)
		move.w	#$280,8(a1)
		move.w	$10(a0),d2
		move.w	d2,$10(a1)
		move.w	$14(a0),d3
		move.w	d3,$14(a1)
		bset	#6,4(a1)
		lea	$18(a1),a2
		move.b	$2C(a0),d1
		andi.w	#$F,d1
		move.w	d1,$16(a1)
		subq.w	#1,d1

loc_414CA:
		move.w	d2,(a2)+
		move.w	d3,(a2)+
		move.w	#1,(a2)+
		dbf	d1,loc_414CA
		move.b	#2,$1D(a1)
		move.b	#1,$22(a1)
		move.w	a1,$3C(a0)

loc_414E6:
		move.w	#$4000,$26(a0)

loc_414EC:
		move.w	#0,$32(a0)
		andi.b	#-$10,$2C(a0)
		move.l	#loc_414FE,(a0)

loc_414FE:
		move.w	$10(a0),-(sp)
		bsr.w	sub_4154C
		move.w	#$20,d1
		move.w	#$11,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectTop).l
		move.w	$44(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_41530
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_41530:
		move.w	$48(a0),d0
		beq.s	loc_4153C
		movea.w	d0,a2
		bclr	#7,(a2)

loc_4153C:
		movea.w	$3C(a0),a1
		jsr	(Delete_Referenced_Sprite).l
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_4154C:
		moveq	#0,d0
		moveq	#0,d1
		move.b	($FFFFFE88).w,d0
		addi.b	#-$80,d0
		tst.b	$2C(a0)
		beq.s	loc_41562
		bsr.w	sub_41636

loc_41562:
		cmp.b	$36(a0),d0
		beq.w	locret_41634
		move.b	d0,$36(a0)
		btst	#0,$2A(a0)
		beq.s	loc_4157C
		neg.w	d0
		addi.w	#$80,d0

loc_4157C:
		btst	#1,$2A(a0)
		beq.s	loc_41586
		neg.w	d0

loc_41586:
		jsr	(GetSineCosine).l
		move.w	$46(a0),d2
		move.w	$44(a0),d3
		moveq	#0,d6
		movea.w	$3C(a0),a1
		move.w	$16(a1),d6
		subq.w	#2,d6
		bcs.w	locret_41634
		swap	d0
		swap	d1
		asr.l	#4,d0
		asr.l	#4,d1
		move.l	d0,d4
		move.l	d1,d5
		asr.l	#1,d4
		asr.l	#1,d5
		add.l	d0,d4
		add.l	d1,d5
		lea	$1E(a1),a2

loc_415BC:
		movem.l	d4-d5,-(sp)
		swap	d4
		swap	d5
		add.w	d2,d4
		add.w	d3,d5
		move.w	d5,(a2)+
		move.w	d4,(a2)+
		movem.l	(sp)+,d4-d5
		add.l	d0,d4
		add.l	d1,d5
		addq.w	#2,a2
		dbf	d6,loc_415BC
		movem.l	d4-d5,-(sp)
		swap	d4
		swap	d5
		add.w	d2,d4
		add.w	d3,d5
		move.w	$24(a1),d2
		move.w	$26(a1),d3
		move.w	d5,$24(a1)
		move.w	d4,$26(a1)
		move.w	d2,$10(a1)
		move.w	d3,$14(a1)
		movem.l	(sp)+,d4-d5
		asr.l	#1,d0
		asr.l	#1,d1

loc_41606:
		add.l	d0,d4
		add.l	d1,d5
		swap	d4
		swap	d5
		add.w	$46(a0),d4
		add.w	$44(a0),d5
		move.w	d4,$14(a0)
		tst.b	$2C(a0)
		beq.s	loc_41630
		subi.w	#$18,d5
		btst	#0,$2A(a0)
		beq.s	loc_41630
		addi.w	#$30,d5

loc_41630:

		move.w	d5,$10(a0)

locret_41634:

		rts
; End of function sub_4154C


; =============== S U B R O U T I N E =======================================


sub_41636:
		tst.w	$34(a0)
		beq.s	loc_4164C
		btst	#3,$2A(a0)
		bne.s	loc_416C0
		subq.w	#1,$34(a0)
		bra.w	loc_416C0
; ---------------------------------------------------------------------------

loc_4164C:
		tst.b	$31(a0)
		bne.s	loc_41668
		btst	#3,$2A(a0)
		beq.s	loc_416C0
		tst.w	($FFFFFE08).w
		bne.w	loc_416C0
		move.b	#1,$31(a0)

loc_41668:
		tst.b	$30(a0)
		bne.s	loc_41698
		move.w	$32(a0),d0
		addi.w	#8,d0
		move.w	d0,$32(a0)
		add.w	d0,$26(a0)
		tst.w	d0
		bne.s	loc_41688
		move.b	#0,$31(a0)

loc_41688:
		cmpi.b	#-$80,$26(a0)
		bcs.s	loc_416C0
		move.b	#1,$30(a0)
		bra.s	loc_416C0
; ---------------------------------------------------------------------------

loc_41698:
		move.w	$32(a0),d0
		subi.w	#8,d0
		move.w	d0,$32(a0)
		add.w	d0,$26(a0)
		tst.w	d0
		bne.s	loc_416B2
		move.w	#$1E,$34(a0)

loc_416B2:
		cmpi.b	#-$80,$26(a0)
		bcc.s	loc_416C0
		move.b	#0,$30(a0)

loc_416C0:

		move.b	$26(a0),d0
		rts
; End of function sub_41636

; ---------------------------------------------------------------------------
Map_SOZSwingingPlatform:include "Levels\SOZ\Misc Object Data\Map - Swinging Platform.asm"

; ---------------------------------------------------------------------------

Obj_SOZBreakableSandRock:

		move.l	#Map_SOZBreakableSandRock,$C(a0)
		move.w	#$43D9,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$18,7(a0)
		move.b	#$10,6(a0)
		move.w	#$280,8(a0)
		move.l	#loc_4172E,(a0)

loc_4172E:
		move.b	($FFFFB020).w,$30(a0)
		move.b	($FFFFB06A).w,$31(a0)
		move.w	#$23,d1
		move.w	#$10,d2
		move.w	#$11,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		bne.s	loc_41760

loc_4175A:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_41760:
		cmpi.b	#$18,d0
		bne.s	loc_4178E
		cmpi.b	#2,$30(a0)
		beq.s	loc_41776
		cmpi.b	#2,$31(a0)
		bne.s	loc_4175A

loc_41776:
		lea	($FFFFB000).w,a1
		move.b	$30(a0),d0
		bsr.s	sub_417A6
		lea	($FFFFB04A).w,a1
		move.b	$31(a0),d0
		bsr.s	sub_417A6
		bra.w	loc_417F6
; ---------------------------------------------------------------------------

loc_4178E:
		move.b	d0,d1
		andi.b	#8,d1
		beq.s	loc_417DE
		cmpi.b	#2,$30(a0)
		bne.s	loc_4175A
		lea	($FFFFB000).w,a1
		bsr.s	sub_417AC

loc_417A4:
		bra.s	loc_417F6

; =============== S U B R O U T I N E =======================================


sub_417A6:

		cmpi.b	#2,d0
		bne.s	loc_417CA
; End of function sub_417A6


; =============== S U B R O U T I N E =======================================


sub_417AC:

		bset	#2,$2A(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		move.w	#-$300,$1A(a1)

loc_417CA:
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		move.b	#2,5(a1)
		rts
; End of function sub_417AC

; ---------------------------------------------------------------------------

loc_417DE:
		andi.b	#$10,d0
		beq.w	loc_4175A
		cmpi.b	#2,$31(a0)
		bne.w	loc_4175A
		lea	($FFFFB04A).w,a1
		bsr.s	sub_417AC

loc_417F6:

		andi.b	#-$19,$2A(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		move.l	#loc_4180A,(a0)

loc_4180A:
		subq.b	#1,$24(a0)
		bpl.s	loc_41828
		move.b	#5,$24(a0)
		addq.b	#1,$22(a0)
		cmpi.b	#5,$22(a0)
		bcs.s	loc_41828
		move.w	#$7F00,$10(a0)

loc_41828:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
Map_SOZBreakableSandRock:include "Levels\SOZ\Misc Object Data\Map - Breakable Sand Rock.asm"

; ---------------------------------------------------------------------------

Obj_SOZPushSwitch:

		move.l	#Map_SOZPushSwitch,$C(a0)
		move.w	#$4455,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$30,7(a0)
		move.b	#$10,6(a0)
		move.w	#$300,8(a0)
		move.b	#1,$22(a0)
		move.w	$10(a0),$44(a0)
		bset	#6,4(a0)
		move.w	#1,$16(a0)
		lea	$18(a0),a2
		move.w	$10(a0),d0
		addi.w	#$10,d0
		btst	#0,$2A(a0)
		beq.s	loc_418D4
		subi.w	#$20,d0

loc_418D4:
		move.w	d0,(a2)+
		move.w	$14(a0),(a2)+
		move.w	#0,(a2)+
		move.l	#loc_418E4,(a0)

loc_418E4:
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		lea	(a3,d0.w),a3
		moveq	#0,d1
		move.b	(a3),d1
		move.w	d1,$36(a0)
		move.b	($FFFFB02A).w,$30(a0)
		move.b	($FFFFB074).w,$31(a0)
		move.w	#$17,d1

loc_4190C:
		move.w	#$10,d2
		move.w	#$11,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		moveq	#0,d4
		bsr.w	sub_419C6
		move.w	$36(a0),d0
		lsr.w	#2,d0
		btst	#0,$2A(a0)
		beq.s	loc_41934
		neg.w	d0

loc_41934:
		add.w	$44(a0),d0

loc_41938:
		move.w	d0,$10(a0)
		tst.b	$2C(a0)
		bpl.s	loc_41946
		bsr.w	sub_41AA8

loc_41946:
		move.w	$36(a0),d1
		move.b	d1,(a3)
		move.w	$44(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_41966
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_41966:
		move.w	$48(a0),d0
		beq.s	loc_41972
		movea.w	d0,a2
		bclr	#7,(a2)

loc_41972:
		tst.w	$36(a0)
		bne.s	loc_4197E
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_4197E:
		move.l	#loc_41984,(a0)

loc_41984:
		move.w	$48(a0),d0
		beq.s	loc_41996
		movea.w	d0,a2
		tst.b	(a2)
		bpl.s	loc_41996
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_41996:

		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3

loc_419A2:
		lea	(a3,d0.w),a3
		moveq	#0,d1
		move.b	(a3),d1
		move.w	d1,$36(a0)
		bsr.w	sub_41A6C
		move.w	$36(a0),d1
		move.b	d1,(a3)
		tst.w	$36(a0)
		bne.s	locret_419C4
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

locret_419C4:
		rts

; =============== S U B R O U T I N E =======================================


sub_419C6:
		moveq	#0,d5
		move.b	$2A(a0),d3
		andi.b	#$60,d3
		beq.w	sub_41A6C
		move.w	$10(a0),d2
		lea	($FFFFB000).w,a1
		move.b	$30(a0),d0
		moveq	#5,d6
		bsr.s	sub_419FA
		tst.w	d5
		bne.s	locret_419F8
		lea	($FFFFB04A).w,a1
		move.b	$31(a0),d0
		moveq	#6,d6
		bsr.s	sub_419FA
		tst.w	d5
		beq.s	sub_41A6C

locret_419F8:
		rts
; End of function sub_419C6


; =============== S U B R O U T I N E =======================================


sub_419FA:

		btst	d6,d3
		beq.s	locret_41A6A
		cmp.w	$10(a1),d2

loc_41A02:
		bcc.s	loc_41A38
		btst	#5,d0
		beq.s	locret_41A6A

loc_41A0A:
		btst	#0,$2A(a0)
		beq.s	locret_41A6A
		cmpi.w	#$80,$36(a0)
		beq.s	loc_41A34
		addq.w	#1,$36(a0)
		move.w	$36(a0),d0
		andi.w	#3,d0
		bne.s	loc_41A34
		subq.w	#1,$10(a1)
		moveq	#$69,d0
		jsr	(Play_Sound_2).l

loc_41A34:

		moveq	#1,d5
		rts
; ---------------------------------------------------------------------------

loc_41A38:
		btst	#5,d0
		beq.s	locret_41A6A
		btst	#0,$2A(a0)
		bne.s	locret_41A6A
		cmpi.w	#$80,$36(a0)
		beq.s	loc_41A34
		addq.w	#1,$36(a0)
		move.w	$36(a0),d0
		andi.w	#3,d0
		bne.s	loc_41A34
		addq.w	#1,$10(a1)
		moveq	#$69,d0
		jsr	(Play_Sound_2).l
		moveq	#1,d5

locret_41A6A:
		rts
; End of function sub_419FA


; =============== S U B R O U T I N E =======================================


sub_41A6C:

		move.b	$2C(a0),d0
		andi.w	#$70,d0
		bne.s	loc_41A82
		subq.w	#1,$34(a0)
		bpl.s	locret_41AA6
		move.w	#9,$34(a0)

loc_41A82:
		tst.w	$36(a0)
		beq.s	locret_41AA6
		moveq	#-$6F,d0
		subq.w	#1,$36(a0)
		beq.s	loc_41A9E
		subq.b	#1,$3A(a0)
		bpl.s	loc_41AA4
		move.b	#3,$3A(a0)
		moveq	#-$70,d0

loc_41A9E:
		jsr	(Play_Sound_2).l

loc_41AA4:
		moveq	#1,d4

locret_41AA6:

		rts
; End of function sub_41A6C


; =============== S U B R O U T I N E =======================================


sub_41AA8:
		move.w	($FFFFF7C4).w,d0
		beq.w	locret_41B54
		movea.w	d0,a2
		cmpi.l	#loc_405D6,(a2)
		beq.s	loc_41AC2
		move.w	#0,($FFFFF7C4).w
		rts
; ---------------------------------------------------------------------------

loc_41AC2:
		move.w	$10(a2),d2

loc_41AC6:
		sub.w	$10(a0),d2
		addi.w	#$1B,d2
		cmpi.w	#$37,d2
		bcc.s	loc_41B4E
		move.w	$14(a2),d3
		sub.w	$14(a0),d3
		addi.w	#$C,d3
		cmpi.w	#$18,d3
		bcc.s	loc_41B4E
		move.b	$2A(a0),d0
		cmpi.w	#$1C,d2
		bcs.s	loc_41AF4
		eori.b	#1,d0

loc_41AF4:
		andi.b	#1,d0
		bne.s	loc_41B24

loc_41AFA:
		cmpi.w	#$80,$36(a0)
		beq.s	loc_41B24
		moveq	#4,d1
		add.w	d4,d1
		move.w	$38(a0),d0
		cmp.w	$10(a2),d0
		bne.s	loc_41B12
		moveq	#1,d1

loc_41B12:
		add.w	d1,$36(a0)
		cmpi.w	#$80,$36(a0)
		bcs.s	loc_41B24
		move.w	#$80,$36(a0)

loc_41B24:

		move.w	$36(a0),d0
		lsr.w	#2,d0
		btst	#0,$2A(a0)
		beq.s	loc_41B34
		neg.w	d0

loc_41B34:
		add.w	$44(a0),d0
		move.w	d0,$10(a0)
		subi.w	#$1C,d0
		cmpi.w	#$1C,d2
		bcs.s	loc_41B4A
		addi.w	#$38,d0

loc_41B4A:
		move.w	d0,$10(a2)

loc_41B4E:

		move.w	$10(a2),$38(a0)

locret_41B54:
		rts
; End of function sub_41AA8

; ---------------------------------------------------------------------------
Map_SOZPushSwitch:include "Levels\SOZ\Misc Object Data\Map - Push Switch.asm"

; ---------------------------------------------------------------------------

Obj_SOZDoor:

		move.l	#Map_SOZDoor,$C(a0)
		move.w	#$4455,$A(a0)

loc_41B7E:
		ori.b	#4,4(a0)
		move.b	#$C,7(a0)
		move.b	#$40,6(a0)
		move.w	#$200,8(a0)
		move.w	$10(a0),$44(a0)
		move.w	$14(a0),$46(a0)
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		move.b	(a3,d0.w),d0
		move.w	d0,$36(a0)
		move.b	$2C(a0),d0
		andi.w	#$F0,d0
		beq.s	loc_41BDA
		move.b	#1,$22(a0)
		move.b	#$40,7(a0)
		move.b	#$C,6(a0)
		move.l	#loc_41C3A,(a0)
		bra.s	loc_41C3A
; ---------------------------------------------------------------------------

loc_41BDA:
		move.l	#loc_41BE0,(a0)

loc_41BE0:
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		move.b	(a3,d0.w),d0
		moveq	#1,d1
		cmp.w	$36(a0),d0
		beq.s	loc_41C00
		bcc.s	loc_41BFC
		neg.w	d1

loc_41BFC:
		add.w	d1,$36(a0)

loc_41C00:
		move.w	$36(a0),d0
		btst	#0,$2A(a0)
		bne.s	loc_41C0E
		neg.w	d0

loc_41C0E:
		add.w	$46(a0),d0
		move.w	d0,$14(a0)

loc_41C16:
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_41C3A:

		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		move.b	(a3,d0.w),d0
		moveq	#1,d1
		cmp.w	$36(a0),d0
		beq.s	loc_41C5A
		bcc.s	loc_41C56
		neg.w	d1

loc_41C56:
		add.w	d1,$36(a0)

loc_41C5A:
		move.w	$36(a0),d0
		btst	#0,$2A(a0)
		bne.s	loc_41C68
		neg.w	d0

loc_41C68:
		add.w	$44(a0),d0
		move.w	d0,$10(a0)
		bra.s	loc_41C16
; ---------------------------------------------------------------------------
Map_SOZDoor:	include "Levels\SOZ\Misc Object Data\Map - Door.asm"

; ---------------------------------------------------------------------------

Obj_SOZSandCork:

		move.l	#Map_SOZSandCork,$C(a0)
		move.w	#$43BD,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$C,7(a0)
		move.b	#8,6(a0)
		move.w	#$280,8(a0)
		move.b	#-$3A,$28(a0)
		move.w	$48(a0),d0
		beq.s	loc_41D2C
		movea.w	d0,a2
		btst	#0,(a2)
		beq.s	loc_41D2C

loc_41CFC:
		move.b	$2C(a0),d5
		andi.w	#$7F,d5
		lsl.w	#4,d5
		moveq	#0,d4
		move.w	$14(a0),d3
		add.w	d5,d3
		subi.w	#$90,d3

loc_41D12:
		bsr.w	sub_41E1A
		subi.w	#$100,d3
		subi.w	#$100,d5
		bhi.s	loc_41D12
		move.w	$48(a0),$48(a1)
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_41D2C:

		move.l	#loc_41D32,(a0)

loc_41D32:
		move.b	$29(a0),d0
		beq.w	loc_41D56
		lea	($FFFFB000).w,a1
		bclr	#0,$29(a0)
		beq.s	loc_41D48
		bsr.s	sub_41D5C

loc_41D48:
		lea	($FFFFB04A).w,a1
		bclr	#1,$29(a0)
		beq.s	loc_41D56
		bsr.s	sub_41D5C

loc_41D56:

		jmp	(loc_1B662).l

; =============== S U B R O U T I N E =======================================


sub_41D5C:

		cmpi.b	#2,$20(a1)
		bne.w	locret_41DF2
		neg.w	$18(a1)
		neg.w	$1A(a1)
		move.b	$2C(a0),d4
		andi.w	#$7F,d4
		lsl.w	#4,d4
		move.w	d4,d5
		move.w	$14(a0),d3
		subi.w	#$90,d3

loc_41D82:
		bsr.w	sub_41E1A
		subi.w	#$100,d3
		subi.w	#$100,d5
		bcc.s	loc_41D82
		move.w	$48(a0),$48(a1)
		lea	(word_41E96).l,a4
		move.l	#loc_41DF4,(a0)
		addq.b	#1,$22(a0)
		move.w	#0,8(a0)
		moveq	#$59,d0
		jsr	(Play_Sound_2).l
		jsr	(loc_216BE).l
		jsr	(MoveSprite2).l
		addi.w	#$18,$1A(a0)
		move.w	$48(a0),d0
		beq.s	loc_41DD2
		movea.w	d0,a2
		bset	#0,(a2)

loc_41DD2:
		tst.b	$2C(a0)
		bpl.s	loc_41DE0
		move.w	#-1,($FFFFEEC4).w
		bra.s	loc_41DE6
; ---------------------------------------------------------------------------

loc_41DE0:
		move.w	#-1,($FFFFEEC6).w

loc_41DE6:
		move.b	#0,$28(a0)
		move.b	#0,$29(a0)

locret_41DF2:
		rts
; End of function sub_41D5C

; ---------------------------------------------------------------------------

loc_41DF4:
		jsr	(MoveSprite2).l
		addi.w	#$18,$1A(a0)
		cmpi.w	#$400,$1A(a0)
		blt.s	loc_41E0E
		tst.b	4(a0)
		bpl.s	loc_41E14

loc_41E0E:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_41E14:
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_41E1A:

		jsr	(Create_New_Sprite).l
		bne.w	locret_41E68
		move.l	#loc_41E6A,(a1)
		move.w	$10(a0),$10(a1)
		move.w	d3,$14(a1)
		move.b	4(a0),4(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.w	#$80,8(a1)
		move.b	#$C,7(a1)
		move.b	#-$80,6(a1)
		move.w	d4,$30(a1)
		move.b	#2,$22(a1)
		move.b	$2C(a0),$2C(a1)

locret_41E68:
		rts
; End of function sub_41E1A

; ---------------------------------------------------------------------------

loc_41E6A:
		tst.w	$30(a0)
		beq.s	loc_41E78
		addq.w	#4,$14(a0)
		subq.w	#4,$30(a0)

loc_41E78:
		move.b	-$1FB(a0),d0
		andi.b	#$F,d0
		bne.s	loc_41E90
		tst.b	4(a0)
		bpl.s	loc_41E90
		moveq	#-$38,d0
		jsr	(Play_Sound_2).l

loc_41E90:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
word_41E96:	dc.w  $FE00, $FE00
		dc.w	$80, $FE00
		dc.w   $200, $FE00
		dc.w  $FE20, $FE20
		dc.w	$60, $FE20
		dc.w   $1E0, $FE20
Map_SOZSandCork:include "Levels\SOZ\Misc Object Data\Map - Sand Cork.asm"

; ---------------------------------------------------------------------------

Obj_SOZSolidSprites:

		move.l	#Map_SOZSolidSprites,$C(a0)
		move.w	#$4001,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$200,8(a0)
		tst.b	$2C(a0)
		beq.s	loc_41F7E
		move.b	#$20,7(a0)
		move.b	#8,6(a0)
		move.b	#1,$22(a0)
		move.l	#loc_41FAC,(a0)
		bra.s	loc_41FAC
; ---------------------------------------------------------------------------

loc_41F7E:
		move.b	#$10,7(a0)
		move.b	#$18,6(a0)
		move.l	#loc_41F90,(a0)

loc_41F90:
		move.w	#$1B,d1
		move.w	#$18,d2
		move.w	#$19,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_41FAC:

		move.w	#$2B,d1
		move.w	#8,d2
		move.w	#9,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
Map_SOZSolidSprites:include "Levels\SOZ\Misc Object Data\Map - Solid Sprites.asm"

; ---------------------------------------------------------------------------

Obj_LevelIntro_PlayerFallIntoGround:
		move.l	#loc_42028,(a0)
		move.b	#1,($FFFFF7CA).w
		move.b	#1,($FFFFF7CB).w
		moveq	#0,d0
		move.w	d0,($FFFFF602).w
		move.w	d0,($FFFFF604).w
		move.w	d0,($FFFFF66A).w
		move.w	d0,($FFFFF606).w
		lea	($FFFFB000).w,a1
		bsr.s	sub_42020
		lea	($FFFFB04A).w,a1
		tst.l	(a1)
		beq.s	locret_42026

; =============== S U B R O U T I N E =======================================


sub_42020:
		move.b	#1,$2E(a1)

locret_42026:
		rts
; End of function sub_42020

; ---------------------------------------------------------------------------

loc_42028:
		move.b	#1,($FFFFF7CA).w
		move.b	#1,($FFFFF7CB).w
		move.w	#0,($FFFFF602).w
		move.w	#0,($FFFFF66A).w
		lea	($FFFFB000).w,a1
		bsr.s	sub_42092
		lea	($FFFFB04A).w,a1
		tst.l	(a1)
		beq.s	loc_42050
		bsr.s	sub_42092

loc_42050:
		lea	($FFFFB000).w,a2
		move.w	#$690,d0
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_42062
		addq.w	#4,d0

loc_42062:
		cmp.w	$14(a2),d0
		bne.s	loc_42080
		bsr.w	loc_42180
		moveq	#-$7E,d0
		jsr	(Play_Sound_2).l
		lea	($FFFFB04A).w,a2
		tst.l	(a2)
		beq.s	loc_42080
		bsr.w	loc_42180

loc_42080:

		cmpi.w	#$6C0,($FFFFB014).w
		bcc.s	loc_4208A
		rts
; ---------------------------------------------------------------------------

loc_4208A:
		move.l	#loc_420A6,(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_42092:

		move.w	$1A(a1),d0
		addi.w	#$38,$1A(a1)
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$14(a1)
		rts
; End of function sub_42092

; ---------------------------------------------------------------------------

loc_420A6:
		move.b	#1,($FFFFF7CA).w
		move.b	#1,($FFFFF7CB).w
		move.w	#0,($FFFFF602).w
		move.w	#0,($FFFFF66A).w
		move.b	($FFFFF605).w,d0
		andi.b	#$70,d0
		bne.s	loc_420CA
		rts
; ---------------------------------------------------------------------------

loc_420CA:
		move.l	#loc_420FC,(a0)
		lea	($FFFFB000).w,a1
		bsr.s	sub_420DE
		lea	($FFFFB04A).w,a1
		tst.l	(a1)
		beq.s	locret_420FA

; =============== S U B R O U T I N E =======================================


sub_420DE:
		move.w	#-$800,$1A(a1)
		bset	#1,$2A(a1)
		clr.b	$40(a1)
		move.b	#$10,$20(a1)
		move.b	#1,$2E(a1)

locret_420FA:
		rts
; End of function sub_420DE

; ---------------------------------------------------------------------------

loc_420FC:
		move.b	#1,($FFFFF7CA).w
		move.b	#1,($FFFFF7CB).w
		move.w	#0,($FFFFF602).w
		move.w	#0,($FFFFF66A).w
		lea	($FFFFB000).w,a2
		cmpi.w	#$6A8,$14(a2)
		bcc.s	loc_42156
		move.b	#0,$2E(a2)
		bsr.w	loc_42180
		lea	($FFFFB04A).w,a2
		tst.l	(a2)
		beq.s	loc_4213C
		move.b	#0,$2E(a2)
		bsr.w	loc_42180

loc_4213C:
		moveq	#-$7E,d0
		jsr	(Play_Sound_2).l
		move.b	#0,($FFFFF7CA).w
		move.b	#0,($FFFFF7CB).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_42156:
		bsr.s	sub_42160
		lea	($FFFFB04A).w,a2
		tst.l	(a2)
		beq.s	locret_4217E

; =============== S U B R O U T I N E =======================================


sub_42160:
		move.w	$18(a2),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$10(a2)
		move.w	$1A(a2),d0
		addi.w	#$38,$1A(a2)
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$14(a2)

locret_4217E:
		rts
; End of function sub_42160

; ---------------------------------------------------------------------------

loc_42180:

		jsr	(Create_New_Sprite3).l
		bne.w	locret_4219C
		move.l	#loc_4219E,(a1)
		move.w	$10(a2),$10(a1)
		move.w	#$66C,$14(a1)

locret_4219C:
		rts
; ---------------------------------------------------------------------------

loc_4219E:
		move.l	#Map_SOZRisingSandWall,$C(a0)
		move.w	#$4432,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$C,7(a0)
		move.b	#$34,6(a0)
		move.w	#$80,8(a0)
		move.b	#8,$22(a0)
		bset	#6,4(a0)
		move.w	#1,$16(a0)
		lea	$18(a0),a2
		move.w	$10(a0),(a2)+
		move.w	$14(a0),d0
		addi.w	#$68,d0
		move.w	d0,(a2)+
		move.w	#$D,(a2)+
		move.b	#3,$24(a0)
		move.w	#$13,$30(a0)
		move.l	#loc_421FE,(a0)

loc_421FE:
		lea	$18(a0),a2
		subq.b	#1,$24(a0)
		bpl.s	loc_4222E
		move.b	#3,$24(a0)
		bchg	#0,4(a0)
		addq.w	#1,$14(a0)
		addq.w	#1,$1A(a0)
		addq.b	#1,$1D(a0)
		cmpi.b	#$D,$1D(a0)
		bcs.s	loc_4222E
		move.b	#9,$1D(a0)

loc_4222E:

		cmpi.w	#$C,$30(a0)
		bne.s	loc_4223C
		move.b	#$D,$22(a0)

loc_4223C:
		subq.w	#1,$30(a0)
		bpl.s	loc_42248
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_42248:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_15_2:
		move.b	#-$30,7(a0)
		move.l	#loc_4225A,(a0)

loc_4225A:
		bsr.s	sub_42262
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_42262:
		lea	($FFFFB000).w,a1
		lea	$30(a0),a2
		moveq	#3,d6
		bsr.s	sub_42278
		lea	($FFFFB04A).w,a1
		lea	$34(a0),a2
		addq.b	#1,d6
; End of function sub_42262


; =============== S U B R O U T I N E =======================================


sub_42278:
		btst	d6,$2A(a0)

loc_4227C:
		bne.w	loc_42362
		move.w	$10(a1),d0
		addi.w	#$10,d0
		sub.w	$10(a0),d0
		bcs.w	locret_42360

loc_42290:
		cmpi.w	#$20,d0
		bge.w	locret_42360
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$10,d0

loc_422A4:
		cmpi.w	#$20,d0
		bgt.w	locret_42360
		tst.b	$2E(a1)
		bne.w	locret_42360
		btst	#1,$2A(a1)
		bne.w	locret_42360
		tst.w	$1C(a1)
		bmi.w	locret_42360
		cmpi.w	#$600,$1C(a1)
		bge.w	loc_422D6
		move.w	#$600,$1C(a1)

loc_422D6:
		btst	#3,$2A(a1)
		beq.s	loc_422E6
		movea.w	$42(a1),a3
		bclr	d6,$2A(a3)

loc_422E6:
		move.w	a0,$42(a1)
		bset	d6,$2A(a0)
		move.w	#0,$18(a1)
		move.w	#0,$1A(a1)
		move.b	$44(a1),$1E(a1)
		move.b	$45(a1),$1F(a1)
		andi.b	#-$77,$2A(a1)
		bset	#3,$2A(a1)
		move.b	#0,$40(a1)

loc_42318:
		move.w	#0,($FFFFF7D0).w
		move.b	#0,$26(a1)
		move.b	#0,$27(a1)
		move.b	#0,$2D(a1)
		move.b	#0,$30(a1)
		move.b	#0,$39(a1)
		move.b	#0,$2F(a1)
		move.l	#0,(a2)
		bclr	#0,$2A(a1)
		andi.b	#-4,4(a1)
		move.b	#$43,$2E(a1)
		move.b	#0,$20(a1)

locret_42360:

		rts
; ---------------------------------------------------------------------------

loc_42362:
		tst.w	($FFFFFE08).w
		beq.s	loc_423D0

loc_42368:
		andi.b	#-$7F,$2A(a1)
		bset	#1,$2A(a1)
		bclr	d6,$2A(a0)

loc_42378:
		move.w	#1,$20(a1)
		move.b	#0,$2E(a1)
		neg.w	$1C(a1)
		move.w	$1C(a1),$18(a1)
		move.w	#0,$1A(a1)
		rts
; ---------------------------------------------------------------------------

loc_42396:
		move.b	#$E,$46(a1)
		move.b	#$F,$47(a1)
		andi.b	#-$7F,$2A(a1)
		bset	#0,$2A(a1)
		bclr	d6,$2A(a0)
		move.w	#1,$20(a1)
		move.b	#0,$2E(a1)
		neg.w	$1C(a1)
		move.w	$1C(a1),$18(a1)
		move.w	#0,$1A(a1)
		rts
; ---------------------------------------------------------------------------

loc_423D0:
		move.w	$1C(a1),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,(a2)
		bmi.s	loc_42368
		cmpi.w	#$700,(a2)
		bcc.s	loc_42396
		cmpi.w	#$1000,$1C(a1)
		bge.s	loc_423F0
		addi.w	#$10,$1C(a1)

loc_423F0:
		bclr	#7,$A(a1)
		move.w	(a2),d0
		lsr.w	#1,d0
		addi.b	#$40,d0
		bmi.s	loc_42406
		bset	#7,$A(a1)

loc_42406:
		move.w	$10(a1),d2
		move.w	(a2),d0
		lsr.w	#1,d0
		jsr	(GetSineCosine).l
		muls.w	#$4800,d0
		swap	d0
		add.w	$10(a0),d0
		move.w	d0,$10(a1)
		sub.w	d2,d0
		asl.w	#8,d0
		move.w	d0,$18(a1)
		lea	byte_4248A(pc),a3
		cmpi.w	#$600,(a2)
		bcs.s	loc_42438
		lea	byte_4250A(pc),a3

loc_42438:
		move.w	$14(a1),d2
		move.w	(a2),d0
		lsr.w	#2,d0
		move.w	d0,d1
		andi.w	#$7F,d1
		andi.w	#-$80,d0
		add.b	(a3,d1.w),d0
		add.w	$14(a0),d0
		move.w	d0,$14(a1)
		sub.w	d2,d0
		asl.w	#8,d0
		move.w	d0,$1A(a1)
		moveq	#0,d0
		move.w	(a2),d0
		lsr.w	#1,d0
		andi.w	#$FF,d0
		divu.w	#$16,d0
		move.b	RawAni_4247E(pc,d0.w),$22(a1)
		moveq	#0,d0
		move.b	$22(a1),d0
		jmp	(Tails_Carry_LoadPLC).l
; End of function sub_42278

; ---------------------------------------------------------------------------
RawAni_4247E:	dc.b  $EF, $FA,	$F9, $F8, $F7, $F6, $F5, $F4, $F3, $F2,	$F1, $F0
byte_4248A:	dc.b    0,   1,   2,   3,   4,   5,   6,   7,   8,   9,  $A,  $C,  $D,  $F, $10, $12, $13, $13, $14, $14
		dc.b  $16, $17, $17, $17, $17, $17, $17, $17, $17, $17, $17, $17, $18, $18, $18, $18, $19, $1B, $1C, $1E
		dc.b  $1F, $21, $22, $24, $25, $27, $28, $2A, $2B, $2D, $2E, $30, $31, $33, $34, $36, $37, $39, $3A, $3C
		dc.b  $3D, $3F, $40, $42, $43, $45, $46, $48, $49, $4B, $4C, $4E, $4F, $51, $52, $54, $55, $57, $58, $5A
		dc.b  $5B, $5D, $5E, $60, $60, $60, $60, $60, $60, $60, $60, $60, $60, $60, $60, $60, $60, $61, $62, $63
		dc.b  $64, $65, $66, $67, $68, $69, $6A, $6B, $6C, $6D, $6E, $6F, $70, $71, $72, $73, $74, $75, $76, $77
		dc.b  $78, $79, $7A, $7B, $7C, $7D, $7E, $7F
byte_4250A:	dc.b    0,   1,   2,   3,   4,   5,   6,   7,   8,   9,  $A,  $C,  $D,  $F, $10, $12, $13, $13, $14, $14
		dc.b  $16, $17, $17, $17, $17, $17, $17, $17, $17, $17, $17, $17, $18, $18, $18, $18, $19, $19, $19, $1A
		dc.b  $1A, $1A, $1B, $1B, $1B, $1C, $1C, $1C, $1D, $1D, $1D, $1D, $1E, $1E, $1E, $1F, $1F, $1F, $20, $20
		dc.b  $20, $21, $21, $21
; ---------------------------------------------------------------------------

Obj_16_2:
		move.b	#-$30,7(a0)
		move.l	#loc_42556,(a0)

loc_42556:
		bsr.s	sub_4255E
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_4255E:
		lea	($FFFFB000).w,a1
		lea	$30(a0),a2
		moveq	#3,d6
		bsr.s	sub_42574
		lea	($FFFFB04A).w,a1
		lea	$34(a0),a2
		addq.b	#1,d6
; End of function sub_4255E


; =============== S U B R O U T I N E =======================================


sub_42574:
		btst	d6,$2A(a0)
		bne.w	loc_426B0
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.s	locret_425E8
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.s	locret_425E8
		btst	#0,$2A(a0)
		bne.s	loc_425EA
		tst.b	$2E(a1)
		bne.s	locret_425E8
		btst	#1,$2A(a1)
		bne.s	locret_425E8
		tst.w	$1C(a1)
		bmi.w	locret_425E8
		cmpi.w	#$400,$1C(a1)
		bge.w	loc_425CE
		move.w	#$400,$1C(a1)

loc_425CE:
		bsr.s	sub_42636

loc_425D0:
		move.l	#0,(a2)
		bclr	#0,$2A(a1)
		andi.b	#-4,4(a1)
		move.b	#$43,$2E(a1)

locret_425E8:

		rts
; ---------------------------------------------------------------------------

loc_425EA:
		tst.b	$2E(a1)
		bne.s	locret_425E8
		btst	#1,$2A(a1)
		bne.s	locret_425E8
		tst.w	$1C(a1)
		bpl.w	locret_425E8
		cmpi.w	#-$400,$1C(a1)
		ble.w	loc_42610
		move.w	#-$400,$1C(a1)

loc_42610:
		bsr.s	sub_42636
		move.l	#0,(a2)
		neg.w	$1C(a1)
		bset	#0,$2A(a1)
		andi.b	#-4,4(a1)
		ori.b	#1,4(a1)
		move.b	#$43,$2E(a1)
		rts
; End of function sub_42574


; =============== S U B R O U T I N E =======================================


sub_42636:

		btst	#3,$2A(a1)
		beq.s	loc_42646
		movea.w	$42(a1),a3
		bclr	d6,$2A(a3)

loc_42646:
		move.w	a0,$42(a1)
		bset	d6,$2A(a0)
		move.w	#0,$18(a1)
		move.w	#0,$1A(a1)
		move.b	$44(a1),$1E(a1)
		move.b	$45(a1),$1F(a1)

loc_42666:
		andi.b	#-$77,$2A(a1)
		bset	#3,$2A(a1)
		bset	#1,$2A(a1)
		move.b	#0,$40(a1)
		move.w	#0,($FFFFF7D0).w
		move.b	#0,$26(a1)
		move.b	#0,$27(a1)
		move.b	#0,$2D(a1)
		move.b	#0,$30(a1)
		move.b	#0,$39(a1)
		move.b	#0,$2F(a1)
		move.b	#0,$20(a1)
		rts
; End of function sub_42636

; ---------------------------------------------------------------------------

loc_426B0:
		tst.w	($FFFFFE08).w
		beq.s	loc_426F8

loc_426B6:

		andi.b	#-$80,$2A(a1)
		bset	#1,$2A(a1)
		btst	#0,$2A(a0)
		bne.s	loc_426DA
		bclr	#1,$2A(a1)
		bset	#0,$2A(a1)
		neg.w	$1C(a1)

loc_426DA:
		bclr	d6,$2A(a0)
		move.w	#1,$20(a1)
		move.b	#0,$2E(a1)
		move.w	$1C(a1),$18(a1)
		move.w	#0,$1A(a1)
		rts
; ---------------------------------------------------------------------------

loc_426F8:
		move.w	$1C(a1),d0
		ext.l	d0
		lsl.l	#7,d0
		add.l	d0,(a2)
		bmi.s	loc_426B6
		cmpi.w	#$100,(a2)
		bcc.s	loc_426B6
		cmpi.w	#$1000,$1C(a1)

loc_42710:
		bge.s	loc_42718
		addi.w	#$10,$1C(a1)

loc_42718:
		move.w	$10(a1),d2
		move.w	(a2),d0
		lsr.w	#1,d0
		jsr	(GetSineCosine).l
		muls.w	#$A00,d0
		asl.l	#4,d0
		swap	d0
		move.w	#$165,d2
		btst	#0,$2A(a0)
		beq.s	loc_42740
		move.w	#$142,d2
		neg.w	d0

loc_42740:
		add.w	$10(a0),d0
		move.w	d0,$10(a1)
		sub.w	d2,d0
		asl.w	#8,d0
		move.w	d0,$18(a1)
		neg.w	d1
		addi.w	#$100,d1
		lsr.w	#1,d1
		mulu.w	d2,d1
		lsr.l	#8,d1
		move.w	d1,d0
		move.w	$14(a1),d2
		add.w	$14(a0),d0
		move.w	d0,$14(a1)
		sub.w	d2,d0
		asl.w	#8,d0
		move.w	d0,$1A(a1)
		moveq	#0,d0
		move.w	(a2),d0
		lsr.w	#1,d0
		andi.w	#$FF,d0
		divu.w	#$16,d0
		move.b	RawAni_42792(pc,d0.w),$22(a1)
		moveq	#0,d0
		move.b	$22(a1),d0
		jmp	(Tails_Carry_LoadPLC).l
; ---------------------------------------------------------------------------
RawAni_42792:	dc.b  $EF, $DF,	$E0, $E1, $E2, $E3, $F5, $F4, $F3, $F2,	$F1, $F0
; ---------------------------------------------------------------------------

Obj_LRZSinkingRock:

		move.l	#Map_LRZSinkingRock,$C(a0)
		move.w	#$40D3,$A(a0)

loc_427AC:
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$280,8(a0)
		move.w	$14(a0),$46(a0)
		tst.b	($FFFFFE11).w
		beq.s	loc_427DC
		move.b	#1,$22(a0)
		move.w	#$4090,$A(a0)

loc_427DC:
		move.l	#loc_427E2,(a0)

loc_427E2:
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		bne.s	loc_427F8
		tst.b	$2E(a0)
		beq.s	loc_42804
		subq.b	#1,$2E(a0)
		bra.s	loc_42804
; ---------------------------------------------------------------------------

loc_427F8:
		cmpi.b	#$40,$2E(a0)
		beq.s	loc_42804
		addq.b	#1,$2E(a0)

loc_42804:

		move.b	$2E(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#3,d0
		add.w	$46(a0),d0
		move.w	d0,$14(a0)
		move.w	#$1B,d1
		move.w	#$10,d2
		move.w	#$11,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
Map_LRZSinkingRock:include "Levels\LRZ\Misc Object Data\Map - Sinking Rock.asm"

; ---------------------------------------------------------------------------

Obj_LRZFallingSpike:

		move.l	#Map_LRZFallingSpike,$C(a0)
		move.w	#$43A1,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.b	#$C,$1E(a0)
		move.w	#$280,8(a0)
		move.b	#-$7E,$28(a0)
		move.b	$2C(a0),$2F(a0)
		move.l	#loc_42898,(a0)

loc_42898:
		lea	($FFFFB000).w,a1
		move.w	$10(a0),d0
		sub.w	$10(a1),d0
		bpl.s	loc_428A8
		neg.w	d0

loc_428A8:
		lea	($FFFFB04A).w,a2
		move.w	$10(a0),d1
		sub.w	$10(a2),d1
		bpl.s	loc_428B8
		neg.w	d1

loc_428B8:
		cmp.w	d1,d0
		bls.s	loc_428BE
		move.w	d1,d0

loc_428BE:
		cmp.w	$2E(a0),d0
		bcc.s	loc_428D0
		tst.w	($FFFFFE08).w
		bne.s	loc_428D0
		move.l	#loc_428D6,(a0)

loc_428D0:

		jmp	(loc_1B662).l
; ---------------------------------------------------------------------------

loc_428D6:
		jsr	(MoveSprite).l
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_428FE
		add.w	d1,$14(a0)
		move.b	#0,$28(a0)
		move.l	#loc_42904,(a0)
		moveq	#-$68,d0
		jsr	(Play_Sound_2).l

loc_428FE:
		jmp	(loc_1B662).l
; ---------------------------------------------------------------------------

loc_42904:
		move.w	#$13,d1
		move.w	#$10,d2
		move.w	#$11,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
Map_LRZFallingSpike:include "Levels\LRZ\Misc Object Data\Map - Falling Spike.asm"

; ---------------------------------------------------------------------------

Obj_LRZDoor:

		move.l	#Map_LRZDoor,$C(a0)
		move.w	#$43A1,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$28,6(a0)
		move.w	#$200,8(a0)
		move.w	$14(a0),$46(a0)
		tst.b	($FFFFFE11).w
		beq.s	loc_4296E
		move.b	#1,$22(a0)
		move.w	#$4090,$A(a0)
		move.b	#$20,6(a0)

loc_4296E:
		move.l	#loc_42974,(a0)

loc_42974:
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		tst.b	(a3,d0.w)
		beq.s	loc_429BC
		move.l	#loc_42994,(a0)
		moveq	#-$71,d0
		jsr	(Play_Sound_2).l

loc_42994:
		addq.b	#1,$2E(a0)
		cmpi.b	#$40,$2E(a0)
		bne.s	loc_429A6
		move.l	#loc_429BC,(a0)

loc_429A6:
		move.b	$2E(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#2,d0
		neg.w	d0
		add.w	$46(a0),d0
		move.w	d0,$14(a0)

loc_429BC:

		move.w	#$1B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
Map_LRZDoor:	include "Levels\LRZ\Misc Object Data\Map - Door.asm"

; ---------------------------------------------------------------------------

Obj_LRZBigDoor:

		move.l	#Map_LRZBigDoor,$C(a0)
		move.w	#$43A1,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$30,7(a0)
		move.b	#$40,6(a0)

loc_42A38:
		move.w	#$280,8(a0)
		move.w	$14(a0),$46(a0)
		move.w	$48(a0),d0
		beq.s	loc_42A62
		movea.w	d0,a2
		btst	#0,(a2)
		beq.s	loc_42A62
		addi.w	#$80,$14(a0)
		move.l	#loc_42B08,(a0)
		bra.w	loc_42B08
; ---------------------------------------------------------------------------

loc_42A62:

		move.l	#loc_42A68,(a0)

loc_42A68:
		lea	($FFFFB000).w,a1
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#-$40,d0
		cmpi.w	#$80,d0
		bcc.w	loc_42B08
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		cmpi.w	#$50,d0
		blt.s	loc_42B08
		move.l	#loc_42AAE,(a0)
		move.w	#-1,($FFFFEECC).w
		moveq	#-$34,d0
		jsr	(Play_Sound_2).l
		move.w	$48(a0),d0
		beq.s	loc_42AAE
		movea.w	d0,a2
		bset	#0,(a2)

loc_42AAE:

		addq.b	#1,$2E(a0)
		cmpi.b	#$40,$2E(a0)
		bne.s	loc_42AC6
		move.l	#loc_42B08,(a0)
		move.w	#0,($FFFFEECC).w

loc_42AC6:
		move.b	$2E(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#1,d0
		add.w	$46(a0),d0
		move.w	d0,$14(a0)
		move.b	($FFFFFE05).w,d0
		andi.b	#$F,d0
		bne.s	loc_42AEC
		moveq	#-$34,d0
		jsr	(Play_Sound_2).l

loc_42AEC:
		move.w	#$3B,d1
		move.w	#$40,d2
		move.w	#$41,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_42B08:

		move.w	#$3B,d1
		move.w	#$40,d2
		move.w	#$41,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
Map_LRZBigDoor:	include "Levels\LRZ\Misc Object Data\Map - Big Door.asm"

; ---------------------------------------------------------------------------

Obj_LRZFireballLauncher:

		move.l	#Map_LRZFireballLauncher,$C(a0)
		move.w	#$63A1,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#4,6(a0)
		move.w	#$280,8(a0)
		move.b	#2,$22(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#2,d0
		move.w	d0,$30(a0)
		move.l	#loc_42BF6,(a0)

loc_42BF6:
		subq.w	#1,$2E(a0)
		bpl.s	loc_42C7A
		move.w	$30(a0),$2E(a0)
		tst.b	4(a0)
		bpl.s	loc_42C7A
		jsr	(Create_New_Sprite3).l
		bne.w	loc_42C7A
		move.l	#loc_42C80,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)

loc_42C24:
		addi.w	#8,$10(a1)
		move.b	4(a0),4(a1)
		move.l	$C(a0),$C(a1)
		move.w	#$3A1,$A(a1)
		move.w	#$300,8(a1)
		move.b	#$C,7(a1)
		move.b	#8,6(a1)
		move.b	#-$65,$28(a1)
		bset	#4,$2B(a1)
		move.w	#$200,$18(a1)
		btst	#0,$2A(a0)
		beq.s	loc_42C72
		neg.w	$18(a1)
		subi.w	#$10,$10(a1)

loc_42C72:
		moveq	#$67,d0
		jsr	(Play_Sound_2).l

loc_42C7A:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_42C80:
		move.b	($FFFFFE05).w,d0
		andi.b	#3,d0
		bne.s	loc_42C94
		addq.b	#1,$22(a0)
		andi.b	#1,$22(a0)

loc_42C94:
		tst.b	4(a0)
		bpl.s	loc_42CAC
		jsr	(MoveSprite2).l
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_42CAC:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
Map_LRZFireballLauncher:include "Levels\LRZ\Misc Object Data\Map - Fireball Launcher.asm"

; ---------------------------------------------------------------------------

Obj_LRZButtonHorizontal:

		move.l	#Map_LRZButtonHorizontal,$C(a0)
		move.w	#$63A1,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$280,8(a0)
		tst.b	($FFFFFE11).w
		beq.s	loc_42D10
		move.l	#Map_LRZButtonHorizontal2,$C(a0)
		move.w	#$240D,$A(a0)

loc_42D10:
		move.l	#loc_42D16,(a0)

loc_42D16:
		move.w	#$10,d1

loc_42D1A:
		move.w	#$F,d2
		move.w	#$10,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l

loc_42D2C:
		move.b	#0,$22(a0)
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		lea	(a3,d0.w),a3
		moveq	#0,d3

loc_42D44:
		btst	#6,$2C(a0)
		beq.s	loc_42D4E
		moveq	#7,d3

loc_42D4E:
		swap	d6
		andi.w	#3,d6
		bne.s	loc_42D62
		btst	#4,$2C(a0)
		bne.s	loc_42D76
		bclr	d3,(a3)
		bra.s	loc_42D76
; ---------------------------------------------------------------------------

loc_42D62:
		tst.b	(a3)
		bne.s	loc_42D6E
		moveq	#$5B,d0
		jsr	(Play_Sound_2).l

loc_42D6E:
		bset	d3,(a3)
		move.b	#1,$22(a0)

loc_42D76:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
Map_LRZButtonHorizontal:	include "Levels\LRZ\Misc Object Data\Map - Button Horizontal.asm"
; ---------------------------------------------------------------------------

Obj_LRZShootingTrigger:

		move.l	#Map_LRZShootingTrigger,$C(a0)
		move.w	#$63A1,$A(a0)

loc_42DCC:
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$280,8(a0)
		move.b	#-$3A,$28(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0

loc_42DF0:
		andi.w	#$F0,d0
		lsr.w	#2,d0
		move.w	d0,$30(a0)
		move.l	#loc_42E00,(a0)

loc_42E00:
		subq.w	#1,$2E(a0)
		bpl.s	loc_42E84
		move.w	$30(a0),$2E(a0)
		tst.b	4(a0)
		bpl.s	loc_42E84
		jsr	(Create_New_Sprite3).l
		bne.w	loc_42E84

loc_42E1C:
		move.l	#loc_42EE8,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	4(a0),4(a1)
		move.l	$C(a0),$C(a1)
		move.w	#$3A1,$A(a1)
		move.w	#$300,8(a1)
		move.b	#4,7(a1)
		move.b	#4,6(a1)

loc_42E52:
		move.b	#-$68,$28(a1)
		bset	#3,$2B(a1)

loc_42E5E:
		move.b	#1,$22(a1)
		move.w	#$200,$18(a1)
		move.w	#$200,$1A(a1)

loc_42E70:
		btst	#0,$2A(a0)
		beq.s	loc_42E7C
		neg.w	$18(a1)

loc_42E7C:
		moveq	#$4D,d0
		jsr	(Play_Sound_2).l

loc_42E84:

		move.b	$29(a0),d0
		beq.w	loc_42EBA
		move.b	$2C(a0),d0

loc_42E90:
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		lea	(a3,d0.w),a3
		moveq	#0,d3
		lea	($FFFFB000).w,a1

loc_42EA2:
		bclr	#0,$29(a0)
		beq.s	loc_42EAC
		bsr.s	sub_42EC0

loc_42EAC:
		lea	($FFFFB04A).w,a1
		bclr	#1,$29(a0)
		beq.s	loc_42EBA
		bsr.s	sub_42EC0

loc_42EBA:

		jmp	(loc_1B662).l

; =============== S U B R O U T I N E =======================================


sub_42EC0:

		cmpi.b	#2,$20(a1)
		bne.s	locret_42EE6
		neg.w	$18(a1)
		neg.w	$1A(a1)
		bset	d3,(a3)
		move.l	#Obj_Explosion,(a0)
		move.b	#2,5(a0)
		clr.b	$28(a0)
		clr.b	$29(a0)

locret_42EE6:
		rts
; End of function sub_42EC0

; ---------------------------------------------------------------------------

loc_42EE8:
		tst.b	4(a0)
		bpl.s	loc_42F00
		jsr	(MoveSprite2).l
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_42F00:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
Map_LRZShootingTrigger:include "Levels\LRZ\Misc Object Data\Map - Shooting Trigger.asm"

; ---------------------------------------------------------------------------

Obj_LRZDashElevator:

		move.l	#Map_LRZDashElevator,$C(a0)
		move.w	#$3A1,$A(a0)
		move.b	#4,4(a0)
		move.b	#$20,7(a0)
		move.b	#$10,6(a0)
		move.w	#$80,8(a0)
		move.w	$14(a0),$46(a0)
		moveq	#0,d1
		move.b	$2C(a0),d0
		bpl.s	loc_42F54
		moveq	#$20,d1
		move.w	d1,$30(a0)

loc_42F54:
		andi.w	#$7F,d0
		lsl.w	#3,d0
		move.w	d0,$34(a0)
		bclr	#0,$2A(a0)
		beq.s	loc_42F72
		move.w	d0,$30(a0)
		sub.w	d1,$30(a0)
		sub.w	d0,$46(a0)

loc_42F72:
		move.l	#loc_42F78,(a0)

loc_42F78:
		moveq	#0,d5
		lea	$2E(a0),a2
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.w	sub_4301C
		addq.w	#1,a2
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.w	sub_4301C
		move.l	$30(a0),d0
		swap	d5
		asr.l	#3,d5
		add.l	d5,d0
		bpl.s	loc_42FA4
		moveq	#0,d0
		moveq	#0,d5

loc_42FA4:
		move.l	$34(a0),d1
		cmp.l	d1,d0
		bcs.s	loc_42FB0
		move.l	d1,d0
		moveq	#0,d5

loc_42FB0:
		move.l	d0,$30(a0)
		swap	d0
		add.w	$46(a0),d0

loc_42FBA:
		move.w	d0,$14(a0)
		move.b	($FFFFFE05).w,d0
		andi.b	#3,d0
		bne.s	loc_43000
		tst.l	d5
		beq.s	loc_43000
		bpl.s	loc_42FE2
		addq.b	#1,$22(a0)
		cmpi.b	#3,$22(a0)
		bcs.s	loc_42FEE
		move.b	#0,$22(a0)
		bra.s	loc_42FEE
; ---------------------------------------------------------------------------

loc_42FE2:
		subq.b	#1,$22(a0)
		bcc.s	loc_42FEE
		move.b	#2,$22(a0)

loc_42FEE:

		move.b	($FFFFFE05).w,d0
		andi.b	#$F,d0
		bne.s	loc_43000
		moveq	#-$29,d0
		jsr	(Play_Sound_2).l

loc_43000:

		move.w	#$2B,d1
		move.w	#8,d2
		move.w	#9,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_4301C:

		tst.b	(a2)
		bne.s	loc_4303A
		btst	d6,$2A(a0)
		beq.s	locret_43038
		cmpi.b	#9,$20(a1)
		bne.s	locret_43038
		move.w	$10(a0),$10(a1)
		move.b	#1,(a2)

locret_43038:

		rts
; ---------------------------------------------------------------------------

loc_4303A:
		btst	#1,$2A(a1)
		bne.s	loc_43052
		cmpi.b	#2,$20(a1)
		beq.s	loc_4305E
		cmpi.b	#9,$20(a1)
		beq.s	loc_4305E

loc_43052:
		move.w	#0,$18(a1)
		move.b	#0,(a2)
		rts
; ---------------------------------------------------------------------------

loc_4305E:

		move.w	$10(a0),$10(a1)
		move.w	$1C(a1),d0
		beq.s	loc_43082
		bpl.s	loc_43076
		addi.w	#$40,d0
		bcc.s	loc_4307E
		moveq	#0,d0
		bra.s	loc_4307E
; ---------------------------------------------------------------------------

loc_43076:
		subi.w	#$40,d0
		bcc.s	loc_4307E
		moveq	#0,d0

loc_4307E:

		move.w	d0,$1C(a1)

loc_43082:
		moveq	#8,d0
		add.b	$3E(a1),d0
		btst	#0,$2A(a1)
		bne.s	loc_43092
		neg.w	d0

loc_43092:
		add.w	d0,d5
		rts
; End of function sub_4301C

; ---------------------------------------------------------------------------
Map_LRZDashElevator:include "Levels\LRZ\Misc Object Data\Map - Dash Elevator.asm"

; ---------------------------------------------------------------------------

Obj_LRZSmashingSpikePlatform:

		move.l	#Map_LRZSmashingSpikePlatform,$C(a0)
		move.w	#$43A1,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$40,7(a0)
		move.b	#$20,6(a0)
		move.w	#$280,8(a0)
		move.w	$14(a0),$46(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#3,d0
		move.w	d0,$38(a0)

loc_43122:
		move.l	#loc_43128,(a0)

loc_43128:
		tst.b	$32(a0)
		bne.s	loc_43178
		move.w	$1A(a0),d0
		addi.w	#$40,$1A(a0)
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$34(a0)
		move.w	$34(a0),d2
		cmp.w	$38(a0),d2
		bcs.w	loc_431E0
		clr.w	$1A(a0)
		move.w	$38(a0),$34(a0)
		move.b	#1,$32(a0)
		move.w	#$1E,$3A(a0)
		move.b	#0,$23(a0)
		tst.b	4(a0)
		bpl.s	loc_431E0
		moveq	#$5F,d0
		jsr	(Play_Sound_2).l
		bra.s	loc_431E0
; ---------------------------------------------------------------------------

loc_43178:
		tst.w	$3A(a0)
		beq.s	loc_431AA
		subq.w	#1,$3A(a0)
		moveq	#0,d0
		move.b	$23(a0),d0
		move.b	RawAni_43196(pc,d0.w),$22(a0)
		beq.s	loc_431E0
		addq.b	#1,$23(a0)
		bra.s	loc_431E0
; ---------------------------------------------------------------------------
RawAni_43196:	dc.b	2,   4,	  6,   7,   7,	 7,   7,   6,	6,   5,	  5,   4,   4,	 3,   3,   2,	2,   1,	  1,   0
; ---------------------------------------------------------------------------

loc_431AA:
		move.w	$34(a0),d2
		beq.s	loc_431D4
		subq.w	#1,d2
		move.w	d2,$34(a0)
		addq.b	#8,$22(a0)
		andi.b	#8,$22(a0)
		move.b	($FFFFFE05).w,d0
		andi.b	#$1F,d0
		bne.s	loc_431E0
		moveq	#$48,d0
		jsr	(Play_Sound_2).l
		bra.s	loc_431E0
; ---------------------------------------------------------------------------

loc_431D4:
		move.b	#0,$32(a0)
		move.b	#0,$22(a0)

loc_431E0:

		move.w	$46(a0),d0
		add.w	$34(a0),d0
		move.w	d0,$14(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.b	$22(a0),d0
		andi.w	#7,d0
		sub.w	d0,d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		swap	d6
		andi.w	#$C,d6
		bne.s	loc_43222
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_43222:
		move.b	d6,d0
		andi.b	#4,d0
		beq.s	loc_43234
		lea	($FFFFB000).w,a1
		jsr	(sub_24280).l

loc_43234:
		andi.b	#8,d6
		beq.s	loc_43244
		lea	($FFFFB04A).w,a1
		jsr	(sub_24280).l

loc_43244:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
Map_LRZSmashingSpikePlatform:include "Levels\LRZ\Misc Object Data\Map - Smashing Spike Platform.asm"


; ---------------------------------------------------------------------------

Obj_LRZSwingingSpikeBall:

		move.l	#Map_LRZSwingingSpikeBall,$C(a0)
		move.w	#-$5C5F,$A(a0)
		move.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$280,8(a0)
		move.w	$10(a0),$44(a0)
		move.w	$14(a0),$46(a0)
		move.b	#-$66,$28(a0)
		tst.b	($FFFFFE11).w
		beq.s	loc_4354E
		move.l	#Map_LRZSwingingSpikeBall2,$C(a0)
		move.w	#-$5BF3,$A(a0)

loc_4354E:
		jsr	(Create_New_Sprite3).l
		bne.w	loc_435CA
		move.l	#loc_435FE,(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		andi.w	#-$6001,$A(a1)
		move.b	4(a0),4(a1)
		move.b	#$50,7(a1)
		move.b	#$50,6(a1)
		move.w	#$280,8(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		bset	#6,4(a1)
		move.w	d0,$16(a1)
		lea	$18(a1),a2
		move.w	$16(a1),d0
		subq.w	#1,d0

loc_435B0:
		move.w	$10(a0),(a2)+
		move.w	$14(a0),(a2)+

loc_435B8:
		move.w	#1,(a2)+
		dbf	d0,loc_435B0
		move.b	#1,$22(a1)
		move.w	a1,$3C(a0)

loc_435CA:
		moveq	#2,d0
		btst	#0,$2A(a0)
		beq.s	loc_435D6
		neg.w	d0

loc_435D6:
		move.b	d0,$36(a0)
		move.l	#loc_435E0,(a0)

loc_435E0:
		movea.w	$3C(a0),a1
		bsr.w	sub_43604
		move.b	$34(a0),d2
		move.b	$36(a0),d0
		add.b	d0,$34(a0)
		move.w	$44(a0),d0
		jmp	(loc_1B666).l
; ---------------------------------------------------------------------------

loc_435FE:
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_43604:
		move.b	$34(a0),d0
		jsr	(GetSineCosine).l
		move.w	$46(a0),d2
		move.w	$44(a0),d3
		swap	d0
		swap	d1
		asr.l	#4,d0
		asr.l	#4,d1
		move.l	d0,d4
		move.l	d1,d5
		tst.b	$2C(a0)
		bpl.s	loc_4362C
		add.l	d0,d4
		add.l	d1,d5

loc_4362C:
		lea	$18(a1),a2
		move.w	$16(a1),d6
		subq.w	#1,d6

loc_43636:
		movem.l	d4-d5,-(sp)
		swap	d4
		swap	d5
		add.w	d2,d4
		add.w	d3,d5
		move.w	d5,(a2)+
		move.w	d4,(a2)+
		movem.l	(sp)+,d4-d5
		add.l	d0,d4
		add.l	d1,d5
		addq.w	#2,a2
		dbf	d6,loc_43636
		swap	d4
		swap	d5
		add.w	d2,d4
		add.w	d3,d5
		move.w	d5,$10(a0)
		move.w	d4,$14(a0)
		rts
; End of function sub_43604

; ---------------------------------------------------------------------------
Map_LRZSwingingSpikeBall:	include "Levels\LRZ\Misc Object Data\Map - Swinging Spike Ball.asm"
; ---------------------------------------------------------------------------

Obj_LRZLavaFall:

		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,$30(a0)
		move.l	#loc_436A8,(a0)

loc_436A8:
		move.w	($FFFFFE04).w,d0
		andi.w	#$FF,d0
		cmp.w	$30(a0),d0
		bcs.w	loc_43746
		subq.b	#1,$24(a0)
		bpl.w	loc_43746
		move.b	#5,$24(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_43746
		move.l	#loc_43764,(a1)
		addq.b	#1,$25(a0)
		cmpi.b	#2,$25(a0)
		bcs.s	loc_436EE
		move.b	#0,$25(a0)
		move.l	#loc_4374C,(a1)

loc_436EE:
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.l	#Map_LRZLavaFall,$C(a1)
		move.w	#$40D3,$A(a1)
		ori.b	#-$7C,4(a1)
		move.w	#$300,8(a1)
		move.b	#$20,7(a1)
		move.b	#$20,6(a1)
		move.b	#-$67,$28(a1)
		bset	#4,$2B(a1)
		move.w	#$800,$1A(a1)
		move.w	#$1C,$2E(a1)
		btst	#0,$2A(a0)
		beq.s	loc_43746
		move.w	#$24,$2E(a1)

loc_43746:

		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_4374C:
		tst.b	4(a0)
		bpl.s	loc_43764
		move.b	($FFFFFE05).w,d0
		andi.b	#$F,d0
		bne.s	loc_43764
		moveq	#-$2B,d0
		jsr	(Play_Sound_2).l

loc_43764:


		subq.w	#1,$2E(a0)
		bmi.s	loc_4377C
		jsr	(MoveSprite2).l
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_4377C:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
Map_LRZLavaFall:include "Levels\LRZ\Misc Object Data\Map - Lava Fall.asm"

; ---------------------------------------------------------------------------

Obj_LRZSpikeBall:

		move.l	#Map_LRZSpikeBall,$C(a0)
		move.w	#$2442,$A(a0)
		move.b	#4,4(a0)
		move.b	#$20,7(a0)
		move.b	#$20,6(a0)
		move.w	#$280,8(a0)
		move.b	#$20,$1F(a0)
		move.b	#$20,$1E(a0)
		move.w	$10(a0),$44(a0)
		move.w	$14(a0),$46(a0)
		tst.b	$2C(a0)
		bne.s	loc_437F8
		ori.w	#-$8000,$A(a0)
		move.b	#-$71,$28(a0)
		move.l	#loc_4397E,(a0)
		bra.w	loc_4397E
; ---------------------------------------------------------------------------

loc_437F8:
		move.l	#loc_437FE,(a0)

loc_437FE:
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#2,d1
		add.w	$44(a0),d1
		move.w	d1,$10(a0)
		move.b	#0,$28(a0)
		andi.w	#$7FFF,$A(a0)
		tst.b	$26(a0)
		bpl.s	loc_43830
		ori.w	#-$8000,$A(a0)
		move.b	#-$71,$28(a0)

loc_43830:
		lea	($FFFFB000).w,a1
		move.w	$14(a1),d0
		sub.w	$46(a0),d0
		addi.w	#$40,d0
		cmpi.w	#$80,d0
		bcc.s	loc_4385C
		move.w	$10(a1),d0
		sub.w	$44(a0),d0
		bcc.s	loc_4385C
		tst.w	($FFFFFE08).w
		bne.s	loc_4385C
		move.b	#1,$30(a0)

loc_4385C:

		tst.b	$30(a0)
		beq.s	loc_4387E
		move.b	$2C(a0),d0
		cmp.b	$26(a0),d0
		bne.s	loc_4387E
		move.l	#loc_4389E,(a0)
		move.w	#-$400,$18(a0)
		move.w	#0,$1A(a0)

loc_4387E:

		subq.b	#2,$26(a0)
		tst.b	$30(a0)
		bne.s	loc_43892
		move.w	$44(a0),d0
		jmp	(loc_1B666).l
; ---------------------------------------------------------------------------

loc_43892:
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_4389E:
		btst	#1,$2A(a0)
		bne.s	loc_4390E
		jsr	(MoveSprite2).l
		moveq	#-$20,d3
		add.w	$10(a0),d3
		jsr	(sub_FE44).l
		tst.w	d1
		bpl.s	loc_438CC
		sub.w	d1,$10(a0)
		move.w	#0,$18(a0)
		move.b	#0,$30(a0)

loc_438CC:
		jsr	(ObjHitFloor).l
		cmpi.w	#$E,d1
		bgt.s	loc_43906
		add.w	d1,$14(a0)
		move.w	#0,$1A(a0)
		tst.w	$18(a0)
		beq.s	loc_438FA
		move.b	($FFFFFE05).w,d0
		andi.b	#$F,d0
		bne.s	loc_438FA
		moveq	#-$6A,d0
		jsr	(Play_Sound_2).l

loc_438FA:

		subi.w	#4,$18(a0)
		bsr.w	sub_439EC
		bra.s	loc_43948
; ---------------------------------------------------------------------------

loc_43906:
		bset	#1,$2A(a0)
		bra.s	loc_43948
; ---------------------------------------------------------------------------

loc_4390E:
		moveq	#-$20,d3
		add.w	$10(a0),d3
		jsr	(sub_FE44).l
		tst.w	d1
		bpl.s	loc_43928
		sub.w	d1,$10(a0)
		move.w	#0,$18(a0)

loc_43928:
		jsr	(MoveSprite).l
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_43948
		add.w	d1,$14(a0)
		bclr	#1,$2A(a0)
		move.w	#0,$1A(a0)

loc_43948:

		subq.b	#1,$24(a0)
		bpl.s	loc_43966
		move.b	#3,$24(a0)
		addq.b	#1,$22(a0)
		cmpi.b	#3,$22(a0)
		bcs.s	loc_43966
		move.b	#0,$22(a0)

loc_43966:

		tst.b	$30(a0)
		beq.s	loc_43978
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_43978:
		jmp	(loc_1B662).l
; ---------------------------------------------------------------------------

loc_4397E:

		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#2,d1
		add.w	$44(a0),d1
		move.w	d1,$10(a0)
		btst	#1,$2A(a0)
		bne.s	loc_439A4
		jsr	(ObjHitFloor).l
		add.w	d1,$14(a0)

loc_439A4:
		tst.b	4(a0)
		bpl.s	loc_439BC
		move.b	($FFFFFE05).w,d0
		andi.b	#$F,d0
		bne.s	loc_439BC
		moveq	#-$6A,d0
		jsr	(Play_Sound_2).l

loc_439BC:

		bsr.w	sub_439EC
		subq.b	#1,$24(a0)
		bpl.s	loc_439DE
		move.b	#3,$24(a0)
		addq.b	#1,$22(a0)
		cmpi.b	#3,$22(a0)
		bcs.s	loc_439DE
		move.b	#0,$22(a0)

loc_439DE:

		subq.b	#2,$26(a0)
		move.w	$44(a0),d0
		jmp	(loc_1B666).l

; =============== S U B R O U T I N E =======================================


sub_439EC:

		move.w	($FFFFFE04).w,d0
		andi.w	#3,d0
		bne.s	locret_43A6A

loc_439F6:
		tst.b	4(a0)
		bpl.s	locret_43A6A
		jsr	(Create_New_Sprite3).l
		bne.w	locret_43A6A
		move.l	#loc_43A6C,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$20,$14(a1)
		move.l	#Map_LRZRockDebris,$C(a1)
		move.w	#-$3F2D,$A(a1)
		ori.b	#-$7C,4(a1)
		move.w	#0,8(a1)
		move.b	#4,7(a1)
		move.b	#4,6(a1)
		jsr	(Random_Number).l
		andi.w	#$1FF,d0
		subi.w	#$100,d0
		move.w	d0,$18(a1)
		asr.w	#4,d0
		add.w	d0,$10(a1)
		swap	d0
		andi.w	#$1FF,d0
		addi.w	#-$400,d0

loc_43A66:
		move.w	d0,$1A(a1)

locret_43A6A:
		rts
; End of function sub_439EC

; ---------------------------------------------------------------------------

loc_43A6C:

		tst.b	4(a0)
		bpl.s	loc_43A88
		addq.b	#1,$22(a0)
		andi.b	#3,$22(a0)
		jsr	(MoveSprite).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_43A88:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
Map_LRZSpikeBall:include "Levels\LRZ\Misc Object Data\Map - Spike Ball.asm"

Map_LRZRockDebris:	include "Levels\LRZ\Misc Object Data\Map - Rock Debris.asm"

; ---------------------------------------------------------------------------

Obj_LRZOrbitingSpikeBallHorizontal:

		move.l	#Map_LRZOrbitingSpikeBall,$C(a0)
		move.w	#$240D,$A(a0)
		move.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.w	$10(a0),$44(a0)
		move.w	$14(a0),$46(a0)
		bclr	#0,$2C(a0)
		beq.s	loc_43B84
		move.b	#$20,7(a0)
		move.b	#$20,6(a0)
		move.b	#1,$22(a0)
		move.l	#loc_43BDE,(a0)
		bra.w	loc_43BDE
; ---------------------------------------------------------------------------

loc_43B84:
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.l	#loc_43B96,(a0)

loc_43B96:
		move.b	#0,$28(a0)
		andi.w	#$7FFF,$A(a0)
		move.b	($FFFFFE05).w,d0
		add.b	d0,d0
		btst	#0,$2A(a0)
		beq.s	loc_43BB2
		neg.b	d0

loc_43BB2:
		add.b	$2C(a0),d0
		bpl.s	loc_43BC4
		ori.w	#-$8000,$A(a0)
		move.b	#-$66,$28(a0)

loc_43BC4:
		jsr	(GetSineCosine).l
		asr.w	#3,d1
		add.w	$44(a0),d1
		move.w	d1,$10(a0)
		move.w	$44(a0),d0
		jmp	(loc_1B666).l
; ---------------------------------------------------------------------------

loc_43BDE:

		move.b	#0,$28(a0)
		andi.w	#$7FFF,$A(a0)
		move.b	($FFFFFE05).w,d0
		add.b	d0,d0
		btst	#0,$2A(a0)
		beq.s	loc_43BFA
		neg.b	d0

loc_43BFA:
		add.b	$2C(a0),d0
		bpl.s	loc_43C0C
		ori.w	#-$8000,$A(a0)
		move.b	#-$71,$28(a0)

loc_43C0C:
		jsr	(GetSineCosine).l
		move.w	d1,d0
		asr.w	#1,d1
		add.w	d0,d1
		asr.w	#3,d1
		add.w	$44(a0),d1
		move.w	d1,$10(a0)
		move.w	$44(a0),d0
		jmp	(loc_1B666).l
; ---------------------------------------------------------------------------

Obj_LRZOrbitingSpikeBallVertical:

		move.l	#Map_LRZOrbitingSpikeBall,$C(a0)
		move.w	#$240D,$A(a0)
		move.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.w	$10(a0),$44(a0)
		move.w	$14(a0),$46(a0)
		bclr	#0,$2C(a0)
		beq.s	loc_43C76
		move.b	#$20,7(a0)
		move.b	#$20,6(a0)
		move.b	#1,$22(a0)
		move.l	#loc_43CD6,(a0)
		bra.w	loc_43CD6
; ---------------------------------------------------------------------------

loc_43C76:
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.l	#loc_43C88,(a0)

loc_43C88:
		move.b	#0,$28(a0)
		andi.w	#$7FFF,$A(a0)
		move.b	($FFFFFE05).w,d0
		add.b	d0,d0
		btst	#0,$2A(a0)
		beq.s	loc_43CA4
		neg.b	d0

loc_43CA4:
		add.b	$2C(a0),d0
		bpl.s	loc_43CB6
		ori.w	#-$8000,$A(a0)
		move.b	#-$66,$28(a0)

loc_43CB6:
		jsr	(GetSineCosine).l
		move.w	d1,d0
		asr.w	#2,d1
		add.w	d0,d1
		asr.w	#3,d1
		add.w	$46(a0),d1
		move.w	d1,$14(a0)
		move.w	$44(a0),d0
		jmp	(loc_1B666).l
; ---------------------------------------------------------------------------

loc_43CD6:

		move.b	#0,$28(a0)
		andi.w	#$7FFF,$A(a0)
		move.b	($FFFFFE05).w,d0
		add.b	d0,d0
		btst	#0,$2A(a0)
		beq.s	loc_43CF2
		neg.b	d0

loc_43CF2:
		add.b	$2C(a0),d0
		bpl.s	loc_43D04
		ori.w	#-$8000,$A(a0)
		move.b	#-$71,$28(a0)

loc_43D04:
		jsr	(GetSineCosine).l
		asr.w	#2,d1
		move.w	d1,d0
		asr.w	#3,d0
		sub.w	d0,d1
		add.w	$46(a0),d1
		move.w	d1,$14(a0)
		move.w	$44(a0),d0
		jmp	(loc_1B666).l
; ---------------------------------------------------------------------------
Map_LRZOrbitingSpikeBall:include "Levels\LRZ\Misc Object Data\Map - Orbiting Spike Ball.asm"

; ---------------------------------------------------------------------------

Obj_LRZFlameThrower:

		move.l	#Map_LRZFlameThrower,$C(a0)
		move.w	#$2090,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$18,7(a0)
		move.b	#$10,6(a0)
		move.w	#$280,8(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		bpl.s	loc_43DC4
		andi.w	#$7F,d0
		lsl.w	#2,d0
		move.w	d0,$32(a0)
		move.w	#$78,$30(a0)
		move.b	#7,$22(a0)
		btst	#0,$2A(a0)
		beq.s	loc_43DBA
		bset	#1,4(a0)

loc_43DBA:
		move.l	#loc_43F12,(a0)
		bra.w	loc_43F12
; ---------------------------------------------------------------------------

loc_43DC4:
		lsl.w	#2,d0
		move.w	d0,$32(a0)
		move.w	#$78,$30(a0)
		move.b	#6,$22(a0)
		move.l	#loc_43DDC,(a0)

loc_43DDC:
		tst.b	$2F(a0)
		bne.s	loc_43DF8
		subq.w	#1,$30(a0)
		bpl.s	loc_43E14
		move.w	$32(a0),$30(a0)
		move.b	#1,$2F(a0)
		bra.w	loc_43EF6
; ---------------------------------------------------------------------------

loc_43DF8:
		subq.w	#1,$30(a0)
		bpl.w	loc_43EF6
		move.w	#$78,$30(a0)
		move.b	#0,$2F(a0)
		moveq	#-$3E,d0
		jsr	(Play_Sound_2).l

loc_43E14:
		subq.b	#1,$24(a0)
		bpl.s	loc_43E2A
		move.b	#2,$24(a0)
		addq.b	#1,$25(a0)
		andi.b	#1,$25(a0)

loc_43E2A:
		move.b	($FFFFFE05).w,d0
		move.b	d0,d1
		andi.b	#3,d0
		bne.w	loc_43EF6
		andi.b	#$F,d1
		bne.s	loc_43E4E
		cmpi.w	#$1E,$30(a0)
		bcs.s	loc_43E4E
		moveq	#-$3E,d0
		jsr	(Play_Sound_2).l

loc_43E4E:

		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#4,d0
		move.b	d0,$2E(a0)
		addq.b	#8,$26(a0)
		tst.b	4(a0)
		bpl.w	loc_43EF6
		jsr	(Create_New_Sprite3).l
		bne.w	loc_43EF6
		move.l	#loc_44048,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$10,$10(a1)
		move.b	4(a0),4(a1)
		move.l	$C(a0),$C(a1)
		move.w	#$240D,$A(a1)
		move.w	#$300,8(a1)
		move.b	#$C,7(a1)
		move.b	#$C,6(a1)
		move.b	#-$68,$28(a1)
		bset	#4,$2B(a1)
		move.b	$2E(a0),d0
		jsr	(GetSineCosine).l
		asl.w	#2,d1
		asl.w	#2,d0
		move.w	d1,$18(a1)
		move.w	d0,$1A(a1)
		btst	#0,$2A(a0)
		beq.s	loc_43EE4
		neg.w	$18(a1)
		subi.w	#$20,$10(a1)

loc_43EE4:
		move.b	$25(a0),$22(a1)
		move.b	$24(a0),$25(a1)
		move.b	#8,$24(a1)

loc_43EF6:

		move.w	#$23,d1
		move.w	#$10,d2
		move.w	#$11,d3
		move.w	$10(a0),d4

loc_43F06:
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_43F12:

		tst.b	$2F(a0)
		bne.s	loc_43F2E
		subq.w	#1,$30(a0)
		bpl.s	loc_43F4A
		move.w	$32(a0),$30(a0)
		move.b	#1,$2F(a0)
		bra.w	loc_4402C
; ---------------------------------------------------------------------------

loc_43F2E:
		subq.w	#1,$30(a0)
		bpl.w	loc_4402C
		move.w	#$78,$30(a0)
		move.b	#0,$2F(a0)
		moveq	#-$3E,d0
		jsr	(Play_Sound_2).l

loc_43F4A:
		subq.b	#1,$24(a0)
		bpl.s	loc_43F60
		move.b	#2,$24(a0)
		addq.b	#1,$25(a0)
		andi.b	#1,$25(a0)

loc_43F60:
		move.b	($FFFFFE05).w,d0
		move.b	d0,d1
		andi.b	#3,d0
		bne.w	loc_4402C
		andi.b	#$F,d1
		bne.s	loc_43F84
		cmpi.w	#$1E,$30(a0)
		bcs.s	loc_43F84
		moveq	#-$3E,d0
		jsr	(Play_Sound_2).l

loc_43F84:

		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#4,d0
		move.b	d0,$2E(a0)
		addq.b	#8,$26(a0)
		tst.b	4(a0)
		bpl.w	loc_4402C
		jsr	(Create_New_Sprite3).l
		bne.w	loc_4402C
		move.l	#loc_44048,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$10,$14(a1)
		move.b	4(a0),4(a1)
		move.l	$C(a0),$C(a1)
		move.w	#$240D,$A(a1)
		move.w	#$300,8(a1)
		move.b	#$C,7(a1)
		move.b	#$C,6(a1)
		move.b	#-$68,$28(a1)
		bset	#4,$2B(a1)
		move.b	$2E(a0),d0
		jsr	(GetSineCosine).l
		asl.w	#2,d1
		asl.w	#2,d0

loc_44000:
		move.w	d1,$1A(a1)
		move.w	d0,$18(a1)
		btst	#0,$2A(a0)
		beq.s	loc_4401A
		neg.w	$1A(a1)
		subi.w	#$20,$14(a1)

loc_4401A:
		move.b	$25(a0),$22(a1)
		move.b	$24(a0),$25(a1)
		move.b	#8,$24(a1)

loc_4402C:

		move.w	#$1B,d1
		move.w	#$10,d2
		move.w	#$11,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_44048:

		subq.b	#1,$24(a0)
		bpl.s	loc_44060
		move.b	#7,$24(a0)
		addq.b	#2,$22(a0)
		cmpi.b	#6,$22(a0)
		bcc.s	loc_44084

loc_44060:
		subq.b	#1,$25(a0)
		bpl.s	loc_44072
		move.b	#2,$25(a0)
		bchg	#0,$22(a0)

loc_44072:
		jsr	(MoveSprite2).l
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_44084:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
Map_LRZFlameThrower:include "Levels\LRZ\Misc Object Data\Map - Flamethrower.asm"

; ---------------------------------------------------------------------------

Obj_LRZSolidRock:

		move.l	#Map_LRZSolidRock,$C(a0)
		move.w	#$6090,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$18,7(a0)
		move.b	#$10,6(a0)
		move.w	#$200,8(a0)
		move.w	$14(a0),$46(a0)
		move.l	#loc_44176,(a0)
		move.w	#-$60,d0
		tst.b	$2C(a0)
		bpl.s	loc_44132
		move.w	#-$C0,d0

loc_44132:
		move.w	$48(a0),d1
		beq.s	loc_4415E
		movea.w	d1,a2
		btst	#0,(a2)
		beq.s	loc_4415E
		btst	#6,$2C(a0)
		bne.s	loc_44166

loc_44148:
		neg.w	d0
		move.w	#-$3F6E,$32(a0)
		move.b	#1,$30(a0)
		move.l	#loc_441A6,(a0)
		bra.s	loc_44166
; ---------------------------------------------------------------------------

loc_4415E:

		btst	#6,$2C(a0)
		bne.s	loc_44148

loc_44166:

		btst	#0,$2A(a0)
		beq.s	loc_44170
		neg.w	d0

loc_44170:
		add.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_44176:

		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		btst	#0,(a3,d0.w)
		beq.s	loc_441D6
		move.l	#loc_441D2,(a0)
		moveq	#-$71,d0
		jsr	(Play_Sound_2).l
		move.w	$48(a0),d0
		beq.s	loc_441A4
		movea.w	d0,a2
		bset	#0,(a2)

loc_441A4:
		bra.s	loc_441D2
; ---------------------------------------------------------------------------

loc_441A6:

		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		tst.b	(a3,d0.w)
		bpl.s	loc_441D6
		move.l	#loc_441D2,(a0)
		moveq	#-$71,d0
		jsr	(Play_Sound_2).l
		move.w	$48(a0),d0
		beq.s	loc_441D2
		movea.w	d0,a2
		bclr	#0,(a2)

loc_441D2:


		bsr.w	sub_441F2

loc_441D6:

		move.w	#$23,d1
		move.w	#$10,d2
		move.w	#$11,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_441F2:
		move.w	#$60,d2
		tst.b	$30(a0)
		bne.s	loc_44220
		move.w	$34(a0),d1
		addq.w	#2,d1
		bne.s	loc_4420A
		move.l	#loc_44176,(a0)

loc_4420A:
		move.w	d1,$34(a0)
		add.w	d1,$32(a0)
		cmp.b	$32(a0),d2
		bhi.s	loc_44242
		move.b	#1,$30(a0)
		bra.s	loc_44242
; ---------------------------------------------------------------------------

loc_44220:
		move.w	$34(a0),d1
		subq.w	#2,d1
		bne.s	loc_4422E
		move.l	#loc_441A6,(a0)

loc_4422E:
		move.w	d1,$34(a0)
		add.w	d1,$32(a0)
		cmp.b	$32(a0),d2
		bls.s	loc_44242
		move.b	#0,$30(a0)

loc_44242:

		tst.b	$2C(a0)
		bmi.s	loc_44266
		moveq	#0,d0
		move.b	$32(a0),d0
		subi.w	#$60,d0
		btst	#0,$2A(a0)
		beq.s	loc_4425C
		neg.w	d0

loc_4425C:
		add.w	$46(a0),d0
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_44266:
		moveq	#0,d0
		move.w	$32(a0),d0
		lsr.w	#7,d0
		subi.w	#$C0,d0
		btst	#0,$2A(a0)
		beq.s	loc_4427C
		neg.w	d0

loc_4427C:
		add.w	$46(a0),d0
		move.w	d0,$14(a0)
		rts
; End of function sub_441F2

; ---------------------------------------------------------------------------
Map_LRZSolidRock:include "Levels\LRZ\Misc Object Data\Map - Solid Rock.asm"

; ---------------------------------------------------------------------------

Obj_LRZTurbineSprites:

		move.w	#-$5C53,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$200,8(a0)
		tst.b	$2C(a0)
		beq.s	loc_442D8
		move.l	#Map_LRZTurbineSprites2,$C(a0)
		move.b	#4,7(a0)
		move.b	#$30,6(a0)
		move.b	#-$60,$28(a0)
		move.l	#loc_44592,(a0)
		bra.w	loc_44592
; ---------------------------------------------------------------------------

loc_442D8:
		move.l	#Map_LRZTurbineSprites,$C(a0)
		move.b	#$10,7(a0)
		move.b	#$30,6(a0)
		move.l	#loc_442F2,(a0)

loc_442F2:
		lea	$30(a0),a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF602).w,d1
		bsr.s	sub_44338
		addq.w	#1,a2
		lea	($FFFFB04A).w,a1
		move.w	($FFFFF66A).w,d1
		bsr.s	sub_44338
		move.b	($FFFFFE05).w,d0
		lsr.b	#1,d0
		andi.b	#3,d0
		move.b	d0,$22(a0)
		tst.b	4(a0)
		bpl.s	loc_44332
		move.b	($FFFFFE05).w,d0
		andi.b	#$F,d0
		bne.s	loc_44332
		moveq	#-$40,d0
		jsr	(Play_Sound_2).l

loc_44332:

		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_44338:

		tst.b	(a2)
		beq.w	loc_44434
		tst.w	($FFFFFE08).w
		bne.w	loc_4436E
		cmpi.b	#4,5(a1)
		bcc.w	loc_4436E
		andi.w	#$70,d1
		bne.w	loc_443C4
		bsr.w	sub_4450A
		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2
		rts
; ---------------------------------------------------------------------------

loc_4436E:

		clr.b	(a2)
		move.b	#$1E,2(a2)
		andi.b	#-4,$2E(a1)
		move.w	#$100,8(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$27(a1)
		rts
; ---------------------------------------------------------------------------
byte_443B4:	dc.b  $20, $20,	$20, $30, $40, $50, $60, $60, $60, $A0,	$A0, $B0, $C0, $D0, $E0, $E0
; ---------------------------------------------------------------------------

loc_443C4:
		moveq	#0,d1
		move.b	4(a2),d0
		move.b	d0,d1
		lsr.w	#4,d1
		move.b	byte_443B4(pc,d1.w),d1
		andi.b	#$F,d0
		or.b	d1,d0
		jsr	(GetSineCosine).l
		muls.w	#$C,d0
		neg.w	d0
		move.w	d0,$1A(a1)
		move.w	#0,$20(a1)
		tst.w	d0
		bpl.s	loc_443FE
		move.w	#$1000,$20(a1)
		ori.w	#-$8000,$A(a1)

loc_443FE:
		clr.b	(a2)
		move.b	#$14,2(a2)
		andi.b	#-4,$2E(a1)
		bset	#1,$2A(a1)
		clr.b	$40(a1)
		clr.b	$3D(a1)
		move.b	#2,5(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$2F(a1)
		move.b	#0,$27(a1)
		rts
; ---------------------------------------------------------------------------

loc_44434:
		tst.b	2(a2)
		beq.s	loc_44448
		subq.b	#1,2(a2)
		bne.s	locret_44446
		move.w	#$100,8(a1)

locret_44446:
		rts
; ---------------------------------------------------------------------------

loc_44448:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.w	locret_44508
		moveq	#$70,d1
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$50,d0
		cmpi.w	#$18,d0
		bcs.w	loc_4448E
		moveq	#$30,d1
		addi.w	#-$40,d0
		cmpi.w	#$18,d0
		bcs.w	loc_4448E
		subi.w	#$40,d0
		cmpi.w	#$18,d0
		bcc.w	locret_44508
		moveq	#-$10,d1

loc_4448E:

		tst.w	($FFFFFE08).w
		bne.w	locret_44508
		cmpi.b	#4,5(a1)
		bcc.w	locret_44508
		tst.b	$2E(a1)
		bne.w	locret_44508
		cmpi.b	#$30,d1
		bne.s	loc_444B6
		tst.w	$A(a1)
		bpl.w	locret_44508

loc_444B6:
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		andi.b	#-4,4(a1)
		move.w	$10(a0),$10(a1)
		move.b	($FFFFFE05).w,d0
		andi.b	#7,d0
		subi.b	#4,d0
		add.b	d0,d0
		add.b	d0,d0
		add.b	d0,d1
		move.b	d1,4(a2)
		move.b	#0,$20(a1)
		move.b	#3,$2E(a1)
		move.b	#1,(a2)
		bsr.w	sub_4450A
		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2

locret_44508:

		rts
; End of function sub_44338


; =============== S U B R O U T I N E =======================================


sub_4450A:

		moveq	#0,d0
		move.b	4(a2),d0
		lsr.b	#3,d0
		move.b	RawAni_44552(pc,d0.w),d1
		move.b	d1,$22(a1)
		andi.w	#$1F,d0
		move.b	byte_44572(pc,d0.w),d1
		ext.w	d1
		add.w	$14(a0),d1
		move.w	d1,$14(a1)
		move.w	#$100,8(a1)
		ori.w	#-$8000,$A(a1)
		move.b	4(a2),d0
		bpl.s	loc_4454A
		move.w	#$280,8(a1)
		andi.w	#$7FFF,$A(a1)

loc_4454A:
		addq.b	#4,d0
		move.b	d0,4(a2)
		rts
; End of function sub_4450A

; ---------------------------------------------------------------------------
RawAni_44552:	dc.b  $95, $95, $63, $63, $64, $64, $64, $64, $64, $65, $65, $65, $65, $66, $66, $66, $66, $66, $66, $66
		dc.b  $67, $67, $67, $67, $68, $68, $68, $68, $95, $95, $95, $95
byte_44572:	dc.b  $43, $40, $38, $32, $24, $1E, $17, $12,  $E, $EA, $E4, $DC, $D7, $CE, $C6, $C0, $BD, $C0, $C6, $CE
		dc.b  $D7, $DC, $E4, $F0,   0, $10, $17, $1E, $24, $32, $38, $40
; ---------------------------------------------------------------------------

loc_44592:
		move.b	($FFFFFE05).w,d0
		lsr.b	#1,d0
		andi.b	#3,d0
		move.b	d0,$22(a0)
		jmp	(loc_1B662).l
; ---------------------------------------------------------------------------
Map_LRZTurbineSprites:	include "Levels\LRZ\Misc Object Data\Map - Turbine.asm"
; ---------------------------------------------------------------------------

Obj_LRZSpikeBallLauncher:

		move.l	#Map_LRZSpikeBallLauncher,$C(a0)
		move.w	#$240D,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$280,8(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_448A2
		move.l	#loc_44954,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		subi.w	#8,$14(a1)
		move.w	$14(a1),$46(a1)
		move.b	4(a0),4(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.w	#$280,8(a1)
		move.b	#$10,7(a1)
		move.b	#$10,6(a1)
		move.b	#-$66,$28(a1)
		move.w	a1,$3C(a0)

loc_448A2:
		move.l	#loc_448A8,(a0)

loc_448A8:
		lea	(Ani_LRZSpikeBallLauncher).l,a1
		jsr	(Animate_SpriteIrregularDelay).l
		tst.b	5(a0)
		beq.s	loc_448FA
		clr.b	5(a0)
		tst.b	$20(a0)
		bne.s	loc_448D4
		tst.b	4(a0)
		bpl.s	loc_448FA
		moveq	#$53,d0
		jsr	(Play_Sound_2).l
		bra.s	loc_448FA
; ---------------------------------------------------------------------------

loc_448D4:
		tst.b	4(a0)
		bpl.s	loc_448E2
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l

loc_448E2:
		movea.w	$3C(a0),a1
		move.l	#loc_44916,(a1)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#4,d0
		neg.w	d0
		move.w	d0,$1A(a1)

loc_448FA:

		move.w	#$1B,d1
		move.w	#4,d2
		move.w	#5,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_44916:
		subq.b	#1,$24(a0)
		bpl.s	loc_44934
		move.b	#2,$24(a0)
		addq.b	#1,$22(a0)
		cmpi.b	#3,$22(a0)
		bcs.s	loc_44934
		move.b	#0,$22(a0)

loc_44934:

		jsr	(MoveSprite).l
		move.w	$46(a0),d0
		cmp.w	$14(a0),d0
		bcc.s	loc_44954
		move.w	d0,$14(a0)
		move.b	#0,$22(a0)
		move.l	#loc_44954,(a0)

loc_44954:

		jmp	(loc_1B662).l
; ---------------------------------------------------------------------------
Ani_LRZSpikeBallLauncher:	include "Levels\LRZ\Misc Object Data\Anim - Spike Ball Launcher.asm"

Map_LRZSpikeBallLauncher:include "Levels\LRZ\Misc Object Data\Map - Spike Ball Launcher.asm"

; ---------------------------------------------------------------------------

Obj_LevelIntro_PlayerRun:
		move.w	($FFFFB010).w,d0
		addi.w	#$B0,d0
		move.w	d0,$30(a0)
		move.w	($FFFFB014).w,d0
		move.w	d0,$32(a0)
		move.l	#loc_44A26,(a0)

loc_44A26:
		move.b	#1,($FFFFF7CA).w
		move.w	#$800,d0
		move.w	d0,($FFFFF602).w
		move.b	#1,($FFFFF676).w
		move.w	$30(a0),($FFFFF678).w
		move.w	$32(a0),($FFFFF67C).w
		move.w	($FFFFB010).w,d0
		addi.w	#$10,d0
		cmp.w	$30(a0),d0
		bcc.s	loc_44A56
		rts
; ---------------------------------------------------------------------------

loc_44A56:
		move.b	#0,($FFFFF7CA).w
		move.b	#0,($FFFFF7CB).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_SSZFloatingPlatform:

		move.l	#loc_44AA0,(a0)
		move.b	#4,4(a0)
		move.b	#$11,6(a0)
		move.b	#$20,7(a0)
		move.w	#$180,8(a0)
		move.w	#$42D4,$A(a0)
		move.l	#Map_SSZFloatingPlatform,$C(a0)
		move.b	#1,$22(a0)
		move.w	$14(a0),$1A(a0)

loc_44AA0:
		move.w	$2E(a0),d0
		move.b	$2A(a0),d1
		andi.w	#$18,d1
		bne.s	loc_44AB6
		tst.w	d0
		beq.s	loc_44ABE
		subq.w	#1,d0
		bra.s	loc_44ABE
; ---------------------------------------------------------------------------

loc_44AB6:
		cmpi.w	#4,d0
		bcc.s	loc_44ABE
		addq.w	#1,d0

loc_44ABE:

		move.w	d0,$2E(a0)
		add.w	$1A(a0),d0
		move.w	d0,$14(a0)
		moveq	#$2B,d1
		moveq	#$11,d2
		moveq	#$11,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_SSZCollapsingColumn:

		move.l	#loc_44B30,(a0)
		move.b	#4,4(a0)
		move.b	#1,5(a0)
		move.b	#$21,6(a0)
		move.b	#$10,7(a0)
		move.w	#$180,8(a0)
		move.w	#-$1D1C,$A(a0)
		move.l	#Map_SSZFloatingPlatform,$C(a0)
		move.b	#2,$22(a0)
		move.w	$14(a0),$1A(a0)
		jsr	(Random_Number).l
		andi.w	#$1FFF,d0
		addi.w	#$800,d0
		move.w	d0,$30(a0)

loc_44B30:
		move.b	$2A(a0),d0
		andi.w	#$18,d0
		beq.s	loc_44B90
		clr.b	5(a0)
		jsr	(Create_New_Sprite3).l
		bne.s	loc_44B7E
		lea	word_46618(pc),a2
		move.w	$10(a0),d1
		moveq	#7,d2

loc_44B50:
		move.l	#loc_44BCC,(a1)
		move.w	a0,$2E(a1)
		move.w	(a2)+,d3
		add.w	d1,d3
		move.w	d3,$10(a1)
		move.w	(a2)+,$30(a1)
		move.w	(a2)+,$32(a1)
		move.w	(a2)+,d3
		move.b	d3,$22(a1)
		addq.b	#1,5(a0)
		jsr	(CreateNewSprite4).l
		dbne	d2,loc_44B50

loc_44B7E:
		moveq	#$59,d0
		jsr	(Play_Sound_2).l
		clr.b	$22(a0)
		move.l	#loc_44B90,(a0)

loc_44B90:

		tst.b	5(a0)
		beq.s	loc_44B98
		bpl.s	loc_44B9E

loc_44B98:
		move.w	#$7FFF,$10(a0)

loc_44B9E:
		move.l	#$2800,d0
		move.l	#$80,d1
		jsr	Gradual_SwingOffset(pc)
		add.w	$1A(a0),d0
		move.w	d0,$14(a0)
		moveq	#$1B,d1
		moveq	#$21,d2
		moveq	#$21,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_44BCC:
		move.l	#loc_44BF8,(a0)
		move.b	#-$7C,4(a0)
		move.b	#8,6(a0)
		move.b	#8,7(a0)
		move.w	#$200,8(a0)
		move.w	#-$1D1C,$A(a0)
		move.l	#Map_SSZFloatingPlatform,$C(a0)

loc_44BF8:
		movea.w	$2E(a0),a1
		tst.b	4(a0)
		bmi.s	loc_44C14
		tst.w	$32(a0)
		beq.s	loc_44C0E
		bmi.s	loc_44C0E
		subq.b	#1,5(a1)

loc_44C0E:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_44C14:
		subq.w	#1,$32(a0)
		bpl.s	loc_44C2C
		move.w	$14(a0),d0
		addi.l	#$3800,$34(a0)
		add.w	$34(a0),d0
		bra.s	loc_44C3A
; ---------------------------------------------------------------------------

loc_44C2C:
		bne.s	loc_44C32
		subq.b	#1,5(a1)

loc_44C32:
		move.w	$14(a1),d0
		add.w	$30(a0),d0

loc_44C3A:
		move.w	d0,$14(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_SSZCollapsingBridge:

		move.l	#loc_44C76,(a0)
		bset	#2,4(a0)
		move.b	#$10,6(a0)
		move.b	#$20,7(a0)
		move.w	#$180,8(a0)
		move.w	#-$3D0C,$A(a0)
		move.l	#Map_SSZCollapsingBridge,$C(a0)
		bset	#7,$2A(a0)

loc_44C76:
		moveq	#$20,d1
		moveq	#$10,d2
		moveq	#9,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		tst.b	$2C(a0)
		bmi.s	loc_44C96
		move.b	$2A(a0),d0
		andi.w	#$18,d0
		bne.s	loc_44C9C

loc_44C96:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_44C9C:
		lea	($FFFFB000).w,a1
		btst	#3,d0
		bne.s	loc_44CAA
		lea	($FFFFB04A).w,a1

loc_44CAA:
		moveq	#$18,d1
		moveq	#$10,d2
		move.w	#$102,d3
		move.w	$10(a0),d4
		cmp.w	$10(a1),d4
		scc	$2E(a0)
		bcs.s	loc_44CC6
		neg.w	d1
		neg.w	d2
		ror.w	#8,d3

loc_44CC6:
		add.w	d4,d1
		btst	#0,4(a0)
		beq.s	loc_44CD2
		ror.w	#8,d3

loc_44CD2:
		moveq	#6,d4
		moveq	#3,d5
		jsr	(Create_New_Sprite3).l
		bne.s	loc_44D0E

loc_44CDE:
		move.l	#loc_45052,(a1)
		move.b	4(a0),4(a1)
		move.w	d1,$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	d3,$22(a1)
		move.w	d4,$2E(a1)
		sub.w	d2,d1
		ror.w	#8,d3
		addi.w	#6,d4
		jsr	(CreateNewSprite4).l
		dbne	d5,loc_44CDE

loc_44D0E:
		move.l	#loc_44D22,(a0)
		move.w	#6,$30(a0)
		move.w	#$20,$32(a0)
		rts
; ---------------------------------------------------------------------------

loc_44D22:
		subq.w	#1,$30(a0)
		bne.s	loc_44D48
		move.w	#6,$30(a0)
		subq.w	#8,$32(a0)
		bne.s	loc_44D3A
		move.w	#$7FFF,$10(a0)

loc_44D3A:
		moveq	#8,d0
		tst.b	$2E(a0)
		bne.s	loc_44D44
		neg.w	d0

loc_44D44:
		add.w	d0,$10(a0)

loc_44D48:
		move.w	$32(a0),d1
		moveq	#$10,d2
		moveq	#9,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

Obj_SSZCollapsingBridgeDiagonal:

		move.l	#loc_44D98,(a0)
		ori.b	#$44,4(a0)
		move.b	#$20,6(a0)
		move.b	#$40,7(a0)
		move.w	#$180,8(a0)
		move.w	#-$3D0C,$A(a0)
		move.l	#Map_SSZCollapsingBridge,$C(a0)
		move.b	#3,$22(a0)
		bset	#7,$2A(a0)

loc_44D98:
		move.b	$2A(a0),d0
		move.w	d0,-(sp)
		moveq	#$40,d1
		lea	word_46658(pc),a2
		move.w	$10(a0),d4
		jsr	(SolidObjectTopSloped2).l
		move.w	(sp)+,d0
		btst	#3,d0
		beq.s	loc_44DCE
		lea	($FFFFB000).w,a1
		btst	#1,$2A(a1)
		beq.s	loc_44DCE
		tst.b	$40(a1)
		bne.s	loc_44DCE
		bclr	#1,$2A(a1)

loc_44DCE:

		btst	#4,d0
		beq.s	loc_44DEC
		lea	($FFFFB04A).w,a1
		btst	#1,$2A(a1)
		beq.s	loc_44DEC
		tst.b	$40(a1)
		bne.s	loc_44DEC
		bclr	#1,$2A(a1)

loc_44DEC:

		tst.b	$2C(a0)
		bmi.s	loc_44DFC
		move.b	$2A(a0),d0
		andi.w	#$18,d0
		bne.s	loc_44E02

loc_44DFC:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_44E02:
		lea	($FFFFB000).w,a1
		btst	#3,d0
		bne.s	loc_44E10
		lea	($FFFFB04A).w,a1

loc_44E10:
		moveq	#$38,d1
		moveq	#$10,d2
		move.w	#$405,d3
		moveq	#-8,d6
		move.w	$10(a0),d4
		cmp.w	$10(a1),d4
		scc	$2E(a0)
		bcs.s	loc_44E30
		neg.w	d1
		neg.w	d2
		ror.w	#8,d3
		neg.l	d6

loc_44E30:
		add.w	d4,d1
		btst	#0,4(a0)
		beq.s	loc_44E3E
		ror.w	#8,d3
		neg.l	d6

loc_44E3E:
		tst.l	d6
		bmi.s	loc_44E44
		addq.l	#8,d6

loc_44E44:
		moveq	#6,d4
		moveq	#7,d5
		swap	d7
		jsr	(Create_New_Sprite3).l
		bne.s	loc_44E9C

loc_44E52:
		move.l	#loc_45052,(a1)
		move.b	4(a0),d7
		andi.w	#$BF,d7
		move.b	d7,4(a1)
		move.w	d1,$10(a1)
		move.w	$14(a0),d7
		add.w	d6,d7
		move.w	d7,$14(a1)
		move.b	d3,$22(a1)
		move.w	d4,$2E(a1)
		sub.w	d2,d1
		ror.w	#8,d3
		addi.w	#6,d4
		btst	#0,d5
		bne.s	loc_44E92
		tst.l	d6
		bmi.s	loc_44E90
		subq.w	#8,d6
		bra.s	loc_44E92
; ---------------------------------------------------------------------------

loc_44E90:
		addq.w	#8,d6

loc_44E92:

		jsr	(CreateNewSprite4).l
		dbne	d5,loc_44E52

loc_44E9C:
		swap	d7
		move.l	#loc_44EBA,(a0)
		move.w	#6,$30(a0)
		move.w	#$40,$32(a0)
		move.l	#word_46658,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_44EBA:
		subq.w	#1,$30(a0)
		bne.s	loc_44EF6
		move.w	#6,$30(a0)
		addq.l	#4,$34(a0)
		subq.w	#8,$32(a0)
		bne.s	loc_44ED6
		move.w	#$7FFF,$10(a0)

loc_44ED6:
		moveq	#8,d0
		moveq	#2,d1
		tst.b	$2E(a0)
		bne.s	loc_44EE4
		neg.w	d0
		neg.w	d1

loc_44EE4:
		add.w	d0,$10(a0)
		btst	#0,4(a0)
		beq.s	loc_44EF2
		neg.w	d1

loc_44EF2:
		sub.w	d1,$14(a0)

loc_44EF6:
		move.b	$2A(a0),d0
		move.w	d0,-(sp)
		move.w	$32(a0),d1
		movea.l	$34(a0),a2
		move.w	$10(a0),d4
		jsr	(SolidObjectTopSloped2).l
		move.w	(sp)+,d0
		btst	#3,d0
		beq.s	loc_44F2E
		lea	($FFFFB000).w,a1
		btst	#1,$2A(a1)
		beq.s	loc_44F2E
		tst.b	$40(a1)
		bne.s	loc_44F2E
		bclr	#1,$2A(a1)

loc_44F2E:

		btst	#4,d0
		beq.s	loc_44F4C
		lea	($FFFFB04A).w,a1
		btst	#1,$2A(a1)
		beq.s	loc_44F4C
		tst.b	$40(a1)
		bne.s	loc_44F4C
		bclr	#1,$2A(a1)

loc_44F4C:

		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

Obj_77_2:
		move.b	#$44,4(a0)
		move.b	#$10,6(a0)
		move.b	#$60,7(a0)
		move.w	#$180,8(a0)
		move.w	#-$3D0C,$A(a0)
		move.l	#Map_SSZCollapsingBridge,$C(a0)
		move.w	$10(a0),$12(a0)
		move.w	#3,$16(a0)
		bset	#7,$2A(a0)
		move.w	#$C0,$2E(a0)
		lea	loc_44FA2(pc),a1
		tst.b	($FFFFFE2A).w
		beq.s	loc_44F9E
		lea	loc_4501A(pc),a1

loc_44F9E:
		move.l	a1,(a0)
		jmp	(a1)
; ---------------------------------------------------------------------------

loc_44FA2:
		move.w	$2E(a0),d1
		tst.w	($FFFFEEDA).w
		beq.s	loc_45006
		cmpi.w	#$68,d1
		bne.s	loc_44FBA
		moveq	#-$71,d0
		jsr	(Play_Sound_2).l

loc_44FBA:
		subq.w	#2,d1
		move.w	d1,$2E(a0)
		bne.s	loc_45006
		clr.b	($FFFFEED7).w
		clr.w	($FFFFEE14).w
		move.w	#$19A0,($FFFFEE16).w
		move.w	#-$100,($FFFFEE18).w
		move.w	#$1000,d0
		move.w	d0,($FFFFEE1A).w
		move.w	d0,($FFFFEE12).w
		move.w	#$140,($FFFFFE2E).w
		move.w	#$C6C,($FFFFFE30).w
		move.b	#1,($FFFFFE2A).w
		jsr	(Save_Level_Data).l
		clr.l	($FFFFFE34).w
		moveq	#0,d1
		move.l	#loc_4501A,(a0)

loc_45006:

		add.w	$12(a0),d1
		move.w	$10(a0),d4
		move.w	d1,$10(a0)
		bsr.s	sub_45026
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_4501A:

		move.w	$10(a0),d4
		bsr.s	sub_45026
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_45026:

		moveq	#$60,d1
		moveq	#$10,d2

loc_4502A:
		moveq	#9,d3
		jsr	(SolidObjectTop).l
		lea	$18(a0),a1
		move.w	$10(a0),d0
		subi.w	#$40,d0
		moveq	#2,d1

loc_45040:
		move.w	d0,(a1)+
		move.w	$14(a0),(a1)+
		addq.w	#2,a1
		addi.w	#$40,d0

loc_4504C:
		dbf	d1,loc_45040
		rts
; End of function sub_45026

; ---------------------------------------------------------------------------

loc_45052:

		move.l	#loc_4507E,(a0)
		bset	#7,4(a0)

loc_4505E:
		move.b	#$10,6(a0)
		move.b	#8,7(a0)
		move.w	#$200,8(a0)
		move.w	#-$3D0C,$A(a0)
		move.l	#Map_SSZCollapsingBridge,$C(a0)

loc_4507E:
		tst.b	4(a0)
		bmi.s	loc_4508A
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_4508A:
		move.w	$2E(a0),d0
		beq.s	loc_45098
		subq.w	#1,d0
		move.w	d0,$2E(a0)
		bra.s	loc_4509E
; ---------------------------------------------------------------------------

loc_45098:
		jsr	(MoveSprite).l

loc_4509E:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_SSZBouncyCloud:

		move.l	#loc_450EC,(a0)
		move.b	#4,4(a0)
		move.b	#$10,6(a0)
		move.b	#$20,7(a0)
		move.w	#$80,8(a0)
		move.w	#-$1C2A,$A(a0)
		move.l	#Map_SSZBouncyCloud,$C(a0)
		clr.b	$2D(a0)
		move.w	$14(a0),$1A(a0)
		jsr	(Random_Number).l
		andi.w	#$FFF,d0
		addi.w	#$C00,d0
		move.w	d0,$30(a0)

loc_450EC:
		move.l	#$1C00,d0
		move.l	#$80,d1
		jsr	Gradual_SwingOffset(pc)
		add.w	$1A(a0),d0
		move.b	$3E(a0),d1
		move.b	$46(a0),d2
		move.b	d1,d3
		or.b	d2,d3
		beq.s	loc_4511A
		cmp.b	d2,d1
		bcc.s	loc_45114
		exg	d1,d2

loc_45114:
		ext.w	d1
		add.w	d1,d0
		bra.s	loc_45134
; ---------------------------------------------------------------------------

loc_4511A:
		move.b	$39(a0),d1
		move.b	$3F(a0),d2
		move.b	$41(a0),d3
		move.b	$47(a0),d4
		cmp.b	d3,d1
		bcc.s	loc_45130
		exg	d2,d4

loc_45130:
		ext.w	d2
		add.w	d2,d0

loc_45134:
		move.w	d0,$14(a0)
		tst.b	5(a0)
		beq.s	loc_45142
		subq.b	#1,5(a0)

loc_45142:
		move.b	$2D(a0),$20(a0)
		lea	($FFFFB000).w,a1
		lea	$38(a0),a2
		moveq	#3,d6
		bsr.s	sub_45170
		lea	($FFFFB04A).w,a1
		lea	$40(a0),a2
		moveq	#4,d6
		bsr.s	sub_45170
		lea	Ani_SSZBouncyCloud(pc),a1
		jsr	(Animate_Sprite).l
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_45170:

		moveq	#$20,d1
		moveq	#$10,d2
		moveq	#0,d3
		move.w	$10(a0),d4
		jsr	(sub_1E2BC).l
		tst.b	(a2)
		bne.s	loc_451C2
		btst	d6,$2A(a0)
		beq.s	locret_451C0
		move.w	$18(a1),2(a2)
		move.w	$1C(a1),4(a2)
		clr.w	$18(a1)
		clr.w	$1C(a1)
		move.b	#1,$20(a0)
		move.b	#1,$2D(a0)
		move.b	5(a0),d0
		bne.s	loc_451B6
		moveq	#7,d0
		move.b	d0,5(a0)

loc_451B6:
		move.b	d0,(a2)
		move.b	(byte_4669F).l,6(a2)

locret_451C0:
		rts
; ---------------------------------------------------------------------------

loc_451C2:
		bmi.w	loc_4527A
		subq.b	#1,(a2)
		beq.s	loc_451DC
		move.b	(a2),d0
		ext.w	d0
		lea	byte_46698(pc),a3
		move.b	(a3,d0.w),6(a2)
		bra.w	locret_45278
; ---------------------------------------------------------------------------

loc_451DC:
		moveq	#-$76,d0
		jsr	(Play_Sound_2).l
		move.w	2(a2),$18(a1)
		move.w	4(a2),$1C(a1)
		move.w	#-$700,$1A(a1)
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		clr.b	$40(a1)
		clr.b	$3D(a1)
		move.b	#2,5(a1)
		clr.b	$20(a1)
		st	(a2)
		moveq	#-$1C,d0
		btst	#0,$2A(a1)
		bne.s	loc_45226
		neg.w	d0
		bclr	#0,(a2)

loc_45226:
		move.b	d0,$26(a1)
		clr.b	$2D(a0)
		clr.b	6(a2)
		move.b	#$26,1(a2)
		lea	word_466C8(pc),a3
		move.w	$10(a1),d1
		jsr	(Create_New_Sprite3).l
		bne.s	locret_45278
		moveq	#3,d2

loc_4524A:
		move.l	#loc_452DA,(a1)
		move.w	a0,$2E(a1)
		move.w	(a3)+,d3
		add.w	d1,d3
		move.w	d3,$10(a1)
		move.w	(a3)+,d3
		add.w	$14(a0),d3

loc_45262:
		move.w	d3,$14(a1)
		move.w	(a3)+,$18(a1)
		move.w	(a3)+,$1A(a1)

loc_4526E:
		jsr	(CreateNewSprite4).l
		dbne	d2,loc_4524A

locret_45278:

		rts
; ---------------------------------------------------------------------------

loc_4527A:
		tst.b	$2E(a1)
		bne.s	loc_452D6
		move.b	$2A(a1),d0
		btst	#1,d0
		beq.s	loc_452D6
		andi.w	#$28,d0
		bne.s	loc_452D6
		move.b	1(a2),d0
		ext.w	d0
		lea	byte_466A0(pc),a3
		move.b	(a3,d0.w),7(a2)
		subq.b	#1,d0
		bmi.s	loc_452A8
		move.b	d0,1(a2)

loc_452A8:
		move.b	$26(a1),d0
		move.l	#$60002,d1
		btst	#0,(a2)
		bne.s	loc_452C4
		tst.b	d0
		bmi.s	loc_452BE
		swap	d1

loc_452BE:
		add.b	d1,d0
		bcc.s	loc_452D0
		bra.s	loc_452CE
; ---------------------------------------------------------------------------

loc_452C4:
		tst.b	d0
		bpl.s	loc_452CA
		swap	d1

loc_452CA:
		sub.b	d1,d0
		bcc.s	loc_452D0

loc_452CE:
		moveq	#0,d0

loc_452D0:

		move.b	d0,$26(a1)
		bne.s	locret_452D8

loc_452D6:

		clr.b	(a2)

locret_452D8:
		rts
; End of function sub_45170

; ---------------------------------------------------------------------------

loc_452DA:
		movea.w	$2E(a0),a1
		move.w	$10(a1),d0
		tst.w	$18(a0)
		bpl.s	loc_452F4
		subi.w	#$18,d0
		cmp.w	$10(a0),d0
		bls.s	loc_45304
		bra.s	loc_452FE
; ---------------------------------------------------------------------------

loc_452F4:
		addi.w	#$18,d0
		cmp.w	$10(a0),d0
		bcc.s	loc_45304

loc_452FE:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_45304:

		move.l	#loc_45336,(a0)
		move.b	#4,4(a0)
		move.b	#4,6(a0)
		move.b	#4,7(a0)
		move.w	#$80,8(a0)
		move.w	#-$1C2A,$A(a0)
		move.l	#Map_SSZBouncyCloud,$C(a0)
		move.b	#2,$20(a0)

loc_45336:
		lea	Ani_SSZBouncyCloud(pc),a1
		jsr	(Animate_SpriteIrregularDelay).l
		tst.b	5(a0)
		beq.s	loc_4534C
		move.l	#Delete_Current_Sprite,(a0)

loc_4534C:
		jsr	(MoveSprite2).l
		lea	$18(a0),a1
		bsr.s	sub_45364
		lea	$1A(a0),a1
		bsr.s	sub_45364
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_45364:

		move.w	(a1),d0
		asr.w	#2,d0
		sub.w	d0,(a1)
		rts
; End of function sub_45364

; ---------------------------------------------------------------------------

Obj_SSZElevatorBar:

		move.l	#loc_4539E,(a0)
		move.b	#4,4(a0)
		move.b	#4,6(a0)
		move.b	#$30,7(a0)
		move.w	#$180,8(a0)
		move.w	#$4348,$A(a0)
		move.l	#Map_SSZElevatorBar,$C(a0)
		move.w	$14(a0),$1A(a0)

loc_4539E:
		move.l	#$18000,d0
		move.l	#$480,d1
		jsr	Gradual_SwingOffset(pc)
		add.w	$1A(a0),d0
		move.w	d0,$14(a0)
		lea	($FFFFB000).w,a1
		lea	$38(a0),a2
		move.w	($FFFFF602).w,d0
		moveq	#$14,d1
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_453CE
		moveq	#$11,d1

loc_453CE:
		bsr.s	sub_453E6
		lea	($FFFFB04A).w,a1
		lea	$39(a0),a2
		move.w	($FFFFF66A).w,d0
		moveq	#$11,d1
		bsr.s	sub_453E6
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_453E6:

		tst.b	(a2)
		bne.w	loc_4548A
		tst.b	2(a2)
		beq.s	loc_45400
		subq.b	#1,2(a2)
		bne.w	locret_45526
		move.w	#$180,8(a0)

loc_45400:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$28,d0
		cmpi.w	#$50,d0
		bcc.w	locret_45526
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		cmpi.w	#$18,d0
		bcc.w	locret_45526
		tst.b	$2E(a1)
		bne.w	locret_45526
		cmpi.b	#4,5(a1)
		bcc.w	locret_45526
		tst.w	($FFFFFE08).w
		bne.w	locret_45526
		moveq	#$4A,d0
		jsr	(Play_Sound_2).l
		st	(a2)
		move.w	$14(a0),$14(a1)
		add.w	d1,$14(a1)
		clr.w	$18(a1)
		clr.w	$1C(a1)
		clr.b	$3D(a1)
		move.b	#3,$2E(a1)
		andi.b	#-4,4(a1)
		clr.b	$20(a1)
		move.w	#$E5,d0
		btst	#0,$2A(a1)
		beq.s	loc_4547C
		addq.w	#4,d0

loc_4547C:
		move.b	d0,$22(a1)
		jsr	(Tails_Carry_LoadPLC).l
		bra.w	locret_45526
; ---------------------------------------------------------------------------

loc_4548A:
		move.w	$14(a0),$14(a1)
		add.w	d1,$14(a1)
		cmpi.b	#4,5(a1)
		bcs.s	loc_454AA
		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$3C,2(a2)
		bra.s	locret_45526
; ---------------------------------------------------------------------------

loc_454AA:
		move.w	d0,d1
		andi.b	#$70,d1
		beq.s	locret_45526
		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$1E,2(a2)
		move.w	#$80,8(a0)
		move.w	#-$200,d1
		move.w	#-$400,d2
		btst	#$A,d0
		bne.s	loc_454EA
		move.w	#$180,8(a0)
		neg.w	d1
		btst	#$B,d0
		bne.s	loc_454EA
		moveq	#0,d1
		btst	#9,d0
		beq.s	loc_454EA
		moveq	#0,d2

loc_454EA:

		move.w	d1,$18(a1)
		move.l	$2E(a0),d0
		asr.l	#8,d0
		add.w	d2,d0
		move.w	d0,$1A(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		moveq	#$62,d0
		jsr	(Play_Sound_2).l

locret_45526:

		rts
; End of function sub_453E6

; ---------------------------------------------------------------------------

Obj_SSZHPZTeleporter:

		move.l	#loc_455CC,(a0)
		move.b	#4,4(a0)
		move.b	#$10,6(a0)
		move.b	#$18,7(a0)
		move.w	#$180,8(a0)
		move.w	#$35C,$A(a0)
		move.l	#Map_SSZHPZTeleporter,$C(a0)
		move.w	$14(a0),$16(a0)
		move.b	$2C(a0),d0
		bpl.s	loc_45574
		lea	($FFFFEED2).w,a1
		add.b	d0,d0
		bpl.s	loc_4556A
		addq.w	#2,a1

loc_4556A:
		tst.b	(a1)
		bmi.s	loc_45574
		move.w	#$20,$1A(a0)

loc_45574:

		cmpi.w	#$1701,($FFFFFE10).w
		beq.s	loc_455AC
		cmpi.b	#$16,($FFFFFE10).w
		bne.s	loc_455BA
		jsr	(Create_New_Sprite3).l
		bne.s	loc_45596
		move.l	#loc_45B94,(a1)
		move.w	a0,$2E(a1)

loc_45596:
		move.w	#$52E,$A(a0)
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_455B2
		move.b	#$4A,$2C(a0)
		bra.s	loc_455B2
; ---------------------------------------------------------------------------

loc_455AC:
		move.w	#$488,$A(a0)

loc_455B2:

		move.b	#$A,$22(a0)
		bra.s	loc_455CC
; ---------------------------------------------------------------------------

loc_455BA:
		cmpi.w	#$1A00,$10(a0)
		bcs.s	loc_455CC
		cmpi.w	#$680,$14(a0)
		bcs.w	loc_45A66

loc_455CC:


		cmpi.b	#$16,($FFFFFE10).w
		bne.s	loc_455F8
		tst.b	4(a0)
		bpl.s	loc_455EE
		tst.b	$38(a0)
		bne.s	loc_455F8
		move.l	#$40C0408,($FFFFFC62).w
		st	($FFFFF650).w
		bra.s	loc_455F8
; ---------------------------------------------------------------------------

loc_455EE:
		tst.b	$38(a0)
		bne.s	loc_455F8
		clr.b	($FFFFF650).w

loc_455F8:

		move.w	$16(a0),d0
		add.w	$1A(a0),d0
		move.w	d0,$14(a0)
		jsr	sub_45866(pc)
		tst.b	$2C(a0)
		bne.s	loc_45616
		tst.b	($FFFFEED6).w
		bne.w	loc_456EE

loc_45616:
		tst.w	$1A(a0)
		bne.s	loc_4562C
		moveq	#$23,d1
		lea	byte_466E8(pc),a2
		move.w	$10(a0),d4
		jsr	(SolidObjectTopSloped2).l

loc_4562C:
		lea	($FFFFEED2).w,a1
		move.b	$2C(a0),d0
		beq.w	loc_456EE
		bpl.s	loc_45660
		add.b	d0,d0
		bpl.s	loc_45640
		addq.w	#2,a1

loc_45640:
		tst.b	(a1)
		bpl.w	loc_456EE
		tst.w	$1A(a0)
		beq.s	loc_45660
		move.w	($FFFFFE04).w,d0
		andi.w	#3,d0
		bne.w	loc_456EE
		subq.w	#1,$1A(a0)
		bra.w	loc_456EE
; ---------------------------------------------------------------------------

loc_45660:

		btst	#3,$2A(a0)
		beq.w	loc_456EE
		lea	($FFFFB000).w,a2
		move.w	$10(a2),d0
		sub.w	$10(a0),d0
		addi.w	#$C,d0
		cmpi.w	#$18,d0
		bcc.s	loc_456EE
		tst.b	$2E(a2)
		bne.w	loc_456EE
		cmpi.b	#4,5(a2)
		bcc.w	loc_456EE
		tst.w	($FFFFFE08).w
		bne.w	loc_456EE
		jsr	(Create_New_Sprite3).l
		bne.s	loc_456EE
		move.w	a1,$3C(a0)
		move.l	#Obj_TeleporterBeam,(a1)
		move.w	a0,$48(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		clr.w	$18(a2)

loc_456C0:
		clr.w	$1C(a2)

loc_456C4:
		move.w	#-1,$1A(a2)
		clr.b	$3D(a2)
		move.b	#1,$2E(a2)

loc_456D4:
		move.b	#5,$20(a2)
		move.l	#loc_456F4,(a0)
		move.w	#-$100,$38(a0)
		moveq	#$53,d0
		jsr	(Play_Sound_2).l

loc_456EE:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_456F4:
		jsr	sub_45856(pc)
		lea	($FFFFB000).w,a1
		movea.w	$3C(a0),a2
		cmpi.b	#8,$46(a2)
		blt.w	loc_457B8
		beq.w	loc_457A2
		cmpi.b	#$18,$46(a2)
		bcc.s	loc_45744
		btst	#0,($FFFFFE05).w
		beq.w	loc_457B8
		subq.w	#1,$14(a1)
		btst	#1,($FFFFFE05).w
		beq.w	loc_457B8
		moveq	#1,d1
		move.w	$10(a1),d0
		cmp.w	$10(a0),d0
		beq.s	loc_457B8
		bcs.s	loc_4573E
		neg.w	d1

loc_4573E:
		add.w	d1,$10(a1)
		bra.s	loc_457B8
; ---------------------------------------------------------------------------

loc_45744:
		move.l	#loc_457BE,(a0)
		move.b	$2C(a0),d0
		cmpi.b	#$16,($FFFFFE10).w
		beq.s	loc_4575A
		andi.w	#$3F,d0

loc_4575A:
		move.b	d0,$2D(a0)
		move.b	#3,$2E(a1)
		moveq	#0,d0
		move.b	d0,$20(a1)
		move.b	d0,$22(a1)
		cmpi.b	#$16,($FFFFFE10).w
		bne.s	loc_4577E
		move.w	#$AA0,($FFFFEE14).w
		bra.s	loc_45790
; ---------------------------------------------------------------------------

loc_4577E:
		move.w	#-$100,($FFFFEE18).w
		move.w	#$1000,d0
		move.w	d0,($FFFFEE1A).w
		move.w	d0,($FFFFEE12).w

loc_45790:
		clr.b	($FFFFEED7).w
		moveq	#$73,d0
		jsr	(Play_Sound_2).l
		st	($FFFFEE0A).w
		bra.s	loc_457B8
; ---------------------------------------------------------------------------

loc_457A2:
		bclr	#3,$2A(a1)
		bset	#2,$2A(a1)
		move.b	#2,$20(a1)
		st	($FFFFEED6).w

loc_457B8:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_457BE:
		jsr	sub_45856(pc)
		lea	($FFFFB000).w,a1
		tst.b	$2D(a0)
		bne.s	loc_45804
		move.b	#1,$2E(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		move.w	$14(a1),$3E(a0)
		clr.l	$2E(a0)
		clr.l	$32(a0)
		clr.b	$36(a0)
		clr.b	($FFFFEE0A).w
		movea.w	$3C(a0),a1
		st	5(a1)
		move.l	#loc_4581C,(a0)
		rts
; ---------------------------------------------------------------------------

loc_45804:
		subi.w	#$10,$14(a1)
		subq.b	#1,$2D(a0)
		beq.s	loc_45816
		subi.w	#$10,($FFFFEE7C).w

loc_45816:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_4581C:
		jsr	sub_45856(pc)
		lea	($FFFFB000).w,a1
		move.l	#$20000,d0
		move.l	#$800,d1
		jsr	Gradual_SwingOffset(pc)
		add.w	$3E(a0),d0
		move.w	d0,$14(a1)
		tst.l	$2E(a0)
		bmi.s	locret_45854
		clr.b	$2E(a1)
		clr.b	$20(a1)
		clr.b	($FFFFEED6).w
		move.l	#loc_455CC,(a0)

locret_45854:
		rts

; =============== S U B R O U T I N E =======================================


sub_45856:

		moveq	#$23,d1
		lea	byte_466E8(pc),a2
		move.w	$10(a0),d4
		jsr	(SolidObjectTopSloped2).l
; End of function sub_45856


; =============== S U B R O U T I N E =======================================


sub_45866:

		tst.b	$39(a0)
		beq.s	loc_45872
		subq.b	#1,$39(a0)
		bra.s	locret_458B2
; ---------------------------------------------------------------------------

loc_45872:
		move.b	#3,$39(a0)
		move.w	$3A(a0),d0
		bne.s	loc_45884
		tst.b	$38(a0)
		beq.s	locret_458B2

loc_45884:
		addq.w	#4,d0
		cmpi.w	#$28,d0
		bcs.s	loc_4588E
		moveq	#0,d0

loc_4588E:
		move.w	d0,$3A(a0)
		lea	word_4670C(pc),a1
		cmpi.b	#$A,($FFFFFE10).w
		bne.s	loc_458A6
		move.l	(a1,d0.w),($FFFFFC58).w
		bra.s	locret_458B2
; ---------------------------------------------------------------------------

loc_458A6:
		move.w	2(a1,d0.w),($FFFFFC62).w
		move.w	(a1,d0.w),($FFFFFC64).w

locret_458B2:

		rts
; End of function sub_45866

; ---------------------------------------------------------------------------

Obj_TeleporterBeam:

		move.l	#Obj_TeleporterBeamSpawn,(a0)
		move.b	#$44,4(a0)		; Multisprite mode
		move.b	#-$80,6(a0)
		move.b	#$18,7(a0)
		move.w	#$80,8(a0)
		move.w	#-$1CA4,$A(a0)
		move.l	#Map_SSZHPZTeleporter,$C(a0)
		move.w	#1,$16(a0)
		move.w	$14(a0),$44(a0)
		subi.w	#$88,$44(a0)
		move.b	#$10,$47(a0)	; Wait 16 frames
		cmpi.b	#3,($FFFFFE10).w
		bne.s	loc_45908
		move.w	#$24EE,$A(a0)	; If in CNZ, use this VRAM offset
		bra.s	Obj_TeleporterBeamSpawn
; ---------------------------------------------------------------------------

loc_45908:
		cmpi.b	#$16,($FFFFFE10).w
		bne.s	Obj_TeleporterBeamSpawn
		move.w	#$652E,$A(a0)	; If in HPZ, use this VRAM offset

Obj_TeleporterBeamSpawn:


		tst.b	$47(a0)
		beq.s	loc_45922
		subq.b	#1,$47(a0)
		bra.s	locret_45990
; ---------------------------------------------------------------------------

loc_45922:
		btst	#0,($FFFFFE05).w
		beq.s	locret_45990		; Do a flickering effect
		lea	$18(a0),a1			; Sprite attribute table to a1
		move.w	$14(a0),d0
		move.w	$16(a0),d1
		subq.w	#1,d1

loc_45938:
		move.w	$10(a0),(a1)	; Same X coordinate for all sprites
		move.w	d0,2(a1)		; Different Y coordinate offset from base
		tst.w	d1
		bne.s	loc_45960
		eori.b	#-1,$46(a0)		; If the last listed sprite
		beq.s	loc_45954
		move.b	#1,5(a1)		; Use mapping 1 on the first frame
		bra.s	loc_4596C
; ---------------------------------------------------------------------------

loc_45954:
		move.b	#2,5(a1)		; Mapping 2 on the second frame + add new sprite
		addq.w	#1,$16(a0)
		bra.s	loc_4596C
; ---------------------------------------------------------------------------

loc_45960:
		move.b	#2,5(a1)
		subi.w	#$20,d0
		addq.w	#6,a1

loc_4596C:

		dbf	d1,loc_45938
		cmpi.w	#7,$16(a0)
		bcs.s	loc_4598A
		tst.b	$46(a0)			; When seven sprites have been made, test $46
		bne.s	loc_4598A
		move.l	#Obj_TeleporterBeamWait,(a0)	; When last sprite uses mapping frame 2, go to next phase
		move.b	#$10,$47(a0)

loc_4598A:

		jsr	(Draw_Sprite).l

locret_45990:

		rts
; ---------------------------------------------------------------------------

Obj_TeleporterBeamWait:
		subq.b	#1,$47(a0)
		beq.s	loc_459A8
		btst	#0,($FFFFFE05).w
		beq.s	locret_459A6
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_459A6:
		rts
; ---------------------------------------------------------------------------

loc_459A8:
		move.l	#Obj_TeleporterBeamExpand,(a0)
		move.w	#2,$16(a0)			; Use two large sprites for the beam

Obj_TeleporterBeamExpand:

		btst	#0,($FFFFFE05).w
		beq.w	locret_45A64
		move.w	$44(a0),d0
		move.w	d0,d1
		sub.w	($FFFFEE7C).w,d1
		cmpi.w	#$68,d1
		ble.s	loc_459D6
		move.w	($FFFFEE7C).w,d0
		addi.w	#$68,d0			; Ensure that object base Y is always centered or above the screen

loc_459D6:
		move.w	d0,$14(a0)
		move.w	$10(a0),d1
		moveq	#0,d2
		move.b	$46(a0),d2		; $46 should be 0 starting out
		move.w	d2,d3
		cmpi.w	#$12,d2			; Maximum of $12
		bcs.s	loc_459EE
		moveq	#$12,d2

loc_459EE:
		addq.w	#6,d2
		lsl.w	#3,d3
		lea	word_46734(pc),a1		; Use if in SSZ or HPZ
		cmpi.b	#$A,($FFFFFE10).w
		beq.s	loc_45A0A
		cmpi.b	#$16,($FFFFFE10).w
		beq.s	loc_45A0A
		lea	word_467FC(pc),a1		; Use if anywhere else

loc_45A0A:

		adda.w	d3,a1
		lea	$18(a0),a2
		move.w	d1,(a2)
		sub.w	d2,(a2)+
		move.w	(a1)+,(a2)
		add.w	d0,(a2)+
		move.w	(a1)+,(a2)+
		move.w	d1,(a2)
		add.w	d2,(a2)+
		move.w	(a1)+,(a2)
		add.w	d0,(a2)+
		move.w	(a1)+,(a2)+
		tst.b	5(a0)
		beq.s	loc_45A4A
		subq.b	#1,$46(a0)		; Contract beam
		bpl.s	loc_45A5E		; Branch if beam is still in effect
		move.b	#9,$22(a0)		; Change main mapping
		clr.w	$16(a0)			; No more sprites
		move.l	#Delete_Current_Sprite,(a0)		; Delete object
		movea.w	$48(a0),a1
		clr.b	$38(a1)			; Set flag to parent indicating completion
		bra.s	loc_45A5E
; ---------------------------------------------------------------------------

loc_45A4A:
		btst	#1,($FFFFFE05).w
		beq.s	loc_45A5E
		cmpi.b	#$18,$46(a0)
		bcc.s	loc_45A5E
		addq.b	#1,$46(a0)		; Expand beam

loc_45A5E:

		jsr	(Draw_Sprite).l

locret_45A64:
		rts
; ---------------------------------------------------------------------------

loc_45A66:
		move.l	#loc_45A72,(a0)
		addi.w	#-$8000,$A(a0)

loc_45A72:
		tst.w	$32(a0)
		beq.s	loc_45A84
		subq.w	#1,$32(a0)
		bne.s	loc_45AD0
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_45A84:
		tst.w	$2E(a0)
		bne.s	loc_45AB0
		move.w	($FFFFEE7C).w,d0
		cmp.w	($FFFFEE1A).w,d0
		bne.s	loc_45AD0
		jsr	(Create_New_Sprite).l
		bne.s	loc_45AAE
		move.l	#Obj_A3_2,(a1)
		move.w	a1,($FFFFFAA4).w
		move.w	a1,$30(a0)
		st	$2E(a0)

loc_45AAE:
		bra.s	loc_45AD0
; ---------------------------------------------------------------------------

loc_45AB0:
		movea.w	$30(a0),a1
		move.w	$10(a1),d0
		cmp.w	$10(a0),d0
		bhi.s	loc_45AD0
		move.w	#$20,$32(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild1_Normal).l

loc_45AD0:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_45AD6:
		jsr	sub_45866(pc)
		tst.b	5(a0)
		beq.s	loc_45B16
		jsr	(Create_New_Sprite3).l
		bne.s	loc_45B16
		move.w	a1,$3C(a0)
		move.l	#Obj_TeleporterBeam,(a1)
		move.w	a0,$48(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.l	#loc_45B1C,(a0)
		move.w	#-$100,$38(a0)
		moveq	#$53,d0
		jsr	(Play_Sound_2).l

loc_45B16:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_45B1C:
		jsr	sub_45866(pc)
		movea.w	($FFFFFAA4).w,a1
		movea.w	$3C(a0),a2
		cmpi.b	#8,$46(a2)
		blt.w	loc_45B84
		beq.w	loc_45B7E
		cmpi.b	#$18,$46(a2)
		bcc.s	loc_45B6C

loc_45B3E:
		btst	#0,($FFFFFE05).w
		beq.w	loc_45B84
		subq.w	#1,$14(a1)
		btst	#1,($FFFFFE05).w

loc_45B52:
		beq.w	loc_45B84
		moveq	#1,d1
		move.w	$10(a1),d0
		cmp.w	$10(a0),d0
		beq.s	loc_45B84
		bcs.s	loc_45B66
		neg.w	d1

loc_45B66:
		add.w	d1,$10(a1)
		bra.s	loc_45B84
; ---------------------------------------------------------------------------

loc_45B6C:
		clr.l	(a1)
		moveq	#$73,d0
		jsr	(Play_Sound_2).l
		move.l	#loc_45B8A,(a0)
		bra.s	loc_45B84
; ---------------------------------------------------------------------------

loc_45B7E:
		bset	#7,($FFFFFAB8).w

loc_45B84:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_45B8A:
		jsr	sub_45866(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_45B94:
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_45BC8
		cmpi.w	#$240,($FFFFEE7C).w
		bcc.s	locret_45BF2
		cmpi.w	#$B00,($FFFFB010).w
		bcs.s	locret_45BF2
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		st	($FFFFEF56).w
		jsr	(SaveGame).l
		move.w	#$A01,d0
		jmp	(StartNewLevel).l
; ---------------------------------------------------------------------------

loc_45BC8:
		movea.w	$2E(a0),a1
		cmpi.w	#$1000,$10(a1)
		bcc.s	loc_45BDA
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_45BDA:
		move.l	#$40C0408,($FFFFFC62).w
		st	($FFFFF650).w
		move.l	#loc_45AD6,(a1)
		move.l	#loc_45BF4,(a0)

locret_45BF2:

		rts
; ---------------------------------------------------------------------------

loc_45BF4:
		move.w	#$1600,d0
		cmp.w	($FFFFEE78).w,d0
		bcs.s	loc_45C0C
		cmp.w	($FFFFEE16).w,d0
		beq.s	loc_45C0C
		move.w	d0,($FFFFEE16).w
		clr.w	($FFFFEE18).w

loc_45C0C:

		lea	($FFFFB000).w,a1
		lea	($FFFFF602).w,a2
		lea	($FFFFF7CA).w,a3
		lea	$30(a0),a4
		lea	1(a4),a5
		moveq	#0,d6
		bsr.s	sub_45C8E
		tst.w	($FFFFFF08).w
		bne.s	loc_45C42
		lea	($FFFFB04A).w,a1
		lea	($FFFFF66A).w,a2
		lea	($FFFFF7CB).w,a3
		lea	$31(a0),a4
		lea	-1(a4),a5
		moveq	#1,d6
		bsr.s	sub_45C8E

loc_45C42:
		move.b	$2C(a0),d0
		beq.s	loc_45C72
		subq.b	#1,d0
		bne.s	loc_45C60
		subq.b	#1,$2D(a0)
		bne.s	loc_45C72
		bset	#6,($FFFFFAB8).w
		move.w	#$23C,$2C(a0)
		bra.s	loc_45C72
; ---------------------------------------------------------------------------

loc_45C60:
		subq.b	#1,$2D(a0)
		bne.s	loc_45C72
		movea.w	$2E(a0),a1
		st	5(a1)
		clr.w	$2C(a0)

loc_45C72:

		tst.b	5(a0)
		beq.s	locret_45C8C
		subq.w	#1,($FFFFEE78).w
		btst	#0,5(a0)
		beq.s	loc_45C88
		subq.w	#1,($FFFFEE7C).w

loc_45C88:
		subq.b	#1,5(a0)

locret_45C8C:
		rts

; =============== S U B R O U T I N E =======================================


sub_45C8E:

		move.b	(a4),d0
		bmi.w	locret_45DAC
		bne.s	loc_45CC0
		move.w	#$1628,d0
		tst.w	d6
		beq.s	loc_45CA2
		addi.w	#$10,d0

loc_45CA2:
		cmp.w	$10(a1),d0
		bcs.w	locret_45DAC
		move.w	d0,$10(a1)
		clr.w	$18(a1)
		clr.w	$1C(a1)
		clr.w	(a2)
		st	(a3)
		addq.b	#1,(a4)
		bra.w	locret_45DAC
; ---------------------------------------------------------------------------

loc_45CC0:
		subq.b	#1,d0
		bne.s	loc_45CE4
		btst	#1,$2A(a1)
		bne.w	locret_45DAC
		move.b	#-$60,2(a4)
		tst.w	d6
		beq.s	loc_45CDE
		move.b	#-$24,2(a4)

loc_45CDE:
		addq.b	#1,(a4)
		bra.w	locret_45DAC
; ---------------------------------------------------------------------------

loc_45CE4:
		subq.b	#1,d0
		bne.s	loc_45D0C
		tst.w	($FFFFFF08).w
		bne.s	loc_45CF6
		tst.b	2(a5)
		beq.w	locret_45DAC

loc_45CF6:
		move.w	#$13C,$2C(a0)
		move.b	#$48,5(a0)
		st	($FFFFEE0A).w
		addq.b	#1,(a4)
		bra.w	locret_45DAC
; ---------------------------------------------------------------------------

loc_45D0C:
		subq.b	#1,d0
		bne.s	loc_45D2E
		tst.w	$2C(a0)
		bne.w	locret_45DAC
		subq.b	#1,2(a4)
		bne.w	locret_45DAC
		move.w	#-$100,$18(a1)
		move.w	#$2424,(a2)
		addq.b	#1,(a4)
		bra.s	locret_45DAC
; ---------------------------------------------------------------------------

loc_45D2E:
		subq.b	#1,d0
		bne.s	loc_45D8A
		move.w	#$15C0,d0
		cmp.w	$10(a1),d0
		bcs.s	loc_45D84
		move.w	d0,$10(a1)
		subi.w	#$80,$14(a1)
		clr.w	$18(a1)
		clr.w	$1C(a1)
		move.b	#3,$2E(a1)
		clr.b	$20(a1)
		clr.b	$22(a1)
		clr.w	(a2)
		moveq	#$73,d0
		jsr	(Play_Sound_2).l
		tst.w	d6
		beq.s	loc_45D6E
		st	(a4)
		rts
; ---------------------------------------------------------------------------

loc_45D6E:
		move.b	#$3C,2(a4)
		tst.w	($FFFFFF08).w
		bne.s	loc_45D80
		move.b	#$78,2(a4)

loc_45D80:
		addq.b	#1,(a4)
		bra.s	locret_45DAC
; ---------------------------------------------------------------------------

loc_45D84:
		move.w	#$2404,(a2)
		bra.s	locret_45DAC
; ---------------------------------------------------------------------------

loc_45D8A:
		subq.b	#1,2(a4)
		bne.s	locret_45DAC
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		st	($FFFFEF56).w
		jsr	(SaveGame).l
		move.w	#$A00,d0
		jmp	(StartNewLevel).l
; ---------------------------------------------------------------------------

locret_45DAC:

		rts
; End of function sub_45C8E

; ---------------------------------------------------------------------------

Obj_SSZRotatingPlatform:

		move.l	#loc_45DFE,(a0)
		move.b	#4,4(a0)
		move.b	#$20,6(a0)
		move.b	#$C,7(a0)
		move.w	#$100,8(a0)
		move.w	#$437E,$A(a0)
		move.l	#Map_SSZRotatingPlatform,$C(a0)
		jsr	(Create_New_Sprite3).l
		bne.s	loc_45DFE
		move.w	a1,$32(a0)
		move.l	#loc_45F10,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	$2C(a0),$2C(a1)

loc_45DFE:

		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bls.s	loc_45E2E
		move.w	$32(a0),d0
		beq.s	loc_45E1C
		movea.w	d0,a1
		st	5(a1)

loc_45E1C:
		move.w	$48(a0),d0
		beq.s	loc_45E28
		movea.w	d0,a1
		bclr	#7,(a1)

loc_45E28:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_45E2E:
		lea	Ani_SSZRotatingPlatform(pc),a1
		jsr	(Animate_Sprite).l
		moveq	#$10,d1
		moveq	#$21,d2
		moveq	#$21,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		lea	($FFFFB000).w,a1
		lea	($FFFFF602).w,a2
		lea	$2E(a0),a3
		moveq	#3,d6
		bsr.s	sub_45E6E
		lea	($FFFFB04A).w,a1
		lea	($FFFFF66A).w,a2
		lea	$30(a0),a3
		moveq	#4,d6
		bsr.s	sub_45E6E
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_45E6E:

		tst.b	(a3)
		bne.s	loc_45E82
		btst	d6,$2A(a0)
		beq.w	locret_45F0E
		move.w	#$100,(a3)
		bra.w	locret_45F0E
; ---------------------------------------------------------------------------

loc_45E82:
		tst.b	(a3)
		bmi.s	loc_45E90
		btst	d6,$2A(a0)
		bne.s	loc_45E90
		clr.b	(a3)
		bra.s	locret_45F0E
; ---------------------------------------------------------------------------

loc_45E90:

		st	(a3)
		clr.w	$18(a1)
		clr.w	$1C(a1)
		clr.b	$3D(a1)
		clr.b	$20(a1)
		bclr	#2,$2A(a1)
		move.b	#3,$2E(a1)
		move.w	(a2),d0
		andi.w	#$70,d0
		beq.s	loc_45EEE
		clr.b	(a3)
		move.w	#-$680,$1A(a1)
		clr.b	$2E(a1)
		bset	#2,$2A(a1)
		bset	#1,$2A(a1)

loc_45ECE:
		move.b	#1,$40(a1)
		move.b	#2,$20(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		moveq	#$62,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

loc_45EEE:
		moveq	#1,d1
		move.w	$10(a1),d0
		cmp.w	$10(a0),d0
		beq.s	loc_45F02
		bmi.s	loc_45EFE
		neg.w	d1

loc_45EFE:
		add.w	d1,$10(a1)

loc_45F02:
		addq.b	#2,1(a3)
		move.b	1(a3),d0
		jmp	loc_460A6(pc)
; ---------------------------------------------------------------------------

locret_45F0E:

		rts
; ---------------------------------------------------------------------------

loc_45F10:
		move.l	#loc_45F2E,(a0)
		addi.w	#$30,$14(a0)
		moveq	#$60,d0
		btst	#0,$2C(a0)
		beq.s	loc_45F2A
		move.w	#$A0,d0

loc_45F2A:
		move.b	d0,7(a0)

loc_45F2E:
		tst.b	5(a0)
		beq.s	loc_45F3A
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_45F3A:
		moveq	#$B,d1
		add.b	7(a0),d1
		moveq	#$11,d2
		moveq	#$11,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		lea	($FFFFB000).w,a1
		lea	($FFFFF602).w,a2
		lea	$2E(a0),a3
		lea	$34(a0),a4
		moveq	#3,d6
		bsr.s	loc_45F74
		lea	($FFFFB04A).w,a1
		lea	($FFFFF66A).w,a2
		lea	$34(a0),a3
		lea	$2E(a0),a4
		moveq	#4,d6

loc_45F74:
		tst.b	(a3)
		bne.s	loc_45FD6
		btst	d6,$2A(a0)
		bne.s	loc_45FB8
		tst.b	1(a3)
		beq.s	locret_45FB6
		move.w	$14(a0),d0
		subi.w	#$64,d0
		cmp.w	$14(a1),d0
		bcc.s	loc_45FAC
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		add.w	d1,d0
		add.w	d1,d1
		cmp.w	d1,d0
		bcs.s	locret_45FB6

loc_45FAC:
		clr.b	1(a3)
		move.w	#$100,8(a1)

locret_45FB6:

		rts
; ---------------------------------------------------------------------------

loc_45FB8:
		move.w	#$1FF,(a3)
		moveq	#0,d1
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		bpl.s	loc_45FCC
		neg.w	d0
		moveq	#-$80,d1

loc_45FCC:
		move.w	d0,4(a3)
		move.b	d1,2(a3)
		rts
; ---------------------------------------------------------------------------

loc_45FD6:
		tst.b	(a3)
		bmi.s	loc_45FE4
		btst	d6,$2A(a0)
		bne.s	loc_45FE4
		clr.b	(a3)
		rts
; ---------------------------------------------------------------------------

loc_45FE4:

		st	(a3)
		clr.w	$18(a1)
		clr.w	$1C(a1)
		clr.b	$3D(a1)
		clr.b	$20(a1)
		bclr	#2,$2A(a1)
		move.b	#3,$2E(a1)
		move.w	(a2),d0
		andi.w	#$70,d0
		beq.s	loc_46042
		clr.b	(a3)
		move.w	#-$680,$1A(a1)
		clr.b	$2E(a1)
		bset	#2,$2A(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		move.b	#2,$20(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		moveq	#$62,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

loc_46042:
		addq.b	#2,2(a3)
		cmpi.w	#$14,4(a3)
		bcc.s	loc_46052
		addq.w	#1,4(a3)

loc_46052:
		move.b	2(a3),d0
		cmpi.b	#-$80,d0
		bcs.s	loc_46074
		move.w	#$180,d1
		tst.b	(a4)
		beq.s	loc_4608A
		move.w	4(a4),d2
		cmp.w	4(a3),d2
		bcc.s	loc_4608A
		move.w	#$200,d1
		bra.s	loc_4608A
; ---------------------------------------------------------------------------

loc_46074:
		move.w	#$100,d1
		tst.b	(a4)
		beq.s	loc_4608A
		move.w	4(a4),d2
		cmp.w	4(a3),d2
		bcc.s	loc_4608A
		move.w	#$80,d1

loc_4608A:

		move.w	d1,8(a1)
		jsr	(GetSineCosine).l
		muls.w	4(a3),d1
		asr.l	#8,d1
		add.w	$10(a0),d1
		move.w	d1,$10(a1)
		move.b	2(a3),d0

loc_460A6:
		addi.w	#$A,d0
		andi.w	#$FF,d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		lsr.w	#5,d0
		andi.w	#-2,d0
		lea	byte_468C4(pc),a2
		adda.w	d0,a2
		move.b	(a2)+,d0
		andi.b	#-4,4(a1)
		or.b	d0,4(a1)
		move.b	(a2),d0
		move.b	d0,$22(a1)
		jmp	(Tails_Carry_LoadPLC).l
; End of function sub_45E6E

; ---------------------------------------------------------------------------

Obj_SSZSwingingCarrier:

		move.l	#loc_46142,(a0)
		move.b	#4,4(a0)
		move.b	#8,6(a0)
		move.w	#$180,8(a0)
		move.w	#$4348,$A(a0)
		move.l	#Map_SSZElevatorBar,$C(a0)
		moveq	#$30,d0
		moveq	#1,d1
		tst.b	$2C(a0)
		bpl.s	loc_4610C
		moveq	#8,d0
		moveq	#4,d1

loc_4610C:
		move.b	d0,7(a0)
		move.b	d1,$22(a0)
		jsr	(Create_New_Sprite3).l
		bne.s	loc_46142
		move.w	a1,$38(a0)
		move.l	#loc_461A8,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	$2A(a0),$2A(a1)
		move.b	$2C(a0),$2C(a1)
		move.w	a0,$48(a1)

loc_46142:

		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bls.s	loc_46172
		move.w	$38(a0),d0
		beq.s	loc_46160
		movea.w	d0,a1
		st	5(a1)

loc_46160:
		move.w	$48(a0),d0
		beq.s	loc_4616C
		movea.w	d0,a1
		bclr	#7,(a1)

loc_4616C:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_46172:
		tst.b	$2C(a0)
		bmi.s	loc_46192
		move.l	#$20000,d0
		move.l	#$821,d1
		jsr	Gradual_SwingOffset(pc)
		addi.w	#$41,d0
		move.w	d0,$20(a0)
		bra.s	loc_461A2
; ---------------------------------------------------------------------------

loc_46192:
		moveq	#1,d0
		btst	#0,$2A(a0)
		beq.s	loc_4619E
		neg.w	d0

loc_4619E:
		add.w	d0,$20(a0)

loc_461A2:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_461A8:
		move.l	#loc_461FE,(a0)
		move.b	#$44,4(a0)
		move.b	#$68,6(a0)
		move.b	#$68,7(a0)
		move.w	#$6348,$A(a0)
		move.l	#Map_SSZElevatorBar,$C(a0)
		move.b	$2C(a0),d0
		andi.w	#3,d0
		addq.w	#6,d0
		move.w	d0,$16(a0)
		jsr	(Create_New_Sprite3).l
		bne.s	loc_461FE
		move.w	a1,$12(a0)
		move.l	#loc_46284,(a1)
		move.b	$2A(a0),$2A(a1)
		move.b	$2C(a0),$2C(a1)
		move.w	a0,$2E(a1)

loc_461FE:

		tst.b	5(a0)
		beq.s	loc_46216
		move.w	$12(a0),d0
		beq.s	loc_46210
		movea.w	d0,a1
		st	5(a1)

loc_46210:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_46216:
		movea.w	$48(a0),a1
		move.w	#$180,d1
		move.w	$20(a1),d0
		subi.w	#$40,d0
		andi.w	#$FF,d0
		cmpi.w	#$80,d0
		bcs.s	loc_46234
		move.w	#$100,d1

loc_46234:
		move.w	d1,8(a0)
		move.w	$20(a1),d0
		jsr	(GetSineCosine).l
		swap	d1
		clr.w	d1
		asr.l	#4,d1
		swap	d0
		clr.w	d0
		asr.l	#4,d0
		move.l	$10(a0),d3
		move.l	$14(a0),d2
		clr.w	d2
		move.w	$16(a0),d4
		subq.w	#1,d4
		lea	$18(a0),a1

loc_46262:
		add.l	d1,d3
		add.l	d0,d2
		swap	d3
		swap	d2
		move.w	d3,(a1)+
		move.w	d2,(a1)+
		move.b	#2,1(a1)
		swap	d3
		swap	d2
		addq.w	#2,a1
		dbf	d4,loc_46262
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_46284:
		move.l	#loc_462B6,(a0)
		move.b	#4,4(a0)
		move.b	#$C,6(a0)
		move.b	#$18,7(a0)
		move.w	#$80,8(a0)
		move.w	#$6348,$A(a0)
		move.l	#Map_SSZElevatorBar,$C(a0)
		move.b	#3,$22(a0)

loc_462B6:
		tst.b	5(a0)
		beq.s	loc_462C2
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_462C2:
		movea.w	$2E(a0),a1
		move.w	$16(a1),d0
		subq.w	#1,d0
		add.w	d0,d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		move.w	$18(a1,d0.w),$10(a0)
		move.w	$1A(a1,d0.w),d0
		addi.w	#$C,d0
		move.w	d0,$14(a0)
		moveq	#$23,d1
		moveq	#8,d2
		moveq	#8,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		swap	d6
		move.w	d6,-(sp)
		lea	($FFFFB000).w,a1
		lea	($FFFFF602).w,a2
		lea	$30(a0),a3
		moveq	#3,d5
		bsr.s	sub_46324
		move.w	(sp)+,d6
		lsr.w	#1,d6
		lea	($FFFFB04A).w,a1
		lea	($FFFFF66A).w,a2
		lea	$32(a0),a3
		moveq	#4,d5
		bsr.s	sub_46324
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_46324:

		tst.b	(a3)
		bne.s	loc_4639A
		tst.b	$2E(a1)
		bne.s	locret_46348
		cmpi.b	#4,5(a1)
		bcc.s	locret_46348
		btst	d5,$2A(a0)
		bne.s	loc_4634A
		andi.w	#5,d6
		beq.s	locret_46348
		jsr	(sub_24280).l

locret_46348:

		rts
; ---------------------------------------------------------------------------

loc_4634A:
		moveq	#$3C,d0
		jsr	(Play_Sound_2).l
		st	(a3)
		move.b	#1,$2E(a1)
		clr.w	$1A(a1)
		clr.w	$18(a1)
		clr.w	$1C(a1)
		clr.b	$3D(a1)
		bset	#2,$2A(a1)
		move.b	#2,$20(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		tst.b	$2C(a0)
		bpl.s	loc_4639A
		move.b	$2A(a0),d0
		andi.w	#1,d0
		andi.b	#-2,$2A(a1)
		or.b	d0,$2A(a1)

loc_4639A:

		move.w	$10(a0),$10(a1)
		move.w	$14(a0),d0
		subi.w	#$C,d0
		move.w	d0,$14(a1)
		tst.b	$2C(a0)
		bpl.s	loc_463FC
		movem.l	d5/a1-a3,-(sp)
		jsr	(SonicOnObjHitFloor).l
		movem.l	(sp)+,d5/a1-a3
		tst.w	d1
		bpl.s	loc_463FC
		add.w	d1,$14(a1)
		cmpi.w	#-$10,d1
		bgt.s	loc_463FC
		clr.b	(a3)
		bclr	d5,$2A(a0)
		clr.b	$2E(a1)
		bclr	#3,$2A(a1)
		move.w	#$800,d0
		btst	#0,$2A(a0)
		beq.s	loc_463EC
		neg.w	d0

loc_463EC:
		move.w	d0,$18(a1)
		move.w	d0,$1C(a1)
		moveq	#-$4A,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

loc_463FC:

		move.w	(a2),d0
		andi.w	#$70,d0
		beq.s	locret_46424
		clr.b	(a3)
		move.w	#-$680,$1A(a1)
		clr.b	$2E(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		moveq	#$62,d0
		jsr	(Play_Sound_2).l

locret_46424:
		rts
; End of function sub_46324

; ---------------------------------------------------------------------------

Obj_SSZRetractingSpring:

		move.l	#loc_46452,(a0)
		bset	#2,4(a0)
		move.b	#$10,6(a0)
		move.b	#$18,7(a0)
		move.w	#$180,8(a0)
		move.w	#$3A2,$A(a0)
		move.l	#Map_SSZRetractingSpring,$C(a0)

loc_46452:
		btst	#0,($FFFFFE05).w
		beq.s	loc_464C6
		moveq	#0,d0
		move.w	$14(a0),d2
		addi.w	#$10,d2
		move.w	d2,d1
		subi.w	#$60,d1
		move.w	$10(a0),d3
		move.w	d3,d4
		subi.w	#$60,d3
		btst	#0,$2A(a0)
		beq.s	loc_46482
		addi.w	#$C0,d3
		exg	d3,d4

loc_46482:
		lea	($FFFFB000).w,a1
		jsr	sub_46514(pc)
		lea	($FFFFB04A).w,a1
		jsr	sub_46514(pc)
		move.b	$22(a0),d1
		tst.w	d0
		bne.s	loc_464AE
		tst.b	d1
		beq.s	loc_464C2
		clr.l	$2E(a0)
		subq.b	#1,d1
		cmpi.b	#3,d1
		bcs.s	loc_464C2
		moveq	#2,d1
		bra.s	loc_464C2
; ---------------------------------------------------------------------------

loc_464AE:
		cmpi.b	#3,d1
		bcc.s	loc_464C2
		tst.b	d1
		bne.s	loc_464C0
		moveq	#-$66,d0
		jsr	(Play_Sound_2).l

loc_464C0:
		addq.b	#1,d1

loc_464C2:

		move.b	d1,$22(a0)

loc_464C6:
		move.w	$10(a0),$12(a0)
		cmpi.b	#2,$22(a0)
		bcc.s	loc_464DA
		move.w	#$7FFF,$10(a0)

loc_464DA:
		moveq	#$23,d1
		moveq	#$10,d2
		lea	byte_468DC(pc),a2
		move.w	$10(a0),d4
		jsr	(sub_1DD0E).l
		move.w	$12(a0),$10(a0)
		swap	d6
		move.w	d6,-(sp)
		lea	($FFFFB000).w,a1
		lea	$2E(a0),a2
		bsr.s	sub_46536
		move.w	(sp)+,d6
		lsr.w	#1,d6
		lea	($FFFFB04A).w,a1
		lea	$30(a0),a2
		bsr.s	sub_46536
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_46514:

		tst.b	$2E(a1)
		bne.s	locret_46534
		cmp.w	$14(a1),d1
		bhi.s	locret_46534
		cmp.w	$14(a1),d2
		bcs.s	locret_46534
		cmp.w	$10(a1),d3
		bhi.s	locret_46534
		cmp.w	$10(a1),d4
		bcs.s	locret_46534
		addq.w	#1,d0

locret_46534:
		rts
; End of function sub_46514


; =============== S U B R O U T I N E =======================================


sub_46536:

		move.b	(a2),d0
		bne.s	loc_4656E
		lsr.w	#1,d6
		bcc.w	locret_465D4
		moveq	#8,d1
		move.w	$10(a1),d2
		sub.w	$10(a0),d2
		bmi.s	loc_46556
		btst	#0,$2A(a0)
		bne.s	loc_46560
		bra.s	locret_465D4
; ---------------------------------------------------------------------------

loc_46556:
		btst	#0,$2A(a0)
		bne.s	locret_465D4
		neg.w	d1

loc_46560:
		sub.w	d1,$10(a1)
		move.b	#4,$22(a0)
		addq.b	#1,(a2)
		bra.s	locret_465D4
; ---------------------------------------------------------------------------

loc_4656E:
		subq.b	#1,d0
		bne.s	loc_465B2
		move.w	#$C00,d1
		move.b	$2A(a0),d2
		andi.w	#1,d2
		eori.w	#1,d2
		beq.s	loc_46586
		neg.w	d1

loc_46586:
		move.w	d1,$1C(a1)
		move.w	d1,$18(a1)
		andi.b	#-2,$2A(a1)
		or.b	d2,$2A(a1)
		andi.b	#-2,4(a1)
		or.b	d2,4(a1)
		move.b	#3,$22(a0)
		addq.b	#1,(a2)
		moveq	#-$4F,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

loc_465B2:
		subq.b	#1,d0
		bne.s	loc_465C6
		move.b	#5,$22(a0)
		move.b	#8,1(a2)
		addq.b	#1,(a2)
		bra.s	locret_465D4
; ---------------------------------------------------------------------------

loc_465C6:
		subq.b	#1,1(a2)
		bne.s	locret_465D4
		move.b	#3,$22(a0)
		clr.w	(a2)

locret_465D4:

		rts
; End of function sub_46536


; =============== S U B R O U T I N E =======================================


Gradual_SwingOffset:

		move.l	$2E(a0),d2
		tst.b	$36(a0)
		beq.s	loc_465F6
		neg.l	d1
		add.l	d2,$32(a0)		; Moving up and then down. Reset speed/direction when center point is reached going down
		bmi.s	loc_4660E
		move.l	d0,$2E(a0)		; Reset initial speed (positive) to move downwards
		clr.l	$32(a0)
		clr.b	$36(a0)
		bra.s	loc_46612
; ---------------------------------------------------------------------------

loc_465F6:
		add.l	d2,$32(a0)		; Moving down and then up. Reset speed/direction when center point is reached going up
		bmi.s	loc_465FE
		bne.s	loc_4660E

loc_465FE:
		neg.l	d0			; Reverse direction to move upwards when speed has reached

loc_46600:
		move.l	d0,$2E(a0)	; Reset initial speed (negative)

loc_46604:
		clr.l	$32(a0)
		st	$36(a0)
		bra.s	loc_46612
; ---------------------------------------------------------------------------

loc_4660E:

		sub.l	d1,$2E(a0)	; Apply speed

loc_46612:

		move.w	$32(a0),d0	; Get final offset for us by calling object
		rts
; End of function Gradual_SwingOffset

; ---------------------------------------------------------------------------
word_46618:	dc.w  $FFF8, $FFE8,   $32,     3
		dc.w	  8, $FFE8,   $31,     4
		dc.w  $FFF8, $FFF8,   $29,     3
		dc.w	  8, $FFF8,   $2E,     4
		dc.w  $FFF8,	 8,   $22,     3
		dc.w	  8,	 8,   $19,     4
		dc.w  $FFF8,   $18,	1,     5
		dc.w	  8,   $18,    $E,     6
word_46658:	dc.w $FAFA

		dc.w $FBFB
		dc.w $FCFC
		dc.w $FDFD
		dc.w $FEFE
		dc.w $FFFF
		dc.w 0
		dc.w $101
		dc.w $202
		dc.w $303
		dc.w $404
		dc.w $505
		dc.w $606
		dc.w $707
		dc.w $808
		dc.w $909
		dc.w $A0A
		dc.w $B0B
		dc.w $C0C
		dc.w $D0D
		dc.w $E0E
		dc.w $F0F
		dc.w $1010
		dc.w $1111
		dc.w $1212
		dc.w $1313
		dc.w $1414
		dc.w $1515
		dc.w $1616
		dc.w $1717
		dc.w $1818
		dc.w $1919
byte_46698:	dc.b 0
		dc.b  $A ;
		dc.b $12 ;
		dc.b $16 ;
		dc.b $17 ;
		dc.b $16 ;
		dc.b $12 ;
byte_4669F:	dc.b $A
byte_466A0:	dc.b	0, $FF,	$FF,   0,   1,	 2,   2,   1
		dc.b	0, $FD,	$FC, $FC, $FD,	 0,   4,   6
		dc.b	6,   4,	  0, $FB, $F8, $F7, $F8, $FB
		dc.b	0,   6,	 $A,  $C,  $C,	$A,   6,   0
		dc.b  $F9, $F4,	$F1, $F0, $F1, $F4, $F9,   0
word_466C8:	dc.w $FFF4
		dc.w $FFF0
		dc.w $FD40
		dc.w $FC00
		dc.w $C
		dc.w $FFF0
		dc.w $2C0
		dc.w $FC00
		dc.w $FFF0
		dc.w $FFF4
		dc.w $FB00
		dc.w $FE00
		dc.w $10
		dc.w $FFF4
		dc.w $500
		dc.w $FE00
byte_466E8:	dc.b    9,   9,   9,   9,   9,   9,   9,   9,   9,   9,   9,   9,  $B,  $D,  $F, $11, $11, $11, $11, $11
		dc.b  $11,  $F,  $D,  $B,   9,   9,   9,   9,   9,   9,   9,   9,   9,   9,   9,   9
word_4670C:	dc.w   $408,  $40C
		dc.w   $60A,  $60C
		dc.w   $80C,  $80E
		dc.w   $A0E,  $C0E
		dc.w   $C0E,  $E0E
		dc.w   $E0E,  $E0E
		dc.w   $C0E,  $E0E
		dc.w   $A0E,  $C0E
		dc.w   $80C,  $80E
		dc.w   $60A,  $60C
word_46734:	dc.w  $FFFA,	 3,    $FFFA,	 4
		dc.w  $FFFA,	 3,    $FFFA,	 4
		dc.w  $FFFB,	 3,    $FFFB,	 4
		dc.w  $FFFC,	 3,    $FFFC,	 6
		dc.w  $FFFE,	 3,    $FFFE,	 6
		dc.w	  0,	 3,    	  0,	 6
		dc.w	  0,	 3,    	  0,	 6
		dc.w	  0,	 5,    	  0,	 6
		dc.w	  0,	 5,    0,	 6
		dc.w	  0,	 5,    0,	 6
		dc.w	  0,	 5,    0,	 6
		dc.w	  0,	 5,    0,	 8
		dc.w	  0,	 5,    0,	 8
		dc.w	  0,	 5,    0,	 8
		dc.w	  0,	 5,    0,	 8
		dc.w	  0,	 7,    0,	 8
		dc.w	  0,	 7,    0,	 8
		dc.w	  0,	 7,    0,	 8
		dc.w	  0,	 7,    0,	 8
		dc.w	  0,	 7,    0,	 8
		dc.w	  0,	 7,    0,	 8
		dc.w	  0,	 7,    0,	 8
		dc.w	  0,	 7,    0,	 8
		dc.w	  0,	 7,    0,	 8
		dc.w	  0,	 7,    0,	 8
word_467FC:	dc.w	  0,	 3,	0,     4
		dc.w	  0,	 3,	0,     4
		dc.w	  0,	 3,	0,     4
		dc.w	  0,	 3,	0,     6
		dc.w	  0,	 3,	0,     6
		dc.w	  0,	 3,	0,     6
		dc.w	  0,	 3,	0,     6
		dc.w	  0,	 5,	0,     6
		dc.w	  0,	 5,	0,     6
		dc.w	  0,	 5,	0,     6
		dc.w	  0,	 5,	0,     6
		dc.w	  0,	 5,	0,     8
		dc.w	  0,	 5,	0,     8
		dc.w	  0,	 5,	0,     8
		dc.w	  0,	 5,	0,     8
		dc.w	  0,	 7,	0,     8
		dc.w	  0,	 7,	0,     8
		dc.w	  0,	 7,	0,     8
		dc.w	  0,	 7,	0,     8
		dc.w	  0,	 7,	0,     8
		dc.w	  0,	 7,	0,     8
		dc.w	  0,	 7,	0,     8
		dc.w	  0,	 7,	0,     8
		dc.w	  0,	 7,	0,     8
		dc.w	  0,	 7,	0,     8
byte_468C4:	dc.b	1, $55
		dc.b	0, $59
		dc.b	0, $5A
		dc.b	0, $5B
		dc.b	1, $5A
		dc.b	1, $59
		dc.b	0, $55
		dc.b	0, $56
		dc.b	0, $57
		dc.b	0, $58
		dc.b	1, $57
		dc.b	1, $56
byte_468DC:	dc.b  $11, $11, $11, $11, $11, $11, $11, $11, $11, $11, $11, $11, $11, $11, $11, $11, $11, $10, $10,  $F
		dc.b   $E,  $D,  $C,  $B,   9,   7,   5,   2, $FF, $FB, $F4, $F4, $F4, $F4, $F4, $F4
Map_SSZFloatingPlatform:include "Levels\SSZ\Misc Object Data\Map - Floating Platform.asm"

Map_SSZCollapsingBridge:include "Levels\SSZ\Misc Object Data\Map - Collapsing Bridge.asm"

Map_SSZBouncyCloud:include "Levels\SSZ\Misc Object Data\Map - Bouncy Cloud.asm"

Ani_SSZBouncyCloud:	include "Levels\SSZ\Misc Object Data\Anim - Bouncy Cloud.asm"

Map_SSZElevatorBar:include "Levels\SSZ\Misc Object Data\Map - Elevator Bar.asm"

Map_SSZHPZTeleporter:include "Levels\SSZ\Misc Object Data\Map - (&HPZ) Teleporter.asm"

Map_SSZRotatingPlatform:include "Levels\SSZ\Misc Object Data\Map - Rotating Platform.asm"

Ani_SSZRotatingPlatform:	include "Levels\SSZ\Misc Object Data\Anim - Rotating Platform.asm"

Map_SSZRetractingSpring:include "Levels\SSZ\Misc Object Data\Map - Retracting Spring.asm"

; ---------------------------------------------------------------------------

Obj_TiltingBridge:

		move.w	$10(a0),d2
		move.w	d2,$44(a0)
		subi.w	#$70,d2
		moveq	#7,d1
		movea.l	a0,a1
		moveq	#1,d4
		bra.s	loc_46DBC
; ---------------------------------------------------------------------------

loc_46DB2:
		jsr	(Create_New_Sprite3).l
		bne.w	loc_46E16

loc_46DBC:
		move.l	#loc_46E4C,(a1)
		move.w	d2,$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	$44(a0),$44(a1)
		move.w	$14(a0),$46(a1)
		move.l	#Map_TiltingBridge,$C(a1)
		move.w	#$234D,$A(a1)
		ori.b	#4,4(a1)
		move.b	#$10,7(a1)
		move.b	#$10,6(a1)
		move.w	#$280,8(a1)
		bset	#7,$2A(a1)
		move.w	a0,$3E(a1)
		move.w	d4,$38(a1)
		addq.w	#1,d4
		addi.w	#$20,d2
		dbf	d1,loc_46DB2

loc_46E16:
		move.l	#loc_46E1C,(a0)

loc_46E1C:
		move.w	$34(a0),$30(a0)
		move.w	$36(a0),$32(a0)
		move.w	#0,$34(a0)
		move.w	#0,$36(a0)
		move.w	$14(a0),d0
		sub.w	$46(a0),d0
		bpl.s	loc_46E40
		neg.w	d0

loc_46E40:
		cmpi.w	#$70,d0
		bcs.s	loc_46E4C
		move.b	#1,$2E(a0)

loc_46E4C:

		movea.w	$3E(a0),a1
		move.w	$30(a1),d0
		beq.s	loc_46E68
		lsl.w	#3,d0
		add.w	$38(a0),d0
		subi.w	#9,d0
		move.b	byte_46ED8(pc,d0.w),d0
		ext.w	d0
		add.w	d0,d0

loc_46E68:
		move.w	$32(a1),d1
		beq.s	loc_46E80
		lsl.w	#3,d1
		add.w	$38(a0),d1
		subi.w	#9,d1
		move.b	byte_46ED8(pc,d1.w),d1
		ext.w	d1
		add.w	d1,d1

loc_46E80:
		add.w	d1,d0
		ext.l	d0
		add.l	d0,$3A(a0)
		move.l	$3A(a0),d0
		add.l	d0,$14(a0)
		btst	#3,$2A(a0)
		beq.s	loc_46E9E
		move.w	$38(a0),$34(a1)

loc_46E9E:
		btst	#4,$2A(a0)
		beq.s	loc_46EAC
		move.w	$38(a0),$36(a1)

loc_46EAC:
		tst.b	$2E(a1)
		beq.s	loc_46EB8
		move.l	#loc_46F18,(a0)

loc_46EB8:
		move.w	#$1B,d1
		move.w	#$10,d2
		move.w	#$11,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		move.w	$44(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------
byte_46ED8:	dc.b  $70, $50, $30, $10, $F0, $D0, $B0, $90, $54, $3C, $24,  $C, $F4, $DC, $C4, $AC, $38, $28, $18,   8
		dc.b  $F8, $E8, $D8, $C8, $1C, $14,  $C,   4, $FC, $F4, $EC, $E4, $E4, $EC, $F4, $FC,   4,  $C, $14, $1C
		dc.b  $C8, $D8, $E8, $F8,   8, $18, $28, $38, $AC, $C4, $DC, $F4,  $C, $24, $3C, $54, $90, $B0, $D0, $F0
		dc.b  $10, $30, $50, $70
; ---------------------------------------------------------------------------

loc_46F18:
		move.l	$3A(a0),d0
		asl.l	#2,d0
		move.l	d0,$3A(a0)
		move.l	#loc_46F28,(a0)

loc_46F28:
		move.l	#$1000,d0
		add.l	d0,$3A(a0)
		move.l	$3A(a0),d0
		add.l	d0,$14(a0)
		move.w	($FFFFEE1A).w,d0
		addi.w	#$110,d0
		cmp.w	$14(a0),d0
		bgt.s	loc_46F54
		move.w	#$7F00,$10(a0)
		move.w	#$7F00,$44(a0)

loc_46F54:
		move.w	#$1B,d1
		move.w	#$10,d2
		move.w	#$11,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jsr	(CheckPlayerReleaseFromObj).l
		move.w	$44(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------
Map_TiltingBridge:include "Levels\DEZ\Misc Object Data\Map - Tilting Bridge.asm"

; ---------------------------------------------------------------------------

Obj_DEZHangCarrier:

		move.l	#Map_DEZHangCarrier,$C(a0)
		move.w	#$235D,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$18,7(a0)
		move.b	#$14,6(a0)
		move.b	#$14,$1E(a0)
		move.w	#$80,8(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#2,d0
		move.w	d0,$34(a0)
		move.l	#loc_46FC2,(a0)

loc_46FC2:
		tst.b	$30(a0)
		beq.s	loc_46FCE
		move.l	#loc_46FF2,(a0)

loc_46FCE:

		lea	$30(a0),a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF602).w,d0
		bsr.w	sub_4703E
		lea	($FFFFB04A).w,a1
		addq.w	#1,a2
		move.w	($FFFFF66A).w,d0
		bsr.w	sub_4703E
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_46FF2:
		jsr	(MoveSprite2).l
		subi.w	#8,$1A(a0)
		jsr	(ObjHitCeiling).l
		tst.w	d1
		bpl.s	loc_4702A
		sub.w	d1,$14(a0)
		move.w	#0,$1A(a0)
		move.w	#$200,$18(a0)
		btst	#0,$2A(a0)
		beq.s	loc_47024
		neg.w	$18(a0)

loc_47024:
		move.l	#loc_4702C,(a0)

loc_4702A:
		bra.s	loc_46FCE
; ---------------------------------------------------------------------------

loc_4702C:
		tst.w	$34(a0)
		beq.s	loc_46FCE
		subq.w	#1,$34(a0)
		jsr	(MoveSprite2).l
		bra.s	loc_46FCE

; =============== S U B R O U T I N E =======================================


sub_4703E:

		tst.b	(a2)
		beq.w	loc_470F8
		tst.b	4(a1)
		bpl.s	loc_470C4
		cmpi.b	#4,5(a1)
		bcc.s	loc_470C4
		andi.b	#$70,d0
		beq.w	loc_470D2
		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$12,2(a2)
		andi.w	#$F00,d0
		beq.w	loc_47074
		move.b	#$3C,2(a2)

loc_47074:
		btst	#$A,d0
		beq.s	loc_47080
		move.w	#-$200,$18(a1)

loc_47080:
		btst	#$B,d0
		beq.s	loc_4708C
		move.w	#$200,$18(a1)

loc_4708C:
		move.w	#-$380,$1A(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$27(a1)
		rts
; ---------------------------------------------------------------------------

loc_470C4:

		clr.b	$2E(a1)
		clr.b	(a2)
		move.b	#$3C,2(a2)
		rts
; ---------------------------------------------------------------------------

loc_470D2:
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$28,$14(a1)
		move.b	($FFFFFE05).w,d0
		andi.b	#$F,d0
		bne.s	locret_470F6
		moveq	#-$30,d0
		jsr	(Play_Sound_2).l

locret_470F6:
		rts
; ---------------------------------------------------------------------------

loc_470F8:
		tst.b	2(a2)
		beq.s	loc_47104
		subq.b	#1,2(a2)
		rts
; ---------------------------------------------------------------------------

loc_47104:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.w	locret_4717C
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		subi.w	#$28,d1
		cmpi.w	#$18,d1
		bcc.w	locret_4717C
		tst.b	$2E(a1)
		bmi.s	locret_4717C
		cmpi.b	#4,5(a1)
		bcc.s	locret_4717C
		tst.w	($FFFFFE08).w
		bne.s	locret_4717C
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$28,$14(a1)
		move.b	#$14,$20(a1)
		bclr	#1,$2A(a1)
		move.b	#1,$2E(a1)

loc_47170:
		move.b	#1,(a2)
		moveq	#$5B,d0
		jsr	(Play_Sound_2).l

locret_4717C:

		rts
; End of function sub_4703E

; ---------------------------------------------------------------------------
Map_DEZHangCarrier:include "Levels\DEZ\Misc Object Data\Map - Hang Carrier.asm"

; ---------------------------------------------------------------------------

Obj_DEZTorpedoLauncher:

		move.l	#Map_TorpedoLauncher,$C(a0)
		move.w	#$373,$A(a0)
		ori.b	#4,4(a0)
		move.b	#8,7(a0)
		move.b	#$10,6(a0)
		move.w	#$280,8(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#2,d0
		move.w	d0,$2E(a0)
		move.w	d0,$30(a0)
		move.l	#loc_471D6,(a0)

loc_471D6:

		tst.b	4(a0)
		bpl.w	loc_47266
		subq.w	#1,$2E(a0)
		bpl.w	loc_47266
		move.w	$30(a0),$2E(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_47252
		move.l	#loc_4728A,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	4(a0),4(a1)
		move.l	$C(a0),$C(a1)
		move.w	#$2373,$A(a1)
		move.w	#$300,8(a1)
		move.b	#8,7(a1)

loc_47226:
		move.b	#8,6(a1)
		move.b	#-$65,$28(a1)
		move.b	#9,$22(a1)

loc_47238:
		move.w	#$400,$18(a1)
		btst	#0,$2A(a0)
		bne.s	loc_4724A
		neg.w	$18(a1)

loc_4724A:
		moveq	#$7C,d0
		jsr	(Play_Sound_2).l

loc_47252:
		move.l	#loc_4726C,(a0)
		move.b	#8,$22(a0)
		move.b	#$1F,$24(a0)
		bra.s	loc_4726C
; ---------------------------------------------------------------------------

loc_47266:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_4726C:

		subq.b	#1,$24(a0)
		bpl.s	loc_47284
		move.b	#7,$24(a0)
		subq.b	#1,$22(a0)
		bne.s	loc_47284
		move.l	#loc_471D6,(a0)

loc_47284:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_4728A:
		tst.b	4(a0)
		bpl.s	loc_472A2
		jsr	(MoveSprite2).l
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_472A2:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
Map_TorpedoLauncher:include "Levels\DEZ\Misc Object Data\Map - Torpedo Launcher.asm"

; ---------------------------------------------------------------------------

Obj_DEZLiftPad:

		move.l	#Map_DEZLiftPad,$C(a0)
		move.w	#$2302,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$20,7(a0)
		move.b	#$10,6(a0)
		move.w	#$280,8(a0)
		move.w	$10(a0),$44(a0)
		move.w	$14(a0),$46(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_47422
		move.l	#Draw_Sprite,(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.b	4(a0),4(a1)
		move.b	#$60,7(a1)
		move.b	#$60,6(a1)
		move.w	#$280,8(a1)
		move.w	$10(a0),d2
		move.w	d2,$10(a1)
		move.w	$14(a0),d3
		move.w	d3,$14(a1)
		bset	#6,4(a1)
		lea	$18(a1),a2
		move.b	$2C(a0),d1
		andi.w	#$F,d1
		move.w	d1,$16(a1)
		subq.w	#1,d1

loc_47406:
		move.w	d2,(a2)+
		move.w	d3,(a2)+
		move.w	#1,(a2)+
		dbf	d1,loc_47406
		move.b	#2,$1D(a1)
		move.b	#1,$22(a1)
		move.w	a1,$3E(a0)

loc_47422:
		move.w	#0,$26(a0)
		move.w	#0,$32(a0)
		move.b	#-1,$36(a0)
		andi.b	#-$10,$2C(a0)
		move.l	#loc_47440,(a0)

loc_47440:
		move.w	$10(a0),-(sp)
		bsr.w	sub_4748E
		move.w	#$18,d1
		move.w	#9,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectTop).l
		move.w	$44(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0

loc_47464:
		cmpi.w	#$280,d0
		bhi.w	loc_47472
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_47472:
		move.w	$48(a0),d0
		beq.s	loc_4747E
		movea.w	d0,a2
		bclr	#7,(a2)

loc_4747E:
		movea.w	$3E(a0),a1
		jsr	(Delete_Referenced_Sprite).l
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_4748E:
		moveq	#0,d0
		moveq	#0,d1
		bsr.w	sub_4757A
		cmp.b	$36(a0),d0
		beq.w	locret_47578
		move.b	d0,$36(a0)
		btst	#4,$2C(a0)
		beq.s	loc_474BC
		neg.w	d0
		btst	#5,$2C(a0)
		beq.s	loc_474CA
		neg.w	d0
		addi.w	#$C0,d0
		bra.s	loc_474CA
; ---------------------------------------------------------------------------

loc_474BC:
		btst	#5,$2C(a0)
		beq.s	loc_474CA
		neg.w	d0
		addi.w	#$40,d0

loc_474CA:

		addi.w	#$80,d0
		btst	#0,$2A(a0)
		beq.s	loc_474DC
		neg.w	d0
		addi.w	#$80,d0

loc_474DC:
		jsr	(GetSineCosine).l
		move.w	$46(a0),d2
		move.w	$44(a0),d3
		moveq	#0,d6
		movea.w	$3E(a0),a1
		move.w	$16(a1),d6
		subq.w	#2,d6
		bcs.w	locret_47578
		swap	d0
		swap	d1
		asr.l	#4,d0
		asr.l	#4,d1
		move.l	d0,d4
		move.l	d1,d5
		lea	$1E(a1),a2

loc_4750A:
		movem.l	d4-d5,-(sp)
		swap	d4
		swap	d5
		add.w	d2,d4
		add.w	d3,d5
		move.w	d5,(a2)+
		move.w	d4,(a2)+
		movem.l	(sp)+,d4-d5
		add.l	d0,d4
		add.l	d1,d5
		addq.w	#2,a2
		dbf	d6,loc_4750A
		movem.l	d4-d5,-(sp)
		swap	d4
		swap	d5
		add.w	d2,d4
		add.w	d3,d5
		move.w	$24(a1),d2
		move.w	$26(a1),d3
		move.w	d5,$24(a1)
		move.w	d4,$26(a1)
		move.w	d2,$10(a1)
		move.w	d3,$14(a1)
		movem.l	(sp)+,d4-d5
		add.l	d0,d4
		add.l	d1,d5
		swap	d4
		swap	d5
		add.w	$46(a0),d4
		add.w	$44(a0),d5
		move.w	d4,$14(a0)
		subi.w	#$20,d5
		btst	#0,$2A(a0)
		beq.s	loc_47574
		addi.w	#$40,d5

loc_47574:
		move.w	d5,$10(a0)

locret_47578:

		rts
; End of function sub_4748E


; =============== S U B R O U T I N E =======================================


sub_4757A:
		tst.w	$34(a0)
		beq.s	loc_47592
		btst	#3,$2A(a0)
		bne.w	loc_4760E
		subq.w	#1,$34(a0)
		bra.w	loc_4760E
; ---------------------------------------------------------------------------

loc_47592:
		tst.b	$31(a0)
		bne.s	loc_475B6
		btst	#3,$2A(a0)
		beq.s	loc_4760E
		tst.w	($FFFFFE08).w
		bne.w	loc_4760E
		move.b	#1,$31(a0)
		moveq	#-$5D,d0
		jsr	(Play_Sound_2).l

loc_475B6:
		tst.b	$30(a0)
		bne.s	loc_475E6
		move.w	$32(a0),d0
		addi.w	#8,d0
		move.w	d0,$32(a0)
		add.w	d0,$26(a0)
		tst.w	d0
		bne.s	loc_475D6
		move.b	#0,$31(a0)

loc_475D6:
		cmpi.b	#$20,$26(a0)
		bcs.s	loc_4760E
		move.b	#1,$30(a0)
		bra.s	loc_4760E
; ---------------------------------------------------------------------------

loc_475E6:
		move.w	$32(a0),d0
		subi.w	#8,d0
		move.w	d0,$32(a0)
		add.w	d0,$26(a0)
		tst.w	d0
		bne.s	loc_47600
		move.w	#$1E,$34(a0)

loc_47600:
		cmpi.b	#$20,$26(a0)
		bcc.s	loc_4760E
		move.b	#0,$30(a0)

loc_4760E:

		move.b	$26(a0),d0
		rts
; End of function sub_4757A

; ---------------------------------------------------------------------------
Map_DEZLiftPad:	include "Levels\DEZ\Misc Object Data\Map - Lift Pad.asm"

; ---------------------------------------------------------------------------

Obj_DEZStaircase:

		ori.b	#4,4(a0)
		move.b	$2C(a0),d0
		andi.w	#7,d0
		cmpi.w	#4,d0
		bcs.s	loc_47658
		bchg	#0,4(a0)

loc_47658:
		btst	#1,4(a0)
		beq.s	loc_47666
		bchg	#0,4(a0)

loc_47666:
		moveq	#$34,d3
		moveq	#2,d4
		btst	#0,$2A(a0)
		beq.s	loc_47676
		moveq	#$3A,d3
		moveq	#-2,d4

loc_47676:
		move.w	$10(a0),d2
		movea.l	a0,a1
		moveq	#3,d1
		bra.s	loc_47690
; ---------------------------------------------------------------------------

loc_47680:
		jsr	(Create_New_Sprite3).l
		bne.w	loc_476E4
		move.l	#loc_476FE,(a1)

loc_47690:
		move.l	#Map_TiltingBridge,$C(a1)
		move.w	#$2480,$A(a1)
		move.b	4(a0),4(a1)
		move.w	#$180,8(a1)
		move.b	#$10,7(a1)
		move.b	#$10,6(a1)
		move.b	$2C(a0),$2C(a1)
		move.w	d2,$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	$10(a0),$44(a1)
		move.w	$14(a1),$46(a1)
		addi.w	#$20,d2
		move.b	d3,$33(a1)
		move.w	a0,$3E(a1)
		add.b	d4,d3
		dbf	d1,loc_47680

loc_476E4:
		move.l	#loc_476EA,(a0)

loc_476EA:
		moveq	#0,d0
		move.b	$2C(a0),d0
		andi.w	#7,d0
		add.w	d0,d0
		move.w	off_4773A(pc,d0.w),d1
		jsr	off_4773A(pc,d1.w)

loc_476FE:
		movea.w	$3E(a0),a2
		moveq	#0,d0
		move.b	$33(a0),d0
		move.w	(a2,d0.w),d0
		add.w	$46(a0),d0
		move.w	d0,$14(a0)
		move.w	#$1B,d1
		move.w	#$10,d2
		move.w	#$11,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		swap	d6
		or.b	d6,$32(a2)
		move.w	$44(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------
off_4773A:	dc.w loc_4774A-off_4773A

		dc.w loc_477C2-off_4773A
		dc.w loc_47774-off_4773A
		dc.w loc_477C2-off_4773A
		dc.w loc_4774A-off_4773A
		dc.w loc_477EC-off_4773A
		dc.w loc_47774-off_4773A
		dc.w loc_477EC-off_4773A
; ---------------------------------------------------------------------------

loc_4774A:
		tst.w	$30(a0)
		bne.s	loc_47762
		move.b	$32(a0),d0
		andi.b	#$30,d0
		beq.s	locret_47760
		move.w	#$1E,$30(a0)

locret_47760:

		rts
; ---------------------------------------------------------------------------

loc_47762:
		subq.w	#1,$30(a0)
		bne.s	locret_47760
		addq.b	#1,$2C(a0)
		moveq	#-$40,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

loc_47774:
		tst.w	$30(a0)
		bne.s	loc_4778C
		move.b	$32(a0),d0
		andi.b	#$C,d0
		beq.s	locret_4778A
		move.w	#$3C,$30(a0)

locret_4778A:
		rts
; ---------------------------------------------------------------------------

loc_4778C:
		subq.w	#1,$30(a0)
		bne.s	loc_4779E
		addq.b	#1,$2C(a0)
		moveq	#-$40,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

loc_4779E:
		lea	$34(a0),a1
		move.w	$30(a0),d0
		lsr.b	#2,d0
		andi.b	#1,d0
		move.w	d0,(a1)+
		eori.b	#1,d0
		move.w	d0,(a1)+
		eori.b	#1,d0
		move.w	d0,(a1)+
		eori.b	#1,d0
		move.w	d0,(a1)+
		rts
; ---------------------------------------------------------------------------

loc_477C2:
		lea	$34(a0),a1
		cmpi.w	#$80,(a1)
		beq.s	locret_477EA
		addq.w	#1,(a1)
		moveq	#0,d1
		move.w	(a1)+,d1
		swap	d1
		lsr.l	#1,d1
		move.l	d1,d2
		lsr.l	#1,d1
		move.l	d1,d3
		add.l	d2,d3
		swap	d1
		swap	d2
		swap	d3
		move.w	d3,(a1)+
		move.w	d2,(a1)+
		move.w	d1,(a1)+

locret_477EA:
		rts
; ---------------------------------------------------------------------------

loc_477EC:
		lea	$34(a0),a1
		cmpi.w	#-$80,(a1)
		beq.s	locret_47814
		subq.w	#1,(a1)
		moveq	#0,d1
		move.w	(a1)+,d1
		swap	d1
		asr.l	#1,d1
		move.l	d1,d2
		asr.l	#1,d1
		move.l	d1,d3
		add.l	d2,d3
		swap	d1
		swap	d2
		swap	d3
		move.w	d3,(a1)+
		move.w	d2,(a1)+
		move.w	d1,(a1)+

locret_47814:
		rts
; ---------------------------------------------------------------------------

Obj_50_2:
		move.b	$2C(a0),d0
		andi.w	#$7F,d0
		lsl.w	#3,d0
		move.w	d0,$32(a0)
		add.w	d0,d0
		move.w	d0,$34(a0)
		move.w	#2,$30(a0)
		btst	#0,$2A(a0)
		beq.s	loc_4783C
		neg.w	$30(a0)

loc_4783C:
		move.l	#loc_47842,(a0)

loc_47842:
		lea	($FFFFB000).w,a1
		bsr.s	sub_47854
		lea	($FFFFB04A).w,a1
		bsr.s	sub_47854
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_47854:

		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	$32(a0),d0
		cmp.w	$34(a0),d0
		bcc.s	locret_47890
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		addi.w	#$30,d1
		cmpi.w	#$60,d1
		bcc.s	locret_47890
		btst	#1,$2A(a1)
		bne.s	locret_47890
		move.w	$30(a0),d0
		subi.w	#$30,d1
		bcs.s	loc_4788C
		neg.w	d0

loc_4788C:
		add.w	d0,$10(a1)

locret_47890:

		rts
; End of function sub_47854

; ---------------------------------------------------------------------------

Obj_DEZLightning:

		move.l	#Map_DEZLightning,$C(a0)
		move.w	#$379,$A(a0)
		ori.b	#4,4(a0)
		move.b	#8,7(a0)
		move.b	#$18,6(a0)
		move.w	#$280,8(a0)
		move.b	#-$61,$28(a0)

loc_478BE:
		tst.b	4(a0)
		bpl.s	loc_478CC
		moveq	#$79,d0
		jsr	(Play_Sound_2).l

loc_478CC:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,$30(a0)
		move.w	#1,$20(a0)
		move.l	#loc_478E2,(a0)

loc_478E2:
		lea	(Ani_DEZLightning).l,a1
		jsr	(Animate_Sprite).l
		tst.b	5(a0)
		beq.s	loc_47906
		move.b	#0,5(a0)
		move.b	#0,$22(a0)
		move.l	#loc_4791A,(a0)

loc_47906:
		cmpi.b	#3,$22(a0)
		bne.s	loc_47914
		jmp	(loc_1B662).l
; ---------------------------------------------------------------------------

loc_47914:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_4791A:
		subq.w	#1,$30(a0)
		bmi.s	loc_478BE
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
Ani_DEZLightning:	include "Levels\DEZ\Misc Object Data\Anim - Lightning.asm"

Map_DEZLightning:include "Levels\DEZ\Misc Object Data\Map - Lightning.asm"

; ---------------------------------------------------------------------------

Obj_DEZConveyorPad:

		move.l	#Map_DEZConveyorPad,$C(a0)
		move.w	#$2408,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$40,7(a0)
		move.b	#$10,6(a0)
		move.b	#$3F,$1F(a0)
		move.b	#$F,$1E(a0)
		move.w	#$280,8(a0)
		move.b	#2,$20(a0)
		move.b	$2A(a0),d0
		andi.b	#1,d0
		move.b	d0,$31(a0)
		andi.b	#-2,$2A(a0)
		move.w	#1,$34(a0)
		move.b	$2C(a0),d0
		andi.w	#$7F,d0
		beq.s	loc_479EA
		lsl.w	#3,d0
		move.w	d0,$32(a0)
		tst.b	$2C(a0)
		bpl.s	loc_479D0
		neg.w	$34(a0)

loc_479D0:
		move.l	#Map_DEZConveyorPad2,$C(a0)
		move.b	#-$80,7(a0)
		bset	#6,4(a0)
		move.w	#0,$16(a0)

loc_479EA:
		move.l	#loc_479F0,(a0)

loc_479F0:
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	loc_47A12
		move.b	$31(a0),$20(a0)
		move.l	#loc_47A14,(a0)
		tst.b	$2C(a0)
		bne.s	loc_47A12
		move.l	#loc_47AB4,(a0)

loc_47A12:

		bra.s	loc_47A58
; ---------------------------------------------------------------------------

loc_47A14:
		tst.w	$32(a0)
		beq.s	loc_47A38
		subq.w	#1,$32(a0)
		move.w	$34(a0),d0
		add.w	d0,$14(a0)
		move.b	($FFFFFE05).w,d0
		andi.b	#$F,d0
		bne.s	loc_47A38
		moveq	#-$29,d0
		jsr	(Play_Sound_2).l

loc_47A38:

		bsr.w	sub_47A88
		move.b	$2A(a0),d0
		move.b	$30(a0),d1
		move.b	d0,$30(a0)
		eor.b	d0,d1
		and.b	d0,d1
		andi.b	#$18,d1
		beq.s	loc_47A58
		bchg	#0,$20(a0)

loc_47A58:

		lea	(Ani_DEZConveyorPad).l,a1
		jsr	(Animate_Sprite).l
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_47A88:
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.s	sub_47A96
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
; End of function sub_47A88


; =============== S U B R O U T I N E =======================================


sub_47A96:
		btst	d6,$2A(a0)
		beq.s	locret_47AB2
		moveq	#2,d0
		tst.b	$20(a0)
		beq.s	loc_47AA6
		neg.w	d0

loc_47AA6:
		tst.b	($FFFFF7C6).w
		beq.s	loc_47AAE
		neg.w	d0

loc_47AAE:
		add.w	d0,$10(a1)

locret_47AB2:
		rts
; End of function sub_47A96

; ---------------------------------------------------------------------------

loc_47AB4:
		move.w	$10(a0),-(sp)
		bsr.w	sub_47B58
		moveq	#1,d0
		tst.b	$20(a0)
		beq.s	loc_47AC6
		neg.w	d0

loc_47AC6:
		add.w	d0,$10(a0)
		moveq	#-$40,d3
		jsr	(ObjHitWall2).l
		tst.w	d1
		bpl.s	loc_47AE0
		sub.w	d1,$10(a0)
		bchg	#0,$20(a0)

loc_47AE0:
		moveq	#$40,d3
		jsr	(ObjHitWall).l
		tst.w	d1
		bpl.s	loc_47AF6
		add.w	d1,$10(a0)
		bchg	#0,$20(a0)

loc_47AF6:
		move.b	$2A(a0),d0
		move.b	$30(a0),d1
		move.b	d0,$30(a0)
		eor.b	d0,d1
		and.b	d0,d1
		andi.b	#$18,d1
		beq.s	loc_47B12
		bchg	#0,$20(a0)

loc_47B12:
		move.w	(sp)+,d4
		lea	(Ani_DEZConveyorPad).l,a1
		jsr	(Animate_Sprite).l
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		jsr	(SolidObjectFull).l
		tst.b	4(a0)
		bpl.s	loc_47B52
		move.b	($FFFFFE05).w,d0
		andi.b	#$F,d0
		bne.s	loc_47B52
		moveq	#-$29,d0
		jsr	(Play_Sound_2).l

loc_47B52:

		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_47B58:
		move.w	$36(a0),d0
		bne.s	loc_47B7C
		move.w	$34(a0),d0
		add.w	d0,$14(a0)
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	locret_47B7A
		add.w	d1,$14(a0)
		move.w	#1,$36(a0)

locret_47B7A:
		rts
; ---------------------------------------------------------------------------

loc_47B7C:
		subq.w	#1,d0
		bne.s	loc_47BBA
		move.w	$10(a0),d3
		subi.w	#$30,d3
		jsr	(ObjHitFloor2).l
		move.w	d1,-(sp)
		move.w	$10(a0),d3
		addi.w	#$30,d3
		jsr	(ObjHitFloor2).l
		move.w	(sp)+,d0
		cmp.w	d0,d1
		ble.s	loc_47BA6
		move.w	d0,d1

loc_47BA6:
		cmpi.w	#$E,d1
		bgt.s	loc_47BB2
		add.w	d1,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_47BB2:
		move.w	#2,$36(a0)
		rts
; ---------------------------------------------------------------------------

loc_47BBA:
		jsr	(MoveSprite).l
		move.w	($FFFFEE1A).w,d0
		addi.w	#$120,d0
		cmp.w	$14(a0),d0
		bgt.s	loc_47BD8
		move.w	#$7F00,d4
		move.w	d4,$10(a0)
		rts
; ---------------------------------------------------------------------------

loc_47BD8:
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	locret_47BF2
		add.w	d1,$14(a0)
		move.w	#0,$1A(a0)
		move.w	#1,$36(a0)

locret_47BF2:
		rts
; End of function sub_47B58

; ---------------------------------------------------------------------------
Ani_DEZConveyorPad:	include "Levels\DEZ\Misc Object Data\Anim - Conveyor Pad.asm"

Map_DEZConveyorPad:	include "Levels\DEZ\Misc Object Data\Map - Conveyor Pad.asm"
word_47DD6:	dc.w $7F
		dc.w $FF
		dc.w $1FF
		dc.w $3FF

; =============== S U B R O U T I N E =======================================


sub_47DDE:

		move.w	#$23FF,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$300,8(a0)
		move.b	$2C(a0),d0
		move.b	d0,d1
		andi.w	#$C,d0
		lsr.w	#1,d0
		move.w	word_47DD6(pc,d0.w),d0
		move.w	d0,$32(a0)
		addq.w	#1,d0
		lsr.w	#4,d0
		andi.w	#$F0,d1
		lsr.w	#4,d1
		mulu.w	d1,d0
		move.w	d0,$30(a0)
		move.b	$2C(a0),d1
		andi.b	#3,d1
		addq.b	#2,d1
		lsl.w	#5,d1
		move.w	($FFFFFE04).w,d0
		add.w	$30(a0),d0
		and.w	$32(a0),d0
		rts
; End of function sub_47DDE

; ---------------------------------------------------------------------------

Obj_DEZEnergyBridge:

		move.l	#Map_DEZEnergyBridge,$C(a0)
		move.b	#$40,7(a0)
		move.b	#8,6(a0)
		bset	#7,$2A(a0)
		bsr.s	sub_47DDE
		sub.w	d1,d0
		bcc.s	loc_47E5C
		neg.w	d0
		move.w	d0,$34(a0)
		move.l	#loc_47E8C,(a0)
		bra.s	loc_47E8C
; ---------------------------------------------------------------------------

loc_47E5C:
		move.l	#loc_47E62,(a0)

loc_47E62:

		move.w	($FFFFFE04).w,d0
		add.w	$30(a0),d0
		and.w	$32(a0),d0
		beq.s	loc_47E76
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_47E76:
		move.b	$2C(a0),d0
		andi.b	#3,d0
		addq.b	#2,d0
		lsl.w	#5,d0
		move.w	d0,$34(a0)
		move.l	#loc_47E8C,(a0)

loc_47E8C:

		subq.w	#1,$34(a0)
		bne.s	loc_47EAA
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.s	sub_47EE8
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.s	sub_47EE8
		move.l	#loc_47E62,(a0)
		bra.s	loc_47EBE
; ---------------------------------------------------------------------------

loc_47EAA:
		moveq	#0,d1
		move.b	7(a0),d1
		move.w	#9,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l

loc_47EBE:
		move.b	($FFFFFE05).w,d0
		andi.b	#3,d0
		move.b	d0,$22(a0)
		tst.b	4(a0)
		bpl.s	loc_47EE2
		move.b	($FFFFFE05).w,d0
		andi.b	#7,d0
		bne.s	loc_47EE2
		moveq	#-$58,d0
		jsr	(Play_Sound_2).l

loc_47EE2:

		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_47EE8:

		bclr	d6,$2A(a0)
		beq.s	locret_47EFA
		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)

locret_47EFA:
		rts
; End of function sub_47EE8

; ---------------------------------------------------------------------------

Obj_56_2:
		move.l	#Map_DEZEnergyBridgeCurved,$C(a0)
		move.b	#$50,7(a0)
		move.b	#$30,6(a0)
		bsr.w	sub_47DDE
		sub.w	d1,d0
		bcc.s	loc_47F26
		neg.w	d0
		move.w	d0,$34(a0)
		move.l	#loc_47F56,(a0)
		bra.s	loc_47F56
; ---------------------------------------------------------------------------

loc_47F26:
		move.l	#loc_47F2C,(a0)

loc_47F2C:

		move.w	($FFFFFE04).w,d0
		add.w	$30(a0),d0
		and.w	$32(a0),d0
		beq.s	loc_47F40
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_47F40:
		move.b	$2C(a0),d0
		andi.b	#3,d0
		addq.b	#2,d0
		lsl.w	#5,d0
		move.w	d0,$34(a0)
		move.l	#loc_47F56,(a0)

loc_47F56:

		subq.w	#1,$34(a0)
		bne.s	loc_47F62
		move.l	#loc_47F2C,(a0)

loc_47F62:
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.s	sub_47F9C
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.s	sub_47F9C
		move.b	($FFFFFE05).w,d0
		andi.b	#3,d0
		move.b	d0,$22(a0)
		tst.b	4(a0)
		bpl.s	loc_47F96
		move.b	($FFFFFE05).w,d0
		andi.b	#7,d0
		bne.s	loc_47F96
		moveq	#-$58,d0
		jsr	(Play_Sound_2).l

loc_47F96:

		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_47F9C:

		tst.w	$34(a0)
		beq.s	loc_47FD8
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$50,d0
		cmpi.w	#$A0,d0
		bcc.s	loc_47FD8
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$30,d0
		cmpi.w	#$60,d0
		bcc.s	loc_47FD8
		bset	d6,$2A(a0)
		move.b	#$E,$46(a1)
		move.b	#$F,$47(a1)
		rts
; ---------------------------------------------------------------------------

loc_47FD8:

		bclr	d6,$2A(a0)
		beq.s	locret_47FF6
		tst.w	$34(a0)
		bne.s	loc_47FEA
		bset	#1,$2A(a1)

loc_47FEA:
		move.b	#$C,$46(a1)
		move.b	#$D,$47(a1)

locret_47FF6:
		rts
; End of function sub_47F9C

; ---------------------------------------------------------------------------
Map_DEZEnergyBridge:include "Levels\DEZ\Misc Object Data\Map - Energy Bridge.asm"

Map_DEZEnergyBridgeCurved:	include "Levels\DEZ\Misc Object Data\Map - Energy Bridge Curved.asm"

; ---------------------------------------------------------------------------

Obj_DEZRetractingSpring:

		move.l	#Map_DEZRetractingSpring,$C(a0)
		move.w	#$2332,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$280,8(a0)
		move.b	#$10,7(a0)
		move.b	#$20,6(a0)
		move.w	$10(a0),$44(a0)
		move.w	#$20,$32(a0)
		move.b	$2C(a0),d0
		andi.w	#2,d0
		move.w	word_4808A(pc,d0.w),$30(a0)
		move.l	#loc_480D4,(a0)

loc_480D4:
		move.w	($FFFFB014).w,d0
		sub.w	$14(a0),d0
		bcs.s	loc_48102

loc_480DE:
		cmpi.w	#$20,d0
		blt.s	loc_48124
		move.w	$32(a0),d1
		cmp.w	$34(a0),d1
		beq.s	loc_48124
		tst.w	$34(a0)
		bne.s	loc_480FC
		moveq	#-$66,d0
		jsr	(Play_Sound_2).l

loc_480FC:
		addq.w	#8,$34(a0)
		bra.s	loc_48124
; ---------------------------------------------------------------------------

loc_48102:
		cmpi.w	#-$20,d0
		bge.s	loc_48124
		tst.w	$34(a0)
		beq.s	loc_48124
		move.w	$32(a0),d1
		cmp.w	$34(a0),d1
		bne.s	loc_48120
		moveq	#-$66,d0
		jsr	(Play_Sound_2).l

loc_48120:
		subq.w	#8,$34(a0)

loc_48124:

		move.w	$34(a0),d0
		btst	#0,$2A(a0)
		bne.s	loc_48132
		neg.w	d0

loc_48132:
		btst	#1,$2A(a0)
		beq.s	loc_4813C
		neg.w	d0

loc_4813C:
		add.w	$44(a0),d0

loc_48140:
		move.w	d0,$10(a0)
		moveq	#0,d1
		move.b	7(a0),d1
		moveq	#9,d3
		move.w	$10(a0),d4
		lea	($FFFFB000).w,a1
		moveq	#3,d6

loc_48156:
		movem.l	d1-d4,-(sp)
		jsr	(sub_1E2BC).l
		btst	#3,$2A(a0)
		beq.s	loc_4816E
		jsr	(sub_22F98).l

loc_4816E:
		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		jsr	(sub_1E2BC).l
		btst	#4,$2A(a0)
		beq.s	loc_4818C
		jsr	(sub_22F98).l

loc_4818C:
		lea	(Ani_DEZRetractingSpring).l,a1
		jsr	(Animate_Sprite).l
		move.w	$44(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------
Ani_DEZRetractingSpring:	include "Levels\DEZ\Misc Object Data\Anim - Retracting Spring.asm"

Map_DEZRetractingSpring:include "Levels\DEZ\Misc Object Data\Map - Retracting Spring.asm"

; ---------------------------------------------------------------------------

Obj_DEZTunnelLauncher:

		move.l	#Map_DEZTunnelLauncher,$C(a0)
		move.w	#$385,$A(a0)
		ori.b	#4,4(a0)
		andi.b	#-2,4(a0)
		move.b	#$48,7(a0)
		move.b	#$50,6(a0)
		move.w	#$80,8(a0)
		bset	#6,4(a0)
		lea	$18(a0),a2
		move.w	#1,$16(a0)
		move.w	$10(a0),d2
		addi.w	#$38,d2
		btst	#0,$2A(a0)
		beq.s	loc_48242
		subi.w	#$70,d2

loc_48242:
		move.w	d2,(a2)+
		move.w	$14(a0),d3
		subi.w	#$2C,d3
		btst	#1,$2A(a0)
		beq.s	loc_4825E
		addi.w	#$58,d3
		bset	#0,4(a0)

loc_4825E:
		move.w	d3,(a2)+
		move.w	#0,(a2)+
		move.b	#0,$22(a0)
		move.l	#loc_48270,(a0)

loc_48270:

		lea	$30(a0),a4

loc_48274:
		lea	($FFFFB000).w,a1
		bsr.w	sub_48370

loc_4827C:
		lea	$38(a0),a4
		lea	($FFFFB04A).w,a1
		bsr.w	sub_48370
		tst.w	$2E(a0)
		beq.w	loc_48316
		subq.b	#1,$2E(a0)
		bne.s	loc_482F4
		move.b	#$3C,$2E(a0)
		tst.b	$2F(a0)
		beq.s	loc_482F4
		subq.b	#1,$2F(a0)
		moveq	#-$53,d0
		cmpi.b	#7,$2F(a0)
		beq.s	loc_482B2
		moveq	#-$59,d0

loc_482B2:
		jsr	(Play_Sound_2).l
		cmpi.b	#7,$2F(a0)
		bne.s	loc_482F4
		jsr	(Create_New_Sprite3).l
		bne.w	loc_482EE
		move.l	#loc_484B0,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	$2C(a0),$2C(a1)
		move.b	$30(a0),$30(a1)
		move.b	$38(a0),$38(a1)

loc_482EE:
		move.l	#loc_4831C,(a0)

loc_482F4:

		subq.b	#1,$22(a0)
		bne.s	loc_48300
		move.b	#2,$22(a0)

loc_48300:
		move.b	#0,$1D(a0)
		move.b	$2E(a0),d0
		andi.b	#1,d0
		beq.s	loc_48316

loc_48310:
		move.b	$2F(a0),$1D(a0)

loc_48316:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_4831C:
		subq.b	#1,$2E(a0)
		bne.s	loc_48348
		move.w	#0,$2E(a0)
		move.b	#0,$22(a0)
		move.b	#0,$1D(a0)
		move.b	#0,$30(a0)
		move.b	#0,$38(a0)
		move.l	#loc_48270,(a0)
		bra.s	loc_4836A
; ---------------------------------------------------------------------------

loc_48348:
		move.b	#0,$1D(a0)
		move.b	$2E(a0),d0
		andi.b	#1,d0
		beq.s	loc_4835E
		move.b	$2F(a0),$1D(a0)

loc_4835E:
		cmpi.b	#6,$22(a0)
		beq.s	loc_4836A
		addq.b	#1,$22(a0)

loc_4836A:

		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_48370:

		move.w	$10(a1),d0

loc_48374:
		sub.w	$10(a0),d0
		addq.w	#8,d0
		cmpi.w	#$10,d0
		bcc.w	locret_48422
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.w	locret_48422
		btst	#1,$2A(a1)
		bne.w	locret_48422
		tst.b	$2E(a1)
		bne.s	locret_48422
		move.w	$10(a0),$10(a1)
		move.b	$2A(a0),d0
		andi.b	#1,d0
		andi.b	#-2,$2A(a1)
		or.b	d0,$2A(a1)
		move.l	a0,-(sp)
		movea.l	a1,a0
		jsr	(Player_TouchFloor).l
		movea.l	(sp)+,a0
		move.b	#-$7F,$2E(a1)
		move.b	#9,$20(a1)
		move.b	#2,(a4)
		tst.b	$2F(a0)
		bne.s	locret_48422
		moveq	#-$5A,d0
		jsr	(Play_Sound_2).l
		cmpa.w	#-$5000,a1
		bne.s	loc_48410
		move.w	#$3C0A,$2E(a0)
		move.b	#$A,$1D(a0)
		moveq	#-$59,d0
		jsr	(Play_Sound_2).l
		tst.b	$22(a0)
		bne.s	locret_4840E
		move.b	#7,$22(a0)

locret_4840E:
		rts
; ---------------------------------------------------------------------------

loc_48410:
		move.w	#$3C00,$2E(a0)
		tst.b	$22(a0)
		bne.s	locret_48422
		move.b	#7,$22(a0)

locret_48422:

		rts
; End of function sub_48370

; ---------------------------------------------------------------------------
Map_DEZTunnelLauncher:include "Levels\DEZ\Misc Object Data\Map - Tunnel Launcher.asm"

; ---------------------------------------------------------------------------

loc_484B0:
		move.b	#$A,$31(a0)
		move.b	#$A,$39(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_484E2
		move.l	#loc_487E4,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	a1,$2E(a0)
		move.b	#2,$40(a0)

loc_484E2:
		move.l	#loc_484E8,(a0)

loc_484E8:
		lea	($FFFFB000).w,a1
		lea	$30(a0),a4
		bsr.s	sub_48518
		lea	($FFFFB04A).w,a1
		lea	$38(a0),a4
		bsr.s	sub_48518
		movea.w	$2E(a0),a1
		lea	$40(a0),a4
		bsr.s	sub_48518
		move.b	$30(a0),d0
		add.b	$38(a0),d0
		beq.s	loc_48512
		rts
; ---------------------------------------------------------------------------

loc_48512:
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_48518:

		moveq	#0,d0
		move.b	(a4),d0
		move.w	off_48524(pc,d0.w),d0
		jmp	off_48524(pc,d0.w)
; End of function sub_48518

; ---------------------------------------------------------------------------
off_48524:	dc.w locret_48532-off_48524

		dc.w loc_48534-off_48524
		dc.w loc_48592-off_48524
		dc.w loc_4865E-off_48524
		dc.w loc_4866E-off_48524
		dc.w loc_486C4-off_48524
		dc.w loc_486D0-off_48524
; ---------------------------------------------------------------------------

locret_48532:
		rts
; ---------------------------------------------------------------------------

loc_48534:
		subq.b	#1,1(a4)
		bpl.s	locret_48590
		addq.b	#2,(a4)
		move.b	#2,$20(a1)
		clr.b	$40(a1)
		move.b	#-$7F,$2E(a1)
		move.w	#$800,$1C(a1)
		move.w	#0,$18(a1)
		move.w	#0,$1A(a1)
		move.w	#0,$26(a1)
		bset	#1,$2A(a1)
		bsr.w	sub_4872C
		cmpi.l	#loc_487E4,(a1)
		beq.s	locret_48590
		cmpi.l	#loc_487F0,(a1)
		beq.s	locret_48590
		move.b	#-$6A,$22(a1)
		moveq	#0,d0
		move.b	$22(a1),d0
		jmp	(Tails_Carry_LoadPLC).l
; ---------------------------------------------------------------------------

locret_48590:

		rts
; ---------------------------------------------------------------------------

loc_48592:
		subq.b	#1,1(a4)
		bhi.w	loc_48638
		movea.l	4(a4),a2
		move.w	(a2)+,d4
		move.w	d4,$10(a1)
		move.w	(a2)+,d5
		move.w	d5,$14(a1)
		move.l	a2,4(a4)

loc_485AE:

		subq.b	#1,2(a4)
		beq.s	loc_48630
		tst.b	(a2)
		bpl.s	loc_48624
		move.b	(a2)+,d4
		andi.w	#$7F,d4
		cmpi.l	#loc_487F0,(a1)
		bne.s	loc_485D0
		moveq	#0,d0
		move.b	word_48620(pc,d4.w),d0
		move.w	d0,$30(a1)

loc_485D0:
		add.b	d4,d4
		move.w	word_48618(pc,d4.w),d2
		addq.b	#2,d4
		add.b	d4,(a4)
		move.b	(a2)+,1(a4)
		move.b	(a2)+,d0
		move.b	d0,3(a4)
		addi.b	#$20,d0
		andi.b	#-$40,d0
		jsr	(GetSineCosine).l
		muls.w	d2,d0
		muls.w	d2,d1
		asr.l	#8,d0
		asr.l	#8,d1
		add.w	$10(a1),d0
		move.w	d0,$12(a1)
		add.w	$14(a1),d1
		move.w	d1,$16(a1)
		cmpi.b	#$A,(a4)
		bcs.s	locret_48616
		move.w	$14(a1),$16(a1)

locret_48616:
		rts
; ---------------------------------------------------------------------------
word_48618:	dc.w $FF80
		dc.w $FFC0
		dc.w $FF80
		dc.w $FF80
word_48620:	dc.w $100
		dc.w $101
; ---------------------------------------------------------------------------

loc_48624:
		move.w	(a2)+,d4
		move.w	(a2)+,d5
		move.w	#$C00,d2
		bra.w	loc_48762
; ---------------------------------------------------------------------------

loc_48630:
		clr.b	$2E(a1)
		clr.b	(a4)
		rts
; ---------------------------------------------------------------------------

loc_48638:
		move.l	$10(a1),d2
		move.l	$14(a1),d3
		move.w	$18(a1),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d2
		move.w	$1A(a1),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d3
		move.l	d2,$10(a1)
		move.l	d3,$14(a1)
		rts
; ---------------------------------------------------------------------------

loc_4865E:
		move.b	3(a4),d0
		jsr	(GetSineCosine).l
		asr.w	#1,d0
		asr.w	#1,d1
		bra.s	loc_4867C
; ---------------------------------------------------------------------------

loc_4866E:
		move.b	3(a4),d0
		jsr	(GetSineCosine).l
		asr.w	#2,d0
		asr.w	#2,d1

loc_4867C:
		add.w	$12(a1),d0
		move.w	d0,d2
		sub.w	$10(a1),d2
		move.w	d0,$10(a1)
		asl.w	#8,d2
		move.w	d2,$18(a1)
		add.w	$16(a1),d1
		move.w	d1,d2
		sub.w	$14(a1),d2
		move.w	d1,$14(a1)
		asl.w	#8,d2
		move.w	d2,$1A(a1)
		movea.l	4(a4),a2
		move.w	(a2)+,d4
		move.w	(a2)+,d5
		cmp.b	3(a4),d5
		bne.s	loc_486BE
		move.b	#4,(a4)
		move.l	a2,4(a4)
		bra.w	loc_485AE
; ---------------------------------------------------------------------------

loc_486BE:
		add.b	d4,3(a4)
		rts
; ---------------------------------------------------------------------------

loc_486C4:
		addq.w	#3,$14(a1)
		move.w	#$300,$1A(a1)
		bra.s	loc_486DA
; ---------------------------------------------------------------------------

loc_486D0:
		subq.w	#3,$14(a1)
		move.w	#-$300,$1A(a1)

loc_486DA:
		move.b	#-1,$26(a1)
		move.b	3(a4),d0
		move.b	d0,$27(a1)
		jsr	(GetSineCosine).l
		asr.w	#1,d0
		asr.w	#2,d1
		add.w	$12(a1),d0
		move.w	d0,d2
		sub.w	$10(a1),d2
		move.w	d0,$10(a1)
		asl.w	#8,d2
		move.w	d2,$18(a1)
		movea.l	4(a4),a2
		move.w	(a2)+,d4
		move.w	(a2)+,d5
		cmp.b	3(a4),d5
		bne.s	loc_48726
		move.b	#4,(a4)
		move.w	#0,$26(a1)
		move.l	a2,4(a4)
		bra.w	loc_485AE
; ---------------------------------------------------------------------------

loc_48726:
		add.b	d4,3(a4)
		rts

; =============== S U B R O U T I N E =======================================


sub_4872C:
		move.b	$2C(a0),d0
		andi.w	#$1F,d0
		add.w	d0,d0
		add.w	d0,d0

Load_DEZ_Light_Tunnel_Player_Path_Data:
		lea	(DEZTunnelPaths).l,a2
		movea.l	(a2,d0.w),a2
		move.w	(a2)+,d0
		subq.b	#1,d0
		move.b	d0,2(a4)
		move.w	(a2)+,d4
		move.w	d4,$10(a1)
		move.w	(a2)+,d5
		move.w	d5,$14(a1)
		move.l	a2,4(a4)
		move.w	(a2)+,d4
		move.w	(a2)+,d5
		move.w	#$C00,d2

loc_48762:
		moveq	#0,d0
		move.w	d2,d3
		move.w	d4,d0
		sub.w	$10(a1),d0
		bge.s	loc_48772
		neg.w	d0
		neg.w	d2

loc_48772:
		moveq	#0,d1
		move.w	d5,d1
		sub.w	$14(a1),d1
		bge.s	loc_48780
		neg.w	d1
		neg.w	d3

loc_48780:
		cmp.w	d0,d1
		bcs.s	loc_487B4
		moveq	#0,d1
		move.w	d5,d1
		sub.w	$14(a1),d1
		swap	d1
		divs.w	d3,d1
		moveq	#0,d0
		move.w	d4,d0
		sub.w	$10(a1),d0
		beq.s	loc_4879E
		swap	d0
		divs.w	d1,d0

loc_4879E:
		move.w	d0,$18(a1)
		move.w	d3,$1A(a1)
		tst.w	d1
		bpl.s	loc_487AC
		neg.w	d1

loc_487AC:
		lsr.w	#8,d1
		move.b	d1,1(a4)
		rts
; ---------------------------------------------------------------------------

loc_487B4:
		moveq	#0,d0
		move.w	d4,d0
		sub.w	$10(a1),d0
		swap	d0
		divs.w	d2,d0
		moveq	#0,d1
		move.w	d5,d1
		sub.w	$14(a1),d1
		beq.s	loc_487CE
		swap	d1
		divs.w	d0,d1

loc_487CE:
		move.w	d1,$1A(a1)
		move.w	d2,$18(a1)
		tst.w	d0
		bpl.s	loc_487DC
		neg.w	d0

loc_487DC:
		lsr.w	#8,d0
		move.b	d0,1(a4)
		rts
; End of function sub_4872C

; ---------------------------------------------------------------------------

loc_487E4:

		move.w	#7,$30(a0)
		move.l	#loc_487F0,(a0)

loc_487F0:

		subq.w	#1,$30(a0)
		bpl.w	loc_48896
		move.w	#1,$30(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_4888E
		move.l	#loc_488A4,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.l	#Map_DEZTransRings,$C(a1)
		move.w	#$2385,$A(a1)
		ori.b	#4,4(a1)
		move.b	#$10,7(a1)
		move.b	#$10,6(a1)
		move.w	#$80,8(a1)
		cmpi.b	#-1,$26(a0)
		bne.s	loc_48874
		move.b	$27(a0),d1
		move.w	#0,8(a1)
		move.b	d1,d0
		add.b	d0,d0
		bpl.s	loc_48864
		bset	#0,$2A(a1)
		move.w	#$80,8(a1)

loc_48864:
		addq.b	#8,d1
		lsr.b	#4,d1
		andi.b	#7,d1
		addq.b	#8,d1
		move.b	d1,$20(a1)
		bra.s	loc_4888E
; ---------------------------------------------------------------------------

loc_48874:
		move.w	$18(a0),d1
		move.w	$1A(a0),d2
		jsr	(GetArcTan).l
		addq.b	#8,d0
		lsr.b	#4,d0
		andi.b	#7,d0
		move.b	d0,$20(a1)

loc_4888E:

		moveq	#-$36,d0
		jsr	(Play_Sound_2).l

loc_48896:
		tst.b	$2E(a0)
		beq.s	loc_4889E
		rts
; ---------------------------------------------------------------------------

loc_4889E:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_488A4:
		lea	(Ani_DEZTransRings).l,a1
		jsr	(Animate_Sprite).l
		tst.b	5(a0)
		beq.s	loc_488BC
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_488BC:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Ani_DEZTransRings:	include "Levels\DEZ\Misc Object Data\Anim - Transporter Rings.asm"

Map_DEZTransRings:	include "Levels\DEZ\Misc Object Data\Map - Transporter Rings.asm"

; ---------------------------------------------------------------------------

Obj_DEZGravitySwitch:

		move.l	#Map_DEZGravitySwitch,$C(a0)
		move.w	#$2490,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#8,6(a0)
		move.w	#$280,8(a0)
		move.l	#loc_48AD6,(a0)

loc_48AD6:

		move.w	#$1B,d1
		move.w	#8,d2
		move.w	#9,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		swap	d6
		move.w	d6,d0
		andi.w	#$14,d0
		beq.w	loc_48B3A
		move.b	#1,$22(a0)
		move.l	#loc_48B7E,(a0)
		move.w	#3,$30(a0)
		moveq	#8,d0
		btst	#1,4(a0)
		beq.s	loc_48B16
		neg.w	d0

loc_48B16:
		add.w	d0,$14(a0)
		lea	($FFFFB000).w,a1
		move.w	d6,d2
		move.w	#$14,d3
		bsr.s	sub_48B40
		lea	($FFFFB04A).w,a1
		move.w	d6,d2
		move.w	#$28,d3
		bsr.s	sub_48B40
		moveq	#$73,d0
		jsr	(Play_Sound_2).l

loc_48B3A:
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_48B40:

		tst.b	$2E(a1)
		bne.s	locret_48B7C
		moveq	#0,d1
		move.b	d1,$20(a1)
		move.b	d1,$2D(a1)
		move.b	d1,$2F(a1)
		move.b	d1,$40(a1)
		move.b	d1,$3D(a1)
		move.w	d1,$1C(a1)
		move.w	d1,$18(a1)
		move.w	d1,$1A(a1)
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		and.w	d3,d2
		beq.s	locret_48B7C
		add.w	d0,$14(a1)

locret_48B7C:

		rts
; End of function sub_48B40

; ---------------------------------------------------------------------------

loc_48B7E:
		subq.w	#1,$30(a0)
		bpl.s	loc_48B96
		move.w	#$13,$30(a0)
		eori.b	#1,($FFFFF7C6).w
		move.l	#loc_48B9C,(a0)

loc_48B96:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_48B9C:
		move.w	#$1B,d1
		move.w	#8,d2
		move.w	#9,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		btst	#3,$2A(a0)
		beq.s	loc_48BC2
		move.w	#0,$30(a0)
		bra.s	loc_48BE4
; ---------------------------------------------------------------------------

loc_48BC2:
		subq.w	#1,$30(a0)
		bpl.s	loc_48BE4
		move.b	#0,$22(a0)
		moveq	#8,d0
		btst	#1,4(a0)
		beq.s	loc_48BDA
		neg.w	d0

loc_48BDA:
		sub.w	d0,$14(a0)
		move.l	#loc_48AD6,(a0)

loc_48BE4:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
Map_DEZGravitySwitch:include "Levels\DEZ\Misc Object Data\Map - Gravity Switch.asm"

; ---------------------------------------------------------------------------

Obj_59_2:

		lea	($FFFFB000).w,a1
		lea	$30(a0),a4
		bsr.s	sub_48C30
		lea	($FFFFB04A).w,a1
		lea	$3A(a0),a4
		bsr.s	sub_48C30
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_48C30:

		moveq	#0,d0
		move.b	(a4),d0
		move.w	off_48C3C(pc,d0.w),d0
		jmp	off_48C3C(pc,d0.w)
; End of function sub_48C30

; ---------------------------------------------------------------------------
off_48C3C:	dc.w loc_48C44-off_48C3C

		dc.w loc_48D2C-off_48C3C
		dc.w loc_48DCA-off_48C3C
		dc.w loc_48E94-off_48C3C
; ---------------------------------------------------------------------------

loc_48C44:
		tst.w	($FFFFFE08).w
		bne.w	locret_48D2A
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addq.w	#3,d0
		btst	#0,$2A(a0)
		beq.s	loc_48C62
		addi.w	#$A,d0

loc_48C62:
		cmpi.w	#$10,d0
		bcc.w	locret_48D2A
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		addi.w	#$20,d1
		cmpi.w	#$40,d1
		bcc.w	locret_48D2A
		tst.b	$2E(a1)
		bne.w	locret_48D2A
		btst	#1,$2A(a1)
		bne.w	locret_48D2A
		btst	#0,($FFFFFAB8).w
		bne.w	locret_48D2A
		movea.w	$42(a1),a3
		cmpi.l	#Obj_59_2,(a3)
		bne.s	loc_48CB0
		move.w	a4,d0
		sub.w	a0,d0
		tst.b	(a3,d0.w)
		bne.s	locret_48D2A

loc_48CB0:
		move.w	a0,$42(a1)
		addq.b	#2,(a4)
		move.b	#-$7D,$2E(a1)
		move.b	#0,$20(a1)
		move.w	#0,$1C(a1)
		move.w	#0,$18(a1)
		move.w	#0,$1A(a1)
		bclr	#5,$2A(a1)
		bset	#1,$2A(a1)
		move.w	$10(a0),$10(a1)
		bclr	#2,$2A(a1)
		beq.s	loc_48D10
		move.b	$1E(a1),d0
		move.b	$44(a1),$1E(a1)
		move.b	$45(a1),$1F(a1)
		sub.b	$44(a1),d0
		ext.w	d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_48D0C
		neg.w	d0

loc_48D0C:
		add.w	d0,$14(a1)

loc_48D10:
		clr.b	1(a4)
		clr.w	2(a4)
		btst	#0,$2A(a1)
		beq.s	loc_48D26
		move.b	#6,2(a4)

loc_48D26:
		clr.w	4(a4)

locret_48D2A:

		rts
; ---------------------------------------------------------------------------

loc_48D2C:
		addq.w	#8,4(a4)
		cmpi.w	#$300,4(a4)
		bne.s	loc_48D66
		move.b	$2C(a0),d0
		andi.w	#$7F,d0
		move.w	d0,6(a4)
		lsr.w	#1,d0
		move.w	d0,8(a4)
		move.w	#$1000,d0
		btst	#1,$2A(a0)
		bne.s	loc_48D58
		neg.w	d0

loc_48D58:
		move.w	d0,$1A(a1)
		addq.b	#2,(a4)
		moveq	#-$61,d0
		jsr	(Play_Sound_2).l

loc_48D66:

		move.w	2(a4),d0
		add.w	4(a4),d0
		cmpi.w	#$C00,d0
		bcs.s	loc_48D78
		subi.w	#$C00,d0

loc_48D78:
		move.w	d0,2(a4)
		moveq	#0,d0
		move.b	2(a4),d0
		move.b	RawAni_48DB2(pc,d0.w),$22(a1)
		andi.b	#-4,4(a1)
		move.b	byte_48DBE(pc,d0.w),d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_48D9C
		ori.b	#2,d0

loc_48D9C:
		or.b	d0,4(a1)
		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2
		rts
; ---------------------------------------------------------------------------
RawAni_48DB2:	dc.b  $55, $59,	$5A, $5B, $5A, $59, $55, $56, $57, $58,	$57, $56
byte_48DBE:	dc.b	0,   1,	  1,   0,   0,	 0,   1,   1,	1,   0,	  0,   0
; ---------------------------------------------------------------------------

loc_48DCA:
		move.w	6(a4),d1
		move.w	8(a4),d2
		cmp.w	d2,d1
		bne.s	loc_48DF6
		cmpa.w	#-$5000,a1
		bne.s	loc_48DF6
		move.b	$2C(a0),d0
		rol.b	#1,d0
		andi.b	#1,d0
		cmp.b	($FFFFF7C6).w,d0
		bne.s	loc_48DF2
		move.b	#1,1(a4)

loc_48DF2:
		move.b	d0,($FFFFF7C6).w

loc_48DF6:

		move.b	#0,$34(a1)
		cmpi.w	#5,d1

loc_48E00:
		bcs.s	loc_48E10
		add.w	d2,d2
		subq.w	#5,d2
		cmp.w	d2,d1
		bcc.s	loc_48E10
		move.b	#1,$34(a1)

loc_48E10:

		subq.w	#1,6(a4)
		bmi.s	loc_48E2C
		move.l	$14(a1),d3
		move.w	$1A(a1),d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d3
		move.l	d3,$14(a1)
		bra.w	loc_48D66
; ---------------------------------------------------------------------------

loc_48E2C:
		addq.b	#2,(a4)
		clr.b	$2E(a1)
		move.w	#0,$1A(a1)
		moveq	#9,d0
		cmpi.b	#1,$38(a1)
		bne.s	loc_48E44
		moveq	#$11,d0

loc_48E44:
		tst.b	$2C(a0)
		bpl.s	loc_48E6A
		neg.w	d0
		btst	#1,$2A(a0)
		beq.s	loc_48E88
		moveq	#7,d0
		cmpi.b	#1,$38(a1)
		bne.s	loc_48E60
		subq.w	#8,d0

loc_48E60:
		tst.b	1(a4)
		beq.s	loc_48E8E
		moveq	#$10,d0
		bra.s	loc_48E8E
; ---------------------------------------------------------------------------

loc_48E6A:
		btst	#1,$2A(a0)
		bne.s	loc_48E88
		moveq	#-7,d0
		cmpi.b	#1,$38(a1)
		bne.s	loc_48E7E
		addq.w	#8,d0

loc_48E7E:
		tst.b	1(a4)
		beq.s	loc_48E8E
		moveq	#-$10,d0
		bra.s	loc_48E8E
; ---------------------------------------------------------------------------

loc_48E88:

		tst.b	1(a4)
		bne.s	locret_48E92

loc_48E8E:

		add.w	d0,$14(a1)

locret_48E92:
		rts
; ---------------------------------------------------------------------------

loc_48E94:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcs.s	locret_48EAC
		clr.w	$42(a1)
		clr.b	(a4)

locret_48EAC:
		rts
; ---------------------------------------------------------------------------

Obj_5A_2:
		move.b	$2C(a0),d0
		bpl.s	loc_48EC8
		andi.w	#$3F,d0
		lsl.w	#3,d0
		move.w	d0,$30(a0)
		move.l	#loc_4906A,(a0)
		bra.w	loc_4906A
; ---------------------------------------------------------------------------

loc_48EC8:
		andi.w	#$3F,d0
		lsl.w	#3,d0
		move.w	d0,$30(a0)
		move.w	#$20,d0
		btst	#6,$2C(a0)
		beq.s	loc_48EE2
		move.w	#$60,d0

loc_48EE2:
		move.w	d0,$32(a0)
		move.l	#loc_48EEC,(a0)

loc_48EEC:
		move.w	$30(a0),d4
		move.w	d4,d5
		add.w	d5,d5
		lea	($FFFFB000).w,a1
		lea	($FFFFF7B0).w,a2
		moveq	#3,d6
		bsr.s	sub_48F12
		lea	($FFFFB04A).w,a1
		lea	($FFFFF7B1).w,a2
		addq.b	#1,d6
		bsr.s	sub_48F12
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_48F12:

		btst	d6,$2A(a0)
		bne.w	loc_48FA4
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d4,d0
		cmp.w	d5,d0
		bcc.w	locret_48F8E
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		move.w	$32(a0),d0
		add.w	d0,d1
		add.w	d0,d0
		cmp.w	d0,d1
		bcc.w	locret_48F8E
		cmpi.b	#6,5(a1)
		bcc.s	locret_48F8E
		tst.w	($FFFFFE08).w
		bne.s	locret_48F8E
		move.w	d1,-(sp)
		jsr	(RideObject_SetRide).l
		move.w	(sp)+,d1
		lsr.w	#3,d1
		btst	#6,$2C(a0)
		beq.s	loc_48F6A
		lsr.w	#1,d1
		move.b	byte_48F98(pc,d1.w),d1
		bra.s	loc_48F6E
; ---------------------------------------------------------------------------

loc_48F6A:
		move.b	byte_48F90(pc,d1.w),d1

loc_48F6E:
		move.b	d1,(a2)
		move.b	#0,2(a2)
		move.b	#-$80,$2D(a1)
		move.w	#1,$20(a1)
		tst.w	$1C(a1)
		bne.s	locret_48F8E
		move.w	#1,$1C(a1)

locret_48F8E:

		rts
; ---------------------------------------------------------------------------
byte_48F90:	dc.b  $80, $80,	$80, $40, $40,	 0,   0,   0
byte_48F98:	dc.b  $80, $80,	$70, $60, $50, $40, $40, $30, $20, $10,	  0,   0
; ---------------------------------------------------------------------------

loc_48FA4:
		btst	#1,$2A(a1)
		bne.s	loc_48FF6
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		add.w	d4,d0
		cmp.w	d5,d0
		bcs.s	loc_48FFE

loc_48FBA:
		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		move.b	#0,$30(a1)
		move.b	#4,$31(a1)
		bset	#1,$2A(a1)
		tst.b	($FFFFF7C6).w
		beq.s	locret_48FF4
		move.b	$27(a1),d0
		addi.b	#$40,d0
		neg.b	d0
		subi.b	#$40,d0
		move.b	d0,$27(a1)
		eori.b	#2,4(a1)

locret_48FF4:
		rts
; ---------------------------------------------------------------------------

loc_48FF6:
		move.w	#0,$1A(a1)
		bra.s	loc_48FBA
; ---------------------------------------------------------------------------

loc_48FFE:
		btst	#3,$2A(a1)
		beq.s	locret_48F8E
		move.b	(a2),d0
		jsr	(GetSineCosine).l
		moveq	#8,d3
		move.w	#$1000,d0
		btst	#6,$2C(a0)
		beq.s	loc_49022
		move.w	#$5000,d0
		moveq	#4,d3

loc_49022:
		muls.w	d0,d1
		swap	d1
		move.w	$14(a0),d2
		add.w	d1,d2
		move.w	d2,$14(a1)
		move.b	(a2),d0
		move.b	d0,$27(a1)
		add.b	d3,(a2)
		tst.w	$1C(a1)
		bne.s	loc_4904A
		move.w	#1,$1C(a1)
		move.w	#1,$20(a1)

loc_4904A:
		tst.b	($FFFFF7C6).w
		beq.s	loc_49056
		eori.b	#2,4(a1)

loc_49056:
		move.b	($FFFFFE05).w,d0
		andi.b	#$F,d0
		bne.s	locret_49068
		moveq	#-$3D,d0
		jsr	(Play_Sound_2).l

locret_49068:
		rts
; End of function sub_48F12

; ---------------------------------------------------------------------------

loc_4906A:

		move.w	$30(a0),d4
		move.w	d4,d5
		add.w	d5,d5
		lea	($FFFFB000).w,a1
		lea	($FFFFF7B0).w,a2
		moveq	#3,d6
		bsr.s	sub_49090
		lea	($FFFFB04A).w,a1
		lea	($FFFFF7B1).w,a2
		addq.b	#1,d6
		bsr.s	sub_49090
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_49090:

		btst	d6,$2A(a0)
		bne.w	loc_49142
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$20,d0
		cmpi.w	#$40,d0
		bcc.w	locret_49140
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		add.w	d4,d1
		cmp.w	d5,d1
		bcc.w	locret_49140
		cmpi.b	#6,5(a1)
		bcc.w	locret_49140
		tst.w	($FFFFFE08).w
		bne.w	locret_49140
		tst.b	$2E(a1)
		bmi.s	locret_49140
		move.w	d0,-(sp)
		jsr	(sub_33C34).l
		move.w	(sp)+,d1
		move.b	#-$40,$26(a1)
		bclr	#0,4(a1)
		bclr	#0,$2A(a1)
		move.b	#0,(a2)
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		bcc.s	loc_49102
		move.b	#-$80,(a2)

loc_49102:
		move.w	$1A(a1),$1C(a1)
		neg.w	$1C(a1)
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		bcc.s	loc_49120
		move.b	#$40,$26(a1)
		neg.w	$1C(a1)

loc_49120:
		bset	#6,$2E(a1)
		bset	#1,$2E(a1)
		move.w	#1,$20(a1)
		move.b	#0,$27(a1)
		move.b	#0,2(a2)
		bra.s	loc_49142
; ---------------------------------------------------------------------------

locret_49140:

		rts
; ---------------------------------------------------------------------------

loc_49142:

		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		add.w	d4,d1
		cmp.w	d5,d1
		bcs.s	loc_4917A
		move.b	#0,$2E(a1)
		bclr	#3,$2A(a1)
		bclr	d6,$2A(a0)
		move.b	#1,$27(a1)
		move.b	#0,$30(a1)
		move.b	#4,$31(a1)
		bset	#1,$2A(a1)
		rts
; ---------------------------------------------------------------------------

loc_4917A:
		btst	#3,$2A(a1)
		beq.s	locret_49140
		bclr	#1,4(a1)
		tst.w	$1A(a1)
		bmi.s	loc_49194
		bset	#1,4(a1)

loc_49194:
		move.b	(a2),d0
		jsr	(GetSineCosine).l
		muls.w	#$1000,d1
		swap	d1
		move.w	$10(a0),d2
		add.w	d1,d2
		move.w	d2,$10(a1)
		moveq	#0,d2
		move.b	(a2),d2
		addq.b	#8,(a2)
		divu.w	#$B,d2
		move.b	RawAni_491DA(pc,d2.w),$22(a1)
		move.b	($FFFFFE05).w,d0
		andi.b	#$F,d0
		bne.s	loc_491CE
		moveq	#-$3D,d0
		jsr	(Play_Sound_2).l

loc_491CE:
		moveq	#0,d0
		move.b	$22(a1),d0
		jmp	(Tails_Carry_LoadPLC).l
; End of function sub_49090

; ---------------------------------------------------------------------------
RawAni_491DA:	dc.b  $6D, $6D, $6E, $6E, $6F, $6F, $70, $70, $71, $71, $72, $72, $73, $73, $74, $74, $75, $75, $76, $76
		dc.b  $77, $77, $6C, $6C, $6D, $6D
; ---------------------------------------------------------------------------

Obj_5B_2:
		move.w	#$20,$30(a0)
		move.w	$10(a0),d1
		lea	($FFFFB000).w,a1
		cmp.w	$10(a1),d1
		bcc.s	loc_4920E
		move.b	#1,$32(a0)

loc_4920E:
		move.l	#loc_49214,(a0)

loc_49214:
		move.w	$10(a0),d1
		lea	$32(a0),a2
		lea	($FFFFB000).w,a1
		bsr.s	sub_49228
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_49228:
		tst.b	(a2)+
		bne.w	loc_49270
		cmp.w	$10(a1),d1
		bhi.s	locret_4926E
		move.b	#1,-1(a2)
		move.w	$14(a0),d2
		move.w	d2,d3
		move.w	$30(a0),d4
		sub.w	d4,d2
		add.w	d4,d3
		move.w	$14(a1),d4
		cmp.w	d2,d4
		blt.s	locret_4926E
		cmp.w	d3,d4
		bge.s	locret_4926E
		tst.w	($FFFFFE08).w
		bne.s	locret_4926E
		move.b	#0,($FFFFF7C6).w
		btst	#0,4(a0)
		bne.s	locret_4926E
		move.b	#1,($FFFFF7C6).w

locret_4926E:

		rts
; ---------------------------------------------------------------------------

loc_49270:
		cmp.w	$10(a1),d1
		bls.s	locret_4926E
		move.b	#0,-1(a2)
		move.w	$14(a0),d2
		move.w	d2,d3
		move.w	$30(a0),d4
		sub.w	d4,d2
		add.w	d4,d3
		move.w	$14(a1),d4
		cmp.w	d2,d4
		blt.s	locret_4926E
		cmp.w	d3,d4
		bge.s	locret_4926E
		tst.w	($FFFFFE08).w
		bne.s	locret_4926E
		move.b	#0,($FFFFF7C6).w
		btst	#0,4(a0)
		beq.s	locret_4926E
		move.b	#1,($FFFFF7C6).w
		rts
; End of function sub_49228

; ---------------------------------------------------------------------------

Obj_5C_2:
		lea	$30(a0),a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF602).w,d1
		bsr.s	sub_492D4
		lea	$32(a0),a2
		lea	($FFFFB04A).w,a1
		move.w	($FFFFF66A).w,d1
		bsr.s	sub_492D4
		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_492D4:

		move.b	(a2),d0
		bne.s	loc_49348
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$20,d0
		cmpi.w	#$40,d0
		bcc.s	locret_49346
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		addi.w	#$20,d1
		cmpi.w	#$40,d1
		bcc.s	locret_49346
		btst	#3,$2A(a1)
		bne.s	locret_49346
		cmpi.b	#6,5(a1)
		bcc.s	locret_49346
		tst.w	($FFFFFE08).w
		bne.s	locret_49346
		bset	#1,$2A(a1)
		move.w	#0,$18(a1)
		move.w	#0,$1A(a1)
		move.w	#0,$1C(a1)
		move.w	#0,$26(a1)
		andi.b	#-4,4(a1)
		move.w	#1,$20(a1)
		move.b	#-$7D,$2E(a1)
		move.b	#1,(a2)

locret_49346:

		rts
; ---------------------------------------------------------------------------

loc_49348:
		cmpi.b	#7,d0
		bcc.w	loc_493F2
		moveq	#8,d1
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		bpl.s	loc_49360
		neg.w	d0
		neg.w	d1

loc_49360:
		cmpi.w	#8,d0
		bcc.s	loc_49372
		move.w	$10(a0),$10(a1)
		moveq	#0,d1
		bset	#1,(a2)

loc_49372:
		sub.w	d1,$10(a1)
		moveq	#8,d1
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		bpl.s	loc_49386
		neg.w	d0
		neg.w	d1

loc_49386:
		cmpi.w	#8,d0
		bcc.s	loc_49398
		move.w	$14(a0),$14(a1)
		moveq	#0,d1
		bset	#2,(a2)

loc_49398:
		sub.w	d1,$14(a1)

loc_4939C:

		move.b	($FFFFFE05).w,d0
		andi.b	#$F,d0
		bne.s	loc_493AE
		moveq	#-$3D,d0
		jsr	(Play_Sound_2).l

loc_493AE:
		moveq	#0,d2
		move.b	1(a2),d2
		addq.b	#1,1(a2)
		cmpi.b	#$60,1(a2)
		bcs.s	loc_493C6
		move.b	#0,1(a2)

loc_493C6:
		lsr.w	#2,d2
		move.b	RawAni_493DA(pc,d2.w),$22(a1)
		moveq	#0,d0
		move.b	$22(a1),d0
		jmp	(Tails_Carry_LoadPLC).l
; ---------------------------------------------------------------------------
RawAni_493DA:	dc.b  $34, $35, $36, $37, $38, $39, $3A, $3B, $3C, $31, $32, $33, $76, $77, $6C, $6D, $6E, $6F, $70, $71
		dc.b  $72, $73, $74, $75
; ---------------------------------------------------------------------------

loc_493F2:
		cmpi.b	#8,d0
		beq.s	loc_49430
		and.b	$2C(a0),d1
		beq.s	loc_4939C
		move.b	#8,(a2)
		lea	(loc_4941C).l,a3

loc_49408:
		addq.w	#4,a3
		lsr.b	#1,d1
		bcc.s	loc_49408
		move.w	(a3)+,$18(a1)
		move.w	(a3)+,$1A(a1)
		move.b	#0,$2E(a1)

loc_4941C:
		bra.w	loc_4939C
; ---------------------------------------------------------------------------
		dc.b 0
		dc.b 0
		dc.b $F4
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b $C
		dc.b 0
		dc.b $F4
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b $C
		dc.b 0
		dc.b 0
		dc.b 0
; ---------------------------------------------------------------------------

loc_49430:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$20,d0
		cmpi.w	#$40,d0
		bcc.s	loc_49456
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		addi.w	#$20,d1
		cmpi.w	#$40,d1
		bcs.w	loc_4939C

loc_49456:
		move.w	#0,(a2)
		rts
; End of function sub_492D4

; ---------------------------------------------------------------------------

Obj_DEZHoverMachine:

		move.l	#Map_DEZHoverMachine,$C(a0)
		move.w	#$230D,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$280,8(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_494D4
		move.l	#loc_494EA,(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.b	4(a0),4(a1)
		move.b	#$10,7(a1)
		move.b	#$10,6(a1)
		move.w	#$280,8(a1)
		move.b	#2,$22(a1)
		move.w	$10(a0),d2
		move.w	d2,$44(a1)
		addi.w	#$20,d2
		move.w	d2,$10(a1)
		move.w	$14(a0),d3
		move.w	d3,$14(a1)

loc_494D4:
		move.l	#loc_494DA,(a0)

loc_494DA:
		addq.b	#1,$22(a0)
		andi.b	#1,$22(a0)
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_494EA:
		move.w	#$200,8(a0)
		move.b	$26(a0),d0
		bpl.s	loc_494FC
		move.w	#$300,8(a0)

loc_494FC:
		addq.b	#2,$26(a0)
		jsr	(GetSineCosine).l
		asr.w	#3,d1
		add.w	$44(a0),d1
		move.w	d1,$10(a0)
		lea	($FFFFB000).w,a1
		bsr.w	sub_4952A
		lea	($FFFFB04A).w,a1
		bsr.w	sub_4952A
		move.w	$44(a0),d0
		jmp	(Sprite_OnScreen_Test2).l

; =============== S U B R O U T I N E =======================================


sub_4952A:

		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$40,d0
		cmpi.w	#$80,d0
		bcc.w	locret_495D6
		jsr	(GetSineCosine).l
		asr.w	#2,d0
		addi.w	#$20,d0
		move.w	d0,d2
		addi.w	#$20,d2
		moveq	#0,d1
		add.w	$14(a1),d1
		sub.w	$14(a0),d1
		add.w	d0,d1
		cmp.w	d2,d1
		bcc.s	locret_495D6
		cmpi.b	#4,5(a1)
		bcc.w	locret_495D6
		tst.b	$2E(a1)
		bne.s	locret_495D6
		sub.w	d0,d1
		bcs.s	loc_49578
		not.w	d1
		add.w	d1,d1

loc_49578:
		add.w	d0,d1
		neg.w	d1
		asr.w	#4,d1
		add.w	d1,$14(a1)
		bset	#1,$2A(a1)
		bclr	#4,$2A(a1)
		move.w	#0,$1A(a1)
		move.b	#0,$2F(a1)
		move.b	#0,$40(a1)
		move.w	#1,$1C(a1)
		move.b	($FFFFFE05).w,d0
		andi.b	#$F,d0
		bne.s	loc_495B8
		moveq	#-$27,d0
		jsr	(Play_Sound_2).l

loc_495B8:
		tst.b	$27(a1)
		bne.s	locret_495D6
		move.b	#1,$27(a1)
		move.b	#0,$20(a1)
		move.b	#$7F,$30(a1)
		move.b	#8,$31(a1)

locret_495D6:

		rts
; End of function sub_4952A

; ---------------------------------------------------------------------------
Map_DEZHoverMachine:include "Levels\DEZ\Misc Object Data\Map - Hover Machine.asm"

; ---------------------------------------------------------------------------

Obj_5F_2:
		lea	$30(a0),a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF602).w,d4
		bsr.s	sub_4964A
		lea	$31(a0),a2
		lea	($FFFFB04A).w,a1
		move.w	($FFFFF66A).w,d4
		bsr.s	sub_4964A
		move.w	$10(a0),d0
		addi.w	#$400,d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$680,d0
		bhi.w	loc_49638
		rts
; ---------------------------------------------------------------------------

loc_49638:
		move.w	$48(a0),d0
		beq.s	loc_49644
		movea.w	d0,a2
		bclr	#7,(a2)

loc_49644:
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_4964A:

		tst.b	(a2)
		bne.s	loc_496A8
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		cmpi.w	#$500,d0
		bcc.s	locret_496A6
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$140,d0
		cmpi.w	#$280,d0
		bcc.s	locret_496A6
		tst.w	($FFFFFE08).w
		bne.s	locret_496A6
		move.b	#1,$27(a1)
		move.b	#0,$20(a1)
		move.b	#-1,$30(a1)
		move.b	#4,$31(a1)
		bclr	#4,$2A(a1)
		clr.b	$40(a1)
		bset	#1,$2A(a1)
		move.b	#1,$2E(a1)
		move.b	#1,(a2)

locret_496A6:

		rts
; ---------------------------------------------------------------------------

loc_496A8:
		tst.w	($FFFFFE08).w
		bne.s	loc_496BC
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		cmpi.w	#$500,d0
		bcs.s	loc_496C8

loc_496BC:
		move.b	#0,$2E(a1)
		move.b	#0,(a2)
		rts
; ---------------------------------------------------------------------------

loc_496C8:
		addi.w	#$38,$18(a1)
		move.w	#$600,d6
		move.w	#$18,d5
		move.w	$1A(a1),d0
		btst	#8,d4
		beq.s	loc_496F2
		sub.w	d5,d0
		move.w	d6,d1
		neg.w	d1
		cmp.w	d1,d0
		bgt.s	loc_496F2
		add.w	d5,d0
		cmp.w	d1,d0
		ble.s	loc_496F2
		move.w	d1,d0

loc_496F2:

		btst	#9,d4
		beq.s	loc_49706
		add.w	d5,d0
		cmp.w	d6,d0
		blt.s	loc_49706
		sub.w	d5,d0
		cmp.w	d6,d0
		bge.s	loc_49706
		move.w	d6,d0

loc_49706:

		move.w	d0,$1A(a1)
		move.w	$1A(a1),d0
		move.w	d0,d1
		asr.w	#5,d1
		beq.s	loc_49730
		bmi.s	loc_49724
		sub.w	d1,d0
		bcc.s	loc_4971E
		move.w	#0,d0

loc_4971E:
		move.w	d0,$1A(a1)
		bra.s	loc_49730
; ---------------------------------------------------------------------------

loc_49724:
		sub.w	d1,d0
		bcs.s	loc_4972C
		move.w	#0,d0

loc_4972C:
		move.w	d0,$1A(a1)

loc_49730:

		movem.l	d0-a6,-(sp)
		movea.l	a1,a0
		jsr	(MoveSprite2).l
		jsr	(sub_11E8C).l
		jsr	(sub_11EEC).l
		movem.l	(sp)+,d0-a6
		bset	#1,$2A(a1)
		move.b	($FFFFFE05).w,d0
		andi.b	#$F,d0
		bne.s	locret_49764
		moveq	#-$2C,d0
		jsr	(Play_Sound_2).l

locret_49764:
		rts
; End of function sub_4964A

; ---------------------------------------------------------------------------

Obj_DEZBumperWall:

		move.l	#Map_DEZBumperWall,$C(a0)
		move.w	#$232D,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$C,7(a0)
		move.b	#$20,6(a0)
		move.w	#$280,8(a0)
		move.b	$2C(a0),d0
		beq.s	loc_497A6
		bmi.s	loc_497AE
		move.b	#8,7(a0)
		move.b	d0,6(a0)
		move.l	#loc_49804,(a0)
		bra.s	loc_49804
; ---------------------------------------------------------------------------

loc_497A6:
		move.l	#loc_497C2,(a0)
		bra.s	loc_497C2
; ---------------------------------------------------------------------------

loc_497AE:
		move.l	#loc_497B4,(a0)

loc_497B4:
		cmpi.b	#$3F,($FFFFF7C0).w
		bne.s	loc_497C2
		move.w	#$7F00,$10(a0)

loc_497C2:


		move.w	#$17,d1
		move.w	#$20,d2
		move.w	#$21,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull2).l
		swap	d6
		andi.w	#3,d6
		beq.s	loc_497FE
		move.w	d6,d0
		andi.w	#1,d0
		beq.s	loc_497F0
		lea	($FFFFB000).w,a1
		moveq	#5,d5
		bsr.s	sub_49848

loc_497F0:
		andi.w	#2,d6
		beq.s	loc_497FE
		lea	($FFFFB04A).w,a1
		moveq	#6,d5
		bsr.s	sub_49848

loc_497FE:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_49804:

		move.w	#$13,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull2).l
		swap	d6
		andi.w	#3,d6
		beq.s	loc_49842
		move.w	d6,d0
		andi.w	#1,d0
		beq.s	loc_49834
		lea	($FFFFB000).w,a1
		moveq	#5,d5
		bsr.s	sub_49848

loc_49834:
		andi.w	#2,d6
		beq.s	loc_49842
		lea	($FFFFB04A).w,a1
		moveq	#6,d5
		bsr.s	sub_49848

loc_49842:

		jmp	(Delete_Sprite_If_Not_In_Range).l

; =============== S U B R O U T I N E =======================================


sub_49848:

		moveq	#-$56,d0
		jsr	(Play_Sound_2).l

loc_49850:
		bclr	#0,$2A(a1)
		move.w	#$C00,$18(a1)
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		bcc.s	loc_49870
		bset	#0,$2A(a1)
		neg.w	$18(a1)

loc_49870:
		bclr	d5,$2A(a0)
		bset	#1,$2A(a1)
		bclr	#5,$2A(a1)
		move.b	#0,$2F(a1)
		bclr	#4,$2A(a1)
		clr.b	$40(a1)
		move.w	#1,$1C(a1)
		tst.b	$27(a1)
		bne.s	loc_498A2
		move.b	#1,$27(a1)

loc_498A2:
		move.b	#0,$20(a1)
		move.b	#-1,$30(a1)
		move.b	#4,$31(a1)
		btst	#0,$2A(a1)
		beq.s	locret_498C0
		neg.w	$1C(a1)

locret_498C0:
		rts
; End of function sub_49848

; ---------------------------------------------------------------------------
Map_DEZBumperWall:include "Levels\DEZ\Misc Object Data\Map - Bumper Wall.asm"

; ---------------------------------------------------------------------------

Obj_DEZGravityPuzzle:

		move.l	#Map_DEZGravityPuzzle,$C(a0)
		move.w	#$232D,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$20,7(a0)
		move.b	#$30,6(a0)
		move.w	#$280,8(a0)
		move.w	$14(a0),$46(a0)
		jsr	(Create_New_Sprite3).l
		bne.w	loc_49980
		move.l	#Sprite_OnScreen_Test,(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.b	4(a0),4(a1)
		move.b	#$20,7(a1)
		move.b	#$30,6(a1)
		move.w	#$200,8(a1)
		bset	#6,4(a1)
		move.w	$10(a0),d2
		move.w	d2,$10(a1)
		move.w	$14(a0),d3
		move.w	d3,$14(a1)
		move.b	($FFFFF7C0).w,d4
		lea	$18(a1),a2
		lea	byte_49A5A(pc),a3
		moveq	#6,d1
		move.w	d1,$16(a1)
		subq.w	#1,d1

loc_4995C:
		move.b	(a3)+,d0
		ext.w	d0
		add.w	d2,d0
		move.w	d0,(a2)+
		move.b	(a3)+,d0
		ext.w	d0
		add.w	d3,d0
		move.w	d0,(a2)+
		addq.w	#1,a2
		move.b	(a3)+,(a2)+
		lsr.b	#1,d4
		bcc.s	loc_49978
		subq.b	#2,-1(a2)

loc_49978:
		dbf	d1,loc_4995C
		move.w	a1,$3E(a0)

loc_49980:
		move.l	#loc_49986,(a0)

loc_49986:
		move.b	$26(a0),d0
		addq.b	#1,$26(a0)
		jsr	(GetSineCosine).l
		asr.w	#2,d0
		add.w	$46(a0),d0
		move.w	d0,$14(a0)
		movea.w	$3E(a0),a2
		lea	$1A(a2),a3
		lea	byte_49A5B(pc),a4
		moveq	#5,d1

loc_499AC:
		move.b	(a4),d2
		ext.w	d2
		add.w	d0,d2
		move.w	d2,(a3)+
		addq.w	#4,a3
		addq.w	#3,a4
		dbf	d1,loc_499AC
		move.w	#$23,d1
		move.w	#$30,d2
		move.w	#$31,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull2).l
		swap	d6
		andi.w	#3,d6
		beq.s	loc_499FC
		move.w	d6,d0
		andi.w	#1,d0
		beq.s	loc_499EC
		lea	($FFFFB000).w,a1
		bsr.s	sub_49A0E
		moveq	#5,d5
		bsr.s	sub_49A02

loc_499EC:
		andi.w	#2,d6
		beq.s	loc_499FC
		bsr.s	sub_49A0E
		lea	($FFFFB04A).w,a1
		moveq	#6,d5
		bsr.s	sub_49A02

loc_499FC:

		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_49A02:

		moveq	#$74,d0
		jsr	(Play_Sound_2).l
		bra.w	loc_49850
; End of function sub_49A02


; =============== S U B R O U T I N E =======================================


sub_49A0E:

		moveq	#0,d1
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		bcs.s	loc_49A1C
		moveq	#3,d1

loc_49A1C:
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$30,d0
		bpl.s	loc_49A2C
		moveq	#0,d0

loc_49A2C:
		cmpi.w	#$60,d0
		bcs.s	loc_49A34
		moveq	#$40,d0

loc_49A34:
		lsr.w	#5,d0
		add.w	d1,d0
		bset	d0,($FFFFF7C0).w
		movea.w	$3E(a0),a2
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		add.w	d0,d0
		addi.w	#$1D,d0
		cmpi.b	#3,(a2,d0.w)
		bcs.s	locret_49A58
		subq.b	#2,(a2,d0.w)

locret_49A58:
		rts
; End of function sub_49A0E

; ---------------------------------------------------------------------------
byte_49A5A:	dc.b $E4
byte_49A5B:	dc.b $E0
		dc.b 3
		dc.b $E4
		dc.b 0
		dc.b 3
		dc.b $E4
		dc.b $20
		dc.b 3
		dc.b $1C
		dc.b $E0
		dc.b 4
		dc.b $1C
		dc.b 0
		dc.b 4
		dc.b $1C
		dc.b $20
		dc.b 4
Map_DEZGravityPuzzle:include "Levels\DEZ\Misc Object Data\Map - Gravity Puzzle.asm"

; ---------------------------------------------------------------------------

Obj_PachinkoTriangleBumper:

		move.l	#Map_PachinkoTriangleBumper,$C(a0)
		move.w	#-$1D15,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$14,7(a0)
		move.b	#$3C,6(a0)
		move.w	#$280,8(a0)
		move.l	#loc_49ADA,(a0)

loc_49ADA:
		move.w	#$23,d1
		move.w	#$40,d2
		move.w	#$41,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull2).l
		swap	d6
		andi.w	#3,d6
		beq.s	loc_49B16
		move.w	d6,d0
		andi.w	#1,d0
		beq.s	loc_49B08
		lea	($FFFFB000).w,a1
		moveq	#5,d5
		bsr.s	sub_49B76

loc_49B08:
		andi.w	#2,d6
		beq.s	loc_49B16
		lea	($FFFFB04A).w,a1
		moveq	#6,d5
		bsr.s	sub_49B76

loc_49B16:

		lea	(Ani_PachinkoTriangleBumper).l,a1
		jsr	(Animate_Sprite).l

loc_49B22:

		move.w	$14(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFEF64).w,d0
		cmpi.w	#$200,d0
		bhi.w	loc_49B3C
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_49B3C:
		move.w	$48(a0),d0
		beq.s	loc_49B48
		movea.w	d0,a2
		bclr	#7,(a2)

loc_49B48:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_49B4E:
		move.w	$14(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFEF64).w,d0
		cmpi.w	#$200,d0
		bhi.w	loc_49B64
		rts
; ---------------------------------------------------------------------------

loc_49B64:
		move.w	$48(a0),d0
		beq.s	loc_49B70
		movea.w	d0,a2
		bclr	#7,(a2)

loc_49B70:
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_49B76:

		moveq	#-$56,d0
		jsr	(Play_Sound_2).l
		bclr	#0,$2A(a1)
		move.w	#$800,$18(a1)
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		bcc.s	loc_49B9E
		bset	#0,$2A(a1)
		neg.w	$18(a1)

loc_49B9E:
		bclr	d5,$2A(a0)
		bset	#1,$2A(a1)
		bclr	#5,$2A(a1)
		move.b	#0,$2F(a1)
		bclr	#4,$2A(a1)
		clr.b	$40(a1)
		move.w	#1,$1C(a1)
		tst.b	$27(a1)
		bne.s	loc_49BD0
		move.b	#1,$27(a1)

loc_49BD0:
		move.b	#0,$20(a1)
		move.b	#-1,$30(a1)
		move.b	#4,$31(a1)
		btst	#0,$2A(a1)
		beq.s	loc_49BEE
		neg.w	$1C(a1)

loc_49BEE:
		move.b	#1,$20(a0)
		rts
; End of function sub_49B76

; ---------------------------------------------------------------------------
Ani_PachinkoTriangleBumper:	include "Levels\Pachinko\Misc Object Data\Anim - Triangle Bumper.asm"

Map_PachinkoTriangleBumper:include "Levels\Pachinko\Misc Object Data\Map - Triangle Bumper.asm"


; ---------------------------------------------------------------------------

Obj_PachinkoFlipper:

		move.l	#Map_PachinkoFlipper,$C(a0)
		move.w	#-$7CD1,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$20,7(a0)
		move.b	#$1C,6(a0)
		move.w	#$280,8(a0)
		move.l	#loc_49C8A,(a0)

loc_49C8A:
		moveq	#0,d1
		move.b	7(a0),d1
		lea	(byte_49E5A).l,a2
		move.w	$10(a0),d4
		jsr	(SolidObjectTopSloped2).l
		lea	$36(a0),a3
		lea	($FFFFB000).w,a1
		move.w	($FFFFF602).w,d5
		moveq	#3,d6
		bsr.s	sub_49CFE
		lea	$37(a0),a3
		lea	($FFFFB04A).w,a1
		move.w	($FFFFF66A).w,d5
		moveq	#4,d6
		bsr.s	sub_49CFE
		tst.b	$38(a0)
		beq.s	loc_49CEC
		clr.b	$38(a0)
		lea	$36(a0),a3
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		bsr.w	sub_49D72
		lea	$37(a0),a3
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		bsr.w	sub_49D72
		move.b	#1,$20(a0)

loc_49CEC:
		lea	(Ani_PachinkoFlipper).l,a1
		jsr	(Animate_Sprite).l
		jmp	(loc_49B22).l

; =============== S U B R O U T I N E =======================================


sub_49CFE:

		tst.w	($FFFFFE08).w
		bne.s	loc_49D48
		move.b	(a3),d0
		bne.s	loc_49D3C
		btst	d6,$2A(a0)
		beq.s	locret_49D3A
		addq.b	#1,(a3)
		move.w	#$200,$20(a1)
		move.b	#1,$2E(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		bne.s	locret_49D3A
		addq.w	#5,$14(a1)

locret_49D3A:

		rts
; ---------------------------------------------------------------------------

loc_49D3C:
		andi.w	#$70,d5
		bne.s	loc_49D68
		btst	d6,$2A(a0)
		bne.s	loc_49D54

loc_49D48:
		move.b	#0,$2E(a1)
		move.b	#0,(a3)
		rts
; ---------------------------------------------------------------------------

loc_49D54:
		moveq	#$18,d1
		btst	#0,$2A(a0)
		beq.s	loc_49D60
		not.w	d1

loc_49D60:
		add.w	d1,$1C(a1)
		bra.w	loc_49DE4
; ---------------------------------------------------------------------------

loc_49D68:
		move.b	#1,$38(a0)
		bra.w	loc_49DE4
; End of function sub_49CFE


; =============== S U B R O U T I N E =======================================


sub_49D72:

		bclr	d6,$2A(a0)
		beq.w	locret_49D3A
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		btst	#0,$2A(a0)
		beq.s	loc_49D8C
		neg.w	d0

loc_49D8C:
		addi.w	#$20,d0
		move.w	d0,d2
		lsl.w	#5,d2
		addi.w	#$800,d2
		neg.w	d2
		asr.w	#2,d0
		addi.w	#$40,d0
		jsr	(GetSineCosine).l
		muls.w	d2,d0
		muls.w	d2,d1
		asr.l	#8,d0
		asr.l	#8,d1
		move.w	d0,$1A(a1)
		btst	#0,$2A(a0)
		beq.s	loc_49DBC
		neg.w	d1

loc_49DBC:
		move.w	d1,$18(a1)
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		move.b	#2,5(a1)
		move.b	#0,$2E(a1)
		move.b	#0,(a3)
		moveq	#-$52,d0
		jmp	(Play_Sound_2).l
; End of function sub_49D72

; ---------------------------------------------------------------------------

loc_49DE4:

		move.l	a0,-(sp)
		movea.l	a1,a0
		move.w	$1C(a0),d0
		beq.s	loc_49E0A
		bmi.s	loc_49DFE
		sub.w	d5,d0
		bcc.s	loc_49DF8
		move.w	#0,d0

loc_49DF8:
		move.w	d0,$1C(a0)
		bra.s	loc_49E0A
; ---------------------------------------------------------------------------

loc_49DFE:
		add.w	d5,d0
		bcc.s	loc_49E06
		move.w	#0,d0

loc_49E06:
		move.w	d0,$1C(a0)

loc_49E0A:

		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		muls.w	$1C(a0),d0
		asr.l	#8,d0
		move.w	d0,$1A(a0)
		muls.w	$1C(a0),d1
		asr.l	#8,d1
		move.w	d1,$18(a0)
		jsr	(MoveSprite_TestGravity2).l
		jsr	(sub_FD9A).l
		tst.w	d1
		bpl.s	loc_49E42
		sub.w	d1,$10(a0)
		move.w	#0,$1C(a0)

loc_49E42:
		jsr	(sub_FA7A).l
		tst.w	d1
		bpl.s	loc_49E56
		add.w	d1,$10(a0)
		move.w	#0,$1C(a0)

loc_49E56:
		movea.l	(sp)+,a0
		rts
; ---------------------------------------------------------------------------
byte_49E5A:	dc.b  $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FC, $FB, $FA, $F9, $F8, $F7, $F6, $F5, $F4, $F3, $F2, $F1
		dc.b  $F0, $EF, $EE, $ED, $EC, $EB, $EA, $E9, $E8, $E7, $E6, $E5

Ani_PachinkoFlipper:	include "Levels\Pachinko\Misc Object Data\Anim - Flipper.asm"

Map_PachinkoFlipper:include "Levels\Pachinko\Misc Object Data\Map - Flipper.asm"

; ---------------------------------------------------------------------------

Obj_PachinkoEnergyTrap:

		movea.l	a0,a1
		moveq	#1,d1
		bra.s	loc_49F20
; ---------------------------------------------------------------------------

loc_49EF4:
		jsr	(Create_New_Sprite3).l
		bne.w	loc_49F46
		move.l	#loc_4A07A,(a1)
		move.w	$10(a0),$10(a1)
		addi.w	#$190,$10(a1)
		move.w	$14(a0),$14(a1)
		bset	#0,4(a1)
		move.w	a0,$3E(a1)

loc_49F20:
		move.l	#Map_PachinkoEnergyTrap,$C(a1)
		move.w	#-$5CAE,$A(a1)
		ori.b	#4,4(a1)
		move.b	#8,7(a1)
		move.b	#$18,6(a1)
		move.w	#0,8(a1)

loc_49F46:
		dbf	d1,loc_49EF4
		move.b	#$3C,$24(a0)
		move.b	#-$10,$25(a0)
		move.l	#loc_49F5C,(a0)

loc_49F5C:
		move.b	($FFFFFE05).w,d0
		andi.b	#7,d0
		bne.s	loc_49F92
		jsr	(Create_New_Sprite3).l
		bne.w	loc_49F92
		move.l	#Obj_PachinkoInvisibleUnknown,(a1)
		move.w	$10(a0),$10(a1)
		addi.w	#$80,$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	$26(a0),$26(a1)
		move.w	a0,$3E(a1)

loc_49F92:

		addi.b	#8,$26(a0)
		tst.b	$2C(a0)
		bne.s	loc_49FAE
		tst.b	$25(a0)
		beq.s	loc_49FAA
		subq.b	#1,$25(a0)
		bra.s	loc_49FAE
; ---------------------------------------------------------------------------

loc_49FAA:
		subq.w	#1,$14(a0)

loc_49FAE:

		lea	($FFFFB000).w,a1
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$180,d0
		cmpi.w	#$180,d0
		bcc.s	loc_49FD6
		move.b	($FFFFFE05).w,d0
		andi.b	#$3F,d0
		bne.s	loc_49FD6
		moveq	#$73,d0
		jsr	(Play_Sound_2).l

loc_49FD6:

		bsr.s	sub_49FE4
		lea	($FFFFB04A).w,a1
		bsr.s	sub_49FE4
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_49FE4:

		move.w	$14(a1),d0
		cmpi.w	#-$20,d0
		bge.s	loc_49FFC
		cmpa.w	#-$5000,a1
		bne.s	loc_4A024
		move.b	#0,$24(a0)
		bra.s	loc_4A024
; ---------------------------------------------------------------------------

loc_49FFC:
		sub.w	$14(a0),d0
		addi.w	#$C,d0
		cmpi.w	#$18,d0
		bcc.s	locret_4A078
		tst.w	($FFFFFE08).w
		bne.s	locret_4A078
		move.w	$14(a0),$14(a1)
		tst.b	$2E(a1)
		bne.s	loc_4A024
		moveq	#-$76,d0
		jsr	(Play_Sound_2).l

loc_4A024:

		move.b	#-$7F,$2E(a1)
		bset	#1,$2A(a1)
		cmpa.w	#-$5000,a1
		bne.s	locret_4A078
		move.b	#1,$2C(a0)
		subq.b	#1,$24(a0)
		bcc.s	locret_4A078
		move.w	($FFFFFE2C).w,($FFFFFE10).w
		move.w	($FFFFFF9A).w,($FFFFEE4E).w
		move.b	($FFFFFE2B).w,($FFFFFE2A).w
		move.b	#0,($FFFFFE48).w
		move.b	#1,($FFFFFE02).w
		move.w	($FFFFFE20).w,($FFFFFE32).w
		move.b	($FFFFFE1B).w,($FFFFFE43).w
		move.b	($FFFFB02B).w,d0
		andi.b	#$71,d0
		move.b	d0,($FFFFFE47).w

locret_4A078:

		rts
; End of function sub_49FE4

; ---------------------------------------------------------------------------

loc_4A07A:
		movea.w	$3E(a0),a1
		move.w	$14(a1),$14(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Map_PachinkoEnergyTrap:include "Levels\Pachinko\Misc Object Data\Map - Energy Trap.asm"

; ---------------------------------------------------------------------------

Obj_PachinkoInvisibleUnknown:

		move.l	#Map_PachinkoInvisibleUnknown,$C(a0)
		move.w	#-$1C9C,$A(a0)
		ori.b	#4,4(a0)
		move.b	#-$78,7(a0)
		move.b	#8,6(a0)
		move.w	#$80,8(a0)
		move.l	#loc_4A0C6,(a0)

loc_4A0C6:
		movea.w	$3E(a0),a1
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#4,d0
		add.w	$14(a1),d0
		move.w	d0,$14(a0)
		moveq	#0,d0
		move.b	$26(a0),d0
		addi.b	#$10,d0
		lsr.w	#5,d0
		move.b	RawAni_4A110(pc,d0.w),$22(a0)
		addi.b	#-$7C,$26(a0)
		addi.w	#2,$10(a0)
		cmpi.w	#$178,$10(a0)
		bls.s	loc_4A10A
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_4A10A:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
RawAni_4A110:	dc.b	0,   1,	  2,   3,   4,	 3,   2,   1
Map_PachinkoInvisibleUnknown:include "Levels\Pachinko\Misc Object Data\Map - Invisible Unknown.asm"


; ---------------------------------------------------------------------------

Obj_Pachinko_Platform:

		move.l	#Map_PachinkoPlatform,$C(a0)
		move.w	#$2358,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$20,7(a0)
		move.b	#$C,6(a0)
		move.w	#$280,8(a0)
		move.l	#loc_4A1B2,(a0)

loc_4A1B2:
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		jmp	(loc_49B22).l
; ---------------------------------------------------------------------------
Map_PachinkoPlatform:include "Levels\Pachinko\Misc Object Data\Map - Platform.asm"

; ---------------------------------------------------------------------------

Obj_PachinkoItemOrb:

		move.l	#Map_PachinkoItemOrb,$C(a0)
		move.w	#-$1C9C,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$200,8(a0)
		move.b	#-$29,$28(a0)
		move.l	#loc_4A218,(a0)

loc_4A218:
		tst.b	$29(a0)
		beq.s	loc_4A228
		clr.b	$29(a0)
		move.l	#loc_4A238,(a0)

loc_4A228:
		lea	(Ani_PachinkoItemOrb).l,a1
		jsr	(Animate_Sprite).l
		bra.w	loc_4A31A
; ---------------------------------------------------------------------------

loc_4A238:
		tst.b	$29(a0)
		bne.s	loc_4A274
		clr.b	$22(a0)
		moveq	#$65,d0
		jsr	(Play_Sound_2).l
		move.b	$14(a0),d1
		andi.w	#$F,d1
		lsl.w	#2,d1
		move.w	($FFFFFE04).w,d0
		andi.w	#3,d0
		add.w	d1,d0
		lea	(byte_1E4484).l,a1
		move.b	(a1,d0.w),$2C(a0)
		move.l	#loc_4A34C,(a0)
		bra.w	loc_4A2CC
; ---------------------------------------------------------------------------

loc_4A274:
		clr.b	$29(a0)
		lea	(Ani_PachinkoItemOrb).l,a1
		jsr	(Animate_Sprite).l
		bra.w	loc_4A31A
; ---------------------------------------------------------------------------
Ani_PachinkoItemOrb:	include "Levels\Pachinko\Misc Object Data\Anim - Item Orb.asm"

Map_PachinkoItemOrb:include "Levels\Pachinko\Misc Object Data\Map - Item Orb.asm"

; ---------------------------------------------------------------------------

Obj_GumballItem:

		move.l	#loc_4A312,(a0)

loc_4A2CC:
		move.l	#Map_PachinkoFItem,$C(a0)
		move.w	#$6378,$A(a0)
		move.b	$2C(a0),d0
		beq.s	loc_4A2F4
		move.l	#Map_GumballBonus,$C(a0)
		move.w	#$388,$A(a0)
		addq.b	#7,d0
		move.b	d0,$22(a0)

loc_4A2F4:
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$200,8(a0)
		move.b	#-$29,$28(a0)

loc_4A312:
		tst.b	$29(a0)
		beq.s	loc_4A31A
		bsr.s	sub_4A362

loc_4A31A:

		move.w	$14(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFEF64).w,d0
		cmpi.w	#$200,d0
		bhi.w	loc_4A33A
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_4A33A:
		move.w	$48(a0),d0
		beq.s	loc_4A346
		movea.w	d0,a2
		bclr	#7,(a2)

loc_4A346:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_4A34C:
		tst.b	$29(a0)
		beq.s	loc_4A354
		bsr.s	sub_4A362

loc_4A354:
		jsr	(MoveSprite2).l
		subi.w	#4,$1A(a0)
		bra.s	loc_4A31A

; =============== S U B R O U T I N E =======================================


sub_4A362:

		lea	($FFFFB000).w,a1
		bclr	#0,$29(a0)
		beq.s	loc_4A370
		bsr.s	sub_4A384

loc_4A370:
		lea	($FFFFB04A).w,a1
		bclr	#1,$29(a0)
		beq.s	loc_4A37E
		bsr.s	sub_4A384

loc_4A37E:
		clr.b	$29(a0)
		rts
; End of function sub_4A362


; =============== S U B R O U T I N E =======================================


sub_4A384:

		move.l	#Delete_Current_Sprite,(a0)
		moveq	#0,d1
		moveq	#1,d2
		move.b	$2C(a0),d1
		cmpi.b	#3,d1
		beq.s	loc_4A3B6
		cmpi.b	#2,d1
		beq.s	loc_4A3AC
		subq.w	#1,d1
		bcs.s	loc_4A3AC
		moveq	#0,d0
		move.w	a1,d0
		jmp	(loc_61100).l
; ---------------------------------------------------------------------------

loc_4A3AC:

		moveq	#$7B,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_4A3B6:
		move.b	$14(a0),d0
		andi.w	#$F,d0
		lea	(byte_1E44C4).l,a1
		move.b	(a1,d0.w),d0
		add.w	d0,($FFFFFE32).w
		jmp	(AddRings).l
; End of function sub_4A384

; ---------------------------------------------------------------------------
Map_PachinkoFItem:include "Levels\Pachinko\Misc Object Data\Map - F Item.asm"

; ---------------------------------------------------------------------------

Obj_EC_1:
		move.l	#Map_PachinkoFItem,$C(a0)
		move.w	#$6378,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	#$280,8(a0)
		move.l	#loc_4A408,(a0)

loc_4A408:
		lea	$30(a0),a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF602).w,d1
		bsr.s	sub_4A428
		addq.w	#1,a2
		lea	($FFFFB04A).w,a1
		move.w	($FFFFF66A).w,d1
		bsr.s	sub_4A428
		jmp	(loc_49B4E).l

; =============== S U B R O U T I N E =======================================


sub_4A428:

		tst.b	(a2)
		beq.w	loc_4A53A
		tst.w	($FFFFFE08).w
		bne.w	loc_4A4F0
		cmpi.b	#4,5(a1)
		bcc.w	loc_4A4F0
		tst.b	$2E(a1)
		bmi.w	loc_4A4F6
		andi.b	#$70,d1
		bne.w	loc_4A4B4
		btst	#$A,d1
		beq.s	loc_4A45A
		subq.b	#1,6(a2)

loc_4A45A:
		btst	#$B,d1
		beq.s	loc_4A464
		addq.b	#1,6(a2)

loc_4A464:
		move.w	$10(a1),d1
		move.w	$14(a1),d2
		movem.l	d1-d2,-(sp)
		bsr.w	sub_4A5E0
		movem.l	(sp)+,d1-d2
		sub.w	$10(a1),d1
		asl.w	#8,d1
		neg.w	d1
		move.w	d1,$18(a1)
		sub.w	$14(a1),d2
		asl.w	#8,d2
		neg.w	d2
		move.w	d2,$1A(a1)
		move.b	($FFFFFE05).w,d0
		andi.b	#$F,d0
		bne.s	locret_4A4A2
		moveq	#-$3A,d0
		jsr	(Play_Sound_2).l

locret_4A4A2:
		rts
; ---------------------------------------------------------------------------
byte_4A4A4:	dc.b  $20, $20,	$20, $30, $40, $50, $60, $60, $60, $A0,	$A0, $B0, $C0, $D0, $E0, $E0
; ---------------------------------------------------------------------------

loc_4A4B4:
		moveq	#0,d1
		move.b	4(a2),d0
		move.b	d0,d1
		lsr.w	#4,d1
		move.b	byte_4A4A4(pc,d1.w),d1
		andi.b	#$F,d0
		or.b	d1,d0
		jsr	(GetSineCosine).l
		muls.w	#$C,d0
		move.w	d0,d2
		move.b	6(a2),d0
		jsr	(GetSineCosine).l
		muls.w	d2,d0
		muls.w	d2,d1
		asr.l	#8,d0
		asr.l	#8,d1
		move.w	d0,$18(a1)
		neg.w	d1
		move.w	d1,$1A(a1)

loc_4A4F0:

		andi.b	#-4,$2E(a1)

loc_4A4F6:
		clr.b	(a2)
		move.b	#$1E,2(a2)
		move.w	#$100,8(a1)
		bset	#1,$2A(a1)
		clr.b	$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		bclr	#4,$2A(a1)
		move.b	#0,$27(a1)
		move.b	#0,$2F(a1)
		rts
; ---------------------------------------------------------------------------

loc_4A53A:
		tst.b	2(a2)
		beq.s	loc_4A54E
		subq.b	#1,2(a2)
		bne.s	locret_4A54C
		move.w	#$100,8(a1)

locret_4A54C:
		rts
; ---------------------------------------------------------------------------

loc_4A54E:
		move.w	$10(a1),d1
		sub.w	$10(a0),d1
		addi.w	#$38,d1
		cmpi.w	#$70,d1
		bcc.w	locret_4A5DE
		move.w	$14(a1),d2
		sub.w	$14(a0),d2
		addi.w	#$38,d2
		cmpi.w	#$70,d2
		bcc.w	locret_4A5DE
		tst.w	($FFFFFE08).w
		bne.w	locret_4A5DE
		cmpi.b	#4,5(a1)
		bcc.w	locret_4A5DE
		tst.b	$2E(a1)
		bne.w	locret_4A5DE
		subi.w	#$38,d1
		subi.w	#$38,d2
		jsr	(GetArcTan).l
		moveq	#0,d1
		tst.b	d0
		bpl.s	loc_4A5AA
		moveq	#-$80,d1
		addi.b	#-$80,d0

loc_4A5AA:
		move.b	d1,4(a2)
		subi.b	#$40,d0
		move.b	d0,6(a2)
		clr.w	$18(a1)
		clr.w	$1A(a1)
		move.w	#$800,$1C(a1)
		andi.b	#-3,4(a1)
		move.b	#2,$20(a1)
		move.b	#1,$2E(a1)
		move.b	#1,(a2)
		bsr.w	sub_4A5E0

locret_4A5DE:

		rts
; End of function sub_4A428


; =============== S U B R O U T I N E =======================================


sub_4A5E0:

		moveq	#0,d0
		move.b	4(a2),d0
		jsr	(GetSineCosine).l
		muls.w	#$3800,d1
		swap	d1
		moveq	#0,d2
		move.w	d1,d3
		moveq	#0,d0
		move.b	6(a2),d0
		jsr	(GetSineCosine).l
		move.w	d3,d5
		muls.w	d0,d5
		muls.w	d1,d3
		asr.l	#8,d3
		sub.l	d5,d2
		asr.l	#8,d2
		add.w	$10(a0),d2
		add.w	$14(a0),d3
		move.w	d2,$10(a1)
		move.w	d3,$14(a1)
		move.w	#$100,8(a1)
		ori.w	#-$8000,$A(a1)
		move.b	4(a2),d0
		bpl.s	loc_4A63C
		move.w	#$280,8(a1)
		andi.w	#$7FFF,$A(a1)

loc_4A63C:
		addq.b	#4,d0
		move.b	d0,4(a2)
		rts
; End of function sub_4A5E0

; ---------------------------------------------------------------------------

Obj_LRZChainedPlatforms:

		move.b	$2C(a0),d0
		bmi.w	loc_4A6F4
		move.l	#Map_LRZChainedPlatforms,$C(a0)
		move.w	#$240D,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$18,7(a0)
		move.b	#$18,6(a0)
		move.w	#$200,8(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,d1
		lsr.w	#3,d0
		andi.w	#$1E,d0
		lea	off_4A890(pc),a2
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,$3C(a0)
		move.l	a2,$40(a0)
		andi.w	#$F,d1
		lsl.w	#2,d1
		move.b	d1,$3C(a0)
		move.b	#4,$3E(a0)
		btst	#0,$2A(a0)
		beq.s	loc_4A6CE
		neg.b	$3E(a0)
		moveq	#0,d1
		move.b	$3C(a0),d1
		add.b	$3E(a0),d1
		cmp.b	$3D(a0),d1
		bcs.s	loc_4A6CA
		move.b	d1,d0
		moveq	#0,d1
		tst.b	d0
		bpl.s	loc_4A6CA
		move.b	$3D(a0),d1
		subq.b	#4,d1

loc_4A6CA:

		move.b	d1,$3C(a0)

loc_4A6CE:
		move.w	(a2,d1.w),d0
		add.w	$34(a0),d0
		move.w	d0,$38(a0)
		move.w	2(a2,d1.w),d0
		add.w	$36(a0),d0
		move.w	d0,$3A(a0)
		bsr.w	sub_4A818
		move.l	#loc_4A74A,(a0)
		bra.w	loc_4A74A
; ---------------------------------------------------------------------------

loc_4A6F4:
		andi.w	#$7F,d0
		add.w	d0,d0
		lea	(off_4A914).l,a2
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d1
		movea.l	a0,a1
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		bra.s	loc_4A71A
; ---------------------------------------------------------------------------

loc_4A712:
		jsr	(Create_New_Sprite).l
		bne.s	loc_4A744

loc_4A71A:
		move.l	#Obj_LRZChainedPlatforms,(a1)
		move.w	(a2)+,d0
		add.w	d2,d0
		move.w	d0,$10(a1)
		move.w	(a2)+,d0
		add.w	d3,d0
		move.w	d0,$14(a1)
		move.w	d2,$34(a1)
		move.w	d3,$36(a1)
		move.w	(a2)+,d0
		move.b	d0,$2C(a1)
		move.b	$2A(a0),$2A(a1)

loc_4A744:
		dbf	d1,loc_4A712
		rts
; ---------------------------------------------------------------------------

loc_4A74A:

		move.w	$10(a0),-(sp)
		bsr.w	sub_4A7BA
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectFull).l
		swap	d6
		andi.w	#$C,d6
		beq.s	loc_4A798
		move.b	d6,d0
		andi.b	#4,d0
		beq.s	loc_4A788
		lea	($FFFFB000).w,a1
		jsr	(sub_24280).l

loc_4A788:
		andi.b	#8,d6
		beq.s	loc_4A798
		lea	($FFFFB04A).w,a1
		jsr	(sub_24280).l

loc_4A798:

		tst.b	4(a0)
		bpl.s	loc_4A7B0
		move.b	($FFFFFE05).w,d0
		andi.b	#$F,d0
		bne.s	loc_4A7B0
		moveq	#-$6C,d0
		jsr	(Play_Sound_2).l

loc_4A7B0:

		move.w	$34(a0),d0
		jmp	(Sprite_OnScreen_Test2).l

; =============== S U B R O U T I N E =======================================


sub_4A7BA:
		move.w	$10(a0),d0
		cmp.w	$38(a0),d0
		bne.s	loc_4A810
		move.w	$14(a0),d0
		cmp.w	$3A(a0),d0
		bne.s	loc_4A810
		moveq	#0,d1
		move.b	$3C(a0),d1
		add.b	$3E(a0),d1
		cmp.b	$3D(a0),d1
		bcs.s	loc_4A7EC
		move.b	d1,d0
		moveq	#0,d1
		tst.b	d0
		bpl.s	loc_4A7EC
		move.b	$3D(a0),d1
		subq.b	#4,d1

loc_4A7EC:

		move.b	d1,$3C(a0)
		movea.l	$40(a0),a1
		move.w	(a1,d1.w),d0
		add.w	$34(a0),d0
		move.w	d0,$38(a0)
		move.w	2(a1,d1.w),d0
		add.w	$36(a0),d0
		move.w	d0,$3A(a0)
		bsr.w	sub_4A818

loc_4A810:

		jsr	(MoveSprite2).l
		rts
; End of function sub_4A7BA


; =============== S U B R O U T I N E =======================================


sub_4A818:

		moveq	#0,d0
		move.w	#-$100,d2
		move.w	$10(a0),d0
		sub.w	$38(a0),d0
		bcc.s	loc_4A82C
		neg.w	d0
		neg.w	d2

loc_4A82C:
		moveq	#0,d1
		move.w	#-$100,d3
		move.w	$14(a0),d1
		sub.w	$3A(a0),d1
		bcc.s	loc_4A840
		neg.w	d1
		neg.w	d3

loc_4A840:
		cmp.w	d0,d1
		bcs.s	loc_4A86A
		move.w	$10(a0),d0
		sub.w	$38(a0),d0
		beq.s	loc_4A856
		ext.l	d0
		asl.l	#8,d0
		divs.w	d1,d0
		neg.w	d0

loc_4A856:
		move.w	d0,$18(a0)
		move.w	d3,$1A(a0)
		swap	d0
		move.w	d0,$12(a0)
		clr.w	$16(a0)
		rts
; ---------------------------------------------------------------------------

loc_4A86A:
		move.w	$14(a0),d1
		sub.w	$3A(a0),d1
		beq.s	loc_4A87C
		ext.l	d1
		asl.l	#8,d1
		divs.w	d0,d1
		neg.w	d1

loc_4A87C:
		move.w	d1,$1A(a0)
		move.w	d2,$18(a0)
		swap	d1
		move.w	d1,$16(a0)
		clr.w	$12(a0)
		rts
; End of function sub_4A818

; ---------------------------------------------------------------------------
off_4A890:	dc.w word_4A896-off_4A890

		dc.w word_4A8C0-off_4A890
		dc.w word_4A8EA-off_4A890
word_4A896:	dc.w	$28,	 0,	0, $FFEA,    $A, $FFE0,	  $20, $FFE0,	$C0, $FFEA,   $D6,     0,   $E0,   $16,	  $D6,	 $20

		dc.w	$C0,   $20,   $20,   $16,    $A
word_4A8C0:	dc.w	$28,	 0,	0, $FFEA,    $A, $FFE0,	  $20, $FFE0,  $140, $FFEA,  $156,     0,  $160,   $16,	 $156,	 $20

		dc.w   $140,   $20,   $20,   $16,    $A
word_4A8EA:	dc.w	$28,	 0,	0, $FFEA,    $A, $FFE0,	  $20, $FFE0,  $1C0, $FFEA,  $1D6,     0,  $1E0,   $16,	 $1D6,	 $20

		dc.w   $1C0,   $20,   $20,   $16,    $A
off_4A914:	dc.w word_4A91A-off_4A914

		dc.w word_4A934-off_4A914
		dc.w word_4A94E-off_4A914
word_4A91A:	dc.w	  3,	 0,	0,     1, $FFE0,   $70,	    3,	   0,	$E0,	 6,   $20,   $70,     8

word_4A934:	dc.w	  3,	 0,	0,   $11, $FFE0,   $B0,	  $13,	   0,  $160,   $16,   $20,   $B0,   $18

word_4A94E:	dc.w	  7,	 0,	0,   $21, $FFE0,   $72,	  $23, $FFE0,	$F0,   $23, $FFE0,  $16E,   $23,     0,	 $1E0,	 $26

		dc.w	$20,  $16E,   $28,   $20,   $F0,   $28,	  $20,	 $72,	$28
Map_LRZChainedPlatforms:include "Levels\LRZ\Misc Object Data\Map - Chained Platforms.asm"

; ---------------------------------------------------------------------------

Obj_SOZRapelWire:

		movea.l	a0,a1
		move.l	#loc_4AA80,(a1)
		bsr.w	sub_4AA46
		move.b	#$20,$22(a1)
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		move.w	d2,$3E(a0)
		move.w	d3,$40(a0)
		move.b	$2C(a0),d1
		andi.b	#$F,d1
		move.b	d1,$36(a0)
		move.w	#$30,$32(a0)
		moveq	#$F,d1
		addq.w	#1,d1
		jsr	(Create_New_Sprite3).l
		bne.w	loc_4AA44
		move.w	a1,$44(a0)
		move.l	#loc_4AD7A,(a1)
		move.w	a0,$42(a1)
		bra.s	loc_4AA16
; ---------------------------------------------------------------------------

loc_4A9FA:
		jsr	(Create_New_Sprite3).l
		bne.w	loc_4AA44
		move.l	#loc_4AE50,(a1)
		move.w	a2,$42(a1)
		move.w	a1,$44(a2)
		move.w	a0,$46(a1)

loc_4AA16:
		movea.l	a1,a2
		bsr.s	sub_4AA46
		move.w	d2,$10(a1)
		move.w	d3,$14(a1)
		addi.w	#$10,d3
		addq.w	#1,$34(a0)
		move.w	$34(a0),$34(a1)
		dbf	d1,loc_4A9FA
		move.l	#loc_4AF0A,(a1)
		move.b	#$21,$22(a1)
		move.w	a1,$46(a0)

loc_4AA44:

		bra.s	loc_4AA80

; =============== S U B R O U T I N E =======================================


sub_4AA46:

		move.b	#4,4(a1)
		move.b	#$10,7(a1)
		move.b	#$10,6(a1)
		move.w	#$280,8(a1)
		move.l	#Map_SOZRapelWire,$C(a1)
		move.w	#$4411,$A(a1)
		move.b	$2A(a0),$2A(a1)
		move.w	$10(a0),$3E(a1)
		move.w	$14(a0),$40(a1)
		rts
; End of function sub_4AA46

; ---------------------------------------------------------------------------

loc_4AA80:

		movea.w	$46(a0),a1
		tst.b	$38(a1)
		beq.s	loc_4AA90
		move.l	#loc_4AA94,(a0)

loc_4AA90:
		bra.w	loc_4AD32
; ---------------------------------------------------------------------------

loc_4AA94:
		movea.w	$46(a0),a1
		tst.b	$38(a1)
		bne.s	loc_4AAA4
		move.l	#loc_4ACC6,(a0)

loc_4AAA4:
		addq.w	#2,$32(a0)
		cmpi.w	#$C0,$32(a0)
		bne.s	loc_4AAC4
		moveq	#$4C,d0
		jsr	(Play_Sound_2).l
		move.l	#loc_4AAC8,(a0)
		move.w	#1,$2E(a0)

loc_4AAC4:
		bra.w	loc_4AD32
; ---------------------------------------------------------------------------

loc_4AAC8:

		movea.w	$46(a0),a1
		tst.b	$38(a1)
		bne.s	loc_4AAD8
		move.l	#loc_4ACC6,(a0)

loc_4AAD8:
		move.b	($FFFFF603).w,d0
		andi.w	#$70,d0
		beq.w	loc_4AB6A
		moveq	#$62,d0
		jsr	(Play_Sound_2).l
		move.b	$2C(a0),d1
		andi.w	#$F0,d1
		bne.s	loc_4AB16
		move.l	#loc_4AB6E,(a0)
		move.w	#$3F,$30(a0)
		move.b	#0,$26(a0)
		subq.b	#1,$36(a0)
		bne.s	loc_4AB6A
		move.l	#loc_4AB9E,(a0)
		bra.s	loc_4AB6A
; ---------------------------------------------------------------------------

loc_4AB16:
		lsl.w	#1,d1
		subi.w	#6,d1
		subq.w	#1,d1
		move.w	d1,$30(a0)
		move.l	#loc_4ABD8,(a0)
		move.b	#-$80,$26(a0)
		move.b	#-$80,$37(a0)
		move.w	#$400,$18(a0)
		btst	#0,$2A(a0)
		bne.s	loc_4AB4C
		neg.w	$18(a0)
		move.b	#0,$37(a0)

loc_4AB4C:
		bchg	#0,$2A(a0)
		move.w	#3,$2E(a0)
		move.w	#6,$3C(a0)
		subq.b	#1,$36(a0)
		bne.s	loc_4AB6A
		move.l	#loc_4AC3A,(a0)

loc_4AB6A:

		bra.w	loc_4AD32
; ---------------------------------------------------------------------------

loc_4AB6E:
		movea.w	$46(a0),a1
		tst.b	$38(a1)
		bne.s	loc_4AB7E
		move.l	#loc_4ACC6,(a0)

loc_4AB7E:
		addq.b	#2,$26(a0)
		addq.w	#2,$32(a0)
		subq.w	#1,$30(a0)
		bpl.s	loc_4AB9A
		moveq	#$4C,d0
		jsr	(Play_Sound_2).l
		move.l	#loc_4AAC8,(a0)

loc_4AB9A:
		bra.w	loc_4AD32
; ---------------------------------------------------------------------------

loc_4AB9E:
		move.w	#2,$2E(a0)
		move.l	#loc_4ABAA,(a0)

loc_4ABAA:
		movea.w	$46(a0),a1
		tst.b	$38(a1)
		bne.s	loc_4ABBA
		move.l	#loc_4ACC6,(a0)

loc_4ABBA:
		addq.b	#2,$26(a0)
		addq.w	#2,$32(a0)
		subq.w	#1,$30(a0)
		bpl.s	loc_4ABD4
		move.b	$26(a0),$27(a0)
		move.l	#loc_4AC98,(a0)

loc_4ABD4:
		bra.w	loc_4AD32
; ---------------------------------------------------------------------------

loc_4ABD8:
		jsr	(MoveSprite2).l
		movea.w	$46(a0),a1
		tst.b	$38(a1)
		bne.s	loc_4ABEE
		move.l	#loc_4ACC6,(a0)

loc_4ABEE:
		cmpi.w	#$1A,$30(a0)
		bcs.s	loc_4AC02
		bne.s	loc_4ABFE
		move.w	#1,$2E(a0)

loc_4ABFE:
		addq.b	#4,$37(a0)

loc_4AC02:
		addq.b	#2,$26(a0)
		addq.w	#1,$32(a0)
		subq.w	#1,$30(a0)
		bpl.s	loc_4AC24
		move.w	#0,$18(a0)
		moveq	#$4C,d0
		jsr	(Play_Sound_2).l
		move.l	#loc_4AAC8,(a0)

loc_4AC24:
		tst.w	$3C(a0)
		beq.s	loc_4AC36
		subq.w	#1,$3C(a0)
		addq.w	#1,$32(a0)
		addq.b	#2,$26(a0)

loc_4AC36:
		bra.w	loc_4AD32
; ---------------------------------------------------------------------------

loc_4AC3A:
		jsr	(MoveSprite2).l
		movea.w	$46(a0),a1
		tst.b	$38(a1)
		bne.s	loc_4AC50
		move.l	#loc_4ACC6,(a0)

loc_4AC50:
		cmpi.w	#$1A,$30(a0)
		bcs.s	loc_4AC5C
		addq.b	#4,$37(a0)

loc_4AC5C:
		addq.b	#2,$26(a0)
		addq.w	#1,$32(a0)
		subq.w	#1,$30(a0)
		bpl.s	loc_4AC82
		move.w	#0,$18(a0)
		move.w	#2,$2E(a0)
		move.b	$26(a0),$27(a0)
		move.l	#loc_4AC98,(a0)

loc_4AC82:
		tst.w	$3C(a0)
		beq.s	loc_4AC94
		subq.w	#1,$3C(a0)
		addq.w	#1,$32(a0)
		addq.b	#2,$26(a0)

loc_4AC94:
		bra.w	loc_4AD32
; ---------------------------------------------------------------------------

loc_4AC98:

		movea.w	$46(a0),a1
		tst.b	$38(a1)
		bne.s	loc_4ACA8
		move.l	#loc_4ACC6,(a0)

loc_4ACA8:
		addq.b	#2,$27(a0)
		cmpi.b	#-4,$27(a0)
		bcc.s	loc_4ACBC
		cmpi.b	#-$7A,$27(a0)
		bcc.s	loc_4ACC2

loc_4ACBC:
		move.b	$27(a0),$26(a0)

loc_4ACC2:
		bra.w	loc_4AD32
; ---------------------------------------------------------------------------

loc_4ACC6:

		tst.b	$26(a0)
		beq.s	loc_4AD02
		cmpi.b	#-$7A,$27(a0)
		bcc.s	loc_4ACF6
		addq.b	#2,$26(a0)
		cmpi.b	#-$80,$26(a0)
		bcs.s	loc_4ACEE
		cmpi.b	#-4,$26(a0)
		bcc.s	loc_4ACEE
		move.b	#0,$26(a0)

loc_4ACEE:

		move.b	#0,$27(a0)
		bra.s	loc_4AD02
; ---------------------------------------------------------------------------

loc_4ACF6:
		move.b	#-4,$26(a0)
		addq.b	#2,$27(a0)
		bmi.s	loc_4AD32

loc_4AD02:

		subq.w	#4,$32(a0)
		cmpi.w	#$30,$32(a0)
		bhi.s	loc_4AD32
		move.w	#$30,$32(a0)
		move.w	#0,$2E(a0)
		move.b	$2C(a0),d1
		andi.b	#$F,d1
		move.b	d1,$36(a0)
		move.l	#loc_4AA80,(a0)
		move.w	$3E(a0),d0
		bra.s	loc_4AD36
; ---------------------------------------------------------------------------

loc_4AD32:

		move.w	$10(a0),d0

loc_4AD36:
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_4AD4C
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_4AD4C:
		move.w	$34(a0),d2
		subq.w	#1,d2
		bcs.s	loc_4AD68
		movea.w	$44(a0),a2

loc_4AD58:
		movea.l	a2,a1
		movea.w	$44(a1),a2
		jsr	(Delete_Referenced_Sprite).l
		dbf	d2,loc_4AD58

loc_4AD68:
		move.w	$48(a0),d0
		beq.s	loc_4AD74
		movea.w	d0,a2
		bclr	#7,(a2)

loc_4AD74:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_4AD7A:
		movea.w	$42(a0),a1
		move.w	$26(a1),$26(a0)
		move.w	$32(a1),$32(a0)
		move.b	$26(a0),d0
		btst	#0,$2A(a1)
		bne.s	loc_4AD9A
		addi.b	#-$80,d0

loc_4AD9A:
		jsr	(sub_A230).l
		muls.w	#$20,d0
		move.w	$32(a0),d2
		divs.w	d2,d0
		move.w	d0,$18(a0)
		move.w	d0,d1
		asr.w	#4,d1
		jsr	(GetArcTan).l
		jsr	(sub_A230).l
		asr.w	#2,d0
		move.w	d0,$1A(a0)
		moveq	#0,d0
		moveq	#0,d1
		move.w	d2,d4
		move.w	d2,d5
		neg.w	d5
		andi.w	#$F,d5
		move.w	$18(a0),d2
		ext.l	d2
		lsl.l	#4,d2
		move.w	$1A(a0),d3
		ext.l	d3
		lsl.l	#4,d3
		subq.w	#1,d5
		bcs.s	loc_4ADF2
		addi.w	#$10,d4

loc_4ADEA:
		sub.l	d2,d0
		sub.l	d3,d1
		dbf	d5,loc_4ADEA

loc_4ADF2:
		lsl.l	#4,d2
		lsl.l	#4,d3
		lsr.w	#4,d4
		subi.w	#$10,d4
		bcc.s	loc_4AE04
		neg.w	d4
		neg.l	d2
		neg.l	d3

loc_4AE04:
		subq.w	#1,d4
		bcs.s	loc_4AE10

loc_4AE08:
		add.l	d2,d0
		add.l	d3,d1
		dbf	d4,loc_4AE08

loc_4AE10:
		add.l	$10(a1),d0
		move.l	d0,$10(a0)
		add.l	$14(a1),d1
		move.l	d1,$14(a0)
		move.w	$18(a0),d1
		move.w	$1A(a0),d2
		jsr	(GetArcTan).l
		addi.b	#-$40,d0
		addq.b	#4,d0
		lsr.b	#3,d0
		move.b	d0,$22(a0)
		move.w	$14(a0),d0
		addi.w	#$10,d0
		cmp.w	$40(a0),d0
		ble.s	locret_4AE4E
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_4AE4E:
		rts
; ---------------------------------------------------------------------------

loc_4AE50:
		movea.w	$42(a0),a1
		move.b	$22(a1),$22(a0)
		bsr.w	sub_4AEE0
		cmpi.w	#$D,$34(a0)
		bne.s	loc_4AE7C
		movea.w	$46(a0),a2
		cmpi.w	#2,$2E(a2)
		bne.s	loc_4AE7C
		cmpi.b	#-$7A,$27(a2)
		bcs.s	loc_4AE7C
		bsr.s	sub_4AE92

loc_4AE7C:

		move.w	$14(a0),d0
		addi.w	#$10,d0
		cmp.w	$40(a0),d0
		ble.s	locret_4AE90
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_4AE90:
		rts

; =============== S U B R O U T I N E =======================================


sub_4AE92:
		move.b	$27(a2),d0
		btst	#0,$2A(a2)
		beq.s	loc_4AEA2
		addi.b	#-$80,d0

loc_4AEA2:
		jsr	(GetSineCosine).l
		muls.w	#$3C,d0
		asr.w	#8,d0
		addi.w	#$40,d0
		jsr	(sub_A230).l
		asr.w	#2,d1
		move.w	d1,$18(a0)
		asr.w	#2,d0
		move.w	d0,$1A(a0)
		move.w	$18(a0),d1
		move.w	$1A(a0),d2
		jsr	(GetArcTan).l
		addi.b	#-$40,d0
		addq.b	#4,d0
		lsr.b	#3,d0
		move.b	d0,$22(a0)
		rts
; End of function sub_4AE92


; =============== S U B R O U T I N E =======================================


sub_4AEE0:

		move.w	$18(a1),d0
		move.w	d0,$18(a0)
		ext.l	d0
		lsl.l	#8,d0
		add.l	$10(a1),d0
		move.l	d0,$10(a0)
		move.w	$1A(a1),d1
		move.w	d1,$1A(a0)
		ext.l	d1
		lsl.l	#8,d1
		add.l	$14(a1),d1
		move.l	d1,$14(a0)
		rts
; End of function sub_4AEE0

; ---------------------------------------------------------------------------

loc_4AF0A:
		move.w	$10(a0),d4
		move.w	$14(a0),d5
		movea.w	$42(a0),a1
		bsr.w	sub_4AEE0
		cmp.w	$10(a0),d4
		beq.s	loc_4AF24
		move.w	d4,$3E(a0)

loc_4AF24:
		cmp.w	$14(a0),d5
		beq.s	loc_4AF2E
		move.w	d5,$40(a0)

loc_4AF2E:
		movea.w	$46(a0),a3
		lea	$38(a0),a2
		lea	($FFFFB000).w,a1
		move.w	($FFFFF602).w,d0
		bsr.s	sub_4AF80
		lea	($FFFFB04A).w,a1
		addq.w	#1,a2
		move.w	($FFFFF66A).w,d0
		bsr.s	sub_4AF80
		move.b	#$21,$22(a0)
		cmpi.w	#3,$2E(a3)
		bne.s	loc_4AF6A
		moveq	#0,d0
		move.b	$37(a3),d0
		addq.b	#4,d0
		lsr.w	#4,d0
		move.b	RawAni_4AF70(pc,d0.w),$22(a0)

loc_4AF6A:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
RawAni_4AF70:	dc.b  $24, $25,	$26, $26, $21, $22, $22, $23, $24, $25,	$26, $26, $21, $22, $22, $23

; =============== S U B R O U T I N E =======================================


sub_4AF80:

		tst.b	(a2)
		beq.w	loc_4B130
		bmi.w	loc_4B02A
		tst.b	4(a1)
		bpl.w	loc_4B03C
		cmpi.b	#4,5(a1)
		bcc.w	loc_4B03C
		tst.w	($FFFFFE08).w
		bne.w	loc_4B03C
		cmpi.w	#2,$2E(a3)
		bne.w	loc_4B04A
		andi.b	#$70,d0
		beq.w	loc_4B04A
		clr.b	$2E(a1)
		clr.b	(a2)
		move.w	$10(a0),d1
		sub.w	$3E(a0),d1
		asl.w	#8,d1
		move.w	d1,$18(a1)
		move.w	$14(a0),d1
		sub.w	$40(a0),d1
		asl.w	#8,d1
		move.w	d1,$1A(a1)
		move.b	#$3C,2(a2)
		btst	#$A,d0
		beq.s	loc_4AFEA
		move.w	#-$200,$18(a1)

loc_4AFEA:
		btst	#$B,d0
		beq.s	loc_4AFF6
		move.w	#$200,$18(a1)

loc_4AFF6:
		addi.w	#-$380,$1A(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		moveq	#$62,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_4B02A:
		move.w	#$300,$18(a1)
		move.w	#$200,$1A(a1)

loc_4B036:
		bset	#1,$2A(a1)

loc_4B03C:

		clr.b	$2E(a1)
		clr.b	(a2)

loc_4B042:
		move.b	#$3C,2(a2)
		rts
; ---------------------------------------------------------------------------

loc_4B04A:

		move.w	$10(a0),$10(a1)

loc_4B050:
		move.w	$14(a0),$14(a1)
		addi.w	#$14,$14(a1)
		move.w	$2E(a3),d0
		bne.s	loc_4B070
		move.b	#$14,$20(a1)
		move.b	#-$6E,$22(a1)
		bra.s	loc_4B08E
; ---------------------------------------------------------------------------

loc_4B070:
		cmpi.w	#1,d0
		bne.s	loc_4B0B0
		move.b	#$14,$20(a1)
		moveq	#0,d0
		move.b	$26(a3),d0
		add.b	d0,d0
		addq.b	#8,d0
		lsr.w	#4,d0
		move.b	RawAni_4B0A0(pc,d0.w),$22(a1)

loc_4B08E:

		moveq	#0,d0
		move.b	$22(a1),d0
		move.l	a2,-(sp)
		jsr	(Tails_Carry_LoadPLC).l
		movea.l	(sp)+,a2
		rts
; ---------------------------------------------------------------------------
RawAni_4B0A0:	dc.b  $93, $92,	$92, $92, $91, $91, $90, $90, $90, $90,	$90, $91, $91, $92, $92, $92
; ---------------------------------------------------------------------------

loc_4B0B0:
		cmpi.w	#2,d0
		bne.s	loc_4B0DE
		move.b	#$14,$20(a1)
		moveq	#0,d0
		move.b	$26(a3),d0
		addq.b	#8,d0
		lsr.w	#4,d0

loc_4B0C6:
		move.b	RawAni_4B0CE(pc,d0.w),$22(a1)
		bra.s	loc_4B08E
; ---------------------------------------------------------------------------
RawAni_4B0CE:
		dc.b  $90, $90,	$90, $90, $90, $90, $90, $90, $91, $92,	$92, $92, $92, $92, $92, $91
; ---------------------------------------------------------------------------

loc_4B0DE:
		move.b	#0,$20(a1)
		moveq	#0,d0
		move.b	$37(a3),d0
		addq.b	#4,d0
		lsr.w	#4,d0

loc_4B0EE:
		move.b	RawAni_4B110(pc,d0.w),$22(a1)
		move.b	byte_4B120(pc,d0.w),d0
		andi.b	#-4,4(a1)
		or.b	d0,4(a1)
		andi.b	#-4,$2A(a1)

loc_4B108:
		or.b	d0,$2A(a1)
		bra.w	loc_4B08E
; ---------------------------------------------------------------------------
RawAni_4B110:
		dc.b  $E4, $E5,	$E6, $E6, $E7, $E6, $E6, $E5, $E4, $E8,	$E9, $E9, $EA, $E9, $E9, $E8
byte_4B120:	dc.b	0,   0,	  0,   0,   0,	 1,   1,   1,	1,   0,	  0,   0,   0,	 1,   1,   1
; ---------------------------------------------------------------------------

loc_4B130:
		tst.b	2(a2)
		beq.s	loc_4B13E
		subq.b	#1,2(a2)
		bne.w	locret_4B1CE

loc_4B13E:
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.w	locret_4B1CE
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		cmpi.w	#$18,d1
		bcc.w	locret_4B1CE
		tst.b	$2E(a1)
		bne.s	locret_4B1CE
		cmpi.b	#4,5(a1)
		bcc.s	locret_4B1CE
		tst.w	($FFFFFE08).w
		bne.s	locret_4B1CE
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addi.w	#$14,$14(a1)
		move.b	#$14,$20(a1)
		move.b	#0,$3D(a1)
		move.b	#3,$2E(a1)
		andi.b	#-4,4(a1)
		move.b	$2A(a3),d0
		andi.b	#1,d0
		or.b	d0,4(a1)
		andi.b	#-4,$2A(a1)
		or.b	d0,$2A(a1)
		move.b	#1,(a2)
		moveq	#$4A,d0
		jsr	(Play_Sound_2).l

locret_4B1CE:

		rts
; End of function sub_4AF80

; ---------------------------------------------------------------------------
Map_SOZRapelWire:include "Levels\SOZ\Misc Object Data\Map - Rapel Wire.asm"


; =============== S U B R O U T I N E =======================================


Ending_4B356:
		bsr.w	sub_4B4C4
		bsr.w	sub_4B592
		lea	($FFFF7800).l,a1
		move.b	($FFFFE400).w,d0
		andi.b	#-4,d0
		jsr	(GetSineCosine).l
		move.w	d0,d4
		move.w	d1,d5
		muls.w	#$18,d4
		muls.w	#$18,d5
		moveq	#0,d2
		move.w	($FFFFEE78).w,d2
		divu.w	#$18,d2
		swap	d2
		neg.w	d2
		addi.w	#-$B4,d2
		moveq	#0,d3
		move.w	($FFFFEE7C).w,d3
		divu.w	#$18,d3
		swap	d3
		neg.w	d3
		addi.w	#-$B4,d3
		move.w	#$F,d7

loc_4B3A6:
		movem.w	d0-d2,-(sp)
		movem.w	d0-d1,-(sp)
		neg.w	d0
		muls.w	d2,d1
		muls.w	d3,d0
		move.l	d0,d6
		add.l	d1,d6
		movem.w	(sp)+,d0-d1
		muls.w	d2,d0
		muls.w	d3,d1
		add.l	d0,d1
		move.l	d6,d2
		move.w	#$F,d6

loc_4B3C8:
		move.l	d2,d0
		asr.l	#8,d0
		move.w	d0,(a1)+
		move.l	d1,d0
		asr.l	#8,d0
		move.w	d0,(a1)+
		add.l	d5,d2
		add.l	d4,d1
		dbf	d6,loc_4B3C8
		movem.w	(sp)+,d0-d2
		addi.w	#$18,d3
		dbf	d7,loc_4B3A6
		lea	($FFFF3000).l,a0
		moveq	#0,d0
		move.w	($FFFFEE7C).w,d0
		divu.w	#$18,d0
		mulu.w	#$80,d0
		adda.l	d0,a0
		moveq	#0,d0
		move.w	($FFFFEE78).w,d0
		divu.w	#$18,d0
		adda.w	d0,a0
		lea	($FFFF7800).l,a4
		lea	($FFFFF800).w,a2
		moveq	#0,d5
		move.b	($FFFFF62C).w,d5
		move.w	d5,d0
		lsl.w	#3,d0
		adda.w	d0,a2
		move.w	#$F,d7

loc_4B424:
		move.w	#$F,d6

loc_4B428:
		moveq	#0,d0
		move.b	(a0)+,d0
		beq.s	loc_4B47C
		cmpi.b	#$13,d0
		bhi.s	loc_4B47C
		move.w	(a4),d3
		addi.w	#$120,d3
		cmpi.w	#$70,d3
		bcs.s	loc_4B47C
		cmpi.w	#$1D0,d3
		bcc.s	loc_4B47C
		move.w	2(a4),d2
		addi.w	#$F0,d2
		cmpi.w	#$70,d2
		bcs.s	loc_4B47C
		cmpi.w	#$170,d2
		bcc.s	loc_4B47C
		lea	($FFFF7000).l,a5
		lsl.w	#3,d0
		lea	(a5,d0.w),a5
		movea.l	(a5)+,a1
		move.w	(a5)+,d1
		add.w	d1,d1
		adda.w	(a1,d1.w),a1
		movea.w	(a5)+,a3
		moveq	#0,d1
		move.b	(a1)+,d1
		subq.b	#1,d1
		bmi.s	loc_4B47C
		bsr.s	sub_4B490

loc_4B47C:
					; Ending_4B356+DCj ...
		addq.w	#4,a4
		dbf	d6,loc_4B428
		lea	$70(a0),a0
		dbf	d7,loc_4B424

loc_4B48A:
		move.b	d5,($FFFFF62C).w
		rts
; End of function Ending_4B356


; =============== S U B R O U T I N E =======================================


sub_4B490:

		cmpi.b	#$50,d5
		beq.s	locret_4B4C2
		move.b	(a1)+,d0
		ext.w	d0
		add.w	d2,d0
		move.w	d0,(a2)+
		move.b	(a1)+,(a2)+
		addq.b	#1,d5
		addq.w	#1,a2
		move.b	(a1)+,d0
		lsl.w	#8,d0
		move.b	(a1)+,d0
		add.w	a3,d0
		move.w	d0,(a2)+
		move.b	(a1)+,d0
		ext.w	d0
		add.w	d3,d0
		andi.w	#$1FF,d0
		bne.s	loc_4B4BC
		addq.w	#1,d0

loc_4B4BC:
		move.w	d0,(a2)+
		dbf	d1,sub_4B490

locret_4B4C2:
		rts
; End of function sub_4B490


; =============== S U B R O U T I N E =======================================


sub_4B4C4:
		lea	($FFFF700C).l,a1
		moveq	#0,d0
		move.b	($FFFFE400).w,d0
		lsr.b	#2,d0
		andi.w	#$F,d0
		moveq	#2,d1

loc_4B4D8:
		move.w	d0,(a1)
		addq.w	#8,a1
		dbf	d1,loc_4B4D8
		lea	($FFFF706C).l,a1
		moveq	#2,d1

loc_4B4E8:
		move.w	d0,(a1)
		addq.w	#8,a1
		dbf	d1,loc_4B4E8
		lea	($FFFF7005).l,a1
		subq.b	#1,($FFFFFEB0).w
		bpl.s	loc_4B526
		move.b	#1,($FFFFFEB0).w
		addq.b	#1,$20(a1)
		cmpi.b	#3,$20(a1)
		bcs.s	loc_4B514
		move.b	#0,$20(a1)

loc_4B514:
		addq.b	#1,($FFFFFEB1).w
		cmpi.b	#6,($FFFFFEB1).w
		bcs.s	loc_4B526
		move.b	#0,($FFFFFEB1).w

loc_4B526:

		move.b	($FFFFFEB1).w,$48(a1)
		move.b	($FFFFFEB3).w,$40(a1)
		subq.b	#1,($FFFFFEB4).w
		bpl.s	loc_4B548
		move.b	#3,($FFFFFEB4).w
		addq.b	#1,($FFFFFEB5).w
		andi.b	#3,($FFFFFEB5).w

loc_4B548:
		move.b	($FFFFFEB5).w,$38(a1)
		rts
; End of function sub_4B4C4

; ---------------------------------------------------------------------------
		subq.b	#1,($FFFFFEB6).w
		bpl.s	loc_4B566
		move.b	#4,($FFFFFEB6).w

loc_4B55C:
		addq.b	#1,($FFFFFEB7).w
		andi.b	#3,($FFFFFEB7).w

loc_4B566:
		move.b	($FFFFFEB7).w,d0
		move.b	d0,$168(a1)
		move.b	d0,$170(a1)
		move.b	d0,$178(a1)
		move.b	d0,$180(a1)
		rts

; =============== S U B R O U T I N E =======================================


sub_4B57C:

		lea	($FFFF7400).l,a2
		move.w	#$1F,d0

loc_4B586:
		tst.b	(a2)
		beq.s	locret_4B590
		addq.w	#8,a2
		dbf	d0,loc_4B586

locret_4B590:
		rts
; End of function sub_4B57C


; =============== S U B R O U T I N E =======================================


sub_4B592:
		lea	($FFFF7400).l,a0
		move.w	#$1F,d7

loc_4B59C:
		moveq	#0,d0
		move.b	(a0),d0
		beq.s	loc_4B5AA
		lsl.w	#2,d0
		movea.l	loc_4B5AC+2(pc,d0.w),a1
		jsr	(a1)

loc_4B5AA:
		addq.w	#8,a0

loc_4B5AC:
		dbf	d7,loc_4B59C
		rts
; End of function sub_4B592

; ---------------------------------------------------------------------------
		dc.l loc_4B5C2
		dc.l loc_4B5F2
		dc.l loc_4B65A
		dc.l loc_4B626
; ---------------------------------------------------------------------------

loc_4B5C2:
		subq.b	#1,2(a0)
		bpl.s	locret_4B5EA
		move.b	#5,2(a0)
		moveq	#0,d0
		move.b	3(a0),d0
		addq.b	#1,3(a0)
		movea.l	4(a0),a1
		move.b	byte_4B5EC(pc,d0.w),d0
		move.b	d0,(a1)
		bne.s	locret_4B5EA
		clr.l	(a0)
		clr.l	4(a0)

locret_4B5EA:

		rts
; ---------------------------------------------------------------------------
byte_4B5EC:	dc.b $10
		dc.b $11
		dc.b $12
		dc.b $13
		dc.b 0
		dc.b 0
; ---------------------------------------------------------------------------

loc_4B5F2:
		subq.b	#1,2(a0)
		bpl.s	locret_4B620
		move.b	#1,2(a0)
		moveq	#0,d0
		move.b	3(a0),d0
		addq.b	#1,3(a0)
		movea.l	4(a0),a1
		move.b	byte_4B622(pc,d0.w),d0
		bne.s	loc_4B61E
		clr.l	(a0)
		clr.l	4(a0)
		move.b	#5,(a1)
		rts
; ---------------------------------------------------------------------------

loc_4B61E:
		move.b	d0,(a1)

locret_4B620:
		rts
; ---------------------------------------------------------------------------
byte_4B622:	dc.b $A
		dc.b $B
		dc.b 0
		dc.b 0
; ---------------------------------------------------------------------------

loc_4B626:
		subq.b	#1,2(a0)
		bpl.s	locret_4B654
		move.b	#7,2(a0)
		moveq	#0,d0
		move.b	3(a0),d0
		addq.b	#1,3(a0)
		movea.l	4(a0),a1
		move.b	byte_4B656(pc,d0.w),d0
		bne.s	loc_4B652
		clr.l	(a0)
		clr.l	4(a0)
		move.b	#6,(a1)
		rts
; ---------------------------------------------------------------------------

loc_4B652:
		move.b	d0,(a1)

locret_4B654:
		rts
; ---------------------------------------------------------------------------
byte_4B656:	dc.b $C
		dc.b 6
		dc.b $C
		dc.b 0
; ---------------------------------------------------------------------------

loc_4B65A:
		subq.b	#1,2(a0)
		bpl.s	locret_4B686
		move.b	#1,2(a0)
		moveq	#0,d0
		move.b	3(a0),d0
		addq.b	#1,3(a0)
		movea.l	4(a0),a1
		move.b	byte_4B688(pc,d0.w),d0
		move.b	d0,(a1)
		bne.s	locret_4B686
		move.b	4(a0),(a1)
		clr.l	(a0)
		clr.l	4(a0)

locret_4B686:

		rts
; ---------------------------------------------------------------------------
byte_4B688:	dc.b $D
		dc.b $E
		dc.b $F
		dc.b $D
		dc.b $E
		dc.b $F
		dc.b $D
		dc.b $E
		dc.b $F
		dc.b $D
		dc.b $E
		dc.b $F
		dc.b $D
		dc.b $E
		dc.b $F
		dc.b $D
		dc.b $E
		dc.b $F
		dc.b $D
		dc.b $E
		dc.b $F
		dc.b $D
		dc.b $E
		dc.b $F
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b $1E
		dc.b $40
		dc.b $80
		dc.b 3
		dc.b $28
		dc.b 2
		dc.b $F8

; =============== S U B R O U T I N E =======================================


sub_4B6AA:
		lea	($FFFF3000).l,a1
		move.w	#$FFF,d0

loc_4B6B4:
		clr.l	(a1)+
		dbf	d0,loc_4B6B4
		lea	($FFFF4020).l,a1
		lea	(SlotBonusLayout).l,a0
		move.w	(a0)+,($FFFFB010).w
		move.w	(a0)+,($FFFFB014).w
		moveq	#$1F,d1

loc_4B6D0:
		moveq	#$1F,d2

loc_4B6D2:
		move.b	(a0)+,(a1)+
		dbf	d2,loc_4B6D2
		lea	$60(a1),a1
		dbf	d1,loc_4B6D0
		lea	($FFFF7008).l,a1
		lea	(SlotBonusMaps).l,a0
		moveq	#$12,d1

loc_4B6EE:
		move.l	(a0)+,(a1)+
		move.w	#0,(a1)+
		move.b	-4(a0),-1(a1)
		move.w	(a0)+,(a1)+
		dbf	d1,loc_4B6EE

loc_4B700:
		lea	($FFFF7400).l,a1
		move.w	#$3F,d1

loc_4B70A:
		clr.l	(a1)+
		dbf	d1,loc_4B70A
		jsr	(Create_New_Sprite).l
		bne.w	locret_4B720
		move.l	#loc_4BF62,(a1)

locret_4B720:
		rts
; End of function sub_4B6AA

; ---------------------------------------------------------------------------
SlotBonusMaps:	dc.l Map_SB_ColoredWall
		dc.w $633B
		dc.l Map_SB_ColoredWall
		dc.w $233B
		dc.l Map_SB_ColoredWall
		dc.w $433B
		dc.l Map_SB_Goal
		dc.w $487
		dc.l Map_SB_Bumper
		dc.w $2434
		dc.l Map_SB_R_and_Peppermint
		dc.w $2478
		dc.l Map_SB_R_and_Peppermint
		dc.w $445D
		dc.l Map_SB_Ring
		dc.w $26BC
		dc.l Map_SB_Slot
		dc.w $481
		dc.l Map_SB_Bumper+$1000000
		dc.w $2434
		dc.l Map_SB_Bumper+$2000000
		dc.w $4434
		dc.l Map_SB_R_and_Peppermint
		dc.w $4478
		dc.l Map_SB_ColoredWall
		dc.w $633B
		dc.l Map_SB_ColoredWall
		dc.w $233B
		dc.l Map_SB_ColoredWall
		dc.w $433B
		dc.l Map_SB_Ring+$4000000
		dc.w $26BC
		dc.l Map_SB_Ring+$5000000
		dc.w $26BC
		dc.l Map_SB_Ring+$6000000
		dc.w $26BC
		dc.l Map_SB_Ring+$7000000
		dc.w $26BC
Map_SB_Slot:	include "Levels\Slots\Misc Object Data\Map - Slot.asm"

Map_SB_R_and_Peppermint:	include "Levels\Slots\Misc Object Data\Map - R and Peppermint.asm"

Map_SB_Goal:	include "Levels\Slots\Misc Object Data\Map - Goal.asm"

Map_SB_Bumper:	include "Levels\Slots\Misc Object Data\Map - Bumper.asm"

Map_SB_Ring:	include "Levels\Slots\Misc Object Data\Map - Ring.asm"

Map_SB_ColoredWall:	include "Levels\Slots\Misc Object Data\Map - Colored Wall.asm"

; ---------------------------------------------------------------------------

Obj_Sonic_RotatingSlotBonus:
		move.w	($FFFFF604).w,($FFFFF602).w
		tst.w	($FFFFFE08).w
		beq.s	loc_4B96E
		jsr	(DebugMode).l
		bra.w	sub_4BBF4
; ---------------------------------------------------------------------------

loc_4B96E:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_4B9BC(pc,d0.w),d1
		jsr	off_4B9BC(pc,d1.w)

loc_4B97C:
		move.b	#2,$20(a0)
		bsr.s	sub_4B99E
		lea	($FFFFB000).w,a1
		moveq	#0,d0
		move.b	$22(a1),d0
		jsr	(Tails_Carry_LoadPLC).l
		bsr.w	sub_4BBF4
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_4B99E:
		move.b	$38(a0),d0
		bne.s	loc_4B9AA
		jmp	(Animate_Sonic).l
; ---------------------------------------------------------------------------

loc_4B9AA:
		cmpi.b	#1,d0
		bne.s	loc_4B9B6
		jmp	(Animate_Tails).l
; ---------------------------------------------------------------------------

loc_4B9B6:
		jmp	(Animate_Knuckles).l
; End of function sub_4B99E

; ---------------------------------------------------------------------------
off_4B9BC:	dc.w loc_4B9CE-off_4B9BC

		dc.w loc_4BA4E-off_4B9BC; 1
		dc.w loc_4BC1E-off_4B9BC; 2
off_4B9C2:	dc.l Map_Sonic
		dc.l Map_Tails
		dc.l Map_Knuckles
; ---------------------------------------------------------------------------

loc_4B9CE:
		addq.b	#2,5(a0)
		move.b	#$E,$1E(a0)
		move.b	#7,$1F(a0)
		move.w	($FFFFFF08).w,d0
		subq.w	#1,d0
		bcc.s	loc_4B9E8
		moveq	#0,d0

loc_4B9E8:
		move.b	d0,$38(a0)
		lsl.w	#2,d0
		move.l	off_4B9C2(pc,d0.w),$C(a0)
		move.w	#$680,$A(a0)
		move.b	#4,4(a0)
		move.w	#$100,8(a0)
		move.b	#2,$20(a0)
		bset	#2,$2A(a0)
		bset	#1,$2A(a0)
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_4BA32
		move.w	#$6A0,$A(a0)
		move.l	#Obj_Tails_Tail,($FFFFCC0A).w
		move.w	a0,($FFFFCC3A).w

loc_4BA32:
		clr.w	($FFFFE400).w
		move.w	#$40,($FFFFE402).w
		move.w	($FFFFFE32).w,($FFFFFE20).w
		move.b	($FFFFFE43).w,($FFFFFE1B).w
		move.b	#1,($FFFFFE1D).w

loc_4BA4E:
		tst.w	($FFFFFFDA).w

loc_4BA52:
		beq.s	loc_4BA62
		btst	#4,($FFFFF605).w
		beq.s	loc_4BA62
		move.w	#1,($FFFFFE08).w

loc_4BA62:

		move.b	#0,$30(a0)
		tst.b	$2E(a0)
		bne.s	loc_4BA80
		moveq	#0,d0
		move.b	$2A(a0),d0
		andi.w	#2,d0
		move.w	off_4BA90(pc,d0.w),d1
		jmp	off_4BA90(pc,d1.w)
; ---------------------------------------------------------------------------

loc_4BA80:
		move.w	($FFFFE402).w,d0
		asl.w	#4,d0
		add.w	($FFFFE400).w,d0
		move.w	d0,($FFFFE400).w
		rts
; ---------------------------------------------------------------------------
off_4BA90:	dc.w loc_4BA94-off_4BA90

		dc.w loc_4BA98-off_4BA90
; ---------------------------------------------------------------------------

loc_4BA94:
		bsr.w	sub_4BBB2

loc_4BA98:
		bsr.w	sub_4BABC
		bsr.w	sub_4BCB0
		bsr.w	sub_4BDCA
		bsr.w	sub_4BE3A
		jsr	(MoveSprite2).l
		move.w	($FFFFE400).w,d0
		add.w	($FFFFE402).w,d0
		move.w	d0,($FFFFE400).w
		rts

; =============== S U B R O U T I N E =======================================


sub_4BABC:
		btst	#2,($FFFFF602).w
		beq.s	loc_4BAC8
		bsr.w	sub_4BB54

loc_4BAC8:
		btst	#3,($FFFFF602).w
		beq.s	loc_4BAD4
		bsr.w	sub_4BB84

loc_4BAD4:
		move.b	($FFFFF602).w,d0
		andi.b	#$C,d0
		bne.s	loc_4BB04
		move.w	$1C(a0),d0
		beq.s	loc_4BB04
		bmi.s	loc_4BAF6
		subi.w	#$C,d0
		bcc.s	loc_4BAF0
		move.w	#0,d0

loc_4BAF0:
		move.w	d0,$1C(a0)
		bra.s	loc_4BB04
; ---------------------------------------------------------------------------

loc_4BAF6:
		addi.w	#$C,d0
		bcc.s	loc_4BB00
		move.w	#0,d0

loc_4BB00:
		move.w	d0,$1C(a0)

loc_4BB04:

		move.b	($FFFFE400).w,d0
		addi.b	#$20,d0
		andi.b	#-$40,d0
		neg.b	d0
		jsr	(GetSineCosine).l
		muls.w	$1C(a0),d1
		add.l	d1,$10(a0)
		muls.w	$1C(a0),d0
		add.l	d0,$14(a0)
		movem.l	d0-d1,-(sp)
		move.l	$14(a0),d2
		move.l	$10(a0),d3
		bsr.w	sub_4BD5A
		beq.s	loc_4BB4E
		movem.l	(sp)+,d0-d1
		sub.l	d1,$10(a0)
		sub.l	d0,$14(a0)
		move.w	#0,$1C(a0)
		rts
; ---------------------------------------------------------------------------

loc_4BB4E:
		movem.l	(sp)+,d0-d1
		rts
; End of function sub_4BABC


; =============== S U B R O U T I N E =======================================


sub_4BB54:
		bset	#0,$2A(a0)
		move.w	$1C(a0),d0
		beq.s	loc_4BB62
		bpl.s	loc_4BB76

loc_4BB62:
		subi.w	#$C,d0
		cmpi.w	#-$800,d0
		bgt.s	loc_4BB70
		move.w	#-$800,d0

loc_4BB70:
		move.w	d0,$1C(a0)
		rts
; ---------------------------------------------------------------------------

loc_4BB76:
		subi.w	#$40,d0
		bcc.s	loc_4BB7E
		nop

loc_4BB7E:
		move.w	d0,$1C(a0)
		rts
; End of function sub_4BB54


; =============== S U B R O U T I N E =======================================


sub_4BB84:
		bclr	#0,$2A(a0)
		move.w	$1C(a0),d0
		bmi.s	loc_4BBA4
		addi.w	#$C,d0
		cmpi.w	#$800,d0
		blt.s	loc_4BB9E
		move.w	#$800,d0

loc_4BB9E:
		move.w	d0,$1C(a0)
		bra.s	locret_4BBB0
; ---------------------------------------------------------------------------

loc_4BBA4:
		addi.w	#$40,d0
		bcc.s	loc_4BBAC
		nop

loc_4BBAC:
		move.w	d0,$1C(a0)

locret_4BBB0:
		rts
; End of function sub_4BB84


; =============== S U B R O U T I N E =======================================


sub_4BBB2:
		move.b	($FFFFF603).w,d0
		andi.b	#$70,d0
		beq.s	locret_4BBF2
		move.b	($FFFFE400).w,d0
		andi.b	#-4,d0
		neg.b	d0
		subi.b	#$40,d0
		jsr	(GetSineCosine).l
		muls.w	#$680,d1
		asr.l	#8,d1
		move.w	d1,$18(a0)
		muls.w	#$680,d0
		asr.l	#8,d0
		move.w	d0,$1A(a0)
		bset	#1,$2A(a0)
		moveq	#$62,d0
		jsr	(Play_Sound_2).l

locret_4BBF2:
		rts
; End of function sub_4BBB2


; =============== S U B R O U T I N E =======================================


sub_4BBF4:

		move.w	$14(a0),d2
		move.w	$10(a0),d3
		move.w	($FFFFEE78).w,d0
		subi.w	#$A0,d3
		bcs.s	loc_4BC0C
		sub.w	d3,d0
		sub.w	d0,($FFFFEE78).w

loc_4BC0C:
		move.w	($FFFFEE7C).w,d0
		subi.w	#$70,d2
		bcs.s	locret_4BC1C
		sub.w	d2,d0
		sub.w	d0,($FFFFEE7C).w

locret_4BC1C:
		rts
; End of function sub_4BBF4

; ---------------------------------------------------------------------------

loc_4BC1E:
		addi.w	#$40,($FFFFE402).w
		cmpi.w	#$1800,($FFFFE402).w
		bne.s	loc_4BC46
		move.w	#$3F,($FFFFF626).w
		clr.w	($FFFFF794).w
		move.l	#loc_4BC54,(a0)
		move.w	#$3C,$38(a0)
		st	($FFFFF650).w

loc_4BC46:
		move.w	($FFFFE400).w,d0
		add.w	($FFFFE402).w,d0
		move.w	d0,($FFFFE400).w
		rts
; ---------------------------------------------------------------------------

loc_4BC54:
		subq.w	#1,($FFFFF794).w
		bpl.s	loc_4BC6A
		move.w	#2,($FFFFF794).w
		move.l	a0,-(sp)
		jsr	(Pal_ToBlack).l
		movea.l	(sp)+,a0

loc_4BC6A:
		addi.w	#$40,($FFFFE402).w
		move.w	($FFFFE400).w,d0
		add.w	($FFFFE402).w,d0
		move.w	d0,($FFFFE400).w
		subq.w	#1,$38(a0)
		bne.s	loc_4BCAC
		move.w	($FFFFFE2C).w,($FFFFFE10).w
		move.w	($FFFFFF9A).w,($FFFFEE4E).w
		move.b	($FFFFFE2B).w,($FFFFFE2A).w
		move.b	#0,($FFFFFE48).w
		move.b	#1,($FFFFFE02).w
		move.w	($FFFFFE20).w,($FFFFFE32).w
		move.b	($FFFFFE1B).w,($FFFFFE43).w

loc_4BCAC:
		bra.w	loc_4B97C

; =============== S U B R O U T I N E =======================================


sub_4BCB0:
		move.l	$14(a0),d2
		move.l	$10(a0),d3
		move.b	($FFFFE400).w,d0
		andi.b	#-4,d0
		jsr	(GetSineCosine).l
		move.w	$18(a0),d4
		ext.l	d4
		asl.l	#8,d4
		muls.w	#$2A,d0
		add.l	d4,d0
		move.w	$1A(a0),d4
		ext.l	d4
		asl.l	#8,d4
		muls.w	#$2A,d1
		add.l	d4,d1
		add.l	d0,d3
		bsr.w	sub_4BD5A
		beq.s	loc_4BD10
		sub.l	d0,d3
		moveq	#0,d0
		move.w	d0,$18(a0)
		bclr	#1,$2A(a0)
		move.b	#4,$3A(a0)
		add.l	d1,d2
		bsr.w	sub_4BD5A
		beq.s	loc_4BD2C
		sub.l	d1,d2
		moveq	#0,d1
		move.w	d1,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_4BD10:
		add.l	d1,d2
		bsr.w	sub_4BD5A
		beq.s	loc_4BD3A
		sub.l	d1,d2
		moveq	#0,d1
		move.w	d1,$1A(a0)
		bclr	#1,$2A(a0)
		move.b	#4,$3A(a0)

loc_4BD2C:
		asr.l	#8,d0
		asr.l	#8,d1
		move.w	d0,$18(a0)
		move.w	d1,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_4BD3A:
		asr.l	#8,d0
		asr.l	#8,d1
		move.w	d0,$18(a0)
		move.w	d1,$1A(a0)
		tst.b	$3A(a0)
		bne.s	loc_4BD54
		bset	#1,$2A(a0)
		rts
; ---------------------------------------------------------------------------

loc_4BD54:
		subq.b	#1,$3A(a0)
		rts
; End of function sub_4BCB0


; =============== S U B R O U T I N E =======================================


sub_4BD5A:

		lea	($FFFF3000).l,a1
		moveq	#0,d4
		swap	d2
		move.w	d2,d4
		swap	d2
		addi.w	#$44,d4
		divu.w	#$18,d4
		mulu.w	#$80,d4
		adda.l	d4,a1
		moveq	#0,d4
		swap	d3
		move.w	d3,d4
		swap	d3
		addi.w	#$14,d4
		divu.w	#$18,d4
		adda.w	d4,a1
		moveq	#0,d5
		move.b	(a1)+,d4
		bsr.s	sub_4BDA2
		move.b	(a1)+,d4
		bsr.s	sub_4BDA2
		adda.w	#$7E,a1
		move.b	(a1)+,d4
		bsr.s	sub_4BDA2
		move.b	(a1)+,d4
		bsr.s	sub_4BDA2
		tst.b	d5
		rts
; End of function sub_4BD5A


; =============== S U B R O U T I N E =======================================


sub_4BDA2:

		beq.s	locret_4BDB0
		cmpi.b	#8,d4
		beq.s	locret_4BDB0
		cmpi.b	#$10,d4
		bcs.s	loc_4BDB2

locret_4BDB0:
		rts
; ---------------------------------------------------------------------------

loc_4BDB2:
		cmpi.b	#7,d4
		beq.s	loc_4BDC6
		cmpi.b	#9,d4
		bcc.s	loc_4BDC6
		move.b	d4,$30(a0)
		move.l	a1,$32(a0)

loc_4BDC6:

		moveq	#-1,d5
		rts
; End of function sub_4BDA2


; =============== S U B R O U T I N E =======================================


sub_4BDCA:
		lea	($FFFF3000).l,a1
		moveq	#0,d4
		move.w	$14(a0),d4
		addi.w	#$50,d4
		divu.w	#$18,d4
		mulu.w	#$80,d4
		adda.l	d4,a1
		moveq	#0,d4
		move.w	$10(a0),d4
		addi.w	#$20,d4
		divu.w	#$18,d4
		adda.w	d4,a1
		move.b	(a1),d4
		bne.s	loc_4BDFC
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_4BDFC:
		cmpi.b	#8,d4
		bne.s	loc_4BE36
		bsr.w	sub_4B57C
		bne.s	loc_4BE10
		move.b	#1,(a2)
		move.l	a1,4(a2)

loc_4BE10:
		jsr	(GiveRing).l
		cmpi.w	#$32,($FFFFFE20).w
		bcs.s	loc_4BE32
		bset	#0,($FFFFFE1B).w
		bne.s	loc_4BE32
		addq.b	#1,($FFFFFE18).w
		moveq	#-$54,d0
		jsr	(Play_Sound).l

loc_4BE32:

		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_4BE36:
		moveq	#-1,d4
		rts
; End of function sub_4BDCA


; =============== S U B R O U T I N E =======================================


sub_4BE3A:
		move.b	$30(a0),d0
		bne.s	loc_4BE5A
		subq.b	#1,$36(a0)
		bpl.s	loc_4BE4C
		move.b	#0,$36(a0)

loc_4BE4C:
		subq.b	#1,$37(a0)
		bpl.s	locret_4BE58
		move.b	#0,$37(a0)

locret_4BE58:
		rts
; ---------------------------------------------------------------------------

loc_4BE5A:
		cmpi.b	#5,d0
		bne.s	loc_4BED0
		move.l	$32(a0),d1
		subi.l	#-$CFFF,d1
		move.w	d1,d2
		andi.w	#$7F,d1
		mulu.w	#$18,d1
		subi.w	#$14,d1
		lsr.w	#7,d2
		andi.w	#$7F,d2
		mulu.w	#$18,d2
		subi.w	#$44,d2
		sub.w	$10(a0),d1
		sub.w	$14(a0),d2
		jsr	(GetArcTan).l
		jsr	(GetSineCosine).l
		muls.w	#-$700,d1
		asr.l	#8,d1
		move.w	d1,$18(a0)
		muls.w	#-$700,d0
		asr.l	#8,d0
		move.w	d0,$1A(a0)
		bset	#1,$2A(a0)
		bsr.w	sub_4B57C
		bne.s	loc_4BEC8
		move.b	#2,(a2)
		move.l	$32(a0),d0
		subq.l	#1,d0
		move.l	d0,4(a2)

loc_4BEC8:
		moveq	#-$56,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

loc_4BED0:
		cmpi.b	#4,d0
		bne.s	loc_4BEE4
		addq.b	#2,5(a0)
		moveq	#$6A,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_4BEE4:
		cmpi.b	#6,d0
		bne.s	loc_4BF18
		tst.b	$37(a0)
		bne.w	locret_4BF60
		move.b	#$1E,$37(a0)
		bsr.w	sub_4B57C
		bne.s	loc_4BF0C
		move.b	#4,(a2)
		move.l	$32(a0),d0
		subq.l	#1,d0
		move.l	d0,4(a2)

loc_4BF0C:
		neg.w	($FFFFE402).w
		moveq	#-$53,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

loc_4BF18:
		cmpi.b	#1,d0
		beq.s	loc_4BF30
		cmpi.b	#2,d0
		beq.s	loc_4BF30
		cmpi.b	#3,d0
		beq.s	loc_4BF30
		cmpi.b	#4,d0
		bne.s	locret_4BF60

loc_4BF30:

		bsr.w	sub_4B57C
		bne.s	loc_4BF58
		move.b	#3,(a2)
		movea.l	$32(a0),a1
		subq.l	#1,a1
		move.l	a1,4(a2)
		move.b	(a1),d0
		addq.b	#1,d0
		cmpi.b	#4,d0
		bls.s	loc_4BF54
		clr.b	d0
		move.b	#4,d0

loc_4BF54:
		move.b	d0,4(a2)

loc_4BF58:
		moveq	#-$52,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

locret_4BF60:

		rts
; End of function sub_4BE3A

; ---------------------------------------------------------------------------

loc_4BF62:
		move.w	#$460,$10(a0)
		move.w	#$430,$14(a0)
		move.l	#Map_SlotBonusCage,$C(a0)
		move.w	#$481,$A(a0)
		ori.b	#4,4(a0)
		move.b	#$18,7(a0)
		move.b	#$10,6(a0)
		move.w	#$80,8(a0)
		move.l	#loc_4BF9A,(a0)

loc_4BF9A:
		move.b	($FFFFE400).w,d0
		andi.b	#-4,d0
		jsr	(GetSineCosine).l
		lea	($FFFFB000).w,a1
		move.w	#$460,d2
		sub.w	$10(a1),d2
		move.w	d2,d4
		move.w	#$430,d3
		sub.w	$14(a1),d3
		move.w	d3,d5
		muls.w	d0,d4
		muls.w	d0,d5
		muls.w	d1,d2
		muls.w	d1,d3
		add.l	d4,d3
		asr.l	#8,d3
		sub.l	d5,d2
		asr.l	#8,d2
		add.w	$10(a1),d2
		add.w	$14(a1),d3
		move.w	d2,$10(a0)
		move.w	d3,$14(a0)
		move.w	d2,($FFFFEED2).w
		move.w	d3,($FFFFEED4).w
		lea	$34(a0),a2
		lea	($FFFFB000).w,a1
		bsr.w	sub_4C014
		subq.b	#1,$24(a0)
		bpl.s	locret_4C012
		move.b	#1,$24(a0)
		addq.b	#1,$22(a0)
		cmpi.b	#6,$22(a0)
		bcs.s	locret_4C012
		move.b	#0,$22(a0)

locret_4C012:

		rts

; =============== S U B R O U T I N E =======================================


sub_4C014:
		move.w	(a2),d0
		move.w	off_4C01E(pc,d0.w),d0
		jmp	off_4C01E(pc,d0.w)
; End of function sub_4C014

; ---------------------------------------------------------------------------
off_4C01E:	dc.w loc_4C026-off_4C01E
		dc.w loc_4C21C-off_4C01E
		dc.w loc_4C250-off_4C01E
		dc.w loc_4C292-off_4C01E
; ---------------------------------------------------------------------------

loc_4C026:
		tst.b	$2E(a1)
		bne.s	locret_4C0A8
		tst.w	($FFFFE406).w
		bne.s	locret_4C0A8
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		addi.w	#$18,d0
		cmpi.w	#$30,d0
		bcc.s	locret_4C0A8
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$18,d0
		cmpi.w	#$30,d0
		bcc.s	locret_4C0A8
		move.w	#$460,$10(a1)
		move.w	#$430,$14(a1)
		move.w	#0,$18(a1)
		move.w	#0,$1A(a1)
		move.w	#0,$1C(a1)
		move.b	#-$7F,$2E(a1)
		addq.w	#2,(a2)+
		move.w	#$78,(a2)
		move.w	a1,$42(a0)
		move.b	#1,($FFFFF650).w
		cmpi.b	#$18,($FFFFE408).w
		bne.s	locret_4C0A8
		move.b	#8,($FFFFE408).w
		clr.w	$32(a0)
		move.w	#-1,($FFFFE406).w
		move.w	#-1,$2E(a0)

locret_4C0A8:

		rts
; ---------------------------------------------------------------------------

loc_4C0AA:
		move.w	($FFFFE40C).w,d0
		bpl.w	loc_4C172
		tst.w	$2E(a0)
		bpl.s	loc_4C0BE
		move.w	#$64,$2E(a0)

loc_4C0BE:
		tst.w	$2E(a0)
		beq.w	loc_4C164
		btst	#0,($FFFFFE05).w
		beq.w	loc_4C16C
		cmpi.w	#$10,$30(a0)
		bcc.w	loc_4C16C
		jsr	(Create_New_Sprite).l
		bne.w	loc_4C16C
		move.l	#loc_4C374,(a1)
		move.l	#Map_SlotSpike,$C(a1)
		move.w	#$2490,$A(a1)
		move.b	#4,4(a1)
		move.b	#$10,7(a1)
		move.w	#$200,8(a1)
		move.w	#$1E,$40(a1)
		move.w	$32(a0),$32(a1)
		addi.w	#$90,$32(a0)
		move.w	$10(a0),$3C(a1)
		move.w	$14(a0),$3E(a1)
		move.w	$32(a1),d0
		jsr	(GetSineCosine).l
		asr.w	#1,d1
		add.w	$3C(a1),d1
		move.w	d1,$34(a1)
		move.w	d1,$10(a1)
		asr.w	#1,d0
		add.w	$3E(a1),d0
		move.w	d0,$38(a1)
		move.w	d0,$14(a1)
		lea	$30(a0),a2
		move.l	a2,$2E(a1)
		move.w	$42(a0),$42(a1)
		addq.w	#1,$30(a0)
		subq.w	#1,$2E(a0)

loc_4C164:
		tst.w	$30(a0)
		beq.w	loc_4C23E

loc_4C16C:

		addq.w	#1,($FFFFE404).w
		rts
; ---------------------------------------------------------------------------

loc_4C172:
		beq.w	loc_4C214
		btst	#0,($FFFFFE05).w
		beq.w	locret_4C21A
		cmpi.w	#$10,$30(a0)
		bcc.w	locret_4C21A
		jsr	(Create_New_Sprite).l
		bne.w	locret_4C21A
		move.l	#loc_1A9EE,(a1)
		move.l	#Map_Ring,$C(a1)
		move.w	#$26BC,$A(a1)
		move.b	#4,4(a1)
		move.w	#$180,8(a1)
		move.b	#8,7(a1)
		move.w	#$1A,$40(a1)
		move.w	$32(a0),$32(a1)
		addi.w	#$89,$32(a0)
		move.w	$10(a0),$3C(a1)
		move.w	$14(a0),$3E(a1)
		move.w	$32(a1),d0
		jsr	(GetSineCosine).l
		asr.w	#1,d1
		add.w	$3C(a1),d1
		move.w	d1,$34(a1)
		move.w	d1,$10(a1)
		asr.w	#1,d0
		add.w	$3E(a1),d0
		move.w	d0,$38(a1)
		move.w	d0,$14(a1)
		lea	$30(a0),a2
		move.l	a2,$2E(a1)
		move.w	$42(a0),$42(a1)
		addq.w	#1,$30(a0)
		subq.w	#1,($FFFFE40C).w

loc_4C214:
		tst.w	$30(a0)
		beq.s	loc_4C23E

locret_4C21A:

		rts
; ---------------------------------------------------------------------------

loc_4C21C:
		move.w	a1,$42(a0)
		cmpi.b	#$18,($FFFFE408).w
		beq.w	loc_4C0AA
		move.b	($FFFFFE0F).w,d0
		andi.w	#$F,d0
		bne.s	locret_4C23C
		moveq	#-$49,d0
		jsr	(Play_Sound_2).l

locret_4C23C:
		rts
; ---------------------------------------------------------------------------

loc_4C23E:

		move.w	#0,$30(a0)
		addq.w	#2,(a2)+
		move.w	#8,(a2)
		clr.b	($FFFFF650).w
		rts
; ---------------------------------------------------------------------------

loc_4C250:
		move.b	($FFFFE400).w,d0
		andi.w	#$3C,d0
		bne.s	locret_4C290
		move.b	($FFFFE400).w,d0
		andi.b	#-4,d0
		jsr	(GetSineCosine).l
		asl.w	#2,d0
		asl.w	#2,d1
		move.w	d0,$18(a1)
		move.w	d1,$1A(a1)
		move.b	#0,$2E(a1)
		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)
		neg.w	($FFFFE402).w
		addq.w	#2,(a2)+
		move.w	#8,(a2)

locret_4C290:
		rts
; ---------------------------------------------------------------------------

loc_4C292:
		subq.w	#1,2(a2)
		bpl.s	locret_4C29E
		clr.w	(a2)
		clr.w	($FFFFE406).w

locret_4C29E:
		rts
; ---------------------------------------------------------------------------
Map_SlotBonusCage:	include "Levels\Slots\Misc Object Data\Map - Bonus Cage (Unused).asm"

; ---------------------------------------------------------------------------

loc_4C374:
		moveq	#0,d1
		move.w	$3C(a0),d1
		swap	d1
		move.l	$34(a0),d0
		sub.l	d1,d0
		asr.l	#4,d0
		sub.l	d0,$34(a0)
		move.w	$34(a0),$10(a0)
		moveq	#0,d1
		move.w	$3E(a0),d1
		swap	d1
		move.l	$38(a0),d0
		sub.l	d1,d0
		asr.l	#4,d0
		sub.l	d0,$38(a0)
		move.w	$38(a0),$14(a0)
		subq.w	#1,$40(a0)
		bne.w	loc_4C3E0
		movea.l	$2E(a0),a1
		subq.w	#1,(a1)
		cmpi.w	#5,($FFFFE404).w
		bcs.s	loc_4C3CA
		clr.w	($FFFFE404).w
		moveq	#$37,d0
		jsr	(Play_Sound_2).l

loc_4C3CA:
		tst.w	($FFFFFE20).w
		beq.s	loc_4C3DA
		subq.w	#1,($FFFFFE20).w
		ori.b	#-$7F,($FFFFFE1D).w

loc_4C3DA:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_4C3E0:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Map_SlotSpike:	include "Levels\Slots\Misc Object Data\Map - Spike.asm"


; =============== S U B R O U T I N E =======================================


Slots_CycleOptions:
		lea	($FFFFE408).w,a4
		moveq	#0,d0
		move.b	(a4),d0
		jmp	loc_4C3FC(pc,d0.w)
; End of function Slots_CycleOptions

; ---------------------------------------------------------------------------

loc_4C3FC:
		bra.w	loc_4C416
; ---------------------------------------------------------------------------
		bra.w	loc_4C462
; ---------------------------------------------------------------------------
		bra.w	loc_4C480
; ---------------------------------------------------------------------------
		bra.w	loc_4C540
; ---------------------------------------------------------------------------
		bra.w	loc_4C576
; ---------------------------------------------------------------------------
		bra.w	loc_4C6BC
; ---------------------------------------------------------------------------
		rts
; ---------------------------------------------------------------------------

loc_4C416:
		movea.l	a4,a1
		moveq	#8,d0

loc_4C41A:
		clr.w	(a1)+
		dbf	d0,loc_4C41A
		move.b	($FFFFFE0F).w,d0
		move.b	d0,6(a4)
		ror.b	#3,d0
		move.b	d0,$A(a4)
		ror.b	#3,d0
		move.b	d0,$E(a4)
		move.b	#8,7(a4)
		move.b	#8,$B(a4)
		move.b	#8,$F(a4)
		move.b	#8,8(a4)
		move.b	#8,$C(a4)
		move.b	#8,$10(a4)
		move.b	#1,1(a4)
		addq.b	#4,(a4)
		rts
; ---------------------------------------------------------------------------

loc_4C462:
		bsr.w	sub_4C6D6
		tst.b	1(a4)
		beq.s	loc_4C46E
		rts
; ---------------------------------------------------------------------------

loc_4C46E:
		move.b	#$18,(a4)
		clr.w	8(a4)
		clr.w	$C(a4)
		clr.w	$10(a4)
		rts
; ---------------------------------------------------------------------------

loc_4C480:
		move.b	($FFFFFE0F).w,d0
		andi.b	#7,d0
		subq.b	#4,d0
		addi.b	#$30,d0
		move.b	d0,8(a4)
		move.b	($FFFFFE0F).w,d0
		rol.b	#4,d0
		andi.b	#7,d0
		subq.b	#4,d0
		addi.b	#$30,d0
		move.b	d0,$C(a4)
		move.b	($FFFFFE0E).w,d0
		andi.b	#7,d0
		subq.b	#4,d0
		addi.b	#$30,d0
		move.b	d0,$10(a4)
		move.b	#2,1(a4)
		clr.b	3(a4)
		clr.b	9(a4)
		clr.b	$D(a4)
		clr.b	$11(a4)
		addq.b	#4,(a4)
		move.b	($FFFFFE0F).w,d0
		ror.b	#3,d0
		lea	(byte_4C8B4).l,a2

loc_4C4DC:
		sub.b	(a2),d0
		bcs.s	loc_4C4E4
		addq.w	#3,a2
		bra.s	loc_4C4DC
; ---------------------------------------------------------------------------

loc_4C4E4:
		cmpi.b	#-1,(a2)
		beq.s	loc_4C4F8
		move.b	1(a2),4(a4)
		move.b	2(a2),5(a4)
		rts
; ---------------------------------------------------------------------------

loc_4C4F8:
		jsr	(Random_Number).l
		add.w	($FFFFFE0E).w,d0
		ror.w	#4,d0
		move.w	d0,d1
		andi.w	#7,d1
		lea	(byte_4C8CC).l,a1
		move.b	(a1,d1.w),4(a4)
		lsr.w	#3,d0
		move.b	d0,d1
		andi.w	#7,d1
		lea	(byte_4C8D4).l,a1
		move.b	(a1,d1.w),d2
		lsl.b	#4,d2
		lsr.w	#3,d0
		andi.w	#7,d0
		lea	(byte_4C8DC).l,a1
		or.b	(a1,d0.w),d2
		move.b	d2,5(a4)
		rts
; ---------------------------------------------------------------------------

loc_4C540:
		bsr.w	sub_4C6D6
		tst.b	1(a4)
		beq.s	loc_4C54C
		rts
; ---------------------------------------------------------------------------

loc_4C54C:
		addi.b	#$30,8(a4)
		addi.b	#$30,$C(a4)
		addi.b	#$30,$10(a4)
		move.b	($FFFFFE0F).w,d0
		andi.b	#$F,d0
		addi.b	#$C,d0
		move.b	d0,1(a4)
		clr.b	2(a4)
		addq.b	#4,(a4)
		rts
; ---------------------------------------------------------------------------

loc_4C576:
		bsr.w	sub_4C6D6
		cmpi.b	#$C,9(a4)
		bne.s	loc_4C594
		cmpi.b	#$C,$D(a4)
		bne.s	loc_4C594
		cmpi.b	#$C,$11(a4)
		beq.w	loc_4C6BC

loc_4C594:

		moveq	#0,d0
		move.b	3(a4),d0
		lea	6(a4),a1
		adda.w	d0,a1
		lea	(byte_4C8CC).l,a3
		add.w	d0,d0
		adda.w	d0,a3
		moveq	#0,d0
		move.b	3(a1),d0
		jmp	loc_4C5B4(pc,d0.w)
; ---------------------------------------------------------------------------

loc_4C5B4:
		bra.w	loc_4C602
; ---------------------------------------------------------------------------
		bra.w	loc_4C63E
; ---------------------------------------------------------------------------
		bra.w	loc_4C6A8
; ---------------------------------------------------------------------------
		bra.w	locret_4C6BA

; =============== S U B R O U T I N E =======================================


sub_4C5C4:

		move.w	4(a4),d1
		move.b	3(a4),d0
		beq.s	loc_4C5D0
		lsr.w	d0,d1

loc_4C5D0:
		andi.w	#7,d1
		cmpi.b	#6,d1
		bgt.s	loc_4C5DC
		rts
; ---------------------------------------------------------------------------

loc_4C5DC:
		subq.b	#2,d1
		rts
; End of function sub_4C5C4


; =============== S U B R O U T I N E =======================================


sub_4C5E0:
		move.w	#-$10,d2
		andi.w	#$F,d1
		move.b	3(a4),d0
		beq.s	loc_4C5F2
		lsl.w	d0,d1
		rol.w	d0,d2

loc_4C5F2:
		and.w	d2,4(a4)
		or.w	d1,4(a4)
		andi.w	#$777,4(a4)
		rts
; End of function sub_4C5E0

; ---------------------------------------------------------------------------

loc_4C602:
		tst.b	3(a4)
		bne.s	loc_4C610
		tst.b	1(a4)
		bmi.s	loc_4C61A
		rts
; ---------------------------------------------------------------------------

loc_4C610:
		cmpi.b	#8,-1(a1)
		bge.s	loc_4C61A
		rts
; ---------------------------------------------------------------------------

loc_4C61A:

		bsr.s	sub_4C5C4
		move.w	(a1),d0
		subi.w	#$A0,d0
		lsr.w	#8,d0
		andi.w	#7,d0
		move.b	(a3,d0.w),d0
		cmp.b	d1,d0
		beq.s	loc_4C632
		rts
; ---------------------------------------------------------------------------

loc_4C632:
		addq.b	#4,3(a1)
		move.b	#$60,2(a1)
		rts
; ---------------------------------------------------------------------------

loc_4C63E:
		bsr.s	sub_4C5C4
		move.w	(a1),d0
		addi.w	#$F0,d0
		andi.w	#$700,d0
		lsr.w	#8,d0
		move.b	(a3,d0.w),d0
		cmp.b	d0,d1
		beq.s	loc_4C67C
		cmpi.b	#$20,2(a1)
		bls.s	loc_4C662
		subi.b	#$C,2(a1)

loc_4C662:
		cmpi.b	#$18,2(a1)
		bgt.s	loc_4C66C
		rts
; ---------------------------------------------------------------------------

loc_4C66C:
		cmpi.b	#-$80,1(a1)
		bls.s	loc_4C676
		rts
; ---------------------------------------------------------------------------

loc_4C676:
		subq.b	#2,2(a1)
		rts
; ---------------------------------------------------------------------------

loc_4C67C:
		move.w	(a1),d0
		addi.w	#$80,d0
		move.w	d0,d1
		andi.w	#$700,d1
		subi.w	#$10,d1
		move.w	d1,(a1)
		lsr.w	#8,d0
		andi.w	#7,d0
		move.b	(a3,d0.w),d1
		bsr.w	sub_4C5E0
		move.b	#-8,2(a1)
		addq.b	#4,3(a1)
		rts
; ---------------------------------------------------------------------------

loc_4C6A8:
		tst.b	1(a1)
		beq.s	loc_4C6B0
		rts
; ---------------------------------------------------------------------------

loc_4C6B0:
		clr.b	2(a1)
		addq.b	#4,3(a1)
		rts
; ---------------------------------------------------------------------------

locret_4C6BA:
		rts
; ---------------------------------------------------------------------------

loc_4C6BC:

		clr.w	8(a4)
		clr.w	$C(a4)
		clr.w	$10(a4)
		clr.b	1(a4)
		bsr.w	sub_4C7A2
		move.b	#$18,(a4)
		rts

; =============== S U B R O U T I N E =======================================


sub_4C6D6:

		moveq	#0,d0
		move.b	3(a4),d0
		lea	6(a4),a1
		adda.w	d0,a1
		lea	(byte_4C8CC).l,a3
		adda.w	d0,a3
		adda.w	d0,a3
		jmp	loc_4C6F0(pc,d0.w)
; End of function sub_4C6D6

; ---------------------------------------------------------------------------

loc_4C6F0:
		bra.w	loc_4C706
; ---------------------------------------------------------------------------
		bra.w	loc_4C712
; ---------------------------------------------------------------------------
		clr.b	3(a4)
		subq.b	#1,1(a4)
		move.w	#$4400,d2
		bra.s	loc_4C71A
; ---------------------------------------------------------------------------

loc_4C706:
		addq.b	#4,3(a4)
		move.w	#$4000,d2
		bra.w	loc_4C71A
; ---------------------------------------------------------------------------

loc_4C712:
		addq.b	#4,3(a4)
		move.w	#$4200,d2

loc_4C71A:

		move.w	(a1),d0
		move.b	2(a1),d1
		ext.w	d1
		sub.w	d1,(a1)
		move.w	(a1),d3
		andi.w	#$7F8,d0
		andi.w	#$7F8,d3
		cmp.w	d0,d3
		bne.s	loc_4C734
		rts
; ---------------------------------------------------------------------------

loc_4C734:
		bsr.w	sub_4C77C
		lea	($FFFF7C00).l,a1
		move.w	#$1F,d1

loc_4C742:
		move.l	$80(a2),$80(a1)
		move.l	$100(a2),$100(a1)
		move.l	$180(a2),$180(a1)
		move.l	(a2)+,(a1)+
		addq.b	#8,d3
		bne.s	loc_4C766
		addi.w	#$100,d3
		andi.w	#$700,d3
		bsr.w	sub_4C77C

loc_4C766:
		dbf	d1,loc_4C742
		move.l	#$FF7C00,d1
		move.w	#$100,d3
		jsr	(Add_To_DMA_Queue).l
		rts

; =============== S U B R O U T I N E =======================================


sub_4C77C:

		move.w	d3,d0
		lsr.w	#8,d0
		andi.w	#7,d0
		move.b	(a3,d0.w),d0
		andi.w	#7,d0
		ror.w	#7,d0
		lea	(ArtUnc_SlotOptions).l,a2
		adda.w	d0,a2
		move.w	d3,d0
		andi.w	#$F8,d0
		lsr.w	#1,d0
		adda.w	d0,a2
		rts
; End of function sub_4C77C


; =============== S U B R O U T I N E =======================================


sub_4C7A2:
		move.b	5(a4),d2
		move.b	d2,d3
		andi.w	#$F0,d2
		lsr.w	#4,d2
		andi.w	#$F,d3
		moveq	#0,d0
		cmp.b	4(a4),d2
		bne.s	loc_4C7BC
		addq.w	#4,d0

loc_4C7BC:
		cmp.b	4(a4),d3
		bne.s	loc_4C7C4
		addq.w	#8,d0

loc_4C7C4:
		jmp	loc_4C7C8(pc,d0.w)
; End of function sub_4C7A2

; ---------------------------------------------------------------------------

loc_4C7C8:
		bra.w	loc_4C838
; ---------------------------------------------------------------------------
		bra.w	loc_4C80E
; ---------------------------------------------------------------------------
		bra.w	loc_4C7E0
; ---------------------------------------------------------------------------
		move.w	d2,d0
		bsr.w	sub_4C88E
		move.w	d0,4(a4)
		rts
; ---------------------------------------------------------------------------

loc_4C7E0:
		cmpi.b	#0,d3
		bne.s	loc_4C7F6
		move.w	d2,d0
		bsr.w	sub_4C88E
		bsr.w	sub_4C89C
		move.w	d0,4(a4)
		rts
; ---------------------------------------------------------------------------

loc_4C7F6:
		cmpi.b	#0,d2
		bne.w	loc_4C838
		move.w	d3,d0
		bsr.w	sub_4C88E
		bsr.w	sub_4C8A0
		move.w	d0,4(a4)
		rts
; ---------------------------------------------------------------------------

loc_4C80E:
		cmpi.b	#0,d2
		bne.s	loc_4C822
		move.w	d3,d0
		bsr.s	sub_4C88E
		bsr.w	sub_4C89C
		move.w	d0,4(a4)
		rts
; ---------------------------------------------------------------------------

loc_4C822:
		cmpi.b	#0,d3
		bne.w	loc_4C838
		move.w	d2,d0
		bsr.s	sub_4C88E
		bsr.w	sub_4C8A0
		move.w	d0,4(a4)
		rts
; ---------------------------------------------------------------------------

loc_4C838:

		cmp.b	d2,d3
		bne.s	loc_4C86C
		cmpi.b	#0,4(a4)
		bne.s	loc_4C852
		move.w	d2,d0
		bsr.s	sub_4C88E
		bsr.w	sub_4C8A0
		move.w	d0,4(a4)
		rts
; ---------------------------------------------------------------------------

loc_4C852:
		cmpi.b	#0,d2
		bne.s	loc_4C86C
		move.b	4(a4),d0
		andi.w	#$F,d0
		bsr.s	sub_4C88E
		bsr.w	sub_4C89C
		move.w	d0,4(a4)
		rts
; ---------------------------------------------------------------------------

loc_4C86C:

		moveq	#2,d1
		moveq	#0,d0
		cmpi.b	#6,4(a4)
		bne.s	loc_4C87A
		add.w	d1,d0

loc_4C87A:
		cmpi.b	#6,d2
		bne.s	loc_4C882
		add.w	d1,d0

loc_4C882:
		cmpi.b	#6,d3
		bne.s	loc_4C88A
		add.w	d1,d0

loc_4C88A:
		move.w	d0,4(a4)

; =============== S U B R O U T I N E =======================================


sub_4C88E:

		add.w	d0,d0
		lea	(word_4C8A4).l,a2
		move.w	(a2,d0.w),d0
		rts
; End of function sub_4C88E


; =============== S U B R O U T I N E =======================================


sub_4C89C:

		asl.w	#2,d0
		rts
; End of function sub_4C89C


; =============== S U B R O U T I N E =======================================


sub_4C8A0:

		add.w	d0,d0
		rts
; End of function sub_4C8A0

; ---------------------------------------------------------------------------
word_4C8A4:	dc.w $64
		dc.w $1E
		dc.w $14
		dc.w $19
		dc.w $FFFF
		dc.w $A
		dc.w 8
		dc.w $C8
byte_4C8B4:	dc.b	4,   0,	  0
		dc.b	9,   1,	$11
		dc.b	4,   3,	$33
		dc.b  $12,   4,	$44
		dc.b	9,   2,	$22
		dc.b   $F,   5,	$55
		dc.b   $F,   6,	$66
		dc.b  $FF,  $F,	$FF
byte_4C8CC:	dc.b	0,   1,	  2,   5,   4,	 6,   5,   3

byte_4C8D4:	dc.b	0,   1,	  2,   5,   4,	 6,   1,   3
byte_4C8DC:	dc.b	0,   1,	  2,   5,   4,	 6,   3,   5

; =============== S U B R O U T I N E =======================================


sub_4C8E4:

		clr.w	($FFFFFF0E).w
		lea	($FFFFFF10).w,a1
		moveq	#0,d0
		move.w	#$1A,d1

loc_4C8F2:
		move.l	d0,(a1)+
		dbf	d1,loc_4C8F2
		jsr	(Clear_Nem_Queue).l
		move	#$2700,sr
		lea	($C00004).l,a6
		move.w	#-$7FFC,(a6)
		move.w	#-$7DD0,(a6)
		move.w	#-$7BF9,(a6)
		move.w	#-$6FFF,(a6)
		move.w	#-$6E00,(a6)
		move.w	#-$74FD,(a6)
		move.w	#-$78E0,(a6)
		clr.b	($FFFFF64E).w
		clr.b	($FFFFF730).w
		move.w	#-$737F,(a6)
		jsr	(Clear_DisplayData).l
		lea	($FFFFAC00).w,a1
		moveq	#0,d0
		move.w	#$FF,d1

loc_4C940:
		move.l	d0,(a1)+
		dbf	d1,loc_4C940
		lea	($FFFFB000).w,a1
		moveq	#0,d0
		move.w	#$7FF,d1

loc_4C950:
		move.l	d0,(a1)+
		dbf	d1,loc_4C950
		jsr	(Init_SpriteTable).l
		lea	($FFFFFC00).w,a1
		moveq	#0,d0
		move.w	#$3F,d1

loc_4C966:
		move.l	d0,(a1)+
		dbf	d1,loc_4C966
		clr.w	($FFFFFE10).w
		clr.w	($FFFFFB00).w
		move.l	#-$500,($FFFFFBFC).w
		rts
; End of function sub_4C8E4

; ---------------------------------------------------------------------------

BlueSpheresTitle:
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		jsr	(Pal_FadeToBlack).l
		bsr.w	sub_4C8E4
		bsr.w	sub_4CCA6
		lea	($FFFFFC80).w,a2
		bsr.w	sub_4CB1A
		move.l	#$77E00002,($C00004).l
		lea	(ArtNem_BlueSphereText).l,a0
		jsr	(Nem_Decomp).l
		move.l	#$72E00000,($C00004).l
		lea	(ArtNem_BlueSphereSKLogo).l,a0
		jsr	(Nem_Decomp).l
		lea	($FFFF0000).l,a1
		lea	(ArtKos_BlueSphereChar).l,a0
		jsr	(Kos_Decomp).l
		lea	(ArtKos_BlueSphereCharSprite).l,a0
		jsr	(Kos_Decomp).l
		move.w	a1,d3
		lsr.w	#1,d3
		move.l	#$FF0000,d1
		move.w	#0,d2
		jsr	(Add_To_DMA_Queue).l
		lea	($FFFF4000).l,a1
		lea	(ArtKos_BlueSphereNormalText).l,a0
		jsr	(Kos_Decomp).l
		move.l	#$FF4000,d1
		move.w	#-$5640,d2
		move.w	#$6D0,d3
		jsr	(Add_To_DMA_Queue).l
		lea	($FFFF8000).w,a1
		lea	(MapEni_BlueSphereTitleFG).l,a0
		move.w	#$2000,d0
		jsr	(Eni_Decomp).l
		lea	($FFFF8000).w,a1
		move.l	#$43800003,d0
		moveq	#$27,d1
		moveq	#$F,d2
		jsr	(Plane_Map_To_VRAM).l
		lea	($FFFF8000).w,a1
		lea	(MapEni_BlueSphereTitleBG).l,a0
		move.w	#$4197,d0
		jsr	(Eni_Decomp).l
		lea	($FFFF8000).w,a1
		move.l	#$609C0003,d0
		moveq	#$B,d1
		moveq	#7,d2
		jsr	(Plane_Map_To_VRAM).l
		lea	aGetBlueSpheres(pc),a1 ; "GET	BLUE   SPHERES !		 "...
		tst.b	($FFFFFFA1).w
		bne.s	loc_4CA8C
		lea	aNoWayNoWayNoWa(pc),a1 ; "NO WAY!    NO	WAY!	NO WAY!	   NO WAY"...
		move.w	#1,($FFFFFF0A).w
		move.l	#$FFF0FFF8,($FFFFF616).w

loc_4CA8C:
		move.w	#$100,d2
		move.w	#$5BF,d6
		jsr	(sub_5B318).l
		tst.b	($FFFFFFA0).w
		bne.s	loc_4CAA8
		move.l	#$FFF0FFF8,($FFFFF616).w

loc_4CAA8:
		move.l	#Obj_SpheresTitle_4CEAA,($FFFFB000).w
		move.l	#Obj_SpheresTitle_4DA30,($FFFFB04A).w
		move.l	#Obj_SpheresTitle_4D986,($FFFFB094).w
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		moveq	#$28,d0
		jsr	(Play_Sound).l
		move.w	($FFFFF60E).w,d0
		ori.b	#$40,d0
		move.w	d0,($C00004).l
		jsr	(Pal_FadeFromBlack).l

loc_4CAE8:
		move.b	#$1A,($FFFFF62A).w
		jsr	(Process_Kos_Queue).l
		jsr	(Wait_VSync).l
		bsr.w	sub_4CC96
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		jsr	(Process_Kos_Module_Queue).l
		cmpi.b	#$2C,($FFFFF600).w
		beq.s	loc_4CAE8
		rts

; =============== S U B R O U T I N E =======================================


sub_4CB1A:

		lea	(Pal_SpheresTitle_2).l,a1
		tst.b	($FFFFFFAB).w
		bne.s	loc_4CB2C
		lea	(Pal_SpheresTitle_1).l,a1

loc_4CB2C:
		moveq	#$3F,d0

loc_4CB2E:
		move.w	(a1)+,(a2)+
		dbf	d0,loc_4CB2E
		rts
; End of function sub_4CB1A

; ---------------------------------------------------------------------------
Pal_SpheresTitle_1:	binclude "General\Blue Sphere\Palettes\Title 1.bin"

Pal_SpheresTitle_2:	binclude "General\Blue Sphere\Palettes\Title 2.bin"

aNoWayNoWayNoWa:dc.b "NO WAY!    NO WAY!    NO WAY!    NO WAY?   ",0

aGetBlueSpheres:dc.b "GET   BLUE   SPHERES !                            ",0


		dc.b   0 ;

; =============== S U B R O U T I N E =======================================


sub_4CC96:
		lea	($FFFFE000).w,a1
		moveq	#$3F,d1

loc_4CC9C:
		subq.w	#2,(a1)
		addq.w	#4,a1
		dbf	d1,loc_4CC9C
		rts
; End of function sub_4CC96


; =============== S U B R O U T I N E =======================================


sub_4CCA6:
		lea	(aGm000010090).l,a1 ; "GM 00001009-0"
		moveq	#3,d1

loc_4CCAE:
	if Sonic3_Complete=0
		lea	(LockonSerialNumber).l,a0
	else
		lea	(LockOnROM_Start+$180).l,a0
	endif
		moveq	#0,d3
		moveq	#$C,d2

loc_4CCB8:
		move.b	(a1)+,d0
		cmp.b	(a0)+,d0
		beq.s	loc_4CCC0
		moveq	#1,d3

loc_4CCC0:
		dbf	d2,loc_4CCB8
		tst.b	d3
		beq.s	loc_4CCDC
		dbf	d1,loc_4CCAE
		move.b	#0,($FFFFFFA0).w
		move.b	#-1,($FFFFFFAB).w
		bsr.s	sub_4CD18

locret_4CCDA:
		rts
; ---------------------------------------------------------------------------

loc_4CCDC:
		move.b	#1,($FFFFFFA0).w
		tst.b	($FFFFFFA1).w
		bne.s	locret_4CCDA
		clr.b	($FFFFFFAB).w
		move.l	#0,($FFFFFFA6).w
		move.l	#$10203,($FFFFFFA2).w
		rts
; End of function sub_4CCA6

; ---------------------------------------------------------------------------
aGm000010090:	dc.b "GM 00001009-0"
aGm000040490:	dc.b "GM 00004049-0"

; =============== S U B R O U T I N E =======================================


sub_4CD18:
	if Sonic3_Complete=0
		lea	(LockonSerialNumber).l,a1
	else
		lea	(LockOnROM_Start+$180).l,a1
	endif
		moveq	#$A,d1

loc_4CD20:
		move.b	(a1),d0
		subi.b	#$30,d0
		beq.s	loc_4CD2E
		cmpi.b	#$A,d0
		bcs.s	loc_4CD34

loc_4CD2E:
		addq.w	#1,a1
		dbf	d1,loc_4CD20

loc_4CD34:
		moveq	#0,d2

loc_4CD36:
		move.b	(a1)+,d0
		subi.b	#$30,d0
		cmpi.b	#$A,d0
		bcc.s	loc_4CD4C
		andi.b	#$F,d0
		mulu.w	#$A,d2
		add.w	d0,d2

loc_4CD4C:
		dbf	d1,loc_4CD36
		andi.w	#$7FFF,d2
		moveq	#0,d6
		move.w	d2,d6
		andi.w	#$3F,d6
		lea	(a_jan).l,a2	; ".JAN"
	if Sonic3_Complete=0
		move.l	(LockonDate).l,d0
	else
		move.l	(LockOnROM_Start+$11C).l,d0
	endif
		moveq	#$E,d1

loc_4CD6A:
		cmp.l	(a2)+,d0
		dbeq	d1,loc_4CD6A
		subi.w	#$E,d1
		neg.w	d1
		andi.w	#$F,d1
		lsl.w	#4,d6
		or.b	d1,d6
		move.w	d2,d0
		lsr.w	#6,d0
		andi.w	#$F,d0
		lsl.w	#4,d6
		or.b	d0,d6
	if Sonic3_Complete=0
		move.b	(SSMagic_TestLoc_200150).l,d1
	else
		move.b	(LockOnROM_Start+$150).l,d1
	endif
		andi.b	#1,d1
		lsl.l	#1,d6
		or.b	d1,d6
	if Sonic3_Complete=0
		lea	(SSMagic_TestLoc_20011A).l,a1
	else
		lea	(LockOnROM_Start+$11A).l,a1
	endif
		moveq	#0,d0
		move.b	(a1)+,d0
		subi.b	#$30,d0
		mulu.w	#$A,d0
		move.b	(a1)+,d1
		subi.b	#$30,d1
		add.b	d1,d0
		subi.b	#$58,d0
		andi.b	#7,d0
		lsl.l	#3,d6
		or.b	d0,d6
		rol.w	#6,d2
		andi.w	#$1F,d2
		lsl.l	#5,d6
		or.b	d2,d6
	if Sonic3_Complete=0
		move.w	(SSMagic_TestLoc_2001A4).l,d0
	else
		move.w	(LockOnROM_Start+$1A4).l,d0
	endif
		lsr.b	#3,d0
		andi.b	#3,d0
		lsl.l	#2,d6
		or.b	d0,d6
		moveq	#0,d1
	if Sonic3_Complete=0
		cmpi.w	#$4547,(SSMagic_TestLoc_200114).l
	else
		cmpi.w	#$4547,(LockOnROM_Start+$114).l
	endif
		beq.s	loc_4CDE6
		moveq	#1,d1

loc_4CDE6:
		lsl.l	#1,d6
		or.b	d1,d6
		move.b	($FFFFFF9F).w,d1
		andi.b	#1,d1
		lsl.l	#1,d6
		or.b	d1,d6
		andi.l	#$7FFFFFF,d6
		move.l	d6,($FFFFFFA6).w
		lea	($FFFFFFA2).w,a2
		move.l	d6,d0
		andi.b	#$7F,d0
		move.b	d0,(a2)+
		move.l	d6,d0
		add.l	d0,d0
		add.l	d6,d0
		addq.l	#1,d0
		moveq	#0,d2
		swap	d0
		move.w	d0,d2
		swap	d0
		divu.w	#$7F,d2
		move.w	d0,d2
		divu.w	#$7F,d2
		swap	d2
		move.b	d2,(a2)+
		move.l	d6,d0
		add.l	d0,d0
		add.l	d0,d0
		add.l	d6,d0
		addq.l	#2,d0
		moveq	#0,d2
		swap	d0
		move.w	d0,d2
		swap	d0
		divu.w	#$7E,d2
		move.w	d0,d2
		divu.w	#$7E,d2
		swap	d2
		move.b	d2,(a2)+
		move.l	d6,d0
		add.l	d0,d0
		add.l	d6,d0
		add.l	d0,d0
		add.l	d6,d0
		addq.l	#3,d0
		moveq	#0,d2
		swap	d0
		move.w	d0,d2
		swap	d0
		divu.w	#$7D,d2
		move.w	d0,d2
		divu.w	#$7D,d2
		swap	d2
		move.b	d2,(a2)+
		rts
; End of function sub_4CD18

; ---------------------------------------------------------------------------
a_jan:		dc.b ".JAN"
a_feb:		dc.b ".FEB"
a_mar:		dc.b ".MAR"
a_apr:		dc.b ".APR"
a_may:		dc.b ".MAY"
a_jun:		dc.b ".JUN"
a_jul:		dc.b ".JUL"
a_aug:		dc.b ".AUG"
a_sep:		dc.b ".SEP"
a_oct:		dc.b ".OCT"
a_nov:		dc.b ".NOV"
a_dec:		dc.b ".DEC"
a_:		dc.b ".   "
		dc.b "    "
a____:		dc.b "...."
; ---------------------------------------------------------------------------

Obj_SpheresTitle_4CEAA:
		tst.b	($FFFFFFA1).w
		bne.s	loc_4CEF8
		move.l	#loc_4CEB6,(a0)

loc_4CEB6:
		tst.b	(Vectors).w
		bne.s	locret_4CEC6
		move.b	($FFFFF604).w,d0
		cmpi.b	#$70,d0
		beq.s	loc_4CEC8

locret_4CEC6:
		rts
; ---------------------------------------------------------------------------

loc_4CEC8:
		clr.b	($FFFFF605).w
		moveq	#-1,d0
		move.w	d0,($FFFFE438).w
		move.w	d0,($FFFFE442).w
		moveq	#$63,d0
		jsr	(Play_Sound_2).l
		move	#$2700,sr
		lea	aGetBlueSpheres(pc),a1 ; "GET	BLUE   SPHERES !		 "...
		move.w	#$100,d2
		move.w	#$5BF,d6
		jsr	(sub_5B318).l
		move	#$2300,sr

loc_4CEF8:
		move.l	#loc_4CF82,(a0)
		move.l	#Obj_SpheresTitle_4D03E,($FFFFB1BC).w
		move.w	#$C0,($FFFFB1D0).w
		move.b	#1,($FFFFFFA1).w
		move.b	#0,($FFFFFFAA).w
		move.l	#Obj_SpheresTitle_4D64E,($FFFFBD4C).w
		move.l	#Obj_SpheresTitle_4D64E,($FFFFBD96).w
		bset	#0,($FFFFBD9A).w
		tst.b	($FFFFFFA0).w
		beq.s	loc_4CF66
		move.w	#$B0,($FFFFB1D0).w
		move.l	#Obj_SpheresTitle_4D2F4,($FFFFB534).w
		move.w	#$144,($FFFFB548).w
		move.l	#Obj_SpheresTitle_4D302,($FFFFB8F6).w
		move.w	#$144,($FFFFB90A).w
		move.l	#Obj_SpheresTitle_4D610,($FFFFBD02).w
		move.b	#1,($FFFFFFAA).w
		rts
; ---------------------------------------------------------------------------

loc_4CF66:
		tst.w	($FFFFE438).w
		bne.s	locret_4CF80
		tst.w	($FFFFE442).w
		bne.s	locret_4CF80
		move.l	#Obj_SpheresTitle_4D302,($FFFFB8F6).w
		move.w	#$144,($FFFFB90A).w

locret_4CF80:

		rts
; ---------------------------------------------------------------------------

loc_4CF82:
		tst.b	($FFFFFFA0).w
		beq.w	loc_4D008
		tst.w	($FFFFF616).w
		beq.s	loc_4CFB2
		addq.w	#1,($FFFFF616).w
		btst	#0,($FFFFF617).w
		bne.s	loc_4CFA0
		addq.w	#1,($FFFFF618).w

loc_4CFA0:
		lea	($FFFFB094).w,a1
		moveq	#3,d1

loc_4CFA6:
		subq.w	#1,$14(a1)
		lea	$4A(a1),a1
		dbf	d1,loc_4CFA6

loc_4CFB2:
		tst.b	($FFFFFFA1).w
		bmi.s	loc_4D000
		move.b	($FFFFF605).w,d1
		btst	#0,d1
		beq.s	loc_4CFD4
		tst.b	($FFFFFFAA).w
		beq.s	loc_4CFD4
		subq.b	#1,($FFFFFFAA).w
		moveq	#-$77,d0
		jsr	(Play_Sound_2).l

loc_4CFD4:

		btst	#1,d1
		beq.s	loc_4D000
		cmpi.b	#2,($FFFFFFAA).w
		bcc.s	loc_4D000
		addq.b	#1,($FFFFFFAA).w
		moveq	#-$77,d0
		jsr	(Play_Sound_2).l
		cmpi.b	#2,($FFFFFFAA).w
		bne.s	loc_4D000
		ori.b	#-$80,($FFFFFFA1).w
		clr.b	($FFFFF605).w

loc_4D000:

		cmpi.b	#1,($FFFFFFAA).w
		bne.s	locret_4D03C

loc_4D008:
		move.b	($FFFFF605).w,d0
		cmpi.b	#-$80,d0
		bne.s	locret_4D03C
		move.b	#0,($FFFFFE48).w
		move.b	#1,($FFFFFFD4).w
		move.w	($FFFFFF0A).w,($FFFFFF08).w
		move.b	#3,($FFFFFE12).w
		move.b	#0,($FFFFFFBB).w
		move.b	#0,($FFFFFE16).w
		move.b	#$34,($FFFFF600).w

locret_4D03C:

		rts
; ---------------------------------------------------------------------------

Obj_SpheresTitle_4D03E:

		move.l	#Map_BlueSpheresText,$C(a0)
		move.w	#-$7AB2,$A(a0)
		move.w	#$120,$10(a0)
		move.w	#$80,8(a0)
		move.b	#$14,7(a0)
		move.b	#8,6(a0)
		move.w	$14(a0),d3
		addi.w	#$10,d3
		movea.l	a0,a1
		move.b	#$A,$6C(a1)
		move.w	#$F7,d2
		moveq	#$A,d1

loc_4D07A:
		lea	$4A(a1),a1
		move.l	#loc_4D5B4,(a1)
		move.w	d2,$10(a1)
		move.w	d3,$14(a1)
		addq.w	#8,d2
		dbf	d1,loc_4D07A
		move.b	#$B,$22(a1)
		move.l	#loc_4D09E,(a0)

loc_4D09E:
		tst.b	($FFFFFFA0).w
		beq.s	loc_4D0B0
		tst.b	($FFFFFFAA).w
		bne.s	loc_4D0D4
		tst.b	($FFFFFFAB).w
		bne.s	loc_4D0DA

loc_4D0B0:

		move.l	($FFFFFFA2).w,d1
		lsl.b	#1,d1
		lsl.w	#1,d1
		swap	d1
		lsl.b	#1,d1
		lsr.w	#1,d1
		swap	d1
		lsr.l	#2,d1
		andi.l	#$FFFFFFF,d1
		bsr.w	sub_4D0F6
		move.b	#1,$22(a0)
		bra.s	loc_4D0F0
; ---------------------------------------------------------------------------

loc_4D0D4:
		tst.b	($FFFFFFAB).w
		bne.s	loc_4D0B0

loc_4D0DA:
		move.l	($FFFFFFA6).w,d1
		addq.l	#1,d1
		andi.l	#$7FFFFFF,d1
		bsr.w	sub_4D13A
		move.b	#0,$22(a0)

loc_4D0F0:
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_4D0F6:
		andi.l	#$FFFFFFF,d1
		movea.l	a0,a1
		lea	$4A(a1),a1
		lea	dword_4D21C(pc),a2
		moveq	#8,d6

loc_4D108:
		lea	$4A(a1),a1
		moveq	#0,d2
		move.l	(a2)+,d3

loc_4D110:
		sub.l	d3,d1
		bcs.s	loc_4D118
		addq.w	#1,d2
		bra.s	loc_4D110
; ---------------------------------------------------------------------------

loc_4D118:
		add.l	d3,d1
		move.b	d2,$22(a1)
		dbf	d6,loc_4D108
		move.w	#$F7,d2
		moveq	#$A,d1
		movea.l	a0,a1

loc_4D12A:
		lea	$4A(a1),a1
		move.w	d2,$10(a1)
		addq.w	#8,d2
		dbf	d1,loc_4D12A
		rts
; End of function sub_4D0F6


; =============== S U B R O U T I N E =======================================


sub_4D13A:
		andi.l	#$7FFFFFF,d1
		movea.l	a0,a1
		lea	$4A(a1),a1
		lea	dword_4D21C(pc),a2
		moveq	#8,d6
		moveq	#0,d4

loc_4D14E:
		lea	$4A(a1),a1
		moveq	#0,d2
		move.l	(a2)+,d3

loc_4D156:
		sub.l	d3,d1
		bcs.s	loc_4D15E
		addq.w	#1,d2
		bra.s	loc_4D156
; ---------------------------------------------------------------------------

loc_4D15E:
		add.l	d3,d1
		tst.w	d2
		beq.s	loc_4D16C
		tst.w	d4
		bne.s	loc_4D16C
		move.w	d6,d4
		addq.w	#1,d4

loc_4D16C:

		tst.w	d4
		bne.s	loc_4D172
		moveq	#$A,d2

loc_4D172:
		move.b	d2,$22(a1)
		dbf	d6,loc_4D14E
		move.w	#$F7,d2
		move.w	d4,d0
		subi.w	#9,d0
		neg.w	d0
		move.w	d0,d1
		lsl.w	#2,d0
		add.w	d0,d2
		movea.l	a0,a1

loc_4D18E:
		lea	$4A(a1),a1
		move.w	d2,$10(a1)
		dbf	d1,loc_4D18E

loc_4D19A:
		lea	$4A(a1),a1
		addq.w	#8,d2
		move.w	d2,$10(a1)
		dbf	d4,loc_4D19A
		rts
; End of function sub_4D13A


; =============== S U B R O U T I N E =======================================


sub_4D1AA:
		andi.l	#$FF,d1
		movea.l	a0,a1
		lea	$4A(a1),a1
		lea	dword_4D238(pc),a2
		moveq	#1,d6
		moveq	#0,d4

loc_4D1BE:
		lea	$4A(a1),a1
		moveq	#0,d2
		move.l	(a2)+,d3

loc_4D1C6:
		sub.l	d3,d1
		bcs.s	loc_4D1CE
		addq.w	#1,d2
		bra.s	loc_4D1C6
; ---------------------------------------------------------------------------

loc_4D1CE:
		add.l	d3,d1
		tst.w	d2
		beq.s	loc_4D1DC
		tst.w	d4
		bne.s	loc_4D1DC
		move.w	d6,d4
		addq.w	#1,d4

loc_4D1DC:

		tst.w	d4
		bne.s	loc_4D1E2
		moveq	#$A,d2

loc_4D1E2:
		move.b	d2,$22(a1)
		dbf	d6,loc_4D1BE
		move.w	#$113,d2
		move.w	d4,d0
		subq.w	#2,d0
		neg.w	d0
		move.w	d0,d1
		lsl.w	#2,d0
		add.w	d0,d2
		movea.l	a0,a1

loc_4D1FC:
		lea	$4A(a1),a1
		move.w	d2,$10(a1)
		dbf	d1,loc_4D1FC

loc_4D208:
		lea	$4A(a1),a1
		addq.w	#8,d2
		move.w	d2,$10(a1)
		dbf	d4,loc_4D208
		rts
; End of function sub_4D1AA

; ---------------------------------------------------------------------------
		dc.l $3B9ACA00
dword_4D21C:	dc.l $5F5E100
		dc.l $989680
		dc.l $F4240
		dc.l $186A0
		dc.l $2710
		dc.l $3E8
		dc.l $64
dword_4D238:	dc.l $A
		dc.l 1
; ---------------------------------------------------------------------------

loc_4D240:
		moveq	#$B,d6
		lea	word_4D294(pc),a2

loc_4D246:
		lea	$4A(a1),a1
		moveq	#0,d4
		move.w	(a2)+,d2
		move.l	(a2)+,d3

loc_4D250:
		sub.l	d3,d1
		subx.w	d2,d0
		bcs.s	loc_4D25A
		addq.w	#1,d4
		bra.s	loc_4D250
; ---------------------------------------------------------------------------

loc_4D25A:
		add.l	d3,d1
		addx.w	d2,d0
		move.b	d4,$22(a1)
		dbf	d6,loc_4D246
		rts
; ---------------------------------------------------------------------------

loc_4D268:
		movea.l	a0,a1
		moveq	#0,d0
		moveq	#0,d1
		moveq	#$B,d6
		lea	word_4D294(pc),a2

loc_4D274:
		lea	$4A(a1),a1
		moveq	#0,d4
		move.b	$22(a1),d4
		move.w	(a2)+,d2
		move.l	(a2)+,d3
		subq.w	#1,d4
		bcs.s	loc_4D28E

loc_4D286:
		add.l	d3,d1
		addx.w	d2,d0
		dbf	d4,loc_4D286

loc_4D28E:
		dbf	d6,loc_4D274
		rts
; ---------------------------------------------------------------------------
word_4D294:	dc.w $17

		dc.l $4876E800
		dc.w 2
		dc.l $540BE400
		dc.w 0
		dc.l $3B9ACA00
		dc.w 0
		dc.l $5F5E100
		dc.w 0
		dc.l $989680
		dc.w 0
		dc.l $F4240
		dc.w 0
		dc.l $186A0
		dc.w 0
		dc.l $2710
		dc.w 0
		dc.l $3E8
		dc.w 0
		dc.l $64
		dc.w 0
		dc.l $A
		dc.w 0
		dc.l 1
word_4D2DC:	dc.w $10C
		dc.w $114
		dc.w $11C
		dc.w $124
		dc.w $134
		dc.w $13C
		dc.w $144
		dc.w $14C
		dc.w $15C
		dc.w $164
		dc.w $16C
		dc.w $174
; ---------------------------------------------------------------------------

Obj_SpheresTitle_4D2F4:
		move.l	#loc_4D3CE,(a0)
		move.l	#loc_4D5FA,d2
		bra.s	loc_4D30E
; ---------------------------------------------------------------------------

Obj_SpheresTitle_4D302:

		move.l	#loc_4D362,(a0)
		move.l	#loc_4D5E4,d2

loc_4D30E:
		move.l	#Map_BlueSpheresText,$C(a0)
		move.w	#-$7AB2,$A(a0)
		move.w	#$D4,$10(a0)
		move.w	#$80,8(a0)
		move.b	#$14,7(a0)
		move.b	#8,6(a0)
		move.b	#2,$22(a0)
		lea	word_4D2DC(pc),a2
		movea.l	a0,a1
		moveq	#$B,d1

loc_4D342:
		lea	$4A(a1),a1
		move.l	d2,(a1)
		move.w	(a2)+,$10(a1)
		subi.w	#$C,$10(a1)
		move.w	$14(a0),$14(a1)
		dbf	d1,loc_4D342
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_4D362:
		tst.b	($FFFFFFA1).w
		bpl.s	loc_4D36A
		rts
; ---------------------------------------------------------------------------

loc_4D36A:
		lea	($FFFFE400).w,a2
		move.l	($FFFFFFA6).w,(a2)
		tst.b	($FFFFFFAB).w
		beq.s	loc_4D37E
		addi.l	#$7654321,(a2)

loc_4D37E:
		andi.l	#$7FFFFFF,(a2)
		moveq	#1,d6
		bsr.w	sub_4D5A0
		move.w	d4,d0
		andi.w	#$3F,d0
		tst.b	($FFFFFFAB).w
		beq.s	loc_4D39A
		ori.w	#$40,d0

loc_4D39A:
		eori.w	#$55,d0
		move.l	($FFFFFFA6).w,d1
		addi.l	#$1234567,d1
		andi.l	#$7FFFFFF,d1
		swap	d1
		lsl.w	#5,d4
		andi.w	#-$800,d4
		or.w	d4,d1
		swap	d1
		ror.l	#6,d1
		eori.l	#-$55555556,d1
		movea.l	a0,a1
		bsr.w	loc_4D240
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_4D3CE:
		tst.b	($FFFFFFA1).w
		bmi.s	loc_4D3DC
		move.w	#0,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_4D3DC:
		move.b	($FFFFF605).w,d0
		cmpi.b	#-$80,d0
		bne.s	loc_4D3EA
		bsr.w	sub_4D488

loc_4D3EA:
		movea.l	a0,a1
		move.w	$30(a0),d0
		addq.w	#1,d0
		mulu.w	#$4A,d0
		adda.w	d0,a1
		move.w	#-$7AB2,$A(a1)
		move.b	($FFFFF605).w,d1
		btst	#0,d1
		beq.s	loc_4D414
		subq.b	#1,$22(a1)
		bcc.s	loc_4D414

loc_4D40E:
		move.b	#9,$22(a1)

loc_4D414:

		btst	#1,d1
		beq.s	loc_4D42C
		addq.b	#1,$22(a1)
		cmpi.b	#$A,$22(a1)
		bcs.s	loc_4D42C
		move.b	#0,$22(a1)

loc_4D42C:

		btst	#2,d1
		beq.s	loc_4D43E
		subq.w	#1,$30(a0)
		bcc.s	loc_4D43E
		move.w	#$B,$30(a0)

loc_4D43E:

		btst	#3,d1
		beq.s	loc_4D456
		addq.w	#1,$30(a0)
		cmpi.w	#$C,$30(a0)
		bcs.s	loc_4D456
		move.w	#0,$30(a0)

loc_4D456:

		tst.b	($FFFFFFA1).w
		bpl.s	loc_4D470
		movea.l	a0,a1
		move.w	$30(a0),d0
		addq.w	#1,d0
		mulu.w	#$4A,d0
		adda.w	d0,a1
		move.w	#-$7A9E,$A(a1)

loc_4D470:
		move.b	($FFFFF605).w,d1
		andi.b	#$F,d1
		beq.s	loc_4D482
		moveq	#-$77,d0
		jsr	(Play_Sound_2).l

loc_4D482:
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_4D488:
		bsr.w	loc_4D268
		eori.w	#$55,d0
		move.w	d0,d2
		andi.w	#$3F,d0
		eori.l	#-$55555556,d1
		rol.l	#6,d1
		swap	d1
		move.w	d1,d3
		andi.w	#-$800,d3
		lsr.w	#5,d3
		or.w	d0,d3
		andi.w	#$7FF,d3
		swap	d1
		subi.l	#$1234567,d1
		andi.w	#$40,d2
		beq.s	loc_4D4C2
		addi.l	#$7654321,d1

loc_4D4C2:
		andi.l	#$7FFFFFF,d1
		move.l	d1,($FFFFE400).w
		lea	($FFFFE400).w,a2
		moveq	#1,d6
		bsr.w	sub_4D5A0
		andi.w	#$7FF,d4
		cmp.w	d4,d3
		bne.w	loc_4D58A
		move.b	#0,($FFFFFFAB).w
		tst.w	d2
		beq.s	loc_4D4FC
		subi.l	#$7654321,d1
		andi.l	#$7FFFFFF,d1
		move.b	#-1,($FFFFFFAB).w

loc_4D4FC:
		move.l	d1,($FFFFFFA6).w
		lea	($FFFFFFA2).w,a2
		move.l	d1,d0
		andi.b	#$7F,d0
		move.b	d0,(a2)+
		move.l	d1,d0
		add.l	d0,d0
		add.l	d1,d0
		addq.l	#1,d0
		moveq	#0,d2
		swap	d0
		move.w	d0,d2
		swap	d0
		divu.w	#$7F,d2
		move.w	d0,d2
		divu.w	#$7F,d2
		swap	d2
		move.b	d2,(a2)+
		move.l	d1,d0
		add.l	d0,d0
		add.l	d0,d0
		add.l	d1,d0
		addq.l	#2,d0
		moveq	#0,d2
		swap	d0
		move.w	d0,d2
		swap	d0
		divu.w	#$7E,d2
		move.w	d0,d2
		divu.w	#$7E,d2
		swap	d2
		move.b	d2,(a2)+
		move.l	d1,d0
		add.l	d0,d0
		add.l	d1,d0
		add.l	d0,d0
		add.l	d1,d0
		addq.l	#3,d0
		moveq	#0,d2
		swap	d0
		move.w	d0,d2
		swap	d0
		divu.w	#$7D,d2
		move.w	d0,d2
		divu.w	#$7D,d2
		swap	d2
		move.b	d2,(a2)+
		lea	($FFFFFC00).w,a2
		bsr.w	sub_4CB1A
		moveq	#$63,d0
		jsr	(Play_Sound_2).l
		andi.b	#$7F,($FFFFFFA1).w
		move.b	#1,($FFFFFFAA).w
		rts
; ---------------------------------------------------------------------------

loc_4D58A:
		moveq	#-$4E,d0
		jsr	(Play_Sound_2).l
		andi.b	#$7F,($FFFFFFA1).w
		move.b	#1,($FFFFFFAA).w
		rts
; End of function sub_4D488


; =============== S U B R O U T I N E =======================================


sub_4D5A0:

		moveq	#0,d4

loc_4D5A2:
		move.w	(a2)+,d5
		eor.w	d5,d4
		lsr.w	#1,d4
		bcc.s	loc_4D5AE
		eori.w	#-$77F0,d4

loc_4D5AE:
		dbf	d6,loc_4D5A2
		rts
; End of function sub_4D5A0

; ---------------------------------------------------------------------------

loc_4D5B4:
		bsr.s	sub_4D5C2
		move.l	#loc_4D5BC,(a0)

loc_4D5BC:
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_4D5C2:

		move.l	#Map_BlueSpheresNum,$C(a0)
		move.w	#-$7AB2,$A(a0)
		move.w	#$80,8(a0)
		move.b	#8,7(a0)
		move.b	#8,6(a0)
		rts
; End of function sub_4D5C2

; ---------------------------------------------------------------------------

loc_4D5E4:
		bsr.s	sub_4D5C2
		move.l	#loc_4D5EC,(a0)

loc_4D5EC:
		tst.b	($FFFFFFA1).w
		bpl.s	loc_4D5F4
		rts
; ---------------------------------------------------------------------------

loc_4D5F4:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_4D5FA:
		bsr.s	sub_4D5C2
		move.l	#loc_4D602,(a0)

loc_4D602:
		tst.b	($FFFFFFA1).w
		bmi.s	loc_4D60A
		rts
; ---------------------------------------------------------------------------

loc_4D60A:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_SpheresTitle_4D610:
		move.l	#Map_BlueSpheresText,$C(a0)
		move.w	#-$7AB2,$A(a0)
		move.w	#$120,$10(a0)
		move.w	#$128,$14(a0)
		move.w	#$80,8(a0)
		move.b	#$14,7(a0)
		move.b	#8,6(a0)
		move.b	#3,$22(a0)
		move.l	#loc_4D648,(a0)

loc_4D648:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_SpheresTitle_4D64E:

		move.l	#Map_BlueSpheresIcon,$C(a0)
		move.w	#-$1A68,$A(a0)
		cmpi.w	#3,($FFFFFF0A).w
		bne.s	loc_4D66A
		move.w	#-$7A68,$A(a0)

loc_4D66A:
		move.w	#$100,$10(a0)
		move.w	#$126,$14(a0)
		tst.b	($FFFFFFA0).w
		bne.s	loc_4D682
		move.w	#$BE,$14(a0)

loc_4D682:
		move.l	#word_4D7A6,$30(a0)
		btst	#0,4(a0)
		beq.s	loc_4D6A0
		move.w	#$140,$10(a0)
		move.l	#word_4D7B2,$30(a0)

loc_4D6A0:
		move.w	#0,8(a0)
		move.b	#8,7(a0)
		move.b	#8,6(a0)
		move.l	#loc_4D6B8,(a0)

loc_4D6B8:
		tst.b	($FFFFFFA0).w
		beq.w	loc_4D75E
		movea.l	$30(a0),a1
		moveq	#0,d0
		move.b	($FFFFFFAA).w,d0
		lsl.w	#2,d0
		move.w	(a1,d0.w),d2
		move.w	2(a1,d0.w),d3
		cmp.w	$10(a0),d2
		bne.s	loc_4D6F0
		move.w	$18(a0),d0
		addi.w	#$80,d0
		cmpi.w	#$100,d0
		bhi.s	loc_4D6F0
		moveq	#0,d1
		move.w	d1,$18(a0)
		bra.s	loc_4D712
; ---------------------------------------------------------------------------

loc_4D6F0:

		move.w	#$40,d1
		cmp.w	$10(a0),d2
		bge.s	loc_4D708
		neg.w	d1
		tst.w	$18(a0)
		bmi.s	loc_4D712
		add.w	d1,d1
		add.w	d1,d1
		bra.s	loc_4D712
; ---------------------------------------------------------------------------

loc_4D708:
		tst.w	$18(a0)
		bpl.s	loc_4D712
		add.w	d1,d1
		add.w	d1,d1

loc_4D712:

		add.w	d1,$18(a0)
		cmp.w	$14(a0),d3
		bne.s	loc_4D732
		move.w	$1A(a0),d0
		addi.w	#$100,d0
		cmpi.w	#$200,d0
		bhi.s	loc_4D732
		moveq	#0,d1
		move.w	d1,$1A(a0)
		bra.s	loc_4D754
; ---------------------------------------------------------------------------

loc_4D732:

		move.w	#$80,d1
		cmp.w	$14(a0),d3
		bge.s	loc_4D74A
		neg.w	d1
		tst.w	$1A(a0)
		bmi.s	loc_4D754
		add.w	d1,d1
		add.w	d1,d1
		bra.s	loc_4D754
; ---------------------------------------------------------------------------

loc_4D74A:
		tst.w	$1A(a0)
		bpl.s	loc_4D754
		add.w	d1,d1
		add.w	d1,d1

loc_4D754:

		add.w	d1,$1A(a0)
		jsr	(MoveSprite2).l

loc_4D75E:
		subq.b	#1,$24(a0)
		bpl.s	loc_4D774
		move.b	#2,$24(a0)
		addq.b	#1,$22(a0)
		andi.b	#7,$22(a0)

loc_4D774:
		move.b	($FFFFF605).w,d0
		andi.b	#$70,d0
		beq.s	loc_4D7A0
		move.w	$A(a0),d0
		move.w	#3,($FFFFFF0A).w
		move.w	#-$7A68,$A(a0)
		cmpi.w	#-$7A68,d0
		bne.s	loc_4D7A0
		move.w	#1,($FFFFFF0A).w
		move.w	#-$1A68,$A(a0)

loc_4D7A0:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
word_4D7A6:	dc.w   $100,   $AE
		dc.w   $100,  $126
		dc.w	$C8,  $142
word_4D7B2:	dc.w   $140,   $AE
		dc.w   $140,  $126
		dc.w   $178,  $142
Map_BlueSpheresText:	include "General\Blue Sphere\Map - Text.asm"

Map_BlueSpheresNum:	include "General\Blue Sphere\Map - Numbers.asm"

Map_BlueSpheresIcon:	include "General\Blue Sphere\Map - Rotating Icon.asm"

word_4D976:	dc.w	$B8,  $100

		dc.w   $10C,   $F8
		dc.w   $130,   $F4
		dc.w   $178,   $E0
; ---------------------------------------------------------------------------

Obj_SpheresTitle_4D986:
		lea	word_4D976(pc),a2
		movea.l	a0,a1
		moveq	#3,d1

loc_4D98E:
		move.l	#Map_BlueSphereCharSprite,$C(a1)
		move.w	#$20FE,$A(a1)
		move.w	(a2)+,$10(a1)
		move.w	(a2)+,$14(a1)
		tst.b	($FFFFFFA1).w
		beq.s	loc_4D9B6
		tst.b	($FFFFFFA0).w
		beq.s	loc_4D9B6
		subi.w	#$10,$14(a1)

loc_4D9B6:

		move.w	#$180,8(a1)
		move.b	#$10,7(a1)
		move.b	#$10,6(a1)
		move.l	#loc_4D9EC,(a1)
		move.b	d1,$20(a1)
		move.w	d1,d0
		add.w	d0,d0
		lea	(Ani_BlueSphereCharSprite).l,a3
		adda.w	(a3,d0.w),a3
		move.b	(a3),$22(a1)
		lea	$4A(a1),a1
		dbf	d1,loc_4D98E

loc_4D9EC:
		tst.b	($FFFFFFA0).w
		beq.s	loc_4D9FE
		lea	(Ani_BlueSphereCharSprite).l,a1
		jsr	(Animate_SpriteIrregularDelay).l

loc_4D9FE:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Ani_BlueSphereCharSprite:	include "General\Blue Sphere\Anim - Character Sprites.asm"

; ---------------------------------------------------------------------------

Obj_SpheresTitle_4DA30:
		move.l	#Map_BlueSpheresCopyright,$C(a0)
		move.w	#-$7A4E,$A(a0)
		move.w	#$180,$10(a0)
		move.w	#$152,$14(a0)
		move.w	#$80,8(a0)
		move.b	#$2C,7(a0)
		move.b	#4,6(a0)
		move.l	#loc_4DA62,(a0)

loc_4DA62:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Map_BlueSpheresCopyright:	include "General\Blue Sphere\Map - Copyright.asm"

; ---------------------------------------------------------------------------

BlueSpheresResults:
		moveq	#-$1F,d0

loc_4DA80:
		jsr	(Play_Sound).l
		bsr.w	sub_4C8E4
		lea	(Pal_SphereResults_012).l,a1
		lea	($FFFFFC80).w,a2
		moveq	#$3F,d0

loc_4DA96:
		move.w	(a1)+,(a2)+
		dbf	d0,loc_4DA96
		lea	($FFFF0000).l,a1

loc_4DAA2:
		lea	(ArtKos_SSResultsGeneral).l,a0
		jsr	(Kos_Decomp).l
		lea	(ArtKos_SSResultsTKIcons).l,a0
		jsr	(Kos_Decomp).l
		move.w	a1,d3
		lsr.w	#1,d3
		move.l	#$FF0000,d1
		move.w	#$3B80,d2
		jsr	(Add_To_DMA_Queue).l
		lea	($FFFF4000).l,a1
		lea	(ArtKos_BlueSphereNormalText).l,a0
		jsr	(Kos_Decomp).l
		move.l	#$FF4000,d1
		move.w	#-$5640,d2
		move.w	#$6D0,d3
		jsr	(Add_To_DMA_Queue).l
		move.l	#$77E00002,($C00004).l
		lea	(ArtNem_BlueSphereText).l,a0

loc_4DB04:
		jsr	(Nem_Decomp).l
		move.l	#$72E00000,($C00004).l
		lea	(ArtNem_BlueSphereSKLogo).l,a0
		jsr	(Nem_Decomp).l
		lea	aCongratulation(pc),a1 ; "CONGRATULATIONS!"
		move.w	#$30A,d2
		move.w	#-$7A41,d6
		jsr	(sub_5B318).l
		lea	($FFFF8000).w,a1
		lea	(MapEni_BlueSphereTitleBG).l,a0
		move.w	#$6197,d0
		jsr	(Eni_Decomp).l
		bsr.w	sub_4DEA2
		move.b	#1,($FFFFFFAA).w
		move.l	#Obj_SphereResults_4DEF8,($FFFFB000).w
		move.l	#Obj_SphereResults_4DF86,($FFFFB04A).w
		move.l	#Obj_SpheresTitle_4D03E,($FFFFB1BC).w
		move.w	#$90,($FFFFB1D0).w
		move.l	#Obj_Sphere_Results_4E012,($FFFFB862).w
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		moveq	#$29,d0
		jsr	(Play_Sound).l
		move.w	($FFFFF60E).w,d0
		ori.b	#$40,d0
		move.w	d0,($C00004).l
		jsr	(Pal_FromBlackWhite).l

loc_4DB9E:
		move.b	#$1A,($FFFFF62A).w
		jsr	(Process_Kos_Queue).l
		jsr	(Wait_VSync).l
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		jsr	(Process_Kos_Module_Queue).l
		cmpi.b	#$30,($FFFFF600).w
		beq.s	loc_4DB9E
		tst.w	($FFFFE442).w
		beq.s	loc_4DC1A
		tst.b	($FFFFFFAB).w
		bmi.s	locret_4DC18
		tst.b	($FFFFFFA0).w
		beq.s	locret_4DC18
		addq.l	#1,($FFFFFFA6).w
		lea	($FFFFFFA2).w,a2
		addi.l	#$1030507,(a2)
		andi.b	#$7F,(a2)
		cmpi.b	#$7F,1(a2)
		bcs.s	loc_4DBFC
		subi.b	#$7F,1(a2)

loc_4DBFC:
		cmpi.b	#$7E,2(a2)
		bcs.s	loc_4DC0A

loc_4DC04:
		subi.b	#$7E,2(a2)

loc_4DC0A:
		cmpi.b	#$7D,3(a2)
		bcs.s	locret_4DC18
		subi.b	#$7D,3(a2)

locret_4DC18:

		rts
; ---------------------------------------------------------------------------

loc_4DC1A:
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		jsr	(Pal_FadeToBlack).l
		bsr.w	sub_4C8E4
		lea	($FFFFFA80).w,a1
		moveq	#0,d0
		move.w	#$1F,d1

loc_4DC36:
		move.l	d0,(a1)+
		dbf	d1,loc_4DC36
		lea	(Pal_SonicTails).l,a1
		lea	($FFFFFC80).w,a2
		moveq	#7,d6

loc_4DC48:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_4DC48
		lea	(Pal_Knuckles).l,a1
		lea	($FFFFFCA0).w,a2
		moveq	#7,d6

loc_4DC5A:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_4DC5A
		lea	(Pal_SphereResults_3).l,a1
		lea	($FFFFFCC0).w,a2
		moveq	#7,d6

loc_4DC6C:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_4DC6C
		lea	(Pal_EndingSKLogo).l,a1
		lea	($FFFFFCE0).w,a2
		moveq	#7,d6

loc_4DC7E:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_4DC7E
		move.l	#$40000000,($C00004).l
		lea	(ArtNem_BlueSphereSKLogo).l,a0
		jsr	(Nem_Decomp).l
		lea	PLC_SphereResults_4DDE8(pc),a1
		jsr	(Load_PLC_Immediate).l
		lea	($FFFF0000).l,a1
		lea	(ArtKos_SKPoseBanner).l,a0
		jsr	(Kos_Decomp).l
		lea	(ArtKos_ANDKnuckles).l,a0
		jsr	(Kos_Decomp).l
		lea	(ArtKos_HPZMasterEmerald).l,a0
		jsr	(Kos_Decomp).l
		lea	(ArtKos_RobotnikSmug).l,a0
		jsr	(Kos_Decomp).l
		lea	(ArtKos_EggRoboHead).l,a0
		jsr	(Kos_Decomp).l
		move.w	a1,d3
		lsr.w	#1,d3
		move.l	#$FF0000,d1
		move.w	#$3000,d2
		jsr	(Add_To_DMA_Queue).l
		lea	($FFFF8000).w,a1
		lea	(MapEni_BlueSphereTitleBG).l,a0
		move.w	#$4000,d0
		jsr	(Eni_Decomp).l
		bsr.w	sub_4DEA2
		move.l	#Obj_SpheresTitle_4D03E,($FFFFB04A).w
		move.w	#$C0,($FFFFB05E).w
		move.l	#Obj_SphereResults_4E0A4,($FFFFB3C2).w
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		clr.b	($FFFFFE19).w
		clr.b	($FFFFF65F).w
		move.w	#1,($FFFFFF08).w
		moveq	#$2C,d0
		jsr	(Play_Sound).l
		move.w	($FFFFF60E).w,d0
		ori.b	#$40,d0
		move.w	d0,($C00004).l
		jsr	(Pal_FadeFromBlack).l

loc_4DD5E:

		move.b	#$1A,($FFFFF62A).w
		jsr	(Process_Kos_Queue).l
		jsr	(Wait_VSync).l
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		jsr	(Process_Kos_Module_Queue).l
		jsr	(SuperSonic_PalFlash).l
		move.b	($FFFFFFAC).w,d1
		cmp.b	($FFFFFFAD).w,d1
		bne.s	loc_4DD5E
		move.b	($FFFFF605).w,d0
		beq.s	loc_4DD5E
		tst.b	($FFFFFFAB).w
		bmi.s	locret_4DDE6
		tst.b	($FFFFFFA0).w
		beq.s	locret_4DDE6
		lea	($FFFFFFA2).w,a2
		moveq	#9,d1

loc_4DDAA:
		addq.l	#1,($FFFFFFA6).w
		addi.l	#$1030507,(a2)
		andi.b	#$7F,(a2)
		cmpi.b	#$7F,1(a2)
		bcs.s	loc_4DDC6
		subi.b	#$7F,1(a2)

loc_4DDC6:
		cmpi.b	#$7E,2(a2)
		bcs.s	loc_4DDD4
		subi.b	#$7E,2(a2)

loc_4DDD4:
		cmpi.b	#$7D,3(a2)
		bcs.s	loc_4DDE2
		subi.b	#$7D,3(a2)

loc_4DDE2:
		dbf	d1,loc_4DDAA

locret_4DDE6:

		rts
; ---------------------------------------------------------------------------
PLC_SphereResults_4DDE8:dc.w 4
		dc.l ArtNem_RobotnikShip
		dc.w $4DE0
		dc.l ArtNem_Chicken
		dc.w $5820
		dc.l ArtNem_Squirrel
		dc.w $59E0
		dc.l ArtNem_Rabbit
		dc.w $5C20
		dc.l ArtNem_BlueSphereTails
		dc.w $F400
Pal_SphereResults_012:	binclude "General\Blue Sphere\Palettes\Results Line 0-2.bin"

Pal_SphereResults_3:	binclude "General\Blue Sphere\Palettes\Results Line 3.bin"

aCongratulation:dc.b "CONGRATULATIONS!",0,0
aPerfect:	dc.b "PERFECT",0

; =============== S U B R O U T I N E =======================================


sub_4DEA2:

		lea	word_4DEDC(pc),a2
		moveq	#$D,d5

loc_4DEA8:
		lea	($FFFF8000).w,a1
		move.w	(a2)+,d0
		swap	d0
		move.w	#3,d0
		moveq	#$B,d1
		moveq	#7,d2
		jsr	(Plane_Map_To_VRAM).l
		dbf	d5,loc_4DEA8
		move.w	#$10,($FFFFF618).w
		lea	($FFFFE002).w,a1
		move.w	#$DF,d1

loc_4DED0:
		subi.w	#$10,(a1)
		addq.w	#4,a1
		dbf	d1,loc_4DED0
		rts
; End of function sub_4DEA2

; ---------------------------------------------------------------------------
word_4DEDC:	dc.w $6000
		dc.w $6020
		dc.w $6040
		dc.w $6410
		dc.w $6430
		dc.w $6450
		dc.w $63F0
		dc.w $6800
		dc.w $6820
		dc.w $6840
		dc.w $6C10
		dc.w $6C30
		dc.w $6C50
		dc.w $6BF0
; ---------------------------------------------------------------------------

Obj_SphereResults_4DEF8:
		move.w	#$12C,$30(a0)
		move.l	#loc_4DF04,(a0)

loc_4DF04:
		subq.w	#1,$30(a0)
		bpl.s	loc_4DF3E
		tst.w	($FFFFE442).w
		bne.s	loc_4DF38
		move	#$2700,sr
		lea	aPerfect(pc),a1	; "PERFECT"
		move.w	#$49A,d2
		move.w	#-$7A41,d6
		jsr	(sub_5B318).l
		move	#$2300,sr
		moveq	#-$54,d0
		jsr	(Play_Sound_2).l
		move.w	#$12C,$30(a0)

loc_4DF38:
		move.l	#loc_4DF52,(a0)

loc_4DF3E:
		tst.w	($FFFFE442).w
		beq.s	locret_4DF50
		move.b	($FFFFF605).w,d0
		beq.s	locret_4DF50
		move.b	#$2C,($FFFFF600).w

locret_4DF50:

		rts
; ---------------------------------------------------------------------------

loc_4DF52:
		tst.w	($FFFFE442).w
		bne.s	loc_4DF5E
		subq.w	#1,$30(a0)
		bmi.s	loc_4DF64

loc_4DF5E:
		move.b	($FFFFF605).w,d0
		beq.s	loc_4DF6A

loc_4DF64:
		move.b	#$2C,($FFFFF600).w

loc_4DF6A:
		move.b	($FFFFFE0F).w,d0
		andi.b	#$F,d0
		bne.s	locret_4DF84
		lea	($FFFFE120).w,a1
		moveq	#$F,d1

loc_4DF7A:
		eori.w	#$100,(a1)
		addq.w	#4,a1
		dbf	d1,loc_4DF7A

locret_4DF84:
		rts
; ---------------------------------------------------------------------------

Obj_SphereResults_4DF86:
		move.l	#Map_Sonic,$C(a0)
		move.w	#-$7980,$A(a0)
		move.w	#$120,$10(a0)
		move.w	#$100,$14(a0)
		move.w	#$80,8(a0)
		move.b	#$18,7(a0)
		move.b	#$18,6(a0)
		move.b	#$13,$20(a0)
		cmpi.w	#1,($FFFFFF08).w
		beq.s	loc_4DFE8
		move.l	#Map_Knuckles,$C(a0)
		move.b	#$24,$20(a0)
		lea	(Pal_Knuckles).l,a1
		lea	($FFFFFC80).w,a2
		moveq	#7,d6

loc_4DFDA:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_4DFDA
		move.l	#loc_4E000,(a0)
		bra.s	loc_4E000
; ---------------------------------------------------------------------------

loc_4DFE8:
		move.l	#loc_4DFEE,(a0)

loc_4DFEE:
		jsr	(Animate_Sonic).l
		jsr	(Sonic_Load_PLC).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_4E000:

		jsr	(Animate_Knuckles).l

loc_4E006:
		jsr	(Knuckles_Load_PLC).l

loc_4E00C:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_Sphere_Results_4E012:
		movea.l	a0,a1
		moveq	#0,d0
		moveq	#0,d2
		moveq	#6,d1

loc_4E01A:
		move.l	#loc_4E074,(a1)
		move.l	#Map_BSResultsEmerald,$C(a1)
		move.w	#$1DC,$A(a1)
		move.w	#$80,8(a1)
		move.b	#$18,7(a1)
		move.b	#$18,6(a1)
		move.b	d0,$26(a1)
		addi.b	#$24,d0
		move.b	d2,$22(a1)
		addq.b	#1,d2
		lea	$4A(a1),a1
		dbf	d1,loc_4E01A
		move.l	#loc_4E05C,(a0)

loc_4E05C:
		move.b	$27(a0),d0
		jsr	(GetSineCosine).l
		asl.w	#4,d0
		addi.w	#$4000,d0
		move.w	d0,($FFFFE400).w
		addq.b	#1,$27(a0)

loc_4E074:
		move.b	$26(a0),d0
		jsr	(GetSineCosine).l
		move.w	($FFFFE400).w,d2
		muls.w	d2,d1
		muls.w	d2,d0
		swap	d1
		swap	d0
		addi.w	#$120,d1
		addi.w	#$100,d0
		move.w	d1,$10(a0)
		move.w	d0,$14(a0)
		addq.b	#1,$26(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_SphereResults_4E0A4:
		move.l	#Map_BlueSpheresText,$C(a0)
		move.w	#-$7AB2,$A(a0)
		move.w	#$120,$10(a0)
		move.w	#$140,$14(a0)
		move.w	#$80,8(a0)
		move.b	#$28,7(a0)
		move.b	#8,6(a0)
		move.b	#4,$22(a0)
		move.w	$14(a0),d3
		addi.w	#$10,d3
		movea.l	a0,a1
		move.b	#$A,$6C(a1)
		move.w	#$114,d2
		moveq	#3,d1

loc_4E0EC:
		lea	$4A(a1),a1
		move.l	#loc_4E1AA,(a1)
		move.w	d2,$10(a1)
		move.w	d3,$14(a1)
		addq.w	#8,d2
		dbf	d1,loc_4E0EC
		move.b	#$B,$22(a1)
		move.w	#$1D,$30(a0)
		move.l	#loc_4E116,(a0)

loc_4E116:
		moveq	#0,d1
		move.b	($FFFFFFAC).w,d1
		addq.b	#1,d1
		bsr.w	sub_4D1AA
		subq.w	#1,$30(a0)
		bpl.s	loc_4E146
		move.w	#$1D,$30(a0)
		move.b	($FFFFFFAC).w,d1
		cmp.b	($FFFFFFAD).w,d1
		beq.s	loc_4E146
		addq.b	#1,($FFFFFFAC).w
		bsr.s	Difficulty_Level_Sprites_Display
		moveq	#-$59,d0
		jsr	(Play_Sound_2).l

loc_4E146:

		move.b	#4,$22(a0)
		cmpi.b	#$C,($FFFFFFAC).w
		bne.s	loc_4E15A
		move.b	#5,$22(a0)

loc_4E15A:
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


Difficulty_Level_Sprites_Display:
		jsr	(Create_New_Sprite).l
		bne.w	locret_4E178
		moveq	#0,d1
		move.b	($FFFFFFAC).w,d1
		subq.b	#1,d1
		lsl.w	#2,d1
		move.l	Difficulty_Sprites(pc,d1.w),(a1)

locret_4E178:
		rts
; End of function Difficulty_Level_Sprites_Display

; ---------------------------------------------------------------------------
Difficulty_Sprites:dc.l	Obj_DifficultySonic
		dc.l Obj_Difficulty_Tails
		dc.l Obj_Difficulty_Knuckles
		dc.l Obj_Difficulty_Eggman
		dc.l Obj_Difficulty_7CFA4
		dc.l Obj_BlueSphere_Ship
		dc.l Obj_Difficulty_2CD26
		dc.l Obj_Difficulty_2CD9A
		dc.l Obj_Difficulty_2CE2C
		dc.l Obj_Difficulty_7CFF0
		dc.l Obj_Difficulty_5FACE
		dc.l Obj_Difficulty_4E24C
; ---------------------------------------------------------------------------

loc_4E1AA:
		bsr.w	sub_4D5C2
		move.l	#loc_4E1B4,(a0)

loc_4E1B4:
		cmpi.b	#$C,($FFFFFFAC).w
		bne.s	loc_4E1BE
		rts
; ---------------------------------------------------------------------------

loc_4E1BE:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_DifficultySonic:
		move.l	#Map_Sonic,$C(a0)
		move.w	#-$7980,$A(a0)
		move.w	#$120,$10(a0)
		move.w	#$120,$14(a0)
		bset	#0,4(a0)
		move.w	#$80,8(a0)
		move.b	#$18,7(a0)
		move.b	#$18,6(a0)
		move.b	#$13,$20(a0)
		move.l	#loc_4E202,(a0)

loc_4E202:
		tst.b	($FFFFFE19).w
		beq.s	loc_4E222
		move.l	#Map_SuperSonic,$C(a0)
		move.b	#$1F,$20(a0)
		move.l	#loc_4E222,(a0)
		move.w	#$14,$30(a0)

loc_4E222:

		tst.b	($FFFFF65F).w
		bpl.s	loc_4E23A
		subq.w	#1,$30(a0)
		bpl.s	loc_4E23A
		move.b	#5,$20(a0)
		move.l	#loc_4E23A,(a0)

loc_4E23A:


		jsr	(Animate_Sonic).l
		jsr	(Sonic_Load_PLC).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_Difficulty_4E24C:
		move.b	#1,($FFFFF65F).w
		move.b	#$F,($FFFFF65E).w
		move.b	#1,($FFFFFE19).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_Difficulty_Tails:
		move.l	#Map_BSTailsPose,$C(a0)
		move.w	#-$5860,$A(a0)
		move.w	#$FC,$10(a0)
		move.w	#$11B,$14(a0)
		bset	#0,4(a0)
		move.w	#$80,8(a0)
		move.b	#$18,7(a0)
		move.b	#$18,6(a0)
		move.l	#loc_4E29C,(a0)

loc_4E29C:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Map_BSTailsPose:	include "General\Blue Sphere\Map - Tails Pose.asm"

; ---------------------------------------------------------------------------

Obj_Difficulty_Knuckles:
		move.l	#Map_Knuckles,$C(a0)
		move.w	#-$5960,$A(a0)
		move.w	#$138,$10(a0)
		move.w	#$118,$14(a0)
		move.w	#$80,8(a0)
		move.b	#$18,7(a0)
		move.b	#$18,6(a0)
		move.b	#$24,$20(a0)
		move.l	#loc_4E2F0,(a0)

loc_4E2F0:
		jsr	(Animate_Knuckles).l
		moveq	#0,d0
		move.b	$22(a0),d0
		cmp.b	$30(a0),d0
		beq.s	loc_4E310
		move.b	d0,$30(a0)
		move.w	#-$2C00,d4
		jsr	(loc_18122).l

loc_4E310:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Map_BSResultsEmerald:	include "General\Blue Sphere\Map - Results Emerald.asm"

; ---------------------------------------------------------------------------

LevelSetup:
		clr.b	($FFFFF664).w
		bclr	#7,($FFFFF74F).w
		clr.l	($FFFFEEA4).w
		clr.w	($FFFFEEB2).w
		clr.l	($FFFFEEBC).w
		clr.l	($FFFFEEC0).w
		clr.l	($FFFFEEC4).w
		clr.w	($FFFFEECC).w
		clr.l	($FFFFEECE).w
		clr.l	($FFFFEF74).w
		clr.l	($FFFFEF66).w
		clr.w	($FFFFEF6C).w
		clr.w	($FFFFFAC0).w
		clr.w	($FFFFEF70).w
		clr.w	($FFFFEE50).w
		clr.l	($FFFFEED2).w
		clr.l	($FFFFEED6).w
		clr.l	($FFFFEEDA).w
		clr.l	($FFFFEEDE).w
		move.w	#$FFF,($FFFFEEAA).w
		move.w	#$FF0,($FFFFEEAC).w
		move.w	#$7C,($FFFFEEAE).w
		move.w	($FFFFEE78).w,($FFFFEE80).w
		move.w	($FFFFEE7C).w,($FFFFEE84).w
		lea	($FFFFF100).w,a0
		lea	($FFFF9000).w,a2
		lea	($FFFF8008).w,a3
		move.w	#-$4000,d7
		move.w	($FFFFFE10).w,d0
		ror.b	#2,d0
		lsr.w	#3,d0
		movea.l	Offs_ScreenInit(pc,d0.w),a1
		jsr	(a1)
		addq.w	#2,a3
		move.w	#-$2000,d7
		move.w	($FFFFFE10).w,d0
		ror.b	#2,d0
		lsr.w	#3,d0
		movea.l	Offs_BackgroundInit(pc,d0.w),a1
		jsr	(a1)
		move.w	($FFFFEE84).w,($FFFFF616).w
		move.w	($FFFFEE90).w,($FFFFF618).w
		rts
; ---------------------------------------------------------------------------

ScreenEvents:

		move.w	($FFFFEE78).w,($FFFFEE80).w
		move.w	($FFFFEE7C).w,($FFFFEE84).w
		jsr	ShakeScreen_BG(pc)
		lea	($FFFFF100).w,a0
		lea	($FFFF9000).w,a2
		lea	($FFFF8008).w,a3
		move.w	#$C000,d7
		move.w	($FFFFFE10).w,d0
		ror.b	#2,d0
		lsr.w	#3,d0
		movea.l	Offs_ScreenEvent(pc,d0.w),a1
		jsr	(a1)
		addq.w	#2,a3
		move.w	#-$2000,d7
		move.w	($FFFFFE10).w,d0
		ror.b	#2,d0
		lsr.w	#3,d0
		movea.l	Offs_BackgroundEvent(pc,d0.w),a1
		jsr	(a1)
		move.w	($FFFFEE84).w,($FFFFF616).w
		move.w	($FFFFEE90).w,($FFFFF618).w
		rts
; ---------------------------------------------------------------------------
Offs_ScreenInit:dc.l AIZ1_ScreenInit
Offs_BackgroundInit:dc.l AIZ1_BackgroundInit	 ; 0
		dc.l AIZ2_ScreenInit	; 1
		dc.l AIZ2_BackgroundInit	; 2
Offs_ScreenEvent:dc.l AIZ1_ScreenEvent
Offs_BackgroundEvent:dc.l AIZ1_BackgroundEvent  ; 0
		dc.l AIZ2_ScreenEvent	; 1
		dc.l AIZ2_BackgroundEvent	; 2
		dc.l HCZ1_ScreenInit	; 3
		dc.l HCZ1_BackgroundInit	; 4
		dc.l HCZ2_ScreenInit	; 5
		dc.l HCZ2_BackgroundInit	; 6
		dc.l HCZ1_ScreenEvent	; 7
		dc.l HCZ1_BackgroundEvent	; 8
		dc.l HCZ2_ScreenEvent	; 9
		dc.l HCZ2_BackgroundEvent	; 10
		dc.l MGZ1_ScreenInit	; 11
		dc.l MGZ1_BackgroundInit	; 12
		dc.l MGZ2_ScreenInit	; 13
		dc.l MGZ2_BackgroundInit	; 14
		dc.l MGZ1_ScreenEvent	; 15
		dc.l MGZ1_BackgroundEvent	; 16
		dc.l MGZ2_ScreenEvent	; 17
		dc.l MGZ2_BackgroundEvent	; 18
		dc.l CNZ1_ScreenInit	; 19
		dc.l CNZ1_BackgroundInit	; 20
		dc.l CNZ2_ScreenInit	; 21
		dc.l CNZ2_BackgroundInit	; 22
		dc.l CNZ1_ScreenEvent	; 23
		dc.l CNZ1_BackgroundEvent	; 24
		dc.l CNZ2_ScreenEvent	; 25
		dc.l CNZ2_BackgroundEvent	; 26
		dc.l FBZ1_ScreenInit	; 27
		dc.l FBZ1_BackgroundInit	; 28
		dc.l FBZ2_ScreenInit	; 29
		dc.l FBZ2_BackgroundInit	; 30
		dc.l FBZ1_ScreenEvent	; 31
		dc.l FBZ1_BackgroundEvent	; 32
		dc.l FBZ2_ScreenEvent	; 33
		dc.l FBZ2_BackgroundEvent	; 34
		dc.l ICZ1_ScreenInit	; 35
		dc.l ICZ1_BackgroundInit	; 36
		dc.l ICZ2_ScreenInit	; 37
		dc.l ICZ2_BackgroundInit	; 38
		dc.l ICZ1_ScreenEvent	; 39
		dc.l ICZ1_BackgroundEvent	; 40
		dc.l ICZ2_ScreenEvent	; 41
		dc.l ICZ2_BackgroundEvent	; 42
		dc.l LBZ1_ScreenInit	; 43
		dc.l LBZ1_BackgroundInit	; 44
		dc.l LBZ2_ScreenInit	; 45
		dc.l LBZ2_BackgroundInit	; 46
		dc.l LBZ1_ScreenEvent	; 47
		dc.l LBZ1_BackgroundEvent	; 48
		dc.l LBZ2_ScreenEvent	; 49
		dc.l LBZ2_BackgroundEvent	; 50
		dc.l MHZ1_ScreenInit	; 51
		dc.l MHZ1_BackgroundInit	; 52
		dc.l MHZ2_ScreenInit	; 53
		dc.l MHZ2_BackgroundInit	; 54
		dc.l MHZ1_ScreenEvent	; 55
		dc.l MHZ1_BackgroundEvent	; 56
		dc.l MHZ2_ScreenEvent	; 57
		dc.l MHZ2_BackgroundEvent	; 58
		dc.l SOZ1_ScreenInit	; 59
		dc.l SOZ1_BackgroundInit	; 60
		dc.l SOZ2_ScreenInit	; 61
		dc.l SOZ2_BackgroundInit	; 62
		dc.l SOZ1_ScreenEvent	; 63
		dc.l SOZ1_BackgroundEvent	; 64
		dc.l SOZ2_ScreenEvent	; 65
		dc.l SOZ2_BackgroundEvent	; 66
		dc.l LRZ1_ScreenInit	; 67
		dc.l LRZ1_BackgroundInit	; 68
		dc.l LRZ2_ScreenInit	; 69
		dc.l LRZ2_BackgroundInit	; 70
		dc.l LRZ1_ScreenEvent	; 71
		dc.l LRZ1_BackgroundEvent	; 72
		dc.l LRZ2_ScreenEvent	; 73
		dc.l LRZ2_BackgroundEvent	; 74
		dc.l SSZ1_ScreenInit	; 75
		dc.l SSZ1_BackgroundInit	; 76
		dc.l SSZ2_ScreenInit	; 77
		dc.l SSZ2_BackgroundInit	; 78
		dc.l SSZ1_ScreenEvent	; 79
		dc.l SSZ1_BackgroundEvent	; 80
		dc.l SSZ2_ScreenEvent	; 81
		dc.l SSZ2_BackgroundEvent	; 82
		dc.l DEZ1_ScreenInit	; 83
		dc.l DEZ1_BackgroundInit	; 84
		dc.l DEZ2_ScreenInit	; 85
		dc.l DEZ2_BackgroundInit	; 86
		dc.l DEZ1_ScreenEvent	; 87
		dc.l DEZ1_BackgroundEvent	; 88
		dc.l DEZ2_ScreenEvent	; 89
		dc.l DEZ2_BackgroundEvent	; 90
		dc.l DDZ_ScreenInit	; 91
		dc.l DDZ_BackgroundInit	; 92
		dc.l DDZ_ScreenInit	; 93
		dc.l DDZ_BackgroundInit	; 94
		dc.l DDZ_ScreenEvent	; 95
		dc.l DDZ_BackgroundEvent	; 96
		dc.l DDZ_ScreenEvent	; 97
		dc.l DDZ_BackgroundEvent	; 98
		dc.l Ending_ScreenInit	; 99
		dc.l Ending_BackgroundInit	; 100
		dc.l Ending_ScreenInit	; 101
		dc.l Ending_BackgroundInit	; 102
		dc.l Ending_ScreenEvent	; 103
		dc.l Ending_BackgroundEvent; 104
		dc.l Ending_ScreenEvent	; 105
		dc.l Ending_BackgroundEvent; 106
		dc.l Comp_ScreenInit	; 107
		dc.l ALZ_BackgroundInit	; 108
		dc.l Comp_ScreenInit	; 109
		dc.l ALZ_BackgroundInit	; 110
		dc.l Comp_ScreenEvent	; 111
		dc.l ALZ_BackgroundEvent	; 112
		dc.l Comp_ScreenEvent	; 113
		dc.l ALZ_BackgroundEvent	; 114
		dc.l Comp_ScreenInit	; 115
		dc.l BPZ_BackgroundInit	; 116
		dc.l Comp_ScreenInit	; 117
		dc.l BPZ_BackgroundInit	; 118
		dc.l Comp_ScreenEvent	; 119
		dc.l BPZ_BackgroundEvent	; 120
		dc.l Comp_ScreenEvent	; 121
		dc.l BPZ_BackgroundEvent	; 122
		dc.l Comp_ScreenInit	; 123
		dc.l DPZ_BackgroundInit	; 124
		dc.l Comp_ScreenInit	; 125
		dc.l DPZ_BackgroundInit	; 126
		dc.l Comp_ScreenEvent	; 127
		dc.l DPZ_BackgroundEvent	; 128
		dc.l Comp_ScreenEvent	; 129
		dc.l DPZ_BackgroundEvent	; 130
		dc.l Comp_ScreenInit	; 131
		dc.l CGZ_BackgroundInit	; 132
		dc.l Comp_ScreenInit	; 133
		dc.l CGZ_BackgroundInit	; 134
		dc.l CGZ_ScreenEvent	; 135
		dc.l CGZ_BackgroundEvent	; 136
		dc.l CGZ_ScreenEvent	; 137
		dc.l CGZ_BackgroundEvent	; 138
		dc.l Comp_ScreenInit	; 139
		dc.l EMZ_BackgroundInit	; 140
		dc.l Comp_ScreenInit	; 141
		dc.l EMZ_BackgroundInit	; 142
		dc.l Comp_ScreenEvent	; 143
		dc.l EMZ_BackgroundEvent	; 144
		dc.l Comp_ScreenEvent	; 145
		dc.l EMZ_BackgroundEvent	; 146
		dc.l Gumball_ScreenInit	; 147
		dc.l Gumball_BackgroundInit; 148
		dc.l Gumball_ScreenInit	; 149
		dc.l Gumball_BackgroundInit; 150
		dc.l Gumball_ScreenEvent; 151
		dc.l Gumball_BackgroundEvent; 152
		dc.l Gumball_ScreenEvent; 153
		dc.l Gumball_BackgroundEvent; 154
		dc.l Pachinko_ScreenInit; 155
		dc.l Pachinko_BackgroundInit; 156
		dc.l Pachinko_ScreenInit; 157
		dc.l Pachinko_BackgroundInit; 158
		dc.l Pachinko_ScreenEvent; 159
		dc.l Pachinko_BackgroundEvent; 160
		dc.l Pachinko_ScreenEvent; 161
		dc.l Pachinko_BackgroundEvent; 162
		dc.l Slots_ScreenInit	; 163
		dc.l Slots_BackgroundInit	; 164
		dc.l Slots_ScreenInit	; 165
		dc.l Slots_BackgroundInit	; 166
		dc.l Slots_ScreenEvent	; 167
		dc.l Slots_BackgroundEvent	; 168
		dc.l Slots_ScreenEvent	; 169
		dc.l Slots_BackgroundEvent	; 170
		dc.l LRZ3_ScreenInit	; 171
		dc.l LRZ3_BackgroundInit	; 172
		dc.l HPZ_ScreenInit	; 173
		dc.l HPZ_BackgroundInit	; 174
		dc.l LRZ3_ScreenEvent	; 175
		dc.l LRZ3_BackgroundEvent	; 176
		dc.l HPZ_ScreenEvent	; 177
		dc.l HPZ_BackgroundEvent	; 178
		dc.l DEZ3_ScreenInit	; 179
		dc.l DEZ3_BackgroundInit	; 180
		dc.l HPZS_ScreenInit	; 181
		dc.l HPZS_BackgroundInit	; 182
		dc.l DEZ3_ScreenEvent	; 183
		dc.l DEZ3_BackgroundEvent	; 184
		dc.l HPZS_ScreenEvent	; 185
		dc.l HPZS_BackgroundEvent	; 186

; =============== S U B R O U T I N E =======================================


VInt_DrawLevel:
		lea	($C00000).l,a6
		lea	($FFFFF100).w,a0
		bsr.s	VInt_DrawLevel_2
		move.l	($FFFFEF74).w,d0
		beq.s	VInt_DrawLevel_Return
		movea.l	d0,a0
; End of function VInt_DrawLevel


; =============== S U B R O U T I N E =======================================


VInt_DrawLevel_2:
		move.w	(a0),d0
		beq.s	VInt_DrawLevel_Done
		clr.w	(a0)+
		move.w	(a0)+,d1
		bmi.s	VInt_DrawLevel_Col
		move.w	#$8F02,d2		; VRAM increment at 2 bytes (horizontal level write)
		move.w	#$80,d3
		bra.s	VInt_DrawLevel_Draw
; ---------------------------------------------------------------------------

VInt_DrawLevel_Col:
		move.w	#$8F80,d2		; VRAM increment at $80 bytes (vertical level write)
		moveq	#2,d3
		andi.w	#$7FFF,d1

VInt_DrawLevel_Draw:
		move.w	d2,4(a6)
		move.w	d0,d2
		move.w	d1,d4
		bsr.s	VInt_VRAMWrite
		move.w	d2,d0
		add.w	d3,d0
		move.w	d4,d1
		bsr.s	VInt_VRAMWrite
		bra.s	VInt_DrawLevel_2
; ---------------------------------------------------------------------------

VInt_DrawLevel_Done:
		move.w	#$8F02,4(a6)

VInt_DrawLevel_Return:
		rts
; End of function VInt_DrawLevel_2


; =============== S U B R O U T I N E =======================================


VInt_VRAMWrite:
		swap	d0
		clr.w	d0
		swap	d0
		lsl.l	#2,d0
		lsr.w	#2,d0
		ori.w	#$4000,d0
		swap	d0
		move.l	d0,4(a6)

loc_4E7BA:
		move.l	(a0)+,(a6)
		dbf	d1,loc_4E7BA
		rts
; End of function VInt_VRAMWrite


; =============== S U B R O U T I N E =======================================


SpecialVInt_VRAMRead:
		swap	d0
		clr.w	d0
		swap	d0
		lsl.l	#2,d0
		lsr.w	#2,d0
		swap	d0
		move.l	d0,4(a6)

loc_4E7D2:
		move.l	(a6),(a0)+
		dbf	d1,loc_4E7D2
		rts
; End of function SpecialVInt_VRAMRead


; =============== S U B R O U T I N E =======================================


sub_4E7DA:
		lea	($C00000).l,a6
		lea	($FFFFF100).w,a0

loc_4E7E4:
		move.w	(a0),d0
		beq.s	locret_4E7FE
		clr.w	(a0)+
		move.w	(a0)+,d1
		move.w	d0,d2
		move.w	d1,d4
		bsr.s	VInt_VRAMWrite
		move.w	d2,d0
		add.w	($FFFFEEB0).w,d0
		move.w	d4,d1
		bsr.s	VInt_VRAMWrite
		bra.s	loc_4E7E4
; ---------------------------------------------------------------------------

locret_4E7FE:
		rts
; End of function sub_4E7DA


; =============== S U B R O U T I N E =======================================


SpecialVInt_Function:
		lea	($C00000).l,a6

loc_4E806:
		move.w	($FFFFEEA6).w,d0
		jmp	SpecialVInt_Array(pc,d0.w)
; End of function SpecialVInt_Function

; ---------------------------------------------------------------------------

SpecialVInt_Array:
		rts
; ---------------------------------------------------------------------------
		nop
		bra.w	SpecialVInt_VScrollOn		; $04
; ---------------------------------------------------------------------------
		bra.w	SpecialVInt_VScrollCopy		; $08
; ---------------------------------------------------------------------------
		bra.w	SpecialVInt_VScrollOff		; $0C
; ---------------------------------------------------------------------------
		bra.w	SpecialVInt_LBZ2WindowCopy	; $10
; ---------------------------------------------------------------------------
		bra.w	SpecialVInt_LBZ2ScrollAClear	; $14
; ---------------------------------------------------------------------------
		bra.w	SpecialVInt_LBZ2ScrollAClear2	; $18
; ---------------------------------------------------------------------------
		bra.w	SpecialVInt_LBZ2WindowClear	; $1C
; ---------------------------------------------------------------------------

SpecialVInt_VScrollOn:
		move.w	#$8B07,4(a6)		; Command $8B07 - VScroll cell-based, HScroll line-based
		addq.w	#4,($FFFFEEA6).w

SpecialVInt_VScrollCopy:
		lea	($FFFFEEEA).w,a0
		move.l	#$40000010,4(a6)
		moveq	#$13,d0

loc_4E846:
		move.l	(a0)+,(a6)
		dbf	d0,loc_4E846
		rts
; ---------------------------------------------------------------------------

SpecialVInt_VScrollOff:
		move.w	#$8B03,4(a6)		; Command $8B03 - VScroll full, HScroll line-based
		clr.w	($FFFFEEA6).w
		rts
; ---------------------------------------------------------------------------

SpecialVInt_LBZ2WindowCopy:
		lea	($FFFFF580).w,a0		; Used specifically by the Death Egg platform at the end of LBZ2
		move.w	($FFFFEECA).w,d0
		addi.w	#$D,d0
		andi.w	#$1F,d0
		lsl.w	#7,d0
		addi.w	#$C000,d0
		move.w	d0,d2
		addi.w	#$64,d0
		moveq	#6,d1
		jsr	SpecialVInt_VRAMRead(pc)	; Grabs the nametable area of the Death Egg platform
		move.w	d2,d0
		moveq	#$18,d1
		jsr	SpecialVInt_VRAMRead(pc)
		lea	($FFFFF580).w,a0
		move.w	($FFFFEECA).w,d0
		lsl.w	#7,d0
		addi.w	#$8000,d0
		moveq	#$1F,d1
		jsr	VInt_VRAMWrite(pc)			; Copies the pertinent data from scroll A to the window nametable
		subq.w	#1,($FFFFEECA).w		; Do this (EECA) number of times
		bpl.s	locret_4E8A2
		addq.w	#4,($FFFFEEA6).w

locret_4E8A2:
		rts
; ---------------------------------------------------------------------------

SpecialVInt_LBZ2ScrollAClear:
		move.l	#$49000003,($C00004).l	; VRAM base $C900
		moveq	#0,d0
		moveq	#$5F,d1

loc_4E8B2:
		move.l	d0,(a6)				; Clear 6 cell lines from VRAM A for when it scrolls upward
		move.l	d0,(a6)
		dbf	d1,loc_4E8B2
		move.w	#$8320,4(a6)		; VRAM command $8320 - Window at base address $8000
		move.w	#$9285,4(a6)		; VRAM command $9285 - Window starts 5 cells down from top
		clr.w	($FFFFEEA6).w
		rts
; ---------------------------------------------------------------------------

SpecialVInt_LBZ2ScrollAClear2:
		move.l	#$46000003,($C00004).l	; VRAM base $C600
		moveq	#0,d0
		moveq	#$5F,d1

loc_4E8DA:
		move.l	d0,(a6)					; Erase remainder of upper area of VRAM A
		move.l	d0,(a6)
		dbf	d1,loc_4E8DA
		addq.w	#4,($FFFFEEA6).w
		rts
; ---------------------------------------------------------------------------

SpecialVInt_LBZ2WindowClear:
		lea	($FFFFF580).w,a0
		move.w	#$829C,d0
		moveq	#$18,d1
		jsr	SpecialVInt_VRAMRead(pc)
		move.w	#$8280,d0
		moveq	#6,d1
		jsr	SpecialVInt_VRAMRead(pc)	; Copy from window data. Luckily, all 6 cell lines are identical so it only needs to be done once

loc_4E900:
		move.l	#$49000003,($C00004).l	; VRAM position $C900
		moveq	#5,d0

loc_4E90C:
		lea	($FFFFF580).w,a0
		moveq	#$F,d1

loc_4E912:
		move.l	(a0)+,(a6)
		move.l	(a0)+,(a6)				; Write cell lines back to Scroll A
		dbf	d1,loc_4E912
		dbf	d0,loc_4E90C
		move.w	#$9200,4(a6)			; VRAM command $9200 - Zero out window position
		clr.w	($FFFFEEA6).w
		rts

; =============== S U B R O U T I N E =======================================


Draw_TileColumn:

		move.w	(a6),d0
		andi.w	#-$10,d0
		move.w	(a5),d2
		move.w	d0,(a5)
		move.w	d2,d3
		sub.w	d0,d2
		beq.w	locret_4EAB6
		tst.b	d2
		bpl.s	loc_4E948
		neg.w	d2
		move.w	d3,d0
		addi.w	#$150,d0

loc_4E948:
		andi.w	#$30,d2
		cmpi.w	#$10,d2
		sne	($FFFFEEA4).w
		movem.w	d1/d6,-(sp)
		bsr.s	Setup_TileColumnDraw
		movem.w	(sp)+,d1/d6
		tst.b	($FFFFEEA4).w
		beq.w	locret_4EAB6
		addi.w	#$10,d0
		bra.s	Setup_TileColumnDraw
; End of function Draw_TileColumn


; =============== S U B R O U T I N E =======================================


Draw_TileColumn2:

		move.w	(a6),d0
		andi.w	#-$10,d0
		move.w	(a5),d2
		move.w	d0,(a5)
		move.w	d2,d3
		sub.w	d0,d2
		beq.w	locret_4EAB6
		tst.b	d2
		bpl.s	loc_4E98C
		neg.w	d2
		move.w	d3,d0
		addi.w	#$150,d0
		swap	d1

loc_4E98C:
		andi.w	#$30,d2
		cmpi.w	#$10,d2
		sne	($FFFFEEA4).w
		movem.w	d1/d6,-(sp)
		bsr.s	Setup_TileColumnDraw
		movem.w	(sp)+,d1/d6
		tst.b	($FFFFEEA4).w
		beq.w	locret_4EAB6
		addi.w	#$10,d0
; End of function Draw_TileColumn2


; =============== S U B R O U T I N E =======================================


Setup_TileColumnDraw:

		move.w	d1,d2
		andi.w	#$70,d2
		move.w	d1,d3
		lsl.w	#4,d3
		andi.w	#$F00,d3
		asr.w	#4,d1
		move.w	d1,d4
		asr.w	#1,d1
		and.w	($FFFFEEAE).w,d1
		andi.w	#$F,d4
		moveq	#$10,d5
		sub.w	d4,d5
		move.w	d5,d4
		sub.w	d6,d5
		bmi.s	loc_4E9FC
		move.w	d0,d5
		asr.w	#2,d5
		andi.w	#$7C,d5
		add.w	d7,d5
		add.w	d3,d5
		move.w	d5,(a0)+
		move.w	d6,d5
		subq.w	#1,d6
		move.w	d6,(a0)+
		bset	#7,-2(a0)
		lea	(a0),a1
		add.w	d5,d5
		add.w	d5,d5
		adda.w	d5,a0
		jsr	Get_LevelChunkColumn(pc)
		bra.s	sub_4EA4A
; ---------------------------------------------------------------------------

loc_4E9FC:
		neg.w	d5
		move.w	d5,-(sp)
		move.w	d0,d5

loc_4EA02:
		asr.w	#2,d5
		andi.w	#$7C,d5
		add.w	d7,d5
		add.w	d3,d5
		move.w	d5,(a0)+
		move.w	d4,d6
		subq.w	#1,d6
		move.w	d6,(a0)+
		bset	#7,-2(a0)
		lea	(a0),a1
		add.w	d4,d4
		add.w	d4,d4
		adda.w	d4,a0
		jsr	Get_LevelChunkColumn(pc)
		bsr.s	sub_4EA4A
		move.w	(sp)+,d6
		move.w	d0,d5
		asr.w	#2,d5
		andi.w	#$7C,d5
		add.w	d7,d5
		move.w	d5,(a0)+
		move.w	d6,d5
		subq.w	#1,d6
		move.w	d6,(a0)+
		bset	#7,-2(a0)
		lea	(a0),a1
		add.w	d5,d5
		add.w	d5,d5
		adda.w	d5,a0
; End of function Setup_TileColumnDraw


; =============== S U B R O U T I N E =======================================


sub_4EA4A:

		swap	d7

loc_4EA4C:
		move.w	(a5,d2.w),d3
		move.w	d3,d4
		andi.w	#$3FF,d3
		lsl.w	#3,d3
		move.w	(a2,d3.w),d5
		swap	d5
		move.w	4(a2,d3.w),d5
		move.w	6(a2,d3.w),d7
		move.w	2(a2,d3.w),d3
		swap	d3
		move.w	d7,d3
		btst	#$B,d4
		beq.s	loc_4EA84
		eori.l	#$10001000,d5
		eori.l	#$10001000,d3
		swap	d5
		swap	d3

loc_4EA84:
		btst	#$A,d4
		beq.s	loc_4EA98
		eori.l	#$8000800,d5
		eori.l	#$8000800,d3
		exg	d3,d5

loc_4EA98:
		move.l	d5,(a1)+
		move.l	d3,(a0)+
		addi.w	#$10,d2
		andi.w	#$70,d2
		bne.s	loc_4EAAE
		addq.w	#4,d1
		and.w	($FFFFEEAE).w,d1
		bsr.s	Get_LevelChunkColumn

loc_4EAAE:
		dbf	d6,loc_4EA4C
		swap	d7
		clr.w	(a0)

locret_4EAB6:

		rts
; End of function sub_4EA4A


; =============== S U B R O U T I N E =======================================


Get_LevelChunkColumn:

		movea.w	(a3,d1.w),a4
		move.w	d0,d3
		asr.w	#7,d3
		adda.w	d3,a4
		moveq	#-1,d3
		clr.w	d3
		move.b	(a4),d3
		lsl.w	#7,d3
		move.w	d0,d4
		asr.w	#3,d4
		andi.w	#$E,d4
		add.w	d4,d3
		movea.l	d3,a5
		rts
; End of function Get_LevelChunkColumn


; =============== S U B R O U T I N E =======================================


Draw_TileRow:

		move.w	(a6),d0
		and.w	($FFFFEEAC).w,d0
		move.w	(a5),d2
		move.w	d0,(a5)
		move.w	d2,d3
		sub.w	d0,d2
		beq.w	locret_4EC46
		tst.b	d2
		bpl.s	loc_4EAFA
		neg.w	d2
		move.w	d3,d0
		addi.w	#$F0,d0
		and.w	($FFFFEEAC).w,d0

loc_4EAFA:
		andi.w	#$30,d2
		cmpi.w	#$10,d2

loc_4EB02:
		sne	($FFFFEEA4).w
		movem.w	d1/d6,-(sp)
		bsr.s	Setup_TileRowDraw

loc_4EB0C:
		movem.w	(sp)+,d1/d6
		tst.b	($FFFFEEA4).w
		beq.w	locret_4EC46
		addi.w	#$10,d0
		and.w	($FFFFEEAC).w,d0
		bra.s	Setup_TileRowDraw
; End of function Draw_TileRow


; =============== S U B R O U T I N E =======================================


Draw_TileRow2:

		move.w	(a6),d0
		and.w	($FFFFEEAC).w,d0
		move.w	(a5),d2
		move.w	d0,(a5)
		move.w	d2,d3
		sub.w	d0,d2
		beq.w	locret_4EC46
		tst.b	d2
		bpl.s	loc_4EB46
		neg.w	d2
		move.w	d3,d0
		addi.w	#$F0,d0
		and.w	($FFFFEEAC).w,d0
		swap	d1

loc_4EB46:
		andi.w	#$30,d2
		cmpi.w	#$10,d2
		sne	($FFFFEEA4).w
		movem.w	d1/d6,-(sp)
		bsr.s	Setup_TileRowDraw
		movem.w	(sp)+,d1/d6
		tst.b	($FFFFEEA4).w
		beq.w	locret_4EC46
		addi.w	#$10,d0
		and.w	($FFFFEEAC).w,d0
; End of function Draw_TileRow2


; =============== S U B R O U T I N E =======================================


Setup_TileRowDraw:

		asr.w	#4,d1
		move.w	d1,d2
		move.w	d1,d4
		asr.w	#3,d1
		add.w	d2,d2
		move.w	d2,d3
		andi.w	#$E,d2
		add.w	d3,d3
		andi.w	#$7C,d3
		andi.w	#$1F,d4
		moveq	#$20,d5
		sub.w	d4,d5
		move.w	d5,d4
		sub.w	d6,d5
		bmi.s	loc_4EBB2
		move.w	d0,d5
		andi.w	#$F0,d5		; If the length of the write can fit without wrapping the nametable
		lsl.w	#4,d5
		add.w	d7,d5
		add.w	d3,d5
		move.w	d5,(a0)+
		move.w	d6,d5
		subq.w	#1,d6
		move.w	d6,(a0)+
		lea	(a0),a1
		add.w	d5,d5
		add.w	d5,d5
		adda.w	d5,a0
		jsr	Get_LevelAddrChunkRow(pc)
		bra.s	loc_4EBF2
; ---------------------------------------------------------------------------

loc_4EBB2:
		neg.w	d5			; If the length of the write wraps over the length of the nametable
		move.w	d5,-(sp)
		move.w	d0,d5
		andi.w	#$F0,d5
		lsl.w	#4,d5
		add.w	d7,d5
		add.w	d3,d5
		move.w	d5,(a0)+
		move.w	d4,d6
		subq.w	#1,d6
		move.w	d6,(a0)+
		lea	(a0),a1
		add.w	d4,d4
		add.w	d4,d4
		adda.w	d4,a0
		bsr.s	Get_LevelAddrChunkRow
		bsr.s	loc_4EBF2
		move.w	(sp)+,d6	; Must place one more write command to account for rollover
		move.w	d0,d5
		andi.w	#$F0,d5
		lsl.w	#4,d5
		add.w	d7,d5
		move.w	d5,(a0)+
		move.w	d6,d5
		subq.w	#1,d6
		move.w	d6,(a0)+
		lea	(a0),a1
		add.w	d5,d5
		add.w	d5,d5
		adda.w	d5,a0
; End of function Setup_TileRowDraw


loc_4EBF2:

		move.w	(a5,d2.w),d3
		move.w	d3,d4
		andi.w	#$3FF,d3
		lsl.w	#3,d3

loc_4EBFE:
		move.l	(a2,d3.w),d5

loc_4EC02:
		move.l	4(a2,d3.w),d3

loc_4EC06:
		btst	#$B,d4

loc_4EC0A:
		beq.s	loc_4EC1A

loc_4EC0C:
		eori.l	#$10001000,d5
		eori.l	#$10001000,d3
		exg	d3,d5

loc_4EC1A:
		btst	#$A,d4
		beq.s	loc_4EC30
		eori.l	#$8000800,d5
		eori.l	#$8000800,d3
		swap	d5
		swap	d3

loc_4EC30:
		move.l	d5,(a1)+
		move.l	d3,(a0)+
		addq.w	#2,d2
		andi.w	#$E,d2
		bne.s	loc_4EC40
		addq.w	#1,d1
		bsr.s	Get_ChunkRow

loc_4EC40:
		dbf	d6,loc_4EBF2
		clr.w	(a0)

locret_4EC46:

		rts

; =============== S U B R O U T I N E =======================================


Get_LevelAddrChunkRow:

		move.w	d0,d3
		asr.w	#5,d3
		and.w	($FFFFEEAE).w,d3
		movea.w	(a3,d3.w),a4

Get_ChunkRow:
		moveq	#-1,d3
		clr.w	d3
		move.b	(a4,d1.w),d3
		lsl.w	#7,d3
		move.w	d0,d4
		andi.w	#$70,d4
		add.w	d4,d3
		movea.l	d3,a5
		rts
; End of function Get_LevelAddrChunkRow


; =============== S U B R O U T I N E =======================================


sub_4EC6A:
		asr.w	#3,d1
		move.w	d1,d2
		asr.w	#4,d1
		andi.w	#$E,d2
		cmpi.w	#$100,($FFFFEEB0).w
		beq.s	loc_4EC84
		moveq	#4,d3
		move.w	#$1F80,d4
		bra.s	loc_4EC8A
; ---------------------------------------------------------------------------

loc_4EC84:
		moveq	#5,d3
		move.w	#$1F00,d4

loc_4EC8A:
		move.w	d0,d5
		lsl.w	d3,d5
		and.w	d4,d5
		add.w	d7,d5
		move.w	d5,(a0)+
		move.w	d6,d5
		subq.w	#1,d6
		move.w	d6,(a0)+
		lea	(a0),a1
		add.w	d5,d5
		add.w	d5,d5
		adda.w	d5,a0
		jsr	Get_LevelAddrChunkRow(pc)
		bra.w	loc_4EBF2
; End of function sub_4EC6A


; =============== S U B R O U T I N E =======================================


sub_4ECAA:

		asr.w	#4,d1
		move.w	d1,d2
		asr.w	#3,d1
		add.w	d2,d2
		andi.w	#$E,d2
		move.w	d5,(a0)+
		move.w	d6,d5
		subq.w	#1,d6
		move.w	d6,(a0)+
		lea	(a0),a1
		add.w	d5,d5
		add.w	d5,d5
		adda.w	d5,a0
		jsr	Get_LevelAddrChunkRow(pc)
		bra.w	loc_4EBF2
; End of function sub_4ECAA


; =============== S U B R O U T I N E =======================================


Refresh_PlaneFull:

		moveq	#$F,d2

loc_4ECD0:
		movem.l	d0-d2/a0,-(sp)
		moveq	#$20,d6
		jsr	Setup_TileRowDraw(pc)
		jsr	VInt_DrawLevel(pc)
		movem.l	(sp)+,d0-d2/a0
		addi.w	#$10,d0
		dbf	d2,loc_4ECD0
		rts
; End of function Refresh_PlaneFull


; =============== S U B R O U T I N E =======================================


Refresh_PlaneTileDeform:

		move.w	(a4)+,d2
		moveq	#$F,d3

loc_4ECF0:

		cmp.w	d2,d0
		bmi.s	loc_4ECFA
		add.w	(a4)+,d2
		addq.w	#4,a5
		bra.s	loc_4ECF0
; ---------------------------------------------------------------------------

loc_4ECFA:
		move.w	(a5),d1
		moveq	#$20,d6
		movem.l	d0/d2-d3/a0/a4-a5,-(sp)

loc_4ED02:
		jsr	Setup_TileRowDraw(pc)

loc_4ED06:
		jsr	VInt_DrawLevel(pc)
		movem.l	(sp)+,d0/d2-d3/a0/a4-a5
		addi.w	#$10,d0
		dbf	d3,loc_4ECF0
		rts
; End of function Refresh_PlaneTileDeform

; ---------------------------------------------------------------------------
		move.w	(a4)+,d2
		moveq	#$1F,d3

loc_4ED1C:

		cmp.w	d2,d0
		bmi.s	loc_4ED26
		add.w	(a4)+,d2
		addq.w	#4,a5
		bra.s	loc_4ED1C
; ---------------------------------------------------------------------------

loc_4ED26:
		move.w	(a5),d1
		moveq	#$10,d6
		movem.l	d0/d2-d3/a0/a4-a5,-(sp)
		jsr	Setup_TileColumnDraw(pc)
		jsr	VInt_DrawLevel(pc)
		movem.l	(sp)+,d0/d2-d3/a0/a4-a5
		addi.w	#$10,d0
		dbf	d3,loc_4ED1C
		rts
; ---------------------------------------------------------------------------

loc_4ED44:
		movem.l	d0-d2/d6/a0,-(sp)
		jsr	sub_4EC6A(pc)
		jsr	sub_4E7DA(pc)
		movem.l	(sp)+,d0-d2/d6/a0
		addi.w	#$10,d0
		dbf	d2,loc_4ED44
		rts
; ---------------------------------------------------------------------------

Refresh_PlaneFullDirect:
		moveq	#$20,d6
		bra.s	Refresh_PlaneDirect2
; ---------------------------------------------------------------------------

Refresh_PlaneScreenDirect:

		moveq	#$15,d6

Refresh_PlaneDirect2:
		move.w	($FFFFEE84).w,d0
		move.w	($FFFFEE80).w,d1

; =============== S U B R O U T I N E =======================================


Refresh_PlaneDirect:

		move	#$2700,sr
		moveq	#$E,d2

loc_4ED72:
		movem.l	d0-d2/d6/a0,-(sp)		; Redraws the entire plane in one go during 68k execution
		jsr	Setup_TileRowDraw(pc)
		jsr	VInt_DrawLevel(pc)
		movem.l	(sp)+,d0-d2/d6/a0
		addi.w	#$10,d0
		dbf	d2,loc_4ED72
		move	#$2300,sr
		rts
; End of function Refresh_PlaneDirect


; =============== S U B R O U T I N E =======================================


DrawTilesAsYouMove:

		lea	($FFFFEE80).w,a6
		lea	($FFFFEE88).w,a5
		move.w	($FFFFEE84).w,d1
		moveq	#$F,d6
		jsr	Draw_TileColumn(pc)
		lea	($FFFFEE84).w,a6
		lea	($FFFFEE8A).w,a5
		move.w	($FFFFEE80).w,d1
		moveq	#$15,d6
		jmp	Draw_TileRow(pc)
; End of function DrawTilesAsYouMove


; =============== S U B R O U T I N E =======================================


DrawBGAsYouMove:

		lea	($FFFFEE8C).w,a6
		lea	($FFFFEE94).w,a5
		move.w	($FFFFEE90).w,d1
		moveq	#$F,d6
		jsr	Draw_TileColumn(pc)
		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		move.w	($FFFFEE8C).w,d1
		moveq	#$15,d6
		jmp	Draw_TileRow(pc)
; End of function DrawBGAsYouMove

; ---------------------------------------------------------------------------

loc_4EDD8:
		movem.l	d5/a4-a5,-(sp)
		lea	($FFFFEE84).w,a6
		jsr	Get_DeformDrawPosVert(pc)
		lea	($FFFFEE8A).w,a5
		jsr	Draw_TileRow2(pc)
		movem.l	(sp)+,d5/a4/a6
		move.w	($FFFFEE8A).w,d6
		bra.s	Draw_BGNoVert

; =============== S U B R O U T I N E =======================================


Draw_BG:

		movem.l	d5/a4-a5,-(sp)
		lea	($FFFFEE90).w,a6

loc_4EDFE:
		jsr	Get_DeformDrawPosVert(pc)

loc_4EE02:
		lea	($FFFFEE96).w,a5

loc_4EE06:
		jsr	Draw_TileRow2(pc)
		movem.l	(sp)+,d5/a4/a6
		move.w	($FFFFEE96).w,d6
		tst.w	($FFFFEE90).w
		bpl.s	Draw_BGNoVert
		move.w	($FFFFEE90).w,d6
		andi.w	#-$10,d6

Draw_BGNoVert:

		move.w	d6,d1

loc_4EE22:
		sub.w	(a4)+,d6
		bmi.s	loc_4EE32
		move.w	(a6)+,d0
		andi.w	#-$10,d0
		move.w	d0,(a6)+
		subq.w	#1,d5
		bra.s	loc_4EE22
; ---------------------------------------------------------------------------

loc_4EE32:
		neg.w	d6
		lsr.w	#4,d6
		moveq	#$F,d4
		sub.w	d6,d4
		bcc.s	loc_4EE40
		moveq	#0,d4
		moveq	#$F,d6

loc_4EE40:

		movem.w	d1/d4-d6,-(sp)
		movem.l	a4/a6,-(sp)
		lea	2(a6),a5
		jsr	Draw_TileColumn(pc)
		movem.l	(sp)+,a4/a6
		movem.w	(sp)+,d1/d4-d6
		addq.w	#4,a6
		tst.w	d4
		beq.s	loc_4EE74
		lsl.w	#4,d6
		add.w	d6,d1
		subq.w	#1,d5
		move.w	(a4)+,d6
		lsr.w	#4,d6
		move.w	d4,d0
		sub.w	d6,d4
		bpl.s	loc_4EE40
		move.w	d0,d6
		moveq	#0,d4
		bra.s	loc_4EE40
; ---------------------------------------------------------------------------

loc_4EE74:

		subq.w	#1,d5
		beq.s	locret_4EE82
		move.w	(a6)+,d0
		andi.w	#-$10,d0
		move.w	d0,(a6)+
		bra.s	loc_4EE74
; ---------------------------------------------------------------------------

locret_4EE82:
		rts
; End of function Draw_BG


; =============== S U B R O U T I N E =======================================


Get_DeformDrawPosVert:

		move.w	(a4)+,d2
		move.w	(a6),d0
		bsr.s	sub_4EE8E
		addi.w	#$E0,d0
; End of function Get_DeformDrawPosVert


; =============== S U B R O U T I N E =======================================


sub_4EE8E:
		cmp.w	d2,d0
		bmi.s	loc_4EE98
		add.w	(a4)+,d2
		addq.w	#4,a5
		bra.s	sub_4EE8E
; ---------------------------------------------------------------------------

loc_4EE98:
		move.w	(a5),d1
		swap	d1
		rts
; End of function sub_4EE8E

; ---------------------------------------------------------------------------

DrawTilesVDeform:

		movem.l	d5/a4-a5,-(sp)
		lea	($FFFFEE80).w,a6
		jsr	Get_XDeformRange(pc)
		lea	($FFFFEE88).w,a5
		jsr	Draw_TileColumn2(pc)
		movem.l	(sp)+,d5/a4/a6
		move.w	($FFFFEE88).w,d6
		bra.s	loc_4EED8

; =============== S U B R O U T I N E =======================================


DrawTilesVDeform2:
		movem.l	d5/a4-a5,-(sp)
		lea	($FFFFEE8C).w,a6
		jsr	Get_XDeformRange(pc)
		lea	($FFFFEE94).w,a5
		jsr	Draw_TileColumn2(pc)
		movem.l	(sp)+,d5/a4/a6
		move.w	($FFFFEE94).w,d6

loc_4EED8:
		move.w	d6,d1

loc_4EEDA:
		sub.w	(a4)+,d6
		bcs.s	loc_4EEEA
		move.w	(a6)+,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,(a6)+
		subq.w	#1,d5
		bra.s	loc_4EEDA
; ---------------------------------------------------------------------------

loc_4EEEA:
		neg.w	d6
		lsr.w	#4,d6
		moveq	#$15,d4
		sub.w	d6,d4
		bcc.s	loc_4EEF8
		moveq	#0,d4
		moveq	#$15,d6

loc_4EEF8:

		movem.w	d1/d4-d6,-(sp)
		movem.l	a4/a6,-(sp)
		lea	2(a6),a5
		jsr	Draw_TileRow(pc)

loc_4EF08:
		movem.l	(sp)+,a4/a6

loc_4EF0C:
		movem.w	(sp)+,d1/d4-d6
		addq.w	#4,a6
		tst.w	d4
		beq.s	loc_4EF2C
		lsl.w	#4,d6
		add.w	d6,d1
		subq.w	#1,d5
		move.w	(a4)+,d6
		lsr.w	#4,d6
		move.w	d4,d0
		sub.w	d6,d4
		bcc.s	loc_4EEF8
		move.w	d0,d6
		moveq	#0,d4
		bra.s	loc_4EEF8
; ---------------------------------------------------------------------------

loc_4EF2C:

		subq.w	#1,d5
		beq.s	locret_4EF3A
		move.w	(a6)+,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,(a6)+
		bra.s	loc_4EF2C
; ---------------------------------------------------------------------------

locret_4EF3A:
		rts
; End of function DrawTilesVDeform2


; =============== S U B R O U T I N E =======================================


Get_XDeformRange:

		move.w	(a4)+,d2
		move.w	(a6),d0
		bsr.s	sub_4EF46
		addi.w	#$140,d0
; End of function Get_XDeformRange


; =============== S U B R O U T I N E =======================================


sub_4EF46:
		cmp.w	d2,d0
		bcs.s	loc_4EF50
		add.w	(a4)+,d2
		addq.w	#4,a5
		bra.s	sub_4EF46
; ---------------------------------------------------------------------------

loc_4EF50:
		move.w	(a5),d1
		swap	d1
		rts
; End of function sub_4EF46


; =============== S U B R O U T I N E =======================================


Draw_PlaneVertBottomUp:

		movem.w	d1-d2,-(sp)
		bsr.s	Draw_PlaneVertSingleBottomUp
		movem.w	(sp)+,d1-d2
		bpl.s	Draw_PlaneVertSingleBottomUp
		rts
; End of function Draw_PlaneVertBottomUp


; =============== S U B R O U T I N E =======================================


Draw_PlaneVertSingleBottomUp:
		and.w	($FFFFEEAC).w,d2
		move.w	d2,d3
		addi.w	#$F0,d3
		and.w	($FFFFEEAC).w,d3
		move.w	($FFFFEEC8).w,d0
		cmp.w	d2,d0
		bcs.s	loc_4EF84
		cmp.w	d3,d0
		bhi.s	loc_4EF84
		moveq	#$20,d6
		jsr	Setup_TileRowDraw(pc)

loc_4EF84:

		subi.w	#$10,($FFFFEEC8).w
		subq.w	#1,($FFFFEECA).w
		rts
; End of function Draw_PlaneVertSingleBottomUp


; =============== S U B R O U T I N E =======================================


Draw_PlaneVertTopDown:

		and.w	($FFFFEEAC).w,d2
		move.w	d2,d3
		addi.w	#$F0,d3
		and.w	($FFFFEEAC).w,d3
		move.w	($FFFFEEC8).w,d0
		cmp.w	d2,d0
		bcs.s	loc_4EFB0
		cmp.w	d3,d0
		bhi.s	loc_4EFB0
		moveq	#$20,d6
		jsr	Setup_TileRowDraw(pc)

loc_4EFB0:

		addi.w	#$10,($FFFFEEC8).w
		subq.w	#1,($FFFFEECA).w
		rts
; End of function Draw_PlaneVertTopDown


; =============== S U B R O U T I N E =======================================


Draw_PlaneHorzRightToLeft:

		movem.w	d1-d2,-(sp)
		bsr.s	sub_4EFCA
		movem.w	(sp)+,d1-d2
		bpl.s	sub_4EFCA
		rts
; End of function Draw_PlaneHorzRightToLeft


; =============== S U B R O U T I N E =======================================


sub_4EFCA:
		andi.w	#-$10,d2
		move.w	d2,d3
		addi.w	#$1F0,d3
		andi.w	#-$10,d3
		move.w	($FFFFEEC8).w,d0
		cmp.w	d2,d0
		bcs.s	loc_4EFEA
		cmp.w	d3,d0
		bhi.s	loc_4EFEA
		moveq	#$10,d6
		jsr	Setup_TileColumnDraw(pc)

loc_4EFEA:

		subi.w	#$10,($FFFFEEC8).w
		subq.w	#1,($FFFFEECA).w
		rts
; End of function sub_4EFCA


; =============== S U B R O U T I N E =======================================


Draw_PlaneHorzLeftToRight:
		movem.w	d1-d2,-(sp)
		bsr.s	sub_4F004
		movem.w	(sp)+,d1-d2

loc_4F000:
		bpl.s	sub_4F004
		rts
; End of function Draw_PlaneHorzLeftToRight


; =============== S U B R O U T I N E =======================================


sub_4F004:
		andi.w	#-$10,d2

loc_4F008:
		move.w	d2,d3
		addi.w	#$1F0,d3
		andi.w	#-$10,d3
		move.w	($FFFFEEC8).w,d0
		cmp.w	d2,d0
		bcs.s	loc_4F024
		cmp.w	d3,d0
		bhi.s	loc_4F024
		moveq	#$10,d6
		jsr	Setup_TileColumnDraw(pc)

loc_4F024:

		addi.w	#$10,($FFFFEEC8).w
		subq.w	#1,($FFFFEECA).w
		rts
; End of function sub_4F004


; =============== S U B R O U T I N E =======================================


Draw_PlaneVertBottomUpComplex:

		movem.l	d1/a4-a5,-(sp)
		bsr.s	sub_4F03E
		movem.l	(sp)+,d1/a4-a5
		bpl.s	sub_4F03E
		rts
; End of function Draw_PlaneVertBottomUpComplex


; =============== S U B R O U T I N E =======================================


sub_4F03E:
		and.w	($FFFFEEAC).w,d1
		move.w	d1,d2
		addi.w	#$F0,d2
		and.w	($FFFFEEAC).w,d2
		move.w	($FFFFEEC8).w,d0
		cmp.w	d1,d0
		bcs.s	loc_4F066
		cmp.w	d2,d0
		bhi.s	loc_4F066

loc_4F058:
		addq.w	#4,a5
		cmp.w	(a4)+,d0
		bpl.s	loc_4F058
		move.w	(a5),d1
		moveq	#$20,d6
		jsr	Setup_TileRowDraw(pc)

loc_4F066:

		subi.w	#$10,($FFFFEEC8).w
		subq.w	#1,($FFFFEECA).w
		rts
; End of function sub_4F03E


; =============== S U B R O U T I N E =======================================


PlainDeformation:

		lea	($FFFFE000).w,a1
		move.w	($FFFFEE80).w,d0
		neg.w	d0
		swap	d0
		move.w	($FFFFEE8C).w,d0
		neg.w	d0
		moveq	#$37,d1

loc_4F086:
		move.l	d0,(a1)+
		move.l	d0,(a1)+
		move.l	d0,(a1)+
		move.l	d0,(a1)+
		dbf	d1,loc_4F086
		rts
; End of function PlainDeformation


; =============== S U B R O U T I N E =======================================


PlainDeformation_Flipped:

		lea	($FFFFE000).w,a1
		move.w	($FFFFEE8C).w,d0
		neg.w	d0
		swap	d0
		move.w	($FFFFEE80).w,d0
		neg.w	d0
		moveq	#$37,d1

loc_4F0A8:
		move.l	d0,(a1)+
		move.l	d0,(a1)+
		move.l	d0,(a1)+
		move.l	d0,(a1)+
		dbf	d1,loc_4F0A8
		rts
; End of function PlainDeformation_Flipped


; =============== S U B R O U T I N E =======================================


sub_4F0B6:
		move.w	d1,d0
		lsr.w	#1,d0
		bcc.s	loc_4F0C2

loc_4F0BC:
		move.w	(a6)+,d5
		add.w	d6,d5
		move.w	d5,(a1)+

loc_4F0C2:
		move.w	(a6)+,d5
		add.w	d6,d5
		move.w	d5,(a1)+
		dbf	d0,loc_4F0BC
		rts
; End of function sub_4F0B6


; =============== S U B R O U T I N E =======================================


ApplyDeformation:

		move.w	#$DF,d1
		lea	($FFFFE000).w,a1
		move.w	($FFFFEE90).w,d0
		move.w	($FFFFEE80).w,d3

ApplyDeformation2:

		move.w	(a4)+,d2
		smi	d4
		bpl.s	loc_4F0E8
		andi.w	#$7FFF,d2

loc_4F0E8:
		sub.w	d2,d0
		bmi.s	loc_4F0FA
		addq.w	#2,a5
		tst.b	d4
		beq.s	ApplyDeformation2
		subq.w	#2,a5
		add.w	d2,d2
		adda.w	d2,a5
		bra.s	ApplyDeformation2
; ---------------------------------------------------------------------------

loc_4F0FA:
		tst.b	d4
		beq.s	loc_4F104
		add.w	d0,d2
		add.w	d2,d2
		adda.w	d2,a5

loc_4F104:
		neg.w	d0
		move.w	d1,d2
		sub.w	d0,d2
		bcc.s	loc_4F110
		move.w	d1,d0
		addq.w	#1,d0

loc_4F110:
		neg.w	d3
		swap	d3

loc_4F114:
		subq.w	#1,d0

loc_4F116:
		tst.b	d4
		beq.s	loc_4F130
		lsr.w	#1,d0
		bcc.s	loc_4F124

loc_4F11E:
		move.w	(a5)+,d3
		neg.w	d3
		move.l	d3,(a1)+

loc_4F124:
		move.w	(a5)+,d3
		neg.w	d3
		move.l	d3,(a1)+
		dbf	d0,loc_4F11E
		bra.s	loc_4F140
; ---------------------------------------------------------------------------

loc_4F130:
		move.w	(a5)+,d3
		neg.w	d3
		lsr.w	#1,d0
		bcc.s	loc_4F13A

loc_4F138:
		move.l	d3,(a1)+

loc_4F13A:
		move.l	d3,(a1)+
		dbf	d0,loc_4F138

loc_4F140:
		tst.w	d2
		bmi.s	locret_4F158
		move.w	(a4)+,d0
		smi	d4
		bpl.s	loc_4F14E
		andi.w	#$7FFF,d0

loc_4F14E:
		move.w	d2,d3
		sub.w	d0,d2
		bpl.s	loc_4F114
		move.w	d3,d0
		bra.s	loc_4F116
; ---------------------------------------------------------------------------

locret_4F158:
		rts
; End of function ApplyDeformation


; =============== S U B R O U T I N E =======================================


ApplyFGDeformation:

		move.w	#$DF,d1
		lea	($FFFFE000).w,a1
		move.w	($FFFFEE84).w,d0
		move.w	($FFFFEE8C).w,d3

ApplyFGDeformation2:

		move.w	(a4)+,d2
		smi	d4
		bpl.s	loc_4F174
		andi.w	#$7FFF,d2

loc_4F174:
		sub.w	d2,d0
		bmi.s	loc_4F186
		addq.w	#2,a5
		tst.b	d4
		beq.s	ApplyFGDeformation2
		subq.w	#2,a5
		add.w	d2,d2
		adda.w	d2,a5
		bra.s	ApplyFGDeformation2
; ---------------------------------------------------------------------------

loc_4F186:
		tst.b	d4
		beq.s	loc_4F190
		add.w	d0,d2
		add.w	d2,d2
		adda.w	d2,a5

loc_4F190:
		neg.w	d0
		move.w	d1,d2
		sub.w	d0,d2
		bcc.s	loc_4F19C
		move.w	d1,d0
		addq.w	#1,d0

loc_4F19C:
		neg.w	d3

loc_4F19E:
		subq.w	#1,d0

loc_4F1A0:
		tst.b	d4
		beq.s	loc_4F1C2
		lsr.w	#1,d0
		bcc.s	loc_4F1B2

loc_4F1A8:
		swap	d3
		move.w	(a5)+,d3
		neg.w	d3
		swap	d3
		move.l	d3,(a1)+

loc_4F1B2:
		swap	d3
		move.w	(a5)+,d3
		neg.w	d3
		swap	d3
		move.l	d3,(a1)+
		dbf	d0,loc_4F1A8
		bra.s	loc_4F1D6
; ---------------------------------------------------------------------------

loc_4F1C2:
		swap	d3
		move.w	(a5)+,d3
		neg.w	d3
		swap	d3
		lsr.w	#1,d0
		bcc.s	loc_4F1D0

loc_4F1CE:
		move.l	d3,(a1)+

loc_4F1D0:
		move.l	d3,(a1)+
		dbf	d0,loc_4F1CE

loc_4F1D6:
		tst.w	d2
		bmi.s	locret_4F1EE
		move.w	(a4)+,d0
		smi	d4
		bpl.s	loc_4F1E4
		andi.w	#$7FFF,d0

loc_4F1E4:
		move.w	d2,d1
		sub.w	d0,d2
		bpl.s	loc_4F19E
		move.w	d1,d0
		bra.s	loc_4F1A0
; ---------------------------------------------------------------------------

locret_4F1EE:
		rts
; End of function ApplyFGDeformation

; ---------------------------------------------------------------------------

ApplyFGandBGDeformation:
		swap	d7
		swap	d3

loc_4F1F4:

		move.w	(a4)+,d3
		smi	d7
		bpl.s	loc_4F1FE
		andi.w	#$7FFF,d3

loc_4F1FE:
		sub.w	d3,d0
		bmi.s	loc_4F210
		addq.w	#2,a5
		tst.b	d7
		beq.s	loc_4F1F4
		subq.w	#2,a5

loc_4F20A:
		add.w	d3,d3

loc_4F20C:
		adda.w	d3,a5
		bra.s	loc_4F1F4
; ---------------------------------------------------------------------------

loc_4F210:
		tst.b	d7
		beq.s	loc_4F21A
		add.w	d0,d3
		add.w	d3,d3
		adda.w	d3,a5

loc_4F21A:
		swap	d3
		neg.w	d0
		move.w	d1,d4
		sub.w	d0,d4
		bcc.s	loc_4F228
		move.w	d1,d0
		addq.w	#1,d0

loc_4F228:

		subq.w	#1,d0

loc_4F22A:
		tst.b	d7
		beq.s	loc_4F250
		lsr.w	#1,d0
		bcc.s	loc_4F23E

loc_4F232:
		move.w	(a2)+,d6
		swap	d6
		move.w	(a5)+,d6
		neg.w	d6
		add.w	(a6)+,d6
		move.l	d6,(a1)+

loc_4F23E:
		move.w	(a2)+,d6
		swap	d6
		move.w	(a5)+,d6
		neg.w	d6
		add.w	(a6)+,d6
		move.l	d6,(a1)+
		dbf	d0,loc_4F232
		bra.s	loc_4F270
; ---------------------------------------------------------------------------

loc_4F250:
		move.w	(a5)+,d5
		neg.w	d5
		lsr.w	#1,d0
		bcc.s	loc_4F262

loc_4F258:
		move.w	(a2)+,d6
		swap	d6
		move.w	(a6)+,d6
		add.w	d5,d6
		move.l	d6,(a1)+

loc_4F262:
		move.w	(a2)+,d6
		swap	d6
		move.w	(a6)+,d6
		add.w	d5,d6
		move.l	d6,(a1)+
		dbf	d0,loc_4F258

loc_4F270:
		tst.w	d4
		bmi.s	loc_4F288
		move.w	(a4)+,d0
		smi	d7
		bpl.s	loc_4F27E
		andi.w	#$7FFF,d0

loc_4F27E:
		move.w	d4,d5
		sub.w	d0,d4
		bpl.s	loc_4F228
		move.w	d5,d0
		bra.s	loc_4F22A
; ---------------------------------------------------------------------------

loc_4F288:
		swap	d7
		rts

; =============== S U B R O U T I N E =======================================


Apply_FGVScroll:

		lea	($FFFFEEEA).w,a1
		move.w	($FFFFEE90).w,d1
		move.w	($FFFFEE80).w,d0
		move.w	d0,d2
		andi.w	#$F,d2
		beq.s	loc_4F2A4
		addi.w	#$10,d0

loc_4F2A4:
		lsr.w	#4,d0

loc_4F2A6:
		addq.w	#2,a5
		move.w	(a4)+,d2
		lsr.w	#4,d2
		sub.w	d2,d0
		bpl.s	loc_4F2A6
		neg.w	d0
		moveq	#$13,d2
		sub.w	d0,d2
		bcc.s	loc_4F2BA
		moveq	#$14,d0

loc_4F2BA:

		subq.w	#1,d0

loc_4F2BC:
		move.w	(a5)+,d3

loc_4F2BE:
		move.w	d3,(a1)+
		move.w	d1,(a1)+
		dbf	d0,loc_4F2BE
		tst.w	d2
		bmi.s	locret_4F2D8
		move.w	(a4)+,d0
		lsr.w	#4,d0
		move.w	d2,d3
		sub.w	d0,d2
		bpl.s	loc_4F2BA
		move.w	d3,d0
		bra.s	loc_4F2BC
; ---------------------------------------------------------------------------

locret_4F2D8:
		rts
; End of function Apply_FGVScroll


; =============== S U B R O U T I N E =======================================


Reset_TileOffsetPositionActual:

		move.w	($FFFFEE80).w,d0
		move.w	d0,d1
		andi.w	#-$10,d0
		move.w	d0,($FFFFEE88).w
		move.w	($FFFFEE84).w,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEE8A).w
		rts
; End of function Reset_TileOffsetPositionActual


; =============== S U B R O U T I N E =======================================


Reset_TileOffsetPositionEff:

		move.w	($FFFFEE8C).w,d0
		move.w	d0,d1
		andi.w	#-$10,d0
		move.w	d0,d2
		move.w	d0,($FFFFEE94).w
		move.w	($FFFFEE90).w,d0

loc_4F30A:
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEE96).w
		rts
; End of function Reset_TileOffsetPositionEff

; ---------------------------------------------------------------------------
		move.w	($FFFFEE60).w,($FFFFEE68).w
		move.w	($FFFFEE64).w,($FFFFEE6C).w
		rts
; ---------------------------------------------------------------------------
		move.w	($FFFFEE6C).w,d0
		subi.w	#$70,d0
		move.w	d0,($FFFFF61E).w
		move.w	($FFFFEE74).w,d0
		subi.w	#$70,d0
		move.w	d0,($FFFFF620).w
		rts

; =============== S U B R O U T I N E =======================================


SpecialEvents:
		cmpi.b	#6,($FFFFB005).w
		bcc.s	locret_4F366
		move.w	($FFFFEEB2).w,d0
		movea.l	off_4F34E(pc,d0.w),a0
		jmp	(a0)
; ---------------------------------------------------------------------------
off_4F34E:	dc.l locret_4F366
		dc.l AIZ2_DoShipLoop
		dc.l loc_54CB0
		dc.l loc_5560C
		dc.l loc_569BA
		dc.l loc_59E46
; ---------------------------------------------------------------------------

locret_4F366:

		rts
; End of function SpecialEvents


; =============== S U B R O U T I N E =======================================


Adjust_BGDuringLoop:

		move.w	(a1),d1
		move.w	d0,(a1)+
		sub.w	d1,d0
		bpl.s	loc_4F37C
		neg.w	d0
		cmp.w	d2,d0
		bcs.s	loc_4F378
		sub.w	d3,d0

loc_4F378:
		sub.w	d0,(a1)+
		rts
; ---------------------------------------------------------------------------

loc_4F37C:
		cmp.w	d2,d0
		bcs.s	loc_4F382
		sub.w	d3,d0

loc_4F382:
		add.w	d0,(a1)+
		rts
; End of function Adjust_BGDuringLoop


; =============== S U B R O U T I N E =======================================


Get_BGActualEffectiveDiff:

		move.w	($FFFFEE80).w,d0
		sub.w	($FFFFEE8C).w,d0
		move.w	d0,($FFFFEE3E).w
		move.w	($FFFFEE84).w,d0
		sub.w	($FFFFEE90).w,d0
		move.w	d0,($FFFFEE40).w
		rts
; End of function Get_BGActualEffectiveDiff


; =============== S U B R O U T I N E =======================================


Offset_SomeObjectsDuringTransition:

		tst.b	($FFFFF667).w
		bne.s	loc_4F3A8
		rts
; ---------------------------------------------------------------------------

loc_4F3A8:
		lea	($FFFFCD7C).w,a1
		moveq	#3,d2
		bra.s	loc_4F3B6
; ---------------------------------------------------------------------------

Offset_ObjectsDuringTransition:


		lea	($FFFFB128).w,a1
		moveq	#$59,d2

loc_4F3B6:

		tst.l	(a1)
		beq.s	loc_4F3CA
		btst	#2,4(a1)
		beq.s	loc_4F3CA
		sub.w	d0,$10(a1)
		sub.w	d1,$14(a1)

loc_4F3CA:

		lea	$4A(a1),a1
		dbf	d2,loc_4F3B6
		rts
; End of function Offset_SomeObjectsDuringTransition


; =============== S U B R O U T I N E =======================================


ShakeScreen_Setup:

		move.w	($FFFFEECE).w,($FFFFEED0).w
		moveq	#0,d1
		cmpi.b	#6,($FFFFB005).w
		bcc.s	loc_4F406
		move.w	($FFFFEECC).w,d0
		beq.s	loc_4F406
		bmi.s	loc_4F3FA
		subq.w	#1,d0					; If EECC is positive, then it's a timed screen shake
		move.w	d0,($FFFFEECC).w
		move.b	ScreenShakeArray(pc,d0.w),d1
		ext.w	d1
		bra.s	loc_4F406
; ---------------------------------------------------------------------------

loc_4F3FA:
		move.w	($FFFFFE04).w,d0		; If EECC is negative, it's a constant screen shake

loc_4F3FE:
		andi.w	#$3F,d0

loc_4F402:
		move.b	ScreenShakeArray2(pc,d0.w),d1

loc_4F406:

		move.w	d1,($FFFFEECE).w
		rts
; End of function ShakeScreen_Setup


; =============== S U B R O U T I N E =======================================


ShakeScreen_BG:
		move.w	($FFFFEF66).w,d0
		beq.s	locret_4F422
		subq.w	#1,d0
		move.w	d0,($FFFFEF66).w
		move.b	ScreenShakeArray(pc,d0.w),d0
		ext.w	d0
		add.w	d0,($FFFFEE80).w

locret_4F422:
		rts
; End of function ShakeScreen_BG

; ---------------------------------------------------------------------------
ScreenShakeArray:	dc.b 1,$FF,1,$FF,2,$FE,2,$FE,3,$FD,3,$FD,4,$FC,4,$FC,5,$FB,5,$FB
ScreenShakeArray2:     dc.b   1,  2,  1,  3,  1,  2,  2,  1,  2,  3,  1,  2,  1,  2,  0,  0
		dc.b   2,  0,  3,  2,  2,  3,  2,  2,  1,  3,  0,  0,  1,  0,  1,  3
		dc.b   1,  2,  1,  3,  1,  2,  2,  1,  2,  3,  1,  2,  1,  2,  0,  0
		dc.b   2,  0,  3,  2,  2,  3,  2,  2,  1,  3,  0,  0,  1,  0,  1,  3
		dc.w     1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    0,    0,    0
		dc.w     0,    0,    0,    0,    0,    0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF
		dc.w $FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,    0,    0,    0,    0
		dc.w     0,    0,    0,    0,    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1
		dc.w     1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    0,    0,    0
		dc.w     0,    0,    0,    0,    0,    0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF
		dc.w $FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,    0,    0,    0,    0
		dc.w     0,    0,    0,    0,    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1
		dc.w     1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    0,    0,    0
		dc.w     0,    0,    0,    0,    0,    0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF
		dc.w $FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,    0,    0,    0,    0
		dc.w     0,    0,    0,    0,    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1
		dc.w     1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    0,    0,    0
		dc.w     0,    0,    0,    0,    0,    0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF
		dc.w $FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,    0,    0,    0,    0
		dc.w     0,    0,    0,    0,    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1
		dc.w     1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    0,    0,    0
		dc.w     0,    0,    0,    0,    0,    0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF
		dc.w     0,    0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,    0,    0,    0,    1,    1,    1,    1,    1
		dc.w     1,    0,    0,    0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,    0,    0,    0,    1,    1,    1
		dc.w     1,    1,    1,    0,    0,    0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,    0,    0,    0,    1
		dc.w     1,    1,    1,    1,    1,    0,$FFFF,$FFFE,$FFFE,$FFFF,    0,    2,    2,    2,    2,    0
		dc.w     0,    0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,    0,    0,    0,    1,    1,    1,    1,    1
		dc.w     1,    0,    0,    0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,    0,    0,    0,    1,    1,    1
LBZ_WaterWaveArray2:     dc.w     1,    1,    1,    0,    0,    0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,    0,    0,    0,    1
		dc.w     1,    1,    1,    1,    1,    0,$FFFF,$FFFE,$FFFE,$FFFF,    0,    2,    2,    2,    2,    0
		dc.w     0,    0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,    0,    0,    0,    1,    1,    1,    1,    1
		dc.w     1,    0,    0,    0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,    0,    0,    0,    1,    1,    1
		dc.w     1,    1,    1,    0,    0,    0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,    0,    0,    0,    1
		dc.w     1,    1,    1,    1,    1,    0,$FFFF,$FFFE,$FFFE,$FFFF,    0,    2,    2,    2,    2,    0
		dc.w     0,    0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,    0,    0,    0,    1,    1,    1,    1,    1
		dc.w     1,    0,    0,    0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,    0,    0,    0,    1,    1,    1
LBZ_WaterWaveArray:     dc.w     1,    1,    1,    0,    0,    0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,    0,    0,    0,    1
		dc.w     1,    1,    1,    1,    1,    0,$FFFF,$FFFE,$FFFE,$FFFF,    0,    2,    2,    2,    2,    0
		dc.w     0,    0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,    0,    0,    0,    1,    1,    1,    1,    1
		dc.w     1,    0,    0,    0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,    0,    0,    0,    1,    1,    1


; =============== S U B R O U T I N E =======================================


Clear_Switches:


		lea	($FFFFF7E0).w,a1
		moveq	#7,d0

loc_4F8FE:
		clr.l	(a1)+
		dbf	d0,loc_4F8FE
		rts
; End of function Clear_Switches

; ---------------------------------------------------------------------------

AIZ1_ScreenInit:
		jsr	Adjust_AIZ1Chunks(pc)
		jsr	Reset_TileOffsetPositionActual(pc)
		jmp	Refresh_PlaneFull(pc)
; ---------------------------------------------------------------------------

AIZ1_ScreenEvent:
		jsr	DrawTilesAsYouMove(pc)
		move.w	($FFFFEEC4).w,d0
		beq.w	locret_4F9BE
		cmpi.w	#$2D30,($FFFFEE78).w		; perform the tree tile manipulation routine when signalled.
		bcc.w	AIZ1SE_ChangeChunk1
		cmpi.w	#$39,d0
		bcc.w	AIZ1SE_ChangeChunk1
		cmpi.w	#$34,d0
		bcs.s	loc_4F93C
		bsr.w	AIZ1SE_ChangeChunk2
		bra.s	loc_4F952
; ---------------------------------------------------------------------------

loc_4F93C:
		cmpi.w	#$24,d0
		bcs.s	loc_4F948
		bsr.w	AIZ1SE_ChangeChunk3
		bra.s	loc_4F952
; ---------------------------------------------------------------------------

loc_4F948:
		cmpi.w	#$14,d0
		bcs.s	loc_4F952
		bsr.w	AIZ1SE_ChangeChunk4

loc_4F952:

		lea	(AIZ_TreeRevealArray).l,a6
		btst	#0,d0
		bne.s	loc_4F962
		lea	$10(a6),a6

loc_4F962:
		subq.w	#1,d0
		lsr.w	#1,d0
		move.w	d0,($FFFFEED2).w
		cmpi.w	#3,d0
		bcs.s	loc_4F976
		move.w	#2,($FFFFEED2).w

loc_4F976:
		lsl.w	#4,d0
		neg.w	d0
		addi.w	#$470,d0

loc_4F97E:

		cmp.w	($FFFFEE8A).w,d0
		bcc.s	loc_4F994
		lea	$20(a6),a6
		addi.w	#$10,d0
		subq.w	#1,($FFFFEED2).w
		bpl.s	loc_4F97E
		bra.s	AIZ1SE_ChangeChunk1
; ---------------------------------------------------------------------------

loc_4F994:
		move.w	#$2C80,d1
		moveq	#$10,d6
		move.l	a0,-(sp)
		jsr	Setup_TileRowDraw(pc)
		movea.l	(sp)+,a0
		subi.w	#$280,d0
		moveq	#0,d1
		moveq	#$F,d6
		jsr	(AIZ_TreeReveal).l
		lea	$10(a6),a6
		addi.w	#$290,d0
		subq.w	#1,($FFFFEED2).w
		bpl.s	loc_4F97E

locret_4F9BE:
		rts
; ---------------------------------------------------------------------------

AIZ1SE_ChangeChunk1:

		clr.w	($FFFFEEC4).w		; When this is run, all chunks have been changed and the routine need not be run anymore
		movea.w	$14(a3),a1
		movea.w	(a3),a5
		move.b	(a5),$59(a1)
		move.b	1(a5),$5A(a1)

; =============== S U B R O U T I N E =======================================


AIZ1SE_ChangeChunk2:
		movea.w	$18(a3),a1
		movea.w	4(a3),a5
		move.b	(a5),$59(a1)
		move.b	1(a5),$5A(a1)
; End of function AIZ1SE_ChangeChunk2


; =============== S U B R O U T I N E =======================================


AIZ1SE_ChangeChunk3:
		movea.w	$1C(a3),a1
		movea.w	8(a3),a5
		move.b	(a5),$59(a1)
		move.b	1(a5),$5A(a1)
; End of function AIZ1SE_ChangeChunk3


; =============== S U B R O U T I N E =======================================


AIZ1SE_ChangeChunk4:
		movea.w	$20(a3),a1
		movea.w	$C(a3),a5
		move.b	(a5),$59(a1)
		move.b	1(a5),$5A(a1)
		rts
; End of function AIZ1SE_ChangeChunk4

; ---------------------------------------------------------------------------

Obj_AIZ1TreeRevealControl:
		tst.w	$2E(a0)
		beq.s	loc_4FA1E
		tst.w	($FFFFEEC4).w
		bne.s	loc_4FA1E
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_4FA1E:

		subq.w	#1,$2E(a0)
		move.w	#$480,d0
		sub.w	($FFFFB014).w,d0
		lsr.w	#3,d0
		addq.w	#3,d0
		cmp.w	($FFFFEEC4).w,d0
		bcc.s	loc_4FA3C
		btst	#0,$2F(a0)
		beq.s	locret_4FA40

loc_4FA3C:
		addq.w	#1,($FFFFEEC4).w

locret_4FA40:
		rts

; =============== S U B R O U T I N E =======================================


Adjust_AIZ1Chunks:
		cmpi.w	#3,($FFFFFF08).w
		beq.s	Adjust_AIZ1Chunks2			; Make changes to AIZ's chunk data if playing as Knuckles
		rts
; End of function Adjust_AIZ1Chunks


; =============== S U B R O U T I N E =======================================


Adjust_AIZ1Chunks2:

		lea	($FFFFFCF0).w,a1
		lea	word_4FAE4(pc),a5
		move.l	(a5)+,(a1)+
		move.l	(a5),(a1)
		lea	($FF4C70).l,a1
		bsr.s	sub_4FAD8
		lea	($FF4CF0).l,a1
		bsr.s	sub_4FAD8
		lea	($FF4D70).l,a1
		bsr.s	sub_4FAD8
		lea	($FF52F0).l,a1
		bsr.s	sub_4FAD8
		lea	($FF4980).l,a1
		bsr.s	sub_4FAD8
		lea	($FF4D80).l,a1
		bsr.s	sub_4FAD8
		lea	($FF3420).l,a1
		bsr.s	sub_4FAD8
		move.w	#$402,(a1)+
		moveq	#5,d1
		bsr.s	sub_4FADA
		move.w	#2,(a1)
		lea	($FF3FA0).l,a1
		bsr.s	sub_4FAD8
		addq.w	#4,a1
		move.w	#$C,(a1)+
		move.w	#$406,(a1)+
		move.w	#$4B,(a1)+
		move.w	#$4B,(a1)+
		move.w	#$40A,2(a1)
		lea	($FF5820).l,a1
		move.w	#$40B,(a1)+
		moveq	#5,d1
		bsr.s	sub_4FADA
		addq.w	#6,a1
		move.w	#$C,(a1)+
		move.w	#$406,(a1)+
		moveq	#1,d1
		bra.s	sub_4FADA
; End of function Adjust_AIZ1Chunks2


; =============== S U B R O U T I N E =======================================


sub_4FAD8:

		moveq	#7,d1
; End of function sub_4FAD8


; =============== S U B R O U T I N E =======================================


sub_4FADA:

		moveq	#$4B,d0

loc_4FADC:
		move.w	d0,(a1)+
		dbf	d1,loc_4FADC
		rts
; End of function sub_4FADA

; ---------------------------------------------------------------------------
word_4FAE4:	dc.w   $EE4,  $EA6,  $E62

word_4FAEA:	dc.w $E40
; ---------------------------------------------------------------------------

AIZ1_BackgroundInit:
		cmpi.w	#$1300,($FFFFEE78).w
		bcc.s	loc_4FB1C
		lea	($FFFFA800).w,a1			; Intro deformation
		moveq	#9,d0

loc_4FAFA:
		clr.l	(a1)+
		dbf	d0,loc_4FAFA

loc_4FB00:
		jsr	(AIZ1_IntroDeform).l
		jsr	Reset_TileOffsetPositionEff(pc)
		jsr	Refresh_PlaneFull(pc)

loc_4FB0E:
		lea	(AIZ1_IntroDeformArray).l,a4
		lea	($FFFFA828).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------

loc_4FB1C:
		move.w	#8,($FFFFEEC2).w			; If not in the intro
		jsr	(AIZ1_Deform).l
		jsr	Reset_TileOffsetPositionEff(pc)
		clr.l	($FFFFA800).w
		move.w	d2,($FFFFA806).w
		lea	(AIZ1_DrawArray).l,a4
		lea	($FFFFA800).w,a5
		jsr	Refresh_PlaneTileDeform(pc)
		jmp	(AIZ1_ApplyDeformWater).l
; ---------------------------------------------------------------------------

AIZ1_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_4FB50(pc,d0.w)
; ---------------------------------------------------------------------------

loc_4FB50:
		bra.w	AIZ1BGE_Intro
; ---------------------------------------------------------------------------
		bra.w	AIZ1BGE_NormalRefresh
; ---------------------------------------------------------------------------
		bra.w	AIZ1BGE_Normal
; ---------------------------------------------------------------------------
		bra.w	AIZ1BGE_FireTransition
; ---------------------------------------------------------------------------
		bra.w	AIZ1BGE_FireRefresh
; ---------------------------------------------------------------------------
		bra.w	AIZ1BGE_Finish
; ---------------------------------------------------------------------------

AIZ1BGE_Intro:
		tst.w	($FFFFEEC6).w
		beq.s	loc_4FBA4
		tst.w	($FFFFFF0E).w
		bne.w	loc_4FBA4
		clr.w	($FFFFEEC6).w
		jsr	(AIZ1_Deform).l							; Set up normal deformation when intro is over
		jsr	Reset_TileOffsetPositionEff(pc)
		clr.l	($FFFFA800).w
		move.w	d2,($FFFFA806).w
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w				; Next routine
		bra.s	loc_4FBD0
; ---------------------------------------------------------------------------

loc_4FBA4:

		jsr	(AIZ1_IntroDeform).l
		lea	(AIZ1_IntroDrawArray).l,a4
		lea	($FFFFA800).w,a5
		moveq	#$20,d6
		moveq	#$A,d5
		jsr	Draw_BG(pc)
		lea	(AIZ1_IntroDeformArray).l,a4
		lea	($FFFFA828).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------

AIZ1BGE_NormalRefresh:
		jsr	(AIZ1_Deform).l

loc_4FBD0:
		lea	(AIZ1_DrawArray).l,a4
		lea	($FFFFA7FC).w,a5
		move.w	($FFFFEE90).w,d1
		jsr	Draw_PlaneVertBottomUpComplex(pc)
		bpl.s	loc_4FBF6
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_4FBF6
; ---------------------------------------------------------------------------

AIZ1BGE_Normal:
		tst.w	($FFFFEEC6).w
		bne.s	AIZ1_AIZ2_Transition		; Wait for signal to start level transition
		jsr	(AIZ1_Deform).l

loc_4FBF6:

		lea	(AIZ1_DrawArray).l,a4
		lea	($FFFFA800).w,a5
		moveq	#$20,d6
		moveq	#2,d5
		jsr	Draw_BG(pc)

loc_4FC08:
		jmp	(AIZ1_ApplyDeformWater).l
; ---------------------------------------------------------------------------

AIZ1_AIZ2_Transition:
		clr.w	($FFFFEEC6).w
		lea	($FFFFFC62).w,a1
		move.l	#$4E006E,(a1)+
		move.l	#$AE00CE,(a1)+
		move.l	#$2EE0AEE,(a1)
		move.l	#$200000,($FFFFEE90).w
		move.w	#$10,($FFFFEE96).w
		move.w	#$68,($FFFFEED2).w
		move.w	#4,($FFFFEEA6).w
		addq.w	#4,($FFFFEEC2).w

AIZ1BGE_FireTransition:
		tst.w	($FFFFEED4).w
		bne.s	loc_4FC6E
		cmpi.b	#6,($FFFFB005).w
		bcc.s	loc_4FC74
		move.w	($FFFFEED2).w,d0
		swap	d0
		clr.w	d0
		sub.l	($FFFFEE90).w,d0
		asr.l	#5,d0
		add.l	d0,($FFFFEE90).w
		cmpi.l	#$1400,d0
		bcc.s	loc_4FC74

loc_4FC6E:
		jsr	(AIZ1_FireRise).l

loc_4FC74:

		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		move.w	#$1000,d1
		moveq	#$20,d6
		jsr	Draw_TileRow(pc)
		cmpi.w	#$190,($FFFFEE90).w
		bcs.w	loc_4FD22
		movem.l	d7-a0/a2-a3,-(sp)
		lea	(AIZ2_128x128_Kos).l,a1
		lea	($FFFF0000).l,a2
		jsr	(Queue_Kos).l
		lea	(AIZ2_16x16_Primary_Kos).l,a1
		lea	($FFFF9000).w,a2
		jsr	(Queue_Kos).l
		lea	(AIZ2_16x16_Secondary_Kos).l,a1
		lea	($FFFF9AB8).w,a2
		jsr	(Queue_Kos).l
		lea	(AIZ2_8x8_Primary_KosM).l,a1
		move.w	#0,d2
		jsr	(Queue_Kos_Module).l
		lea	(AIZ2_8x8_Secondary_KosM).l,a1
		move.w	#$3F80,d2
		jsr	(Queue_Kos_Module).l
		lea	(PLC_SpikesSprings).l,a1
		jsr	(Load_PLC_Raw).l

loc_4FCF2:
		movem.l	(sp)+,d7-a0/a2-a3
		jsr	(Create_New_Sprite).l
		bne.s	loc_4FD10
		move.l	#Obj_AIZTransitionFloor,(a1)
		move.w	#$2FB0,$10(a1)

loc_4FD0A:
		move.w	#$3A0,$14(a1)

loc_4FD10:
		move.w	#$F0,($FFFFEEC8).w

loc_4FD16:
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_4FD32
; ---------------------------------------------------------------------------

loc_4FD22:
		jsr	(AIZTrans_WavyFlame).l
		jmp	PlainDeformation(pc)
; ---------------------------------------------------------------------------

AIZ1BGE_FireRefresh:
		jsr	(AIZ1_FireRise).l

loc_4FD32:
		lea	($FFFF8008).w,a3
		move.w	#$C000,d7
		move.w	#$180,d1
		moveq	#0,d2
		jsr	Draw_PlaneVertBottomUp(pc)	; Refresh main plane
		bpl.s	loc_4FD52
		addq.w	#2,a3
		move.w	#$E000,d7
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_4FD62
; ---------------------------------------------------------------------------

loc_4FD52:
		jsr	(AIZTrans_WavyFlame).l
		jmp	PlainDeformation(pc)
; ---------------------------------------------------------------------------

AIZ1BGE_Finish:
		jsr	(AIZ1_FireRise).l

loc_4FD62:
		tst.b	($FFFFFF60).w
		bne.w	loc_4FE2E		; Wait for the art to be loaded
		move.w	#1,($FFFFFE10).w	; Officially change this to act 2
		clr.b	($FFFFEE33).w
		clr.b	($FFFFF76C).w
		clr.b	($FFFFF710).w
		clr.b	($FFFFF7AA).w
		clr.b	($FFFFFF97).w
		jsr	Clear_Switches(pc)
		movem.l	d7-a0/a2-a3,-(sp)
		jsr	(Load_Level).l
		jsr	(LoadSolids).l
		jsr	(CheckLevelForWater).l
		moveq	#$B,d0
		jsr	(LoadPalette_Immediate).l
		movem.l	(sp)+,d7-a0/a2-a3
		jsr	Adjust_AIZ2Layout(pc)
		lea	($FFFFFC62).w,a1
		move.l	#$4E006E,(a1)+
		move.l	#$AE00CE,(a1)+
		move.l	#$2EE0AEE,(a1)
		move.w	#$2F00,d0
		move.w	#$80,d1
		sub.w	d0,($FFFFB010).w
		sub.w	d1,($FFFFB014).w
		sub.w	d0,($FFFFB05A).w
		sub.w	d1,($FFFFB05E).w
		jsr	Offset_SomeObjectsDuringTransition(pc)
		sub.w	d0,($FFFFEE78).w
		sub.w	d1,($FFFFEE7C).w
		sub.w	d0,($FFFFEE80).w
		sub.w	d1,($FFFFEE84).w		; Offset objects and camera positions
		move.l	#$100010,d0
		move.l	d0,($FFFFEE14).w
		move.l	#$260,d0
		move.l	d0,($FFFFEE18).w
		move.w	d0,($FFFFEE12).w
		move.w	($FFFFEE80).w,($FFFFEEB4).w
		move.w	($FFFFEE80).w,($FFFFEEB6).w
		jsr	Reset_TileOffsetPositionActual(pc)
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		clr.w	($FFFFEEC2).w

loc_4FE2E:
		jsr	(AIZTrans_WavyFlame).l
		jmp	PlainDeformation(pc)
; ---------------------------------------------------------------------------

Obj_AIZTransitionFloor:
		tst.b	($FFFFFE11).w
		beq.s	loc_4FE4A
		move.w	#$7FFF,$10(a0)
		move.l	#Delete_Current_Sprite,(a0)

loc_4FE4A:
		move.b	#$10,6(a0)
		bset	#7,$2A(a0)
		move.w	#$A0,d1
		moveq	#$10,d2
		moveq	#$10,d3
		move.w	$10(a0),d4
		jmp	(SolidObjectTop).l

; =============== S U B R O U T I N E =======================================


Adjust_AIZ2Layout:

		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_4FECC
		move.w	#$5B,($FF1020).l		; Only do this if playing as Knuckles
		lea	($FF3420).l,a1
		moveq	#7,d1
		bsr.s	sub_4FF00
		move.w	#$CAE,(a1)+
		moveq	#5,d1
		bsr.s	sub_4FF00
		move.w	#$8AE,(a1)
		lea	($FF3FA0).l,a1
		moveq	#7,d1
		bsr.s	sub_4FF00
		addq.w	#4,a1
		move.w	#$4B6,(a1)+
		move.w	#$4CC,(a1)+
		move.w	#$5B,(a1)+
		move.w	#$5B,(a1)+
		move.w	#$4B7,2(a1)
		lea	($FF5822).l,a1
		moveq	#5,d1
		bsr.s	sub_4FF00
		addq.w	#6,a1
		move.w	#$4B6,(a1)+
		move.w	#$4CC,(a1)+
		move.w	#$5B,(a1)+
		move.w	#$5B,(a1)

loc_4FECC:
		movea.w	($FFFF8014).w,a1
		movea.w	($FFFF8048).w,a5
		move.b	$7F(a1),$63(a5)
		movea.w	($FFFF8012).w,a1
		movea.w	($FFFF8026).w,a5
		bsr.s	sub_4FEF6
		movea.w	($FFFF8016).w,a1
		movea.w	($FFFF802A).w,a5
		bsr.s	sub_4FEF6
		movea.w	($FFFF801A).w,a1
		movea.w	($FFFF802E).w,a5
; End of function Adjust_AIZ2Layout


; =============== S U B R O U T I N E =======================================


sub_4FEF6:

		moveq	#3,d0

loc_4FEF8:
		move.b	(a1)+,(a5)+
		dbf	d0,loc_4FEF8
		rts
; End of function sub_4FEF6


; =============== S U B R O U T I N E =======================================


sub_4FF00:

		moveq	#$5B,d0

loc_4FF02:
		move.w	d0,(a1)+
		dbf	d1,loc_4FF02
		rts
; End of function sub_4FF00

; ---------------------------------------------------------------------------

AIZ2_ScreenInit:
		jsr	Adjust_AIZ2Layout(pc)
		jsr	Reset_TileOffsetPositionActual(pc)
		jmp	Refresh_PlaneFull(pc)
; ---------------------------------------------------------------------------

AIZ2_ScreenEvent:
		move.w	($FFFFEECE).w,d0
		add.w	d0,($FFFFEE84).w
		move.w	($FFFFEEC0).w,d0
		jmp	loc_4FF26(pc,d0.w)
; ---------------------------------------------------------------------------

loc_4FF26:
		bra.w	AIZ2SE_Normal
; ---------------------------------------------------------------------------
		bra.w	AIZ2SE_ShipRefresh
; ---------------------------------------------------------------------------
		bra.w	AIZ2SE_ShipDraw
; ---------------------------------------------------------------------------
		bra.w	AIZ2SE_EndRefresh
; ---------------------------------------------------------------------------
		bra.w	AIZ2SE_End
; ---------------------------------------------------------------------------

AIZ2SE_Normal:
		tst.w	($FFFFEEC4).w
		beq.w	DrawTilesAsYouMove		; Keep drawing as usual while flag isn't set
		clr.w	($FFFFEEC4).w
		move.w	#$180,($FFFFEEC8).w		; Set up redraw memory
		move.w	#5,($FFFFEECA).w
		clr.l	($FFFFA9F8).w
		move.w	($FFFFEE80).w,d0
		andi.w	#-$10,d0
		subi.w	#$10,d0
		move.w	d0,($FFFFA9FE).w
		st	($FFFFEE0A).w				; Camera doesn't follow Sonic
		move.w	#4,($FFFFEEB2).w
		addq.w	#4,($FFFFEEC0).w		; Set speed of automatic movement

AIZ2SE_ShipRefresh:
		move.w	#$4380,d1
		move.w	($FFFFEE84).w,d2
		subi.w	#$10,d2
		jsr	Draw_PlaneVertBottomUp(pc)
		bpl.w	loc_4FFF0
		move.w	#$4020,d0
		move.w	d0,($FFFFA9F6).w
		move.w	d0,($FFFFEE98).w
		clr.w	($FFFFEE9A).w			; Set up secondary BG camera X
		move.w	($FFFFEE84).w,d0
		addi.w	#$8F0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEE9C).w
		move.w	d0,($FFFFEEA2).w		; Set up secondary BG camera Y
		jsr	(Create_New_Sprite).l
		bne.s	loc_4FFBA
		move.l	#Obj_AIZBattleship,(a1)	; Star battleship sequence

loc_4FFBA:
		st	($FFFFEED6).w
		move.l	#HInt6,($FFFFFFF8).w	; HInt is needed to change Y scroll value to proper amount mid-draw
		clr.b	($FFFFF730).w
		move.b	#$40,($FFFFF625).w		; Set HInt position
		addq.w	#4,($FFFFEEC0).w

AIZ2SE_ShipDraw:
		tst.w	($FFFFEEC4).w
		bne.s	loc_50008				; Branch when battleship has gone off-screen
		lea	word_50076(pc),a4
		lea	($FFFFA9F4).w,a6
		move.w	($FFFFEE98).w,(a6)
		moveq	#2,d5
		move.w	($FFFFEEA2).w,d6
		jsr	Draw_BGNoVert(pc)

loc_4FFF0:

		lea	word_50072(pc),a4
		lea	($FFFFA9F8).w,a6
		move.w	($FFFFEE80).w,4(a6)
		moveq	#2,d5
		move.w	($FFFFEE8A).w,d6

loc_50004:
		jmp	Draw_BGNoVert(pc)
; ---------------------------------------------------------------------------

loc_50008:
		clr.w	($FFFFEEC4).w

loc_5000C:
		move.w	#$170,($FFFFEEC8).w
		move.w	#4,($FFFFEECA).w		;Set redraw memory

loc_50018:
		addq.w	#4,($FFFFEEC0).w

AIZ2SE_EndRefresh:
		move.w	#$4380,d1
		move.w	($FFFFEE84).w,d2
		subi.w	#$10,d2

loc_50028:
		jsr	Draw_PlaneVertBottomUp(pc)
		bpl.s	loc_4FFF0
		move.w	($FFFFEE80).w,d0
		andi.w	#-$10,d0

loc_50036:
		subi.w	#$10,d0
		move.w	d0,($FFFFEE88).w
		move.w	#$46C0,($FFFFEED4).w		; Set level X start to 46C0
		clr.w	($FFFFEED6).w
		move.b	#-1,($FFFFF625).w
		addq.w	#4,($FFFFEEC0).w

AIZ2SE_End:
		jmp	DrawTilesAsYouMove(pc)
; ---------------------------------------------------------------------------

HInt6:

		move.w	#$8AFF,($C00004).l
		move.l	#$40000010,($C00004).l
		move.w	($FFFFEE84).w,($C00000).l
		rte
; ---------------------------------------------------------------------------
word_50072:	dc.w $180
		dc.w $7FFF
word_50076:	dc.w $A80
		dc.w $7FFF
; ---------------------------------------------------------------------------

AIZ2_BackgroundInit:
		move.w	($FFFFEE80).w,($FFFFEEB4).w
		move.w	($FFFFEE80).w,($FFFFEEB6).w
		move.w	#$C,($FFFFEEC2).w
		cmpi.w	#$3E80,($FFFFEE78).w
		bcs.s	loc_500A0
		move.w	#$14,($FFFFEEC2).w
		move.w	#$4440,($FFFFEED4).w

loc_500A0:
		jsr	(AIZ2_Deform).l
		jsr	Reset_TileOffsetPositionEff(pc)
		moveq	#0,d1
		jsr	Refresh_PlaneFull(pc)
		jmp	(AIZ2_ApplyDeform).l
; ---------------------------------------------------------------------------

AIZ2_BackgroundEvent:
		lea	($FFFFEEB4).w,a1
		move.w	($FFFFEE80).w,d0
		move.w	#$100,d2
		move.w	#$200,d3
		jsr	Adjust_BGDuringLoop(pc)
		move.w	($FFFFEEC2).w,d0
		jmp	loc_500D2(pc,d0.w)
; ---------------------------------------------------------------------------

loc_500D2:
		bra.w	AIZ2BGE_FireRedraw
; ---------------------------------------------------------------------------
		bra.w	AIZ2BGE_WaitFire
; ---------------------------------------------------------------------------
		bra.w	AIZ2BGE_BGRedraw
; ---------------------------------------------------------------------------
		bra.w	AIZ2BGE_Normal
; ---------------------------------------------------------------------------
		bra.w	AIZ2BGE_ShipRefresh
; ---------------------------------------------------------------------------
		bra.w	AIZ2BGE_ShipMove
; ---------------------------------------------------------------------------

AIZ2BGE_FireRedraw:
		lea	($FFFF8008).w,a3
		move.w	#$C000,d7
		move.w	($FFFFEE80).w,d1
		move.w	($FFFFEE84).w,d2
		jsr	Draw_PlaneVertBottomUp(pc)
		bmi.s	loc_50110
		jsr	(AIZ1_FireRise).l
		jsr	(AIZTrans_WavyFlame).l
		jmp	PlainDeformation(pc)
; ---------------------------------------------------------------------------

loc_50110:
		addq.w	#2,a3
		move.w	#-$2000,d7
		clr.w	($FFFFEED2).w
		addq.w	#4,($FFFFEEC2).w

AIZ2BGE_WaitFire:
		jsr	(AIZ1_FireRise).l
		jsr	(AIZTrans_WavyFlame).l
		tst.w	($FFFFEED2).w
		bne.s	loc_50160
		move.w	($FFFFEE90).w,d0
		andi.w	#$7F,d0
		cmpi.w	#$20,d0
		bcs.s	loc_50144
		cmpi.w	#$30,d0
		bcs.s	loc_50148

loc_50144:
		jmp	PlainDeformation(pc)
; ---------------------------------------------------------------------------

loc_50148:
		addi.w	#$180,d0
		move.w	d0,($FFFFEE90).w
		and.w	($FFFFEEAC).w,d0
		subi.w	#$10,d0
		move.w	d0,($FFFFEE96).w
		st	($FFFFEED2).w

loc_50160:
		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		move.w	#$200,d1
		moveq	#$20,d6
		jsr	Draw_TileRow(pc)
		cmpi.w	#$310,($FFFFEE90).w
		bcs.s	loc_501D6			; If fire hasn't subsided, branch
		movem.l	d7-a0/a2-a3,-(sp)
		moveq	#$C,d0
		jsr	(Load_PLC).l
		jsr	(LoadEnemyArt).l
		movem.l	(sp)+,d7-a0/a2-a3
		lea	($FFFFFC62).w,a1
		move.l	#$8EE00AA,(a1)+
		move.l	#$8E004E,(a1)+
		move.l	#$2E000C,(a1)
		move.w	#$6000,d0
		move.w	d0,($FFFFEE16).w
		jsr	(AIZ2_Deform).l
		jsr	Reset_TileOffsetPositionEff(pc)
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w		; Set up Effective BG Y location for screen redraw
		move.w	#$F,($FFFFEECA).w		; Set up redraw count
		move.w	#$C,($FFFFEEA6).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_50204
; ---------------------------------------------------------------------------

loc_501D6:
		jsr	(AIZ2_ApplyDeform).l
		lea	($FFFFE002).w,a1
		move.w	($FFFFEE8C).w,d0	; Cancel out background deformation since we're still in the open field
		neg.w	d0
		moveq	#$37,d1

loc_501E8:
		move.w	d0,(a1)
		addq.w	#4,a1
		move.w	d0,(a1)
		addq.w	#4,a1
		move.w	d0,(a1)
		addq.w	#4,a1
		move.w	d0,(a1)
		addq.w	#4,a1
		dbf	d1,loc_501E8
		rts
; ---------------------------------------------------------------------------

AIZ2BGE_BGRedraw:
		jsr	(AIZ2_Deform).l

loc_50204:
		moveq	#0,d1
		move.w	($FFFFEE90).w,d2
		jsr	Draw_PlaneVertBottomUp(pc)
		bpl.s	loc_50260
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_50260
; ---------------------------------------------------------------------------

AIZ2BGE_Normal:
		jsr	(AIZ2_Deform).l
		tst.w	($FFFFEEC6).w
		beq.s	loc_50260
		clr.w	($FFFFEEC6).w
		move.w	#$A8,d0
		cmpi.w	#$400,($FFFFEE7C).w
		bcs.s	loc_50236
		move.w	#-$198,d0

loc_50236:
		move.w	d0,($FFFFEEE8).w
		add.w	d0,($FFFFEE90).w
		jsr	Reset_TileOffsetPositionEff(pc)
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		move.w	#$4440,($FFFFEED4).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_50280
; ---------------------------------------------------------------------------

loc_50260:

		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jsr	Draw_TileRow(pc)
		jsr	(AIZ2_ApplyDeform).l
		jmp	ShakeScreen_Setup(pc)
; ---------------------------------------------------------------------------

AIZ2BGE_ShipRefresh:
		jsr	(AIZ2_Deform).l

loc_50280:
		moveq	#0,d1
		move.w	($FFFFEE90).w,d2
		jsr	Draw_PlaneVertBottomUp(pc)
		bpl.s	loc_50298
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_50298
; ---------------------------------------------------------------------------

AIZ2BGE_ShipMove:
		jsr	(AIZ2_Deform).l

loc_50298:

		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jsr	Draw_TileRow(pc)
		jsr	(AIZ2_ApplyDeform).l
		tst.w	($FFFFEED6).w
		beq.s	loc_502C2
		move.w	($FFFFEE9C).w,($FFFFF616).w		; Use effective camera position rather than actual camera position
		move.w	($FFFFEE90).w,($FFFFF618).w
		addq.w	#4,sp		; Skip last part of ScreenEvents

loc_502C2:
		jmp	ShakeScreen_Setup(pc)
; ---------------------------------------------------------------------------

AIZ2_DoShipLoop:
		clr.w	($FFFFEEBC).w
		move.w	($FFFFEE78).w,d0
		addq.w	#4,d0
		cmp.w	($FFFFEED4).w,d0
		bcs.s	loc_502FA
		move.w	#$200,d1			; Do loop
		move.w	d1,($FFFFEEBC).w
		sub.w	d1,($FFFFB010).w
		sub.w	d1,($FFFFB05A).w	; Subtract $200 from X position of Sonic and Tails
		sub.w	d1,d0
		move.w	d0,d1
		andi.w	#-$10,d1
		subi.w	#$10,d1
		move.w	d1,($FFFFEE88).w
		move.w	d1,($FFFFA9FE).w

loc_502FA:
		move.w	d0,($FFFFEE78).w
		move.w	d0,($FFFFEE80).w
		move.w	d0,($FFFFEE14).w
		move.w	d0,($FFFFEE16).w	; Set all the camera/start positions
		move.w	d0,d1
		lea	($FFFFB000).w,a1
		bsr.s	sub_50318
		move.w	d1,d0
		lea	($FFFFB04A).w,a1

; =============== S U B R O U T I N E =======================================


sub_50318:
		cmpi.b	#5,$20(a1)
		bne.s	loc_50324
		clr.b	$20(a1)				; If Sonic is standing set him to the running animation

loc_50324:
		addi.w	#$18,d0
		cmp.w	$10(a1),d0
		bls.s	loc_5033A
		move.w	d0,$10(a1)			; Make sure Sonic stays on-screen
		move.w	#$400,$1C(a1)		; Set his running velocity to $400 if the left of screen is hit
		bra.s	locret_50348
; ---------------------------------------------------------------------------

loc_5033A:
		addi.w	#$88,d0
		cmp.w	$10(a1),d0
		bhi.s	locret_50348
		move.w	d0,$10(a1)			; Make sure Sonic can't go past a certain point to the right

locret_50348:

		rts
; End of function sub_50318

; ---------------------------------------------------------------------------

Obj_AIZBattleship:
		move.l	#Obj_AIZBattleshipMain,(a0)
		move.l	#AIZBattleship_BombScript,$2E(a0)
		move.w	#$1A4,$32(a0)
		move.w	#$3FBC,d1
		moveq	#1,d2

loc_50364:
		jsr	(Create_New_Sprite3).l
		bne.s	loc_5037E
		move.l	#Obj_BattleshipPropeller,(a1)	; Create two propellers, one at the front and one in the back
		move.w	d1,$2E(a1)
		move.w	#$3DCC,d1
		dbf	d2,loc_50364

loc_5037E:
		lea	($FFFFFC20).w,a1
		lea	(Pal_AIZBattleship).l,a5
		moveq	#7,d0

loc_5038A:
		move.l	(a5)+,(a1)+
		dbf	d0,loc_5038A

Obj_AIZBattleshipMain:
		subi.l	#$8800,($FFFFEE98).w
		move.w	($FFFFEE98).w,d0
		cmpi.w	#$3CDC,d0
		bpl.s	loc_503BC
		move.l	#Obj_AIZ2BossSmall,(a0)
		st	($FFFFEEC4).w				; Set for the next screen event
		jsr	(Create_New_Sprite3).l
		bne.s	locret_503BA
		move.l	#Obj_AIZ2MakeTree,(a1)

locret_503BA:
		rts
; ---------------------------------------------------------------------------

loc_503BC:
		move.w	d0,d1
		subi.w	#$3D5C,d0
		bpl.s	loc_503D2
		neg.w	d0					; Move upwards as the battleship goes offscreen
		asr.w	#1,d0
		add.w	($FFFFEEA2).w,d0
		move.w	d0,($FFFFEE9C).w
		bra.s	loc_503EA
; ---------------------------------------------------------------------------

loc_503D2:
		asr.w	#2,d1			; Continue bobbing up and down
		andi.w	#$F,d1
		lea	(AIZBattleShip_BobbingMotion).l,a1
		move.b	(a1,d1.w),d1
		add.w	($FFFFEEA2).w,d1
		move.w	d1,($FFFFEE9C).w	; Get the bobbing motion delta, apply it to the second camera Y

loc_503EA:
		move.w	($FFFFFE04).w,d0
		subq.w	#1,d0
		andi.w	#$F,d0
		bne.s	loc_503FE
		moveq	#-$43,d0			; Replay the battleship flying sound every 16th frame
		jsr	(Play_Sound_2).l

loc_503FE:
		subq.w	#1,$32(a0)			; Wait for delay to finish
		bcc.s	locret_50424
		movea.l	$2E(a0),a2
		move.w	(a2)+,$32(a0)		; Get the first word of the bomb script as the new delay
		bmi.s	locret_50424
		jsr	(Create_New_Sprite3).l
		bne.s	locret_50424
		move.l	#Obj_AIZShipBomb,(a1)		; Create a new bomb
		move.w	(a2)+,$2E(a1)		; Put the X position into $2E so it can be translated
		move.l	a2,$2E(a0)			; Update the script position

locret_50424:

		rts
; ---------------------------------------------------------------------------

Obj_BattleshipPropeller:
		move.l	#Obj_BattleshipPropellerMain,(a0)
		move.b	#4,4(a0)
		move.b	#$20,6(a0)
		move.b	#8,7(a0)
		move.w	#$80,8(a0)
		move.w	#$500,$A(a0)
		move.l	#Map_AIZShipPropeller,$C(a0)
		move.w	#$A71,$30(a0)

Obj_BattleshipPropellerMain:
		cmpi.w	#$C,($FFFFEEC0).w
		bne.s	loc_50466
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_50466:
		lea	(Ani_AIZShipPropeller).l,a1
		jsr	(Animate_Sprite).l
		jsr	Translate_Camera2ObjPosition(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_AIZShipBomb:
		move.l	#Obj_AIZShipBombMain,(a0)
		move.b	#4,4(a0)
		move.b	#$18,7(a0)
		move.w	#$80,8(a0)
		move.w	#$500,$A(a0)
		move.l	#Map_AIZ2BombExplode,$C(a0)
		move.b	#$10,$1E(a0)
		move.w	#$A60,$30(a0)
		move.w	#6,$32(a0)

Obj_AIZShipBombMain:
		moveq	#0,d0
		move.b	5(a0),d0
		jmp	loc_504BE(pc,d0.w)
; ---------------------------------------------------------------------------

loc_504BE:
		bra.w	AIZShipBomb_ReadyDrop
; ---------------------------------------------------------------------------
		bra.w	AIZShipBomb_Delay
; ---------------------------------------------------------------------------
		bra.w	AIZShipBomb_Drop
; ---------------------------------------------------------------------------

AIZShipBomb_ReadyDrop:
		addq.w	#2,$30(a0)
		cmpi.w	#$A80,$30(a0)		; Put bomb into position before delay
		bcs.s	loc_504EE
		addq.b	#4,5(a0)
		bra.s	loc_504EE
; ---------------------------------------------------------------------------

AIZShipBomb_Delay:
		subq.w	#1,$32(a0)
		bne.s	loc_504EE
		addq.b	#4,5(a0)
		moveq	#$51,d0
		jsr	(Play_Sound_2).l		; Play the drop sound after the delay

loc_504EE:

		jsr	Translate_Camera2ObjPosition(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

AIZShipBomb_Drop:
		move.l	$14(a0),d0
		add.l	$1A(a0),d0
		move.l	d0,$14(a0)			; Drop bomb downwards

loc_50504:
		addi.l	#$2000,$1A(a0)		; Increase acceleration
		swap	d0
		jsr	Translate_Camera2ObjX(pc)
		jsr	(Draw_Sprite).l
		jsr	(ObjHitFloor).l
		cmpi.w	#-8,d1
		bgt.s	locret_50578
		move.w	#$10,($FFFFEECC).w	; If touching the floor, set up a timed screen shake
		moveq	#$4E,d0
		jsr	(Play_Sound_2).l		; Play the bomb explosion sound
		jsr	(Create_New_Sprite3).l
		bne.s	loc_50572
		lea	(AIZBombExplodeDat).l,a2
		moveq	#7,d1

loc_50542:
		move.l	#Obj_AIZBombExplosion,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	(a2)+,d2
		add.w	d2,$10(a1)
		move.w	(a2)+,d2
		add.w	d2,$14(a1)
		move.w	(a2)+,$20(a1)
		move.w	(a2)+,$2E(a1)
		jsr	(CreateNewSprite4).l
		dbne	d1,loc_50542

loc_50572:
		move.l	#Delete_Current_Sprite,(a0)		; Delete the bomb sprite

locret_50578:
		rts

; =============== S U B R O U T I N E =======================================


Translate_Camera2ObjPosition:

		move.w	$30(a0),d0
		sub.w	($FFFFEE9C).w,d0
		add.w	($FFFFEE84).w,d0

Translate_Camera2ObjX:
		sub.w	($FFFFEED0).w,d0
		add.w	($FFFFEECE).w,d0
		move.w	d0,$14(a0)
		move.w	$2E(a0),d0
		sub.w	($FFFFEE98).w,d0
		add.w	($FFFFEE80).w,d0
		move.w	d0,$10(a0)
		rts
; End of function Translate_Camera2ObjPosition

; ---------------------------------------------------------------------------

Obj_AIZBombExplosion:
		move.w	($FFFFEEBC).w,d0
		sub.w	d0,$10(a0)
		subq.w	#1,$2E(a0)
		bmi.s	loc_505B4
		rts
; ---------------------------------------------------------------------------

loc_505B4:
		move.l	#Obj_AIZBombExplosionAnim,(a0)
		move.b	#4,4(a0)
		move.b	#$20,7(a0)
		move.w	#$500,$A(a0)
		move.l	#Map_AIZ2BombExplode,$C(a0)
		move.b	#-$75,$28(a0)
		bra.s	loc_505E4
; ---------------------------------------------------------------------------

Obj_AIZBombExplosionAnim:
		move.w	($FFFFEEBC).w,d0
		sub.w	d0,$10(a0)

loc_505E4:
		lea	(Ani_AIZ2BombExplode).l,a1
		jsr	(Animate_SpriteIrregularDelay).l
		tst.b	5(a0)
		beq.s	loc_505FC
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_505FC:
		moveq	#4,d0
		add.b	$20(a0),d0
		cmp.b	$22(a0),d0
		bls.s	loc_5060E
		jsr	(Add_SpriteToCollisionResponseList).l

loc_5060E:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_AIZ2MakeTree:
		cmpi.w	#$44D0,($FFFFEE78).w
		bcc.s	loc_5061E
		rts
; ---------------------------------------------------------------------------

loc_5061E:
		move.l	#loc_50632,(a0)
		move.w	($FFFFEEB6).w,$2E(a0)
		move.l	#AIZMakeTreeScript,$30(a0)

loc_50632:
		movea.l	$30(a0),a2
		tst.w	(a2)
		bpl.s	loc_50640
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_50640:
		move.w	($FFFFEEB6).w,d0
		sub.w	$2E(a0),d0
		cmp.w	(a2)+,d0
		bcs.s	locret_50662
		jsr	(Create_New_Sprite3).l
		bne.s	locret_50662
		move.l	#Obj_AIZ2BGTree,(a1)
		move.w	(a2)+,8(a1)
		move.l	a2,$30(a0)

locret_50662:

		rts
; ---------------------------------------------------------------------------

Obj_AIZ2BGTree:
		move.l	#Obj_AIZ2BGTreeMove,(a0)
		move.w	#$438,$A(a0)
		move.l	#Map_AIZ2BGTree,$C(a0)
		move.w	#$E9,$14(a0)
		move.w	#$1C0,$2E(a0)
		move.w	($FFFFEEB6).w,$30(a0)

Obj_AIZ2BGTreeMove:
		cmpi.w	#$4880,($FFFFEE78).w
		bcs.s	loc_50698
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_50698:
		move.w	($FFFFEEB6).w,d0
		sub.w	$30(a0),d0
		move.w	d0,d1
		asr.w	#2,d0
		sub.w	d0,d1
		move.w	$2E(a0),d0
		sub.w	d1,d0
		move.w	d0,$10(a0)
		cmpi.w	#$1C0,d0
		bcc.s	locret_506BC
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_506BC:
		rts
; ---------------------------------------------------------------------------

Obj_AIZ2BossSmall:
		move.l	#Obj_AIZ2BossSmallMain,(a0)
		move.w	#$300,8(a0)
		move.w	#$500,$A(a0)
		move.l	#Map_AIZ2BossSmall,$C(a0)
		move.w	#$30,$10(a0)
		move.w	#$D8,$14(a0)
		move.w	#5,$18(a0)
		clr.w	$2E(a0)
		lea	($FFFFFC22).w,a1
		lea	(Pal_AIZBossSmall).l,a5
		moveq	#6,d0

loc_506FA:
		move.l	(a5)+,(a1)+
		dbf	d0,loc_506FA

Obj_AIZ2BossSmallMain:
		tst.b	$2E(a0)
		bne.s	loc_50712
		cmpi.w	#$4670,($FFFFEE78).w
		bcs.s	locret_5077C
		st	$2E(a0)

loc_50712:
		cmpi.w	#$240,$10(a0)
		bcs.s	loc_50732
		clr.b	($FFFFEE0A).w
		clr.w	($FFFFEEB2).w
		clr.w	($FFFFEEBC).w			; Stop repeating scrolling section
		move.w	#$6000,($FFFFEE16).w	; Change level size
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_50732:
		move.l	$10(a0),d0
		move.l	$18(a0),d1		; Move Robotnik
		add.l	d1,d0
		move.l	d0,$10(a0)
		tst.b	$2F(a0)
		bne.s	loc_50758
		subi.l	#$E80,d1		; Phase 1: Slow down until moving slightly to the left
		cmpi.l	#-$10000,d1
		sle	$2F(a0)
		bra.s	loc_5075E
; ---------------------------------------------------------------------------

loc_50758:
		addi.l	#$E80,d1		; Phase 2: Speed up till moving off screen

loc_5075E:
		move.l	d1,$18(a0)
		jsr	(Draw_Sprite).l
		move.w	($FFFFFE04).w,d0
		subq.w	#1,d0
		andi.w	#$F,d0
		bne.s	locret_5077C
		moveq	#-$42,d0		; Every sixteenth frame, play alarm sound
		jsr	(Play_Sound_2).l

locret_5077C:

		rts
; ---------------------------------------------------------------------------
word_5077E:	dc.w 0

		dc.w 0
		dc.w 1
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w 1
		dc.w 1
		dc.w 0
		dc.w 0
		dc.w $FFFE
		dc.w 1
		dc.w 2
		dc.w 2
		dc.w $FFFF
		dc.w 2
		dc.w 2
		dc.w 1
		dc.w 2
		dc.w $FFFF
		dc.w $FFFE
		dc.w $FFFE
		dc.w $FFFE
		dc.w 1
		dc.w $FFFF
		dc.w $FFFF
		dc.w $FFFF
		dc.w 0
		dc.w $FFFE
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w $FFFE
		dc.w 0
		dc.w $FFFE
		dc.w 2
		dc.w 0
		dc.w $FFFE
		dc.w 2
		dc.w 2
		dc.w $FFFF
		dc.w $FFFE
		dc.w $FFFE
		dc.w 1
		dc.w 2
		dc.w 2
		dc.w $FFFF
		dc.w 2
		dc.w 2
		dc.w 1
		dc.w 2
		dc.w $FFFF
		dc.w $FFFE
		dc.w $FFFE
		dc.w $FFFE
		dc.w 1
		dc.w $FFFF
		dc.w $FFFF
		dc.w $FFFF
		dc.w 0
		dc.w $FFFE
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w $FFFE
		dc.w 0
		dc.w $FFFE
		dc.w 2
		dc.w 0
		dc.w $FFFE
		dc.w 2
		dc.w 2
		dc.w $FFFF
		dc.w $FFFE
		dc.w $FFFE
		dc.w 1
		dc.w 2
		dc.w 2
		dc.w $FFFF
		dc.w 2
		dc.w 2
		dc.w 1
		dc.w 2
		dc.w $FFFF
		dc.w $FFFE
		dc.w $FFFE
		dc.w $FFFE
		dc.w 1
		dc.w $FFFF
		dc.w $FFFF
		dc.w $FFFF
		dc.w 0
		dc.w $FFFE
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w $FFFE
		dc.w 0
		dc.w $FFFE
		dc.w 2
		dc.w 0
		dc.w $FFFE
		dc.w 2
		dc.w 2
		dc.w $FFFF
		dc.w $FFFE
		dc.w $FFFE
		dc.w 1
		dc.w 2
		dc.w 2
		dc.w $FFFF
		dc.w 2
		dc.w 2
		dc.w 1
		dc.w 2
		dc.w $FFFF
		dc.w $FFFE
		dc.w $FFFE
		dc.w $FFFE
		dc.w 1
		dc.w $FFFF
		dc.w $FFFF
		dc.w $FFFF
		dc.w 0
		dc.w $FFFE
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w $FFFE
		dc.w 0
		dc.w $FFFE
		dc.w 2
		dc.w 0
		dc.w $FFFE
		dc.w 2
		dc.w 2
		dc.w $FFFF
		dc.w $FFFE
		dc.w $FFFE
		dc.w 1
		dc.w 2
		dc.w 2
		dc.w $FFFF
		dc.w 2
		dc.w 2
		dc.w 1
		dc.w 2
		dc.w $FFFF
		dc.w $FFFE
		dc.w $FFFE
		dc.w $FFFE
		dc.w 1
		dc.w $FFFF
		dc.w $FFFF
		dc.w $FFFF
		dc.w 0
		dc.w $FFFE
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w $FFFE
		dc.w 0
		dc.w $FFFE
		dc.w 2
		dc.w 0
		dc.w $FFFE
		dc.w 2
		dc.w 2
		dc.w $FFFF
		dc.w $FFFE
		dc.w $FFFE
		dc.w 1
		dc.w 2
		dc.w 2
		dc.w $FFFF
		dc.w 2
		dc.w 2
		dc.w 1
		dc.w 2
		dc.w $FFFF
		dc.w $FFFE
		dc.w $FFFE
		dc.w $FFFE
		dc.w 1
		dc.w $FFFF
		dc.w $FFFF
		dc.w $FFFF
		dc.w 0
		dc.w $FFFE
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w $FFFE
		dc.w 0
		dc.w $FFFE
		dc.w 2
		dc.w 0
		dc.w $FFFE
		dc.w 2
		dc.w 2
		dc.w $FFFF
		dc.w $FFFE
		dc.w $FFFE
		dc.w 1
		dc.w 2
		dc.w 2
		dc.w $FFFF
		dc.w 2
		dc.w 2
		dc.w 1
		dc.w 2
		dc.w $FFFF
		dc.w $FFFE
		dc.w $FFFE
		dc.w $FFFE
		dc.w 1
		dc.w $FFFF
		dc.w $FFFF
		dc.w $FFFF
		dc.w 0
		dc.w $FFFE
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w $FFFE
		dc.w 0
		dc.w $FFFE
		dc.w 2
		dc.w 0
		dc.w $FFFE
		dc.w 2
		dc.w 2
		dc.w $FFFF
		dc.w $FFFE
		dc.w $FFFE
		dc.w 1
		dc.w 2
		dc.w 2
		dc.w $FFFF
		dc.w 2
		dc.w 2
		dc.w 1
		dc.w 2
		dc.w $FFFF
		dc.w $FFFE
		dc.w $FFFE
		dc.w $FFFE
		dc.w 1
		dc.w $FFFF
		dc.w $FFFF
		dc.w $FFFF
		dc.w 0
		dc.w $FFFE
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w $FFFE
		dc.w 0
		dc.w $FFFE
		dc.w 2
		dc.w 0
		dc.w $FFFE
		dc.w 2
		dc.w 2
		dc.w $FFFF
		dc.w $FFFE
; ---------------------------------------------------------------------------

HCZ1_ScreenInit:
		clr.w	($FFFFEEE8).w
		jsr	Reset_TileOffsetPositionActual(pc)
		jmp	Refresh_PlaneFull(pc)
; ---------------------------------------------------------------------------

HCZ1_ScreenEvent:
		jmp	DrawTilesAsYouMove(pc)
; ---------------------------------------------------------------------------

HCZ1_BackgroundInit:
		jsr	HCZ1_Deform(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		moveq	#0,d1
		jsr	Refresh_PlaneFull(pc)
		moveq	#$60,d0
		cmp.w	($FFFFEEE2).w,d0
		blt.s	loc_50BAC
		neg.w	d0
		cmp.w	($FFFFEEE2).w,d0
		bgt.s	loc_50BB0

loc_50BAC:
		move.w	d0,($FFFFEEE2).w		; Cap dynamic art reloading value at $60 either way

loc_50BB0:
		lea	(HCZ1_BGDeformArray).l,a4
		lea	($FFFFA800).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------

HCZ1_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_50BC6(pc,d0.w)
; ---------------------------------------------------------------------------

loc_50BC6:
		bra.w	HCZ1BGE_Normal
; ---------------------------------------------------------------------------
		bra.w	HCZ1BGE_DoTransition
; ---------------------------------------------------------------------------

HCZ1BGE_Normal:
		tst.w	($FFFFEEC6).w
		beq.s	loc_50C2A
		clr.w	($FFFFEEC6).w				; Do transition
		movem.l	d7-a0/a2-a3,-(sp)
		lea	(HCZ2_128x128_Secondary_Kos).l,a1
		lea	($FFFF0A00).l,a2
		jsr	(Queue_Kos).l
		lea	(HCZ2_16x16_Secondary_Kos).l,a1
		lea	($FFFF9558).w,a2
		jsr	(Queue_Kos).l
		lea	(HCZ2_8x8_Secondary_KosM).l,a1	; Load secondary HCZ2 art, blocks, and chunks so as to not compromise current position
		move.w	#$2360,d2
		jsr	(Queue_Kos_Module).l
		moveq	#$10,d0
		jsr	(Load_PLC).l
		moveq	#$11,d0
		jsr	(Load_PLC).l					; load HCZ 2 PLCs
		movem.l	(sp)+,d7-a0/a2-a3
		st	($FFFFEEE8).w
		addq.w	#4,($FFFFEEC2).w

loc_50C2A:
		jsr	HCZ1_Deform(pc)
		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jsr	Draw_TileRow(pc)
		lea	(HCZ1_BGDeformArray).l,a4
		lea	($FFFFA800).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------

HCZ1BGE_DoTransition:
		tst.b	($FFFFFF60).w
		bne.w	loc_50CDC			; Don't do anything else until kos queue has been cleared
		move.w	#$101,($FFFFFE10).w	; Change the act
		clr.b	($FFFFEE33).w		; Reload resize routine counter
		clr.b	($FFFFF76C).w		; Reload sprite manager
		clr.b	($FFFFF710).w		; Reload ring manager
		clr.b	($FFFFF7AA).w		; Unlock the screen
		clr.b	($FFFFFF97).w		; Refresh sprite/ring memory
		jsr	Clear_Switches(pc)
		move.l	#Obj_HCZWaterSplash,($FFFFB172).w	; Load the splash object
		move.b	#1,($FFFFB19E).w
		movem.l	d7-a0/a2-a3,-(sp)
		jsr	(Load_Level).l				; Load HCZ2 layout
		jsr	(LoadSolids).l
		jsr	(CheckLevelForWater).l
		move.w	#$6A0,d0
		move.w	d0,($FFFFF646).w
		move.w	d0,($FFFFF648).w
		move.w	d0,($FFFFF64A).w	; Set the water up
		moveq	#$D,d0
		jsr	(LoadPalette_Immediate).l	; Load HCZ2 palette
		movem.l	(sp)+,d7-a0/a2-a3
		move.w	#$3600,d0
		moveq	#0,d1
		sub.w	d0,($FFFFB010).w
		sub.w	d0,($FFFFB05A).w
		jsr	Offset_ObjectsDuringTransition(pc)
		sub.w	d0,($FFFFEE78).w
		sub.w	d0,($FFFFEE80).w
		sub.w	d0,($FFFFEE14).w
		sub.w	d0,($FFFFEE16).w		; Offset objects/camera position by specified amount
		jsr	Reset_TileOffsetPositionActual(pc)
		clr.w	($FFFFEEC2).w

loc_50CDC:
		jsr	HCZ1_Deform(pc)
		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jsr	Draw_TileRow(pc)
		lea	(HCZ1_BGDeformArray).l,a4
		lea	($FFFFA800).w,a5
		jmp	ApplyDeformation(pc)

; =============== S U B R O U T I N E =======================================


HCZ1_Deform:

		move.w	($FFFFEE84).w,d0		; Get the BG camera Y position
		subi.w	#$610,d0				; Get the difference between that and the water line equilibrium point
		move.w	d0,d1
		asr.w	#2,d0
		move.w	d0,d2
		addi.w	#$190,d0
		move.w	d0,($FFFFEE90).w		; The effective BG Y is negative when the BG is above the water line, positive when otherwise
		sub.w	d1,d2					; The difference between the effective BG Y and the actual BG Y difference is what's used to calculate how the water line should be drawn
		move.w	d2,($FFFFEEE2).w
		move.w	($FFFFEE80).w,d0		; Get the camera BG X
		swap	d0
		clr.w	d0
		tst.w	d2
		beq.w	loc_50DDA		; If equilibrium point, branch
		move.l	d0,d1
		move.l	d0,d3			; Set up deformation scroll value
		asr.l	#7,d3
		moveq	#$2F,d4
		cmpi.w	#-$60,d2
		bgt.s	loc_50D52
		lea	($FFFFA81A).w,a1	; If background is high enough that water line doesn't have to be messed with, just apply the standard formation to it

loc_50D3A:
		swap	d1
		move.w	d1,(a1)+
		swap	d1
		sub.l	d3,d1
		swap	d1
		move.w	d1,(a1)+
		swap	d1
		sub.l	d3,d1
		dbf	d4,loc_50D3A
		bra.w	loc_50DDA		; Then finish it up
; ---------------------------------------------------------------------------

loc_50D52:
		lea	($FFFFA99A).w,a1

loc_50D56:
		swap	d1				; If background camera is lower, then apply water line deformation backwards
		move.w	d1,-(a1)
		swap	d1
		sub.l	d3,d1
		swap	d1
		move.w	d1,-(a1)
		swap	d1
		sub.l	d3,d1
		dbf	d4,loc_50D56
		cmpi.w	#$60,d2
		bge.s	loc_50DDA		; If background camera is low enough that water line doesn't need to be messed with, then end it.
		lea	($FFFFA8DA).w,a1	; Otherwise, the fun begins
		lea	(a1),a5
		lea	(HCZ_WaterlineScroll_Data).l,a6
		move.w	d2,d1
		bmi.s	loc_50DAE
		move.w	d1,d3			; If waterline is displayed below water level
		neg.w	d3
		addi.w	#$60,d3
		lsl.w	#5,d3
		adda.w	d3,a6
		add.w	d3,d3
		adda.w	d3,a6			; Set up area of water line scroll data to use based on position
		subq.w	#1,d1
		moveq	#0,d3
		lsr.w	#1,d1
		bcc.s	loc_50DA0

loc_50D98:
		move.b	(a6)+,d3
		add.w	d3,d3
		move.w	(a5,d3.w),(a1)+

loc_50DA0:
		move.b	(a6)+,d3
		add.w	d3,d3
		move.w	(a5,d3.w),(a1)+	; Apply scroll data
		dbf	d1,loc_50D98
		bra.s	loc_50DDA
; ---------------------------------------------------------------------------

loc_50DAE:
		move.w	d1,d3			; If waterline is displayed above water level
		addi.w	#$60,d3
		lsl.w	#5,d3
		adda.w	d3,a6
		add.w	d3,d3
		adda.w	d3,a6			; Set up area of water line scroll data to use based on position
		neg.w	d1
		subq.w	#1,d1
		moveq	#0,d3
		lsr.w	#1,d1
		bcc.s	loc_50DCE

loc_50DC6:
		move.b	(a6)+,d3
		add.w	d3,d3
		move.w	(a5,d3.w),-(a1)

loc_50DCE:
		move.b	(a6)+,d3
		add.w	d3,d3
		move.w	(a5,d3.w),-(a1)	; Apply scroll data
		dbf	d1,loc_50DC6

loc_50DDA:

		move.l	d0,d1			; Get BG X again
		asr.l	#2,d0
		asr.l	#5,d1
		lea	($FFFFA800).w,a1
		swap	d0
		move.w	d0,(a1)
		move.w	d0,$18(a1)
		move.w	d0,d3
		swap	d0
		sub.l	d1,d0
		swap	d0
		move.w	d0,2(a1)
		move.w	d0,$16(a1)
		swap	d0
		sub.l	d1,d0
		swap	d0
		move.w	d0,4(a1)
		move.w	d0,$14(a1)
		swap	d0
		sub.l	d1,d0
		swap	d0
		move.w	d0,6(a1)
		move.w	d0,$12(a1)
		swap	d0
		sub.l	d1,d0
		swap	d0
		move.w	d0,8(a1)
		move.w	d0,$10(a1)
		swap	d0
		sub.l	d1,d0
		swap	d0
		move.w	d0,$A(a1)
		move.w	d0,$E(a1)
		swap	d0
		sub.l	d1,d0
		swap	d0
		move.w	d0,$C(a1)
		move.w	d0,$19A(a1)
		move.w	d0,d4
		tst.w	d2
		bpl.s	loc_50E68
		lea	($FFFFA8DA).w,a1	; Water line above water
		moveq	#$2F,d0

loc_50E4E:
		move.w	d4,(a1)+
		move.w	d4,(a1)+
		dbf	d0,loc_50E4E
		moveq	#$5F,d0
		add.w	d2,d0
		bmi.s	locret_50E86
		lea	($FFFFA81A).w,a1

loc_50E60:
		move.w	d3,(a1)+
		dbf	d0,loc_50E60
		bra.s	locret_50E86
; ---------------------------------------------------------------------------

loc_50E68:
		lea	($FFFFA81A).w,a1	; Water line below water
		moveq	#$2F,d0

loc_50E6E:
		move.w	d3,(a1)+
		move.w	d3,(a1)+
		dbf	d0,loc_50E6E
		moveq	#$5F,d0
		sub.w	d2,d0
		bmi.s	locret_50E86
		lea	($FFFFA99A).w,a1

loc_50E80:
		move.w	d4,-(a1)
		dbf	d0,loc_50E80

locret_50E86:

		rts
; End of function HCZ1_Deform

; ---------------------------------------------------------------------------

HCZ2_ScreenInit:
		jsr	Reset_TileOffsetPositionActual(pc)
		jmp	Refresh_PlaneFull(pc)
; ---------------------------------------------------------------------------

HCZ2_ScreenEvent:
		move.w	($FFFFEECE).w,d0
		add.w	d0,($FFFFEE84).w
		jmp	DrawTilesAsYouMove(pc)
; ---------------------------------------------------------------------------

HCZ2_BackgroundInit:
		cmpi.w	#$C00,($FFFFEE78).w
		bcc.s	loc_50ED0
		cmpi.w	#$500,($FFFFEE7C).w
		bcs.s	loc_50ED0
		move.w	#4,($FFFFEEC2).w	; Special deformation occurs when camera X is less than $C00 and
		jsr	(Create_New_Sprite).l		; camera Y is greater than $500
		bne.s	loc_50EC0
		move.l	#Obj_HCZ2Wall,(a1)

loc_50EC0:
		jsr	HCZ2_WallMove(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		jsr	Refresh_PlaneFull(pc)
		jmp	PlainDeformation(pc)
; ---------------------------------------------------------------------------

loc_50ED0:

		move.w	#$10,($FFFFEEC2).w			; Normal deformation
		jsr	HCZ2_Deform(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		moveq	#0,d1
		jsr	Refresh_PlaneFull(pc)
		lea	(HCZ2_BGDeformArray).l,a4
		lea	($FFFFA800).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------

HCZ2_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_50EFA(pc,d0.w)
; ---------------------------------------------------------------------------

loc_50EFA:
		bra.w	HCZ2BGE_WallMoveInit
; ---------------------------------------------------------------------------
		bra.w	HCZ2BGE_WallMove
; ---------------------------------------------------------------------------
		bra.w	HCZ2BGE_NormalTransition
; ---------------------------------------------------------------------------
		bra.w	HCZ2BGE_NormalRefresh
; ---------------------------------------------------------------------------
		bra.w	HCZ2BGE_Normal
; ---------------------------------------------------------------------------

HCZ2BGE_WallMoveInit:
		jsr	(Create_New_Sprite).l
		bne.s	loc_50F1C
		move.l	#Obj_HCZ2Wall,(a1)

loc_50F1C:
		addq.w	#4,($FFFFEEC2).w

HCZ2BGE_WallMove:
		tst.w	($FFFFEEC6).w
		bne.s	loc_50F64
		jsr	HCZ2_WallMove(pc)
		jsr	DrawBGAsYouMove(pc)
		jsr	PlainDeformation(pc)
		jsr	ShakeScreen_Setup(pc)
		jsr	Get_BGActualEffectiveDiff(pc)
		clr.b	($FFFFF664).w
		move.w	($FFFFB010).w,d0
		cmpi.w	#$3F0,d0
		bcs.s	locret_50F62
		cmpi.w	#$C10,d0
		bcc.s	locret_50F62
		move.w	($FFFFB014).w,d0
		cmpi.w	#$600,d0
		bcs.s	locret_50F62
		cmpi.w	#$840,d0
		bcc.s	locret_50F62
		st	($FFFFF664).w			; Only enable BG tile collision if player is within above parameters

locret_50F62:

		rts
; ---------------------------------------------------------------------------

loc_50F64:
		clr.w	($FFFFEEC6).w
		tst.w	($FFFFEECC).w
		bpl.s	loc_50F72
		clr.w	($FFFFEECC).w		; Disable screen shaking if still constant

loc_50F72:
		clr.b	($FFFFF664).w
		move.w	#$F0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w

HCZ2BGE_NormalTransition:
		move.w	#$400,d1
		moveq	#0,d2
		jsr	Draw_PlaneVertSingleBottomUp(pc)
		bpl.w	PlainDeformation
		jsr	HCZ2_Deform(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_50FB8
; ---------------------------------------------------------------------------

HCZ2BGE_NormalRefresh:
		jsr	HCZ2_Deform(pc)

loc_50FB8:
		moveq	#0,d1
		move.w	($FFFFEE90).w,d2
		jsr	Draw_PlaneVertBottomUp(pc)
		bpl.s	loc_50FCE
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_50FCE
; ---------------------------------------------------------------------------

HCZ2BGE_Normal:
		jsr	HCZ2_Deform(pc)

loc_50FCE:

		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jsr	Draw_TileRow(pc)
		lea	(HCZ2_BGDeformArray).l,a4
		lea	($FFFFA800).w,a5
		jsr	ApplyDeformation(pc)
		jmp	ShakeScreen_Setup(pc)

; =============== S U B R O U T I N E =======================================


HCZ2_WallMove:

		cmpi.b	#6,($FFFFB005).w
		bcc.s	loc_51052			; If player is dead, don't bother
		move.l	#$E000,d0
		cmpi.w	#$A88,($FFFFB010).w
		bcs.s	loc_5100C

loc_51006:
		move.l	#$14000,d0			; Speed up if player has passed the end already

loc_5100C:
		move.w	($FFFFEED2).w,d1
		beq.s	loc_5102E
		cmpi.w	#-$600,d1
		bgt.s	loc_5103A
		tst.w	($FFFFEECC).w		; When wall has travelled $600 pixels
		bpl.s	loc_51052
		move.w	#$E,($FFFFEECC).w	; Set screen shake to timed
		moveq	#$5F,d0
		jsr	(Play_Sound_2).l		; Play final crashing sound
		bra.s	loc_51052
; ---------------------------------------------------------------------------

loc_5102E:
		cmpi.w	#$680,($FFFFB010).w
		bcs.s	loc_51052			; If wall hasn't started moving and player hasn't moved far enough, end.
		st	($FFFFEECC).w			; Begin constant screen shake movement

loc_5103A:
		sub.l	d0,($FFFFEED2).w	; Subtract speed from BG X offset
		move.w	($FFFFFE04).w,d0
		subq.w	#1,d0
		andi.w	#$F,d0
		bne.s	loc_51052
		moveq	#$6F,d0
		jsr	(Play_Sound_2).l		; Play the screen shake sound every 16th frame

loc_51052:

		move.w	($FFFFEE84).w,d0	; Get BG camera Y
		subi.w	#$500,d0
		move.w	d0,($FFFFEE90).w	; Offset it by $500 and put it in effective BG Y
		move.w	($FFFFEE80).w,d0
		subi.w	#$200,d0
		add.w	($FFFFEED2).w,d0
		move.w	d0,($FFFFEE8C).w	; Do the same with the BG Camera X, offsetting it by the wall movement amount
		rts
; End of function HCZ2_WallMove


; =============== S U B R O U T I N E =======================================


HCZ2_Deform:

		move.w	($FFFFEE84).w,d0
		move.w	($FFFFEECE).w,d1
		sub.w	d1,d0
		asr.w	#2,d0
		add.w	d1,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEE80).w,d0
		swap	d0
		clr.w	d0
		asr.l	#1,d0
		move.l	d0,d1
		asr.l	#3,d1
		lea	($FFFFA800).w,a1
		lea	(HCZ2_BGDeformIndex).l,a5
		moveq	#0,d2

loc_5109C:
		move.b	(a5)+,d3
		bmi.s	loc_510B4
		ext.w	d3
		swap	d0

loc_510A4:
		move.b	(a5)+,d2
		move.w	d0,(a1,d2.w)
		dbf	d3,loc_510A4
		swap	d0
		sub.l	d1,d0
		bra.s	loc_5109C
; ---------------------------------------------------------------------------

loc_510B4:
		move.w	$12(a1),d0
		sub.w	$A(a1),d0
		move.w	d0,($FFFFEEE2).w
		move.w	6(a1),d0
		sub.w	$12(a1),d0
		move.w	d0,($FFFFEEE4).w
		move.w	4(a1),d0
		sub.w	$12(a1),d0
		move.w	d0,($FFFFEEE6).w
		rts
; End of function HCZ2_Deform

; ---------------------------------------------------------------------------

Obj_HCZ2Wall:

		cmpi.w	#4,($FFFFEEC2).w
		beq.s	loc_510E8
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_510E8:
		move.w	($FFFFEED2).w,d4
		neg.w	d4
		addi.w	#$5BE,d4
		move.w	d4,$10(a0)
		move.w	#$700,$14(a0)
		move.b	#$40,7(a0)
		bset	#7,$2A(a0)
		moveq	#$4B,d1
		move.w	#$100,d2
		move.w	#$100,d3
		jmp	(SolidObjectFull2).l
; ---------------------------------------------------------------------------

MGZ1_ScreenInit:
		clr.w	($FFFFEEE8).w
		jsr	Reset_TileOffsetPositionActual(pc)
		jmp	Refresh_PlaneFull(pc)
; ---------------------------------------------------------------------------

MGZ1_ScreenEvent:
		move.w	($FFFFEECE).w,d0
		add.w	d0,($FFFFEE84).w
		jsr	Do_ShakeSound(pc)
		jmp	DrawTilesAsYouMove(pc)
; ---------------------------------------------------------------------------

MGZ1_BackgroundInit:
		jsr	(MGZ1_Deform).l
		moveq	#0,d0
		moveq	#0,d1
		jsr	Refresh_PlaneFull(pc)
		lea	(MGZ1_BGDeformArray).l,a4
		lea	($FFFFA800).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------

MGZ1_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_51158(pc,d0.w)
; ---------------------------------------------------------------------------

loc_51158:
		bra.w	MGZ1BGE_Normal
; ---------------------------------------------------------------------------
		bra.w	MGZ1BGE_Transition
; ---------------------------------------------------------------------------

MGZ1BGE_Normal:
		tst.w	($FFFFEEC6).w
		beq.s	loc_511B0
		clr.w	($FFFFEEC6).w			; Transition time
		movem.l	d7-a0/a2-a3,-(sp)
		lea	(MGZ2_128x128_Secondary_Kos).l,a1
		lea	($FFFF6B00).l,a2
		jsr	(Queue_Kos).l
		lea	(MGZ2_16x16_Secondary_Kos).l,a1
		lea	($FFFF9C60).w,a2
		jsr	(Queue_Kos).l
		lea	(MGZ2_8x8_Secondary_KosM).l,a1
		move.w	#$4A40,d2
		jsr	(Queue_Kos_Module).l		; Queue art, blocks and chunks for act 2
		moveq	#$14,d0
		jsr	(Load_PLC).l					; Load act 2 PLCs
		movem.l	(sp)+,d7-a0/a2-a3
		addq.w	#4,($FFFFEEC2).w

loc_511B0:
		jsr	(MGZ1_Deform).l					; Pretty self-explanatory to be honest
		lea	(MGZ1_BGDeformArray).l,a4
		lea	($FFFFA800).w,a5
		jsr	ApplyDeformation(pc)
		jmp	ShakeScreen_Setup(pc)
; ---------------------------------------------------------------------------

MGZ1BGE_Transition:
		tst.b	($FFFFFF60).w
		bne.w	loc_51268				; Wait for Kos queue to finish
		move.w	#$201,($FFFFFE10).w		; Change act
		clr.b	($FFFFEE33).w
		clr.b	($FFFFF76C).w
		clr.b	($FFFFF710).w
		clr.b	($FFFFF7AA).w
		clr.b	($FFFFFF97).w			; Reset various managers
		jsr	Clear_Switches(pc)
		movem.l	d7-a0/a2-a3,-(sp)
		jsr	(Load_Level).l
		jsr	(LoadSolids).l
		moveq	#$F,d0
		jsr	(LoadPalette_Immediate).l
		movem.l	(sp)+,d7-a0/a2-a3
		move.w	#$2E00,d0
		move.w	#$600,d1
		sub.w	d0,($FFFFB010).w
		sub.w	d1,($FFFFB014).w
		sub.w	d0,($FFFFB05A).w
		sub.w	d1,($FFFFB05E).w
		jsr	Offset_ObjectsDuringTransition(pc)
		sub.w	d0,($FFFFEE78).w
		sub.w	d1,($FFFFEE7C).w
		sub.w	d0,($FFFFEE80).w
		sub.w	d1,($FFFFEE84).w
		sub.w	d0,($FFFFEE14).w
		sub.w	d0,($FFFFEE16).w
		sub.w	d1,($FFFFEE18).w
		sub.w	d1,($FFFFEE1A).w
		move.w	($FFFFEE1A).w,($FFFFEE12).w
		jsr	Reset_TileOffsetPositionActual(pc)
		clr.l	($FFFFEEE2).w
		clr.w	($FFFFEEE6).w
		clr.w	($FFFFEEA2).w
		clr.w	($FFFFEEB4).w
		clr.w	($FFFFEEB8).w
		clr.w	($FFFFEEC2).w		; Clear flags/values used for BG stuff in act 2

loc_51268:
		jsr	(MGZ1_Deform).l
		lea	(MGZ1_BGDeformArray).l,a4
		lea	($FFFFA800).w,a5
		jmp	ApplyDeformation(pc)

; =============== S U B R O U T I N E =======================================


Do_ShakeSound:

		cmpi.b	#6,($FFFFB005).w
		bcc.s	locret_512A4		; If dying, skip this
		tst.w	($FFFFEEE8).w
		bne.s	locret_512A4		; If flag is set, skip this
		tst.w	($FFFFEECC).w
		bpl.s	locret_512A4		; If screen is not shaking continuously, skip this
		move.w	($FFFFFE04).w,d0
		subq.w	#1,d0
		andi.w	#$F,d0
		bne.s	locret_512A4
		moveq	#$6F,d0
		jsr	(Play_Sound_2).l

locret_512A4:
		rts
; End of function Do_ShakeSound

; ---------------------------------------------------------------------------

MGZ2_ScreenInit:
		clr.l	($FFFFEEE2).w
		clr.l	($FFFFEEE6).w
		clr.w	($FFFFEEB4).w
		clr.w	($FFFFEEB8).w
		jsr	Reset_TileOffsetPositionActual(pc)
		jmp	Refresh_PlaneFull(pc)
; ---------------------------------------------------------------------------

MGZ2_ScreenEvent:
		move.w	($FFFFEECE).w,d0
		add.w	d0,($FFFFEE84).w
		tst.w	($FFFFEEB4).w
		beq.s	loc_512D0
		st	($FFFFEECC).w		; Turn continuous shaking on

loc_512D0:
		jsr	Do_ShakeSound(pc)
		move.w	($FFFFEEC0).w,d0
		jmp	loc_512DC(pc,d0.w)
; ---------------------------------------------------------------------------

loc_512DC:
		bra.w	MGZ2SE_Normal
; ---------------------------------------------------------------------------
		bra.w	MGZ2SE_Collapse
; ---------------------------------------------------------------------------
		bra.w	MGZ2SE_MoveBG
; ---------------------------------------------------------------------------

MGZ2SE_Normal:
		tst.w	($FFFFEEC4).w
		bne.s	loc_512FA
		jsr	MGZ2_QuakeEvent(pc)
		jsr	MGZ2_ChunkEvent(pc)
		jmp	DrawTilesAsYouMove(pc)
; ---------------------------------------------------------------------------

loc_512FA:
		clr.w	($FFFFEEC4).w		; Clear background event
		st	($FFFFEEE8).w
		move.w	#$14,($FFFFEECC).w
		addq.w	#4,($FFFFEEC0).w

MGZ2SE_Collapse:
		jsr	MGZ2_LevelCollapse(pc)
		tst.w	($FFFFEECC).w
		bmi.s	loc_5131A
		jmp	DrawTilesAsYouMove(pc)
; ---------------------------------------------------------------------------

loc_5131A:
		lea	(MGZ2_FGVScrollArray).l,a4
		lea	($FFFFA900).w,a5
		moveq	#$F,d6
		moveq	#$A,d5
		jmp	DrawTilesVDeform(pc)
; ---------------------------------------------------------------------------

MGZ2SE_MoveBG:
		move.l	($FFFFEEDA).w,d0
		cmpi.l	#$50000,d0
		bcc.s	loc_51342
		addi.l	#$800,d0
		move.l	d0,($FFFFEEDA).w

loc_51342:
		swap	d0
		add.w	d0,($FFFFEEDE).w	; Apply a movement offset for the BG scrolling during the boss
		jmp	DrawTilesAsYouMove(pc)

; =============== S U B R O U T I N E =======================================


MGZ2_LevelCollapse:
		cmpi.b	#6,($FFFFB005).w
		bcc.w	locret_514A8		; If dying, don't do anything else
		tst.w	($FFFFEECC).w
		bmi.w	loc_5140C			; If shaking continuously, branch
		bne.w	locret_514A8
		movea.w	$38(a3),a1			; Get chunk line at $700 Y
		lea	$79(a1),a1				; Get chunk at $3C80
		move.w	-8(a3),d0			; Get FG level X chunksize
		subq.w	#3,d0
		moveq	#2,d1

loc_51372:
		clr.b	(a1)+
		clr.b	(a1)+
		clr.b	(a1)+				; Clear the three main chunks on three lines that comprise the boss battle
		adda.w	d0,a1
		dbf	d1,loc_51372
		lea	($FFFFA902).w,a1
		lea	($FFFFA93C).w,a5
		lea	$28(a5),a6
		move.w	($FFFFEE84).w,d0	; Get BG Y camera
		and.w	($FFFFEEAC).w,d0	; AND it to get tile position
		moveq	#9,d1

loc_51394:
		move.w	d0,(a1)
		addq.w	#4,a1
		clr.l	(a5)+
		clr.l	(a6)+				; Clear scroll values, etc
		dbf	d1,loc_51394
		jsr	(Create_New_Sprite).l
		bne.s	loc_513FA
		move.w	#$3C90,d1
		move.l	#$5C00790,d2
		move.l	#$FFFFA93C,d3
		moveq	#9,d4

loc_513BA:
		move.l	#Obj_MGZ2LevelCollapseSolid,(a1)		; Create solid objects that Sonic can stand on as the level collapses
		move.w	d1,$10(a1)
		move.w	d2,$2E(a1)
		move.l	d3,$30(a1)
		swap	d2
		jsr	(CreateNewSprite4).l
		bne.s	loc_513FA
		move.l	#Obj_MGZ2LevelCollapseSolid,(a1)
		move.w	d1,$10(a1)
		move.w	d2,$2E(a1)
		move.l	d3,$30(a1)
		addi.w	#$20,d1
		swap	d2
		addq.l	#4,d3
		jsr	(CreateNewSprite4).l
		dbne	d4,loc_513BA

loc_513FA:

		st	($FFFFEECC).w		; Turn quake on
		clr.w	($FFFFEED8).w
		st	($FFFFEEA2).w			; Turn on special VScroll VInt function
		move.w	#4,($FFFFEEA6).w

loc_5140C:
		lea	($FFFFA900).w,a1
		lea	$28(a1),a4
		lea	$14(a4),a5
		lea	(MGZ2_CollapseScrollDelay).l,a6
		move.w	($FFFFEED8).w,d0
		addq.w	#1,($FFFFEED8).w
		moveq	#$A,d1
		moveq	#9,d2

loc_5142A:
		cmp.w	(a6)+,d0		; Get scroll delay for each block
		bcs.s	loc_51436
		addi.l	#$500,$64(a1)	; Add $500 to Vscroll velocity for this block when not delayed

loc_51436:
		move.l	$64(a1),d3
		add.l	d3,(a5)+		; Add velocity to actual VScroll
		move.w	-4(a5),d3
		cmpi.w	#$2E0,d3
		bcs.s	loc_5144C
		move.w	#$2E0,d3		; $2E0 is the maximum scroll
		subq.w	#1,d1			; When maximum scroll is reached, lower amount of "active" scrolling lines

loc_5144C:
		move.w	($FFFFEE84).w,d4	; Get BG Y
		sub.w	d3,d4
		move.w	d4,(a4)+
		move.w	d4,(a1)				; Subtract from scroll to get... something
		addq.w	#4,a1
		dbf	d2,loc_5142A			; Repeat until all scrolling parts are off-screen
		move.w	($FFFFFE04).w,d0
		subq.w	#1,d0
		andi.w	#$F,d0
		bne.s	loc_51470
		moveq	#-$34,d0			; Play collapsing sound every 16 frames
		jsr	(Play_Sound_2).l

loc_51470:
		tst.w	d1
		bne.s	locret_514A8		; If scrolling chunks still remain, do nothing
		movea.w	$2C(a3),a1			; Get chunk line at $580 Y
		lea	$79(a1),a1				; Get chunk at $3C80 X
		move.w	-8(a3),d0
		subq.w	#3,d0
		moveq	#2,d1

loc_51484:
		clr.b	(a1)+
		clr.b	(a1)+
		clr.b	(a1)+
		adda.w	d0,a1
		dbf	d1,loc_51484
		clr.w	($FFFFEECC).w		; Stop quaking
		clr.l	($FFFFEEDA).w		; Stop special tile drawing
		move.w	($FFFFEE80).w,($FFFFEEDE).w
		move.w	#$C,($FFFFEEA6).w	; Set VScroll VInt routine
		addq.w	#4,($FFFFEEC0).w	; Next screen routine

locret_514A8:

		rts
; End of function MGZ2_LevelCollapse


; =============== S U B R O U T I N E =======================================


MGZ2_QuakeEvent:
		tst.w	($FFFFEEB8).w
		beq.s	loc_514D8
		bpl.s	loc_514BE
		tst.l	($FFFFF680).w
		bne.s	loc_514D8
		move.w	#$FF,($FFFFEEB8).w

loc_514BE:
		move.w	($FFFFEE18).w,d0
		beq.s	loc_514D8
		cmpi.w	#$1E0,d0
		beq.s	loc_514D8
		subq.w	#2,d0
		bcc.s	loc_514D4
		moveq	#0,d0
		move.w	d0,($FFFFEEB8).w

loc_514D4:
		move.w	d0,($FFFFEE18).w

loc_514D8:
		move.w	($FFFFB010).w,d0
		move.w	($FFFFB014).w,d1
		move.w	($FFFFEEE2).w,d2
		jmp	loc_514E8(pc,d2.w)
; End of function MGZ2_QuakeEvent

; ---------------------------------------------------------------------------

loc_514E8:
		bra.w	MGZ2_QuakeEventCheck
; ---------------------------------------------------------------------------
		bra.w	MGZ2_QuakeEvent1
; ---------------------------------------------------------------------------
		bra.w	MGZ2_QuakeEvent2
; ---------------------------------------------------------------------------
		bra.w	MGZ2_QuakeEvent3
; ---------------------------------------------------------------------------
		bra.w	MGZ2_QuakeEvent1Cont
; ---------------------------------------------------------------------------
		bra.w	MGZ2_QuakeEvent2Cont
; ---------------------------------------------------------------------------
		bra.w	MGZ2_QuakeEvent3Cont
; ---------------------------------------------------------------------------

MGZ2_QuakeEventCheck:
		lea	($FFFFEEE4).w,a5		; EEE4-EEE6 are flags to determine whether earthquake event has already completed. There are three
		lea	(MGZ2_QuakeEventArray).l,a1
		moveq	#4,d2
		moveq	#2,d3

loc_51512:
		tst.b	(a5)
		bne.s	loc_51552
		cmp.w	(a1),d0
		bcs.s	loc_51552
		cmp.w	2(a1),d0
		bcc.s	loc_51552
		cmp.w	4(a1),d1
		bcs.s	loc_51552
		cmp.w	6(a1),d1
		bcc.s	loc_51552
		move.w	d2,($FFFFEEE2).w
		move.w	8(a1),d0
		move.w	d0,($FFFFEE1A).w
		move.w	d0,($FFFFEE12).w
		move.w	$A(a1),d0
		cmpi.w	#4,d2
		bne.s	loc_5154C
		move.w	d0,($FFFFEE16).w	; First earthquake event near start of level makes you go right
		rts
; ---------------------------------------------------------------------------

loc_5154C:
		move.w	d0,($FFFFEE14).w	; The other two make you go left
		rts
; ---------------------------------------------------------------------------

loc_51552:

		lea	$C(a1),a1
		addq.w	#1,a5
		addq.w	#4,d2
		dbf	d3,loc_51512
		rts
; ---------------------------------------------------------------------------

MGZ2_QuakeEvent1:
		cmpi.w	#$780,d0
		bcs.w	loc_51656		; If player retreats, revert to normal camera movement
		move.w	($FFFFEE16).w,d0
		cmp.w	($FFFFEE78).w,d0
		bhi.s	locret_515A2		; If camera X hasn't reached level X end, branch
		move.w	d0,($FFFFEE14).w	; Lock the screen
		st	($FFFFEEE4).w			; Set the earthquake flag for this first one
		addi.w	#$C,($FFFFEEE2).w	; Set next quake event routine
		jsr	(Create_New_Sprite).l
		bne.s	locret_515A2
		move.l	#Obj_MGZ2DrillingEggman,(a1)
		move.w	#$8E0,$10(a1)
		move.w	#$690,$14(a1)		; Create drilling eggman boss sprite
		st	($FFFFEECC).w
		st	($FFFFEEB4).w			; Start shaking the screen

locret_515A2:

		rts
; ---------------------------------------------------------------------------

MGZ2_QuakeEvent2:
		cmpi.w	#$3200,d0
		bcs.s	loc_515B4
		move.w	#$1DF,($FFFFEE18).w	; If player retreats, reset level height
		bra.w	loc_51656
; ---------------------------------------------------------------------------

loc_515B4:
		move.w	($FFFFEE1A).w,d1
		cmp.w	($FFFFEE7C).w,d1
		bne.s	loc_515CC
		cmp.w	($FFFFEE18).w,d1
		beq.s	loc_515CC
		move.w	d1,($FFFFEE18).w	; Adjust level height during this event
		st	($FFFFEEB9).w

loc_515CC:

		move.w	($FFFFEE14).w,d0	; If camera X hasn't reached level X start, branch
		cmp.w	($FFFFEE78).w,d0
		bcs.s	locret_5160C
		move.w	d0,($FFFFEE16).w	; Lock the screen
		st	($FFFFEEE5).w			; Set this earthquake flag
		addi.w	#$C,($FFFFEEE2).w	; Set next quake event routine
		jsr	(Create_New_Sprite).l
		bne.s	locret_5160C
		move.l	#Obj_MGZ2DrillingEggman,(a1)
		bset	#0,4(a1)
		move.w	#$2FA0,$10(a1)
		move.w	#$2D0,$14(a1)		; Set Robotnik drilling object
		st	($FFFFEECC).w
		st	($FFFFEEB4).w			; Start quaking

locret_5160C:

		rts
; ---------------------------------------------------------------------------

MGZ2_QuakeEvent3:
		cmpi.w	#$3480,d0			; Same as above, you know the drill (haha, drill...)
		bcc.s	loc_51656
		move.w	($FFFFEE14).w,d0
		cmp.w	($FFFFEE78).w,d0
		bcs.s	locret_51654
		move.w	d0,($FFFFEE16).w
		st	($FFFFEEE6).w
		addi.w	#$C,($FFFFEEE2).w
		jsr	(Create_New_Sprite).l
		bne.s	locret_51654
		move.l	#Obj_MGZ2DrillingEggman,(a1)
		bset	#0,4(a1)
		move.w	#$3300,$10(a1)
		move.w	#$790,$14(a1)
		st	($FFFFEECC).w
		st	($FFFFEEB4).w

locret_51654:

		rts
; ---------------------------------------------------------------------------

loc_51656:

		move.w	#$1000,d0
		move.w	d0,($FFFFEE1A).w
		move.w	d0,($FFFFEE12).w
		move.l	#$6000,d0
		move.l	d0,($FFFFEE14).w
		clr.w	($FFFFEEE2).w
		rts
; ---------------------------------------------------------------------------

MGZ2_QuakeEvent1Cont:
		cmpi.w	#$980,($FFFFB010).w
		bcc.s	loc_516A2			; Reset level Y end when Sonic has travelled past $980 X
		rts
; ---------------------------------------------------------------------------

MGZ2_QuakeEvent2Cont:
		cmpi.w	#$100,($FFFFB014).w
		bcc.s	locret_51696
		cmpi.w	#$2F80,($FFFFB010).w
		bcs.s	locret_51696
		move.w	#$6000,d0
		move.w	d0,($FFFFEE16).w
		bra.s	loc_516A2
; ---------------------------------------------------------------------------

locret_51696:

		rts
; ---------------------------------------------------------------------------

MGZ2_QuakeEvent3Cont:
		cmpi.w	#$3200,($FFFFB010).w
		bcs.s	loc_516A2
		rts
; ---------------------------------------------------------------------------

loc_516A2:

		move.w	#$1000,d0
		move.w	d0,($FFFFEE1A).w
		move.w	d0,($FFFFEE12).w
		clr.w	($FFFFEEE2).w
		rts

; =============== S U B R O U T I N E =======================================


MGZ2_ChunkEvent:
		move.w	($FFFFEED6).w,d0
		jmp	loc_516BC(pc,d0.w)
; End of function MGZ2_ChunkEvent

; ---------------------------------------------------------------------------

loc_516BC:
		bra.w	MGZ2_ChunkEventCheck
; ---------------------------------------------------------------------------
		bra.w	MGZ2_ChunkEvent1
; ---------------------------------------------------------------------------
		bra.w	MGZ2_ChunkEvent2_3
; ---------------------------------------------------------------------------
		bra.w	MGZ2_ChunkEvent2_3
; ---------------------------------------------------------------------------
		bra.w	MGZ2_ChunkEventReset
; ---------------------------------------------------------------------------
		rts
; ---------------------------------------------------------------------------

MGZ2_ChunkEventCheck:
		move.w	($FFFFB010).w,d0
		move.w	($FFFFB014).w,d1
		lea	(MGZ2_ChunkEventArray).l,a1
		moveq	#4,d2
		moveq	#2,d3

loc_516E4:
		cmp.w	(a1),d0
		bcs.s	loc_51706
		cmp.w	2(a1),d0
		bcc.s	loc_51706
		cmp.w	4(a1),d1
		bcs.s	loc_51706
		cmp.w	6(a1),d1
		bcc.s	loc_51706
		cmpi.w	#4,d2
		bne.s	loc_51712
		tst.w	($FFFFEECC).w
		bmi.s	loc_51712		; Only perform the first layout shift event if screen is continually shaking

loc_51706:

		lea	$C(a1),a1
		addq.w	#4,d2
		dbf	d3,loc_516E4
		rts
; ---------------------------------------------------------------------------

loc_51712:

		move.w	d2,($FFFFEED6).w
		clr.w	($FFFFEED8).w
		clr.w	($FFFFEEDA).w
		move.w	8(a1),($FFFFEEDC).w
		move.w	$A(a1),($FFFFEEDE).w

MGZ2_ChunkEvent1:
		move.w	($FFFFEED8).w,d0
		cmpi.w	#$5C,d0
		bcs.s	loc_51762
		clr.w	($FFFFEECC).w		; Stop shaking when first chunk event is finished
		clr.w	($FFFFEEB4).w		; Reset quake event
		clr.w	($FFFFEE14).w		; Reset level height
		move.w	#$10,($FFFFEED6).w
		rts
; ---------------------------------------------------------------------------

MGZ2_ChunkEvent2_3:

		move.w	($FFFFEED8).w,d0
		cmpi.w	#$5C,d0
		bcs.s	loc_51762
		move.w	#$6000,d0
		move.w	d0,($FFFFEE16).w	; Reset level end X
		move.w	#$14,($FFFFEED6).w
		rts
; ---------------------------------------------------------------------------

loc_51762:

		subq.w	#1,($FFFFEEDA).w
		bpl.s	locret_517C2
		move.w	#6,($FFFFEEDA).w	; Perform the layout change once every seven frames
		move.w	d0,d2
		bsr.s	MGZ2_ModifyChunk
		move.w	($FFFFEEDC).w,d0
		addi.w	#$80,d0
		sub.w	($FFFFEE80).w,d0
		bcs.s	locret_517C2
		cmpi.w	#$1C0,d0			; Calculate the X position of the screen redraw
		bcc.s	locret_517C2
		move.w	($FFFFEEDE).w,d0
		lea	(MGZ2_ScreenRedrawArray).l,a1
		add.w	(a1,d2.w),d0		; Calculate the Y position
		move.w	2(a1,d2.w),d2		; And the number of lines to write

loc_51798:
		move.w	($FFFFEE84).w,d3
		and.w	($FFFFEEAC).w,d3
		cmp.w	d3,d0
		bcs.s	loc_517BA
		addi.w	#$F0,d3
		cmp.w	d3,d0
		bcc.s	loc_517BA
		move.w	($FFFFEEDC).w,d1
		moveq	#8,d6				; Always draw 8 tiles
		swap	d2
		jsr	Setup_TileRowDraw(pc)
		swap	d2

loc_517BA:

		addi.w	#$10,d0
		dbf	d2,loc_51798

locret_517C2:

		rts
; ---------------------------------------------------------------------------

MGZ2_ChunkEventReset:
		cmpi.w	#$2A00,($FFFFB010).w	; When Player has travelled far enough, reset the chunk to its original form
		bcs.s	locret_517D4
		clr.w	($FFFFEED6).w
		moveq	#$5C,d0
		bra.s	MGZ2_ModifyChunk
; ---------------------------------------------------------------------------

locret_517D4:
		rts

; =============== S U B R O U T I N E =======================================


MGZ2_ModifyChunk:

		lea	(MGZ2_ChunkReplaceArray).l,a1
		lea	($FF5880).l,a5
		bsr.s	sub_517EA
		lea	($FF7500).l,a5
; End of function MGZ2_ModifyChunk


; =============== S U B R O U T I N E =======================================


sub_517EA:
		lea	(MGZ2_QuakeChunks).l,a4
		adda.w	(a1,d0.w),a4
		moveq	#7,d1

loc_517F6:
		move.l	(a4)+,(a5)+
		move.l	(a4)+,(a5)+
		move.l	(a4)+,(a5)+
		move.l	(a4)+,(a5)+
		dbf	d1,loc_517F6
		addq.w	#2,d0
		move.w	d0,($FFFFEED8).w
		rts
; End of function sub_517EA

; ---------------------------------------------------------------------------

Obj_MGZ2LevelCollapseSolid:

		cmpi.w	#8,($FFFFEEC0).w
		bne.s	loc_51818
		jmp	(Delete_Current_Sprite).l		; Delete control object when next screen event is in effect
; ---------------------------------------------------------------------------

loc_51818:
		movea.l	$30(a0),a1		; Get vertical scroll position for this block
		move.w	$2E(a0),d0		; Get vertical position
		add.w	(a1),d0			; Add it to scroll value to get final Y position
		move.w	d0,$14(a0)
		move.b	#$10,7(a0)		; Set up width
		bset	#7,$2A(a0)		; Make it invisible
		moveq	#$1B,d1
		moveq	#$40,d2
		moveq	#$40,d3			; Height, etc
		move.w	$10(a0),d4		; Position
		jmp	(SolidObjectFull2).l
; ---------------------------------------------------------------------------

MGZ2_BackgroundInit:
		jsr	MGZ2_ClearBottomBG(pc)
		move.w	#4,($FFFFEEC2).w	; Use second background event
		clr.w	($FFFFEEA2).w		; Clear VScroll routine flag
		move.w	($FFFFB010).w,d0
		move.w	($FFFFB014).w,d1
		cmpi.w	#$500,d1
		bcc.s	loc_5187E
		cmpi.w	#$3800,d0
		bcs.s	loc_518CA
		move.w	#4,($FFFFEED2).w	; If player is <$500 Y and >$3800 X (Knuckles area presumably)
		move.l	#Obj_MGZ2BGMoveKnux,d1
		cmpi.w	#$3A80,d0
		bcs.s	loc_518C0
		move.w	#$220,($FFFFEED4).w
		bra.s	loc_518CA
; ---------------------------------------------------------------------------

loc_5187E:
		cmpi.w	#$800,d1
		bcs.s	loc_518A4
		cmpi.w	#$34C0,d0
		bcs.s	loc_518CA
		move.w	#8,($FFFFEED2).w	; If player is >$800 Y and >$34C0 X
		move.l	#Obj_MGZ2BGMoveSonic,d1
		cmpi.w	#$3800,d0
		bcs.s	loc_518C0
		move.w	#$1D0,($FFFFEED4).w
		bra.s	loc_518CA
; ---------------------------------------------------------------------------

loc_518A4:
		cmpi.w	#$3900,d0
		bcs.s	loc_518CA
		move.w	#$C,($FFFFEED2).w	; If player is >$3900X and inbetween $500 and $800 Y
		move.w	#$1D0,($FFFFEED4).w
		st	($FFFFEEE0).w			; Turn off cloud movement
		clr.l	($FFFFA838).w
		bra.s	loc_518CA
; ---------------------------------------------------------------------------

loc_518C0:

		jsr	(Create_New_Sprite).l
		bne.s	loc_518CA
		move.l	d1,(a1)

loc_518CA:

		jsr	(MGZ2_BGDeform).l
		jsr	Reset_TileOffsetPositionEff(pc)
		clr.l	($FFFFA800).w
		move.w	d2,($FFFFA806).w
		lea	(MGZ2_BGDrawArray).l,a4
		lea	($FFFFA800).w,a5
		jsr	Refresh_PlaneTileDeform(pc)
		lea	(MGZ2_BGDeformArray).l,a4
		lea	($FFFFA808).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------

MGZ2_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_51900(pc,d0.w)
; ---------------------------------------------------------------------------

loc_51900:
		bra.w	MGZ2BGE_GoRefresh
; ---------------------------------------------------------------------------
		bra.w	MGZ2BGE_Normal
; ---------------------------------------------------------------------------
		bra.w	MGZ2BGE_Refresh
; ---------------------------------------------------------------------------

MGZ2BGE_GoRefresh:
		jsr	MGZ2_ClearBottomBG(pc)
		clr.l	($FFFFA800).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_51968
; ---------------------------------------------------------------------------

MGZ2BGE_Normal:
		jsr	MGZ2_BGEventTrigger(pc)
		bne.s	loc_51968		; If BG event has triggered, go refresh the BG
		jsr	(MGZ2_BGDeform).l

loc_51926:

		lea	(MGZ2_BGDrawArray).l,a4
		lea	($FFFFA800).w,a5
		moveq	#$20,d6
		moveq	#2,d5
		jsr	Draw_BG(pc)
		lea	(MGZ2_BGDeformArray).l,a4
		lea	($FFFFA808).w,a5
		jsr	ApplyDeformation(pc)
		lea	(MGZ2_FGVScrollArray).l,a4
		lea	($FFFFA926).w,a5
		jsr	Apply_FGVScroll(pc)
		jsr	Get_BGActualEffectiveDiff(pc)
		jsr	ShakeScreen_Setup(pc)
		tst.b	($FFFFF664).w
		beq.s	locret_51966
		jmp	Go_CheckPlayerRelease(pc)			; Only do this if BG collision is on
; ---------------------------------------------------------------------------

locret_51966:
		rts
; ---------------------------------------------------------------------------

loc_51968:

		jsr	(MGZ2_BGDeform).l
		jsr	Reset_TileOffsetPositionEff(pc)
		move.w	d2,($FFFFA806).w
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_51994
; ---------------------------------------------------------------------------

MGZ2BGE_Refresh:
		jsr	(MGZ2_BGDeform).l

loc_51994:
		lea	(MGZ2_BGDrawArray).l,a4
		lea	($FFFFA7FC).w,a5
		move.w	($FFFFEE90).w,d1
		jsr	Draw_PlaneVertBottomUpComplex(pc)
		bpl.w	loc_51926
		subq.w	#4,($FFFFEEC2).w
		bra.w	loc_51926

; =============== S U B R O U T I N E =======================================


MGZ2_ClearBottomBG:

		move.w	(a3),d0
		addq.w	#8,d0
		move.w	d0,$74(a3)
		move.w	d0,$78(a3)
		move.w	d0,$7C(a3)
		rts
; End of function MGZ2_ClearBottomBG


; =============== S U B R O U T I N E =======================================


MGZ2_BGEventTrigger:
		tst.w	($FFFFEEA2).w
		beq.s	loc_519CC
		rts
; ---------------------------------------------------------------------------

loc_519CC:
		move.w	($FFFFB010).w,d0
		move.w	($FFFFB014).w,d1
		move.w	($FFFFEED2).w,d2
		jmp	loc_519DC(pc,d2.w)
; End of function MGZ2_BGEventTrigger

; ---------------------------------------------------------------------------

loc_519DC:
		bra.w	loc_51A6A	; 0 - Normal
; ---------------------------------------------------------------------------
		bra.w	loc_51A3C	; 4 - Knuckles BG Move Event
; ---------------------------------------------------------------------------
		bra.w	loc_51A04	; 8 - Sonic BG Move Event
; ---------------------------------------------------------------------------
		clr.b	($FFFFF664).w	; C - After BG Move
		cmpi.w	#$800,d1		; Turn off BG collision
		bcs.w	loc_51AB8
		cmpi.w	#$3A40,d0
		bcs.w	loc_51AB8		; If Player (Sonic/Tails) is > $800 Y and > $3A40 X, go back to BG event
		move.w	#8,($FFFFEED2).w
		rts
; ---------------------------------------------------------------------------

loc_51A04:
		st	($FFFFF664).w		; Set BG collision on
		cmpi.w	#$800,d1
		bcc.s	loc_51A22
		cmpi.w	#$3900,d0
		bcs.w	loc_51AB8
		st	($FFFFEEE0).w		; If Player < $800 Y and > $3900 X, turn off cloud movement
		clr.l	($FFFFA838).w
		moveq	#$C,d0			; Got to after BG Event trigger
		bra.s	loc_51A34
; ---------------------------------------------------------------------------

loc_51A22:
		cmpi.w	#$900,d1
		bcc.w	loc_51AB8
		cmpi.w	#$34C0,d0
		bcc.w	loc_51AB8		; If player is > $900 Y or > $34C0 X, continue normal deformation
		moveq	#0,d0

loc_51A34:
		move.w	d0,($FFFFEED2).w	; Otherwise, return to normal BG collision trigger
		moveq	#-1,d0
		rts
; ---------------------------------------------------------------------------

loc_51A3C:
		st	($FFFFF664).w		; Set BG collision on
		cmpi.w	#$100,d1
		bcc.s	loc_51A50
		cmpi.w	#$3C00,d0
		bcs.s	loc_51A50
		clr.b	($FFFFF664).w	; If Player < $100 Y and > $3C00 X, turn off BG collision

loc_51A50:

		cmpi.w	#$80,d1
		bcs.s	loc_51AB8
		cmpi.w	#$180,d1
		bcc.s	loc_51AB8
		cmpi.w	#$3800,d0
		bcc.s	loc_51AB8		; If player is < $80 Y and > $180 Y and  > $3800 X, continue deformation
		clr.w	($FFFFEED2).w	; Otherwise
		moveq	#-1,d0
		rts
; ---------------------------------------------------------------------------

loc_51A6A:
		clr.b	($FFFFF664).w
		cmpi.w	#$80,d1
		bcs.s	loc_51AB8
		cmpi.w	#$180,d1
		bcc.s	loc_51A8A
		cmpi.w	#$3800,d0
		bcs.s	loc_51AB8
		moveq	#4,d0			; If between $80 and $180 Y and > $3800 X, use first BG move
		move.l	#Obj_MGZ2BGMoveKnux,d1
		bra.s	loc_51AA4
; ---------------------------------------------------------------------------

loc_51A8A:
		cmpi.w	#$800,d1
		bcs.s	loc_51AB8
		cmpi.w	#$900,d1
		bcc.s	loc_51AB8
		cmpi.w	#$34C0,d0
		bcs.s	loc_51AB8
		moveq	#8,d0			; If between $800 and $900 Y and > $34C0 X, use second BG move
		move.l	#Obj_MGZ2BGMoveSonic,d1

loc_51AA4:
		move.w	d0,($FFFFEED2).w
		clr.w	($FFFFEED4).w
		jsr	(Create_New_Sprite).l
		bne.s	locret_51AB6
		move.l	d1,(a1)

locret_51AB6:
		rts
; ---------------------------------------------------------------------------

loc_51AB8:

		moveq	#0,d0
		rts
; ---------------------------------------------------------------------------

Obj_MGZ2BGMoveKnux:

		moveq	#4,d0
		move.w	#$400,d1
		move.w	#$38A0,d2
		move.w	#$220,d3
		move.w	#$6000,d4
		bra.s	loc_51AE6
; ---------------------------------------------------------------------------

Obj_MGZ2BGMoveSonic:

		moveq	#8,d0
		move.w	#$A80,d1
		move.w	#$36D0,d2
		move.w	#$1D0,d3
		move.w	#$6000,d4
		st	$38(a0)

loc_51AE6:
		cmp.w	($FFFFEED2).w,d0
		beq.s	loc_51AF2
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_51AF2:
		cmp.w	($FFFFB014).w,d1
		bcc.s	locret_51AFE
		cmp.w	($FFFFB010).w,d2
		bcs.s	loc_51B00

locret_51AFE:
		rts
; ---------------------------------------------------------------------------

loc_51B00:
		move.w	d3,$2E(a0)
		move.w	d4,$32(a0)
		move.w	($FFFFEE80).w,d0
		move.w	d0,($FFFFEE14).w
		bset	#7,($FFFFF74F).w
		move.l	#loc_51B1C,(a0)

loc_51B1C:
		move.w	($FFFFEED4).w,d0
		cmp.w	$2E(a0),d0			; Wait for BG offset to match given value
		bcs.s	loc_51B44
		moveq	#$5F,d0				; Play final crashing sound
		jsr	(Play_Sound_2).l
		move.w	#$E,($FFFFEECC).w	; Do final screen shake
		clr.w	($FFFFEEB4).w		; Disable constant screen shaking
		bclr	#7,($FFFFF74F).w	; Reenable Knuckles wall grab
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_51B44:
		move.w	($FFFFB010).w,d2
		move.w	($FFFFB014).w,d3
		tst.b	$39(a0)
		beq.s	loc_51B58
		move.w	d0,d1
		addq.w	#1,d1
		bra.s	loc_51B84
; ---------------------------------------------------------------------------

loc_51B58:
		tst.b	$38(a0)
		bne.s	loc_51B6C
		cmpi.w	#$200,d3
		bcc.s	loc_51B76
		cmpi.w	#$3CB0,d2
		bcs.s	loc_51B72
		bra.s	loc_51B76
; ---------------------------------------------------------------------------

loc_51B6C:
		cmpi.w	#$3D50,d2	; Second background object check
		bcs.s	loc_51B76

loc_51B72:
		st	$39(a0)

loc_51B76:

		move.l	$34(a0),d1
		add.l	$30(a0),d1
		move.l	d1,$34(a0)
		swap	d1

loc_51B84:
		move.w	d1,($FFFFEED4).w	; Move background offset
		sub.w	d0,d1
		sub.w	d1,($FFFFB014).w
		sub.w	d1,($FFFFB05E).w
		rts
; ---------------------------------------------------------------------------

CNZ1_ScreenInit:
		jsr	Reset_TileOffsetPositionActual(pc)
		jmp	Refresh_PlaneFull(pc)
; ---------------------------------------------------------------------------

CNZ1_ScreenEvent:
		tst.w	($FFFFEED8).w
		beq.s	loc_51BAA
		clr.w	($FFFFEED8).w
		jmp	Refresh_PlaneScreenDirect(pc)
; ---------------------------------------------------------------------------

loc_51BAA:
		jsr	DrawTilesAsYouMove(pc)
		lea	($FFFFEED2).w,a5
		tst.l	(a5)
		beq.w	locret_51C6A
		move.w	(a5)+,d0			; All this below is for removing chunks from the miniboss arena
		move.w	(a5),d1
		clr.l	-2(a5)
		move.w	d0,d2
		move.w	d1,d3
		asr.w	#3,d2
		move.w	d2,d4
		asr.w	#4,d2
		move.w	d3,d5
		asr.w	#5,d3
		and.w	($FFFFEEAE).w,d3
		movea.w	(a3,d3.w),a4
		moveq	#-1,d6
		clr.w	d6
		move.b	(a4,d2.w),d6
		lsl.w	#7,d6
		andi.w	#$C,d4
		andi.w	#$60,d5
		add.w	d4,d6
		add.w	d5,d6
		movea.l	d6,a4
		clr.l	(a4)
		clr.l	$10(a4)		; Clear the neccesary parts of the chunks
		asr.w	#2,d0
		andi.w	#$78,d0
		lsl.w	#4,d1
		andi.w	#$E00,d1
		add.w	d1,d0
		add.w	d7,d0
		moveq	#0,d1
		move.w	d0,(a0)+
		move.w	#1,(a0)+
		move.l	d1,(a0)+
		move.l	d1,(a0)+
		move.l	d1,(a0)+
		move.l	d1,(a0)+
		addi.w	#$100,d0
		move.w	d0,(a0)+
		move.w	#1,(a0)+
		move.l	d1,(a0)+
		move.l	d1,(a0)+
		move.l	d1,(a0)+
		move.l	d1,(a0)+		; Add a VRAM write to remove it from the screen
		clr.w	(a0)
		movea.w	$18(a3),a4
		lea	$64(a4),a4			; Level layout $300 Y $3200 X (the boss arena blocks)
		moveq	#0,d1
		clr.w	($FFFFEED6).w
		moveq	#3,d3

loc_51C38:
		lea	(a4),a5
		moveq	#2,d2

loc_51C3C:
		moveq	#-1,d0
		clr.w	d0
		move.b	(a5)+,d0
		lsl.w	#7,d0
		add.w	d1,d0
		movea.l	d0,a6
		tst.l	(a6)+
		bne.s	locret_51C6A
		tst.l	(a6)+
		bne.s	locret_51C6A
		tst.l	(a6)+
		bne.s	locret_51C6A
		tst.l	(a6)
		bne.s	locret_51C6A
		dbf	d2,loc_51C3C
		addi.w	#$20,d1			; Basically, if a line of blocks is completely destroyed, the boss is lowered by $20 pixels to compensate.
		addi.w	#$20,($FFFFEED6).w
		dbf	d3,loc_51C38

locret_51C6A:

		rts
; ---------------------------------------------------------------------------

CNZ1_BackgroundInit:
		jsr	CNZ1_Deform(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		moveq	#0,d1
		jsr	Refresh_PlaneFull(pc)
		lea	CNZ1_BGDeformArray(pc),a4
		lea	($FFFFA800).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------

CNZ1_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_51C8E(pc,d0.w)
; ---------------------------------------------------------------------------

loc_51C8E:
		bra.w	CNZ1BGE_Normal
; ---------------------------------------------------------------------------
		bra.w	CNZ1BGE_BossStart
; ---------------------------------------------------------------------------
		bra.w	CNZ1BGE_Boss
; ---------------------------------------------------------------------------
		bra.w	CNZ1BGE_AfterBoss
; ---------------------------------------------------------------------------
		bra.w	CNZ1BGE_FGRefresh
; ---------------------------------------------------------------------------
		bra.w	CNZ1BGE_FGRefresh2
; ---------------------------------------------------------------------------
		bra.w	CNZ1BGE_DoTransition
; ---------------------------------------------------------------------------

CNZ1BGE_Normal:
		cmpi.w	#$3000,($FFFFEE78).w
		bcs.s	loc_51CFA
		cmpi.w	#$54C,($FFFFEE7C).w
		bcs.s	loc_51CD2
		move.w	#$700,d0			; This is positional adjustment for Knuckles' path
		sub.w	d0,($FFFFB014).w
		sub.w	d0,($FFFFB05E).w
		sub.w	d0,($FFFFEE7C).w
		sub.w	d0,($FFFFEE84).w
		jsr	Reset_TileOffsetPositionActual(pc)

loc_51CD2:
		jsr	CNZ1_BossLevelScroll(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		lea	(Pal_CNZMiniboss).l,a1
		jsr	(PalLoad_Line1).l
		move.w	#$1C0,d0
		move.w	d0,($FFFFEE18).w	; Change level start Y
		bset	#7,($FFFFF74F).w	; Disable wall grabbing for Knuckles
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_51D26
; ---------------------------------------------------------------------------

loc_51CFA:
		jsr	CNZ1_Deform(pc)
		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jsr	Draw_TileRow(pc)
		lea	CNZ1_BGDeformArray(pc),a4
		lea	($FFFFA800).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------

CNZ1BGE_BossStart:
		move.w	#$1C0,d0
		jsr	CNZ1_ScrollToYStart(pc)
		jsr	CNZ1_BossLevelScroll(pc)

loc_51D26:
		jsr	DrawBGAsYouMove(pc)
		jmp	PlainDeformation(pc)
; ---------------------------------------------------------------------------

CNZ1BGE_Boss:
		move.w	#$1C0,d0
		jsr	CNZ1_ScrollToYStart(pc)
		jsr	CNZ1_BossLevelScroll2(pc)
		lea	($FFFFEE8C).w,a6
		lea	($FFFFEE94).w,a5
		move.w	#$200,d1
		moveq	#$10,d6
		jsr	Draw_TileColumn(pc)
		jmp	PlainDeformation(pc)
; ---------------------------------------------------------------------------

CNZ1BGE_AfterBoss:
		move.w	#$1C0,d0
		jsr	CNZ1_ScrollToYStart(pc)
		tst.w	($FFFFEEC6).w
		bne.s	loc_51D6E
		jsr	CNZ1_BossLevelScroll2(pc)
		jsr	DrawBGAsYouMove(pc)
		jsr	PlainDeformation(pc)
		jmp	Get_BGActualEffectiveDiff(pc)
; ---------------------------------------------------------------------------

loc_51D6E:
		clr.w	($FFFFEEC6).w		; When signalled
		move.w	#$2F0,($FFFFEEC8).w	; Set refresh position
		move.w	#$F,($FFFFEECA).w	; Refresh number
		addq.w	#4,($FFFFEEC2).w

CNZ1BGE_FGRefresh:
		move.w	#$1C0,d0
		jsr	CNZ1_ScrollToYStart(pc)		; Continue scrolling
		move.w	#-$4000,d7
		moveq	#0,d1
		move.w	#$200,d2
		jsr	Draw_PlaneVertSingleBottomUp(pc)	; Refresh the foreground using BG chunks
		bmi.s	loc_51DAE
		move.w	#-$2000,d7
		jsr	CNZ1_BossLevelScroll2(pc)
		jsr	DrawBGAsYouMove(pc)
		jsr	PlainDeformation(pc)
		jmp	Get_BGActualEffectiveDiff(pc)
; ---------------------------------------------------------------------------

loc_51DAE:
		movea.w	$C(a3),a1		; $180 Y of BG
		addq.w	#4,a1			; $200 X of BG
		move.w	-8(a3),d0		; Get X size of BG
		subq.w	#5,d0
		movea.w	$12(a3),a5		; $280 Y of FG
		lea	$63(a5),a5			; $3180 of FG
		move.w	-$A(a3),d1		; Get X size of FG
		subq.w	#5,d1
		moveq	#5,d2

loc_51DCA:
		move.b	(a1)+,(a5)+		; Replace 5x5 portion of Foreground with equivalent from BG. Basically,
		move.b	(a1)+,(a5)+		; transferring the actual layout to the FG for use with collision.
		move.b	(a1)+,(a5)+
		move.b	(a1)+,(a5)+
		move.b	(a1)+,(a5)+
		adda.w	d0,a1
		adda.w	d1,a5
		dbf	d2,loc_51DCA
		clr.b	($FFFFF664).w	; Turn off BG collision
		clr.w	($FFFFEEDA).w	; Turn off scrolling
		move.w	#$1C0,d0
		add.w	d0,($FFFFB014).w	; Move players and camera to position
		add.w	d0,($FFFFB05E).w
		add.w	d0,($FFFFEE7C).w
		add.w	d0,($FFFFEE84).w
		jsr	Reset_TileOffsetPositionActual(pc)
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w	; Set up refresh position
		move.w	#$F,($FFFFEECA).w	; Refresh amount
		addq.w	#4,($FFFFEEC2).w

CNZ1BGE_FGRefresh2:
		move.w	#$380,d0
		jsr	CNZ1_ScrollToYStart(pc)
		lea	($FFFF8008).w,a3
		move.w	#-$4000,d7
		move.w	($FFFFEE80).w,d1
		move.w	($FFFFEE84).w,d2
		jsr	Draw_PlaneVertSingleBottomUp(pc)	; Refresh the FG using FG chunks this time
		bmi.s	loc_51E42
		addq.w	#2,a3
		move.w	#-$2000,d7
		jsr	CNZ1_BossLevelScroll2(pc)
		jsr	DrawBGAsYouMove(pc)
		jmp	PlainDeformation(pc)
; ---------------------------------------------------------------------------

loc_51E42:
		addq.w	#2,a3
		move.w	#-$2000,d7
		jsr	(Create_New_Sprite).l
		bne.s	loc_51E5C
		move.l	#Obj_EndSign,(a1)
		move.w	#$32C0,$10(a1)			; Set up the end sign

loc_51E5C:
		addq.w	#4,($FFFFEEC2).w

CNZ1BGE_DoTransition:
		tst.w	($FFFFEEC6).w
		beq.w	loc_51F28				; Don't do anything until signpost lands
		clr.w	($FFFFEEC6).w
		movem.l	d7-a0/a2-a3,-(sp)
		moveq	#$18,d0
		jsr	(Load_PLC).l
		moveq	#$19,d0
		jsr	(Load_PLC).l					; Load CNZ 2 PLCs
		move.w	#$301,($FFFFFE10).w		; Change to act 2
		clr.b	($FFFFEE33).w
		clr.b	($FFFFF76C).w
		clr.b	($FFFFF710).w
		clr.b	($FFFFF7AA).w
		clr.b	($FFFFFF97).w			; Reset various managers
		jsr	Clear_Switches(pc)
		jsr	(Load_Level).l
		jsr	(LoadSolids).l
		jsr	(CheckLevelForWater).l		; Level stuff, etc etc
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_51EC0
		move.w	#$8014,($C00004).l		; Turn HInt on for water only if not playing as Knuckles

loc_51EC0:
		moveq	#$11,d0
		jsr	(LoadPalette_Immediate).l	; Load CNZ palette
		movem.l	(sp)+,d7-a0/a2-a3
		bclr	#7,($FFFFF74F).w		; Wall gliding is possible again
		move.w	#$3000,d0
		move.w	#-$200,d1
		sub.w	d0,($FFFFB010).w
		sub.w	d1,($FFFFB014).w
		sub.w	d0,($FFFFB05A).w
		sub.w	d1,($FFFFB05E).w		; Offset object/player positions
		jsr	Offset_ObjectsDuringTransition(pc)
		sub.w	d0,($FFFFEE78).w
		sub.w	d1,($FFFFEE7C).w
		sub.w	d0,($FFFFEE80).w
		sub.w	d1,($FFFFEE84).w		; Offset camera positions
		sub.w	d0,($FFFFEE14).w
		sub.w	d0,($FFFFEE16).w
		sub.w	d1,($FFFFEE18).w
		sub.w	d1,($FFFFEE1A).w		; Offset level start/ends
		move.w	($FFFFEE1A).w,($FFFFEE12).w
		jsr	Reset_TileOffsetPositionActual(pc)
		move.w	#$2F0,($FFFFEEC8).w		; Set up refresh
		move.w	#$F,($FFFFEECA).w
		clr.w	($FFFFEEC2).w

loc_51F28:
		jsr	CNZ1_BossLevelScroll2(pc)
		jsr	DrawBGAsYouMove(pc)
		jmp	PlainDeformation(pc)

; =============== S U B R O U T I N E =======================================


CNZ1_Deform:

		move.w	($FFFFEE84).w,d0
		move.w	($FFFFEECE).w,d2
		sub.w	d2,d0
		swap	d0
		clr.w	d0
		asr.l	#4,d0
		move.l	d0,d1
		asr.l	#1,d1
		add.l	d1,d0
		asr.l	#2,d1
		add.l	d1,d0
		swap	d0
		add.w	d2,d0
		move.w	d0,($FFFFEE90).w		; Effective BG Y is about 1/10th (13/128ths to be exact) of camera Y
		move.w	($FFFFEE80).w,d0
		swap	d0
		clr.w	d0
		asr.l	#1,d0
		move.l	d0,d1
		asr.l	#3,d1
		lea	($FFFFA80A).w,a1
		swap	d0
		move.w	d0,-(a1)
		swap	d0
		sub.l	d1,d0
		swap	d0
		move.w	d0,($FFFFEE8C).w		; Effective BG X is 7/16th speed of normal camera
		move.w	d0,-(a1)
		swap	d0
		sub.l	d1,d0
		sub.l	d1,d0
		swap	d0
		move.w	d0,($FFFFEEE2).w		; Dynamic art reload BG speed is 5/16th of normal camera
		swap	d0
		sub.l	d1,d0
		swap	d0
		move.w	d0,-(a1)
		swap	d0
		sub.l	d1,d0
		sub.l	d1,d0
		swap	d0
		move.w	d0,-(a1)
		swap	d0
		sub.l	d1,d0
		asr.l	#1,d1
		sub.l	d1,d0
		swap	d0
		move.w	d0,-(a1)
		rts
; End of function CNZ1_Deform


; =============== S U B R O U T I N E =======================================


CNZ1_BossLevelScroll:

		cmpi.w	#$1E0,($FFFFEE90).w
		bcs.s	CNZ1_BossLevelScroll2
		addq.w	#4,($FFFFEEC2).w

CNZ1_BossLevelScroll2:

		move.w	($FFFFEE84).w,d0
		subi.w	#$100,d0
		add.w	($FFFFEEDA).w,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEE80).w,d0
		subi.w	#$2F80,d0
		move.w	d0,($FFFFEE8C).w
		rts
; End of function CNZ1_BossLevelScroll

; ---------------------------------------------------------------------------

Obj_CNZMinibossScrollControl:
		moveq	#0,d0
		move.b	5(a0),d0
		jmp	loc_51FD8(pc,d0.w)
; ---------------------------------------------------------------------------

loc_51FD8:
		bra.w	Obj_CNZMinibossScrollInit
; ---------------------------------------------------------------------------
		bra.w	Obj_CNZMinibossScrollMain
; ---------------------------------------------------------------------------
		bra.w	Obj_CNZMinibossScrollWait
; ---------------------------------------------------------------------------
		bra.w	Obj_CNZMinibossScrollSlow
; ---------------------------------------------------------------------------
		bra.w	Obj_CNZMinibossScrollWait2
; ---------------------------------------------------------------------------
		bra.w	Obj_CNZMinibossScrollWait3
; ---------------------------------------------------------------------------

Obj_CNZMinibossScrollInit:
		lea	($FFFF8008).w,a3
		movea.w	$14(a3),a1			; $280 Y
		move.b	$63(a1),d0			; $3180 X chunk
		suba.w	-8(a3),a1
		move.b	d0,$63(a1)			; Replace FG layout piece
		addq.w	#2,a3
		movea.w	(a3),a1
		move.b	4(a1),d0
		move.w	-8(a3),d1
		adda.w	d1,a1
		move.b	d0,4(a1)
		adda.w	d1,a1
		move.b	d0,4(a1)			; Replace BG layout piece
		addq.b	#4,5(a0)

Obj_CNZMinibossScrollMain:
		tst.w	($FFFFEEC6).w
		bne.s	loc_52042
		move.l	($FFFFEEDE).w,d0	; Speed up scroll
		cmpi.l	#$40000,d0
		bcc.s	loc_5203C
		addi.l	#$200,d0
		move.l	d0,($FFFFEEDE).w

loc_5203C:
		add.l	d0,($FFFFEEDA).w	; Set BG scrolling speed
		rts
; ---------------------------------------------------------------------------

loc_52042:
		clr.w	($FFFFEEC6).w		; When boss is completed
		addq.b	#4,5(a0)

Obj_CNZMinibossScrollWait:
		move.w	($FFFFEEDA).w,d0
		andi.w	#$FF,d0
		cmpi.w	#4,d0
		bcs.s	loc_52062			; Wait until the offset is a multiple of $100
		move.l	($FFFFEEDE).w,d0
		add.l	d0,($FFFFEEDA).w
		rts
; ---------------------------------------------------------------------------

loc_52062:
		addq.b	#4,5(a0)

Obj_CNZMinibossScrollSlow:
		move.l	($FFFFEEDE).w,d0	; Start slowing down the scrolling
		cmpi.l	#$10000,d0
		bls.s	loc_52082
		subi.l	#$400,d0
		move.l	d0,($FFFFEEDE).w
		add.l	d0,($FFFFEEDA).w
		rts
; ---------------------------------------------------------------------------

loc_52082:
		addq.b	#4,5(a0)

Obj_CNZMinibossScrollWait2:
		move.w	($FFFFEEDA).w,d0
		andi.w	#$FF,d0
		cmpi.w	#4,d0
		bcs.s	loc_5209E			; Keep going until offset is a multiple of $100 again
		move.l	($FFFFEEDE).w,d0
		add.l	d0,($FFFFEEDA).w
		rts
; ---------------------------------------------------------------------------

loc_5209E:
		move.w	d0,($FFFFEEDA).w		; Reset scroll offset
		move.w	#$1000,($FFFFEE12).w	; Reset Y end
		st	($FFFFF664).w				; BG collision is on
		addq.w	#4,($FFFFEEC2).w		; Next BG Event
		movea.w	($FFFF8008).w,a1
		lea	$67(a1),a1
		move.w	($FFFF8000).w,d0
		moveq	#0,d1
		moveq	#6,d2

loc_520C0:
		move.b	d1,(a1)					; Copy top of FG at $3380 downwards
		adda.w	d0,a1
		dbf	d2,loc_520C0
		addq.b	#4,5(a0)

Obj_CNZMinibossScrollWait3:
		cmpi.w	#$1C0,($FFFFEEDA).w		; Wait till scroll offset is $1C0
		bcc.s	loc_520DE
		move.l	($FFFFEEDE).w,d0
		add.l	d0,($FFFFEEDA).w
		rts
; ---------------------------------------------------------------------------

loc_520DE:
		st	($FFFFEEC6).w				; Set flag to continue next BG event
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


CNZ1_ScrollToYStart:

		move.w	($FFFFEE7C).w,d1
		cmp.w	d0,d1
		bcs.s	loc_520F2
		exg	d0,d1

loc_520F2:
		cmp.w	($FFFFEE18).w,d1
		bls.s	locret_520FC
		move.w	d1,($FFFFEE18).w

locret_520FC:
		rts
; End of function CNZ1_ScrollToYStart

; ---------------------------------------------------------------------------
CNZ1_BGDeformArray:	dc.w $80

		dc.w $30
		dc.w $60
		dc.w $C0
		dc.w $7FFF
; ---------------------------------------------------------------------------

CNZ2_ScreenInit:
		jsr	Reset_TileOffsetPositionActual(pc)
		jmp	Refresh_PlaneFull(pc)
; ---------------------------------------------------------------------------

CNZ2_ScreenEvent:
		move.w	($FFFFEECE).w,d0
		add.w	d0,($FFFFEE84).w
		cmpi.w	#$4600,($FFFFB010).w
		bcc.s	loc_52138			; If player is far enough to the right, skip ahead
		moveq	#0,d0
		cmpi.w	#$940,($FFFFB010).w
		bcc.s	loc_5212E
		move.w	#$580,d0			; If player is still in old boss arena, set the level Y start to $580, otherwise, make it 0 like normal

loc_5212E:
		cmp.w	($FFFFEE18).w,d0
		beq.s	loc_52138
		move.w	d0,($FFFFEE18).w

loc_52138:

		tst.w	($FFFFEED8).w
		beq.s	loc_52146
		clr.w	($FFFFEED8).w
		jmp	Refresh_PlaneScreenDirect(pc)
; ---------------------------------------------------------------------------

loc_52146:
		move.w	($FFFFEEC0).w,d0
		jmp	loc_5214E(pc,d0.w)
; ---------------------------------------------------------------------------

loc_5214E:
		bra.w	loc_5215A
; ---------------------------------------------------------------------------
		bra.w	loc_521D2
; ---------------------------------------------------------------------------
		bra.w	CNZ2SE_Normal
; ---------------------------------------------------------------------------

loc_5215A:
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_5216C
		move.w	#8,($FFFFEEC0).w	; If playing as Sonic/Tails, don't do any special screen events
		bra.w	CNZ2SE_Normal
; ---------------------------------------------------------------------------

loc_5216C:
		lea	($FFFFB000).w,a1		; Only do all this is Knuckles is playing
		cmpi.w	#$4880,$10(a1)
		bcs.w	CNZ2SE_Normal		; If Knuckles is not past $4880 X, just play normally

loc_5217A:
		cmpi.w	#$B00,$14(a1)
		bcs.s	CNZ2SE_Normal		; If Knuckles is not past $B00 Y, play normally
		jsr	(Create_New_Sprite).l
		bne.s	loc_521BE
		move.l	#Obj_CNZTeleporter,(a1)
		jsr	(CreateNewSprite4).l
		bne.s	loc_521BE
		move.l	#Obj_81,(a1)
		move.w	#$4980,$10(a1)
		move.w	#$A20,$14(a1)
		movem.l	d7-a0/a2-a3,-(sp)
		lea	(PLC_CNZ2KnuxEnd).l,a1
		jsr	(Load_PLC_Raw).l
		movem.l	(sp)+,d7-a0/a2-a3

loc_521BE:

		move.w	#$4750,($FFFFEE14).w
		move.w	#$48E0,($FFFFEE16).w
		clr.b	($FFFFFAAA).w
		addq.w	#4,($FFFFEEC0).w

loc_521D2:
		tst.b	($FFFFFAAA).w
		beq.s	CNZ2SE_Normal
		jsr	(Create_New_Sprite).l
		bne.s	CNZ2SE_Normal
		move.l	#Obj_IncLevEndXGradual,(a1)
		move.w	#$49A0,($FFFFFA92).w
		lea	(a2),a6
		jsr	(Obj_PlayLevelMusic).l
		lea	(a6),a2
		jsr	(Restore_PlayerControl).l
		addq.w	#4,($FFFFEEC0).w

CNZ2SE_Normal:

		jmp	DrawTilesAsYouMove(pc)
; ---------------------------------------------------------------------------

CNZ2_BackgroundInit:
		move.w	#8,($FFFFEEC2).w
		jsr	CNZ1_Deform(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		moveq	#0,d1
		jsr	Refresh_PlaneFull(pc)
		lea	CNZ1_BGDeformArray(pc),a4
		lea	($FFFFA800).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------

CNZ2_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_5222C(pc,d0.w)
; ---------------------------------------------------------------------------

loc_5222C:
		bra.w	loc_52238
; ---------------------------------------------------------------------------
		bra.w	loc_52266
; ---------------------------------------------------------------------------
		bra.w	loc_5227C
; ---------------------------------------------------------------------------

loc_52238:
		moveq	#0,d1
		move.w	#$200,d2
		jsr	Draw_PlaneVertSingleBottomUp(pc)
		bpl.w	PlainDeformation
		jsr	CNZ1_Deform(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_5226A
; ---------------------------------------------------------------------------

loc_52266:
		jsr	CNZ1_Deform(pc)

loc_5226A:
		moveq	#0,d1
		move.w	($FFFFEE90).w,d2
		jsr	Draw_PlaneVertSingleBottomUp(pc)
		bpl.s	loc_52280
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_52280
; ---------------------------------------------------------------------------

loc_5227C:
		jsr	CNZ1_Deform(pc)

loc_52280:

		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jsr	Draw_TileRow(pc)
		lea	CNZ1_BGDeformArray(pc),a4
		lea	($FFFFA800).w,a5
		jsr	ApplyDeformation(pc)
		jmp	ShakeScreen_Setup(pc)
; ---------------------------------------------------------------------------

Obj_CNZTeleporter:
		lea	($FFFFB000).w,a1
		cmpi.w	#$4A38,$10(a1)
		bcs.s	locret_522FE		; If Knuckles isn't in range, don't bother
		btst	#1,$2A(a1)
		beq.s	loc_522C2
		move.w	#$4A40,d0
		cmp.w	$10(a1),d0
		bhi.s	locret_522FE
		move.w	d0,$10(a1)			; While jumping, don't allow Knuckles past this point (so he lands on the teleporter)

loc_522C2:
		clr.w	$18(a1)
		clr.w	$1C(a1)				; Stop Knuckles' momentum
		st	($FFFFF7CA).w			; Turn off player control
		clr.w	($FFFFF602).w		; Clear buttons
		lea	(ArtKosM_SSZTeleport).l,a1
		move.w	#-$6000,d2
		jsr	(Queue_Kos_Module).l	; Load teleporter graphics
		lea	($FFFFFC22).w,a1
		move.l	#$EEE0EC0,(a1)
		move.w	#$EA2,$E(a1)
		move.w	#$E80,$12(a1)		; Replace applicable palette entries
		move.l	#Obj_CNZTeleporterMain,(a0)

locret_522FE:

		rts
; ---------------------------------------------------------------------------

Obj_CNZTeleporterMain:
		tst.b	($FFFFFF60).w
		bne.s	locret_52348		; Don't do anything while art is loading
		lea	($FFFFB000).w,a1
		btst	#1,$2A(a1)
		bne.s	locret_52348		; Wait till Knuckles is not in the air
		jsr	(Create_New_Sprite3).l
		bne.s	locret_52348
		move.w	a1,$3C(a0)
		move.l	#Obj_TeleporterBeam,(a1)
		move.w	a0,$48(a1)
		move.w	#$4A40,d0
		move.w	d0,$10(a0)
		move.w	d0,$10(a1)
		move.w	#$A38,$14(a1)		; Set teleporter position/attributes
		moveq	#$53,d0
		jsr	(Play_Sound_2).l
		move.l	#loc_5234A,(a0)

locret_52348:

		rts
; ---------------------------------------------------------------------------

loc_5234A:
		lea	($FFFFB000).w,a1
		movea.w	$3C(a0),a2
		cmpi.b	#8,$46(a2)
		blt.s	locret_523C8
		beq.s	loc_523B6		; Once beam has expanded halfway. On the first frame this happen, set player state
		cmpi.b	#$18,$46(a2)
		bcc.s	loc_5238E
		btst	#0,($FFFFFE05).w
		beq.s	locret_523C8
		subq.w	#1,$14(a1)		; Raise player slightly
		btst	#1,($FFFFFE05).w
		beq.s	locret_523C8
		moveq	#1,d1
		move.w	$10(a1),d0
		cmp.w	$10(a0),d0
		beq.s	locret_523C8
		bcs.s	loc_52388
		neg.w	d1

loc_52388:
		add.w	d1,$10(a1)		; Move player X towards center of beam X
		bra.s	locret_523C8
; ---------------------------------------------------------------------------

loc_5238E:
		move.l	#loc_523CA,(a0)	; When beam has expanded all the way
		move.b	#3,$2E(a1)		; Stop player animation
		moveq	#0,d0
		move.w	d0,$14(a1)		; Make player disappear!
		move.b	d0,$20(a1)
		move.b	d0,$22(a1)
		moveq	#$73,d0
		jsr	(Play_Sound_2).l
		st	($FFFFEE0A).w
		bra.s	locret_523C8
; ---------------------------------------------------------------------------

loc_523B6:
		move.b	#1,$2E(a1)		; Player under object control
		bset	#2,$2A(a1)		; Set to jumping state
		move.b	#2,$20(a1)		; Rolling animation

locret_523C8:

		rts
; ---------------------------------------------------------------------------

loc_523CA:
		subi.w	#$10,($FFFFEE7C).w
		cmpi.w	#$780,($FFFFEE7C).w
		bcc.s	locret_523EA
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		move.w	#$500,d0		; Start Ice Cap
		jmp	(StartNewLevel).l
; ---------------------------------------------------------------------------

locret_523EA:
		rts
; ---------------------------------------------------------------------------

FBZ1_ScreenInit:
		cmpi.w	#$180,($FFFFB010).w
		bcs.s	loc_52412
		move.w	-8(a3),d0
		subq.w	#5,d0
		movea.w	$34(a3),a1		; $680 Y
		movea.w	$48(a3),a5		; $900 Y
		moveq	#2,d1

loc_52404:
		move.l	(a5)+,(a1)+		; Copy the "indoors" beginning part
		move.b	(a5)+,(a1)+
		adda.w	d0,a1
		adda.w	d0,a5
		dbf	d1,loc_52404
		bra.s	loc_5241C
; ---------------------------------------------------------------------------

loc_52412:
		move.w	#$18,($FFFFEED2).w		; If player is < $180 X
		st	($FFFFEED4).w

loc_5241C:
		jsr	Reset_TileOffsetPositionActual(pc)
		jmp	Refresh_PlaneFull(pc)
; ---------------------------------------------------------------------------

FBZ1_ScreenEvent:
		cmpi.b	#6,($FFFFB005).w
		bcs.s	loc_5242E
		rts							; Don't do any special events while Sonic is dying
; ---------------------------------------------------------------------------

loc_5242E:
		lea	FBZ1_LayoutModRange(pc),a1
		move.w	($FFFFB010).w,d0
		move.w	($FFFFB014).w,d1
		move.w	($FFFFEED2).w,d2
		jmp	loc_52442(pc,d2.w)
; ---------------------------------------------------------------------------

loc_52442:
		bra.w	FBZ1SE_Normal
; ---------------------------------------------------------------------------
		bra.w	FBZ1SE_LayoutMod1
; ---------------------------------------------------------------------------
		bra.w	FBZ1SE_LayoutMod2
; ---------------------------------------------------------------------------
		bra.w	FBZ1SE_LayoutMod3
; ---------------------------------------------------------------------------
		bra.w	FBZ1SE_LayoutMod4
; ---------------------------------------------------------------------------
		bra.w	FBZ1SE_LayoutMod5
; ---------------------------------------------------------------------------
		bra.w	FBZ1SE_LayoutMod6	; Beginning of stage
; ---------------------------------------------------------------------------

FBZ1SE_Normal:
		moveq	#4,d2
		moveq	#5,d3

loc_52462:
		lea	(a1),a5					; Check layout mod ranges
		cmp.w	(a5)+,d0
		bcs.s	loc_5247A
		cmp.w	(a5)+,d0
		bhi.s	loc_5247A
		cmp.w	(a5)+,d1
		bcs.s	loc_5247A
		cmp.w	(a5)+,d1
		bhi.s	loc_5247A
		move.w	d2,($FFFFEED2).w
		bra.s	loc_52482
; ---------------------------------------------------------------------------

loc_5247A:

		addq.w	#8,a1
		addq.w	#4,d2
		dbf	d3,loc_52462

loc_52482:
		jmp	DrawTilesAsYouMove(pc)
; ---------------------------------------------------------------------------

FBZ1SE_LayoutMod1:
		jsr	FBZ1Screen_CheckInRange(pc)		; Make sure Sonic is still in range
		tst.w	($FFFFEED4).w
		bne.s	loc_524AA
		cmpi.w	#$B00,d0		; If indoors, check if Sonic is in right half of ranged area
		bcc.s	loc_524A0		; If so, branch
		cmpi.w	#$70A,d0		; Otherwise, check if Sonic has gone far enough to the right
		bls.w	loc_52828
		bra.s	loc_524D4
; ---------------------------------------------------------------------------

loc_524A0:
		cmpi.w	#$A0E,d1		; If to the right of ranged area, instead check if Sonic has gone low enough
		bls.w	loc_52828
		bra.s	loc_524D4
; ---------------------------------------------------------------------------

loc_524AA:
		cmpi.w	#$B00,d0		; If outdoors, check if Sonic is in right half of ranged area
		bcc.s	loc_524BA		; If so, branch
		cmpi.w	#$6F6,d0		; Otherwise, check if Sonic has gone far enough to the left
		bls.s	loc_524C2
		bra.w	loc_52828
; ---------------------------------------------------------------------------

loc_524BA:
		cmpi.w	#$9F2,d1		; If to the right of ranged area, instead check if Sonic has gone high enough
		bhi.w	loc_52828

loc_524C2:
		clr.w	($FFFFEED4).w	; In either case, go outdoors->indoors
		movea.w	(a3),a5
		lea	$60(a5),a5
		movea.w	(a3),a6
		lea	$64(a6),a6
		bra.s	loc_524E8
; ---------------------------------------------------------------------------

loc_524D4:

		st	($FFFFEED4).w		; Go indoors->outdoors
		movea.w	$18(a3),a5
		lea	$60(a5),a5			; First source is at $300 Y, $3000 X
		movea.w	$14(a3),a6
		lea	$64(a6),a6			; Second source is at $280 Y, $3200 X (both of these are technically out of range)

loc_524E8:
		movea.w	$48(a3),a1
		lea	$C(a1),a1			; First destination is $900 Y, $600 X
		move.w	-8(a3),d0
		subq.w	#4,d0			; Width of four tiles
		moveq	#5,d1			; Height of 6 tiles

loc_524F8:
		move.l	(a5)+,(a1)+		; Copy over layout
		adda.w	d0,a5
		adda.w	d0,a1
		dbf	d1,loc_524F8
		movea.w	$48(a3),a1
		lea	$1A(a1),a1			; Second destination is $900 Y, $D00 X
		move.w	-8(a3),d0
		subq.w	#6,d0			; Width of 6 tiles
		moveq	#3,d1			; Height of 4 tiles

loc_52512:
		move.l	(a6)+,(a1)+
		move.w	(a6)+,(a1)+		; Copy over layout
		adda.w	d0,a6
		adda.w	d0,a1
		dbf	d1,loc_52512
		jmp	Refresh_PlaneScreenDirect(pc)	; Refresh screen
; ---------------------------------------------------------------------------

FBZ1SE_LayoutMod2:
		lea	8(a1),a1			; The following layout mods all basically work identically to the above with modifications in positioning, etc
		jsr	FBZ1Screen_CheckInRange(pc)		; I'll leave it as an exercise to the reader to get the specifics of each routine :)
		tst.w	($FFFFEED4).w
		bne.s	loc_5254A
		cmpi.w	#$C80,d0
		bcc.s	loc_52540
		cmpi.w	#$1F2,d1
		bcc.w	loc_52828
		bra.s	loc_52574
; ---------------------------------------------------------------------------

loc_52540:
		cmpi.w	#$108A,d0
		bls.w	loc_52828
		bra.s	loc_52574
; ---------------------------------------------------------------------------

loc_5254A:
		cmpi.w	#$C80,d0
		bcc.s	loc_5255A
		cmpi.w	#$20E,d1
		bcc.s	loc_52562
		bra.w	loc_52828
; ---------------------------------------------------------------------------

loc_5255A:
		cmpi.w	#$1076,d0
		bhi.w	loc_52828

loc_52562:
		clr.w	($FFFFEED4).w
		movea.w	(a3),a5
		lea	$6C(a5),a5
		movea.w	(a3),a6
		lea	$76(a6),a6
		bra.s	loc_52588
; ---------------------------------------------------------------------------

loc_52574:

		st	($FFFFEED4).w
		movea.w	$14(a3),a5
		lea	$6C(a5),a5
		movea.w	$10(a3),a6
		lea	$76(a6),a6

loc_52588:
		movea.w	8(a3),a1
		lea	$E(a1),a1
		move.w	-8(a3),d0
		subi.w	#$A,d0
		moveq	#3,d1

loc_5259A:
		move.l	(a5)+,(a1)+
		move.l	(a5)+,(a1)+
		move.w	(a5)+,(a1)+
		adda.w	d0,a5
		adda.w	d0,a1
		dbf	d1,loc_5259A
		movea.w	$C(a3),a1
		lea	$1C(a1),a1
		move.w	-8(a3),d0
		subi.w	#$C,d0
		moveq	#2,d1

loc_525BA:
		move.l	(a6)+,(a1)+
		move.l	(a6)+,(a1)+
		move.l	(a6)+,(a1)+
		adda.w	d0,a6
		adda.w	d0,a1
		dbf	d1,loc_525BA
		jmp	Refresh_PlaneScreenDirect(pc)
; ---------------------------------------------------------------------------

FBZ1SE_LayoutMod3:
		lea	$10(a1),a1
		jsr	FBZ1Screen_CheckInRange(pc)
		tst.w	($FFFFEED4).w
		bne.s	loc_525F4
		cmpi.w	#$1880,d0
		bcc.s	loc_525EA
		cmpi.w	#$158A,d0
		bls.w	loc_52828
		bra.s	loc_52622
; ---------------------------------------------------------------------------

loc_525EA:
		cmpi.w	#$A0E,d1
		bls.w	loc_52828
		bra.s	loc_52622
; ---------------------------------------------------------------------------

loc_525F4:
		cmpi.w	#$1880,d0
		bcc.s	loc_52604
		cmpi.w	#$1576,d0
		bls.s	loc_5260C
		bra.w	loc_52828
; ---------------------------------------------------------------------------

loc_52604:
		cmpi.w	#$9F2,d1
		bhi.w	loc_52828

loc_5260C:
		clr.w	($FFFFEED4).w
		movea.w	$34(a3),a5
		lea	$60(a5),a5
		movea.w	$28(a3),a6
		lea	$66(a6),a6
		bra.s	loc_52636
; ---------------------------------------------------------------------------

loc_52622:

		st	($FFFFEED4).w
		movea.w	$44(a3),a5
		lea	$60(a5),a5
		movea.w	$3C(a3),a6
		lea	$66(a6),a6

loc_52636:
		movea.w	$48(a3),a1
		lea	$28(a1),a1
		move.w	-8(a3),d0
		subq.w	#6,d0
		moveq	#3,d1

loc_52646:
		move.l	(a5)+,(a1)+
		move.w	(a5)+,(a1)+
		adda.w	d0,a5
		adda.w	d0,a1
		dbf	d1,loc_52646
		movea.w	$48(a3),a1
		lea	$34(a1),a1
		move.w	-8(a3),d0
		subq.w	#6,d0
		moveq	#3,d1

loc_52662:
		move.l	(a6)+,(a1)+
		move.w	(a6)+,(a1)+
		adda.w	d0,a6
		adda.w	d0,a1
		dbf	d1,loc_52662
		jmp	Refresh_PlaneScreenDirect(pc)
; ---------------------------------------------------------------------------

FBZ1SE_LayoutMod4:
		lea	$18(a1),a1
		jsr	FBZ1Screen_CheckInRange(pc)
		tst.w	($FFFFEED4).w
		bne.s	loc_526A0
		cmpi.w	#$208A,d0
		bcc.s	loc_526D6
		cmpi.w	#$1D80,d0
		bcc.s	loc_52696
		cmpi.w	#$1C0A,d0
		bls.w	loc_52828
		bra.s	loc_526D6
; ---------------------------------------------------------------------------

loc_52696:
		cmpi.w	#$F2,d1
		bcc.w	loc_52828
		bra.s	loc_526D6
; ---------------------------------------------------------------------------

loc_526A0:
		cmpi.w	#$1D80,d0
		bcc.s	loc_526B0
		cmpi.w	#$1BF6,d0
		bls.s	loc_526C0
		bra.w	loc_52828
; ---------------------------------------------------------------------------

loc_526B0:
		cmpi.w	#$10E,d1
		bls.w	loc_52828
		cmpi.w	#$2076,d0
		bcc.w	loc_52828

loc_526C0:
		clr.w	($FFFFEED4).w
		movea.w	$28(a3),a5
		lea	$6E(a5),a5
		movea.w	$28(a3),a6
		lea	$76(a6),a6
		bra.s	loc_526EA
; ---------------------------------------------------------------------------

loc_526D6:

		st	($FFFFEED4).w
		movea.w	$3C(a3),a5
		lea	$6E(a5),a5
		movea.w	$3C(a3),a6
		lea	$76(a6),a6

loc_526EA:
		movea.w	(a3),a1
		lea	$36(a1),a1
		move.w	-8(a3),d0
		subq.w	#8,d0
		moveq	#3,d1

loc_526F8:
		move.l	(a5)+,(a1)+
		move.l	(a5)+,(a1)+
		adda.w	d0,a5
		adda.w	d0,a1
		dbf	d1,loc_526F8
		movea.w	(a3),a1
		lea	$3E(a1),a1
		move.w	-8(a3),d0
		subi.w	#$12,d0
		moveq	#4,d1

loc_52714:
		move.l	(a6)+,(a1)+
		move.l	(a6)+,(a1)+
		move.l	(a6)+,(a1)+
		move.l	(a6)+,(a1)+
		move.w	(a6)+,(a1)+
		adda.w	d0,a6
		adda.w	d0,a1
		dbf	d1,loc_52714
		jmp	Refresh_PlaneScreenDirect(pc)
; ---------------------------------------------------------------------------

FBZ1SE_LayoutMod5:
		lea	$20(a1),a1
		jsr	FBZ1Screen_CheckInRange(pc)
		cmpi.w	#$2100,d0
		bcs.s	loc_52740
		cmpi.w	#$2600,d0
		bls.w	loc_52828

loc_52740:
		tst.w	($FFFFEED4).w
		bne.s	loc_52750
		cmpi.w	#$172,d1
		bcc.w	loc_52828
		bra.s	loc_5276E
; ---------------------------------------------------------------------------

loc_52750:
		cmpi.w	#$18E,d1
		bcs.w	loc_52828
		clr.w	($FFFFEED4).w
		movea.w	$28(a3),a5
		lea	$6E(a5),a5
		movea.w	$28(a3),a6
		lea	$76(a6),a6
		bra.s	loc_52782
; ---------------------------------------------------------------------------

loc_5276E:
		st	($FFFFEED4).w
		movea.w	$3C(a3),a5
		lea	$6E(a5),a5
		movea.w	$3C(a3),a6
		lea	$76(a6),a6

loc_52782:
		movea.w	(a3),a1
		lea	$36(a1),a1
		move.w	-8(a3),d0
		subq.w	#8,d0
		moveq	#3,d1

loc_52790:
		move.l	(a5)+,(a1)+
		move.l	(a5)+,(a1)+
		adda.w	d0,a5
		adda.w	d0,a1
		dbf	d1,loc_52790
		movea.w	(a3),a1
		lea	$3E(a1),a1
		move.w	-8(a3),d0
		subi.w	#$12,d0
		moveq	#4,d1

loc_527AC:
		move.l	(a6)+,(a1)+
		move.l	(a6)+,(a1)+
		move.l	(a6)+,(a1)+
		move.l	(a6)+,(a1)+
		move.w	(a6)+,(a1)+
		adda.w	d0,a6
		adda.w	d0,a1
		dbf	d1,loc_527AC
		jmp	Refresh_PlaneScreenDirect(pc)
; ---------------------------------------------------------------------------

FBZ1SE_LayoutMod6:
		lea	$28(a1),a1			; Get the last layout change range
		jsr	FBZ1Screen_CheckInRange(pc)	; Ensure player is still in specified range
		tst.w	($FFFFEED4).w
		bne.s	loc_527DA
		cmpi.w	#$70E,d1		; If "indoors", check if Sonic is below given point
		bls.w	loc_52828		; If not, don't do anything
		bra.s	loc_527EC
; ---------------------------------------------------------------------------

loc_527DA:
		cmpi.w	#$6F2,d1		; If "outdoors" flag is set, check if Sonic is above point given
		bhi.w	loc_52828		; If not, don't do anything
		clr.w	($FFFFEED4).w	; Make Sonic "indoors"
		movea.w	$48(a3),a5		; Perform layout copy of indoor tiles
		bra.s	loc_527F4
; ---------------------------------------------------------------------------

loc_527EC:
		st	($FFFFEED4).w		; Make Sonic "outdoors"
		movea.w	$54(a3),a5		; Perform layout copy of outdoor tiles

loc_527F4:
		movea.w	$34(a3),a1
		move.w	-8(a3),d0
		subq.w	#5,d0
		moveq	#2,d1

loc_52800:
		move.l	(a5)+,(a1)+
		move.b	(a5)+,(a1)+		; Perform layout copy
		adda.w	d0,a5
		adda.w	d0,a1
		dbf	d1,loc_52800
		jmp	Refresh_PlaneScreenDirect(pc)	; Redraw screen directly

; =============== S U B R O U T I N E =======================================


FBZ1Screen_CheckInRange:

		cmp.w	(a1)+,d0
		bcs.s	loc_52822
		cmp.w	(a1)+,d0
		bhi.s	loc_52822
		cmp.w	(a1)+,d1
		bcs.s	loc_52822
		cmp.w	(a1)+,d1
		bhi.s	loc_52822
		rts
; ---------------------------------------------------------------------------

loc_52822:
		addq.w	#4,sp
		clr.w	($FFFFEED2).w

loc_52828:

		jmp	DrawTilesAsYouMove(pc)
; End of function FBZ1Screen_CheckInRange

; ---------------------------------------------------------------------------
FBZ1_LayoutModRange:	dc.w   $400,  $F00,  $880,  $A80
		dc.w   $880, $1100,  $180,  $300
		dc.w  $1400, $1B80,  $900,  $B00
		dc.w  $1A80, $2100,   $80,  $200
		dc.w  $2080, $2680,  $100,  $280
		dc.w	  0,  $180,  $580,  $780
; ---------------------------------------------------------------------------

FBZ1_BackgroundInit:
		jsr	(Create_New_Sprite).l
		bne.s	loc_5286A
		move.l	#Obj_FBZOutdoorBGMotion,(a1)

loc_5286A:
		cmpi.w	#$180,($FFFFB010).w
		bcc.s	loc_528A4
		st	($FFFFEED6).w		; if player is at start, then he's outside. Set outdoors flag
		lea	Pal_FBZBGOutdoors(pc),a1
		lea	($FFFFFCE4).w,a5
		move.l	(a1)+,(a5)+		; Change to outdoor palette
		move.l	(a1)+,(a5)+
		move.l	(a1)+,(a5)+
		move.l	(a1)+,(a5)+
		jsr	FBZ_Deform(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		move.w	#$200,d1		; Outdoor BG is $200 pixels right of indoor BG
		moveq	#0,d0
		jsr	Refresh_PlaneFull(pc)
		lea	FBZ_OutBGDeformArray(pc),a4
		lea	($FFFFA800).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------

loc_528A4:
		jsr	FBZ_Deform(pc)		; Indoors
		jsr	Reset_TileOffsetPositionEff(pc)
		moveq	#0,d1
		jsr	Refresh_PlaneFull(pc)
		lea	FBZ_InBGDeformArray(pc),a4
		lea	($FFFFA800).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------

FBZ1_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_528C6(pc,d0.w)
; ---------------------------------------------------------------------------

loc_528C6:
		bra.w	FBZ1BGE_Normal
; ---------------------------------------------------------------------------
		bra.w	FBZ1BGE_ChangeTopDown
; ---------------------------------------------------------------------------
		bra.w	FBZ1BGE_ChangeBottomUp
; ---------------------------------------------------------------------------
		bra.w	FBZ1BGE_ChangeLeftRight
; ---------------------------------------------------------------------------
		bra.w	FBZ1BGE_ChangeRightLeft
; ---------------------------------------------------------------------------

FBZ1BGE_ChangeTopDown:
		jsr	FBZ1_CheckBGChange(pc)

loc_528DE:
		moveq	#0,d1
		move.w	($FFFFEE90).w,d2
		tst.w	($FFFFEED6).w
		beq.s	loc_528F0
		move.w	#$200,d1
		moveq	#0,d2

loc_528F0:
		jsr	Draw_PlaneVertTopDown(pc)
		bpl.w	FBZ1BGE_GoDeform
		clr.w	($FFFFEEC2).w
		bra.w	FBZ1BGE_GoDeform
; ---------------------------------------------------------------------------

FBZ1BGE_ChangeBottomUp:
		jsr	FBZ1_CheckBGChange(pc)

loc_52904:
		moveq	#0,d1
		move.w	($FFFFEE90).w,d2
		tst.w	($FFFFEED6).w
		beq.s	loc_52916
		move.w	#$200,d1
		moveq	#0,d2

loc_52916:
		jsr	Draw_PlaneVertSingleBottomUp(pc)
		bpl.w	FBZ1BGE_GoDeform
		clr.w	($FFFFEEC2).w
		bra.w	FBZ1BGE_GoDeform
; ---------------------------------------------------------------------------

FBZ1BGE_ChangeLeftRight:
		jsr	FBZ1_CheckBGChange(pc)

loc_5292A:
		move.w	($FFFFEE90).w,d1
		moveq	#0,d2
		tst.w	($FFFFEED6).w
		beq.s	loc_5293C
		moveq	#0,d1
		move.w	#$200,d2

loc_5293C:
		jsr	Draw_PlaneHorzLeftToRight(pc)
		bpl.w	FBZ1BGE_GoDeform
		clr.w	($FFFFEEC2).w
		bra.w	FBZ1BGE_GoDeform
; ---------------------------------------------------------------------------

FBZ1BGE_ChangeRightLeft:
		jsr	FBZ1_CheckBGChange(pc)

loc_52950:
		move.w	($FFFFEE90).w,d1
		moveq	#0,d2
		tst.w	($FFFFEED6).w
		beq.s	loc_52962
		moveq	#0,d1
		move.w	#$200,d2

loc_52962:
		jsr	Draw_PlaneHorzRightToLeft(pc)
		bpl.w	FBZ1BGE_GoDeform
		clr.w	($FFFFEEC2).w
		bra.w	FBZ1BGE_GoDeform
; ---------------------------------------------------------------------------

FBZ1BGE_Normal:
		tst.w	($FFFFEEC6).w
		beq.s	loc_529EE
		clr.w	($FFFFEEC6).w		; Check for transition flag
		movem.l	d7-a0/a2-a3,-(sp)
		moveq	#$1C,d0
		jsr	(Load_PLC).l
		move.w	#$401,($FFFFFE10).w
		clr.b	($FFFFEE33).w
		clr.b	($FFFFF76C).w
		clr.b	($FFFFF710).w
		clr.b	($FFFFF7AA).w
		clr.b	($FFFFFF97).w
		jsr	Clear_Switches(pc)
		jsr	(Load_Level).l
		jsr	(LoadSolids).l
		moveq	#$13,d0
		jsr	(LoadPalette_Immediate).l
		movem.l	(sp)+,d7-a0/a2-a3
		move.w	#$2E00,d0
		moveq	#0,d1
		sub.w	d0,($FFFFB010).w
		sub.w	d0,($FFFFB05A).w
		jsr	Offset_ObjectsDuringTransition(pc)
		sub.w	d0,($FFFFEE78).w
		sub.w	d0,($FFFFEE80).w
		sub.w	d0,($FFFFEE14).w
		sub.w	d0,($FFFFEE16).w
		jsr	Reset_TileOffsetPositionActual(pc)
		jsr	FBZ_Deform(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		bra.s	FBZ1BGE_GoDeform
; ---------------------------------------------------------------------------

loc_529EE:
		cmpi.b	#6,($FFFFB005).w
		bcs.s	loc_529F8
		rts						; Don't do special events if Sonic is dying
; ---------------------------------------------------------------------------

loc_529F8:
		jsr	FBZ1_CheckBGChange(pc)

FBZ1BGE_GoDeform:

		move.w	($FFFFEED6).w,d1
		beq.s	loc_52A06
		move.w	#$200,d1

loc_52A06:
		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#$20,d6
		jsr	Draw_TileRow(pc)
		lea	FBZ_InBGDeformArray(pc),a4
		tst.w	($FFFFEED6).w
		beq.s	loc_52A22
		lea	FBZ_OutBGDeformArray(pc),a4

loc_52A22:
		lea	($FFFFA800).w,a5
		jmp	ApplyDeformation(pc)

; =============== S U B R O U T I N E =======================================


FBZ_Deform:

		tst.w	($FFFFEED6).w
		bne.s	loc_52A70
		move.w	($FFFFEE84).w,d0	; Indoors
		asr.w	#1,d0
		move.w	d0,d1
		asr.w	#5,d1
		sub.w	d1,d0
		move.w	d0,($FFFFEE90).w	; Effective BG Y is slightly below half speed of normal BG Y
		move.w	($FFFFEE80).w,d0
		swap	d0
		clr.w	d0
		asr.l	#4,d0
		move.l	d0,d1
		lea	($FFFFA800).w,a1
		lea	FBZ_InBGDeformIndex(pc),a5
		moveq	#0,d2

loc_52A56:
		move.b	(a5)+,d3
		bmi.s	locret_52A6E
		ext.w	d3
		swap	d0

loc_52A5E:
		move.b	(a5)+,d2
		move.w	d0,(a1,d2.w)
		dbf	d3,loc_52A5E
		swap	d0
		add.l	d1,d0
		bra.s	loc_52A56
; ---------------------------------------------------------------------------

locret_52A6E:
		rts
; ---------------------------------------------------------------------------

loc_52A70:
		moveq	#$16,d0				; Outdoors
		add.w	($FFFFEEDA).w,d0	; Add offset of bobbing motion to 16
		move.w	d0,($FFFFEE90).w
		lea	($FFFFA800).w,a1
		lea	FBZ_OutBGDeformIndex(pc),a5
		move.w	($FFFFEE80).w,d0
		swap	d0
		clr.w	d0
		asr.l	#4,d0
		move.l	d0,d1
		asr.l	#1,d1
		move.l	($FFFFA9FC).w,d2	; Get cloud movement speed
		addi.l	#$E00,($FFFFA9FC).w
		moveq	#8,d3

loc_52A9E:
		move.w	(a5)+,d4
		add.l	d2,d0
		swap	d0
		move.w	d0,(a1,d4.w)
		swap	d0
		add.l	d1,d0
		dbf	d3,loc_52A9E
		rts
; End of function FBZ_Deform


; =============== S U B R O U T I N E =======================================


FBZ1_CheckBGChange:

		move.w	($FFFFB010).w,d0
		move.w	($FFFFB014).w,d1
		move.w	($FFFFEED2).w,d2	; The BG change events are synced with the layout mod events in screen events. Each numbered routine
		jmp	loc_52AC2(pc,d2.w)		; here corresponds with the same layoutmod number in FBZ1_ScreenEvents
; End of function FBZ1_CheckBGChange

; ---------------------------------------------------------------------------

loc_52AC2:
		bra.w	FBZ_Deform		; If no event, then just do business as usual
; ---------------------------------------------------------------------------
		bra.w	FBZ1_BGChange1
; ---------------------------------------------------------------------------
		bra.w	FBZ1_BGChange2
; ---------------------------------------------------------------------------
		bra.w	FBZ1_BGChange3
; ---------------------------------------------------------------------------
		bra.w	FBZ1_BGChange4
; ---------------------------------------------------------------------------
		bra.w	FBZ1_BGChange5
; ---------------------------------------------------------------------------
		bra.w	FBZ1_BGChange6
; ---------------------------------------------------------------------------

FBZ1_BGChange1:
		tst.w	($FFFFEED6).w
		bne.s	loc_52AFE
		cmpi.w	#$B00,d0		; If indoors
		bcc.s	loc_52AF4
		cmpi.w	#$9C0,d1
		bcs.w	FBZ_Deform
		bra.s	loc_52B22
; ---------------------------------------------------------------------------

loc_52AF4:
		cmpi.w	#$900,d1
		bcs.w	FBZ_Deform
		bra.s	loc_52B22
; ---------------------------------------------------------------------------

loc_52AFE:
		cmpi.w	#$B00,d0		; If outdoors
		bcc.s	loc_52B0E
		cmpi.w	#$9C0,d1
		bhi.w	FBZ_Deform
		bra.s	loc_52B16
; ---------------------------------------------------------------------------

loc_52B0E:
		cmpi.w	#$900,d1
		bhi.w	FBZ_Deform

loc_52B16:
		clr.w	($FFFFEED6).w
		moveq	#4,d0
		moveq	#0,d6
		bra.w	FBZ_BGChangeGoIn
; ---------------------------------------------------------------------------

loc_52B22:

		st	($FFFFEED6).w
		moveq	#8,d0
		move.w	#$F0,d6
		bra.w	FBZ_BGChangeGoOut
; ---------------------------------------------------------------------------

FBZ1_BGChange2:
		tst.w	($FFFFEED6).w
		bne.s	loc_52B50
		cmpi.w	#$C80,d0
		bcc.s	loc_52B46
		cmpi.w	#$2C0,d1
		bhi.w	FBZ_Deform
		bra.s	loc_52B76
; ---------------------------------------------------------------------------

loc_52B46:
		cmpi.w	#$240,d1
		bhi.w	FBZ_Deform
		bra.s	loc_52B76
; ---------------------------------------------------------------------------

loc_52B50:
		cmpi.w	#$C80,d0
		bcc.s	loc_52B60
		cmpi.w	#$2C0,d1
		bcs.w	FBZ_Deform
		bra.s	loc_52B68
; ---------------------------------------------------------------------------

loc_52B60:
		cmpi.w	#$240,d1
		bcs.w	FBZ_Deform

loc_52B68:
		clr.w	($FFFFEED6).w
		moveq	#8,d0
		move.w	#$F0,d6
		bra.w	FBZ_BGChangeGoIn
; ---------------------------------------------------------------------------

loc_52B76:

		st	($FFFFEED6).w
		moveq	#4,d0
		moveq	#0,d6
		bra.w	FBZ_BGChangeGoOut
; ---------------------------------------------------------------------------

FBZ1_BGChange3:
		tst.w	($FFFFEED6).w
		bne.s	loc_52BA2
		cmpi.w	#$1880,d0
		bcc.s	loc_52B98

loc_52B8E:
		cmpi.w	#$9C0,d1
		bcs.w	FBZ_Deform
		bra.s	loc_52BC6
; ---------------------------------------------------------------------------

loc_52B98:
		cmpi.w	#$940,d1
		bcs.w	FBZ_Deform
		bra.s	loc_52BC6
; ---------------------------------------------------------------------------

loc_52BA2:
		cmpi.w	#$1880,d0
		bcc.s	loc_52BB2
		cmpi.w	#$9C0,d1
		bhi.w	FBZ_Deform
		bra.s	loc_52BBA
; ---------------------------------------------------------------------------

loc_52BB2:
		cmpi.w	#$940,d1
		bhi.w	FBZ_Deform

loc_52BBA:
		clr.w	($FFFFEED6).w
		moveq	#4,d0
		moveq	#0,d6
		bra.w	FBZ_BGChangeGoIn
; ---------------------------------------------------------------------------

loc_52BC6:

		st	($FFFFEED6).w
		moveq	#8,d0
		move.w	#$F0,d6
		bra.w	FBZ_BGChangeGoOut
; ---------------------------------------------------------------------------

FBZ1_BGChange4:
		cmpi.w	#$100,d1
		bcs.s	loc_52C0C
		tst.w	($FFFFEED6).w
		bne.s	loc_52BEA
		cmpi.w	#$1C0,d1
		bhi.w	FBZ_Deform
		bra.s	loc_52C00
; ---------------------------------------------------------------------------

loc_52BEA:
		cmpi.w	#$1C0,d1
		bcs.w	FBZ_Deform
		clr.w	($FFFFEED6).w
		moveq	#8,d0
		move.w	#$F0,d6
		bra.w	FBZ_BGChangeGoIn
; ---------------------------------------------------------------------------

loc_52C00:
		st	($FFFFEED6).w
		moveq	#4,d0
		moveq	#0,d6
		bra.w	FBZ_BGChangeGoOut
; ---------------------------------------------------------------------------

loc_52C0C:
		tst.w	($FFFFEED6).w
		bne.s	loc_52C1C
		cmpi.w	#$1B00,d0
		bcs.w	FBZ_Deform
		bra.s	loc_52C2E
; ---------------------------------------------------------------------------

loc_52C1C:
		cmpi.w	#$1B00,d0
		bhi.w	FBZ_Deform
		clr.w	($FFFFEED6).w
		moveq	#$C,d0
		moveq	#0,d6
		bra.s	loc_52C3E
; ---------------------------------------------------------------------------

loc_52C2E:
		st	($FFFFEED6).w
		moveq	#$10,d0
		move.w	#$3F0,d6
		lea	Pal_FBZBGOutdoors(pc),a1
		bra.s	loc_52C42
; ---------------------------------------------------------------------------

loc_52C3E:
		lea	Pal_FBZBGIndoors(pc),a1		; Special case for going left/right rather than up/down

loc_52C42:
		lea	($FFFFFC64).w,a5
		move.l	(a1)+,(a5)+
		move.l	(a1)+,(a5)+
		move.l	(a1)+,(a5)+
		move.l	(a1)+,(a5)+
		move.w	d0,($FFFFEEC2).w
		jsr	FBZ_Deform(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		move.w	d6,($FFFFEEC8).w
		move.w	#$1F,($FFFFEECA).w
		addq.w	#4,sp
		cmpi.w	#$C,($FFFFEEC2).w
		beq.w	loc_5292A
		bra.w	loc_52950
; ---------------------------------------------------------------------------

FBZ1_BGChange5:
		tst.w	($FFFFEED6).w
		bne.s	loc_52C84
		cmpi.w	#$240,d1
		bhi.w	FBZ_Deform
		bra.s	loc_52C98
; ---------------------------------------------------------------------------

loc_52C84:
		cmpi.w	#$240,d1
		bcs.w	FBZ_Deform
		clr.w	($FFFFEED6).w
		moveq	#8,d0
		move.w	#$F0,d6
		bra.s	FBZ_BGChangeGoIn
; ---------------------------------------------------------------------------

loc_52C98:
		st	($FFFFEED6).w
		moveq	#4,d0
		moveq	#0,d6
		bra.s	FBZ_BGChangeGoOut
; ---------------------------------------------------------------------------

FBZ1_BGChange6:
		tst.w	($FFFFEED6).w
		bne.s	loc_52CB2
		cmpi.w	#$640,d1
		bcs.w	FBZ_Deform
		bra.s	loc_52CC4
; ---------------------------------------------------------------------------

loc_52CB2:
		cmpi.w	#$640,d1
		bhi.w	FBZ_Deform
		clr.w	($FFFFEED6).w
		moveq	#4,d0
		moveq	#0,d6
		bra.s	FBZ_BGChangeGoIn
; ---------------------------------------------------------------------------

loc_52CC4:
		st	($FFFFEED6).w
		moveq	#8,d0
		move.w	#$F0,d6

FBZ_BGChangeGoOut:

		lea	Pal_FBZBGOutdoors(pc),a1
		bra.s	loc_52CD8
; ---------------------------------------------------------------------------

FBZ_BGChangeGoIn:

		lea	Pal_FBZBGIndoors(pc),a1

loc_52CD8:
		lea	($FFFFFC64).w,a5
		move.l	(a1)+,(a5)+
		move.l	(a1)+,(a5)+
		move.l	(a1)+,(a5)+
		move.l	(a1)+,(a5)+			; Modify the palette as needed
		move.w	d0,($FFFFEEC2).w	; Set the appropriate BG event to handle the change
		jsr	FBZ_Deform(pc)			; Do deformation as normal
		jsr	Reset_TileOffsetPositionEff(pc)
		add.w	d6,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,sp				; Finish here without doing anything else
		cmpi.w	#4,($FFFFEEC2).w
		beq.w	loc_528DE
		bra.w	loc_52904
; ---------------------------------------------------------------------------

Obj_FBZOutdoorBGMotion:

		move.l	#$2800,d0			; Uses built-in bobbing motion function to move BG up and down
		move.l	#$80,d1
		jsr	(Gradual_SwingOffset).l
		move.w	d0,($FFFFEEDA).w
		rts
; ---------------------------------------------------------------------------
FBZ_InBGDeformArray:	dc.w $80

		dc.w $40
		dc.w $20
		dc.w 8
		dc.w 8
		dc.w 8
		dc.w 8
		dc.w $28
		dc.w $30
		dc.w 8
		dc.w 4
		dc.w 4
		dc.w $B8
		dc.w $30
		dc.w $10
		dc.w $10
		dc.w $30
		dc.w $28
		dc.w $18
		dc.w $10
		dc.w $30
		dc.w $30
		dc.w $10
		dc.w $10
		dc.w $30
		dc.w $28
		dc.w $18
		dc.w $10
		dc.w $B0
		dc.w $30
		dc.w $28
		dc.w $40
		dc.w $18
		dc.w $30
		dc.w $7FFF
FBZ_OutBGDeformArray:	dc.w $30

		dc.w $20
		dc.w $30
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $7FFF
FBZ_InBGDeformIndex:	dc.b    0,  $C,   1,  $A, $16,  $A,   8, $14, $18, $1C, $20, $24, $28, $2C, $30, $34, $38,   2,   6, $12
		dc.b  $3E,   0, $46,   7,   4, $10, $1E, $26, $2E, $36, $3A, $40,   3,  $E, $22, $32, $3C,   1,   0, $44
		dc.b    3,   2, $1A, $2A, $42, $FF
FBZ_OutBGDeformIndex:	dc.w $E
		dc.w 2
		dc.w $A
		dc.w 6
		dc.w $C
		dc.w 4
		dc.w 8
		dc.w 0
		dc.w $10

Pal_FBZBGIndoors:	binclude "Levels\FBZ\Palettes\FBZ BG Indoors.bin"
Pal_FBZBGOutdoors:	binclude "Levels\FBZ\Palettes\FBZ BG Outdoors.bin"
; ---------------------------------------------------------------------------

FBZ2_ScreenInit:
		move.w	#$2C40,d0
		cmp.w	($FFFFEE78).w,d0
		bhi.s	loc_52E2C
		move.w	#4,($FFFFEEC0).w	; If screen X is past subboss battle, change screen event
		move.w	d0,($FFFFEE14).w
		jsr	SetUp_FBZ2BossEvent(pc)
		clr.l	($FFFFEE98).w
		clr.l	($FFFFEE9C).w		; Clear BG camera offset
		move.w	#-$2000,d7
		movem.l	d7-a0/a2-a3,-(sp)
		lea	(ArtKosM_FBZCloud).l,a1
		move.w	#$7460,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_FBZBossPillar).l,a1
		move.w	#$7AA0,d2
		jsr	(Queue_Kos_Module).l	; Load boss event graphics
		movem.l	(sp)+,d7-a0/a2-a3

loc_52E2C:
		jsr	Reset_TileOffsetPositionActual(pc)
		jmp	Refresh_PlaneFull(pc)
; ---------------------------------------------------------------------------

FBZ2_ScreenEvent:
		move.w	($FFFFEECE).w,d0
		add.w	d0,($FFFFEE84).w
		move.w	($FFFFEEC0).w,d0
		jmp	loc_52E44(pc,d0.w)
; ---------------------------------------------------------------------------

loc_52E44:
		bra.w	FBZ2SE_Normal
; ---------------------------------------------------------------------------
		bra.w	FBZ2SE_BossEvent
; ---------------------------------------------------------------------------
		bra.w	FBZ2SE_BossEventRefresh
; ---------------------------------------------------------------------------
		bra.w	FBZ2SE_BossEventEnd
; ---------------------------------------------------------------------------

FBZ2SE_Normal:
		cmpi.b	#6,($FFFFB005).w
		bcs.s	loc_52E5E
		rts
; ---------------------------------------------------------------------------

loc_52E5E:
		lea	FBZ2_LayoutModRange(pc),a1		; Only one layout mod this time around
		move.w	($FFFFB010).w,d0
		move.w	($FFFFB014).w,d1
		move.w	($FFFFEED2).w,d2
		jmp	loc_52E72(pc,d2.w)
; ---------------------------------------------------------------------------

loc_52E72:
		bra.w	FBZ2_NoLayoutMod
; ---------------------------------------------------------------------------
		bra.w	FBZ2_LayoutMod1
; ---------------------------------------------------------------------------

FBZ2_NoLayoutMod:
		cmp.w	(a1)+,d0
		bcs.s	loc_52E90
		cmp.w	(a1)+,d0
		bhi.s	loc_52E90
		cmp.w	(a1)+,d1
		bcs.s	loc_52E90
		cmp.w	(a1)+,d1
		bhi.s	loc_52E90
		move.w	#4,($FFFFEED2).w

loc_52E90:

		jsr	DrawTilesAsYouMove(pc)
		cmpi.w	#$2B30,($FFFFEE78).w
		bcs.s	locret_52EAC
		jsr	SetUp_FBZ2BossEvent(pc)		; If Player passes certain point, set up the boss event
		clr.l	($FFFFEE98).w
		clr.l	($FFFFEE9C).w
		addq.w	#4,($FFFFEEC0).w

locret_52EAC:
		rts
; ---------------------------------------------------------------------------

FBZ2_LayoutMod1:
		jsr	FBZ1Screen_CheckInRange(pc)
		cmpi.w	#$E00,d0
		bcs.s	loc_52EBE
		cmpi.w	#$1280,d0
		bls.s	loc_52F10

loc_52EBE:
		tst.w	($FFFFEED4).w
		bne.s	loc_52ECC
		cmpi.w	#$B0E,d1		; If indoors
		bls.s	loc_52F10
		bra.s	loc_52EDE
; ---------------------------------------------------------------------------

loc_52ECC:
		cmpi.w	#$AF2,d1		; If outdoors
		bhi.s	loc_52F10
		clr.w	($FFFFEED4).w
		movea.w	(a3),a5
		lea	$70(a5),a5
		bra.s	loc_52EEA
; ---------------------------------------------------------------------------

loc_52EDE:
		st	($FFFFEED4).w
		movea.w	$10(a3),a5
		lea	$70(a5),a5

loc_52EEA:
		movea.w	$50(a3),a1
		lea	$1A(a1),a1
		move.w	-8(a3),d0
		subi.w	#$E,d0		; Width of 14 tiles
		moveq	#3,d1		; Height of 4 tiles

loc_52EFC:
		move.l	(a5)+,(a1)+
		move.l	(a5)+,(a1)+
		move.l	(a5)+,(a1)+
		move.w	(a5)+,(a1)+
		adda.w	d0,a5
		adda.w	d0,a1
		dbf	d1,loc_52EFC
		jmp	Refresh_PlaneScreenDirect(pc)
; ---------------------------------------------------------------------------

loc_52F10:

		jmp	DrawTilesAsYouMove(pc)
; ---------------------------------------------------------------------------

FBZ2SE_BossEvent:
		move.w	#-$2000,d7			; Draw FG tiles on BG plane instead
		jmp	DrawTilesAsYouMove(pc)
; ---------------------------------------------------------------------------

FBZ2SE_BossEventRefresh:
		move.w	#-$2000,d7
		move.w	#$2D00,d1
		moveq	#0,d2
		jsr	Draw_PlaneVertBottomUp(pc)
		bpl.s	FBZ2SE_BossEventEnd
		addq.w	#4,($FFFFEEC0).w

FBZ2SE_BossEventEnd:

		rts

; =============== S U B R O U T I N E =======================================


SetUp_FBZ2BossEvent:

		jsr	(Create_New_Sprite).l
		bne.s	loc_52F7A
		move.l	#Obj_FBZEndBossEventControl,(a1)
		jsr	(CreateNewSprite4).l
		bne.s	loc_52F7A
		move.l	#Obj_FBZBossPillar,(a1)
		lea	($FFFFEEEA).w,a5
		moveq	#0,d1
		moveq	#4,d2

loc_52F56:
		move.l	d1,(a5)+		; Reset object addresses for clouds
		dbf	d2,loc_52F56
		lea	($FFFFEEEA).w,a5
		moveq	#9,d1

loc_52F62:
		jsr	(CreateNewSprite4).l
		bne.s	loc_52F7A
		move.w	a1,(a5)+
		move.l	#Obj_FBZCloud,(a1)	; Create cloud objects and place addresses in FFEEEA
		move.w	d1,$2E(a1)
		dbf	d1,loc_52F62

loc_52F7A:

		lea	Pal_FBZBGOutdoors(pc),a1	; Modify palette
		lea	($FFFFFC62).w,a5
		lea	($FFFFFCE2).w,a6
		move.w	#$EEE,(a5)+
		move.w	#$EEE,(a6)+
		move.l	(a1),(a5)+
		move.l	(a1)+,(a6)+
		move.l	(a1),(a5)+
		move.l	(a1)+,(a6)+
		move.l	(a1),(a5)+
		move.l	(a1)+,(a6)+
		move.l	(a1),(a5)+
		move.l	(a1)+,(a6)+
		rts
; End of function SetUp_FBZ2BossEvent

; ---------------------------------------------------------------------------
FBZ2_LayoutModRange:	dc.w $D80, $1300, $A00,	$B80
; ---------------------------------------------------------------------------

FBZ2_BackgroundInit:
		jsr	(Create_New_Sprite).l
		bne.s	loc_52FB6
		move.l	#Obj_FBZOutdoorBGMotion,(a1)

loc_52FB6:
		cmpi.w	#$2C40,($FFFFEE78).w
		bcs.s	loc_53002
		move.w	#$10,($FFFFEEC2).w		; If in boss event area, set BG event
		move.w	(a3),d0
		move.w	d0,$70(a3)			; Copy top BG line to bottom BG line (I guess so the scrolling doesn't garble the screen?)
		move.w	d0,$74(a3)
		move.w	d0,$78(a3)
		move.w	d0,$7C(a3)
		st	($FFFFEECC).w			; Start shaking
		move.w	#-$4000,d7
		jsr	FBZ2_CloudDeform(pc)	; Deform the cloud sprites
		jsr	Reset_TileOffsetPositionEff(pc)
		jsr	Refresh_PlaneFull(pc)
		jsr	PlainDeformation_Flipped(pc)	; Reverse deformation
		jsr	Get_BGActualEffectiveDiff(pc)
		move.w	($FFFFEE90).w,($FFFFF616).w
		move.w	($FFFFEE84).w,($FFFFF618).w
		addq.w	#4,sp

locret_53000:
		rts
; ---------------------------------------------------------------------------

loc_53002:
		jsr	FBZ_Deform(pc)			; Nromal play
		jsr	Reset_TileOffsetPositionEff(pc)
		moveq	#0,d1
		jsr	Refresh_PlaneFull(pc)
		lea	FBZ_InBGDeformArray(pc),a4
		lea	($FFFFA800).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------

FBZ2_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_53024(pc,d0.w)
; ---------------------------------------------------------------------------

loc_53024:
		bra.w	FBZ2BGE_Init
; ---------------------------------------------------------------------------
		bra.w	FBZ2BGE_Normal
; ---------------------------------------------------------------------------
		bra.w	FBZ2BGE_ChangeTopDown
; ---------------------------------------------------------------------------
		bra.w	FBZ2BGE_ChangeBottomUp
; ---------------------------------------------------------------------------
		bra.w	FBZ2BGE_BossEvent
; ---------------------------------------------------------------------------

FBZ2BGE_ChangeTopDown:
		jsr	FBZ2_CheckBGChange(pc)

loc_5303C:
		moveq	#0,d1
		move.w	($FFFFEE90).w,d2
		tst.w	($FFFFEED6).w
		beq.s	loc_5304E
		move.w	#$200,d1
		moveq	#0,d2

loc_5304E:
		jsr	Draw_PlaneVertTopDown(pc)
		bpl.s	loc_530BA
		move.w	#4,($FFFFEEC2).w
		bra.s	loc_530BA
; ---------------------------------------------------------------------------

FBZ2BGE_ChangeBottomUp:
		jsr	FBZ2_CheckBGChange(pc)

loc_53060:
		moveq	#0,d1
		move.w	($FFFFEE90).w,d2
		tst.w	($FFFFEED6).w
		beq.s	loc_53072
		move.w	#$200,d1
		moveq	#0,d2

loc_53072:
		jsr	Draw_PlaneVertSingleBottomUp(pc)
		bpl.s	loc_530BA
		move.w	#4,($FFFFEEC2).w
		bra.s	loc_530BA
; ---------------------------------------------------------------------------

FBZ2BGE_Init:
		move.w	(a3),d0
		move.w	d0,$70(a3)
		move.w	d0,$74(a3)
		move.w	d0,$78(a3)
		move.w	d0,$7C(a3)			; Copy BG lines
		addq.w	#4,($FFFFEEC2).w	; Next BG Event

FBZ2BGE_Normal:
		tst.w	($FFFFEEC0).w
		beq.s	loc_530AC
		jsr	FBZ2_CloudDeform(pc)	; If boss event has started
		jsr	Reset_TileOffsetPositionEff(pc)
		move.w	#$10,($FFFFEEC2).w
		bra.s	loc_530F0
; ---------------------------------------------------------------------------

loc_530AC:
		cmpi.b	#6,($FFFFB005).w
		bcs.s	loc_530B6			; Don't change BG if dying
		rts
; ---------------------------------------------------------------------------

loc_530B6:
		jsr	FBZ2_CheckBGChange(pc)

loc_530BA:

		move.w	($FFFFEED6).w,d1
		beq.s	loc_530C4
		move.w	#$200,d1

loc_530C4:
		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#$20,d6
		jsr	Draw_TileRow(pc)
		lea	FBZ_InBGDeformArray(pc),a4
		tst.w	($FFFFEED6).w
		beq.s	loc_530E0
		lea	FBZ_OutBGDeformArray(pc),a4

loc_530E0:
		lea	($FFFFA800).w,a5
		jsr	ApplyDeformation(pc)
		jmp	ShakeScreen_Setup(pc)
; ---------------------------------------------------------------------------

FBZ2BGE_BossEvent:
		jsr	FBZ2_CloudDeform(pc)

loc_530F0:
		move.w	#-$4000,d7
		jsr	DrawBGAsYouMove(pc)		; Draw BG on plane A
		jsr	PlainDeformation_Flipped(pc)
		jsr	Get_BGActualEffectiveDiff(pc)
		jsr	ShakeScreen_Setup(pc)
		move.w	($FFFFEE90).w,($FFFFF616).w
		move.w	($FFFFEE84).w,($FFFFF618).w
		addq.w	#4,sp
		tst.w	($FFFFEED8).w
		beq.s	locret_5318A
		clr.w	($FFFFEED8).w		; If boss has been loaded
		move.w	($FFFFEE9C).w,d0
		clr.w	($FFFFEE9C).w		; Get final Y offset and clear it
		btst	#1,($FFFFB02A).w
		beq.s	loc_53134
		add.w	d0,($FFFFB014).w	; If player is not on ground, adjust his Y position properly
		add.w	d0,($FFFFB05E).w

loc_53134:
		add.w	d0,($FFFFEE7C).w
		add.w	d0,($FFFFEE84).w
		add.w	d0,($FFFFEE18).w
		add.w	d0,($FFFFEE1A).w	; Add offset to camera Ys
		move.w	($FFFFEE1A).w,($FFFFEE12).w
		move.w	($FFFFEE98).w,d0
		clr.w	($FFFFEE98).w
		sub.w	d0,($FFFFB010).w

loc_53156:
		sub.w	d0,($FFFFB05A).w	; Adjust X position of players
		sub.w	d0,($FFFFEE78).w

loc_5315E:
		sub.w	d0,($FFFFEE80).w
		sub.w	d0,($FFFFEE14).w
		sub.w	d0,($FFFFEE16).w	; and of cameras
		movea.w	($FFFF8034).w,a1	; $580 Y of FG
		lea	$5C(a1),a1				; $2D00 X of FG
		move.w	($FFFF8000).w,d0
		subi.w	#$14,d0
		moveq	#3,d1

loc_5317C:
		moveq	#$13,d2

loc_5317E:
		clr.b	(a1)+				; Clear large area of FG, probably erasing the copied FG area from the layout mod
		dbf	d2,loc_5317E
		adda.w	d0,a1
		dbf	d1,loc_5317C

locret_5318A:
		rts

; =============== S U B R O U T I N E =======================================


FBZ2_CloudDeform:

		move.w	($FFFFEE84).w,d0
		subi.w	#$300,d0
		add.w	($FFFFEE9C).w,d0		; Add camera BG Y to Y event offset
		move.w	d0,($FFFFEE90).w		; Make that the effective Y
		move.w	($FFFFEE80).w,d0
		subi.w	#$2600,d0
		sub.w	($FFFFEE98).w,d0
		move.w	d0,($FFFFEE8C).w		; Do the same with the X values
		lea	($FFFFA800).w,a1
		lea	FBZ2_CloudDeformIndex(pc),a5
		move.w	($FFFFEE8C).w,d0
		swap	d0
		clr.w	d0
		asr.l	#4,d0
		move.l	d0,d1
		asr.l	#2,d1
		move.l	($FFFFA9FC).w,d2
		asr.l	#3,d2
		addi.l	#$8000,($FFFFA9FC).w	; Perform cloud movement
		moveq	#9,d3

loc_531D2:
		move.w	(a5)+,d4
		add.l	d2,d0
		swap	d0
		move.w	d0,(a1,d4.w)		; Set up cloud speeds
		swap	d0
		add.l	d1,d0
		dbf	d3,loc_531D2
		lea	($FFFFA800).w,a1
		lea	($FFFFEEEA).w,a5
		move.w	($FFFFEE90).w,d0
		move.w	($FFFFEECE).w,d1
		sub.w	d1,d0
		asr.w	#1,d0
		add.w	d1,d0
		neg.w	d0
		add.w	($FFFFEEDA).w,d0	; Get effective Y, add BG motion offset to it
		moveq	#9,d1

loc_53202:
		move.w	(a5)+,d2
		beq.s	loc_5322E
		movea.w	d2,a6			; Load cloud address
		move.w	$30(a6),d3		; Get Y position
		add.w	d0,d3			; Add ofset
		andi.w	#$FF,d3
		addi.w	#$74,d3
		move.w	d3,$14(a6)		; Load to actual Y
		move.w	(a1)+,d3
		neg.w	d3
		add.w	$2E(a6),d3
		andi.w	#$1FF,d3
		addi.w	#$54,d3
		move.w	d3,$10(a6)		; Do the same to the X

loc_5322E:
		dbf	d1,loc_53202
		rts
; End of function FBZ2_CloudDeform


; =============== S U B R O U T I N E =======================================


FBZ2_CheckBGChange:

		move.w	($FFFFB010).w,d0
		move.w	($FFFFB014).w,d1
		move.w	($FFFFEED2).w,d2		; You know how this goes by now
		jmp	loc_53244(pc,d2.w)
; End of function FBZ1_CheckBGChange

; ---------------------------------------------------------------------------

loc_53244:
		bra.w	FBZ_Deform
; ---------------------------------------------------------------------------
		tst.w	($FFFFEED6).w
		bne.s	loc_53258
		cmpi.w	#$A40,d1
		bcs.w	FBZ_Deform
		bra.s	loc_5326A
; ---------------------------------------------------------------------------

loc_53258:
		cmpi.w	#$A40,d1
		bhi.w	FBZ_Deform
		clr.w	($FFFFEED6).w
		moveq	#8,d0
		moveq	#0,d6
		bra.s	loc_5327A
; ---------------------------------------------------------------------------

loc_5326A:
		st	($FFFFEED6).w
		moveq	#$C,d0
		move.w	#$F0,d6
		lea	Pal_FBZBGOutdoors(pc),a1
		bra.s	loc_5327E
; ---------------------------------------------------------------------------

loc_5327A:
		lea	Pal_FBZBGIndoors(pc),a1

loc_5327E:
		lea	($FFFFFC64).w,a5
		move.l	(a1)+,(a5)+
		move.l	(a1)+,(a5)+
		move.l	(a1)+,(a5)+
		move.l	(a1)+,(a5)+
		move.w	d0,($FFFFEEC2).w
		jsr	FBZ_Deform(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		add.w	d6,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,sp
		cmpi.w	#8,($FFFFEEC2).w
		beq.w	loc_5303C
		bra.w	loc_53060
; ---------------------------------------------------------------------------

Obj_FBZEndBossEventControl:
		move.l	#loc_532E0,(a0)
		move.b	#$11,6(a0)
		bset	#7,$2A(a0)
		move.w	#$32B8,($FFFFEE16).w		; Set $32B8 as the X end
		move.w	#$3C,d0
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_532DC
		addq.w	#4,d0

loc_532DC:
		move.w	d0,($FFFFEE18).w		; Set level Y start depending on whether Tails is playing or not. I guess this is because Tails' center point is slightly lower than Sonic's

loc_532E0:
		cmpi.w	#$2E80,($FFFFB010).w
		bcs.w	loc_533A4
		move.l	#loc_532F0,(a0)			; If Sonic has passed $2E80 X, start moving the BG

loc_532F0:
		st	($FFFFF664).w				; Set BG collision on
		addi.l	#$A000,($FFFFEE9C).w
		addi.l	#$7800,($FFFFEE98).w	; Move the extra BG camera by a set amount
		cmpi.w	#$5D0,($FFFFEE9C).w
		bcs.s	loc_5333A
		move.w	#$5D0,($FFFFEE9C).w		; When BG has reached end point
		move.w	#$45C,($FFFFEE98).w
		clr.b	($FFFFF664).w			; Stop BG collision
		move.l	#loc_53322,(a0)

loc_53322:
		move.w	($FFFFEE18).w,d0
		cmp.w	($FFFFEE7C).w,d0
		bne.s	loc_5333A
		move.w	d0,($FFFFEE1A).w		; Lock screen when camera has scrolled as high as possible
		move.w	d0,($FFFFEE12).w
		move.l	#loc_5333A,(a0)

loc_5333A:


		cmpi.w	#$280,($FFFFB014).w
		bcc.s	loc_53348
		move.w	($FFFFEE78).w,($FFFFEE14).w	; If player is above $280 Y then lock screen X as you move

loc_53348:
		move.w	($FFFFEE18).w,d0
		cmp.w	($FFFFEE1A).w,d0
		bne.s	loc_533A4
		move.w	($FFFFEE16).w,d0
		cmp.w	($FFFFEE14).w,d0
		bne.s	loc_533A4
		move.w	#$F0,($FFFFEEC8).w		; When the screen is completely locked, start proper Screen Events
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC0).w		; Next screen event
		move.l	#loc_53372,(a0)

loc_53372:
		cmpi.w	#$C,($FFFFEEC0).w
		bne.s	loc_533A4
		jsr	(Create_New_Sprite).l
		bne.s	loc_53388				; When screen event has finished, load the boss
		move.l	#Obj_FBZEndBoss,(a1)

loc_53388:
		clr.w	($FFFFEECC).w			; Stop shaking
		st	($FFFFEED8).w				; Set variable when boss has loaded
		move.w	#$31C0,d0
		move.w	#$31C0,d4
		move.w	#$690,d1
		move.l	#loc_533A4,(a0)
		bra.s	loc_533B8
; ---------------------------------------------------------------------------

loc_533A4:

		move.w	$10(a0),d4
		move.w	#$31C0,d0
		add.w	($FFFFEE98).w,d0
		move.w	#$690,d1
		sub.w	($FFFFEE9C).w,d1

loc_533B8:
		move.w	d0,$10(a0)
		move.w	d1,$14(a0)
		move.w	#$4C0,d1
		moveq	#$11,d2
		moveq	#$11,d3
		jmp	(SolidObjectTop).l
; ---------------------------------------------------------------------------

Obj_FBZBossPillar:
		move.l	#Obj_FBZBossPillarMain,(a0)
		move.b	#$44,4(a0)			; Set up boss pillar object
		move.b	#-1,6(a0)
		move.b	#$20,7(a0)
		move.w	#$300,8(a0)
		move.w	#-$3C2B,$A(a0)
		move.l	#Map_FBZ2Preboss,$C(a0)
		move.w	#2,$16(a0)			; 2 sprites

Obj_FBZBossPillarMain:
		move.w	#$2DE0,d4
		add.w	($FFFFEE98).w,d4
		move.w	d4,$10(a0)			; Move pillar to proper X area
		move.w	d4,d0
		move.w	d4,d1
		subi.w	#$200,d0
		tst.w	$30(a0)
		beq.s	loc_5341E
		addi.w	#$28,d1

loc_5341E:
		move.w	#$580,d5
		sub.w	($FFFFEE9C).w,d5	; Get proper Y offset
		move.w	d5,d2
		move.w	d5,d3
		addi.w	#$80,d2
		addi.w	#$100,d3
		clr.w	$30(a0)
		lea	($FFFFB000).w,a1
		bsr.s	FBZBossPillar_CheckPlayerPos
		lea	($FFFFB04A).w,a1
		bsr.s	FBZBossPillar_CheckPlayerPos
		tst.w	$30(a0)
		beq.s	loc_53456
		cmpi.w	#$40,$2E(a0)	; If player is in range, increase pillar offset
		bcc.s	loc_5346A
		addq.w	#8,$2E(a0)
		bra.s	loc_5346A
; ---------------------------------------------------------------------------

loc_53456:
		tst.w	$2E(a0)
		beq.s	loc_5346A
		subq.w	#8,$2E(a0)		; If player is not in range, decrease pillar offset
		bne.s	loc_5346A
		moveq	#-$37,d0		; Play sound only when pillar hits ground
		jsr	(Play_Sound_2).l

loc_5346A:

		sub.w	$2E(a0),d5
		move.w	d5,$14(a0)		; Subtract Y from offset and place it in sprite Y
		lea	$18(a0),a1
		addi.w	#$80,d5
		moveq	#1,d0

loc_5347C:
		move.w	d4,(a1)
		move.w	d5,2(a1)
		subi.w	#$100,d5		; Set the sprite positions of each pillar sprite
		addq.w	#6,a1
		dbf	d0,loc_5347C
		moveq	#$2B,d1
		move.w	#$100,d2
		move.w	#$100,d3
		jsr	(SolidObjectFull).l	; Make it solid
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


FBZBossPillar_CheckPlayerPos:

		move.w	$10(a1),d6
		cmp.w	d0,d6
		blt.s	locret_534C4
		cmp.w	d1,d6
		bcc.s	locret_534C4
		move.w	$14(a1),d6
		cmp.w	d2,d6
		bcs.s	locret_534C4
		cmp.w	d3,d6
		bcc.s	locret_534C4
		tst.b	$2E(a1)
		bmi.s	locret_534C4
		st	$30(a0)

locret_534C4:
		rts
; End of function FBZBossPillar_CheckPlayerPos

; ---------------------------------------------------------------------------

Obj_FBZCloud:
		move.l	#Draw_Sprite,(a0)
		move.b	#$40,4(a0)		; Multisprite routine
		move.b	#$C,6(a0)
		move.b	#$2C,7(a0)
		move.w	#$380,8(a0)
		move.w	#$63A3,$A(a0)
		move.l	#Map_FBZ2Preboss,$C(a0)
		move.w	$2E(a0),d0
		add.w	d0,d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		lea	FBZCloud_PositionFrameData(pc),a1
		adda.w	d0,a1
		move.w	(a1)+,$2E(a0)
		move.w	(a1)+,$30(a0)
		move.w	(a1),d0
		move.b	d0,$22(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Map_FBZ2Preboss:	include "Levels\FBZ\Misc Object Data\Map - Act 2 Preboss.asm"

FBZ2_CloudDeformIndex:	dc.w 4
		dc.w $E
		dc.w 8
		dc.w $10
		dc.w 2
		dc.w $C
		dc.w 6
		dc.w $12
		dc.w $A
		dc.w 0
FBZCloud_PositionFrameData:	dc.w   $1E0,   $EC,	1
		dc.w   $144,   $C8,	2
		dc.w	$60,   $B4,	3
		dc.w	$C4,   $A0,	2
		dc.w   $140,   $84,	1
		dc.w   $1A0,   $6C,	3
		dc.w	$F0,   $54,	1
		dc.w   $160,   $3C,	3
		dc.w	$7C,   $28,	2
		dc.w	$20,	$C,	1
; ---------------------------------------------------------------------------

ICZ1_ScreenInit:
		tst.b	($FFFFFE2A).w
		bne.s	loc_53648			; If not restarting from a lamppost
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_53648			; And we're Knuckles
		jsr	(Create_New_Sprite).l
		bne.s	loc_53648
		move.l	#Obj_ICZTeleporter,(a1)	; Make teleporter object, etc
		move.w	#$3640,($FFFFB010).w
		move.w	#$660,($FFFFB014).w
		move.w	#$35A0,d0
		move.w	d0,($FFFFEE80).w
		move.w	d0,($FFFFEE78).w
		move.w	#$5FB,d0
		move.w	d0,($FFFFEE84).w
		move.w	d0,($FFFFEE7C).w

loc_53648:

		move.w	#$7FF,($FFFFEEAA).w
		move.w	#$7F0,($FFFFEEAC).w
		move.w	#$3C,($FFFFEEAE).w		; We're in a looping level!
		jsr	Reset_TileOffsetPositionActual(pc)
		jmp	Refresh_PlaneFull(pc)
; ---------------------------------------------------------------------------

ICZ1_ScreenEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_5366A(pc,d0.w)
; ---------------------------------------------------------------------------

loc_5366A:
		bra.w	ICZ1SE_Init
; ---------------------------------------------------------------------------
		bra.w	ICZ1SE_WaitQuake
; ---------------------------------------------------------------------------
		bra.w	ICZ1SE_Normal
; ---------------------------------------------------------------------------
		bra.w	ICZ1SE_Normal
; ---------------------------------------------------------------------------
		bra.w	ICZ1SE_Normal
; ---------------------------------------------------------------------------
		bra.w	ICZ1SE_Normal
; ---------------------------------------------------------------------------

ICZ1SE_Init:
		tst.w	($FFFFEECC).w
		beq.s	loc_53696
		tst.b	($FFFFF7CA).w	; If shaking due to hitting the wall, remove player control temporarily
		bne.s	loc_53696
		st	($FFFFF7CA).w
		clr.w	($FFFFF602).w

loc_53696:

		move.w	($FFFFEECE).w,d0
		add.w	d0,($FFFFEE80).w
		bra.s	ICZ1SE_Normal
; ---------------------------------------------------------------------------

ICZ1SE_WaitQuake:
		move.w	($FFFFEECE).w,d0
		add.w	d0,($FFFFEE84).w

ICZ1SE_Normal:

		jmp	DrawTilesAsYouMove(pc)
; ---------------------------------------------------------------------------

ICZ1_BackgroundInit:
		lea	(a3),a1
		moveq	#7,d0

loc_536B0:
		move.w	(a1),$20(a1)	; Upper $400 of BG is mirrored in lower $400
		addq.w	#4,a1
		dbf	d0,loc_536B0
		move.w	($FFFFEE84).w,($FFFFEEB4).w
		move.w	($FFFFEE84).w,($FFFFEEB6).w		; Camera BG Y is noted in two variables
		cmpi.w	#$3940,($FFFFEE78).w
		bcc.s	loc_53704
		cmpi.w	#$3580,($FFFFEE78).w
		bcs.s	loc_536DC
		addi.w	#$2800,($FFFFEEB6).w		; If past $3580 X, adjust BG camera

loc_536DC:
		clr.w	($FFFFEEE8).w				; No VScrolling when outside
		jsr	(ICZ1_SetIntroPal).l
		jsr	ICZ1_IntroDeform(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		move.w	#$1880,d1
		jsr	Refresh_PlaneFull(pc)
		lea	(ICZ1_IntroBGDeformArray).l,a4
		lea	($FFFFA800).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------

loc_53704:
		move.w	#$10,($FFFFEEC2).w		; If past $3940 X, we're indoors already
		st	($FFFFEEE8).w				; Go indoors
		jsr	(ICZ1_SetIndoorPal).l
		jsr	ICZ1_Deform(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		jsr	Refresh_PlaneFull(pc)
		jmp	PlainDeformation(pc)
; ---------------------------------------------------------------------------

ICZ1_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_5372C(pc,d0.w)
; ---------------------------------------------------------------------------

loc_5372C:
		bra.w	ICZ1BGE_Intro
; ---------------------------------------------------------------------------
		bra.w	ICZ1BGE_SnowFall
; ---------------------------------------------------------------------------
		bra.w	ICZ1BGE_Refresh
; ---------------------------------------------------------------------------
		bra.w	ICZ1BGE_Refresh2
; ---------------------------------------------------------------------------
		bra.w	ICZ1BGE_Normal
; ---------------------------------------------------------------------------
		bra.w	ICZ1BGE_Transition
; ---------------------------------------------------------------------------

ICZ1BGE_Intro:
		tst.w	($FFFFEEC6).w
		beq.s	loc_53780
		clr.w	($FFFFEEC6).w		; If flag is set
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_5375C
		addq.w	#4,($FFFFEEC2).w	; Just go to next BG event if playing as Knuckles
		bra.s	loc_53780
; ---------------------------------------------------------------------------

loc_5375C:
		jsr	(Create_New_Sprite).l
		bne.s	loc_5376A
		move.l	#Obj_ICZ1BigSnowPile,(a1)

loc_5376A:
		clr.l	($FFFFEED2).w
		clr.l	($FFFFEED6).w		; Clear offsets
		jsr	ICZ1_BigSnowFall(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_537BA
; ---------------------------------------------------------------------------

loc_53780:

		jsr	ICZ1_IntroDeform(pc)		; Deformation is pretty standard during the intro portion
		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		move.w	#$1880,d1
		moveq	#$20,d6
		jsr	Draw_TileRow(pc)
		lea	(ICZ1_IntroBGDeformArray).l,a4
		lea	($FFFFA800).w,a5
		jsr	ApplyDeformation(pc)
		jmp	ShakeScreen_Setup(pc)
; ---------------------------------------------------------------------------

ICZ1BGE_SnowFall:
		tst.w	($FFFFEEC6).w
		bne.s	loc_537C6
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_53780
		jsr	ICZ1_BigSnowFall(pc)	; If Knuckles, skip

loc_537BA:
		jsr	DrawBGAsYouMove(pc)
		jsr	PlainDeformation(pc)
		jmp	ShakeScreen_Setup(pc)
; ---------------------------------------------------------------------------

loc_537C6:
		clr.w	($FFFFEEC6).w
		move.w	#$2E0,($FFFFEEC8).w		; Set BG refresh position
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w

ICZ1BGE_Refresh:
		move.w	#$1880,d1
		move.w	#$200,d2
		jsr	Draw_PlaneVertBottomUp(pc)
		bpl.w	PlainDeformation
		jsr	ICZ1_Deform(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_5380E
; ---------------------------------------------------------------------------

ICZ1BGE_Refresh2:
		jsr	ICZ1_Deform(pc)

loc_5380E:
		move.w	($FFFFEE8C).w,d1
		move.w	($FFFFEE90).w,d2
		jsr	Draw_PlaneVertBottomUp(pc)
		bpl.s	loc_5387E
		st	($FFFFEEE8).w		; Go indoors
		jsr	(ICZ1_SetIndoorPal).l	; Set indoor palette
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_5387E
; ---------------------------------------------------------------------------

ICZ1BGE_Normal:
		cmpi.w	#$6900,($FFFFEE78).w
		bcs.s	loc_5387A
		movem.l	d7-a0/a2-a3,-(sp)
		lea	(ICZ2_128x128_Secondary_Kos).l,a1
		lea	($FFFF0A00).l,a2
		jsr	(Queue_Kos).l
		lea	(ICZ2_16x16_Secondary_Kos).l,a1
		lea	($FFFF9408).w,a2
		jsr	(Queue_Kos).l
		lea	(ICZ2_8x8_Secondary_KosM).l,a1
		move.w	#$2440,d2
		jsr	(Queue_Kos_Module).l
		moveq	#$20,d0
		jsr	(Load_PLC).l
		movem.l	(sp)+,d7-a0/a2-a3
		addq.w	#4,($FFFFEEC2).w

loc_5387A:
		jsr	ICZ1_Deform(pc)

loc_5387E:

		jsr	DrawBGAsYouMove(pc)
		jmp	PlainDeformation(pc)
; ---------------------------------------------------------------------------

ICZ1BGE_Transition:
		tst.w	($FFFFFF0E).w
		bne.w	loc_53938
		move.w	#$501,($FFFFFE10).w
		clr.b	($FFFFEE33).w
		clr.b	($FFFFF76C).w
		clr.b	($FFFFF710).w
		clr.b	($FFFFF7AA).w
		clr.b	($FFFFFF97).w
		jsr	Clear_Switches(pc)
		movem.l	d7-a0/a2-a3,-(sp)
		jsr	(Load_Level).l
		jsr	(LoadSolids).l
		jsr	(CheckLevelForWater).l
		move.w	#-$7FEC,($C00004).l		; Turn on HInt since ICZ2 has water
		moveq	#$15,d0
		jsr	(LoadPalette_Immediate).l
		movem.l	(sp)+,d7-a0/a2-a3
		move.w	#$6880,d0
		move.w	#-$100,d1
		sub.w	d0,($FFFFB010).w
		sub.w	d1,($FFFFB014).w
		sub.w	d0,($FFFFB05A).w
		sub.w	d1,($FFFFB05E).w
		jsr	Offset_ObjectsDuringTransition(pc)
		jsr	Offset_SomeObjectsDuringTransition(pc)
		sub.w	d0,($FFFFEE78).w
		sub.w	d1,($FFFFEE7C).w
		sub.w	d0,($FFFFEE80).w
		sub.w	d1,($FFFFEE84).w
		move.l	#$7000,d0
		move.l	d0,($FFFFEE14).w
		move.l	#$B20,d0
		move.l	d0,($FFFFEE18).w
		move.w	d0,($FFFFEE12).w
		move.w	#$FFF,($FFFFEEAA).w
		move.w	#$FF0,($FFFFEEAC).w
		move.w	#$7C,($FFFFEEAE).w
		jsr	Reset_TileOffsetPositionActual(pc)
		clr.w	($FFFFEEC2).w

loc_53938:
		jsr	ICZ1_Deform(pc)
		jmp	PlainDeformation(pc)

; =============== S U B R O U T I N E =======================================


ICZ1_IntroDeform:

		lea	($FFFFEEB4).w,a1
		move.w	($FFFFEE84).w,d0
		move.w	#$400,d2
		move.w	#$800,d3
		jsr	Adjust_BGDuringLoop(pc)
		move.w	($FFFFEEB6).w,d0
		asr.w	#7,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEE80).w,d0
		move.w	($FFFFEECE).w,d3
		sub.w	d3,d0
		swap	d0
		clr.w	d0
		asr.l	#5,d0
		move.l	d0,d1
		swap	d0
		add.w	d3,d0
		swap	d0
		lea	($FFFFA800).w,a1
		moveq	#0,d3
		moveq	#4,d2			; First five deformation speeds are constant
		bsr.s	sub_53996
		add.l	d1,d0
		move.l	d1,d2
		asr.l	#1,d2
		add.l	d2,d1
		move.l	$12(a1),d3
		addi.l	#$800,$12(a1)
		moveq	#8,d2			; Last 9 move slowly automatically
; End of function ICZ1_IntroDeform


; =============== S U B R O U T I N E =======================================


sub_53996:

		swap	d0
		move.w	d0,(a1)+
		swap	d0
		add.l	d1,d0
		add.l	d3,d1
		addi.l	#$800,d3
		dbf	d2,sub_53996
		rts
; End of function sub_53996


; =============== S U B R O U T I N E =======================================


ICZ1_BigSnowFall:

		cmpi.w	#-$12E,($FFFFEED2).w
		ble.s	loc_539DE
		st	($FFFFEECC).w
		addi.l	#$2400,($FFFFEED6).w
		move.l	($FFFFEED6).w,d0
		sub.l	d0,($FFFFEED2).w
		move.w	($FFFFFE04).w,d0
		subq.w	#1,d0
		andi.w	#$F,d0
		bne.s	loc_539F0
		moveq	#$6F,d0
		jsr	(Play_Sound_2).l
		bra.s	loc_539F0
; ---------------------------------------------------------------------------

loc_539DE:
		tst.w	($FFFFEECC).w
		bpl.s	loc_539F0
		move.w	#4,($FFFFEECC).w
		move.w	#-$12E,($FFFFEED2).w

loc_539F0:

		move.w	($FFFFEE84).w,d0		; Use portion of background to show snow object
		subi.w	#$460,d0
		add.w	($FFFFEED2).w,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEE80).w,d0
		subi.w	#$1D40,d0
		move.w	d0,($FFFFEE8C).w
		rts
; End of function ICZ1_BigSnowFall


; =============== S U B R O U T I N E =======================================


ICZ1_Deform:

		move.w	($FFFFEE84).w,d0
		asr.w	#1,d0
		move.w	d0,($FFFFEE90).w	; BG moves up/down at half speed
		asr.w	#1,d0
		move.w	d0,($FFFFEEE4).w	; Dynamic BG moves up/down at quarter speed
		move.w	($FFFFEE80).w,d0
		asr.w	#1,d0
		subi.w	#$1D80,d0
		move.w	d0,($FFFFEE8C).w	; BG moves left/right at half speed
		asr.w	#1,d0
		move.w	d0,($FFFFEEE2).w	; Dynamic BG moves left/right at quarter speed
		rts
; End of function ICZ1_Deform

; ---------------------------------------------------------------------------

Obj_ICZ1BigSnowPile:
		move.l	#loc_53A4C,(a0)
		move.b	#-$80,6(a0)
		move.w	#$3880,$10(a0)
		bset	#7,$2A(a0)

loc_53A4C:
		cmpi.w	#8,($FFFFEEC2).w
		bcs.s	loc_53A5A
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_53A5A:
		move.w	#$5E0,d0
		sub.w	($FFFFEED2).w,d0		; Shift Y position based on offset
		move.w	d0,$14(a0)
		move.w	#$94,d1
		lea	ICZ1_SnowpileSlopeDef(pc),a2
		move.w	$10(a0),d4
		jsr	(SolidObjectTopSloped2).l
		cmpi.w	#$70E,$14(a0)
		bne.s	locret_53AD2
		tst.b	($FFFFF7CA).w
		beq.s	locret_53AD2
		lea	($FFFFB000).w,a1
		btst	#1,$2A(a1)		; Wait till player is standing on ground
		bne.s	locret_53AD2
		move.b	($FFFFF605).w,d0
		andi.w	#$70,d0			; Wait until a jump button is pressed
		beq.s	locret_53AD2
		clr.b	($FFFFF7CA).w	; When done, unlock player
		move.w	#-$600,$1A(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		moveq	#$62,d0
		jsr	(Play_Sound_2).l	; Perform jumping on player object manually

locret_53AD2:

		rts
; ---------------------------------------------------------------------------

Obj_ICZTeleporter:
		jsr	(Create_New_Sprite3).l
		beq.s	loc_53ADE
		rts
; ---------------------------------------------------------------------------

loc_53ADE:
		move.l	#Obj_ICZTeleporterMain,(a0)
		move.b	#4,4(a0)
		move.b	#$10,6(a0)
		move.b	#$20,7(a0)
		move.w	#$80,8(a0)
		move.w	#$2347,$A(a0)
		move.l	#Map_ICZPlatforms,$C(a0)		; Attributes for teleporter platform in ICZ
		move.w	#$3640,$10(a0)
		move.w	#$670,$14(a0)					; Set position
		move.b	#$1A,$22(a0)
		move.w	($FFFFB014).w,$3E(a0)			; Knuckles Y position into $3E
		move.w	a1,$3C(a0)						; Child beam object into $3C
		move.l	#Obj_TeleporterBeamExpand,(a1)
		move.b	#$44,4(a1)
		st	5(a1)
		move.b	#-$80,6(a1)
		move.b	#$18,7(a1)
		move.w	#$80,8(a1)
		move.w	#$255E,$A(a1)
		move.l	#Map_SSZHPZTeleporter,$C(a1)	; Set attributes of beam object
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	#2,$16(a1)
		move.w	$14(a0),$44(a1)					; Lots of init stuff for the beam to work properly
		subi.w	#$80,$44(a1)
		move.b	#$18,$46(a1)
		move.w	a0,$48(a1)				; Parent in $48
		lea	($FFFFFCB0).w,a1
		move.w	#$EA2,(a1)
		move.w	#$E80,4(a1)				; Slight change to palette
		lea	($FFFFB000).w,a1
		move.b	#1,$2E(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)				; Knuckles is under object control, spinning animation, and jumping

Obj_ICZTeleporterMain:
		lea	($FFFFB000).w,a1
		move.l	#$20000,d0
		move.l	#$800,d1
		jsr	(Gradual_SwingOffset).l		; Do gradual swing on Knuckles until he starts to reverse direction
		add.w	$3E(a0),d0
		move.w	d0,$14(a1)
		tst.l	$2E(a0)
		bmi.s	loc_53BFE
		clr.b	$2E(a1)				; Return player control to Knuckles
		clr.b	$20(a1)
		move.l	#Obj_ICZTeleporterCheckDel,(a0)

Obj_ICZTeleporterCheckDel:
		cmpi.w	#$3780,($FFFFEE80).w
		bcs.s	loc_53BEE
		lea	($FFFFFC30).w,a1		; When player moves far enough to the right, restore palette and delete object
		move.w	#$2C,(a1)
		clr.w	4(a1)
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_53BEE:
		moveq	#$23,d1			; Act as a solid object otherwise
		moveq	#$10,d2
		moveq	#1,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l

loc_53BFE:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
		dc.b  $61, $61
		dc.b  $61, $61
		dc.b  $60, $60
		dc.b  $60, $60
		dc.b  $5F, $5F
		dc.b  $5E, $5E
		dc.b  $5D, $5C
		dc.b  $5C, $5B
		dc.b  $5A, $59
		dc.b  $59, $58
		dc.b  $57, $57
ICZ1_SnowpileSlopeDef:	dc.b  $56, $56
		dc.b  $55, $55
		dc.b  $54, $54
		dc.b  $53, $53
		dc.b  $52, $52
		dc.b  $51, $51
		dc.b  $51, $51
		dc.b  $50, $50
		dc.b  $50, $50
		dc.b  $4F, $4F
		dc.b  $4E, $4E
		dc.b  $4D, $4C
		dc.b  $4C, $4B
		dc.b  $4A, $49
		dc.b  $49, $48
		dc.b  $47, $47
		dc.b  $46, $46
		dc.b  $45, $45
		dc.b  $44, $44
		dc.b  $43, $43
		dc.b  $42, $42
		dc.b  $41, $41
		dc.b  $41, $41
		dc.b  $40, $40
		dc.b  $40, $40
		dc.b  $3F, $3F
		dc.b  $3E, $3E
		dc.b  $3D, $3C
		dc.b  $3C, $3B
		dc.b  $3A, $39
		dc.b  $39, $38
		dc.b  $37, $37
		dc.b  $36, $36
		dc.b  $35, $35
		dc.b  $34, $34
		dc.b  $33, $33
		dc.b  $32, $32
		dc.b  $31, $31
		dc.b  $31, $31
		dc.b  $30, $30
		dc.b  $30, $30
		dc.b  $2F, $2F
		dc.b  $2E, $2E
		dc.b  $2D, $2C
		dc.b  $2C, $2B
		dc.b  $2A, $29
		dc.b  $29, $28
		dc.b  $27, $27
		dc.b  $26, $26
		dc.b  $25, $25
		dc.b  $24, $24
		dc.b  $23, $23
		dc.b  $22, $22
		dc.b  $21, $21
		dc.b  $21, $21
		dc.b  $20, $20
		dc.b  $20, $20
		dc.b  $1F, $1F
		dc.b  $1E, $1E
		dc.b  $1D, $1C
		dc.b  $1C, $1B
		dc.b  $1A, $19
		dc.b  $19, $18
		dc.b  $17, $17
		dc.b  $16, $16
		dc.b  $15, $15
		dc.b  $14, $14
		dc.b  $13, $13
		dc.b  $12, $12
		dc.b  $11, $11
		dc.b  $11, $11
		dc.b  $10, $10
		dc.b  $10, $10
		dc.b   $F,  $F
		dc.b   $E,  $E
		dc.b   $D,  $C
		dc.b   $C,  $B
		dc.b   $A,   9
		dc.b	9,   8
		dc.b	7,   7
		dc.b	6,   6
		dc.b	5,   5
		dc.b	4,   4
		dc.b	3,   3
		dc.b	2,   2
; ---------------------------------------------------------------------------

ICZ2_ScreenInit:
		jsr	Reset_TileOffsetPositionActual(pc)
		jmp	Refresh_PlaneFull(pc)
; ---------------------------------------------------------------------------

ICZ2_ScreenEvent:
		jmp	DrawTilesAsYouMove(pc)		; About as straightforward as you can get really
; ---------------------------------------------------------------------------

ICZ2_BackgroundInit:
		move.w	#4,($FFFFEEC2).w
		cmpi.w	#$3600,($FFFFEE78).w	; Check ranges for either indoor/outdoor BGs
		bcc.s	loc_53CF6
		cmpi.w	#$720,($FFFFEE7C).w
		bcc.s	loc_53D2C
		cmpi.w	#$1000,($FFFFEE78).w
		bcc.s	loc_53CF6
		cmpi.w	#$580,($FFFFEE7C).w
		bcc.s	loc_53D2C

loc_53CF6:

		clr.w	($FFFFEEE8).w			; Outdoors
		cmpi.w	#$720,($FFFFEE78).w
		bcc.s	loc_53D0A
		jsr	(ICZ2_SetICZ1Pal).l
		bra.s	loc_53D10
; ---------------------------------------------------------------------------

loc_53D0A:
		jsr	(ICZ2_SetOutdoorsPal).l

loc_53D10:
		jsr	(ICZ2_OutDeform).l
		moveq	#0,d0
		moveq	#0,d1
		jsr	Refresh_PlaneFull(pc)
		lea	(ICZ2_OutBGDeformArray).l,a4
		lea	($FFFFA800).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------

loc_53D2C:

		st	($FFFFEEE8).w			; Indoors
		jsr	(ICZ2_SetIndoorsPal).l
		jsr	(ICZ2_InDeform).l
		jsr	Reset_TileOffsetPositionEff(pc)
		moveq	#0,d1
		jsr	Refresh_PlaneFull(pc)
		lea	(ICZ2_InBGDeformArray).l,a4
		lea	($FFFFA800).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------

ICZ2_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_53D5C(pc,d0.w)
; ---------------------------------------------------------------------------

loc_53D5C:
		bra.w	ICZ2BGE_FromICZ1
; ---------------------------------------------------------------------------
		bra.w	ICZ2BGE_Normal
; ---------------------------------------------------------------------------
		bra.w	ICZ2BGE_Refresh
; ---------------------------------------------------------------------------

ICZ2BGE_FromICZ1:
		addq.w	#4,($FFFFEEC2).w		; This only applies when coming from ICZ 1
		cmpi.w	#$580,($FFFFEE7C).w
		bcc.s	loc_53D96
		bra.w	loc_53DFC
; ---------------------------------------------------------------------------

ICZ2BGE_Normal:
		tst.w	($FFFFEEE8).w
		bne.s	loc_53DD8
		move.w	($FFFFEE78).w,d0		; If outdoors
		cmpi.w	#$1000,d0
		bcs.s	loc_53DC4
		cmpi.w	#$3600,d0
		bcc.s	loc_53DC4
		cmpi.w	#$720,($FFFFEE7C).w
		bcs.s	loc_53DC4

loc_53D96:
		st	($FFFFEEE8).w				; Set to go indoors
		jsr	(ICZ2_SetIndoorsPal).l
		jsr	(ICZ2_InDeform).l
		jsr	Reset_TileOffsetPositionEff(pc)
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		bra.w	loc_53E84
; ---------------------------------------------------------------------------

loc_53DC4:

		jsr	(ICZ2_OutDeform).l				; No trigger, run normal deformation

loc_53DCA:

		lea	(ICZ2_OutBGDeformArray).l,a4
		lea	($FFFFA800).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------

loc_53DD8:
		move.w	($FFFFEE78).w,d0		; If indoors
		cmpi.w	#$1900,d0
		bcs.s	loc_53DE8
		cmpi.w	#$1B80,d0
		bcs.s	loc_53E38

loc_53DE8:
		cmpi.w	#$1000,d0
		bcs.s	loc_53E38
		cmpi.w	#$3600,d0
		bcc.s	loc_53E38
		cmpi.w	#$720,($FFFFEE7C).w
		bcc.s	loc_53E38

loc_53DFC:
		clr.w	($FFFFEEE8).w
		cmpi.w	#$720,($FFFFEE78).w
		bcc.s	loc_53E10
		jsr	(ICZ2_SetICZ1Pal).l
		bra.s	loc_53E16
; ---------------------------------------------------------------------------

loc_53E10:
		jsr	(ICZ2_SetOutdoorsPal).l

loc_53E16:
		jsr	(ICZ2_OutDeform).l
		jsr	Reset_TileOffsetPositionEff(pc)
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_53E68
; ---------------------------------------------------------------------------

loc_53E38:

		jsr	(ICZ2_InDeform).l

loc_53E3E:

		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jsr	Draw_TileRow(pc)
		lea	(ICZ2_InBGDeformArray).l,a4
		lea	($FFFFA800).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------

ICZ2BGE_Refresh:
		tst.w	($FFFFEEE8).w
		bne.s	loc_53E7E
		jsr	(ICZ2_OutDeform).l

loc_53E68:
		moveq	#0,d1
		move.w	($FFFFEE90).w,d2
		jsr	Draw_PlaneVertBottomUp(pc)
		bpl.w	loc_53DCA
		subq.w	#4,($FFFFEEC2).w
		bra.w	loc_53DCA
; ---------------------------------------------------------------------------

loc_53E7E:
		jsr	(ICZ2_InDeform).l

loc_53E84:
		moveq	#0,d1
		move.w	($FFFFEE90).w,d2
		jsr	Draw_PlaneVertBottomUp(pc)
		bpl.s	loc_53E3E
		subq.w	#4,($FFFFEEC2).w
		bra.s	loc_53E3E
; ---------------------------------------------------------------------------

LBZ1_ScreenInit:
		move.w	4(a3),d0
		subi.w	#$76,d0
		move.w	d0,$70(a3)
		move.w	d0,$74(a3)
		move.w	d0,$78(a3)
		move.w	d0,$7C(a3)
		movea.w	$48(a3),a1
		movea.w	$4C(a3),a5
		move.b	$79(a1),$79(a5)
		move.b	#-$25,$79(a1)
		jsr	LBZ1_RotateChunks(pc)
		lea	($FFFFA948).w,a1
		moveq	#$D,d0

loc_53ECC:
		clr.l	(a1)+		; Clear VScroll
		dbf	d0,loc_53ECC
		jsr	LBZ1_EventVScroll(pc)
		lea	($FFFFA900).w,a1
		moveq	#$B,d0

loc_53EDC:
		move.w	(a1)+,d1
		and.w	($FFFFEEAC).w,d1
		move.w	d1,(a1)+	; Set up tile offsets for VScroll array
		dbf	d0,loc_53EDC
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_53F06
		cmpi.w	#$3B60,($FFFFEE78).w	; Skip this if Knuckles
		bcs.s	loc_53F0A
		jsr	(Create_New_Sprite).l
		bne.s	loc_53F06
		move.l	#Obj_LBZ1InvisibleBarrier,(a1)

loc_53F06:

		jsr	LBZ1_ModEndingLayout(pc)

loc_53F0A:
		move.w	($FFFFB010).w,d0
		move.w	($FFFFB014).w,d1
		moveq	#0,d2
		jsr	(LBZ1_CheckLayoutMod).l
		jsr	Reset_TileOffsetPositionActual(pc)
		jmp	Refresh_PlaneFull(pc)
; ---------------------------------------------------------------------------

LBZ1_ScreenEvent:
		move.w	($FFFFEECE).w,d0
		add.w	d0,($FFFFEE84).w
		jsr	LBZ1_KnuxLevelSizeAdjust(pc)
		cmpi.w	#$55,($FFFFEEC4).w
		bne.s	loc_53F6A
		clr.w	($FFFFEEC4).w
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_53F50
		movea.w	8(a3),a1
		move.b	#-$26,$7D(a1)		; Changes the chunk where the boss appears
		jmp	Refresh_PlaneScreenDirect(pc)
; ---------------------------------------------------------------------------

loc_53F50:
		movea.w	$4C(a3),a1
		move.b	$78(a1),d0
		movea.w	$50(a3),a1
		lea	$78(a1),a1
		move.b	d0,(a1)+		; Changes all the chunks where the boss appears in Knuckles' stage
		move.b	d0,(a1)+
		move.b	d0,(a1)+
		jmp	Refresh_PlaneScreenDirect(pc)
; ---------------------------------------------------------------------------

loc_53F6A:
		move.w	($FFFFB010).w,d0	; Normal level operation
		move.w	($FFFFB014).w,d1
		move.w	($FFFFEED2).w,d2
		bne.s	loc_53F86
		jsr	(LBZ1_CheckLayoutMod).l
		tst.w	d3
		bmi.s	loc_53FE2
		jmp	Refresh_PlaneScreenDirect(pc)	; Refresh screen when a layout mod is made
; ---------------------------------------------------------------------------

loc_53F86:
		lea	(LBZ1_LayoutModExitRange-4).l,a1		; If already in a layout
		adda.w	d2,a1
		cmp.w	(a1)+,d0
		bcs.s	loc_53F98
		cmp.w	(a1)+,d0
		bhi.s	loc_53F98
		bra.s	loc_53FE2
; ---------------------------------------------------------------------------

loc_53F98:

		clr.w	($FFFFEED2).w
		lsr.w	#1,d2
		jsr	loc_53FA6-2(pc,d2.w)

loc_53FA2:
		jmp	Refresh_PlaneScreenDirect(pc)
; ---------------------------------------------------------------------------

loc_53FA6:
		bra.s	LBZ1_LayoutExitMod1
; ---------------------------------------------------------------------------
		bra.s	LBZ1_LayoutExitMod2
; ---------------------------------------------------------------------------
		bra.s	LBZ1_LayoutExitMod3
; ---------------------------------------------------------------------------
		bra.s	LBZ1_LayoutExitMod4
; ---------------------------------------------------------------------------

LBZ1_LayoutExitMod1:
		movea.w	(a3),a5
		lea	$88(a5),a5
		jmp	(LBZ1_DoMod1).l
; ---------------------------------------------------------------------------

LBZ1_LayoutExitMod2:
		movea.w	$24(a3),a5
		lea	$8A(a5),a5
		jmp	(LBZ1_DoMod2).l
; ---------------------------------------------------------------------------

LBZ1_LayoutExitMod3:
		movea.w	(a3),a5
		lea	$98(a5),a5
		jmp	(LBZ1_DoMod3).l
; ---------------------------------------------------------------------------

LBZ1_LayoutExitMod4:
		movea.w	$30(a3),a5
		lea	$9A(a5),a5
		jmp	(LBZ1_DoMod4).l
; ---------------------------------------------------------------------------

loc_53FE2:

		jsr	LBZ1_EventVScroll(pc)		; Do the vscroll deformation, if necessary
		lea	(LBZ1_FGVScrollArray).l,a4
		lea	($FFFFA900).w,a5
		moveq	#$F,d6
		moveq	#$C,d5
		jmp	DrawTilesVDeform(pc)

; =============== S U B R O U T I N E =======================================


LBZ1_EventVScroll:

		tst.w	($FFFFEEC4).w
		beq.w	loc_540AC
		bpl.s	loc_5401C
		move.w	#1,($FFFFEEC4).w
		move.w	#4,($FFFFEEA6).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_5401C
		move.l	#Obj_LBZ1InvisibleBarrier,(a1)

loc_5401C:

		lea	($FFFFA94C).w,a1
		lea	(LBZ1_CollapseScrollSpeed).l,a5
		move.l	$2C(a1),d0
		addi.l	#$100,$2C(a1)
		move.w	$30(a1),d1
		addq.w	#1,$30(a1)
		asr.w	#6,d1
		moveq	#$A,d2
		moveq	#9,d3

loc_54040:
		addq.w	#2,d1
		andi.w	#$E,d1
		move.w	(a5,d1.w),d4
		ext.l	d4
		lsl.l	#4,d4
		move.l	(a1),d5
		sub.l	d4,d5
		sub.l	d0,d5
		swap	d5
		cmpi.w	#-$300,d5
		bgt.s	loc_54062
		move.w	#-$300,d5
		subq.w	#1,d2

loc_54062:
		swap	d5
		move.l	d5,(a1)+
		dbf	d3,loc_54040
		move.w	($FFFFFE04).w,d0
		subq.w	#1,d0
		andi.w	#$F,d0
		bne.s	loc_54082
		tst.w	d2
		beq.s	loc_54082
		moveq	#-$34,d0
		jsr	(Play_Sound_2).l

loc_54082:

		tst.w	d2
		bne.s	loc_540AC
		clr.w	($FFFFEECC).w
		clr.w	($FFFFEEC4).w
		move.w	#$C,($FFFFEEA6).w
		jsr	LBZ1_ModEndingLayout(pc)
		lea	($FFFFA948).w,a1
		moveq	#$D,d0

loc_5409E:
		clr.l	(a1)+
		dbf	d0,loc_5409E
		moveq	#$5F,d0
		jsr	(Play_Sound_2).l

loc_540AC:

		lea	($FFFFA900).w,a1
		lea	($FFFFA930).w,a4
		lea	($FFFFA948).w,a5
		move.w	($FFFFEE84).w,d0
		moveq	#$B,d1

loc_540BE:
		move.w	(a5),d2
		add.w	d0,d2
		move.w	d2,(a1)
		move.w	d2,(a4)+
		addq.w	#4,a1
		addq.w	#4,a5
		dbf	d1,loc_540BE
		rts
; End of function LBZ1_EventVScroll


; =============== S U B R O U T I N E =======================================


LBZ1_ModEndingLayout:

		movea.w	(a3),a1			; This ensures that when Sonic starts from the lamppost before the boss the building behind him disappears
		lea	$74(a1),a1			; It also doubles as the layout used by Knuckles in his version of the level
		move.w	-8(a3),d0
		subq.w	#4,d0
		moveq	#$B,d1

loc_540DE:
		clr.l	(a1)+
		adda.w	d0,a1
		dbf	d1,loc_540DE
		movea.w	(a3),a5
		lea	$98(a5),a5
		movea.w	$24(a3),a1
		lea	$74(a1),a1
		move.w	-8(a3),d0
		subq.w	#4,d0
		moveq	#2,d1

loc_540FC:
		move.l	(a5)+,(a1)+
		adda.w	d0,a5
		adda.w	d0,a1
		dbf	d1,loc_540FC
		st	($FFFFEED4).w		; Disable the layout modding for this area (layoutmod3)
		rts
; End of function LBZ1_ModEndingLayout


; =============== S U B R O U T I N E =======================================


LBZ1_KnuxLevelSizeAdjust:
		cmpi.w	#3,($FFFFFF08).w
		bne.s	locret_54144		; Only do this if playing as Knuckles
		move.w	($FFFFB010).w,d0
		cmpi.w	#$37C0,d0			; Basically this adjusts the top of the screen for Knuckles when he approaches the end of the level
		bcs.s	locret_54144
		cmpi.w	#$3800,d0
		bhi.s	locret_54144
		move.w	($FFFFB014).w,d0
		cmpi.w	#$600,d0
		bcs.s	locret_54144
		cmpi.w	#$680,d0
		bhi.s	locret_54144
		moveq	#0,d1
		cmpi.w	#$640,d0
		bcc.s	loc_54140
		move.w	#$40C,d1

loc_54140:
		move.w	d1,($FFFFEE18).w

locret_54144:

		rts
; End of function LBZ1_KnuxLevelSizeAdjust


; =============== S U B R O U T I N E =======================================


LBZ1_RotateChunks:

		moveq	#$17,d2

loc_54148:
		lea	($FF6E00).l,a1
		lea	-2(a1),a5
		move.w	(a5),d0
		moveq	#$3E,d1

loc_54156:
		move.w	-(a5),-(a1)
		dbf	d1,loc_54156
		move.w	d0,(a5)
		dbf	d2,loc_54148
		rts
; End of function LBZ1_RotateChunks

; ---------------------------------------------------------------------------

Obj_LBZ1InvisibleBarrier:

		cmpi.w	#$3D80,($FFFFEE78).w
		bcs.s	loc_54172
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_54172:
		move.w	#$3BC0,d4
		move.w	d4,$10(a0)
		move.w	#$100,$14(a0)
		move.b	#$40,7(a0)
		bset	#7,$2A(a0)
		moveq	#$4B,d1
		move.w	#$100,d2
		move.w	#$100,d3
		jmp	(SolidObjectFull2).l
; ---------------------------------------------------------------------------

LBZ1_BackgroundInit:
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_541C6
		movea.w	(a3),a1			; Get rid of the death egg portion of the BG while playing as Knuckles. For obvious reasons.
		addq.w	#2,a1
		move.b	#-$1C,(a1)+
		move.b	#-$1A,(a1)+
		move.b	#-$20,(a1)+
		movea.w	4(a3),a1
		addq.w	#2,a1
		move.b	#-$14,(a1)+
		move.b	#-$12,(a1)+
		move.b	#-$18,(a1)+

loc_541C6:
		jsr	(LBZ1_Deform).l
		jsr	Reset_TileOffsetPositionEff(pc)
		move.w	d2,($FFFFA802).w
		clr.l	($FFFFA804).w
		lea	LBZ1_BGDrawArray(pc),a4
		lea	($FFFFA800).w,a5
		jsr	Refresh_PlaneTileDeform(pc)
		lea	LBZ1_BGDeformArray(pc),a4
		lea	($FFFFA808).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------

LBZ1_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_541F8(pc,d0.w)
; ---------------------------------------------------------------------------

loc_541F8:
		bra.w	LBZ1BGE_Normal
; ---------------------------------------------------------------------------
		bra.w	LBZ1BGE_DoTransition
; ---------------------------------------------------------------------------

LBZ1BGE_Normal:
		tst.w	($FFFFEEC6).w
		beq.s	loc_54248
		clr.w	($FFFFEEC6).w		; Yeah, normal transition nonsense for the level change
		movem.l	d7-a0/a2-a3,-(sp)
		lea	(LBZ2_128x128_Kos).l,a1
		lea	($FFFF0000).l,a2
		jsr	(Queue_Kos).l
		lea	(LBZ2_16x16_Secondary_Kos).l,a1
		lea	($FFFF96B8).w,a2
		jsr	(Queue_Kos).l
		lea	(LBZ2_8x8_Secondary_KosM).l,a1
		move.w	#$33A0,d2
		jsr	(Queue_Kos_Module).l
		movem.l	(sp)+,d7-a0/a2-a3
		addq.w	#4,($FFFFEEC2).w

loc_54248:
		jsr	(LBZ1_Deform).l
		lea	LBZ1_BGDrawArray(pc),a4
		lea	($FFFFA800).w,a5
		moveq	#$20,d6
		moveq	#2,d5
		jsr	Draw_BG(pc)
		lea	LBZ1_BGDeformArray(pc),a4
		lea	($FFFFA808).w,a5
		jsr	ApplyDeformation(pc)
		lea	(LBZ1_FGVScrollArray).l,a4
		lea	($FFFFA92E).w,a5
		jsr	Apply_FGVScroll(pc)
		jmp	ShakeScreen_Setup(pc)
; ---------------------------------------------------------------------------

LBZ1BGE_DoTransition:
		tst.b	($FFFFFF60).w
		bne.w	loc_5432E
		move.w	#$601,($FFFFFE10).w
		clr.b	($FFFFEE33).w
		clr.b	($FFFFF76C).w
		clr.b	($FFFFF710).w
		clr.b	($FFFFF7AA).w
		clr.b	($FFFFFF97).w
		jsr	Clear_Switches(pc)
		movem.l	d7-a0/a2-a3,-(sp)
		jsr	(Load_Level).l
		jsr	(LoadSolids).l
		jsr	(CheckLevelForWater).l
		move.w	#-$7FEC,($C00004).l		; Water in this stage yaaay
		moveq	#$17,d0
		jsr	(LoadPalette_Immediate).l
		movem.l	(sp)+,d7-a0/a2-a3
		jsr	Adjust_LBZ2Layout(pc)
		move.w	#$3A00,d0
		moveq	#0,d1
		sub.w	d0,($FFFFB010).w
		sub.w	d0,($FFFFB05A).w
		jsr	Offset_ObjectsDuringTransition(pc)
		sub.w	d0,($FFFFEE78).w
		sub.w	d0,($FFFFEE80).w
		sub.w	d0,($FFFFEE14).w
		sub.w	d0,($FFFFEE16).w
		jsr	Reset_TileOffsetPositionActual(pc)
		clr.l	($FFFFEED2).w
		clr.l	($FFFFEEE6).w
		clr.w	($FFFFEEA0).w
		clr.w	($FFFFEF40).w
		clr.w	($FFFFEEBE).w
		move.w	#$40,($FFFFEEE2).w
		cmpi.w	#$540,($FFFFEE7C).w
		bcs.s	loc_5431C
		neg.w	($FFFFEEE2).w

loc_5431C:
		movem.l	d7-a0/a2-a3,-(sp)
		jsr	(sub_2807A).l				; Start LBZ2 tile animation
		movem.l	(sp)+,d7-a0/a2-a3
		clr.w	($FFFFEEC2).w

loc_5432E:
		lea	LBZ1_BGDeformArray(pc),a4
		lea	($FFFFA808).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------
LBZ1_BGDrawArray:	dc.w $D0
		dc.w $7FFF
LBZ1_BGDeformArray:	dc.w $D0
		dc.w $18
		dc.w 8
		dc.w 8
		dc.w $7FFF
; ---------------------------------------------------------------------------

LBZ2_ScreenInit:
		jsr	Adjust_LBZ2Layout(pc)
		move.w	#4,($FFFFEEC0).w
		clr.l	($FFFFEEE6).w
		clr.w	($FFFFEEA0).w
		clr.w	($FFFFEF40).w
		clr.w	($FFFFEEBE).w
		bsr.s	LBZ2_LayoutMod
		jsr	Reset_TileOffsetPositionActual(pc)
		jmp	Refresh_PlaneFull(pc)
; ---------------------------------------------------------------------------

LBZ2_ScreenEvent:
		move.w	($FFFFEECE).w,d0
		add.w	d0,($FFFFEE84).w
		move.w	($FFFFEEC0).w,d0
		jmp	loc_5437C(pc,d0.w)
; ---------------------------------------------------------------------------

loc_5437C:
		bra.w	LBZ2SE_FromTransition
; ---------------------------------------------------------------------------
		bra.w	LBZ2SE_Normal
; ---------------------------------------------------------------------------

LBZ2SE_FromTransition:
		cmpi.w	#3,($FFFFFF08).w		; Only run when going from transition, of course
		beq.s	loc_543C2				; Knuckles adjusts the layout immediately.
		cmpi.w	#$60A,($FFFFB010).w
		bcs.s	loc_5439E
		bsr.s	LBZ2_LayoutMod
		addq.w	#4,($FFFFEEC0).w
		jmp	Refresh_PlaneScreenDirect(pc)
; ---------------------------------------------------------------------------

loc_5439E:
		jmp	DrawTilesAsYouMove(pc)

; =============== S U B R O U T I N E =======================================


LBZ2_LayoutMod:

		movea.w	(a3),a5			; Thankfully, this is the only one in the whole level
		lea	$94(a5),a5
		movea.w	(a3),a1
		addq.w	#6,a1
		move.w	-8(a3),d0
		subq.w	#6,d0
		moveq	#5,d1

loc_543B4:
		move.l	(a5)+,(a1)+
		move.w	(a5)+,(a1)+
		adda.w	d0,a5
		adda.w	d0,a1
		dbf	d1,loc_543B4
		rts
; End of function LBZ2_LayoutMod

; ---------------------------------------------------------------------------

loc_543C2:
		bsr.s	LBZ2_LayoutMod
		addq.w	#4,($FFFFEEC0).w

LBZ2SE_Normal:
		jmp	DrawTilesAsYouMove(pc)		; Remarkably straightforward

; =============== S U B R O U T I N E =======================================


Adjust_LBZ2Layout:

		movea.w	($FFFF8050).w,a1
		movea.w	($FFFF8054).w,a5
		move.b	5(a1),5(a5)
		move.b	#-$25,5(a1)
		jsr	LBZ1_RotateChunks(pc)
		movea.w	($FFFF8054).w,a1
		move.b	4(a1),d0
		movea.w	($FFFF8058).w,a1
		addq.w	#4,a1
		move.b	d0,(a1)+
		move.b	d0,(a1)+
		move.b	d0,(a1)+
		movea.w	($FFFF8024).w,a1
		move.b	#$58,$8A(a1)
		movea.w	($FFFF8028).w,a1
		move.b	#$55,$8A(a1)
		rts
; End of function Adjust_LBZ2Layout

; ---------------------------------------------------------------------------

LBZ2_BackgroundInit:
		move.w	#8,($FFFFEEC2).w
		jsr	LBZ2_Deform(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		moveq	#0,d1
		jsr	Refresh_PlaneFull(pc)
		moveq	#$40,d0
		cmp.w	($FFFFEEE2).w,d0
		blt.s	loc_54432
		neg.w	d0
		cmp.w	($FFFFEEE2).w,d0
		bgt.s	loc_54436

loc_54432:
		move.w	d0,($FFFFEEE2).w		; Keep art reloading in range

loc_54436:
		lea	(LBZ2_BGDeformArray).l,a4
		lea	($FFFFA800).w,a5
		jmp	ApplyDeformation(pc)
; ---------------------------------------------------------------------------

LBZ2_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_5444C(pc,d0.w)
; ---------------------------------------------------------------------------

loc_5444C:
		bra.w	LBZ2BGE_FromTransition
; ---------------------------------------------------------------------------
		bra.w	LBZ2BGE_Refresh
; ---------------------------------------------------------------------------
		bra.w	LBZ2BGE_Normal
; ---------------------------------------------------------------------------
		bra.w	LBZ2BGE_DeathEgg
; ---------------------------------------------------------------------------
		bra.w	LBZ2BGE_PlatformDetach
; ---------------------------------------------------------------------------
		bra.w	LBZ2BGE_Falling
; ---------------------------------------------------------------------------

LBZ2BGE_FromTransition:
		jsr	LBZ2_Deform(pc)						; This and below are only done when transitioning
		jsr	Reset_TileOffsetPositionEff(pc)
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_54488
; ---------------------------------------------------------------------------

LBZ2BGE_Refresh:
		jsr	LBZ2_Deform(pc)

loc_54488:
		moveq	#0,d1
		move.w	($FFFFEE90).w,d2
		jsr	Draw_PlaneVertBottomUp(pc)
		bpl.s	loc_544A4
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_544A4
; ---------------------------------------------------------------------------

LBZ2BGE_Normal:
		tst.w	($FFFFEEC6).w
		bne.s	loc_544C6		; Wait for flag
		jsr	LBZ2_Deform(pc)

loc_544A4:

		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jsr	Draw_TileRow(pc)
		lea	(LBZ2_BGDeformArray).l,a4
		lea	($FFFFA800).w,a5
		jsr	ApplyDeformation(pc)
		jmp	ShakeScreen_Setup(pc)
; ---------------------------------------------------------------------------

loc_544C6:
		clr.w	($FFFFEEC6).w			; Oh boy, NOW the fun begins
		move.w	8(a3),(a3)
		move.w	$C(a3),4(a3)			; Modify the background slightly
		move.w	#$4390,d0
		move.w	d0,($FFFFEE16).w		; X-end is at $4390
		move.w	#$668,d0
		move.w	d0,($FFFFEE1A).w		; Y-end is $668
		move.w	d0,($FFFFEE12).w
		move.w	#$3C,($FFFFEEE0).w
		move.w	#$1E00,($FFFFEEA2).w
		move.l	#$6200,($FFFFEE9C).w
		st	($FFFFEE0A).w
		st	($FFFFEF40).w
		addq.w	#4,($FFFFEEC2).w

LBZ2BGE_DeathEgg:
		tst.w	($FFFFEF40).w
		beq.s	loc_5452E
		tst.w	($FFFFEECC).w
		bne.s	loc_5451A			; Branch if shaking
		clr.w	($FFFFEF40).w
		bra.s	loc_5452E
; ---------------------------------------------------------------------------

loc_5451A:
		move.w	($FFFFFE04).w,d0
		subq.w	#1,d0
		andi.w	#$F,d0
		bne.s	loc_5452E
		moveq	#-$33,d0			; Play death egg rumbling sound
		jsr	(Play_Sound_2).l

loc_5452E:

		tst.w	($FFFFEEC6).w
		beq.w	loc_545DE
		jsr	LBZ2_EndFallingAccel(pc)	; When signalled, start the falling of the death egg platform
		tst.w	($FFFFEE9C).w
		bpl.w	loc_545DE
		clr.w	($FFFFEEC6).w			; When movement starts going negative
		move.w	#$1B,($FFFFEECA).w
		move.w	#$10,($FFFFEEA6).w		; Do the first window copy
		clr.b	($FFFFF730).w			; No more water evidently
		addq.w	#4,($FFFFEEC2).w
		bra.w	loc_545DE
; ---------------------------------------------------------------------------

LBZ2BGE_PlatformDetach:
		tst.w	($FFFFEEA6).w
		bne.s	sub_545DA			; Wait for window copy to finish
		move.w	($FFFFFE04).w,d0
		andi.w	#3,d0
		bne.s	loc_545AA
		move.w	($FFFFEEE8).w,d0	; Only ever four frames
		cmpi.w	#$28,d0
		bcs.s	loc_545A4
		clr.w	($FFFFEEE8).w		; When scroll A has scrolled off screen
		move.w	#$18,($FFFFEEA6).w	; Use the next Special VInt function to restore the entire platform
		movea.w	$2A(a3),a1
		lea	$87(a1),a1
		clr.b	(a1)
		clr.b	1(a1)
		clr.b	2(a1)				; Furthermore, clear the entire level layout at $580 Y, $4380 X (3 chunks long, 2 chunks high)
		adda.w	-$A(a3),a1
		clr.b	(a1)+
		clr.b	(a1)+
		clr.b	(a1)				; This is for when the platform scrolls off screen at the end
		addq.w	#4,($FFFFEEC2).w
		bra.s	LBZ2BGE_Falling
; ---------------------------------------------------------------------------

loc_545A4:
		addq.w	#1,d0
		move.w	d0,($FFFFEEE8).w	; Increment value

loc_545AA:
		bsr.s	sub_545DA
		move.w	($FFFFEE84).w,($FFFFF616).w
		move.w	($FFFFEE90).w,($FFFFF618).w
		move.w	($FFFFEEE8).w,d0
		add.w	d0,($FFFFF616).w	; Actual vertical scroll is modified by EEE8.
		addq.w	#4,sp
		rts
; ---------------------------------------------------------------------------

LBZ2BGE_Falling:

		tst.w	($FFFFEEC6).w
		beq.s	sub_545DA		; Continue Death Egg deformation until signal
		st	($FFFFEE0A).w		; Set flag so that camera doesn't follow Sonic
		move.w	($FFFFEE7C).w,($FFFFEE84).w		; Scroll screen upwards
		subq.w	#2,($FFFFEE7C).w
		rts

; =============== S U B R O U T I N E =======================================


sub_545DA:

		jsr	LBZ2_EndFallingAccel(pc)

loc_545DE:

		jsr	LBZ2_DeathEggMoveScreen(pc)
		jsr	LBZ2_DeathEggDeform(pc)
		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jsr	Draw_TileRow(pc)
		lea	(LBZ2_DEBGDeformArray).l,a4
		lea	($FFFFA800).w,a5
		jsr	ApplyDeformation(pc)
		jmp	ShakeScreen_Setup(pc)
; End of function sub_545DA


; =============== S U B R O U T I N E =======================================


LBZ2_Deform:

		move.w	($FFFFEE84).w,d0			; Oh hey, it's more waterline fun, wasn't this just so interesting the first timeno
		move.w	($FFFFEECE).w,d3
		sub.w	d3,d0
		subi.w	#$5F0,d0
		move.w	d0,d1
		swap	d0
		clr.w	d0
		asr.l	#1,d0
		move.l	d0,d2
		asr.l	#3,d2
		sub.l	d2,d0
		asr.l	#2,d2
		sub.l	d2,d0
		swap	d0
		move.w	d0,d2
		addi.w	#$2C0,d0
		add.w	d3,d0
		move.w	d0,($FFFFEE90).w			; Calculate effective Y position
		sub.w	d1,d2
		move.w	d2,($FFFFEEE2).w			; Water line equilibrium point
		move.w	($FFFFEE80).w,d0
		swap	d0
		clr.w	d0
		tst.w	d2
		beq.w	loc_546FA					; Equilibrium skips ahead
		move.l	d0,d1
		move.l	d0,d3
		asr.l	#6,d3
		move.l	d3,d4
		asr.l	#3,d4
		sub.l	d4,d3
		moveq	#$1F,d4
		cmpi.w	#-$40,d2
		bgt.s	loc_5467A
		lea	($FFFFA81E).w,a1	; Above water, no art reloading needed

loc_54662:
		swap	d1
		move.w	d1,(a1)+
		swap	d1
		sub.l	d3,d1
		swap	d1
		move.w	d1,(a1)+
		swap	d1
		sub.l	d3,d1
		dbf	d4,loc_54662
		bra.w	loc_546FA
; ---------------------------------------------------------------------------

loc_5467A:
		lea	($FFFFA91E).w,a1	; Below water

loc_5467E:
		swap	d1
		move.w	d1,-(a1)
		swap	d1
		sub.l	d3,d1
		swap	d1
		move.w	d1,-(a1)
		swap	d1
		sub.l	d3,d1
		dbf	d4,loc_5467E
		cmpi.w	#$40,d2
		bge.s	loc_546FA		; No art reloading needed if out of range
		lea	($FFFFA89E).w,a1
		lea	(a1),a5
		lea	(LBZ_WaterlineScroll_Data).l,a6
		move.w	d2,d1
		bmi.s	loc_546D2
		move.w	d1,d3			; Below water
		neg.w	d3
		addi.w	#$40,d3
		lsl.w	#6,d3
		adda.w	d3,a6
		subq.w	#1,d1
		moveq	#0,d3
		lsr.w	#1,d1
		bcc.s	loc_546C4

loc_546BC:
		move.b	(a6)+,d3
		add.w	d3,d3
		move.w	(a5,d3.w),(a1)+

loc_546C4:
		move.b	(a6)+,d3
		add.w	d3,d3
		move.w	(a5,d3.w),(a1)+
		dbf	d1,loc_546BC
		bra.s	loc_546FA
; ---------------------------------------------------------------------------

loc_546D2:
		move.w	d1,d3			; Above water
		addi.w	#$40,d3
		lsl.w	#6,d3
		adda.w	d3,a6
		neg.w	d1
		subq.w	#1,d1
		moveq	#0,d3
		lsr.w	#1,d1
		bcc.s	loc_546EE

loc_546E6:
		move.b	(a6)+,d3
		add.w	d3,d3
		move.w	(a5,d3.w),-(a1)

loc_546EE:
		move.b	(a6)+,d3
		add.w	d3,d3
		move.w	(a5,d3.w),-(a1)
		dbf	d1,loc_546E6

loc_546FA:

		lea	($FFFFA9E2).w,a1			; Below the water area moving up (from Knuckles area of course)
		move.l	d0,d1
		asr.l	#1,d1
		move.l	d1,d3
		asr.l	#3,d3
		swap	d1
		move.w	d1,($FFFFEE8C).w		; Effective X
		move.w	d1,-(a1)
		swap	d1
		sub.l	d3,d1
		swap	d1
		move.w	d1,($FFFFEEE4).w		; Art reloading for the bricks in Knuckles' area
		move.w	d1,-(a1)
		swap	d1
		lea	(LBZ2_BGUWDeformRange).l,a5	; This is an array of counters used for deformation sizes underwater.
		sub.l	d3,d1					; Likely because the underwater wavy effect neccesitates specifying deformation line-by-line
		moveq	#4,d4

loc_54726:
		sub.l	d3,d1
		swap	d1
		move.w	(a5)+,d5

loc_5472C:
		move.w	d1,-(a1)
		move.w	d1,-(a1)
		move.w	d1,-(a1)
		move.w	d1,-(a1)
		dbf	d5,loc_5472C
		swap	d1
		dbf	d4,loc_54726
		moveq	#$3F,d3
		tst.w	d2
		bmi.s	loc_54748
		sub.w	d2,d3					; Only perform as much addition line-by-line deformation as needed
		bcs.s	loc_54756

loc_54748:
		swap	d1
		lsr.w	#1,d3
		bcc.s	loc_54750

loc_5474E:
		move.w	d1,-(a1)

loc_54750:
		move.w	d1,-(a1)
		dbf	d3,loc_5474E

loc_54756:
		lea	($FFFFA800).w,a1			; With that overwith, we can actually do some normal stuff
		lea	(LBZ2_CloudDeformArray).l,a5
		move.l	d0,d1
		asr.l	#6,d1
		move.l	d1,d3
		move.l	($FFFFA9E2).w,d4
		addi.l	#$E00,($FFFFA9E2).w		; Move clouds
		moveq	#$C,d5

loc_54774:
		move.w	(a5)+,d6
		add.l	d4,d1
		swap	d1
		move.w	d1,(a1,d6.w)
		swap	d1
		add.l	d3,d1
		dbf	d5,loc_54774
		move.l	d0,d1			; And now just do the rest of the deformation
		asr.l	#4,d1
		move.l	d1,d3
		asr.l	#1,d3
		lea	($FFFFA81A).w,a1
		swap	d1
		move.w	d1,(a1)+
		swap	d1
		add.l	d3,d1
		swap	d1
		move.w	d1,(a1)+
		tst.w	d2
		bpl.s	loc_547B4		; If below water, just do the full deformation
		moveq	#$3F,d4
		add.w	d2,d4
		bmi.s	loc_547D2		; If above water far enough that entire waterline shows, skip ahead
		cmpi.w	#$30,d4
		bcs.s	loc_547C6
		subi.w	#$30,d4
		bra.s	loc_547B6
; ---------------------------------------------------------------------------

loc_547B4:
		moveq	#$F,d4

loc_547B6:
		moveq	#$17,d5

loc_547B8:
		move.w	d1,(a1)+		; First $30 pixels have their own deformation
		move.w	d1,(a1)+
		dbf	d5,loc_547B8
		swap	d1
		add.l	d3,d1
		swap	d1

loc_547C6:
		lsr.w	#1,d4			; As do the last $10 pixels
		bcc.s	loc_547CC

loc_547CA:
		move.w	d1,(a1)+

loc_547CC:
		move.w	d1,(a1)+
		dbf	d4,loc_547CA

loc_547D2:
		moveq	#$3F,d0			; And yet, there's more, cause we now have the wavy effects to go!
		sub.w	d2,d0
		bmi.s	locret_5480A	; If high enough, no waviness needed
		addi.w	#$60,d0			; Otherwise, keep it up
		cmpi.w	#$E0,d0
		bcs.s	loc_547E6
		move.w	#$DF,d0

loc_547E6:
		lea	($FFFFA9DE).w,a1
		lea	LBZ_WaterWaveArray(pc),a5	; Water wave array
		move.w	($FFFFFE04).w,d1
		asr.w	#1,d1
		andi.w	#$7E,d1
		adda.w	d1,a5
		lsr.w	#1,d0
		bcc.s	loc_54802

loc_547FE:
		move.w	-(a5),d3
		add.w	d3,-(a1)

loc_54802:
		move.w	-(a5),d3
		add.w	d3,-(a1)
		dbf	d0,loc_547FE

locret_5480A:
		rts
; End of function LBZ2_Deform


; =============== S U B R O U T I N E =======================================


LBZ2_DeathEggDeform:
		move.w	($FFFFEE84).w,d0		; Oh no, I'm not commenting all of this again.
		move.w	($FFFFEECE).w,d3
		sub.w	d3,d0
		subi.w	#$5F0,d0
		sub.w	($FFFFEED4).w,d0
		sub.w	($FFFFEED8).w,d0
		move.w	d0,d1
		swap	d0
		clr.w	d0
		asr.l	#1,d0
		move.l	d0,d2
		asr.l	#3,d2
		sub.l	d2,d0
		asr.l	#2,d2
		sub.l	d2,d0
		swap	d0
		move.w	d0,d2
		addi.w	#$2C0,d0
		sub.w	($FFFFEEBE).w,d0
		add.w	d3,d0
		bpl.s	loc_5485C
		moveq	#0,d3
		move.w	d0,d4

loc_54848:
		addi.w	#$100,d3
		addi.w	#$100,d4
		bmi.s	loc_54848
		cmp.w	($FFFFEEA0).w,d3
		bcs.s	loc_5485C
		move.w	d3,($FFFFEEA0).w

loc_5485C:

		tst.w	($FFFFEEBE).w
		bne.s	loc_5486C
		cmpi.w	#$100,d0
		bne.s	loc_5486C
		move.w	d0,($FFFFEEBE).w

loc_5486C:

		add.w	($FFFFEEA0).w,d0
		move.w	d0,($FFFFEE90).w
		tst.w	($FFFFEEA0).w
		beq.s	loc_5488A

loc_5487A:
		cmpi.w	#$100,d0
		bcs.s	loc_54886
		subi.w	#$100,d0
		bra.s	loc_5487A
; ---------------------------------------------------------------------------

loc_54886:
		move.w	d0,($FFFFEE90).w

loc_5488A:
		tst.w	($FFFFEE9C).w
		bmi.s	loc_54894
		sub.w	d1,d2
		bpl.s	loc_54898

loc_54894:
		move.w	#$7FFF,d2

loc_54898:
		move.w	d2,($FFFFEEE2).w
		move.w	($FFFFEE80).w,d0
		swap	d0
		clr.w	d0
		move.l	d0,d1
		move.l	d0,d3
		asr.l	#6,d3
		move.l	d3,d4
		asr.l	#3,d4
		sub.l	d4,d3
		moveq	#$1F,d4
		lea	($FFFFA8AC).w,a1

loc_548B6:
		swap	d1
		move.w	d1,-(a1)
		swap	d1
		sub.l	d3,d1
		swap	d1
		move.w	d1,-(a1)
		swap	d1
		sub.l	d3,d1
		dbf	d4,loc_548B6
		cmpi.w	#$40,d2
		bge.s	loc_54906
		lea	($FFFFA82C).w,a1
		lea	(a1),a5
		lea	(LBZ_WaterlineScroll_Data).l,a6
		move.w	d2,d1
		move.w	d1,d3
		neg.w	d3
		addi.w	#$40,d3
		lsl.w	#6,d3
		adda.w	d3,a6
		subq.w	#1,d1
		moveq	#0,d3
		lsr.w	#1,d1
		bcc.s	loc_548FA

loc_548F2:
		move.b	(a6)+,d3
		add.w	d3,d3
		move.w	(a5,d3.w),(a1)+

loc_548FA:
		move.b	(a6)+,d3
		add.w	d3,d3
		move.w	(a5,d3.w),(a1)+
		dbf	d1,loc_548F2

loc_54906:
		lea	($FFFFA8EC).w,a1
		move.l	d0,d1
		asr.l	#1,d1
		move.l	d1,d3
		asr.l	#3,d3
		moveq	#6,d4

loc_54914:
		sub.l	d3,d1
		dbf	d4,loc_54914
		moveq	#$5F,d3
		sub.w	d2,d3
		bcs.s	loc_5492E
		swap	d1
		lsr.w	#1,d3
		bcc.s	loc_54928

loc_54926:
		move.w	d1,-(a1)

loc_54928:
		move.w	d1,-(a1)
		dbf	d3,loc_54926

loc_5492E:
		lea	($FFFFA80C).w,a1
		lea	(LBZ2_CloudDeformArray).l,a5
		move.l	d0,d1
		asr.l	#6,d1
		move.l	d1,d3
		move.l	($FFFFA9E2).w,d4
		addi.l	#$E00,($FFFFA9E2).w
		moveq	#$C,d5

loc_5494C:
		move.w	(a5)+,d6
		add.l	d4,d1
		swap	d1
		move.w	d1,(a1,d6.w)
		swap	d1
		add.l	d3,d1
		dbf	d5,loc_5494C
		lea	($FFFFA810).w,a1
		lea	($FFFFA800).w,a5
		moveq	#3,d1

loc_54968:
		move.l	(a1)+,(a5)+
		dbf	d1,loc_54968
		move.l	d0,d1
		asr.l	#4,d1
		move.l	d1,d3
		asr.l	#1,d3
		lea	($FFFFA826).w,a1
		swap	d1
		move.w	d1,(a1)+
		swap	d1
		add.l	d3,d1
		swap	d1
		move.w	d1,(a1)+
		swap	d1
		add.l	d3,d1
		swap	d1
		move.w	d1,(a1)+
		moveq	#$3F,d0
		sub.w	d2,d0
		addi.w	#$20,d0
		cmpi.w	#$60,d0
		bcs.s	loc_549A0
		move.w	#$5F,d0

loc_549A0:
		lea	($FFFFA8EC).w,a1
		lea	LBZ_WaterWaveArray2(pc),a5
		move.w	($FFFFFE04).w,d1
		asr.w	#1,d1
		andi.w	#$7E,d1
		adda.w	d1,a5
		lsr.w	#1,d0
		bcc.s	loc_549BC

loc_549B8:
		move.w	-(a5),d3
		add.w	d3,-(a1)

loc_549BC:
		move.w	-(a5),d3
		add.w	d3,-(a1)
		dbf	d0,loc_549B8
		rts
; End of function LBZ2_DeathEggDeform


; =============== S U B R O U T I N E =======================================


LBZ2_DeathEggMoveScreen:
		cmpi.b	#6,($FFFFB005).w
		bcc.w	locret_54A92		; If dying, don't bother
		tst.b	($FFFFEE0A).w
		beq.s	loc_549FC			; Skip if flag turned off
		move.w	($FFFFB010).w,d0
		sub.w	($FFFFEE78).w,d0
		subi.w	#$A0,d0
		bcs.s	loc_549E8
		add.w	d0,($FFFFEE78).w	; Move screen along with player in robotnik ship

loc_549E8:
		cmpi.w	#$4390,($FFFFEE78).w
		bcc.s	loc_549F8
		cmpi.w	#$668,($FFFFEE7C).w
		bcs.s	loc_549FC

loc_549F8:
		clr.b	($FFFFEE0A).w		; Stop movement when screen edge is reached

loc_549FC:

		tst.w	($FFFFEEE0).w
		beq.s	loc_54A0A
		subq.w	#1,($FFFFEEE0).w
		bra.w	locret_54A92
; ---------------------------------------------------------------------------

loc_54A0A:
		cmpi.w	#$4390,($FFFFEE78).w
		bcs.s	loc_54A1A
		move.w	($FFFFEE16).w,d0
		move.w	d0,($FFFFEE14).w

loc_54A1A:
		cmpi.w	#$668,($FFFFEE7C).w
		bcs.s	loc_54A2A
		move.w	($FFFFEE1A).w,d0
		move.w	d0,($FFFFEE18).w		; Lock screen when edges are reached

loc_54A2A:
		lea	($FFFFEED4).w,a1
		moveq	#0,d1
		move.w	($FFFFEEA2).w,d1		; Speed of death egg movement
		add.l	d1,(a1)
		move.w	(a1),d0
		move.w	d0,d1
		sub.w	8(a1),d0
		move.w	d1,8(a1)
		move.w	#$2200,d1
		tst.b	($FFFFEE0A).w
		bne.s	loc_54A50
		move.l	($FFFFEE9C).w,d1		; Get BG movement speed if edge of screen is reached

loc_54A50:
		add.l	d1,4(a1)
		move.w	4(a1),d1
		move.w	d1,d2
		sub.w	$A(a1),d1
		move.w	d2,$A(a1)
		tst.b	($FFFFEE0A).w
		beq.s	loc_54A74
		movea.w	($FFFFEED2).w,a5	; If movement is still going
		add.w	d0,$14(a5)			; Add Y movement to screen and robotnik ship
		add.w	d0,($FFFFEE7C).w

loc_54A74:
		move.w	($FFFFF64A).w,d2
		add.w	d0,d2
		add.w	d1,d2
		cmpi.w	#$F00,d2
		bcs.s	loc_54A86
		move.w	#$F80,d2

loc_54A86:
		move.w	d2,($FFFFF64A).w
		move.w	d0,($FFFFEEE6).w
		add.w	d1,($FFFFEEE6).w

locret_54A92:

		rts
; End of function LBZ2_DeathEggMoveScreen


; =============== S U B R O U T I N E =======================================


LBZ2_EndFallingAccel:
		tst.w	($FFFFEEA2).w
		beq.s	loc_54AA2
		subi.w	#$100,($FFFFEEA2).w
		bra.s	locret_54AB4
; ---------------------------------------------------------------------------

loc_54AA2:
		cmpi.l	#$FFFE8000,($FFFFEE9C).w
		ble.s	locret_54AB4
		subi.l	#$100,($FFFFEE9C).w

locret_54AB4:

		rts
; End of function LBZ2_EndFallingAccel

; ---------------------------------------------------------------------------

MHZ1_ScreenInit:
		clr.w	($FFFFEEE8).w
		clr.b	($FFFFF7C1).w
		jsr	sub_54B80(pc)
		tst.w	($FFFFFFAE).w
		beq.s	loc_54B18
		move.b	($FFFFFE2A).w,d0
		beq.s	loc_54AE0
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_54B18
		subq.b	#1,d0
		bne.s	loc_54B18
		move.w	#$680,d2
		bra.s	loc_54B10
; ---------------------------------------------------------------------------

loc_54AE0:
		move.w	#$560,d2
		move.w	#$948,d3
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_54B08
		lea	($FFFFB000).w,a1
		move.w	#$718,$10(a1)
		move.w	#$62D,$14(a1)
		move.w	#$680,d2
		move.w	#$5CD,d3

loc_54B08:
		move.w	d3,($FFFFEE7C).w
		move.w	d3,($FFFFEE84).w

loc_54B10:
		move.w	d2,($FFFFEE78).w
		move.w	d2,($FFFFEE80).w

loc_54B18:

		jsr	Reset_TileOffsetPositionActual(pc)
		jmp	Refresh_PlaneFull(pc)
; ---------------------------------------------------------------------------

MHZ1_ScreenEvent:
		tst.b	($FFFFEED2).w
		bne.s	loc_54B7C
		tst.w	($FFFFEEE8).w
		bne.s	loc_54B7C
		jsr	sub_54B80(pc)
		move.w	#$AA0,d0
		cmpi.w	#$4100,($FFFFB010).w
		bcs.s	loc_54B40
		move.w	#$710,d0

loc_54B40:
		cmp.w	($FFFFEE1A).w,d0
		beq.s	loc_54B4E
		move.w	d0,($FFFFEE1A).w
		move.w	d0,($FFFFEE12).w

loc_54B4E:
		cmpi.w	#$710,($FFFFEE7C).w
		bcs.s	loc_54B7C
		cmpi.w	#$4298,($FFFFEE78).w
		bcs.s	loc_54B7C
		move.w	#$710,($FFFFEE18).w
		move.w	#8,($FFFFEEB2).w
		st	($FFFFEED2).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_54B7C
		move.l	#Obj_MHZ_Miniboss,(a1)

loc_54B7C:

		jmp	DrawTilesAsYouMove(pc)

; =============== S U B R O U T I N E =======================================


sub_54B80:

		move.w	#$680,d0
		tst.w	($FFFFFFAE).w
		bne.s	loc_54B98
		moveq	#0,d0
		cmpi.w	#$580,($FFFFB014).w
		bcc.s	loc_54B98
		move.w	#$C0,d0

loc_54B98:

		cmp.w	($FFFFEE14).w,d0
		beq.s	locret_54BA2
		move.w	d0,($FFFFEE14).w

locret_54BA2:
		rts
; End of function sub_54B80

; ---------------------------------------------------------------------------

MHZ1_BackgroundInit:
		move.w	($FFFFEE80).w,($FFFFEEB4).w
		move.w	($FFFFEE80).w,($FFFFEEB6).w
		jsr	sub_54C68(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		moveq	#0,d1
		jsr	Refresh_PlaneFull(pc)
		jmp	PlainDeformation(pc)
; ---------------------------------------------------------------------------

MHZ1_BackgroundEvent:
		tst.w	($FFFFEEC6).w
		beq.w	loc_54C3C
		clr.w	($FFFFEEC6).w
		movem.l	d7-a0/a2-a3,-(sp)
		moveq	#$28,d0
		jsr	(Load_PLC).l
		move.w	#$701,($FFFFFE10).w
		clr.b	($FFFFEE33).w
		clr.b	($FFFFF76C).w
		clr.b	($FFFFF710).w
		clr.b	($FFFFF7AA).w
		clr.b	($FFFFFF97).w
		jsr	Clear_Switches(pc)
		jsr	(Load_Level).l
		jsr	(LoadSolids).l
		movem.l	(sp)+,d7-a0/a2-a3
		move.w	#$4200,d0
		moveq	#0,d1
		sub.w	d0,($FFFFB010).w
		sub.w	d0,($FFFFB05A).w
		jsr	sub_54CF4(pc)
		sub.w	d0,($FFFFEE78).w
		sub.w	d0,($FFFFEE80).w
		move.w	($FFFFEE80).w,($FFFFEEB4).w
		sub.w	d0,($FFFFEE14).w
		sub.w	d0,($FFFFEE16).w
		jsr	Reset_TileOffsetPositionActual(pc)
		clr.w	($FFFFEEB2).w
		clr.b	($FFFFEED2).w

loc_54C3C:
		lea	($FFFFEEB4).w,a1
		move.w	($FFFFEE80).w,d0
		move.w	#$100,d2
		move.w	#$200,d3
		jsr	Adjust_BGDuringLoop(pc)
		jsr	sub_54C68(pc)
		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jsr	Draw_TileRow(pc)
		jmp	PlainDeformation(pc)

; =============== S U B R O U T I N E =======================================


sub_54C68:

		move.w	($FFFFEE84).w,d0
		swap	d0
		clr.w	d0
		asr.l	#3,d0
		move.l	d0,d1
		asr.l	#2,d1
		add.l	d1,d0
		swap	d0
		addi.w	#$76,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEEB6).w,d0
		swap	d0
		clr.w	d0
		asr.l	#1,d0
		move.l	d0,d1
		asr.l	#2,d1
		sub.l	d1,d0
		asr.l	#1,d1
		swap	d0
		move.w	d0,($FFFFEE8C).w
		swap	d0
		sub.l	d1,d0
		swap	d0
		move.w	d0,($FFFFEEE2).w
		swap	d0
		sub.l	d1,d0
		swap	d0
		move.w	d0,($FFFFEEE4).w
		rts
; End of function sub_54C68

; ---------------------------------------------------------------------------

loc_54CB0:
		clr.w	($FFFFEEBC).w
		move.w	($FFFFEE78).w,d0
		cmpi.w	#$4400,d0
		bcs.s	loc_54CEE
		move.w	#$200,d1
		move.w	d1,($FFFFEEBC).w
		sub.w	d1,($FFFFB010).w
		sub.w	d1,($FFFFB05A).w
		sub.w	d1,d0
		move.w	d0,d1
		andi.w	#-$10,d1
		subi.w	#$10,d1
		move.w	d1,($FFFFEE88).w

loc_54CDE:
		move.w	d0,($FFFFEE78).w
		move.w	d0,($FFFFEE80).w
		move.w	#$4298,d2
		move.w	d2,($FFFFEE16).w

loc_54CEE:
		move.w	d0,($FFFFEE14).w

locret_54CF2:
		rts

; =============== S U B R O U T I N E =======================================


sub_54CF4:
		lea	($FFFFB128).w,a1
		moveq	#$59,d2

loc_54CFA:
		move.l	(a1),d3
		beq.s	loc_54D26
		cmpi.l	#loc_2B962,d3
		bne.s	loc_54D16
		move.l	#Delete_Current_Sprite,(a1)
		move.w	$48(a1),d3
		beq.s	loc_54D16
		movea.w	d3,a5
		clr.b	(a5)

loc_54D16:

		btst	#2,4(a1)
		beq.s	loc_54D26
		sub.w	d0,$10(a1)
		sub.w	d1,$14(a1)

loc_54D26:

		lea	$4A(a1),a1
		dbf	d2,loc_54CFA
		rts
; End of function sub_54CF4

; ---------------------------------------------------------------------------

MHZ2_ScreenInit:
		move.w	#4,($FFFFEEC0).w
		clr.w	($FFFFEEE8).w
		st	($FFFFF7C1).w
		move.w	($FFFFB010).w,d0
		lea	Pal_MHZ2Gold(pc),a1
		cmpi.w	#$2940,d0
		bcc.s	loc_54D72
		st	($FFFFEED6).w
		lea	(Pal_MHZ2+$20).l,a1
		cmpi.w	#$9C0,d0
		bcc.s	loc_54D72
		cmpi.w	#$600,($FFFFB014).w
		bcs.s	loc_54D72
		clr.b	($FFFFEED6).w
		clr.b	($FFFFF7C1).w
		lea	(Pal_MHZ1+$20).l,a1

loc_54D72:

		lea	($FFFFFC40).w,a5
		lea	($FFFFFCC0).w,a6
		moveq	#$F,d0

loc_54D7C:
		move.l	(a1),(a5)+
		move.l	(a1)+,(a6)+
		dbf	d0,loc_54D7C
		jsr	Reset_TileOffsetPositionActual(pc)
		jmp	Refresh_PlaneFull(pc)
; ---------------------------------------------------------------------------

MHZ2_ScreenEvent:
		move.w	($FFFFEECE).w,d0
		add.w	d0,($FFFFEE80).w
		move.w	($FFFFEEC0).w,d0
		jmp	loc_54D9C(pc,d0.w)
; ---------------------------------------------------------------------------

loc_54D9C:
		bra.w	loc_54DB0
; ---------------------------------------------------------------------------
		bra.w	loc_54DBE
; ---------------------------------------------------------------------------
		bra.w	loc_54E86
; ---------------------------------------------------------------------------
		bra.w	loc_54E9C
; ---------------------------------------------------------------------------
		bra.w	loc_54F64
; ---------------------------------------------------------------------------

loc_54DB0:
		tst.b	($FFFFFAAA).w
		beq.s	loc_54DBA
		addq.w	#4,($FFFFEEC0).w

loc_54DBA:
		jmp	DrawTilesAsYouMove(pc)
; ---------------------------------------------------------------------------

loc_54DBE:
		tst.w	($FFFFEEC4).w
		beq.s	loc_54DDC
		clr.w	($FFFFEEC4).w
		move.w	#$320,($FFFFEEC8).w
		move.w	#$A,($FFFFEECA).w
		addq.w	#8,($FFFFEEC0).w
		bra.w	loc_54E9C
; ---------------------------------------------------------------------------

loc_54DDC:
		cmpi.w	#$3C90,($FFFFEE78).w
		bcs.s	loc_54E00
		bne.w	loc_54E7E
		move.w	#$3C90,($FFFFEE14).w
		cmpi.w	#$280,($FFFFEE7C).w
		bcs.w	loc_54E7E
		move.w	#$280,($FFFFEE18).w
		bra.s	loc_54E7E
; ---------------------------------------------------------------------------

loc_54E00:
		move.w	#$620,d0
		cmpi.w	#$380,($FFFFEE78).w
		bcs.s	loc_54E1A
		moveq	#0,d0
		cmpi.w	#$3600,($FFFFEE78).w
		bcs.s	loc_54E1A
		move.w	#$1A8,d0

loc_54E1A:

		cmp.w	($FFFFEE18).w,d0
		beq.s	loc_54E24
		move.w	d0,($FFFFEE18).w

loc_54E24:
		cmpi.w	#$3600,($FFFFEE78).w
		bcc.s	loc_54E4C
		move.w	#$98,d0
		cmpi.w	#$5C0,($FFFFB014).w
		bcc.s	loc_54E3C
		move.w	#$380,d0

loc_54E3C:
		cmp.w	($FFFFEE14).w,d0
		beq.s	loc_54E4C
		tst.w	($FFFFEEE8).w
		bne.s	loc_54E4C
		move.w	d0,($FFFFEE14).w

loc_54E4C:

		move.w	#$9A0,d0
		cmpi.w	#$3A97,($FFFFB010).w
		bcs.s	loc_54E70
		move.w	#$280,d0
		cmpi.w	#$3AC0,($FFFFB010).w
		bcc.s	loc_54E70
		cmpi.w	#$300,($FFFFB014).w
		bcs.s	loc_54E70
		move.w	#$9A0,d0

loc_54E70:

		cmp.w	($FFFFEE1A).w,d0
		beq.s	loc_54E7E
		move.w	d0,($FFFFEE1A).w
		move.w	d0,($FFFFEE12).w

loc_54E7E:

		bsr.w	sub_55008
		jmp	DrawTilesAsYouMove(pc)
; ---------------------------------------------------------------------------

loc_54E86:
		move.w	($FFFFEE80).w,($FFFFA804).w
		lea	word_550D2(pc),a4
		lea	($FFFFA800).w,a5
		moveq	#$15,d6
		moveq	#2,d5
		jmp	loc_4EDD8(pc)
; ---------------------------------------------------------------------------

loc_54E9C:

		move.w	#$4280,d1
		move.w	#$280,d2
		jsr	Draw_PlaneVertBottomUp(pc)
		bpl.w	locret_54F62
		move.l	#$400000,($FFFFEE98).w
		move.w	#$80,d0
		move.w	d0,($FFFFEEA2).w
		move.w	d0,($FFFFEE9C).w
		jsr	sub_54F8C(pc)
		lea	($FFFFA800).w,a1
		move.w	(a1)+,d0
		andi.w	#-$10,d0
		move.w	d0,(a1)+
		clr.l	(a1)+
		move.w	(a1)+,d0
		andi.w	#-$10,d0
		move.w	d0,(a1)+
		lea	($FFFFFC20).w,a1
		lea	Pal_MHZ2Ship(pc),a5
		moveq	#7,d0

loc_54EE4:
		move.l	(a5)+,(a1)+
		dbf	d0,loc_54EE4
		lea	($FFFFA80C).w,a5
		clr.l	(a5)
		jsr	(Create_New_Sprite).l
		bne.s	loc_54F2A
		move.l	#loc_5583E,(a1)
		move.w	#$4C0,$30(a1)
		move.w	#$4000,$3A(a1)
		jsr	(CreateNewSprite4).l
		bne.s	loc_54F2A
		move.l	#loc_55814,(a1)
		move.w	a1,(a5)+
		jsr	(CreateNewSprite4).l
		bne.s	loc_54F2A
		move.l	#loc_55814,(a1)
		move.w	a1,(a5)+

loc_54F2A:

		movem.l	d7-a0/a2-a3,-(sp)
		lea	(ArtKosM_MHZShipPropeller).l,a1
		move.w	#-$6000,d2
		jsr	(Queue_Kos_Module).l
		movem.l	(sp)+,d7-a0/a2-a3
		move.w	#$4EF9,($FFFFFFF6).w
		move.l	#HInt6,($FFFFFFF8).w
		move.b	#-$80,($FFFFF625).w
		move.w	#-$7FEC,($C00004).l
		addq.w	#4,($FFFFEEC0).w

locret_54F62:
		rts
; ---------------------------------------------------------------------------

loc_54F64:
		jsr	sub_54F8C(pc)
		lea	word_550DA(pc),a4
		lea	($FFFFA800).w,a6
		moveq	#2,d5
		move.w	($FFFFEEA2).w,d6
		jsr	Draw_BGNoVert(pc)
		lea	word_550D6(pc),a4
		lea	($FFFFA804).w,a6
		moveq	#2,d5
		move.w	($FFFFEE8A).w,d6
		jmp	Draw_BGNoVert(pc)

; =============== S U B R O U T I N E =======================================


sub_54F8C:

		move.w	($FFFFEE80).w,d0
		move.w	d0,($FFFFA808).w
		addi.w	#$1E0,d0
		add.w	($FFFFEE98).w,d0
		move.w	($FFFFA800).w,d2
		move.w	d0,($FFFFA800).w
		move.w	($FFFFEE9C).w,d1
		lea	($FFFFB000).w,a1
		cmpi.b	#-$7F,$2E(a1)
		bne.s	loc_54FD4
		move.w	#$2DC,d3
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_54FC4
		move.w	#$2CD,d3

loc_54FC4:
		move.w	($FFFFEEDE).w,d4
		sub.w	d1,d4
		add.w	d4,$14(a1)
		sub.w	d0,d2
		add.w	d2,$10(a1)

loc_54FD4:
		move.w	d1,($FFFFEEDE).w
		neg.w	d1
		addi.w	#$158,d1
		lea	($FFFFA80C).w,a1
		move.w	#$46B8,d2
		bsr.s	sub_54FEC
		move.w	#$45B8,d2
; End of function sub_54F8C


; =============== S U B R O U T I N E =======================================


sub_54FEC:
		move.w	(a1)+,d3
		beq.s	locret_55006
		movea.w	d3,a5
		sub.w	d0,d2
		bcs.s	locret_55006
		addi.w	#$5C,d2
		andi.w	#$1FF,d2
		move.w	d2,$10(a5)
		move.w	d1,$14(a5)

locret_55006:
		rts
; End of function sub_54FEC


; =============== S U B R O U T I N E =======================================


sub_55008:
		lea	word_5513E(pc),a1
		move.w	($FFFFB010).w,d0
		move.w	($FFFFB014).w,d1
		moveq	#0,d2
		move.w	#4,d3

loc_5501A:
		lea	(a1),a5
		cmp.w	(a5)+,d0
		bcs.s	loc_5502C
		cmp.w	(a5)+,d0
		bhi.s	loc_5502C
		cmp.w	(a5)+,d1
		bcs.s	loc_5502C
		cmp.w	(a5)+,d1
		bcs.s	loc_55038

loc_5502C:

		adda.w	#$A,a1
		addq.w	#4,d2
		dbf	d3,loc_5501A
		rts
; ---------------------------------------------------------------------------

loc_55038:
		jmp	loc_5503C(pc,d2.w)
; End of function sub_55008

; ---------------------------------------------------------------------------

loc_5503C:
		bra.w	loc_55050
; ---------------------------------------------------------------------------
		bra.w	loc_55062
; ---------------------------------------------------------------------------
		bra.w	loc_55074
; ---------------------------------------------------------------------------
		bra.w	loc_55074
; ---------------------------------------------------------------------------
		bra.w	loc_55086
; ---------------------------------------------------------------------------

loc_55050:
		tst.w	($FFFFEED6).w
		bne.s	loc_5505C
		cmp.w	(a5),d1
		bcs.s	loc_55098
		rts
; ---------------------------------------------------------------------------

loc_5505C:
		cmp.w	(a5),d1
		bcc.s	loc_550A8
		rts
; ---------------------------------------------------------------------------

loc_55062:
		tst.w	($FFFFEED6).w
		bne.s	loc_5506E
		cmp.w	(a5),d0
		bcc.s	loc_55098
		rts
; ---------------------------------------------------------------------------

loc_5506E:
		cmp.w	(a5),d0
		bcs.s	loc_550A8
		rts
; ---------------------------------------------------------------------------

loc_55074:

		tst.w	($FFFFEED6).w
		bne.s	loc_55080
		cmp.w	(a5),d0
		bcs.s	loc_55098
		rts
; ---------------------------------------------------------------------------

loc_55080:
		cmp.w	(a5),d0
		bcc.s	loc_550B8
		rts
; ---------------------------------------------------------------------------

loc_55086:
		tst.w	($FFFFEED6).w
		bne.s	loc_55092
		cmp.w	(a5),d1
		bcs.s	loc_55098
		rts
; ---------------------------------------------------------------------------

loc_55092:
		cmp.w	(a5),d1
		bcc.s	loc_550B8
		rts
; ---------------------------------------------------------------------------

loc_55098:

		st	($FFFFEED6).w
		st	($FFFFF7C1).w
		lea	(Pal_MHZ2+$20).l,a1
		bra.s	loc_550C4
; ---------------------------------------------------------------------------

loc_550A8:

		clr.w	($FFFFEED6).w
		clr.b	($FFFFF7C1).w
		lea	(Pal_MHZ1+$20).l,a1
		bra.s	loc_550C4
; ---------------------------------------------------------------------------

loc_550B8:

		clr.w	($FFFFEED6).w
		st	($FFFFF7C1).w
		lea	Pal_MHZ2Gold(pc),a1

loc_550C4:

		lea	($FFFFFC40).w,a5
		moveq	#$F,d0

loc_550CA:
		move.l	(a1)+,(a5)+
		dbf	d0,loc_550CA
		rts
; ---------------------------------------------------------------------------
word_550D2:	dc.w $2B0
		dc.w $7FFF
word_550D6:	dc.w $300
		dc.w $7FFF
word_550DA:	dc.w $100
		dc.w $7FFF
Pal_MHZ2Ship:	binclude "Levels\MHZ\Palettes\Act 2 Ship.bin"

Pal_MHZ2Gold:	binclude "Levels\MHZ\Palettes\Act 2 Gold.bin"


word_5513E:	dc.w   $420,  $4A0,  $640,  $6C0
		dc.w   $680,  $980,  $A00,  $7C0
		dc.w   $800,  $9C0, $2900, $2980
		dc.w   $280,  $300, $2940, $2B00
		dc.w  $2B80,  $540,  $580, $2B40
		dc.w  $2800, $2980,  $7C0,  $840
		dc.w   $800
; ---------------------------------------------------------------------------

MHZ2_BackgroundInit:
		move.w	($FFFFEE80).w,($FFFFEEB4).w
		move.w	($FFFFEE80).w,($FFFFEEB6).w
		cmpi.w	#$3700,($FFFFB010).w
		bcs.s	loc_55198
		cmpi.w	#$500,($FFFFB014).w
		bcc.s	loc_55198
		move.w	#8,($FFFFEEC2).w
		jsr	sub_554B8(pc)
		bra.s	loc_5519C
; ---------------------------------------------------------------------------

loc_55198:

		jsr	sub_54C68(pc)

loc_5519C:
		jsr	Reset_TileOffsetPositionEff(pc)
		moveq	#0,d1
		jsr	Refresh_PlaneFull(pc)
		jmp	PlainDeformation(pc)
; ---------------------------------------------------------------------------

MHZ2_BackgroundEvent:
		lea	($FFFFEEB4).w,a1
		move.w	($FFFFEE80).w,d0
		move.w	#$100,d2
		move.w	#$200,d3
		jsr	Adjust_BGDuringLoop(pc)
		move.w	($FFFFEEC2).w,d0
		jmp	loc_551C6(pc,d0.w)
; ---------------------------------------------------------------------------

loc_551C6:
		bra.w	loc_551EE
; ---------------------------------------------------------------------------
		bra.w	loc_55236
; ---------------------------------------------------------------------------
		bra.w	loc_55250
; ---------------------------------------------------------------------------
		bra.w	loc_552F8
; ---------------------------------------------------------------------------
		bra.w	loc_55312
; ---------------------------------------------------------------------------
		bra.w	loc_553B6
; ---------------------------------------------------------------------------
		bra.w	loc_55424
; ---------------------------------------------------------------------------
		bra.w	loc_5543A
; ---------------------------------------------------------------------------
		bra.w	loc_5545A
; ---------------------------------------------------------------------------
		bra.w	loc_55486
; ---------------------------------------------------------------------------

loc_551EE:
		cmpi.w	#$3700,($FFFFB010).w
		bcs.s	loc_5521E
		cmpi.w	#$500,($FFFFB014).w
		bcc.s	loc_5521E
		jsr	sub_554B8(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_5523A
; ---------------------------------------------------------------------------

loc_5521E:

		jsr	sub_54C68(pc)

loc_55222:

		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jsr	Draw_TileRow(pc)
		jmp	PlainDeformation(pc)
; ---------------------------------------------------------------------------

loc_55236:
		jsr	sub_554B8(pc)

loc_5523A:
		moveq	#0,d1
		move.w	($FFFFEE90).w,d2
		jsr	Draw_PlaneVertSingleBottomUp(pc)
		bpl.w	loc_552E4
		addq.w	#4,($FFFFEEC2).w
		bra.w	loc_552E4
; ---------------------------------------------------------------------------

loc_55250:
		cmpi.w	#$500,($FFFFB014).w
		bcs.s	loc_5527A
		jsr	sub_54C68(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		bra.w	loc_552FC
; ---------------------------------------------------------------------------

loc_5527A:
		cmpi.w	#$420,($FFFFB014).w
		bls.s	loc_5528A
		btst	#1,($FFFFB02A).w
		bne.s	loc_552E0

loc_5528A:
		movem.l	d7-a0/a2-a3,-(sp)
		lea	(MHZ_Custom_Layout).l,a1
		lea	($FFFF8000).w,a2
		move.w	#$1FF,d0

loc_5529C:
		move.l	(a1)+,(a2)+
		move.l	(a1)+,(a2)+
		dbf	d0,loc_5529C
		lea	(MHZ_128x128_Custom_Kos).l,a1
		lea	($FFFF2280).l,a2
		jsr	(Queue_Kos).l
		lea	(MHZ_16x16_Custom_Kos).l,a1
		lea	($FFFF9B28).w,a2
		jsr	(Queue_Kos).l
		lea	(ArtKosM_MHZ_Custom).l,a1
		move.w	#$4440,d2
		jsr	(Queue_Kos_Module).l
		movem.l	(sp)+,d7-a0/a2-a3
		addq.w	#8,($FFFFEEC2).w
		bra.s	loc_55312
; ---------------------------------------------------------------------------

loc_552E0:
		jsr	sub_554B8(pc)

loc_552E4:

		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jsr	Draw_TileRow(pc)
		jmp	PlainDeformation(pc)
; ---------------------------------------------------------------------------

loc_552F8:
		jsr	sub_54C68(pc)

loc_552FC:
		moveq	#0,d1
		move.w	($FFFFEE90).w,d2
		jsr	Draw_PlaneVertSingleBottomUp(pc)
		bpl.w	loc_55222
		clr.w	($FFFFEEC2).w
		bra.w	loc_55222
; ---------------------------------------------------------------------------

loc_55312:

		tst.b	($FFFFEED2).w
		bne.s	loc_55380
		cmpi.w	#$3F00,($FFFFEE78).w
		bcs.w	loc_55486
		addq.w	#4,($FFFFEEC0).w
		clr.l	($FFFFA800).w
		move.w	($FFFFEE80).w,d0
		move.w	d0,($FFFFA804).w
		andi.w	#-$10,d0
		move.w	d0,($FFFFA806).w
		move.w	#$1A0,($FFFFEEC8).w
		move.w	#2,($FFFFEECA).w
		st	($FFFFEED2).w
		lea	word_558E8(pc),a1
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_5535A
		lea	$10(a1),a1

loc_5535A:
		move.b	(a1),($FFFFEED9).w
		st	($FFFFEE0A).w
		move.w	#$C,($FFFFEEB2).w
		movem.l	d7-a0/a2-a3,-(sp)
		lea	(ArtKosM_MHZEndBossPillar).l,a1
		move.w	#-$5000,d2
		jsr	(Queue_Kos_Module).l
		movem.l	(sp)+,d7-a0/a2-a3

loc_55380:
		move.w	#$4000,d1
		move.w	#$180,d2
		lea	($FFFF8008).w,a3
		move.w	#-$4000,d7
		jsr	Draw_PlaneVertSingleBottomUp(pc)
		addq.w	#2,a3
		move.w	#-$2000,d7
		tst.w	($FFFFEECA).w
		bpl.w	loc_55486
		move.w	#$80,($FFFFEEC8).w
		move.w	#2,($FFFFEECA).w
		st	($FFFFEED3).w
		addq.w	#4,($FFFFEEC2).w

loc_553B6:
		move.w	#$200,d1
		move.w	#$80,d2
		jsr	Draw_PlaneVertTopDown(pc)
		bpl.w	loc_55486
		lea	($FFFFA808).w,a5
		clr.l	(a5)
		clr.l	4(a5)
		jsr	(Create_New_Sprite).l
		bne.s	loc_55420
		move.l	#loc_556F8,(a1)
		jsr	(CreateNewSprite4).l
		bne.s	loc_55420
		move.l	#loc_55732,(a1)
		move.w	a1,(a5)+
		moveq	#2,d1

loc_553F0:
		jsr	(CreateNewSprite4).l
		bne.s	loc_55420
		move.l	#loc_5577C,(a1)
		move.w	d1,$2E(a1)
		move.w	a1,(a5)+
		jsr	(CreateNewSprite4).l
		bne.s	loc_55420
		move.l	#loc_5577C,(a1)
		move.w	d1,$2E(a1)
		st	$30(a1)
		move.w	a1,(a5)+
		dbf	d1,loc_553F0

loc_55420:

		addq.w	#4,($FFFFEEC2).w

loc_55424:
		tst.w	($FFFFEEC6).w
		bpl.s	loc_55486
		move.w	#$180,($FFFFEEC8).w
		move.w	#2,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w

loc_5543A:
		moveq	#0,d1
		move.w	#$180,d2
		jsr	Draw_PlaneVertTopDown(pc)
		bpl.s	loc_55486
		clr.b	($FFFFEED3).w
		move.w	#$280,($FFFFEEC8).w
		move.w	#2,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w

loc_5545A:
		move.w	#$4080,d1
		move.w	#$280,d2
		lea	($FFFF8008).w,a3
		move.w	#-$4000,d7
		jsr	Draw_PlaneVertTopDown(pc)
		addq.w	#2,a3
		move.w	#-$2000,d7
		tst.w	($FFFFEECA).w
		bpl.s	loc_55486
		clr.b	($FFFFEED2).w
		clr.w	($FFFFEEC0).w
		addq.w	#4,($FFFFEEC2).w

loc_55486:

		jsr	sub_554B8(pc)
		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jsr	Draw_TileRow(pc)
		jsr	sub_5550C(pc)
		cmpi.w	#$10,($FFFFEEC0).w
		bne.s	loc_554B4
		move.w	($FFFFEE9C).w,($FFFFF616).w
		move.w	($FFFFEE90).w,($FFFFF618).w
		addq.w	#4,sp

loc_554B4:
		jmp	ShakeScreen_Setup(pc)

; =============== S U B R O U T I N E =======================================


sub_554B8:

		move.w	($FFFFEE84).w,d0
		subi.w	#$280,d0
		swap	d0
		clr.w	d0
		asr.l	#3,d0
		move.l	d0,d1
		asr.l	#2,d1
		add.l	d1,d0
		swap	d0
		addi.w	#$180,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEEB6).w,d0
		move.w	($FFFFEECE).w,d2
		sub.w	d2,d0
		swap	d0
		clr.w	d0
		asr.l	#1,d0
		move.l	d0,d1
		asr.l	#2,d1
		sub.l	d1,d0
		asr.l	#1,d1
		swap	d0
		add.w	d2,d0
		move.w	d0,($FFFFEE8C).w
		swap	d0
		sub.l	d1,d0
		swap	d0
		move.w	d0,($FFFFEEE2).w
		swap	d0
		sub.l	d1,d0
		swap	d0
		move.w	d0,($FFFFEEE4).w
		rts
; End of function sub_554B8


; =============== S U B R O U T I N E =======================================


sub_5550C:
		jsr	PlainDeformation(pc)
		cmpi.w	#$10,($FFFFEEC0).w
		bne.s	loc_55534
		lea	($FFFFE000).w,a1
		move.w	($FFFFA800).w,d0
		neg.w	d0
		moveq	#$3F,d1

loc_55524:
		move.w	d0,(a1)
		addq.w	#4,a1
		move.w	d0,(a1)
		addq.w	#4,a1
		dbf	d1,loc_55524
		bra.w	locret_5560A
; ---------------------------------------------------------------------------

loc_55534:
		tst.b	($FFFFEED2).w
		beq.s	loc_55552
		lea	($FFFFE000).w,a1
		move.w	($FFFFEE8C).w,d0
		neg.w	d0
		moveq	#$17,d1

loc_55546:
		move.w	d0,(a1)
		addq.w	#4,a1
		move.w	d0,(a1)
		addq.w	#4,a1
		dbf	d1,loc_55546

loc_55552:
		tst.b	($FFFFEED3).w
		beq.w	locret_5560A
		move.w	($FFFFEE78).w,d0
		subi.w	#$4180,d0
		cmpi.w	#-$140,d0
		blt.w	loc_555FC
		move.w	d0,d1
		muls.w	#$5600,d1
		add.l	d1,d1
		swap	d1
		sub.w	d1,d0
		subi.w	#$18,d0
		swap	d0
		clr.w	d0
		tst.l	d0
		smi	d3
		bpl.s	loc_55586
		neg.l	d0

loc_55586:
		moveq	#0,d2
		swap	d0
		move.w	d0,d2
		divu.w	#$30,d2
		move.w	d2,d1
		swap	d0
		move.w	d0,d2
		divu.w	#$30,d2
		swap	d1
		move.w	d2,d1
		tst.b	d3
		beq.s	loc_555A4
		neg.l	d1

loc_555A4:
		lea	($FFFFE002).w,a1
		move.w	($FFFFEE80).w,d0
		subi.w	#$80,d0
		neg.w	d0
		swap	d0
		clr.w	d0
		moveq	#$2F,d2

loc_555B8:
		swap	d0
		move.w	d0,(a1)
		swap	d0
		add.l	d1,d0
		addq.w	#4,a1
		dbf	d2,loc_555B8
		lea	($FFFFA808).w,a1
		lea	($FFFFE0BE).w,a5
		moveq	#$1C,d0
		moveq	#6,d1

loc_555D2:
		move.w	(a1)+,d2
		beq.s	locret_5560A
		movea.w	d2,a6
		move.w	(a5),d2
		subi.w	#$48,d2
		andi.w	#$1FF,d2
		add.w	($FFFFEE78).w,d2
		move.w	d2,$10(a6)
		btst	#0,d1
		bne.s	loc_555F6
		suba.w	d0,a5
		addi.w	#$C,d0

loc_555F6:
		dbf	d1,loc_555D2
		bra.s	locret_5560A
; ---------------------------------------------------------------------------

loc_555FC:
		lea	($FFFFE002).w,a1
		moveq	#$2F,d0

loc_55602:
		clr.w	(a1)
		addq.w	#4,a1
		dbf	d0,loc_55602

locret_5560A:

		rts
; End of function sub_5550C

; ---------------------------------------------------------------------------

loc_5560C:
		clr.w	($FFFFEEBC).w
		move.w	($FFFFEE78).w,d0
		addq.w	#4,d0
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_55620
		addq.w	#1,d0

loc_55620:
		cmpi.w	#$4280,d0
		bcs.s	loc_5569A
		tst.w	($FFFFEEC6).w
		beq.s	loc_5564A
		st	($FFFFEEC6).w
		cmpi.w	#$4420,d0
		bcs.s	loc_5569A
		move.w	#$4420,d0
		move.w	#$45A0,($FFFFEE16).w
		st	($FFFFEE0A).w
		clr.w	($FFFFEEB2).w
		bra.s	loc_5569E
; ---------------------------------------------------------------------------

loc_5564A:
		move.w	#$200,d1
		move.w	d1,($FFFFEEBC).w
		sub.w	d1,($FFFFB010).w
		sub.w	d1,($FFFFB05A).w
		sub.w	d1,d0
		move.w	d0,d1
		andi.w	#-$10,d1
		subi.w	#$10,d1
		move.w	d1,($FFFFEE88).w
		addq.w	#1,($FFFFEEDA).w
		move.w	($FFFFEEDA).w,d1
		andi.w	#$F,d1
		lea	word_558E8(pc),a1
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_55686
		lea	$10(a1),a1

loc_55686:
		move.b	(a1,d1.w),($FFFFEED9).w
		tst.b	($FFFFFAA9).w
		beq.s	loc_5569A
		st	($FFFFEEDC).w
		clr.b	($FFFFFAA9).w

loc_5569A:

		move.w	d0,($FFFFEE16).w

loc_5569E:
		move.w	d0,($FFFFEE78).w
		move.w	d0,($FFFFEE80).w
		move.w	d0,($FFFFEE14).w
		move.w	d0,d1
		lea	($FFFFB000).w,a1
		bsr.s	sub_556B8
		move.w	d1,d0
		lea	($FFFFB04A).w,a1

; =============== S U B R O U T I N E =======================================


sub_556B8:
		cmpi.b	#5,$20(a1)
		bne.s	loc_556C4
		clr.b	$20(a1)

loc_556C4:
		addi.w	#$18,d0
		cmp.w	$10(a1),d0
		bls.s	loc_556E8
		move.w	d0,$10(a1)
		move.w	#$400,$1C(a1)
		cmpi.w	#3,($FFFFFF08).w
		bne.s	locret_556F6
		move.w	#$500,$1C(a1)
		bra.s	locret_556F6
; ---------------------------------------------------------------------------

loc_556E8:
		addi.w	#$A8,d0
		cmp.w	$10(a1),d0
		bhi.s	locret_556F6
		move.w	d0,$10(a1)

locret_556F6:

		rts
; End of function sub_556B8

; ---------------------------------------------------------------------------

loc_556F8:
		move.l	#loc_5576A,(a0)
		move.b	#4,4(a0)
		move.b	#$18,6(a0)
		move.b	#$18,7(a0)
		move.w	#$80,8(a0)
		move.w	#-$1A80,$A(a0)
		move.l	#Map_MHZEndBossMisc,$C(a0)
		move.w	#$4238,$10(a0)
		move.w	#$2F0,$14(a0)
		bra.s	loc_5576A
; ---------------------------------------------------------------------------

loc_55732:
		move.l	#loc_5576A,(a0)
		move.b	#$44,4(a0)
		move.b	#-$80,6(a0)
		move.b	#$C,7(a0)
		move.w	#$380,8(a0)
		move.w	#$6580,$A(a0)
		move.l	#Map_MHZEndBossMisc,$C(a0)
		move.w	#$300,$14(a0)
		move.b	#1,$22(a0)

loc_5576A:

		tst.b	($FFFFEED3).w
		bne.s	loc_55776
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_55776:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5577C:

		move.l	#loc_557C8,(a0)
		move.b	#$44,4(a0)
		move.b	#$10,6(a0)
		move.b	#$10,7(a0)
		move.w	#$23AF,$A(a0)
		move.l	#Map_MHZEndBossMisc,$C(a0)
		move.b	#-$75,$28(a0)
		move.w	#$80,d0
		moveq	#4,d1
		move.w	$2E(a0),d2
		subq.w	#1,d2
		bcs.s	loc_557C0

loc_557B6:
		addi.w	#$80,d0
		subq.w	#1,d1
		dbf	d2,loc_557B6

loc_557C0:
		move.w	d0,8(a0)
		move.b	d1,$22(a0)

loc_557C8:
		tst.w	($FFFFEEDC).w
		bne.s	loc_557D4
		tst.b	($FFFFEED3).w
		bne.s	loc_557DA

loc_557D4:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_557DA:
		move.w	($FFFFEED8).w,d0
		tst.w	$30(a0)
		beq.s	loc_557EC
		cmpi.w	#4,d0
		bne.s	locret_55812
		moveq	#0,d0

loc_557EC:
		lsl.w	#2,d0
		add.w	$2E(a0),d0
		add.w	d0,d0
		lea	word_558C2(pc),a1
		move.w	(a1,d0.w),$14(a0)
		jsr	(Draw_Sprite).l
		cmpi.w	#1,$2E(a0)
		bne.s	locret_55812
		jmp	(Add_SpriteToCollisionResponseList).l
; ---------------------------------------------------------------------------

locret_55812:

		rts
; ---------------------------------------------------------------------------

loc_55814:

		move.l	#loc_5582E,(a0)
		move.w	#$380,8(a0)
		move.w	#-$5B00,$A(a0)
		move.l	#Map_MHZEndBossMisc,$C(a0)

loc_5582E:
		lea	Ani_MHZEndPropellers(pc),a1
		jsr	(Animate_Sprite).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5583E:
		addq.b	#1,$3C(a0)
		addi.l	#$C0,$38(a0)
		move.l	$38(a0),d0
		sub.l	d0,($FFFFEE98).w
		tst.w	($FFFFEEC4).w
		beq.s	loc_55876
		cmpi.l	#$2800,$2E(a0)
		bne.s	loc_55876
		move.w	$32(a0),d0
		move.b	$3C(a0),d1
		andi.w	#3,d1
		bne.s	loc_55888
		addq.w	#1,$32(a0)
		bra.s	loc_55888
; ---------------------------------------------------------------------------

loc_55876:

		move.l	#$2800,d0
		move.l	#$C0,d1
		jsr	(Gradual_SwingOffset).l

loc_55888:

		add.w	($FFFFEEA2).w,d0
		addq.w	#5,d0
		move.w	d0,($FFFFEE9C).w
		tst.b	($FFFFFAA9).w
		bne.s	loc_558AC
		cmpi.w	#-$3E6,($FFFFEE98).w
		bgt.s	loc_558AC
		st	($FFFFFAA9).w
		st	($FFFFEEC4).w
		st	($FFFFEE0A).w

loc_558AC:

		move.w	($FFFFFE04).w,d0
		subq.w	#1,d0
		andi.w	#$F,d0
		bne.s	locret_558C0
		moveq	#-$43,d0
		jsr	(Play_Sound_2).l

locret_558C0:
		rts
; ---------------------------------------------------------------------------
word_558C2:	dc.w $336
		dc.w $334
		dc.w $333
		dc.w 0
		dc.w $320
		dc.w $320
		dc.w $320
		dc.w 0
		dc.w $2F6
		dc.w $2F8
		dc.w $2FA
		dc.w 0
		dc.w $2C9
		dc.w $2CF
		dc.w $2D4
		dc.w 0
		dc.w $2C9
		dc.w $2CF
		dc.w $2D4
word_558E8:	dc.w $102

		dc.w 2
		dc.w $102
		dc.w $100
		dc.w $200
		dc.w $102
		dc.w $102
		dc.w $200
		dc.w $102
		dc.w 3
		dc.w $104
		dc.w $200
		dc.w $401
		dc.w $304
		dc.w $200
		dc.w $402
Map_MHZEndBossMisc:	include "Levels\MHZ\Misc Object Data\Map - End Boss Misc.asm"

Ani_MHZEndPropellers:	include "Levels\MHZ\Misc Object Data\Anim - End Propellers.asm"

; ---------------------------------------------------------------------------

SOZ1_ScreenInit:
		jsr	Reset_TileOffsetPositionActual(pc)
		jmp	Refresh_PlaneFull(pc)
; ---------------------------------------------------------------------------

SOZ1_ScreenEvent:
		move.w	($FFFFEECE).w,d0
		add.w	d0,($FFFFEE84).w
		jmp	DrawTilesAsYouMove(pc)
; ---------------------------------------------------------------------------

SOZ1_BackgroundInit:
		move.w	(a3),$1C(a3)
		movea.w	$18(a3),a1
		move.b	#-3,$D(a1)
		jsr	sub_55D56(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		moveq	#0,d1
		jsr	(Refresh_PlaneFull).l
		jmp	loc_55DF2(pc)
; ---------------------------------------------------------------------------

SOZ1_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_55A82(pc,d0.w)
; ---------------------------------------------------------------------------

loc_55A82:
		bra.w	loc_55A9A
; ---------------------------------------------------------------------------
		bra.w	loc_55B04
; ---------------------------------------------------------------------------
		bra.w	loc_55B70
; ---------------------------------------------------------------------------
		bra.w	loc_55BCE
; ---------------------------------------------------------------------------
		bra.w	loc_55C26
; ---------------------------------------------------------------------------
		bra.w	loc_55C84
; ---------------------------------------------------------------------------

loc_55A9A:
		tst.w	($FFFFEEC6).w
		beq.s	loc_55ACE
		clr.w	($FFFFEEC6).w
		move.w	#-8,($FFFFEE9C).w
		st	($FFFFEECC).w
		jsr	sub_55DB6(pc)
		jsr	Reset_TileOffsetPositionEff(pc)
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_55B08
; ---------------------------------------------------------------------------

loc_55ACE:
		move.w	#$B20,d0
		cmpi.w	#$4000,($FFFFB010).w
		bcs.s	loc_55ADE
		move.w	#$960,d0

loc_55ADE:
		move.w	d0,($FFFFEE1A).w
		move.w	d0,($FFFFEE12).w
		jsr	sub_55E96(pc)
		jsr	sub_55D56(pc)
		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jsr	(Draw_TileRow).l
		jmp	loc_55DF2(pc)
; ---------------------------------------------------------------------------

loc_55B04:
		jsr	sub_55DB6(pc)

loc_55B08:
		move.w	($FFFFEE8C).w,d1
		move.w	($FFFFEE90).w,d2
		jsr	Draw_PlaneVertBottomUp(pc)
		bpl.w	loc_55BA2
		movem.l	d7-a0/a2-a3,-(sp)
		lea	(SOZ1_16x16_Custom_Kos).l,a1
		lea	($FFFF9EA0).w,a2
		jsr	(Queue_Kos).l
		lea	(ArtKosM_SOZ1_Custom).l,a1
		move.w	#$62A0,d2
		jsr	(Queue_Kos_Module).l
		movem.l	(sp)+,d7-a0/a2-a3
		jsr	(Create_New_Sprite).l
		bne.s	loc_55B6A
		move.l	#loc_55F48,(a1)
		jsr	(CreateNewSprite4).l
		bne.s	loc_55B6A
		move.l	#loc_55F98,(a1)
		jsr	(CreateNewSprite4).l
		bne.s	loc_55B6A
		move.l	#loc_55FDA,(a1)

loc_55B6A:

		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_55BA2
; ---------------------------------------------------------------------------

loc_55B70:
		cmpi.w	#$55,($FFFFEEC6).w
		bne.s	loc_55B9E
		move.w	#$4378,d0
		cmp.w	($FFFFB010).w,d0
		bhi.s	loc_55B9E
		cmpi.w	#$9A8,($FFFFB014).w
		bcs.s	loc_55B9E
		tst.w	($FFFFFF08).w
		bne.s	loc_55BB4
		cmp.w	($FFFFB05A).w,d0
		bcs.s	loc_55BB4
		cmpi.w	#$9A8,($FFFFB05E).w
		bcc.s	loc_55BB4

loc_55B9E:

		jsr	sub_55D94(pc)

loc_55BA2:

		jsr	(DrawBGAsYouMove).l
		jsr	sub_55EBE(pc)
		jsr	sub_55E4C(pc)
		jmp	ShakeScreen_Setup(pc)
; ---------------------------------------------------------------------------

loc_55BB4:

		move.w	#$F,($FFFFF626).w
		move.w	#$15,($FFFFEED6).w
		move.w	#$10,($FFFFEED8).w
		st	($FFFFEE50).w
		addq.w	#4,($FFFFEEC2).w

loc_55BCE:
		tst.w	($FFFFEED8).w
		beq.s	loc_55BE0
		subq.w	#1,($FFFFEED8).w
		bne.s	loc_55BFE
		st	($FFFFEED4).w
		bra.s	loc_55BFE
; ---------------------------------------------------------------------------

loc_55BE0:
		tst.w	($FFFFEED4).w
		bne.s	loc_55BFE
		btst	#0,($FFFFFE05).w
		beq.s	loc_55BFE
		move.l	a0,-(sp)
		jsr	(Pal_ToBlack).l
		movea.l	(sp)+,a0
		subq.w	#1,($FFFFEED6).w
		bmi.s	loc_55C10

loc_55BFE:

		jsr	sub_55D94(pc)
		jsr	(DrawBGAsYouMove).l
		jsr	sub_55EBE(pc)
		jmp	sub_55E4C(pc)
; ---------------------------------------------------------------------------

loc_55C10:
		move.w	#$401F,($FFFFF626).w
		move.w	#$15,($FFFFEED6).w
		move.w	#8,($FFFFEED8).w
		addq.w	#4,($FFFFEEC2).w

loc_55C26:
		tst.w	($FFFFEED8).w
		beq.s	loc_55C32
		subq.w	#1,($FFFFEED8).w
		bra.s	loc_55C4A
; ---------------------------------------------------------------------------

loc_55C32:
		btst	#0,($FFFFFE05).w
		beq.s	loc_55C4A
		move.l	a0,-(sp)
		jsr	(Pal_ToBlack).l
		movea.l	(sp)+,a0
		subq.w	#1,($FFFFEED6).w
		bmi.s	loc_55C4E

loc_55C4A:

		jmp	sub_55E4C(pc)
; ---------------------------------------------------------------------------

loc_55C4E:
		movem.l	d7-a0/a2-a3,-(sp)
		lea	(SOZ2_16x16_Secondary_Kos).l,a1
		lea	($FFFF9EA0).w,a2
		jsr	(Queue_Kos).l
		lea	(ArtKosM_SOZ2_Secondary).l,a1
		move.w	#$62A0,d2
		jsr	(Queue_Kos_Module).l
		moveq	#$2C,d0
		jsr	(Load_PLC).l
		movem.l	(sp)+,d7-a0/a2-a3
		addq.w	#4,($FFFFEEC2).w
		rts
; ---------------------------------------------------------------------------

loc_55C84:
		tst.b	($FFFFFF60).w
		bne.w	locret_55D54
		move.w	#$801,($FFFFFE10).w
		clr.b	($FFFFEE33).w
		clr.b	($FFFFF76C).w
		clr.b	($FFFFF710).w
		clr.b	($FFFFF7AA).w
		clr.b	($FFFFFF97).w
		jsr	Clear_Switches(pc)
		movem.l	d7-a0/a2-a3,-(sp)
		jsr	(Load_Level).l
		jsr	(LoadSolids).l
		moveq	#3,d0
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_55CC6
		moveq	#5,d0

loc_55CC6:
		jsr	(LoadPalette).l
		moveq	#$1B,d0
		jsr	(LoadPalette).l
		moveq	#$1B,d0
		jsr	(LoadPalette_Immediate).l
		movem.l	(sp)+,d7-a0/a2-a3
		jsr	sub_55EFC(pc)
		lea	($FFFFFC40).w,a1
		moveq	#$F,d0

loc_55CEA:
		clr.l	(a1)+
		dbf	d0,loc_55CEA
		move.w	($FFFFB010).w,d2
		sub.w	($FFFFB05A).w,d2
		move.w	($FFFFB014).w,d3
		sub.w	($FFFFB05E).w,d3
		move.w	#$140,d0
		move.w	#$3AC,d1
		move.w	d0,($FFFFB010).w
		move.w	d1,($FFFFB014).w
		sub.w	d2,d0
		sub.w	d3,d1
		move.w	d0,($FFFFB05A).w
		move.w	d1,($FFFFB05E).w
		move.w	#$A0,d0
		move.w	#$34C,d1
		move.w	d0,($FFFFEE78).w
		move.w	d1,($FFFFEE7C).w
		move.w	d0,($FFFFEE80).w
		move.w	d1,($FFFFEE84).w
		move.w	d0,($FFFFEE14).w
		move.w	d0,($FFFFEE16).w
		move.w	d1,($FFFFEE18).w
		move.w	d1,($FFFFEE1A).w
		move.w	d1,($FFFFEE12).w
		clr.l	($FFFFEED4).w
		clr.w	($FFFFEEC6).w
		clr.w	($FFFFEEC2).w

locret_55D54:
		rts

; =============== S U B R O U T I N E =======================================


sub_55D56:

		move.w	($FFFFEE84).w,d0
		asr.w	#4,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEE80).w,d0
		swap	d0
		clr.w	d0
		asr.l	#4,d0
		move.l	d0,d1
		asr.l	#1,d1
		swap	d0
		move.w	d0,($FFFFEE8C).w
		swap	d0
		swap	d1
		move.w	d1,($FFFFEEE2).w
		swap	d1
		asr.l	#1,d1
		lea	($FFFFA800).w,a1
		moveq	#6,d2

loc_55D86:
		swap	d0
		move.w	d0,(a1)+
		swap	d0
		add.l	d1,d0
		dbf	d2,loc_55D86
		rts
; End of function sub_55D56


; =============== S U B R O U T I N E =======================================


sub_55D94:

		tst.w	($FFFFEECC).w
		bpl.s	sub_55DB6
		move.w	($FFFFFE04).w,d0
		andi.w	#3,d0
		beq.s	sub_55DB6
		addq.w	#1,($FFFFEE9C).w
		cmpi.w	#$280,($FFFFEE9C).w
		blt.s	sub_55DB6
		move.w	#8,($FFFFEECC).w
; End of function sub_55D94


; =============== S U B R O U T I N E =======================================


sub_55DB6:
		tst.w	($FFFFEECC).w
		bpl.s	loc_55DD0
		move.w	($FFFFFE04).w,d0
		subq.w	#1,d0
		andi.w	#$F,d0
		bne.s	loc_55DD0
		moveq	#$6F,d0
		jsr	(Play_Sound_2).l

loc_55DD0:

		move.w	($FFFFEE84).w,d0
		subi.w	#$900,d0
		add.w	($FFFFEE9C).w,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEE80).w,d0
		subi.w	#$3CD0,d0
		move.w	d0,($FFFFEE8C).w
		move.w	d0,($FFFFEEE2).w
		rts
; End of function sub_55DB6

; ---------------------------------------------------------------------------

loc_55DF2:

		lea	($FFFFA810).w,a1
		lea	word_5077E(pc),a6
		move.w	($FFFFEE84).w,d0
		move.w	#$DF,d1
		move.w	($FFFFFE04).w,d2
		asr.w	#1,d2
		add.w	d0,d2
		add.w	d0,d2
		andi.w	#$3E,d2
		adda.w	d2,a6
		move.w	($FFFFEE80).w,d6
		neg.w	d6
		jsr	sub_4F0B6(pc)
		lea	($FFFFE000).w,a1
		lea	($FFFFA810).w,a2
		lea	word_560DC(pc),a4
		lea	($FFFFA800).w,a5
		lea	word_5077E(pc),a6
		move.w	($FFFFEE90).w,d0
		move.w	#$DF,d1
		move.w	($FFFFFE04).w,d2
		asr.w	#1,d2
		add.w	d0,d2
		add.w	d0,d2
		andi.w	#$3E,d2
		adda.w	d2,a6
		jmp	ApplyFGandBGDeformation(pc)

; =============== S U B R O U T I N E =======================================


sub_55E4C:

		lea	($FFFFE000).w,a1
		lea	word_5077E(pc),a6
		move.w	($FFFFEE84).w,d0
		move.w	($FFFFFE04).w,d1
		asr.w	#1,d1
		add.w	d0,d1
		add.w	d0,d1
		andi.w	#$3E,d1
		adda.w	d1,a6
		move.w	($FFFFEE80).w,d0
		neg.w	d0
		move.w	($FFFFEE8C).w,d1
		neg.w	d1
		move.w	#$6F,d2

loc_55E78:
		move.w	(a6)+,d3
		move.w	d3,d4
		add.w	d0,d3
		add.w	d1,d4
		move.w	d3,(a1)+
		move.w	d4,(a1)+
		move.w	(a6)+,d3
		move.w	d3,d4
		add.w	d0,d3
		add.w	d1,d4
		move.w	d3,(a1)+
		move.w	d4,(a1)+
		dbf	d2,loc_55E78
		rts
; End of function sub_55E4C


; =============== S U B R O U T I N E =======================================


sub_55E96:
		move.w	($FFFFEE1A).w,d0
		cmpi.w	#$960,d0
		bne.s	locret_55EBC
		cmp.w	($FFFFEE7C).w,d0
		bhi.s	locret_55EBC
		move.w	d0,($FFFFEE18).w
		cmpi.w	#$4310,($FFFFEE78).w
		bcs.s	locret_55EBC
		move.w	#$4180,($FFFFEE14).w
		st	($FFFFEEC6).w

locret_55EBC:
		rts
; End of function sub_55E96


; =============== S U B R O U T I N E =======================================


sub_55EBE:

		move.w	($FFFFEED2).w,d0
		beq.s	locret_55EFA
		clr.w	($FFFFEED2).w
		movea.w	$18(a3),a1
		move.b	d0,$D(a1)
		cmpi.w	#$540,($FFFFEE8C).w
		bcs.s	locret_55EFA
		move.w	#$6A0,d1
		move.w	#$320,d0
		moveq	#5,d6
		moveq	#5,d2

loc_55EE4:
		movem.w	d0-d2/d6,-(sp)
		jsr	(Setup_TileRowDraw).l
		movem.w	(sp)+,d0-d2/d6
		addi.w	#$10,d0
		dbf	d2,loc_55EE4

locret_55EFA:

		rts
; End of function sub_55EBE


; =============== S U B R O U T I N E =======================================


sub_55EFC:
		lea	($FFFFFC42).w,a1
		lea	($FFFFFCC2).w,a5
		lea	word_560EA(pc),a6
		moveq	#$A,d0

loc_55F0A:
		move.w	(a6),(a1)+
		move.w	(a6)+,(a5)+
		dbf	d0,loc_55F0A
		lea	($FFFFFC62).w,a1
		lea	($FFFFFCE2).w,a5
		lea	word_56100(pc),a6
		moveq	#$E,d0

loc_55F20:
		move.w	(a6),(a1)+
		move.w	(a6)+,(a5)+
		dbf	d0,loc_55F20
		move.b	#5,($FFFFF7C3).w
		move.w	#$707,($FFFFF634).w
		move.b	#0,($FFFFF650).w
		move.w	#4,($FFFFF656).w
		move.w	#$D0,($FFFFF652).w
		rts
; End of function sub_55EFC

; ---------------------------------------------------------------------------

loc_55F48:
		moveq	#0,d0
		move.b	5(a0),d0
		jmp	loc_55F52(pc,d0.w)
; ---------------------------------------------------------------------------

loc_55F52:
		bra.w	loc_55F5E
; ---------------------------------------------------------------------------
		bra.w	loc_55F6E
; ---------------------------------------------------------------------------
		bra.w	loc_55F7C
; ---------------------------------------------------------------------------

loc_55F5E:
		tst.w	($FFFFEECC).w
		bne.s	locret_55F96
		move.w	#$3C,$2E(a0)
		addq.b	#4,5(a0)

loc_55F6E:
		subq.w	#1,$2E(a0)
		bne.s	locret_55F96
		st	($FFFFEED4).w
		addq.b	#4,5(a0)

loc_55F7C:
		tst.w	($FFFFEED4).w
		bne.s	locret_55F96
		jsr	(Create_New_Sprite).l
		bne.s	loc_55F90
		move.l	#Obj_SOZ_Miniboss,(a1)

loc_55F90:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

locret_55F96:

		rts
; ---------------------------------------------------------------------------

loc_55F98:
		move.l	#loc_55FBE,(a0)
		move.b	#4,4(a0)
		move.b	#$24,7(a0)
		move.w	#$200,8(a0)
		move.l	#Map_SOZ1EndDoor,$C(a0)
		move.w	#$A00,$14(a0)

loc_55FBE:
		tst.b	($FFFFFE11).w
		beq.s	loc_55FCA
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_55FCA:
		move.w	($FFFFEE78).w,$10(a0)
		st	($FFFFEF3A).w
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_55FDA:
		move.l	#loc_56012,(a0)
		move.b	#4,4(a0)
		move.b	#$24,7(a0)
		move.w	#$380,8(a0)
		move.w	#-$3FD7,$A(a0)
		move.l	#Map_SOZ1EndDoor,$C(a0)
		move.w	#$439C,$18(a0)
		move.w	#$9D4,$1A(a0)
		move.b	#1,$22(a0)

loc_56012:

		bclr	#7,4(a0)
		tst.w	($FFFFEED4).w
		bne.s	loc_56020
		rts
; ---------------------------------------------------------------------------

loc_56020:
		moveq	#-$71,d0
		jsr	(Play_Sound_2).l
		move.w	#$F6,($FFFFEED2).w
		move.l	#loc_56034,(a0)

loc_56034:
		moveq	#1,d0
		bsr.s	sub_560A2
		cmpi.w	#$58,$2E(a0)
		bcs.s	loc_56050
		move.w	#$58,$2E(a0)
		clr.w	($FFFFEED4).w
		move.l	#loc_56056,(a0)

loc_56050:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_56056:
		tst.b	($FFFFFE11).w
		beq.s	loc_56062
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_56062:
		bclr	#7,4(a0)
		tst.w	($FFFFEED4).w
		bne.s	loc_56070
		rts
; ---------------------------------------------------------------------------

loc_56070:
		moveq	#-$71,d0
		jsr	(Play_Sound_2).l
		move.l	#loc_5607E,(a0)

loc_5607E:
		moveq	#-1,d0
		bsr.s	sub_560A2
		tst.w	$2E(a0)
		bpl.s	loc_5609C
		clr.w	$2E(a0)
		move.w	#$FD,($FFFFEED2).w
		clr.w	($FFFFEED4).w
		move.l	#loc_56012,(a0)

loc_5609C:
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_560A2:

		move.w	($FFFFFE04).w,d1
		andi.w	#3,d1
		bne.s	loc_560AE
		add.w	d0,d0

loc_560AE:
		add.w	d0,$2E(a0)
		move.w	$1A(a0),d0
		add.w	$2E(a0),d0
		move.w	d0,$14(a0)
		lea	ScreenShakeArray2(pc),a1
		move.w	$2E(a0),d0
		andi.w	#$3F,d0
		move.b	(a1,d0.w),d0
		andi.w	#1,d0
		add.w	$18(a0),d0
		move.w	d0,$10(a0)
		rts
; End of function sub_560A2

; ---------------------------------------------------------------------------
word_560DC:	dc.w $110
		dc.w 8
		dc.w 8
		dc.w 8
		dc.w 8
		dc.w 8
		dc.w $7FFF
word_560EA:	dc.w   $C46,  $824,  $804,  $402,  $202,  $200,	    0,	$422,  $402,  $200,   $40

word_56100:	dc.w   $6AE,  $664,  $422,  $402,  $200,     0,	    0,	$EEE,  $466,  $224,	0,   $46,  $6EE,  $48C,	 $26A

Map_SOZ1EndDoor:	include "Levels\SOZ\Misc Object Data\Map - Act 1 End Door.asm"

; ---------------------------------------------------------------------------

SOZ2_ScreenInit:
		move.w	#$7FF,($FFFFEEAA).w
		move.w	#$7F0,($FFFFEEAC).w
		move.w	#$3C,($FFFFEEAE).w
		move.w	#8,($FFFFEEC0).w
		cmpi.w	#$4E80,($FFFFB010).w
		bcs.s	loc_561B0
		jsr	sub_5622C(pc)

loc_561B0:
		jsr	(Reset_TileOffsetPositionActual).l
		jmp	(Refresh_PlaneFull).l
; ---------------------------------------------------------------------------

SOZ2_ScreenEvent:
		move.w	($FFFFEECE).w,d0
		add.w	d0,($FFFFEE84).w
		move.w	($FFFFEEC0).w,d0
		jmp	loc_561CC(pc,d0.w)
; ---------------------------------------------------------------------------

loc_561CC:
		bra.w	loc_561D8
; ---------------------------------------------------------------------------
		bra.w	loc_56206
; ---------------------------------------------------------------------------
		bra.w	loc_5621A
; ---------------------------------------------------------------------------

loc_561D8:
		move.w	#$7FF,($FFFFEEAA).w
		move.w	#$7F0,($FFFFEEAC).w
		move.w	#$3C,($FFFFEEAE).w
		jsr	(Reset_TileOffsetPositionActual).l
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC0).w

loc_56206:
		move.w	($FFFFEE80).w,d1
		move.w	($FFFFEE84).w,d2
		jsr	(Draw_PlaneVertBottomUp).l
		bpl.s	loc_5621A
		addq.w	#4,($FFFFEEC0).w

loc_5621A:

		tst.w	($FFFFEEC4).w
		beq.s	loc_56226
		clr.w	($FFFFEEC4).w
		bsr.s	sub_5622C

loc_56226:
		jmp	(DrawTilesAsYouMove).l

; =============== S U B R O U T I N E =======================================


sub_5622C:

		movea.w	$1C(a3),a1
		lea	$AB(a1),a5
		lea	$95(a1),a1
		move.b	(a5)+,(a1)+
		move.b	(a5)+,(a1)+
		move.b	(a5)+,(a1)+
		move.b	(a5)+,(a1)+
		movea.w	$28(a3),a1
		lea	$AB(a1),a5
		lea	$8C(a1),a1
		move.w	-8(a3),d0
		subi.w	#9,d0
		moveq	#3,d1

loc_56256:
		moveq	#8,d2

loc_56258:
		move.b	(a5)+,(a1)+
		dbf	d2,loc_56258
		adda.w	d0,a1
		adda.w	d0,a5
		dbf	d1,loc_56256
		rts
; End of function sub_5622C

; ---------------------------------------------------------------------------

SOZ2_BackgroundInit:
		jsr	sub_5697E(pc)
		moveq	#$10,d0
		cmpi.w	#$2980,($FFFFB010).w
		bcs.s	loc_56278
		moveq	#$20,d0

loc_56278:
		move.w	d0,($FFFFEEC2).w
		jsr	sub_566D2(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		moveq	#0,d1
		jsr	(Refresh_PlaneFull).l
		jmp	(PlainDeformation).l
; ---------------------------------------------------------------------------

SOZ2_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_5629C(pc,d0.w)
; ---------------------------------------------------------------------------

loc_5629C:
		bra.w	loc_562D0
; ---------------------------------------------------------------------------
		bra.w	loc_56300
; ---------------------------------------------------------------------------
		bra.w	loc_56324
; ---------------------------------------------------------------------------
		bra.w	loc_56366
; ---------------------------------------------------------------------------
		bra.w	loc_563A6
; ---------------------------------------------------------------------------
		bra.w	loc_5641C
; ---------------------------------------------------------------------------
		bra.w	loc_5645E
; ---------------------------------------------------------------------------
		bra.w	loc_564B8
; ---------------------------------------------------------------------------
		bra.w	loc_564D4
; ---------------------------------------------------------------------------
		bra.w	loc_565C6
; ---------------------------------------------------------------------------
		bra.w	loc_565DE
; ---------------------------------------------------------------------------
		bra.w	loc_56676
; ---------------------------------------------------------------------------
		bra.w	loc_566A4
; ---------------------------------------------------------------------------

loc_562D0:
		cmpi.w	#8,($FFFFEEC0).w
		bcs.s	locret_562FE
		jsr	sub_5697E(pc)
		jsr	sub_566D2(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_56304
; ---------------------------------------------------------------------------

locret_562FE:
		rts
; ---------------------------------------------------------------------------

loc_56300:
		jsr	sub_566D2(pc)

loc_56304:
		moveq	#0,d1
		move.w	($FFFFEE90).w,d2
		jsr	(Draw_PlaneVertBottomUp).l
		bpl.w	loc_563C0
		move.w	#$F,($FFFFF626).w
		move.w	#$15,($FFFFEED2).w
		addq.w	#4,($FFFFEEC2).w

loc_56324:
		btst	#0,($FFFFFE05).w
		beq.s	loc_563A6
		cmpi.w	#5,($FFFFEED2).w
		bne.s	loc_56346
		jsr	(Create_New_Sprite).l
		bne.s	loc_56346
		move.l	#Obj_TitleCard,(a1)
		st	$3E(a1)

loc_56346:

		move.l	a0,-(sp)
		jsr	(Pal_FromBlack).l
		movea.l	(sp)+,a0
		subq.w	#1,($FFFFEED2).w
		bpl.s	loc_563A6
		move.w	#$401F,($FFFFF626).w
		move.w	#$15,($FFFFEED2).w
		addq.w	#4,($FFFFEEC2).w

loc_56366:
		btst	#0,($FFFFFE05).w
		beq.s	loc_563A6
		move.l	a0,-(sp)
		jsr	(Pal_FromBlack).l
		movea.l	(sp)+,a0
		subq.w	#1,($FFFFEED2).w
		bpl.s	loc_563A6
		move.l	#$6000,d0
		move.l	d0,($FFFFEE14).w
		move.l	d0,($FFFFEE0C).w
		move.l	#-$FFF800,d0
		move.l	d0,($FFFFEE18).w
		move.l	d0,($FFFFEE10).w
		clr.w	($FFFFEE50).w
		clr.w	($FFFFF7CA).w
		addq.w	#4,($FFFFEEC2).w

loc_563A6:

		jsr	sub_5699A(pc)
		beq.s	loc_563B6
		move.w	#$18,($FFFFEEC2).w
		bra.w	loc_56484
; ---------------------------------------------------------------------------

loc_563B6:
		tst.w	($FFFFEEC6).w
		bne.s	loc_563D8
		jsr	sub_566D2(pc)

loc_563C0:
		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jsr	(Draw_TileRow).l
		jmp	(PlainDeformation).l
; ---------------------------------------------------------------------------

loc_563D8:
		clr.w	($FFFFEEC6).w
		addq.w	#4,($FFFFEEC2).w
		moveq	#0,d0
		move.w	#$80,d0
		cmpi.w	#$400,($FFFFB014).w
		bcs.s	loc_563F6
		addq.w	#4,($FFFFEEC2).w
		move.w	#$3E0,d0

loc_563F6:
		swap	d0
		move.l	d0,($FFFFEE9C).w
		jsr	sub_566E8(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		subi.w	#$10,($FFFFEE96).w
		move.w	#$10,($FFFFEEB2).w
		cmpi.w	#$14,($FFFFEEC2).w
		beq.s	loc_56440
		bra.s	loc_56474
; ---------------------------------------------------------------------------

loc_5641C:
		jsr	sub_5699A(pc)
		beq.s	loc_5642A
		move.w	#$18,($FFFFEEC2).w
		bra.s	loc_56484
; ---------------------------------------------------------------------------

loc_5642A:
		tst.w	($FFFFEEC6).w
		bne.s	loc_56450
		cmpi.w	#$400,($FFFFEE9C).w
		bcs.s	loc_5643C
		clr.w	($FFFFEEB2).w

loc_5643C:
		jsr	sub_566E8(pc)

loc_56440:
		jsr	(DrawBGAsYouMove).l
		jsr	(PlainDeformation).l
		jmp	Go_CheckPlayerRelease(pc)
; ---------------------------------------------------------------------------

loc_56450:
		clr.w	($FFFFEEC6).w
		move.w	#$10,($FFFFEEB2).w
		addq.w	#4,($FFFFEEC2).w

loc_5645E:
		jsr	sub_5699A(pc)
		bne.s	loc_56484
		cmpi.w	#$A00,($FFFFEE9C).w
		bcs.s	loc_56470
		clr.w	($FFFFEEB2).w

loc_56470:
		jsr	sub_566E8(pc)

loc_56474:
		jsr	(DrawBGAsYouMove).l
		jsr	(PlainDeformation).l
		jmp	Go_CheckPlayerRelease(pc)
; ---------------------------------------------------------------------------

loc_56484:

		move.w	($FFFFEE8C).w,($FFFFEED4).w
		move.w	($FFFFEE90).w,($FFFFEED6).w
		jsr	sub_566D2(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		move.w	#$1F0,($FFFFEEC8).w
		move.w	#$1F,($FFFFEECA).w
		clr.w	($FFFFEEC6).w
		clr.w	($FFFFEEB2).w
		clr.b	($FFFFF664).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_564BC
; ---------------------------------------------------------------------------

loc_564B8:
		jsr	sub_566D2(pc)

loc_564BC:
		move.w	($FFFFEE90).w,d1
		moveq	#0,d2
		jsr	(Draw_PlaneHorzRightToLeft).l
		bpl.s	loc_564E8
		clr.w	($FFFFEED4).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_564E8
; ---------------------------------------------------------------------------

loc_564D4:
		cmpi.w	#$5000,($FFFFB010).w
		bcs.s	loc_564E4
		cmpi.w	#$500,($FFFFEE7C).w
		bcc.s	loc_56510

loc_564E4:
		jsr	sub_566D2(pc)

loc_564E8:

		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jsr	(Draw_TileRow).l
		move.w	($FFFFEED4).w,d0
		beq.s	loc_5650A
		move.w	d0,($FFFFEE8C).w
		move.w	($FFFFEED6).w,($FFFFEE90).w

loc_5650A:
		jmp	(PlainDeformation).l
; ---------------------------------------------------------------------------

loc_56510:
		move.w	#$5250,($FFFFEEDE).w
		move.w	#$6D8,($FFFFEEE0).w
		movea.w	(a3),a1
		move.w	-8(a3),d0
		subq.w	#4,d0
		moveq	#0,d1
		moveq	#$F,d2

loc_56528:
		moveq	#3,d3

loc_5652A:
		move.b	(a1),4(a1)
		move.b	d1,(a1)+
		dbf	d3,loc_5652A
		adda.w	d0,a1
		dbf	d2,loc_56528
		lea	($FFFFA800).w,a1
		moveq	#$7F,d2

loc_56540:
		move.l	d1,(a1)+
		dbf	d2,loc_56540
		jsr	sub_56706(pc)
		lea	($FFFFA800).w,a1
		moveq	#$C,d0

loc_56550:
		move.w	(a1)+,(a1)
		andi.w	#-$10,(a1)+
		dbf	d0,loc_56550
		move.w	#$500,($FFFFEE18).w
		move.w	#$680,d0
		move.w	d0,($FFFFEE1A).w
		move.w	d0,($FFFFEE12).w
		move.w	#$5140,($FFFFEE16).w
		movem.l	d7-a0/a2-a3,-(sp)
		lea	(SOZ2_16x16_Custom_Kos).l,a1
		lea	($FFFF9EA0).w,a2
		jsr	(Queue_Kos).l
		lea	(ArtKosM_SOZ2_Custom).l,a1
		move.w	#$62A0,d2
		jsr	(Queue_Kos_Module).l
		movem.l	(sp)+,d7-a0/a2-a3
		move.w	#$7FFF,($FFFFF634).w
		move.b	#0,($FFFFF7C3).w
		move.w	($FFFFF656).w,d0
		neg.b	d0
		move.b	d0,($FFFFF650).w
		move.w	#0,($FFFFF658).w
		move.b	#$7F,($FFFFF7F0).w
		jsr	sub_56A12(pc)
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_565F4
; ---------------------------------------------------------------------------

loc_565C6:
		move.w	($FFFFEE84).w,d0
		cmp.w	($FFFFEE18).w,d0
		beq.s	loc_565D4
		move.w	d0,($FFFFEE18).w

loc_565D4:
		cmp.w	($FFFFEE1A).w,d0
		bne.s	loc_565DE
		addq.w	#4,($FFFFEEC2).w

loc_565DE:

		move.w	#$7FFF,($FFFFF634).w
		move.b	#$7F,($FFFFF7F0).w
		tst.w	($FFFFEEC6).w
		bmi.s	loc_5661A
		jsr	sub_56706(pc)

loc_565F4:
		lea	word_56AB8(pc),a4
		lea	($FFFFA800).w,a5
		moveq	#$20,d6
		moveq	#$D,d5
		jsr	(Draw_BG).l
		lea	word_56AB8(pc),a4
		lea	($FFFFA900).w,a5
		jsr	(ApplyDeformation).l
		jmp	(ShakeScreen_Setup).l
; ---------------------------------------------------------------------------

loc_5661A:
		move.w	($FFFFEE8C).w,d0
		subi.w	#$100,d0
		move.w	d0,($FFFFEED4).w
		jsr	sub_56964(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		movem.l	d7-a0/a2-a3,-(sp)
		lea	(SOZ2_16x16_Secondary_Kos).l,a1
		lea	($FFFF9EA0).w,a2
		jsr	(Queue_Kos).l
		lea	(ArtKosM_SOZ2_Secondary).l,a1
		move.w	#$62A0,d2
		jsr	(Queue_Kos_Module).l
		moveq	#$1B,d0
		jsr	(LoadPalette_Immediate).l
		movem.l	(sp)+,d7-a0/a2-a3
		addq.w	#4,($FFFFEEC2).w

loc_56676:
		tst.b	($FFFFFF60).w
		bne.s	loc_566BC
		jsr	sub_56964(pc)
		move.w	#$200,d1
		move.w	($FFFFEE90).w,d2
		jsr	(Draw_PlaneVertBottomUp).l
		bpl.s	loc_566A8
		clr.w	($FFFFEED4).w
		move.w	#$52C0,($FFFFEE16).w
		clr.b	($FFFFF7F0).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_566A8
; ---------------------------------------------------------------------------

loc_566A4:
		jsr	sub_56964(pc)

loc_566A8:

		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		move.w	#$200,d1
		moveq	#$20,d6
		jsr	(Draw_TileRow).l

loc_566BC:
		move.w	($FFFFEED4).w,d0
		beq.s	loc_566C6
		move.w	d0,($FFFFEE8C).w

loc_566C6:
		jsr	(PlainDeformation).l
		jmp	(ShakeScreen_Setup).l

; =============== S U B R O U T I N E =======================================


sub_566D2:

		move.w	($FFFFEE84).w,d0
		asr.w	#1,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEE80).w,d0
		asr.w	#1,d0
		move.w	d0,($FFFFEE8C).w
		rts
; End of function sub_566D2


; =============== S U B R O U T I N E =======================================


sub_566E8:

		move.w	($FFFFEE84).w,d0
		addi.w	#$2E0,d0
		add.w	($FFFFEE9C).w,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEE80).w,d0
		subi.w	#$1930,d0
		move.w	d0,($FFFFEE8C).w
		rts
; End of function sub_566E8


; =============== S U B R O U T I N E =======================================


sub_56706:

		move.w	($FFFFEE84).w,d0
		subi.w	#$250,d0
		move.w	#$6D8,d1
		sub.w	($FFFFEEE0).w,d1
		add.w	d1,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEE80).w,d0
		subi.w	#$4010,d0
		move.w	#$5250,d1
		sub.w	($FFFFEEDE).w,d1
		add.w	d1,d0
		move.w	d0,($FFFFEE8C).w
		cmpi.b	#6,($FFFFB005).w
		bcc.w	loc_56936
		move.w	($FFFFEEDA).w,d0
		jmp	loc_56744(pc,d0.w)
; ---------------------------------------------------------------------------

loc_56744:
		bra.w	loc_5675C
; ---------------------------------------------------------------------------
		bra.w	loc_5678A
; ---------------------------------------------------------------------------
		bra.w	loc_567B0
; ---------------------------------------------------------------------------
		bra.w	loc_5680A
; ---------------------------------------------------------------------------
		bra.w	loc_5687C
; ---------------------------------------------------------------------------
		bra.w	loc_56904
; ---------------------------------------------------------------------------

loc_5675C:
		jsr	loc_568DE(pc)
		tst.w	($FFFFEEDC).w
		beq.w	loc_56936
		lea	($FFFFA934).w,a1
		moveq	#-1,d0
		moveq	#8,d1

loc_56770:
		move.w	d0,-(a1)
		subq.w	#1,d0
		dbf	d1,loc_56770
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		move.w	#3,($FFFFEED8).w
		addq.w	#4,($FFFFEEDA).w

loc_5678A:
		jsr	loc_568DE(pc)
		subq.w	#1,($FFFFEED8).w
		bpl.w	loc_56936
		lea	($FFFFA934).w,a1
		moveq	#-1,d0
		moveq	#8,d1

loc_5679E:
		move.w	d0,-(a1)
		subq.w	#2,d0
		dbf	d1,loc_5679E
		move.w	#8,($FFFFEED8).w
		addq.w	#4,($FFFFEEDA).w

loc_567B0:
		jsr	loc_568DE(pc)
		subq.w	#1,($FFFFEED8).w
		bpl.w	loc_56936
		lea	($FFFFA984).w,a1
		lea	$3E(a1),a5
		lea	word_56AE2(pc),a6
		move.w	($FFFFEEDC).w,d0
		sub.w	($FFFFEE84).w,d0
		add.w	($FFFFEE90).w,d0
		subi.w	#$440,d0
		bcc.s	loc_567DC
		moveq	#0,d0

loc_567DC:
		lsr.w	#3,d0
		andi.w	#-2,d0
		cmpi.w	#$10,d0
		bls.s	loc_567EA
		moveq	#$10,d0

loc_567EA:
		suba.w	d0,a6
		moveq	#8,d1

loc_567EE:
		move.l	#$80000,(a1)+
		move.w	(a6)+,(a5)+
		dbf	d1,loc_567EE
		clr.w	($FFFFEED2).w
		moveq	#$59,d0
		jsr	(Play_Sound_2).l
		addq.w	#4,($FFFFEEDA).w

loc_5680A:
		jsr	loc_568DE(pc)
		lea	($FFFFA944).w,a1
		lea	$40(a1),a5
		lea	$3E(a5),a6
		moveq	#9,d0
		moveq	#8,d1

loc_5681E:
		tst.b	(a6)
		beq.s	loc_5682C
		bpl.s	loc_56828
		subq.w	#1,d0
		bra.s	loc_5683A
; ---------------------------------------------------------------------------

loc_56828:
		subq.b	#1,(a6)
		bra.s	loc_5683A
; ---------------------------------------------------------------------------

loc_5682C:
		move.l	(a5),d2
		sub.l	d2,(a1)
		subi.l	#$2800,(a5)
		bpl.s	loc_5683A
		st	(a6)

loc_5683A:

		addq.w	#4,a1
		addq.w	#4,a5
		addq.w	#2,a6
		dbf	d1,loc_5681E
		tst.w	d0
		beq.s	loc_56868
		cmpi.w	#9,d0
		beq.w	loc_56936
		tst.w	($FFFFEED2).w
		bne.w	loc_56936
		moveq	#-$6D,d0
		jsr	(Play_Sound_2).l
		st	($FFFFEED2).w
		bra.w	loc_56936
; ---------------------------------------------------------------------------

loc_56868:
		lea	($FFFFA922).w,a1
		moveq	#8,d1

loc_5686E:
		clr.w	(a1)+
		dbf	d1,loc_5686E
		clr.w	($FFFFEED8).w
		addq.w	#4,($FFFFEEDA).w

loc_5687C:
		jsr	loc_568DE(pc)
		tst.w	($FFFFEED8).w
		beq.s	loc_5689A
		subq.w	#1,($FFFFEED8).w
		bne.w	loc_56936
		clr.w	($FFFFEEDC).w
		clr.w	($FFFFEEDA).w
		bra.w	loc_56936
; ---------------------------------------------------------------------------

loc_5689A:
		lea	($FFFFA944).w,a1
		lea	$40(a1),a5
		lea	$3F(a5),a6
		moveq	#9,d0
		moveq	#8,d1

loc_568AA:
		tst.b	(a6)
		beq.s	loc_568B8
		bpl.s	loc_568B4
		subq.w	#1,d0
		bra.s	loc_568C8
; ---------------------------------------------------------------------------

loc_568B4:
		subq.b	#1,(a6)
		bra.s	loc_568C8
; ---------------------------------------------------------------------------

loc_568B8:
		move.l	(a5),d2
		subi.l	#$2800,(a5)
		sub.l	d2,(a1)
		bmi.s	loc_568C8
		clr.l	(a1)
		st	(a6)

loc_568C8:

		addq.w	#4,a1
		addq.w	#4,a5
		addq.w	#2,a6
		dbf	d1,loc_568AA
		tst.w	d0
		bne.s	loc_56936
		move.w	#$F,($FFFFEED8).w
		bra.s	loc_56936
; ---------------------------------------------------------------------------

loc_568DE:

		tst.w	($FFFFEEC6).w
		bne.s	loc_568E6
		rts
; ---------------------------------------------------------------------------

loc_568E6:
		lea	($FFFFA9C2).w,a1
		moveq	#0,d0
		moveq	#$B,d1

loc_568EE:
		move.w	d0,(a1)+
		addq.w	#5,d0
		dbf	d1,loc_568EE
		move.w	#$5140,($FFFFEE16).w
		move.w	#$14,($FFFFEEDA).w
		addq.w	#4,sp

loc_56904:
		lea	($FFFFA944).w,a1
		lea	$7E(a1),a5
		moveq	#$C,d0
		moveq	#$B,d1

loc_56910:
		tst.w	(a5)
		beq.s	loc_56918
		subq.w	#1,(a5)
		bra.s	loc_56926
; ---------------------------------------------------------------------------

loc_56918:
		subq.w	#5,(a1)
		cmpi.w	#-$100,(a1)
		bgt.s	loc_56926
		move.w	#-$100,(a1)
		subq.w	#1,d0

loc_56926:

		addq.w	#4,a1
		addq.w	#2,a5
		dbf	d1,loc_56910
		tst.w	d0
		bne.s	loc_56936
		st	($FFFFEEC6).w

loc_56936:

		move.l	a0,-(sp)
		lea	($FFFFA800).w,a0
		lea	$100(a0),a1
		lea	$20(a1),a5
		lea	$20(a5),a6
		move.w	($FFFFEE8C).w,d0
		moveq	#$C,d1

loc_5694E:
		move.w	(a5)+,d2
		add.w	(a6),d2
		add.w	d0,d2
		move.w	d2,(a0)
		move.w	d2,(a1)+
		addq.w	#4,a0
		addq.w	#4,a6
		dbf	d1,loc_5694E
		movea.l	(sp)+,a0
		rts
; End of function sub_56706


; =============== S U B R O U T I N E =======================================


sub_56964:

		move.w	($FFFFEE84).w,d0
		asr.w	#1,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEE80).w,d0
		asr.w	#1,d0
		addi.w	#$200,d0
		move.w	d0,($FFFFEE8C).w
		rts
; End of function sub_56964


; =============== S U B R O U T I N E =======================================


sub_5697E:

		movea.w	$38(a3),a5
		movea.w	$3C(a3),a6
		lea	$17(a5),a5
		lea	$17(a6),a6
		moveq	#9,d0

loc_56990:
		clr.b	(a5)+
		clr.b	(a6)+
		dbf	d0,loc_56990
		rts
; End of function sub_5697E


; =============== S U B R O U T I N E =======================================


sub_5699A:

		cmpi.w	#$2A00,($FFFFB010).w
		bcs.s	loc_569B6
		move.w	($FFFFB014).w,d0
		cmpi.w	#$140,d0
		bcs.s	loc_569B6
		cmpi.w	#$180,d0
		bhi.s	loc_569B6
		moveq	#-1,d0
		rts
; ---------------------------------------------------------------------------

loc_569B6:

		moveq	#0,d0
		rts
; End of function sub_5699A

; ---------------------------------------------------------------------------

loc_569BA:
		st	($FFFFF664).w
		addi.l	#$A000,($FFFFEE9C).w
		move.w	#$2E0,d0
		add.w	($FFFFEE9C).w,d0
		neg.w	d0
		move.w	d0,($FFFFEE40).w
		move.w	#$1930,($FFFFEE3E).w
		rts
; ---------------------------------------------------------------------------

Go_CheckPlayerRelease:

		movem.l	d7-a0/a2-a3,-(sp)
		lea	($FFFFB000).w,a1
		btst	#3,$2A(a1)
		beq.s	loc_569F6
		movea.w	$42(a1),a0
		jsr	(CheckPlayerReleaseFromObj).l

loc_569F6:
		lea	($FFFFB04A).w,a1
		btst	#3,$2A(a1)
		beq.s	loc_56A0C
		movea.w	$42(a1),a0
		jsr	(CheckPlayerReleaseFromObj).l

loc_56A0C:
		movem.l	(sp)+,d7-a0/a2-a3
		rts

; =============== S U B R O U T I N E =======================================


sub_56A12:
		jsr	(Create_New_Sprite).l
		bne.s	locret_56A32
		move.l	#loc_56A34,d1
		moveq	#7,d2

loc_56A22:
		move.l	d1,(a1)
		move.w	d2,$2C(a1)
		jsr	(CreateNewSprite4).l
		dbne	d2,loc_56A22

locret_56A32:
		rts
; End of function sub_56A12

; ---------------------------------------------------------------------------

loc_56A34:
		move.b	#$40,7(a0)
		bset	#7,$2A(a0)
		move.w	$2C(a0),d0
		lsl.w	#4,d0
		addi.w	#$458,d0
		sub.w	($FFFFEE90).w,d0
		add.w	($FFFFEE84).w,d0
		move.w	d0,$14(a0)
		move.w	$2C(a0),d0
		add.w	d0,d0
		lea	word_56AF4(pc),a1
		move.w	(a1,d0.w),d4
		add.w	d0,d0
		lea	($FFFFA808).w,a1
		sub.w	(a1,d0.w),d4
		add.w	($FFFFEE80).w,d4
		cmpi.w	#$10,($FFFFEEDA).w
		beq.s	loc_56A7E
		move.w	#$7FFF,d4

loc_56A7E:
		move.w	d4,$10(a0)
		moveq	#$4B,d1
		moveq	#8,d2
		moveq	#8,d3
		jsr	(SolidObjectFull2).l
		move.w	#-$300,d0
		lea	($FFFFB000).w,a1
		btst	#$10,d6
		beq.s	loc_56AA4
		move.w	d0,$18(a1)
		move.w	d0,$1A(a1)

loc_56AA4:
		lea	($FFFFB04A).w,a1
		btst	#$11,d6
		beq.s	locret_56AB6
		move.w	d0,$18(a1)
		move.w	d0,$1A(a1)

locret_56AB6:
		rts
; ---------------------------------------------------------------------------
word_56AB8:	dc.w $440

		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $7FFF
		dc.w $1800
		dc.w $1502
		dc.w $1204
		dc.w $F06
		dc.w $C08
		dc.w $90A
		dc.w $60C
		dc.w $30E
word_56AE2:	dc.w $10
		dc.w $30E
		dc.w $60C
		dc.w $90A
		dc.w $C08
		dc.w $F06
		dc.w $1204
		dc.w $1502
		dc.w $1800
word_56AF4:	dc.w $1268
		dc.w $1260
		dc.w $1260
		dc.w $125C
		dc.w $1254
		dc.w $1248
		dc.w $1248
		dc.w $1248
; ---------------------------------------------------------------------------

LRZ1_ScreenInit:
		jsr	(Reset_TileOffsetPositionActual).l
		jmp	(Refresh_PlaneFull).l
; ---------------------------------------------------------------------------

LRZ1_ScreenEvent:
		move.w	($FFFFEECE).w,d0
		add.w	d0,($FFFFEE84).w
		move.w	($FFFFEEDE).w,d0
		beq.s	loc_56B5E
		bmi.s	loc_56B2C
		movea.w	$40(a3),a1
		move.b	#-$64,$A(a1)
		bra.s	loc_56B54
; ---------------------------------------------------------------------------

loc_56B2C:
		movea.w	$38(a3),a1
		lea	$1D(a1),a1
		move.b	#$44,(a1)+
		move.b	#0,(a1)+
		move.b	#$4A,(a1)
		movea.w	$3C(a3),a1
		lea	$1D(a1),a1
		move.b	#$3E,(a1)+
		move.b	#0,(a1)+
		move.b	#$4B,(a1)

loc_56B54:
		clr.w	($FFFFEEDE).w
		jmp	(Refresh_PlaneScreenDirect).l
; ---------------------------------------------------------------------------

loc_56B5E:
		jmp	(DrawTilesAsYouMove).l
; ---------------------------------------------------------------------------

LRZ1_BackgroundInit:
		move.w	(a3),d0
		move.w	#$1C,d1
		moveq	#$18,d2

loc_56B6C:
		move.w	d0,(a3,d1.w)
		addq.w	#4,d1
		dbf	d2,loc_56B6C
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_56B88
		movea.w	4(a3),a1
		move.b	#-$A,4(a1)

loc_56B88:
		jsr	sub_56D40(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		clr.l	($FFFFA800).w
		move.w	d2,($FFFFA806).w
		clr.l	($FFFFA808).w
		lea	word_56F68(pc),a4
		lea	($FFFFA800).w,a5
		jsr	(Refresh_PlaneTileDeform).l
		lea	word_56F6E(pc),a4
		lea	($FFFFA80C).w,a5
		jmp	(ApplyDeformation).l
; ---------------------------------------------------------------------------

LRZ1_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_56BC2(pc,d0.w)
; ---------------------------------------------------------------------------

loc_56BC2:
		bra.w	loc_56BD2
; ---------------------------------------------------------------------------
		bra.w	loc_56C6E
; ---------------------------------------------------------------------------
		bra.w	loc_56C88
; ---------------------------------------------------------------------------
		bra.w	loc_56CAA
; ---------------------------------------------------------------------------

loc_56BD2:
		tst.w	($FFFFEEC6).w
		beq.s	loc_56C28
		clr.w	($FFFFEEC6).w
		movem.l	d7-a0/a2-a3,-(sp)
		lea	(LRZ2_128x128_Secondary_Kos).l,a1
		lea	($FFFF0180).l,a2
		jsr	(Queue_Kos).l
		lea	(LRZ2_16x16_Secondary_Kos).l,a1
		lea	($FFFF9128).w,a2
		jsr	(Queue_Kos).l
		lea	(ArtKosM_LRZ2_Secondary).l,a1
		move.w	#$1200,d2
		jsr	(Queue_Kos_Module).l
		moveq	#$30,d0
		jsr	(Load_PLC).l
		movem.l	(sp)+,d7-a0/a2-a3
		move.w	#$C,($FFFFEEC2).w
		bra.w	loc_56D16
; ---------------------------------------------------------------------------

loc_56C28:
		jsr	sub_56DCA(pc)
		jsr	sub_56D40(pc)

loc_56C30:

		lea	word_56F68(pc),a4
		lea	($FFFFA800).w,a5
		moveq	#$20,d6
		moveq	#3,d5
		jsr	(Draw_BG).l
		move.l	($FFFFEED4).w,d0
		beq.s	loc_56C5A
		move.w	d0,($FFFFEE90).w
		swap	d0
		move.w	d0,($FFFFEE8C).w
		jsr	(PlainDeformation).l
		bra.s	loc_56C68
; ---------------------------------------------------------------------------

loc_56C5A:
		lea	word_56F6E(pc),a4
		lea	($FFFFA80C).w,a5
		jsr	(ApplyDeformation).l

loc_56C68:
		jmp	(ShakeScreen_Setup).l
; ---------------------------------------------------------------------------

loc_56C6E:
		jsr	sub_56DCA(pc)
		jsr	sub_56DAC(pc)

loc_56C76:
		jsr	(DrawBGAsYouMove).l
		jsr	(PlainDeformation).l
		jmp	(ShakeScreen_Setup).l
; ---------------------------------------------------------------------------

loc_56C88:
		jsr	sub_56D40(pc)

loc_56C8C:
		lea	word_56F68(pc),a4
		lea	($FFFFA7FC).w,a5
		move.w	($FFFFEE90).w,d1
		jsr	(Draw_PlaneVertBottomUpComplex).l
		bpl.s	loc_56C30
		clr.l	($FFFFEED4).w
		clr.w	($FFFFEEC2).w
		bra.s	loc_56C30
; ---------------------------------------------------------------------------

loc_56CAA:
		tst.b	($FFFFFF60).w
		bne.s	loc_56D16
		move.w	#$901,($FFFFFE10).w
		clr.b	($FFFFEE33).w
		clr.b	($FFFFF76C).w
		clr.b	($FFFFF710).w
		clr.b	($FFFFF7AA).w

loc_56CC6:
		clr.b	($FFFFFF97).w
		jsr	(Clear_Switches).l
		clr.b	($FFFFFE65).w
		movem.l	d7-a0/a2-a3,-(sp)

loc_56CD8:
		jsr	(Load_Level).l
		jsr	(LoadSolids).l
		movem.l	(sp)+,d7-a0/a2-a3
		move.w	#$2C00,d0
		moveq	#0,d1
		sub.w	d0,($FFFFB010).w
		sub.w	d0,($FFFFB05A).w
		jsr	(Offset_ObjectsDuringTransition).l
		sub.w	d0,($FFFFEE78).w
		sub.w	d0,($FFFFEE80).w
		sub.w	d0,($FFFFEE14).w
		sub.w	d0,($FFFFEE16).w
		jsr	(Reset_TileOffsetPositionActual).l
		clr.w	($FFFFEEC2).w

loc_56D16:

		jsr	sub_56D40(pc)
		lea	word_56F68(pc),a4
		lea	($FFFFA800).w,a5
		moveq	#$20,d6
		moveq	#3,d5
		jsr	(Draw_BG).l
		lea	word_56F6E(pc),a4
		lea	($FFFFA80C).w,a5
		jsr	(ApplyDeformation).l
		jmp	(ShakeScreen_Setup).l

; =============== S U B R O U T I N E =======================================


sub_56D40:

		move.w	($FFFFEE84).w,d0
		move.w	($FFFFEECE).w,d1
		sub.w	d1,d0
		asr.w	#3,d0
		add.w	d1,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEE80).w,d0
		swap	d0
		clr.w	d0
		asr.l	#3,d0
		move.l	d0,d1
		move.l	d0,d2
		asr.l	#2,d0
		swap	d1
		move.w	d1,($FFFFEE8C).w
		move.w	d1,($FFFFA804).w
		swap	d1
		sub.l	d0,d1
		swap	d1
		move.w	d1,($FFFFEEE2).w
		swap	d1
		sub.l	d0,d1
		swap	d1
		move.w	d1,($FFFFEEE4).w
		lea	($FFFFA81C).w,a1
		move.l	d2,d1
		moveq	#7,d3

loc_56D88:
		swap	d1
		move.w	d1,-(a1)
		swap	d1
		add.l	d0,d1
		dbf	d3,loc_56D88
		lea	($FFFFA81C).w,a1
		add.l	d0,d2
		add.l	d0,d0
		moveq	#4,d3

loc_56D9E:
		swap	d2
		move.w	d2,(a1)+
		swap	d2
		add.l	d0,d2
		dbf	d3,loc_56D9E
		rts
; End of function sub_56D40


; =============== S U B R O U T I N E =======================================


sub_56DAC:

		move.w	($FFFFEE84).w,d0
		subi.w	#$788,d0
		add.w	($FFFFEE9C).w,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEE80).w,d0
		subi.w	#$1500,d0
		move.w	d0,($FFFFEE8C).w
		rts
; End of function sub_56DAC


; =============== S U B R O U T I N E =======================================


sub_56DCA:

		lea	word_56F88(pc),a1
		move.w	($FFFFB010).w,d0
		move.w	($FFFFB014).w,d1
		moveq	#0,d2
		move.w	#2,d3

loc_56DDC:
		lea	(a1),a5
		cmp.w	(a5)+,d0
		bcs.s	loc_56DEE
		cmp.w	(a5)+,d0
		bhi.s	loc_56DEE
		cmp.w	(a5)+,d1
		bcs.s	loc_56DEE
		cmp.w	(a5)+,d1
		bcs.s	loc_56DFA

loc_56DEE:

		adda.w	#$A,a1
		addq.w	#4,d2
		dbf	d3,loc_56DDC
		rts
; ---------------------------------------------------------------------------

loc_56DFA:
		jmp	loc_56DFE(pc,d2.w)
; End of function sub_56DCA

; ---------------------------------------------------------------------------

loc_56DFE:
		bra.w	loc_56E0A
; ---------------------------------------------------------------------------
		bra.w	loc_56E1C
; ---------------------------------------------------------------------------
		bra.w	loc_56E2E
; ---------------------------------------------------------------------------

loc_56E0A:
		tst.w	($FFFFEED2).w
		bne.s	loc_56E16
		cmp.w	(a5),d0
		bcc.s	loc_56E40
		rts
; ---------------------------------------------------------------------------

loc_56E16:
		cmp.w	(a5),d0
		bcs.s	loc_56E66
		rts
; ---------------------------------------------------------------------------

loc_56E1C:
		tst.w	($FFFFEED2).w
		bne.s	loc_56E28
		cmp.w	(a5),d0
		bcs.s	loc_56E40
		rts
; ---------------------------------------------------------------------------

loc_56E28:
		cmp.w	(a5),d0
		bcc.s	loc_56E66
		rts
; ---------------------------------------------------------------------------

loc_56E2E:
		tst.w	($FFFFEED2).w
		bne.s	loc_56E3A
		cmp.w	(a5),d1
		bcc.s	loc_56E40
		rts
; ---------------------------------------------------------------------------

loc_56E3A:
		cmp.w	(a5),d1
		bcs.s	loc_56E66
		rts
; ---------------------------------------------------------------------------

loc_56E40:

		st	($FFFFEED2).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_56E52
		move.l	#Obj_56EA0,(a1)

loc_56E52:
		jsr	sub_56DAC(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		addq.w	#4,($FFFFEEC2).w
		addq.w	#4,sp
		jmp	loc_56C76(pc)
; ---------------------------------------------------------------------------

loc_56E66:

		clr.w	($FFFFEED2).w
		move.w	($FFFFEE8C).w,($FFFFEED4).w
		move.w	($FFFFEE90).w,($FFFFEED6).w
		jsr	sub_56D40(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		move.w	d2,($FFFFA806).w
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		addq.w	#4,sp
		jmp	loc_56C8C(pc)
; ---------------------------------------------------------------------------

Obj_56EA0:
		move.l	#loc_56EC2,(a0)
		move.b	#-$80,6(a0)
		move.w	#$1E80,$10(a0)
		bset	#7,$2A(a0)
		move.w	#-$4000,$34(a0)
		clr.w	($FFFFEE9C).w

loc_56EC2:
		tst.w	($FFFFEED2).w
		bne.s	loc_56ECE
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_56ECE:
		move.l	$2E(a0),d0
		move.l	$32(a0),d1
		move.l	#-$100,d2
		tst.b	$36(a0)
		beq.s	loc_56EF6
		neg.l	d2
		add.l	d1,d0
		bmi.s	loc_56F0A
		moveq	#0,d0
		move.l	#$C000,d1
		clr.b	$36(a0)
		bra.s	loc_56F0C
; ---------------------------------------------------------------------------

loc_56EF6:
		add.l	d1,d0
		beq.s	loc_56EFC
		bpl.s	loc_56F0A

loc_56EFC:
		moveq	#0,d0
		move.l	#-$C000,d1
		st	$36(a0)
		bra.s	loc_56F0C
; ---------------------------------------------------------------------------

loc_56F0A:

		add.l	d2,d1

loc_56F0C:

		move.l	d1,$32(a0)
		move.l	d0,$2E(a0)
		swap	d0
		move.w	d0,($FFFFEE9C).w
		neg.w	d0
		addi.w	#$988,d0
		move.w	d0,$14(a0)
		move.w	#$280,d1
		move.w	#$80,d2
		move.w	#$6C,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		btst	#3,$2A(a0)
		beq.s	loc_56F54
		lea	($FFFFB000).w,a1
		btst	#4,$2B(a1)
		bne.s	loc_56F54
		jsr	(sub_24280).l

loc_56F54:

		btst	#4,$2A(a0)
		beq.s	locret_56F66
		lea	($FFFFB04A).w,a1
		jsr	(sub_24280).l

locret_56F66:
		rts
; ---------------------------------------------------------------------------
word_56F68:	dc.w $B0

		dc.w $100
		dc.w $7FFF
word_56F6E:	dc.w $40

		dc.w $20
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $100
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $20
		dc.w $7FFF
word_56F88:	dc.w  $1AC0, $1B40,  $840,  $8C0
		dc.w  $1B00, $2240, $2340,  $840
		dc.w   $880, $22C0, $20C0, $2180
		dc.w   $740,  $800,  $7A0
; ---------------------------------------------------------------------------

LRZ2_ScreenInit:
		jsr	(Reset_TileOffsetPositionActual).l
		jmp	(Refresh_PlaneFull).l
; ---------------------------------------------------------------------------

LRZ2_ScreenEvent:
		move.w	($FFFFEECE).w,d0
		add.w	d0,($FFFFEE84).w
		jmp	(DrawTilesAsYouMove).l
; ---------------------------------------------------------------------------

LRZ2_BackgroundInit:
		jsr	(Create_New_Sprite).l
		bne.s	loc_56FD2
		move.l	#loc_5711E,(a1)
		move.w	a1,($FFFFEED8).w

loc_56FD2:
		move.w	#8,($FFFFEEC2).w
		jsr	sub_57082(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		moveq	#0,d1
		jsr	(Refresh_PlaneFull).l
		lea	word_57184(pc),a4
		lea	($FFFFA800).w,a5
		jmp	(ApplyDeformation).l
; ---------------------------------------------------------------------------

LRZ2_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_57000(pc,d0.w)
; ---------------------------------------------------------------------------

loc_57000:
		bra.w	loc_5700C
; ---------------------------------------------------------------------------
		bra.w	loc_57040
; ---------------------------------------------------------------------------
		bra.w	loc_57058
; ---------------------------------------------------------------------------

loc_5700C:
		jsr	(Create_New_Sprite).l
		bne.s	loc_5701E
		move.l	#loc_5711E,(a1)
		move.w	a1,($FFFFEED8).w

loc_5701E:
		jsr	sub_57082(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_57044
; ---------------------------------------------------------------------------

loc_57040:
		jsr	sub_57082(pc)

loc_57044:
		moveq	#0,d1
		move.w	($FFFFEE90).w,d2
		jsr	(Draw_PlaneVertBottomUp).l
		bpl.s	loc_5705C
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_5705C
; ---------------------------------------------------------------------------

loc_57058:
		jsr	sub_57082(pc)

loc_5705C:

		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jsr	(Draw_TileRow).l
		lea	word_57184(pc),a4
		lea	($FFFFA800).w,a5
		jsr	(ApplyDeformation).l
		jmp	(ShakeScreen_Setup).l

; =============== S U B R O U T I N E =======================================


sub_57082:

		move.w	($FFFFEE84).w,d0
		move.w	($FFFFEECE).w,d1
		sub.w	d1,d0
		swap	d0
		clr.w	d0
		asr.l	#3,d0
		move.l	d0,d2
		asr.l	#2,d2
		sub.l	d2,d0
		swap	d0
		add.w	d1,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEE80).w,d0
		swap	d0
		clr.w	d0
		asr.l	#3,d0
		move.l	d0,d1
		move.l	d0,d2
		asr.l	#2,d0
		swap	d1
		move.w	d1,($FFFFEE8C).w
		swap	d1
		sub.l	d0,d1
		swap	d1
		move.w	d1,($FFFFEEE2).w
		swap	d1
		sub.l	d0,d1
		swap	d1
		move.w	d1,($FFFFEEE4).w
		lea	($FFFFA810).w,a1
		move.l	d2,d1
		moveq	#7,d3

loc_570D2:
		swap	d1
		move.w	d1,-(a1)
		swap	d1
		add.l	d0,d1
		dbf	d3,loc_570D2
		lea	($FFFFA810).w,a1
		add.l	d0,d2
		add.l	d0,d0
		moveq	#4,d3

loc_570E8:
		swap	d2
		move.w	d2,(a1)+
		swap	d2
		add.l	d0,d2
		dbf	d3,loc_570E8
		move.w	($FFFFEED8).w,d0
		beq.s	locret_5711C
		movea.w	d0,a1
		move.w	#$678,d0
		sub.w	($FFFFA804).w,d0
		cmpi.w	#-$7E0,d0
		ble.s	loc_5710C
		moveq	#0,d0

loc_5710C:
		move.w	d0,$10(a1)
		move.w	#$C0,d0
		sub.w	($FFFFEE90).w,d0
		move.w	d0,$14(a1)

locret_5711C:
		rts
; End of function sub_57082

; ---------------------------------------------------------------------------

loc_5711E:

		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_57130
		clr.w	($FFFFEED8).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_57130:
		move.l	#loc_57156,(a0)
		move.b	#$40,6(a0)
		move.b	#$50,7(a0)
		move.w	#$380,8(a0)
		move.w	#$639F,$A(a0)
		move.l	#Map_LRZ2DeathEggBG,$C(a0)

loc_57156:
		tst.w	$2E(a0)
		bne.s	loc_57176
		tst.w	$10(a0)
		beq.s	locret_57182
		lea	(ArtKosM_LRZ2DeathEggBG).l,a1
		move.w	#$73E0,d2
		jsr	(Queue_Kos_Module).l
		st	$2E(a0)

loc_57176:
		tst.w	$10(a0)
		beq.s	locret_57182
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

locret_57182:

		rts
; ---------------------------------------------------------------------------
word_57184:	dc.w $20

		dc.w $20
		dc.w $20
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $F0
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $20
		dc.w $7FFF
Map_LRZ2DeathEggBG:	include "Levels\LRZ\Misc Object Data\Map - Act 2 BG Death Egg.asm"

; ---------------------------------------------------------------------------

SSZ1_ScreenInit:
		tst.b	($FFFFFE2A).w
		bne.s	loc_57246
		jsr	(Create_New_Sprite).l
		bne.s	loc_57246
		move.l	#Obj_57C1E,(a1)
		move.w	#$100,$10(a1)
		move.b	#$6C,$2D(a1)
		st	($FFFFEED7).w
		move.w	#$200,($FFFFEE16).w
		move.w	#$BC0,d0
		move.w	d0,($FFFFEE1A).w
		move.w	d0,($FFFFEE12).w
		moveq	#$60,d0
		move.w	d0,($FFFFEE80).w
		move.w	d0,($FFFFEE78).w
		move.w	#$F49,d0
		move.w	d0,($FFFFEE84).w
		move.w	d0,($FFFFEE7C).w
		st	($FFFFEE0A).w

loc_57246:

		clr.w	($FFFFEE98).w
		clr.w	($FFFFEE9C).w
		lea	($FFFFA9F6).w,a1
		lea	(a1),a5
		moveq	#4,d0

loc_57256:
		clr.w	(a1)+
		dbf	d0,loc_57256
		lea	word_58758(pc),a6
		moveq	#4,d1
		jsr	(Create_New_Sprite).l
		bne.s	loc_5728E

loc_5726A:
		move.w	a1,(a5)+
		move.l	#loc_57BB2,(a1)
		move.w	(a6)+,$38(a1)
		move.w	(a6)+,$3A(a1)
		move.w	(a6)+,$40(a1)
		move.w	(a6)+,d2
		move.b	d2,$22(a1)
		jsr	(CreateNewSprite4).l
		dbne	d1,loc_5726A

loc_5728E:
		jsr	sub_5758A(pc)
		jsr	(Reset_TileOffsetPositionActual).l
		jmp	(Refresh_PlaneFull).l
; ---------------------------------------------------------------------------

SSZ1_ScreenEvent:
		move.w	($FFFFEECE).w,d0
		add.w	d0,($FFFFEE84).w
		move.w	($FFFFEEC0).w,d0
		jmp	loc_572AE(pc,d0.w)
; ---------------------------------------------------------------------------

loc_572AE:
		bra.w	loc_572BA
; ---------------------------------------------------------------------------
		bra.w	loc_57344
; ---------------------------------------------------------------------------
		bra.w	loc_574B0
; ---------------------------------------------------------------------------

loc_572BA:
		tst.b	($FFFFFAAA).w
		bne.s	loc_572CE
		jsr	sub_575EA(pc)
		jsr	sub_5758A(pc)
		jmp	(DrawTilesAsYouMove).l
; ---------------------------------------------------------------------------

loc_572CE:
		jsr	(Create_New_Sprite).l
		bne.s	loc_572E2
		move.l	#Obj_57E96,(a1)
		move.w	#$1E,$2E(a1)

loc_572E2:
		lea	($FFFFA8E0).w,a1
		lea	$20(a1),a5
		moveq	#9,d0

loc_572EC:
		move.w	#-1,(a1)+
		clr.l	(a5)+
		clr.l	$3C(a5)
		dbf	d0,loc_572EC
		jsr	sub_5750C(pc)
		lea	($FFFFA880).w,a1
		move.w	($FFFFEEAC).w,d0
		moveq	#9,d1

loc_57308:
		move.w	(a1)+,(a1)
		and.w	d0,(a1)+
		dbf	d1,loc_57308
		jsr	(Restore_PlayerControl).l
		lea	($FFFFB04A).w,a1
		jsr	(Restore_PlayerControl2).l
		st	($FFFFF7CA).w
		st	($FFFFF7CB).w
		clr.w	($FFFFF602).w
		clr.w	($FFFFF66A).w
		st	($FFFFEE0A).w
		st	($FFFFEECC).w
		move.w	#4,($FFFFEEA6).w
		addq.w	#4,($FFFFEEC0).w
		bra.s	loc_5734E
; ---------------------------------------------------------------------------

loc_57344:
		tst.w	($FFFFEEC4).w
		bne.s	loc_57360
		jsr	sub_5750C(pc)

loc_5734E:
		lea	word_577B2(pc),a4
		lea	($FFFFA880).w,a5
		moveq	#$F,d6
		moveq	#$A,d5
		jmp	(DrawTilesVDeform).l
; ---------------------------------------------------------------------------

loc_57360:
		movem.l	d7-a0/a2-a3,-(sp)
		lea	(SSZ1_128x128_Custom_Kos).l,a1
		lea	($FFFF0180).l,a2
		jsr	(Queue_Kos).l
		lea	(SSZ1_16x16_Custom_Kos).l,a1
		lea	($FFFF90B8).w,a2
		jsr	(Queue_Kos).l
		lea	(ArtKosM_SSZ1_Custom).l,a1
		move.w	#$E60,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_SSZSpiralRamp).l,a1
		move.w	#$6900,d2
		jsr	(Queue_Kos_Module).l
		movem.l	(sp)+,d7-a0/a2-a3
		move.w	-8(a3),d0
		subq.w	#3,d0
		movea.w	(a3),a1
		move.b	#4,(a1,d0.w)
		move.b	#5,1(a1,d0.w)
		move.b	#6,2(a1,d0.w)
		movea.w	4(a3),a1
		move.b	#7,(a1,d0.w)
		move.b	#8,1(a1,d0.w)
		move.b	#9,2(a1,d0.w)
		lea	($FFFFFC20).w,a1
		lea	Pal_SSZDeathEgg(pc),a5
		moveq	#7,d0

loc_573E4:
		move.l	(a5)+,(a1)+
		dbf	d0,loc_573E4
		jsr	sub_574DC(pc)
		move.w	($FFFFEEEA).w,d0
		move.w	d0,d1
		andi.w	#-$10,d0
		move.w	d0,($FFFFEEF2).w
		move.w	($FFFFEEEE).w,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEF4).w
		st	($FFFFEE98).w
		clr.l	($FFFFEEF6).w
		clr.w	($FFFFEEFA).w
		jsr	(Create_New_Sprite).l
		bne.w	loc_574A0
		move.w	#$5A8,d1
		move.w	#$58C,d2
		move.w	#$554,d3
		moveq	#9,d4

loc_5742C:
		move.l	#loc_58234,(a1)
		move.w	#$1A38,$10(a1)
		move.w	d1,$14(a1)
		jsr	(CreateNewSprite4).l
		bne.s	loc_574A0
		move.l	#loc_58360,(a1)
		move.w	#$1A80,$10(a1)
		move.w	d2,$14(a1)
		tst.w	d4
		beq.s	loc_574A0
		jsr	(CreateNewSprite4).l
		bne.s	loc_574A0
		move.l	#loc_582AC,(a1)
		move.w	#$1A48,$10(a1)
		move.w	d1,$14(a1)
		subi.w	#$38,$14(a1)
		jsr	(CreateNewSprite4).l
		bne.s	loc_574A0
		move.l	#loc_581F2,(a1)
		move.w	#$19F8,$10(a1)
		move.w	d3,$14(a1)
		moveq	#$70,d5
		sub.w	d5,d1
		sub.w	d5,d2
		sub.w	d5,d3
		jsr	(CreateNewSprite4).l
		dbne	d4,loc_5742C

loc_574A0:

		st	($FFFFEEC4).w
		move.w	#$C,($FFFFEEA6).w
		addq.w	#4,($FFFFEEC0).w
		rts
; ---------------------------------------------------------------------------

loc_574B0:
		jsr	sub_574DC(pc)
		lea	($FFFFEEEA).w,a6
		lea	($FFFFEEF2).w,a5
		move.w	($FFFFEEEE).w,d1
		moveq	#$F,d6
		jsr	(Draw_TileColumn).l
		lea	($FFFFEEEE).w,a6
		lea	($FFFFEEF4).w,a5
		move.w	($FFFFEEEA).w,d1
		moveq	#$15,d6
		jmp	(Draw_TileRow).l

; =============== S U B R O U T I N E =======================================


sub_574DC:

		move.w	($FFFFEE80).w,($FFFFEEEA).w
		move.w	($FFFFEE7C).w,d0
		subi.w	#$110,d0
		asr.w	#2,d0
		move.w	d0,($FFFFEEEE).w
		cmpi.w	#$110,($FFFFEE7C).w
		bne.w	sub_5758A
		addi.l	#$6000,($FFFFEEF6).w
		move.w	($FFFFEEF6).w,d0
		add.w	d0,($FFFFEEEE).w
		bra.s	sub_5758A
; End of function sub_574DC


; =============== S U B R O U T I N E =======================================


sub_5750C:

		lea	($FFFFA880).w,a5
		lea	$60(a5),a6
		move.w	($FFFFEE84).w,d0
		moveq	#$A,d1
		moveq	#9,d2

loc_5751C:
		tst.w	(a6)
		beq.s	loc_57526
		bmi.s	loc_57536
		subq.w	#1,(a6)
		bra.s	loc_57536
; ---------------------------------------------------------------------------

loc_57526:
		move.l	$80(a5),d3
		addi.l	#$800,$80(a5)
		sub.l	d3,$C0(a5)

loc_57536:

		move.w	$C0(a5),d3
		add.w	d0,d3
		cmpi.w	#$580,d3
		bcc.s	loc_5754C
		clr.l	$80(a5)
		move.w	#$580,d3
		subq.w	#1,d1

loc_5754C:
		move.w	d3,(a5)
		move.w	d3,-$20(a6)
		addq.w	#4,a5
		addq.w	#2,a6
		dbf	d2,loc_5751C
		movea.w	($FFFFFAA4).w,a1
		move.w	$10(a1),d0
		subi.w	#$19A0,d0
		lsr.w	#3,d0
		andi.w	#-4,d0
		lea	($FFFFA940).w,a5
		move.w	#$660,d2
		sub.w	(a5,d0.w),d2
		move.w	d2,$14(a1)
		tst.w	d1
		bne.s	sub_5758A
		st	($FFFFEEC5).w
		move.l	#Delete_Current_Sprite,(a1)
; End of function sub_5750C


; =============== S U B R O U T I N E =======================================


sub_5758A:

		move.w	($FFFFEE84).w,d0
		move.w	($FFFFEECE).w,d3
		sub.w	d3,d0
		move.w	d0,d1
		asr.w	#2,d1
		add.w	d1,d0
		move.w	($FFFFEE9C).w,d1
		move.w	d1,d2
		asr.w	#2,d2
		add.w	d2,d1
		asr.w	#1,d1
		add.w	d1,d0
		add.w	d3,d0
		move.w	($FFFFEE80).w,d1
		move.w	d1,d2
		asr.w	#2,d2
		add.w	d2,d1
		lea	($FFFFA9F6).w,a5
		moveq	#4,d2

loc_575BA:
		move.w	(a5)+,d3
		beq.s	loc_575E4
		movea.w	d3,a6
		move.w	$38(a6),d3
		sub.w	d0,d3
		andi.w	#$FF,d3
		addi.w	#$70,d3
		move.w	d3,$14(a6)
		move.w	$3A(a6),d3
		sub.w	d1,d3
		andi.w	#$1FF,d3
		addi.w	#$50,d3
		move.w	d3,$10(a6)

loc_575E4:
		dbf	d2,loc_575BA
		rts
; End of function sub_5758A


; =============== S U B R O U T I N E =======================================


sub_575EA:
		tst.b	($FFFFEED8).w
		bne.w	locret_57788
		cmpi.w	#$19A0,($FFFFEE78).w
		bcs.s	loc_5761C
		cmpi.w	#$680,($FFFFB014).w
		bcc.s	loc_5761C
		move.w	#$19A0,($FFFFEE14).w
		move.w	#$5C0,d0
		move.w	d0,($FFFFEE18).w
		move.w	d0,($FFFFEE12).w
		st	($FFFFEED8).w
		bra.w	locret_57788
; ---------------------------------------------------------------------------

loc_5761C:

		tst.b	($FFFFEED7).w
		bne.w	locret_57788
		move.b	($FFFFEED3).w,d0
		or.b	($FFFFEED5).w,d0
		bne.s	loc_57686
		move.w	($FFFFEE7C).w,d0
		cmpi.w	#$100,d0
		bcs.s	loc_57674
		cmpi.w	#$E00,d0
		bcc.s	loc_57674
		lea	word_5778A(pc),a1
		move.w	($FFFFB010).w,d1

loc_57646:
		cmp.w	(a1)+,d1
		bcs.s	loc_5764E
		addq.w	#2,a1
		bra.s	loc_57646
; ---------------------------------------------------------------------------

loc_5764E:
		move.w	(a1),d2
		cmp.w	d0,d2
		bhi.s	loc_57658
		move.w	d2,($FFFFEE18).w

loc_57658:
		lea	word_5779A(pc),a1

loc_5765C:
		cmp.w	(a1)+,d1
		bcs.s	loc_57664
		addq.w	#2,a1
		bra.s	loc_5765C
; ---------------------------------------------------------------------------

loc_57664:
		move.w	(a1),d2
		cmp.w	d0,d2
		bcs.s	loc_57686
		move.w	d2,($FFFFEE1A).w
		move.w	d2,($FFFFEE12).w
		bra.s	loc_57686
; ---------------------------------------------------------------------------

loc_57674:

		move.w	#-$100,($FFFFEE18).w
		move.w	#$1000,d0
		move.w	d0,($FFFFEE1A).w
		move.w	d0,($FFFFEE12).w

loc_57686:

		move.w	($FFFFB014).w,d0
		cmpi.w	#$440,d0
		bcs.s	loc_5770C
		cmpi.w	#$880,d0
		bcc.w	loc_5777E
		tst.b	($FFFFEED2).w
		bmi.w	loc_5777E
		bne.w	locret_57788
		tst.b	($FFFFEED3).w
		bne.s	loc_576E8
		move.w	#$160,($FFFFEE14).w
		move.w	#$19A0,($FFFFEE16).w
		cmpi.w	#$7C0,d0
		bcs.w	locret_57788
		cmpi.w	#$160,($FFFFEE78).w
		bne.w	locret_57788
		btst	#1,($FFFFB02A).w
		bne.w	locret_57788
		move.w	#$160,($FFFFEE16).w
		move.w	#$7C0,d0
		move.w	d0,($FFFFEE18).w
		move.w	d0,($FFFFEE12).w
		st	($FFFFEED3).w

loc_576E8:
		cmpi.w	#$7C0,($FFFFEE7C).w
		bne.w	locret_57788
		jsr	(Create_New_Sprite).l
		bne.s	loc_5770A
		move.l	#Obj_SSZGHZBoss,(a1)
		st	($FFFFEED7).w
		move.w	#$7F00,($FFFFEED2).w

loc_5770A:
		bra.s	locret_57788
; ---------------------------------------------------------------------------

loc_5770C:
		tst.b	($FFFFEED4).w
		bmi.s	loc_5777E
		bne.s	locret_57788
		tst.b	($FFFFEED5).w
		bne.s	loc_5775C
		move.w	#$1660,($FFFFEE16).w
		moveq	#0,d1
		tst.w	($FFFFEED2).w
		bne.s	loc_5772C
		move.w	#$160,d1

loc_5772C:
		move.w	d1,($FFFFEE14).w
		cmpi.w	#$420,d0
		bcs.s	locret_57788
		cmpi.w	#$1660,($FFFFEE78).w
		bne.s	locret_57788
		btst	#1,($FFFFB02A).w
		bne.s	locret_57788
		move.w	#$1660,($FFFFEE14).w
		move.w	#$380,d0
		move.w	d0,($FFFFEE18).w
		move.w	d0,($FFFFEE12).w
		st	($FFFFEED5).w

loc_5775C:
		cmpi.w	#$380,($FFFFEE7C).w
		bne.s	locret_57788
		jsr	(Create_New_Sprite).l
		bne.s	loc_5777C
		move.l	#Obj_SSZMTZBoss,(a1)
		st	($FFFFEED7).w
		move.w	#$7F00,($FFFFEED4).w

loc_5777C:
		bra.s	locret_57788
; ---------------------------------------------------------------------------

loc_5777E:

		clr.w	($FFFFEE14).w
		move.w	#$19A0,($FFFFEE16).w

locret_57788:

		rts
; End of function sub_575EA

; ---------------------------------------------------------------------------
word_5778A:	dc.w $EE0
		dc.w $D00
		dc.w $11E0
		dc.w $CC0
		dc.w $1340
		dc.w $B20
		dc.w $7FFF
		dc.w 0
word_5779A:	dc.w $640
		dc.w $C60
		dc.w $880
		dc.w $CA0
		dc.w $1200
		dc.w $C60
		dc.w $1380
		dc.w $A80
		dc.w $13C0
		dc.w $660
		dc.w $7FFF
		dc.w $3E0
word_577B2:	dc.w $19C0

		dc.w $20
		dc.w $20
		dc.w $20
		dc.w $20
		dc.w $20
		dc.w $20
		dc.w $20
		dc.w $20
		dc.w $7FFF
dword_577C6:	dc.l 9
		dc.l $C0006
		dc.l $3000C
		dc.l 9
		dc.l $C0003
Pal_SSZDeathEgg:	binclude "Levels\SSZ\Palettes\Death Egg.bin"

; ---------------------------------------------------------------------------

SSZ1_BackgroundInit:
		clr.w	($FFFFEEE2).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_57840
		move.l	#loc_57B6A,(a1)
		lea	word_5853E(pc),a5
		move.w	(a5)+,d1

loc_57812:
		jsr	(CreateNewSprite4).l
		bne.s	loc_57840
		move.l	#loc_57B8E,(a1)
		move.w	(a5)+,d2
		move.b	d2,4(a1)
		move.b	#-$80,6(a1)
		move.w	(a5)+,$10(a1)
		move.w	(a5)+,$1A(a1)
		move.w	(a5)+,$2E(a1)
		move.l	(a5)+,$30(a1)
		dbf	d1,loc_57812

loc_57840:

		move.w	($FFFFEE7C).w,d0
		and.w	($FFFFEEAA).w,d0
		cmpi.w	#$800,d0
		bcs.s	loc_57854
		cmpi.w	#$F00,d0
		bcs.s	loc_5786A

loc_57854:
		jsr	sub_579F0(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		jsr	(Refresh_PlaneFull).l
		jmp	(PlainDeformation).l
; ---------------------------------------------------------------------------

loc_5786A:
		move.w	#8,($FFFFEEC2).w
		jsr	sub_57A60(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		move.w	#$1C00,d1
		jsr	(Refresh_PlaneFull).l
		lea	word_58502(pc),a4
		lea	($FFFFA804).w,a5
		jmp	(ApplyDeformation).l
; ---------------------------------------------------------------------------

SSZ1_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_5789A(pc,d0.w)
; ---------------------------------------------------------------------------

loc_5789A:
		bra.w	loc_578AA
; ---------------------------------------------------------------------------
		bra.w	loc_57942
; ---------------------------------------------------------------------------
		bra.w	loc_57960
; ---------------------------------------------------------------------------
		bra.w	loc_579D2
; ---------------------------------------------------------------------------

loc_578AA:
		move.w	($FFFFEE7C).w,d0
		and.w	($FFFFEEAA).w,d0
		cmpi.w	#$800,d0
		bcs.s	loc_578EC
		cmpi.w	#$F00,d0
		bcc.s	loc_578EC
		move.w	($FFFFEE8C).w,($FFFFEEDE).w
		move.w	($FFFFEE90).w,($FFFFEEE0).w
		jsr	sub_57A60(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_57946
; ---------------------------------------------------------------------------

loc_578EC:

		jsr	sub_579F0(pc)

loc_578F0:

		jsr	(DrawBGAsYouMove).l
		jsr	(PlainDeformation).l
		jsr	(ShakeScreen_Setup).l
		tst.w	($FFFFEE98).w
		bne.s	loc_57916
		lea	word_577B2(pc),a4
		lea	($FFFFA8BE).w,a5
		jmp	(Apply_FGVScroll).l
; ---------------------------------------------------------------------------

loc_57916:
		move.w	($FFFFEEFA).w,d0
		beq.s	loc_57932
		clr.w	($FFFFEEFA).w
		move.w	d0,(a0)+
		move.w	#7,(a0)+
		moveq	#$1F,d0

loc_57928:
		move.w	#$6061,(a0)+
		dbf	d0,loc_57928
		clr.w	(a0)

loc_57932:
		move.w	($FFFFEEEE).w,($FFFFF616).w
		move.w	($FFFFEE90).w,($FFFFF618).w
		addq.w	#4,sp
		rts
; ---------------------------------------------------------------------------

loc_57942:
		jsr	sub_57A60(pc)

loc_57946:
		move.w	#$1C00,d1
		move.w	($FFFFEE90).w,d2
		jsr	(Draw_PlaneVertBottomUp).l
		bpl.s	loc_5799A
		clr.w	($FFFFEEDE).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_5799A
; ---------------------------------------------------------------------------

loc_57960:
		move.w	($FFFFEE7C).w,d0
		and.w	($FFFFEEAA).w,d0
		cmpi.w	#$800,d0
		bcs.s	loc_57974
		cmpi.w	#$F00,d0
		bcs.s	loc_57996

loc_57974:
		jsr	sub_579F0(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_579D6
; ---------------------------------------------------------------------------

loc_57996:
		jsr	sub_57A60(pc)

loc_5799A:

		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		move.w	#$1C00,d1
		moveq	#$20,d6
		jsr	(Draw_TileRow).l
		move.w	($FFFFEEDE).w,d0
		beq.s	loc_579C4
		move.w	d0,($FFFFEE8C).w
		move.w	($FFFFEEE0).w,($FFFFEE90).w
		jmp	(PlainDeformation).l
; ---------------------------------------------------------------------------

loc_579C4:
		lea	word_58502(pc),a4
		lea	($FFFFA804).w,a5
		jmp	(ApplyDeformation).l
; ---------------------------------------------------------------------------

loc_579D2:
		jsr	sub_579F0(pc)

loc_579D6:
		move.w	($FFFFEE8C).w,d1
		move.w	($FFFFEE90).w,d2
		jsr	(Draw_PlaneVertSingleBottomUp).l
		bpl.w	loc_578F0
		clr.w	($FFFFEEC2).w
		bra.w	loc_578F0

; =============== S U B R O U T I N E =======================================


sub_579F0:


		tst.w	($FFFFEEE2).w
		bne.s	loc_57A30
		cmpi.w	#$1800,($FFFFEE78).w
		bcs.s	loc_57A12
		st	($FFFFEEE2).w
		bsr.s	sub_579F0
		move.w	($FFFFEE8C).w,d0
		andi.w	#-$10,d0
		move.w	d0,($FFFFEE94).w
		rts
; ---------------------------------------------------------------------------

loc_57A12:
		move.w	($FFFFEE84).w,d0
		addi.w	#$160,d0
		add.w	($FFFFEE9C).w,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEE80).w,d0
		addi.w	#$28,d0
		move.w	d0,($FFFFEE8C).w
		rts
; ---------------------------------------------------------------------------

loc_57A30:
		cmpi.w	#$1800,($FFFFEE78).w
		bcc.s	loc_57A4C
		clr.w	($FFFFEEE2).w
		bsr.s	sub_579F0
		move.w	($FFFFEE8C).w,d0
		andi.w	#-$10,d0
		move.w	d0,($FFFFEE94).w
		rts
; ---------------------------------------------------------------------------

loc_57A4C:
		move.w	($FFFFEE84).w,d0
		addi.w	#$180,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEE80).w,($FFFFEE8C).w
		rts
; End of function sub_579F0


; =============== S U B R O U T I N E =======================================


sub_57A60:

		move.w	($FFFFEE84).w,d0
		move.w	($FFFFEE9C).w,d1
		asr.w	#1,d1
		add.w	d1,d0
		and.w	($FFFFEEAA).w,d0
		subi.w	#$800,d0
		asr.w	#1,d0
		addi.w	#$A0,d0
		move.w	d0,($FFFFEE90).w
		lea	($FFFFA804).w,a1
		move.l	-4(a1),d2
		addi.l	#$500,-4(a1)
		move.w	($FFFFEE80).w,d0
		swap	d0
		clr.w	d0
		asr.l	#5,d0
		move.l	d0,d1
		asr.l	#1,d0
		add.l	d2,d0
		swap	d0
		move.w	d0,(a1)
		move.w	d0,6(a1)
		move.w	d0,$A(a1)
		move.w	d0,$14(a1)
		swap	d0
		add.l	d2,d1
		add.l	d1,d0
		swap	d0
		move.w	d0,8(a1)
		move.w	d0,$E(a1)
		swap	d0
		add.l	d1,d0
		swap	d0
		move.w	d0,4(a1)
		move.w	d0,$C(a1)
		move.w	d0,$12(a1)
		move.w	d0,$16(a1)
		move.w	d0,$3A(a1)
		swap	d0
		add.l	d1,d0
		swap	d0
		move.w	d0,2(a1)
		move.w	d0,$10(a1)
		move.w	d0,$18(a1)
		move.w	d0,$38(a1)
		swap	d0
		add.l	d1,d0
		swap	d0
		move.w	d0,$1A(a1)
		move.w	d0,$36(a1)
		swap	d0
		add.l	d1,d0
		swap	d0
		move.w	d0,$1C(a1)
		move.w	d0,$34(a1)
		swap	d0
		add.l	d1,d0
		swap	d0
		move.w	d0,$1E(a1)
		move.w	d0,$32(a1)
		swap	d0
		add.l	d1,d0
		swap	d0
		move.w	d0,$20(a1)
		move.w	d0,$30(a1)
		swap	d0
		add.l	d1,d0
		swap	d0
		move.w	d0,$22(a1)
		move.w	d0,$2E(a1)
		swap	d0
		add.l	d1,d0
		add.l	d1,d0
		swap	d0
		move.w	d0,$24(a1)
		move.w	d0,$2C(a1)
		swap	d0
		move.l	d1,d2
		asr.l	#1,d2
		add.l	d1,d0
		add.l	d1,d0
		add.l	d2,d0
		swap	d0
		move.w	d0,$26(a1)
		move.w	d0,$2A(a1)
		swap	d0
		add.l	d1,d0
		add.l	d1,d0
		add.l	d2,d0
		swap	d0
		move.w	d0,$28(a1)
		rts
; End of function sub_57A60

; ---------------------------------------------------------------------------

loc_57B6A:
		move.l	#loc_57B76,(a0)
		move.w	#-$8000,$30(a0)

loc_57B76:
		move.l	#$8000,d0
		move.l	#$100,d1
		jsr	(Gradual_SwingOffset).l
		move.w	d0,($FFFFEE9C).w
		rts
; ---------------------------------------------------------------------------

loc_57B8E:
		bset	#7,$2A(a0)
		move.w	$1A(a0),d0
		sub.w	($FFFFEE9C).w,d0
		move.w	d0,$14(a0)
		move.w	$2E(a0),d1
		movea.l	$30(a0),a2
		move.w	$10(a0),d4
		jmp	(SolidObjectTopSloped2).l
; ---------------------------------------------------------------------------

loc_57BB2:
		move.l	#loc_57BF6,(a0)
		move.b	#$40,4(a0)
		move.b	#$10,6(a0)
		move.b	#$30,7(a0)
		move.w	#0,8(a0)
		move.w	#-$1CF0,$A(a0)
		move.l	#Map_SSZRoamingClouds,$C(a0)
		move.w	$38(a0),$1A(a0)
		jsr	(Random_Number).l
		andi.w	#$FFF,d0
		addi.w	#$C00,d0
		move.w	d0,$30(a0)

loc_57BF6:
		move.l	#$1C00,d0
		move.l	#$80,d1
		jsr	(Gradual_SwingOffset).l
		add.w	$1A(a0),d0
		move.w	d0,$38(a0)
		move.l	$3E(a0),d0
		sub.l	d0,$3A(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_57C1E:

		jsr	(Create_New_Sprite3).l
		beq.s	loc_57C28
		rts
; ---------------------------------------------------------------------------

loc_57C28:
		move.l	#loc_57CD2,(a0)
		move.w	#$1000,$14(a0)
		move.w	#-$100,$38(a0)
		move.w	a1,$3C(a0)
		move.l	#Obj_TeleporterBeamExpand,(a1)
		move.b	#$44,4(a1)
		move.b	#-$80,6(a1)
		move.b	#$18,7(a1)
		move.w	#$80,8(a1)
		move.w	#-$1CA4,$A(a1)
		move.l	#Map_SSZHPZTeleporter,$C(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	#2,$16(a1)
		move.w	$14(a0),$44(a1)
		subi.w	#$88,$44(a1)
		move.b	#$18,$46(a1)
		move.w	a0,$48(a1)
		tst.b	($FFFFFE11).w
		bne.s	loc_57CAC
		jsr	(CreateNewSprite4).l
		bne.s	loc_57CAC
		move.l	#Obj_57E34,(a1)
		move.w	#$60,$2C(a1)

loc_57CAC:

		st	($FFFFEED6).w
		lea	($FFFFB000).w,a1
		move.w	($FFFFEE7C).w,d0
		addi.w	#$65,d0
		move.w	d0,$14(a1)
		move.b	#3,$2E(a1)
		moveq	#0,d0
		move.b	d0,$20(a1)
		move.b	d0,$22(a1)
		rts
; ---------------------------------------------------------------------------

loc_57CD2:
		jsr	(sub_45866).l
		lea	($FFFFB000).w,a1
		move.w	$10(a0),$10(a1)
		tst.b	$2D(a0)
		bne.w	loc_57D50
		move.b	#1,$2E(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		move.w	#-1,$1A(a1)
		move.w	$14(a1),d1
		move.w	d1,$3E(a0)
		tst.b	($FFFFFE11).w
		beq.s	loc_57D18
		bset	#7,$A(a1)
		bra.s	loc_57D3C
; ---------------------------------------------------------------------------

loc_57D18:
		tst.w	($FFFFFF08).w
		bne.s	loc_57D3C
		jsr	(CreateNewSprite4).l
		bne.s	loc_57D3C
		move.l	#Obj_57DCC,(a1)
		move.w	$10(a0),$10(a1)
		move.w	d1,$3E(a1)
		move.w	#$C,$2C(a1)

loc_57D3C:

		clr.b	($FFFFEE0A).w
		movea.w	$3C(a0),a1
		st	5(a1)
		move.l	#Obj_57D64,(a0)
		rts
; ---------------------------------------------------------------------------

loc_57D50:
		subi.w	#8,$14(a1)
		subq.b	#1,$2D(a0)
		beq.s	locret_57D62
		subi.w	#8,($FFFFEE7C).w

locret_57D62:
		rts
; ---------------------------------------------------------------------------

Obj_57D64:
		jsr	(sub_45866).l
		lea	($FFFFB000).w,a1
		move.l	#$20000,d0
		move.l	#$800,d1
		jsr	(Gradual_SwingOffset).l
		add.w	$3E(a0),d0
		move.w	d0,$14(a1)
		tst.l	$2E(a0)
		bmi.s	locret_57DA0
		clr.b	$2E(a1)
		clr.b	$20(a1)
		clr.b	($FFFFEED6).w
		move.l	#loc_57DA2,(a0)

locret_57DA0:
		rts
; ---------------------------------------------------------------------------

loc_57DA2:
		move.w	($FFFFEE7C).w,d0
		cmp.w	($FFFFEE1A).w,d0
		bne.s	loc_57DC6
		cmp.w	($FFFFEE18).w,d0
		beq.s	loc_57DB6
		move.w	d0,($FFFFEE18).w

loc_57DB6:
		move.w	$3A(a0),d0
		or.b	$38(a0),d0
		bne.s	loc_57DC6
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_57DC6:

		jmp	(sub_45866).l
; ---------------------------------------------------------------------------

Obj_57DCC:
		lea	($FFFFB04A).w,a1
		tst.w	$2C(a0)
		beq.s	loc_57DFA
		subq.w	#1,$2C(a0)
		bne.s	locret_57E32
		move.w	$10(a0),$10(a1)
		move.b	#1,$2E(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		move.w	#-1,$1A(a1)

loc_57DFA:
		move.l	#$20000,d0
		move.l	#$800,d1
		jsr	(Gradual_SwingOffset).l
		add.w	$3E(a0),d0
		move.w	d0,$14(a1)
		tst.l	$2E(a0)
		bmi.s	locret_57E32
		clr.b	$2E(a1)
		clr.b	$20(a1)
		clr.w	($FFFFF704).w
		move.w	#6,($FFFFF708).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

locret_57E32:

		rts
; ---------------------------------------------------------------------------

Obj_57E34:
		tst.w	$2C(a0)
		beq.s	loc_57E64
		subq.w	#1,$2C(a0)
		bne.s	locret_57E94
		jsr	(Create_New_Sprite3).l
		bne.s	locret_57E94
		move.l	#Obj_CutsceneKnuckles,(a1)
		move.w	#$100,$10(a1)
		move.b	#$2C,$2C(a1)
		move.w	a1,$20(a0)
		move.w	#$C4E,$3E(a0)

loc_57E64:
		movea.w	$20(a0),a1
		move.l	#$20000,d0
		move.l	#$800,d1
		jsr	(Gradual_SwingOffset).l
		add.w	$3E(a0),d0
		move.w	d0,$14(a1)
		tst.l	$2E(a0)
		bmi.s	locret_57E94
		bset	#0,($FFFFFAB8).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

locret_57E94:

		rts
; ---------------------------------------------------------------------------

Obj_57E96:
		cmpi.b	#4,5(a0)
		bhi.s	loc_57EB0
		move.w	($FFFFFE04).w,d0
		andi.w	#$F,d0
		bne.s	loc_57EB0
		moveq	#-$34,d0
		jsr	(Play_Sound_2).l

loc_57EB0:

		moveq	#0,d0
		move.b	5(a0),d0
		jmp	loc_57EBA(pc,d0.w)
; ---------------------------------------------------------------------------

loc_57EBA:
		bra.w	loc_57ECA
; ---------------------------------------------------------------------------
		bra.w	loc_57EDC
; ---------------------------------------------------------------------------
		bra.w	loc_57F18
; ---------------------------------------------------------------------------
		bra.w	loc_57F3E
; ---------------------------------------------------------------------------

loc_57ECA:
		subq.w	#1,$2E(a0)
		bne.w	locret_57FBE
		move.w	#4,$30(a0)
		addq.b	#4,5(a0)

loc_57EDC:
		jsr	sub_57FC0(pc)
		cmpi.w	#$600,($FFFFEE7C).w
		bcs.w	locret_57FBE
		jsr	sub_57FE2(pc)
		cmpi.w	#$60C,($FFFFEE7C).w
		bcs.w	locret_57FBE
		lea	($FFFFA8E0).w,a1
		lea	dword_577C6(pc),a5
		moveq	#4,d0

loc_57F02:
		move.l	(a5)+,(a1)+
		dbf	d0,loc_57F02
		moveq	#$59,d0
		jsr	(Play_Sound_2).l
		addq.b	#4,5(a0)
		bra.w	locret_57FBE
; ---------------------------------------------------------------------------

loc_57F18:
		jsr	sub_57FC0(pc)
		jsr	sub_57FE2(pc)
		cmpi.w	#$640,($FFFFEE7C).w
		bcs.w	locret_57FBE
		move.w	#$F,$2E(a0)
		move.w	#8,$30(a0)
		clr.w	$32(a0)
		addq.b	#4,5(a0)

loc_57F3E:
		tst.w	($FFFFEEC4).w
		bpl.s	locret_57FBE
		tst.w	$2E(a0)
		beq.s	loc_57F5E
		subq.w	#1,$2E(a0)
		bne.s	locret_57FBE
		jsr	(Create_New_Sprite).l
		bne.s	loc_57F5E
		move.l	#Obj_583BE,(a1)

loc_57F5E:

		cmpi.w	#$5C0,($FFFFEE7C).w
		bcc.s	loc_57F7E
		jsr	sub_58048(pc)
		move.w	($FFFFFE04).w,d0
		addq.w	#8,d0
		andi.w	#$F,d0
		bne.s	loc_57F7E
		moveq	#-$33,d0
		jsr	(Play_Sound_2).l

loc_57F7E:

		move.w	#$500,d0
		moveq	#0,d1
		move.b	$30(a0),d1
		subq.w	#1,d1
		bcs.s	loc_57F94

loc_57F8C:
		subi.w	#$70,d0
		dbf	d1,loc_57F8C

loc_57F94:
		moveq	#0,d1
		move.b	$31(a0),d1
		sub.w	d1,d0
		move.w	($FFFFEE7C).w,d1
		sub.w	d0,d1
		bcs.s	locret_57FBE
		cmpi.w	#2,d1
		bls.s	loc_57FAC
		moveq	#2,d1

loc_57FAC:
		sub.w	d1,($FFFFEE7C).w
		cmpi.w	#$110,($FFFFEE7C).w
		bcc.s	locret_57FBE
		move.w	#$110,($FFFFEE7C).w

locret_57FBE:

		rts

; =============== S U B R O U T I N E =======================================


sub_57FC0:

		cmpi.w	#$618,($FFFFEE7C).w
		bcs.s	loc_57FD2
		btst	#0,($FFFFFE05).w
		beq.s	locret_57FE0
		bra.s	loc_57FDC
; ---------------------------------------------------------------------------

loc_57FD2:
		move.w	($FFFFFE04).w,d0
		andi.w	#3,d0
		beq.s	locret_57FE0

loc_57FDC:
		addq.w	#1,($FFFFEE7C).w

locret_57FE0:

		rts
; End of function sub_57FC0


; =============== S U B R O U T I N E =======================================


sub_57FE2:

		lea	($FFFFB000).w,a1
		lea	($FFFFF602).w,a2
		lea	$30(a0),a3
		bsr.s	sub_58002
		tst.w	($FFFFFF08).w
		bne.s	locret_58046
		lea	($FFFFB04A).w,a1
		lea	($FFFFF66A).w,a2
		lea	$31(a0),a3
; End of function sub_57FE2


; =============== S U B R O U T I N E =======================================


sub_58002:
		tst.b	$2E(a1)
		bne.s	locret_58046
		tst.b	(a3)
		bmi.s	loc_58016
		subq.b	#1,(a3)
		bpl.s	locret_58046
		move.w	#$2020,(a2)
		rts
; ---------------------------------------------------------------------------

loc_58016:
		tst.w	$1A(a1)
		bmi.s	loc_58034
		move.w	#$7FFF,$14(a1)
		andi.b	#-4,4(a1)
		move.b	#3,$2E(a1)
		clr.b	$20(a1)
		bra.s	locret_58046
; ---------------------------------------------------------------------------

loc_58034:
		move.w	#$2800,d0
		cmpi.w	#$1A40,$10(a1)
		bcs.s	loc_58044
		move.w	#$2400,d0

loc_58044:
		move.w	d0,(a2)

locret_58046:

		rts
; End of function sub_58002


; =============== S U B R O U T I N E =======================================


sub_58048:
		lea	($FFFFB000).w,a1
		lea	$30(a0),a2
		moveq	#0,d3
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_5805C
		moveq	#-1,d3

loc_5805C:
		bsr.s	sub_5806E
		tst.w	($FFFFFF08).w
		bne.s	locret_58046
		lea	($FFFFB04A).w,a1
		lea	$32(a0),a2
		moveq	#-1,d3
; End of function sub_58048


; =============== S U B R O U T I N E =======================================


sub_5806E:
		tst.w	4(a2)
		bne.w	loc_58192
		cmpi.w	#$910,(a2)
		bne.s	loc_580CC
		st	4(a2)
		move.b	#1,$2E(a1)
		bset	#1,$2A(a1)
		move.b	#1,$40(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		bset	#2,$2A(a1)
		move.w	#$800,$1C(a1)
		move.w	#$400,$18(a1)
		move.w	#-$680,$1A(a1)
		clr.w	$12(a1)
		clr.w	$16(a1)
		moveq	#$62,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

loc_580CC:
		moveq	#0,d0
		move.b	1(a2),d0
		addq.b	#1,d0
		cmpi.b	#$70,d0
		bcs.s	loc_580E0
		subi.b	#$70,d0
		addq.b	#1,(a2)

loc_580E0:
		move.b	d0,1(a2)
		lea	byte_587B4(pc),a6
		move.b	(a6,d0.w),d0
		move.w	d0,d2
		andi.w	#$7FFF,$A(a1)
		addi.b	#$40,d2
		bmi.s	loc_58100
		ori.w	#-$8000,$A(a1)

loc_58100:
		jsr	(GetSineCosine).l
		muls.w	#$4C00,d0
		swap	d0
		move.w	#$1A40,$10(a1)
		add.w	d0,$10(a1)
		muls.w	#$1C00,d1
		swap	d1
		subi.b	#$40,d2
		bpl.s	loc_58128
		neg.w	d1
		subi.w	#$38,d1

loc_58128:
		move.w	#$570,$14(a1)
		add.w	d1,$14(a1)
		lea	byte_58824(pc),a6
		moveq	#0,d0
		move.b	1(a2),d0
		move.b	(a6,d0.w),d0
		ext.w	d0
		sub.w	d0,$14(a1)
		moveq	#0,d0
		move.b	(a2),d0
		subq.w	#1,d0
		bcs.s	loc_58158

loc_5814E:
		subi.w	#$70,$14(a1)
		dbf	d0,loc_5814E

loc_58158:
		tst.w	d3
		beq.s	loc_58170
		addq.w	#4,$14(a1)
		move.w	#$100,8(a1)
		tst.b	d2
		bmi.s	loc_58170
		move.w	#$80,8(a1)

loc_58170:

		addi.w	#$A,d2
		andi.w	#$FF,d2
		move.w	d2,d0
		add.w	d2,d2
		add.w	d0,d2
		lsr.w	#6,d2
		lea	byte_587A8(pc),a2
		move.b	(a2,d2.w),d0
		move.b	d0,$22(a1)
		jmp	(Tails_Carry_LoadPLC).l
; ---------------------------------------------------------------------------

loc_58192:
		tst.w	4(a2)
		bpl.s	loc_581D2
		move.w	$18(a1),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$10(a1)
		move.w	$1A(a1),d0
		addi.w	#$38,$1A(a1)
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$14(a1)
		tst.w	$1A(a1)
		bmi.s	locret_581F0
		move.b	#3,$2E(a1)
		clr.b	$22(a1)
		clr.b	$20(a1)
		move.w	#$B4,4(a2)
		bra.s	locret_581F0
; ---------------------------------------------------------------------------

loc_581D2:
		cmpa.w	#-$5000,a1
		bne.s	locret_581F0
		subq.w	#1,4(a2)
		bne.s	locret_581F0
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		move.w	#$B00,d0
		jmp	(StartNewLevel).l
; ---------------------------------------------------------------------------

locret_581F0:

		rts
; End of function sub_5806E

; ---------------------------------------------------------------------------

loc_581F2:
		move.l	#loc_5821E,(a0)
		move.b	#4,4(a0)
		move.b	#$1C,6(a0)
		move.w	#$80,8(a0)
		move.w	#-$3CB8,$A(a0)
		move.l	#Map_SSZCollapsingBridge,$C(a0)
		move.b	#9,$22(a0)

loc_5821E:
		move.w	$14(a0),d0
		subi.w	#$24,d0
		cmp.w	($FFFFB014).w,d0
		bcc.w	loc_583A0
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_58234:
		move.l	#loc_58260,(a0)
		move.b	#4,4(a0)
		move.b	#$18,6(a0)
		move.w	#$80,8(a0)
		move.w	#-$3D0C,$A(a0)
		move.l	#Map_SSZCollapsingBridge,$C(a0)
		move.b	#6,$22(a0)

loc_58260:
		move.w	$14(a0),d0
		move.b	$22(a0),d1
		subq.b	#6,d1
		beq.s	loc_58288
		subq.b	#1,d1
		beq.s	loc_5827E
		subi.w	#$2C,d0
		cmp.w	($FFFFB014).w,d0
		bcs.s	loc_582A6
		bra.w	loc_583A0
; ---------------------------------------------------------------------------

loc_5827E:
		moveq	#-$20,d1
		moveq	#8,d2
		subi.w	#$24,d0
		bra.s	loc_58290
; ---------------------------------------------------------------------------

loc_58288:
		moveq	#-$40,d1
		moveq	#$10,d2
		subi.w	#$1C,d0

loc_58290:
		cmp.w	($FFFFB014).w,d0
		bcs.s	loc_582A6
		addq.b	#1,$22(a0)
		jsr	(Create_New_Sprite3).l
		bne.s	loc_582A6
		moveq	#8,d0
		bra.s	loc_5831E
; ---------------------------------------------------------------------------

loc_582A6:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_582AC:
		move.l	#loc_582D8,(a0)
		move.b	#4,4(a0)
		move.b	#$18,6(a0)
		move.w	#$200,8(a0)
		move.w	#$42F4,$A(a0)
		move.l	#Map_SSZCollapsingBridge,$C(a0)
		move.b	#$B,$22(a0)

loc_582D8:
		move.w	$14(a0),d0
		move.b	$22(a0),d1
		subi.b	#$B,d1
		beq.s	loc_58302
		subq.b	#1,d1
		beq.s	loc_582F8
		subi.w	#$2C,d0
		cmp.w	($FFFFB014).w,d0
		bcs.s	loc_5835A
		bra.w	loc_583A0
; ---------------------------------------------------------------------------

loc_582F8:
		moveq	#$20,d1
		moveq	#8,d2
		subi.w	#$24,d0
		bra.s	loc_5830A
; ---------------------------------------------------------------------------

loc_58302:
		moveq	#$40,d1
		moveq	#$10,d2
		subi.w	#$1C,d0

loc_5830A:
		cmp.w	($FFFFB014).w,d0
		bcs.s	loc_5835A
		addq.b	#1,$22(a0)
		jsr	(Create_New_Sprite3).l
		bne.s	loc_5835A
		moveq	#$D,d0

loc_5831E:
		move.l	#loc_583A6,(a1)
		move.b	#-$7C,4(a1)
		move.b	#$10,6(a1)
		move.w	8(a0),8(a1)
		move.w	$A(a0),$A(a1)
		move.l	$C(a0),$C(a1)
		move.b	d0,$22(a1)
		move.w	$10(a0),$10(a1)
		add.w	d1,$10(a1)
		move.w	$14(a0),$14(a1)
		add.w	d2,$14(a1)

loc_5835A:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_58360:
		move.l	#loc_5838C,(a0)
		move.b	#4,4(a0)
		move.b	#$1C,6(a0)
		move.w	#$100,8(a0)
		move.w	#-$3CB8,$A(a0)
		move.l	#Map_SSZCollapsingBridge,$C(a0)
		move.b	#$A,$22(a0)

loc_5838C:
		move.w	$14(a0),d0
		subi.w	#$24,d0
		cmp.w	($FFFFB014).w,d0
		bcc.s	loc_583A0
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_583A0:

		move.l	#loc_583A6,(a0)

loc_583A6:

		tst.b	4(a0)
		bmi.s	loc_583B2
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_583B2:
		jsr	(MoveSprite).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_583BE:
		tst.w	($FFFFEE98).w
		bne.s	loc_583C6
		rts
; ---------------------------------------------------------------------------

loc_583C6:
		move.l	#loc_583D2,(a0)
		move.w	#$870,$2E(a0)

loc_583D2:
		move.w	($FFFFFE04).w,d0
		andi.w	#$F,d0
		bne.s	loc_583E4
		moveq	#-$34,d0
		jsr	(Play_Sound_2).l

loc_583E4:
		tst.w	$30(a0)
		beq.s	loc_583F2
		subq.w	#1,$30(a0)
		bra.w	locret_584A0
; ---------------------------------------------------------------------------

loc_583F2:
		move.w	($FFFFB014).w,d0
		cmpi.w	#$4000,d0
		bcs.s	loc_58400
		move.w	#$5C0,d0

loc_58400:
		addi.w	#$198,d0
		move.w	$2E(a0),d1
		cmp.w	d1,d0
		bhi.w	locret_584A0
		move.w	d1,d0
		cmpi.w	#$300,d0
		bcc.s	loc_5841C
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_5841C:
		lsl.w	#4,d1
		andi.w	#$F00,d1
		addi.w	#-$2000,d1
		move.w	d1,($FFFFEEFA).w
		lea	word_58894(pc),a2
		cmpi.w	#$380,d0
		bcs.s	loc_58442
		lea	$80(a2),a2
		cmpi.w	#$800,d0
		bcs.s	loc_58442
		lea	$80(a2),a2

loc_58442:

		lea	byte_58A3E(pc),a3
		move.w	$32(a0),d4
		addq.w	#3,$32(a0)
		move.w	d0,d1
		andi.w	#$70,d0
		adda.w	d0,a2
		subi.w	#$178,d1
		move.w	#$1A08,d2
		moveq	#7,d3
		jsr	(Create_New_Sprite3).l
		bne.s	loc_58494

loc_58468:
		move.l	#loc_584A2,(a1)
		move.w	(a2)+,$A(a1)
		move.w	d2,$10(a1)
		move.w	d1,$14(a1)
		andi.w	#7,d4
		move.b	(a3,d4.w),$2E(a1)
		addq.w	#1,d4
		addi.w	#$10,d2
		jsr	(CreateNewSprite4).l
		dbne	d3,loc_58468

loc_58494:
		subi.w	#$10,$2E(a0)
		move.w	#7,$30(a0)

locret_584A0:

		rts
; ---------------------------------------------------------------------------

loc_584A2:
		move.w	$A(a0),d0
		bpl.s	loc_584BE
		clr.w	$A(a0)
		addq.w	#1,d0
		beq.s	loc_584E4
		move.b	#1,$22(a0)
		addq.w	#1,d0
		beq.s	loc_584BE
		addq.b	#1,$22(a0)

loc_584BE:

		move.l	#loc_584DE,(a0)
		move.b	#-$7C,4(a0)
		move.b	#8,6(a0)
		move.w	#$180,8(a0)
		move.l	#Map_SSZSpiralRampPieces,$C(a0)

loc_584DE:
		tst.b	4(a0)
		bmi.s	loc_584EA

loc_584E4:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_584EA:
		tst.b	$2E(a0)
		beq.s	loc_584F6
		subq.b	#1,$2E(a0)
		bra.s	loc_584FC
; ---------------------------------------------------------------------------

loc_584F6:
		jsr	(MoveSprite).l

loc_584FC:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
word_58502:	dc.w $1D0

		dc.w $10
		dc.w 8
		dc.w $18
		dc.w $10
		dc.w $10
		dc.w 8
		dc.w $28
		dc.w $10
		dc.w 8
		dc.w 8
		dc.w $28
		dc.w 8
		dc.w $20
		dc.w 8
		dc.w 8
		dc.w 8
		dc.w $10
		dc.w $18
		dc.w $20
		dc.w $40
		dc.w $20
		dc.w $18
		dc.w $10
		dc.w 8
		dc.w 8
		dc.w 8
		dc.w $20
		dc.w 8
		dc.w $7FFF
word_5853E:	dc.w 9
		dc.w 0
		dc.w $C38
		dc.w $C0
		dc.w $A0
		dc.l byte_585B8
		dc.w 0
		dc.w $E58
		dc.w $180
		dc.w $180
		dc.l byte_585B8
		dc.w 0
		dc.w $13D8
		dc.w $200
		dc.w $140
		dc.l byte_58618
		dc.w 0
		dc.w $D78
		dc.w $2C0
		dc.w $E0
		dc.l byte_58618
		dc.w 1
		dc.w $F18
		dc.w $2C0
		dc.w $C0
		dc.l byte_58638
		dc.w 1
		dc.w $9D8
		dc.w $580
		dc.w $140
		dc.l byte_58618
		dc.w 0
		dc.w $E18
		dc.w $5C0
		dc.w $100
		dc.l byte_58658
		dc.w 0
		dc.w $F78
		dc.w $6C0
		dc.w $120
		dc.l byte_58638
		dc.w 0
		dc.w $498
		dc.w $540
		dc.w $40
		dc.l byte_585B8
		dc.w 0
		dc.w $618
		dc.w $500
		dc.w $40
		dc.l byte_585B8
byte_585B8:	dc.b  $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21
		dc.b  $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21
		dc.b  $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21
		dc.b  $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21
		dc.b  $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21
byte_58618:	dc.b  $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21
		dc.b  $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21
byte_58638:	dc.b  $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21
		dc.b  $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21
byte_58658:	dc.b  $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21
		dc.b  $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $21, $22, $22, $22, $22, $22, $22, $22, $22
		dc.b  $23, $23, $23, $23, $23, $23, $24, $24, $24, $24, $24, $25, $25, $25, $26, $26, $26, $27, $27, $27
		dc.b  $28, $28, $29, $29, $2A, $2A, $2B, $2B, $2C, $2C, $2D, $2D, $2E, $2F, $2F, $30, $31, $31, $32, $33
		dc.b  $33, $34, $35, $36, $37, $37, $38, $39, $3A, $3B, $3C, $3D, $3E, $3F, $40, $41, $42, $43, $44, $45
		dc.b  $46, $47, $48, $49, $4A, $4B, $4C, $4D, $4E, $4E, $4F, $50, $51, $52, $53, $53, $53, $54, $55, $55
		dc.b  $56, $56, $57, $58, $58, $59, $59, $5A, $5A, $5A, $5B, $5B, $5C, $5C, $5C, $5D, $5D, $5E, $5E, $5E
		dc.b  $5E, $5F, $5F, $5F, $5F, $60, $60, $60, $60, $60, $60, $61, $61, $61, $61, $61, $61, $61, $61, $61
		dc.b  $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61
		dc.b  $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61
		dc.b  $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61
		dc.b  $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61
		dc.b  $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61, $61
word_58758:	dc.w	$10,   $30, $FE00,     1
		dc.w	$44,  $100, $9E00,     2
		dc.w	$78,   $B0, $E600,     1
		dc.w	$AC,  $1C0, $B600,     2
		dc.w	$D8,  $140, $CE00,     1
Map_SSZRoamingClouds:	include "Levels\SSZ\Misc Object Data\Map - Roaming Clouds.asm"

byte_587A8:	dc.b  $EF, $FA,	$F9, $F8, $F7, $F6, $F5, $F4, $F3, $F2,	$F1, $F0

byte_587B4:	dc.b    0,   2,   5,   7,   9,  $B,  $E, $10, $12, $15, $17, $19, $1B, $1E, $20, $22, $25, $27, $29, $2B
		dc.b  $2E, $30, $32, $35, $37, $39, $3B, $3E, $40, $42, $45, $47, $49, $4B, $4E, $50, $52, $55, $57, $59
		dc.b  $5B, $5E, $60, $62, $65, $67, $69, $6B, $6E, $70, $72, $75, $77, $79, $7B, $7E, $80, $82, $85, $87
		dc.b  $89, $8B, $8E, $90, $92, $95, $97, $99, $9B, $9E, $A0, $A2, $A5, $A7, $A9, $AB, $AE, $B0, $B2, $B5
		dc.b  $B7, $B9, $BB, $BE, $C0, $C2, $C5, $C7, $C9, $CB, $CE, $D0, $D2, $D5, $D7, $D9, $DB, $DE, $E0, $E2
		dc.b  $E5, $E7, $E9, $EB, $EE, $F0, $F2, $F5, $F7, $F9, $FB, $FE
byte_58824:	dc.b    3,   3,   4,   5,   6,   6,   7,   7,   8,   8,   8,   8,   7,   7,   7,   7,   7,   6,   5,   4
		dc.b    3,   3,   3,   2,   1,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, $FF, $FF, $FF, $FF, $FE
		dc.b  $FE, $FE, $FE, $FE, $FE, $FD, $FD, $FD, $FD, $FE, $FE, $FF, $FF,   0,   0,   2,   3,   4,   5,   6
		dc.b    7,   7,   8,   8,   9,   9,   9,   8,   7,   7,   7,   7,   7,   6,   5,   4,   3,   3,   3,   2
		dc.b    1,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, $FF, $FF, $FF, $FF, $FE, $FE, $FF, $FF, $FF
		dc.b  $FF, $FE, $FE, $FE, $FE, $FF, $FF,   0,   0,   0,   1,   3
word_58894:	dc.w $4000
		dc.w $4004
		dc.w $4008
		dc.w $400C
		dc.w $480C
		dc.w $4808
		dc.w $4804
		dc.w $4800
		dc.w $4010
		dc.w $4014
		dc.w $4018
		dc.w $401C
		dc.w $481C
		dc.w $4818
		dc.w $4814
		dc.w $4810
		dc.w $4020
		dc.w $4024
		dc.w $4028
		dc.w $402C
		dc.w $482C
		dc.w $4828
		dc.w $4824
		dc.w $4820
		dc.w $4020
		dc.w $4024
		dc.w $4028
		dc.w $402C
		dc.w $482C
		dc.w $4828
		dc.w $4824
		dc.w $4820
		dc.w $4030
		dc.w $4034
		dc.w $4038
		dc.w $403C
		dc.w $483C
		dc.w $4838
		dc.w $4834
		dc.w $4830
		dc.w $4040
		dc.w $4044
		dc.w $4048
		dc.w $404C
		dc.w $484C
		dc.w $4848
		dc.w $4844
		dc.w $4840
		dc.w $4020
		dc.w $4024
		dc.w $4028
		dc.w $402C
		dc.w $482C
		dc.w $4828
		dc.w $4824
		dc.w $4820
		dc.w $4040
		dc.w $4044
		dc.w $4048
		dc.w $404C
		dc.w $484C
		dc.w $4848
		dc.w $4844
		dc.w $4840
		dc.w $4020
		dc.w $4024
		dc.w $4028
		dc.w $402C
		dc.w $482C
		dc.w $4828
		dc.w $4824
		dc.w $4820
		dc.w $4040
		dc.w $4044
		dc.w $4048
		dc.w $404C
		dc.w $484C
		dc.w $4848
		dc.w $4844
		dc.w $4840
		dc.w $4020
		dc.w $4024
		dc.w $4028
		dc.w $402C
		dc.w $482C
		dc.w $4828
		dc.w $4824
		dc.w $4820
		dc.w $4020
		dc.w $4024
		dc.w $4028
		dc.w $402C
		dc.w $482C
		dc.w $4828
		dc.w $4824
		dc.w $4820
		dc.w $4030
		dc.w $4034
		dc.w $4038
		dc.w $403C
		dc.w $483C
		dc.w $4838
		dc.w $4834
		dc.w $4830
		dc.w $4040
		dc.w $4044
		dc.w $4048
		dc.w $404C
		dc.w $484C
		dc.w $4848
		dc.w $4844
		dc.w $4840
		dc.w $4020
		dc.w $4024
		dc.w $4028
		dc.w $402C
		dc.w $482C
		dc.w $4828
		dc.w $4824
		dc.w $4820
		dc.w $4040
		dc.w $4044
		dc.w $4048
		dc.w $404C
		dc.w $484C
		dc.w $4848
		dc.w $4844
		dc.w $4840
		dc.w $4020
		dc.w $4024
		dc.w $4028
		dc.w $402C
		dc.w $482C
		dc.w $4828
		dc.w $4824
		dc.w $4820
		dc.w $4040
		dc.w $4044
		dc.w $4048
		dc.w $404C
		dc.w $484C
		dc.w $4848
		dc.w $4844
		dc.w $4840
		dc.w $4020
		dc.w $4024
		dc.w $4028
		dc.w $402C
		dc.w $482C
		dc.w $4828
		dc.w $4824
		dc.w $4820
		dc.w $4040
		dc.w $4044
		dc.w $4048
		dc.w $404C
		dc.w $484C
		dc.w $4848
		dc.w $4844
		dc.w $4840
		dc.w $4020
		dc.w $4024
		dc.w $4028
		dc.w $402C
		dc.w $482C
		dc.w $4828
		dc.w $4824
		dc.w $4820
		dc.w $4040
		dc.w $4044
		dc.w $4048
		dc.w $404C
		dc.w $484C
		dc.w $4848
		dc.w $4844
		dc.w $4840
		dc.w $FFFE
		dc.w $4054
		dc.w $4058
		dc.w $405C
		dc.w $485C
		dc.w $4858
		dc.w $4854
		dc.w $FFFD
		dc.w $FFFF
		dc.w $FFFF
		dc.w $FFFE
		dc.w $4068
		dc.w $4868
		dc.w $FFFD
		dc.w $FFFF
		dc.w $FFFF
Map_SSZSpiralRampPieces:	include "Levels\SSZ\Misc Object Data\Map - Spiral Ramp Pieces.asm"

byte_58A3E:	dc.b  $1C
		dc.b	8
		dc.b  $10
		dc.b	0
		dc.b	4
		dc.b  $14
		dc.b  $18
		dc.b   $C
; ---------------------------------------------------------------------------

SSZ2_ScreenInit:
		st	($FFFFF650).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_58A92
		move.l	#Obj_57C1E,(a1)
		move.w	#$A0,$10(a1)
		move.b	#$44,$2D(a1)
		moveq	#0,d1
		move.w	d1,($FFFFEE80).w
		move.w	d1,($FFFFEE78).w
		move.w	#$649,d1
		move.w	d1,($FFFFEE84).w
		move.w	d1,($FFFFEE7C).w
		st	($FFFFEE0A).w
		jsr	(CreateNewSprite4).l
		bne.s	loc_58A92
		move.l	#loc_59078,(a1)
		move.w	#1,$30(a1)

loc_58A92:

		jsr	(Reset_TileOffsetPositionActual).l
		moveq	#0,d1
		jmp	(Refresh_PlaneFull).l
; ---------------------------------------------------------------------------

SSZ2_ScreenEvent:
		move.w	($FFFFEECE).w,d0
		add.w	d0,($FFFFEE84).w
		move.w	($FFFFEEC0).w,d0
		jmp	loc_58AB0(pc,d0.w)
; ---------------------------------------------------------------------------

loc_58AB0:
		bra.w	loc_58ACC
; ---------------------------------------------------------------------------
		bra.w	loc_58AE0
; ---------------------------------------------------------------------------
		bra.w	loc_58B20
; ---------------------------------------------------------------------------
		bra.w	loc_58B7C
; ---------------------------------------------------------------------------
		bra.w	loc_58B9E
; ---------------------------------------------------------------------------
		bra.w	loc_58C42
; ---------------------------------------------------------------------------
		bra.w	loc_58C68
; ---------------------------------------------------------------------------

loc_58ACC:
		move.w	($FFFFEE18).w,d0
		cmp.w	($FFFFEE1A).w,d0
		bne.w	loc_58C68
		addq.w	#4,($FFFFEEA6).w
		addq.w	#4,($FFFFEEC0).w

loc_58AE0:
		tst.w	($FFFFEEC4).w
		beq.w	loc_58C68
		clr.w	($FFFFEEC4).w
		movea.w	$24(a3),a1
		movea.w	$28(a3),a5
		moveq	#3,d0

loc_58AF6:
		move.b	#$17,(a1)+
		move.b	#$18,(a1)+
		move.b	#$19,(a5)+
		move.b	#$19,(a5)+
		dbf	d0,loc_58AF6
		move.b	#$17,(a1)
		move.b	#$19,(a5)
		st	($FFFFEF72).w
		addq.w	#4,($FFFFEEC0).w
		jmp	(Refresh_PlaneFullDirect).l
; ---------------------------------------------------------------------------

loc_58B20:
		tst.w	($FFFFEEC4).w
		beq.w	loc_58C68
		bmi.w	loc_58C68
		clr.w	($FFFFEEC4).w
		move	#$2700,sr
		lea	($C00000).l,a6
		move.l	#$7E000003,($C00004).l
		move.l	#$66666666,d0
		moveq	#$7F,d1

loc_58B4C:
		move.l	d0,(a6)
		dbf	d1,loc_58B4C
		move	#$2300,sr
		jsr	(Create_New_Sprite).l
		bne.s	loc_58B64
		move.l	#loc_591D6,(a1)

loc_58B64:
		move.w	#$1F0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		clr.b	($FFFFF650).w
		addq.w	#4,($FFFFEEC0).w
		bra.w	locret_58C7E
; ---------------------------------------------------------------------------

loc_58B7C:
		move.w	#$200,d1
		move.w	#$100,d2
		jsr	(Draw_PlaneVertBottomUp).l
		bpl.w	locret_58C7E
		clr.w	($FFFFEE84).w
		clr.l	($FFFFEE7C).w
		clr.w	($FFFFEE78).w
		addq.w	#4,($FFFFEEC0).w

loc_58B9E:
		movem.l	d7-a0/a2-a3,-(sp)
		jsr	(sub_5B18E).l
		movem.l	(sp)+,d7-a0/a2-a3
		cmpi.b	#7,($FFFFFFB1).w
		bcc.s	loc_58BBC
		cmpi.b	#7,($FFFFFFB0).w
		bcs.s	loc_58C1A

loc_58BBC:
		jsr	sub_592EE(pc)
		tst.w	($FFFFFAAE).w
		beq.w	locret_58C7E
		move.w	#$14C0,d0
		tst.w	($FFFFFFAE).w
		bne.s	loc_58BD6
		move.w	#$1660,d0

loc_58BD6:
		cmp.w	($FFFFEE7C).w,d0
		bne.w	locret_58C7E
		tst.w	($FFFFEEC2).w
		bne.w	locret_58C7E
		clr.b	($FFFFFAB9).w
		move.w	($FFFFEE90).w,d0
		addi.w	#$100,d0
		move.w	d0,($FFFFEE90).w
		clr.w	($FFFFEE92).w
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEE96).w
		lea	(Pal_Ending2).l,a1
		lea	($FFFFFC20).w,a5
		moveq	#$17,d0

loc_58C0E:
		move.l	(a1)+,(a5)+
		dbf	d0,loc_58C0E
		addq.w	#4,($FFFFEEC2).w
		bra.s	locret_58C7E
; ---------------------------------------------------------------------------

loc_58C1A:
		tst.w	($FFFFEEC4).w
		beq.s	locret_58C7E
		lea	(Pal_Ending1).l,a1
		lea	($FFFFFC20).w,a5
		moveq	#$17,d0

loc_58C2C:
		move.l	(a1)+,(a5)+
		dbf	d0,loc_58C2C
		move.w	#$7F0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC0).w

loc_58C42:
		moveq	#0,d1
		move.w	#$700,d2
		jsr	(Draw_PlaneVertBottomUp).l
		bpl.s	locret_58C7E
		move.w	#$720,d0
		move.w	d0,($FFFFEE84).w
		move.w	d0,($FFFFEE7C).w
		clr.w	($FFFFEE7E).w
		move.w	d0,($FFFFEE8A).w
		addq.w	#4,($FFFFEEC0).w

loc_58C68:

		jsr	sub_5928C(pc)
		lea	($FFFFEE84).w,a6
		lea	($FFFFEE8A).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jmp	(Draw_TileRow).l
; ---------------------------------------------------------------------------

locret_58C7E:

		rts
; ---------------------------------------------------------------------------
word_58C80:	dc.w $380
		dc.w $10
		dc.w $10
		dc.w $18
		dc.w $10
		dc.w 8
		dc.w $10
		dc.w $10
		dc.w 8
		dc.w $38
		dc.w $10
		dc.w $10
		dc.w $28
		dc.w 8
		dc.w $20
		dc.w 8
		dc.w 8
		dc.w 8
		dc.w 8
		dc.w 8
		dc.w $18
		dc.w $20
		dc.w $30
		dc.w 8
		dc.w 8
		dc.w $10
		dc.w 8
		dc.w $28
		dc.w $10
		dc.w $10
		dc.w $18
		dc.w $10
		dc.w 8
		dc.w $10
		dc.w $10
		dc.w 8
		dc.w $7FFF
word_58CCA:	dc.w $800
		dc.w $24
		dc.w 4
		dc.w $14
		dc.w 4
		dc.w $1C
		dc.w 4
		dc.w $20
		dc.w $8080
		dc.w $7FFF
word_58CDE:	dc.w $120
		dc.w 8
		dc.w 8
		dc.w 4
		dc.w 4
		dc.w 8
		dc.w 8
		dc.w $18
		dc.w $10
		dc.w $10
		dc.w $7FFF
; ---------------------------------------------------------------------------

SSZ2_BackgroundInit:
		clr.l	($FFFFEE9C).w
		jsr	sub_58D3E(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		moveq	#0,d1
		jsr	(Refresh_PlaneFull).l
		jmp	sub_58FBC(pc)
; ---------------------------------------------------------------------------

SSZ2_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_58D16(pc,d0.w)
; ---------------------------------------------------------------------------

loc_58D16:
		bra.w	loc_58D1E
; ---------------------------------------------------------------------------
		lea	($FFFF8008).w,a3

loc_58D1E:
		jsr	sub_58D3E(pc)
		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jsr	(Draw_TileRow).l
		jsr	sub_58FBC(pc)
		jmp	(ShakeScreen_Setup).l

; =============== S U B R O U T I N E =======================================


sub_58D3E:

		tst.w	($FFFFEEC2).w
		beq.s	loc_58D6E

loc_58D44:
		lea	($FFFFA800).w,a1
		move.l	(a1),d0
		addi.l	#$8000,(a1)+
		lea	$16(a1),a1
		move.w	#$5E,-(a1)
		clr.w	d0
		move.l	d0,d1
		asr.l	#3,d1
		moveq	#7,d2

loc_58D60:
		swap	d0
		move.w	d0,-(a1)
		swap	d0
		sub.l	d1,d0
		dbf	d2,loc_58D60
		rts
; ---------------------------------------------------------------------------

loc_58D6E:
		cmpi.w	#$18,($FFFFEEC0).w
		bcc.w	loc_58F52
		cmpi.w	#$C,($FFFFEEC0).w
		bcc.w	locret_58F50
		lea	($FFFFA800).w,a1
		move.l	(a1),d2
		addi.l	#$1000,(a1)+
		clr.w	(a1)+
		move.w	($FFFFEE80).w,d0
		swap	d0
		clr.w	d0
		asr.l	#5,d0
		move.l	d0,d1
		asr.l	#1,d0
		add.l	d2,d0
		swap	d0
		move.w	d0,(a1)
		move.w	d0,4(a1)
		move.w	d0,8(a1)
		move.w	d0,$10(a1)
		move.w	d0,$36(a1)
		move.w	d0,$3A(a1)
		move.w	d0,$3E(a1)
		move.w	d0,$46(a1)
		swap	d0
		add.l	d2,d1
		add.l	d1,d0
		swap	d0
		move.w	d0,6(a1)
		move.w	d0,$A(a1)
		move.w	d0,$E(a1)
		move.w	d0,$14(a1)
		move.w	d0,$3C(a1)
		move.w	d0,$40(a1)
		move.w	d0,$44(a1)
		swap	d0
		add.l	d1,d0
		swap	d0
		move.w	d0,2(a1)
		move.w	d0,$C(a1)
		move.w	d0,$16(a1)
		move.w	d0,$34(a1)
		move.w	d0,$38(a1)
		move.w	d0,$42(a1)
		swap	d0
		add.l	d1,d0
		swap	d0
		move.w	d0,$12(a1)
		swap	d0
		lea	$18(a1),a1
		moveq	#8,d2

loc_58E14:
		swap	d0
		move.w	d0,(a1)+
		swap	d0
		add.l	d1,d0
		dbf	d2,loc_58E14
		cmpi.w	#4,($FFFFEEC0).w
		bhi.s	loc_58E3A
		lea	($FFFFA82A).w,a1
		move.w	($FFFFEE80).w,d0
		moveq	#8,d1

loc_58E32:
		move.w	d0,(a1)+
		dbf	d1,loc_58E32
		bra.s	loc_58E6E
; ---------------------------------------------------------------------------

loc_58E3A:
		lea	($FFFFA804).w,a1
		move.w	$2A(a1),$2C(a1)
		move.w	$28(a1),d0
		move.w	d0,$2A(a1)
		move.w	d0,$2E(a1)
		move.w	$26(a1),$28(a1)
		move.w	$24(a1),$26(a1)
		move.w	$22(a1),$30(a1)
		move.w	$1E(a1),$32(a1)
		move.w	$1A(a1),$34(a1)

loc_58E6E:
		move.w	($FFFFEE84).w,d0
		subi.w	#$320,d0
		sub.w	($FFFFEE9C).w,d0
		move.w	($FFFFEEA6).w,d1
		subq.w	#4,d1
		beq.s	loc_58E88
		subq.w	#4,d1
		beq.s	loc_58E88
		addq.w	#8,d0

loc_58E88:

		move.w	d0,($FFFFEE90).w
		move.w	#$5E,($FFFFEE8C).w
		lea	($FFFFA8D0).w,a5
		lea	(a5),a6
		move.w	($FFFFEED2).w,d0
		smi	d6
		bpl.s	loc_58EA2
		neg.w	d0

loc_58EA2:
		swap	d0
		clr.w	d0
		asr.l	#7,d0
		move.w	d0,d1
		swap	d0
		moveq	#0,d2
		moveq	#0,d3
		moveq	#$3F,d4
		tst.b	d6
		bne.s	loc_58EC8

loc_58EB6:
		add.w	d1,d3
		addx.w	d0,d2
		move.w	d2,-(a5)
		move.w	d2,d5
		neg.w	d5
		move.w	d5,(a6)+
		dbf	d4,loc_58EB6
		bra.s	loc_58ED8
; ---------------------------------------------------------------------------

loc_58EC8:

		add.w	d1,d3
		addx.w	d0,d2
		move.w	d2,(a6)+
		move.w	d2,d5
		neg.w	d5
		move.w	d5,-(a5)
		dbf	d4,loc_58EC8

loc_58ED8:
		lea	($FFFFA960).w,a5
		lea	(a5),a6
		move.w	($FFFFEED2).w,d0
		smi	d6
		bpl.s	loc_58EE8
		neg.w	d0

loc_58EE8:
		swap	d0
		clr.w	d0
		asr.l	#3,d0
		move.w	d0,d1
		swap	d0
		moveq	#0,d2
		moveq	#0,d3
		moveq	#7,d4
		tst.b	d6
		bne.s	loc_58F0E

loc_58EFC:
		add.w	d1,d3
		addx.w	d0,d2
		move.w	d2,-(a5)
		move.w	d2,d5
		neg.w	d5
		move.w	d5,(a6)+
		dbf	d4,loc_58EFC
		bra.s	loc_58F1E
; ---------------------------------------------------------------------------

loc_58F0E:

		add.w	d1,d3
		addx.w	d0,d2
		move.w	d2,(a6)+
		move.w	d2,d5
		neg.w	d5
		move.w	d5,-(a5)
		dbf	d4,loc_58F0E

loc_58F1E:
		lea	($FFFFA970).w,a1
		lea	($FFFFA940).w,a5
		move.w	($FFFFEE8C).w,d0
		move.w	d0,d1
		andi.w	#$F,d1
		beq.s	loc_58F36
		addi.w	#$10,d0

loc_58F36:
		lsr.w	#3,d0
		andi.w	#-2,d0
		adda.w	d0,a5
		move.w	($FFFFEE90).w,d0
		addq.w	#8,d0
		moveq	#$13,d1

loc_58F46:
		move.w	(a5)+,d2
		add.w	d0,d2
		move.w	d2,(a1)+
		dbf	d1,loc_58F46

locret_58F50:
		rts
; ---------------------------------------------------------------------------

loc_58F52:
		lea	($FFFFA800).w,a1
		move.l	(a1),d0
		subi.l	#$10000,(a1)+
		lea	$110(a1),a1
		clr.w	d0
		move.l	d0,d1
		asr.l	#5,d1
		moveq	#$1F,d2

loc_58F6A:
		swap	d0
		move.w	d0,-(a1)
		move.w	d0,-(a1)
		move.w	d0,-(a1)
		move.w	d0,-(a1)
		swap	d0
		sub.l	d1,d0
		dbf	d2,loc_58F6A
		move.w	(a1),d0
		neg.w	d0
		move.w	d0,-4(a1)
		move.w	d0,-$C(a1)
		move.w	8(a1),d0
		neg.w	d0
		move.w	d0,-8(a1)
		move.w	$10(a1),d0
		neg.w	d0
		move.w	d0,-2(a1)
		move.w	$18(a1),d0
		neg.w	d0
		move.w	d0,-$E(a1)
		move.w	$20(a1),d0
		neg.w	d0
		move.w	d0,-$A(a1)
		move.w	$28(a1),d0
		neg.w	d0
		move.w	d0,-6(a1)
		rts
; End of function sub_58D3E


; =============== S U B R O U T I N E =======================================


sub_58FBC:

		tst.w	($FFFFEEC2).w
		beq.s	loc_58FD0
		lea	word_58CDE(pc),a4
		lea	($FFFFA804).w,a5
		jmp	(ApplyDeformation).l
; ---------------------------------------------------------------------------

loc_58FD0:
		cmpi.w	#$18,($FFFFEEC0).w
		bcc.w	loc_5906A
		cmpi.w	#$C,($FFFFEEC0).w
		bcc.w	loc_59064
		lea	word_58C80(pc),a4
		lea	($FFFFA804).w,a5
		jsr	(ApplyFGDeformation).l
		lea	($FFFFE002).w,a1
		lea	($FFFFA850).w,a5
		move.w	($FFFFEE90).w,d0
		subi.w	#$100,d0
		bmi.s	loc_59018
		subi.w	#$80,d0
		bpl.s	loc_5904A
		move.w	d0,d1
		neg.w	d0
		addi.w	#$80,d1
		add.w	d1,d1
		adda.w	d1,a5
		bra.s	loc_59036
; ---------------------------------------------------------------------------

loc_59018:
		neg.w	d0
		cmpi.w	#$E0,d0
		bcc.s	loc_5904A
		move.w	d0,d1
		addi.w	#-$E0,d0
		neg.w	d0
		cmpi.w	#$80,d0
		bcs.s	loc_59032
		move.w	#$80,d0

loc_59032:
		lsl.w	#2,d1
		adda.w	d1,a1

loc_59036:
		subq.w	#1,d0
		move.w	($FFFFEE8C).w,d1
		neg.w	d1

loc_5903E:
		move.w	(a5)+,d2
		add.w	d1,d2
		move.w	d2,(a1)
		addq.w	#4,a1
		dbf	d0,loc_5903E

loc_5904A:

		lea	($FFFFEEEA).w,a1
		lea	($FFFFA970).w,a5
		move.w	($FFFFEE84).w,d0
		swap	d0
		moveq	#$13,d1

loc_5905A:
		move.w	(a5)+,d0
		move.l	d0,(a1)+
		dbf	d1,loc_5905A
		rts
; ---------------------------------------------------------------------------

loc_59064:
		jmp	(PlainDeformation).l
; ---------------------------------------------------------------------------

loc_5906A:
		lea	word_58CCA(pc),a4
		lea	($FFFFA804).w,a5
		jmp	(ApplyFGDeformation).l
; End of function sub_58FBC

; ---------------------------------------------------------------------------

loc_59078:
		moveq	#0,d0
		move.b	5(a0),d0
		jmp	loc_59082(pc,d0.w)
; ---------------------------------------------------------------------------

loc_59082:
		bra.w	loc_5908E
; ---------------------------------------------------------------------------
		bra.w	loc_590E4
; ---------------------------------------------------------------------------
		bra.w	loc_59194
; ---------------------------------------------------------------------------

loc_5908E:
		tst.w	($FFFFEEA6).w
		beq.w	locret_591D4
		addi.l	#$11B,($FFFFEE9C).w
		move.l	#$2000,d0
		move.l	#$4A,d1
		jsr	(Gradual_SwingOffset).l
		cmp.w	($FFFFEED2).w,d0
		beq.w	locret_591D4
		move.w	d0,($FFFFEED2).w
		bne.w	locret_591D4
		tst.w	($FFFFEEC4).w
		bpl.w	locret_591D4
		tst.b	$38(a0)
		bne.s	loc_590D6
		st	$38(a0)
		bra.w	locret_591D4
; ---------------------------------------------------------------------------

loc_590D6:
		clr.w	($FFFFEEC4).w
		move.w	#$C,($FFFFEEA6).w
		addq.b	#4,5(a0)

loc_590E4:
		cmpi.b	#7,($FFFFFFB1).w
		bcc.s	loc_590F4
		cmpi.b	#7,($FFFFFFB0).w
		bcs.s	loc_59146

loc_590F4:
		cmpi.w	#-$8000,$3C(a0)
		bcc.s	loc_59102
		addi.w	#$20,$3C(a0)

loc_59102:
		move.l	$3A(a0),d0
		sub.l	d0,($FFFFEE9C).w
		move.w	($FFFFEE7C).w,d0
		subi.w	#$318,d0
		sub.w	($FFFFEE9C).w,d0
		cmpi.w	#$D0,d0
		beq.s	loc_59124
		bcs.s	loc_59132
		subq.w	#1,($FFFFEE7C).w
		bra.s	loc_59132
; ---------------------------------------------------------------------------

loc_59124:
		tst.b	$39(a0)
		bne.s	loc_59132
		st	$39(a0)
		st	($FFFFFAA9).w

loc_59132:

		cmpi.w	#$2A0,($FFFFEE7C).w
		bne.w	locret_591D4
		st	($FFFFEEC5).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_59146:
		cmpi.w	#-$8000,$3C(a0)
		bcc.s	loc_59154
		addi.w	#$20,$3C(a0)

loc_59154:
		move.l	$3A(a0),d0
		add.l	d0,($FFFFEE9C).w
		move.w	($FFFFEE7C).w,d0
		subi.w	#$318,d0
		sub.w	($FFFFEE9C).w,d0
		cmpi.w	#$D0,d0
		beq.s	loc_59176
		bcc.s	loc_59184
		addq.w	#1,($FFFFEE7C).w
		bra.s	loc_59184
; ---------------------------------------------------------------------------

loc_59176:
		tst.b	$39(a0)
		bne.s	loc_59184
		st	$39(a0)
		st	($FFFFFAA9).w

loc_59184:

		cmpi.w	#$600,($FFFFEE7C).w
		bne.s	locret_591D4
		st	($FFFFEEC5).w
		addq.b	#4,5(a0)

loc_59194:
		cmpi.w	#$18,($FFFFEEC0).w
		bcs.s	locret_591D4
		move.l	$3A(a0),d0
		add.l	d0,($FFFFEE7C).w
		move.w	($FFFFEE7C).w,d0
		cmpi.w	#$7D0,d0
		bcs.s	locret_591D4
		subi.l	#$98,$3A(a0)
		bpl.s	locret_591D4
		cmpi.w	#$804,($FFFFEE7C).w
		bne.s	locret_591D4
		jsr	(Create_New_Sprite).l
		bne.s	loc_591CE
		move.l	#Obj_5EF68,(a1)

loc_591CE:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

locret_591D4:

		rts
; ---------------------------------------------------------------------------

loc_591D6:
		move.l	#loc_59208,(a0)
		move.b	#$40,4(a0)
		move.b	#$40,6(a0)
		move.w	#$380,8(a0)
		move.l	#Map_KnuxEndingIslandMask,$C(a0)
		move.w	#$122,$10(a0)
		move.w	#$F0,$14(a0)
		move.w	#8,$16(a0)

loc_59208:
		tst.w	($FFFFEEC2).w
		beq.s	loc_59232
		cmpi.w	#$80,($FFFFEE90).w
		bne.s	loc_59218
		bra.s	loc_59220
; ---------------------------------------------------------------------------

loc_59218:
		subi.l	#$6000,($FFFFEE90).w

loc_59220:
		move.w	($FFFFEE90).w,d0
		subi.w	#$1D0,d0
		neg.w	d0
		addi.w	#$F0,d0
		move.w	d0,$14(a0)

loc_59232:
		lea	$18(a0),a1
		move.w	$14(a0),d0
		subi.w	#$40,d0
		moveq	#1,d2

loc_59240:
		move.w	#$A2,d1
		moveq	#3,d3

loc_59246:
		move.w	d1,(a1)+
		move.w	d0,(a1)+
		addq.w	#2,a1
		addi.w	#$40,d1
		dbf	d3,loc_59246
		addi.w	#$40,d0
		dbf	d2,loc_59240
		cmpi.w	#$18,($FFFFEEC0).w
		bne.s	loc_5926A
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_5926A:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
Map_KnuxEndingIslandMask:	include "General\Ending\Map - Knuckles Ending Island Mask.asm"


; =============== S U B R O U T I N E =======================================


sub_5928C:

		tst.b	($FFFFF650).w
		bne.s	locret_592BC
		subq.w	#1,($FFFFF634).w
		bpl.s	locret_592BC
		move.w	#7,($FFFFF634).w
		move.w	($FFFFF632).w,d0
		addq.w	#6,d0
		cmpi.w	#$30,d0
		bcs.s	loc_592AC
		moveq	#0,d0

loc_592AC:
		move.w	d0,($FFFFF632).w
		move.l	Pal_EndingWater(pc,d0.w),($FFFFFC7A).w
		move.w	Pal_EndingWater+$4(pc,d0.w),($FFFFFC7E).w

locret_592BC:
		rts
; End of function sub_5928C

; ---------------------------------------------------------------------------
Pal_EndingWater:	binclude "General\Ending\Palettes\Water Cycle.bin"

; =============== S U B R O U T I N E =======================================


sub_592EE:

		tst.b	($FFFFF650).w
		bne.s	locret_59318
		subq.w	#1,($FFFFF634).w
		bpl.s	locret_59318
		move.w	#3,($FFFFF634).w
		move.w	($FFFFF632).w,d0
		addq.w	#4,d0
		cmpi.w	#$38,d0
		bcs.s	loc_5930E
		moveq	#0,d0

loc_5930E:
		move.w	d0,($FFFFF632).w
		move.l	dword_5931A(pc,d0.w),($FFFFFC76).w

locret_59318:
		rts
; End of function sub_592EE

; ---------------------------------------------------------------------------
dword_5931A:	dc.l  $C400400,	$E680600, $E800800, $E800800, $EE00A00,	$EE00A00, $EE00C00
		dc.l  $C400C00,	$E680C00, $E800400, $E800600, $EE00A00,	$EA40800, $EA40400
; ---------------------------------------------------------------------------

DEZ1_ScreenInit:
		jsr	(Reset_TileOffsetPositionActual).l
		jmp	(Refresh_PlaneFull).l
; ---------------------------------------------------------------------------

DEZ1_ScreenEvent:
		tst.w	($FFFFEEC4).w
		beq.s	loc_59378
		clr.w	($FFFFEEC4).w
		movea.w	$14(a3),a1
		move.b	#-$43,$6E(a1)
		jmp	(Refresh_PlaneScreenDirect).l
; ---------------------------------------------------------------------------

loc_59378:
		jmp	(DrawTilesAsYouMove).l
; ---------------------------------------------------------------------------

DEZ1_BackgroundInit:
		clr.w	($FFFFEE8C).w
		clr.w	($FFFFEE90).w
		jsr	(Reset_TileOffsetPositionEff).l
		jsr	(Refresh_PlaneFull).l
		jmp	(PlainDeformation).l
; ---------------------------------------------------------------------------

DEZ1_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_593A0(pc,d0.w)
; ---------------------------------------------------------------------------

loc_593A0:
		bra.w	loc_593A8
; ---------------------------------------------------------------------------
		bra.w	loc_593EC
; ---------------------------------------------------------------------------

loc_593A8:
		tst.w	($FFFFEEC6).w
		beq.s	loc_593E6
		clr.w	($FFFFEEC6).w
		movem.l	d7-a0/a2-a3,-(sp)
		lea	(DEZ2_16x16_Secondary_Kos).l,a1
		lea	($FFFFA5E0).w,a2
		jsr	(Queue_Kos).l
		lea	(ArtKosM_DEZ2_Secondary).l,a1
		move.w	#$5240,d2
		jsr	(Queue_Kos_Module).l
		moveq	#$38,d0
		jsr	(Load_PLC).l
		movem.l	(sp)+,d7-a0/a2-a3
		addq.w	#4,($FFFFEEC2).w

loc_593E6:
		jmp	(PlainDeformation).l
; ---------------------------------------------------------------------------

loc_593EC:
		tst.b	($FFFFFF60).w
		bne.w	loc_59488
		move.w	#$B01,($FFFFFE10).w
		clr.b	($FFFFEE33).w
		clr.b	($FFFFF76C).w
		clr.b	($FFFFF710).w
		clr.b	($FFFFF7AA).w
		clr.b	($FFFFFF97).w
		jsr	(Clear_Switches).l
		movem.l	d7-a0/a2-a3,-(sp)
		jsr	(Load_Level).l
		jsr	(LoadSolids).l
		lea	($FFFFFC40).w,a0
		lea	(Pal_DEZ2+$20).l,a1
		moveq	#$F,d0

loc_59430:
		move.l	(a1)+,(a0)+
		dbf	d0,loc_59430
		movem.l	(sp)+,d7-a0/a2-a3
		move.w	#$3600,d0
		move.w	#-$400,d1
		sub.w	d0,($FFFFB010).w
		sub.w	d1,($FFFFB014).w
		sub.w	d0,($FFFFB05A).w
		sub.w	d1,($FFFFB05E).w
		jsr	(Offset_ObjectsDuringTransition).l
		sub.w	d0,($FFFFEE78).w
		sub.w	d1,($FFFFEE7C).w
		sub.w	d0,($FFFFEE80).w
		sub.w	d1,($FFFFEE84).w
		sub.w	d0,($FFFFEE14).w
		sub.w	d0,($FFFFEE16).w
		sub.w	d1,($FFFFEE18).w
		sub.w	d1,($FFFFEE1A).w
		move.w	($FFFFEE1A).w,($FFFFEE12).w
		jsr	(Reset_TileOffsetPositionActual).l
		clr.w	($FFFFEEC2).w

loc_59488:
		jmp	(PlainDeformation).l
; ---------------------------------------------------------------------------

DEZ2_ScreenInit:
		move.w	#4,($FFFFEEC0).w
		jsr	(Reset_TileOffsetPositionActual).l
		jmp	(Refresh_PlaneFull).l
; ---------------------------------------------------------------------------

DEZ2_ScreenEvent:
		move.w	($FFFFEEC0).w,d0
		jmp	loc_594A8(pc,d0.w)
; ---------------------------------------------------------------------------

loc_594A8:
		bra.w	loc_594B4
; ---------------------------------------------------------------------------
		bra.w	loc_594DA
; ---------------------------------------------------------------------------
		bra.w	loc_594F8
; ---------------------------------------------------------------------------

loc_594B4:
		tst.w	($FFFFEEC4).w
		beq.s	loc_594F8
		clr.w	($FFFFEEC4).w
		movea.w	$38(a3),a1
		addq.w	#1,a1
		move.b	#-$29,(a1)+
		move.b	#-$24,(a1)+
		move.b	#-$29,(a1)
		addq.w	#4,($FFFFEEC0).w
		jmp	(Refresh_PlaneScreenDirect).l
; ---------------------------------------------------------------------------

loc_594DA:
		tst.w	($FFFFEEC4).w
		beq.s	loc_594F8
		clr.w	($FFFFEEC4).w
		movea.w	$18(a3),a1
		move.b	#-$44,$6B(a1)
		addq.w	#4,($FFFFEEC0).w
		jmp	(Refresh_PlaneScreenDirect).l
; ---------------------------------------------------------------------------

loc_594F8:

		jmp	(DrawTilesAsYouMove).l
; ---------------------------------------------------------------------------

DEZ2_BackgroundInit:
		move.w	#8,($FFFFEEC2).w
		clr.w	($FFFFEE8C).w
		clr.w	($FFFFEE90).w
		jsr	(Reset_TileOffsetPositionEff).l
		jsr	(Refresh_PlaneFull).l
		jmp	(PlainDeformation).l
; ---------------------------------------------------------------------------

DEZ2_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_59526(pc,d0.w)
; ---------------------------------------------------------------------------

loc_59526:
		bra.w	loc_59532
; ---------------------------------------------------------------------------
		bra.w	loc_59556
; ---------------------------------------------------------------------------
		bra.w	loc_59566
; ---------------------------------------------------------------------------

loc_59532:
		clr.w	($FFFFEE8C).w
		clr.w	($FFFFEE90).w
		jsr	(Reset_TileOffsetPositionEff).l
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w

loc_59556:
		moveq	#0,d1
		moveq	#0,d2
		jsr	(Draw_PlaneVertBottomUp).l
		bpl.s	loc_59566
		addq.w	#4,($FFFFEEC2).w

loc_59566:

		jmp	(PlainDeformation).l
; ---------------------------------------------------------------------------

DDZ_ScreenInit:
		jsr	(Create_New_Sprite).l
		bne.s	loc_5957A
		move.l	#loc_81492,(a1)

loc_5957A:
		clr.w	($FFFFEE98).w
		clr.w	($FFFFEEA0).w
		clr.w	($FFFFEE9C).w
		clr.w	($FFFFEEA2).w
		moveq	#0,d1
		moveq	#0,d0
		jmp	(Refresh_PlaneFull).l
; ---------------------------------------------------------------------------

DDZ_ScreenEvent:
		jsr	sub_59648(pc)
		move.w	($FFFFEEC0).w,d4
		jmp	loc_595A0(pc,d4.w)
; ---------------------------------------------------------------------------

loc_595A0:
		bra.w	loc_595B0
; ---------------------------------------------------------------------------
		bra.w	loc_595C0
; ---------------------------------------------------------------------------
		bra.w	loc_595EE
; ---------------------------------------------------------------------------
		bra.w	loc_59602
; ---------------------------------------------------------------------------

loc_595B0:
		tst.w	($FFFFEED2).w
		beq.w	locret_59646
		jsr	sub_59672(pc)
		addq.w	#4,($FFFFEEC0).w

loc_595C0:
		cmpi.w	#$200,($FFFFEED2).w
		bne.s	loc_595D6
		cmpi.w	#$400,d0
		bcc.s	sub_59614
		cmpi.w	#$220,d1
		bcc.s	sub_59614
		bra.s	loc_5961E
; ---------------------------------------------------------------------------

loc_595D6:
		jsr	sub_59672(pc)
		bsr.s	sub_59614
		move.w	#$F0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC0).w
		bra.s	loc_595F0
; ---------------------------------------------------------------------------

loc_595EE:
		bsr.s	sub_59614

loc_595F0:
		moveq	#0,d1
		moveq	#0,d2
		jsr	(Draw_PlaneVertBottomUp).l
		bpl.s	locret_59646
		addq.w	#4,($FFFFEEC0).w
		bra.s	locret_59646
; ---------------------------------------------------------------------------

loc_59602:
		cmpi.w	#$400,d0
		bcs.s	sub_59614
		cmpi.w	#$800,d0
		bcc.s	sub_59614
		cmpi.w	#$220,d1
		bcs.s	loc_5961E

; =============== S U B R O U T I N E =======================================


sub_59614:

		move.w	d2,($FFFFEE98).w
		move.w	d3,($FFFFEE9C).w
		bra.s	locret_59646
; ---------------------------------------------------------------------------

loc_5961E:

		lea	($FFFFEE98).w,a6
		lea	($FFFFEEA0).w,a5
		move.w	($FFFFEE9C).w,d1
		moveq	#$F,d6
		jsr	(Draw_TileColumn).l
		lea	($FFFFEE9C).w,a6
		lea	($FFFFEEA2).w,a5
		move.w	($FFFFEE98).w,d1
		moveq	#$15,d6
		jmp	(Draw_TileRow).l
; ---------------------------------------------------------------------------

locret_59646:

		rts
; End of function sub_59614


; =============== S U B R O U T I N E =======================================


sub_59648:
		move.w	($FFFFEE98).w,d2
		move.w	($FFFFEE9C).w,d3
		move.w	($FFFFEE80).w,d0
		sub.w	($FFFFEED4).w,d0
		add.w	($FFFFEED2).w,d0
		move.w	d0,($FFFFEE98).w
		move.w	($FFFFEE84).w,d1
		sub.w	($FFFFEED6).w,d1
		addi.w	#$100,d1
		move.w	d1,($FFFFEE9C).w
		rts
; End of function sub_59648


; =============== S U B R O U T I N E =======================================


sub_59672:

		move.w	($FFFFEE98).w,d5
		move.w	d5,d4
		andi.w	#-$10,d5
		move.w	d5,($FFFFEEA0).w
		move.w	($FFFFEE9C).w,d5
		and.w	($FFFFEEAC).w,d5
		move.w	d5,($FFFFEEA2).w
		rts
; End of function sub_59672

; ---------------------------------------------------------------------------

DDZ_BackgroundInit:
		clr.w	($FFFFA800).w
		jsr	sub_596EA(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		moveq	#0,d1
		jsr	(Refresh_PlaneFull).l
		bra.s	loc_596BC
; ---------------------------------------------------------------------------

DDZ_BackgroundEvent:
		jsr	sub_596EA(pc)
		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		moveq	#0,d1
		moveq	#$20,d6
		jsr	(Draw_TileRow).l

loc_596BC:
		lea	word_59716(pc),a4
		lea	($FFFFA800).w,a5
		lea	($FFFFE000).w,a1
		move.w	($FFFFEE98).w,d3
		move.w	($FFFFEE90).w,d0
		move.w	#$DF,d1
		jsr	(ApplyDeformation2).l
		move.w	($FFFFEE9C).w,($FFFFF616).w
		move.w	($FFFFEE90).w,($FFFFF618).w
		addq.w	#4,sp
		rts

; =============== S U B R O U T I N E =======================================


sub_596EA:

		move.w	($FFFFEE84).w,d0
		asr.w	#1,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEED8).w,d0
		swap	d0
		clr.w	d0
		asr.l	#4,d0
		move.l	d0,d1
		asr.l	#3,d1
		moveq	#5,d2
		lea	($FFFFA80E).w,a1

loc_59708:
		swap	d0
		move.w	d0,-(a1)
		swap	d0
		sub.l	d1,d0
		dbf	d2,loc_59708
		rts
; End of function sub_596EA

; ---------------------------------------------------------------------------
word_59716:	dc.w $B0
		dc.w $10
		dc.w 8
		dc.w 8
		dc.w $18
		dc.w $38
		dc.w $7FFF
; ---------------------------------------------------------------------------

Pachinko_ScreenInit:
		jsr	(Reset_TileOffsetPositionActual).l
		jmp	(Refresh_PlaneFull).l
; ---------------------------------------------------------------------------

Pachinko_ScreenEvent:
		jmp	(DrawTilesAsYouMove).l
; ---------------------------------------------------------------------------

Pachinko_BackgroundInit:
		jsr	Pachinko_BGScroll(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		jsr	(Refresh_PlaneFull).l
		jmp	(PlainDeformation).l
; ---------------------------------------------------------------------------

Pachinko_BackgroundEvent:
		jsr	Pachinko_BGScroll(pc)
		jsr	(DrawBGAsYouMove).l
		jmp	(PlainDeformation).l

; =============== S U B R O U T I N E =======================================


Pachinko_BGScroll:

		move.w	($FFFFEE84).w,d0
		asr.w	#3,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEE80).w,d0
		subi.w	#$A0,d0
		swap	d0
		clr.w	d0
		asr.l	#1,d0
		move.l	d0,d1
		asr.l	#2,d1
		add.l	d1,d0
		swap	d0
		addi.w	#$60,d0
		move.w	d0,($FFFFEE8C).w
		rts
; End of function Pachinko_BGScroll

; ---------------------------------------------------------------------------

Slots_ScreenInit:
		move.w	#$7FF,($FFFFEEAA).w
		move.w	#$7F0,($FFFFEEAC).w
		move.w	#$3C,($FFFFEEAE).w
		rts
; ---------------------------------------------------------------------------

Slots_ScreenEvent:
		move.w	($FFFFEEC0).w,d0
		jmp	loc_597A2(pc,d0.w)
; ---------------------------------------------------------------------------

loc_597A2:
		bra.w	loc_597AA
; ---------------------------------------------------------------------------
		bra.w	loc_597E4
; ---------------------------------------------------------------------------

loc_597AA:
		addq.w	#4,($FFFFEEC0).w
		move.w	#$400,d1
		sub.w	($FFFFEED2).w,d1
		add.w	($FFFFEE80).w,d1
		move.w	d1,($FFFFEE98).w
		andi.w	#-$10,d1
		move.w	d1,($FFFFEEA0).w
		move.w	#$400,d0
		sub.w	($FFFFEED4).w,d0
		add.w	($FFFFEE84).w,d0
		move.w	d0,($FFFFEE9C).w
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEA2).w
		jmp	(Refresh_PlaneDirect).l
; ---------------------------------------------------------------------------

loc_597E4:
		moveq	#$20,d1
		move.w	#$400,d0
		sub.w	($FFFFEED2).w,d0
		add.w	($FFFFEE80).w,d0
		lea	($FFFFEE98).w,a1
		bsr.s	sub_59832
		move.w	#$400,d0
		sub.w	($FFFFEED4).w,d0
		add.w	($FFFFEE84).w,d0
		lea	($FFFFEE9C).w,a1
		bsr.s	sub_59832
		lea	($FFFFEE98).w,a6
		lea	($FFFFEEA0).w,a5
		move.w	($FFFFEE9C).w,d1
		moveq	#$F,d6
		jsr	(Draw_TileColumn).l
		lea	($FFFFEE9C).w,a6
		lea	($FFFFEEA2).w,a5
		move.w	($FFFFEE98).w,d1
		moveq	#$15,d6
		jmp	(Draw_TileRow).l

; =============== S U B R O U T I N E =======================================


sub_59832:

		sub.w	(a1),d0
		smi	d2
		bpl.s	loc_5983A
		neg.w	d0

loc_5983A:
		cmp.w	d1,d0
		bls.s	loc_59840
		move.w	d1,d0

loc_59840:
		tst.b	d2
		beq.s	loc_59846
		neg.w	d0

loc_59846:
		add.w	d0,(a1)
		rts
; End of function sub_59832

; ---------------------------------------------------------------------------

Slots_BackgroundInit:
		lea	($FFFFA800).w,a1
		moveq	#$7F,d0

loc_59850:
		clr.l	(a1)+
		dbf	d0,loc_59850
		moveq	#0,d1
		moveq	#0,d0
		move.l	d0,($FFFFEE90).w
		jsr	(Refresh_PlaneFull).l
		jmp	loc_59990(pc)
; ---------------------------------------------------------------------------

Slots_BackgroundEvent:
		move.l	#$400,d0
		tst.w	($FFFFE402).w
		bpl.s	loc_59876
		neg.l	d0

loc_59876:
		add.l	($FFFFEED8).w,d0
		move.l	#$8000,d1
		cmp.l	d1,d0
		bgt.s	loc_5988A
		neg.l	d1
		cmp.l	d1,d0
		bge.s	loc_5988C

loc_5988A:
		move.l	d1,d0

loc_5988C:
		move.l	d0,($FFFFEED8).w
		add.l	d0,($FFFFEE90).w
		andi.w	#$FF,($FFFFEE90).w
		lea	($FF1000).l,a0
		move.l	a0,($FFFFEF74).w
		clr.w	(a0)
		clr.w	($FFFFEED6).w
		lea	word_599DE(pc),a5
		lea	($FFFFA820).w,a6
		moveq	#7,d6

loc_598B4:
		move.l	a5,-(sp)
		move.w	d6,-(sp)
		move.w	(a5),d0
		move.l	2(a5),d1
		add.l	d1,(a6)
		bcc.s	loc_598C6
		add.w	d0,(a6)
		bra.s	loc_598CE
; ---------------------------------------------------------------------------

loc_598C6:
		move.w	(a6),d1
		sub.w	d0,d1
		bcs.s	loc_598D2
		move.w	d1,(a6)

loc_598CE:
		st	$A(a6)

loc_598D2:
		move.w	$A(a5),d5
		beq.s	loc_598E0
		tst.w	($FFFFEED6).w
		bne.w	loc_59962

loc_598E0:
		subq.w	#1,4(a6)
		bmi.s	loc_598EE
		tst.w	$A(a6)
		beq.s	loc_59962
		bra.s	loc_598F4
; ---------------------------------------------------------------------------

loc_598EE:
		move.w	6(a5),4(a6)

loc_598F4:
		move.w	6(a6),d0
		addq.w	#1,d0
		cmp.w	8(a5),d0
		bcs.s	loc_59902
		moveq	#0,d0

loc_59902:
		move.w	d0,6(a6)
		clr.w	$A(a6)
		st	($FFFFEED6).w
		tst.w	d5
		bne.s	loc_5991A
		move.w	(a5),d0
		add.w	d0,8(a6)
		bra.s	loc_59962
; ---------------------------------------------------------------------------

loc_5991A:
		btst	#0,7(a6)
		beq.s	loc_59926
		add.w	$C(a5),d5

loc_59926:
		moveq	#0,d1
		move.w	(a5),d2
		move.w	6(a6),d3
		subq.w	#1,d3
		bcs.s	loc_59938

loc_59932:
		add.w	d2,d1
		dbf	d3,loc_59932

loc_59938:
		move.w	$10(a5),d0
		move.w	$12(a5),d6
		movem.l	d1/d5-d6/a5,-(sp)
		jsr	(sub_4ECAA).l
		movem.l	(sp)+,d1/d5-d6/a5
		tst.w	$E(a5)
		beq.s	loc_59962
		addi.w	#$10,d0
		addi.w	#$100,d5
		jsr	(sub_4ECAA).l

loc_59962:

		move.w	(sp)+,d6
		movea.l	(sp)+,a5
		lea	$14(a5),a5
		lea	$C(a6),a6
		dbf	d6,loc_598B4
		lea	($FFFFA800).w,a1
		lea	($FFFFA820).w,a5
		moveq	#7,d0

loc_5997C:
		move.w	(a5),d1
		add.w	8(a5),d1
		move.w	d1,(a1)+
		move.w	d1,$E(a1)
		lea	$C(a5),a5
		dbf	d0,loc_5997C

loc_59990:
		lea	word_599BE(pc),a4
		lea	($FFFFA800).w,a5
		lea	($FFFFE000).w,a1
		move.w	($FFFFEE98).w,d3
		move.w	($FFFFEE90).w,d0
		move.w	#$DF,d1
		jsr	(ApplyDeformation2).l
		move.w	($FFFFEE9C).w,($FFFFF616).w
		move.w	($FFFFEE90).w,($FFFFF618).w
		addq.w	#4,sp
		rts
; ---------------------------------------------------------------------------
word_599BE:	dc.w $20
		dc.w $20
		dc.w $20
		dc.w $20
		dc.w $30
		dc.w $20
		dc.w $10
		dc.w $20
		dc.w $20
		dc.w $20
		dc.w $20
		dc.w $20
		dc.w $30
		dc.w $20
		dc.w $10
		dc.w $7FFF
word_599DE:	dc.w $48
		dc.w 0
		dc.w $C000
		dc.w 8
		dc.w 8
		dc.w $E000
		dc.w $FFFE
		dc.w 1
		dc.w 0
		dc.w $19
		dc.w $48
		dc.w 0
		dc.w $C000
		dc.w 9
		dc.w 8
		dc.w $E200
		dc.w $FFFE
		dc.w 1
		dc.w $20
		dc.w $19
		dc.w $50
		dc.w 0
		dc.w $A000
		dc.w $B
		dc.w $10
		dc.w $E400
		dc.w 0
		dc.w 1
		dc.w $40
		dc.w $19
		dc.w $40
		dc.w 0
		dc.w $E000
		dc.w 4
		dc.w 8
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w $40
		dc.w 1
		dc.w 0
		dc.w 3
		dc.w 8
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w $48
		dc.w 0
		dc.w $C000
		dc.w $A
		dc.w 8
		dc.w $EB00
		dc.w $FFFE
		dc.w 1
		dc.w $B0
		dc.w $19
		dc.w $58
		dc.w 0
		dc.w $8000
		dc.w 7
		dc.w 4
		dc.w $ED00
		dc.w $FFFE
		dc.w 0
		dc.w $D0
		dc.w $19
		dc.w $40
		dc.w 0
		dc.w $E000
		dc.w 5
		dc.w 8
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
; ---------------------------------------------------------------------------

LRZ3_ScreenInit:
		clr.w	($FFFFEE16).w
		lea	($FFFFB000).w,a1
		cmpi.w	#$480,$10(a1)
		bcs.s	loc_59AF8
		lea	($FFFFFCA0).w,a1
		lea	(Pal_LRZBossFire).l,a5
		moveq	#$17,d0

loc_59A9A:
		move.l	(a5)+,(a1)+
		dbf	d0,loc_59A9A
		move.w	#$9C0,$10(a1)
		move.w	#$36C,$14(a1)
		move.w	#$920,d0
		move.w	d0,($FFFFEE80).w
		move.w	d0,($FFFFEE78).w
		clr.w	($FFFFEE7A).w
		move.w	d0,($FFFFEE14).w
		move.w	d0,($FFFFEE16).w
		move.w	#$2F0,d0
		move.w	d0,($FFFFEE84).w
		move.w	d0,($FFFFEE7C).w
		clr.w	($FFFFEE7E).w
		move.w	d0,($FFFFEE18).w
		move.w	d0,($FFFFEE1A).w
		move.w	d0,($FFFFEE12).w
		move.w	#$14,($FFFFEEB2).w
		move.w	#$10,($FFFFEED2).w
		move.w	#$2D,($FFFFEED4).w
		move.w	#$C,($FFFFEEC0).w

loc_59AF8:
		jsr	(Reset_TileOffsetPositionActual).l
		jmp	(Refresh_PlaneFull).l
; ---------------------------------------------------------------------------

LRZ3_ScreenEvent:
		move.w	($FFFFEEC0).w,d0
		jmp	loc_59B0C(pc,d0.w)
; ---------------------------------------------------------------------------

loc_59B0C:
		bra.w	loc_59B1C
; ---------------------------------------------------------------------------
		bra.w	loc_59B46
; ---------------------------------------------------------------------------
		bra.w	loc_59B88
; ---------------------------------------------------------------------------
		bra.w	loc_59BA4
; ---------------------------------------------------------------------------

loc_59B1C:
		move.w	($FFFFEF5E).w,d0
		beq.s	loc_59B30
		clr.w	($FFFFEF5E).w
		move.w	d0,($FFFFFE20).w
		move.b	#1,($FFFFFE1D).w

loc_59B30:
		move.l	($FFFFEF60).w,d0
		beq.s	loc_59B42
		clr.l	($FFFFEF60).w
		move.l	d0,($FFFFFE22).w
		st	($FFFFFE1E).w

loc_59B42:
		addq.w	#4,($FFFFEEC0).w

loc_59B46:
		move.b	#1,($FFFFFE1C).w
		tst.w	($FFFFEEC4).w
		beq.s	loc_59B78
		clr.w	($FFFFEEC4).w
		movea.w	$24(a3),a1
		move.b	#$16,(a1)+
		move.b	#$15,(a1)+
		move.b	#$16,(a1)+
		move.b	#$15,(a1)+
		move.b	#$16,(a1)
		addq.w	#4,($FFFFEEC0).w
		jmp	(Refresh_PlaneScreenDirect).l
; ---------------------------------------------------------------------------

loc_59B78:
		move.w	($FFFFEE7C).w,d0
		cmp.w	($FFFFEE1A).w,d0
		bne.s	loc_59BA4
		move.w	d0,($FFFFEE18).w
		bra.s	loc_59BA4
; ---------------------------------------------------------------------------

loc_59B88:
		tst.w	($FFFFEEC4).w
		beq.s	loc_59BA4
		clr.w	($FFFFEEC4).w
		clr.w	($FFFFEE7A).w
		clr.w	($FFFFEE7E).w
		move.w	#$14,($FFFFEEB2).w
		addq.w	#4,($FFFFEEC0).w

loc_59BA4:

		move.w	($FFFFEEDE).w,d1
		beq.s	loc_59BF4
		move.w	d1,d3
		lsr.w	#7,d3
		move.w	($FFFFEEE0).w,d0
		move.w	d0,d2
		lsr.w	#5,d2
		andi.w	#-4,d2
		movea.w	(a3,d2.w),a1
		move.b	#$17,(a1,d3.w)
		move.b	#$17,1(a1,d3.w)
		moveq	#-$80,d2
		and.w	d2,d0
		and.w	d2,d1
		moveq	#$30,d2
		add.w	d2,d0
		add.w	d2,d1
		moveq	#$A,d6
		moveq	#4,d2

loc_59BDA:
		movem.w	d0-d2/d6,-(sp)
		jsr	(Setup_TileRowDraw).l
		movem.w	(sp)+,d0-d2/d6
		addi.w	#$10,d0
		dbf	d2,loc_59BDA
		clr.w	($FFFFEEDE).w

loc_59BF4:
		jmp	(DrawTilesAsYouMove).l
; ---------------------------------------------------------------------------

LRZ3_BackgroundInit:
		jsr	(Create_New_Sprite).l
		bne.s	loc_59C08
		move.l	#Obj_59FC4,(a1)

loc_59C08:
		lea	($FFFFA800).w,a1
		move.l	#$600050,d0
		moveq	#$13,d1

loc_59C14:
		move.l	d0,(a1)+
		dbf	d1,loc_59C14
		lea	($FFFFA900).w,a1
		move.l	#$30303030,d0
		moveq	#$2F,d1

loc_59C26:
		move.l	d0,(a1)+
		dbf	d1,loc_59C26
		move.w	(a3),$7C(a3)
		jsr	sub_59D82(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		jsr	(Refresh_PlaneFull).l
		jmp	sub_59DDE(pc)
; ---------------------------------------------------------------------------

LRZ3_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_59C4C(pc,d0.w)
; ---------------------------------------------------------------------------

loc_59C4C:
		bra.w	loc_59C60
; ---------------------------------------------------------------------------
		bra.w	loc_59C8C
; ---------------------------------------------------------------------------
		bra.w	loc_59D02
; ---------------------------------------------------------------------------
		bra.w	loc_59D24
; ---------------------------------------------------------------------------
		bra.w	loc_59D74
; ---------------------------------------------------------------------------

loc_59C60:
		cmpi.w	#$500,($FFFFEE7C).w
		bcs.s	loc_59C6E
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_59C8C
; ---------------------------------------------------------------------------

loc_59C6E:
		jsr	sub_59D82(pc)

loc_59C72:

		jsr	(DrawBGAsYouMove).l
		move.w	($FFFFEED6).w,d0
		beq.s	loc_59C88
		move.w	d0,($FFFFEE8C).w
		move.w	($FFFFEED8).w,($FFFFEE90).w

loc_59C88:
		jmp	sub_59DDE(pc)
; ---------------------------------------------------------------------------

loc_59C8C:

		cmpi.w	#$500,($FFFFEE7C).w
		bcs.s	loc_59CD8
		cmpi.w	#$A00,($FFFFEE78).w
		bne.s	loc_59CCA
		move.w	($FFFFEE7C).w,d0
		cmp.w	($FFFFEE1A).w,d0
		bne.s	loc_59CCA
		move.w	#$A00,($FFFFEE16).w
		move.w	d0,($FFFFEE18).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_59CBE
		move.l	#Obj_LRZEndBoss,(a1)

loc_59CBE:
		move.w	#4,($FFFFEEA6).w
		addq.w	#8,($FFFFEEC2).w
		bra.s	loc_59D24
; ---------------------------------------------------------------------------

loc_59CCA:

		jsr	sub_59DA2(pc)
		jsr	(DrawBGAsYouMove).l
		jmp	sub_59DDE(pc)
; ---------------------------------------------------------------------------

loc_59CD8:
		move.w	($FFFFEE8C).w,($FFFFEED6).w
		move.w	($FFFFEE90).w,($FFFFEED8).w
		jsr	sub_59D82(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_59D06
; ---------------------------------------------------------------------------

loc_59D02:
		jsr	sub_59D82(pc)

loc_59D06:
		move.w	($FFFFEE8C).w,d1
		move.w	($FFFFEE90).w,d2
		jsr	(Draw_PlaneVertTopDown).l
		bpl.w	loc_59C72
		clr.w	($FFFFEED6).w
		clr.w	($FFFFEEC2).w
		bra.w	loc_59C72
; ---------------------------------------------------------------------------

loc_59D24:

		tst.w	($FFFFEEC6).w
		beq.s	loc_59D30
		tst.w	($FFFFEEDC).w
		beq.s	loc_59D66

loc_59D30:
		jsr	sub_59DBC(pc)
		lea	word_5A106(pc),a4
		lea	($FFFFA800).w,a5
		moveq	#$F,d6
		moveq	#$14,d5
		jsr	(DrawTilesVDeform2).l
		jsr	sub_59DDE(pc)
		lea	($FFFFEEEA).w,a1
		lea	($FFFFA800).w,a5
		move.w	($FFFFEE84).w,d0
		swap	d0
		moveq	#$13,d1

loc_59D5A:
		move.w	(a5),d0
		move.l	d0,(a1)+
		addq.w	#4,a5
		dbf	d1,loc_59D5A
		rts
; ---------------------------------------------------------------------------

loc_59D66:
		clr.w	($FFFFEEC6).w
		move.w	#$C,($FFFFEEA6).w
		addq.w	#4,($FFFFEEC2).w

loc_59D74:
		jsr	sub_59DA2(pc)
		jsr	(DrawBGAsYouMove).l
		jmp	sub_59DDE(pc)

; =============== S U B R O U T I N E =======================================


sub_59D82:

		move.w	($FFFFEE84).w,d0
		asr.w	#4,d0
		addi.w	#$10,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEE80).w,d0
		asr.w	#4,d0
		move.w	d0,($FFFFEE8C).w
		asr.w	#1,d0
		move.w	d0,($FFFFEEE4).w
		rts
; End of function sub_59D82


; =============== S U B R O U T I N E =======================================


sub_59DA2:

		move.w	($FFFFEE80).w,d0
		subi.w	#$700,d0
		move.w	d0,($FFFFEE8C).w
		move.w	($FFFFEE84).w,d0
		subi.w	#$500,d0
		move.w	d0,($FFFFEE90).w
		rts
; End of function sub_59DA2


; =============== S U B R O U T I N E =======================================


sub_59DBC:
		bsr.s	sub_59DA2
		lea	($FFFFA800).w,a1
		lea	$113(a1),a5
		moveq	#$30,d1
		moveq	#$13,d2

loc_59DCA:
		moveq	#0,d3
		move.b	(a5),d3
		sub.w	d1,d3
		add.w	d0,d3
		move.w	d3,(a1)
		addq.w	#4,a1
		addq.w	#8,a5
		dbf	d2,loc_59DCA
		rts
; End of function sub_59DBC


; =============== S U B R O U T I N E =======================================


sub_59DDE:

		tst.b	($FFFFFAAA).w
		bne.s	loc_59DF2
		tst.b	($FFFFFACD).w
		bne.s	loc_59DF2
		cmpi.w	#8,($FFFFEEC0).w
		bcc.s	loc_59DF8

loc_59DF2:
		jmp	(PlainDeformation).l
; ---------------------------------------------------------------------------

loc_59DF8:
		lea	($FFFFE000).w,a1
		lea	(word_5077E).l,a5
		lea	(a5),a6
		move.w	($FFFFEE84).w,d0
		move.w	($FFFFFE04).w,d1
		add.w	d1,d1
		add.w	d1,d0
		andi.w	#$3E,d0
		adda.w	d0,a5
		move.w	($FFFFEE90).w,d0
		asr.w	#1,d1
		add.w	d1,d0
		andi.w	#$3E,d0
		adda.w	d0,a6
		move.w	($FFFFEE80).w,d0
		neg.w	d0
		move.w	($FFFFEE8C).w,d1
		neg.w	d1
		move.w	#$DF,d2

loc_59E34:
		move.w	(a5)+,d3
		add.w	d0,d3
		move.w	d3,(a1)+
		move.w	(a6)+,d3
		add.w	d1,d3
		move.w	d3,(a1)+
		dbf	d2,loc_59E34
		rts
; End of function sub_59DDE

; ---------------------------------------------------------------------------

loc_59E46:
		tst.w	($FFFFEED4).w
		beq.s	loc_59E52
		subq.w	#1,($FFFFEED4).w
		rts
; ---------------------------------------------------------------------------

loc_59E52:
		st	($FFFFEE0A).w
		move.w	($FFFFEED2).w,d0
		jmp	loc_59E5E(pc,d0.w)
; ---------------------------------------------------------------------------

loc_59E5E:
		bra.w	loc_59E7A
; ---------------------------------------------------------------------------
		bra.w	loc_59E90
; ---------------------------------------------------------------------------
		bra.w	loc_59EA8
; ---------------------------------------------------------------------------
		bra.w	loc_59EBE
; ---------------------------------------------------------------------------
		bra.w	loc_59ED4
; ---------------------------------------------------------------------------
		bra.w	loc_59EE8
; ---------------------------------------------------------------------------
		bra.w	loc_59F00
; ---------------------------------------------------------------------------

loc_59E7A:
		move.l	#$20000,d2
		moveq	#0,d1
		cmpi.w	#$410,($FFFFEE78).w
		bcs.w	loc_59F3C
		addq.w	#4,($FFFFEED2).w

loc_59E90:
		move.l	#$16A00,d2
		move.l	d2,d1
		neg.l	d1
		cmpi.w	#$330,($FFFFEE7C).w
		bhi.w	loc_59F3C
		addq.w	#4,($FFFFEED2).w

loc_59EA8:
		move.l	#$20000,d2
		moveq	#0,d1
		cmpi.w	#$650,($FFFFEE78).w
		bcs.w	loc_59F3C
		addq.w	#4,($FFFFEED2).w

loc_59EBE:
		move.l	#$16A00,d2
		move.l	d2,d1
		neg.l	d1
		cmpi.w	#$2F0,($FFFFEE7C).w
		bhi.s	loc_59F3C
		addq.w	#4,($FFFFEED2).w

loc_59ED4:
		move.l	#$20000,d2
		moveq	#0,d1
		cmpi.w	#$910,($FFFFEE78).w
		bcs.s	loc_59F3C
		addq.w	#4,($FFFFEED2).w

loc_59EE8:
		move.l	#$1D900,d2
		move.l	#$C400,d1
		cmpi.w	#$320,($FFFFEE7C).w
		bcs.s	loc_59F3C
		addq.w	#4,($FFFFEED2).w

loc_59F00:
		move.l	#$20000,d2
		moveq	#0,d1
		cmpi.w	#$BBF,($FFFFEE78).w
		bcs.s	loc_59F3C
		moveq	#0,d2
		cmpi.w	#$C50,($FFFFB010).w
		bcs.s	loc_59F3C
		move.w	#$A00,($FFFFEE14).w
		move.w	#$BC0,($FFFFEE16).w
		move.w	#$560,d0
		move.w	d0,($FFFFEE1A).w
		move.w	d0,($FFFFEE12).w
		clr.b	($FFFFEE0A).w
		clr.w	($FFFFEEB2).w
		rts
; ---------------------------------------------------------------------------

loc_59F3C:

		add.l	d1,($FFFFEE7C).w
		move.w	($FFFFEE7C).w,d1
		move.w	d1,($FFFFEE7C).w
		move.w	d1,($FFFFEE84).w
		move.w	d1,($FFFFEE18).w
		move.w	d1,($FFFFEE1A).w
		move.w	d1,($FFFFEE12).w
		add.l	d2,($FFFFEE78).w
		move.w	($FFFFEE78).w,d0
		move.w	d0,($FFFFEE78).w
		move.w	d0,($FFFFEE80).w
		move.w	d0,($FFFFEE14).w
		move.w	d0,($FFFFEE16).w
		movem.w	d0/d2,-(sp)
		lea	($FFFFB000).w,a1
		bsr.s	sub_59F82
		movem.w	(sp)+,d0/d2
		lea	($FFFFB04A).w,a1

; =============== S U B R O U T I N E =======================================


sub_59F82:
		cmpi.b	#5,$20(a1)
		bne.s	loc_59F8E
		clr.b	$20(a1)

loc_59F8E:
		addi.w	#$10,d0
		cmp.w	$10(a1),d0
		bls.s	loc_59FB4
		btst	#5,$2A(a1)
		beq.s	loc_59FA8
		lea	(a1),a0
		jmp	(Kill_Character).l
; ---------------------------------------------------------------------------

loc_59FA8:
		move.w	d0,$10(a1)
		asr.l	#8,d2
		move.w	d2,$1C(a1)
		bra.s	locret_59FC2
; ---------------------------------------------------------------------------

loc_59FB4:
		addi.w	#$110,d0
		cmp.w	$10(a1),d0
		bhi.s	locret_59FC2
		move.w	d0,$10(a1)

locret_59FC2:

		rts
; End of function sub_59F82

; ---------------------------------------------------------------------------

Obj_59FC4:
		move.l	#loc_59FDC,(a0)
		move.b	#-$40,6(a0)
		move.w	#$640,$14(a0)
		bset	#7,$2A(a0)

loc_59FDC:
		cmpi.w	#$C,($FFFFEEC2).w
		bne.w	loc_5A07A
		move.w	($FFFFEEDC).w,d0
		tst.b	($FFFFEEDB).w
		beq.s	loc_59FFA
		cmpi.w	#$80,d0
		bcc.s	loc_5A000
		addq.w	#1,d0
		bra.s	loc_5A000
; ---------------------------------------------------------------------------

loc_59FFA:
		tst.w	d0
		beq.s	loc_5A000
		subq.w	#1,d0

loc_5A000:

		move.w	d0,($FFFFEEDC).w
		swap	d0
		clr.w	d0
		asr.l	#8,d0
		move.w	d0,d1
		swap	d0
		moveq	#$30,d2
		moveq	#0,d3
		move.w	#$AF,d4
		tst.b	($FFFFEEDA).w
		bne.s	loc_5A040
		lea	($FFFFA910).w,a1

loc_5A020:
		move.b	d2,(a1)+
		add.w	d1,d3
		addx.w	d0,d2
		dbf	d4,loc_5A020
		moveq	#$30,d2
		moveq	#0,d3
		moveq	#$F,d4
		lea	($FFFFA910).w,a1

loc_5A034:
		sub.w	d1,d3
		subx.w	d0,d2
		move.b	d2,-(a1)
		dbf	d4,loc_5A034
		bra.s	loc_5A062
; ---------------------------------------------------------------------------

loc_5A040:
		lea	($FFFFA9B0).w,a1

loc_5A044:
		move.b	d2,-(a1)
		add.w	d1,d3
		addx.w	d0,d2
		dbf	d4,loc_5A044
		moveq	#$30,d2
		moveq	#0,d3
		moveq	#$F,d4
		lea	($FFFFA9B0).w,a1

loc_5A058:
		sub.w	d1,d3
		subx.w	d0,d2
		move.b	d2,(a1)+
		dbf	d4,loc_5A058

loc_5A062:
		move.w	#$A0,d1
		lea	($FFFFA910).w,a2
		move.w	#$AA0,d4
		move.w	d4,$10(a0)
		jsr	(SolidObjectTopSloped2).l
		bra.s	loc_5A094
; ---------------------------------------------------------------------------

loc_5A07A:
		move.w	#$180,d1
		move.w	#$40,d2
		move.w	#$30,d3
		move.w	#$B80,d4
		move.w	d4,$10(a0)
		jsr	(SolidObjectTop).l

loc_5A094:
		move.w	($FFFFEEDC).w,d0
		swap	d0
		clr.w	d0
		lsr.l	#7,d0
		move.l	d0,d1
		lsr.l	#1,d1
		add.l	d1,d0
		tst.b	($FFFFEEDA).w
		bne.s	loc_5A0AC
		neg.l	d0

loc_5A0AC:
		move.l	d0,($FFFFEEE6).w
		btst	#3,$2A(a0)
		beq.s	loc_5A0DE
		lea	($FFFFB000).w,a1
		tst.b	($FFFFFAAA).w
		bne.s	loc_5A0D6
		btst	#4,$2B(a1)
		bne.s	loc_5A0D6
		tst.b	($FFFFFACD).w
		bne.s	loc_5A0D6
		jsr	(sub_24280).l

loc_5A0D6:

		move.l	($FFFFEEE6).w,d0
		add.l	d0,$10(a1)

loc_5A0DE:
		btst	#4,$2A(a0)
		beq.s	locret_5A104
		lea	($FFFFB04A).w,a1
		tst.b	($FFFFFAAA).w
		bne.s	loc_5A0FC
		tst.b	($FFFFFACD).w
		bne.s	loc_5A0FC
		jsr	(sub_24280).l

loc_5A0FC:

		move.l	($FFFFEEE6).w,d0
		add.l	d0,$10(a1)

locret_5A104:
		rts
; ---------------------------------------------------------------------------
word_5A106:	dc.w $310
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $7FFF
; ---------------------------------------------------------------------------

HPZ_ScreenInit:
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_5A13E
		move.w	#$AA0,($FFFFEE16).w
		bra.s	loc_5A14C
; ---------------------------------------------------------------------------

loc_5A13E:
		cmpi.w	#$480,($FFFFB014).w
		bcc.s	loc_5A14C
		move.w	#$AA0,($FFFFEE14).w

loc_5A14C:

		jsr	(Reset_TileOffsetPositionActual).l
		jmp	(Refresh_PlaneFull).l
; ---------------------------------------------------------------------------

HPZ_ScreenEvent:
		tst.w	($FFFFEED2).w
		bne.s	loc_5A176
		tst.w	($FFFFEE50).w
		bne.s	loc_5A176
		jsr	(Create_New_Sprite).l
		bne.s	loc_5A172
		move.l	#Obj_B1_2,(a1)

loc_5A172:
		st	($FFFFEED2).w

loc_5A176:

		move.w	($FFFFEECE).w,d0
		add.w	d0,($FFFFEE84).w
		tst.w	($FFFFEEC4).w
		beq.s	loc_5A19E
		clr.w	($FFFFEEC4).w
		movea.w	$1C(a3),a1
		move.b	#$61,$30(a1)
		move.b	#$61,$31(a1)
		jmp	(Refresh_PlaneScreenDirect).l
; ---------------------------------------------------------------------------

loc_5A19E:
		jmp	(DrawTilesAsYouMove).l
; ---------------------------------------------------------------------------

HPZ_BackgroundInit:
		move.w	$14(a3),$18(a3)
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_5A1C2
		movea.w	4(a3),a1
		move.b	#-$72,3(a1)
		move.b	#-$71,4(a1)

loc_5A1C2:
		cmpi.w	#$EC0,($FFFFB010).w
		bcc.s	loc_5A1D0
		jsr	sub_5A32C(pc)
		bra.s	loc_5A1DA
; ---------------------------------------------------------------------------

loc_5A1D0:
		move.w	#8,($FFFFEEC2).w
		jsr	sub_5A334(pc)

loc_5A1DA:
		jsr	(Reset_TileOffsetPositionEff).l
		lea	($FFFFA800).w,a1
		move.w	(a1)+,(a1)
		andi.w	#-$10,(a1)+
		move.w	(a1)+,(a1)
		andi.w	#-$10,(a1)
		lea	word_5A39C(pc),a4
		lea	($FFFFA800).w,a5
		jsr	(Refresh_PlaneTileDeform).l
		lea	word_5A3A0(pc),a4
		lea	($FFFFA808).w,a5
		jmp	(ApplyDeformation).l
; ---------------------------------------------------------------------------

HPZ_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_5A214(pc,d0.w)
; ---------------------------------------------------------------------------

loc_5A214:
		bra.w	loc_5A224
; ---------------------------------------------------------------------------
		bra.w	loc_5A288
; ---------------------------------------------------------------------------
		bra.w	loc_5A2A6
; ---------------------------------------------------------------------------
		bra.w	loc_5A30A
; ---------------------------------------------------------------------------

loc_5A224:
		cmpi.w	#$EC0,($FFFFB010).w
		bcs.s	loc_5A25E
		jsr	sub_5A334(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		lea	($FFFFA800).w,a1
		move.w	(a1)+,(a1)
		andi.w	#-$10,(a1)+
		move.w	(a1)+,(a1)
		andi.w	#-$10,(a1)
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_5A28C
; ---------------------------------------------------------------------------

loc_5A25E:
		jsr	sub_5A32C(pc)

loc_5A262:

		lea	word_5A39C(pc),a4
		lea	($FFFFA800).w,a5
		moveq	#$20,d6
		moveq	#2,d5
		jsr	(Draw_BG).l
		lea	word_5A3A0(pc),a4
		lea	($FFFFA808).w,a5
		jsr	(ApplyDeformation).l
		jmp	(ShakeScreen_Setup).l
; ---------------------------------------------------------------------------

loc_5A288:
		jsr	sub_5A334(pc)

loc_5A28C:
		lea	word_5A39C(pc),a4
		lea	($FFFFA7FC).w,a5
		move.w	($FFFFEE90).w,d1
		jsr	(Draw_PlaneVertBottomUpComplex).l
		bpl.s	loc_5A2E4
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_5A2E4
; ---------------------------------------------------------------------------

loc_5A2A6:
		cmpi.w	#$EC0,($FFFFB010).w
		bcc.s	loc_5A2E0
		jsr	sub_5A32C(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		lea	($FFFFA800).w,a1
		move.w	(a1)+,(a1)
		andi.w	#-$10,(a1)+
		move.w	(a1)+,(a1)
		andi.w	#-$10,(a1)
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_5A30E
; ---------------------------------------------------------------------------

loc_5A2E0:
		jsr	sub_5A334(pc)

loc_5A2E4:

		lea	word_5A39C(pc),a4
		lea	($FFFFA800).w,a5
		moveq	#$20,d6
		moveq	#2,d5
		jsr	(Draw_BG).l
		lea	word_5A3A0(pc),a4
		lea	($FFFFA808).w,a5
		jsr	(ApplyDeformation).l
		jmp	(ShakeScreen_Setup).l
; ---------------------------------------------------------------------------

loc_5A30A:
		jsr	sub_5A32C(pc)

loc_5A30E:
		lea	word_5A39C(pc),a4
		lea	($FFFFA7FC).w,a5
		move.w	($FFFFEE90).w,d1
		jsr	(Draw_PlaneVertBottomUpComplex).l
		bpl.w	loc_5A262
		clr.w	($FFFFEEC2).w
		bra.w	loc_5A262

; =============== S U B R O U T I N E =======================================


sub_5A32C:

		move.w	#$348,d2
		moveq	#0,d3
		bra.s	loc_5A33C
; End of function sub_5A32C


; =============== S U B R O U T I N E =======================================


sub_5A334:

		move.w	#$E00,d2
		move.w	#$700,d3

loc_5A33C:
		move.w	($FFFFEE84).w,d0
		move.w	($FFFFEECE).w,d4
		sub.w	d4,d0
		add.w	d3,d0
		swap	d0
		clr.w	d0
		asr.l	#4,d0
		move.l	d0,d1
		add.l	d0,d0
		add.l	d1,d0
		swap	d0
		add.w	d4,d0
		move.w	d0,($FFFFEE90).w
		move.w	($FFFFEE80).w,d0
		sub.w	d2,d0
		swap	d0
		clr.w	d0
		move.l	d0,d2
		asr.l	#4,d0
		move.l	d0,d1
		add.l	d0,d0
		add.l	d1,d0
		swap	d0
		move.w	d0,($FFFFA800).w
		move.w	d0,($FFFFA808).w
		lea	($FFFFA81C).w,a1
		move.l	d2,d0
		asr.l	#2,d2
		sub.l	d2,d0
		asr.l	#2,d2
		moveq	#8,d1

loc_5A388:
		swap	d0
		move.w	d0,-(a1)
		swap	d0
		sub.l	d2,d0
		dbf	d1,loc_5A388
		move.w	($FFFFA81A).w,($FFFFA804).w
		rts
; End of function sub_5A334

; ---------------------------------------------------------------------------
word_5A39C:	dc.w $200

		dc.w $7FFF
word_5A3A0:	dc.w $198

		dc.w 8
		dc.w 4
		dc.w 4
		dc.w 8
		dc.w 8
		dc.w $10
		dc.w 8
		dc.w $30
		dc.w $7FFF
; ---------------------------------------------------------------------------

DEZ3_ScreenInit:
		clr.w	($FFFFEEE2).w
		st	($FFFFEEE4).w
		jsr	sub_5A79E(pc)
		move.w	(a3),d0
		move.w	d0,$10(a3)
		move.w	d0,$12(a3)
		move.w	d0,$7C(a3)
		move.w	d0,$7E(a3)
		lea	($FFFF800A).w,a3
		move.w	#-$2000,d7
		lea	($FFFF8000).w,a1
		move.w	(a1),d0
		mulu.w	4(a1),d0
		move.w	2(a1),d1
		mulu.w	6(a1),d1
		add.w	d1,d0
		addi.w	#$88,d0
		adda.w	d0,a1
		move.w	#$FFF,d1
		sub.w	d0,d1

loc_5A3FA:
		clr.b	(a1)+
		dbf	d1,loc_5A3FA
		jsr	(Create_New_Sprite).l
		bne.s	loc_5A442
		move.l	#Obj_5A7C8,(a1)
		jsr	(CreateNewSprite4).l
		bne.s	loc_5A442
		move.l	#Obj_5A8E6,(a1)
		jsr	(CreateNewSprite4).l
		bne.s	loc_5A442
		move.l	#Obj_DEZ3_Boss,(a1)
		move.w	#$3C0,d0
		move.w	#$F8,d1
		move.w	d0,$10(a1)
		move.w	d1,$14(a1)
		move.w	d0,($FFFFEED4).w
		move.w	d1,($FFFFEED6).w

loc_5A442:

		move.w	#$6C0,($FFFFEED2).w
		st	($FFFFEE0A).w
		move.w	#$80,d0
		move.w	d0,($FFFFEE78).w
		move.w	d0,($FFFFEE80).w
		move.w	d0,($FFFFEEE8).w
		jsr	sub_5A508(pc)
		jsr	(Reset_TileOffsetPositionActual).l
		lea	($FFFFA800).w,a1
		clr.l	(a1)+
		move.w	(a1)+,(a1)
		andi.w	#-$10,(a1)+
		clr.w	(a1)
		lea	word_5A524(pc),a4
		lea	($FFFFA800).w,a5
		jmp	(Refresh_PlaneTileDeform).l
; ---------------------------------------------------------------------------

DEZ3_ScreenEvent:
		lea	($FFFF800A).w,a3
		move.w	#-$2000,d7
		move.w	($FFFFEEC0).w,d0
		jmp	loc_5A492(pc,d0.w)
; ---------------------------------------------------------------------------

loc_5A492:
		bra.w	loc_5A49A
; ---------------------------------------------------------------------------
		bra.w	loc_5A4C4
; ---------------------------------------------------------------------------

loc_5A49A:
		move.w	($FFFFEF5E).w,d0
		beq.s	loc_5A4AE
		clr.w	($FFFFEF5E).w
		move.w	d0,($FFFFFE20).w
		move.b	#1,($FFFFFE1D).w

loc_5A4AE:
		move.l	($FFFFEF60).w,d0
		beq.s	loc_5A4C0
		clr.l	($FFFFEF60).w
		move.l	d0,($FFFFFE22).w
		st	($FFFFFE1E).w

loc_5A4C0:
		addq.w	#4,($FFFFEEC0).w

loc_5A4C4:
		jsr	sub_5A508(pc)
		lea	word_5A524(pc),a4
		lea	($FFFFA800).w,a6
		moveq	#2,d5
		move.w	($FFFFEE8A).w,d6
		jsr	(Draw_BGNoVert).l
		move.w	($FFFFEED8).w,d1
		beq.s	locret_5A506
		clr.w	($FFFFEED8).w
		move.w	#$1E0,d0
		and.w	d0,d1
		moveq	#2,d6
		moveq	#1,d2

loc_5A4F0:
		movem.w	d0-d2/d6,-(sp)
		jsr	(Setup_TileRowDraw).l
		movem.w	(sp)+,d0-d2/d6
		addi.w	#$10,d0
		dbf	d2,loc_5A4F0

locret_5A506:
		rts

; =============== S U B R O U T I N E =======================================


sub_5A508:

		moveq	#$20,d0
		add.w	($FFFFEECE).w,d0
		move.w	d0,($FFFFEE84).w
		move.w	($FFFFEE80).w,d0
		move.w	d0,($FFFFA80A).w
		andi.w	#$1FF,d0
		move.w	d0,($FFFFA804).w
		rts
; End of function sub_5A508

; ---------------------------------------------------------------------------
word_5A524:	dc.w $E0

		dc.w $7FFF
; ---------------------------------------------------------------------------

DEZ3_BackgroundInit:
		lea	($FFFF8008).w,a3
		move.w	#-$4000,d7
		jsr	sub_5A76C(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		jsr	(Refresh_PlaneFull).l
		bra.w	loc_5A734
; ---------------------------------------------------------------------------

DEZ3_BackgroundEvent:
		lea	($FFFF8008).w,a3
		move.w	#-$4000,d7
		jsr	sub_5A76C(pc)
		move.w	($FFFFEEC2).w,d0
		jmp	loc_5A558(pc,d0.w)
; ---------------------------------------------------------------------------

loc_5A558:
		bra.w	loc_5A57C
; ---------------------------------------------------------------------------
		bra.w	loc_5A5B0
; ---------------------------------------------------------------------------
		bra.w	loc_5A5E0
; ---------------------------------------------------------------------------
		bra.w	loc_5A606
; ---------------------------------------------------------------------------
		bra.w	loc_5A61A
; ---------------------------------------------------------------------------
		bra.w	loc_5A662
; ---------------------------------------------------------------------------
		bra.w	loc_5A676
; ---------------------------------------------------------------------------
		bra.w	loc_5A71A
; ---------------------------------------------------------------------------
		bra.w	loc_5A72E
; ---------------------------------------------------------------------------

loc_5A57C:
		move.b	#1,($FFFFFE1C).w
		tst.w	($FFFFEEC6).w
		beq.w	loc_5A72E
		clr.w	($FFFFEEC6).w
		movea.w	8(a3),a1
		move.b	#$1A,$D(a1)
		move.w	($FFFFEE90).w,d0
		move.w	($FFFFEE8C).w,d1
		moveq	#$15,d6
		jsr	(Refresh_PlaneDirect).l
		addq.w	#4,($FFFFEEC2).w
		bra.w	loc_5A734
; ---------------------------------------------------------------------------

loc_5A5B0:
		tst.w	($FFFFEECC).w
		beq.w	loc_5A72E
		jsr	(Create_New_Sprite).l
		bne.s	loc_5A5DC
		move.l	#Obj_5A922,(a1)
		move.w	#$13,$2E(a1)
		move.w	#$2D0,$30(a1)
		move.w	#$2C0,($FFFFEEE8).w
		addq.w	#4,($FFFFEEC2).w

loc_5A5DC:
		bra.w	loc_5A72E
; ---------------------------------------------------------------------------

loc_5A5E0:
		cmpi.w	#$6C0,($FFFFEED2).w
		beq.w	loc_5A72E
		jsr	(Reset_TileOffsetPositionEff).l
		move.w	#$F0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		move.w	($FFFFEE8E).w,($FFFFEEDE).w
		addq.w	#4,($FFFFEEC2).w

loc_5A606:
		moveq	#0,d1
		moveq	#0,d2
		jsr	(Draw_PlaneVertBottomUp).l
		bpl.s	loc_5A61A
		clr.w	($FFFFEEDE).w
		addq.w	#4,($FFFFEEC2).w

loc_5A61A:

		cmpi.w	#$2C0,($FFFFEED2).w
		beq.w	loc_5A72E
		jsr	(Reset_TileOffsetPositionEff).l
		move.w	#$F0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		move.w	($FFFFEE8E).w,($FFFFEEDE).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_5A65E
		move.l	#Obj_5A94C,(a1)
		move.w	($FFFFEE80).w,d0
		andi.w	#-$20,d0
		move.w	d0,($FFFFEEE8).w
		subi.w	#$10,d0
		move.w	d0,$30(a1)

loc_5A65E:
		addq.w	#4,($FFFFEEC2).w

loc_5A662:
		moveq	#0,d1
		moveq	#0,d2
		jsr	(Draw_PlaneVertBottomUp).l
		bpl.s	loc_5A676
		clr.w	($FFFFEEDE).w
		addq.w	#4,($FFFFEEC2).w

loc_5A676:

		tst.w	($FFFFEED2).w
		beq.w	loc_5A6FE
		jsr	sub_5A79E(pc)
		tst.w	($FFFFEEC6).w
		beq.w	loc_5A72E
		clr.w	($FFFFEEC6).w
		move.w	($FFFFEEDC).w,d0
		jmp	loc_5A696(pc,d0.w)
; ---------------------------------------------------------------------------

loc_5A696:
		bra.s	loc_5A69E
; ---------------------------------------------------------------------------
		bra.s	loc_5A6A4
; ---------------------------------------------------------------------------
		bra.s	loc_5A69E
; ---------------------------------------------------------------------------
		bra.s	loc_5A6AA
; ---------------------------------------------------------------------------

loc_5A69E:

		move.w	#$603,d0
		bra.s	loc_5A6B4
; ---------------------------------------------------------------------------

loc_5A6A4:
		move.w	#$903,d0
		bra.s	loc_5A6B4
; ---------------------------------------------------------------------------

loc_5A6AA:
		move.w	#$807,d0
		move.w	#-2,($FFFFEEDC).w

loc_5A6B4:

		addq.w	#2,($FFFFEEDC).w
		movea.w	8(a3),a1
		move.b	d0,$E(a1)
		lsr.w	#8,d0
		movea.w	$C(a3),a1
		move.b	d0,$E(a1)
		move.w	#$700,d1
		move.w	#$160,d0
		moveq	#8,d6
		moveq	#9,d2
		move.w	($FFFFEE90).w,d3
		andi.w	#-$10,d3
		addi.w	#$E0,d3

loc_5A6E2:
		movem.w	d0-d3/d6,-(sp)
		jsr	(Setup_TileRowDraw).l
		movem.w	(sp)+,d0-d3/d6
		addi.w	#$10,d0
		cmp.w	d3,d0
		bhi.s	loc_5A6FC
		dbf	d2,loc_5A6E2

loc_5A6FC:
		bra.s	loc_5A72E
; ---------------------------------------------------------------------------

loc_5A6FE:
		jsr	(Reset_TileOffsetPositionEff).l
		move.w	#$F0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		move.w	($FFFFEE8E).w,($FFFFEEDE).w
		addq.w	#4,($FFFFEEC2).w

loc_5A71A:
		moveq	#0,d1
		moveq	#0,d2
		jsr	(Draw_PlaneVertBottomUp).l
		bpl.s	loc_5A72E
		clr.w	($FFFFEEDE).w
		addq.w	#4,($FFFFEEC2).w

loc_5A72E:

		jsr	(DrawBGAsYouMove).l

loc_5A734:

		lea	word_5A524(pc),a4
		lea	($FFFFA808).w,a5
		lea	($FFFFE000).w,a1
		move.w	($FFFFEE84).w,d0
		move.w	($FFFFEEDE).w,d3
		bne.s	loc_5A74E
		move.w	($FFFFEE8C).w,d3

loc_5A74E:
		move.w	#$DF,d1
		jsr	(ApplyDeformation2).l
		move.w	($FFFFEE90).w,($FFFFF616).w
		move.w	($FFFFEE84).w,($FFFFF618).w
		addq.w	#4,sp
		jmp	(ShakeScreen_Setup).l

; =============== S U B R O U T I N E =======================================


sub_5A76C:

		move.w	($FFFFEE8C).w,($FFFFEE8E).w
		tst.w	($FFFFEED2).w
		bne.s	loc_5A77C
		moveq	#0,d0
		bra.s	loc_5A788
; ---------------------------------------------------------------------------

loc_5A77C:
		move.w	($FFFFEE80).w,d0
		sub.w	($FFFFEED4).w,d0
		add.w	($FFFFEED2).w,d0

loc_5A788:
		move.w	d0,($FFFFEE8C).w
		move.w	($FFFFEE84).w,d0
		sub.w	($FFFFEED6).w,d0
		addi.w	#$180,d0
		move.w	d0,($FFFFEE90).w
		rts
; End of function sub_5A76C


; =============== S U B R O U T I N E =======================================


sub_5A79E:

		moveq	#0,d1
		move.w	($FFFFEEE2).w,d1
		cmp.w	($FFFFEEE4).w,d1
		beq.s	locret_5A7C6
		move.w	d1,($FFFFEEE4).w
		addq.w	#2,d1
		lsl.w	#2,d1
		addi.l	#ArtUnc_DEZFBLaser,d1
		move.w	#$4100,d2
		move.w	#$40,d3
		jsr	(Add_To_DMA_Queue).l

locret_5A7C6:
		rts
; End of function sub_5A79E

; ---------------------------------------------------------------------------

Obj_5A7C8:
		move.l	#loc_5A7EC,(a0)
		move.b	#$10,6(a0)
		move.w	#$130,$10(a0)
		move.w	#$F0,$14(a0)
		bset	#7,$2A(a0)
		move.w	#$80,$2E(a0)

loc_5A7EC:
		cmpi.b	#$17,($FFFFFE10).w
		beq.s	loc_5A7FA
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_5A7FA:
		move.w	($FFFFEEDA).w,d1
		beq.s	loc_5A83C
		clr.w	($FFFFEEDA).w
		cmp.w	($FFFFEEE8).w,d1
		bcs.s	loc_5A83C
		jsr	(Create_New_Sprite3).l
		bne.s	loc_5A82C
		move.l	#Obj_5A872,(a1)
		move.w	d1,$10(a1)
		move.w	$2E(a0),d2
		subi.w	#$20,d2
		cmp.w	d1,d2
		bhi.s	loc_5A82C
		move.w	d1,($FFFFEED8).w

loc_5A82C:

		moveq	#$20,d0
		add.w	d0,($FFFFEEE8).w
		cmp.w	$2E(a0),d1
		bcs.s	loc_5A83C
		add.w	d0,$10(a0)

loc_5A83C:

		moveq	#-$20,d1
		move.w	($FFFFEE80).w,d0
		andi.w	#-$20,d0
		move.w	$2E(a0),d2
		cmp.w	d2,d0
		beq.s	loc_5A860
		bcs.s	loc_5A858
		cmp.w	($FFFFEEE8).w,d2
		bcs.s	loc_5A85C
		neg.w	d1

loc_5A858:
		add.w	d1,$10(a0)

loc_5A85C:
		move.w	d0,$2E(a0)

loc_5A860:
		move.w	#$B0,d1
		moveq	#$10,d2
		moveq	#$10,d3
		move.w	$10(a0),d4
		jmp	(SolidObjectTop).l
; ---------------------------------------------------------------------------

Obj_5A872:
		move.l	#loc_5A8B2,(a0)
		move.b	#-$7C,4(a0)
		move.b	#$10,6(a0)
		move.b	#$C,7(a0)
		move.w	#$80,8(a0)
		move.w	#-$3FFF,$A(a0)
		move.l	#Map_DEZ3Blocks,$C(a0)
		move.w	#$F0,$14(a0)
		move.w	$10(a0),d0
		andi.w	#$60,d0
		lsr.w	#5,d0
		move.b	d0,$22(a0)

loc_5A8B2:
		tst.b	4(a0)
		bmi.s	loc_5A8C4
		move.w	($FFFFF7DA).w,d0
		addi.w	#$400,d0
		move.w	d0,$10(a0)

loc_5A8C4:
		jsr	(MoveSprite2).l
		addi.w	#$1A,$1A(a0)
		moveq	#$10,d1
		moveq	#$10,d2
		moveq	#$10,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_5A8E6:
		move.l	#loc_5A904,(a0)
		move.b	#$10,6(a0)
		move.w	#$40,$10(a0)
		move.w	#$F0,$14(a0)
		bset	#7,$2A(a0)

loc_5A904:
		cmpi.w	#$6C0,($FFFFEED2).w
		beq.s	loc_5A912
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_5A912:
		moveq	#$40,d1
		moveq	#$10,d2
		moveq	#$10,d3
		move.w	$10(a0),d4
		jmp	(SolidObjectTop).l
; ---------------------------------------------------------------------------

Obj_5A922:
		subq.w	#1,$32(a0)
		bpl.s	locret_5A94A
		move.w	#$F,$32(a0)
		move.w	$30(a0),($FFFFEEDA).w
		addi.w	#$20,$30(a0)
		subq.w	#1,$2E(a0)
		bne.s	locret_5A94A
		clr.w	($FFFFEECC).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

locret_5A94A:

		rts
; ---------------------------------------------------------------------------

Obj_5A94C:
		cmpi.b	#$17,($FFFFFE10).w
		beq.s	loc_5A95A
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_5A95A:
		tst.w	($FFFFEED2).w
		bne.s	loc_5A97C
		move.w	($FFFFEE80).w,d0
		addi.w	#$9C,d0
		cmp.w	$30(a0),d0
		bcs.s	locret_5A9AA
		move.w	$30(a0),($FFFFEEDA).w
		addi.w	#$20,$30(a0)
		bra.s	locret_5A9AA
; ---------------------------------------------------------------------------

loc_5A97C:
		cmpi.w	#$110,($FFFFEED6).w
		bcc.s	locret_5A9AA
		subq.w	#1,$32(a0)
		bpl.s	locret_5A9AA
		move.w	($FFFFEED4).w,d0
		addi.w	#$90,d0
		cmp.w	$30(a0),d0
		bcs.s	locret_5A9AA
		move.w	$30(a0),($FFFFEEDA).w
		addi.w	#$20,$30(a0)
		move.w	#$D,$32(a0)

locret_5A9AA:

		rts
; ---------------------------------------------------------------------------
Map_DEZ3Blocks:	include "Levels\DEZ\Misc Object Data\Map - Act 3 Blocks.asm"

; ---------------------------------------------------------------------------

HPZS_ScreenInit:
		tst.b	($FFFFFFB0).w
		beq.s	loc_5AA14
		move.b	($FFFFFE16).w,d0
		ori.b	#-$80,d0
		move.b	d0,($FFFFEF70).w

loc_5AA14:
		movea.w	$10(a3),a1
		clr.b	$29(a1)
		clr.b	$2B(a1)
		movea.w	$14(a3),a1
		clr.b	$29(a1)
		jsr	(Reset_TileOffsetPositionActual).l
		jmp	(Refresh_PlaneFull).l
; ---------------------------------------------------------------------------

HPZS_ScreenEvent:
		move.w	($FFFFEECE).w,d0
		add.w	d0,($FFFFEE84).w
		jmp	(DrawTilesAsYouMove).l
; ---------------------------------------------------------------------------

HPZS_BackgroundInit:
		jsr	sub_5A334(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		lea	($FFFFA800).w,a1
		move.w	(a1)+,(a1)
		andi.w	#-$10,(a1)+
		move.w	(a1)+,(a1)
		andi.w	#-$10,(a1)
		lea	word_5A39C(pc),a4
		lea	($FFFFA800).w,a5
		jsr	(Refresh_PlaneTileDeform).l
		lea	word_5A3A0(pc),a4
		lea	($FFFFA808).w,a5
		jmp	(ApplyDeformation).l
; ---------------------------------------------------------------------------

HPZS_BackgroundEvent:
		jsr	sub_5A334(pc)
		lea	word_5A39C(pc),a4
		lea	($FFFFA800).w,a5
		moveq	#$20,d6
		moveq	#2,d5
		jsr	(Draw_BG).l
		lea	word_5A3A0(pc),a4
		lea	($FFFFA808).w,a5
		jsr	(ApplyDeformation).l
		jmp	(ShakeScreen_Setup).l
; ---------------------------------------------------------------------------

Ending_ScreenInit:
		jsr	(Create_New_Sprite).l
		bne.s	loc_5AAB0
		move.l	#Obj_5D86A,(a1)

loc_5AAB0:
		st	($FFFFEF72).w
		st	($FFFFEE0A).w
		move.b	#3,($FFFFB02E).w
		move.l	#$2000000,d0
		move.l	d0,($FFFFEE78).w
		move.l	d0,($FFFFEE80).w
		move.l	d0,($FFFFEE7C).w
		move.l	d0,($FFFFEE84).w
		clr.l	($FFFFEE98).w
		clr.l	($FFFFEE9C).w
		move.w	#$2B4,($FFFFEED4).w
		jsr	sub_5B11C(pc)
		jsr	(Reset_TileOffsetPositionActual).l
		jmp	(Refresh_PlaneFull).l
; ---------------------------------------------------------------------------

Ending_ScreenEvent:
		move.w	($FFFFEEC0).w,d0
		jmp	loc_5AAFA(pc,d0.w)
; ---------------------------------------------------------------------------

loc_5AAFA:
		bra.w	loc_5AB36
; ---------------------------------------------------------------------------
		bra.w	loc_5AB58
; ---------------------------------------------------------------------------
		bra.w	loc_5AB6E
; ---------------------------------------------------------------------------
		bra.w	loc_5ABBC
; ---------------------------------------------------------------------------
		bra.w	loc_5AC70
; ---------------------------------------------------------------------------
		bra.w	loc_5ACFC
; ---------------------------------------------------------------------------
		bra.w	loc_5AD16
; ---------------------------------------------------------------------------
		bra.w	loc_5AD30
; ---------------------------------------------------------------------------
		bra.w	loc_5AD56
; ---------------------------------------------------------------------------
		bra.w	loc_5AD8E
; ---------------------------------------------------------------------------
		bra.w	loc_5AE0A
; ---------------------------------------------------------------------------
		bra.w	loc_5AE76
; ---------------------------------------------------------------------------
		bra.w	loc_5AE90
; ---------------------------------------------------------------------------
		bra.w	loc_5AEA8
; ---------------------------------------------------------------------------
		bra.w	loc_5AED4
; ---------------------------------------------------------------------------

loc_5AB36:
		tst.w	($FFFFEEC4).w
		beq.w	loc_5AEE4
		clr.w	($FFFFEEC4).w
		move.w	($FFFFEE98).w,($FFFFEED2).w
		jsr	sub_5AEEA(pc)
		jsr	(Reset_TileOffsetPositionActual).l
		addq.w	#4,($FFFFEEC0).w
		bra.s	loc_5AB62
; ---------------------------------------------------------------------------

loc_5AB58:
		tst.w	($FFFFEEC4).w
		bne.s	loc_5AB66
		jsr	sub_5AEEA(pc)

loc_5AB62:
		bra.w	loc_5AEE4
; ---------------------------------------------------------------------------

loc_5AB66:
		clr.w	($FFFFEEC4).w
		addq.w	#4,($FFFFEEC0).w

loc_5AB6E:
		jsr	sub_5AEEA(pc)
		cmpi.b	#7,($FFFFFFB0).w
		bcs.s	loc_5AB96
		moveq	#0,d0
		move.w	($FFFFEED8).w,d0
		addi.w	#$10,d0
		cmpi.w	#-$8000,d0
		bcs.s	loc_5AB8E
		move.w	#-$8000,d0

loc_5AB8E:
		move.w	d0,($FFFFEED8).w
		sub.l	d0,($FFFFEED4).w

loc_5AB96:
		tst.w	($FFFFEEC4).w
		beq.w	loc_5AEE4
		clr.w	($FFFFEEC4).w
		move.w	#$3F,($FFFFF626).w
		move.w	#$15,($FFFFEEDA).w
		st	($FFFFEE50).w
		st	($FFFFF650).w
		addq.w	#4,($FFFFEEC0).w
		bra.s	loc_5ABC0
; ---------------------------------------------------------------------------

loc_5ABBC:
		jsr	sub_5AEEA(pc)

loc_5ABC0:
		move.l	a0,-(sp)
		jsr	(Pal_ToBlack).l
		movea.l	(sp)+,a0
		subq.w	#1,($FFFFEEDA).w
		bpl.w	loc_5AEE4
		lea	($FFFFAC00).w,a1
		moveq	#0,d0
		move.w	#$FF,d1

loc_5ABDC:
		move.l	d0,(a1)+
		dbf	d1,loc_5ABDC
		lea	($FFFFB04A).w,a1
		moveq	#0,d0
		move.w	#$7EC,d1

loc_5ABEC:
		move.l	d0,(a1)+
		dbf	d1,loc_5ABEC
		cmpi.b	#7,($FFFFFFB1).w
		bcc.s	loc_5AC04
		move.w	#$24,($FFFFEEC0).w
		bra.w	loc_5ADC0
; ---------------------------------------------------------------------------

loc_5AC04:
		jsr	(Create_New_Sprite).l
		bne.s	loc_5AC12
		move.l	#Obj_5DFEE,(a1)

loc_5AC12:
		movem.l	d7-a0/a2-a3,-(sp)
		lea	(AIZ1_128x128_Kos).l,a1
		lea	($FFFF0000).l,a2
		jsr	(Queue_Kos).l
		lea	(AIZ1_16x16_Primary_Kos).l,a1
		lea	($FFFF9000).w,a2
		jsr	(Queue_Kos).l
		lea	(AIZ1_16x16_MainLevel_Kos).l,a1
		lea	($FFFF9268).w,a2
		jsr	(Queue_Kos).l
		lea	(AIZ1_8x8_Primary_KosM).l,a1
		move.w	#0,d2
		jsr	(Queue_Kos_Module).l
		lea	(AIZ1_8x8_MainLevel_KosM).l,a1
		move.w	#$17C0,d2
		jsr	(Queue_Kos_Module).l
		movem.l	(sp)+,d7-a0/a2-a3
		addq.w	#4,($FFFFEEC0).w

loc_5AC70:
		tst.b	($FFFFFF60).w
		bne.w	loc_5AEE4
		movem.l	d7-a0/a2-a3,-(sp)
		clr.w	($FFFFFE10).w
		move.b	#1,($FFFFFE2A).w
		jsr	(Load_Level).l
		jsr	(LoadSolids).l
		move.w	#$D01,($FFFFFE10).w
		clr.b	($FFFFFE2A).w
		moveq	#3,d0
		jsr	(LoadPalette).l
		moveq	#$2A,d0
		jsr	(LoadPalette).l
		lea	(Pal_EndingObjects).l,a1
		lea	($FFFFFCA0).w,a2
		moveq	#7,d6

loc_5ACB8:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_5ACB8
		jsr	(Adjust_AIZ1Chunks2).l
		movem.l	(sp)+,d7-a0/a2-a3
		move.w	#$1EB8,d0
		move.w	d0,($FFFFEE78).w
		move.w	d0,($FFFFEE80).w
		move.w	#$1E0,d0
		move.w	d0,($FFFFEE7C).w
		move.w	d0,($FFFFEE84).w
		jsr	(Reset_TileOffsetPositionActual).l
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC0).w

loc_5ACFC:
		move.w	($FFFFEE80).w,d1
		move.w	($FFFFEE84).w,d2
		jsr	(Draw_PlaneVertBottomUp).l
		bpl.w	loc_5AEE4
		addq.w	#4,($FFFFEEC2).w
		addq.w	#4,($FFFFEEC0).w

loc_5AD16:
		cmpi.w	#$10,($FFFFEEC2).w
		bcs.w	loc_5AEE4
		move.w	#$3F,($FFFFF626).w
		move.w	#$15,($FFFFEEDA).w
		addq.w	#4,($FFFFEEC0).w

loc_5AD30:
		move.l	a0,-(sp)
		jsr	(Pal_FromBlack).l
		movea.l	(sp)+,a0
		subq.w	#1,($FFFFEEDA).w
		bpl.w	loc_5AEE4
		clr.w	($FFFFEE50).w
		clr.b	($FFFFF650).w
		clr.w	($FFFFF634).w
		clr.w	($FFFFF632).w
		addq.w	#4,($FFFFEEC0).w

loc_5AD56:
		tst.w	($FFFFEEC4).w
		bne.s	loc_5AD72
		addi.l	#$1000,($FFFFEEDC).w
		move.l	a0,-(sp)
		jsr	(AnPal_AIZ1).l
		movea.l	(sp)+,a0
		bra.w	loc_5AEE4
; ---------------------------------------------------------------------------

loc_5AD72:
		clr.w	($FFFFEEC4).w
		move.w	#$3F,($FFFFF626).w
		move.w	#$15,($FFFFEEDA).w
		st	($FFFFEE50).w
		st	($FFFFF650).w
		addq.w	#4,($FFFFEEC0).w

loc_5AD8E:
		move.l	a0,-(sp)
		jsr	(Pal_ToBlack).l
		movea.l	(sp)+,a0
		subq.w	#1,($FFFFEEDA).w
		bpl.w	loc_5AEE4
		lea	($FFFFAC00).w,a1
		moveq	#0,d0
		move.w	#$FF,d1

loc_5ADAA:
		move.l	d0,(a1)+
		dbf	d1,loc_5ADAA
		lea	($FFFFB04A).w,a1
		moveq	#0,d0
		move.w	#$7EC,d1

loc_5ADBA:
		move.l	d0,(a1)+
		dbf	d1,loc_5ADBA

loc_5ADC0:
		jsr	(Create_New_Sprite).l
		bne.s	loc_5ADCE
		move.l	#Obj_Ending,(a1)

loc_5ADCE:
		movem.l	d7-a0/a2-a3,-(sp)
		lea	(SSZ2_128x128_Kos).l,a1
		lea	($FFFF0000).l,a2
		jsr	(Queue_Kos).l
		lea	(SSZ2_16x16_Kos).l,a1
		lea	($FFFF9000).w,a2
		jsr	(Queue_Kos).l
		lea	(ArtKosM_SSZ2).l,a1
		moveq	#0,d2
		jsr	(Queue_Kos_Module).l
		movem.l	(sp)+,d7-a0/a2-a3
		addq.w	#4,($FFFFEEC0).w

loc_5AE0A:
		tst.b	($FFFFFF60).w
		bne.w	loc_5AEE4
		movem.l	d7-a0/a2-a3,-(sp)
		jsr	(Load_Level).l
		jsr	(LoadSolids).l
		moveq	#3,d0
		jsr	(LoadPalette).l
		lea	(Pal_Ending1).l,a1
		lea	($FFFFFCA0).w,a5
		moveq	#$17,d0

loc_5AE36:
		move.l	(a1)+,(a5)+
		dbf	d0,loc_5AE36
		jsr	sub_5B11C(pc)
		movem.l	(sp)+,d7-a0/a2-a3
		move.l	#$2000000,d0
		move.l	d0,($FFFFEE78).w
		move.l	d0,($FFFFEE80).w
		move.l	d0,($FFFFEE7C).w
		move.l	d0,($FFFFEE84).w
		jsr	(Reset_TileOffsetPositionActual).l
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC0).w

loc_5AE76:
		move.w	($FFFFEE80).w,d1
		move.w	($FFFFEE84).w,d2
		jsr	(Draw_PlaneVertBottomUp).l
		bpl.s	loc_5AEE4
		move.w	#$14,($FFFFEEC2).w
		addq.w	#4,($FFFFEEC0).w

loc_5AE90:
		cmpi.w	#4,($FFFFEEC2).w
		bhi.s	loc_5AEE4
		move.w	#$3F,($FFFFF626).w
		move.w	#$15,($FFFFEEDA).w
		addq.w	#4,($FFFFEEC0).w

loc_5AEA8:
		move.l	a0,-(sp)
		jsr	(Pal_FromBlack).l
		movea.l	(sp)+,a0
		subq.w	#1,($FFFFEEDA).w
		bpl.s	loc_5AEE4
		clr.w	($FFFFEE50).w
		clr.b	($FFFFF650).w
		clr.w	($FFFFF634).w
		clr.w	($FFFFF632).w
		clr.l	($FFFFEE7C).w
		clr.l	($FFFFEE84).w
		addq.w	#4,($FFFFEEC0).w

loc_5AED4:
		movem.l	d7-a0/a2-a3,-(sp)
		jsr	(sub_5B18E).l
		movem.l	(sp)+,d7-a0/a2-a3
		rts
; ---------------------------------------------------------------------------

loc_5AEE4:

		jmp	(DrawTilesAsYouMove).l

; =============== S U B R O U T I N E =======================================


sub_5AEEA:

		move.w	($FFFFEE98).w,d0
		sub.w	($FFFFEED2).w,d0
		addi.w	#$140,d0
		move.w	d0,($FFFFEE80).w
		move.w	($FFFFEE9C).w,d0
		sub.w	($FFFFEED4).w,d0
		move.w	d0,($FFFFEE84).w
		rts
; End of function sub_5AEEA

; ---------------------------------------------------------------------------

Ending_BackgroundInit:
		jsr	sub_5B092(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		move.w	#$200,d1
		jsr	(Refresh_PlaneFull).l
		lea	word_5B144(pc),a4
		lea	($FFFFA804).w,a5
		jmp	(ApplyDeformation).l
; ---------------------------------------------------------------------------

Ending_BackgroundEvent:
		move.w	($FFFFEEC2).w,d0
		jmp	loc_5AF32(pc,d0.w)
; ---------------------------------------------------------------------------

loc_5AF32:
		bra.w	loc_5AF4E
; ---------------------------------------------------------------------------
		bra.w	loc_5AF84
; ---------------------------------------------------------------------------
		bra.w	loc_5AFC4
; ---------------------------------------------------------------------------
		bra.w	loc_5AFF0
; ---------------------------------------------------------------------------
		bra.w	loc_5B012
; ---------------------------------------------------------------------------
		bra.w	loc_5B03A
; ---------------------------------------------------------------------------
		bra.w	loc_5B072
; ---------------------------------------------------------------------------

loc_5AF4E:
		tst.w	($FFFFEEC6).w
		bne.s	loc_5AF5A
		jsr	sub_5B092(pc)
		bra.s	loc_5AF88
; ---------------------------------------------------------------------------

loc_5AF5A:
		clr.w	($FFFFEEC6).w
		lea	(Pal_Ending1).l,a1
		lea	($FFFFFC20).w,a5
		moveq	#$17,d0

loc_5AF6A:
		move.l	(a1)+,(a5)+
		dbf	d0,loc_5AF6A
		jsr	sub_5B116(pc)
		move.w	#$220,d0
		move.w	d0,($FFFFEE9C).w
		move.w	d0,($FFFFEE96).w
		addq.w	#4,($FFFFEEC2).w

loc_5AF84:
		jsr	sub_5B0A8(pc)

loc_5AF88:

		lea	($FFFFEE90).w,a6
		lea	($FFFFEE96).w,a5
		move.w	#$200,d1
		moveq	#$20,d6
		jsr	(Draw_TileRow).l
		lea	word_5B144(pc),a4
		tst.w	($FFFFEEC2).w
		beq.s	loc_5AFAA
		lea	word_5B15A(pc),a4

loc_5AFAA:
		lea	($FFFFA804).w,a5
		jsr	(ApplyDeformation).l
		lea	sub_592EE(pc),a1
		tst.w	($FFFFEEC2).w
		beq.s	loc_5AFC2
		lea	sub_5928C(pc),a1

loc_5AFC2:
		jmp	(a1)
; ---------------------------------------------------------------------------

loc_5AFC4:
		jsr	(AIZ1_Deform).l
		jsr	(Reset_TileOffsetPositionEff).l
		clr.l	($FFFFA800).w
		move.w	d2,($FFFFA806).w
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_5AFF6
; ---------------------------------------------------------------------------

loc_5AFF0:
		jsr	(AIZ1_Deform).l

loc_5AFF6:
		lea	(AIZ1_DrawArray).l,a4
		lea	($FFFFA7FC).w,a5
		move.w	($FFFFEE90).w,d1
		jsr	(Draw_PlaneVertBottomUpComplex).l
		bpl.s	loc_5B020
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_5B020
; ---------------------------------------------------------------------------

loc_5B012:
		jsr	(AIZ1_Deform).l
		move.w	($FFFFEEDC).w,d0
		sub.w	d0,($FFFFEE90).w

loc_5B020:

		lea	(AIZ1_DrawArray).l,a4
		lea	($FFFFA800).w,a5
		moveq	#$20,d6
		moveq	#2,d5
		jsr	(Draw_BG).l
		jmp	(AIZ1_ApplyDeformWater).l
; ---------------------------------------------------------------------------

loc_5B03A:
		movea.w	$1C(a3),a1
		addq.w	#4,a1
		move.b	#$1A,(a1)+
		move.b	#$1B,(a1)+
		move.b	#$1A,(a1)+
		move.b	#$1B,(a1)+
		jsr	sub_5B0A8(pc)
		jsr	(Reset_TileOffsetPositionEff).l
		addi.w	#$E0,d0
		and.w	($FFFFEEAC).w,d0
		move.w	d0,($FFFFEEC8).w
		move.w	#$F,($FFFFEECA).w
		addq.w	#4,($FFFFEEC2).w
		bra.s	loc_5B076
; ---------------------------------------------------------------------------

loc_5B072:
		jsr	sub_5B0A8(pc)

loc_5B076:
		move.w	#$200,d1
		move.w	($FFFFEE90).w,d2
		jsr	(Draw_PlaneVertBottomUp).l
		bpl.w	loc_5AF88
		move.w	#4,($FFFFEEC2).w
		bpl.w	loc_5AF88

; =============== S U B R O U T I N E =======================================


sub_5B092:

		move.w	($FFFFEE9C).w,d0
		cmpi.w	#$120,d0
		bls.s	loc_5B0A0
		move.w	#$120,d0

loc_5B0A0:
		move.w	d0,($FFFFEE90).w
		jmp	loc_58D44(pc)
; End of function sub_5B092


; =============== S U B R O U T I N E =======================================


sub_5B0A8:

		move.w	($FFFFEE9C).w,($FFFFEE90).w
		move.w	($FFFFEE98).w,d0
		swap	d0
		clr.w	d0
		move.l	d0,d1
		asr.l	#4,d1
		lea	($FFFFA800).w,a1
		add.l	(a1),d1
		addi.l	#$800,(a1)+
		lea	$10(a1),a1
		moveq	#$1F,d2

loc_5B0CC:
		swap	d0
		move.w	d0,(a1)+
		move.w	d0,(a1)+
		move.w	d0,(a1)+
		move.w	d0,(a1)+
		swap	d0
		add.l	d1,d0
		dbf	d2,loc_5B0CC
		lea	($FFFFA814).w,a1
		move.w	(a1),d0
		move.w	d0,-4(a1)
		move.w	d0,-$C(a1)
		move.w	8(a1),d0
		move.w	d0,-8(a1)
		move.w	$10(a1),d0
		move.w	d0,-2(a1)
		move.w	$18(a1),d0
		move.w	d0,-$E(a1)
		move.w	$20(a1),d0
		move.w	d0,-$A(a1)
		move.w	$28(a1),d0
		move.w	d0,-6(a1)
		rts
; End of function sub_5B0A8


; =============== S U B R O U T I N E =======================================


sub_5B116:
		lea	($FFFFFC20).w,a6
		bra.s	loc_5B120
; End of function sub_5B116


; =============== S U B R O U T I N E =======================================


sub_5B11C:

		lea	($FFFFFCA0).w,a6

loc_5B120:
		lea	($FFFFFCA0).w,a5
		lea	Pal_5B16E(pc),a1
		moveq	#7,d0

loc_5B12A:
		move.l	(a1),(a5)+
		move.l	(a1)+,(a6)+
		dbf	d0,loc_5B12A
		lea	(Pal_EndingObjects).l,a1
		moveq	#7,d0

loc_5B13A:
		move.l	(a1),(a5)+
		move.l	(a1)+,(a6)+
		dbf	d0,loc_5B13A
		rts
; End of function sub_5B11C

; ---------------------------------------------------------------------------
word_5B144:	dc.w $A0

		dc.w 8
		dc.w 8
		dc.w 4
		dc.w 4
		dc.w 8
		dc.w 8
		dc.w $18
		dc.w $10
		dc.w $10
		dc.w $7FFF
word_5B15A:	dc.w $300
		dc.w $24
		dc.w 4
		dc.w $14
		dc.w 4
		dc.w $1C
		dc.w 4
		dc.w $20
		dc.w $8080
		dc.w $7FFF
Pal_5B16E:	binclude "General\Ending\Palettes\Sky.bin"


; =============== S U B R O U T I N E =======================================


sub_5B18E:

		move.w	($FFFFFA86).w,d0
		move.w	off_5B19A(pc,d0.w),d0
		jmp	off_5B19A(pc,d0.w)
; End of function sub_5B18E

; ---------------------------------------------------------------------------
off_5B19A:	dc.w loc_5B1A2-off_5B19A

		dc.w loc_5B1F4-off_5B19A
		dc.w loc_5B204-off_5B19A
		dc.w locret_5B2D4-off_5B19A
; ---------------------------------------------------------------------------

loc_5B1A2:
		addq.w	#2,($FFFFFA86).w
		clr.b	($FFFFFACC).w
		clr.l	($FFFFEE7C).w
		clr.l	($FFFFF616).w
		clr.w	($FFFFFAAE).w
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_5B1D2
		jsr	(Create_New_Sprite).l
		bne.s	loc_5B1D2
		move.l	#Obj_Song_Fade_Transition,(a1)
		move.b	#-$24,$2C(a1)

loc_5B1D2:

		bsr.w	sub_5B514
		move.w	#$EEE,($FFFFFC02).w
		move.w	#$EE,($FFFFFC22).w
		lea	PLC_5B1EC(pc),a1
		jmp	(Load_PLC_Raw).l
; ---------------------------------------------------------------------------
PLC_5B1EC:	dc.w 0
		dc.l ArtNem_BlueSphereText
		dc.w $68E0
; ---------------------------------------------------------------------------

loc_5B1F4:
		subq.w	#1,($FFFFF660).w
		bpl.s	locret_5B202
		addq.w	#2,($FFFFFA86).w
		bsr.w	sub_5B42A

locret_5B202:
		rts
; ---------------------------------------------------------------------------

loc_5B204:
		move.l	($FFFFEE7C).w,d0
		move.l	d0,d1
		add.l	($FFFFFAC8).w,d0
		move.l	d0,($FFFFEE7C).w
		swap	d0
		swap	d1
		eor.w	d0,d1
		btst	#4,d1
		beq.s	locret_5B282
		lsl.w	#4,d0
		addi.w	#$E00,d0
		move.w	d0,d1
		andi.w	#$F00,d1
		bsr.w	sub_5B2D6
		moveq	#0,d2
		tst.w	($FFFFFFAE).w
		beq.s	loc_5B238
		moveq	#8,d2

loc_5B238:
		add.w	($FFFFFAAE).w,d2
		movea.l	off_5B284(pc,d2.w),a1
		move.w	($FFFFFA84).w,d2
		move.w	(a1,d2.w),d2
		lea	(a1,d2.w),a1
		move.w	(a1)+,d2
		cmpi.w	#-8,d2
		beq.s	loc_5B294
		cmpi.w	#-$C,d2
		beq.s	loc_5B29E
		move.w	d2,d3
		andi.w	#-$100,d0
		andi.w	#-$100,d3
		cmp.w	d0,d3
		bne.s	locret_5B282
		move.w	#-$7CB9,d6
		bclr	#0,d2
		beq.s	loc_5B276
		move.w	#-$5CB9,d6

loc_5B276:
		andi.w	#$FFE,d2
		bsr.w	sub_5B318
		addq.w	#2,($FFFFFA84).w

locret_5B282:

		rts
; ---------------------------------------------------------------------------
off_5B284:	dc.l off_5BC8A
		dc.l off_5BF48
		dc.l off_5B6E6
		dc.l off_5B9A4
; ---------------------------------------------------------------------------

loc_5B294:
		addq.w	#4,($FFFFFAAE).w
		clr.w	($FFFFFA84).w
		rts
; ---------------------------------------------------------------------------

loc_5B29E:
		addq.w	#2,($FFFFFA86).w
		clr.l	($FFFFFE22).w
		st	($FFFFEEC4).w
		st	($FFFFFACC).w
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_5B2B8
		rts
; ---------------------------------------------------------------------------

loc_5B2B8:
		tst.b	($FFFFFA88).w
		bmi.s	loc_5B2CE
		jsr	(Create_New_Sprite).l
		bne.s	locret_5B2CC
		move.l	#Obj_5EF68,(a1)

locret_5B2CC:
		rts
; ---------------------------------------------------------------------------

loc_5B2CE:
		clr.b	($FFFFFAB9).w
		rts
; ---------------------------------------------------------------------------

locret_5B2D4:
		rts

; =============== S U B R O U T I N E =======================================


sub_5B2D6:
		move	#$2700,sr
		lea	($C00000).l,a6
		move.w	d1,d2
		addi.w	#-$4000,d2
		swap	d2
		clr.w	d2
		swap	d2
		lsl.l	#2,d2
		lsr.w	#2,d2
		ori.w	#$4000,d2
		swap	d2
		move.l	#$800000,d3
		moveq	#0,d4
		moveq	#1,d5

loc_5B300:
		move.l	d2,4(a6)
		moveq	#$27,d6

loc_5B306:
		move.w	d4,(a6)
		dbf	d6,loc_5B306
		add.l	d3,d2
		dbf	d5,loc_5B300
		move	#$2300,sr

locret_5B316:
		rts
; End of function sub_5B2D6


; =============== S U B R O U T I N E =======================================


sub_5B318:

		bsr.w	sub_5B36C
		move	#$2700,sr
		lea	($C00000).l,a6
		addi.w	#-$4000,d2
		swap	d2
		clr.w	d2
		swap	d2
		lsl.l	#2,d2
		lsr.w	#2,d2
		ori.w	#$4000,d2
		swap	d2
		move.l	d2,d3
		addi.l	#$800000,d3
		lea	($FFFF7000).l,a1
		move.l	d2,4(a6)
		subq.w	#1,d0
		move.w	d0,d1

loc_5B350:
		move.w	(a1)+,(a6)
		dbf	d0,loc_5B350
		lea	($FFFF7080).l,a1
		move.l	d3,4(a6)

loc_5B360:
		move.w	(a1)+,(a6)
		dbf	d1,loc_5B360
		move	#$2300,sr
		rts
; End of function sub_5B318


; =============== S U B R O U T I N E =======================================


sub_5B36C:
		lea	($FFFF7000).l,a2
		lea	($FFFF7080).l,a3
		moveq	#0,d0

loc_5B37A:

		moveq	#0,d1
		move.b	(a1)+,d1
		beq.s	locret_5B316
		cmpi.b	#$20,d1
		beq.w	loc_5B420
		cmpi.b	#$3F,d1
		beq.w	loc_5B418
		cmpi.b	#$21,d1
		beq.s	loc_5B410
		cmpi.b	#$26,d1
		beq.s	loc_5B408
		cmpi.b	#$29,d1
		beq.s	loc_5B400
		cmpi.b	#$28,d1
		beq.s	loc_5B3F8
		cmpi.b	#$2E,d1
		beq.s	loc_5B3F0
		cmpi.b	#$49,d1
		beq.s	loc_5B3DC
		addq.w	#2,d0
		subi.b	#$41,d1
		lsl.w	#3,d1
		lea	word_5B566(pc),a4
		adda.w	d1,a4

loc_5B3C2:

		move.w	(a4)+,d5
		add.w	d6,d5
		move.w	d5,(a2)+
		move.w	(a4)+,d5
		add.w	d6,d5
		move.w	d5,(a2)+
		move.w	(a4)+,d5
		add.w	d6,d5
		move.w	d5,(a3)+
		move.w	(a4)+,d5
		add.w	d6,d5
		move.w	d5,(a3)+
		bra.s	loc_5B37A
; ---------------------------------------------------------------------------

loc_5B3DC:
		addq.w	#1,d0
		lea	word_5B5A6(pc),a4

loc_5B3E2:

		move.w	(a4)+,d5
		add.w	d6,d5
		move.w	d5,(a2)+
		move.w	(a4)+,d5
		add.w	d6,d5
		move.w	d5,(a3)+
		bra.s	loc_5B37A
; ---------------------------------------------------------------------------

loc_5B3F0:
		addq.w	#1,d0
		lea	word_5B636(pc),a4
		bra.s	loc_5B3E2
; ---------------------------------------------------------------------------

loc_5B3F8:
		addq.w	#1,d0
		lea	word_5B63A(pc),a4
		bra.s	loc_5B3E2
; ---------------------------------------------------------------------------

loc_5B400:
		addq.w	#1,d0
		lea	word_5B63E(pc),a4
		bra.s	loc_5B3E2
; ---------------------------------------------------------------------------

loc_5B408:
		addq.w	#2,d0
		lea	word_5B642(pc),a4
		bra.s	loc_5B3C2
; ---------------------------------------------------------------------------

loc_5B410:
		addq.w	#1,d0
		lea	word_5B64A(pc),a4
		bra.s	loc_5B3E2
; ---------------------------------------------------------------------------

loc_5B418:
		addq.w	#2,d0
		lea	word_5B64E(pc),a4
		bra.s	loc_5B3C2
; ---------------------------------------------------------------------------

loc_5B420:
		addq.w	#1,d0
		clr.w	(a2)+
		clr.w	(a3)+
		bra.w	loc_5B37A
; End of function sub_5B36C


; =============== S U B R O U T I N E =======================================


sub_5B42A:
		lea	(ArtKosM_ANDKnuckles).l,a1
		move.w	#$7DE0,d2
		jsr	(Queue_Kos_Module).l
		move.w	($FFFFFF08).w,d0
		moveq	#0,d1
		andi.w	#3,d0
		subq.w	#2,d0
		bmi.s	loc_5B452
		beq.s	loc_5B44E
		addi.w	#$18,d1

loc_5B44E:
		addi.w	#$18,d1

loc_5B452:
		tst.w	($FFFFFFAE).w
		bne.s	loc_5B45C
		addi.w	#$C,d1

loc_5B45C:
		tst.b	($FFFFFA88).w
		bmi.s	loc_5B46C
		beq.s	loc_5B468
		addi.w	#4,d1

loc_5B468:
		addi.w	#4,d1

loc_5B46C:
		movea.l	off_5B472(pc,d1.w),a2
		jmp	(a2)
; End of function sub_5B42A

; ---------------------------------------------------------------------------
off_5B472:	dc.l loc_5B4C4
		dc.l loc_5B4C4
		dc.l loc_5B4C4
		dc.l sub_5B4E8
		dc.l sub_5B4E8
		dc.l loc_5B4F8
		dc.l sub_5B4E8
		dc.l sub_5B4E8
		dc.l loc_5B4F8
		dc.l sub_5B4E8
		dc.l sub_5B4E8
		dc.l loc_5B4F8
		dc.l loc_5B4C4
		dc.l loc_5B4BA
		dc.l loc_5B4BA
		dc.l sub_5B4E8
		dc.l loc_5B4DE
		dc.l loc_5B4D4
; ---------------------------------------------------------------------------

loc_5B4BA:
		lea	PLC_5B50C(pc),a1
		jsr	(Load_PLC_Raw).l

loc_5B4C4:
		lea	(ArtKosM_SKPoseBanner).l,a1
		move.w	#-$7D60,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

loc_5B4D4:
		lea	PLC_5B504(pc),a1
		jsr	(Load_PLC_Raw).l

loc_5B4DE:
		lea	PLC_5B50C(pc),a1
		jsr	(Load_PLC_Raw).l

; =============== S U B R O U T I N E =======================================


sub_5B4E8:

		lea	(ArtKosM_S3PoseBanner).l,a1
		move.w	#-$7D60,d2
		jmp	(Queue_Kos_Module).l
; End of function sub_5B4E8

; ---------------------------------------------------------------------------

loc_5B4F8:
		bsr.s	sub_5B4E8
		lea	PLC_5B504(pc),a1
		jmp	(Load_PLC_Raw).l
; ---------------------------------------------------------------------------
PLC_5B504:	dc.w 0

		dc.l ArtNem_S3EndingGraphics
		dc.w $8BA0
PLC_5B50C:	dc.w 0

		dc.l ArtNem_Knux_Ending_Pose
		dc.w $5820

; =============== S U B R O U T I N E =======================================


sub_5B514:
		moveq	#0,d1
		tst.w	($FFFFFFAE).w
		bne.s	loc_5B520
		addi.w	#$24,d1

loc_5B520:
		btst	#6,($FFFFFFD8).w
		beq.s	loc_5B52C
		addi.w	#$12,d1

loc_5B52C:
		move.w	($FFFFFF08).w,d0
		subq.w	#2,d0
		bmi.s	loc_5B53E
		beq.s	loc_5B53A
		addi.w	#6,d1

loc_5B53A:
		addi.w	#6,d1

loc_5B53E:
		tst.b	($FFFFFA88).w
		bmi.s	loc_5B54A
		beq.s	loc_5B548
		addq.w	#2,d1

loc_5B548:
		addq.w	#2,d1

loc_5B54A:
		lea	word_5B69E(pc),a1
		moveq	#0,d0
		move.w	(a1,d1.w),d0
		lsl.l	#8,d0
		move.l	d0,($FFFFFAC8).w
		lea	word_5B656(pc),a1
		move.w	(a1,d1.w),($FFFFF660).w
		rts
; End of function sub_5B514

; ---------------------------------------------------------------------------
word_5B566:	dc.w	  0,  $800,	1,     2
		dc.w	  3,	 4,	5,     6
		dc.w	  7,	 8,	9,    $A
		dc.w	  3,  $807,    $B,  $809
		dc.w	  3,	$C,	5,    $D
		dc.w	  3,	$C,    $E,    $F
		dc.w	  7,	 8,	9,   $10
		dc.w	$11,  $811,    $E, $180B
word_5B5A6:	dc.w	$11,   $12
		dc.w	  0,	 0
		dc.w	$13,  $811
		dc.w	$14,   $15
		dc.w	$16,   $17
		dc.w	$18,   $19
		dc.w	$11,   $13
		dc.w	 $B,   $1A
		dc.w	$1B,   $1C
		dc.w	$1D,   $1E
		dc.w	$1B,  $811
		dc.w	$1D,   $1F
		dc.w	  7,  $807
		dc.w	  9,  $809
		dc.w	$20,   $21
		dc.w	$22,   $23
		dc.w	  7,  $807
		dc.w	  9,   $24
		dc.w	$20,   $21
		dc.w	$25,   $26
		dc.w   $821,	$C
		dc.w	$27,	 6
		dc.w	$28,   $29
		dc.w	$2A,   $2B
		dc.w	$11,  $811
		dc.w   $815,   $15
		dc.w	$2C,  $82C
		dc.w	$2D,  $82D
		dc.w	$2E,  $811
		dc.w	$2F,   $30
		dc.w	$31,  $831
		dc.w	$32,  $832
		dc.w	$31,   $33
		dc.w	$2A,   $2B
		dc.w   $80C,   $34
		dc.w	$35,   $36
word_5B636:	dc.w   $13
		dc.w   $37
word_5B63A:	dc.w $38
		dc.w $1038
word_5B63E:	dc.w $838
		dc.w $1838
word_5B642:	dc.w $39
		dc.w $3A
		dc.w $3B
		dc.w $3C
word_5B64A:	dc.w $812
		dc.w $3D
word_5B64E:	dc.w $180A
		dc.w $3E
		dc.w $3F
		dc.w $40
word_5B656:	dc.w $30C
		dc.w $2B2
		dc.w $30C
		dc.w $2EE
		dc.w $2EE
		dc.w $2EE
		dc.w $A5
		dc.w $78
		dc.w $78
		dc.w $226
		dc.w $1C0
		dc.w $226
		dc.w $3C
		dc.w $3C
		dc.w $3C
		dc.w $87
		dc.w $96
		dc.w $64
		dc.w $2EE
		dc.w $294
		dc.w 0
		dc.w $2EE
		dc.w $2EE
		dc.w 0
		dc.w $A5
		dc.w $78
		dc.w $78
		dc.w $208
		dc.w $19D
		dc.w 0
		dc.w $208
		dc.w $208
		dc.w 0
		dc.w $64
		dc.w $96
		dc.w $96
word_5B69E:	dc.w $C3
		dc.w $C3
		dc.w $C3
		dc.w $100
		dc.w $100
		dc.w $100
		dc.w $BD
		dc.w $B1
		dc.w $B1
		dc.w $E8
		dc.w $E8
		dc.w $100
		dc.w $100
		dc.w $100
		dc.w $100
		dc.w $E5
		dc.w $D6
		dc.w $100
		dc.w $CE
		dc.w $CE
		dc.w $CF
		dc.w $CE
		dc.w $CE
		dc.w $CD
		dc.w $C8
		dc.w $BC
		dc.w $BC
		dc.w $F5
		dc.w $F5
		dc.w $FD
		dc.w $F5
		dc.w $F5
		dc.w $FB
		dc.w $F2
		dc.w $E2
		dc.w $E2
off_5B6E6:	dc.w byte_5B72E-off_5B6E6

		dc.w byte_5B744-off_5B6E6
		dc.w byte_5B756-off_5B6E6
		dc.w byte_5B76A-off_5B6E6
		dc.w byte_5B77C-off_5B6E6
		dc.w byte_5B78E-off_5B6E6
		dc.w byte_5B7A0-off_5B6E6
		dc.w byte_5B7AC-off_5B6E6
		dc.w byte_5B7B8-off_5B6E6
		dc.w byte_5B7C4-off_5B6E6
		dc.w byte_5B7D8-off_5B6E6
		dc.w byte_5B7EE-off_5B6E6
		dc.w byte_5B802-off_5B6E6
		dc.w byte_5B81A-off_5B6E6
		dc.w byte_5B82E-off_5B6E6
		dc.w byte_5B840-off_5B6E6
		dc.w byte_5B852-off_5B6E6
		dc.w byte_5B85E-off_5B6E6
		dc.w byte_5B874-off_5B6E6
		dc.w byte_5B886-off_5B6E6
		dc.w byte_5B89A-off_5B6E6
		dc.w byte_5B8B0-off_5B6E6
		dc.w byte_5B8C6-off_5B6E6
		dc.w byte_5B8D4-off_5B6E6
		dc.w byte_5B8E4-off_5B6E6
		dc.w byte_5B8F4-off_5B6E6
		dc.w byte_5B908-off_5B6E6
		dc.w byte_5B918-off_5B6E6
		dc.w byte_5B928-off_5B6E6
		dc.w byte_5B938-off_5B6E6
		dc.w byte_5B948-off_5B6E6
		dc.w byte_5B958-off_5B6E6
		dc.w byte_5B96E-off_5B6E6
		dc.w byte_5B982-off_5B6E6
		dc.w byte_5B992-off_5B6E6
		dc.w byte_5B9A2-off_5B6E6
byte_5B72E:	dc.b $F
		dc.b 7
aExecutiveProducer:dc.b	"EXECUTIVE PRODUCER",0,0
byte_5B744:	dc.b $11
		dc.b $E
aHayaoNakayama:	dc.b "HAYAO NAKAYAMA",0,0
byte_5B756:	dc.b $21
		dc.b $B
aProjectManagers_1:dc.b	"PROJECT MANAGERS",0,0
byte_5B76A:	dc.b $23
		dc.b $10
aHisashiSuzuki:	dc.b "HISASHI SUZUKI",0,0
byte_5B77C:	dc.b $24
		dc.b $E
aShinobuToyoda:	dc.b "SHINOBU TOYODA",0,0
byte_5B78E:	dc.b $25
		dc.b $E
aMasaharuYoshii:dc.b "MASAHARU YOSHII",0
byte_5B7A0:	dc.b $35
		dc.b $19
aProducer:	dc.b "PRODUCER",0,0
byte_5B7AC:	dc.b $37
		dc.b $18
aYujiNaka:	dc.b "YUJI NAKA",0
byte_5B7B8:	dc.b $47
		dc.b $1B
aDirector:	dc.b "DIRECTOR",0,0
byte_5B7C4:	dc.b $49
		dc.b 8
aHirokazuYasuhara_1:dc.b "HIROKAZU YASUHARA",0
byte_5B7D8:	dc.b $59
		dc.b 9
aLeadGameDesigner:dc.b "LEAD GAME DESIGNER",0,0
byte_5B7EE:	dc.b $5B
		dc.b 8
aHirokazuYasuhara_0:dc.b "HIROKAZU YASUHARA",0
byte_5B802:	dc.b $6B
		dc.b 3
aSeniorGameDesigners:dc.b "SENIOR GAME DESIGNERS",0
byte_5B81A:	dc.b $6D
		dc.b $A
aHisayoshiYoshida:dc.b "HISAYOSHI YOSHIDA",0
byte_5B82E:	dc.b $6E
		dc.b $10
aTakashiIizuka:	dc.b "TAKASHI IIZUKA",0,0
byte_5B840:	dc.b $7E
		dc.b $B
aLeadProgrammer_0:dc.b "LEAD PROGRAMMER",0
byte_5B852:	dc.b $80
		dc.b $18
aYujiNaka_0:	dc.b "YUJI NAKA",0
byte_5B85E:	dc.b $90
		dc.b 7
aSeniorProgrammers:dc.b	"SENIOR PROGRAMMERS",0,0
byte_5B874:	dc.b $92
		dc.b $C
aTakahiroHamano:dc.b "TAKAHIRO HAMANO",0
byte_5B886:	dc.b $93
		dc.b 8
aMasanobuYamamoto:dc.b "MASANOBU YAMAMOTO",0
byte_5B89A:	dc.b $A3
		dc.b 7
aCharacterDesigner:dc.b	"CHARACTER DESIGNER",0,0
byte_5B8B0:	dc.b $A5
		dc.b 6
aTakashiThomasYuda:dc.b	"TAKASHI THOMAS YUDA",0
byte_5B8C6:	dc.b $B5
		dc.b $17
aC_g_Artist:	dc.b "C.G. ARTIST",0
byte_5B8D4:	dc.b $B7
		dc.b $12
aKunitakeAoki:	dc.b "KUNITAKE AOKI",0
byte_5B8E4:	dc.b $C7
		dc.b $13
aEnemyArtist:	dc.b "ENEMY ARTIST",0,0
byte_5B8F4:	dc.b $C9
		dc.b $A
aSatoshiYokokawa_1:dc.b	"SATOSHI YOKOKAWA",0,0
byte_5B908:	dc.b $D9
		dc.b $11
aSceneArtists:	dc.b "SCENE ARTISTS",0
byte_5B918:	dc.b $DB
		dc.b $12
aKunitakeAoki_0:dc.b "KUNITAKE AOKI",0
byte_5B928:	dc.b $DC
		dc.b $14
aChieYoshida:	dc.b "CHIE YOSHIDA",0,0
byte_5B938:	dc.b $DD
		dc.b $12
aTsunekoAoki:	dc.b "TSUNEKO AOKI",0,0
byte_5B948:	dc.b $DE
		dc.b $10
aShigeruOkada:	dc.b "SHIGERU OKADA",0
byte_5B958:	dc.b $DF
		dc.b 6
aTakashiThomasYuda_0:dc.b "TAKASHI THOMAS YUDA",0
byte_5B96E:	dc.b $E0
		dc.b $A
aSatoshiYokokawa_2:dc.b	"SATOSHI YOKOKAWA",0,0
byte_5B982:	dc.b $F0
		dc.b $11
aArtAssistant:	dc.b "ART ASSISTANT",0
byte_5B992:	dc.b $F2
		dc.b $12
aOsamuOhashi:	dc.b "OSAMU OHASHI",0,0
byte_5B9A2:	dc.b $FF
		dc.b $F8
off_5B9A4:	dc.w byte_5B9F6-off_5B9A4

		dc.w byte_5BA08-off_5B9A4
		dc.w byte_5BA1A-off_5B9A4
		dc.w byte_5BA2C-off_5B9A4
		dc.w byte_5BA32-off_5B9A4
		dc.w byte_5BA42-off_5B9A4
		dc.w byte_5BA4A-off_5B9A4
		dc.w byte_5BA5E-off_5B9A4
		dc.w byte_5BA70-off_5B9A4
		dc.w byte_5BA82-off_5B9A4
		dc.w byte_5BA94-off_5B9A4
		dc.w byte_5BAA2-off_5B9A4
		dc.w byte_5BABA-off_5B9A4
		dc.w byte_5BAD2-off_5B9A4
		dc.w byte_5BAE2-off_5B9A4
		dc.w byte_5BAF0-off_5B9A4
		dc.w byte_5BB02-off_5B9A4
		dc.w byte_5BB12-off_5B9A4
		dc.w byte_5BB2A-off_5B9A4
		dc.w byte_5BB3C-off_5B9A4
		dc.w byte_5BB4C-off_5B9A4
		dc.w byte_5BB62-off_5B9A4
		dc.w byte_5BB72-off_5B9A4
		dc.w byte_5BB88-off_5B9A4
		dc.w byte_5BB92-off_5B9A4
		dc.w byte_5BB9E-off_5B9A4
		dc.w byte_5BBAC-off_5B9A4
		dc.w byte_5BBBC-off_5B9A4
		dc.w byte_5BBD4-off_5B9A4
		dc.w byte_5BBE2-off_5B9A4
		dc.w byte_5BBF0-off_5B9A4
		dc.w byte_5BC04-off_5B9A4
		dc.w byte_5BC14-off_5B9A4
		dc.w byte_5BC26-off_5B9A4
		dc.w byte_5BC38-off_5B9A4
		dc.w byte_5BC48-off_5B9A4
		dc.w byte_5BC5C-off_5B9A4
		dc.w byte_5BC6A-off_5B9A4
		dc.w byte_5BC7A-off_5B9A4
		dc.w byte_5BC82-off_5B9A4
		dc.w byte_5BC88-off_5B9A4
byte_5B9F6:	dc.b 2
		dc.b $D
aMusicComposers:dc.b "MUSIC COMPOSERS",0
byte_5BA08:	dc.b 4
		dc.b $E
aHowardDrossin:	dc.b "HOWARD DROSSIN",0,0
byte_5BA1A:	dc.b $14
		dc.b $D
aSegaSoundTeam:	dc.b "SEGA SOUND TEAM",0
byte_5BA2C:	dc.b $16
		dc.b $24
aBo:		dc.b "BO",0,0
byte_5BA32:	dc.b $17
		dc.b $12
aSachioOgawa:	dc.b "SACHIO OGAWA",0,0
byte_5BA42:	dc.b $18
		dc.b $20
aMilpo:		dc.b "MILPO",0
byte_5BA4A:	dc.b $19
		dc.b $A
aMasaruSetsumaru:dc.b "MASARU SETSUMARU",0,0
byte_5BA5E:	dc.b $1A
		dc.b $C
aTatsuyukiMaeda:dc.b "TATSUYUKI MAEDA",0
byte_5BA70:	dc.b $1B
		dc.b $C
aTomonoriSawada:dc.b "TOMONORI SAWADA",0
byte_5BA82:	dc.b $1C
		dc.b $E
aMasayukiNagao:	dc.b "MASAYUKI NAGAO",0,0
byte_5BA94:	dc.b $1D
		dc.b $16
aJunSenoue:	dc.b "JUN SENOUE",0,0
byte_5BAA2:	dc.b $2D
		dc.b 3
aExecutiveManagement:dc.b "EXECUTIVE MANAGEMENT",0,0
byte_5BABA:	dc.b $2F
		dc.b 6
		dc.b $53
aHouichirouIrimajiri:dc.b "HOUICHIROU IRIMAJIRI",0
byte_5BAD2:	dc.b $30
		dc.b $12
aTomKalinske:	dc.b "TOM KALINSKE",0,0
byte_5BAE2:	dc.b $31
		dc.b $16
aPaulRioux:	dc.b "PAUL RIOUX",0,0
byte_5BAF0:	dc.b $41
		dc.b $D
aProductManager:dc.b "PRODUCT MANAGER",0
byte_5BB02:	dc.b $43
		dc.b $12
aPamelaKelly:	dc.b "PAMELA KELLY",0,0
byte_5BB12:	dc.b $53
		dc.b 3
aExecutiveCoordinator:dc.b "EXECUTIVE COORDINATOR",0
byte_5BB2A:	dc.b $55
		dc.b $E
aMamoruShigeta:	dc.b "MAMORU SHIGETA",0,0
byte_5BB3C:	dc.b $56
		dc.b $14
aTomioTakami:	dc.b "TOMIO TAKAMI",0,0
byte_5BB4C:	dc.b $57
		dc.b $A
aDianeA_Fornasier:dc.b "DIANE A. FORNASIER ",0
byte_5BB62:	dc.b $58
		dc.b $12
aRogerHector:	dc.b "ROGER HECTOR",0,0
byte_5BB72:	dc.b $59
		dc.b 4
aTakaharuUtsunomiya:dc.b "TAKAHARU UTSUNOMIYA",0
byte_5BB88:	dc.b $69
		dc.b $1B
aTesters:	dc.b "TESTERS",0
byte_5BB92:	dc.b $6B
		dc.b $16
aJasonKuo:	dc.b "JASON KUO",0
byte_5BB9E:	dc.b $6C
		dc.b $16
aRickGreer:	dc.b "RICK GREER",0,0
byte_5BBAC:	dc.b $6D
		dc.b $12
aMikeWilliams:	dc.b "MIKE WILLIAMS",0
byte_5BBBC:	dc.b $7D
		dc.b 5
aSoundSpecialThanks:dc.b "SOUND SPECIAL THANKS",0,0
byte_5BBD4:	dc.b $7F
		dc.b $16
aCubeCorp_:	dc.b "CUBE CORP.",0,0
byte_5BBE2:	dc.b $80
		dc.b $16
aOpusCorp_:	dc.b "OPUS CORP.",0,0
byte_5BBF0:	dc.b $81
		dc.b 8
aMasanoriNakayama:dc.b "MASANORI NAKAYAMA",0
byte_5BC04:	dc.b $82
		dc.b $14
aStudioWho:	dc.b "(STUDIO WHO)",0,0
byte_5BC14:	dc.b $92
		dc.b $F
aSpecialThanks:	dc.b "SPECIAL THANKS",0,0
byte_5BC26:	dc.b $94
		dc.b $10
aJinaIshiwatari:dc.b "JINA ISHIWATARI",0
byte_5BC38:	dc.b $95
		dc.b $12
aEmiKawamura:	dc.b "EMI KAWAMURA",0,0
byte_5BC48:	dc.b $96
		dc.b 8
aDeborahMccracken_0:dc.b "DEBORAH MCCRACKEN",0
byte_5BC5C:	dc.b $97
		dc.b $14
aTakuMakino:	dc.b "TAKU MAKINO",0
byte_5BC6A:	dc.b $AB
		dc.b $13
aPresentedBy:	dc.b "PRESENTED BY",0,0
byte_5BC7A:	dc.b $AD
		dc.b $20
aSega:		dc.b "SEGA",0,0
byte_5BC82:	dc.b $BD
		dc.b $20
		dc.b "  ",0,0
byte_5BC88:	dc.b $FF
		dc.b $F4
off_5BC8A:	dc.w byte_5BCD2-off_5BC8A

		dc.w byte_5BCE8-off_5BC8A
		dc.w byte_5BCFA-off_5BC8A
		dc.w byte_5BD0E-off_5BC8A
		dc.w byte_5BD20-off_5BC8A
		dc.w byte_5BD32-off_5BC8A
		dc.w byte_5BD44-off_5BC8A
		dc.w byte_5BD50-off_5BC8A
		dc.w byte_5BD5C-off_5BC8A
		dc.w byte_5BD68-off_5BC8A
		dc.w byte_5BD7C-off_5BC8A
		dc.w byte_5BD92-off_5BC8A
		dc.w byte_5BDA6-off_5BC8A
		dc.w byte_5BDBE-off_5BC8A
		dc.w byte_5BDD2-off_5BC8A
		dc.w byte_5BDE4-off_5BC8A
		dc.w byte_5BDF6-off_5BC8A
		dc.w byte_5BE02-off_5BC8A
		dc.w byte_5BE18-off_5BC8A
		dc.w byte_5BE2A-off_5BC8A
		dc.w byte_5BE3E-off_5BC8A
		dc.w byte_5BE54-off_5BC8A
		dc.w byte_5BE6A-off_5BC8A
		dc.w byte_5BE78-off_5BC8A
		dc.w byte_5BE88-off_5BC8A
		dc.w byte_5BE98-off_5BC8A
		dc.w byte_5BEAC-off_5BC8A
		dc.w byte_5BEBC-off_5BC8A
		dc.w byte_5BECC-off_5BC8A
		dc.w byte_5BEDC-off_5BC8A
		dc.w byte_5BEEC-off_5BC8A
		dc.w byte_5BEFC-off_5BC8A
		dc.w byte_5BF12-off_5BC8A
		dc.w byte_5BF26-off_5BC8A
		dc.w byte_5BF36-off_5BC8A
		dc.w byte_5BF46-off_5BC8A
byte_5BCD2:	dc.b $F
		dc.b 7
aExecutiveProducer_1:dc.b "EXECUTIVE PRODUCER",0,0
byte_5BCE8:	dc.b $11
		dc.b $E
aHayaoNakayama_1:dc.b "HAYAO NAKAYAMA",0,0
byte_5BCFA:	dc.b $21
		dc.b $B
aProjectManagers:dc.b "PROJECT MANAGERS",0,0
byte_5BD0E:	dc.b $23
		dc.b $10
aHisashiSuzuki_1:dc.b "HISASHI SUZUKI",0,0
byte_5BD20:	dc.b $24
		dc.b $E
aShinobuToyoda_1:dc.b "SHINOBU TOYODA",0,0
byte_5BD32:	dc.b $25
		dc.b $E
aMasaharuYoshii_0:dc.b "MASAHARU YOSHII",0
byte_5BD44:	dc.b $35
		dc.b $19
aProducer_1:	dc.b "PRODUCER",0,0
byte_5BD50:	dc.b $37
		dc.b $18
aYujiNaka_1:	dc.b "YUJI NAKA",0
byte_5BD5C:	dc.b $47
		dc.b $1B
aDirector_1:	dc.b "DIRECTOR",0,0
byte_5BD68:	dc.b $49
		dc.b 8
aHirokazuYasuhara_2:dc.b "HIROKAZU YASUHARA",0
byte_5BD7C:	dc.b $59
		dc.b 9
aLeadGameDesigner_1:dc.b "LEAD GAME DESIGNER",0,0
byte_5BD92:	dc.b $5B
		dc.b 8
aHirokazuYasuhara:dc.b "HIROKAZU YASUHARA",0
byte_5BDA6:	dc.b $6B
		dc.b 3
aSeniorGameDesigners_0:dc.b "SENIOR GAME DESIGNERS",0
byte_5BDBE:	dc.b $6D
		dc.b $A
aHisayoshiYoshida_0:dc.b "HISAYOSHI YOSHIDA",0
byte_5BDD2:	dc.b $6E
		dc.b $10
aTakashiIizuka_1:dc.b "TAKASHI IIZUKA",0,0
byte_5BDE4:	dc.b $7E
		dc.b $B
aLeadProgrammer:dc.b "LEAD PROGRAMMER",0
byte_5BDF6:	dc.b $80
		dc.b $18
aYujiNaka_2:	dc.b "YUJI NAKA",0
byte_5BE02:	dc.b $90
		dc.b 7
aSeniorProgrammers_1:dc.b "SENIOR PROGRAMMERS",0,0
byte_5BE18:	dc.b $92
		dc.b $C
aTakahiroHamano_0:dc.b "TAKAHIRO HAMANO",0
byte_5BE2A:	dc.b $93
		dc.b 8
aMasanobuYamamoto_0:dc.b "MASANOBU YAMAMOTO",0
byte_5BE3E:	dc.b $A3
		dc.b 7
aCharacterDesigner_1:dc.b "CHARACTER DESIGNER",0,0
byte_5BE54:	dc.b $A5
		dc.b 6
aTakashiThomasYuda_1:dc.b "TAKASHI THOMAS YUDA",0
byte_5BE6A:	dc.b $B5
		dc.b $17
aC_g_Artist_0:	dc.b "C.G. ARTIST",0
byte_5BE78:	dc.b $B7
		dc.b $12
aKunitakeAoki_1:dc.b "KUNITAKE AOKI",0
byte_5BE88:	dc.b $C7
		dc.b $13
aEnemyArtist_1:	dc.b "ENEMY ARTIST",0,0
byte_5BE98:	dc.b $C9
		dc.b $A
aSatoshiYokokawa:dc.b "SATOSHI YOKOKAWA",0,0
byte_5BEAC:	dc.b $D9
		dc.b $11
aSceneArtists_0:dc.b "SCENE ARTISTS",0
byte_5BEBC:	dc.b $DB
		dc.b $12
aKunitakeAoki_2:dc.b "KUNITAKE AOKI",0
byte_5BECC:	dc.b $DC
		dc.b $14
aChieYoshida_1:	dc.b "CHIE YOSHIDA",0,0
byte_5BEDC:	dc.b $DD
		dc.b $12
aTsunekoAoki_1:	dc.b "TSUNEKO AOKI",0,0
byte_5BEEC:	dc.b $DE
		dc.b $10
aShigeruOkada_0:dc.b "SHIGERU OKADA",0
byte_5BEFC:	dc.b $DF
		dc.b 6
aTakashiThomasYuda_2:dc.b "TAKASHI THOMAS YUDA",0
byte_5BF12:	dc.b $E0
		dc.b $A
aSatoshiYokokawa_3:dc.b	"SATOSHI YOKOKAWA",0,0
byte_5BF26:	dc.b $F0
		dc.b $11
aArtAssistant_0:dc.b "ART ASSISTANT",0
byte_5BF36:	dc.b $F2
		dc.b $12
aOsamuOhashi_1:	dc.b "OSAMU OHASHI",0,0
byte_5BF46:	dc.b $FF
		dc.b $F8
off_5BF48:	dc.w byte_5BFAE-off_5BF48

		dc.w byte_5BFC0-off_5BF48
		dc.w byte_5BFCE-off_5BF48
		dc.w byte_5BFDE-off_5BF48
		dc.w byte_5BFEC-off_5BF48
		dc.w byte_5BFFA-off_5BF48
		dc.w byte_5C00E-off_5BF48
		dc.w byte_5C01A-off_5BF48
		dc.w byte_5C02C-off_5BF48
		dc.w byte_5C03E-off_5BF48
		dc.w byte_5C044-off_5BF48
		dc.w byte_5C054-off_5BF48
		dc.w byte_5C05C-off_5BF48
		dc.w byte_5C070-off_5BF48
		dc.w byte_5C082-off_5BF48
		dc.w byte_5C094-off_5BF48
		dc.w byte_5C0A6-off_5BF48
		dc.w byte_5C0B4-off_5BF48
		dc.w byte_5C0C8-off_5BF48
		dc.w byte_5C0D8-off_5BF48
		dc.w byte_5C0F0-off_5BF48
		dc.w byte_5C108-off_5BF48
		dc.w byte_5C118-off_5BF48
		dc.w byte_5C126-off_5BF48
		dc.w byte_5C138-off_5BF48
		dc.w byte_5C148-off_5BF48
		dc.w byte_5C160-off_5BF48
		dc.w byte_5C172-off_5BF48
		dc.w byte_5C182-off_5BF48
		dc.w byte_5C198-off_5BF48
		dc.w byte_5C1A8-off_5BF48
		dc.w byte_5C1BE-off_5BF48
		dc.w byte_5C1C8-off_5BF48
		dc.w byte_5C1D4-off_5BF48
		dc.w byte_5C1E2-off_5BF48
		dc.w byte_5C1F2-off_5BF48
		dc.w byte_5C20A-off_5BF48
		dc.w byte_5C222-off_5BF48
		dc.w byte_5C22A-off_5BF48
		dc.w byte_5C238-off_5BF48
		dc.w byte_5C246-off_5BF48
		dc.w byte_5C25A-off_5BF48
		dc.w byte_5C26A-off_5BF48
		dc.w byte_5C27C-off_5BF48
		dc.w byte_5C28E-off_5BF48
		dc.w byte_5C29E-off_5BF48
		dc.w byte_5C2B2-off_5BF48
		dc.w byte_5C2C0-off_5BF48
		dc.w byte_5C2D0-off_5BF48
		dc.w byte_5C2D8-off_5BF48
		dc.w byte_5C2DE-off_5BF48
byte_5BFAE:	dc.b 2
		dc.b $D
aMusicComposers_0:dc.b "MUSIC COMPOSERS",0
byte_5BFC0:	dc.b 4
		dc.b $16
aBradBuxer:	dc.b "BRAD BUXER",0,0
byte_5BFCE:	dc.b 5
		dc.b $12
aBobbyBrooks:	dc.b "BOBBY BROOKS",0,0
byte_5BFDE:	dc.b 6
		dc.b $14
aDarrylRoss:	dc.b "DARRYL ROSS",0
byte_5BFEC:	dc.b 7
		dc.b $14
aGeoffGrace:	dc.b "GEOFF GRACE",0
byte_5BFFA:	dc.b 8
		dc.b $E
aDougGrigsbyIii:dc.b "DOUG GRIGSBY III",0,0
byte_5C00E:	dc.b 9
		dc.b $1A
aScirocco:	dc.b "SCIROCCO",0,0
byte_5C01A:	dc.b $A
		dc.b $E
aHowardDrossin_1:dc.b "HOWARD DROSSIN",0,0
byte_5C02C:	dc.b $1A
		dc.b $D
aSegaSoundTeam_0:dc.b "SEGA SOUND TEAM",0
byte_5C03E:	dc.b $1C
		dc.b $24
aBo_1:		dc.b "BO",0,0
byte_5C044:	dc.b $1D
		dc.b $12
aSachioOgawa_1:	dc.b "SACHIO OGAWA",0,0
byte_5C054:	dc.b $1E
		dc.b $20
aMilpo_0:	dc.b "MILPO",0
byte_5C05C:	dc.b $1F
		dc.b $A
aMasaruSetsumaru_1:dc.b	"MASARU SETSUMARU",0,0
byte_5C070:	dc.b $20
		dc.b $C
aTatsuyukiMaeda_0:dc.b "TATSUYUKI MAEDA",0
byte_5C082:	dc.b $21
		dc.b $C
aTomonoriSawada_0:dc.b "TOMONORI SAWADA",0
byte_5C094:	dc.b $22
		dc.b $E
aMasayukiNagao_1:dc.b "MASAYUKI NAGAO",0,0
byte_5C0A6:	dc.b $23
		dc.b $16
aJunSenoue_1:	dc.b "JUN SENOUE",0,0
byte_5C0B4:	dc.b $33
		dc.b 9
aSoundCoordinator:dc.b "SOUND COORDINATOR",0
byte_5C0C8:	dc.b $35
		dc.b $14
aHisakiNimiya:	dc.b "HISAKI NIMIYA",0
byte_5C0D8:	dc.b $45
		dc.b 3
aExecutiveManagement_1:dc.b "EXECUTIVE MANAGEMENT",0,0
byte_5C0F0:	dc.b $47
		dc.b 6
aShouichirouIrimajiri:dc.b "SHOUICHIROU IRIMAJIRI",0
byte_5C108:	dc.b $48
		dc.b $12
aTomKalinske_1:	dc.b "TOM KALINSKE",0,0
byte_5C118:	dc.b $49
		dc.b $16
aPaulRioux_1:	dc.b "PAUL RIOUX",0,0
byte_5C126:	dc.b $59
		dc.b $D
aProductManager_0:dc.b "PRODUCT MANAGER",0
byte_5C138:	dc.b $5B
		dc.b $12
aPamelaKelly_1:	dc.b "PAMELA KELLY",0,0
byte_5C148:	dc.b $6B
		dc.b 3
aExecutiveCoordinator_0:dc.b "EXECUTIVE COORDINATOR",0
byte_5C160:	dc.b $6D
		dc.b $E
aMamoruShigeta_1:dc.b "MAMORU SHIGETA",0,0
byte_5C172:	dc.b $6E
		dc.b $14
aTomioTakami_1:	dc.b "TOMIO TAKAMI",0,0
byte_5C182:	dc.b $6F
		dc.b $A
aDianeA_Fornasier_0:dc.b "DIANE A. FORNASIER ",0
byte_5C198:	dc.b $70
		dc.b $12
aRogerHector_1:	dc.b "ROGER HECTOR",0,0
byte_5C1A8:	dc.b $71
		dc.b 4
aTakaharuUtsunomiya_0:dc.b "TAKAHARU UTSUNOMIYA",0
byte_5C1BE:	dc.b $81
		dc.b $1B
aTesters_0:	dc.b "TESTERS",0
byte_5C1C8:	dc.b $83
		dc.b $16
aJasonKuo_0:	dc.b "JASON KUO",0
byte_5C1D4:	dc.b $84
		dc.b $16
aRickGreer_1:	dc.b "RICK GREER",0,0
byte_5C1E2:	dc.b $85
		dc.b $12
aMikeWilliams_0:dc.b "MIKE WILLIAMS",0
byte_5C1F2:	dc.b $95
		dc.b 5
aSoundSpecialThanks_1:dc.b "SOUND SPECIAL THANKS",0,0
byte_5C20A:	dc.b $97
		dc.b 6
aMayumiNinaSakazaki:dc.b "MAYUMI NINA SAKAZAKI",0,0
byte_5C222:	dc.b $98
		dc.b $20
aMrm:		dc.b "(MRM)",0
byte_5C22A:	dc.b $99
		dc.b $16
aCubeCorp__1:	dc.b "CUBE CORP.",0,0
byte_5C238:	dc.b $9A
		dc.b $16
aOpusCorp__1:	dc.b "OPUS CORP.",0,0
byte_5C246:	dc.b $9B
		dc.b 8
aMasanoriNakayama_0:dc.b "MASANORI NAKAYAMA",0
byte_5C25A:	dc.b $9C
		dc.b $14
aStudioWho_1:	dc.b "(STUDIO WHO)",0,0
byte_5C26A:	dc.b $AC
		dc.b $F
aSpecialThanks_1:dc.b "SPECIAL THANKS",0,0
byte_5C27C:	dc.b $AE
		dc.b $10
aJinaIshiwatari_0:dc.b "JINA ISHIWATARI",0
byte_5C28E:	dc.b $AF
		dc.b $12
aEmiKawamura_1:	dc.b "EMI KAWAMURA",0,0
byte_5C29E:	dc.b $B0
		dc.b 8
aDeborahMccracken:dc.b "DEBORAH MCCRACKEN",0
byte_5C2B2:	dc.b $B1
		dc.b $14
aTakuMakino_0:	dc.b "TAKU MAKINO",0
byte_5C2C0:	dc.b $C5
		dc.b $13
aPresentedBy_1:	dc.b "PRESENTED BY",0,0
byte_5C2D0:	dc.b $C7
		dc.b $20
aSega_1:	dc.b "SEGA",0,0
byte_5C2D8:	dc.b $D7
		dc.b $20
		dc.b "  ",0,0
byte_5C2DE:	dc.b $FF
		dc.b $F4
; ---------------------------------------------------------------------------

ContinueScreen:
		jsr	(Pal_FadeToBlack).l
		move	#$2700,sr
		move.w	($FFFFF60E).w,d0
		andi.b	#-$41,d0
		move.w	d0,($C00004).l
		lea	($C00004).l,a6
		move.w	#-$7FFC,(a6)
		move.w	#-$7900,(a6)
		clr.w	($FFFFFF0E).w
		lea	($FFFFFF10).w,a1
		moveq	#0,d0
		move.w	#$1A,d1

loc_5C314:
		move.l	d0,(a1)+
		dbf	d1,loc_5C314
		jsr	(Clear_Nem_Queue).l
		jsr	(Clear_DisplayData).l
		move.l	#$40200000,($C00004).l
		lea	(ArtNem_ContinueDigits).l,a0
		jsr	(Nem_Decomp).l
		move.l	#$68E00001,($C00004).l
		lea	(ArtNem_BlueSphereText).l,a0
		jsr	(Nem_Decomp).l
		move.l	#$51800000,($C00004).l
		lea	(ArtNem_ContinueSprites).l,a0
		jsr	(Nem_Decomp).l
		move.l	#$5B200000,($C00004).l
		lea	(ArtNem_ContinueIcons).l,a0
		jsr	(Nem_Decomp).l
		clr.b	($FFFFF711).w
		clr.b	($FFFFFAA9).w
		clr.b	($FFFFFA88).w
		lea	($FFFFB000).w,a1
		moveq	#0,d0
		move.w	#$7FF,d1

loc_5C394:
		move.l	d0,(a1)+
		dbf	d1,loc_5C394
		moveq	#0,d0
		move.l	d0,($FFFFFE66).w
		move.l	d0,($FFFFFE6A).w
		jsr	(Init_SpriteTable).l
		move.w	#$293,($FFFFF614).w
		lea	(Pal_ContinueScreen).l,a1
		lea	($FFFFFC80).w,a2
		moveq	#$1F,d6

loc_5C3BC:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_5C3BC
		lea	aCONTINUE(pc),a1 ; "C O	N T I N	U E"
		move.w	#$292,d2
		move.w	#-$7CB9,d6
		jsr	(sub_5B318).l
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_5C3FE
		tst.w	($FFFFFFAE).w
		beq.s	loc_5C3EE
		move.l	#Obj_Continue_SonicAlone_5C660,($FFFFB000).w
		bra.w	loc_5C3FE
; ---------------------------------------------------------------------------

loc_5C3EE:
		move.l	#Obj_Continue_SonicWTails_5C52A,($FFFFB000).w
		move.l	#Obj_Continue_TailsWSonic,($FFFFB04A).w

loc_5C3FE:

		move.l	#loc_5C838,($FFFFB094).w
		lea	($FFFFB0DE).w,a1
		move.l	#loc_5C4D6,(a1)
		move.w	a1,($FFFFFAA4).w
		move.l	#loc_5C9DC,($FFFFB128).w
		bsr.w	sub_5CB1C
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		move.b	#$16,($FFFFF62A).w
		jsr	(Wait_VSync).l
		move.w	($FFFFF60E).w,d0
		ori.b	#$40,d0
		move.w	d0,($C00004).l
		moveq	#$28,d0
		jsr	(Play_Sound).l
		jsr	(Pal_FadeFromBlack).l

loc_5C454:
		move.b	#$16,($FFFFF62A).w
		jsr	(Process_Kos_Queue).l
		jsr	(Wait_VSync).l
		jsr	(Process_Sprites).l
		jsr	(Render_Sprites).l
		jsr	(Process_Kos_Module_Queue).l
		move.b	($FFFFFAA9).w,d0
		beq.s	loc_5C454
		subq.b	#1,d0
		beq.s	loc_5C48A
		move.b	#0,($FFFFF600).w
		rts
; ---------------------------------------------------------------------------

loc_5C48A:
		move.b	#$C,($FFFFF600).w
		move.b	#3,($FFFFFE12).w
		move.b	#3,($FFFFFEC6).w
		moveq	#0,d0
		move.w	d0,($FFFFFE20).w
		move.l	d0,($FFFFFE22).w
		move.l	d0,($FFFFFE26).w
		move.w	d0,($FFFFFED0).w
		move.l	d0,($FFFFFED2).w
		move.l	d0,($FFFFFED6).w
		move.l	#$1388,($FFFFFFC0).w
		move.l	#$1388,($FFFFFFC4).w
		subq.b	#1,($FFFFFE18).w
		st	($FFFFEF56).w
		jsr	(SaveGame_LivesContinues).l

locret_5C4D4:

		rts
; ---------------------------------------------------------------------------

loc_5C4D6:
		move.l	#loc_5C4E6,(a0)
		clr.w	($FFFFFA82).w
		move.b	#$A,($FFFFFA84).w

loc_5C4E6:
		btst	#7,($FFFFF605).w
		bne.s	loc_5C51C
		btst	#7,($FFFFF607).w
		bne.s	loc_5C51C
		subq.w	#1,($FFFFFA82).w
		bpl.s	locret_5C512
		move.w	#$3B,($FFFFFA82).w
		move.b	($FFFFFA84).w,d0
		subq.b	#1,d0
		bmi.s	loc_5C514
		move.b	d0,($FFFFFA84).w
		bsr.w	sub_5CAAE

locret_5C512:
		rts
; ---------------------------------------------------------------------------

loc_5C514:
		move.b	#2,($FFFFFAA9).w
		rts
; ---------------------------------------------------------------------------

loc_5C51C:

		move.l	#locret_5C528,(a0)
		bset	#3,$38(a0)

locret_5C528:
		rts
; ---------------------------------------------------------------------------

Obj_Continue_SonicWTails_5C52A:
		move.l	#Map_ContinueSprites,$C(a0)
		move.w	#$8C,$A(a0)
		move.w	#$280,8(a0)
		move.b	#$C,7(a0)
		move.b	#$14,6(a0)
		move.w	#$118,$10(a0)
		move.w	#$120,$14(a0)
		move.l	#loc_5C55C,(a0)

loc_5C55C:
		movea.w	($FFFFFAA4).w,a1
		btst	#3,$38(a1)
		bne.s	loc_5C582
		move.b	#0,$22(a0)
		btst	#4,($FFFFFE0F).w
		beq.s	loc_5C57C
		move.b	#1,$22(a0)

loc_5C57C:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5C582:
		move.l	#loc_5C588,(a0)

loc_5C588:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_5C5A2(pc,d0.w),d1
		jsr	off_5C5A2(pc,d1.w)
		jsr	(Sonic_Load_PLC).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_5C5A2:	dc.w loc_5C5AC-off_5C5A2
		dc.w loc_5C5D0-off_5C5A2
		dc.w loc_5C62C-off_5C5A2
		dc.w loc_5C642-off_5C5A2
		dc.w locret_5C65E-off_5C5A2
; ---------------------------------------------------------------------------

loc_5C5AC:
		addq.b	#2,5(a0)
		move.l	#Map_Sonic,$C(a0)
		move.w	#$680,$A(a0)
		clr.b	($FFFFF766).w
		move.b	#$5A,$22(a0)
		move.b	#6,$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_5C5D0:
		subq.b	#1,$24(a0)
		bpl.s	locret_5C606
		move.b	#6,$24(a0)
		moveq	#0,d0
		move.b	$23(a0),d0
		addq.w	#2,d0
		cmpi.b	#$A,d0
		bcc.s	loc_5C608
		move.b	d0,$23(a0)
		lea	RawAni_5C622(pc,d0.w),a2
		move.b	(a2)+,$22(a0)
		bclr	#0,4(a0)
		tst.b	(a2)
		beq.s	locret_5C606
		bset	#0,4(a0)

locret_5C606:

		rts
; ---------------------------------------------------------------------------

loc_5C608:
		move.b	#4,5(a0)
		move.w	#1,$20(a0)
		move.w	#$600,$1C(a0)
		move.w	#$F,$2E(a0)
		rts
; ---------------------------------------------------------------------------
RawAni_5C622:	dc.b  $5A,   1,	$59,   1, $55,	 0, $56,   0, $57,   0
; ---------------------------------------------------------------------------

loc_5C62C:
		jsr	(Animate_Sonic).l
		subq.w	#1,$2E(a0)
		bmi.s	loc_5C63A
		rts
; ---------------------------------------------------------------------------

loc_5C63A:
		move.b	#6,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_5C642:
		jsr	(Animate_Sonic).l
		addq.w	#6,$10(a0)
		cmpi.w	#$1E0,$10(a0)
		bcc.s	loc_5C656
		rts
; ---------------------------------------------------------------------------

loc_5C656:
		move.b	#8,5(a0)
		rts
; ---------------------------------------------------------------------------

locret_5C65E:
		rts
; ---------------------------------------------------------------------------

Obj_Continue_SonicAlone_5C660:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_5C67A(pc,d0.w),d1
		jsr	off_5C67A(pc,d1.w)
		jsr	(Sonic_Load_PLC).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_5C67A:	dc.w loc_5C684-off_5C67A

		dc.w loc_5C6B6-off_5C67A
		dc.w loc_5C6E0-off_5C67A
		dc.w loc_5C6F4-off_5C67A
		dc.w locret_5C716-off_5C67A
; ---------------------------------------------------------------------------

loc_5C684:
		move.b	#2,5(a0)
		move.l	#Map_Sonic,$C(a0)
		move.w	#$680,$A(a0)
		move.w	#$280,8(a0)
		move.b	#$C,7(a0)
		move.b	#$14,6(a0)
		move.w	#$120,$10(a0)
		move.w	#$120,$14(a0)

loc_5C6B6:
		movea.w	($FFFFFAA4).w,a1
		btst	#2,$38(a1)
		bne.s	loc_5C6CC
		lea	byte_5CBC5(pc),a1
		jmp	(Animate_RawNoSSTCheckResult).l
; ---------------------------------------------------------------------------

loc_5C6CC:
		move.b	#4,5(a0)
		move.b	#-$46,$22(a0)
		move.w	#7,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_5C6E0:
		subq.w	#1,$2E(a0)
		bpl.s	locret_5C6F2
		move.b	#6,5(a0)
		move.b	#$21,$22(a0)

locret_5C6F2:
		rts
; ---------------------------------------------------------------------------

loc_5C6F4:
		addq.w	#6,$10(a0)
		cmpi.w	#$1E0,$10(a0)
		bcc.s	loc_5C70A
		lea	byte_5CBB4(pc),a1
		jmp	(Animate_RawNoSSTCheckResult).l
; ---------------------------------------------------------------------------

loc_5C70A:
		move.b	#8,5(a0)
		move.b	#1,($FFFFFAA9).w

locret_5C716:
		rts
; ---------------------------------------------------------------------------

Obj_Continue_TailsWSonic:
		move.l	#Map_ContinueSprites,$C(a0)
		move.w	#$8C,$A(a0)
		move.w	#$200,8(a0)
		move.b	#$10,7(a0)
		move.b	#$14,6(a0)
		move.w	#$12C,$10(a0)
		move.w	#$120,$14(a0)
		move.l	#loc_5C74A,(a0)

loc_5C74A:
		movea.w	($FFFFFAA4).w,a1
		btst	#3,$38(a1)
		bne.s	loc_5C770
		move.b	#5,$22(a0)
		btst	#5,($FFFFFE0F).w
		beq.s	loc_5C76A
		move.b	#6,$22(a0)

loc_5C76A:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5C770:
		move.l	#loc_5C790,(a0)
		addq.w	#4,$14(a0)
		lea	($FFFFCC0A).w,a1
		move.l	#Obj_Tails_Tail,(a1)
		move.w	a0,$30(a1)
		move.l	#loc_5C82C,($FFFFCC54).w

loc_5C790:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_5C7AA(pc,d0.w),d1
		jsr	off_5C7AA(pc,d1.w)
		jsr	(Tails_Load_PLC).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_5C7AA:	dc.w loc_5C7B2-off_5C7AA

		dc.w loc_5C7E2-off_5C7AA
		dc.w loc_5C802-off_5C7AA
		dc.w loc_5C814-off_5C7AA
; ---------------------------------------------------------------------------

loc_5C7B2:
		addq.b	#2,5(a0)
		move.l	#Map_Tails,$C(a0)
		move.w	#$6A0,$A(a0)
		move.w	#$280,8(a0)
		clr.b	($FFFFF7DE).w
		move.w	#$500,$20(a0)
		move.w	#-$5300,$22(a0)
		move.w	#$27,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_5C7E2:
		subq.w	#1,$2E(a0)
		bpl.w	locret_5C4D4
		move.b	#4,5(a0)
		move.b	#0,$20(a0)
		move.w	#$600,$1C(a0)
		move.w	#$13,$2E(a0)

loc_5C802:
		subq.w	#1,$2E(a0)
		bpl.s	loc_5C80E

loc_5C808:
		move.b	#6,5(a0)

loc_5C80E:
		jmp	(Animate_Tails).l
; ---------------------------------------------------------------------------

loc_5C814:
		addq.w	#6,$10(a0)
		cmpi.w	#$1E0,$10(a0)
		bcs.s	loc_5C826
		move.b	#1,($FFFFFAA9).w

loc_5C826:
		jmp	(Animate_Tails).l
; ---------------------------------------------------------------------------

loc_5C82C:
		bclr	#2,($FFFFCC0E).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_5C838:
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_5C854
		lea	loc_5C8C8(pc),a1
		move.l	a1,(a0)
		move.w	#$40,$10(a0)
		move.w	#$120,$14(a0)
		jmp	(a1)
; ---------------------------------------------------------------------------

loc_5C854:
		lea	loc_5C85A(pc),a1
		move.l	a1,(a0)

loc_5C85A:
		move.l	#Map_ContinueSprites,$C(a0)
		move.w	#$608C,$A(a0)
		move.w	#$200,8(a0)
		move.b	#$10,7(a0)
		move.b	#$18,6(a0)
		move.w	#$11C,$10(a0)
		move.w	#$120,$14(a0)
		move.l	#loc_5C88C,(a0)

loc_5C88C:
		move.w	#$2F,$2E(a0)
		movea.w	($FFFFFAA4).w,a1
		btst	#3,$38(a1)
		beq.s	loc_5C8AC
		move.l	#loc_5C8AC,(a0)
		move.l	#loc_5C972,($FFFFB4A0).w

loc_5C8AC:

		subq.w	#1,$2E(a0)
		bpl.s	loc_5C8B8
		move.l	#loc_5C8C8,(a0)

loc_5C8B8:
		lea	byte_5CBC0(pc),a1
		jsr	(Animate_RawNoSST).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5C8C8:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_5C8E2(pc,d0.w),d1
		jsr	off_5C8E2(pc,d1.w)
		jsr	(Knuckles_Load_PLC_661E0).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_5C8E2:	dc.w loc_5C8EA-off_5C8E2

		dc.w loc_5C91E-off_5C8E2
		dc.w loc_5C932-off_5C8E2
		dc.w locret_5C970-off_5C8E2
; ---------------------------------------------------------------------------

loc_5C8EA:
		addq.b	#2,5(a0)
		move.l	#Map_Knuckles,$C(a0)
		move.w	#$64DA,$A(a0)
		move.w	#$80,8(a0)
		move.b	#7,$22(a0)
		move.b	#$20,7(a0)
		move.b	#$30,6(a0)
		clr.b	$24(a0)
		clr.b	$23(a0)
		rts
; ---------------------------------------------------------------------------

loc_5C91E:
		movea.w	($FFFFFAA4).w,a1
		btst	#3,$38(a1)
		bne.s	loc_5C92C
		rts
; ---------------------------------------------------------------------------

loc_5C92C:
		move.b	#4,5(a0)

loc_5C932:
		move.w	$10(a0),d0
		addq.w	#6,d0
		move.w	d0,$10(a0)
		movea.w	($FFFFFAA4).w,a1
		cmpi.w	#$120,d0
		bcs.s	loc_5C94C
		bset	#2,$38(a1)

loc_5C94C:
		cmpi.w	#$1E0,d0
		bcc.s	loc_5C95C
		lea	byte_5CBB4(pc),a1
		jmp	(Animate_RawNoSSTCheckResult).l
; ---------------------------------------------------------------------------

loc_5C95C:
		move.b	#6,5(a0)
		cmpi.w	#3,($FFFFFF08).w
		bne.s	locret_5C970
		move.b	#1,($FFFFFAA9).w

locret_5C970:

		rts
; ---------------------------------------------------------------------------

loc_5C972:
		lea	(ObjDat3_919A6).l,a1
		jsr	(SetUp_ObjAttributes).l
		bclr	#2,4(a0)
		bset	#0,4(a0)
		move.l	#Obj_Continue_EggRobo_5C9C4,(a0)
		move.w	#$60,$10(a0)
		move.w	#$F0,$14(a0)
		move.w	#$600,$18(a0)
		jsr	(Swing_Setup1).l
		lea	(ChildObjDat_919D0).l,a2
		jsr	(CreateChild1_Normal).l
		lea	(ArtKosM_EggRoboBadnik).l,a1
		move.w	#-$6000,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

Obj_Continue_EggRobo_5C9C4:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jsr	(sub_91988).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5C9DC:
		move.l	#Map_ContinueSprites,$C(a0)
		move.w	#$408C,$A(a0)
		move.w	#$380,8(a0)
		move.b	#7,$22(a0)
		move.b	#8,7(a0)
		move.b	#8,6(a0)
		move.w	#$120,$10(a0)
		move.w	#$F5,$14(a0)
		move.l	#loc_5CA14,(a0)

loc_5CA14:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5CA1A:
		move.l	#Map_ContinueIcons,$C(a0)
		move.w	#$D9,$A(a0)
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_5CA36
		move.w	#$60D9,$A(a0)

loc_5CA36:
		move.w	#$380,8(a0)
		move.b	#8,7(a0)
		move.b	#8,6(a0)
		bsr.w	sub_5CB4A
		move.w	#$D8,$14(a0)
		move.l	#loc_5CA5C,(a0)
		bsr.w	sub_5CB6A

loc_5CA5C:
		moveq	#0,d0
		btst	#4,($FFFFFE0F).w
		beq.s	loc_5CA68
		addq.w	#1,d0

loc_5CA68:
		movea.l	$30(a0),a1
		move.b	(a1,d0.w),$22(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_5CA78:
		move.l	#Map_ContinueIcons,$C(a0)
		move.w	#$D9,$A(a0)
		move.w	#$280,8(a0)
		move.b	#8,7(a0)
		move.b	#8,6(a0)
		move.l	#loc_5CA9E,(a0)

loc_5CA9E:
		lea	byte_5CBBB(pc),a1
		jsr	(Animate_RawNoSST).l
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_5CAAE:
		move.b	($FFFFFA84).w,d0
		move.b	d0,d1
		andi.w	#$F0,d0
		lsr.w	#3,d0
		andi.w	#$F,d1
		add.w	d1,d1
		move.w	#1,d2
		lea	($FFFF2000).l,a1
		add.w	d2,d0
		move.w	d0,(a1)+
		add.w	d2,d1
		move.w	d1,(a1)+
		addq.w	#1,d0
		move.w	d0,(a1)+
		addq.w	#1,d1
		move.w	d1,(a1)+
		move	#$2700,sr
		lea	($C00000).l,a6
		move.w	#-$38DA,d2
		swap	d2
		clr.w	d2
		swap	d2
		lsl.l	#2,d2
		lsr.w	#2,d2
		ori.w	#$4000,d2
		swap	d2
		move.l	d2,d3
		addi.l	#$800000,d3
		lea	($FFFF2000).l,a1
		move.l	d2,4(a6)
		move.w	(a1)+,(a6)
		move.w	(a1)+,(a6)
		move.l	d3,4(a6)
		move.w	(a1)+,(a6)
		move.w	(a1)+,(a6)
		move	#$2300,sr
		rts
; End of function sub_5CAAE


; =============== S U B R O U T I N E =======================================


sub_5CB1C:
		moveq	#0,d0
		move.b	($FFFFFE18).w,d0
		beq.s	loc_5CB2A
		cmpi.b	#$A,d0
		bls.s	loc_5CB2C

loc_5CB2A:
		moveq	#$A,d0

loc_5CB2C:
		lea	($FFFFB172).w,a1
		moveq	#0,d1

loc_5CB32:
		subq.b	#1,d0
		beq.w	locret_5C4D4
		move.l	#loc_5CA1A,(a1)
		move.b	d1,$2C(a1)
		addq.w	#2,d1
		lea	$4A(a1),a1
		bra.s	loc_5CB32
; End of function sub_5CB1C


; =============== S U B R O U T I N E =======================================


sub_5CB4A:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_5CB58(pc,d0.w),$10(a0)
		rts
; End of function sub_5CB4A

; ---------------------------------------------------------------------------
word_5CB58:	dc.w $120
		dc.w $138
		dc.w $108
		dc.w $150
		dc.w $F0
		dc.w $168
		dc.w $D8
		dc.w $180
		dc.w $C0

; =============== S U B R O U T I N E =======================================


sub_5CB6A:
		move.w	($FFFFFF08).w,d4
		cmpi.b	#2,d4
		bne.s	loc_5CB7E
		lea	ChildObjDat_5CB88(pc),a2
		jsr	(CreateChild6_Simple).l

loc_5CB7E:
		lsl.w	#2,d4
		move.l	off_5CB8E(pc,d4.w),$30(a0)
		rts
; End of function sub_5CB6A

; ---------------------------------------------------------------------------
ChildObjDat_5CB88:dc.w 0
		dc.l Obj_5CA78
off_5CB8E:	dc.l byte_5CBAE
		dc.l byte_5CBAE
		dc.l byte_5CBB0
		dc.l byte_5CBB2
aCONTINUE:	dc.b "C O N T I N U E",0
byte_5CBAE:	dc.b 0
		dc.b 1
byte_5CBB0:	dc.b 2
		dc.b 3
byte_5CBB2:	dc.b 7
		dc.b 8
byte_5CBB4:	dc.b 2

		dc.b $21
		dc.b $22
		dc.b $23
		dc.b $24
		dc.b $FF
		dc.b $FC
byte_5CBBB:	dc.b 8
		dc.b 4
		dc.b 5
		dc.b 6
		dc.b $FC
byte_5CBC0:	dc.b $B
		dc.b 2
		dc.b 2
		dc.b 4
		dc.b $FC
byte_5CBC5:	dc.b $B
		dc.b $BD
		dc.b $BE
		dc.b $FF
		dc.b $FC
Pal_ContinueScreen:	binclude "General\Sprites\Continue\Screen.bin"

Map_ContinueSprites:	include "General\Sprites\Continue\Map - Player Sprites.asm"

Map_ContinueIcons:	include "General\Sprites\Continue\Map - Player Icons.asm"

ArtNem_ContinueSprites:binclude "General\Sprites\Continue\Player Sprites.bin"

ArtNem_ContinueIcons:binclude "General\Sprites\Continue\Player Icons.bin"

ArtNem_ContinueDigits:	binclude "General\Sprites\Continue\Digits.bin"


; ---------------------------------------------------------------------------

S3Credits:
		rts
; ---------------------------------------------------------------------------

Obj_5D86A:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_5D89C(pc,d0.w),d1
		jsr	off_5D89C(pc,d1.w)
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_5D886
		move.b	#$7F,($FFFFF65E).w

loc_5D886:
		lea	($FFFFB000).w,a1
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_5D89C:	dc.w loc_5D8BC-off_5D89C

		dc.w loc_5D9EE-off_5D89C
		dc.w loc_5DA50-off_5D89C
		dc.w loc_5DA74-off_5D89C
		dc.w loc_5DB2C-off_5D89C
		dc.w loc_5DB60-off_5D89C
		dc.w loc_5DB76-off_5D89C
		dc.w loc_5DBBE-off_5D89C
		dc.w loc_5DBDC-off_5D89C
		dc.w loc_5DBF6-off_5D89C
		dc.w loc_5DC2C-off_5D89C
		dc.w loc_5DC98-off_5D89C
		dc.w loc_5DCA6-off_5D89C
		dc.w loc_5DD34-off_5D89C
		dc.w loc_5DD6A-off_5D89C
		dc.w loc_5DE1A-off_5D89C
; ---------------------------------------------------------------------------

loc_5D8BC:
		lea	ObjDat3_600DA(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bclr	#2,4(a0)
		move.b	#2,5(a0)
		bsr.w	sub_5FE82
		st	($FFFFEE0A).w
		clr.b	($FFFFFAB8).w
		lea	($FFFFB000).w,a1
		bclr	#2,4(a1)
		bset	#7,$A(a1)
		move.b	#-$7F,$2E(a1)
		move.b	#$F,$20(a1)
		clr.b	$2A(a1)
		move.w	#$800,$1C(a1)
		clr.l	($FFFFB04A).w
		cmpi.w	#2,($FFFFFF08).w
		move.w	#$7FFF,($FFFFF670).w
		move.b	#1,($FFFFFE1E).w
		tst.b	($FFFFFA88).w
		bmi.w	loc_5D96A
		bne.s	loc_5D944
		cmpi.w	#2,($FFFFFF08).w
		bcc.w	loc_5D96A
		bsr.w	sub_5FC8E
		jsr	(Create_New_Sprite).l
		bne.s	loc_5D940
		move.l	#Obj_5FDD4,(a1)

loc_5D940:
		bra.w	loc_5D95C
; ---------------------------------------------------------------------------

loc_5D944:
		clr.b	($FFFFB020).w
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_5D958
		bsr.w	sub_5FCB4
		bra.w	loc_5D96A
; ---------------------------------------------------------------------------

loc_5D958:
		bsr.w	sub_5FCCE

loc_5D95C:
		move.l	#$EEE0EEE,d0
		move.l	d0,($FFFFFC04).w
		move.w	d0,($FFFFFC08).w

loc_5D96A:

		move.w	#$100,$10(a0)
		move.w	#$E0,$14(a0)
		lea	($FFFFB250).w,a1
		move.w	a1,$44(a0)
		move.l	#Obj_5EA52,(a1)
		st	$2C(a1)
		bset	#2,$38(a1)
		move.w	a0,$46(a1)
		lea	($FFFFBDE0).w,a1
		move.l	#Obj_5DE60,(a1)
		move.w	a0,$46(a1)
		move.w	#$11E,$10(a1)
		move.w	#$CF,$14(a1)
		lea	(Pal_EndingObjects).l,a1
		lea	($FFFFFCC0).w,a2
		moveq	#7,d6

loc_5D9B8:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_5D9B8
		lea	(ArtKosM_HPZMasterEmerald).l,a1
		move.w	#-$5A40,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_SonicPlane).l,a1
		move.w	#$3C60,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_SonicPlaneEnding).l,a1
		move.w	#$4DC0,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

loc_5D9EE:
		cmpi.w	#$EEE,($FFFFFC02).w
		bne.s	loc_5DA12
		bset	#7,$38(a0)
		bne.s	loc_5DA12
		move.b	#1,($FFFFFAC1).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_5DA12
		move.l	#loc_5DF58,(a1)

loc_5DA12:

		move.l	($FFFFEE9C).w,d0
		addi.l	#$8000,d0
		move.l	d0,($FFFFEE9C).w
		cmpi.l	#$800000,d0
		bcs.s	locret_5DA4E
		move.b	#4,5(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_5DA3C
		move.l	#loc_5F94C,(a1)

loc_5DA3C:
		move.b	#$1F,($FFFFFAB9).w
		move.w	#-$100,($FFFFFAC2).w
		move.w	#-$100,($FFFFFAC4).w

locret_5DA4E:
		rts
; ---------------------------------------------------------------------------

loc_5DA50:
		move.l	($FFFFEE9C).w,d0
		addi.l	#$8000,d0
		move.l	d0,($FFFFEE9C).w
		cmpi.l	#$1000000,d0
		bcs.s	locret_5DA72
		move.b	#6,5(a0)
		bset	#3,$38(a0)

locret_5DA72:
		rts
; ---------------------------------------------------------------------------

loc_5DA74:
		movea.w	$44(a0),a1
		move.w	$10(a1),d0
		addi.w	#$20,d0
		cmp.w	$10(a0),d0
		bgt.s	loc_5DA96
		move.l	($FFFFEE9C).w,d0
		addi.l	#$8000,d0
		move.l	d0,($FFFFEE9C).w
		rts
; ---------------------------------------------------------------------------

loc_5DA96:
		move.b	#8,5(a0)
		bset	#0,($FFFFFAB8).w
		move.w	#$20,$2E(a0)
		moveq	#-$20,d0
		move.b	d0,$42(a1)
		move.w	$10(a1),d1
		neg.w	d0
		add.w	d0,d1
		move.w	d1,$10(a0)
		moveq	#$2B,d0
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_5DACC
		subq.b	#4,d0
		bclr	#2,($FFFFCC0E).w

loc_5DACC:
		move.b	d0,$43(a1)
		move.w	$14(a1),d1
		neg.w	d0
		add.w	d0,d1
		move.w	d1,$14(a0)
		move.w	d1,$3A(a0)
		lea	($FFFFB000).w,a1
		tst.b	($FFFFFA88).w
		bmi.s	loc_5DB1C
		beq.s	loc_5DB1C
		move.b	#2,($FFFFF65F).w
		move.w	#$1E,($FFFFF65C).w
		move.b	#0,($FFFFFE19).w
		move.b	#0,($FFFFF667).w
		move.l	#Map_Sonic,$C(a1)
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_5DB1C
		move.l	#Map_Tails,$C(a1)

loc_5DB1C:

		move.b	#5,$20(a1)
		move.b	#-$7D,$2E(a1)
		bsr.w	sub_5FD88

loc_5DB2C:
		subq.w	#1,$2E(a0)
		bne.s	loc_5DB38
		bset	#1,($FFFFFAB8).w

loc_5DB38:
		addq.w	#2,$10(a0)
		cmpi.w	#$160,$10(a0)
		bcs.s	loc_5DB5C
		move.b	#$A,5(a0)
		tst.b	($FFFFFA88).w
		bpl.s	loc_5DB5C
		move.b	#$C,5(a0)
		move.w	#$12B,$2E(a0)

loc_5DB5C:

		bra.w	sub_60000
; ---------------------------------------------------------------------------

loc_5DB60:
		tst.w	($FFFFFAA4).w
		bne.s	loc_5DB6A
		bra.w	sub_60000
; ---------------------------------------------------------------------------

loc_5DB6A:
		move.b	#$C,5(a0)
		move.w	#$12B,$2E(a0)

loc_5DB76:
		subq.w	#1,$2E(a0)
		bpl.s	loc_5DBB2
		move.b	#$E,5(a0)
		move.w	#-$100,($FFFFFAC4).w
		clr.b	($FFFFFAB9).w
		move.w	#$BF,$2E(a0)
		st	($FFFFEEC6).w
		lea	word_5DBB6(pc),a2
		moveq	#$42,d1
		moveq	#1,d2
		bsr.w	Create_Continue_Sprite
		lea	(ArtKosM_IslandLiftGfx).l,a1
		move.w	#$5FE0,d2
		jsr	(Queue_Kos_Module).l

loc_5DBB2:
		bra.w	sub_60000
; ---------------------------------------------------------------------------
word_5DBB6:	dc.w   $69C,  $384
		dc.w   $6DC,  $384
; ---------------------------------------------------------------------------

loc_5DBBE:
		addq.w	#2,($FFFFEE98).w
		addq.w	#1,($FFFFEE9C).w
		subq.w	#1,$2E(a0)
		bpl.s	loc_5DBD8
		move.b	#$10,5(a0)
		move.w	#$12B,$2E(a0)

loc_5DBD8:
		bra.w	sub_60000
; ---------------------------------------------------------------------------

loc_5DBDC:
		addq.w	#2,($FFFFEE98).w
		subq.w	#1,$2E(a0)
		bpl.s	loc_5DBF2
		move.b	#$12,5(a0)
		move.w	#$8F,$2E(a0)

loc_5DBF2:
		bra.w	sub_60000
; ---------------------------------------------------------------------------

loc_5DBF6:
		cmpi.w	#$60,$10(a0)
		bls.s	loc_5DC02
		subq.w	#2,$10(a0)

loc_5DC02:
		addq.w	#2,($FFFFEE98).w
		bsr.w	sub_60000
		subq.w	#1,$2E(a0)

loc_5DC0E:
		bpl.s	locret_5DC2A
		move.b	#$14,5(a0)
		bset	#7,$2A(a0)
		st	($FFFFEEC4).w
		move.w	#$8F,$2E(a0)
		clr.b	($FFFFB020).w

locret_5DC2A:
		rts
; ---------------------------------------------------------------------------

loc_5DC2C:
		addq.w	#2,($FFFFEE98).w
		subq.w	#1,$2E(a0)
		bpl.w	locret_5FF1A
		move.b	#$16,5(a0)
		move.b	#1,$22(a0)
		move.w	#$40,$10(a0)
		move.w	#$110,$14(a0)
		move.w	#$77,$2E(a0)
		lea	($FFFFB000).w,a1
		clr.b	$22(a1)
		move.w	#$100,$18(a0)
		bsr.w	sub_6001E
		lea	ChildObjDat_601CA(pc),a2
		jsr	(CreateChild6_Simple).l
		lea	ChildObjDat_601D0(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	ChildObjDat_601D8(pc),a2
		jsr	(CreateChild1_Normal).l
		tst.b	($FFFFFA88).w
		bmi.w	locret_5FF1A
		lea	ChildObjDat_601E0(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_5DC98:
		subq.w	#1,$2E(a0)
		bpl.s	locret_5DCA4
		move.b	#$18,5(a0)

locret_5DCA4:
		rts
; ---------------------------------------------------------------------------

loc_5DCA6:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		cmpi.w	#$140,$10(a0)
		bcs.s	loc_5DCC4
		lea	word_60253(pc),a1
		jsr	(Animate_RawNoSSTMultiDelay).l

loc_5DCC4:
		cmpi.w	#$220,$10(a0)
		bls.w	locret_5FF1A
		move.b	#$1A,5(a0)
		move.w	#$226E,$A(a0)
		bset	#0,4(a0)
		bclr	#7,$A(a0)
		bset	#4,$38(a0)
		subq.w	#8,$14(a0)
		move.w	#-$80,$18(a0)
		clr.w	$1A(a0)
		move.b	#5,$22(a0)
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_5DD0E
		move.b	#6,$22(a0)

loc_5DD0E:
		lea	Pal_EndingSmallPlane(pc),a1
		jsr	(PalLoad_Line1).l
		lea	ChildObjDat_6022E(pc),a2
		jsr	(CreateChild1_Normal).l
		tst.b	($FFFFFA88).w
		bmi.w	locret_5FF1A
		lea	ChildObjDat_6020C(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_5DD34:
		jsr	(MoveSprite2).l
		cmpi.w	#$120,$10(a0)
		bcc.s	locret_5DD68
		move.b	#$1C,5(a0)
		move.w	#$3B,$2E(a0)
		bset	#5,$38(a0)
		tst.b	($FFFFFA88).w
		bmi.s	locret_5DD68
		jsr	(Create_New_Sprite).l
		bne.s	locret_5DD68
		move.l	#loc_5FC1E,(a1)

locret_5DD68:

		rts
; ---------------------------------------------------------------------------

loc_5DD6A:
		subq.w	#1,$2E(a0)
		bpl.s	locret_5DDD0
		move.b	#$1E,5(a0)
		st	($FFFFEEC4).w
		cmpi.w	#3,($FFFFFF08).w
		beq.s	locret_5DDD0
		tst.b	($FFFFFA88).w
		bmi.s	locret_5DDD0
		lea	word_5DDD2(pc),a2
		moveq	#$41,d1
		moveq	#5,d2
		bsr.w	Create_Continue_Sprite
		lea	word_5DDEA(pc),a2
		moveq	#$43,d1
		moveq	#1,d2
		bsr.w	Create_Continue_Sprite
		lea	word_5DDF2(pc),a2
		moveq	#$44,d1
		moveq	#3,d2
		bsr.w	Create_Continue_Sprite
		lea	word_5DE02(pc),a2
		moveq	#$45,d1
		moveq	#1,d2
		bsr.w	Create_Continue_Sprite
		lea	word_5DE0A(pc),a2
		moveq	#$46,d1
		moveq	#1,d2
		bsr.w	Create_Continue_Sprite
		lea	word_5DE12(pc),a2
		moveq	#$47,d1
		moveq	#1,d2
		bsr.w	Create_Continue_Sprite

locret_5DDD0:

		rts
; ---------------------------------------------------------------------------
word_5DDD2:	dc.w   $2B0,   $D4
		dc.w   $2D0,   $D4
		dc.w   $2F0,   $D4
		dc.w   $310,   $D4
		dc.w   $330,   $D4
		dc.w   $350,   $D4
word_5DDEA:	dc.w   $12C,  $11C
		dc.w	$F4,  $11C
word_5DDF2:	dc.w	$E8,  $12C
		dc.w   $158,  $12C
		dc.w	$B8,  $12C
		dc.w   $188,  $12C
word_5DE02:	dc.w   $2FC,   $DC
		dc.w   $32C,   $DC
word_5DE0A:	dc.w   $2C4,   $D8
		dc.w   $2EC,   $D8
word_5DE12:	dc.w   $304,   $D0
		dc.w   $344,   $D0
; ---------------------------------------------------------------------------

loc_5DE1A:
		jsr	(MoveSprite2).l
		cmpi.w	#$60,$10(a0)
		bcc.s	locret_5DE34
		move.l	#loc_5DE36,(a0)
		bset	#1,$38(a0)

locret_5DE34:
		rts
; ---------------------------------------------------------------------------

loc_5DE36:
		tst.b	($FFFFFA88).w
		bmi.s	loc_5DE46
		cmpi.w	#$78,($FFFFEE84).w
		bcs.w	locret_5FF1A

loc_5DE46:
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		clr.b	($FFFFFAC1).w
		clr.b	($FFFFFAB8).w
		st	($FFFFEEC4).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_5DE60:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_5DE74(pc,d0.w),d1
		jsr	off_5DE74(pc,d1.w)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_5DE74:	dc.w loc_5DE80-off_5DE74

		dc.w loc_5DED4-off_5DE74
		dc.w loc_5DEF0-off_5DE74
		dc.w loc_5DF12-off_5DE74
		dc.w loc_5DF34-off_5DE74
		dc.w loc_5DF48-off_5DE74
; ---------------------------------------------------------------------------

loc_5DE80:
		move.b	#2,5(a0)
		move.l	#Map_SSZMasterEmerald,$C(a0)
		move.b	#$20,7(a0)
		move.b	#$18,6(a0)
		move.b	#2,$22(a0)
		tst.b	$2C(a0)
		bne.s	loc_5DEC6
		move.w	#-$3AD2,$A(a0)
		move.w	#$280,8(a0)
		tst.b	($FFFFFA88).w
		bpl.s	locret_5DEC4
		move.b	#8,5(a0)
		move.w	#$77,$2E(a0)

locret_5DEC4:
		rts
; ---------------------------------------------------------------------------

loc_5DEC6:
		move.w	#$252E,$A(a0)
		move.w	#$300,8(a0)
		rts
; ---------------------------------------------------------------------------

loc_5DED4:
		btst	#0,($FFFFFAB8).w
		bne.s	loc_5DEDE
		rts
; ---------------------------------------------------------------------------

loc_5DEDE:
		move.b	#4,5(a0)
		move.w	#-$200,$18(a0)
		move.w	#$100,$1A(a0)

loc_5DEF0:
		move.w	($FFFFFAA4).w,d0
		bne.s	loc_5DEFC
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_5DEFC:
		move.b	#6,5(a0)
		move.w	d0,$46(a0)
		move.b	#-$20,$42(a0)
		move.b	#1,$43(a0)

loc_5DF12:
		jsr	(Refresh_ChildPosition).l
		cmpi.w	#$50,$10(a0)
		bls.s	loc_5DF2E
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_5DF2E
		rts
; ---------------------------------------------------------------------------

loc_5DF2E:

		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_5DF34:
		subq.w	#1,$2E(a0)
		bpl.s	locret_5DF46
		move.b	#$A,5(a0)
		move.w	#-$80,$1A(a0)

locret_5DF46:
		rts
; ---------------------------------------------------------------------------

loc_5DF48:
		jsr	(MoveSprite2).l
		cmpi.w	#$40,$14(a0)
		bcs.s	loc_5DF2E
		rts
; ---------------------------------------------------------------------------

loc_5DF58:

		tst.b	($FFFFFA88).w
		beq.s	locret_5DF7E
		bmi.s	locret_5DF7E
		move.b	($FFFFFAC1).w,d0
		beq.s	locret_5DF7E
		lea	(off_7DD5A).l,a1
		lea	($FFFFFC5C).w,a2
		tst.b	d0
		bpl.s	loc_5DF78
		lea	($FFFFFC3C).w,a2

loc_5DF78:
		jsr	(Run_PalRotationScript2).l

locret_5DF7E:

		rts
; ---------------------------------------------------------------------------

loc_5DF80:
		lea	ObjDat3_60104(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bclr	#2,4(a0)
		move.l	#loc_5DF98,(a0)
		rts
; ---------------------------------------------------------------------------

loc_5DF98:
		btst	#1,($FFFFFAB8).w
		beq.s	loc_5DFA6
		move.l	#loc_5DFB2,(a0)

loc_5DFA6:
		jsr	(Refresh_ChildPosition).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5DFB2:
		move.b	$42(a0),d0
		subq.b	#2,d0
		move.b	d0,$42(a0)
		cmpi.b	#-$74,d0
		bgt.s	loc_5DFCC
		move.l	#loc_5DFD8,(a0)
		move.w	a0,($FFFFFAA4).w

loc_5DFCC:
		jsr	(Refresh_ChildPosition).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5DFD8:
		jsr	(Refresh_ChildPosition).l
		cmpi.w	#$50,$10(a0)
		bls.w	loc_5EC36
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_5DFEE:
		move.l	#Map_SonicPlaneEnding,$C(a0)
		move.w	#$26E,$A(a0)

loc_5DFFC:
		move.w	#$380,8(a0)
		move.b	#1,$22(a0)
		move.b	#$20,7(a0)

loc_5E00E:
		move.b	#$14,6(a0)
		move.l	#loc_5E08A,(a0)
		bset	#0,4(a0)
		move.w	#$220,$10(a0)
		move.w	#$B0,$14(a0)
		move.w	#-$100,$18(a0)
		bsr.w	sub_6001E
		moveq	#-$24,d0
		jsr	(Play_Sound).l
		lea	ChildObjDat_601CA(pc),a2
		jsr	(CreateChild6_Simple).l
		lea	ChildObjDat_601D0(pc),a2
		jsr	(CreateChild1_Normal).l
		bclr	#0,($FFFFFAB8).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_5E07A
		move.l	#Obj_5DE60,(a1)
		move.w	a0,$46(a1)
		move.w	#$190,$10(a1)
		move.w	#$DC,$14(a1)
		st	$2C(a1)

loc_5E07A:
		lea	(ArtKosM_SonicPlaneEnding).l,a1
		move.w	#$4DC0,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

loc_5E08A:
		cmpi.w	#$EEE,($FFFFFC02).w
		bne.s	loc_5E0AC
		bset	#7,$38(a0)
		bne.s	loc_5E0AC
		st	($FFFFFAC1).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_5E0AC
		move.l	#loc_5DF58,(a1)

loc_5E0AC:

		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		cmpi.w	#$60,$10(a0)
		bcc.s	loc_5E0D0
		move.l	#loc_5E0D6,(a0)
		bset	#4,$38(a0)
		clr.b	5(a0)

loc_5E0D0:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5E0D6:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_5E0F0(pc,d0.w),d1
		jsr	off_5E0F0(pc,d1.w)
		jsr	(Knuckles_Load_PLC_661E0).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_5E0F0:	dc.w loc_5E0F8-off_5E0F0

		dc.w loc_5E142-off_5E0F0
		dc.w loc_5E170-off_5E0F0
		dc.w locret_5E188-off_5E0F0
; ---------------------------------------------------------------------------

loc_5E0F8:
		move.b	#2,5(a0)
		move.l	#Map_Knuckles,$C(a0)
		move.w	#-$7B26,$A(a0)
		move.w	#$180,8(a0)
		move.b	#7,$22(a0)
		move.w	#$1E0,$10(a0)
		move.w	#$E0,$14(a0)
		move.w	#-$200,$18(a0)
		clr.w	$1A(a0)
		lea	(Pal_ContinueScreen+$60).l,a1
		lea	($FFFFFC00).w,a2
		moveq	#7,d6

loc_5E13A:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_5E13A
		rts
; ---------------------------------------------------------------------------

loc_5E142:
		lea	(byte_66824).l,a1
		jsr	(Animate_RawNoSSTCheckResult).l
		jsr	(MoveSprite2).l
		cmpi.w	#$120,$10(a0)
		bcc.s	locret_5E16E
		move.b	#4,5(a0)
		move.b	#$55,$22(a0)
		move.w	#$77,$2E(a0)

locret_5E16E:
		rts
; ---------------------------------------------------------------------------

loc_5E170:
		subq.w	#1,$2E(a0)
		bpl.w	locret_5FF1A
		move.b	#6,5(a0)
		st	($FFFFEEC4).w
		clr.b	($FFFFFAC1).w
		rts
; ---------------------------------------------------------------------------

locret_5E188:
		rts
; ---------------------------------------------------------------------------

Obj_Ending:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_5E1AE(pc,d0.w),d1
		jsr	off_5E1AE(pc,d1.w)
		subq.w	#2,($FFFFEE98).w
		lea	($FFFFB000).w,a1
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		rts
; ---------------------------------------------------------------------------
off_5E1AE:	dc.w loc_5E1C2-off_5E1AE

		dc.w loc_5E288-off_5E1AE
		dc.w loc_5E2C2-off_5E1AE
		dc.w loc_5E334-off_5E1AE
		dc.w loc_5E3EE-off_5E1AE
		dc.w loc_5E412-off_5E1AE
		dc.w loc_5E45A-off_5E1AE
		dc.w loc_5E474-off_5E1AE
		dc.w loc_5E4B6-off_5E1AE
		dc.w loc_5E4E2-off_5E1AE
; ---------------------------------------------------------------------------

loc_5E1C2:
		move.b	#2,5(a0)
		bset	#0,4(a0)
		move.w	#$C0,$10(a0)
		move.w	#$E0,$14(a0)
		jsr	(Swing_Setup1).l
		cmpi.b	#2,($FFFFFA88).w
		beq.s	loc_5E1F0
		moveq	#-$24,d0
		jsr	(Play_Sound).l

loc_5E1F0:
		lea	($FFFFB000).w,a1
		bset	#0,4(a1)
		bset	#0,$2A(a1)
		bclr	#7,$A(a1)
		move.b	#-$7D,$2E(a1)
		move.b	#5,$20(a1)
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_5E228
		lea	($FFFFCC0A).w,a2
		move.l	#Obj_Tails_Tail,(a2)
		move.w	a1,$30(a2)

loc_5E228:
		bsr.w	sub_5FD88
		lea	ChildObjDat_601BA(pc),a2
		jsr	(CreateChild1_Normal).l
		bne.s	loc_5E23E
		bset	#2,$38(a1)

loc_5E23E:
		tst.b	($FFFFFA88).w
		bmi.s	loc_5E258
		lea	ChildObjDat_60214(pc),a2
		jsr	(CreateChild6_Simple).l
		lea	ChildObjDat_6021A(pc),a2
		jsr	(CreateChild6_Simple).l

loc_5E258:
		lea	(ArtKosM_SonicPlane).l,a1
		move.w	#$3C60,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_SonicPlaneEnding).l,a1
		move.w	#$4DC0,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_EndingAnimals).l,a1
		move.w	#$5FE0,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

loc_5E288:
		bclr	#2,($FFFFCC0E).w
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		tst.b	($FFFFFACC).w
		beq.w	locret_5FF1A
		move.b	#4,5(a0)
		move.w	#$1F,$2E(a0)
		lea	($FFFFB000).w,a1
		move.b	#$58,$22(a1)
		clr.b	$20(a1)
		jmp	(Player_Load_PLC).l
; ---------------------------------------------------------------------------

loc_5E2C2:
		subq.w	#1,$2E(a0)
		bpl.w	locret_5FF1A
		move.b	#6,5(a0)
		bset	#2,$38(a0)
		move.w	#$300,$18(a0)
		move.w	#-$600,$1A(a0)
		lea	($FFFFB000).w,a1
		bclr	#0,4(a1)
		bclr	#0,$2A(a1)
		move.b	#$81,$2E(a1)
		move.w	#$200,$20(a1)
		clr.l	($FFFFCC0A).w
		moveq	#0,d0
		cmpi.w	#2,($FFFFFF08).w
		beq.s	loc_5E316
		moveq	#4,d0
		tst.b	($FFFFFA88).w
		bmi.s	loc_5E316
		moveq	#8,d0

loc_5E316:

		move.w	d0,($FFFFFA92).w
		movea.l	off_5E328(pc,d0.w),a1
		move.w	#$68E0,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------
off_5E328:	dc.l ArtKosM_TailsEndPose
		dc.l ArtKosM_NormalSonicEndPose
		dc.l ArtKosM_SuperSonicEndPose
; ---------------------------------------------------------------------------

loc_5E334:
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.w	locret_5FF1A
		cmpi.w	#$E0,$14(a0)
		bcs.w	locret_5FF1A
		move.l	#Map_SonicTailsEndPoses,$C(a0)
		move.w	#$4347,$A(a0)
		move.w	#$100,8(a0)
		move.b	#-$80,7(a0)
		move.b	#-$80,6(a0)
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_5E37A
		move.b	#3,$22(a0)

loc_5E37A:
		move.w	($FFFFFA92).w,d0
		movea.l	off_5E3B4(pc,d0.w),a1
		lea	($FFFFFC40).w,a2
		moveq	#7,d0

loc_5E388:
		move.l	(a1)+,(a2)+
		dbf	d0,loc_5E388
		tst.b	($FFFFFA88).w
		bmi.s	loc_5E3C0
		bne.s	loc_5E39E
		cmpi.w	#2,($FFFFFF08).w
		bcc.s	loc_5E3C0

loc_5E39E:
		move.b	#$A,5(a0)
		move.b	#1,($FFFFFE1E).w
		clr.w	($FFFFF65C).w
		jmp	(loc_8648C).l
; ---------------------------------------------------------------------------
off_5E3B4:	dc.l Pal_TailsEndPose
		dc.l Pal_SonicEndPose
		dc.l Pal_SuperSonicEndPose
; ---------------------------------------------------------------------------

loc_5E3C0:

		move.b	#8,5(a0)
		move.w	#5,$2E(a0)
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_5E3DA
		bset	#0,4(a0)

loc_5E3DA:
		lea	($FFFFB000).w,a1
		move.b	#$83,$2E(a1)
		clr.b	$22(a1)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5E3EE:
		subq.w	#1,$2E(a0)
		bpl.s	loc_5E40C
		move.b	#$12,5(a0)
		addq.b	#1,$22(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_5E40C
		move.l	#Obj_5EF68,(a1)

loc_5E40C:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5E412:
		lea	($FFFFB000).w,a1
		tst.b	$2E(a1)
		bne.s	locret_5E440
		cmpi.w	#2,($FFFFFF08).w
		beq.s	loc_5E442
		move.b	#$C,5(a0)
		move.b	#$81,$2E(a1)
		clr.b	$20(a1)
		move.w	#$800,$18(a1)
		move.w	#$800,$1C(a1)

locret_5E440:
		rts
; ---------------------------------------------------------------------------

loc_5E442:
		jsr	(Create_New_Sprite).l
		bne.s	loc_5E450
		move.l	#loc_5FCDC,(a1)

loc_5E450:
		bset	#0,4(a0)
		bra.w	loc_5E3C0
; ---------------------------------------------------------------------------

loc_5E45A:
		addq.w	#4,$10(a0)
		cmpi.w	#$200,$10(a0)
		bcs.s	locret_5E472
		move.b	#$E,5(a0)
		move.w	#$1F,$2E(a0)

locret_5E472:
		rts
; ---------------------------------------------------------------------------

loc_5E474:
		subq.w	#1,$2E(a0)
		bpl.s	locret_5E4B4
		move.b	#$10,5(a0)
		move.b	#2,$22(a0)
		bclr	#0,4(a0)
		lea	($FFFFB000).w,a1
		move.b	#$83,$2E(a1)
		clr.b	$22(a1)
		jsr	(Create_New_Sprite).l
		bne.s	locret_5E4B4
		move.l	#loc_5FCFC,(a1)
		tst.b	($FFFFFA88).w
		beq.s	locret_5E4B4
		move.b	#2,$2C(a1)

locret_5E4B4:

		rts
; ---------------------------------------------------------------------------

loc_5E4B6:
		subq.w	#8,$10(a0)
		cmpi.w	#$160,$10(a0)
		bhi.s	loc_5E4DC
		move.b	#$12,5(a0)
		move.w	#$160,$10(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_5E4DC
		move.l	#Obj_5EF68,(a1)

loc_5E4DC:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5E4E2:
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_5E4F0
		move.b	#$7F,($FFFFF65E).w

loc_5E4F0:
		btst	#3,($FFFFFAB8).w
		bne.s	loc_5E4FE
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5E4FE:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_5E504:
		move.l	#loc_5E568,(a0)
		move.l	#Map_EndingAnimals,$C(a0)
		move.w	#$2FF,$A(a0)
		move.w	#$380,8(a0)
		move.b	#2,$22(a0)
		move.b	#$C,7(a0)
		move.b	#8,6(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		lea	word_5E554(pc,d0.w),a1
		move.w	(a1)+,$10(a0)
		move.w	(a1)+,$14(a0)
		lsl.w	#2,d0
		move.w	d0,$2E(a0)
		move.w	$10(a0),$3A(a0)
		bra.w	sub_6001E
; ---------------------------------------------------------------------------
word_5E554:	dc.w   $170,   $B0
		dc.w   $150,   $C0
		dc.w   $190,   $D0
		dc.w   $140,   $E0
		dc.w   $168,   $F0
; ---------------------------------------------------------------------------

loc_5E568:
		btst	#3,($FFFFFAB8).w
		bne.w	loc_5EC36
		lea	byte_602A1(pc),a1
		jsr	(Animate_RawNoSST).l
		subq.w	#1,$2E(a0)
		bpl.s	loc_5E58E
		move.l	#loc_5E594,(a0)
		move.w	#-$40,$18(a0)

loc_5E58E:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5E594:

		btst	#3,($FFFFFAB8).w
		bne.w	loc_5EC36
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		lea	byte_602A1(pc),a1
		jsr	(Animate_RawNoSST).l
		move.w	$3A(a0),d0
		sub.w	$10(a0),d0
		cmpi.w	#$30,d0
		blt.s	loc_5E5D4
		move.l	#loc_5E5DA,(a0)
		move.w	#$80,$18(a0)
		move.b	#2,$22(a0)

loc_5E5D4:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5E5DA:
		btst	#3,($FFFFFAB8).w
		bne.w	loc_5EC36
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		move.w	$3A(a0),d0
		sub.w	$10(a0),d0
		bcc.s	loc_5E60C
		move.l	#loc_5E594,(a0)
		move.w	#-$40,$18(a0)
		move.w	$3A(a0),$10(a0)

loc_5E60C:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5E612:
		move.l	#loc_5E64A,(a0)
		move.l	#Map_EndingAnimals,$C(a0)
		move.w	#$62FF,$A(a0)
		move.w	#$280,8(a0)
		move.b	#$C,7(a0)
		move.b	#8,6(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#3,d0
		addi.w	#$60,d0
		move.w	d0,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_5E64A:

		btst	#3,($FFFFFAB8).w
		bne.w	loc_5EC36
		subq.w	#1,$2E(a0)
		bpl.s	locret_5E684
		move.l	#loc_5E686,(a0)
		jsr	(Random_Number).l
		andi.w	#$3F,d0
		addi.w	#$180,d0
		move.w	d0,$10(a0)
		move.w	#$180,$14(a0)
		move.w	#-$300,$18(a0)
		move.w	#-$600,$1A(a0)

locret_5E684:
		rts
; ---------------------------------------------------------------------------

loc_5E686:
		btst	#3,($FFFFFAB8).w
		bne.w	loc_5EC36
		jsr	(MoveSprite).l
		clr.b	$22(a0)
		tst.w	$1A(a0)
		bmi.s	loc_5E6BA
		move.b	#1,$22(a0)
		cmpi.w	#$180,$14(a0)
		bcs.s	loc_5E6BA
		move.l	#loc_5E64A,(a0)
		move.w	#$3B,$2E(a0)

loc_5E6BA:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5E6C0:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	VInt_TableFC(pc,d0.w),d1
		jsr	VInt_TableFC(pc,d1.w)
		tst.b	($FFFFFA88).w
		beq.s	loc_5E6E6
		bmi.s	loc_5E6E6
		lea	(off_7DD5A).l,a1
		lea	($FFFFFC5C).w,a2
		jsr	(Run_PalRotationScript2).l

loc_5E6E6:

		lea	($FFFFB000).w,a1
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
VInt_TableFC:	dc.w loc_5E70E-VInt_TableFC

		dc.w loc_5E80A-VInt_TableFC
		dc.w loc_5E832-VInt_TableFC
		dc.w loc_5E86A-VInt_TableFC
		dc.w loc_5E890-VInt_TableFC
		dc.w loc_5E916-VInt_TableFC
		dc.w loc_5E98A-VInt_TableFC
		dc.w loc_5E9C2-VInt_TableFC
		dc.w loc_5E9E2-VInt_TableFC
; ---------------------------------------------------------------------------

loc_5E70E:
		lea	ObjDat3_600C2(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.w	#$12B,$2E(a0)
		lea	($FFFFB000).w,a1
		move.b	#-$7D,$2E(a1)
		clr.b	$22(a1)
		st	($FFFFEE0A).w
		clr.b	($FFFFFAB8).w
		clr.b	($FFFFF711).w
		clr.w	($FFFFEECC).w
		clr.l	($FFFFFE22).w
		move.w	($FFFFEE78).w,d0
		addi.w	#$C0,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d0
		addi.w	#$110,d0
		move.w	d0,$14(a0)
		lea	ChildObjDat_601BA(pc),a2
		jsr	(CreateChild1_Normal).l
		move.l	#byte_60236,$30(a0)
		bsr.w	sub_5FE82
		tst.b	($FFFFFA88).w
		bmi.s	loc_5E7C0
		move.b	#4,$22(a0)
		move.l	#byte_6023F,$30(a0)
		lea	ChildObjDat_601B2(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	(ArtKosM_HPZMasterEmerald).l,a1
		move.w	#-$5A40,d2
		jsr	(Queue_Kos_Module).l
		tst.b	($FFFFFA88).w
		beq.s	loc_5E7C0
		move.b	#1,($FFFFFE1E).w
		move.b	#-1,($FFFFF65F).w
		move.b	#$F,($FFFFF65E).w
		move.b	#1,($FFFFFE19).w
		move.w	#$7FFF,($FFFFF670).w

loc_5E7C0:

		lea	(Pal_SonicTails).l,a1
		lea	($FFFFFCA0).w,a2
		moveq	#7,d6

loc_5E7CC:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_5E7CC
		move.l	#$EE0088,($FFFFFCAA).w
		lea	(ArtKosM_KnuxEnding).l,a1
		move.w	#$6200,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_SonicPlane).l,a1
		move.w	#$3C60,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_SonicPlaneEnding).l,a1
		move.w	#$4DC0,d2

loc_5E804:
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

loc_5E80A:
		moveq	#-$32,d0

loc_5E80C:
		jsr	(sub_85E52).l
		jsr	(Animate_RawMultiDelay).l
		subq.w	#1,$2E(a0)
		bpl.s	locret_5E830
		move.b	#4,5(a0)
		move.w	#-$6C0,$1A(a0)
		jsr	(Obj_PlayLevelMusic).l

locret_5E830:
		rts
; ---------------------------------------------------------------------------

loc_5E832:
		jsr	(Animate_RawMultiDelay).l
		jsr	(MoveSprite_LightGravity).l
		tst.w	$1A(a0)
		bmi.s	locret_5E868
		move.b	#6,5(a0)
		jsr	(Swing_Setup1).l
		move.w	#$B3,$2E(a0)
		tst.b	($FFFFFA88).w
		bmi.s	locret_5E868
		lea	(word_60244).l,a1
		jsr	(Set_Raw_Animation).l

locret_5E868:

		rts
; ---------------------------------------------------------------------------

loc_5E86A:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jsr	(Animate_RawMultiDelay).l
		subq.w	#1,$2E(a0)
		bpl.s	locret_5E88E
		move.b	#8,5(a0)
		move.w	#$400,$18(a0)

locret_5E88E:
		rts
; ---------------------------------------------------------------------------

loc_5E890:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jsr	(Animate_RawMultiDelay).l
		move.w	($FFFFEE78).w,d0
		addi.w	#$200,d0
		cmp.w	$10(a0),d0
		bhi.w	locret_5FF1A
		move.b	#$A,5(a0)
		move.l	#Map_SonicPlaneEnding,$C(a0)
		move.w	#-$7D92,$A(a0)
		move.b	#1,$22(a0)
		bset	#0,4(a0)
		bset	#7,$2A(a0)
		move.w	($FFFFEE7C).w,d0
		addi.w	#$50,d0
		move.w	d0,$14(a0)
		move.w	#-$200,$18(a0)
		bsr.w	sub_6001E
		lea	word_60253(pc),a1
		jsr	(Set_Raw_Animation).l
		lea	ChildObjDat_601D8(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	ChildObjDat_601CA(pc),a2
		jsr	(CreateChild6_Simple).l
		lea	ChildObjDat_601D0(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_5E916:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		move.w	($FFFFEE78).w,d3
		addi.w	#$60,d3
		cmp.w	$10(a0),d3
		bcs.s	loc_5E936
		jsr	(Animate_RawMultiDelay).l

loc_5E936:
		subi.w	#$A0,d3
		cmp.w	$10(a0),d3
		bcs.w	locret_5FF1A
		move.b	#$C,5(a0)
		move.w	#$226E,$A(a0)
		move.b	#6,$22(a0)
		bclr	#0,4(a0)
		bset	#4,$38(a0)
		move.w	($FFFFEE9C).w,d0
		addi.w	#$448,d0
		move.w	d0,$14(a0)
		move.w	#$100,$18(a0)
		clr.w	$1A(a0)
		lea	ChildObjDat_6022E(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	Pal_EndingSmallPlane(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_5E98A:
		jsr	(MoveSprite2).l
		move.w	($FFFFEE78).w,d0
		addi.w	#$A0,d0
		cmp.w	$10(a0),d0
		bcc.s	locret_5E9C0
		move.b	#$E,5(a0)
		clr.b	$22(a0)
		st	($FFFFEEC4).w
		tst.b	($FFFFFA88).w
		bmi.s	locret_5E9C0
		jsr	(Create_New_Sprite).l
		bne.s	locret_5E9C0
		move.l	#loc_5FC1E,(a1)

locret_5E9C0:

		rts
; ---------------------------------------------------------------------------

loc_5E9C2:
		tst.b	($FFFFFAA9).w
		beq.s	locret_5E9E0
		move.b	#$10,5(a0)
		move.b	#$1A,$22(a0)
		move.w	($FFFFEE9C).w,d0
		addi.w	#$448,d0
		move.w	d0,$14(a0)

locret_5E9E0:
		rts
; ---------------------------------------------------------------------------

loc_5E9E2:
		jsr	(MoveSprite2).l
		tst.b	4(a0)
		bmi.s	locret_5EA18
		move.l	#loc_5EA1A,(a0)
		move.w	#$167,$2E(a0)
		move.b	#2,($FFFFF65F).w
		move.w	#$1E,($FFFFF65C).w
		move.b	#0,($FFFFFE19).w
		move.b	#0,($FFFFF667).w
		bset	#1,$38(a0)

locret_5EA18:
		rts
; ---------------------------------------------------------------------------

loc_5EA1A:
		subq.w	#1,$2E(a0)
		bpl.w	locret_5FF1A
		jsr	(Create_New_Sprite).l
		bne.s	loc_5EA30
		move.l	#loc_5F94C,(a1)

loc_5EA30:
		move.b	#$3F,($FFFFFAB9).w
		clr.w	($FFFFFAC2).w
		move.w	#-$80,($FFFFFAC4).w
		tst.b	($FFFFFA88).w
		bmi.s	loc_5EA4C
		move.w	#$80,($FFFFFAC4).w

loc_5EA4C:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_5EA52:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_5EA6A(pc,d0.w),d1
		jsr	off_5EA6A(pc,d1.w)
		bsr.w	sub_60038
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------
off_5EA6A:	dc.w loc_5EA74-off_5EA6A

		dc.w loc_5EADC-off_5EA6A
		dc.w loc_5EB02-off_5EA6A
		dc.w loc_5EB16-off_5EA6A
		dc.w loc_5EB2E-off_5EA6A
; ---------------------------------------------------------------------------

loc_5EA74:
		lea	ObjDat3_600CE(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bclr	#2,$38(a0)
		beq.s	loc_5EA8C
		bclr	#2,4(a0)

loc_5EA8C:
		tst.b	$2C(a0)
		beq.s	loc_5EABA
		move.b	#4,5(a0)
		move.w	#$40,$10(a0)
		move.w	#$10B,d0
		move.w	d0,$14(a0)
		move.w	d0,$3A(a0)
		tst.b	($FFFFFA88).w
		bmi.s	loc_5EABA
		lea	ChildObjDat_601E8(pc),a2
		jsr	(CreateChild1_Normal).l

loc_5EABA:

		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_5EAC6
		subq.b	#4,$43(a0)

loc_5EAC6:
		bset	#6,4(a0)
		move.w	#2,$16(a0)
		lea	ChildObjDat_601C2(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_5EADC:
		jsr	(Child_GetPriority).l
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		bne.s	loc_5EAF4
		jmp	(Refresh_ChildPositionAdjusted).l
; ---------------------------------------------------------------------------

loc_5EAF4:
		move.b	#8,5(a0)
		move.w	$14(a0),$3A(a0)
		rts
; ---------------------------------------------------------------------------

loc_5EB02:
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		beq.s	locret_5EB14
		move.b	#6,5(a0)

locret_5EB14:
		rts
; ---------------------------------------------------------------------------

loc_5EB16:
		btst	#0,($FFFFFAB8).w
		bne.s	loc_5EB26
		addq.w	#2,$10(a0)
		bra.w	sub_60000
; ---------------------------------------------------------------------------

loc_5EB26:
		move.b	#2,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_5EB2E:
		bra.w	sub_60000
; ---------------------------------------------------------------------------

Obj_5EB32:
		move.l	#loc_5EBB4,(a0)
		movea.w	$46(a0),a1
		move.w	8(a1),8(a0)
		move.b	#$20,7(a0)
		move.b	#$20,6(a0)
		btst	#2,4(a1)
		beq.s	loc_5EB5C
		bset	#2,4(a0)

loc_5EB5C:
		move.w	($FFFFFF08).w,d0
		add.w	d0,d0
		move.w	off_5EB6A(pc,d0.w),d0
		jmp	off_5EB6A(pc,d0.w)
; ---------------------------------------------------------------------------
off_5EB6A:	dc.w loc_5EB72-off_5EB6A

		dc.w loc_5EB72-off_5EB6A
		dc.w loc_5EB88-off_5EB6A
		dc.w loc_5EB9E-off_5EB6A
; ---------------------------------------------------------------------------

loc_5EB72:
		move.l	#Map_SonicPlane,$C(a0)
		move.w	#-$7E1D,$A(a0)
		move.b	#$C,$22(a0)
		rts
; ---------------------------------------------------------------------------

loc_5EB88:
		move.l	#Map_SonicPlaneEnding,$C(a0)
		move.w	#-$7D92,$A(a0)
		move.b	#$B,$22(a0)
		rts
; ---------------------------------------------------------------------------

loc_5EB9E:
		move.l	#Map_SonicPlaneEnding,$C(a0)
		move.w	#-$7D92,$A(a0)
		move.b	#$12,$22(a0)
		rts
; ---------------------------------------------------------------------------

loc_5EBB4:
		jsr	(Child_GetPriority).l
		jsr	(Refresh_ChildPositionAdjusted).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_5EBC6:
		move.l	#loc_5EBE4,(a0)
		lea	(ObjDat3_7D450).l,a1
		jsr	(SetUp_ObjAttributes).l
		addi.w	#$4000,$A(a0)
		move.b	#2,$22(a0)

loc_5EBE4:
		jsr	(Refresh_ChildPosition).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5EBF0:
		lea	word_600F2(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_5EC14,(a0)

loc_5EC00:

		movea.w	$46(a0),a1
		btst	#2,4(a1)
		bne.s	locret_5EC12
		bclr	#2,4(a0)

locret_5EC12:
		rts
; ---------------------------------------------------------------------------

loc_5EC14:
		jsr	(Refresh_ChildPositionAdjusted).l
		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		bne.s	loc_5EC36
		btst	#1,($FFFFFE0F).w
		bne.w	locret_5FF1A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5EC36:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_5EC3C:
		lea	word_600F8(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_5EC4E,(a0)
		bra.s	loc_5EC00
; ---------------------------------------------------------------------------

loc_5EC4E:
		movea.w	$46(a0),a1
		moveq	#0,d0
		move.b	$22(a1),d0
		subq.w	#1,d0
		add.w	d0,d0
		move.w	word_5EC8E(pc,d0.w),$42(a0)
		jsr	(Refresh_ChildPositionAdjusted).l
		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		bne.s	loc_5EC36
		move.b	#$16,$22(a0)
		btst	#1,($FFFFFE0F).w
		beq.s	loc_5EC88
		move.b	#$17,$22(a0)

loc_5EC88:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
word_5EC8E:	dc.w $F60C
		dc.w $F70B
		dc.w $F809
; ---------------------------------------------------------------------------

loc_5EC94:
		lea	word_600FE(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_5ECA8,(a0)
		bra.w	loc_5EC00
; ---------------------------------------------------------------------------

loc_5ECA8:
		jsr	(Refresh_ChildPositionAdjusted).l
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------

loc_5ECB4:
		lea	ObjDat3_600E6(pc),a1
		jsr	(SetUp_ObjAttributes).l
		movea.w	$46(a0),a1
		bclr	#7,$A(a0)
		btst	#7,$A(a1)
		beq.s	loc_5ECD6
		bset	#7,$A(a0)

loc_5ECD6:
		btst	#2,4(a1)
		bne.s	loc_5ECE4
		bclr	#2,4(a0)

loc_5ECE4:
		move.l	#loc_5ED18,(a0)
		move.w	($FFFFFF08).w,d0
		cmpi.w	#3,d0
		bne.s	loc_5ECFC
		tst.b	($FFFFFA88).w
		bmi.s	loc_5ECFC
		addq.w	#1,d0

loc_5ECFC:

		add.w	d0,d0
		tst.b	$2C(a0)
		beq.s	loc_5ED06
		addq.b	#1,d0

loc_5ED06:
		move.b	RawAni_5ED0E(pc,d0.w),$22(a0)
		rts
; ---------------------------------------------------------------------------
RawAni_5ED0E:	dc.b   $C,  $E,	 $C,  $E,  $D,	$F, $13, $14, $13, $15
; ---------------------------------------------------------------------------

loc_5ED18:
		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		bne.w	loc_5EC36
		bsr.w	sub_6008A
		jsr	(Refresh_ChildPositionAdjusted).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5ED36:
		lea	word_60110(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#loc_5ED4A,(a0)
		bra.w	loc_5EC00
; ---------------------------------------------------------------------------

loc_5ED4A:
		jsr	(Child_GetPriority).l
		jsr	(Refresh_ChildPositionAdjusted).l
		movea.w	$46(a0),a1
		btst	#5,$38(a1)
		bne.w	loc_5EC36
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5ED6A:
		lea	word_600F8(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_5ED7E,(a0)
		bra.w	loc_5EC00
; ---------------------------------------------------------------------------

loc_5ED7E:
		jsr	(Refresh_ChildPositionAdjusted).l
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		bne.w	loc_5EC36
		move.b	#$18,$22(a0)
		btst	#1,($FFFFFE0F).w
		beq.s	loc_5EDA6
		move.b	#$19,$22(a0)

loc_5EDA6:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5EDAC:
		move.l	#Map_IslandLiftGfx,$C(a0)
		move.w	#$E2FF,$A(a0)
		move.w	#$300,8(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		move.w	$10(a0),$3A(a0)
		move.w	$14(a0),$3C(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		subi.b	#$41,d0
		bcc.s	loc_5EDE6
		moveq	#0,d0

loc_5EDE6:
		add.w	d0,d0
		move.w	off_5EDF0(pc,d0.w),d0
		jmp	off_5EDF0(pc,d0.w)
; ---------------------------------------------------------------------------
off_5EDF0:	dc.w loc_5EDFE-off_5EDF0

		dc.w loc_5EE18-off_5EDF0
		dc.w loc_5EE3C-off_5EDF0
		dc.w loc_5EE5E-off_5EDF0
		dc.w loc_5EE86-off_5EDF0
		dc.w loc_5EE86-off_5EDF0
		dc.w loc_5EE86-off_5EDF0
; ---------------------------------------------------------------------------

loc_5EDFE:
		move.l	#loc_5EEC4,(a0)
		bset	#2,4(a0)
		move.w	($FFFFEE84).w,$3A(a0)
		bclr	#7,$A(a0)
		rts
; ---------------------------------------------------------------------------

loc_5EE18:
		move.l	#loc_5EF28,(a0)
		move.b	#4,$22(a0)
		move.b	$2D(a0),d0
		move.b	d0,$24(a0)
		cmpi.w	#3,($FFFFFF08).w
		bne.s	locret_5EE3A
		bset	#2,4(a0)

locret_5EE3A:
		rts
; ---------------------------------------------------------------------------

loc_5EE3C:
		move.l	#loc_5EF5C,(a0)
		move.b	#$1A,$22(a0)
		move.l	#byte_60281,$30(a0)
		tst.b	$2D(a0)
		beq.s	locret_5EE5C
		move.b	#$18,$24(a0)

locret_5EE5C:
		rts
; ---------------------------------------------------------------------------

loc_5EE5E:
		move.l	#loc_5EF5C,(a0)
		move.b	#$1A,$22(a0)
		move.l	#byte_60289,$30(a0)
		tst.b	$2C(a0)
		cmpi.b	#8,$2D(a0)
		bcs.s	locret_5EE84
		move.b	#$10,$24(a0)

locret_5EE84:
		rts
; ---------------------------------------------------------------------------

loc_5EE86:
		bclr	#7,$A(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		subi.b	#$45,d0
		lsl.w	#2,d0
		move.l	off_5EEB8(pc,d0.w),$30(a0)
		move.l	#loc_5EF5C,(a0)
		bset	#2,4(a0)
		tst.b	$2D(a0)
		beq.s	locret_5EEB6
		move.b	#$C,$24(a0)

locret_5EEB6:
		rts
; ---------------------------------------------------------------------------
off_5EEB8:	dc.l byte_6028F
		dc.l byte_60295
		dc.l byte_6029B
; ---------------------------------------------------------------------------

loc_5EEC4:
		move.w	($FFFFEE84).w,d0
		sub.w	$3A(a0),d0
		cmpi.w	#$10,d0
		blt.s	loc_5EF04
		move.l	#loc_5EF08,(a0)
		bclr	#2,4(a0)
		move.w	#$10,$1A(a0)
		move.w	$10(a0),d0
		sub.w	($FFFFEE80).w,d0
		addi.w	#$80,d0
		move.w	d0,$10(a0)
		move.w	$14(a0),d0
		sub.w	($FFFFEE84).w,d0
		addi.w	#$80,d0
		move.w	d0,$14(a0)

loc_5EF04:
		bra.w	loc_5EF0E
; ---------------------------------------------------------------------------

loc_5EF08:
		jsr	(MoveSprite2).l

loc_5EF0E:
		lea	byte_60276(pc),a1
		jsr	(Animate_RawNoSST).l
		btst	#0,($FFFFFE0F).w
		bne.w	locret_5FF1A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5EF28:
		lea	byte_6027C(pc),a1
		jsr	(Animate_RawNoSST).l
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_5EF3E
		bsr.w	sub_5FE48

loc_5EF3E:
		btst	#3,($FFFFFAB8).w
		bne.s	loc_5EF56
		btst	#6,$38(a0)
		bne.w	locret_5FF1A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5EF56:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_5EF5C:

		jsr	(Animate_Raw).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_5EF68:

		move.l	#loc_5F144,(a0)
		move.w	#$1FF,$2E(a0)
		clr.b	($FFFFF65F).w
		move.w	($FFFFFF08).w,d0
		moveq	#0,d1
		andi.w	#3,d0
		subq.w	#2,d0
		bmi.s	loc_5EF90
		beq.s	loc_5EF8C
		addi.w	#$30,d1

loc_5EF8C:
		addi.w	#$30,d1

loc_5EF90:
		tst.w	($FFFFFFAE).w
		bne.s	loc_5EF9A
		addi.w	#$18,d1

loc_5EF9A:
		tst.b	($FFFFFA88).w
		bmi.s	loc_5EFAA
		beq.s	loc_5EFA6
		addi.w	#8,d1

loc_5EFA6:
		addi.w	#8,d1

loc_5EFAA:
		lea	off_5EFB6(pc,d1.w),a1
		movea.l	(a1)+,a2
		move.l	(a1)+,$34(a0)
		jmp	(a2)
; ---------------------------------------------------------------------------
off_5EFB6:	dc.l loc_5F046
		dc.l loc_5F0E2
		dc.l loc_5F046
		dc.l loc_5F106
		dc.l loc_5F046
		dc.l loc_5F106
		dc.l loc_5F05C
		dc.l loc_5F0E2
		dc.l loc_5F05C
		dc.l loc_5F106
		dc.l loc_5F05C
		dc.l loc_5F116
		dc.l loc_5F05C
		dc.l loc_5F0E2
		dc.l loc_5F05C
		dc.l loc_5F106
		dc.l loc_5F05C
		dc.l loc_5F116
		dc.l loc_5F05C
		dc.l loc_5F0E2
		dc.l loc_5F05C
		dc.l loc_5F106
		dc.l loc_5F05C
		dc.l loc_5F116
		dc.l loc_5F090
		dc.l loc_5F126
		dc.l loc_5F072
		dc.l loc_5F0DA
		dc.l loc_5F072
		dc.l loc_5F0DA
		dc.l loc_5F0C4
		dc.l loc_5F126
		dc.l loc_5F0A6
		dc.l loc_5F0DA
		dc.l loc_5F0A6
		dc.l loc_5F116
; ---------------------------------------------------------------------------

loc_5F046:
		jsr	(Create_New_Sprite).l
		bne.s	locret_5F05A
		move.l	#loc_5F1AC,(a1)
		move.b	#4,$2C(a1)

locret_5F05A:
		rts
; ---------------------------------------------------------------------------

loc_5F05C:
		jsr	(Create_New_Sprite).l
		bne.s	locret_5F070
		move.l	#loc_5F20A,(a1)
		move.b	#4,$2C(a1)

locret_5F070:
		rts
; ---------------------------------------------------------------------------

loc_5F072:
		jsr	(Create_New_Sprite).l
		bne.s	loc_5F080
		move.l	#loc_5F480,(a1)

loc_5F080:
		jsr	(Create_New_Sprite).l
		bne.s	locret_5F08E
		move.l	#loc_5F1AC,(a1)

locret_5F08E:
		rts
; ---------------------------------------------------------------------------

loc_5F090:
		jsr	(Create_New_Sprite).l
		bne.s	locret_5F0A4
		move.l	#loc_5F1AC,(a1)
		move.b	#8,$2C(a1)

locret_5F0A4:
		rts
; ---------------------------------------------------------------------------

loc_5F0A6:
		jsr	(Create_New_Sprite).l
		bne.s	loc_5F0B4
		move.l	#loc_5F480,(a1)

loc_5F0B4:
		jsr	(Create_New_Sprite).l
		bne.s	locret_5F0C2
		move.l	#loc_5F20A,(a1)

locret_5F0C2:
		rts
; ---------------------------------------------------------------------------

loc_5F0C4:
		jsr	(Create_New_Sprite).l
		bne.s	locret_5F0D8
		move.l	#loc_5F20A,(a1)
		move.b	#8,$2C(a1)

locret_5F0D8:
		rts
; ---------------------------------------------------------------------------

loc_5F0DA:
		move.b	#0,($FFFFF600).w
		rts
; ---------------------------------------------------------------------------

loc_5F0E2:
		jsr	(Create_New_Sprite).l
		bne.s	loc_5F0F0
		move.l	#loc_5F566,(a1)

loc_5F0F0:
		jsr	(Create_New_Sprite).l
		bne.s	locret_5F104
		move.l	#loc_5F8C6,(a1)
		move.b	#4,$2C(a1)

locret_5F104:
		rts
; ---------------------------------------------------------------------------

loc_5F106:
		jsr	(Create_New_Sprite).l
		bne.s	locret_5F114
		move.l	#loc_5F5C2,(a1)

locret_5F114:
		rts
; ---------------------------------------------------------------------------

loc_5F116:
		jsr	(Create_New_Sprite).l
		bne.s	locret_5F124
		move.l	#loc_5FD5A,(a1)

locret_5F124:
		rts
; ---------------------------------------------------------------------------

loc_5F126:
		jsr	(Create_New_Sprite).l
		bne.s	loc_5F134
		move.l	#loc_5F71E,(a1)

loc_5F134:
		jsr	(Create_New_Sprite).l
		bne.s	locret_5F142
		move.l	#loc_5F8C6,(a1)

locret_5F142:
		rts
; ---------------------------------------------------------------------------

loc_5F144:
		subq.w	#1,$2E(a0)
		bmi.s	loc_5F15A
		cmpi.w	#$40,$2E(a0)
		bne.s	locret_5F158
		bset	#2,($FFFFFAB8).w

locret_5F158:

		rts
; ---------------------------------------------------------------------------

loc_5F15A:
		move.l	#loc_5F18A,(a0)
		st	($FFFFF650).w
		jsr	(Create_New_Sprite).l
		bne.s	locret_5F158
		move.w	a1,$44(a0)
		move.l	#Obj_FadeSelectedToBlack,(a1)
		move.w	#5,$3A(a1)
		move.w	#$3F,$3C(a1)
		move.w	#-$400,$30(a1)
		rts
; ---------------------------------------------------------------------------

loc_5F18A:
		movea.w	$44(a0),a1
		btst	#7,$2A(a1)
		beq.w	locret_5FF1A
		move.l	#locret_5F1AA,(a0)
		bset	#3,($FFFFFAB8).w
		movea.l	$34(a0),a1
		jmp	(a1)
; ---------------------------------------------------------------------------

locret_5F1AA:
		rts
; ---------------------------------------------------------------------------

loc_5F1AC:

		lea	ObjDat3_60118(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_5F1F6,(a0)
		lea	word_5F1EA(pc),a1
		bsr.w	sub_5FF1C
		lea	(Pal_EndingSKLogo).l,a1
		lea	($FFFFFCA0).w,a2
		moveq	#7,d6

loc_5F1D0:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_5F1D0
		jsr	(Create_New_Sprite).l
		bne.s	locret_5F1E8
		move.l	#loc_5F4FA,(a1)
		move.w	a0,$46(a1)

locret_5F1E8:
		rts
; ---------------------------------------------------------------------------
word_5F1EA:	dc.w   $120,   $B0
		dc.w	$E0,   $B8
		dc.w   $120,   $F0
; ---------------------------------------------------------------------------

loc_5F1F6:

		btst	#3,($FFFFFAB8).w
		bne.s	loc_5F204
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5F204:

		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_5F20A:

		lea	ObjDat3_60124(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_5F1F6,(a0)
		lea	word_5F260(pc),a1
		bsr.w	sub_5FF1C
		lea	(Pal_EndingS3KLogo).l,a1
		lea	($FFFFFCA0).w,a2
		moveq	#7,d6

loc_5F22E:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_5F22E
		jsr	(Create_New_Sprite).l
		bne.s	loc_5F246
		move.l	#loc_5F526,(a1)
		move.w	a0,$46(a1)

loc_5F246:
		jsr	(Create_New_Sprite).l
		bne.s	locret_5F25E
		move.l	#loc_5F4FA,(a1)
		move.w	a0,$46(a1)
		move.b	#2,$2C(a1)

locret_5F25E:
		rts
; ---------------------------------------------------------------------------
word_5F260:	dc.w   $120,   $B0
		dc.w	$D0,   $B8
		dc.w   $120,   $F0
; ---------------------------------------------------------------------------

loc_5F26C:
		lea	ObjDat3_60154(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_5F1F6,(a0)
		tst.b	$2C(a0)
		beq.s	loc_5F294
		move.l	#loc_5F2EA,(a0)
		move.w	#$4AF,$2E(a0)
		bclr	#2,($FFFFFAB8).w

loc_5F294:
		lea	word_5F2E2(pc),a1
		bsr.w	sub_5FF1C
		lea	(Pal_EndingS3KLogo).l,a1
		lea	($FFFFFCA0).w,a2
		moveq	#7,d6

loc_5F2A8:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_5F2A8
		jsr	(Create_New_Sprite).l
		bne.s	loc_5F2C6
		move.l	#loc_5F4FA,(a1)
		move.w	a0,$46(a1)
		move.b	#4,$2C(a1)

loc_5F2C6:
		jsr	(Create_New_Sprite).l
		bne.s	loc_5F2D8
		move.l	#loc_5F546,(a1)
		move.w	a0,$46(a1)

loc_5F2D8:
		lea	ChildObjDat_601F0(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------
word_5F2E2:	dc.w   $120,   $F0
		dc.w   $120,   $F0
; ---------------------------------------------------------------------------

loc_5F2EA:
		cmpi.w	#$40,$2E(a0)
		bne.s	loc_5F2F8
		bset	#2,($FFFFFAB8).w

loc_5F2F8:

		btst	#7,($FFFFF604).w
		bne.s	loc_5F314
		btst	#7,($FFFFF606).w
		bne.s	loc_5F314
		subq.w	#1,$2E(a0)
		bmi.s	loc_5F314
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5F314:

		move.b	#0,($FFFFF600).w
		rts
; ---------------------------------------------------------------------------

loc_5F31C:
		lea	word_60160(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		bclr	#2,4(a0)
		move.l	#loc_5F376,(a0)
		lea	byte_5F36E(pc),a1
		bsr.w	sub_5FEFE
		lea	(Pal_SonicTails).l,a1
		lea	($FFFFFC80).w,a2
		moveq	#7,d6

loc_5F346:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_5F346
		jsr	(Create_New_Sprite).l
		bne.s	locret_5F36C
		move.l	#loc_5FF62,(a1)
		move.w	#-$3FE,$30(a1)
		move.w	#-$37E,$32(a1)
		move.w	#$E,$3A(a1)

locret_5F36C:
		rts
; ---------------------------------------------------------------------------
byte_5F36E:	dc.b 0
		dc.b $40
		dc.b 0
		dc.b $40
		dc.b $E4
		dc.b $2C
		dc.b $E4
		dc.b $2C
; ---------------------------------------------------------------------------

loc_5F376:
		lea	byte_6025C(pc),a1
		jsr	(Animate_RawNoSST).l
		btst	#2,($FFFFFAB8).w
		beq.s	loc_5F398
		move.l	#loc_5F39E,(a0)
		lea	byte_60260(pc),a1
		jsr	(Set_Raw_Animation).l

loc_5F398:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5F39E:
		jsr	(Animate_Raw).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5F3AA:
		lea	word_60168(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		bclr	#2,4(a0)
		move.l	#loc_5F3DA,(a0)
		lea	byte_5F3D2(pc),a1
		bsr.w	sub_5FEFE
		lea	ChildObjDat_60204(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------
byte_5F3D2:	dc.b $24
		dc.b $2C
		dc.b $24
		dc.b $2C
		dc.b 8
		dc.b $40
		dc.b $24
		dc.b $2C
; ---------------------------------------------------------------------------

loc_5F3DA:
		lea	byte_6026B(pc),a1
		jsr	(Animate_RawNoSST).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5F3EA:
		lea	word_60170(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		bclr	#2,4(a0)
		move.l	#loc_5F400,(a0)

loc_5F400:
		lea	byte_6026F(pc),a1
		jsr	(Animate_RawNoSST).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5F410:
		lea	ObjDat3_60176(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bclr	#2,4(a0)
		move.l	#loc_5F46A,(a0)
		lea	byte_5F462(pc),a1
		bsr.w	sub_5FEFE
		lea	(Pal_EndingEyecatchKnuckles).l,a1
		lea	($FFFFFCC0).w,a2
		moveq	#7,d6

loc_5F43A:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_5F43A
		jsr	(Create_New_Sprite).l
		bne.s	locret_5F460
		move.l	#loc_5FF62,(a1)
		move.w	#-$3BE,$30(a1)
		move.w	#-$33E,$32(a1)
		move.w	#$E,$3A(a1)

locret_5F460:
		rts
; ---------------------------------------------------------------------------
byte_5F462:	dc.b $E4
		dc.b $2C
		dc.b $E4
		dc.b $2C
		dc.b $1C
		dc.b $2C
		dc.b 0
		dc.b $40
; ---------------------------------------------------------------------------

loc_5F46A:
		lea	(word_66771).l,a1
		jsr	(Animate_Raw2NoSSTMultiDelay).l
		bsr.w	Knuckles_Load_PLC_5FEA8
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5F480:

		move.l	#loc_5F4E4,(a0)
		move.l	#Map_KnuxEndPose,$C(a0)
		move.w	#$2C1,$A(a0)
		move.w	#$100,8(a0)
		move.b	#$40,7(a0)
		move.b	#$40,6(a0)
		move.w	#$120,$10(a0)
		move.w	#$108,$14(a0)
		move.l	#word_602CA,$30(a0)
		lea	(Pal_KnuxEndPose).l,a1
		lea	($FFFFFC00).w,a2
		moveq	#7,d6

loc_5F4C6:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_5F4C6
		tst.b	($FFFFFA88).w
		beq.s	locret_5F4E2
		bmi.s	locret_5F4E2
		jsr	(Create_New_Sprite).l
		bne.s	locret_5F4E2
		move.l	#loc_5FBA0,(a1)

locret_5F4E2:

		rts
; ---------------------------------------------------------------------------

loc_5F4E4:
		btst	#3,($FFFFFAB8).w
		bne.w	loc_5F204
		jsr	(Animate_Raw).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5F4FA:

		tst.b	($FFFFFFD8).w
		bpl.w	loc_5EC36
		lea	ObjDat3_60130(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bclr	#2,4(a0)
		move.l	#Child_Draw_Sprite,(a0)
		lea	byte_5F520(pc),a1
		bra.w	loc_5FFD4
; ---------------------------------------------------------------------------
byte_5F520:	dc.b $48

		dc.b 8
		dc.b $34
		dc.b $F0
		dc.b $48
		dc.b $CC
; ---------------------------------------------------------------------------

loc_5F526:
		lea	ObjDat3_6013C(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bclr	#2,4(a0)
		move.l	#Child_Draw_Sprite,(a0)
		lea	byte_5F544(pc),a1
		bra.w	loc_5FFD4
; ---------------------------------------------------------------------------
byte_5F544:	dc.b	0, $14
; ---------------------------------------------------------------------------
loc_5F546
		lea	ObjDat3_60148(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bclr	#2,4(a0)
		move.l	#Child_Draw_Sprite,(a0)
		lea	byte_5F564(pc),a1
		bra.w	loc_5FFD4
; ---------------------------------------------------------------------------
byte_5F564:	dc.b	0, $48
; ---------------------------------------------------------------------------

loc_5F566:
		lea	ObjDat3_6018E(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_5F5B4,(a0)
		bclr	#2,4(a0)
		move.w	#$110,$10(a0)
		move.w	#$F0,$14(a0)
		move.w	#$4AF,$2E(a0)
		lea	(Pal_EndingEyecatchEggman).l,a1
		lea	($FFFFFCA0).w,a2
		moveq	#7,d6

loc_5F59A:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_5F59A
		bsr.w	sub_5FDA4
		lea	(ArtKosM_RobotnikSmug).l,a1
		move.w	#$6000,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

loc_5F5B4:
		lea	byte_602C6(pc),a1
		jsr	(Animate_RawNoSST).l
		bra.w	loc_5F2F8
; ---------------------------------------------------------------------------

loc_5F5C2:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_5F5D6(pc,d0.w),d1
		jsr	off_5F5D6(pc,d1.w)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_5F5D6:	dc.w loc_5F5DE-off_5F5D6

		dc.w loc_5F654-off_5F5D6
		dc.w loc_5F66A-off_5F5D6
		dc.w loc_5F682-off_5F5D6
; ---------------------------------------------------------------------------

loc_5F5DE:
		lea	ObjDat3_6019A(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bclr	#2,4(a0)
		move.w	#$120,$10(a0)
		move.w	#$108,$14(a0)
		move.w	#$EF,$2E(a0)
		lea	(Pal_EndingEyecatchEggRobo).l,a1
		lea	($FFFFFCA0).w,a2
		moveq	#7,d6

loc_5F60C:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_5F60C
		bsr.w	sub_5FDA4
		lea	ChildObjDat_60220(pc),a2
		jsr	(CreateChild1_Normal).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_5F644
		move.w	a1,$46(a1)
		move.l	#loc_862B4,(a1)
		move.w	#$120,$10(a1)
		move.w	#$124,$14(a1)
		move.b	#-$76,$2C(a1)

loc_5F644:
		lea	(ArtKosM_EggRoboSKEnding).l,a1
		move.w	#$6000,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

loc_5F654:
		btst	#2,$38(a0)
		beq.s	locret_5F668
		move.b	#4,5(a0)
		move.w	#$1F,$2E(a0)

locret_5F668:
		rts
; ---------------------------------------------------------------------------

loc_5F66A:
		subq.w	#1,$14(a0)
		subq.w	#1,$2E(a0)
		bpl.s	locret_5F680
		move.b	#6,5(a0)
		move.w	#$4AF,$2E(a0)

locret_5F680:
		rts
; ---------------------------------------------------------------------------

loc_5F682:
		lea	byte_602C2(pc),a1
		jsr	(Animate_RawNoSST).l
		bra.w	loc_5F2F8
; ---------------------------------------------------------------------------

loc_5F690:
		lea	word_601A6(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#Draw_Sprite,(a0)
		bclr	#2,4(a0)
		rts
; ---------------------------------------------------------------------------

loc_5F6A8:
		lea	word_601AC(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		bclr	#2,4(a0)
		move.l	#loc_5F6C4,(a0)
		move.w	#$77,$2E(a0)

loc_5F6C4:
		subq.w	#1,$2E(a0)
		bpl.s	locret_5F6D8
		move.l	#loc_5F6DA,(a0)
		move.l	#loc_5F6EA,$34(a0)

locret_5F6D8:
		rts
; ---------------------------------------------------------------------------

loc_5F6DA:
		lea	byte_602A7(pc),a1
		jsr	(Animate_RawNoSSTMultiDelay).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5F6EA:
		move.l	#loc_5F6FC,(a0)
		movea.w	$46(a0),a1
		bset	#2,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_5F6FC:
		move.b	#-$14,$43(a0)
		movea.w	$46(a0),a1
		tst.b	$22(a1)
		beq.s	loc_5F712
		move.b	#-$13,$43(a0)

loc_5F712:
		jsr	(Refresh_ChildPosition).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5F71E:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_5F73E(pc,d0.w),d1
		jsr	off_5F73E(pc,d1.w)
		lea	(DPLCPtr_7D4D6).l,a2
		jsr	(Perform_DPLC).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_5F73E:	dc.w loc_5F74E-off_5F73E

		dc.w loc_5F7CC-off_5F73E
		dc.w loc_5F802-off_5F73E
		dc.w loc_5F82C-off_5F73E
		dc.w loc_5F82C-off_5F73E
		dc.w loc_5F85A-off_5F73E
		dc.w loc_5F82C-off_5F73E
		dc.w loc_5F8A8-off_5F73E
; ---------------------------------------------------------------------------

loc_5F74E:
		clr.w	($FFFFFA9A).w
		lea	(ObjDat4_7D3EA).l,a1
		jsr	(SetUp_ObjAttributesSlotted).l
		bclr	#2,4(a0)
		bset	#7,$A(a0)
		move.b	#$F,$22(a0)
		move.w	#$120,$10(a0)
		move.w	#$F8,$14(a0)
		move.w	#$EF,$2E(a0)
		lea	(Pal_SSZGHZMisc).l,a1
		lea	($FFFFFCA0).w,a2
		moveq	#7,d6

loc_5F78E:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_5F78E
		bsr.w	sub_5FDA4
		lea	(ChildObjDat_7D48C).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_5F7AC
		move.b	#$80,$2C(a1)

loc_5F7AC:
		lea	(word_7D842).l,a1
		lea	($FFFFFADE).w,a2
		move.l	(a1)+,(a2)+
		move.l	(a1)+,(a2)+
		clr.w	(a2)
		lea	(ArtKosM_MechaSonicExtra).l,a1
		move.w	#$8380,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

loc_5F7CC:
		subq.w	#1,$2E(a0)
		bmi.s	loc_5F7D8
		jmp	(Run_PalRotationScript).l
; ---------------------------------------------------------------------------

loc_5F7D8:
		move.b	#4,5(a0)
		lea	(Pal_SSZGHZMisc).l,a1
		lea	($FFFFFC20).w,a2
		moveq	#7,d6

loc_5F7EA:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_5F7EA
		bset	#6,$38(a0)
		lea	(ChildObjDat_7D492).l,a2

loc_5F7FC:
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_5F802:
		btst	#6,$38(a0)
		bne.w	locret_5FF1A
		move.b	#6,5(a0)
		move.b	#$E,$22(a0)
		move.l	#loc_5F832,$34(a0)
		lea	(byte_7D5EF).l,a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_5F82C:
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_5F832:
		move.b	#8,5(a0)
		move.l	#loc_5F84C,$34(a0)
		lea	(byte_7D5F6).l,a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_5F84C:
		move.b	#$A,5(a0)
		move.w	#-$400,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_5F85A:
		jsr	(MoveSprite_LightGravity).l
		tst.w	$1A(a0)
		bmi.w	locret_5FF1A
		cmpi.w	#$C8,$14(a0)
		bcs.w	locret_5FF1A
		move.b	#$C,5(a0)
		move.w	#$CC,$14(a0)
		move.l	#loc_5F89A,$34(a0)
		moveq	#-$6A,d0
		jsr	(Play_Sound_2).l
		lea	(byte_7D5AB).l,a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_5F89A:
		move.b	#$E,5(a0)
		move.w	#$4AF,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_5F8A8:
		btst	#7,($FFFFF604).w
		bne.s	loc_5F8BE
		btst	#7,($FFFFF606).w
		bne.s	loc_5F8BE
		subq.w	#1,$2E(a0)
		bpl.s	locret_5F8C4

loc_5F8BE:

		move.b	#0,($FFFFF600).w

locret_5F8C4:
		rts
; ---------------------------------------------------------------------------

loc_5F8C6:

		lea	ObjDat3_60182(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bclr	#2,4(a0)
		move.l	#loc_5F946,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lea	word_5F93E(pc,d0.w),a1
		move.w	(a1)+,$10(a0)
		move.w	(a1)+,$14(a0)
		lea	(Pal_EndingMasterEmerald).l,a1
		lea	($FFFFFC80).w,a2
		moveq	#7,d6

loc_5F8FA:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_5F8FA
		jsr	(Create_New_Sprite).l
		bne.s	loc_5F92E
		move.w	a1,$44(a0)

loc_5F90C:
		move.l	#Obj_FadeSelectedFromBlack,(a1)
		moveq	#5,d0
		move.w	d0,$3A(a1)
		move.w	d0,$2E(a1)
		move.w	#$F,$3C(a1)
		move.w	#-$400,$30(a1)
		move.w	#-$380,$32(a1)

loc_5F92E:
		lea	(ArtKosM_HPZMasterEmerald).l,a1
		move.w	#-$5A40,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------
word_5F93E:	dc.w   $120,  $100
		dc.w   $130,   $F4
; ---------------------------------------------------------------------------

loc_5F946:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5F94C:

		move.l	#loc_5F986,(a0)
		move.l	($FFFFFE0C).w,($FFFFF636).w
		lea	(Pal_FBZCloud).l,a1
		lea	($FFFFFC00).w,a2
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_5F96E
		lea	($FFFFFC20).w,a2

loc_5F96E:
		moveq	#3,d0

loc_5F970:
		move.l	(a1)+,(a2)+
		dbf	d0,loc_5F970
		lea	(ArtKosM_FBZCloud).l,a1
		move.w	#$76C0,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

loc_5F986:
		tst.b	($FFFFFAB9).w
		beq.w	loc_5EC36
		move.b	($FFFFFE0F).w,d0
		and.b	($FFFFFAB9).w,d0
		bne.w	locret_5FA56
		addq.b	#1,$39(a0)
		jsr	(Create_New_Sprite).l
		bne.w	locret_5FA56
		jsr	(Random_Number).l
		move.l	#loc_5FA58,(a1)
		move.b	d0,$2C(a1)
		move.w	($FFFFFAC2).w,d2
		beq.s	loc_5F9D0
		move.w	d0,d1
		andi.w	#$3F,d1
		tst.w	d2
		bpl.s	loc_5F9CA
		neg.w	d1

loc_5F9CA:
		add.w	d2,d1
		move.w	d1,$18(a1)

loc_5F9D0:
		move.w	($FFFFFAC4).w,d3
		beq.s	loc_5F9EA
		move.l	d0,d1
		swap	d1
		andi.w	#$3F,d1
		tst.w	d3
		bpl.s	loc_5F9E4
		neg.w	d1

loc_5F9E4:
		add.w	d3,d1
		move.w	d1,$1A(a1)

loc_5F9EA:
		tst.w	d2
		beq.s	loc_5FA1C
		tst.w	d3
		beq.s	loc_5F9FA
		btst	#0,$39(a0)
		bne.s	loc_5FA1C

loc_5F9FA:
		move.w	#$50,d1
		tst.w	d2
		bpl.s	loc_5FA06
		move.w	#$1F0,d1

loc_5FA06:
		move.w	d1,$10(a1)
		move.w	d0,d1

loc_5FA0C:
		andi.w	#$FF,d1
		addi.w	#$80,d1
		move.w	d1,$14(a1)
		bra.w	loc_5FA4A
; ---------------------------------------------------------------------------

loc_5FA1C:

		move.w	#$60,d1
		tst.w	d3
		bpl.s	loc_5FA28
		move.w	#$180,d1

loc_5FA28:
		move.w	d1,$14(a1)
		move.w	d0,d1
		andi.w	#$1FF,d1
		move.w	d1,d2
		subi.w	#$160,d2
		bcs.s	loc_5FA42
		add.w	d2,d2
		addi.w	#$10,d2
		move.w	d2,d1

loc_5FA42:
		addi.w	#$70,d1
		move.w	d1,$10(a1)

loc_5FA4A:
		moveq	#1,d1
		tst.w	d0
		bpl.s	loc_5FA52
		moveq	#3,d1

loc_5FA52:
		move.b	d1,$22(a1)

locret_5FA56:

		rts
; ---------------------------------------------------------------------------

loc_5FA58:
		move.l	#loc_5FA8C,(a0)
		move.l	#Map_FBZ2Preboss,$C(a0)
		move.w	#$3B6,$A(a0)
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_5FA7A
		move.w	#$23B6,$A(a0)

loc_5FA7A:
		move.w	#$300,8(a0)
		move.b	#$20,7(a0)
		move.b	#$10,6(a0)

loc_5FA8C:
		move.w	($FFFFFAC2).w,d0
		beq.s	loc_5FAA0
		move.w	$18(a0),d1
		add.w	d0,d1
		ext.l	d1
		lsl.l	#8,d1
		add.l	d1,$10(a0)

loc_5FAA0:
		move.w	($FFFFFAC4).w,d2
		beq.s	loc_5FAB4
		move.w	$1A(a0),d3
		add.w	d2,d3
		ext.l	d3
		lsl.l	#8,d3
		add.l	d3,$14(a0)

loc_5FAB4:
		cmpi.w	#$200,$10(a0)
		bcc.w	loc_5EC36
		cmpi.w	#$200,$14(a0)
		bcc.w	loc_5EC36
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_Difficulty_5FACE:
		move.l	#Map_SKPoseBanner,$C(a0)
		move.w	#$6180,$A(a0)
		move.w	#$280,8(a0)
		move.b	#$40,7(a0)
		move.b	#$14,6(a0)
		move.l	#loc_5FB14,(a0)
		move.w	#$120,$10(a0)
		move.w	#$A0,$14(a0)
		jsr	(Create_New_Sprite).l
		bne.s	locret_5FB12
		move.l	#loc_5FB1A,(a1)
		move.w	a0,$46(a1)

locret_5FB12:
		rts
; ---------------------------------------------------------------------------

loc_5FB14:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5FB1A:
		tst.b	($FFFFFFD8).w
		bpl.w	loc_5EC36
		move.l	#Map_ANDKnuckles,$C(a0)
		move.w	#$61C8,$A(a0)
		move.w	#$280,8(a0)
		move.b	#8,7(a0)
		move.b	#4,6(a0)
		move.b	#2,$22(a0)
		move.l	#Child_Draw_Sprite,(a0)
		lea	byte_5F520(pc),a1
		bra.w	loc_5FFD4
; ---------------------------------------------------------------------------

Obj_Difficulty_Eggman:
		move.l	#Map_EndingEyecatchEggman,$C(a0)
		move.w	#$2232,$A(a0)
		bset	#0,4(a0)
		move.w	#$280,8(a0)
		move.b	#$20,7(a0)
		move.b	#$20,6(a0)
		move.l	#loc_5FB90,(a0)
		move.w	#$168,$10(a0)
		move.w	#$108,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_5FB90:
		lea	byte_602C6(pc),a1
		jsr	(Animate_RawNoSST).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_5FBA0:
		tst.b	($FFFFF650).w
		bne.w	loc_5EC36
		subq.b	#1,$24(a0)
		bpl.w	locret_5FBE0
		move.b	#2,$24(a0)
		lea	Pal_KnuxEndPoseSuper(pc),a1
		move.w	$3A(a0),d0
		addq.w	#6,d0
		cmpi.w	#$3C,d0
		bcs.s	loc_5FBCE
		moveq	#0,d0
		move.b	#$E,$24(a0)

loc_5FBCE:
		move.w	d0,$3A(a0)
		lea	($FFFFFC04).w,a2
		move.l	(a1,d0.w),(a2)+
		move.w	4(a1,d0.w),2(a2)

locret_5FBE0:
		rts
; ---------------------------------------------------------------------------
Pal_KnuxEndPoseSuper:	binclude "General\Ending\Palettes\Super Knuckles End Pose.bin"

; ---------------------------------------------------------------------------

loc_5FC1E:

		move.b	#2,$39(a0)
		move.l	#loc_5FC2A,(a0)

loc_5FC2A:
		subq.w	#1,$2E(a0)
		bpl.s	locret_5FC4C
		move.w	#5,$2E(a0)
		lea	($FFFFFC42).w,a1
		moveq	#$E,d0

loc_5FC3C:
		jsr	(sub_85EB4).l
		dbf	d0,loc_5FC3C
		subq.b	#1,$39(a0)
		bmi.s	loc_5FC4E

locret_5FC4C:

		rts
; ---------------------------------------------------------------------------

loc_5FC4E:
		move.l	#loc_5FC62,(a0)
		move.b	#2,$39(a0)
		move.w	#$13,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_5FC62:
		subq.w	#1,$2E(a0)
		bpl.s	locret_5FC4C
		move.w	#3,$2E(a0)
		lea	($FFFFFC42).w,a1
		lea	($FFFFFCC2).w,a2
		moveq	#$E,d0

loc_5FC78:
		jsr	(sub_85F2A).l
		dbf	d0,loc_5FC78
		subq.b	#1,$39(a0)
		bpl.s	locret_5FC4C
		jmp	(Go_Delete_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_5FC8E:
		clr.b	($FFFFB020).w
		move.w	#$24,($FFFFF65C).w
		move.b	#1,($FFFFFE19).w

loc_5FC9E:
		move.b	#-1,($FFFFF65F).w
		move.b	#0,($FFFFF65E).w
		move.l	#Map_SuperSonic,($FFFFB00C).w
		rts
; End of function sub_5FC8E


; =============== S U B R O U T I N E =======================================


sub_5FCB4:
		move.b	#-1,($FFFFF65F).w
		move.w	#0,($FFFFF65C).w
		move.b	#0,($FFFFF668).w
		move.b	#1,($FFFFF667).w
		rts
; End of function sub_5FCB4


; =============== S U B R O U T I N E =======================================


sub_5FCCE:

		move.b	#-1,($FFFFFE19).w
		move.w	#0,($FFFFF65C).w
		bra.s	loc_5FC9E
; End of function sub_5FCCE

; ---------------------------------------------------------------------------

loc_5FCDC:
		move.l	#loc_5FCEC,(a0)
		lea	dword_60C0A(pc),a1
		jsr	(sub_7C678).l

loc_5FCEC:
		btst	#3,($FFFFFAB8).w
		bne.w	loc_5EC36
		jmp	(Run_PalRotationScript).l
; ---------------------------------------------------------------------------

loc_5FCFC:
		move.l	#loc_5FD16,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_5FD4E(pc,d0.w),$3A(a0)
		add.w	d0,d0
		move.l	off_5FD52(pc,d0.w),$30(a0)

loc_5FD16:
		tst.b	($FFFFF650).w
		bne.w	loc_5EC36
		subq.b	#1,$24(a0)
		bpl.s	locret_5FD4C
		move.b	$3B(a0),$24(a0)
		moveq	#0,d0
		move.b	$23(a0),d0
		addq.b	#6,d0
		cmp.b	$3A(a0),d0
		bcs.s	loc_5FD3A
		moveq	#0,d0

loc_5FD3A:
		move.b	d0,$23(a0)
		movea.l	$30(a0),a1
		adda.w	d0,a1
		lea	($FFFFFC44).w,a2
		move.l	(a1)+,(a2)+
		move.w	(a1)+,(a2)+

locret_5FD4C:
		rts
; ---------------------------------------------------------------------------
word_5FD4E:	dc.w $1806
		dc.w $4804
off_5FD52:	dc.l AnPal_SuperSonic_1+$24
		dc.l AnPal_SuperSonic_4
; ---------------------------------------------------------------------------

loc_5FD5A:
		move.l	#loc_5FD66,(a0)
		move.w	#$1F,$2E(a0)

loc_5FD66:
		subq.w	#1,$2E(a0)
		bpl.w	locret_5FF1A
		jsr	(Create_New_Sprite).l
		bne.s	loc_5FD82
		move.l	#loc_5F26C,(a1)
		move.b	#4,$2C(a1)

loc_5FD82:
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_5FD88:

		lea	($FFFFB000).w,a1
		move.w	($FFFFFF08).w,d0
		andi.w	#3,d0
		move.b	byte_5FDA0(pc,d0.w),$22(a1)
		jmp	(Player_Load_PLC).l
; End of function sub_5FD88

; ---------------------------------------------------------------------------
byte_5FDA0:	dc.b $BA
		dc.b $BA
		dc.b $AD
		dc.b $56

; =============== S U B R O U T I N E =======================================


sub_5FDA4:

		jsr	(Create_New_Sprite).l
		bne.s	locret_5FDD2
		move.w	a1,$44(a0)
		move.l	#Obj_FadeSelectedFromBlack,(a1)
		moveq	#5,d0
		move.w	d0,$3A(a1)
		move.w	d0,$2E(a1)
		move.w	#$F,$3C(a1)
		move.w	#-$3E0,$30(a1)
		move.w	#-$360,$32(a1)

locret_5FDD2:
		rts
; End of function sub_5FDA4

; ---------------------------------------------------------------------------

Obj_5FDD4:
		move.w	#$77,$2E(a0)
		move.l	#loc_5FDE0,(a0)

loc_5FDE0:
		subq.w	#1,$2E(a0)
		bpl.s	locret_5FE0E
		move.l	#loc_5FE10,(a0)
		lea	($FFFFB000).w,a1
		move.b	#$F,$20(a1)
		move.b	#2,($FFFFF65F).w
		move.w	#$1E,($FFFFF65C).w
		move.b	#0,($FFFFFE19).w
		move.b	#0,($FFFFF667).w

locret_5FE0E:
		rts
; ---------------------------------------------------------------------------

loc_5FE10:
		move.l	#Map_Sonic,($FFFFB00C).w
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


Create_Continue_Sprite:

		moveq	#0,d3

loc_5FE20:
		jsr	(Create_New_Sprite).l
		move.l	#loc_5EDAC,(a1)
		move.b	d1,$2C(a1)
		move.b	d3,$2D(a1)
		move.w	(a2,d3.w),$10(a1)
		move.w	2(a2,d3.w),$14(a1)
		addq.w	#4,d3
		dbf	d2,loc_5FE20
		rts
; End of function Create_Continue_Sprite


; =============== S U B R O U T I N E =======================================


sub_5FE48:
		bclr	#6,$38(a0)
		move.w	$3A(a0),d0
		sub.w	($FFFFEE98).w,d0
		addi.w	#$80,d0
		move.w	d0,$10(a0)
		cmpi.w	#$200,d0
		bcc.s	loc_5FE7A
		move.w	$3C(a0),d0
		sub.w	($FFFFEE9C).w,d0
		addi.w	#$80,d0
		move.w	d0,$14(a0)
		cmpi.w	#$200,d0
		bcs.s	locret_5FE80

loc_5FE7A:
		bset	#6,$38(a0)

locret_5FE80:
		rts
; End of function sub_5FE48


; =============== S U B R O U T I N E =======================================


sub_5FE82:

		moveq	#0,d0
		lea	($FFFFFA82).w,a1
		move.l	d0,(a1)+
		move.l	d0,(a1)+
		moveq	#2,d0
		cmpi.b	#7,($FFFFFFB1).w
		beq.s	loc_5FEA2
		moveq	#0,d0
		cmpi.b	#7,($FFFFFFB0).w
		beq.s	loc_5FEA2
		moveq	#-2,d0

loc_5FEA2:

		move.b	d0,($FFFFFA88).w
		rts
; End of function sub_5FE82


; =============== S U B R O U T I N E =======================================


Knuckles_Load_PLC_5FEA8:
		moveq	#0,d0
		move.b	$22(a0),d0
		cmp.b	$3A(a0),d0
		beq.s	locret_5FEFC
		move.b	d0,$3A(a0)
		lea	(PLC_Knuckles).l,a2
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d5
		subq.w	#1,d5
		bmi.s	locret_5FEFC
		move.w	#$BC00,d4
		move.l	#ArtUnc_Knux,d6

loc_5FED4:
		moveq	#0,d1
		move.w	(a2)+,d1
		move.w	d1,d3
		lsr.w	#8,d3
		andi.w	#$F0,d3
		addi.w	#$10,d3
		andi.w	#$FFF,d1
		lsl.l	#5,d1
		add.l	d6,d1
		move.w	d4,d2
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		dbf	d5,loc_5FED4

locret_5FEFC:
					; Knuckles_Load_PLC_5FEA8+20j
		rts
; End of function Knuckles_Load_PLC_5FEA8


; =============== S U B R O U T I N E =======================================


sub_5FEFE:

		move.w	($FFFFFF08).w,d0
		andi.w	#3,d0
		add.w	d0,d0
		adda.w	d0,a1
		move.b	(a1)+,d0
		ext.w	d0
		add.w	d0,$10(a0)
		move.b	(a1)+,d0
		ext.w	d0
		add.w	d0,$14(a0)

locret_5FF1A:

		rts
; End of function sub_5FEFE


; =============== S U B R O U T I N E =======================================


sub_5FF1C:

		moveq	#0,d0
		move.b	$2C(a0),d0
		adda.w	d0,a1
		move.w	(a1)+,$10(a0)
		move.w	(a1)+,$14(a0)
		bclr	#2,4(a0)
		lea	($FFFFFC20).w,a1
		moveq	#0,d0
		moveq	#7,d1

loc_5FF3A:
		move.l	d0,(a1)+
		dbf	d1,loc_5FF3A
		jsr	(Create_New_Sprite).l
		bne.s	locret_5FF60
		move.l	#loc_5FF62,(a1)
		move.w	#-$3E0,$30(a1)
		move.w	#-$360,$32(a1)
		move.w	#$F,$3A(a1)

locret_5FF60:
		rts
; End of function sub_5FF1C

; ---------------------------------------------------------------------------

loc_5FF62:

		move.b	#7,$39(a0)
		move.l	#loc_5FF6E,(a0)

loc_5FF6E:
		subq.w	#1,$2E(a0)
		bpl.s	locret_5FF92
		move.w	#3,$2E(a0)
		movea.w	$30(a0),a1
		move.w	$3A(a0),d0

loc_5FF82:
		jsr	(sub_85EB4).l
		dbf	d0,loc_5FF82
		subq.b	#1,$39(a0)
		bmi.s	loc_5FF94

locret_5FF92:

		rts
; ---------------------------------------------------------------------------

loc_5FF94:
		move.l	#loc_5FFA6,(a0)
		move.b	#7,$39(a0)
		move.w	#3,$2E(a0)

loc_5FFA6:
		subq.w	#1,$2E(a0)
		bpl.s	locret_5FF92
		move.w	#3,$2E(a0)
		movea.w	$30(a0),a1
		movea.w	$32(a0),a2
		move.w	$3A(a0),d0

loc_5FFBE:
		jsr	(sub_85F2A).l
		dbf	d0,loc_5FFBE
		subq.b	#1,$39(a0)
		bpl.s	locret_5FF92
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_5FFD4:

		moveq	#0,d0
		move.b	$2C(a0),d0
		lea	(a1,d0.w),a1
		movea.w	$46(a0),a2
		move.b	(a1)+,d0
		ext.w	d0
		move.w	$10(a2),d1
		add.w	d0,d1
		move.w	d1,$10(a0)
		move.b	(a1)+,d0
		ext.w	d0
		move.w	$14(a2),d1
		add.w	d0,d1
		move.w	d1,$14(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_60000:

		move.b	$3C(a0),d0

loc_60004:
		addq.b	#4,d0

loc_60006:
		move.b	d0,$3C(a0)

loc_6000A:
		jsr	(GetSineCosine).l
		asr.w	#6,d0

loc_60012:
		move.w	$3A(a0),d1
		add.w	d0,d1

loc_60018:
		move.w	d1,$14(a0)
		rts
; End of function sub_60000


; =============== S U B R O U T I N E =======================================


sub_6001E:

		move.w	#$80,d0
		move.w	d0,$3E(a0)
		move.w	d0,$1A(a0)
		move.w	#8,$40(a0)
		bclr	#0,$38(a0)
		rts
; End of function sub_6001E


; =============== S U B R O U T I N E =======================================


sub_60038:
		lea	byte_6006E(pc),a1
		jsr	(sub_86458).l
		moveq	#0,d0
		move.b	$44(a0),d0
		addq.b	#1,d0
		cmpi.b	#6,d0
		bcs.s	loc_60052
		moveq	#0,d0

loc_60052:
		move.b	d0,$44(a0)
		move.b	byte_60072(pc,d0.w),$1D(a0)
		moveq	#6,d0
		btst	#0,($FFFFFE0F).w
		beq.s	loc_60068
		moveq	#7,d0

loc_60068:
		move.b	d0,$23(a0)
		rts
; End of function sub_60038

; ---------------------------------------------------------------------------
byte_6006E:	dc.b $34
		dc.b 4
		dc.b $18
		dc.b $18
byte_60072:	dc.b 2
		dc.b 3
		dc.b 4
		dc.b 5
		dc.b 4
		dc.b 3
; ---------------------------------------------------------------------------
		move.l	d0,($FFFFFA82).w
		add.l	d0,($FFFFEE98).w
		move.l	d1,($FFFFFA84).w
		add.l	d1,($FFFFEE9C).w
		rts

; =============== S U B R O U T I N E =======================================


sub_6008A:
		movea.w	$46(a0),a1
		moveq	#0,d0
		move.b	$22(a1),d0
		subq.b	#1,d0
		add.w	d0,d0
		move.w	off_600B0(pc,d0.w),d1
		lea	off_600B0(pc,d1.w),a2
		tst.b	$2C(a0)
		beq.s	loc_600A8
		addq.w	#2,a2

loc_600A8:
		move.w	(a2)+,d0
		move.w	d0,$42(a0)
		rts
; End of function sub_6008A

; ---------------------------------------------------------------------------
off_600B0:	dc.w word_600B6-off_600B0

		dc.w word_600BA-off_600B0
		dc.w word_600BE-off_600B0
word_600B6:	dc.w $FCF8
		dc.w $10EC
word_600BA:	dc.w $FCF9
		dc.w $10F4
word_600BE:	dc.w $FCFC
		dc.w $10F6
ObjDat3_600C2:	dc.l Map_KnuxEnding
		dc.w $8310
		dc.w $200
		dc.b $20
		dc.b $20
		dc.b 5
		dc.b 0
ObjDat3_600CE:	dc.l Map_SonicPlane
		dc.w $81E3
		dc.w $200
		dc.b $40
		dc.b $20
		dc.b 1
		dc.b 0
ObjDat3_600DA:	dc.l Map_SonicPlaneEnding
		dc.w $826E
		dc.w $200
		dc.b $20
		dc.b $14
		dc.b 0
		dc.b 0
ObjDat3_600E6:	dc.l Map_SonicPlaneEnding
		dc.w $826E
		dc.w $200
		dc.b $C
		dc.b $C
		dc.b 0
		dc.b 0
word_600F2:	dc.w $200
		dc.b 4
		dc.b 8
		dc.b 4
		dc.b 0
word_600F8:	dc.w $180

		dc.b $C
		dc.b 4
		dc.b $16
		dc.b 0
word_600FE:	dc.w $200
		dc.b $40
		dc.b $10
		dc.b 9
		dc.b 0
ObjDat3_60104:	dc.l Map_SonicPlaneEnding
		dc.w $826E
		dc.w $200
		dc.b $80
		dc.b $10
		dc.b 7
		dc.b 0
word_60110:	dc.w $426E
		dc.w $200
		dc.b 4
		dc.b 4
		dc.b $11
		dc.b 0
ObjDat3_60118:	dc.l Map_SKPoseBanner
		dc.w $A415
		dc.b 1
		dc.b $80
		dc.b $40
		dc.b $14
		dc.w 0
ObjDat3_60124:	dc.l Map_S3PoseBanner
		dc.w $A415
		dc.b 1
		dc.b $80
		dc.b $30
		dc.b $10
		dc.w 0
ObjDat3_60130:	dc.l Map_ANDKnuckles
		dc.w $A3EF
		dc.w $180
		dc.b 8
		dc.b 4
		dc.b 2
		dc.b 0
ObjDat3_6013C:	dc.l Map_ANDKnuckles
		dc.w $A3EF
		dc.w $180
		dc.b $20
		dc.b 4
		dc.b 0
		dc.b 0
ObjDat3_60148:	dc.l Map_ANDKnuckles
		dc.w $A3EF
		dc.w $300
		dc.b $38
		dc.b 8
		dc.b 1
		dc.b 0
ObjDat3_60154:	dc.l Map_S3EndingGraphics
		dc.w $A45D
		dc.w $180
		dc.b $50
		dc.b $50
		dc.b 0
		dc.b 0
word_60160:	dc.w $845D
		dc.w $100
		dc.b $20
		dc.b $20
		dc.b 1
		dc.b 0
word_60168:	dc.w $845D
		dc.w $100
		dc.b $20
		dc.b $20
		dc.b $A
		dc.b 0
word_60170:	dc.w $100
		dc.b $C
		dc.b $C
		dc.b $A
		dc.b 0
ObjDat3_60176:	dc.l Map_Knuckles
		dc.w $C5E0
		dc.w $100
		dc.b $20
		dc.b $20
		dc.b $D8
		dc.b 0
ObjDat3_60182:	dc.l Map_SSZMasterEmerald
		dc.w $852E
		dc.w $300
		dc.b $20
		dc.b $18
		dc.b 2
		dc.b 0
ObjDat3_6018E:	dc.l Map_EndingEyecatchEggman
		dc.w $A300
		dc.w $200
		dc.b $38
		dc.b $20
		dc.b 0
		dc.b 0
ObjDat3_6019A:	dc.l Map_EndingEyecatchEggRobo
		dc.w $A300
		dc.w $200
		dc.b $38
		dc.b $20
		dc.b 0
		dc.b 0
word_601A6:	dc.w $180
		dc.b $38
		dc.b $20
		dc.b 4
		dc.b 0
word_601AC:	dc.w $180
		dc.b 8
		dc.b 8
		dc.b 2
		dc.b 0
ChildObjDat_601B2:dc.w 0
		dc.l Obj_5EBC6
		dc.b 4
		dc.b $F0
ChildObjDat_601BA:dc.w 0

		dc.l Obj_5EA52
		dc.b $E0
		dc.b $2B
ChildObjDat_601C2:dc.w 0
		dc.l Obj_5EB32
		dc.b 0
		dc.b $F0
ChildObjDat_601CA:dc.w 1

		dc.l loc_5ECB4
ChildObjDat_601D0:dc.w 0

		dc.l loc_5EBF0
		dc.w $1C00
ChildObjDat_601D8:dc.w 0

		dc.l loc_5EC3C
		dc.w $F60C
ChildObjDat_601E0:dc.w 0
		dc.l loc_5EC94
		dc.w $DEFE
ChildObjDat_601E8:dc.w 0
		dc.l loc_5DF80
		dc.w $C0FC
ChildObjDat_601F0:dc.w 2
		dc.l loc_5F31C
		dc.w 0
		dc.l loc_5F3AA
		dc.w 0
		dc.l loc_5F410
		dc.w 0
ChildObjDat_60204:dc.w 0
		dc.l loc_5F3EA
		dc.w $F008
ChildObjDat_6020C:dc.w 0
		dc.l loc_5ED36
		dc.w $F005
ChildObjDat_60214:dc.w 4
		dc.l loc_5E504
ChildObjDat_6021A:dc.w 1
		dc.l loc_5E612
ChildObjDat_60220:dc.w 1
		dc.l loc_5F690
		dc.w $F0
		dc.l loc_5F6A8
		dc.w $EC
ChildObjDat_6022E:dc.w 0

		dc.l loc_5ED6A
		dc.w $FA07
byte_60236:	dc.b 5
		dc.b $B
		dc.b 6
		dc.b 5
		dc.b 7
		dc.b $B
		dc.b 6
		dc.b $B
		dc.b $FC
byte_6023F:	dc.b 4
		dc.b $7F
		dc.b 4
		dc.b $7F
		dc.b $FC
word_60244:	dc.w $400
		dc.w $43F
		dc.w $105
		dc.w $205
		dc.w $33F
		dc.w $47F
		dc.w $47F
		dc.b $FC ; 
word_60253:	dc.w $10F

		dc.w $20F
		dc.w $37F
		dc.w $37F
		dc.b $FC ; 
byte_6025C:	dc.b $F
		dc.b 1
		dc.b 2
		dc.b $FC
byte_60260:	dc.b 7
		dc.b 1
		dc.b 1
		dc.b 3
		dc.b 4
		dc.b $F8
		dc.b 7
		dc.b $7F
		dc.b 4
		dc.b 4
		dc.b $FC
byte_6026B:	dc.b $F
		dc.b $A
		dc.b $B
		dc.b $FC
byte_6026F:	dc.b $B
		dc.b 5
		dc.b 6
		dc.b 7
		dc.b 8
		dc.b 9
		dc.b $FC
byte_60276:	dc.b 7
		dc.b 0
		dc.b 1
		dc.b 2
		dc.b 3
		dc.b $FC
byte_6027C:	dc.b 7
		dc.b 4
		dc.b 5
		dc.b 6
		dc.b $FC
byte_60281:	dc.b 7
		dc.b 7
		dc.b 8
		dc.b 9
		dc.b $1A
		dc.b $1A
		dc.b $1A
		dc.b $FC
byte_60289:	dc.b 7
		dc.b $A
		dc.b $B
		dc.b $C
		dc.b $D
		dc.b $FC
byte_6028F:	dc.b $B
		dc.b $E
		dc.b $F
		dc.b $10
		dc.b $11
		dc.b $FC
byte_60295:	dc.b $B
		dc.b $12
		dc.b $13
		dc.b $14
		dc.b $15
		dc.b $FC
byte_6029B:	dc.b $B
		dc.b $16
		dc.b $17
		dc.b $18
		dc.b $19
		dc.b $FC
byte_602A1:	dc.b 5

		dc.b 2
		dc.b 3
		dc.b 4
		dc.b 3
		dc.b $FC
byte_602A7:	dc.b 2
		dc.b 0
		dc.b 2
		dc.b 1
		dc.b 6
		dc.b $F
		dc.b 2
		dc.b 1
		dc.b 6
		dc.b 7
		dc.b 2
		dc.b 1
		dc.b 6
		dc.b 3
		dc.b 2
		dc.b 1
		dc.b 6
		dc.b 1
		dc.b 2
		dc.b 1
		dc.b 6
		dc.b 1
		dc.b 2
		dc.b $13
		dc.b 3
		dc.b $3F
		dc.b $F4
byte_602C2:	dc.b $E
		dc.b 0
		dc.b 1
		dc.b $FC
byte_602C6:	dc.b $B

		dc.b 0
		dc.b 1
		dc.b $FC
word_602CA:	dc.w $500
		dc.w 1
		dc.w $2F8
		dc.w $77F
		dc.w $202
		dc.w $FC00
Map_KnuxEnding:	include "General\Sprites\Knuckles\Cutscene\Map - Ending Cutscene.asm"

Map_SonicPlane:	include "General\Ending\Map - Sonic Plane.asm"

Map_SonicPlaneEnding:	include "General\Ending\Map - Sonic Plane Ending.asm"

Map_SKPoseBanner:	include "General\Ending\Map - Sonic and Knuckles Pose Banner.asm"

Map_S3PoseBanner:	include "General\Ending\Map - Sonic 3 Pose Banner.asm"

Map_IslandLiftGfx:	include "General\Ending\Map - Island Lift Sprites.asm"

Map_EndingAnimals:	include "General\Ending\Map - Ending Pelican and Dolphin.asm"

Map_SonicTailsEndPoses:	include "General\Ending\Map - Sonic Tails Ending Poses.asm"

Map_ANDKnuckles:	include "General\Title\Map - ANDKnuckles Subtitle.asm"

Map_EndingEyecatchEggRobo:	include "General\Ending\Map - Ending Egg Robo Eyecatch.asm"

Map_EndingEyecatchEggman:	include "General\Ending\Map - Ending Eggman Eyecatch.asm"

Map_KnuxEndPose:	include "General\Ending\Map - Knuckles End Pose.asm"

Pal_EndingSmallPlane:	binclude "General\Ending\Palettes\Small Plane.bin"


Pal_EndingSKLogo:	binclude "General\Ending\Palettes\SK Logo.bin"


Pal_EndingS3KLogo:	binclude "General\Ending\Palettes\S3K Logo.bin"


Pal_EndingEyecatchKnuckles:	binclude "General\Ending\Palettes\Knuckles Eyecatch.bin"

Pal_EndingMasterEmerald:	binclude "General\Ending\Palettes\Master Emerald.bin"

Pal_FBZCloud:	binclude "Levels\FBZ\Palettes\FBZ Cloud.bin"

Pal_TailsEndPose:	binclude "General\Ending\Palettes\Tails End Pose.bin"

Pal_SonicEndPose:	binclude "General\Ending\Palettes\Sonic End Pose.bin"

Pal_SuperSonicEndPose:	binclude "General\Ending\Palettes\Super Sonic End Pose.bin"

Pal_EndingEyecatchEggRobo:	binclude "General\Ending\Palettes\Egg Robo Eyecatch.bin"

Pal_EndingEyecatchEggman:	binclude "General\Ending\Palettes\Eggman Eyecatch.bin"

Pal_KnuxEndPose:	binclude "General\Ending\Palettes\Knuckles End Pose.bin"

dword_60C0A:	dc.l	 $40000,    $60C14
		dc.l	  $FC44,  $300006C
		dc.l	$8E00AE,  $8CE0017
		dc.l   $28E02AE,  $2CE0AEE
		dc.l	 $704AE,  $4CE04EE
		dc.l   $CEE0007,  $6CE06EE
		dc.l   $6EE0EEE,    $704AE
		dc.l   $4CE04EE,  $CEE0007
		dc.l   $28E02AE,  $2CE0AEE
		dc.l	 $7FFFC
; ---------------------------------------------------------------------------

Obj_86:

		lea	ObjDat3_613B0(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_60CB8,(a0)
		move.w	a0,($FFFFFAA4).w
		subi.w	#$100,$14(a0)
		move.w	$14(a0),$3A(a0)
		st	($FFFFF665).w
		move.l	($FFFFFE0C).w,($FFFFF636).w
		move.w	($FFFFFE32).w,($FFFFFE20).w
		move.b	($FFFFFE43).w,($FFFFFE1B).w
		move.b	#1,($FFFFFE1D).w
		bset	#7,($FFFFB00A).w
		bset	#7,($FFFFB054).w
		lea	($FF2000).l,a1
		moveq	#-1,d0
		moveq	#8,d1

loc_60CA8:
		move.l	d0,(a1)+
		dbf	d1,loc_60CA8
		lea	ChildObjDat_613F8(pc),a2
		jsr	(CreateChild1_Normal).l

loc_60CB8:

		bsr.w	sub_6126C
		lea	word_60D16(pc),a1
		jsr	(Check_PlayerInRange).l
		tst.w	d0
		bne.s	loc_60CD0
		swap	d0
		tst.w	d0
		beq.s	loc_60D10

loc_60CD0:
		move.l	#loc_60D1E,(a0)
		move.l	#loc_60D32,$34(a0)
		bset	#1,$38(a0)
		movea.w	d0,a1
		move.w	$10(a0),d0
		cmp.w	$10(a1),d0
		scs	d1
		tst.w	$1A(a1)
		bmi.s	loc_60CF8
		not.b	d1

loc_60CF8:
		bclr	#0,4(a0)
		tst.b	d1
		beq.s	loc_60D08
		bset	#0,4(a0)

loc_60D08:
		moveq	#-$2E,d0
		jsr	(Play_Sound_2).l

loc_60D10:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
word_60D16:	dc.w $FFDC
		dc.w $48
		dc.w $FFF8
		dc.w $10
; ---------------------------------------------------------------------------

loc_60D1E:
		bsr.w	sub_6126C
		lea	byte_61450(pc),a1
		jsr	(Animate_RawNoSST).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_60D32:
		move.l	#loc_60D40,(a0)
		bset	#3,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_60D40:
		bsr.w	sub_6126C
		btst	#1,$38(a0)
		bne.s	loc_60D52
		move.l	#loc_60CB8,(a0)

loc_60D52:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_60D58:

		lea	ObjDat3_61398(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.w	#$100,$10(a0)
		move.w	#$310,$14(a0)
		lea	ChildObjDat_61424(pc),a2
		jsr	(CreateChild1_Normal).l
		move.l	#loc_60D7E,(a0)

loc_60D7E:
		btst	#1,$38(a0)
		bne.s	loc_60D96
		lea	(SolidObjectFull).l,a1
		bsr.w	sub_61314
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_60D96:
		clr.b	($FF2022).l
		lea	ChildObjDat_6143E(pc),a2
		jsr	(CreateChild6_Simple).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_60DAC:

		lea	ObjDat3_613C8(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.w	#-$1000,$30(a0)
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		bne.s	loc_60E36
		move.w	#$1B,d1
		move.w	#8,d2
		move.w	#$10,d3
		move.w	$10(a0),d4
		lea	($FFFFB000).w,a1
		moveq	#3,d6
		movem.l	d1-d4,-(sp)
		jsr	SolidObjectFull2_1P
		btst	#3,$2A(a0)
		beq.s	loc_60DFC
		bset	#5,$38(a0)
		jsr	(sub_22F98).l

loc_60DFC:
		movem.l	(sp)+,d1-d4
		lea	($FFFFB04A).w,a1
		moveq	#4,d6
		jsr	SolidObjectFull2_1P
		btst	#4,$2A(a0)
		beq.s	loc_60E1A
		jsr	(sub_22F98).l

loc_60E1A:
		lea	(Ani_Spring).l,a1
		jsr	(Animate_Sprite).l
		btst	#5,$38(a0)
		beq.s	loc_60E46
		cmpi.b	#1,$21(a0)
		bne.s	loc_60E46

loc_60E36:
		move.l	#MoveChkDel,(a0)
		movea.w	$46(a0),a1
		bset	#1,$38(a1)

loc_60E46:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_60E4C:
		lea	ObjDat3_613BC(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_60E5C,(a0)

loc_60E5C:

		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		beq.s	loc_60E80
		move.l	#loc_60E8C,(a0)
		move.l	#loc_60EA2,$34(a0)
		lea	ChildObjDat_61444(pc),a2
		jsr	(CreateChild6_Simple).l

loc_60E80:
		jsr	(Refresh_ChildPosition).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_60E8C:
		lea	byte_6145B(pc),a1
		jsr	(Animate_RawNoSSTMultiDelay).l
		jsr	(Refresh_ChildPosition).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_60EA2:
		move.l	#loc_60E5C,(a0)
		movea.w	$46(a0),a1
		bclr	#1,$38(a1)
		bclr	#3,$38(a1)

locret_60EB8:

		rts
; ---------------------------------------------------------------------------

loc_60EBA:
		lea	ObjDat3_613E0(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_60ECE,(a0)
		bsr.w	sub_612A8

loc_60ECE:
		move.w	$1A(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$200,d0
		bhi.s	loc_60EE0
		move.w	d0,$1A(a0)

loc_60EE0:
		jsr	(MoveSprite2).l
		movea.w	$46(a0),a1
		move.w	$14(a1),d0
		cmp.w	$14(a0),d0
		bls.s	loc_60EFC
		move.w	d0,$14(a0)
		bra.w	loc_60F0E
; ---------------------------------------------------------------------------

loc_60EFC:
		addi.w	#$10,d0
		cmp.w	$14(a0),d0
		bhi.s	loc_60F0E
		jsr	(sub_610E0).l
		bne.s	loc_60F28

loc_60F0E:

		move.w	($FFFFEE7C).w,d0
		addi.w	#$240,d0
		cmp.w	$14(a0),d0
		bcs.s	loc_60F28
		jsr	(Animate_Raw).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_60F28:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_87:

		lea	ObjDat3_613A4(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_60F3E,(a0)

loc_60F3E:
		tst.w	($FF2020).l
		bpl.s	loc_60F8E
		moveq	#$D,d1
		moveq	#8,d2
		moveq	#$11,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		btst	#$10,d6
		bne.s	loc_60F64
		btst	#3,$2A(a0)
		beq.s	loc_60F72

loc_60F64:
		lea	($FFFFB000).w,a1
		bsr.w	sub_60F94
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_60F72:
		btst	#$11,d6
		bne.s	loc_60F80
		btst	#4,$2A(a0)
		beq.s	loc_60F8E

loc_60F80:
		lea	($FFFFB04A).w,a1
		bsr.w	sub_60F94
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_60F8E:

		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_60F94:

		move.w	#-$300,d0
		move.w	#-$600,$1A(a1)
		bset	#0,$2A(a1)
		btst	#0,4(a0)
		bne.s	loc_60FB4
		bclr	#0,$2A(a1)
		neg.w	d0

loc_60FB4:
		move.w	d0,$18(a1)
		move.w	d0,$1C(a1)
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		move.b	#$10,$20(a1)
		clr.b	$40(a1)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lea	($FF2000).l,a1
		clr.b	(a1,d0.w)
		move.w	#$F,($FF2020).l
		movea.w	($FFFFFAA4).w,a1
		bset	#0,$38(a1)
		moveq	#-$4F,d0
		jsr	(Play_Sound_2).l
		rts
; End of function sub_60F94

; ---------------------------------------------------------------------------

loc_60FFE:

		lea	ObjDat3_6138C(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_61012,(a0)
		bsr.w	sub_61362

loc_61012:
		jsr	(Refresh_ChildPosition).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6101E:
		lea	ObjDat3_613D4(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_61032,(a0)
		bsr.w	sub_61320

loc_61032:
		subq.b	#1,$2E(a0)
		bpl.s	loc_6103E
		move.l	#MoveChkDel,(a0)

loc_6103E:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_61044:
		addi.w	#$2A0,$14(a0)
		move.l	#loc_61050,(a0)

loc_61050:
		subq.w	#1,($FF2020).l
		lea	word_610AE(pc),a1
		jsr	(Check_PlayerInRange).l
		tst.w	d0
		bne.s	loc_61076
		swap	d0
		tst.w	d0
		beq.w	locret_60EB8
		lea	($FFFFB04A).w,a1
		jmp	(Delete_Referenced_Sprite).l
; ---------------------------------------------------------------------------

loc_61076:
		move.w	($FFFFFE2C).w,($FFFFFE10).w
		move.w	($FFFFFF9A).w,($FFFFEE4E).w
		move.b	($FFFFFE2B).w,($FFFFFE2A).w
		move.b	#0,($FFFFFE48).w
		move.b	#1,($FFFFFE02).w
		move.w	($FFFFFE20).w,($FFFFFE32).w
		move.b	($FFFFFE1B).w,($FFFFFE43).w
		move.b	($FFFFB02B).w,d0
		andi.b	#$71,d0
		move.b	d0,($FFFFFE47).w
		rts
; ---------------------------------------------------------------------------
word_610AE:	dc.w  $FF00,  $200, $FFF0,   $40
; ---------------------------------------------------------------------------

loc_610B6:
		lea	ObjDat3_613EC(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_610C6,(a0)

loc_610C6:
		st	($FFFFEF3A).w
		movea.w	$46(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_610E0:
		lea	word_610F0(pc),a1
		jsr	(Check_PlayerInRange).l
		tst.l	d0
		bne.s	loc_610F8
		rts
; ---------------------------------------------------------------------------
word_610F0:	dc.w  $FFE8,   $30, $FFE8,   $30
; ---------------------------------------------------------------------------

loc_610F8:
		moveq	#0,d1
		moveq	#1,d2
		move.b	$2C(a0),d1

loc_61100:
		add.w	d1,d1
		move.w	off_6110E(pc,d1.w),d1
		jsr	off_6110E(pc,d1.w)
		tst.w	d2

locret_6110C:

		rts
; End of function sub_610E0

; ---------------------------------------------------------------------------
off_6110E:	dc.w loc_61120-off_6110E

		dc.w loc_61130-off_6110E
		dc.w loc_6114E-off_6110E
		dc.w locret_6114C-off_6110E
		dc.w loc_6115C-off_6110E
		dc.w loc_611D6-off_6110E
		dc.w loc_61200-off_6110E
		dc.w loc_6122A-off_6110E
		dc.w loc_61264-off_6110E
; ---------------------------------------------------------------------------

loc_61120:
		addq.b	#1,($FFFFFE12).w
		addq.b	#1,($FFFFFE1C).w
		moveq	#$2A,d0
		jmp	(Play_Sound).l
; ---------------------------------------------------------------------------

loc_61130:
		tst.b	($FF2022).l
		bne.s	locret_6110C
		jsr	(Create_New_Sprite3).l
		bne.s	locret_6110C
		move.l	#loc_60D58,(a1)
		st	($FF2022).l

locret_6114C:
		rts
; ---------------------------------------------------------------------------

loc_6114E:
		addi.w	#$14,($FFFFFE32).w
		moveq	#$A,d0
		jmp	(AddRings).l
; ---------------------------------------------------------------------------

loc_6115C:
		move.l	d0,-(sp)
		tst.w	d0
		beq.s	loc_61164
		bsr.s	sub_61176

loc_61164:
		move.l	(sp)+,d0
		swap	d0
		tst.w	d0
		beq.s	loc_6116E
		bsr.s	sub_61176

loc_6116E:
		clr.b	$29(a0)
		moveq	#0,d2
		rts

; =============== S U B R O U T I N E =======================================


sub_61176:

		movea.w	d0,a1
		move.w	$10(a0),d1
		move.w	$14(a0),d2
		sub.w	$10(a1),d1
		sub.w	$14(a1),d2
		jsr	(GetArcTan).l
		move.b	($FFFFFE04).w,d1
		andi.w	#3,d1
		add.w	d1,d0
		jsr	(GetSineCosine).l
		muls.w	#-$700,d1
		asr.l	#8,d1
		move.w	d1,$18(a1)
		muls.w	#-$700,d0
		asr.l	#8,d0
		move.w	d0,$1A(a1)
		bset	#1,$2A(a1)
		bclr	#4,$2A(a1)
		bclr	#5,$2A(a1)
		clr.b	$40(a1)
		move.b	#1,$20(a0)
		moveq	#$7B,d0
		jmp	(Play_Sound_2).l
; End of function sub_61176

; ---------------------------------------------------------------------------

loc_611D6:
		lea	($FFFFB000).w,a1
		move.l	#Obj_Fire_Shield,($FFFFCCE8).w
		move.w	a1,($FFFFCD2A).w
		andi.b	#-$72,$2B(a1)
		bset	#0,$2B(a1)
		moveq	#4,d0
		bsr.w	sub_61254
		moveq	#$3E,d0
		jmp	(Play_Sound).l
; ---------------------------------------------------------------------------

loc_61200:
		lea	($FFFFB000).w,a1
		move.l	#Obj_Bubble_Shield,($FFFFCCE8).w
		move.w	a1,($FFFFCD2A).w
		andi.b	#-$72,$2B(a1)
		bset	#0,$2B(a1)
		moveq	#6,d0
		bsr.w	sub_61254
		moveq	#$3F,d0
		jmp	(Play_Sound).l
; ---------------------------------------------------------------------------

loc_6122A:
		lea	($FFFFB000).w,a1
		move.l	#Obj_Lightning_Shield,($FFFFCCE8).w
		move.w	a1,($FFFFCD2A).w
		andi.b	#-$72,$2B(a1)
		bset	#0,$2B(a1)
		moveq	#5,d0
		bsr.w	sub_61254
		moveq	#$41,d0
		jmp	(Play_Sound).l

; =============== S U B R O U T I N E =======================================


sub_61254:

		bset	d0,$2B(a1)
		lea	($FFFFFE47).w,a2
		andi.b	#-$71,(a2)
		bset	d0,(a2)
		rts
; End of function sub_61254

; ---------------------------------------------------------------------------

loc_61264:
		bset	#7,($FFFFFE47).w
		rts

; =============== S U B R O U T I N E =======================================


sub_6126C:

		bclr	#0,$38(a0)
		beq.s	loc_61294
		lea	($FF2000).l,a1
		moveq	#0,d0
		moveq	#$D,d1

loc_6127E:
		tst.w	(a1)+
		bne.s	loc_6128A
		addi.w	#$20,d0
		dbf	d1,loc_6127E

loc_6128A:
		move.w	$3A(a0),d1
		add.w	d0,d1
		move.w	d1,$3C(a0)

loc_61294:
		move.w	$3C(a0),d1
		move.w	$14(a0),d2
		cmp.w	d1,d2
		bcc.s	locret_612A6
		addq.w	#4,d2
		move.w	d2,$14(a0)

locret_612A6:
		rts
; End of function sub_6126C


; =============== S U B R O U T I N E =======================================


sub_612A8:
		jsr	(Random_Number).l
		andi.w	#$F,d0
		bne.s	loc_612C2
		movea.w	$46(a0),a1
		bset	#7,$38(a1)
		beq.s	loc_612C2
		moveq	#3,d0

loc_612C2:

		move.b	byte_612E0(pc,d0.w),d0
		move.b	d0,$2C(a0)
		cmpi.b	#4,d0
		bne.s	loc_612D6
		move.b	#-$29,$28(a0)

loc_612D6:
		lsl.w	#2,d0
		move.l	off_612F0(pc,d0.w),$30(a0)
		rts
; End of function sub_612A8

; ---------------------------------------------------------------------------
byte_612E0:	dc.b 0
		dc.b 3
		dc.b 1
		dc.b 4
		dc.b 2
		dc.b 4
		dc.b 5
		dc.b 4
		dc.b 6
		dc.b 3
		dc.b 7
		dc.b 4
		dc.b 5
		dc.b 6
		dc.b 7
		dc.b 2
off_612F0:	dc.l word_61466
		dc.l word_6146A
		dc.l word_6146E
		dc.l word_61472
		dc.l word_61476
		dc.l word_6147A
		dc.l word_6147E
		dc.l word_61482
		dc.l word_61486

; =============== S U B R O U T I N E =======================================


sub_61314:
		moveq	#$4B,d1
		moveq	#$10,d2
		moveq	#$11,d3
		move.w	$10(a0),d4
		jmp	(a1)
; End of function sub_61314


; =============== S U B R O U T I N E =======================================


sub_61320:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.b	d0,$2E(a0)
		lea	byte_61342(pc,d0.w),a1
		move.b	(a1)+,d0
		ext.w	d0
		add.w	d0,$10(a0)
		moveq	#0,d0
		move.b	(a1)+,d0
		ext.w	d0
		add.w	d0,$14(a0)
		rts
; End of function sub_61320

; ---------------------------------------------------------------------------
byte_61342:	dc.b  $F8,   8
		dc.b	8,   8
		dc.b  $F8, $F8
		dc.b	8, $F8
		dc.b  $E8,   8
		dc.b  $18,   8
		dc.b  $E8, $F8
		dc.b  $18, $F8
		dc.b  $D8,   8
		dc.b  $28,   8
		dc.b  $D8, $F8
		dc.b  $28, $F8
		dc.b  $C8,   8
		dc.b  $38,   8
		dc.b  $C8, $F8
		dc.b  $38, $F8

; =============== S U B R O U T I N E =======================================


sub_61362:
		moveq	#0,d0
		move.b	$2C(a0),d0
		subi.w	#6,d0
		lsr.w	#1,d0
		move.b	RawAni_61388(pc,d0.w),d0
		move.b	d0,$22(a0)
		cmpi.b	#$16,d0
		bne.w	locret_60EB8
		lea	ChildObjDat_6144A(pc),a2
		jmp	(CreateChild6_Simple).l
; End of function sub_61362

; ---------------------------------------------------------------------------
RawAni_61388:	dc.b	0,   1,	  0, $16
ObjDat3_6138C:	dc.l Map_GumballBonus
		dc.w $15B
		dc.w $200
		dc.b $10
		dc.b $20
		dc.b 0
		dc.b 0
ObjDat3_61398:	dc.l Map_GumballBonus
		dc.w $A15B
		dc.w $100
		dc.b $40
		dc.b $10
		dc.b $13
		dc.b 0
ObjDat3_613A4:	dc.l Map_GumballBonus
		dc.w $A15B
		dc.w $100
		dc.b 4
		dc.b $10
		dc.b $12
		dc.b 0
ObjDat3_613B0:	dc.l Map_GumballBonus
		dc.w $A15B
		dc.w $100
		dc.b $18
		dc.b $18
		dc.b 5
		dc.b 0
ObjDat3_613BC:	dc.l Map_GumballBonus
		dc.w $A15B
		dc.w $100
		dc.b $14
		dc.b $14
		dc.b 2
		dc.b 0
ObjDat3_613C8:	dc.l Map_Spring
		dc.w $4A4
		dc.w $100
		dc.b $10
		dc.b $10
		dc.b 0
		dc.b 0
ObjDat3_613D4:	dc.l Map_GumballBonus
		dc.w $A15B
		dc.w $100
		dc.b 8
		dc.b 8
		dc.b $15
		dc.b 0
ObjDat3_613E0:	dc.l Map_GumballBonus
		dc.w $815B
		dc.w $100
		dc.b 8
		dc.b 8
		dc.b 8
		dc.b 0
ObjDat3_613EC:	dc.l Map_GumballBonus
		dc.w 0
		dc.w $180
		dc.b 4
		dc.b $10
		dc.b $17
		dc.b 0
ChildObjDat_613F8:dc.w 6
		dc.l loc_60D58
		dc.b 0
		dc.b 0
		dc.l loc_60E4C
		dc.b 0
		dc.b $24
		dc.l loc_61044
		dc.b 0
		dc.b 0
		dc.l loc_60FFE
		dc.b $C8
		dc.b $D4
		dc.l loc_60FFE
		dc.b 0
		dc.b $D4
		dc.l loc_60FFE
		dc.b $38
		dc.b $D4
		dc.l loc_60FFE
		dc.b 0
		dc.b $D8
ChildObjDat_61424:dc.w 3
		dc.l loc_60DAC
		dc.b $D0
		dc.b $E8
		dc.l loc_60DAC
		dc.b $F0
		dc.b $E8
		dc.l loc_60DAC
		dc.b $10
		dc.b $E8
		dc.l loc_60DAC
		dc.b $30
		dc.b $E8
ChildObjDat_6143E:dc.w $F
		dc.l loc_6101E
ChildObjDat_61444:dc.w 0
		dc.l loc_60EBA
ChildObjDat_6144A:dc.w 0
		dc.l loc_610B6
byte_61450:	dc.b 3
		dc.b 5
		dc.b 6
		dc.b 7
		dc.b $14
		dc.b 5
		dc.b $F4
		dc.b $7F
		dc.b 5
		dc.b 5
		dc.b $FC
byte_6145B:	dc.b 2
		dc.b 3
		dc.b 3
		dc.b 3
		dc.b 4
		dc.b $F
		dc.b 3
		dc.b 3
		dc.b 2
		dc.b 3
		dc.b $F4
word_61466:	dc.w $7F08
		dc.w $8FC
word_6146A:	dc.w $7F09
		dc.w $9FC
word_6146E:	dc.w $7F0A
		dc.w $AFC
word_61472:	dc.w $7F0B
		dc.w $BFC
word_61476:	dc.w $7F0C
		dc.w $CFC
word_6147A:	dc.w $7F0D
		dc.w $DFC
word_6147E:	dc.w $7F0E
		dc.w $EFC
word_61482:	dc.w $7F0F
		dc.w $FFC
word_61486:	dc.w $110
		dc.w $11FC
Map_GumballBonus:	include "Levels\Gumball\Misc Object Data\Map - Gumball Bonus.asm"

; ---------------------------------------------------------------------------

Obj_SSEntryRing:

		move.b	$2C(a0),d0
		move.l	($FFFFFF92).w,d1
		btst	d0,d1
		beq.s	loc_6167C				; only make the ring if it hasn't already been collected
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_6167C:
		jsr	(Obj_WaitOffscreen).l			; Don't start anything until the ring is explicitly onscreen
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	SSEntryRing_Index(pc,d0.w),d1
		jsr	SSEntryRing_Index(pc,d1.w)
		bra.w	SSEntryRing_Display
; ---------------------------------------------------------------------------
SSEntryRing_Index:	dc.w SSEntryRing_Init-SSEntryRing_Index
		dc.w SSEntryRing_Main-SSEntryRing_Index
		dc.w SSEntryRing_Animate-SSEntryRing_Index
; ---------------------------------------------------------------------------

SSEntryRing_Init:

		lea	ObjSlot_SSEntryRing(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l		; Only one special stage ring can be loaded at one time, period
		move.l	#AniRaw_SSEntryRing,$30(a0)
		tst.b	$2C(a0)
		bmi.s	loc_616C6			; If negative, then ALWAYS make this a super emerald ring
		tst.w	($FFFFFFAE).w		; Probably only used in MHZ for the first rings
		bne.s	SSEntryRing_Main			; If only Sonic and Knuckles, skip ahead
		bsr.w	SSEntry_CheckLevel
		beq.s	SSEntryRing_Main			; If in an S3 level, skip ahead since it's a normal ring
		cmpi.b	#7,($FFFFFFB0).w
		bne.s	SSEntryRing_Main			; Only make this a super emerald ring if you actually have 7 chaos emeralds

loc_616C6:
		bset	#6,$38(a0)				; Make this a super emerald ring
		lea	(PalSPtr_SSEntry).l,a1
		lea	($FFFFFADE).w,a2
		move.l	(a1)+,(a2)+
		move.l	(a1)+,(a2)+
		lea	(PalSPtr_SSEntry2).l,a1
		move.l	(a1)+,(a2)+
		move.l	(a1)+,(a2)+
		clr.w	(a2)					; Set up the Palette script pointers

SSEntryRing_Main:

		jsr	(Animate_Raw).l
		tst.w	($FFFFFE08).w
		bne.s	locret_61708		; If in debug mode, don't allow collision
		cmpi.b	#8,$22(a0)
		bcs.s	locret_61708		; If ring hasn't finished forming, don't allow collision
		lea	SSEntry_Range(pc),a1
		jsr	(Check_PlayerInRange).l
		tst.w	d0
		bne.s	loc_6170A

locret_61708:

		rts
; ---------------------------------------------------------------------------

loc_6170A:
		lea	($FFFFB000).w,a1			; If collision was made
		cmpi.b	#6,5(a1)
		bcc.s	locret_61708		; If player has died for whatever reason, don't do anything
		moveq	#-$4D,d0
		jsr	(Play_Sound_2).l		; Play the ring swish sound
		cmpi.b	#7,($FFFFFFB0).w
		bne.s	loc_6173A			; If chaos emeralds aren't collected, branch
		tst.w	($FFFFFFAE).w
		bne.s	loc_61794			; If only Sonic and Knuckles and the emeralds are collected, go claim 50 rings
		bsr.w	SSEntry_CheckLevel
		beq.s	loc_61794			; Otherwise, only do so if on an S3 level
		cmpi.b	#7,($FFFFFFB1).w
		beq.s	loc_61794			; Only collect rings in an SK level if the super emeralds are collected as well

loc_6173A:
		move.b	#4,5(a0)
		move.b	#-1,($FFFFF766).w	; Make the player disappear and lock input
		lea	($FFFFB000).w,a1
		move.b	#0,$22(a1)
		move.b	#$1C,$20(a1)
		move.b	#$53,$2E(a1)
		tst.b	($FFFFF73E).w
		beq.s	loc_61778
		lea	($FFFFB04A).w,a1
		move.b	#0,$22(a1)
		move.b	#$1C,$20(a1)
		move.b	#$53,$2E(a1)		; Lock both players, etc

loc_61778:
		jsr	(Create_New_Sprite).l
		bne.s	locret_6178A
		move.l	#Obj_SSEntryFlash,(a1)
		move.w	a0,$46(a1)			; Set ring as parent

locret_6178A:
		rts
; ---------------------------------------------------------------------------
SSEntry_Range:	dc.w $FFE8
		dc.w $30
		dc.w $FFD8
		dc.w $50
; ---------------------------------------------------------------------------

loc_61794:

		moveq	#-$4D,d0
		jsr	(Play_Sound_2).l
		move.b	$2C(a0),d0
		move.l	($FFFFFF92).w,d1
		bset	d0,d1
		move.l	d1,($FFFFFF92).w	; Set the special stage ring as collected
		bset	#5,$38(a0)
		moveq	#$32,d0				; Add 50 rings
		jmp	(AddRings).l
; ---------------------------------------------------------------------------

SSEntryRing_Animate:
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

Obj_SSEntryFlash:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	SSEntryFlash_Index(pc,d0.w),d1
		jsr	SSEntryFlash_Index(pc,d1.w)
		lea	DPLCPtr_SSEntryFlash(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
SSEntryFlash_Index:	dc.w SSEntryFlash_Init-SSEntryFlash_Index
		dc.w SSEntryFlash_Main-SSEntryFlash_Index
; ---------------------------------------------------------------------------

SSEntryFlash_Init:
		lea	ObjSlot_SSEntryFlash(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l
		move.l	#AniRaw_SSEntryFlash,$30(a0)
		move.l	#SSEntryFlash_Finished,$34(a0)
		movea.w	$46(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		move.b	$2C(a1),$2C(a0)		; Copy positional data from parent ring
		move.w	($FFFFB010).w,d0
		cmp.w	$10(a0),d0
		bcs.s	locret_61820
		bset	#0,4(a1)			; Set direction based on where player approached

locret_61820:
		rts
; ---------------------------------------------------------------------------

SSEntryFlash_Main:
		move.b	$22(a0),d6
		jsr	(Animate_RawAdjustFlipX).l
		cmp.b	$22(a0),d6
		beq.s	locret_61844
		cmpi.b	#3,$23(a0)
		bne.s	locret_61844
		movea.w	$46(a0),a1			; Set parent to be deleted in the middle of the animation
		bset	#5,$38(a1)

locret_61844:

		rts
; ---------------------------------------------------------------------------

SSEntryFlash_Finished:
		move.l	#Obj_Wait,(a0)		; This is performed when animation is finished
		move.w	#$20,$2E(a0)
		move.l	#SSEntryFlash_GoSS,$34(a0)
		rts
; ---------------------------------------------------------------------------

SSEntryFlash_GoSS:
		moveq	#-$51,d0
		jsr	(Play_Sound_2).l		; Play the special stage entry sound (you know the one)
		jsr	(Clear_SpriteRingMem).l
		jsr	(Save_Level_Data2).l
		tst.b	$2C(a0)
		bmi.s	loc_618AC			; If negative, always go to HPZ
		moveq	#0,d0
		tst.w	($FFFFFFAE).w
		bne.s	loc_61892			; If SK alone, go directly to special stage
		bsr.w	SSEntry_CheckLevel
		beq.s	loc_61892			; Otherwise, do so if S3 levels
		cmpi.b	#7,($FFFFFFB0).w
		bne.s	loc_61892			; or if chaos emeralds aren't collected
		bra.w	loc_618AC			; When conditions are met, go to HPZ
; ---------------------------------------------------------------------------
		moveq	#1,d0

loc_61892:

		move.b	d0,($FFFFFFBB).w			; Regular ring takes you directly to special stage
		move.b	#1,($FFFFFE48).w
		move.b	#$34,($FFFFF600).w
		move.b	#1,($FFFFFF97).w
		bra.w	loc_618D0
; ---------------------------------------------------------------------------

loc_618AC:

		move.b	#2,($FFFFFE48).w			; Super emerald takes you to HPZ
		move.w	#$1701,($FFFFFE10).w
		move.w	#$1701,($FFFFEE4E).w
		move.b	#0,($FFFFFE2A).w
		move.b	#1,($FFFFFE02).w
		move.b	#1,($FFFFFF97).w

loc_618D0:
		move.b	$2C(a0),d0
		move.l	($FFFFFF92).w,d1
		bset	d0,d1
		move.l	d1,($FFFFFF92).w			; Set SS ring as collected
		jmp	(Go_Delete_SpriteSlotted2).l

; =============== S U B R O U T I N E =======================================


SSEntry_CheckLevel:

		cmpi.b	#7,($FFFFFE10).w
		bcc.s	loc_618F8
		cmpi.b	#4,($FFFFFE10).w
		beq.s	loc_618F8
		moveq	#0,d1				; 0 is S3 levels
		rts
; ---------------------------------------------------------------------------

loc_618F8:
		moveq	#1,d1				; 1 is SK levels
		rts
; End of function SSEntry_CheckLevel

; ---------------------------------------------------------------------------

SSEntryRing_Display:
		btst	#5,$38(a0)
		bne.s	loc_6196A
		tst.b	4(a0)
		bpl.s	loc_61928
		btst	#6,$38(a0)
		beq.s	loc_61918
		jsr	(Run_PalRotationScript).l			; Only run the rotation script if this is a super emerald ring

loc_61918:
		lea	DPLCPtr_SSEntryRing(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_61928:
		move.w	$10(a0),d0					; If off-screen
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_6196A
		move.w	$14(a0),d0
		move.w	($FFFFEE7C).w,d1
		move.w	$14(a0),d0
		sub.w	($FFFFEE7C).w,d0
		addi.w	#$80,d0
		cmpi.w	#$200,d0
		bhi.w	loc_6196A					; Jump below when far enough off-screen
		move.l	#$EE0088,($FFFFFC2A).w
		move.w	#$44,($FFFFFC3E).w
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6196A:

		move.l	#$EE0088,($FFFFFC2A).w
		move.w	#$44,($FFFFFC3E).w			; Restore the part of the palette that was changed
		lea	(ArtKosM_BadnikExplosion).l,a1
		move.w	#-$4C00,d2
		jsr	(Queue_Kos_Module).l			; Restore the overwritten badnik explosion art
		jmp	(Go_Delete_SpriteSlotted).l
; ---------------------------------------------------------------------------
ObjSlot_SSEntryRing:	dc.w	  0, $25A0,   $40,     4
		dc.l Map_SSEntryRing
		dc.b 2
		dc.b $80
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b 0
ObjSlot_SSEntryFlash:	dc.w	  0, $2680,   $18,     6
		dc.l Map_SSEntryFlash
		dc.b 2
		dc.b 0
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b 0
DPLCPtr_SSEntryRing:	dc.l ArtUnc_SSEntryRing
		dc.l DPLC_SSEntryRing
DPLCPtr_SSEntryFlash:	dc.l ArtUnc_SSEntryFlash
		dc.l DPLC_SSEntryFlash
AniRaw_SSEntryRing:	dc.b 4
		dc.b 0
		dc.b 0
		dc.b 1
		dc.b 2
		dc.b 3
		dc.b 4
		dc.b 5
		dc.b 6
		dc.b 7
		dc.b $F8
		dc.b $C
		dc.b 6
		dc.b $A
		dc.b 9
		dc.b 8
		dc.b $B
		dc.b $FC
AniRaw_SSEntryFlash:	dc.b 0

		dc.b 0
		dc.b 0
		dc.b 1
		dc.b 2
		dc.b $43
		dc.b 3
		dc.b 2
		dc.b 1
		dc.b 0
		dc.b $F4
		dc.b 0
Map_SSEntryRing:	include "General\Sprites\SS Entry\Map - Entry Ring.asm"

DPLC_SSEntryRing:	include "General\Sprites\SS Entry\DPLC - Special Stage Entry Ring.asm"

Map_SSEntryFlash:	include "General\Special Stage\Map - Entry Flash.asm"

DPLC_SSEntryFlash:	include "General\Sprites\SS Entry\DPLC - Special Stage Entry Flash.asm"

PalSPtr_SSEntry:	dc.w 4
		dc.w 0
		dc.l PalScript_SSEntry
PalScript_SSEntry:	dc.w  $FC2A,  $100
		dc.w   $ECE,  $A8A,     2,  $AEE,	 $6EE,	   2,  $ECA,  $A86,	2,  $AEE,  $6EE,     2,	 $8E8,	$4C4
		dc.w	  2,  $AEE,  $6EE,     2,  $6EC,  $4CA,	    2,	$AEE,  $6EE,	 2,  $6CE,  $2AC,     2,  $AEE,	 $6EE,	   2
		dc.w  $FFFC,  $6EE,   $AA,     1,  $8EE,   $CC,	    1,	$AEE,  $6EE,	 1,  $CEE,  $AEE,     1,  $EEE,	 $EEE,	   1
		dc.w   $CEE,  $AEE,	1,  $AEE,  $6EE,     1,	 $8EE,	 $CC,	  1, $FFFC
PalSPtr_SSEntry2:	dc.w 4
		dc.w 0
		dc.l PalScript_SSEntry2
PalScript_SSEntry2:	dc.w  $FC3E,	 0
		dc.w	$868,     2,   $AA,     2,	 $864,	   2,	$AA,	 2,  $2A2,     2,   $AA,     2,	 $4A8,	   2
		dc.w	$AA,	 2,  $28A,     2,   $AA,     2,	$FFFC,	 $66,	  1,   $88,	1,   $AA,     1,   $CC,	    1,	$EEE
		dc.w	  1,   $CC,	1,   $AA,     1,   $88,	    1, $FFFC,  $6EE,   $AA,	1,  $8EE,   $CC,     1,	 $AEE,	$6EE
		dc.w	  1,  $CEE,  $AEE,     1,  $EEE,  $EEE,	    1,	$CEE,  $AEE,	 1,  $AEE,  $6EE,     1,  $8EE,	  $CC,	   1
		dc.w	$66,	 0,   $88,     0,   $AA,     0,	  $CC,	   0,  $EEE,	 0,   $CC,     0,   $AA,     0,	  $88,	   0
; ---------------------------------------------------------------------------

Obj_CutsceneKnuckles:

		move.w	a0,($FFFFFAA4).w
		moveq	#0,d0
		move.b	$2C(a0),d0
		movea.l	off_61D5E(pc,d0.w),a1
		move.l	a1,(a0)
		jmp	(a1)
; ---------------------------------------------------------------------------
off_61D5E:	dc.l loc_61D92
		dc.l loc_61F98
		dc.l loc_62112
		dc.l loc_6229E
		dc.l loc_624DE
		dc.l loc_62640
		dc.l loc_628AA
		dc.l loc_62B3A
		dc.l loc_630E0
		dc.l loc_63A6A
		dc.l loc_63CFC
		dc.l loc_656DA
		dc.l CutsceneKnux_SKIntro
; ---------------------------------------------------------------------------

loc_61D92:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_61DB0(pc,d0.w),d1
		jsr	off_61DB0(pc,d1.w)
		lea	DPLCPtr_6666A(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_61DB0:	dc.w loc_61DBE-off_61DB0

		dc.w loc_61DF4-off_61DB0
		dc.w loc_61E24-off_61DB0
		dc.w loc_61E64-off_61DB0
		dc.w loc_61E96-off_61DB0
		dc.w loc_61EE0-off_61DB0
		dc.w loc_61F10-off_61DB0
; ---------------------------------------------------------------------------

loc_61DBE:
		lea	ObjDat4_663BA(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l
		bclr	#7,$A(a0)
		move.b	#$13,$1E(a0)
		move.b	#8,$22(a0)
		move.w	#$1400,$10(a0)
		move.w	#$440,$14(a0)
		bsr.w	sub_65DD6
		lea	ChildObjDat_6659A(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_61DF4:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_61E02
		rts
; ---------------------------------------------------------------------------

loc_61E02:
		move.b	#4,5(a0)
		bset	#7,$2A(a0)
		move.w	#-$600,$1A(a0)
		move.w	#$80,$18(a0)
		lea	Pal_CutsceneKnux1(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_61E24:
		lea	word_666AF(pc),a1
		jsr	(Animate_RawNoSST).l
		jsr	(MoveSprite).l
		tst.l	d0
		bmi.s	locret_61E42
		jsr	(ObjHitFloor).l
		tst.w	d1
		bmi.s	loc_61E44

locret_61E42:
		rts
; ---------------------------------------------------------------------------

loc_61E44:
		move.b	#6,5(a0)
		add.w	d1,$14(a0)
		move.b	#$16,$22(a0)
		move.w	#$7F,$2E(a0)
		move.l	#loc_61E6A,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_61E64:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_61E6A:
		move.b	#8,5(a0)
		bchg	#0,4(a0)
		move.l	#word_666A9,$30(a0)
		move.w	#-$600,$18(a0)
		clr.w	$1A(a0)
		move.w	#$29,$2E(a0)
		move.l	#loc_61EA8,$34(a0)

loc_61E96:
		jsr	(Animate_Raw).l
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_61EA8:
		neg.w	$18(a0)
		bchg	#0,4(a0)
		move.w	#$29,$2E(a0)
		move.l	#loc_61EC2,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_61EC2:
		move.b	#$A,5(a0)
		move.b	#$16,$22(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_61EEC,$34(a0)
		bra.w	loc_62056
; ---------------------------------------------------------------------------

loc_61EE0:
		jsr	(Animate_Raw).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_61EEC:
		move.b	#$C,5(a0)
		move.l	#word_666A9,$30(a0)
		move.w	#$600,$18(a0)
		jsr	(Create_New_Sprite).l
		bne.s	locret_61F0E
		move.l	#Obj_Song_Fade_ToLevelMusic,(a1)

locret_61F0E:
		rts
; ---------------------------------------------------------------------------

loc_61F10:
		tst.b	4(a0)
		bpl.s	loc_61F22
		jsr	(Animate_Raw).l
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_61F22:
		clr.b	($FFFFF650).w
		clr.b	($FFFFF7CA).w
		jsr	(AfterBoss_Cleanup).l
		jsr	(Remove_From_TrackingSlot).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_61F44
		move.l	#Obj_TitleCard,(a1)

loc_61F44:
		move.b	#-$6F,($FFFFF711).w
		move.b	#-$80,($FFFFFE1E).w
		clr.l	($FFFFFE22).w
		move.b	#1,($FFFFFE1C).w
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_61F60:
		lea	ObjDat3_66432(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_61F70,(a0)

loc_61F70:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_61F82
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_61F82:
		lea	(word_2A8B0).l,a4
		addq.b	#1,$22(a0)
		move.l	#loc_2A5F8,(a0)
		jmp	(sub_216B0).l
; ---------------------------------------------------------------------------

loc_61F98:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_61FB6(pc,d0.w),d1
		jsr	off_61FB6(pc,d1.w)
		lea	DPLCPtr_6666A(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_61FB6:	dc.w loc_61FC2-off_61FB6

		dc.w loc_62014-off_61FB6
		dc.w loc_62022-off_61FB6
		dc.w loc_6206E-off_61FB6
		dc.w loc_620AA-off_61FB6
		dc.w loc_620E4-off_61FB6
; ---------------------------------------------------------------------------

loc_61FC2:
		lea	ObjDat4_663BA(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l
		move.w	#$4B8E,$10(a0)
		move.w	#$17D,$14(a0)
		bset	#0,4(a0)
		bsr.w	sub_65DD6
		move.w	#$77,$2E(a0)
		move.l	#loc_6201A,$34(a0)
		lea	Pal_CutsceneKnux1(pc),a1
		jsr	(PalLoad_Line1).l
		lea	ChildObjDat_6655A(pc),a2
		jsr	(CreateChild6_Simple).l
		bne.s	locret_62012
		move.w	#$4B08,$10(a1)
		move.w	#$178,$14(a1)

locret_62012:
		rts
; ---------------------------------------------------------------------------

loc_62014:

		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6201A:
		move.b	#4,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_62022:
		move.w	$10(a0),d0
		subq.w	#2,d0
		cmpi.w	#$4B3C,d0
		bcs.s	loc_6203C
		move.w	d0,$10(a0)
		lea	byte_6669F(pc),a1
		jmp	(Animate_RawNoSST).l
; ---------------------------------------------------------------------------

loc_6203C:
		move.b	#6,5(a0)
		bclr	#0,4(a0)
		move.w	#$5F,$2E(a0)
		move.l	#loc_6207A,$34(a0)

loc_62056:

		move.l	#word_666B9,$30(a0)
		clr.b	$24(a0)
		clr.b	$23(a0)
		move.b	#$1C,$22(a0)

locret_6206C:

		rts
; ---------------------------------------------------------------------------

loc_6206E:
		jsr	(Animate_Raw).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6207A:
		move.b	#8,5(a0)

loc_62080:

		move.w	#-$100,$18(a0)
		move.w	#-$400,$1A(a0)

loc_6208C:

		move.l	#word_666AF,$30(a0)
		clr.b	$24(a0)
		clr.b	$23(a0)
		move.b	#8,$22(a0)
		move.b	#$13,$1E(a0)
		rts
; ---------------------------------------------------------------------------

loc_620AA:

		jsr	(Animate_Raw).l
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.s	locret_620D6
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	locret_620D6
		bset	#2,$38(a0)
		bne.s	loc_620D8
		neg.w	$18(a0)
		neg.w	$1A(a0)

locret_620D6:

		rts
; ---------------------------------------------------------------------------

loc_620D8:
		addq.b	#2,5(a0)
		add.w	d1,$14(a0)
		bra.w	loc_62056
; ---------------------------------------------------------------------------

loc_620E4:
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_620EA:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.w	loc_62158
		move.b	#8,7(a0)
		moveq	#$13,d1
		move.w	#$20,d2
		move.w	#$40,d3
		move.w	$10(a0),d4
		jmp	(SolidObjectFull2).l
; ---------------------------------------------------------------------------

loc_62112:
		cmpi.b	#2,($FFFFB038).w
		beq.s	loc_62158
		lea	word_62150(pc),a1
		jsr	(Check_CameraInRange).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_62142(pc,d0.w),d1
		jsr	off_62142(pc,d1.w)
		lea	DPLCPtr_6666A(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Sprite_CheckDeleteTouchSlotted).l
; ---------------------------------------------------------------------------
off_62142:	dc.w loc_6215E-off_62142

		dc.w loc_62194-off_62142
		dc.w loc_62014-off_62142
		dc.w loc_62200-off_62142
		dc.w loc_62014-off_62142
		dc.w loc_620AA-off_62142
		dc.w loc_62242-off_62142
word_62150:	dc.w $540
		dc.w $600
		dc.w $3900
		dc.w $3940
; ---------------------------------------------------------------------------

loc_62158:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_6215E:
		lea	ObjDat4_663BA(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l
		move.w	($FFFFEE18).w,($FFFFFA96).w
		move.w	($FFFFEE16).w,($FFFFFA92).w
		move.w	#$3940,($FFFFEE16).w
		lea	ChildObjDat_665A2(pc),a2
		jsr	(CreateChild1_Normal).l
		bne.s	loc_6218C
		move.b	#2,$2C(a1)

loc_6218C:
		addi.w	#$9E,$10(a0)
		rts
; ---------------------------------------------------------------------------

loc_62194:
		lea	($FFFFB000).w,a1
		cmpi.w	#$3990,$10(a1)
		bcs.s	loc_621AE
		tst.b	$2E(a1)
		bne.s	loc_621AE
		btst	#3,$2A(a1)
		bne.s	loc_621BC

loc_621AE:

		move.w	($FFFFEE7C).w,($FFFFEE18).w
		move.w	($FFFFEE78).w,($FFFFEE14).w
		rts
; ---------------------------------------------------------------------------

loc_621BC:
		move.b	#4,5(a0)
		bsr.w	sub_65DD6
		move.w	#$B3,$2E(a0)
		move.l	#loc_621D6,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_621D6:
		move.b	#6,5(a0)
		bset	#0,4(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_62216,$34(a0)
		move.w	#$5C0,($FFFFEE18).w
		lea	Pal_CutsceneKnux1(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_62200:
		subq.w	#4,$10(a0)
		lea	(byte_6669F).l,a1
		jsr	(Animate_RawNoSST).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_62216:
		move.b	#8,5(a0)
		move.b	#$20,$22(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_62232,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_62232:
		move.b	#$A,5(a0)
		bchg	#0,4(a0)
		bra.w	loc_62080
; ---------------------------------------------------------------------------

loc_62242:
		jsr	(Animate_Raw).l
		tst.b	4(a0)
		bmi.w	locret_6206C
		lea	(Pal_HCZ2).l,a1
		jsr	(PalLoad_Line1).l
		lea	ChildObjDat_62280(pc),a2
		jsr	(CreateChild1_Normal).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_62274
		move.l	#Obj_Song_Fade_ToLevelMusic,(a1)

loc_62274:
		jsr	(Remove_From_TrackingSlot).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------
ChildObjDat_62280:dc.w 1
		dc.l Obj_DecLevStartYGradual
		dc.b 0
		dc.b 0
		dc.l Obj_IncLevEndXGradual
		dc.b 0
		dc.b 0
word_6228E:	dc.w $176
		dc.w $300
		dc.w $1C00
		dc.w $1E00
word_62296:	dc.w $280
		dc.w $280
		dc.w $1D00
		dc.w $1D00
; ---------------------------------------------------------------------------

loc_6229E:
		cmpi.b	#2,($FFFFB038).w
		beq.w	loc_62158
		lea	word_6228E(pc),a1
		jsr	(Check_CameraInRange).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_622D0(pc,d0.w),d1
		jsr	off_622D0(pc,d1.w)
		lea	DPLCPtr_6666A(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_622D0:	dc.w loc_622E4-off_622D0

		dc.w loc_62332-off_622D0
		dc.w loc_62354-off_622D0
		dc.w loc_6237C-off_622D0
		dc.w loc_62354-off_622D0
		dc.w loc_623FE-off_622D0
		dc.w loc_62446-off_622D0
		dc.w loc_625D0-off_622D0
		dc.w $1B00
		dc.w $1D00
; ---------------------------------------------------------------------------

loc_622E4:
		lea	ObjDat4_663BA(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l
		move.l	#word_666BF,$30(a0)
		move.l	#loc_6233E,$34(a0)
		lea	word_62296(pc),a1
		move.b	#$1F,$26(a0)
		jsr	(loc_85D70).l
		lea	($FFFFFC20).w,a1
		lea	($FFFFFCA0).w,a2
		moveq	#7,d6

loc_62318:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_62318
		lea	Pal_CutsceneKnux1(pc),a1
		jsr	(PalLoad_Line1).l
		lea	ChildObjDat_66560(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_62332:
		jsr	(Animate_Raw).l
		jmp	(loc_85CA4).l
; ---------------------------------------------------------------------------

loc_6233E:
		move.b	#4,5(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_62360,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_62354:

		jsr	(Animate_Raw).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_62360:
		move.b	#6,5(a0)
		bset	#0,4(a0)
		move.w	#-$600,$1A(a0)
		move.w	#$140,$18(a0)
		bra.w	loc_6208C
; ---------------------------------------------------------------------------

loc_6237C:
		jsr	(Animate_Raw).l
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.s	locret_623B6
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	locret_623B6
		moveq	#0,d0
		move.b	$39(a0),d0
		cmpi.b	#8,d0
		bcc.s	loc_623B8
		move.l	word_623DA(pc,d0.w),$18(a0)
		addq.b	#4,d0
		move.b	d0,$39(a0)
		bchg	#0,4(a0)

locret_623B6:

		rts
; ---------------------------------------------------------------------------

loc_623B8:
		move.b	#8,5(a0)
		bclr	#0,4(a0)
		add.w	d1,$14(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_623E2,$34(a0)
		bra.w	loc_62056
; ---------------------------------------------------------------------------
word_623DA:	dc.w  $FF00, $FC00
		dc.w   $100, $FC00
; ---------------------------------------------------------------------------

loc_623E2:
		move.b	#$A,5(a0)
		bset	#0,4(a0)
		move.w	#-$600,$1A(a0)
		move.w	#$400,$18(a0)
		bra.w	loc_6208C
; ---------------------------------------------------------------------------

loc_623FE:
		jsr	(Animate_Raw).l
		jsr	(MoveSprite).l
		tst.b	4(a0)
		bmi.w	locret_6206C
		lea	ChildObjDat_66568(pc),a2
		jsr	(CreateChild1_Normal).l
		move.w	($FFFFFA98).w,($FFFFEE12).w

loc_62422:

		lea	($FFFFFCA0).w,a1
		lea	($FFFFFC20).w,a2
		moveq	#7,d6

loc_6242C:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_6242C
		lea	(PLC_83D48).l,a1
		jsr	(Load_PLC_Raw).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_6244C

loc_62446:
		move.l	#Obj_Song_Fade_ToLevelMusic,(a1)

loc_6244C:
		jsr	(Remove_From_TrackingSlot).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_62458:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.w	loc_62158
		move.b	#8,7(a0)
		moveq	#$13,d1
		move.w	#$100,d2
		move.w	#$200,d3
		move.w	$10(a0),d4
		jmp	(SolidObjectFull2).l
; ---------------------------------------------------------------------------

loc_62480:

		subq.w	#1,$2E(a0)
		bpl.s	locret_624BA
		moveq	#0,d0
		move.b	$39(a0),d0
		cmpi.b	#6,d0
		bcc.s	loc_624BC
		addq.b	#1,$39(a0)
		add.w	d0,d0
		move.w	word_624D0(pc,d0.w),$2E(a0)
		moveq	#0,d1
		btst	#1,d0
		beq.s	loc_624A8
		moveq	#$40,d1

loc_624A8:
		lea	Pal_CNZFlash(pc),a1
		adda.w	d1,a1

; =============== S U B R O U T I N E =======================================


sub_624AE:
		lea	($FFFFFC40).w,a2
		moveq	#$F,d0

loc_624B4:
		move.l	(a1)+,(a2)+
		dbf	d0,loc_624B4

locret_624BA:
		rts
; End of function sub_624AE

; ---------------------------------------------------------------------------

loc_624BC:
		tst.b	$2C(a0)
		beq.s	loc_624CA
		lea	(Pal_CNZ+$20).l,a1
		bsr.s	sub_624AE

loc_624CA:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
word_624D0:	dc.w 8
		dc.w 4
		dc.w 3
		dc.w 2
		dc.w 4
		dc.w 8
		dc.w 8
; ---------------------------------------------------------------------------

loc_624DE:
		cmpi.b	#2,($FFFFB038).w
		beq.w	loc_62158
		lea	word_62520(pc),a1
		jsr	(Check_CameraInRange).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_62510(pc,d0.w),d1
		jsr	off_62510(pc,d1.w)
		lea	DPLCPtr_6666A(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Sprite_CheckDeleteTouchSlotted).l
; ---------------------------------------------------------------------------
off_62510:	dc.w loc_62528-off_62510

		dc.w loc_6254E-off_62510
		dc.w loc_6256C-off_62510
		dc.w loc_62014-off_62510
		dc.w loc_620AA-off_62510
		dc.w loc_625BE-off_62510
		dc.w loc_625E2-off_62510
		dc.w loc_6261A-off_62510
word_62520:	dc.w $720
		dc.w $A00
		dc.w $45C0
		dc.w $46E0
; ---------------------------------------------------------------------------

loc_62528:
		lea	ObjDat4_663BA(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l
		clr.w	($FFFFF602).w
		st	($FFFFF7CA).w
		move.b	#-$80,($FFFFB02E).w
		bsr.w	sub_65DD6
		lea	Pal_CutsceneKnux1(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_6254E:
		lea	($FFFFB000).w,a1
		cmpi.w	#$4728,$10(a1)
		bcs.s	locret_62562
		btst	#1,$2A(a1)
		bne.s	loc_62564

locret_62562:
		rts
; ---------------------------------------------------------------------------

loc_62564:
		move.b	#4,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_6256C:
		move.w	#$808,($FFFFF602).w
		cmpi.w	#$4760,($FFFFB010).w
		bcc.s	loc_6257C
		rts
; ---------------------------------------------------------------------------

loc_6257C:
		move.b	#6,5(a0)
		clr.w	($FFFFF602).w
		lea	($FFFFB000).w,a1
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		move.w	#$1F,$2E(a0)
		move.l	#loc_625A6,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_625A6:
		move.b	#8,5(a0)
		move.w	#$7F,$2E(a0)
		move.l	#loc_625CA,$34(a0)
		bra.w	loc_62080
; ---------------------------------------------------------------------------

loc_625BE:
		jsr	(Animate_Raw).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_625CA:
		move.b	#$C,5(a0)

loc_625D0:
		clr.b	$23(a0)
		clr.b	$24(a0)
		move.l	#byte_6669F,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_625E2:
		addq.w	#4,$10(a0)
		jsr	(Animate_Raw).l
		tst.b	4(a0)
		bmi.w	locret_6206C
		move.b	#$E,5(a0)
		clr.b	($FFFFB02E).w
		lea	(Pal_CNZ).l,a1
		jsr	(PalLoad_Line1).l
		jsr	(Create_New_Sprite).l
		bne.s	locret_62618
		move.l	#Obj_Song_Fade_ToLevelMusic,(a1)

locret_62618:
		rts
; ---------------------------------------------------------------------------

loc_6261A:
		move.w	#$404,($FFFFF602).w
		move.w	($FFFFEE7C).w,d0
		addi.w	#$160,d0
		cmp.w	$14(a0),d0
		bcs.s	loc_62630
		rts
; ---------------------------------------------------------------------------

loc_62630:
		clr.b	($FFFFF7CA).w
		jsr	(Remove_From_TrackingSlot).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_62640:
		cmpi.b	#2,($FFFFB038).w
		beq.w	loc_62158
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_62668(pc,d0.w),d1
		jsr	off_62668(pc,d1.w)
		lea	DPLCPtr_6666A(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Sprite_CheckDeleteTouchSlotted).l
; ---------------------------------------------------------------------------
off_62668:	dc.w loc_62678-off_62668

		dc.w loc_626B2-off_62668
		dc.w loc_62014-off_62668
		dc.w loc_626EE-off_62668
		dc.w loc_62014-off_62668
		dc.w loc_62354-off_62668
		dc.w loc_62354-off_62668
		dc.w loc_62778-off_62668
; ---------------------------------------------------------------------------

loc_62678:
		move.w	($FFFFB010).w,d0
		cmp.w	$10(a0),d0
		bcc.s	loc_626AC
		lea	ObjDat4_663BA(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l
		move.b	#$16,$22(a0)
		move.w	#$A0,($FFFFEE18).w
		lea	Pal_CutsceneKnux1(pc),a1
		jsr	(PalLoad_Line1).l
		lea	ChildObjDat_6657C(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_626AC:
		jmp	(Go_Delete_SpriteSlotted2).l
; ---------------------------------------------------------------------------

loc_626B2:
		btst	#3,$38(a0)
		bne.s	loc_626BC
		rts
; ---------------------------------------------------------------------------

loc_626BC:
		move.b	#4,5(a0)
		bsr.w	sub_65DD6
		move.w	#$3B,$2E(a0)
		move.l	#loc_626D6,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_626D6:
		move.b	#6,5(a0)
		move.l	#byte_666C3,$30(a0)
		move.l	#loc_626F4,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_626EE:
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_626F4:
		move.b	#8,5(a0)
		move.w	#$F,$2E(a0)
		move.l	#loc_62726,$34(a0)
		moveq	#$51,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_66584(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	(PLC_83D64).l,a1
		jmp	(Load_PLC_Raw).l
; ---------------------------------------------------------------------------

loc_62726:
		move.b	#$A,5(a0)
		move.w	#$7F,$2E(a0)
		move.l	#loc_6273E,$34(a0)
		bra.w	loc_62056
; ---------------------------------------------------------------------------

loc_6273E:
		move.b	#$C,5(a0)
		st	($FFFFEECC).w
		move.w	#$5F,$2E(a0)
		move.l	#loc_62760,$34(a0)
		lea	ChildObjDat_6658C(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_62760:
		move.b	#$E,5(a0)
		move.l	#byte_6669F,$30(a0)
		clr.b	$24(a0)
		clr.b	$23(a0)
		rts
; ---------------------------------------------------------------------------

loc_62778:
		tst.b	4(a0)
		bpl.w	loc_6278A
		addq.w	#2,$10(a0)
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_6278A:
		clr.b	($FFFFFAA9).w
		clr.b	($FFFFB02E).w
		clr.b	($FFFFB078).w
		move.w	#$3B60,($FFFFFA92).w
		lea	(Child6_IncLevX).l,a2
		jsr	(CreateChild6_Simple).l
		move.w	#$148,($FFFFEE12).w
		jsr	(Remove_From_TrackingSlot).l
		lea	(Pal_LBZ1).l,a1
		jsr	(PalLoad_Line1).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_627C6:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.w	loc_62158
		lea	word_62822(pc),a1
		jsr	(Check_PlayerInRange).l
		tst.l	d0
		beq.s	locret_627FE
		tst.w	d0
		beq.s	loc_627F4
		movea.w	$46(a0),a2
		bset	#3,$38(a2)
		bsr.w	sub_62800

loc_627F4:
		swap	d0
		tst.w	d0
		beq.s	locret_627FE
		bsr.w	sub_62800

locret_627FE:

		rts

; =============== S U B R O U T I N E =======================================


sub_62800:

		st	($FFFFFAA9).w
		movea.w	d0,a1
		cmpi.b	#6,5(a1)
		bcc.s	locret_627FE
		move.b	#-$7F,$2E(a1)
		bclr	#0,4(a1)
		bclr	#0,$2A(a1)
		rts
; End of function sub_62800

; ---------------------------------------------------------------------------
word_62822:	dc.w  $FFC0,   $80, $FFD0,   $60
; ---------------------------------------------------------------------------

loc_6282A:
		lea	ObjDat3_6640E(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_6284E,(a0)
		move.w	#-$200,$18(a0)
		move.w	#-$400,$1A(a0)
		moveq	#$51,d0
		jsr	(Play_Sound_2).l

loc_6284E:
		jsr	(MoveSprite_LightGravity).l
		jmp	(Sprite_CheckDeleteXY).l
; ---------------------------------------------------------------------------

loc_6285A:
		move.l	#loc_628A0,(a0)
		move.l	#Obj_BossExpControl1,$34(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		lea	word_62890(pc,d0.w),a1
		move.w	(a1)+,$10(a0)
		move.w	(a1)+,$14(a0)
		move.b	#$20,$39(a0)
		move.b	#$20,$3A(a0)
		move.b	#$20,$3B(a0)
		rts
; ---------------------------------------------------------------------------
word_62890:	dc.w  $3BC0,  $1A0
		dc.w  $3B80,  $1A0
		dc.w  $3B40,  $1A0
		dc.w  $3B00,  $1A0
; ---------------------------------------------------------------------------

loc_628A0:
		subq.w	#4,$14(a0)
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_628AA:
		cmpi.b	#2,($FFFFB038).w
		beq.w	loc_62158
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_628D2(pc,d0.w),d1
		jsr	off_628D2(pc,d1.w)
		lea	DPLCPtr_6666A(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Sprite_CheckDeleteTouchSlotted).l
; ---------------------------------------------------------------------------
off_628D2:	dc.w loc_628E0-off_628D2

		dc.w loc_6290E-off_628D2
		dc.w loc_62928-off_628D2
		dc.w loc_62942-off_628D2
		dc.w loc_62964-off_628D2
		dc.w loc_629A8-off_628D2
		dc.w loc_629C0-off_628D2
; ---------------------------------------------------------------------------

loc_628E0:
		lea	ObjDat4_663BA(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l
		bset	#0,4(a0)
		move.b	#$20,$22(a0)
		bsr.w	sub_65DD6
		lea	Pal_CutsceneKnux1(pc),a1
		jsr	(PalLoad_Line1).l
		lea	ChildObjDat_66592(pc),a2
		jmp	(CreateChild3_NormalRepeated).l
; ---------------------------------------------------------------------------

loc_6290E:
		btst	#1,$38(a0)
		bne.s	loc_62918
		rts
; ---------------------------------------------------------------------------

loc_62918:
		move.b	#4,5(a0)
		move.l	#loc_62932,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_62928:
		lea	byte_666D2(pc),a1
		jmp	(Animate_RawNoSSTMultiDelay).l
; ---------------------------------------------------------------------------

loc_62932:
		move.b	#6,5(a0)
		bclr	#0,4(a0)
		bra.w	loc_62056
; ---------------------------------------------------------------------------

loc_62942:
		tst.b	($FFFFEECC).w
		beq.s	loc_6295E
		move.b	#8,5(a0)
		move.l	#byte_6669A,$30(a0)
		clr.b	$24(a0)
		clr.b	$23(a0)

loc_6295E:
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_62964:
		btst	#3,$38(a0)
		bne.s	loc_6297A
		move.w	($FFFFEEE6).w,d0
		add.w	d0,$14(a0)
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_6297A:
		move.b	#$A,5(a0)
		bset	#0,4(a0)
		move.b	#9,$22(a0)
		move.w	#$200,$18(a0)
		move.w	#-$100,$1A(a0)
		jsr	(Create_New_Sprite).l
		bne.s	locret_629A6
		move.l	#Obj_Song_Fade_ToLevelMusic,(a1)

locret_629A6:
		rts
; ---------------------------------------------------------------------------

loc_629A8:
		move.w	$14(a0),d0
		cmp.w	($FFFFF646).w,d0
		bcs.s	loc_629C0
		moveq	#$39,d0
		jsr	(Play_Sound_2).l
		move.b	#$C,5(a0)

loc_629C0:

		move.w	($FFFFEEE6).w,d0
		add.w	d0,$14(a0)
		jmp	(MoveSprite_LightGravity).l
; ---------------------------------------------------------------------------

loc_629CE:
		lea	ObjDat3_6641A(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_62A0A,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		move.l	dword_629FA(pc,d0.w),$3E(a0)
		lsl.w	#3,d0
		add.w	d0,$14(a0)
		move.w	$10(a0),$3A(a0)
		rts
; ---------------------------------------------------------------------------
dword_629FA:	dc.l $1000010
		dc.l $C0000C
		dc.l $800008
		dc.l $400004
; ---------------------------------------------------------------------------

loc_62A0A:
		tst.b	($FFFFEECC).w
		beq.s	loc_62A22
		move.l	#loc_62A28,(a0)
		move.w	$3E(a0),$18(a0)
		move.b	#6,$39(a0)

loc_62A22:
		jmp	(Sprite_CheckDeleteXY).l
; ---------------------------------------------------------------------------

loc_62A28:
		move.w	($FFFFEEE6).w,d0
		add.w	d0,$14(a0)
		move.w	$10(a0),d0
		move.w	$40(a0),d1
		cmp.w	$3A(a0),d0
		scs	d2
		bcs.s	loc_62A42
		neg.w	d1

loc_62A42:
		add.w	d1,$18(a0)
		cmp.b	$3C(a0),d2
		beq.s	loc_62A82
		move.b	d2,$3C(a0)
		cmpi.b	#3,$39(a0)
		bne.s	loc_62A6C
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		move.l	dword_62A9E(pc,d0.w),$3E(a0)
		move.w	$3E(a0),$18(a0)

loc_62A6C:
		subq.b	#1,$39(a0)
		bne.s	loc_62A82
		move.l	#loc_62AAE,(a0)
		movea.w	$46(a0),a1
		bset	#3,$38(a1)

loc_62A82:

		jsr	(MoveSprite2).l
		tst.b	$2C(a0)
		bne.s	loc_62A98
		movea.w	$46(a0),a1
		move.w	$10(a0),$10(a1)

loc_62A98:
		jmp	(Sprite_CheckDeleteXY).l
; ---------------------------------------------------------------------------
dword_62A9E:	dc.l $2000020
		dc.l $1800018
		dc.l $1000010
		dc.l $800008
; ---------------------------------------------------------------------------

loc_62AAE:
		move.w	($FFFFEEE6).w,d0
		add.w	d0,$14(a0)
		jsr	(MoveSprite_LightGravity).l
		jmp	(Sprite_CheckDeleteXY).l
; ---------------------------------------------------------------------------

Obj_C8_1:
		lea	ObjDat3_66426(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bclr	#1,4(a0)
		beq.s	loc_62ADA
		bset	#7,$A(a0)

loc_62ADA:
		bclr	#0,4(a0)
		beq.s	loc_62AE8
		move.w	#0,8(a0)

loc_62AE8:
		move.l	#loc_62AEE,(a0)

loc_62AEE:
		move.w	($FFFFEEE6).w,d0
		add.w	d0,$14(a0)
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
Map_LBZKnuxPillar:	include "Levels\LBZ\Misc Object Data\Map - Knuckles Pillar.asm"

; ---------------------------------------------------------------------------

loc_62B3A:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_62B58(pc,d0.w),d1
		jsr	off_62B58(pc,d1.w)
		lea	DPLCPtr_6666A(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Sprite_CheckDeleteTouchSlotted).l
; ---------------------------------------------------------------------------
off_62B58:	dc.w loc_62B68-off_62B58

		dc.w loc_62BB2-off_62B58
		dc.w loc_62BC0-off_62B58
		dc.w loc_62BE4-off_62B58
		dc.w loc_62BF4-off_62B58
		dc.w loc_62C42-off_62B58
		dc.w loc_62C42-off_62B58
		dc.w loc_62C90-off_62B58
; ---------------------------------------------------------------------------

loc_62B68:
		lea	ObjDat4_663BA(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l
		bclr	#7,$A(a0)
		move.w	#$77,$2E(a0)
		move.l	#byte_6669F,$30(a0)
		move.w	#$2B0,$10(a0)
		move.w	#$66C,$14(a0)
		move.w	#$200,$18(a0)
		lea	($FFFFFC20).w,a1
		lea	($FFFFFCA0).w,a2
		moveq	#7,d6

loc_62BA2:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_62BA2
		lea	Pal_CutsceneKnux1(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_62BB2:
		subq.w	#1,$2E(a0)
		bpl.s	locret_62BBE
		move.b	#4,5(a0)

locret_62BBE:
		rts
; ---------------------------------------------------------------------------

loc_62BC0:
		cmpi.w	#$360,$10(a0)
		bcc.s	loc_62BD4
		jsr	(Animate_Raw).l
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_62BD4:
		move.b	#6,5(a0)
		lea	ChildObjDat_665B0(pc),a2
		jsr	(CreateChild6_Simple).l

loc_62BE4:
		btst	#3,$38(a0)
		bne.s	loc_62BEE
		rts
; ---------------------------------------------------------------------------

loc_62BEE:
		move.b	#8,5(a0)

loc_62BF4:
		jsr	(Animate_Raw).l
		jsr	(MoveSprite2).l
		movea.w	$46(a0),a1
		move.w	$10(a1),d0
		subi.w	#$28,d0
		cmp.w	$10(a0),d0
		bls.s	loc_62C14
		rts
; ---------------------------------------------------------------------------

loc_62C14:
		move.w	d0,$10(a0)
		move.b	#$A,5(a0)
		move.b	#$17,$1E(a0)
		move.w	#$100,$18(a0)
		move.w	#-$400,$1A(a0)
		move.l	#loc_62C5A,$34(a0)
		lea	word_666AF(pc),a1
		jsr	(Set_Raw_Animation).l

loc_62C42:
		jsr	(Animate_Raw).l
		jsr	(MoveSprite).l
		jsr	(ObjHitFloor_DoRoutine).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_62C5A:
		move.b	#$C,5(a0)
		move.b	#$13,$1E(a0)
		move.w	#-$300,$1A(a0)
		move.l	#loc_62C76,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_62C76:
		move.b	#$E,5(a0)
		move.w	#$200,$18(a0)
		clr.w	$1A(a0)
		lea	byte_6669F(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_62C90:
		tst.b	4(a0)
		bpl.w	loc_62422
		jsr	(Animate_Raw).l
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

Obj_A8_2:
		cmpi.b	#2,($FFFFB038).w
		beq.w	loc_62158
		tst.b	($FFFFFE2A).w
		bne.w	loc_62158
		tst.w	($FFFFFFAE).w
		bne.w	loc_62158
		lea	($FFFFB000).w,a1
		moveq	#0,d0
		move.b	($FFFFFAB8).w,d0
		move.w	off_62CD0(pc,d0.w),d0
		jmp	off_62CD0(pc,d0.w)
; ---------------------------------------------------------------------------
off_62CD0:	dc.w loc_62CDE-off_62CD0

		dc.w loc_62CF8-off_62CD0
		dc.w loc_62D2C-off_62CD0
		dc.w loc_62D42-off_62CD0
		dc.w loc_62D5A-off_62CD0
		dc.w locret_62D6E-off_62CD0
		dc.w loc_62D70-off_62CD0
; ---------------------------------------------------------------------------

loc_62CDE:
		move.b	#2,($FFFFFAB8).w
		tst.l	($FFFFB04A).w
		beq.s	loc_62CF8
		jsr	(Create_New_Sprite).l
		bne.s	loc_62CF8
		move.l	#loc_62DAC,(a1)

loc_62CF8:


		move.w	#$389,d0
		cmp.w	$10(a1),d0
		bls.s	loc_62D04
		rts
; ---------------------------------------------------------------------------

loc_62D04:
		move.w	d0,$10(a1)
		move.b	#4,($FFFFFAB8).w
		bclr	#0,4(a1)
		bclr	#0,$2A(a1)
		st	($FFFFF7CA).w
		clr.w	($FFFFF602).w
		jsr	(Stop_Object).l
		bra.w	sub_65DD6
; ---------------------------------------------------------------------------

loc_62D2C:
		btst	#1,$2A(a1)
		beq.s	loc_62D36
		rts
; ---------------------------------------------------------------------------

loc_62D36:
		move.b	#6,($FFFFFAB8).w
		move.w	#$20,$2E(a0)

loc_62D42:
		subq.w	#1,$2E(a0)
		bmi.s	loc_62D4A
		rts
; ---------------------------------------------------------------------------

loc_62D4A:
		move.b	#8,($FFFFFAB8).w
		st	($FFFFEE0A).w
		move.w	#$202,($FFFFF602).w

loc_62D5A:
		addq.w	#2,($FFFFEE7C).w
		cmpi.w	#$5B0,($FFFFEE7C).w
		bcc.s	loc_62D68
		rts
; ---------------------------------------------------------------------------

loc_62D68:
		move.b	#$A,($FFFFFAB8).w

locret_62D6E:
		rts
; ---------------------------------------------------------------------------

loc_62D70:
		clr.b	($FFFFFAB8).w
		clr.b	($FFFFF7CA).w
		clr.b	($FFFFF7CB).w
		clr.b	($FFFFEE0A).w
		clr.w	($FFFFF602).w
		clr.w	($FFFFF66A).w
		move.b	#5,($FFFFB06A).w
		move.b	#1,($FFFFFE2A).w
		move.w	#$190,($FFFFFE2E).w
		move.w	#$56C,($FFFFFE30).w
		jsr	(Save_Level_Data).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_62DAC:

		lea	($FFFFB04A).w,a1
		cmpi.b	#4,($FFFFFAB8).w
		bcc.s	loc_62DC4
		move.w	#$371,d0
		cmp.w	$10(a1),d0
		bls.s	loc_62DC4
		rts
; ---------------------------------------------------------------------------

loc_62DC4:

		move.w	d0,$10(a0)
		move.l	#loc_62DDC,(a0)
		st	($FFFFF7CB).w
		clr.w	($FFFFF66A).w
		jsr	(Stop_Object).l

loc_62DDC:
		lea	($FFFFB04A).w,a1
		move.b	($FFFFFAB8).w,d0
		beq.s	loc_62E1A
		cmpi.b	#4,($FFFFFAB8).w
		bcs.s	loc_62E04
		move.w	#$371,d0
		cmp.w	$10(a1),d0
		bhi.s	locret_62E18
		move.b	#8,$20(a1)
		jmp	(Stop_Object).l
; ---------------------------------------------------------------------------

loc_62E04:
		tst.b	4(a1)
		bmi.s	locret_62E18
		move.l	#loc_62DAC,(a0)
		clr.b	($FFFFF7CB).w
		clr.w	($FFFFF66A).w

locret_62E18:

		rts
; ---------------------------------------------------------------------------

loc_62E1A:
		clr.b	($FFFFF7CB).w
		clr.w	($FFFFF66A).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_A9_2:
		lea	ObjDat3_6644A(pc),a1
		jsr	(SetUp_ObjAttributes).l
		lea	ChildObjDat_665B6(pc),a2
		jsr	(CreateChild6_Simple).l
		move.l	#loc_62F0A,(a0)
		tst.b	($FFFFFE2A).w
		bne.s	loc_62E56
		cmpi.b	#2,($FFFFB038).w
		beq.s	loc_62E56
		move.l	#loc_62E5C,(a0)

loc_62E56:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_62E5C:
		cmpi.b	#$A,($FFFFFAB8).w
		bcc.s	loc_62E6A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_62E6A:
		move.l	#loc_62E92,(a0)
		lea	(ArtKosM_MHZKnuxPeer).l,a1
		move.w	#-$6000,d2
		jsr	(Queue_Kos_Module).l
		lea	ChildObjDat_665AA(pc),a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_62E92
		move.b	#$1C,$2C(a1)

loc_62E92:

		move.w	($FFFFFAA4).w,d0
		beq.s	loc_62ECA
		movea.w	d0,a1
		lea	word_65C48(pc),a2
		jsr	(Check_InMyRange).l
		beq.s	loc_62ECA
		move.l	#loc_62ED0,(a0)
		move.w	#1,$2E(a0)
		move.b	#1,$22(a0)
		bset	#1,$38(a0)
		st	($FFFFFAA9).w
		moveq	#$5B,d0
		jsr	(Play_Sound_2).l

loc_62ECA:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_62ED0:
		bclr	#1,$38(a0)
		subq.w	#1,$2E(a0)
		bpl.s	loc_62EF6
		move.l	#Wait_Draw,(a0)
		move.w	#$5F,$2E(a0)
		move.l	#loc_62EFC,$34(a0)
		move.b	#0,$22(a0)

loc_62EF6:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_62EFC:
		move.b	#$C,($FFFFFAB8).w
		move.l	#loc_62F0A,(a0)
		rts
; ---------------------------------------------------------------------------

loc_62F0A:

		bsr.w	sub_65DEC
		move.b	$2A(a0),d1
		andi.b	#$18,d1
		beq.s	loc_62F46
		move.l	#loc_62F4C,(a0)
		move.b	#1,$22(a0)
		moveq	#$5B,d0
		jsr	(Play_Sound_2).l
		btst	#2,$38(a0)
		bne.s	loc_62F46
		bset	#1,$38(a0)
		not.b	($FFFFFAA9).w
		moveq	#$5B,d0
		jsr	(Play_Sound_2).l

loc_62F46:

		jmp	(Sprite_CheckDelete).l
; ---------------------------------------------------------------------------

loc_62F4C:
		bclr	#1,$38(a0)
		bsr.w	sub_65DEC
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		bne.s	loc_62F6C
		move.l	#loc_62F0A,(a0)
		move.b	#0,$22(a0)

loc_62F6C:
		jmp	(Sprite_CheckDelete).l
; ---------------------------------------------------------------------------

loc_62F72:
		lea	ObjDat3_6643E(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_62FA2,(a0)
		move.w	#$374,$10(a0)
		move.w	#$66C,$14(a0)
		move.w	#$200,$18(a0)
		move.w	#7,$2E(a0)
		move.l	#loc_62FB4,$34(a0)

loc_62FA2:

		jsr	(MoveSprite2).l
		jsr	(Obj_Wait).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_62FB4:
		move.l	#loc_62FCA,(a0)
		move.l	#loc_62FDA,$34(a0)
		bset	#7,$A(a0)
		rts
; ---------------------------------------------------------------------------

loc_62FCA:
		lea	byte_666E1(pc),a1
		jsr	(Animate_RawNoSSTMultiDelay).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_62FDA:
		move.l	#loc_62FA2,(a0)
		move.w	#-$400,$18(a0)
		move.w	#$F,$2E(a0)
		move.l	#loc_62FFC,$34(a0)
		bclr	#7,$A(a0)
		rts
; ---------------------------------------------------------------------------

loc_62FFC:
		movea.w	$46(a0),a1
		bset	#3,$38(a1)
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_6300C:
		lea	ObjDat3_66462(pc),a1
		jsr	(SetUp_ObjAttributes).l
		movea.w	$46(a0),a1
		move.w	a0,$44(a1)
		move.l	#loc_6303C,(a0)
		move.w	#$390,$10(a0)
		move.w	#$620,$14(a0)
		tst.b	($FFFFFAA9).w
		beq.s	loc_6303C
		addi.w	#$40,$14(a0)

loc_6303C:

		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		bne.s	loc_63078
		jsr	(sub_65E4C).l
		lea	($FFFFB000).w,a1
		jsr	(Find_OtherObject).l
		tst.b	($FFFFFAA9).w
		beq.s	loc_6306E
		tst.w	d0
		bne.s	loc_6306E
		cmpi.w	#$40,d2
		bcc.s	loc_6306E
		cmpi.w	#$60,d3
		bcs.s	loc_63074

loc_6306E:

		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_63074:
		clr.b	($FFFFFAA9).w

loc_63078:
		move.l	#loc_630A6,(a0)
		movea.w	$46(a0),a1
		bset	#2,$38(a1)
		move.w	#$100,d0
		tst.b	($FFFFFAA9).w
		bne.s	loc_63094
		neg.w	d0

loc_63094:
		move.w	d0,$1A(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_630BE,$34(a0)

loc_630A6:
		jsr	(MoveSprite2).l
		jsr	(sub_65E4C).l
		jsr	(Obj_Wait).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_630BE:
		move.l	#loc_6303C,(a0)
		movea.w	$46(a0),a1
		bclr	#2,$38(a1)
		rts
; ---------------------------------------------------------------------------
word_630D0:	dc.w   $648,  $848
		dc.w   $2D0,  $4D0
		dc.w   $748,  $748
word_630DC:	dc.w   $3D0,  $3D0
; ---------------------------------------------------------------------------

loc_630E0:
		cmpi.b	#2,($FFFFB038).w
		beq.s	loc_6311A
		cmpi.b	#7,($FFFFFE2A).w
		bcc.w	loc_62158
		lea	word_630D0(pc),a1
		jsr	(Check_CameraInRange).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6312A(pc,d0.w),d1
		jsr	off_6312A(pc,d1.w)
		lea	DPLCPtr_66672(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Sprite_CheckDeleteTouchSlotted).l
; ---------------------------------------------------------------------------

loc_6311A:
		lea	ChildObjDat_665BC(pc),a2
		jsr	(CreateChild1_Normal).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------
off_6312A:	dc.w loc_63134-off_6312A

		dc.w loc_63170-off_6312A
		dc.w loc_631A4-off_6312A
		dc.w loc_63220-off_6312A
		dc.w loc_632AE-off_6312A
; ---------------------------------------------------------------------------

loc_63134:
		lea	ObjDat4_663CC(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l
		move.l	#loc_63182,$34(a0)
		move.w	($FFFFEE14).w,($FFFFFA94).w
		move.w	(word_630DC).l,($FFFFFAB4).w
		bsr.w	sub_65DD6
		st	($FFFFEEE8).w
		lea	Pal_CutsceneKnux1(pc),a1
		jsr	(PalLoad_Line1).l
		lea	ChildObjDat_665BC(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_63170:
		move.w	($FFFFEE78).w,d0
		move.w	($FFFFFAB4).w,d1
		cmp.w	d1,d0
		bcc.s	loc_63182
		move.w	d0,($FFFFEE14).w
		rts
; ---------------------------------------------------------------------------

loc_63182:

		move.w	d1,($FFFFEE14).w
		move.b	#4,5(a0)
		move.w	#$3B,$2E(a0)
		st	($FFFFF7CA).w
		st	($FFFFF7CB).w
		clr.w	($FFFFF602).w
		clr.w	($FFFFF66A).w
		rts
; ---------------------------------------------------------------------------

loc_631A4:
		subi.w	#1,$2E(a0)
		bmi.s	loc_631E0
		moveq	#0,d0
		lea	($FFFFB000).w,a1
		btst	#1,$2A(a1)
		bne.s	loc_631BE
		bset	#0,d0

loc_631BE:
		lea	($FFFFB04A).w,a2
		tst.l	(a2)
		beq.s	loc_631D4
		tst.b	4(a2)
		bpl.s	loc_631D4
		btst	#1,$2A(a2)
		bne.s	loc_631D8

loc_631D4:

		bset	#1,d0

loc_631D8:
		cmpi.b	#3,d0
		beq.s	loc_631E0

locret_631DE:
		rts
; ---------------------------------------------------------------------------

loc_631E0:

		move.b	#6,5(a0)
		move.l	#loc_63280,$34(a0)
		move.w	#$10,$3E(a0)
		clr.w	$2E(a0)
		move.b	#1,$39(a0)
		lea	($FFFFB000).w,a1
		bsr.w	sub_6320E
		lea	($FFFFB04A).w,a1
		tst.l	(a1)
		beq.s	locret_631DE

; =============== S U B R O U T I N E =======================================


sub_6320E:
		move.b	#-$7F,$2E(a1)
		move.b	#5,$20(a1)
		jmp	(Stop_Object).l
; End of function sub_6320E

; ---------------------------------------------------------------------------

loc_63220:
		bsr.w	sub_65E62
		cmpi.b	#8,$23(a0)
		bcs.s	loc_63238
		moveq	#-$26,d0
		jsr	(sub_85E52).l
		bsr.w	sub_65EB4

loc_63238:
		lea	byte_666F6(pc),a1
		jsr	(Animate_RawNoSSTMultiDelay).l
		beq.s	locret_6327E
		cmpi.b	#$C,$23(a0)
		bne.s	loc_63266
		lea	($FFFFB000).w,a1
		move.b	#$14,$20(a1)
		lea	($FFFFB04A).w,a1
		tst.b	4(a1)
		bpl.s	loc_63266
		move.b	#$14,$20(a1)

loc_63266:

		cmpi.b	#2,$22(a0)
		bne.s	locret_6327E
		addq.b	#1,$39(a0)
		subq.w	#4,$3E(a0)
		moveq	#$5B,d0
		jsr	(Play_Sound_2).l

locret_6327E:

		rts
; ---------------------------------------------------------------------------

loc_63280:
		move.b	#8,5(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_63294
		move.l	#loc_6338E,(a1)

loc_63294:
		tst.b	($FFFFB04E).w
		bpl.s	loc_632AE
		jsr	(Create_New_Sprite).l
		bne.s	loc_632AE
		move.l	#loc_6338E,(a1)
		move.b	#2,$2C(a1)

loc_632AE:


		tst.b	4(a0)
		bpl.w	loc_62422
		bra.w	sub_65EB4
; ---------------------------------------------------------------------------
		lea	(Pal_MHZ2).l,a1
		jsr	(PalLoad_Line1).l
		bra.w	loc_62422
; ---------------------------------------------------------------------------

loc_632CA:
		lea	ObjDat3_66456(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_63308,(a0)
		cmpi.b	#2,($FFFFB038).w
		bne.s	loc_632F8
		move.l	#Sprite_OnScreen_Test,(a0)
		move.w	#-$7AD8,$A(a0)
		movea.w	$46(a0),a1
		move.w	$48(a1),$48(a0)

loc_632F8:
		lea	(ArtKosM_MHZKnuxSwitch).l,a1
		move.w	#-$5B00,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

loc_63308:
		movea.w	$46(a0),a1
		clr.b	$22(a0)
		cmpi.b	#2,$22(a1)
		bne.s	loc_6331E
		move.b	#1,$22(a0)

loc_6331E:
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_63324:
		lea	ObjDat3_6646E(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_63372,(a0)
		jsr	(Random_Number).l
		andi.w	#$1FF,d0
		cmpi.w	#$140,d0
		bcs.s	loc_6334A
		andi.w	#$3F,d0
		lsl.w	#2,d0

loc_6334A:
		move.w	($FFFFEE80).w,d1
		add.w	d0,d1
		move.w	d1,$10(a0)
		move.w	($FFFFEE84).w,d1
		addi.w	#$E8,d1
		move.w	d1,$14(a0)
		moveq	#0,d1
		movea.w	$46(a0),a1
		move.b	$39(a1),d1
		add.w	d1,d1
		neg.w	d1
		move.w	d1,$1A(a0)

loc_63372:
		move.w	$1A(a0),d0
		add.w	d0,$14(a0)
		move.w	($FFFFEE7C).w,d0
		subq.w	#8,d0
		cmp.w	$14(a0),d0
		bcc.w	loc_62158
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6338E:

		lea	($FFFFB000).w,a1
		tst.b	$2C(a0)
		beq.s	loc_6339C
		lea	($FFFFB04A).w,a1

loc_6339C:
		move.l	#loc_633D6,(a0)
		move.w	a1,$44(a0)
		move.w	#-$1000,$1A(a0)
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		move.b	#-$7F,$2E(a1)
		move.b	#$F,$20(a1)
		bclr	#1,4(a1)
		bset	#7,$A(a1)
		st	($FFFFEE39).w
		rts
; ---------------------------------------------------------------------------

loc_633D6:
		moveq	#-$26,d0
		jsr	(sub_85E52).l
		jsr	(MoveSprite_LightGravity).l
		movea.w	$44(a0),a1
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		tst.w	$1A(a0)
		bmi.w	locret_6206C
		clr.b	($FFFFF7CA).w
		clr.b	($FFFFF7CB).w
		clr.w	($FFFFF602).w
		clr.w	($FFFFF66A).w
		clr.b	$2E(a1)
		bclr	#7,$A(a1)
		clr.b	$20(a1)
		move.w	#$10,$1C(a1)
		clr.b	($FFFFEE39).w
		clr.b	($FFFFEEE8).w
		move.b	#7,($FFFFFE2A).w
		move.w	#$52A,($FFFFFE2E).w
		move.w	#$5AC,($FFFFFE30).w
		jsr	(Save_Level_Data).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

CutsceneKnux_SKIntro:
		cmpi.b	#2,($FFFFB038).w
		bne.w	loc_62158
		tst.b	($FFFFFE2A).w
		bne.w	loc_62158
		tst.w	($FFFFFFAE).w
		beq.w	loc_62158
		move.l	#loc_63466,(a0)

loc_63466:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_63486(pc,d0.w),d1
		jsr	off_63486(pc,d1.w)
		move.w	$42(a0),d0
		move.w	off_63494(pc,d0.w),d0
		jsr	off_63494(pc,d0.w)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_63486:	dc.w loc_634CA-off_63486

		dc.w loc_63526-off_63486
		dc.w loc_63562-off_63486
		dc.w loc_6358E-off_63486
		dc.w loc_635C8-off_63486
		dc.w loc_635F6-off_63486
		dc.w loc_63620-off_63486
off_63494:	dc.w loc_6349A-off_63494

		dc.w loc_634AC-off_63494
		dc.w loc_634B8-off_63494
; ---------------------------------------------------------------------------

loc_6349A:
		move.l	#Map_KnuxIntroLay,$C(a0)
		lea	DPLCPtr_6667A(pc),a2
		jmp	(Perform_DPLC).l
; ---------------------------------------------------------------------------

loc_634AC:
		move.l	#Map_Knuckles,$C(a0)
		bra.w	Knuckles_Load_PLC_6618A
; ---------------------------------------------------------------------------

loc_634B8:
		move.l	#Map_HPZKnucklesGrab,$C(a0)
		lea	DPLCPtr_66682(pc),a2
		jmp	(Perform_DPLC).l
; ---------------------------------------------------------------------------

loc_634CA:
		lea	ObjDat4_663DE(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l
		move.w	#$EF,$2E(a0)
		move.b	#-$7D,($FFFFB02E).w
		move.w	#$560,($FFFFEE78).w
		move.w	#$948,($FFFFEE7C).w
		st	($FFFFEE0A).w
		move.l	($FFFFFE0C).w,($FFFFF636).w
		clr.b	($FFFFF711).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_63508
		move.l	#loc_63682,(a1)

loc_63508:
		lea	ChildObjDat_66656(pc),a2
		jsr	(CreateChild6_Simple).l
		lea	(Pal_SKIntroBomb).l,a1
		lea	($FFFFFCA0).w,a2
		moveq	#7,d6

loc_6351E:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_6351E
		rts
; ---------------------------------------------------------------------------

loc_63526:
		btst	#0,($FFFFFAB8).w
		bne.s	loc_6354C
		subq.w	#1,$2E(a0)
		bne.s	loc_63542
		jsr	(Create_New_Sprite).l
		bne.s	loc_63542
		move.l	#loc_63790,(a1)

loc_63542:

		lea	byte_668C3(pc),a1
		jmp	(Animate_RawNoSST).l
; ---------------------------------------------------------------------------

loc_6354C:
		move.b	#4,5(a0)
		move.b	#4,$22(a0)
		lea	byte_668C7(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_63562:
		btst	#1,($FFFFFAB8).w
		bne.s	loc_63570
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_63570:
		move.b	#6,5(a0)
		move.w	#2,$42(a0)
		move.b	#-$73,$22(a0)
		move.w	#-$100,$18(a0)
		move.w	#-$100,$1A(a0)

loc_6358E:
		btst	#2,($FFFFFAB8).w
		bne.s	loc_635A2
		addi.w	#8,$1A(a0)
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_635A2:
		move.b	#8,5(a0)
		move.w	#4,$42(a0)
		move.b	#3,$22(a0)
		subq.w	#8,$14(a0)
		move.b	#$13,$1E(a0)
		move.w	#-$100,$18(a0)
		clr.w	$1A(a0)

loc_635C8:
		jsr	(MoveSprite_LightGravity).l
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.w	locret_6206C
		add.w	d1,$14(a0)
		move.b	#$A,5(a0)
		move.l	#loc_635FC,$34(a0)
		lea	byte_668D0(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_635F6:
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_635FC:
		move.b	#$C,5(a0)
		move.w	#2,$42(a0)
		move.b	#7,$22(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		lea	byte_6682F(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_63620:
		move.w	$18(a0),d0
		addi.w	#$C,d0
		cmpi.w	#$400,d0
		bhi.s	loc_63632
		move.w	d0,$18(a0)

loc_63632:
		jsr	(MoveSprite2).l
		jsr	(Animate_RawCheckResult).l
		move.w	($FFFFEE78).w,d0
		addi.w	#$180,d0
		cmp.w	$10(a0),d0
		bcc.w	locret_6206C

loc_6364E:

		move.b	#1,($FFFFFE2A).w
		move.w	#$6F4,($FFFFFE2E).w
		move.w	#$9EC,($FFFFFE30).w
		jsr	(Save_Level_Data).l
		clr.l	($FFFFFE34).w
		move.w	#$700,d0
		move.w	d0,($FFFFFE10).w
		move.w	d0,($FFFFEE4E).w
		move.w	#1,($FFFFFE02).w
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_63682:
		btst	#7,($FFFFF605).w
		bne.s	loc_6364E
		btst	#7,($FFFFF607).w
		bne.s	loc_6364E
		rts
; ---------------------------------------------------------------------------

loc_63694:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_636F4(pc,d0.w),$10(a0)
		move.w	#$9F4,$14(a0)
		moveq	#0,d1
		cmpi.w	#8,d0
		bcs.s	loc_636B0
		moveq	#4,d1

loc_636B0:
		move.l	word_63704(pc,d1.w),$3A(a0)
		lea	off_6370C(pc),a1
		move.b	#$C,$1E(a0)
		andi.w	#2,d0
		beq.s	loc_636D0
		adda.w	#$A,a1
		move.b	#$A,$1E(a0)

loc_636D0:
		move.l	(a1)+,(a0)
		move.l	(a1)+,$C(a0)
		move.w	(a1)+,$A(a0)
		bset	#2,4(a0)
		move.w	#$200,8(a0)
		move.b	#$10,7(a0)
		move.b	#$10,6(a0)
		rts
; ---------------------------------------------------------------------------
word_636F4:	dc.w $5F0
		dc.w $600
		dc.w $610
		dc.w $620
		dc.w $660
		dc.w $670
		dc.w $680
		dc.w $690
word_63704:	dc.w $5E8
		dc.w $628
		dc.w $658
		dc.w $698
off_6370C:	dc.l loc_63720
		dc.l Map_Animals2
		dc.w $580
		dc.l loc_63750
		dc.l Map_Animals1
		dc.w $592
; ---------------------------------------------------------------------------

loc_63720:
		jsr	(MoveSprite).l
		move.b	#1,$22(a0)
		tst.w	$1A(a0)
		bmi.s	loc_6374A
		move.b	#0,$22(a0)
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_6374A
		add.w	d1,$14(a0)
		bsr.w	sub_65E02

loc_6374A:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_63750:
		jsr	(MoveSprite2).l
		addi.w	#$18,$1A(a0)
		tst.w	$1A(a0)
		bmi.s	loc_63774
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_63774
		add.w	d1,$14(a0)
		bsr.w	sub_65E02

loc_63774:

		subq.b	#1,$24(a0)
		bpl.s	loc_6378A
		move.b	#1,$24(a0)
		addq.b	#1,$22(a0)
		andi.b	#1,$22(a0)

loc_6378A:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_63790:
		lea	ObjDat3_66486(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_637EC,(a0)
		move.b	#$10,$1E(a0)
		move.w	($FFFFEE78).w,d0
		addi.w	#$A0,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d0
		subi.w	#$40,d0
		move.w	d0,$14(a0)
		moveq	#$51,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_6665C(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	(PLC_83D64).l,a1
		jsr	(Load_PLC_Raw).l
		lea	(ArtKosM_KnuxIntroBomb).l,a1
		move.w	#-$5A40,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

loc_637EC:
		jsr	(MoveSprite).l
		tst.b	4(a0)
		bpl.s	loc_63840
		tst.w	$1A(a0)
		bmi.s	loc_63840
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_63840
		add.w	d1,$14(a0)
		bset	#0,($FFFFFAB8).w
		moveq	#$5D,d0
		jsr	(Play_Sound_2).l
		move.w	$1A(a0),d0
		asr.w	#2,d0
		neg.w	d0
		move.w	d0,$1A(a0)
		cmpi.w	#-$100,d0
		blt.s	loc_63840
		move.l	#loc_63846,(a0)
		move.w	#$77,$2E(a0)
		moveq	#-$1F,d0
		jsr	(Play_Sound).l

loc_63840:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_63846:
		subq.w	#1,$2E(a0)
		bpl.s	loc_6389C
		move.l	#loc_638A2,(a0)
		bset	#7,$2A(a0)
		bset	#1,($FFFFFAB8).w
		moveq	#$4E,d0
		jsr	(Play_Sound_2).l
		lea	($FFFFFC00).w,a1
		lea	($FFFFFC80).w,a2
		moveq	#7,d6

loc_63870:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_63870
		jsr	(Create_New_Sprite).l
		bne.s	loc_6389C
		move.w	a1,$44(a0)
		move.l	#loc_85E64,(a1)
		move.w	#7,$3A(a1)
		st	$2C(a1)
		lea	ChildObjDat_66650(pc),a2
		jsr	(CreateChild6_Simple).l

loc_6389C:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_638A2:
		movea.w	$44(a0),a1
		btst	#5,$38(a1)
		beq.w	locret_6206C
		bset	#2,($FFFFFAB8).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_638C4
		move.l	#loc_639C8,(a1)

loc_638C4:
		lea	(Pal_SSZ1).l,a1
		lea	($FFFFFCA0).w,a2
		moveq	#7,d6

loc_638D0:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_638D0
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_638DC:
		move.l	#loc_638EC,(a0)
		lea	word_66492(pc),a1
		jmp	(SetUp_ObjAttributes3).l
; ---------------------------------------------------------------------------

loc_638EC:
		lea	byte_66905(pc),a1
		jsr	(Animate_RawNoSST).l
		jsr	(Refresh_ChildPosition).l
		move.b	($FFFFFE0F).w,d0
		andi.b	#7,d0
		bne.s	loc_63910
		lea	ChildObjDat_66664(pc),a2
		jsr	(CreateChild6_Simple).l

loc_63910:
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_63916:
		lea	word_66498(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_63946,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		jsr	(Random_Number).l
		andi.w	#$7F,d0
		subi.w	#$3F,d0
		move.w	d0,$18(a0)
		move.w	#-$100,$1A(a0)

loc_63946:
		jsr	(MoveSprite2).l
		lea	byte_6690B(pc),a1
		jsr	(Animate_RawNoSST).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6395C:
		lea	(ObjDat_BossExplosion1).l,a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#Go_Delete_Sprite,$34(a0)
		moveq	#-$4C,d0
		jsr	(Play_Sound_2).l
		moveq	#0,d0
		move.b	$2C(a0),d0
		lea	byte_639A2(pc,d0.w),a1
		lsr.w	#1,d0
		move.w	d0,$2E(a0)
		move.b	(a1)+,d0
		ext.w	d0
		add.w	d0,$10(a0)
		move.b	(a1)+,d0
		ext.w	d0
		add.w	d0,$14(a0)
		lea	(loc_639B6).l,a1
		move.l	a1,(a0)
		jmp	(a1)
; ---------------------------------------------------------------------------
byte_639A2:	dc.b 0
		dc.b 0
		dc.b 8
		dc.b $F8
		dc.b $FA
		dc.b $F4
		dc.b $F6
		dc.b 4
		dc.b 8
		dc.b $A
		dc.b 0
		dc.b $18
		dc.b 8
		dc.b $E8
		dc.b $F4
		dc.b $E0
		dc.b $EA
		dc.b $FC
		dc.b $18
		dc.b 0
; ---------------------------------------------------------------------------

loc_639B6:
		subq.w	#1,$2E(a0)
		bpl.w	locret_6206C
		lea	(Obj_BossExplosionAnim).l,a1
		move.l	a1,(a0)
		jmp	(a1)
; ---------------------------------------------------------------------------

loc_639C8:
		lea	(ObjDat3_919A6).l,a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_63A16,(a0)
		move.w	($FFFFEE78).w,d0
		addi.w	#$110,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d0
		subi.w	#$60,d0
		move.w	d0,$14(a0)
		moveq	#$19,d0
		jsr	(Play_Sound).l
		lea	(ChildObjDat_919D0).l,a2
		jsr	(CreateChild1_Normal).l
		lea	(ArtKosM_EggRoboBadnik).l,a1
		move.w	#-$6000,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

loc_63A16:
		addq.w	#1,$14(a0)
		move.w	($FFFFEE7C).w,d0
		addi.w	#$40,d0
		cmp.w	$14(a0),d0
		bge.s	loc_63A3A
		move.l	#loc_63A46,(a0)
		move.w	#$7F,$2E(a0)
		jsr	(Swing_Setup1).l

loc_63A3A:
		jsr	(sub_91988).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_63A46:
		subq.w	#1,$2E(a0)
		bne.s	loc_63A52
		move.w	#$400,$18(a0)

loc_63A52:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jsr	(sub_91988).l
		jmp	(Sprite_CheckDelete).l
; ---------------------------------------------------------------------------

loc_63A6A:
		cmpi.b	#2,($FFFFB038).w
		beq.w	loc_62158
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_63A8C(pc,d0.w),d1
		jsr	off_63A8C(pc,d1.w)
		bsr.w	Knuckles_Load_PLC_661E0
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_63A8C:	dc.w loc_63A96-off_63A8C

		dc.w loc_63ACA-off_63A8C
		dc.w loc_63AE8-off_63A8C
		dc.w loc_63B10-off_63A8C
		dc.w locret_63B20-off_63A8C
; ---------------------------------------------------------------------------

loc_63A96:
		lea	ObjDat4_663BA(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l
		bset	#0,4(a0)
		move.l	#Map_Knuckles,$C(a0)
		move.b	#$56,$22(a0)
		move.w	#$3A38,$10(a0)
		move.w	#$EC,$14(a0)
		lea	Pal_CutsceneKnux1(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_63ACA:
		btst	#1,($FFFFFAB8).w
		beq.w	locret_6206C
		move.b	#4,5(a0)
		move.b	#-$22,$22(a0)
		move.l	#loc_63AF2,$34(a0)

loc_63AE8:
		lea	word_66891(pc),a1
		jmp	(Animate_Raw2NoSSTMultiDelay).l
; ---------------------------------------------------------------------------

loc_63AF2:
		move.b	#6,5(a0)
		bset	#2,($FFFFFAB8).w
		move.l	#loc_63B1A,$34(a0)
		lea	word_668A7(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_63B10:
		lea	word_668A7(pc),a1
		jmp	(Animate_Raw2NoSSTMultiDelay).l
; ---------------------------------------------------------------------------

loc_63B1A:
		move.b	#8,5(a0)

locret_63B20:
		rts
; ---------------------------------------------------------------------------

Obj_AE_2:
		cmpi.b	#2,($FFFFB038).w
		beq.w	loc_62158
		move.l	#loc_63B40,(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_63B40
		move.l	#loc_863C0,(a1)

loc_63B40:

		lea	($FFFFB000).w,a1
		lea	word_63B94(pc),a2
		jsr	(Check_InMyRange).l
		beq.w	locret_6206C
		move.l	#loc_63B9C,(a0)
		move.w	($FFFFEE78).w,($FFFFEE14).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_63B72
		move.l	#Obj_CutsceneKnuckles,(a1)
		move.b	#$24,$2C(a1)

loc_63B72:
		bsr.w	sub_65DD6
		jsr	(Create_New_Sprite).l
		bne.s	loc_63B84
		move.l	#loc_63C3E,(a1)

loc_63B84:
		lea	(ArtKosM_LRZKnuxBoulder).l,a1
		move.w	#-$6000,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------
word_63B94:	dc.w  $FFF0,   $10, $FDC0,  $240
; ---------------------------------------------------------------------------

loc_63B9C:
		lea	($FFFFB000).w,a1
		cmpi.w	#$39B0,$10(a1)
		bcs.s	locret_63BBC
		move.l	#loc_63BBE,(a0)
		st	($FFFFF7CA).w
		jsr	(Stop_Object).l
		clr.w	($FFFFF602).w

locret_63BBC:
		rts
; ---------------------------------------------------------------------------

loc_63BBE:
		lea	($FFFFB000).w,a1
		btst	#1,$2A(a1)
		bne.w	locret_6206C
		move.l	#loc_63BF4,(a0)
		bset	#0,($FFFFFAB8).w
		move.w	#0,($FFFFEE14).w
		st	($FFFFEE0A).w
		clr.b	($FFFFF7CA).w
		move.b	#-$7F,$2E(a1)
		move.b	#7,$20(a1)
		rts
; ---------------------------------------------------------------------------

loc_63BF4:
		move.w	($FFFFEE7C).w,d0
		subq.w	#2,d0
		move.w	d0,($FFFFEE7C).w
		cmpi.w	#$90,d0
		bhi.w	locret_6206C
		move.l	#loc_63C14,(a0)
		bset	#1,($FFFFFAB8).w
		rts
; ---------------------------------------------------------------------------

loc_63C14:
		cmpi.w	#$4C0,($FFFFB014).w
		bcs.w	locret_6206C
		st	($FFFFEE5E).w
		move.w	($FFFFFE20).w,($FFFFEF5E).w
		move.l	($FFFFFE22).w,($FFFFEF60).w
		move.b	($FFFFB02B).w,($FFFFFF96).w
		move.w	#$1600,d0
		jmp	(StartNewLevel).l
; ---------------------------------------------------------------------------

loc_63C3E:
		lea	ObjDat3_6647A(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_63C66,(a0)
		move.w	#$3A08,$10(a0)
		move.w	#$E2,$14(a0)
		move.b	#$1F,$1E(a0)
		move.w	a0,$46(a0)
		rts
; ---------------------------------------------------------------------------

loc_63C66:
		btst	#2,($FFFFFAB8).w
		beq.s	loc_63C7A
		move.l	#loc_63C80,(a0)
		move.w	#-$200,$18(a0)

loc_63C7A:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_63C80:
		moveq	#$69,d0
		jsr	(sub_85E52).l
		bsr.w	sub_65ED4
		bsr.w	sub_65EFE
		jsr	(MoveSprite2).l
		jsr	(ObjHitFloor).l
		tst.w	d1
		bmi.s	loc_63CA6
		move.l	#loc_63CAC,(a0)

loc_63CA6:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_63CAC:
		moveq	#$69,d0
		jsr	(sub_85E52).l
		bsr.w	sub_65ED4
		bsr.w	sub_65EFE
		jsr	(MoveSprite_LightGravity).l
		tst.w	$1A(a0)
		bmi.s	loc_63CE6
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_63CE6
		move.w	#-$100,$1A(a0)
		move.w	#$14,($FFFFEECC).w
		moveq	#$59,d0
		jsr	(Play_Sound_2).l

loc_63CE6:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
word_63CEC:	dc.w $180
		dc.w $480
		dc.w $FE0
		dc.w $11E0
		dc.w $380
		dc.w $380
		dc.w $10E0
		dc.w $10E0
; ---------------------------------------------------------------------------

loc_63CFC:
		movea.l	a0,a1
		move.l	#loc_63D1A,(a1)
		lea	($FFFFBDE0).w,a2
		move.w	a2,($FFFFFAA4).w
		moveq	#$24,d0

loc_63D0E:
		move.w	(a1)+,(a2)+
		dbf	d0,loc_63D0E
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_63D1A:
		cmpi.b	#2,($FFFFB038).w
		beq.w	loc_62158
		lea	word_63CEC(pc),a1
		jsr	(Check_CameraInRange).l
		jsr	(sub_85D6A).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_63D5C
		move.l	#loc_85CA4,(a1)
		move.l	#loc_63DD4,$34(a1)
		move.b	#$1F,$26(a1)
		move.w	#$78,$2E(a1)
		move.b	$27(a0),$27(a1)

loc_63D5C:
		move.l	#loc_63DE0,(a0)
		move.l	#Map_Knuckles,$C(a0)
		move.w	#$24DA,$A(a0)
		move.w	#$100,8(a0)
		move.b	#$18,7(a0)
		move.b	#$18,6(a0)
		move.b	#$13,$1E(a0)
		move.b	#9,$1F(a0)
		move.b	#4,4(a0)
		bset	#0,4(a0)
		move.b	#-$28,$22(a0)
		move.b	#8,$29(a0)
		move.l	#word_66771,$30(a0)
		clr.w	$44(a0)
		lea	($FFFFFC20).w,a1
		lea	($FFFFFCA0).w,a2
		moveq	#7,d6

loc_63DBC:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_63DBC
		lea	Pal_CutsceneKnux1(pc),a1
		jsr	(PalLoad_Line1).l

loc_63DCC:
		move.w	#$88,($FFFFFC2C).w
		rts
; ---------------------------------------------------------------------------

loc_63DD4:
		bset	#0,($FFFFFAB8).w
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_63DE0:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_63E1E(pc,d0.w),d1
		jsr	off_63E1E(pc,d1.w)
		move.w	$44(a0),d0
		move.w	off_63E00(pc,d0.w),d0
		jsr	off_63E00(pc,d0.w)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_63E00:	dc.w loc_63E06-off_63E00

		dc.w loc_63E0A-off_63E00
		dc.w loc_63E14-off_63E00
; ---------------------------------------------------------------------------

loc_63E06:
		bra.w	Knuckles_Load_PLC_661E0
; ---------------------------------------------------------------------------

loc_63E0A:
		lea	DPLCPtr_66682(pc),a2
		jmp	(Perform_DPLC).l
; ---------------------------------------------------------------------------

loc_63E14:
		lea	DPLCPtr_6668A(pc),a2
		jmp	(Perform_DPLC).l
; ---------------------------------------------------------------------------
off_63E1E:	dc.w loc_63E7C-off_63E1E

		dc.w loc_63EDA-off_63E1E
		dc.w loc_63F3C-off_63E1E
		dc.w loc_63FD8-off_63E1E
		dc.w loc_64016-off_63E1E
		dc.w loc_6403A-off_63E1E
		dc.w loc_64090-off_63E1E
		dc.w loc_64102-off_63E1E
		dc.w loc_6414C-off_63E1E
		dc.w loc_64184-off_63E1E
		dc.w loc_641EC-off_63E1E
		dc.w loc_64258-off_63E1E
		dc.w loc_642F0-off_63E1E
		dc.w loc_64350-off_63E1E
		dc.w loc_6438A-off_63E1E
		dc.w loc_643BE-off_63E1E
		dc.w loc_643EA-off_63E1E
		dc.w loc_64422-off_63E1E
		dc.w loc_64460-off_63E1E
		dc.w loc_6451E-off_63E1E
		dc.w loc_64574-off_63E1E
		dc.w loc_64594-off_63E1E
		dc.w loc_645D4-off_63E1E
		dc.w loc_64610-off_63E1E
		dc.w loc_64668-off_63E1E
		dc.w loc_64692-off_63E1E
		dc.w loc_646F6-off_63E1E
		dc.w loc_64758-off_63E1E
		dc.w loc_647C6-off_63E1E
		dc.w loc_6480A-off_63E1E
		dc.w loc_64846-off_63E1E
		dc.w loc_6487C-off_63E1E
		dc.w loc_648B2-off_63E1E
		dc.w loc_648E2-off_63E1E
		dc.w loc_648F2-off_63E1E
		dc.w loc_64952-off_63E1E
		dc.w loc_64984-off_63E1E
		dc.w loc_649AE-off_63E1E
		dc.w loc_649D6-off_63E1E
		dc.w loc_64A00-off_63E1E
		dc.w loc_64A36-off_63E1E
		dc.w loc_64A6E-off_63E1E
		dc.w loc_64AC0-off_63E1E
		dc.w loc_64B10-off_63E1E
		dc.w loc_64B6A-off_63E1E
		dc.w loc_64BB8-off_63E1E
		dc.w loc_64BFA-off_63E1E
; ---------------------------------------------------------------------------

loc_63E7C:
		jsr	(Animate_Raw2MultiDelay).l
		tst.w	d2
		bpl.s	loc_63EA0
		btst	#0,($FFFFFAB8).w
		beq.s	loc_63EA0
		move.b	$39(a0),d0
		addq.b	#1,d0
		cmpi.b	#2,d0
		bcc.w	loc_641C4
		move.b	d0,$39(a0)

loc_63EA0:

		jsr	(Find_SonicTails).l
		bsr.w	sub_66094
		cmpi.w	#$40,d3
		bcc.w	locret_6206C
		cmpi.w	#$30,d2
		bcc.w	locret_6206C
		bra.w	loc_63F20
; ---------------------------------------------------------------------------

loc_63EBE:


		move.b	#0,5(a0)
		clr.b	$39(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		lea	word_66771(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_63EDA:
		jsr	(Animate_RawCheckResult).l
		jsr	(Find_SonicTails).l
		bsr.w	sub_66094
		cmpi.w	#$10,d3
		bcc.s	loc_63F00
		cmpi.w	#$20,d2
		bcc.s	loc_63F00
		cmpi.b	#2,$20(a1)
		bne.w	loc_63FF8

loc_63F00:

		subq.w	#1,$2E(a0)
		bmi.w	loc_64066
		lea	off_63F10(pc),a3
		bra.w	loc_660BE
; ---------------------------------------------------------------------------
off_63F10:	dc.l loc_63F7A

		dc.l loc_63FF8
		dc.l loc_6429E
		dc.l loc_660A6
; ---------------------------------------------------------------------------

loc_63F20:
		move.b	#2,5(a0)
		move.b	#-$26,$22(a0)
		move.w	#$77,$2E(a0)
		lea	byte_667AD(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_63F3C:
		jsr	(sub_6615A).l
		move.w	$18(a0),d0
		beq.s	loc_63F58
		move.w	$40(a0),d1
		add.w	d1,d0
		move.w	d0,$18(a0)
		jsr	(MoveSprite2).l

loc_63F58:
		jsr	(Animate_Raw2MultiDelay).l
		bmi.w	locret_6206C
		lea	off_63F6A(pc),a3
		bra.w	loc_660BE
; ---------------------------------------------------------------------------
off_63F6A:	dc.l loc_63F7A
		dc.l loc_660A6
		dc.l loc_6429E
		dc.l loc_660A6
; ---------------------------------------------------------------------------

loc_63F7A:

		move.b	#4,5(a0)
		move.l	#loc_63EBE,$34(a0)
		move.w	#$2C0,d3
		move.w	#-$20,d4
		btst	#0,4(a0)
		bne.s	loc_63F9C
		neg.w	d3
		neg.w	d4

loc_63F9C:
		move.w	d3,$18(a0)
		move.w	d4,$40(a0)
		move.w	$18(a1),d0
		move.w	#$100,d1
		move.w	#-$100,d2
		cmp.w	d2,d0
		blt.s	loc_63FC0
		cmp.w	d1,d0
		bge.s	loc_63FC0
		tst.w	d0
		bpl.s	loc_63FBE
		move.w	d2,d1

loc_63FBE:
		move.w	d1,d0

loc_63FC0:

		neg.w	d0
		move.w	d0,$18(a1)
		neg.w	$1A(a1)
		neg.w	$1C(a1)

loc_63FCE:
		lea	word_667B4(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_63FD8:
		subq.w	#1,$2E(a0)
		bmi.w	loc_63EBE
		lea	off_63FE8(pc),a3
		bra.w	loc_660BE
; ---------------------------------------------------------------------------
off_63FE8:	dc.l loc_660A6
		dc.l loc_660A6
		dc.l loc_6429E
		dc.l loc_660A6
; ---------------------------------------------------------------------------

loc_63FF8:

		tst.b	$34(a1)
		bne.w	locret_6206C
		move.b	#6,5(a0)

loc_64006:
		move.b	#-$22,$22(a0)
		move.w	#7,$2E(a0)
		bra.w	loc_660AE
; ---------------------------------------------------------------------------

loc_64016:
		jmp	(Animate_RawCheckResult).l
; ---------------------------------------------------------------------------

loc_6401C:
		move.b	#$A,5(a0)
		move.w	#-$600,$1A(a0)
		moveq	#$62,d0
		jsr	(Play_Sound_2).l
		lea	byte_667C1(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_6403A:
		jsr	(Animate_RawCheckResult).l
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bpl.w	loc_640DC
		lea	off_64056(pc),a3
		bra.w	loc_660BE
; ---------------------------------------------------------------------------
off_64056:	dc.l loc_660A6

		dc.l loc_660A6
		dc.l loc_660A6
		dc.l loc_660A6
; ---------------------------------------------------------------------------

loc_64066:

		move.b	#8,5(a0)
		jsr	(Find_SonicTails).l
		bsr.w	sub_66094
		clr.w	$18(a0)
		clr.w	$1A(a0)
		move.l	#loc_6401C,$34(a0)
		lea	byte_667CC(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_64090:
		jsr	(sub_6615A).l
		jsr	(MoveSprite2).l
		tst.w	$18(a0)
		beq.w	loc_64132
		jsr	(Find_SonicTails).l
		cmpi.w	#$30,d2
		bcs.s	loc_640C4
		btst	#0,4(a0)
		sne	d4
		tst.w	d0
		beq.s	loc_640BE
		not.b	d4

loc_640BE:
		tst.b	d4
		beq.w	loc_64132

loc_640C4:
		lea	off_640CC(pc),a3
		bra.w	loc_660BE
; ---------------------------------------------------------------------------
off_640CC:	dc.l loc_660A6
		dc.l loc_660A6
		dc.l loc_6429E
		dc.l loc_660A6
; ---------------------------------------------------------------------------

loc_640DC:
		move.b	#$C,5(a0)
		move.b	#-$40,$22(a0)
		move.w	#$400,d0
		btst	#0,4(a0)
		beq.s	loc_640F6
		neg.w	d0

loc_640F6:
		move.w	d0,$18(a0)
		move.w	#$80,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_64102:
		jsr	(Animate_Raw2MultiDelay).l
		jsr	(MoveSprite).l
		jsr	(ObjHitFloor).l
		tst.w	d1
		bmi.w	loc_64164
		lea	off_64122(pc),a3
		bra.w	loc_660BE
; ---------------------------------------------------------------------------
off_64122:	dc.l loc_6429E
		dc.l loc_660A6
		dc.l loc_6429E
		dc.l loc_660A6
; ---------------------------------------------------------------------------

loc_64132:

		move.b	#$E,5(a0)
		bchg	#0,4(a0)
		clr.w	$18(a0)
		lea	word_667D4(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_6414C:
		jsr	(Animate_RawCheckResult).l
		jsr	(Find_SonicTails).l
		bsr.w	sub_66094
		lea	off_63F10(pc),a3
		bra.w	loc_660BE
; ---------------------------------------------------------------------------

loc_64164:
		add.w	d1,$14(a0)
		move.b	#$10,5(a0)
		clr.w	$1A(a0)
		move.l	#loc_63EBE,$34(a0)
		lea	byte_667E0(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_64184:
		move.b	($FFFFFE0F).w,d0
		andi.b	#$F,d0
		bne.s	loc_64196
		moveq	#$3C,d0
		jsr	(Play_Sound_2).l

loc_64196:
		jsr	(Animate_RawCheckResult).l
		subq.w	#1,$2E(a0)
		bmi.w	loc_64222
		cmpi.w	#$2B,$2E(a0)
		bne.s	loc_641BC
		bclr	#0,$38(a0)
		lea	ChildObjDat_665FC(pc),a2
		jsr	(CreateChild6_Simple).l

loc_641BC:
		lea	off_64056(pc),a3
		bra.w	loc_660BE
; ---------------------------------------------------------------------------

loc_641C4:

		move.b	#$12,5(a0)
		jsr	(Find_SonicTails).l
		bsr.w	sub_66094
		clr.w	$18(a0)
		clr.w	$1A(a0)
		move.w	#$3B,$2E(a0)
		lea	byte_667F5(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_641EC:
		jsr	(Animate_RawCheckResult).l
		jsr	(sub_6615A).l
		tst.w	$18(a0)
		bne.s	loc_6420C
		bchg	#0,4(a0)
		subq.w	#4,$14(a0)
		bra.w	loc_63EBE
; ---------------------------------------------------------------------------

loc_6420C:
		move.w	$40(a0),d0
		add.w	d0,$18(a0)
		jsr	(MoveSprite2).l
		lea	off_64056(pc),a3
		bra.w	loc_660BE
; ---------------------------------------------------------------------------

loc_64222:
		move.b	#$14,5(a0)
		bset	#0,$38(a0)
		move.w	#$800,d0
		move.w	#-$10,d1
		btst	#0,4(a0)
		beq.s	loc_64242
		neg.w	d0
		neg.w	d1

loc_64242:
		move.w	d0,$18(a0)
		move.w	d1,$40(a0)
		addq.w	#4,$14(a0)
		lea	byte_667C1(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_64258:
		jsr	(Animate_RawCheckResult).l
		jsr	(sub_6615A).l
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.w	locret_6206C
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.w	locret_6206C
		add.w	d1,$14(a0)
		move.w	($FFFFEE78).w,d0
		addi.w	#$A0,d0
		sub.w	$10(a0),d0
		bpl.s	loc_64292
		neg.w	d0

loc_64292:
		cmpi.w	#$60,d0
		bcs.w	loc_641C4
		bra.w	loc_64066
; ---------------------------------------------------------------------------

loc_6429E:


		bset	#0,$38(a0)
		moveq	#$5D,d0
		jsr	(Play_Sound_2).l
		move.w	#$300,d3
		move.w	$10(a1),d1
		sub.w	$10(a0),d1
		bcs.s	loc_642BC
		neg.w	d3

loc_642BC:
		move.w	d3,$18(a0)
		move.w	#-$300,$1A(a0)
		subq.b	#1,$29(a0)
		beq.s	loc_64310
		move.b	#$16,5(a0)
		move.w	#0,$44(a0)
		move.l	#Map_Knuckles,$C(a0)
		move.b	#-$73,$22(a0)
		lea	byte_667BC(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_642F0:
		jsr	(sub_6615A).l
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.w	locret_6206C
		jsr	(ObjHitFloor).l
		tst.w	d1
		bmi.s	loc_64356
		rts
; ---------------------------------------------------------------------------

loc_64310:
		move.b	#$18,5(a0)
		clr.b	($FFFFFE1E).w
		move.w	#2,$44(a0)
		move.l	#Map_HPZKnucklesGrab,$C(a0)
		move.b	#2,$22(a0)
		bset	#4,$38(a0)
		move.b	#$14,($FFFFFF91).w
		jsr	(Create_New_Sprite).l
		bne.s	locret_6434E
		move.l	#Obj_Song_Fade_Transition,(a1)
		move.b	#$14,$2C(a1)

locret_6434E:
		rts
; ---------------------------------------------------------------------------

loc_64350:
		jmp	(Animate_Raw2MultiDelay).l
; ---------------------------------------------------------------------------

loc_64356:
		add.w	d1,$14(a0)
		move.b	#$1A,5(a0)
		move.l	#loc_643A4,$34(a0)
		moveq	#-$70,d0
		jsr	(Play_Sound_2).l
		lea	byte_6680A(pc),a1
		jsr	(Set_Raw_Animation).l
		lea	(ArtKosM_HPZKnuxDizzy).l,a1
		move.w	#-$6000,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

loc_6438A:
		move.b	($FFFFFE0F).w,d0
		andi.b	#$1F,d0
		bne.s	loc_6439C
		moveq	#$59,d0
		jsr	(Play_Sound_2).l

loc_6439C:
		subq.w	#1,$2E(a0)
		bmi.s	loc_643C6
		rts
; ---------------------------------------------------------------------------

loc_643A4:
		move.b	#$1C,5(a0)
		move.w	#$7F,$2E(a0)
		st	($FFFFEECC).w
		lea	ChildObjDat_66602(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_643BE:
		subq.w	#1,$2E(a0)
		bmi.s	loc_643F2
		rts
; ---------------------------------------------------------------------------

loc_643C6:
		move.b	#$1E,5(a0)
		move.b	#6,$22(a0)
		move.w	#$F,$2E(a0)
		lea	ChildObjDat_66644(pc),a2
		jsr	(CreateChild6_Simple).l
		bne.s	locret_643E8
		st	$2C(a1)

locret_643E8:
		rts
; ---------------------------------------------------------------------------

loc_643EA:
		subq.w	#1,$2E(a0)
		bmi.s	loc_64450
		rts
; ---------------------------------------------------------------------------

loc_643F2:
		move.b	#$20,5(a0)
		move.w	#0,$44(a0)
		move.l	#Map_Knuckles,$C(a0)
		move.b	#$56,$22(a0)
		bclr	#0,4(a0)
		move.w	#7,$2E(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_64422:
		jsr	(Animate_RawCheckResult).l
		move.w	$18(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$400,d0
		bcc.s	loc_6443A
		move.w	d0,$18(a0)

loc_6443A:
		jsr	(MoveSprite2).l
		move.w	($FFFFEE78).w,d0
		addi.w	#$180,d0
		cmp.w	$10(a0),d0
		bcs.s	loc_64472
		rts
; ---------------------------------------------------------------------------

loc_64450:
		move.b	#$22,5(a0)
		lea	byte_66824(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_64460:
		jsr	(Animate_RawCheckResult).l
		btst	#0,($FFFFFAB8).w
		bne.w	loc_6453C
		rts
; ---------------------------------------------------------------------------

loc_64472:
		move.b	#$24,5(a0)
		move.w	#2,$44(a0)
		move.l	#Map_HPZKnucklesGrab,$C(a0)
		move.b	#$A,$22(a0)
		lea	byte_6687B(pc),a1
		jsr	(Set_Raw_Animation).l
		bset	#7,$A(a0)
		move.w	#$1620,$10(a0)
		move.w	#$3AC,$14(a0)
		clr.b	($FFFFFAB8).w
		clr.w	($FFFFEECC).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_644BE
		move.l	#loc_64C70,(a1)

loc_644BE:
		jsr	(Create_New_Sprite).l
		bne.s	loc_644CC
		move.l	#loc_64E88,(a1)

loc_644CC:
		jsr	(Create_New_Sprite).l
		bne.s	loc_644DA
		move.l	#Obj_IncLevEndXGradual,(a1)

loc_644DA:
		jsr	(Create_New_Sprite).l
		bne.s	loc_644E8
		move.l	#Obj_DecLevStartYGradual,(a1)

loc_644E8:
		move.w	($FFFFFA98).w,($FFFFEE12).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_644FC
		move.l	#Obj_IncLevEndYGradual,(a1)

loc_644FC:
		lea	(ArtKosM_KnuxFinalBossCrane).l,a1
		move.w	#-$6B20,d2
		jsr	(Queue_Kos_Module).l
		lea	PLC_64516(pc),a1
		jmp	(Load_PLC_Raw).l
; ---------------------------------------------------------------------------
PLC_64516:	dc.w 0
		dc.l ArtNem_RobotnikShip
		dc.w $A5C0
; ---------------------------------------------------------------------------

loc_6451E:
		jsr	(Animate_RawCheckResult).l
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.s	locret_6453A
		jsr	(ObjHitFloor).l
		tst.w	d1
		bmi.s	loc_6457C

locret_6453A:
		rts
; ---------------------------------------------------------------------------

loc_6453C:
		move.b	#$26,5(a0)
		move.w	#0,$44(a0)
		move.l	#Map_Knuckles,$C(a0)
		move.b	#-$66,$22(a0)
		move.w	#$C0,$18(a0)
		move.w	#-$600,$1A(a0)
		moveq	#$62,d0
		jsr	(Play_Sound_2).l
		lea	byte_667C1(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_64574:
		subq.w	#1,$2E(a0)
		bmi.s	loc_645B0
		rts
; ---------------------------------------------------------------------------

loc_6457C:
		add.w	d1,$14(a0)
		move.b	#$28,5(a0)
		move.b	#-$2A,$22(a0)
		move.w	#8,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_64594:
		jsr	(Animate_RawCheckResult).l
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.s	locret_645AE
		cmpi.w	#$339,$14(a0)
		bcc.s	loc_645E0

locret_645AE:
		rts
; ---------------------------------------------------------------------------

loc_645B0:
		move.b	#$2A,5(a0)
		move.w	#-$C0,$18(a0)
		move.w	#-$500,$1A(a0)
		moveq	#$62,d0
		jsr	(Play_Sound_2).l
		lea	byte_667C1(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_645D4:
		subq.w	#1,$2E(a0)
		bmi.s	loc_6463C
		jmp	(Animate_RawCheckResult).l
; ---------------------------------------------------------------------------

loc_645E0:
		move.b	#$2C,5(a0)
		move.w	#$339,$14(a0)
		move.w	#2,$44(a0)
		move.l	#Map_HPZKnucklesGrab,$C(a0)
		move.b	#$A,$22(a0)
		move.w	#$7F,$2E(a0)
		lea	byte_66880(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_64610:
		jsr	(Animate_RawCheckResult).l
		move.w	$18(a0),d0
		addi.w	#$C,d0
		cmpi.w	#$300,d0
		bls.s	loc_64628
		move.w	#$300,d0

loc_64628:
		move.w	d0,$18(a0)
		jsr	(MoveSprite2).l
		cmpi.w	#$1660,$10(a0)
		bcc.s	loc_64670
		rts
; ---------------------------------------------------------------------------

loc_6463C:
		move.b	#$2E,5(a0)
		move.w	#0,$44(a0)
		move.l	#Map_Knuckles,$C(a0)
		move.b	#7,$22(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		lea	byte_6682F(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_64668:
		subq.w	#1,$2E(a0)
		bmi.s	loc_646B8
		rts
; ---------------------------------------------------------------------------

loc_64670:
		move.b	#$30,5(a0)
		move.w	#2,$44(a0)
		move.l	#Map_HPZKnucklesGrab,$C(a0)
		move.b	#$D,$22(a0)
		move.w	#$1D,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_64692:
		jsr	(Animate_RawCheckResult).l
		jsr	(MoveSprite).l
		movea.w	($FFFFFAAE).w,a1
		lea	word_646B0(pc),a2
		jsr	(Check_InTheirRange).l
		bne.s	loc_6471A
		rts
; ---------------------------------------------------------------------------
word_646B0:	dc.w  $FFE0,   $40, $FFE0,   $40
; ---------------------------------------------------------------------------

loc_646B8:
		move.b	#$32,5(a0)
		bset	#1,($FFFFFAB8).w
		move.w	#0,$44(a0)
		move.l	#Map_Knuckles,$C(a0)
		move.b	#-$66,$22(a0)
		move.w	#$300,$18(a0)
		move.w	#-$500,$1A(a0)
		moveq	#$62,d0
		jsr	(Play_Sound_2).l
		lea	byte_667C1(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_646F6:
		jsr	(Animate_RawCheckResult).l
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.s	locret_64710
		cmpi.w	#$3AB,$14(a0)
		bcc.s	loc_6478E

locret_64710:
		rts
; ---------------------------------------------------------------------------
		dc.w  $FFE0,   $40, $FFE0,   $40
; ---------------------------------------------------------------------------

loc_6471A:
		bset	#6,$2A(a1)
		move.b	#$34,5(a0)
		move.w	#0,$44(a0)
		move.l	#Map_Knuckles,$C(a0)
		move.b	#-$66,$22(a0)
		move.w	#-$200,$18(a0)
		move.w	#-$200,$1A(a0)
		moveq	#$62,d0
		jsr	(Play_Sound_2).l
		lea	byte_667C1(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_64758:
		jsr	(Animate_RawCheckResult).l
		move.w	$18(a0),d0
		addi.w	#$C,d0
		cmpi.w	#$300,d0
		bls.s	loc_64770
		move.w	#$300,d0

loc_64770:
		move.w	d0,$18(a0)
		jsr	(MoveSprite2).l
		movea.w	($FFFFFABA).w,a1
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		cmpi.w	#$30,d0
		bcs.s	loc_647EC
		rts
; ---------------------------------------------------------------------------

loc_6478E:
		move.w	#$3AB,$14(a0)
		move.b	#$36,5(a0)
		bclr	#7,$A(a0)
		move.w	#0,$44(a0)
		move.l	#Map_Knuckles,$C(a0)
		move.b	#7,$22(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		lea	byte_6682F(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_647C6:
		jsr	(Animate_RawCheckResult).l
		jsr	(MoveSprite).l
		movea.w	($FFFFFABA).w,a1
		lea	word_647E4(pc),a2
		jsr	(Check_InTheirRange).l
		bne.s	loc_6482A
		rts
; ---------------------------------------------------------------------------
word_647E4:	dc.w  $FFF0,   $60,	0,   $10
; ---------------------------------------------------------------------------

loc_647EC:
		move.b	#$38,5(a0)
		move.w	#-$600,$1A(a0)
		moveq	#$62,d0
		jsr	(Play_Sound_2).l
		lea	byte_667C1(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_6480A:
		btst	#4,($FFFFFAB8).w
		bne.s	loc_6486E

loc_64812:

		movea.w	($FFFFFABA).w,a1
		move.w	$10(a1),d0
		subi.w	#$C,d0
		move.w	d0,$10(a0)
		move.w	$14(a1),$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_6482A:
		move.b	#$3A,5(a0)
		move.w	#2,$44(a0)
		move.l	#Map_HPZKnucklesGrab,$C(a0)
		move.b	#0,$22(a0)
		bra.s	loc_64812
; ---------------------------------------------------------------------------

loc_64846:
		subq.w	#1,$2E(a0)
		bmi.s	loc_6489E
		moveq	#0,d0
		move.b	($FFFFFE0F).w,d1
		btst	#0,d1
		beq.s	loc_6485A
		moveq	#1,d0

loc_6485A:
		move.b	d0,$22(a0)
		andi.b	#3,d1
		beq.s	loc_6486C
		moveq	#$78,d0
		jsr	(Play_Sound_2).l

loc_6486C:
		bra.s	loc_64812
; ---------------------------------------------------------------------------

loc_6486E:
		move.b	#$3C,5(a0)
		move.w	#$3B,$2E(a0)
		bra.s	loc_64812
; ---------------------------------------------------------------------------

loc_6487C:
		moveq	#0,d0
		btst	#0,($FFFFFE0F).w
		beq.s	loc_64888
		moveq	#1,d0

loc_64888:
		move.b	d0,$22(a0)
		jsr	(MoveSprite_LightGravity).l
		jsr	(ObjHitFloor).l
		tst.w	d1
		bmi.s	loc_648B8
		rts
; ---------------------------------------------------------------------------

loc_6489E:
		move.b	#$3E,5(a0)
		move.w	#-$100,$18(a0)
		move.w	#-$100,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_648B2:
		jmp	(Animate_Raw2MultiDelay).l
; ---------------------------------------------------------------------------

loc_648B8:
		add.w	d1,$14(a0)
		move.b	#$40,5(a0)
		bset	#5,($FFFFFAB8).w
		clr.w	$18(a0)
		clr.w	$1A(a0)
		move.l	#loc_648EA,$34(a0)
		lea	byte_667E7(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_648E2:
		tst.b	($FFFFFAAC).w
		bne.s	loc_648FA
		rts
; ---------------------------------------------------------------------------

loc_648EA:
		move.b	#$42,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_648F2:
		subq.w	#1,$2E(a0)
		bmi.s	loc_64964
		rts
; ---------------------------------------------------------------------------

loc_648FA:
		move.b	#$44,5(a0)
		move.w	#$10,$2E(a0)
		clr.b	($FFFFEE0A).w
		move.w	#$5C0,d0
		move.w	d0,($FFFFEE12).w
		move.w	d0,($FFFFFA98).w
		moveq	#-$34,d0
		jsr	(Play_Sound_2).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_6492C
		move.l	#Obj_IncLevEndYGradual,(a1)

loc_6492C:
		bsr.w	*+4
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	locret_64950
		move.b	#$14,$2C(a1)
		move.w	#$1880,$10(a1)
		move.w	#$3D0,$14(a1)

locret_64950:
		rts
; ---------------------------------------------------------------------------

loc_64952:
		jsr	(MoveSprite).l
		jsr	(ObjHitFloor).l
		tst.w	d1
		bmi.s	loc_6498A
		rts
; ---------------------------------------------------------------------------

loc_64964:
		move.b	#$46,5(a0)
		move.b	#2,$22(a0)
		st	($FFFFEEC4).w
		move.w	#$14,($FFFFEECC).w
		lea	ChildObjDat_6663E(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_64984:
		jmp	(Animate_Raw2MultiDelay).l
; ---------------------------------------------------------------------------

loc_6498A:
		add.w	d1,$14(a0)
		move.b	#$48,5(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		move.l	#loc_649B4,$34(a0)
		lea	byte_6680A(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_649AE:
		jmp	(Animate_Raw2MultiDelay).l
; ---------------------------------------------------------------------------

loc_649B4:
		move.b	#$4A,5(a0)
		move.l	#loc_649DE,$34(a0)
		lea	byte_6684F(pc),a1
		jsr	(Set_Raw_Animation).l
		lea	ChildObjDat_66644(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_649D6:
		subq.w	#1,$2E(a0)
		bmi.s	loc_64A1C
		rts
; ---------------------------------------------------------------------------

loc_649DE:
		move.b	#$4C,5(a0)
		move.w	#0,$44(a0)
		move.l	#Map_Knuckles,$C(a0)
		move.b	#$56,$22(a0)
		move.w	#7,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_64A00:
		jsr	(Animate_RawCheckResult).l
		subi.w	#$C,$18(a0)
		jsr	(MoveSprite2).l
		cmpi.w	#$1810,$10(a0)
		bls.s	loc_64A3C
		rts
; ---------------------------------------------------------------------------

loc_64A1C:
		move.b	#$4E,5(a0)
		bset	#0,4(a0)
		clr.w	$18(a0)
		lea	byte_6682F(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_64A36:
		jmp	(Animate_Raw2MultiDelay).l
; ---------------------------------------------------------------------------

loc_64A3C:
		move.b	#$50,5(a0)
		bclr	#0,4(a0)
		move.w	#2,$44(a0)
		move.l	#Map_HPZKnucklesGrab,$C(a0)
		move.b	#$E,$22(a0)
		move.l	#loc_64A8E,$34(a0)
		lea	word_668AF(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_64A6E:
		jsr	(Animate_Raw2MultiDelay).l
		beq.s	locret_64A8C
		cmpi.b	#6,$23(a0)
		bne.w	locret_64A8C
		st	($FFFFFAA2).w
		moveq	#$59,d0
		jsr	(Play_Sound_2).l

locret_64A8C:

		rts
; ---------------------------------------------------------------------------

loc_64A8E:
		move.b	#$52,5(a0)
		bset	#0,4(a0)
		move.l	#loc_64AE2,$34(a0)
		move.w	#0,$44(a0)
		move.l	#Map_Knuckles,$C(a0)
		move.b	#$56,$22(a0)
		lea	byte_66885(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_64AC0:
		jsr	(Animate_RawCheckResult).l
		subi.w	#$C,$18(a0)
		jsr	(MoveSprite2).l
		move.w	($FFFFEE78).w,d0
		subi.w	#$40,d0
		cmp.w	$10(a0),d0
		bcc.s	loc_64B22
		rts
; ---------------------------------------------------------------------------

loc_64AE2:
		move.b	#$54,5(a0)
		bset	#0,4(a0)
		move.w	#0,$44(a0)
		move.l	#Map_Knuckles,$C(a0)
		move.b	#7,$22(a0)
		clr.w	$18(a0)
		lea	byte_6682F(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_64B10:
		jsr	(Animate_RawMultiDelay).l
		btst	#6,($FFFFFAB8).w
		bne.w	loc_64B80
		rts
; ---------------------------------------------------------------------------

loc_64B22:
		move.b	#$56,5(a0)
		move.w	#4,$44(a0)
		move.l	#Map_SSZKnucklesTired,$C(a0)
		clr.b	$22(a0)
		bclr	#0,4(a0)
		move.w	#$161C,$10(a0)
		move.w	#$62C,$14(a0)
		move.w	#$1520,($FFFFFA94).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_64B60
		move.l	#Obj_DecLevStartXGradual,(a1)

loc_64B60:
		lea	byte_6671F(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_64B6A:
		jsr	(Animate_RawCheckResult).l
		jsr	(MoveSprite).l
		cmpi.w	#$15C0,$10(a0)
		bls.s	loc_64BC6
		rts
; ---------------------------------------------------------------------------

loc_64B80:
		move.b	#$58,5(a0)
		move.w	#0,$44(a0)
		move.l	#Map_Knuckles,$C(a0)
		move.b	#-$66,$22(a0)
		move.w	#-$1E0,$18(a0)
		move.w	#-$600,$1A(a0)
		moveq	#$62,d0
		jsr	(Play_Sound_2).l
		lea	byte_667C1(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_64BB8:
		btst	#7,($FFFFFAB8).w
		bne.s	loc_64C00
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_64BC6:
		move.b	#$5A,5(a0)
		move.w	#$15C0,$10(a0)
		move.w	#$600,$14(a0)
		move.w	#4,$44(a0)
		move.l	#Map_SSZKnucklesTired,$C(a0)
		clr.b	$22(a0)
		bclr	#0,4(a0)
		lea	byte_6671F(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_64BFA:
		jmp	(Animate_RawCheckResult).l
; ---------------------------------------------------------------------------

loc_64C00:
		move.b	#$5C,5(a0)
		move.w	#0,$44(a0)
		move.l	#Map_Knuckles,$C(a0)
		move.b	#-$66,$22(a0)
		lea	byte_667C1(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_64C24:
		lea	ObjDat3_664E2(pc),a1
		jsr	(SetUp_ObjAttributes).l
		movea.w	$46(a0),a1
		btst	#0,$38(a1)
		bne.w	loc_62158
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		bclr	#0,4(a0)
		btst	#0,4(a1)
		beq.s	loc_64C5C
		bset	#0,4(a0)

loc_64C5C:
		lea	byte_6683A(pc),a1
		jsr	(Animate_RawNoSST).l
		bsr.w	sub_66236
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_64C70:
		lea	($FFFFB000).w,a1
		cmpi.w	#$14D0,$10(a1)
		bcs.s	locret_64CA4
		move.l	#loc_64CA6,(a0)
		jsr	(Stop_Object).l
		st	($FFFFF7CA).w
		clr.w	($FFFFF602).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_64C9E
		move.l	#loc_863C0,(a1)

loc_64C9E:
		move.w	#$300,($FFFFEE12).w

locret_64CA4:
		rts
; ---------------------------------------------------------------------------

loc_64CA6:
		lea	($FFFFB000).w,a1
		btst	#1,$2A(a1)
		bne.w	locret_6206C
		move.w	#$808,($FFFFF602).w
		cmpi.w	#$15A8,$10(a1)
		bcs.w	locret_6206C
		move.l	#loc_64D1A,(a0)
		st	($FFFFEE0A).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_64CE2
		move.l	#Obj_Song_Fade_Transition,(a1)
		move.b	#$2E,$2C(a1)

loc_64CE2:
		lea	($FFFFB000).w,a1
		clr.b	($FFFFF7CA).w
		move.b	#-$7D,$2E(a1)
		move.b	#-$3C,$22(a1)
		cmpi.b	#1,$38(a1)
		bne.s	loc_64D04
		move.b	#-$50,$22(a1)

loc_64D04:
		move.b	#7,$20(a1)
		clr.w	($FFFFF602).w
		jsr	(Stop_Object).l
		jmp	(Player_Load_PLC).l
; ---------------------------------------------------------------------------

loc_64D1A:
		move.w	($FFFFEE78).w,d0
		addq.w	#2,d0
		move.w	d0,($FFFFEE78).w
		cmpi.w	#$1580,d0
		bcs.s	locret_64D36
		move.l	#loc_64D38,(a0)
		bset	#0,($FFFFFAB8).w

locret_64D36:
		rts
; ---------------------------------------------------------------------------

loc_64D38:
		btst	#1,($FFFFFAB8).w
		beq.s	locret_64D5A
		move.l	#loc_64D5C,(a0)
		lea	($FFFFB000).w,a1
		move.b	#0,$2E(a1)
		st	($FFFFF7CA).w
		move.w	#$808,($FFFFF602).w

locret_64D5A:
		rts
; ---------------------------------------------------------------------------

loc_64D5C:
		lea	($FFFFB000).w,a1
		move.w	$18(a1),d0
		cmpi.w	#$300,d0
		bls.s	loc_64D6E
		move.w	#$300,d0

loc_64D6E:
		move.w	d0,$18(a1)
		move.w	d0,$1C(a1)
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,($FFFFEE78).w
		move.w	#$17D0,d0
		cmp.w	($FFFFEE78).w,d0
		bhi.s	locret_64DA8
		move.l	#loc_64DAA,(a0)
		move.w	d0,($FFFFEE78).w
		move.w	d0,($FFFFEE14).w
		move.w	d0,($FFFFEE16).w
		move.w	($FFFFEE1A).w,($FFFFEE18).w
		clr.b	($FFFFF7CA).w
		clr.b	($FFFFF7CB).w

locret_64DA8:
		rts
; ---------------------------------------------------------------------------

loc_64DAA:
		btst	#5,($FFFFFAB8).w
		beq.s	locret_64DCA
		move.l	#loc_64DCC,(a0)
		st	($FFFFF7CA).w
		jsr	(Create_New_Sprite).l
		bne.s	locret_64DCA
		move.l	#loc_863C0,(a1)

locret_64DCA:

		rts
; ---------------------------------------------------------------------------

loc_64DCC:
		lea	($FFFFB000).w,a1
		btst	#1,$2A(a1)
		bne.s	locret_64DDE
		move.l	#loc_64DE0,(a0)

locret_64DDE:
		rts
; ---------------------------------------------------------------------------

loc_64DE0:
		lea	($FFFFB000).w,a1
		move.w	#$808,d0
		move.w	$10(a1),d1
		subi.w	#$1892,d1
		bcs.s	loc_64DF6
		move.w	#$404,d0

loc_64DF6:
		move.w	d0,($FFFFF602).w
		tst.w	d1
		bpl.s	loc_64E00
		neg.w	d1

loc_64E00:
		cmpi.w	#4,d1
		bhi.w	locret_6206C
		move.l	#loc_64E28,(a0)
		move.w	#$3F,$2E(a0)
		st	($FFFFFAAC).w
		clr.w	($FFFFF602).w
		jsr	(Stop_Object).l
		jmp	(Player_Load_PLC).l
; ---------------------------------------------------------------------------

loc_64E28:
		subq.w	#1,$2E(a0)
		bpl.s	locret_64E44
		move.l	#loc_64E46,(a0)
		lea	($FFFFB000).w,a1
		bset	#0,4(a1)
		bset	#0,$2A(a1)

locret_64E44:
		rts
; ---------------------------------------------------------------------------

loc_64E46:
		lea	($FFFFB000).w,a1
		cmpi.w	#$580,$14(a1)
		bcs.s	locret_64E6A
		btst	#1,$2A(a1)
		bne.s	locret_64E6A
		move.l	#loc_64E6C,(a0)
		clr.b	($FFFFF7CA).w
		move.w	#$5C0,($FFFFEE18).w

locret_64E6A:

		rts
; ---------------------------------------------------------------------------

loc_64E6C:
		lea	($FFFFB000).w,a1
		cmpi.w	#$1660,$10(a1)
		bcc.w	locret_6206C
		move.l	#locret_64E86,(a0)
		clr.b	($FFFFF7CB).w
		rts
; ---------------------------------------------------------------------------

locret_64E86:
		rts
; ---------------------------------------------------------------------------

loc_64E88:
		lea	ObjDat3_664EE(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.w	a0,($FFFFFAAE).w
		move.l	#loc_64EC4,(a0)
		bset	#0,4(a0)
		move.w	#$1640,$10(a0)
		move.w	#$2D0,$14(a0)
		lea	(Child1_MakeRoboHead4).l,a2
		jsr	(CreateChild1_Normal).l
		lea	ChildObjDat_66608(pc),a2
		jsr	(CreateChild1_Normal).l

loc_64EC4:
		btst	#2,$38(a0)
		beq.s	loc_64EEC
		move.l	#loc_64EF2,(a0)
		move.w	#$100,$18(a0)
		move.w	#$180,$1A(a0)
		move.w	#$40,$2E(a0)
		move.l	#loc_64F04,$34(a0)

loc_64EEC:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_64EF2:
		jsr	(MoveSprite2).l
		jsr	(Obj_Wait).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_64F04:
		move.l	#loc_64F20,(a0)
		clr.w	$18(a0)
		jsr	(Swing_Setup1).l
		lea	(Child1_MakeRoboShipFlame).l,a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_64F20:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		btst	#6,$2A(a0)
		bne.s	loc_64F38
		addq.w	#2,$10(a0)

loc_64F38:
		cmpi.w	#$1890,$10(a0)
		bcs.s	loc_64F66
		move.l	#loc_64F70,(a0)
		bset	#4,$38(a0)
		clr.w	$18(a0)
		move.b	#$F,$28(a0)
		move.b	#-1,$29(a0)
		lea	ChildSpriteDat_66624(pc),a2
		jsr	(CreateChild3_NormalRepeated).l

loc_64F66:
		bsr.w	sub_66348
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_64F70:
		move.b	($FFFFFAB8).w,d0
		andi.b	#$C,d0
		cmpi.b	#$C,d0
		bne.s	loc_64F8A
		move.l	#loc_64FA0,(a0)
		bset	#4,($FFFFFAB8).w

loc_64F8A:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		bsr.w	sub_66372
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_64FA0:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		btst	#5,($FFFFFAB8).w
		beq.s	loc_64FD2
		move.l	#loc_64FDC,(a0)
		move.w	#$190,$18(a0)
		bclr	#4,$38(a0)
		lea	(Child1_MakeRoboShipFlame).l,a2
		jsr	(CreateChild1_Normal).l

loc_64FD2:
		bsr.w	sub_66372
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_64FDC:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		move.w	($FFFFEE78).w,d0
		addi.w	#$200,d0
		cmp.w	$10(a0),d0
		bcs.s	loc_65000
		bsr.w	sub_66372
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_65000:
		ori.b	#$30,$38(a0)
		movea.w	($FFFFFABA).w,a1
		jsr	(Delete_Referenced_Sprite).l
		clr.w	($FFFFFABA).w
		clr.w	($FFFFF634).w
		lea	(ArtKosM_Teleporter).l,a1
		move.w	#-$5A40,d2
		jsr	(Queue_Kos_Module).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_6502E:
		lea	ObjDat3_664FA(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_65048,(a0)
		lea	ChildObjDat_66610(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_65048:
		btst	#0,($FFFFFAB8).w
		bne.s	loc_6505C
		jsr	(Refresh_ChildPositionAdjusted).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6505C:
		move.l	#loc_65068,(a0)
		move.b	$43(a0),$3A(a0)

loc_65068:
		move.w	($FFFFFABA).w,d0
		beq.s	loc_6509A
		movea.w	d0,a1
		move.w	$14(a1),d0
		subi.w	#$18,d0
		cmp.w	$14(a0),d0
		bls.s	loc_650A6
		move.w	$1A(a0),d0
		addi.w	#$80,d0
		bmi.s	loc_6508C
		move.w	d0,$1A(a0)

loc_6508C:
		move.b	$1A(a0),d2
		move.b	$3A(a0),d3
		add.b	d2,d3
		move.b	d3,$43(a0)

loc_6509A:
		jsr	(Refresh_ChildPositionAdjusted).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_650A6:
		move.l	#loc_650D4,(a0)
		move.b	#2,$22(a0)
		move.w	#$14,($FFFFEECC).w
		moveq	#-$34,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_6661E(pc),a2
		jsr	(CreateChild6_Simple).l
		lea	ChildObjDat_66638(pc),a2
		jsr	(CreateChild6_Simple).l

loc_650D4:
		move.w	$1A(a0),d2
		subi.w	#$80,d2
		bpl.s	loc_650FA
		move.l	#loc_6510C,(a0)
		moveq	#0,d2
		movea.w	$46(a0),a1
		bset	#2,$38(a1)
		movea.w	($FFFFFABA).w,a2
		bset	#7,$A(a2)

loc_650FA:
		move.w	d2,$1A(a0)
		move.b	$1A(a0),d2
		move.b	$3A(a0),d3
		add.b	d2,d3
		move.b	d3,$43(a0)

loc_6510C:
		jsr	(Refresh_ChildPositionAdjusted).l
		move.w	($FFFFFABA).w,d0
		beq.s	loc_65132
		movea.w	d0,a1
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),d0
		move.b	($FFFFFABD).w,d1
		ext.w	d1
		neg.w	d1
		add.w	d1,d0
		move.w	d0,$14(a1)

loc_65132:
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_65138:
		lea	word_66506(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_65148,(a0)

loc_65148:
		jsr	(Refresh_ChildPositionAdjusted).l
		move.b	$22(a1),d0
		addq.b	#1,d0
		move.b	d0,$22(a0)
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6515E:
		lea	word_6650C(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_6516E,(a0)

loc_6516E:
		movea.w	$46(a0),a1
		move.b	$1A(a1),d0
		lsr.b	#4,d0
		addq.b	#4,d0
		move.b	d0,$22(a0)
		jsr	(Refresh_ChildPosition).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6518A:
		lea	ObjDat3_66512(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_651AC,(a0)
		addi.w	#$30,$14(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		move.w	d0,$2E(a0)

loc_651AC:
		subq.w	#1,$2E(a0)
		bmi.s	loc_651B4
		rts
; ---------------------------------------------------------------------------

loc_651B4:
		move.l	#loc_651E2,(a0)
		jsr	(Random_Number).l
		andi.w	#$3F,d0
		subi.w	#$20,d0
		add.w	d0,$10(a0)
		swap	d0
		andi.w	#$3F,d0
		subi.w	#$20,d0
		add.w	d0,$14(a0)
		move.l	#loc_651F2,$34(a0)

loc_651E2:
		lea	byte_66843(pc),a1
		jsr	(Animate_RawNoSST).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_651F2:
		move.l	#loc_6520A,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_6520A:
		lea	byte_6684A(pc),a1
		jsr	(Animate_RawNoSST).l
		subi.w	#$80,$1A(a0)
		jsr	(MoveSprite2).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_65226:
		lea	ObjDat3_6651E(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_65276,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,d1
		move.w	word_65262(pc,d0.w),$42(a0)
		move.w	word_6526C(pc,d0.w),$2E(a0)
		lsr.w	#1,d1
		move.b	RawAni_6525C(pc,d1.w),$22(a0)
		move.l	#loc_65288,$34(a0)
		rts
; ---------------------------------------------------------------------------
RawAni_6525C:	dc.b  $1C, $1B,	$1A, $19, $18,	 0
word_65262:	dc.w $42C
		dc.w $FE2A
		dc.w $622
		dc.w $F824
		dc.w $FE1C
word_6526C:	dc.w $20
		dc.w $30
		dc.w $40
		dc.w $50
		dc.w $60
; ---------------------------------------------------------------------------

loc_65276:
		jsr	(Refresh_ChildPosition).l
		jsr	(Obj_Wait).l
		jmp	(Sprite_CheckDeleteXY).l
; ---------------------------------------------------------------------------

loc_65288:
		move.l	#loc_65296,(a0)
		bset	#7,$A(a0)
		rts
; ---------------------------------------------------------------------------

loc_65296:
		jsr	(MoveSprite).l
		jmp	(Sprite_CheckDeleteXY).l
; ---------------------------------------------------------------------------

loc_652A2:
		move.l	#loc_652FE,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lea	byte_652DE(pc,d0.w),a1
		move.w	($FFFFEE78).w,d1
		addi.w	#$140,d1
		move.w	($FFFFEE7C).w,d2
		addi.w	#$C0,d2
		move.b	(a1)+,d3
		ext.w	d3
		add.w	d3,d1
		move.w	d1,$10(a0)
		move.b	(a1)+,d3
		ext.w	d3
		add.w	d3,d2
		move.w	d2,$14(a0)
		lsl.w	#2,d0
		move.w	d0,$2E(a0)
		rts
; ---------------------------------------------------------------------------
byte_652DE:	dc.b  $F0, $A8
		dc.b  $E8, $D0
		dc.b  $F8, $F0
		dc.b  $F0, $90
		dc.b  $E0, $A0
		dc.b  $F8, $C8
		dc.b  $E0, $F0
		dc.b  $E0, $C0
		dc.b  $C0, $A8
		dc.b  $D0, $D0
		dc.b  $C0, $F8
		dc.b  $B8, $C8
		dc.b  $C8, $E0
		dc.b  $A0, $C0
		dc.b  $A8, $E0
		dc.b  $90, $F8
; ---------------------------------------------------------------------------

loc_652FE:
		subq.w	#1,$2E(a0)
		bpl.w	locret_6206C
		lea	(Obj_Explosion).l,a1
		move.l	a1,(a0)
		move.b	#2,5(a0)
		jsr	(a1)
		bset	#7,$A(a0)
		rts
; ---------------------------------------------------------------------------

loc_6531E:
		lea	ObjDat3_6652A(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_65348,(a0)
		move.w	#$F0,$2E(a0)
		lea	ChildObjDat3_6662C(pc),a2
		tst.b	$2C(a0)
		beq.s	loc_65342
		lea	ChildObjDat3_66632(pc),a2

loc_65342:
		jmp	(CreateChild8_TreeListRepeated).l
; ---------------------------------------------------------------------------

loc_65348:
		subq.w	#1,$2E(a0)
		bne.s	loc_65354
		bset	#7,$38(a0)

loc_65354:
		jsr	(Refresh_ChildPositionAdjusted).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_65360:
		bset	#3,$38(a0)
		move.b	#$40,$3C(a0)
		move.b	#1,$40(a0)
		bra.w	loc_65382
; ---------------------------------------------------------------------------

loc_65376:
		move.b	#-$40,$3C(a0)
		move.b	#-1,$40(a0)

loc_65382:
		lea	word_66536(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_653F2,(a0)
		move.b	$3C(a0),$26(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,d1
		lsr.w	#1,d1
		btst	#3,$38(a0)
		beq.s	loc_653AE
		addi.w	#$A,d1

loc_653AE:
		move.b	byte_653DE(pc,d1.w),$31(a0)
		cmpi.b	#$12,d0
		bne.s	loc_653C0
		bset	#2,$38(a0)

loc_653C0:
		move.w	d0,d1
		addi.b	#$10,d1
		add.b	d1,d1
		move.b	d1,$30(a0)
		lsl.w	#2,d0
		subi.w	#$48,d0
		neg.w	d0
		move.w	d0,$2E(a0)
		move.w	d0,$32(a0)
		rts
; ---------------------------------------------------------------------------
byte_653DE:	dc.b $D0
		dc.b $D4
		dc.b $D8
		dc.b $E0
		dc.b $E8
		dc.b $F4
		dc.b $F8
		dc.b $FC
		dc.b 0
		dc.b $40
		dc.b $30
		dc.b $28
		dc.b $20
		dc.b $18
		dc.b $10
		dc.b 8
		dc.b $F0
		dc.b $E8
		dc.b $E0
		dc.b $C0
; ---------------------------------------------------------------------------

loc_653F2:
		subi.w	#1,$2E(a0)
		bmi.s	loc_65404
		bsr.w	sub_6628C
		jmp	(MoveSprite_Circular).l
; ---------------------------------------------------------------------------

loc_65404:
		move.l	#loc_6540A,(a0)

loc_6540A:
		move.w	$3A(a0),d0
		addi.w	#$20,d0
		cmpi.w	#$800,d0
		bcs.s	loc_65432
		btst	#2,$38(a0)
		beq.s	loc_65426
		cmpi.w	#$C00,d0
		bcs.s	loc_65432

loc_65426:
		move.l	#loc_65452,(a0)
		move.w	$32(a0),$2E(a0)

loc_65432:

		move.w	d0,$3A(a0)
		bsr.w	sub_6628C
		jsr	(MoveSprite_Circular).l
		btst	#2,$38(a0)
		beq.s	loc_6544C
		bsr.w	sub_662A6

loc_6544C:
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_65452:
		bsr.w	sub_6628C
		movea.w	$44(a0),a1
		btst	#7,$38(a1)
		beq.s	loc_6546E
		subq.w	#1,$2E(a0)
		bpl.s	loc_6546E
		move.l	#loc_6549A,(a0)

loc_6546E:

		btst	#2,$38(a0)
		bne.s	loc_65484
		moveq	#5,d2
		jsr	(MoveSprite_CircularSimple).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_65484:
		bsr.w	sub_662A6
		lea	(AngleLookup_1).l,a2
		jsr	(MoveSprite_AtAngleLookup).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6549A:
		move.b	$3C(a0),d0
		moveq	#4,d1
		move.b	$31(a0),d2
		sub.b	d0,d2
		beq.s	loc_654C2
		sgt	d3
		bpl.s	loc_654AE
		neg.b	d2

loc_654AE:
		cmpi.b	#4,d2
		bcs.s	loc_654C2
		tst.b	d3
		bne.s	loc_654BA
		neg.b	d1

loc_654BA:
		add.b	d1,d0
		move.b	d0,$3C(a0)
		bra.s	loc_6546E
; ---------------------------------------------------------------------------

loc_654C2:

		move.l	#loc_654E2,(a0)
		tst.b	$2C(a0)
		bne.s	loc_654E0
		movea.w	$44(a0),a1
		moveq	#2,d0
		tst.b	$2C(a1)
		beq.s	loc_654DC
		moveq	#3,d0

loc_654DC:
		bset	d0,($FFFFFAB8).w

loc_654E0:
		bra.s	loc_6546E
; ---------------------------------------------------------------------------

loc_654E2:
		btst	#4,($FFFFFAB8).w
		beq.s	loc_654F6
		move.l	#loc_654FA,(a0)
		move.w	#$3B,$2E(a0)

loc_654F6:
		bra.w	loc_6546E
; ---------------------------------------------------------------------------

loc_654FA:
		btst	#2,$38(a0)
		bne.s	loc_6550E
		moveq	#5,d2
		jsr	(MoveSprite_CircularSimple).l
		bra.w	loc_65538
; ---------------------------------------------------------------------------

loc_6550E:
		moveq	#0,d0
		movea.w	$44(a0),a1
		tst.b	$2C(a1)
		beq.s	loc_6551C
		addq.w	#2,d0

loc_6551C:
		btst	#0,($FFFFFE0F).w
		beq.s	loc_65526
		addq.w	#1,d0

loc_65526:
		move.b	RawAni_65550(pc,d0.w),$22(a0)
		lea	(AngleLookup_1).l,a2
		jsr	(MoveSprite_AtAngleLookup).l

loc_65538:
		subq.w	#1,$2E(a0)
		bpl.s	loc_6554A
		move.l	#loc_65554,(a0)
		move.w	$32(a0),$2E(a0)

loc_6554A:
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------
RawAni_65550:	dc.b  $15, $1C,	$19, $1B
; ---------------------------------------------------------------------------

loc_65554:
		subq.w	#1,$2E(a0)
		bpl.s	loc_65560
		move.l	#loc_65564,(a0)

loc_65560:
		bra.w	loc_6546E
; ---------------------------------------------------------------------------

loc_65564:
		move.b	$3C(a0),d0
		moveq	#2,d1
		move.b	$26(a0),d2
		sub.b	d0,d2
		beq.s	loc_6558C
		sgt	d3
		bpl.s	loc_65578
		neg.b	d2

loc_65578:
		subq.b	#1,d2
		beq.s	loc_6558C
		tst.b	d3
		bne.s	loc_65582
		neg.b	d1

loc_65582:
		add.b	d1,d0
		move.b	d0,$3C(a0)
		bra.w	loc_6546E
; ---------------------------------------------------------------------------

loc_6558C:

		move.l	#loc_655AA,(a0)
		clr.b	$39(a0)
		moveq	#1,d0
		btst	#3,$38(a0)
		bne.s	loc_655A2
		neg.w	d0

loc_655A2:
		move.b	d0,$40(a0)
		bra.w	loc_6546E
; ---------------------------------------------------------------------------

loc_655AA:
		bsr.w	sub_6628C
		bra.w	loc_6546E
; ---------------------------------------------------------------------------

loc_655B2:
		lea	ObjDat3_6653C(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_655CE,(a0)
		move.w	#$17F0,$10(a0)
		move.w	#$660,$14(a0)

loc_655CE:
		moveq	#$1B,d1
		moveq	#$20,d2
		moveq	#$20,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		tst.b	($FFFFFAA2).w
		beq.s	loc_655F4
		lea	ChildObjDat_6664A(pc),a2
		jsr	(CreateChild6_Simple).l
		jsr	(Go_Delete_Sprite).l

loc_655F4:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
		dc.w  $FFE8,   $30, $FFE0,   $40
; ---------------------------------------------------------------------------

loc_65602:
		lea	word_66548(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_6561C,(a0)
		bset	#7,4(a0)
		bra.w	loc_662C0
; ---------------------------------------------------------------------------

loc_6561C:
		tst.b	4(a0)
		bpl.s	loc_6562E
		jsr	(MoveSprite_LightGravity).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6562E:
		jsr	(Displace_PlayerOffObject).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_6563A:
		lea	ObjDat3_6654E(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_65662,(a0)
		move.w	#$63,$2E(a0)
		tst.b	$2C(a0)
		beq.w	locret_6206C
		move.l	#Wait_Draw,(a0)
		bra.w	loc_65692
; ---------------------------------------------------------------------------

loc_65662:
		subq.w	#1,$2E(a0)
		bmi.s	loc_65678
		lea	byte_66875(pc),a1
		jsr	(Animate_RawNoSST).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_65678:
		move.l	#Wait_Draw,(a0)
		clr.b	$22(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_65692,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_65692:

		move.b	#5,$22(a0)
		move.w	#$B,$2E(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		rts
; ---------------------------------------------------------------------------

Obj_B1_2:

		move.w	$3A(a0),d0
		moveq	#0,d1
		cmpi.w	#$460,($FFFFEE78).w
		bcs.s	loc_656B8
		moveq	#4,d1

loc_656B8:
		move.w	d1,$3A(a0)
		cmp.w	d0,d1
		beq.s	locret_656D0
		movea.l	off_656D2(pc,d1.w),a1
		lea	($FFFFFC20).w,a2
		moveq	#$17,d0

loc_656CA:
		move.l	(a1)+,(a2)+
		dbf	d0,loc_656CA

locret_656D0:
		rts
; ---------------------------------------------------------------------------
off_656D2:	dc.l Pal_HPZ_A
		dc.l Pal_HPZ2_A
; ---------------------------------------------------------------------------

loc_656DA:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6571A(pc,d0.w),d1
		jsr	off_6571A(pc,d1.w)
		btst	#6,$38(a0)
		bne.s	loc_65702
		move.l	#Map_Knuckles,$C(a0)
		bsr.w	Knuckles_Load_PLC_661E0
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_65702:
		move.l	#Map_SSZKnucklesTired,$C(a0)
		lea	DPLCPtr_6668A(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_6571A:	dc.w loc_65730-off_6571A

		dc.w loc_6575E-off_6571A
		dc.w loc_65794-off_6571A
		dc.w loc_657CE-off_6571A
		dc.w loc_657FE-off_6571A
		dc.w loc_65826-off_6571A
		dc.w loc_6584C-off_6571A
		dc.w loc_65876-off_6571A
		dc.w loc_658BA-off_6571A
		dc.w loc_658F2-off_6571A
		dc.w loc_6594A-off_6571A
; ---------------------------------------------------------------------------

loc_65730:
		lea	ObjDat4_663BA(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l
		clr.b	($FFFFFAB8).w
		move.w	#$80,8(a0)
		lea	($FFFFFC20).w,a1
		lea	($FFFFFCA0).w,a2
		moveq	#7,d6

loc_6574E:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_6574E
		lea	Pal_CutsceneKnux1(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_6575E:
		lea	byte_667C1(pc),a1
		jsr	(Animate_RawNoSSTCheckResult).l
		btst	#0,($FFFFFAB8).w
		beq.w	locret_6206C
		move.b	#4,5(a0)
		move.b	#$56,$22(a0)
		move.b	#$33,$1E(a0)
		lea	(ArtKosM_SSZDeathEggSmall).l,a1
		move.w	#-$6000,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

loc_65794:
		jsr	(MoveSprite_LightGravity).l
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.w	locret_6206C
		add.w	d1,$14(a0)
		move.b	#6,5(a0)
		move.w	#5,$2E(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_657C4
		move.l	#loc_66072,(a1)

loc_657C4:
		lea	ChildObjDat_665F6(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_657CE:
		moveq	#-$2D,d0
		jsr	(sub_85E52).l
		subq.w	#1,$2E(a0)
		bpl.w	locret_6206C
		move.b	#8,5(a0)
		bset	#0,4(a0)
		bset	#6,$38(a0)
		clr.b	$22(a0)
		lea	byte_66719(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_657FE:
		moveq	#-$2D,d0
		jsr	(sub_85E52).l
		btst	#1,($FFFFFAB8).w
		bne.s	loc_65814
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_65814:
		move.b	#$A,5(a0)
		clr.b	$22(a0)
		move.w	#5,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_65826:
		subq.w	#1,$2E(a0)
		bpl.s	locret_6584A
		move.b	#$C,5(a0)
		bclr	#0,4(a0)
		bclr	#6,$38(a0)
		move.b	#$56,$22(a0)
		move.w	#5,$2E(a0)

locret_6584A:
		rts
; ---------------------------------------------------------------------------

loc_6584C:
		subq.w	#1,$2E(a0)
		bpl.w	locret_6206C
		move.b	#$E,5(a0)
		move.b	#$13,$1E(a0)
		move.w	#$200,$18(a0)
		move.w	#-$300,$1A(a0)
		lea	byte_667C1(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_65876:
		jsr	(Animate_RawCheckResult).l
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.w	locret_6206C
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.w	locret_6206C
		add.w	d1,$14(a0)
		move.b	#$10,5(a0)
		move.w	#$300,$18(a0)
		clr.w	$1A(a0)
		bclr	#0,4(a0)
		lea	byte_66824(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_658BA:
		jsr	(Animate_RawCheckResult).l
		jsr	(MoveSprite2).l
		cmpi.w	#$2A8,$10(a0)
		bcs.w	locret_6206C
		move.b	#$12,5(a0)
		move.b	#$1B,$1E(a0)
		move.w	#$480,$18(a0)
		move.w	#-$600,$1A(a0)
		lea	byte_667C1(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_658F2:
		jsr	(Animate_RawCheckResult).l
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.w	locret_6206C
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.w	locret_6206C
		add.w	d1,$14(a0)
		move.b	#$14,5(a0)
		move.w	#$200,8(a0)
		bclr	#0,4(a0)
		bset	#6,$38(a0)
		move.b	#1,$22(a0)
		st	($FFFFEEDA).w
		moveq	#$5B,d0
		jsr	(Play_Sound_2).l
		lea	byte_6671F(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_6594A:
		bsr.w	sub_65FDE
		jsr	(Animate_RawMultiDelay).l
		move.w	($FFFFEE78).w,d0
		subi.w	#$80,d0
		cmp.w	$10(a0),d0
		bgt.s	loc_65976
		move.w	$14(a0),d0
		sub.w	($FFFFEE7C).w,d0
		addi.w	#$80,d0
		cmpi.w	#$200,d0
		bls.w	locret_6206C

loc_65976:
		move.b	#1,($FFFFFE2A).w
		move.w	#$140,($FFFFFE2E).w
		move.w	#$C6C,($FFFFFE30).w
		jsr	(Save_Level_Data).l
		lea	($FFFFFCA0).w,a1
		lea	($FFFFFC20).w,a2
		moveq	#7,d6

loc_65998:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_65998
		lea	(PLC_83D48).l,a1
		jsr	(Load_PLC_Raw).l
		jsr	(Remove_From_TrackingSlot).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

Obj_AF_2:
		lea	ObjDat3_6649E(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_659C6,(a0)

loc_659C6:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_659CC:
		lea	ObjDat3_664AA(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_65A30,(a0)
		move.w	#$200,$10(a0)
		move.w	#$C68,d0
		move.w	d0,$14(a0)
		move.w	d0,$1A(a0)
		move.w	#-$40,$40(a0)
		move.w	#$100,$2E(a0)
		move.l	($FFFFFE0C).w,($FFFFF636).w
		lea	ChildObjDat_665C4(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	($FFFFFC60).w,a1
		lea	($FFFFFCE0).w,a2
		moveq	#7,d6

loc_65A14:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_65A14
		lea	Pal_KnuxSSZEnd(pc),a1
		lea	($FFFFFC60).w,a2
		moveq	#$F,d0

loc_65A24:
		move.w	(a1)+,d1
		beq.s	loc_65A2A
		move.w	d1,(a2)

loc_65A2A:
		addq.w	#2,a2
		dbf	d0,loc_65A24

loc_65A30:
		jsr	(MoveSprite_SSZBGAdjust).l
		jsr	(Draw_Sprite).l
		subq.w	#1,$2E(a0)
		bpl.s	locret_65A48
		move.l	#loc_65A4A,(a0)

locret_65A48:
		rts
; ---------------------------------------------------------------------------

loc_65A4A:
		bsr.w	sub_66054
		jsr	(MoveSprite_SSZBGAdjust).l
		jsr	(Draw_Sprite).l
		move.w	($FFFFEE7C).w,d0
		subi.w	#$38,d0
		cmp.w	$14(a0),d0
		bls.w	locret_6206C
		bset	#5,$38(a0)
		bset	#1,($FFFFFAB8).w
		lea	($FFFFFCE0).w,a1
		lea	($FFFFFC60).w,a2
		moveq	#7,d6

loc_65A80:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_65A80
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_65A8C:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_65AB0(pc,d0.w),d1
		jsr	off_65AB0(pc,d1.w)
		jsr	(MoveSprite_SSZBGAdjust).l
		lea	DPLCPtr_66692(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_65AB0:	dc.w loc_65AB6-off_65AB0

		dc.w loc_65AD4-off_65AB0
		dc.w loc_65AF6-off_65AB0
; ---------------------------------------------------------------------------

loc_65AB6:
		lea	ObjDat4_664B6(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l
		move.l	#byte_66739,$30(a0)
		move.w	$14(a0),$1A(a0)
		move.w	#$190,$2E(a0)

loc_65AD4:
		jsr	(Animate_RawMultiDelay).l
		subq.w	#1,$2E(a0)
		bpl.w	locret_6206C
		move.b	#4,5(a0)
		move.w	#$10,$40(a0)
		move.w	#$180,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_65AF6:
		subq.w	#1,$2E(a0)
		bmi.s	loc_65B02
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_65B02:
		jsr	(Remove_From_TrackingSlot).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_65B0E:
		lea	ObjDat3_664C8(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_65B24,(a0)
		move.w	$14(a0),$1A(a0)

loc_65B24:
		st	($FFFFEF3A).w
		btst	#2,($FFFFFAB8).w
		bne.s	loc_65B3C
		jsr	(MoveSprite_SSZBGAdjust).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_65B3C:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_65B42:

		lea	word_664D4(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_65B5A,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)

loc_65B5A:
		jsr	(Refresh_ChildPosition).l
		lea	byte_66760(pc),a1
		jsr	(Animate_RawNoSSTMultiDelay).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_65B70:
		lea	word_664DA(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#loc_65BAE,(a0)
		jsr	(Random_Number).l
		move.w	#$100,d1
		andi.w	#$3F,d0
		subi.w	#$20,d0
		bpl.s	loc_65B96
		neg.w	d1

loc_65B96:
		move.w	d1,$18(a0)
		add.w	d0,$10(a0)
		swap	d0
		andi.w	#$1F,d0
		add.w	d0,$14(a0)
		move.w	#$100,$1A(a0)

loc_65BAE:
		move.b	#4,$22(a0)
		btst	#0,($FFFFFE0F).w
		beq.s	loc_65BC2
		move.b	#5,$22(a0)

loc_65BC2:
		addi.w	#-$10,$1A(a0)
		jsr	(MoveSprite2).l
		jmp	(Sprite_CheckDeleteXY).l
; ---------------------------------------------------------------------------

Obj_83:

		cmpi.b	#2,($FFFFB038).w
		beq.w	loc_62158
		lea	ObjDat3_66402(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_65C04,(a0)
		addq.w	#4,$14(a0)
		lea	PLC_65BFC(pc),a1
		jmp	(Load_PLC_Raw).l
; ---------------------------------------------------------------------------
PLC_65BFC:	dc.w 0

		dc.l ArtNem_GrayButton
		dc.w $8AC0
; ---------------------------------------------------------------------------

loc_65C04:

		move.w	($FFFFFAA4).w,d0
		beq.s	loc_65C3A
		movea.w	d0,a1
		lea	word_65C48(pc),a2
		jsr	(Check_InMyRange).l
		beq.s	loc_65C3A

loc_65C18:
		move.l	#loc_65C50,(a0)
		move.b	#1,$22(a0)
		st	($FFFFFAA9).w
		clr.w	$48(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	off_65C40(pc,d0.w),d0
		jsr	off_65C40(pc,d0.w)

loc_65C3A:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
off_65C40:	dc.w loc_65C56-off_65C40

		dc.w loc_65C72-off_65C40
		dc.w loc_65C78-off_65C40
		dc.w loc_65CAC-off_65C40
word_65C48:	dc.w  $FFE8,   $30, $FFE8,   $30

; ---------------------------------------------------------------------------

loc_65C50:
		jmp	(Sprite_CheckDelete).l
; ---------------------------------------------------------------------------

loc_65C56:
		clr.b	($FFFFF7CA).w
		move.w	#$1000,d0
		move.w	d0,($FFFFFA98).w
		move.w	d0,($FFFFEE12).w
		lea	(Child6_IncLevY).l,a2

loc_65C6C:
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_65C72:
		st	($FFFFF7E8).w
		rts
; ---------------------------------------------------------------------------

loc_65C78:
		move.w	#$14,($FFFFEECC).w
		move.w	($FFFFEE7C).w,d0
		addi.w	#$100,d0
		move.w	d0,($FFFFF648).w
		move.w	#$350,($FFFFF64A).w
		st	($FFFFFAA3).w
		moveq	#$57,d0
		jsr	(Play_Sound_2).l
		jsr	(Create_New_Sprite).l
		bne.s	locret_65CAA
		move.l	#loc_62480,(a1)

locret_65CAA:
		rts
; ---------------------------------------------------------------------------

loc_65CAC:
		move.w	#$14,($FFFFEECC).w
		movea.w	($FFFF8048).w,a1
		lea	$8E(a1),a1
		move.w	($FFFF8000).w,d0
		move.b	#$14,(a1)
		adda.w	d0,a1
		move.b	#$F,(a1)
		adda.w	d0,a1
		move.b	#$F,(a1)
		adda.w	d0,a1
		move.b	#-$78,(a1)
		jsr	(Create_New_Sprite).l
		bne.s	loc_65CF4
		move.l	#Obj_48_1,(a1)
		move.w	#$4740,$10(a1)
		move.w	#$828,$14(a1)
		move.b	#$4C,$2C(a1)

loc_65CF4:
		jsr	(Create_New_Sprite).l
		bne.s	locret_65D14
		move.l	#Obj_48_1,(a1)
		move.w	#$4740,$10(a1)
		move.w	#$A28,$14(a1)
		move.b	#$20,$2C(a1)

locret_65D14:
		rts
; ---------------------------------------------------------------------------

Obj_88:

		jsr	(Obj_WaitOffscreen).l
		move.l	#loc_65D46,(a0)
		jsr	(Create_New_Sprite3).l
		bne.s	loc_65D46
		move.l	#Obj_CorkFloor,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	#1,$2C(a1)
		move.w	a1,$44(a0)

loc_65D46:

		movea.w	$44(a0),a1
		cmpi.l	#loc_2A5F8,(a1)
		beq.s	loc_65D58
		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_65D58:
		tst.b	($FFFFFAA2).w
		bne.s	loc_65D68
		st	($FFFFFAA2).w
		move.w	#$958,($FFFFF64A).w

loc_65D68:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_89:

		lea	ObjDat3_66402(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_65D8C,(a0)
		addq.w	#4,$14(a0)
		lea	PLC_65BFC(pc),a1
		jmp	(Load_PLC_Raw).l
; ---------------------------------------------------------------------------

loc_65D8C:
		bsr.w	sub_65DEC
		move.b	#0,$22(a0)
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	loc_65DD0
		move.b	#1,$22(a0)
		tst.b	($FFFFFAA3).w
		beq.s	loc_65DD0
		clr.b	($FFFFFAA3).w
		move.w	#$A58,($FFFFF64A).w
		moveq	#$57,d0
		jsr	(Play_Sound_2).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_65DD0
		move.l	#loc_62480,(a1)
		st	$2C(a1)

loc_65DD0:

		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_65DD6:

		jsr	(Create_New_Sprite).l
		bne.s	locret_65DEA
		move.l	#Obj_Song_Fade_Transition,(a1)
		move.b	#$1F,$2C(a1)

locret_65DEA:
		rts
; End of function sub_65DD6


; =============== S U B R O U T I N E =======================================


sub_65DEC:

		move.w	#$1B,d1
		move.w	#4,d2
		move.w	#5,d3
		move.w	$10(a0),d4
		jmp	(SolidObjectFull).l
; End of function sub_65DEC


; =============== S U B R O U T I N E =======================================


sub_65E02:

		jsr	(Random_Number).l
		andi.w	#$1FF,d0
		addi.w	#$100,d0
		neg.w	d0
		move.w	d0,$1A(a0)
		swap	d0
		move.w	#$100,d1
		btst	#2,($FFFFFAB8).w
		bne.s	loc_65E3E
		bclr	#0,4(a0)
		move.w	$10(a0),d2
		cmp.w	$3A(a0),d2
		bcs.s	loc_65E46
		cmp.w	$3C(a0),d2
		bhi.s	loc_65E3E
		tst.w	d0
		bpl.s	loc_65E46

loc_65E3E:

		neg.w	d1
		bset	#0,4(a0)

loc_65E46:

		move.w	d1,$18(a0)
		rts
; End of function sub_65E02


; =============== S U B R O U T I N E =======================================


sub_65E4C:

		move.w	#$1B,d1
		move.w	#$20,d2
		move.w	#$20,d3
		move.w	$10(a0),d4
		jmp	(SolidObjectFull).l
; End of function sub_65E4C


; =============== S U B R O U T I N E =======================================


sub_65E62:
		lea	($FFFFB000).w,a1
		bsr.w	sub_65E72
		lea	($FFFFB04A).w,a1
		tst.l	(a1)
		beq.s	locret_65EAE
; End of function sub_65E62


; =============== S U B R O U T I N E =======================================


sub_65E72:
		move.b	#5,$20(a1)
		cmpi.b	#$C,$23(a0)
		bcs.s	locret_65EAE
		move.b	#-$7D,$2E(a1)
		move.b	#0,$20(a1)
		bset	#1,4(a1)
		moveq	#0,d0
		btst	#1,($FFFFFE0F).w
		beq.s	loc_65E9E
		moveq	#2,d0

loc_65E9E:
		add.b	$38(a1),d0
		move.b	RawAni_65EB0(pc,d0.w),$22(a1)
		jsr	(Player_Load_PLC2).l

locret_65EAE:
		rts
; End of function sub_65E72

; ---------------------------------------------------------------------------
RawAni_65EB0:	dc.b  $B4, $A7,	$B5, $A8

; =============== S U B R O U T I N E =======================================


sub_65EB4:

		subq.w	#1,$2E(a0)
		bpl.s	locret_65ED2
		move.w	$3E(a0),$2E(a0)
		jsr	(Create_New_Sprite).l
		bne.s	locret_65ED2
		move.l	#loc_63324,(a1)
		move.w	a0,$46(a1)

locret_65ED2:

		rts
; End of function sub_65EB4


; =============== S U B R O U T I N E =======================================


sub_65ED4:

		subq.b	#1,$24(a0)
		bpl.s	locret_65EFC
		move.b	#4,$24(a0)
		move.b	$23(a0),d0
		addq.b	#1,d0
		move.b	d0,$23(a0)
		andi.b	#3,d0
		move.b	4(a0),d1
		andi.b	#-4,d1
		or.b	d0,d1
		move.b	d1,4(a0)

locret_65EFC:
		rts
; End of function sub_65ED4


; =============== S U B R O U T I N E =======================================


sub_65EFE:

		lea	($FFFFB000).w,a1
		moveq	#0,d2
		moveq	#$3C,d3
		moveq	#-$73,d4
		bsr.w	sub_65F84
		lea	($FFFFB04A).w,a1
		moveq	#1,d2
		moveq	#$3D,d3
		moveq	#-$76,d4
		bsr.w	sub_65F84
		lea	($FFFFB000).w,a1
		moveq	#0,d2
		moveq	#$3C,d3
		bsr.w	sub_65F2E
		lea	($FFFFB04A).w,a1
		moveq	#1,d2
		moveq	#$3D,d3
; End of function sub_65EFE


; =============== S U B R O U T I N E =======================================


sub_65F2E:
		btst	d2,$38(a0)
		beq.w	locret_65FD4
		subq.b	#1,$24(a1)
		bpl.s	loc_65F5C
		move.b	#8,$24(a1)
		move.b	$23(a1),d0
		addq.b	#1,$23(a1)
		andi.b	#3,d0
		move.b	4(a1),d1
		andi.b	#-4,d1
		or.b	d0,d1
		move.b	d1,4(a1)

loc_65F5C:
		move.b	(a0,d3.w),d0
		addq.b	#2,(a0,d3.w)
		jsr	(GetSineCosine).l
		asr.w	#3,d0
		asr.w	#3,d1
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		add.w	d0,d2
		add.w	d1,d3
		move.w	d2,$10(a1)
		move.w	d3,$14(a1)
		rts
; End of function sub_65F2E


; =============== S U B R O U T I N E =======================================


sub_65F84:

		btst	d2,$38(a0)
		bne.s	locret_65FD4
		lea	word_65FD6(pc),a2
		jsr	(Check_InMyRange).l
		beq.s	locret_65FD4
		bset	d2,$38(a0)
		move.w	d3,-(sp)
		clr.b	($FFFFEE0A).w
		clr.b	($FFFFFE1E).w
		move.b	#-$7D,$2E(a1)
		move.b	d4,$22(a1)
		clr.b	$20(a1)
		clr.b	$24(a1)
		clr.b	$23(a1)
		move.l	a1,-(sp)
		jsr	(Player_Load_PLC2).l
		movea.l	(sp)+,a1
		movea.l	a1,a2
		movea.l	a0,a1
		jsr	(sub_8622C).l
		move.w	(sp)+,d3
		move.b	d0,(a0,d3.w)

locret_65FD4:
		rts
; End of function sub_65F84

; ---------------------------------------------------------------------------
word_65FD6:	dc.w  $FFE0,   $40, $FFE0,   $40

; =============== S U B R O U T I N E =======================================


sub_65FDE:
		btst	#3,$38(a0)
		bne.w	locret_6206C
		lea	($FFFFB000).w,a1
		jsr	(Find_OtherObject).l
		cmpi.w	#$20,d3
		bcc.w	locret_6206C
		subi.w	#$30,d2
		cmpi.w	#$20,d2
		bcc.w	locret_6206C
		tst.w	d0
		beq.w	locret_6206C
		btst	#0,4(a1)
		beq.w	locret_6206C
		cmpi.b	#8,$20(a1)
		bne.w	locret_6206C
		lea	byte_6672A(pc),a1
		jmp	(Set_Raw_Animation).l
; End of function sub_65FDE


; =============== S U B R O U T I N E =======================================


MoveSprite_SSZBGAdjust:

		move.w	($FFFFFA84).w,d0
		add.w	d0,$10(a0)
		move.w	$40(a0),d0
		ext.l	d0
		lsl.l	#8,d0
		move.l	$1A(a0),d1
		add.l	d0,d1
		move.l	d1,$1A(a0)
		swap	d1
		move.w	($FFFFEE9C).w,d0
		asr.w	#2,d0
		sub.w	d0,d1
		move.w	d1,$14(a0)
		rts
; End of function MoveSprite_SSZBGAdjust


; =============== S U B R O U T I N E =======================================


sub_66054:
		move.b	($FFFFFE0F).w,d0
		andi.w	#$1F,d0
		bne.w	locret_6206C
		moveq	#-$60,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_665F0(pc),a2
		jmp	(CreateChild6_Simple).l
; End of function sub_66054

; ---------------------------------------------------------------------------

loc_66072:
		move.w	($FFFFEE78).w,$3A(a0)
		move.l	#loc_6607E,(a0)

loc_6607E:
		move.w	($FFFFEE78).w,d0
		move.w	$3A(a0),d1
		move.w	d0,$3A(a0)
		sub.w	d1,d0
		asr.w	#1,d0
		move.w	d0,($FFFFFA84).w
		rts

; =============== S U B R O U T I N E =======================================


sub_66094:

		bset	#0,4(a0)
		tst.w	d0
		beq.s	locret_660A4
		bclr	#0,4(a0)

locret_660A4:
		rts
; End of function sub_66094

; ---------------------------------------------------------------------------

loc_660A6:

		tst.b	$34(a1)
		bne.w	locret_6206C

loc_660AE:
		btst	#1,$2B(a1)
		bne.w	locret_6206C
		jmp	(HurtSonic_Directly).l
; ---------------------------------------------------------------------------

loc_660BE:

		lea	word_66152(pc),a1
		jsr	(Check_PlayerInRange).l
		tst.l	d0
		beq.w	locret_6206C
		tst.w	d0
		beq.s	loc_660DA
		move.l	d0,-(sp)
		bsr.w	sub_660E2
		move.l	(sp)+,d0

loc_660DA:
		swap	d0
		tst.w	d0
		beq.w	locret_6206C

; =============== S U B R O U T I N E =======================================


sub_660E2:
		btst	#4,$38(a0)
		bne.w	locret_6206C
		movea.w	d0,a1
		btst	#0,4(a0)
		sne	d4
		move.w	$10(a1),d1
		cmp.w	$10(a0),d1
		bcc.s	loc_66102
		not.b	d4

loc_66102:
		tst.b	d4
		bne.s	loc_66134
		move.w	$14(a1),d2
		sub.w	$14(a0),d2
		bpl.s	loc_66112
		neg.w	d2

loc_66112:
		cmpi.w	#$10,d2
		bcc.s	loc_66134
		cmpi.b	#2,$20(a1)
		beq.s	loc_6612A
		btst	#1,$2B(a1)
		bne.w	loc_6429E

loc_6612A:
		movea.l	(a3),a4
		jmp	(a4)
; ---------------------------------------------------------------------------
		movea.l	4(a3),a4
		jmp	(a4)
; ---------------------------------------------------------------------------

loc_66134:

		cmpi.b	#2,$20(a1)
		beq.s	loc_66146
		btst	#1,$2B(a1)
		bne.w	loc_6429E

loc_66146:
		movea.l	8(a3),a4
		jmp	(a4)
; End of function sub_660E2

; ---------------------------------------------------------------------------
		movea.l	$C(a3),a4
		jmp	(a4)
; ---------------------------------------------------------------------------
word_66152:	dc.w  $FFE8,   $30, $FFE8,   $30

; =============== S U B R O U T I N E =======================================


sub_6615A:

		tst.w	$18(a0)
		beq.s	locret_66188
		bmi.s	loc_66176
		move.w	($FFFFEE78).w,d0
		addi.w	#$130,d0
		cmp.w	$10(a0),d0
		bhi.s	locret_66188
		clr.w	$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_66176:
		move.w	($FFFFEE78).w,d0
		addi.w	#$10,d0
		cmp.w	$10(a0),d0
		bcs.s	locret_66188
		clr.w	$18(a0)

locret_66188:

		rts
; End of function sub_6615A

; ---------------------------------------------------------------------------

Knuckles_Load_PLC_6618A:
		moveq	#0,d0
		move.b	$22(a0),d0
		cmp.b	$3A(a0),d0
		beq.s	locret_661DE
		move.b	d0,$3A(a0)
		lea	(PLC_Knuckles).l,a2
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d5
		subq.w	#1,d5
		bmi.s	locret_661DE
		move.w	#$D400,d4
		move.l	#ArtUnc_Knux,d6

loc_661B6:
		moveq	#0,d1
		move.w	(a2)+,d1
		move.w	d1,d3
		lsr.w	#8,d3
		andi.w	#$F0,d3
		addi.w	#$10,d3
		andi.w	#$FFF,d1
		lsl.l	#5,d1
		add.l	d6,d1
		move.w	d4,d2
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		dbf	d5,loc_661B6

locret_661DE:

		rts

; =============== S U B R O U T I N E =======================================


Knuckles_Load_PLC_661E0:

		moveq	#0,d0
		move.b	$22(a0),d0
		cmp.b	$3A(a0),d0
		beq.s	locret_66234
		move.b	d0,$3A(a0)
		lea	(PLC_Knuckles).l,a2
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d5
		subq.w	#1,d5
		bmi.s	locret_66234
		move.w	#$9B40,d4
		move.l	#ArtUnc_Knux,d6

loc_6620C:
		moveq	#0,d1
		move.w	(a2)+,d1
		move.w	d1,d3
		lsr.w	#8,d3
		andi.w	#$F0,d3
		addi.w	#$10,d3
		andi.w	#$FFF,d1
		lsl.l	#5,d1
		add.l	d6,d1
		move.w	d4,d2
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		dbf	d5,loc_6620C

locret_66234:
					; Knuckles_Load_PLC_661E0+20j
		rts
; End of function Knuckles_Load_PLC_661E0


; =============== S U B R O U T I N E =======================================


sub_66236:
		move.l	#ArtUnc_DashDust,d6
		moveq	#0,d0
		move.b	$22(a0),d0
		cmp.b	$3A(a0),d0
		beq.s	locret_6628A
		move.b	d0,$3A(a0)
		lea	(DPLC_DashSplashDrown).l,a2
		add.w	d0,d0
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d5
		subq.w	#1,d5
		bmi.s	locret_6628A
		move.w	#-$6000,d4

loc_66262:
		moveq	#0,d1
		move.w	(a2)+,d1
		move.w	d1,d3
		lsr.w	#8,d3
		andi.w	#$F0,d3
		addi.w	#$10,d3
		andi.w	#$FFF,d1
		lsl.l	#5,d1
		add.l	d6,d1
		move.w	d4,d2
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l
		dbf	d5,loc_66262

locret_6628A:

		rts
; End of function sub_66236


; =============== S U B R O U T I N E =======================================


sub_6628C:

		move.b	$40(a0),d0
		add.b	d0,$3C(a0)
		subq.b	#1,$39(a0)
		bpl.s	locret_662A4
		move.b	$30(a0),$39(a0)
		neg.b	$40(a0)

locret_662A4:
		rts
; End of function sub_6628C


; =============== S U B R O U T I N E =======================================


sub_662A6:

		moveq	#0,d0
		move.b	$3C(a0),d0
		addi.b	#$10,d0
		rol.b	#3,d0
		andi.b	#7,d0
		addi.b	#$13,d0
		move.b	d0,$22(a0)
		rts
; End of function sub_662A6

; ---------------------------------------------------------------------------

loc_662C0:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,d3
		lea	byte_66308(pc,d0.w),a1
		move.b	(a1)+,d1
		ext.w	d1
		add.w	d1,$10(a0)
		move.b	(a1)+,d2
		ext.w	d2
		add.w	d2,$14(a0)
		lsr.w	#1,d0
		addq.b	#7,d0
		move.b	d0,$22(a0)
		move.w	#-$200,d0
		lsl.w	#4,d3
		neg.w	d3
		add.w	d3,d0
		move.w	d0,$18(a0)
		lsl.w	#1,d3
		andi.w	#$180,d3
		addi.w	#$80,d3
		tst.w	d2
		bpl.s	loc_66302
		neg.w	d3

loc_66302:
		move.w	d3,$1A(a0)
		rts
; ---------------------------------------------------------------------------
byte_66308:	dc.b	8, $F8
		dc.b	8,   0
		dc.b	8, $F0
		dc.b	8,   8
		dc.b	8, $E8
		dc.b	8, $10
		dc.b	8, $E0
		dc.b	8, $18
		dc.b	0, $F8
		dc.b	0,   0
		dc.b	0, $F0
		dc.b	0,   8
		dc.b	0, $E8
		dc.b	0, $10
		dc.b	0, $E0
		dc.b	0, $18
		dc.b  $F8, $F8
		dc.b  $F8,   0
		dc.b  $F8, $F0
		dc.b  $F8,   8
		dc.b  $F8, $E8
		dc.b  $F8, $10
		dc.b  $F8, $E0
		dc.b  $F8, $18
		dc.b  $F0, $F8
		dc.b  $F0,   0
		dc.b  $F0, $F0
		dc.b  $F0,   8
		dc.b  $F0, $E8
		dc.b  $F0, $10
		dc.b  $F0, $E0
		dc.b  $F0, $18

; =============== S U B R O U T I N E =======================================


sub_66348:
		btst	#6,$2A(a0)
		beq.s	locret_66370
		tst.b	$20(a0)
		bne.s	loc_66364
		move.b	#$30,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l

loc_66364:
		subq.b	#1,$20(a0)
		bne.s	locret_66370
		bclr	#6,$2A(a0)

locret_66370:

		rts
; End of function sub_66348


; =============== S U B R O U T I N E =======================================


sub_66372:

		tst.b	$28(a0)
		bne.s	locret_663B8
		tst.b	$20(a0)
		bne.s	loc_66392
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		bset	#6,$2A(a0)

loc_66392:
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_663A0
		addi.w	#4,d0

loc_663A0:
		jsr	(sub_7A614).l
		subq.b	#1,$20(a0)
		bne.s	locret_663B8
		bclr	#6,$2A(a0)
		move.b	$25(a0),$28(a0)

locret_663B8:

		rts
; End of function sub_66372

; ---------------------------------------------------------------------------
ObjDat4_663BA:	dc.w 0

		dc.w $A4DA
		dc.w $2E
		dc.w 0
		dc.l Map_CutsceneKnux
		dc.w $180
		dc.b $1C
		dc.b $18
		dc.b $16
		dc.b 0
ObjDat4_663CC:	dc.w 0
		dc.w $A4DA
		dc.w $2E
		dc.w 0
		dc.l Map_MHZKnuxPullSwitch
		dc.w $180
		dc.b $1C
		dc.b $18
		dc.b 3
		dc.b 0
ObjDat4_663DE:	dc.w 0
		dc.w $6A0
		dc.w $2E
		dc.w 0
		dc.l Map_KnuxIntroLay
		dc.w $180
		dc.w $1C18
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b $A4
		dc.b $DA
		dc.b 0
		dc.b $2E
		dc.b 0
		dc.b 0
		dc.l Map_HPZKnucklesGrab
		dc.b 1
		dc.b $80
		dc.b $1C
		dc.b $18
		dc.b 2
		dc.b 0
ObjDat3_66402:	dc.l Map_Button

		dc.w $8456
		dc.w $100
		dc.b $10
		dc.b 8
		dc.b 0
		dc.b 0
ObjDat3_6640E:	dc.l Map_LBZKnuxBomb
		dc.w $A4D6
		dc.w $80
		dc.b 8
		dc.b 8
		dc.b 0
		dc.b 0
ObjDat3_6641A:	dc.l Map_LBZKnuxPillar
		dc.w $45A0
		dc.w $280
		dc.b $10
		dc.b $10
		dc.b 0
		dc.b 0
ObjDat3_66426:	dc.l Map_LBZKnuxPillar
		dc.w $45A0
		dc.w $280
		dc.b $10
		dc.b $80
		dc.b 1
		dc.b 0
ObjDat3_66432:	dc.l Map_AIZCorkFloor
		dc.w $4001
		dc.w $180
		dc.b $10
		dc.b $18
		dc.b 0
		dc.b 0
ObjDat3_6643E:	dc.l Map_MHZKnuxPeer
		dc.w $2500
		dc.w $180
		dc.b $10
		dc.b $10
		dc.b 4
		dc.b 0
ObjDat3_6644A:	dc.l Map_Button
		dc.w $341
		dc.w $100
		dc.b $80
		dc.b $80
		dc.b 0
		dc.b 0
ObjDat3_66456:	dc.l Map_MHZKnuxSwitch
		dc.w $A528
		dc.w $300
		dc.b $10
		dc.b $10
		dc.b 0
		dc.b 0
ObjDat3_66462:	dc.l Map_MHZKnuxDoor
		dc.w $63C9
		dc.w $80
		dc.b $10
		dc.b $20
		dc.b 0
		dc.b 0
ObjDat3_6646E:	dc.l Map_MHZKnuxLeaves

		dc.w $E368
		dc.w 0
		dc.b 4
		dc.b 4
		dc.b 0
		dc.b 0
ObjDat3_6647A:	dc.l Map_LRZKnuxBoulder
		dc.w $4500
		dc.w $200
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b 0
ObjDat3_66486:	dc.l Map_KnuxIntroBomb
		dc.w $252E
		dc.w $180
		dc.b $C
		dc.b $10
		dc.b 0
		dc.b 0
word_66492:	dc.w $100
		dc.b 8
		dc.b 8
		dc.b 1
		dc.b 0
word_66498:	dc.w $100
		dc.b 8
		dc.b 8
		dc.b 5
		dc.b 0
ObjDat3_6649E:	dc.l Map_Button
		dc.w $48E
		dc.w $180
		dc.b $10
		dc.b 8
		dc.b 1
		dc.b 0
ObjDat3_664AA:	dc.l Map_SSZDeathEggSmall
		dc.w $6500
		dc.w $380
		dc.b $3C
		dc.b $30
		dc.b 0
		dc.b 0
ObjDat4_664B6:	dc.w 0
		dc.w $64C9
		dc.w $10
		dc.w 2
		dc.l Map_SSZDeathEggCloud
		dc.w $280
		dc.w $4010
		dc.b 0
		dc.b 0
ObjDat3_664C8:	dc.l Map_SpriteMask
		dc.w 0
		dc.w $200
		dc.b $40
		dc.b $30
		dc.b $C
		dc.b 0
word_664D4:	dc.w $300
		dc.b 4
		dc.b $1C
		dc.b 1
		dc.b 0
word_664DA:	dc.w $500
		dc.b 2
		dc.b $80
		dc.b 8
		dc.b 8
		dc.b 4
		dc.b 0
ObjDat3_664E2:	dc.l Map_DashDust
		dc.w $500
		dc.w $80
		dc.b $10
		dc.b $10
		dc.b $A
		dc.b 0
ObjDat3_664EE:	dc.l Map_RobotnikShip

		dc.w $852E
		dc.w 0
		dc.b $1C
		dc.b $20
		dc.b $A
		dc.b 0
ObjDat3_664FA:	dc.l Map_KnuxFinalBossCrane

		dc.w $84A7
		dc.w $180
		dc.b $14
		dc.b $14
		dc.b 0
		dc.b 0
word_66506:	dc.w $280
		dc.b $10
		dc.b $C
		dc.b 1
		dc.b 0
word_6650C:	dc.w $180
		dc.b 4
		dc.b $80
		dc.b 4
		dc.b 0
ObjDat3_66512:	dc.l Map_HPZEmeraldMisc
		dc.w $83B5
		dc.w 0
		dc.b $C
		dc.b $C
		dc.b $12
		dc.b 0
ObjDat3_6651E:	dc.l Map_HPZEmeraldMisc
		dc.w $43B5
		dc.w $180
		dc.b 4
		dc.b 8
		dc.b $18
		dc.b 0
ObjDat3_6652A:	dc.l Map_KnuxFinalBossCrane
		dc.w $4A7
		dc.w 0
		dc.b 8
		dc.b 8
		dc.b $12
		dc.b 0
word_66536:	dc.w 0
		dc.b 8
		dc.b 8
		dc.b $12
		dc.b 0
ObjDat3_6653C:	dc.l Map_LRZ3Platform
		dc.w $C001
		dc.w 0
		dc.b $10
		dc.b $20
		dc.b 6
		dc.b 0
word_66548:	dc.w 0
		dc.b 4
		dc.b 4
		dc.b 7
		dc.b 0
ObjDat3_6654E:	dc.l Map_HPZKnuxDizzyStars
		dc.w $2500
		dc.w $180
		dc.b $C
		dc.b 4
		dc.b 1
		dc.b 0
ChildObjDat_6655A:dc.w 0
		dc.l loc_620EA
ChildObjDat_66560:dc.w 0
		dc.l loc_62458
		dc.w $E094
ChildObjDat_66568:dc.w 2
		dc.l Obj_DecLevStartYGradual
		dc.w 0
		dc.l Obj_DecLevStartXGradual
		dc.w 0
		dc.l Obj_IncLevEndXGradual
		dc.w 0
ChildObjDat_6657C:dc.w 0
		dc.l loc_627C6
		dc.w $C000
ChildObjDat_66584:dc.w 0
		dc.l loc_6282A
		dc.w $F8F0
ChildObjDat_6658C:dc.w 3
		dc.l loc_6285A
ChildObjDat_66592:dc.w 3
		dc.l loc_629CE
		dc.b 2
		dc.b $24
ChildObjDat_6659A:dc.w 0
		dc.l loc_61F60
		dc.w $18
ChildObjDat_665A2:dc.w 0
		dc.l Obj_83
		dc.w $C
ChildObjDat_665AA:dc.w 0
		dc.l Obj_CutsceneKnuckles
ChildObjDat_665B0:dc.w 0
		dc.l loc_62F72
ChildObjDat_665B6:dc.w 0
		dc.l loc_6300C
ChildObjDat_665BC:dc.w 0

		dc.l loc_632CA
		dc.w $F800
ChildObjDat_665C4:dc.w 6
		dc.l loc_65B0E
		dc.w 0
		dc.l loc_65A8C
		dc.w $CD
		dc.l loc_65B42
		dc.w $E01D
		dc.l loc_65B42
		dc.w $F01D
		dc.l loc_65B42
		dc.w $81D
		dc.l loc_65B42
		dc.w $101D
		dc.l loc_65B42
		dc.w $281D
ChildObjDat_665F0:dc.w 0
		dc.l loc_65B70
ChildObjDat_665F6:dc.w 0
		dc.l loc_659CC
ChildObjDat_665FC:dc.w 0
		dc.l loc_64C24
ChildObjDat_66602:dc.w $F
		dc.l loc_652A2
ChildObjDat_66608:dc.w 0
		dc.l loc_6502E
		dc.w $23
ChildObjDat_66610:dc.w 1

		dc.l loc_65138
		dc.w 0
		dc.l loc_6515E
		dc.w $D0
ChildObjDat_6661E:dc.w $E
		dc.l loc_6518A
ChildSpriteDat_66624:dc.w 1
		dc.l loc_6531E
		dc.w $8FC
ChildObjDat3_6662C:dc.w	9
		dc.l loc_65376
ChildObjDat3_66632:dc.w	9
		dc.l loc_65360
ChildObjDat_66638:dc.w 4
		dc.l loc_65226
ChildObjDat_6663E:dc.w 0
		dc.l loc_655B2
ChildObjDat_66644:dc.w 0

		dc.l loc_6563A
ChildObjDat_6664A:dc.w $1F
		dc.l loc_65602
ChildObjDat_66650:dc.w 9
		dc.l loc_6395C
ChildObjDat_66656:dc.w 7
		dc.l loc_63694
ChildObjDat_6665C:dc.w 0
		dc.l loc_638DC
		dc.w $EC
ChildObjDat_66664:dc.w 0
		dc.l loc_63916
DPLCPtr_6666A:	dc.l ArtUnc_CutsceneKnux

		dc.l DPLC_CutsceneKnux
DPLCPtr_66672:	dc.l ArtUnc_MHZKnuxPress
		dc.l DPLC_MHZKnuxPress
DPLCPtr_6667A:	dc.l ArtUnc_KnuxIntroLay
		dc.l DPLC_KnuxIntroLay
DPLCPtr_66682:	dc.l ArtUnc_HPZKnucklesGrab

		dc.l DPLC_HPZKnucklesGrab
DPLCPtr_6668A:	dc.l ArtUnc_SSZKnucklesTired

		dc.l DPLC_SSZKnucklesTired
DPLCPtr_66692:	dc.l ArtUnc_SSZDeathEggCloud
		dc.l DPLC_SSZDeathEggCloud
byte_6669A:	dc.b 7
		dc.b 1
		dc.b 2
		dc.b 3
		dc.b $FC
byte_6669F:	dc.b 4

		dc.b $A
		dc.b $B
		dc.b $C
		dc.b $D
		dc.b $E
		dc.b $F
		dc.b $10
		dc.b $11
		dc.b $FC
word_666A9:	dc.w $112

		dc.w $1314
		dc.w $15FC
word_666AF:	dc.w $108

		dc.w $408
		dc.w $508
		dc.w $608
		dc.w $7FC
word_666B9:	dc.w $71C
		dc.w $1C1D
		dc.w $F806
word_666BF:	dc.w $71E
		dc.w $1FFC
byte_666C3:	dc.b  $16,   7
		dc.b  $16,   7
		dc.b  $17,   7
		dc.b  $18,   7
		dc.b  $19, $13
		dc.b  $1A,   7
		dc.b  $1B,   0
		dc.b  $F4
byte_666D2:	dc.b  $20,   5
		dc.b  $21,   5
		dc.b  $22, $14
		dc.b  $23,   3
		dc.b  $24,  $F
		dc.b  $21,   5
		dc.b  $20,   5
		dc.b  $F4
byte_666E1:	dc.b	0,   4
		dc.b	0,   9
		dc.b	1, $1D
		dc.b	0,   4
		dc.b	2,   4
		dc.b	3, $1D
		dc.b	2,   4
		dc.b	0,   4
		dc.b	1, $1D
		dc.b	0,   4
		dc.b  $F4
byte_666F6:	dc.b	3,   7
		dc.b	3, $1F
		dc.b	0,   7
		dc.b	1, $1F
		dc.b	2,   7
		dc.b	1, $7F
		dc.b	2,   7
		dc.b	1, $1F
		dc.b	2,   7
		dc.b	1,  $F
		dc.b	2,   7
		dc.b	1,  $B
		dc.b	2,   7
		dc.b	1,   7
		dc.b	2,   7
		dc.b	1,   7
		dc.b	2,   7
		dc.b  $F4
byte_66719:	dc.b	0,   7
		dc.b	0,   7
		dc.b  $F8,   6
byte_6671F:	dc.b	1,  $B

		dc.b	2,   5
		dc.b	3,  $B
		dc.b	2,  $B
		dc.b	1,  $B
		dc.b  $FC
byte_6672A:	dc.b	4,   7
		dc.b	4,   7
		dc.b	5,   7
		dc.b	6, $1F
		dc.b  $F8,  $A
		dc.b	5,  $F
		dc.b	6, $1F
		dc.b  $FC
byte_66739:	dc.b	0,   5
		dc.b	0,   5
		dc.b	1,   7
		dc.b	2,   9
		dc.b	3,   9
		dc.b	4,  $B
		dc.b	5,  $C
		dc.b	6,  $D
		dc.b	7,  $E
		dc.b	8,  $F
		dc.b	9, $13
		dc.b   $A, $1D
		dc.b   $B, $27
		dc.b   $C, $63
		dc.b  $F8, $1E
		dc.b   $B, $3B
		dc.b   $A, $63
		dc.b   $B, $3B
		dc.b   $C, $63
		dc.b  $FC
byte_66760:	dc.b	6,   0
		dc.b	6, $4D
		dc.b	1, $4D
		dc.b	1, $4D
		dc.b	1, $4D
		dc.b	1, $4D
		dc.b	2,   9
		dc.b	3,   9
		dc.b  $F4
word_66771:	dc.w $D804

		dc.w $D904
		dc.w $DA04
		dc.w $DB04
		dc.w $D804
		dc.w $D904
		dc.w $DA04
		dc.w $DB04
		dc.w $D804
		dc.w $D904
		dc.w $DA04
		dc.w $DB04
		dc.w $D804
		dc.w $D904
		dc.w $DA04
		dc.w $DB04
		dc.w $D804
		dc.w $D904
		dc.w $DA04
		dc.w $DB04
		dc.w $D804
		dc.w $D904
		dc.w $DA04
		dc.w $DB04
		dc.w $DC04
		dc.w $DD04
		dc.w $DC04
		dc.w $DD04
		dc.w $DE0B
		dc.w $FFFC
byte_667AD:	dc.b 4
		dc.b $D8
		dc.b $D9
		dc.b $DA
		dc.b $DB
		dc.b $FF
		dc.b $FC
word_667B4:	dc.w $DA05
		dc.w $9B05
		dc.w $9C0F
		dc.w $FFF4
byte_667BC:	dc.b 1
		dc.b 0
		dc.b $8D
		dc.b $FF
		dc.b $FC
byte_667C1:	dc.b 1

		dc.b $9A
		dc.b $96
		dc.b $9A
		dc.b $97
		dc.b $9A
		dc.b $98
		dc.b $9A
		dc.b $99
		dc.b $FF
		dc.b $FC
byte_667CC:	dc.b 3
		dc.b $DA
		dc.b $DA
		dc.b $9B
		dc.b $9C
		dc.b $9B
		dc.b $FF
		dc.b $F4
word_667D4:	dc.w $C005
		dc.w $CA05
		dc.w $CB7F
		dc.w $CB7F
		dc.w $CB7F
		dc.w $FFFC
byte_667E0:	dc.b 5
		dc.b $CC
		dc.b $9B
		dc.b $9C
		dc.b $9B
		dc.b $FF
		dc.b $F4
byte_667E7:	dc.b 2
		dc.b 3
		dc.b 3
		dc.b 3
		dc.b 4
		dc.b 3
		dc.b 5
		dc.b 3
		dc.b 4
		dc.b $7F
		dc.b 4
		dc.b $1F
		dc.b $FF
		dc.b $F4
byte_667F5:	dc.b 3
		dc.b $DA
		dc.b $DA
		dc.b $9B
		dc.b $9C
		dc.b $FF
		dc.b $F8
		dc.b 8
		dc.b 0
		dc.b $86
		dc.b $87
		dc.b $86
		dc.b $88
		dc.b $86
		dc.b $89
		dc.b $86
		dc.b $8A
		dc.b $86
		dc.b $8B
		dc.b $FF
		dc.b $FC
byte_6680A:	dc.b 2

		dc.b 3
		dc.b 3
		dc.b 3
		dc.b 4
		dc.b 3
		dc.b 5
		dc.b 3
		dc.b 4
		dc.b $3F
		dc.b $FF
		dc.b $F4
		dc.b 2
		dc.b 3
		dc.b 3
		dc.b 3
		dc.b 4
		dc.b 3
		dc.b 5
		dc.b 3
		dc.b 4
		dc.b $7F
		dc.b 6
		dc.b 3
		dc.b $FF
		dc.b $F4
byte_66824:	dc.b 4

		dc.b 7
		dc.b 8
		dc.b 1
		dc.b 2
		dc.b 3
		dc.b 4
		dc.b 5
		dc.b 6
		dc.b $FF
		dc.b $FC
byte_6682F:	dc.b 3

		dc.b 7
		dc.b 8
		dc.b 1
		dc.b 2
		dc.b 3
		dc.b 4
		dc.b 5
		dc.b 6
		dc.b $FF
		dc.b $FC
byte_6683A:	dc.b 1
		dc.b $A
		dc.b $B
		dc.b $C
		dc.b $D
		dc.b $E
		dc.b $F
		dc.b $10
		dc.b $FC
byte_66843:	dc.b 1
		dc.b $12
		dc.b $12
		dc.b $13
		dc.b $14
		dc.b $15
		dc.b $F4
byte_6684A:	dc.b 3
		dc.b $16
		dc.b $16
		dc.b $17
		dc.b $F4
byte_6684F:	dc.b 6
		dc.b $3F
		dc.b 6
		dc.b $3F
		dc.b 7
		dc.b 2
		dc.b 8
		dc.b 2
		dc.b 7
		dc.b 2
		dc.b 6
		dc.b 2
		dc.b 7
		dc.b 2
		dc.b 8
		dc.b 2
		dc.b 7
		dc.b 2
		dc.b 6
		dc.b 2
		dc.b 7
		dc.b 2
		dc.b 8
		dc.b 2
		dc.b 7
		dc.b 2
		dc.b 6
		dc.b 2
		dc.b 7
		dc.b 2
		dc.b 8
		dc.b 2
		dc.b 7
		dc.b 2
		dc.b 6
		dc.b $5F
		dc.b $FF
		dc.b $F4
byte_66875:	dc.b 5
		dc.b 1
		dc.b 2
		dc.b 3
		dc.b 4
		dc.b $FC
byte_6687B:	dc.b 7
		dc.b 9
		dc.b $A
		dc.b $FF
		dc.b $FC
byte_66880:	dc.b 5
		dc.b $B
		dc.b $C
		dc.b $FF
		dc.b $FC
byte_66885:	dc.b $56
		dc.b 7
		dc.b $56
		dc.b $1F
		dc.b $DE
		dc.b 0
		dc.b $DE
		dc.b $F
		dc.b $56
		dc.b $3F
		dc.b $FF
		dc.b $F4
word_66891:	dc.w $D804
		dc.w $D904
		dc.w $DA04
		dc.w $DB04
		dc.w $DC04
		dc.w $DC04
		dc.w $DD04
		dc.w $DC04
		dc.w $DD04
		dc.w $DE00
		dc.w $FFF4
word_668A7:	dc.w $DE07

		dc.w $DE07
		dc.w $5600
		dc.w $FFF4
word_668AF:	dc.w $E59
		dc.w $E77
		dc.w $F07
		dc.w $101D
		dc.w $1107
		dc.w $1207
		dc.w $1107
		dc.w $1207
		dc.w $F07
		dc.w $FFF4
byte_668C3:	dc.b $13
		dc.b 0
		dc.b 1
		dc.b $FC
byte_668C7:	dc.b 4
		dc.b $6F
		dc.b 4
		dc.b $6F
		dc.b 2
		dc.b 7
		dc.b 3
		dc.b $7F
		dc.b $FC
byte_668D0:	dc.b 3
		dc.b 3
		dc.b 3
		dc.b 3
		dc.b 4
		dc.b 3
		dc.b 5
		dc.b 3
		dc.b 4
		dc.b $5F
		dc.b 6
		dc.b $1F
		dc.b 7
		dc.b 2
		dc.b 8
		dc.b 2
		dc.b 7
		dc.b 2
		dc.b 6
		dc.b 2
		dc.b 7
		dc.b 2
		dc.b 8
		dc.b 2
		dc.b 7
		dc.b 2
		dc.b 6
		dc.b $F
		dc.b 9
		dc.b 7
		dc.b $A
		dc.b 7
		dc.b 9
		dc.b 7
		dc.b $A
		dc.b 7
		dc.b 9
		dc.b 7
		dc.b $A
		dc.b 7
		dc.b 9
		dc.b 7
		dc.b $A
		dc.b 7
		dc.b 9
		dc.b 7
		dc.b $A
		dc.b 7
		dc.b 9
		dc.b 7
		dc.b $A
		dc.b 7
		dc.b $F4
byte_66905:	dc.b 3
		dc.b 1
		dc.b 2
		dc.b 3
		dc.b 4
		dc.b $FC
byte_6690B:	dc.b 5
		dc.b 5
		dc.b 5
		dc.b 6
		dc.b 7
		dc.b 8
		dc.b $F4
Pal_CutsceneKnux1:	binclude "General\Sprites\Knuckles\Cutscene\Pal.bin"


Pal_CNZFlash:	binclude "Levels\CNZ\Palettes\Flash.bin"

Pal_KnuxSSZEnd:	binclude "General\Sprites\Knuckles\Palettes\SSZ End.bin"

Pal_HPZ2_A:	binclude "Levels\HPZ\Palettes\2_A.bin"

Pal_HPZ2_B:	binclude "Levels\HPZ\Palettes\2_B.bin"

Pal_SKIntroBomb:	binclude "General\Sprites\Knuckles\Cutscene\Intro Bomb Pal.bin"

Map_MHZKnuxPeer:	include "Levels\MHZ\Misc Object Data\Map - Knuckles Peering.asm"

Map_MHZKnuxDoor:	include "Levels\MHZ\Misc Object Data\Map - Knuckles Switch Door.asm"

Map_MHZKnuxPullSwitch:	include "General\Sprites\Knuckles\Cutscene\Map - MHZ2 Press.asm"

DPLC_MHZKnuxPress:	include "General\Sprites\Knuckles\Cutscene\DPLC - MHZ Press.asm"

Map_MHZKnuxSwitch:	include "Levels\MHZ\Misc Object Data\Map - Act 2 Knuckles Switch.asm"

Map_MHZKnuxLeaves:	include "Levels\MHZ\Misc Object Data\Map - Act 2 Knuckles Leaves.asm"

Map_LRZKnuxBoulder:	include "Levels\LRZ\Misc Object Data\Map - Knuckles Boulder.asm"

Map_SSZKnucklesTired:	include "General\Sprites\Knuckles\Cutscene\Map - SSZ Tired.asm"

DPLC_SSZKnucklesTired:	include "General\Sprites\Knuckles\Cutscene\DPLC - SSZ Tired.asm"

Map_SSZDeathEggSmall:	include "Levels\SSZ\Misc Object Data\Map - Death Egg Small.asm"

Map_SSZDeathEggCloud:	include "General\Sprites\SSZ Death Egg Cloud\Map - SSZ Death Egg Cloud.asm"

DPLC_SSZDeathEggCloud:	include "General\Sprites\SSZ Death Egg Cloud\DPLC - SSZ Death Egg Cloud.asm"

Map_HPZKnucklesGrab:	include "General\Sprites\Knuckles\Cutscene\Map - HPZ Grab.asm"

DPLC_HPZKnucklesGrab:	include "General\Sprites\Knuckles\Cutscene\DPLC - HPZ Grab.asm"

Map_KnuxFinalBossCrane:	include "General\Sprites\Robotnik\Map - Robotnik Ship Crane.asm"

Map_HPZKnuxDizzyStars:	include "Levels\HPZ\Misc Object Data\Map - Knuckles Dizzy Stars.asm"

Map_KnuxIntroLay:	include "General\Sprites\Knuckles\Cutscene\Map - Intro Laying.asm"

DPLC_KnuxIntroLay:	include "General\Sprites\Knuckles\Cutscene\DPLC - Intro Laying.asm"

Map_KnuxIntroBomb:	include "General\Sprites\Knuckles\Cutscene\Map - Intro Bomb.asm"

; ---------------------------------------------------------------------------

Obj_84:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_67490(pc,d0.w),d1
		jsr	off_67490(pc,d1.w)
		jsr	(Sonic_Load_PLC).l
		bsr.w	sub_67A08
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_67490:	dc.w loc_674AC-off_67490

		dc.w loc_67514-off_67490
		dc.w loc_67536-off_67490
		dc.w loc_67560-off_67490
		dc.w loc_67594-off_67490
		dc.w loc_675C0-off_67490
		dc.w loc_67614-off_67490
		dc.w loc_67624-off_67490
		dc.w loc_6764E-off_67490
		dc.w loc_67674-off_67490
		dc.w loc_676AC-off_67490
		dc.w loc_676C6-off_67490
		dc.w loc_676E8-off_67490
		dc.w loc_67704-off_67490
; ---------------------------------------------------------------------------

loc_674AC:
		addq.b	#2,5(a0)
		move.l	#Map_Sonic,$C(a0)
		move.w	#$680,$A(a0)
		move.w	#$280,8(a0)
		move.b	#-$46,$22(a0)
		move.b	#$40,7(a0)
		move.b	#$20,6(a0)
		move.w	#$60,$10(a0)
		move.w	#$30,$14(a0)
		move.w	#$40,$2E(a0)
		move.l	#loc_6751A,$34(a0)
		move.w	#8,$40(a0)
		move.w	#-$16E8,($FFFFEEB6).w
		move.b	#-1,($FFFFF766).w
		lea	($FFFFB000).w,a1
		move.b	#0,$22(a1)
		move.b	#$53,$2E(a1)

locret_67512:

		rts
; ---------------------------------------------------------------------------

loc_67514:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6751A:
		move.b	#4,5(a0)
		move.w	#$300,$18(a0)
		move.w	#$600,$1A(a0)
		lea	ChildObjDat_67A5A(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_67536:
		subi.w	#$18,$1A(a0)
		beq.s	loc_67544
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_67544:
		move.b	#6,5(a0)
		clr.w	$18(a0)
		move.w	#$5F,$2E(a0)
		move.l	#loc_67572,$34(a0)
		jmp	Swing_Setup1(pc)
; ---------------------------------------------------------------------------

loc_67560:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_67572:
		move.b	#8,5(a0)
		move.w	#$400,$18(a0)
		move.w	#-$400,$1A(a0)
		move.l	#byte_67A84,$30(a0)
		bset	#3,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_67594:
		subi.w	#$40,$18(a0)
		jsr	(MoveSprite).l
		cmpi.w	#$130,$14(a0)
		bcc.s	loc_675AE
		jmp	(loc_67A20).l
; ---------------------------------------------------------------------------

loc_675AE:
		move.b	#$A,5(a0)
		move.w	#$130,$14(a0)
		clr.w	$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_675C0:
		subi.w	#$40,$18(a0)
		jsr	(MoveSprite2).l
		cmpi.w	#$40,$10(a0)
		bcs.s	loc_675D6
		rts
; ---------------------------------------------------------------------------

loc_675D6:
		move.b	#$C,5(a0)
		move.w	#$40,$10(a0)
		move.w	#5,$2E(a0)
		move.l	#loc_675FA,$34(a0)
		move.w	#$3F,$3A(a0)
		bra.w	loc_67996
; ---------------------------------------------------------------------------

loc_675FA:
		move.w	#5,$2E(a0)
		cmpi.w	#$80,$10(a0)
		bcs.w	locret_67512
		lea	ChildObjDat_67A70(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_67614:
		subq.w	#1,$3A(a0)
		bpl.w	locret_67512
		move.b	#$E,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_67624:
		bsr.w	sub_679B8
		jsr	(Obj_Wait).l
		move.w	$10(a0),d0
		addq.w	#4,d0
		move.w	d0,$10(a0)
		cmpi.w	#$200,d0
		bcc.s	loc_67640
		rts
; ---------------------------------------------------------------------------

loc_67640:
		move.b	#$10,5(a0)
		move.w	#$1F,$3A(a0)
		rts
; ---------------------------------------------------------------------------

loc_6764E:
		bsr.w	sub_679B8
		jsr	(Obj_Wait).l
		subq.w	#1,$3A(a0)
		bpl.w	locret_67512
		move.b	#$12,5(a0)
		bset	#2,$38(a0)
		move.w	#$C,$40(a0)
		rts
; ---------------------------------------------------------------------------

loc_67674:
		bsr.w	sub_679B8
		jsr	(Obj_Wait).l
		move.w	$10(a0),d0
		subi.w	#4,d0
		move.w	d0,$10(a0)
		cmpi.w	#$120,d0
		bls.s	loc_67692
		rts
; ---------------------------------------------------------------------------

loc_67692:
		move.b	#$14,5(a0)
		bset	#2,$38(a0)
		move.w	#$1F,$3A(a0)
		move.w	#$10,$40(a0)
		rts
; ---------------------------------------------------------------------------

loc_676AC:
		bsr.w	sub_679B8
		jsr	(Obj_Wait).l
		subq.w	#1,$3A(a0)
		bpl.w	locret_67512
		move.b	#$16,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_676C6:
		bsr.w	sub_679B8
		cmpi.w	#$918,($FFFFB010).w
		bcc.s	loc_676D8
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_676D8:
		move.b	#$18,5(a0)
		lea	ChildObjDat_67A78(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_676E8:
		bsr.w	sub_679B8
		cmpi.w	#$1240,($FFFFB010).w
		bcc.s	loc_676F6
		rts
; ---------------------------------------------------------------------------

loc_676F6:
		move.b	#$1A,5(a0)
		subi.w	#$20,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_67704:
		bsr.w	sub_679B8
		cmpi.w	#$13D0,($FFFFB010).w
		bcc.s	loc_67712
		rts
; ---------------------------------------------------------------------------

loc_67712:
		st	($FFFFF650).w
		lea	($FFFFB000).w,a1
		move.b	#4,5(a1)
		bset	#1,$2A(a1)
		move.w	#-$400,$1A(a1)
		move.w	#-$200,$18(a1)
		move.w	#0,$1C(a1)
		move.b	#$1A,$20(a1)
		clr.b	$2E(a1)
		clr.w	($FFFFF602).w
		st	($FFFFF7CA).w
		clr.b	($FFFFFE19).w
		move.b	#2,($FFFFF65F).w
		move.w	#$1E,($FFFFF65C).w
		lea	Pal_AIZIntroEmeralds(pc),a1
		lea	($FFFFFC60).w,a2
		moveq	#7,d0

loc_67764:
		move.l	(a1)+,(a2)+
		dbf	d0,loc_67764
		lea	ChildObjDat_67A7E(pc),a2
		jsr	(CreateChild6_Simple).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_6777A:
		move.l	#loc_677CE,(a0)
		move.l	#Map_AIZIntroPlane,$C(a0)
		move.w	#$529,$A(a0)
		move.w	#$280,8(a0)
		move.b	#$40,7(a0)
		move.b	#$20,7(a0)
		jsr	Swing_Setup1(pc)
		lea	(ArtKosM_AIZIntroPlane).l,a1
		move.w	#-$5AE0,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_AIZIntroEmeralds).l,a1
		move.w	#-$49E0,d2
		jsr	(Queue_Kos_Module).l
		lea	ChildObjDat_67A62(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_677CE:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		beq.s	loc_677EC
		move.l	#loc_67800,(a0)

loc_677EC:
		btst	#3,$38(a1)
		bne.s	loc_677FA
		jsr	(Refresh_ChildPosition).l

loc_677FA:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_67800:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		subq.w	#4,$10(a0)
		cmpi.w	#$20,$10(a0)
		bcs.s	loc_6781E
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6781E:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_67824:
		move.l	#Map_AIZIntroPlane,$C(a0)
		move.w	#$529,$A(a0)
		move.w	#$280,8(a0)
		move.b	#4,7(a0)
		move.b	#$C,7(a0)
		move.l	#loc_6784A,(a0)

loc_6784A:
		lea	(byte_67A8F).l,a1
		jsr	(Animate_RawNoSST).l
		jsr	(Refresh_ChildPosition).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_67862:
		move.l	#Map_AIZIntroPlane,$C(a0)
		move.w	#$529,$A(a0)
		move.w	#$280,8(a0)
		move.b	#4,7(a0)
		move.b	#$C,7(a0)
		move.l	#loc_67888,(a0)

loc_67888:
		lea	(byte_67A97).l,a1
		jsr	(Animate_RawNoSST).l
		jsr	(Refresh_ChildPosition).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_678A0:
		move.l	#loc_678DA,(a0)
		move.l	#Map_AIZIntroWaves,$C(a0)
		move.w	#$3D1,$A(a0)
		move.w	#$100,8(a0)
		move.b	#$10,7(a0)
		bset	#0,4(a0)
		movea.w	$46(a0),a1
		move.l	#byte_67A9B,$30(a0)
		move.l	#Go_Delete_Sprite,$34(a0)

loc_678DA:
		cmpi.w	#$60,$10(a0)
		bcs.s	loc_678FA
		movea.w	$46(a0),a1
		move.w	$40(a1),d0
		sub.w	d0,$10(a0)
		jsr	(Animate_RawMultiDelay).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_678FA:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_67900:
		lea	ObjDat3_67A4E(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	$2C(a0),d0
		lsr.b	#1,d0
		move.b	d0,$22(a0)
		move.l	#loc_67938,(a0)
		move.b	#4,$1E(a0)
		lea	($FFFFB000).w,a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		moveq	#$40,d0
		jsr	(Set_IndexedVelocity).l

loc_67938:
		jsr	(MoveSprite).l
		tst.l	d0
		bmi.s	loc_67956
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_67956
		add.w	d1,$14(a0)
		move.l	#loc_6795C,(a0)

loc_67956:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6795C:
		movea.w	($FFFFFAA4).w,a1
		move.w	$10(a0),d0
		move.w	$10(a1),d1
		subq.w	#8,d0
		cmp.w	d0,d1
		bcs.s	loc_67976
		addi.w	#$10,d0
		cmp.w	d0,d1
		bcs.s	loc_6797C

loc_67976:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6797C:
		move.w	$18(a1),d0
		btst	#1,$2C(a0)
		beq.s	loc_6798A
		neg.w	d0

loc_6798A:
		tst.w	d0
		bmi.w	locret_67512
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_67996:
		move.l	#Map_SuperSonic,$C(a0)
		move.b	#$21,$22(a0)
		move.b	#0,($FFFFF65E).w
		move.w	#$24,($FFFFF65C).w
		move.w	#$7FFF,($FFFFF670).w
		rts

; =============== S U B R O U T I N E =======================================


sub_679B8:

		move.b	#1,($FFFFFE19).w
		move.b	#$21,$22(a0)
		btst	#1,($FFFFFE0F).w
		beq.s	loc_679D2
		move.b	#$22,$22(a0)

loc_679D2:
		subq.b	#1,($FFFFF65E).w
		bpl.s	locret_67A06
		move.b	#6,($FFFFF65E).w
		lea	(AnPal_SuperSonic_1).l,a1
		move.w	($FFFFF65C).w,d0
		addq.w	#6,($FFFFF65C).w
		cmpi.w	#$36,($FFFFF65C).w
		bcs.s	loc_679FA
		move.w	#$24,($FFFFF65C).w

loc_679FA:
		lea	($FFFFFC04).w,a2
		move.l	(a1,d0.w),(a2)+
		move.w	4(a1,d0.w),(a2)

locret_67A06:
		rts
; End of function sub_679B8


; =============== S U B R O U T I N E =======================================


sub_67A08:
		move.w	$40(a0),d1
		move.w	($FFFFEEB6).w,d0
		bpl.s	loc_67A1A
		add.w	d1,d0
		move.w	d0,($FFFFEEB6).w
		rts
; ---------------------------------------------------------------------------

loc_67A1A:
		add.w	d1,($FFFFB010).w
		rts
; End of function sub_67A08

; ---------------------------------------------------------------------------

loc_67A20:
		movea.l	$30(a0),a1
		subq.b	#1,$24(a0)
		bpl.s	locret_67A4C
		move.b	(a1),$24(a0)
		moveq	#0,d0
		move.b	$23(a0),d0
		addq.w	#1,d0
		cmp.b	1(a1),d0
		bcs.s	loc_67A3E
		moveq	#0,d0

loc_67A3E:
		move.b	d0,$23(a0)
		moveq	#0,d1
		move.b	2(a1,d0.w),d1
		move.b	d1,$22(a0)

locret_67A4C:
		rts
; ---------------------------------------------------------------------------
ObjDat3_67A4E:	dc.l Map_AIZIntroEmeralds
		dc.w $65B1
		dc.w $280
		dc.b 4
		dc.b 4
		dc.b 1
		dc.b 0
ChildObjDat_67A5A:dc.w 0
		dc.l loc_6777A
		dc.w $DE2C
ChildObjDat_67A62:dc.w 1
		dc.l loc_67824
		dc.w $3804
		dc.l loc_67862
		dc.w $1818
ChildObjDat_67A70:dc.w 0
		dc.l loc_678A0
		dc.w $18
ChildObjDat_67A78:dc.w 0
		dc.l Obj_CutsceneKnuckles
ChildObjDat_67A7E:dc.w 6
		dc.l loc_67900
byte_67A84:	dc.b	3,   8
		dc.b  $97, $96
		dc.b  $98, $96
		dc.b  $99, $96
		dc.b  $9A, $96
		dc.b  $FC
byte_67A8F:	dc.b 0
		dc.b 1
		dc.b 2
		dc.b 3
		dc.b 4
		dc.b 3
		dc.b 2
		dc.b $FC
byte_67A97:	dc.b 0
		dc.b 5
		dc.b 6
		dc.b $FC
byte_67A9B:	dc.b 0
		dc.b 1
		dc.b 0
		dc.b 0
		dc.b 1
		dc.b 1
		dc.b 2
		dc.b 2
		dc.b 3
		dc.b 2
		dc.b 4
		dc.b 1
		dc.b 5
		dc.b 1
		dc.b $F4
Pal_AIZIntroEmeralds:	binclude "Levels\AIZ\Palettes\Intro Emeralds.bin"

; ---------------------------------------------------------------------------

Obj_RobotnikHead:
		jsr	(Refresh_ChildPositionAdjusted).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	RobotnikHead_Index(pc,d0.w),d1
		jsr	RobotnikHead_Index(pc,d1.w)
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------
RobotnikHead_Index:	dc.w Obj_RobotnikHeadInit-RobotnikHead_Index
		dc.w Obj_RobotnikHeadMain-RobotnikHead_Index
		dc.w Obj_RobotnikHeadEnd-RobotnikHead_Index
; ---------------------------------------------------------------------------

Obj_RobotnikHeadInit:

		lea	ObjDat_RobotnikHead(pc),a1
		jsr	(SetUp_ObjAttributes).l
		jsr	(Child_SyncDraw).l
		move.l	#AniRaw_RobotnikHead,$30(a0)
		movea.w	$46(a0),a1
		move.w	$46(a1),$44(a0)
		cmpi.b	#2,($FFFFB038).w
		bne.s	Obj_RobotnikHeadEnd

; =============== S U B R O U T I N E =======================================


sub_67B14:

		move.l	#Map_EggRoboHead,$C(a0)		; If player is Knuckles, use Egg Robo head

loc_67B1C:
		move.l	#AniRaw_EggRoboHead,$30(a0)
		lea	(ArtKosM_EggRoboHead).l,a1
		move.w	#-$5A40,d2
		jmp	(Queue_Kos_Module).l
; End of function sub_67B14

; ---------------------------------------------------------------------------

Obj_RobotnikHeadMain:

		jsr	(Animate_Raw).l
		movea.w	$44(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_67B56
		btst	#6,$2A(a1)
		beq.s	locret_67B54
		move.b	#2,$22(a0)		; Use hurt mapping frame if parent boss object is currently hurt

locret_67B54:
		rts
; ---------------------------------------------------------------------------

loc_67B56:
		move.b	#4,5(a0)
		move.b	#3,$22(a0)		; Use defeated head frame if parent boss object is defeated
		rts
; ---------------------------------------------------------------------------

Obj_RobotnikHeadEnd:

		rts
; ---------------------------------------------------------------------------

Obj_RobotnikHead2:
		jsr	(Refresh_ChildPositionAdjusted).l
		jsr	(Child_SyncDraw).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	RobotnikHead2_Index(pc,d0.w),d1
		jsr	RobotnikHead2_Index(pc,d1.w)
		btst	#6,$38(a0)
		bne.w	Obj_RobotnikHeadEnd
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------
RobotnikHead2_Index:	dc.w Obj_RobotnikHeadInit-RobotnikHead2_Index
		dc.w Obj_RobotnikHeadMain-RobotnikHead2_Index
		dc.w Obj_RobotnikHeadEnd-RobotnikHead2_Index
; ---------------------------------------------------------------------------

Obj_FBZRobotnikHead:
		jsr	(Refresh_ChildPositionAdjusted).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	FBZRobotnikHead_Index(pc,d0.w),d1
		jsr	FBZRobotnikHead_Index(pc,d1.w)
		jsr	(Child_GetPriority).l
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------
FBZRobotnikHead_Index:	dc.w Obj_FBZRobotnikHeadInit-FBZRobotnikHead_Index

		dc.w Obj_FBZRobotnikHeadMain-FBZRobotnikHead_Index
		dc.w Obj_RobotnikHeadEnd-FBZRobotnikHead_Index
; ---------------------------------------------------------------------------

Obj_FBZRobotnikHeadInit:
		lea	ObjDat_FBZRobotnikHead(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#AniRaw_RobotnikHead,$30(a0)
		movea.w	$46(a0),a1
		move.w	$46(a1),$44(a0)
		cmpi.b	#2,($FFFFB038).w
		bne.w	Obj_RobotnikHeadEnd
		bra.w	sub_67B14
; ---------------------------------------------------------------------------

Obj_FBZRobotnikHeadMain:
		move.w	$10(a0),d0
		bclr	#0,4(a0)
		cmp.w	($FFFFB010).w,d0
		bcc.s	loc_67BFC
		bset	#0,4(a0)

loc_67BFC:
		clr.b	$22(a0)
		movea.w	$44(a0),a1
		btst	#2,$38(a0)
		beq.s	loc_67C12
		move.b	#1,$22(a0)

loc_67C12:
		btst	#7,$2A(a1)
		bne.s	loc_67C2A
		btst	#6,$2A(a1)
		beq.s	locret_67C28
		move.b	#2,$22(a0)

locret_67C28:
		rts
; ---------------------------------------------------------------------------

loc_67C2A:
		move.b	#4,5(a0)
		move.b	#3,$22(a0)
		rts
; ---------------------------------------------------------------------------

Obj_RobotnikHead3:
		jsr	(Refresh_ChildPositionAdjusted).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	RobotnikHead3_Index(pc,d0.w),d1
		jsr	RobotnikHead3_Index(pc,d1.w)
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------
RobotnikHead3_Index:	dc.w Obj_RobotnikHead3Init-RobotnikHead3_Index

		dc.w Obj_RobotnikHead3Main-RobotnikHead3_Index
		dc.w Obj_RobotnikHead3End-RobotnikHead3_Index
; ---------------------------------------------------------------------------

Obj_RobotnikHead3Init:

		lea	ObjDat_RobotnikHead(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#AniRaw_RobotnikHead,$30(a0)
		cmpi.b	#2,($FFFFB038).w
		bne.s	loc_67C76
		bsr.w	sub_67B14

loc_67C76:
		movea.w	$46(a0),a1
		btst	#7,$A(a1)
		beq.s	locret_67C88
		bset	#7,$A(a0)

locret_67C88:
		rts
; ---------------------------------------------------------------------------

Obj_RobotnikHead3Main:

		jsr	(Animate_Raw).l
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_67CAC
		btst	#6,$2A(a1)
		beq.s	locret_67CAA
		move.b	#2,$22(a0)

locret_67CAA:
		rts
; ---------------------------------------------------------------------------

loc_67CAC:
		move.b	#4,5(a0)
		move.b	#3,$22(a0)
		rts
; ---------------------------------------------------------------------------

Obj_RobotnikHead3End:

		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.w	Obj_RobotnikHeadEnd
		lea	AniRaw_RobotnikHead(pc),a1
		jmp	(Animate_RawNoSST).l
; ---------------------------------------------------------------------------

Obj_RobotnikHead4:

		jsr	(Refresh_ChildPositionAdjusted).l
		jsr	(Child_GetPriority).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	RobotnikHead4_Index(pc,d0.w),d1
		jsr	RobotnikHead4_Index(pc,d1.w)
		movea.w	$46(a0),a1
		btst	#5,$38(a1)
		bne.s	loc_67CFE
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_67CFE:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
RobotnikHead4_Index:	dc.w Obj_RobotnikHead3Init-RobotnikHead4_Index

		dc.w Obj_RobotnikHead3Main-RobotnikHead4_Index
		dc.w Obj_RobotnikHead3End-RobotnikHead4_Index
; ---------------------------------------------------------------------------

Obj_MechaSonicHead:
		lea	ObjDat_MechaSonicHead(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#Obj_MechaSonicHeadMain,(a0)
		lea	(ArtKosM_MechaSonicHead).l,a1
		move.w	#-$5A40,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

Obj_MechaSonicHeadMain:
		jsr	(Refresh_ChildPositionAdjusted).l
		tst.b	($FFFFFA89).w
		bne.s	loc_67D3C
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_67D3C:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_RobotnikShip:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	RobotnikShip_Index(pc,d0.w),d1
		jsr	RobotnikShip_Index(pc,d1.w)
		btst	#6,$38(a0)
		bne.w	Obj_RobotnikHeadEnd
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
RobotnikShip_Index:	dc.w loc_67D68-RobotnikShip_Index

		dc.w loc_67D84-RobotnikShip_Index
		dc.w loc_67DD8-RobotnikShip_Index
		dc.w loc_67E0A-RobotnikShip_Index
; ---------------------------------------------------------------------------

loc_67D68:
		lea	ObjDat_RobotnikShip(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	$2C(a0),$22(a0)
		lea	(Child1_MakeRoboHead2).l,a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_67D84:
		jsr	(Refresh_ChildPositionAdjusted).l
		jsr	(Child_SyncDraw).l
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_67D9E
		rts
; ---------------------------------------------------------------------------

loc_67D9E:
		move.b	#4,5(a0)
		cmpi.b	#0,($FFFFFE10).w
		beq.s	loc_67DC2
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	locret_67DC0
		move.b	#4,$2C(a1)

locret_67DC0:
		rts
; ---------------------------------------------------------------------------

loc_67DC2:
		lea	(Child6_CreateBossExplosion).l,a2	; if in Angel Island
		jsr	(CreateChild6_Simple).l
		bne.s	locret_67DD6
		move.b	#$12,$2C(a1)

locret_67DD6:
		rts
; ---------------------------------------------------------------------------

loc_67DD8:
		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		bne.s	loc_67DF0
		jsr	(Child_SyncDraw).l
		jmp	(Refresh_ChildPositionAdjusted).l
; ---------------------------------------------------------------------------

loc_67DF0:
		move.b	#6,5(a0)
		move.b	#5,$22(a0)
		move.w	#-$200,$1A(a0)
		move.w	#$7F,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_67E0A:
		jsr	(MoveSprite).l
		subq.w	#1,$2E(a0)
		bmi.s	loc_67E18
		rts
; ---------------------------------------------------------------------------

loc_67E18:
		bset	#5,$38(a0)
		clr.b	($FFFFF7AA).w
		jmp	(Go_Delete_Sprite_2).l
; ---------------------------------------------------------------------------

Obj_RobotnikShip2:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	RobotnikShip2_Index(pc,d0.w),d1
		jsr	RobotnikShip2_Index(pc,d1.w)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
RobotnikShip2_Index:	dc.w Obj_RobotnikShipInit-RobotnikShip2_Index

		dc.w Obj_RobotnikShipMain-RobotnikShip2_Index
		dc.w Obj_RobotnikShip2Wait-RobotnikShip2_Index
		dc.w Obj_RobotnikShipReady-RobotnikShip2_Index
		dc.w Obj_RobotnikShipEscape-RobotnikShip2_Index
; ---------------------------------------------------------------------------

Obj_RobotnikShip2Wait:
		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		bne.s	loc_67E54
		rts
; ---------------------------------------------------------------------------

loc_67E54:
		move.b	#6,5(a0)
		move.b	#5,$22(a0)
		rts
; ---------------------------------------------------------------------------

Obj_RobotnikShip3:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	RobotnikShip3_Index(pc,d0.w),d1
		jsr	RobotnikShip3_Index(pc,d1.w)
		movea.w	$46(a0),a1
		btst	#5,$38(a1)
		bne.s	loc_67E8C
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
RobotnikShip3_Index:	dc.w Obj_RobotnikShipInit-RobotnikShip3_Index
		dc.w Obj_RobotnikShipMain-RobotnikShip3_Index
		dc.w Obj_RobotnikShipWait-RobotnikShip3_Index
		dc.w Obj_RobotnikShipReady-RobotnikShip3_Index
		dc.w Obj_RobotnikShipEscape-RobotnikShip3_Index
; ---------------------------------------------------------------------------

loc_67E8C:
		jmp	(Go_Delete_Sprite_2).l
; ---------------------------------------------------------------------------

Obj_RobotnikShipInit:

		lea	ObjDat_RobotnikShip(pc),a1
		jsr	(SetUp_ObjAttributes).l
		jsr	(Child_SyncDraw).l
		move.b	$2C(a0),$22(a0)
		lea	(Child1_MakeRoboHead).l,a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

Obj_RobotnikShipMain:

		jsr	(Refresh_ChildPositionAdjusted).l
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_67EC8
		rts
; ---------------------------------------------------------------------------

loc_67EC8:
		move.b	#4,5(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild1_Normal).l
		bne.s	locret_67EE2
		move.b	#4,$2C(a1)

locret_67EE2:
		rts
; ---------------------------------------------------------------------------

Obj_RobotnikShipWait:

		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		bne.s	loc_67EF6
		jmp	(Refresh_ChildPositionAdjusted).l
; ---------------------------------------------------------------------------

loc_67EF6:
		move.b	#6,5(a0)
		move.b	#$A,$22(a0)
		rts
; ---------------------------------------------------------------------------

Obj_RobotnikShipReady:

		move.w	($FFFFEE7C).w,d0
		addi.w	#$40,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_67F18
		subq.w	#1,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_67F18:
		move.b	#8,5(a0)

loc_67F1E:
		bset	#0,4(a0)
		move.w	#$300,$18(a0)
		clr.w	$1A(a0)
		move.w	#$100,$2E(a0)
		lea	Child1_MakeRoboShipFlame(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

Obj_RobotnikShipEscape:

		jsr	(MoveSprite2).l
		subq.w	#1,$2E(a0)
		bmi.s	loc_67F4C
		rts
; ---------------------------------------------------------------------------

loc_67F4C:
		bset	#5,$38(a0)
		clr.b	($FFFFF7AA).w
		jmp	(Go_Delete_Sprite_2).l
; ---------------------------------------------------------------------------

Obj_RobotnikShip4:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	RobotnikShip4_Index(pc,d0.w),d1
		jsr	RobotnikShip4_Index(pc,d1.w)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
RobotnikShip4_Index:	dc.w Obj_RobotnikShipInit-RobotnikShip4_Index

		dc.w Obj_RobotnikShipMain-RobotnikShip4_Index
		dc.w Obj_RobotnikShipWait-RobotnikShip4_Index
		dc.w Obj_RobotnikShipReady-RobotnikShip4_Index
		dc.w Obj_RobotnikShipEscape-RobotnikShip4_Index
; ---------------------------------------------------------------------------

Obj_FBZRobotnikShip:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	FBZRobotnikShip_Index(pc,d0.w),d1
		jsr	FBZRobotnikShip_Index(pc,d1.w)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
FBZRobotnikShip_Index:	dc.w Obj_FBZRobotnikShipInit-FBZRobotnikShip_Index

		dc.w Obj_FBZRobotnikShipMain-FBZRobotnikShip_Index
		dc.w Obj_FBZRobotnikShipWait-FBZRobotnikShip_Index
		dc.w Obj_FBZRobotnikShipFall-FBZRobotnikShip_Index
		dc.w Obj_FBZRobotnikShipRise-FBZRobotnikShip_Index
		dc.w Obj_RobotnikShipEscape-FBZRobotnikShip_Index
; ---------------------------------------------------------------------------

Obj_FBZRobotnikShipInit:
		lea	ObjDat_RobotnikShip(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	$2C(a0),$22(a0)
		lea	(Child1_MakeFBZRoboHead).l,a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

Obj_FBZRobotnikShipMain:
		jsr	(Refresh_ChildPosition).l
		jsr	(Child_GetPriority).l
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_67FD0
		rts
; ---------------------------------------------------------------------------

loc_67FD0:
		move.b	#4,5(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild1_Normal).l
		bne.s	locret_67FEA
		move.b	#4,$2C(a1)

locret_67FEA:
		rts
; ---------------------------------------------------------------------------

Obj_FBZRobotnikShipWait:
		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		bne.s	loc_68004
		jsr	(Child_GetPriority).l
		jmp	(Refresh_ChildPosition).l
; ---------------------------------------------------------------------------

loc_68004:
		move.b	#6,5(a0)
		move.b	#5,$22(a0)
		clr.w	$18(a0)
		move.w	#-$200,$1A(a0)
		move.w	#$2F,$2E(a0)
		move.l	#Obj_FBZRobotnikShipReadyGo,$34(a0)
		rts
; ---------------------------------------------------------------------------

Obj_FBZRobotnikShipFall:
		jsr	(MoveSprite).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

Obj_FBZRobotnikShipReadyGo:
		move.b	#8,5(a0)
		bset	#0,4(a0)
		rts
; ---------------------------------------------------------------------------

Obj_FBZRobotnikShipRise:
		move.w	($FFFFEE7C).w,d0
		addi.w	#$C0,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_68058
		subq.w	#1,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_68058:
		move.b	#$A,5(a0)
		bra.w	loc_67F1E
; ---------------------------------------------------------------------------

Obj_RobotnikShipFlame:
		lea	ObjDat2_RoboShipFlame(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#Obj_RobotnikShipFlameMain,(a0)
		rts
; ---------------------------------------------------------------------------

Obj_RobotnikShipFlameMain:
		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		bne.s	loc_6809E
		jsr	(Refresh_ChildPositionAdjusted).l
		btst	#0,($FFFFFE0F).w
		bne.w	Obj_RobotnikHeadEnd
		tst.w	$18(a1)
		beq.w	Obj_RobotnikHeadEnd
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6809E:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_BlueSphere_Ship:
		move.l	#loc_680EC,(a0)
		move.l	#Map_RobotnikShip,$C(a0)
		move.w	#$226F,$A(a0)
		move.w	#$280,8(a0)
		move.b	#$20,7(a0)
		move.b	#$20,6(a0)
		move.b	#$A,$22(a0)
		move.w	#$188,$10(a0)
		move.w	#$C0,$14(a0)
		jsr	(Swing_Setup1).l
		lea	Child1_BlueSphereShipHead(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_680EC:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_BlueSphere_ShipHead:
		move.l	#loc_68118,(a0)
		move.w	#$280,8(a0)
		move.b	#$10,7(a0)
		move.b	#8,6(a0)
		rts
; ---------------------------------------------------------------------------

loc_68118:
		jsr	(Refresh_ChildPositionAdjusted).l
		lea	AniRaw_EggRoboHead(pc),a1
		jsr	(Animate_RawNoSST).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
ObjDat_RobotnikHead:	dc.l Map_RobotnikShip

		dc.w $52E
		dc.w $280
		dc.b $10
		dc.b 8
		dc.b 0
		dc.b 0
ObjDat_FBZRobotnikHead:	dc.l Map_FBZRobotnikHead
		dc.w $430
		dc.w $280
		dc.b $10
		dc.b 8
		dc.b 0
		dc.b 0
ObjDat_RobotnikShip:	dc.l Map_RobotnikShip

		dc.w $52E
		dc.w $280
		dc.b $1C
		dc.b $20
		dc.b 8
		dc.b 0
ObjDat2_RoboShipFlame:	dc.w $280
		dc.b 8
		dc.b 4
		dc.b 6
		dc.b 0
ObjDat_MechaSonicHead:	dc.l Map_MechaSonicHead
		dc.w $252E
		dc.w $280
		dc.b $14
		dc.b $10
		dc.b 0
		dc.b 0
Child1_MakeRoboHead:dc.w 0
		dc.l Obj_RobotnikHead
		dc.w $E4
Child1_MakeRoboHead2:dc.w 0
		dc.l Obj_RobotnikHead2
		dc.w $E4
Child1_MakeFBZRoboHead:dc.w 0
		dc.l Obj_FBZRobotnikHead
		dc.w $E4
Child1_MakeRoboHead3:dc.w 0

		dc.l Obj_RobotnikHead3
		dc.w $E4
Child1_MakeRoboHead4:dc.w 0

		dc.l Obj_RobotnikHead4
		dc.w $E4
word_6818C:	dc.w 0
		dc.l Obj_RobotnikShip
		dc.w $EC
		dc.w 0
		dc.l Obj_RobotnikShip2
		dc.w 0
Child1_MakeRoboShip3:dc.w 0

		dc.l Obj_RobotnikShip3
		dc.w $FA04
ChildObjDat_681A4:dc.w 0
		dc.l Obj_RobotnikShip4
		dc.w $F8
ChildObjDat_681AC:dc.w 0
		dc.l Obj_FBZRobotnikShip
		dc.w 4
Child1_MakeRoboShipFlame:dc.w 0

		dc.l Obj_RobotnikShipFlame
		dc.w $1E00
Child1_MakeMechaHead:dc.w 0

		dc.l Obj_MechaSonicHead
		dc.w $E0
Child1_BlueSphereShipHead:dc.w 0
		dc.l Obj_BlueSphere_ShipHead
		dc.w $E4
AniRaw_RobotnikHead:	dc.b 5

		dc.b 0
		dc.b 1
		dc.b $FC
AniRaw_EggRoboHead:	dc.b $F

		dc.b 0
		dc.b 1
		dc.b $FC
Map_EggRoboHead:	include "General\Sprites\Robotnik\Map - Egg Robo Head.asm"

Map_MechaSonicHead:	include "General\Sprites\Mecha Sonic\Map - Mecha Sonic Head.asm"

Map_RobotnikShip:	include "General\Sprites\Robotnik\Map - Robotnik Ship.asm"

Map_FBZRobotnikRun:	include "Levels\FBZ\Misc Object Data\Map - Robotnik Run.asm"

Map_FBZRobotnikHead:	include "Levels\FBZ\Misc Object Data\Map - Robotnik Head.asm"

Map_FBZRobotnikStand:	include "Levels\FBZ\Misc Object Data\Map - Robotnik Stand.asm"

; ---------------------------------------------------------------------------

Obj_AIZ_Miniboss_Cutscene:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_684FE(pc,d0.w),d1
		jsr	off_684FE(pc,d1.w)
		bra.w	loc_68F62
; ---------------------------------------------------------------------------
off_684FE:	dc.w loc_68508-off_684FE

		dc.w loc_6852C-off_684FE
		dc.w loc_68574-off_684FE
		dc.w loc_685B8-off_684FE
		dc.w loc_685FC-off_684FE
; ---------------------------------------------------------------------------

loc_68508:
		lea	ObjDat3_68FFE(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#$60,$29(a0)
		move.w	($FFFFEE16).w,($FFFFFA92).w
		move.b	#1,($FFFFF7AA).w
		moveq	#$5A,d0
		jmp	(Load_PLC).l
; ---------------------------------------------------------------------------

loc_6852C:
		move.w	($FFFFEE78).w,d0
		move.w	#$2F10,d5
		cmp.w	d5,d0
		bcc.s	loc_6853A
		rts
; ---------------------------------------------------------------------------

loc_6853A:
		move.l	#loc_6857A,$34(a0)
		lea	ChildObjDat_6906A(pc),a2
		jsr	(CreateChild3_NormalRepeated).l
		lea	Pal_AIZMiniboss(pc),a1
		jsr	(PalLoad_Line1).l

loc_68556:
		move.b	#4,5(a0)
		move.w	#$B4,$2E(a0)
		move.w	d5,($FFFFEE14).w
		move.w	d5,($FFFFEE16).w
		moveq	#-$1F,d0
		jsr	(Play_Sound).l

locret_68572:


		rts
; ---------------------------------------------------------------------------

loc_68574:

		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6857A:
		move.l	#loc_685BE,$34(a0)
		move.b	#6,5(a0)
		lea	ChildObjDat_6905C(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	ChildObjDat_69072(pc),a2
		jsr	(CreateChild1_Normal).l

; =============== S U B R O U T I N E =======================================


sub_6859C:
		move.w	#$100,$1A(a0)
		move.w	#$AF,$2E(a0)
		moveq	#$2E,d0
		jsr	(Play_Sound).l
		move.b	#$2E,($FFFFFF91).w
		rts
; End of function sub_6859C

; ---------------------------------------------------------------------------

loc_685B8:
		jmp	(MoveWaitTouch).l
; ---------------------------------------------------------------------------

loc_685BE:
		move.w	#$7F,$2E(a0)
		move.l	#loc_6862E,$34(a0)
		move.b	#3,$39(a0)
		bset	#1,$38(a0)

loc_685D8:
		move.b	#8,5(a0)
		clr.w	$1A(a0)

; =============== S U B R O U T I N E =======================================


Swing_Setup1:

		move.w	#$C0,d0
		move.w	d0,$3E(a0)
		move.w	d0,$1A(a0)
		move.w	#$10,$40(a0)
		bclr	#0,$38(a0)
		rts
; End of function Swing_Setup1

; ---------------------------------------------------------------------------

loc_685FC:

		jsr	(Swing_UpAndDown).l
		jmp	(MoveWaitTouch).l
; ---------------------------------------------------------------------------
		subq.b	#1,$39(a0)
		bpl.s	loc_68616
		move.l	#loc_6862E,$34(a0)

loc_68616:
		move.w	#$40,$2E(a0)
		moveq	#$4F,d0
		jsr	(Play_Sound_2).l
		lea	Child1_AIZ_MinibossFlames(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6862E:

		move.w	#$10,$2E(a0)
		move.l	#loc_68646,$34(a0)
		lea	ChildObjDat_69104(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_68646:
		move.l	#loc_68690,(a0)
		lea	Pal_AIZMiniboss(pc),a1
		jsr	(PalLoad_Line1).l
		move.b	#$F,$28(a0)
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		move.w	#$400,$18(a0)
		clr.w	$1A(a0)
		move.w	#$40,$2E(a0)
		cmpi.w	#0,($FFFFFE10).w
		bne.s	loc_68682
		move.w	#$120,$2E(a0)

loc_68682:
		move.l	#Go_Delete_Sprite,$34(a0)
		st	($FFFFEEC6).w
		rts
; ---------------------------------------------------------------------------

loc_68690:
		jsr	(MoveSprite2).l
		subq.w	#1,$2E(a0)
		bmi.s	loc_686A2
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_686A2:
		clr.b	($FFFFF7AA).w
		jsr	(Obj_PlayLevelMusic).l
		lea	(PLC_83D48).l,a1
		jsr	(Load_PLC_Raw).l
		jmp	(Go_Delete_Sprite_2).l
; ---------------------------------------------------------------------------

loc_686BE:
		jsr	(Refresh_ChildPositionAdjusted).l
		lea	word_6900A(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		bset	#4,$2B(a0)
		move.l	#byte_69126,$30(a0)
		move.l	#loc_686E8,(a0)
		jmp	(Child_DrawTouch_Sprite2).l
; ---------------------------------------------------------------------------

loc_686E8:
		jsr	(Refresh_ChildPositionAdjusted).l
		jsr	(Animate_Raw).l
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		beq.s	loc_68704
		clr.b	$28(a0)

loc_68704:
		jmp	(Child_DrawTouch_Sprite2).l
; ---------------------------------------------------------------------------

loc_6870A:
		jsr	(Refresh_ChildPositionAdjusted).l
		move.l	#loc_68720,(a0)
		lea	word_69012(pc),a1
		jmp	(SetUp_ObjAttributes2).l
; ---------------------------------------------------------------------------

loc_68720:
		jsr	(Refresh_ChildPositionAdjusted).l
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------

loc_6872C:

		jsr	(Refresh_ChildPositionAdjusted).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_68746(pc,d0.w),d1
		jsr	off_68746(pc,d1.w)
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------
off_68746:	dc.w loc_68754-off_68746

		dc.w loc_6875E-off_68746
		dc.w loc_6877E-off_68746
		dc.w loc_6879C-off_68746
		dc.w loc_687DC-off_68746
		dc.w loc_6879C-off_68746
		dc.w locret_68572-off_68746
; ---------------------------------------------------------------------------

loc_68754:

		lea	word_6901A(pc),a1
		jmp	(SetUp_ObjAttributes2).l
; ---------------------------------------------------------------------------

loc_6875E:
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		bne.s	loc_6876C
		rts
; ---------------------------------------------------------------------------

loc_6876C:
		move.b	#4,5(a0)
		move.l	#loc_68784,$34(a0)
		bra.w	loc_68EC0
; ---------------------------------------------------------------------------

loc_6877E:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_68784:
		move.l	#loc_687A2,$34(a0)

loc_6878C:
		move.b	#6,5(a0)
		move.l	#byte_6912F,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_6879C:

		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_687A2:
		move.b	#8,5(a0)
		move.b	#3,$39(a0)
		move.l	#loc_687B6,$34(a0)

loc_687B6:
		move.w	#$1C,$2E(a0)
		subq.b	#1,$39(a0)
		cmpi.b	#1,$39(a0)
		beq.s	loc_687D2
		lea	ChildObjDat_6909A(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_687D2:
		lea	ChildObjDat_690A8(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_687DC:
		jsr	(Obj_Wait).l
		tst.b	$39(a0)
		bmi.s	loc_687EA
		rts
; ---------------------------------------------------------------------------

loc_687EA:
		move.b	#$A,5(a0)
		move.l	#byte_69136,$30(a0)
		move.l	#loc_68802,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_68802:
		move.b	#$C,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_6880A:

		jsr	(Refresh_ChildPositionAdjusted).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_68824(pc,d0.w),d1
		jsr	off_68824(pc,d1.w)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_68824:	dc.w loc_68828-off_68824

		dc.w loc_6879C-off_68824
; ---------------------------------------------------------------------------

loc_68828:
		lea	byte_69022(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#byte_6913F,$30(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_68844:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_68852(pc,d0.w),d1
		jmp	off_68852(pc,d1.w)
; ---------------------------------------------------------------------------
off_68852:	dc.w sub_6885A-off_68852

		dc.w loc_6888E-off_68852
		dc.w loc_68574-off_68852
		dc.w loc_6888E-off_68852

; =============== S U B R O U T I N E =======================================


sub_6885A:

		lea	word_6902A(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		moveq	#$4D,d0
		jsr	(Play_Sound_2).l
		move.l	#byte_6914C,$30(a0)
		move.l	#loc_6889A,$34(a0)
		move.w	#-$400,$1A(a0)
		move.w	#$60,$2E(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6888E:

		jsr	(Move_AnimateRaw_Wait).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6889A:
		move.b	#4,5(a0)
		move.w	#8,$2E(a0)
		move.l	#loc_688B0,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_688B0:
		move.b	#6,5(a0)
		moveq	#$51,d0
		jsr	(Play_Sound_2).l
		move.w	#$80,8(a0)
		bset	#1,4(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		move.w	#$60,$2E(a0)
		movea.w	$46(a0),a1
		moveq	#0,d0
		move.b	$2C(a1),d0
		bsr.w	sub_68EE4
		move.w	($FFFFEE7C).w,d0
		subi.w	#$20,d0
		move.w	d0,$14(a0)
		rts
; End of function sub_6885A

; ---------------------------------------------------------------------------

Obj_AIZMiniboss_Flame:

		jsr	(Refresh_ChildPositionAdjusted).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_68908(pc,d0.w),d1
		jmp	off_68908(pc,d1.w)
; ---------------------------------------------------------------------------
off_68908:	dc.w sub_6890E-off_68908

		dc.w loc_68574-off_68908
		dc.w loc_68956-off_68908

; =============== S U B R O U T I N E =======================================


sub_6890E:

		lea	ObjDat3_6903E(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bset	#4,$2B(a0)
		move.l	#loc_6893E,$34(a0)
		moveq	#6,d1

loc_68928:
		moveq	#0,d0
		move.b	$2C(a0),d0
		sub.w	d0,d1
		add.b	d1,d1
		move.w	d1,$2E(a0)
		rts
; ---------------------------------------------------------------------------
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6893E:
		move.b	#4,5(a0)
		move.l	#byte_6915F,$30(a0)
		move.l	#loc_68962,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_68956:
		jsr	(Animate_RawMultiDelay).l
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_68962:
		move.l	#Map_BossExplosion,$C(a0)
		move.w	#-$7B2E,$A(a0)
		move.l	#byte_69164,$30(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		cmpi.b	#6,$2C(a0)
		bne.w	locret_68572
		lea	ChildObjDat_690D0(pc),a2
		jmp	(CreateChild1_Normal).l
; End of function sub_6890E

; ---------------------------------------------------------------------------

loc_68994:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_689A8(pc,d0.w),d1
		jsr	off_689A8(pc,d1.w)
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_689A8:	dc.w loc_689AC-off_689A8

		dc.w loc_689F8-off_689A8
; ---------------------------------------------------------------------------

loc_689AC:
		bsr.w	sub_6890E
		move.w	#$100,8(a0)
		move.l	#byte_6916F,$30(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		movea.w	$46(a0),a1
		movea.w	$46(a1),a1
		move.w	a1,$46(a0)
		move.w	$14(a1),$14(a0)
		move.w	#-$60,d0
		btst	#0,4(a1)
		beq.s	loc_689EC
		neg.w	d0
		bset	#0,4(a0)

loc_689EC:
		move.w	$10(a1),d1
		add.w	d0,d1
		move.w	d1,$10(a0)
		rts
; ---------------------------------------------------------------------------

loc_689F8:
		jsr	(Animate_RawMultiDelay).l
		tst.w	d2
		beq.s	locret_68A16
		bmi.s	locret_68A16
		move.w	word_68A18(pc,d0.w),d0
		btst	#0,4(a0)
		bne.s	loc_68A12
		neg.w	d0

loc_68A12:
		add.w	d0,$10(a0)

locret_68A16:

		rts
; ---------------------------------------------------------------------------
word_68A18:	dc.w 0
		dc.w 0
		dc.w 0
		dc.w $10
		dc.w 8
		dc.w 8
; ---------------------------------------------------------------------------

Obj_AIZ_Miniboss:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_68A36(pc,d0.w),d1
		jsr	off_68A36(pc,d1.w)
		bra.w	loc_68F62
; ---------------------------------------------------------------------------
off_68A36:	dc.w loc_68A46-off_68A36

		dc.w loc_68A6E-off_68A36
		dc.w loc_68574-off_68A36
		dc.w loc_68ABA-off_68A36
		dc.w loc_685FC-off_68A36
		dc.w loc_68B1C-off_68A36
		dc.w loc_68B68-off_68A36
		dc.w loc_68BBC-off_68A36
; ---------------------------------------------------------------------------

loc_68A46:
		lea	ObjDat3_68FFE(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#6,$29(a0)
		move.b	#1,($FFFFF7AA).w
		moveq	#$5A,d0
		jsr	(Load_PLC).l
		lea	Pal_AIZMiniboss(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_68A6E:
		move.w	($FFFFEE78).w,d0
		move.w	#$10E0,d5
		cmpi.b	#2,($FFFFB038).w
		bne.s	loc_68A82
		move.w	#$10C0,d5

loc_68A82:
		cmp.w	d5,d0
		bcc.s	loc_68A88
		rts
; ---------------------------------------------------------------------------

loc_68A88:
		move.l	#loc_68A94,$34(a0)
		bra.w	loc_68556
; ---------------------------------------------------------------------------

loc_68A94:
		move.l	#loc_68ACC,$34(a0)
		move.b	#6,5(a0)
		bsr.w	sub_6859C
		lea	ChildObjDat_6905C(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	ChildObjDat_69086(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_68ABA:
		jsr	(MoveSprite2).l
		jsr	(Obj_Wait).l
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_68ACC:

		move.l	#loc_68ADE,$34(a0)
		move.w	#$14,$2E(a0)
		bra.w	loc_685D8
; ---------------------------------------------------------------------------

loc_68ADE:
		move.l	#loc_68AFE,$34(a0)
		move.w	#$1E,$2E(a0)
		cmpi.b	#2,($FFFFB038).w
		bne.w	locret_68572
		bset	#1,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_68AFE:
		move.b	#$A,5(a0)
		move.b	#8,$39(a0)
		moveq	#$4F,d0
		jsr	(Play_Sound_2).l
		lea	Child1_AIZ_MinibossFlames(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_68B1C:
		jsr	(Swing_UpAndDown_Count).l
		beq.s	loc_68B28
		tst.w	d1
		bmi.s	loc_68B34

loc_68B28:
		jsr	(MoveSprite2).l
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_68B34:

		move.b	#6,5(a0)
		move.w	#$5F,$2E(a0)
		move.l	#loc_68B74,$34(a0)
		move.w	#-$100,d0
		bchg	#2,$38(a0)
		beq.s	loc_68B5E
		neg.w	d0
		move.l	#loc_68ACC,$34(a0)

loc_68B5E:
		move.w	d0,$1A(a0)
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_68B68:
		jsr	(Obj_Wait).l
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_68B74:
		move.l	#loc_68B92,$34(a0)

loc_68B7C:
		move.b	#$C,5(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		move.w	#$10,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_68B92:
		move.b	#$E,5(a0)
		move.b	#4,$39(a0)
		move.l	#loc_68BDC,$34(a0)
		move.w	#$100,d0
		bchg	#3,$38(a0)
		bne.s	loc_68BB4
		neg.w	d0

loc_68BB4:
		move.w	d0,$18(a0)
		bra.w	Swing_Setup1
; ---------------------------------------------------------------------------

loc_68BBC:
		jsr	(Swing_UpAndDown_Count).l
		bne.s	loc_68BD0
		jsr	(MoveSprite2).l
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_68BD0:
		movea.l	$34(a0),a1
		jsr	(a1)
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_68BDC:
		move.b	#4,$39(a0)
		move.l	#loc_68BF6,$34(a0)
		bchg	#0,4(a0)
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_68BF6:
		move.l	#loc_68B34,$34(a0)
		bra.w	loc_68B7C
; ---------------------------------------------------------------------------

loc_68C02:
		jsr	(Obj_EndSignControl).l
		lea	ChildObjDat_6910C(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_68C12:

		jsr	(Refresh_ChildPositionAdjusted).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	word_68C2C(pc,d0.w),d1
		jsr	word_68C2C(pc,d1.w)
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------
word_68C2C:	dc.w loc_68754-word_68C2C

		dc.w loc_68C38-word_68C2C
		dc.w loc_68574-word_68C2C
		dc.w loc_6879C-word_68C2C
		dc.w loc_6879C-word_68C2C
		dc.w locret_68572-word_68C2C
; ---------------------------------------------------------------------------

loc_68C38:
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		bne.s	loc_68C46
		rts
; ---------------------------------------------------------------------------

loc_68C46:
		move.b	#4,5(a0)
		move.l	#loc_68C58,$34(a0)
		bra.w	loc_68EC0
; ---------------------------------------------------------------------------

loc_68C58:
		move.l	#loc_68C64,$34(a0)
		bra.w	loc_6878C
; ---------------------------------------------------------------------------

loc_68C64:
		move.b	#8,5(a0)
		move.l	#loc_68C84,$34(a0)
		move.l	#byte_69136,$30(a0)
		lea	ChildObjDat_690A8(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_68C84:
		move.b	#2,5(a0)
		movea.w	$46(a0),a1
		bclr	#1,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_68C96:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_68CC6(pc,d0.w),d1
		jsr	off_68CC6(pc,d1.w)
		movea.w	$46(a0),a1
		movea.w	$46(a1),a1
		btst	#7,$2A(a1)
		bne.s	loc_68CC0
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_68CC0:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------
off_68CC6:	dc.w loc_68CD0-off_68CC6

		dc.w loc_68CF4-off_68CC6
		dc.w loc_68574-off_68CC6
		dc.w loc_68D42-off_68CC6
		dc.w loc_68D5E-off_68CC6
; ---------------------------------------------------------------------------

loc_68CD0:
		bsr.w	sub_6885A
		movea.w	$46(a0),a1
		cmpi.l	#loc_6872C,(a1)
		bne.s	loc_68CE4
		clr.b	$28(a0)

loc_68CE4:
		move.l	#loc_68D06,$34(a0)
		move.b	#8,$1E(a0)
		rts
; ---------------------------------------------------------------------------

loc_68CF4:
		jsr	(Animate_Raw).l
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_68D06:
		move.b	#4,5(a0)
		move.w	#8,$2E(a0)
		move.l	#loc_68D1C,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_68D1C:
		move.b	#6,5(a0)
		move.l	#loc_68D48,$34(a0)
		bset	#1,4(a0)
		bsr.w	sub_68ED4
		move.w	($FFFFEE7C).w,d0
		subi.w	#$20,d0
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_68D42:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_68D48:
		move.b	#8,5(a0)
		move.w	#$80,8(a0)
		move.l	#loc_68D70,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_68D5E:
		jsr	(Animate_Raw).l
		jsr	(MoveSprite2).l
		jmp	(ObjHitFloor_DoRoutine).l
; ---------------------------------------------------------------------------

loc_68D70:
		moveq	#$4E,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_690D8(pc),a2
		jsr	(CreateChild1_Normal).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_68D88:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_68D96(pc,d0.w),d1
		jmp	off_68D96(pc,d1.w)
; ---------------------------------------------------------------------------
off_68D96:	dc.w loc_68D9C-off_68D96

		dc.w loc_68DD8-off_68D96
		dc.w loc_68DEE-off_68D96
; ---------------------------------------------------------------------------

loc_68D9C:

		lea	ObjDat3_69032(pc),a1
		jsr	(SetUp_ObjAttributes).l
		cmpi.b	#0,($FFFFFE10).w
		beq.s	loc_68DB4
		move.w	#$500,$A(a0)

loc_68DB4:
		movea.w	$46(a0),a1
		tst.b	$28(a1)
		bne.s	loc_68DC2
		clr.b	$28(a0)

loc_68DC2:
		move.l	#AniRaw_BossExplosion,$30(a0)
		move.l	#loc_68DDE,$34(a0)
		moveq	#$C,d1
		bra.w	loc_68928
; ---------------------------------------------------------------------------

loc_68DD8:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_68DDE:
		move.b	#4,5(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_68DEE:
		jsr	(Animate_RawMultiDelay).l
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_68DFA:
		lea	ObjDat3_6904A(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_68E7E,(a0)
		move.l	#loc_68E84,$34(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	($FFFFEE78).w,d1
		move.w	word_68E48(pc,d0.w),d2
		add.w	d2,d1
		move.w	d1,$10(a0)
		move.w	($FFFFEE7C).w,d1
		move.w	word_68E54(pc,d0.w),d2
		move.w	d2,$14(a0)
		move.w	byte_68E60(pc,d0.w),$18(a0)
		move.w	byte_68E60(pc,d0.w),$2E(a0)
		lsr.w	#1,d0
		move.b	byte_68E78(pc,d0.w),$22(a0)
		rts
; ---------------------------------------------------------------------------
word_68E48:	dc.w $FFE0
		dc.w $FF98
		dc.w $FFF0
		dc.w $FFA8
		dc.w $FFF8
		dc.w $FFB0
word_68E54:	dc.w $310
		dc.w $310
		dc.w $31C
		dc.w $31C
		dc.w $328
		dc.w $328
byte_68E60:	dc.b 2
		dc.b 0
		dc.b 2
		dc.b 0
		dc.b 1
		dc.b $80
		dc.b 1
		dc.b $80
		dc.b 1
		dc.b 0
		dc.b 1
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
byte_68E78:	dc.b 0
		dc.b 0
		dc.b 1
		dc.b 1
		dc.b 2
		dc.b 2
; ---------------------------------------------------------------------------

loc_68E7E:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_68E84:
		move.l	#loc_68E8C,(a0)
		rts
; ---------------------------------------------------------------------------

loc_68E8C:
		jsr	(MoveSprite2).l
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------

loc_68E98:

		lea	word_69056(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#Obj_FlickerMove,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		addi.b	#$E,d0
		move.b	d0,$22(a0)
		moveq	#8,d0
		jmp	(Set_IndexedVelocity).l
; ---------------------------------------------------------------------------

loc_68EC0:

		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_68ECE(pc,d0.w),$2E(a0)
		rts
; ---------------------------------------------------------------------------
word_68ECE:	dc.w 0
		dc.w $10
		dc.w $20

; =============== S U B R O U T I N E =======================================


sub_68ED4:
		movea.w	$46(a0),a1
		moveq	#0,d0
		move.b	$2C(a1),d0
		move.w	word_68F28(pc,d0.w),$2E(a0)
; End of function sub_68ED4


; =============== S U B R O U T I N E =======================================


sub_68EE4:
		lsr.w	#1,d0
		move.b	$39(a1),d1
		addq.b	#4,d1
		move.b	d1,$39(a1)
		andi.w	#$C,d1
		add.w	d1,d0
		lea	byte_68F2E(pc),a2
		lea	word_68F4E(pc),a3
		btst	#0,4(a1)
		beq.s	loc_68F0E
		lea	byte_68F3E(pc),a2
		lea	word_68F58(pc),a3

loc_68F0E:
		move.b	(a2,d0.w),d0
		add.w	d0,d0
		move.w	(a3,d0.w),d0
		add.w	($FFFFEE78).w,d0
		move.w	d0,$10(a0)
		move.w	#$400,$1A(a0)
		rts
; End of function sub_68EE4

; ---------------------------------------------------------------------------
word_68F28:	dc.w 0
		dc.w $20
		dc.w $40
byte_68F2E:	dc.b 2
		dc.b 3
		dc.b 4
		dc.b 0
		dc.b 0
		dc.b 2
		dc.b 4
		dc.b 0
		dc.b 1
		dc.b 3
		dc.b 4
		dc.b 0
		dc.b 0
		dc.b 1
		dc.b 4
		dc.b 0
byte_68F3E:	dc.b 3
		dc.b 2
		dc.b 0
		dc.b 0
		dc.b 4
		dc.b 3
		dc.b 1
		dc.b 0
		dc.b 4
		dc.b 2
		dc.b 0
		dc.b 0
		dc.b 3
		dc.b 2
		dc.b 1
		dc.b 0
word_68F4E:	dc.w $24
		dc.w $4C
		dc.w $74
		dc.w $9C
		dc.w $C4
word_68F58:	dc.w $7C
		dc.w $A4
		dc.w $CC
		dc.w $F4
		dc.w $11C
; ---------------------------------------------------------------------------

loc_68F62:

		tst.b	$28(a0)
		bne.s	locret_68FB4
		tst.b	$29(a0)
		beq.s	loc_68FB6
		tst.b	$20(a0)
		bne.s	loc_68F88
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		bset	#6,$2A(a0)

loc_68F88:
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_68F94
		addq.w	#8,d0

loc_68F94:
		lea	word_68FE6(pc),a1
		lea	word_68FEE(pc,d0.w),a2
		jsr	(CopyWordData_4).l
		subq.b	#1,$20(a0)
		bne.s	locret_68FB4
		bclr	#6,$2A(a0)
		move.b	$25(a0),$28(a0)

locret_68FB4:

		rts
; ---------------------------------------------------------------------------

loc_68FB6:
		move.l	#Wait_FadeToLevelMusic,(a0)
		move.l	#loc_68C02,$34(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_68FE0
		move.b	#$10,$2C(a1)

loc_68FE0:
		jmp	(BossDefeated_StopTimer).l
; ---------------------------------------------------------------------------
word_68FE6:	dc.w  $FC2E, $FC34, $FC36, $FC3C
word_68FEE:	dc.w   $644,  $240,   $20,  $644
		dc.w   $888,  $AAA,  $EEE,  $AAA
ObjDat3_68FFE:	dc.l Map_AIZMiniboss

		dc.w $A41A
		dc.w $200
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b $F
word_6900A:	dc.w $841A
		dc.w $180
		dc.b $28
		dc.b $10
		dc.b 2
		dc.b $9C
word_69012:	dc.w $A41A
		dc.w $200
		dc.b 4
		dc.b 8
		dc.b 6
		dc.b 0
word_6901A:	dc.w $A41A
		dc.w $280
		dc.b 8
		dc.b 8
		dc.b 3
		dc.b 0
byte_69022:	dc.b 4
		dc.b $1A
		dc.b 2
		dc.b 0
		dc.b 8
		dc.b 8
		dc.b 7
		dc.b 0
word_6902A:	dc.w $41A
		dc.w $280
		dc.b 8
		dc.b $10
		dc.b $C
		dc.b $98
ObjDat3_69032:	dc.l Map_BossExplosion
		dc.w $4D2
		dc.w $80
		dc.b $C
		dc.b $C
		dc.b 0
		dc.b $97
ObjDat3_6903E:	dc.l Map_AIZMinibossFlame
		dc.w $8482
		dc.w $100
		dc.b $10
		dc.b $10
		dc.b 0
		dc.b $8B
ObjDat3_6904A:	dc.l Map_AIZMinibossSmall
		dc.w $2474
		dc.w $380
		dc.b $10
		dc.b $10
		dc.b 0
		dc.b 0
word_69056:	dc.w $200
		dc.b $10
		dc.b $14
		dc.b 0
		dc.b 0
ChildObjDat_6905C:dc.w 1

		dc.l loc_686BE
		dc.w $20
		dc.l loc_6870A
		dc.w $DC08
ChildObjDat_6906A:dc.w 5
		dc.l loc_68DFA
		dc.w 0
ChildObjDat_69072:dc.w 2
		dc.l loc_6872C
		dc.w $E0
		dc.l loc_6872C
		dc.w $9E4
		dc.l loc_6872C
		dc.w $12E8
ChildObjDat_69086:dc.w 2
		dc.l loc_68C12
		dc.w $E0
		dc.l loc_68C12
		dc.w $9E4
		dc.l loc_68C12
		dc.w $12E8
ChildObjDat_6909A:dc.w 1
		dc.l loc_6880A
		dc.w 4
		dc.l loc_68844
		dc.w 4
ChildObjDat_690A8:dc.w 1

		dc.l loc_6880A
		dc.w 4
		dc.l loc_68C96
		dc.w 4
Child1_AIZ_MinibossFlames:dc.w 3

		dc.l Obj_AIZMiniboss_Flame
		dc.w $9C04
		dc.l Obj_AIZMiniboss_Flame
		dc.w $AC04
		dc.l Obj_AIZMiniboss_Flame
		dc.w $BC04
		dc.l Obj_AIZMiniboss_Flame
		dc.w $D403
ChildObjDat_690D0:dc.w 0
		dc.l loc_68994
		dc.w 0
ChildObjDat_690D8:dc.w 6

		dc.l loc_68D88
		dc.w $DC
		dc.l loc_68D88
		dc.w $8E4
		dc.l loc_68D88
		dc.w $F8E4
		dc.l loc_68D88
		dc.w $4EC
		dc.l loc_68D88
		dc.w $FCEC
		dc.l loc_68D88
		dc.w $4FC
		dc.l loc_68D88
		dc.w $FCFC
ChildObjDat_69104:dc.w 0
		dc.l Obj_BossExplosionSpecial
		dc.w 0
ChildObjDat_6910C:dc.w 3
		dc.l loc_68E98
		dc.w $F0F8
		dc.l loc_68E98
		dc.w $CF0
		dc.l loc_68E98
		dc.w $F014
		dc.l loc_68E98
		dc.w $100C
byte_69126:	dc.b 1
		dc.b 1
		dc.b 2
		dc.b $FC
		dc.b 7
		dc.b 3
		dc.b 4
		dc.b 5
		dc.b $F4
byte_6912F:	dc.b 3
		dc.b 5
		dc.b 4
		dc.b 5
		dc.b 5
		dc.b $17
		dc.b $F4
byte_69136:	dc.b 5

		dc.b $17
		dc.b 5
		dc.b $17
		dc.b 4
		dc.b 5
		dc.b 3
		dc.b 5
		dc.b $F4
byte_6913F:	dc.b 7
		dc.b 1
		dc.b 7
		dc.b 1
		dc.b 8
		dc.b 1
		dc.b 9
		dc.b 3
		dc.b $A
		dc.b 3
		dc.b $B
		dc.b 3
		dc.b $F4
byte_6914C:	dc.b 1
		dc.b $C
		dc.b $D
		dc.b $FC
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 1
		dc.b 1
		dc.b 2
		dc.b 2
		dc.b 3
		dc.b 3
		dc.b 4
		dc.b 4
		dc.b 5
		dc.b 4
		dc.b $F4
byte_6915F:	dc.b 0
		dc.b 1
		dc.b 0
		dc.b 1
		dc.b $F4
byte_69164:	dc.b 2
		dc.b 1
		dc.b 2
		dc.b 1
		dc.b 3
		dc.b 2
		dc.b 4
		dc.b 4
		dc.b 5
		dc.b 1
		dc.b $F4
byte_6916F:	dc.b 0
		dc.b 1
		dc.b 0
		dc.b 1
		dc.b 1
		dc.b 2
		dc.b 2
		dc.b 2
		dc.b 3
		dc.b 4
		dc.b 4
		dc.b 4
		dc.b $F4
Pal_AIZMiniboss:	binclude "Levels\AIZ\Palettes\Miniboss.bin"


AIZBossSonicDat:	dc.w $4880
		dc.w $48E0
		dc.w $15A
AIZBossKnuxDat:	dc.w $4100
		dc.w $4160
		dc.w $5DA
; ---------------------------------------------------------------------------

Obj_AIZ_EndBoss:
		move.l	#Obj_AIZ_EndBossWait,(a0)
		lea	AIZBossSonicDat(pc),a1
		cmpi.b	#2,($FFFFB038).w
		bne.s	loc_691BE
		lea	AIZBossKnuxDat(pc),a1

loc_691BE:
		lea	($FFFFFA82).w,a2
		move.w	(a1)+,(a2)+
		move.w	(a1)+,(a2)+
		move.w	(a1)+,(a2)+			; Load relative positional data depending on the character

Obj_AIZ_EndBossWait:
		move.w	($FFFFFA82).w,d0
		cmp.w	($FFFFEE78).w,d0
		bls.s	loc_691D4			; Only branch if Sonic has reached the boss area
		rts
; ---------------------------------------------------------------------------

loc_691D4:
		move.w	d0,($FFFFEE14).w

loc_691D8:
		move.w	d0,($FFFFEE16).w
		move.l	#Obj_Wait,(a0)			; Set up object to wait $78 frames
		move.w	#$78,$2E(a0)
		move.l	#Obj_AIZ_EndBossMusic,$34(a0)
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		move.b	#1,($FFFFF7AA).w		; Lock the screen
		clr.b	($FFFFFAA2).w
		clr.b	($FFFFFAA3).w
		moveq	#$6B,d0
		jsr	(Load_PLC).l					; Load Robotnik's ship and explosions
		lea	(ArtKosM_AIZEndBoss).l,a1
		move.w	#$3000,d2
		jsr	(Queue_Kos_Module).l		; Load the AIZ boss ship
		lea	Pal_AIZEndBoss(pc),a1
		jmp	(PalLoad_Line1).l				; Load the AIZ boss palette
; ---------------------------------------------------------------------------

Obj_AIZ_EndBossMusic:
		move.l	#Obj_AIZ_EndBossMain,(a0)
		moveq	#$19,d0					; Play the boss music
		jsr	(Play_Sound).l
		move.b	#$19,($FFFFFF91).w
		rts
; ---------------------------------------------------------------------------

Obj_AIZ_EndBossMain:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	AIZ_EndBossIndex(pc,d0.w),d1
		jsr	AIZ_EndBossIndex(pc,d1.w)
		btst	#6,$38(a0)
		bne.w	locret_69366			; Only draw and touch when boss has revealed itself
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
AIZ_EndBossIndex:	dc.w Obj_AIZ_EndBossInit-AIZ_EndBossIndex

		dc.w loc_692E2-AIZ_EndBossIndex
		dc.w loc_6932C-AIZ_EndBossIndex
		dc.w loc_69368-AIZ_EndBossIndex
		dc.w loc_693F0-AIZ_EndBossIndex
		dc.w loc_692E2-AIZ_EndBossIndex
		dc.w loc_69456-AIZ_EndBossIndex
		dc.w loc_6946A-AIZ_EndBossIndex
; ---------------------------------------------------------------------------

Obj_AIZ_EndBossInit:
		lea	ObjDat_AIZEndBoss(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#8,$29(a0)			; 8 hits defeats it
		bset	#0,4(a0)
		lea	(word_6818C).l,a2
		jsr	(CreateChild1_Normal).l
		bne.s	loc_69296
		move.b	#8,$2C(a1)

loc_69296:
		lea	ChildObjDat_69D18(pc),a2
		jsr	(CreateChild1_Normal).l

loc_692A0:
		move.b	#2,5(a0)
		moveq	#$4B,d0
		jsr	(Play_Sound_2).l
		ori.b	#$48,$38(a0)
		move.l	#loc_69302,$34(a0)
		clr.b	$28(a0)
		bsr.w	sub_69C94
		bclr	#0,4(a0)
		cmpi.w	#8,$26(a0)
		bcc.s	loc_692D8
		bset	#0,4(a0)

loc_692D8:
		lea	ChildObjDat_69D2E(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_692E2:
		lea	byte_69D98(pc),a1
		jsr	(Animate_RawNoSSTMultiDelay).l
		bclr	#6,$38(a0)
		cmpi.b	#$2B,$22(a0)
		bne.s	locret_69300
		bset	#6,$38(a0)

locret_69300:
		rts
; ---------------------------------------------------------------------------

loc_69302:
		move.b	#4,5(a0)
		bclr	#6,$38(a0)
		bset	#7,$A(a0)
		move.b	#$16,$28(a0)
		move.l	#loc_6933A,$34(a0)
		lea	ChildObjDat_69D36(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6932C:
		lea	byte_69DB3(pc),a1
		jsr	(Animate_RawNoSSTMultiDelay).l
		bra.w	sub_69BE2
; ---------------------------------------------------------------------------

loc_6933A:
		move.b	#6,5(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_6937E,$34(a0)
		move.w	#$C0,d0
		move.w	d0,$3E(a0)
		move.w	d0,$1A(a0)
		move.w	#$10,$40(a0)
		bclr	#0,$38(a0)

locret_69366:

		rts
; ---------------------------------------------------------------------------

loc_69368:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jsr	(Obj_Wait).l
		bra.w	sub_69BE2
; ---------------------------------------------------------------------------

loc_6937E:
		bset	#1,$38(a0)
		btst	#7,$38(a0)
		bne.s	loc_693A2
		move.w	#4,$26(a0)
		move.w	#$2F,$2E(a0)
		move.l	#loc_693DC,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_693A2:
		move.w	#$BF,d0
		cmpi.b	#2,($FFFFB038).w
		bne.s	loc_693B2
		move.w	#$FF,d0

loc_693B2:
		move.w	d0,$2E(a0)
		move.l	#loc_693C0,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_693C0:

		move.b	#8,5(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_693FA,$34(a0)
		andi.b	#-$B,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_693DC:
		st	($FFFFFAA2).w
		move.w	#$8F,$2E(a0)
		move.l	#loc_693C0,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_693F0:
		bsr.w	sub_69BE2
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_693FA:
		move.b	#$A,5(a0)
		moveq	#$4B,d0
		jsr	(Play_Sound_2).l
		move.l	#loc_6942A,$34(a0)
		clr.b	$28(a0)
		bsr.w	sub_69C94
		lea	ChildObjDat_69D2E(pc),a2
		jsr	(CreateChild1_Normal).l
		move.b	#2,$2C(a1)
		rts
; ---------------------------------------------------------------------------

loc_6942A:
		move.b	#$C,5(a0)
		bset	#7,$38(a0)
		beq.s	loc_6943E
		move.b	#$E,5(a0)

loc_6943E:
		move.l	#loc_69476,$34(a0)
		bclr	#7,$A(a0)
		move.b	#0,$22(a0)
		bra.w	loc_69A66
; ---------------------------------------------------------------------------

loc_69456:
		move.w	($FFFFEE14).w,d0
		addq.w	#2,d0
		cmp.w	($FFFFFA84).w,d0
		bhi.s	loc_69466
		move.w	d0,($FFFFEE14).w

loc_69466:
		addq.w	#2,($FFFFEE16).w

loc_6946A:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_69476:
		clr.w	$18(a0)
		clr.w	$1A(a0)
		bra.w	loc_692A0
; ---------------------------------------------------------------------------

loc_69482:
		move.l	#loc_694A4,$34(a0)
		st	($FFFFFAA3).w
		move.l	#Obj_Wait,(a0)
		bset	#4,$38(a0)
		lea	ChildObjDat_69D66(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_694A4:
		move.l	#loc_694D4,(a0)

loc_694AA:

		st	($FFFFFAA8).w
		clr.b	($FFFFF7AA).w
		lea	(PLC_CNZ2KnuxEnd).l,a1
		jsr	(Load_PLC_Raw).l
		lea	ChildObjDat_69D8C(pc),a2
		jsr	(CreateChild6_Simple).l
		bset	#1,4(a1)
		jmp	(PLCLoad_AnimalsAndExplosion).l
; ---------------------------------------------------------------------------

loc_694D4:
		tst.b	($FFFFFAA8).w
		bne.w	locret_69366
		move.l	#loc_69526,(a0)
		jsr	(Restore_PlayerControl).l
		lea	($FFFFB04A).w,a1
		jsr	(Restore_PlayerControl2).l
		jsr	(Obj_PlayLevelMusic).l
		st	($FFFFF7CA).w
		clr.w	($FFFFF602).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_6950E
		move.l	#loc_863C0,(a1)

loc_6950E:
		move.w	($FFFFFA84).w,d0
		addi.w	#$158,d0
		move.w	d0,($FFFFFA92).w
		lea	(Child6_IncLevX).l,a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_69526:
		move.b	#5,($FFFFF73F).w
		lea	($FFFFB000).w,a1
		move.w	($FFFFFA84).w,d0
		addi.w	#$1F8,d0
		cmp.w	$10(a1),d0
		bls.s	loc_69546
		move.w	#$808,($FFFFF602).w
		rts
; ---------------------------------------------------------------------------

loc_69546:
		jsr	(Stop_Object).l
		cmpi.b	#2,($FFFFB038).w
		beq.s	loc_6957A
		move.l	#loc_69588,(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_6956E
		move.l	#Obj_CutsceneKnuckles,(a1)
		move.b	#4,$2C(a1)

loc_6956E:
		lea	(PLC_83D6C).l,a1
		jmp	(Load_PLC_Raw).l
; ---------------------------------------------------------------------------

loc_6957A:
		move.l	#loc_695CE,(a0)
		move.w	#$2020,($FFFFF602).w
		rts
; ---------------------------------------------------------------------------

loc_69588:
		move.b	#5,($FFFFF73F).w
		tst.b	($FFFFF7CA).w
		beq.s	loc_695A0
		move.w	#$101,($FFFFF602).w
		clr.w	($FFFFF66A).w
		rts
; ---------------------------------------------------------------------------

loc_695A0:
		move.l	#loc_695A8,(a0)
		rts
; ---------------------------------------------------------------------------

loc_695A8:
		move.b	#5,($FFFFF73F).w

loc_695AE:
		move.w	($FFFFFA86).w,d0
		addi.w	#$1E6,d0
		cmp.w	($FFFFB014).w,d0
		bhi.w	locret_69366
		move.w	#$100,d0
		jsr	(StartNewLevel).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_695CE:
		move.w	#$2000,($FFFFF602).w
		lea	($FFFFB000).w,a1
		bset	#7,$A(a1)
		tst.w	$1A(a1)
		bmi.w	locret_69366
		move.l	#loc_69616,(a0)
		move.b	#-$7D,$2E(a1)
		move.b	#-$35,$22(a1)
		jsr	(Player_Load_PLC).l
		move.w	#$1000,d0
		move.w	d0,($FFFFFA98).w
		move.w	d0,($FFFFEE12).w
		lea	(Child6_IncLevY).l,a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_69616:
		lea	($FFFFB000).w,a1
		jsr	(MoveSprite_NormGravity).l
		bra.s	loc_695AE
; ---------------------------------------------------------------------------

loc_69622:

		jsr	(Refresh_ChildPositionAdjusted).l
		bsr.w	Child_SyncDraw
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6964E(pc,d0.w),d1
		jsr	off_6964E(pc,d1.w)
		btst	#6,$38(a0)
		bne.w	locret_69366
		bsr.w	sub_69CA4
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_6964E:	dc.w loc_6965A-off_6964E

		dc.w loc_69682-off_6964E
		dc.w loc_696B4-off_6964E
		dc.w loc_696CA-off_6964E
		dc.w loc_696E2-off_6964E
		dc.w loc_69704-off_6964E
; ---------------------------------------------------------------------------

loc_6965A:
		lea	word_69CE0(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		moveq	#0,d0
		tst.b	$2C(a0)
		beq.s	loc_69678
		move.b	#$2A,$22(a0)
		move.w	#$280,8(a0)

loc_69678:
		lea	ChildObjDat_69D26(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_69682:
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		bne.s	loc_69690
		rts
; ---------------------------------------------------------------------------

loc_69690:
		tst.b	$2C(a0)
		bne.s	loc_696AC
		move.b	#4,5(a0)
		move.w	#4,$2E(a0)
		move.l	#loc_696BA,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_696AC:
		move.b	#8,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_696B4:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_696BA:
		move.b	#6,5(a0)
		move.l	#loc_696DA,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_696CA:
		bclr	#6,$38(a0)
		lea	byte_69DBE(pc),a1
		jmp	(Animate_RawNoSSTMultiDelay).l
; ---------------------------------------------------------------------------

loc_696DA:
		move.b	#8,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_696E2:
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		bne.s	loc_696F0
		rts
; ---------------------------------------------------------------------------

loc_696F0:
		move.b	#$A,5(a0)
		bset	#1,$38(a0)
		move.w	$26(a1),$26(a0)
		rts
; ---------------------------------------------------------------------------

loc_69704:
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		beq.s	loc_69712
		rts
; ---------------------------------------------------------------------------

loc_69712:
		move.b	#2,5(a0)
		bclr	#1,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_69720:
		move.l	#Obj_FlickerMove,(a0)
		move.b	#1,$22(a0)
		clr.b	$28(a0)
		moveq	#$C,d0
		jmp	(Set_IndexedVelocity).l
; ---------------------------------------------------------------------------

loc_69738:
		bsr.w	Child_SyncDraw
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_69760(pc,d0.w),d1
		jsr	off_69760(pc,d1.w)
		jsr	(Refresh_ChildPositionAdjusted).l
		btst	#6,$38(a0)
		bne.w	locret_69366
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------
off_69760:	dc.w loc_69768-off_69760

		dc.w loc_69774-off_69760
		dc.w loc_697BA-off_69760
		dc.w loc_6981E-off_69760
; ---------------------------------------------------------------------------

loc_69768:
		lea	word_69CE6(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		rts
; ---------------------------------------------------------------------------

loc_69774:
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		bne.s	loc_69782
		rts
; ---------------------------------------------------------------------------

loc_69782:
		move.b	#4,5(a0)
		move.b	#1,$23(a0)
		bset	#1,$38(a0)
		move.b	#1,$3A(a0)
		move.l	#loc_697D8,$34(a0)
		move.w	$26(a1),$26(a0)
		clr.w	$2E(a0)
		tst.b	$2C(a1)
		beq.s	locret_697B8
		move.w	#$4F,$2E(a0)

locret_697B8:
		rts
; ---------------------------------------------------------------------------

loc_697BA:
		subq.w	#1,$2E(a0)
		bpl.s	locret_697D6
		move.w	#3,$2E(a0)
		bsr.w	sub_69AD8
		subq.b	#1,$23(a0)
		bpl.s	locret_697D6
		movea.l	$34(a0),a1
		jsr	(a1)

locret_697D6:

		rts
; ---------------------------------------------------------------------------

loc_697D8:
		move.b	#6,5(a0)
		cmpi.b	#2,($FFFFB038).w
		beq.s	loc_69802

loc_697E6:
		movea.w	$46(a0),a1
		bclr	#1,$38(a1)
		move.w	#$5F,$2E(a0)
		move.l	#loc_69824,$34(a0)
		bra.w	loc_69B5E
; ---------------------------------------------------------------------------

loc_69802:
		subq.b	#1,$3A(a0)
		bmi.s	loc_697E6
		move.w	#$2F,$2E(a0)
		bra.w	loc_69B5E
; ---------------------------------------------------------------------------

loc_69812:
		move.b	#2,5(a0)
		clr.b	$39(a0)
		rts
; ---------------------------------------------------------------------------

loc_6981E:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_69824:
		move.b	#4,5(a0)
		move.b	#1,$23(a0)
		bclr	#1,$38(a0)
		clr.w	$2E(a0)
		move.l	#loc_69812,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_69844:

		lea	word_69CEC(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_6989E,(a0)
		bset	#4,$2B(a0)
		move.l	#loc_698BC,$34(a0)
		movea.w	$46(a0),a1
		movea.w	$46(a1),a2
		movea.w	$46(a2),a2
		move.w	a2,$44(a0)
		move.w	$26(a1),d0
		move.w	d0,$26(a0)
		move.l	off_6988E(pc,d0.w),$30(a0)
		cmpi.w	#8,d0
		bcc.s	locret_6988C
		bset	#0,4(a0)

locret_6988C:
		rts
; ---------------------------------------------------------------------------
off_6988E:	dc.l word_69DC9
		dc.l word_69DF3
		dc.l word_69DF3
		dc.l word_69DC9
; ---------------------------------------------------------------------------

loc_6989E:
		movea.w	$44(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_698C6
		jsr	(Refresh_ChildPosition).l
		jsr	(Animate_Raw).l
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_698BC:
		lea	ChildObjDat_69D56(pc),a2
		jsr	(CreateChild1_Normal).l

loc_698C6:
		bset	#6,$38(a0)
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_698D2:
		lea	word_69CF2(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		bset	#4,$2B(a0)
		moveq	#$4D,d0
		jsr	(Play_Sound_2).l
		move.b	#$C,$1E(a0)
		move.w	#$9F,$2E(a0)
		move.l	#loc_69908,(a0)
		move.l	#loc_69946,$34(a0)
		bra.w	loc_69B7A
; ---------------------------------------------------------------------------

loc_69908:
		tst.w	$18(a0)
		beq.s	loc_69914
		jsr	(ObjHitFloor_DoRoutine).l

loc_69914:

		jsr	(Animate_Raw).l
		jsr	(MoveSprite2).l
		subq.w	#1,$2E(a0)
		bmi.s	loc_69940
		move.b	($FFFFFE0F).w,d0
		andi.b	#3,d0
		bne.s	loc_6993A
		lea	ChildObjDat_69D5E(pc),a2
		jsr	(CreateChild1_Normal).l

loc_6993A:
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_69940:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_69946:
		move.l	#loc_69914,(a0)
		move.l	#byte_69E29,$30(a0)
		clr.w	$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_6995A:
		lea	word_69CF8(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_6998A,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		move.l	#byte_69E2F,$30(a0)
		tst.w	$18(a0)
		bne.s	locret_69988
		move.l	#byte_69E38,$30(a0)

locret_69988:
		rts
; ---------------------------------------------------------------------------

loc_6998A:
		jsr	(Animate_RawMultiDelay).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_69996:
		lea	ObjDat_AIZEndBoss2(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_699B0,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_699B0:
		lea	byte_69E41(pc),a1
		jsr	(Animate_RawNoSSTMultiDelay).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_699C0:
		lea	word_69CFE(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#loc_699EA,(a0)
		tst.b	$2C(a0)
		bne.s	loc_699E0
		move.l	#Go_Delete_Sprite,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_699E0:
		move.l	#loc_69A04,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_699EA:
		lea	byte_69E4A(pc),a1
		jsr	(Animate_RawNoSSTMultiDelayFlipX).l
		cmpi.b	#$2B,$22(a0)
		beq.w	locret_69366
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_69A04:
		move.l	#loc_69A1A,(a0)
		move.w	#$800,$1A(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_69A1A:
		jsr	(MoveSprite2).l
		lea	byte_69E65(pc),a1
		jsr	(Animate_RawNoSSTMultiDelayFlipX).l
		cmpi.b	#$2B,$22(a0)
		beq.w	locret_69366
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_69A3A:

		lea	word_69D12(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#Obj_FlickerMove,(a0)
		move.b	$2C(a0),d0
		lsr.b	#1,d0
		addi.b	#$32,d0
		move.b	d0,$22(a0)
		moveq	#0,d0
		jsr	(Set_IndexedVelocity).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_69A66:

		jsr	(Random_Number).l
		andi.w	#$C,d0
		move.w	$26(a0),d1
		move.w	d0,$26(a0)
		cmp.w	d1,d0
		beq.s	loc_69A66
		lea	word_69AC8(pc,d0.w),a1
		moveq	#0,d2
		move.w	($FFFFFA84).w,d2
		add.w	(a1)+,d2
		swap	d2
		sub.l	$10(a0),d2
		add.l	d2,d2
		swap	d2
		move.w	d2,$18(a0)
		moveq	#0,d3
		move.w	($FFFFFA86).w,d3
		add.w	(a1)+,d3
		swap	d3
		sub.l	$14(a0),d3
		add.l	d3,d3
		swap	d3
		move.w	d3,$1A(a0)
		move.w	#$7F,$2E(a0)
		tst.w	d2
		beq.s	locret_69AC6
		bclr	#0,4(a0)
		tst.w	d2
		bmi.s	locret_69AC6
		bset	#0,4(a0)

locret_69AC6:

		rts
; ---------------------------------------------------------------------------
word_69AC8:	dc.w	$58,   $76
		dc.w	$A0,   $46
		dc.w   $160,   $46
		dc.w   $1A8,   $76

; =============== S U B R O U T I N E =======================================


sub_69AD8:
		move.w	$26(a0),d0
		moveq	#0,d1
		eori.w	#$C,d0
		beq.s	loc_69AEE
		cmpi.w	#$C,d0
		beq.s	loc_69AEE
		addi.w	#$10,d1

loc_69AEE:

		moveq	#0,d2
		move.b	$39(a0),d2
		add.w	d2,d1
		lea	byte_69B0E(pc,d1.w),a1
		move.b	(a1)+,$42(a0)
		move.b	(a1)+,$43(a0)
		move.b	(a1)+,$22(a0)
		addq.b	#4,d2
		move.b	d2,$39(a0)
		rts
; End of function sub_69AD8

; ---------------------------------------------------------------------------
byte_69B0E:	dc.b  $E8,   8,	  5,   0
		dc.b  $E8,   8,	  5,   0
		dc.b  $E4,   0,	  4,   0
		dc.b  $E4,   0,	  4,   0
		dc.b  $E8,   8,	  5,   0
		dc.b  $F0, $10,	  6,   0
		dc.b  $E8,   8,	  5,   0
		dc.b  $E4,   0,	  4,   0

; =============== S U B R O U T I N E =======================================


Child_SyncDraw:

		movea.w	$46(a0),a1
		btst	#6,$38(a1)
		bne.s	loc_69B56
		bclr	#6,$38(a0)
		bset	#7,$A(a0)
		btst	#7,$A(a1)
		bne.s	locret_69B54
		bclr	#7,$A(a0)

locret_69B54:
		rts
; ---------------------------------------------------------------------------

loc_69B56:
		bset	#6,$38(a0)
		rts
; End of function Child_SyncDraw

; ---------------------------------------------------------------------------

loc_69B5E:

		move.w	$26(a0),d0
		lsr.w	#1,d0
		move.w	off_69B72(pc,d0.w),d0
		lea	off_69B72(pc,d0.w),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------
off_69B72:	dc.w ChildObjDat_69D3E-off_69B72

		dc.w ChildObjDat_69D46-off_69B72
		dc.w ChildObjDat_69D46-off_69B72
		dc.w ChildObjDat_69D4E-off_69B72
; ---------------------------------------------------------------------------

loc_69B7A:
		movea.w	$46(a0),a1
		move.w	$26(a1),d0
		cmpi.w	#8,d0
		bcc.s	loc_69B8E
		bset	#0,4(a0)

loc_69B8E:
		move.l	off_69BB2(pc,d0.w),$30(a0)
		lea	word_69BC2(pc,d0.w),a1
		move.w	(a1)+,d1
		add.w	d1,$10(a0)
		move.w	(a1)+,d1
		add.w	d1,$14(a0)
		lea	word_69BD2(pc,d0.w),a1
		move.w	(a1)+,$18(a0)
		move.w	(a1)+,$1A(a0)
		rts
; ---------------------------------------------------------------------------
off_69BB2:	dc.l byte_69E1D
		dc.l byte_69E23
		dc.l byte_69E23
		dc.l byte_69E1D
word_69BC2:	dc.w	$14,   $14
		dc.w	  0,   $18
		dc.w	  0,   $18
		dc.w  $FFEC,   $14
word_69BD2:	dc.w   $300,  $300
		dc.w	  0,  $400
		dc.w	  0,  $400
		dc.w  $FD00,  $300

; =============== S U B R O U T I N E =======================================


sub_69BE2:

		tst.b	$28(a0)
		bne.s	locret_69C34
		tst.b	$29(a0)
		beq.s	loc_69C36
		tst.b	$20(a0)
		bne.s	loc_69C02
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l

loc_69C02:
		bset	#6,$2A(a0)
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_69C16
		addi.w	#$E,d0

loc_69C16:
		bsr.w	sub_69C5C
		subq.b	#1,$20(a0)
		bne.s	locret_69C34
		bclr	#6,$2A(a0)
		cmpi.b	#0,$22(a0)
		bne.s	locret_69C34
		move.b	$25(a0),$28(a0)

locret_69C34:

		rts
; ---------------------------------------------------------------------------

loc_69C36:
		move.l	#Wait_FadeToLevelMusic,(a0)
		bclr	#6,$38(a0)
		bset	#7,$A(a0)
		move.b	#0,$22(a0)
		move.l	#loc_69482,$34(a0)
		jmp	(BossDefeated_StopTimer).l
; End of function sub_69BE2


; =============== S U B R O U T I N E =======================================


sub_69C5C:

		lea	word_69C6A(pc),a1
		lea	word_69C78(pc,d0.w),a2
		jmp	(CopyWordData_7).l
; End of function sub_69C5C

; ---------------------------------------------------------------------------
word_69C6A:	dc.w $FC28
		dc.w $FC2E
		dc.w $FC32
		dc.w $FC34
		dc.w $FC36
		dc.w $FC3A
		dc.w $FC3C
word_69C78:	dc.w   $222,	 8,   $4C,     6,   $20,  $A24,	 $622,	$AAA,  $AAA,  $AAA,  $CCC,  $EEE,  $666,  $888

; =============== S U B R O U T I N E =======================================


sub_69C94:

		moveq	#0,d0
		bsr.s	sub_69C5C
		bclr	#6,$2A(a0)
		clr.b	$20(a0)
		rts
; End of function sub_69C94


; =============== S U B R O U T I N E =======================================


sub_69CA4:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_69CB2
		rts
; ---------------------------------------------------------------------------

loc_69CB2:
		move.l	#Wait_Draw,(a0)
		bset	#7,$2A(a0)
		move.b	#1,$22(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_69720,$34(a0)
		rts
; End of function sub_69CA4

; ---------------------------------------------------------------------------
ObjDat_AIZEndBoss:	dc.l Map_AIZEndBoss
		dc.w $A180		; VRAM
		dc.w $280		; Priority
		dc.b $28		; Width
		dc.b $20		; Height
		dc.b 0			; Frame
		dc.b $10		; Collision
word_69CE0:	dc.w $200
		dc.b $24
		dc.b $14
		dc.b 1
		dc.b 0
word_69CE6:	dc.w $180
		dc.b $C
		dc.b $C
		dc.b 4
		dc.b 0
word_69CEC:	dc.w $100
		dc.b 8
		dc.b 4
		dc.b $B
		dc.b $97
word_69CF2:	dc.w $100
		dc.b $14
		dc.b $18
		dc.b $F
		dc.b $9A
word_69CF8:	dc.w $100
		dc.b 8
		dc.b 8
		dc.b $18
		dc.b 0
word_69CFE:	dc.w $8180
		dc.w $100
		dc.b $30
		dc.b $30
		dc.b $24
		dc.b 0
ObjDat_AIZEndBoss2:	dc.l Map_AIZEndBoss
		dc.w $8180
		dc.w $100
		dc.b $18
		dc.b $10
		dc.b $21
		dc.b 0
word_69D12:	dc.w $180
		dc.b $10
		dc.b $10
		dc.b 0
		dc.b 0
ChildObjDat_69D18:dc.w 1
		dc.l loc_69622
		dc.w $14FC
		dc.l loc_69622
		dc.w $ECFC
ChildObjDat_69D26:dc.w 0
		dc.l loc_69738
		dc.w $E400
ChildObjDat_69D2E:dc.w 0

		dc.l loc_699C0
		dc.w 0
ChildObjDat_69D36:dc.w 0
		dc.l loc_69996
		dc.w $D0
ChildObjDat_69D3E:dc.w 0
		dc.l loc_69844
		dc.w $305
ChildObjDat_69D46:dc.w 0
		dc.l loc_69844
		dc.w 7
ChildObjDat_69D4E:dc.w 0
		dc.l loc_69844
		dc.w $FD05
ChildObjDat_69D56:dc.w 0
		dc.l loc_698D2
		dc.w 0
ChildObjDat_69D5E:dc.w 0
		dc.l loc_6995A
		dc.w 0
ChildObjDat_69D66:dc.w 5
		dc.l loc_69A3A
		dc.w $F0F0
		dc.l loc_69A3A
		dc.w $10F0
		dc.l loc_69A3A
		dc.w $F008
		dc.l loc_69A3A
		dc.w $1008
		dc.l loc_69A3A
		dc.w $F418
		dc.l loc_69A3A
		dc.w $C18
ChildObjDat_69D8C:dc.w 0
		dc.l Obj_81
		dc.w 0
		dc.l Obj_CutsceneKnuckles
byte_69D98:	dc.b  $2B,   0
		dc.b  $2B,   0
		dc.b  $2B,   0
		dc.b	0,   0
		dc.b  $2B,   0
		dc.b  $2B,   0
		dc.b	0,   0
		dc.b  $2B,   0
		dc.b  $2B,   0
		dc.b	0,   0
		dc.b  $2B,   0
		dc.b  $2B,   0
		dc.b	0,   0
		dc.b  $F4
byte_69DB3:	dc.b  $1B,   0
		dc.b  $1B,   4
		dc.b  $1C,   5
		dc.b  $1D,   6
		dc.b	0,   0
		dc.b  $F4
byte_69DBE:	dc.b  $1E,   0
		dc.b  $1E,   4
		dc.b  $1F,   5
		dc.b  $20,   6
		dc.b	1,   0
		dc.b  $F4
word_69DC9:	dc.w 7
		dc.w $2B07
		dc.w $2B08
		dc.w $2B08
		dc.w $2B09
		dc.w $2B09
		dc.w $2B0A
		dc.w $2B0A
		dc.w $2B0A
		dc.w $2B0A
		dc.w $2B0A
		dc.w $2B0A
		dc.w $2B0A
		dc.w $2B0A
		dc.w $2B0A
		dc.w $2B0A
		dc.w $2B0A
		dc.w $2B0A
		dc.w $2B0A
		dc.w $2B0A
		dc.w $2BF4
word_69DF3:	dc.w $B
		dc.w $2B0B
		dc.w $2B0C
		dc.w $2B0C
		dc.w $2B0D
		dc.w $2B0D
		dc.w $2B0E
		dc.w $2B0E
		dc.w $2B0E
		dc.w $2B0E
		dc.w $2B0E
		dc.w $2B0E
		dc.w $2B0E
		dc.w $2B0E
		dc.w $2B0E
		dc.w $2B0E
		dc.w $2B0E
		dc.w $2B0E
		dc.w $2B0E
		dc.w $2B0E
		dc.w $2BF4
byte_69E1D:	dc.b 1
		dc.b $26
		dc.b $27
		dc.b $28
		dc.b $29
		dc.b $FC
byte_69E23:	dc.b 1
		dc.b $16
		dc.b $17
		dc.b $2F
		dc.b $30
		dc.b $FC
byte_69E29:	dc.b 1
		dc.b $10
		dc.b $11
		dc.b $2D
		dc.b $2E
		dc.b $FC
byte_69E2F:	dc.b  $12,   0
		dc.b  $12,   9
		dc.b  $13,   2
		dc.b  $14,   2
		dc.b  $F4
byte_69E38:	dc.b  $18,   0
		dc.b  $18,   9
		dc.b  $19,   2
		dc.b  $1A,   2
		dc.b  $F4
byte_69E41:	dc.b  $21,   0
		dc.b  $21,   4
		dc.b  $22,   5
		dc.b  $23,   6
		dc.b  $F4
byte_69E4A:	dc.b  $2B,   0
		dc.b  $24,   0
		dc.b  $64,   0
		dc.b  $6B,   0
		dc.b  $2C,   0
		dc.b  $6C,   0
		dc.b  $6B,   0
		dc.b  $24,   0
		dc.b  $64,   0
		dc.b  $6B,   0
		dc.b  $2C,   0
		dc.b  $6C,   0
		dc.b  $6B,   0
		dc.b  $F4
byte_69E65:	dc.b  $2B,   0
		dc.b  $24,   0
		dc.b  $64,   0
		dc.b  $6B,   0
		dc.b  $2C,   0
		dc.b  $6C,   0
		dc.b  $6B,   0
		dc.b  $31,   0
		dc.b  $71,   0
		dc.b  $6B,   0
		dc.b  $31,   0
		dc.b  $71,   0
		dc.b  $6B,   0
		dc.b  $F4
Pal_AIZEndBoss:	binclude "Levels\AIZ\Palettes\End Boss.bin"

; ---------------------------------------------------------------------------

Obj_HCZMiniboss:
		lea	word_69ED2(pc),a1
		jsr	(Check_CameraInRange).l
		move.l	#loc_69EDA,(a0)
		move.b	#1,($FFFFF7AA).w
		st	($FFFFEEE8).w
		moveq	#$5B,d0
		jsr	(Load_PLC).l
		move.w	#$300,($FFFFEE18).w
		lea	ChildObjDat_6AD6E(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------
word_69ED2:	dc.w   $300,  $400, $3500, $3700
; ---------------------------------------------------------------------------

loc_69EDA:
		btst	#0,$38(a0)
		bne.s	loc_69EFE
		move.w	#$638,d0
		cmp.w	($FFFFEE7C).w,d0
		bhi.s	loc_69EFE
		bset	#0,$38(a0)
		move.w	d0,($FFFFEE18).w
		move.w	d0,($FFFFEE1A).w
		move.w	d0,($FFFFEE12).w

loc_69EFE:

		btst	#1,$38(a0)
		move.w	#$3680,d0
		move.w	($FFFFEE78).w,d1
		move.w	d1,($FFFFEE14).w
		cmp.w	d1,d0
		bhi.s	loc_69F22
		bset	#1,$38(a0)
		move.w	d0,($FFFFEE14).w
		move.w	d0,($FFFFEE16).w

loc_69F22:
		cmpi.b	#3,$38(a0)
		beq.s	loc_69F2C
		rts
; ---------------------------------------------------------------------------

loc_69F2C:
		move.w	($FFFFEE16).w,($FFFFFA92).w
		move.w	$14(a0),$44(a0)
		move.l	#Obj_Wait,(a0)
		move.w	#$78,$2E(a0)
		move.l	#loc_69F64,$34(a0)
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		bset	#3,$38(a0)
		lea	Pal_HCZMiniboss(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_69F64:
		move.l	#Obj_HCZ_MinibossLoop,(a0)
		moveq	#$2E,d0
		jsr	(Play_Sound).l
		move.b	#$2E,($FFFFFF91).w

locret_69F78:

		rts
; ---------------------------------------------------------------------------

Obj_HCZ_MinibossLoop:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_69F92(pc,d0.w),d1
		jsr	off_69F92(pc,d1.w)
		bsr.w	sub_6AC48
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_69F92:	dc.w loc_69FAA-off_69F92

		dc.w loc_69FE4-off_69F92
		dc.w loc_6A00A-off_69F92
		dc.w loc_69FE4-off_69F92
		dc.w loc_6A00A-off_69F92
		dc.w loc_6A076-off_69F92
		dc.w loc_6A0C2-off_69F92
		dc.w loc_6A0F8-off_69F92
		dc.w loc_6A110-off_69F92
		dc.w loc_6A15A-off_69F92
		dc.w loc_6A00A-off_69F92
		dc.w loc_6A216-off_69F92
; ---------------------------------------------------------------------------

loc_69FAA:
		lea	ObjDat3_6ACF0(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#6,$29(a0)
		move.b	#$28,$1E(a0)
		bset	#3,$38(a0)
		move.w	#$100,$1A(a0)
		move.w	#$DF,$2E(a0)
		move.l	#loc_69FF0,$34(a0)
		lea	Child1_HCZMiniboss_RocketsEngine(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_69FE4:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_69FF0:
		move.b	#4,5(a0)
		clr.w	$1A(a0)
		move.w	#$3B,$2E(a0)
		move.l	#loc_6A010,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A00A:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6A010:
		move.b	#6,5(a0)
		move.w	#-$400,$1A(a0)
		move.w	#$37,$2E(a0)
		move.l	#loc_6A02C,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A02C:
		move.b	#8,5(a0)
		move.w	#$3B,$2E(a0)
		move.l	#loc_6A042,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A042:

		bsr.w	sub_6AAD2

loc_6A046:
		move.b	#$A,5(a0)
		moveq	#$3C,d0
		jsr	(Play_Sound_2).l
		bset	#6,$38(a0)
		bclr	#7,$38(a0)
		move.w	#$400,$1A(a0)
		move.w	#$47,$2E(a0)
		move.l	#loc_6A098,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A076:
		btst	#7,$38(a0)
		bne.s	loc_6A08C
		move.w	$14(a0),d0
		cmp.w	($FFFFF646).w,d0
		bcs.s	loc_6A08C
		bsr.w	sub_6AAB6

loc_6A08C:

		jsr	(MoveSprite2).l
		jmp	(ObjHitFloor_DoRoutine).l
; ---------------------------------------------------------------------------

loc_6A098:
		move.b	#$C,5(a0)
		move.w	$40(a0),$18(a0)
		neg.w	$40(a0)
		clr.w	$1A(a0)
		move.w	#$2F,$2E(a0)
		move.l	#loc_6A0D8,$34(a0)
		bclr	#7,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A0C2:
		jsr	(MoveSprite2).l
		jsr	(ObjHitFloor).l
		add.w	d1,$14(a0)
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6A0D8:
		move.w	#-$400,$1A(a0)
		clr.w	$18(a0)
		subq.b	#1,$39(a0)
		bmi.s	loc_6A0F0
		move.b	#$E,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A0F0:
		move.b	#$10,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A0F8:
		bsr.w	sub_6AAA0
		jsr	(MoveSprite2).l
		move.w	$14(a0),d0
		cmp.w	$44(a0),d0
		bls.w	loc_6A046
		rts
; ---------------------------------------------------------------------------

loc_6A110:
		bsr.w	sub_6AAA0
		jsr	(MoveSprite2).l
		move.w	$44(a0),d0
		addi.w	#$108,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_6A12A
		rts
; ---------------------------------------------------------------------------

loc_6A12A:
		move.b	#$12,5(a0)
		bclr	#7,$38(a0)
		move.w	d0,$14(a0)
		move.w	#$180,d0
		tst.w	$40(a0)
		bpl.s	loc_6A146
		neg.w	d0

loc_6A146:
		move.w	d0,$18(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_6A16C,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A15A:
		addi.w	#$20,$1A(a0)
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6A16C:
		move.b	#$14,5(a0)
		moveq	#-$6F,d0
		jsr	(Play_Sound_2).l
		bclr	#3,$38(a0)
		move.w	#$9F,$2E(a0)
		move.l	#loc_6A194,$34(a0)
		clr.w	$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A194:
		bset	#2,$38(a0)
		move.w	#$17F,$2E(a0)
		move.l	#loc_6A1AA,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A1AA:
		bclr	#2,$38(a0)
		move.w	#$7F,$2E(a0)
		move.l	#loc_6A1C0,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A1C0:

		bset	#3,$38(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_6A1C0,$34(a0)
		move.l	#loc_6A1DE,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A1DE:
		move.b	#2,5(a0)
		move.w	#-$20,$1A(a0)
		move.w	#$7F,$2E(a0)
		move.l	#loc_6A1FA,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A1FA:
		move.b	#$16,5(a0)
		bclr	#6,$38(a0)
		move.w	#-$400,$1A(a0)
		moveq	#$70,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_6A216:
		jsr	(MoveSprite2).l
		move.w	$14(a0),d0
		cmp.w	$44(a0),d0
		bls.w	loc_6A042
		rts
; ---------------------------------------------------------------------------

loc_6A22A:
		st	($FFFFFAA2).w
		jsr	(Obj_EndSignControl).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_6A242
		move.l	#loc_6A24C,(a1)

loc_6A242:
		lea	ChildObjDat_6ADAA(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6A24C:
		tst.b	($FFFFFAA8).w
		bne.w	locret_69F78
		move.l	#loc_6A270,(a0)
		clr.w	($FFFFF602).w
		clr.w	($FFFFF66A).w
		st	($FFFFF7CA).w
		st	($FFFFF7CB).w
		move.b	#-$80,($FFFFB02E).w

loc_6A270:
		tst.b	($FFFFFAAA).w
		beq.w	locret_69F78
		move.l	#loc_6A2A0,(a0)
		lea	ChildObjDat_6ADA4(pc),a2
		tst.b	($FFFFFF09).w
		beq.s	loc_6A28C
		lea	ChildObjDat_6AD9E(pc),a2

loc_6A28C:
		jsr	(CreateChild6_Simple).l
		move.w	#$2F,$2E(a0)
		move.l	#Go_Delete_Sprite,$34(a0)

loc_6A2A0:
		btst	#0,$38(a0)
		beq.w	locret_69F78
		lea	ChildObjDat_6AD98(pc),a2
		jsr	(CreateChild6_Simple).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

Obj_HCZMiniboss_Rockets:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6A2D0(pc,d0.w),d1
		jsr	off_6A2D0(pc,d1.w)
		moveq	#$20,d0
		jmp	(Child_DrawTouch_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------
off_6A2D0:	dc.w loc_6A2DE-off_6A2D0

		dc.w loc_6A2F8-off_6A2D0
		dc.w loc_6A34C-off_6A2D0
		dc.w loc_6A36C-off_6A2D0
		dc.w loc_6A37A-off_6A2D0
		dc.w loc_6A404-off_6A2D0
		dc.w loc_6A41E-off_6A2D0
; ---------------------------------------------------------------------------

loc_6A2DE:
		lea	ObjDat3_6ACFC(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bset	#6,$38(a0)
		lea	ChildObjDat_6AD76(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6A2F8:
		clr.b	$28(a0)
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		beq.w	locret_69F78
		move.b	#4,5(a0)
		move.b	#1,$40(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_6A356,$34(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_6A344(pc,d0.w),$3C(a0)
		cmpi.b	#4,d0
		bcs.s	locret_6A342
		bset	#0,4(a0)
		move.b	#6,5(a0)

locret_6A342:
		rts
; ---------------------------------------------------------------------------
word_6A344:	dc.w 0
		dc.w $8080
		dc.w $8000
		dc.w $80
; ---------------------------------------------------------------------------

loc_6A34C:
		bsr.w	sub_6AB1A
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6A356:
		move.b	#8,5(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_6A384,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A36C:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6A372:
		move.b	#2,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A37A:
		bsr.w	sub_6AB1A
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6A384:
		move.b	#2,$40(a0)
		move.b	#-$75,$28(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_6A3A0,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A3A0:
		move.b	#$A,5(a0)
		move.b	#4,$40(a0)
		move.l	#loc_6A416,$34(a0)
		bclr	#6,$38(a0)
		moveq	#$67,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_6A3C4:
		move.b	#2,$40(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_6A3DA,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A3DA:
		move.b	#6,5(a0)
		cmpi.b	#4,$2C(a0)
		bcs.s	loc_6A3EE
		move.b	#4,5(a0)

loc_6A3EE:
		move.b	#1,$40(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_6A372,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A404:
		bsr.w	sub_6AB1A
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		bne.w	locret_69F78

loc_6A416:
		move.b	#$C,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A41E:
		bsr.w	sub_6AB1A
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.b	#1,d0
		move.b	loc_6A45C(pc,d0.w),d1
		cmp.b	$3C(a0),d1
		beq.s	loc_6A436
		rts
; ---------------------------------------------------------------------------

loc_6A436:
		move.b	#8,5(a0)
		clr.b	$28(a0)
		move.b	#2,$40(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_6A3C4,$34(a0)
		bset	#6,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A45C:
		or.b	d0,d0
		and.w	d0,d0

loc_6A460:
		lea	word_6AD08(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#loc_6A478,(a0)
		bset	#4,$2B(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A478:
		bsr.w	sub_6ABA8

loc_6A47C:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_6A4A2
		btst	#6,$38(a1)
		bne.w	locret_69F78
		btst	#0,($FFFFFE0F).w
		bne.w	locret_69F78
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_6A4A2:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

Obj_HCZMiniboss_Engine:
		lea	word_6AD10(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#loc_6A4C0,(a0)
		bset	#4,$2B(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A4C0:
		jsr	(Refresh_ChildPosition).l
		bra.s	loc_6A47C
; ---------------------------------------------------------------------------

loc_6A4C8:

		lea	ObjDat4_6AD30(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l
		move.w	($FFFFF646).w,$14(a0)
		move.l	#Obj_Wait,(a0)
		tst.b	$2C(a0)
		beq.s	loc_6A4EA
		move.w	#7,$2E(a0)

loc_6A4EA:
		move.l	#loc_6A4F4,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A4F4:
		move.l	#loc_6A504,(a0)
		move.l	#Go_Delete_SpriteSlotted3,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A504:
		lea	byte_6AE3B(pc),a1
		jsr	(Animate_RawNoSST).l
		lea	DPLCPtr_6ADE4(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6A51E:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6A536(pc,d0.w),d1
		jsr	off_6A536(pc,d1.w)
		bsr.w	sub_6A960
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_6A536:	dc.w loc_6A542-off_6A536

		dc.w loc_6A55C-off_6A536
		dc.w loc_6A57C-off_6A536
		dc.w loc_6A5B2-off_6A536
		dc.w loc_6A5D8-off_6A536
		dc.w loc_6A618-off_6A536
; ---------------------------------------------------------------------------

loc_6A542:
		lea	ObjDat3_6AD18(pc),a1
		jsr	(SetUp_ObjAttributes).l
		addi.w	#$148,$14(a0)
		clr.w	$42(a0)
		clr.w	$44(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A55C:
		tst.b	4(a0)
		bpl.w	locret_69F78
		move.b	#4,5(a0)
		lea	Pal_HCZMinibossWater(pc),a1
		lea	($FFFFF0A0).w,a2
		moveq	#7,d0

loc_6A574:
		move.l	(a1)+,(a2)+
		dbf	d0,loc_6A574
		rts
; ---------------------------------------------------------------------------

loc_6A57C:
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		beq.w	locret_69F78
		move.b	#6,5(a0)
		move.l	#byte_6ADEC,$30(a0)
		move.l	#loc_6A5BC,$34(a0)
		moveq	#-$40,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_6AD92(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_6A5B2:
		lea	byte_6ADEC(pc),a1
		jmp	(Animate_RawNoSSTMultiDelay).l
; ---------------------------------------------------------------------------

loc_6A5BC:
		move.b	#8,5(a0)
		move.l	#byte_6ADEC,$30(a0)
		move.l	#loc_6A622,$34(a0)
		clr.b	$29(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A5D8:
		bsr.w	sub_6A9B8
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		beq.s	loc_6A5FA
		moveq	#-$41,d0
		jsr	(sub_85E52).l
		lea	byte_6AE11(pc),a1
		jmp	(Animate_RawNoSST).l
; ---------------------------------------------------------------------------

loc_6A5FA:
		move.b	#$A,5(a0)
		bset	#3,$38(a0)
		move.l	#loc_6A622,$34(a0)
		bsr.w	loc_6A986
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_6A618:
		lea	byte_6AE16(pc),a1
		jmp	(Animate_RawNoSSTMultiDelay).l
; ---------------------------------------------------------------------------

loc_6A622:

		move.b	#4,5(a0)
		move.b	#$16,$22(a0)
		bclr	#3,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A636:
		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		beq.s	loc_6A656
		lea	ChildObjDat_6ADC4(pc),a2
		jsr	(CreateChild1_Normal).l
		bsr.w	loc_6A986
		jsr	(Go_Delete_Sprite_2).l

loc_6A656:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6A65C:
		lea	ObjDat3_6AD24(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_6A6B8,(a0)
		jsr	(Random_Number).l
		andi.w	#$FF,d0
		ext.w	d0
		add.w	d0,$10(a0)
		swap	d0
		andi.w	#$3F,d0
		subq.w	#8,d0
		add.w	d0,$14(a0)
		andi.w	#3,d0
		move.b	d0,$22(a0)
		lsl.w	#2,d0
		move.l	off_6A6A8(pc,d0.w),$30(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_6A6D2,$34(a0)
		rts
; ---------------------------------------------------------------------------
off_6A6A8:	dc.l word_6AE46
		dc.l word_6AE4A
		dc.l word_6AE4E
		dc.l word_6AE52
; ---------------------------------------------------------------------------

loc_6A6B8:

		movea.w	$46(a0),a3
		bsr.w	sub_6A9AA
		jsr	(Animate_Raw).l
		jsr	(Obj_Wait).l
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------

loc_6A6D2:
		move.l	#loc_6A6E4,(a0)
		movea.l	$30(a0),a1
		move.b	1(a1),$22(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A6E4:
		movea.w	$46(a0),a3
		btst	#3,$38(a3)
		bne.s	loc_6A6FA
		bsr.w	sub_6A9AA
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------

loc_6A6FA:
		move.l	#loc_6A6B8,(a0)
		move.w	#$1F,$2E(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6A710:
		lea	ObjDat3_6AD24(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_6A79C,(a0)
		move.w	($FFFFEE78).w,d0
		addi.w	#$A0,d0
		move.w	d0,$10(a0)
		move.w	d0,$3A(a0)
		move.w	($FFFFF646).w,d0
		addq.w	#8,d0
		move.w	d0,$14(a0)
		jsr	(Random_Number).l
		andi.w	#$FF,d0
		move.w	d0,d1
		ext.w	d0
		bpl.s	loc_6A74E
		st	$3C(a0)

loc_6A74E:
		add.w	d0,$10(a0)
		bsr.w	sub_6A940
		lsl.w	#4,d0
		move.w	d0,$18(a0)
		andi.b	#1,d1
		move.b	d1,$23(a0)
		swap	d0
		andi.w	#$1F,d0
		add.w	d0,$14(a0)
		andi.w	#3,d0
		move.b	d0,$22(a0)
		lsl.w	#2,d0
		lea	off_6A6A8(pc),a1
		move.l	(a1,d0.w),$30(a0)
		move.w	#$200,$1A(a0)
		move.w	#$BF,$2E(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6A79C:
		tst.b	4(a0)
		bpl.s	loc_6A7BE
		bsr.w	sub_6A916
		jsr	(MoveSprite2).l
		jsr	(Animate_Raw).l
		jsr	(Obj_Wait).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6A7BE:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_6A7C4:

		lea	($FFFFB000).w,a1
		btst	#6,$2A(a1)
		beq.w	locret_69F78
		move.l	#loc_6A872,(a0)
		clr.b	($FFFFFAA2).w
		movea.w	$46(a0),a1
		bset	#0,$38(a1)
		move.b	#4,4(a0)
		lea	($FFFFB000).w,a1
		lea	($FFFFF7CA).w,a2
		tst.b	$2C(a0)
		beq.s	loc_6A80C
		lea	($FFFFB04A).w,a1
		lea	($FFFFF7CB).w,a2
		btst	#6,$2A(a1)
		beq.w	loc_6A86C

loc_6A80C:
		clr.b	(a2)
		tst.l	(a1)
		beq.s	loc_6A86C
		move.w	a1,$44(a0)
		bclr	#7,$A(a0)
		move.w	$10(a1),d0
		move.w	d0,$10(a0)
		move.w	$14(a1),$14(a0)
		move.w	($FFFFEE78).w,d1
		addi.w	#$A0,d1
		move.w	d1,$3A(a0)
		sub.w	d1,d0
		bpl.s	loc_6A83E
		st	$3C(a0)

loc_6A83E:
		bsr.w	sub_6A940
		move.w	#$200,$1A(a0)
		bset	#1,$2A(a1)
		move.b	#1,$2E(a1)
		move.b	#$F,$20(a1)
		clr.b	$3D(a1)
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		rts
; ---------------------------------------------------------------------------

loc_6A86C:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_6A872:
		bsr.w	sub_6A916
		jsr	(MoveSprite2).l
		movea.w	$44(a0),a1
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),d0
		move.w	d0,$14(a1)
		cmpi.w	#$828,d0
		bcc.s	loc_6A896
		rts
; ---------------------------------------------------------------------------

loc_6A896:
		tst.b	$2C(a0)
		beq.s	loc_6A8AE
		lea	($FFFFB04A).w,a1
		tst.l	(a1)
		beq.s	loc_6A8C0
		jsr	(Restore_PlayerControl2).l
		bra.w	loc_6A8C0
; ---------------------------------------------------------------------------

loc_6A8AE:
		jsr	(Restore_PlayerControl).l
		move.w	#0,($FFFFFA96).w
		jsr	(Make_LevelSizeObj).l

loc_6A8C0:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_6A8C6:

		lea	byte_6AD42(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#Obj_FlickerMove,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		addi.b	#$1B,d0
		move.b	d0,$22(a0)
		moveq	#$20,d0
		jmp	(Set_IndexedVelocity).l
; ---------------------------------------------------------------------------

loc_6A8EE:

		lea	byte_6AD48(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#MoveChkDel,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		addi.b	#$1F,d0
		move.b	d0,$22(a0)
		moveq	#$1C,d0
		jmp	(Set_IndexedVelocity).l

; =============== S U B R O U T I N E =======================================


sub_6A916:

		move.w	$10(a0),d0
		move.w	$18(a0),d1
		move.w	#$100,d2
		cmp.w	$3A(a0),d0
		scs	d3
		bcs.s	loc_6A92C
		neg.w	d2

loc_6A92C:
		add.w	d2,d1
		cmp.b	$3C(a0),d3
		beq.s	loc_6A93A
		move.b	d3,$3C(a0)
		add.w	d2,d1

loc_6A93A:
		move.w	d1,$18(a0)
		rts
; End of function sub_6A916


; =============== S U B R O U T I N E =======================================


sub_6A940:

		add.w	d0,d0
		smi	d2
		bpl.s	loc_6A948
		neg.w	d0

loc_6A948:
		move.w	#$100,d3
		sub.w	d0,d3
		bpl.s	loc_6A952
		moveq	#0,d3

loc_6A952:
		lsl.w	#4,d3
		tst.b	d2
		beq.s	loc_6A95A
		neg.w	d3

loc_6A95A:
		move.w	d3,$18(a0)
		rts
; End of function sub_6A940


; =============== S U B R O U T I N E =======================================


sub_6A960:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		beq.w	locret_69F78
		move.l	#loc_6A636,(a0)
		clr.b	$28(a0)
		bclr	#3,$38(a0)
		beq.w	locret_69F78
		bra.w	*+4

loc_6A986:

		move.w	$42(a0),d0
		beq.s	loc_6A990
		bsr.w	sub_6A996

loc_6A990:
		move.w	$44(a0),d0
		beq.s	locret_6A9A8
; End of function sub_6A960


; =============== S U B R O U T I N E =======================================


sub_6A996:
		movea.w	d0,a2
		bset	#1,$2A(a2)
		clr.b	$2E(a2)
		move.w	#$100,8(a2)

locret_6A9A8:
		rts
; End of function sub_6A996


; =============== S U B R O U T I N E =======================================


sub_6A9AA:

		movea.l	a0,a1
		movea.l	a0,a2
		movea.l	a3,a0
		bsr.w	sub_6AA30
		movea.l	a1,a0
		rts
; End of function sub_6A9AA


; =============== S U B R O U T I N E =======================================


sub_6A9B8:
		clr.l	$42(a0)
		move.w	$14(a0),d0
		subi.w	#$20,d0
		lea	($FFFFB000).w,a2
		cmp.w	$14(a2),d0
		bhi.s	loc_6A9E0
		move.w	a2,$42(a0)
		bsr.w	sub_6AA30
		tst.b	$2E(a2)
		bne.s	loc_6A9E0
		bsr.w	sub_6AA00

loc_6A9E0:

		lea	($FFFFB04A).w,a2
		cmp.w	$14(a2),d0
		bhi.s	locret_6AA22
		cmpi.b	#6,5(a2)
		bcc.s	locret_6AA22
		move.w	a2,$44(a0)
		bsr.w	sub_6AA30
		tst.b	$2E(a2)
		bne.s	locret_6AA22
; End of function sub_6A9B8


; =============== S U B R O U T I N E =======================================


sub_6AA00:
		bset	#1,$2A(a2)
		move.b	#1,$2E(a2)
		move.b	#$F,$20(a2)
		clr.b	$3D(a2)
		clr.w	$18(a2)
		clr.w	$1A(a2)
		clr.w	$1C(a2)

locret_6AA22:

		rts
; End of function sub_6AA00

; ---------------------------------------------------------------------------
		dc.w $B000
		dc.w 0
		dc.w $B04A
		dc.w 0
		dc.w $B04A
		dc.w $B04A

; =============== S U B R O U T I N E =======================================


sub_6AA30:

		move.w	$10(a2),d0
		move.w	$18(a2),d1
		move.w	#$40,d2
		sub.w	$10(a0),d0
		scs	d3
		bcc.s	loc_6AA46
		neg.w	d0

loc_6AA46:
		cmpi.w	#3,d0
		bhi.s	loc_6AA54
		tst.w	d1
		bpl.s	loc_6AA62
		bra.w	loc_6AA60
; ---------------------------------------------------------------------------

loc_6AA54:
		cmpi.w	#$70,d0
		bls.s	loc_6AA5C
		moveq	#0,d1

loc_6AA5C:
		tst.b	d3
		bne.s	loc_6AA62

loc_6AA60:
		neg.w	d2

loc_6AA62:

		add.w	d2,d1
		move.w	#$100,8(a2)
		move.w	d1,$18(a2)
		bpl.s	loc_6AA76
		move.w	#$300,8(a2)

loc_6AA76:
		ext.l	d1
		lsl.l	#8,d1
		add.l	d1,$10(a2)
		move.l	#$8000,d4
		move.w	$14(a2),d5
		sub.w	$14(a0),d5
		cmpi.w	#-$10,d5
		blt.s	loc_6AA9A
		cmpi.w	#$10,d5
		ble.s	locret_6AA9E
		neg.l	d4

loc_6AA9A:
		add.l	d4,$14(a2)

locret_6AA9E:
		rts
; End of function sub_6AA30


; =============== S U B R O U T I N E =======================================


sub_6AAA0:

		btst	#7,$38(a0)
		bne.w	locret_69F78
		move.w	$14(a0),d0
		cmp.w	($FFFFF646).w,d0
		bcs.w	locret_69F78
; End of function sub_6AAA0


; =============== S U B R O U T I N E =======================================


sub_6AAB6:
		bset	#7,$38(a0)
		moveq	#$39,d0
		jsr	(Play_Sound_2).l
		clr.w	($FFFFFA9A).w
		lea	ChildObjDat_6AD7E(pc),a2
		jmp	(CreateChild1_Normal).l
; End of function sub_6AAB6


; =============== S U B R O U T I N E =======================================


sub_6AAD2:
		move.b	$3A(a0),d0
		addq.b	#2,$3A(a0)
		andi.w	#$E,d0
		lea	byte_6AB0A(pc,d0.w),a1
		move.b	(a1)+,d0
		bne.s	loc_6AAEA
		move.w	#$100,d0

loc_6AAEA:
		move.w	#$400,d2
		cmpi.w	#$A0,d0
		bcs.s	loc_6AAF6
		neg.w	d2

loc_6AAF6:
		move.w	d2,$40(a0)
		move.w	($FFFFEE78).w,d1
		add.w	d0,d1
		move.w	d1,$10(a0)
		move.b	(a1)+,$39(a0)
		rts
; End of function sub_6AAD2

; ---------------------------------------------------------------------------
byte_6AB0A:	dc.b  $40,   1
		dc.b	0,   1
		dc.b  $40,   0
		dc.b  $40,   1
		dc.b	0,   0
		dc.b	0,   1
		dc.b  $40,   0
		dc.b	0,   0

; =============== S U B R O U T I N E =======================================


sub_6AB1A:

		move.b	$40(a0),d2
		add.b	d2,$3C(a0)
		bsr.w	sub_6AB60
		add.b	d2,$3D(a0)
		bsr.w	sub_6AB94
		moveq	#0,d0
		move.b	$3D(a0),d0
		lsr.w	#4,d0
		move.b	byte_6AB50(pc,d0.w),$22(a0)
		move.w	#$200,8(a0)
		cmpi.b	#8,d0
		bcs.s	locret_6AB4E
		move.w	#$280,8(a0)

locret_6AB4E:
		rts
; End of function sub_6AB1A

; ---------------------------------------------------------------------------
byte_6AB50:	dc.b 1
		dc.b 2
		dc.b 3
		dc.b 4
		dc.b 5
		dc.b 6
		dc.b 7
		dc.b 8
		dc.b 9
		dc.b $A
		dc.b $B
		dc.b $1A
		dc.b $1A
		dc.b $1A
		dc.b $C
		dc.b $D

; =============== S U B R O U T I N E =======================================


sub_6AB60:
		moveq	#0,d0
		move.b	$3C(a0),d0
		bsr.w	sub_6AB76
		move.w	$10(a2),d0
		add.w	d1,d0
		move.w	d0,$10(a0)
		rts
; End of function sub_6AB60


; =============== S U B R O U T I N E =======================================


sub_6AB76:
		cmpi.b	#-$80,d0
		bcs.s	loc_6AB82
		moveq	#-1,d1
		sub.b	d0,d1
		move.b	d1,d0

loc_6AB82:
		lea	(HCZMiniboss_RocketTwistLookup).l,a1
		move.b	(a1,d0.w),d1
		ext.w	d1
		movea.w	$46(a0),a2
		rts
; End of function sub_6AB76


; =============== S U B R O U T I N E =======================================


sub_6AB94:
		moveq	#0,d0
		move.b	$3D(a0),d0
		bsr.s	sub_6AB76
		move.w	$14(a2),d0
		add.w	d1,d0
		move.w	d0,$14(a0)
		rts
; End of function sub_6AB94


; =============== S U B R O U T I N E =======================================


sub_6ABA8:
		movea.w	$46(a0),a2
		moveq	#0,d0
		move.b	$3D(a2),d0
		lsr.w	#3,d0
		andi.w	#-2,d0
		move.w	word_6ABF8(pc,d0.w),8(a0)
		lea	byte_6AC18(pc,d0.w),a1
		move.b	(a1)+,d1
		ext.w	d1
		btst	#0,4(a2)
		beq.s	loc_6ABD6
		neg.w	d1
		bset	#0,4(a0)

loc_6ABD6:
		move.b	(a1)+,d2
		ext.w	d2
		move.w	$10(a2),d3
		add.w	d1,d3
		move.w	d3,$10(a0)
		move.w	$14(a2),d3
		add.w	d2,d3
		move.w	d3,$14(a0)
		lsr.w	#1,d0
		move.b	byte_6AC38(pc,d0.w),$22(a0)
		rts
; End of function sub_6ABA8

; ---------------------------------------------------------------------------
word_6ABF8:	dc.w $280
		dc.w $200
		dc.w $200
		dc.w $200
		dc.w $200
		dc.w $180
		dc.w $180
		dc.w $180
		dc.w $180
		dc.w $180
		dc.w $180
		dc.w $280
		dc.w $280
		dc.w $280
		dc.w $280
		dc.w $280
byte_6AC18:	dc.b	3,   3
		dc.b	0,   0
		dc.b	6,   6
		dc.b   $C,  $C
		dc.b  $12, $12
		dc.b   $C,  $C
		dc.b	8,   8
		dc.b	0,   0
		dc.b	3,   3
		dc.b	0,   0
		dc.b	0,   0
		dc.b	0,   0
		dc.b  $FA, $FA
		dc.b  $F6, $F6
		dc.b	0,   0
		dc.b	0,   0
byte_6AC38:	dc.b   $E,  $F
		dc.b  $10, $11
		dc.b  $12, $11
		dc.b  $10,  $F
		dc.b   $E, $1A
		dc.b  $1A, $1A
		dc.b   $E,  $E
		dc.b  $1A, $1A

; =============== S U B R O U T I N E =======================================


sub_6AC48:
		tst.b	$28(a0)
		bne.s	locret_6ACA4
		tst.b	$29(a0)
		beq.s	loc_6ACA6
		tst.b	$20(a0)
		bne.s	loc_6AC68
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l

loc_6AC68:
		bset	#6,$2A(a0)
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_6AC7C
		addi.w	#$E,d0

loc_6AC7C:
		lea	word_6ACC6(pc),a1
		lea	word_6ACD4(pc,d0.w),a2
		jsr	(CopyWordData_7).l
		subq.b	#1,$20(a0)
		bne.s	locret_6ACA4
		bclr	#6,$2A(a0)
		cmpi.b	#0,$22(a0)
		bne.s	locret_6ACA4
		move.b	$25(a0),$28(a0)

locret_6ACA4:

		rts
; ---------------------------------------------------------------------------

loc_6ACA6:
		move.l	#Wait_FadeToLevelMusic,(a0)
		move.l	#loc_6A22A,$34(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild1_Normal).l
		jmp	(BossDefeated_StopTimer).l
; End of function sub_6AC48

; ---------------------------------------------------------------------------
word_6ACC6:	dc.w $FC28
		dc.w $FC2E
		dc.w $FC32
		dc.w $FC34
		dc.w $FC36
		dc.w $FC3A
		dc.w $FC3C
word_6ACD4:	dc.w 4
		dc.w 0
		dc.w $C
		dc.w 8
		dc.w $20
		dc.w $826
		dc.w $624
		dc.w $AAA
		dc.w $AAA
		dc.w $888
		dc.w $AAA
		dc.w $EEE
		dc.w $888
		dc.w $AAA
ObjDat3_6ACF0:	dc.l Map_HCZMiniboss
		dc.w $A304
		dc.w $280
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b $F
ObjDat3_6ACFC:	dc.l Map_HCZMiniboss
		dc.w $A304
		dc.w $200
		dc.b $10
		dc.b $10
		dc.b 1
		dc.b $8B
word_6AD08:	dc.w $8304
		dc.w $280
		dc.b $10
		dc.b $10
		dc.b $15
		dc.b 0
word_6AD10:	dc.w $8304
		dc.w $280
		dc.b $10
		dc.b $10
		dc.b $15
		dc.b $92
ObjDat3_6AD18:	dc.l Map_HCZMiniboss
		dc.w $A304
		dc.w $280
		dc.b $10
		dc.b $28
		dc.b $16
		dc.b 0
ObjDat3_6AD24:	dc.l Map_Bubbler

		dc.w $A45C
		dc.w $280
		dc.b $10
		dc.b $10
		dc.b 0
		dc.b 0
ObjDat4_6AD30:	dc.w 2
		dc.w $83FC
		dc.w $10
		dc.w 0
		dc.l Map_HCZMinibossSplash
		dc.w $80
		dc.b $10
		dc.b $10
		dc.b 0
		dc.b 0
byte_6AD42:	dc.b 2
		dc.b $80
		dc.b $C
		dc.b $C
		dc.b 0
		dc.b 0
byte_6AD48:	dc.b 2
		dc.b $80
		dc.b $14
		dc.b $24
		dc.b 0
		dc.b 0
Child1_HCZMiniboss_RocketsEngine:dc.w 4
		dc.l Obj_HCZMiniboss_Rockets
		dc.w $1818
		dc.l Obj_HCZMiniboss_Rockets
		dc.w $E8E8
		dc.l Obj_HCZMiniboss_Rockets
		dc.w $E818
		dc.l Obj_HCZMiniboss_Rockets
		dc.w $18E8
		dc.l Obj_HCZMiniboss_Engine
		dc.w $24
ChildObjDat_6AD6E:dc.w 0
		dc.l loc_6A51E
		dc.w 0
ChildObjDat_6AD76:dc.w 0
		dc.l loc_6A460
		dc.w 0
ChildObjDat_6AD7E:dc.w 2
		dc.l loc_6A4C8
		dc.w 0
		dc.l loc_6A4C8
		dc.w $F000
		dc.l loc_6A4C8
		dc.w $1000
ChildObjDat_6AD92:dc.w $1D
		dc.l loc_6A65C
ChildObjDat_6AD98:dc.w 0
		dc.l loc_6A710
ChildObjDat_6AD9E:dc.w 0
		dc.l loc_6A7C4
ChildObjDat_6ADA4:dc.w 1
		dc.l loc_6A7C4
ChildObjDat_6ADAA:dc.w 3
		dc.l loc_6A8C6
		dc.w $F4F4
		dc.l loc_6A8C6
		dc.w $F40C
		dc.l loc_6A8C6
		dc.w $CF4
		dc.l loc_6A8C6
		dc.w $C0C
ChildObjDat_6ADC4:dc.w 4
		dc.l loc_6A8EE
		dc.w $DC
		dc.l loc_6A8EE
		dc.w $F800
		dc.l loc_6A8EE
		dc.w $800
		dc.l loc_6A8EE
		dc.w $F430
		dc.l loc_6A8EE
		dc.w $C30
DPLCPtr_6ADE4:	dc.l ArtUnc_DashDust
		dc.l DPLC_HCZMinibossSplash
byte_6ADEC:	dc.b  $16,   7

		dc.b  $17,   7
		dc.b  $18,   7
		dc.b  $16,   6
		dc.b  $17,   6
		dc.b  $18,   6
		dc.b  $16,   5
		dc.b  $17,   5
		dc.b  $18,   5
		dc.b  $16,   4
		dc.b  $17,   4
		dc.b  $18,   4
		dc.b  $16,   3
		dc.b  $17,   3
		dc.b  $18,   3
		dc.b  $16,   2
		dc.b  $17,   2
		dc.b  $18,   2
		dc.b  $F4
byte_6AE11:	dc.b 1
		dc.b $16
		dc.b $17
		dc.b $18
		dc.b $FC
byte_6AE16:	dc.b  $16,   2
		dc.b  $17,   2
		dc.b  $18,   2
		dc.b  $16,   3
		dc.b  $17,   3
		dc.b  $18,   3
		dc.b  $16,   4
		dc.b  $17,   4
		dc.b  $18,   4
		dc.b  $16,   5
		dc.b  $17,   5
		dc.b  $18,   5
		dc.b  $16,   6
		dc.b  $17,   6
		dc.b  $18,   6
		dc.b  $16,   7
		dc.b  $17,   7
		dc.b  $18,   7
		dc.b  $F4
byte_6AE3B:	dc.b 3
		dc.b 0
		dc.b 1
		dc.b 2
		dc.b 3
		dc.b 4
		dc.b 5
		dc.b 6
		dc.b 7
		dc.b 8
		dc.b $F4
word_6AE46:	dc.w 0

		dc.w $16FC
word_6AE4A:	dc.w 1

		dc.w $16FC
word_6AE4E:	dc.w 2

		dc.w $16FC
word_6AE52:	dc.w 3

		dc.w $16FC
Pal_HCZMiniboss:	binclude "Levels\HCZ\Palettes\Miniboss.bin"

Pal_HCZMinibossWater:	binclude "Levels\HCZ\Palettes\Miniboss Water.bin"

byte_6AE96:	dc.b	4, $38
		dc.b	8, $38
		dc.b  $3F,   0
		dc.b  $41,   0
		dc.b	7, $38
		dc.b	7, $38
		dc.b  $40,   0
		dc.b  $40, $50
word_6AEA6:	dc.w 0
		dc.w $3B8
		dc.w $44E0
		dc.w $4640
		dc.w $2B8
		dc.w $2B8
		dc.w $4540
		dc.w $4590
; ---------------------------------------------------------------------------

Obj_HCZEndBoss:
		lea	byte_6AE96(pc),a1
		cmpi.b	#2,($FFFFB038).w
		bne.s	loc_6AEC6
		lea	word_6AEA6(pc),a1

loc_6AEC6:
		jsr	(Check_CameraInRange).l
		move.b	#$19,$26(a0)
		jsr	(sub_85D6A).l
		move.l	#loc_6AEFE,(a0)
		move.l	#loc_6AF04,$34(a0)
		moveq	#$6C,d0
		jsr	(Load_PLC).l
		move.w	#0,($FFFFFC1E).w
		lea	Pal_HCZEndBoss(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_6AEFE:
		jmp	(loc_85CA4).l
; ---------------------------------------------------------------------------

loc_6AF04:
		move.l	#loc_6AF0C,(a0)

locret_6AF0A:

		rts
; ---------------------------------------------------------------------------

loc_6AF0C:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6AF24(pc,d0.w),d1
		jsr	off_6AF24(pc,d1.w)
		bsr.w	sub_6BBC4
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_6AF24:	dc.w loc_6AF32-off_6AF24

		dc.w loc_6AF74-off_6AF24
		dc.w loc_6AFB6-off_6AF24
		dc.w loc_6AF74-off_6AF24
		dc.w loc_6AF74-off_6AF24
		dc.w loc_6AFB6-off_6AF24
		dc.w loc_6B064-off_6AF24
; ---------------------------------------------------------------------------

loc_6AF32:
		lea	ObjDat3_6BD20(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#8,$29(a0)
		move.w	#$80,$1A(a0)
		move.w	#$EF,$2E(a0)
		move.l	#loc_6AF80,$34(a0)
		lea	(ChildObjDat_6BDEC).l,a2
		jsr	(CreateChild1_Normal).l
		bne.s	loc_6AF6A
		move.b	#5,$2C(a1)

loc_6AF6A:
		lea	ChildObjDat_6BD8A(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6AF74:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6AF80:
		move.b	#4,5(a0)
		move.w	$14(a0),$3A(a0)
		move.w	#-$100,$44(a0)
		move.w	#$9F,$30(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_6AFC8,$34(a0)
		lea	(PLC_83D6C).l,a1
		jsr	(Load_PLC_Raw).l
		jmp	Swing_Setup1(pc)
; ---------------------------------------------------------------------------

loc_6AFB6:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6AFC8:

		bset	#3,$38(a0)
		cmpi.b	#2,($FFFFB038).w
		beq.s	loc_6AFF2
		move.b	#6,5(a0)
		move.w	#$80,$1A(a0)
		move.w	#$9F,$2E(a0)
		move.l	#loc_6B008,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6AFF2:
		move.b	#$A,5(a0)
		move.w	#$1FF,$2E(a0)
		move.l	#loc_6B03A,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6B008:
		move.w	#-$100,$1A(a0)
		move.w	#$4F,$2E(a0)
		move.l	#loc_6B01E,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6B01E:
		move.b	#$A,5(a0)
		move.w	#$FF,$2E(a0)
		move.w	$3A(a0),$14(a0)
		move.l	#loc_6B03A,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6B03A:

		move.b	#$C,5(a0)
		bclr	#3,$38(a0)
		move.w	$44(a0),$18(a0)
		move.w	#$BF,$2E(a0)
		move.l	#loc_6B08E,$34(a0)
		move.b	#8,$39(a0)
		jmp	Swing_Setup1(pc)
; ---------------------------------------------------------------------------

loc_6B064:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jsr	(Obj_Wait).l
		subq.w	#1,$30(a0)
		bpl.s	locret_6B08C
		neg.w	$18(a0)
		bchg	#0,4(a0)
		move.w	#$13F,$30(a0)

locret_6B08C:
		rts
; ---------------------------------------------------------------------------

loc_6B08E:
		move.w	#$5F,$2E(a0)
		subq.b	#1,$39(a0)
		bmi.s	loc_6B0A2
		bset	#1,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_6B0A2:
		move.w	$18(a0),$44(a0)
		clr.w	$18(a0)
		bra.w	loc_6AFC8
; ---------------------------------------------------------------------------

loc_6B0B0:
		move.l	#loc_6B0CC,(a0)
		bset	#4,$38(a0)
		move.l	#loc_6B0E8,$34(a0)
		moveq	#$C,d0
		jmp	(Set_IndexedVelocity).l
; ---------------------------------------------------------------------------

loc_6B0CC:
		jsr	(MoveSprite).l
		jsr	(Obj_Wait).l
		btst	#0,($FFFFFE0F).w
		beq.w	locret_6AF0A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6B0E8:
		move.l	#loc_6B154,(a0)
		bclr	#7,4(a0)
		st	($FFFFFAA8).w
		clr.b	($FFFFF7AA).w
		move.w	($FFFFFAB4).w,d0
		addi.w	#$180,d0
		move.w	d0,($FFFFFA92).w
		lea	(Child6_IncLevX).l,a2
		jsr	(CreateChild6_Simple).l
		cmpi.b	#2,($FFFFB038).w
		beq.s	loc_6B138
		jsr	(Create_New_Sprite).l
		bne.s	locret_6B136
		move.l	#Obj_81,(a1)
		move.w	#$4250,$10(a1)
		move.w	#$7E0,$14(a1)

locret_6B136:
		rts
; ---------------------------------------------------------------------------

loc_6B138:
		jsr	(Create_New_Sprite).l
		bne.s	locret_6B152
		move.l	#Obj_81,(a1)
		move.w	#$4760,$10(a1)
		move.w	#$360,$14(a1)

locret_6B152:
		rts
; ---------------------------------------------------------------------------

loc_6B154:
		move.w	($FFFFEE78).w,($FFFFEE14).w
		tst.b	($FFFFFAA8).w
		bne.w	locret_6AF0A
		clr.w	($FFFFF602).w
		clr.w	($FFFFF66A).w
		st	($FFFFF7CA).w
		st	($FFFFF7CB).w
		move.b	#-$80,($FFFFB02E).w
		jsr	(Restore_PlayerControl).l
		lea	($FFFFB04A).w,a1
		jsr	(Restore_PlayerControl2).l
		jsr	(Obj_PlayLevelMusic).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_6B19C
		move.l	#loc_6B7BC,(a1)

loc_6B19C:
		move.w	#0,($FFFFEE18).w
		jmp	(Go_Delete_Sprite_2).l
; ---------------------------------------------------------------------------

loc_6B1A8:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6B1C4(pc,d0.w),d1
		jsr	off_6B1C4(pc,d1.w)
		jsr	(Refresh_ChildPosition).l
		moveq	#0,d0
		jmp	(Child_DrawTouch_Sprite2_FlickerMove).l
; ---------------------------------------------------------------------------
off_6B1C4:	dc.w loc_6B1CE-off_6B1C4

		dc.w loc_6B1D8-off_6B1C4
		dc.w loc_6B204-off_6B1C4
		dc.w loc_6B22A-off_6B1C4
		dc.w loc_6B25C-off_6B1C4
; ---------------------------------------------------------------------------

loc_6B1CE:
		lea	byte_6BD32(pc),a1
		jmp	(SetUp_ObjAttributes3).l
; ---------------------------------------------------------------------------

loc_6B1D8:
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		bne.s	loc_6B1E6
		rts
; ---------------------------------------------------------------------------

loc_6B1E6:
		move.b	#4,5(a0)
		move.b	#-$5A,$28(a0)
		move.l	#byte_6BDF4,$30(a0)
		move.l	#loc_6B212,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6B204:
		moveq	#-$40,d0
		jsr	(sub_85E52).l
		jmp	(Animate_RawGetFaster).l
; ---------------------------------------------------------------------------

loc_6B212:
		move.b	#6,5(a0)
		move.l	#byte_6BDFB,$30(a0)
		lea	ChildObjDat_6BDBA(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6B22A:
		jsr	(Animate_Raw).l
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		beq.s	loc_6B244
		moveq	#-$40,d0
		jmp	(sub_85E52).l
; ---------------------------------------------------------------------------

loc_6B244:
		move.b	#8,5(a0)
		move.l	#byte_6BE01,$30(a0)
		move.l	#loc_6B262,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6B25C:
		jmp	(Animate_RawGetSlower).l
; ---------------------------------------------------------------------------

loc_6B262:
		move.b	#2,5(a0)
		clr.b	$28(a0)
		rts
; ---------------------------------------------------------------------------

loc_6B26E:
		move.w	$10(a0),-(sp)
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6B29E(pc,d0.w),d1
		jsr	off_6B29E(pc,d1.w)
		move.w	#$1F,d1
		move.w	#$C,d2
		move.w	#$C,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectTop).l
		bsr.w	sub_6BC42
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_6B29E:	dc.w loc_6B2AA-off_6B29E

		dc.w loc_6B2F2-off_6B29E
		dc.w loc_6B31E-off_6B29E
		dc.w loc_6B336-off_6B29E
		dc.w loc_6B31E-off_6B29E
		dc.w loc_6B394-off_6B29E
; ---------------------------------------------------------------------------

loc_6B2AA:
		lea	word_6BD3E(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.w	($FFFFF646).w,d0
		subq.w	#8,d0
		move.w	d0,$14(a0)
		move.w	d0,$3A(a0)
		move.l	#byte_6BE0C,$30(a0)
		move.l	#loc_6B2F8,$34(a0)
		lea	ChildObjDat_6BDCA(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	ChildObjDat_6BDE6(pc),a2
		jsr	(CreateChild6_Simple).l
		movea.w	$46(a0),a1
		move.w	$46(a1),$44(a0)
		rts
; ---------------------------------------------------------------------------

loc_6B2F2:
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_6B2F8:
		move.b	#4,5(a0)
		move.l	#byte_6BE15,$30(a0)
		move.w	#-$100,$1A(a0)
		move.l	#loc_6B32E,$34(a0)
		lea	ChildObjDat_6BDC2(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6B31E:
		jsr	(MoveSprite2).l
		jsr	(Animate_Raw).l
		bra.w	sub_6BC8A
; ---------------------------------------------------------------------------

loc_6B32E:
		move.b	#6,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_6B336:
		jsr	(Animate_Raw).l
		movea.w	$44(a0),a1
		btst	#3,$38(a1)
		beq.s	loc_6B34A
		rts
; ---------------------------------------------------------------------------

loc_6B34A:
		move.b	#8,5(a0)
		bset	#3,$38(a0)
		move.w	#$80,$1A(a0)
		move.l	#loc_6B37A,$34(a0)
		move.w	#$80,$18(a0)
		tst.w	$18(a1)
		bpl.s	locret_6B374
		neg.w	$18(a0)

locret_6B374:
		rts
; ---------------------------------------------------------------------------
		bra.w	sub_6BC8A
; ---------------------------------------------------------------------------

loc_6B37A:
		move.l	#loc_6B394,(a0)
		move.w	#$F,$2E(a0)
		clr.w	$18(a0)
		move.l	#loc_6B3BC,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6B394:

		move.w	#$1F,d1
		move.w	#$C,d2
		move.w	#$C,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		jsr	(Animate_Raw).l
		jsr	(Obj_Wait).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6B3BC:
		jsr	(Displace_PlayerOffObject).l
		jmp	(Go_Delete_Sprite_2).l
; ---------------------------------------------------------------------------

loc_6B3C8:
		jsr	(MoveSprite2).l
		jsr	(Animate_Raw).l
		bsr.w	sub_6BC8A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6B3DE:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6B3F6(pc,d0.w),d1
		jsr	off_6B3F6(pc,d1.w)
		bsr.w	sub_6BC70
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------
off_6B3F6:	dc.w loc_6B3FC-off_6B3F6

		dc.w loc_6B410-off_6B3F6
		dc.w loc_6B440-off_6B3F6
; ---------------------------------------------------------------------------

loc_6B3FC:
		lea	byte_6BD46(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#byte_6BE19,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_6B410:
		bsr.w	sub_6B9E2
		bsr.w	sub_6B9AC
		bsr.w	sub_6B916
		jsr	(Animate_Raw).l
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		bne.s	loc_6B430
		rts
; ---------------------------------------------------------------------------

loc_6B430:
		move.b	#4,5(a0)
		move.w	$18(a1),$18(a0)
		bra.w	loc_6BB1E
; ---------------------------------------------------------------------------

loc_6B440:
		bsr.w	sub_6B916
		move.w	$18(a1),$18(a0)
		jsr	(MoveSprite2).l
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_6B456:

		lea	word_6BD4C(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_6B47A,(a0)
		move.l	#byte_6BE32,$30(a0)

loc_6B46E:
		move.w	($FFFFF646).w,d0
		subq.w	#4,d0
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_6B47A:
		jsr	(Animate_Raw).l
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_6B49E(pc,d0.w),d0
		movea.w	$46(a0),a1
		move.w	$10(a1),d1
		add.w	d0,d1
		move.w	d1,$10(a0)
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------
word_6B49E:	dc.w $FFFC
		dc.w 4
; ---------------------------------------------------------------------------

loc_6B4A2:
		lea	word_6BD52(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#AnimateRaw_DrawTouch,(a0)
		move.l	#byte_6BE36,$30(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		bra.s	loc_6B46E
; ---------------------------------------------------------------------------

loc_6B4C4:
		lea	ObjDat3_6BD5A(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#Obj_Wait,(a0)
		move.l	#loc_6B4F2,$34(a0)
		bsr.w	sub_6B96C
		tst.b	$2C(a0)
		bne.w	locret_6AF0A
		lea	ChildObjDat_6BDCA(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6B4F2:
		move.l	#loc_6B502,(a0)
		move.l	#Go_Delete_Sprite_2,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6B502:
		bsr.w	sub_6BB40
		jmp	(AnimateRaw_DrawTouch).l
; ---------------------------------------------------------------------------

loc_6B50C:
		lea	ObjDat3_6BD72(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_6B56C,(a0)
		jsr	(Random_Number).l
		andi.w	#$FF,d0
		ext.w	d0
		add.w	d0,$10(a0)
		swap	d0
		move.w	($FFFFF646).w,d1
		andi.w	#$1F,d0
		add.w	d0,d1
		move.w	d1,$14(a0)
		andi.w	#3,d0
		move.b	d0,$22(a0)
		lsl.w	#2,d0
		move.l	off_6B55C(pc,d0.w),$30(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_6B586,$34(a0)
		rts
; ---------------------------------------------------------------------------
off_6B55C:	dc.l word_6AE46
		dc.l word_6AE4A
		dc.l word_6AE4E
		dc.l word_6AE52
; ---------------------------------------------------------------------------

loc_6B56C:

		movea.w	$46(a0),a3
		bsr.w	sub_6BB9A
		jsr	(Animate_Raw).l
		jsr	(Obj_Wait).l
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------

loc_6B586:
		move.l	#loc_6B598,(a0)
		movea.l	$30(a0),a1
		move.b	1(a1),$22(a0)
		rts
; ---------------------------------------------------------------------------

loc_6B598:
		movea.w	$46(a0),a3
		btst	#3,$38(a3)
		bne.s	loc_6B5AE
		bsr.w	sub_6BB9A
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------

loc_6B5AE:
		move.l	#loc_6B56C,(a0)
		move.w	#$1F,$2E(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6B5C4:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6B5D8(pc,d0.w),d1
		jsr	off_6B5D8(pc,d1.w)
		jmp	(Child_DrawTouch_Sprite).l
; ---------------------------------------------------------------------------
off_6B5D8:	dc.w loc_6B5E6-off_6B5D8

		dc.w loc_6B600-off_6B5D8
		dc.w loc_6B644-off_6B5D8
		dc.w loc_6B678-off_6B5D8
		dc.w loc_6B6E6-off_6B5D8
		dc.w loc_6B70E-off_6B5D8
		dc.w loc_6B734-off_6B5D8
; ---------------------------------------------------------------------------

loc_6B5E6:
		lea	byte_6BD38(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.b	#8,$1E(a0)
		bsr.w	sub_6B8F0
		jmp	(Refresh_ChildPositionAdjusted).l
; ---------------------------------------------------------------------------

loc_6B600:
		jsr	(Refresh_ChildPositionAdjusted).l
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		bne.s	loc_6B614
		rts
; ---------------------------------------------------------------------------

loc_6B614:
		move.b	#4,5(a0)
		tst.b	$2C(a0)
		beq.s	loc_6B622
		rts
; ---------------------------------------------------------------------------

loc_6B622:
		move.b	#6,5(a0)
		move.w	#3,$2E(a0)
		move.l	#loc_6B6BA,$34(a0)
		move.b	#1,$40(a0)
		move.b	#0,$41(a0)
		rts
; ---------------------------------------------------------------------------

loc_6B644:
		jsr	(Refresh_ChildPositionAdjusted).l
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		beq.s	loc_6B658
		rts
; ---------------------------------------------------------------------------

loc_6B658:
		move.b	#6,5(a0)
		subq.b	#2,$2C(a0)
		move.w	#7,$2E(a0)
		move.l	#loc_6B694,$34(a0)
		bsr.w	sub_6B8F0
		bra.w	loc_6B904
; ---------------------------------------------------------------------------

loc_6B678:
		move.b	$40(a0),d0
		add.b	d0,$42(a0)
		move.b	$41(a0),d0
		add.b	d0,$43(a0)
		jsr	(Refresh_ChildPositionAdjusted).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6B694:
		move.b	#2,5(a0)
		tst.b	$2C(a0)
		bne.s	locret_6B6B8
		lea	word_6BDAA(pc),a2
		jsr	(CreateChild7_Normal2).l
		bne.s	locret_6B6B8
		move.w	$46(a0),$46(a1)
		move.b	#4,$2C(a1)

locret_6B6B8:

		rts
; ---------------------------------------------------------------------------

loc_6B6BA:
		move.b	#8,5(a0)
		move.l	#loc_6B71C,$34(a0)
		move.w	#$100,$18(a0)
		movea.w	$46(a0),a1
		bclr	#1,$38(a1)
		btst	#0,4(a1)
		beq.s	locret_6B6E4
		neg.w	$18(a0)

locret_6B6E4:
		rts
; ---------------------------------------------------------------------------

loc_6B6E6:
		move.w	$14(a0),d0
		cmp.w	($FFFFF646).w,d0
		bcc.s	loc_6B6FE
		jsr	(MoveSprite_LightGravity).l
		jsr	(ObjHitFloor_DoRoutine).l
		rts
; ---------------------------------------------------------------------------

loc_6B6FE:
		move.b	#$A,5(a0)
		lea	ChildObjDat_6BDD8(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6B70E:
		jsr	(MoveSprite_LightGravity).l
		jsr	(ObjHitFloor_DoRoutine).l
		rts
; ---------------------------------------------------------------------------

loc_6B71C:
		move.b	#$C,5(a0)
		move.l	#byte_6BE07,$30(a0)
		move.l	#loc_6B73A,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6B734:
		jmp	(Animate_RawGetFaster).l
; ---------------------------------------------------------------------------

loc_6B73A:
		lea	ChildObjDat_6BDE0(pc),a2
		jsr	(CreateChild6_Simple).l
		moveq	#$4E,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_6BDB2(pc),a2
		jsr	(CreateChild1_Normal).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_6B75C:
		lea	word_6BD2C(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_6B76E,(a0)
		rts
; ---------------------------------------------------------------------------

loc_6B76E:
		jsr	(Refresh_ChildPositionAdjusted).l
		moveq	#0,d0
		jmp	(Child_Draw_Sprite2_FlickerMove).l
; ---------------------------------------------------------------------------

loc_6B77C:
		lea	ObjDat3_6BD66(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_6B7A2,(a0)
		move.l	#byte_6BF02,$30(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_6B7A2:
		jsr	(Animate_Raw).l
		cmpi.b	#3,$22(a0)
		bcc.s	loc_6B7B6
		jsr	(Add_SpriteToCollisionResponseList).l

loc_6B7B6:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6B7BC:
		lea	(ArtKosM_HCZGeyserVert).l,a1
		move.w	#$6D60,d2
		jsr	(Queue_Kos_Module).l
		move.l	#loc_6B7D2,(a0)

loc_6B7D2:
		move.l	#loc_6B7EC,(a0)
		move.w	#$5F,$2E(a0)
		move.l	#loc_6B804,$34(a0)
		st	($FFFFEECC).w
		rts
; ---------------------------------------------------------------------------

loc_6B7EC:
		move.b	($FFFFFE0F).w,d0
		andi.b	#7,d0
		bne.s	loc_6B7FE
		moveq	#$6F,d0
		jsr	(Play_Sound_2).l

loc_6B7FE:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6B804:
		jsr	(Create_New_Sprite).l
		bne.s	loc_6B81C
		move.l	#loc_6B824,(a1)
		st	$2C(a1)
		move.w	#4,$2E(a1)

loc_6B81C:
		lea	loc_6B832(pc),a1
		move.l	a1,(a0)
		jmp	(a1)
; ---------------------------------------------------------------------------

loc_6B824:
		subq.w	#1,$2E(a0)
		bpl.w	locret_6AF0A
		move.l	#loc_6B832,(a0)

loc_6B832:

		lea	ObjDat3_6BD7E(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_6B882,(a0)
		tst.b	$2C(a0)
		bne.s	loc_6B860
		st	($FFFFF650).w
		st	($FFFFEECC).w
		moveq	#$57,d0
		jsr	(Play_Sound_2).l
		lea	($FFFFB000).w,a1
		bra.w	loc_6B864
; ---------------------------------------------------------------------------

loc_6B860:
		lea	($FFFFB04A).w,a1

loc_6B864:
		move.w	a1,$44(a0)
		move.w	$10(a1),d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d1
		addi.w	#$130,d1
		move.w	d1,$14(a0)
		jmp	(loc_6BCB2).l
; ---------------------------------------------------------------------------

loc_6B882:
		movea.w	$44(a0),a1
		move.w	$14(a0),d0
		subq.w	#6,d0
		move.w	d0,$14(a0)
		subi.w	#$60,d0
		cmp.w	$14(a1),d0
		bcc.s	loc_6B8B2
		move.b	#-$7F,$2E(a1)
		move.b	#$1A,$20(a1)
		move.l	#loc_6B8C8,(a0)
		move.w	#$5F,$2E(a0)

loc_6B8B2:

		tst.b	$2C(a0)
		bne.s	loc_6B8C2
		move.l	a0,-(sp)
		jsr	(AnPal_HCZ1).l
		movea.l	(sp)+,a0

loc_6B8C2:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6B8C8:
		movea.w	$44(a0),a1
		subq.w	#6,$14(a0)
		subq.w	#6,$14(a1)
		tst.b	$2C(a0)
		bne.s	loc_6B8C2
		subq.w	#1,$2E(a0)
		bpl.s	loc_6B8B2
		move.w	#$200,d0
		jsr	(StartNewLevel).l
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_6B8F0:

		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_6B8FE(pc,d0.w),8(a0)
		rts
; End of function sub_6B8F0

; ---------------------------------------------------------------------------
word_6B8FE:	dc.w $280
		dc.w $200
		dc.w $180
; ---------------------------------------------------------------------------

loc_6B904:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_6B912(pc,d0.w),$40(a0)
		rts
; ---------------------------------------------------------------------------
word_6B912:	dc.w  $101
		dc.w  $100

; =============== S U B R O U T I N E =======================================


sub_6B916:

		movea.w	$46(a0),a1
		moveq	#0,d0
		move.b	$39(a1),d0
		cmp.b	$39(a0),d0
		beq.s	locret_6B946
		move.b	d0,$39(a0)
		move.b	byte_6B949(pc,d0.w),d1
		ext.w	d1
		move.w	($FFFFF646).w,d2
		add.w	d1,d2
		move.w	d2,$14(a0)
		lsl.w	#2,d0
		move.l	off_6B954(pc,d0.w),$30(a0)
		clr.b	$24(a0)

locret_6B946:
		rts
; End of function sub_6B916

; ---------------------------------------------------------------------------
		dc.b $F8 ; 
byte_6B949:	dc.b $F8
		dc.b $F0
		dc.b $E8
		dc.b $E0
		dc.b $D8
		dc.b $D8
		dc.b 0
		dc.b 0
		dc.b 6
		dc.b $BE
		dc.b $19
off_6B954:	dc.l byte_6BE19
		dc.l byte_6BE1E
		dc.l byte_6BE23
		dc.l byte_6BE28
		dc.l byte_6BE2D
		dc.l byte_6BE2D

; =============== S U B R O U T I N E =======================================


sub_6B96C:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,$2E(a0)
		move.w	word_6B98E(pc,d0.w),d1
		move.w	($FFFFF646).w,d2
		add.w	d1,d2
		move.w	d2,$14(a0)
		add.w	d0,d0
		move.l	off_6B998(pc,d0.w),$30(a0)
		rts
; End of function sub_6B96C

; ---------------------------------------------------------------------------
word_6B98E:	dc.w $FFF8
		dc.w $FFE8
		dc.w $FFD8
		dc.w $FFC8
		dc.w $FFB8
off_6B998:	dc.l byte_6BE3F
		dc.l byte_6BE76
		dc.l byte_6BEA5
		dc.l byte_6BECC
		dc.l byte_6BEEB

; =============== S U B R O U T I N E =======================================


sub_6B9AC:
		move.w	$10(a0),d0
		move.w	($FFFFF646).w,d1
		addq.w	#8,d1
		move.l	#$20000,d2
		lea	($FFFFB000).w,a1
		bsr.w	sub_6B9C8
		lea	($FFFFB04A).w,a1
; End of function sub_6B9AC


; =============== S U B R O U T I N E =======================================


sub_6B9C8:
		tst.b	$2E(a1)
		bne.s	locret_6B9E0
		cmp.w	$14(a1),d1
		bcc.s	locret_6B9E0
		cmp.w	$10(a1),d0
		bcc.s	loc_6B9DC
		neg.l	d2

loc_6B9DC:
		add.l	d2,$10(a1)

locret_6B9E0:
		rts
; End of function sub_6B9C8


; =============== S U B R O U T I N E =======================================


sub_6B9E2:
		movea.w	$46(a0),a1
		moveq	#0,d0
		move.b	$39(a1),d0
		lsl.w	#2,d0
		lea	word_6BAC2(pc),a1
		lea	(a1,d0.w),a1
		moveq	#$42,d4
		lea	($FFFFB000).w,a2
		bsr.w	sub_6BA06
		moveq	#$43,d4
		lea	($FFFFB04A).w,a2
; End of function sub_6B9E2


; =============== S U B R O U T I N E =======================================


sub_6BA06:
		movea.w	$46(a0),a3
		btst	#7,$2A(a3)
		bne.w	sub_6BB02
		cmpi.b	#6,5(a2)
		bcc.w	loc_6BAB2
		tst.b	$34(a2)
		bne.w	loc_6BAB2
		tst.b	$2E(a2)
		beq.s	loc_6BA32
		tst.b	(a0,d4.w)
		bne.s	loc_6BA6C

loc_6BA32:
		move.w	$14(a0),d0
		move.w	$14(a2),d2
		add.w	(a1),d0
		cmp.w	d0,d2
		bcs.w	locret_6BB00
		add.w	2(a1),d0
		cmp.w	d0,d2
		bcc.w	locret_6BB00
		move.w	$10(a0),d0
		move.w	$10(a2),d2
		sub.w	d2,d0
		addi.w	#$10,d0
		cmpi.w	#$20,d0
		bcc.w	locret_6BB00
		tst.b	$2E(a2)
		bne.s	loc_6BA6C
		bsr.w	sub_6BADA

loc_6BA6C:

		move.w	$14(a0),d0
		move.w	$14(a2),d2
		add.w	(a1)+,d0
		cmp.w	d0,d2
		bcs.w	sub_6BB02
		move.w	$10(a2),d0
		move.w	$18(a2),d1
		move.w	#$80,d2
		sub.w	$10(a0),d0
		cmpi.w	#-$12,d0
		ble.s	sub_6BB02
		cmpi.w	#$12,d0
		bge.s	sub_6BB02
		tst.w	d0
		bmi.s	loc_6BA9E
		neg.w	d2

loc_6BA9E:
		add.w	d2,d1
		move.w	d1,$18(a2)
		ext.l	d1
		lsl.l	#8,d1
		add.l	d1,$10(a2)
		subq.w	#2,$14(a2)
		rts
; ---------------------------------------------------------------------------

loc_6BAB2:

		jsr	(Displace_PlayerOffObject).l
		clr.b	(a0,d4.w)
		clr.b	$2E(a2)
		rts
; End of function sub_6BA06

; ---------------------------------------------------------------------------
word_6BAC2:	dc.w  $FFE8,   $48
		dc.w  $FFE0,   $58
		dc.w  $FFD8,   $68
		dc.w  $FFD0,   $78
		dc.w  $FFC8,   $88
		dc.w  $FFB8,   $88

; =============== S U B R O U T I N E =======================================


sub_6BADA:
		st	(a0,d4.w)
		bset	#1,$2A(a2)
		move.b	#1,$2E(a2)
		move.b	#$18,$20(a2)
		clr.b	$3D(a2)
		clr.w	$18(a2)
		clr.w	$1A(a2)
		clr.w	$1C(a2)

locret_6BB00:

		rts
; End of function sub_6BADA


; =============== S U B R O U T I N E =======================================


sub_6BB02:

		clr.b	(a0,d4.w)
		bset	#1,$2A(a2)
		clr.b	$2E(a2)
		move.b	#2,$20(a2)
		move.w	#-$200,$1A(a2)
		rts
; End of function sub_6BB02

; ---------------------------------------------------------------------------

loc_6BB1E:
		tst.b	$42(a0)
		beq.s	loc_6BB2E
		clr.b	$42(a0)
		lea	($FFFFB000).w,a2
		bsr.s	sub_6BB02

loc_6BB2E:
		tst.b	$43(a0)
		beq.s	locret_6BB3E
		clr.b	$43(a0)
		lea	($FFFFB04A).w,a2
		bsr.s	sub_6BB02

locret_6BB3E:
		rts

; =============== S U B R O U T I N E =======================================


sub_6BB40:
		cmpi.b	#$30,$23(a0)
		bcc.s	locret_6BB90
		lea	word_6BB92(pc),a1
		lea	($FFFFB000).w,a2
		bsr.w	sub_6BB5C
		lea	word_6BB92(pc),a1
		lea	($FFFFB04A).w,a2
; End of function sub_6BB40


; =============== S U B R O U T I N E =======================================


sub_6BB5C:
		tst.b	$2E(a2)
		bne.s	locret_6BB90
		move.w	$10(a0),d0
		move.w	$10(a2),d1
		add.w	(a1)+,d0
		cmp.w	d0,d1
		bcs.s	locret_6BB90
		add.w	(a1)+,d0
		cmp.w	d0,d1
		bcc.s	locret_6BB90
		move.w	$14(a0),d0
		move.w	$14(a2),d1
		add.w	(a1)+,d0
		cmp.w	d0,d1
		bcs.s	locret_6BB90
		add.w	(a1)+,d0
		cmp.w	d0,d1
		bcc.s	locret_6BB90
		move.w	#-$800,$1A(a2)

locret_6BB90:
		rts
; End of function sub_6BB5C

; ---------------------------------------------------------------------------
word_6BB92:	dc.w  $FFF4,   $18

		dc.w  $FFC8,   $40

; =============== S U B R O U T I N E =======================================


sub_6BB9A:

		movea.w	$46(a0),a1
		move.w	$10(a0),d0
		move.w	$18(a0),d1
		move.w	#$80,d2
		sub.w	$10(a1),d0
		tst.w	d0
		bmi.s	loc_6BBB4
		neg.w	d2

loc_6BBB4:
		add.w	d2,d1
		move.w	d1,$18(a0)
		ext.l	d1
		lsl.l	#8,d1
		add.l	d1,$10(a0)
		rts
; End of function sub_6BB9A


; =============== S U B R O U T I N E =======================================


sub_6BBC4:
		tst.l	(a0)
		beq.s	locret_6BC1A
		tst.b	$28(a0)
		bne.s	locret_6BC1A
		tst.b	$29(a0)
		beq.s	loc_6BC1C
		tst.b	$20(a0)
		bne.s	loc_6BBE8
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l

loc_6BBE8:
		bset	#6,$2A(a0)
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_6BBFA
		addq.w	#6,d0

loc_6BBFA:
		lea	word_6BC30(pc),a1
		lea	word_6BC36(pc,d0.w),a2
		jsr	(CopyWordData_3).l
		subq.b	#1,$20(a0)
		bne.s	locret_6BC1A
		bclr	#6,$2A(a0)
		move.b	$25(a0),$28(a0)

locret_6BC1A:
		rts
; ---------------------------------------------------------------------------

loc_6BC1C:
		move.l	#Wait_FadeToLevelMusic,(a0)
		move.l	#loc_6B0B0,$34(a0)
		jmp	(BossDefeated_StopTimer).l
; End of function sub_6BBC4

; ---------------------------------------------------------------------------
word_6BC30:	dc.w $FC34
		dc.w $FC36
		dc.w $FC3C
word_6BC36:	dc.w	  6,   $20,  $624,  $EEE,  $EEE,  $EEE

; =============== S U B R O U T I N E =======================================


sub_6BC42:
		movea.w	$44(a0),a1
		btst	#7,$2A(a1)
		beq.s	locret_6BC6E
		bset	#7,$2A(a0)
		move.l	#loc_6B3C8,(a0)
		move.w	#$100,$1A(a0)
		move.l	#Go_Delete_Sprite_2,$34(a0)
		jsr	(Displace_PlayerOffObject).l

locret_6BC6E:
		rts
; End of function sub_6BC42


; =============== S U B R O U T I N E =======================================


sub_6BC70:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		beq.s	locret_6BC88
		bset	#7,$2A(a0)
		move.b	#4,5(a0)

locret_6BC88:
		rts
; End of function sub_6BC70


; =============== S U B R O U T I N E =======================================


sub_6BC8A:

		move.w	$3A(a0),d0
		sub.w	$14(a0),d0
		bcs.s	loc_6BCAC
		andi.w	#$F0,d0
		lsr.w	#4,d0
		move.b	d0,$39(a0)
		tst.w	$1A(a0)
		bpl.s	locret_6BCAA
		cmpi.b	#5,d0
		bcc.s	loc_6BCAC

locret_6BCAA:
		rts
; ---------------------------------------------------------------------------

loc_6BCAC:

		movea.l	$34(a0),a2
		jmp	(a2)
; End of function sub_6BC8A

; ---------------------------------------------------------------------------

loc_6BCB2:
		lea	(byte_303EA).l,a3
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		subi.w	#$80,d3
		moveq	#7,d1

loc_6BCC6:
		jsr	(Create_New_Sprite3).l
		bne.s	locret_6BD1E
		move.l	#loc_3011A,(a1)
		move.l	#Map_HCZWaterWallDebris,$C(a1)
		move.w	#$43C3,$A(a1)
		move.b	#-$7C,4(a1)
		move.b	(a3)+,d0
		ext.w	d0
		add.w	d2,d0
		move.w	d0,$10(a1)
		move.b	(a3)+,d0
		ext.w	d0
		add.w	d3,d0
		move.w	d0,$14(a1)
		move.w	#$280,8(a1)
		move.b	#$18,7(a1)
		move.b	#$18,6(a1)
		move.w	(a3)+,$18(a1)
		move.w	(a3)+,$1A(a1)
		move.b	d1,$22(a1)
		dbf	d1,loc_6BCC6

locret_6BD1E:
		rts
; ---------------------------------------------------------------------------
ObjDat3_6BD20:	dc.l Map_HCZEndBoss
		dc.w $A320
		dc.w $100
		dc.b $2C
		dc.b $1C
		dc.b 0
		dc.b 6
word_6BD2C:	dc.w $200
		dc.b $C
		dc.b 4
		dc.b 1
		dc.b 0
byte_6BD32:	dc.b 2
		dc.b 0
		dc.b $1C
		dc.b 4
		dc.b 2
		dc.b 0
byte_6BD38:	dc.b 2
		dc.b 0
		dc.b $1C
		dc.b 4
		dc.b 6
		dc.b 0
word_6BD3E:	dc.w $8320
		dc.w $80
		dc.b $14
		dc.b $C
		dc.b $17
		dc.b 0
byte_6BD46:	dc.b 0
		dc.b $80
		dc.b $14
		dc.b $30
		dc.b $D
		dc.b 0
word_6BD4C:	dc.w 0
		dc.b $10
		dc.b 4
		dc.b $1A
		dc.b 0
word_6BD52:	dc.w $8320
		dc.w $80
		dc.b $C
		dc.b 8
		dc.b $18
		dc.b 0
ObjDat3_6BD5A:	dc.l Map_HCZEndBoss
		dc.w $8320
		dc.w $100
		dc.b $C
		dc.b $10
		dc.b 8
		dc.b 0
ObjDat3_6BD66:	dc.l Map_Explosion
		dc.w $85A0
		dc.w $80
		dc.b $C
		dc.b $C
		dc.b 0
		dc.b $8B
ObjDat3_6BD72:	dc.l Map_Bubbler
		dc.w $845C
		dc.w $280
		dc.b $10
		dc.b $10
		dc.b 0
		dc.b 0
ObjDat3_6BD7E:	dc.l Map_HCZWaterWall
		dc.w $436B
		dc.w $280
		dc.b $20
		dc.b $60
		dc.b 1
		dc.b 0
ChildObjDat_6BD8A:dc.w 4
		dc.l loc_6B5C4
		dc.w $2312
		dc.l loc_6B5C4
		dc.w $1B0A
		dc.l loc_6B5C4
		dc.w $130A
		dc.l loc_6B75C
		dc.w $1C
		dc.l loc_6B1A8
		dc.w $24
word_6BDAA:	dc.w 0
		dc.l loc_6B5C4
		dc.b $13
		dc.b $A
ChildObjDat_6BDB2:dc.w 0

		dc.l loc_6B77C
		dc.w 0
ChildObjDat_6BDBA:dc.w 0
		dc.l loc_6B26E
		dc.w 0
ChildObjDat_6BDC2:dc.w 0
		dc.l loc_6B3DE
		dc.w 0
ChildObjDat_6BDCA:dc.w 1

		dc.l loc_6B456
		dc.w $FC00
		dc.l loc_6B456
		dc.w $400
ChildObjDat_6BDD8:dc.w 0
		dc.l loc_6B4A2
		dc.w 0
ChildObjDat_6BDE0:dc.w 4
		dc.l loc_6B4C4
ChildObjDat_6BDE6:dc.w $13
		dc.l loc_6B50C
ChildObjDat_6BDEC:dc.w 0
		dc.l Obj_RobotnikShip2
		dc.w $C
byte_6BDF4:	dc.b 7
		dc.b 8
		dc.b 2
		dc.b 3
		dc.b 4
		dc.b 5
		dc.b $FC
byte_6BDFB:	dc.b 0
		dc.b 2
		dc.b 3
		dc.b 4
		dc.b 5
		dc.b $FC
byte_6BE01:	dc.b 7
		dc.b 2
		dc.b 3
		dc.b 4
		dc.b 5
		dc.b $FC
byte_6BE07:	dc.b 5
		dc.b 8
		dc.b 6
		dc.b 7
		dc.b $FC
byte_6BE0C:	dc.b 3
		dc.b $17
		dc.b $17
		dc.b $22
		dc.b $16
		dc.b $21
		dc.b $15
		dc.b $20
		dc.b $F4
byte_6BE15:	dc.b 3
		dc.b $15
		dc.b $20
		dc.b $FC
byte_6BE19:	dc.b 3

		dc.b $D
		dc.b $F
		dc.b $11
		dc.b $FC
byte_6BE1E:	dc.b 3
		dc.b $24
		dc.b $25
		dc.b $26
		dc.b $FC
byte_6BE23:	dc.b 3
		dc.b $27
		dc.b $28
		dc.b $29
		dc.b $FC
byte_6BE28:	dc.b 3
		dc.b $2A
		dc.b $2B
		dc.b $2C
		dc.b $FC
byte_6BE2D:	dc.b 3
		dc.b $2D
		dc.b $2E
		dc.b $2F
		dc.b $FC
byte_6BE32:	dc.b 1
		dc.b $1A
		dc.b $23
		dc.b $FC
byte_6BE36:	dc.b  $18,   2
		dc.b  $18,   2
		dc.b  $30,   3
		dc.b  $19,   4
		dc.b  $F4
byte_6BE3F:	dc.b	8,   0,	  8,   0
		dc.b  $1B,   0,	  9,   0
		dc.b  $1C,   0,	 $A,   0
		dc.b  $1D,   0,	 $A,   0
		dc.b  $1D,   0,	 $A,   0
		dc.b  $1D,   0,	 $A,   0
		dc.b  $1D,   0,	 $A,   0
		dc.b  $1D,   0,	 $A,   0
		dc.b  $1D,   0,	 $A,   0
		dc.b  $1D,   0,	 $A,   0
		dc.b  $1D,   0,	 $A,   0
		dc.b  $1D,   0,	 $B,   2
		dc.b  $1E,   2,	 $C,   3
		dc.b  $1F,   3,	$F4
byte_6BE76:	dc.b	8,   0,	  8,   0
		dc.b  $1B,   0,	  9,   0
		dc.b  $1C,   0,	 $A,   0
		dc.b  $1D,   0,	 $A,   0
		dc.b  $1D,   0,	 $A,   0
		dc.b  $1D,   0,	 $A,   0
		dc.b  $1D,   0,	 $A,   0
		dc.b  $1D,   0,	 $A,   0
		dc.b  $1D,   0,	 $A,   0
		dc.b  $1D,   0,	 $B,   2
		dc.b  $1E,   2,	 $C,   3
		dc.b  $1F,   3,	$F4
byte_6BEA5:	dc.b	8,   0,	  8,   0
		dc.b  $1B,   0,	  9,   0
		dc.b  $1C,   0,	 $A,   0
		dc.b  $1D,   0,	 $A,   0
		dc.b  $1D,   0,	 $A,   0
		dc.b  $1D,   0,	 $A,   0
		dc.b  $1D,   0,	 $A,   0
		dc.b  $1D,   0,	 $B,   2
		dc.b  $1E,   2,	 $C,   3
		dc.b  $1F,   3,	$F4
byte_6BECC:	dc.b	8,   0,	  8,   0
		dc.b  $1B,   0,	  9,   0
		dc.b  $1C,   0,	 $A,   0
		dc.b  $1D,   0,	 $A,   0
		dc.b  $1D,   0,	 $A,   0
		dc.b  $1D,   0,	 $B,   2
		dc.b  $1E,   2,	 $C,   3
		dc.b  $1F,   3,	$F4
byte_6BEEB:	dc.b	8,   0,	  8,   0
		dc.b  $1B,   0,	  9,   0
		dc.b  $1C,   0,	 $A,   0
		dc.b  $1D,   0,	 $B,   2
		dc.b  $1E,   2,	 $C,   3
		dc.b  $1F,   3,	$F4
byte_6BF02:	dc.b	7
		dc.b	0
		dc.b	0
		dc.b	1
		dc.b	2
		dc.b	3
		dc.b	4
		dc.b  $F4
Pal_HCZEndBoss:	binclude "Levels\HCZ\Palettes\End Boss.bin"

; ---------------------------------------------------------------------------

Obj_MGZ2DrillingEggman:

		move.l	#Obj_Wait,(a0)
		move.b	#1,($FFFFF7AA).w
		move.w	#$78,$2E(a0)
		move.l	#Obj_MGZ2DrillingEggmanGo,$34(a0)
		clr.b	$2C(a0)
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		lea	(ArtKosM_MGZEndBoss).l,a1
		move.w	#$67E0,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_MGZEndBossDebris).l,a1
		move.w	#-$7440,d2
		jsr	(Queue_Kos_Module).l
		moveq	#$6D,d0
		jsr	(Load_PLC).l
		lea	Pal_MGZEndBoss(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

Obj_MGZ2DrillingEggmanGo:
		move.l	#Obj_MGZ2DrillingEggmanStart,(a0)
		moveq	#$19,d0		; Play boss music
		jsr	(Play_Sound).l
		move.b	#$19,($FFFFFF91).w

locret_6BF96:

		rts
; ---------------------------------------------------------------------------

Obj_MGZ2DrillingEggmanStart:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6BFB0(pc,d0.w),d1
		jsr	off_6BFB0(pc,d1.w)
		bsr.w	MGZ2_SpecialCheckHit
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_6BFB0:	dc.w loc_6BFCA-off_6BFB0

		dc.w loc_6C014-off_6BFB0
		dc.w loc_6C024-off_6BFB0
		dc.w loc_6C07E-off_6BFB0
		dc.w loc_6C0B2-off_6BFB0
		dc.w loc_6C0E4-off_6BFB0
		dc.w loc_6C122-off_6BFB0
		dc.w loc_6C136-off_6BFB0
		dc.w loc_6C0E4-off_6BFB0
		dc.w loc_6C16A-off_6BFB0
		dc.w loc_6C0E4-off_6BFB0
		dc.w loc_6C1D4-off_6BFB0
		dc.w loc_6C2B2-off_6BFB0
; ---------------------------------------------------------------------------

loc_6BFCA:
		lea	ObjDat_MGZDrillBoss(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#-1,$29(a0)
		move.b	#$30,$1F(a0)
		move.b	#$24,$1E(a0)
		move.w	#$C,$26(a0)
		bset	#3,$38(a0)
		move.w	#-$800,$1A(a0)
		lea	Child1_MakeRoboShip3(pc),a2
		jsr	(CreateChild1_Normal).l
		bne.s	loc_6C00A

loc_6C004:
		move.b	#9,$2C(a1)

loc_6C00A:
		lea	ChildObjDat_6D7C0(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6C014:
		move.b	#4,5(a0)
		moveq	#$59,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_6C024:
		move.w	$1A(a0),d0
		addi.w	#$40,d0
		cmpi.w	#$C0,d0
		bge.s	loc_6C06E
		move.w	d0,$1A(a0)
		btst	#7,$38(a0)
		bne.s	loc_6C068
		move.w	($FFFFEE7C).w,d1
		addi.w	#$120,d1
		cmp.w	$14(a0),d1
		bcs.s	loc_6C068
		bset	#7,$38(a0)
		lea	ChildObjDat_6D7EA(pc),a2
		btst	#0,4(a0)
		beq.s	loc_6C062
		lea	ChildObjDat_6D7F2(pc),a2

loc_6C062:
		jsr	(CreateChild3_NormalRepeated).l

loc_6C068:

		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_6C06E:
		move.b	#6,5(a0)
		move.b	#5,$39(a0)
		jmp	Swing_Setup1(pc)
; ---------------------------------------------------------------------------

loc_6C07E:
		btst	#6,$2A(a0)
		bne.s	loc_6C092
		jsr	(Swing_UpAndDown_Count).l
		tst.b	$39(a0)
		bpl.s	loc_6C0AC

loc_6C092:
		move.b	#$16,5(a0)
		move.w	#-$400,$1A(a0)
		move.w	#$7F,$2E(a0)
		move.l	#loc_6C200,$34(a0)

loc_6C0AC:
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_6C0B2:
		subq.w	#1,$2E(a0)
		bpl.s	loc_6C0D8
		move.w	#3,$2E(a0)
		subq.w	#2,$26(a0)
		bne.s	loc_6C0D8
		move.b	#$A,5(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_6C0F6,$34(a0)

loc_6C0D8:

		jsr	(Swing_UpAndDown).l
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_6C0E4:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6C0F6:
		move.l	#loc_6C10C,$34(a0)

loc_6C0FE:
		bset	#3,$38(a0)
		move.w	#$5F,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C10C:
		move.b	#$C,5(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_6C128,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C122:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6C128:
		move.b	#$E,5(a0)
		bset	#1,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C136:
		btst	#1,$38(a0)
		beq.s	loc_6C140
		rts
; ---------------------------------------------------------------------------

loc_6C140:
		move.b	#$10,5(a0)
		bclr	#3,$38(a0)
		move.w	#$5F,$2E(a0)
		move.l	#loc_6C15C,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C15C:
		move.b	#$12,5(a0)
		move.w	#3,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C16A:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		subq.w	#1,$2E(a0)
		bpl.s	locret_6C18E
		move.w	#3,$2E(a0)
		addq.w	#2,$26(a0)
		cmpi.w	#$C,$26(a0)
		bcc.s	loc_6C190

locret_6C18E:
		rts
; ---------------------------------------------------------------------------

loc_6C190:
		move.b	#$14,5(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_6C1A6,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C1A6:
		move.l	#loc_6C1B2,$34(a0)
		bra.w	loc_6C0FE
; ---------------------------------------------------------------------------

loc_6C1B2:
		move.b	#$16,5(a0)
		move.w	#-$400,$1A(a0)
		move.w	#$7F,$2E(a0)
		move.l	#loc_6C200,$34(a0)
		bclr	#7,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C1D4:
		jsr	(ObjHitCeiling).l
		tst.w	d1
		bmi.s	loc_6C1E4
		jmp	(Move_WaitNoFall).l
; ---------------------------------------------------------------------------

loc_6C1E4:
		move.b	#$18,5(a0)
		lea	ChildObjDat_6D7EA(pc),a2
		btst	#0,4(a0)
		beq.s	loc_6C1FA
		lea	ChildObjDat_6D7F2(pc),a2

loc_6C1FA:
		jmp	(CreateChild3_NormalRepeated).l
; ---------------------------------------------------------------------------

loc_6C200:

		bset	#5,$38(a0)
		clr.b	($FFFFF7AA).w
		move.l	#Delete_Current_Sprite,(a0)
		jsr	(Obj_PlayLevelMusic).l
		lea	(MGZ_8x8_Primary_KosM).l,a1
		move.w	#0,d2
		jsr	(Queue_Kos_Module).l
		lea	(MGZ2_8x8_Secondary_KosM).l,a1
		move.w	#$4A40,d2
		jsr	(Queue_Kos_Module).l
		moveq	#$14,d0
		jsr	(Load_PLC).l
		lea	(ArtKosM_Spiker).l,a1
		move.w	#-$5A00,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_Mantis).l,a1
		move.w	#-$5620,d2
		jsr	(Queue_Kos_Module).l
		lea	(PLC_83D3A).l,a1
		jsr	(Load_PLC_Raw).l
		lea	(Pal_MGZ).l,a1
		jsr	(PalLoad_Line1).l
		move.w	#$1DF,($FFFFEE18).w
		st	($FFFFEEB8).w
		btst	#0,4(a0)
		bne.s	loc_6C29E
		move.w	#$6000,($FFFFFA92).w
		jsr	(Create_New_Sprite).l
		bne.s	locret_6C29C
		move.l	#Obj_IncLevEndXGradual,(a1)

locret_6C29C:
		rts
; ---------------------------------------------------------------------------

loc_6C29E:
		clr.w	($FFFFFA94).w
		jsr	(Create_New_Sprite).l
		bne.s	locret_6C2B0
		move.l	#Obj_DecLevStartXGradual,(a1)

locret_6C2B0:
		rts
; ---------------------------------------------------------------------------

loc_6C2B2:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6C2BE:
		move.l	#Obj_Wait,(a0)
		bset	#4,$38(a0)
		move.l	#loc_6C2E2,$34(a0)
		move.w	#$200,8(a0)
		lea	ChildObjDat_6D822(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6C2E2:
		move.l	#loc_6C2EE,(a0)
		jmp	(loc_694AA).l
; ---------------------------------------------------------------------------

loc_6C2EE:
		tst.b	($FFFFFAA8).w
		bne.w	locret_6BF96
		move.l	#locret_6C318,(a0)
		bset	#4,$38(a0)
		jsr	(Obj_PlayLevelMusic).l
		jsr	(Create_New_Sprite).l
		bne.s	locret_6C316
		move.l	#loc_6D104,(a1)

locret_6C316:
		rts
; ---------------------------------------------------------------------------

locret_6C318:
		rts
; ---------------------------------------------------------------------------

Obj_A1_1_MGZ2_Boss:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6C332(pc,d0.w),d1
		jsr	off_6C332(pc,d1.w)
		bsr.w	MGZ2_SpecialCheckHit
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_6C332:	dc.w loc_6C354-off_6C332
		dc.w loc_6C3E6-off_6C332
		dc.w loc_6C416-off_6C332
		dc.w loc_6C43A-off_6C332
		dc.w loc_6C45A-off_6C332
		dc.w loc_6C3E6-off_6C332
		dc.w loc_6C4B2-off_6C332
		dc.w loc_6C4F2-off_6C332
		dc.w loc_6C514-off_6C332
		dc.w loc_6C3E6-off_6C332
		dc.w loc_6C546-off_6C332
		dc.w loc_6C3E6-off_6C332
		dc.w loc_6C514-off_6C332
		dc.w loc_6C5C4-off_6C332
		dc.w loc_6C5FE-off_6C332
		dc.w loc_6C4F2-off_6C332
		dc.w loc_6C514-off_6C332
; ---------------------------------------------------------------------------

loc_6C354:
		lea	ObjDat_MGZDrillBoss(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bset	#7,$A(a0)
		st	$46(a0)
		move.b	#8,$29(a0)
		move.b	#1,($FFFFF7AA).w
		move.b	#$1C,$1E(a0)
		move.w	#$C,$26(a0)
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		move.w	#$78,$2E(a0)
		move.l	#loc_6C3EC,$34(a0)
		lea	(ArtKosM_MGZEndBoss).l,a1
		move.w	#$67E0,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_MGZEndBossDebris).l,a1
		move.w	#-$7440,d2
		jsr	(Queue_Kos_Module).l
		moveq	#$6D,d0
		jsr	(Load_PLC).l
		lea	Pal_MGZEndBoss(pc),a1
		jsr	(PalLoad_Line1).l
		lea	(Child1_MakeRoboShip3).l,a2
		jsr	(CreateChild1_Normal).l
		bne.s	loc_6C3DC
		move.b	#9,$2C(a1)

loc_6C3DC:
		lea	ChildObjDat_6D7C0(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6C3E6:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6C3EC:
		move.b	#4,5(a0)
		moveq	#$19,d0
		jsr	(Play_Sound).l
		move.b	#$19,($FFFFFF91).w
		move.w	#$80,$1A(a0)
		move.w	#$BF,$2E(a0)
		move.l	#loc_6C422,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C416:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6C422:
		move.b	#6,5(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_6C44C,$34(a0)
		jmp	Swing_Setup1(pc)
; ---------------------------------------------------------------------------

loc_6C43A:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6C44C:
		move.b	#8,5(a0)
		move.w	#3,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C45A:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		subq.w	#1,$2E(a0)
		bpl.s	locret_6C47E
		move.w	#3,$2E(a0)
		subq.w	#2,$26(a0)
		cmpi.w	#4,$26(a0)
		bls.s	loc_6C480

locret_6C47E:
		rts
; ---------------------------------------------------------------------------

loc_6C480:
		move.b	#$A,5(a0)
		bset	#3,$38(a0)
		move.w	#$5F,$2E(a0)
		move.l	#loc_6C49C,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C49C:
		move.b	#$C,5(a0)
		move.w	#$400,$1A(a0)
		move.l	#loc_6C4BE,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C4B2:
		jsr	(MoveSprite2).l
		jmp	(ObjHitFloor_DoRoutine).l
; ---------------------------------------------------------------------------

loc_6C4BE:
		move.b	#$E,5(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_6C4F8,$34(a0)
		st	($FFFFEEC4).w
		st	($FFFFF665).w
		moveq	#$61,d0
		jsr	(Play_Sound_2).l
		jsr	(Create_New_Sprite).l
		bne.s	locret_6C4F0
		move.l	#Obj_MGZ2_BossTransition,(a1)

locret_6C4F0:
		rts
; ---------------------------------------------------------------------------

loc_6C4F2:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6C4F8:
		move.b	#$10,5(a0)
		move.w	#-$400,$1A(a0)
		move.w	#$17,$2E(a0)
		move.l	#loc_6C51A,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C514:
		jmp	(Move_WaitNoFall).l
; ---------------------------------------------------------------------------

loc_6C51A:
		move.b	#$12,5(a0)
		bclr	#3,$38(a0)
		move.w	#$7F,$2E(a0)
		move.l	#loc_6C538,$34(a0)
		jmp	Swing_Setup1(pc)
; ---------------------------------------------------------------------------

loc_6C538:
		move.b	#$14,5(a0)
		move.w	#3,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C546:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		subq.w	#1,$2E(a0)
		bpl.s	locret_6C564
		move.w	#3,$2E(a0)
		subq.w	#2,$26(a0)
		beq.s	loc_6C566

locret_6C564:
		rts
; ---------------------------------------------------------------------------

loc_6C566:
		move.b	#$16,5(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_6C57C,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C57C:
		move.b	#$18,5(a0)
		move.w	#-$400,$1A(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_6C598,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C598:
		move.b	#$1A,5(a0)
		clr.b	$46(a0)
		bset	#0,4(a0)
		move.w	#$3E80,$10(a0)
		move.w	#$700,$14(a0)
		move.w	#-$80,$18(a0)
		move.b	#6,$3A(a0)
		jmp	Swing_Setup1(pc)
; ---------------------------------------------------------------------------

loc_6C5C4:
		jsr	(MoveSprite2).l
		btst	#6,$2A(a0)
		bne.s	loc_6C5E8
		move.w	($FFFFB010).w,d0
		cmp.w	$10(a0),d0
		bcc.s	loc_6C5E8
		jsr	(Swing_UpAndDown).l
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_6C5E8:

		move.b	#$1C,5(a0)
		move.w	#$200,$18(a0)
		move.l	#loc_6C614,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C5FE:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		cmpi.w	#$3E00,$10(a0)
		bcs.w	locret_6BF96

loc_6C614:

		move.b	#$1E,5(a0)
		moveq	#$60,d0
		jsr	(Play_Sound_2).l
		bclr	#3,$38(a0)
		bclr	#2,$38(a0)
		move.w	#$9F,$2E(a0)
		move.l	#loc_6C646,$34(a0)
		lea	ChildObjDat_6D836(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6C646:
		move.w	#$1F,$2E(a0)
		move.l	#loc_6C658,$34(a0)
		bra.w	loc_6D710
; ---------------------------------------------------------------------------

loc_6C658:
		bset	#3,$38(a0)
		move.w	#$9F,$2E(a0)
		move.l	#loc_6C66C,$34(a0)

loc_6C66C:
		move.b	#$20,5(a0)
		move.w	#$FF,$2E(a0)
		move.l	#loc_6C614,$34(a0)
		bset	#2,$38(a0)
		rts
; ---------------------------------------------------------------------------
word_6C688:	dc.w	  0,  $128, $3C78, $3E78
		dc.w	$28,   $28, $3D78, $3D78
; ---------------------------------------------------------------------------

Obj_A2_1:
		lea	word_6C688(pc),a1
		jsr	(Check_CameraInRange).l
		move.b	#$2E,$26(a0)
		jsr	(sub_85D6A).l
		move.l	#loc_6C6F4,(a0)
		move.l	#loc_6C6FA,$34(a0)
		lea	(ArtKosM_MGZEndBoss).l,a1
		move.w	#$67E0,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_MGZEndBossDebris).l,a1
		move.w	#-$7440,d2
		jsr	(Queue_Kos_Module).l
		moveq	#$6D,d0
		jsr	(Load_PLC).l
		cmpi.b	#2,($FFFFB038).w
		lea	Pal_MGZEndBoss(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_6C6F4:
		jmp	(loc_85CA4).l
; ---------------------------------------------------------------------------

loc_6C6FA:
		move.l	#loc_6C702,(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C702:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6C71A(pc,d0.w),d1
		jsr	off_6C71A(pc,d1.w)
		bsr.w	loc_6D61E
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_6C71A:	dc.w loc_6C72A-off_6C71A

		dc.w loc_6C782-off_6C71A
		dc.w loc_6C796-off_6C71A
		dc.w loc_6C814-off_6C71A
		dc.w loc_6C7D8-off_6C71A
		dc.w loc_6C814-off_6C71A
		dc.w loc_6C83C-off_6C71A
		dc.w loc_6C88A-off_6C71A
; ---------------------------------------------------------------------------

loc_6C72A:
		lea	ObjDat_MGZDrillBoss(pc),a1
		jsr	(SetUp_ObjAttributes).l
		st	$46(a0)
		move.b	#8,$29(a0)
		move.b	#$1C,$1E(a0)
		move.w	#$C,$26(a0)
		move.b	#2,$2C(a0)
		bset	#3,$38(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_6C788,$34(a0)
		lea	(Child1_MakeRoboShip3).l,a2
		jsr	(CreateChild1_Normal).l
		bne.s	loc_6C778
		move.b	#9,$2C(a1)

loc_6C778:
		lea	ChildObjDat_6D7C0(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6C782:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6C788:

		move.b	#4,5(a0)
		bset	#1,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C796:
		btst	#2,$38(a0)
		bne.s	loc_6C7A0
		rts
; ---------------------------------------------------------------------------

loc_6C7A0:
		move.b	#6,5(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_6C7BC,$34(a0)
		move.b	#0,$2C(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C7BC:
		move.b	#8,5(a0)
		move.w	#$87,$2E(a0)
		move.l	#loc_6C7FE,$34(a0)
		lea	($FFFFFA82).w,a1
		bra.w	loc_6D51A
; ---------------------------------------------------------------------------

loc_6C7D8:
		cmpi.w	#$28,$2E(a0)
		bne.s	loc_6C7F2
		moveq	#$59,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_6D83E(pc),a2
		jsr	(CreateChild6_Simple).l

loc_6C7F2:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6C7FE:
		move.b	#$A,5(a0)

loc_6C804:
		move.w	#$3F,$2E(a0)
		move.l	#loc_6C81A,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C814:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6C81A:
		move.b	#$C,5(a0)
		move.w	#$9F,$2E(a0)
		move.l	#loc_6C862,$34(a0)
		move.b	#2,$2C(a0)
		lea	($FFFFFA8A).w,a1
		bra.w	loc_6D51A
; ---------------------------------------------------------------------------

loc_6C83C:
		cmpi.w	#$48,$2E(a0)
		bne.s	loc_6C856
		moveq	#$59,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_6D83E(pc),a2
		jsr	(CreateChild6_Simple).l

loc_6C856:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6C862:
		move.b	#$E,5(a0)
		move.w	#$3E18,$10(a0)
		move.w	#-$58,$14(a0)
		move.w	#$77,$2E(a0)
		move.l	#loc_6C788,$34(a0)
		bclr	#2,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_6C88A:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6C890:
		move.l	#Obj_Wait,(a0)
		move.w	#$200,8(a0)
		move.l	#loc_6C8B4,$34(a0)
		bset	#4,$38(a0)
		lea	ChildObjDat_6D822(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6C8B4:
		move.l	#loc_6C8F4,(a0)
		st	($FFFFFAA8).w
		clr.b	($FFFFF7AA).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_6C8DC
		move.l	#Obj_81,(a1)
		move.w	#$3F40,$10(a1)
		move.w	#$B0,$14(a1)

loc_6C8DC:
		move.w	($FFFFFAB4).w,d0
		addi.w	#$118,d0
		move.w	d0,($FFFFFA92).w
		lea	(Child6_IncLevX).l,a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_6C8F4:
		move.w	($FFFFEE78).w,($FFFFEE14).w
		tst.b	($FFFFFAA8).w
		bne.w	locret_6BF96
		move.l	#loc_6C932,(a0)
		clr.b	($FFFFFAA8).w
		jsr	(Restore_PlayerControl).l
		jsr	(Obj_PlayLevelMusic).l
		clr.w	($FFFFF602).w
		st	($FFFFF7CA).w
		clr.w	$2E(a0)
		move.b	#1,($FFFFEE0A).w
		addi.w	#$30,($FFFFEE16).w
		rts
; ---------------------------------------------------------------------------

loc_6C932:
		move.w	($FFFFEE78).w,d0
		addi.w	#$150,d0
		cmp.w	($FFFFB010).w,d0
		bls.w	loc_6D13C
		jmp	(loc_86334).l
; ---------------------------------------------------------------------------

loc_6C948:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6C95E(pc,d0.w),d1
		jsr	off_6C95E(pc,d1.w)
		moveq	#0,d0
		jmp	(Child_Draw_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------
off_6C95E:	dc.w loc_6C962-off_6C95E
		dc.w loc_6C988-off_6C95E
; ---------------------------------------------------------------------------

loc_6C962:
		lea	word_6D782(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		movea.w	$46(a0),a1
		cmpi.l	#Obj_A1_1_MGZ2_Boss,(a1)
		bne.s	loc_6C97E
		bclr	#7,$A(a0)

loc_6C97E:
		lea	ChildObjDat_6D7DA(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6C988:
		movea.w	$46(a0),a1
		btst	#5,$38(a1)
		bne.s	loc_6C9E2
		cmpi.b	#2,$2C(a1)
		beq.s	loc_6C9CC
		btst	#1,$38(a1)
		beq.s	loc_6C9C6
		bset	#1,$38(a0)
		bne.s	loc_6C9CC
		lea	ChildObjDat_6D802(pc),a2
		btst	#0,4(a0)
		beq.s	loc_6C9BC
		lea	ChildObjDat_6D80A(pc),a2

loc_6C9BC:
		jsr	(CreateChild3_NormalRepeated).l
		bra.w	loc_6C9CC
; ---------------------------------------------------------------------------

loc_6C9C6:
		bclr	#1,$38(a0)

loc_6C9CC:

		lea	byte_6D24A(pc),a2
		bsr.w	sub_6D228
		lea	byte_6D284(pc),a2
		bsr.w	sub_6D26A
		jmp	(Refresh_ChildPositionAdjusted).l
; ---------------------------------------------------------------------------

loc_6C9E2:

		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_6C9E8:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6C9FE(pc,d0.w),d1
		jsr	off_6C9FE(pc,d1.w)
		moveq	#0,d0
		jmp	(Child_DrawTouch_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------
off_6C9FE:	dc.w loc_6CA12-off_6C9FE

		dc.w loc_6CA2E-off_6C9FE
		dc.w loc_6CA62-off_6C9FE
		dc.w loc_6CB14-off_6C9FE
		dc.w loc_6CB38-off_6C9FE
		dc.w loc_6CB6A-off_6C9FE
		dc.w loc_6CB38-off_6C9FE
		dc.w loc_6CB6A-off_6C9FE
		dc.w loc_6CB38-off_6C9FE
		dc.w loc_6CC32-off_6C9FE
; ---------------------------------------------------------------------------

loc_6CA12:
		lea	word_6D788(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.b	#2,5(a0)
		movea.w	$46(a0),a1
		move.w	$46(a1),$44(a0)
		rts
; ---------------------------------------------------------------------------

loc_6CA2E:
		movea.w	$44(a0),a1
		btst	#5,$38(a1)
		bne.s	loc_6C9E2
		btst	#3,$38(a1)
		bne.s	loc_6CA58
		lea	byte_6D25A(pc),a2
		bsr.w	sub_6D228

loc_6CA4A:

		lea	byte_6D294(pc),a2
		bsr.w	sub_6D26A
		jmp	(Refresh_ChildPositionAdjusted).l
; ---------------------------------------------------------------------------

loc_6CA58:
		move.b	#4,5(a0)
		bra.w	loc_6D2FA
; ---------------------------------------------------------------------------

loc_6CA62:
		movea.w	$44(a0),a1
		btst	#5,$38(a1)
		bne.w	loc_6C9E2
		btst	#3,$38(a1)
		beq.s	loc_6CA88
		btst	#1,$38(a1)
		bne.s	loc_6CA9A
		jsr	(Animate_RawMultiDelay).l
		bra.s	loc_6CA4A
; ---------------------------------------------------------------------------

loc_6CA88:
		move.b	#6,5(a0)
		move.l	#loc_6CB1E,$34(a0)
		bra.w	loc_6D3A8
; ---------------------------------------------------------------------------

loc_6CA9A:
		cmpi.b	#2,$2C(a1)
		beq.s	loc_6CACA
		move.b	#8,5(a0)
		move.w	#$27,$2E(a0)
		move.l	#loc_6CB4A,$34(a0)
		bsr.w	sub_6D334
		bclr	#5,$38(a0)
		lea	ChildObjDat_6D7FA(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6CACA:
		move.b	#8,5(a0)
		move.w	#$37,$2E(a0)
		move.l	#loc_6CBB2,$34(a0)
		bclr	#2,$38(a0)
		bsr.w	sub_6D42E
		lea	ChildObjDat_6D812(pc),a2
		jsr	(CreateChild1_Normal).l
		moveq	#$59,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_6D83E(pc),a2
		jsr	(CreateChild6_Simple).l

loc_6CB04:
		bclr	#5,$38(a0)
		lea	ChildObjDat_6D7FA(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6CB14:
		jsr	(Animate_RawMultiDelay).l
		bra.w	loc_6CA4A
; ---------------------------------------------------------------------------

loc_6CB1E:
		move.b	#2,5(a0)
		move.w	#$1F,$2E(a0)
		movea.w	$44(a0),a1
		move.l	#loc_6CB4A,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6CB38:
		jsr	(MoveSprite2).l
		jsr	(Animate_RawMultiDelay).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6CB4A:

		move.b	#$A,5(a0)
		movea.w	$46(a0),a1
		bset	#3,$38(a1)
		move.w	#0,$2E(a0)
		move.l	#loc_6CB76,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6CB6A:
		jsr	(Animate_RawMultiDelay).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6CB76:
		move.b	#8,5(a0)
		movea.w	$46(a0),a1
		bclr	#3,$38(a1)
		neg.w	$18(a0)
		move.w	#$27,$2E(a0)
		move.l	#loc_6CB9A,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6CB9A:
		move.b	#4,5(a0)
		movea.w	$44(a0),a1
		bset	#5,$38(a0)
		bclr	#1,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_6CBB2:
		move.b	#$E,5(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_6CBCE,$34(a0)
		bset	#5,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_6CBCE:
		move.b	#8,5(a0)
		move.w	#$2F,$2E(a0)
		move.l	#loc_6CC0E,$34(a0)
		bsr.w	sub_6D4DC
		lea	ChildObjDat_6D812(pc),a2
		jsr	(CreateChild1_Normal).l
		bne.s	loc_6CBF8
		move.b	#2,$2C(a1)

loc_6CBF8:
		moveq	#$59,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_6D83E(pc),a2
		jsr	(CreateChild6_Simple).l
		bra.w	loc_6CB04
; ---------------------------------------------------------------------------

loc_6CC0E:
		move.b	#$12,5(a0)
		ori.b	#$24,$38(a0)
		movea.w	$44(a0),a1
		bset	#2,$38(a1)
		bclr	#1,$38(a1)
		subi.w	#$80,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_6CC32:
		movea.w	$44(a0),a1
		btst	#2,$38(a1)
		bne.s	locret_6CC44
		move.b	#4,5(a0)

locret_6CC44:
		rts
; ---------------------------------------------------------------------------

loc_6CC46:
		lea	word_6D77C(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_6CC58,(a0)
		rts
; ---------------------------------------------------------------------------

loc_6CC58:
		movea.w	$46(a0),a1
		btst	#5,$38(a1)
		bne.w	loc_6C9E2
		jsr	(Refresh_ChildPositionAdjusted).l
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------

loc_6CC72:
		lea	word_6D788(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		clr.b	$28(a0)
		move.w	#$200,8(a0)
		move.l	#loc_6CCC0,(a0)
		movea.w	$46(a0),a1
		move.w	$26(a1),d0
		move.w	word_6CCA8(pc,d0.w),$42(a0)
		lsr.w	#1,d0
		move.b	RawAni_6CCB8(pc,d0.w),$22(a0)
		jmp	(Refresh_ChildPositionAdjusted).l
; ---------------------------------------------------------------------------
word_6CCA8:	dc.w $C00
		dc.w $3F9
		dc.w $F0
		dc.w $FDF9
		dc.w $F400
		dc.w $FD07
		dc.w $10
		dc.w $C00
RawAni_6CCB8:	dc.b  $1C, $15,	$2C, $2A, $2D, $2B, $29, $1C
; ---------------------------------------------------------------------------

loc_6CCC0:
		jsr	(Refresh_ChildPositionAdjusted).l
		movea.w	$46(a0),a1
		btst	#5,$38(a1)
		bne.s	loc_6CCE0
		btst	#4,$38(a1)
		bne.s	loc_6CCE0
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6CCE0:

		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_6CCE6:
		move.l	#loc_6CD12,(a0)
		move.l	#loc_6CD32,$34(a0)
		movea.w	$46(a0),a1
		move.w	$26(a1),$26(a0)
		move.b	4(a1),4(a0)
		bclr	#7,4(a0)
		move.w	#4,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_6CD12:
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		bne.s	loc_6CD2C
		btst	#4,$38(a1)
		bne.s	loc_6CD2C
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6CD2C:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_6CD32:
		move.w	#4,$2E(a0)
		lea	ChildObjDat_6D81A(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6CD42:
		lea	word_6D794(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_6CD80,(a0)
		move.w	#$2F,$2E(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		movea.w	$46(a0),a1
		movea.w	$46(a1),a2
		move.w	a2,$44(a0)
		move.w	$26(a1),$26(a0)
		move.w	$2C(a1),$2C(a0)
		bsr.w	sub_6D334
		bra.w	loc_6D6A6
; ---------------------------------------------------------------------------

loc_6CD80:
		movea.w	$44(a0),a1
		btst	#2,$38(a1)
		bne.s	loc_6CD9C
		jsr	(MoveSprite2).l
		jsr	(Obj_Wait).l
		bra.w	loc_6D6A6
; ---------------------------------------------------------------------------

loc_6CD9C:
		move.l	#loc_6CDB0,(a0)
		movea.w	$44(a0),a1
		move.w	$46(a1),$44(a0)
		bra.w	loc_6D6A6
; ---------------------------------------------------------------------------

loc_6CDB0:
		movea.w	$44(a0),a1
		movea.w	$46(a1),a2
		move.w	$14(a1),d0
		move.b	$2C(a2),d1
		cmp.b	$2C(a0),d1
		bne.s	loc_6CDE4
		tst.b	d1
		bne.s	loc_6CDDA
		moveq	#8,d1
		add.w	d1,d0
		cmp.w	$14(a0),d0
		blt.s	loc_6CDE4

loc_6CDD4:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_6CDDA:
		moveq	#8,d1
		sub.w	d1,d0
		cmp.w	$14(a0),d0
		ble.s	loc_6CDD4

loc_6CDE4:

		bra.w	loc_6D6A6
; ---------------------------------------------------------------------------

loc_6CDE8:

		lea	word_6D78E(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_6CE04,(a0)
		bsr.w	sub_6D36E
		move.l	#loc_6CE1E,$34(a0)

loc_6CE04:
		subq.w	#1,$2E(a0)
		bmi.s	loc_6CE1E
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		beq.w	locret_6BF96
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_6CE1E:

		move.l	#loc_6CE36,(a0)
		move.b	#$17,$22(a0)
		clr.w	$2E(a0)
		moveq	#0,d0
		jmp	(Child_DrawTouch_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------

loc_6CE36:
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		bne.s	loc_6CE58
		move.b	#$16,$22(a0)
		addq.w	#1,$2E(a0)
		jsr	(MoveSprite2).l
		jmp	(Child_DrawTouch_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------

loc_6CE58:
		move.l	#loc_6CE66,(a0)
		moveq	#0,d0
		jmp	(Child_DrawTouch_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------

loc_6CE66:
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		beq.s	loc_6CE78
		jmp	(Child_DrawTouch_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------

loc_6CE78:
		move.l	#loc_6CE8A,(a0)
		neg.w	$18(a0)
		moveq	#0,d0
		jmp	(Child_DrawTouch_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------

loc_6CE8A:
		subq.w	#1,$2E(a0)
		bmi.s	loc_6CE9C
		jsr	(MoveSprite2).l
		jmp	(Child_DrawTouch_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------

loc_6CE9C:
		move.b	#$17,$22(a0)
		move.l	#Delete_Current_Sprite,(a0)
		moveq	#0,d0
		jmp	(Child_DrawTouch_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------

loc_6CEB0:

		lea	word_6D79A(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_6CEF0,(a0)
		move.b	$2C(a0),d0
		subi.b	#4,d0
		move.b	d0,$2C(a0)
		beq.s	loc_6CEE6
		move.w	#$380,8(a0)
		movea.w	$46(a0),a1
		cmpi.l	#Obj_A1_1_MGZ2_Boss,(a1)
		bne.s	loc_6CEE6
		bclr	#7,$A(a0)

loc_6CEE6:

		lea	ChildObjDat_6D7E2(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6CEF0:
		movea.w	$46(a0),a1
		btst	#5,$38(a1)
		bne.s	loc_6CF12
		lea	byte_6D2D2(pc),a2
		bsr.w	sub_6D2A4
		jsr	(Refresh_ChildPositionAdjusted).l
		moveq	#$14,d0
		jmp	(Child_Draw_Sprite2_FlickerMove).l
; ---------------------------------------------------------------------------

loc_6CF12:
		bset	#5,$38(a0)
		move.l	#Delete_Current_Sprite,(a0)
		rts
; ---------------------------------------------------------------------------

loc_6CF20:
		lea	word_6D7A0(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#loc_6CF62,(a0)
		bset	#4,$2B(a0)
		movea.w	$46(a0),a1
		move.w	$46(a1),$44(a0)
		tst.b	$2C(a1)
		beq.s	loc_6CF4C
		move.w	#$300,8(a0)

loc_6CF4C:
		bclr	#7,$A(a0)
		btst	#7,$A(a1)
		beq.s	locret_6CF60
		bset	#7,$A(a0)

locret_6CF60:
		rts
; ---------------------------------------------------------------------------

loc_6CF62:
		movea.w	$46(a0),a1
		btst	#5,$38(a1)
		bne.s	loc_6CF98
		lea	byte_6D2E6(pc),a2
		bsr.w	sub_6D2A4
		jsr	(Refresh_ChildPositionAdjusted).l
		movea.w	$44(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_6CF98
		btst	#0,($FFFFFE0F).w
		bne.w	locret_6BF96
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_6CF98:

		jmp	(Go_Delete_Sprite_2).l
; ---------------------------------------------------------------------------

loc_6CF9E:

		lea	ObjDat3_6D7A8(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_6CFB2,(a0)
		bra.w	loc_6D3E2
; ---------------------------------------------------------------------------

loc_6CFB2:
		jsr	(MoveSprite_LightGravity).l
		jmp	(Sprite_CheckDeleteXY).l
; ---------------------------------------------------------------------------

loc_6CFBE:

		lea	word_6D782(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		jsr	(Refresh_ChildPositionAdjusted).l
		move.l	#Obj_FlickerMove,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		beq.s	loc_6CFE2
		move.w	#$200,8(a0)

loc_6CFE2:
		lsr.w	#1,d0
		addi.b	#$2E,d0
		move.b	d0,$22(a0)
		moveq	#$28,d0
		jmp	(Set_IndexedVelocity).l
; ---------------------------------------------------------------------------

loc_6CFF4:
		lea	ObjDat3_6D7B4(pc),a1
		jsr	(SetUp_ObjAttributes).l

loc_6CFFE:
		move.l	#loc_6D060,(a0)
		move.w	#-$72E0,$3A(a0)
		move.w	($FFFFEE78).w,d0
		addi.w	#$140,d0
		move.w	d0,$10(a0)
		move.w	d0,$30(a0)
		move.w	($FFFFEE7C).w,d0
		addi.w	#$50,d0
		move.w	d0,$14(a0)
		move.w	d0,$34(a0)
		move.w	#-$400,$18(a0)
		move.b	#4,$40(a0)
		move.l	#ArtScaled_MGZEndBoss,$42(a0)
		move.b	#1,$3E(a0)
		bsr.w	DynamicWaterHeightC
		moveq	#6,d0
		move.w	$1C(a0),d1
		beq.s	loc_6D058
		cmpi.w	#$C,d1
		beq.s	loc_6D058
		moveq	#$10,d0

loc_6D058:

		move.w	d0,$2E(a0)
		bra.w	loc_6D0EE
; ---------------------------------------------------------------------------

loc_6D060:
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		bne.w	loc_6D0FE
		move.w	$18(a0),d0
		add.w	$2E(a0),d0
		cmpi.w	#-$100,d0
		bgt.s	loc_6D080
		move.w	d0,$18(a0)

loc_6D080:
		move.w	$1A(a0),d0
		move.w	$3C(a0),d1
		bmi.s	loc_6D096
		add.w	d1,d0
		cmpi.w	#$400,d0
		ble.s	loc_6D09E
		bra.w	loc_6D0A2
; ---------------------------------------------------------------------------

loc_6D096:
		add.w	d1,d0
		cmpi.w	#-$400,d0
		blt.s	loc_6D0A2

loc_6D09E:
		move.w	d0,$1A(a0)

loc_6D0A2:

		jsr	(sub_86180).l
		move.w	$30(a0),d2
		move.w	$34(a0),d3
		moveq	#0,d0
		move.b	$40(a0),d0
		addq.w	#4,d0
		move.l	#$100,d4
		divu.w	d0,d4
		sub.w	d4,d2
		sub.w	d4,d3
		move.w	d2,$10(a0)
		move.w	d3,$14(a0)
		move.b	($FFFFFE0F).w,d0
		andi.b	#3,d0
		bne.s	loc_6D0F4
		move.b	$40(a0),d0
		add.b	$3E(a0),d0
		andi.b	#$7F,d0
		cmpi.b	#4,d0
		bcs.w	loc_6D0EE
		move.b	d0,$40(a0)

loc_6D0EE:

		jsr	(Perform_Art_Scaling).l

loc_6D0F4:
		move.w	$30(a0),d0
		jmp	(Sprite_OnScreen_Test2).l
; ---------------------------------------------------------------------------

loc_6D0FE:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_6D104:
		subq.w	#1,$2E(a0)
		bpl.w	locret_6BF96
		moveq	#0,d0
		move.b	$39(a0),d0
		move.w	word_6D14C(pc,d0.w),$2E(a0)
		lsl.w	#4,d0
		lea	(Pal_MGZFadeCNZ).l,a1
		adda.w	d0,a1
		lea	($FFFFFC60).w,a2
		moveq	#7,d1

loc_6D128:
		move.l	(a1)+,(a2)+
		dbf	d1,loc_6D128
		addq.b	#2,$39(a0)
		cmpi.b	#$20,$39(a0)
		bcs.w	locret_6BF96

loc_6D13C:
		move.w	#$300,d0
		jsr	(StartNewLevel).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
word_6D14C:	dc.w $A
		dc.w $A
		dc.w $A
		dc.w $A
		dc.w $A
		dc.w $A
		dc.w $A
		dc.w $A
		dc.w $A
		dc.w $64
		dc.w 5
		dc.w 5
		dc.w 5
		dc.w 5
		dc.w $14
; ---------------------------------------------------------------------------

loc_6D16A:
		movea.w	$46(a0),a1
		move.w	($FFFFEE7C).w,d0
		move.w	d0,d1
		moveq	#$18,d2
		addi.w	#$70,d0
		cmp.w	$14(a1),d0
		bge.s	loc_6D18A
		move.w	#$C8,d2
		bset	#2,$38(a0)

loc_6D18A:
		add.w	d2,d1
		move.w	d1,$14(a0)
		move.l	#Obj_Wait,(a0)
		move.b	#9,$39(a0)
		move.l	#loc_6D1A6,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6D1A6:
		subq.b	#1,$39(a0)
		bmi.w	loc_6CD2C
		move.w	#3,$2E(a0)
		lea	ChildObjDat_6D844(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_6D1BE:
		lea	ObjDat3_6D7A8(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_6D1D2,(a0)
		bsr.w	sub_6D1DE

loc_6D1D2:
		jsr	(MoveSprite_LightGravity).l
		jmp	(Sprite_CheckDeleteXY).l

; =============== S U B R O U T I N E =======================================


sub_6D1DE:
		jsr	(Random_Number).l
		move.w	d0,d1
		andi.w	#3,d0
		move.b	RawAni_6D224(pc,d0.w),$22(a0)
		andi.w	#$3FF,d1
		btst	#0,d1
		beq.s	loc_6D1FC
		neg.w	d1

loc_6D1FC:
		move.w	d1,$18(a0)
		swap	d0
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		beq.s	locret_6D222
		andi.w	#$1FF,d0
		addi.w	#$200,d0
		btst	#0,d0
		beq.s	loc_6D21E
		neg.w	d0

loc_6D21E:
		move.w	d0,$1A(a0)

locret_6D222:
		rts
; End of function sub_6D1DE

; ---------------------------------------------------------------------------
RawAni_6D224:	dc.b	0,   1,	  2,   0

; =============== S U B R O U T I N E =======================================


sub_6D228:

		movea.w	$46(a0),a1
		move.w	$26(a1),d0
		move.w	d0,$26(a0)
		lea	(a2,d0.w),a3
		move.b	(a3)+,$22(a0)
		moveq	#0,d0
		move.b	(a3)+,d0
		beq.s	locret_6D248
		lsl.w	#4,d0
		move.w	d0,8(a0)

locret_6D248:
		rts
; End of function sub_6D228

; ---------------------------------------------------------------------------
byte_6D24A:	dc.b	2, $30
		dc.b	3, $30
		dc.b  $1E, $30
		dc.b  $1F, $30
		dc.b	5, $30
		dc.b	3, $30
		dc.b	4, $30
		dc.b	2, $30
byte_6D25A:	dc.b	9, $28
		dc.b   $C, $28
		dc.b  $20, $28
		dc.b  $14, $30
		dc.b  $13, $30
		dc.b  $12, $30
		dc.b   $F, $28
		dc.b	9, $28

; =============== S U B R O U T I N E =======================================


sub_6D26A:

		movea.w	$46(a0),a1
		move.w	$26(a1),d0
		move.w	d0,$26(a0)
		lea	(a2,d0.w),a3
		move.b	(a3)+,$42(a0)
		move.b	(a3)+,$43(a0)
		rts
; End of function sub_6D26A

; ---------------------------------------------------------------------------
byte_6D284:	dc.b  $E4, $10
		dc.b  $F6, $18
		dc.b   $C, $1C
		dc.b  $18, $14
		dc.b  $2C,   8
		dc.b  $20, $F4
		dc.b  $14, $EC
		dc.b  $E4, $10
byte_6D294:	dc.b  $E9,   0
		dc.b  $EF, $16
		dc.b	0, $20
		dc.b  $10,  $F
		dc.b  $11,   0
		dc.b  $10, $F0
		dc.b	0, $E0
		dc.b  $E9,   0

; =============== S U B R O U T I N E =======================================


sub_6D2A4:

		movea.w	$46(a0),a1
		moveq	#0,d0
		move.b	$3A(a1),d0
		move.b	d0,$3A(a0)
		add.w	d0,d0
		lea	(a2,d0.w),a3
		move.b	(a3)+,$42(a0)
		move.b	(a3)+,$43(a0)
		move.b	(a3)+,$22(a0)
		tst.b	$2C(a0)
		beq.s	locret_6D2D0
		subi.b	#$14,$42(a0)

locret_6D2D0:
		rts
; End of function sub_6D2A4

; ---------------------------------------------------------------------------
byte_6D2D2:	dc.b	8, $18
		dc.b	6,   0
		dc.b  $F8, $14
		dc.b	7,   0
		dc.b  $18, $14
		dc.b	8,   0
		dc.b  $18,   8
		dc.b  $18,   0
		dc.b  $18, $FC
		dc.b  $23,   0
byte_6D2E6:	dc.b	0, $10
		dc.b  $19,   0
		dc.b  $F8,   8
		dc.b  $1A,   0
		dc.b	8,   8
		dc.b  $24,   0
		dc.b  $10,   0
		dc.b  $1B,   0
		dc.b	9, $F9
		dc.b  $25,   0
; ---------------------------------------------------------------------------

loc_6D2FA:
		movea.w	$44(a0),a1
		move.w	$26(a1),d0
		add.w	d0,d0
		move.l	off_6D314(pc,d0.w),$30(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		rts
; ---------------------------------------------------------------------------
off_6D314:	dc.l byte_6D853
		dc.l byte_6D87A
		dc.l byte_6D8A1
		dc.l byte_6D8C8
		dc.l byte_6D8CD
		dc.l byte_6D8D2
		dc.l byte_6D8D9
		dc.l byte_6D853

; =============== S U B R O U T I N E =======================================


sub_6D334:

		move.w	$26(a0),d0
		add.w	d0,d0
		move.l	dword_6D34E(pc,d0.w),$18(a0)
		btst	#0,4(a1)
		beq.s	locret_6D34C
		neg.w	$18(a0)

locret_6D34C:
		rts
; End of function sub_6D334

; ---------------------------------------------------------------------------
dword_6D34E:	dc.l $FC000000

		dc.l $FC000400
		dc.l $400
		dc.l $4000400
		dc.l $4000000
		dc.l $400FC00
		dc.l $FC00
		dc.l $FC000000

; =============== S U B R O U T I N E =======================================


sub_6D36E:
		movea.w	$46(a0),a1
		move.w	$26(a1),d0
		add.w	d0,d0
		move.l	dword_6D34E(pc,d0.w),$18(a0)
		btst	#0,4(a1)
		beq.s	loc_6D38A
		neg.w	$18(a0)

loc_6D38A:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_6D398(pc,d0.w),$2E(a0)
		rts
; End of function sub_6D36E

; ---------------------------------------------------------------------------
word_6D398:	dc.w 4
		dc.w 9
		dc.w $E
		dc.w $13
		dc.w $18
		dc.w $1D
		dc.w $22
		dc.w $27
; ---------------------------------------------------------------------------

loc_6D3A8:
		movea.w	$44(a0),a1
		move.w	$26(a1),d0
		add.w	d0,d0
		move.l	off_6D3C2(pc,d0.w),$30(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		rts
; ---------------------------------------------------------------------------
off_6D3C2:	dc.l byte_6D900
		dc.l byte_6D91F
		dc.l byte_6D93E
		dc.l byte_6D8C8
		dc.l byte_6D8CD
		dc.l byte_6D8D2
		dc.l byte_6D95D
		dc.l byte_6D900
; ---------------------------------------------------------------------------

loc_6D3E2:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,d1
		lsr.w	#1,d0
		move.b	RawAni_6D3FC(pc,d0.w),$22(a0)
		add.w	d1,d1
		move.l	word_6D406(pc,d1.w),$18(a0)
		rts
; ---------------------------------------------------------------------------
RawAni_6D3FC:	dc.b	0,   1,	  2,   0,   0,	 1,   0,   2,	0,   1
word_6D406:	dc.w  $FC00, $FC00
		dc.w   $400, $FC00
		dc.w  $FF80, $FC00
		dc.w	$80, $FC00
		dc.w  $FD00, $FE00
		dc.w   $300, $FE00
		dc.w  $FE00, $FD00
		dc.w   $200, $FD00
		dc.w  $FF80, $FE00
		dc.w	$80, $FE00

; =============== S U B R O U T I N E =======================================


sub_6D42E:
		jsr	(Random_Number).l
		andi.w	#$FF,d0
		move.w	d0,d1
		andi.w	#1,d1
		bclr	#0,4(a0)
		subi.w	#$80,d0
		bcc.s	loc_6D452
		addq.w	#2,d1
		bset	#0,4(a0)

loc_6D452:
		move.w	($FFFFEE7C).w,d3
		addi.w	#8,d3
		lea	($FFFFFA82).w,a2

loc_6D45E:
		move.w	($FFFFEE78).w,d2
		addi.w	#$A8,d2
		add.w	d0,d2
		add.w	d1,d1
		move.w	word_6D4AC(pc,d1.w),d4
		move.w	d4,$26(a0)
		move.w	d2,$10(a0)
		move.w	d3,$14(a0)
		move.w	d1,(a2)+
		move.w	d4,(a2)+
		move.w	d2,(a2)+
		move.w	d3,(a2)+
		add.w	d1,d1
		move.l	off_6D4BC(pc,d1.w),$30(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		add.w	d4,d4
		lea	dword_6D34E(pc),a3
		move.l	(a3,d4.w),$18(a0)
		btst	#0,4(a0)
		beq.s	locret_6D4AA
		neg.w	$18(a0)

locret_6D4AA:
		rts
; End of function sub_6D42E

; ---------------------------------------------------------------------------
word_6D4AC:	dc.w 4
		dc.w 2
		dc.w 4
		dc.w 2
		dc.w $C
		dc.w $A
		dc.w $C
		dc.w $A
off_6D4BC:	dc.l byte_6D8C1
		dc.l byte_6D89A
		dc.l byte_6D8C1
		dc.l byte_6D89A
		dc.l byte_6D8F9
		dc.l byte_6D8D2
		dc.l byte_6D8F9
		dc.l byte_6D8D2

; =============== S U B R O U T I N E =======================================


sub_6D4DC:
		jsr	(Random_Number).l
		andi.w	#$7F,d0
		move.w	d0,d1
		andi.w	#1,d1
		addq.w	#4,d1
		move.w	($FFFFFA82).w,d2
		lsr.w	#1,d2
		bset	#0,4(a0)
		move.b	byte_6D516(pc,d2.w),d3
		beq.s	loc_6D508
		neg.w	d0
		bclr	#0,4(a0)

loc_6D508:
		add.b	d3,d1
		move.w	#$F8,d3
		lea	($FFFFFA8A).w,a2
		bra.w	loc_6D45E
; End of function sub_6D4DC

; ---------------------------------------------------------------------------
byte_6D516:	dc.b 2
		dc.b 0
		dc.b 0
		dc.b 2
; ---------------------------------------------------------------------------

loc_6D51A:

		move.w	(a1)+,d0
		move.w	(a1)+,d1
		move.w	d1,$26(a0)
		move.w	(a1)+,d2
		move.w	(a1)+,d3
		lea	byte_6D588(pc,d0.w),a2
		move.b	(a2)+,d4
		ext.w	d4
		add.w	d4,d2
		move.w	d2,$10(a0)
		move.b	(a2)+,d4
		ext.w	d4
		add.w	d4,d3
		move.w	d3,$14(a0)
		lsr.w	#1,d0
		move.b	byte_6D598(pc,d0.w),$3A(a0)
		lsr.w	#1,d0
		move.b	byte_6D5A0(pc,d0.w),d2
		andi.b	#-4,4(a0)
		or.b	d2,4(a0)
		add.w	d1,d1
		lea	dword_6D34E(pc),a2
		move.l	(a2,d1.w),$18(a0)
		asr	$18(a0)
		asr	$1A(a0)
		btst	#0,4(a0)
		beq.s	loc_6D576
		neg.w	$18(a0)

loc_6D576:
		moveq	#$59,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_6D83E(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------
byte_6D588:	dc.b  $F4, $D4
		dc.b  $1A, $D8
		dc.b   $C, $D4
		dc.b  $E6, $D8
		dc.b  $14, $24
		dc.b  $30, $1C
		dc.b  $EC, $24
		dc.b  $D0, $1C
byte_6D598:	dc.b 0
		dc.b 8
		dc.b 0
		dc.b 8
		dc.b 0
		dc.b 2
		dc.b 0
		dc.b 2
byte_6D5A0:	dc.b 0
		dc.b 1
		dc.b 1
		dc.b 0

; =============== S U B R O U T I N E =======================================


MGZ2_SpecialCheckHit:

		tst.b	$28(a0)
		bne.s	locret_6D608	; If collision is on, don't do anything
		tst.b	$29(a0)
		bne.s	loc_6D5C2		; If still has a hit point, branch
		tst.b	$46(a0)
		beq.s	loc_6D60A		; ONLY kill the boss is $46 isn't set. If it is set, this is an event instance of the object
		move.b	#1,$29(a0)
		bclr	#7,$2A(a0)

loc_6D5C2:
		tst.b	$20(a0)
		bne.s	loc_6D5D6
		move.b	#$20,$20(a0)
		moveq	#$6E,d0			; Play hit sound
		jsr	(Play_Sound_2).l

loc_6D5D6:
		bset	#6,$2A(a0)
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_6D5EA
		addi.w	#6,d0

loc_6D5EA:
		bsr.w	MGZ2_BossPalAdjust
		subq.b	#1,$20(a0)
		bne.s	locret_6D608
		bclr	#6,$2A(a0)
		cmpi.b	#0,$22(a0)
		bne.s	locret_6D608
		move.b	$25(a0),$28(a0)	; Put backup of collision back into $28

locret_6D608:

		rts
; ---------------------------------------------------------------------------

loc_6D60A:
		move.l	#Wait_FadeToLevelMusic,(a0)
		move.l	#loc_6C2BE,$34(a0)
		jmp	(BossDefeated_StopTimer).l
; End of function MGZ2_SpecialCheckHit

; ---------------------------------------------------------------------------

loc_6D61E:
		tst.b	$28(a0)
		bne.s	locret_6D668
		tst.b	$29(a0)
		beq.s	loc_6D66A
		tst.b	$20(a0)
		bne.s	loc_6D644
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		bset	#6,$2A(a0)

loc_6D644:
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_6D652
		addi.w	#6,d0

loc_6D652:
		bsr.w	MGZ2_BossPalAdjust
		subq.b	#1,$20(a0)
		bne.s	locret_6D668
		bclr	#6,$2A(a0)
		move.b	$25(a0),$28(a0)

locret_6D668:

		rts
; ---------------------------------------------------------------------------

loc_6D66A:
		move.l	#Wait_FadeToLevelMusic,(a0)
		move.l	#loc_6C890,$34(a0)
		jmp	(BossDefeated_StopTimer).l

; =============== S U B R O U T I N E =======================================


MGZ2_BossPalAdjust:

		lea	word_6D694(pc),a1
		lea	word_6D69A(pc,d0.w),a2
		movea.w	(a1)+,a3
		move.w	(a2)+,(a3)+
		movea.w	(a1)+,a3
		move.w	(a2)+,(a3)+
		movea.w	(a1)+,a3
		move.w	(a2)+,(a3)+
		rts
; End of function MGZ2_BossPalAdjust

; ---------------------------------------------------------------------------
word_6D694:	dc.w $FC36
		dc.w $FC3A
		dc.w $FC3C
word_6D69A:	dc.w $20
		dc.w $866
		dc.w $644
		dc.w $EEE
		dc.w $888
		dc.w $AAA
; ---------------------------------------------------------------------------

loc_6D6A6:

		movea.w	$44(a0),a1
		movea.w	$46(a1),a1
		btst	#7,$2A(a1)
		bne.s	loc_6D6BC
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_6D6BC:
		jsr	(Random_Number).l
		andi.w	#$3C,d0
		jmp	(loc_849D8).l

; =============== S U B R O U T I N E =======================================


DynamicWaterHeightC:
		movea.w	$46(a0),a2
		moveq	#0,d0
		move.b	$39(a2),d0
		addq.b	#1,$39(a2)
		andi.b	#7,d0
		move.b	byte_6D708(pc,d0.w),d0
		move.w	d0,$1C(a0)
		move.w	d0,$3C(a2)
		lea	word_6D6F8(pc,d0.w),a1
		move.w	(a1)+,$1A(a0)
		move.w	(a1)+,$3C(a0)
		rts
; End of function DynamicWaterHeightC

; ---------------------------------------------------------------------------
word_6D6F8:	dc.w  $FE00,	 8
		dc.w  $FA00,   $40
		dc.w   $600, $FFC0
		dc.w  $FE00,	 8
byte_6D708:	dc.b 0
		dc.b 8
		dc.b 4
		dc.b 0
		dc.b 0
		dc.b 4
		dc.b 0
		dc.b 8
; ---------------------------------------------------------------------------

loc_6D710:
		move.w	$3C(a0),d0
		lea	word_6D744(pc,d0.w),a2
		move.w	(a2)+,d1
		add.w	($FFFFEE78).w,d1
		move.w	d1,$10(a0)
		move.w	(a2)+,d1
		add.w	($FFFFEE7C).w,d1
		move.w	d1,$14(a0)
		move.l	dword_6D754(pc,d0.w),$18(a0)
		lsr.w	#1,d0
		move.w	word_6D764(pc,d0.w),$26(a0)
		lsr.w	#1,d0
		move.b	byte_6D76C(pc,d0.w),$3A(a0)
		rts
; ---------------------------------------------------------------------------
word_6D744:	dc.w  $FFC0,   $70
		dc.w	$A0,  $120
		dc.w	$A0, $FFB0
		dc.w  $FFC0,   $70
dword_6D754:	dc.l $2000000
		dc.l $80FE00
		dc.l $800200
		dc.l $2000000
word_6D764:	dc.w 0
		dc.w $C
		dc.w 4
		dc.w 0
byte_6D76C:	dc.b 6
		dc.b 4
		dc.b 8
		dc.b 6
ObjDat_MGZDrillBoss:	dc.l Map_MGZEndBoss

		dc.w $233F
		dc.w $300
		dc.b $24
		dc.b $20
		dc.b 0
		dc.b $F
word_6D77C:	dc.w $380
		dc.b $10
		dc.b $10
		dc.b 1
		dc.b 0
word_6D782:	dc.w $300

		dc.b $18
		dc.b $18
		dc.b 2
		dc.b 0
word_6D788:	dc.w $280

		dc.b $C
		dc.b $C
		dc.b 9
		dc.b $8B
word_6D78E:	dc.w $200
		dc.b 4
		dc.b 4
		dc.b $16
		dc.b $98
word_6D794:	dc.w $300
		dc.b 4
		dc.b 4
		dc.b $16
		dc.b $98
word_6D79A:	dc.w $180
		dc.b $C
		dc.b $C
		dc.b 6
		dc.b 0
word_6D7A0:	dc.w $33F
		dc.w $180
		dc.b $C
		dc.b $C
		dc.b $19
		dc.b $9A
ObjDat3_6D7A8:	dc.l Map_MGZEndBossDebris

		dc.w $C45E
		dc.w $100
		dc.b $10
		dc.b $10
		dc.b 0
		dc.b 0
ObjDat3_6D7B4:	dc.l Map_ScaledArt
		dc.w $2469
		dc.w $300
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b 0
ChildObjDat_6D7C0:dc.w 3

		dc.l loc_6CC46
		dc.w $EC0F
		dc.l loc_6C948
		dc.w $E410
		dc.l loc_6CEB0
		dc.w $818
		dc.l loc_6CEB0
		dc.w $F418
ChildObjDat_6D7DA:dc.w 0
		dc.l loc_6C9E8
		dc.w $E900
ChildObjDat_6D7E2:dc.w 0
		dc.l loc_6CF20
		dc.w $10
ChildObjDat_6D7EA:dc.w 9

		dc.l loc_6CF9E
		dc.w $18C0
ChildObjDat_6D7F2:dc.w 9

		dc.l loc_6CF9E
		dc.w $E8C0
ChildObjDat_6D7FA:dc.w 0

		dc.l loc_6CC72
		dc.w $C00
ChildObjDat_6D802:dc.w 7
		dc.l loc_6CDE8
		dc.w $F000
ChildObjDat_6D80A:dc.w 7
		dc.l loc_6CDE8
		dc.w $1000
ChildObjDat_6D812:dc.w 0

		dc.l loc_6CCE6
		dc.w 0
ChildObjDat_6D81A:dc.w 0
		dc.l loc_6CD42
		dc.w 0
ChildObjDat_6D822:dc.w 2

		dc.l loc_6CFBE
		dc.w $CEC
		dc.l loc_6CFBE
		dc.w $F008
		dc.l loc_6CFBE
		dc.w $1408
ChildObjDat_6D836:dc.w 0
		dc.l loc_6CFF4
		dc.w 0
ChildObjDat_6D83E:dc.w 0

		dc.l loc_6D16A
ChildObjDat_6D844:dc.w 0
		dc.l loc_6D1BE
		dc.b	0,   5
		dc.b	1,   5
		dc.b	2,   5
		dc.b	3,   5
		dc.b  $FC
byte_6D853:	dc.b	9,   7
		dc.b   $A,   7
		dc.b   $B,   7
		dc.b	9,   6
		dc.b   $A,   6
		dc.b   $B,   6
		dc.b	9,   5
		dc.b   $A,   5
		dc.b   $B,   5
		dc.b	9,   4
		dc.b   $A,   4
		dc.b   $B,   4
		dc.b	9,   3
		dc.b   $A,   3
		dc.b   $B,   3
		dc.b  $F8, $20
		dc.b	9,   2
		dc.b   $A,   2
		dc.b   $B,   2
		dc.b  $FC
byte_6D87A:	dc.b   $C,   7
		dc.b   $D,   7
		dc.b   $E,   7
		dc.b   $C,   6
		dc.b   $D,   6
		dc.b   $E,   6
		dc.b   $C,   5
		dc.b   $D,   5
		dc.b   $E,   5
		dc.b   $C,   4
		dc.b   $D,   4
		dc.b   $E,   4
		dc.b   $C,   3
		dc.b   $D,   3
		dc.b   $E,   3
		dc.b  $F8, $20
byte_6D89A:	dc.b   $C,   2
		dc.b   $D,   2
		dc.b   $E,   2
		dc.b  $FC
byte_6D8A1:	dc.b  $20,   7
		dc.b  $21,   7
		dc.b  $22,   7
		dc.b  $20,   6
		dc.b  $21,   6
		dc.b  $22,   6
		dc.b  $20,   5
		dc.b  $21,   5
		dc.b  $22,   5
		dc.b  $20,   4
		dc.b  $21,   4
		dc.b  $22,   4
		dc.b  $20,   3
		dc.b  $21,   3
		dc.b  $22,   3
		dc.b  $F8, $20
byte_6D8C1:	dc.b  $20,   2
		dc.b  $21,   2
		dc.b  $22,   2
		dc.b  $FC
byte_6D8C8:	dc.b  $14, $7F

		dc.b  $14, $7F
		dc.b  $FC
byte_6D8CD:	dc.b  $13, $7F

		dc.b  $13, $7F
		dc.b  $FC
byte_6D8D2:	dc.b  $26,   2

		dc.b  $27,   2
		dc.b  $28,   2
		dc.b  $FC
byte_6D8D9:	dc.b   $F,   7
		dc.b  $10,   7
		dc.b  $11,   7
		dc.b   $F,   6
		dc.b  $10,   6
		dc.b  $11,   6
		dc.b   $F,   5
		dc.b  $10,   5
		dc.b  $11,   5
		dc.b   $F,   4
		dc.b  $10,   4
		dc.b  $11,   4
		dc.b   $F,   3
		dc.b  $10,   3
		dc.b  $11,   3
		dc.b  $F8, $20
byte_6D8F9:	dc.b   $F,   2
		dc.b  $10,   2
		dc.b  $11,   2
		dc.b  $FC
byte_6D900:	dc.b	9,   3
		dc.b   $A,   3
		dc.b   $B,   3
		dc.b	9,   4
		dc.b   $A,   4
		dc.b   $B,   4
		dc.b	9,   5
		dc.b   $A,   5
		dc.b   $B,   5
		dc.b	9,   6
		dc.b   $A,   6
		dc.b   $B,   6
		dc.b	9,   7
		dc.b   $A,   7
		dc.b   $B,   7
		dc.b  $F4
byte_6D91F:	dc.b   $C,   3
		dc.b   $D,   3
		dc.b   $E,   3
		dc.b   $C,   4
		dc.b   $D,   4
		dc.b   $E,   4
		dc.b   $C,   5
		dc.b   $D,   5
		dc.b   $E,   5
		dc.b   $C,   6
		dc.b   $D,   6
		dc.b   $E,   6
		dc.b   $C,   7
		dc.b   $D,   7
		dc.b   $E,   7
		dc.b  $F4
byte_6D93E:	dc.b  $20,   3
		dc.b  $21,   3
		dc.b  $22,   3
		dc.b  $20,   4
		dc.b  $21,   4
		dc.b  $22,   4
		dc.b  $20,   5
		dc.b  $21,   5
		dc.b  $22,   5
		dc.b  $20,   6
		dc.b  $21,   6
		dc.b  $22,   6
		dc.b  $20,   7
		dc.b  $21,   7
		dc.b  $22,   7
		dc.b  $F4
byte_6D95D:	dc.b   $F,   3
		dc.b  $10,   3
		dc.b  $11,   3
		dc.b   $F,   4
		dc.b  $10,   4
		dc.b  $11,   4
		dc.b   $F,   5
		dc.b  $10,   5
		dc.b  $11,   5
		dc.b   $F,   6
		dc.b  $10,   6
		dc.b  $11,   6
		dc.b   $F,   7
		dc.b  $10,   7
		dc.b  $11,   7
		dc.b  $F4
Pal_MGZEndBoss:	binclude "Levels\MGZ\Palettes\End Boss.bin"


; ---------------------------------------------------------------------------

Obj_CNZMiniboss:
		move.w	#$31E0,d0
		cmp.w	($FFFFEE78).w,d0	; Wait for Player to get in range
		bls.s	loc_6D9A8
		rts
; ---------------------------------------------------------------------------

loc_6D9A8:
		move.w	($FFFFEE16).w,($FFFFFA92).w	; X end to FFFA92
		move.w	#$1C0,($FFFFEE18).w
		move.w	d0,($FFFFEE14).w		; Set X start
		addi.w	#$80,d0
		move.w	d0,($FFFFEE16).w		; Set X end
		move.w	#$2B8,($FFFFEE1A).w
		move.w	#$2B8,($FFFFEE12).w		; Set Y end
		move.l	#Obj_Wait,(a0)
		move.w	#$78,$2E(a0)			; Wait for 2 seconds
		move.l	#Obj_CNZMinibossGo,$34(a0)
		moveq	#-$1F,d0
		jsr	(Play_Sound).l				; Fade out music
		move.b	#1,($FFFFF7AA).w		; Lock screen
		moveq	#$5D,d0
		jsr	(Load_PLC).l					; Load CNZ Miniboss PLC
		lea	Pal_CNZMiniboss(pc),a1		; Load CNZ Miniboss palette
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

Obj_CNZMinibossGo:
		move.l	#Obj_CNZMinibossStart,(a0)
		moveq	#$2E,d0
		jsr	(Play_Sound).l			; Play miniboss music
		move.b	#$2E,($FFFFFF91).w
		jsr	(Create_New_Sprite).l
		bne.s	locret_6DA22
		move.l	#Obj_CNZMinibossScrollControl,(a1)

locret_6DA22:

		rts
; ---------------------------------------------------------------------------

Obj_CNZMinibossStart:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	CNZMiniboss_Index(pc,d0.w),d1
		jsr	CNZMiniboss_Index(pc,d1.w)
		bsr.w	CNZMiniboss_MoveDown
		jsr	(Run_PalRotationScript).l
		bsr.w	CNZMiniboss_CheckPlayerHit
		bsr.w	CNZMiniboss_CheckTopHit
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
CNZMiniboss_Index:	dc.w Obj_CNZMinibossInit-CNZMiniboss_Index

		dc.w Obj_CNZMinibossLower-CNZMiniboss_Index
		dc.w Obj_CNZMinibossMove-CNZMiniboss_Index
		dc.w Obj_CNZMinibossMove-CNZMiniboss_Index
		dc.w Obj_CNZMinibossOpening-CNZMiniboss_Index
		dc.w Obj_CNZMinibossWaitHit-CNZMiniboss_Index
		dc.w Obj_CNZMinibossClosing-CNZMiniboss_Index
		dc.w Obj_CNZMinibossLower2-CNZMiniboss_Index
; ---------------------------------------------------------------------------

Obj_CNZMinibossInit:
		lea	ObjDat_CNZMiniboss(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#6,$29(a0)		; 6 hits (for some reason)
		move.b	#4,$45(a0)
		bset	#3,$38(a0)
		move.w	#$80,$1A(a0)	; Initial vertical speed
		move.w	#$11F,$2E(a0)	; Wait amount
		move.l	#Obj_CNZMinibossGo2,$34(a0)
		lea	Child1_CNZMinibossMakeTop(pc),a2		; Make the little top
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

Obj_CNZMinibossLower:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

Obj_CNZMinibossGo2:
		move.b	#4,5(a0)
		clr.w	$1A(a0)
		bset	#1,$38(a0)
		move.w	#$90,$2E(a0)
		move.l	#Obj_CNZMinibossGo3,$34(a0)
		bra.w	SetUp_CNZMinibossSwing
; ---------------------------------------------------------------------------

Obj_CNZMinibossMove:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

Obj_CNZMinibossGo3:
		move.w	#$100,$18(a0)
		move.w	#$9F,$2E(a0)

Obj_CNZMinibossCloseGo:
		move.b	#6,5(a0)
		move.l	#Obj_CNZMinibossChangeDir,$34(a0)
		bclr	#3,$38(a0)
		lea	(PalSPtr_CNZMinibossNormal).l,a1
		lea	($FFFFFADE).w,a2
		move.l	(a1)+,(a2)+
		move.l	(a1)+,(a2)+
		clr.w	(a2)
		move.l	#CNZMiniboss_MakeTimedSparks,($FFFFFADA).w
		rts
; ---------------------------------------------------------------------------

Obj_CNZMinibossChangeDir:

		neg.w	$18(a0)
		move.w	#$13F,$2E(a0)
		rts
; ---------------------------------------------------------------------------

Obj_CNZMinibossOpening:
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

Obj_CNZMinibossOpenGo:
		move.b	#$A,5(a0)
		move.l	#Obj_CNZMinibossChangeDir,$34(a0)
		bset	#6,$38(a0)		; Set Open state
		move.b	#$7F,$3B(a0)
		lea	Child1_CNZCoilOpenSparks(pc),a2		; Create spark objects for coil
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

Obj_CNZMinibossWaitHit:
		btst	#6,$2A(a0)
		bne.s	loc_6DB4E
		rts
; ---------------------------------------------------------------------------

loc_6DB4E:
		move.b	#$C,5(a0)
		bclr	#6,$38(a0)
		move.l	#AniRaw_CNZMinibossClosing,$30(a0)
		move.l	#Obj_CNZMinibossCloseGo,$34(a0)
		rts
; ---------------------------------------------------------------------------

Obj_CNZMinibossClosing:
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

Obj_CNZMinibossLower2:
		addq.w	#1,$14(a0)
		subq.b	#1,$43(a0)
		bmi.s	loc_6DB7E
		rts
; ---------------------------------------------------------------------------

loc_6DB7E:
		move.b	$42(a0),5(a0)
		rts
; ---------------------------------------------------------------------------

Obj_CNZMinibossEnd:
		move.l	#Obj_Wait,(a0)
		st	($FFFFFAA8).w		; Set end of level flag
		bset	#4,$38(a0)
		move.l	#Obj_CNZMinibossEndGo,$34(a0)
		lea	Child6_CNZMinibossMakeDebris(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

Obj_CNZMinibossEndGo:
		move.l	#Obj_EndSignControlAwaitStart,(a0)
		clr.b	($FFFFF7AA).w	; Unlock level
		jsr	(AfterBoss_Cleanup).l
		lea	(PLC_EndSignStuff).l,a1		; Get ready to start act 2 after sign finishes
		jmp	(Load_PLC_Raw).l
; ---------------------------------------------------------------------------

Obj_CNZMinibossTop:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	CNZMinibossTop_Index(pc,d0.w),d1
		jsr	CNZMinibossTop_Index(pc,d1.w)
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
CNZMinibossTop_Index:	dc.w Obj_CNZMinibossTopInit-CNZMinibossTop_Index
		dc.w Obj_CNZMinibossTopWait-CNZMinibossTop_Index
		dc.w Obj_CNZMinibossTopWait2-CNZMinibossTop_Index
		dc.w Obj_CNZMinibossTopMain-CNZMinibossTop_Index
; ---------------------------------------------------------------------------

Obj_CNZMinibossTopInit:
		lea	ObjDat3_CNZMinibossTop(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.b	#$10,$1F(a0)
		move.b	#8,$1E(a0)
		rts
; ---------------------------------------------------------------------------

Obj_CNZMinibossTopWait:
		movea.w	$46(a0),a1

loc_6DC02:
		btst	#1,$38(a1)
		bne.s	loc_6DC10		; Wait for signal from main boss
		jmp	(Refresh_ChildPosition).l
; ---------------------------------------------------------------------------

loc_6DC10:
		move.b	#4,5(a0)
		move.l	#AniRaw_CNZMinibossTop,$30(a0)
		move.l	#Obj_CNZMinibossTopGo,$34(a0)
		rts
; ---------------------------------------------------------------------------

Obj_CNZMinibossTopWait2:
		jsr	(Refresh_ChildPosition).l
		jmp	(Animate_RawGetFaster).l
; ---------------------------------------------------------------------------

Obj_CNZMinibossTopGo:
		move.b	#6,5(a0)
		move.l	#AniRaw_CNZMinibossTop2,$30(a0)
		move.w	#$200,$18(a0)
		move.w	#$200,$1A(a0)		; Set initial speed of top
		rts
; ---------------------------------------------------------------------------

Obj_CNZMinibossTopMain:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.w	loc_6DDD2			; If parent has been destroyed, destroy this object
		move.w	$10(a0),-(sp)
		jsr	(MoveSprite2).l
		moveq	#$13,d1
		moveq	#$C,d2
		moveq	#8,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectFull).l
		jsr	(Animate_Raw).l
		tst.w	$18(a0)
		bmi.s	loc_6DCB0
		moveq	#$10,d3		; If moving to the right
		jsr	(ObjHitWall).l
		tst.w	d1
		bmi.w	loc_6DD4C	; Reverse direction if block is hit from side
		move.w	$10(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$3380,d0
		bcc.w	loc_6DD8E	; Reverse direction if edge of screen is hit
		move.w	$14(a0),d1
		bsr.w	CNZMinibossTop_CheckHitBase
		bne.w	loc_6DD8E	; Reverse direction if miniboss base was hit
		bra.w	loc_6DCDA
; ---------------------------------------------------------------------------

loc_6DCB0:
		moveq	#-$10,d3	; If moving to the left
		jsr	(ObjHitWall2).l
		tst.w	d1
		bmi.w	loc_6DD4C	; Reverse direction if wall was hit
		move.w	$10(a0),d0
		subi.w	#$10,d0
		cmpi.w	#$3200,d0
		bcs.w	loc_6DD8E	; Reverse direction if edge of screen is hit
		move.w	$14(a0),d1
		bsr.w	CNZMinibossTop_CheckHitBase
		bne.w	loc_6DD8E	; Reverse direction if miniboss base was hit

loc_6DCDA:
		bsr.w	CNZMinibossTop_CheckPlayerBounce
		bne.w	loc_6DDCC	; If bounce was detected, reverse direction
		tst.w	$1A(a0)
		bmi.s	loc_6DD1E
		jsr	(ObjHitFloor).l		; If moving downward, check for hitting the blocks
		tst.w	d1
		bmi.w	loc_6DD94	; If hit, reverse direction
		move.w	$10(a0),d0
		move.w	$14(a0),d1
		addq.w	#8,d1
		move.w	($FFFFEE7C).w,d2
		addi.w	#$E0,d2
		cmp.w	d2,d1
		bcc.w	loc_6DDCC	; If bottom of screen was hit, bounce
		cmpi.w	#$380,d1
		bhi.w	loc_6DDCC	; Maximum lower bound is $380
		bsr.w	CNZMinibossTop_CheckHitBase
		bne.w	loc_6DDCC	; If base was hit, bounce
		rts
; ---------------------------------------------------------------------------

loc_6DD1E:
		jsr	(ObjHitCeiling).l	; If moving upward, check for hitting the blocks from below
		tst.w	d1
		bmi.s	loc_6DD94	; If hit, reverse direction
		move.w	$10(a0),d0
		move.w	$14(a0),d1
		subq.w	#8,d1
		cmp.w	($FFFFEE7C).w,d1
		bls.w	loc_6DDCC	; If top of screen was hit, bounce
		cmpi.w	#$240,d1
		bls.w	loc_6DDCC	; Maximum upper bound is $240
		bsr.w	CNZMinibossTop_CheckHitBase
		bne.w	loc_6DDCC	; If base was hit, bounce
		rts
; ---------------------------------------------------------------------------

loc_6DD4C:

		lea	Child1_CNZBounceEffect(pc),a2
		jsr	(CreateChild1_Normal).l
		bne.s	loc_6DD64
		tst.w	$18(a0)
		bmi.s	loc_6DD64
		bset	#0,4(a1)

loc_6DD64:

		moveq	#$10,d0
		neg.w	$18(a0)		; Change direction
		bmi.s	loc_6DD6E
		neg.w	d0

loc_6DD6E:
		add.w	$10(a0),d0
		cmpi.w	#$3200,d0
		bls.s	locret_6DD8C
		cmpi.w	#$3380,d0
		bcc.s	locret_6DD8C	; If the walls were hit somehow, don't do anything
		move.w	d0,($FFFFEED2).w
		move.w	$14(a0),($FFFFEED4).w	; Move X/Y positions into special variables for removing the blocks from the level layout
		bsr.w	CNZMiniboss_BlockExplosion

locret_6DD8C:

		rts
; ---------------------------------------------------------------------------

loc_6DD8E:

		neg.w	$18(a0)			; Simple direction switch
		rts
; ---------------------------------------------------------------------------

loc_6DD94:

		move.w	$10(a0),d0
		moveq	#8,d1
		neg.w	$1A(a0)
		bmi.s	loc_6DDA2
		neg.w	d1

loc_6DDA2:
		add.w	$14(a0),d1
		cmpi.w	#$3200,d0
		bls.s	locret_6DD8C
		cmpi.w	#$3380,d0
		bcc.s	locret_6DD8C
		cmpi.w	#$300,d1
		bcs.s	locret_6DD8C
		cmpi.w	#$3380,d1
		bcc.s	locret_6DD8C
		move.w	d0,($FFFFEED2).w		; Move X/Y positions into special variables see above
		move.w	d1,($FFFFEED4).w
		bsr.w	CNZMiniboss_BlockExplosion
		rts
; ---------------------------------------------------------------------------

loc_6DDCC:

		neg.w	$1A(a0)			; Simple direction switch
		rts
; ---------------------------------------------------------------------------

loc_6DDD2:
		lea	Child1_CNZMinibossExplosion(pc),a2
		jsr	(CreateChild1_Normal).l
		move.b	#6,$2C(a1)
		clr.b	$28(a0)
		jsr	(Displace_PlayerOffObject).l
		jmp	(Go_Delete_Sprite).l

; =============== S U B R O U T I N E =======================================


CNZMiniboss_BlockExplosion:

		lea	Child1_CNZMinibossExplosion(pc),a2
		jsr	(CreateChild1_Normal).l
		bne.s	locret_6DE24
		move.b	#6,$2C(a1)
		move.w	($FFFFEED2).w,d0
		andi.w	#-$20,d0
		addi.w	#$10,d0
		move.w	d0,$10(a1)
		move.w	($FFFFEED4).w,d0
		andi.w	#-$20,d0
		addi.w	#$10,d0
		move.w	d0,$14(a1)

locret_6DE24:
		rts
; End of function CNZMiniboss_BlockExplosion

; ---------------------------------------------------------------------------

Obj_CNZMinibossCoil:

		move.l	#Obj_CNZMinibossCoilClose,(a0)
		move.b	#$1A,$28(a0)
		move.b	#$70,$29(a0)
		bclr	#2,$38(a0)
		rts
; ---------------------------------------------------------------------------

Obj_CNZMinibossCoilClose:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_6DEB6
		btst	#6,$38(a1)
		bne.s	loc_6DEA8
		jsr	(Refresh_ChildPosition).l		; If base is not open
		movea.w	$46(a0),a1
		tst.b	$28(a0)
		bne.s	loc_6DE9C		; Skip if collision is set
		bset	#2,$38(a0)
		bne.s	loc_6DE88		; If $38 already set, branch
		move.b	#$10,$3A(a0)
		btst	#2,$38(a1)
		bne.s	loc_6DE88		; If base has been stunned already, branch
		move.b	$28(a1),$25(a1)	; Backup parent collision
		clr.b	$28(a1)			; Unset parent collision
		subq.b	#1,$29(a1)		; Remove a hit

loc_6DE88:

		subq.b	#1,$3A(a0)
		bpl.w	locret_6DA22
		bclr	#2,$38(a0)
		move.b	$25(a0),$28(a0)	; Restore collision

loc_6DE9C:
		move.b	#$70,$29(a0)
		jmp	(Add_SpriteToCollisionResponseList).l
; ---------------------------------------------------------------------------

loc_6DEA8:
		move.l	#Obj_CNZMinibossCoilOpen,(a0)
		move.b	#$A9,$28(a0)
		rts
; ---------------------------------------------------------------------------

loc_6DEB6:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_CNZMinibossCoilOpen:
		jsr	(Refresh_ChildPosition).l
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_6DEB6
		btst	#6,$38(a1)
		beq.w	Obj_CNZMinibossCoil		; If parent closes up
		jmp	(Add_SpriteToCollisionResponseList).l
; ---------------------------------------------------------------------------

loc_6DEDE:
		move.l	#loc_6DEEC,(a0)
		move.b	#-$56,$28(a0)
		rts
; ---------------------------------------------------------------------------

loc_6DEEC:
		jsr	(Refresh_ChildPosition).l
		jmp	(Add_SpriteToCollisionResponseList).l
; ---------------------------------------------------------------------------

Obj_CNZMinibossTimedSparks:
		lea	ObjDat3_CNZMinibossSpark(pc),a1		;Temporary sparks when boss is closed
		jsr	(SetUp_ObjAttributes3).l
		bset	#5,$2B(a0)
		move.l	#Obj_Wait,(a0)
		move.l	#Obj_CNZMinibossTimedSparksGo,$34(a0)
		move.l	#AniRaw_CNZMinibossTimedSparkLeft,$30(a0)
		tst.b	$2C(a0)
		beq.s	locret_6DF32
		move.l	#AniRaw_CNZMinibossTimedSparkRight,$30(a0)
		move.w	#2,$2E(a0)

locret_6DF32:
		rts
; ---------------------------------------------------------------------------

Obj_CNZMinibossTimedSparksGo:
		move.l	#Obj_CNZMinibossTimedSparksMain,(a0)
		move.w	#$7F,$2E(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		rts
; ---------------------------------------------------------------------------

Obj_CNZMinibossTimedSparksMain:
		jsr	(Refresh_ChildPosition).l
		jsr	(Animate_RawMultiDelay).l
		jsr	(Obj_Wait).l
		jmp	(Child_DrawTouch_Sprite).l
; ---------------------------------------------------------------------------

Obj_CNZMinibossSparks:

		lea	ObjDat3_CNZMinibossSpark(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		bset	#5,$2B(a0)			; Player isn't hurt with lightning shield
		move.l	#Obj_CNZMinibossSparksMain,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		move.l	off_6DF88(pc,d0.w),$30(a0)
		rts
; ---------------------------------------------------------------------------
off_6DF88:	dc.l AniRaw_CNZMinibossSparks1
		dc.l AniRaw_CNZMinibossSparks2
		dc.l AniRaw_CNZMinibossSparks3
; ---------------------------------------------------------------------------

Obj_CNZMinibossSparksMain:
		movea.w	$46(a0),a1
		btst	#6,$38(a1)
		beq.w	loc_6DEB6
		jsr	(Refresh_ChildPosition).l
		jsr	(Animate_RawMultiDelay).l
		jmp	(Child_DrawTouch_Sprite).l
; ---------------------------------------------------------------------------

Obj_CNZMinibossBounceEffect:
		lea	ObjDat3_CNZMbossBounceEffect(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		bset	#5,$2B(a0)
		move.l	#AnimateRaw_DrawTouch,(a0)
		move.w	#$3208,$10(a0)
		btst	#0,4(a0)
		beq.s	loc_6DFDE
		move.w	#$3378,$10(a0)

loc_6DFDE:
		move.l	#AniRaw_CNZMBossBoundEffect,$30(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		rts
; ---------------------------------------------------------------------------

Obj_CNZMinibossDebris:
		lea	ObjDat_CNZMinibossDebris(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#Obj_FlickerMove,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_6E022(pc,d0.w),$42(a0)
		lsr.w	#1,d0
		move.b	CNZMinibossDebris_Frames(pc,d0.w),$22(a0)
		jsr	(Refresh_ChildPosition).l
		moveq	#0,d0
		jmp	(Set_IndexedVelocity).l
; ---------------------------------------------------------------------------
word_6E022:	dc.w $F000
		dc.w $1000
		dc.w $14
		dc.w $1C
		dc.w $24
		dc.w $2C
		dc.w $34
		dc.w $3C
		dc.w $48
CNZMinibossDebris_Frames:	dc.b  $12, $13,	$14, $14, $14, $14, $14, $14, $15,   0
; ---------------------------------------------------------------------------

SetUp_CNZMinibossSwing:
		move.w	#$60,d0
		move.w	d0,$3E(a0)
		move.w	d0,$1A(a0)
		move.w	#8,$40(a0)
		bclr	#0,$38(a0)
		rts

; =============== S U B R O U T I N E =======================================


CNZMiniboss_CheckPlayerHit:
		tst.b	$28(a0)
		bne.s	locret_6E0AE
		bset	#2,$38(a0)		; If boss was hit by Sonic, set flag
		bne.s	loc_6E09C		; If already set earlier, skip ahead
		addq.b	#1,$29(a0)		; Don't allow hit to affect him
		move.b	#$10,$3A(a0)
		bset	#3,$38(a0)
		bne.s	loc_6E09C
		move.b	#8,5(a0)
		move.l	#AniRaw_CNZMinibossOpening,$30(a0)
		move.l	#Obj_CNZMinibossOpenGo,$34(a0)		; Set boss to opening animation/routine
		lea	(PalSPtr_CNZMinibossOpen).l,a1
		lea	($FFFFFADE).w,a2		; Reset pal script
		move.l	(a1)+,(a2)+
		move.l	(a1)+,(a2)+

loc_6E09C:

		subq.b	#1,$3A(a0)
		bpl.s	locret_6E0AE
		bclr	#2,$38(a0)
		move.b	$25(a0),$28(a0)		; Restore collision after 16 frames at most while opening

locret_6E0AE:

		rts
; End of function CNZMiniboss_CheckPlayerHit


; =============== S U B R O U T I N E =======================================


CNZMiniboss_CheckTopHit:
		tst.b	$44(a0)
		beq.s	locret_6E0F8		; If not hit by top, don't bother
		tst.b	$20(a0)
		bne.s	loc_6E0D6
		subq.b	#1,$45(a0)			; Subtract 1 from ACTUAL hit count
		beq.s	CNZMiniboss_BossDefeated
		bset	#6,$2A(a0)			; Set to indicate in hit stun
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l		; Play hit sound

loc_6E0D6:
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_6E0E4
		addi.w	#$A,d0

loc_6E0E4:
		bsr.w	CNZMiniboss_BossFlash	; Do the boss flash
		subq.b	#1,$20(a0)
		bne.s	locret_6E0F8
		bclr	#6,$2A(a0)
		clr.b	$44(a0)

locret_6E0F8:

		rts
; ---------------------------------------------------------------------------

CNZMiniboss_BossDefeated:
		move.l	#Wait_FadeToLevelMusic,(a0)
		bset	#7,$2A(a0)				; Boss has been annihilated!
		move.l	#Obj_CNZMinibossEnd,$34(a0)
		move.w	#$20,($FFFFFC34).w		; Set palette properly
		st	($FFFFEEC6).w				; Signal BG event
		lea	Child1_CNZMinibossExplosion(pc),a2
		jsr	(CreateChild1_Normal).l
		jmp	(BossDefeated_StopTimer).l
; End of function CNZMiniboss_CheckTopHit


; =============== S U B R O U T I N E =======================================


CNZMiniboss_BossFlash:
		lea	word_6E146(pc),a1
		lea	word_6E150(pc,d0.w),a2
		movea.w	(a1)+,a3
		move.w	(a2)+,(a3)+
		movea.w	(a1)+,a3
		move.w	(a2)+,(a3)+
		movea.w	(a1)+,a3
		move.w	(a2)+,(a3)+
		movea.w	(a1)+,a3
		move.w	(a2)+,(a3)+
		movea.w	(a1)+,a3
		move.w	(a2)+,(a3)+
		rts
; End of function CNZMiniboss_BossFlash

; ---------------------------------------------------------------------------
word_6E146:	dc.w $FC24
		dc.w $FC26
		dc.w $FC28
		dc.w $FC2E
		dc.w $FC3C
word_6E150:	dc.w $6E0
		dc.w $280
		dc.w $40
		dc.w $28
		dc.w $642
		dc.w $888
		dc.w $AAA
		dc.w $CCC
		dc.w $888
		dc.w $AAA
; ---------------------------------------------------------------------------

CNZMiniboss_MakeTimedSparks:
		lea	(PalSPtr_CNZMinibossSparks).l,a2
		move.l	(a2)+,(a1)+
		move.l	(a2)+,(a1)+
		lea	Child1_CNZMinibossTimedSparks(pc),a2
		jmp	(CreateChild1_Normal).l

; =============== S U B R O U T I N E =======================================


CNZMiniboss_MoveDown:
		move.w	($FFFFEED6).w,d0
		cmp.w	$3C(a0),d0
		beq.s	locret_6E198
		move.w	d0,$3C(a0)
		move.b	5(a0),$42(a0)
		move.b	#$E,5(a0)
		move.b	#$1F,$43(a0)

locret_6E198:
		rts
; End of function CNZMiniboss_MoveDown


; =============== S U B R O U T I N E =======================================


CNZMinibossTop_CheckPlayerBounce:
		lea	($FFFFB000).w,a1
		bsr.w	sub_6E1A8
		bne.s	locret_6E20E
		lea	($FFFFB04A).w,a1
; End of function CNZMinibossTop_CheckPlayerBounce


; =============== S U B R O U T I N E =======================================


sub_6E1A8:
		tst.w	$1A(a1)
		bpl.s	loc_6E210		; If player is moving downward, don't bother
		cmpi.b	#2,$20(a1)
		bne.s	loc_6E210		; If player is not in rolling animation, don't bother
		move.w	$10(a0),d0
		move.w	$14(a0),d1
		addi.w	#$C,d1
		move.w	$10(a1),d2
		subi.w	#$10,d2
		cmp.w	d2,d0
		bcs.s	loc_6E210		; If player is not within X range, don't bother
		addi.w	#$20,d2
		cmp.w	d2,d0
		bcc.s	loc_6E210		; See above
		move.w	$14(a1),d2
		subi.w	#$10,d2
		cmp.w	d2,d1
		bcs.s	loc_6E210		; If player is not within Y range, don't bother
		addi.w	#$20,d2
		cmp.w	d2,d1
		bcc.s	loc_6E210		; See above
		tst.w	$18(a1)
		bmi.s	loc_6E1FA
		tst.w	$18(a0)
		bpl.s	loc_6E204		; If player and top are moving the same direction, don't need to reverse X direction
		bra.w	loc_6E200
; ---------------------------------------------------------------------------

loc_6E1FA:
		tst.w	$18(a0)
		bmi.s	loc_6E204		; If player and top are moving the same direction, don't need to reverse X direction

loc_6E200:
		neg.w	$18(a0)			; If moving in opposite directions, reverse

loc_6E204:

		tst.w	$1A(a0)
		bmi.w	loc_6E210
		moveq	#1,d0			; If top is moving downward on collision, set collision flag

locret_6E20E:
		rts
; ---------------------------------------------------------------------------

loc_6E210:
		moveq	#0,d0
		rts
; End of function sub_6E1A8


; =============== S U B R O U T I N E =======================================


CNZMinibossTop_CheckHitBase:

		movea.w	$46(a0),a1
		lea	CNZMiniboss_BaseRange(pc),a2		; Two hit boxes. First is the slightly wider base
		move.w	$10(a1),d2
		add.w	(a2)+,d2
		cmp.w	d2,d0
		bcs.s	loc_6E23C
		add.w	(a2)+,d2
		cmp.w	d2,d0
		bcc.s	loc_6E23C
		move.w	$14(a1),d2
		add.w	(a2)+,d2
		cmp.w	d2,d1
		bcs.s	loc_6E23C
		add.w	(a2)+,d2
		cmp.w	d2,d1
		bcs.s	loc_6E270

loc_6E23C:

		lea	CNZMiniboss_CoilRange(pc),a2		; Then it's the coil, different ranges depending on open or close state
		btst	#6,$38(a1)
		beq.s	loc_6E24C
		lea	CNZMiniboss_CoilOpenRange(pc),a2

loc_6E24C:
		move.w	$10(a1),d2
		add.w	(a2)+,d2
		cmp.w	d2,d0
		bcs.s	loc_6E26C
		add.w	(a2)+,d2
		cmp.w	d2,d0
		bcc.s	loc_6E26C
		move.w	$14(a1),d2
		add.w	(a2)+,d2
		cmp.w	d2,d1
		bcs.s	loc_6E26C
		add.w	(a2)+,d2
		cmp.w	d2,d1
		bcs.s	loc_6E270

loc_6E26C:

		moveq	#0,d2
		rts
; ---------------------------------------------------------------------------

loc_6E270:

		btst	#6,$38(a1)
		beq.s	loc_6E27C
		st	$44(a1)				; Only set hit state if coil was open to begin with

loc_6E27C:
		moveq	#1,d2
		rts
; End of function CNZMinibossTop_CheckHitBase

; ---------------------------------------------------------------------------
CNZMiniboss_BaseRange:	dc.w  $FFE8,   $30
		dc.w  $FFF0,   $20
CNZMiniboss_CoilRange:	dc.w  $FFF4,   $18
		dc.w	$10,   $18
CNZMiniboss_CoilOpenRange:	dc.w  $FFF4,   $18
		dc.w	$10,   $38
ObjDat_CNZMiniboss:	dc.l Map_CNZMiniboss
		dc.w $A52E
		dc.w $280
		dc.b $18
		dc.b $30
		dc.b 0
		dc.b $C
ObjDat3_CNZMinibossTop:	dc.w $200
		dc.b $18
		dc.b $10
		dc.b 7
		dc.b $AA
ObjDat3_CNZMinibossSpark:	dc.w $200

		dc.b $C
		dc.b $18
		dc.b $A
		dc.b $92
ObjDat3_CNZMbossBounceEffect:	dc.w $100
		dc.b 8
		dc.b 8
		dc.b $C
		dc.b 0
ObjDat_CNZMinibossDebris:	dc.l Map_CNZMiniboss
		dc.w $A52E
		dc.w $100
		dc.b $10
		dc.b $10
		dc.b 0
		dc.b 0
Child1_CNZMinibossMakeTop:dc.w 1
		dc.l Obj_CNZMinibossTop
		dc.w $2C
		dc.l Obj_CNZMinibossCoil
		dc.w $1C
Child1_CNZMinibossTimedSparks:dc.w 1
		dc.l Obj_CNZMinibossTimedSparks
		dc.w $EC18
		dc.l Obj_CNZMinibossTimedSparks
		dc.w $1418
		dc.w 0
		dc.l loc_6DEDE
		dc.w $FC
Child1_CNZCoilOpenSparks:dc.w 2
		dc.l Obj_CNZMinibossSparks
		dc.w $FC28
		dc.l Obj_CNZMinibossSparks
		dc.w $42C
		dc.l Obj_CNZMinibossSparks
		dc.w $FC3C
Child1_CNZBounceEffect:dc.w 0
		dc.l Obj_CNZMinibossBounceEffect
		dc.w $FC
Child1_CNZMinibossExplosion:dc.w 0
		dc.l Obj_CreateBossExplosion
		dc.w 0
Child6_CNZMinibossMakeDebris:dc.w 8
		dc.l Obj_CNZMinibossDebris
AniRaw_CNZMinibossOpening:	dc.b	0,   3
		dc.b	1,   3
		dc.b	2,   3
		dc.b	3,   3
		dc.b	4,   3
		dc.b	5,   3
		dc.b	6,   3
		dc.b  $F4
AniRaw_CNZMinibossClosing:	dc.b	6,   3
		dc.b	5,   3
		dc.b	4,   3
		dc.b	3,   3
		dc.b	2,   3
		dc.b	1,   3
		dc.b	0,   3
		dc.b  $F4
AniRaw_CNZMinibossTop:	dc.b	7,   8,  7,   8,  9, $FC

AniRaw_CNZMinibossTop2:	dc.b	0,   7,  8,   9,  $FC

AniRaw_CNZMinibossTimedSparkLeft:	dc.b   $A,   0
		dc.b  $11,   2
		dc.b   $B,   0
		dc.b  $11,   2
		dc.b  $FC
AniRaw_CNZMinibossTimedSparkRight:	dc.b   $F,   0
		dc.b  $11,   2
		dc.b  $10,   0
		dc.b  $11,   2
		dc.b  $FC
AniRaw_CNZMinibossSparks1:	dc.b   $A,   0
		dc.b  $11,   7
		dc.b   $B,   0
		dc.b  $11,   7
		dc.b  $FC
AniRaw_CNZMinibossSparks2:	dc.b  $11,   0
		dc.b   $F,   0
		dc.b  $11,   7
		dc.b  $10,   0
		dc.b  $11,   9
		dc.b  $FC
AniRaw_CNZMinibossSparks3:	dc.b   $A,   0
		dc.b  $11,   7
		dc.b   $B,   0
		dc.b  $11,  $B
		dc.b  $FC
AniRaw_CNZMBossBoundEffect:	dc.b   $C,   0,   $D,   1,   $E,   1,   $F4,   0

Pal_CNZMiniboss:	binclude "Levels\CNZ\Palettes\Miniboss.bin"


PalSPtr_CNZMinibossNormal:	dc.w 4
		dc.w 0
		dc.l PalScript_CNZMinibossNormal
		dc.w 0
PalScript_CNZMinibossNormal:	dc.w $FC34
		dc.w	  2,  $EEE,	0,  $A22,     0,   $20,	    5, $FFF8,	$14, $FC34,	2,  $EEE,     0,  $A22,	    0,	 $20
		dc.w	  3, $FFF8,   $14, $FC34,     2,  $EEE,	    0,	$A22,	  0,   $20,	1, $FFF8,   $14, $FC34,	   $A,	$EEE
		dc.w	  0,  $A22,	0,   $20,     0, $FFF4

PalSPtr_CNZMinibossSparks:	dc.w 4
		dc.w 0
		dc.l PalScript_CNZMinibossSparks
		dc.w 0
PalScript_CNZMinibossSparks:	dc.w $FC34
word_6E3F4:	dc.w	$30,  $EEE,	0,  $A22,     0,   $20,	    0, $FFF8,	$14, $FC34,	2,  $EEE,     0,  $A22,	    0,	 $20
		dc.w	  1, $FFF8,   $14, $FC34,     3,  $EEE,	    0,	$A22,	  0,   $20,	3, $FFF8,   $14, $FC34,	    1,	 $20
		dc.w	$5F, $FFF8, $FF94

PalSPtr_CNZMinibossOpen:	dc.w 4
		dc.w 0
		dc.l PalScript_CNZMinibossOpen
		dc.w 0
PalScript_CNZMinibossOpen:	dc.w $FC34
		dc.w	  0,  $EEE,	0,  $A22,     0,   $20,	    1,	$EEE,	  0,  $A22,	0,   $20,     7,  $EEE,	    0,	$A22
		dc.w	  0,   $20,	2, $FFFC
; ---------------------------------------------------------------------------
word_6E46E:	dc.w	  0,  $300
		dc.w  $4660, $4860
word_6E476:	dc.w   $240,  $240
		dc.w  $4760, $47E0
; ---------------------------------------------------------------------------

Obj_CNZEndBoss:
		lea	word_6E46E(pc),a1
		jsr	(Check_CameraInRange).l
		move.l	#loc_6E4B8,(a0)
		move.l	#loc_6E4BE,$34(a0)
		lea	word_6E476(pc),a1
		move.b	#$19,$26(a0)
		jsr	(sub_85D6A).l
		moveq	#$6E,d0
		jsr	(Load_PLC).l
		lea	Pal_CNZEndBoss(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_6E4B8:
		jmp	(loc_85CA4).l
; ---------------------------------------------------------------------------

loc_6E4BE:
		move.l	#loc_6E4C6,(a0)

locret_6E4C4:

		rts
; ---------------------------------------------------------------------------

loc_6E4C6:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6E4E2(pc,d0.w),d1
		jsr	off_6E4E2(pc,d1.w)
		bsr.w	sub_6EC3A
		bsr.w	sub_6EC9E
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_6E4E2:	dc.w loc_6E4F2-off_6E4E2

		dc.w loc_6E548-off_6E4E2
		dc.w loc_6E574-off_6E4E2
		dc.w loc_6E5B6-off_6E4E2
		dc.w loc_6E5D8-off_6E4E2
		dc.w loc_6E62C-off_6E4E2
		dc.w loc_6E680-off_6E4E2
		dc.w loc_6E6AA-off_6E4E2
; ---------------------------------------------------------------------------

loc_6E4F2:
		lea	ObjDat3_6ED84(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#8,$29(a0)

loc_6E502:
		move.w	$14(a0),$3A(a0)
		move.w	#$7F,$2E(a0)
		move.l	#loc_6E55E,$34(a0)
		move.w	#-$100,$18(a0)
		jsr	Swing_Setup1(pc)
		lea	(ChildObjDat_681A4).l,a2
		jsr	(CreateChild1_Normal).l
		bne.s	loc_6E534
		move.b	#9,$2C(a1)

loc_6E534:
		lea	ChildObjDat_6EDCC(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	ChildObjDat_6EDD4(pc),a2
		jmp	(CreateChild3_NormalRepeated).l
; ---------------------------------------------------------------------------

loc_6E548:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6E55A:
		jsr	Swing_Setup1(pc)

loc_6E55E:
		move.b	#4,5(a0)
		move.w	#$B4,$2E(a0)
		move.l	#loc_6E5A4,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6E574:
		jsr	(Find_SonicTails).l
		addi.w	#$10,d2
		cmpi.w	#$20,d2
		bcs.s	loc_6E59E
		move.w	#$100,d1
		bset	#0,4(a0)
		tst.w	d0
		bne.s	loc_6E59A
		neg.w	d1
		bclr	#0,4(a0)

loc_6E59A:
		move.w	d1,$18(a0)

loc_6E59E:
		jmp	(Swing_MoveWaitNoFall).l
; ---------------------------------------------------------------------------

loc_6E5A4:
		move.b	#6,5(a0)
		bset	#1,$38(a0)
		clr.w	$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_6E5B6:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		btst	#1,$38(a0)
		beq.s	loc_6E5CC
		rts
; ---------------------------------------------------------------------------

loc_6E5CC:
		move.b	#8,5(a0)
		clr.w	$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_6E5D8:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		move.w	$10(a0),d0
		movea.w	$44(a0),a1
		cmp.w	$10(a1),d0
		beq.s	loc_6E610
		bhi.s	loc_6E602
		addq.w	#1,d0
		move.w	d0,$10(a0)
		bset	#0,4(a0)
		rts
; ---------------------------------------------------------------------------

loc_6E602:
		subq.w	#1,d0

loc_6E604:
		bclr	#0,4(a0)
		move.w	d0,$10(a0)
		rts
; ---------------------------------------------------------------------------

loc_6E610:
		move.b	#$A,5(a0)
		bset	#3,$38(a0)
		move.w	#$BF,$2E(a0)
		move.l	#loc_6E632,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6E62C:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6E632:
		bset	#2,$38(a0)
		move.w	#$FF,$2E(a0)
		move.l	#loc_6E650,$34(a0)
		lea	ChildObjDat_6EDE4(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6E650:
		bclr	#2,$38(a0)
		bset	#7,$38(a0)
		move.w	#$FF,$2E(a0)
		move.l	#loc_6E66C,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6E66C:
		move.b	#$C,5(a0)
		bclr	#3,$38(a0)
		bclr	#7,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_6E680:
		move.w	$14(a0),d0
		addq.w	#1,d0
		movea.w	$44(a0),a1
		move.w	$14(a1),d1
		subi.w	#$14,d1
		cmp.w	d1,d0
		bcc.s	loc_6E69C
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_6E69C:
		move.b	#$E,5(a0)
		bset	#3,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_6E6AA:
		move.w	$14(a0),d0
		subq.w	#1,d0
		cmp.w	$3A(a0),d0
		bls.s	loc_6E6BC
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_6E6BC:
		move.w	$3A(a0),$14(a0)
		bra.w	loc_6E55A
; ---------------------------------------------------------------------------

loc_6E6C6:
		move.l	#Obj_Wait,(a0)
		bset	#4,$38(a0)
		move.l	#loc_6E6E4,$34(a0)
		lea	ChildObjDat_6EE00(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6E6E4:
		move.l	#loc_6E724,(a0)
		st	($FFFFFAA8).w
		clr.b	($FFFFF7AA).w
		move.w	($FFFFFAB4).w,d0
		addi.w	#$190,d0
		move.w	d0,($FFFFFA92).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_6E718
		move.l	#Obj_81,(a1)
		move.w	#$4990,$10(a1)
		move.w	#$2E0,$14(a1)

loc_6E718:
		lea	(Child6_IncLevX).l,a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_6E724:
		move.w	($FFFFEE78).w,($FFFFEE14).w
		tst.b	($FFFFFAA8).w
		bne.w	locret_6E4C4
		move.l	#loc_6E778,(a0)
		jsr	(Restore_PlayerControl).l
		lea	($FFFFB04A).w,a1
		jsr	(Restore_PlayerControl2).l
		jsr	(Obj_PlayLevelMusic).l
		move.w	#$200,($FFFFFA96).w
		lea	(Child6_DecLevY).l,a2
		jsr	(CreateChild6_Simple).l
		move.w	($FFFFFAB4).w,d0
		addi.w	#$310,d0
		move.w	d0,($FFFFFA92).w
		lea	(Child6_IncLevX).l,a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_6E778:
		cmpi.w	#$4A30,($FFFFB010).w
		bcs.s	locret_6E7B4
		move.l	#loc_6E7B6,(a0)
		lea	(ArtKosM_BadnikExplosion).l,a1
		move.w	#-$4C00,d2
		jsr	(Queue_Kos_Module).l
		jsr	(Create_New_Sprite).l
		bne.s	locret_6E7B4
		move.w	a1,$44(a0)
		move.l	#Obj_CNZCannon,(a1)
		move.w	#$4B20,$10(a1)
		move.w	#$2A8,$14(a1)

locret_6E7B4:

		rts
; ---------------------------------------------------------------------------

loc_6E7B6:
		move.w	($FFFFEE78).w,($FFFFEE14).w
		movea.w	$44(a0),a1
		cmpi.b	#1,$30(a1)
		bne.w	locret_6E4C4
		move.l	#loc_6E7E4,(a0)
		move.w	#$200,d0
		move.w	d0,($FFFFEE12).w
		move.w	#$BF,$2E(a0)
		st	($FFFFF7CA).w
		rts
; ---------------------------------------------------------------------------

loc_6E7E4:
		subq.w	#1,$2E(a0)
		bpl.w	locret_6E4C4
		movea.w	$44(a0),a1
		cmpi.b	#$12,$26(a1)
		bne.w	locret_6E4C4
		move.l	#loc_6E80C,(a0)

loc_6E800:
		move.w	#$7070,($FFFFF602).w
		st	($FFFFF7CA).w
		rts
; ---------------------------------------------------------------------------

loc_6E80C:
		move.w	($FFFFEE7C).w,d0
		addi.w	#$20,d0
		cmp.w	($FFFFB014).w,d0
		bcs.w	locret_6E4C4
		move.w	#$500,d0
		jsr	(StartNewLevel).l
		jmp	(Go_Delete_Sprite_2).l
; ---------------------------------------------------------------------------

loc_6E82C:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6E844(pc,d0.w),d1
		jsr	off_6E844(pc,d1.w)
		bsr.w	sub_6ED22
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_6E844:	dc.w loc_6E850-off_6E844

		dc.w loc_6E86A-off_6E844
		dc.w loc_6E8A2-off_6E844
		dc.w loc_6E8E8-off_6E844
		dc.w loc_6E8FE-off_6E844
		dc.w loc_6E920-off_6E844
; ---------------------------------------------------------------------------

loc_6E850:
		lea	ObjDat3_6ED9C(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#$10,$1E(a0)
		move.l	#byte_6EE1D,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_6E86A:
		jsr	(Refresh_ChildPositionAdjusted).l
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		bne.s	loc_6E87E
		rts
; ---------------------------------------------------------------------------

loc_6E87E:
		move.b	#4,5(a0)
		move.l	#loc_6E8B6,$34(a0)
		jsr	(Find_SonicTails).l
		move.w	#$100,d1
		tst.w	d0
		bne.s	loc_6E89C
		neg.w	d1

loc_6E89C:
		move.w	d1,$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_6E8A2:
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.w	locret_6E4C4
		jmp	(ObjHitFloor_DoRoutine).l
; ---------------------------------------------------------------------------

loc_6E8B6:
		moveq	#$5D,d0
		jsr	(Play_Sound_2).l
		move.w	$1A(a0),d0
		cmpi.w	#$80,d0
		bcs.s	loc_6E8D2
		asr.w	#1,d0
		neg.w	d0
		move.w	d0,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_6E8D2:
		move.b	#6,5(a0)
		movea.w	$46(a0),a1
		move.w	a0,$44(a1)
		bclr	#1,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_6E8E8:
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		bne.s	loc_6E8F6
		rts
; ---------------------------------------------------------------------------

loc_6E8F6:
		move.b	#8,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_6E8FE:
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		beq.s	loc_6E910
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_6E910:
		move.b	#$A,5(a0)
		move.b	#4,$22(a0)
		bra.w	loc_6EAD0
; ---------------------------------------------------------------------------

loc_6E920:
		movea.w	$46(a0),a1
		bclr	#3,$38(a1)
		bne.s	loc_6E92E
		rts
; ---------------------------------------------------------------------------

loc_6E92E:
		move.b	#2,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_6E936:

		lea	word_6EDA8(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#Obj_FlickerMove,(a0)
		tst.b	$2C(a0)
		beq.s	loc_6E952
		bset	#0,4(a0)

loc_6E952:
		moveq	#8,d0
		jmp	(Set_IndexedVelocity).l
; ---------------------------------------------------------------------------

loc_6E95A:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6E986(pc,d0.w),d1
		jsr	off_6E986(pc,d1.w)
		lea	(CNZEndBossMagnet_AngleX).l,a1
		jsr	(MoveSprite_AngleXLookupOffset).l
		bsr.w	sub_6EBD8
		bsr.w	sub_6EBF0
		bsr.w	sub_6ED4C
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_6E986:	dc.w loc_6E994-off_6E986

		dc.w loc_6E9B2-off_6E986
		dc.w loc_6E9E2-off_6E986
		dc.w loc_6EA26-off_6E986
		dc.w loc_6EA5C-off_6E986
		dc.w loc_6EA92-off_6E986
		dc.w loc_6EAB2-off_6E986
; ---------------------------------------------------------------------------

loc_6E994:
		lea	ObjDat3_6EDB4(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	$2C(a0),d0
		lsl.b	#5,d0
		move.b	d0,$3C(a0)
		move.l	#byte_6EE0E,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_6E9B2:
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		bne.s	loc_6E9C0
		rts
; ---------------------------------------------------------------------------

loc_6E9C0:
		move.b	#4,5(a0)
		move.b	#1,$40(a0)
		move.w	#$40,$2E(a0)
		move.l	#loc_6EA1A,$34(a0)
		move.b	$3C(a0),$3A(a0)
		rts
; ---------------------------------------------------------------------------

loc_6E9E2:
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		bne.s	loc_6EA02
		move.b	$40(a0),d0
		add.b	d0,$3C(a0)
		jsr	(Animate_RawMultiDelay).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6EA02:
		move.b	#6,5(a0)
		lea	ChildObjDat_6EDDC(pc),a2
		jsr	(CreateChild1_Normal).l
		move.b	$2C(a0),$2C(a1)
		rts
; ---------------------------------------------------------------------------

loc_6EA1A:
		addq.b	#1,$40(a0)
		move.w	#$40,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_6EA26:
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		beq.s	loc_6EA40
		move.b	$40(a0),d0
		add.b	d0,$3C(a0)
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_6EA40:
		move.b	#8,5(a0)
		bset	#7,$38(a0)
		move.w	#$40,$2E(a0)
		move.l	#loc_6EA70,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6EA5C:
		move.b	$40(a0),d0
		add.b	d0,$3C(a0)
		jsr	(Animate_RawMultiDelay).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6EA70:
		cmpi.b	#1,$40(a0)
		beq.s	loc_6EA84
		subq.b	#1,$40(a0)
		move.w	#$40,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_6EA84:
		move.b	#$A,5(a0)
		bclr	#7,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_6EA92:
		jsr	(Animate_RawMultiDelay).l
		move.b	$3C(a0),d0
		addq.b	#1,d0
		move.b	d0,$3C(a0)
		cmp.b	$3A(a0),d0
		beq.s	loc_6EAAA
		rts
; ---------------------------------------------------------------------------

loc_6EAAA:
		move.b	#$C,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_6EAB2:
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		beq.s	loc_6EAC4
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_6EAC4:
		move.b	#2,5(a0)
		move.b	#1,$22(a0)

loc_6EAD0:
		clr.b	$24(a0)
		clr.b	$23(a0)
		rts
; ---------------------------------------------------------------------------

loc_6EADA:

		lea	ObjDat3_6EDC0(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bset	#5,$2B(a0)
		move.l	#byte_6EE2C,$30(a0)
		move.l	#loc_6EB34,$34(a0)
		btst	#1,$2C(a0)
		beq.s	loc_6EB0C
		move.l	#loc_6EB0C,(a0)
		bra.w	sub_6EC1E
; ---------------------------------------------------------------------------

loc_6EB0C:

		move.l	#loc_6EB16,(a0)
		bra.w	sub_6EC1E
; ---------------------------------------------------------------------------

loc_6EB16:
		moveq	#$78,d0
		jsr	(sub_85E52).l
		jsr	(Refresh_ChildPosition).l
		jsr	(Animate_Raw).l
		bsr.w	sub_6EC1E
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_6EB34:

		move.b	#9,$22(a0)
		move.b	$39(a0),d0
		addq.b	#1,d0
		move.b	d0,$39(a0)
		andi.b	#3,d0
		andi.b	#-4,4(a0)
		or.b	d0,4(a0)
		rts
; ---------------------------------------------------------------------------
		lea	ObjDat3_6EDC0(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bset	#5,$2B(a0)
		move.l	#loc_6EB34,$34(a0)
		move.b	$2C(a0),d0
		beq.s	loc_6EB84
		move.l	#byte_6EE3B,$30(a0)
		move.l	#loc_6EB8C,(a0)
		bra.w	sub_6EC1E
; ---------------------------------------------------------------------------

loc_6EB84:
		move.l	#byte_6EE32,$30(a0)

loc_6EB8C:
		move.l	#loc_6EB96,(a0)
		bra.w	sub_6EC1E
; ---------------------------------------------------------------------------

loc_6EB96:
		jsr	(Refresh_ChildPosition).l
		jsr	(Animate_RawMultiDelay).l
		bsr.w	sub_6EC1E
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_6EBAC:

		lea	word_6EDAE(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#Obj_FlickerMove,(a0)
		move.b	$2C(a0),d0
		lsr.b	#1,d0
		addi.b	#$B,d0
		move.b	d0,$22(a0)
		moveq	#0,d0
		jsr	(Set_IndexedVelocity).l
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_6EBD8:
		move.b	$3C(a0),d0
		move.w	#$200,8(a0)
		addi.b	#$40,d0
		bpl.s	locret_6EBEE
		move.w	#$280,8(a0)

locret_6EBEE:
		rts
; End of function sub_6EBD8


; =============== S U B R O U T I N E =======================================


sub_6EBF0:
		cmpi.b	#3,$22(a0)
		beq.s	locret_6EC12
		move.b	$3C(a0),d0
		lea	byte_6EC14(pc),a1
		moveq	#4,d6

loc_6EC02:
		cmp.b	(a1)+,d0
		bcs.s	loc_6EC0E
		addq.w	#1,a1
		dbf	d6,loc_6EC02
		rts
; ---------------------------------------------------------------------------

loc_6EC0E:
		move.b	(a1)+,$22(a0)

locret_6EC12:
		rts
; End of function sub_6EBF0

; ---------------------------------------------------------------------------
byte_6EC14:	dc.b  $30,   1
		dc.b  $58,   8
		dc.b  $A8,   2
		dc.b  $D0,   8
		dc.b  $FF,   1

; =============== S U B R O U T I N E =======================================


sub_6EC1E:

		movea.w	$46(a0),a1
		btst	#7,$38(a1)
		bne.s	loc_6EC34
		btst	#7,$2A(a1)
		bne.s	loc_6EC34
		rts
; ---------------------------------------------------------------------------

loc_6EC34:

		jmp	(Go_Delete_Sprite).l
; End of function sub_6EC1E


; =============== S U B R O U T I N E =======================================


sub_6EC3A:
		btst	#2,$38(a0)
		bne.s	loc_6EC44
		rts
; ---------------------------------------------------------------------------

loc_6EC44:
		lea	($FFFFB000).w,a1
		bsr.w	sub_6EC50
		lea	($FFFFB04A).w,a1
; End of function sub_6EC3A


; =============== S U B R O U T I N E =======================================


sub_6EC50:
		move.w	$10(a0),d0
		sub.w	$10(a1),d0
		spl	d1
		bpl.s	loc_6EC5E
		neg.w	d0

loc_6EC5E:
		andi.w	#-$40,d0
		cmpi.w	#$1C0,d0
		bcs.s	loc_6EC6C
		move.w	#$1C0,d0

loc_6EC6C:
		lsr.w	#4,d0
		move.l	dword_6EC7E(pc,d0.w),d2
		tst.b	d1
		bne.s	loc_6EC78
		neg.l	d2

loc_6EC78:
		add.l	d2,$10(a1)
		rts
; End of function sub_6EC50

; ---------------------------------------------------------------------------
dword_6EC7E:	dc.l $28000
		dc.l $20000
		dc.l $1C000
		dc.l $18000
		dc.l $14000
		dc.l $10000
		dc.l $C000
		dc.l $8000

; =============== S U B R O U T I N E =======================================


sub_6EC9E:
		tst.l	(a0)
		beq.s	locret_6ECF4
		tst.b	$28(a0)
		bne.s	locret_6ECF4
		tst.b	$29(a0)
		beq.s	loc_6ECF6
		tst.b	$20(a0)
		bne.s	loc_6ECC2
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l

loc_6ECC2:
		bset	#6,$2A(a0)
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_6ECD4
		addq.w	#8,d0

loc_6ECD4:
		lea	word_6ED0A(pc),a1
		lea	word_6ED12(pc,d0.w),a2
		jsr	(CopyWordData_4).l
		subq.b	#1,$20(a0)
		bne.s	locret_6ECF4
		bclr	#6,$2A(a0)
		move.b	$25(a0),$28(a0)

locret_6ECF4:
		rts
; ---------------------------------------------------------------------------

loc_6ECF6:
		move.l	#Wait_FadeToLevelMusic,(a0)
		move.l	#loc_6E6C6,$34(a0)
		jmp	(BossDefeated_StopTimer).l
; End of function sub_6EC9E

; ---------------------------------------------------------------------------
word_6ED0A:	dc.w $FC32
		dc.w $FC34
		dc.w $FC36
		dc.w $FC3C
word_6ED12:	dc.w $60
		dc.w $20
		dc.w $20
		dc.w $640
		dc.w $888
		dc.w $EEE
		dc.w $EEE
		dc.w $AAA

; =============== S U B R O U T I N E =======================================


sub_6ED22:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		beq.s	loc_6ED32
		clr.b	$28(a0)

loc_6ED32:
		btst	#4,$38(a1)
		bne.s	loc_6ED3C
		rts
; ---------------------------------------------------------------------------

loc_6ED3C:
		move.l	#Delete_Current_Sprite,(a0)
		lea	ChildObjDat_6EDF2(pc),a2
		jmp	(CreateChild1_Normal).l
; End of function sub_6ED22


; =============== S U B R O U T I N E =======================================


sub_6ED4C:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		beq.s	loc_6ED5C
		clr.b	$28(a0)

loc_6ED5C:
		btst	#4,$38(a1)
		bne.s	loc_6ED66
		rts
; ---------------------------------------------------------------------------

loc_6ED66:
		bset	#7,$2A(a0)
		move.b	#1,$22(a0)
		clr.b	$28(a0)
		move.l	#Obj_FlickerMove,(a0)
		moveq	#0,d0
		jmp	(Set_IndexedVelocity).l
; End of function sub_6ED4C

; ---------------------------------------------------------------------------
ObjDat3_6ED84:	dc.l Map_CNZEndBoss
		dc.w $2430
		dc.w $280
		dc.b $40
		dc.b $14
		dc.b 0
		dc.b 6
		dc.l Map_RobotnikShip
		dc.w $852E
		dc.w $280
		dc.b $20
		dc.b $20
		dc.b 5
		dc.b 0
ObjDat3_6ED9C:	dc.l Map_CNZEndBoss
		dc.w $2430
		dc.w $280
		dc.b $10
		dc.b $10
		dc.b 4
		dc.b $8B
word_6EDA8:	dc.w $280
		dc.b 8
		dc.b $10
		dc.b $A
		dc.b 0
word_6EDAE:	dc.w $280
		dc.b $14
		dc.b $14
		dc.b 0
		dc.b 0
ObjDat3_6EDB4:	dc.l Map_CNZEndBoss
		dc.w $2430
		dc.w $200
		dc.b 8
		dc.b $10
		dc.b 1
		dc.b $9E
ObjDat3_6EDC0:	dc.l Map_CNZEndBoss

		dc.w $2430
		dc.w $80
		dc.b $10
		dc.b $40
		dc.b 6
		dc.b $AB
ChildObjDat_6EDCC:dc.w 0
		dc.l loc_6E82C
		dc.w $14
ChildObjDat_6EDD4:dc.w 3
		dc.l loc_6E95A
		dc.w 8
ChildObjDat_6EDDC:dc.w 0
		dc.l loc_6EADA
		dc.w $4C
ChildObjDat_6EDE4:dc.w 1
		dc.l loc_6EADA
		dc.w $F454
		dc.l loc_6EADA
		dc.w $C54
ChildObjDat_6EDF2:dc.w 1
		dc.l loc_6E936
		dc.w $F800
		dc.l loc_6E936
		dc.w $800
ChildObjDat_6EE00:dc.w 1
		dc.l loc_6EBAC
		dc.w $EC00
		dc.l loc_6EBAC
		dc.w $1400
byte_6EE0E:	dc.b	1,   0
		dc.b	3,   0
		dc.b	1,   0
		dc.b	3,   0
		dc.b	1,   4
		dc.b	3,   0
		dc.b	1,   9
		dc.b  $FC
byte_6EE1D:	dc.b	4,   0
		dc.b	5,   0
		dc.b	4,   0
		dc.b	5,   0
		dc.b	4,   4
		dc.b	5,   0
		dc.b	4,   9
		dc.b  $FC
byte_6EE2C:	dc.b	0,   9
		dc.b	6,   9
		dc.b	7, $F4
byte_6EE32:	dc.b	9, $1F
		dc.b	6,   0
		dc.b	9,   2
		dc.b	7,   0
		dc.b  $FC
byte_6EE3B:	dc.b	9, $24,	  6,   0
		dc.b	9,   2,	  7,   0
		dc.b  $FC,   7,	  0,   1
		dc.b  $FC
Pal_CNZEndBoss:	binclude "Levels\CNZ\Palettes\End Boss.bin"

; ---------------------------------------------------------------------------

Obj_AA_1_FBZ1_Boss:
		lea	byte_6EE98(pc),a1
		jsr	(Check_CameraInRange).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6EE8E(pc,d0.w),d1
		jsr	off_6EE8E(pc,d1.w)
		bsr.w	sub_6F786
		bsr.w	sub_6F994
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_6EE8E:	dc.w loc_6EEA8-off_6EE8E

		dc.w loc_6EF0E-off_6EE8E
		dc.w loc_6EF32-off_6EE8E
		dc.w loc_6EF5A-off_6EE8E
		dc.w loc_6EF76-off_6EE8E
byte_6EE98:	dc.b	2, $40
		dc.b	6,   0
		dc.b  $2D, $20
		dc.b  $2F, $20
		dc.b	5, $40
		dc.b	5, $40
		dc.b  $2E, $20
		dc.b  $2E, $20
; ---------------------------------------------------------------------------

loc_6EEA8:
		lea	Obj3_6FA34(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#6,$29(a0)
		move.b	#1,($FFFFF7AA).w
		move.w	($FFFFEE16).w,($FFFFFA92).w
		move.w	($FFFFEE1A).w,($FFFFFA98).w
		move.w	#$540,($FFFFEE12).w
		move.w	#$2E20,$3A(a0)
		move.l	#loc_6EF14,$34(a0)
		lea	(PLC_83D64).l,a1
		jsr	(Load_PLC_Raw).l
		lea	(ArtKosM_FBZMiniboss).l,a1
		move.w	#-$5A40,d2
		jsr	(Queue_Kos_Module).l
		lea	Pal_FBZMiniboss(pc),a1
		jsr	(PalLoad_Line1).l
		lea	ChildObjDat_6FA76(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6EF0E:
		jmp	(loc_85C7E).l
; ---------------------------------------------------------------------------

loc_6EF14:
		move.b	#4,5(a0)
		move.w	($FFFFEE16).w,($FFFFFA92).w
		move.w	$3A(a0),d0
		move.w	d0,($FFFFEE14).w
		addi.w	#$80,d0
		move.w	d0,($FFFFEE16).w
		rts
; ---------------------------------------------------------------------------

loc_6EF32:
		btst	#0,$38(a0)
		bne.s	loc_6EF3C
		rts
; ---------------------------------------------------------------------------

loc_6EF3C:
		move.b	#6,5(a0)
		move.l	#loc_6EF60,$34(a0)
		move.w	#$78,$2E(a0)
		moveq	#-$1F,d0
		jsr	(Play_Sound).l

locret_6EF58:

		rts
; ---------------------------------------------------------------------------

loc_6EF5A:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6EF60:
		move.b	#8,5(a0)
		moveq	#$2E,d0
		jsr	(Play_Sound).l
		move.b	#$2E,($FFFFFF91).w
		rts
; ---------------------------------------------------------------------------

loc_6EF76:
		bclr	#7,$38(a0)
		beq.s	locret_6EF58
		lea	ChildObjDat_6FAA8(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6EF88:
		subq.w	#1,$2E(a0)
		bmi.s	loc_6EF98
		bsr.w	sub_6F786
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6EF98:
		bclr	#7,4(a0)
		move.w	#$77,$2E(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_6EFB2
		move.l	#Obj_Song_Fade_ToLevelMusic,(a1)

loc_6EFB2:
		jsr	(Obj_EndSignControl).l
		lea	ChildObjDat_6FAB0(pc),a2
		jsr	(CreateChild6_Simple).l
		lea	(ChildObjDat_89ED0).l,a2
		jsr	(CreateChild1_Normal).l
		lea	(ChildObjDat_86B7A).l,a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_6EFDA:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6EFF2(pc,d0.w),d1
		jsr	off_6EFF2(pc,d1.w)
		bsr.w	sub_6F796
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
off_6EFF2:	dc.w loc_6EFF6-off_6EFF2

		dc.w loc_6F010-off_6EFF2
; ---------------------------------------------------------------------------

loc_6EFF6:
		lea	(ObjDat3_89E84).l,a1
		jsr	(SetUp_ObjAttributes).l

loc_6F002:
		move.w	#$280,8(a0)
		move.w	$14(a0),$3E(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F010:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_6F04A
		move.w	$3E(a0),d0
		btst	#3,$2A(a0)
		bne.s	loc_6F03C
		btst	#2,$38(a1)
		bne.s	loc_6F03C
		bclr	#0,$38(a1)
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F03C:

		bset	#0,$38(a1)
		addq.w	#4,d0
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F04A:
		move.l	#loc_6F056,(a0)
		addq.w	#8,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F056:
		bsr.w	sub_6F796
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_6F060:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6F074(pc,d0.w),d1
		jsr	off_6F074(pc,d1.w)
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------
off_6F074:	dc.w loc_6F07C-off_6F074

		dc.w loc_6F086-off_6F074
		dc.w loc_6F0AA-off_6F074
		dc.w loc_6F0B8-off_6F074
; ---------------------------------------------------------------------------

loc_6F07C:
		lea	word_6FA58(pc),a1
		jmp	(SetUp_ObjAttributes3).l
; ---------------------------------------------------------------------------

loc_6F086:
		movea.w	$46(a0),a1
		btst	#0,$38(a1)
		bne.s	loc_6F094
		rts
; ---------------------------------------------------------------------------

loc_6F094:
		move.b	#4,5(a0)
		move.w	#$40,$2E(a0)
		move.l	#loc_6F0B0,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F0AA:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6F0B0:
		move.b	#6,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F0B8:
		btst	#2,($FFFFFE0F).w
		jsr	(Find_SonicTails8Way).l
		addi.w	#9,d4
		move.b	d4,$22(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F0CE:
		lea	word_6FA5E(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_6F102,(a0)
		move.w	#$EEE,($FFFFFC3E).w
		lea	(word_6FAE0).l,a1
		lea	($FFFFFADE).w,a2
		move.l	(a1)+,(a2)+
		move.l	(a1)+,(a2)+
		clr.w	(a2)
		move.l	#Go_Delete_Sprite,($FFFFFADA).w
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6F102:
		jsr	(Run_PalRotationScript).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6F10E:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6F122(pc,d0.w),d1
		jsr	off_6F122(pc,d1.w)
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------
off_6F122:	dc.w loc_6F12A-off_6F122

		dc.w loc_6F142-off_6F122
		dc.w loc_6F162-off_6F122
		dc.w locret_6F176-off_6F122
; ---------------------------------------------------------------------------

loc_6F12A:
		lea	word_6FA40(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.b	$2C(a0),d0
		lsr.b	#1,d0
		addq.b	#1,d0
		move.b	d0,$22(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F142:
		movea.w	$46(a0),a1
		btst	#0,$38(a1)
		bne.s	loc_6F150
		rts
; ---------------------------------------------------------------------------

loc_6F150:
		move.b	#4,5(a0)
		move.l	#loc_6F16E,$34(a0)
		bra.w	loc_6F7A6
; ---------------------------------------------------------------------------

loc_6F162:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6F16E:
		move.b	#6,5(a0)
		rts
; ---------------------------------------------------------------------------

locret_6F176:
		rts
; ---------------------------------------------------------------------------

loc_6F178:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6F190(pc,d0.w),d1
		jsr	off_6F190(pc,d1.w)
		bsr.w	sub_6FA14
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_6F190:	dc.w loc_6F1A6-off_6F190

		dc.w loc_6F1D6-off_6F190
		dc.w loc_6F1F4-off_6F190
		dc.w loc_6F218-off_6F190
		dc.w loc_6F1F4-off_6F190
		dc.w loc_6F29E-off_6F190
		dc.w loc_6F338-off_6F190
		dc.w loc_6F1F4-off_6F190
		dc.w loc_6F378-off_6F190
		dc.w loc_6F384-off_6F190
		dc.w loc_6F1F4-off_6F190
; ---------------------------------------------------------------------------

loc_6F1A6:
		lea	word_6FA46(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.w	#-$140,d0
		subi.b	#$A,$2C(a0)
		beq.s	loc_6F1CA
		neg.w	d0
		bset	#0,4(a0)
		move.w	#$3F,$2E(a0)

loc_6F1CA:
		move.w	d0,$18(a0)
		move.w	#-$D0,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F1D6:
		movea.w	$46(a0),a1
		btst	#0,$38(a1)
		bne.s	loc_6F1E4
		rts
; ---------------------------------------------------------------------------

loc_6F1E4:
		move.b	#4,5(a0)
		move.l	#loc_6F1FA,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F1F4:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6F1FA:
		move.b	#6,5(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_6F224,$34(a0)
		lea	word_6FAA2(pc),a2
		jmp	(CreateChild4_LinkListRepeated).l
; ---------------------------------------------------------------------------

loc_6F218:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6F224:
		move.b	#8,5(a0)
		bset	#3,$38(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_6F240,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F240:

		move.b	#$A,5(a0)
		bset	#2,$38(a0)
		bclr	#3,$38(a0)
		movea.w	$46(a0),a1
		bclr	#1,$38(a1)
		bclr	#1,$38(a0)
		bclr	#6,$38(a1)
		bclr	#6,$38(a0)
		move.w	#$78,$2E(a0)
		move.l	#loc_6F2A8,$34(a0)
		move.b	#-$60,$3C(a0)
		move.b	#2,$40(a0)
		btst	#0,4(a0)
		beq.s	locret_6F29C
		move.b	#$60,$3C(a0)
		move.b	#-2,$40(a0)

locret_6F29C:
		rts
; ---------------------------------------------------------------------------

loc_6F29E:
		bsr.w	sub_6F7F2
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6F2A8:
		move.w	#$F0,$2E(a0)
		movea.w	$46(a0),a1
		btst	#0,$38(a1)
		beq.s	loc_6F2E4
		btst	#1,$38(a1)
		bne.w	locret_6EF58
		move.b	#$C,5(a0)
		bclr	#2,$38(a0)
		bset	#1,$38(a1)
		bset	#1,$38(a0)
		bset	#7,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_6F2E4:
		btst	#6,$38(a1)
		bne.w	locret_6EF58
		lea	($FFFFB000).w,a2
		tst.b	$40(a2)
		bne.w	locret_6EF58
		move.w	$10(a2),d0
		cmp.w	$10(a1),d0
		bcc.s	loc_6F30E
		btst	#0,4(a0)
		beq.s	loc_6F318
		rts
; ---------------------------------------------------------------------------

loc_6F30E:
		btst	#0,4(a0)
		beq.w	locret_6EF58

loc_6F318:
		move.b	#$12,5(a0)
		bclr	#2,$38(a0)
		bset	#6,$38(a1)
		bset	#6,$38(a0)
		bset	#7,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_6F338:
		btst	#3,$38(a0)
		bne.s	loc_6F344
		bra.w	sub_6F830
; ---------------------------------------------------------------------------

loc_6F344:
		move.b	#$E,5(a0)
		move.b	#2,$40(a0)
		move.w	#$60,$2E(a0)
		move.l	#loc_6F360,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F360:
		move.b	#$10,5(a0)
		bclr	#3,$38(a0)
		movea.w	$46(a0),a1
		bclr	#2,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_6F378:
		btst	#2,$38(a0)
		bne.w	loc_6F240
		rts
; ---------------------------------------------------------------------------

loc_6F384:
		bclr	#3,$38(a0)
		bne.s	loc_6F38E
		rts
; ---------------------------------------------------------------------------

loc_6F38E:
		move.b	#$14,5(a0)
		move.w	#$10,$2E(a0)
		move.l	#loc_6F3A4,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F3A4:
		move.b	#$10,5(a0)
		bset	#3,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F3B2:
		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		bne.s	loc_6F3C4
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6F3C4:
		move.l	#Obj_FlickerMove,(a0)
		bset	#4,$38(a0)
		move.w	#$3F,$2E(a0)
		moveq	#0,d0
		jmp	(Set_IndexedVelocity).l
; ---------------------------------------------------------------------------

loc_6F3DE:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6F3F6(pc,d0.w),d1
		jsr	off_6F3F6(pc,d1.w)
		bsr.w	sub_6FA14
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_6F3F6:	dc.w loc_6F416-off_6F3F6

		dc.w loc_6F46A-off_6F3F6
		dc.w loc_6F4C0-off_6F3F6
		dc.w loc_6F4F6-off_6F3F6
		dc.w loc_6F53E-off_6F3F6
		dc.w loc_6F554-off_6F3F6
		dc.w loc_6F5B8-off_6F3F6
		dc.w loc_6F5E0-off_6F3F6
		dc.w loc_6F612-off_6F3F6
		dc.w loc_6F620-off_6F3F6
		dc.w loc_6F632-off_6F3F6
		dc.w loc_6F64E-off_6F3F6
		dc.w loc_6F67E-off_6F3F6
		dc.w loc_6F6A6-off_6F3F6
		dc.w loc_6F6E4-off_6F3F6
		dc.w loc_6F728-off_6F3F6
; ---------------------------------------------------------------------------

loc_6F416:
		addq.b	#2,$2C(a0)
		cmpi.b	#$A,$2C(a0)
		beq.s	loc_6F432
		lea	word_6FA4C(pc),a1
		move.w	#4,$3E(a0)
		jmp	(SetUp_ObjAttributes3).l
; ---------------------------------------------------------------------------

loc_6F432:
		lea	word_6FA52(pc),a1
		move.w	#3,$3E(a0)
		jsr	(SetUp_ObjAttributes3).l
		move.b	#-$7A,$28(a0)
		movea.w	$46(a0),a1
		movea.w	$46(a1),a1
		movea.w	$46(a1),a1
		movea.w	$46(a1),a1
		movea.w	$46(a1),a1
		move.w	a1,$44(a0)
		move.w	a1,$30(a1)
		move.w	a0,$32(a1)
		rts
; ---------------------------------------------------------------------------

loc_6F46A:
		jsr	(Refresh_ChildPosition).l
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		bne.s	loc_6F47E
		rts
; ---------------------------------------------------------------------------

loc_6F47E:
		move.b	#4,5(a0)
		bset	#3,$38(a0)
		bsr.w	sub_6F7D2
		move.w	#$F,$2E(a0)
		move.l	#loc_6F4CC,$34(a0)
		movea.w	$46(a0),a1
		move.w	$30(a1),$30(a0)
		move.w	$32(a1),$32(a0)
		btst	#0,4(a1)
		beq.s	locret_6F4BE
		bset	#0,4(a0)
		neg.w	$18(a0)

locret_6F4BE:
		rts
; ---------------------------------------------------------------------------

loc_6F4C0:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6F4CC:
		move.b	#6,5(a0)
		bclr	#3,$38(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		move.w	#$80,8(a0)
		cmpi.b	#$A,$2C(a0)
		beq.s	locret_6F4F4
		move.w	#$180,8(a0)

locret_6F4F4:
		rts
; ---------------------------------------------------------------------------

loc_6F4F6:
		movea.w	$46(a0),a1

loc_6F4FA:
		btst	#2,$38(a1)
		bne.s	loc_6F504
		rts
; ---------------------------------------------------------------------------

loc_6F504:

		move.b	#8,5(a0)
		bset	#2,$38(a0)
		bclr	#3,$38(a0)
		bclr	#6,$38(a0)
		bclr	#1,$38(a0)
		move.b	$3C(a1),$3C(a0)
		move.b	$40(a1),$40(a0)
		move.b	$2C(a0),d0
		add.b	d0,d0
		move.b	d0,$3B(a0)
		move.b	d0,$3A(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F53E:
		subq.b	#1,$3B(a0)
		bpl.s	loc_6F54A
		move.b	#$A,5(a0)

loc_6F54A:
		move.w	$3E(a0),d2
		jmp	(MoveSprite_CircularSimple).l
; ---------------------------------------------------------------------------

loc_6F554:
		bsr.w	sub_6F7F2
		move.w	$3E(a0),d2
		jsr	(MoveSprite_CircularSimple).l
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		bne.s	loc_6F578
		btst	#6,$38(a1)
		bne.s	loc_6F58C
		rts
; ---------------------------------------------------------------------------

loc_6F578:
		move.b	#$C,5(a0)
		bset	#1,$38(a0)
		bclr	#2,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F58C:
		move.b	#$18,5(a0)
		bset	#6,$38(a0)
		bclr	#2,$38(a0)
		cmpi.b	#$A,$2C(a0)
		bne.s	locret_6F5B6
		lea	($FFFFB000).w,a1
		move.w	$10(a1),$30(a0)
		move.w	$14(a1),$32(a0)

locret_6F5B6:
		rts
; ---------------------------------------------------------------------------

loc_6F5B8:
		bsr.w	sub_6F830
		beq.s	loc_6F5D6
		move.b	#$E,5(a0)
		cmpi.b	#$A,$2C(a0)
		bne.s	loc_6F5D6
		movea.w	$44(a0),a1
		bset	#3,$38(a1)

loc_6F5D6:

		move.w	$3E(a0),d2
		jmp	(MoveSprite_CircularSimple).l
; ---------------------------------------------------------------------------

loc_6F5E0:
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		bne.s	loc_6F5F6
		move.w	$3E(a0),d2
		jmp	(MoveSprite_CircularSimple).l
; ---------------------------------------------------------------------------

loc_6F5F6:
		move.b	#$10,5(a0)
		bset	#3,$38(a0)
		move.w	#$F,$2E(a0)
		move.l	#loc_6F618,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F612:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6F618:
		move.b	#$12,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F620:
		move.b	#$14,d4
		bsr.w	sub_6F85A
		move.w	$3E(a0),d2
		jmp	(MoveSprite_CircularSimple).l
; ---------------------------------------------------------------------------

loc_6F632:
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		beq.s	loc_6F640
		rts
; ---------------------------------------------------------------------------

loc_6F640:
		move.b	#$16,5(a0)
		bclr	#3,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F64E:
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		bne.w	loc_6F504
		bsr.w	sub_6F8C8
		beq.s	loc_6F674
		cmpi.b	#$A,$2C(a0)
		bne.s	loc_6F674
		movea.w	$44(a0),a1
		bset	#2,$38(a1)

loc_6F674:

		move.w	$3E(a0),d2
		jmp	(MoveSprite_CircularSimple).l
; ---------------------------------------------------------------------------

loc_6F67E:
		bsr.w	sub_6F8F2
		beq.s	loc_6F69C
		move.b	#$1A,5(a0)
		cmpi.b	#$A,$2C(a0)
		bne.s	loc_6F69C
		movea.w	$44(a0),a1
		bset	#3,$38(a1)

loc_6F69C:

		move.w	$3E(a0),d2
		jmp	(MoveSprite_CircularSimple).l
; ---------------------------------------------------------------------------

loc_6F6A6:
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		bne.s	loc_6F6BC
		move.w	$3E(a0),d2
		jmp	(MoveSprite_CircularSimple).l
; ---------------------------------------------------------------------------

loc_6F6BC:
		move.b	#$1C,5(a0)
		bset	#3,$38(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_6F702,$34(a0)
		cmpi.b	#$A,$2C(a0)
		bne.w	locret_6EF58
		bra.w	loc_6F91C
; ---------------------------------------------------------------------------

loc_6F6E4:
		cmpi.b	#$A,$2C(a0)
		beq.s	loc_6F6F6
		bsr.w	sub_6F93A
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6F6F6:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6F702:
		move.b	#$1E,5(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_6F72E,$34(a0)
		moveq	#-$6A,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_6F720:
		move.b	#$16,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F728:
		jsr	(Obj_Wait).l

loc_6F72E:
		move.b	#$1C,5(a0)
		neg.w	$18(a0)
		neg.w	$1A(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_6F720,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F74C:
		lea	(ObjDat3_89E78).l,a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_6F764,(a0)
		move.b	#1,$22(a0)

loc_6F764:
		bsr.w	sub_6F786
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_6F780
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6F780:
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_6F786:

		moveq	#$23,d1
		moveq	#$20,d2
		moveq	#$1C,d3
		move.w	$10(a0),d4
		jmp	(SolidObjectFull).l
; End of function sub_6F786


; =============== S U B R O U T I N E =======================================


sub_6F796:

		moveq	#$1B,d1
		moveq	#8,d2
		moveq	#$D,d3
		move.w	$10(a0),d4
		jmp	(SolidObjectFull).l
; End of function sub_6F796

; ---------------------------------------------------------------------------

loc_6F7A6:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_6F7C0(pc,d0.w),$2E(a0)
		add.w	d0,d0
		lea	word_6F7C6(pc,d0.w),a1
		move.w	(a1)+,d1
		move.w	(a1)+,(a0,d1.w)
		rts
; ---------------------------------------------------------------------------
word_6F7C0:	dc.w $20
		dc.w $20
		dc.w $40
word_6F7C6:	dc.w	$18, $FFC0
		dc.w	$18,   $40
		dc.w	$1A,   $40

; =============== S U B R O U T I N E =======================================


sub_6F7D2:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	locret_6F7E4(pc,d0.w),d0
		move.w	d0,$18(a0)
		move.w	d0,$1A(a0)

locret_6F7E4:
		rts
; End of function sub_6F7D2

; ---------------------------------------------------------------------------
		dc.w $FF40
		dc.w $FE80
		dc.w $FDC0
		dc.w $FD00
		dc.w $FC40
		dc.w $FAD0

; =============== S U B R O U T I N E =======================================


sub_6F7F2:

		move.b	$3C(a0),d0
		moveq	#0,d1
		btst	#0,4(a0)
		beq.s	loc_6F802

loc_6F800:
		addq.w	#2,d1

loc_6F802:
		move.b	$40(a0),d2
		bmi.s	loc_6F814
		move.b	byte_6F82C(pc,d1.w),d3
		cmp.b	d3,d0
		bcc.s	loc_6F81E
		bra.w	loc_6F820
; ---------------------------------------------------------------------------

loc_6F814:
		addq.w	#1,d1
		move.b	byte_6F82C(pc,d1.w),d3
		cmp.b	d3,d0
		bhi.s	loc_6F820

loc_6F81E:
		neg.b	d2

loc_6F820:

		move.b	d2,$40(a0)
		add.b	d2,d0
		move.b	d0,$3C(a0)
		rts
; End of function sub_6F7F2

; ---------------------------------------------------------------------------
byte_6F82C:	dc.b $B0
		dc.b $80
		dc.b $80
		dc.b $50

; =============== S U B R O U T I N E =======================================


sub_6F830:

		btst	#0,4(a0)
		bne.s	loc_6F84A
		addq.b	#2,$3C(a0)
		moveq	#-$40,d0
		cmp.b	$3C(a0),d0
		bhi.s	loc_6F856

loc_6F844:
		move.b	d0,$3C(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F84A:
		subq.b	#2,$3C(a0)
		moveq	#$40,d0
		cmp.b	$3C(a0),d0
		bcc.s	loc_6F844

loc_6F856:
		moveq	#0,d0
		rts
; End of function sub_6F830


; =============== S U B R O U T I N E =======================================


sub_6F85A:
		move.b	$3C(a0),d0
		moveq	#0,d1
		move.b	$2C(a0),d1
		movea.w	$46(a0),a1
		move.b	$40(a1),d2
		move.b	d2,$40(a0)
		lsr.w	#1,d1
		btst	#0,4(a0)
		bne.s	loc_6F888
		move.b	locret_6F8BC+1(pc,d1.w),d3
		sub.b	d2,d0
		cmp.b	d3,d0
		bls.s	loc_6F892
		bra.w	loc_6F8B8
; ---------------------------------------------------------------------------

loc_6F888:
		move.b	byte_6F8C2(pc,d1.w),d3
		add.b	d2,d0
		cmp.b	d3,d0
		bcs.s	loc_6F8B8

loc_6F892:
		move.b	d3,d0
		move.b	d4,5(a0)
		addq.b	#2,$40(a0)
		cmpi.b	#$A,$2C(a0)
		bne.s	loc_6F8B8
		movea.w	$44(a0),a1
		movea.w	$46(a1),a1
		bset	#2,$38(a1)
		bset	#6,$3A(a1)

loc_6F8B8:

		move.b	d0,$3C(a0)

locret_6F8BC:
		rts
; End of function sub_6F85A

; ---------------------------------------------------------------------------
		dc.b $A0
		dc.b $88
		dc.b $60
		dc.b $48
byte_6F8C2:	dc.b $38
		dc.b $60
		dc.b $78
		dc.b $90
		dc.b $B8
		dc.b $CC

; =============== S U B R O U T I N E =======================================


sub_6F8C8:
		btst	#0,4(a0)
		bne.s	loc_6F8E2
		addq.b	#2,$3C(a0)
		moveq	#-$60,d0
		cmp.b	$3C(a0),d0
		bhi.s	loc_6F8EE

loc_6F8DC:
		move.b	d0,$3C(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F8E2:
		subq.b	#2,$3C(a0)
		moveq	#$60,d0
		cmp.b	$3C(a0),d0
		bcc.s	loc_6F8DC

loc_6F8EE:
		moveq	#0,d0
		rts
; End of function sub_6F8C8


; =============== S U B R O U T I N E =======================================


sub_6F8F2:
		btst	#0,4(a0)
		bne.s	loc_6F90C
		subq.b	#2,$3C(a0)
		moveq	#-$80,d0
		cmp.b	$3C(a0),d0
		bcs.s	loc_6F918

loc_6F906:
		move.b	d0,$3C(a0)
		rts
; ---------------------------------------------------------------------------

loc_6F90C:
		addq.b	#2,$3C(a0)
		moveq	#-$80,d0
		cmp.b	$3C(a0),d0
		bcs.s	loc_6F906

loc_6F918:
		moveq	#0,d0
		rts
; End of function sub_6F8F2

; ---------------------------------------------------------------------------

loc_6F91C:
		move.w	$30(a0),d0
		sub.w	$10(a0),d0
		lsl.w	#3,d0
		move.w	d0,$18(a0)
		move.w	$32(a0),d0
		sub.w	$14(a0),d0
		lsl.w	#3,d0
		move.w	d0,$1A(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_6F93A:
		movea.w	$32(a0),a1
		movea.w	$30(a0),a2
		moveq	#0,d2
		move.b	$2C(a0),d2
		lsr.w	#1,d2
		moveq	#0,d0
		move.w	$10(a1),d0
		move.w	$10(a2),d3
		sub.w	d3,d0
		smi	d1
		bpl.s	loc_6F95C
		neg.w	d0

loc_6F95C:
		divu.w	#5,d0
		mulu.w	d2,d0
		tst.b	d1
		beq.s	loc_6F968
		neg.w	d0

loc_6F968:
		add.w	d0,d3
		move.w	d3,$10(a0)
		moveq	#0,d0
		move.w	$14(a1),d0
		move.w	$14(a2),d3
		sub.w	d3,d0
		smi	d1
		bpl.s	loc_6F980
		neg.w	d0

loc_6F980:
		divu.w	#5,d0
		mulu.w	d2,d0
		tst.b	d1
		beq.s	loc_6F98C
		neg.w	d0

loc_6F98C:
		add.w	d0,d3
		move.w	d3,$14(a0)
		rts
; End of function sub_6F93A


; =============== S U B R O U T I N E =======================================


sub_6F994:
		btst	#6,$3A(a0)
		beq.s	locret_6F9DC
		tst.b	$20(a0)
		bne.s	loc_6F9B6
		subq.b	#1,$29(a0)
		beq.s	loc_6F9DE
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l

loc_6F9B6:
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_6F9C2
		addq.w	#8,d0

loc_6F9C2:
		lea	word_6F9FC(pc),a1
		lea	word_6FA04(pc,d0.w),a2
		jsr	(CopyWordData_4).l
		subq.b	#1,$20(a0)
		bne.s	locret_6F9DC

loc_6F9D6:
		bclr	#6,$3A(a0)

locret_6F9DC:

		rts
; ---------------------------------------------------------------------------

loc_6F9DE:
		move.l	#loc_6EF88,(a0)
		bset	#7,$2A(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild1_Normal).l
		jmp	(BossDefeated_StopTimer).l
; End of function sub_6F994

; ---------------------------------------------------------------------------
word_6F9FC:	dc.w $FC24
		dc.w $FC28
		dc.w $FC36
		dc.w $FC3E
word_6FA04:	dc.w $222
		dc.w $644
		dc.w $222
		dc.w $44
		dc.w $AAA
		dc.w $AAA
		dc.w $EEE
		dc.w $EEE

; =============== S U B R O U T I N E =======================================


sub_6FA14:

		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_6FA22
		rts
; ---------------------------------------------------------------------------

loc_6FA22:
		move.l	#loc_6F3B2,(a0)
		bset	#7,$2A(a0)
		clr.b	$28(a0)
		rts
; End of function sub_6FA14

; ---------------------------------------------------------------------------
Obj3_6FA34:	dc.l Map_FBZMiniboss
		dc.w $A52E
		dc.w $200
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b 0
word_6FA40:	dc.w $100
		dc.b 8
		dc.b 8
		dc.b 1
		dc.b 0
word_6FA46:	dc.w $300
		dc.b $18
		dc.b $10
		dc.b 5
		dc.b 0
word_6FA4C:	dc.w $280
		dc.b 8
		dc.b 8
		dc.b 6
		dc.b 0
word_6FA52:	dc.w $200
		dc.b $18
		dc.b $18
		dc.b 7
		dc.b 0
word_6FA58:	dc.w $100
		dc.b $10
		dc.b 8
		dc.b 8
		dc.b 0
word_6FA5E:	dc.w $180
		dc.b $10
		dc.b 8
		dc.b $11
		dc.b 0
		dc.w $280
		dc.b $10
		dc.b 8
		dc.b 4
		dc.b 0
		dc.l Map_EggCapsule
		dc.w $8494
		dc.w $100
		dc.b 8
		dc.b 8
		dc.b 0
		dc.b 0
ChildObjDat_6FA76:dc.w 6
		dc.l loc_6F10E
		dc.w $F0F8
		dc.l loc_6F10E
		dc.w $10F8
		dc.l loc_6F10E
		dc.w $F8
		dc.l loc_6EFDA
		dc.w $DC
		dc.l loc_6F060
		dc.w $F8
		dc.l loc_6F178
		dc.w 0
		dc.l loc_6F178
		dc.w 0
word_6FAA2:	dc.w 4
		dc.l loc_6F3DE
ChildObjDat_6FAA8:dc.w 0
		dc.l loc_6F0CE
		dc.w $F8
ChildObjDat_6FAB0:dc.w 0
		dc.l loc_6F74C
		dc.b 3
		dc.b 9
		dc.b $A
		dc.b $B
		dc.b $C
		dc.b $D
		dc.b $E
		dc.b $F
		dc.b $10
		dc.b $FC
Pal_FBZMiniboss:	binclude "Levels\FBZ\Palettes\FBZ Miniboss.bin"

word_6FAE0:	dc.w 4
		dc.w 0
		dc.l word_6FAEA
		dc.w 0
word_6FAEA:	dc.w $FC3E
		dc.w	  6,  $EEE,	0,  $644,     3, $FFF4
Map_FBZMiniboss:	include "Levels\FBZ\Misc Object Data\Map - Miniboss.asm"

; ---------------------------------------------------------------------------

Obj_AB_1_FBZ_Laser_Boss:
		lea	word_6FCFC(pc),a1
		jsr	(Check_CameraInRange).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_6FD2E(pc,d0.w),d1
		jsr	off_6FD2E(pc,d1.w)
		bsr.w	sub_70330
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_6FD2E:	dc.w loc_6FD38-off_6FD2E

		dc.w loc_6FDC0-off_6FD2E
		dc.w loc_6FE00-off_6FD2E
		dc.w loc_6FE22-off_6FD2E
		dc.w loc_6FEB2-off_6FD2E
; ---------------------------------------------------------------------------

loc_6FD38:
		lea	ObjDat3_70396(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#$7F,$29(a0)
		move.b	#6,$39(a0)
		move.b	#1,($FFFFF7AA).w
		move.w	($FFFFEE12).w,($FFFFFA98).w
		move.w	#$2900,($FFFFEE14).w
		move.w	#$5E0,($FFFFEE12).w
		lea	PLC_705B6(pc),a1
		cmpi.b	#2,($FFFFB038).w
		bne.s	loc_6FD76
		lea	PLC_705D0(pc),a1

loc_6FD76:
		jsr	(Load_PLC_Raw).l
		lea	Pal_FBZ2Subboss(pc),a1
		jsr	(PalLoad_Line1).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_6FD9A
		move.l	#Obj_Song_Fade_Transition,(a1)
		move.b	#$2E,$2C(a1)

loc_6FD9A:
		lea	ChildObjDat_703D0(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	ChildObjDat_703DE(pc),a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_6FDB6
		move.b	#$49,$2C(a1)

loc_6FDB6:
		lea	ChildObjDat_703C8(pc),a2
		jmp	(CreateChild3_NormalRepeated).l
; ---------------------------------------------------------------------------

loc_6FDC0:
		lea	($FFFFB000).w,a1
		jsr	(Find_OtherObject).l
		cmpi.w	#$18,d2
		bcs.s	loc_6FDD2
		rts
; ---------------------------------------------------------------------------

loc_6FDD2:
		move.b	#4,5(a0)
		move.w	#$80,$1A(a0)
		move.w	#$37,$2E(a0)
		move.l	#loc_6FE0C,$34(a0)
		bset	#7,$38(a0)
		bne.w	locret_6FE20
		lea	ChildObjDat_703E4(pc),a2
		jmp	(CreateChild3_NormalRepeated).l
; ---------------------------------------------------------------------------

loc_6FE00:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6FE0C:
		move.b	#6,5(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_6FE3A,$34(a0)

locret_6FE20:

		rts
; ---------------------------------------------------------------------------

loc_6FE22:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_6FE28:
		subq.b	#1,$39(a0)
		bmi.s	loc_6FE6E
		bset	#3,$38(a0)
		bclr	#6,$2A(a0)

loc_6FE3A:
		move.b	#8,5(a0)
		bclr	#1,$38(a0)
		clr.w	$1A(a0)
		lea	ChildObjDat_703EC(pc),a2
		jsr	(CreateChild1_Normal).l

; =============== S U B R O U T I N E =======================================


sub_6FE54:
		lea	($FFFFB000).w,a1
		jsr	(Find_OtherObject).l
		move.w	#$100,d1
		tst.w	d0
		bne.s	loc_6FE68
		neg.w	d1

loc_6FE68:
		move.w	d1,$18(a0)
		rts
; End of function sub_6FE54

; ---------------------------------------------------------------------------

loc_6FE6E:
		move.l	#Wait_Draw,(a0)
		bset	#7,$2A(a0)
		bset	#5,$38(a0)
		move.w	#$5F,$2E(a0)
		move.l	#loc_6FF10,$34(a0)
		lea	word_6FEA4(pc),a6
		move.w	(a6)+,d6

loc_6FE94:
		movea.l	(a6)+,a1
		move.w	(a6)+,d2
		jsr	(Queue_Kos_Module).l
		dbf	d6,loc_6FE94
		rts
; ---------------------------------------------------------------------------
word_6FEA4:	dc.w 1
		dc.l ArtKosM_FBZCloud
		dc.w $7460
		dc.l ArtKosM_FBZBossPillar
		dc.w $7AA0
; ---------------------------------------------------------------------------

loc_6FEB2:
		btst	#1,$38(a0)
		bne.s	loc_6FEFA
		move.b	($FFFFFE0F).w,d0
		andi.b	#$1F,d0
		bne.s	loc_6FEC6
		bsr.s	sub_6FE54

loc_6FEC6:
		move.w	#$100,d0
		movea.w	$44(a0),a1
		move.w	$10(a1),d1
		move.w	$10(a0),d2
		addi.w	#$20,d1
		cmp.w	d1,d2
		bcs.s	loc_6FEF0
		movea.w	$46(a0),a1
		move.w	$10(a1),d1
		subi.w	#$20,d1
		cmp.w	d1,d2
		bcs.s	loc_6FEF4
		neg.w	d0

loc_6FEF0:
		move.w	d0,$18(a0)

loc_6FEF4:
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_6FEFA:
		move.b	#6,5(a0)
		move.w	#$7F,$2E(a0)
		move.l	#loc_6FE28,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_6FF10:
		bset	#4,$38(a0)
		move.w	#$5F,$2E(a0)
		move.l	#loc_6FF34,$34(a0)
		jsr	(Create_New_Sprite).l
		bne.s	locret_6FF32
		move.l	#Obj_Song_Fade_ToLevelMusic,(a1)

locret_6FF32:
		rts
; ---------------------------------------------------------------------------

loc_6FF34:
		bset	#2,$38(a0)
		clr.b	($FFFFF7AA).w
		move.l	#loc_6FF50,(a0)
		lea	(PLC_83D48).l,a1
		jmp	(Load_PLC_Raw).l
; ---------------------------------------------------------------------------

loc_6FF50:
		move.w	($FFFFEE78).w,($FFFFEE14).w
		jmp	(Sprite_CheckDeleteXY).l
; ---------------------------------------------------------------------------

loc_6FF5C:
		lea	word_703A2(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_6FF70,(a0)
		bra.w	loc_702EA
; ---------------------------------------------------------------------------

loc_6FF70:

		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_6FFB0
		btst	#1,$2C(a0)
		bne.s	loc_6FFAA
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		beq.s	loc_6FFAA
		move.l	#loc_6FFB8,(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_6FFCA,$34(a0)
		move.w	#$100,$18(a0)

loc_6FFAA:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6FFB0:
		move.l	#Sprite_OnScreen_Test,(a0)
		rts
; ---------------------------------------------------------------------------

loc_6FFB8:
		jsr	(MoveSprite2).l
		jsr	(Obj_Wait).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_6FFCA:
		move.l	#loc_6FF70,(a0)
		movea.w	$46(a0),a1
		bclr	#3,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_6FFDC:
		lea	word_703A8(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_6FFFA,(a0)
		addi.w	#$CC,$10(a0)
		addi.w	#$7C,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_6FFFA:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_7000C

loc_70006:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7000C:
		move.l	#Sprite_OnScreen_Test,(a0)
		move.b	#3,$22(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild1_Normal).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7002A:
		lea	ObjDat3_703BC(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_70068,(a0)
		move.l	#loc_700EA,$34(a0)
		addi.w	#$D8,$10(a0)
		addi.w	#$74,$14(a0)
		move.l	#byte_703F4,$30(a0)
		cmpi.b	#2,($FFFFB038).w
		bne.s	locret_70066
		move.l	#Map_EggRoboStand,$C(a0)

locret_70066:
		rts
; ---------------------------------------------------------------------------

loc_70068:

		jsr	(Animate_RawMultiDelay).l
		movea.w	$46(a0),a1
		btst	#6,$2A(a1)
		beq.s	loc_70080
		move.b	#2,$22(a0)

loc_70080:
		btst	#7,$2A(a1)
		beq.s	loc_70094
		move.l	#loc_7009A,(a0)
		move.b	#3,$22(a0)

loc_70094:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7009A:
		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		beq.s	loc_700E4
		move.l	$34(a0),(a0)
		subq.w	#4,$14(a0)
		move.w	#$200,$18(a0)
		move.l	#Map_FBZRobotnikRun,$C(a0)
		move.w	#-$7B57,$A(a0)
		clr.b	$22(a0)
		clr.b	$24(a0)
		clr.b	$23(a0)
		bset	#0,4(a0)
		cmpi.b	#2,($FFFFB038).w
		bne.s	loc_700E4
		move.l	#Map_EggRoboRun,$C(a0)

loc_700E4:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_700EA:
		tst.b	4(a0)
		bpl.s	loc_70106
		lea	byte_70419(pc),a1
		jsr	(Animate_RawNoSST).l
		jsr	(MoveSprite2).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_70106:
		lea	(PLC_83D3A).l,a1
		jsr	(Load_PLC_Raw).l

loc_70112:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_70118:
		lea	word_703AE(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_70152,(a0)
		move.w	#$B0,d0
		move.b	$2C(a0),d1
		bne.s	loc_70134
		neg.w	d0

loc_70134:
		add.w	d0,$10(a0)
		addi.w	#$60,$14(a0)
		movea.w	$46(a0),a1
		moveq	#$44,d0
		tst.b	d1
		beq.s	loc_7014A
		moveq	#$46,d0

loc_7014A:
		move.w	(a1,d0.w),$44(a0)
		rts
; ---------------------------------------------------------------------------

loc_70152:
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		bne.s	loc_7018C
		move.w	$10(a0),-(sp)
		movea.w	$44(a0),a1
		move.w	$10(a1),$10(a0)
		moveq	#$13,d1
		moveq	#$50,d2
		move.w	#$60,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectFull).l
		btst	#0,($FFFFFE0F).w
		bne.w	locret_6FE20
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7018C:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_70192:
		lea	word_703B4(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#loc_701B4,(a0)
		move.l	#byte_70401,$30(a0)
		move.l	#loc_701EE,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_701B4:
		jsr	(Refresh_ChildPosition).l
		jsr	(Animate_RawGetFaster).l
		tst.w	d2
		beq.s	loc_701E8
		bmi.s	loc_701D6
		cmpi.b	#4,$2E(a0)
		bne.s	loc_701E8
		moveq	#$53,d0
		jsr	(Play_Sound_2).l

loc_701D6:
		cmpi.b	#$20,$2F(a0)
		bne.s	loc_701E8
		movea.w	$46(a0),a1
		bset	#1,$38(a1)

loc_701E8:

		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_701EE:
		move.l	#loc_70220,(a0)
		move.b	#6,$22(a0)
		move.l	#byte_70406,$30(a0)

loc_70202:
		addi.w	#$3C,$14(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_70262,$34(a0)
		moveq	#$54,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_70220:
		clr.b	$28(a0)
		cmpi.b	#8,$22(a0)
		bne.s	loc_70232
		move.b	#-$54,$28(a0)

loc_70232:
		lea	($FFFFB000).w,a2
		cmpi.b	#4,5(a2)
		beq.s	loc_7024A
		lea	($FFFFB04A).w,a2
		cmpi.b	#4,5(a2)
		bne.s	loc_70250

loc_7024A:
		bset	#6,$2A(a0)

loc_70250:
		jsr	(Animate_Raw).l
		jsr	(Obj_Wait).l
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_70262:
		move.l	#loc_70294,$34(a0)
		move.w	#$1F,$2E(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_7027E
		move.l	#loc_8642E,(a1)

loc_7027E:
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild1_Normal).l
		bne.s	locret_70292
		addi.w	#$60,$14(a1)

locret_70292:
		rts
; ---------------------------------------------------------------------------

loc_70294:
		move.l	#byte_70412,$30(a0)
		move.l	#loc_702C0,$34(a0)
		clr.b	$24(a0)
		clr.b	$23(a0)
		btst	#6,$2A(a0)
		bne.s	locret_702BE
		movea.w	$46(a0),a1
		bset	#6,$2A(a1)

locret_702BE:
		rts
; ---------------------------------------------------------------------------

loc_702C0:
		move.l	#Obj_Wait,(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_702D6,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_702D6:
		movea.w	$46(a0),a1
		tst.b	$39(a1)
		bmi.s	loc_702E4
		clr.w	($FFFFEECC).w

loc_702E4:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_702EA:
		movea.w	$46(a0),a1
		moveq	#0,d0
		move.b	$2C(a0),d0
		cmpi.w	#4,d0
		bcc.s	loc_7030C
		moveq	#$44,d1
		tst.b	d0
		beq.s	loc_70302
		moveq	#$46,d1

loc_70302:
		move.w	a0,(a1,d1.w)
		bset	#1,4(a0)

loc_7030C:
		add.w	d0,d0
		lea	word_70320(pc,d0.w),a1
		move.w	(a1)+,d0
		add.w	d0,$10(a0)
		move.w	(a1)+,d0
		add.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------
word_70320:	dc.w  $FF50,   $18
		dc.w	$B0,   $18
		dc.w  $FF50,   $A8
		dc.w	$B0,   $A8

; =============== S U B R O U T I N E =======================================


sub_70330:
		tst.b	$28(a0)
		bne.s	locret_70360
		tst.b	$20(a0)
		bne.s	loc_7034A
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l

loc_7034A:
		bsr.w	sub_70362
		subq.b	#1,$20(a0)
		bne.s	locret_70360
		move.b	$25(a0),$28(a0)
		move.b	#$7F,$29(a0)

locret_70360:

		rts
; End of function sub_70330


; =============== S U B R O U T I N E =======================================


sub_70362:
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_70376
		btst	#7,$2A(a0)
		bne.s	loc_70376
		addq.w	#6,d0

loc_70376:

		lea	word_70384(pc),a1
		lea	word_7038A(pc,d0.w),a2
		jmp	(CopyWordData_3).l
; End of function sub_70362

; ---------------------------------------------------------------------------
word_70384:	dc.w  $FC38, $FC3A, $FC3C
word_7038A:	dc.w   $866,  $644,   $20
		dc.w   $EEE,  $EEE,  $EEE
ObjDat3_70396:	dc.l Map_FBZ2Subboss
		dc.w $A52E
		dc.w $280
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b $1C
word_703A2:	dc.w $80
		dc.b 8
		dc.b 8
		dc.b 1
		dc.b 0
word_703A8:	dc.w $280
		dc.b $C
		dc.b $14
		dc.b 2
		dc.b 0
word_703AE:	dc.w $80
		dc.b 8
		dc.b $60
		dc.b 4
		dc.b 0
word_703B4:	dc.w $A52E
		dc.w $80
		dc.b $18
		dc.b 4
		dc.b 5
		dc.b 0
ObjDat3_703BC:	dc.l Map_FBZRobotnikStand
		dc.w $8466
		dc.w $280
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b 0
ChildObjDat_703C8:dc.w 3
		dc.l loc_6FF5C
		dc.w 0
ChildObjDat_703D0:dc.w 1
		dc.l loc_6FFDC
		dc.w 0
		dc.l loc_7002A
		dc.w 0
ChildObjDat_703DE:dc.w 0
		dc.l Obj_8B
ChildObjDat_703E4:dc.w 1
		dc.l loc_70118
		dc.w 0
ChildObjDat_703EC:dc.w 0
		dc.l loc_70192
		dc.w 8
byte_703F4:	dc.b	0,   7
		dc.b	1, $17
		dc.b	0,   7
		dc.b	1,  $F
		dc.b	0, $3F
		dc.b	1,   7
		dc.b  $FC
byte_70401:	dc.b   $B, $40
		dc.b	5,  $A
		dc.b  $FC
byte_70406:	dc.b	0,   6
		dc.b	6,  $A
		dc.b	7,  $A
		dc.b  $F8,   8
		dc.b	0,   8
		dc.b   $A, $FC
byte_70412:	dc.b	0,   7
		dc.b	7,  $A
		dc.b	6,  $A
		dc.b  $F4
byte_70419:	dc.b	5,   0

		dc.b	1,   2
		dc.b	1, $FC
		dc.b	0
Pal_FBZ2Subboss:	binclude "Levels\FBZ\Palettes\FBZ2 Subboss.bin"

Map_FBZ2Subboss:	include "Levels\FBZ\Misc Object Data\Map - Act 2 Subboss.asm"

PLC_705B6:	dc.w 3
		dc.l ArtNem_FBZ2Subboss
		dc.w $A5C0
		dc.l ArtNem_FBZRobtonikStand
		dc.w $8CC0
		dc.l ArtNem_FBZRobtonikRun
		dc.w $9520
		dc.l ArtNem_BossExplosion
		dc.w $A000
PLC_705D0:	dc.w 3
		dc.l ArtNem_FBZ2Subboss
		dc.w $A5C0
		dc.l ArtNem_EggRoboStand
		dc.w $8CC0
		dc.l ArtNem_EggRoboRun
		dc.w $9520
		dc.l ArtNem_BossExplosion
		dc.w $A000
; ---------------------------------------------------------------------------

Obj_FBZEndBoss:

		move.l	#Obj_Wait,(a0)
		move.b	#1,($FFFFF7AA).w
		move.w	#$77,$2E(a0)
		move.l	#loc_70632,$34(a0)
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_70620
		move.l	#Obj_Song_Fade_Transition,(a1)
		move.b	#$19,$2C(a1)

loc_70620:
		moveq	#$6F,d0
		jsr	(Load_PLC).l
		lea	Pal_FBZEndBoss(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_70632:
		move.l	#loc_7063A,(a0)

locret_70638:
		rts
; ---------------------------------------------------------------------------

loc_7063A:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_70652(pc,d0.w),d1
		jsr	off_70652(pc,d1.w)
		bsr.w	sub_70E10
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_70652:	dc.w loc_7065C-off_70652

		dc.w loc_706AC-off_70652
		dc.w loc_706E2-off_70652
		dc.w loc_7071A-off_70652
		dc.w loc_707BC-off_70652
; ---------------------------------------------------------------------------

loc_7065C:
		lea	ObjDat3_70E8C(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#8,$29(a0)
		move.b	#-$80,$3C(a0)
		move.w	($FFFFEE80).w,d0
		addi.w	#$A0,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE84).w,d0
		subi.w	#$60,d0
		move.w	d0,$14(a0)
		lea	(ChildObjDat_681AC).l,a2
		jsr	(CreateChild1_Normal).l
		bne.s	loc_706A2
		move.b	#$B,$2C(a1)
		move.w	a1,$3E(a0)

loc_706A2:
		lea	ChildObjDat_70EE0(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_706AC:
		jsr	(MoveSprite).l
		move.w	#$690,d0
		subi.w	#$48,d0
		cmp.w	$14(a0),d0
		bls.s	loc_706C2
		rts
; ---------------------------------------------------------------------------

loc_706C2:
		move.w	d0,$14(a0)
		move.b	#4,5(a0)
		bset	#7,$38(a0)
		move.w	#$5F,$2E(a0)
		move.l	#loc_70700,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_706E2:
		bsr.w	sub_70C72
		addq.b	#4,$3C(a0)
		lea	(byte_710C2).l,a2
		jsr	(MoveSprite_AngleYLookup).l
		bsr.w	sub_70DC8
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_70700:

		move.b	#6,5(a0)
		bset	#3,$38(a0)
		move.w	#$3F,$2E(a0)
		move.b	#9,$39(a0)
		rts
; ---------------------------------------------------------------------------

loc_7071A:
		bsr.w	sub_70DAC
		jsr	(Find_SonicTails).l
		cmpi.b	#2,($FFFFB038).w
		bne.s	loc_70736
		bset	#1,$38(a0)
		bra.w	loc_7075A
; ---------------------------------------------------------------------------

loc_70736:
		btst	#1,$38(a0)
		bne.s	locret_70788
		btst	#0,$38(a0)
		bne.s	loc_7075A
		cmpi.w	#$18,d2
		bcc.s	loc_7075A
		btst	#1,$2A(a1)
		bne.s	loc_7075A
		ori.b	#3,$38(a0)

loc_7075A:

		subq.w	#1,$2E(a0)
		bpl.s	locret_70788
		move.w	#$1F,$2E(a0)
		bclr	#0,$38(a0)
		subq.b	#1,$39(a0)
		bmi.s	loc_7078A
		bset	#3,$38(a0)
		bclr	#0,4(a0)
		tst.w	d0
		bne.s	locret_70788
		bset	#0,4(a0)

locret_70788:

		rts
; ---------------------------------------------------------------------------

loc_7078A:
		move.b	#8,5(a0)
		bset	#2,$38(a0)
		move.l	#loc_707EC,$34(a0)
		moveq	#2,d0
		move.w	#$1FF,d1
		cmpi.b	#2,($FFFFB038).w
		bne.s	loc_707B2
		moveq	#2,d0
		move.w	#$FF,d1

loc_707B2:
		move.b	d0,$40(a0)
		move.w	d1,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_707BC:
		cmpi.b	#2,($FFFFB038).w
		bne.s	loc_707CA
		bset	#1,$38(a0)

loc_707CA:
		bsr.w	sub_70C72
		move.b	$40(a0),d0
		add.b	d0,$3C(a0)
		lea	(byte_710C2).l,a2
		jsr	(MoveSprite_AngleYLookup).l
		bsr.w	sub_70DC8
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_707EC:
		bclr	#2,$38(a0)
		bra.w	loc_70700
; ---------------------------------------------------------------------------

loc_707F6:
		tst.b	$3C(a0)
		beq.s	loc_7081A
		move.b	$40(a0),d0
		add.b	d0,$3C(a0)
		lea	(byte_710C2).l,a2
		jsr	(MoveSprite_AngleYLookup).l
		bsr.w	sub_70DC8
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7081A:
		move.l	#Wait_FadeToLevelMusic,(a0)
		move.w	#$200,8(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_70836,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_70836:
		move.l	#Obj_Wait,(a0)
		bset	#4,$38(a0)
		move.l	#loc_70854,$34(a0)
		lea	ChildObjDat_70F0A(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_70854:
		move.l	#Obj_Wait,(a0)
		bclr	#7,4(a0)
		move.w	#$7F,$2E(a0)
		move.l	#loc_70870,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_70870:
		move.l	#loc_708AA,(a0)
		st	($FFFFFAA8).w
		clr.b	($FFFFF7AA).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_70898
		move.l	#Obj_81,(a1)
		move.w	#$307C,$10(a1)
		move.w	#$660,$14(a1)

loc_70898:
		move.w	#$2FDC,($FFFFFA92).w
		lea	(Child6_IncLevX).l,a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_708AA:
		move.w	($FFFFEE78).w,($FFFFEE14).w
		tst.b	($FFFFFAA8).w
		bne.w	locret_70638
		move.l	#loc_7092A,(a0)
		jsr	(Restore_PlayerControl).l
		clr.w	($FFFFF602).w
		st	($FFFFF7CA).w
		clr.w	$2E(a0)
		lea	($FFFFB04A).w,a1
		jsr	(Restore_PlayerControl2).l
		jsr	(Obj_PlayLevelMusic).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_708EE
		move.l	#loc_863C0,(a1)

loc_708EE:
		move.w	#$1000,($FFFFEE12).w
		move.w	#$3738,($FFFFFA92).w
		lea	(Child6_IncLevX).l,a2
		jsr	(CreateChild6_Simple).l

loc_70906:
		lea	word_7091C(pc),a6
		move.w	(a6)+,d6

loc_7090C:
		movea.l	(a6)+,a1
		move.w	(a6)+,d2
		jsr	(Queue_Kos_Module).l
		dbf	d6,loc_7090C
		rts
; ---------------------------------------------------------------------------
word_7091C:	dc.w 1
		dc.l ArtKosM_FBZExitDoor
		dc.w $7CA0
		dc.l ArtKosM_FBZExitHall
		dc.w $7E80
; ---------------------------------------------------------------------------

loc_7092A:
		cmpi.w	#$720,($FFFFEE7C).w
		bcc.s	loc_70938
		jmp	(loc_86334).l
; ---------------------------------------------------------------------------

loc_70938:
		move.w	#$800,d0
		jsr	(StartNewLevel).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_70948:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7095C(pc,d0.w),d1
		jsr	off_7095C(pc,d1.w)
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_7095C:	dc.w loc_70966-off_7095C

		dc.w loc_70990-off_7095C
		dc.w loc_709A8-off_7095C
		dc.w loc_70A0C-off_7095C
		dc.w loc_70A28-off_7095C
; ---------------------------------------------------------------------------

loc_70966:
		lea	word_70E98(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		lea	ChildObjDat_70EF4(pc),a2
		jsr	(CreateChild1_Normal).l
		movea.w	$46(a0),a1
		tst.b	$2C(a0)
		bne.s	loc_7098A
		move.w	a0,$44(a1)
		rts
; ---------------------------------------------------------------------------

loc_7098A:
		move.w	a0,$46(a1)
		rts
; ---------------------------------------------------------------------------

loc_70990:
		movea.w	$46(a0),a1
		btst	#7,$38(a1)
		bne.s	loc_709A2
		jmp	(Refresh_ChildPosition).l
; ---------------------------------------------------------------------------

loc_709A2:
		move.b	#4,5(a0)

loc_709A8:
		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		bne.s	loc_709EC
		btst	#3,$38(a1)
		bne.s	loc_709BE
		rts
; ---------------------------------------------------------------------------

loc_709BE:
		move.b	#6,5(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		btst	#0,4(a1)
		beq.s	loc_709D6
		addq.w	#8,d0

loc_709D6:
		lea	word_709FC(pc,d0.w),a1
		move.w	(a1)+,$18(a0)
		move.w	(a1)+,$2E(a0)
		move.l	#loc_70A12,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_709EC:
		lea	ChildObjDat_70F24(pc),a2
		jsr	(CreateChild1_Normal).l
		jmp	(Go_Delete_Sprite_2).l
; ---------------------------------------------------------------------------
word_709FC:	dc.w   $100,	 7
		dc.w   $100,	 0
		dc.w  $FF00,	 0
		dc.w  $FF00,	 7
; ---------------------------------------------------------------------------

loc_70A0C:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_70A12:
		move.b	#8,5(a0)
		move.w	#7,$2E(a0)
		move.l	#loc_70A34,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_70A28:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_70A34:
		move.b	#4,5(a0)
		movea.w	$46(a0),a1
		bclr	#3,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_70A46:
		lea	word_70E9E(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_70A76,(a0)
		movea.w	$46(a0),a1
		tst.b	$2C(a1)
		beq.s	loc_70A66
		bset	#0,4(a0)

loc_70A66:
		move.w	$46(a1),$44(a0)
		lea	ChildObjDat_70EFC(pc),a2
		jsr	(CreateChild3_NormalRepeated).l

loc_70A76:
		movea.w	$44(a0),a1
		move.b	$3C(a1),$3C(a0)
		movea.w	$46(a0),a1
		move.w	$10(a1),$10(a0)
		lea	(byte_71102).l,a2
		jsr	(MoveSprite_AngleYLookup).l
		bsr.w	sub_70DFA
		moveq	#0,d0
		jmp	(Child_Draw_Sprite2_FlickerMove).l
; ---------------------------------------------------------------------------

loc_70AA2:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_70AB8(pc,d0.w),d1
		jsr	off_70AB8(pc,d1.w)
		moveq	#8,d0
		jmp	(Child_Draw_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------
off_70AB8:	dc.w loc_70ABC-off_70AB8

		dc.w loc_70AF2-off_70AB8
; ---------------------------------------------------------------------------

loc_70ABC:
		lea	word_70E9E(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		movea.w	$46(a0),a1
		moveq	#-$1C,d0
		btst	#0,4(a1)
		beq.s	loc_70ADC
		bset	#0,4(a0)
		neg.w	d0

loc_70ADC:
		movea.w	$46(a1),a1
		move.w	$46(a1),$44(a0)
		move.b	d0,$42(a0)
		move.b	#2,$43(a0)
		rts
; ---------------------------------------------------------------------------

loc_70AF2:
		jsr	(Child_GetPriority).l
		bra.w	loc_70C8E
; ---------------------------------------------------------------------------

loc_70AFC:
		lea	word_70EA4(pc),a1
		jsr	(SetUp_ObjAttributes3).l

loc_70B06:
		move.l	#loc_70B18,(a0)
		movea.w	$46(a0),a1
		bclr	#1,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_70B18:
		jsr	(Child_GetPriority).l
		btst	#7,$2A(a1)
		bne.s	loc_70B58
		btst	#1,$38(a1)
		beq.s	loc_70B4C
		move.l	#loc_70B74,(a0)
		move.w	#$5F,$2E(a0)
		move.l	#loc_70B06,$34(a0)
		lea	ChildObjDat_70F04(pc),a2
		jsr	(CreateChild6_Simple).l

loc_70B4C:
		jsr	(Refresh_ChildPosition).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_70B58:
		move.l	#loc_70B80,(a0)
		move.w	$3E(a1),$46(a0)
		subq.b	#4,$43(a0)
		jsr	(Refresh_ChildPosition).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_70B74:
		jsr	(Child_GetPriority).l
		jmp	(Refresh_ChildPosWait).l
; ---------------------------------------------------------------------------

loc_70B80:
		jsr	(Refresh_ChildPosition).l
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------

loc_70B8C:
		bsr.w	sub_70D10
		move.l	#Obj_Wait,(a0)
		move.l	#loc_70BA0,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_70BA0:
		move.l	#loc_70BB0,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_70BB0:
		moveq	#$4F,d0
		jsr	(sub_85E52).l
		jsr	(Child_GetPriority).l
		jsr	(Refresh_ChildPosition).l
		jsr	(Animate_RawMultiDelay).l
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_70BD0:

		lea	word_70EAA(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		jsr	(Refresh_ChildPositionAdjusted).l
		move.l	#Obj_FlickerMove,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		addi.b	#8,d0
		move.b	d0,$22(a0)
		moveq	#$34,d0
		jmp	(Set_IndexedVelocity).l
; ---------------------------------------------------------------------------

loc_70BFE:

		lea	word_70EAA(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		jsr	(Refresh_ChildPositionAdjusted).l
		move.l	#Obj_FlickerMove,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		addi.b	#$C,d0
		move.b	d0,$22(a0)
		moveq	#8,d0
		jmp	(Set_IndexedVelocity).l
; ---------------------------------------------------------------------------

Obj_FBZExitDoor:
		lea	ObjDat_FBZExitDoor(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_70C3C,(a0)

loc_70C3C:
		jsr	(Check_PlayerCollision).l
		bne.s	loc_70C4A
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_70C4A:
		move.l	#loc_70C66,(a0)
		move.w	#$800,$18(a0)
		lea	($FFFFB000).w,a1
		subq.w	#8,$10(a1)
		moveq	#$5D,d0
		jsr	(Play_Sound_2).l

loc_70C66:
		jsr	(MoveSprite_LightGravity).l
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_70C72:

		cmpi.w	#4,$2E(a0)
		bcs.s	locret_70C8C
		move.b	$3C(a0),d0
		andi.b	#$7F,d0
		bne.s	locret_70C8C
		moveq	#-$37,d0
		jsr	(Play_Sound_2).l

locret_70C8C:

		rts
; End of function sub_70C72

; ---------------------------------------------------------------------------

loc_70C8E:
		movea.w	$44(a0),a1
		movea.w	$46(a0),a2
		move.w	$10(a1),d0
		move.b	$42(a0),d1
		ext.w	d1
		add.w	d0,d1
		move.w	$10(a2),d2
		sub.w	d2,d1
		moveq	#$10,d3
		moveq	#0,d4
		move.b	$2C(a0),d4
		bsr.w	sub_70CE4
		move.w	$14(a1),d0
		move.b	$43(a0),d1
		ext.w	d1
		add.w	d0,d1
		move.w	$14(a2),d2
		sub.w	d2,d1
		moveq	#$14,d3
		bsr.w	sub_70CE4
		tst.b	$3C(a2)
		beq.s	locret_70CDA
		bmi.s	locret_70CDA
		move.w	word_70CDC(pc,d4.w),8(a0)

locret_70CDA:

		rts
; ---------------------------------------------------------------------------
word_70CDC:	dc.w $180
		dc.w $100
		dc.w $80
		dc.w 0

; =============== S U B R O U T I N E =======================================


sub_70CE4:

		move.w	off_70CEC(pc,d4.w),d5
		jmp	off_70CEC(pc,d5.w)
; End of function sub_70CE4

; ---------------------------------------------------------------------------
off_70CEC:	dc.w loc_70CF4-off_70CEC

		dc.w loc_70CFA-off_70CEC
		dc.w loc_70D00-off_70CEC
		dc.w loc_70D08-off_70CEC
; ---------------------------------------------------------------------------

loc_70CF4:
		asr.w	#2,d1
		bra.w	loc_70D08
; ---------------------------------------------------------------------------

loc_70CFA:
		asr.w	#1,d1
		bra.w	loc_70D08
; ---------------------------------------------------------------------------

loc_70D00:
		asr.w	#1,d1
		move.w	d1,d0
		asr.w	#1,d1
		add.w	d0,d1

loc_70D08:


		add.w	d1,d2
		move.w	d2,(a0,d3.w)
		rts

; =============== S U B R O U T I N E =======================================


sub_70D10:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_70D40(pc,d0.w),$2E(a0)
		move.w	word_70D52(pc,d0.w),$42(a0)
		add.w	d0,d0
		move.l	off_70D64(pc,d0.w),$30(a0)
		movea.l	off_70D88(pc,d0.w),a1
		jsr	(SetUp_ObjAttributes).l
		bset	#4,$2B(a0)
		jmp	(Refresh_ChildPosition).l
; End of function sub_70D10

; ---------------------------------------------------------------------------
word_70D40:	dc.w $50
		dc.w $4D
		dc.w $4A
		dc.w $47
		dc.w $44
		dc.w $41
		dc.w $3E
		dc.w $3B
		dc.w 0
word_70D52:	dc.w $98
		dc.w $8A4
		dc.w $F8A4
		dc.w $B4
		dc.w $C4
		dc.w $D4
		dc.w $E4
		dc.w $F4
		dc.w $F0
off_70D64:	dc.l byte_70F70
		dc.l byte_70F70
		dc.l byte_70F70
		dc.l byte_70F61
		dc.l byte_70F61
		dc.l byte_70F61
		dc.l byte_70F61
		dc.l byte_70F61
		dc.l byte_70F3E
off_70D88:	dc.l ObjDat3_70EC8
		dc.l ObjDat3_70EC8
		dc.l ObjDat3_70EC8
		dc.l ObjDat3_70EBC
		dc.l ObjDat3_70EBC
		dc.l ObjDat3_70EBC
		dc.l ObjDat3_70EBC
		dc.l ObjDat3_70EBC
		dc.l ObjDat3_70EB0

; =============== S U B R O U T I N E =======================================


sub_70DAC:
		movea.w	$44(a0),a1
		movea.w	$46(a0),a2
		move.w	$10(a1),d0
		move.w	$10(a2),d1
		sub.w	d0,d1
		asr.w	#1,d1
		add.w	d1,d0
		move.w	d0,$10(a0)
		rts
; End of function sub_70DAC


; =============== S U B R O U T I N E =======================================


sub_70DC8:

		tst.b	$3C(a0)
		beq.s	loc_70DEC
		bmi.s	loc_70DDE
		bset	#7,$A(a0)
		move.w	#0,8(a0)
		rts
; ---------------------------------------------------------------------------

loc_70DDE:
		bclr	#7,$A(a0)
		move.w	#$300,8(a0)
		rts
; ---------------------------------------------------------------------------

loc_70DEC:
		bset	#7,$A(a0)
		move.w	#$300,8(a0)
		rts
; End of function sub_70DC8


; =============== S U B R O U T I N E =======================================


sub_70DFA:
		tst.b	$3C(a0)
		beq.s	loc_70DEC
		bmi.s	loc_70DDE
		bset	#7,$A(a0)
		move.w	#$200,8(a0)
		rts
; End of function sub_70DFA


; =============== S U B R O U T I N E =======================================


sub_70E10:
		tst.l	(a0)
		beq.s	locret_70E66
		tst.b	$28(a0)
		bne.s	locret_70E66
		tst.b	$29(a0)
		beq.s	loc_70E68
		tst.b	$20(a0)
		bne.s	loc_70E34
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l

loc_70E34:
		bset	#6,$2A(a0)
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_70E46
		addq.w	#8,d0

loc_70E46:
		lea	word_70E74(pc),a1
		lea	word_70E7C(pc,d0.w),a2
		jsr	(CopyWordData_4).l
		subq.b	#1,$20(a0)
		bne.s	locret_70E66
		bclr	#6,$2A(a0)
		move.b	$25(a0),$28(a0)

locret_70E66:
		rts
; ---------------------------------------------------------------------------

loc_70E68:
		move.l	#loc_707F6,(a0)
		jmp	(BossDefeated_StopTimer).l
; End of function sub_70E10

; ---------------------------------------------------------------------------
word_70E74:	dc.w $FC26
		dc.w $FC28
		dc.w $FC32
		dc.w $FC3C
word_70E7C:	dc.w	$2A,   $26,   $20,  $644
		dc.w   $888,  $AAA,  $EEE,  $AAA
ObjDat3_70E8C:	dc.l Map_FBZEndBoss
		dc.w $A400
		dc.w $200
		dc.b $28
		dc.b $18
		dc.b 0
		dc.b $16
word_70E98:	dc.w $280
		dc.b $10
		dc.b $20
		dc.b 1
		dc.b $A3
word_70E9E:	dc.w $200

		dc.b 8
		dc.b 8
		dc.b 2
		dc.b 0
word_70EA4:	dc.w $180
		dc.b $C
		dc.b 8
		dc.b 3
		dc.b 0
word_70EAA:	dc.w $80

		dc.b $14
		dc.b $10
		dc.b 8
		dc.b 0
ObjDat3_70EB0:	dc.l Map_FBZEndBoss
		dc.w $8400
		dc.w 0
		dc.b 4
		dc.b 8
		dc.b 4
		dc.b $8B
ObjDat3_70EBC:	dc.l Map_BossExplosion
		dc.w $8500
		dc.w 0
		dc.b $10
		dc.b $10
		dc.b 0
		dc.b $8B
ObjDat3_70EC8:	dc.l Map_FBZEndBossFlame
		dc.w $8450
		dc.w 0
		dc.b $10
		dc.b $10
		dc.b 0
		dc.b $8B
ObjDat_FBZExitDoor:	dc.l Map_FBZExitDoor
		dc.w $43E5
		dc.w $80
		dc.b 8
		dc.b $20
		dc.b 0
		dc.b $D7
ChildObjDat_70EE0:dc.w 2
		dc.l loc_70948
		dc.w $D048
		dc.l loc_70948
		dc.w $3048
		dc.l loc_70AFC
		dc.w $D8
ChildObjDat_70EF4:dc.w 0
		dc.l loc_70A46
		dc.w $E0
ChildObjDat_70EFC:dc.w 3
		dc.l loc_70AA2
		dc.w 0
ChildObjDat_70F04:dc.w 8
		dc.l loc_70B8C
ChildObjDat_70F0A:dc.w 3
		dc.l loc_70BD0
		dc.w $EC08
		dc.l loc_70BD0
		dc.w $1408
		dc.l loc_70BD0
		dc.w $F020
		dc.l loc_70BD0
		dc.w $1020
ChildObjDat_70F24:dc.w 3
		dc.l loc_70BFE
		dc.w $F8F0
		dc.l loc_70BFE
		dc.w $8F0
		dc.l loc_70BFE
		dc.w $F810
		dc.l loc_70BFE
		dc.w $810
byte_70F3E:	dc.b	4,   3
		dc.b	4,   3
		dc.b	5,   3
		dc.b	6,   3
		dc.b	7,   3
		dc.b	4,   3
		dc.b	5,   3
		dc.b	6,   3
		dc.b	7,   3
		dc.b	4,   3
		dc.b	5,   3
		dc.b	6,   3
		dc.b	7,   3
		dc.b	4,   3
		dc.b	5,   3
		dc.b	6,   3
		dc.b	7,   3
		dc.b  $F4
byte_70F61:	dc.b	0,   2
		dc.b	0,   2
		dc.b	1,   2
		dc.b	2,   3
		dc.b	3,   4
		dc.b	4,   5
		dc.b	5,   6
		dc.b  $F4
byte_70F70:	dc.b	0,   2
		dc.b	0,   2
		dc.b	1,   3
		dc.b	2,   4
		dc.b	3,   5
		dc.b	4,   6
		dc.b  $F4,   0
Map_FBZExitDoor:	include "Levels\FBZ\Misc Object Data\Map - Exit Door.asm"

Pal_FBZEndBoss:	binclude "Levels\FBZ\Palettes\FBZ End Boss.bin"

Map_FBZEndBoss:	include "Levels\FBZ\Misc Object Data\Map - End Boss.asm"

Map_FBZEndBossFlame:	include "Levels\FBZ\Misc Object Data\Map - End Boss Flame.asm"

byte_710C2:	dc.b    0,   2,   4,   5,   7,   9,  $B,  $C,  $E, $10, $11, $13, $15, $17, $18, $1A, $1C, $1D, $1F, $20
		dc.b  $22, $23, $25, $27, $28, $29, $2B, $2C, $2E, $2F, $30, $32, $33, $34, $35, $37, $38, $39, $3A, $3B
		dc.b  $3C, $3D, $3E, $3F, $3F, $40, $41, $42, $43, $43, $44, $44, $45, $45, $46, $46, $47, $47, $47, $47
		dc.b  $48, $48, $48, $48
byte_71102:	dc.b    0,   1,   2,   2,   3,   4,   5,   5,   6,   7,   8,   9,   9,  $A,  $B,  $C,  $C,  $D,  $E,  $E
		dc.b   $F, $10, $10, $11, $12, $12, $13, $14, $14, $15, $15, $16, $17, $17, $18, $18, $19, $19, $1A, $1A
		dc.b  $1B, $1B, $1B, $1C, $1C, $1D, $1D, $1D, $1E, $1E, $1E, $1E, $1F, $1F, $1F, $1F, $1F, $20, $20, $20
		dc.b  $20, $20, $20, $20
word_71142:	dc.w 0
		dc.w $378
		dc.w $5F0
		dc.w $7F0
		dc.w $2B8
		dc.w $2B8
		dc.w $6F0
		dc.w $6F0
word_71152:	dc.w $7C8
		dc.w $9C8
		dc.w $5F0
		dc.w $7F0
		dc.w $8C8
		dc.w $8C8
		dc.w $6F0
		dc.w $6F0
; ---------------------------------------------------------------------------

Obj_ICZMiniboss:
		cmpi.w	#$501,($FFFFEE4E).w
		beq.s	loc_711AA
		lea	word_71142(pc),a1
		tst.b	$2C(a0)
		beq.s	loc_71178
		lea	word_71152(pc),a1

loc_71178:
		jsr	(Check_CameraInRange).l
		move.b	#$2E,$26(a0)
		jsr	(sub_85D6A).l
		move.l	#loc_711B0,(a0)
		move.l	#loc_711B6,$34(a0)
		moveq	#$5F,d0
		jsr	(Load_PLC).l
		lea	Pal_ICZMiniboss(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_711AA:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_711B0:
		jmp	(loc_85CA4).l
; ---------------------------------------------------------------------------

loc_711B6:
		move.l	#loc_711BE,(a0)

locret_711BC:

		rts
; ---------------------------------------------------------------------------

loc_711BE:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_711D6(pc,d0.w),d1
		jsr	off_711D6(pc,d1.w)
		bsr.w	sub_718DA
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_711D6:	dc.w loc_711EC-off_711D6

		dc.w loc_7122A-off_711D6
		dc.w loc_71252-off_711D6
		dc.w loc_7127E-off_711D6
		dc.w loc_712C4-off_711D6
		dc.w loc_71300-off_711D6
		dc.w loc_7127E-off_711D6
		dc.w loc_7135E-off_711D6
		dc.w loc_7138A-off_711D6
		dc.w loc_713AC-off_711D6
		dc.w loc_7122A-off_711D6
; ---------------------------------------------------------------------------

loc_711EC:
		lea	ObjDat3_71960(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#6,$29(a0)
		move.w	#$200,$3E(a0)
		move.w	#$80,$1A(a0)
		move.w	#$BF,$2E(a0)
		move.l	#loc_71236,$34(a0)
		lea	ChildObjDat_719AA(pc),a2
		jsr	(CreateChild6_Simple).l
		lea	ChildObjDat_71984(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_7122A:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_71236:
		move.b	#4,5(a0)
		bset	#3,$38(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_71258,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_71252:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_71258:

		move.b	#6,5(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_7128A,$34(a0)
		lea	(word_71AE6).l,a1

loc_71272:
		lea	($FFFFFADE).w,a2
		move.l	(a1)+,(a2)+
		move.l	(a1)+,(a2)+
		clr.w	(a2)
		rts
; ---------------------------------------------------------------------------

loc_7127E:
		jsr	(Run_PalRotationScript).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7128A:
		bset	#2,$38(a0)
		move.w	#$7F,$2E(a0)
		move.l	#loc_712A8,$34(a0)
		moveq	#$74,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_712A8:
		move.b	#8,5(a0)
		move.w	#$300,$1A(a0)
		move.w	#7,$2E(a0)
		move.l	#loc_712D6,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_712C4:
		jsr	(MoveSprite2).l
		jsr	(Run_PalRotationScript).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_712D6:
		bsr.w	sub_7184E

loc_712DA:
		move.b	#$A,5(a0)
		move.w	#$300,$1A(a0)
		neg.w	$3E(a0)
		move.w	$3E(a0),$18(a0)
		move.w	#$5F,$2E(a0)
		moveq	#-$41,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_71300:
		jsr	(Run_PalRotationScript).l
		subq.w	#1,$2E(a0)
		bmi.s	loc_71318
		addi.w	#-$10,$1A(a0)
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_71318:
		move.b	#$C,5(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_7133A,$34(a0)
		rts
; ---------------------------------------------------------------------------
		jsr	(Run_PalRotationScript).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7133A:
		subq.b	#1,$39(a0)
		bpl.s	loc_712DA
		move.b	#$E,5(a0)
		bset	#1,$38(a0)
		move.w	($FFFFFAB4).w,d0
		addi.w	#$A0,d0
		cmp.w	$10(a0),d0
		scc	$43(a0)
		rts
; ---------------------------------------------------------------------------

loc_7135E:
		btst	#1,$38(a0)
		beq.s	loc_7136C
		jmp	(Run_PalRotationScript).l
; ---------------------------------------------------------------------------

loc_7136C:
		move.b	#$10,5(a0)
		bclr	#2,$38(a0)
		move.l	#loc_71390,($FFFFFADA).w
		lea	(word_71B52).l,a1
		bra.w	loc_71272
; ---------------------------------------------------------------------------

loc_7138A:
		jmp	(Run_PalRotationScript).l
; ---------------------------------------------------------------------------

loc_71390:
		move.b	#$12,5(a0)
		move.w	#$222,($FFFFFC34).w
		move.w	#$3F,$2E(a0)
		move.l	#loc_713B2,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_713AC:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_713B2:
		move.b	#$14,5(a0)
		move.w	#-$100,$1A(a0)
		clr.w	$18(a0)
		move.w	#$17,$2E(a0)
		move.l	#loc_713D2,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_713D2:
		move.b	#4,5(a0)
		move.w	#$FF,$2E(a0)
		move.l	#loc_71258,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_713E8:
		jsr	(Obj_EndSignControl).l
		movea.w	($FFFFFAAE).w,a1
		cmpi.l	#loc_8B660,(a1)
		bne.s	loc_71400
		bset	#5,$38(a1)

loc_71400:
		cmpi.b	#2,($FFFFB038).w
		beq.s	loc_71416
		jsr	(Create_New_Sprite).l
		bne.s	loc_71416
		move.l	#loc_71420,(a1)

loc_71416:

		lea	ChildObjDat_719B0(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_71420:
		move.l	#loc_71440,(a0)
		lea	(word_719FA).l,a1
		lea	($FFFFFADE).w,a2
		move.l	(a1)+,(a2)+
		move.l	(a1)+,(a2)+
		clr.w	(a2)
		move.l	#Go_Delete_Sprite,($FFFFFADA).w
		rts
; ---------------------------------------------------------------------------

loc_71440:
		jmp	(Run_PalRotationScript).l
; ---------------------------------------------------------------------------

loc_71446:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_71462(pc,d0.w),d1
		jsr	off_71462(pc,d1.w)
		jsr	(Refresh_ChildPosition).l
		moveq	#0,d0
		jmp	(Child_Draw_Sprite2_FlickerMove).l
; ---------------------------------------------------------------------------
off_71462:	dc.w loc_7146A-off_71462

		dc.w loc_71478-off_71462
		dc.w loc_71498-off_71462
		dc.w locret_714B6-off_71462
; ---------------------------------------------------------------------------

loc_7146A:
		lea	word_7196C(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		bra.w	loc_716B2
; ---------------------------------------------------------------------------

loc_71478:
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		bne.s	loc_71486
		rts
; ---------------------------------------------------------------------------

loc_71486:
		move.b	#4,5(a0)
		move.l	#loc_714AE,$34(a0)
		bra.w	loc_716C8
; ---------------------------------------------------------------------------

loc_71498:
		move.b	$18(a0),d0
		add.b	d0,$42(a0)
		move.b	$19(a0),d0
		add.b	d0,$43(a0)
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_714AE:
		move.b	#6,5(a0)
		rts
; ---------------------------------------------------------------------------

locret_714B6:
		rts
; ---------------------------------------------------------------------------

loc_714B8:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_714CE(pc,d0.w),d1
		jsr	off_714CE(pc,d1.w)
		moveq	#0,d0
		jmp	(Child_DrawTouch_Sprite2_FlickerMove).l
; ---------------------------------------------------------------------------
off_714CE:	dc.w loc_714E6-off_714CE

		dc.w loc_714F4-off_714CE
		dc.w loc_7151E-off_714CE
		dc.w loc_7155A-off_714CE
		dc.w loc_7157C-off_714CE
		dc.w loc_71594-off_714CE
		dc.w loc_715B4-off_714CE
		dc.w loc_71600-off_714CE
		dc.w loc_7155A-off_714CE
		dc.w loc_7164E-off_714CE
		dc.w loc_7155A-off_714CE
		dc.w locret_71688-off_714CE
; ---------------------------------------------------------------------------

loc_714E6:
		lea	ObjDat3_71972(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bra.w	loc_716F4
; ---------------------------------------------------------------------------

loc_714F4:
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		bne.s	loc_71502
		rts
; ---------------------------------------------------------------------------

loc_71502:
		move.b	#4,5(a0)
		move.w	#-$40,$1A(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_7153A,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7151E:
		moveq	#1,d0
		btst	#0,($FFFFFE0F).w
		beq.s	loc_7152A
		neg.w	d0

loc_7152A:
		add.w	d0,$10(a0)
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7153A:
		move.b	#6,5(a0)
		move.w	#$180,8(a0)
		bsr.w	sub_71740
		move.w	#$1F,$2E(a0)
		move.l	#loc_71566,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7155A:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_71566:
		move.b	#8,5(a0)
		move.b	#-$75,$28(a0)
		moveq	#-$41,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_7157C:
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		bne.s	loc_7158C
		bra.w	loc_7179E
; ---------------------------------------------------------------------------

loc_7158C:
		move.b	#$A,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_71594:
		movea.w	$46(a0),a1
		moveq	#0,d0
		tst.b	$43(a1)
		bne.s	loc_715A2
		moveq	#-$80,d0

loc_715A2:
		cmp.b	$3D(a0),d0
		beq.s	loc_715AC
		bra.w	loc_7179E
; ---------------------------------------------------------------------------

loc_715AC:
		move.b	#$C,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_715B4:
		addq.b	#4,$3C(a0)
		lea	(ICZMiniboss_OrbAngleLookup).l,a2
		jsr	(MoveSprite_AtAngleLookup).l
		moveq	#0,d0
		bsr.w	sub_717B8
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		beq.s	loc_715F0
		tst.b	$2C(a0)
		bne.w	locret_711BC
		moveq	#0,d0
		tst.b	$43(a1)
		bne.s	loc_715E8
		moveq	#-$80,d0

loc_715E8:
		cmp.b	$3C(a0),d0
		bne.w	locret_711BC

loc_715F0:
		move.b	#$E,5(a0)
		bclr	#1,$38(a1)
		bra.w	loc_7186A
; ---------------------------------------------------------------------------

loc_71600:
		move.b	$3C(a0),d0
		cmp.b	$42(a0),d0
		beq.s	loc_71620
		addq.b	#4,$3C(a0)
		lea	(ICZMiniboss_OrbAngleLookup).l,a2
		jsr	(MoveSprite_AtAngleLookup).l
		moveq	#0,d0
		bra.w	sub_717B8
; ---------------------------------------------------------------------------

loc_71620:
		move.b	#$10,5(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_71636,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_71636:
		move.b	#$12,5(a0)
		move.w	#$7F,$2E(a0)
		move.l	#loc_71654,$34(a0)
		bra.w	loc_718CA
; ---------------------------------------------------------------------------

loc_7164E:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_71654:
		move.b	#$14,5(a0)
		moveq	#$67,d0
		jsr	(Play_Sound_2).l
		move.w	#$400,$1A(a0)
		clr.w	$18(a0)
		move.w	#$45,$2E(a0)
		move.l	#loc_7167C,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7167C:
		move.b	#2,5(a0)
		clr.b	$28(a0)
		rts
; ---------------------------------------------------------------------------

locret_71688:
		rts
; ---------------------------------------------------------------------------

loc_7168A:

		lea	word_7197E(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#Obj_FlickerMove,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		addi.b	#$B,d0
		move.b	d0,$22(a0)
		moveq	#8,d0
		jmp	(Set_IndexedVelocity).l
; ---------------------------------------------------------------------------

loc_716B2:
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		move.b	RawAni_716C2(pc,d0.w),$22(a0)
		rts
; ---------------------------------------------------------------------------
RawAni_716C2:	dc.b	1,   9,	  3,   2,  $A,	 4
; ---------------------------------------------------------------------------

loc_716C8:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_716DC(pc,d0.w),$18(a0)
		move.w	word_716E8(pc,d0.w),$2E(a0)
		rts
; ---------------------------------------------------------------------------
word_716DC:	dc.w $FFFF
		dc.w $1FF
		dc.w 1
		dc.w $FFFF
		dc.w $1FF
		dc.w 1
word_716E8:	dc.w 2
		dc.w 2
		dc.w 3
		dc.w 6
		dc.w 6
		dc.w 8
; ---------------------------------------------------------------------------

loc_716F4:
		move.w	($FFFFFAB0).w,d0
		addi.w	#$D8,d0
		move.w	d0,$14(a0)

loc_71700:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_71730(pc,d0.w),d2
		jsr	(Random_Number).l
		andi.w	#7,d0
		subq.w	#3,d0
		add.w	d0,d2
		move.w	($FFFFFAB4).w,$10(a0)
		add.w	d2,$10(a0)
		swap	d0
		andi.w	#7,d0
		subq.w	#3,d0
		add.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------
word_71730:	dc.w $FFE0
		dc.w $20
		dc.w $60
		dc.w $A0
		dc.w $E0
		dc.w $120
		dc.w $160
		dc.w $1A0

; =============== S U B R O U T I N E =======================================


sub_71740:
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#4,d0
		move.b	d0,$3C(a0)
		move.w	$10(a0),d0
		move.w	$14(a0),d1
		movem.w	d0-d1,-(sp)
		lea	(ICZMiniboss_OrbAngleLookup).l,a2
		jsr	(MoveSprite_AtAngleLookup).l
		moveq	#0,d0
		moveq	#0,d1
		moveq	#0,d2
		moveq	#0,d3
		movem.w	(sp)+,d0-d1
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		move.w	d0,$10(a0)
		move.w	d1,$14(a0)
		swap	d0
		swap	d1
		swap	d2
		swap	d3
		sub.l	d0,d2
		sub.l	d1,d3
		lsl.l	#3,d2
		lsl.l	#3,d3
		swap	d2
		swap	d3
		move.w	d2,$18(a0)
		move.w	d3,$1A(a0)
		rts
; End of function sub_71740

; ---------------------------------------------------------------------------

loc_7179E:

		addq.b	#4,$3C(a0)
		lea	(ICZMiniboss_OrbAngleLookup).l,a2
		jsr	(MoveSprite_AtAngleLookup).l
		move.b	$3D(a0),d0
		addq.b	#1,d0
		move.b	d0,$3D(a0)

; =============== S U B R O U T I N E =======================================


sub_717B8:

		jsr	(GetSineCosine).l
		tst.w	d1
		bpl.s	loc_717C4
		neg.w	d1

loc_717C4:
		move.w	$14(a0),d2
		move.w	$14(a1),d4
		sub.w	d4,d2
		scs	d3
		bcc.s	loc_717D4
		neg.w	d2

loc_717D4:
		mulu.w	d1,d2
		lsr.l	#8,d2
		cmpi.b	#$40,$3D(a0)
		bcs.s	loc_717EA
		cmpi.b	#-$40,$3D(a0)
		bcc.s	loc_717EA
		not.b	d3

loc_717EA:

		tst.b	d3
		beq.s	loc_717F0
		neg.w	d2

loc_717F0:
		add.w	d2,d4
		move.w	d4,$14(a0)
		move.b	$3D(a0),d0
		spl	d3
		cmpi.b	#$40,$3C(a0)
		bcs.s	loc_7180E
		cmpi.b	#-$40,$3C(a0)
		bcc.s	loc_7180E
		not.b	d3

loc_7180E:

		move.b	#6,$22(a0)
		cmpi.b	#$20,d0
		bcs.s	loc_7183C
		cmpi.b	#$60,d0
		bcs.s	loc_7182C
		cmpi.b	#-$60,d0
		bcs.s	loc_7183C
		cmpi.b	#-$20,d0
		bcc.s	loc_7183C

loc_7182C:
		move.b	#5,$22(a0)
		tst.b	d3
		bne.s	loc_7183C
		move.b	#8,$22(a0)

loc_7183C:

		move.w	#$180,8(a0)
		tst.b	d3
		bne.s	locret_7184C
		move.w	#$300,8(a0)

locret_7184C:
		rts
; End of function sub_717B8


; =============== S U B R O U T I N E =======================================


sub_7184E:
		move.b	$3A(a0),d0
		addq.b	#1,$3A(a0)
		andi.w	#7,d0
		move.b	byte_71862(pc,d0.w),$39(a0)
		rts
; End of function sub_7184E

; ---------------------------------------------------------------------------
byte_71862:	dc.b 1
		dc.b 0
		dc.b 1
		dc.b 1
		dc.b 0
		dc.b 1
		dc.b 0
		dc.b 0
; ---------------------------------------------------------------------------

loc_7186A:
		movea.w	$46(a0),a1
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,d1
		lsr.w	#1,d1
		tst.b	$43(a1)
		bne.s	loc_71880
		addq.w	#8,d1

loc_71880:
		move.b	byte_7189A(pc,d1.w),$42(a0)
		add.w	d0,d0
		move.l	word_718AA(pc,d0.w),$18(a0)
		tst.b	$43(a1)
		bne.s	locret_71898
		neg.w	$18(a0)

locret_71898:
		rts
; ---------------------------------------------------------------------------
byte_7189A:	dc.b $60
		dc.b $5C
		dc.b $58
		dc.b $54
		dc.b $50
		dc.b $4C
		dc.b $48
		dc.b $44
		dc.b $E0
		dc.b $DC
		dc.b $D8
		dc.b $D4
		dc.b $D0
		dc.b $CC
		dc.b $C8
		dc.b $C4
word_718AA:	dc.w  $FD00, $FC00
		dc.w  $FE00, $FC00
		dc.w  $FF00, $FC00
		dc.w	  0, $FC00
		dc.w   $100, $FC00
		dc.w   $200, $FC00
		dc.w   $300, $FC00
		dc.w   $400, $FC00
; ---------------------------------------------------------------------------

loc_718CA:
		move.w	($FFFFFAB0).w,d0
		subi.w	#$40,d0
		move.w	d0,$14(a0)
		bra.w	loc_71700

; =============== S U B R O U T I N E =======================================


sub_718DA:
		tst.b	$28(a0)
		bne.s	locret_71924
		tst.b	$29(a0)
		beq.s	loc_71926
		tst.b	$20(a0)
		bne.s	loc_718FA
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l

loc_718FA:
		bset	#6,$2A(a0)
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_7190E
		addi.w	#4,d0

loc_7190E:
		bsr.w	sub_71946
		subq.b	#1,$20(a0)
		bne.s	locret_71924
		bclr	#6,$2A(a0)
		move.b	$25(a0),$28(a0)

locret_71924:

		rts
; ---------------------------------------------------------------------------

loc_71926:
		move.l	#Wait_FadeToLevelMusic,(a0)
		move.l	#loc_713E8,$34(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild1_Normal).l
		jmp	(BossDefeated_StopTimer).l
; End of function sub_718DA


; =============== S U B R O U T I N E =======================================


sub_71946:
		lea	word_71954(pc),a1
		lea	word_71958(pc,d0.w),a2
		jmp	(CopyWordData_2).l
; End of function sub_71946

; ---------------------------------------------------------------------------
word_71954:	dc.w $FC34
		dc.w $FC36
word_71958:	dc.w $222
		dc.w $20
		dc.w $EEE
		dc.w $EEE
ObjDat3_71960:	dc.l Map_ICZMiniboss
		dc.w $A4A9
		dc.w $280
		dc.b $18
		dc.b $18
		dc.b 0
		dc.b 6
word_7196C:	dc.w $280
		dc.b $10
		dc.b $C
		dc.b 1
		dc.b 0
ObjDat3_71972:	dc.l Map_ICZMiniboss
		dc.w $44A9
		dc.w $280
		dc.b $C
		dc.b $C
		dc.b 6
		dc.b 0
word_7197E:	dc.w $180
		dc.b $C
		dc.b $C
		dc.b $B
		dc.b 0
ChildObjDat_71984:dc.w 5
		dc.l loc_71446
		dc.w $F2F5
		dc.l loc_71446
		dc.w $EF5
		dc.l loc_71446
		dc.w $12
		dc.l loc_71446
		dc.w $F2F5
		dc.l loc_71446
		dc.w $EF5
		dc.l loc_71446
		dc.w $E
ChildObjDat_719AA:dc.w 7
		dc.l loc_714B8
ChildObjDat_719B0:dc.w 3
		dc.l loc_7168A
		dc.w $F4F4
		dc.l loc_7168A
		dc.w $CF4
		dc.l loc_7168A
		dc.w $F40C
		dc.l loc_7168A
		dc.b $C
		dc.b $C
		dc.b 0
		dc.b 3
		dc.b 1
		dc.b 3
		dc.b 2
		dc.b 3
		dc.b 3
		dc.b 3
		dc.b 4
		dc.b 3
		dc.b 5
		dc.b 3
		dc.b 6
		dc.b 3
		dc.b $F4
		dc.b 0
Pal_ICZMiniboss:	binclude "Levels\ICZ\Palettes\Miniboss.bin"

word_719FA:	dc.w 4
		dc.w 0
		dc.l word_71A04
		dc.w 0
word_71A04:	dc.w $FC62
		dc.w   $901,  $EEC,  $CC6,  $C80,  $C60,  $C40,	 $A40,	$820,  $620,  $200,  $600,     7,  $EEC,  $CC6,	 $C82,	$C80
		dc.w   $C40,  $A40,  $820,  $820,  $200,  $600,	    7,	$EEC,  $CC8,  $E82,  $C82,  $C40,  $C40,  $A20,	 $820,	$200
		dc.w   $600,	 7,  $EEE,  $EC8,  $EA4,  $C82,	 $C60,	$C40,  $A20,  $A20,  $400,  $600,     7,  $EEE,	 $EC8,	$EA4
		dc.w   $E82,  $C60,  $C40,  $C20,  $A20,  $400,	 $600,	   7,  $EEE,  $EC8,  $EA6,  $E82,  $C62,  $C40,	 $C20,	$C20
		dc.w   $600,  $800,	7,  $EEE,  $EE8,  $EC6,	 $EA2,	$C80,  $C60,  $C20,  $C20,  $600,  $A00,     7,	 $EEE,	$EEA
		dc.w   $EC6,  $EA4,  $C82,  $C60,  $C40,  $C20,	 $800,	$C00,	  7,  $EEE,  $EEA,  $EC8,  $EA4,  $C82,	 $C60,	$C40
		dc.w   $E20,  $A00,  $C00,     7,  $EEE,  $EEA,	 $EC8,	$EA4,  $C82,  $C60,  $C40,  $E20,  $A00,  $E00,	    7, $FFF4
word_71AE6:	dc.w 4
		dc.w 0
		dc.l word_71AF0
		dc.w 0
word_71AF0:	dc.w $FC34
		dc.w	  2,  $222,	7,  $C22,     0,  $EE0,	    0, $FFF8,	$14, $FC34,	2,  $222,     5,  $C22,	    0,	$EE0
		dc.w	  0, $FFF8,   $14, $FC34,     2,  $222,	    3,	$C22,	  0,  $EE0,	0, $FFF8,   $14, $FC34,	    2,	$222
		dc.w	  1,  $C22,	0,  $EE0,     0, $FFF8,	  $14, $FC34,	  0,  $222,	0,  $C22,     0,  $EE0,	    0, $FFFC
word_71B52:	dc.w 4
		dc.w 0
		dc.l word_71B5C
		dc.w 0
word_71B5C:	dc.w $FC34
		dc.w	  2,  $222,	1,  $C22,     0,  $EE0,	    0, $FFF8,	$14, $FC34,	2,  $222,     3,  $C22,	    0,	$EE0
		dc.w	  0, $FFF8,   $14, $FC34,     2,  $222,	    5,	$C22,	  0,  $EE0,	0, $FFF8,   $14, $FC34,	    2,	$222
		dc.w	  7,  $C22,	0,  $EE0,     0, $FFF8,	  $14, $FC34,	  4,  $222,	9,  $C22,     0,  $EE0,	    0, $FFF4
word_71BBE:	dc.w $2F8
		dc.w $6F8
		dc.w $4340
		dc.w $4490
word_71BC6:	dc.w $5F8
		dc.w $5F8
		dc.w $4390
		dc.w $4390
; ---------------------------------------------------------------------------

Obj_ICZEndBoss:
		lea	word_71BBE(pc),a1
		jsr	(Check_CameraInRange).l
		move.l	#loc_71C08,(a0)
		move.l	#loc_71C0E,$34(a0)
		lea	word_71BC6(pc),a1
		move.b	#$19,$26(a0)
		jsr	(sub_85D6A).l
		moveq	#$70,d0
		jsr	(Load_PLC).l
		lea	Pal_ICZEndBoss(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_71C08:
		jmp	(loc_85CA4).l
; ---------------------------------------------------------------------------

loc_71C0E:
		move.l	#loc_71C16,(a0)

locret_71C14:

		rts
; ---------------------------------------------------------------------------

loc_71C16:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_71C2E(pc,d0.w),d1
		jsr	off_71C2E(pc,d1.w)
		bsr.w	sub_7225C
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_71C2E:	dc.w loc_71C36-off_71C2E

		dc.w loc_71C78-off_71C2E
		dc.w loc_71CAA-off_71C2E
		dc.w loc_71D64-off_71C2E
; ---------------------------------------------------------------------------

loc_71C36:
		lea	ObjDat3_72306(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#8,$29(a0)
		move.w	#$80,$1A(a0)
		move.w	#$CF,$2E(a0)
		move.l	#loc_71C84,$34(a0)
		lea	(ChildObjDat_72336).l,a2
		jsr	(CreateChild1_Normal).l
		bne.s	loc_71C6E
		move.b	#9,$2C(a1)

loc_71C6E:
		lea	ChildObjDat_7233E(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_71C78:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_71C84:
		move.w	#$7FFF,$44(a0)
		bsr.w	sub_72120
		move.b	#4,5(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_71CEC,$34(a0)
		move.w	#$BF,$46(a0)
		rts
; ---------------------------------------------------------------------------

loc_71CAA:
		jsr	(Swing_UpAndDown).l
		subq.w	#1,$44(a0)
		bpl.s	loc_71CC6
		neg.w	$18(a0)
		bchg	#0,4(a0)
		move.w	#$17F,$44(a0)

loc_71CC6:
		jsr	(MoveSprite2).l
		cmpi.b	#2,($FFFFB038).w
		bne.s	loc_71CE6
		subq.w	#1,$46(a0)
		bpl.s	loc_71CE6
		move.w	#$7F,$46(a0)
		bchg	#2,$38(a0)

loc_71CE6:

		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_71CEC:
		bset	#2,$38(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_71D02,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_71D02:
		move.w	#$3F,$2E(a0)
		move.w	#-$80,$18(a0)
		move.w	#$17F,$44(a0)
		move.l	#loc_71D1E,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_71D1E:

		move.l	#loc_71D46,$34(a0)
		moveq	#$7F,d0
		jsr	(Play_Sound_2).l
		bsr.w	sub_7213A
		cmpi.w	#2,$26(a0)
		bne.w	locret_71C14
		lea	ChildObjDat_72352(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_71D46:
		bclr	#1,$38(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_71D1E,$34(a0)
		rts
; ---------------------------------------------------------------------------
		bclr	#2,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_71D64:
		subq.w	#1,$3C(a0)
		bmi.s	loc_71D78
		addi.l	#$8000,$14(a0)
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_71D78:
		move.b	#4,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_71D80:
		move.l	#Obj_Wait,(a0)
		bset	#4,$38(a0)
		move.l	#loc_71D9E,$34(a0)
		lea	ChildObjDat_7236C(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_71D9E:
		move.l	#loc_71DE2,(a0)
		st	($FFFFFAA8).w
		clr.b	($FFFFF7AA).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_71DC6
		move.l	#Obj_81,(a1)
		move.w	#$4560,$10(a1)
		move.w	#$6A3,$14(a1)

loc_71DC6:
		move.w	($FFFFFAB4).w,d0
		addi.w	#$130,d0
		move.w	d0,($FFFFFA92).w
		jsr	(Create_New_Sprite).l
		bne.s	locret_71DE0
		move.l	#Obj_IncLevEndXGradual,(a1)

locret_71DE0:
		rts
; ---------------------------------------------------------------------------

loc_71DE2:
		move.w	($FFFFEE78).w,($FFFFEE14).w
		tst.b	($FFFFFAA8).w
		bne.w	locret_71C14
		clr.b	($FFFFFAA8).w
		jsr	(Restore_PlayerControl).l
		lea	($FFFFB04A).w,a1
		jsr	(Restore_PlayerControl2).l
		jsr	(Obj_PlayLevelMusic).l
		move.w	($FFFFFA98).w,($FFFFEE12).w
		move.w	#$47C0,($FFFFFA92).w
		lea	(Child6_IncLevX).l,a2
		jsr	(CreateChild6_Simple).l
		jmp	(Go_Delete_Sprite_2).l
; ---------------------------------------------------------------------------

loc_71E28:
		jsr	(Refresh_ChildPositionAdjusted).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_71E44(pc,d0.w),d1
		jsr	off_71E44(pc,d1.w)
		moveq	#$C,d0
		jmp	(Child_Draw_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------
off_71E44:	dc.w loc_71E4A-off_71E44

		dc.w loc_71E54-off_71E44
		dc.w loc_71E7C-off_71E44
; ---------------------------------------------------------------------------

loc_71E4A:
		lea	word_72312(pc),a1
		jmp	(SetUp_ObjAttributes3).l
; ---------------------------------------------------------------------------

loc_71E54:
		movea.w	$46(a0),a1
		tst.b	$3B(a1)
		bne.s	loc_71E60
		rts
; ---------------------------------------------------------------------------

loc_71E60:
		move.b	#4,5(a0)
		move.b	#4,$22(a0)
		move.w	#$E,$2E(a0)
		move.l	#loc_71E82,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_71E7C:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_71E82:
		move.w	#$17,$2E(a0)
		move.w	#6,$26(a0)
		lea	ChildObjDat_7235E(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_71E98:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_71EC4(pc,d0.w),d1
		jsr	off_71EC4(pc,d1.w)
		jsr	(Refresh_ChildPosition).l
		moveq	#0,d0
		movea.w	$46(a0),a1
		tst.b	$3B(a1)
		bne.s	loc_71EBE
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_71EBE:
		jmp	(loc_849D8).l
; ---------------------------------------------------------------------------
off_71EC4:	dc.w loc_71ECA-off_71EC4

		dc.w loc_71ED4-off_71EC4
		dc.w loc_71F10-off_71EC4
; ---------------------------------------------------------------------------

loc_71ECA:
		lea	word_72318(pc),a1
		jmp	(SetUp_ObjAttributes3).l
; ---------------------------------------------------------------------------

loc_71ED4:
		movea.w	$46(a0),a4
		move.b	$3A(a0),d0
		move.b	$38(a4),d1
		move.b	d1,$3A(a0)
		eor.b	d1,d0
		andi.b	#4,d0
		beq.s	locret_71F0E
		moveq	#1,d0
		btst	#2,d1
		bne.s	loc_71EF6
		neg.b	d0

loc_71EF6:
		move.b	d0,$40(a0)
		move.b	#4,5(a0)
		move.w	#$24,$2E(a0)
		move.l	#loc_71F1E,$34(a0)

locret_71F0E:
		rts
; ---------------------------------------------------------------------------

loc_71F10:
		move.b	$40(a0),d0
		add.b	d0,$43(a0)
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_71F1E:

		move.b	#2,5(a0)
		movea.w	$46(a0),a1
		move.b	$38(a1),$3A(a0)
		rts
; ---------------------------------------------------------------------------

loc_71F30:
		move.w	$10(a0),-(sp)
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_71F74(pc,d0.w),d1
		jsr	off_71F74(pc,d1.w)
		jsr	(Refresh_ChildPosition).l
		moveq	#$23,d1
		moveq	#4,d2
		moveq	#$A,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectFull).l
		moveq	#0,d0
		movea.w	$46(a0),a1
		tst.b	$3B(a1)
		bne.s	loc_71F68
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_71F68:
		jsr	(Displace_PlayerOffObject).l
		jmp	(loc_849D8).l
; ---------------------------------------------------------------------------
off_71F74:	dc.w loc_71F7A-off_71F74

		dc.w loc_71F92-off_71F74
		dc.w loc_71FDA-off_71F74
; ---------------------------------------------------------------------------

loc_71F7A:
		lea	word_7231E(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		movea.w	$46(a0),a1
		lea	ChildObjDat_72364(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_71F92:
		movea.w	$46(a0),a4
		btst	#1,$38(a4)
		beq.s	loc_71FA2
		bsr.w	loc_72006

loc_71FA2:
		move.b	$3A(a0),d0
		move.b	$38(a4),d1
		move.b	d1,$3A(a0)
		eor.b	d1,d0
		andi.b	#4,d0
		beq.s	locret_71FD8
		moveq	#1,d0
		btst	#2,d1
		bne.s	loc_71FC0
		neg.b	d0

loc_71FC0:
		move.b	d0,$40(a0)
		move.b	#4,5(a0)
		move.w	#$42,$2E(a0)
		move.l	#loc_71F1E,$34(a0)

locret_71FD8:
		rts
; ---------------------------------------------------------------------------

loc_71FDA:
		movea.w	$46(a0),a4
		btst	#1,$38(a4)
		beq.s	loc_71FEA
		bsr.w	loc_72006

loc_71FEA:
		move.b	$40(a0),d0
		add.b	d0,$43(a0)
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------
		move.b	#2,5(a0)
		move.b	$38(a4),$3A(a0)
		rts
; ---------------------------------------------------------------------------

loc_72006:

		move.w	$26(a4),d0
		cmpi.w	#2,d0
		beq.w	locret_71C14

loc_72012:
		move.w	d0,$26(a0)
		lea	ChildObjDat_72358(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_72020:

		lea	ObjDat3_72324(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#Obj_Wait,(a0)
		move.l	#loc_7203C,$34(a0)
		bra.w	loc_72168
; ---------------------------------------------------------------------------

loc_7203C:
		movea.w	$46(a0),a1
		move.l	#loc_7205E,(a0)
		cmpi.w	#6,$26(a1)
		bne.s	loc_72054
		move.l	#loc_72092,(a0)

loc_72054:
		move.l	#Go_Delete_Sprite,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7205E:
		jsr	(Refresh_ChildPosition).l
		jsr	(Animate_RawMultiDelay).l
		cmpi.b	#4,$23(a0)
		bcs.s	loc_72084
		cmpi.b	#8,$23(a0)
		bhi.s	loc_72084
		lea	word_7208A(pc),a1
		jsr	(sub_8A9C6).l

loc_72084:

		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------
word_7208A:	dc.w  $FFE8,   $30, $FFE8,   $30
; ---------------------------------------------------------------------------

loc_72092:
		jsr	(Refresh_ChildPositionAdjusted).l
		jsr	(Animate_RawMultiDelay).l
		cmpi.b	#4,$23(a0)
		bcs.s	loc_720B8
		cmpi.b	#8,$23(a0)
		bhi.s	loc_720B8
		lea	word_720BE(pc),a1
		jsr	(sub_8A9C6).l

loc_720B8:

		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------
word_720BE:	dc.w  $FFF0,   $20, $FFF0,   $20
; ---------------------------------------------------------------------------

loc_720C6:
		move.l	#loc_720D4,(a0)
		move.b	#-$65,$28(a0)
		rts
; ---------------------------------------------------------------------------

loc_720D4:
		jsr	(Refresh_ChildPosition).l
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_720EC
		jmp	(Add_SpriteToCollisionResponseList).l
; ---------------------------------------------------------------------------

loc_720EC:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_720F2:

		lea	word_72330(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		jsr	(Refresh_ChildPositionAdjusted).l
		move.l	#Obj_FlickerMove,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		addi.b	#$16,d0
		move.b	d0,$22(a0)
		moveq	#$34,d0
		jmp	(Set_IndexedVelocity).l

; =============== S U B R O U T I N E =======================================


sub_72120:
		move.w	#$C0,d0
		move.w	d0,$3E(a0)
		move.w	d0,$1A(a0)
		move.w	#$10,$40(a0)
		bclr	#0,$38(a0)
		rts
; End of function sub_72120


; =============== S U B R O U T I N E =======================================


sub_7213A:
		bset	#1,$38(a0)
		tst.b	$3B(a0)
		bne.s	loc_72160
		move.b	$3A(a0),d0
		andi.w	#$F,d0
		lea	byte_723D0(pc),a1
		move.b	(a1,d0.w),$27(a0)
		addq.b	#1,d0
		move.b	d0,$3A(a0)
		rts
; ---------------------------------------------------------------------------

loc_72160:
		move.w	#2,$26(a0)
		rts
; End of function sub_7213A

; ---------------------------------------------------------------------------

loc_72168:
		movea.w	$46(a0),a1
		move.w	$26(a1),d0
		moveq	#0,d1
		move.b	$2C(a0),d1
		lea	word_721F4(pc),a2
		move.w	(a2,d0.w),d2
		adda.w	d2,a2
		move.w	(a2,d1.w),$42(a0)
		lea	word_7222C(pc),a2
		move.w	(a2,d0.w),d2
		adda.w	d2,a2
		move.b	(a2,d1.w),d2
		or.b	d2,4(a0)
		lea	word_721C2(pc),a2
		move.w	(a2,d0.w),d2
		adda.w	d2,a2
		move.w	(a2,d1.w),$2E(a0)
		cmpi.b	#6,d0
		beq.s	loc_721B8
		add.w	d1,d1
		move.l	off_721D8(pc,d1.w),$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_721B8:
		move.l	#byte_7239C,$30(a0)
		rts
; ---------------------------------------------------------------------------
word_721C2:	dc.w	8
		dc.w   $A
		dc.w	8
		dc.w   $E
		dc.w  $11
		dc.w   $E
		dc.w   $B
		dc.w	8
		dc.w	5
		dc.w	2
		dc.w $FFFF
off_721D8:	dc.l byte_7238F
		dc.l byte_7238F
		dc.l byte_7238F
		dc.l byte_7238F
		dc.l byte_72380
		dc.l byte_72380
		dc.l byte_72380
word_721F4:	dc.w 8
		dc.w $16
		dc.w $22
		dc.w $30
		dc.w $B014
		dc.w $C014
		dc.w $B804
		dc.w $C004
		dc.w $CC0C
		dc.w $DC08
		dc.w $E404
		dc.w $840
		dc.w $3C
		dc.w $F040
		dc.w $F83C
		dc.w $FC34
		dc.w $FC28
		dc.w $5014
		dc.w $4014
		dc.w $4804
		dc.w $4004
		dc.w $340C
		dc.w $2408
		dc.w $1C04
		dc.w $18FC
		dc.w $1400
		dc.w $10F8
		dc.w $8FC
word_7222C:	dc.w 8
		dc.w $16
		dc.w $22
		dc.w $E
		dc.w $200
		dc.w $200
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w $100
		dc.w $100
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w $300
		dc.w $300
		dc.w $100
		dc.w $100
		dc.w $100
		dc.w $100
		dc.w $100

; =============== S U B R O U T I N E =======================================


sub_7225C:
		tst.b	$28(a0)
		bne.s	locret_722C4
		move.b	$29(a0),d0
		beq.s	loc_722C6
		tst.b	$20(a0)
		bne.s	loc_72292
		cmpi.b	#2,d0
		bne.s	loc_72284
		st	$3B(a0)
		move.b	#6,5(a0)
		move.w	#$7F,$3C(a0)

loc_72284:
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l

loc_72292:
		bset	#6,$2A(a0)
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_722A6
		addi.w	#4,d0

loc_722A6:
		bsr.w	sub_722EC
		subq.b	#1,$20(a0)
		bne.s	locret_722C4
		bclr	#6,$2A(a0)
		cmpi.b	#0,$22(a0)
		bne.s	locret_722C4
		move.b	$25(a0),$28(a0)

locret_722C4:

		rts
; ---------------------------------------------------------------------------

loc_722C6:
		move.l	#Wait_FadeToLevelMusic,(a0)
		move.l	#loc_71D80,$34(a0)
		movea.w	($FFFFFAAE).w,a1
		cmpi.l	#loc_8B660,(a1)
		bne.s	loc_722E6
		bset	#5,$38(a1)

loc_722E6:
		jmp	(BossDefeated_StopTimer).l
; End of function sub_7225C


; =============== S U B R O U T I N E =======================================


sub_722EC:
		lea	word_722FA(pc),a1
		lea	word_722FE(pc,d0.w),a2
		jmp	(CopyWordData_2).l
; End of function sub_722EC

; ---------------------------------------------------------------------------
word_722FA:	dc.w $FC34
		dc.w $FC3C
word_722FE:	dc.w $20
		dc.w $644
		dc.w $EEE
		dc.w $AAA
ObjDat3_72306:	dc.l Map_ICZEndBoss
		dc.w $A2A6
		dc.w $280
		dc.b $24
		dc.b $24
		dc.b 0
		dc.b $F
word_72312:	dc.w $200
		dc.b $14
		dc.b 8
		dc.b 3
		dc.b 0
word_72318:	dc.w $280
		dc.b 8
		dc.b $C
		dc.b 1
		dc.b 0
word_7231E:	dc.w $280
		dc.b $18
		dc.b $2C
		dc.b 2
		dc.b 0
ObjDat3_72324:	dc.l Map_ICZEndBoss
		dc.w $A2A6
		dc.w $80
		dc.b $10
		dc.b $10
		dc.b 5
		dc.b 0
word_72330:	dc.w $180
		dc.b $14
		dc.b $10
		dc.b 0
		dc.b 0
ChildObjDat_72336:dc.w 0
		dc.l Obj_RobotnikShip4
		dc.w 0
ChildObjDat_7233E:dc.w 2
		dc.l loc_71E28
		dc.w $1807
		dc.l loc_71E98
		dc.w $B
		dc.l loc_71F30
		dc.w $2D
ChildObjDat_72352:dc.w 5
		dc.l loc_72020
ChildObjDat_72358:dc.w 6
		dc.l loc_72020
ChildObjDat_7235E:dc.w 3
		dc.l loc_72020
ChildObjDat_72364:dc.w 0
		dc.l loc_720C6
		dc.w 8
ChildObjDat_7236C:dc.w 2
		dc.l loc_720F2
		dc.w $EC04
		dc.l loc_720F2
		dc.w $C04
		dc.l loc_720F2
		dc.w $1C
byte_72380:	dc.b	5,   1
		dc.b	5,   1
		dc.b	6,   1
		dc.b	7,   2
		dc.b	8,   3
		dc.b	9,   4
		dc.b   $A,   5
		dc.b  $F4
byte_7238F:	dc.b   $B,   2
		dc.b   $B,   2
		dc.b   $C,   3
		dc.b   $D,   4
		dc.b   $E,   5
		dc.b   $F,   6
		dc.b  $F4
byte_7239C:	dc.b  $10,   1
		dc.b  $10,   1
		dc.b  $11,   1
		dc.b  $12,   2
		dc.b  $13,   2
		dc.b  $14,   2
		dc.b  $15,   2
		dc.b  $F4,   5
		dc.b	0,   1
		dc.b  $FC,   0
Pal_ICZEndBoss:	binclude "Levels\ICZ\Palettes\End Boss.bin"

byte_723D0:	dc.b	0,   2
		dc.b	4,   2
		dc.b	0,   2
		dc.b	4,   2
		dc.b	0,   2
		dc.b	0,   2
		dc.b	4,   2
		dc.b	2,   4
; ---------------------------------------------------------------------------

Obj_LBZMiniboss:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_723F4(pc,d0.w),d1
		jsr	off_723F4(pc,d1.w)
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_723F4:	dc.w loc_72400-off_723F4

		dc.w loc_72452-off_723F4
		dc.w loc_72474-off_723F4
		dc.w loc_724BC-off_723F4
		dc.w loc_724E2-off_723F4
		dc.w loc_72558-off_723F4
; ---------------------------------------------------------------------------

loc_72400:
		lea	ObjDat3_72956(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#6,$29(a0)
		move.b	#1,($FFFFF7AA).w
		move.w	$10(a0),$3C(a0)
		move.w	#$10,$2E(a0)
		move.l	#loc_72458,$34(a0)
		lea	Pal_LBZMiniboss(pc),a1
		jsr	(PalLoad_Line1).l
		lea	ChildObjDat_7296E(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	ChildObjDat_72976(pc),a2
		jsr	(CreateChild4_LinkListRepeated).l
		lea	ChildObjDat_7297C(pc),a2
		jmp	(CreateChild4_LinkListRepeated).l
; ---------------------------------------------------------------------------

loc_72452:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_72458:
		move.b	#4,5(a0)
		move.w	#0,$1A(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_72480,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_72474:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_72480:
		move.b	#6,5(a0)
		bset	#1,$38(a0)
		lea	(byte_72982).l,a1
		lea	($FFFFFA82).w,a2
		moveq	#5,d6

loc_72498:
		move.b	(a1)+,(a2)+
		dbf	d6,loc_72498
		move.l	#-$57E,$30(a0)
		move.b	#$10,$24(a0)
		move.l	#loc_724C8,$34(a0)

loc_724B4:
		move.w	#$10,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_724BC:
		jsr	(Animate_Raw).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_724C8:
		lea	($FFFFFA82).w,a1
		subq.b	#1,(a1)
		cmpi.b	#2,(a1)
		bhi.s	loc_724B4
		move.b	#8,5(a0)
		move.b	#6,$28(a0)
		rts
; ---------------------------------------------------------------------------

loc_724E2:
		lea	($FFFFB000).w,a1
		moveq	#0,d0
		moveq	#0,d1
		move.w	$10(a0),d2
		cmpi.b	#2,($FFFFB038).w
		bne.s	loc_72502
		moveq	#$20,d4
		tst.b	$2C(a0)
		beq.s	loc_72500
		neg.w	d4

loc_72500:
		add.w	d4,d2

loc_72502:
		sub.w	$10(a1),d2
		bpl.s	loc_7250C
		neg.w	d2
		addq.w	#2,d0

loc_7250C:
		moveq	#0,d1
		move.w	$14(a0),d3
		move.w	$14(a1),d4
		subi.w	#$38,d4
		sub.w	d4,d3
		bpl.s	loc_72522
		neg.w	d3
		addq.w	#2,d1

loc_72522:
		move.w	word_72554(pc,d0.w),$18(a0)
		move.w	word_72554(pc,d1.w),$1A(a0)
		cmpi.w	#4,d2
		bhi.s	loc_72538
		clr.w	$18(a0)

loc_72538:
		cmpi.w	#4,d3
		bhi.s	loc_72542
		clr.w	$1A(a0)

loc_72542:
		jsr	(MoveSprite2).l
		jsr	(Animate_Raw).l
		jmp	(loc_72840).l
; ---------------------------------------------------------------------------
word_72554:	dc.w  $FF00,  $100
; ---------------------------------------------------------------------------

loc_72558:
		subq.w	#2,$14(a0)
		jmp	(loc_72840).l
; ---------------------------------------------------------------------------

loc_72562:
		cmpi.b	#2,($FFFFB038).w
		beq.s	loc_72584
		jsr	(Create_New_Sprite).l
		bne.s	loc_72578
		move.l	#Obj_Song_Fade_ToLevelMusic,(a1)

loc_72578:
		move.w	$3C(a0),$10(a0)
		jmp	(Obj_EndSignControl).l
; ---------------------------------------------------------------------------

loc_72584:
		movea.w	$46(a0),a1
		move.b	$2C(a0),d0
		bset	d0,$38(a1)
		jmp	(Go_Delete_Sprite_2).l
; ---------------------------------------------------------------------------

loc_72596:
		jsr	(Refresh_ChildPositionAdjusted).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_725B0(pc,d0.w),d1
		jsr	off_725B0(pc,d1.w)
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------
off_725B0:	dc.w loc_725B6-off_725B0

		dc.w loc_725CA-off_725B0
		dc.w loc_725E8-off_725B0
; ---------------------------------------------------------------------------

loc_725B6:
		lea	word_72962(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#byte_72988,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_725CA:
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		bne.s	loc_725D8
		rts
; ---------------------------------------------------------------------------

loc_725D8:
		move.b	#4,5(a0)
		move.l	#byte_72988,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_725E8:
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_725EE:
		bset	#2,$38(a0)

loc_725F4:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_72610(pc,d0.w),d1
		jsr	off_72610(pc,d1.w)
		tst.b	$2C(a0)
		bne.s	loc_7260C
		jmp	loc_728C8(pc)
; ---------------------------------------------------------------------------

loc_7260C:
		jmp	loc_72902(pc)
; ---------------------------------------------------------------------------
off_72610:	dc.w loc_7261C-off_72610

		dc.w loc_72658-off_72610
		dc.w loc_72688-off_72610
		dc.w loc_726E4-off_72610
		dc.w loc_7270E-off_72610
		dc.w loc_7278E-off_72610
; ---------------------------------------------------------------------------

loc_7261C:
		lea	word_72968(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.w	#$100,$2E(a0)
		move.l	#loc_72674,$34(a0)
		move.b	#4,$3D(a0)
		move.w	#5,$3E(a0)
		cmpi.b	#$A,$2C(a0)
		bne.s	loc_72654
		move.w	#4,$3E(a0)
		bset	#1,$38(a0)

loc_72654:
		bra.w	loc_727B0
; ---------------------------------------------------------------------------

loc_72658:
		tst.b	$2C(a0)
		bne.s	loc_72664
		jsr	(Refresh_ChildPositionAdjusted).l

loc_72664:
		move.w	$3E(a0),d2
		jsr	(MoveSprite_CircularSimple).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_72674:

		move.b	#4,5(a0)
		bsr.w	sub_7280C
		move.l	#loc_726B2,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_72688:
		btst	#1,$38(a0)
		beq.s	loc_726A8
		move.b	$3D(a0),d0
		add.b	d0,$3C(a0)
		move.w	$3E(a0),d2
		jsr	(MoveSprite_CircularSimple).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_726A8:
		move.w	$3E(a0),d2
		jmp	(MoveSprite_CircularSimple).l
; ---------------------------------------------------------------------------

loc_726B2:
		bsr.w	sub_72826
		move.l	#loc_72726,$34(a0)
		tst.b	$2C(a0)
		beq.s	loc_726DC
		move.b	#6,5(a0)
		movea.w	$46(a0),a1
		bset	#1,$38(a1)
		move.b	$3C(a1),$3C(a0)
		rts
; ---------------------------------------------------------------------------

loc_726DC:
		move.b	#8,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_726E4:
		movea.w	$46(a0),a1
		move.b	$3C(a1),$3C(a0)
		move.w	$3E(a0),d2
		jsr	(MoveSprite_CircularSimple).l
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		beq.s	loc_72706
		rts
; ---------------------------------------------------------------------------

loc_72706:
		move.b	#8,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_7270E:
		move.b	$3D(a0),d0
		add.b	d0,$3C(a0)
		jsr	(Obj_Wait).l
		move.w	$3E(a0),d2
		jmp	(MoveSprite_CircularSimple).l
; ---------------------------------------------------------------------------

loc_72726:
		bclr	#1,$38(a0)
		neg.b	$3D(a0)
		bsr.w	loc_72674
		cmpi.b	#$A,$2C(a0)
		bne.s	loc_72756
		move.b	#$A,5(a0)
		move.w	#$3C,$2E(a0)
		move.l	#loc_72674,$34(a0)
		bset	#1,$38(a0)

loc_72756:
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		moveq	#0,d1
		btst	#2,$38(a0)
		beq.s	loc_7276A
		addq.w	#8,d1

loc_7276A:
		tst.b	$3D(a0)
		bpl.s	loc_72772
		addq.w	#4,d1

loc_72772:
		movea.l	off_7277E(pc,d1.w),a1
		move.b	(a1,d0.w),$3C(a0)
		rts
; ---------------------------------------------------------------------------
off_7277E:	dc.l byte_727F4
		dc.l byte_727FA
		dc.l byte_72800
		dc.l byte_72806
; ---------------------------------------------------------------------------

loc_7278E:
		move.w	$3E(a0),d2
		jsr	(MoveSprite_CircularSimple).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7279E:
		jsr	(MoveSprite).l
		jsr	(Obj_Wait).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_727B0:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	byte_727E2(pc,d0.w),8(a0)
		lsr.w	#1,d0
		move.b	byte_727EE(pc,d0.w),$22(a0)
		move.b	byte_727F4(pc,d0.w),$3C(a0)
		btst	#2,$38(a0)
		beq.s	loc_727D8
		move.b	byte_72800(pc,d0.w),$3C(a0)

loc_727D8:
		move.w	$3E(a0),d2
		jmp	(MoveSprite_CircularSimple).l
; ---------------------------------------------------------------------------
byte_727E2:	dc.b	3,   0,	  3, $80
		dc.b	3,   0,	  3, $80
		dc.b	3,   0,	  2, $80
byte_727EE:	dc.b 7
		dc.b 8
		dc.b 7
		dc.b 8
		dc.b 7
		dc.b 6
byte_727F4:	dc.b $55
		dc.b 0
		dc.b $D5
		dc.b $AA
		dc.b $80
		dc.b $68
byte_727FA:	dc.b $2A
		dc.b $7A
		dc.b $B0
		dc.b $DA
		dc.b 0
		dc.b $18
byte_72800:	dc.b $D5
		dc.b $80
		dc.b $55
		dc.b $2A
		dc.b 0
		dc.b $F4
byte_72806:	dc.b $AA
		dc.b 0
		dc.b $2A
		dc.b $55
		dc.b $80
		dc.b $8C

; =============== S U B R O U T I N E =======================================


sub_7280C:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_7281A(pc,d0.w),$2E(a0)
		rts
; End of function sub_7280C

; ---------------------------------------------------------------------------
word_7281A:	dc.w 0
		dc.w $14
		dc.w 9
		dc.w 9
		dc.w 9
		dc.w 5

; =============== S U B R O U T I N E =======================================


sub_72826:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_72834(pc,d0.w),$2E(a0)
		rts
; End of function sub_72826

; ---------------------------------------------------------------------------
word_72834:	dc.w $34
		dc.w $14
		dc.w 9
		dc.w 9
		dc.w 9
		dc.w 3
; ---------------------------------------------------------------------------

loc_72840:

		tst.b	$28(a0)
		bne.s	locret_72898
		tst.b	$29(a0)
		beq.s	loc_7289A
		cmpi.b	#3,$29(a0)
		bne.s	loc_7285A
		bset	#0,$38(a0)

loc_7285A:
		tst.b	$20(a0)
		bne.s	loc_7287A
		move.b	5(a0),$3A(a0)
		move.b	#$A,5(a0)
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l

loc_7287A:
		jsr	(BossFlash).l
		subq.b	#1,$20(a0)
		bne.s	locret_72898
		move.b	$3A(a0),5(a0)
		move.w	#$EEE,($FFFFFC22).w
		move.b	$25(a0),$28(a0)

locret_72898:

		rts
; ---------------------------------------------------------------------------

loc_7289A:
		move.l	#Wait_NewDelay,(a0)
		move.l	#loc_72562,$34(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild1_Normal).l
		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_728C2
		jmp	(BossDefeated_StopTimer).l
; ---------------------------------------------------------------------------

loc_728C2:
		jmp	(BossDefeated).l
; ---------------------------------------------------------------------------

loc_728C8:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_728EA
		btst	#0,$38(a1)
		beq.s	loc_728E4
		btst	#2,$38(a0)
		bne.s	loc_728EA

loc_728E4:
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_728EA:

		move.w	$44(a0),d0
		beq.s	loc_728F8
		movea.w	d0,a1
		bset	#7,$2A(a1)

loc_728F8:
		bsr.w	sub_72910
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_72902:
		btst	#7,$2A(a0)
		bne.s	loc_728EA
		jmp	(Draw_And_Touch_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_72910:
		move.l	#loc_7279E,(a0)
		clr.b	$28(a0)
		move.w	#$80,$2E(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		lea	word_7293E(pc,d0.w),a1
		move.w	(a1)+,$18(a0)
		move.w	(a1)+,$1A(a0)
		rts
; End of function sub_72910

; ---------------------------------------------------------------------------
word_7293E:	dc.w $100
		dc.w $FF00
		dc.w $FE00
		dc.w $FE00
		dc.w $300
		dc.w $FE00
		dc.w $200
		dc.w $FF00
		dc.w $FF00
		dc.w $FE00
		dc.w $FF80
		dc.w $FF00
ObjDat3_72956:	dc.l Map_LBZMiniboss
		dc.w $A4D6
		dc.w $280
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b 0
word_72962:	dc.w $200
		dc.b $20
		dc.b $20
		dc.b 3
		dc.b 0
word_72968:	dc.w $180
		dc.b 8
		dc.b 8
		dc.b 6
		dc.b $98
ChildObjDat_7296E:dc.w 0
		dc.l loc_72596
		dc.w 0
ChildObjDat_72976:dc.w 5
		dc.l loc_725F4
ChildObjDat_7297C:dc.w 5
		dc.l loc_725EE
byte_72982:	dc.b   $F,   0
		dc.b	1,   0
		dc.b	2, $FC
byte_72988:	dc.b	7,   3

		dc.b	4,   5
		dc.b  $F8,   6
		dc.b  $3F,   5
		dc.b	5,   5
		dc.b  $F8,   6
		dc.b	7,   5
		dc.b	4,   3
		dc.b	4, $FC
Pal_LBZMiniboss:	binclude "Levels\LBZ\Palettes\Miniboss.bin"

; ---------------------------------------------------------------------------

Obj_LBZ_FinalBoss1:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_729D2(pc,d0.w),d1
		jsr	off_729D2(pc,d1.w)
		bsr.w	sub_734FA
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_729D2:	dc.w loc_729DE-off_729D2

		dc.w loc_72A54-off_729D2
		dc.w loc_72A70-off_729D2
		dc.w locret_72AEC-off_729D2
		dc.w loc_72AEE-off_729D2
		dc.w loc_72B04-off_729D2
; ---------------------------------------------------------------------------

loc_729DE:
		lea	ObjDat3_736CC(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#9,$29(a0)
		move.b	#1,($FFFFF7AA).w
		move.l	#loc_72A5A,$34(a0)
		cmpi.b	#2,($FFFFB038).w
		beq.s	loc_72A2A
		move.w	#$7F,$2E(a0)
		st	($FFFFFE1E).w
		moveq	#$71,d0
		jsr	(Load_PLC).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_72A2A
		move.l	#Obj_Song_Fade_Transition,(a1)
		move.b	#$19,$2C(a1)

loc_72A2A:

		lea	(Child1_MakeRoboHead3).l,a2
		jsr	(CreateChild1_Normal).l
		lea	ChildObjDat_737F0(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	ChildObjDat_73766(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	ChildObjDat_737E8(pc),a2
		jmp	(CreateChild3_NormalRepeated).l
; ---------------------------------------------------------------------------

loc_72A54:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_72A5A:
		move.b	#4,5(a0)
		move.w	#-$100,$1A(a0)
		lea	Pal_LBZFinalBoss1(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_72A70:
		move.w	$14(a0),d0
		move.w	($FFFFEE7C).w,d1
		tst.w	$1A(a0)
		bmi.s	loc_72A8C
		addi.w	#$118,d1
		cmp.w	d1,d0
		bcc.s	loc_72A9A
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_72A8C:
		subi.w	#$B0,d1
		cmp.w	d1,d0
		bls.s	loc_72A9A
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_72A9A:

		cmpi.b	#2,$29(a0)
		bls.s	loc_72AAA
		btst	#3,$38(a0)
		beq.s	locret_72AE6

loc_72AAA:
		jsr	(Random_Number).l
		swap	d0
		moveq	#0,d1
		bclr	#0,4(a0)
		btst	#0,d0
		beq.s	loc_72AC8
		moveq	#2,d1
		bset	#0,4(a0)

loc_72AC8:
		move.w	word_72AE8(pc,d1.w),d1
		move.w	($FFFFEE78).w,d2
		add.w	d1,d2
		move.w	d2,$10(a0)
		move.w	#$100,d0
		tst.w	$1A(a0)
		bmi.s	loc_72AE2
		neg.w	d0

loc_72AE2:
		move.w	d0,$1A(a0)

locret_72AE6:
		rts
; ---------------------------------------------------------------------------
word_72AE8:	dc.w $110
		dc.w $30
; ---------------------------------------------------------------------------

locret_72AEC:
		rts
; ---------------------------------------------------------------------------

loc_72AEE:
		subq.b	#1,$40(a0)
		bmi.s	loc_72AF6
		rts
; ---------------------------------------------------------------------------

loc_72AF6:
		move.b	#$A,5(a0)
		move.b	#4,$40(a0)

locret_72B02:

		rts
; ---------------------------------------------------------------------------

loc_72B04:
		addq.w	#8,$14(a0)
		subq.b	#1,$40(a0)
		bmi.s	loc_72B10
		rts
; ---------------------------------------------------------------------------

loc_72B10:
		move.b	#6,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_72B18:
		move.w	$14(a0),d0
		addq.w	#1,d0
		move.w	($FFFFEE7C).w,d1
		addi.w	#$140,d1
		cmp.w	d1,d0
		bcc.s	loc_72B34
		move.w	d0,$14(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_72B34:
		move.l	#loc_72B46,(a0)
		move.w	#$3F,$2E(a0)
		st	($FFFFF7CB).w
		rts
; ---------------------------------------------------------------------------

loc_72B46:
		subq.w	#1,$2E(a0)
		bpl.s	locret_72B94
		lea	($FFFFB000).w,a1
		btst	#7,$2A(a1)
		bne.s	locret_72B94
		btst	#1,$2A(a1)
		bne.s	locret_72B94
		cmpi.b	#6,5(a1)
		bcc.s	locret_72B94
		move.l	#loc_72B96,(a0)
		jsr	(Set_PlayerEndingPose).l
		clr.b	($FFFFFAAA).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_72B86
		move.l	#Obj_LevelResults,(a1)

loc_72B86:
		jsr	(Create_New_Sprite).l
		bne.s	locret_72B94
		move.l	#loc_72CFA,(a1)

locret_72B94:

		rts
; ---------------------------------------------------------------------------

loc_72B96:
		tst.b	($FFFFFAAA).w
		beq.w	locret_72B02
		move.l	#loc_72BBC,(a0)
		jsr	(Obj_PlayLevelMusic).l
		move.w	#$1F,$2E(a0)
		lea	(PLC_83D64).l,a1
		jmp	(Load_PLC_Raw).l
; ---------------------------------------------------------------------------

loc_72BBC:
		subq.w	#1,$2E(a0)
		bpl.w	locret_72B02
		move.l	#loc_72C0A,(a0)
		bset	#5,$38(a0)
		move.w	a0,($FFFFFAA4).w
		jsr	(Restore_PlayerControl).l
		lea	($FFFFB04A).w,a1
		jsr	(Restore_PlayerControl2).l
		st	($FFFFF7CA).w
		clr.w	($FFFFF602).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_72BFA
		move.l	#loc_863C0,(a1)

loc_72BFA:
		lea	(ArtKosM_LBZ2DeathEggSmall).l,a1
		move.w	#-$6A40,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

loc_72C0A:
		lea	($FFFFB000).w,a1
		btst	#1,$2A(a1)
		bne.s	locret_72C3A
		move.w	($FFFFEE78).w,d0
		addi.w	#$A0,d0
		sub.w	$10(a1),d0
		scs	d2
		bpl.s	loc_72C28
		neg.w	d0

loc_72C28:
		cmpi.w	#4,d0
		bcs.s	loc_72C3C
		moveq	#3,d1
		tst.b	d2
		beq.s	loc_72C36
		moveq	#2,d1

loc_72C36:
		bset	d1,($FFFFF602).w

locret_72C3A:
		rts
; ---------------------------------------------------------------------------

loc_72C3C:
		move.l	#loc_72C68,(a0)
		clr.b	($FFFFFA88).w
		jsr	(Stop_Object).l
		bclr	#0,4(a1)
		bclr	#0,$2A(a1)
		move.w	#$101,($FFFFF602).w
		lea	ChildObjDat_73806(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_72C68:
		btst	#0,($FFFFFA88).w
		beq.s	locret_72C9C
		move.l	#loc_72C9E,(a0)
		move.l	#loc_72CBE,$34(a0)
		lea	($FFFFB000).w,a1
		bsr.w	sub_72C8E
		lea	($FFFFB04A).w,a1
		clr.b	$20(a0)

; =============== S U B R O U T I N E =======================================


sub_72C8E:
		move.b	#-$7D,$2E(a1)
		clr.b	$24(a1)
		clr.b	$23(a1)

locret_72C9C:
		rts
; End of function sub_72C8E

; ---------------------------------------------------------------------------

loc_72C9E:
		lea	($FFFFB000).w,a1
		lea	byte_7386A(pc),a2
		jsr	(Animate_ExternalPlayerSprite).l
		lea	($FFFFB04A).w,a1
		clr.b	$20(a1)
		lea	byte_73874(pc),a2
		jmp	(Animate_ExternalPlayerSprite).l
; ---------------------------------------------------------------------------

loc_72CBE:
		move.l	#loc_72CC6,(a0)
		rts
; ---------------------------------------------------------------------------

loc_72CC6:
		btst	#1,($FFFFFA88).w
		beq.s	locret_72CD8
		move.l	#loc_72CDA,(a0)
		st	($FFFFEEC6).w

locret_72CD8:
		rts
; ---------------------------------------------------------------------------

loc_72CDA:
		move.w	($FFFFEE7C).w,d0
		addi.w	#$120,d0
		cmp.w	($FFFFB014).w,d0
		bhi.w	locret_72B02
		move.w	#$700,d0
		jsr	(StartNewLevel).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_72CFA:
		lea	($FFFFB04A).w,a1
		btst	#7,$2A(a1)
		bne.s	locret_72D16
		btst	#1,$2A(a1)
		bne.s	locret_72D16
		cmpi.b	#6,5(a1)
		bcs.s	loc_72D18

locret_72D16:

		rts
; ---------------------------------------------------------------------------

loc_72D18:
		jsr	(Set_PlayerEndingPose).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_72D24:
		move.l	#loc_72D5A,(a0)
		move.w	#$4430,$10(a0)
		move.w	#$728,$14(a0)
		move.w	#$1010,$3A(a0)
		move.w	#$200,d0
		tst.b	$2C(a0)
		beq.s	loc_72D48
		neg.w	d0

loc_72D48:
		move.w	d0,$18(a0)
		move.w	#$41,$2E(a0)
		move.l	#loc_72D78,$34(a0)

loc_72D5A:
		subq.b	#1,$39(a0)
		bpl.s	loc_72D6C
		move.b	#3,$39(a0)
		jsr	(sub_83E84).l

loc_72D6C:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_72D78:
		clr.w	$18(a0)
		move.w	#-$200,$1A(a0)
		move.w	#$57,$2E(a0)
		move.l	#loc_72D92,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_72D92:
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild1_Normal).l
		bne.s	loc_72DB2
		move.w	#$4430,$10(a1)
		move.w	#$678,$14(a1)
		move.b	#$C,$2C(a1)

loc_72DB2:
		tst.b	$2C(a0)
		bne.s	loc_72DE4
		jsr	(Create_New_Sprite).l
		bne.s	loc_72DE4
		move.l	#loc_72DEA,(a1)
		move.w	($FFFFEE78).w,d0
		addi.w	#$D0,d0
		move.w	d0,$10(a1)
		move.w	($FFFFEE7C).w,d0
		subi.w	#$20,d0
		move.w	d0,$14(a1)
		move.w	#5,$3A(a1)

loc_72DE4:

		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_72DEA:
		subq.w	#1,$2E(a0)
		bpl.s	locret_72E20
		addq.b	#1,$39(a0)
		cmpi.b	#8,$39(a0)
		bne.s	loc_72E00
		st	($FFFFEEC6).w

loc_72E00:
		cmpi.b	#$18,$39(a0)
		bcc.s	loc_72E22
		move.w	$3A(a0),$2E(a0)
		addq.w	#1,$3A(a0)
		jsr	(Create_New_Sprite).l
		bne.s	locret_72E20
		move.l	#loc_72E54,(a1)

locret_72E20:

		rts
; ---------------------------------------------------------------------------

loc_72E22:
		move.l	#loc_72E2E,(a0)
		move.w	#$17F,$2E(a0)

loc_72E2E:
		subq.w	#1,$2E(a0)
		bmi.s	loc_72E36
		rts
; ---------------------------------------------------------------------------

loc_72E36:
		bset	#0,($FFFFFA88).w
		clr.b	$39(a0)
		clr.w	$2E(a0)
		lea	ChildObjDat_7380C(pc),a2
		jsr	(CreateChild1_Normal).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_72E54:
		lea	ObjDat3_73736(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#MoveChkDel,(a0)
		jsr	(Random_Number).l
		andi.w	#7,d0
		move.b	RawAni_72E96(pc,d0.w),$22(a0)
		swap	d0
		andi.w	#$FF,d0
		move.w	($FFFFEE78).w,d1
		addi.w	#$20,d1
		add.w	d0,d1
		move.w	d1,$10(a0)
		move.w	($FFFFEE7C).w,d0
		subi.w	#$20,d0
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------
RawAni_72E96:	dc.b	7,   8,	  9,  $A,  $B,	 7,   8,   9
; ---------------------------------------------------------------------------

loc_72E9E:

		lea	ObjDat3_73742(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_72EF8,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		beq.s	loc_72EBC
		move.l	#loc_72F40,(a0)

loc_72EBC:
		move.w	word_72EE8(pc,d0.w),$1A(a0)
		lea	byte_72EDA(pc,d0.w),a1
		move.b	(a1)+,$22(a0)
		move.b	(a1)+,d0
		or.b	d0,4(a0)
		lea	Pal_LBZEnding(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------
byte_72EDA:	dc.b	0,   0
		dc.b	1,   0
		dc.b	1,   0
		dc.b	2,   0
		dc.b	2,   1
		dc.b	2,   2
		dc.b	2,   3
word_72EE8:	dc.w $40
		dc.w $38
		dc.w $3C
		dc.w $40
		dc.w $44
		dc.w $48
		dc.w $4C
		dc.w $50
; ---------------------------------------------------------------------------

loc_72EF8:
		move.b	($FFFFFE0F).w,d0
		andi.b	#$F,d0
		bne.s	loc_72F2C
		lea	ChildObjDat_73838(pc),a2
		jsr	(CreateChild6_Simple).l
		jsr	(Random_Number).l
		andi.w	#$1F,d0
		subi.w	#$10,d0
		add.w	d0,$10(a1)
		swap	d0
		andi.w	#$1F,d0
		subi.w	#$10,d0
		add.w	d0,$14(a1)

loc_72F2C:
		move.w	($FFFFEE7C).w,d0
		addi.w	#$80,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_72F40
		bset	#1,($FFFFFA88).w

loc_72F40:

		jsr	(MoveSprite2).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_72F4C:
		lea	ObjDat3_7374E(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_72F7A,(a0)
		move.w	#-$40,$1A(a0)
		move.w	#$7F,$2E(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		lea	ChildObjDat_7383E(pc),a2
		jsr	(CreateChild6_Simple).l

loc_72F7A:
		move.b	($FFFFFE0F).w,d0
		andi.b	#3,d0
		bne.s	loc_72FA0
		move.b	$39(a0),d0
		addq.b	#1,d0
		move.b	d0,$39(a0)
		andi.b	#3,d0
		move.b	4(a0),d1
		andi.b	#-4,d1
		or.b	d0,d1
		move.b	d1,4(a0)

loc_72FA0:
		jsr	(MoveSprite2).l
		jsr	(Obj_Wait).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_72FB2:
		lea	ObjDat3_7375A(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_72FD8,(a0)
		move.l	#byte_73864,$30(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		move.w	#$40,$1A(a0)

loc_72FD8:
		jsr	(Animate_Raw).l
		jsr	(MoveSprite2).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
word_72FEA:	dc.w	  0,  $428, $4280, $4380
		dc.w   $328,  $328, $4300, $4300
; ---------------------------------------------------------------------------

Obj_CD_1_LBZ2_TallBoss:
		lea	word_72FEA(pc),a1
		jsr	(Check_CameraInRange).l
		move.b	#$19,$26(a0)
		jsr	(sub_85D6A).l
		move.l	#loc_73046,(a0)
		move.l	#loc_7304C,$34(a0)
		clr.b	($FFFFFAA2).w
		clr.b	($FFFFFAA3).w
		moveq	#$71,d0
		jsr	(Load_PLC).l

; =============== S U B R O U T I N E =======================================


sub_7302E:
		lea	PLC_73038(pc),a1
		jmp	(Load_PLC_Raw).l
; End of function sub_7302E

; ---------------------------------------------------------------------------
PLC_73038:	dc.w 1
		dc.l ArtNem_RobotnikShip
		dc.w $A5C0
		dc.l ArtNem_BossExplosion
		dc.w $A000
; ---------------------------------------------------------------------------

loc_73046:
		jmp	(loc_85CA4).l
; ---------------------------------------------------------------------------

loc_7304C:
		move.l	#Obj_LBZ_FinalBoss1,(a0)
		rts
; ---------------------------------------------------------------------------

loc_73054:
		move.w	$14(a0),d0
		subq.w	#1,d0
		move.w	($FFFFEE7C).w,d1
		subi.w	#$50,d1
		cmp.w	d1,d0
		bcs.s	loc_73070
		move.w	d0,$14(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_73070:
		move.w	d1,$14(a0)
		bset	#5,$38(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_73088
		move.l	#Obj_LBZ_FinalBoss2,(a1)

loc_73088:
		jmp	(Go_Delete_Sprite_2).l
; ---------------------------------------------------------------------------

loc_7308E:

		lea	ObjDat3_736D8(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_730B0,(a0)
		move.l	#loc_730B0,$34(a0)
		lea	ChildObjDat_737BA(pc),a2
		jmp	(CreateChild3_NormalRepeated).l
; ---------------------------------------------------------------------------

loc_730B0:

		jsr	(Refresh_ChildPositionAdjusted).l
		bsr.w	sub_7361E
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_730C0:
		movea.w	$46(a0),a1
		btst	#6,$2A(a1)
		bne.s	loc_730EC
		move.l	$34(a0),(a0)
		btst	#5,$2A(a1)
		beq.s	loc_730EC
		subi.b	#$28,$43(a0)
		cmpi.b	#4,$2C(a0)
		bne.s	loc_730EC
		bclr	#5,$2A(a1)

loc_730EC:

		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_730F2:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_730F8:
		move.w	#1,$3C(a0)
		bra.s	loc_7308E
; ---------------------------------------------------------------------------

loc_73100:
		lea	ObjDat3_736E4(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_73128,(a0)
		move.l	#loc_73128,$34(a0)
		move.w	#2,$3C(a0)
		lea	ChildObjDat_737DA(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_73128:

		jsr	(Refresh_ChildPositionAdjusted).l
		bsr.w	sub_7361E
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_73138:

		lea	word_736F8(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_73152,(a0)
		move.w	#$60,$2E(a0)
		bsr.w	sub_73682

loc_73152:
		jsr	(MoveSprite).l
		jsr	(TimedSprite_ScreenLock).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_73164:
		move.l	#loc_73174,(a0)
		lea	ObjDat3_7371E(pc),a1
		jmp	(SetUp_ObjAttributes).l
; ---------------------------------------------------------------------------

loc_73174:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_7318C
		jsr	(Refresh_ChildPositionAdjusted).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7318C:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_73192:

		lea	ObjDat3_7372A(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_731B0,(a0)
		tst.b	$2C(a0)
		beq.s	locret_731AE
		move.b	#$22,$22(a0)

locret_731AE:
		rts
; ---------------------------------------------------------------------------

loc_731B0:
		movea.w	$46(a0),a1
		btst	#6,$2A(a1)
		beq.s	loc_731C8
		jsr	(Refresh_ChildPositionAdjusted).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_731C8:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_731CE:
		lea	word_736FE(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_731F4,(a0)
		movea.w	$46(a0),a1
		move.w	$46(a1),$44(a0)
		tst.b	$2C(a0)
		beq.s	loc_731F4
		move.b	#8,$39(a0)

loc_731F4:

		bsr.w	sub_733FC
		moveq	#4,d0
		jmp	(Child_Draw_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------
		movea.w	$44(a0),a1
		btst	#6,$2A(a1)
		bne.s	loc_73212
		move.l	#loc_731F4,(a0)

loc_73212:
		moveq	#4,d0
		jmp	(Child_Draw_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------

loc_7321A:

		lea	word_73704(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#loc_73232,(a0)
		move.w	#8,$3A(a0)
		rts
; ---------------------------------------------------------------------------

loc_73232:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_7326A
		jsr	(Refresh_ChildPositionAdjusted).l
		subq.w	#1,$2E(a0)
		bpl.w	locret_72B02
		move.w	$3A(a0),$2E(a0)
		subq.w	#1,$3A(a0)
		bpl.s	loc_73264
		move.l	#loc_73270,(a0)
		move.w	#$18,$2E(a0)

loc_73264:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7326A:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_73270:
		jsr	(Refresh_ChildPositionAdjusted).l
		subq.w	#1,$2E(a0)
		bmi.s	loc_7328C
		btst	#0,$2F(a0)
		bne.w	locret_72B02
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7328C:
		move.l	#loc_732A8,(a0)
		move.l	#byte_73849,$30(a0)
		move.l	#loc_732BA,$34(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_732A8:
		jsr	(Refresh_ChildPositionAdjusted).l
		jsr	(Animate_Raw).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_732BA:
		move.l	#loc_732F6,(a0)
		tst.b	4(a0)
		bpl.s	loc_732CE
		moveq	#$5E,d0
		jsr	(Play_Sound_2).l

loc_732CE:
		move.b	#-$64,$28(a0)
		move.b	#$11,$22(a0)
		moveq	#-$2C,d0
		move.w	#-$800,d1
		btst	#0,4(a0)
		beq.s	loc_732EC
		neg.w	d0
		neg.w	d1

loc_732EC:
		add.w	d0,$10(a0)
		move.w	d1,$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_732F6:
		btst	#0,($FFFFFE0F).w
		bne.s	loc_73318
		lea	ChildObjDat_737D2(pc),a2
		jsr	(CreateChild1_Normal).l
		move.l	#byte_73851,$30(a1)
		bsr.w	sub_734E4
		bra.w	loc_7332E
; ---------------------------------------------------------------------------

loc_73318:
		lea	ChildObjDat_737D2(pc),a2
		jsr	(CreateChild1_Normal).l
		move.l	#byte_73857,$30(a1)
		bsr.w	sub_734E4

loc_7332E:
		jsr	(MoveSprite2).l
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------

loc_7333A:
		lea	word_7370C(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_73358,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		jsr	(Refresh_ChildPositionAdjusted).l

loc_73358:
		jsr	(Animate_Raw).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_73364:

		lea	word_736F0(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		bset	#4,$2B(a0)
		move.l	#loc_73384,(a0)
		move.l	#byte_73844,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_73384:
		jsr	(Refresh_ChildPositionAdjusted).l
		jsr	(Animate_Raw).l
		jmp	(Child_DrawTouch_Sprite).l
; ---------------------------------------------------------------------------

loc_73396:
		lea	ObjDat3_73712(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_733CA,(a0)
		move.l	#byte_7385D,$30(a0)
		move.l	#loc_733E2,$34(a0)
		move.b	#-$14,$43(a0)
		tst.b	$2C(a0)
		beq.s	locret_733C8
		move.b	#-$80,$3C(a0)

locret_733C8:
		rts
; ---------------------------------------------------------------------------

loc_733CA:
		jsr	(Animate_Raw).l
		addq.b	#1,$3C(a0)
		moveq	#3,d2
		jsr	(MoveSprite_CircularSimpleOffset).l
		jmp	(Child_DrawTouch_Sprite).l
; ---------------------------------------------------------------------------

loc_733E2:
		move.b	$39(a0),d0
		addq.b	#1,d0
		move.b	d0,$39(a0)
		andi.b	#3,d0
		andi.b	#-4,4(a0)
		or.b	d0,4(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_733FC:
		moveq	#0,d0
		move.b	$39(a0),d0
		subq.w	#1,$2E(a0)
		bmi.s	loc_7340E
		add.w	d0,d0
		bra.w	loc_73484
; ---------------------------------------------------------------------------

loc_7340E:
		movea.w	$44(a0),a1
		btst	#0,4(a1)
		sne	d2
		beq.s	loc_73426
		subq.b	#1,d0
		bpl.s	loc_73430
		moveq	#$B,d0
		bra.w	loc_73430
; ---------------------------------------------------------------------------

loc_73426:
		addq.b	#1,d0
		cmpi.b	#$C,d0
		bcs.s	loc_73430
		moveq	#0,d0

loc_73430:

		move.b	d0,$39(a0)
		lea	byte_734AA(pc),a2
		move.b	(a2,d0.w),d1
		bset	#0,4(a0)
		bclr	#7,d1
		bne.s	loc_73450
		bclr	#0,4(a0)
		not.b	d2

loc_73450:
		bclr	#3,$38(a1)
		cmpi.b	#4,d1
		bne.s	loc_73478
		bset	#3,$38(a1)
		tst.b	d2
		beq.s	loc_73478
		movem.l	d0-d1,-(sp)
		lea	ChildObjDat_737C2(pc),a2
		jsr	(CreateChild1_Normal).l
		movem.l	(sp)+,d0-d1

loc_73478:

		move.b	d1,$22(a0)
		add.w	d0,d0
		move.w	word_734B6(pc,d0.w),$2E(a0)

loc_73484:
		lea	byte_734CE(pc,d0.w),a1
		movea.w	$46(a0),a2
		move.b	(a1)+,d1
		ext.w	d1
		move.w	$10(a2),d2
		add.w	d1,d2
		move.w	d2,$10(a0)
		move.b	(a1)+,d1
		ext.w	d1
		move.w	$14(a2),d2
		add.w	d1,d2
		move.w	d2,$14(a0)
		rts
; End of function sub_733FC

; ---------------------------------------------------------------------------
byte_734AA:	dc.b $83
		dc.b $84
		dc.b $85
		dc.b $86
		dc.b $87
		dc.b $88
		dc.b 7
		dc.b 6
		dc.b 5
		dc.b 4
		dc.b 3
		dc.b $2D
word_734B6:	dc.w 7
		dc.w $5F
		dc.w 7
		dc.w 7
		dc.w 7
		dc.w 7
		dc.w 7
		dc.w 7
		dc.w 7
		dc.w $5F
		dc.w 7
		dc.w $27
byte_734CE:	dc.b  $27, $F8
		dc.b  $24, $F8
		dc.b  $24, $F8
		dc.b  $14, $F8
		dc.b   $C, $F8
		dc.b	0, $F8
		dc.b  $F4, $F8
		dc.b  $EC, $F8
		dc.b  $DC, $F8
		dc.b  $DC, $F8
		dc.b  $D9, $F8

; =============== S U B R O U T I N E =======================================


sub_734E4:

		jsr	(Random_Number).l
		swap	d0
		andi.b	#7,d0
		addi.b	#$18,d0
		move.b	d0,$42(a1)
		rts
; End of function sub_734E4


; =============== S U B R O U T I N E =======================================


sub_734FA:
		tst.b	$28(a0)
		bne.w	locret_735B4
		tst.b	$29(a0)
		beq.w	loc_735B6
		tst.b	$20(a0)
		bne.s	loc_73584
		move.b	5(a0),$3A(a0)
		move.b	#6,5(a0)
		move.b	#$20,$20(a0)
		bset	#6,$2A(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		move.w	$1A(a0),d0
		asl.w	#1,d0
		cmpi.w	#-$800,d0
		blt.s	loc_73546
		cmpi.w	#$800,d0
		bgt.s	loc_73546
		move.w	d0,$1A(a0)

loc_73546:

		cmpi.b	#5,$29(a0)
		beq.s	loc_7355C
		cmpi.b	#1,$29(a0)
		bne.s	loc_73584
		bset	#3,$38(a0)

loc_7355C:
		move.w	$3C(a0),d0
		bset	d0,$38(a0)
		addq.w	#1,$3C(a0)
		move.b	#8,5(a0)
		move.b	#$F,$40(a0)
		bset	#5,$2A(a0)
		lea	ChildObjDat_737F8(pc),a2
		jsr	(CreateChild1_Normal).l

loc_73584:

		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_73592
		addi.w	#4,d0

loc_73592:
		bsr.w	sub_73604
		subq.b	#1,$20(a0)
		bne.s	locret_735B4
		move.b	$3A(a0),5(a0)
		move.w	#$EEE,($FFFFFC22).w
		move.b	$25(a0),$28(a0)
		bclr	#6,$2A(a0)

locret_735B4:

		rts
; ---------------------------------------------------------------------------

loc_735B6:
		jsr	(BossDefeated).l
		move.b	#5,$22(a0)
		bset	#6,$2A(a0)
		bset	#7,$2A(a0)
		clr.b	$28(a0)
		move.w	$3C(a0),d0
		bset	d0,$38(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild1_Normal).l
		move.b	#4,$2C(a1)
		cmpi.b	#2,($FFFFB038).w
		beq.s	loc_735FC
		move.l	#loc_72B18,(a0)
		rts
; ---------------------------------------------------------------------------

loc_735FC:
		move.l	#loc_73054,(a0)
		rts
; End of function sub_734FA


; =============== S U B R O U T I N E =======================================


sub_73604:
		lea	word_73612(pc),a1
		lea	word_73616(pc,d0.w),a2
		jmp	(CopyWordData_2).l
; End of function sub_73604

; ---------------------------------------------------------------------------
word_73612:	dc.w $FC28
		dc.w $FC3C
word_73616:	dc.w $26
		dc.w $20
		dc.w $EEE
		dc.w $EEE

; =============== S U B R O U T I N E =======================================


sub_7361E:

		movea.w	$46(a0),a1
		move.w	$3C(a0),d0
		btst	d0,$38(a1)
		beq.s	loc_73672
		move.l	#byte_736C2,$3E(a0)
		bset	#7,$2A(a0)
		lea	(ChildObjDat_7377A).l,a2
		cmpi.w	#2,d0
		bne.s	loc_73654
		move.l	#byte_736C6,$3E(a0)
		lea	(ChildObjDat_73794).l,a2

loc_73654:
		move.w	#$10,$2E(a0)
		move.l	#loc_730F2,(a0)
		jsr	(CreateChild1_Normal).l
		lea	(Child6_CreateBossExplosion).l,a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_73672:
		btst	#6,$2A(a1)
		beq.s	locret_73680
		move.l	#loc_730C0,(a0)

locret_73680:
		rts
; End of function sub_7361E


; =============== S U B R O U T I N E =======================================


sub_73682:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,d1
		lsr.w	#1,d1
		movea.w	$46(a0),a1
		movea.l	$3E(a1),a1
		move.b	(a1,d1.w),$22(a0)
		add.w	d0,d0
		lea	word_736AA(pc,d0.w),a1
		move.w	(a1)+,$18(a0)
		move.w	(a1)+,$1A(a0)
		rts
; End of function sub_73682

; ---------------------------------------------------------------------------
word_736AA:	dc.w  $FF00, $FE00
		dc.w   $100, $FE00
		dc.w  $FE00, $FF00
		dc.w   $200, $FF00
		dc.w  $FD00, $FD00
		dc.w   $300, $FD00
byte_736C2:	dc.b $23
		dc.b $25
		dc.b $24
		dc.b $26
byte_736C6:	dc.b $27
		dc.b $29
		dc.b $28
		dc.b $2A
		dc.b $2B
		dc.b $2C
ObjDat3_736CC:	dc.l Map_RobotnikShip
		dc.w $852E
		dc.w $280
		dc.b $20
		dc.b $20
		dc.b $C
		dc.b $F
ObjDat3_736D8:	dc.l Map_LBZFinalBoss1
		dc.w $A3AA
		dc.w $200
		dc.b $20
		dc.b $14
		dc.b 0
		dc.b $AD
ObjDat3_736E4:	dc.l Map_LBZFinalBoss1
		dc.w $A3AA
		dc.w $200
		dc.b $28
		dc.b $18
		dc.b 1
		dc.b $AD
word_736F0:	dc.w $83AA
		dc.w $280
		dc.b $C
		dc.b $18
		dc.b 9
		dc.b $89
word_736F8:	dc.w $200
		dc.b $10
		dc.b $10
		dc.b $2A
		dc.b 0
word_736FE:	dc.w $180
		dc.b $C
		dc.b $C
		dc.b 3
		dc.b 0
word_73704:	dc.w $83AA
		dc.w $100
		dc.b $18
		dc.b 8
		dc.b $F
		dc.b 0
word_7370C:	dc.w $100
		dc.b 8
		dc.b 8
		dc.b $1C
		dc.b 0
ObjDat3_73712:	dc.l Map_LBZFinalBoss1
		dc.w $A3AA
		dc.w $300
		dc.b $C
		dc.b $C
		dc.b $C
		dc.b $97
ObjDat3_7371E:	dc.l Map_LBZFinalBoss1
		dc.w $A3AA
		dc.w $200
		dc.b $28
		dc.b 8
		dc.b 2
		dc.b 0
ObjDat3_7372A:	dc.l Map_LBZFinalBoss1
		dc.w $A3AA
		dc.w $280
		dc.b $10
		dc.b $C
		dc.b $10
		dc.b 0
ObjDat3_73736:	dc.l Map_LBZDeathEggSmall
		dc.w $44AE
		dc.w $300
		dc.b $C
		dc.b $C
		dc.b 7
		dc.b 0
ObjDat3_73742:	dc.l Map_LBZDeathEggSmall
		dc.w $24AE
		dc.w $380
		dc.b $18
		dc.b $18
		dc.b 0
		dc.b 0
ObjDat3_7374E:	dc.l Map_LBZDeathEggSmall
		dc.w $24AE
		dc.w $300
		dc.b 4
		dc.b 4
		dc.b 3
		dc.b 0
ObjDat3_7375A:	dc.l Map_LBZDeathEggSmall
		dc.w $24AE
		dc.w $300
		dc.b 4
		dc.b 4
		dc.b 4
		dc.b 0
ChildObjDat_73766:dc.w 2
		dc.l loc_7308E
		dc.w 8
		dc.l loc_730F8
		dc.w $30
		dc.l loc_73100
		dc.w $5C
ChildObjDat_7377A:dc.w 3
		dc.l loc_73138
		dc.w $F0FC
		dc.l loc_73138
		dc.w $10FC
		dc.l loc_73138
		dc.w $F010
		dc.l loc_73138
		dc.w $1010
ChildObjDat_73794:dc.w 5
		dc.l loc_73138
		dc.w $F0F8
		dc.l loc_73138
		dc.w $10F8
		dc.l loc_73138
		dc.w $F010
		dc.l loc_73138
		dc.w $1010
		dc.l loc_73138
		dc.w $ECE0
		dc.l loc_73138
		dc.w $14E0
ChildObjDat_737BA:dc.w 1
		dc.l loc_731CE
		dc.w 0
ChildObjDat_737C2:dc.w 0
		dc.l loc_7321A
		dc.w $F800
		dc.w 0
		dc.l loc_7321A
		dc.w $800
ChildObjDat_737D2:dc.w 0

		dc.l loc_7333A
		dc.w $2000
ChildObjDat_737DA:dc.w 1
		dc.l loc_73364
		dc.w $EC30
		dc.l loc_73364
		dc.w $1430
ChildObjDat_737E8:dc.w 0
		dc.l loc_73396
		dc.w 0
ChildObjDat_737F0:dc.w 0
		dc.l loc_73164
		dc.w $EC
ChildObjDat_737F8:dc.w	  1
		dc.l loc_73192
		dc.w $F000
		dc.l loc_73192
		dc.w $1000
ChildObjDat_73806:dc.w 1
		dc.l loc_72D24
ChildObjDat_7380C:dc.w 6
		dc.l loc_72E9E
		dc.w 0
		dc.l loc_72E9E
		dc.w $F028
		dc.l loc_72E9E
		dc.w $9000
		dc.l loc_72E9E
		dc.w $B828
		dc.l loc_72E9E
		dc.w $1810
		dc.l loc_72E9E
		dc.w $DCF8
		dc.l loc_72E9E
		dc.w $B01C
ChildObjDat_73838:dc.w 0
		dc.l loc_72F4C
ChildObjDat_7383E:dc.w 0
		dc.l loc_72FB2
byte_73844:	dc.b	2,   9
		dc.b   $A,  $B
		dc.b  $FC
byte_73849:	dc.b 0
		dc.b $17
		dc.b $17
		dc.b $18
		dc.b $19
		dc.b $1A
		dc.b $1B
		dc.b $F4
byte_73851:	dc.b 0
		dc.b $1C
		dc.b $1C
		dc.b $1D
		dc.b $1E
		dc.b $F4
byte_73857:	dc.b 0
		dc.b $1F
		dc.b $1F
		dc.b $20
		dc.b $21
		dc.b $F4
byte_7385D:	dc.b	1,  $C
		dc.b   $D,  $E
		dc.b   $D,  $C
		dc.b  $F4
byte_73864:	dc.b 2
		dc.b 4
		dc.b 4
		dc.b 5
		dc.b 6
		dc.b $F4
byte_7386A:	dc.b 5,	$C4
		dc.b 0,	$55
		dc.b 0,	$59
		dc.b 1,	$5A
		dc.b 1,	0
byte_73874:	dc.b	5, $C4
		dc.b	0, $55
		dc.b	0, $59
		dc.b	1, $5A
		dc.b	1, $5A
		dc.b	1, $5A
		dc.b	1, $5A
		dc.b	1, $5A
		dc.b	1,   0
Pal_LBZFinalBoss1:	binclude "Levels\LBZ\Palettes\Final Boss 1.bin"

Pal_LBZEnding:	binclude "Levels\LBZ\Palettes\Ending.bin"

word_738C6:	dc.w   $460,  $6A0, $3900, $3B20
word_738CE:	dc.w   $5A0,  $5A0, $3A20, $3A20
; ---------------------------------------------------------------------------

Obj_LBZ_EndBoss:
		lea	word_738C6(pc),a1
		jsr	(Check_CameraInRange).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_738F8(pc,d0.w),d1
		jsr	off_738F8(pc,d1.w)
		bsr.w	sub_73FE2
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_738F8:	dc.w loc_73906-off_738F8

		dc.w loc_7395A-off_738F8
		dc.w loc_7397A-off_738F8
		dc.w loc_7399E-off_738F8
		dc.w loc_739E6-off_738F8
		dc.w loc_73A1A-off_738F8
		dc.w loc_73A48-off_738F8
; ---------------------------------------------------------------------------

loc_73906:
		lea	ObjDat3_740EC(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#8,$29(a0)
		move.l	#loc_73960,$34(a0)
		lea	word_738CE(pc),a1
		move.b	#$19,$26(a0)
		jsr	(sub_85D6A).l
		lea	ChildObjDat_7414C(pc),a2
		jsr	(CreateChild1_Normal).l
		moveq	#$77,d0
		jsr	(Load_PLC).l
		lea	(ArtKosM_LBZEndBoss).l,a1
		move.w	#-$7B60,d2
		jsr	(Queue_Kos_Module).l
		lea	Pal_LBZEndBoss(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_7395A:
		jmp	(loc_85CA4).l
; ---------------------------------------------------------------------------

loc_73960:
		move.b	#4,5(a0)
		lea	ChildObjDat_7418A(pc),a2
		jsr	(CreateChild4_LinkListRepeated).l
		lea	ChildObjDat_7415A(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_7397A:
		btst	#7,$38(a0)
		bne.s	loc_73984
		rts
; ---------------------------------------------------------------------------

loc_73984:
		move.b	#6,5(a0)
		move.b	#1,($FFFFEE0A).w
		move.w	#$39F0,d0
		move.w	d0,($FFFFEE14).w
		move.w	d0,($FFFFEE16).w

locret_7399C:

		rts
; ---------------------------------------------------------------------------

loc_7399E:
		move.w	#$39F0,d0
		move.w	($FFFFEE78).w,d1
		subq.w	#2,d1
		cmp.w	d0,d1
		bls.s	loc_739B2
		move.w	d1,($FFFFEE78).w
		rts
; ---------------------------------------------------------------------------

loc_739B2:
		move.w	d0,($FFFFEE78).w
		move.b	#8,5(a0)
		clr.b	($FFFFEE0A).w
		moveq	#-$30,d0
		jsr	(Play_Sound_2).l
		move.w	#-$40,$1A(a0)
		move.w	#$DF,$2E(a0)
		move.l	#loc_739F2,$34(a0)
		lea	ChildObjDat_74162(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_739E6:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_739F2:
		bset	#2,$38(a0)
		move.b	#$F,$28(a0)
		bset	#3,$38(a0)

loc_73A04:
		move.b	#$A,5(a0)
		move.w	#7,$2E(a0)
		move.l	#loc_73A20,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_73A1A:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_73A20:
		bset	#1,$38(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_73A36,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_73A36:
		move.b	#$C,5(a0)
		moveq	#-$7F,d0
		jsr	(Play_Sound_2).l
		bra.w	loc_73F1C
; ---------------------------------------------------------------------------

loc_73A48:
		btst	#1,$38(a0)
		beq.s	loc_73A04
		rts
; ---------------------------------------------------------------------------

loc_73A52:
		addi.w	#$20,$1A(a0)
		jsr	(MoveSprite2).l
		jsr	(Obj_Wait).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_73A6A:
		bset	#5,$38(a0)
		bclr	#7,4(a0)
		clr.b	($FFFFF7AA).w
		jsr	(Obj_PlayLevelMusic).l
		lea	($FFFFB04A).w,a1
		bclr	#4,$2A(a1)
		move.l	#Go_Delete_Sprite_2,(a0)
		rts
; ---------------------------------------------------------------------------

loc_73A92:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_73AC4(pc,d0.w),d1
		jsr	off_73AC4(pc,d1.w)
		jsr	(Animate_Raw).l
		btst	#7,$2A(a0)
		bne.s	loc_73ABE
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		beq.s	loc_73ABE
		bsr.w	sub_73B82

loc_73ABE:

		jmp	(Child_DrawTouch_Sprite).l
; ---------------------------------------------------------------------------
off_73AC4:	dc.w loc_73ACC-off_73AC4

		dc.w loc_73AF6-off_73AC4
		dc.w loc_73B12-off_73AC4
		dc.w loc_73B3C-off_73AC4
; ---------------------------------------------------------------------------

loc_73ACC:
		lea	word_7412A(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#byte_741F4,$30(a0)
		move.b	#$10,$1E(a0)
		move.w	#$F,$2E(a0)
		move.l	#loc_73B02,$34(a0)
		bra.w	loc_73F42
; ---------------------------------------------------------------------------

loc_73AF6:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_73B02:
		move.b	#4,5(a0)
		move.l	#loc_73B24,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_73B12:
		addi.w	#$20,$1A(a0)
		jsr	(MoveSprite2).l
		jmp	(ObjHitFloor_DoRoutine).l
; ---------------------------------------------------------------------------

loc_73B24:
		move.b	#6,5(a0)
		move.l	#sub_73B82,$34(a0)
		move.w	$26(a0),d0
		clr.w	$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_73B3C:
		move.w	#$10,d3
		jsr	(ObjHitWall_DoRoutine).l
		jsr	(ObjHitFloor2_DoRoutine).l
		tst.b	d3
		beq.s	loc_73B56
		addi.w	#$10,$18(a0)

loc_73B56:
		jsr	(MoveSprite2).l
		move.w	$18(a0),d0
		addi.w	#$200,d0
		cmpi.w	#$400,d0
		bcs.w	locret_7399C
		move.w	($FFFFFE0E).w,d0
		andi.w	#3,d0
		bne.w	locret_7399C
		lea	ChildObjDat_74198(pc),a2
		jmp	(CreateChild1_Normal).l

; =============== S U B R O U T I N E =======================================


sub_73B82:

		move.l	#Delete_Current_Sprite,(a0)
		bset	#7,$2A(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_741A0(pc),a2
		jmp	(CreateChild1_Normal).l
; End of function sub_73B82

; ---------------------------------------------------------------------------

loc_73BA0:

		lea	word_74130(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#loc_73BDC,(a0)
		move.l	#byte_741F8,$30(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		bne.s	loc_73BD0
		move.w	#-$200,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_73BD0:
		subi.w	#$10,d0
		add.w	d0,d0
		neg.w	d0
		move.w	d0,$2E(a0)

loc_73BDC:
		addq.w	#1,$2E(a0)
		bmi.w	locret_7399C
		jsr	(MoveSprite2).l
		jsr	(Animate_Raw).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_73BF6:

		lea	word_74138(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#Obj_FlickerMove,(a0)
		bra.w	loc_73F7C
; ---------------------------------------------------------------------------

loc_73C0A:

		jsr	(Refresh_ChildPositionAdjusted).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_73C24(pc,d0.w),d1
		jsr	off_73C24(pc,d1.w)
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------
off_73C24:	dc.w loc_73C2A-off_73C24

		dc.w loc_73C44-off_73C24
		dc.w loc_73C6A-off_73C24
; ---------------------------------------------------------------------------

loc_73C2A:
		lea	word_7411C(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		addq.w	#2,d0
		move.b	d0,$22(a0)
		rts
; ---------------------------------------------------------------------------

loc_73C44:
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		beq.s	loc_73C58
		move.b	#4,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_73C58:
		move.w	$2E(a0),d0
		addq.w	#1,$2E(a0)
		andi.w	#3,d0
		sub.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_73C6A:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_73C78
		rts
; ---------------------------------------------------------------------------

loc_73C78:
		lea	ChildObjDat_74176(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_73C82:

		lea	word_74122(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#Obj_FlickerMove,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_73CAA(pc,d0.w),$18(a0)
		move.w	#-$200,$1A(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
word_73CAA:	dc.w $FF00
		dc.w $200
		dc.w $FE00
; ---------------------------------------------------------------------------

loc_73CB0:
		movea.w	$46(a0),a1
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_73CCE(pc,d0.w),d1
		jsr	off_73CCE(pc,d1.w)
		lea	locret_7399C(pc),a2
		bsr.w	sub_73FCE
		bra.w	loc_74098
; ---------------------------------------------------------------------------
off_73CCE:	dc.w loc_73CD8-off_73CCE

		dc.w loc_73CFC-off_73CCE
		dc.w loc_73D0E-off_73CCE
		dc.w loc_73D32-off_73CCE
		dc.w loc_73D40-off_73CCE
; ---------------------------------------------------------------------------

loc_73CD8:
		lea	ObjDat3_74140(pc),a1
		jsr	(SetUp_ObjAttributes).l
		subi.w	#$14,$10(a0)
		addi.w	#$40,$14(a0)
		tst.b	$2C(a0)
		beq.s	locret_73CFA
		move.l	#loc_73D56,(a0)

locret_73CFA:
		rts
; ---------------------------------------------------------------------------

loc_73CFC:
		btst	#1,$38(a1)
		bne.s	loc_73D06
		rts
; ---------------------------------------------------------------------------

loc_73D06:
		move.b	#4,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_73D0E:
		subq.b	#1,$3C(a0)
		cmpi.b	#-$40,$3C(a0)
		bls.s	loc_73D1C
		rts
; ---------------------------------------------------------------------------

loc_73D1C:
		move.b	#6,5(a0)
		move.w	#$80,$2E(a0)
		move.l	#loc_73D38,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_73D32:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_73D38:
		move.b	#8,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_73D40:
		addq.b	#1,$3C(a0)
		beq.s	loc_73D48
		rts
; ---------------------------------------------------------------------------

loc_73D48:
		move.b	#2,5(a0)
		bclr	#1,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_73D56:
		lea	loc_73D62(pc),a2
		bsr.w	sub_73FCE
		bra.w	loc_74098
; ---------------------------------------------------------------------------

loc_73D62:
		movea.w	$46(a0),a1
		move.b	$3C(a1),$3C(a0)
		moveq	#4,d2
		jmp	(MoveSprite_CircularSimple).l
; ---------------------------------------------------------------------------

loc_73D74:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_73D88(pc,d0.w),d1
		jsr	off_73D88(pc,d1.w)
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
off_73D88:	dc.w loc_73D8E-off_73D88

		dc.w loc_73DB6-off_73D88
		dc.w loc_73DEA-off_73D88
; ---------------------------------------------------------------------------

loc_73D8E:
		lea	ObjDat3_740F8(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.w	#-$180,$18(a0)
		move.l	#byte_741EA,$30(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_73DC8,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_73DB6:
		jsr	(MoveSprite2).l
		jsr	(Animate_Raw).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_73DC8:
		move.b	#4,5(a0)
		move.b	#3,$22(a0)
		move.w	#-$200,$1A(a0)
		move.w	#$29,$2E(a0)
		move.l	#loc_73DF6,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_73DEA:
		jsr	(MoveSprite_LightGravity).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_73DF6:
		move.l	#Delete_Current_Sprite,(a0)
		move.b	#0,$22(a0)
		movea.w	$46(a0),a1
		bset	#7,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_73E0E:
		jsr	(Refresh_ChildPositionAdjusted).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_73E28(pc,d0.w),d1
		jsr	off_73E28(pc,d1.w)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_73E28:	dc.w loc_73E30-off_73E28

		dc.w loc_73E3A-off_73E28
		dc.w loc_73E5E-off_73E28
		dc.w loc_73E8E-off_73E28
; ---------------------------------------------------------------------------

loc_73E30:
		lea	ObjDat3_74104(pc),a1
		jmp	(SetUp_ObjAttributes).l
; ---------------------------------------------------------------------------

loc_73E3A:
		movea.w	$46(a0),a1
		btst	#7,$38(a1)
		bne.s	loc_73E48
		rts
; ---------------------------------------------------------------------------

loc_73E48:
		move.b	#4,5(a0)
		move.b	#0,$22(a0)
		move.l	#byte_741F0,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_73E5E:
		movea.w	$46(a0),a1
		btst	#6,$2A(a1)
		bne.s	loc_73E78
		btst	#7,$2A(a1)
		bne.s	loc_73E80
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_73E78:
		move.b	#2,$22(a0)
		rts
; ---------------------------------------------------------------------------

loc_73E80:
		move.b	#6,5(a0)
		move.b	#3,$22(a0)
		rts
; ---------------------------------------------------------------------------

loc_73E8E:
		movea.w	$46(a0),a1
		btst	#5,$38(a1)
		bne.s	loc_73E9C
		rts
; ---------------------------------------------------------------------------

loc_73E9C:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_73EA2:
		lea	ObjDat3_74110(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_73EB4,(a0)
		rts
; ---------------------------------------------------------------------------

loc_73EB4:
		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		bne.s	loc_73F10
		btst	#3,$38(a1)
		bne.s	loc_73EE2
		moveq	#$13,d1
		move.w	#$80,d2
		move.w	#$120,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_73EE2:
		move.l	#loc_73EEE,(a0)
		addi.w	#$60,$14(a0)

loc_73EEE:
		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		bne.s	loc_73F10
		moveq	#$13,d1
		moveq	#$14,d2
		moveq	#0,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_73F10:

		jsr	(Displace_PlayerOffObject).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_73F1C:
		lea	ChildObjDat_74190(pc),a2
		jsr	(CreateChild1_Normal).l
		move.b	$39(a0),d0
		addq.b	#1,$39(a0)
		andi.w	#7,d0
		move.b	byte_73F3A(pc,d0.w),$2C(a1)
		rts
; ---------------------------------------------------------------------------
byte_73F3A:	dc.b 0
		dc.b 2
		dc.b 1
		dc.b 2
		dc.b 0
		dc.b 1
		dc.b 2
		dc.b 1
; ---------------------------------------------------------------------------

loc_73F42:
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#3,d0
		lea	word_73F64(pc,d0.w),a1
		move.w	(a1)+,d0
		add.w	d0,$10(a0)
		move.w	(a1)+,d0
		add.w	d0,$14(a0)
		move.w	(a1)+,$18(a0)
		move.w	(a1)+,$1A(a0)
		rts
; ---------------------------------------------------------------------------
word_73F64:	dc.w  $FFF0,   $60
		dc.w  $FA00, $FE00
		dc.w  $FFF0,   $60
		dc.w  $FC00, $FF00
		dc.w  $FFF0,   $90
		dc.w  $FC00,	 0
; ---------------------------------------------------------------------------

loc_73F7C:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,d1
		move.w	d0,d2
		cmpi.b	#8,d0
		bcs.s	loc_73F98
		move.b	#$B,$22(a0)
		subi.w	#8,d2
		move.w	d2,d1

loc_73F98:
		add.w	d0,d0
		lea	word_73FAE(pc,d0.w),a1
		move.w	(a1)+,$18(a0)
		move.w	(a1)+,$1A(a0)
		lsr.w	#1,d1
		or.b	d1,4(a0)
		rts
; ---------------------------------------------------------------------------
word_73FAE:	dc.w  $FD00, $FD00
		dc.w   $300, $FD00
		dc.w  $FD00, $FE00
		dc.w   $300, $FE00
		dc.w  $FC00, $FC00
		dc.w   $400, $FC00
		dc.w  $FC00, $FD00
		dc.w   $400, $FD00

; =============== S U B R O U T I N E =======================================


sub_73FCE:

		move.w	$10(a0),-(sp)
		jsr	(a2)
		moveq	#$12,d1
		moveq	#7,d2
		moveq	#7,d3
		move.w	(sp)+,d4
		jmp	(SolidObjectTop).l
; End of function sub_73FCE


; =============== S U B R O U T I N E =======================================


sub_73FE2:
		tst.l	(a0)
		beq.s	locret_74038
		tst.b	$28(a0)
		bne.s	locret_74038
		tst.b	$29(a0)
		beq.s	loc_7403A
		tst.b	$20(a0)
		bne.s	loc_74006
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l

loc_74006:
		bset	#6,$2A(a0)
		lea	($FFFFFC36).w,a1
		move.w	#$222,d0
		btst	#0,$20(a0)
		bne.s	loc_74020
		move.w	#$EEE,d0

loc_74020:
		move.w	d0,(a1)
		subq.b	#1,$20(a0)
		bne.s	locret_74038
		bclr	#6,$2A(a0)
		move.w	#$222,(a1)
		move.b	$25(a0),$28(a0)

locret_74038:
		rts
; ---------------------------------------------------------------------------

loc_7403A:
		move.l	#loc_73A52,(a0)
		clr.b	($FFFFFE1E).w
		moveq	#$64,d0
		jsr	(HUD_AddToScore).l
		bclr	#7,4(a0)
		move.w	#$7F,$2E(a0)
		bset	#4,$38(a0)
		move.w	#-$5BDB,$A(a0)
		move.w	#-$200,$1A(a0)
		move.l	#loc_73A6A,$34(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild1_Normal).l
		bne.s	loc_74086
		move.b	#4,$2C(a1)

loc_74086:
		move.w	#$3AB8,($FFFFFA92).w
		lea	(Child6_IncLevX).l,a2
		jmp	(CreateChild6_Simple).l
; End of function sub_73FE2

; ---------------------------------------------------------------------------

loc_74098:

		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_740AA
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_740AA:
		move.l	#MoveChkDel,(a0)
		bset	#7,$2A(a0)
		move.w	#-$5BDB,$A(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_740E4(pc,d0.w),$18(a0)
		move.w	#-$200,$1A(a0)
		jsr	(Displace_PlayerOffObject).l
		lea	($FFFFB04A).w,a1
		bclr	#4,$2A(a1)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
word_740E4:	dc.w $300
		dc.w $200
		dc.w $FE00
		dc.w $FD00
ObjDat3_740EC:	dc.l Map_LBZEndBoss
		dc.w $2425
		dc.w $280
		dc.b $20
		dc.b $10
		dc.b 0
		dc.b $18
ObjDat3_740F8:	dc.l Map_FBZRobotnikRun
		dc.w $4A9
		dc.w $280
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b 0
ObjDat3_74104:	dc.l Map_RobotnikShip
		dc.w $852E
		dc.w $300
		dc.b $10
		dc.b 8
		dc.b 4
		dc.b 0
ObjDat3_74110:	dc.l Map_LBZEndBoss
		dc.w $2425
		dc.w 0
		dc.b 8
		dc.b $80
		dc.b $C
		dc.b 0
word_7411C:	dc.w $280
		dc.b 8
		dc.b $18
		dc.b 2
		dc.b 0
word_74122:	dc.w $A425
		dc.w $200
		dc.b 8
		dc.b 8
		dc.b $D
		dc.b 0
word_7412A:	dc.w $280
		dc.b $10
		dc.b $10
		dc.b 5
		dc.b $9A
word_74130:	dc.w $425
		dc.w $200
		dc.b 8
		dc.b 8
		dc.b 7
		dc.b 0
word_74138:	dc.w $A425
		dc.w $200
		dc.b 8
		dc.b 8
		dc.b $A
		dc.b 0
ObjDat3_74140:	dc.l Map_LBZEndBoss
		dc.w $4425
		dc.w $280
		dc.b 8
		dc.b 8
		dc.b $E
		dc.b 0
ChildObjDat_7414C:dc.w 1
		dc.l loc_73E0E
		dc.w $F8
		dc.l loc_73EA2
		dc.w $E890
ChildObjDat_7415A:dc.w 0
		dc.l loc_73D74
		dc.w $70E8
ChildObjDat_74162:dc.w 2
		dc.l loc_73C0A
		dc.w $E838
		dc.l loc_73C0A
		dc.w $1838
		dc.l loc_73C0A
		dc.w $38
ChildObjDat_74176:dc.w 2
		dc.l loc_73C82
		dc.w $E8
		dc.l loc_73C82
		dc.w $F8
		dc.l loc_73C82
		dc.w 8
ChildObjDat_7418A:dc.w 3
		dc.l loc_73CB0
ChildObjDat_74190:dc.w 0
		dc.l loc_73A92
		dc.w 0
ChildObjDat_74198:dc.w 0
		dc.l loc_73BA0
		dc.w $10
ChildObjDat_741A0:dc.w $B
		dc.l loc_73BF6
		dc.w $F8F8
		dc.l loc_73BF6
		dc.w $8F8
		dc.l loc_73BF6
		dc.w $F808
		dc.l loc_73BF6
		dc.w $808
		dc.l loc_73BF6
		dc.w $F0F0
		dc.l loc_73BF6
		dc.w $10F0
		dc.l loc_73BF6
		dc.w $F010
		dc.l loc_73BF6
		dc.w $1010
		dc.l loc_73BA0
		dc.w $F806
		dc.l loc_73BA0
		dc.w $608
		dc.l loc_73BA0
		dc.w $F8FA
		dc.l loc_73BA0
		dc.w $6F8
byte_741EA:	dc.b 7
		dc.b 0
		dc.b 1
		dc.b 2
		dc.b 1
		dc.b $FC
byte_741F0:	dc.b 7
		dc.b 0
		dc.b 1
		dc.b $FC
byte_741F4:	dc.b 0
		dc.b 5
		dc.b 6
		dc.b $FC
byte_741F8:	dc.b 5
		dc.b 7
		dc.b 7
		dc.b 8
		dc.b 9
		dc.b $F4
Pal_LBZEndBoss:	binclude "Levels\LBZ\Palettes\End Boss.bin"

; ---------------------------------------------------------------------------

Obj_LBZ_FinalBoss2:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7427C(pc,d0.w),d1
		jsr	off_7427C(pc,d1.w)
		jsr	(sub_74FD2).l
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_7427C:	dc.w loc_742A8-off_7427C
		dc.w loc_7430E-off_7427C
		dc.w loc_7430E-off_7427C
		dc.w loc_7432A-off_7427C
		dc.w loc_7430E-off_7427C
		dc.w loc_743CE-off_7427C
		dc.w loc_74412-off_7427C
		dc.w loc_74442-off_7427C
		dc.w loc_74456-off_7427C
		dc.w loc_7447A-off_7427C
		dc.w loc_744A4-off_7427C
		dc.w loc_744E4-off_7427C
		dc.w loc_744FC-off_7427C
		dc.w loc_74528-off_7427C
		dc.w loc_74542-off_7427C
		dc.w loc_7455C-off_7427C
		dc.w loc_74576-off_7427C
		dc.w loc_745A2-off_7427C
		dc.w loc_745E2-off_7427C
		dc.w loc_74618-off_7427C
		dc.w loc_7463A-off_7427C
		dc.w loc_746C8-off_7427C
; ---------------------------------------------------------------------------

loc_742A8:
		lea	ObjDat3_750B6(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#8,$29(a0)
		bset	#3,$38(a0)
		st	($FFFFF665).w
		move.w	($FFFFEE78).w,d0
		addi.w	#$A0,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d0
		subi.w	#$50,d0
		move.w	d0,$14(a0)
		move.w	#$59,$2E(a0)
		move.l	#loc_74314,$34(a0)
		lea	Pal_LBZFinalBoss2(pc),a1
		jsr	(PalLoad_Line1).l
		lea	(ArtKosM_LBZFinalBoss2).l,a1
		move.w	#$7B20,d2
		jsr	(Queue_Kos_Module).l
		lea	(Child1_MakeRoboHead4).l,a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_7430E:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_74314:
		move.b	#6,5(a0)
		move.b	#8,$22(a0)
		lea	ChildObjDat_75122(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_7432A:
		jsr	(MoveSprite_LightGravity).l
		move.w	($FFFFEE7C).w,d0
		addi.w	#$120,d0
		cmp.w	$14(a0),d0
		bcs.s	loc_74340
		rts
; ---------------------------------------------------------------------------

loc_74340:
		bset	#7,$A(a0)
		clr.w	$1A(a0)
		move.b	#$F,$28(a0)
		bchg	#0,4(a0)
		lea	ChildObjDat_7513C(pc),a2
		jsr	(CreateChild1_Normal).l

loc_74360:


		move.b	#8,5(a0)
		move.w	#$7F,$2E(a0)
		move.l	#loc_74376,$34(a0)

locret_74374:

		rts
; ---------------------------------------------------------------------------

loc_74376:
		bchg	#0,4(a0)
		move.b	$39(a0),d0
		addq.b	#1,$39(a0)
		btst	#2,d0
		bne.s	loc_743AE
		move.b	#$A,5(a0)
		bclr	#3,$38(a0)
		bclr	#2,$38(a0)
		move.w	#$AF,$2E(a0)
		move.l	#loc_74360,$34(a0)
		bra.w	loc_74F24
; ---------------------------------------------------------------------------

loc_743AE:
		move.b	#$C,5(a0)
		clr.b	$39(a0)
		clr.w	$1A(a0)
		move.l	#loc_74428,$34(a0)
		move.w	($FFFFEE7C).w,$14(a0)
		bra.w	loc_74F82
; ---------------------------------------------------------------------------

loc_743CE:
		move.w	$3A(a0),d0
		move.w	off_743E6(pc,d0.w),d0
		jsr	off_743E6(pc,d0.w)
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------
off_743E6:	dc.w locret_743F4-off_743E6

		dc.w loc_743F0-off_743E6
		dc.w loc_743F6-off_743E6
		dc.w locret_743F4-off_743E6
		dc.w loc_7440C-off_743E6
; ---------------------------------------------------------------------------

loc_743F0:
		subq.w	#4,$1A(a0)

locret_743F4:
		rts
; ---------------------------------------------------------------------------

loc_743F6:
		move.w	$1A(a0),d0
		add.w	$3C(a0),d0
		move.w	d0,$1A(a0)
		bne.s	locret_7440A
		move.w	#2,$3C(a0)

locret_7440A:
		rts
; ---------------------------------------------------------------------------

loc_7440C:
		subq.w	#4,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_74412:
		moveq	#$50,d1
		move.w	#$F0,d2
		bsr.w	sub_74FA8
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_74428:
		move.b	#$E,5(a0)
		clr.w	$18(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_74448,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_74442:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_74448:
		move.b	#$10,5(a0)
		bset	#3,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_74456:
		jsr	(MoveSprite_LightGravity).l
		move.w	($FFFFEE84).w,d0
		addi.w	#$C0,d0
		cmp.w	$14(a0),d0
		bcs.s	loc_7446C
		rts
; ---------------------------------------------------------------------------

loc_7446C:
		move.b	#$12,5(a0)
		bset	#2,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_7447A:
		addi.w	#-$80,$1A(a0)
		jsr	(MoveSprite2).l
		tst.w	$1A(a0)
		bpl.s	locret_7449A
		move.w	($FFFFEE84).w,d0
		addi.w	#$E0,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_7449C

locret_7449A:
		rts
; ---------------------------------------------------------------------------

loc_7449C:
		move.b	#$14,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_744A4:
		addi.w	#$40,$1A(a0)
		jsr	(MoveSprite2).l
		tst.w	$1A(a0)
		bmi.s	locret_744C4
		move.w	($FFFFEE84).w,d0
		addi.w	#$D0,d0
		cmp.w	$14(a0),d0
		bls.s	loc_744C6

locret_744C4:
		rts
; ---------------------------------------------------------------------------

loc_744C6:
		move.b	#$16,5(a0)
		move.w	d0,$14(a0)
		clr.w	$1A(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_744EA,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_744E4:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_744EA:
		move.b	#$18,5(a0)
		move.l	#loc_74512,$34(a0)
		bra.w	loc_74F82
; ---------------------------------------------------------------------------

loc_744FC:
		moveq	#$30,d1
		move.w	#$110,d2
		bsr.w	sub_74FA8
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_74512:
		move.b	#$1A,5(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_7452E,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_74528:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7452E:
		move.b	#$1C,5(a0)
		move.w	#-$400,$1A(a0)
		bclr	#3,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_74542:
		jsr	(MoveSprite2).l
		move.w	($FFFFEE7C).w,d0
		subi.w	#$60,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_74558
		rts
; ---------------------------------------------------------------------------

loc_74558:
		bra.w	loc_74360
; ---------------------------------------------------------------------------

loc_7455C:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_74562:
		move.b	#$20,5(a0)
		move.w	#-$400,$1A(a0)
		bchg	#1,$39(a0)
		rts
; ---------------------------------------------------------------------------

loc_74576:
		jsr	(MoveSprite2).l
		move.w	($FFFFEE7C).w,d0
		subi.w	#$60,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_7458C
		rts
; ---------------------------------------------------------------------------

loc_7458C:
		move.b	#$22,5(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_745A8,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_745A2:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_745A8:
		move.b	#$24,5(a0)
		movea.w	$44(a0),a1
		clr.b	$3C(a1)
		move.w	($FFFFEE78).w,d0
		move.w	d0,d1
		addi.w	#$A0,d0
		bclr	#0,4(a0)
		move.w	#$E0,d2
		cmp.w	$10(a0),d0
		bcs.s	loc_745DA
		bset	#0,4(a0)
		move.w	#$60,d2

loc_745DA:
		add.w	d2,d1
		move.w	d1,$10(a0)
		rts
; ---------------------------------------------------------------------------

loc_745E2:
		move.w	($FFFFEE84).w,d0
		addi.w	#$88,d0
		cmp.w	$14(a0),d0
		bls.s	loc_745F6
		addq.w	#8,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_745F6:
		move.b	#$26,5(a0)
		bset	#1,$38(a0)
		move.w	#$14,($FFFFEECC).w
		move.w	#3,$2E(a0)
		moveq	#$61,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_74618:
		addq.w	#4,$14(a0)
		subq.w	#1,$2E(a0)
		bmi.s	loc_74624
		rts
; ---------------------------------------------------------------------------

loc_74624:
		move.b	#$28,5(a0)
		move.w	#7,$2E(a0)
		move.l	#loc_74640,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7463A:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_74640:
		move.b	#$2A,5(a0)
		clr.b	$30(a0)
		subi.w	#$10,$14(a0)
		bclr	#1,$38(a0)
		move.w	#$400,d0
		btst	#0,4(a0)
		beq.s	loc_74664
		neg.w	d0

loc_74664:
		move.w	d0,$18(a0)
		move.w	#-$600,$1A(a0)
		move.w	#$3F,$2E(a0)
		btst	#1,($FFFFB02B).w
		bne.s	loc_7468C
		movea.l	a0,a2
		lea	($FFFFB000).w,a0
		jsr	(HurtSonic2).l
		movea.l	a2,a0
		rts
; ---------------------------------------------------------------------------

loc_7468C:
		lea	($FFFFB000).w,a1
		clr.b	$2E(a1)
		neg.w	d0
		move.w	d0,$18(a1)
		move.w	#-$400,$1A(a1)
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		clr.b	$40(a1)
		clr.b	$3D(a1)
		move.b	#2,$20(a1)
		move.b	#2,5(a1)
		moveq	#-$4F,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

loc_746C8:
		jsr	(MoveSprite).l
		subq.w	#1,$2E(a0)
		bmi.w	loc_74360
		rts
; ---------------------------------------------------------------------------

loc_746D8:
		move.l	#loc_746F4,(a0)
		move.b	#5,$22(a0)
		bset	#4,$38(a0)
		lea	ChildObjDat_7515E(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_746F4:
		move.w	$14(a0),d0
		subq.w	#1,d0
		move.w	d0,$14(a0)
		move.w	($FFFFEE7C).w,d1
		subi.w	#$40,d1
		cmp.w	d1,d0
		bcs.s	loc_74710
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_74710:
		move.l	#loc_7473A,(a0)
		bclr	#7,4(a0)
		bset	#5,$38(a0)
		bset	#0,4(a0)
		move.w	($FFFFEE78).w,d2
		addi.w	#$40,d2
		move.w	d2,$10(a0)
		jmp	(loc_694AA).l
; ---------------------------------------------------------------------------

loc_7473A:
		tst.b	($FFFFFAA8).w
		bne.w	locret_74374
		tst.b	($FFFFFAA2).w
		beq.w	locret_74374
		move.l	#loc_74768,(a0)
		jsr	sub_7302E(pc)
		bclr	#7,$2A(a0)
		jsr	(Restore_PlayerControl).l
		clr.w	($FFFFF602).w
		st	($FFFFF7CA).w

loc_74768:
		lea	($FFFFB000).w,a1
		move.w	#$808,d0
		move.w	($FFFFEE78).w,d1
		addi.w	#$50,d1
		sub.w	$10(a1),d1
		bcc.s	loc_74784
		move.w	#$404,d0
		neg.w	d1

loc_74784:
		move.w	d0,($FFFFF602).w
		cmpi.w	#8,d1
		bcc.w	locret_74374
		move.l	#loc_747D6,(a0)
		clr.w	($FFFFF602).w
		bset	#0,4(a1)
		bset	#0,$2A(a1)
		jsr	(Stop_Object).l
		moveq	#$71,d0
		jsr	(Load_PLC).l
		lea	(ArtKosM_EggRoboHead).l,a1
		move.w	#-$5A40,d2
		jsr	(Queue_Kos_Module).l
		bclr	#5,$38(a0)
		lea	(Child1_MakeRoboHead4).l,a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_747D6:
		move.w	#$101,($FFFFF602).w
		move.w	$14(a0),d0
		addq.w	#1,d0
		move.w	($FFFFEE7C).w,d1
		addi.w	#$40,d1
		cmp.w	d1,d0
		bcc.s	loc_747F8
		move.w	d0,$14(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_747F8:
		move.l	#loc_7481C,(a0)
		move.w	#$200,$18(a0)
		jsr	(Swing_Setup1).l
		lea	(Child1_MakeRoboShipFlame).l,a2
		jsr	(CreateChild1_Normal).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7481C:
		move.w	#$101,($FFFFF602).w
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		move.w	$10(a0),d0
		lea	($FFFFB000).w,a1
		bclr	#0,4(a1)
		bclr	#0,$2A(a1)
		cmp.w	$10(a1),d0
		bcc.s	loc_74854
		bset	#0,4(a1)
		bset	#0,$2A(a1)

loc_74854:
		move.w	($FFFFEE78).w,d1
		addi.w	#$A0,d1
		cmp.w	d1,d0
		bcc.s	loc_74866
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_74866:
		move.w	d0,$10(a0)
		move.l	#loc_74894,(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_748A0,$34(a0)
		bclr	#3,$38(a0)
		lea	ChildObjDat_7517E(pc),a2
		jsr	(CreateChild1_Normal).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_74894:
		jsr	(Obj_Wait).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_748A0:
		move.l	#loc_748AE,(a0)
		move.w	#$400,$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_748AE:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		move.w	$10(a0),d0
		move.w	($FFFFEE78).w,d1
		addi.w	#$1C0,d1
		cmp.w	d1,d0
		bcc.s	loc_748D0
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_748D0:
		move.l	#loc_748F4,(a0)
		bset	#6,$2A(a0)
		bset	#4,$38(a0)
		bset	#5,$38(a0)
		clr.b	($FFFFF7AA).w
		bclr	#7,4(a0)
		rts
; ---------------------------------------------------------------------------

loc_748F4:
		btst	#3,$38(a0)
		beq.s	locret_74908
		move.l	#loc_7490A,(a0)
		move.w	#$808,($FFFFF602).w

locret_74908:
		rts
; ---------------------------------------------------------------------------

loc_7490A:
		cmpi.w	#$4510,($FFFFB010).w
		bcs.s	locret_74950
		move.l	#loc_74952,(a0)
		lea	($FFFFB000).w,a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		move.b	#-$7D,$2E(a1)
		move.b	#-$74,$22(a1)
		jsr	(Player_Load_PLC).l
		clr.b	$23(a0)
		move.b	#$A,$24(a0)
		move.w	#$200,$18(a0)
		move.w	#-$400,$1A(a0)

locret_74950:
		rts
; ---------------------------------------------------------------------------

loc_74952:
		jsr	(MoveSprite_LightGravity).l
		lea	($FFFFB000).w,a1
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		subq.b	#1,$24(a0)
		bpl.s	loc_7498E
		move.b	#$A,$24(a0)
		addq.b	#1,$23(a0)
		moveq	#-$74,d0
		btst	#0,$23(a0)
		bne.s	loc_74984
		moveq	#-$73,d0

loc_74984:
		move.b	d0,$22(a1)
		jsr	(Player_Load_PLC).l

loc_7498E:
		move.w	($FFFFFAB0).w,d0
		addi.w	#$200,d0
		cmp.w	($FFFFB014).w,d0
		bhi.w	locret_74374
		move.w	#$700,d0
		jsr	(StartNewLevel).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_749AE:
		lea	ObjDat3_750C2(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_749BE,(a0)

loc_749BE:
		jsr	(Child_GetPriorityOnce).l
		jsr	(Refresh_ChildPositionAdjusted).l
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------

loc_749D0:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_749E6(pc,d0.w),d1
		jsr	off_749E6(pc,d1.w)
		moveq	#$C,d0
		jmp	(Child_DrawTouch_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------
off_749E6:	dc.w loc_749EC-off_749E6
		dc.w loc_74A14-off_749E6
		dc.w loc_74A3E-off_749E6
; ---------------------------------------------------------------------------

loc_749EC:
		lea	ObjDat3_750CE(pc),a1
		jsr	(SetUp_ObjAttributes).l
		movea.w	$46(a0),a1
		move.w	a0,$44(a1)
		move.b	#$14,$42(a0)
		move.b	#-6,$43(a0)
		lea	ChildObjDat_75144(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_74A14:
		movea.w	$46(a0),a1
		btst	#7,$A(a1)
		beq.s	loc_74A32
		bset	#7,$A(a0)
		move.b	#4,5(a0)
		move.b	#-$53,$28(a0)

loc_74A32:
		lea	(LBZFinalBoss2_CircleLookup).l,a2
		jmp	(MoveSprite_CircularLookup).l
; ---------------------------------------------------------------------------

loc_74A3E:
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		bne.w	locret_74374
		btst	#2,$38(a1)
		bne.s	loc_74A88
		lea	($FFFFB000).w,a1
		move.b	$3C(a0),d0
		move.w	$14(a0),d1
		sub.w	$14(a1),d1
		cmpi.w	#-2,d1
		blt.s	loc_74A7C
		cmpi.w	#2,d1
		ble.s	loc_74A88
		subq.b	#1,d0
		cmpi.b	#-$30,d0
		blt.s	loc_74A88
		bra.w	loc_74A84
; ---------------------------------------------------------------------------

loc_74A7C:
		addq.b	#1,d0
		cmpi.b	#0,d0
		bgt.s	loc_74A88

loc_74A84:
		move.b	d0,$3C(a0)

loc_74A88:

		jsr	(Change_FlipXUseParent).l
		lea	(LBZFinalBoss2_CircleLookup).l,a2
		jmp	(MoveSprite_CircularLookup).l
; ---------------------------------------------------------------------------

loc_74A9A:
		lea	word_750E0(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_74ACA,(a0)
		movea.w	$46(a0),a1
		movea.w	$46(a1),a2
		move.w	a2,$46(a0)
		move.w	a1,$44(a0)
		move.w	a1,$44(a0)
		move.b	#$18,$42(a0)
		move.b	#-6,$43(a0)

loc_74ACA:
		jsr	(Child_GetPriorityOnce).l
		jsr	(Change_FlipXUseParent).l
		movea.w	$44(a0),a1
		move.b	$3C(a1),d0
		addi.b	#$14,d0
		move.b	d0,$3C(a0)
		lea	(LBZ2FinalBoss2_CircleLookup2).l,a2
		jsr	(MoveSprite_CircularLookup).l
		moveq	#$C,d0
		jmp	(Child_DrawTouch_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------

loc_74AFA:

		lea	word_750DA(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		movea.w	$46(a0),a1
		move.w	$46(a1),$44(a0)
		move.l	#loc_74B36,(a0)
		move.l	#byte_75194,$30(a0)
		tst.b	$2C(a0)
		beq.s	loc_74B36
		move.b	#8,$22(a0)
		move.w	#$180,8(a0)
		move.l	#byte_7519C,$30(a0)

loc_74B36:

		jsr	(Child_GetPriorityOnce).l

loc_74B3C:
		jsr	(Refresh_ChildPositionAdjusted).l
		jsr	(Animate_Raw).l
		movea.w	$44(a0),a1
		tst.b	$30(a1)
		beq.s	loc_74B6E
		move.l	#loc_74B76,(a0)
		move.b	#7,$22(a0)
		tst.b	$2C(a0)
		beq.s	loc_74B6E
		move.b	#$B,$22(a0)
		addq.b	#8,$42(a0)

loc_74B6E:

		moveq	#$C,d0
		jmp	(Child_DrawTouch_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------

loc_74B76:
		jsr	(Refresh_ChildPositionAdjusted).l
		movea.w	$44(a0),a1
		tst.b	$30(a1)
		bne.s	loc_74B96
		move.l	#loc_74B3C,(a0)
		tst.b	$2C(a0)
		beq.s	loc_74B96
		subq.b	#8,$42(a0)

loc_74B96:

		moveq	#$C,d0
		jmp	(Child_DrawTouch_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------

loc_74B9E:
		lea	ObjDat3_750E6(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_74BAE,(a0)

loc_74BAE:
		jsr	(Child_GetPriorityOnce).l
		jsr	(Refresh_ChildPositionAdjusted).l
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------

loc_74BC0:
		lea	ObjDat3_750F2(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_74BD0,(a0)

loc_74BD0:
		move.b	#-$66,d0
		bsr.w	sub_74EBC
		jsr	(Refresh_ChildPositionAdjusted).l
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_74BFA
		btst	#0,($FFFFFE0F).w
		bne.w	locret_74374
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_74BFA:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_74C00:
		move.l	#loc_74C0C,(a0)
		move.b	#-$64,$28(a0)

loc_74C0C:
		jsr	(Refresh_ChildPositionAdjusted).l
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_74BFA
		jmp	(Add_SpriteToCollisionResponseList).l
; ---------------------------------------------------------------------------

loc_74C24:
		move.l	#loc_74C34,(a0)
		movea.w	$46(a0),a1
		move.w	$46(a1),$44(a0)

loc_74C34:

		jsr	(Refresh_ChildPositionAdjusted).l
		movea.w	$44(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_74C7A
		btst	#3,$38(a1)
		bne.w	locret_74374
		btst	#6,$2A(a1)
		bne.w	locret_74374
		lea	word_74C84(pc),a1
		jsr	(Check_PlayerInRange).l
		tst.w	d0
		beq.s	locret_74C78
		movea.w	d0,a1
		tst.b	$34(a1)
		bne.s	locret_74C78
		cmpi.b	#6,5(a1)
		bcs.s	loc_74C8C

locret_74C78:

		rts
; ---------------------------------------------------------------------------

loc_74C7A:
		clr.b	($FFFFB02E).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
word_74C84:	dc.w  $FFF0,   $20, $FFF0,   $20
; ---------------------------------------------------------------------------

loc_74C8C:
		move.l	#loc_74CCC,(a0)
		movea.w	$44(a0),a1
		st	$30(a1)
		move.b	#$1E,5(a1)
		move.w	#$40,$2E(a1)
		move.l	#loc_74562,$34(a1)
		lea	($FFFFB000).w,a1
		move.b	#-$7F,$2E(a1)
		move.b	#2,$20(a1)
		moveq	#0,d0
		move.w	d0,$18(a1)
		move.w	d0,$1A(a1)
		move.w	d0,$1C(a1)

loc_74CCC:
		movea.w	$44(a0),a1
		tst.b	$30(a1)
		beq.s	loc_74CF8
		btst	#7,$2A(a1)
		bne.w	loc_74BFA
		jsr	(Refresh_ChildPositionAdjusted).l
		lea	($FFFFB000).w,a1
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		rts
; ---------------------------------------------------------------------------

loc_74CF8:
		move.l	#loc_74D04,(a0)
		move.w	#$40,$2E(a0)

loc_74D04:
		subq.w	#1,$2E(a0)
		bmi.s	loc_74D0C
		rts
; ---------------------------------------------------------------------------

loc_74D0C:
		move.l	#loc_74C34,(a0)
		rts
; ---------------------------------------------------------------------------

loc_74D14:

		lea	ObjDat3_750FE(pc),a1
		jsr	(SetUp_ObjAttributes).l
		jsr	(Refresh_ChildPositionAdjusted).l
		move.l	#Obj_FlickerMove,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		addi.b	#$D,d0
		move.b	d0,$22(a0)
		moveq	#0,d0
		jsr	(Set_IndexedVelocity).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_74D48:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_74D5C(pc,d0.w),d1
		jsr	off_74D5C(pc,d1.w)
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_74D5C:	dc.w loc_74D62-off_74D5C

		dc.w loc_74D7C-off_74D5C
		dc.w loc_74DEA-off_74D5C
; ---------------------------------------------------------------------------

loc_74D62:
		lea	ObjDat3_7510A(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#$10,$1E(a0)
		move.l	#loc_74D90,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_74D7C:
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.w	locret_74374
		jmp	(ObjHitFloor_DoRoutine).l
; ---------------------------------------------------------------------------

loc_74D90:
		move.w	$1A(a0),d0
		cmpi.w	#$100,d0
		bcs.s	loc_74DA4
		asr.w	#1,d0
		neg.w	d0
		move.w	d0,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_74DA4:
		move.l	#loc_74DEA,(a0)
		move.b	#$7F,$39(a0)
		movea.w	$46(a0),a1
		bset	#3,$38(a1)
		lea	(ChildObjDat_690D8).l,a2
		jsr	(CreateChild1_Normal).l
		move.w	#$1000,d0
		move.w	d0,($FFFFFA98).w
		move.w	d0,($FFFFEE12).w
		move.w	#$6000,($FFFFFA92).w
		move.w	#0,($FFFFFA96).w
		lea	(Child1_Act2LevelSize).l,a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_74DEA:

		bclr	#7,4(a0)
		move.b	($FFFFFE0F).w,d0
		andi.b	#3,d0
		bne.w	locret_74374
		subq.b	#1,$39(a0)
		bmi.s	loc_74E0C
		lea	ChildObjDat_7518E(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_74E0C:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_74E12:
		lea	ObjDat3_75116(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_74E24,(a0)
		rts
; ---------------------------------------------------------------------------

loc_74E24:
		jsr	(Refresh_ChildPosition).l
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------

loc_74E30:
		jsr	(Random_Number).l
		andi.w	#$3C,d0
		lea	word_74E7C(pc,d0.w),a1
		move.w	(a1)+,$10(a0)
		move.w	(a1)+,$14(a0)
		move.l	#Obj_Wait,(a0)
		move.w	#$60,$2E(a0)
		move.l	#loc_74E70,$34(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild1_Normal).l
		bne.s	locret_74E6E
		move.b	#4,$2C(a1)

locret_74E6E:
		rts
; ---------------------------------------------------------------------------

loc_74E70:
		bset	#5,$38(a0)
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------
word_74E7C:	dc.w  $4310,  $3ED
		dc.w  $4330,  $3F0
		dc.w  $4350,  $3F0
		dc.w  $4370,  $3F0
		dc.w  $4390,  $3F0
		dc.w  $43B0,  $3F0
		dc.w  $43D0,  $3F0
		dc.w  $43F0,  $3F0
		dc.w  $4410,  $3F0
		dc.w  $4430,  $3ED
		dc.w  $4450,  $3E5
		dc.w  $4470,  $3D6
		dc.w  $4490,  $3B8
		dc.w  $44B0,  $3A2
		dc.w  $44D0,  $395
		dc.w  $44F0,  $390

; =============== S U B R O U T I N E =======================================


sub_74EBC:
		movea.w	$46(a0),a1
		btst	#7,$A(a1)
		beq.s	locret_74ED4
		bset	#7,$A(a0)
		move.l	(sp),(a0)
		move.b	d0,$28(a0)

locret_74ED4:
		rts
; End of function sub_74EBC

; ---------------------------------------------------------------------------
		movea.w	$44(a0),a1
		movea.w	$46(a0),a2
		move.w	$10(a1),d0
		moveq	#$10,d2
		btst	#0,4(a2)
		beq.s	loc_74EEE
		neg.w	d2

loc_74EEE:
		add.w	d2,d0
		move.w	$10(a2),d1
		moveq	#$C,d2
		btst	#0,4(a2)
		beq.s	loc_74F00
		neg.w	d2

loc_74F00:
		add.w	d2,d1
		sub.w	d1,d0
		asr.w	#1,d0
		add.w	d0,d1
		move.w	d1,$10(a0)
		move.w	$14(a1),d0
		subq.w	#4,d0
		move.w	$14(a2),d1
		subq.w	#4,d1
		sub.w	d1,d0
		asr.w	#1,d0
		add.w	d0,d1
		move.w	d1,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_74F24:
		jsr	(Random_Number).l
		andi.w	#6,d0
		move.w	d0,$3A(a0)
		move.w	($FFFFEE78).w,d1
		move.w	#$1A8,d2
		move.w	#-$300,d3
		btst	#0,4(a0)
		beq.s	loc_74F4C
		move.w	#-$68,d2
		neg.w	d3

loc_74F4C:
		add.w	d2,d1
		move.w	d1,$10(a0)
		move.w	d3,$18(a0)
		move.w	($FFFFEE7C).w,d1
		move.w	word_74F72(pc,d0.w),d2
		add.w	d1,d2
		move.w	d2,$14(a0)
		move.w	word_74F7A(pc,d0.w),$1A(a0)
		move.w	#8,$3C(a0)
		rts
; ---------------------------------------------------------------------------
word_74F72:	dc.w $60
		dc.w $10
		dc.w $A0
		dc.w $80
word_74F7A:	dc.w 0
		dc.w $200
		dc.w $FE00
		dc.w 0
; ---------------------------------------------------------------------------

loc_74F82:

		move.w	#-$300,d0
		btst	#0,4(a0)
		beq.s	loc_74F90
		neg.w	d0

loc_74F90:
		move.w	d0,$18(a0)
		jsr	(Random_Number).l
		andi.w	#$7F,d0
		addi.w	#$C0,d0
		move.w	d0,$2E(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_74FA8:

		move.w	($FFFFEE78).w,d0
		tst.w	$18(a0)
		bmi.s	loc_74FBE
		add.w	d2,d0
		cmp.w	$10(a0),d0
		bls.s	loc_74FC6
		bra.w	locret_74FD0
; ---------------------------------------------------------------------------

loc_74FBE:
		add.w	d1,d0
		cmp.w	$10(a0),d0
		bcs.s	locret_74FD0

loc_74FC6:
		bchg	#0,4(a0)
		neg.w	$18(a0)

locret_74FD0:

		rts
; End of function sub_74FA8


; =============== S U B R O U T I N E =======================================


sub_74FD2:
		cmpi.b	#8,5(a0)
		bcs.s	locret_75044
		tst.b	$28(a0)
		bne.s	locret_75044
		move.b	$29(a0),d0
		beq.s	loc_75046
		tst.b	$20(a0)
		bne.s	loc_75010
		cmpi.b	#$A,5(a0)
		bne.s	loc_74FFA
		move.w	#8,$3A(a0)

loc_74FFA:
		move.b	#$3C,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		movea.w	$44(a0),a1
		clr.b	$28(a1)

loc_75010:
		bset	#6,$2A(a0)
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_75024
		addi.w	#$C,d0

loc_75024:
		bsr.w	sub_75084
		subq.b	#1,$20(a0)
		bne.s	locret_75044
		bclr	#6,$2A(a0)
		move.b	$25(a0),$28(a0)
		movea.w	$44(a0),a1
		move.b	#-$53,$28(a1)

locret_75044:
		rts
; ---------------------------------------------------------------------------

loc_75046:
		move.l	#Wait_FadeToLevelMusic,(a0)
		move.l	#loc_746D8,$34(a0)
		jsr	(BossDefeated_StopTimer).l
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_7506E
		move.b	#4,$2C(a1)

loc_7506E:
		tst.b	$30(a0)
		bne.s	loc_7507A
		jsr	(Restore_PlayerControl).l

loc_7507A:
		lea	ChildObjDat_75186(pc),a2
		jmp	(CreateChild1_Normal).l
; End of function sub_74FD2


; =============== S U B R O U T I N E =======================================


sub_75084:
		lea	word_75092(pc),a1
		lea	word_7509E(pc,d0.w),a2
		jmp	(CopyWordData_6).l
; End of function sub_75084

; ---------------------------------------------------------------------------
word_75092:	dc.w $FC28
		dc.w $FC2E
		dc.w $FC30
		dc.w $FC38
		dc.w $FC3A
		dc.w $FC3C
word_7509E:	dc.w 8
		dc.w $A
		dc.w 4
		dc.w $644
		dc.w $422
		dc.w 0
		dc.w $888
		dc.w $666
		dc.w $AAA
		dc.w $AAA
		dc.w $EEE
		dc.w $EEE
ObjDat3_750B6:	dc.l Map_RobotnikShip
		dc.w $52E
		dc.w $280
		dc.b $1C
		dc.b $20
		dc.b 5
		dc.b 0
ObjDat3_750C2:	dc.l Map_LBZFinalBoss2
		dc.w $23D9
		dc.w $200
		dc.b $28
		dc.b $28
		dc.b 0
		dc.b 0
ObjDat3_750CE:	dc.l Map_LBZFinalBoss2
		dc.w $23D9
		dc.w $180
		dc.b $20
		dc.b $10
		dc.b 2
		dc.b 0
word_750DA:	dc.w $80
		dc.b $14
		dc.b $14
		dc.b 4
		dc.b 0
word_750E0:	dc.w $180
		dc.b 8
		dc.b 8
		dc.b 3
		dc.b 0
ObjDat3_750E6:	dc.l Map_LBZFinalBoss2
		dc.w $23D9
		dc.w $300
		dc.b $14
		dc.b $C
		dc.b 1
		dc.b 0
ObjDat3_750F2:	dc.l Map_LBZFinalBoss2
		dc.w $3D9
		dc.w $300
		dc.b $C
		dc.b $C
		dc.b $C
		dc.b 0
ObjDat3_750FE:	dc.l Map_LBZFinalBoss2
		dc.w $A3D9
		dc.w $100
		dc.b $10
		dc.b $14
		dc.b $D
		dc.b 0
ObjDat3_7510A:	dc.l Map_LBZFinalBoss1
		dc.w $A3AA
		dc.w $300
		dc.b $C
		dc.b $10
		dc.b $16
		dc.b 0
ObjDat3_75116:	dc.l Map_LBZFinalBoss1
		dc.w $A3AA
		dc.w $200
		dc.b $10
		dc.b 4
		dc.b $15
		dc.b 0
ChildObjDat_75122:dc.w 3
		dc.l loc_749D0
		dc.w $1424
		dc.l loc_749AE
		dc.w $CEC
		dc.l loc_74B9E
		dc.w $E8
		dc.l loc_74BC0
		dc.w $38EC
ChildObjDat_7513C:dc.w 0
		dc.l loc_74C00
		dc.w $4CC
ChildObjDat_75144:dc.w 3
		dc.l loc_74AFA
		dc.w $D6FE
		dc.l loc_74AFA
		dc.w $B6FE
		dc.l loc_74A9A
		dc.w 0
		dc.l loc_74C24
		dc.w $C0FE
ChildObjDat_7515E:dc.w 4
		dc.l loc_74D14
		dc.w $F4D4
		dc.l loc_74D14
		dc.w $14D4
		dc.l loc_74D14
		dc.w $2CE8
		dc.l loc_74D14
		dc.w $F4FC
		dc.l loc_74D14
		dc.w $14FC
ChildObjDat_7517E:dc.w 0
		dc.l loc_74D48
		dc.w 8
ChildObjDat_75186:dc.w 0
		dc.l loc_74E12
		dc.w $10
ChildObjDat_7518E:dc.w 0
		dc.l loc_74E30
byte_75194:	dc.b 9
		dc.b 7
		dc.b 4
		dc.b 5
		dc.b 6
		dc.b 5
		dc.b 4
		dc.b $FC
byte_7519C:	dc.b 9
		dc.b $B
		dc.b 8
		dc.b 9
		dc.b $A
		dc.b 9
		dc.b 8
		dc.b $FC
		dc.b 2
		dc.b 4
		dc.b 4
		dc.b 5
		dc.b 6
		dc.b $F4
Pal_LBZFinalBoss2:	binclude "Levels\LBZ\Palettes\Final Boss 2.bin"

; ---------------------------------------------------------------------------

Obj_MHZ_Miniboss:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_751F0(pc,d0.w),d1
		jsr	off_751F0(pc,d1.w)
		move.w	($FFFFEEBC).w,d0
		beq.s	loc_751E2
		sub.w	d0,$10(a0)

loc_751E2:
		bsr.w	sub_75D80
		bsr.w	sub_75D50
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_751F0:	dc.w loc_75220-off_751F0

		dc.w loc_752D4-off_751F0
		dc.w loc_7531C-off_751F0
		dc.w loc_752D4-off_751F0
		dc.w loc_75392-off_751F0
		dc.w loc_753B6-off_751F0
		dc.w loc_753DE-off_751F0
		dc.w loc_7541A-off_751F0
		dc.w loc_7544C-off_751F0
		dc.w loc_754A0-off_751F0
		dc.w loc_754E0-off_751F0
		dc.w loc_75532-off_751F0
		dc.w loc_75564-off_751F0
		dc.w loc_754A0-off_751F0
		dc.w loc_755AE-off_751F0
		dc.w loc_754A0-off_751F0
		dc.w loc_7560C-off_751F0
		dc.w loc_7565C-off_751F0
		dc.w loc_754A0-off_751F0
		dc.w loc_75694-off_751F0
		dc.w loc_756C6-off_751F0
		dc.w loc_756FC-off_751F0
		dc.w loc_7571C-off_751F0
		dc.w loc_757A0-off_751F0
; ---------------------------------------------------------------------------

loc_75220:
		lea	ObjDat3_75E52(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.w	($FFFFEE78).w,d0
		addi.w	#$110,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d0
		subi.w	#$78,d0
		move.w	d0,$14(a0)
		move.b	#6,$29(a0)
		move.w	a0,($FFFFFAA4).w
		move.b	#5,$42(a0)
		move.l	($FFFFFE0C).w,($FFFFF636).w
		move.b	#1,($FFFFF7AA).w
		move.w	#$100,$1A(a0)
		move.w	#$97,$2E(a0)
		move.l	#loc_752E6,$34(a0)
		move.l	#byte_75EAE,$30(a0)
		move.b	#$18,$1E(a0)
		lea	ChildObjDat_75E84(pc),a2
		jsr	(CreateChild1_Normal).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_7529E
		move.l	#Obj_Song_Fade_Transition,(a1)
		move.b	#$2E,$2C(a1)

loc_7529E:
		lea	(ArtKosM_MHZMiniboss).l,a1
		move.w	#$75A0,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_MHZMinibossLog).l,a1
		move.w	#-$6C20,d2
		jsr	(Queue_Kos_Module).l
		lea	(PLC_75F48).l,a1
		jsr	(Load_PLC_Raw).l
		lea	Pal_MHZMiniboss(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_752D4:
		jsr	(Animate_RawMultiDelay).l
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_752E6:
		move.b	#4,5(a0)
		clr.w	$1A(a0)
		move.b	$11(a0),$3A(a0)
		move.w	$14(a0),$3C(a0)
		move.b	#3,$39(a0)

loc_75302:

		move.w	#$80,d0
		move.w	d0,$3E(a0)
		move.w	d0,$1A(a0)
		move.w	#$10,$40(a0)
		bclr	#0,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_7531C:
		jsr	(Animate_RawMultiDelay).l
		jsr	(Swing_UpAndDown_Count).l
		bne.s	loc_75330
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_75330:

		move.b	#6,5(a0)
		move.w	$3C(a0),$14(a0)
		move.w	#$400,$18(a0)
		clr.w	$1A(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_75356,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_75356:
		move.b	#8,5(a0)
		move.b	#5,$22(a0)
		move.w	#$4F,$2E(a0)
		move.l	#loc_753A4,$34(a0)
		move.w	#$6000,($FFFFEE0E).w
		move.w	#$6000,($FFFFFA92).w
		jsr	(Create_New_Sprite).l
		bne.s	locret_75390
		move.l	#loc_75E1A,(a1)
		move.w	($FFFFEE16).w,$34(a1)

locret_75390:
		rts
; ---------------------------------------------------------------------------

loc_75392:
		tst.b	4(a0)
		bpl.s	locret_753B4
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_753A4:
		move.b	#$A,5(a0)
		move.b	#4,$22(a0)
		addq.w	#2,$10(a0)

locret_753B4:
		rts
; ---------------------------------------------------------------------------

loc_753B6:
		move.w	$18(a0),d0
		addi.w	#-$20,d0
		move.w	d0,$18(a0)
		beq.s	loc_753CA
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_753CA:
		move.b	#$C,5(a0)
		move.b	$3A(a0),$11(a0)
		clr.w	$18(a0)
		bra.w	loc_75302
; ---------------------------------------------------------------------------

loc_753DE:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		move.w	$10(a0),d0
		sub.w	($FFFFEE78).w,d0
		cmpi.w	#$110,d0
		bls.s	loc_753FA
		rts
; ---------------------------------------------------------------------------

loc_753FA:
		move.b	#$E,5(a0)
		move.l	#byte_75EBB,$30(a0)
		move.l	#loc_75444,$34(a0)
		clr.b	$24(a0)
		clr.b	$23(a0)
		rts
; ---------------------------------------------------------------------------

loc_7541A:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jsr	(Animate_RawMultiDelay).l
		beq.s	locret_75442
		cmpi.b	#$A,$23(a0)
		bne.s	locret_75442
		subq.b	#1,$42(a0)
		moveq	#-$75,d0
		jsr	(Play_Sound_2).l

locret_75442:

		rts
; ---------------------------------------------------------------------------

loc_75444:

		move.b	#$10,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_7544C:
		jsr	(Swing_UpAndDown).l
		tst.w	d3
		bne.s	loc_7545C
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_7545C:
		move.b	#$12,5(a0)
		move.w	#$200,$1A(a0)
		cmpi.b	#1,$42(a0)
		beq.s	loc_75480
		move.w	#$F,$2E(a0)
		move.l	#loc_754AC,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_75480:
		move.w	#7,$2E(a0)
		move.l	#loc_754BE,$34(a0)
		cmpi.b	#2,($FFFFB038).w
		bne.s	locret_7549E
		move.l	#loc_754D6,$34(a0)

locret_7549E:
		rts
; ---------------------------------------------------------------------------

loc_754A0:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_754AC:
		move.b	#$E,5(a0)
		move.l	#loc_75444,$34(a0)
		bra.w	loc_75302
; ---------------------------------------------------------------------------

loc_754BE:
		move.b	#$14,5(a0)
		move.l	#byte_75ED0,$30(a0)
		move.l	#loc_75508,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_754D6:
		move.b	#$20,5(a0)
		bra.w	loc_75302
; ---------------------------------------------------------------------------

loc_754E0:
		jsr	(Animate_RawMultiDelay).l
		beq.s	locret_75506
		cmpi.b	#$12,$22(a0)
		bne.s	loc_754F8
		moveq	#-$74,d0
		jsr	(Play_Sound_2).l

loc_754F8:
		cmpi.b	#$C,$23(a0)
		bne.s	locret_75506
		subi.w	#$20,$10(a0)

locret_75506:

		rts
; ---------------------------------------------------------------------------

loc_75508:
		move.b	#$16,5(a0)
		bset	#6,$38(a0)
		move.l	#byte_75EF3,$30(a0)
		move.w	#-$400,$18(a0)
		move.w	#-$400,$1A(a0)
		moveq	#-$74,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_75532:
		jsr	(Animate_RawMultiDelay).l
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.s	locret_7554E
		jsr	(ObjHitFloor).l
		tst.w	d1
		bmi.s	loc_75550

locret_7554E:
		rts
; ---------------------------------------------------------------------------

loc_75550:
		move.b	#$18,5(a0)
		move.w	#-$200,$18(a0)
		move.w	#-$300,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_75564:
		jsr	(MoveSprite).l
		move.w	$1A(a0),d0
		bmi.s	locret_75576
		cmpi.w	#$100,d0
		bcc.s	loc_75578

locret_75576:
		rts
; ---------------------------------------------------------------------------

loc_75578:
		move.b	#$1A,5(a0)
		bclr	#6,$38(a0)
		move.w	#$100,$18(a0)
		move.w	#-$400,$1A(a0)
		move.w	#$10,$2E(a0)
		move.l	#loc_755A0,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_755A0:
		move.b	#$1C,5(a0)
		bset	#6,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_755AE:
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.s	locret_755C4
		move.w	$14(a0),d0
		cmp.w	$3C(a0),d0
		bcc.s	loc_755C6

locret_755C4:
		rts
; ---------------------------------------------------------------------------

loc_755C6:
		move.b	#$1E,5(a0)
		move.b	#5,$22(a0)
		bclr	#6,$38(a0)
		move.w	$3C(a0),$14(a0)
		clr.w	$16(a0)
		clr.w	$1A(a0)
		move.w	#$400,$18(a0)
		move.w	#$2A,$2E(a0)
		move.l	#loc_75330,$34(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		move.l	#byte_75F0D,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_7560C:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jsr	(Animate_RawMultiDelay).l
		beq.s	locret_7565A
		cmpi.b	#$A,$23(a0)
		bne.s	locret_7565A
		move.b	#$22,5(a0)
		move.b	#$F,$22(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		move.l	#byte_75F02,$30(a0)
		move.l	#loc_7566E,$34(a0)
		subq.b	#1,$42(a0)
		lea	ChildObjDat_75E9E(pc),a2
		jsr	(CreateChild1_Normal).l

locret_7565A:

		rts
; ---------------------------------------------------------------------------

loc_7565C:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_7566E:
		move.b	#$24,5(a0)
		move.w	#-$80,$1A(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_7568A,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7568A:
		move.b	#$26,5(a0)
		bra.w	loc_75302
; ---------------------------------------------------------------------------

loc_75694:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		btst	#2,$38(a0)
		bne.s	loc_756AA
		rts
; ---------------------------------------------------------------------------

loc_756AA:
		move.b	#$28,5(a0)
		move.b	#0,$22(a0)
		move.w	#-$200,$1A(a0)
		move.l	#byte_75EAE,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_756C6:
		jsr	(Animate_RawMultiDelay).l
		jsr	(MoveSprite2).l
		move.w	($FFFFEE7C).w,d0
		addi.w	#$30,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_756E2
		rts
; ---------------------------------------------------------------------------

loc_756E2:
		move.b	#$2A,5(a0)
		move.w	d0,$14(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_75708,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_756FC:
		jsr	(Animate_RawMultiDelay).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_75708:
		move.b	#$2C,5(a0)
		move.w	#-$400,$18(a0)
		move.w	#$700,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_7571C:
		jsr	(Animate_RawMultiDelay).l
		move.w	$1A(a0),d0
		addi.w	#-$48,d0
		cmpi.w	#-$700,d0
		blt.s	loc_75734
		move.w	d0,$1A(a0)

loc_75734:
		jsr	(MoveSprite2).l
		move.w	($FFFFEE7C).w,d0
		subi.w	#$80,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_7574A
		rts
; ---------------------------------------------------------------------------

loc_7574A:
		move.b	#$2E,5(a0)
		move.b	#5,$22(a0)
		move.w	($FFFFEE80).w,d0
		addi.w	#$30,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE84).w,d0
		subi.w	#$5C,d0
		move.w	d0,$14(a0)
		move.w	#$400,$18(a0)
		move.w	#$400,$1A(a0)
		move.w	#$37,$2E(a0)
		move.l	#loc_75330,$34(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		move.l	#byte_75F0D,$30(a0)
		bclr	#2,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_757A0:
		move.w	$1A(a0),d0
		addi.w	#-$10,d0
		bmi.s	loc_757AE
		move.w	d0,$1A(a0)

loc_757AE:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_757BA:
		jmp	(Obj_EndSignControl).l
; ---------------------------------------------------------------------------

loc_757C0:

		move.l	#loc_757D6,(a0)
		bset	#4,$2B(a0)
		lea	word_75E5E(pc),a1
		jmp	(SetUp_ObjAttributes2).l
; ---------------------------------------------------------------------------

loc_757D6:
		bsr.w	sub_75C8A
		jsr	(Refresh_ChildPositionAdjusted).l
		movea.w	$46(a0),a1
		btst	#6,$38(a1)
		bne.w	loc_7582A
		move.b	($FFFFFE0F).w,d0
		btst	#0,d0
		bne.w	loc_7582A
		andi.b	#$F,d0
		bne.s	loc_75824
		tst.b	4(a0)
		bpl.s	loc_75824
		jsr	(Create_New_Sprite).l
		bne.s	loc_75824
		move.l	#loc_759FC,(a1)
		move.w	a0,$46(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)

loc_75824:

		jmp	(Child_DrawTouch_Sprite).l
; ---------------------------------------------------------------------------

loc_7582A:

		btst	#7,$2A(a1)
		bne.s	loc_75834
		rts
; ---------------------------------------------------------------------------

loc_75834:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_7583A:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7584E(pc,d0.w),d1
		jsr	off_7584E(pc,d1.w)
		jmp	(Child_DrawTouch_Sprite).l
; ---------------------------------------------------------------------------
off_7584E:	dc.w loc_7585A-off_7584E

		dc.w loc_7589E-off_7584E
		dc.w loc_7592A-off_7584E
		dc.w loc_75924-off_7584E
		dc.w loc_7592A-off_7584E
		dc.w loc_75986-off_7584E
; ---------------------------------------------------------------------------

loc_7585A:
		lea	word_75E7E(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.b	#6,$1E(a0)
		move.w	#-$300,$1A(a0)
		move.l	#byte_75F1C,$30(a0)
		moveq	#0,d0
		lea	($FFFFB000).w,a1
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		beq.s	loc_7589A
		smi	d1
		bpl.s	loc_7588E
		neg.w	d0

loc_7588E:
		swap	d0
		divu.w	#$3800,d0
		tst.b	d1
		beq.s	loc_7589A
		neg.w	d0

loc_7589A:

		move.w	d0,$18(a0)

loc_7589E:
		jsr	(MoveSprite_LightGravity).l
		tst.w	$1A(a0)
		bmi.s	loc_758B8
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_758B8
		bsr.w	sub_758BE

loc_758B8:

		jmp	(Animate_RawMultiDelay).l

; =============== S U B R O U T I N E =======================================


sub_758BE:
		bset	#7,$38(a0)
		bne.s	loc_758E2
		add.w	d1,$14(a0)
		move.w	$18(a0),d0
		asr.w	#1,d0
		move.w	d0,$18(a0)
		move.w	$1A(a0),d0
		asr.w	#1,d0
		neg.w	d0
		move.w	d0,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_758E2:
		move.b	#4,5(a0)
		add.w	d1,$14(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_758FC,$34(a0)
		rts
; End of function sub_758BE

; ---------------------------------------------------------------------------

loc_758FC:
		move.b	#6,5(a0)
		clr.w	$18(a0)
		move.w	#-$200,$1A(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_75936,$34(a0)
		lea	ChildObjDat_75EA6(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_75924:
		jsr	(MoveSprite2).l

loc_7592A:
		jsr	(Animate_RawMultiDelay).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_75936:
		move.b	#8,5(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_7594C,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7594C:
		move.b	#$A,5(a0)
		move.w	#$180,8(a0)
		move.w	#-$300,$1A(a0)
		movea.w	$46(a0),a1
		moveq	#0,d0
		move.w	$10(a1),d0
		subq.w	#6,d0
		sub.w	$10(a0),d0
		smi	d1
		bpl.s	loc_75974
		neg.w	d0

loc_75974:
		swap	d0
		divu.w	#$6100,d0
		tst.b	d1
		beq.s	loc_75980
		neg.w	d0

loc_75980:
		move.w	d0,$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_75986:
		addi.w	#$10,$1A(a0)
		jsr	(MoveSprite2).l
		tst.w	$1A(a0)
		bmi.s	loc_759AA
		movea.w	$46(a0),a1
		move.w	$14(a1),d0
		addi.w	#-8,d0
		cmp.w	$14(a0),d0
		bls.s	loc_759B0

loc_759AA:
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_759B0:
		movea.w	$46(a0),a1
		bset	#2,$38(a1)
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_759C0:
		lea	word_75E5E(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#loc_759D0,(a0)

loc_759D0:
		movea.w	$46(a0),a1
		move.b	($FFFFFE0F).w,d0
		btst	#0,d0
		bne.w	loc_759EC
		jsr	(Refresh_ChildPosition).l
		jmp	(Child_DrawTouch_Sprite).l
; ---------------------------------------------------------------------------

loc_759EC:
		btst	#7,$2A(a1)
		bne.s	loc_759F6
		rts
; ---------------------------------------------------------------------------

loc_759F6:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_759FC:
		lea	(ObjDat3_6646E).l,a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_75A24,(a0)
		bsr.w	sub_75C06
		move.w	($FFFFEE7C).w,d0
		addi.w	#$AC,d0
		move.w	d0,$14(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_75A24:
		move.w	$18(a0),d0
		add.w	$40(a0),d0
		cmpi.w	#-$100,d0
		ble.s	loc_75A44
		cmpi.w	#$100,d0
		bge.s	loc_75A48
		move.l	#loc_75A48,(a0)
		bset	#0,$38(a0)

loc_75A44:
		move.w	d0,$18(a0)

loc_75A48:

		move.w	$1A(a0),d0
		move.w	$3E(a0),d1
		btst	#0,$38(a0)
		beq.s	loc_75A5A
		moveq	#-1,d1

loc_75A5A:
		sub.w	d1,d0
		cmpi.w	#$80,d0
		blt.s	loc_75A68
		move.l	#loc_75A6C,(a0)

loc_75A68:
		move.w	d0,$1A(a0)

loc_75A6C:
		jsr	(MoveSprite2).l
		tst.b	4(a0)
		bpl.s	loc_75A7E
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_75A7E:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_91_2:
		lea	ObjDat3_75E66(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_75A94,(a0)

loc_75A94:
		move.w	($FFFFFAA4).w,d0
		beq.s	loc_75ACE
		movea.w	d0,a1
		cmpi.l	#Obj_MHZ_Miniboss,(a1)
		bne.s	loc_75ACE
		tst.b	4(a0)
		bmi.s	loc_75AB0
		move.b	#5,$42(a1)

loc_75AB0:
		move.b	$42(a1),d0
		cmp.b	$22(a0),d0
		beq.s	loc_75ACE
		move.b	d0,$22(a0)
		cmpi.b	#5,d0
		bcc.s	loc_75ACE
		lea	ChildObjDat_75E98(pc),a2
		jsr	(CreateChild6_Simple).l

loc_75ACE:

		jmp	(Sprite_CheckDelete).l
; ---------------------------------------------------------------------------

loc_75AD4:
		lea	ObjDat3_75E72(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_75B34,(a0)
		move.b	#$18,$1E(a0)
		movea.w	($FFFFFAA4).w,a1
		moveq	#0,d2
		move.b	$42(a1),d2
		move.b	byte_75B2E(pc,d2.w),d3
		ext.w	d3
		add.w	d3,$14(a0)
		jsr	(Random_Number).l
		cmpi.b	#2,($FFFFB038).w
		beq.s	loc_75B0E
		moveq	#0,d0

loc_75B0E:
		move.w	#-$400,d1
		btst	#0,d0
		beq.s	loc_75B24
		tst.b	d2
		beq.s	loc_75B24
		move.w	#-$200,d1
		sne	$3A(a0)

loc_75B24:

		move.w	d1,$18(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
byte_75B2E:	dc.b $40
		dc.b $20
		dc.b 0
		dc.b $E0
		dc.b $C0
		dc.b 0
; ---------------------------------------------------------------------------

loc_75B34:
		lea	byte_75F12(pc),a1
		jsr	(Animate_RawNoSST).l
		tst.b	$3A(a0)
		beq.s	loc_75B58
		addi.w	#$20,$1A(a0)
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_75B58
		neg.w	$1A(a0)

loc_75B58:

		jsr	(MoveSprite2).l
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------

loc_75B64:
		bsr.w	sub_75B6E
		jmp	(Child_AddToTouchList).l

; =============== S U B R O U T I N E =======================================


sub_75B6E:
		movea.w	$46(a0),a1
		moveq	#0,d0
		move.b	$22(a1),d0
		lsl.w	#2,d0
		lea	byte_75BAE(pc,d0.w),a2
		move.b	(a2)+,d0
		ext.w	d0
		move.w	$10(a1),d1
		btst	#0,4(a1)
		beq.s	loc_75B90
		neg.w	d0

loc_75B90:
		add.w	d0,d1
		move.w	d1,$10(a0)
		move.b	(a2)+,d0
		ext.w	d0
		move.w	$14(a1),d1
		add.w	d0,d1
		move.w	d1,$14(a0)
		move.b	(a2)+,$28(a0)
		move.b	(a2)+,$22(a0)
		rts
; End of function sub_75B6E

; ---------------------------------------------------------------------------
byte_75BAE:	dc.b  $D6, $28,	$A3,  $B
		dc.b  $D6, $29,	$A3,  $B
		dc.b  $D6, $2A,	$A3,  $B
		dc.b  $D6, $2B,	$A3,  $B
		dc.b  $C8, $F0,	$9A,  $A
		dc.b  $C8, $F0,	$9A,  $A
		dc.b  $C8, $F0,	$9A,  $A
		dc.b  $D8, $F5,	$9A,  $A
		dc.b  $CF, $F5,	$9A,  $A
		dc.b  $F8, $F8,	$9A,  $A
		dc.b  $EF, $F8,	$9A,  $A
		dc.b  $24,  $E,	$9B,   4
		dc.b  $24,  $D,	$9B,   4
		dc.b	0,   0,	  0,   0
		dc.b  $24,  $E,	$9B,   4
		dc.b	0,   0,	  0,   0
		dc.b  $2B,  $E,	$9B,   4
		dc.b  $2A,  $E,	$9B,   4
		dc.b  $29,  $E,	$9B,   4
		dc.b	0,   0,	  0,   0
		dc.b  $DF, $28,	$A3,  $B
		dc.b  $D6, $28,	$A3,  $B

; =============== S U B R O U T I N E =======================================


sub_75C06:
		move.w	($FFFFEE7C).w,d2
		addi.w	#$E0,d2
		sub.w	$14(a0),d2
		lsr.w	#3,d2
		andi.w	#$1E,d2
		jsr	(Random_Number).l
		move.w	word_75C4A(pc,d2.w),d3
		andi.w	#$1FF,d0
		add.w	d0,d3
		moveq	#-$C,d4
		btst	#1,d0
		beq.s	loc_75C34
		neg.w	d3
		neg.w	d4

loc_75C34:
		move.w	d3,$18(a0)
		move.w	d4,$40(a0)
		swap	d0
		andi.w	#$F,d0
		addq.w	#8,d0
		move.w	d0,$3E(a0)
		rts
; End of function sub_75C06

; ---------------------------------------------------------------------------
word_75C4A:	dc.w $400
		dc.w $400
		dc.w $400
		dc.w $400
		dc.w $380
		dc.w $300
		dc.w $280
		dc.w $200
		dc.w $180
		dc.w $140
		dc.w $100
		dc.w $C0
		dc.w $80
		dc.w $80
		dc.w $80
		dc.w $80
		dc.w $40
		dc.w $40
		dc.w $40
		dc.w $40
		dc.w $3C
		dc.w $38
		dc.w $34
		dc.w $30
		dc.w $2C
		dc.w $28
		dc.w $24
		dc.w $20
		dc.w $1C
		dc.w $18
		dc.w $14
		dc.w $10

; =============== S U B R O U T I N E =======================================


sub_75C8A:
		movea.w	$46(a0),a1
		moveq	#0,d0
		move.b	$22(a1),d0
		move.b	RawAni_75CB6(pc,d0.w),$22(a0)
		add.w	d0,d0
		move.w	d0,d1
		lea	word_75CCC(pc,d0.w),a2
		move.w	(a2)+,8(a0)
		add.w	d1,d1
		add.b	$2C(a0),d1
		lea	word_75CF8(pc,d1.w),a2
		move.w	(a2)+,$42(a0)
		rts
; End of function sub_75C8A

; ---------------------------------------------------------------------------
RawAni_75CB6:	dc.b  $16, $16, $16, $16, $16, $17, $16, $16, $16, $16, $16, $16, $16, $16, $16, $16, $16, $16, $16, $16
		dc.b  $16, $16
word_75CCC:	dc.w $280
		dc.w $280
		dc.w $280
		dc.w $280
		dc.w $280
		dc.w $280
		dc.w $280
		dc.w $280
		dc.w $280
		dc.w $280
		dc.w $280
		dc.w $180
		dc.w $180
		dc.w $180
		dc.w $180
		dc.w $180
		dc.w $280
		dc.w $280
		dc.w $280
		dc.w $180
		dc.w $280
		dc.w $280
word_75CF8:	dc.w $B1C
		dc.w $11C
		dc.w $B1C
		dc.w $11C
		dc.w $B1C
		dc.w $11C
		dc.w $B1C
		dc.w $11C
		dc.w $F81C
		dc.w $FF1C
		dc.w $E812
		dc.w $EF12
		dc.w $F81C
		dc.w $FF1C
		dc.w $F81C
		dc.w $FF1C
		dc.w $EF1C
		dc.w $F61C
		dc.w $F81C
		dc.w $FF1C
		dc.w $EF1C
		dc.w $F61C
		dc.w $F81C
		dc.w $B1C
		dc.w $F81B
		dc.w $B1B
		dc.w $F81C
		dc.w $B1C
		dc.w $F81C
		dc.w $B1C
		dc.w $F81C
		dc.w $B1C
		dc.w $F81C
		dc.w $FF1C
		dc.w $F01C
		dc.w $F71C
		dc.w $EF1C
		dc.w $F61C
		dc.w $F81C
		dc.w $B1C
		dc.w $C1C
		dc.w $61C
		dc.w $B1C
		dc.w $11C

; =============== S U B R O U T I N E =======================================


sub_75D50:
		moveq	#0,d0
		move.b	$22(a0),d0
		move.w	#$200,8(a0)
		move.b	byte_75D6A(pc,d0.w),d0
		beq.s	locret_75D68
		move.w	#$80,8(a0)

locret_75D68:
		rts
; End of function sub_75D50

; ---------------------------------------------------------------------------
byte_75D6A:	dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 1
		dc.b 1
		dc.b 1
		dc.b 1
		dc.b 1
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0

; =============== S U B R O U T I N E =======================================


sub_75D80:
		tst.b	$28(a0)
		bne.s	locret_75DCA
		move.b	$29(a0),d0
		beq.s	loc_75DCC
		tst.b	$20(a0)
		bne.s	loc_75DA0
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l

loc_75DA0:
		bset	#6,$2A(a0)
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_75DB4
		addi.w	#8,d0

loc_75DB4:
		bsr.w	sub_75DF4
		subq.b	#1,$20(a0)
		bne.s	locret_75DCA
		bclr	#6,$2A(a0)
		move.b	$25(a0),$28(a0)

locret_75DCA:

		rts
; ---------------------------------------------------------------------------

loc_75DCC:
		move.l	#Wait_FadeToLevelMusic,(a0)
		move.l	#loc_757BA,$34(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_75DEE
		move.b	#$10,$2C(a1)

loc_75DEE:
		jmp	(BossDefeated_StopTimer).l
; End of function sub_75D80


; =============== S U B R O U T I N E =======================================


sub_75DF4:
		lea	word_75E02(pc),a1
		lea	word_75E0A(pc,d0.w),a2
		jmp	(CopyWordData_4).l
; End of function sub_75DF4

; ---------------------------------------------------------------------------
word_75E02:	dc.w $FC2E
		dc.w $FC36
		dc.w $FC3A
		dc.w $FC3C
word_75E0A:	dc.w $224
		dc.w $222
		dc.w $A64
		dc.w $642
		dc.w $AAA
		dc.w $EEE
		dc.w $888
		dc.w $666
; ---------------------------------------------------------------------------

loc_75E1A:
		move.w	($FFFFEE16).w,d0
		cmp.w	$34(a0),d0
		bne.s	loc_75E4C
		move.l	$30(a0),d1
		addi.l	#$4000,d1
		move.l	d1,$30(a0)
		swap	d1
		add.w	d1,d0
		cmp.w	($FFFFFA92).w,d0
		bcc.s	loc_75E46
		move.w	d0,($FFFFEE16).w
		move.w	d0,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_75E46:
		move.w	($FFFFFA92).w,($FFFFEE16).w

loc_75E4C:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
ObjDat3_75E52:	dc.l Map_MHZMiniboss
		dc.w $A3AD
		dc.w $200
		dc.b $48
		dc.b $40
		dc.b 0
		dc.b $F
word_75E5E:	dc.w $83AD

		dc.w $280
		dc.b $C
		dc.b $C
		dc.b $16
		dc.b $9A
ObjDat3_75E66:	dc.l Map_MHZMinibossTree
		dc.w $6001
		dc.w $380
		dc.b $14
		dc.b $90
		dc.b 5
		dc.b 0
ObjDat3_75E72:	dc.l Map_MHZMinibossLog
		dc.w $649F
		dc.w $380
		dc.b $14
		dc.b $14
		dc.b 6
		dc.b $86
word_75E7E:	dc.w $300
		dc.b 8
		dc.b 8
		dc.b $18
		dc.b $8B
ChildObjDat_75E84:dc.w 1
		dc.l loc_757C0
		dc.w 0
		dc.l loc_757C0
		dc.w 0
		dc.l loc_75B64
		dc.w 0
ChildObjDat_75E98:dc.w 0
		dc.l loc_75AD4
ChildObjDat_75E9E:dc.w 0
		dc.l loc_7583A
		dc.w $F8
ChildObjDat_75EA6:dc.w 0
		dc.l loc_759C0
		dc.w $113
byte_75EAE:	dc.b	0,  $B

		dc.b	1,   5
		dc.b	2,   5
		dc.b	3,  $B
		dc.b	2,   5
		dc.b	1,   5
		dc.b  $FC
byte_75EBB:	dc.b	4, $27
		dc.b	4, $27
		dc.b	7,   2
		dc.b	9,   2
		dc.b   $C,   2
		dc.b   $D, $3B
		dc.b   $B,   2
		dc.b	9,   2
		dc.b	7,   2
		dc.b	4, $27
		dc.b  $F4
byte_75ED0:	dc.b	4, $27
		dc.b	4, $27
		dc.b	7,   2
		dc.b	9,   2
		dc.b   $C,   2
		dc.b   $D, $27
		dc.b  $10,   3
		dc.b  $11,   7
		dc.b  $12,   7
		dc.b  $11,   7
		dc.b  $12,   7
		dc.b  $11,   7
		dc.b  $12,   7
		dc.b  $11,   7
		dc.b  $12,   7
		dc.b  $11,   7
		dc.b  $12, $31
		dc.b  $F4
byte_75EF3:	dc.b   $A,   3
		dc.b   $A,   3
		dc.b	8,   3
		dc.b	6,   3
		dc.b  $F8,  $A
		dc.b	6, $7F
		dc.b	6, $7F
		dc.b  $FC
byte_75F02:	dc.b   $F, $31
		dc.b   $F, $31
		dc.b  $13,   4
		dc.b  $14,   4
		dc.b  $15,   4
		dc.b  $F4
byte_75F0D:	dc.b	5, $7F

		dc.b	5, $7F
		dc.b  $FC
byte_75F12:	dc.b	1,   0
		dc.b	1,   2
		dc.b	3,   4
		dc.b	5,   6
		dc.b	7, $FC
byte_75F1C:	dc.b  $18,   3
		dc.b  $19,   3
		dc.b  $1A,   3
		dc.b  $1B,   3
		dc.b  $1C,  $B
		dc.b  $FC,   0
Pal_MHZMiniboss:	binclude "Levels\MHZ\Palettes\Miniboss.bin"

PLC_75F48:	dc.w 0
		dc.l ArtNem_BossExplosion
		dc.w $9A40
; ---------------------------------------------------------------------------

Obj_MHZ_EndBoss:
		lea	word_769F4(pc),a1
		jsr	(Check_CameraInRange).l
		move.l	#loc_75FD4,(a0)
		move.w	($FFFFEE78).w,($FFFFEE14).w
		move.b	#1,($FFFFF7AA).w
		jsr	(loc_85D7E).l
		addi.w	#$C0,$10(a0)
		lea	ObjDat3_76928(pc),a1
		jsr	(SetUp_ObjAttributes).l
		clr.b	5(a0)
		clr.b	($FFFFFAA9).w
		lea	(ArtKosM_MHZEndBoss).l,a1
		move.w	#$7D80,d2
		jsr	(Queue_Kos_Module).l
		moveq	#$7B,d0
		jsr	(Load_PLC).l
		lea	Pal_MHZEndBoss(pc),a1
		jsr	(PalLoad_Line1).l
		lea	ChildObjDat_7699C(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	ChildObjDat_76982(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	ChildObjDat_7697C(pc),a2
		jsr	(CreateChild6_Simple).l
		lea	ChildObjDat_76976(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_75FD4:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_75FF4(pc,d0.w),d1
		jsr	off_75FF4(pc,d1.w)
		move.w	($FFFFEEBC).w,d0
		sub.w	d0,$10(a0)
		bsr.w	sub_76782
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_75FF4:	dc.w loc_76004-off_75FF4

		dc.w loc_7601A-off_75FF4
		dc.w loc_76038-off_75FF4
		dc.w loc_76062-off_75FF4
		dc.w loc_76088-off_75FF4
		dc.w loc_76088-off_75FF4
		dc.w loc_76106-off_75FF4
		dc.w loc_76088-off_75FF4
; ---------------------------------------------------------------------------

loc_76004:
		move.b	#$F,$28(a0)
		move.b	#9,$29(a0)
		move.b	$28(a0),$25(a0)
		clr.b	($FFFFFA88).w

loc_7601A:
		btst	#2,$38(a0)
		beq.s	locret_76036
		move.b	#4,5(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_7603E,$34(a0)

locret_76036:
		rts
; ---------------------------------------------------------------------------

loc_76038:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7603E:
		move.b	#6,5(a0)
		move.w	#-$200,$1A(a0)
		move.w	#$23,$2E(a0)
		move.l	#loc_7606E,$34(a0)
		moveq	#-$30,d0
		jsr	(Play_Sound_2).l

locret_76060:

		rts
; ---------------------------------------------------------------------------

loc_76062:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7606E:
		move.b	#8,5(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_7609A,$34(a0)
		jmp	(Swing_Setup1).l
; ---------------------------------------------------------------------------

loc_76088:

		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7609A:
		move.b	#$A,5(a0)
		bset	#6,$38(a0)
		move.w	#$400,$18(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_760C4,$34(a0)
		moveq	#-$4A,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_760C4:
		move.b	#$C,5(a0)
		bset	#7,$38(a0)
		move.w	#$4180,$10(a0)
		move.w	#$2E0,$14(a0)
		bset	#3,$38(a0)
		clr.w	$18(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_760F4
		move.l	#loc_76896,(a1)

loc_760F4:
		move.w	#$45A0,($FFFFFA92).w
		lea	(Child6_IncLevX).l,a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_76106:
		move.w	($FFFFEE78).w,d0
		addi.w	#$E0,d0
		cmp.w	$10(a0),d0
		bcc.s	loc_76120
		jsr	(Swing_UpAndDown).l
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_76120:
		move.b	#$E,5(a0)
		move.l	#loc_76136,$34(a0)
		clr.w	$2E(a0)
		bra.w	loc_76088
; ---------------------------------------------------------------------------

loc_76136:
		move.w	#$5F,$2E(a0)
		move.w	#$400,d0
		cmpi.b	#2,($FFFFB038).w
		bne.s	loc_7614C
		move.w	#$500,d0

loc_7614C:
		move.w	#$100,d1
		bchg	#6,$38(a0)
		beq.s	loc_7615C
		move.w	#-$100,d1

loc_7615C:
		add.w	d1,d0
		move.w	d0,$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_76164:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		cmpi.w	#$44D0,$10(a0)
		bcs.s	loc_761A4
		move.l	#Wait_FadeToLevelMusic,(a0)
		bset	#7,$2A(a0)
		move.w	#$14,($FFFFEECC).w
		move.l	#loc_761B2,$34(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		jsr	(BossDefeated_StopTimer).l

loc_761A4:
		move.w	($FFFFEEBC).w,d0
		sub.w	d0,$10(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_761B2:
		move.l	#loc_761E8,(a0)
		move.w	#$100,8(a0)
		bset	#7,$A(a0)
		clr.w	$18(a0)
		move.w	#-$200,$1A(a0)
		bset	#4,$38(a0)
		lea	PLC_76A04(pc),a1
		jsr	(Load_PLC_Raw).l
		lea	ChildObjDat_769B0(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_761E8:
		jsr	(MoveSprite).l
		move.w	($FFFFEE7C).w,d0
		addi.w	#$120,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_76236
		move.l	#loc_7623C,(a0)
		bset	#0,($FFFFFA88).w
		st	($FFFFFAA8).w
		clr.b	($FFFFF7AA).w
		bset	#5,$38(a0)
		jsr	(PLCLoad_AnimalsAndExplosion).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_76236
		move.l	#Obj_81,(a1)
		move.w	#$4640,$10(a1)
		move.w	#$320,$14(a1)

loc_76236:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7623C:
		move.w	($FFFFEE78).w,d0
		addq.w	#4,d0
		move.w	#$45A0,d1
		cmp.w	d1,d0
		bcs.s	loc_7626A
		move.l	#loc_76270,(a0)
		move.w	d1,d0
		move.w	d1,($FFFFEE14).w
		move.w	d1,($FFFFEE16).w
		clr.b	($FFFFEE0A).w
		clr.b	($FFFFF7CA).w
		clr.b	($FFFFF7CB).w
		clr.w	($FFFFF602).w

loc_7626A:
		move.w	d0,($FFFFEE78).w
		rts
; ---------------------------------------------------------------------------

loc_76270:
		tst.b	($FFFFFAA8).w
		bne.w	locret_76060
		move.l	#loc_76310,(a0)
		clr.b	($FFFFFAA9).w
		move.w	($FFFFEE78).w,d0
		subi.w	#$40,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d0
		addi.w	#$40,d0
		move.w	d0,$14(a0)
		jsr	(Restore_PlayerControl).l
		bset	#7,$A(a1)
		lea	($FFFFB04A).w,a1
		bset	#7,$A(a1)
		jsr	(Restore_PlayerControl2).l
		jsr	(Obj_PlayLevelMusic).l
		st	($FFFFF7CA).w
		move.w	#$101,($FFFFF602).w
		st	($FFFFF7CB).w
		move.w	#$101,($FFFFF66A).w
		jsr	(sub_8638A).l
		move.w	#$1BF,$2E(a0)
		move.w	#$55,($FFFFEEC4).w
		move.w	#$5000,($FFFFFA92).w
		bclr	#5,$38(a0)
		lea	ChildObjDat_7699C(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	(PLC_83D7C).l,a1
		jsr	(Load_PLC_Raw).l
		lea	(Child6_IncLevX).l,a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_76310:
		subq.w	#1,$2E(a0)
		bmi.s	loc_76318
		rts
; ---------------------------------------------------------------------------

loc_76318:
		move.l	#loc_76356,(a0)
		bclr	#7,$2A(a0)
		bclr	#4,$38(a0)
		bset	#0,4(a0)
		move.w	#$400,$18(a0)
		clr.w	$1A(a0)
		lea	(Child1_MakeRoboShipFlame).l,a2
		jsr	(CreateChild1_Normal).l
		cmpi.b	#2,($FFFFB038).w
		bne.w	locret_76060
		jmp	(loc_67B1C).l
; ---------------------------------------------------------------------------

loc_76356:
		moveq	#-$42,d0
		jsr	(sub_85E52).l
		jsr	(sub_8638A).l
		moveq	#0,d1
		move.w	($FFFFEE78).w,d0
		addi.w	#$80,d0
		cmp.w	$10(a0),d0
		bcc.s	loc_76376
		moveq	#-$10,d1

loc_76376:
		jsr	(MoveSprite_CustomGravity).l
		move.w	($FFFFEE7C).w,d0
		subi.w	#$40,d0
		cmp.w	$14(a0),d0
		bcs.s	loc_763A4
		move.l	#loc_763B2,(a0)
		bset	#5,$38(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_763A4
		move.l	#loc_863C0,(a1)

loc_763A4:

		move.w	($FFFFEEBC).w,d0
		sub.w	d0,$10(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_763B2:
		lea	($FFFFB000).w,a1
		cmpi.w	#$4778,$10(a1)
		bcc.s	loc_763C4
		jmp	(loc_86334).l
; ---------------------------------------------------------------------------

loc_763C4:
		move.l	#loc_763D8,(a0)
		clr.w	($FFFFF602).w
		lea	($FFFFB000).w,a1
		jmp	(Stop_Object).l
; ---------------------------------------------------------------------------

loc_763D8:
		move.w	#$101,($FFFFF602).w
		move.w	#$101,($FFFFF606).w
		tst.b	($FFFFFAA9).w
		beq.w	locret_76060
		move.l	#loc_76404,(a0)
		move.w	#$2020,($FFFFF602).w
		lea	($FFFFB000).w,a1
		move.w	#$200,$18(a1)
		rts
; ---------------------------------------------------------------------------

loc_76404:
		move.w	#$2000,($FFFFF602).w
		lea	($FFFFB000).w,a1
		tst.w	$1A(a1)
		bmi.w	locret_76060
		move.l	#loc_76456,(a0)
		jsr	(Stop_Object).l
		move.b	#-$7F,$2E(a1)
		move.b	#$11,$20(a1)
		bset	#0,4(a1)
		bset	#0,$2A(a1)
		move.w	#$5F,$2E(a0)
		moveq	#$4A,d0
		jsr	(Play_Sound_2).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_76456
		move.l	#loc_7646E,(a1)

loc_76456:

		subq.w	#1,$2E(a0)
		bmi.s	loc_7645E
		rts
; ---------------------------------------------------------------------------

loc_7645E:
		move.w	#$400,d0
		jsr	(StartNewLevel).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_7646E:
		move.l	#loc_76492,(a0)
		lea	($FFFFB04A).w,a1
		move.b	#-$7F,$2E(a1)
		move.b	#$20,$20(a1)
		bclr	#0,4(a1)
		bclr	#0,$2A(a1)
		rts
; ---------------------------------------------------------------------------

loc_76492:
		lea	($FFFFB04A).w,a1
		addq.w	#1,$10(a1)
		subq.w	#1,$14(a1)
		rts
; ---------------------------------------------------------------------------

loc_764A0:
		lea	word_76964(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_764C4,(a0)
		movea.w	$46(a0),a1
		move.w	a0,$44(a1)
		move.b	$28(a0),$25(a0)
		move.b	#-1,$29(a0)

loc_764C4:
		jsr	(Refresh_ChildPositionAdjusted).l
		jmp	(Child_AddToTouchList).l
; ---------------------------------------------------------------------------

loc_764D0:
		lea	ObjDat3_76934(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_764E0,(a0)

loc_764E0:
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		beq.s	loc_764F8
		move.l	#loc_764F8,(a0)
		bset	#7,$A(a0)

loc_764F8:

		bsr.w	sub_7675C
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------

loc_76502:
		lea	ObjDat3_76934(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_76516,(a0)
		bsr.w	sub_7673E

loc_76516:
		bsr.w	sub_7675C
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------

loc_76520:
		lea	ObjDat3_76940(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_7654A,(a0)
		move.b	#1,$29(a0)
		lea	ChildObjDat_769A4(pc),a2
		jsr	(CreateChild6_Simple).l
		lea	ChildObjDat_769AA(pc),a2
		jsr	(CreateChild6_Simple).l

loc_7654A:
		tst.b	$28(a0)
		beq.s	loc_76574
		subq.w	#1,$2E(a0)
		bpl.s	loc_7656E
		jsr	(Random_Number).l
		andi.w	#$F,d0
		addq.w	#8,d0
		move.w	d0,$2E(a0)
		moveq	#-$77,d0
		jsr	(Play_Sound_2).l

loc_7656E:
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_76574:
		move.l	#Wait_Draw,(a0)
		move.w	#$3F,$2E(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		movea.w	$46(a0),a1
		bset	#2,$38(a1)
		lea	($FFFFFC00).w,a1
		lea	($FFFFFC80).w,a2
		moveq	#7,d6

loc_7659C:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_7659C
		lea	(Pal_MHZEndBoss).l,a1
		lea	($FFFFFCA0).w,a2
		moveq	#7,d6

loc_765AE:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_765AE
		lea	(Pal_MHZ1+$20).l,a1
		lea	($FFFFFCC0).w,a2
		moveq	#$F,d6

loc_765C0:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_765C0
		jsr	(Create_New_Sprite).l
		bne.s	loc_765DE
		move.l	#loc_85E64,(a1)
		st	$2C(a1)
		move.w	#3,$3A(a1)

loc_765DE:
		jsr	(Create_New_Sprite).l
		bne.s	loc_765F2
		move.l	#Obj_Song_Fade_Transition,(a1)
		move.b	#$19,$2C(a1)

loc_765F2:
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		clr.b	($FFFFF7C1).w
		rts
; ---------------------------------------------------------------------------

loc_76604:
		lea	word_76958(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#byte_769B6,$30(a0)
		tst.b	$2C(a0)
		beq.s	loc_76624
		move.l	#byte_769C1,$30(a0)

loc_76624:
		move.l	#loc_7662A,(a0)

loc_7662A:
		jsr	(Animate_RawMultiDelay).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_76636:
		lea	word_7695E(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_76652,(a0)
		move.l	#byte_769CE,$30(a0)
		bsr.w	sub_76714

loc_76652:
		jsr	(Animate_Raw).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7665E:

		lea	ObjDat3_7694C(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_76674,(a0)
		bset	#4,$2B(a0)

loc_76674:
		jsr	(Refresh_ChildPositionAdjusted).l
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_766C4
		move.b	#-$75,$28(a0)
		btst	#6,$2A(a1)
		beq.s	loc_76698
		clr.b	$28(a0)

loc_76698:
		btst	#0,($FFFFFE0F).w
		sne	d0
		tst.b	$2C(a0)
		beq.s	loc_766A8
		not.b	d0

loc_766A8:
		tst.b	d0
		bne.w	locret_76060
		btst	#6,$38(a1)
		beq.w	locret_76060
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_766C4:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_766CA:
		lea	ObjDat3_7696A(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#Obj_FlickerMove,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		lea	word_766FC(pc,d0.w),a1
		move.w	(a1)+,8(a0)
		move.b	(a1)+,$22(a0)
		moveq	#8,d0
		jsr	(Set_IndexedVelocity).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
word_766FC:	dc.w $200
		dc.b $12
		dc.w 2
		dc.b 0
		dc.w $1300
		dc.b 3
		dc.w $14
		dc.b 0
		dc.w $300
		dc.b $15
		dc.w 2
		dc.b 0
		dc.w $1600
		dc.b 2
		dc.w $17
		dc.b 0

; =============== S U B R O U T I N E =======================================


sub_76714:
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		lea	word_7672E(pc,d0.w),a1
		move.w	(a1)+,d0
		add.w	d0,$10(a0)
		move.w	(a1)+,d0
		add.w	d0,$14(a0)
		rts
; End of function sub_76714

; ---------------------------------------------------------------------------
word_7672E:	dc.w  $FFB3, $FFB2
		dc.w  $FF5F, $FF5E
		dc.w  $FF0B, $FF0A
		dc.w  $FEB7, $FEB6

; =============== S U B R O U T I N E =======================================


sub_7673E:
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		lea	word_76754(pc,d0.w),a1
		move.w	(a1)+,8(a0)
		move.b	(a1)+,$22(a0)
		rts
; End of function sub_7673E

; ---------------------------------------------------------------------------
word_76754:	dc.w $300
		dc.b 2
		dc.w 2
		dc.b 0
		dc.w $300

; =============== S U B R O U T I N E =======================================


sub_7675C:

		movea.w	$46(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		bclr	#0,4(a0)
		btst	#0,4(a1)
		beq.s	locret_76780
		bset	#0,4(a0)

locret_76780:
		rts
; End of function sub_7675C


; =============== S U B R O U T I N E =======================================


sub_76782:
		movea.w	$44(a0),a4
		move.b	$29(a0),d0
		tst.b	$28(a0)
		beq.s	loc_767A0
		tst.b	$28(a4)
		bne.w	locret_76820
		subq.b	#1,d0
		move.b	$1C(a4),$1C(a0)

loc_767A0:
		btst	#7,$38(a0)
		bne.s	loc_767B0
		cmpi.b	#1,d0
		bgt.s	loc_767B0
		moveq	#2,d0

loc_767B0:

		move.b	d0,$29(a0)
		tst.b	$20(a0)
		bne.s	loc_767E8
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		bset	#6,$2A(a0)
		clr.b	$28(a0)
		clr.b	$28(a4)
		lea	($FFFFB000).w,a1
		tst.b	$1C(a0)
		beq.s	loc_767E4
		lea	($FFFFB04A).w,a1

loc_767E4:
		clr.w	$18(a1)

loc_767E8:
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_767F6
		addi.w	#$A,d0

loc_767F6:
		bsr.w	sub_7686A
		subq.b	#1,$20(a0)
		bne.s	locret_76820
		bclr	#6,$2A(a0)
		cmpi.b	#1,$29(a0)
		beq.s	loc_76822
		move.b	$25(a0),$28(a0)
		move.b	$25(a4),$28(a4)
		move.b	#-1,$29(a4)

locret_76820:

		rts
; ---------------------------------------------------------------------------

loc_76822:
		move.l	#loc_76164,(a0)
		bclr	#6,$38(a0)
		move.w	#$400,d0
		cmpi.b	#2,($FFFFB038).w
		bne.s	loc_7683E
		move.w	#$500,d0

loc_7683E:
		move.w	d0,$18(a0)
		st	($FFFFFAA9).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_76854
		move.l	#loc_768B6,(a1)

loc_76854:
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	locret_76868
		move.b	#$20,$2C(a1)

locret_76868:
		rts
; End of function sub_76782


; =============== S U B R O U T I N E =======================================


sub_7686A:
		lea	word_76878(pc),a1
		lea	word_76882(pc,d0.w),a2
		jmp	(CopyWordData_5).l
; End of function sub_7686A

; ---------------------------------------------------------------------------
word_76878:	dc.w $FC28
		dc.w $FC34
		dc.w $FC36
		dc.w $FC3A
		dc.w $FC3C
word_76882:	dc.w $E42
		dc.w $228
		dc.w 0
		dc.w $C40
		dc.w $820
		dc.w $888
		dc.w $AAA
		dc.w $EEE
		dc.w $888
		dc.w $AAA
; ---------------------------------------------------------------------------

loc_76896:
		cmpi.w	#$4010,($FFFFEE78).w
		bcs.w	locret_76060
		lea	(ArtKosM_MHZEndBossSpikes).l,a1
		move.w	#$75E0,d2
		jsr	(Queue_Kos_Module).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_768B6:
		tst.b	($FFFFFAA9).w
		bne.w	locret_76060
		move.l	#loc_768D2,(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_768D2
		move.l	#loc_863C0,(a1)

loc_768D2:

		moveq	#0,d0
		lea	($FFFFB000).w,a1
		bclr	#0,$2A(a1)
		bclr	#2,$2A(a1)
		btst	#1,$2A(a1)
		bne.s	locret_768FC
		move.l	#loc_768FE,(a0)
		move.w	#$55,($FFFFEEC6).w
		st	($FFFFF7CA).w

locret_768FC:
		rts
; ---------------------------------------------------------------------------

loc_768FE:
		move.w	#$808,($FFFFF602).w
		lea	($FFFFB000).w,a1
		cmpi.w	#$4600,$10(a1)
		bcc.s	loc_76912
		rts
; ---------------------------------------------------------------------------

loc_76912:
		move.w	#$4600,$10(a1)
		jsr	(Stop_Object).l
		clr.w	($FFFFF602).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
ObjDat3_76928:	dc.l Map_RobotnikShip
		dc.w $52E
		dc.w $280
		dc.b $20
		dc.b $20
		dc.b $A
		dc.b 0
ObjDat3_76934:	dc.l Map_MHZEndBoss

		dc.w $23EC
		dc.w $280
		dc.b $80
		dc.b $80
		dc.b 1
		dc.b 0
ObjDat3_76940:	dc.l Map_MHZEndBoss
		dc.w $23EC
		dc.w $200
		dc.b $80
		dc.b $80
		dc.b 4
		dc.b $11
ObjDat3_7694C:	dc.l Map_MHZEndBoss
		dc.w $3EC
		dc.w $200
		dc.b $10
		dc.b $10
		dc.b $11
		dc.b $8B
word_76958:	dc.w $180
		dc.b $10
		dc.b $10
		dc.b 5
		dc.b 0
word_7695E:	dc.w $180
		dc.b $80
		dc.b $80
		dc.b $E
		dc.b 0
word_76964:	dc.w $200
		dc.b $18
		dc.b $28
		dc.b 0
		dc.b $25
ObjDat3_7696A:	dc.l Map_MHZEndBoss
		dc.w $A3EC
		dc.w $80
		dc.b $80
		dc.b $80
		dc.b 0
		dc.b 0
ChildObjDat_76976:dc.w 1
		dc.l loc_76502
ChildObjDat_7697C:dc.w 0
		dc.l loc_764D0
ChildObjDat_76982:dc.w 3
		dc.l loc_7665E
		dc.w $EC18
		dc.l loc_7665E
		dc.w $D418
		dc.l loc_76520
		dc.w $11AF
		dc.l loc_764A0
		dc.w $21F0
ChildObjDat_7699C:dc.w 0

		dc.l Obj_RobotnikHead4
		dc.w $E4
ChildObjDat_769A4:dc.w 1
		dc.l loc_76604
ChildObjDat_769AA:dc.w 3
		dc.l loc_76636
ChildObjDat_769B0:dc.w 5
		dc.l loc_766CA
byte_769B6:	dc.b	5,   1
		dc.b	6,   3
		dc.b	7,   5
		dc.b	8,   7
		dc.b	0,   9
		dc.b  $FC
byte_769C1:	dc.b	9,   1
		dc.b   $A,   1
		dc.b	9,   1
		dc.b   $A,   1
		dc.b   $B,   1
		dc.b   $C,   1
		dc.b  $FC
byte_769CE:	dc.b	1,  $D
		dc.b   $E,  $F
		dc.b  $10, $FC
Pal_MHZEndBoss:	binclude "Levels\MHZ\Palettes\End Boss.bin"


word_769F4:	dc.w 0
		dc.w $300
		dc.w $3AA0
		dc.w $3D90
		dc.w $280
		dc.w $280
		dc.w $3C90
		dc.w $3C90
PLC_76A04:	dc.w 1
		dc.l ArtNem_EggCapsule
		dc.w $9280
		dc.l ArtNem_Explosion
		dc.w $B400
; ---------------------------------------------------------------------------

Obj_SOZ_Miniboss:

		move.l	#Obj_Wait,(a0)
		move.w	#$439D,$10(a0)
		move.w	#$9F7,$14(a0)
		lea	(Pal_SOZMinibossFade).l,a1
		lea	($FFFFFC20).w,a2
		moveq	#7,d6

loc_76A30:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_76A30
		lea	(Pal_SOZMinibossMain).l,a1
		lea	($FFFFFCA0).w,a2
		moveq	#7,d6

loc_76A42:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_76A42
		move.l	#loc_76A8A,$34(a0)
		move.w	#$78,$2E(a0)
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		lea	(ArtKosM_SOZMiniboss).l,a1
		move.w	#$76A0,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_SOZSand).l,a1
		move.w	#-$61A0,d2
		jsr	(Queue_Kos_Module).l
		lea	(PLC_83D64).l,a1
		jmp	(Load_PLC_Raw).l
; ---------------------------------------------------------------------------

loc_76A8A:
		move.l	#loc_76A92,(a0)
		rts
; ---------------------------------------------------------------------------

loc_76A92:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_76AAE(pc,d0.w),d1
		jsr	off_76AAE(pc,d1.w)
		bsr.w	sub_772F6
		bsr.w	sub_770EA
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_76AAE:	dc.w loc_76AC8-off_76AAE

		dc.w loc_76B2A-off_76AAE
		dc.w loc_76B44-off_76AAE
		dc.w loc_76B80-off_76AAE
		dc.w loc_76BAA-off_76AAE
		dc.w loc_76BF4-off_76AAE
		dc.w loc_76C36-off_76AAE
		dc.w loc_76CCE-off_76AAE
		dc.w loc_76D08-off_76AAE
		dc.w loc_76D28-off_76AAE
		dc.w loc_76D7C-off_76AAE
		dc.w loc_76DB0-off_76AAE
		dc.w locret_76E08-off_76AAE
; ---------------------------------------------------------------------------

loc_76AC8:
		lea	ObjDat3_773AC(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.w	8(a0),$3C(a0)
		move.b	#$3B,$1E(a0)
		move.l	#loc_76B30,$34(a0)
		moveq	#$2E,d0
		jsr	(Play_Sound).l
		move.b	#$2E,($FFFFFF91).w
		move.w	#$3F,$2E(a0)
		move.l	#loc_76B30,$34(a0)
		jsr	(Create_New_Sprite).l
		bne.s	locret_76B28
		move.l	#Obj_FadeSelectedFromBlack,(a1)
		move.w	#3,$3A(a1)
		move.w	#$F,$3C(a1)
		move.w	#-$3E0,$30(a1)
		move.w	#-$360,$32(a1)

locret_76B28:
		rts
; ---------------------------------------------------------------------------

loc_76B2A:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_76B30:

		move.b	#4,5(a0)
		st	($FFFFEED4).w
		lea	ChildObjDat_773E6(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_76B44:
		jsr	(Find_SonicTails).l
		cmpi.w	#$60,d2
		bcs.s	loc_76B52
		rts
; ---------------------------------------------------------------------------

loc_76B52:
		move.b	#6,5(a0)
		bclr	#0,4(a0)
		tst.w	d0
		beq.s	loc_76B68
		bset	#0,4(a0)

loc_76B68:
		move.w	#$3E,$2E(a0)
		move.l	#loc_76B86,$34(a0)
		lea	ChildObjDat_773DE(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_76B80:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_76B86:
		move.b	#8,5(a0)
		move.w	#-$100,$1A(a0)
		move.w	#7,$2E(a0)
		move.l	#loc_76BB6,$34(a0)
		lea	ChildObjDat_773D6(pc),a2
		jmp	(CreateChild3_NormalRepeated).l
; ---------------------------------------------------------------------------

loc_76BAA:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_76BB6:
		clr.w	$1A(a0)
		move.w	#7,$2E(a0)
		move.l	#loc_76BCA,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_76BCA:
		move.w	#$80,$1A(a0)
		move.w	#$F,$2E(a0)
		move.l	#loc_76BE0,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_76BE0:
		move.b	#$A,5(a0)
		move.l	#loc_76C26,$34(a0)
		clr.w	$1A(a0)

locret_76BF2:

		rts
; ---------------------------------------------------------------------------

loc_76BF4:
		jsr	(MoveSprite2).l
		lea	byte_7745D(pc),a1
		jsr	(Animate_RawNoSSTMultiDelay).l
		tst.w	d2
		beq.s	locret_76C24
		bmi.s	locret_76C24
		move.b	$22(a0),$39(a0)
		cmpi.b	#7,$22(a0)
		bne.s	loc_76C1E
		move.w	#-$700,$1A(a0)

loc_76C1E:
		move.b	#0,$22(a0)

locret_76C24:

		rts
; ---------------------------------------------------------------------------

loc_76C26:
		move.b	#$C,5(a0)
		move.l	#loc_76C5E,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_76C36:
		tst.w	$18(a0)
		bmi.s	loc_76C48
		cmpi.w	#$4438,$10(a0)
		bcs.s	loc_76C48
		clr.w	$18(a0)

loc_76C48:

		moveq	#$60,d1
		jsr	(MoveSprite_CustomGravity).l
		tst.w	$1A(a0)
		bmi.w	locret_76BF2
		jmp	(ObjHitFloor_DoRoutine).l
; ---------------------------------------------------------------------------

loc_76C5E:
		move.b	#$E,5(a0)
		move.b	#0,$3A(a0)
		move.l	#loc_76CF0,$34(a0)

loc_76C72:
		move.l	#byte_7746A,$30(a0)
		move.w	#$14,($FFFFEECC).w
		moveq	#$61,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_77402(pc),a2
		jmp	(CreateChild3_NormalRepeated).l
; ---------------------------------------------------------------------------

loc_76C92:
		move.b	#$E,5(a0)
		move.l	#loc_76D14,$34(a0)
		bra.s	loc_76C72
; ---------------------------------------------------------------------------

loc_76CA2:
		move.b	#4,5(a0)
		move.b	#$3B,$1E(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		move.w	#8,($FFFFEECC).w
		moveq	#$5F,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_7740A(pc),a2
		jmp	(CreateChild3_NormalRepeated).l
; ---------------------------------------------------------------------------

loc_76CCE:
		jsr	(Animate_RawMultiDelay).l
		tst.w	d2
		beq.s	locret_76CEE
		bmi.s	locret_76CEE
		move.b	$22(a0),$39(a0)
		move.b	$3A(a0),$22(a0)
		lea	byte_772E2(pc),a1
		bsr.w	sub_772BE

locret_76CEE:

		rts
; ---------------------------------------------------------------------------

loc_76CF0:
		move.b	#$10,5(a0)
		move.l	#byte_7747D,$30(a0)
		move.l	#loc_76D0E,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_76D08:
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_76D0E:
		bset	#1,$38(a0)

loc_76D14:
		move.b	#$12,5(a0)
		move.b	#1,$3A(a0)
		move.w	#$60,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_76D28:
		subq.w	#1,$2E(a0)
		bmi.s	loc_76D5C
		jsr	(Find_SonicTails).l
		btst	#0,4(a0)
		beq.s	loc_76D3E
		subq.w	#2,d0

loc_76D3E:
		tst.w	d0
		bne.s	loc_76D44
		rts
; ---------------------------------------------------------------------------

loc_76D44:
		move.b	#$14,5(a0)
		move.l	#byte_77452,$30(a0)
		move.l	#loc_76DA8,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_76D5C:
		move.b	#$16,5(a0)
		move.l	#byte_77482,$30(a0)
		move.l	#loc_76DE6,$34(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_76D7C:
		subq.w	#1,$2E(a0)
		jsr	(Animate_RawMultiDelayFlipX).l
		tst.w	d2
		beq.s	locret_76DA6
		bmi.s	locret_76DA6
		move.b	$22(a0),d0
		move.b	d0,$39(a0)
		move.b	#1,$22(a0)
		cmpi.b	#9,d0
		bne.s	locret_76DA6
		move.b	#$19,$22(a0)

locret_76DA6:

		rts
; ---------------------------------------------------------------------------

loc_76DA8:
		move.b	#$12,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_76DB0:
		jsr	(MoveSprite2).l
		jsr	(Animate_RawMultiDelay).l
		tst.w	d2
		beq.s	locret_76DE4
		bmi.s	locret_76DE4
		move.b	$22(a0),$39(a0)
		cmpi.b	#7,$22(a0)
		bne.s	loc_76DD6
		move.w	#-$700,$1A(a0)

loc_76DD6:
		move.b	$3A(a0),$22(a0)
		lea	byte_772E2(pc),a1
		bsr.w	sub_772BE

locret_76DE4:

		rts
; ---------------------------------------------------------------------------

loc_76DE6:
		move.b	#$C,5(a0)
		move.l	#loc_76C92,$34(a0)
		move.w	#$180,d0
		btst	#0,4(a0)
		bne.s	loc_76E02
		neg.w	d0

loc_76E02:
		move.w	d0,$18(a0)
		rts
; ---------------------------------------------------------------------------

locret_76E08:
		rts
; ---------------------------------------------------------------------------

loc_76E0A:
		subq.w	#1,$2E(a0)
		bmi.s	loc_76E1C
		jsr	(MoveSprite2).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_76E1C:
		bset	#5,$38(a0)
		bset	#7,$2A(a0)
		move.w	($FFFFEE78).w,d0
		addi.w	#$A0,d0
		move.w	d0,$10(a0)
		bclr	#7,4(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_76E48
		move.l	#loc_76E4E,(a1)

loc_76E48:
		jmp	(Obj_EndSignControl).l
; ---------------------------------------------------------------------------

loc_76E4E:
		tst.b	($FFFFFAA8).w
		beq.w	locret_76BF2
		move.l	#loc_76E5C,(a0)

loc_76E5C:
		tst.b	($FFFFFAA8).w
		bne.w	locret_76BF2
		move.l	#loc_76E94,(a0)
		lea	ChildObjDat_773F4(pc),a2
		jsr	(CreateChild1_Normal).l
		st	($FFFFF7CA).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_76E86
		move.l	#loc_863C0,(a1)

loc_76E86:
		cmpi.w	#$43A0,($FFFFB010).w
		bcs.s	loc_76E94
		bset	#3,$38(a0)

loc_76E94:

		lea	($FFFFF602).w,a1
		lea	($FFFFB000).w,a2
		move.w	#$43A0,d0
		tst.w	$18(a0)
		btst	#3,$38(a0)
		bne.s	loc_76EC8
		cmp.w	$10(a2),d0
		bls.s	loc_76EE4
		moveq	#0,d1
		btst	#5,$2A(a2)
		beq.s	loc_76EC0
		ori.w	#$4040,d1

loc_76EC0:
		ori.w	#$808,d1
		move.w	d1,(a1)
		rts
; ---------------------------------------------------------------------------

loc_76EC8:
		cmp.w	$10(a2),d0
		bcc.s	loc_76EE4
		moveq	#0,d1
		btst	#5,$2A(a2)
		beq.s	loc_76EDC
		ori.w	#$4040,d1

loc_76EDC:
		ori.w	#$404,d1
		move.w	d1,(a1)
		rts
; ---------------------------------------------------------------------------

loc_76EE4:

		move.w	d0,$10(a2)
		clr.w	(a1)
		bclr	#0,4(a2)
		bclr	#0,$2A(a2)
		clr.w	$18(a2)
		clr.w	$1A(a2)
		clr.w	$1C(a2)
		move.w	#$55,($FFFFEEC6).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_76F0E:
		lea	word_773B8(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.w	8(a0),$3C(a0)
		move.l	#loc_76F24,(a0)

loc_76F24:
		bsr.w	sub_770EA
		movea.w	$46(a0),a1
		moveq	#8,d0
		btst	#6,$2A(a1)
		bne.s	loc_76F40
		bsr.w	sub_7710C
		jmp	(Child_DrawTouch_Sprite).l
; ---------------------------------------------------------------------------

loc_76F40:
		jmp	(loc_849D8).l
; ---------------------------------------------------------------------------

loc_76F46:

		jsr	(Refresh_ChildPositionAdjusted).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_76F60(pc,d0.w),d1
		jsr	off_76F60(pc,d1.w)
		jmp	(Child_DrawTouch_Sprite).l
; ---------------------------------------------------------------------------
off_76F60:	dc.w loc_76F6A-off_76F60

		dc.w locret_76F86-off_76F60
		dc.w loc_76F88-off_76F60
		dc.w loc_76FA6-off_76F60
		dc.w loc_7701C-off_76F60
; ---------------------------------------------------------------------------

loc_76F6A:
		lea	word_773C4(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		tst.b	$2C(a0)
		bne.s	locret_76F84
		clr.b	$28(a0)
		move.b	#4,5(a0)

locret_76F84:
		rts
; ---------------------------------------------------------------------------

locret_76F86:
		rts
; ---------------------------------------------------------------------------

loc_76F88:
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		beq.s	locret_76FA4
		move.b	#6,5(a0)
		move.b	#-$29,$28(a0)
		clr.b	$29(a0)

locret_76FA4:
		rts
; ---------------------------------------------------------------------------

loc_76FA6:
		jsr	(Check_PlayerCollision).l
		beq.s	locret_76FF8
		jsr	(Check_PlayerAttack).l
		bne.s	loc_76FC2
		tst.b	$34(a1)
		bne.s	locret_76FF8
		jmp	(HurtSonic_Directly).l
; ---------------------------------------------------------------------------

loc_76FC2:
		neg.w	$18(a1)
		neg.w	$1A(a1)
		neg.w	$1C(a1)
		move.b	#8,5(a0)
		move.l	#byte_77495,$30(a0)
		move.l	#loc_76FFA,$34(a0)
		movea.w	$46(a0),a2
		move.w	a1,$44(a2)
		bset	#6,$2A(a2)
		bset	#7,$38(a2)

locret_76FF8:

		rts
; ---------------------------------------------------------------------------

loc_76FFA:
		move.b	#$1A,$22(a0)
		movea.w	$46(a0),a1
		bclr	#6,$2A(a1)
		bclr	#1,$38(a1)
		move.b	#4,5(a0)
		clr.b	$28(a0)
		rts
; ---------------------------------------------------------------------------

loc_7701C:
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_77022:
		lea	word_773BE(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.w	8(a0),$3C(a0)
		movea.w	$46(a0),a1
		bclr	#0,4(a0)
		btst	#0,4(a1)
		beq.s	loc_7704A
		bset	#0,4(a0)

loc_7704A:
		move.l	#loc_77062,(a0)
		move.w	#-$100,$1A(a0)
		move.w	#$3F,$2E(a0)
		jmp	(Child_DrawTouch_Sprite).l
; ---------------------------------------------------------------------------

loc_77062:
		bsr.w	sub_770EA
		jmp	(MoveDraw_SpriteTimed).l
; ---------------------------------------------------------------------------

loc_7706C:

		lea	ObjDat3_773CA(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_770C4,(a0)
		movea.w	$46(a0),a1
		move.b	$42(a0),d0
		btst	#0,4(a1)
		beq.s	loc_7708E
		neg.b	d0

loc_7708E:
		ext.w	d0
		move.w	$10(a1),d1
		add.w	d0,d1
		moveq	#0,d0
		move.b	$2C(a0),d0
		lea	byte_770B8(pc,d0.w),a2
		move.b	(a2)+,d0
		bmi.s	loc_770AA
		bset	#0,4(a0)

loc_770AA:
		ext.w	d0
		add.w	d0,d1
		move.w	d1,$10(a0)
		move.b	(a2)+,$2E(a0)
		rts
; ---------------------------------------------------------------------------
byte_770B8:	dc.b  $E8,  $B
		dc.b  $18,  $B
		dc.b  $F0,   5
		dc.b  $10,   5
		dc.b  $F8, $FF
		dc.b	8, $FF
; ---------------------------------------------------------------------------

loc_770C4:
		subq.b	#1,$2E(a0)
		bpl.s	locret_770D8
		move.l	#loc_770DA,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)

locret_770D8:
		rts
; ---------------------------------------------------------------------------

loc_770DA:
		lea	byte_7749B(pc),a1
		jsr	(Animate_RawNoSSTMultiDelay).l
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_770EA:

		bset	#7,$A(a0)
		move.w	$3C(a0),d0
		cmpi.w	#$4200,$10(a0)
		bcc.s	loc_77106
		move.w	#$80,d0
		bclr	#7,$A(a0)

loc_77106:
		move.w	d0,8(a0)
		rts
; End of function sub_770EA


; =============== S U B R O U T I N E =======================================


sub_7710C:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	off_7716E(pc,d0.w),d1
		lea	off_7716E(pc,d1.w),a1
		movea.w	$46(a0),a2
		moveq	#0,d1
		move.b	$39(a2),d1
		andi.b	#$3F,d1
		lsl.w	#2,d1
		adda.w	d1,a1
		move.b	(a1)+,d2
		ext.w	d2
		move.b	(a1)+,d3
		ext.w	d3
		move.b	(a1)+,$22(a0)
		bclr	#0,4(a0)
		btst	#0,4(a2)
		beq.s	loc_7714E
		bset	#0,4(a0)
		neg.w	d2

loc_7714E:
		tst.b	(a1)
		beq.s	loc_77158
		bchg	#0,4(a0)

loc_77158:
		move.w	$10(a2),d1
		add.w	d2,d1
		move.w	d1,$10(a0)
		move.w	$14(a2),d1
		add.w	d3,d1
		move.w	d1,$14(a0)
		rts
; End of function sub_7710C

; ---------------------------------------------------------------------------
off_7716E:	dc.w byte_7717E-off_7716E

		dc.w byte_771A6-off_7716E
		dc.w byte_771CE-off_7716E
		dc.w byte_771F6-off_7716E
		dc.w byte_7721E-off_7716E
		dc.w byte_77246-off_7716E
		dc.w byte_7726E-off_7716E
		dc.w byte_77296-off_7716E
byte_7717E:	dc.b	0, $F8,	$15,   0
		dc.b	0, $F8,	$15,   0
		dc.b	0, $F8,	$15,   0
		dc.b	0, $F8,	$15,   0
		dc.b	0, $F8,	$15,   0
		dc.b  $FF, $F7,	$15,   0
		dc.b  $FE, $F6,	$15,   0
		dc.b  $FD, $F5,	$15,   0
		dc.b  $FC, $F4,	$15,   0
		dc.b	0, $F8,	$16,   0
byte_771A6:	dc.b  $F4, $14,	  6,   0
		dc.b  $F4, $14,	  6,   0
		dc.b  $F4, $14,	  6,   0
		dc.b  $F4, $14,	  6,   0
		dc.b  $F5, $14,	  6,   0
		dc.b  $EC,  $D,	  7,   0
		dc.b  $E0,   0,	  8,   0
		dc.b  $E4, $F6,	  9,   0
		dc.b  $E0, $EC,	 $A,   0
		dc.b  $F8, $14,	 $B,   0
byte_771CE:	dc.b	0,   4,	$17,   0
		dc.b	0,   4,	$17,   0
		dc.b	0,   4,	$17,   0
		dc.b	0,   4,	$17,   0
		dc.b	1,   4,	$17,   0
		dc.b  $FC,   2,	$17,   0
		dc.b  $F8,   0,	$17,   0
		dc.b  $F4, $FE,	$17,   0
		dc.b  $F0, $F8,	$17,   0
		dc.b	0,   4,	$17,   0
byte_771F6:	dc.b	0, $28,	 $C,   1
		dc.b  $FF, $28,	 $C,   1
		dc.b  $F8, $20,	 $C,   1
		dc.b  $F3, $1A,	 $C,   1
		dc.b  $F2, $19,	 $C,   1
		dc.b  $F3, $1A,	 $C,   1
		dc.b  $F8, $20,	 $C,   1
		dc.b  $FF, $28,	 $C,   1
		dc.b	0, $28,	 $C,   1
		dc.b	0, $28,	 $F,   1
byte_7721E:	dc.b	0, $14,	 $C,   0
		dc.b	2, $14,	 $C,   0
		dc.b  $FC, $10,	 $D,   0
		dc.b  $FE,  $E,	 $E,   0
		dc.b  $FE,  $E,	 $E,   0
		dc.b  $FE,  $E,	 $E,   0
		dc.b  $FC, $10,	 $D,   0
		dc.b	2, $14,	 $C,   0
		dc.b	0, $14,	 $C,   0
		dc.b	0, $14,	 $F,   0
byte_77246:	dc.b  $F8, $1C,	$17,   0
		dc.b  $FA, $1C,	$17,   0
		dc.b  $F6, $14,	$17,   0
		dc.b  $F2,  $E,	$17,   0
		dc.b  $F2,  $E,	$17,   0
		dc.b  $F2,  $E,	$17,   0
		dc.b  $F6, $14,	$17,   0
		dc.b  $FA, $1C,	$17,   0
		dc.b  $F8, $1C,	$17,   0
		dc.b  $FC, $1C,	$17,   0
byte_7726E:	dc.b  $FC, $34,	$10,   0
		dc.b  $FB, $34,	$10,   0
		dc.b  $F4, $2C,	$10,   0
		dc.b  $EF, $26,	$10,   0
		dc.b  $EE, $25,	$10,   0
		dc.b  $EF, $26,	$10,   0
		dc.b  $F4, $2C,	$10,   0
		dc.b  $FB, $34,	$10,   0
		dc.b  $FC, $34,	$10,   0
		dc.b  $FC, $34,	$11,   0
byte_77296:	dc.b	0, $14,	  3,   0
		dc.b	2, $14,	  3,   0
		dc.b	2, $14,	  3,   0
		dc.b	2, $14,	  3,   0
		dc.b	2, $14,	  3,   0
		dc.b	2, $14,	  3,   0
		dc.b	2, $14,	  3,   0
		dc.b	2, $14,	  3,   0
		dc.b	0, $14,	  3,   0
		dc.b	0, $14,	  3,   0

; =============== S U B R O U T I N E =======================================


sub_772BE:

		moveq	#0,d0
		move.b	$23(a0),d0
		adda.w	d0,a1
		move.b	(a1)+,d0
		ext.w	d0
		btst	#0,4(a0)
		beq.s	loc_772D4
		neg.w	d0

loc_772D4:
		add.w	d0,$10(a0)
		move.b	(a1)+,d0
		ext.w	d0
		add.w	d0,$14(a0)
		rts
; End of function sub_772BE

; ---------------------------------------------------------------------------
byte_772E2:	dc.b	0,   0

		dc.b	1,   0
		dc.b	7,   8
		dc.b	5,   6
		dc.b	1,   1
		dc.b  $FF, $FF
		dc.b  $FB, $FA
		dc.b  $F9, $F8
		dc.b  $FF,   0
		dc.b	0,   0

; =============== S U B R O U T I N E =======================================


sub_772F6:
		cmpi.w	#$A10,$14(a0)
		bcc.s	loc_77364
		btst	#6,$2A(a0)
		beq.w	locret_773AA
		bclr	#7,$38(a0)
		beq.w	locret_773AA
		move.b	#$C,5(a0)
		move.l	#loc_76CA2,$34(a0)
		move.b	#8,$1E(a0)
		moveq	#0,d0
		move.b	d0,$22(a0)
		move.b	d0,$23(a0)
		move.b	d0,$24(a0)
		move.b	d0,$3A(a0)
		move.b	d0,$39(a0)
		moveq	#$59,d0
		jsr	(Play_Sound_2).l
		movea.w	$44(a0),a1
		move.w	#$200,d0
		move.w	$10(a1),d1
		cmp.w	$10(a0),d1
		bcs.s	loc_77358
		neg.w	d0

loc_77358:
		move.w	d0,$18(a0)
		move.w	#-$200,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_77364:
		move.l	#loc_76E0A,(a0)
		clr.w	$18(a0)
		move.w	#$40,$1A(a0)
		move.w	#$BF,$2E(a0)
		clr.b	($FFFFFE1E).w
		move.w	($FFFFEE14).w,($FFFFFA94).w
		move.w	($FFFFEE16).w,($FFFFFA92).w
		move.w	($FFFFEE78).w,($FFFFEE14).w
		move.w	($FFFFEE78).w,($FFFFEE16).w
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	locret_773AA
		move.b	#4,$2C(a1)

locret_773AA:

		rts
; End of function sub_772F6

; ---------------------------------------------------------------------------
ObjDat3_773AC:	dc.l Map_SOZMiniboss
		dc.w $A3B5
		dc.w $300
		dc.b $24
		dc.b $34
		dc.b 0
		dc.b 0
word_773B8:	dc.w $280
		dc.b $14
		dc.b $14
		dc.b 0
		dc.b 0
word_773BE:	dc.w $280
		dc.b $34
		dc.b $34
		dc.b $18
		dc.b 0
word_773C4:	dc.w $280
		dc.b $C
		dc.b $10
		dc.b $1A
		dc.b $A8
ObjDat3_773CA:	dc.l Map_SOZMinibossDust
		dc.w $C4F3
		dc.w $180
		dc.b 8
		dc.b 8
		dc.b 0
		dc.b 0
ChildObjDat_773D6:dc.w 7
		dc.l loc_76F0E
		dc.w 0
ChildObjDat_773DE:dc.w 0
		dc.l loc_77022
		dc.w $40
ChildObjDat_773E6:dc.w 1
		dc.l loc_76F46
		dc.w $F4E4
		dc.l loc_76F46
		dc.w 0
ChildObjDat_773F4:dc.w 1
		dc.l Obj_DecLevStartXGradual
		dc.w 0
		dc.l Obj_IncLevEndXGradual
		dc.w 0
ChildObjDat_77402:dc.w 5
		dc.l loc_7706C
		dc.w $FC38
ChildObjDat_7740A:dc.w 5
		dc.l loc_7706C
		dc.w 4
Pal_SOZMinibossFade:	binclude "Levels\SOZ\Palettes\Miniboss Fade.bin"

Pal_SOZMinibossMain:	binclude "Levels\SOZ\Palettes\Miniboss Main.bin"

byte_77452:	dc.b	0,   9
		dc.b	0, $1F
		dc.b	9,   9
		dc.b  $49,   9
		dc.b	0,   9
		dc.b  $F4
byte_7745D:	dc.b	0,   9
		dc.b	0,   9
		dc.b	5,   4
		dc.b	6,   4
		dc.b	7,   4
		dc.b	8,   1
		dc.b  $F4
byte_7746A:	dc.b	8,   4
		dc.b	7,   4
		dc.b	6,   4
		dc.b	5,   4
		dc.b	4,   4
		dc.b	3,   9
		dc.b	2,   9
		dc.b	1,   9
		dc.b	0, $1F
		dc.b  $F4
byte_7747D:	dc.b   $F,   0
		dc.b  $19,   1
		dc.b  $F4
byte_77482:	dc.b	0,   4
		dc.b	1,   4
		dc.b	2,   4
		dc.b	3,   4
		dc.b	4,   4
		dc.b	5,   9
		dc.b	6,   9
		dc.b	7,   5
		dc.b	8,   0
		dc.b  $F4
byte_77495:	dc.b	3, $12
		dc.b  $12, $13
		dc.b  $14, $F4
byte_7749B:	dc.b	0,   3
		dc.b	0,   3
		dc.b	1,   5
		dc.b	2,   5
		dc.b	3,   7
		dc.b  $F4
Map_SOZMiniboss:	include "Levels\SOZ\Misc Object Data\Map - Miniboss.asm"

Map_SOZMinibossDust:	include "Levels\SOZ\Misc Object Data\Map - Miniboss Landing Dust.asm"

; ---------------------------------------------------------------------------

Obj_SOZ_EndBoss:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7766E(pc,d0.w),d1
		jsr	off_7766E(pc,d1.w)
		move.w	$10(a0),($FFFFEEDE).w
		move.w	$14(a0),($FFFFEEE0).w
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_7766E:	dc.w loc_7767C-off_7766E

		dc.w loc_776EA-off_7766E
		dc.w loc_77710-off_7766E
		dc.w loc_77772-off_7766E
		dc.w loc_77790-off_7766E
		dc.w loc_777CC-off_7766E
		dc.w loc_777F0-off_7766E
; ---------------------------------------------------------------------------

loc_7767C:
		lea	ObjDat3_7828A(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#8,$29(a0)
		move.w	$14(a0),$3A(a0)
		move.w	#$C0,($FFFFFA82).w
		lea	(ArtKosM_SOZEndBoss).l,a1
		move.w	#$7480,d2
		jsr	(Queue_Kos_Module).l
		moveq	#$6D,d0
		jsr	(Load_PLC).l
		lea	Pal_SOZEndBoss1(pc),a1
		jsr	(PalLoad_Line1).l
		lea	(Pal_SOZEndBoss2).l,a1
		lea	($FFFFFC60).w,a2
		moveq	#7,d6

loc_776C6:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_776C6
		lea	ChildObjDat_782FA(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	ChildObjDat_78320(pc),a2
		jsr	(CreateChild8_TreeListRepeated).l
		lea	ChildObjDat_78326(pc),a2
		jmp	(CreateChild8_TreeListRepeated).l
; ---------------------------------------------------------------------------

loc_776EA:
		lea	($FFFFB000).w,a1
		jsr	(Find_OtherObject).l
		cmpi.w	#$C0,d2
		bcc.s	locret_7770E
		move.b	#4,5(a0)
		move.w	#$3B,$2E(a0)
		moveq	#-$1F,d0
		jsr	(Play_Sound).l

locret_7770E:
		rts
; ---------------------------------------------------------------------------

loc_77710:
		subq.w	#1,$2E(a0)
		bpl.w	locret_77AF6
		move.b	#6,5(a0)
		moveq	#$19,d0
		jsr	(Play_Sound).l
		move.b	#$19,($FFFFFF91).w

loc_7772C:
		lea	word_7775A(pc),a1
		cmpi.b	#2,($FFFFB038).w
		bne.s	loc_7773C
		lea	word_77766(pc),a1

loc_7773C:

		move.w	(a1)+,$18(a0)
		move.w	(a1)+,$3E(a0)
		move.w	(a1)+,$40(a0)
		move.w	(a1),$30(a0)
		move.w	(a1)+,$2E(a0)
		move.w	(a1)+,$32(a0)
		move.w	(a1)+,$46(a0)
		rts
; ---------------------------------------------------------------------------
word_7775A:	dc.w  $FFC0,  $100, $FF80,   $3F,   $7F,   $1F
word_77766:	dc.w  $FF80,  $200, $FF00,   $1F,   $3F,   $1F
; ---------------------------------------------------------------------------

loc_77772:
		jsr	(MoveSprite2).l
		bsr.w	sub_7808C
		subq.w	#1,$2E(a0)
		bpl.s	locret_7778E
		move.b	#8,5(a0)
		move.w	$30(a0),$2E(a0)

locret_7778E:
		rts
; ---------------------------------------------------------------------------

loc_77790:
		bsr.w	sub_7806C
		jsr	(MoveSprite2).l
		bsr.w	sub_7808C
		move.w	$3C(a0),d0
		add.w	$40(a0),d0
		move.w	d0,$3C(a0)
		subq.w	#1,$2E(a0)
		bpl.s	locret_777CA
		move.b	#$A,5(a0)
		move.w	$46(a0),$2E(a0)
		move.w	#$14,($FFFFEECC).w
		moveq	#-$65,d0
		jsr	(Play_Sound_2).l

locret_777CA:
		rts
; ---------------------------------------------------------------------------

loc_777CC:
		bsr.w	sub_7806C
		subq.w	#1,$2E(a0)
		bpl.s	locret_777EE
		move.b	#8,5(a0)
		bsr.w	sub_78038
		neg.b	$3E(a0)
		neg.w	$40(a0)
		move.w	$32(a0),$2E(a0)

locret_777EE:
		rts
; ---------------------------------------------------------------------------

loc_777F0:
		tst.w	($FFFFEEDC).w
		beq.s	loc_777FA
		bra.w	loc_781E4
; ---------------------------------------------------------------------------

loc_777FA:
		move.b	$42(a0),5(a0)
		clr.b	$28(a0)
		moveq	#0,d0
		bra.w	sub_7825E
; ---------------------------------------------------------------------------

loc_7780A:
		move.l	#loc_77822,(a0)
		bset	#4,$38(a0)
		bset	#7,$A(a0)
		clr.w	$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_77822:
		jsr	(MoveSprite_LightGravity).l
		cmpi.w	#$200,$1A(a0)
		blt.s	loc_77842
		move.l	#loc_77848,(a0)
		bclr	#7,$2A(a0)
		bset	#0,4(a0)

loc_77842:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_77848:
		addi.w	#-$40,$1A(a0)
		jsr	(MoveSprite2).l
		cmpi.w	#-$100,$1A(a0)
		bgt.s	loc_77894
		move.l	#loc_7789A,(a0)
		jsr	(Swing_Setup1).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_77882
		move.l	#Obj_81,(a1)
		move.w	#$5360,$10(a1)
		move.w	#$720,$14(a1)

loc_77882:
		bclr	#4,$38(a0)
		lea	(Child1_MakeRoboShipFlame).l,a2
		jsr	(CreateChild1_Normal).l

loc_77894:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7789A:
		move.w	($FFFFEE78).w,($FFFFEE14).w
		jsr	(Swing_UpAndDown).l
		subq.w	#1,$14(a0)
		move.w	$18(a0),d0
		addi.w	#$20,d0
		cmpi.w	#$400,d0
		bls.s	loc_778BC
		move.w	#$400,d0

loc_778BC:
		move.w	d0,$18(a0)
		jsr	(MoveSprite2).l
		move.w	($FFFFEE78).w,d0
		addi.w	#$1A0,d0
		cmp.w	$10(a0),d0
		bcs.s	loc_778DA
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_778DA:
		move.l	#loc_778F2,(a0)
		st	($FFFFFAA8).w
		ori.b	#$30,$38(a0)
		bclr	#7,4(a0)
		rts
; ---------------------------------------------------------------------------

loc_778F2:
		move.w	($FFFFEE78).w,($FFFFEE14).w
		tst.b	($FFFFFAA8).w
		bne.w	locret_77AF6
		move.l	#loc_77966,(a0)
		jsr	(Restore_PlayerControl).l
		jsr	(Obj_PlayLevelMusic).l
		clr.w	($FFFFF602).w
		st	($FFFFF7CA).w
		clr.w	$2E(a0)
		lea	($FFFFB04A).w,a1
		jsr	(Restore_PlayerControl2).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_77936
		move.l	#loc_77A6E,(a1)

loc_77936:
		jsr	(Create_New_Sprite).l
		bne.s	loc_77944
		move.l	#loc_863C0,(a1)

loc_77944:
		move.w	#-$100,($FFFFEE18).w
		move.w	#$800,($FFFFEE12).w
		move.w	#$5440,($FFFFFA92).w
		jsr	(Create_New_Sprite).l
		bne.s	locret_77964
		move.l	#Obj_IncLevEndXGradual,(a1)

locret_77964:
		rts
; ---------------------------------------------------------------------------

loc_77966:
		cmpi.w	#$700,($FFFFEE12).w
		bcs.s	loc_77974
		move.w	#$800,($FFFFEE1A).w

loc_77974:
		lea	($FFFFB000).w,a1
		cmpi.w	#$5468,$10(a1)
		bcc.s	loc_77986
		jmp	(loc_86334).l
; ---------------------------------------------------------------------------

loc_77986:
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		move.w	$18(a1),$18(a0)
		clr.w	$1A(a0)
		cmpi.b	#2,$38(a1)
		beq.s	loc_779B8
		move.l	#loc_779C0,(a0)
		move.b	#$81,$2E(a1)
		move.b	#$1A,$20(a1)
		rts
; ---------------------------------------------------------------------------

loc_779B8:
		move.l	#loc_77A3E,(a0)
		rts
; ---------------------------------------------------------------------------

loc_779C0:
		jsr	(MoveSprite2).l
		lea	($FFFFB000).w,a1
		move.w	$14(a0),$14(a1)
		move.w	$10(a0),d0
		move.w	#$54C0,d1
		cmp.w	d1,d0
		bcs.s	loc_779FC
		move.l	#loc_77A02,(a0)
		bset	#0,($FFFFFAB8).w
		clr.w	$18(a0)
		clr.w	$1A(a0)
		move.w	d1,d0
		st	($FFFFEE39).w
		move.w	#$7F,$2E(a0)

loc_779FC:
		move.w	d0,$10(a1)
		rts
; ---------------------------------------------------------------------------

loc_77A02:
		cmpi.w	#$1000,$1A(a0)
		bcs.s	loc_77A10
		move.w	#$1000,$1A(a0)

loc_77A10:
		jsr	(MoveSprite).l
		lea	($FFFFB000).w,a1
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		subq.w	#1,$2E(a0)
		bmi.s	loc_77A2E
		rts
; ---------------------------------------------------------------------------

loc_77A2E:
		move.w	#$900,d0
		jsr	(StartNewLevel).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_77A3E:
		jsr	(MoveSprite2).l
		lea	($FFFFB000).w,a1
		move.w	$14(a0),$14(a1)
		move.w	$10(a0),d0
		move.w	d0,$10(a1)
		cmpi.w	#$5560,d0
		bcc.s	loc_77A5E
		rts
; ---------------------------------------------------------------------------

loc_77A5E:
		move.w	#$900,d0
		jsr	(StartNewLevel).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_77A6E:
		btst	#0,($FFFFFAB8).w
		beq.w	locret_77AF6
		move.l	#loc_77A98,(a0)
		lea	($FFFFB04A).w,a1
		bclr	#7,$A(a1)
		move.b	#-$7F,$2E(a1)
		move.b	#$1A,$20(a1)
		clr.b	($FFFFF7CB).w

loc_77A98:
		lea	($FFFFB000).w,a1
		lea	($FFFFB04A).w,a2
		move.w	$10(a1),$10(a2)
		move.w	$14(a1),d0
		subi.w	#$20,d0
		move.w	d0,$14(a2)
		rts
; ---------------------------------------------------------------------------

loc_77AB4:
		addq.b	#6,$2C(a0)

loc_77AB8:
		move.l	#Map_SOZEndBoss,$C(a0)
		move.w	#-$1C5C,$A(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	off_77AD4(pc,d0.w),d0
		jmp	off_77AD4(pc,d0.w)
; ---------------------------------------------------------------------------
off_77AD4:	dc.w loc_77AE0-off_77AD4

		dc.w loc_77B6C-off_77AD4
		dc.w loc_77C08-off_77AD4
		dc.w loc_77AF8-off_77AD4
		dc.w loc_77B7E-off_77AD4
		dc.w loc_77C1A-off_77AD4
; ---------------------------------------------------------------------------

loc_77AE0:
		lea	word_782AE(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_77B16,(a0)
		move.b	#$28,$43(a0)

locret_77AF6:

		rts
; ---------------------------------------------------------------------------

loc_77AF8:
		lea	word_782B4(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_77B50,(a0)
		move.b	#$28,$43(a0)
		bclr	#7,$A(a0)
		rts
; ---------------------------------------------------------------------------

loc_77B16:
		movea.w	$46(a0),a1
		move.b	$3C(a1),d0
		asr.b	#2,d0
		move.b	d0,$42(a0)
		move.w	$10(a0),-(sp)
		jsr	(Refresh_ChildPosition).l
		moveq	#$1F,d1
		moveq	#$14,d2
		moveq	#$14,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectFull).l
		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		bne.w	loc_77C7A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_77B50:
		jsr	(Refresh_ChildPosition).l
		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		beq.w	locret_77AF6
		moveq	#0,d0
		jmp	(loc_849D8).l
; ---------------------------------------------------------------------------

loc_77B6C:
		lea	word_782BA(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_77B9A,(a0)
		rts
; ---------------------------------------------------------------------------

loc_77B7E:
		lea	word_782C0(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_77BE0,(a0)
		bclr	#7,$A(a0)
		st	$3A(a0)
		rts
; ---------------------------------------------------------------------------

loc_77B9A:
		move.w	$10(a0),-(sp)
		movea.w	$44(a0),a1
		move.b	$3C(a1),d0
		tst.b	$3A(a0)
		beq.s	loc_77BAE
		neg.b	d0

loc_77BAE:
		move.b	d0,$3C(a0)
		lea	(AngleLookup_3).l,a2
		jsr	(MoveSprite_AtAngleLookup).l
		moveq	#$1B,d1
		moveq	#$10,d2
		moveq	#$10,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectFull).l
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.w	loc_77C7A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_77BE0:
		movea.w	$44(a0),a1
		move.b	$3C(a1),d0
		tst.b	$3A(a0)
		beq.s	loc_77BF0
		neg.b	d0

loc_77BF0:
		move.b	d0,$3C(a0)
		lea	(AngleLookup_3).l,a2
		jsr	(MoveSprite_AtAngleLookup).l
		moveq	#0,d0
		jmp	(Child_Draw_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------

loc_77C08:
		lea	word_782C6(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_77C32,(a0)
		rts
; ---------------------------------------------------------------------------

loc_77C1A:
		lea	word_782CC(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_77C88,(a0)
		bclr	#7,$A(a0)
		rts
; ---------------------------------------------------------------------------

loc_77C32:
		move.w	$10(a0),-(sp)
		movea.w	$44(a0),a1
		move.b	$3C(a1),$3C(a0)
		lea	(AngleLookup_2).l,a2
		jsr	(MoveSprite_AtAngleLookup).l
		subi.w	#$1C,$10(a0)
		subq.w	#4,$14(a0)
		moveq	#$2B,d1
		moveq	#$14,d2
		moveq	#$C,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectFull).l
		bsr.w	sub_7815A
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_77C7A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_77C7A:

		jsr	(Displace_PlayerOffObject).l
		moveq	#0,d0
		jmp	(loc_849D8).l
; ---------------------------------------------------------------------------

loc_77C88:
		movea.w	$44(a0),a1
		move.b	$3C(a1),d0
		neg.b	d0
		move.b	d0,$3C(a0)
		lea	(AngleLookup_2).l,a2
		jsr	(MoveSprite_AtAngleLookup).l
		subi.w	#$1C,$10(a0)
		subq.w	#4,$14(a0)
		moveq	#0,d0
		jmp	(Child_Draw_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------

loc_77CB4:
		move.b	#$20,7(a0)
		move.b	#$50,6(a0)
		move.l	#loc_77CC6,(a0)

loc_77CC6:

		move.w	$10(a0),-(sp)
		movea.w	$46(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),d0
		subi.w	#$14,d0
		move.w	d0,$14(a0)
		moveq	#$2B,d1
		moveq	#$28,d2
		moveq	#$28,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectFull2).l
		bsr.w	sub_780AC

loc_77CF2:

		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_77D00
		rts
; ---------------------------------------------------------------------------

loc_77D00:
		jsr	(Displace_PlayerOffObject).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_77D0C:
		tst.w	($FFFFEEDC).w
		bne.s	loc_77D18
		move.l	#loc_77CC6,(a0)

loc_77D18:
		bra.s	loc_77CF2
; ---------------------------------------------------------------------------

loc_77D1A:
		move.b	#$30,7(a0)
		move.b	#$30,6(a0)
		move.l	#loc_77D2C,(a0)

loc_77D2C:

		tst.w	($FFFFEEDC).w
		bne.s	loc_77D60
		move.w	$10(a0),-(sp)
		movea.w	$46(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),d0
		addi.w	#$44,d0
		move.w	d0,$14(a0)
		moveq	#$3B,d1
		moveq	#$30,d2
		moveq	#$30,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectFull2).l
		bsr.w	sub_78120
		bra.s	loc_77CF2
; ---------------------------------------------------------------------------

loc_77D60:
		move.l	#loc_77D6C,(a0)
		jsr	(Displace_PlayerOffObject).l

loc_77D6C:
		tst.w	($FFFFEEDC).w
		bne.w	loc_77CF2
		move.l	#loc_77D2C,(a0)
		jsr	(Displace_PlayerOffObject).l
		bra.s	loc_77D2C
; ---------------------------------------------------------------------------

loc_77D82:
		move.b	#$20,7(a0)
		move.b	#-1,6(a0)
		move.l	#loc_77D94,(a0)

loc_77D94:
		movea.w	$46(a0),a1
		move.w	$10(a1),d0
		addi.w	#$20,d0
		move.w	d0,$10(a0)
		move.w	$14(a1),$14(a0)
		moveq	#$2B,d1
		move.w	#$200,d2
		move.w	#$200,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull2).l
		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		bne.s	loc_77DCC
		rts
; ---------------------------------------------------------------------------

loc_77DCC:
		jsr	(Displace_PlayerOffObject).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_77DD8:
		lea	ObjDat3_78296(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_77DEA,(a0)
		rts
; ---------------------------------------------------------------------------

loc_77DEA:
		jsr	(Refresh_ChildPosition).l
		moveq	#0,d0
		jmp	(Child_Draw_Sprite2_FlickerMove).l
; ---------------------------------------------------------------------------

loc_77DF8:
		lea	ObjDat3_782D2(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_77E16,(a0)
		lea	ChildObjDat_78334(pc),a2
		jsr	(CreateChild6_Simple).l
		move.w	a1,$44(a0)

loc_77E16:
		movea.w	$44(a0),a1
		btst	#4,$38(a1)
		bne.s	loc_77E56

loc_77E22:
		jsr	(Refresh_ChildPosition).l
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_77E4A
		tst.w	($FFFFEEDC).w
		bne.s	loc_77E4A
		btst	#0,($FFFFFE0F).w
		bne.w	locret_77AF6
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_77E4A:

		bset	#7,$2A(a0)
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_77E56:
		move.l	#loc_77E74,(a0)
		move.w	#8,$2E(a0)
		moveq	#$5E,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_7833A(pc),a2
		jsr	(CreateChild1_Normal).l

loc_77E74:
		subq.w	#1,$2E(a0)
		bmi.s	loc_77E4A
		bra.s	loc_77E22
; ---------------------------------------------------------------------------

loc_77E7C:
		lea	word_782DE(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#loc_77E90,(a0)
		bsr.w	sub_7819A

loc_77E90:
		subq.w	#1,$2E(a0)
		bmi.s	loc_77EAA
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_77E4A
		tst.w	($FFFFEEDC).w
		bne.s	loc_77E4A
		rts
; ---------------------------------------------------------------------------

loc_77EAA:
		move.l	#loc_77EB8,(a0)
		move.l	#Go_Delete_Sprite_2,$34(a0)

loc_77EB8:
		lea	byte_78348(pc),a1
		jsr	(Animate_RawNoSST).l
		move.w	$18(a0),d0
		addi.w	#$10,d0
		move.w	d0,$18(a0)
		add.w	d0,$3A(a0)
		btst	#2,$38(a0)
		bne.s	loc_77F02
		moveq	#$10,d0
		move.w	$3C(a0),d1
		bmi.s	loc_77EE4
		neg.w	d0

loc_77EE4:
		move.w	$1A(a0),d2
		add.w	d0,d2
		move.w	d2,$1A(a0)
		move.w	d1,d3
		add.w	d2,d1
		eor.w	d1,d3
		bpl.s	loc_77EFE
		moveq	#0,d1
		bset	#2,$38(a0)

loc_77EFE:
		move.w	d1,$3C(a0)

loc_77F02:
		movea.w	$46(a0),a1
		move.w	$10(a1),d0
		move.w	$14(a1),d1
		move.b	$3A(a0),d2
		ext.w	d2
		add.w	d2,d0
		move.w	d0,$10(a0)
		move.b	$3C(a0),d3
		ext.w	d3
		add.w	d3,d1
		move.w	d1,$14(a0)
		btst	#7,$2A(a1)
		bne.w	loc_77E4A
		tst.w	($FFFFEEDC).w
		bne.w	loc_77E4A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_77F3E:
		lea	word_782E6(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#loc_77F94,(a0)
		move.w	#7,$2E(a0)
		lea	($FFFFB000).w,a1
		move.w	$10(a0),d0
		sub.w	$10(a1),d0
		bpl.s	loc_77F64
		neg.w	d0

loc_77F64:
		cmpi.w	#$80,d0
		bcc.s	loc_77F7A
		move.w	#-$400,$18(a0)
		move.w	#$400,$1A(a0)
		bra.w	locret_77F92
; ---------------------------------------------------------------------------

loc_77F7A:
		move.b	#$F,$22(a0)
		move.w	#$8F8,$42(a0)
		move.w	#-$400,$18(a0)
		move.w	#$300,$1A(a0)

locret_77F92:
		rts
; ---------------------------------------------------------------------------

loc_77F94:
		subq.w	#1,$2E(a0)
		bmi.s	loc_77FB6
		move.b	$18(a0),d0
		add.b	d0,$42(a0)
		move.b	$1A(a0),d0
		add.b	d0,$43(a0)
		jsr	(Refresh_ChildPosition).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_77FB6:
		move.l	#loc_77FBC,(a0)

loc_77FBC:
		jsr	(MoveSprite2).l
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_77FCE:
		lea	ObjDat3_782EE(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_77FEC,(a0)
		move.w	#8,$2E(a0)
		move.l	#Go_Delete_Sprite,$34(a0)

loc_77FEC:
		st	($FFFFEF3A).w
		jsr	(Refresh_ChildPosition).l
		jmp	(Wait_Draw).l
; ---------------------------------------------------------------------------

loc_77FFC:
		lea	ObjDat3_782A2(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_78018,(a0)
		move.w	#$5260,$10(a0)
		move.w	#$710,$14(a0)

loc_78018:
		movea.w	$46(a0),a1
		cmpi.w	#$5180,$10(a0)
		bcs.s	loc_78032
		btst	#7,$2A(a1)
		bne.s	loc_78032
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_78032:

		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_78038:
		tst.b	$3C(a0)
		bpl.s	locret_7805E
		tst.w	$18(a0)
		bpl.s	loc_78054
		cmpi.w	#$4E80,$10(a0)
		bcc.s	locret_7805E
		lea	word_78060(pc),a1
		bra.w	loc_7773C
; ---------------------------------------------------------------------------

loc_78054:
		cmpi.w	#$5210,$10(a0)
		bcc.w	loc_7772C

locret_7805E:

		rts
; End of function sub_78038

; ---------------------------------------------------------------------------
word_78060:	dc.w   $400,  $800, $FC00,   $1F,    $F,     7

; =============== S U B R O U T I N E =======================================


sub_7806C:

		subq.w	#1,($FFFFFA82).w
		bpl.w	locret_77AF6
		move.w	#$200,($FFFFFA82).w
		moveq	#$53,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_7832C(pc),a2
		jmp	(CreateChild1_Normal).l
; End of function sub_7806C


; =============== S U B R O U T I N E =======================================


sub_7808C:

		move.b	$26(a0),d0
		sub.b	$3E(a0),d0
		move.b	d0,$26(a0)
		jsr	(GetSineCosine).l
		asr.w	#4,d0
		move.w	$3A(a0),d1
		add.w	d0,d1
		move.w	d1,$14(a0)
		rts
; End of function sub_7808C


; =============== S U B R O U T I N E =======================================


sub_780AC:
		swap	d6
		moveq	#0,d0
		lea	($FFFFB000).w,a1
		bsr.w	sub_780BE
		moveq	#1,d0
		lea	($FFFFB04A).w,a1
; End of function sub_780AC


; =============== S U B R O U T I N E =======================================


sub_780BE:
		btst	d0,d6
		beq.s	locret_78118
		move.w	$10(a0),d0
		sub.w	$10(a1),d0
		bcs.s	loc_7811A
		cmpi.b	#2,$20(a1)
		beq.s	loc_780E4
		cmpi.b	#2,$38(a1)
		bne.s	loc_780E4
		cmpi.b	#1,$2F(a1)
		bne.s	locret_78118

loc_780E4:

		move.w	$14(a1),($FFFFEEDC).w
		move.l	#loc_77D0C,(a0)
		move.w	#-$400,$18(a1)
		move.w	#-$300,$1A(a1)
		movea.w	$46(a0),a2
		move.b	5(a2),$42(a2)
		move.b	#$C,5(a2)
		move.b	#$F,$28(a2)
		jsr	(Displace_PlayerOffObject).l

locret_78118:

		rts
; ---------------------------------------------------------------------------

loc_7811A:
		jmp	(sub_24280).l
; End of function sub_780BE


; =============== S U B R O U T I N E =======================================


sub_78120:
		swap	d6
		moveq	#0,d0
		moveq	#3,d1
		lea	($FFFFB000).w,a1
		bsr.w	sub_78136
		moveq	#1,d0
		moveq	#4,d1
		lea	($FFFFB04A).w,a1
; End of function sub_78120


; =============== S U B R O U T I N E =======================================


sub_78136:
		btst	d0,d6
		bne.s	loc_78140
		bclr	d1,$2A(a0)
		beq.s	locret_78158

loc_78140:
		bclr	#3,$2A(a1)
		tst.b	$34(a1)
		bne.s	locret_78158
		andi.b	#-$61,$2A(a0)
		jsr	(sub_24280).l

locret_78158:

		rts
; End of function sub_78136


; =============== S U B R O U T I N E =======================================


sub_7815A:
		movea.w	$44(a0),a1
		btst	#7,$2A(a1)
		bne.s	locret_78198
		swap	d6
		moveq	#0,d0
		lea	($FFFFB000).w,a1
		bsr.w	sub_78178
		moveq	#1,d0
		lea	($FFFFB04A).w,a1
; End of function sub_7815A


; =============== S U B R O U T I N E =======================================


sub_78178:
		btst	d0,d6
		beq.s	locret_78198
		tst.b	$34(a1)
		bne.s	locret_78198
		move.w	$10(a0),d0
		sub.w	$10(a1),d0
		bcs.s	locret_78198
		andi.b	#-$61,$2A(a0)
		jsr	(sub_24280).l

locret_78198:
		rts
; End of function sub_78178


; =============== S U B R O U T I N E =======================================


sub_7819A:
		moveq	#0,d0
		move.b	$2C(a0),d0
		lea	word_781BC(pc,d0.w),a1
		move.b	(a1)+,$3A(a0)
		move.b	(a1)+,$3C(a0)
		move.w	word_781BC(pc,d0.w),$42(a0)
		addq.w	#2,d0
		lsl.w	#2,d0
		move.w	d0,$2E(a0)
		rts
; End of function sub_7819A

; ---------------------------------------------------------------------------
word_781BC:	dc.w $EA02
		dc.w $F0F8
		dc.w $EC09
		dc.w $E5FC
		dc.w $F308
		dc.w $EAFB
		dc.w $E104
		dc.w $EE0D
		dc.w $E8F8
		dc.w $ECFF
		dc.w $E0FE
		dc.w $E40C
		dc.w $E6FF
		dc.w $DC09
		dc.w $E1F6
		dc.w $E604
		dc.w $EC02
		dc.w $EA06
		dc.w $E8F4
		dc.w $DA0C
; ---------------------------------------------------------------------------

loc_781E4:
		tst.b	$28(a0)
		bne.s	locret_7822E
		tst.b	$29(a0)
		beq.s	loc_78230
		tst.b	$20(a0)
		bne.s	loc_7820A
		bset	#6,$2A(a0)
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l

loc_7820A:
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_78218
		addi.w	#$A,d0

loc_78218:
		bsr.w	sub_7825E
		subq.b	#1,$20(a0)
		bne.s	locret_7822E
		bclr	#6,$2A(a0)
		move.b	$25(a0),$28(a0)

locret_7822E:

		rts
; ---------------------------------------------------------------------------

loc_78230:
		move.l	#Wait_FadeToLevelMusic,(a0)
		move.l	#loc_7780A,$34(a0)
		move.w	#$55,($FFFFEEC6).w
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		move.w	($FFFFEE78).w,d0
		move.w	d0,($FFFFEE14).w
		jmp	(BossDefeated_StopTimer).l

; =============== S U B R O U T I N E =======================================


sub_7825E:

		lea	word_7826C(pc),a1
		lea	word_78276(pc,d0.w),a2
		jmp	(CopyWordData_3).l
; End of function sub_7825E

; ---------------------------------------------------------------------------
word_7826C:	dc.w $FC6C
		dc.w $FC6E
		dc.w $FC70
		dc.w $FC72
		dc.w $FC74
word_78276:	dc.w $6E
		dc.w $24C
		dc.w $28
		dc.w 4
		dc.w 2
		dc.w $AAA
		dc.w $CCC
		dc.w $CCC
		dc.w $EEE
		dc.w $EEE
ObjDat3_7828A:	dc.l Map_RobotnikShip
		dc.w $52E
		dc.w $300
		dc.b $20
		dc.b $20
		dc.b $A
		dc.b 0
ObjDat3_78296:	dc.l Map_SOZEndBoss
		dc.w $23A4
		dc.w $280
		dc.b $18
		dc.b $1C
		dc.b 6
		dc.b 0
ObjDat3_782A2:	dc.l Map_SOZEndBossBody
		dc.w 1
		dc.w 0
		dc.b $10
		dc.b $30
		dc.b 0
		dc.b 0
word_782AE:	dc.w $200
		dc.b $18
		dc.b $18
		dc.b 0
		dc.b 0
word_782B4:	dc.w $300
		dc.b $18
		dc.b $18
		dc.b 3
		dc.b 0
word_782BA:	dc.w $180
		dc.b $14
		dc.b $14
		dc.b 1
		dc.b 0
word_782C0:	dc.w $300
		dc.b $14
		dc.b $14
		dc.b 4
		dc.b 0
word_782C6:	dc.w $100
		dc.b $28
		dc.b $14
		dc.b 2
		dc.b 0
word_782CC:	dc.w $300
		dc.b $28
		dc.b $14
		dc.b 5
		dc.b 0
ObjDat3_782D2:	dc.l Map_SOZEndBoss
		dc.w $A3A4
		dc.w $180
		dc.b 8
		dc.b 8
		dc.b $D
		dc.b 0
word_782DE:	dc.w $23A4
		dc.w $200
		dc.b 4
		dc.b 4
		dc.b $A
		dc.b 0
word_782E6:	dc.w $23A4
		dc.w $300
		dc.b $14
		dc.b $14
		dc.b $E
		dc.b $98
ObjDat3_782EE:	dc.l Map_SpriteMask
		dc.w 0
		dc.w $280
		dc.b $20
		dc.b $20
		dc.b 4
		dc.b 0
ChildObjDat_782FA:dc.w 5
		dc.l loc_77CB4
		dc.w $EC
		dc.l loc_77D1A
		dc.w $40
		dc.l loc_77D82
		dc.w $2000
		dc.l loc_77FFC
		dc.w 0
		dc.l loc_77DD8
		dc.w $24
		dc.l Obj_RobotnikHead4
		dc.w $E4
ChildObjDat_78320:dc.w 2
		dc.l loc_77AB8
ChildObjDat_78326:dc.w 2
		dc.l loc_77AB4
ChildObjDat_7832C:dc.w 0
		dc.l loc_77DF8
		dc.w $E8D2
ChildObjDat_78334:dc.w $13
		dc.l loc_77E7C
ChildObjDat_7833A:dc.w 1
		dc.l loc_77FCE
		dc.w $EC
		dc.l loc_77F3E
		dc.w $4F6
byte_78348:	dc.b 7
		dc.b $A
		dc.b $A
		dc.b $B
		dc.b $C
		dc.b $F4
Map_SOZEndBoss:	include "Levels\SOZ\Misc Object Data\Map - End Boss.asm"

Map_SOZEndBossBody:	include "Levels\SOZ\Misc Object Data\Map - End Boss Body.asm"

Pal_SOZEndBoss1:	binclude "Levels\SOZ\Palettes\End Boss 1.bin"

Pal_SOZEndBoss2:	binclude "Levels\SOZ\Palettes\End Boss 2.bin"

byte_784E0:	dc.b	6, $10
		dc.b	8, $10
		dc.b  $2B,   0
		dc.b  $2D,   0
byte_784E8:	dc.b	7, $10
		dc.b	7, $10
		dc.b  $2C,   0
		dc.b  $2C,   0
; ---------------------------------------------------------------------------

Obj_LRZ_Miniboss:
		lea	byte_784E0(pc),a1
		jsr	(Check_CameraInRange).l
		move.l	#loc_78522,(a0)
		move.l	#loc_78528,$34(a0)
		lea	byte_784E8(pc),a1
		move.b	#$2E,$26(a0)
		jsr	(sub_85D6A).l
		lea	Pal_LRZMiniboss1(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_78522:
		jmp	(loc_85CA4).l
; ---------------------------------------------------------------------------

loc_78528:
		move.l	#loc_78538,(a0)
		lea	Pal_LRZMiniboss2(pc),a1
		bsr.w	sub_78B38

locret_78536:

		rts
; ---------------------------------------------------------------------------

loc_78538:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7854C(pc,d0.w),d1
		jsr	off_7854C(pc,d1.w)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_7854C:	dc.w loc_78562-off_7854C

		dc.w loc_78592-off_7854C
		dc.w loc_785C2-off_7854C
		dc.w loc_785E4-off_7854C
		dc.w loc_785E4-off_7854C
		dc.w loc_78628-off_7854C
		dc.w loc_78666-off_7854C
		dc.w loc_785E4-off_7854C
		dc.w loc_786DA-off_7854C
		dc.w loc_7871A-off_7854C
		dc.w loc_78768-off_7854C
; ---------------------------------------------------------------------------

loc_78562:
		lea	ObjDat3_78D5A(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#6,$29(a0)
		move.w	#$7A8,($FFFFFAB0).w
		move.w	$14(a0),($FFFFFAB2).w
		lea	ChildObjDat_78D84(pc),a2
		jsr	(CreateChild8_TreeListRepeated).l
		lea	ChildObjDat_78D8A(pc),a2
		jmp	(CreateChild8_TreeListRepeated).l
; ---------------------------------------------------------------------------

loc_78592:
		tst.l	($FFFFF680).w
		bne.w	locret_78536
		move.b	#4,5(a0)
		move.w	#$2F,$2E(a0)
		lea	(ArtKosM_LRZMiniboss).l,a1
		move.w	#$7F60,d2
		jsr	(Queue_Kos_Module).l
		lea	(PLC_83D64).l,a1
		jmp	(Load_PLC_Raw).l
; ---------------------------------------------------------------------------

loc_785C2:
		subq.w	#1,$2E(a0)
		bpl.s	locret_785E2
		move.b	#6,5(a0)
		bset	#3,$38(a0)
		move.w	#$15F,$2E(a0)
		move.l	#loc_785EA,$34(a0)

locret_785E2:
		rts
; ---------------------------------------------------------------------------

loc_785E4:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_785EA:

		move.b	#8,5(a0)
		bclr	#3,$38(a0)
		move.w	#$4F,$2E(a0)
		move.l	#loc_78606,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_78606:
		move.b	#$A,5(a0)
		clr.w	$18(a0)
		move.w	#-$400,$1A(a0)
		moveq	#-$6B,d0
		jsr	(Play_Sound_2).l
		lea	byte_78DE2(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_78628:
		jsr	(Animate_RawMultiDelay).l
		bsr.w	sub_7867C
		jsr	(MoveSprite2).l
		move.w	($FFFFFAB0).w,d0
		cmp.w	$14(a0),d0
		bcs.w	locret_78536
		move.w	d0,$14(a0)
		move.b	#$C,5(a0)
		clr.w	$1A(a0)
		move.w	#$BF,$2E(a0)
		move.l	#loc_786A6,$34(a0)
		jmp	(Swing_Setup1).l
; ---------------------------------------------------------------------------

loc_78666:
		jsr	(Swing_UpAndDown).l
		bsr.w	sub_7867C
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l

; =============== S U B R O U T I N E =======================================


sub_7867C:

		move.b	($FFFFFE0F).w,d0
		andi.w	#$F,d0
		bne.s	locret_786A0
		lea	($FFFFB000).w,a1
		jsr	(Find_OtherObject).l
		clr.w	$18(a0)
		cmpi.w	#8,d2
		bls.s	locret_786A0
		move.w	word_786A2(pc,d0.w),$18(a0)

locret_786A0:

		rts
; End of function sub_7867C

; ---------------------------------------------------------------------------
word_786A2:	dc.w $FE00
		dc.w $200
; ---------------------------------------------------------------------------

loc_786A6:
		move.b	#$E,5(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_786BC,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_786BC:
		move.b	#$10,5(a0)
		move.b	#-$4B,$28(a0)
		move.l	#loc_786EA,$34(a0)
		lea	byte_78DF1(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_786DA:
		addq.w	#4,$14(a0)
		jsr	(Animate_RawMultiDelay).l
		jmp	(Add_SpriteToCollisionResponseList).l
; ---------------------------------------------------------------------------

loc_786EA:
		move.b	#$12,5(a0)
		move.b	#5,$22(a0)
		move.b	#6,$28(a0)
		move.w	#$5F,$2E(a0)
		move.l	#loc_7873A,$34(a0)
		move.w	#$14,($FFFFEECC).w
		moveq	#-$65,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_7871A:
		moveq	#$33,d1
		moveq	#4,d2
		moveq	#0,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		bsr.w	sub_78C14
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7873A:
		move.b	#$14,5(a0)
		move.w	#$2F,$2E(a0)
		move.l	#loc_787AE,$34(a0)
		clr.w	$18(a0)
		move.w	#$400,$1A(a0)
		lea	byte_78DF8(pc),a1
		jsr	(Set_Raw_Animation).l
		jmp	(Displace_PlayerOffObject).l
; ---------------------------------------------------------------------------

loc_78768:
		jsr	(Animate_RawMultiDelay).l
		cmpi.b	#6,$23(a0)
		bcc.s	loc_78784
		bsr.w	sub_78C14
		jsr	(Add_SpriteToCollisionResponseList).l
		bra.w	loc_7878C
; ---------------------------------------------------------------------------

loc_78784:
		bsr.w	sub_78CCA
		clr.b	$28(a0)

loc_7878C:
		jsr	(MoveSprite2).l
		jsr	(Obj_Wait).l
		move.w	($FFFFFAB2).w,d0
		cmp.w	$14(a0),d0
		bhi.s	locret_787AC
		move.w	d0,$14(a0)
		move.b	#6,5(a0)

locret_787AC:
		rts
; ---------------------------------------------------------------------------

loc_787AE:
		move.l	#loc_785EA,$34(a0)
		move.b	$38(a0),d0
		andi.b	#-$40,d0
		cmpi.b	#-$40,d0
		beq.s	loc_787D8
		move.w	#$15F,$2E(a0)
		bset	#3,$38(a0)
		bclr	#2,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_787D8:
		move.w	#$1F,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_787E0:
		jsr	(Create_New_Sprite).l
		bne.s	loc_787EE
		move.l	#loc_78AA8,(a1)

loc_787EE:
		lea	ChildObjDat_78D9E(pc),a2
		jsr	(CreateChild1_Normal).l
		jmp	(Obj_EndSignControl).l
; ---------------------------------------------------------------------------

loc_787FE:
		bset	#0,4(a0)
		move.w	#$10,$2E(a0)

loc_7880A:
		moveq	#0,d0
		moveq	#0,d1
		move.b	$2C(a0),d1
		beq.s	loc_7881E
		cmpi.b	#$16,d1
		bne.s	loc_7881C
		addq.w	#4,d0

loc_7881C:
		addq.w	#4,d0

loc_7881E:
		movea.l	off_7882C(pc,d0.w),a1
		move.l	a1,(a0)
		add.w	d1,d1
		add.w	d1,$2E(a0)
		jmp	(a1)
; ---------------------------------------------------------------------------
off_7882C:	dc.l loc_78838
		dc.l loc_788DE
		dc.l loc_78922
; ---------------------------------------------------------------------------

loc_78838:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_78850(pc,d0.w),d1
		jsr	off_78850(pc,d1.w)
		bsr.w	sub_78B46
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_78850:	dc.w loc_7885A-off_78850

		dc.w loc_78868-off_78850
		dc.w loc_78890-off_78850
		dc.w loc_788A4-off_78850
		dc.w loc_78890-off_78850
; ---------------------------------------------------------------------------

loc_7885A:
		lea	word_78D66(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		bsr.w	sub_78BEE

loc_78868:
		movea.w	$44(a0),a1
		btst	#3,$38(a1)
		beq.s	locret_7888E
		move.b	#4,5(a0)
		move.w	#-$200,$1A(a0)
		move.w	#$6F,$2E(a0)
		move.l	#loc_7889C,$34(a0)

locret_7888E:
		rts
; ---------------------------------------------------------------------------

loc_78890:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7889C:
		move.b	#6,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_788A4:
		movea.w	$44(a0),a1
		btst	#3,$38(a1)
		bne.s	locret_788CA
		move.b	#8,5(a0)
		move.w	#$200,$1A(a0)
		move.w	#$6F,$2E(a0)
		move.l	#loc_788CC,$34(a0)

locret_788CA:
		rts
; ---------------------------------------------------------------------------

loc_788CC:
		move.b	#2,5(a0)
		movea.w	$44(a0),a1
		bset	#2,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_788DE:
		lea	word_78D66(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		bsr.w	sub_78BD6
		move.l	#loc_788F4,(a0)
		rts
; ---------------------------------------------------------------------------

loc_788F4:
		move.b	$3C(a0),d0
		add.b	$40(a0),d0
		cmpi.b	#$70,d0
		bcs.s	loc_78908
		cmpi.b	#-$70,d0
		bls.s	loc_7890C

loc_78908:
		neg.b	$40(a0)

loc_7890C:
		move.b	d0,$3C(a0)
		moveq	#4,d2
		jsr	(MoveSprite_CircularSimple).l
		bsr.w	sub_78B46
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_78922:
		lea	word_78D6C(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		bsr.w	sub_78BD6
		move.l	#loc_78946,(a0)
		move.l	#byte_78E05,$30(a0)
		move.b	#4,$29(a0)
		rts
; ---------------------------------------------------------------------------

loc_78946:

		movea.w	$44(a0),a1
		btst	#3,$38(a1)
		beq.s	loc_78976
		move.l	#loc_7897A,(a0)
		moveq	#$7F,d0
		btst	#0,4(a0)
		beq.s	loc_78966
		move.w	#$DF,d0

loc_78966:
		move.w	d0,$2E(a0)
		move.l	#loc_789CA,$34(a0)
		clr.b	$39(a0)

loc_78976:
		bra.w	sub_78B46
; ---------------------------------------------------------------------------

loc_7897A:
		movea.w	$44(a0),a1
		btst	#2,$38(a1)
		beq.s	loc_7898C
		move.l	#loc_78946,(a0)

loc_7898C:
		jsr	(Animate_Raw).l
		lea	(AngleLookup_2).l,a2
		jsr	(MoveSprite_AtAngleLookup).l
		jsr	(Obj_Wait).l
		bsr.w	sub_78B46
		bsr.w	sub_78CF4
		move.b	$20(a0),d0
		beq.s	loc_789BE
		btst	#0,d0
		bne.w	locret_78536
		bra.w	loc_789C4
; ---------------------------------------------------------------------------

loc_789BE:
		jsr	(Add_SpriteToCollisionResponseList).l

loc_789C4:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_789CA:
		move.b	$39(a0),d0
		addq.b	#1,d0
		move.b	d0,$39(a0)
		move.w	#$13,$2E(a0)
		cmpi.b	#3,d0
		bcs.s	loc_789E6
		move.w	#$FFF,$2E(a0)

loc_789E6:
		moveq	#-$68,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_78D90(pc),a2
		jsr	(CreateChild10_NormalAdjusted).l
		bne.s	locret_78A00
		move.b	$39(a0),$2C(a1)

locret_78A00:
		rts
; ---------------------------------------------------------------------------

loc_78A02:
		lea	word_78D72(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_78A1C,(a0)
		bset	#3,$2B(a0)
		bsr.w	sub_78BAA

loc_78A1C:
		jsr	(MoveSprite2).l
		jmp	(Sprite_CheckDeleteTouchXY).l
; ---------------------------------------------------------------------------

loc_78A28:
		lea	word_78D78(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_78A46,(a0)
		move.w	#$1F,$2E(a0)
		move.l	#Go_Delete_Sprite,$34(a0)

loc_78A46:
		jsr	(Obj_Wait).l
		movea.w	$46(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		btst	#7,$2A(a1)
		bne.s	loc_78A6A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_78A6A:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_78A70:

		lea	word_78D7E(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#Obj_FlickerMove,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		move.b	RawAni_78A9C(pc,d0.w),$22(a0)
		moveq	#$5C,d0
		jsr	(Set_IndexedVelocity).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
RawAni_78A9C:	dc.b   $C,  $C,	 $C, $11, $11, $12, $13,  $D,  $E,  $F,	$10,   0
; ---------------------------------------------------------------------------

loc_78AA8:
		tst.b	($FFFFFAAA).w
		beq.w	locret_78536
		move.l	#loc_78AE0,(a0)
		lea	word_78EAA(pc),a1
		lea	($FFFFFADE).w,a2
		move.l	(a1)+,(a2)+
		move.l	(a1)+,(a2)+
		clr.w	(a2)
		move.l	#loc_78B00,($FFFFFADA).w
		move.w	#$7FFF,($FFFFF634).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_78AE0
		move.l	#loc_78B08,(a1)

loc_78AE0:

		jsr	(Run_PalRotationScript).l

loc_78AE6:
		cmpi.w	#$940,($FFFFEE78).w
		bcs.w	locret_78536
		move.w	#$940,($FFFFEE14).w
		clr.w	($FFFFF634).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_78B00:
		move.l	#loc_78AE6,(a0)
		rts
; ---------------------------------------------------------------------------

loc_78B08:
		cmpi.w	#$2C0,($FFFFEE78).w
		bcs.w	locret_78536
		move.w	#$2C0,($FFFFEE14).w
		lea	(Pal_LRZ2).l,a1
		lea	($FFFFFC20).w,a2
		moveq	#7,d6

loc_78B24:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_78B24
		lea	Pal_LRZMiniboss3(pc),a1
		bsr.w	sub_78B38
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_78B38:

		lea	($FFFFFC40).w,a2
		moveq	#$F,d0

loc_78B3E:
		move.l	(a1)+,(a2)+
		dbf	d0,loc_78B3E
		rts
; End of function sub_78B38


; =============== S U B R O U T I N E =======================================


sub_78B46:

		movea.w	$44(a0),a1
		moveq	#6,d0
		btst	#0,4(a0)
		beq.s	loc_78B56
		moveq	#7,d0

loc_78B56:
		btst	d0,$38(a1)
		beq.w	locret_78536
		move.l	#Wait_Draw,(a0)
		move.w	#$80,8(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		move.w	#$2C,d1
		sub.w	d0,d1
		move.w	d1,$2E(a0)
		move.l	#loc_78B86,$34(a0)
		rts
; End of function sub_78B46

; ---------------------------------------------------------------------------

loc_78B86:
		move.w	#$F,$2E(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild1_Normal).l
		bne.s	locret_78BA8
		move.b	#6,$2C(a1)

locret_78BA8:
		rts

; =============== S U B R O U T I N E =======================================


sub_78BAA:
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#2,d0
		move.l	loc_78BC4+2(pc,d0.w),$18(a0)
		movea.w	$46(a0),a1
		btst	#0,4(a1)
		beq.s	locret_78BC8

loc_78BC4:
		neg.w	$18(a0)

locret_78BC8:
		rts
; End of function sub_78BAA

; ---------------------------------------------------------------------------
		dc.w   $200,  $300
		dc.w   $200,  $200
		dc.w   $200,  $100

; =============== S U B R O U T I N E =======================================


sub_78BD6:

		move.l	(sp)+,$34(a0)
		move.l	#Wait_Draw,(a0)
		move.b	#-$80,$3C(a0)
		move.b	#1,$40(a0)
		rts
; End of function sub_78BD6


; =============== S U B R O U T I N E =======================================


sub_78BEE:
		move.w	#$20,d0
		btst	#0,4(a0)
		beq.s	loc_78BFE
		move.w	#$120,d0

loc_78BFE:
		add.w	($FFFFEE78).w,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d0
		addi.w	#$1B8,d0
		move.w	d0,$14(a0)
		rts
; End of function sub_78BEE


; =============== S U B R O U T I N E =======================================


sub_78C14:

		tst.b	$28(a0)
		bne.s	locret_78C5E
		move.b	$29(a0),d0
		beq.s	loc_78C60
		tst.b	$20(a0)
		bne.s	loc_78C3A
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		bset	#6,$2A(a0)

loc_78C3A:
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_78C48
		addi.w	#4,d0

loc_78C48:
		bsr.w	sub_78C98
		subq.b	#1,$20(a0)
		bne.s	locret_78C5E
		bclr	#6,$2A(a0)
		move.b	$25(a0),$28(a0)

locret_78C5E:

		rts
; ---------------------------------------------------------------------------

loc_78C60:
		move.l	#Wait_FadeToLevelMusic,(a0)
		move.w	#$80,8(a0)
		bset	#6,$38(a0)
		bset	#7,$38(a0)
		move.l	#loc_787E0,$34(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild1_Normal).l
		jsr	(Displace_PlayerOffObject).l
		jmp	(BossDefeated_StopTimer).l
; End of function sub_78C14


; =============== S U B R O U T I N E =======================================


sub_78C98:

		lea	word_78CA6(pc),a1
		lea	word_78CB2(pc,d0.w),a2
		jmp	(CopyWordData_6).l
; End of function sub_78C98

; ---------------------------------------------------------------------------
word_78CA6:	dc.w $FC26
		dc.w $FC28
		dc.w $FC30
		dc.w $FC38
		dc.w $FC3A
		dc.w $FC3C
word_78CB2:	dc.w $2A
		dc.w 6
		dc.w 2
		dc.w $644
		dc.w $422
		dc.w 0
		dc.w $888
		dc.w $AAA
		dc.w $CCC
		dc.w $AAA
		dc.w $CCC
		dc.w $EEE

; =============== S U B R O U T I N E =======================================


sub_78CCA:
		tst.b	$29(a0)
		beq.s	loc_78C60
		tst.b	$20(a0)
		beq.s	locret_78CF2
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_78CE4
		addi.w	#4,d0

loc_78CE4:
		bsr.s	sub_78C98
		subq.b	#1,$20(a0)
		bne.s	locret_78CF2
		bclr	#6,$2A(a0)

locret_78CF2:

		rts
; End of function sub_78CCA


; =============== S U B R O U T I N E =======================================


sub_78CF4:
		tst.b	$28(a0)
		bne.s	locret_78D2A
		move.b	$29(a0),d0
		beq.s	loc_78D2C
		tst.b	$20(a0)
		bne.s	loc_78D1E
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_78D98(pc),a2
		jsr	(CreateChild6_Simple).l

loc_78D1E:
		subq.b	#1,$20(a0)
		bne.s	locret_78D2A
		move.b	$25(a0),$28(a0)

locret_78D2A:

		rts
; ---------------------------------------------------------------------------

loc_78D2C:
		movea.w	$44(a0),a1
		move.w	#6,d0
		btst	#0,4(a0)
		beq.s	loc_78D40
		move.w	#7,d0

loc_78D40:
		bset	d0,$38(a1)
		move.b	$38(a1),d0
		andi.b	#-$40,d0
		cmpi.b	#-$40,d0
		bne.s	locret_78D2A
		move.w	#$1F,$2E(a1)
		rts
; End of function sub_78CF4

; ---------------------------------------------------------------------------
ObjDat3_78D5A:	dc.l Map_LRZMiniboss
		dc.w $A3FB
		dc.w 0
		dc.b $30
		dc.b $80
		dc.b 1
		dc.b 0
word_78D66:	dc.w 0

		dc.b 8
		dc.b 8
		dc.b 8
		dc.b 0
word_78D6C:	dc.w 0
		dc.b $10
		dc.b $10
		dc.b 6
		dc.b 6
word_78D72:	dc.w 0
		dc.b 4
		dc.b 4
		dc.b 9
		dc.b $98
word_78D78:	dc.w 0
		dc.b $10
		dc.b $10
		dc.b $A
		dc.b 0
word_78D7E:	dc.w $80
		dc.b $18
		dc.b $14
		dc.b $C
		dc.b 0
ChildObjDat_78D84:dc.w $B
		dc.l loc_7880A
ChildObjDat_78D8A:dc.w $B
		dc.l loc_787FE
ChildObjDat_78D90:dc.w 0
		dc.l loc_78A02
		dc.w $800
ChildObjDat_78D98:dc.w 0
		dc.l loc_78A28
ChildObjDat_78D9E:dc.w $A
		dc.l loc_78A70
		dc.w $F4
		dc.l loc_78A70
		dc.w $E7F4
		dc.l loc_78A70
		dc.w $19F4
		dc.l loc_78A70
		dc.w $F422
		dc.l loc_78A70
		dc.w $C22
		dc.l loc_78A70
		dc.w $F836
		dc.l loc_78A70
		dc.w $836
		dc.l loc_78A70
		dc.w $EE04
		dc.l loc_78A70
		dc.w $1204
		dc.l loc_78A70
		dc.w $EE0C
		dc.l loc_78A70
		dc.w $120C
byte_78DE2:	dc.b	5,   0
		dc.b	5,   5
		dc.b	4,   1
		dc.b	3,   2
		dc.b	2,   3
		dc.b	1, $7F
		dc.b	1, $7F
		dc.b  $FC
byte_78DF1:	dc.b	3,   0
		dc.b	3,   0
		dc.b	4,   0
		dc.b  $F4
byte_78DF8:	dc.b	4,   3
		dc.b	4,   3
		dc.b	3,   3
		dc.b	2,   3
		dc.b	1, $7F
		dc.b	1, $7F
		dc.b  $FC
byte_78E05:	dc.b	1,   6
		dc.b	7,  $B
		dc.b  $FC
Pal_LRZMiniboss1:	binclude "Levels\LRZ\Palettes\Miniboss 1.bin"

Pal_LRZMiniboss2:	binclude "Levels\LRZ\Palettes\Miniboss 2.bin"

Pal_LRZMiniboss3:	binclude "Levels\LRZ\Palettes\Miniboss 3.bin"
word_78EAA:	dc.w 4

		dc.w 0
		dc.l word_78EB4
		dc.w 0
word_78EB4:	dc.w $FC42
		dc.w   $401,   $EE,   $AE,   $6E,    $E,    $A,	    3,	 $CC,	$8C,   $4A,    $A,     8,     3,   $AA,	  $6A,	 $26
		dc.w	$28,	 6,	3,   $CC,   $8C,   $4A,	   $A,	   8,	  3,   $EE,   $AE,   $6E,    $E,    $A,	   $F,	 $CC
		dc.w	$AC,   $6C,    $C,  $208,     3,   $CC,	  $8C,	 $6C,  $22A,  $226,	3,   $AA,  $28A,  $24A,	 $228,	$224
		dc.w	  3,  $288,  $268,  $248,  $424,  $222,	    3,	$266,  $246,  $226,  $422,  $222,     3,  $266,	 $244,	$224
		dc.w   $422,  $222,	3,  $244,  $222,  $224,	 $422,	$222,	  3,  $222,  $222,  $224,  $422,  $222,	    7, $FFF4
; ---------------------------------------------------------------------------

Obj_9E_2:
		move.l	#loc_78F82,(a0)
		move.w	#$3B,$2E(a0)
		lea	(ArtKosM_LRZ3DeathEggFlash).l,a1
		move.w	#$7560,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_LRZ3PlatformDebris).l,a1
		move.w	#-$6F20,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

loc_78F82:
		st	($FFFFF7CA).w
		st	($FFFFF7CB).w
		clr.w	($FFFFF602).w
		clr.w	($FFFFF66A).w
		subq.w	#1,$2E(a0)
		bpl.s	locret_78FAC
		move.l	#loc_78FAE,(a0)
		jsr	(Create_New_Sprite).l
		bne.s	locret_78FAC
		move.l	#loc_793E2,(a1)

locret_78FAC:

		rts
; ---------------------------------------------------------------------------

loc_78FAE:
		btst	#0,($FFFFFAB8).w
		beq.s	locret_78FAC
		move.l	#loc_79002,(a0)
		clr.b	($FFFFF7CA).w
		clr.b	($FFFFF7CB).w
		lea	ObjDat3_795D2(pc),a1
		jsr	(SetUp_ObjAttributes).l
		clr.b	5(a0)
		move.w	#-$40,$10(a0)
		move.w	#$460,$14(a0)
		move.w	#$100,$18(a0)
		jsr	(Swing_Setup1).l
		move.w	#$11F,$2E(a0)
		move.l	#loc_79034,$34(a0)
		lea	ChildObjDat_7961A(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_79002:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_79016(pc,d0.w),d1
		jsr	off_79016(pc,d1.w)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_79016:	dc.w loc_7901A-off_79016

		dc.w loc_79022-off_79016
; ---------------------------------------------------------------------------

loc_7901A:
		moveq	#-$42,d0
		jsr	(sub_85E52).l

loc_79022:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_79034:
		move.b	#2,5(a0)
		bset	#1,($FFFFFAB8).w
		clr.w	$18(a0)
		move.w	#$BF,$2E(a0)
		move.l	#loc_79054,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_79054:
		move.l	#loc_79072,(a0)
		st	($FFFFEEC4).w
		clr.w	$2E(a0)
		move.w	#$200,$18(a0)
		lea	ChildObjDat_79652(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_79072:
		tst.b	4(a0)
		bpl.s	loc_790A6
		moveq	#-$42,d0
		jsr	(sub_85E52).l
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		move.w	$2E(a0),d0
		addq.w	#1,d0
		move.w	d0,$2E(a0)
		cmpi.w	#$1B0,d0
		bcs.s	loc_790A0
		addq.w	#1,$14(a0)

loc_790A0:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_790A6:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_790AC:
		lea	word_795F0(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_790D8,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	byte_790D0(pc,d0.w),$10(a0)
		move.w	#$4C0,$14(a0)
		rts
; ---------------------------------------------------------------------------
byte_790D0:	dc.b	1,   8
		dc.b	2,   8
		dc.b	3,   8
		dc.b	3, $F8
; ---------------------------------------------------------------------------

loc_790D8:
		move.w	($FFFFEE78).w,d0
		addi.w	#$120,d0
		cmp.w	$10(a0),d0
		bcc.s	loc_790E8
		rts
; ---------------------------------------------------------------------------

loc_790E8:
		move.l	#loc_7910A,(a0)
		moveq	#-$63,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_79672(pc),a2
		jsr	(CreateChild6_Simple).l
		lea	ChildObjDat_79658(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_7910A:
		btst	#1,$38(a0)
		bne.s	loc_79118
		jmp	(Sprite_CheckDelete).l
; ---------------------------------------------------------------------------

loc_79118:
		move.w	$10(a0),d0
		subi.w	#$40,d0
		move.w	d0,($FFFFEEDE).w
		move.w	#$480,($FFFFEEE0).w
		moveq	#$4E,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_79686(pc),a2
		jsr	(CreateChild6_Simple).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_79142:

		lea	word_795F6(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_79192,(a0)
		move.w	$10(a0),$3A(a0)
		move.w	$14(a0),$3C(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,d1
		lsr.w	#1,d0
		move.b	RawAni_7917E(pc,d0.w),$22(a0)
		add.w	d1,d1
		move.l	dword_79182(pc,d1.w),$18(a0)
		move.w	#$B,$2E(a0)
		rts
; ---------------------------------------------------------------------------
RawAni_7917E:	dc.b   $E,  $F,	$10, $11
dword_79182:	dc.l $1000000
		dc.l $FF000000
		dc.l $100
		dc.l $FF00
; ---------------------------------------------------------------------------

loc_79192:

		jsr	(MoveSprite2).l
		subq.w	#1,$2E(a0)
		bpl.s	loc_791AA
		move.l	#loc_791B0,(a0)
		move.w	#$F,$2E(a0)

loc_791AA:
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_791B0:
		subq.w	#1,$2E(a0)
		bpl.s	loc_791CE
		move.l	#loc_79192,(a0)
		move.w	$3A(a0),$10(a0)
		move.w	$3C(a0),$14(a0)
		move.w	#$B,$2E(a0)

loc_791CE:
		jmp	(Child_CheckParent).l
; ---------------------------------------------------------------------------

loc_791D4:
		lea	word_795FC(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_791FE,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_791FA(pc,d0.w),$14(a0)
		lea	ChildObjDat_79678(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------
word_791FA:	dc.w $340
		dc.w $2C0
; ---------------------------------------------------------------------------

loc_791FE:
		addq.w	#4,$14(a0)
		movea.w	$46(a0),a1
		move.w	$14(a1),d0
		subi.w	#$10,d0
		cmp.w	$14(a0),d0
		bls.s	loc_7921A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7921A:
		move.l	#loc_79266,(a0)
		bclr	#7,4(a0)
		move.b	#-$6F,$28(a0)
		move.w	#$1F,$2E(a0)
		addq.w	#8,$14(a0)
		lea	(ChildObjDat_690D8).l,a2
		jsr	(CreateChild1_Normal).l
		addi.w	#$18,$14(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		tst.b	$2C(a0)
		beq.s	locret_79264
		movea.w	$46(a0),a1
		bset	#1,$38(a1)

locret_79264:
		rts
; ---------------------------------------------------------------------------

loc_79266:
		subq.w	#1,$2E(a0)
		bmi.s	loc_79272
		jmp	(Add_SpriteToCollisionResponseList).l
; ---------------------------------------------------------------------------

loc_79272:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_79278:
		lea	word_795E4(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_79290,(a0)
		move.l	#byte_796B5,$30(a0)

loc_79290:
		movea.w	$46(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		jsr	(Animate_Raw).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_792AC:

		lea	word_795DE(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_792F0,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_792D0(pc,d0.w),$2E(a0)
		move.w	word_792E0(pc,d0.w),$18(a0)
		rts
; ---------------------------------------------------------------------------
word_792D0:	dc.w $24
		dc.w $64
		dc.w $18
		dc.w $58
		dc.w $C
		dc.w $4C
		dc.w 0
		dc.w $40
word_792E0:	dc.w $FF80
		dc.w $80
		dc.w $FF40
		dc.w $C0
		dc.w $FF00
		dc.w $100
		dc.w $FEC0
		dc.w $140
; ---------------------------------------------------------------------------

loc_792F0:
		btst	#1,($FFFFFAB8).w
		bne.s	loc_79304
		jsr	(Refresh_ChildPosition).l
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_79304:
		move.l	#loc_7931E,$34(a0)
		jsr	(Refresh_ChildPosition).l
		jsr	(Obj_Wait).l
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_7931E:
		move.l	#loc_79334,(a0)
		move.w	#$14,$2E(a0)
		move.l	#loc_79346,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_79334:
		jsr	(MoveSprite_LightGravity).l
		jsr	(Obj_Wait).l
		jmp	(Sprite_CheckDeleteXY).l
; ---------------------------------------------------------------------------

loc_79346:
		move.l	#loc_7935E,(a0)
		moveq	#-$60,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_7964C(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_7935E:
		addi.w	#-$40,$1A(a0)
		jsr	(MoveSprite2).l
		bsr.w	sub_794F8
		jmp	(Sprite_CheckDeleteXY).l
; ---------------------------------------------------------------------------

loc_79374:
		lea	word_795E4(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_7938C,(a0)
		move.l	#byte_79694,$30(a0)

loc_7938C:
		movea.w	$46(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		jsr	(Animate_RawMultiDelay).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_793A8:
		lea	word_795EA(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_793C6,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		move.w	#$100,$1A(a0)

loc_793C6:
		lea	byte_796B9(pc),a1
		jsr	(Animate_RawNoSSTMultiDelay).l
		addi.w	#-$10,$1A(a0)
		jsr	(MoveSprite2).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_793E2:
		lea	ObjDat3_79602(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_79406,(a0)
		move.w	#$B0,$10(a0)
		move.w	#$449,$14(a0)
		move.l	#loc_79416,$34(a0)

loc_79406:
		lea	byte_7968C(pc),a1
		jsr	(Animate_RawNoSST).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_79416:
		move.l	#loc_79486,(a0)
		move.b	#-$80,($FFFFF650).w
		move.w	#$F,$2E(a0)
		moveq	#-$61,d0
		jsr	(Play_Sound_2).l
		lea	($FFFFFC00).w,a1
		lea	($FFFFFC80).w,a2
		moveq	#7,d6

loc_7943A:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_7943A
		lea	(Pal_LRZBossFire).l,a1
		lea	($FFFFFCA0).w,a2
		moveq	#$17,d6

loc_7944C:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_7944C
		jsr	(Create_New_Sprite).l
		bne.s	loc_7946A
		move.l	#loc_85E64,(a1)
		move.w	a1,$44(a0)
		move.w	#3,$3A(a1)

loc_7946A:
		lea	(ArtKosM_LRZ3Autoscroll).l,a1
		move.w	#-$7B80,d2
		jsr	(Queue_Kos_Module).l
		lea	(PLC_83D64).l,a1
		jmp	(Load_PLC_Raw).l
; ---------------------------------------------------------------------------

loc_79486:
		movea.w	$44(a0),a1
		btst	#7,$2A(a1)
		beq.w	locret_78FAC
		move.b	#1,($FFFFF650).w
		bset	#0,($FFFFFAB8).w
		st	($FFFFEEC4).w
		moveq	#-$64,d0
		jsr	(Play_Sound_2).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_794BE
		move.l	#loc_85EE6,(a1)
		move.w	a1,$44(a0)

loc_794BE:
		jsr	(Create_New_Sprite).l
		bne.s	loc_794D8
		move.l	#Obj_CollapsingBridge,(a1)
		move.w	#$60,$10(a1)
		move.w	#$4D0,$14(a1)

loc_794D8:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_794DE:
		lea	ObjDat3_7960E(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#Obj_FlickerMove,(a0)
		bsr.w	sub_79516
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_794F8:
		tst.w	$1A(a0)
		bpl.w	locret_78FAC
		move.b	($FFFFFE0F).w,d0
		andi.b	#3,d0
		bne.w	locret_78FAC
		lea	ChildObjDat_7967E(pc),a2
		jmp	(CreateChild1_Normal).l
; End of function sub_794F8


; =============== S U B R O U T I N E =======================================


sub_79516:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,d1
		lsr.w	#1,d0
		move.b	byte_79554(pc,d0.w),$22(a0)
		movea.w	$46(a0),a1
		move.w	$10(a1),d2
		move.w	$14(a1),d3
		lea	byte_79566(pc,d1.w),a2
		move.b	(a2)+,d0
		ext.w	d0
		add.w	d0,d2
		move.b	(a2)+,d0
		ext.w	d0
		add.w	d0,d3
		move.w	d2,$10(a0)
		move.w	d3,$14(a0)
		add.w	d1,d1
		move.l	word_7958A(pc,d1.w),$18(a0)
		rts
; End of function sub_79516

; ---------------------------------------------------------------------------
byte_79554:	dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 1
		dc.b 1
		dc.b 1
		dc.b 1
		dc.b 3
		dc.b 3
		dc.b 2
		dc.b 2
		dc.b 3
		dc.b 2
		dc.b 2
		dc.b 3
byte_79566:	dc.b  $20, $F8
		dc.b  $E0, $10
		dc.b	0, $10
		dc.b  $20, $10
		dc.b  $F0, $28
		dc.b  $10, $28
		dc.b  $F0, $10
		dc.b  $10, $10
		dc.b  $D8, $28
		dc.b  $28, $28
		dc.b  $D4,   4
		dc.b  $F0,   4
		dc.b  $10,   4
		dc.b  $2C,   4
		dc.b  $E0, $20
		dc.b	0, $20
		dc.b  $20, $20
		dc.b	0, $2C
word_7958A:	dc.w   $200, $FE00
		dc.w  $FE80, $FE80
		dc.w	$80, $FF00
		dc.w   $180, $FE00
		dc.w  $FE80, $FE00
		dc.w   $100, $FF00
		dc.w  $FE00, $FD80
		dc.w   $200, $FD80
		dc.w  $FE00, $FE00
		dc.w   $200, $FE00
		dc.w  $FD00, $FC00
		dc.w  $FE00, $FD00
		dc.w   $200, $FD00
		dc.w   $300, $FC00
		dc.w  $FE00, $FC80
		dc.w   $100, $FE00
		dc.w   $200, $FC80
		dc.w	$80, $FF00
ObjDat3_795D2:	dc.l Map_LRZ3Autoscroll
		dc.w $2424
		dc.w $300
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b 0
word_795DE:	dc.w $280
		dc.b 4
		dc.b $10
		dc.b 1
		dc.b 0
word_795E4:	dc.w $280

		dc.b $10
		dc.b $10
		dc.b 2
		dc.b 0
word_795EA:	dc.w $280
		dc.b 8
		dc.b 8
		dc.b 7
		dc.b 0
word_795F0:	dc.w $280
		dc.b $C
		dc.b $C
		dc.b $D
		dc.b 0
word_795F6:	dc.w $280
		dc.b 4
		dc.b 4
		dc.b $E
		dc.b 0
word_795FC:	dc.w $280
		dc.b 8
		dc.b $1C
		dc.b $C
		dc.b $92
ObjDat3_79602:	dc.l Map_LRZ3DeathEggFlash
		dc.w $23AB
		dc.w $300
		dc.b $2C
		dc.b $28
		dc.b 0
		dc.b 0
ObjDat3_7960E:	dc.l Map_LRZ3Debris

		dc.w $E487
		dc.w $80
		dc.b $C
		dc.b $C
		dc.b 0
		dc.b 0
ChildObjDat_7961A:dc.w 7
		dc.l loc_792AC
		dc.w $F40C
		dc.l loc_792AC
		dc.w $C0C
		dc.l loc_792AC
		dc.w $EC0C
		dc.l loc_792AC
		dc.w $140C
		dc.l loc_792AC
		dc.w $EC04
		dc.l loc_792AC
		dc.w $1404
		dc.l loc_792AC
		dc.w $E804
		dc.l loc_792AC
		dc.w $1804
ChildObjDat_7964C:dc.w 0
		dc.l loc_79374
ChildObjDat_79652:dc.w 3
		dc.l loc_790AC
ChildObjDat_79658:dc.w 3
		dc.l loc_79142
		dc.w $F000
		dc.l loc_79142
		dc.w $1000
		dc.l loc_79142
		dc.w $F0
		dc.l loc_79142
		dc.w $10
ChildObjDat_79672:dc.w 1
		dc.l loc_791D4
ChildObjDat_79678:dc.w 0
		dc.l loc_79278
ChildObjDat_7967E:dc.w 0
		dc.l loc_793A8
		dc.w $18
ChildObjDat_79686:dc.w $11
		dc.l loc_794DE
byte_7968C:	dc.b	4,   0
		dc.b	0,   1
		dc.b	2,   3
		dc.b	4, $F4
byte_79694:	dc.b	2,   1
		dc.b	2,   1
		dc.b	3,   1
		dc.b	2,   1
		dc.b	3,   1
		dc.b	4,   1
		dc.b	3,   1
		dc.b	4,   1
		dc.b	5,   0
		dc.b	4,   1
		dc.b	5,   0
		dc.b	6,   0
		dc.b	5,   0
		dc.b  $F8, $1C
		dc.b	6,   0
		dc.b  $12,   0
		dc.b  $FC
byte_796B5:	dc.b	0, $12
		dc.b  $13, $FC
byte_796B9:	dc.b	6,   2
		dc.b	7,   2
		dc.b	8,   3
		dc.b	9,   4
		dc.b   $A,   5
		dc.b   $B,   5
		dc.b  $F4,   0
		dc.b	0,  $E
		dc.b  $EE,  $C
		dc.b  $EE,  $C
		dc.b  $EE,  $C
		dc.b  $EE,  $C
		dc.b  $EE,  $C
		dc.b  $EE,  $E
		dc.b  $EE,  $E
		dc.b  $EE,   8
		dc.b  $EE,  $C
		dc.b  $EE,  $E
		dc.b  $EE,  $E
		dc.b  $EE,  $E
		dc.b  $EE,  $E
		dc.b  $EE,  $E
		dc.b  $EE,   0
		dc.b	0,  $E
		dc.b  $EE,  $C
		dc.b  $EE,   8
		dc.b  $EE,   8
		dc.b  $EE,  $C
		dc.b  $EE,  $E
		dc.b  $EE,  $C
		dc.b  $EE,   8
		dc.b  $EE,  $E
		dc.b  $EE,  $E
		dc.b  $EE,  $E
		dc.b  $EE,  $C
		dc.b  $EE,   8
		dc.b  $EE,   4
		dc.b  $EE,   0
		dc.b  $EE,   0
		dc.b	0,  $E
		dc.b  $EE,  $E
		dc.b  $EE,  $E
		dc.b  $EE,  $E
		dc.b  $EE,  $E
		dc.b  $EE,  $E
		dc.b  $EE,  $E
		dc.b  $EE,  $E
		dc.b  $EE,  $E
		dc.b  $EE,  $E
		dc.b  $EE,  $C
		dc.b  $EE,   8
		dc.b  $EE,   4
		dc.b  $EE,   0
		dc.b  $EE,   0
		dc.b  $AE
Pal_LRZBossFire:	binclude "Levels\LRZ\Palettes\Boss Act Fire.bin"


; ---------------------------------------------------------------------------

Obj_LRZEndBoss:
		move.w	a0,($FFFFFAA4).w
		move.l	#loc_797C6,(a0)
		lea	(ArtKosM_LRZEndBoss).l,a1
		move.w	#$7980,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_LRZ3PlatformDebris).l,a1
		move.w	#-$6F20,d2
		jsr	(Queue_Kos_Module).l
		lea	(PLC_83D64).l,a1
		jsr	(Load_PLC_Raw).l
		lea	Pal_LRZEndBoss(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_797C6:
		btst	#0,($FFFFFA88).w
		beq.w	locret_797F8
		move.b	#1,($FFFFF7AA).w
		move.l	#Obj_Wait,(a0)
		move.w	#$78,$2E(a0)
		move.l	#loc_797EC,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_797EC:
		move.l	#loc_797FA,(a0)
		move.b	#$19,($FFFFFF91).w

locret_797F8:

		rts
; ---------------------------------------------------------------------------

loc_797FA:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_79812(pc,d0.w),d1
		jsr	off_79812(pc,d1.w)
		bsr.w	sub_79F58
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_79812:	dc.w loc_7981E-off_79812

		dc.w loc_79858-off_79812
		dc.w loc_798B8-off_79812
		dc.w loc_7990A-off_79812
		dc.w loc_79936-off_79812
		dc.w loc_79958-off_79812
; ---------------------------------------------------------------------------

loc_7981E:
		lea	ObjDat3_7A140(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.w	#$B10,$10(a0)
		move.w	#$640,$14(a0)
		move.b	#$E,$29(a0)
		move.w	#-$12,$26(a0)
		move.w	#-$580,$1A(a0)
		moveq	#$7A,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_7A18C(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_79858:
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.s	locret_7986E
		move.w	#$600,d0
		cmp.w	$14(a0),d0
		bls.s	loc_79870

locret_7986E:
		rts
; ---------------------------------------------------------------------------

loc_79870:
		move.w	d0,$14(a0)
		move.b	#4,5(a0)
		move.b	#3,$39(a0)
		move.w	#$7F,d0
		move.w	d0,$2E(a0)
		move.w	d0,$3A(a0)
		move.l	#loc_798C6,$34(a0)
		moveq	#1,d0
		btst	#0,4(a0)
		bne.s	loc_798A0
		moveq	#-1,d0

loc_798A0:
		move.w	d0,($FFFFFAA2).w
		move.w	d0,($FFFFEEDA).w
		jsr	(Create_New_Sprite).l
		bne.s	locret_798B6
		move.l	#loc_79A54,(a1)

locret_798B6:
		rts
; ---------------------------------------------------------------------------

loc_798B8:
		addq.w	#1,($FFFFFA84).w
		bsr.w	sub_79F30
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_798C6:
		subq.b	#1,$39(a0)
		bmi.s	loc_798EA
		subi.w	#$10,$3A(a0)
		move.w	$3A(a0),$2E(a0)
		moveq	#-$68,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_7A19A(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_798EA:
		move.w	#$F7,$2E(a0)
		move.l	#loc_798FA,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_798FA:
		move.b	#6,5(a0)
		clr.b	($FFFFEEDB).w
		clr.w	($FFFFFA84).w
		rts
; ---------------------------------------------------------------------------

loc_7990A:
		bsr.w	sub_79F30
		tst.w	($FFFFEEDC).w
		bne.w	locret_797F8
		move.b	#8,5(a0)
		clr.b	($FFFFFAA3).w
		move.w	#$100,$1A(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_79942,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_79936:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_79942:
		move.b	#$A,5(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_7995E,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_79958:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7995E:
		move.b	#2,5(a0)
		move.w	#-$580,$1A(a0)
		move.w	#$A30,d1
		bchg	#0,4(a0)
		beq.s	loc_7997A
		move.w	#$B10,d1

loc_7997A:
		move.w	d1,$10(a0)
		moveq	#$7A,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_79988:
		subq.w	#1,$2E(a0)
		bmi.s	loc_79998
		addq.w	#1,$14(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_79998:
		move.l	#loc_799E0,(a0)
		ori.b	#$30,$38(a0)
		bclr	#7,4(a0)
		st	($FFFFFAA8).w
		clr.b	($FFFFF7AA).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_799C6
		move.l	#Obj_81,(a1)
		bset	#1,4(a1)

loc_799C6:
		jsr	(Create_New_Sprite).l
		bne.s	loc_799D4
		move.l	#loc_7A100,(a1)

loc_799D4:
		lea	(PLC_CNZ2KnuxEnd).l,a1
		jmp	(Load_PLC_Raw).l
; ---------------------------------------------------------------------------

loc_799E0:
		tst.b	($FFFFFAA8).w
		bne.w	locret_797F8
		move.l	#locret_79A52,(a0)
		bset	#1,($FFFFFA88).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_79A08
		move.l	#Obj_Song_Fade_Transition,(a1)
		move.b	#$14,$2C(a1)

loc_79A08:
		jsr	(Restore_PlayerControl).l
		lea	($FFFFB04A).w,a1
		jsr	(Restore_PlayerControl2).l
		clr.w	($FFFFF602).w
		move.w	#$EC0,($FFFFFA92).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_79A30
		move.l	#Obj_IncLevEndXGradual,(a1)

loc_79A30:
		jsr	(Create_New_Sprite).l
		bne.s	locret_79A50
		move.l	#Obj_B3_2,(a1)
		move.b	#$2D,$2C(a1)
		move.w	#$FE8,$10(a1)
		move.w	#$5E0,$14(a1)

locret_79A50:
		rts
; ---------------------------------------------------------------------------

locret_79A52:
		rts
; ---------------------------------------------------------------------------

loc_79A54:
		move.l	#loc_79A70,(a0)
		move.w	#$9E0,d0
		tst.b	($FFFFFAA3).w
		bmi.s	loc_79A68
		move.w	#$B60,d0

loc_79A68:
		move.w	d0,$10(a0)
		bsr.w	sub_79A8E

loc_79A70:
		tst.b	($FFFFFAA3).w
		beq.s	loc_79AA8
		movea.w	$44(a0),a1
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		bpl.s	loc_79A86
		neg.w	d0

loc_79A86:
		cmpi.w	#$80,d0
		bcs.w	locret_797F8

; =============== S U B R O U T I N E =======================================


sub_79A8E:
		jsr	(Create_New_Sprite).l
		bne.s	locret_79AA6
		move.l	#loc_79E5A,(a1)
		move.w	$10(a0),$10(a1)
		move.w	a1,$44(a0)

locret_79AA6:
		rts
; End of function sub_79A8E

; ---------------------------------------------------------------------------

loc_79AA8:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_79AAE:
		lea	word_7A14C(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_79AC4,(a0)
		move.w	#-$800,$1A(a0)

loc_79AC4:
		bsr.w	sub_79EB6
		tst.w	$1A(a0)
		bmi.s	loc_79B02
		move.l	#loc_79B22,(a0)
		move.w	#$100,8(a0)
		moveq	#$40,d0
		movea.w	$46(a0),a1
		btst	#0,4(a1)
		beq.s	loc_79AEC
		move.w	#$140,d0

loc_79AEC:
		move.w	d0,d1
		addi.w	#$9E0,d0
		move.w	d0,$10(a0)
		lsr.w	#1,d1
		lea	($FFFFA900).w,a1
		adda.w	d1,a1
		move.w	a1,$44(a0)

loc_79B02:
		move.b	($FFFFFE0F).w,d0
		andi.b	#3,d0
		bne.s	loc_79B16
		lea	ChildObjDat_7A1A8(pc),a2
		jsr	(CreateChild1_Normal).l

loc_79B16:
		jsr	(MoveSprite_LightGravity).l
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------

loc_79B22:
		bsr.w	sub_79EB6
		jsr	(MoveSprite_LightGravity).l
		movea.w	$44(a0),a1
		moveq	#0,d0
		move.b	(a1),d0
		subi.w	#$30,d0
		neg.w	d0
		addi.w	#$612,d0
		cmp.w	$14(a0),d0
		bls.s	loc_79B4A
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------

loc_79B4A:
		move.l	#loc_79B54,(a0)
		clr.w	$1A(a0)

loc_79B54:
		bsr.w	sub_79EB6
		tst.b	($FFFFFAA3).w
		bne.s	loc_79B66
		tst.b	4(a0)
		bpl.w	loc_79AA8

loc_79B66:
		bsr.w	sub_79F14
		jsr	(MoveSprite2).l
		bsr.w	sub_79F30
		bsr.w	loc_79EC4
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------

loc_79B7E:
		lea	word_7A152(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_79B96,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)

loc_79B96:
		jsr	(Refresh_ChildPosition).l
		lea	byte_7A1C7(pc),a1
		jsr	(Animate_RawNoSSTMultiDelay).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_79BAC:
		lea	word_7A158(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_79BCA,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		move.w	#$100,$1A(a0)

loc_79BCA:
		lea	byte_7A1D8(pc),a1
		jsr	(Animate_RawNoSSTMultiDelay).l
		addi.w	#-$10,$1A(a0)
		jsr	(MoveSprite2).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_79BE6:
		lea	word_7A15E(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_79BF6,(a0)

loc_79BF6:
		jsr	(Refresh_ChildPosition).l
		lea	byte_7A1C2(pc),a1
		jsr	(Animate_RawNoSST).l
		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------

loc_79C0C:
		lea	word_7A164(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#loc_79C1C,(a0)

loc_79C1C:
		jsr	(Refresh_ChildPositionAdjusted).l
		movea.w	$46(a0),a1
		move.b	#$F,$22(a0)
		btst	#6,$2A(a1)
		beq.s	loc_79C3E
		move.b	#$10,$22(a0)
		bra.w	loc_79C4C
; ---------------------------------------------------------------------------

loc_79C3E:
		btst	#7,$2A(a1)
		beq.s	loc_79C4C
		move.b	#$11,$22(a0)

loc_79C4C:

		jmp	(Child_Draw_Sprite2).l
; ---------------------------------------------------------------------------

Obj_AD_2:
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#2,d0
		jmp	loc_79C5E(pc,d0.w)
; ---------------------------------------------------------------------------

loc_79C5E:
		bra.w	loc_79C72
; ---------------------------------------------------------------------------
		bra.w	loc_79CCE
; ---------------------------------------------------------------------------
		bra.w	loc_79CCE
; ---------------------------------------------------------------------------
		bra.w	loc_79CDE
; ---------------------------------------------------------------------------
		bra.w	loc_79CF8
; ---------------------------------------------------------------------------

loc_79C72:
		bsr.w	sub_7A040
		beq.w	locret_797F8
		move.l	#loc_79C9E,(a0)
		lea	ChildObjDat_7A1B0(pc),a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_79C9E
		addi.w	#$C0,$14(a1)
		move.b	$2C(a0),$2C(a1)
		move.w	#$37F,$2E(a1)

loc_79C9E:

		tst.w	($FFFFFAA4).w
		bne.w	loc_79DB6
		subq.w	#1,$2E(a0)
		bpl.w	locret_797F8
		move.w	#$17F,$2E(a0)

; =============== S U B R O U T I N E =======================================


sub_79CB4:
		lea	ChildObjDat_7A1B0(pc),a2
		jsr	(CreateChild6_Simple).l
		bne.s	locret_79CCC
		move.b	$2C(a0),$2C(a1)
		move.w	#$4FF,$2E(a1)

locret_79CCC:
		rts
; End of function sub_79CB4

; ---------------------------------------------------------------------------

loc_79CCE:

		bsr.w	sub_7A040
		beq.w	locret_797F8
		bsr.s	sub_79CB4
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_79CDE:
		lea	ObjDat3_7A16C(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_79CEE,(a0)

loc_79CEE:
		bsr.w	sub_7A064
		jmp	(Sprite_CheckDelete).l
; ---------------------------------------------------------------------------

loc_79CF8:
		lea	ObjDat3_7A178(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_79D08,(a0)

loc_79D08:
		lea	byte_7A1E9(pc),a1
		jsr	(Animate_RawNoSST).l
		moveq	#$2B,d1
		moveq	#$18,d2
		moveq	#$19,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Sprite_CheckDelete).l
; ---------------------------------------------------------------------------

loc_79D28:
		lea	ObjDat3_7A16C(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_79D44,(a0)
		move.w	#-$80,$1A(a0)
		move.w	#$20,$3A(a0)

loc_79D44:
		subq.w	#1,$3A(a0)
		bmi.s	loc_79D52
		bsr.w	sub_7A064
		bra.w	loc_79D82
; ---------------------------------------------------------------------------

loc_79D52:
		move.l	#loc_79D6E,(a0)
		move.w	#$180,8(a0)
		move.w	#$80,$1A(a0)
		lea	ChildObjDat_7A1B6(pc),a2
		jsr	(CreateChild6_Simple).l

loc_79D6E:
		bsr.w	sub_7A064
		move.b	$2C(a0),d0
		cmpi.b	#1,d0
		beq.s	loc_79DB0
		subq.w	#1,$2E(a0)
		bmi.s	loc_79DB6

loc_79D82:
		tst.w	($FFFFFAA4).w
		beq.s	loc_79DAA
		tst.b	4(a0)
		bpl.s	loc_79DB6
		tst.b	d0
		bne.s	loc_79DAA
		tst.b	($FFFFFAA9).w
		bne.s	loc_79DAA
		cmpi.w	#$612,$14(a0)
		bhi.s	loc_79DAA
		move.l	#loc_79DC2,(a0)
		st	($FFFFFAA9).w

loc_79DAA:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_79DB0:
		tst.b	4(a0)
		bmi.s	loc_79DAA

loc_79DB6:

		jsr	(Displace_PlayerOffObject).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_79DC2:
		bsr.w	sub_7A064
		cmpi.w	#$612,$14(a0)
		bcs.s	loc_79DAA
		move.l	#loc_79DEA,(a0)
		bset	#0,($FFFFFA88).w
		clr.w	$1A(a0)
		bset	#7,$2A(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_79DEA:

		bsr.w	sub_79FFE
		tst.b	($FFFFFAA3).w
		bne.s	loc_79DFC
		tst.b	4(a0)
		bpl.w	loc_79DB6

loc_79DFC:
		bsr.w	sub_79F14
		bsr.w	sub_7A064
		bsr.w	sub_79F30
		jmp	(Sprite_CheckDelete).l
; ---------------------------------------------------------------------------
		move.l	#loc_79E34,(a0)
		move.w	#$80,$18(a0)
		move.w	#$40,d0
		move.w	d0,$3E(a0)
		move.w	d0,$1A(a0)
		move.w	#8,$40(a0)
		bclr	#0,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_79E34:
		jsr	(Swing_UpAndDown).l
		cmpi.w	#$B60,$10(a0)
		bcs.s	loc_79E50
		move.l	#loc_79E50,(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)

loc_79E50:

		bsr.w	sub_7A064
		jmp	(Sprite_CheckDelete).l
; ---------------------------------------------------------------------------

loc_79E5A:
		lea	ObjDat3_7A16C(pc),a1
		jsr	(SetUp_ObjAttributes).l
		lea	loc_79DEA(pc),a1
		move.l	a1,(a0)
		jmp	(a1)
; ---------------------------------------------------------------------------

loc_79E6C:
		lea	word_7A184(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#loc_79E7C,(a0)

loc_79E7C:
		movea.w	$46(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		lea	byte_7A1E5(pc),a1
		jsr	(Animate_RawNoSST).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_79E9C:
		lea	ObjDat3_7960E(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#Obj_FlickerMove,(a0)
		bsr.w	sub_7A07C
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_79EB6:

		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_79EE6
		rts
; ---------------------------------------------------------------------------

loc_79EC4:
		movea.w	$46(a0),a1
		btst	#6,$2A(a1)
		bne.w	locret_797F8
		lea	word_79F0C(pc),a2
		jsr	(Check_InTheirRange).l
		beq.w	locret_797F8
		bset	#6,$2A(a1)

loc_79EE6:
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_79EFA
		move.b	#6,$2C(a1)

loc_79EFA:
		jsr	(Delete_Current_Sprite).l
		moveq	#-$65,d0
		jsr	(Play_Sound_2).l
		addq.w	#4,sp
		rts
; End of function sub_79EB6

; ---------------------------------------------------------------------------
word_79F0C:	dc.w  $FFD0,   $60, $FFD0,   $60
; =============== S U B R O U T I N E =======================================


sub_79F14:

		move.w	($FFFFEEDC).w,d0
		move.w	($FFFFFA84).w,d1
		lsr.w	#2,d1
		add.w	d1,d0
		add.w	d0,d0
		tst.b	($FFFFFAA2).w
		bne.s	loc_79F2A
		neg.w	d0

loc_79F2A:
		move.w	d0,$18(a0)
		rts
; End of function sub_79F14


; =============== S U B R O U T I N E =======================================


sub_79F30:

		move.w	$10(a0),d0
		subi.w	#$9E0,d0
		lsr.w	#1,d0
		lea	($FFFFA900).w,a1
		moveq	#0,d1
		move.b	(a1,d0.w),d1
		subi.w	#$30,d1
		neg.w	d1
		addi.w	#$612,d1
		add.w	$26(a0),d1
		move.w	d1,$14(a0)
		rts
; End of function sub_79F30


; =============== S U B R O U T I N E =======================================


sub_79F58:
		btst	#6,$2A(a0)
		beq.s	locret_79F98
		tst.b	$20(a0)
		bne.s	loc_79F7A
		subq.b	#1,$29(a0)
		beq.s	loc_79F9A
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l

loc_79F7A:
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_79F88
		addi.w	#8,d0

loc_79F88:
		bsr.w	sub_79FD8
		subq.b	#1,$20(a0)
		bne.s	locret_79F98
		bclr	#6,$2A(a0)

locret_79F98:

		rts
; ---------------------------------------------------------------------------

loc_79F9A:
		move.l	#loc_79988,(a0)
		bset	#7,$2A(a0)
		clr.b	($FFFFFAA3).w
		clr.w	($FFFFFA84).w
		st	($FFFFEEC6).w
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_79FC6
		move.b	#4,$2C(a1)

loc_79FC6:
		clr.b	($FFFFEEDB).w
		jsr	(BossDefeated_StopTimer).l
		move.w	#$7F,$2E(a0)
		rts
; End of function sub_79F58


; =============== S U B R O U T I N E =======================================


sub_79FD8:
		lea	word_79FE6(pc),a1
		lea	word_79FEE(pc,d0.w),a2
		jmp	(CopyWordData_4).l
; End of function sub_79FD8

; ---------------------------------------------------------------------------
word_79FE6:	dc.w $FC28
		dc.w $FC38
		dc.w $FC3A
		dc.w $FC3C
word_79FEE:	dc.w $406
		dc.w $646
		dc.w $424
		dc.w 0
		dc.w $EEE
		dc.w $EEE
		dc.w $EEE
		dc.w $EEE

; =============== S U B R O U T I N E =======================================


sub_79FFE:
		movea.w	($FFFFFAA4).w,a1
		tst.w	(a1)
		beq.w	locret_797F8
		lea	word_7A038(pc),a2
		jsr	(Check_InTheirRange).l
		beq.w	locret_797F8
		lea	ChildObjDat_7A1BC(pc),a2
		jsr	(CreateChild6_Simple).l
		jsr	(Go_Delete_Sprite).l
		jsr	(Displace_PlayerOffObject).l
		moveq	#-$62,d0
		jsr	(Play_Sound_2).l
		addq.w	#4,sp
		rts
; End of function sub_79FFE

; ---------------------------------------------------------------------------
word_7A038:	dc.w  $FFC0,   $80, $FFC0,   $80

; =============== S U B R O U T I N E =======================================


sub_7A040:

		move.w	$10(a0),d0
		sub.w	($FFFFEE78).w,d0
		cmpi.w	#$140,d0
		bcc.s	loc_7A060
		move.w	$14(a0),d0
		sub.w	($FFFFEE7C).w,d0
		cmpi.w	#$E0,d0
		bcc.s	loc_7A060
		moveq	#1,d0
		rts
; ---------------------------------------------------------------------------

loc_7A060:

		moveq	#0,d0
		rts
; End of function sub_7A040


; =============== S U B R O U T I N E =======================================


sub_7A064:

		move.w	$10(a0),-(sp)
		jsr	(MoveSprite2).l
		moveq	#$23,d1
		moveq	#$10,d2
		moveq	#$D,d3
		move.w	(sp)+,d4
		jmp	(SolidObjectTop).l
; End of function sub_7A064


; =============== S U B R O U T I N E =======================================


sub_7A07C:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,d1
		lsr.w	#1,d0
		move.b	RawAni_7A0BA(pc,d0.w),$22(a0)
		movea.w	$46(a0),a1
		move.w	$10(a1),d2
		move.w	$14(a1),d3
		lea	byte_7A0C4(pc,d1.w),a2
		move.b	(a2)+,d0
		ext.w	d0
		add.w	d0,d2
		move.b	(a2)+,d0
		ext.w	d0
		add.w	d0,d3
		move.w	d2,$10(a0)
		move.w	d3,$14(a0)
		add.w	d1,d1
		move.l	word_7A0D8(pc,d1.w),$18(a0)
		rts
; End of function sub_7A07C

; ---------------------------------------------------------------------------
RawAni_7A0BA:	dc.b	1,   1,	  1,   1,   1,	 3,   2,   3,	2,   3
byte_7A0C4:	dc.b  $F0, $F8
		dc.b	0, $F8
		dc.b  $10, $F8
		dc.b  $F8,   8
		dc.b	8,   8
		dc.b  $F4, $FC
		dc.b   $C, $FC
		dc.b  $EC,   8
		dc.b  $14,   8
		dc.b	0,  $C
word_7A0D8:	dc.w  $FD80, $FD00
		dc.w	$80, $FC80
		dc.w   $280, $FD00
		dc.w  $FE00, $FD80
		dc.w   $200, $FD80
		dc.w  $FD00, $FD00
		dc.w   $300, $FD80
		dc.w  $FD00, $FC80
		dc.w   $300, $FC80
		dc.w  $FF80, $FC00
; ---------------------------------------------------------------------------

loc_7A100:
		tst.b	($FFFFFACD).w
		beq.w	locret_797F8
		move.l	#loc_7A12A,(a0)
		lea	word_78EAA(pc),a1
		lea	($FFFFFADE).w,a2
		move.l	(a1)+,(a2)+
		move.l	(a1)+,(a2)+
		clr.w	(a2)
		move.l	#loc_7A138,($FFFFFADA).w
		move.w	#$7FFF,($FFFFF634).w

loc_7A12A:
		jsr	(Run_PalRotationScript).l

loc_7A130:
		move.w	#$7FFF,($FFFFF634).w
		rts
; ---------------------------------------------------------------------------

loc_7A138:
		move.l	#loc_7A130,(a0)
		rts
; ---------------------------------------------------------------------------
ObjDat3_7A140:	dc.l Map_LRZEndBoss
		dc.w $23CC
		dc.w $280
		dc.b $28
		dc.b $2C
		dc.b 0
		dc.b $B8
word_7A14C:	dc.w $280
		dc.b $10
		dc.b $10
		dc.b 4
		dc.b $9A
word_7A152:	dc.w $280
		dc.b $10
		dc.b $10
		dc.b 5
		dc.b 0
word_7A158:	dc.w $280
		dc.b 8
		dc.b 8
		dc.b $A
		dc.b 0
word_7A15E:	dc.w $200
		dc.b $28
		dc.b 4
		dc.b 1
		dc.b 0
word_7A164:	dc.w $3CC
		dc.w $200
		dc.b $C
		dc.b 8
		dc.b $F
		dc.b 0
ObjDat3_7A16C:	dc.l Map_LRZ3Platform

		dc.w $6001
		dc.w $280
		dc.b $18
		dc.b $10
		dc.b 1
		dc.b 0
ObjDat3_7A178:	dc.l Map_LRZ3Platform
		dc.w $6001
		dc.w $280
		dc.b $20
		dc.b $18
		dc.b 4
		dc.b 0
word_7A184:	dc.w $4001
		dc.w $100
		dc.b $20
		dc.b 8
		dc.b 2
		dc.b 0
ChildObjDat_7A18C:dc.w 1
		dc.l loc_79BE6
		dc.w $EE
		dc.l loc_79C0C
		dc.w $EB01
ChildObjDat_7A19A:dc.w 1
		dc.l loc_79AAE
		dc.w $E8
		dc.l loc_79B7E
		dc.w $C9
ChildObjDat_7A1A8:dc.w 0
		dc.l loc_79BAC
		dc.w $10
ChildObjDat_7A1B0:dc.w 0
		dc.l loc_79D28
ChildObjDat_7A1B6:dc.w 0
		dc.l loc_79E6C
ChildObjDat_7A1BC:dc.w 9
		dc.l loc_79E9C
byte_7A1C2:	dc.b	2,   1
		dc.b	2,   3
		dc.b  $FC
byte_7A1C7:	dc.b	5,   0
		dc.b	5,   0
		dc.b	6,   1
		dc.b	5,   0
		dc.b	6,   1
		dc.b	7,   3
		dc.b	8,   4
		dc.b	9,   5
		dc.b  $F4
byte_7A1D8:	dc.b   $A,   2
		dc.b   $A,   2
		dc.b   $B,   3
		dc.b   $C,   4
		dc.b   $D,   5
		dc.b   $E,   5
		dc.b  $F4
byte_7A1E5:	dc.b	3,   2
		dc.b	3, $FC
byte_7A1E9:	dc.b	7,   4
		dc.b	5, $FC
		dc.b	0
Pal_LRZEndBoss:	binclude "Levels\LRZ\Palettes\End Boss.bin"

; ---------------------------------------------------------------------------

Obj_SSZGHZBoss:

		move.l	#Obj_Wait,(a0)
		move.b	#1,($FFFFF7AA).w
		move.w	#$1F,$2E(a0)
		move.l	#loc_7A294,$34(a0)
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_7A244
		move.l	#Obj_Song_Fade_Transition,(a1)
		move.b	#$19,$2C(a1)

loc_7A244:
		move.w	($FFFFEE78).w,d0
		addi.w	#$110,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d0
		subi.w	#$40,d0
		move.w	d0,$14(a0)
		clr.w	($FFFFFA88).w
		moveq	#$7B,d0
		jsr	(Load_PLC).l
		lea	(ArtKosM_SSZGHZMisc).l,a1
		move.w	#-$7300,d2
		jsr	(Queue_Kos_Module).l
		lea	($FFFFFC20).w,a1
		lea	($FFFFFCA0).w,a2
		moveq	#7,d6

loc_7A282:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_7A282
		lea	(Pal_SSZGHZMisc).l,a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_7A294:
		move.l	#loc_7A29C,(a0)

locret_7A29A:

		rts
; ---------------------------------------------------------------------------

loc_7A29C:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7A2B4(pc,d0.w),d1
		jsr	off_7A2B4(pc,d1.w)
		bsr.w	sub_7A5A0
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_7A2B4:	dc.w loc_7A2C0-off_7A2B4

		dc.w loc_7A2F0-off_7A2B4
		dc.w loc_7A32C-off_7A2B4
		dc.w loc_7A35E-off_7A2B4
		dc.w loc_7A388-off_7A2B4
		dc.w loc_7A3A8-off_7A2B4
; ---------------------------------------------------------------------------

loc_7A2C0:
		lea	ObjDat3_7A64E(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#8,$29(a0)
		move.w	#$100,$1A(a0)
		move.w	#$67,$2E(a0)
		move.l	#loc_7A2FC,$34(a0)
		lea	(Child1_MakeMechaHead).l,a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_7A2F0:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7A2FC:
		move.b	#4,5(a0)
		move.w	#-$100,$18(a0)
		lea	ChildObjDat_7A69E(pc),a2
		jsr	(CreateChild1_Normal).l
		move.w	#$C0,d0
		move.w	d0,$3E(a0)
		move.w	d0,$1A(a0)
		move.w	#$10,$40(a0)
		bclr	#0,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_7A32C:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		move.w	($FFFFEE78).w,d0
		addi.w	#$A0,d0
		cmp.w	$10(a0),d0
		bcs.s	locret_7A35C
		move.b	#6,5(a0)
		bset	#6,$38(a0)
		lea	ChildObjDat_7A684(pc),a2
		jsr	(CreateChild9_TreeList).l

locret_7A35C:
		rts
; ---------------------------------------------------------------------------

loc_7A35E:
		btst	#2,$38(a0)
		beq.s	locret_7A386
		move.b	#8,5(a0)
		bclr	#6,$38(a0)
		move.w	#-$100,$18(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_7A39A,$34(a0)

locret_7A386:
		rts
; ---------------------------------------------------------------------------

loc_7A388:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7A39A:
		move.b	#$A,5(a0)
		bset	#6,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_7A3A8:
		bclr	#3,$38(a0)
		beq.s	locret_7A3CC
		move.b	#8,5(a0)
		bclr	#6,$38(a0)
		neg.w	$18(a0)
		bchg	#0,4(a0)
		move.w	#$3F,$2E(a0)

locret_7A3CC:
		rts
; ---------------------------------------------------------------------------

loc_7A3CE:
		move.l	#loc_7A3E6,(a0)
		bset	#0,4(a0)
		move.w	#$400,$18(a0)
		clr.w	$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_7A3E6:
		subq.w	#1,$2E(a0)
		bmi.s	loc_7A3F8
		jsr	(MoveSprite2).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7A3F8:
		clr.b	($FFFFF7AA).w
		bset	#4,$38(a0)
		st	($FFFFFA89).w
		st	($FFFFEED2).w
		lea	($FFFFFCA0).w,a1
		lea	($FFFFFC20).w,a2
		moveq	#7,d6

loc_7A414:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_7A414
		moveq	#$32,d0
		jsr	(Load_PLC).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_7A428:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7A43E(pc,d0.w),d1
		jsr	off_7A43E(pc,d1.w)
		moveq	#0,d0
		jmp	(Child_Draw_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------
off_7A43E:	dc.w loc_7A446-off_7A43E

		dc.w loc_7A460-off_7A43E
		dc.w loc_7A482-off_7A43E
		dc.w loc_7A496-off_7A43E
; ---------------------------------------------------------------------------

loc_7A446:
		lea	ObjDat3_7A660(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#$1A,$43(a0)
		move.b	#1,$3A(a0)
		bra.w	sub_7A634
; ---------------------------------------------------------------------------

loc_7A460:

		addq.w	#2,$14(a0)
		subq.w	#1,$2E(a0)
		bpl.s	locret_7A480
		addq.b	#2,5(a0)
		cmpi.b	#$A,$2C(a0)
		bne.s	locret_7A480
		movea.w	$44(a0),a1
		bset	#2,$38(a1)

locret_7A480:

		rts
; ---------------------------------------------------------------------------

loc_7A482:
		movea.w	$44(a0),a1
		btst	#2,$38(a1)
		beq.s	locret_7A494
		move.b	#6,5(a0)

locret_7A494:
		rts
; ---------------------------------------------------------------------------

loc_7A496:
		move.b	$3C(a0),d0
		subi.b	#$40,d0
		sls	d1
		cmpi.b	#-$80,d0
		bcc.s	loc_7A4C2
		neg.b	$3A(a0)
		movea.w	$44(a0),a1
		btst	#0,4(a1)
		beq.s	loc_7A4B8
		not.b	d1

loc_7A4B8:
		tst.b	d1
		bne.s	loc_7A4C2
		bset	#3,$38(a1)

loc_7A4C2:

		move.b	$3A(a0),d0
		add.b	d0,$3C(a0)
		jmp	(Refresh_ChildPosition).l
; ---------------------------------------------------------------------------

loc_7A4D0:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7A4E6(pc,d0.w),d1
		jsr	off_7A4E6(pc,d1.w)
		moveq	#0,d0
		jmp	(Child_Draw_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------
off_7A4E6:	dc.w loc_7A4EC-off_7A4E6

		dc.w loc_7A460-off_7A4E6
		dc.w loc_7A500-off_7A4E6
; ---------------------------------------------------------------------------

loc_7A4EC:
		bsr.w	sub_7A634
		move.b	#4,$3A(a0)
		lea	ObjDat3_7A66C(pc),a1
		jmp	(SetUp_ObjAttributes).l
; ---------------------------------------------------------------------------

loc_7A500:

		movea.w	$46(a0),a1
		move.b	$3C(a1),$3C(a0)
		move.b	$3A(a0),d2
		jmp	(MoveSprite_CircularSimple).l
; ---------------------------------------------------------------------------

loc_7A514:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7A53E(pc,d0.w),d1
		jsr	off_7A53E(pc,d1.w)
		move.b	#0,$22(a0)
		btst	#0,($FFFFFE0F).w
		beq.s	loc_7A536
		move.b	#1,$22(a0)

loc_7A536:
		moveq	#0,d0
		jmp	(Child_DrawTouch_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------
off_7A53E:	dc.w loc_7A544-off_7A53E

		dc.w loc_7A460-off_7A53E
		dc.w loc_7A500-off_7A53E
; ---------------------------------------------------------------------------

loc_7A544:
		bsr.w	sub_7A634
		move.b	#3,$3A(a0)
		lea	ObjDat3_7A678(pc),a1
		jmp	(SetUp_ObjAttributes).l
; ---------------------------------------------------------------------------

loc_7A558:
		lea	word_7A65A(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_7A568,(a0)

loc_7A568:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_7A59A
		btst	#6,$38(a1)
		bne.w	locret_7A29A
		btst	#0,($FFFFFE0F).w
		bne.w	locret_7A29A
		jsr	(Refresh_ChildPositionAdjusted).l
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7A59A:
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_7A5A0:
		tst.b	$28(a0)
		bne.s	locret_7A5EA
		move.b	$29(a0),d0
		beq.s	loc_7A5EC
		tst.b	$20(a0)
		bne.s	loc_7A5C6
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		bset	#6,$2A(a0)

loc_7A5C6:
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_7A5D4
		addi.w	#4,d0

loc_7A5D4:
		bsr.w	sub_7A614
		subq.b	#1,$20(a0)
		bne.s	locret_7A5EA
		bclr	#6,$2A(a0)
		move.b	$25(a0),$28(a0)

locret_7A5EA:

		rts
; ---------------------------------------------------------------------------

loc_7A5EC:
		move.l	#Wait_FadeToLevelMusic,(a0)
		move.l	#loc_7A3CE,$34(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild1_Normal).l
		bne.s	loc_7A60E
		move.b	#4,$2C(a1)

loc_7A60E:
		jmp	(BossDefeated).l
; End of function sub_7A5A0


; =============== S U B R O U T I N E =======================================


sub_7A614:

		lea	word_7A622(pc),a1
		lea	word_7A628(pc,d0.w),a2
		jmp	(CopyWordData_3).l
; End of function sub_7A614

; ---------------------------------------------------------------------------
word_7A622:	dc.w $FC0E
		dc.w $FC1C
		dc.w $FC1E
word_7A628:	dc.w 8
		dc.w $866
		dc.w $222
		dc.w $888
		dc.w $CCC
		dc.w $EEE

; =============== S U B R O U T I N E =======================================


sub_7A634:

		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_7A642(pc,d0.w),$2E(a0)
		rts
; End of function sub_7A634

; ---------------------------------------------------------------------------
word_7A642:	dc.w $C
		dc.w $14
		dc.w $1C
		dc.w $24
		dc.w $2C
		dc.w $3C
ObjDat3_7A64E:	dc.l Map_RobotnikShip
		dc.w $52E
		dc.w $200
		dc.b $1C
		dc.b $20
		dc.b $A
		dc.b $F
word_7A65A:	dc.w $200
		dc.b 8
		dc.b 4
		dc.b 6
		dc.b 0
ObjDat3_7A660:	dc.l Map_SSZGHZMisc
		dc.w $2468
		dc.w $300
		dc.b 8
		dc.b 8
		dc.b 2
		dc.b 0
ObjDat3_7A66C:	dc.l Map_SSZGHZMisc
		dc.w $2468
		dc.w $300
		dc.b 8
		dc.b 8
		dc.b 3
		dc.b 0
ObjDat3_7A678:	dc.l Map_SSZGHZMisc
		dc.w $2468
		dc.w $280
		dc.b 8
		dc.b 8
		dc.b 0
		dc.b $8F
ChildObjDat_7A684:dc.w 5
		dc.l loc_7A428
		dc.l loc_7A4D0
		dc.l loc_7A4D0
		dc.l loc_7A4D0
		dc.l loc_7A4D0
		dc.l loc_7A514
ChildObjDat_7A69E:dc.w 0
		dc.l loc_7A558
		dc.w $1E00
; ---------------------------------------------------------------------------

Obj_SSZMTZBoss:

		move.l	#Obj_Wait,(a0)
		move.b	#1,($FFFFF7AA).w
		move.w	#$1F,$2E(a0)
		move.l	#loc_7A712,$34(a0)
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_7A6DC
		move.l	#Obj_Song_Fade_Transition,(a1)
		move.b	#$19,$2C(a1)

loc_7A6DC:
		clr.w	($FFFFFA88).w
		moveq	#$7B,d0
		jsr	(Load_PLC).l
		lea	(ArtKosM_SSZMTZOrbs).l,a1
		move.w	#$83E0,d2
		jsr	(Queue_Kos_Module).l
		lea	($FFFFFC20).w,a1
		lea	($FFFFFCA0).w,a2
		moveq	#7,d6

loc_7A702:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_7A702
		lea	Pal_SSZMTZOrbs(pc),a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_7A712:
		move.l	#loc_7A71A,(a0)

locret_7A718:
		rts
; ---------------------------------------------------------------------------

loc_7A71A:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7A728(pc,d0.w),d1
		jmp	off_7A728(pc,d1.w)
; ---------------------------------------------------------------------------
off_7A728:	dc.w loc_7A72C-off_7A728

		dc.w loc_7A7E2-off_7A728
; ---------------------------------------------------------------------------

loc_7A72C:
		move.l	#Map_RobotnikShip,$C(a0)
		move.w	#$52E,$A(a0)
		ori.b	#4,4(a0)
		move.w	#$180,8(a0)
		move.w	#$1700,$10(a0)
		move.w	#$300,$14(a0)
		move.b	#$A,$22(a0)
		addq.b	#2,5(a0)
		move.b	#$11,$28(a0)
		move.b	#8,$29(a0)
		move.b	#7,$3C(a0)
		move.w	$10(a0),($FFFFFAF0).w
		move.w	$14(a0),($FFFFFAF4).w
		move.w	#0,($FFFFFAF8).w
		move.w	#$100,($FFFFFAFA).w
		move.b	#$20,7(a0)
		clr.b	$2E(a0)
		clr.b	$30(a0)
		move.b	#$40,$1D(a0)
		move.b	#$27,$38(a0)
		move.b	#$27,$3A(a0)
		lea	(Child1_MakeMechaHead).l,a2
		jsr	(CreateChild1_Normal).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_7A7C4
		move.l	#loc_7AD8A,(a1)
		move.l	a0,$34(a1)

loc_7A7C4:
		lea	($FFFFFA82).w,a2
		move.b	#$10,(a2)+
		move.b	#0,(a2)+
		move.b	#3,(a2)+
		move.b	#0,(a2)+
		move.b	#1,(a2)+
		move.b	#0,(a2)+
		rts
; ---------------------------------------------------------------------------

loc_7A7E2:
		moveq	#0,d0
		move.b	$26(a0),d0
		move.w	off_7A7F0(pc,d0.w),d1
		jmp	off_7A7F0(pc,d1.w)
; ---------------------------------------------------------------------------
off_7A7F0:	dc.w loc_7A800-off_7A7F0

		dc.w loc_7A874-off_7A7F0
		dc.w loc_7A8F4-off_7A7F0
		dc.w loc_7A93C-off_7A7F0
		dc.w loc_7A95A-off_7A7F0
		dc.w loc_7A98A-off_7A7F0
		dc.w loc_7A9D4-off_7A7F0
		dc.w loc_7AA44-off_7A7F0
; ---------------------------------------------------------------------------

loc_7A800:
		bsr.w	sub_7B12E
		move.w	($FFFFFAF4).w,$14(a0)
		cmpi.w	#$420,($FFFFFAF4).w
		bcs.s	loc_7A84A
		addq.b	#2,$26(a0)
		move.w	#0,($FFFFFAFA).w
		move.w	#-$100,($FFFFFAF8).w
		bclr	#7,$2E(a0)
		bclr	#0,4(a0)
		move.w	($FFFFB010).w,d0
		cmp.w	($FFFFFAF0).w,d0
		bcs.s	loc_7A84A
		move.w	#$100,($FFFFFAF8).w
		bset	#7,$2E(a0)
		bset	#0,4(a0)

loc_7A84A:

		bsr.w	sub_7AC06
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_7A85A:
		move.b	$1D(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#6,d0
		add.w	($FFFFFAF4).w,d0
		move.w	d0,$14(a0)
		addq.b	#4,$1D(a0)
		rts
; End of function sub_7A85A

; ---------------------------------------------------------------------------

loc_7A874:
		bsr.w	sub_7B12E
		btst	#7,$2E(a0)
		bne.s	loc_7A8AE
		cmpi.w	#$1680,($FFFFFAF0).w
		bcc.s	loc_7A8DA
		bchg	#7,$2E(a0)
		move.w	#$100,($FFFFFAF8).w
		bset	#0,4(a0)
		bset	#6,$2E(a0)
		beq.s	loc_7A8DA
		addq.b	#2,$26(a0)
		move.w	#-$100,($FFFFFAFA).w
		bra.s	loc_7A8DA
; ---------------------------------------------------------------------------

loc_7A8AE:
		cmpi.w	#$1780,($FFFFFAF0).w
		bcs.s	loc_7A8DA
		bchg	#7,$2E(a0)
		move.w	#-$100,($FFFFFAF8).w
		bclr	#0,4(a0)
		bset	#6,$2E(a0)
		beq.s	loc_7A8DA
		addq.b	#2,$26(a0)
		move.w	#-$100,($FFFFFAFA).w

loc_7A8DA:

		move.w	($FFFFFAF0).w,$10(a0)
		bsr.w	sub_7A85A

loc_7A8E4:
		bsr.w	sub_7AC06
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7A8F4:
		bsr.w	sub_7B12E
		cmpi.w	#$3F0,($FFFFFAF4).w
		bcc.s	loc_7A906
		move.w	#0,($FFFFFAFA).w

loc_7A906:
		btst	#7,$2E(a0)
		bne.s	loc_7A91E
		cmpi.w	#$1700,($FFFFFAF0).w
		bcc.s	loc_7A92C
		move.w	#0,($FFFFFAF8).w
		bra.s	loc_7A92C
; ---------------------------------------------------------------------------

loc_7A91E:
		cmpi.w	#$1700,($FFFFFAF0).w
		bcs.s	loc_7A92C
		move.w	#0,($FFFFFAF8).w

loc_7A92C:

		move.w	($FFFFFAF8).w,d0
		or.w	($FFFFFAFA).w,d0
		bne.s	loc_7A93A
		addq.b	#2,$26(a0)

loc_7A93A:
		bra.s	loc_7A8DA
; ---------------------------------------------------------------------------

loc_7A93C:
		cmpi.b	#$68,$38(a0)
		bcc.s	loc_7A94E
		addq.b	#1,$38(a0)
		addq.b	#1,$3A(a0)
		bra.s	loc_7A958
; ---------------------------------------------------------------------------

loc_7A94E:
		subq.b	#1,$3A(a0)
		bne.s	loc_7A958
		addq.b	#2,$26(a0)

loc_7A958:

		bra.s	loc_7A8DA
; ---------------------------------------------------------------------------

loc_7A95A:
		cmpi.b	#$27,$38(a0)
		bcs.s	loc_7A968
		subq.b	#1,$38(a0)
		bra.s	loc_7A986
; ---------------------------------------------------------------------------

loc_7A968:
		addq.b	#1,$3A(a0)
		cmpi.b	#$27,$3A(a0)
		bcs.s	loc_7A986
		move.w	#$100,($FFFFFAFA).w
		move.b	#0,$26(a0)
		bclr	#6,$2E(a0)

loc_7A986:

		bra.w	loc_7A8DA
; ---------------------------------------------------------------------------

loc_7A98A:
		tst.b	$3A(a0)
		beq.s	loc_7A996
		subq.b	#1,$3A(a0)
		bra.s	loc_7A99C
; ---------------------------------------------------------------------------

loc_7A996:
		move.b	#-1,$3B(a0)

loc_7A99C:
		cmpi.b	#$27,$38(a0)
		bcs.s	loc_7A9A8
		subq.b	#1,$38(a0)

loc_7A9A8:
		bsr.w	sub_7B12E
		cmpi.w	#$3B0,($FFFFFAF4).w
		bcc.s	loc_7A9BA
		move.w	#0,($FFFFFAFA).w

loc_7A9BA:
		tst.b	$30(a0)
		bne.s	loc_7A9D0
		tst.b	$3B(a0)
		beq.s	loc_7A9CC
		move.b	#-$80,$3B(a0)

loc_7A9CC:
		addq.b	#2,$26(a0)

loc_7A9D0:
		bra.w	loc_7A8DA
; ---------------------------------------------------------------------------

loc_7A9D4:
		tst.b	$3C(a0)
		beq.s	loc_7AA02
		tst.b	$3B(a0)
		bne.s	loc_7AA40
		cmpi.b	#$27,$3A(a0)
		bcc.s	loc_7A9EE
		addq.b	#1,$3A(a0)
		bra.s	loc_7AA40
; ---------------------------------------------------------------------------

loc_7A9EE:
		move.w	#$100,($FFFFFAFA).w
		move.b	#0,$26(a0)
		bclr	#6,$2E(a0)
		bra.s	loc_7AA40
; ---------------------------------------------------------------------------

loc_7AA02:
		move.w	#-$180,($FFFFFAFA).w
		move.w	#-$100,($FFFFFAF8).w
		bclr	#0,4(a0)
		btst	#7,$2E(a0)
		beq.s	loc_7AA28
		move.w	#$100,($FFFFFAF8).w
		bset	#0,4(a0)

loc_7AA28:
		move.b	#$E,$26(a0)
		move.b	#0,$32(a0)
		bclr	#6,$2E(a0)
		move.b	#0,$33(a0)

loc_7AA40:

		bra.w	loc_7A8DA
; ---------------------------------------------------------------------------

loc_7AA44:
		tst.b	$33(a0)
		beq.s	loc_7AA52
		subq.b	#1,$33(a0)
		bra.w	loc_7A8E4
; ---------------------------------------------------------------------------

loc_7AA52:
		moveq	#0,d0
		move.b	$32(a0),d0
		move.w	off_7AA60(pc,d0.w),d1
		jmp	off_7AA60(pc,d1.w)
; ---------------------------------------------------------------------------
off_7AA60:	dc.w loc_7AA66-off_7AA60

		dc.w loc_7AACE-off_7AA60
		dc.w loc_7AB1A-off_7AA60
; ---------------------------------------------------------------------------

loc_7AA66:
		bsr.w	sub_7B12E
		cmpi.w	#$3B0,($FFFFFAF4).w
		bcc.s	loc_7AA78
		move.w	#0,($FFFFFAFA).w

loc_7AA78:
		btst	#7,$2E(a0)
		bne.s	loc_7AAA6
		cmpi.w	#$16A0,($FFFFFAF0).w
		bcc.s	loc_7AACA
		addq.b	#2,$32(a0)
		move.w	#$180,($FFFFFAFA).w
		move.b	#3,$31(a0)
		move.w	#$1E,($FFFFFAFC).w
		bset	#0,4(a0)
		bra.s	loc_7AACA
; ---------------------------------------------------------------------------

loc_7AAA6:
		cmpi.w	#$1760,($FFFFFAF0).w
		bcs.s	loc_7AACA
		addq.b	#2,$32(a0)
		move.w	#$180,($FFFFFAFA).w
		move.b	#3,$31(a0)
		move.w	#$1E,($FFFFFAFC).w
		bclr	#0,4(a0)

loc_7AACA:

		bra.w	loc_7A8DA
; ---------------------------------------------------------------------------

loc_7AACE:
		bsr.w	sub_7B12E
		cmpi.w	#$420,($FFFFFAF4).w
		bcs.s	loc_7AAEC
		move.w	#-$180,($FFFFFAFA).w
		addq.b	#2,$32(a0)
		bchg	#7,$2E(a0)
		bra.s	loc_7AB12
; ---------------------------------------------------------------------------

loc_7AAEC:
		btst	#7,$2E(a0)
		bne.s	loc_7AB04
		cmpi.w	#$1680,($FFFFFAF0).w
		bcc.s	loc_7AB12
		move.w	#0,($FFFFFAF8).w
		bra.s	loc_7AB12
; ---------------------------------------------------------------------------

loc_7AB04:
		cmpi.w	#$1780,($FFFFFAF0).w
		bcs.s	loc_7AB12
		move.w	#0,($FFFFFAF8).w

loc_7AB12:

		bsr.w	sub_7AB56
		bra.w	loc_7A8DA
; ---------------------------------------------------------------------------

loc_7AB1A:
		bsr.w	sub_7B12E
		cmpi.w	#$3F0,($FFFFFAF4).w
		bcc.s	loc_7AB3A
		move.w	#$100,($FFFFFAF8).w
		btst	#7,$2E(a0)
		bne.s	loc_7AB3A
		move.w	#-$100,($FFFFFAF8).w

loc_7AB3A:

		cmpi.w	#$3B0,($FFFFFAF4).w
		bcc.s	loc_7AB4E
		move.w	#0,($FFFFFAFA).w
		move.b	#0,$32(a0)

loc_7AB4E:
		bsr.w	sub_7AB56
		bra.w	loc_7A8DA

; =============== S U B R O U T I N E =======================================


sub_7AB56:

		subi.w	#1,($FFFFFAFC).w
		bne.s	locret_7AB7E
		tst.b	$31(a0)
		beq.s	locret_7AB7E
		subq.b	#1,$31(a0)
		move.b	#$10,$33(a0)
		move.w	#$1E,($FFFFFAFC).w
		lea	ChildObjDat_7AB80(pc),a2
		jsr	(CreateChild1_Normal).l

locret_7AB7E:
		rts
; End of function sub_7AB56

; ---------------------------------------------------------------------------
ChildObjDat_7AB80:dc.w 1
		dc.l loc_7AB8E
		dc.w $F4FC
		dc.l loc_7AB8E
		dc.w $E8FC
; ---------------------------------------------------------------------------

loc_7AB8E:

		lea	ObjDat3_7ABFA(pc),a1
		jsr	(SetUp_ObjAttributes).l
		movea.w	$46(a0),a1
		jsr	(Refresh_ChildPositionAdjusted).l
		moveq	#0,d0
		tst.b	$2C(a0)
		beq.s	loc_7ABB8
		moveq	#8,d0
		move.b	#$C,$22(a0)
		move.w	#$100,8(a0)

loc_7ABB8:
		move.w	d0,$2E(a0)
		move.l	#loc_7ABC2,(a0)

loc_7ABC2:
		subq.w	#1,$2E(a0)
		bmi.s	loc_7ABCE
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7ABCE:
		move.l	#loc_7ABEE,(a0)
		move.w	#-$400,d0
		btst	#0,4(a0)
		beq.s	loc_7ABE2
		neg.w	d0

loc_7ABE2:
		move.w	d0,$18(a0)
		moveq	#$5E,d0
		jsr	(Play_Sound_2).l

loc_7ABEE:
		jsr	(MoveSprite2).l
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------
ObjDat3_7ABFA:	dc.l Map_SSZMTZOrbs
		dc.w $A41F
		dc.w $280
		dc.b $28
		dc.b 8
		dc.b $D
		dc.b $9C

; =============== S U B R O U T I N E =======================================


sub_7AC06:

		bsr.w	sub_7ACF2
		cmpi.b	#$1F,$1C(a0)
		bne.s	loc_7AC4A
		st	$39(a0)
		lea	($FFFFFA82).w,a1
		andi.b	#-$10,2(a1)
		ori.b	#5,2(a1)
		tst.b	$3C(a0)
		beq.s	loc_7AC42
		move.b	#$A,$26(a0)
		move.w	#-$180,($FFFFFAFA).w
		subq.b	#1,$3C(a0)
		move.w	#0,($FFFFFAF8).w

loc_7AC42:
		move.w	#0,($FFFFFAF8).w
		rts
; ---------------------------------------------------------------------------

loc_7AC4A:
		cmpi.b	#4,($FFFFB005).w
		beq.s	loc_7AC5A
		cmpi.b	#4,($FFFFB04F).w
		bne.s	locret_7AC78

loc_7AC5A:
		lea	($FFFFFA82).w,a1
		move.b	2(a1),d0
		andi.b	#$F,d0
		cmpi.b	#4,d0
		beq.s	locret_7AC78
		andi.b	#-$10,2(a1)
		ori.b	#4,2(a1)

locret_7AC78:

		rts
; End of function sub_7AC06

; ---------------------------------------------------------------------------

loc_7AC7A:
		move.l	#loc_7AC92,(a0)
		bset	#0,4(a0)
		move.w	#$400,$18(a0)
		clr.w	$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_7AC92:
		subq.w	#1,$2E(a0)
		bmi.s	loc_7ACA4
		jsr	(MoveSprite2).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7ACA4:
		clr.b	($FFFFF7AA).w
		bset	#4,$38(a0)
		st	($FFFFFA89).w
		st	($FFFFEED4).w
		lea	($FFFFFCA0).w,a1
		lea	($FFFFFC20).w,a2
		moveq	#7,d6

loc_7ACC0:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_7ACC0
		moveq	#$32,d0
		jsr	(Load_PLC).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------
		move.b	$1D(a0),d0
		jsr	(GetSineCosine).l
		asr.w	#6,d0
		add.w	($FFFFFAF4).w,d0
		move.w	d0,$14(a0)
		move.w	($FFFFFAF0).w,$10(a0)
		addq.b	#2,$1D(a0)

; =============== S U B R O U T I N E =======================================


sub_7ACF2:
		cmpi.b	#$10,$26(a0)
		bcc.s	locret_7AD38
		tst.b	$29(a0)
		beq.s	loc_7AD3A
		tst.b	$28(a0)
		bne.s	locret_7AD38
		tst.b	$1C(a0)
		bne.s	loc_7AD1A
		move.b	#$20,$1C(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l

loc_7AD1A:
		moveq	#0,d0
		btst	#0,$1C(a0)
		bne.s	loc_7AD28
		addi.w	#4,d0

loc_7AD28:
		bsr.w	sub_7AD6A
		subq.b	#1,$1C(a0)
		bne.s	locret_7AD38
		move.b	#$F,$28(a0)

locret_7AD38:

		rts
; ---------------------------------------------------------------------------

loc_7AD3A:
		move.l	#Wait_FadeToLevelMusic,(a0)
		move.l	#loc_7AC7A,$34(a0)
		st	($FFFFFA88).w
		clr.b	$38(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild1_Normal).l
		bne.s	loc_7AD64
		move.b	#4,$2C(a1)

loc_7AD64:
		jmp	(BossDefeated).l
; End of function sub_7ACF2


; =============== S U B R O U T I N E =======================================


sub_7AD6A:
		lea	word_7AD78(pc),a1
		lea	word_7AD7E(pc,d0.w),a2
		jmp	(CopyWordData_3).l
; End of function sub_7AD6A

; ---------------------------------------------------------------------------
word_7AD78:	dc.w $FC0E
		dc.w $FC1C
		dc.w $FC1E
word_7AD7E:	dc.w 8
		dc.w $866
		dc.w $222
		dc.w $888
		dc.w $CCC
		dc.w $EEE
; ---------------------------------------------------------------------------

loc_7AD8A:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7AD98(pc,d0.w),d1
		jmp	off_7AD98(pc,d1.w)
; ---------------------------------------------------------------------------
off_7AD98:	dc.w loc_7ADA2-off_7AD98

		dc.w loc_7AE22-off_7AD98
		dc.w loc_7AFA4-off_7AD98
		dc.w loc_7B02A-off_7AD98
		dc.w loc_7B116-off_7AD98
; ---------------------------------------------------------------------------

loc_7ADA2:
		movea.l	a0,a1
		moveq	#6,d3
		moveq	#0,d2
		bra.s	loc_7ADB2
; ---------------------------------------------------------------------------

loc_7ADAA:
		jsr	(Create_New_Sprite).l
		bne.s	locret_7AE12

loc_7ADB2:
		move.b	#$20,7(a1)
		move.l	$34(a0),$34(a1)
		move.l	#loc_7AD8A,(a1)
		move.l	#Map_SSZMTZOrbs,$C(a1)
		move.w	#$41F,$A(a1)
		ori.b	#4,4(a1)
		move.w	#$180,8(a1)
		addq.b	#2,5(a1)
		move.b	#0,$22(a1)
		move.b	byte_7AE14(pc,d2.w),$2E(a1)
		move.b	byte_7AE14(pc,d2.w),$41(a1)
		move.b	byte_7AE1B(pc,d2.w),$40(a1)
		move.b	#$40,$2F(a1)
		move.b	#-$79,$28(a1)
		move.b	#0,$42(a1)
		addq.w	#1,d2
		dbf	d3,loc_7ADAA

locret_7AE12:
		rts
; ---------------------------------------------------------------------------
byte_7AE14:	dc.b $24
		dc.b $6C
		dc.b $B4
		dc.b $FC
		dc.b $48
		dc.b $90
		dc.b $D8
byte_7AE1B:	dc.b 0
		dc.b 1
		dc.b 1
		dc.b 0
		dc.b 1
		dc.b 1
		dc.b 0
; ---------------------------------------------------------------------------

loc_7AE22:
		movea.l	$34(a0),a1
		move.w	$14(a1),$30(a0)
		subi.w	#4,$30(a0)
		move.w	$10(a1),$3E(a0)
		tst.b	$39(a1)
		beq.s	loc_7AE9C
		move.b	#0,$39(a1)
		addi.b	#1,$30(a1)
		addq.b	#2,5(a0)
		move.b	#$3C,$3C(a0)
		move.b	#2,$20(a0)
		move.w	#-$400,$1A(a0)
		move.w	#-$80,d1
		move.w	($FFFFB010).w,d0
		sub.w	$10(a0),d0
		bpl.s	loc_7AE70
		neg.w	d1

loc_7AE70:
		cmpi.w	#$16A0,$10(a0)
		bcc.s	loc_7AE7C
		move.w	#$80,d1

loc_7AE7C:
		cmpi.w	#$1760,$10(a0)
		bcs.s	loc_7AE88
		move.w	#-$80,d1

loc_7AE88:
		bclr	#0,4(a0)
		tst.w	d1
		bmi.s	loc_7AE98
		bset	#0,4(a0)

loc_7AE98:
		move.w	d1,$18(a0)

loc_7AE9C:
		bsr.w	sub_7AEB0
		bsr.w	sub_7AF5A
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_7AEB0:
		move.b	$2F(a0),d0
		jsr	(GetSineCosine).l
		move.w	d0,d3
		moveq	#0,d1
		move.b	$38(a1),d1
		muls.w	d1,d0
		move.w	d0,d5
		move.w	d0,d4
		move.b	$3A(a1),d2
		tst.b	$3B(a1)
		beq.s	loc_7AED6
		move.w	#$10,d2

loc_7AED6:
		muls.w	d3,d2
		move.w	$3E(a0),d6
		move.b	$2E(a0),d0
		jsr	(GetSineCosine).l
		muls.w	d0,d5
		swap	d5
		add.w	d6,d5
		move.w	d5,$10(a0)
		muls.w	d1,d4
		swap	d4
		move.w	d4,$3A(a0)
		move.w	$30(a0),d6
		move.b	$41(a0),d0
		tst.b	$3B(a1)
		beq.s	loc_7AF0A
		move.b	$42(a0),d0

loc_7AF0A:
		jsr	(GetSineCosine).l
		muls.w	d0,d2
		swap	d2
		add.w	d6,d2
		move.w	d2,$14(a0)
		addq.b	#4,$2E(a0)
		tst.b	$3B(a1)
		bne.s	loc_7AF2A
		addq.b	#8,$41(a0)
		rts
; ---------------------------------------------------------------------------

loc_7AF2A:
		cmpi.b	#-1,$3B(a1)
		beq.s	loc_7AF4C
		cmpi.b	#-$80,$3B(a1)
		bne.s	loc_7AF44
		subq.b	#2,$42(a0)
		bpl.s	locret_7AF58
		clr.b	$42(a0)

loc_7AF44:
		move.b	#0,$3B(a1)
		rts
; ---------------------------------------------------------------------------

loc_7AF4C:
		cmpi.b	#$40,$42(a0)
		bcc.s	locret_7AF58
		addq.b	#2,$42(a0)

locret_7AF58:

		rts
; End of function sub_7AEB0


; =============== S U B R O U T I N E =======================================


sub_7AF5A:
		move.w	$3A(a0),d0
		bmi.s	loc_7AF82
		cmpi.w	#$C,d0
		blt.s	loc_7AF74
		move.b	#0,$22(a0)
		move.w	#$80,8(a0)
		rts
; ---------------------------------------------------------------------------

loc_7AF74:
		move.b	#1,$22(a0)
		move.w	#$100,8(a0)
		rts
; ---------------------------------------------------------------------------

loc_7AF82:
		cmpi.w	#-$C,d0
		blt.s	loc_7AF96
		move.b	#1,$22(a0)
		move.w	#$300,8(a0)
		rts
; ---------------------------------------------------------------------------

loc_7AF96:
		move.b	#2,$22(a0)
		move.w	#$380,8(a0)
		rts
; End of function sub_7AF5A

; ---------------------------------------------------------------------------

loc_7AFA4:
		tst.b	$3C(a0)
		bmi.s	loc_7AFB6
		subq.b	#1,$3C(a0)
		bpl.s	loc_7AFB6
		move.b	#-$3A,$28(a0)

loc_7AFB6:

		jsr	(MoveSprite).l
		subi.w	#$20,$1A(a0)
		cmpi.w	#$180,$1A(a0)
		blt.s	loc_7AFD0
		move.w	#$180,$1A(a0)

loc_7AFD0:
		tst.w	$1A(a0)
		bmi.s	loc_7AFF8
		cmpi.w	#$42C,$14(a0)
		bcs.s	loc_7AFF8
		move.w	#$42C,$14(a0)
		move.w	#$42C,$38(a0)
		move.b	#1,$32(a0)
		addq.b	#2,5(a0)
		bsr.w	sub_7B0A8

loc_7AFF8:

		bsr.w	sub_7B0C2

loc_7AFFC:
		lea	Ani_SSZMTZOrbs(pc),a1
		jsr	(Animate_Sprite).l
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
		tst.b	$29(a0)
		beq.s	locret_7B028
		move.b	#$E,$22(a0)
		move.b	#6,$20(a0)
		addq.b	#2,5(a0)

locret_7B028:
		rts
; ---------------------------------------------------------------------------

loc_7B02A:
		tst.b	$3C(a0)
		bmi.s	loc_7B03C
		subq.b	#1,$3C(a0)
		bpl.s	loc_7B03C
		move.b	#-$26,$28(a0)

loc_7B03C:

		bsr.w	sub_7B0C2
		cmpi.b	#8,$22(a0)
		bne.s	loc_7AFFC
		move.b	$32(a0),d0
		jsr	(GetSineCosine).l
		neg.w	d0
		asr.w	#2,d0
		add.w	$38(a0),d0
		cmpi.w	#$42C,d0
		bcc.s	loc_7B08C
		move.w	d0,$14(a0)
		addq.b	#1,$32(a0)
		btst	#0,$32(a0)
		beq.s	loc_7B080
		moveq	#-1,d0
		btst	#0,4(a0)
		beq.s	loc_7B07C
		neg.w	d0

loc_7B07C:
		add.w	d0,$10(a0)

loc_7B080:
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7B08C:
		move.w	#$42C,$14(a0)
		bsr.w	sub_7B0A8
		move.b	#1,$32(a0)
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_7B0A8:

		move.w	($FFFFB010).w,d0
		sub.w	$10(a0),d0
		bpl.s	loc_7B0BA
		bclr	#0,4(a0)
		rts
; ---------------------------------------------------------------------------

loc_7B0BA:
		bset	#0,4(a0)
		rts
; End of function sub_7B0A8


; =============== S U B R O U T I N E =======================================


sub_7B0C2:

		moveq	#0,d0
		move.b	$29(a0),d0
		bne.s	loc_7B0D2
		tst.b	($FFFFFA88).w
		bne.s	loc_7B0F6
		rts
; ---------------------------------------------------------------------------

loc_7B0D2:
		clr.b	$29(a0)
		andi.b	#3,d0
		add.w	d0,d0
		movea.w	word_7B10E(pc,d0.w),a1
		tst.b	$34(a1)
		bne.w	locret_7A718
		jsr	(Check_PlayerAttack).l
		bne.s	loc_7B0F6
		jsr	(HurtSonic_Directly).l

loc_7B0F6:

		clr.b	$28(a0)
		move.b	#$E,$22(a0)
		move.b	#6,$20(a0)
		move.b	#8,5(a0)
		rts
; End of function sub_7B0C2

; ---------------------------------------------------------------------------
word_7B10E:	dc.w $B000
		dc.w $B000
		dc.w $B04A
		dc.w $B04A
; ---------------------------------------------------------------------------

loc_7B116:
		moveq	#$77,d0
		jsr	(Play_Sound_2).l
		movea.l	$34(a0),a1
		subi.b	#1,$30(a1)
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_7B12E:

		move.l	($FFFFFAF0).w,d2
		move.l	($FFFFFAF4).w,d3
		move.w	($FFFFFAF8).w,d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d2
		move.w	($FFFFFAFA).w,d0
		ext.l	d0
		asl.l	#8,d0
		add.l	d0,d3
		move.l	d2,($FFFFFAF0).w
		move.l	d3,($FFFFFAF4).w
		rts
; End of function sub_7B12E

; ---------------------------------------------------------------------------
		moveq	#0,d6
		movea.l	a1,a4
		lea	($FFFFFA82).w,a2
		lea	$22(a0),a3
		tst.b	(a3)
		bne.s	loc_7B168
		addq.w	#2,a2
		bra.s	loc_7B16C
; ---------------------------------------------------------------------------

loc_7B168:
		bsr.w	sub_7B17A

loc_7B16C:
		moveq	#0,d6
		move.b	$16(a0),d6
		subq.w	#1,d6
		bmi.s	locret_7B1E0
		lea	$1D(a0),a3

; =============== S U B R O U T I N E =======================================


sub_7B17A:

		movea.l	a4,a1
		moveq	#0,d0
		moveq	#0,d1
		moveq	#0,d2
		moveq	#0,d4
		move.b	(a2)+,d0
		move.b	d0,d1
		lsr.b	#4,d1
		andi.b	#$F,d0
		move.b	d0,d2
		cmp.b	d0,d1
		beq.s	loc_7B196
		st	d4

loc_7B196:
		move.b	d0,d5
		lsl.b	#4,d5
		or.b	d0,d5
		move.b	(a2)+,d0
		move.b	d0,d1
		lsr.b	#4,d1
		tst.b	d4
		beq.s	loc_7B1AA
		moveq	#0,d0
		moveq	#0,d1

loc_7B1AA:
		andi.b	#$F,d0
		subi.b	#1,d0
		bpl.s	loc_7B1CC
		add.w	d2,d2
		adda.w	(a1,d2.w),a1
		move.b	(a1),d0
		move.b	1(a1,d1.w),d2
		bmi.s	loc_7B1E2

loc_7B1C2:

		andi.b	#$7F,d2
		move.b	d2,(a3)
		addi.b	#1,d1

loc_7B1CC:

		lsl.b	#4,d1
		or.b	d1,d0
		move.b	d0,-1(a2)
		move.b	d5,-2(a2)
		adda.w	#6,a3
		dbf	d6,sub_7B17A

locret_7B1E0:
		rts
; ---------------------------------------------------------------------------

loc_7B1E2:
		addq.b	#1,d2
		bne.s	loc_7B1F0
		move.b	#0,d1
		move.b	1(a1),d2
		bra.s	loc_7B1C2
; ---------------------------------------------------------------------------

loc_7B1F0:
		addq.b	#1,d2
		bne.s	loc_7B1FC
		addi.b	#2,$26(a0)
		rts
; ---------------------------------------------------------------------------

loc_7B1FC:
		addq.b	#1,d2
		bne.s	loc_7B20A
		andi.b	#-$10,d5
		or.b	2(a1,d1.w),d5
		bra.s	loc_7B1CC
; ---------------------------------------------------------------------------

loc_7B20A:
		addq.b	#1,d2
		bne.s	locret_7B21A
		moveq	#0,d3
		move.b	2(a1,d1.w),d1
		move.b	1(a1,d1.w),d2
		bra.s	loc_7B1C2
; ---------------------------------------------------------------------------

locret_7B21A:
		rts
; End of function sub_7B17A

; ---------------------------------------------------------------------------
Ani_SSZMTZOrbs:	include "Levels\SSZ\Misc Object Data\Anim - MTZOrbs.asm"

Pal_SSZMTZOrbs:	binclude "Levels\SSZ\Palettes\MTZOrbs.bin"

; ---------------------------------------------------------------------------

Obj_A3_2:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7B2B2(pc,d0.w),d1
		jsr	off_7B2B2(pc,d1.w)
		lea	sub_7D35A(pc),a4
		bsr.w	sub_7D312
		bsr.w	sub_7D2D8
		lea	DPLCPtr_7D4D6(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_7B2B2:	dc.w loc_7B2DC-off_7B2B2

		dc.w loc_7B3AC-off_7B2B2
		dc.w loc_7B3E6-off_7B2B2
		dc.w loc_7B416-off_7B2B2
		dc.w loc_7B44A-off_7B2B2
		dc.w loc_7B478-off_7B2B2
		dc.w loc_7B4DA-off_7B2B2
		dc.w loc_7B53E-off_7B2B2
		dc.w loc_7B5AC-off_7B2B2
		dc.w loc_7B53E-off_7B2B2
		dc.w loc_7B53E-off_7B2B2
		dc.w loc_7B63A-off_7B2B2
		dc.w loc_7B67C-off_7B2B2
		dc.w loc_7B6A0-off_7B2B2
		dc.w loc_7B6DA-off_7B2B2
		dc.w loc_7B6EE-off_7B2B2
		dc.w loc_7B748-off_7B2B2
		dc.w loc_7B77E-off_7B2B2
		dc.w loc_7B7BA-off_7B2B2
		dc.w loc_7B748-off_7B2B2
		dc.w loc_7B804-off_7B2B2
; ---------------------------------------------------------------------------

loc_7B2DC:
		lea	ObjDat4_7D3EA(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l
		move.b	#8,$29(a0)
		move.l	($FFFFFE0C).w,($FFFFF636).w
		tst.b	($FFFFFE11).w
		beq.s	loc_7B308
		move.w	#$220,$10(a0)
		move.w	#$4A0,$14(a0)
		bra.w	loc_7B35A
; ---------------------------------------------------------------------------

loc_7B308:
		move.b	#4,5(a0)
		move.b	#2,$22(a0)
		move.w	#-$800,$18(a0)
		bset	#2,$38(a0)
		lea	ChildObjDat_7D47A(pc),a2
		jsr	(CreateChild6_Simple).l
		move.w	($FFFFEE78).w,d0
		addi.w	#$20,d0
		move.w	d0,($FFFFFAB4).w
		addi.w	#$100,d0
		move.w	d0,($FFFFFAB6).w
		addi.w	#$40,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d0
		addi.w	#$30,d0
		move.w	d0,($FFFFFAB0).w
		addi.w	#$70,d0
		move.w	d0,$14(a0)

loc_7B35A:
		lea	(ArtKosM_MechaSonicExtra).l,a1
		move.w	#-$7C80,d2
		jsr	(Queue_Kos_Module).l
		lea	(PLC_83D64).l,a1
		jsr	(Load_PLC_Raw).l
		lea	(Pal_SSZGHZMisc).l,a1
		jsr	(PalLoad_Line1).l
		tst.b	($FFFFFE11).w
		bne.s	loc_7B39C
		jsr	(Create_New_Sprite).l
		bne.s	loc_7B39C
		move.l	#Obj_Song_Fade_Transition,(a1)
		move.b	#$19,$2C(a1)

loc_7B39C:

		lea	ChildObjDat_7D474(pc),a2
		jsr	(CreateChild6_Simple).l
		jmp	(Create_New_Sprite).l
; ---------------------------------------------------------------------------

loc_7B3AC:
		btst	#4,($FFFFFAB8).w
		beq.w	locret_7B448
		move.b	#$14,5(a0)
		move.b	#2,$3B(a0)
		move.w	($FFFFEE78).w,d0
		addi.w	#$20,d0
		move.w	d0,($FFFFFAB4).w
		addi.w	#$100,d0
		move.w	d0,($FFFFFAB6).w
		move.w	($FFFFEE7C).w,d0
		addi.w	#$30,d0
		move.w	d0,($FFFFFAB0).w
		bra.w	loc_7B57A
; ---------------------------------------------------------------------------

loc_7B3E6:
		jsr	(MoveSprite2).l
		move.w	($FFFFEE78).w,d0
		subi.w	#$20,d0
		cmp.w	$10(a0),d0
		bcs.s	locret_7B414
		move.b	#6,5(a0)
		bclr	#2,$38(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_7B41C,$34(a0)

locret_7B414:
		rts
; ---------------------------------------------------------------------------

loc_7B416:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7B41C:
		move.b	#8,5(a0)
		bset	#0,4(a0)
		move.w	($FFFFEE7C).w,d0
		addi.w	#$40,d0
		move.w	d0,$14(a0)
		move.w	#$400,$18(a0)
		move.b	#3,$22(a0)
		move.l	#byte_7D523,$30(a0)

locret_7B448:

		rts
; ---------------------------------------------------------------------------

loc_7B44A:
		jsr	(Animate_RawMultiDelay).l
		jsr	(MoveSprite2).l
		move.w	$10(a0),d0
		cmp.w	($FFFFFAB6).w,d0
		bcc.s	loc_7B462
		rts
; ---------------------------------------------------------------------------

loc_7B462:

		move.b	#$A,5(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_7B484,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7B478:
		jsr	(Animate_RawMultiDelay).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7B484:
		move.b	#$C,5(a0)
		move.b	#$1F,$1E(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		move.l	#loc_7B4EC,$34(a0)
		jsr	(Random_Number).l
		tst.w	d0
		bmi.s	loc_7B4CA
		bclr	#4,($FFFFFAB8).w
		bne.s	loc_7B4CA
		move.l	#byte_7D4DE,$30(a0)
		bclr	#3,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_7B4CA:

		move.l	#byte_7D4EF,$30(a0)
		bset	#3,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_7B4DA:
		jsr	(Animate_RawMultiDelay).l
		jsr	(MoveSprite_LightGravity).l
		jmp	(ObjHitFloor_DoRoutine).l
; ---------------------------------------------------------------------------

loc_7B4EC:
		move.b	#$E,5(a0)
		clr.w	$16(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		moveq	#-$6A,d0
		jsr	(Play_Sound_2).l
		btst	#3,$38(a0)
		bne.s	loc_7B520
		move.l	#byte_7D596,$30(a0)
		move.l	#loc_7B544,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7B520:
		bchg	#0,4(a0)
		move.b	#1,$22(a0)
		move.l	#byte_7D5A2,$30(a0)
		move.l	#loc_7B57A,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7B53E:
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_7B544:
		move.b	#$10,5(a0)
		move.w	#$820,d0
		move.w	#-$20,d1
		btst	#0,4(a0)
		beq.s	loc_7B55E
		neg.w	d0
		neg.w	d1

loc_7B55E:
		move.w	d0,$18(a0)
		move.w	d1,$40(a0)
		clr.w	$1A(a0)
		bset	#2,$38(a0)
		lea	ChildObjDat_7D486(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_7B57A:

		move.b	#$14,5(a0)
		move.l	#byte_7D541,$30(a0)
		move.l	#loc_7B5E8,$34(a0)
		move.w	($FFFFEE78).w,d0
		addi.w	#$A0,d0
		bset	#0,4(a0)
		cmp.w	$10(a0),d0
		bcc.s	locret_7B5AA
		bclr	#0,4(a0)

locret_7B5AA:
		rts
; ---------------------------------------------------------------------------

loc_7B5AC:
		move.w	$40(a0),d0
		add.w	d0,$18(a0)
		jsr	(MoveSprite2).l
		lea	loc_7B5C2(pc),a1
		bra.w	loc_7D216
; ---------------------------------------------------------------------------

loc_7B5C2:
		move.b	#$12,5(a0)
		move.w	d0,$10(a0)
		clr.w	$12(a0)
		bclr	#2,$38(a0)
		move.l	#byte_7D59B,$30(a0)
		move.l	#loc_7B57A,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7B5E8:
		move.b	#$F,$1E(a0)
		lea	byte_7D54A(pc),a1
		jsr	(Set_Raw_Animation).l
		move.w	#$200,d0
		btst	#0,4(a0)
		bne.s	loc_7B606
		neg.w	d0

loc_7B606:
		move.w	d0,$18(a0)
		move.w	#-$600,$1A(a0)
		move.b	$3B(a0),d0
		addq.b	#1,$3B(a0)
		andi.w	#7,d0
		moveq	#0,d1
		move.b	byte_7B62E(pc,d0.w),d1
		move.b	d1,$3A(a0)
		move.b	byte_7B636(pc,d1.w),5(a0)
		rts
; ---------------------------------------------------------------------------
byte_7B62E:	dc.b 0
		dc.b 1
		dc.b 2
		dc.b 0
		dc.b 1
		dc.b 2
		dc.b 0
		dc.b 1
byte_7B636:	dc.b $16
		dc.b $1A
		dc.b $1E
		dc.b 0
; ---------------------------------------------------------------------------

loc_7B63A:
		jsr	(Animate_RawMultiDelay).l
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bpl.s	loc_7B64E
		rts
; ---------------------------------------------------------------------------

loc_7B64E:
		move.b	#$18,5(a0)
		move.w	#$780,d0
		moveq	#-$20,d1
		btst	#0,4(a0)
		bne.s	loc_7B666
		neg.w	d0
		neg.w	d1

loc_7B666:
		move.w	d0,$18(a0)
		move.w	d1,$40(a0)
		clr.w	$1A(a0)
		moveq	#-$4A,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_7B67C:
		jsr	(Animate_RawMultiDelay).l
		move.w	$40(a0),d0
		add.w	d0,$18(a0)
		jsr	(MoveSprite2).l
		lea	loc_7B698(pc),a1
		bra.w	loc_7D216
; ---------------------------------------------------------------------------

loc_7B698:
		move.w	d0,$10(a0)
		bra.w	loc_7B462
; ---------------------------------------------------------------------------

loc_7B6A0:
		jsr	(Animate_RawMultiDelay).l
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.s	locret_7B6BE
		jsr	(ObjHitFloor).l
		tst.w	d1
		bmi.s	loc_7B6C0
		beq.s	loc_7B6C0

locret_7B6BE:
		rts
; ---------------------------------------------------------------------------

loc_7B6C0:

		add.w	d1,$14(a0)
		move.b	#$1C,5(a0)
		move.w	#-$900,$1A(a0)
		moveq	#$49,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_7B6DA:
		jsr	(Animate_RawMultiDelay).l
		jsr	(MoveSprite).l
		lea	loc_7B462(pc),a1
		bra.w	loc_7D216
; ---------------------------------------------------------------------------

loc_7B6EE:
		jsr	(Animate_RawMultiDelay).l
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.s	locret_7B70C
		jsr	(ObjHitFloor).l
		tst.w	d1
		bmi.s	loc_7B70E
		beq.s	loc_7B70E

locret_7B70C:

		rts
; ---------------------------------------------------------------------------

loc_7B70E:

		add.w	d1,$14(a0)
		move.b	#$20,5(a0)
		move.w	#$F,$2E(a0)
		move.l	#loc_7B754,$34(a0)
		bset	#2,$38(a0)
		moveq	#-$6A,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_7D480(pc),a2
		jsr	(CreateChild6_Simple).l
		bne.s	locret_7B70C
		move.b	#8,$2C(a1)
		rts
; ---------------------------------------------------------------------------

loc_7B748:
		jsr	(Animate_RawMultiDelay).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7B754:
		move.b	#$22,5(a0)
		move.w	#$100,d0
		tst.w	$18(a0)
		bmi.s	loc_7B766
		neg.w	d0

loc_7B766:
		move.w	d0,$18(a0)
		clr.w	$1A(a0)
		move.w	#7,$2E(a0)
		move.l	#loc_7B790,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7B77E:
		jsr	(Animate_RawMultiDelay).l
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7B790:
		move.b	#$24,5(a0)
		move.w	#$640,d0
		move.w	#-$20,d1
		tst.w	$18(a0)
		bmi.s	loc_7B7A8
		neg.w	d0
		neg.w	d1

loc_7B7A8:
		move.w	d0,$18(a0)
		move.w	d1,$40(a0)
		moveq	#-$4A,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_7B7BA:
		jsr	(Animate_RawMultiDelay).l
		move.w	$40(a0),d0
		add.w	d0,$18(a0)
		jsr	(MoveSprite2).l
		lea	loc_7B7D6(pc),a1
		bra.w	loc_7D216
; ---------------------------------------------------------------------------

loc_7B7D6:
		move.b	#$26,5(a0)
		move.w	#$F,$2E(a0)
		move.l	#loc_7B7EC,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7B7EC:
		move.b	#$28,5(a0)
		bclr	#2,$38(a0)
		clr.w	$18(a0)
		move.w	#-$640,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_7B804:
		jsr	(Animate_RawMultiDelay).l
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bpl.w	loc_7B462
		rts
; ---------------------------------------------------------------------------

loc_7B81A:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7B838(pc,d0.w),d1
		jsr	off_7B838(pc,d1.w)
		lea	DPLCPtr_7D4D6(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_7B838:	dc.w loc_7B852-off_7B838

		dc.w loc_7B87C-off_7B838
		dc.w loc_7B93E-off_7B838
		dc.w loc_7B972-off_7B838
		dc.w loc_7B984-off_7B838
		dc.w loc_7B9D2-off_7B838
		dc.w loc_7B9FA-off_7B838
		dc.w loc_7BA28-off_7B838
		dc.w loc_7BA90-off_7B838
		dc.w loc_7BABE-off_7B838
		dc.w loc_7BB06-off_7B838
		dc.w loc_7BBAC-off_7B838
		dc.w loc_7BBE0-off_7B838
; ---------------------------------------------------------------------------

loc_7B852:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7B858:
		move.b	#2,5(a0)
		move.b	#$E,$22(a0)
		move.b	#$1F,$1E(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		move.l	#loc_7B888,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7B87C:
		jsr	(MoveSprite_LightGravity).l
		jmp	(ObjHitFloor_DoRoutine).l
; ---------------------------------------------------------------------------

loc_7B888:
		move.b	#$23,$1E(a0)
		lea	byte_7D5E4(pc),a1
		jsr	(Set_Raw_Animation).l
		lea	(word_7D842).l,a1
		bsr.w	sub_7C678
		lea	ChildObjDat_7D48C(pc),a2
		jsr	(CreateChild6_Simple).l
		moveq	#-$6A,d0
		jsr	(Play_Sound_2).l
		tst.b	($FFFFFE11).w
		bne.s	loc_7B8E6
		move.b	#4,5(a0)
		st	($FFFFFAA8).w
		bset	#5,$38(a0)
		bclr	#3,$38(a0)
		move.w	#$77,$2E(a0)
		jsr	(Create_New_Sprite).l
		bne.s	locret_7B8E4
		move.l	#loc_7D056,(a1)

locret_7B8E4:
		rts
; ---------------------------------------------------------------------------

loc_7B8E6:
		btst	#7,$38(a0)
		bne.s	loc_7B916
		bset	#5,$38(a0)
		move.b	#8,5(a0)
		move.w	#$BF,$2E(a0)
		move.l	#loc_7B996,$34(a0)
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		st	($FFFFF7CB).w
		rts
; ---------------------------------------------------------------------------

loc_7B916:
		move.l	#loc_7BC32,(a0)
		clr.b	($FFFFFE1E).w
		move.w	#$BF,$2E(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_7B934
		move.l	#loc_8642E,(a1)

loc_7B934:
		lea	ChildObjDat_7D4D0(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_7B93E:
		jsr	(Run_PalRotationScript).l
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------
		jsr	(ObjHitFloor).l
		tst.w	d1
		bmi.w	locret_7B448
		beq.w	locret_7B448
		move.b	#6,5(a0)
		bset	#7,$A(a0)
		lea	(Pal_SSZGHZMisc).l,a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_7B972:
		tst.b	4(a0)
		bpl.s	loc_7B97E
		jmp	(MoveSprite).l
; ---------------------------------------------------------------------------

loc_7B97E:
		jmp	(Go_Delete_Sprite_2).l
; ---------------------------------------------------------------------------

loc_7B984:
		jsr	(Run_PalRotationScript).l
		jsr	(Animate_RawMultiDelay).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7B996:
		move.b	#$A,5(a0)
		move.b	#1,($FFFFFE1E).w
		clr.b	$2A(a0)
		clr.b	$38(a0)
		ori.b	#$50,$38(a0)
		moveq	#$1A,d0
		jsr	(Play_Sound).l
		lea	ChildObjDat_7D492(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	(ArtKosM_HPZMasterEmerald).l,a1
		move.w	#-$5A40,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

loc_7B9D2:
		btst	#6,$38(a0)
		bne.s	locret_7B9F8
		move.b	#$C,5(a0)
		lea	byte_7D5EF(pc),a1
		jsr	(Set_Raw_Animation).l
		move.b	#$E,$22(a0)
		move.l	#loc_7BA00,$34(a0)

locret_7B9F8:
		rts
; ---------------------------------------------------------------------------

loc_7B9FA:
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_7BA00:
		move.b	#$E,5(a0)
		move.w	#$3B,$2E(a0)
		bset	#2,$38(a0)
		lea	ChildObjDat_7D486(pc),a2
		btst	#0,4(a0)
		beq.s	loc_7BA22
		lea	ChildObjDat_7D47A(pc),a2

loc_7BA22:
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_7BA28:
		moveq	#-$55,d0
		jsr	(sub_85E52).l
		subq.w	#1,$2E(a0)
		bmi.s	loc_7BA38
		rts
; ---------------------------------------------------------------------------

loc_7BA38:
		move.b	#$10,5(a0)
		clr.w	($FFFFF602).w
		st	($FFFFF7CA).w
		lea	($FFFFB000).w,a1
		jsr	(Stop_Object).l
		move.w	($FFFFEE16).w,d0
		addi.w	#$140,d0
		move.w	d0,($FFFFEE16).w
		addi.w	#$100,d0
		move.w	d0,($FFFFFAB6).w
		move.w	#$600,$18(a0)
		clr.w	$1A(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_7BA80
		move.l	#loc_7C818,(a1)
		move.w	a1,$44(a0)

loc_7BA80:
		jsr	(Create_New_Sprite3).l
		bne.s	locret_7BA8E
		move.l	#loc_7C9E8,(a1)

locret_7BA8E:
		rts
; ---------------------------------------------------------------------------

loc_7BA90:
		jsr	(MoveSprite2).l
		move.w	($FFFFFAB6).w,d0
		subi.w	#$AA,d0
		cmp.w	$10(a0),d0
		bls.s	loc_7BAA6
		rts
; ---------------------------------------------------------------------------

loc_7BAA6:
		move.b	#$12,5(a0)
		move.l	#loc_7BAD0,$34(a0)
		lea	byte_7D5F6(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_7BABE:
		addi.w	#-$30,$18(a0)
		jsr	(MoveSprite2).l
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_7BAD0:
		move.b	#$14,5(a0)
		bclr	#2,$38(a0)
		move.w	#-$400,$1A(a0)
		move.b	#$4B,$1E(a0)
		move.l	#loc_7BB20,$34(a0)
		lea	byte_7D61A(pc),a1
		btst	#0,4(a0)
		beq.s	loc_7BB00
		lea	byte_7D60A(pc),a1

loc_7BB00:
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_7BB06:
		jsr	(Animate_RawMultiDelayFlipX).l
		jsr	(MoveSprite_LightGravity).l
		tst.w	$1A(a0)
		bmi.w	locret_7B448
		jmp	(ObjHitFloor_DoRoutine).l
; ---------------------------------------------------------------------------

loc_7BB20:
		move.w	($FFFFEE14).w,d0
		addi.w	#$A0,d0
		move.w	d0,($FFFFEE14).w
		addi.w	#$10,d0
		move.w	d0,($FFFFFA82).w
		addi.w	#$50,d0
		move.w	d0,($FFFFFA84).w
		addi.w	#$50,d0
		move.w	d0,($FFFFFA86).w
		addi.w	#$40,d0
		move.w	d0,($FFFFFA88).w
		addi.w	#$40,d0
		move.w	d0,($FFFFFA8A).w
		addi.w	#$50,d0
		move.w	d0,($FFFFFA8C).w
		addi.w	#$50,d0
		move.w	d0,($FFFFFA8E).w
		move.b	#$16,5(a0)
		move.l	#loc_7BBC6,$34(a0)
		lea	byte_7D5AB(pc),a1
		jsr	(Set_Raw_Animation).l

loc_7BB7C:
		clr.b	$38(a0)
		bset	#7,$38(a0)
		moveq	#-$6A,d0
		jsr	(Play_Sound_2).l
		lea	(word_7D9EA).l,a1
		bsr.w	sub_7C678
		lea	ChildObjDat_7D48C(pc),a2
		jsr	(CreateChild6_Simple).l
		bne.s	locret_7BBAA
		move.b	#8,$2C(a1)

locret_7BBAA:
		rts
; ---------------------------------------------------------------------------

loc_7BBAC:
		moveq	#-$5C,d0
		jsr	(sub_85E52).l
		jsr	(Run_PalRotationScript).l
		bchg	#6,($FFFFFAB8).w
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_7BBC6:
		move.b	#$18,5(a0)
		lea	($FFFFB000).w,a1
		clr.b	$2A(a1)
		clr.b	$3D(a1)
		move.w	#$782,$3E(a1)
		rts
; ---------------------------------------------------------------------------

loc_7BBE0:
		jsr	(Run_PalRotationScript).l
		bchg	#6,($FFFFFAB8).w
		move.w	#$808,($FFFFF602).w
		lea	($FFFFB000).w,a1
		move.w	$10(a1),d0
		move.w	($FFFFFA8A).w,d1
		addi.w	#$10,d1
		cmp.w	d1,d0
		bcs.w	locret_7B448
		clr.b	($FFFFEE0A).w
		clr.w	($FFFFEE24).w
		clr.w	($FFFFF602).w
		clr.b	($FFFFF7CA).w
		bsr.w	sub_7D150
		move.l	#Obj_SSZ2_Boss,(a0)
		move.b	#8,$29(a0)
		move.b	#$23,$28(a0)
		bra.w	loc_7BDD8
; ---------------------------------------------------------------------------

loc_7BC32:
		subq.w	#1,$2E(a0)
		bmi.s	loc_7BC3E
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7BC3E:
		move.l	#Obj_Wait,(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_7BC70,$34(a0)
		bclr	#7,4(a0)
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		addi.w	#$20,$14(a0)
		lea	ChildObjDat_7D4CA(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_7BC70:
		move.l	#loc_7BCB0,(a0)
		bset	#5,$38(a0)
		clr.w	$3A(a0)
		move.b	#4,$39(a0)
		lea	($FFFFFC00).w,a1
		lea	($FFFFFC80).w,a2
		moveq	#$1F,d6

loc_7BC90:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_7BC90
		jsr	(Create_New_Sprite).l
		bne.s	locret_7BCAE
		move.w	a1,$44(a0)
		move.l	#loc_85E64,(a1)
		move.w	#7,$3A(a1)

locret_7BCAE:
		rts
; ---------------------------------------------------------------------------

loc_7BCB0:
		bsr.w	sub_7BD30
		movea.w	$44(a0),a1
		btst	#7,$2A(a1)
		beq.w	locret_7B448
		move.l	#loc_7BCFC,(a0)
		move.w	#$77,$2E(a0)
		st	($FFFFFAA2).w
		st	($FFFFEEC5).w
		lea	($FFFFB000).w,a1
		move.b	#-$7D,$2E(a1)
		clr.b	$22(a1)
		bclr	#3,$2A(a1)
		clr.b	$40(a1)
		clr.b	$3D(a1)
		st	($FFFFEF56).w
		jmp	(SaveGame).l
; ---------------------------------------------------------------------------

loc_7BCFC:
		bsr.w	sub_7BD30
		subq.w	#1,$2E(a0)
		bpl.w	locret_7B448
		move.w	#3,($FFFFFF08).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_7BD1C
		move.l	#loc_5E6C0,(a1)

loc_7BD1C:
		jsr	(Create_New_Sprite).l
		bne.s	loc_7BD2A
		move.l	#loc_85EE6,(a1)

loc_7BD2A:
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_7BD30:

		subq.w	#1,$3A(a0)
		bpl.s	locret_7BD4A
		move.w	#$1F,$3A(a0)
		subq.b	#1,$39(a0)
		bmi.s	locret_7BD4A
		moveq	#$4E,d0
		jsr	(Play_Sound_2).l

locret_7BD4A:

		rts
; End of function sub_7BD30

; ---------------------------------------------------------------------------

Obj_SSZ2_Boss:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7BD76(pc,d0.w),d1
		jsr	off_7BD76(pc,d1.w)
		lea	loc_7D39E(pc),a4
		bsr.w	sub_7D312
		bsr.w	sub_7D2D8
		lea	DPLCPtr_7D4D6(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_7BD76:	dc.w loc_7BDBE-off_7BD76

		dc.w loc_7BDBE-off_7BD76
		dc.w loc_7BE0E-off_7BD76
		dc.w loc_7BE42-off_7BD76
		dc.w loc_7BE9C-off_7BD76
		dc.w loc_7BF28-off_7BD76
		dc.w loc_7BF5A-off_7BD76
		dc.w loc_7BFA0-off_7BD76
		dc.w loc_7C062-off_7BD76
		dc.w loc_7C11C-off_7BD76
		dc.w loc_7C144-off_7BD76
		dc.w loc_7C11C-off_7BD76
		dc.w loc_7C18C-off_7BD76
		dc.w loc_7C1D8-off_7BD76
		dc.w loc_7C1F2-off_7BD76
		dc.w loc_7C144-off_7BD76
		dc.w loc_7C250-off_7BD76
		dc.w loc_7C2A4-off_7BD76
		dc.w loc_7C2DC-off_7BD76
		dc.w loc_7C302-off_7BD76
		dc.w loc_7C328-off_7BD76
		dc.w loc_7C37A-off_7BD76
		dc.w loc_7C37A-off_7BD76
		dc.w loc_7C3F8-off_7BD76
		dc.w loc_7C430-off_7BD76
		dc.w loc_7C458-off_7BD76
		dc.w loc_7C49E-off_7BD76
		dc.w loc_7C4E0-off_7BD76
		dc.w loc_7C51C-off_7BD76
		dc.w loc_7C55E-off_7BD76
		dc.w loc_7C59A-off_7BD76
		dc.w loc_7C630-off_7BD76
		dc.w loc_7C64E-off_7BD76
		dc.w loc_7C65C-off_7BD76
		dc.w loc_7C684-off_7BD76
		dc.w loc_7C6F0-off_7BD76
; ---------------------------------------------------------------------------

loc_7BDBE:
		moveq	#-$5C,d0
		jsr	(sub_85E52).l
		jsr	(Run_PalRotationScript).l
		bchg	#6,($FFFFFAB8).w
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_7BDD8:

		move.b	#2,5(a0)
		bset	#6,$38(a0)
		move.l	#loc_7BDF6,$34(a0)
		lea	byte_7D5FF(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_7BDF6:
		move.b	#4,5(a0)
		clr.w	$18(a0)
		move.w	#-$480,$1A(a0)
		bclr	#6,($FFFFFAB8).w
		rts
; ---------------------------------------------------------------------------

loc_7BE0E:
		jsr	(Run_PalRotationScript).l
		jsr	(MoveSprite_LightGravity).l
		move.w	($FFFFFAB0).w,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_7BE26
		rts
; ---------------------------------------------------------------------------

loc_7BE26:
		move.w	d0,$14(a0)
		move.b	#6,5(a0)
		move.l	#loc_7BE4E,$34(a0)
		lea	byte_7D645(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_7BE42:
		jsr	(Run_PalRotationScript).l
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_7BE4E:
		move.b	#8,5(a0)
		clr.b	$39(a0)
		bclr	#1,$38(a0)
		lea	word_7DA60(pc),a1
		bsr.w	sub_7C678
		move.w	#$3F,$2E(a0)
		move.l	#loc_7BEA8,$34(a0)
		lea	($FFFFFC00).w,a1
		lea	($FFFFFC80).w,a2
		moveq	#$1F,d6

loc_7BE7E:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_7BE7E
		jsr	(Create_New_Sprite).l
		bne.s	loc_7BE92
		move.l	#loc_7D09C,(a1)

loc_7BE92:
		moveq	#-$61,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_7BE9C:
		jsr	(Run_PalRotationScript).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7BEA8:
		cmpi.b	#2,$29(a0)
		bls.s	loc_7BF0C

loc_7BEB0:

		move.w	$10(a0),d0
		move.w	($FFFFFA82).w,d1
		bclr	#0,4(a0)
		cmp.w	($FFFFFA88).w,d0
		bcc.s	loc_7BECE
		move.w	($FFFFFA8E).w,d1
		bset	#0,4(a0)

loc_7BECE:
		move.w	d1,$3C(a0)

loc_7BED2:
		move.b	#$A,5(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		move.w	#$80,d0
		btst	#0,4(a0)
		bne.s	loc_7BEEE
		neg.w	d0

loc_7BEEE:
		move.w	d0,$40(a0)
		lea	byte_7D652(pc),a1
		jsr	(Set_Raw_Animation).l
		bset	#6,$38(a0)
		lea	ChildObjDat_7D49A(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_7BF0C:
		move.b	#$3C,5(a0)
		move.b	#8,$22(a0)
		move.w	#$80,$2E(a0)
		move.b	#5,$39(a0)
		bra.w	loc_7C34C
; ---------------------------------------------------------------------------

loc_7BF28:
		jsr	(Run_PalRotationScript).l
		jsr	(Animate_RawMultiDelay).l
		move.w	$18(a0),d0
		add.w	$40(a0),d0
		move.w	d0,$18(a0)
		cmpi.w	#-$800,d0
		ble.s	loc_7BF52
		cmpi.w	#$800,d0
		bge.s	loc_7BF52
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_7BF52:

		move.b	#$C,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_7BF5A:
		jsr	(Run_PalRotationScript).l
		jsr	(MoveSprite2).l
		tst.w	$18(a0)
		bmi.s	loc_7BF7C
		move.w	$3C(a0),d0
		sub.w	$10(a0),d0
		cmpi.w	#$38,d0
		bcs.s	loc_7BF8C
		rts
; ---------------------------------------------------------------------------

loc_7BF7C:
		move.w	$10(a0),d0
		sub.w	$3C(a0),d0
		cmpi.w	#$38,d0
		bcs.s	loc_7BF8C
		rts
; ---------------------------------------------------------------------------

loc_7BF8C:

		move.b	#$E,5(a0)
		neg.w	$40(a0)
		lea	byte_7D626(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_7BFA0:
		jsr	(Run_PalRotationScript).l
		jsr	(Animate_RawMultiDelayFlipX).l
		move.w	$40(a0),d0
		add.w	d0,$18(a0)
		jsr	(MoveSprite2).l
		move.w	$3C(a0),d0
		tst.w	$18(a0)
		bmi.s	loc_7BFCC
		cmp.w	$10(a0),d0
		bls.s	loc_7BFD4
		rts
; ---------------------------------------------------------------------------

loc_7BFCC:
		cmp.w	$10(a0),d0
		bcc.s	loc_7BFD4
		rts
; ---------------------------------------------------------------------------

loc_7BFD4:

		move.b	#$10,5(a0)
		bclr	#6,$38(a0)
		btst	#1,$38(a0)
		bne.s	loc_7C008
		move.w	#7,$2E(a0)
		move.b	$39(a0),d0
		addq.b	#1,d0
		move.b	d0,$39(a0)
		cmpi.b	#2,d0
		bcc.s	loc_7C018

loc_7BFFE:
		move.l	#loc_7BEB0,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7C008:
		move.w	#$1F,$2E(a0)
		move.l	#loc_7C06E,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7C018:
		bsr.w	sub_7D1EA
		move.b	d2,$43(a0)
		move.w	$10(a0),d0
		cmp.w	($FFFFFA88).w,d0
		bcs.s	loc_7C02C
		not.b	d3

loc_7C02C:
		tst.b	d3
		bne.s	loc_7BFFE
		bset	#1,$38(a0)
		move.l	#loc_7BED2,$34(a0)
		move.b	locret_7C04E+1(pc,d2.w),$42(a0)
		add.w	d2,d2
		movea.w	word_7C054(pc,d2.w),a1
		move.w	(a1),$3C(a0)

locret_7C04E:
		rts
; ---------------------------------------------------------------------------
		dc.b 4
		dc.b 5
		dc.b 6
		dc.b 1
word_7C054:	dc.w $203
		dc.w $FA8A
		dc.w $FA8C
		dc.w $FA8E
		dc.w $FA82
		dc.w $FA84
		dc.w $FA86
; ---------------------------------------------------------------------------

loc_7C062:
		jsr	(Run_PalRotationScript).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7C06E:
		bsr.w	sub_7D1B6
		beq.s	loc_7C0B6
		move.b	#$12,5(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_7C12E,$34(a0)
		moveq	#$3C,d0
		jsr	(Play_Sound_2).l
		lea	($FFFFB000).w,a1
		moveq	#0,d0
		move.w	$10(a1),d0
		moveq	#0,d1
		move.w	($FFFFEE7C).w,d1
		addi.w	#$B0,d1
		moveq	#3,d5
		jsr	(sub_861D0).l
		lea	byte_7D52A(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_7C0B6:
		jsr	(Random_Number).l
		andi.b	#3,d0
		bne.s	loc_7C104
		move.b	#$1C,5(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		move.w	$10(a0),d0
		move.w	#-$80,d1
		cmp.w	($FFFFFA88).w,d0
		bcc.s	loc_7C0E0
		neg.w	d1

loc_7C0E0:
		move.w	d1,$40(a0)
		moveq	#-$60,d0
		jsr	(Play_Sound_2).l
		lea	byte_7D652(pc),a1
		jsr	(Set_Raw_Animation).l
		bset	#6,$38(a0)
		lea	ChildObjDat_7D49A(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_7C104:
		move.b	#$28,5(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		lea	byte_7D57C(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_7C11C:
		jsr	(Run_PalRotationScript).l
		jsr	(Animate_RawMultiDelay).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7C12E:
		move.b	#$14,5(a0)
		move.b	#$13,$1E(a0)
		move.l	#loc_7C15C,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7C144:
		jsr	(Run_PalRotationScript).l
		jsr	(Animate_RawMultiDelay).l
		jsr	(MoveSprite2).l
		jmp	(ObjHitFloor_DoRoutine).l
; ---------------------------------------------------------------------------

loc_7C15C:
		move.b	#$16,5(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_7C17A,$34(a0)
		moveq	#$5F,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_7C17A:
		move.b	#$18,5(a0)
		clr.w	$18(a0)
		move.w	#-$400,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_7C18C:
		jsr	(Run_PalRotationScript).l
		jsr	(Animate_RawMultiDelay).l
		jsr	(MoveSprite2).l
		move.w	($FFFFFAB0).w,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_7C1AA
		rts
; ---------------------------------------------------------------------------

loc_7C1AA:
		move.b	#$1A,5(a0)
		move.l	#loc_7C1E4,$34(a0)
		move.w	$10(a0),d0
		bclr	#0,4(a0)
		cmp.w	($FFFFFA88).w,d0
		bcc.s	loc_7C1CE
		bset	#0,4(a0)

loc_7C1CE:
		lea	byte_7D538(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_7C1D8:
		jsr	(Run_PalRotationScript).l
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_7C1E4:

		clr.b	$39(a0)
		bclr	#1,$38(a0)
		bra.w	loc_7BEB0
; ---------------------------------------------------------------------------

loc_7C1F2:
		jsr	(Run_PalRotationScript).l
		jsr	(Animate_RawMultiDelay).l
		move.w	$40(a0),d0
		add.w	d0,$18(a0)
		move.w	$1A(a0),d0
		addi.w	#$80,d0
		move.w	d0,$1A(a0)
		cmpi.w	#$800,d0
		bcs.s	loc_7C22C
		move.b	#$1E,5(a0)
		move.b	#$57,$1E(a0)
		move.l	#loc_7C232,$34(a0)

loc_7C22C:
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_7C232:
		move.b	#$20,5(a0)
		move.b	#$1F,$1E(a0)
		move.l	#loc_7C274,$34(a0)
		moveq	#-$6A,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_7C250:
		jsr	(Run_PalRotationScript).l
		jsr	(Animate_RawMultiDelay).l
		move.w	$1A(a0),d0
		addi.w	#-$80,d0
		move.w	d0,$1A(a0)
		jsr	(MoveSprite2).l
		jmp	(ObjHitFloor_DoRoutine).l
; ---------------------------------------------------------------------------

loc_7C274:
		move.b	#$22,5(a0)
		move.w	$40(a0),d0
		neg.w	d0
		asr.w	#1,d0
		move.w	d0,$40(a0)
		clr.w	$1A(a0)
		move.l	#loc_7C2BE,$34(a0)
		moveq	#-$6A,d0
		jsr	(Play_Sound_2).l
		lea	byte_7D556(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_7C2A4:
		jsr	(Run_PalRotationScript).l
		jsr	(Animate_RawMultiDelay).l
		move.w	$40(a0),d0
		add.w	d0,$18(a0)
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_7C2BE:
		move.b	#$24,5(a0)
		bclr	#6,$38(a0)
		move.l	#loc_7C2E8,$34(a0)
		lea	byte_7D561(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_7C2DC:
		jsr	(Run_PalRotationScript).l
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_7C2E8:
		move.b	#$26,5(a0)
		clr.w	$18(a0)
		move.w	#-$600,$1A(a0)
		lea	byte_7D56C(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_7C302:
		jsr	(Run_PalRotationScript).l
		jsr	(Animate_RawMultiDelayFlipX).l
		jsr	(MoveSprite_LightGravity).l
		move.w	($FFFFFAB0).w,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_7C320
		rts
; ---------------------------------------------------------------------------

loc_7C320:
		move.w	d0,$14(a0)
		bra.w	loc_7C1E4
; ---------------------------------------------------------------------------

loc_7C328:
		jsr	(Run_PalRotationScript).l
		jsr	(Animate_RawMultiDelayFlipX).l
		moveq	#$10,d1
		jsr	(MoveSprite_CustomGravity).l
		cmpi.w	#$100,$1A(a0)
		bcc.s	loc_7C346
		rts
; ---------------------------------------------------------------------------

loc_7C346:
		move.b	#$2A,5(a0)

loc_7C34C:
		move.w	#$100,d0
		move.w	d0,$3E(a0)
		move.w	d0,$1A(a0)
		move.w	#$10,$40(a0)
		bclr	#0,$38(a0)
		move.b	#3,$39(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_7C39E,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7C37A:
		jsr	(Run_PalRotationScript).l
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jsr	(Find_SonicTails).l
		jsr	(Change_FlipX).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7C39E:
		move.w	#$2F,$2E(a0)
		lea	ChildObjDat_7D4AE(pc),a2
		jsr	CreateChild1_Normal(pc)
		subq.b	#1,$39(a0)
		bpl.w	locret_7B448
		move.b	#8,$2C(a1)
		move.b	#$2C,5(a0)
		move.l	#loc_7C3CA,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7C3CA:
		move.b	#$2E,5(a0)
		move.b	#$1F,$1E(a0)
		move.l	#loc_7C410,$34(a0)
		bclr	#7,$38(a0)
		lea	(word_7DB66).l,a1
		bsr.w	sub_7C678
		lea	byte_7D508(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_7C3F8:
		jsr	(Run_PalRotationScript).l
		jsr	(Animate_RawMultiDelay).l
		jsr	(MoveSprite).l
		jmp	(ObjHitFloor_DoRoutine).l
; ---------------------------------------------------------------------------

loc_7C410:
		move.b	#$30,5(a0)
		move.l	#loc_7C436,$34(a0)
		moveq	#-$6A,d0
		jsr	(Play_Sound_2).l
		lea	byte_7D510(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_7C430:
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_7C436:
		move.b	#$32,5(a0)
		clr.b	$1A(a0)
		move.b	#$13,$1E(a0)
		move.l	#loc_7C46A,$34(a0)
		move.l	#byte_7D519,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_7C458:
		jsr	(Animate_RawMultiDelay).l
		jsr	(MoveSprite_LightGravity).l
		jmp	(ObjHitFloor_DoRoutine).l
; ---------------------------------------------------------------------------

loc_7C46A:
		move.b	#$34,5(a0)
		moveq	#-$6A,d0
		jsr	(Play_Sound_2).l
		bset	#0,4(a0)
		move.w	#$400,d0
		move.w	$10(a0),d1
		cmp.w	($FFFFFAB6).w,d1
		bcs.s	loc_7C494
		bclr	#0,4(a0)
		neg.w	d0

loc_7C494:
		move.w	d0,$18(a0)
		clr.w	$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_7C49E:
		jsr	(Animate_RawMultiDelay).l
		jsr	(MoveSprite2).l
		move.w	($FFFFFAB6).w,d0
		tst.w	$18(a0)
		bmi.s	loc_7C4BC
		cmp.w	$10(a0),d0
		bls.s	loc_7C4C4
		rts
; ---------------------------------------------------------------------------

loc_7C4BC:
		cmp.w	$10(a0),d0
		bcc.s	loc_7C4C4
		rts
; ---------------------------------------------------------------------------

loc_7C4C4:

		move.w	d0,$10(a0)
		move.b	#$36,5(a0)
		move.b	#$1F,$1E(a0)
		clr.w	$18(a0)
		move.w	#-$200,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_7C4E0:
		jsr	(Animate_RawMultiDelay).l
		jsr	(MoveSprite_LightGravity).l
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_7C4F8
		rts
; ---------------------------------------------------------------------------

loc_7C4F8:
		add.w	d1,$14(a0)
		move.b	#$38,5(a0)
		move.l	#loc_7C522,$34(a0)
		moveq	#-$6A,d0
		jsr	(Play_Sound_2).l
		lea	byte_7D5C1(pc),a1
		jmp	(Set_Raw_Animation).l
; ---------------------------------------------------------------------------

loc_7C51C:
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_7C522:
		move.b	#$3A,5(a0)
		move.w	#-$400,$1A(a0)
		move.b	#$4B,$1E(a0)
		move.l	#loc_7C578,$34(a0)
		bclr	#0,4(a0)
		bne.s	loc_7C54E
		move.l	#byte_7D61A,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_7C54E:
		move.b	#$C,$22(a0)
		move.l	#byte_7D5D8,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_7C55E:
		jsr	(Animate_RawMultiDelay).l
		jsr	(MoveSprite_LightGravity).l
		tst.w	$1A(a0)
		bmi.w	locret_7B448
		jmp	(ObjHitFloor_DoRoutine).l
; ---------------------------------------------------------------------------

loc_7C578:
		move.b	#0,5(a0)
		move.l	#loc_7BDD8,$34(a0)
		moveq	#-$6A,d0
		jsr	(Play_Sound_2).l
		lea	byte_7D5B6(pc),a1
		jsr	Set_Raw_Animation(pc)
		bra.w	loc_7BB7C
; ---------------------------------------------------------------------------

loc_7C59A:
		jsr	(Run_PalRotationScript).l
		subq.w	#1,$2E(a0)
		bmi.s	loc_7C61A
		jsr	(Swing_UpAndDown_Count).l
		bne.s	loc_7C5EA
		jsr	(MoveSprite2).l
		jsr	(Find_SonicTails).l
		move.w	#-$100,d1
		btst	#0,4(a0)
		beq.s	loc_7C5CA
		subq.w	#2,d0
		neg.w	d1

loc_7C5CA:
		tst.w	d0
		bne.s	loc_7C5D4
		move.w	d1,$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_7C5D4:
		move.b	#$3E,5(a0)
		move.l	#loc_7C646,$34(a0)
		lea	byte_7D636(pc),a1
		jmp	Set_Raw_Animation(pc)
; ---------------------------------------------------------------------------

loc_7C5EA:
		move.b	#$40,5(a0)
		bclr	#7,$38(a0)
		move.w	#$100,d0
		btst	#0,4(a0)
		bne.s	loc_7C604
		neg.w	d0

loc_7C604:
		move.w	d0,$18(a0)
		move.l	#loc_7C654,($FFFFFADA).w
		lea	(word_7DC7E).l,a1
		bra.w	sub_7C678
; ---------------------------------------------------------------------------

loc_7C61A:
		move.b	#$46,5(a0)
		move.l	#loc_7C718,$34(a0)
		lea	byte_7D587(pc),a1
		jmp	Set_Raw_Animation(pc)
; ---------------------------------------------------------------------------

loc_7C630:
		jsr	(Run_PalRotationScript).l
		jsr	Animate_RawMultiDelayFlipX(pc)
		jsr	(Swing_UpAndDown).l
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_7C646:
		move.b	#$3C,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_7C64E:
		jmp	(Run_PalRotationScript).l
; ---------------------------------------------------------------------------

loc_7C654:
		move.b	#$42,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_7C65C:
		jsr	(MoveSprite_LightGravity).l
		cmpi.w	#$400,$1A(a0)
		bge.s	loc_7C66C
		rts
; ---------------------------------------------------------------------------

loc_7C66C:
		move.b	#$44,5(a0)
		lea	(word_7DC06).l,a1

; =============== S U B R O U T I N E =======================================


sub_7C678:

		lea	($FFFFFADE).w,a2
		move.l	(a1)+,(a2)+
		move.l	(a1)+,(a2)+
		clr.w	(a2)
		rts
; End of function sub_7C678

; ---------------------------------------------------------------------------

loc_7C684:
		jsr	(Run_PalRotationScript).l
		bclr	#7,$38(a0)
		cmpi.l	#word_7DC10,($FFFFFAE2).w
		beq.s	loc_7C6A0
		bset	#7,$38(a0)

loc_7C6A0:
		move.w	$1A(a0),d0
		addi.w	#-$40,d0
		cmpi.w	#-$400,d0
		blt.s	loc_7C6B2
		move.w	d0,$1A(a0)

loc_7C6B2:
		jsr	(MoveSprite2).l
		move.w	($FFFFFAB0).w,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_7C6C4
		rts
; ---------------------------------------------------------------------------

loc_7C6C4:
		move.w	d0,$14(a0)
		move.b	#$3C,5(a0)
		move.b	#6,$39(a0)
		move.w	#$100,d0
		move.w	d0,$3E(a0)
		neg.w	d0
		move.w	d0,$1A(a0)
		move.w	#$10,$40(a0)
		bset	#0,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_7C6F0:
		jsr	(Run_PalRotationScript).l
		jsr	Animate_RawMultiDelay(pc)
		beq.w	locret_7B448
		cmpi.b	#8,$23(a0)
		bne.w	locret_7B448
		moveq	#-$68,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_7D4A8(pc),a2
		jmp	CreateChild6_Simple(pc)
; ---------------------------------------------------------------------------

loc_7C718:
		move.b	#$3C,5(a0)
		move.w	#$7F,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_7C726:
		lea	ObjDat3_7D444(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_7C738,(a0)
		bsr.w	sub_7D162

loc_7C738:
		jsr	(MoveSprite2).l
		jmp	(Sprite_CheckDeleteTouchXY).l
; ---------------------------------------------------------------------------

loc_7C744:
		lea	ObjDat3_7D438(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_7C756,(a0)
		bsr.w	sub_7D192

loc_7C756:
		jsr	Animate_Raw(pc)
		jsr	Refresh_ChildPositionAdjusted(pc)
		jmp	(Child_DrawTouch_Sprite).l
; ---------------------------------------------------------------------------

loc_7C764:
		move.l	#loc_7C77A,(a0)
		moveq	#$54,d0
		jsr	(Play_Sound_2).l
		moveq	#2,d5
		jmp	(loc_861C0).l
; ---------------------------------------------------------------------------

loc_7C77A:
		lea	byte_7D6A3(pc),a1
		jsr	Animate_RawNoSST(pc)
		jsr	(MoveSprite2).l
		jmp	(Sprite_CheckDeleteTouchXY).l
; ---------------------------------------------------------------------------

loc_7C78E:
		lea	ObjDat3_7D426(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_7C79C,(a0)

loc_7C79C:
		lea	byte_7D67B(pc),a1
		jsr	Animate_RawNoSST(pc)
		jsr	Refresh_ChildPositionAdjusted(pc)
		movea.w	$46(a0),a1
		btst	#6,$38(a1)
		beq.w	loc_7C8F8
		cmpi.b	#$12,$22(a1)
		bne.w	locret_7B448
		btst	#0,($FFFFFE0F).w
		lea	byte_7D4A2(pc),a2
		jsr	CreateChild6_Simple(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7C7D4:
		lea	word_7D432(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_7C80A,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		jsr	(Random_Number).l
		andi.w	#$1F,d0
		subi.w	#$F,d0
		add.w	d0,$10(a0)
		swap	d0
		andi.w	#$1F,d0
		subi.w	#$F,d0
		add.w	d0,$14(a0)

loc_7C80A:
		lea	byte_7D683(pc),a1
		jsr	Animate_RawNoSSTMultiDelay(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7C818:

		lea	ObjDat3_7D450(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.w	($FFFFEE16).w,d0
		addi.w	#$100,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d0
		addi.w	#$A8,d0
		move.w	d0,$14(a0)
		move.l	#loc_7C864,(a0)
		lea	($FFFFFFB2).w,a1
		moveq	#3,d0
		moveq	#6,d1

loc_7C846:
		cmp.b	(a1)+,d0
		bne.s	locret_7C854
		dbf	d1,loc_7C846
		move.l	#loc_7C856,(a0)

locret_7C854:
		rts
; ---------------------------------------------------------------------------

loc_7C856:
		lea	off_7DD5A(pc),a1
		lea	($FFFFFC5C).w,a2
		jsr	(Run_PalRotationScript2).l

loc_7C864:
		move.b	#0,$22(a0)
		btst	#6,($FFFFFAB8).w
		beq.s	loc_7C878
		move.b	#1,$22(a0)

loc_7C878:
		tst.b	($FFFFFAA2).w
		bne.w	loc_7C8F8
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7C886:
		lea	ObjDat3_7D41A(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		movea.w	$46(a0),a1
		btst	#2,4(a1)
		bne.s	loc_7C8A0
		bclr	#2,4(a0)

loc_7C8A0:
		move.l	#loc_7C8BA,(a0)
		move.l	#byte_7D668,$30(a0)
		move.l	#loc_7C8C4,$34(a0)
		jsr	Refresh_ChildPositionAdjusted(pc)

loc_7C8BA:
		jsr	Animate_RawMultiDelay(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7C8C4:
		move.l	#loc_7C8D6,(a0)
		movea.w	$46(a0),a1
		bclr	#6,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_7C8D6:
		move.b	#-7,$42(a0)
		move.b	#3,$43(a0)
		jsr	Refresh_ChildPositionAdjusted(pc)
		movea.w	$46(a0),a1
		cmpi.b	#$E,$22(a1)
		bne.s	loc_7C8F8
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7C8F8:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_7C8FE:
		addq.b	#4,$2C(a0)

loc_7C902:

		lea	ObjDat3_7D402(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_7C91C,(a0)
		bsr.w	sub_7D236
		moveq	#$3C,d0
		jsr	(Play_Sound_2).l

loc_7C91C:
		lea	byte_7D65F(pc),a1
		jsr	Animate_RawNoSSTMultiDelay(pc)
		jsr	Refresh_ChildPositionAdjusted(pc)
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_7C942
		btst	#2,$38(a1)
		beq.s	loc_7C942
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7C942:

		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

Obj_MetalSonic_Sparks:
		lea	ObjDat3_7D40E(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_7C964,(a0)
		bclr	#7,$2C(a0)
		beq.s	loc_7C964
		bclr	#2,4(a0)

loc_7C964:

		movea.w	$46(a0),a1
		btst	#6,$38(a1)
		bne.w	loc_7C8F8
		cmpi.w	#$E88,($FFFFFC32).w
		bne.w	locret_7B448
		moveq	#$5C,d0
		jsr	(Play_Sound_2).l
		moveq	#0,d0
		bchg	#0,$39(a0)
		bne.s	loc_7C990
		moveq	#4,d0

loc_7C990:
		add.b	$2C(a0),d0
		lea	word_7C9AA(pc,d0.w),a2
		move.w	(a2)+,$42(a0)
		move.b	(a2)+,$22(a0)
		jsr	Refresh_ChildPositionAdjusted(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
word_7C9AA:	dc.w $FC0C
		dc.b 4
		dc.w 0
		dc.b 8
		dc.w $500
		dc.b 8
		dc.w $406
		dc.b 0
		dc.w $804
		dc.b 7
		dc.b 0
; ---------------------------------------------------------------------------

loc_7C9BA:
		lea	word_7D3FC(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_7C9C8,(a0)

loc_7C9C8:
		bsr.w	sub_7D260
		jsr	Refresh_ChildPositionAdjusted(pc)
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_7C9E2
		jmp	(Add_SpriteToCollisionResponseList).l
; ---------------------------------------------------------------------------

loc_7C9E2:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_7C9E8:
		move.b	#1,($FFFFEE0A).w
		move.l	#loc_7C9F6,(a0)
		rts
; ---------------------------------------------------------------------------

loc_7C9F6:
		bsr.w	sub_7D150
		move.w	($FFFFEE78).w,d0
		move.w	$18(a0),d1
		move.w	($FFFFEE16).w,d2
		addq.w	#6,d0
		cmp.w	d2,d0
		bcc.s	loc_7CA12
		move.w	d0,($FFFFEE78).w
		rts
; ---------------------------------------------------------------------------

loc_7CA12:
		move.w	d2,($FFFFEE78).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_B2_2:
		move.l	#loc_7CA3A,(a0)
		move.w	($FFFFEE14).w,($FFFFEE16).w
		lea	PLC_7CA32(pc),a1
		jmp	(Load_PLC_Raw).l
; ---------------------------------------------------------------------------
PLC_7CA32:	dc.w 0
		dc.l ArtNem_RobotnikShip
		dc.w $A5C0
; ---------------------------------------------------------------------------

loc_7CA3A:
		lea	($FFFFB000).w,a1
		btst	#1,$2A(a1)
		beq.w	locret_7B448
		move.l	#loc_7CAAA,(a0)
		lea	(ObjDat3_664EE).l,a1
		jsr	SetUp_ObjAttributes(pc)
		move.w	#-$80,$18(a0)
		jsr	(Swing_Setup1).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_7CA78
		move.l	#Obj_Song_Fade_Transition,(a1)
		move.b	#$19,$2C(a1)

loc_7CA78:
		lea	(Child1_MakeRoboHead4).l,a2
		jsr	CreateChild1_Normal(pc)
		lea	ChildObjDat_7D4BC(pc),a2
		jsr	CreateChild1_Normal(pc)
		lea	(Child1_MakeRoboShipFlame).l,a2
		jsr	CreateChild1_Normal(pc)
		lea	(ArtKosM_KnuxFinalBossCrane).l,a1
		move.w	#$94E0,d2
		jsr	(Queue_Kos_Module).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7CAAA:
		jsr	Swing_UpAndDown(pc)
		jsr	(MoveSprite2).l
		cmpi.w	#$120,$10(a0)
		bcc.s	loc_7CACC
		move.l	#loc_7CAD2,(a0)
		clr.w	$18(a0)
		bset	#0,($FFFFFAB8).w

loc_7CACC:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7CAD2:
		btst	#1,($FFFFFAB8).w
		beq.s	loc_7CAE6
		move.l	#loc_7CAE6,(a0)
		move.w	#-$80,$18(a0)

loc_7CAE6:

		btst	#2,($FFFFFAB8).w
		beq.s	loc_7CAF8
		move.l	#loc_7CAF8,(a0)
		clr.w	$18(a0)

loc_7CAF8:

		btst	#3,($FFFFFAB8).w
		beq.s	loc_7CB18
		move.l	#loc_7CB28,(a0)
		move.w	#$80,$18(a0)
		bset	#0,4(a0)
		bclr	#0,($FFFFB004).w

loc_7CB18:
		jsr	Swing_UpAndDown(pc)
		jsr	(MoveSprite2).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7CB28:
		jsr	Swing_UpAndDown(pc)
		jsr	(MoveSprite2).l
		cmpi.w	#$120,$10(a0)
		bcs.s	loc_7CB5E
		move.l	#loc_7CB64,(a0)
		clr.w	$18(a0)
		move.w	#$3B,$2E(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_7CB5E
		move.l	#Obj_Song_Fade_Transition,(a1)
		move.b	#$30,$2C(a1)

loc_7CB5E:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7CB64:
		subq.w	#1,$2E(a0)
		bne.s	loc_7CB94
		move.l	#loc_7CBA4,(a0)
		st	($FFFFEE0A).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_7CB82
		move.l	#loc_7D11C,(a1)

loc_7CB82:
		jsr	(Create_New_Sprite).l
		bne.s	loc_7CB90
		move.l	#Obj_A3_2,(a1)

loc_7CB90:
		move.w	a1,($FFFFFAA4).w

loc_7CB94:
		jsr	Swing_UpAndDown(pc)
		jsr	(MoveSprite2).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7CBA4:
		movea.w	($FFFFFAA4).w,a1
		lea	word_7CC16(pc),a2
		jsr	(Check_InMyRange).l
		beq.s	loc_7CBCE
		move.l	#loc_7CBCE,(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_7CBC8
		move.l	#loc_7CC3A,(a1)

loc_7CBC8:
		bset	#5,($FFFFFAB8).w

loc_7CBCE:

		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		movea.w	($FFFFFAA4).w,a1
		lea	word_7CC1E(pc),a2
		jsr	(Check_InMyRange).l
		beq.s	loc_7CC10
		move.l	#Wait_Draw,(a0)
		move.w	#$80,8(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_7CC26,$34(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l

loc_7CC10:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
word_7CC16:	dc.w  $FFE0,   $40,	0,   $78
word_7CC1E:	dc.w  $FFE0,   $40,	0,   $30
; ---------------------------------------------------------------------------

loc_7CC26:
		lea	word_7D4C4(pc),a2
		jsr	CreateChild6_Simple(pc)
		ori.b	#$30,$38(a0)
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_7CC3A:
		move.l	#loc_7CC68,(a0)
		lea	($FFFFB000).w,a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		move.b	#-$40,$22(a1)
		move.w	#$400,$18(a0)
		move.w	#$80,$1A(a0)
		jsr	(Player_Load_PLC).l

loc_7CC68:
		jsr	(MoveSprite2).l
		lea	($FFFFB000).w,a1
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	$10(a0),d0
		cmp.w	($FFFFFAB6).w,d0
		bcs.w	locret_7B448
		move.l	#loc_7CCB0,(a0)
		move.w	#6,$2E(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		move.b	#$13,$1E(a0)
		move.b	#-$36,$22(a1)
		jmp	(Player_Load_PLC).l
; ---------------------------------------------------------------------------

loc_7CCB0:
		subq.w	#1,$2E(a0)
		bne.s	loc_7CCC6
		lea	($FFFFB000).w,a1
		move.b	#-$35,$22(a1)
		jsr	(Player_Load_PLC).l

loc_7CCC6:
		jsr	(MoveSprite).l
		lea	($FFFFB000).w,a1
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.w	locret_7B448
		lea	($FFFFB000).w,a1
		add.w	d1,$14(a1)
		clr.b	$2E(a1)
		jsr	Stop_Object(pc)
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_7CCFE:
		lea	(ObjDat3_664FA).l,a1
		jsr	(SetUp_ObjAttributes).l
		move.w	#0,8(a0)
		move.l	#loc_7CD22,(a0)
		lea	(ChildObjDat_66610).l,a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_7CD22:
		btst	#0,($FFFFFAB8).w
		bne.s	loc_7CD36
		jsr	(Refresh_ChildPositionAdjusted).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7CD36:
		move.l	#loc_7CD42,(a0)
		move.b	$43(a0),$3A(a0)

loc_7CD42:
		lea	($FFFFB000).w,a1
		move.w	$14(a1),d0
		subi.w	#$10,d0
		cmp.w	$14(a0),d0
		bls.s	loc_7CD76
		move.b	$1A(a0),d0
		addi.b	#1,d0
		move.b	d0,$1A(a0)
		move.b	$3A(a0),d1
		add.b	d0,d1
		move.b	d1,$43(a0)
		jsr	(Refresh_ChildPositionAdjusted).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7CD76:
		move.l	#loc_7CD82,(a0)
		bset	#1,($FFFFFAB8).w

loc_7CD82:
		move.b	$3A(a0),d0
		ext.w	d0
		movea.w	$46(a0),a1
		move.w	$14(a1),d1
		add.w	d0,d1
		lea	($FFFFB000).w,a1
		move.w	$14(a1),d2
		subi.w	#$10,d2
		sub.w	d1,d2
		bpl.s	loc_7CDA4
		moveq	#0,d2

loc_7CDA4:
		move.b	d2,$1A(a0)
		add.b	d2,d0
		bpl.s	loc_7CDB0
		move.b	#$7F,d0

loc_7CDB0:
		move.b	d0,$43(a0)
		move.w	$10(a0),d0
		cmpi.w	#8,d0
		bls.s	loc_7CDD2
		move.w	$10(a1),d1
		subi.w	#$C,d0
		cmp.w	d0,d1
		bcs.s	loc_7CE12
		addi.w	#$18,d0
		cmp.w	d0,d1
		bcc.s	loc_7CE12

loc_7CDD2:
		move.l	#loc_7CE1E,(a0)
		bset	#2,($FFFFFAB8).w
		move.b	#2,$22(a0)
		move.b	#-$7D,$2E(a1)
		move.b	#-$35,$22(a1)
		bset	#0,4(a1)
		bclr	#3,$2A(a1)
		clr.b	$40(a1)
		clr.b	$3D(a1)
		jsr	(Player_Load_PLC).l
		moveq	#$4A,d0
		jsr	(Play_Sound_2).l

loc_7CE12:

		jsr	(Refresh_ChildPositionAdjusted).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7CE1E:
		move.b	$1A(a0),d0
		subq.b	#1,d0
		bpl.s	loc_7CE34
		move.l	#loc_7CE42,(a0)
		bset	#3,($FFFFFAB8).w
		moveq	#0,d0

loc_7CE34:
		move.b	d0,$1A(a0)
		move.b	$3A(a0),d1
		add.b	d0,d1
		move.b	d1,$43(a0)

loc_7CE42:
		jsr	(Refresh_ChildPositionAdjusted).l
		btst	#5,($FFFFFAB8).w
		bne.s	loc_7CE66
		lea	($FFFFB000).w,a1
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),d0
		addi.w	#$16,d0
		move.w	d0,$14(a1)

loc_7CE66:
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7CE6C:
		lea	ObjDat3_7D45C(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#Obj_FlickerMove,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		move.b	d0,$22(a0)
		moveq	#8,d0
		jmp	(Set_IndexedVelocity).l
; ---------------------------------------------------------------------------

loc_7CE90:
		lea	ObjDat3_7D468(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_7CF02,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lea	byte_7CEE2(pc,d0.w),a1
		move.b	(a1)+,d1
		ext.w	d1
		movea.w	$46(a0),a2
		btst	#0,4(a2)
		beq.s	loc_7CEC2
		neg.w	d2
		bset	#0,4(a0)

loc_7CEC2:
		add.w	d1,$10(a0)
		move.b	(a1)+,d2
		ext.w	d2
		add.w	d2,$14(a0)
		asl.w	#5,d1
		move.w	d1,$18(a0)
		asl.w	#4,d2
		move.w	d2,$1A(a0)
		lsr.w	#1,d0
		move.b	d0,$22(a0)
		rts
; ---------------------------------------------------------------------------
byte_7CEE2:	dc.b  $EC, $DC
		dc.b  $F4, $D8
		dc.b  $F4, $E8
		dc.b  $FC, $D8
		dc.b  $FC, $E8
		dc.b	4, $D8
		dc.b	4, $E8
		dc.b   $C, $D8
		dc.b   $C, $E8
		dc.b  $14, $E0
		dc.b  $14, $F0
		dc.b  $EC, $FC
		dc.b  $F4, $F8
		dc.b  $FC, $F8
		dc.b	4, $F8
		dc.b   $C, $F8
; ---------------------------------------------------------------------------

loc_7CF02:
		tst.b	($FFFFFAA2).w
		bne.s	loc_7CF0E
		jmp	(Obj_FlickerMove).l
; ---------------------------------------------------------------------------

loc_7CF0E:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_7CF14:
		move.b	$2C(a0),d0
		subq.b	#2,d0
		bpl.s	loc_7CF4E
		move.w	($FFFFEE78).w,d0
		addi.w	#$A0,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d0
		addi.w	#$D0,d0
		move.w	d0,$14(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_7CF48
		move.b	#$C,$2C(a1)

loc_7CF48:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_7CF4E:
		move.l	#loc_7CF7C,(a0)
		addi.w	#$30,$14(a0)
		moveq	#2,d1
		tst.b	d0
		bne.s	loc_7CF62
		neg.w	d1

loc_7CF62:
		move.w	d1,$18(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	locret_7CF7A
		move.b	#$1E,$2C(a1)

locret_7CF7A:
		rts
; ---------------------------------------------------------------------------

loc_7CF7C:
		move.w	$18(a0),d0
		move.w	$10(a0),d1
		add.w	d0,d1
		move.w	d1,$10(a0)
		move.w	($FFFFEE78).w,d0
		subi.w	#$10,d0
		cmp.w	d0,d1
		bcs.w	loc_7C8F8
		addi.w	#$160,d0
		cmp.w	d0,d1
		bhi.w	loc_7C8F8
		rts
; ---------------------------------------------------------------------------

Obj_Difficulty_7CFA4:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7CFC2(pc,d0.w),d1
		jsr	off_7CFC2(pc,d1.w)
		lea	DPLCPtr_7D4D6(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_7CFC2:	dc.w loc_7CFC6-off_7CFC2

		dc.w locret_7CFEE-off_7CFC2
; ---------------------------------------------------------------------------

loc_7CFC6:
		lea	ObjDat4_7D3EA(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l
		move.w	#$43F4,$A(a0)
		bclr	#2,4(a0)
		bset	#0,4(a0)
		move.w	#$D8,$10(a0)
		move.w	#$104,$14(a0)

locret_7CFEE:
		rts
; ---------------------------------------------------------------------------

Obj_Difficulty_7CFF0:
		move.l	#Map_SSZMasterEmerald,$C(a0)
		move.w	#$61EE,$A(a0)
		move.w	#$280,8(a0)
		move.b	#$20,7(a0)
		move.b	#$18,6(a0)
		move.b	#2,$22(a0)
		move.w	#$120,$10(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_7D03E(pc,d0.w),$14(a0)
		move.l	#loc_7D042,(a0)
		cmpi.b	#7,($FFFFFFB1).w
		beq.s	locret_7D03C
		move.l	#loc_7D050,(a0)

locret_7D03C:
		rts
; ---------------------------------------------------------------------------
word_7D03E:	dc.w $F0
		dc.w $120
; ---------------------------------------------------------------------------

loc_7D042:
		lea	off_7DD5A(pc),a1
		lea	($FFFFFC7C).w,a2
		jsr	(Run_PalRotationScript2).l

loc_7D050:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7D056:
		move.l	#loc_7D062,(a0)
		move.w	#$77,$2E(a0)

loc_7D062:
		moveq	#2,d0
		jsr	(sub_868F8).l
		tst.b	5(a0)
		beq.s	locret_7D076
		move.l	#loc_7D078,(a0)

locret_7D076:
		rts
; ---------------------------------------------------------------------------

loc_7D078:
		jsr	(Check_TailsEndPose).l
		tst.b	($FFFFFAA8).w
		bne.w	locret_7B448
		jsr	(Restore_PlayerControl).l
		lea	($FFFFB04A).w,a1
		jsr	(Restore_PlayerControl2).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_7D09C:
		move.b	#2,$39(a0)
		move.l	#loc_7D0A8,(a0)

loc_7D0A8:
		subq.w	#1,$2E(a0)
		bpl.s	locret_7D0CA
		move.w	#5,$2E(a0)
		lea	($FFFFFC00).w,a1
		moveq	#$3F,d0

loc_7D0BA:
		jsr	(sub_85EB4).l
		dbf	d0,loc_7D0BA
		subq.b	#1,$39(a0)
		bmi.s	loc_7D0CC

locret_7D0CA:

		rts
; ---------------------------------------------------------------------------

loc_7D0CC:
		move.l	#loc_7D0E0,(a0)
		move.b	#2,$39(a0)
		move.w	#$1D,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_7D0E0:
		subq.w	#1,$2E(a0)
		bpl.s	locret_7D0CA
		move.w	#3,$2E(a0)
		lea	($FFFFFC00).w,a1
		lea	($FFFFFC80).w,a2
		moveq	#$3F,d0

loc_7D0F6:
		jsr	(sub_85F2A).l
		dbf	d0,loc_7D0F6
		subq.b	#1,$39(a0)
		bpl.s	locret_7D0CA
		lea	($FFFFFC80).w,a1
		lea	($FFFFFC00).w,a2
		moveq	#$1F,d6

loc_7D110:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_7D110
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_7D11C:
		move.w	#$100,d0
		cmp.w	($FFFFEE78).w,d0
		bls.s	loc_7D134
		addq.w	#1,($FFFFEE78).w
		addq.w	#1,($FFFFEE14).w
		addq.w	#1,($FFFFEE16).w
		rts
; ---------------------------------------------------------------------------

loc_7D134:
		move.w	d0,($FFFFEE78).w
		move.w	d0,($FFFFEE14).w
		move.w	d0,($FFFFEE16).w
		clr.b	($FFFFEE0A).w
		bset	#4,($FFFFFAB8).w
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_7D150:

		lea	($FFFFB000).w,a1
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		rts
; End of function sub_7D150


; =============== S U B R O U T I N E =======================================


sub_7D162:
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		move.l	word_7D172(pc,d0.w),$18(a0)
		rts
; End of function sub_7D162

; ---------------------------------------------------------------------------
word_7D172:	dc.w	  0,  $400
		dc.w   $2D4,  $2D4
		dc.w   $400,	 0
		dc.w   $2D4, $FD2C
		dc.w	  0, $FC00
		dc.w  $FD2C, $FD2C
		dc.w  $FC00,	 0
		dc.w  $FD2C,  $2D4

; =============== S U B R O U T I N E =======================================


sub_7D192:
		moveq	#0,d0
		move.b	$2C(a0),d0
		lea	off_7D1A6(pc,d0.w),a1
		move.l	(a1)+,$30(a0)
		move.l	(a1)+,$34(a0)
		rts
; End of function sub_7D192

; ---------------------------------------------------------------------------
off_7D1A6:	dc.l byte_7D68C
		dc.l loc_7C764
		dc.l byte_7D6B3
		dc.l Go_Delete_Sprite

; =============== S U B R O U T I N E =======================================


sub_7D1B6:
		bsr.w	sub_7D1EA
		moveq	#0,d0
		move.b	$42(a0),d0
		lsl.w	#2,d0
		lea	loc_7D1CE(pc,d0.w),a1

loc_7D1C6:
		move.b	(a1)+,d1
		beq.s	locret_7D1D0
		cmp.b	d1,d2
		bne.s	loc_7D1C6

loc_7D1CE:
		moveq	#1,d0

locret_7D1D0:
		rts
; End of function sub_7D1B6

; ---------------------------------------------------------------------------
		dc.b 1
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 1
		dc.b 2
		dc.b 0
		dc.b 0
		dc.b 1
		dc.b 2
		dc.b 3
		dc.b 0
		dc.b 4
		dc.b 5
		dc.b 6
		dc.b 0
		dc.b 5
		dc.b 6
		dc.b 0
		dc.b 0
		dc.b 6
		dc.b 0
		dc.b 0
		dc.b 0

; =============== S U B R O U T I N E =======================================


sub_7D1EA:
		move.w	($FFFFB010).w,d0
		sub.w	($FFFFEE14).w,d0
		move.w	d0,d1
		subi.w	#$F0,d1
		scc	d3
		bcc.s	loc_7D202
		moveq	#1,d2
		bra.w	loc_7D204
; ---------------------------------------------------------------------------

loc_7D202:
		moveq	#4,d2

loc_7D204:
		cmpi.w	#$50,d0
		bcs.s	locret_7D214
		addq.w	#1,d2
		cmpi.w	#$A0,d0
		bcs.s	locret_7D214
		addq.w	#1,d2

locret_7D214:

		rts
; End of function sub_7D1EA

; ---------------------------------------------------------------------------

loc_7D216:

		tst.w	$18(a0)
		bmi.s	loc_7D228
		move.w	($FFFFFAB6).w,d0
		cmp.w	$10(a0),d0
		bls.s	loc_7D234
		rts
; ---------------------------------------------------------------------------

loc_7D228:
		move.w	($FFFFFAB4).w,d0
		cmp.w	$10(a0),d0
		bcc.s	loc_7D234
		rts
; ---------------------------------------------------------------------------

loc_7D234:

		jmp	(a1)

; =============== S U B R O U T I N E =======================================


sub_7D236:
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		lea	word_7D24C(pc,d0.w),a1
		move.w	(a1)+,$42(a0)
		move.w	(a1)+,8(a0)
		rts
; End of function sub_7D236

; ---------------------------------------------------------------------------
word_7D24C:	dc.w  $FC1C,  $300
		dc.w   $81C,  $200
		dc.w  $F81C,  $200
		dc.w   $41C,  $300
		dc.w   $C0C,  $200

; =============== S U B R O U T I N E =======================================


sub_7D260:
		lea	word_7D280(pc),a1
		movea.w	$46(a0),a2
		moveq	#0,d0
		move.b	$22(a2),d0
		lsl.w	#2,d0
		adda.w	d0,a1
		move.w	(a1)+,$42(a0)
		move.b	(a1)+,$28(a0)
		move.b	(a1)+,$22(a0)
		rts
; End of function sub_7D260

; ---------------------------------------------------------------------------
word_7D280:	dc.w $10F4
		dc.b $B4
		dc.b 2
		dc.w $10FC
		dc.b $B4
		dc.b 2
		dc.w $1000
		dc.b $B4
		dc.b 2
		dc.w 0
		dc.b 0
		dc.b 0
		dc.w 0
		dc.b 0
		dc.b 0
		dc.w 0
		dc.b 0
		dc.b 0
		dc.w 0
		dc.b 0
		dc.b 0
		dc.w $14F8
		dc.b $9E
		dc.b 1
		dc.w $10F4
		dc.b $9E
		dc.b 1
		dc.w $CEC
		dc.b $98
		dc.b 0
		dc.w $EC
		dc.b $B3
		dc.b 8
		dc.w $F4EC
		dc.b $98
		dc.b 0
		dc.w $F0F4
		dc.b $B4
		dc.b 2
		dc.w $10F4
		dc.b $B4
		dc.b 2
		dc.w $1004
		dc.b $B4
		dc.b 2
		dc.w $140C
		dc.b $B4
		dc.b 2
		dc.w $1705
		dc.b $B4
		dc.b 2
		dc.w $10F4
		dc.b $B4
		dc.b 2
		dc.w $CF4
		dc.b $9E
		dc.b 1
		dc.w $10F4
		dc.b $B4
		dc.b 2
		dc.w $10F4
		dc.b $B4
		dc.b 2
		dc.w $10F4
		dc.b $B4
		dc.b 2

; =============== S U B R O U T I N E =======================================


sub_7D2D8:

		btst	#6,$2A(a0)
		bne.s	locret_7D2FA
		moveq	#0,d0
		move.b	$22(a0),d0
		move.b	byte_7D2FC(pc,d0.w),d0
		btst	#7,$38(a0)
		beq.s	loc_7D2F6
		ori.b	#-$80,d0

loc_7D2F6:
		move.b	d0,$28(a0)

locret_7D2FA:
		rts
; End of function sub_7D2D8

; ---------------------------------------------------------------------------
byte_7D2FC:	dc.b $23
		dc.b $23
		dc.b 9
		dc.b $86
		dc.b $86
		dc.b $86
		dc.b $86
		dc.b $1A
		dc.b $23
		dc.b $23
		dc.b $23
		dc.b $23
		dc.b $23
		dc.b $23
		dc.b 9
		dc.b 0
		dc.b 9
		dc.b $23
		dc.b 6
		dc.b $23
		dc.b $23
		dc.b $23

; =============== S U B R O U T I N E =======================================


sub_7D312:

		tst.b	$28(a0)
		bne.s	locret_7D356
		move.b	$29(a0),d0
		beq.s	loc_7D358
		tst.b	$20(a0)
		bne.s	loc_7D338
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		bset	#6,$2A(a0)

loc_7D338:
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_7D346
		addi.w	#8,d0

loc_7D346:
		bsr.w	sub_7D3BE
		subq.b	#1,$20(a0)
		bne.s	locret_7D356
		bclr	#6,$2A(a0)

locret_7D356:

		rts
; ---------------------------------------------------------------------------

loc_7D358:
		jmp	(a4)
; End of function sub_7D312


; =============== S U B R O U T I N E =======================================


sub_7D35A:

		move.l	#loc_7B81A,(a0)
		clr.b	5(a0)
		move.l	#loc_7B858,$34(a0)
		bset	#6,$2A(a0)
		clr.b	($FFFFFE1E).w
		move.w	#$7F,$2E(a0)
		moveq	#$64,d0
		jsr	(HUD_AddToScore).l
		bclr	#7,4(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	CreateChild1_Normal(pc)
		bne.s	locret_7D39C
		move.b	#4,$2C(a1)

locret_7D39C:
		rts
; End of function sub_7D35A

; ---------------------------------------------------------------------------

loc_7D39E:
		bset	#7,$38(a0)
		bsr.s	sub_7D35A
		move.w	($FFFFEE78).w,d0
		move.w	d0,($FFFFEE14).w
		move.w	d0,($FFFFEE16).w
		lea	(Pal_SSZGHZMisc).l,a1
		jmp	(PalLoad_Line1).l

; =============== S U B R O U T I N E =======================================


sub_7D3BE:
		lea	word_7D3CC(pc),a1
		lea	word_7D3D6(pc,d0.w),a2
		jmp	(CopyWordData_5).l
; End of function sub_7D3BE

; ---------------------------------------------------------------------------
word_7D3CC:	dc.w $FC28
		dc.w $FC34
		dc.w $FC36
		dc.w $FC38
		dc.w $FC3C
word_7D3D6:	dc.w 8
		dc.w $A24
		dc.w $624
		dc.w $422
		dc.w $20
		dc.w $888
		dc.w $666
		dc.w $888
		dc.w $AAA
		dc.w $EEE
ObjDat4_7D3EA:	dc.w 2

		dc.w $A3F4
		dc.w $28
		dc.w 0
		dc.l Map_MechaSonic
		dc.w $280
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b $23
word_7D3FC:	dc.w $80
		dc.b $10
		dc.b $10
		dc.b 0
		dc.b 0
ObjDat3_7D402:	dc.l Map_MechaSonicExtra
		dc.w $841C
		dc.w $200
		dc.b $C
		dc.b 4
		dc.b 0
		dc.b 0
ObjDat3_7D40E:	dc.l Map_MechaSonicExtra
		dc.w $A41C
		dc.w $200
		dc.b $14
		dc.b $10
		dc.b 4
		dc.b 0
ObjDat3_7D41A:	dc.l Map_MechaSonicExtra
		dc.w $A41C
		dc.w $200
		dc.b 4
		dc.b 4
		dc.b $11
		dc.b 0
ObjDat3_7D426:	dc.l Map_MechaSonicExtra
		dc.w $A41C
		dc.w $280
		dc.b $18
		dc.b $18
		dc.b 8
		dc.b 0
word_7D432:	dc.w $280
		dc.b 4
		dc.b 4
		dc.b 8
		dc.b 0
ObjDat3_7D438:	dc.l Map_MechaSonicExtra
		dc.w $A41C
		dc.w $200
		dc.b $18
		dc.b $18
		dc.b $A
		dc.b $86
ObjDat3_7D444:	dc.l Map_MechaSonicExtra
		dc.w $A41C
		dc.w $280
		dc.b 8
		dc.b 8
		dc.b $15
		dc.b $87
ObjDat3_7D450:	dc.l Map_SSZMasterEmerald

		dc.w $852E
		dc.w $300
		dc.b $20
		dc.b $18
		dc.b 0
		dc.b 0
ObjDat3_7D45C:	dc.l Map_RoboshipPieces
		dc.w $852E
		dc.w 0
		dc.b $1C
		dc.b $20
		dc.b 0
		dc.b 0
ObjDat3_7D468:	dc.l Map_MechaSonicPieces
		dc.w $A3F4
		dc.w 0
		dc.b 4
		dc.b 8
		dc.b 0
		dc.b 0
ChildObjDat_7D474:dc.w 0
		dc.l loc_7C9BA
ChildObjDat_7D47A:dc.w 1

		dc.l loc_7C902
ChildObjDat_7D480:dc.b 0
		dc.b 0
		dc.l loc_7C902
ChildObjDat_7D486:dc.w 1

		dc.l loc_7C8FE
ChildObjDat_7D48C:dc.w 0

		dc.l Obj_MetalSonic_Sparks
ChildObjDat_7D492:dc.w 0

		dc.l loc_7C886
		dc.b $FC
		dc.b $C
ChildObjDat_7D49A:dc.w 0

		dc.l loc_7C78E
		dc.w $14FC
byte_7D4A2:	dc.b 0
		dc.b 0
		dc.l loc_7C7D4
ChildObjDat_7D4A8:dc.w 7
		dc.l loc_7C726
ChildObjDat_7D4AE:dc.b 0
		dc.b 0
		dc.l loc_7C744
		dc.w $F9F8
		dc.w 0
		dc.l loc_7C818
ChildObjDat_7D4BC:dc.w 0
		dc.l loc_7CCFE
		dc.w $23
word_7D4C4:	dc.w 3
		dc.l loc_7CE6C
ChildObjDat_7D4CA:dc.w $F
		dc.l loc_7CE90
ChildObjDat_7D4D0:dc.b 0
		dc.b 2
		dc.l loc_7CF14
DPLCPtr_7D4D6:	dc.l ArtUnc_MechaSonic

		dc.l DPLC_MechaSonic
byte_7D4DE:	dc.b	3,   0
		dc.b	4,   1
		dc.b	5,   2
		dc.b	6,   3
		dc.b	7,   4
		dc.b	8,   5
		dc.b  $F8,  $E
		dc.b	8, $7F
		dc.b  $FC
byte_7D4EF:	dc.b	3,   0
		dc.b	4,   1
		dc.b	5,   2
		dc.b	6,   3
		dc.b	7,   4
		dc.b	8,   4
		dc.b	9,   4
		dc.b   $A,   4
		dc.b   $B,   4
		dc.b   $C,   4
		dc.b  $F8, $16
		dc.b   $C, $7F
		dc.b  $FC
byte_7D508:	dc.b  $13,   5
		dc.b  $13,   5
		dc.b	8, $7F
		dc.b  $F8, $E4
byte_7D510:	dc.b	1,   5
		dc.b	1,   5
		dc.b	2,   9
		dc.b	1,   5
		dc.b  $F4
byte_7D519:	dc.b	3,   1
		dc.b	3,   1
		dc.b	4,   1
		dc.b	5,   1
		dc.b  $F8,  $A
byte_7D523:	dc.b	3,   0
		dc.b	4,   0
		dc.b	5,   0
		dc.b  $FC
byte_7D52A:	dc.b	8,   0
		dc.b	7,   3
		dc.b	6,   3
		dc.b	3,   1
		dc.b	4,   1
		dc.b	5,   1
		dc.b  $F8, $F9
byte_7D538:	dc.b	6,   3
		dc.b	6,   3
		dc.b	7,   3
		dc.b	8, $1F
		dc.b  $F4
byte_7D541:	dc.b	0,   0
		dc.b	1,   5
		dc.b	2,   9
		dc.b	1,   0
		dc.b  $F4
byte_7D54A:	dc.b	1,   0
		dc.b	1,   1
		dc.b	3,   1
		dc.b	4,   1
		dc.b	5,   1
		dc.b  $F8, $D9
byte_7D556:	dc.b  $12,   0
		dc.b  $12,   5
		dc.b   $D,   3
		dc.b	8,   5
		dc.b	1,   1
		dc.b  $F4
byte_7D561:	dc.b	1,   3
		dc.b	1,   7
		dc.b	2,   7
		dc.b	1,   3
		dc.b	8,   0
		dc.b  $F4
byte_7D56C:	dc.b	8,   5
		dc.b	8,   5
		dc.b	9,   3
		dc.b   $A,   3
		dc.b   $B,   3
		dc.b   $C,   3
		dc.b  $48, $7F
		dc.b  $F8, $80
byte_7D57C:	dc.b	8,   5
		dc.b  $13,   5
		dc.b  $14, $7F
		dc.b  $F8,   8
		dc.b  $15, $7F
		dc.b  $FC
byte_7D587:	dc.b	1,   5
		dc.b	1,   5
		dc.b  $10,  $F
		dc.b	1,   5
		dc.b  $11, $17
		dc.b	0,   5
		dc.b	8,   3
		dc.b  $F4
byte_7D596:	dc.b	1,   5
		dc.b	2, $1F
		dc.b  $F4
byte_7D59B:	dc.b	2,   0
		dc.b	1,   5
		dc.b	0, $3F
		dc.b  $F4
byte_7D5A2:	dc.b	1,   5
		dc.b	2,   9
		dc.b	1,   5
		dc.b	0, $3F
		dc.b  $F4
byte_7D5AB:	dc.b	1,   5

		dc.b	1,   5
		dc.b	2,   9
		dc.b  $13,   5
		dc.b  $15,   3
		dc.b  $F4
byte_7D5B6:	dc.b	1,   5
		dc.b	1,   5
		dc.b	2,   9
		dc.b  $13,   5
		dc.b  $15, $7F
		dc.b  $F4
byte_7D5C1:	dc.b	3,   1
		dc.b	3,   1
		dc.b	4,   1
		dc.b	5,   1
		dc.b	6,   3
		dc.b	7,   4
		dc.b	8,   3
		dc.b	1,   5
		dc.b	2,   9
		dc.b	1,   5
		dc.b	0,   3
		dc.b  $F4
byte_7D5D8:	dc.b   $C,   3
		dc.b   $C,   3
		dc.b   $A,   3
		dc.b	9,   3
		dc.b	8,   3
		dc.b  $F8, $42
byte_7D5E4:	dc.b   $E,   5
		dc.b   $E,   5
		dc.b   $F,   3
		dc.b  $F8,   8
		dc.b   $F, $7F
		dc.b  $FC
byte_7D5EF:	dc.b   $F,   5

		dc.b   $E,   5
		dc.b	2,   1
		dc.b  $F4
byte_7D5F6:	dc.b	2,   5

		dc.b	2,  $F
		dc.b	1,   5
		dc.b	8,   0
		dc.b  $F4
byte_7D5FF:	dc.b	1,   3
		dc.b	1,   3
		dc.b	2,  $F
		dc.b	1,   3
		dc.b	8,   0
		dc.b  $F4
byte_7D60A:	dc.b	8,   7
		dc.b	8,   7
		dc.b	9,   5
		dc.b   $A,   5
		dc.b   $B,   5
		dc.b   $C,   5
		dc.b  $48, $7F
		dc.b  $F8, $10
byte_7D61A:	dc.b	8, $7F

		dc.b  $FC,   2
		dc.b	5,   2
		dc.b	5,   1
		dc.b	5,   8
		dc.b	0, $F4
byte_7D626:	dc.b	8,   1
		dc.b	8,   1
		dc.b	9,   1
		dc.b   $A,   1
		dc.b   $B,   1
		dc.b   $C,   0
		dc.b  $48, $7F
		dc.b  $F8, $24
byte_7D636:	dc.b	8,   3
		dc.b	8,   3
		dc.b	9,   3
		dc.b   $A,   3
		dc.b   $B,   3
		dc.b   $C,   3
		dc.b  $48,   3
		dc.b  $F4
byte_7D645:	dc.b	8,   3
		dc.b	8,  $F
		dc.b	1,   5
		dc.b  $10,  $F
		dc.b	1,   5
		dc.b  $11,   0
		dc.b  $F4
byte_7D652:	dc.b	8,   1

		dc.b	8,   1
		dc.b   $D,   5
		dc.b  $12, $7F
		dc.b  $F8,  $A
		dc.b  $12, $7F
		dc.b  $FC
byte_7D65F:	dc.b	1,   1
		dc.b	2,   1
		dc.b	3,   1
		dc.b	0,   0
		dc.b  $FC
byte_7D668:	dc.b  $11,   3
		dc.b  $11,   3
		dc.b	0,   3
		dc.b  $11,   3
		dc.b	0,   3
		dc.b  $11,   3
		dc.b  $12, $1B
		dc.b  $13,   5
		dc.b  $14, $3F
		dc.b  $F4
byte_7D67B:	dc.b	0,   0,	  8,   9
		dc.b	0, $17,	$18, $FC
byte_7D683:	dc.b   $E,   1
		dc.b   $E,   1
		dc.b   $F,   2
		dc.b  $10,   3
		dc.b  $F4
byte_7D68C:	dc.b	0,  $A,	 $A,   0
		dc.b   $A,  $B,	  0,  $A
		dc.b   $C,   0,	 $A,  $B
		dc.b	0,  $A,	 $D,   0
		dc.b  $19,  $D,	  0,  $B
		dc.b   $D,   0,	$F4
byte_7D6A3:	dc.b	0,   0,	 $D, $16
		dc.b	0,  $D,	 $C, $16
		dc.b	0,  $D,	$16,   0
		dc.b   $D, $19,	$16, $FC
byte_7D6B3:	dc.b	0,  $B,	 $B,  $D
		dc.b	0,  $B,	 $D,   0
		dc.b   $B,  $D,	  0,  $A
		dc.b   $B,   0,	 $A,  $B
		dc.b	0,  $A,	 $B,   0
		dc.b   $A,   0,	 $A,   0
		dc.b   $A,   0,	 $A,   0
		dc.b   $A,   0,	 $A,   0
		dc.b   $A,   0,	 $A,   0
		dc.b  $F4
Map_RoboshipPieces:	include "Levels\SSZ\Misc Object Data\Map - Robotnik Ship Pieces.asm"

Map_SSZMasterEmerald:	include "Levels\SSZ\Misc Object Data\Map - Master Emerald.asm"

Map_MechaSonicPieces:	include "General\Sprites\Mecha Sonic\Map - Mecha Sonic Pieces.asm"

word_7D842:	dc.w 4

		dc.w 0
		dc.l word_7D84C
		dc.w 0
word_7D84C:	dc.w $FC20
		dc.w $F00
Pal_SSZGHZMisc:	binclude "Levels\SSZ\Palettes\GHZMisc.bin"


word_7D9EA:	dc.w 4
		dc.w 0
		dc.l word_7D9F4
		dc.w 0
word_7D9F4:	dc.w $FC20
		dc.w $F00
		dc.w	  0,  $EEE,   $4E,   $2A,     8,   $EE,	  $88,	   4,  $E88,  $C44,  $A24,  $624,  $422,  $ECC,	  $20,	 $44
		dc.w	  2,	 0,  $EEE,   $8E,   $4E,   $2C,	  $EE,	 $88,	$28,  $EEE,  $EEE,  $E88,  $C66,  $A24,	 $ECC,	$642
		dc.w	$44,	 1,	0,  $EEE,   $4E,   $2A,	    8,	 $EE,	$88,	 4,  $EEE,  $E88,  $C44,  $A24,	 $624,	$ECC
		dc.w   $422,   $44,	0, $FFFC
word_7DA60:	dc.w 4
		dc.w 0
		dc.l word_7DA6A
		dc.w 0
word_7DA6A:	dc.w $FC20
		dc.w $F01
		dc.w	  0,  $EEE,   $4E,   $2A,     8,   $EE,	  $88,	   4,  $EEE,  $E88,  $C44,  $A24,  $624,  $ECC,	 $422,	 $44
		dc.w	  5,	 0,  $EEE,   $8E,   $4E,   $2C,	  $EE,	 $88,	$28,  $EEE,  $EEE,  $E88,  $C66,  $A24,	 $ECC,	$642
		dc.w	$44,	 5,	0,  $EEE,   $8E,   $4E,	  $2C,	 $EE,	$88,   $28,  $EEE,  $EEE,  $EEE,  $EEE,	 $EEE,	$ECC
		dc.w   $642,   $44,   $1D, $FFF8,   $6E, $FC20,	 $F00,	   0,  $EEE,   $4E,   $2A,     8,   $EE,   $88,	    4,	$4EE
		dc.w   $4AE,   $6E,  $24A,  $228,  $ECC,     4,	  $44,	   5,	  0,  $EEE,   $4E,   $2A,     8,   $EE,	  $88,	   4
		dc.w   $2EE,  $2AE,   $6C,  $248,  $226,  $ECC,	    4,	 $44,	  5,	 0,  $EEE,   $4E,   $2A,     8,	  $EE,	 $88
		dc.w	  4,   $EE,   $AE,   $6A,  $246,  $224,	 $ECC,	   2,	$44,	 5,	0,  $EEE,   $4E,   $2A,	    8,	 $EE
		dc.w	$88,	 4,  $2EE,  $2AE,   $6C,  $248,	 $226,	$ECC,	  4,   $44,	5, $FFFC
word_7DB66:	dc.w 4
		dc.w 0
		dc.l word_7DB70
		dc.w 0
word_7DB70:	dc.w $FC20
		dc.w $F01
		dc.w	  0,  $EEE,   $8E,   $4E,   $2C,   $EE,	  $88,	 $28,  $EEE,  $EEE,  $E88,  $C66,  $A24,  $ECC,	 $642,	 $44
		dc.w	  5,	 0,  $EEE,   $4E,   $2A,     8,	  $EE,	 $88,	  4,  $EEE,  $E88,  $C44,  $A24,  $624,	 $ECC,	$422
		dc.w	$44,	 5,	0,  $EEE,   $4E,   $2A,	    8,	 $EE,	$88,	 4,  $E88,  $C44,  $A24,  $624,	 $422,	$ECC
		dc.w	$20,   $44,   $7F, $FFF8,   $6E, $FC20,	 $F00,	   0,  $EEE,   $4E,   $2A,     8,   $EE,   $88,	    4,	$E88
		dc.w   $C44,  $A24,  $624,  $422,  $ECC,   $20,	  $44,	 $7F, $FFFC
word_7DC06:	dc.w 4
		dc.w 0
		dc.l word_7DC10
		dc.w 0
word_7DC10:	dc.w $FC20

		dc.w $F01
		dc.w	  0,  $EEE,   $4E,   $2A,     8,   $EE,	  $88,	   4,  $E88,  $C44,  $A24,  $624,  $422,  $ECC,	  $20,	 $44
		dc.w	  7,	 0,  $EEE,   $8E,   $4E,   $2C,	  $EE,	 $88,	$28,  $EEE,  $EEE,  $E88,  $C66,  $A24,	 $ECC,	$642
		dc.w	$44,	 7,	0,  $EEE,   $4E,   $2A,	    8,	 $EE,	$88,	 4,  $EEE,  $E88,  $C44,  $A24,	 $624,	$ECC
		dc.w   $422,   $44,	7, $FFF8, $FEC8
word_7DC7E:	dc.w 4
		dc.w 0
		dc.l word_7DC88
		dc.w 0
word_7DC88:	dc.w $FC20
		dc.w $F01
		dc.w	  0,  $EEE,   $8E,   $4E,   $2C,   $EE,	  $88,	 $28,  $EEE,  $EEE,  $E88,  $C66,  $A24,  $ECC,	 $642,	 $44
		dc.w	  1,	 0,  $EEE,   $4E,   $2A,     8,	  $EE,	 $88,	  4,  $EEE,  $E88,  $C44,  $A24,  $624,	 $ECC,	$422
		dc.w	$44,	 1,	0,  $EEE,   $4E,   $2A,	    8,	 $EE,	$88,	 4,  $E88,  $C44,  $A24,  $624,	 $422,	$ECC
		dc.w	$20,   $44,	1,     0,  $EEE,   $8E,	  $4E,	 $2C,	$EE,   $88,   $28,  $EEE,  $EEE,  $E88,	 $C66,	$A24
		dc.w   $ECC,  $642,   $44,     3,     0,  $EEE,	  $4E,	 $2A,	  8,   $EE,   $88,     4,  $EEE,  $E88,	 $C44,	$A24
		dc.w   $624,  $ECC,  $422,   $44,     3,     0,	 $EEE,	 $4E,	$2A,	 8,   $EE,   $88,     4,  $E88,	 $C44,	$A24
		dc.w   $624,  $422,  $ECC,   $20,   $44,     3,	$FFF4
off_7DD5A:	dc.l off_7DD7A

		dc.w 1
		dc.b 0
		dc.b $F
		dc.w $109
		dc.w $209
		dc.w $307
		dc.w $407
		dc.w $505
		dc.w $605
		dc.w $505
		dc.w $407
		dc.w $307
		dc.w $209
		dc.w $109
		dc.w $FFFC
off_7DD7A:	dc.w word_7DD88-off_7DD7A

		dc.w word_7DD8C-off_7DD7A
		dc.w word_7DD90-off_7DD7A
		dc.w word_7DD94-off_7DD7A
		dc.w word_7DD98-off_7DD7A
		dc.w word_7DD9C-off_7DD7A
		dc.w word_7DDA0-off_7DD7A
word_7DD88:	dc.w $480
		dc.w $6A0
word_7DD8C:	dc.w $680
		dc.w $8A0
word_7DD90:	dc.w $680
		dc.w $8C0
word_7DD94:	dc.w $6A0
		dc.w $AC0
word_7DD98:	dc.w $8A0
		dc.w $AE0
word_7DD9C:	dc.w $8C0
		dc.w $CE0
word_7DDA0:	dc.w $AC0
		dc.w $EE0
word_7DDA4:	dc.w $18C
		dc.w $38C
		dc.w $3400
		dc.w $3780
		dc.w $28C
		dc.w $28C
		dc.w $3680
		dc.w $36C0
; ---------------------------------------------------------------------------

Obj_DEZ_Miniboss:
		lea	word_7DDA4(pc),a1
		jsr	(Check_CameraInRange).l
		move.b	#$2E,$26(a0)
		jsr	(sub_85D6A).l
		move.l	#loc_7DE28,(a0)
		move.l	#loc_7DE2C,$34(a0)
		lea	ObjDat3_7EF46(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		clr.b	5(a0)
		clr.b	$29(a0)
		clr.b	$42(a0)
		move.w	#$4000,$3A(a0)
		move.w	#-$8000,$3C(a0)
		lea	ChildObjDat_7EF8E(pc),a2
		jsr	CreateChild1_Normal(pc)
		lea	ChildObjDat_7EF96(pc),a2
		jsr	CreateChild6_Simple(pc)
		moveq	#$7B,d0
		jsr	(Load_PLC).l
		lea	(ArtKosM_DEZMinibossMisc).l,a1
		move.w	#-$8000,d2
		jsr	(Queue_Kos_Module).l
		lea	Pal_DEZMiniboss1(pc),a1
		jmp	PalLoad_Line1(pc)
; ---------------------------------------------------------------------------

loc_7DE28:
		jmp	loc_85CA4(pc)
; ---------------------------------------------------------------------------

loc_7DE2C:
		move.l	#loc_7DE46,(a0)
		addi.w	#$E0,($FFFFFAB2).w
		addi.w	#$40,($FFFFFAB4).w
		addi.w	#$100,($FFFFFAB6).w

locret_7DE44:

		rts
; ---------------------------------------------------------------------------

loc_7DE46:
		addq.b	#4,$3C(a0)
		bpl.s	loc_7DE4E
		rts
; ---------------------------------------------------------------------------

loc_7DE4E:
		move.l	#loc_7DE6E,(a0)

loc_7DE54:
		move.b	#0,5(a0)
		clr.w	$3C(a0)
		move.w	#$7F,$2E(a0)
		move.l	#loc_7DEA6,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7DE6E:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7DE92(pc,d0.w),d1
		jsr	off_7DE92(pc,d1.w)
		move.b	($FFFFFE0F).w,d0
		andi.b	#$1F,d0
		bne.s	loc_7DE8E
		moveq	#-$3D,d0
		jsr	(Play_Sound_2).l

loc_7DE8E:
		bra.w	loc_7EE36
; ---------------------------------------------------------------------------
off_7DE92:	dc.w loc_7DEA2-off_7DE92

		dc.w loc_7DEC6-off_7DE92
		dc.w loc_7DEA2-off_7DE92
		dc.w loc_7DF14-off_7DE92
		dc.w loc_7DEA2-off_7DE92
		dc.w loc_7DF40-off_7DE92
		dc.w loc_7DEA2-off_7DE92
		dc.w loc_7DF84-off_7DE92
; ---------------------------------------------------------------------------

loc_7DEA2:
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_7DEA6:
		move.b	#2,5(a0)
		move.w	#$F,$2E(a0)
		move.l	#sub_7DEF6,$34(a0)
		move.b	#2,$39(a0)
		clr.w	$40(a0)
		rts
; ---------------------------------------------------------------------------

loc_7DEC6:
		move.w	$40(a0),d0
		move.w	$3C(a0),d1
		addi.w	#$20,d0
		add.w	d0,d1
		cmpi.w	#$7000,d1
		bcs.s	loc_7DEEC
		move.w	#$7000,d1
		lsr.w	#1,d0
		neg.w	d0
		subq.b	#1,$39(a0)
		bpl.s	loc_7DEEC
		bsr.w	sub_7DEF6

loc_7DEEC:

		move.w	d0,$40(a0)
		move.w	d1,$3C(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_7DEF6:

		move.b	#4,5(a0)
		move.w	#$9F,$2E(a0)
		move.l	#loc_7DF0C,$34(a0)
		rts
; End of function sub_7DEF6

; ---------------------------------------------------------------------------

loc_7DF0C:
		move.b	#6,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_7DF14:
		move.b	$3A(a0),d0
		addq.b	#2,d0
		bmi.s	loc_7DF22
		move.b	d0,$3A(a0)
		rts
; ---------------------------------------------------------------------------

loc_7DF22:
		move.b	#8,5(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_7DF38,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7DF38:
		move.b	#$A,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_7DF40:
		move.b	$3A(a0),d0
		subq.b	#4,d0
		cmpi.b	#$40,d0
		bls.s	loc_7DF52
		move.b	d0,$3A(a0)
		rts
; ---------------------------------------------------------------------------

loc_7DF52:
		move.b	#$40,$3A(a0)
		move.b	#$C,5(a0)
		move.w	#$9F,$2E(a0)
		move.l	#loc_7DF6E,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7DF6E:
		move.b	#$E,5(a0)
		move.w	#$1B,$2E(a0)
		move.l	#loc_7DE54,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7DF84:
		subq.b	#4,$3C(a0)
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_7DF8C:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7DF9A(pc,d0.w),d1
		jmp	off_7DF9A(pc,d1.w)
; ---------------------------------------------------------------------------
off_7DF9A:	dc.w loc_7DFA2-off_7DF9A

		dc.w loc_7E00C-off_7DF9A
		dc.w loc_7E006-off_7DF9A
		dc.w loc_7E00C-off_7DF9A
; ---------------------------------------------------------------------------

loc_7DFA2:
		move.b	($FFFFFE0F).w,d0
		andi.b	#7,d0
		bne.s	loc_7DFB4
		lea	ChildObjDat_7EFA2(pc),a2
		jsr	CreateChild6_Simple(pc)

loc_7DFB4:
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_7DFB8:
		move.b	#2,5(a0)
		move.w	#$5F,$2E(a0)
		move.l	#loc_7DFDE,$34(a0)
		st	($FFFFEEC4).w
		lea	ChildObjDat_7EFA8(pc),a2
		jsr	CreateChild1_Normal(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7DFDE:
		move.b	#4,5(a0)
		bset	#5,$38(a0)
		move.w	#-$80,$18(a0)
		move.w	#$40,$1A(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_7E016,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7E006:
		jsr	(MoveSprite2).l

loc_7E00C:
		jsr	Obj_Wait(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7E016:
		move.b	#6,5(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_7E044,$34(a0)
		move.w	#0,$3A(a0)
		move.w	#$200,$3C(a0)
		move.w	#$100,$26(a0)
		lea	ChildObjDat_7EFB6(pc),a2
		jmp	CreateChild8_TreeListRepeated(pc)
; ---------------------------------------------------------------------------

loc_7E044:
		move.l	#loc_7E0A6,(a0)
		clr.b	5(a0)
		bclr	#6,$2A(a0)
		clr.b	$29(a0)
		clr.b	$42(a0)
		move.w	$14(a0),$30(a0)
		bclr	#5,$38(a0)
		jsr	(Create_New_Sprite).l
		bne.s	sub_7E08C
		move.w	a0,$46(a1)
		move.l	#Obj_8B,(a1)
		move.w	#$3740,$10(a1)
		move.w	#$360,$14(a1)
		move.b	#-$77,$2C(a1)

; =============== S U B R O U T I N E =======================================


sub_7E08C:

		move.w	#$80,d0
		move.w	d0,$3E(a0)
		move.w	d0,$1A(a0)
		move.w	#8,$40(a0)
		bclr	#0,$38(a0)
		rts
; End of function sub_7E08C

; ---------------------------------------------------------------------------

loc_7E0A6:
		move.b	($FFFFFE0F).w,d0
		andi.b	#$3F,d0
		bne.s	loc_7E0B8
		moveq	#-$3A,d0
		jsr	(Play_Sound_2).l

loc_7E0B8:
		bsr.w	sub_7EE88
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7E0CA(pc,d0.w),d1
		jmp	off_7E0CA(pc,d1.w)
; ---------------------------------------------------------------------------
off_7E0CA:	dc.w loc_7E0D6-off_7E0CA

		dc.w loc_7E108-off_7E0CA
		dc.w loc_7E13C-off_7E0CA
		dc.w loc_7E186-off_7E0CA
		dc.w loc_7E1AC-off_7E0CA
		dc.w loc_7E1FC-off_7E0CA
; ---------------------------------------------------------------------------

loc_7E0D6:
		jsr	Swing_UpAndDown(pc)
		jsr	(MoveSprite2).l
		bsr.w	sub_7EC64
		bsr.w	sub_7EB8E
		btst	#1,$38(a0)
		beq.s	loc_7E0F4
		bsr.w	sub_7E0FA

loc_7E0F4:
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_7E0FA:

		move.b	#2,5(a0)
		bset	#7,$38(a0)
		rts
; End of function sub_7E0FA

; ---------------------------------------------------------------------------

loc_7E108:
		jsr	Run_PalRotationScript(pc)
		jsr	Swing_UpAndDown(pc)
		jsr	(MoveSprite2).l
		bsr.w	sub_7EC84
		bsr.w	sub_7EB8E
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7E124:
		move.b	#4,5(a0)
		clr.w	$18(a0)
		bclr	#1,$38(a0)
		bset	#3,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_7E13C:
		jsr	Swing_UpAndDown(pc)
		jsr	(MoveSprite2).l
		btst	#1,$38(a0)
		bne.s	loc_7E15C
		btst	#3,$38(a0)
		beq.s	loc_7E16A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7E15C:
		bsr.s	sub_7E0FA
		bclr	#3,$38(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7E16A:
		move.b	#6,5(a0)
		clr.w	$18(a0)
		move.w	#-$400,$1A(a0)
		bset	#2,$38(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7E186:
		btst	#1,$38(a0)
		bne.s	loc_7E1A0
		addi.w	#$20,$1A(a0)
		jsr	(MoveSprite2).l
		tst.w	$1A(a0)
		bmi.s	loc_7E1A6

loc_7E1A0:
		move.b	#8,5(a0)

loc_7E1A6:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7E1AC:
		btst	#2,$38(a0)
		bne.s	loc_7E1DE
		move.b	#$A,5(a0)
		move.w	#$100,$1A(a0)
		clr.w	$3A(a0)
		btst	#1,$38(a0)
		bne.s	loc_7E1E4
		bset	#6,$38(a0)
		move.w	#$100,$26(a0)
		move.w	#$100,$3C(a0)

loc_7E1DE:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7E1E4:
		bset	#7,$38(a0)
		move.w	#$800,$26(a0)
		move.w	#$800,$3C(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7E1FC:
		jsr	(MoveSprite2).l
		move.w	$30(a0),d0
		cmp.w	$14(a0),d0
		bhi.s	loc_7E236
		move.w	d0,$14(a0)
		move.b	#0,5(a0)
		bclr	#6,$38(a0)
		lea	($FFFFB000).w,a1
		jsr	Find_OtherObject(pc)
		move.w	#-$80,d1
		tst.w	d0
		beq.s	loc_7E22E
		neg.w	d1

loc_7E22E:
		move.w	d1,$18(a0)
		bsr.w	sub_7E08C

loc_7E236:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7E23C:
		jsr	(Create_New_Sprite).l
		bne.s	loc_7E24A
		move.l	#loc_7E25C,(a1)

loc_7E24A:
		bset	#5,$38(a0)
		lea	ChildObjDat_7EFD2(pc),a2
		jsr	CreateChild1_Normal(pc)
		jmp	Obj_EndSignControl(pc)
; ---------------------------------------------------------------------------

loc_7E25C:
		tst.b	($FFFFFAA8).w
		beq.w	locret_7DE44
		move.l	#loc_7E26A,(a0)

loc_7E26A:
		tst.b	($FFFFFAA8).w
		bne.w	locret_7DE44
		move.l	#loc_7E298,(a0)
		st	($FFFFF7CA).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_7E28A
		move.l	#loc_863C0,(a1)

loc_7E28A:
		cmpi.w	#$140,($FFFFB010).w
		bcs.s	loc_7E298
		bset	#3,$38(a0)

loc_7E298:

		lea	($FFFFB000).w,a1
		move.w	#$140,d0
		tst.w	$18(a0)
		btst	#3,$38(a0)
		bne.s	loc_7E2CA
		cmp.w	$10(a1),d0
		bls.s	loc_7E2E8
		moveq	#0,d1
		btst	#5,$2A(a1)
		beq.s	loc_7E2C0
		ori.w	#$4040,d1

loc_7E2C0:
		ori.w	#$808,d1
		move.w	d1,($FFFFF602).w
		rts
; ---------------------------------------------------------------------------

loc_7E2CA:
		cmp.w	$10(a1),d0
		bcc.s	loc_7E2E8
		moveq	#0,d1
		btst	#5,$2A(a1)
		beq.s	loc_7E2DE
		ori.w	#$4040,d1

loc_7E2DE:
		ori.w	#$404,d1
		move.w	d1,($FFFFF602).w
		rts
; ---------------------------------------------------------------------------

loc_7E2E8:

		move.w	d0,$10(a1)
		move.l	#loc_7E342,(a0)
		jsr	Stop_Object(pc)
		clr.w	($FFFFF602).w
		move.w	#$1F,$2E(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_7E320
		move.l	#Obj_CreateBossExplosion,(a1)
		move.w	#$100,$10(a1)
		move.w	#$760,$14(a1)
		move.b	#$14,$2C(a1)

loc_7E320:
		jsr	(Create_New_Sprite).l
		bne.s	locret_7E340
		move.l	#Obj_CreateBossExplosion,(a1)
		move.w	#$180,$10(a1)
		move.w	#$760,$14(a1)
		move.b	#$14,$2C(a1)

locret_7E340:
		rts
; ---------------------------------------------------------------------------

loc_7E342:
		subq.w	#1,$2E(a0)
		bpl.s	locret_7E382
		move.l	#loc_7E384,(a0)
		st	($FFFFEEC4).w
		move.w	#0,($FFFFFA96).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_7E366
		move.l	#Obj_DecLevStartYGradual,(a1)

loc_7E366:
		move.w	#$2000,($FFFFFA98).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_7E37A
		move.l	#Obj_IncLevEndYGradual,(a1)

loc_7E37A:
		moveq	#-$34,d0
		jsr	(Play_Sound_2).l

locret_7E382:
		rts
; ---------------------------------------------------------------------------

loc_7E384:
		lea	($FFFFB000).w,a1
		cmpi.w	#$360,$14(a1)
		bcs.s	locret_7E3C8
		btst	#1,$2A(a1)
		bne.s	locret_7E3C8
		move.l	#loc_7E3CA,(a0)
		move.b	#-$7D,$2E(a1)
		move.b	#0,$20(a1)
		jsr	(Stop_Object).l
		bclr	#5,$2A(a1)
		bset	#1,$2A(a1)
		bclr	#0,$2A(a1)
		bclr	#0,4(a1)

locret_7E3C8:

		rts
; ---------------------------------------------------------------------------

loc_7E3CA:
		addq.w	#8,$1C(a0)
		cmpi.w	#$300,$1C(a0)
		bne.s	loc_7E3E8
		move.l	#loc_7E3EC,(a0)
		move.w	#$24,$2E(a0)
		bclr	#7,($FFFFB00A).w

loc_7E3E8:
		bra.w	sub_7EEEE
; ---------------------------------------------------------------------------

loc_7E3EC:
		subq.w	#1,$2E(a0)
		bpl.s	loc_7E416
		move.l	#loc_7E420,(a0)
		move.w	#-$1000,$1A(a0)
		lea	($FFFFB000).w,a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		moveq	#-$61,d0
		jsr	(Play_Sound_2).l

loc_7E416:
		subi.w	#$10,($FFFFB014).w
		bra.w	sub_7EEEE
; ---------------------------------------------------------------------------

loc_7E420:
		bsr.w	sub_7EEEE
		tst.w	$1A(a0)
		bmi.s	loc_7E44C
		move.l	#loc_7E44C,(a0)
		jsr	(sub_5FD88).l
		lea	($FFFFB000).w,a1
		bclr	#0,4(a1)
		bclr	#0,$2A(a1)
		move.w	#$500,$20(a1)

loc_7E44C:

		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.s	loc_7E490
		move.w	#$3AC,d0
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_7E468
		move.w	#$3B0,d0

loc_7E468:
		cmp.w	$14(a0),d0
		bhi.s	loc_7E490
		move.w	d0,$14(a0)
		move.l	#loc_7E4A2,(a0)
		move.w	#$77,$2E(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_7E490
		move.l	#Obj_TitleCard,(a1)
		st	$3E(a1)

loc_7E490:

		lea	($FFFFB000).w,a1
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		rts
; ---------------------------------------------------------------------------

loc_7E4A2:
		subq.w	#1,$2E(a0)
		bpl.w	locret_7DE44
		lea	(Pal_DEZMiniboss2).l,a1
		lea	($FFFFFC20).w,a2
		moveq	#7,d6

loc_7E4B6:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_7E4B6
		clr.b	($FFFFB02E).w
		clr.b	($FFFFF7CA).w
		clr.b	($FFFFF7CB).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_7E4CE:
		lea	word_7EF70(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		addi.w	#$C,$14(a0)
		move.b	#0,$42(a0)
		move.b	#$C,$43(a0)
		move.w	#-$200,d0
		moveq	#-$40,d1
		tst.b	$2C(a0)
		beq.s	loc_7E4F8
		neg.w	d0
		moveq	#$40,d1

loc_7E4F8:
		move.w	d0,$18(a0)
		move.b	d1,$3C(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_7E52A,$34(a0)
		move.l	#loc_7E51C,(a0)
		lea	ChildObjDat_7EFBC(pc),a2
		jsr	CreateChild1_Normal(pc)

loc_7E51C:
		jsr	(MoveSprite2).l
		jsr	Obj_Wait(pc)
		bra.w	loc_7EC46
; ---------------------------------------------------------------------------

loc_7E52A:
		move.l	#loc_7E566,(a0)
		tst.b	$2C(a0)
		beq.s	locret_7E54A
		move.l	#loc_7E54C,(a0)
		movea.w	$46(a0),a1
		move.w	a0,$44(a1)
		move.w	$44(a0),$46(a0)

locret_7E54A:
		rts
; ---------------------------------------------------------------------------

loc_7E54C:

		movea.w	$46(a0),a1
		btst	#7,$38(a1)
		bne.s	loc_7E582
		bclr	#3,$38(a0)
		bne.w	loc_7E63E
		bra.w	loc_7EBF2
; ---------------------------------------------------------------------------

loc_7E566:
		movea.w	$46(a0),a1
		btst	#7,$38(a1)
		bne.s	loc_7E582
		btst	#3,$38(a1)
		bne.s	loc_7E590

loc_7E57A:

		bsr.w	sub_7EBC2
		bra.w	loc_7EBF2
; ---------------------------------------------------------------------------

loc_7E582:

		move.l	#loc_7E6E8,(a0)
		move.w	#$4000,$3A(a0)
		bra.s	loc_7E57A
; ---------------------------------------------------------------------------

loc_7E590:
		move.l	#loc_7E598,(a0)
		bra.s	loc_7E57A
; ---------------------------------------------------------------------------

loc_7E598:
		movea.w	$46(a0),a1
		btst	#7,$38(a1)
		bne.s	loc_7E582
		bsr.w	sub_7EBC2
		movea.w	$46(a0),a1
		move.b	$3C(a0),d0
		tst.w	$3C(a1)
		bmi.s	loc_7E5C4
		subi.b	#$40,d0
		cmpi.b	#$10,d0
		bls.s	loc_7E5CE
		bra.w	loc_7E5D4
; ---------------------------------------------------------------------------

loc_7E5C4:
		subi.b	#$30,d0
		cmpi.b	#$10,d0
		bhi.s	loc_7E5D4

loc_7E5CE:
		move.l	#loc_7E5D8,(a0)

loc_7E5D4:

		bra.w	loc_7EBF2
; ---------------------------------------------------------------------------

loc_7E5D8:
		movea.w	$46(a0),a1
		move.w	$3C(a0),d0
		btst	#7,$38(a1)
		bne.s	loc_7E582
		move.w	$3A(a1),d1
		move.w	$3C(a1),d2
		bmi.s	loc_7E606
		subi.w	#$100,d1
		add.w	d1,d0
		tst.w	d1
		bpl.s	loc_7E616
		cmpi.w	#$4000,d0
		bcs.s	loc_7E622
		bra.w	loc_7E616
; ---------------------------------------------------------------------------

loc_7E606:
		addi.w	#$100,d1
		add.w	d1,d0
		tst.w	d1
		bmi.s	loc_7E616
		cmpi.w	#$4000,d0
		bhi.s	loc_7E622

loc_7E616:

		move.w	d0,$3C(a0)
		move.w	d1,$3A(a1)
		bra.w	loc_7EBF2
; ---------------------------------------------------------------------------

loc_7E622:

		move.w	#$4000,d0
		move.w	d0,$3C(a0)
		move.w	d1,$3A(a1)
		bclr	#3,$38(a1)
		movea.w	$44(a0),a2
		bset	#3,$38(a2)

loc_7E63E:
		move.l	#loc_7E64C,(a0)
		clr.w	$18(a0)
		bra.w	loc_7EBF2
; ---------------------------------------------------------------------------

loc_7E64C:
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		beq.s	loc_7E664
		move.l	#loc_7E668,(a0)
		move.w	#7,$2E(a0)

loc_7E664:
		bra.w	loc_7EC46
; ---------------------------------------------------------------------------

loc_7E668:
		subq.w	#1,$2E(a0)
		bpl.s	loc_7E67A
		move.l	#loc_7E67E,(a0)
		move.w	#-$400,$1A(a0)

loc_7E67A:
		bra.w	loc_7EC46
; ---------------------------------------------------------------------------

loc_7E67E:
		addi.w	#$20,$1A(a0)
		jsr	(MoveSprite2).l
		movea.w	$46(a0),a1
		move.w	$14(a1),d0
		addi.w	#$C,d0
		tst.w	$1A(a0)
		bpl.s	loc_7E6A2
		cmp.w	$14(a0),d0
		bcs.s	loc_7E6B2

loc_7E6A2:
		move.w	d0,$14(a0)
		move.l	#loc_7E6B6,(a0)
		bclr	#2,$38(a1)

loc_7E6B2:
		bra.w	loc_7EC46
; ---------------------------------------------------------------------------

loc_7E6B6:
		movea.w	$46(a0),a1
		btst	#7,$38(a1)
		bne.w	loc_7E582
		btst	#6,$38(a1)
		beq.s	loc_7E6D0
		bsr.w	sub_7E6D4

loc_7E6D0:
		bra.w	loc_7EBF2

; =============== S U B R O U T I N E =======================================


sub_7E6D4:

		move.l	#loc_7E566,(a0)
		tst.b	$2C(a0)
		beq.s	locret_7E6E6
		move.l	#loc_7E54C,(a0)

locret_7E6E6:
		rts
; ---------------------------------------------------------------------------

loc_7E6E8:
		bsr.w	sub_7EBC2
		move.b	$3A(a0),d0
		addq.b	#1,d0
		cmpi.b	#$60,d0
		bcc.s	loc_7E700
		move.b	d0,$3A(a0)
		bra.w	loc_7EC52
; ---------------------------------------------------------------------------

loc_7E700:
		move.l	#loc_7E710,(a0)
		move.w	#$3F,$2E(a0)
		bra.w	loc_7EC52
; ---------------------------------------------------------------------------

loc_7E710:
		subq.w	#1,$2E(a0)
		bpl.s	loc_7E71C
		move.l	#loc_7E724,(a0)

loc_7E71C:
		bsr.w	sub_7EBC2
		bra.w	loc_7EC52
; ---------------------------------------------------------------------------

loc_7E724:
		bsr.w	sub_7EBC2
		move.b	$3A(a0),d0
		subq.b	#1,d0
		cmpi.b	#$40,d0
		bhi.s	loc_7E742
		bsr.s	sub_7E6D4
		movea.w	$46(a0),a1
		bclr	#7,$38(a1)
		moveq	#$40,d0

loc_7E742:
		move.b	d0,$3A(a0)
		bra.w	loc_7EC52
; End of function sub_7E6D4

; ---------------------------------------------------------------------------

loc_7E74A:
		lea	word_7EF76(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_7E758,(a0)

loc_7E758:
		lea	byte_7EFEC(pc),a1
		jsr	Animate_RawNoSST(pc)
		jsr	Refresh_ChildPosition(pc)
		jmp	Child_DrawTouch_Sprite2(pc)
; ---------------------------------------------------------------------------

loc_7E768:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7E77C(pc,d0.w),d1
		jsr	off_7E77C(pc,d1.w)
		moveq	#$14,d0
		jmp	Child_Draw_Sprite_FlickerMove(pc)
; ---------------------------------------------------------------------------
off_7E77C:	dc.w loc_7E786-off_7E77C

		dc.w loc_7E79C-off_7E77C
		dc.w loc_7E7B4-off_7E77C
		dc.w loc_7E7D6-off_7E77C
		dc.w loc_7E800-off_7E77C
; ---------------------------------------------------------------------------

loc_7E786:
		lea	word_7EF52(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.b	#-1,$29(a0)
		movea.w	$46(a0),a1
		move.w	d0,$44(a1)

loc_7E79C:
		bsr.w	sub_7ED6C
		movea.w	$46(a0),a1
		cmpi.l	#loc_7DE6E,(a1)
		beq.s	loc_7E7AE
		rts
; ---------------------------------------------------------------------------

loc_7E7AE:
		move.b	#4,5(a0)

loc_7E7B4:
		bsr.w	sub_7ED6C
		bsr.w	sub_7EDD0
		movea.w	$46(a0),a1
		btst	#6,$2A(a1)
		bne.s	loc_7E7CE
		jmp	(Add_SpriteToCollisionResponseList).l
; ---------------------------------------------------------------------------

loc_7E7CE:
		move.b	#6,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_7E7D6:
		bsr.w	sub_7ED6C
		movea.w	$46(a0),a1
		btst	#6,$2A(a1)
		beq.s	loc_7E7E8
		rts
; ---------------------------------------------------------------------------

loc_7E7E8:
		move.b	#8,5(a0)
		move.b	#-1,$29(a0)
		move.b	#$17,$28(a0)
		clr.b	$20(a0)
		rts
; ---------------------------------------------------------------------------

loc_7E800:
		bsr.w	sub_7ED6C
		bsr.w	sub_7EDD0
		jmp	(Add_SpriteToCollisionResponseList).l
; ---------------------------------------------------------------------------

loc_7E80E:
		lea	word_7EF58(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_7E820,(a0)
		bsr.w	sub_7ED54

loc_7E820:
		bsr.w	sub_7EB76
		addq.b	#4,$3C(a0)
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		bne.s	loc_7E89C
		move.b	$3C(a0),d0
		jsr	(GetSineCosine).l
		move.w	$3A(a1),d1
		muls.w	d1,d0
		swap	d0
		move.w	d0,d1
		add.w	$10(a1),d0
		move.w	d0,$10(a0)
		addi.w	#$20,d1
		cmpi.w	#$40,d1
		scs	d5
		move.b	$3C(a1),d0
		ext.w	d0
		add.w	$14(a1),d0
		move.w	d0,$14(a0)
		move.b	$3C(a0),d0
		bpl.s	loc_7E870
		not.b	d0

loc_7E870:
		lsr.w	#2,d0
		andi.w	#$1C,d0
		lea	byte_7E8C2(pc,d0.w),a2
		move.b	(a2)+,$22(a0)
		bclr	#7,$A(a0)
		move.b	(a2)+,d1
		or.b	d1,$A(a0)
		move.w	(a2)+,8(a0)
		tst.b	d5
		beq.s	loc_7E898
		tst.b	d1
		beq.w	locret_7DE44

loc_7E898:
		jmp	Draw_And_Touch_Sprite(pc)
; ---------------------------------------------------------------------------

loc_7E89C:
		bclr	#1,$38(a1)
		move.l	#loc_7E8E2,(a0)
		move.b	#$15,$22(a0)
		bset	#7,$A(a0)
		move.w	#$180,8(a0)
		move.w	#-$400,$1A(a0)
		rts
; ---------------------------------------------------------------------------
byte_7E8C2:	dc.b  $15, $80,	  1, $80
		dc.b  $15, $80,	  1, $80
		dc.b  $15, $80,	  1, $80
		dc.b  $16, $80,	  1, $80
		dc.b  $16,   0,	  3,   0
		dc.b  $17,   0,	  3,   0
		dc.b  $17,   0,	  3,   0
		dc.b  $17,   0,	  3,   0
; ---------------------------------------------------------------------------

loc_7E8E2:
		bsr.w	sub_7EB76
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bpl.s	loc_7E8F6
		jmp	Draw_And_Touch_Sprite(pc)
; ---------------------------------------------------------------------------

loc_7E8F6:
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	CreateChild1_Normal(pc)
		bne.s	loc_7E908
		move.b	#6,$2C(a1)

loc_7E908:
		lea	ChildObjDat_7EF9C(pc),a2
		jsr	CreateChild6_Simple(pc)
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_7E916:
		lea	word_7EF5E(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_7E972,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lea	byte_7E942(pc,d0.w),a1
		move.b	(a1)+,$22(a0)
		move.b	(a1)+,d1
		or.b	d1,4(a0)
		add.w	d0,d0
		move.l	word_7E952(pc,d0.w),$18(a0)
		rts
; ---------------------------------------------------------------------------
byte_7E942:	dc.b  $19,   2
		dc.b  $18,   3
		dc.b  $1A,   1
		dc.b  $18,   1
		dc.b  $19,   0
		dc.b  $18,   0
		dc.b  $1A,   0
		dc.b  $18,   2
word_7E952:	dc.w	  0,  $200
		dc.w   $16A,  $16A
		dc.w   $200,	 0
		dc.w   $16A, $FE96
		dc.w	  0, $FE00
		dc.w  $FE96, $FE96
		dc.w  $FE00,	 0
		dc.w  $FE96,  $16A
; ---------------------------------------------------------------------------

loc_7E972:
		jsr	(MoveSprite2).l
		jmp	(Sprite_CheckDeleteTouchXY).l
; ---------------------------------------------------------------------------

loc_7E97E:
		lea	word_7EF7C(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_7E98C,(a0)

loc_7E98C:
		jsr	Refresh_ChildPosition(pc)
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_7E9D0
		btst	#0,($FFFFFE0F).w
		bne.w	locret_7DE44
		move.b	$43(a0),d0
		addq.b	#1,d0
		move.b	d0,$43(a0)
		cmpi.b	#$24,d0
		bcs.s	loc_7E9CA
		move.l	#loc_7E9D4,(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_7E9FC,$34(a0)

loc_7E9CA:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7E9D0:
		jmp	Go_Delete_Sprite(pc)
; ---------------------------------------------------------------------------

loc_7E9D4:
		jsr	Refresh_ChildPosition(pc)
		jsr	Obj_Wait(pc)
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_7E9F8
		btst	#0,($FFFFFE0F).w
		bne.w	locret_7DE44
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7E9F8:
		jmp	Go_Delete_Sprite(pc)
; ---------------------------------------------------------------------------

loc_7E9FC:
		move.l	#loc_7EA12,(a0)
		move.b	#$1B,$22(a0)
		clr.b	$39(a0)
		subq.b	#4,$43(a0)
		rts
; ---------------------------------------------------------------------------

loc_7EA12:
		move.b	$22(a0),d0
		addq.b	#1,d0
		move.b	d0,$22(a0)
		cmpi.b	#$22,d0
		bcs.s	loc_7EA30
		move.l	#loc_7EA3C,(a0)
		lea	ChildObjDat_7EFCC(pc),a2
		jsr	CreateChild6_Simple(pc)

loc_7EA30:
		addq.b	#8,$43(a0)
		jsr	Refresh_ChildPosition(pc)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_7EA3C:
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		beq.s	loc_7EA66
		jsr	Refresh_ChildPosition(pc)
		move.b	($FFFFFE0F).w,d0
		andi.b	#$1F,d0
		bne.s	loc_7EA5E
		moveq	#-$3C,d0
		jsr	(Play_Sound_2).l

loc_7EA5E:
		bsr.w	sub_7EB34
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_7EA66:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_7EA6C:
		lea	word_7EF82(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_7EA9A,(a0)
		move.w	($FFFFFAB0).w,d0
		addi.w	#$B0,d0
		move.w	d0,$14(a0)
		moveq	#-$10,d0
		tst.b	$2C(a0)
		beq.s	loc_7EA96
		neg.w	d0
		bset	#0,4(a0)

loc_7EA96:
		move.w	d0,$3A(a0)

loc_7EA9A:
		lea	byte_7EFF4(pc),a1
		jsr	Animate_RawNoSST(pc)
		movea.w	$46(a0),a1
		move.w	$10(a1),d0
		add.w	$3A(a0),d0
		move.w	d0,$10(a0)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_7EAB6:
		lea	word_7EF64(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		bsr.w	sub_7ECF4
		move.l	#loc_7EAC8,(a0)

loc_7EAC8:
		jmp	Obj_FlickerMove(pc)
; ---------------------------------------------------------------------------

loc_7EACC:

		lea	word_7EF6A(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_7EAFC,(a0)
		move.w	#-$200,$1A(a0)
		move.w	#-$200,d0
		tst.b	$2C(a0)
		beq.s	loc_7EAF2
		bset	#0,4(a0)
		neg.w	d0

loc_7EAF2:
		move.w	d0,$18(a0)
		move.w	#$3F,$2E(a0)

loc_7EAFC:
		subq.w	#1,$2E(a0)
		bpl.s	loc_7EB08
		move.l	#Obj_FlickerMove,(a0)

loc_7EB08:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7EB0E:

		lea	word_7EF88(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#Obj_FlickerMove,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		addi.b	#$23,d0
		move.b	d0,$22(a0)
		moveq	#8,d0
		jmp	(Set_IndexedVelocity).l

; =============== S U B R O U T I N E =======================================


sub_7EB34:
		lea	word_7EB6E(pc),a1
		jsr	(Check_PlayerInRange).l
		tst.w	d0
		beq.s	loc_7EB46
		bsr.w	sub_7EB4C

loc_7EB46:
		swap	d0
		tst.w	d0
		beq.s	locret_7EB6C
; End of function sub_7EB34


; =============== S U B R O U T I N E =======================================


sub_7EB4C:
		movea.w	d0,a1
		tst.b	$34(a1)
		bne.s	locret_7EB6C
		btst	#3,$2A(a1)
		bne.s	locret_7EB6C
		btst	#1,$2B(a1)
		bne.s	locret_7EB6C
		move.l	d0,-(sp)
		jsr	HurtSonic_Directly(pc)
		move.l	(sp)+,d0

locret_7EB6C:

		rts
; End of function sub_7EB4C

; ---------------------------------------------------------------------------
word_7EB6E:	dc.w  $FFE8,   $30, $FFB8,   $90

; =============== S U B R O U T I N E =======================================


sub_7EB76:

		move.b	#-$7A,$28(a0)
		movea.w	$46(a0),a1
		btst	#6,$2A(a1)
		beq.s	locret_7EB8C
		clr.b	$28(a0)

locret_7EB8C:
		rts
; End of function sub_7EB76


; =============== S U B R O U T I N E =======================================


sub_7EB8E:

		btst	#3,($FFFFB02A).w
		bne.s	loc_7EBBA
		move.b	($FFFFFE0F).w,d0
		andi.w	#$1F,d0
		bne.s	locret_7EBB8
		lea	($FFFFB000).w,a1
		jsr	(Find_OtherObject).l
		move.w	$26(a0),d1
		tst.w	d0
		beq.s	loc_7EBB4
		neg.w	d1

loc_7EBB4:
		move.w	d1,$3C(a0)

locret_7EBB8:
		rts
; ---------------------------------------------------------------------------

loc_7EBBA:
		move.w	$26(a0),$3C(a0)
		rts
; End of function sub_7EB8E


; =============== S U B R O U T I N E =======================================


sub_7EBC2:

		movea.w	$46(a0),a1
		moveq	#8,d0
		move.w	$3A(a1),d1
		move.w	$3C(a1),d2
		bmi.s	loc_7EBDE
		add.w	d0,d1
		cmp.w	d2,d1
		blt.s	loc_7EBE8
		move.w	d2,d1
		bra.w	loc_7EBE8
; ---------------------------------------------------------------------------

loc_7EBDE:
		neg.w	d0
		add.w	d0,d1
		cmp.w	d2,d1
		bgt.s	loc_7EBE8
		move.w	d2,d1

loc_7EBE8:

		add.w	d1,$3C(a0)
		move.w	d1,$3A(a1)
		rts
; End of function sub_7EBC2

; ---------------------------------------------------------------------------

loc_7EBF2:

		movea.w	$46(a0),a1
		tst.b	$2C(a0)
		bne.s	loc_7EC06
		move.b	$3C(a0),$43(a1)
		bra.w	loc_7EC12
; ---------------------------------------------------------------------------

loc_7EC06:
		move.b	$43(a1),d0
		addi.b	#-$80,d0
		move.b	d0,$3C(a0)

loc_7EC12:
		move.w	$10(a0),-(sp)
		moveq	#2,d2
		jsr	MoveSprite_CircularSimpleOffset(pc)
		moveq	#$23,d1
		moveq	#8,d2
		moveq	#$15,d3
		move.w	(sp)+,d4

loc_7EC24:

		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_7EC3C
		jsr	(SolidObjectTop).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7EC3C:
		jsr	Displace_PlayerOffObject(pc)
		moveq	#0,d0
		jmp	loc_849D8(pc)
; ---------------------------------------------------------------------------

loc_7EC46:

		moveq	#$23,d1
		moveq	#8,d2
		moveq	#$15,d3
		move.w	$10(a0),d4
		bra.s	loc_7EC24
; ---------------------------------------------------------------------------

loc_7EC52:

		move.w	$10(a0),-(sp)
		jsr	MoveSprite_Circular(pc)
		moveq	#$23,d1
		moveq	#8,d2
		moveq	#$15,d3
		move.w	(sp)+,d4
		bra.s	loc_7EC24

; =============== S U B R O U T I N E =======================================


sub_7EC64:
		move.w	$10(a0),d0
		tst.w	$18(a0)
		beq.s	locret_7EC82
		bmi.s	loc_7EC78
		cmp.w	($FFFFFAB6).w,d0
		bhi.s	loc_7EC7E
		rts
; ---------------------------------------------------------------------------

loc_7EC78:
		cmp.w	($FFFFFAB4).w,d0
		bcc.s	locret_7EC82

loc_7EC7E:
		neg.w	$18(a0)

locret_7EC82:

		rts
; End of function sub_7EC64


; =============== S U B R O U T I N E =======================================


sub_7EC84:
		move.w	$10(a0),d0
		move.w	#-$80,d1
		move.w	($FFFFB010).w,d2
		sub.w	d0,d2
		bls.s	loc_7EC96
		neg.w	d1

loc_7EC96:
		move.w	d1,$18(a0)
		beq.s	locret_7ECB0
		bmi.s	loc_7ECA6
		cmp.w	($FFFFFAB6).w,d0
		bcc.s	loc_7ECAC
		rts
; ---------------------------------------------------------------------------

loc_7ECA6:
		cmp.w	($FFFFFAB4).w,d0
		bhi.s	locret_7ECB0

loc_7ECAC:
		clr.w	$18(a0)

locret_7ECB0:

		rts
; End of function sub_7EC84

; ---------------------------------------------------------------------------
		move.w	$10(a0),d0
		tst.w	$18(a0)
		beq.s	loc_7ECD2
		bmi.s	loc_7ECC8
		cmp.w	($FFFFFAB6).w,d0
		bcc.s	loc_7ECCE
		bra.w	loc_7ECD2
; ---------------------------------------------------------------------------

loc_7ECC8:
		cmp.w	($FFFFFAB4).w,d0
		bhi.s	loc_7ECD2

loc_7ECCE:
		clr.w	$18(a0)

loc_7ECD2:

		move.w	$14(a0),d0
		tst.w	$1A(a0)
		beq.s	locret_7ECF2
		bmi.s	loc_7ECE8
		cmp.w	($FFFFFAB2).w,d0
		bcc.s	loc_7ECEE
		bra.w	locret_7ECF2
; ---------------------------------------------------------------------------

loc_7ECE8:
		cmp.w	($FFFFFAB0).w,d0
		bhi.s	locret_7ECF2

loc_7ECEE:
		clr.w	$1A(a0)

locret_7ECF2:

		rts

; =============== S U B R O U T I N E =======================================


sub_7ECF4:
		jsr	(Random_Number).l
		move.w	d0,d1
		andi.w	#$C,d1
		move.l	byte_7ED40(pc,d1.w),$18(a0)
		andi.w	#$1F,d0
		btst	#0,d0
		beq.s	loc_7ED1C
		neg.w	d0
		neg.w	$18(a0)
		bset	#0,4(a0)

loc_7ED1C:
		add.w	d0,$10(a0)
		swap	d0
		move.w	d0,d1
		andi.w	#3,d1
		move.b	byte_7ED50(pc,d1.w),$22(a0)
		andi.w	#$1F,d0
		btst	#0,d0
		beq.s	loc_7ED3A
		neg.w	d0

loc_7ED3A:
		add.w	d0,$14(a0)
		rts
; End of function sub_7ECF4

; ---------------------------------------------------------------------------
byte_7ED40:	dc.b	3,   0,	$FC,   0
		dc.b	2,   0,	$FD,   0
		dc.b	4,   0,	$FB,   0
		dc.b	3,   0,	$FE,   0
byte_7ED50:	dc.b $12
		dc.b $13
		dc.b $14
		dc.b $12

; =============== S U B R O U T I N E =======================================


sub_7ED54:
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		move.b	byte_7ED64(pc,d0.w),$3C(a0)
		rts
; End of function sub_7ED54

; ---------------------------------------------------------------------------
byte_7ED64:	dc.b 0
		dc.b $80
		dc.b $20
		dc.b $A0
		dc.b $40
		dc.b $C0
		dc.b $60
		dc.b $E0

; =============== S U B R O U T I N E =======================================


sub_7ED6C:

		movea.w	$46(a0),a1
		move.w	$14(a1),$14(a0)
		move.w	($FFFFB010).w,d0
		move.w	$10(a1),d1
		sub.w	d1,d0
		smi	d2
		bpl.s	loc_7ED86
		neg.w	d0

loc_7ED86:
		cmpi.w	#$A0,d0
		bls.s	loc_7ED90
		move.w	#$A0,d0

loc_7ED90:
		lsr.w	#3,d0
		andi.w	#$FE,d0
		lea	byte_7EDBA(pc,d0.w),a2
		move.b	(a2)+,d0
		bclr	#0,4(a0)
		tst.b	d2
		beq.s	loc_7EDAE
		bset	#0,4(a0)
		neg.w	d0

loc_7EDAE:
		add.w	d0,d1
		move.w	d1,$10(a0)
		move.b	(a2)+,$22(a0)
		rts
; End of function sub_7ED6C

; ---------------------------------------------------------------------------
byte_7EDBA:	dc.b	0,   2
		dc.b	1,   2
		dc.b	2,   3
		dc.b	4,   3
		dc.b	5,   3
		dc.b	6,   4
		dc.b	8,   4
		dc.b	9,   4
		dc.b   $A,   5
		dc.b   $B,   5
		dc.b   $C,   5

; =============== S U B R O U T I N E =======================================


sub_7EDD0:

		tst.b	$28(a0)
		bne.s	locret_7EE10
		tst.b	$20(a0)
		bne.s	loc_7EDF2
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		movea.w	$46(a0),a1
		addq.b	#1,$29(a1)

loc_7EDF2:
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_7EE00
		addi.w	#8,d0

loc_7EE00:
		bsr.w	sub_7EE12
		subq.b	#1,$20(a0)
		bne.s	locret_7EE10
		move.b	$25(a0),$28(a0)

locret_7EE10:

		rts
; End of function sub_7EDD0


; =============== S U B R O U T I N E =======================================


sub_7EE12:
		lea	word_7EE1E(pc),a1
		lea	word_7EE26(pc,d0.w),a2
		jmp	CopyWordData_4(pc)
; End of function sub_7EE12

; ---------------------------------------------------------------------------
word_7EE1E:	dc.w $FC36
		dc.w $FC38
		dc.w $FC3A
		dc.w $FC3C
word_7EE26:	dc.w $666
		dc.w $444
		dc.w $222
		dc.w 0
		dc.w $888
		dc.w $AAA
		dc.w $CCC
		dc.w $EEE
; ---------------------------------------------------------------------------

loc_7EE36:
		move.b	$29(a0),d0
		cmp.b	$42(a0),d0
		bne.s	loc_7EE42
		rts
; ---------------------------------------------------------------------------

loc_7EE42:
		move.b	d0,$42(a0)
		bset	#1,$38(a0)
		cmpi.b	#8,d0
		bcs.s	locret_7EE86
		move.l	#loc_7DF8C,(a0)
		clr.b	5(a0)
		move.w	#$7F,$2E(a0)
		move.l	#loc_7DFB8,$34(a0)
		bset	#6,$2A(a0)
		bsr.w	*+4
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	CreateChild1_Normal(pc)
		bne.s	locret_7EE86
		move.b	#$E,$2C(a1)

locret_7EE86:

		rts

; =============== S U B R O U T I N E =======================================


sub_7EE88:
		move.b	$29(a0),d0
		cmp.b	$42(a0),d0
		bne.s	loc_7EE94

locret_7EE92:
		rts
; ---------------------------------------------------------------------------

loc_7EE94:
		move.b	d0,$42(a0)
		cmpi.b	#8,d0
		bcc.s	loc_7EECC
		move.w	#$800,$26(a0)
		lea	(word_7F03C).l,a1
		lea	($FFFFFADE).w,a2
		move.l	(a1)+,(a2)+
		move.l	(a1)+,(a2)+
		clr.w	(a2)
		move.l	#loc_7E124,($FFFFFADA).w
		bset	#1,$38(a0)
		bne.s	locret_7EE92
		lea	ChildObj_7EFC4(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_7EECC:
		bset	#7,$2A(a0)
		move.l	#Wait_FadeToLevelMusic,(a0)
		move.l	#loc_7E23C,$34(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	CreateChild1_Normal(pc)
		jmp	BossDefeated_StopTimer(pc)
; End of function sub_7EE88


; =============== S U B R O U T I N E =======================================


sub_7EEEE:

		move.w	$3C(a0),d0
		add.w	$1C(a0),d0
		cmpi.w	#$C00,d0
		bcs.s	loc_7EF00
		subi.w	#$C00,d0

loc_7EF00:
		move.w	d0,$3C(a0)
		moveq	#0,d0
		move.b	$3C(a0),d0
		lea	($FFFFB000).w,a1
		move.b	byte_7EF2E(pc,d0.w),$22(a1)
		andi.b	#-4,4(a1)
		move.b	byte_7EF3A(pc,d0.w),d0
		or.b	d0,4(a1)
		moveq	#0,d0
		move.b	$22(a1),d0
		jmp	(Player_Load_PLC).l
; End of function sub_7EEEE

; ---------------------------------------------------------------------------
byte_7EF2E:	dc.b $55
		dc.b $59
		dc.b $5A
		dc.b $5B
		dc.b $5A
		dc.b $59
		dc.b $55
		dc.b $56
		dc.b $57
		dc.b $58
		dc.b $57
		dc.b $56
byte_7EF3A:	dc.b 0
		dc.b 1
		dc.b 1
		dc.b 0
		dc.b 0
		dc.b 0
		dc.b 1
		dc.b 1
		dc.b 1
		dc.b 0
		dc.b 0
		dc.b 0
ObjDat3_7EF46:	dc.l Map_DEZMiniboss
		dc.w $A400
		dc.w $280
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b 0
word_7EF52:	dc.w $200
		dc.b $C
		dc.b $C
		dc.b 2
		dc.b $17
word_7EF58:	dc.w $180
		dc.b $10
		dc.b $10
		dc.b $15
		dc.b $86
word_7EF5E:	dc.w $100
		dc.b 4
		dc.b 4
		dc.b $15
		dc.b $98
word_7EF64:	dc.w $80
		dc.b 8
		dc.b 8
		dc.b $12
		dc.b 0
word_7EF6A:	dc.w $180
		dc.b $10
		dc.b $18
		dc.b $11
		dc.b 0
word_7EF70:	dc.w $300
		dc.b $18
		dc.b $10
		dc.b 1
		dc.b 0
word_7EF76:	dc.w $280
		dc.b $18
		dc.b 4
		dc.b $B
		dc.b $9E
word_7EF7C:	dc.w $380
		dc.b $10
		dc.b $80
		dc.b 6
		dc.b 0
word_7EF82:	dc.w $300
		dc.b 8
		dc.b 4
		dc.b 8
		dc.b 0
word_7EF88:	dc.w $100
		dc.b $10
		dc.b $14
		dc.b $23
		dc.b 0
ChildObjDat_7EF8E:dc.w 0
		dc.l loc_7E768
		dc.w $FC
ChildObjDat_7EF96:dc.w 7
		dc.l loc_7E80E
ChildObjDat_7EF9C:dc.w 7
		dc.l loc_7E916
ChildObjDat_7EFA2:dc.w 0
		dc.l loc_7EAB6
ChildObjDat_7EFA8:dc.w 1
		dc.l loc_7EACC
		dc.w $D800
		dc.l loc_7EACC
		dc.w $2800
ChildObjDat_7EFB6:dc.w 1
		dc.l loc_7E4CE
ChildObjDat_7EFBC:dc.w 0
		dc.l loc_7E74A
		dc.w 4
ChildObj_7EFC4:	dc.w 0
		dc.l loc_7E97E
		dc.w $1E
ChildObjDat_7EFCC:dc.w 1
		dc.l loc_7EA6C
ChildObjDat_7EFD2:dc.w 3
		dc.l loc_7EB0E
		dc.w $F000
		dc.l loc_7EB0E
		dc.w $1000
		dc.l loc_7EB0E
		dc.w $F418
		dc.l loc_7EB0E
		dc.w $C18
byte_7EFEC:	dc.b 1
		dc.b $B
		dc.b $C
		dc.b $D
		dc.b $E
		dc.b $F
		dc.b $10
		dc.b $FC
byte_7EFF4:	dc.b	0,   8
		dc.b	7,   9
		dc.b	7,  $A
		dc.b	7, $FC
Pal_DEZMiniboss1:	binclude "Levels\DEZ\Palettes\Miniboss 1.bin"

Pal_DEZMiniboss2:	binclude "Levels\DEZ\Palettes\Miniboss 2.bin"

word_7F03C:	dc.w 4
		dc.w 0
		dc.l word_7F046
		dc.w 0
word_7F046:	dc.w $FC36
		dc.w $20A
		dc.w   $66A,  $448,  $226,     7,  $66C,  $44A,	 $228,	   7,  $66A,  $448,  $226,     7,  $666,  $444,	 $222,	   7
		dc.w  $FFF4
; ---------------------------------------------------------------------------

Obj_DEZ_EndBoss:
		lea	word_7F0BE(pc),a1
		jsr	(Check_CameraInRange).l
		move.l	#loc_7F0CE,(a0)
		move.l	#loc_7F0D2,$34(a0)
		lea	word_7F0C6(pc),a1
		move.b	#$19,$26(a0)
		jsr	sub_85D6A(pc)
		clr.b	($FFFFFAB8).w
		moveq	#$76,d0
		jsr	(Load_PLC).l
		lea	(ArtKosM_DEZEndBoss).l,a1
		move.w	#$7140,d2
		jsr	(Queue_Kos_Module).l
		lea	Pal_DEZEndBoss(pc),a1
		jsr	PalLoad_Line1(pc)
		lea	ChildObjDat_7FC8C(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------
word_7F0BE:	dc.w   $198,  $498, $33E0, $3480
word_7F0C6:	dc.w   $218,  $288, $3400, $34E0
; ---------------------------------------------------------------------------

loc_7F0CE:
		jmp	loc_85CA4(pc)
; ---------------------------------------------------------------------------

loc_7F0D2:
		move.l	#loc_7F0DA,(a0)

locret_7F0D8:

		rts
; ---------------------------------------------------------------------------

loc_7F0DA:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7F102(pc,d0.w),d1
		jsr	off_7F102(pc,d1.w)
		bsr.w	sub_7FB92
		move.b	($FFFFFE0F).w,d0
		andi.b	#$3F,d0
		bne.s	loc_7F0FE
		moveq	#-$3A,d0
		jsr	(Play_Sound_2).l

loc_7F0FE:
		jmp	Draw_And_Touch_Sprite(pc)
; ---------------------------------------------------------------------------
off_7F102:	dc.w loc_7F10E-off_7F102

		dc.w loc_7F150-off_7F102
		dc.w loc_7F182-off_7F102
		dc.w loc_7F1CC-off_7F102
		dc.w loc_7F182-off_7F102
		dc.w loc_7F1CC-off_7F102
; ---------------------------------------------------------------------------

loc_7F10E:
		lea	ObjDat3_7FC44(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.b	#8,$29(a0)
		move.w	#$100,$1A(a0)
		move.w	#$BF,$2E(a0)
		move.l	#loc_7F15A,$34(a0)
		lea	ChildObjDat_7FC9A(pc),a2
		jsr	CreateChild6_Simple(pc)
		tst.l	($FFFFB04A).w
		beq.s	locret_7F14E
		lea	ChildObjDat_7FC9A(pc),a2
		jsr	CreateChild6_Simple(pc)
		bne.s	locret_7F14E
		move.b	#2,$2C(a1)

locret_7F14E:

		rts
; ---------------------------------------------------------------------------

loc_7F150:
		jsr	(MoveSprite2).l
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_7F15A:
		jsr	(Swing_Setup1).l
		move.w	#$100,$18(a0)

loc_7F166:
		move.b	#4,5(a0)
		andi.b	#-$D,$38(a0)
		move.w	#$B3,$2E(a0)
		move.l	#loc_7F194,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7F182:
		jsr	Swing_UpAndDown(pc)
		jsr	(MoveSprite2).l
		bsr.w	sub_7FA60
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_7F194:
		cmpi.b	#3,$39(a0)
		bcc.s	loc_7F1C4
		move.b	#6,5(a0)
		addq.b	#1,$39(a0)
		bset	#3,$38(a0)
		move.l	#loc_7F1DE,$34(a0)
		lea	byte_7FCD4(pc),a1
		jsr	Set_Raw_Animation(pc)
		lea	ChildObjDat_7FCA0(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_7F1C4:
		move.w	#$F,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_7F1CC:
		jsr	Swing_UpAndDown(pc)
		jsr	(MoveSprite2).l
		bsr.w	sub_7FA60
		jmp	Animate_Raw(pc)
; ---------------------------------------------------------------------------

loc_7F1DE:
		move.b	#8,5(a0)
		bset	#2,$38(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_7F1FA,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7F1FA:
		move.b	#$A,5(a0)
		move.l	#loc_7F166,$34(a0)
		lea	byte_7FCD9(pc),a1
		jmp	Set_Raw_Animation(pc)
; ---------------------------------------------------------------------------

loc_7F210:
		move.l	#loc_7F220,(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_7F220:
		jsr	(MoveSprite_LightGravity).l
		cmpi.w	#$318,$14(a0)
		bcc.s	loc_7F234
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7F234:
		move.l	#loc_7F266,(a0)
		bclr	#7,4(a0)
		lea	ChildObjDat_7FCCE(pc),a2
		jsr	CreateChild6_Simple(pc)
		lea	ChildObjDat_7FCC8(pc),a2
		jsr	CreateChild6_Simple(pc)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		rts
; ---------------------------------------------------------------------------

loc_7F266:
		btst	#1,($FFFFFAB8).w
		beq.s	locret_7F298
		move.l	#loc_7F29A,(a0)
		bset	#4,$38(a0)
		move.w	#$3F,$2E(a0)
		move.w	#$35D0,$10(a0)
		move.w	#$328,$14(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l

locret_7F298:
		rts
; ---------------------------------------------------------------------------

loc_7F29A:
		move.w	$2E(a0),d0
		subq.w	#1,d0
		move.w	d0,$2E(a0)
		beq.s	loc_7F2B4
		cmpi.w	#$30,$2E(a0)
		bne.s	locret_7F2DA
		st	($FFFFEEC4).w
		rts
; ---------------------------------------------------------------------------

loc_7F2B4:
		move.l	#loc_7F2DC,(a0)
		clr.b	($FFFFF7AA).w
		moveq	#$17,d0
		jsr	(Play_Sound).l
		move.w	#$3620,($FFFFFA92).w
		jsr	(Create_New_Sprite).l
		bne.s	locret_7F2DA
		move.l	#Obj_IncLevEndXGradual,(a1)

locret_7F2DA:

		rts
; ---------------------------------------------------------------------------

loc_7F2DC:
		move.w	($FFFFEE78).w,($FFFFEE14).w
		cmpi.w	#$3620,($FFFFEE78).w
		bcs.s	locret_7F2FC
		move.l	#loc_7F2FE,(a0)
		move.b	#1,($FFFFEE0A).w
		addi.w	#$40,($FFFFEE16).w

locret_7F2FC:
		rts
; ---------------------------------------------------------------------------

loc_7F2FE:
		move.w	($FFFFEE78).w,d0
		addi.w	#$160,d0
		cmp.w	($FFFFB010).w,d0
		bls.w	loc_7F310
		rts
; ---------------------------------------------------------------------------

loc_7F310:
		st	($FFFFEE5E).w
		move.w	($FFFFFE20).w,($FFFFEF5E).w
		move.l	($FFFFFE22).w,($FFFFEF60).w
		move.b	($FFFFB02B).w,($FFFFFF96).w
		move.w	#$1700,d0
		jsr	(StartNewLevel).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_7F336:
		lea	word_7FC50(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_7F344,(a0)

loc_7F344:
		lea	($FFFFB000).w,a2
		tst.b	$2C(a0)
		beq.s	loc_7F352
		lea	($FFFFB04A).w,a2

loc_7F352:
		movea.w	$46(a0),a1
		jsr	sub_8622C(pc)
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		beq.s	loc_7F37C
		move.b	d0,d1
		smi	d2
		addi.b	#$30,d1
		cmpi.b	#$60,d1
		bcc.s	loc_7F37C
		moveq	#$30,d0
		tst.b	d2
		beq.s	loc_7F37C
		moveq	#-$30,d0

loc_7F37C:

		move.b	d0,$3C(a0)
		lea	(byte_7FD28).l,a2
		jsr	MoveSprite_AtAngleLookup(pc)
		bsr.w	sub_7FA7E
		bsr.w	sub_7FACC
		moveq	#8,d0
		jmp	Child_DrawTouch_Sprite_FlickerMove(pc)
; ---------------------------------------------------------------------------

loc_7F398:
		lea	word_7FC62(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_7F3B0,(a0)
		move.b	#$B,$1E(a0)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_7F3B0:
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		bne.s	loc_7F3C4
		jsr	Refresh_ChildPosition(pc)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_7F3C4:
		move.l	#loc_7F3D0,(a0)
		move.w	#$10,$2E(a0)

loc_7F3D0:
		subq.w	#1,$2E(a0)
		bmi.s	loc_7F3EA
		bchg	#2,$38(a0)
		bne.s	loc_7F3E2
		addq.b	#1,$43(a0)

loc_7F3E2:
		jsr	Refresh_ChildPosition(pc)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_7F3EA:
		move.l	#loc_7F3F6,(a0)
		move.w	#7,$2E(a0)

loc_7F3F6:
		subq.w	#1,$2E(a0)
		bpl.s	loc_7F40A
		move.l	#loc_7F414,(a0)
		moveq	#-$79,d0

loc_7F404:
		jsr	(Play_Sound_2).l

loc_7F40A:
		movea.w	$46(a0),a1
		move.w	$10(a1),$10(a0)

loc_7F414:
		bsr.w	sub_7F8A0
		tst.w	$1A(a0)
		bpl.s	loc_7F430
		jsr	(ObjHitCeiling).l
		tst.w	d1
		bpl.s	loc_7F43E
		bsr.w	sub_7F45A
		bra.w	loc_7F43E
; ---------------------------------------------------------------------------

loc_7F430:
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_7F43E
		bsr.w	sub_7F472

loc_7F43E:

		movea.w	$46(a0),a1
		btst	#7,$2A(a0)
		bne.s	sub_7F4AC
		btst	#0,($FFFFFE0F).w
		bne.w	locret_7F0D8
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_7F45A:
		sub.w	d1,$14(a0)
		move.b	#0,5(a0)
		move.b	#-$3A,$28(a0)
		st	$3A(a0)
		bra.w	loc_7F486
; End of function sub_7F45A


; =============== S U B R O U T I N E =======================================


sub_7F472:
		add.w	d1,$14(a0)
		move.b	#2,5(a0)
		move.b	#-$3A,$28(a0)
		clr.b	$3A(a0)

loc_7F486:
		move.l	#loc_7F4FA,(a0)
		move.w	#$257,$2E(a0)
		jsr	(Random_Number).l
		move.w	#$80,d1
		tst.b	d0
		bpl.s	loc_7F4A2
		neg.w	d1

loc_7F4A2:
		move.w	d1,$18(a0)
		clr.w	$1A(a0)
		rts
; End of function sub_7F472


; =============== S U B R O U T I N E =======================================


sub_7F4AC:

		move.l	#Go_Delete_Sprite,$34(a0)
		bra.w	loc_7F4C0
; End of function sub_7F4AC


; =============== S U B R O U T I N E =======================================


sub_7F4B8:

		move.l	#loc_7F4EE,$34(a0)

loc_7F4C0:
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_7F4D4
		move.b	#6,$2C(a1)

loc_7F4D4:
		move.l	#Wait_Draw,(a0)
		movea.w	$46(a0),a1
		subq.b	#1,$39(a1)
		move.w	#7,$2E(a0)
		jmp	(Draw_Sprite).l
; End of function sub_7F4B8

; ---------------------------------------------------------------------------

loc_7F4EE:
		lea	ChildObjDat_7FCB4(pc),a2
		jsr	CreateChild1_Normal(pc)
		jmp	Go_Delete_Sprite(pc)
; ---------------------------------------------------------------------------

loc_7F4FA:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7F51E(pc,d0.w),d1
		jsr	off_7F51E(pc,d1.w)
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.w	sub_7F4AC
		bsr.w	sub_7FB4E
		jmp	Draw_And_Touch_Sprite(pc)
; ---------------------------------------------------------------------------
off_7F51E:	dc.w loc_7F528-off_7F51E

		dc.w loc_7F538-off_7F51E
		dc.w loc_7F568-off_7F51E
		dc.w loc_7F5D2-off_7F51E
		dc.w loc_7F5FC-off_7F51E
; ---------------------------------------------------------------------------

loc_7F528:
		bsr.w	sub_7F900
		bsr.w	sub_7F8CA
		subq.w	#1,$2E(a0)
		bmi.s	loc_7F55A
		rts
; ---------------------------------------------------------------------------

loc_7F538:
		jsr	(MoveSprite2).l
		bsr.w	sub_7F9A8
		bsr.w	sub_7FA60
		lea	byte_7FCDE(pc),a1
		jsr	Animate_RawNoSST(pc)
		bsr.w	sub_7F8CA
		subq.w	#1,$2E(a0)
		bpl.w	locret_7F0D8

loc_7F55A:
		move.b	#8,5(a0)
		move.w	#$1F,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_7F568:
		jsr	(sub_7F8A0).l

loc_7F56E:
		bsr.w	sub_7F9F8
		tst.w	$1A(a0)
		bpl.s	loc_7F5A0
		jsr	(ObjHitCeiling).l
		tst.w	d1
		bpl.s	locret_7F5D0
		sub.w	d1,$14(a0)
		st	$3A(a0)
		btst	#1,4(a0)
		bne.s	loc_7F5BA

loc_7F592:
		move.b	#0,5(a0)
		move.b	#-$3A,$28(a0)
		rts
; ---------------------------------------------------------------------------

loc_7F5A0:
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	locret_7F5D0
		add.w	d1,$14(a0)
		clr.b	$3A(a0)
		btst	#1,4(a0)
		bne.s	loc_7F592

loc_7F5BA:
		move.b	#2,5(a0)
		move.b	#-$3A,$28(a0)
		move.w	$3C(a0),$18(a0)
		clr.w	$1A(a0)

locret_7F5D0:

		rts
; ---------------------------------------------------------------------------

loc_7F5D2:
		subq.w	#1,$42(a0)
		bne.s	loc_7F5DE
		bchg	#1,4(a0)

loc_7F5DE:
		jsr	(sub_7F8A0).l
		bsr.w	sub_7FA60
		move.w	#$80,d0
		tst.w	$18(a0)
		bpl.s	loc_7F5F4
		neg.w	d0

loc_7F5F4:
		move.w	d0,$3C(a0)
		bra.w	loc_7F56E
; ---------------------------------------------------------------------------

loc_7F5FC:
		subq.w	#1,$2E(a0)
		bpl.s	locret_7F608
		bsr.w	sub_7F4B8
		addq.w	#4,sp

locret_7F608:
		rts
; ---------------------------------------------------------------------------

loc_7F60A:

		lea	word_7FC68(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_7F62E,(a0)
		jsr	Refresh_ChildPositionAdjusted(pc)
		bsr.w	sub_7FB1A
		movea.w	$46(a0),a1
		movea.w	$46(a1),a1
		move.w	a1,$46(a0)
		rts
; ---------------------------------------------------------------------------

loc_7F62E:
		jsr	(MoveSprite2).l
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_7F644
		jmp	Sprite_CheckDeleteTouchXY(pc)
; ---------------------------------------------------------------------------

loc_7F644:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_7F64A:
		lea	word_7FC56(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_7F66C,(a0)
		move.l	#byte_7FCEF,$30(a0)
		lea	ChildObjDat_7FCAE(pc),a2
		jsr	CreateChild6_Simple(pc)
		jmp	Child_DrawTouch_Sprite(pc)
; ---------------------------------------------------------------------------

loc_7F66C:
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		bne.s	loc_7F684
		jsr	Refresh_ChildPosition(pc)
		jsr	Animate_RawMultiDelay(pc)
		jmp	Child_DrawTouch_Sprite(pc)
; ---------------------------------------------------------------------------

loc_7F684:
		move.l	#loc_7F690,(a0)
		move.w	#$10,$2E(a0)

loc_7F690:
		subq.w	#1,$2E(a0)
		bmi.s	loc_7F6AE
		bchg	#2,$38(a0)
		bne.s	loc_7F6A2
		addq.b	#1,$43(a0)

loc_7F6A2:
		jsr	Refresh_ChildPosition(pc)
		jsr	Animate_RawMultiDelay(pc)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_7F6AE:
		move.l	#loc_7F6BA,(a0)
		move.w	#7,$2E(a0)

loc_7F6BA:
		subq.w	#1,$2E(a0)
		bmi.s	loc_7F6CC
		jsr	Refresh_ChildPosition(pc)
		jsr	Animate_RawMultiDelay(pc)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_7F6CC:
		move.l	#loc_7F6D2,(a0)

loc_7F6D2:
		bchg	#2,$38(a0)
		bne.s	loc_7F6DE
		subq.b	#1,$43(a0)

loc_7F6DE:
		jsr	Refresh_ChildPosition(pc)
		jsr	Animate_RawMultiDelay(pc)
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		beq.s	loc_7F6F6
		jmp	Child_DrawTouch_Sprite(pc)
; ---------------------------------------------------------------------------

loc_7F6F6:
		jmp	Go_Delete_Sprite(pc)
; ---------------------------------------------------------------------------

loc_7F6FA:
		lea	word_7FC5C(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_7F708,(a0)

loc_7F708:
		movea.w	$46(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_7F71C:
		lea	ObjDat3_7FC74(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_70068,(a0)
		move.l	#loc_7F74C,$34(a0)
		move.l	#byte_7FCE2,$30(a0)
		move.w	#$3610,$10(a0)
		move.w	#$324,$14(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7F74C:
		lea	($FFFFB000).w,a1
		move.w	$10(a0),d0
		move.w	$10(a1),d1
		sub.w	d1,d0
		bmi.s	loc_7F76A
		cmpi.w	#$40,d0
		bcc.s	loc_7F76A
		addi.w	#$40,d1
		move.w	d1,$10(a0)

loc_7F76A:

		lea	(byte_70419).l,a1
		jsr	(Animate_RawNoSST).l
		jsr	(MoveSprite2).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_7F782:
		lea	ObjDat3_7FC80(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_7F79C,(a0)
		move.w	#$3600,$10(a0)
		move.w	#$32C,$14(a0)

loc_7F79C:
		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		beq.s	loc_7F7C8
		move.l	#Sprite_OnScreen_Test,(a0)
		move.b	#$15,$22(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_7F7C8
		move.b	#6,$2C(a1)

loc_7F7C8:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7F7CE:
		lea	word_7FC6E(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#Obj_FlickerMove,(a0)
		move.b	$2C(a0),d0
		lsr.b	#1,d0
		addi.b	#$22,d0
		move.b	d0,$22(a0)
		moveq	#8,d0
		jsr	Set_IndexedVelocity(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_7F7F6:
		move.l	#loc_7F81E,(a0)
		addi.w	#$38,$14(a0)
		move.w	#$1010,$3A(a0)
		moveq	#2,d0
		moveq	#4,d1
		tst.b	$2C(a0)
		beq.s	loc_7F816
		neg.w	d0
		moveq	#2,d1

loc_7F816:
		move.w	d0,$18(a0)
		move.b	d1,$39(a0)

loc_7F81E:
		subq.b	#1,$39(a0)
		bpl.s	loc_7F830
		move.b	#3,$39(a0)
		jsr	(sub_83E84).l

loc_7F830:
		move.w	$18(a0),d0
		move.w	$10(a0),d1
		add.w	d0,d1
		move.w	d1,$10(a0)
		tst.w	d0
		bmi.s	loc_7F84C
		move.w	#$35D0,d2
		cmp.w	d2,d1
		bcc.s	loc_7F854
		rts
; ---------------------------------------------------------------------------

loc_7F84C:
		move.w	#$3450,d2
		cmp.w	d2,d1
		bhi.s	locret_7F870

loc_7F854:
		move.w	d2,$10(a0)
		move.l	#loc_7F872,(a0)
		move.w	#-2,$1A(a0)
		tst.b	$2C(a0)
		bne.s	locret_7F870
		bset	#1,($FFFFFAB8).w

locret_7F870:

		rts
; ---------------------------------------------------------------------------

loc_7F872:
		subq.b	#1,$39(a0)
		bpl.s	loc_7F884
		move.b	#3,$39(a0)
		jsr	(sub_83E84).l

loc_7F884:
		move.w	$1A(a0),d0
		move.w	$14(a0),d1
		add.w	d0,d1
		move.w	d1,$14(a0)
		cmpi.w	#$240,d1
		bcc.w	locret_7F0D8
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_7F8A0:

		move.w	$18(a0),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$10(a0)
		move.w	$1A(a0),d0
		moveq	#$38,d1
		tst.b	($FFFFF7C6).w
		beq.s	loc_7F8BA
		neg.w	d1

loc_7F8BA:
		add.w	d1,d0
		move.w	d0,$1A(a0)
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$14(a0)
		rts
; End of function sub_7F8A0


; =============== S U B R O U T I N E =======================================


sub_7F8CA:

		tst.b	$3A(a0)
		sne	d0
		tst.b	($FFFFF7C6).w
		beq.s	loc_7F8D8
		not.b	d0

loc_7F8D8:
		tst.b	d0
		beq.s	locret_7F8FE
		move.b	#4,5(a0)
		move.b	#-$3A,$28(a0)
		clr.b	$39(a0)
		move.w	$18(a0),d0
		beq.s	loc_7F8FA
		move.w	d0,$3C(a0)
		clr.w	$18(a0)

loc_7F8FA:
		clr.w	$1A(a0)

locret_7F8FE:
		rts
; End of function sub_7F8CA


; =============== S U B R O U T I N E =======================================


sub_7F900:
		jsr	Check_PlayerCollision(pc)
		beq.w	locret_7F9A6
		cmpi.b	#2,$20(a1)
		beq.s	loc_7F926
		tst.b	$34(a1)
		bne.w	locret_7F9A6
		btst	#1,$2B(a1)
		bne.w	locret_7F9A6
		jmp	HurtSonic_Directly(pc)
; ---------------------------------------------------------------------------

loc_7F926:
		btst	#1,$2A(a1)
		beq.s	loc_7F95C
		bset	#2,$2A(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		move.w	#-$300,$1A(a1)
		bset	#1,$2A(a1)
		bsr.w	sub_7F4AC
		adda.w	#8,sp
		rts
; ---------------------------------------------------------------------------

loc_7F95C:
		move.b	#6,5(a0)
		move.b	#-$3A,$28(a0)
		move.w	#7,$42(a0)
		move.b	#8,$39(a0)
		move.w	#$200,d4
		tst.w	$18(a1)
		bpl.s	loc_7F980
		neg.w	d4

loc_7F980:
		move.w	d4,$18(a0)
		move.w	$1C(a1),d4
		bpl.s	loc_7F98C
		neg.w	d4

loc_7F98C:
		cmpi.w	#$500,d4
		bcc.s	loc_7F996
		move.w	#$500,d4

loc_7F996:
		btst	#1,4(a0)
		beq.s	loc_7F9A0
		neg.w	d4

loc_7F9A0:
		move.w	d4,$1A(a0)
		addq.w	#4,sp

locret_7F9A6:

		rts
; End of function sub_7F900


; =============== S U B R O U T I N E =======================================


sub_7F9A8:
		jsr	Check_PlayerCollision(pc)
		beq.w	locret_7F9F6
		cmpi.b	#2,$20(a1)
		bne.s	loc_7F9C0
		btst	#1,$2A(a1)
		beq.s	loc_7F9D6

loc_7F9C0:
		tst.b	$34(a1)
		bne.w	locret_7F9F6
		btst	#1,$2B(a1)
		bne.w	locret_7F9F6
		jmp	HurtSonic_Directly(pc)
; ---------------------------------------------------------------------------

loc_7F9D6:
		move.w	$10(a0),d0
		sub.w	$10(a1),d0
		smi	d1
		move.w	$18(a1),d2
		bmi.s	loc_7F9E8
		not.b	d1

loc_7F9E8:
		tst.b	d1
		beq.s	locret_7F9F6
		neg.w	d2
		move.w	d2,$18(a1)
		neg.w	$1C(a1)

locret_7F9F6:

		rts
; End of function sub_7F9A8


; =============== S U B R O U T I N E =======================================


sub_7F9F8:
		jsr	Check_PlayerCollision(pc)
		beq.s	locret_7FA5E
		tst.b	$39(a0)
		beq.s	loc_7FA0A
		subq.b	#1,$39(a0)
		rts
; ---------------------------------------------------------------------------

loc_7FA0A:
		cmpi.b	#2,$20(a1)
		beq.s	loc_7FA2C
		cmpi.b	#9,$20(a1)
		beq.s	loc_7FA2C

loc_7FA1A:

		tst.b	$34(a1)
		bne.s	locret_7FA5E
		btst	#1,$2B(a1)
		bne.s	locret_7FA5E
		jmp	HurtSonic_Directly(pc)
; ---------------------------------------------------------------------------

loc_7FA2C:

		jsr	(Find_OtherObject).l
		cmpi.w	#$10,d2
		bcc.s	loc_7FA1A
		btst	#1,4(a0)
		sne	d2
		tst.w	d1
		bne.s	loc_7FA46
		not.b	d2

loc_7FA46:
		tst.b	d2
		bne.s	loc_7FA1A
		neg.w	$18(a1)
		neg.w	$1A(a1)
		neg.w	$1C(a1)
		bsr.w	sub_7F4AC
		adda.w	#8,sp

locret_7FA5E:

		rts
; End of function sub_7F9F8


; =============== S U B R O U T I N E =======================================


sub_7FA60:

		move.w	$10(a0),d0
		tst.w	$18(a0)
		bmi.s	loc_7FA72
		cmpi.w	#$3598,d0
		bcc.s	loc_7FA78
		rts
; ---------------------------------------------------------------------------

loc_7FA72:
		cmpi.w	#$3488,d0
		bhi.s	locret_7FA7C

loc_7FA78:
		neg.w	$18(a0)

locret_7FA7C:
		rts
; End of function sub_7FA60


; =============== S U B R O U T I N E =======================================


sub_7FA7E:
		jsr	Check_PlayerCollision(pc)
		beq.s	locret_7FACA
		move.b	$3C(a0),d0
		move.b	($FFFFFE0F).w,d1
		andi.b	#3,d1
		subq.b	#2,d1
		add.w	d1,d0
		jsr	(GetSineCosine).l
		lsl.w	#3,d0
		lsl.w	#3,d1
		move.w	d0,$18(a1)
		move.w	d1,$1A(a1)
		bset	#1,$2A(a1)
		bclr	#4,$2A(a1)
		bclr	#5,$2A(a1)
		clr.b	$40(a1)
		move.b	#1,$20(a0)
		moveq	#-$56,d0
		jsr	(Play_Sound_2).l

locret_7FACA:
		rts
; End of function sub_7FA7E


; =============== S U B R O U T I N E =======================================


sub_7FACC:
		moveq	#0,d0
		move.b	$3C(a0),d0
		bclr	#7,d0
		sne	d2
		moveq	#4,d3
		lea	byte_7FB0A(pc),a1
		btst	#6,d0
		beq.s	loc_7FAE8
		moveq	#$A,d3
		addq.w	#8,a1

loc_7FAE8:

		cmp.b	(a1)+,d0
		bcs.s	loc_7FAF0
		addq.w	#1,d3
		bra.s	loc_7FAE8
; ---------------------------------------------------------------------------

loc_7FAF0:
		move.b	d3,$22(a0)
		move.b	4(a0),d0
		andi.b	#-4,d0
		tst.b	d2
		beq.s	loc_7FB04
		ori.b	#3,d0

loc_7FB04:
		move.b	d0,4(a0)
		rts
; End of function sub_7FACC

; ---------------------------------------------------------------------------
byte_7FB0A:	dc.b 5
		dc.b $10
		dc.b $1B
		dc.b $26
		dc.b $31
		dc.b $3C
		dc.b $40
		dc.b 0
		dc.b $45
		dc.b $50
		dc.b $5B
		dc.b $66
		dc.b $71
		dc.b $7C
		dc.b $80
		dc.b 0

; =============== S U B R O U T I N E =======================================


sub_7FB1A:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,d1
		lsr.w	#1,d0
		addi.b	#$1F,d0
		move.b	d0,$22(a0)
		add.w	d1,d1
		move.l	word_7FB42(pc,d1.w),$18(a0)
		btst	#1,4(a0)
		beq.s	locret_7FB40
		neg.w	$1A(a0)

locret_7FB40:
		rts
; End of function sub_7FB1A

; ---------------------------------------------------------------------------
word_7FB42:	dc.w  $FE96, $FE96
		dc.w	  0, $FE00
		dc.w   $16A, $FE96

; =============== S U B R O U T I N E =======================================


sub_7FB4E:
		movea.w	$46(a0),a1
		btst	#6,$2A(a1)
		bne.s	locret_7FB88
		lea	word_7FB8A(pc),a2
		jsr	Check_InMyRange(pc)
		beq.s	locret_7FB88
		btst	#1,4(a0)
		sne	d0
		tst.w	$1A(a0)
		bpl.s	loc_7FB74
		not.b	d0

loc_7FB74:
		tst.b	d0
		beq.s	loc_7FB82
		st	$42(a1)
		bset	#6,$2A(a1)

loc_7FB82:
		bsr.w	sub_7F4B8
		addq.w	#4,sp

locret_7FB88:

		rts
; End of function sub_7FB4E

; ---------------------------------------------------------------------------
word_7FB8A:	dc.w  $FFD8,   $50, $FFD8,   $50

; =============== S U B R O U T I N E =======================================


sub_7FB92:
		tst.b	$42(a0)
		beq.s	locret_7FBD4
		tst.b	$20(a0)
		bne.s	loc_7FBB2
		subq.b	#1,$29(a0)
		beq.s	loc_7FBD6
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l

loc_7FBB2:
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_7FBC0
		addi.w	#$C,d0

loc_7FBC0:
		bsr.w	sub_7FC0E
		subq.b	#1,$20(a0)
		bne.s	locret_7FBD4
		bclr	#6,$2A(a0)
		clr.b	$42(a0)

locret_7FBD4:

		rts
; ---------------------------------------------------------------------------

loc_7FBD6:
		move.l	#Wait_NewDelay,(a0)
		bset	#7,$2A(a0)
		bset	#0,($FFFFFAB8).w
		move.l	#loc_7F210,$34(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_7FC0A
		move.l	#loc_7FC3E,(a1)

loc_7FC0A:
		jmp	BossDefeated_StopTimer(pc)
; End of function sub_7FB92


; =============== S U B R O U T I N E =======================================


sub_7FC0E:
		lea	word_7FC1A(pc),a1
		lea	word_7FC26(pc,d0.w),a2
		jmp	CopyWordData_6(pc)
; End of function sub_7FC0E

; ---------------------------------------------------------------------------
word_7FC1A:	dc.w $FC26
		dc.w $FC28
		dc.w $FC36
		dc.w $FC38
		dc.w $FC3A
		dc.w $FC3C
word_7FC26:	dc.w $2A
		dc.w 6
		dc.w $A48
		dc.w $644
		dc.w $422
		dc.w 0
		dc.w $888
		dc.w $AAA
		dc.w $888
		dc.w $AAA
		dc.w $CCC
		dc.w $EEE
; ---------------------------------------------------------------------------

loc_7FC3E:
		clr.b	($FFFFF7C6).w
		rts
; ---------------------------------------------------------------------------
ObjDat3_7FC44:	dc.l Map_DEZEndBoss
		dc.w $A38A
		dc.w $200
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b 0
word_7FC50:	dc.w $180
		dc.b $18
		dc.b $18
		dc.b 4
		dc.b $D7
word_7FC56:	dc.w $200
		dc.b $18
		dc.b 4
		dc.b $16
		dc.b $9C
word_7FC5C:	dc.w $200
		dc.b $18
		dc.b $C
		dc.b $13
		dc.b $9C
word_7FC62:	dc.w $280
		dc.b $10
		dc.b $18
		dc.b $11
		dc.b 0
word_7FC68:	dc.w $280
		dc.b 8
		dc.b 8
		dc.b $1F
		dc.b $98
word_7FC6E:	dc.w 0
		dc.b $28
		dc.b $28
		dc.b $22
		dc.b 0
ObjDat3_7FC74:	dc.l Map_FBZRobotnikStand
		dc.w $8466
		dc.w $200
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b 0
ObjDat3_7FC80:	dc.l Map_DEZEndBoss
		dc.w $A38A
		dc.w $180
		dc.b $C
		dc.b $14
		dc.b $14
		dc.b 0
ChildObjDat_7FC8C:dc.w	  1
		dc.l loc_7F71C
		dc.w 0
		dc.l loc_7F782
		dc.w 0
ChildObjDat_7FC9A:dc.w 0

		dc.l loc_7F336
ChildObjDat_7FCA0:dc.w 1
		dc.l loc_7F64A
		dc.w $14
		dc.l loc_7F398
		dc.w $C
ChildObjDat_7FCAE:dc.w 0
		dc.l loc_7F6FA
ChildObjDat_7FCB4:dc.w 2
		dc.l loc_7F60A
		dc.w $F0F7
		dc.l loc_7F60A
		dc.w $F4
		dc.l loc_7F60A
		dc.w $10F7
ChildObjDat_7FCC8:dc.w 5
		dc.l loc_7F7CE
ChildObjDat_7FCCE:dc.w 1
		dc.l loc_7F7F6
byte_7FCD4:	dc.b	3,   0
		dc.b	1,   2
		dc.b  $F4
byte_7FCD9:	dc.b	3,   2
		dc.b	1,   0
		dc.b  $F4
byte_7FCDE:	dc.b	3, $11
		dc.b  $12, $FC
byte_7FCE2:	dc.b	0,   7
		dc.b	1, $17
		dc.b	0,   7
		dc.b	1,  $F
		dc.b	0, $3F
		dc.b	1,   7
		dc.b  $FC
byte_7FCEF:	dc.b  $16,   0
		dc.b  $17,   1
		dc.b  $1E,   1
		dc.b  $18,   0
		dc.b  $19,   1
		dc.b  $1E,   1
		dc.b  $1A,   0
		dc.b  $1B,   1
		dc.b  $1E,   4
		dc.b  $1C,   0
		dc.b  $1D,   1
		dc.b  $1E,   1
		dc.b  $FC
Pal_DEZEndBoss:	binclude "Levels\DEZ\Palettes\End Boss.bin"

byte_7FD28:	dc.b 0
		dc.b 1
		dc.b 2
		dc.b 3
		dc.b 4
		dc.b 5
		dc.b 6
		dc.b 7
		dc.b 8
		dc.b 9
		dc.b $A
		dc.b $B
		dc.b $C
		dc.b $D
		dc.b $D
		dc.b $E
		dc.b $F
		dc.b $10
		dc.b $11
		dc.b $12
		dc.b $13
		dc.b $14
		dc.b $15
		dc.b $15
		dc.b $16
		dc.b $17
		dc.b $18
		dc.b $19
		dc.b $19
		dc.b $1A
		dc.b $1B
		dc.b $1C
		dc.b $1C
		dc.b $1D
		dc.b $1E
		dc.b $1E
		dc.b $1F
		dc.b $20
		dc.b $20
		dc.b $21
		dc.b $21
		dc.b $22
		dc.b $22
		dc.b $23
		dc.b $23
		dc.b $24
		dc.b $24
		dc.b $25
		dc.b $25
		dc.b $25
		dc.b $26
		dc.b $26
		dc.b $26
		dc.b $27
		dc.b $27
		dc.b $27
		dc.b $27
		dc.b $27
		dc.b $28
		dc.b $28
		dc.b $28
		dc.b $28
		dc.b $28
		dc.b $28
; ---------------------------------------------------------------------------

Obj_DEZ3_Boss:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_7FD84(pc,d0.w),d1
		jsr	off_7FD84(pc,d1.w)
		move.w	$10(a0),($FFFFEED4).w
		move.w	$14(a0),($FFFFEED6).w
		rts
; ---------------------------------------------------------------------------
off_7FD84:	dc.w loc_7FD9E-off_7FD84

		dc.w loc_7FE2C-off_7FD84
		dc.w loc_7FE74-off_7FD84
		dc.w loc_7FE96-off_7FD84
		dc.w loc_7FEE2-off_7FD84
		dc.w loc_7FEF6-off_7FD84
		dc.w sub_7FF3E-off_7FD84
		dc.w loc_7FFD2-off_7FD84
		dc.w loc_8001C-off_7FD84
		dc.w loc_80058-off_7FD84
		dc.w loc_80082-off_7FD84
		dc.w loc_800DE-off_7FD84
		dc.w loc_800EE-off_7FD84
; ---------------------------------------------------------------------------

loc_7FD9E:
		move.b	#2,5(a0)
		bset	#2,4(a0)
		move.w	a0,($FFFFFAA4).w
		clr.l	($FFFFFA84).w
		lea	(ArtKosM_DEZFinalBossMisc).l,a1
		move.w	#$71E0,d2
		jsr	(Queue_Kos_Module).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_7FDD0
		move.l	#loc_80DE0,(a1)

loc_7FDD0:
		jsr	(Create_New_Sprite).l
		bne.s	loc_7FDE2
		move.l	#loc_80D72,(a1)
		move.w	a0,$46(a1)

loc_7FDE2:
		lea	($FFFFB000).w,a1
		move.w	#$30,$10(a1)
		move.w	#$CD,$14(a1)
		bsr.w	sub_7FE06
		lea	($FFFFB04A).w,a1
		move.w	#$10,$10(a1)
		move.w	#$CD,$14(a1)

; =============== S U B R O U T I N E =======================================


sub_7FE06:
		move.b	#-$7F,$2E(a1)
		move.b	#0,$20(a1)
		move.w	#$600,$18(a1)
		move.w	#$600,$1C(a1)
		cmpi.b	#1,$38(a1)
		bne.s	locret_7FE2A
		addq.w	#4,$14(a1)

locret_7FE2A:
		rts
; End of function sub_7FE06

; ---------------------------------------------------------------------------

loc_7FE2C:
		bsr.w	sub_7FE5C
		move.w	($FFFFEE78).w,d1
		addi.w	#$98,d1
		cmp.w	d1,d0
		bcs.s	locret_7FE5A
		move.b	#4,5(a0)
		clr.b	($FFFFEE0A).w
		jsr	(Create_New_Sprite).l
		bne.s	locret_7FE5A
		move.l	#Obj_Song_Fade_Transition,(a1)
		move.b	#$30,$2C(a1)

locret_7FE5A:

		rts

; =============== S U B R O U T I N E =======================================


sub_7FE5C:

		lea	($FFFFB04A).w,a1
		bsr.w	sub_7FE68
		lea	($FFFFB000).w,a1
; End of function sub_7FE5C


; =============== S U B R O U T I N E =======================================


sub_7FE68:
		move.w	$10(a1),d0
		addq.w	#6,d0
		move.w	d0,$10(a1)
		rts
; End of function sub_7FE68

; ---------------------------------------------------------------------------

loc_7FE74:
		bsr.s	sub_7FE5C
		cmpi.w	#$360,d0
		bcs.s	locret_7FE94
		move.b	#6,5(a0)
		bsr.w	sub_7FE8A
		lea	($FFFFB04A).w,a1

; =============== S U B R O U T I N E =======================================


sub_7FE8A:
		jsr	Stop_Object(pc)
		move.b	#5,$20(a1)

locret_7FE94:
		rts
; End of function sub_7FE8A

; ---------------------------------------------------------------------------

loc_7FE96:
		btst	#1,($FFFFFAB8).w
		beq.s	locret_7FEE0
		move.b	#8,5(a0)
		move.w	#$BF,$2E(a0)
		move.w	#-$80,$1A(a0)
		clr.b	($FFFFB02E).w
		clr.b	($FFFFB078).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_7FEC6
		move.l	#loc_8642E,(a1)

loc_7FEC6:
		lea	(PLC_83D64).l,a1
		jsr	(Load_PLC_Raw).l
		jsr	(Create_New_Sprite).l
		bne.s	locret_7FEE0
		move.l	#loc_810A0,(a1)

locret_7FEE0:

		rts
; ---------------------------------------------------------------------------

loc_7FEE2:
		jsr	(MoveSprite2).l
		subq.w	#1,$2E(a0)
		bpl.s	locret_7FEF4
		move.b	#$A,5(a0)

locret_7FEF4:
		rts
; ---------------------------------------------------------------------------

loc_7FEF6:
		btst	#2,($FFFFFAB8).w
		beq.s	locret_7FF3C
		move.b	#$C,5(a0)
		move.w	$14(a0),$3A(a0)
		move.w	#1,$40(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_7FF22
		move.l	#loc_804F0,(a1)
		move.w	a0,$46(a1)

loc_7FF22:
		jsr	(Create_New_Sprite).l
		bne.s	loc_7FF34
		move.l	#loc_806DA,(a1)
		move.w	a0,$46(a1)

loc_7FF34:
		lea	ChildObjDat_81310(pc),a2
		jsr	CreateChild6_Simple(pc)

locret_7FF3C:
		rts

; =============== S U B R O U T I N E =======================================


sub_7FF3E:

		move.w	$40(a0),d0
		add.w	d0,$10(a0)
		move.b	$26(a0),d0
		addq.b	#2,d0
		andi.b	#$7F,d0
		move.b	d0,$26(a0)
		beq.s	loc_7FF6A
		jsr	(GetSineCosine).l
		asr.w	#4,d0
		move.w	$3A(a0),d1
		sub.w	d0,d1
		move.w	d1,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_7FF6A:
		move.b	#$E,5(a0)
		move.w	#$1F,$2E(a0)
		move.w	#$14,($FFFFEECC).w
		moveq	#-$65,d0
		jsr	(Play_Sound_2).l
		moveq	#0,d0
		move.b	$30(a0),d0
		jmp	loc_7FF8E(pc,d0.w)
; End of function sub_7FF3E

; ---------------------------------------------------------------------------

loc_7FF8E:
		bra.w	loc_7FF9A
; ---------------------------------------------------------------------------
		bra.w	loc_7FFB2
; ---------------------------------------------------------------------------
		bra.w	loc_7FFBC
; ---------------------------------------------------------------------------

loc_7FF9A:
		move.l	#loc_7FFD8,$34(a0)
		cmpi.w	#$540,$10(a0)
		bcs.s	locret_7FFD0
		move.b	#4,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_7FFB2:
		move.l	#loc_8000E,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_7FFBC:
		move.b	#$18,5(a0)
		move.w	#$F,$2E(a0)
		move.l	#loc_800D0,$34(a0)

locret_7FFD0:
		rts
; ---------------------------------------------------------------------------

loc_7FFD2:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_7FFD8:

		move.b	#$C,5(a0)
		moveq	#1,d2
		move.w	($FFFFB010).w,d0
		cmpi.w	#$610,d0
		bcc.s	loc_7FFFA
		move.w	$10(a0),d1
		subi.w	#$80,d1
		cmp.w	d1,d0
		bcc.s	loc_80008
		bra.w	loc_80006
; ---------------------------------------------------------------------------

loc_7FFFA:
		move.w	$10(a0),d1

loc_7FFFE:
		addi.w	#$80,d1
		cmp.w	d1,d0
		bcc.s	loc_80008

loc_80006:
		neg.w	d2

loc_80008:

		move.w	d2,$40(a0)
		rts
; ---------------------------------------------------------------------------

loc_8000E:
		move.b	#$10,5(a0)

loc_80014:
		bset	#1,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_8001C:
		cmpi.w	#-1,($FFFFFA82).w
		beq.s	loc_80030
		btst	#1,$38(a0)
		beq.w	loc_7FFD8
		rts
; ---------------------------------------------------------------------------

loc_80030:
		move.b	#$12,5(a0)
		bset	#5,$38(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_8004A
		move.l	#loc_8642E,(a1)

loc_8004A:
		move.w	($FFFFEE78).w,d0
		move.w	d0,($FFFFEE16).w
		move.w	d0,($FFFFEE14).w
		rts
; ---------------------------------------------------------------------------

loc_80058:
		move.w	$14(a0),d0
		addq.w	#1,d0
		move.w	d0,$14(a0)
		cmpi.w	#$18F,d0
		bcs.s	locret_80080
		move.b	#$14,5(a0)
		move.w	#$6C0,($FFFFEED2).w
		move.w	($FFFFEE78).w,d0
		subi.w	#$40,d0
		move.w	d0,$10(a0)

locret_80080:
		rts
; ---------------------------------------------------------------------------

loc_80082:
		move.w	$14(a0),d0
		subq.w	#1,d0
		move.w	d0,$14(a0)
		cmpi.w	#$AF,d0
		bhi.w	locret_80C88
		move.b	#8,$30(a0)
		move.w	#$80,$1C(a0)
		move.w	$14(a0),$3A(a0)
		clr.w	$26(a0)
		st	($FFFFEE0A).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_800C0
		move.l	#loc_80590,(a1)
		move.w	a0,$46(a1)

loc_800C0:
		lea	(ArtKosM_MasterEmerald).l,a1
		move.w	#-$6600,d2
		jsr	(Queue_Kos_Module).l

loc_800D0:
		move.b	#$16,5(a0)
		move.w	#1,$40(a0)
		rts
; ---------------------------------------------------------------------------

loc_800DE:
		bsr.w	sub_80F3A
		bsr.w	sub_81046
		bsr.w	sub_7FF3E
		bra.w	sub_8100E
; ---------------------------------------------------------------------------

loc_800EE:
		bsr.w	sub_80F3A
		bsr.w	sub_81046
		addq.w	#1,$10(a0)
		bsr.w	sub_8100E
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_80102:
		jsr	(MoveSprite2).l
		cmpi.w	#$18F,$14(a0)
		bcc.s	loc_8011E
		move.w	$10(a0),($FFFFEED4).w
		move.w	$14(a0),($FFFFEED6).w
		rts
; ---------------------------------------------------------------------------

loc_8011E:
		clr.w	($FFFFEECC).w
		clr.w	($FFFFEED2).w
		bset	#5,$38(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_8013A
		move.l	#loc_80160,(a1)

loc_8013A:
		lea	(ArtKosM_KnuxFinalBossCrane).l,a1
		move.w	#-$6C60,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_DEZFinalBossDebris).l,a1
		move.w	#$2000,d2
		jsr	(Queue_Kos_Module).l
		jmp	(Go_Delete_Sprite_2).l
; ---------------------------------------------------------------------------

loc_80160:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8017A(pc,d0.w),d1
		jsr	off_8017A(pc,d1.w)
		jsr	(sub_80E2C).l
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_8017A:	dc.w loc_80184-off_8017A

		dc.w loc_801D8-off_8017A
		dc.w loc_80208-off_8017A
		dc.w loc_8023E-off_8017A
		dc.w loc_80264-off_8017A
; ---------------------------------------------------------------------------

loc_80184:
		lea	ObjDat3_812EC(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bset	#0,4(a0)
		move.b	#$F,$28(a0)
		move.b	#8,$29(a0)
		move.w	($FFFFEE80).w,d0
		addi.w	#$60,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE84).w,d0
		addi.w	#$140,d0
		move.w	d0,$14(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_801C6
		move.l	#loc_8642E,(a1)

loc_801C6:
		lea	(Child1_MakeRoboHead3).l,a2
		jsr	CreateChild1_Normal(pc)
		lea	ChildObjDat_81330(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_801D8:
		subq.w	#1,$14(a0)
		move.w	($FFFFEE7C).w,d0
		addi.w	#$50,d0
		cmp.w	$14(a0),d0
		bcs.w	locret_80C88
		move.b	#4,5(a0)
		move.w	#$500,$18(a0)
		lea	(Child1_MakeRoboShipFlame).l,a2
		jsr	CreateChild1_Normal(pc)
		jmp	(Swing_Setup1).l
; ---------------------------------------------------------------------------

loc_80208:
		bsr.w	sub_80F0E
		jsr	Swing_UpAndDown(pc)
		jsr	(MoveSprite2).l
		move.w	($FFFFEE78).w,d0
		addi.w	#$100,d0
		cmp.w	$10(a0),d0
		bhi.s	locret_8023C
		move.b	#6,5(a0)
		clr.w	$18(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_80250,$34(a0)

locret_8023C:
		rts
; ---------------------------------------------------------------------------

loc_8023E:
		bsr.w	sub_80EF4
		jsr	Swing_UpAndDown(pc)
		jsr	(MoveSprite2).l
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_80250:
		move.b	#8,5(a0)
		move.w	#$500,$18(a0)
		bset	#7,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_80264:
		bsr.w	sub_80F0E
		bsr.w	sub_80EF4
		jsr	Swing_UpAndDown(pc)
		move.w	$18(a0),d0
		cmpi.w	#$280,d0
		bls.s	loc_80282
		subi.w	#$10,d0
		move.w	d0,$18(a0)

loc_80282:
		jsr	(MoveSprite2).l
		move.w	($FFFFEE78).w,d0
		addi.w	#$100,d0
		cmp.w	$10(a0),d0
		bls.s	locret_8029A
		move.w	d0,$10(a0)

locret_8029A:
		rts
; ---------------------------------------------------------------------------

loc_8029C:
		bset	#3,($FFFFFAB8).w
		move.w	#$F,$2E(a0)
		move.l	#loc_802B2,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_802B2:
		move.l	#loc_802C0,(a0)
		bset	#4,($FFFFFAB8).w
		rts
; ---------------------------------------------------------------------------

loc_802C0:
		jsr	Swing_UpAndDown(pc)
		jsr	(MoveSprite2).l
		move.w	($FFFFEE78).w,d0
		addi.w	#$180,d0
		cmp.w	$10(a0),d0
		bcs.s	loc_802DE
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_802DE:
		move.l	#loc_8030E,(a0)
		bset	#5,($FFFFFAB8).w
		ori.b	#$30,$38(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_802FE
		move.l	#loc_8642E,(a1)

loc_802FE:
		lea	(ArtKosM_BadnikExplosion).l,a1
		move.w	#-$4C00,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

loc_8030E:
		move.l	#loc_80382,(a0)
		clr.b	$38(a0)
		move.w	($FFFFEE78).w,d0
		subi.w	#$80,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d0
		addi.w	#$80,d0
		move.w	d0,$14(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_80344
		move.b	#$16,$2C(a1)

loc_80344:
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_80358
		move.b	#$16,$2C(a1)

loc_80358:
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_8036C
		move.b	#$18,$2C(a1)

loc_8036C:
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	locret_80380
		move.b	#$18,$2C(a1)

locret_80380:
		rts
; ---------------------------------------------------------------------------

loc_80382:
		addq.w	#2,$10(a0)
		move.w	($FFFFEE78).w,d0
		addi.w	#$80,d0
		cmp.w	$10(a0),d0
		bcc.s	locret_803D4
		move.l	#loc_803D6,(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_803B4
		move.l	#loc_85E64,(a1)
		move.w	a1,$44(a0)
		move.w	#3,$3A(a1)
		rts
; ---------------------------------------------------------------------------

loc_803B4:
		lea	($FFFFC280).w,a1
		movea.l	a1,a2
		moveq	#0,d0
		moveq	#$24,d1

loc_803BE:
		move.w	d0,(a1)+
		dbf	d1,loc_803BE
		move.l	#loc_85E64,(a2)
		move.w	a2,$44(a0)
		move.w	#3,$3A(a2)

locret_803D4:
		rts
; ---------------------------------------------------------------------------

loc_803D6:
		movea.w	$44(a0),a1
		btst	#7,$2A(a1)
		beq.s	locret_80424
		st	($FFFFEF56).w
		jsr	(SaveGame).l
		jsr	(Go_Delete_Sprite).l
		cmpi.w	#2,($FFFFFF08).w
		bcc.s	loc_8040C
		cmpi.b	#7,($FFFFFFB0).w
		bne.s	loc_8040C
		move.w	#$C00,d0
		jmp	(StartNewLevel).l
; ---------------------------------------------------------------------------

loc_8040C:

		cmpi.w	#3,($FFFFFF08).w
		beq.s	loc_8041E
		move.w	#$D01,d0
		jmp	(StartNewLevel).l
; ---------------------------------------------------------------------------

loc_8041E:
		move.b	#0,($FFFFF600).w

locret_80424:
		rts
; ---------------------------------------------------------------------------

loc_80426:
		lea	ObjDat3_81304(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_80494,(a0)
		jsr	(Random_Number).l
		move.w	#0,8(a0)
		tst.w	d0
		bpl.s	loc_8044C
		move.w	#$300,8(a0)

loc_8044C:
		andi.w	#$1FF,d0
		move.w	($FFFFEE78).w,d1
		add.w	d0,d1
		addi.w	#$20,d1
		move.w	d1,$10(a0)
		move.w	($FFFFEE7C).w,d1
		subi.w	#$20,d1
		move.w	d1,$14(a0)
		andi.b	#3,d0
		or.b	d0,4(a0)
		swap	d0
		move.w	d0,d1
		andi.w	#3,d0
		lea	RawAni_80490(pc,d0.w),a1
		move.b	(a1)+,$22(a0)
		andi.w	#$300,d1
		addi.w	#$100,d1
		move.w	d1,$1A(a0)
		rts
; ---------------------------------------------------------------------------
RawAni_80490:	dc.b	0,   1,	  2,   1
; ---------------------------------------------------------------------------

loc_80494:
		jsr	(MoveSprite2).l
		move.w	($FFFFEE7C).w,d0
		addi.w	#$108,d0
		cmp.w	$14(a0),d0
		blt.w	loc_810D0
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_804B0:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_804C4(pc,d0.w),d1
		jsr	off_804C4(pc,d1.w)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_804C4:	dc.w loc_804C8-off_804C4

		dc.w loc_804D2-off_804C4
; ---------------------------------------------------------------------------

loc_804C8:
		lea	ObjDat3_812F8(pc),a1
		jmp	(SetUp_ObjAttributes).l
; ---------------------------------------------------------------------------

loc_804D2:
		btst	#3,($FFFFFAB8).w
		bne.s	loc_804E0
		jmp	(Refresh_ChildPositionAdjusted).l
; ---------------------------------------------------------------------------

loc_804E0:
		move.l	#Wait_Draw,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_804F0:
		lea	ObjDat3_812C8(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_80512,(a0)
		move.w	#$6C,$42(a0)
		move.w	#8,$44(a0)
		move.b	#8,$29(a0)

loc_80512:

		tst.b	($FFFFFAA9).w
		bne.s	loc_8051C
		bra.w	sub_8125C
; ---------------------------------------------------------------------------

loc_8051C:
		move.l	#loc_80522,(a0)

loc_80522:
		tst.b	($FFFFFAA9).w
		bmi.s	loc_80536
		bsr.w	sub_8125C
		bsr.w	sub_81024
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_80536:
		move.l	#loc_80542,(a0)
		move.b	#$16,$28(a0)

loc_80542:
		tst.b	($FFFFFAA9).w
		bpl.s	loc_8055C
		bsr.w	sub_81024
		bsr.w	sub_8119A
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8055C:
		move.l	#loc_80562,(a0)

loc_80562:
		tst.b	($FFFFFAA9).w
		beq.s	loc_80576
		bsr.w	sub_81024
		bsr.w	sub_8125C
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_80576:
		move.l	#loc_80512,(a0)
		bclr	#7,4(a0)
		rts
; ---------------------------------------------------------------------------

loc_80584:
		clr.w	($FFFFEEE2).w
		bsr.w	sub_81024
		jmp	Child_Draw_Sprite2(pc)
; ---------------------------------------------------------------------------

loc_80590:
		move.l	#loc_805AE,(a0)
		move.b	#8,$28(a0)
		move.b	#-1,$29(a0)
		move.w	#$A0,$42(a0)
		move.w	#-$34,$44(a0)

loc_805AE:

		tst.b	$28(a0)
		beq.s	loc_805C2
		bsr.w	sub_81024
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	Child_CheckParent(pc)
; ---------------------------------------------------------------------------

loc_805C2:
		move.l	#loc_805F0,(a0)
		move.b	#-1,$29(a0)
		movea.w	$46(a0),a1
		bset	#2,$38(a1)
		st	($FFFFEEC6).w
		jsr	(Create_New_Sprite3).l
		bne.s	loc_805F0
		move.l	#loc_8060C,(a1)
		move.w	$46(a0),$46(a1)

loc_805F0:

		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		bne.s	loc_80608
		move.l	#loc_805AE,(a0)
		move.b	$25(a0),$28(a0)

loc_80608:
		jmp	Child_CheckParent(pc)
; ---------------------------------------------------------------------------

loc_8060C:
		lea	ObjDat3_812AA(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_80634,(a0)
		bset	#0,4(a0)
		move.w	#$7C,$42(a0)
		move.w	#$28,$44(a0)
		move.b	#1,($FFFFFAA9).w

loc_80634:
		move.w	$44(a0),d0
		addq.w	#4,d0
		move.w	d0,$44(a0)
		cmpi.w	#$68,d0
		bcs.s	loc_80672
		move.l	#loc_8067A,(a0)
		bset	#2,$38(a0)
		move.b	#-$80,($FFFFFAA9).w
		st	($FFFFEEC6).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_80672
		move.l	#loc_807BC,(a1)
		move.w	$46(a0),$46(a1)
		move.w	a0,$3A(a1)

loc_80672:

		bsr.w	sub_81024
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_8067A:
		btst	#2,$38(a0)
		beq.s	loc_8068A
		bsr.w	sub_81024
		jmp	Child_CheckParent(pc)
; ---------------------------------------------------------------------------

loc_8068A:
		move.l	#loc_806A6,(a0)
		move.w	#$80,$2E(a0)
		move.b	#1,($FFFFFAA9).w
		st	($FFFFEEC6).w
		move.b	#1,($FFFFFAA9).w

loc_806A6:
		move.w	$44(a0),d0
		subq.w	#4,d0
		move.w	d0,$44(a0)
		cmpi.w	#$28,d0
		bhi.s	loc_806D2
		movea.w	$46(a0),a1
		bclr	#2,$38(a1)
		clr.w	$1C(a1)
		clr.b	($FFFFFAA9).w
		st	($FFFFEEC6).w
		jsr	(Go_Delete_Sprite).l

loc_806D2:
		bsr.w	sub_81024
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_806DA:

		lea	ObjDat3_812D4(pc),a1
		jsr	(SetUp_ObjAttributes).l
		lea	($FFFFFFB2).w,a1
		moveq	#3,d0
		moveq	#6,d1

loc_806EC:
		cmp.b	(a1)+,d0
		bne.s	loc_8070A
		dbf	d1,loc_806EC
		st	$3A(a0)
		lea	word_813AA(pc),a1
		lea	($FFFFFADE).w,a2
		moveq	#3,d0

loc_80702:
		move.l	(a1)+,(a2)+
		dbf	d0,loc_80702
		clr.w	(a2)

loc_8070A:
		tst.b	$2C(a0)
		bne.s	loc_80724
		move.l	#loc_80730,(a0)
		move.w	#$58,$42(a0)
		move.w	#8,$44(a0)
		rts
; ---------------------------------------------------------------------------

loc_80724:
		move.l	#loc_80760,(a0)
		clr.b	$22(a0)
		rts
; ---------------------------------------------------------------------------

loc_80730:
		tst.b	$3A(a0)
		beq.s	loc_8073A
		jsr	Run_PalRotationScript(pc)

loc_8073A:
		bsr.w	sub_81024
		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		bne.w	loc_810D0
		tst.b	($FFFFFAA9).w
		beq.s	loc_80758
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_80758:
		bclr	#7,4(a0)
		rts
; ---------------------------------------------------------------------------

loc_80760:
		tst.b	$3A(a0)
		beq.s	loc_8076A
		jsr	Run_PalRotationScript(pc)

loc_8076A:
		jsr	Refresh_ChildPosition(pc)
		btst	#4,($FFFFFAB8).w
		beq.s	loc_8077C
		move.l	#loc_80782,(a0)

loc_8077C:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_80782:
		tst.b	$3A(a0)
		beq.s	loc_8078C
		jsr	Run_PalRotationScript(pc)

loc_8078C:
		jsr	(MoveSprite).l
		cmpi.w	#$CF,$14(a0)
		bcs.s	loc_807A6
		move.l	#loc_807AC,(a0)
		move.w	#$CF,$14(a0)

loc_807A6:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_807AC:
		tst.b	$3A(a0)
		beq.s	loc_807B6
		jsr	Run_PalRotationScript(pc)

loc_807B6:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_807BC:
		lea	ObjDat3_812B6(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_807EE,(a0)
		move.w	#$58,$42(a0)
		move.w	#4,$44(a0)
		move.l	#loc_80802,$34(a0)
		move.b	#$13,$39(a0)
		moveq	#$53,d0
		jsr	(Play_Sound_2).l

loc_807EE:
		bsr.w	sub_80FFA
		lea	byte_8135A(pc),a1
		jsr	Animate_RawNoSSTMultiDelay(pc)
		bsr.w	sub_81024
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_80802:
		move.l	#loc_80810,(a0)
		move.w	#$78,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_80810:
		subq.w	#1,$2E(a0)
		bmi.s	loc_8083C
		cmpi.w	#$28,$2E(a0)
		bcs.s	loc_80822
		bsr.w	sub_80FFA

loc_80822:
		move.b	#$1A,$22(a0)
		btst	#0,d0
		bne.s	loc_80834
		move.b	#$1F,$22(a0)

loc_80834:
		bsr.w	sub_81024
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_8083C:
		move.l	#loc_8086C,(a0)
		addi.w	#$34,$42(a0)
		addi.w	#4,$44(a0)
		lea	byte_81397(pc),a1
		jsr	Set_Raw_Animation(pc)
		move.l	#loc_80888,$34(a0)
		bclr	#7,4(a0)
		moveq	#$4E,d0
		jsr	(Play_Sound_2).l

loc_8086C:
		jsr	Animate_RawMultiDelay(pc)
		beq.s	loc_8087C
		moveq	#0,d0
		move.b	$22(a0),d0
		move.w	d0,($FFFFEEE2).w

loc_8087C:
		bsr.w	sub_80FA6
		bsr.w	sub_81024
		jmp	Child_CheckParent(pc)
; ---------------------------------------------------------------------------

loc_80888:
		move.l	#loc_80894,(a0)
		move.w	#$5F,$2E(a0)

loc_80894:
		subq.w	#1,$2E(a0)
		bmi.s	loc_8089E
		jmp	Child_CheckParent(pc)
; ---------------------------------------------------------------------------

loc_8089E:
		movea.w	$3A(a0),a1
		bclr	#2,$38(a1)
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_808AE:
		lea	word_812C2(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_808FA,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		movea.w	$46(a0),a1
		move.w	$10(a1),d2
		addi.w	#$64,d2
		move.w	$14(a1),d3
		addq.w	#4,d3
		jsr	(Random_Number).l
		andi.w	#$1F,d0
		add.w	d0,d2
		swap	d0
		andi.w	#$7F,d0
		subi.w	#$40,d0
		add.w	d0,d3
		move.w	d2,$10(a0)
		move.w	d3,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_808FA:
		lea	byte_8138E(pc),a1
		jsr	Animate_RawNoSSTMultiDelay(pc)
		subi.w	#$40,$18(a0)
		movea.w	$46(a0),a1
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		jsr	(GetSineCosine).l
		add.w	d0,d0
		move.w	d0,$1A(a0)
		jsr	(MoveSprite2).l
		move.w	$10(a1),d0
		addi.w	#$3C,d0
		cmp.w	$10(a0),d0
		bcs.s	loc_8093A
		jsr	(Go_Delete_Sprite).l

loc_8093A:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_DEZ3_Boss_Fireball:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_80952(pc,d0.w),d1
		jsr	off_80952(pc,d1.w)
		bra.w	sub_81024
; ---------------------------------------------------------------------------
off_80952:	dc.w loc_80956-off_80952

		dc.w loc_80980-off_80952
; ---------------------------------------------------------------------------

loc_80956:
		move.b	#2,5(a0)
		bset	#2,4(a0)
		clr.b	$39(a0)
		clr.b	$23(a0)
		move.w	#$B0,$42(a0)
		move.w	#-$18,$44(a0)
		moveq	#$48,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_80980:
		subq.w	#1,$2E(a0)
		bpl.w	locret_80C88
		cmpi.w	#$C7,$14(a0)
		bcc.s	loc_809CA
		move.w	#1,$2E(a0)
		move.b	$23(a0),d0
		move.b	d0,d1
		addq.b	#1,d0
		cmpi.b	#3,d0
		bcs.s	loc_809A6
		moveq	#0,d0

loc_809A6:
		move.b	d0,$23(a0)
		andi.w	#3,d1
		add.w	d1,d1
		lea	byte_809EE(pc,d0.w),a1
		move.b	(a1)+,d0
		ext.w	d0
		add.w	d0,$42(a0)
		move.b	(a1)+,d0
		ext.w	d0
		add.w	d0,$44(a0)
		moveq	#0,d2
		bra.w	sub_8106E
; ---------------------------------------------------------------------------

loc_809CA:
		move.l	#loc_809F4,(a0)
		move.w	#$CF,$14(a0)
		clr.b	$23(a0)
		move.w	#2,$2E(a0)
		bsr.w	sub_80A26
		moveq	#2,d2
		bsr.w	sub_8106E
		addq.w	#4,sp
		rts
; ---------------------------------------------------------------------------
byte_809EE:	dc.b	8,   8
		dc.b  $FC,   4
		dc.b   $C,  $C
; ---------------------------------------------------------------------------

loc_809F4:
		subq.w	#1,$2E(a0)
		bpl.s	sub_80A26
		move.w	#2,$2E(a0)
		addq.w	#8,$42(a0)
		cmpi.w	#$300,$42(a0)
		bcc.w	loc_810D0
		moveq	#8,d0
		moveq	#1,d2
		bchg	#0,$23(a0)
		beq.s	loc_80A1E
		neg.w	d0
		moveq	#2,d2

loc_80A1E:
		add.w	d0,$14(a0)
		bsr.w	sub_8106E

; =============== S U B R O U T I N E =======================================


sub_80A26:

		movea.w	$46(a0),a1
		move.w	$42(a0),d0
		move.w	$10(a1),d1
		add.w	d0,d1
		move.w	d1,$10(a0)
		rts
; End of function sub_80A26

; ---------------------------------------------------------------------------

loc_80A3A:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_80A5C(pc,d0.w),d1
		jsr	off_80A5C(pc,d1.w)
		tst.b	$2C(a0)
		bne.s	loc_80A56
		bsr.w	sub_81024
		jmp	Draw_And_Touch_Sprite(pc)
; ---------------------------------------------------------------------------

loc_80A56:
		bsr.s	sub_80A26
		jmp	Draw_And_Touch_Sprite(pc)
; ---------------------------------------------------------------------------
off_80A5C:	dc.w loc_80A60-off_80A5C

		dc.w loc_80A98-off_80A5C
; ---------------------------------------------------------------------------

loc_80A60:
		lea	ObjDat3_8129E(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bset	#4,$2B(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		cmpi.b	#2,d0
		bne.s	loc_80A82
		bset	#0,4(a0)

loc_80A82:
		lsl.w	#2,d0
		move.l	off_80A8C(pc,d0.w),$30(a0)
		rts
; ---------------------------------------------------------------------------
off_80A8C:	dc.l byte_80AD4
		dc.l byte_80AEE
		dc.l byte_80B08
; ---------------------------------------------------------------------------

loc_80A98:
		subq.b	#1,$24(a0)
		bpl.s	locret_80ACE
		moveq	#0,d0
		move.b	$23(a0),d0
		addq.b	#4,d0
		move.b	d0,$23(a0)
		movea.l	$30(a0),a1
		lea	(a1,d0.w),a1
		move.b	(a1)+,d1
		bmi.s	loc_80AD0
		move.b	d1,$22(a0)
		move.b	(a1)+,$24(a0)
		move.b	(a1)+,d0
		ext.w	d0
		add.w	d0,$42(a0)
		move.b	(a1)+,d0
		ext.w	d0
		add.w	d0,$44(a0)

locret_80ACE:
		rts
; ---------------------------------------------------------------------------

loc_80AD0:
		jmp	Go_Delete_Sprite(pc)
; ---------------------------------------------------------------------------
byte_80AD4:	dc.b    6,   0,   0,   0,   7,   1,   0,   4,   8,   4,   0,   4,   9,   4,   0,   0,  $A,   5,   0,   4
		dc.b   $B,   5,   0,   0, $FF, $F4
byte_80AEE:	dc.b   $C,   0,   0,   0,  $D,   1,   4, $FC,  $E,   4,   4, $FC,  $F,   4,   0,   0, $10,   5,   0,   0
		dc.b  $11,   5,   0,   4, $FF, $F4
byte_80B08:	dc.b   $C,   0,   0,   0,  $D,   1,   4, $FC,  $E,   4,   4, $FC,  $F,   4,   0,   0, $10,   5,   0,   0
		dc.b  $12,   5,   4, $FC, $FF, $F4
; ---------------------------------------------------------------------------

loc_80B22:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_80B58(pc,d0.w),d1
		jsr	off_80B58(pc,d1.w)
		move.b	$3A(a0),d0
		andi.b	#7,d0
		cmpi.b	#7,d0
		beq.s	loc_80B42
		bra.w	sub_80A26
; ---------------------------------------------------------------------------

loc_80B42:
		lea	($FFFFFA82).w,a1
		tst.b	$2C(a0)
		beq.s	loc_80B50
		lea	($FFFFFA83).w,a1

loc_80B50:
		st	(a1)
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------
off_80B58:	dc.w loc_80B66-off_80B58

		dc.w loc_80B90-off_80B58
		dc.w loc_80C2A-off_80B58
		dc.w loc_80C58-off_80B58
		dc.w loc_80C8A-off_80B58
		dc.w loc_80CA6-off_80B58
		dc.w loc_80C2A-off_80B58
; ---------------------------------------------------------------------------

loc_80B66:
		move.b	#2,5(a0)
		move.b	#3,$39(a0)
		lea	ChildObjDat_81316(pc),a2
		jsr	CreateChild1_Normal(pc)
		move.w	#-$80,d0
		tst.b	$2C(a0)
		beq.s	loc_80B86
		neg.w	d0

loc_80B86:
		move.w	d0,$42(a0)
		move.w	#$E3,$14(a0)

loc_80B90:
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		bne.s	loc_80C0E
		move.w	($FFFFB010).w,d0
		move.w	$10(a0),d1
		move.b	$3A(a0),d2
		moveq	#0,d3
		lsr.b	#1,d2
		bcc.s	loc_80BB6
		moveq	#-$20,d3
		lsr.b	#1,d2
		bcc.s	loc_80BB6
		moveq	#$20,d3

loc_80BB6:

		add.w	d3,d1
		sub.w	d1,d0
		smi	d1
		bpl.s	loc_80BC0
		neg.w	d0

loc_80BC0:
		cmpi.w	#$80,d0
		bcc.s	locret_80C0C
		cmpi.w	#4,d0
		bls.s	locret_80C0C
		move.w	#-$80,d0
		tst.b	$2C(a0)
		beq.s	loc_80BD8
		neg.w	d0

loc_80BD8:
		move.w	$42(a0),d2
		move.b	$3A(a0),d3
		moveq	#2,d4
		moveq	#2,d5

loc_80BE4:
		lsr.b	#1,d3
		bcc.s	loc_80BEA
		addq.w	#2,d4

loc_80BEA:
		dbf	d5,loc_80BE4
		tst.b	d1
		bne.s	loc_80C00
		addi.w	#$40,d0
		cmp.w	d0,d2
		bge.s	locret_80C0C
		add.w	d4,$42(a0)
		rts
; ---------------------------------------------------------------------------

loc_80C00:
		subi.w	#$40,d0
		cmp.w	d0,d2
		blt.s	locret_80C0C
		sub.w	d4,$42(a0)

locret_80C0C:

		rts
; ---------------------------------------------------------------------------

loc_80C0E:
		move.b	#4,5(a0)
		move.w	#-$80,$1A(a0)
		move.w	#7,$2E(a0)
		move.l	#loc_80C34,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_80C2A:
		jsr	(MoveSprite2).l
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_80C34:
		move.w	#$10,$2E(a0)
		clr.w	$1A(a0)
		move.l	#loc_80C48,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_80C48:
		move.b	#6,5(a0)
		move.l	#loc_80C60,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_80C58:
		lea	byte_8133E(pc),a1
		jmp	Animate_RawNoSSTMultiDelay(pc)
; ---------------------------------------------------------------------------

loc_80C60:
		move.b	#8,5(a0)
		move.w	#$2F,$2E(a0)
		bset	#1,$38(a0)
		move.b	$39(a0),d0
		lsl.w	#2,d0
		andi.w	#$C,d0
		move.w	d0,($FFFFEECC).w
		moveq	#-$65,d0
		jsr	(Play_Sound_2).l

locret_80C88:

		rts
; ---------------------------------------------------------------------------

loc_80C8A:
		subq.w	#1,$2E(a0)
		bpl.s	locret_80CA4
		move.b	#$A,5(a0)
		bclr	#1,$38(a0)
		move.l	#loc_80CAE,$34(a0)

locret_80CA4:
		rts
; ---------------------------------------------------------------------------

loc_80CA6:
		lea	byte_81349(pc),a1
		jmp	Animate_RawNoSSTMultiDelay(pc)
; ---------------------------------------------------------------------------

loc_80CAE:
		move.b	#$C,5(a0)
		move.w	#$80,$1A(a0)
		move.w	#7,$2E(a0)
		move.l	#loc_80CCA,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_80CCA:
		move.b	#2,5(a0)
		move.w	#$E3,$14(a0)
		movea.w	$46(a0),a1
		bclr	#1,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_80CE2:

		lea	ObjDat3_81292(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_80CF8,(a0)
		move.b	#3,$29(a0)

loc_80CF8:

		movea.w	$46(a0),a1
		move.b	$22(a1),$22(a0)
		btst	#1,$38(a1)
		bne.s	loc_80D18
		jsr	Refresh_ChildPosition(pc)
		bsr.w	sub_810D6
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_80D18:
		move.l	#loc_80D30,(a0)
		move.b	#$1A,$28(a0)
		bset	#7,$A(a0)
		move.w	#$80,8(a0)

loc_80D30:
		movea.w	$46(a0),a1
		move.b	$22(a1),$22(a0)
		btst	#1,$38(a1)
		beq.s	loc_80D50
		jsr	Refresh_ChildPosition(pc)
		bsr.w	sub_810FA
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------

loc_80D50:
		move.l	#loc_80CF8,(a0)
		bclr	#7,$A(a0)
		move.w	#$280,8(a0)
		bra.s	loc_80CF8
; ---------------------------------------------------------------------------

loc_80D64:
		jsr	Refresh_ChildPosition(pc)
		jsr	Obj_Wait(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_80D72:
		lea	ObjDat3_81286(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_80D9E,(a0)
		movea.w	$46(a0),a1
		move.w	$10(a1),d0
		subi.w	#$10,d0
		move.w	d0,$10(a0)
		move.w	$14(a1),d0
		subi.w	#$3C,d0
		move.w	d0,$14(a0)

loc_80D9E:
		btst	#0,($FFFFFAB8).w
		beq.s	loc_80DB8
		move.l	#loc_80DBE,(a0)
		move.w	#$1F,$2E(a0)
		move.w	#-$80,$18(a0)

loc_80DB8:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_80DBE:
		subq.w	#1,$2E(a0)
		bmi.s	loc_80DD0
		jsr	(MoveSprite2).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_80DD0:
		bset	#1,($FFFFFAB8).w
		st	($FFFFEEC6).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_80DE0:
		lea	ObjDat3_812E0(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_80E02,(a0)
		move.w	#$70,$10(a0)
		move.w	#$C0,$14(a0)
		bset	#0,4(a0)

loc_80E02:
		lea	byte_81354(pc),a1
		jsr	Animate_RawNoSST(pc)
		move.w	$10(a0),d0
		addq.w	#6,d0
		move.w	d0,$10(a0)
		cmpi.w	#$3D0,d0
		bcc.s	loc_80E20
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_80E20:
		bset	#0,($FFFFFAB8).w
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_80E2C:
		tst.b	$28(a0)
		bne.s	locret_80EA2
		move.b	$29(a0),d0
		beq.s	loc_80EA4
		tst.b	$20(a0)
		bne.s	loc_80E70
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		bset	#6,$2A(a0)
		btst	#7,$38(a0)
		beq.s	loc_80E70
		lea	($FFFFB000).w,a1
		tst.b	$1C(a0)
		beq.s	loc_80E68
		lea	($FFFFB04A).w,a1

loc_80E68:
		clr.w	$18(a1)
		clr.w	$1C(a1)

loc_80E70:

		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_80E7E
		addi.w	#4,d0

loc_80E7E:
		bsr.w	sub_80ED6
		subq.b	#1,$20(a0)
		bne.s	locret_80EA2
		bclr	#6,$2A(a0)
		move.b	$25(a0),$28(a0)
		cmpi.b	#8,5(a0)
		bcs.s	locret_80EA2
		move.w	#$800,$18(a0)

locret_80EA2:

		rts
; ---------------------------------------------------------------------------

loc_80EA4:
		move.l	#Wait_Draw,(a0)
		move.w	#$2F,$2E(a0)
		move.l	#loc_8029C,$34(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_80ECC
		move.b	#4,$2C(a1)

loc_80ECC:
		moveq	#$64,d0
		jsr	(HUD_AddToScore).l
		rts
; End of function sub_80E2C


; =============== S U B R O U T I N E =======================================


sub_80ED6:
		lea	word_80EE2(pc),a1
		lea	word_80EE8(pc,d0.w),a2
		jmp	CopyWordData_3(pc)
; End of function sub_80ED6

; ---------------------------------------------------------------------------
word_80EE2:	dc.w $FC0E
		dc.w $FC1C
		dc.w $FC1E
word_80EE8:	dc.w 8
		dc.w $866
		dc.w $222
		dc.w $888
		dc.w $CCC
		dc.w $EEE

; =============== S U B R O U T I N E =======================================


sub_80EF4:

		move.b	($FFFFFE0F).w,d0
		andi.b	#$F,d0
		bne.s	locret_80F0C
		jsr	(Create_New_Sprite).l
		bne.s	locret_80F0C
		move.l	#loc_80426,(a1)

locret_80F0C:

		rts
; End of function sub_80EF4


; =============== S U B R O U T I N E =======================================


sub_80F0E:

		move.l	($FFFFFA84).w,d0
		addi.l	#$1000,d0
		cmpi.l	#$40000,d0
		bhi.s	loc_80F24
		move.l	d0,($FFFFFA84).w

loc_80F24:
		move.l	($FFFFEE78).w,d1
		add.l	d0,d1
		move.l	d1,($FFFFEE78).w
		swap	d1
		move.w	d1,($FFFFEE14).w
		move.w	d1,($FFFFEE16).w
		rts
; End of function sub_80F0E


; =============== S U B R O U T I N E =======================================


sub_80F3A:

		btst	#7,$2A(a0)
		beq.s	locret_80F9C
		move.l	#loc_80102,(a0)
		move.w	#$80,$18(a0)
		move.w	#$80,$1A(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_80F62
		move.l	#loc_8642E,(a1)

loc_80F62:
		bclr	#5,$38(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_80F7C
		move.b	#$16,$2C(a1)

loc_80F7C:
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_80F90
		move.b	#$16,$2C(a1)

loc_80F90:
		lea	PLC_80F9E(pc),a1
		jsr	(Load_PLC_Raw).l
		addq.w	#4,sp

locret_80F9C:
		rts
; End of function sub_80F3A

; ---------------------------------------------------------------------------
PLC_80F9E:	dc.w 0
		dc.l ArtNem_RobotnikShip
		dc.w $A5C0

; =============== S U B R O U T I N E =======================================


sub_80FA6:
		cmpi.b	#$1E,$22(a0)
		bne.s	locret_80FF0
		lea	word_80FF2(pc),a1
		jsr	Check_PlayerInRange(pc)
		tst.l	d0
		beq.s	locret_80FF0
		tst.w	d0
		beq.s	loc_80FD6
		movea.w	d0,a1
		tst.b	$34(a1)
		bne.s	loc_80FD6
		btst	#1,$2B(a1)
		bne.s	loc_80FD6
		move.l	d0,-(sp)
		jsr	HurtSonic_Directly(pc)
		move.l	(sp)+,d0

loc_80FD6:

		swap	d0
		tst.w	d0
		beq.s	locret_80FF0
		movea.w	d0,a1
		tst.b	$34(a1)
		bne.s	locret_80FF0
		btst	#1,$2B(a1)
		bne.s	locret_80FF0
		jsr	HurtSonic_Directly(pc)

locret_80FF0:

		rts
; End of function sub_80FA6

; ---------------------------------------------------------------------------
word_80FF2:	dc.w	  0,  $120, $FFE0,   $40

; =============== S U B R O U T I N E =======================================


sub_80FFA:

		move.b	($FFFFFE0F).w,d0
		andi.b	#3,d0
		bne.s	locret_8100C
		lea	ChildObjDat_8132A(pc),a2
		jsr	CreateChild6_Simple(pc)

locret_8100C:
		rts
; End of function sub_80FFA


; =============== S U B R O U T I N E =======================================


sub_8100E:

		move.w	$10(a0),d0
		addi.w	#$40,d0
		move.w	d0,($FFFFEE14).w
		move.w	d0,($FFFFEE16).w
		addq.w	#1,($FFFFEE78).w
		rts
; End of function sub_8100E


; =============== S U B R O U T I N E =======================================


sub_81024:

		movea.w	$46(a0),a1
		move.w	$42(a0),d0
		move.w	$10(a1),d1
		add.w	d0,d1
		move.w	d1,$10(a0)
		move.w	$44(a0),d0
		move.w	$14(a1),d1
		add.w	d0,d1
		move.w	d1,$14(a0)
		rts
; End of function sub_81024


; =============== S U B R O U T I N E =======================================


sub_81046:

		btst	#2,$38(a0)
		bne.s	locret_8106C
		subq.w	#1,$1C(a0)
		bpl.s	locret_8106C
		move.w	#$140,$1C(a0)
		jsr	(Create_New_Sprite).l
		bne.s	locret_8106C
		move.l	#Obj_DEZ3_Boss_Fireball,(a1)
		move.w	a0,$46(a1)

locret_8106C:
		rts
; End of function sub_81046


; =============== S U B R O U T I N E =======================================


sub_8106E:

		jsr	(Create_New_Sprite3).l
		bne.s	locret_8109E
		move.l	#loc_80A3A,(a1)
		move.w	$46(a0),$46(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	$42(a0),$42(a1)
		move.w	$44(a0),$44(a1)
		move.b	d2,$2C(a1)

locret_8109E:
		rts
; End of function sub_8106E

; ---------------------------------------------------------------------------

loc_810A0:
		move.w	($FFFFEE78).w,d0
		move.w	d0,($FFFFEE14).w
		move.w	#$520,d1
		cmp.w	d1,d0
		bcs.w	locret_80C88
		bset	#2,($FFFFFAB8).w
		move.w	d1,($FFFFEE14).w
		addi.w	#$A0,d1
		move.w	d1,($FFFFEE16).w
		move.w	#$2C0,($FFFFEED2).w
		addi.w	#$100,$10(a0)

loc_810D0:

		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_810D6:

		move.b	$29(a0),d0
		beq.s	loc_81140
		tst.b	$20(a0)
		beq.s	locret_810F8
		bsr.w	sub_8117A
		subq.b	#1,$20(a0)
		bne.s	locret_810F8
		bclr	#6,$2A(a0)
		move.b	$25(a0),$28(a0)

locret_810F8:

		rts
; End of function sub_810D6


; =============== S U B R O U T I N E =======================================


sub_810FA:
		cmpi.b	#4,$22(a0)
		bne.s	sub_810D6
		tst.b	$28(a0)
		bne.s	locret_8113E
		move.b	$29(a0),d0
		beq.s	loc_81140
		tst.b	$20(a0)
		bne.s	loc_81128
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		bset	#6,$2A(a0)

loc_81128:
		bsr.w	sub_8117A
		subq.b	#1,$20(a0)
		bne.s	locret_8113E
		bclr	#6,$2A(a0)
		move.b	$25(a0),$28(a0)

locret_8113E:

		rts
; ---------------------------------------------------------------------------

loc_81140:

		move.l	#loc_80D64,(a0)
		move.w	#$1F,$2E(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_81168
		move.b	#6,$2C(a1)

loc_81168:
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		movea.w	$46(a0),a1
		bset	d0,$3A(a1)
		rts
; End of function sub_810FA


; =============== S U B R O U T I N E =======================================


sub_8117A:

		movea.w	$46(a0),a1
		move.b	$22(a1),d0
		btst	#0,$20(a0)
		beq.s	loc_81190
		move.b	d0,$22(a0)
		rts
; ---------------------------------------------------------------------------

loc_81190:
		addi.b	#$13,d0
		move.b	d0,$22(a0)
		rts
; End of function sub_8117A


; =============== S U B R O U T I N E =======================================


sub_8119A:
		tst.b	$28(a0)
		bne.s	locret_81204
		tst.b	$29(a0)
		beq.s	loc_81206
		tst.b	$20(a0)
		bne.s	loc_811DA
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		lea	($FFFFB000).w,a1
		tst.b	$1C(a0)
		beq.s	loc_811C8
		lea	($FFFFB04A).w,a1

loc_811C8:
		move.w	#$600,d0
		move.w	d0,$1C(a1)
		move.w	d0,$18(a1)
		move.w	#-$300,$1A(a1)

loc_811DA:
		bset	#6,$2A(a0)
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_811EE
		addi.w	#$A,d0

loc_811EE:
		bsr.w	sub_81230
		subq.b	#1,$20(a0)
		bne.s	locret_81204
		bclr	#6,$2A(a0)
		move.b	$25(a0),$28(a0)

locret_81204:

		rts
; ---------------------------------------------------------------------------

loc_81206:
		move.l	#loc_80584,(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_81220
		move.b	#4,$2C(a1)

loc_81220:
		movea.w	$46(a0),a1
		bset	#7,$2A(a1)
		jmp	(BossDefeated_StopTimer).l
; End of function sub_8119A


; =============== S U B R O U T I N E =======================================


sub_81230:

		lea	word_8123E(pc),a1
		lea	word_81248(pc,d0.w),a2
		jmp	(CopyWordData_5).l
; End of function sub_81230

; ---------------------------------------------------------------------------
word_8123E:	dc.w $FC34
		dc.w $FC36
		dc.w $FC38
		dc.w $FC3A
		dc.w $FC3C
word_81248:	dc.w $888
		dc.w $666
		dc.w $444
		dc.w $222
		dc.w 0
		dc.w $EEE
		dc.w $EEE
		dc.w $CCC
		dc.w $AAA
		dc.w $888

; =============== S U B R O U T I N E =======================================


sub_8125C:

		tst.b	$29(a0)
		beq.s	loc_81206
		tst.b	$20(a0)
		beq.s	locret_81284
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_81276
		addi.w	#$A,d0

loc_81276:
		bsr.s	sub_81230
		subq.b	#1,$20(a0)
		bne.s	locret_81284
		bclr	#6,$2A(a0)

locret_81284:

		rts
; End of function sub_8125C

; ---------------------------------------------------------------------------
ObjDat3_81286:	dc.l Map_DEZFinalBossMisc
		dc.w $238F
		dc.w $280
		dc.b $20
		dc.b $20
		dc.b 5
		dc.b 0
ObjDat3_81292:	dc.l Map_DEZFinalBossMisc
		dc.w $238F
		dc.w $280
		dc.b $10
		dc.b $60
		dc.b 0
		dc.b 0
ObjDat3_8129E:	dc.l Map_DEZFinalBossMisc
		dc.w $A38F
		dc.w $300
		dc.b $10
		dc.b $10
		dc.b 6
		dc.b $8B
ObjDat3_812AA:	dc.l Map_DEZFinalBossMisc
		dc.w $2001
		dc.w $180
		dc.b $40
		dc.b $40
		dc.b $1E
		dc.b 0
ObjDat3_812B6:	dc.l Map_DEZFinalBossMisc
		dc.w $238F
		dc.w $180
		dc.b $10
		dc.b $24
		dc.b $1A
		dc.b 0
word_812C2:	dc.w $200
		dc.b 4
		dc.b 4
		dc.b $1B
		dc.b 0
ObjDat3_812C8:	dc.l Map_DEZFinalBossMisc
		dc.w $238F
		dc.w $280
		dc.b 4
		dc.b $20
		dc.b $18
		dc.b 0
ObjDat3_812D4:	dc.l Map_BossMasterEmerald
		dc.w $44D0
		dc.w $300
		dc.b $20
		dc.b $18
		dc.b 1
		dc.b 0
ObjDat3_812E0:	dc.l Map_FBZRobotnikRun
		dc.w $58C
		dc.w $280
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b 0
ObjDat3_812EC:	dc.l Map_RobotnikShip
		dc.w $52E
		dc.w $200
		dc.b $20
		dc.b $20
		dc.b 5
		dc.b 0
ObjDat3_812F8:	dc.l Map_KnuxFinalBossCrane
		dc.w $49D
		dc.w $200
		dc.b $14
		dc.b $14
		dc.b 0
		dc.b 0
ObjDat3_81304:	dc.l Map_DEZFinalBossDebris
		dc.w $C100
		dc.w $300
		dc.b $18
		dc.b $10
		dc.b 0
		dc.b 0
ChildObjDat_81310:dc.w 1
		dc.l loc_80B22
ChildObjDat_81316:dc.w 2
		dc.l loc_80CE2
		dc.w $F0
		dc.l loc_80CE2
		dc.w $E0F0
		dc.l loc_80CE2
		dc.w $20F0
ChildObjDat_8132A:dc.w 0
		dc.l loc_808AE
ChildObjDat_81330:dc.w 1
		dc.l loc_804B0
		dc.w $23
		dc.l loc_806DA
		dc.w $3B
byte_8133E:	dc.b	0,   1
		dc.b	1,   1
		dc.b	2,   1
		dc.b	3,   1
		dc.b	4,   0
		dc.b  $F4
byte_81349:	dc.b	4,   3
		dc.b	3,   3
		dc.b	2,   3
		dc.b	1,   3
		dc.b	0,  $F
		dc.b  $F4
byte_81354:	dc.b	2,   0
		dc.b	1,   2
		dc.b	1, $FC
byte_8135A:	dc.b  $1F,   5
		dc.b  $1A,   0
		dc.b  $1F,   5
		dc.b  $1A,   0
		dc.b  $1F,   5
		dc.b  $1A,   0
		dc.b  $1F,   4
		dc.b  $1A,   0
		dc.b  $1F,   4
		dc.b  $1A,   0
		dc.b  $1F,   3
		dc.b  $1A,   0
		dc.b  $1F,   3
		dc.b  $1A,   0
		dc.b  $1F,   2
		dc.b  $1A,   0
		dc.b  $1F,   2
		dc.b  $1A,   0
		dc.b  $1F,   1
		dc.b  $1A,   0
		dc.b  $1F,   1
		dc.b  $F4, $1A
		dc.b	0, $1F
		dc.b	0, $1A
		dc.b	0, $1F
		dc.b	0, $F4
byte_8138E:	dc.b  $1B,   7
		dc.b  $1B,   7
		dc.b  $1C,   5
		dc.b  $1D,   3
		dc.b  $F4
byte_81397:	dc.b	0,   0
		dc.b	6,   0
		dc.b   $E,   1
		dc.b  $16,   2
		dc.b  $1E,   3
		dc.b  $16,   1
		dc.b   $E,   2
		dc.b	6,   3
		dc.b	0,   0
		dc.b  $F4
word_813AA:	dc.w 4
		dc.w 0
		dc.l word_813BA
		dc.w 4
		dc.w 0
		dc.l word_813E8
word_813BA:	dc.w $FC52
		dc.w 0
		dc.w   $660,	$E,  $680,   $11,  $880,     6,	 $6A2,	   6,  $AC0,	 4,  $CE8,     4,  $AC0,     4,	 $6A2,	   6
		dc.w   $880,	 6,  $680,   $11, $FFFC
word_813E8:	dc.w $FC56
		dc.w 0
		dc.w   $6A0,	$E,  $8C0,     8,  $AC0,     8,	 $CE0,	   6,  $CE6,	 6,  $CE8,     4,  $EEC,     4,	 $CE8,	   4
		dc.w   $CE6,	 6,  $CE0,     6,  $AC0,     8,	 $8C0,	   8, $FFFC
word_8141E:	dc.w 4
		dc.w 0
		dc.l word_8142E
		dc.w 4
		dc.w 0
		dc.l word_8145C
word_8142E:	dc.w $FC72
		dc.w 0
		dc.w   $660,	$E,  $680,   $11,  $880,     6,	 $6A2,	   6,  $AC0,	 4,  $CE8,     4,  $AC0,     4,	 $6A2,	   6
		dc.w   $880,	 6,  $680,   $11, $FFFC
word_8145C:	dc.w $FC76
		dc.w 0
		dc.w   $6A0,	$E,  $8C0,     8,  $AC0,     8,	 $CE0,	   6,  $CE6,	 6,  $CE8,     4,  $EEC,     4,	 $CE8,	   4
		dc.w   $CE6,	 6,  $CE0,     6,  $AC0,     8,	 $8C0,	   8, $FFFC
; ---------------------------------------------------------------------------

loc_81492:
		bsr.w	sub_82742
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_81514(pc,d0.w),d1
		jsr	off_81514(pc,d1.w)
		move.w	($FFFFFABC).w,d0
		move.w	($FFFFFE08).w,d1
		move.w	d1,($FFFFFABC).w
		eor.w	d1,d0
		beq.s	loc_814B8
		bsr.w	sub_8151C

loc_814B8:
		tst.w	d1
		bne.s	locret_81512
		bsr.w	sub_82920
		bsr.w	sub_829D2
		btst	#1,($FFFFFAB8).w
		beq.s	locret_81512
		move.l	#loc_816FC,(a0)
		bset	#3,$38(a0)
		move.l	($FFFFEE78).w,d0
		move.l	d0,($FFFFFA86).w
		swap	d0
		move.w	d0,($FFFFFA94).w
		move.w	d0,($FFFFEE14).w
		move.w	d0,($FFFFEE16).w
		addi.w	#$140,d0
		move.w	d0,($FFFFFA92).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_81504
		move.l	#Obj_DecLevStartXGradual,(a1)

loc_81504:
		jsr	(Create_New_Sprite).l
		bne.s	locret_81512
		move.l	#Obj_IncLevEndXGradual,(a1)

locret_81512:

		rts
; ---------------------------------------------------------------------------
off_81514:	dc.w loc_81554-off_81514

		dc.w loc_8160A-off_81514
		dc.w loc_8167C-off_81514
		dc.w loc_816F4-off_81514

; =============== S U B R O U T I N E =======================================


sub_8151C:

		tst.w	d1
		bne.s	loc_81548
		lea	($FFFFB000).w,a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		move.b	#1,$2E(a1)
		clr.b	$20(a1)
		move.w	#$800,$18(a1)
		move.w	#$800,$1C(a1)
		rts
; ---------------------------------------------------------------------------

loc_81548:
		clr.w	($FFFFEE14).w
		move.w	#$7FFF,($FFFFEE16).w
		rts
; End of function sub_8151C

; ---------------------------------------------------------------------------

loc_81554:
		move.b	#2,5(a0)
		move.w	a0,($FFFFFA8E).w
		move.w	#$17,$2E(a0)
		move.w	#$400,$18(a0)
		st	($FFFFEE0A).w
		move.b	#1,($FFFFF7AA).w
		move.l	#$10000,($FFFFFA82).w
		move.l	#$800,($FFFFFA8A).w
		lea	($FFFFB000).w,a1
		bset	#7,$A(a1)
		move.b	#-$7F,$2E(a1)
		move.b	#2,$20(a1)
		clr.b	$2A(a1)
		move.w	($FFFFEE78).w,d0
		subi.w	#$20,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d0
		addi.w	#$20,d0
		move.w	d0,$14(a0)
		lea	word_81602(pc),a1
		lea	($FFFFFAB0).w,a2
		move.l	(a1)+,(a2)+
		move.l	(a1)+,(a2)+
		move.w	#0,($FFFFEE18).w
		move.w	#$120,($FFFFEE1A).w
		move.w	#$120,($FFFFEE12).w
		lea	($FFFFB04A).w,a1
		moveq	#0,d0
		moveq	#$11,d1

loc_815DC:
		move.l	d0,(a1)+
		dbf	d1,loc_815DC
		clr.w	(a1)
		jsr	(Create_New_Sprite).l
		bne.s	loc_815F2
		move.l	#loc_82722,(a1)

loc_815F2:
		lea	(ArtKosM_DDZMisc).l,a1
		move.w	#$5B60,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------
word_81602:	dc.w	$20,   $C0
		dc.w	$20,   $C0
; ---------------------------------------------------------------------------

loc_8160A:
		jsr	(MoveSprite_LightGravity).l
		subq.w	#1,$2E(a0)
		bpl.w	locret_82ABA
		move.b	#4,5(a0)
		bset	#7,$38(a0)
		addi.w	#$32,($FFFFFE20).w
		move.b	#1,($FFFFF65F).w
		move.b	#$F,($FFFFF65E).w
		move.b	#1,($FFFFFE19).w
		move.w	#$3C,($FFFFF670).w
		move.l	#Map_SuperSonic,($FFFFB00C).w
		move.b	#-$7F,($FFFFB02E).w
		move.b	#$1F,($FFFFB020).w
		move.w	#$A00,($FFFFF760).w
		move.w	#$30,($FFFFF762).w
		move.w	#$100,($FFFFF764).w
		move.b	#0,($FFFFB035).w
		bset	#1,($FFFFB02B).w
		moveq	#$46,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

loc_8167C:
		subi.w	#$20,$1A(a0)
		jsr	(MoveSprite2).l
		lea	($FFFFB000).w,a1
		tst.b	$2E(a1)
		bne.w	locret_82ABA
		move.b	#6,5(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		bset	#2,$38(a0)
		move.b	#1,$2E(a1)
		clr.b	$20(a1)
		move.w	#$1000,$18(a1)
		move.w	#$1000,$1C(a1)
		cmpi.b	#7,($FFFFFFB1).w
		beq.s	loc_816D2
		move.l	#loc_8242A,($FFFFCBC0).w
		bra.w	loc_816E8
; ---------------------------------------------------------------------------

loc_816D2:
		jsr	(sub_5FCCE).l
		move.l	#Obj_HyperSonic_19348,($FFFFCD7C).w
		move.l	#Obj_HyperSonicKnux_Trail,($FFFFCBC0).w

loc_816E8:
		lea	(PLC_83D64).l,a1
		jmp	(Load_PLC_Raw).l
; ---------------------------------------------------------------------------

loc_816F4:
		bsr.w	sub_82772
		bra.w	sub_828B2
; ---------------------------------------------------------------------------

loc_816FC:
		bsr.w	sub_82742
		bsr.w	sub_82772
		bsr.w	sub_828B2
		bsr.w	sub_829A0
		bsr.w	sub_829D2
		btst	#0,($FFFFFAB8).w
		beq.s	locret_81724
		move.l	#loc_81726,(a0)
		move.w	#$140,$3C(a0)

locret_81724:
		rts
; ---------------------------------------------------------------------------

loc_81726:
		clr.w	($FFFFFAAE).w
		move.w	($FFFFEE78).w,d0
		cmpi.w	#$7400,d0
		bcs.s	loc_81770
		move.w	#$2000,d1
		sub.w	d1,d0
		move.w	d0,($FFFFEE78).w
		jsr	(loc_1BBBE).l
		moveq	#0,d0
		lea	($FFFFE700).w,a1
		move.w	#$FF,d1

loc_8174E:
		move.l	d0,(a1)+
		dbf	d1,loc_8174E
		move.w	($FFFFEE78).w,d0
		subi.w	#$80,d0
		andi.w	#-$80,d0
		move.w	d0,($FFFFF7DA).w
		move.w	#$2000,d1
		move.w	d1,($FFFFFAAE).w
		sub.w	d1,$10(a0)

loc_81770:
		bsr.w	sub_82742
		bsr.w	sub_82772
		bsr.w	sub_828B2
		move.w	($FFFFFABC).w,d0
		move.w	($FFFFFE08).w,d1
		move.w	d1,($FFFFFABC).w
		eor.w	d1,d0
		beq.s	loc_81790
		bsr.w	sub_8151C

loc_81790:
		tst.w	d1
		bne.w	locret_82ABA
		bsr.w	sub_82920
		bra.w	sub_829D2
; ---------------------------------------------------------------------------

loc_8179E:
		lea	($FFFFB000).w,a1
		jsr	(MoveSprite).l
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	($FFFFEE7C).w,d0
		addi.w	#$F0,d0
		cmp.w	$14(a0),d0
		bcc.w	locret_82ABA
		movea.l	a0,a2
		lea	($FFFFB000).w,a1
		movea.l	a1,a0
		jsr	(Kill_Character).l
		movea.l	a2,a0
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_B6_2:
		move.w	($FFFFFAAE).w,d0
		sub.w	d0,$10(a0)
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_817FE(pc,d0.w),d1
		jsr	off_817FE(pc,d1.w)
		move.w	$10(a0),($FFFFEED4).w
		move.w	$14(a0),($FFFFEED6).w
		rts
; ---------------------------------------------------------------------------
off_817FE:	dc.w loc_8180E-off_817FE

		dc.w loc_81856-off_817FE
		dc.w loc_818B4-off_817FE
		dc.w loc_81914-off_817FE
		dc.w loc_81958-off_817FE
		dc.w loc_81A00-off_817FE
		dc.w loc_81A74-off_817FE
		dc.w loc_81B26-off_817FE
; ---------------------------------------------------------------------------

loc_8180E:
		move.b	#2,5(a0)
		bset	#1,($FFFFFAB8).w
		move.w	#$200,($FFFFEED2).w
		move.w	($FFFFEE78).w,d0
		addi.w	#$140,d0
		move.w	d0,$10(a0)
		move.w	#$A0,$14(a0)
		move.w	#$8F,$2E(a0)
		jsr	(Swing_Setup1).l
		lea	ChildObjDat_8325C(pc),a2
		jsr	CreateChild6_Simple(pc)
		lea	ChildObjDat_83262(pc),a2
		jsr	CreateChild6_Simple(pc)
		lea	ChildObjDat_83268(pc),a2
		jmp	CreateChild6_Simple(pc)
; ---------------------------------------------------------------------------

loc_81856:
		jsr	Swing_UpAndDown(pc)
		jsr	(MoveSprite2).l
		subq.w	#1,$10(a0)
		subq.w	#1,$2E(a0)
		bpl.s	locret_818B2
		move.b	#4,5(a0)
		bset	#3,$38(a0)
		move.w	($FFFFEE14).w,d0
		subi.w	#$100,d0
		move.w	d0,($FFFFFA94).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_81890
		move.l	#Obj_DecLevStartXGradual,(a1)

loc_81890:
		jsr	(Create_New_Sprite).l
		bne.s	locret_818B2
		move.l	#loc_81F94,(a1)
		move.w	a0,$46(a1)
		st	$39(a1)
		move.w	#$D8,$42(a1)
		move.w	#$80,$44(a1)

locret_818B2:

		rts
; ---------------------------------------------------------------------------

loc_818B4:
		jsr	Swing_UpAndDown(pc)
		jsr	(MoveSprite2).l
		move.w	#$160,d2
		move.w	#$130,d3
		bsr.w	sub_830C0
		move.w	($FFFFFAA4).w,d0
		beq.s	locret_81912
		movea.w	d0,a1
		btst	#7,$2A(a1)
		beq.s	locret_81912
		move.b	#6,5(a0)
		bset	#7,$2A(a0)
		move.w	#$12B,$2E(a0)
		move.l	#-$20,($FFFFFA8A).w
		jsr	(Create_New_Sprite).l
		bne.s	locret_81912
		move.l	#loc_82E9A,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	a0,$46(a1)

locret_81912:

		rts
; ---------------------------------------------------------------------------

loc_81914:
		move.w	#$160,d2
		move.w	#$130,d3
		bsr.w	sub_830C0
		subq.w	#1,$2E(a0)
		bpl.s	locret_81956
		move.b	#8,5(a0)
		move.w	#$3B,$3A(a0)
		move.b	#3,$39(a0)
		move.w	#-$300,$18(a0)
		move.w	#$100,$1A(a0)
		jsr	(Create_New_Sprite).l
		bne.s	locret_81956
		move.l	#loc_83004,(a1)
		move.w	a0,$46(a1)

locret_81956:

		rts
; ---------------------------------------------------------------------------

loc_81958:
		subq.w	#1,$3A(a0)
		bpl.s	loc_8197C
		move.w	#$59,$3A(a0)
		subq.b	#1,$39(a0)
		bmi.s	loc_8197C
		lea	($FFFFFC40).w,a1
		moveq	#$F,d0
		moveq	#$E,d1
		moveq	#-$20,d2

loc_81974:
		jsr	DecColor_Obj(pc)
		dbf	d0,loc_81974

loc_8197C:

		moveq	#$6F,d0
		jsr	(sub_85E52).l
		move.w	#$160,d2
		move.w	#$130,d3
		bsr.w	sub_830C0
		jsr	(MoveSprite2).l
		move.w	($FFFFEE1A).w,d0
		addi.w	#$D0,d0
		cmp.w	$14(a0),d0
		bcc.w	locret_82ABA
		move.b	#$A,5(a0)
		ori.b	#$30,$38(a0)
		move.w	#$1F,$2E(a0)
		moveq	#$4E,d0
		jsr	(Play_Sound_2).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_819CE
		move.l	#loc_83108,(a1)

loc_819CE:
		lea	(Pal_DDZ+$20).l,a1
		lea	($FFFFFC40).w,a2
		moveq	#7,d6

loc_819DA:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_819DA
		lea	($FFFFFC00).w,a1
		lea	($FFFFFC80).w,a2
		moveq	#$1F,d6

loc_819EA:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_819EA
		lea	(ArtKosM_MasterEmerald).l,a1
		move.w	#-$6600,d2
		jmp	(Queue_Kos_Module).l
; ---------------------------------------------------------------------------

loc_81A00:
		subq.w	#1,$2E(a0)
		bpl.w	locret_82ABA
		move.b	#$C,5(a0)
		bclr	#7,$2A(a0)
		andi.b	#-$31,$38(a0)
		move.w	($FFFFFA8E).w,d0
		beq.s	loc_81A28
		movea.w	d0,a1
		andi.b	#-$D,$38(a1)

loc_81A28:
		move.w	#$600,($FFFFEED2).w
		move.w	($FFFFEE78).w,d0
		move.w	d0,($FFFFEE14).w
		move.w	d0,($FFFFEE16).w
		subi.w	#$80,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d0
		move.w	d0,($FFFFEE18).w
		move.w	d0,($FFFFEE1A).w
		move.w	d0,($FFFFEE12).w
		addi.w	#$E0,d0
		move.w	d0,$14(a0)
		clr.w	$18(a0)
		move.w	#-$200,$1A(a0)
		lea	ChildObjDat_83274(pc),a2
		jsr	CreateChild6_Simple(pc)
		lea	ChildObjDat_83282(pc),a2
		jmp	CreateChild6_Simple(pc)
; ---------------------------------------------------------------------------

loc_81A74:
		jsr	(MoveSprite2).l
		move.w	($FFFFEE7C).w,d0
		addi.w	#$20,d0
		cmp.w	$14(a0),d0
		bcs.s	loc_81A9C
		bset	#7,$38(a0)
		bne.s	loc_81A9C
		moveq	#$48,d0
		jsr	(Play_Sound_2).l
		clr.w	$1A(a0)

loc_81A9C:

		addi.w	#$10,$18(a0)
		move.w	($FFFFEE78).w,d0
		addi.w	#$1C0,d0
		cmp.w	$10(a0),d0
		bhi.s	locret_81B24
		move.b	#$E,5(a0)
		bclr	#4,$38(a0)
		move.l	#$800,($FFFFFA8A).w
		bset	#0,($FFFFFAB8).w
		move.b	#7,$29(a0)
		clr.w	$2E(a0)
		clr.w	$18(a0)
		jsr	(Swing_Setup1).l
		move.w	#0,d0
		move.w	d0,($FFFFFA96).w
		addi.w	#$C0,d0
		move.w	d0,$14(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_81AFC
		move.l	#Obj_DecLevStartYGradual,(a1)

loc_81AFC:
		move.w	#$120,d0
		move.w	d0,($FFFFFA98).w
		move.w	d0,($FFFFEE12).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_81B16
		move.l	#Obj_IncLevEndYGradual,(a1)

loc_81B16:
		move.w	($FFFFFA8E).w,d0
		beq.s	locret_81B24
		movea.w	d0,a1
		bset	#2,$38(a1)

locret_81B24:

		rts
; ---------------------------------------------------------------------------

loc_81B26:
		jsr	Swing_UpAndDown(pc)
		jsr	(MoveSprite2).l
		move.w	#$40,d2
		move.w	#$60,d3
		movea.w	($FFFFFA8E).w,a1
		move.b	$18(a1),d1
		bmi.s	loc_81B44
		moveq	#0,d1

loc_81B44:
		ext.w	d1
		neg.w	d1
		asr.w	#1,d1
		btst	#3,($FFFFF604).w
		bne.s	loc_81B68
		move.w	$10(a0),d0
		addi.w	#2,d0
		add.w	d1,d0
		move.w	($FFFFEE16).w,d1
		add.w	d2,d1
		cmp.w	d1,d0
		bcs.s	loc_81B7C
		rts
; ---------------------------------------------------------------------------

loc_81B68:
		move.w	$10(a0),d0
		addi.w	#-2,d0
		add.w	d1,d0
		move.w	($FFFFEE14).w,d1
		add.w	d3,d1
		cmp.w	d1,d0
		bls.s	loc_81B82

loc_81B7C:
		swap	d0
		move.l	d0,$10(a0)

loc_81B82:
		move.l	$10(a0),d0
		addi.l	#$70000,d0
		tst.b	$20(a0)
		beq.s	loc_81B98
		addi.l	#$80000,d0

loc_81B98:
		move.l	($FFFFEE14).w,d1
		addi.l	#$600000,d1
		cmp.l	d1,d0
		bcs.s	loc_81BB0
		addi.l	#$1500000,d1
		cmp.l	d1,d0
		bcs.s	loc_81BB2

loc_81BB0:
		move.l	d1,d0

loc_81BB2:
		move.l	d0,$10(a0)
		bsr.w	sub_8307C
		bra.w	loc_82DCE
; ---------------------------------------------------------------------------

loc_81BBE:
		move.w	($FFFFFAAE).w,d0
		sub.w	d0,$10(a0)
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_81BEA(pc,d0.w),d1
		jsr	off_81BEA(pc,d1.w)
		move.w	($FFFFFA90).w,d0
		add.w	d0,$10(a0)
		move.w	$10(a0),($FFFFEED4).w
		move.w	$14(a0),($FFFFEED6).w
		rts
; ---------------------------------------------------------------------------
off_81BEA:	dc.w loc_81BF2-off_81BEA

		dc.w loc_81C2C-off_81BEA
		dc.w loc_81C70-off_81BEA
		dc.w loc_81CA4-off_81BEA
; ---------------------------------------------------------------------------

loc_81BF2:
		move.w	($FFFFEE78).w,d0
		addq.w	#1,d0
		move.w	d0,($FFFFEE78).w
		addi.w	#$40,d0
		cmp.w	$10(a0),d0
		bcs.s	locret_81C2A
		move.b	#2,5(a0)
		bset	#4,$38(a0)
		move.w	#$40,$2E(a0)
		jsr	(Create_New_Sprite).l
		bne.s	locret_81C2A
		move.l	#loc_8303E,(a1)
		move.w	a0,$46(a1)

locret_81C2A:

		rts
; ---------------------------------------------------------------------------

loc_81C2C:
		move.b	($FFFFFE0F).w,d0
		andi.b	#7,d0
		bne.s	loc_81C3E
		moveq	#$4E,d0
		jsr	(Play_Sound_2).l

loc_81C3E:
		addi.w	#$10,$1A(a0)
		jsr	(MoveSprite2).l
		subq.w	#1,$2E(a0)
		bpl.s	locret_81C6E
		move.b	#4,5(a0)
		jsr	(Create_New_Sprite).l
		bne.s	locret_81C6E
		move.l	#loc_85E64,(a1)
		move.w	a1,$44(a0)
		move.w	#7,$3A(a1)

locret_81C6E:

		rts
; ---------------------------------------------------------------------------

loc_81C70:
		movea.w	($FFFFFA8E).w,a1
		addq.w	#8,$10(a1)
		addi.w	#$10,$1A(a0)
		jsr	(MoveSprite2).l
		movea.w	$44(a0),a1
		btst	#7,$2A(a1)
		beq.w	locret_82ABA
		move.b	#6,5(a0)
		move.w	#$1F,$2E(a0)
		clr.b	($FFFFF65F).w
		rts
; ---------------------------------------------------------------------------

loc_81CA4:
		subq.w	#1,$2E(a0)
		bpl.w	locret_82ABA
		st	($FFFFEF56).w
		jsr	(SaveGame).l
		move.w	#$D01,d0
		jsr	(StartNewLevel).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_81CC6:
		lea	ObjDat3_83226(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_81D0E,(a0)
		move.b	$43(a0),$3C(a0)
		movea.w	$46(a0),a1
		move.w	$46(a1),$44(a0)
		lea	($FFFFFFB2).w,a1
		moveq	#3,d0
		moveq	#6,d1

loc_81CEC:
		cmp.b	(a1)+,d0
		bne.s	locret_81D0C
		dbf	d1,loc_81CEC
		st	$3A(a0)
		lea	(word_8141E).l,a1
		lea	($FFFFFADE).w,a2
		moveq	#3,d0

loc_81D04:
		move.l	(a1)+,(a2)+
		dbf	d0,loc_81D04
		clr.w	(a2)

locret_81D0C:
		rts
; ---------------------------------------------------------------------------

loc_81D0E:
		movea.w	$46(a0),a1
		move.b	$22(a1),d0
		subi.b	#$3A,d0
		move.b	$3C(a0),d1
		add.b	d0,d1
		move.b	d1,$43(a0)
		jsr	Refresh_ChildPosition(pc)
		tst.b	$3A(a0)
		beq.s	loc_81D32
		jsr	Run_PalRotationScript(pc)

loc_81D32:
		movea.w	$44(a0),a1
		btst	#4,$38(a1)
		bne.s	loc_81D44
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_81D44:
		move.l	#loc_81D4A,(a0)

loc_81D4A:
		move.w	($FFFFFAAE).w,d0
		sub.w	d0,$10(a0)
		lea	($FFFFB000).w,a1
		move.w	$10(a1),d0
		cmp.w	$10(a0),d0
		bcs.s	loc_81D64
		move.w	d0,$10(a0)

loc_81D64:
		move.w	($FFFFFA90).w,d0
		add.w	d0,$10(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_81D72:
		lea	ObjDat3_8320E(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_81DCC,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		lea	word_81DB4(pc,d0.w),a1
		move.w	(a1)+,$42(a0)
		move.w	(a1)+,$44(a0)
		move.l	off_81DC0(pc,d0.w),$30(a0)
		lsr.w	#2,d0
		move.b	byte_81DB0(pc,d0.w),$22(a0)
		tst.w	d0
		bne.w	locret_82ABA
		lea	ChildObjDat_8327A(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------
byte_81DB0:	dc.b $3A
		dc.b 5
		dc.b $3D
		dc.b 0
word_81DB4:	dc.w	$64,   $4C
		dc.w	$10,   $20
		dc.w	$1C,   $8C
off_81DC0:	dc.l byte_832D0
		dc.l 0
		dc.l byte_832D9
; ---------------------------------------------------------------------------

loc_81DCC:
		move.l	$30(a0),d0
		beq.s	loc_81DD8
		movea.l	d0,a1
		jsr	Animate_RawNoSSTMultiDelay(pc)

loc_81DD8:
		bsr.w	sub_82C86
		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		beq.s	loc_81E16
		move.l	#loc_81E28,(a0)
		bset	#7,$2A(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		move.l	word_81E1C(pc,d0.w),$18(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_81E16
		move.b	#4,$2C(a1)

loc_81E16:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
word_81E1C:	dc.w	$80, $FE00
		dc.w  $FF00, $FF00
		dc.w  $FE00, $FD00
; ---------------------------------------------------------------------------

loc_81E28:
		move.w	($FFFFFAAE).w,d0
		sub.w	d0,$10(a0)
		move.w	($FFFFFA90).w,d0
		add.w	d0,$10(a0)
		jmp	Obj_FlickerMove(pc)
; ---------------------------------------------------------------------------

loc_81E3C:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_81E50(pc,d0.w),d1
		jsr	off_81E50(pc,d1.w)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_81E50:	dc.w loc_81E54-off_81E50

		dc.w loc_81E72-off_81E50
; ---------------------------------------------------------------------------

loc_81E54:
		lea	ObjDat3_831CC(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.w	a0,($FFFFFAA4).w
		move.w	#$C0,$42(a0)
		move.w	#$4B,$44(a0)
		move.b	#7,$29(a0)

loc_81E72:
		bsr.w	sub_82C86
		bra.w	loc_82D18
; ---------------------------------------------------------------------------

loc_81E7A:
		bsr.w	sub_82C86
		jmp	Child_Draw_Sprite2(pc)
; ---------------------------------------------------------------------------

loc_81E82:
		lea	ObjDat3_831BA(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_81EB8,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		lea	word_81EAC(pc,d0.w),a1
		move.w	(a1)+,$42(a0)
		move.w	(a1)+,$44(a0)
		lsl.w	#2,d0
		move.w	d0,$2E(a0)
		rts
; ---------------------------------------------------------------------------
word_81EAC:	dc.w	$90,   $60
		dc.w	$B0,   $58
		dc.w	$A8,   $78
; ---------------------------------------------------------------------------

loc_81EB8:
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		beq.s	loc_81EDE
		move.l	#loc_81ECA,(a0)

loc_81ECA:
		subq.w	#1,$2E(a0)
		bpl.s	loc_81EDE
		move.w	#$60,$2E(a0)
		lea	ChildObjDat_8326E(pc),a2
		jsr	CreateChild6_Simple(pc)

loc_81EDE:

		move.b	($FFFFFE0F).w,d0
		andi.b	#$F,d0
		bne.s	loc_81F0A
		movea.l	a0,a1
		lea	($FFFFB000).w,a2
		jsr	sub_8622C(pc)
		addi.b	#$10,d0
		lsr.b	#4,d0
		andi.w	#$FE,d0
		move.w	d0,$26(a0)
		lsr.w	#1,d0
		addi.b	#$1C,d0
		move.b	d0,$22(a0)

loc_81F0A:
		bsr.w	sub_82CD6
		moveq	#0,d0
		jmp	Child_Draw_Sprite_FlickerMove(pc)
; ---------------------------------------------------------------------------

loc_81F14:
		lea	word_831C6(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_81F26,(a0)
		bsr.w	sub_82CA4

loc_81F26:
		jsr	(MoveSprite2).l
		jsr	(sub_82BE4).l
		jmp	Sprite_CheckDeleteXY(pc)
; ---------------------------------------------------------------------------

loc_81F36:
		lea	ObjDat3_831D8(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		lea	word_81F5E(pc),a1

loc_81F42:
		move.l	#loc_81F6A,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		lea	(a1,d0.w),a1
		move.w	(a1)+,$42(a0)
		move.w	(a1)+,$44(a0)
		rts
; ---------------------------------------------------------------------------
word_81F5E:	dc.w	$10,   $38
		dc.w	$10,   $87
		dc.w	$28,   $60
; ---------------------------------------------------------------------------

loc_81F6A:
		bsr.w	sub_82C86
		btst	#1,($FFFFFE0F).w
		bne.s	loc_81F7A
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_81F7A:
		jmp	Child_CheckParent(pc)
; ---------------------------------------------------------------------------

loc_81F7E:
		lea	ObjDat3_831E4(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		lea	word_81F8C(pc),a1
		bra.s	loc_81F42
; ---------------------------------------------------------------------------
word_81F8C:	dc.w  $FFE0,   $24, $FFF0,   $44
; ---------------------------------------------------------------------------

loc_81F94:
		bsr.w	sub_82C86
		tst.b	$39(a0)
		bpl.s	loc_81FDA
		move.w	($FFFFB010).w,d0
		cmp.w	$10(a0),d0
		bcs.s	loc_81FDA
		moveq	#2,d1
		move.b	d1,$39(a0)
		moveq	#0,d2

loc_81FB0:
		jsr	(Create_New_Sprite).l
		bne.s	loc_81FDA
		move.l	#Obj_DDZMissile,(a1)
		move.b	#1,$2C(a1)
		move.w	a0,$46(a1)
		move.b	d2,$39(a1)
		addq.w	#1,d2
		dbf	d1,loc_81FB0
		moveq	#-$7F,d0
		jsr	(Play_Sound_2).l

loc_81FDA:

		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		beq.w	locret_82ABA
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

Obj_DDZMissile:

		lea	ObjDat3_831F0(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		lea	ChildObjDat_83250(pc),a2
		jsr	CreateChild6_Simple(pc)
		tst.b	$2C(a0)
		bne.s	loc_82014
		move.l	#loc_82038,(a0)
		move.w	#-$3FFA,$3C(a0)
		bra.w	sub_82AA6
; ---------------------------------------------------------------------------

loc_82014:
		move.l	#loc_82060,(a0)
		moveq	#0,d0
		move.b	$39(a0),d0
		add.w	d0,d0
		move.w	word_82032(pc,d0.w),d1
		add.w	d1,$14(a0)
		lsl.w	#3,d0
		move.w	d0,$2E(a0)
		bra.s	loc_81FDA
; ---------------------------------------------------------------------------
word_82032:	dc.w 0
		dc.w $FFF8
		dc.w 8
; ---------------------------------------------------------------------------

loc_82038:
		tst.b	4(a0)
		bpl.s	loc_8204C
		move.l	#loc_8204C,(a0)
		moveq	#-$4A,d0
		jsr	(Play_Sound_2).l

loc_8204C:

		move.w	($FFFFFAAE).w,d0
		sub.w	d0,$10(a0)
		subq.w	#2,$10(a0)
		bsr.w	sub_82B06
		jmp	Sprite_CheckDelete(pc)
; ---------------------------------------------------------------------------

loc_82060:
		movea.w	$46(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		subq.w	#1,$2E(a0)
		bpl.s	loc_8209A
		move.l	#loc_8209E,(a0)
		move.b	#$40,$3C(a0)
		bsr.w	sub_82AA6
		move.w	#$200,$18(a0)
		move.w	#$B,$2E(a0)
		move.l	#loc_820B6,$34(a0)

loc_8209A:
		bra.w	loc_81FDA
; ---------------------------------------------------------------------------

loc_8209E:
		movea.w	$46(a0),a1
		move.w	$14(a1),$14(a0)
		jsr	(MoveSprite2).l
		jsr	Obj_Wait(pc)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_820B6:
		move.l	#loc_820D0,(a0)
		clr.b	5(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_820F8,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_820D0:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_820E8(pc,d0.w),d1
		jsr	off_820E8(pc,d1.w)
		bsr.w	sub_82B06
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_820E8:	dc.w loc_820EE-off_820E8

		dc.w loc_82122-off_820E8
		dc.w loc_8213E-off_820E8
; ---------------------------------------------------------------------------

loc_820EE:
		jsr	(MoveSprite2).l
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_820F8:
		move.b	#2,5(a0)
		move.w	#$1F,$2E(a0)
		bset	#7,$A(a0)
		move.w	#$180,8(a0)
		moveq	#0,d0
		move.b	$39(a0),d0
		move.b	byte_8211E(pc,d0.w),$40(a0)
		rts
; ---------------------------------------------------------------------------
byte_8211E:	dc.b 4
		dc.b 2
		dc.b $FE
		dc.b 0
; ---------------------------------------------------------------------------

loc_82122:
		subq.w	#1,$2E(a0)
		bpl.s	loc_8212E
		move.b	#4,5(a0)

loc_8212E:
		move.b	$40(a0),d0
		add.b	d0,$3C(a0)
		bsr.w	sub_82AA6
		bra.w	loc_82ABC
; ---------------------------------------------------------------------------

loc_8213E:
		bsr.w	sub_82A82
		bsr.w	sub_82AA6
		bra.w	loc_82ABC
; ---------------------------------------------------------------------------

loc_8214A:
		lea	word_831FC(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_8215C,(a0)
		bsr.w	sub_82AD8

loc_8215C:
		bsr.w	sub_82AD8

loc_82160:
		jsr	Child_GetPriority(pc)
		move.b	($FFFFFE0F).w,d3
		andi.b	#7,d3
		bne.s	loc_82176
		lea	ChildObjDat_83256(pc),a2
		jsr	CreateChild6_Simple(pc)

loc_82176:
		btst	#1,d3
		bne.s	loc_82184
		jsr	Refresh_ChildPosition(pc)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_82184:
		bclr	#7,4(a0)
		jmp	Child_CheckParent(pc)
; ---------------------------------------------------------------------------

loc_8218E:
		lea	word_83202(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_821C2,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		movea.w	$46(a0),a1
		movea.w	$46(a1),a1
		move.b	$3C(a1),d0
		jsr	(GetSineCosine).l
		neg.w	d0
		neg.w	d1
		move.w	d0,$18(a0)
		move.w	d1,$1A(a0)

loc_821C2:

		move.w	($FFFFFAAE).w,d0
		sub.w	d0,$10(a0)
		lea	byte_832B4(pc),a1
		jsr	Animate_RawNoSSTMultiDelay(pc)
		jsr	(MoveSprite2).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_DDZAsteroid:

		move.l	#loc_821FC,(a0)
		move.l	#Map_DDZMissileAsteroid,$C(a0)
		move.w	#-$5D25,$A(a0)
		move.w	#0,8(a0)
		bsr.w	sub_83146

loc_821FC:
		tst.w	($FFFFFE08).w
		bne.s	loc_82208
		jsr	(MoveSprite2).l

loc_82208:
		move.w	($FFFFFAAE).w,d0
		sub.w	d0,$10(a0)
		tst.b	($FFFFFE19).w
		beq.s	loc_82224
		lea	($FFFFB000).w,a1
		movea.l	$30(a0),a2
		jsr	Check_InMyRange(pc)
		bne.s	loc_8222A

loc_82224:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_8222A:
		moveq	#$59,d0
		jsr	(Play_Sound_2).l
		move.w	($FFFFFA8E).w,d0
		beq.s	loc_82240
		movea.w	d0,a2
		move.w	#-$400,$18(a2)

loc_82240:
		move.l	($FFFFFA82).w,d0
		move.l	#$10000,d1
		sub.l	d1,d0
		cmp.l	d1,d0
		bcc.s	loc_82252
		move.l	d1,d0

loc_82252:
		move.l	d0,($FFFFFA82).w
		moveq	#0,d0
		move.b	$2C(a0),d0
		andi.b	#-$10,d0
		cmpi.b	#$20,d0
		bne.s	loc_822D8
		moveq	#0,d1
		move.w	$14(a0),d2
		sub.w	($FFFFB014).w,d2
		smi	d3
		bpl.s	loc_82276
		neg.w	d2

loc_82276:
		cmpi.w	#$10,d2
		bcs.s	loc_82284
		moveq	#4,d1
		tst.b	d3
		beq.s	loc_82284
		moveq	#8,d1

loc_82284:

		lea	off_82346(pc),a2
		movea.l	(a2,d1.w),a2
		moveq	#2,d4

loc_8228E:
		jsr	(Create_New_Sprite).l
		bne.w	loc_82334
		move.l	#Obj_DDZAsteroid,(a1)
		move.w	$10(a0),d2
		add.w	(a2)+,d2
		move.w	d2,$10(a1)
		move.w	$14(a0),d3
		add.w	(a2)+,d3
		move.w	d3,$14(a1)
		move.b	$2C(a0),d0
		andi.b	#$F,d0
		addi.b	#$10,d0
		move.b	d0,$2C(a1)
		dbf	d4,loc_8228E
		lea	word_82376(pc),a1
		adda.w	d1,a1
		move.w	(a1)+,d1
		add.w	d1,$10(a0)
		move.w	(a1)+,d1
		add.w	d1,$14(a0)

loc_822D8:
		move.b	$2C(a0),d0
		andi.w	#$10,d0
		lsr.w	#2,d0
		lea	off_82382(pc),a2
		movea.l	(a2,d0.w),a2
		move.l	#loc_823EE,d1
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		move.w	(a2)+,d4

loc_822FA:
		jsr	(Create_New_Sprite).l
		bne.s	loc_82334
		move.l	d1,(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.b	(a2)+,d5
		ext.w	d5
		add.w	d2,d5
		move.w	d5,$10(a1)
		move.b	(a2)+,d5
		ext.w	d5
		add.w	d3,d5
		move.w	d5,$14(a1)
		move.w	(a2)+,$2C(a1)
		move.w	(a2)+,$18(a1)
		move.w	(a2)+,$1A(a1)
		dbf	d4,loc_822FA

loc_82334:

		move.w	$48(a0),d0
		beq.s	loc_82340
		movea.w	d0,a2
		bclr	#7,(a2)

loc_82340:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
off_82346:	dc.l word_82352
		dc.l word_8235E
		dc.l word_8236A
word_82352:	dc.w 0
		dc.w $FFE8
		dc.w $18
		dc.w 0
		dc.w 0
		dc.w $18
word_8235E:	dc.w $FFE8
		dc.w 0
		dc.w 0
		dc.w $18
		dc.w $18
		dc.w 0
word_8236A:	dc.w $FFE8
		dc.w 0
		dc.w 0
		dc.w $FFE8
		dc.w $18
		dc.w 0
word_82376:	dc.w $FFF0
		dc.w 0
		dc.w 0
		dc.w $FFE8
		dc.w 0
		dc.w $18
off_82382:	dc.l word_8238A
		dc.l word_823B4
word_8238A:	dc.w 4
		dc.w $F802
		dc.w 0
		dc.w $FF80
		dc.w $140
		dc.w $8FC
		dc.w 0
		dc.w $FF40
		dc.w $FF00
		dc.w $FCF8
		dc.w $100
		dc.w $FF00
		dc.w $FE00
		dc.w $804
		dc.w $100
		dc.w $FE00
		dc.w $100
		dc.w $408
		dc.w $100
		dc.w $FE80
		dc.w $280
word_823B4:	dc.w 6
		dc.w $F4FC
		dc.w 0
		dc.w $FF80
		dc.w $FE80
		dc.w $FC0C
		dc.w 0
		dc.w $FF00
		dc.w $100
		dc.w $6F8
		dc.w 0
		dc.w $FF40
		dc.w $FF80
		dc.w $F40C
		dc.w $100
		dc.w $FE00
		dc.w $100
		dc.w $FCF4
		dc.w $100
		dc.w $FF00
		dc.w $FF80
		dc.w $808
		dc.w $100
		dc.w $FF40
		dc.w $60
		dc.w 0
		dc.w $100
		dc.w $FEC0
		dc.w $80
; ---------------------------------------------------------------------------

loc_823EE:
		lea	word_83208(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_82412,(a0)
		move.l	#byte_832A8,$30(a0)
		tst.b	$2C(a0)
		beq.s	loc_82412
		move.l	#byte_832AE,$30(a0)

loc_82412:

		move.w	($FFFFFAAE).w,d0
		sub.w	d0,$10(a0)
		jsr	Animate_Raw(pc)
		jsr	(MoveSprite2).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_8242A:
		lea	ObjDat3_8321A(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_82452,(a0)
		move.b	#6,$22(a0)
		move.l	#ArtUnc_SuperSonicKnux_Stars,d1
		move.w	#-$C80,d2
		move.w	#$1A0,d3
		jmp	(Add_To_DMA_Queue).l
; ---------------------------------------------------------------------------

loc_82452:
		tst.b	($FFFFFE19).w
		beq.w	locret_82ABA
		move.w	($FFFFFAAE).w,d0
		sub.w	d0,$10(a0)
		subq.w	#8,$10(a0)
		subq.b	#1,$24(a0)
		bpl.s	loc_82494
		move.b	#1,$24(a0)
		move.b	$22(a0),d0
		addq.b	#1,d0
		cmpi.b	#6,d0
		bcs.s	loc_82490
		moveq	#0,d0
		lea	($FFFFB000).w,a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)

loc_82490:
		move.b	d0,$22(a0)

loc_82494:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8249A:
		lea	ObjDat3_83232(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_824F4,(a0)
		move.w	#$400,$18(a0)
		move.b	($FFFFFE0F).w,d0
		andi.w	#$18,d0
		moveq	#0,d1
		move.b	$2C(a0),d1
		add.w	d1,d0
		move.w	word_824D4(pc,d0.w),$1A(a0)
		lsl.w	#3,d1
		move.w	d1,$2E(a0)
		move.w	($FFFFFAAE).w,d0
		sub.w	d0,$10(a0)
		rts
; ---------------------------------------------------------------------------
word_824D4:	dc.w $FEC0
		dc.w $FEE0
		dc.w $100
		dc.w $E0
		dc.w $FF40
		dc.w $FF60
		dc.w $80
		dc.w $60
		dc.w $FF80
		dc.w $FFA0
		dc.w $40
		dc.w $20
		dc.w $FF00
		dc.w $FF20
		dc.w $C0
		dc.w $A0
; ---------------------------------------------------------------------------

loc_824F4:
		move.w	($FFFFFAAE).w,d0
		sub.w	d0,$10(a0)
		subq.w	#1,$2E(a0)
		bpl.w	locret_82ABA
		move.l	#loc_8253C,(a0)
		move.w	#$10,$2E(a0)
		movea.w	$46(a0),a1
		move.w	$10(a1),d0
		addi.w	#$20,d0
		move.w	d0,$10(a0)
		move.w	$14(a1),d0
		addi.w	#$20,d0
		move.w	d0,$14(a0)
		moveq	#-$7F,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_83294(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_8253C:
		subq.w	#1,$2E(a0)
		bpl.s	loc_82554
		move.l	#loc_8255C,(a0)
		move.w	#$180,8(a0)
		bset	#7,$38(a0)

loc_82554:
		addq.w	#4,$10(a0)
		bra.w	loc_82568
; ---------------------------------------------------------------------------

loc_8255C:
		addi.w	#-$20,$18(a0)
		jsr	(MoveSprite2).l

loc_82568:
		lea	byte_832BF(pc),a1
		jsr	Animate_RawNoSST(pc)
		move.w	($FFFFFA90).w,d0
		add.w	d0,$10(a0)
		move.w	($FFFFFAAE).w,d0
		sub.w	d0,$10(a0)
		bsr.w	sub_82C28
		jmp	Sprite_CheckDelete(pc)
; ---------------------------------------------------------------------------

loc_82588:
		move.l	#loc_8259A,(a0)
		lea	word_8323E(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_8259A:
		movea.w	$46(a0),a1
		btst	#7,$38(a1)
		beq.s	loc_825AC
		move.w	#$100,8(a0)

loc_825AC:
		lea	byte_832C3(pc),a1
		jsr	Animate_RawNoSSTMultiDelay(pc)
		jsr	Refresh_ChildPosition(pc)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_825BC:
		move.l	#loc_82160,(a0)
		lea	word_831FC(pc),a1
		jmp	SetUp_ObjAttributes3(pc)
; ---------------------------------------------------------------------------

loc_825CA:
		lea	ObjDat3_83244(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_82606,(a0)
		movea.w	$46(a0),a1
		move.w	$10(a0),d0
		addi.w	#$52,d0
		move.w	d0,$10(a0)
		move.w	$14(a0),d0
		addi.w	#$5A,d0
		move.w	d0,$14(a0)
		move.w	#$200,$18(a0)
		move.w	#$200,$1A(a0)
		move.w	#4,$2E(a0)

loc_82606:
		move.w	($FFFFFAAE).w,d0
		sub.w	d0,$10(a0)
		subq.w	#1,$2E(a0)
		bpl.s	loc_82632
		move.l	#loc_82652,(a0)
		move.w	#$80,8(a0)
		bset	#7,$A(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#3,d0
		move.w	d0,$2E(a0)

loc_82632:
		jsr	(MoveSprite2).l
		move.w	($FFFFFA90).w,d0
		add.w	d0,$10(a0)
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.w	loc_83038
		jmp	Sprite_CheckDeleteXY(pc)
; ---------------------------------------------------------------------------

loc_82652:
		move.w	($FFFFFAAE).w,d0
		sub.w	d0,$10(a0)
		subq.w	#1,$2E(a0)
		bpl.s	loc_82678
		addi.w	#-$40,$18(a0)
		move.w	$1A(a0),d0
		addi.w	#-$20,d0
		bmi.s	loc_8268A
		move.w	d0,$1A(a0)
		bra.w	loc_8268A
; ---------------------------------------------------------------------------

loc_82678:
		move.b	($FFFFFE0F).w,d3
		andi.b	#7,d3
		bne.s	loc_8268A
		lea	ChildObjDat_832A2(pc),a2
		jsr	CreateChild6_Simple(pc)

loc_8268A:

		jsr	(MoveSprite2).l
		move.w	($FFFFFA90).w,d0
		add.w	d0,$10(a0)
		bsr.w	sub_82C28
		jmp	Sprite_CheckDeleteXY(pc)
; ---------------------------------------------------------------------------

loc_826A0:
		lea	word_83202(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_821C2,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		move.w	#-$200,$18(a0)
		move.w	#-$200,$1A(a0)
		move.w	($FFFFFAAE).w,d0
		sub.w	d0,$10(a0)
		rts
; ---------------------------------------------------------------------------

loc_826CC:
		lea	ObjDat_BossExplosion1(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_826E2,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)

loc_826E2:
		movea.w	$46(a0),a1
		tst.b	$2C(a1)
		beq.s	loc_826FC
		move.w	($FFFFFAAE).w,d0
		sub.w	d0,$10(a0)
		move.w	($FFFFFA90).w,d0
		add.w	d0,$10(a0)

loc_826FC:
		lea	(AniRaw_BossExplosion).l,a1
		jsr	Animate_RawNoSSTMultiDelay(pc)
		move.w	$3A(a0),d0
		add.w	d0,$18(a0)
		move.w	$3C(a0),d0
		add.w	d0,$1A(a0)
		jsr	(MoveSprite2).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_82722:
		move.w	$3A(a0),d1
		moveq	#0,d0
		cmpi.w	#$A,($FFFFFE20).w
		bhi.s	loc_82732
		moveq	#8,d0

loc_82732:
		cmp.w	d1,d0
		beq.w	locret_82ABA
		move.w	d0,$3A(a0)
		jmp	(Change_Music_Tempo).l

; =============== S U B R O U T I N E =======================================


sub_82742:

		btst	#7,$38(a0)
		beq.s	locret_82750
		tst.b	($FFFFFE19).w
		beq.s	loc_82752

locret_82750:
		rts
; ---------------------------------------------------------------------------

loc_82752:
		move.l	#loc_8179E,(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		lea	($FFFFB000).w,a1
		move.b	#-$7F,$2E(a1)
		move.b	#$1A,$20(a1)
		rts
; End of function sub_82742


; =============== S U B R O U T I N E =======================================


sub_82772:

		lea	($FFFFB000).w,a1
		tst.b	$34(a1)
		beq.s	loc_827A0
		addi.b	#$10,$26(a1)
		cmpi.b	#$1E,$34(a1)
		bcs.s	loc_827A8
		clr.w	$18(a0)
		clr.w	$1A(a0)
		move.l	($FFFFFA82).w,d2
		lsr.l	#8,d2
		neg.w	d2
		moveq	#0,d3
		bra.w	loc_82828
; ---------------------------------------------------------------------------

loc_827A0:
		clr.b	$26(a1)
		clr.b	$2A(a1)

loc_827A8:
		moveq	#0,d2
		moveq	#0,d3
		moveq	#$40,d0
		move.w	$18(a0),d2
		beq.s	loc_827CA
		bmi.s	loc_827C0
		neg.w	d0
		add.w	d0,d2
		bpl.s	loc_827C6
		bra.w	loc_827C4
; ---------------------------------------------------------------------------

loc_827C0:
		add.w	d0,d2
		bmi.s	loc_827C6

loc_827C4:
		moveq	#0,d2

loc_827C6:

		move.w	d2,$18(a0)

loc_827CA:
		moveq	#$40,d0
		move.w	$1A(a0),d3
		beq.s	loc_827E8
		bmi.s	loc_827DE
		neg.w	d0
		add.w	d0,d3
		bpl.s	loc_827E4
		bra.w	loc_827E2
; ---------------------------------------------------------------------------

loc_827DE:
		add.w	d0,d3
		bmi.s	loc_827E4

loc_827E2:
		moveq	#0,d3

loc_827E4:

		move.w	d3,$1A(a0)

loc_827E8:
		lea	($FFFFF604).w,a2
		tst.w	(a2)
		beq.s	loc_82828
		tst.b	($FFFFF7CA).w
		bne.s	loc_82828
		move.b	(a2)+,d0
		move.b	(a2)+,d1
		andi.w	#$F,d0
		lsl.w	#2,d0
		andi.w	#$70,d1
		beq.s	loc_8281A
		tst.b	$34(a1)
		bne.s	loc_8281A
		movem.w	word_82872(pc,d0.w),d2-d3
		move.w	d2,$18(a0)
		move.w	d3,$1A(a0)

loc_8281A:

		tst.w	d0
		beq.s	loc_82828
		movem.w	word_82832(pc,d0.w),d4-d5
		add.w	d4,d2
		add.w	d5,d3

loc_82828:

		move.w	d2,$18(a1)
		move.w	d3,$1A(a1)
		rts
; End of function sub_82772

; ---------------------------------------------------------------------------
word_82832:	dc.w	  0,	 0
		dc.w	  0, $FD00
		dc.w	  0,  $300
		dc.w	  0,	 0
		dc.w  $FD00,	 0
		dc.w  $FDE1, $FDE1
		dc.w  $FDE1,  $21F
		dc.w	  0,	 0
		dc.w   $300,	 0
		dc.w   $21F, $FDE1
		dc.w   $21F,  $21F
		dc.w	  0,	 0
		dc.w	  0,	 0
		dc.w	  0,	 0
		dc.w	  0,	 0
		dc.w	  0,	 0
word_82872:	dc.w   $600,	 0
		dc.w	  0, $FA00
		dc.w	  0,  $600
		dc.w	  0,	 0
		dc.w  $FA00,	 0
		dc.w  $FBC2, $FBC2
		dc.w  $FBC2,  $43E
		dc.w	  0,	 0
		dc.w   $600,	 0
		dc.w   $43E, $FBC2
		dc.w   $43E,  $43E
		dc.w	  0,	 0
		dc.w	  0,	 0
		dc.w	  0,	 0
		dc.w	  0,	 0
		dc.w	  0,	 0

; =============== S U B R O U T I N E =======================================


sub_828B2:

		tst.w	d2
		beq.s	loc_828EE
		move.l	$10(a0),d0
		move.w	($FFFFEE78).w,d1
		ext.l	d2
		lsl.l	#8,d2
		add.l	d2,d0
		swap	d0
		move.w	($FFFFFAB4).w,d4
		add.w	d4,d1
		cmp.w	d1,d0
		bcs.s	loc_828EE
		move.w	($FFFFFAB6).w,d5
		sub.w	d4,d5
		add.w	d5,d1
		bset	#1,$38(a0)
		cmp.w	d1,d0
		bcc.s	loc_828EE
		bclr	#1,$38(a0)
		swap	d0
		move.l	d0,$10(a0)

loc_828EE:

		tst.w	d3
		beq.s	locret_8291E
		move.l	$14(a0),d0
		move.w	($FFFFEE7C).w,d1
		ext.l	d3
		lsl.l	#8,d3
		add.l	d3,d0
		swap	d0
		move.w	($FFFFFAB0).w,d4
		add.w	d4,d1
		cmp.w	d1,d0
		bcs.s	locret_8291E
		move.w	($FFFFFAB2).w,d5
		sub.w	d4,d5
		add.w	d5,d1
		cmp.w	d1,d0
		bcc.s	locret_8291E
		swap	d0
		move.l	d0,$14(a0)

locret_8291E:

		rts
; End of function sub_828B2


; =============== S U B R O U T I N E =======================================


sub_82920:

		move.l	($FFFFFA82).w,d0
		add.l	($FFFFFA8A).w,d0
		move.l	#$60000,d2
		move.w	($FFFFFA8E).w,d1
		beq.s	loc_82952
		movea.w	d1,a1
		btst	#1,$38(a1)
		beq.s	loc_82952
		move.w	$18(a1),d1
		bmi.s	loc_82952
		beq.s	loc_82952
		ext.l	d1
		lsl.l	#4,d1
		add.l	d1,d0
		move.l	#$80000,d2

loc_82952:

		cmp.l	d2,d0
		ble.s	loc_82958
		move.l	d2,d0

loc_82958:
		cmpi.l	#$10000,d0
		ble.s	loc_82964
		move.l	d0,($FFFFFA82).w

loc_82964:
		move.l	($FFFFEE78).w,d1
		move.l	d1,d2
		add.l	d0,d1
		andi.l	#$7FFFFFFF,d1
		move.l	d1,($FFFFEE78).w
		swap	d0
		add.w	d0,($FFFFEED8).w
		swap	d1
		swap	d2
		move.w	d1,($FFFFEE14).w
		move.w	$3C(a0),d3
		add.w	d1,d3
		move.w	d3,($FFFFEE16).w
		sub.w	d2,d1
		move.w	d1,($FFFFFA90).w
		move.w	$10(a0),d2
		add.w	d1,d2
		move.w	d2,$10(a0)
		rts
; End of function sub_82920


; =============== S U B R O U T I N E =======================================


sub_829A0:
		move.l	($FFFFFA82).w,d0
		add.l	($FFFFFA8A).w,d0
		cmpi.l	#$60000,d0
		bhi.s	loc_829B4
		move.l	d0,($FFFFFA82).w

loc_829B4:
		move.l	($FFFFFA86).w,d1
		move.l	d1,d2
		add.l	d0,d1
		move.l	d1,($FFFFFA86).w
		swap	d0
		add.w	d0,($FFFFEED8).w
		swap	d1
		swap	d2
		sub.w	d2,d1
		move.w	d1,($FFFFFA90).w
		rts
; End of function sub_829A0


; =============== S U B R O U T I N E =======================================


sub_829D2:

		lea	($FFFFB000).w,a1
		move.w	($FFFFEE78).w,d0
		move.w	d0,d1
		move.w	$10(a0),d2
		move.w	d2,$10(a1)
		btst	#3,$38(a0)
		beq.s	loc_82A2E
		move.w	d2,d3
		addi.w	#$80,d0
		sub.w	d0,d2
		bcc.s	loc_82A10
		add.w	d2,d1
		cmp.w	($FFFFEE14).w,d1
		blt.s	loc_82A06
		move.w	d1,($FFFFEE78).w
		bra.w	loc_82A2E
; ---------------------------------------------------------------------------

loc_82A06:
		move.w	($FFFFEE14).w,($FFFFEE78).w
		bra.w	loc_82A2E
; ---------------------------------------------------------------------------

loc_82A10:
		addi.w	#$20,d0
		sub.w	d0,d3
		bls.s	loc_82A2E
		add.w	d3,d1
		cmp.w	($FFFFEE16).w,d1
		bge.s	loc_82A28
		move.w	d1,($FFFFEE78).w
		bra.w	loc_82A2E
; ---------------------------------------------------------------------------

loc_82A28:
		move.w	($FFFFEE16).w,($FFFFEE78).w

loc_82A2E:

		move.w	($FFFFEE7C).w,d0
		move.w	d0,d1
		move.w	$14(a0),d2
		move.w	d2,$14(a1)
		btst	#2,$38(a0)
		beq.s	locret_82A80
		move.w	d2,d3
		addi.w	#$60,d0
		sub.w	d0,d2
		bcc.s	loc_82A64
		add.w	d2,d1
		cmp.w	($FFFFEE18).w,d1
		blt.s	loc_82A5C
		move.w	d1,($FFFFEE7C).w
		rts
; ---------------------------------------------------------------------------

loc_82A5C:
		move.w	($FFFFEE18).w,($FFFFEE7C).w
		rts
; ---------------------------------------------------------------------------

loc_82A64:
		addi.w	#$20,d0
		sub.w	d0,d3
		ble.s	locret_82A80
		add.w	d3,d1
		cmp.w	($FFFFEE1A).w,d1
		bge.s	loc_82A7A
		move.w	d1,($FFFFEE7C).w
		rts
; ---------------------------------------------------------------------------

loc_82A7A:
		move.w	($FFFFEE1A).w,($FFFFEE7C).w

locret_82A80:

		rts
; End of function sub_829D2


; =============== S U B R O U T I N E =======================================


sub_82A82:
		move.b	($FFFFFE0F).w,d0
		andi.b	#3,d0
		beq.s	locret_82AA4
		movea.l	a0,a1
		lea	($FFFFB000).w,a2
		jsr	sub_8622C(pc)
		moveq	#2,d1
		sub.b	$3C(a0),d0
		bpl.s	loc_82AA0
		neg.w	d1

loc_82AA0:
		add.b	d1,$3C(a0)

locret_82AA4:
		rts
; End of function sub_82A82


; =============== S U B R O U T I N E =======================================


sub_82AA6:

		move.b	$3C(a0),d0
		addi.b	#$10,d0
		lsr.b	#5,d0
		move.b	d0,$3D(a0)
		addq.b	#8,d0
		move.b	d0,$22(a0)

locret_82ABA:

		rts
; End of function sub_82AA6

; ---------------------------------------------------------------------------

loc_82ABC:

		move.b	$3C(a0),d0
		jsr	(GetSineCosine).l
		add.w	d0,d0
		add.w	d1,d1
		move.w	d0,$18(a0)
		move.w	d1,$1A(a0)
		jmp	(MoveSprite2).l

; =============== S U B R O U T I N E =======================================


sub_82AD8:

		movea.w	$46(a0),a1
		moveq	#0,d0
		move.b	$3D(a1),d0
		move.b	#$10,$22(a0)
		add.b	d0,$22(a0)
		add.w	d0,d0
		move.w	word_82AF6(pc,d0.w),$42(a0)
		rts
; End of function sub_82AD8

; ---------------------------------------------------------------------------
word_82AF6:	dc.w $E0
		dc.w $EAEA
		dc.w $E000
		dc.w $EA16
		dc.w $20
		dc.w $1616
		dc.w $2000
		dc.w $16EA

; =============== S U B R O U T I N E =======================================


sub_82B06:

		tst.b	($FFFFFE19).w
		beq.s	locret_82B60
		tst.b	4(a0)
		bpl.s	loc_82B30
		tst.b	$2C(a0)
		beq.s	loc_82B30
		move.w	($FFFFFAA4).w,d0
		beq.s	loc_82B30
		movea.w	d0,a1
		tst.b	$28(a1)
		bne.s	loc_82B30
		lea	word_82BB4(pc),a2
		jsr	Check_InTheirRange(pc)
		bne.s	loc_82B62

loc_82B30:

		lea	($FFFFB000).w,a1
		tst.b	$34(a1)
		bne.s	loc_82B50
		moveq	#0,d0
		move.b	$3D(a0),d0
		add.w	d0,d0
		move.w	off_82BBC(pc,d0.w),d1
		lea	off_82BBC(pc,d1.w),a2
		jsr	Check_InMyRange(pc)
		bne.s	loc_82B6E

loc_82B50:
		move.w	$46(a0),d0
		beq.s	locret_82B60
		movea.w	d0,a1
		btst	#7,$2A(a1)
		bne.s	loc_82B84

locret_82B60:

		rts
; ---------------------------------------------------------------------------

loc_82B62:
		subq.b	#1,$29(a1)
		st	$28(a1)
		bra.w	loc_82B78
; ---------------------------------------------------------------------------

loc_82B6E:
		lea	($FFFFB000).w,a1
		move.b	#$59,$34(a1)

loc_82B78:
		move.w	$46(a0),d0
		beq.s	loc_82B84
		movea.w	d0,a1
		subq.b	#1,$39(a1)

loc_82B84:

		move.l	#Wait_Draw,(a0)
		move.w	#3,$2E(a0)
		move.l	#loc_85088,$34(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_82BAC
		move.b	#6,$2C(a1)

loc_82BAC:
		bset	#7,$2A(a0)
		rts
; End of function sub_82B06

; ---------------------------------------------------------------------------
word_82BB4:	dc.w	  0,   $38, $FFD4,   $18

off_82BBC:	dc.w word_82BC4-word_82BB4
		dc.w word_82BCC-word_82BB4
		dc.w word_82BD4-word_82BB4
		dc.w word_82BCC-word_82BB4
word_82BC4:	dc.w $10

		dc.w $18
		dc.w $20
		dc.w $18
word_82BCC:	dc.w $FFE8
		dc.w $30
		dc.w $FFDC
		dc.w $48
word_82BD4:	dc.w $FFE4
		dc.w $38
		dc.w $FFE4
		dc.w $38
		dc.w $FFDC
		dc.w $48
		dc.w $FFE8
		dc.w $30

; =============== S U B R O U T I N E =======================================


sub_82BE4:
		tst.b	($FFFFFE19).w
		beq.s	locret_82C1E
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_82C18
		lea	($FFFFB000).w,a1
		tst.b	$34(a1)
		bne.s	locret_82C1E
		lea	word_82C20(pc),a2
		jsr	Check_InMyRange(pc)
		beq.s	locret_82C1E
		move.b	#$3B,$34(a1)
		moveq	#-$4C,d0
		jsr	(Play_Sound_2).l

loc_82C18:
		jsr	(Go_Delete_Sprite).l

locret_82C1E:

		rts
; End of function sub_82BE4

; ---------------------------------------------------------------------------
word_82C20:	dc.w  $FFF0,   $20, $FFF0,   $20

; =============== S U B R O U T I N E =======================================


sub_82C28:

		tst.b	($FFFFFE19).w
		beq.s	locret_82C4E
		lea	($FFFFB000).w,a1
		tst.b	$34(a1)
		lea	word_82C62(pc),a2
		jsr	Check_InMyRange(pc)
		bne.s	loc_82C50
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.w	loc_82B84

locret_82C4E:
		rts
; ---------------------------------------------------------------------------

loc_82C50:
		lea	($FFFFB000).w,a1
		move.b	#$59,$34(a1)
		bsr.w	sub_82C6A
		bra.w	loc_82B84
; End of function sub_82C28

; ---------------------------------------------------------------------------
word_82C62:	dc.w  $FFF0,   $20, $FFF0,   $20

; =============== S U B R O U T I N E =======================================


sub_82C6A:

		move.l	($FFFFFA82).w,d0
		move.l	#$10000,d1
		subi.l	#$30000,d0
		cmp.l	d1,d0
		bge.s	loc_82C80
		move.l	d1,d0

loc_82C80:
		move.l	d0,($FFFFFA82).w
		rts
; End of function sub_82C6A


; =============== S U B R O U T I N E =======================================


sub_82C86:

		movea.w	$46(a0),a1
		move.w	$10(a1),d0
		move.w	$14(a1),d1
		add.w	$42(a0),d0
		add.w	$44(a0),d1
		move.w	d0,$10(a0)
		move.w	d1,$14(a0)
		rts
; End of function sub_82C86


; =============== S U B R O U T I N E =======================================


sub_82CA4:
		movea.w	$46(a0),a1
		move.w	$26(a1),d0
		add.w	d0,d0
		move.l	word_82CB6(pc,d0.w),$18(a0)
		rts
; End of function sub_82CA4

; ---------------------------------------------------------------------------
word_82CB6:	dc.w	  0,  $400
		dc.w   $2D4,  $2D4
		dc.w   $400,	 0
		dc.w   $2D4, $FD2C
		dc.w	  0, $FC00
		dc.w  $FD2C, $FD2C
		dc.w  $FC00,	 0
		dc.w  $FD2C,  $2D4

; =============== S U B R O U T I N E =======================================


sub_82CD6:
		move.w	$26(a0),d0
		lea	byte_82D08(pc,d0.w),a1
		movea.w	$46(a0),a2
		move.b	(a1)+,d1
		ext.w	d1
		move.w	$10(a2),d2
		add.w	$42(a0),d2
		add.w	d1,d2
		move.w	d2,$10(a0)
		move.b	(a1)+,d1
		ext.w	d1
		move.w	$14(a2),d2
		add.w	$44(a0),d2
		add.w	d1,d2
		move.w	d2,$14(a0)
		rts
; End of function sub_82CD6

; ---------------------------------------------------------------------------
byte_82D08:	dc.b	0,   8
		dc.b	8,   8
		dc.b	8,   0
		dc.b	8, $F8
		dc.b	0, $F8
		dc.b  $F8, $F8
		dc.b  $F8,   0
		dc.b  $F8,   8
; ---------------------------------------------------------------------------

loc_82D18:
		tst.b	($FFFFFE19).w
		beq.s	locret_82D5A
		tst.b	$28(a0)
		beq.s	locret_82D5A
		tst.b	$29(a0)
		bmi.s	loc_82D5C
		tst.b	$20(a0)
		bne.s	loc_82D3E
		move.b	#$20,$20(a0)
		moveq	#-$65,d0
		jsr	(Play_Sound_2).l

loc_82D3E:
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_82D4C
		addi.w	#$18,d0

loc_82D4C:
		bsr.w	sub_82D72
		subq.b	#1,$20(a0)
		bne.s	locret_82D5A
		clr.b	$28(a0)

locret_82D5A:

		rts
; ---------------------------------------------------------------------------

loc_82D5C:
		moveq	#$64,d0
		jsr	(HUD_AddToScore).l
		bset	#7,$2A(a0)
		move.l	#loc_81E7A,(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_82D72:

		lea	word_82D86(pc),a1
		lea	word_82D9E(pc,d0.w),a2
		moveq	#$B,d1

loc_82D7C:
		movea.w	(a1)+,a3
		move.w	(a2)+,(a3)+
		dbf	d1,loc_82D7C
		rts
; End of function sub_82D72

; ---------------------------------------------------------------------------
word_82D86:	dc.w $FC46
		dc.w $FC48
		dc.w $FC4C
		dc.w $FC4E
		dc.w $FC50
		dc.w $FC52
		dc.w $FC54
		dc.w $FC56
		dc.w $FC58
		dc.w $FC5A
		dc.w $FC5C
		dc.w $FC5E
word_82D9E:	dc.w $A
		dc.w 6
		dc.w $CAA
		dc.w $A88
		dc.w $866
		dc.w $444
		dc.w $E42
		dc.w $E00
		dc.w $C00
		dc.w $600
		dc.w $200
		dc.w 0
		dc.w $888
		dc.w $AAA
		dc.w $CCC
		dc.w $AAA
		dc.w $888
		dc.w $666
		dc.w $ECC
		dc.w $ECA
		dc.w $AAA
		dc.w $AAA
		dc.w $CCC
		dc.w $EEE
; ---------------------------------------------------------------------------

loc_82DCE:
		tst.b	($FFFFFE19).w
		beq.s	locret_82E2A
		tst.b	$20(a0)
		bne.s	loc_82E14
		lea	($FFFFB000).w,a1
		lea	word_82E92(pc),a2
		jsr	Check_InMyRange(pc)
		beq.s	locret_82E2A
		subq.b	#1,$29(a0)
		bmi.s	loc_82E2C
		move.b	#$20,$20(a0)
		move.b	#$5A,($FFFFB034).w
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		bsr.w	sub_82C6A
		move.w	($FFFFFA8E).w,d0
		beq.s	loc_82E14
		movea.w	d0,a1
		move.w	#-$1000,$18(a1)

loc_82E14:

		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_82E22
		addi.w	#$18,d0

loc_82E22:
		bsr.w	sub_82D72
		subq.b	#1,$20(a0)

locret_82E2A:

		rts
; ---------------------------------------------------------------------------

loc_82E2C:
		moveq	#$64,d0
		jsr	(HUD_AddToScore).l
		move.l	#loc_81BBE,(a0)
		clr.b	5(a0)
		bset	#7,$2A(a0)
		st	($FFFFF7CA).w
		move.w	#$7FFF,($FFFFF670).w
		move.w	($FFFFEE7C).w,d0
		move.w	d0,($FFFFEE18).w
		move.w	d0,($FFFFEE1A).w
		move.w	($FFFFFA8E).w,d0
		beq.s	loc_82E72
		movea.w	d0,a1
		bclr	#2,$38(a1)
		move.w	#-$400,$18(a1)
		clr.w	$1A(a1)

loc_82E72:
		jsr	(Create_New_Sprite).l
		bne.s	locret_82E2A
		move.l	#loc_82F1C,(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.w	a0,$46(a1)
		rts
; ---------------------------------------------------------------------------
word_82E92:	dc.w	$20,   $40,   $20,   $40
; ---------------------------------------------------------------------------

loc_82E9A:
		bsr.w	sub_82C86
		subq.w	#1,$2E(a0)
		bpl.s	loc_82EEE
		moveq	#$18,d0
		bsr.w	sub_82D72
		moveq	#$4E,d0
		jsr	(Play_Sound_2).l
		move.w	#$1F,$2E(a0)
		moveq	#0,d1
		move.b	$39(a0),d1
		lea	word_82EF4(pc,d1.w),a2
		jsr	(Create_New_Sprite).l
		bne.s	loc_82EDC
		move.l	#loc_82F78,(a1)
		move.w	a0,$46(a1)
		move.w	(a2)+,$42(a1)
		move.w	(a2)+,$44(a1)

loc_82EDC:
		addq.b	#4,d1
		cmpi.b	#$28,d1
		bcc.s	loc_82EEA
		move.b	d1,$39(a0)
		rts
; ---------------------------------------------------------------------------

loc_82EEA:
		jsr	Go_Delete_Sprite(pc)

loc_82EEE:
		moveq	#0,d0
		bra.w	sub_82D72
; ---------------------------------------------------------------------------
word_82EF4:	dc.w	$C0,   $38
		dc.w	$78,   $80
		dc.w	$B0,   $78
		dc.w	$58,   $40
		dc.w	$98,   $60
		dc.w	$E0,   $70
		dc.w	$C8,   $40
		dc.w	$70,   $80
		dc.w	$98,   $70
		dc.w	$50,   $40
; ---------------------------------------------------------------------------

loc_82F1C:
		bsr.w	sub_82C86
		subq.w	#1,$2E(a0)
		bpl.s	locret_82F6A
		move.w	#$1F,$2E(a0)
		moveq	#$4E,d0
		jsr	(Play_Sound_2).l
		moveq	#0,d1
		move.b	$39(a0),d1
		lea	word_82F6C(pc,d1.w),a2
		jsr	(Create_New_Sprite).l
		bne.s	loc_82F5C
		move.l	#loc_82F78,(a1)
		move.w	a0,$46(a1)
		move.w	(a2)+,$42(a1)
		move.w	(a2)+,$44(a1)
		st	$2C(a1)

loc_82F5C:
		addq.b	#4,d1
		cmpi.b	#$C,d1
		bcc.w	loc_83038
		move.b	d1,$39(a0)

locret_82F6A:
		rts
; ---------------------------------------------------------------------------
word_82F6C:	dc.w	$50,   $48
		dc.w	$30,   $30
		dc.w	$30,   $68
; ---------------------------------------------------------------------------

loc_82F78:

		bsr.w	sub_82C86
		moveq	#0,d0
		move.b	$39(a0),d0
		cmpi.b	#$30,d0
		bcc.w	loc_83038
		addq.b	#2,$39(a0)
		lea	byte_82FD4(pc,d0.w),a2
		jsr	(Create_New_Sprite).l
		bne.s	locret_82FD2
		move.l	#loc_826CC,(a1)
		move.w	a0,$46(a1)
		move.w	$10(a0),d0
		move.b	(a2)+,d1
		ext.w	d1
		add.w	d1,d0
		move.w	d0,$10(a1)
		move.w	$14(a0),d0
		move.b	(a2)+,d1
		ext.w	d1
		add.w	d1,d0
		move.w	d0,$14(a1)
		asr.w	#4,d1
		move.w	d1,$1A(a1)
		move.w	#$100,$18(a1)
		move.w	#-$100,$3A(a1)

locret_82FD2:
		rts
; ---------------------------------------------------------------------------
byte_82FD4:	dc.b	0,   0
		dc.b  $F0, $F8
		dc.b	0,   8
		dc.b	8, $F8
		dc.b  $F0,   8
		dc.b	0, $F0
		dc.b  $F0, $E8
		dc.b  $10,   8
		dc.b  $10, $F0
		dc.b  $E8,   0
		dc.b  $F8, $E0
		dc.b  $18,   0
		dc.b  $F8, $10
		dc.b  $E0, $F0
		dc.b	8, $E0
		dc.b	8, $18
		dc.b  $E8, $E0
		dc.b  $E0, $10
		dc.b  $20, $F0
		dc.b  $20, $10
		dc.b  $18, $D8
		dc.b  $D8, $F8
		dc.b  $F0, $20
		dc.b  $28,   0
; ---------------------------------------------------------------------------

loc_83004:
		move.l	#loc_8302A,(a0)
		move.w	#$90,$42(a0)
		move.w	#$60,$44(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_8302A
		move.b	#$1C,$2C(a1)

loc_8302A:

		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		beq.w	sub_82C86

loc_83038:

		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_8303E:
		move.l	#loc_83078,(a0)
		move.w	#$40,$42(a0)
		move.w	#$40,$44(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_83064
		move.b	#$E,$2C(a1)

loc_83064:
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_83078
		move.b	#$E,$2C(a1)

loc_83078:

		bra.w	sub_82C86

; =============== S U B R O U T I N E =======================================


sub_8307C:
		move.w	($FFFFEE78).w,d0
		addi.w	#$140,d0
		cmp.w	$10(a0),d0
		bcs.w	locret_82ABA
		subq.w	#1,$2E(a0)
		bpl.w	locret_82ABA
		move.w	#$82,$2E(a0)
		move.w	$14(a0),d0
		addi.w	#$68,d0
		cmp.w	($FFFFB014).w,d0
		bcc.s	loc_830B8
		moveq	#-$68,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_83288(pc),a2
		jmp	CreateChild6_Simple(pc)
; ---------------------------------------------------------------------------

loc_830B8:
		lea	ChildObjDat_8328E(pc),a2
		jmp	CreateChild6_Simple(pc)
; End of function sub_8307C


; =============== S U B R O U T I N E =======================================


sub_830C0:

		movea.w	($FFFFFA8E).w,a1
		move.b	$18(a1),d1
		ext.w	d1
		neg.w	d1
		asr.w	#1,d1
		btst	#3,($FFFFF604).w
		bne.s	loc_830EC
		move.w	$10(a0),d0
		addi.w	#2,d0
		add.w	d1,d0
		move.w	($FFFFEE16).w,d1
		add.w	d2,d1
		cmp.w	d1,d0
		bcs.s	loc_83100
		rts
; ---------------------------------------------------------------------------

loc_830EC:
		move.w	$10(a0),d0
		addi.w	#-2,d0
		add.w	d1,d0
		move.w	($FFFFEE14).w,d1
		add.w	d3,d1
		cmp.w	d1,d0
		bls.s	locret_83106

loc_83100:
		swap	d0
		move.l	d0,$10(a0)

locret_83106:
		rts
; End of function sub_830C0

; ---------------------------------------------------------------------------

loc_83108:
		move.b	#4,$39(a0)
		move.l	#loc_8311A,(a0)
		move.w	#3,$3A(a0)

loc_8311A:
		subq.w	#1,$2E(a0)
		bpl.w	locret_82ABA
		move.w	$3A(a0),$2E(a0)
		lea	($FFFFFC00).w,a1
		moveq	#$3F,d0

loc_8312E:
		jsr	sub_85EB4(pc)
		dbf	d0,loc_8312E
		subq.b	#1,$39(a0)
		bmi.s	loc_8313E
		rts
; ---------------------------------------------------------------------------

loc_8313E:
		move.l	#loc_85EE6,(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_83146:
		move.b	$2C(a0),d0
		move.w	d0,d1
		andi.w	#$F0,d0
		lsr.w	#1,d0
		lea	byte_8318A(pc,d0.w),a1
		move.b	(a1)+,7(a0)
		move.b	(a1)+,6(a0)
		move.b	(a1)+,$22(a0)
		move.b	(a1)+,$28(a0)
		move.l	(a1)+,$30(a0)
		bset	#2,4(a0)
		andi.w	#$F,d1
		add.w	d1,d1
		move.w	word_8317E(pc,d1.w),$18(a0)
		rts
; End of function sub_83146

; ---------------------------------------------------------------------------
word_8317E:	dc.w $FF80
		dc.w $FFC0
		dc.w 0
		dc.w $40
		dc.w $80
		dc.w $FE00
byte_8318A:	dc.b $10
		dc.b $10
		dc.b $26
		dc.b 0
		dc.l byte_831A2
		dc.b $18
		dc.b $18
		dc.b $27
		dc.b 0
		dc.l byte_831AA
		dc.b $28
		dc.b $28
		dc.b $28
		dc.b 0
		dc.l byte_831B2
byte_831A2:	dc.b  $FF, $E8
		dc.b	0, $30
		dc.b  $FF, $E8
		dc.b	0, $30
byte_831AA:	dc.b  $FF, $E0
		dc.b	0, $40
		dc.b  $FF, $E0
		dc.b	0, $40
byte_831B2:	dc.b  $FF, $D8
		dc.b	0, $50
		dc.b  $FF, $C8
		dc.b	0, $68
ObjDat3_831BA:	dc.l Map_DDZMissileAsteroid
		dc.w $C2DB
		dc.w $280
		dc.b 8
		dc.b 8
		dc.b $1C
		dc.b 0
word_831C6:	dc.w $280
		dc.b 4
		dc.b 4
		dc.b $24
		dc.b 0
ObjDat3_831CC:	dc.l Map_DDZMissileAsteroid
		dc.w $42DB
		dc.w $300
		dc.b $38
		dc.b $2C
		dc.b $38
		dc.b 0
ObjDat3_831D8:	dc.l Map_DDZMissileAsteroid
		dc.w $C2DB
		dc.w $280
		dc.b $10
		dc.b $18
		dc.b 7
		dc.b 0
ObjDat3_831E4:	dc.l Map_DDZMissileAsteroid
		dc.w $C2DB
		dc.w $180
		dc.b $10
		dc.b $10
		dc.b 6
		dc.b 0
ObjDat3_831F0:	dc.l Map_DDZMissileAsteroid
		dc.w $42DB
		dc.w $180
		dc.b $18
		dc.b $18
		dc.b 8
		dc.b 0
word_831FC:	dc.w $180

		dc.b 8
		dc.b 8
		dc.b $12
		dc.b 0
word_83202:	dc.w $200

		dc.b 8
		dc.b 8
		dc.b $18
		dc.b 0
word_83208:	dc.w $300
		dc.b $C
		dc.b $C
		dc.b $29
		dc.b 0
ObjDat3_8320E:	dc.l Map_DDZMissileAsteroid
		dc.w $42DB
		dc.w $200
		dc.b $40
		dc.b $24
		dc.b 1
		dc.b 0
ObjDat3_8321A:	dc.l Map_SuperSonicKnux_Stars
		dc.w $879C
		dc.w $80
		dc.b $18
		dc.b $18
		dc.b 0
		dc.b 0
ObjDat3_83226:	dc.l Map_BossMasterEmerald
		dc.w $64D0
		dc.w $280
		dc.b $20
		dc.b $18
		dc.b 0
		dc.b 0
ObjDat3_83232:	dc.l Map_DDZMissileAsteroid
		dc.w $42DB
		dc.w $300
		dc.b $10
		dc.b $C
		dc.b $31
		dc.b 0
word_8323E:	dc.w $280
		dc.b 8
		dc.b $10
		dc.b $33
		dc.b 0
ObjDat3_83244:	dc.l Map_DDZMissileAsteroid
		dc.w $42DB
		dc.w $300
		dc.b 8
		dc.b 8
		dc.b $25
		dc.b 0
ChildObjDat_83250:dc.w 0
		dc.l loc_8214A
ChildObjDat_83256:dc.w 0
		dc.l loc_8218E
ChildObjDat_8325C:dc.w 0
		dc.l loc_81E3C
ChildObjDat_83262:dc.w 2
		dc.l loc_81F36
ChildObjDat_83268:dc.w 2
		dc.l loc_81E82
ChildObjDat_8326E:dc.w 0
		dc.l loc_81F14
ChildObjDat_83274:dc.w 2
		dc.l loc_81D72
ChildObjDat_8327A:dc.w 0
		dc.l loc_81CC6
		dc.w $1CFC
ChildObjDat_83282:dc.w 1
		dc.l loc_81F7E
ChildObjDat_83288:dc.w 3
		dc.l loc_825CA
ChildObjDat_8328E:dc.w 3
		dc.l loc_8249A
ChildObjDat_83294:dc.w 1
		dc.l loc_82588
		dc.w $800
		dc.l loc_825BC
		dc.w $E800
ChildObjDat_832A2:dc.w 0
		dc.l loc_826A0
byte_832A8:	dc.b 3
		dc.b $29
		dc.b $2A
		dc.b $2B
		dc.b $2C
		dc.b $FC
byte_832AE:	dc.b 3
		dc.b $2D
		dc.b $2E
		dc.b $2F
		dc.b $30
		dc.b $FC
byte_832B4:	dc.b  $18,   3
		dc.b  $18,   3
		dc.b  $19,   3
		dc.b  $1A,   4
		dc.b  $1B,   5
		dc.b  $F4
byte_832BF:	dc.b	1, $31
		dc.b  $32, $FC
byte_832C3:	dc.b  $33,   3
		dc.b  $34,   3
		dc.b  $35,   3
		dc.b  $39,   7
		dc.b  $37,   3
		dc.b  $36,   3
		dc.b  $FC
byte_832D0:	dc.b  $3A, $2F
		dc.b  $3B,   9
		dc.b  $3C,   9
		dc.b  $3B,   9
		dc.b  $FC
byte_832D9:	dc.b  $3D, $2F
		dc.b  $3E,   9
		dc.b  $3F,   9
		dc.b  $3E,   9
		dc.b  $FC
Map_DDZMissileAsteroid:include "Levels\DDZ\Misc Object Data\Map - Missile Asteroid.asm"

; ---------------------------------------------------------------------------

Obj_HiddenMonitor:

		lea	ObjDat_HiddenMonitor(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#Obj_HiddenMonitorMain,(a0)
		move.b	#$F,$1E(a0)
		move.b	#$F,$1F(a0)
		move.b	#$46,$28(a0)
		move.b	$2C(a0),$20(a0)	; Backup object subtype
		rts
; ---------------------------------------------------------------------------

Obj_HiddenMonitorMain:
		move.w	($FFFFFAA6).w,d0
		beq.s	loc_8375A
		movea.w	d0,a1
		cmpi.l	#Obj_EndSign,(a1)
		bne.s	loc_8375A			; If no signpost is active, branch
		btst	#0,$38(a1)
		beq.s	loc_8375A			; If signpost hasn't landed, branch
		lea	word_8379E(pc),a2
		move.w	$10(a0),d0
		move.w	$10(a1),d1
		add.w	(a2)+,d0
		cmp.w	d0,d1
		bcs.s	loc_8374C
		add.w	(a2)+,d0
		cmp.w	d0,d1
		bcc.s	loc_8374C
		move.w	$14(a0),d0
		move.w	$14(a1),d1
		add.w	(a2)+,d0
		cmp.w	d0,d1
		bcs.s	loc_8374C
		add.w	(a2)+,d0
		cmp.w	d0,d1
		bcs.s	loc_83760

loc_8374C:

		moveq	#$7E,d0				; If signpost has landed
		jsr	(Play_Sound_2).l
		move.l	#Sprite_OnScreen_Test,(a0)

loc_8375A:

		jmp	(Delete_Sprite_If_Not_In_Range).l
; ---------------------------------------------------------------------------

loc_83760:
		bclr	#0,$38(a1)			; If signpost has landed and is in range
		move.l	#Obj_Monitor,(a0)	; make this object a monitor
		move.b	#2,5(a0)
		move.b	#4,$3C(a0)
		move.w	#-$500,$1A(a0)
		moveq	#$44,d0
		jsr	(Play_Sound_2).l
		bclr	#0,4(a0)
		beq.s	loc_83798
		bset	#7,$A(a0)
		clr.b	$2A(a0)

loc_83798:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
word_8379E:	dc.w  $FFF2,   $1C, $FF80,   $C0
ObjDat_HiddenMonitor:	dc.l Map_Monitor
		dc.w $4C4
		dc.w $280
		dc.b $E
		dc.b $10
		dc.b 0
		dc.b 0
; ---------------------------------------------------------------------------

Obj_EndSign:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	EndSign_Index(pc,d0.w),d1
		jsr	EndSign_Index(pc,d1.w)
		lea	PLCPtr_EndSigns(pc),a2
		jsr	Perform_DPLC(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
EndSign_Index:	dc.w Obj_EndSignInit-EndSign_Index

		dc.w Obj_EndSignFall-EndSign_Index
		dc.w Obj_EndSignLanded-EndSign_Index
		dc.w Obj_EndSignResults-EndSign_Index
		dc.w Obj_EndSignAfter-EndSign_Index
; ---------------------------------------------------------------------------

Obj_EndSignInit:
		lea	ObjSlot_EndSigns(pc),a1
		jsr	SetUp_ObjAttributesSlotted(pc)
		btst	#7,($FFFFB00A).w
		beq.s	loc_837EE
		bset	#7,$A(a0)			; Signs have same priority as Sonic

loc_837EE:
		move.w	a0,($FFFFFAA6).w	; Put RAM address here for use by hidden monitor object
		move.b	#$18,$1F(a0)
		move.b	#$1E,$1E(a0)
		move.l	#AniRaw_EndSigns1,$30(a0)
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_83816
		move.l	#AniRaw_EndSigns2,$30(a0)

loc_83816:
		move.w	($FFFFEE7C).w,d0
		subi.w	#$20,d0
		move.w	d0,$14(a0)			; Place vertical position at top of screen
		moveq	#-$48,d0
		jsr	(Play_Sound_2).l
		lea	Child1_EndSignStub(pc),a2	; Make the little stub at the bottom of the signpost
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

Obj_EndSignFall:
		move.b	($FFFFFE0F).w,d0
		andi.b	#3,d0
		bne.s	loc_83844
		lea	Child6_EndSignSparkle(pc),a2	; Create a signpost sparkle every 4 frames
		jsr	CreateChild6_Simple(pc)

loc_83844:
		bsr.w	EndSign_CheckPlayerHit
		addi.w	#$C,$1A(a0)
		jsr	(MoveSprite2).l					; Move downward
		bsr.w	EndSign_CheckWall
		jsr	Animate_Raw(pc)
		move.w	($FFFFEE7C).w,d0
		addi.w	#$50,d0
		cmp.w	$14(a0),d0
		bhi.s	locret_838BC		; Ensure that signpost can't land if too far up the screen itself
		tst.w	$1A(a0)
		bmi.s	locret_838BC		; And also when the signpost is still moving up
		cmpi.b	#8,($FFFFFE10).w
		bne.s	loc_8389C
		moveq	#0,d0				; Special code for handling the landing on Sandopolis 1's sand
		cmpi.w	#$4210,$10(a0)
		bcs.s	loc_83884
		moveq	#2,d0

loc_83884:
		cmp.w	$3E(a0),d0
		beq.s	loc_83894
		move.w	d0,$3E(a0)
		move.w	word_838BE(pc,d0.w),8(a0)

loc_83894:
		cmpi.w	#$9F2,$14(a0)
		bcc.s	loc_838AA

loc_8389C:
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	locret_838BC
		add.w	d1,$14(a0)

loc_838AA:
		move.b	#4,5(a0)			; If signpost has landed
		bset	#0,$38(a0)
		move.w	#$40,$2E(a0)

locret_838BC:

		rts
; ---------------------------------------------------------------------------
word_838BE:	dc.w $180
		dc.w $300
; ---------------------------------------------------------------------------

Obj_EndSignLanded:
		btst	#0,$38(a0)
		beq.s	loc_838FA
		jsr	Animate_Raw(pc)
		subq.w	#1,$2E(a0)			; Keep animating while landing for X amount of frames
		bmi.s	loc_838D6
		rts
; ---------------------------------------------------------------------------

loc_838D6:
		move.b	#6,5(a0)
		st	($FFFFFABE).w
		clr.w	$18(a0)
		clr.w	$1A(a0)			; Null velocity
		moveq	#0,d0
		move.b	($FFFFFF09).w,d0	; Get current character "mode"
		move.b	FrameArray_EndSign(pc,d0.w),$22(a0)
		st	($FFFFF7CB).w		; Null Sonic's input
		rts
; ---------------------------------------------------------------------------

loc_838FA:
		move.b	#2,5(a0)			; If a hidden monitor was hit, bounce ths signpost again
		move.b	#$20,$20(a0)
		move.w	#-$200,$1A(a0)
		rts
; ---------------------------------------------------------------------------
FrameArray_EndSign:	dc.b	0,   0,	  1,   2
; ---------------------------------------------------------------------------

Obj_EndSignResults:
		lea	($FFFFB000).w,a1
		btst	#1,$2A(a1)
		bne.s	locret_83936		; If player is not standing on the ground, wait until he is
		move.b	#8,5(a0)
		jsr	Set_PlayerEndingPose(pc)
		jsr	(Create_New_Sprite).l
		bne.s	locret_83936
		move.l	#Obj_LevelResults,(a1)

locret_83936:

		rts
; ---------------------------------------------------------------------------

Obj_EndSignAfter:
		cmpi.b	#$B,($FFFFFE10).w
		bne.s	loc_8395A
		jsr	(ObjHitFloor).l		; If Death Egg Zone, then check if there's still a floor
		tst.w	d1
		beq.s	loc_83956
		bmi.s	loc_83956
		jsr	(MoveSprite).l		; Move sprite if there's no floor
		bra.w	loc_8395E
; ---------------------------------------------------------------------------

loc_83956:

		add.w	d1,$14(a0)

loc_8395A:
		clr.w	$1A(a0)		; Null vertical velocity

loc_8395E:
		move.w	$10(a0),d0			; Check for whether signpost goes out of range
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_83988
		move.w	$14(a0),d0
		sub.w	($FFFFEE7C).w,d0
		addi.w	#$80,d0
		cmpi.w	#$200,d0
		bhi.s	loc_83988
		jmp	(Check_TailsEndPose).l
; ---------------------------------------------------------------------------

loc_83988:

		lea	PLC_SpikesSprings(pc),a1
		jsr	(Load_PLC_Raw).l
		jsr	Remove_From_TrackingSlot(pc)
		jmp	Go_Delete_Sprite(pc)
; ---------------------------------------------------------------------------
PLC_SpikesSprings:	dc.w 0

		dc.l ArtNem_SpikesSprings
		dc.w $9280
; ---------------------------------------------------------------------------

Obj_SignpostSparkle:
		lea	ObjDat_SignpostSparkle(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		btst	#7,($FFFFB00A).w
		beq.s	loc_839B8
		bset	#7,$A(a0)

loc_839B8:
		move.l	#Obj_SignpostSparkleMain,(a0)
		jsr	(Random_Number).l
		andi.w	#$1F,d0
		subi.w	#$10,d0
		add.w	d0,$14(a0)			; Random vertical position
		move.w	$10(a0),$3A(a0)
		move.w	#$1000,$18(a0)
		move.w	#$20,$2E(a0)
		move.l	#Go_Delete_Sprite,$34(a0)

Obj_SignpostSparkleMain:
		move.w	#$400,d0
		move.w	$10(a0),d1
		cmp.w	$3A(a0),d1
		bcs.s	loc_839FA
		neg.w	d0

loc_839FA:
		move.w	#$280,d1
		add.w	d0,$18(a0)		; Do rotation around sign
		bpl.s	loc_83A08
		move.w	#$380,d1

loc_83A08:
		move.w	d1,8(a0)
		jsr	(MoveSprite2).l
		lea	AniRaw_SignpostSparkle(pc),a1
		jsr	Animate_RawNoSST(pc)
		jsr	Obj_Wait(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_SignpostStub:
		lea	ObjDat_SignpostStub(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#Obj_SignpostStubMain,(a0)
		btst	#7,($FFFFB00A).w
		beq.s	Obj_SignpostStubMain
		bset	#7,$A(a0)

Obj_SignpostStubMain:

		jsr	Refresh_ChildPosition(pc)
		jsr	(Child_GetPriority).l
		jmp	(Child_Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


EndSign_CheckPlayerHit:
		tst.b	$20(a0)
		bne.s	loc_83AB8
		lea	EndSign_Range(pc),a1
		jsr	Check_PlayerInRange(pc)
		tst.l	d0
		beq.s	locret_83ABC		; If neither player is in range, don't do anything
		tst.w	d0
		beq.s	loc_83A6A
		bsr.w	sub_83A70

loc_83A6A:
		swap	d0
		tst.w	d0
		beq.s	locret_83ABC
; End of function EndSign_CheckPlayerHit


; =============== S U B R O U T I N E =======================================


sub_83A70:
		movea.w	d0,a1				; This can be done up to twice depending on who hit the signpost
		cmpi.b	#2,$20(a1)
		bne.s	locret_83ABC		; only go on if Player is currently jumping
		tst.w	$1A(a1)
		bpl.s	locret_83ABC		; And if he's actually moving upwards
		move.b	#$20,$20(a0)		; Set delay for when it checks for the next hit
		move.w	$10(a0),d0
		sub.w	$10(a1),d0
		bne.s	loc_83A92
		moveq	#8,d0

loc_83A92:
		lsl.w	#4,d0
		move.w	d0,$18(a0)			; Modify strength of X velocity based on how far to the left/right player is
		move.w	#-$200,$1A(a0)		; New vertical velocity is always the same
		moveq	#-$48,d0
		jsr	(Play_Sound_2).l
		lea	Child6_EndSignScore(pc),a2
		jsr	CreateChild6_Simple(pc)
		moveq	#$A,d0
		movea.l	a1,a3
		jmp	(HUD_AddToScore).l			; Add 100 points whenever hit
; ---------------------------------------------------------------------------

loc_83AB8:
		subq.b	#1,$20(a0)

locret_83ABC:

		rts
; End of function sub_83A70

; ---------------------------------------------------------------------------
EndSign_Range:	dc.w  $FFE0,   $40, $FFE8,   $30

; =============== S U B R O U T I N E =======================================


EndSign_CheckWall:
		move.w	($FFFFEE78).w,d0
		tst.w	$18(a0)
		bmi.s	loc_83AE8
		addi.w	#$128,d0
		cmp.w	$10(a0),d0
		bcs.s	loc_83AFE
		moveq	#$20,d3
		jsr	(ObjHitWall).l
		tst.w	d1
		bmi.s	loc_83AFE
		rts
; ---------------------------------------------------------------------------

loc_83AE8:
		addi.w	#$18,d0
		cmp.w	$10(a0),d0
		bhi.s	loc_83AFE
		moveq	#-$20,d3
		jsr	(ObjHitWall2).l
		tst.w	d1
		bpl.s	locret_83B02

loc_83AFE:

		neg.w	$18(a0)

locret_83B02:
		rts
; End of function EndSign_CheckWall

; ---------------------------------------------------------------------------
ObjSlot_EndSigns:	dc.w 0, $4AC, $C, 0
		dc.l Map_EndSigns
		dc.w $300
		dc.b $18
		dc.b $10
		dc.b 0
		dc.b 0
ObjDat_SignpostStub:	dc.l Map_SignpostStub
		dc.w $69E
		dc.w $300
		dc.b 4
		dc.b 8
		dc.b 0
		dc.b 0
ObjDat_SignpostSparkle:	dc.l Map_Ring
		dc.w $26BC
		dc.w $280
		dc.b 8
		dc.b 8
		dc.b 4
		dc.b 0
Child1_EndSignStub:dc.w 0
		dc.l Obj_SignpostStub
		dc.b 0, $18
Child6_EndSignSparkle:dc.w 0
		dc.l Obj_SignpostSparkle
Child6_EndSignScore:dc.w 0
		dc.l Obj_EnemyScore
PLCPtr_EndSigns:	dc.l ArtUnc_EndSigns
		dc.l DPLC_EndSigns
AniRaw_EndSigns1:	dc.b	1,   0
		dc.b	4,   5
		dc.b	6,   1
		dc.b	4,   5
		dc.b	6,   3
		dc.b	4,   5
		dc.b	6, $FC
AniRaw_EndSigns2:	dc.b	1,   1
		dc.b	4,   5
		dc.b	6,   2
		dc.b	4,   5
		dc.b	6,   3
		dc.b	4,   5
		dc.b	6, $FC
AniRaw_SignpostSparkle:	dc.b	1,   4
		dc.b	5,   6
		dc.b	7, $FC
DPLC_EndSigns:	include "General\Sprites\Signpost\DPLC - End Signs.asm"

Map_EndSigns:	include "General\Sprites\Signpost\Map - End Signs.asm"

Map_SignpostStub:	include "General\Sprites\Signpost\Map - Signpost Stub.asm"


; =============== S U B R O U T I N E =======================================


AfterBoss_Cleanup:


		moveq	#0,d0
		lea	($FFFFFE10).w,a1
		move.b	(a1)+,d0
		add.b	d0,d0
		add.b	(a1)+,d0
		add.b	d0,d0
		move.w	off_83C1C(pc,d0.w),d0
		jmp	off_83C1C(pc,d0.w)
; End of function AfterBoss_Cleanup

; ---------------------------------------------------------------------------
off_83C1C:	dc.w loc_83C7C-off_83C1C

		dc.w loc_83C90-off_83C1C
		dc.w locret_83CA6-off_83C1C
		dc.w locret_83CA6-off_83C1C
		dc.w loc_83CA8-off_83C1C
		dc.w loc_83CA8-off_83C1C
		dc.w locret_83CB2-off_83C1C
		dc.w locret_83CB2-off_83C1C
		dc.w locret_83CB2-off_83C1C
		dc.w locret_83CB2-off_83C1C
		dc.w locret_83CB2-off_83C1C
		dc.w loc_83CB4-off_83C1C
		dc.w loc_83CC0-off_83C1C
		dc.w loc_83CC0-off_83C1C
		dc.w loc_83CC0-off_83C1C
		dc.w loc_83CC0-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
		dc.w locret_83CCC-off_83C1C
; ---------------------------------------------------------------------------

loc_83C7C:
		lea	(Pal_AIZ).l,a1
		lea	($FFFFFC20).w,a2
		moveq	#$17,d0

loc_83C88:
		move.l	(a1)+,(a2)+
		dbf	d0,loc_83C88
		rts
; ---------------------------------------------------------------------------

loc_83C90:
		lea	(Pal_AIZFire).l,a1
		jsr	(PalLoad_Line1).l
		lea	PLC_83CCE(pc),a1
		jmp	(Load_PLC_Raw).l
; ---------------------------------------------------------------------------

locret_83CA6:
		rts
; ---------------------------------------------------------------------------

loc_83CA8:
		lea	PLC_83D3A(pc),a1
		jmp	(Load_PLC_Raw).l
; ---------------------------------------------------------------------------

locret_83CB2:
		rts
; ---------------------------------------------------------------------------

loc_83CB4:
		lea	(Pal_ICZ2).l,a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

loc_83CC0:
		lea	(Pal_MHZ2).l,a1
		jmp	(PalLoad_Line1).l
; ---------------------------------------------------------------------------

locret_83CCC:
		rts
; ---------------------------------------------------------------------------
PLC_83CCE:	dc.w 6
		dc.l ArtNem_Monitors
		dc.w $9880
		dc.l ArtNem_AIZMisc2
		dc.w $5D20
		dc.l ArtNem_AIZSwingVine
		dc.w $8360
		dc.l ArtNem_AIZBackgroundTree
		dc.w $8700
		dc.l ArtNem_Bubbles
		dc.w $8B80
		dc.l ArtNem_GrayButton
		dc.w $8AC0
		dc.l ArtNem_AIZCorkFloor2
		dc.w $8800
		dc.w	  0,  $EEE,  $EC0,  $E60,  $C22,   $EE,	  $88,	$60A,	$8E,   $2E,  $844,   $20,  $EAA,  $A66,	 $ECC,	 $44
		dc.w	  0,  $EEE,  $EC0,  $E60,  $C22,   $EE,	  $88,	 $8E,	$2C,  $822,	0,   $20,  $CAA,  $866,	 $644,	 $44
PLC_83D3A:	dc.w 1

		dc.l ArtNem_Monitors
		dc.w $9880
		dc.l ArtNem_SpikesSprings
		dc.w $9280
PLC_83D48:	dc.w 0

		dc.l ArtNem_Monitors
		dc.w $9880
		dc.w 2
		dc.l ArtNem_Explosion
		dc.w $B400
		dc.l ArtNem_Squirrel
		dc.w $B000
		dc.l ArtNem_BlueFlicky
		dc.w $B240
PLC_83D64:	dc.w 0

		dc.l ArtNem_BossExplosion
		dc.w $A000
PLC_83D6C:	dc.w 0

		dc.l ArtNem_Explosion
		dc.w $B400
PLC_CNZ2KnuxEnd:	dc.w 0

		dc.l ArtNem_EggCapsule
		dc.w $9280
PLC_83D7C:	dc.w 0
		dc.l ArtNem_RobotnikShip
		dc.w $A5C0
; ---------------------------------------------------------------------------

Obj_CreateBossExplosion:

		moveq	#0,d0
		move.b	$2C(a0),d0
		lea	CreateBossExpParameterIndex(pc),a1
		adda.w	(a1,d0.w),a1
		move.b	(a1)+,$39(a0)
		move.b	(a1)+,$3A(a0)
		move.b	(a1)+,$3B(a0)
		move.b	(a1)+,d0
		lea	CreateBossExpRoutineSet(pc,d0.w),a1
		movea.l	(a1)+,a2
		move.l	a2,(a0)
		move.l	(a1)+,$34(a0)
		jmp	(a2)
; ---------------------------------------------------------------------------
CreateBossExpRoutineSet:	dc.l Obj_Wait
		dc.l Obj_BossExpControl1
		dc.l Obj_WaitForParent
		dc.l Obj_BossExpControl1
		dc.l Obj_Wait
		dc.l Obj_NormalExpControl
		dc.l Obj_Wait
		dc.l Obj_BossExpControl2
		dc.l Obj_WaitForParent
		dc.l Obj_BossExpControl2
		dc.l Obj_WaitForParent
		dc.l Obj_NormalExpControl
		dc.l Obj_WaitForParent
		dc.l Obj_BossExpControlOff
CreateBossExpParameterIndex:	dc.w CreateBossExp_00-CreateBossExpParameterIndex

		dc.w CreateBossExp_02-CreateBossExpParameterIndex
		dc.w CreateBossExp_04-CreateBossExpParameterIndex
		dc.w CreateBossExp_06-CreateBossExpParameterIndex
		dc.w CreateBossExp_08-CreateBossExpParameterIndex
		dc.w CreateBossExp_0A-CreateBossExpParameterIndex
		dc.w CreateBossExp_0C-CreateBossExpParameterIndex
		dc.w CreateBossExp_0E-CreateBossExpParameterIndex
		dc.w CreateBossExp_10-CreateBossExpParameterIndex
		dc.w CreateBossExp_12-CreateBossExpParameterIndex
		dc.w CreateBossExp_14-CreateBossExpParameterIndex
		dc.w CreateBossExp_16-CreateBossExpParameterIndex
		dc.w CreateBossExp_18-CreateBossExpParameterIndex
		dc.w CreateBossExp_1A-CreateBossExpParameterIndex
		dc.w CreateBossExp_1C-CreateBossExpParameterIndex
		dc.w CreateBossExp_1E-CreateBossExpParameterIndex
		dc.w CreateBossExp_20-CreateBossExpParameterIndex
CreateBossExp_00:	dc.b  $20, $20,	$20,   0	; Explosion timer, X offset range, Y offset range, routine set
CreateBossExp_02:	dc.b  $28, $80,	$80, $18
CreateBossExp_04:	dc.b  $80, $20,	$20,   8
CreateBossExp_06:	dc.b	4, $10,	$10,   0
CreateBossExp_08:	dc.b	8, $20,	$20, $10
CreateBossExp_0A:	dc.b  $20, $20,	$20,   0
CreateBossExp_0C:	dc.b  $40, $80,	$20,   0
CreateBossExp_0E:	dc.b  $80, $40,	$40,   8
CreateBossExp_10:	dc.b  $20, $20,	$20, $18
CreateBossExp_12:	dc.b  $80, $20,	$20, $20
CreateBossExp_14:	dc.b	8, $80,	$20, $10
CreateBossExp_16:	dc.b  $80, $80,	$80,   8
CreateBossExp_18:	dc.b  $80, $80,	$80, $28
CreateBossExp_1A:	dc.b  $80, $40,	$40, $28
CreateBossExp_1C:	dc.b  $80, $80,	$40,   8
CreateBossExp_1E:	dc.b  $80, $10,	$10,   8
CreateBossExp_20:	dc.b  $80, $20,	$20, $30
; ---------------------------------------------------------------------------

Obj_WaitForParent:
		movea.w	$46(a0),a1
		btst	#5,$38(a1)
		bne.w	loc_83EC2
		tst.l	(a1)
		beq.w	loc_83EC2
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

Obj_BossExpControl1:

		move.b	$39(a0),d0
		bmi.s	loc_83E7E		; If negative, explosions are constantly created every three frames
		subq.b	#1,d0
		move.b	d0,$39(a0)		; Otherwise, continue making explosions until timer runs out
		beq.s	loc_83EC2

loc_83E7E:
		move.w	#2,$2E(a0)

; =============== S U B R O U T I N E =======================================


sub_83E84:

		lea	Child6_MakeBossExplosion1(pc),a2
		jsr	CreateChild6_Simple(pc)
		bne.w	locret_83EC0

loc_83E90:

		jsr	(Random_Number).l		; Offset the explosion by a random amount capped by an effective range
		moveq	#0,d1
		move.b	$3A(a0),d1
		move.w	d1,d2
		add.w	d2,d2
		subq.w	#1,d2
		and.w	d2,d0
		sub.w	d1,d0
		add.w	d0,$10(a1)
		swap	d0
		moveq	#0,d1
		move.b	$3B(a0),d1
		move.w	d1,d2
		add.w	d2,d2
		subq.w	#1,d2
		and.w	d2,d0
		sub.w	d1,d0
		add.w	d0,$14(a1)

locret_83EC0:

		rts
; End of function sub_83E84

; ---------------------------------------------------------------------------

loc_83EC2:

		jmp	Go_Delete_Sprite(pc)
; ---------------------------------------------------------------------------

Obj_NormalExpControl:
		subq.b	#1,$39(a0)				; Same as above, but uses regular explosions (no animals of course)
		beq.s	loc_83EC2
		move.w	#2,$2E(a0)
		lea	Child6_MakeNormalExplosion(pc),a2
		jsr	CreateChild6_Simple(pc)
		bne.w	locret_83EC0
		move.b	#2,5(a1)
		bset	#7,$A(a1)
		bra.s	loc_83E90
; ---------------------------------------------------------------------------

Obj_BossExpControl2:
		subq.b	#1,$39(a0)
		beq.s	loc_83EC2
		move.w	#2,$2E(a0)
		lea	Child6_MakeBossExplosion2(pc),a2
		jsr	CreateChild6_Simple(pc)
		bne.w	locret_83EC0
		bra.s	loc_83E90
; ---------------------------------------------------------------------------

Obj_BossExpControlOff:
		subq.b	#1,$39(a0)
		beq.s	loc_83EC2
		move.w	#2,$2E(a0)
		lea	Child6_MakeBossExplosionOff(pc),a2
		jsr	CreateChild6_Simple(pc)
		bne.w	locret_83EC0
		bra.w	loc_83E90
; ---------------------------------------------------------------------------

Obj_BossExplosionSpecial:
		move.w	#2,$2E(a0)
		move.w	($FFFFEE78).w,d0
		addi.w	#$A0,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d0
		addi.w	#$70,d0
		move.w	d0,$14(a0)
		move.b	#2,$2C(a0)
		bra.w	Obj_CreateBossExplosion
; ---------------------------------------------------------------------------

Obj_BossExplosion1:
		lea	ObjDat_BossExplosion1(pc),a1
		jsr	SetUp_ObjAttributes(pc)

loc_83F52:
		move.l	#Obj_BossExplosionAnim,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		moveq	#-$4C,d0
		jsr	(Play_Sound_2).l

Obj_BossExplosionAnim:

		lea	AniRaw_BossExplosion(pc),a1
		jsr	Animate_RawNoSSTMultiDelay(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_BossExplosion2:
		lea	ObjDat_BossExplosion2(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		bra.s	loc_83F52
; ---------------------------------------------------------------------------

Obj_BossExplosionOffset:
		lea	ObjDat_BossExplosion1(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#Obj_BossExplosionOffsetAnim,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		moveq	#-$4C,d0
		jsr	(Play_Sound_2).l

Obj_BossExplosionOffsetAnim:
		move.w	($FFFFEEBC).w,d0
		sub.w	d0,$10(a0)
		lea	AniRaw_BossExplosion(pc),a1
		jsr	Animate_RawNoSSTMultiDelay(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
ObjDat_BossExplosion1:	dc.l Map_BossExplosion

		dc.w $8500
		dc.w 0
		dc.b $C
		dc.b $C
		dc.b 0
		dc.b 0
ObjDat_BossExplosion2:	dc.l Map_BossExplosion
		dc.w $84D2
		dc.w 0
		dc.b $C
		dc.b $C
		dc.b 0
		dc.b 0
AniRaw_BossExplosion:	dc.b	0,   0

		dc.b	0,   1
		dc.b	1,   1
		dc.b	2,   2
		dc.b	3,   3
		dc.b	4,   4
		dc.b	5,   4
		dc.b  $F4,   0
Child6_MakeBossExplosion1:		dc.w 0
		dc.l Obj_BossExplosion1
Child6_MakeBossExplosion2:		dc.w 0
		dc.l Obj_BossExplosion2
Child6_MakeBossExplosionOff:	dc.w 0
		dc.l Obj_BossExplosionOffset
Child6_CreateBossExplosion:dc.w 0
		dc.l Obj_CreateBossExplosion
		dc.b 0
		dc.b 0
Child6_MakeNormalExplosion:dc.w 0
		dc.l Obj_Explosion
Map_BossExplosion:	include "General\Sprites\Boss Explosion\Map - Boss Explosion.asm"


; =============== S U B R O U T I N E =======================================


SetUp_ObjAttributes:

		move.l	(a1)+,$C(a0)		; Mappings location

SetUp_ObjAttributes2:

		move.w	(a1)+,$A(a0)		; VRAM offset

SetUp_ObjAttributes3:

		move.w	(a1)+,8(a0)			; Priority
		move.b	(a1)+,7(a0)			; Width
		move.b	(a1)+,6(a0)			; Height
		move.b	(a1)+,$22(a0)		; Mappings frame
		move.b	(a1)+,$28(a0)		; Collision Number
		bset	#2,4(a0)			; Object uses world coordinates
		addq.b	#2,5(a0)			; Increase routine counter

locret_8405E:

		rts
; End of function SetUp_ObjAttributes


; =============== S U B R O U T I N E =======================================


CreateChild1_Normal:

		moveq	#0,d2				; Includes positional offset data
		move.w	(a2)+,d6

loc_84064:
		jsr	(Create_New_Sprite3).l
		bne.s	locret_840AE
		move.w	a0,$46(a1)			; Parent RAM address into $46
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)		; Mappings and VRAM offset copied from parent object
		move.l	(a2)+,(a1)			; Object address
		move.b	d2,$2C(a1)			; Index of child object (done sequentially for each object)
		move.w	$10(a0),d0
		move.b	(a2)+,d1			; X Positional offset
		move.b	d1,$42(a1)			; $42 has the X offset
		ext.w	d1
		add.w	d1,d0
		move.w	d0,$10(a1)			; Apply offset to new position
		move.w	$14(a0),d0
		move.b	(a2)+,d1			; Same as above for Y
		move.b	d1,$43(a1)			; $43 has the Y offset
		ext.w	d1
		add.w	d1,d0
		move.w	d0,$14(a1)			; Apply offset
		addq.w	#2,d2				; Add 2 to index
		dbf	d6,loc_84064			; Loop
		moveq	#0,d0

locret_840AE:
		rts
; End of function CreateChild1_Normal


; =============== S U B R O U T I N E =======================================


CreateChild2_Complex:


		moveq	#0,d2				; Includes positional offset data and velocity and CHECKLATER
		move.w	(a2)+,d6

loc_840B4:
		jsr	(Create_New_Sprite3).l
		bne.s	locret_84112
		move.w	a0,$46(a1)			; Parent RAM address into $46
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)		; Mappings and VRAM offset copied from parent object
		move.l	(a2)+,(a1)
		move.l	(a2)+,$3E(a1)
		move.l	(a2)+,$30(a1)
		move.l	(a2)+,$34(a1)
		move.b	d2,$2C(a1)
		move.w	$10(a0),d0
		move.b	(a2)+,d1
		move.b	d1,$42(a1)			; See offset information above
		ext.w	d1
		add.w	d1,d0
		move.w	d0,$10(a1)
		move.w	$14(a0),d0
		move.b	(a2)+,d1
		move.b	d1,$43(a1)			; See offset information above
		ext.w	d1
		add.w	d1,d0
		move.w	d0,$14(a1)
		move.w	(a2)+,$18(a1)		; X Velocity
		move.w	(a2)+,$1A(a1)		; Y Velocity
		addq.w	#2,d2
		dbf	d6,loc_840B4
		moveq	#0,d0

locret_84112:
		rts
; End of function CreateChild2_Complex


; =============== S U B R O U T I N E =======================================


CreateChild3_NormalRepeated:

		moveq	#0,d2			; Same as Child creation routine 1, except it repeats one object several times rather than different objects sequentially
		move.w	(a2)+,d6

loc_84118:
		movea.l	a2,a3
		jsr	(Create_New_Sprite3).l
		bne.s	locret_84164
		move.w	a0,$46(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.l	(a3)+,(a1)
		move.b	d2,$2C(a1)
		move.w	$10(a0),d0
		move.b	(a3)+,d1
		move.b	d1,$42(a1)
		ext.w	d1
		add.w	d1,d0
		move.w	d0,$10(a1)
		move.w	$14(a0),d0
		move.b	(a3)+,d1
		move.b	d1,$43(a1)
		ext.w	d1
		add.w	d1,d0
		move.w	d0,$14(a1)
		addq.w	#2,d2
		dbf	d6,loc_84118
		moveq	#0,d0

locret_84164:
		rts
; End of function CreateChild3_NormalRepeated


; =============== S U B R O U T I N E =======================================


CreateChild4_LinkListRepeated:

		movea.l	a0,a3				; Creates a linked object list. Previous object address is in $46, while next object in list is at $44
		moveq	#0,d2
		move.w	(a2)+,d6

loc_8416C:
		jsr	(Create_New_Sprite3).l
		bne.s	locret_841A4
		move.w	a3,$46(a1)
		move.w	a1,$44(a3)
		movea.l	a1,a3
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.l	(a2),(a1)
		move.b	d2,$2C(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addq.w	#2,d2
		dbf	d6,loc_8416C
		moveq	#0,d0

locret_841A4:
		rts
; End of function CreateChild4_LinkListRepeated


; =============== S U B R O U T I N E =======================================


CreateChild5_ComplexAdjusted:

		moveq	#0,d2				; Same as child routine 2, but adjusts both X position and X velocity based on parent object's orientation
		move.w	(a2)+,d6

loc_841AA:
		jsr	(Create_New_Sprite3).l
		bne.s	locret_8421E
		move.w	a0,$46(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.l	(a2)+,(a1)
		move.l	(a2)+,$3E(a1)
		move.l	(a2)+,$30(a1)
		move.l	(a2)+,$34(a1)
		move.b	d2,$2C(a1)
		move.w	$10(a0),d0
		move.b	(a2)+,d1
		move.b	d1,$42(a1)
		ext.w	d1
		btst	#0,4(a0)
		beq.s	loc_841EA
		neg.w	d1

loc_841EA:
		add.w	d1,d0
		move.w	d0,$10(a1)
		move.w	$14(a0),d0
		move.b	(a2)+,d1
		move.b	d1,$43(a1)
		ext.w	d1
		add.w	d1,d0
		move.w	d0,$14(a1)
		move.w	(a2)+,d1
		btst	#0,4(a0)
		beq.s	loc_8420E
		neg.w	d1

loc_8420E:
		move.w	d1,$18(a1)
		move.w	(a2)+,$1A(a1)
		addq.w	#2,d2
		dbf	d6,loc_841AA
		moveq	#0,d0

locret_8421E:
		rts
; End of function CreateChild5_ComplexAdjusted


; =============== S U B R O U T I N E =======================================


CreateChild6_Simple:

		moveq	#0,d2				; Simple child creation routine, merely creates x number of the same object at the parent's position
		move.w	(a2)+,d6

loc_84224:
		jsr	(Create_New_Sprite3).l
		bne.s	locret_84256
		move.w	a0,$46(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.l	(a2),(a1)
		move.b	d2,$2C(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addq.w	#2,d2
		dbf	d6,loc_84224
		moveq	#0,d0

locret_84256:
		rts
; End of function CreateChild6_Simple


; =============== S U B R O U T I N E =======================================


CreateChild7_Normal2:

		moveq	#0,d2				; Same as child routine 1, but does not limit children to object slots after the parent
		move.w	(a2)+,d6

loc_8425C:
		jsr	(Create_New_Sprite).l
		bne.s	locret_842A6
		move.w	a0,$46(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.l	(a2)+,(a1)
		move.b	d2,$2C(a1)
		move.w	$10(a0),d0
		move.b	(a2)+,d1
		move.b	d1,$42(a1)
		ext.w	d1
		add.w	d1,d0
		move.w	d0,$10(a1)
		move.w	$14(a0),d0
		move.b	(a2)+,d1
		move.b	d1,$43(a1)
		ext.w	d1
		add.w	d1,d0
		move.w	d0,$14(a1)
		addq.w	#2,d2
		dbf	d6,loc_8425C
		moveq	#0,d0

locret_842A6:
		rts
; End of function CreateChild7_Normal2


; =============== S U B R O U T I N E =======================================


CreateChild8_TreeListRepeated:

		movea.l	a0,a3				; Creates a linked object list like routine 4, but they only chain themselves one way. All maintain the calling object as their parent
		moveq	#0,d2
		move.w	(a2)+,d6

loc_842AE:
		jsr	(Create_New_Sprite3).l
		bne.s	locret_842E6
		move.w	a3,$46(a1)
		move.w	a0,$44(a1)
		movea.l	a1,a3
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.l	(a2),(a1)
		move.b	d2,$2C(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addq.w	#2,d2
		dbf	d6,loc_842AE
		moveq	#0,d0

locret_842E6:
		rts
; End of function CreateChild8_TreeListRepeated


; =============== S U B R O U T I N E =======================================


CreateChild9_TreeList:
		movea.l	a0,a3				; Same as routine 8, but creates seperate objects in a list rather than repeating the same object
		moveq	#0,d2
		move.w	(a2)+,d6

loc_842EE:
		jsr	(Create_New_Sprite3).l
		bne.s	locret_84326
		move.w	a3,$46(a1)
		move.w	a0,$44(a1)
		movea.l	a1,a3
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.l	(a2)+,(a1)
		move.b	d2,$2C(a1)
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		addq.w	#2,d2
		dbf	d6,loc_842EE
		moveq	#0,d0

locret_84326:
		rts
; End of function CreateChild9_TreeList


; =============== S U B R O U T I N E =======================================


CreateChild10_NormalAdjusted:

		moveq	#0,d2				; Same as child routine 1, but adjusts X position based on parent object's orientation
		move.w	(a2)+,d6

loc_8432C:
		jsr	(Create_New_Sprite3).l
		bne.s	locret_84386
		move.w	a0,$46(a1)
		move.l	$C(a0),$C(a1)
		move.w	$A(a0),$A(a1)
		move.l	(a2)+,(a1)
		move.b	d2,$2C(a1)
		move.w	$10(a0),d0
		move.b	(a2)+,d1
		btst	#0,4(a0)
		beq.s	loc_84360
		bset	#0,4(a1)
		neg.b	d1

loc_84360:
		move.b	d1,$42(a1)
		ext.w	d1
		add.w	d1,d0
		move.w	d0,$10(a1)
		move.w	$14(a0),d0
		move.b	(a2)+,d1
		move.b	d1,$43(a1)
		ext.w	d1
		add.w	d1,d0
		move.w	d0,$14(a1)
		addq.w	#2,d2
		dbf	d6,loc_8432C
		moveq	#0,d0

locret_84386:
		rts
; End of function CreateChild10_NormalAdjusted


; =============== S U B R O U T I N E =======================================


Refresh_ChildPosition:

		movea.w	$46(a0),a1
		move.w	$10(a1),d0
		move.b	$42(a0),d1
		ext.w	d1
		add.w	d1,d0
		move.w	d0,$10(a0)
		move.w	$14(a1),d0
		move.b	$43(a0),d1
		ext.w	d1
		add.w	d1,d0
		move.w	d0,$14(a0)
		rts
; End of function Refresh_ChildPosition


; =============== S U B R O U T I N E =======================================


Refresh_ChildPositionAdjusted:

		movea.w	$46(a0),a1
		move.w	$10(a1),d0
		move.b	$42(a0),d1
		ext.w	d1
		bclr	#0,4(a0)
		btst	#0,4(a1)
		beq.s	loc_843D2
		neg.w	d1
		bset	#0,4(a0)

loc_843D2:
		add.w	d1,d0
		move.w	d0,$10(a0)
		move.w	$14(a1),d0
		move.b	$43(a0),d1
		ext.w	d1
		bclr	#1,4(a0)
		btst	#1,4(a1)
		beq.s	loc_843F8
		neg.w	d1
		bset	#1,4(a0)

loc_843F8:
		add.w	d1,d0
		move.w	d0,$14(a0)
		rts
; End of function Refresh_ChildPositionAdjusted


; =============== S U B R O U T I N E =======================================


Animate_Raw:

		movea.l	$30(a0),a1
; End of function Animate_Raw


; =============== S U B R O U T I N E =======================================


Animate_RawNoSST:

		subq.b	#1,$24(a0)
		bpl.s	locret_84426
		moveq	#0,d0
		move.b	$23(a0),d0
		addq.w	#1,d0
		move.b	d0,$23(a0)
		moveq	#0,d1
		move.b	1(a1,d0.w),d1
		bmi.s	loc_84428
		move.b	(a1),$24(a0)
		move.b	d1,$22(a0)

locret_84426:
		rts
; ---------------------------------------------------------------------------

loc_84428:

		neg.b	d1
		jsr	loc_8442E+2(pc,d1.w)

loc_8442E:
		clr.b	$23(a0)
		rts
; End of function Animate_RawNoSST

; ---------------------------------------------------------------------------
		bra.w	AnimateRaw_Restart		;FC
; ---------------------------------------------------------------------------
		bra.w	AnimateRaw_Jump			;F8
; ---------------------------------------------------------------------------
		bra.w	AnimateRaw_CustomCode	;F4
; ---------------------------------------------------------------------------

AnimateRaw_Jump:
		move.b	2(a1,d0.w),d1
		ext.w	d1
		lea	(a1,d1.w),a1
		move.l	a1,$30(a0)

AnimateRaw_Restart:
		move.b	1(a1),$22(a0)
		move.b	(a1),$24(a0)
		rts
; ---------------------------------------------------------------------------

AnimateRaw_CustomCode:
		clr.b	$24(a0)
		movea.l	$34(a0),a1
		jmp	(a1)

; =============== S U B R O U T I N E =======================================


Animate_RawAdjustFlipX:

		movea.l	$30(a0),a1
		subq.b	#1,$24(a0)
		bpl.s	locret_84496
		moveq	#0,d0
		move.b	$23(a0),d0
		addq.w	#1,d0
		move.b	d0,$23(a0)
		moveq	#0,d1
		move.b	1(a1,d0.w),d1
		bmi.s	loc_84428
		bclr	#6,d1
		beq.s	loc_8448E
		bchg	#0,4(a0)

loc_8448E:
		move.b	(a1),$24(a0)
		move.b	d1,$22(a0)

locret_84496:
		rts
; End of function Animate_RawAdjustFlipX

; ---------------------------------------------------------------------------

Animate_RawAdjustFlipY:
		movea.l	$30(a0),a1
		subq.b	#1,$24(a0)
		bpl.s	locret_844CC
		moveq	#0,d0
		move.b	$23(a0),d0
		addq.w	#1,d0
		move.b	d0,$23(a0)
		moveq	#0,d1
		move.b	1(a1,d0.w),d1
		bmi.w	loc_84428
		bclr	#6,d1
		beq.s	loc_844C4
		bchg	#1,4(a0)

loc_844C4:
		move.b	(a1),$24(a0)
		move.b	d1,$22(a0)

locret_844CC:
		rts

; =============== S U B R O U T I N E =======================================


Animate_ExternalPlayerSprite:

		subq.b	#1,$24(a1)
		bpl.s	loc_84500
		move.b	(a2),$24(a1)
		moveq	#0,d0
		move.b	$23(a1),d0
		addq.b	#2,d0
		move.b	d0,$23(a1)
		move.b	1(a2,d0.w),d1
		beq.s	loc_84504
		move.b	d1,$22(a1)
		bclr	#0,4(a1)
		tst.b	2(a2,d0.w)
		beq.s	loc_84500
		bset	#0,4(a1)

loc_84500:

		jmp	Player_Load_PLC2(pc)
; ---------------------------------------------------------------------------

loc_84504:
		jsr	Player_Load_PLC2(pc)
		movea.l	$34(a0),a1
		jmp	(a1)
; End of function Animate_ExternalPlayerSprite


; =============== S U B R O U T I N E =======================================


Animate_RawCheckResult:

		movea.l	$30(a0),a1
; End of function Animate_RawCheckResult


; =============== S U B R O U T I N E =======================================


Animate_RawNoSSTCheckResult:

		subq.b	#1,$24(a0)
		bpl.s	loc_8453E
		moveq	#0,d0
		move.b	$23(a0),d0
		addq.w	#1,d0
		move.b	d0,$23(a0)
		lea	1(a1,d0.w),a2
		moveq	#0,d1
		move.b	(a2)+,d1
		cmpi.b	#-1,d1
		beq.s	loc_84542
		move.b	(a1),$24(a0)
		move.b	d1,$22(a0)
		moveq	#1,d2
		rts
; ---------------------------------------------------------------------------

loc_8453E:
		moveq	#0,d2
		rts
; ---------------------------------------------------------------------------

loc_84542:
		move.b	(a2)+,d1
		neg.b	d1
		jsr	loc_8454E(pc,d1.w)
		clr.b	$23(a0)

loc_8454E:
		moveq	#-1,d2
		rts
; End of function Animate_RawNoSSTCheckResult

; ---------------------------------------------------------------------------
		bra.w	loc_8456A
; ---------------------------------------------------------------------------
		bra.w	loc_8455E
; ---------------------------------------------------------------------------
		bra.w	loc_84576
; ---------------------------------------------------------------------------

loc_8455E:
		move.b	(a2)+,d1
		ext.w	d1
		lea	(a1,d1.w),a1
		move.l	a1,$30(a0)

loc_8456A:
		move.b	1(a1),$22(a0)
		move.b	(a1),$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_84576:
		clr.b	$24(a0)
		movea.l	$34(a0),a1
		jmp	(a1)

; =============== S U B R O U T I N E =======================================


Set_Raw_Animation:

		move.l	a1,$30(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		rts
; End of function Set_Raw_Animation


; =============== S U B R O U T I N E =======================================


Stop_Object:

		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		rts
; End of function Stop_Object


; =============== S U B R O U T I N E =======================================


Animate_RawMultiDelay:

		movea.l	$30(a0),a1
; End of function Animate_RawMultiDelay


; =============== S U B R O U T I N E =======================================


Animate_RawNoSSTMultiDelay:

		subq.b	#1,$24(a0)
		bpl.s	loc_845C8
		moveq	#0,d0
		move.b	$23(a0),d0
		addq.w	#2,d0
		move.b	d0,$23(a0)
		moveq	#0,d1
		move.b	(a1,d0.w),d1
		bmi.s	loc_845CC
		move.b	d1,$22(a0)
		move.b	1(a1,d0.w),$24(a0)
		moveq	#1,d2
		rts
; ---------------------------------------------------------------------------

loc_845C8:
		moveq	#0,d2
		rts
; ---------------------------------------------------------------------------

loc_845CC:

		neg.b	d1
		jsr	loc_845D2+2(pc,d1.w)

loc_845D2:
		clr.b	$23(a0)
		rts
; End of function Animate_RawNoSSTMultiDelay

; ---------------------------------------------------------------------------
		bra.w	loc_845F2
; ---------------------------------------------------------------------------
		bra.w	loc_845E4
; ---------------------------------------------------------------------------
		bra.w	loc_84600
; ---------------------------------------------------------------------------

loc_845E4:
		move.b	1(a1,d0.w),d1
		ext.w	d1
		lea	(a1,d1.w),a1
		move.l	a1,$30(a0)

loc_845F2:
		move.b	(a1),$22(a0)
		move.b	1(a1),$24(a0)
		moveq	#1,d2
		rts
; ---------------------------------------------------------------------------

loc_84600:
		clr.b	$24(a0)
		movea.l	$34(a0),a1
		jsr	(a1)
		moveq	#-1,d2
		rts

; =============== S U B R O U T I N E =======================================


Animate_RawMultiDelayFlipX:

		movea.l	$30(a0),a1
; End of function Animate_RawMultiDelayFlipX


; =============== S U B R O U T I N E =======================================


Animate_RawNoSSTMultiDelayFlipX:

		subq.b	#1,$24(a0)
		bpl.s	loc_84646
		moveq	#0,d0
		move.b	$23(a0),d0
		addq.w	#2,d0
		move.b	d0,$23(a0)
		moveq	#0,d1
		move.b	(a1,d0.w),d1
		bmi.s	loc_845CC
		bclr	#6,d1
		beq.s	loc_84638
		bchg	#0,4(a0)

loc_84638:
		move.b	d1,$22(a0)
		move.b	1(a1,d0.w),$24(a0)
		moveq	#1,d2
		rts
; ---------------------------------------------------------------------------

loc_84646:
		moveq	#0,d2
		rts
; End of function Animate_RawNoSSTMultiDelayFlipX


; =============== S U B R O U T I N E =======================================


Animate_RawMultiDelayFlipY:
		movea.l	$30(a0),a1
		subq.b	#1,$24(a0)
		bpl.s	loc_84684
		moveq	#0,d0
		move.b	$23(a0),d0
		addq.w	#2,d0
		move.b	d0,$23(a0)
		moveq	#0,d1
		move.b	(a1,d0.w),d1
		bmi.w	loc_845CC
		bclr	#6,d1
		beq.s	loc_84676
		bchg	#1,4(a0)

loc_84676:
		move.b	d1,$22(a0)
		move.b	1(a1,d0.w),$24(a0)
		moveq	#1,d2
		rts
; ---------------------------------------------------------------------------

loc_84684:
		moveq	#0,d2
		rts
; End of function Animate_RawMultiDelayFlipY


; =============== S U B R O U T I N E =======================================


Animate_Raw2MultiDelay:

		movea.l	$30(a0),a1
; End of function Animate_Raw2MultiDelay


; =============== S U B R O U T I N E =======================================


Animate_Raw2NoSSTMultiDelay:

		subq.b	#1,$24(a0)
		bpl.s	loc_846BA
		moveq	#0,d0
		move.b	$23(a0),d0
		addq.w	#2,d0
		move.b	d0,$23(a0)
		lea	(a1,d0.w),a2
		moveq	#0,d1
		move.b	(a2)+,d1
		cmpi.b	#-1,d1
		beq.s	loc_846BE
		move.b	d1,$22(a0)
		move.b	1(a1,d0.w),$24(a0)
		moveq	#1,d2
		rts
; ---------------------------------------------------------------------------

loc_846BA:
		moveq	#0,d2
		rts
; ---------------------------------------------------------------------------

loc_846BE:
		move.b	(a2)+,d1
		neg.b	d1
		jsr	loc_846C6+2(pc,d1.w)

loc_846C6:
		clr.b	$23(a0)
		rts
; End of function Animate_Raw2NoSSTMultiDelay

; ---------------------------------------------------------------------------
		bra.w	loc_846E4
; ---------------------------------------------------------------------------
		bra.w	loc_846D8
; ---------------------------------------------------------------------------
		bra.w	loc_846F2
; ---------------------------------------------------------------------------

loc_846D8:
		move.b	(a2)+,d1
		ext.w	d1
		lea	(a1,d1.w),a1
		move.l	a1,$30(a0)

loc_846E4:
		move.b	(a1),$22(a0)
		move.b	1(a1),$24(a0)
		moveq	#-1,d2
		rts
; ---------------------------------------------------------------------------

loc_846F2:
		clr.b	$24(a0)
		movea.l	$34(a0),a1
		jsr	(a1)
		moveq	#-1,d2
		rts

; =============== S U B R O U T I N E =======================================


Animate_RawGetFaster:

		movea.l	$30(a0),a1
		bset	#5,$38(a0)
		bne.s	loc_84714
		move.b	(a1),$2E(a0)
		clr.b	$2F(a0)

loc_84714:
		subq.b	#1,$24(a0)
		bpl.s	loc_8474C
		move.b	$2E(a0),d2
		moveq	#0,d0
		move.b	$23(a0),d0
		addq.b	#1,d0
		move.b	2(a1,d0.w),d1
		bpl.s	loc_8473C
		moveq	#0,d0
		move.b	2(a1),d1
		tst.b	d2
		beq.s	loc_84750
		subq.b	#1,d2
		move.b	d2,$2E(a0)

loc_8473C:
		move.b	d0,$23(a0)
		move.b	d1,$22(a0)
		move.b	d2,$24(a0)
		moveq	#1,d2
		rts
; ---------------------------------------------------------------------------

loc_8474C:
		moveq	#0,d2
		rts
; ---------------------------------------------------------------------------

loc_84750:
		move.b	d0,$23(a0)
		move.b	d1,$22(a0)
		move.b	d2,$24(a0)
		move.b	$2F(a0),d0
		addq.b	#1,d0
		move.b	d0,$2F(a0)
		cmp.b	1(a1),d0
		bcs.s	loc_8477C
		bclr	#5,$38(a0)
		clr.b	$2F(a0)
		movea.l	$34(a0),a2
		jsr	(a2)

loc_8477C:
		moveq	#-1,d2
		rts
; End of function Animate_RawGetFaster

; ---------------------------------------------------------------------------

Animate_RawGetSlower:
		movea.l	$30(a0),a1
		bset	#5,$38(a0)
		bne.s	loc_84790
		clr.w	$2E(a0)

loc_84790:
		subq.b	#1,$24(a0)
		bpl.s	locret_847C4
		move.b	$2E(a0),d2
		moveq	#0,d0
		move.b	$23(a0),d0
		addq.b	#1,d0
		move.b	1(a1,d0.w),d1
		bpl.s	loc_847B0
		moveq	#0,d0
		move.b	1(a1),d1
		addq.b	#1,d2

loc_847B0:
		move.b	d0,$23(a0)
		move.b	d1,$22(a0)
		move.b	d2,$24(a0)
		cmp.b	(a1),d2
		bcc.s	loc_847C6
		move.b	d2,$2E(a0)

locret_847C4:

		rts
; ---------------------------------------------------------------------------

loc_847C6:
		move.b	$2F(a0),d0
		addq.b	#1,d0
		move.b	d0,$2F(a0)
		cmp.b	1(a1),d0
		bcs.s	locret_847C4
		bclr	#5,$38(a0)
		clr.b	$2F(a0)
		movea.l	$34(a0),a2
		jmp	(a2)

; =============== S U B R O U T I N E =======================================


Swing_UpAndDown:

		move.w	$40(a0),d0	; Acceleration
		move.w	$1A(a0),d1  ; Velocity
		move.w	$3E(a0),d2  ; Maximum acceleration before "swinging"
		moveq	#0,d3
		btst	#0,$38(a0)
		bne.s	loc_84812
		neg.w	d0			; Apply upward acceleration
		add.w	d0,d1
		neg.w	d2
		cmp.w	d2,d1
		bgt.s	loc_84824
		bset	#0,$38(a0)
		neg.w	d0
		neg.w	d2
		moveq	#1,d3

loc_84812:
		add.w	d0,d1		; Apply downward acceleration
		cmp.w	d2,d1
		blt.s	loc_84824
		bclr	#0,$38(a0)
		neg.w	d0
		add.w	d0,d1
		moveq	#1,d3

loc_84824:

		move.w	d1,$1A(a0)
		rts
; End of function Swing_UpAndDown


; =============== S U B R O U T I N E =======================================


Swing_LeftAndRight:

		move.w	$3C(a0),d0
		move.w	$18(a0),d1
		move.w	$3A(a0),d2
		moveq	#0,d3
		btst	#3,$38(a0)
		bne.s	loc_84856
		neg.w	d0
		add.w	d0,d1
		neg.w	d2
		cmp.w	d2,d1
		bgt.s	loc_84868
		bset	#3,$38(a0)
		neg.w	d0
		neg.w	d2
		moveq	#1,d3

loc_84856:
		add.w	d0,d1
		cmp.w	d2,d1
		blt.s	loc_84868
		bclr	#3,$38(a0)
		neg.w	d0
		add.w	d0,d1
		moveq	#1,d3

loc_84868:

		move.w	d1,$18(a0)
		rts
; End of function Swing_LeftAndRight


; =============== S U B R O U T I N E =======================================


Swing_UpAndDown_Count:

		bsr.w	Swing_UpAndDown
		tst.w	d3
		beq.s	locret_84888
		move.b	$39(a0),d2
		subq.b	#1,d2
		move.b	d2,$39(a0)
		bmi.s	loc_84886
		moveq	#0,d0
		rts
; ---------------------------------------------------------------------------

loc_84886:
		moveq	#1,d0

locret_84888:
		rts
; End of function Swing_UpAndDown_Count


; =============== S U B R O U T I N E =======================================


Obj_Wait:

		subq.w	#1,$2E(a0)
		bmi.s	loc_84892
		rts
; ---------------------------------------------------------------------------

loc_84892:
		movea.l	$34(a0),a1
		jmp	(a1)
; End of function Obj_Wait


; =============== S U B R O U T I N E =======================================


ObjHitFloor_DoRoutine:

		tst.w	$1A(a0)
		bmi.s	locret_848AA
		jsr	(ObjHitFloor).l
		tst.w	d1
		bmi.s	loc_848AC
		beq.s	loc_848AC

locret_848AA:
		rts
; ---------------------------------------------------------------------------

loc_848AC:

		add.w	d1,$14(a0)
		movea.l	$34(a0),a1
		jmp	(a1)
; End of function ObjHitFloor_DoRoutine


; =============== S U B R O U T I N E =======================================


ObjHitFloor2_DoRoutine:

		move.w	$18(a0),d3
		ext.l	d3
		lsl.l	#8,d3
		add.l	$10(a0),d3
		swap	d3
		jsr	(ObjHitFloor2).l
		cmpi.w	#-1,d1
		blt.s	loc_848DE
		cmpi.w	#$C,d1
		bge.s	loc_848DE
		add.w	d1,$14(a0)
		moveq	#0,d0
		rts
; ---------------------------------------------------------------------------

loc_848DE:

		movea.l	$34(a0),a1
		jsr	(a1)
		moveq	#1,d0
		rts
; End of function ObjHitFloor2_DoRoutine


; =============== S U B R O U T I N E =======================================


ObjHitWall_DoRoutine:

		jsr	(ObjHitWall).l
		tst.w	d1
		bmi.s	loc_848F4
		rts
; ---------------------------------------------------------------------------

loc_848F4:
		add.w	d1,$10(a0)
		movea.l	$34(a0),a1
		jmp	(a1)
; End of function ObjHitWall_DoRoutine

; ---------------------------------------------------------------------------

ObjHitWall2_DoRoutine:
		jsr	(ObjHitWall2).l
		tst.w	d1
		bmi.s	loc_8490A
		rts
; ---------------------------------------------------------------------------

loc_8490A:
		add.w	d1,$10(a0)
		movea.l	$34(a0),a1
		jmp	(a1)
; ---------------------------------------------------------------------------

Draw_And_Touch_Sprite:

		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Child_Draw_Sprite:

		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.w	Go_Delete_Sprite
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Child_DrawTouch_Sprite:

		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.w	Go_Delete_Sprite
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Child_CheckParent:

		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.w	Go_Delete_Sprite
		rts
; ---------------------------------------------------------------------------

Child_AddToTouchList:

		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.w	Go_Delete_Sprite
		jmp	(Add_SpriteToCollisionResponseList).l
; ---------------------------------------------------------------------------

Child_Remember_Draw_Sprite:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_84984
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_84984:
		bsr.w	Remove_From_TrackingSlot
		bra.w	Go_Delete_Sprite
; ---------------------------------------------------------------------------

Child_Draw_Sprite2:

		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		bne.s	loc_8499E
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8499E:
		bra.w	Go_Delete_Sprite_2
; ---------------------------------------------------------------------------

Child_DrawTouch_Sprite2:


		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		bne.s	loc_849C2
		btst	#7,$2A(a1)
		bne.s	loc_849BC
		jsr	(Add_SpriteToCollisionResponseList).l

loc_849BC:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_849C2:
		bra.w	Go_Delete_Sprite_2
; ---------------------------------------------------------------------------

Child_Draw_Sprite_FlickerMove:

		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_849D8
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_849D8:

		bset	#7,$2A(a0)
		move.l	#Obj_FlickerMove,(a0)
		clr.b	$28(a0)
		bsr.w	Set_IndexedVelocity
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Child_Draw_Sprite2_FlickerMove:

		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		bne.s	loc_849D8
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Child_DrawTouch_Sprite_FlickerMove:

		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_849D8
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Child_DrawTouch_Sprite2_FlickerMove:

		movea.w	$46(a0),a1
		btst	#4,$38(a1)
		bne.s	loc_849D8
		btst	#7,$2A(a1)
		beq.s	loc_84A3C
		bset	#7,$2A(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_84A3C:
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_IncLevEndXGradual:

		move.w	($FFFFEE16).w,d0
		move.l	$30(a0),d1
		addi.l	#$4000,d1
		move.l	d1,$30(a0)
		swap	d1
		add.w	d1,d0
		cmp.w	($FFFFFA92).w,d0
		bcc.s	loc_84A6A
		move.w	d0,($FFFFEE16).w
		rts
; ---------------------------------------------------------------------------

loc_84A6A:
		move.w	($FFFFFA92).w,($FFFFEE16).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_DecLevStartXGradual:

		move.w	($FFFFEE14).w,d0
		move.l	$30(a0),d1
		addi.l	#$4000,d1
		move.l	d1,$30(a0)
		swap	d1
		sub.w	d1,d0
		cmp.w	($FFFFFA94).w,d0
		ble.s	loc_84A98
		move.w	d0,($FFFFEE14).w
		rts
; ---------------------------------------------------------------------------

loc_84A98:
		move.w	($FFFFFA94).w,($FFFFEE14).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_DecLevStartYGradual:

		move.w	($FFFFEE18).w,d0
		move.l	$30(a0),d1
		addi.l	#$4000,d1
		move.l	d1,$30(a0)
		swap	d1
		sub.w	d1,d0
		cmp.w	($FFFFFA96).w,d0
		ble.s	loc_84AC6
		move.w	d0,($FFFFEE18).w
		rts
; ---------------------------------------------------------------------------

loc_84AC6:
		move.w	($FFFFFA96).w,($FFFFEE18).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_IncLevEndYGradual:

		move.w	($FFFFEE1A).w,d0
		move.l	$30(a0),d1
		addi.l	#$8000,d1
		move.l	d1,$30(a0)
		swap	d1
		add.w	d1,d0
		cmp.w	($FFFFFA98).w,d0
		bgt.s	loc_84AF4
		move.w	d0,($FFFFEE1A).w
		rts
; ---------------------------------------------------------------------------

loc_84AF4:
		move.w	($FFFFFA98).w,($FFFFEE1A).w
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
Child6_IncLevX:	dc.w 0
				dc.l Obj_IncLevEndXGradual
				dc.w 0
				dc.l Obj_DecLevStartXGradual
Child6_DecLevY:	dc.w 0
				dc.l Obj_DecLevStartYGradual
Child6_IncLevY:	dc.w 0
				dc.l Obj_IncLevEndYGradual

; =============== S U B R O U T I N E =======================================


Find_SonicTails:

		moveq	#0,d0			; d0 = 0 if Sonic/Tails is left of object, 2 if right of object
		moveq	#0,d1			; d1 = 0 if Sonic/Tails is above object, 2 if below object
		lea	($FFFFB000).w,a1
		move.w	$10(a0),d2
		sub.w	$10(a1),d2
		bpl.s	loc_84B2E
		neg.w	d2
		addq.w	#2,d0

loc_84B2E:
		lea	($FFFFB04A).w,a2
		move.w	$10(a0),d3
		sub.w	$10(a2),d3
		bpl.s	loc_84B40
		neg.w	d3
		addq.w	#2,d1

loc_84B40:
		cmp.w	d3,d2
		bls.s	loc_84B4A
		movea.l	a2,a1
		move.w	d1,d0
		move.w	d3,d2

loc_84B4A:
		moveq	#0,d1
		move.w	$14(a0),d3
		sub.w	$14(a1),d3
		bpl.s	locret_84B5A
		neg.w	d3
		addq.w	#2,d1

locret_84B5A:
		rts
; End of function Find_SonicTails


; =============== S U B R O U T I N E =======================================


Change_FlipX:

		bclr	#0,4(a0)
		tst.w	d0
		beq.s	locret_84B6C
		bset	#0,4(a0)

locret_84B6C:
		rts
; End of function Change_FlipX


; =============== S U B R O U T I N E =======================================


Change_FlipXWithVelocity:

		bclr	#0,4(a0)
		tst.w	$18(a0)
		bmi.s	locret_84B80
		bset	#0,4(a0)

locret_84B80:
		rts
; End of function Change_FlipXWithVelocity


; =============== S U B R O U T I N E =======================================


Change_FlipXUseParent:

		bclr	#0,4(a0)
		movea.w	$46(a0),a1
		btst	#0,4(a1)
		beq.s	locret_84B9A
		bset	#0,4(a0)

locret_84B9A:
		rts
; End of function Change_FlipXUseParent


; =============== S U B R O U T I N E =======================================


Find_OtherObject:

		moveq	#0,d0			; d0 = 0 if other object is left of calling object, 2 if right of it
		moveq	#0,d1			; d1 = 0 if other object is above calling object, 2 if below it
		move.w	$10(a0),d2
		sub.w	$10(a1),d2
		bpl.s	loc_84BAE
		neg.w	d2
		addq.w	#2,d0

loc_84BAE:
		moveq	#0,d1
		move.w	$14(a0),d3
		sub.w	$14(a1),d3
		bpl.s	locret_84BBE
		neg.w	d3
		addq.w	#2,d1

locret_84BBE:
		rts
; End of function Find_OtherObject


; =============== S U B R O U T I N E =======================================


MoveSprite_LightGravity:

		moveq	#$20,d1

MoveSprite_CustomGravity:

		move.w	$18(a0),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$10(a0)
		move.w	$1A(a0),d0
		add.w	d1,$1A(a0)
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$14(a0)
		rts
; End of function MoveSprite_LightGravity


; =============== S U B R O U T I N E =======================================


MoveSprite_NormGravity:
		moveq	#$38,d1
		move.w	$18(a1),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$10(a1)
		move.w	$1A(a1),d0
		add.w	d1,$1A(a1)
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$14(a1)
		rts
; End of function MoveSprite_NormGravity


; =============== S U B R O U T I N E =======================================


MoveSprite_Circular:

		move.b	$3C(a0),d0
		jsr	(GetSineCosine).l
		move.w	$3A(a0),d2
		move.w	d2,d3
		muls.w	d0,d2
		swap	d2
		muls.w	d1,d3
		swap	d3
		movea.w	$46(a0),a1
		move.w	$10(a1),d0
		add.w	d2,d0
		move.b	$42(a0),d4
		ext.w	d4
		add.w	d4,d0
		move.w	d0,$10(a0)
		move.w	$14(a1),d1
		add.w	d3,d1
		move.b	$43(a0),d4
		ext.w	d4
		add.w	d4,d1
		move.w	d1,$14(a0)
		rts
; End of function MoveSprite_Circular


; =============== S U B R O U T I N E =======================================


MoveSprite_CircularSimple:

		move.b	$3C(a0),d0
		jsr	(GetSineCosine).l
		swap	d0
		clr.w	d0
		swap	d1
		clr.w	d1
		asr.l	d2,d0
		asr.l	d2,d1
		movea.w	$46(a0),a1
		move.l	$10(a1),d2
		move.l	$14(a1),d3
		add.l	d0,d2
		add.l	d1,d3
		move.l	d2,$10(a0)
		move.l	d3,$14(a0)
		rts
; End of function MoveSprite_CircularSimple

; ---------------------------------------------------------------------------

MoveSprite_CircularSimpleCheckFlip:

		move.b	$3C(a0),d0
		jsr	(GetSineCosine).l
		swap	d0
		clr.w	d0
		swap	d1
		clr.w	d1
		asr.l	d2,d0
		asr.l	d2,d1
		movea.w	$46(a0),a1
		move.l	$10(a1),d2
		move.l	$14(a1),d3
		btst	#0,4(a1)
		beq.s	loc_84C9E
		neg.l	d0

loc_84C9E:
		add.l	d0,d2
		add.l	d1,d3
		move.l	d2,$10(a0)
		move.l	d3,$14(a0)
		rts

; =============== S U B R O U T I N E =======================================


MoveSprite_CircularSimpleOffset:

		move.b	$3C(a0),d0
		jsr	(GetSineCosine).l
		swap	d0
		clr.w	d0
		swap	d1
		clr.w	d1
		asr.l	d2,d0
		asr.l	d2,d1
		movea.w	$46(a0),a1
		move.l	$10(a1),d2
		move.l	$14(a1),d3
		move.b	$42(a0),d4
		ext.w	d4
		swap	d4
		clr.w	d4
		add.l	d4,d2
		move.b	$43(a0),d4
		ext.w	d4
		swap	d4
		clr.w	d4
		add.l	d4,d3
		add.l	d0,d2
		add.l	d1,d3
		move.l	d2,$10(a0)
		move.l	d3,$14(a0)
		rts
; End of function MoveSprite_CircularSimpleOffset


; =============== S U B R O U T I N E =======================================


MoveSprite_AtAngleLookup:

		moveq	#0,d0
		move.b	$3C(a0),d0
		move.w	d0,d1
		andi.w	#$3F,d0
		lsr.w	#5,d1
		andi.w	#6,d1
		movea.w	$46(a0),a1
		lea	$40(a2),a3
		move.w	$10(a1),d2
		move.w	$14(a1),d3
		move.w	d0,d4
		not.w	d4
		move.w	AtAngle_LookupIndex(pc,d1.w),d1
		jsr	AtAngle_LookupIndex(pc,d1.w)
		add.w	d5,d2
		add.w	d6,d3
		move.w	d2,$10(a0)
		move.w	d3,$14(a0)
		rts
; End of function MoveSprite_AtAngleLookup

; ---------------------------------------------------------------------------
AtAngle_LookupIndex:	dc.w AtAngle_00_3F-AtAngle_LookupIndex
		dc.w AtAngle_40_7F-AtAngle_LookupIndex
		dc.w AtAngle_80_BF-AtAngle_LookupIndex
		dc.w AtAngle_C0_FF-AtAngle_LookupIndex
; ---------------------------------------------------------------------------

AtAngle_00_3F:
		moveq	#0,d5
		move.b	(a2,d0.w),d5
		moveq	#0,d6
		move.b	(a3,d4.w),d6
		rts
; ---------------------------------------------------------------------------

AtAngle_40_7F:
		moveq	#0,d5
		move.b	(a3,d4.w),d5
		moveq	#0,d6
		move.b	(a2,d0.w),d6
		neg.w	d6
		rts
; ---------------------------------------------------------------------------

AtAngle_80_BF:
		moveq	#0,d5
		move.b	(a2,d0.w),d5
		neg.w	d5
		moveq	#0,d6
		move.b	(a3,d4.w),d6
		neg.w	d6
		rts
; ---------------------------------------------------------------------------

AtAngle_C0_FF:
		moveq	#0,d5
		move.b	(a3,d4.w),d5
		neg.w	d5
		moveq	#0,d6
		move.b	(a2,d0.w),d6
		rts

; =============== S U B R O U T I N E =======================================


MoveSprite_CircularLookup:

		moveq	#0,d0
		move.b	$3C(a0),d0
		move.w	d0,d1
		andi.w	#$3F,d0
		lsr.w	#5,d1
		andi.w	#6,d1
		movea.w	$46(a0),a1
		lea	$40(a2),a3
		move.w	$10(a1),d2
		move.w	$14(a1),d3
		move.b	$42(a0),d4
		ext.w	d4
		btst	#0,4(a0)
		beq.s	loc_84DAA
		neg.w	d4

loc_84DAA:
		add.w	d4,d2
		move.b	$43(a0),d4
		ext.w	d4
		add.w	d4,d3
		move.w	d0,d4
		not.w	d4
		lea	AtAngle_LookupIndex(pc),a4
		move.w	(a4,d1.w),d1
		jsr	(a4,d1.w)
		btst	#0,4(a0)
		beq.s	loc_84DCE
		neg.w	d5

loc_84DCE:
		add.w	d5,d2
		add.w	d6,d3
		move.w	d2,$10(a0)
		move.w	d3,$14(a0)
		rts
; End of function MoveSprite_CircularLookup


; =============== S U B R O U T I N E =======================================


MoveSprite_AngleYLookup:

		moveq	#0,d0
		move.b	$3C(a0),d0
		move.w	d0,d1
		andi.w	#$3F,d0
		lsr.w	#5,d1
		andi.w	#6,d1
		movea.w	$46(a0),a1
		lea	$40(a2),a3
		move.w	$14(a1),d3
		move.w	d0,d4
		not.w	d4
		move.w	AngleY_LookupIndex(pc,d1.w),d1
		jsr	AngleY_LookupIndex(pc,d1.w)
		add.w	d1,d3
		move.w	d3,$14(a0)
		rts
; End of function MoveSprite_AngleYLookup

; ---------------------------------------------------------------------------
AngleY_LookupIndex:	dc.w loc_84E16-AngleY_LookupIndex
		dc.w loc_84E1E-AngleY_LookupIndex
		dc.w loc_84E28-AngleY_LookupIndex
		dc.w loc_84E32-AngleY_LookupIndex
; ---------------------------------------------------------------------------

loc_84E16:
		moveq	#0,d1
		move.b	(a3,d4.w),d1
		rts
; ---------------------------------------------------------------------------

loc_84E1E:
		moveq	#0,d1
		move.b	(a2,d0.w),d1
		neg.w	d1
		rts
; ---------------------------------------------------------------------------

loc_84E28:
		moveq	#0,d1
		move.b	(a3,d4.w),d1
		neg.w	d1
		rts
; ---------------------------------------------------------------------------

loc_84E32:
		moveq	#0,d1
		move.b	(a2,d0.w),d1
		rts

; =============== S U B R O U T I N E =======================================


MoveSprite_AngleXLookupOffset:

		moveq	#0,d0
		move.b	$3C(a0),d0
		move.b	d0,d1
		rol.b	#3,d1
		andi.w	#6,d1
		move.w	AngleX_LookupIndex(pc,d1.w),d2
		jmp	AngleX_LookupIndex(pc,d2.w)
; End of function MoveSprite_AngleXLookupOffset

; ---------------------------------------------------------------------------
AngleX_LookupIndex:	dc.w loc_84E58-AngleX_LookupIndex
		dc.w loc_84E60-AngleX_LookupIndex
		dc.w loc_84E6C-AngleX_LookupIndex
		dc.w loc_84E7C-AngleX_LookupIndex
; ---------------------------------------------------------------------------

loc_84E58:
		move.b	(a1,d0.w),d1
		bra.w	loc_84E8C
; ---------------------------------------------------------------------------

loc_84E60:
		moveq	#$7F,d1
		sub.w	d0,d1
		move.b	(a1,d1.w),d1
		bra.w	loc_84E8C
; ---------------------------------------------------------------------------

loc_84E6C:
		move.w	d0,d1
		andi.w	#$3F,d1
		move.b	(a1,d1.w),d1
		neg.w	d1
		bra.w	loc_84E8C
; ---------------------------------------------------------------------------

loc_84E7C:
		move.w	#$FF,d1
		sub.w	d0,d1
		move.b	(a1,d1.w),d1
		neg.w	d1
		bra.w	*+4

loc_84E8C:

		movea.w	$46(a0),a1
		move.w	$10(a1),d2
		move.b	$42(a0),d3
		ext.w	d3
		add.w	d3,d2
		btst	#0,4(a1)
		beq.s	loc_84EA6
		neg.w	d1

loc_84EA6:
		add.w	d1,d2
		move.w	d2,$10(a0)
		move.w	$14(a1),d2
		move.b	$43(a0),d3
		ext.w	d3
		add.w	d3,d2
		move.w	d2,$14(a0)
		rts
; ---------------------------------------------------------------------------
		moveq	#0,d0			; Same as above but unused
		move.b	$3C(a0),d0
		move.b	d0,d1
		rol.b	#3,d1
		andi.w	#6,d1
		move.w	off_84ED4(pc,d1.w),d2
		jmp	off_84ED4(pc,d2.w)
; ---------------------------------------------------------------------------
off_84ED4:	dc.w loc_84EDC-off_84ED4

		dc.w loc_84EE4-off_84ED4
		dc.w loc_84EF0-off_84ED4
		dc.w loc_84F00-off_84ED4
; ---------------------------------------------------------------------------

loc_84EDC:
		move.b	(a1,d0.w),d1
		bra.w	loc_84F10
; ---------------------------------------------------------------------------

loc_84EE4:
		moveq	#$7F,d1
		sub.w	d0,d1
		move.w	(a1,d1.w),d1
		bra.w	loc_84F10
; ---------------------------------------------------------------------------

loc_84EF0:
		move.w	d0,d1
		andi.w	#$3F,d1
		move.w	(a1,d1.w),d1
		neg.w	d1
		bra.w	loc_84F10
; ---------------------------------------------------------------------------

loc_84F00:
		move.w	#$FF,d1
		sub.w	d0,d1
		move.w	(a1,d1.w),d1
		neg.w	d1
		bra.w	*+4

loc_84F10:

		movea.w	$46(a0),a1
		move.w	$10(a1),d2
		move.b	$42(a0),d3
		ext.w	d3
		add.w	d3,d2
		move.w	d2,$10(a0)
		move.w	$14(a1),d2
		move.b	$43(a0),d3
		ext.w	d3
		add.w	d3,d2
		add.w	d1,d2
		move.w	d2,$14(a0)
		rts
; ---------------------------------------------------------------------------
		subq.w	#1,$2E(a0)			; Timed object, not actually used
		bmi.w	Go_Delete_Sprite
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
		subq.w	#1,$2E(a0)			; Timed object with gravity-influenced movement
		bmi.w	Go_Delete_Sprite
		jsr	(MoveSprite).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

MoveDraw_SpriteTimed:
		subq.w	#1,$2E(a0)
		bmi.w	Go_Delete_Sprite
		jsr	(MoveSprite2).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

MoveDraw_SpriteTimed2:
		subq.w	#1,$2E(a0)
		bmi.w	Go_Delete_Sprite
		jsr	(MoveSprite_LightGravity).l
		bra.w	Draw_And_Touch_Sprite

; =============== S U B R O U T I N E =======================================


TimedSprite_ScreenLock:
		subq.w	#1,$2E(a0)
		bmi.s	loc_84F88
		rts
; ---------------------------------------------------------------------------

loc_84F88:
		move.b	#1,($FFFFF7AA).w
		bra.w	Go_Delete_Sprite_2
; End of function TimedSprite_ScreenLock


; =============== S U B R O U T I N E =======================================


BossFlash:
		lea	($FFFFFC22).w,a1
		moveq	#0,d0
		tst.w	(a1)
		bne.s	loc_84FA0
		move.w	#$EEE,d0

loc_84FA0:
		move.w	d0,(a1)
		rts
; End of function BossFlash


; =============== S U B R O U T I N E =======================================


SetUp_ObjAttributesSlotted:

		moveq	#0,d0
		move.w	(a1)+,d1		; Maximum number of objects that can be made in this array
		move.w	d1,d2
		move.w	(a1)+,d3		; Base VRAM offset of object
		move.w	(a1)+,d4		; Amount to add to base VRAM offset for each slot
		moveq	#0,d5
		move.w	(a1)+,d5		; Index of slot array to use
		lea	($FFFFFA9A).w,a2
		adda.w	d5,a2			; Get the address of the array to use
		move.b	(a2),d5
		beq.s	loc_84FE4		; If array is clear, just make the object

loc_84FBC:
		lsr.b	#1,d5			; Check slot (each bit)
		bcc.s	loc_84FE4		; If clear, make object
		addq.w	#1,d0			; Increment bit number
		add.w	d4,d3			; Add VRAM offset
		dbf	d1,loc_84FBC		; Repeat max times
		moveq	#0,d0
		move.l	d0,(a0)
		move.l	d0,$10(a0)
		move.l	d0,$14(a0)
		move.b	d0,$2C(a0)
		move.b	d0,4(a0)
		move.w	d0,$2A(a0)		; If no open slots, then destroy this object period
		addq.w	#8,sp
		rts
; ---------------------------------------------------------------------------

loc_84FE4:
		bset	d0,(a2)			; Turn this slot on
		move.b	d0,$3B(a0)
		move.w	a2,$3C(a0)		; Keep track of slot address and bit number
		move.w	d3,$A(a0)		; Use correct VRAM offset
		move.l	(a1)+,$C(a0)	; Mapping address
		move.w	(a1)+,8(a0)		; Priority
		move.b	(a1)+,7(a0)		; Width
		move.b	(a1)+,6(a0)		; Height
		move.b	(a1)+,$22(a0)	; Frame number
		move.b	(a1)+,$28(a0)	; Collision number
		bset	#2,$2A(a0)		; Turn object slotting on
		move.b	#-1,$3A(a0)		; CHECKLATER
		bset	#2,4(a0)		; Use screen coordinates
		addq.b	#2,5(a0)		; Next routine
		rts
; End of function SetUp_ObjAttributesSlotted


; =============== S U B R O U T I N E =======================================


Perform_DPLC:

		moveq	#0,d0
		move.b	$22(a0),d0		; Get the frame number
		cmp.b	$3A(a0),d0		; If frame number remains the same as before, don't do anything
		beq.s	locret_8506E
		move.b	d0,$3A(a0)
		movea.l	(a2)+,a3		; Source address of art
		move.w	$A(a0),d4
		andi.w	#$7FF,d4		; Isolate tile location offset
		lsl.w	#5,d4			; Convert to VRAM address
		movea.l	(a2)+,a2		; Address of DPLC script
		add.w	d0,d0
		adda.w	(a2,d0.w),a2	; Apply offset to script
		move.w	(a2)+,d5		; Get number of DMA transactions
		moveq	#0,d3

loc_8504A:
		move.w	(a2)+,d3		; Art source offset
		move.l	d3,d1
		andi.w	#-$10,d1		; Isolate all but lower 4 bits
		add.w	d1,d1
		add.l	a3,d1			; Get final source address of art
		move.w	d4,d2			; Destination VRAM address
		andi.w	#$F,d3
		addq.w	#1,d3
		lsl.w	#4,d3			; d3 is the total number of words to transfer (maximum 16 tiles per transaction)
		add.w	d3,d4
		add.w	d3,d4
		jsr	(Add_To_DMA_Queue).l	; Add to queue
		dbf	d5,loc_8504A		; Keep going

locret_8506E:
		rts
; End of function Perform_DPLC

; ---------------------------------------------------------------------------

Sprite_CheckDelete:

		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_85088
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_85088:

		move.w	$48(a0),d0
		beq.s	loc_85094
		movea.w	d0,a2
		bclr	#7,(a2)

loc_85094:
		bset	#7,$2A(a0)
		move.l	#Delete_Current_Sprite,(a0)
		rts
; ---------------------------------------------------------------------------

Sprite_CheckDelete2:
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_850BA
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_850BA:


		move.w	$48(a0),d0
		beq.s	loc_850C6
		movea.w	d0,a2
		bclr	#7,(a2)

loc_850C6:
		bset	#4,$38(a0)
		move.l	#Delete_Current_Sprite,(a0)
		rts
; ---------------------------------------------------------------------------

Sprite_CheckDeleteXY:

		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	Go_Delete_Sprite
		move.w	$14(a0),d0
		sub.w	($FFFFEE7C).w,d0
		addi.w	#$80,d0
		cmpi.w	#$200,d0
		bhi.w	Go_Delete_Sprite
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_FlickerMove:

		jsr	(MoveSprite).l
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	Go_Delete_Sprite_3
		move.w	$14(a0),d0
		sub.w	($FFFFEE7C).w,d0
		addi.w	#$80,d0
		cmpi.w	#$200,d0
		bhi.w	Go_Delete_Sprite_3
		bchg	#6,$38(a0)
		beq.w	locret_8405E
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Sprite_CheckDeleteTouch:

		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_85088
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Sprite_CheckDeleteTouch2:

		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_850BA
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Sprite_CheckDeleteTouchXY:

		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	Go_Delete_Sprite
		move.w	$14(a0),d0
		sub.w	($FFFFEE7C).w,d0
		addi.w	#$80,d0
		cmpi.w	#$200,d0
		bhi.w	Go_Delete_Sprite
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Sprite_CheckDeleteSlotted:
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.s	Go_Delete_SpriteSlotted
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Go_Delete_SpriteSlotted:

		move.w	$48(a0),d0
		beq.s	Go_Delete_SpriteSlotted2
		movea.w	d0,a2
		bclr	#7,(a2)

Go_Delete_SpriteSlotted2:

		move.l	#Delete_Current_Sprite,(a0)
		bset	#7,$2A(a0)

; =============== S U B R O U T I N E =======================================


Remove_From_TrackingSlot:

		move.b	$3B(a0),d0
		movea.w	$3C(a0),a1
		bclr	d0,(a1)
		rts
; End of function Remove_From_TrackingSlot

; ---------------------------------------------------------------------------
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.s	Go_Delete_SpriteSlotted
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Sprite_CheckDeleteTouchSlotted:
		tst.b	$2A(a0)
		bmi.s	Go_Delete_SpriteSlotted3
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.s	Go_Delete_SpriteSlotted
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Go_Delete_SpriteSlotted3:


		move.l	#Delete_Current_Sprite,(a0)
		bra.s	Remove_From_TrackingSlot
; ---------------------------------------------------------------------------
		tst.b	$2A(a0)					; Unused, seems to be identical to the above
		bmi.s	Go_Delete_SpriteSlotted3
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	Go_Delete_SpriteSlotted
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
		move.w	$10(a0),d0				; Next three are unused, virtually the same
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_85088
		rts
; ---------------------------------------------------------------------------
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_85088
		rts
; ---------------------------------------------------------------------------
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.w	loc_85088
		jmp	(Add_SpriteToCollisionResponseList).l

; =============== S U B R O U T I N E =======================================


Go_Delete_Sprite:

		move.l	#Delete_Current_Sprite,(a0)
		bset	#7,$2A(a0)
		rts
; End of function Go_Delete_Sprite


; =============== S U B R O U T I N E =======================================


Go_Delete_Sprite_2:

		move.l	#Delete_Current_Sprite,(a0)
		bset	#4,$38(a0)
		rts
; End of function Go_Delete_Sprite_2

; ---------------------------------------------------------------------------

Go_Delete_Sprite_3:

		move.l	#Delete_Current_Sprite,(a0)
		bset	#7,$2A(a0)
		bset	#4,$38(a0)
		rts

; =============== S U B R O U T I N E =======================================


Set_IndexedVelocity:

		moveq	#0,d1
		move.b	$2C(a0),d1
		add.w	d1,d1
		add.w	d1,d0
		lea	Obj_VelocityIndex(pc,d0.w),a1
		move.w	(a1)+,$18(a0)
		move.w	(a1)+,$1A(a0)
		btst	#0,4(a0)
		beq.s	locret_852F2
		neg.w	$18(a0)

locret_852F2:
		rts
; End of function Set_IndexedVelocity

; ---------------------------------------------------------------------------
Obj_VelocityIndex:	dc.w  $FF00, $FF00
		dc.w   $100, $FF00
		dc.w  $FE00, $FE00
		dc.w   $200, $FE00
		dc.w  $FD00, $FE00
		dc.w   $300, $FE00
		dc.w  $FE00, $FE00
		dc.w	  0, $FE00
		dc.w  $FC00, $FD00
		dc.w   $400, $FD00
		dc.w   $300, $FD00
		dc.w  $FC00, $FD00
		dc.w   $400, $FD00
		dc.w  $FE00, $FE00
		dc.w   $200, $FE00
		dc.w	  0, $FF00
		dc.w  $FFC0, $F900
		dc.w  $FF80, $F900
		dc.w  $FE80, $F900
		dc.w  $FF00, $F900
		dc.w  $FE00, $F900
		dc.w  $FD80, $F900
		dc.w  $FD00, $F900
		dc.w	  0, $FF00
		dc.w  $FF00, $FF00
		dc.w   $100, $FF00
		dc.w  $FE00, $FF00
		dc.w   $200, $FF00
		dc.w  $FE00, $FE00
		dc.w   $200, $FE00
		dc.w  $FD00, $FE00
		dc.w   $300, $FE00
		dc.w  $FD00, $FD00
		dc.w   $300, $FD00
		dc.w  $FC00, $FD00
		dc.w   $400, $FD00
		dc.w  $FE00, $FD00
		dc.w   $200, $FD00

; =============== S U B R O U T I N E =======================================


Find_SonicTails8Way:
		bsr.w	Find_SonicTails		; This routine seems bugged slightly. Shouldn't the first two cmpi instructions look at d3 and not d2?
		cmp.w	d2,d3
		beq.s	loc_853E2
		bhi.s	loc_853BC
		swap	d3			; If Y distance is closer to object
		clr.w	d3
		divu.w	d2,d3
		tst.w	d0
		beq.s	loc_853AE
		cmpi.w	#-$8000,d2	; If Y was closer and Sonic is to right of object
		bcs.s	loc_853FE
		tst.w	d0
		beq.s	loc_853FA
		bra.w	loc_85402
; ---------------------------------------------------------------------------

loc_853AE:
		cmpi.w	#-$8000,d2	; If Y was closer and Sonic is to left of object
		bcs.s	loc_8540E
		tst.w	d1
		bne.s	loc_8540A
		bra.w	loc_85412
; ---------------------------------------------------------------------------

loc_853BC:
		swap	d2			; If X distance is closer to object
		clr.w	d2
		divu.w	d3,d2
		tst.w	d1
		bne.s	loc_853D4
		cmpi.w	#-$8000,d2
		bcs.s	loc_853F6
		tst.w	d0
		bne.s	loc_853FA
		bra.w	loc_85412
; ---------------------------------------------------------------------------

loc_853D4:
		cmpi.w	#-$8000,d2
		bcs.s	loc_85406
		tst.w	d0
		bne.s	loc_85402
		bra.w	loc_8540A
; ---------------------------------------------------------------------------

loc_853E2:
		tst.w	d0				; If X and Y distance are identical
		beq.s	loc_853EE
		tst.w	d1
		beq.s	loc_853FA
		bra.w	loc_85402
; ---------------------------------------------------------------------------

loc_853EE:
		tst.w	d1
		bne.s	loc_8540A
		bra.w	loc_85412
; ---------------------------------------------------------------------------

loc_853F6:
		moveq	#0,d4
		rts
; ---------------------------------------------------------------------------

loc_853FA:

		moveq	#1,d4
		rts
; ---------------------------------------------------------------------------

loc_853FE:
		moveq	#2,d4
		rts
; ---------------------------------------------------------------------------

loc_85402:

		moveq	#3,d4
		rts
; ---------------------------------------------------------------------------

loc_85406:
		moveq	#4,d4
		rts
; ---------------------------------------------------------------------------

loc_8540A:

		moveq	#5,d4
		rts
; ---------------------------------------------------------------------------

loc_8540E:
		moveq	#6,d4
		rts
; ---------------------------------------------------------------------------

loc_85412:

		moveq	#7,d4
		rts
; End of function Find_SonicTails8Way


; =============== S U B R O U T I N E =======================================


Set_VelocityXTrackSonic:

		lea	($FFFFB000).w,a1
		bsr.w	Find_OtherObject
		bclr	#0,4(a0)
		tst.w	d0
		beq.s	loc_85430
		neg.w	d4
		bset	#0,4(a0)

loc_85430:
		move.w	d4,$18(a0)
		rts
; End of function Set_VelocityXTrackSonic


; =============== S U B R O U T I N E =======================================


Chase_Object:

		move.w	d0,d2			; d0 = Maximum speed
		neg.w	d2
		move.w	d1,d3			; d1 = acceleration
		move.w	$10(a0),d4
		cmp.w	$10(a1),d4
		seq	d5
		beq.s	loc_8545E
		bcs.s	loc_8544C
		neg.w	d1

loc_8544C:
		move.w	$18(a0),d4
		add.w	d1,d4
		cmp.w	d2,d4
		blt.s	loc_8545E
		cmp.w	d0,d4
		bgt.s	loc_8545E
		move.w	d4,$18(a0)

loc_8545E:

		move.w	$14(a0),d4
		cmp.w	$14(a1),d4
		beq.s	loc_85480
		bcs.s	loc_8546C
		neg.w	d3

loc_8546C:
		move.w	$1A(a0),d4
		add.w	d3,d4
		cmp.w	d2,d4
		blt.s	locret_8547E
		cmp.w	d0,d4
		bgt.s	locret_8547E
		move.w	d4,$1A(a0)

locret_8547E:

		rts
; ---------------------------------------------------------------------------

loc_85480:
		tst.b	d5
		beq.s	locret_8547E
		clr.w	$18(a0)
		clr.w	$1A(a0)
		rts
; End of function Chase_Object


; =============== S U B R O U T I N E =======================================


Chase_ObjectXOnly:

		move.w	d0,d2
		neg.w	d2
		move.w	$10(a1),d3
		move.b	$42(a0),d4
		ext.w	d4
		add.w	d4,d3
		cmp.w	$10(a0),d3
		bcc.s	loc_854A6
		neg.w	d1

loc_854A6:
		move.w	$18(a0),d3
		add.w	d1,d3
		cmp.w	d2,d3
		blt.s	locret_854B8
		cmp.w	d0,d3
		bgt.s	locret_854B8
		move.w	d3,$18(a0)

locret_854B8:

		rts
; End of function Chase_ObjectXOnly


; =============== S U B R O U T I N E =======================================


Chase_ObjectYOnly:

		move.w	d0,d2
		neg.w	d2
		move.w	$14(a1),d3
		move.b	$43(a0),d4
		ext.w	d4
		add.w	d4,d3
		cmp.w	$14(a0),d3
		bcc.s	loc_854D2
		neg.w	d1

loc_854D2:
		move.w	$1A(a0),d3
		add.w	d1,d3
		cmp.w	d2,d3
		blt.s	locret_854E4
		cmp.w	d0,d3
		bgt.s	locret_854E4
		move.w	d3,$1A(a0)

locret_854E4:

		rts
; End of function Chase_ObjectYOnly

; ---------------------------------------------------------------------------
		move.w	d0,d2			; Unused, seems to be a combination of the above two routines, but additionally using offsets
		neg.w	d2
		move.w	d1,d3
		move.w	$10(a1),d6
		move.b	$42(a0),d4
		ext.w	d4
		add.w	d4,d6
		cmp.w	$10(a0),d6
		seq	d5
		beq.s	loc_85516
		bcc.s	loc_85504
		neg.w	d1

loc_85504:
		move.w	$18(a0),d4
		add.w	d1,d4
		cmp.w	d2,d4
		blt.s	loc_85516
		cmp.w	d0,d4
		bgt.s	loc_85516
		move.w	d4,$18(a0)

loc_85516:

		move.w	$14(a1),d6
		move.b	$43(a0),d4
		ext.w	d4
		add.w	d4,d6
		cmp.w	$14(a0),d6
		beq.s	loc_85540
		bcc.s	loc_8552C
		neg.w	d3

loc_8552C:
		move.w	$1A(a0),d4
		add.w	d3,d4
		cmp.w	d2,d4
		blt.s	locret_8553E
		cmp.w	d0,d4
		bgt.s	locret_8553E
		move.w	d4,$1A(a0)

locret_8553E:

		rts
; ---------------------------------------------------------------------------

loc_85540:
		tst.b	d5
		beq.s	locret_8553E
		clr.w	$18(a0)
		clr.w	$1A(a0)
		rts
; ---------------------------------------------------------------------------

Obj_FadeSelectedToBlack:
		move.l	#loc_8555E,(a0)
		move.b	#7,$39(a0)
		st	($FFFFFABF).w

loc_8555E:
		subq.w	#1,$2E(a0)
		bpl.s	locret_8558E
		move.w	$3A(a0),$2E(a0)
		movea.w	$30(a0),a1
		move.w	$3C(a0),d0
		moveq	#$E,d1
		moveq	#-$20,d2

loc_85576:
		bsr.w	DecColor_Obj
		dbf	d0,loc_85576
		subq.b	#1,$39(a0)
		bpl.s	locret_8558E
		clr.b	($FFFFFABF).w
		jsr	(Go_Delete_Sprite).l

locret_8558E:

		rts

; =============== S U B R O U T I N E =======================================


DecColor_Obj:

		move.b	(a1),d3
		and.b	d1,d3
		beq.s	loc_85598
		subq.b	#2,d3

loc_85598:
		move.b	d3,(a1)+
		move.b	(a1),d3
		move.b	d3,d4
		and.b	d2,d3
		beq.s	loc_855A6
		subi.b	#$20,d3

loc_855A6:
		and.b	d1,d4
		beq.s	loc_855AC
		subq.b	#2,d4

loc_855AC:
		or.b	d3,d4
		move.b	d4,(a1)+
		rts
; End of function DecColor_Obj

; ---------------------------------------------------------------------------

Obj_FadeSelectedFromBlack:

		move.l	#loc_855C2,(a0)
		move.b	#7,$39(a0)
		st	($FFFFFABF).w

loc_855C2:
		subq.w	#1,$2E(a0)
		bpl.s	locret_855F6
		move.w	$3A(a0),$2E(a0)
		movea.w	$30(a0),a1
		movea.w	$32(a0),a2
		move.w	$3C(a0),d0
		moveq	#$E,d1
		moveq	#-$20,d2

loc_855DE:
		bsr.w	IncColor_Obj
		dbf	d0,loc_855DE
		subq.b	#1,$39(a0)
		bpl.s	locret_855F6
		clr.b	($FFFFFABF).w
		jsr	(Go_Delete_Sprite).l

locret_855F6:

		rts

; =============== S U B R O U T I N E =======================================


IncColor_Obj:
		move.b	(a1),d3
		and.b	d1,d3
		move.b	(a2)+,d4
		and.b	d1,d4
		cmp.b	d4,d3
		bcc.s	loc_85606
		addq.b	#2,d3

loc_85606:
		move.b	d3,(a1)+
		move.b	(a1),d3
		move.b	d3,d4
		and.b	d2,d3
		move.b	(a2)+,d5
		move.b	d5,d6
		and.b	d2,d5
		cmp.b	d5,d3
		bcc.s	loc_8561C
		addi.b	#$20,d3

loc_8561C:
		and.b	d1,d4
		and.b	d1,d6
		cmp.b	d6,d4
		bcc.s	loc_85626
		addq.b	#2,d4

loc_85626:
		or.b	d3,d4
		move.b	d4,(a1)+
		rts
; End of function IncColor_Obj

; ---------------------------------------------------------------------------

MoveFall_AnimateRaw:

		jsr	(MoveSprite).l
		jmp	Animate_Raw(pc)
; ---------------------------------------------------------------------------

Move_AnimateRaw:

		jsr	(MoveSprite2).l
		jmp	Animate_Raw(pc)
; ---------------------------------------------------------------------------

MoveSlowFall_AnimateRaw:
		jsr	MoveSprite_LightGravity(pc)
		jmp	Animate_Raw(pc)
; ---------------------------------------------------------------------------
		jsr	Swing_UpAndDown(pc)

; =============== S U B R O U T I N E =======================================


Move_AnimateRaw_Wait:
		jsr	(MoveSprite2).l

loc_85652:
		jsr	Animate_Raw(pc)
		jmp	Obj_Wait(pc)
; End of function Move_AnimateRaw_Wait

; ---------------------------------------------------------------------------

Refresh_ChildPosWait:
		jsr	Refresh_ChildPosition(pc)

Wait_Draw:

		jsr	Obj_Wait(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Wait_FadeToLevelMusic:

		subq.w	#1,$2E(a0)
		bmi.s	loc_85674
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_85674:
		bclr	#7,4(a0)
		move.w	#$77,$2E(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_8568E
		move.l	#Obj_Song_Fade_ToLevelMusic,(a1)

loc_8568E:
		movea.l	$34(a0),a1
		jmp	(a1)
; ---------------------------------------------------------------------------

Wait_NewDelay:

		subq.w	#1,$2E(a0)
		bmi.s	loc_856A0
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_856A0:
		bclr	#7,4(a0)
		move.w	#$77,$2E(a0)
		movea.l	$34(a0),a1
		jmp	(a1)
; ---------------------------------------------------------------------------

MoveWaitTouch:

		jsr	(MoveSprite2).l
		jsr	Obj_Wait(pc)
		jmp	Draw_And_Touch_Sprite(pc)
; ---------------------------------------------------------------------------
		jsr	Refresh_ChildPosition(pc)

AnimateRaw_DrawTouch:

		jsr	Animate_RawMultiDelay(pc)
		jmp	Draw_And_Touch_Sprite(pc)
; ---------------------------------------------------------------------------

AnimateRaw_MoveChkDel:

		jsr	Animate_Raw(pc)

MoveChkDel:

		jsr	(MoveSprite).l
		jmp	Sprite_CheckDeleteXY(pc)
; ---------------------------------------------------------------------------
		jsr	Animate_Raw(pc)

MoveTouchChkDel:
		jsr	(MoveSprite).l
		jmp	Sprite_CheckDeleteTouchXY(pc)
; ---------------------------------------------------------------------------

Move_WaitNoFall:

		jsr	(MoveSprite2).l
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

Swing_MoveWaitNoFall:
		jsr	Swing_UpAndDown(pc)
		jsr	(MoveSprite2).l
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------
		jsr	Animate_Raw(pc)
		jmp	Draw_And_Touch_Sprite(pc)
; ---------------------------------------------------------------------------
		jsr	Animate_Raw(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
		jsr	(MoveSprite2).l
		jsr	Animate_Raw(pc)
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
		jsr	Animate_Raw(pc)
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------
		jmp	Draw_And_Touch_Sprite(pc)

; =============== S U B R O U T I N E =======================================


EnemyDefeated:


		bsr.w	EnemyDefeat_Score
		movea.w	$44(a0),a1
		tst.w	$1A(a1)
		bmi.s	loc_85750
		move.w	$14(a1),d0
		cmp.w	$14(a0),d0
		bcc.s	loc_85758
		neg.w	$1A(a1)
		rts
; ---------------------------------------------------------------------------

loc_85750:
		addi.w	#$100,$1A(a1)
		rts
; ---------------------------------------------------------------------------

loc_85758:
		subi.w	#$100,$1A(a1)
		rts
; End of function EnemyDefeated


; =============== S U B R O U T I N E =======================================


EnemyDefeat_Score:
		bset	#7,$2A(a0)
		clr.b	$28(a0)
		moveq	#0,d0
		move.w	($FFFFF7D0).w,d0
		addq.w	#2,($FFFFF7D0).w
		cmpi.w	#6,d0
		bcs.s	loc_8577C
		moveq	#6,d0

loc_8577C:
		move.w	d0,$3E(a0)
		move.w	word_857AC(pc,d0.w),d0
		cmpi.w	#$20,($FFFFF7D0).w
		bcs.s	loc_85796
		move.w	#$3E8,d0		; 10000 points
		move.w	#$A,$3E(a0)

loc_85796:
		movea.w	a1,a3
		jsr	(HUD_AddToScore).l
		move.l	#Obj_Explosion,(a0)
		move.b	#0,5(a0)
		rts
; End of function EnemyDefeat_Score

; ---------------------------------------------------------------------------
word_857AC:	dc.w $A		;100 points
		dc.w $14		;200 points
		dc.w $32		;500 points
		dc.w $64		;1000 points

; =============== S U B R O U T I N E =======================================


HurtSonic_Directly:

		movea.l	a0,a2
		movea.l	a1,a0
		jsr	(HurtSonic2).l
		movea.l	a2,a0
		rts
; End of function HurtSonic_Directly


; =============== S U B R O U T I N E =======================================


Check_PlayerAttack:

		btst	#1,$2B(a1)
		bne.s	loc_85822
		cmpi.b	#9,$20(a1)
		beq.s	loc_85822
		cmpi.b	#2,$20(a1)
		beq.s	loc_85822
		moveq	#0,d0
		move.b	$38(a1),d0
		add.w	d0,d0
		move.w	off_857EA(pc,d0.w),d0
		jmp	off_857EA(pc,d0.w)
; ---------------------------------------------------------------------------
off_857EA:	dc.w Check_SonicAttack-off_857EA
		dc.w Check_TailsAttack-off_857EA
		dc.w Check_KnuxAttack-off_857EA
; ---------------------------------------------------------------------------

Check_SonicAttack:

		moveq	#0,d0
		rts
; ---------------------------------------------------------------------------

Check_TailsAttack:
		tst.b	$2F(a1)
		beq.s	Check_SonicAttack		; If Tails is not flying, branch
		btst	#6,$2A(a1)
		bne.s	Check_SonicAttack		; If Tails is underwater, branch
		move.w	$10(a1),d1
		move.w	$14(a1),d2
		sub.w	$10(a0),d1
		sub.w	$14(a0),d2
		jsr	(GetArcTan).l		; Get angle between Tails and object
		subi.b	#$20,d0
		cmpi.b	#$40,d0
		bcc.s	Check_SonicAttack		; If Tails is between 20-60 degrees off object (directly below), then he is attacking

loc_85822:
		moveq	#1,d0
		rts
; End of function Check_PlayerAttack

; ---------------------------------------------------------------------------

Check_KnuxAttack:
		cmpi.b	#1,$2F(a1)
		beq.s	loc_85822
		cmpi.b	#3,$2F(a1)
		beq.s	loc_85822				; If Knux is gliding or sliding, then he's attacking
		bra.s	Check_SonicAttack

; =============== S U B R O U T I N E =======================================


Check_LRControllerShake:

		subq.b	#1,$3D(a0)
		bpl.s	loc_8584A
		move.b	#5,$3C(a0)
		move.b	#$3C,$3D(a0)

loc_8584A:
		movea.w	$3E(a0),a2
		move.w	(a2),d0
		andi.w	#$C,d0
		beq.s	locret_8586E
		move.w	$3A(a0),d1
		move.w	d0,$3A(a0)
		andi.w	#$C,d1
		eor.w	d1,d0
		beq.s	locret_8586E
		subq.b	#1,$3C(a0)
		bmi.s	locret_8586E
		moveq	#0,d0

locret_8586E:

		rts
; End of function Check_LRControllerShake


; =============== S U B R O U T I N E =======================================


Check_PlayerCollision:

		move.b	$29(a0),d0
		beq.s	locret_8588E
		clr.b	$29(a0)
		andi.w	#3,d0
		add.w	d0,d0
		lea	word_85890(pc),a1
		movea.w	(a1,d0.w),a1
		move.w	a1,$44(a0)
		moveq	#1,d1

locret_8588E:
		rts
; End of function Check_PlayerCollision

; ---------------------------------------------------------------------------
word_85890:	dc.w $B000
		dc.w $B000
		dc.w $B04A
		dc.w $B04A

; =============== S U B R O U T I N E =======================================


Check_InTheirRange:

		move.w	$10(a0),d0
		move.w	$10(a1),d1
		add.w	(a2)+,d1
		cmp.w	d1,d0
		blt.s	loc_858C4
		add.w	(a2)+,d1
		cmp.w	d1,d0
		bge.s	loc_858C4
		move.w	$14(a0),d0
		move.w	$14(a1),d1
		add.w	(a2)+,d1
		cmp.w	d1,d0
		blt.s	loc_858C4
		add.w	(a2)+,d1
		cmp.w	d1,d0
		bge.s	loc_858C4
		moveq	#1,d0
		rts
; ---------------------------------------------------------------------------

loc_858C4:

		moveq	#0,d0
		rts
; End of function Check_InTheirRange


; =============== S U B R O U T I N E =======================================


Check_InMyRange:

		move.w	$10(a0),d0
		move.w	$10(a1),d1
		add.w	(a2)+,d0
		cmp.w	d0,d1
		blt.s	loc_858F4
		add.w	(a2)+,d0
		cmp.w	d0,d1
		bge.s	loc_858F4
		move.w	$14(a0),d0
		move.w	$14(a1),d1
		add.w	(a2)+,d0
		cmp.w	d0,d1
		blt.s	loc_858F4
		add.w	(a2)+,d0
		cmp.w	d0,d1
		bge.s	loc_858F4
		moveq	#1,d0
		rts
; ---------------------------------------------------------------------------

loc_858F4:

		moveq	#0,d0
		rts
; End of function Check_InMyRange


; =============== S U B R O U T I N E =======================================


Check_PlayerInRange:

		moveq	#0,d0
		lea	($FFFFB04A).w,a2
		move.w	$10(a2),d1
		move.w	$14(a2),d2
		move.w	$10(a0),d3
		move.w	$14(a0),d4
		add.w	(a1)+,d3
		move.w	d3,d5
		add.w	(a1)+,d5
		add.w	(a1)+,d4
		move.w	d4,d6
		add.w	(a1)+,d6
		bsr.w	sub_8592C
		swap	d0
		lea	($FFFFB000).w,a2
		move.w	$10(a2),d1
		move.w	$14(a2),d2
; End of function Check_PlayerInRange


; =============== S U B R O U T I N E =======================================


sub_8592C:
		cmp.w	d3,d1
		bcs.s	locret_8593E
		cmp.w	d5,d1
		bcc.s	locret_8593E
		cmp.w	d4,d2
		bcs.s	locret_8593E
		cmp.w	d6,d2
		bcc.s	locret_8593E
		move.w	a2,d0

locret_8593E:
		rts
; End of function sub_8592C


; =============== S U B R O U T I N E =======================================


PalLoad_Line1:

		lea	($FFFFFC20).w,a2
		moveq	#7,d0

loc_85946:
		move.l	(a1)+,(a2)+
		dbf	d0,loc_85946
		rts
; End of function PalLoad_Line1


; =============== S U B R O U T I N E =======================================


Displace_PlayerOffObject:

		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	locret_85988
		bclr	#3,$2A(a0)
		beq.s	loc_85970
		lea	($FFFFB000).w,a1
		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)

loc_85970:
		bclr	#4,$2A(a0)
		beq.s	locret_85988
		lea	($FFFFB04A).w,a1
		bclr	#3,$2A(a1)
		bset	#1,$2A(a1)

locret_85988:

		rts
; End of function Displace_PlayerOffObject


; =============== S U B R O U T I N E =======================================


Run_PalRotationScript:

		tst.b	($FFFFFABF).w
		bne.s	locret_85A00
		lea	($FFFFFADE).w,a1

loc_85994:
		move.w	(a1),d0			; Palette displacement
		beq.s	locret_85A00
		subq.b	#1,2(a1)		; Rotation delay
		bpl.s	loc_859CA
		movea.l	4(a1),a2		; Address of palette copy array in a2
		movea.w	(a2),a3			; Palette destination in a3
		movea.l	a2,a4
		adda.w	d0,a4
		move.w	(a4),d1
		bpl.s	loc_859B0
		bsr.w	sub_859CE

loc_859B0:
		moveq	#0,d2
		move.b	2(a2),d2		; Number of colors to change

loc_859B6:
		move.w	(a4)+,(a3)+
		dbf	d2,loc_859B6
		move.w	(a4)+,d0
		move.b	d0,2(a1)
		move.l	a4,d0
		move.l	a2,d1
		sub.l	d1,d0
		move.w	d0,(a1)

loc_859CA:

		addq.w	#8,a1
		bra.s	loc_85994
; End of function Run_PalRotationScript


; =============== S U B R O U T I N E =======================================


sub_859CE:
		move.b	3(a2),d2

loc_859D2:
		beq.s	loc_859FC
		neg.w	d1
		jmp	loc_859D2(pc,d1.w)
; ---------------------------------------------------------------------------
		bra.w	loc_859E2
; ---------------------------------------------------------------------------
		bra.w	loc_85A02
; ---------------------------------------------------------------------------

loc_859E2:
		addq.b	#1,3(a1)		; Add one to counter
		cmp.b	3(a1),d2		; Compare with max counter
		bhi.s	loc_859FC
		move.w	2(a4),d2
		adda.w	d2,a2
		move.l	a2,4(a1)		; Load new script after counter has finished
		movea.w	(a2),a3
		clr.w	2(a1)

loc_859FC:

		movea.l	a2,a4			; Start from the beginning of the rotation
		addq.l	#4,a4

locret_85A00:
		rts
; End of function sub_859CE

; ---------------------------------------------------------------------------

loc_85A02:
		addq.b	#1,3(a1)
		cmp.b	3(a1),d2
		bhi.s	loc_859FC		; Wait for counter to finish
		movea.l	($FFFFFADA).w,a2
		move.l	a1,-(sp)
		jsr	(a2)				; Run custom routine
		movea.l	(sp)+,a1
		addq.w	#4,sp
		bra.s	loc_859CA

; =============== S U B R O U T I N E =======================================


Run_PalRotationScript2:

		tst.b	($FFFFFABF).w
		bne.s	locret_85A58
		subq.b	#1,$3A(a0)
		bpl.s	locret_85A58
		movea.l	(a1)+,a3		; Address of Palette animation data
		move.w	(a1)+,d0		; Number of colors to replace
		moveq	#0,d1
		move.b	$3B(a0),d1
		addq.b	#2,d1
		moveq	#0,d2
		move.b	(a1,d1.w),d2
		bpl.s	loc_85A3E
		moveq	#0,d1
		move.b	(a1),d2

loc_85A3E:
		move.b	d1,$3B(a0)
		move.b	1(a1,d1.w),$3A(a0)
		add.w	d2,d2
		move.w	(a3,d2.w),d2
		lea	(a3,d2.w),a3

loc_85A52:
		move.w	(a3)+,(a2)+
		dbf	d0,loc_85A52

locret_85A58:
		rts
; End of function Run_PalRotationScript2


; =============== S U B R O U T I N E =======================================


Child_GetPriority:

		movea.w	$46(a0),a1
		bclr	#7,$A(a0)
		btst	#7,$A(a1)
		beq.s	loc_85A72
		bset	#7,$A(a0)

loc_85A72:
		move.w	8(a1),8(a0)
		rts
; End of function Child_GetPriority


; =============== S U B R O U T I N E =======================================


Child_GetPriorityOnce:

		movea.w	$46(a0),a1
		btst	#7,$A(a1)
		beq.s	locret_85A8E
		bset	#7,$A(a0)
		move.l	(sp),(a0)

locret_85A8E:
		rts
; End of function Child_GetPriorityOnce


; =============== S U B R O U T I N E =======================================


CopyWordData_7:

		movea.w	(a1)+,a3
		move.w	(a2)+,(a3)+

CopyWordData_6:

		movea.w	(a1)+,a3
		move.w	(a2)+,(a3)+

CopyWordData_5:
		movea.w	(a1)+,a3
		move.w	(a2)+,(a3)+
; End of function CopyWordData_7


; =============== S U B R O U T I N E =======================================


CopyWordData_4:

		movea.w	(a1)+,a3
		move.w	(a2)+,(a3)+
; End of function CopyWordData_4


; =============== S U B R O U T I N E =======================================


CopyWordData_3:

		movea.w	(a1)+,a3
		move.w	(a2)+,(a3)+

CopyWordData_2:
		movea.w	(a1)+,a3
		move.w	(a2)+,(a3)+
		movea.w	(a1)+,a3
		move.w	(a2)+,(a3)+
		rts
; End of function CopyWordData_3


; =============== S U B R O U T I N E =======================================


Obj_WaitOffscreen:

		move.l	#Map_Offscreen,$C(a0)
		bset	#2,4(a0)
		move.b	#$20,7(a0)
		move.b	#$20,6(a0)
		move.l	(sp)+,$34(a0)
		move.l	#loc_85AD2,(a0)

loc_85AD2:
		tst.b	4(a0)
		bmi.s	loc_85B02
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_85AF0
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_85AF0:
		move.w	$48(a0),d0
		beq.s	loc_85AFC
		movea.w	d0,a2
		bclr	#7,(a2)

loc_85AFC:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_85B02:
		move.l	$34(a0),(a0)			; Restore normal object operation when onscreen
		rts
; End of function Obj_WaitOffscreen

; ---------------------------------------------------------------------------
Map_Offscreen:	dc.w 0
; ---------------------------------------------------------------------------

Obj_Song_Fade_ToLevelMusic:

		move.w	#$78,$2E(a0)
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		move.l	#loc_85B1E,(a0)

loc_85B1E:
		subq.w	#1,$2E(a0)
		bpl.w	locret_8405E
		bsr.w	Obj_PlayLevelMusic
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_Song_Fade_Transition:

		move.w	#$5A,$2E(a0)
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		move.l	#loc_85B44,(a0)

loc_85B44:
		subq.w	#1,$2E(a0)
		bpl.w	locret_8405E
		move.b	$2C(a0),d0
		move.b	d0,($FFFFFF91).w
		jsr	(Play_Sound).l
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


Obj_PlayLevelMusic:

		moveq	#0,d0
		lea	($FFFFEE4E).w,a1
		move.b	(a1)+,d0
		add.b	d0,d0
		add.b	(a1),d0
		lea	(LevelMusic_Playlist).l,a2
		move.b	(a2,d0.w),d0
		move.w	d0,($FFFFFF90).w
		btst	#1,($FFFFB02B).w
		beq.s	loc_85B84
		moveq	#$2C,d0			; If invincible, play invincibility

loc_85B84:
		jmp	(Play_Sound).l
; End of function Obj_PlayLevelMusic


; =============== S U B R O U T I N E =======================================


Restore_PlayerControl:

		lea	($FFFFB000).w,a1

Restore_PlayerControl2:

		clr.b	$2E(a1)
		bclr	#1,$2A(a1)
		move.w	#$505,$20(a1)
		clr.b	$23(a1)
		clr.b	$24(a1)
		rts
; End of function Restore_PlayerControl


; =============== S U B R O U T I N E =======================================


Obj_EndSignControl:

		move.l	#Obj_EndSignControlWait,(a0)
		st	($FFFFFAA8).w		; End of level is in effect
		bset	#4,$38(a0)
		move.w	#$77,$2E(a0)
		move.l	#Obj_EndSignControlDoSign,$34(a0)
		rts
; End of function Obj_EndSignControl

; ---------------------------------------------------------------------------
PLC_EndSignStuff:	dc.w 1

		dc.l ArtNem_SignpostStub
		dc.w $D3C0
		dc.l ArtNem_Monitors
		dc.w $9880
; ---------------------------------------------------------------------------

Obj_EndSignControlWait:
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

Obj_EndSignControlDoSign:
		move.l	#Obj_EndSignControlAwaitStart,(a0)
		clr.b	($FFFFF7AA).w
		lea	Child6_EndSign(pc),a2
		jsr	CreateChild6_Simple(pc)
		lea	PLC_EndSignStuff(pc),a1
		jsr	(Load_PLC_Raw).l
		jmp	AfterBoss_Cleanup(pc)
; ---------------------------------------------------------------------------
Child6_EndSign:	dc.w 0
		dc.l Obj_EndSign
; ---------------------------------------------------------------------------

Obj_EndSignControlAwaitStart:

		tst.b	($FFFFFAA8).w
		bne.w	locret_8405E
		move.l	#Obj_EndSignControlDoStart,(a0)
		jsr	Restore_PlayerControl(pc)
		lea	($FFFFB04A).w,a1
		jmp	Restore_PlayerControl2(pc)
; ---------------------------------------------------------------------------

Obj_EndSignControlDoStart:
		tst.b	($FFFFFAAA).w		; Wait for title card to finish
		beq.w	locret_8405E
		jsr	Change_Act2Sizes(pc)
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
		jsr	Displace_PlayerOffObject(pc)
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


Check_CameraInRange:

		move.w	($FFFFEE7C).w,d0
		cmp.w	(a1)+,d0
		bcs.s	loc_85C74
		cmp.w	(a1)+,d0
		bhi.s	loc_85C74
		move.w	($FFFFEE78).w,d1
		cmp.w	(a1)+,d1
		bcs.s	loc_85C74
		cmp.w	(a1)+,d1
		bhi.s	loc_85C74
		bclr	#7,$27(a0)
		cmp.w	(a1),d0
		bls.s	loc_85C5E
		bset	#7,$27(a0)

loc_85C5E:
		bclr	#6,$27(a0)
		cmp.w	4(a1),d1
		bls.s	loc_85C70
		bset	#6,$27(a0)

loc_85C70:
		move.l	(sp),(a0)
		rts
; ---------------------------------------------------------------------------

loc_85C74:
		jsr	(Delete_Sprite_If_Not_In_Range).l
		addq.w	#4,sp
		rts
; End of function Check_CameraInRange

; ---------------------------------------------------------------------------

loc_85C7E:

		move.w	($FFFFEE78).w,($FFFFEE14).w
		move.w	($FFFFEE12).w,d0
		cmp.w	($FFFFEE1A).w,d0
		bcs.s	locret_85CA2
		move.w	d0,($FFFFEE18).w
		move.w	$3A(a0),d0
		cmp.w	($FFFFEE78).w,d0
		bhi.s	locret_85CA2
		movea.l	$34(a0),a1
		jsr	(a1)

locret_85CA2:

		rts
; ---------------------------------------------------------------------------

loc_85CA4:

		btst	#0,$27(a0)
		bne.s	loc_85CC6
		subq.w	#1,$2E(a0)
		bpl.s	loc_85CC6
		move.b	$26(a0),d0
		move.b	d0,($FFFFFF91).w
		jsr	(Play_Sound).l
		bset	#0,$27(a0)

loc_85CC6:

		btst	#1,$27(a0)
		bne.s	loc_85D06
		move.w	($FFFFEE7C).w,d0
		tst.b	$27(a0)
		bmi.s	loc_85CE6
		cmp.w	($FFFFFAB0).w,d0
		bcc.s	loc_85CF2
		move.w	d0,($FFFFEE18).w
		bra.w	loc_85D06
; ---------------------------------------------------------------------------

loc_85CE6:
		move.w	($FFFFFAB2).w,d1
		addi.w	#$60,d1
		cmp.w	d1,d0
		bhi.s	loc_85D06

loc_85CF2:
		bset	#1,$27(a0)
		move.w	($FFFFFAB0).w,($FFFFEE18).w
		move.w	($FFFFFAB2).w,d0
		move.w	d0,($FFFFEE12).w

loc_85D06:

		btst	#2,$27(a0)
		bne.s	loc_85D48
		move.w	($FFFFEE78).w,d0
		btst	#6,$27(a0)
		bne.s	loc_85D28
		cmp.w	($FFFFFAB4).w,d0
		bcc.s	loc_85D36
		move.w	d0,($FFFFEE14).w
		bra.w	loc_85D48
; ---------------------------------------------------------------------------

loc_85D28:
		cmp.w	($FFFFFAB6).w,d0
		bls.s	loc_85D36
		move.w	d0,($FFFFEE16).w
		bra.w	loc_85D48
; ---------------------------------------------------------------------------

loc_85D36:

		bset	#2,$27(a0)
		move.w	($FFFFFAB4).w,($FFFFEE14).w
		move.w	($FFFFFAB6).w,($FFFFEE16).w

loc_85D48:

		move.b	$27(a0),d0
		andi.b	#7,d0
		cmpi.b	#7,d0
		bne.w	locret_8405E
		clr.b	$27(a0)
		clr.w	$1C(a0)
		clr.b	$26(a0)
		movea.l	$34(a0),a1
		jmp	(a1)

; =============== S U B R O U T I N E =======================================


sub_85D6A:

		move.b	#1,($FFFFF7AA).w

loc_85D70:
		moveq	#-$1F,d0
		jsr	(Play_Sound).l
		move.w	#$78,$2E(a0)

loc_85D7E:
		move.w	($FFFFEE18).w,($FFFFFA96).w
		move.w	($FFFFEE12).w,($FFFFFA98).w
		move.w	($FFFFEE14).w,($FFFFFA94).w
		move.w	($FFFFEE16).w,($FFFFFA92).w
		move.w	(a1)+,($FFFFFAB0).w
		move.w	(a1)+,($FFFFFAB2).w
		move.w	(a1)+,($FFFFFAB4).w
		move.w	(a1)+,($FFFFFAB6).w
		rts
; End of function sub_85D6A


; =============== S U B R O U T I N E =======================================


Change_Act2Sizes:
		moveq	#0,d0
		move.b	($FFFFFE10).w,d0
		cmpi.b	#8,d0
		beq.w	locret_8405E		; SOZ1 has a special event leading to SOZ2, so don't mess around there
		lsl.w	#4,d0
		lea	(LevelSizes).l,a1
		lea	8(a1,d0.w),a1			; Get level sizes for act 2
		move.w	(a1)+,($FFFFFA94).w
		move.w	(a1)+,($FFFFFA92).w
		move.w	(a1)+,($FFFFFA96).w
		move.w	(a1)+,d1
		move.w	d1,($FFFFFA98).w	; Put level sizes into the target size memory
		move.w	d1,($FFFFEE12).w
		cmpi.b	#$10,d0
		beq.w	locret_8405E		; If we're in HCZ, don't immediately apply these changes. There's another event to do.
; End of function Change_Act2Sizes


; =============== S U B R O U T I N E =======================================


Make_LevelSizeObj:
		lea	Child1_Act2LevelSize(pc),a2
		jmp	CreateChild1_Normal(pc)
; End of function Make_LevelSizeObj

; ---------------------------------------------------------------------------
Child1_Act2LevelSize:dc.w 2
		dc.l Obj_IncLevEndXGradual
		dc.w 0
		dc.l Obj_DecLevStartYGradual
		dc.w 0
		dc.l Obj_IncLevEndYGradual
		dc.w 0
; ---------------------------------------------------------------------------
		lea	($FFFFFE10).w,a1		; Unused
		moveq	#0,d0
		moveq	#0,d1
		move.b	(a1)+,d0
		lsl.w	#4,d0
		tst.b	(a1)+
		beq.s	loc_85E0E
		addq.w	#8,d1

loc_85E0E:
		add.w	d1,d0
		lea	(LevelSizes).l,a1
		lea	(a1,d0.w),a1
		move.w	(a1)+,($FFFFFA94).w
		move.w	(a1)+,($FFFFFA92).w
		move.w	(a1)+,($FFFFFA96).w
		move.w	(a1)+,d1
		move.w	d1,($FFFFFA98).w
		move.w	d1,($FFFFEE12).w
		lea	(Child7_ChangeLevSize).l,a2
		jmp	CreateChild7_Normal2(pc)

; =============== S U B R O U T I N E =======================================


StartNewLevel:

		move.w	d0,($FFFFFE10).w
		move.w	d0,($FFFFEE4E).w
		move.w	#1,($FFFFFE02).w
		clr.b	($FFFFFE2A).w
		clr.b	($FFFFFE48).w
		rts
; End of function StartNewLevel


; =============== S U B R O U T I N E =======================================


sub_85E52:

		move.b	($FFFFFE0F).w,d1
		andi.b	#$F,d1
		bne.w	locret_8405E
		jmp	(Play_Sound_2).l
; End of function sub_85E52

; ---------------------------------------------------------------------------

loc_85E64:

		move.b	#7,$39(a0)
		move.l	#loc_85E74,(a0)
		st	($FFFFFABF).w

loc_85E74:
		subq.w	#1,$2E(a0)
		bpl.s	locret_85EA8
		move.w	$3A(a0),$2E(a0)
		lea	($FFFFFC00).w,a1
		moveq	#$3F,d0

loc_85E86:
		bsr.w	sub_85EB4
		dbf	d0,loc_85E86
		subq.b	#1,$39(a0)
		bmi.s	loc_85E96
		rts
; ---------------------------------------------------------------------------

loc_85E96:
		tst.b	$2C(a0)
		beq.s	loc_85EAA
		move.l	#loc_85EE6,(a0)
		bset	#5,$38(a0)

locret_85EA8:
		rts
; ---------------------------------------------------------------------------

loc_85EAA:
		clr.b	($FFFFFABF).w
		jmp	(Go_Delete_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_85EB4:

		moveq	#$E,d2
		move.b	(a1),d3
		and.b	d2,d3
		cmp.b	d2,d3
		bcc.s	loc_85EC2
		addq.b	#2,d3
		move.b	d3,(a1)

loc_85EC2:
		addq.w	#1,a1
		move.b	(a1),d3
		move.b	d3,d4
		andi.b	#-$20,d3
		andi.b	#$E,d4
		cmpi.b	#-$20,d3
		bcc.s	loc_85EDA
		addi.b	#$20,d3

loc_85EDA:
		cmp.b	d2,d4
		bcc.s	loc_85EE0
		addq.b	#2,d4

loc_85EE0:
		or.b	d3,d4
		move.b	d4,(a1)+
		rts
; End of function sub_85EB4

; ---------------------------------------------------------------------------

loc_85EE6:

		move.b	#7,$39(a0)
		move.w	#3,$2E(a0)
		move.l	#loc_85EF8,(a0)

loc_85EF8:
		subq.w	#1,$2E(a0)
		bpl.w	locret_8405E
		move.w	#3,$2E(a0)
		lea	($FFFFFC00).w,a1
		lea	($FFFFFC80).w,a2
		moveq	#$3F,d0

loc_85F10:
		bsr.w	sub_85F2A
		dbf	d0,loc_85F10
		subq.b	#1,$39(a0)
		bpl.w	locret_8405E
		clr.b	($FFFFFABF).w
		jmp	(Go_Delete_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_85F2A:

		move.b	(a2)+,d2
		andi.b	#$E,d2
		move.b	(a1),d3
		cmp.b	d2,d3
		bls.s	loc_85F3A
		subq.b	#2,d3
		move.b	d3,(a1)

loc_85F3A:
		addq.w	#1,a1
		move.b	(a2)+,d2
		move.b	d2,d3
		andi.b	#-$20,d2
		andi.b	#$E,d3
		move.b	(a1),d4
		move.b	d4,d5
		andi.b	#-$20,d4
		andi.b	#$E,d5
		cmp.b	d2,d4
		bls.s	loc_85F5C
		subi.b	#$20,d4

loc_85F5C:
		cmp.b	d3,d5
		bls.s	loc_85F62
		subq.b	#2,d5

loc_85F62:
		or.b	d4,d5
		move.b	d5,(a1)+
		rts
; End of function sub_85F2A

; ---------------------------------------------------------------------------
		move.w	($FFFFFF08).w,d0
		cmpi.w	#2,d0
		beq.s	loc_85F7E
		cmpi.w	#7,($FFFFFFB0).w
		beq.s	loc_85F82
		moveq	#0,d0
		rts
; ---------------------------------------------------------------------------

loc_85F7E:
		moveq	#1,d0
		rts
; ---------------------------------------------------------------------------

loc_85F82:
		moveq	#2,d0
		rts

; =============== S U B R O U T I N E =======================================


BossDefeated_StopTimer:

		clr.b	($FFFFFE1E).w
; End of function BossDefeated_StopTimer


; =============== S U B R O U T I N E =======================================


BossDefeated:

		move.w	#$3F,$2E(a0)
		moveq	#$64,d0
		jsr	(HUD_AddToScore).l
		bclr	#7,4(a0)
		rts
; End of function BossDefeated


; =============== S U B R O U T I N E =======================================


Player_Load_PLC:

		move.l	a0,-(sp)
		lea	($FFFFB000).w,a0
		moveq	#0,d0
		move.b	$38(a0),d0
		lsl.w	#2,d0
		movea.l	off_85FB8(pc,d0.w),a1
		jsr	(a1)
		movea.l	(sp)+,a0
		rts
; End of function Player_Load_PLC

; ---------------------------------------------------------------------------
off_85FB8:	dc.l Sonic_Load_PLC
		dc.l Tails_Load_PLC
		dc.l Knuckles_Load_PLC

; =============== S U B R O U T I N E =======================================


Player_Load_PLC2:

		move.l	a0,-(sp)
		movea.l	a1,a0
		tst.l	(a0)
		beq.s	loc_85FDA
		moveq	#0,d0
		move.b	$38(a0),d0
		lsl.w	#2,d0
		movea.l	off_85FB8(pc,d0.w),a1
		jsr	(a1)

loc_85FDA:
		movea.l	(sp)+,a0
		rts
; End of function Player_Load_PLC2


; =============== S U B R O U T I N E =======================================


PLCLoad_AnimalsAndExplosion:

		lea	PLC_83D6C(pc),a1
		jsr	(Load_PLC_Raw).l
		moveq	#0,d0
		move.b	($FFFFFE10).w,d0
		add.w	d0,d0
		move.w	off_85FFE(pc,d0.w),d0
		lea	off_85FFE(pc,d0.w),a1
		jmp	(Load_PLC_Raw).l
; End of function PLCLoad_AnimalsAndExplosion

; ---------------------------------------------------------------------------
off_85FFE:	dc.w PLC_8602E-off_85FFE

		dc.w PLC_8603C-off_85FFE
		dc.w PLC_8604A-off_85FFE
		dc.w PLC_86058-off_85FFE
		dc.w PLC_86066-off_85FFE
		dc.w PLC_86074-off_85FFE
		dc.w PLC_86082-off_85FFE
		dc.w PLC_86090-off_85FFE
		dc.w PLC_8609E-off_85FFE
		dc.w PLC_860AC-off_85FFE
		dc.w PLC_860BA-off_85FFE
		dc.w PLC_860C8-off_85FFE
		dc.w PLC_860D6-off_85FFE
		dc.w PLC_860E4-off_85FFE
		dc.w PLC_860E4-off_85FFE
		dc.w PLC_860E4-off_85FFE
		dc.w PLC_860E4-off_85FFE
		dc.w PLC_860E4-off_85FFE
		dc.w PLC_860E4-off_85FFE
		dc.w PLC_860E4-off_85FFE
		dc.w PLC_860E4-off_85FFE
		dc.w PLC_860E4-off_85FFE
		dc.w PLC_860E4-off_85FFE
		dc.w PLC_860E4-off_85FFE
PLC_8602E:	dc.w 1
		dc.l ArtNem_BlueFlicky
		dc.w $B000
		dc.l ArtNem_Chicken
		dc.w $B240
PLC_8603C:	dc.w 1
		dc.l ArtNem_Rabbit
		dc.w $B000
		dc.l ArtNem_Bunny
		dc.w $B240
PLC_8604A:	dc.w 1
		dc.l ArtNem_BlueFlicky
		dc.w $B000
		dc.l ArtNem_Chicken
		dc.w $B240
PLC_86058:	dc.w 1
		dc.l ArtNem_Rabbit
		dc.w $B000
		dc.l ArtNem_BlueFlicky
		dc.w $B240
PLC_86066:	dc.w 1
		dc.l ArtNem_Squirrel
		dc.w $B000
		dc.l ArtNem_BlueFlicky
		dc.w $B240
PLC_86074:	dc.w 1
		dc.l ArtNem_Penguin
		dc.w $B000
		dc.l ArtNem_Bunny
		dc.w $B240
PLC_86082:	dc.w 1
		dc.l ArtNem_BlueFlicky
		dc.w $B000
		dc.l ArtNem_Chicken
		dc.w $B240
PLC_86090:	dc.w 1
		dc.l ArtNem_Squirrel
		dc.w $B000
		dc.l ArtNem_Chicken
		dc.w $B240
PLC_8609E:	dc.w 1
		dc.l ArtNem_Rabbit
		dc.w $B000
		dc.l ArtNem_Chicken
		dc.w $B240
PLC_860AC:	dc.w 1
		dc.l ArtNem_BlueFlicky
		dc.w $B000
		dc.l ArtNem_Chicken
		dc.w $B240
PLC_860BA:	dc.w 1
		dc.l ArtNem_Rabbit
		dc.w $B000
		dc.l ArtNem_Chicken
		dc.w $B240
PLC_860C8:	dc.w 1
		dc.l ArtNem_Squirrel
		dc.w $B000
		dc.l ArtNem_Chicken
		dc.w $B240
PLC_860D6:	dc.w 1
		dc.l ArtNem_Squirrel
		dc.w $B000
		dc.l ArtNem_Chicken
		dc.w $B240
PLC_860E4:	dc.w 1
		dc.l ArtNem_BlueFlicky
		dc.w $B000
		dc.l ArtNem_Chicken
		dc.w $B240
; ---------------------------------------------------------------------------

AddRings:

		lea	($FFFFFE20).w,a2
		lea	($FFFFFE1D).w,a3
		lea	($FFFFFE1B).w,a4

loc_860FE:
		lea	($FFFFFEC8).w,a5
		move.w	#$3E7,d1
		add.w	d0,(a5)
		cmp.w	(a5),d1
		bcc.s	loc_8610E
		move.w	d1,(a5)

loc_8610E:
		add.w	d0,(a2)
		cmp.w	(a2),d1
		bcc.s	loc_86116
		move.w	d1,(a2)

loc_86116:
		ori.b	#1,(a3)
		cmpi.w	#$64,(a2)
		bcs.s	loc_86132
		bset	#1,(a4)
		beq.s	loc_8613A
		cmpi.w	#$C8,(a2)
		bcs.s	loc_86132
		bset	#2,(a4)
		beq.s	loc_8613A

loc_86132:

		moveq	#$33,d0
		jmp	(Play_Sound).l
; ---------------------------------------------------------------------------

loc_8613A:

		addq.w	#1,($FFFFFECC).w		; Add an extra life
		addq.b	#1,($FFFFFE12).w
		addq.b	#1,($FFFFFE1C).w
		moveq	#$2A,d0
		jmp	(Play_Sound).l

; =============== S U B R O U T I N E =======================================


Perform_Art_Scaling:

		clr.w	($FFFFF740).w
		move.l	a0,-(sp)
		jsr	Init_ArtScaling
		movea.l	(sp)+,a0
		move.l	a0,-(sp)
		move.w	$A(a0),d0
		jsr	(sub_2468A).l
		movea.l	(sp)+,a0
		move.w	($FFFFF740).w,d3
		lsl.w	#4,d3
		move.l	#-$3000,d1
		move.w	$3A(a0),d2
		jmp	(Add_To_DMA_Queue).l
; End of function Perform_Art_Scaling


; =============== S U B R O U T I N E =======================================


sub_86180:

		move.w	$18(a0),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$30(a0)
		move.w	$1A(a0),d0
		ext.l	d0
		lsl.l	#8,d0
		add.l	d0,$34(a0)
		rts
; End of function sub_86180


; =============== S U B R O U T I N E =======================================


sub_8619A:
		move.w	$30(a0),d2
		move.w	$34(a0),d3
		moveq	#0,d0
		move.b	$40(a0),d0
		addq.w	#4,d0
		move.l	#$100,d4
		divu.w	d0,d4
		sub.w	d4,d2
		sub.w	d4,d3
		move.w	d2,$10(a0)
		move.w	d3,$14(a0)
		rts
; End of function sub_8619A

; ---------------------------------------------------------------------------

loc_861C0:
		lea	($FFFFB000).w,a1
		moveq	#0,d0
		move.w	$10(a1),d0
		moveq	#0,d1
		move.w	$14(a1),d1

; =============== S U B R O U T I N E =======================================


sub_861D0:
		sub.w	$10(a0),d0
		smi	d2
		bpl.s	loc_861DA
		neg.w	d0

loc_861DA:
		sub.w	$14(a0),d1
		smi	d3
		bpl.s	loc_861E4
		neg.w	d1

loc_861E4:
		cmp.w	d1,d0
		scs	d4
		beq.s	loc_8621A
		bcc.s	loc_861EE
		exg	d0,d1

loc_861EE:
		swap	d1
		divu.w	d0,d1

loc_861F2:
		move.w	#$100,d0
		lsl.w	d5,d0
		moveq	#8,d6
		sub.w	d5,d6
		lsr.w	d6,d1

loc_861FE:
		tst.b	d4
		beq.s	loc_86204
		exg	d0,d1

loc_86204:
		tst.b	d2
		beq.s	loc_8620A
		neg.w	d0

loc_8620A:
		tst.b	d3
		beq.s	loc_86210
		neg.w	d1

loc_86210:
		move.w	d0,$18(a0)
		move.w	d1,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_8621A:
		tst.w	d0
		beq.s	loc_861F2
		move.w	#$100,d0
		lsl.w	d5,d0
		move.w	#$100,d1
		lsl.w	d5,d1
		bra.s	loc_861FE
; End of function sub_861D0


; =============== S U B R O U T I N E =======================================


sub_8622C:

		moveq	#0,d0
		moveq	#0,d1
		moveq	#0,d2
		moveq	#0,d3
		moveq	#0,d4
		move.w	$10(a2),d0
		move.w	$14(a2),d1
		sub.w	$10(a1),d0
		bpl.s	loc_86248
		neg.w	d0
		moveq	#8,d2

loc_86248:
		sub.w	$14(a1),d1
		bpl.s	loc_86252
		neg.w	d1
		moveq	#4,d3

loc_86252:
		cmp.w	d0,d1
		bcc.s	loc_8625A
		exg	d0,d1
		moveq	#2,d4

loc_8625A:
		tst.w	d1
		beq.s	locret_8627E
		lsl.w	#5,d0
		divu.w	d1,d0
		add.w	d2,d3
		add.w	d3,d4
		move.w	off_8626E(pc,d4.w),d4
		jmp	off_8626E(pc,d4.w)
; ---------------------------------------------------------------------------
off_8626E:	dc.w locret_8627E-off_8626E

		dc.w loc_86280-off_8626E
		dc.w loc_86288-off_8626E
		dc.w loc_86290-off_8626E
		dc.w loc_86296-off_8626E
		dc.w loc_8629A-off_8626E
		dc.w loc_862A0-off_8626E
		dc.w loc_862A6-off_8626E
; ---------------------------------------------------------------------------

locret_8627E:

		rts
; End of function sub_8622C

; ---------------------------------------------------------------------------

loc_86280:
		subi.w	#$40,d0
		neg.w	d0
		rts
; ---------------------------------------------------------------------------

loc_86288:
		subi.w	#$80,d0
		neg.w	d0
		rts
; ---------------------------------------------------------------------------

loc_86290:
		addi.w	#$40,d0
		rts
; ---------------------------------------------------------------------------

loc_86296:
		neg.w	d0
		rts
; ---------------------------------------------------------------------------

loc_8629A:
		addi.w	#$C0,d0
		rts
; ---------------------------------------------------------------------------

loc_862A0:
		addi.w	#$80,d0
		rts
; ---------------------------------------------------------------------------

loc_862A6:
		subi.w	#$C0,d0
		neg.w	d0
		rts
; ---------------------------------------------------------------------------

Obj_8B:

		bset	#2,4(a0)

loc_862B4:
		clr.w	$A(a0)
		move.l	#Map_SpriteMask,$C(a0)
		move.b	#$20,7(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.l	#loc_862FE,(a0)
		btst	#3,d0
		beq.s	loc_862DE
		move.l	#loc_86308,(a0)

loc_862DE:
		move.w	d0,d1
		andi.w	#$F0,d0
		lsr.w	#2,d0
		move.b	d0,6(a0)
		lsr.w	#2,d0
		move.b	d0,$22(a0)
		andi.w	#7,d1
		add.w	d1,d1
		move.w	word_86324(pc,d1.w),8(a0)
		rts
; ---------------------------------------------------------------------------

loc_862FE:
		st	($FFFFEF3A).w
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_86308:
		st	($FFFFEF3A).w
		movea.w	$46(a0),a1
		btst	#5,$38(a1)
		bne.s	loc_8631E
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8631E:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
word_86324:	dc.w 0
		dc.w $80
		dc.w $100
		dc.w $180
		dc.w $200
		dc.w $280
		dc.w $300
		dc.w $380
; ---------------------------------------------------------------------------

loc_86334:

		move.w	#$808,d0
		tst.w	$2E(a0)
		beq.s	loc_86346
		subq.w	#1,$2E(a0)
		move.w	#$4808,d0

loc_86346:
		btst	#5,($FFFFB02A).w
		beq.s	loc_86358
		move.w	#$1F,$2E(a0)
		move.w	#$4848,d0

loc_86358:
		move.w	d0,($FFFFF602).w
		rts

; =============== S U B R O U T I N E =======================================


sub_8635E:

		move.w	d0,$1A(a1)
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		clr.b	$40(a1)
		clr.b	$3D(a1)
		move.b	#$10,$20(a1)
		move.b	#2,5(a1)
		moveq	#-$4F,d0
		jmp	(Play_Sound_2).l
; End of function sub_8635E


; =============== S U B R O U T I N E =======================================


sub_8638A:

		lea	($FFFFB000).w,a1
		bsr.w	sub_8639C
		lea	($FFFFB04A).w,a1
		tst.b	4(a1)
		bpl.s	locret_863BE
; End of function sub_8638A


; =============== S U B R O U T I N E =======================================


sub_8639C:
		move.w	$10(a0),d0
		bclr	#0,4(a1)
		bclr	#0,$2A(a1)
		cmp.w	$10(a1),d0
		bcc.s	locret_863BE
		bset	#0,4(a1)
		bset	#0,$2A(a1)

locret_863BE:

		rts
; End of function sub_8639C

; ---------------------------------------------------------------------------

loc_863C0:

		tst.l	($FFFFB04A).w
		beq.s	loc_863E6
		move.b	#1,($FFFFF7CB).w
		clr.w	($FFFFF702).w
		move.l	#loc_863D6,(a0)

loc_863D6:
		tst.b	($FFFFF7CB).w
		beq.s	loc_863E2
		clr.w	($FFFFF66A).w
		rts
; ---------------------------------------------------------------------------

loc_863E2:
		clr.w	($FFFFF606).w

loc_863E6:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

Obj_B3_2:

		lea	($FFFFB000).w,a1
		lea	word_86426(pc),a2
		jsr	(Check_InMyRange).l
		beq.w	locret_8405E
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_86418
		cmpi.b	#9,($FFFFFE10).w
		bne.s	loc_86418
		st	($FFFFEF56).w
		jsr	(SaveGame).l

loc_86418:

		moveq	#0,d0
		move.w	$2C(a0),d0
		lsr.w	#1,d0
		rol.b	#1,d0
		jmp	StartNewLevel(pc)
; ---------------------------------------------------------------------------
word_86426:	dc.w  $FFF0,   $20, $FF80,  $100
; ---------------------------------------------------------------------------

loc_8642E:

		st	($FFFFEECC).w
		move.l	#loc_86438,(a0)

loc_86438:
		tst.w	($FFFFEECC).w
		beq.s	loc_86452
		move.b	($FFFFFE0F).w,d1
		andi.b	#$F,d1
		bne.w	locret_8405E
		moveq	#$6F,d0
		jmp	(Play_Sound_2).l
; ---------------------------------------------------------------------------

loc_86452:
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_86458:
		lea	$18(a0),a2
		move.w	$16(a0),d0
		subq.w	#1,d0
		move.w	$10(a0),d2
		move.w	$14(a0),d3

loc_8646A:
		move.b	(a1)+,d1
		ext.w	d1
		btst	#0,4(a0)
		beq.s	loc_86478
		neg.w	d1

loc_86478:
		add.w	d2,d1
		move.w	d1,(a2)+
		move.b	(a1)+,d1
		ext.w	d1
		add.w	d3,d1
		move.w	d1,(a2)+
		addq.w	#2,a2
		dbf	d0,loc_8646A
		rts
; End of function sub_86458

; ---------------------------------------------------------------------------

loc_8648C:
		addi.w	#$32,($FFFFFE20).w
		move.b	#1,($FFFFF65F).w
		move.b	#$F,($FFFFF65E).w
		move.b	#1,($FFFFFE19).w
		move.w	#$3C,($FFFFF670).w
		move.w	#$800,($FFFFF760).w
		move.w	#$18,($FFFFF762).w
		move.w	#$C0,($FFFFF764).w
		move.b	#$1F,($FFFFB020).w
		cmpi.w	#2,($FFFFFF08).w
		bne.s	loc_864F8
		move.b	#0,($FFFFFE19).w
		move.b	#1,($FFFFF667).w
		move.b	#$29,($FFFFB020).w
		move.w	#$800,($FFFFFEC0).w
		move.w	#$18,($FFFFFEC2).w
		move.w	#$C0,($FFFFFEC4).w
		move.l	#Obj_HyperTails_Birds,($FFFFCD7C).w
		bra.s	loc_8652C
; ---------------------------------------------------------------------------

loc_864F8:
		bcc.s	loc_86524
		move.l	#Map_SuperSonic,($FFFFB00C).w
		move.b	#-1,($FFFFFE19).w
		move.w	#$A00,($FFFFF760).w
		move.w	#$30,($FFFFF762).w
		move.w	#$100,($FFFFF764).w
		move.l	#Obj_HyperSonic_19348,($FFFFCD7C).w
		bra.s	loc_8652C
; ---------------------------------------------------------------------------

loc_86524:
		move.l	#Obj_HyperSonicKnux_Trail,($FFFFCBC0).w

loc_8652C:

		move.b	#-$7F,($FFFFB02E).w
		move.b	#0,($FFFFB035).w
		bset	#1,($FFFFB02B).w
		rts
; ---------------------------------------------------------------------------

Obj_81:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_86566(pc,d0.w),d1
		move.w	$10(a0),-(sp)
		jsr	off_86566(pc,d1.w)
		moveq	#$2B,d1
		moveq	#$18,d2
		moveq	#$18,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectFull).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_86566:	dc.w loc_8657A-off_86566

		dc.w loc_865D0-off_86566
		dc.w loc_8661E-off_86566
		dc.w loc_86626-off_86566
		dc.w loc_8662A-off_86566
		dc.w loc_866BA-off_86566
		dc.w loc_866CC-off_86566
		dc.w loc_866DA-off_86566
		dc.w loc_866EC-off_86566
		dc.w loc_86716-off_86566
; ---------------------------------------------------------------------------

loc_8657A:
		lea	ObjDat3_86B32(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		btst	#1,4(a0)
		bne.s	loc_86592
		lea	ChildObjDat_86B5C(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_86592:
		move.b	#8,5(a0)
		move.w	($FFFFEE78).w,d0
		addi.w	#$A0,d0
		move.w	d0,$10(a0)
		move.w	d0,$3E(a0)
		move.w	($FFFFEE7C).w,d0
		subi.w	#$40,d0
		move.w	d0,$14(a0)
		move.w	#1,$3A(a0)
		jsr	(Swing_Setup1).l
		lea	ChildObjDat_86B64(pc),a2
		jsr	CreateChild1_Normal(pc)
		lea	ChildObjDat_86B6C(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_865D0:
		btst	#1,$38(a0)
		beq.s	locret_8661C
		move.b	#4,5(a0)

; =============== S U B R O U T I N E =======================================


sub_865DE:
		cmpi.b	#2,($FFFFFE10).w
		beq.s	loc_865EA
		st	($FFFFF7CB).w

loc_865EA:
		move.b	#1,$22(a0)
		move.w	#$40,$2E(a0)
		st	($FFFFFACD).w
		lea	ChildObjDat_86B7A(pc),a2
		jsr	CreateChild1_Normal(pc)
		lea	ChildObjDat_86B9A(pc),a2
		jsr	CreateChild1_Normal(pc)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild1_Normal).l
		move.b	#8,$2C(a1)

locret_8661C:

		rts
; End of function sub_865DE

; ---------------------------------------------------------------------------

loc_8661E:
		move.b	#6,d0
		bra.w	sub_868F8
; ---------------------------------------------------------------------------

loc_86626:
		bra.w	Check_TailsEndPose
; ---------------------------------------------------------------------------

loc_8662A:
		move.w	($FFFFEE78).w,d0
		move.w	$3A(a0),d1
		bmi.s	loc_86642
		addi.w	#$110,d0
		cmp.w	$10(a0),d0
		bcs.s	loc_8664C
		bra.w	loc_8664E
; ---------------------------------------------------------------------------

loc_86642:
		addi.w	#$30,d0
		cmp.w	$10(a0),d0
		bcs.s	loc_8664E

loc_8664C:
		neg.w	d1

loc_8664E:

		move.w	d1,$3A(a0)
		add.w	d1,$10(a0)
		move.w	($FFFFEE7C).w,d0
		addi.w	#$40,d0
		cmpi.b	#2,($FFFFFE10).w
		bne.s	loc_8666A
		subi.w	#$20,d0

loc_8666A:
		move.l	#$4000,d1
		cmp.w	$14(a0),d0
		bhi.s	loc_86678
		neg.l	d1

loc_86678:
		add.l	d1,$14(a0)
		btst	#1,$38(a0)
		beq.s	loc_86698
		moveq	#0,d0
		move.b	($FFFFFE10).w,d0
		move.b	byte_866A2(pc,d0.w),5(a0)
		move.w	a1,$44(a0)
		bsr.w	sub_865DE

loc_86698:
		jsr	Swing_UpAndDown(pc)
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------
byte_866A2:	dc.b $A
		dc.b $A
		dc.b $E
		dc.b $A
		dc.b $A
		dc.b $A
		dc.b $10
		dc.b $A
		dc.b $A
		dc.b $A
		dc.b $A
		dc.b $A
		dc.b $A
		dc.b $A
		dc.b $A
		dc.b $A
		dc.b $A
		dc.b $A
		dc.b $A
		dc.b $A
		dc.b $A
		dc.b $A
		dc.b $A
		dc.b $A
; ---------------------------------------------------------------------------

loc_866BA:
		move.b	#$C,d0
		bsr.w	sub_868F8
		jsr	Swing_UpAndDown(pc)
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_866CC:
		bsr.w	Check_TailsEndPose
		jsr	Swing_UpAndDown(pc)
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_866DA:
		move.b	#$C,d0
		bsr.w	sub_86984
		jsr	Swing_UpAndDown(pc)
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_866EC:
		move.b	#$12,d0
		bsr.w	sub_868F8

loc_866F4:
		jsr	Swing_UpAndDown(pc)
		move.w	($FFFFEE78).w,d0
		subi.w	#$60,d0
		cmp.w	$10(a0),d0
		bcs.s	loc_8670C
		st	($FFFFFAA2).w
		rts
; ---------------------------------------------------------------------------

loc_8670C:
		subq.w	#2,$10(a0)
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_86716:
		bsr.w	Check_TailsEndPose
		bra.s	loc_866F4
; ---------------------------------------------------------------------------

loc_8671C:
		move.l	#loc_8672A,(a0)
		lea	word_86B3E(pc),a1
		jmp	SetUp_ObjAttributes3(pc)
; ---------------------------------------------------------------------------

loc_8672A:

		jsr	(sub_86A3E).l
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	loc_86750
		move.l	#loc_86754,(a0)
		movea.w	$46(a0),a1
		bset	#1,$38(a1)
		move.b	#$C,$22(a0)

loc_86750:
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_86754:

		bsr.w	sub_86A3E
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_8675C:
		move.l	#loc_86770,(a0)
		bset	#1,4(a0)
		lea	word_86B3E(pc),a1
		jmp	SetUp_ObjAttributes3(pc)
; ---------------------------------------------------------------------------

loc_86770:
		jsr	Refresh_ChildPosition(pc)
		bsr.w	sub_86A54
		lea	word_867C2(pc),a1
		jsr	Check_PlayerInRange(pc)
		tst.l	d0
		beq.s	loc_867BE
		tst.w	d0
		beq.s	loc_867A0
		movea.w	d0,a1
		tst.w	$1A(a1)
		bpl.s	loc_867A0
		cmpi.b	#2,$20(a1)
		beq.s	loc_867AA
		cmpi.b	#1,$38(a1)
		beq.s	loc_867AA

loc_867A0:

		swap	d0
		movea.w	d0,a1
		tst.w	$1A(a1)
		bpl.s	loc_867BE

loc_867AA:

		move.l	#loc_867CA,(a0)
		subq.b	#8,$43(a0)
		movea.w	$46(a0),a1
		bset	#1,$38(a1)

loc_867BE:

		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------
word_867C2:	dc.w  $FFE6,   $34, $FFE4,   $38
; ---------------------------------------------------------------------------

loc_867CA:
		jsr	Refresh_ChildPosition(pc)
		bsr.w	sub_86A54
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_867D6:

		lea	ObjDat3_86B44(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		cmpi.w	#$400,($FFFFFE10).w
		bne.s	loc_867EC
		move.w	#$44E,$A(a0)

loc_867EC:
		move.l	#Obj_FlickerMove,(a0)
		bsr.w	sub_86A64
		moveq	#4,d0
		jsr	Set_IndexedVelocity(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_86802:

		lea	word_86B56(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_86810,(a0)

loc_86810:
		jsr	Refresh_ChildPosition(pc)
		lea	byte_86BF6(pc),a1
		jsr	Animate_RawNoSST(pc)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_86820:

		lea	word_86B50(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_8683E,(a0)
		move.b	#8,$1E(a0)
		bsr.w	sub_86A7A
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8683E:
		subq.w	#1,$2E(a0)
		bpl.s	loc_86850
		move.l	#loc_86854,(a0)
		move.w	#$80,8(a0)

loc_86850:
		jmp	Sprite_CheckDelete(pc)
; ---------------------------------------------------------------------------

loc_86854:
		jsr	MoveSprite_LightGravity(pc)
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_86888
		add.w	d1,$14(a0)
		move.w	$3E(a0),$1A(a0)
		jsr	Find_SonicTails(pc)
		move.w	#-$200,d1
		tst.b	($FFFFFAA8).w
		beq.s	loc_86880
		tst.w	d0
		beq.s	loc_86880
		neg.w	d1

loc_86880:

		move.w	d1,$18(a0)
		bsr.w	sub_86B1E

loc_86888:

		moveq	#0,d0
		btst	#3,($FFFFFE0F).w
		bne.s	loc_86894
		moveq	#1,d0

loc_86894:
		move.b	d0,$22(a0)
		jmp	Sprite_CheckDelete(pc)
; ---------------------------------------------------------------------------

loc_8689C:
		jsr	Refresh_ChildPosition(pc)
		subq.w	#1,$2E(a0)
		bpl.s	loc_868B2
		move.l	#loc_868B6,(a0)
		move.w	#$80,8(a0)

loc_868B2:
		jmp	Sprite_CheckDelete(pc)
; ---------------------------------------------------------------------------

loc_868B6:
		lea	($FFFFB000).w,a1
		move.w	#$300,d0
		move.w	#$100,d1
		moveq	#$10,d2
		move.w	#0,d3
		move.w	#-$30,d4
		sub.b	$2C(a0),d4
		bsr.w	sub_869F6
		jsr	(MoveSprite2).l
		bsr.w	sub_86B1E
		tst.b	($FFFFFAA8).w
		bne.s	loc_868F0
		move.l	#loc_868F2,(a0)
		bset	#0,4(a0)

loc_868F0:
		bra.s	loc_86888
; ---------------------------------------------------------------------------

loc_868F2:
		subq.w	#2,$10(a0)
		bra.s	loc_86888

; =============== S U B R O U T I N E =======================================


sub_868F8:

		subq.w	#1,$2E(a0)
		bpl.s	locret_86930
		lea	($FFFFB000).w,a1
		btst	#7,$2A(a1)
		bne.s	locret_86930
		btst	#1,$2A(a1)
		bne.s	locret_86930
		cmpi.b	#6,5(a1)
		bcc.s	locret_86930
		move.b	d0,5(a0)
		bsr.w	Set_PlayerEndingPose
		jsr	(Create_New_Sprite).l
		bne.s	locret_86930
		move.l	#Obj_LevelResults,(a1)

locret_86930:

		rts
; End of function sub_868F8


; =============== S U B R O U T I N E =======================================


Check_TailsEndPose:

		tst.b	($FFFFFAA8).w
		beq.w	locret_8661C
		cmpi.b	#3,($FFFFFE10).w
		bne.s	loc_8694A
		lea	($FFFFB000).w,a1
		bsr.w	Set_PlayerEndingPose

loc_8694A:
		btst	#7,$38(a0)
		bne.w	locret_8661C
		lea	($FFFFB04A).w,a1
		btst	#7,$2A(a1)
		bne.w	locret_8661C
		btst	#1,$2A(a1)
		bne.w	locret_8661C
		cmpi.b	#6,5(a1)
		bcc.w	locret_8661C
		bset	#7,$38(a0)
		clr.b	($FFFFF7CB).w
		jmp	Set_PlayerEndingPose(pc)
; End of function Check_TailsEndPose


; =============== S U B R O U T I N E =======================================


sub_86984:
		subq.w	#1,$2E(a0)
		bpl.s	locret_869C4
		lea	($FFFFB000).w,a1
		cmpi.b	#6,5(a1)
		bcc.s	locret_869C4
		tst.b	4(a1)
		bpl.s	locret_869C4
		cmpi.b	#1,$38(a1)
		beq.s	loc_869AA
		tst.b	($FFFFF73E).w
		beq.s	locret_869C4

loc_869AA:
		move.w	#-$100,$18(a0)
		move.b	d0,5(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_869C2
		move.l	#Obj_LevelResults,(a1)

loc_869C2:
		moveq	#1,d0

locret_869C4:

		rts
; End of function sub_86984


; =============== S U B R O U T I N E =======================================


Set_PlayerEndingPose:

		move.b	#-$7F,$2E(a1)
		move.b	#$13,$20(a1)
		clr.b	$3D(a1)
		clr.w	$18(a1)
		clr.w	$1A(a1)
		clr.w	$1C(a1)
		bclr	#5,$2A(a0)
		bclr	#6,$2A(a0)
		bclr	#5,$2A(a1)
		rts
; End of function Set_PlayerEndingPose


; =============== S U B R O U T I N E =======================================


sub_869F6:
		move.w	d2,d5
		move.w	$10(a1),d6
		add.w	d3,d6
		cmp.w	$10(a0),d6
		bcc.s	loc_86A06
		neg.w	d2

loc_86A06:
		move.w	$18(a0),d6
		add.w	d2,d6
		cmp.w	d0,d6
		bgt.s	loc_86A1A
		neg.w	d0
		cmp.w	d0,d6
		blt.s	loc_86A1A
		move.w	d6,$18(a0)

loc_86A1A:

		move.w	$14(a1),d6
		add.w	d4,d6
		cmp.w	$14(a0),d6
		bcc.s	loc_86A28
		neg.w	d5

loc_86A28:
		move.w	$1A(a0),d6
		add.w	d5,d6
		cmp.w	d1,d6
		bgt.s	locret_86A3C
		neg.w	d1
		cmp.w	d1,d6
		blt.s	loc_86A1A
		move.w	d6,$1A(a0)

locret_86A3C:
		rts
; End of function sub_869F6


; =============== S U B R O U T I N E =======================================


sub_86A3E:

		move.w	#$1B,d1
		move.w	#4,d2
		move.w	#6,d3
		move.w	$10(a0),d4
		jmp	(SolidObjectFull).l
; End of function sub_86A3E


; =============== S U B R O U T I N E =======================================


sub_86A54:

		moveq	#5,d2
		moveq	#$1B,d1
		moveq	#9,d3
		move.w	$10(a0),d4
		jmp	(SolidObjectFull).l
; End of function sub_86A54


; =============== S U B R O U T I N E =======================================


sub_86A64:

		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		move.b	byte_86A74(pc,d0.w),$22(a0)
		rts
; End of function sub_86A64

; ---------------------------------------------------------------------------
byte_86A74:	dc.b 2
		dc.b 3
		dc.b $A
		dc.b 4
		dc.b $B
		dc.b 0

; =============== S U B R O U T I N E =======================================


sub_86A7A:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,d1
		andi.w	#6,d0
		lea	word_86B0E(pc),a1
		move.w	(a1,d0.w),d2
		move.w	d2,$1A(a0)
		move.w	d2,$3E(a0)
		movea.w	$46(a0),a1
		btst	#1,4(a1)
		beq.s	loc_86AB0
		move.l	#loc_8689C,(a0)
		addq.b	#8,$43(a0)
		clr.w	$1A(a0)

loc_86AB0:
		andi.w	#2,d0
		move.w	d0,d2
		cmpi.w	#$400,($FFFFFE10).w
		bne.s	loc_86AC0
		addq.w	#4,d2

loc_86AC0:
		move.w	word_86B16(pc,d2.w),$A(a0)
		moveq	#0,d2
		move.b	($FFFFFE10).w,d2
		add.w	d2,d2
		lea	(byte_2C7BA).l,a1
		adda.w	d2,a1
		lsr.w	#1,d0
		move.b	(a1,d0.w),d0
		lsl.w	#3,d0
		lea	(word_2C7EA).l,a2
		move.l	4(a2,d0.w),$C(a0)
		lsl.w	#2,d1
		move.w	d1,$2E(a0)
		movea.w	$46(a0),a1
		move.w	$10(a0),d0
		move.w	#$200,d1
		cmp.w	$10(a1),d0
		bcc.s	loc_86B04
		neg.w	d1

loc_86B04:
		move.w	d1,$18(a0)
		bsr.w	sub_86B1E
		rts
; End of function sub_86A7A

; ---------------------------------------------------------------------------
word_86B0E:	dc.w  $FC80, $FD00, $FD80, $FE00
word_86B16:	dc.w  $8580, $8592, $842E, $8440

; =============== S U B R O U T I N E =======================================


sub_86B1E:

		bclr	#0,4(a0)
		tst.w	$18(a0)
		bpl.s	locret_86B30
		bset	#0,4(a0)

locret_86B30:
		rts
; End of function sub_86B1E

; ---------------------------------------------------------------------------
ObjDat3_86B32:	dc.l Map_EggCapsule
		dc.w $8494
		dc.w $200
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b 0
word_86B3E:	dc.w $200

		dc.b $10
		dc.b 8
		dc.b 5
		dc.b 0
ObjDat3_86B44:	dc.l Map_EggCapsule
		dc.w $8494
		dc.w $180
		dc.b $C
		dc.b $C
		dc.b 0
		dc.b 0
word_86B50:	dc.w $280
		dc.b 8
		dc.b 8
		dc.b 2
		dc.b 0
word_86B56:	dc.w $200
		dc.b $14
		dc.b 4
		dc.b 6
		dc.b 0
ChildObjDat_86B5C:dc.w 0
		dc.l loc_8671C
		dc.w $DC
ChildObjDat_86B64:dc.w 0
		dc.l loc_8675C
		dc.w $24
ChildObjDat_86B6C:dc.w 1
		dc.l loc_86802
		dc.w $ECDC
		dc.l loc_86802
		dc.w $14DC
ChildObjDat_86B7A:dc.w 4

		dc.l loc_867D6
		dc.w $F8
		dc.l loc_867D6
		dc.w $F0F8
		dc.l loc_867D6
		dc.w $10F8
		dc.l loc_867D6
		dc.w $E8F8
		dc.l loc_867D6
		dc.w $18F8
ChildObjDat_86B9A:dc.w 8
		dc.l loc_86820
		dc.w $FC
		dc.l loc_86820
		dc.w $F8FC
		dc.l loc_86820
		dc.w $8FC
		dc.l loc_86820
		dc.w $10FC
		dc.l loc_86820
		dc.w $F0FC
		dc.l loc_86820
		dc.w $E8FC
		dc.l loc_86820
		dc.w $18FC
		dc.l loc_86820
		dc.w $FCFC
		dc.l loc_86820
		dc.w $4FC
		dc.l loc_86820
		dc.w $CFC
		dc.l loc_86820
		dc.w $F4FC
		dc.l loc_86820
		dc.w $ECFC
		dc.l loc_86820
		dc.w $14FC
		dc.l loc_86820
		dc.w $1CFC
		dc.l loc_86820
		dc.w $E4FC
byte_86BF6:	dc.b 0
		dc.b 6
		dc.b 7
		dc.b 8
		dc.b 9
		dc.b $FC
Map_EggCapsule:	include "General\Sprites\Robotnik\Map - Egg Capsule.asm"

; ---------------------------------------------------------------------------

Obj_8A:

		move.l	#Sprite_OnScreen_Test,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		movea.l	off_86D12(pc,d0.w),a1
		move.l	#byte_86D2A,$C(a0)
		jmp	SetUp_ObjAttributes2(pc)
; ---------------------------------------------------------------------------
off_86D12:	dc.l word_86D1A
		dc.l word_86D22
word_86D1A:	dc.w $43E5
		dc.w 0
		dc.b 8
		dc.b $20
		dc.b 0
		dc.b 0
word_86D22:	dc.w $43F4
		dc.w $280
		dc.b 8
		dc.b $18
		dc.b 1
		dc.b 0
byte_86D2A:	dc.b	0,   4
		dc.b	0, $12
		dc.b	0,   2
		dc.b  $E0,   7
		dc.b	0,   7
		dc.b  $FF, $F8
		dc.b	0,   7
		dc.b  $10,   7
		dc.b  $FF, $F8
		dc.b	0,   2
		dc.b  $E8,   6
		dc.b	0,   0
		dc.b  $FF, $F8
		dc.b	0,   6
		dc.b	0,   6
		dc.b  $FF, $F8
; ---------------------------------------------------------------------------

loc_86D4A:

		movea.l	$3E(a0),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_86D5E,(a0)
		bset	#3,$2B(a0)

loc_86D5E:

		movea.l	$34(a0),a1
		jsr	(a1)
		jmp	(Sprite_CheckDeleteTouchXY).l
; ---------------------------------------------------------------------------

Obj_Tulipon:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_86D84(pc,d0.w),d1
		jsr	off_86D84(pc,d1.w)
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------
off_86D84:	dc.w loc_86D8A-off_86D84

		dc.w loc_86DA2-off_86D84
		dc.w loc_86DC6-off_86D84
; ---------------------------------------------------------------------------

loc_86D8A:
		lea	ObjDat3_86E12(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.w	#$1F,$2E(a0)
		move.l	#loc_86DAE,$34(a0)

locret_86DA0:

		rts
; ---------------------------------------------------------------------------

loc_86DA2:
		tst.b	4(a0)
		bpl.w	locret_86DA0
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_86DAE:

		move.b	#4,5(a0)
		move.l	#byte_86E42,$30(a0)
		move.l	#loc_86DFC,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_86DC6:
		jsr	Animate_RawMultiDelay(pc)
		beq.s	locret_86DA0
		cmpi.b	#6,d0
		beq.s	loc_86DD8
		cmpi.b	#$E,d0
		bne.s	locret_86DA0

loc_86DD8:
		moveq	#$4D,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_86E2A(pc),a2
		jsr	CreateChild2_Complex(pc)
		bne.s	locret_86DFA
		addq.b	#1,$39(a0)
		btst	#0,$39(a0)
		beq.s	locret_86DFA
		neg.w	$18(a1)

locret_86DFA:

		rts
; ---------------------------------------------------------------------------

loc_86DFC:
		move.b	#2,5(a0)
		move.w	#$78,$2E(a0)
		move.l	#loc_86DAE,$34(a0)
		rts
; ---------------------------------------------------------------------------
ObjDat3_86E12:	dc.l Map_Tulipon
		dc.w $252A
		dc.w $200
		dc.b $C
		dc.b $18
		dc.b 0
		dc.b $23
ObjDat3_86E1E:	dc.l Map_Tulipon
		dc.w $252A
		dc.w $280
		dc.b 8
		dc.b 8
		dc.b 4
		dc.b $98
ChildObjDat_86E2A:dc.w 0
		dc.l loc_86D4A
		dc.l ObjDat3_86E1E
		dc.l 0
		dc.l MoveSprite
		dc.b 0
		dc.b $F0
		dc.w $100
		dc.w $FB00
byte_86E42:	dc.b	0,   7
		dc.b	1,   9
		dc.b	2,   4
		dc.b	3,   4
		dc.b	0,   9
		dc.b	1,   9
		dc.b	2,   4
		dc.b	3,   4
		dc.b	0,   0
		dc.b  $F4,   0
; ---------------------------------------------------------------------------

Obj_RhinoBot:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_86E76(pc,d0.w),d1
		jsr	off_86E76(pc,d1.w)
		lea	DPLCPtr_87132(pc),a2
		jsr	Perform_DPLC(pc)
		jmp	Sprite_CheckDeleteTouchSlotted(pc)
; ---------------------------------------------------------------------------
off_86E76:	dc.w loc_86E7E-off_86E76

		dc.w loc_86EC4-off_86E76
		dc.w loc_86EEA-off_86E76
		dc.w loc_86EEE-off_86E76
; ---------------------------------------------------------------------------

loc_86E7E:
		lea	ObjDat4_870FE(pc),a1
		jsr	SetUp_ObjAttributesSlotted(pc)
		move.b	#8,$1F(a0)
		move.b	#$10,$1E(a0)
		move.w	#-$10,d0
		move.w	#-$300,d1
		btst	#0,4(a0)
		beq.s	loc_86EB2
		neg.w	d0
		neg.w	d1
		bset	#3,$38(a0)
		bset	#2,$38(a0)

loc_86EB2:
		move.w	d0,$40(a0)
		move.w	d1,$3E(a0)
		move.l	#loc_86F40,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_86EC4:
		lea	loc_86F92(pc),a3
		bsr.w	sub_870A4
		lea	loc_86F74(pc),a3
		bsr.w	sub_870CA
		move.w	$40(a0),d0
		add.w	d0,$18(a0)
		jsr	(MoveSprite2).l
		bsr.w	sub_86FF8
		bra.w	loc_8701C
; ---------------------------------------------------------------------------

loc_86EEA:
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_86EEE:
		lea	loc_86FE8(pc),a3
		bsr.w	sub_870CA
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_86EFC:

		cmpi.w	#1,($FFFFFE10).w
		beq.s	loc_86F26
		jsr	Refresh_ChildPositionAdjusted(pc)
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_86F22(pc,d0.w),d1
		jsr	off_86F22(pc,d1.w)
		lea	DPLCPtr_87132(pc),a2
		jsr	Perform_DPLC(pc)
		jmp	Child_Remember_Draw_Sprite(pc)
; ---------------------------------------------------------------------------
off_86F22:	dc.w loc_86F2C-off_86F22

		dc.w loc_86F3C-off_86F22
; ---------------------------------------------------------------------------

loc_86F26:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_86F2C:
		lea	ObjDat4_87110(pc),a1
		jsr	SetUp_ObjAttributesSlotted(pc)
		move.l	#Go_Delete_SpriteSlotted3,$34(a0)

loc_86F3C:
		jmp	Animate_Raw(pc)
; ---------------------------------------------------------------------------

loc_86F40:

		bchg	#2,$38(a0)
		move.l	#loc_86F58,$34(a0)
		neg.w	$40(a0)
		neg.w	$3E(a0)
		rts
; ---------------------------------------------------------------------------

loc_86F58:

		bchg	#3,$38(a0)
		bchg	#0,4(a0)
		bclr	#1,$38(a0)
		move.l	#loc_86F40,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_86F74:

		bclr	#2,$38(a0)
		btst	#3,$38(a0)
		bne.s	loc_86F88
		bset	#2,$38(a0)

loc_86F88:
		clr.w	$18(a0)
		clr.w	$1A(a0)
		bra.s	loc_86F58
; ---------------------------------------------------------------------------

loc_86F92:
		move.b	#4,5(a0)
		move.b	#0,$22(a0)
		move.w	#$20,$2E(a0)
		move.l	#loc_86FCE,$34(a0)
		bset	#1,$38(a0)
		moveq	#$48,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_8712A(pc),a2
		jsr	CreateChild1_Normal(pc)
		bne.s	locret_86FCC
		move.l	#byte_8714A,$30(a1)

locret_86FCC:
		rts
; ---------------------------------------------------------------------------

loc_86FCE:
		move.b	#6,5(a0)
		move.w	#$400,d0
		btst	#3,$38(a0)
		bne.s	loc_86FE2
		neg.w	d0

loc_86FE2:
		move.w	d0,$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_86FE8:
		move.b	#2,5(a0)
		move.b	#0,$22(a0)
		bra.w	loc_86F74

; =============== S U B R O U T I N E =======================================


sub_86FF8:
		move.w	$18(a0),d0
		beq.s	loc_87016
		btst	#2,$38(a0)
		beq.s	loc_8700E
		cmp.w	$3E(a0),d0
		bge.s	loc_87016
		rts
; ---------------------------------------------------------------------------

loc_8700E:
		cmp.w	$3E(a0),d0
		ble.s	loc_87016
		rts
; ---------------------------------------------------------------------------

loc_87016:

		movea.l	$34(a0),a1
		jmp	(a1)
; End of function sub_86FF8

; ---------------------------------------------------------------------------

loc_8701C:
		moveq	#0,d1
		btst	#3,$38(a0)
		beq.s	loc_87054
		btst	#2,$38(a0)
		beq.s	loc_8703C
		cmpi.w	#$80,$18(a0)
		bgt.s	loc_8707E
		moveq	#1,d1
		bra.w	loc_8707E
; ---------------------------------------------------------------------------

loc_8703C:
		moveq	#1,d1
		cmpi.w	#$280,$18(a0)
		bgt.s	loc_8707E
		moveq	#2,d1
		bset	#1,$38(a0)
		beq.s	loc_87084
		bra.w	loc_8707E
; ---------------------------------------------------------------------------

loc_87054:
		btst	#2,$38(a0)
		bne.s	loc_8706A
		cmpi.w	#-$80,$18(a0)
		ble.s	loc_8707E
		moveq	#1,d1
		bra.w	loc_8707E
; ---------------------------------------------------------------------------

loc_8706A:
		moveq	#1,d1
		cmpi.w	#-$280,$18(a0)
		ble.s	loc_8707E
		moveq	#2,d1
		bset	#1,$38(a0)
		beq.s	loc_87084

loc_8707E:

		move.b	d1,$22(a0)
		rts
; ---------------------------------------------------------------------------

loc_87084:

		move.b	d1,$22(a0)
		moveq	#$48,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_87122(pc),a2
		jsr	CreateChild1_Normal(pc)
		bne.s	locret_870A2
		move.l	#byte_8713A,$30(a1)

locret_870A2:
		rts

; =============== S U B R O U T I N E =======================================


sub_870A4:
		jsr	Find_SonicTails(pc)
		cmpi.w	#$20,d3
		bhi.s	locret_870C2
		cmpi.w	#$60,d2
		bhi.s	locret_870C2
		btst	#3,$38(a0)
		bne.s	loc_870BE
		subq.w	#2,d0

loc_870BE:
		tst.w	d0
		bne.s	loc_870C4

locret_870C2:
		rts
; ---------------------------------------------------------------------------

loc_870C4:
		jsr	(a3)
		addq.w	#4,sp
		rts
; End of function sub_870A4


; =============== S U B R O U T I N E =======================================


sub_870CA:

		moveq	#4,d0
		btst	#3,$38(a0)
		bne.s	loc_870D6
		neg.w	d0

loc_870D6:
		move.w	$10(a0),d3
		add.w	d0,d3
		move.l	a3,-(sp)
		jsr	(ObjHitFloor2).l
		movea.l	(sp)+,a3
		cmpi.w	#-1,d1
		blt.s	loc_870F8
		cmpi.w	#$C,d1
		bge.s	loc_870F8
		add.w	d1,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_870F8:

		jsr	(a3)
		addq.w	#4,sp
		rts
; End of function sub_870CA

; ---------------------------------------------------------------------------
ObjDat4_870FE:	dc.w 1
		dc.w $2500
		dc.w $15
		dc.w 0
		dc.l Map_RhinoBot
		dc.w $280
		dc.b $14
		dc.b $10
		dc.b 0
		dc.b $B
ObjDat4_87110:	dc.w 1
		dc.w $44A
		dc.w 6
		dc.w 2
		dc.l Map_RhinoBot
		dc.w $200
		dc.b $C
		dc.b 8
		dc.b 4
		dc.b 0
ChildObjDat_87122:dc.w 0
		dc.l loc_86EFC
		dc.w $C08
ChildObjDat_8712A:dc.w 0
		dc.l loc_86EFC
		dc.w $1008
DPLCPtr_87132:	dc.l ArtUnc_AIZRhino

		dc.l DPLC_RhinoBot
byte_8713A:	dc.b	2,   4
		dc.b	4,   5
		dc.b	6,   7
		dc.b	4,   5
		dc.b	6,   7
		dc.b	4,   5
		dc.b	6,   7
		dc.b  $F4,   0
byte_8714A:	dc.b	2,   4
		dc.b	4,   5
		dc.b	6,   7
		dc.b	4,   5
		dc.b	6,   7
		dc.b  $F4,   0
; ---------------------------------------------------------------------------

Obj_MonkeyDude:

		jsr	Obj_WaitOffscreen(pc)
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8716C(pc,d0.w),d1
		jsr	off_8716C(pc,d1.w)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------
off_8716C:	dc.w loc_87172-off_8716C

		dc.w loc_871BC-off_8716C
		dc.w loc_871DA-off_8716C
; ---------------------------------------------------------------------------

loc_87172:
		lea	ObjDat3_8765A(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#2,d0
		move.b	d0,$2C(a0)
		lsr.w	#1,d0
		move.b	d0,$39(a0)
		move.l	#byte_876B4,$30(a0)
		move.w	#$3B,$2E(a0)
		move.l	#loc_871C2,$34(a0)
		btst	#0,4(a0)
		bne.w	loc_871B4
		lea	ChildObjDat_87680(pc),a2
		jmp	CreateChild4_LinkListRepeated(pc)
; ---------------------------------------------------------------------------

loc_871B4:
		lea	ChildObjDat_87686(pc),a2
		jmp	CreateChild4_LinkListRepeated(pc)
; ---------------------------------------------------------------------------

loc_871BC:
		jmp	(loc_85652).l
; ---------------------------------------------------------------------------

loc_871C2:
		move.b	#4,5(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		move.l	#byte_876B8,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_871DA:
		jsr	Animate_RawMultiDelay(pc)
		tst.w	d2
		beq.s	locret_87202
		btst	#2,$38(a0)
		bne.s	loc_87204
		cmpi.b	#0,$22(a0)
		bne.s	locret_87202
		addq.w	#8,$14(a0)
		subq.b	#1,$39(a0)
		cmpi.b	#1,$39(a0)
		beq.s	loc_87218

locret_87202:

		rts
; ---------------------------------------------------------------------------

loc_87204:
		cmpi.b	#2,$22(a0)
		bne.s	locret_87202
		subq.b	#1,$39(a0)
		beq.s	loc_87218
		subq.w	#8,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_87218:

		move.b	#2,5(a0)
		move.b	$2C(a0),$39(a0)
		bchg	#2,$38(a0)
		move.w	#$3B,$2E(a0)
		move.l	#byte_876B4,$30(a0)
		move.b	#0,$22(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_87248:
		bset	#3,$38(a0)

loc_8724E:

		lea	word_87666(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		clr.b	5(a0)
		move.b	$2C(a0),d0
		add.b	d0,d0
		move.b	d0,$3B(a0)
		move.b	d0,$3A(a0)
		tst.b	$2C(a0)
		bne.s	loc_87292
		move.l	#loc_872CC,(a0)
		moveq	#$E,d0
		btst	#3,$38(a0)
		bne.s	loc_87280
		neg.w	d0

loc_87280:
		add.w	d0,$10(a0)
		subq.w	#2,$14(a0)
		move.w	$14(a0),$3E(a0)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_87292:
		cmpi.b	#8,$2C(a0)
		beq.s	loc_872A4
		move.l	#loc_8741C,(a0)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_872A4:
		move.l	#loc_8744C,(a0)
		move.b	#6,$22(a0)
		movea.w	$46(a0),a1
		movea.w	$46(a1),a1
		move.w	a1,$3E(a0)
		movea.w	$46(a1),a1
		movea.w	$46(a1),a1
		move.w	a1,$44(a0)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_872CC:
		bsr.w	sub_87500
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_872E2(pc,d0.w),d1
		jsr	off_872E2(pc,d1.w)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------
off_872E2:	dc.w loc_872EE-off_872E2

		dc.w loc_8732A-off_872E2
		dc.w loc_87382-off_872E2
		dc.w loc_873B4-off_872E2
		dc.w loc_873EA-off_872E2
		dc.w loc_87330-off_872E2
; ---------------------------------------------------------------------------

loc_872EE:
		move.b	$3C(a0),d0
		btst	#3,$38(a0)
		beq.s	loc_87308
		addq.b	#4,d0
		cmpi.b	#-$80,d0
		bcc.s	loc_87316
		move.b	d0,$3C(a0)
		rts
; ---------------------------------------------------------------------------

loc_87308:
		subq.b	#4,d0
		cmpi.b	#-$80,d0
		bls.s	loc_87316
		move.b	d0,$3C(a0)
		rts
; ---------------------------------------------------------------------------

loc_87316:

		move.b	#2,5(a0)

loc_8731C:
		bsr.w	sub_87638
		move.l	#loc_87370,$34(a0)

locret_87328:

		rts
; ---------------------------------------------------------------------------

loc_8732A:
		bsr.w	sub_87524
		beq.s	loc_87374

loc_87330:
		btst	#3,$38(a0)
		beq.s	loc_8734E
		move.b	$41(a0),d1
		bsr.w	sub_87540
		subi.b	#$20,d0
		cmpi.b	#$60,d0
		bcc.s	loc_87360
		bra.w	loc_8736C
; ---------------------------------------------------------------------------

loc_8734E:
		move.b	$41(a0),d1
		bsr.w	sub_87540
		subi.b	#-$80,d0
		cmpi.b	#$60,d0
		bcs.s	loc_8736C

loc_87360:
		neg.w	$40(a0)
		move.b	$41(a0),d1
		bsr.w	sub_87540

loc_8736C:

		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_87370:
		bra.w	sub_87638
; ---------------------------------------------------------------------------

loc_87374:
		move.b	#4,5(a0)
		bset	#1,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_87382:
		btst	#3,$38(a0)
		beq.s	loc_87398
		moveq	#4,d1
		bsr.w	sub_87540
		cmpi.b	#-$40,d0
		bcc.s	loc_873A6
		rts
; ---------------------------------------------------------------------------

loc_87398:
		moveq	#-4,d1
		bsr.w	sub_87540
		cmpi.b	#$40,d0
		bls.s	loc_873A6
		rts
; ---------------------------------------------------------------------------

loc_873A6:

		move.b	#6,5(a0)
		bset	#2,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_873B4:
		btst	#3,$38(a0)
		beq.s	loc_873CA
		moveq	#-8,d1
		bsr.w	sub_87540
		moveq	#$60,d1
		cmp.b	d1,d0
		bls.s	loc_873D8
		rts
; ---------------------------------------------------------------------------

loc_873CA:
		moveq	#8,d1
		bsr.w	sub_87540
		moveq	#-$60,d1
		cmp.b	d1,d0
		bcc.s	loc_873D8
		rts
; ---------------------------------------------------------------------------

loc_873D8:

		move.b	#8,5(a0)
		move.b	d1,$3C(a0)
		bclr	#1,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_873EA:
		btst	#3,$38(a0)
		bne.s	loc_87400
		moveq	#-2,d1
		bsr.w	sub_87540
		moveq	#-$80,d1
		cmp.b	d1,d0
		bls.s	loc_8740E
		rts
; ---------------------------------------------------------------------------

loc_87400:
		moveq	#2,d1
		bsr.w	sub_87540
		moveq	#-$80,d1
		cmp.b	d1,d0
		bcc.s	loc_8740E
		rts
; ---------------------------------------------------------------------------

loc_8740E:

		move.b	#$A,5(a0)
		move.b	d1,$3C(a0)
		bra.w	loc_8731C
; ---------------------------------------------------------------------------

loc_8741C:
		bsr.w	sub_87518
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_87432(pc,d0.w),d1
		jsr	off_87432(pc,d1.w)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------
off_87432:	dc.w loc_87438-off_87432

		dc.w loc_87442-off_87432
		dc.w loc_8743E-off_87432
; ---------------------------------------------------------------------------

loc_87438:
		moveq	#2,d1
		bsr.w	sub_8756A

loc_8743E:
		bra.w	loc_8754C
; ---------------------------------------------------------------------------

loc_87442:
		moveq	#4,d1
		bsr.w	sub_87592
		bra.w	loc_8754C
; ---------------------------------------------------------------------------

loc_8744C:
		bsr.w	sub_87518
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_87462(pc,d0.w),d1
		jsr	off_87462(pc,d1.w)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------
off_87462:	dc.w loc_87468-off_87462

		dc.w loc_87472-off_87462
		dc.w loc_8746E-off_87462
; ---------------------------------------------------------------------------

loc_87468:
		moveq	#2,d1
		bsr.w	sub_8756A

loc_8746E:
		bra.w	loc_8754C
; ---------------------------------------------------------------------------

loc_87472:
		bsr.w	sub_875B4
		moveq	#4,d1
		bsr.w	sub_87592
		bra.w	loc_8754C
; ---------------------------------------------------------------------------

loc_87480:
		lea	word_8766C(pc),a1
		jsr	SetUp_ObjAttributes2(pc)
		move.l	#loc_874B6,(a0)
		move.l	#byte_876BD,$30(a0)
		move.l	#loc_874CA,$34(a0)
		move.b	#8,$1E(a0)
		move.w	#-$200,$18(a0)
		move.w	#-$400,$1A(a0)
		jmp	(loc_1B662).l
; ---------------------------------------------------------------------------

loc_874B6:
		jsr	(MoveSprite_LightGravity).l
		jsr	Animate_RawMultiDelay(pc)
		jsr	ObjHitFloor_DoRoutine(pc)
		jmp	(loc_1B662).l
; ---------------------------------------------------------------------------

loc_874CA:
		move.l	#loc_874D2,(a0)
		rts
; ---------------------------------------------------------------------------

loc_874D2:
		jmp	(loc_1B662).l
; ---------------------------------------------------------------------------
		movea.w	$46(a0),a1
		move.b	4(a1),d0
		btst	#3,$38(a0)
		beq.s	loc_874EC
		bchg	#0,d0

loc_874EC:
		move.w	#$200,8(a0)
		btst	#0,d0
		beq.s	locret_874FE
		move.w	#$300,8(a0)

locret_874FE:
		rts

; =============== S U B R O U T I N E =======================================


sub_87500:
		movea.w	$46(a0),a1
		move.w	$14(a1),d0
		subq.w	#2,d0
		tst.b	$22(a1)
		beq.s	loc_87512
		subq.w	#2,d0

loc_87512:
		move.w	d0,$14(a0)
		rts
; End of function sub_87500


; =============== S U B R O U T I N E =======================================


sub_87518:

		movea.w	$46(a0),a1
		move.w	8(a1),8(a0)
		rts
; End of function sub_87518


; =============== S U B R O U T I N E =======================================


sub_87524:
		jsr	Find_SonicTails(pc)
		cmpi.w	#$80,d2
		bcc.s	loc_8753C
		btst	#3,$38(a0)
		beq.s	loc_87538
		subq.w	#2,d0

loc_87538:
		tst.w	d0
		rts
; ---------------------------------------------------------------------------

loc_8753C:
		moveq	#1,d4
		rts
; End of function sub_87524


; =============== S U B R O U T I N E =======================================


sub_87540:

		move.b	$3C(a0),d0
		add.b	d1,d0
		move.b	d0,$3C(a0)
		rts
; End of function sub_87540

; ---------------------------------------------------------------------------

loc_8754C:

		subq.b	#1,$3B(a0)
		bne.s	loc_87562
		move.b	$3A(a0),$3B(a0)
		movea.w	$46(a0),a1
		move.b	$3C(a1),$3C(a0)

loc_87562:
		moveq	#5,d2
		jsr	MoveSprite_CircularSimple(pc)
		rts

; =============== S U B R O U T I N E =======================================


sub_8756A:

		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		beq.s	locret_87590
		move.b	d1,5(a0)
		bset	#1,$38(a0)
		move.b	$3A(a0),d0
		lsr.b	#1,d0
		move.b	d0,$3A(a0)
		move.b	#1,$3B(a0)

locret_87590:
		rts
; End of function sub_8756A


; =============== S U B R O U T I N E =======================================


sub_87592:

		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		bne.s	locret_875B2
		move.b	d1,5(a0)
		move.b	$3A(a0),d0
		add.b	d0,d0
		move.b	d0,$3A(a0)
		move.b	#1,$3B(a0)

locret_875B2:
		rts
; End of function sub_87592


; =============== S U B R O U T I N E =======================================


sub_875B4:
		btst	#3,$38(a0)
		beq.s	loc_875E0
		btst	#0,$38(a0)
		bne.w	locret_87328
		movea.w	$44(a0),a1
		btst	#2,$38(a1)
		beq.s	locret_875DE
		movea.w	$3E(a0),a1
		cmpi.b	#-$7C,$3C(a1)
		bcs.s	loc_8760A

locret_875DE:

		rts
; ---------------------------------------------------------------------------

loc_875E0:
		btst	#0,$38(a0)
		bne.w	locret_87328
		movea.w	$44(a0),a1
		btst	#2,$38(a1)
		beq.s	locret_875DE
		movea.w	$3E(a0),a1
		cmpi.b	#$7C,$3C(a1)
		bcs.w	locret_87328
		move.w	#$2548,$A(a0)

loc_8760A:
		bset	#0,$38(a0)
		move.b	#4,$22(a0)
		moveq	#$51,d0
		jsr	(Play_Sound_2).l
		lea	(ChildObjDat_8769C).l,a2
		jsr	CreateChild2_Complex(pc)
		bne.s	locret_875DE
		btst	#3,$38(a0)
		beq.s	locret_875DE
		neg.w	$18(a1)
		rts
; End of function sub_875B4


; =============== S U B R O U T I N E =======================================


sub_87638:

		jsr	(Random_Number).l
		move.w	($FFFFF636).w,d0
		moveq	#1,d1
		btst	#0,d0
		beq.s	loc_8764C
		neg.w	d1

loc_8764C:
		move.w	d1,$40(a0)
		andi.w	#$3C,d0
		move.w	d0,$2E(a0)
		rts
; End of function sub_87638

; ---------------------------------------------------------------------------
ObjDat3_8765A:	dc.l Map_MonkeyDude
		dc.w $2548
		dc.w $280
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b $B
word_87666:	dc.w $300
		dc.b 4
		dc.b 4
		dc.b 3
		dc.b 0
word_8766C:	dc.w $A548
		dc.w $280
		dc.b $20
		dc.b $20
		dc.b 6
		dc.b $B
ObjDat3_87674:	dc.l Map_MonkeyDude
		dc.w $548
		dc.w $280
		dc.b $20
		dc.b $20
		dc.b 6
		dc.b $98
ChildObjDat_87680:dc.w 4
		dc.l loc_8724E
ChildObjDat_87686:dc.w 4
		dc.l loc_87248
		dc.w 0
		dc.l loc_8724E
		dc.w 8
		dc.w 0
		dc.l loc_87480
		dc.w 0
ChildObjDat_8769C:dc.w 0
		dc.l loc_86D4A
		dc.l ObjDat3_87674
		dc.w 0
		dc.w 0
		dc.l MoveSprite_LightGravity
		dc.w 0
		dc.w $FE00
		dc.w $FC00
byte_876B4:	dc.b	7,   0

		dc.b	1, $FC
byte_876B8:	dc.b	0,   7
		dc.b	2,   7
		dc.b  $FC
byte_876BD:	dc.b	8,  $F
		dc.b	8,  $F
		dc.b	9,  $F
		dc.b   $A,  $F
		dc.b  $F8,  $A
		dc.b	6, $7E
		dc.b  $FC
; ---------------------------------------------------------------------------

Obj_CaterKillerJr:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_876E2(pc,d0.w),d1
		jsr	off_876E2(pc,d1.w)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------
off_876E2:	dc.w loc_876EC-off_876E2

		dc.w loc_87728-off_876E2
		dc.w loc_87728-off_876E2
		dc.w loc_87758-off_876E2
		dc.w loc_8777A-off_876E2
; ---------------------------------------------------------------------------

loc_876EC:
		lea	ObjDat3_87862(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.w	#-$100,$18(a0)
		lea	ChildObjDat_87898(pc),a2
		jsr	CreateChild3_NormalRepeated(pc)

loc_87702:

		move.b	#4,5(a0)
		move.b	#3,$39(a0)
		move.w	#$80,d0
		move.w	d0,$3E(a0)
		move.w	d0,$1A(a0)
		move.w	#8,$40(a0)
		bclr	#0,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_87728:

		jsr	Swing_UpAndDown_Count(pc)
		bne.s	loc_87738
		jsr	(MoveSprite2).l
		bra.w	loc_8783E
; ---------------------------------------------------------------------------

loc_87738:
		move.b	#6,5(a0)
		move.w	#$100,d0
		move.w	d0,$3E(a0)
		move.w	d0,$1A(a0)
		move.w	#8,$40(a0)
		bclr	#0,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_87758:

		jsr	Swing_UpAndDown(pc)
		tst.w	d3
		beq.s	loc_87770
		move.b	#8,5(a0)
		neg.w	$18(a0)
		bchg	#0,4(a0)

loc_87770:
		jsr	(MoveSprite2).l
		bra.w	loc_8783E
; ---------------------------------------------------------------------------

loc_8777A:

		jsr	Swing_UpAndDown(pc)
		tst.w	d3
		bne.s	loc_87702
		jsr	(MoveSprite2).l
		bra.w	loc_8783E
; ---------------------------------------------------------------------------

loc_8778C:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_877A2(pc,d0.w),d1
		jsr	off_877A2(pc,d1.w)
		moveq	#0,d0
		jmp	(Child_DrawTouch_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------
off_877A2:	dc.w loc_877AC-off_877A2

		dc.w loc_877D8-off_877A2
		dc.w loc_87728-off_877A2
		dc.w loc_87758-off_877A2
		dc.w loc_8777A-off_877A2
; ---------------------------------------------------------------------------

loc_877AC:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	off_877C6(pc,d0.w),d1
		lea	off_877C6(pc,d1.w),a1
		lsr.w	#1,d0
		move.b	byte_877D2(pc,d0.w),$2F(a0)
		jmp	SetUp_ObjAttributes(pc)
; ---------------------------------------------------------------------------
off_877C6:	dc.w ObjDat3_8786E-off_877C6

		dc.w ObjDat3_8786E-off_877C6
		dc.w ObjDat3_8786E-off_877C6
		dc.w ObjDat3_8787A-off_877C6
		dc.w ObjDat3_87886-off_877C6
		dc.w ObjDat3_87886-off_877C6
byte_877D2:	dc.b $B
		dc.b $17
		dc.b $23
		dc.b $2F
		dc.b $37
		dc.b $3F
; ---------------------------------------------------------------------------

loc_877D8:
		subq.w	#1,$2E(a0)
		bmi.s	loc_877E0
		rts
; ---------------------------------------------------------------------------

loc_877E0:
		move.b	#4,5(a0)
		moveq	#$40,d1
		moveq	#0,d0
		move.b	$2C(a0),d0
		addq.w	#2,d0
		lsl.w	#2,d0
		sub.w	d0,d1
		move.w	d1,$2E(a0)
		move.l	#loc_87854,$34(a0)
		move.w	#-$100,$18(a0)
		bra.w	loc_87702
; ---------------------------------------------------------------------------

loc_8780A:
		lea	word_87892(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_8782C,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		bset	#4,$2B(a0)
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8782C:
		jsr	Refresh_ChildPositionAdjusted(pc)
		lea	byte_878A8(pc),a1
		jsr	Animate_RawNoSSTMultiDelay(pc)
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8783E:

		cmpi.l	#loc_8778C,(a0)
		bne.s	locret_87852
		cmpi.b	#6,$2C(a0)
		bcc.s	locret_87852
		jsr	Obj_Wait(pc)

locret_87852:

		rts
; ---------------------------------------------------------------------------

loc_87854:
		move.w	#$1A,$2E(a0)
		lea	ChildObjDat_878A0(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------
ObjDat3_87862:	dc.l Map_CaterKillerJr
		dc.w $A55F
		dc.w $280
		dc.b 8
		dc.b 8
		dc.b 0
		dc.b $17
ObjDat3_8786E:	dc.l Map_CaterKillerJr
		dc.w $A55F
		dc.w $280
		dc.b 8
		dc.b $C
		dc.b 1
		dc.b $97
ObjDat3_8787A:	dc.l Map_CaterKillerJr
		dc.w $A55F
		dc.w $280
		dc.b 8
		dc.b 8
		dc.b 2
		dc.b $97
ObjDat3_87886:	dc.l Map_MonkeyDude
		dc.w $A548
		dc.w $280
		dc.b 4
		dc.b 4
		dc.b 3
		dc.b $98
word_87892:	dc.w $200
		dc.b $10
		dc.b $10
		dc.b 3
		dc.b 0
ChildObjDat_87898:dc.w 5
		dc.l loc_8778C
		dc.w 0
ChildObjDat_878A0:dc.w 0
		dc.l loc_8780A
		dc.w 0
byte_878A8:	dc.b	3,   2
		dc.b	3,   2
		dc.b	4,   3
		dc.b	5,   4
		dc.b  $F4,   0
; ---------------------------------------------------------------------------

Obj_Jawz:

		jsr	(Obj_WaitOffscreen).l
		lea	ObjDat3_87918(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_878CE,(a0)
		move.w	#-$200,d4
		jmp	Set_VelocityXTrackSonic(pc)
; ---------------------------------------------------------------------------

loc_878CE:
		jsr	(MoveSprite2).l
		lea	byte_87924(pc),a1
		jsr	Animate_RawNoSST(pc)
		moveq	#0,d0
		move.b	$29(a0),d0
		bne.s	loc_878E8
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------

loc_878E8:
		add.w	d0,d0
		movea.w	loc_8790C+4(pc,d0.w),a1
		jsr	(Check_PlayerAttack).l
		bne.s	loc_87904
		lea	(ChildObjDat_6BDB2).l,a2
		jsr	CreateChild1_Normal(pc)
		jmp	Go_Delete_Sprite(pc)
; ---------------------------------------------------------------------------

loc_87904:
		move.w	a1,$44(a0)
		jsr	EnemyDefeated(pc)

loc_8790C:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
		dc.w $B000
		dc.w $B04A
		dc.w $B04A
ObjDat3_87918:	dc.l Map_Jawz
		dc.w $A539
		dc.w $280
		dc.b $1C
		dc.b $C
		dc.b 0
		dc.b $D7
byte_87924:	dc.b 0
		dc.b 0
		dc.b 1
		dc.b $FC
; ---------------------------------------------------------------------------

Obj_Blastoid:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_87944(pc,d0.w),d1
		jsr	off_87944(pc,d1.w)
		bsr.w	sub_879A8
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------
off_87944:	dc.w loc_8794A-off_87944

		dc.w loc_87952-off_87944
		dc.w loc_87976-off_87944
; ---------------------------------------------------------------------------

loc_8794A:
		lea	ObjDat3_879E0(pc),a1
		jmp	SetUp_ObjAttributes(pc)
; ---------------------------------------------------------------------------

loc_87952:
		jsr	Find_SonicTails(pc)
		cmpi.w	#$80,d2
		bcs.s	loc_8795E
		rts
; ---------------------------------------------------------------------------

loc_8795E:
		move.b	#4,5(a0)
		move.l	#byte_87A10,$30(a0)
		move.l	#loc_879A0,$34(a0)

locret_87974:

		rts
; ---------------------------------------------------------------------------

loc_87976:
		jsr	Animate_RawMultiDelay(pc)
		tst.w	d2
		beq.s	locret_87974
		bmi.s	locret_87974
		cmpi.b	#1,$22(a0)
		bne.s	locret_87974
		tst.b	4(a0)
		bpl.w	locret_87974
		moveq	#$4D,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_879F8(pc),a2
		jmp	CreateChild5_ComplexAdjusted(pc)
; ---------------------------------------------------------------------------

loc_879A0:
		move.b	#2,5(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_879A8:
		jsr	Check_PlayerCollision(pc)
		beq.w	locret_87974
		jsr	Check_PlayerAttack(pc)
		bne.s	loc_879C4
		tst.b	$34(a1)
		bne.w	locret_87974
		jmp	(HurtSonic_Directly).l
; ---------------------------------------------------------------------------

loc_879C4:
		addq.w	#4,sp
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		lea	($FFFFF7E0).w,a3
		st	(a3,d0.w)
		jsr	EnemyDefeated(pc)
		jmp	(Draw_Sprite).l
; End of function sub_879A8

; ---------------------------------------------------------------------------
ObjDat3_879E0:	dc.l Map_Blastoid
		dc.w $A539
		dc.w $280
		dc.b $14
		dc.b $C
		dc.b 0
		dc.b $D7
ObjDat3_879EC:	dc.l Map_Blastoid
		dc.w $A539
		dc.w $280
		dc.b 4
		dc.b 4
		dc.b 2
		dc.b $98
ChildObjDat_879F8:dc.w 0
		dc.l loc_86D4A
		dc.l ObjDat3_879EC
		dc.l word_87A1F
		dc.l Move_AnimateRaw
		dc.b $EC
		dc.b $F9
		dc.w $FE00
		dc.w $FF00
byte_87A10:	dc.b	0, $7F
		dc.b	1,   4
		dc.b	0,   9
		dc.b	1,   4
		dc.b	0,   9
		dc.b	1,   4
		dc.b	0, $3F
		dc.b  $F4
word_87A1F:	dc.w 2
		dc.w $3FC
		dc.b 0
; ---------------------------------------------------------------------------

Obj_Buggernaut:

		jsr	(Obj_WaitOffscreen).l

loc_87A2A:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_87A3C(pc,d0.w),d1
		jsr	off_87A3C(pc,d1.w)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------
off_87A3C:	dc.w loc_87A42-off_87A3C

		dc.w loc_87A74-off_87A3C
		dc.w loc_87A92-off_87A3C
; ---------------------------------------------------------------------------

loc_87A42:
		lea	ObjDat3_87BA0(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#byte_87BBA,$30(a0)
		lea	ChildObjDat_87BB2(pc),a2
		jsr	CreateChild1_Normal(pc)
		addq.b	#1,$39(a0)

loc_87A5E:
		move.b	#2,5(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_87A7C,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_87A74:
		jsr	Animate_Raw(pc)
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_87A7C:
		move.b	#4,5(a0)
		move.w	#$7F,$2E(a0)
		move.l	#loc_87A5E,$34(a0)

locret_87A90:
		rts
; ---------------------------------------------------------------------------

loc_87A92:
		tst.b	4(a0)
		bpl.s	locret_87A90
		jsr	Find_SonicTails(pc)
		jsr	Change_FlipX(pc)
		move.w	#$200,d0
		moveq	#$10,d1
		jsr	Chase_Object(pc)
		bsr.w	sub_87B88
		jsr	(MoveSprite2).l
		jsr	Animate_Raw(pc)
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

Obj_Buggernaught_Baby:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_87ACE(pc,d0.w),d1
		jsr	off_87ACE(pc,d1.w)
		jmp	Sprite_CheckDeleteTouchXY(pc)
; ---------------------------------------------------------------------------
off_87ACE:	dc.w loc_87AD4-off_87ACE

		dc.w loc_87AE6-off_87ACE
		dc.w loc_87B4C-off_87ACE
; ---------------------------------------------------------------------------

loc_87AD4:
		lea	word_87BAC(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#byte_87BBF,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_87AE6:
		jsr	Animate_Raw(pc)
		movea.w	$46(a0),a1
		cmpi.l	#loc_87A2A,(a1)
		beq.s	loc_87AFC
		bsr.w	sub_87B56
		beq.s	loc_87B24

loc_87AFC:
		bclr	#0,4(a0)
		btst	#0,4(a1)
		beq.s	loc_87B10
		bset	#0,4(a0)

loc_87B10:
		move.w	#$200,d0
		moveq	#$20,d1
		jsr	Chase_Object(pc)
		bsr.w	sub_87B88
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_87B24:
		move.b	#4,5(a0)
		move.w	$10(a0),d0
		move.w	#$200,d1
		bset	#0,4(a0)
		cmp.w	($FFFFB010).w,d0
		bcc.s	loc_87B46
		neg.w	d1
		bclr	#0,4(a0)

loc_87B46:
		move.w	d1,$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_87B4C:
		jsr	Animate_Raw(pc)
		jmp	(MoveSprite2).l

; =============== S U B R O U T I N E =======================================


sub_87B56:
		lea	($FFFFB128).w,a2
		move.w	#$59,d0

loc_87B5E:
		cmpi.l	#loc_87A2A,(a2)
		beq.s	loc_87B72

loc_87B66:
		lea	$4A(a2),a2
		dbf	d0,loc_87B5E
		moveq	#0,d0
		rts
; ---------------------------------------------------------------------------

loc_87B72:
		move.b	$39(a2),d1
		addq.b	#1,d1
		cmpi.b	#4,d1
		bhi.s	loc_87B66
		move.b	d1,$39(a2)
		move.w	a2,$46(a0)
		rts
; End of function sub_87B56


; =============== S U B R O U T I N E =======================================


sub_87B88:

		move.w	$14(a0),d0
		move.w	($FFFFF646).w,d1
		subi.w	#8,d1
		cmp.w	d1,d0
		bcs.s	locret_87B9E
		move.w	#-$200,$1A(a0)

locret_87B9E:
		rts
; End of function sub_87B88

; ---------------------------------------------------------------------------
ObjDat3_87BA0:	dc.l Map_Buggernaut
		dc.w $A44C
		dc.w $280
		dc.b $10
		dc.b $C
		dc.b 0
		dc.b $17
word_87BAC:	dc.w $280
		dc.b $C
		dc.b $C
		dc.b 3
		dc.b 0
ChildObjDat_87BB2:dc.w 0
		dc.l Obj_Buggernaught_Baby
		dc.w $2000
byte_87BBA:	dc.b	0,   0
		dc.b	1,   2
		dc.b  $FC
byte_87BBF:	dc.b	0,   3
		dc.b	4,   5
		dc.b  $FC
; ---------------------------------------------------------------------------

Obj_TurboSpiker:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_87BDC(pc,d0.w),d1
		jsr	off_87BDC(pc,d1.w)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------
off_87BDC:	dc.w loc_87BEC-off_87BDC

		dc.w loc_87C48-off_87BDC
		dc.w loc_87CAE-off_87BDC
		dc.w loc_87CCE-off_87BDC
		dc.w loc_87CEC-off_87BDC
		dc.w loc_87CFA-off_87BDC
		dc.w loc_87D20-off_87BDC
		dc.w loc_87D3C-off_87BDC
; ---------------------------------------------------------------------------

loc_87BEC:
		lea	ObjDat3_87EB4(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		bclr	#1,4(a0)
		beq.s	loc_87C0A
		move.b	#$A,5(a0)
		lea	ChildObjDat_87F1E(pc),a2
		jsr	CreateChild1_Normal(pc)

loc_87C0A:
		move.b	#$10,$1F(a0)
		move.b	#$F,$1E(a0)
		move.l	#byte_87F26,$30(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		move.w	d0,$2E(a0)
		add.w	d0,d0
		move.w	d0,$3C(a0)
		move.l	#loc_87C72,$34(a0)
		move.w	#-$80,d4
		jsr	Set_VelocityXTrackSonic(pc)
		lea	ChildObjDat_87EE6(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_87C48:
		jsr	Find_SonicTails(pc)
		cmpi.w	#$60,d2
		bcc.s	loc_87C60
		btst	#0,4(a0)
		beq.s	loc_87C5C
		subq.w	#2,d0

loc_87C5C:
		tst.w	d0
		beq.s	loc_87C8E

loc_87C60:
		jsr	Animate_Raw(pc)
		jsr	(MoveSprite2).l
		jsr	Obj_Wait(pc)
		jmp	ObjHitFloor2_DoRoutine(pc)
; ---------------------------------------------------------------------------

loc_87C72:
		move.b	5(a0),d0
		cmpi.b	#4,d0
		beq.s	locret_87C8C
		move.b	d0,$3A(a0)
		move.b	#4,5(a0)
		move.w	#$F,$2E(a0)

locret_87C8C:

		rts
; ---------------------------------------------------------------------------

loc_87C8E:
		move.b	#6,5(a0)
		move.w	#$F,$2E(a0)
		move.w	#$200,d0
		bchg	#0,4(a0)
		beq.s	loc_87CA8
		neg.w	d0

loc_87CA8:
		move.w	d0,$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_87CAE:
		subq.w	#1,$2E(a0)
		bmi.s	loc_87CB6
		rts
; ---------------------------------------------------------------------------

loc_87CB6:
		move.b	$3A(a0),5(a0)
		neg.w	$18(a0)
		bchg	#0,4(a0)
		move.w	$3C(a0),$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_87CCE:
		subq.w	#1,$2E(a0)
		bmi.s	loc_87CD6
		rts
; ---------------------------------------------------------------------------

loc_87CD6:
		move.b	#8,5(a0)
		bset	#1,$38(a0)
		move.l	#byte_87F2B,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_87CEC:
		jsr	Animate_Raw(pc)
		jsr	(MoveSprite2).l
		jmp	ObjHitFloor2_DoRoutine(pc)
; ---------------------------------------------------------------------------

loc_87CFA:
		jsr	Find_SonicTails(pc)
		cmpi.w	#$60,d2
		bcs.s	loc_87D06
		rts
; ---------------------------------------------------------------------------

loc_87D06:
		move.b	#$C,5(a0)
		bset	#0,$38(a0)
		move.w	#3,$2E(a0)
		lea	ChildObjDat_87EFE(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_87D20:
		subq.w	#1,$2E(a0)
		bmi.s	loc_87D28
		rts
; ---------------------------------------------------------------------------

loc_87D28:
		move.b	#$E,5(a0)
		move.w	#$180,8(a0)
		move.w	#$F,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_87D3C:
		subq.w	#1,$2E(a0)
		bmi.s	loc_87D44
		rts
; ---------------------------------------------------------------------------

loc_87D44:
		move.b	#2,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_87D4C:
		lea	word_87EC0(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_87D5E,(a0)
		jmp	Child_DrawTouch_Sprite(pc)
; ---------------------------------------------------------------------------

loc_87D5E:
		jsr	Refresh_ChildPositionAdjusted(pc)
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		bne.s	loc_87D72
		jmp	Child_DrawTouch_Sprite(pc)
; ---------------------------------------------------------------------------

loc_87D72:
		move.l	#loc_87DA4,(a0)
		move.w	#$100,d0
		btst	#0,4(a0)
		beq.s	loc_87D86
		neg.w	d0

loc_87D86:
		move.w	d0,$18(a0)
		move.w	#-$400,$1A(a0)
		moveq	#-$5E,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_87EEE(pc),a2
		jsr	CreateChild1_Normal(pc)
		jmp	Sprite_CheckDeleteTouchXY(pc)
; ---------------------------------------------------------------------------

loc_87DA4:
		jsr	(MoveSprite2).l
		jmp	Sprite_CheckDeleteTouchXY(pc)
; ---------------------------------------------------------------------------

loc_87DAE:
		lea	word_87EC6(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_87DC0,(a0)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_87DC0:
		jsr	Refresh_ChildPositionAdjusted(pc)
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_87DE4
		bsr.w	sub_87DE8
		bchg	#0,$38(a0)
		beq.w	locret_87C8C
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_87DE4:
		jmp	Go_Delete_Sprite(pc)

; =============== S U B R O U T I N E =======================================


sub_87DE8:
		move.b	($FFFFFE0F).w,d0
		andi.b	#3,d0
		bne.s	locret_87E18
		lea	ChildObjDat_87EF6(pc),a2
		jsr	CreateChild1_Normal(pc)
		bne.s	locret_87E18
		jsr	(Random_Number).l
		andi.w	#7,d0
		subq.w	#3,d0
		add.w	d0,$10(a1)
		swap	d0
		andi.w	#7,d0
		subq.w	#3,d0
		add.w	d0,$14(a1)

locret_87E18:

		rts
; End of function sub_87DE8

; ---------------------------------------------------------------------------

loc_87E1A:
		lea	word_87ECC(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_87E3E,(a0)
		move.l	#byte_87F30,$30(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_87E3E:
		jsr	Animate_Raw(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_87E48:

		lea	word_87ED2(pc),a1
		jsr	SetUp_ObjAttributes2(pc)
		move.l	#loc_87E66,(a0)
		move.b	$2C(a0),$2F(a0)
		moveq	#$39,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_87E66:
		subq.w	#1,$2E(a0)
		bmi.s	loc_87E6E
		rts
; ---------------------------------------------------------------------------

loc_87E6E:
		move.l	#loc_87E86,(a0)
		move.l	#byte_87F37,$30(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_87E86:
		jsr	Animate_Raw(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_87E90:
		move.l	#loc_87E9E,(a0)
		lea	ObjDat3_87EDA(pc),a1
		jmp	SetUp_ObjAttributes(pc)
; ---------------------------------------------------------------------------

loc_87E9E:
		movea.w	$46(a0),a1
		btst	#0,$38(a1)
		bne.s	loc_87EAE
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_87EAE:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
ObjDat3_87EB4:	dc.l Map_TurboSpiker
		dc.w $2500
		dc.w $280
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b $1A
word_87EC0:	dc.w $280
		dc.b 8
		dc.b $10
		dc.b 3
		dc.b $9E
word_87EC6:	dc.w $200
		dc.b 4
		dc.b 8
		dc.b 4
		dc.b 0
word_87ECC:	dc.w $280
		dc.b 4
		dc.b 4
		dc.b 5
		dc.b 0
word_87ED2:	dc.w $8500
		dc.w $200
		dc.b 8
		dc.b 8
		dc.b 8
		dc.b 0
ObjDat3_87EDA:	dc.l Map_TurboSpikerHidden
		dc.w $C001
		dc.w $180
		dc.b $10
		dc.b $10
		dc.b 0
		dc.b 0
ChildObjDat_87EE6:dc.w 0
		dc.l loc_87D4C
		dc.w $400
ChildObjDat_87EEE:dc.w 0
		dc.l loc_87DAE
		dc.w $FC14
ChildObjDat_87EF6:dc.w 0
		dc.l loc_87E1A
		dc.w 4
ChildObjDat_87EFE:dc.w 4
		dc.l loc_87E48
		dc.w $4F8
		dc.l loc_87E48
		dc.w $FA00
		dc.l loc_87E48
		dc.w $600
		dc.l loc_87E48
		dc.w $F800
		dc.l loc_87E48
		dc.w $800
ChildObjDat_87F1E:dc.w 0
		dc.l loc_87E90
		dc.w 0
byte_87F26:	dc.b	5,   0
		dc.b	1,   2
		dc.b  $FC
byte_87F2B:	dc.b	1,   0
		dc.b	1,   2
		dc.b  $FC
byte_87F30:	dc.b	0,   5
		dc.b	5,   5
		dc.b	6,   7
		dc.b  $F4
byte_87F37:	dc.b	1,   8
		dc.b	9,  $A
		dc.b   $B,  $C
		dc.b   $D, $F4
		dc.b	0
Map_TurboSpikerHidden:	include "General\Sprites\Turbo Spiker\Map - Turbo Spiker Hidden.asm"

; ---------------------------------------------------------------------------

Obj_MegaChomper:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_87F80(pc,d0.w),d1
		jsr	off_87F80(pc,d1.w)
		btst	#7,$2A(a0)
		bne.s	loc_87F76
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------

loc_87F76:
		jsr	EnemyDefeated(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_87F80:	dc.w loc_87F88-off_87F80

		dc.w loc_87FAC-off_87F80
		dc.w loc_88024-off_87F80
		dc.w loc_88062-off_87F80
; ---------------------------------------------------------------------------

loc_87F88:
		lea	ObjDat3_8826C(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#byte_88278,$30(a0)
		clr.w	$42(a0)
		bclr	#1,4(a0)
		beq.s	locret_87FAA
		bset	#7,$A(a0)

locret_87FAA:

		rts
; ---------------------------------------------------------------------------

loc_87FAC:
		bsr.w	loc_8813A
		jsr	Animate_Raw(pc)
		jsr	Find_SonicTails(pc)
		move.b	($FFFFFE0F).w,d4
		andi.b	#7,d4
		bne.s	loc_87FCE
		moveq	#1,d4
		tst.w	d1
		bne.s	loc_87FCA
		neg.w	d4

loc_87FCA:
		add.w	d4,$14(a0)

loc_87FCE:
		move.w	$14(a0),d4
		move.w	($FFFFF646).w,d5
		addq.w	#8,d5
		cmp.w	d5,d4
		bhi.s	loc_87FE4
		btst	#6,$2A(a1)
		beq.s	loc_87FFC

loc_87FE4:
		move.w	#$200,d0
		move.w	#8,d1
		jsr	(Chase_ObjectXOnly).l
		jsr	Change_FlipXWithVelocity(pc)
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_87FFC:
		move.b	#4,5(a0)
		move.w	#$200,d4
		bset	#0,4(a0)
		tst.w	d0
		bne.s	loc_88018
		neg.w	d4
		bclr	#0,4(a0)

loc_88018:
		move.w	d4,$18(a0)
		move.w	#-$400,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_88024:
		bsr.w	loc_8813A
		jsr	Animate_Raw(pc)
		tst.w	$1A(a0)
		bmi.s	loc_88052
		move.w	$14(a0),d0
		cmp.w	($FFFFF646).w,d0
		bcs.s	loc_88052
		move.w	$1A(a0),d0
		addi.w	#-$20,d0
		move.w	d0,$1A(a0)
		beq.s	loc_88056
		bmi.s	loc_88056
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_88052:

		jmp	MoveSprite_LightGravity(pc)
; ---------------------------------------------------------------------------

loc_88056:

		move.b	#2,5(a0)
		clr.w	$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_88062:
		move.b	#0,$22(a0)
		btst	#2,($FFFFFE0F).w
		beq.s	loc_88076
		move.b	#2,$22(a0)

loc_88076:
		movea.w	$44(a0),a1
		cmpi.b	#4,5(a1)
		beq.w	loc_88108
		cmpi.b	#2,$20(a1)
		beq.s	loc_88108
		cmpi.b	#9,$20(a1)
		beq.s	loc_88108
		jsr	Check_LRControllerShake(pc)
		bne.s	loc_88108
		btst	#2,$38(a0)
		beq.s	loc_880AE
		move.w	($FFFFF604).w,d0
		andi.w	#-$7374,d0
		move.w	d0,($FFFFF602).w

loc_880AE:
		move.w	$10(a1),d0
		move.b	$42(a0),d1
		ext.w	d1
		move.b	$38(a0),d2
		andi.b	#1,d2
		move.b	4(a1),d3
		andi.b	#1,d3
		eor.b	d2,d3
		beq.s	loc_880DC
		bchg	#0,4(a0)
		bchg	#0,$38(a0)
		neg.b	$42(a0)

loc_880DC:
		add.w	d1,d0
		move.w	d0,$10(a0)
		move.w	$14(a1),d0
		move.b	$43(a0),d1
		ext.w	d1
		bpl.s	loc_880FA
		cmpi.b	#8,$20(a1)
		bne.s	loc_880FA
		addi.w	#$10,d1

loc_880FA:

		add.w	d1,d0
		move.w	d0,$14(a0)
		bsr.w	sub_881FE
		beq.w	locret_87FAA

loc_88108:

		bclr	#2,$38(a0)
		beq.s	loc_88114
		clr.b	($FFFFF7CA).w

loc_88114:
		move.l	#MoveChkDel,(a0)
		move.b	#2,$22(a0)
		move.w	#$200,d0
		btst	#0,4(a0)
		beq.s	loc_8812E
		neg.w	d0

loc_8812E:
		move.w	d0,$18(a0)
		move.w	#-$200,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_8813A:

		move.b	$29(a0),d0
		beq.w	locret_87FAA
		clr.b	$29(a0)
		andi.w	#3,d0
		move.w	d0,d2
		lsl.w	#2,d0
		lea	word_881EA-4(pc),a2
		lea	(a2,d0.w),a2
		movea.w	(a2)+,a1
		move.w	a1,$44(a0)
		move.w	$14(a0),d1
		sub.w	$14(a1),d1
		cmpi.w	#-$10,d1
		blt.w	locret_87FAA
		cmpi.w	#$10,d1
		bge.w	locret_87FAA
		jsr	Check_PlayerAttack(pc)
		bne.w	loc_881F6
		cmpi.w	#1,d2
		bne.s	loc_88190
		clr.w	($FFFFF602).w
		st	($FFFFF7CA).w
		bset	#2,$38(a0)

loc_88190:
		movea.w	(a2)+,a3
		move.w	a3,$3E(a0)
		move.w	(a3),$46(a0)
		move.b	#6,5(a0)
		move.w	#0,8(a0)
		move.w	#$3C,$2E(a0)
		move.w	$10(a0),d0
		sub.w	$10(a1),d0
		move.b	d0,$42(a0)
		bclr	#0,4(a0)
		tst.w	d0
		bpl.s	loc_881C8
		bset	#0,4(a0)

loc_881C8:
		move.w	$14(a0),d0
		sub.w	$14(a1),d0
		move.b	d0,$43(a0)
		bclr	#0,$38(a0)
		btst	#0,4(a1)
		beq.s	locret_881E8

loc_881E2:
		bset	#0,$38(a0)

locret_881E8:
		rts
; ---------------------------------------------------------------------------
word_881EA:	dc.w  $B000, $F604
		dc.w  $B04A, $F606
		dc.w  $B000, $F604
; ---------------------------------------------------------------------------

loc_881F6:
		bset	#7,$2A(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_881FE:

		subq.w	#1,$2E(a0)
		bpl.s	loc_88246
		move.w	#$3B,$2E(a0)
		ori.b	#1,($FFFFFE1D).w
		bset	#7,$38(a0)
		move.w	($FFFFFE20).w,d0
		subq.w	#1,d0
		bmi.s	loc_88258
		beq.s	loc_88230
		cmpi.w	#$A,($FFFFFE20).w
		beq.s	loc_88230
		cmpi.w	#$64,($FFFFFE20).w
		bne.s	loc_88236

loc_88230:

		ori.b	#-$80,($FFFFFE1D).w

loc_88236:
		move.w	d0,($FFFFFE20).w
		moveq	#$33,d0
		jsr	(Play_Sound_2).l

loc_88242:
		moveq	#0,d0
		rts
; ---------------------------------------------------------------------------

loc_88246:
		bclr	#7,$38(a0)
		beq.s	loc_88242
		andi.b	#-2,($FFFFFE1D).w
		moveq	#0,d0
		rts
; ---------------------------------------------------------------------------

loc_88258:
		movea.l	a0,a2
		movea.w	$44(a0),a1
		movea.l	a1,a0
		jsr	(Kill_Character).l
		movea.l	a2,a0
		moveq	#1,d0
		rts
; End of function sub_881FE

; ---------------------------------------------------------------------------
ObjDat3_8826C:	dc.l Map_MegaChomper
		dc.w $254D
		dc.w $280
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b $D7
byte_88278:	dc.b 2
		dc.b 0
		dc.b 1
		dc.b $FC
; ---------------------------------------------------------------------------

Obj_Poindexter:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_88294(pc,d0.w),d1
		jsr	off_88294(pc,d1.w)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------
off_88294:	dc.w loc_88298-off_88294

		dc.w loc_882E6-off_88294
; ---------------------------------------------------------------------------

loc_88298:
		lea	ObjDat3_88320(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#byte_8832C,$30(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		add.w	d0,d0
		move.w	d0,$2E(a0)
		add.w	d0,d0
		move.w	d0,$3A(a0)
		move.l	#loc_8830E,$34(a0)
		move.w	#-$40,d4
		jsr	Set_VelocityXTrackSonic(pc)
		move.w	#$20,d0
		move.w	d0,$3E(a0)
		move.w	d0,$1A(a0)
		move.w	#1,$40(a0)
		bclr	#0,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_882E6:
		jsr	Swing_UpAndDown(pc)
		jsr	(MoveSprite2).l
		jsr	Animate_RawMultiDelay(pc)
		jsr	Obj_Wait(pc)
		move.b	#$A,$28(a0)
		cmpi.b	#2,$22(a0)
		bne.s	locret_8830C
		move.b	#-$7A,$28(a0)

locret_8830C:
		rts
; ---------------------------------------------------------------------------

loc_8830E:
		neg.w	$18(a0)
		bchg	#0,4(a0)
		move.w	$3A(a0),$2E(a0)
		rts
; ---------------------------------------------------------------------------
ObjDat3_88320:	dc.l Map_Poindexter
		dc.w $A559
		dc.w $280
		dc.b $14
		dc.b $14
		dc.b 0
		dc.b 0
byte_8832C:	dc.b	0, $7F
		dc.b	1,   4
		dc.b	2, $3F
		dc.b	1,   4
		dc.b  $FC,   0
; ---------------------------------------------------------------------------

Obj_BubblesBadnik:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8836A(pc,d0.w),d1
		jsr	off_8836A(pc,d1.w)
		move.b	#$12,$28(a0)
		cmpi.b	#4,$22(a0)
		bne.s	loc_8835E
		move.b	#-$7A,$28(a0)

loc_8835E:
		lea	PLCPtr_88436(pc),a2
		jsr	Perform_DPLC(pc)
		jmp	Sprite_CheckDeleteTouchSlotted(pc)
; ---------------------------------------------------------------------------
off_8836A:	dc.w loc_88370-off_8836A

		dc.w loc_883AC-off_8836A
		dc.w loc_883E6-off_8836A
; ---------------------------------------------------------------------------

loc_88370:
		lea	ObjDat4_88424(pc),a1
		jsr	SetUp_ObjAttributesSlotted(pc)
		move.w	#-$80,$18(a0)
		btst	#0,4(a0)
		beq.s	loc_8838A
		neg.w	$18(a0)

loc_8838A:
		move.l	#byte_8844D,$30(a0)
		move.w	#$100,d0
		move.w	d0,$3E(a0)
		move.w	d0,$1A(a0)
		move.w	#2,$40(a0)
		bclr	#0,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_883AC:
		jsr	Animate_RawMultiDelay(pc)
		move.w	$1A(a0),d4
		jsr	Swing_UpAndDown(pc)
		tst.w	$1A(a0)
		bne.s	loc_883E0
		tst.w	d4
		bmi.s	loc_883E0
		move.b	#4,5(a0)
		move.l	#byte_8843E,$30(a0)
		move.l	#loc_88414,$34(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)

loc_883E0:

		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_883E6:
		jsr	Animate_RawMultiDelay(pc)
		beq.s	loc_883FC
		cmpi.b	#4,$23(a0)
		bne.s	loc_883FC
		moveq	#-$6C,d0
		jsr	(Play_Sound_2).l

loc_883FC:

		jsr	Swing_UpAndDown(pc)
		tst.w	d3
		beq.s	loc_8840E
		neg.w	$18(a0)
		bchg	#0,4(a0)

loc_8840E:
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_88414:
		move.b	#2,5(a0)
		move.l	#byte_8844D,$30(a0)
		rts
; ---------------------------------------------------------------------------
ObjDat4_88424:	dc.w 1
		dc.w $A500
		dc.w $18
		dc.w 0
		dc.l Map_BubblesBadnik
		dc.w $280
		dc.b $14
		dc.b $18
		dc.b 0
		dc.b 0
PLCPtr_88436:	dc.l ArtUnc_BubblesBadnik
		dc.l DPLC_BubblesBadnik
byte_8843E:	dc.b	0,  $F
		dc.b	0, $77
		dc.b	1,   3
		dc.b	2,   3
		dc.b	2,   3
		dc.b	1,   3
		dc.b	0, $77
		dc.b  $F4
byte_8844D:	dc.b	0, $7F

		dc.b	3,   3
		dc.b	4, $6B
		dc.b	4, $6B
		dc.b	3,   3
		dc.b	0, $7F
		dc.b  $FC
; ---------------------------------------------------------------------------

Obj_MGZMiniBoss:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_88476(pc,d0.w),d1
		jsr	off_88476(pc,d1.w)
		bsr.w	sub_88A62
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------
off_88476:	dc.w loc_88480-off_88476

		dc.w loc_884A2-off_88476
		dc.w loc_884D2-off_88476
		dc.w loc_884FA-off_88476
		dc.w loc_8852E-off_88476
; ---------------------------------------------------------------------------

loc_88480:
		lea	ObjDat3_88AF6(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.b	#-2,$29(a0)
		move.b	#$28,$1E(a0)
		jsr	(Swing_Setup1).l
		lea	ChildObjDat_88B2C(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_884A2:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jsr	Find_SonicTails(pc)
		cmpi.w	#$60,d2
		bcc.w	locret_884D0
		move.b	#4,5(a0)
		move.l	#byte_88B73,$30(a0)
		move.l	#loc_884E2,$34(a0)

locret_884D0:

		rts
; ---------------------------------------------------------------------------

loc_884D2:

		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jmp	Animate_RawGetFaster(pc)
; ---------------------------------------------------------------------------

loc_884E2:
		move.b	#6,5(a0)
		move.l	#byte_88B79,$30(a0)
		move.l	#loc_88514,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_884FA:

		jsr	Animate_Raw(pc)
		subq.w	#1,$14(a0)
		jsr	(ObjHitCeiling).l
		tst.w	d1
		bpl.s	locret_88512
		movea.l	$34(a0),a1
		jsr	(a1)

locret_88512:
		rts
; ---------------------------------------------------------------------------

loc_88514:
		move.b	#8,5(a0)
		st	($FFFFEECC).w
		move.w	#$BF,$2E(a0)
		move.l	#loc_8855A,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8852E:

		jsr	Animate_Raw(pc)
		moveq	#-2,d0
		move.b	($FFFFFE0F).w,d1
		btst	#0,d1
		beq.s	loc_88540
		moveq	#1,d0

loc_88540:
		add.w	d0,$14(a0)
		andi.b	#7,d1
		bne.s	loc_88556
		moveq	#$6F,d0
		jsr	(Play_Sound_2).l
		bsr.w	sub_88A32

loc_88556:
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_8855A:
		clr.w	($FFFFEECC).w
		st	($FFFFF7E8).w
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

Obj_9F_1:
		lea	byte_8859C(pc),a1
		jsr	(Check_CameraInRange).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_88588(pc,d0.w),d1
		jsr	off_88588(pc,d1.w)
		bsr.w	sub_88A62
		jmp	Draw_And_Touch_Sprite(pc)
; ---------------------------------------------------------------------------
off_88588:	dc.w loc_885A4-off_88588

		dc.w loc_88604-off_88588
		dc.w loc_884D2-off_88588
		dc.w loc_884FA-off_88588
		dc.w loc_8852E-off_88588
		dc.w loc_8867A-off_88588
		dc.w loc_886EA-off_88588
		dc.w loc_88748-off_88588
		dc.w loc_8876A-off_88588
		dc.w loc_88790-off_88588
byte_8859C:	dc.b $D
		dc.b $20
		dc.b $E
		dc.b $C0
		dc.b $2B
		dc.b $80
		dc.b $30
		dc.b $80
; ---------------------------------------------------------------------------

loc_885A4:
		lea	ObjDat3_88AF6(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.b	#6,$29(a0)
		move.b	#$28,$1E(a0)
		move.w	#$2E00,($FFFFEE16).w
		move.w	#$E10,($FFFFEE12).w
		move.w	#$2E00,$3A(a0)
		move.l	#loc_88616,$34(a0)
		jsr	(Swing_Setup1).l
		bset	#1,$38(a0)
		lea	PLC_88B88(pc),a1
		jsr	(Load_PLC_Raw).l
		jsr	(Create_New_Sprite).l
		bne.s	loc_885FC
		move.l	#Obj_Song_Fade_Transition,(a1)
		move.b	#$2E,$2C(a1)

loc_885FC:
		lea	ChildObjDat_88B2C(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_88604:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jmp	(loc_85C7E).l
; ---------------------------------------------------------------------------

loc_88616:
		move.b	#4,5(a0)
		move.l	#byte_88B73,$30(a0)
		move.l	#loc_8862E,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8862E:
		move.b	#6,5(a0)
		move.l	#byte_88B79,$30(a0)
		move.l	#loc_88646,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_88646:

		move.b	#8,5(a0)
		st	($FFFFEECC).w
		move.w	#$7F,$2E(a0)
		move.l	#loc_88660,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_88660:
		move.b	#$A,5(a0)
		clr.w	($FFFFEECC).w
		move.w	#$3F,$2E(a0)
		move.l	#loc_8867E,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8867A:
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_8867E:
		move.b	#$C,5(a0)
		bset	#1,4(a0)
		st	($FFFFEECC).w
		move.w	#$7F,$2E(a0)
		move.l	#loc_88716,$34(a0)
		move.w	($FFFFEE78).w,$10(a0)
		jsr	(Random_Number).l
		andi.w	#$E,d0
		move.w	word_886DA(pc,d0.w),d1
		add.w	d1,$10(a0)
		subi.w	#$40,$14(a0)
		cmpi.b	#2,($FFFFB038).w
		bne.s	locret_886D8
		move.w	d0,d3
		lea	ChildObjDat_88B62(pc),a2
		jsr	CreateChild1_Normal(pc)
		cmpi.w	#8,d3
		bcc.s	locret_886D8
		bset	#0,4(a1)

locret_886D8:

		rts
; ---------------------------------------------------------------------------
word_886DA:	dc.w $30
		dc.w $48
		dc.w $60
		dc.w $78
		dc.w $C8
		dc.w $E0
		dc.w $F8
		dc.w $110
; ---------------------------------------------------------------------------

loc_886EA:
		jsr	Animate_Raw(pc)
		moveq	#2,d0
		move.b	($FFFFFE0F).w,d1
		btst	#0,d1
		beq.s	loc_886FC
		moveq	#-1,d0

loc_886FC:
		add.w	d0,$14(a0)
		andi.b	#7,d1
		bne.s	loc_88712
		moveq	#$6F,d0
		jsr	(Play_Sound_2).l
		bsr.w	sub_88A32

loc_88712:
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_88716:
		move.b	#$E,5(a0)
		clr.w	($FFFFEECC).w
		cmpi.b	#2,($FFFFB038).w
		beq.s	loc_88738
		move.w	#$2F,$2E(a0)
		move.l	#loc_88754,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_88738:
		move.w	#$17,$2E(a0)
		move.l	#loc_88776,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_88748:
		addq.w	#4,$14(a0)
		jsr	Animate_Raw(pc)
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_88754:
		move.b	#$10,5(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_88776,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8876A:
		jsr	Animate_Raw(pc)
		subq.w	#1,$14(a0)
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_88776:

		move.b	#$12,5(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_887A4,$34(a0)
		jmp	(Swing_Setup1).l
; ---------------------------------------------------------------------------

loc_88790:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jsr	Animate_Raw(pc)
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_887A4:
		bclr	#1,4(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_887BA,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_887BA:
		move.b	#6,5(a0)
		move.l	#loc_88646,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_887CA:
		jsr	(Obj_EndSignControl).l
		lea	ChildObjDat_88B42(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_887DA:
		move.w	($FFFFEE78).w,d0
		addq.w	#1,d0
		move.w	d0,($FFFFEE78).w
		move.w	d0,($FFFFEE14).w
		cmpi.w	#$2E00,d0
		bcs.w	locret_884D0
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_887F6:

		move.l	#loc_88804,(a0)
		move.b	#-$62,$28(a0)
		rts
; ---------------------------------------------------------------------------

loc_88804:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_8881A
		jsr	Refresh_ChildPositionAdjusted(pc)
		jmp	(Add_SpriteToCollisionResponseList).l
; ---------------------------------------------------------------------------

loc_8881A:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_88820:
		lea	ObjDat3_88B02(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		bset	#3,$2B(a0)
		jsr	(Random_Number).l
		andi.b	#3,d0
		move.b	d0,$22(a0)
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		beq.s	loc_88854
		tst.b	d0
		bne.s	loc_88854
		lea	ObjDat3_88B0E(pc),a1
		jsr	SetUp_ObjAttributes(pc)

loc_88854:

		move.l	#MoveDraw_SpriteTimed2,(a0)
		move.w	#$5F,$2E(a0)
		jmp	Draw_And_Touch_Sprite(pc)
; ---------------------------------------------------------------------------

loc_88864:
		lea	ObjDat3_88B20(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_888A6,(a0)
		move.w	($FFFFEE78).w,d0
		addi.w	#$30,d0
		btst	#0,4(a0)
		beq.s	loc_88886
		addi.w	#$E0,d0

loc_88886:
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d0
		addi.w	#$F0,d0
		move.w	d0,$14(a0)
		move.w	d0,$3A(a0)
		clr.b	5(a0)
		move.w	#$F,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_888A6:
		btst	#4,$38(a0)
		bne.w	loc_88942
		move.w	$10(a0),-(sp)
		bsr.w	sub_88976
		moveq	#0,d1
		move.b	7(a0),d1
		addi.w	#$B,d1
		moveq	#0,d2
		move.b	6(a0),d2
		move.w	d2,d3
		addq.w	#1,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectFull).l
		swap	d6
		andi.w	#3,d6
		beq.s	loc_88926
		move.b	d6,d0
		andi.b	#1,d0
		beq.s	loc_88902
		bclr	#5,$2A(a0)
		lea	($FFFFB000).w,a1
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$28,d0
		bmi.s	loc_88902
		jsr	(sub_24280).l

loc_88902:

		andi.b	#2,d6
		beq.s	loc_88926
		bclr	#6,$2A(a0)
		lea	($FFFFB04A).w,a1
		move.w	$14(a1),d0
		sub.w	$14(a0),d0
		addi.w	#$28,d0
		bmi.s	loc_88926
		jsr	(sub_24280).l

loc_88926:

		subq.b	#1,$24(a0)
		bpl.s	loc_8893C
		move.b	#7,$24(a0)
		addq.b	#1,$22(a0)
		andi.b	#3,$22(a0)

loc_8893C:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_88942:
		jsr	Displace_PlayerOffObject(pc)
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_8894C:

		lea	word_88B1A(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#Obj_FlickerMove,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		move.b	RawAni_88970(pc,d0.w),$22(a0)
		moveq	#4,d0
		jmp	Set_IndexedVelocity(pc)
; ---------------------------------------------------------------------------
RawAni_88970:	dc.b	4,   3,	  5,   6,   6,	 0

; =============== S U B R O U T I N E =======================================


sub_88976:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_88984(pc,d0.w),d1
		jmp	off_88984(pc,d1.w)
; End of function sub_88976

; ---------------------------------------------------------------------------
off_88984:	dc.w loc_8898E-off_88984

		dc.w loc_889A8-off_88984
		dc.w loc_889E8-off_88984
		dc.w loc_88A08-off_88984
		dc.w loc_88A18-off_88984
; ---------------------------------------------------------------------------

loc_8898E:
		subq.w	#4,$14(a0)
		subq.w	#1,$2E(a0)
		bpl.w	locret_884D0
		move.b	#2,5(a0)
		move.w	#$3F,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_889A8:
		subq.w	#1,$2E(a0)
		bpl.w	locret_884D0
		move.b	#4,5(a0)
		move.w	#$100,d0
		btst	#0,4(a0)
		beq.s	loc_889C4
		neg.w	d0

loc_889C4:
		add.w	d0,$18(a0)
		move.w	#$DF,$2E(a0)
		move.w	#$100,d0
		move.w	d0,$3E(a0)
		move.w	d0,$1A(a0)
		move.w	#$10,$40(a0)
		bclr	#0,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_889E8:
		jsr	Swing_UpAndDown(pc)
		jsr	(MoveSprite2).l
		subq.w	#1,$2E(a0)
		bpl.w	locret_884D0
		move.b	#6,5(a0)
		move.w	#$3F,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_88A08:
		subq.w	#1,$2E(a0)
		bpl.w	locret_884D0
		move.b	#8,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_88A18:
		move.w	$14(a0),d0
		addq.w	#2,d0
		move.w	d0,$14(a0)
		cmp.w	$3A(a0),d0
		bcs.w	locret_884D0
		bset	#4,$38(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_88A32:

		lea	ChildObjDat_88B3A(pc),a2
		jsr	CreateChild1_Normal(pc)
		bne.s	locret_88A60
		jsr	(Random_Number).l
		andi.w	#$1FF,d0
		move.w	($FFFFEE78).w,d1
		subi.w	#$40,d1
		add.w	d0,d1
		move.w	d1,$10(a1)
		move.w	($FFFFEE7C).w,d0
		subi.w	#$20,d0
		move.w	d0,$14(a1)

locret_88A60:
		rts
; End of function sub_88A32


; =============== S U B R O U T I N E =======================================


sub_88A62:

		tst.b	$28(a0)
		bne.s	locret_88AB2
		tst.b	$29(a0)
		beq.s	loc_88AB4
		tst.b	$20(a0)
		bne.s	loc_88A88
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		bset	#6,$2A(a0)

loc_88A88:
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_88A94
		addq.w	#6,d0

loc_88A94:
		lea	word_88AE4(pc),a1
		lea	word_88AEA(pc,d0.w),a2
		jsr	CopyWordData_3(pc)
		subq.b	#1,$20(a0)
		bne.s	locret_88AB2
		bclr	#6,$2A(a0)
		move.b	$25(a0),$28(a0)

locret_88AB2:

		rts
; ---------------------------------------------------------------------------

loc_88AB4:
		move.l	#Wait_FadeToLevelMusic,(a0)
		clr.w	($FFFFEECC).w
		move.l	#loc_887CA,$34(a0)
		jsr	(Create_New_Sprite).l
		bne.s	loc_88AD4
		move.l	#loc_887DA,(a1)

loc_88AD4:
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild1_Normal).l
		jmp	BossDefeated_StopTimer(pc)
; End of function sub_88A62

; ---------------------------------------------------------------------------
word_88AE4:	dc.w $FC38
		dc.w $FC3A
		dc.w $FC3C
word_88AEA:	dc.w $CAA
		dc.w $866
		dc.w $644
		dc.w $EEE
		dc.w $EEE
		dc.w $EEE
ObjDat3_88AF6:	dc.l Map_MGZMiniBoss

		dc.w $254F
		dc.w $280
		dc.b $28
		dc.b $C
		dc.b 0
		dc.b $10
ObjDat3_88B02:	dc.l Map_MGZEndBossDebris
		dc.w $4570
		dc.w $200
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b 0
ObjDat3_88B0E:	dc.l Map_MGZMinibossSpires
		dc.w $4500
		dc.w $200
		dc.b 4
		dc.b $10
		dc.b 0
		dc.b $84
word_88B1A:	dc.w $280
		dc.b $C
		dc.b $C
		dc.b 0
		dc.b 0
ObjDat3_88B20:	dc.l Map_MGZMovingSpikePlatform
		dc.w $4001
		dc.w $280
		dc.b $18
		dc.b $30
		dc.b 0
		dc.b 0
ChildObjDat_88B2C:dc.w 1

		dc.l loc_887F6
		dc.w $E4EA
		dc.l loc_887F6
		dc.w $1CEA
ChildObjDat_88B3A:dc.w 0
		dc.l loc_88820
		dc.w 0
ChildObjDat_88B42:dc.w 4
		dc.l loc_8894C
		dc.w 0
		dc.l loc_8894C
		dc.w $E400
		dc.l loc_8894C
		dc.w $1C00
		dc.l loc_8894C
		dc.w $E4EA
		dc.l loc_8894C
		dc.w $1CEA
ChildObjDat_88B62:dc.w 0
		dc.l loc_88864
		dc.w 0
		dc.b	0,   5
		dc.b	1,   5
		dc.b	2,   5
		dc.b	3,   5
		dc.b  $FC
byte_88B73:	dc.b	5,   4

		dc.b	0,   1
		dc.b	2, $FC
byte_88B79:	dc.b	0,   0

		dc.b	1,   2
		dc.b  $FC
Map_MGZMinibossSpires:	include "Levels\MGZ\Misc Object Data\Map - Miniboss Spires.asm"

PLC_88B88:	dc.w 1
		dc.l ArtNem_BossExplosion
		dc.w $A000
		dc.l ArtNem_MGZSpire
		dc.w $A000
; ---------------------------------------------------------------------------

Obj_Spiker:

		jsr	(Obj_WaitOffscreen).l
		moveq	#$A,d0
		bsr.w	sub_88DCE
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_88BB4(pc,d0.w),d1
		jsr	off_88BB4(pc,d1.w)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------
off_88BB4:	dc.w loc_88BC0-off_88BB4

		dc.w loc_88BD0-off_88BB4
		dc.w loc_88BEA-off_88BB4
		dc.w loc_88C04-off_88BB4
		dc.w loc_88C24-off_88BB4
		dc.w loc_88C38-off_88BB4
; ---------------------------------------------------------------------------

loc_88BC0:
		lea	ObjDat3_88DFA(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		lea	ChildObjDat_88E1E(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_88BD0:
		jsr	Find_SonicTails(pc)
		cmpi.w	#$40,d2
		bcs.s	loc_88BDC
		rts
; ---------------------------------------------------------------------------

loc_88BDC:
		move.b	#4,5(a0)
		move.w	#7,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_88BEA:
		subq.w	#1,$14(a0)
		subq.w	#1,$2E(a0)
		bmi.s	loc_88BF6
		rts
; ---------------------------------------------------------------------------

loc_88BF6:
		move.b	#6,5(a0)
		bset	#2,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_88C04:
		jsr	Find_SonicTails(pc)
		cmpi.w	#$40,d2
		bcc.s	loc_88C10
		rts
; ---------------------------------------------------------------------------

loc_88C10:
		move.b	#8,5(a0)
		bclr	#2,$38(a0)
		move.w	#7,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_88C24:
		addq.w	#1,$14(a0)
		subq.w	#1,$2E(a0)
		bmi.s	loc_88C30
		rts
; ---------------------------------------------------------------------------

loc_88C30:
		move.b	#2,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_88C38:
		lea	byte_88E4A(pc),a1
		jsr	Animate_RawNoSSTMultiDelay(pc)
		tst.w	d2
		beq.s	locret_88C6C
		cmpi.b	#4,$23(a0)
		bne.s	locret_88C6C
		movea.w	$44(a0),a1
		move.w	#-$600,$1A(a1)
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		clr.b	$40(a1)
		move.b	#2,5(a1)

locret_88C6C:

		rts
; ---------------------------------------------------------------------------

loc_88C6E:
		move.b	$3A(a0),5(a0)
		move.b	#$A,$28(a0)
		rts
; ---------------------------------------------------------------------------

loc_88C7C:

		jsr	Refresh_ChildPosition(pc)
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_88C92(pc,d0.w),d1
		jsr	off_88C92(pc,d1.w)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------
off_88C92:	dc.w loc_88C9A-off_88C92

		dc.w loc_88CB0-off_88C92
		dc.w loc_88CC6-off_88C92
		dc.w loc_88D02-off_88C92
; ---------------------------------------------------------------------------

loc_88C9A:
		lea	word_88E06(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		tst.b	$2C(a0)
		bne.s	locret_88CAE
		bset	#0,4(a0)

locret_88CAE:
		rts
; ---------------------------------------------------------------------------

loc_88CB0:
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		bne.s	loc_88CBE
		rts
; ---------------------------------------------------------------------------

loc_88CBE:
		move.b	#4,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_88CC6:
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		beq.s	loc_88CFA
		jsr	Find_SonicTails(pc)
		cmpi.w	#$40,d2
		bcc.s	locret_88CE8
		tst.b	$2C(a0)
		beq.s	loc_88CE4
		subq.w	#2,d0

loc_88CE4:
		tst.w	d0
		beq.s	loc_88CEA

locret_88CE8:
		rts
; ---------------------------------------------------------------------------

loc_88CEA:
		move.b	#6,5(a0)
		move.l	#loc_88D28,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_88CFA:
		move.b	#2,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_88D02:
		lea	byte_88E53(pc),a1
		jsr	Animate_RawNoSSTMultiDelay(pc)
		tst.w	d2
		beq.s	locret_88D26
		cmpi.b	#4,$22(a0)
		bne.s	locret_88D26
		moveq	#$4D,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_88E32(pc),a2
		jsr	CreateChild5_ComplexAdjusted(pc)

locret_88D26:

		rts
; ---------------------------------------------------------------------------

loc_88D28:
		move.b	#4,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_88D30:
		jsr	Refresh_ChildPosition(pc)
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_88D46(pc,d0.w),d1
		jsr	off_88D46(pc,d1.w)
		jmp	Child_DrawTouch_Sprite(pc)
; ---------------------------------------------------------------------------
off_88D46:	dc.w loc_88D4C-off_88D46

		dc.w loc_88D54-off_88D46
		dc.w loc_88D94-off_88D46
; ---------------------------------------------------------------------------

loc_88D4C:
		lea	word_88E0C(pc),a1
		jsr	SetUp_ObjAttributes3(pc)

loc_88D54:
		jsr	Check_PlayerCollision(pc)
		bne.s	loc_88D5C
		rts
; ---------------------------------------------------------------------------

loc_88D5C:
		bsr.w	sub_88DA6
		move.b	#4,5(a0)
		clr.b	$28(a0)
		move.w	#$10,$2E(a0)
		move.l	#loc_88D98,$34(a0)
		movea.w	$46(a0),a1
		bset	#3,$38(a1)
		move.b	#1,$22(a1)
		clr.b	$28(a1)
		move.w	$44(a0),$44(a1)
		rts
; ---------------------------------------------------------------------------

loc_88D94:
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_88D98:
		move.b	#2,5(a0)
		move.b	#-$36,$28(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_88DA6:
		clr.w	$1A(a1)
		bset	#1,$2A(a1)
		addq.w	#6,$14(a1)
		move.b	#2,5(a1)
		clr.b	$40(a1)
		bclr	#4,$2A(a1)
		moveq	#-$4F,d0
		jsr	(Play_Sound_2).l
		rts
; End of function sub_88DA6


; =============== S U B R O U T I N E =======================================


sub_88DCE:
		btst	#3,$38(a0)
		bne.s	loc_88DD8
		rts
; ---------------------------------------------------------------------------

loc_88DD8:
		bclr	#3,$38(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		move.b	5(a0),$3A(a0)
		move.b	d0,5(a0)
		move.l	#loc_88C6E,$34(a0)
		rts
; End of function sub_88DCE

; ---------------------------------------------------------------------------
ObjDat3_88DFA:	dc.l Map_Spiker
		dc.w $2530
		dc.w $280
		dc.b $20
		dc.b $10
		dc.b 0
		dc.b $A
word_88E06:	dc.w $280
		dc.b $20
		dc.b 4
		dc.b 3
		dc.b 0
word_88E0C:	dc.w $200
		dc.b $20
		dc.b 4
		dc.b 7
		dc.b $CA
ObjDat3_88E12:	dc.l Map_Spiker
		dc.w $530
		dc.w $280
		dc.b 4
		dc.b 4
		dc.b 5
		dc.b $98
ChildObjDat_88E1E:dc.w 2
		dc.l loc_88C7C
		dc.w $F00C
		dc.l loc_88C7C
		dc.w $100C
		dc.l loc_88D30
		dc.w $F4
ChildObjDat_88E32:dc.w 0
		dc.l loc_86D4A
		dc.l ObjDat3_88E12
		dc.l byte_88E5C
		dc.l MoveSlowFall_AnimateRaw
		dc.b 4
		dc.b 0
		dc.w $200
		dc.w $FE00
byte_88E4A:	dc.b	1,   0
		dc.b	2,   1
		dc.b	1,   0
		dc.b	0,   5
		dc.b  $F4
byte_88E53:	dc.b	3,   1
		dc.b	3,  $F
		dc.b	4,   7
		dc.b	3, $3F
		dc.b  $F4
byte_88E5C:	dc.b	1,   5
		dc.b	6, $FC
; ---------------------------------------------------------------------------

Obj_Mantis:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_88E78(pc,d0.w),d1
		jsr	off_88E78(pc,d1.w)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------
off_88E78:	dc.w loc_88E82-off_88E78

		dc.w loc_88E98-off_88E78
		dc.w loc_88EC4-off_88E78
		dc.w loc_88EFE-off_88E78
		dc.w loc_88F22-off_88E78
; ---------------------------------------------------------------------------

loc_88E82:
		lea	ObjDat3_88F8A(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.b	#$29,$1E(a0)
		lea	ChildObjDat_88F9C(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_88E98:
		jsr	Find_SonicTails(pc)
		bclr	#0,4(a0)
		tst.w	d0
		beq.s	loc_88EAC
		bset	#0,4(a0)

loc_88EAC:
		cmpi.w	#$40,d2
		bcs.s	loc_88EB4
		rts
; ---------------------------------------------------------------------------

loc_88EB4:
		move.b	#4,5(a0)
		move.l	#loc_88EE8,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_88EC4:
		lea	byte_88FA4(pc),a1
		jsr	Animate_RawNoSSTMultiDelay(pc)
		tst.w	d2
		beq.s	locret_88EE0
		bmi.s	locret_88EE0
		moveq	#0,d0
		move.b	$23(a0),d0
		move.w	word_88EE2(pc,d0.w),d0
		add.w	d0,$14(a0)

locret_88EE0:

		rts
; ---------------------------------------------------------------------------
word_88EE2:	dc.w 0
		dc.w $FFFB
		dc.w $FFED
; ---------------------------------------------------------------------------

loc_88EE8:
		move.b	#6,5(a0)
		move.w	#-$600,$1A(a0)
		move.l	#loc_88F0E,$34(a0)

locret_88EFC:
		rts
; ---------------------------------------------------------------------------

loc_88EFE:
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.s	locret_88EFC
		jmp	ObjHitFloor_DoRoutine(pc)
; ---------------------------------------------------------------------------

loc_88F0E:
		move.b	#8,5(a0)
		clr.w	$1A(a0)
		move.l	#loc_88F48,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_88F22:
		lea	byte_88FAB(pc),a1
		jsr	Animate_RawNoSSTMultiDelay(pc)
		tst.w	d2
		beq.s	locret_88F3E
		bmi.s	locret_88F3E
		moveq	#0,d0
		move.b	$23(a0),d0
		move.w	word_88F40(pc,d0.w),d0
		add.w	d0,$14(a0)

locret_88F3E:

		rts
; ---------------------------------------------------------------------------
word_88F40:	dc.w 0
		dc.w $12
		dc.w 6
		dc.w $FFFF
; ---------------------------------------------------------------------------

loc_88F48:
		move.b	#2,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_88F50:
		jsr	Refresh_ChildPositionAdjusted(pc)
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_88F66(pc,d0.w),d1
		jsr	off_88F66(pc,d1.w)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------
off_88F66:	dc.w loc_88F6A-off_88F66

		dc.w loc_88F72-off_88F66
; ---------------------------------------------------------------------------

loc_88F6A:
		lea	word_88F96(pc),a1
		jmp	SetUp_ObjAttributes3(pc)
; ---------------------------------------------------------------------------

loc_88F72:
		movea.w	$46(a0),a1
		move.b	#5,$22(a0)
		tst.w	$1A(a1)
		bmi.s	locret_88F88
		move.b	#4,$22(a0)

locret_88F88:
		rts
; ---------------------------------------------------------------------------
ObjDat3_88F8A:	dc.l Map_Mantis
		dc.w $254F
		dc.w $280
		dc.b $14
		dc.b $1C
		dc.b 0
		dc.b $1A
word_88F96:	dc.w $200
		dc.b 4
		dc.b 4
		dc.b 5
		dc.b 0
ChildObjDat_88F9C:dc.w 0
		dc.l loc_88F50
		dc.w $F7F5
byte_88FA4:	dc.b	0,   0
		dc.b	1,   2
		dc.b	2,   0
		dc.b  $F4
byte_88FAB:	dc.b	2,   0
		dc.b	1,   2
		dc.b	3,   2
		dc.b	0, $1F
		dc.b  $F4
; ---------------------------------------------------------------------------

Obj_Clamer:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_88FD4(pc,d0.w),d1
		jsr	off_88FD4(pc,d1.w)
		lea	PLCPtr_89168(pc),a2
		jsr	Perform_DPLC(pc)
		jmp	Sprite_CheckDeleteTouchSlotted(pc)
; ---------------------------------------------------------------------------
off_88FD4:	dc.w loc_88FDC-off_88FD4

		dc.w loc_88FEC-off_88FD4
		dc.w loc_8904E-off_88FD4
		dc.w loc_89064-off_88FD4
; ---------------------------------------------------------------------------

loc_88FDC:
		lea	ObjDat4_89124(pc),a1
		jsr	SetUp_ObjAttributesSlotted(pc)
		lea	ChildObjDat_89148(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_88FEC:
		btst	#0,$38(a0)
		bne.s	loc_89014
		jsr	Find_SonicTails(pc)
		cmpi.w	#$60,d2
		bcc.s	loc_8900C
		btst	#0,4(a0)
		beq.s	loc_89008
		subq.w	#2,d0

loc_89008:
		tst.w	d0
		beq.s	loc_89036

loc_8900C:
		lea	byte_89170(pc),a1
		jmp	Animate_RawNoSSTMultiDelay(pc)
; ---------------------------------------------------------------------------

loc_89014:
		move.b	#4,5(a0)
		clr.b	$28(a0)
		bclr	#0,$38(a0)
		move.l	#loc_89056,$34(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_89036:
		move.b	#6,5(a0)
		move.l	#loc_89056,$34(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)

locret_8904C:

		rts
; ---------------------------------------------------------------------------

loc_8904E:
		lea	byte_89179(pc),a1
		jmp	Animate_RawNoSST(pc)
; ---------------------------------------------------------------------------

loc_89056:

		move.b	#2,5(a0)
		move.b	#$A,$28(a0)
		rts
; ---------------------------------------------------------------------------

loc_89064:
		lea	byte_89185(pc),a1
		jsr	Animate_RawNoSSTMultiDelay(pc)
		tst.w	d2
		beq.w	locret_8904C
		cmpi.b	#8,$22(a0)
		bne.w	locret_8904C
		tst.b	4(a0)
		bpl.w	locret_8904C
		lea	ChildObjDat_89150(pc),a2
		jmp	CreateChild5_ComplexAdjusted(pc)
; ---------------------------------------------------------------------------

loc_8908C:
		lea	word_89136(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		movea.w	$46(a0),a1
		move.b	4(a1),4(a0)
		clr.w	$A(a0)
		move.l	#loc_890AA,(a0)
		rts
; ---------------------------------------------------------------------------

loc_890AA:

		bsr.w	Check_PlayerCollision
		beq.s	loc_890C4
		move.l	#loc_890C8,(a0)
		bsr.w	sub_890D8
		movea.w	$46(a0),a1
		bset	#0,$38(a1)

loc_890C4:
		jmp	Child_DrawTouch_Sprite(pc)
; ---------------------------------------------------------------------------

loc_890C8:
		subq.w	#1,$2E(a0)
		bmi.s	loc_890D0
		rts
; ---------------------------------------------------------------------------

loc_890D0:
		move.l	#loc_890AA,(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_890D8:
		move.w	#$800,d0
		bclr	#0,$2A(a1)
		btst	#0,4(a0)
		beq.s	loc_890F2
		neg.w	d0
		bset	#0,$2A(a1)

loc_890F2:
		move.w	d0,$18(a1)
		move.w	d0,$1C(a1)
		move.w	#-$800,$1A(a1)
		bset	#1,$2A(a1)
		addq.w	#6,$14(a1)
		move.b	#$10,$20(a1)
		move.b	#2,5(a1)
		clr.b	$40(a1)
		moveq	#-$4F,d0
		jsr	(Play_Sound_2).l
		rts
; End of function sub_890D8

; ---------------------------------------------------------------------------
ObjDat4_89124:	dc.w 1
		dc.w $A500
		dc.w $12
		dc.w 0
		dc.l Map_Clamer
		dc.w $280
		dc.b $14
		dc.b $10
		dc.b 0
		dc.b $A
word_89136:	dc.w $280
		dc.b 8
		dc.b 4
		dc.b $B
		dc.b $D7
ObjDat3_8913C:	dc.l Map_Clamer
		dc.w $A570
		dc.w $200
		dc.b 8
		dc.b 8
		dc.b 9
		dc.b $98
ChildObjDat_89148:dc.w 0
		dc.l loc_8908C
		dc.w $F8
ChildObjDat_89150:dc.w 0
		dc.l loc_86D4A
		dc.l ObjDat3_8913C
		dc.l 0
		dc.l MoveSprite2
		dc.b $F0
		dc.b 2
		dc.w $FE00
		dc.w 0
PLCPtr_89168:	dc.l ArtUnc_Clamer
		dc.l DPLC_Clamer
byte_89170:	dc.b	1,   1
		dc.b	0, $5F
		dc.b	1,   1
		dc.b	2,   1
		dc.b  $FC
byte_89179:	dc.b	0,   0
		dc.b	1,   2
		dc.b	3,   4
		dc.b	3,   2
		dc.b	1,  $A
		dc.b	0, $F4
byte_89185:	dc.b	0,   2
		dc.b	5,   2
		dc.b	6,   2
		dc.b	7, $2F
		dc.b	8,   5
		dc.b	7, $1F
		dc.b	6,   2
		dc.b	5,   2
		dc.b	0, $1F
		dc.b  $F4
; ---------------------------------------------------------------------------

Obj_CNZBlastoid:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_891B0(pc,d0.w),d1
		jsr	off_891B0(pc,d1.w)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------
off_891B0:	dc.w loc_891BA-off_891B0

		dc.w loc_891C2-off_891B0
		dc.w loc_891EE-off_891B0
		dc.w loc_8920E-off_891B0
		dc.w loc_8920E-off_891B0
; ---------------------------------------------------------------------------

loc_891BA:
		lea	ObjDat3_8933A(pc),a1
		jmp	SetUp_ObjAttributes(pc)
; ---------------------------------------------------------------------------

loc_891C2:
		jsr	Find_SonicTails(pc)
		cmpi.w	#$80,d2
		bcs.s	loc_891CE
		rts
; ---------------------------------------------------------------------------

loc_891CE:
		move.b	#4,5(a0)
		move.l	#byte_89362,$30(a0)
		move.l	#loc_891F2,$34(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)

locret_891EC:
		rts
; ---------------------------------------------------------------------------

loc_891EE:
		jmp	Animate_RawGetFaster(pc)
; ---------------------------------------------------------------------------

loc_891F2:
		move.b	#6,5(a0)
		move.w	#4,$2E(a0)
		move.l	#loc_89212,$34(a0)
		lea	ChildObjDat_89352(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_8920E:
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_89212:
		move.b	#8,5(a0)
		moveq	#$68,d0
		bchg	#1,4(a0)
		bne.s	loc_89224
		neg.w	d0

loc_89224:
		add.w	d0,$14(a0)
		move.w	#$20,$2E(a0)
		move.l	#loc_8924E,$34(a0)
		moveq	#$79,d0
		jsr	(Play_Sound_2).l
		tst.b	4(a0)
		bpl.w	locret_891EC
		lea	ChildObjDat_8935A(pc),a2
		jmp	CreateChild3_NormalRepeated(pc)
; ---------------------------------------------------------------------------

loc_8924E:
		move.b	#2,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_89256:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_89268(pc,d0.w),d1
		jsr	off_89268(pc,d1.w)
		jmp	Child_DrawTouch_Sprite(pc)
; ---------------------------------------------------------------------------
off_89268:	dc.w loc_8926C-off_89268

		dc.w loc_89298-off_89268
; ---------------------------------------------------------------------------

loc_8926C:
		lea	word_89346(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		bset	#5,$2B(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		movea.w	$46(a0),a1
		moveq	#$34,d0
		btst	#1,4(a1)
		bne.s	loc_89292
		neg.w	d0

loc_89292:
		add.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_89298:
		lea	byte_89367(pc),a1
		jmp	Animate_RawNoSST(pc)
; ---------------------------------------------------------------------------

loc_892A0:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_892B2(pc,d0.w),d1
		jsr	off_892B2(pc,d1.w)
		jmp	Sprite_CheckDeleteTouchXY(pc)
; ---------------------------------------------------------------------------
off_892B2:	dc.w loc_892B8-off_892B2

		dc.w loc_892EE-off_892B2
		dc.w loc_89334-off_892B2
; ---------------------------------------------------------------------------

loc_892B8:
		lea	word_8934C(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		bset	#5,$2B(a0)
		movea.w	$46(a0),a1
		move.w	#$600,d0
		btst	#1,4(a1)
		bne.s	loc_892D8
		neg.w	d0

loc_892D8:
		move.w	d0,$1A(a0)
		move.w	#$600,d0
		tst.b	$2C(a0)
		bne.s	loc_892E8
		neg.w	d0

loc_892E8:
		move.w	d0,$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_892EE:
		lea	byte_89372(pc),a1
		jsr	Animate_RawNoSST(pc)
		moveq	#$40,d0
		move.w	$18(a0),d1
		bmi.s	loc_89300
		neg.w	d0

loc_89300:
		add.w	d0,d1
		cmpi.w	#-$100,d1
		blt.s	loc_8930E
		cmpi.w	#$100,d1
		ble.s	loc_89328

loc_8930E:
		move.w	d1,$18(a0)
		moveq	#$40,d0
		move.w	$1A(a0),d1
		bmi.s	loc_8931C
		neg.w	d0

loc_8931C:
		add.w	d0,d1
		move.w	d1,$1A(a0)
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_89328:
		move.b	#4,5(a0)
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_89334:
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------
ObjDat3_8933A:	dc.l Map_CNZBlastoid
		dc.w $A524
		dc.w $280
		dc.b $C
		dc.b $C
		dc.b 0
		dc.b $B
word_89346:	dc.w $200
		dc.b $C
		dc.b $40
		dc.b 2
		dc.b $AB
word_8934C:	dc.w $280
		dc.b 8
		dc.b 8
		dc.b 6
		dc.b $98
ChildObjDat_89352:dc.w 0
		dc.l loc_89256
		dc.w 0
ChildObjDat_8935A:dc.w 1
		dc.l loc_892A0
		dc.w 0
byte_89362:	dc.b	9, $10
		dc.b	0,   1
		dc.b  $FC
byte_89367:	dc.b	0,   2
		dc.b	8,   3
		dc.b	8,   4
		dc.b	8,   5
		dc.b	8,   2
		dc.b  $F4
byte_89372:	dc.b	3,   6
		dc.b	7, $FC
; ---------------------------------------------------------------------------

Obj_Batbot:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8938E(pc,d0.w),d1
		jsr	off_8938E(pc,d1.w)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------
off_8938E:	dc.w loc_89394-off_8938E

		dc.w loc_893A4-off_8938E
		dc.w loc_893CC-off_8938E
; ---------------------------------------------------------------------------

loc_89394:
		lea	ObjDat3_89454(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		lea	ChildObjDat_8946C(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_893A4:
		jsr	Find_SonicTails(pc)
		cmpi.w	#$40,d2
		bcs.s	loc_893B0
		rts
; ---------------------------------------------------------------------------

loc_893B0:
		move.b	#4,5(a0)
		bset	#3,$38(a0)
		move.w	#$200,d0
		tst.w	d0
		bne.s	loc_893C6
		neg.w	d0

loc_893C6:
		move.w	d0,$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_893CC:
		lea	byte_8947A(pc),a1
		jsr	Animate_RawNoSST(pc)
		lea	($FFFFB000).w,a1
		move.w	#$200,d0
		moveq	#8,d1
		jsr	Chase_Object(pc)
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_893E8:
		jsr	Refresh_ChildPosition(pc)
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_893FE(pc,d0.w),d1
		jsr	off_893FE(pc,d1.w)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------
off_893FE:	dc.w loc_89404-off_893FE

		dc.w loc_8940C-off_893FE
		dc.w loc_89426-off_893FE
; ---------------------------------------------------------------------------

loc_89404:
		lea	word_89460(pc),a1
		jmp	SetUp_ObjAttributes3(pc)
; ---------------------------------------------------------------------------

loc_8940C:

		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		bne.s	loc_8941A
		rts
; ---------------------------------------------------------------------------

loc_8941A:
		move.b	#4,5(a0)
		addq.b	#1,$22(a0)
		rts
; ---------------------------------------------------------------------------

loc_89426:
		lea	byte_89480(pc),a1
		jmp	Animate_RawNoSSTMultiDelay(pc)
; ---------------------------------------------------------------------------

loc_8942E:
		jsr	Refresh_ChildPosition(pc)
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_89444(pc,d0.w),d1
		jsr	off_89444(pc,d1.w)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------
off_89444:	dc.w loc_8944A-off_89444

		dc.w loc_8940C-off_89444
		dc.w locret_89452-off_89444
; ---------------------------------------------------------------------------

loc_8944A:
		lea	word_89466(pc),a1
		jmp	SetUp_ObjAttributes3(pc)
; ---------------------------------------------------------------------------

locret_89452:
		rts
; ---------------------------------------------------------------------------
ObjDat3_89454:	dc.l Map_Batbot
		dc.w $A552
		dc.w $280
		dc.b $20
		dc.b 8
		dc.b 2
		dc.b $D
word_89460:	dc.w $200
		dc.b 8
		dc.b 8
		dc.b 3
		dc.b 0
word_89466:	dc.w $200
		dc.b 4
		dc.b 4
		dc.b 5
		dc.b 0
ChildObjDat_8946C:dc.w 1
		dc.l loc_893E8
		dc.w $10
		dc.l loc_8942E
		dc.w 3
byte_8947A:	dc.b	2,   0
		dc.b	1,   2
		dc.b	1, $FC
byte_89480:	dc.b	3, $1D
		dc.b	4,   2
		dc.b	3,   1
		dc.b	4,   2
		dc.b	3,  $E
		dc.b	4,   2
		dc.b  $FC,   0
; ---------------------------------------------------------------------------

Obj_Blaster:

		jsr	(Obj_WaitOffscreen).l

loc_89494:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_894A6(pc,d0.w),d1
		jsr	off_894A6(pc,d1.w)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------
off_894A6:	dc.w loc_894B6-off_894A6

		dc.w loc_894F2-off_894A6
		dc.w loc_89552-off_894A6
		dc.w loc_8957A-off_894A6
		dc.w loc_895A4-off_894A6
		dc.w loc_895C6-off_894A6
		dc.w loc_895EC-off_894A6
		dc.w loc_895FA-off_894A6
; ---------------------------------------------------------------------------

loc_894B6:
		lea	ObjDat3_896FC(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		bclr	#1,4(a0)
		beq.s	loc_894CA
		st	$3C(a0)

loc_894CA:
		move.b	#$E,$1E(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		move.w	d0,$2E(a0)
		add.w	d0,d0
		move.w	d0,$3A(a0)
		move.l	#loc_8953C,$34(a0)
		move.w	#-$80,d4
		jmp	Set_VelocityXTrackSonic(pc)
; ---------------------------------------------------------------------------

loc_894F2:
		bsr.w	sub_896D6
		jsr	Find_SonicTails(pc)
		tst.w	d1
		bne.s	loc_89512
		cmpi.w	#$80,d2
		bcc.s	loc_89512
		btst	#0,4(a0)
		beq.s	loc_8950E
		subq.w	#2,d0

loc_8950E:
		tst.w	d0
		beq.s	loc_89528

loc_89512:

		lea	byte_8975E(pc),a1
		jsr	Animate_RawNoSSTMultiDelay(pc)
		jsr	(MoveSprite2).l
		jsr	ObjHitFloor2_DoRoutine(pc)
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_89528:
		move.b	#6,5(a0)
		move.b	#0,$22(a0)
		move.b	#$10,$39(a0)
		rts
; ---------------------------------------------------------------------------

loc_8953C:

		move.b	#4,5(a0)
		move.w	#$20,$2E(a0)
		move.l	#loc_8955A,$34(a0)

locret_89550:

		rts
; ---------------------------------------------------------------------------

loc_89552:
		bsr.w	sub_896D6
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_8955A:
		neg.w	$18(a0)
		bchg	#0,4(a0)
		move.w	$3A(a0),$2E(a0)

loc_8956A:
		move.b	#2,5(a0)
		move.l	#loc_8953C,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8957A:
		bsr.w	sub_896D6
		subq.b	#1,$39(a0)
		bpl.w	locret_89550
		move.b	#8,5(a0)
		move.l	#loc_8956A,$34(a0)
		lea	ChildObjDat_89726(pc),a2
		jsr	CreateChild1_Normal(pc)
		lea	ChildObjDat_8972E(pc),a2
		jmp	CreateChild5_ComplexAdjusted(pc)
; ---------------------------------------------------------------------------

loc_895A4:
		bsr.w	sub_896D6
		lea	byte_89768(pc),a1
		jsr	Animate_RawNoSSTMultiDelay(pc)
		tst.w	d2
		beq.s	locret_895C4
		cmpi.b	#6,$23(a0)
		bne.s	locret_895C4
		lea	ChildObjDat_89746(pc),a2
		jsr	CreateChild5_ComplexAdjusted(pc)

locret_895C4:

		rts
; ---------------------------------------------------------------------------

loc_895C6:
		addi.w	#-$20,$1A(a0)
		jsr	(MoveSprite2).l
		jsr	(ObjHitCeiling).l
		tst.w	d1
		bpl.s	locret_895EA
		add.w	d1,$14(a0)
		move.b	#$C,5(a0)
		clr.w	$1A(a0)

locret_895EA:
		rts
; ---------------------------------------------------------------------------

loc_895EC:
		tst.b	($FFFFF7C1).w
		bne.s	locret_895F8
		move.b	#$E,5(a0)

locret_895F8:
		rts
; ---------------------------------------------------------------------------

loc_895FA:
		addi.w	#$20,$1A(a0)
		jsr	(MoveSprite2).l
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	locret_89624
		add.w	d1,$14(a0)
		move.b	$3D(a0),5(a0)
		move.w	$3E(a0),$18(a0)
		clr.w	$1A(a0)

locret_89624:
		rts
; ---------------------------------------------------------------------------

loc_89626:
		lea	word_89708(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_8963E,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8963E:
		jsr	Refresh_ChildPositionAdjusted(pc)
		lea	byte_89763(pc),a1
		jsr	Animate_RawNoSST(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_89650:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_89662(pc,d0.w),d1
		jsr	off_89662(pc,d1.w)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------
off_89662:	dc.w loc_89666-off_89662

		dc.w loc_8968A-off_89662
; ---------------------------------------------------------------------------

loc_89666:
		lea	ObjDat3_896FC(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_8969E,$34(a0)
		move.b	#$E,$1E(a0)
		moveq	#8,d0
		jsr	(Set_IndexedVelocity).l
		jmp	(Change_FlipXWithVelocity).l
; ---------------------------------------------------------------------------

loc_8968A:
		jsr	(MoveSprite_LightGravity).l
		tst.w	$1A(a0)
		bmi.w	locret_89550
		jmp	(ObjHitFloor_DoRoutine).l
; ---------------------------------------------------------------------------

loc_8969E:
		move.l	#loc_89494,(a0)
		move.b	#2,5(a0)
		move.w	#$3F,$2E(a0)
		move.w	#$7F,$3A(a0)
		move.l	#loc_8953C,$34(a0)
		move.w	#-$80,d0
		btst	#0,4(a0)
		beq.s	loc_896CC
		neg.w	d0

loc_896CC:
		move.w	d0,$18(a0)
		clr.w	$1A(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_896D6:

		tst.b	$3C(a0)
		beq.s	locret_896FA
		tst.b	($FFFFF7C1).w
		beq.s	locret_896FA
		move.b	5(a0),$3D(a0)
		move.b	#$A,5(a0)
		move.w	$18(a0),$3E(a0)
		clr.w	$18(a0)
		addq.w	#4,sp

locret_896FA:
		rts
; End of function sub_896D6

; ---------------------------------------------------------------------------
ObjDat3_896FC:	dc.l Map_Blaster

		dc.w $A506
		dc.w $280
		dc.b $18
		dc.b $10
		dc.b 0
		dc.b $A
word_89708:	dc.w $200
		dc.b 8
		dc.b 8
		dc.b 4
		dc.b 0
ObjDat3_8970E:	dc.l Map_Blaster
		dc.w $A506
		dc.w $280
		dc.b 4
		dc.b 4
		dc.b 5
		dc.b $98
ObjDat3_8971A:	dc.l Map_Blaster
		dc.w $A506
		dc.w $200
		dc.b 4
		dc.b 4
		dc.b 7
		dc.b 0
ChildObjDat_89726:dc.w 0
		dc.l loc_89626
		dc.w $E5EA
ChildObjDat_8972E:dc.w 0
		dc.l loc_86D4A
		dc.l ObjDat3_8970E
		dc.l byte_89771
		dc.l MoveFall_AnimateRaw
		dc.b $E0
		dc.b $E0
		dc.w $FE00
		dc.w $FC00
ChildObjDat_89746:dc.w 0
		dc.l loc_86D4A
		dc.l ObjDat3_8971A
		dc.l byte_89775
		dc.l MoveFall_AnimateRaw
		dc.b $F4
		dc.b $FC
		dc.w $100
		dc.w $FE00
byte_8975E:	dc.b	0, $17
		dc.b	1,   2
		dc.b  $FC
byte_89763:	dc.b	0,   4
		dc.b	4,   5
		dc.b  $F4
byte_89768:	dc.b	0,   1
		dc.b	0,   1
		dc.b	2,   5
		dc.b	0, $1F
		dc.b  $F4
byte_89771:	dc.b	1,   5
		dc.b	6, $FC
byte_89775:	dc.b	2,   7
		dc.b	8,   9
		dc.b   $A, $FC
		dc.b	0
Map_Blaster:	include "General\Sprites\Blaster\Map - Blaster.asm"

; ---------------------------------------------------------------------------

Obj_TechnoSqueek:

		jsr	(Obj_WaitOffscreen).l

loc_89826:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_89838(pc,d0.w),d1
		jsr	off_89838(pc,d1.w)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------
off_89838:	dc.w loc_89842-off_89838

		dc.w loc_898DC-off_89838
		dc.w loc_8992E-off_89838
		dc.w loc_8995C-off_89838
		dc.w loc_899A0-off_89838
; ---------------------------------------------------------------------------

loc_89842:
		move.w	#$800,$2E(a0)
		move.l	#loc_89926,$34(a0)
		cmpi.b	#4,$2C(a0)
		beq.s	loc_8989E
		lea	ObjDat_89B06(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#byte_89B2C,$30(a0)
		bset	#0,4(a0)
		cmpi.b	#2,$2C(a0)
		bne.s	loc_8987C
		bset	#1,4(a0)

loc_8987C:
		lea	ChildObjDat_89B24(pc),a2
		jsr	CreateChild1_Normal(pc)
		move.w	#$400,d0
		move.w	d0,$3A(a0)
		move.w	d0,$18(a0)
		move.w	#$20,$3C(a0)
		bclr	#3,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_8989E:
		lea	ObjDat3_89B12(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.b	#6,5(a0)
		move.l	#byte_89B52,$30(a0)
		bset	#1,4(a0)
		lea	ChildObjDat_89B24(pc),a2
		jsr	CreateChild1_Normal(pc)
		move.w	#$400,d0
		move.w	d0,$3E(a0)
		move.w	d0,$1A(a0)
		move.w	#$20,$40(a0)
		bclr	#0,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_898DC:
		jsr	Animate_RawMultiDelayFlipX(pc)
		tst.w	d2
		beq.s	loc_898F2
		cmpi.b	#6,$23(a0)
		bne.s	loc_898F2
		bset	#1,$38(a0)

loc_898F2:

		jsr	Swing_LeftAndRight(pc)
		tst.w	$18(a0)
		beq.s	loc_89906
		jsr	(MoveSprite2).l
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_89906:
		move.b	#4,5(a0)
		move.l	#byte_89B42,$30(a0)
		move.l	#loc_89932,$34(a0)

loc_8991C:

		clr.b	$23(a0)
		clr.b	$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_89926:

		bclr	#5,$38(a0)

locret_8992C:

		rts
; ---------------------------------------------------------------------------

loc_8992E:
		jmp	Animate_RawAdjustFlipX(pc)
; ---------------------------------------------------------------------------

loc_89932:
		move.b	#2,5(a0)
		move.l	#byte_89B37,$30(a0)

loc_89940:
		bclr	#1,$38(a0)
		bset	#5,$38(a0)
		move.w	#$10,$2E(a0)
		move.l	#loc_89926,$34(a0)
		bra.s	loc_8991C
; ---------------------------------------------------------------------------

loc_8995C:
		jsr	Animate_RawMultiDelayFlipY(pc)
		tst.w	d2
		beq.s	loc_89972
		cmpi.b	#6,$23(a0)
		bne.s	loc_89972
		bset	#1,$38(a0)

loc_89972:

		jsr	Swing_UpAndDown(pc)
		tst.w	$1A(a0)
		beq.s	loc_89986
		jsr	(MoveSprite2).l
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_89986:
		move.b	#8,5(a0)
		move.l	#byte_89B68,$30(a0)
		move.l	#loc_899A4,$34(a0)
		bra.w	loc_8991C
; ---------------------------------------------------------------------------

loc_899A0:
		jmp	Animate_RawAdjustFlipY(pc)
; ---------------------------------------------------------------------------

loc_899A4:
		move.b	#6,5(a0)
		move.l	#byte_89B5D,$30(a0)
		bra.s	loc_89940
; ---------------------------------------------------------------------------

loc_899B4:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_899C6(pc,d0.w),d1
		jsr	off_899C6(pc,d1.w)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------
off_899C6:	dc.w loc_899CC-off_899C6

		dc.w loc_899E8-off_899C6
		dc.w loc_89A20-off_899C6
; ---------------------------------------------------------------------------

loc_899CC:
		lea	word_89B1E(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		movea.w	$46(a0),a1
		cmpi.b	#4,$2C(a1)
		bne.s	locret_899E6
		move.b	#4,5(a0)

locret_899E6:
		rts
; ---------------------------------------------------------------------------

loc_899E8:
		lea	byte_89B4D(pc),a1
		jsr	Animate_RawNoSST(pc)
		movea.w	$46(a0),a1
		moveq	#0,d0
		move.b	$22(a1),d0
		btst	#1,$38(a1)
		beq.s	loc_89A04
		moveq	#2,d0

loc_89A04:
		add.w	d0,d0
		move.w	word_89A1A(pc,d0.w),$42(a0)
		btst	#5,$38(a1)
		bne.w	locret_8992C
		jmp	Refresh_ChildPositionAdjusted(pc)
; ---------------------------------------------------------------------------
word_89A1A:	dc.w $1404
		dc.w $C04
		dc.w 4
; ---------------------------------------------------------------------------

loc_89A20:
		lea	byte_89B73(pc),a1
		jsr	Animate_RawNoSST(pc)
		movea.w	$46(a0),a1
		moveq	#0,d0
		move.b	$22(a1),d0
		subq.w	#5,d0
		btst	#1,$38(a1)
		beq.s	loc_89A3E
		moveq	#2,d0

loc_89A3E:
		add.w	d0,d0
		move.w	word_89A54(pc,d0.w),$42(a0)
		btst	#5,$38(a1)
		bne.w	locret_8992C
		jmp	Refresh_ChildPositionAdjusted(pc)
; ---------------------------------------------------------------------------
word_89A54:	dc.w $FC14
		dc.w $FC0C
		dc.w $FC00
; ---------------------------------------------------------------------------

loc_89A5A:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_89A6C(pc,d0.w),d1
		jsr	off_89A6C(pc,d1.w)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------
off_89A6C:	dc.w loc_89A70-off_89A6C

		dc.w loc_89AA2-off_89A6C
; ---------------------------------------------------------------------------

loc_89A70:
		lea	ObjDat_89B06(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.b	#7,$1E(a0)
		move.l	#loc_89AB6,$34(a0)
		move.w	#$90,d0
		jsr	(Set_IndexedVelocity).l
		jsr	(Change_FlipXWithVelocity).l
		clr.b	$2C(a0)
		lea	ChildObjDat_89B24(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_89AA2:
		jsr	(MoveSprite_LightGravity).l
		tst.w	$1A(a0)
		bmi.w	locret_8992C
		jmp	(ObjHitFloor_DoRoutine).l
; ---------------------------------------------------------------------------

loc_89AB6:
		move.l	#loc_89826,(a0)
		move.b	#2,5(a0)
		move.w	#$800,$2E(a0)
		move.l	#loc_89926,$34(a0)
		move.l	#byte_89B2C,$30(a0)
		move.w	#$400,d0
		move.w	d0,$3A(a0)
		bclr	#3,$38(a0)
		btst	#0,4(a0)
		bne.s	loc_89AF6
		neg.w	d0
		bset	#3,$38(a0)

loc_89AF6:
		move.w	d0,$18(a0)
		move.w	#$20,$3C(a0)
		clr.w	$1A(a0)
		rts
; ---------------------------------------------------------------------------
ObjDat_89B06:	dc.l Map_TechnoSqueek

		dc.w $A52E
		dc.w $280
		dc.b $C
		dc.b 8
		dc.b 0
		dc.b $B
ObjDat3_89B12:	dc.l Map_TechnoSqueek
		dc.w $A52E
		dc.w $280
		dc.b 8
		dc.b $C
		dc.b 5
		dc.b $B
word_89B1E:	dc.w $280
		dc.b 8
		dc.b 4
		dc.b 2
		dc.b 0
ChildObjDat_89B24:dc.w 0

		dc.l loc_899B4
		dc.w $1404
byte_89B2C:	dc.b	0,   0

		dc.b	0, $17
		dc.b	1,   1
		dc.b  $41,   1
		dc.b	0, $1F
		dc.b  $F4
byte_89B37:	dc.b	0,   0
		dc.b	0, $37
		dc.b	1,   1
		dc.b  $41,   1
		dc.b	0, $1F
		dc.b  $F4
byte_89B42:	dc.b	3,   0
		dc.b	0,   1
		dc.b  $41,   0
		dc.b	0,   1
		dc.b  $41,   0
		dc.b  $F4
byte_89B4D:	dc.b	3,   2
		dc.b	3,   4
		dc.b  $FC
byte_89B52:	dc.b	5,   0
		dc.b	5, $17
		dc.b	6,   1
		dc.b  $46,   1
		dc.b	0, $1F
		dc.b  $F4
byte_89B5D:	dc.b	5,   0
		dc.b	5, $37
		dc.b	6,   1
		dc.b  $46,   1
		dc.b	5, $1F
		dc.b  $F4
byte_89B68:	dc.b	3,   5
		dc.b	5,   6
		dc.b  $46,   5
		dc.b	5,   6
		dc.b  $46,   5
		dc.b  $F4
byte_89B73:	dc.b	3,   7
		dc.b	8,   9
		dc.b  $FC
Map_TechnoSqueek:include "General\Sprites\Technosqueek\Map - Technosqueek.asm"

; ---------------------------------------------------------------------------

Obj_FBZEggPrison:

		lea	ObjDat3_89E78(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_89C14,(a0)
		lea	ChildObjDat_89EA8(pc),a2
		jsr	CreateChild1_Normal(pc)
		move.w	$48(a0),d0
		beq.s	locret_89C12
		movea.w	d0,a2
		btst	#0,(a2)
		beq.s	locret_89C12
		move.l	#loc_89C54,(a0)
		move.b	#1,$22(a0)
		bset	#5,$38(a0)

locret_89C12:

		rts
; ---------------------------------------------------------------------------

loc_89C14:

		btst	#1,$38(a0)
		beq.s	loc_89C54
		move.l	#loc_89C54,(a0)
		move.b	#1,$22(a0)
		move.w	$48(a0),d0
		beq.s	loc_89C34
		movea.w	d0,a2
		bset	#0,(a2)

loc_89C34:
		bsr.w	sub_89DAC
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_89C4C
		move.b	#8,$2C(a1)

loc_89C4C:
		lea	ChildObjDat_89EB0(pc),a2
		jsr	CreateChild1_Normal(pc)

loc_89C54:

		bsr.w	sub_89D9C
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------

loc_89C5C:
		lea	(word_86B3E).l,a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_8672A,(a0)
		movea.w	$46(a0),a1
		btst	#5,$38(a1)
		beq.s	locret_89C84
		move.l	#loc_86754,(a0)
		move.b	#$C,$22(a0)

locret_89C84:
		rts
; ---------------------------------------------------------------------------

Obj_FBZSpringPlunger:

		lea	ObjDat3_89E84(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.b	#5,$22(a0)
		jsr	(sub_86A3E).l
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	loc_89CDE
		move.b	#6,$22(a0)
		btst	#3,d0
		beq.s	loc_89CC4
		move.b	#$C,$22(a0)
		lea	($FFFFB000).w,a1
		move.w	#-$A00,d0
		jsr	(sub_8635E).l

loc_89CC4:
		btst	#4,d0
		beq.s	loc_89CDE
		move.b	#$C,$22(a0)
		lea	($FFFFB04A).w,a1
		move.w	#-$A00,d0
		jsr	(sub_8635E).l

loc_89CDE:

		jmp	Sprite_CheckDelete(pc)
; ---------------------------------------------------------------------------

loc_89CE2:

		lea	word_89E96(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_89D02,(a0)
		move.b	#8,$1E(a0)
		bsr.w	sub_89DEE
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_89D02:
		subq.w	#1,$2E(a0)
		bpl.s	loc_89D14
		move.l	#loc_89D18,(a0)
		move.w	#$80,8(a0)

loc_89D14:
		jmp	Sprite_CheckDelete(pc)
; ---------------------------------------------------------------------------

loc_89D18:
		jsr	MoveSprite_LightGravity(pc)
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_89D30
		add.w	d1,$14(a0)
		move.w	$3E(a0),$1A(a0)

loc_89D30:
		moveq	#0,d0
		btst	#3,($FFFFFE0F).w
		bne.s	loc_89D3C
		moveq	#1,d0

loc_89D3C:
		move.b	d0,$22(a0)
		jmp	Sprite_CheckDelete(pc)
; ---------------------------------------------------------------------------

loc_89D44:

		lea	ObjDat3_89E9C(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#Obj_Bouncing_Ring,(a0)
		move.b	#-1,($FFFFFEB6).w
		move.b	#8,$1E(a0)
		move.b	#8,$1F(a0)
		move.b	#-$7C,4(a0)
		moveq	#4,d0
		jsr	(Set_IndexedVelocity).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_89D78:

		lea	word_89E90(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#Obj_FlickerMove,(a0)
		jsr	(sub_86A64).l
		moveq	#4,d0
		jsr	(Set_IndexedVelocity).l
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_89D9C:
		moveq	#$2B,d1
		moveq	#$18,d2
		moveq	#$18,d3
		move.w	$10(a0),d4
		jmp	(SolidObjectFull).l
; End of function sub_89D9C


; =============== S U B R O U T I N E =======================================


sub_89DAC:
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		move.w	off_89DBC(pc,d0.w),d0
		jmp	off_89DBC(pc,d0.w)
; End of function sub_89DAC

; ---------------------------------------------------------------------------
off_89DBC:	dc.w loc_89DC4-off_89DBC, loc_89DCC-off_89DBC

		dc.w loc_89DDE-off_89DBC, loc_8F514-off_89DBC
; ---------------------------------------------------------------------------

loc_89DC4:
		lea	ChildObjDat_89ED0(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_89DCC:
		move.w	#-$47,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_89EF0(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_89DDE:
		lea	ChildObjDat_89F16(pc),a2
		jsr	CreateChild1_Normal(pc)
		lea	ChildObjDat_89F24(pc),a2
		jmp	CreateChild1_Normal(pc)

; =============== S U B R O U T I N E =======================================


sub_89DEE:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,d1
		andi.w	#6,d0
		lea	word_89E6C(pc),a1
		move.w	(a1,d0.w),d2
		move.w	d2,$1A(a0)
		move.w	d2,$3E(a0)
		andi.w	#2,d0
		move.w	d0,d2
		move.w	byte_89E74(pc,d2.w),$A(a0)
		moveq	#0,d2
		move.b	($FFFFFE10).w,d2
		add.w	d2,d2
		lea	(byte_2C7BA).l,a1
		adda.w	d2,a1
		lsr.w	#1,d0
		move.b	(a1,d0.w),d0
		lsl.w	#3,d0
		lea	(word_2C7EA).l,a2
		move.l	4(a2,d0.w),$C(a0)
		lsl.w	#2,d1
		move.w	d1,$2E(a0)
		movea.w	$46(a0),a1
		move.w	$10(a0),d0
		move.w	#$200,d1
		cmp.w	$10(a1),d0
		bcc.s	loc_89E54
		neg.w	d1

loc_89E54:
		move.w	d1,$18(a0)
		bclr	#0,4(a0)
		tst.w	$18(a0)
		bpl.s	locret_89E6A
		bset	#0,4(a0)

locret_89E6A:
		rts
; End of function sub_89DEE

; ---------------------------------------------------------------------------
word_89E6C:	dc.w  $FC80, $FD00, $FD80, $FE00
byte_89E74:	dc.b $85
		dc.b $80
		dc.b $85
		dc.b $92
ObjDat3_89E78:	dc.l Map_FBZEggCapsule

		dc.w 0
		dc.w $200
		dc.b $20
		dc.b $28
		dc.b 0
		dc.b 0
ObjDat3_89E84:	dc.l Map_FBZEggCapsule

		dc.w 0
		dc.w $180
		dc.b $10
		dc.b 8
		dc.b 5
		dc.b 0
word_89E90:	dc.w $100
		dc.b 8
		dc.b 8
		dc.b 2
		dc.b 0
word_89E96:	dc.w $280
		dc.b $20
		dc.b $28
		dc.b 0
		dc.b 0
ObjDat3_89E9C:	dc.l Map_Ring
		dc.w $A6BC
		dc.w $180
		dc.b 8
		dc.b 8
		dc.b 0
		dc.b $47
ChildObjDat_89EA8:dc.w 0
		dc.l loc_89C5C
		dc.w $DC
ChildObjDat_89EB0:dc.w 4
		dc.l loc_89D78
		dc.w $F8
		dc.l loc_89D78
		dc.w $F0F8
		dc.l loc_89D78
		dc.w $10F8
		dc.l loc_89D78
		dc.w $E8F8
		dc.l loc_89D78
		dc.w $18F8
ChildObjDat_89ED0:dc.w 4

		dc.l loc_89CE2
		dc.w $FC
		dc.l loc_89CE2
		dc.w $10FC
		dc.l loc_89CE2
		dc.w $F0FC
		dc.l loc_89CE2
		dc.w $1CFC
		dc.l loc_89CE2
		dc.w $E4FC
ChildObjDat_89EF0:dc.w 5
		dc.l loc_89D44
		dc.w $F8FC
		dc.l loc_89D44
		dc.w $8FC
		dc.l loc_89D44
		dc.w $10FC
		dc.l loc_89D44
		dc.w $F0FC
		dc.l loc_89D44
		dc.w $18FC
		dc.l loc_89D44
		dc.w $E8FC
ChildObjDat_89F16:dc.w 1
		dc.l loc_89650
		dc.w $E8FC
		dc.l loc_89650
		dc.w $18FC
ChildObjDat_89F24:dc.w 1
		dc.l loc_89A5A
		dc.w $F8FC
		dc.l loc_89A5A
		dc.w $8FC
; ---------------------------------------------------------------------------

Obj_ICZPathFollowPlatform:

		jsr	(Obj_WaitOffscreen).l

loc_89F38:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_89F6A(pc,d0.w),d1
		move.w	$10(a0),-(sp)
		jsr	off_89F6A(pc,d1.w)
		moveq	#$2B,d1
		moveq	#$14,d2
		moveq	#$14,d3
		move.w	(sp)+,d4
		btst	#7,$2A(a0)
		bne.s	loc_89F64
		jsr	(SolidObjectFull).l
		bsr.w	sub_8A3C4

loc_89F64:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
off_89F6A:	dc.w loc_89F7E-off_89F6A

		dc.w loc_89FB6-off_89F6A
		dc.w loc_89FD6-off_89F6A
		dc.w loc_89FF2-off_89F6A
		dc.w loc_8A036-off_89F6A
		dc.w loc_8A11C-off_89F6A
		dc.w locret_8A176-off_89F6A
		dc.w loc_8A178-off_89F6A
		dc.w loc_8A192-off_89F6A
		dc.w loc_8A1AE-off_89F6A
; ---------------------------------------------------------------------------

loc_89F7E:
		lea	ObjDat3_8A3E2(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.w	a0,($FFFFFAA4).w
		move.b	#$20,$1F(a0)
		move.b	#$12,$1E(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		move.b	byte_89FB2(pc,d0.w),5(a0)
		tst.w	d0
		bne.w	locret_8A034
		lea	ChildObjDat_8A436(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------
byte_89FB2:	dc.b 2
		dc.b 6
		dc.b $C
		dc.b $E
; ---------------------------------------------------------------------------

loc_89FB6:
		btst	#3,$2A(a0)
		bne.s	loc_89FC0
		rts
; ---------------------------------------------------------------------------

loc_89FC0:
		move.b	#4,5(a0)
		move.w	#$F,$2E(a0)
		move.l	#loc_89FEA,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_89FD6:
		moveq	#1,d0
		btst	#0,($FFFFFE0F).w
		beq.s	loc_89FE2
		neg.w	d0

loc_89FE2:
		add.w	d0,$10(a0)
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_89FEA:
		move.b	#$A,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_89FF2:
		btst	#5,$2A(a0)
		beq.s	loc_8A004
		move.b	($FFFFF604).w,d0
		andi.b	#$C,d0
		bne.s	loc_8A00A

loc_8A004:
		clr.b	$39(a0)
		rts
; ---------------------------------------------------------------------------

loc_8A00A:
		addq.b	#1,$39(a0)
		cmpi.b	#$10,$39(a0)
		bcs.w	locret_8A034
		move.b	#8,5(a0)
		lea	($FFFFB000).w,a1
		jsr	Find_SonicTails(pc)
		move.w	#$80,d1
		tst.w	d0
		beq.s	loc_8A030
		neg.w	d1

loc_8A030:
		move.w	d1,$18(a0)

locret_8A034:

		rts
; ---------------------------------------------------------------------------

loc_8A036:
		cmpi.w	#-$100,($FFFFEE18).w
		bne.s	loc_8A046
		move.w	($FFFFEEAA).w,d0
		and.w	d0,$14(a0)

loc_8A046:
		jsr	(MoveSprite2).l
		jsr	(ObjHitFloor).l
		cmpi.w	#8,d1
		bge.s	loc_8A09E
		move.b	d3,$26(a0)
		add.w	d1,$14(a0)
		move.b	d3,d0
		bpl.s	loc_8A066
		neg.b	d0

loc_8A066:
		andi.b	#-8,d0
		beq.s	loc_8A07C
		move.w	$18(a0),d0
		add.w	d3,d3
		ext.w	d3
		asr.w	#1,d3
		add.w	d3,d0
		bsr.w	sub_8A35A

loc_8A07C:
		tst.w	$18(a0)
		bmi.s	loc_8A090
		moveq	#$1C,d3
		jsr	(ObjHitWall).l
		tst.w	d1
		bmi.s	loc_8A0AA
		rts
; ---------------------------------------------------------------------------

loc_8A090:
		moveq	#-$1C,d3
		jsr	(ObjHitWall2).l
		tst.w	d1
		bmi.s	loc_8A0F4
		rts
; ---------------------------------------------------------------------------

loc_8A09E:
		move.b	#$A,5(a0)
		bsr.w	sub_8A386
		rts
; ---------------------------------------------------------------------------

loc_8A0AA:
		move.b	#$C,5(a0)
		clr.b	($FFFFEE39).w
		clr.w	$18(a0)
		clr.w	$1A(a0)
		tst.b	$2C(a0)
		beq.w	locret_8A034
		lea	ChildObjDat_8A42A(pc),a2
		jsr	CreateChild6_Simple(pc)
		jsr	(Create_New_Sprite3).l
		bne.s	loc_8A0EC
		move.l	#Obj_Spring,(a1)
		move.w	#$5D5A,$10(a1)
		move.w	#$27A,$14(a1)
		move.b	#0,$2C(a1)

loc_8A0EC:
		jsr	Displace_PlayerOffObject(pc)
		jmp	loc_85088(pc)
; ---------------------------------------------------------------------------

loc_8A0F4:
		move.b	#$C,5(a0)
		rts
; ---------------------------------------------------------------------------
		dc.w 0
		dc.w 8
		dc.w $10
		dc.w $18
		dc.w $20
		dc.w $28
		dc.w $30
		dc.w $38
		dc.w $FFC8
		dc.w $FFD0
		dc.w $FFD8
		dc.w $FFE0
		dc.w $FFE8
		dc.w $FFF0
		dc.w $FFF8
		dc.w 0
; ---------------------------------------------------------------------------

loc_8A11C:
		bsr.w	sub_8A36C
		jsr	(MoveSprite2).l
		jsr	(ObjHitFloor).l
		tst.w	d1
		bmi.s	loc_8A15E
		tst.w	$18(a0)
		beq.s	locret_8A15C
		bmi.s	loc_8A148
		moveq	#$20,d3
		jsr	(ObjHitWall).l
		tst.w	d1
		bmi.s	loc_8A154
		bra.w	locret_8A15C
; ---------------------------------------------------------------------------

loc_8A148:
		moveq	#-$20,d3
		jsr	(ObjHitWall2).l
		tst.w	d1
		bpl.s	locret_8A15C

loc_8A154:
		add.w	d1,$10(a0)
		clr.w	$18(a0)

locret_8A15C:

		rts
; ---------------------------------------------------------------------------

loc_8A15E:
		move.b	#8,5(a0)
		move.w	$1A(a0),d0
		btst	#6,d3
		beq.s	loc_8A170
		neg.w	d0

loc_8A170:
		move.w	d0,$18(a0)
		rts
; ---------------------------------------------------------------------------

locret_8A176:
		rts
; ---------------------------------------------------------------------------

loc_8A178:
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		bne.s	loc_8A184
		rts
; ---------------------------------------------------------------------------

loc_8A184:
		move.b	#$10,5(a0)
		move.w	$14(a0),$3A(a0)
		rts
; ---------------------------------------------------------------------------

loc_8A192:
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	loc_8A1A2
		addq.w	#1,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_8A1A2:
		move.b	#$12,5(a0)
		clr.w	$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_8A1AE:
		addi.w	#-$20,$1A(a0)
		jsr	(MoveSprite2).l
		move.w	$14(a0),d0
		cmp.w	$3A(a0),d0
		bls.s	loc_8A1C6
		rts
; ---------------------------------------------------------------------------

loc_8A1C6:
		move.b	#$E,5(a0)
		move.w	$3A(a0),$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_8A1D4:
		lea	ObjDat3_8A412(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#AnimateRaw_MoveChkDel,(a0)
		move.l	#byte_8A43E,$30(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_8A200(pc,d0.w),$42(a0)
		jsr	Refresh_ChildPosition(pc)
		moveq	#8,d0
		jmp	Set_IndexedVelocity(pc)
; ---------------------------------------------------------------------------
word_8A200:	dc.w $ECF7
		dc.w $14F4
		dc.w $1400
		dc.w $C0C
		dc.w $F809
		dc.w $FCFA
; ---------------------------------------------------------------------------

loc_8A20C:
		lea	ObjDat3_8A41E(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_8A258,(a0)
		move.l	#byte_8A444,$30(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		move.w	#$5F,$2E(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_8A246(pc,d0.w),$42(a0)
		jsr	Refresh_ChildPosition(pc)
		moveq	#0,d0
		jmp	Set_IndexedVelocity(pc)
; ---------------------------------------------------------------------------
word_8A246:	dc.w $ECD0
		dc.w $8CC
		dc.w $F4EC
		dc.w $10E0
		dc.w $AFC
		dc.w $EC0C
		dc.w $818
		dc.w $F028
		dc.w $C34
; ---------------------------------------------------------------------------

loc_8A258:
		jsr	Animate_Raw(pc)
		jsr	(MoveSprite).l
		jsr	Obj_Wait(pc)
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_ICZBreakableWall:

		lea	ObjDat3_8A406(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_8A280,(a0)
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_8A280:
		moveq	#$2B,d1
		moveq	#$40,d2
		moveq	#$70,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		cmpi.b	#2,($FFFFB038).w
		bne.s	loc_8A2A0
		swap	d6
		andi.w	#1,d6
		bne.s	loc_8A2E2

loc_8A2A0:
		movea.w	($FFFFFAA4).w,a1
		cmpi.l	#loc_89F38,(a1)
		bne.s	loc_8A2DC
		move.w	$10(a1),d0
		move.w	$14(a1),d1
		and.w	($FFFFEEAA).w,d1
		move.w	$10(a0),d2
		move.w	$14(a0),d3
		lea	word_8A2FC(pc),a2
		add.w	(a2)+,d2
		cmp.w	d2,d0
		bcs.s	loc_8A2DC
		add.w	(a2)+,d2
		cmp.w	d2,d0
		bcc.s	loc_8A2DC
		add.w	(a2)+,d3
		cmp.w	d3,d1
		bcs.s	loc_8A2DC
		add.w	(a2)+,d3
		cmp.w	d3,d1
		bcs.s	loc_8A2E2

loc_8A2DC:

		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_8A2E2:

		lea	ChildObjDat_8A430(pc),a2
		jsr	CreateChild6_Simple(pc)
		jsr	Go_Delete_Sprite(pc)
		moveq	#$59,d0
		jsr	(Play_Sound_2).l
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------
word_8A2FC:	dc.w  $FFD0,   $60, $FFC0,   $80
; ---------------------------------------------------------------------------

loc_8A304:
		lea	ObjDat3_8A3FA(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_8A318,(a0)
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_8A318:
		movea.w	$46(a0),a1
		btst	#3,$2A(a1)
		beq.s	loc_8A32A
		move.l	#MoveChkDel,(a0)

loc_8A32A:
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

Obj_BB_1:
		jsr	(Obj_WaitOffscreen).l
		lea	ObjDat3_8A3EE(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_8A344,(a0)

loc_8A344:
		moveq	#$1B,d1
		moveq	#$10,d2
		moveq	#$11,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_8A35A:
		cmpi.w	#-$C00,d0
		blt.s	locret_8A36A
		cmpi.w	#$C00,d0
		bgt.s	locret_8A36A
		move.w	d0,$18(a0)

locret_8A36A:
		rts
; End of function sub_8A35A


; =============== S U B R O U T I N E =======================================


sub_8A36C:
		move.w	$1A(a0),d0
		addi.w	#$38,d0
		cmpi.w	#-$C00,d0
		blt.s	locret_8A384
		cmpi.w	#$C00,d0
		bgt.s	locret_8A384
		move.w	d0,$1A(a0)

locret_8A384:

		rts
; End of function sub_8A36C


; =============== S U B R O U T I N E =======================================


sub_8A386:
		move.b	$26(a0),d3
		lsr.b	#3,d3
		andi.w	#$E,d3
		move.w	$18(a0),d1
		bpl.s	loc_8A398
		neg.w	d1

loc_8A398:
		move.w	off_8A3A0(pc,d3.w),d0
		jmp	off_8A3A0(pc,d0.w)
; End of function sub_8A386

; ---------------------------------------------------------------------------
off_8A3A0:	dc.w loc_8A3B0-off_8A3A0

		dc.w loc_8A3B6-off_8A3A0
		dc.w loc_8A3BE-off_8A3A0
		dc.w loc_8A3B6-off_8A3A0
		dc.w loc_8A3B0-off_8A3A0
		dc.w loc_8A3B6-off_8A3A0
		dc.w loc_8A3BE-off_8A3A0
		dc.w loc_8A3B6-off_8A3A0
; ---------------------------------------------------------------------------

loc_8A3B0:
		clr.w	$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_8A3B6:
		lsr.w	#1,d1
		move.w	d1,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_8A3BE:
		move.w	d1,$1A(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_8A3C4:
		clr.b	($FFFFEE39).w
		tst.w	$18(a0)
		bne.s	loc_8A3D4
		tst.w	$1A(a0)
		beq.s	locret_8A3E0

loc_8A3D4:
		btst	#3,$2A(a0)
		beq.s	locret_8A3E0
		st	($FFFFEE39).w

locret_8A3E0:

		rts
; End of function sub_8A3C4

; ---------------------------------------------------------------------------
ObjDat3_8A3E2:	dc.l Map_ICZPlatforms
		dc.w $43B6
		dc.w $280
		dc.b $20
		dc.b $14
		dc.b 0
		dc.b 0
ObjDat3_8A3EE:	dc.l Map_ICZPlatforms
		dc.w $4377
		dc.w $280
		dc.b $10
		dc.b $10
		dc.b $1E
		dc.b 0
ObjDat3_8A3FA:	dc.l Map_ICZWallAndColumn
		dc.w $4001
		dc.w $280
		dc.b $10
		dc.b $C
		dc.b 8
		dc.b 0
ObjDat3_8A406:	dc.l Map_ICZWallAndColumn
		dc.w $4001
		dc.w $280
		dc.b $20
		dc.b $40
		dc.b 6
		dc.b 0
ObjDat3_8A412:	dc.l Map_ICZPlatforms
		dc.w $C3B6
		dc.w $80
		dc.b 8
		dc.b 8
		dc.b $23
		dc.b 0
ObjDat3_8A41E:	dc.l Map_ICZPlatforms
		dc.w $C347
		dc.w $80
		dc.b $C
		dc.b $C
		dc.b $1C
		dc.b 0
ChildObjDat_8A42A:dc.w 5
		dc.l loc_8A1D4
ChildObjDat_8A430:dc.w 8
		dc.l loc_8A20C
ChildObjDat_8A436:dc.w 0
		dc.l loc_8A304
		dc.w $F010
byte_8A43E:	dc.b	2, $23
		dc.b  $13, $24
		dc.b  $14, $FC
byte_8A444:	dc.b	2, $1C
		dc.b  $1D, $25
		dc.b  $26, $FC
; ---------------------------------------------------------------------------

Obj_ICZCrushingColumn:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8A46E(pc,d0.w),d1
		move.w	$10(a0),-(sp)
		jsr	off_8A46E(pc,d1.w)
		moveq	#$2B,d1
		moveq	#$70,d2
		moveq	#$70,d3
		move.w	(sp)+,d4
		jsr	(SolidObjectFull).l
		jmp	Sprite_CheckDelete(pc)
; ---------------------------------------------------------------------------
off_8A46E:	dc.w loc_8A488-off_8A46E

		dc.w loc_8A4C4-off_8A46E
		dc.w loc_8A4D6-off_8A46E
		dc.w loc_8A4DE-off_8A46E
		dc.w loc_8A504-off_8A46E
		dc.w loc_8A50C-off_8A46E
		dc.w loc_8A51C-off_8A46E
		dc.w loc_8A562-off_8A46E
		dc.w loc_8A586-off_8A46E
		dc.w loc_8A596-off_8A46E
		dc.w loc_8A5AC-off_8A46E
		dc.w loc_8A5C8-off_8A46E
		dc.w loc_8A5E4-off_8A46E
; ---------------------------------------------------------------------------

loc_8A488:
		lea	ObjDat3_8A626(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.b	#$70,$1E(a0)
		move.w	$14(a0),$3E(a0)
		move.w	#$1F,$2E(a0)
		cmpi.b	#3,$2C(a0)
		bcc.s	loc_8A4B8
		move.b	#$C,$22(a0)
		lea	ChildObjDat_8A638(pc),a2
		jsr	CreateChild1_Normal(pc)

loc_8A4B8:

		move.b	$2C(a0),d0
		add.b	d0,d0
		move.b	d0,5(a0)

locret_8A4C2:

		rts
; ---------------------------------------------------------------------------

loc_8A4C4:
		move.b	$2A(a0),d0
		andi.b	#$18,d0
		beq.s	locret_8A4C2

loc_8A4CE:
		move.b	#$C,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_8A4D6:
		subq.w	#1,$2E(a0)
		bmi.s	loc_8A4CE
		rts
; ---------------------------------------------------------------------------

loc_8A4DE:
		lea	($FFFFB000).w,a1
		jsr	Find_OtherObject(pc)
		cmpi.w	#$28,d2
		bcs.w	locret_8A4C2
		btst	#0,4(a0)
		beq.s	loc_8A4F8
		subq.w	#2,d0

loc_8A4F8:
		tst.w	d0
		beq.s	locret_8A4C2

loc_8A4FC:
		move.b	#$10,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_8A504:
		subq.w	#1,$2E(a0)
		bmi.s	loc_8A4FC
		rts
; ---------------------------------------------------------------------------

loc_8A50C:
		cmpi.b	#2,($FFFFB038).w
		bne.s	loc_8A516
		rts
; ---------------------------------------------------------------------------

loc_8A516:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_8A51C:
		move.w	$1A(a0),d0
		addi.w	#-$20,d0
		cmpi.w	#-$400,d0
		ble.s	loc_8A52E
		move.w	d0,$1A(a0)

loc_8A52E:
		jsr	(MoveSprite2).l
		jsr	(ObjHitCeiling).l
		tst.w	d1
		bpl.w	locret_8A4C2

loc_8A540:

		add.w	d1,$14(a0)
		move.b	#$12,5(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_8A59A,$34(a0)
		moveq	#-$6A,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_8A562:
		move.w	$1A(a0),d0
		addi.w	#$20,d0
		cmpi.w	#$400,d0
		bgt.s	loc_8A574
		move.w	d0,$1A(a0)

loc_8A574:
		jsr	(MoveSprite2).l
		jsr	(ObjHitFloor).l
		tst.w	d1
		bmi.s	loc_8A540
		rts
; ---------------------------------------------------------------------------

loc_8A586:
		addq.w	#8,$14(a0)
		jsr	(ObjHitFloor).l
		tst.w	d1
		bmi.s	loc_8A540
		rts
; ---------------------------------------------------------------------------

loc_8A596:
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_8A59A:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.b	locret_8A5A6+1(pc,d0.w),5(a0)

locret_8A5A6:
		rts
; ---------------------------------------------------------------------------
		dc.b $16
		dc.b $16
		dc.b $18
		dc.b $14
; ---------------------------------------------------------------------------

loc_8A5AC:
		move.w	$14(a0),d0
		subq.w	#1,d0
		cmp.w	$3E(a0),d0
		bls.s	loc_8A5BE
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_8A5BE:
		move.w	#$5F,$2E(a0)
		bra.w	loc_8A4B8
; ---------------------------------------------------------------------------

loc_8A5C8:
		move.w	$14(a0),d0
		addq.w	#1,d0
		cmp.w	$3E(a0),d0
		bcc.s	loc_8A5DA
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_8A5DA:
		move.w	#$5F,$2E(a0)
		bra.w	loc_8A4B8
; ---------------------------------------------------------------------------

loc_8A5E4:
		lea	($FFFFB000).w,a1
		jsr	Find_OtherObject(pc)
		btst	#0,4(a0)
		beq.s	loc_8A5F6
		subq.w	#2,d0

loc_8A5F6:
		tst.w	d0
		bne.w	locret_8A4C2
		move.b	#$14,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_8A604:
		move.l	#loc_8A612,(a0)
		lea	word_8A632(pc),a1
		jsr	SetUp_ObjAttributes3(pc)

loc_8A612:
		movea.w	$46(a0),a1
		move.w	$14(a1),d0
		addi.w	#$B0,d0
		move.w	d0,$14(a0)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------
ObjDat3_8A626:	dc.l Map_ICZWallAndColumn
		dc.w $4001
		dc.w $280
		dc.b $20
		dc.b $70
		dc.b 2
		dc.b 0
word_8A632:	dc.w $280
		dc.b $20
		dc.b $40
		dc.b $D
		dc.b 0
ChildObjDat_8A638:dc.w 0
		dc.l loc_8A604
		dc.w 0
; ---------------------------------------------------------------------------

Obj_ICZFreezer:

		jsr	Obj_WaitOffscreen(pc)
		move.l	#loc_8A656,(a0)
		lea	ObjDat3_8AA96(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------

loc_8A656:

		jsr	Find_SonicTails(pc)
		cmpi.w	#$40,d2
		bcc.s	loc_8A67A
		move.l	#loc_8A67E,(a0)
		clr.w	$2E(a0)
		clr.w	$30(a0)
		clr.b	$39(a0)
		moveq	#$7F,d0
		jsr	(Play_Sound_2).l

loc_8A67A:
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------

loc_8A67E:
		jsr	Find_SonicTails(pc)
		cmpi.w	#$40,d2
		bcc.s	loc_8A6C6
		subq.w	#1,$30(a0)
		bpl.s	loc_8A6AA
		moveq	#0,d0
		move.b	$39(a0),d0
		bchg	#1,d0
		move.b	d0,$39(a0)
		move.w	word_8A6DE(pc,d0.w),$30(a0)
		move.w	off_8A6E2(pc,d0.w),d0
		jsr	off_8A6E2(pc,d0.w)

loc_8A6AA:
		btst	#1,$38(a0)
		beq.s	loc_8A6C2
		subq.w	#1,$2E(a0)
		bpl.s	loc_8A6C2
		move.w	#1,$2E(a0)
		bsr.w	sub_8A708

loc_8A6C2:

		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------

loc_8A6C6:
		move.l	#loc_8A656,(a0)
		bclr	#1,$38(a0)
		moveq	#-$1C,d0
		jsr	(Play_Sound_2).l
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------
word_8A6DE:	dc.w $40
		dc.w $40
off_8A6E2:	dc.w loc_8A6E6-off_8A6E2

		dc.w loc_8A6EE-off_8A6E2
; ---------------------------------------------------------------------------

loc_8A6E6:
		bclr	#1,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_8A6EE:
		bset	#1,$38(a0)
		lea	ChildObjDat_8AAD2(pc),a2
		btst	#1,4(a0)
		beq.s	loc_8A704
		lea	ChildObjDat_8AADA(pc),a2

loc_8A704:
		jmp	CreateChild1_Normal(pc)

; =============== S U B R O U T I N E =======================================


sub_8A708:
		lea	ChildObjDat_8AAC2(pc),a2
		btst	#1,4(a0)
		beq.s	loc_8A718
		lea	ChildObjDat_8AACA(pc),a2

loc_8A718:
		jmp	CreateChild1_Normal(pc)
; End of function sub_8A708

; ---------------------------------------------------------------------------

loc_8A71C:

		lea	word_8AAA2(pc),a1
		jsr	SetUp_ObjAttributes2(pc)
		move.l	#loc_8A72C,(a0)

locret_8A72A:
		rts
; ---------------------------------------------------------------------------

loc_8A72C:
		bsr.w	sub_8A916
		jsr	Refresh_ChildPosition(pc)
		subq.b	#1,$3A(a0)
		bpl.w	locret_8A72A
		move.b	#2,$3A(a0)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8A748:

		move.l	#loc_8A75C,(a0)
		move.w	#$1F,$2E(a0)
		lea	ObjDat3_8AA96(pc),a1
		jmp	SetUp_ObjAttributes(pc)
; ---------------------------------------------------------------------------

loc_8A75C:
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		beq.s	loc_8A78C
		subq.w	#1,$2E(a0)
		bmi.s	loc_8A770
		rts
; ---------------------------------------------------------------------------

loc_8A770:
		move.l	#loc_8A778,(a0)
		rts
; ---------------------------------------------------------------------------

loc_8A778:
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		beq.s	loc_8A78C
		lea	word_8AA30(pc),a1
		bra.w	sub_8A9C6
; ---------------------------------------------------------------------------

loc_8A78C:

		move.l	#loc_8A7A2,(a0)
		move.w	#$1F,$2E(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8A7A2:
		jsr	Obj_Wait(pc)
		lea	word_8AA30(pc),a1
		bra.w	sub_8A9C6
; ---------------------------------------------------------------------------

loc_8A7AE:
		lea	ObjDat3_8AAAA(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_8A80C,(a0)
		move.b	#$10,$1E(a0)
		movea.w	$44(a0),a1
		move.w	$10(a1),d0
		move.w	d0,$10(a0)
		move.w	$14(a1),$14(a0)
		btst	#0,4(a1)
		beq.s	loc_8A7E2
		bset	#0,4(a0)

loc_8A7E2:
		movea.w	$46(a0),a2
		move.w	#$200,d1
		cmp.w	$10(a2),d0
		bcc.s	loc_8A7F2
		neg.w	d1

loc_8A7F2:
		move.w	d1,$18(a0)
		move.w	#-$400,$1A(a0)
		move.w	#$7F,$2E(a0)
		move.l	#loc_8A88A,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8A80C:
		move.w	($FFFFEE78).w,d0
		tst.w	$18(a0)
		bmi.s	loc_8A824
		addi.w	#$128,d0
		cmp.w	$10(a0),d0
		bcs.s	loc_8A82E
		bra.w	loc_8A832
; ---------------------------------------------------------------------------

loc_8A824:
		addi.w	#$20,d0
		cmp.w	$10(a0),d0
		bcs.s	loc_8A832

loc_8A82E:
		clr.w	$18(a0)

loc_8A832:

		jsr	(MoveSprite).l
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_8A84C
		add.w	d1,$14(a0)
		move.l	#loc_8A84C,(a0)

loc_8A84C:

		movea.w	$44(a0),a1
		move.w	$10(a0),d0
		move.w	$14(a0),d1
		cmpi.b	#2,$38(a1)
		bne.s	loc_8A870
		moveq	#-4,d2
		btst	#0,4(a1)
		beq.s	loc_8A86C
		neg.w	d2

loc_8A86C:
		add.w	d2,d0
		addq.w	#2,d1

loc_8A870:
		move.w	d0,$10(a1)
		move.w	d1,$14(a1)
		subq.w	#1,$2E(a0)
		bmi.s	loc_8A88A
		bsr.w	sub_8AA38
		bne.s	loc_8A8BA
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8A88A:

		movea.w	$44(a0),a1
		btst	#1,$2B(a1)
		movea.l	a0,a2
		movea.l	a1,a0
		jsr	(HurtSonic2).l
		cmpi.b	#$18,$20(a0)
		beq.s	loc_8A8B8
		move.w	#$200,d0
		btst	#0,4(a0)
		bne.s	loc_8A8B4
		neg.w	d0

loc_8A8B4:
		move.w	d0,$18(a0)

loc_8A8B8:
		movea.l	a2,a0

loc_8A8BA:
		movea.w	$44(a0),a1
		bset	#1,$2A(a1)
		clr.b	$2E(a1)
		move.b	#$78,$34(a1)
		lea	ChildObjDat_8AAEA(pc),a2
		jsr	CreateChild1_Normal(pc)
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_8A8DC:

		lea	ObjDat3_8AAB6(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#AnimateRaw_MoveChkDel,(a0)
		move.l	#byte_8AB3E,$30(a0)
		cmpi.b	#8,$2C(a0)
		bcc.s	loc_8A902
		move.l	#byte_8AB34,$30(a0)

loc_8A902:
		jsr	(Random_Number).l
		andi.b	#3,d0
		move.b	d0,$23(a0)
		moveq	#$C,d0
		jmp	Set_IndexedVelocity(pc)

; =============== S U B R O U T I N E =======================================


sub_8A916:
		subq.w	#1,$2E(a0)
		bpl.s	locret_8A96E
		move.w	#2,$2E(a0)
		moveq	#0,d0
		move.b	$39(a0),d0
		addq.b	#4,d0
		cmpi.b	#$48,d0
		bcc.s	loc_8A970
		move.b	d0,$39(a0)
		lea	byte_8A97A(pc,d0.w),a1
		move.b	(a1)+,$43(a0)
		move.b	(a1)+,$22(a0)
		move.b	(a1)+,d2
		jsr	(Random_Number).l
		and.b	d2,d0
		move.w	d2,d3
		lsr.b	#1,d3
		sub.b	d3,d0
		move.b	d0,$42(a0)
		swap	d0
		and.b	d2,d0
		sub.b	d3,d0
		movea.w	$46(a0),a1
		btst	#1,4(a1)
		beq.s	loc_8A96A
		neg.b	$43(a0)

loc_8A96A:
		add.b	d0,$43(a0)

locret_8A96E:
		rts
; ---------------------------------------------------------------------------

loc_8A970:
		jsr	(Delete_Current_Sprite).l
		addq.w	#4,sp
		rts
; End of function sub_8A916

; ---------------------------------------------------------------------------
byte_8A97A:	dc.b  $10, $16,	  3,   0
		dc.b  $10, $16,	  3,   0
		dc.b  $14, $16,	  3,   0
		dc.b  $18, $16,	  3,   0
		dc.b  $1C, $16,	  7,   0
		dc.b  $22, $17,	  7,   0
		dc.b  $26, $17,	  7,   0
		dc.b  $2E, $17,	  7,   0
		dc.b  $32, $17,	  7,   0
		dc.b  $3C, $18,	  7,   0
		dc.b  $40, $18,	 $F,   0
		dc.b  $4D, $19,	 $F,   0
		dc.b  $52, $19,	 $F,   0
		dc.b  $4B, $19,	 $F,   0
		dc.b  $44, $19,	 $F,   0
		dc.b  $42, $19,	 $F,   0
		dc.b  $3E, $18,	 $F,   0
		dc.b  $3B, $17,	 $F,   0
		dc.b  $38, $16,	 $F,   0

; =============== S U B R O U T I N E =======================================


sub_8A9C6:

		jsr	Check_PlayerInRange(pc)
		tst.l	d0
		beq.s	locret_8AA2E
		tst.w	d0
		beq.s	loc_8A9D8
		movea.w	d0,a4
		bsr.w	sub_8A9E0

loc_8A9D8:
		swap	d0
		tst.w	d0
		beq.s	locret_8AA2E
		movea.w	d0,a4
; End of function sub_8A9C6


; =============== S U B R O U T I N E =======================================


sub_8A9E0:
		tst.b	$2E(a4)
		bne.s	locret_8AA2E
		btst	#1,$2B(a4)
		bne.s	locret_8AA2E
		tst.b	$34(a4)
		bne.s	locret_8AA2E
		cmpi.b	#4,5(a4)
		bcc.s	locret_8AA2E
		move.b	#-$7F,$2E(a4)
		move.b	#$1A,$20(a4)
		bset	#1,$2A(a4)
		clr.b	$3D(a4)
		clr.w	$18(a4)
		clr.w	$1A(a4)
		clr.w	$1C(a4)
		move.l	d0,d4
		lea	ChildObjDat_8AAE2(pc),a2
		jsr	CreateChild1_Normal(pc)
		move.l	d4,d0
		move.w	a4,$44(a1)

locret_8AA2E:

		rts
; End of function sub_8A9E0

; ---------------------------------------------------------------------------
word_8AA30:	dc.w  $FFF0,   $20, $FFD8,   $50


; =============== S U B R O U T I N E =======================================


sub_8AA38:
		lea	($FFFFB000).w,a3
		cmpa.w	$44(a0),a3
		bne.s	loc_8AA46
		lea	($FFFFB04A).w,a3

loc_8AA46:
		tst.w	$1A(a3)
		bmi.s	loc_8AA8A
		cmpi.b	#2,$20(a3)
		beq.s	loc_8AA5C
		cmpi.b	#9,$20(a3)
		bne.s	loc_8AA8A

loc_8AA5C:
		lea	word_8AA8E(pc),a1
		jsr	Check_PlayerInRange(pc)
		tst.l	d0
		beq.s	locret_8AA88
		tst.w	d0
		beq.s	loc_8AA74
		movea.w	d0,a4
		tst.b	$2E(a4)
		beq.s	loc_8AA82

loc_8AA74:
		swap	d0
		tst.w	d0
		beq.s	locret_8AA88
		movea.w	d0,a4
		tst.b	$2E(a4)
		bne.s	loc_8AA8A

loc_8AA82:
		neg.w	$1A(a3)
		moveq	#1,d0

locret_8AA88:

		rts
; ---------------------------------------------------------------------------

loc_8AA8A:

		moveq	#0,d0
		rts
; End of function sub_8AA38

; ---------------------------------------------------------------------------
word_8AA8E:	dc.w $FFE4,  $38,$FFE8,	 $30
ObjDat3_8AA96:	dc.l Map_ICZPlatforms

		dc.w $23B6
		dc.w $280
		dc.b $10
		dc.b $C
		dc.b 6
		dc.b $9A
word_8AAA2:	dc.w $43B6
		dc.w $80
		dc.b $C
		dc.b $C
		dc.b $16
		dc.b 0
ObjDat3_8AAAA:	dc.l Map_ICZPlatforms
		dc.w $43B6
		dc.w $80
		dc.b $14
		dc.b $10
		dc.b 2
		dc.b 0
ObjDat3_8AAB6:	dc.l Map_ICZPlatforms
		dc.w $43B6
		dc.w $80
		dc.b 4
		dc.b 4
		dc.b $C
		dc.b 0
ChildObjDat_8AAC2:dc.w 0
		dc.l loc_8A71C
		dc.w $C
ChildObjDat_8AACA:dc.w 0
		dc.l loc_8A71C
		dc.w $F4
ChildObjDat_8AAD2:dc.w 0
		dc.l loc_8A748
		dc.w $30
ChildObjDat_8AADA:dc.w 0
		dc.l loc_8A748
		dc.w $D0
ChildObjDat_8AAE2:dc.w 0
		dc.l loc_8A7AE
		dc.w 0
ChildObjDat_8AAEA:dc.w $B

		dc.l loc_8A8DC
		dc.w $F4F8
		dc.l loc_8A8DC
		dc.w $FCF8
		dc.l loc_8A8DC
		dc.w $4F8
		dc.l loc_8A8DC
		dc.w $CF8
		dc.l loc_8A8DC
		dc.w $F400
		dc.l loc_8A8DC
		dc.w $FC00
		dc.l loc_8A8DC
		dc.w $400
		dc.l loc_8A8DC
		dc.w $C00
		dc.l loc_8A8DC
		dc.w $F408
		dc.l loc_8A8DC
		dc.w $FC08
		dc.l loc_8A8DC
		dc.w $408
		dc.l loc_8A8DC
		dc.w $C08
byte_8AB34:	dc.b	0, $27

		dc.b  $23, $27
		dc.b  $13, $27
		dc.b  $24, $27
		dc.b  $14, $FC
byte_8AB3E:	dc.b	0, $27

		dc.b   $C, $27
		dc.b   $D, $27
		dc.b   $E, $FC
byte_8AB46:	dc.b	0, $27
		dc.b   $F, $27
		dc.b  $10, $27
		dc.b  $11, $FC
; ---------------------------------------------------------------------------

Obj_ICZSegmentColumn:

		lea	ObjDat3_8ACE2(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#Sprite_CheckDelete2,(a0)
		lea	ChildObjDat_8ACF4(pc),a2
		tst.b	$2C(a0)
		beq.s	loc_8AB6A
		lea	ChildObjDat_8ACFC(pc),a2

loc_8AB6A:
		jmp	CreateChild8_TreeListRepeated(pc)
; ---------------------------------------------------------------------------
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_8AB82
		rts
; ---------------------------------------------------------------------------

loc_8AB82:
		jmp	loc_850BA(pc)
; ---------------------------------------------------------------------------

loc_8AB86:

		lea	word_8ACEE(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_8ABB0,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		cmpi.b	#6,d0
		bne.s	loc_8ABA6
		move.b	#3,$22(a0)

loc_8ABA6:
		lsl.w	#4,d0
		sub.w	d0,$14(a0)
		bra.w	loc_8ACCE
; ---------------------------------------------------------------------------

loc_8ABB0:

		tst.b	$2C(a0)
		beq.s	loc_8ABC2
		movea.w	$46(a0),a1
		btst	#0,$38(a1)
		bne.s	loc_8ABF8

loc_8ABC2:
		move.w	($FFFFB018).w,-(sp)
		move.w	($FFFFB062).w,-(sp)
		bsr.w	sub_8AC70
		move.l	(sp)+,d0
		moveq	#5,d1
		cmpi.b	#3,$22(a0)
		beq.s	loc_8ABF4
		tst.b	$2C(a0)
		bne.s	loc_8ABF4
		lea	($FFFFB000).w,a1
		bsr.w	sub_8AC80
		lea	($FFFFB04A).w,a1
		swap	d0
		addq.b	#1,d1
		bsr.w	sub_8AC80

loc_8ABF4:

		bra.w	loc_8ACCE
; ---------------------------------------------------------------------------

loc_8ABF8:
		move.l	#loc_8AC1E,(a0)
		bset	#0,$38(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#2,d0
		addi.w	#$F,d0
		move.w	d0,$2E(a0)
		move.l	#loc_8AC2A,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8AC1E:
		bsr.w	sub_8AC70
		jsr	Obj_Wait(pc)
		bra.w	loc_8ACCE
; ---------------------------------------------------------------------------

loc_8AC2A:
		move.l	#loc_8AC44,(a0)
		move.w	#7,$2E(a0)
		move.l	#loc_8AC54,$34(a0)
		subq.b	#2,$2C(a0)
		rts
; ---------------------------------------------------------------------------

loc_8AC44:
		bsr.w	sub_8AC70
		addq.w	#4,$14(a0)
		jsr	Obj_Wait(pc)
		bra.w	loc_8ACCE
; ---------------------------------------------------------------------------

loc_8AC54:
		move.l	#loc_8ABB0,(a0)
		bclr	#0,$38(a0)
		move.w	#$10,($FFFFEECC).w
		moveq	#-$6A,d0
		jsr	(Play_Sound_2).l
		rts

; =============== S U B R O U T I N E =======================================


sub_8AC70:

		moveq	#$2B,d1
		moveq	#$10,d2
		moveq	#$10,d3
		move.w	$10(a0),d4
		jmp	(SolidObjectFull).l
; End of function sub_8AC70


; =============== S U B R O U T I N E =======================================


sub_8AC80:

		btst	d1,$2A(a0)
		beq.s	locret_8ACCC
		move.w	d0,d3
		tst.w	d3
		bpl.s	loc_8AC8E
		neg.w	d3

loc_8AC8E:
		cmpi.b	#2,$20(a1)
		bne.s	locret_8ACCC
		cmpi.w	#$600,d3
		bcs.s	locret_8ACCC
		move.w	d0,$18(a1)
		move.w	d0,$1C(a1)
		bclr	d1,$2A(a0)
		bclr	d1,$2A(a1)
		bset	#0,$38(a0)
		lea	ChildObjDat_8AAEA(pc),a2
		jsr	CreateChild1_Normal(pc)
		jsr	Displace_PlayerOffObject(pc)
		jsr	Go_Delete_Sprite(pc)
		moveq	#$59,d0
		jsr	(Play_Sound_2).l
		addq.w	#4,sp

locret_8ACCC:

		rts
; End of function sub_8AC80

; ---------------------------------------------------------------------------

loc_8ACCE:

		movea.w	$44(a0),a1
		btst	#4,$38(a1)
		bne.w	Go_Delete_Sprite_2
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
ObjDat3_8ACE2:	dc.l Map_ICZWallAndColumn
		dc.w $4001
		dc.w $280
		dc.b $20
		dc.b $10
		dc.b $B
		dc.b 0
word_8ACEE:	dc.w $280
		dc.b $20
		dc.b $10
		dc.b $A
		dc.b 0
ChildObjDat_8ACF4:dc.w 2
		dc.l loc_8AB86
		dc.w 0
ChildObjDat_8ACFC:dc.w 3
		dc.l loc_8AB86
		dc.w 0
; ---------------------------------------------------------------------------

Obj_ICZSwingingPlatform:

		lea	ObjDat3_8B138(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_8AD20,(a0)
		lea	ChildObjDat_8B164(pc),a2
		jsr	CreateChild1_Normal(pc)
		move.w	a1,$46(a0)
		rts
; ---------------------------------------------------------------------------

loc_8AD20:

		btst	#3,$38(a0)
		beq.s	loc_8AD3C
		move.l	#loc_8AD40,(a0)
		btst	#0,4(a0)
		beq.s	loc_8AD3C
		move.l	#loc_8ADCA,(a0)

loc_8AD3C:

		jmp	Sprite_CheckDeleteTouch2(pc)
; ---------------------------------------------------------------------------

loc_8AD40:
		move.w	$3E(a0),d0
		subi.w	#$10,d0
		move.w	d0,$3E(a0)
		move.w	$3C(a0),d1
		add.w	d0,d1
		scc	d2
		tst.w	d0
		bpl.s	loc_8AD5C
		tst.b	d2
		bne.s	loc_8AD82

loc_8AD5C:
		move.w	d1,$3C(a0)
		tst.b	$2C(a0)
		beq.s	loc_8AD72
		cmpi.w	#$4800,d1
		bcs.s	loc_8AD72
		cmpi.w	#$200,d0
		bcc.s	loc_8AD9C

loc_8AD72:

		cmpi.w	#$6E00,d1
		bcc.s	loc_8AD7E
		moveq	#1,d2
		jsr	MoveSprite_CircularSimple(pc)

loc_8AD7E:
		jmp	Sprite_CheckDeleteTouch2(pc)
; ---------------------------------------------------------------------------

loc_8AD82:

		move.l	#loc_8AD20,(a0)
		bclr	#3,$38(a0)
		clr.w	$3C(a0)
		moveq	#1,d2
		jsr	MoveSprite_CircularSimple(pc)
		jmp	Sprite_CheckDeleteTouch2(pc)
; ---------------------------------------------------------------------------

loc_8AD9C:

		move.l	#loc_8AE0C,(a0)
		bset	#2,$38(a0)
		move.b	#$10,$1E(a0)
		move.w	#$400,d0
		btst	#0,4(a0)
		beq.s	loc_8ADBC
		neg.w	d0

loc_8ADBC:
		move.w	d0,$18(a0)
		move.w	#-$600,$1A(a0)
		jmp	Sprite_CheckDeleteTouch2(pc)
; ---------------------------------------------------------------------------

loc_8ADCA:
		move.w	$3E(a0),d0
		addi.w	#$10,d0
		move.w	d0,$3E(a0)
		move.w	$3C(a0),d1
		add.w	d0,d1
		scs	d2
		tst.w	d0
		bmi.s	loc_8ADE6
		tst.b	d2
		bne.s	loc_8AD82

loc_8ADE6:
		move.w	d1,$3C(a0)
		tst.b	$2C(a0)
		beq.s	loc_8ADFC
		cmpi.w	#-$4800,d1
		bhi.s	loc_8ADFC
		cmpi.w	#$200,d0
		bcc.s	loc_8AD9C

loc_8ADFC:

		cmpi.w	#-$6E00,d1
		bls.s	loc_8AE08
		moveq	#1,d2
		jsr	MoveSprite_CircularSimple(pc)

loc_8AE08:
		jmp	Sprite_CheckDeleteTouch2(pc)
; ---------------------------------------------------------------------------

loc_8AE0C:
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.s	loc_8AE40
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_8AE40
		add.w	d1,$14(a0)
		move.w	$1A(a0),d0
		cmpi.w	#$100,d0
		bcs.s	loc_8AE44
		asr.w	#2,d0
		neg.w	d0
		move.w	d0,$1A(a0)
		lea	ChildObjDat_8B17E(pc),a2
		jsr	CreateChild1_Normal(pc)

loc_8AE40:

		jmp	Sprite_CheckDeleteTouch2(pc)
; ---------------------------------------------------------------------------

loc_8AE44:
		move.l	#loc_8AE62,(a0)
		move.w	#$10,d0
		tst.w	$18(a0)
		bmi.s	loc_8AE56
		neg.w	d0

loc_8AE56:
		move.w	d0,$40(a0)
		clr.w	$1A(a0)
		jmp	Sprite_CheckDeleteTouch2(pc)
; ---------------------------------------------------------------------------

loc_8AE62:
		move.w	$18(a0),d0
		move.w	d0,d1
		add.w	$40(a0),d0
		eor.w	d0,d1
		bmi.s	loc_8AE96
		move.w	d0,$18(a0)
		move.w	$10(a0),d1
		jsr	(MoveSprite2).l
		move.w	$10(a0),d0
		eor.w	d0,d1
		btst	#3,d1
		beq.s	loc_8AE92
		lea	ChildObjDat_8B18C(pc),a2
		jsr	CreateChild1_Normal(pc)

loc_8AE92:
		jmp	Sprite_CheckDeleteTouch2(pc)
; ---------------------------------------------------------------------------

loc_8AE96:
		move.l	#loc_8AEA0,(a0)
		jmp	Sprite_CheckDeleteTouch2(pc)
; ---------------------------------------------------------------------------

loc_8AEA0:
		jmp	Sprite_CheckDeleteTouch2(pc)
; ---------------------------------------------------------------------------

loc_8AEA4:
		lea	word_8B158(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_8AEB2,(a0)

loc_8AEB2:

		bsr.w	sub_8B080
		jmp	Child_Draw_Sprite2(pc)
; ---------------------------------------------------------------------------

loc_8AEBA:
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		bne.s	loc_8AECC
		move.l	#loc_8AEB2,(a0)

loc_8AECC:
		bsr.w	sub_8B054
		jmp	Child_Draw_Sprite2(pc)
; ---------------------------------------------------------------------------

loc_8AED4:
		lea	word_8B15E(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		move.l	#loc_8AEE2,(a0)

loc_8AEE2:
		bsr.w	sub_8B06A
		jmp	Child_Draw_Sprite2(pc)
; ---------------------------------------------------------------------------

loc_8AEEA:
		lea	word_8B144(pc),a1
		jsr	SetUp_ObjAttributes2(pc)
		move.l	#loc_8AF32,(a0)
		subi.w	#$80,$14(a0)
		movea.w	$46(a0),a1
		btst	#0,4(a1)
		beq.s	loc_8AF10
		bset	#0,4(a0)

loc_8AF10:
		bset	#6,4(a0)
		move.w	#7,$16(a0)
		lea	$1C(a0),a1
		moveq	#6,d6

loc_8AF22:
		move.w	#8,(a1)
		addq.w	#6,a1
		dbf	d6,loc_8AF22
		move.b	#8,$22(a0)

loc_8AF32:
		bsr.w	sub_8B114
		bsr.w	sub_8AFA2
		jmp	Child_Draw_Sprite2(pc)
; ---------------------------------------------------------------------------

loc_8AF3E:
		lea	ObjDat3_8B14C(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_8AF9E,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_8AF86(pc,d0.w),d1
		neg.w	d1
		move.w	d1,$1A(a0)
		movea.w	$46(a0),a1
		btst	#0,4(a1)
		bne.s	loc_8AF6A
		neg.w	d1

loc_8AF6A:
		move.w	d1,$18(a0)
		lsr.w	#1,d0
		move.b	byte_8AF96(pc,d0.w),d0
		movea.w	$46(a0),a1
		move.w	(a1,d0.w),$10(a0)
		move.w	2(a1,d0.w),$14(a0)
		rts
; ---------------------------------------------------------------------------
word_8AF86:	dc.w $80
		dc.w $100
		dc.w $180
		dc.w $200
		dc.w $280
		dc.w $300
		dc.w $380
		dc.w $400
byte_8AF96:	dc.b $42
		dc.b $18
		dc.b $1E
		dc.b $24
		dc.b $2A
		dc.b $30
		dc.b $36
		dc.b $3C
; ---------------------------------------------------------------------------

loc_8AF9E:
		jmp	MoveChkDel(pc)

; =============== S U B R O U T I N E =======================================


sub_8AFA2:
		movea.w	$46(a0),a1
		lea	$18(a0),a2
		move.w	$10(a0),d0
		move.w	$10(a1),d1
		sub.w	d0,d1
		swap	d0
		swap	d1
		move.w	$14(a0),d0
		move.w	$14(a1),d1
		sub.w	d0,d1
		moveq	#0,d5
		moveq	#6,d6

loc_8AFC6:
		move.l	d1,d2
		move.w	off_8AFE0(pc,d5.w),d4
		jsr	off_8AFE0(pc,d4.w)
		move.l	d0,(a2)
		swap	d2
		add.l	d2,(a2)+
		addq.w	#2,a2
		addq.w	#2,d5
		dbf	d6,loc_8AFC6
		rts
; End of function sub_8AFA2

; ---------------------------------------------------------------------------
off_8AFE0:	dc.w loc_8AFF0-off_8AFE0

		dc.w loc_8AFF8-off_8AFE0
		dc.w loc_8B000-off_8AFE0
		dc.w loc_8B014-off_8AFE0
		dc.w loc_8B01C-off_8AFE0
		dc.w loc_8B030-off_8AFE0
		dc.w loc_8B044-off_8AFE0
		dc.w locret_8B052-off_8AFE0
; ---------------------------------------------------------------------------

loc_8AFF0:
		asr.w	#3,d2
		swap	d2
		asr.w	#3,d2
		rts
; ---------------------------------------------------------------------------

loc_8AFF8:
		asr.w	#2,d2
		swap	d2
		asr.w	#2,d2
		rts
; ---------------------------------------------------------------------------

loc_8B000:
		asr.w	#2,d2
		move.w	d2,d3
		asr.w	#1,d2
		add.w	d3,d2
		swap	d2
		asr.w	#2,d2
		move.w	d2,d3
		asr.w	#1,d2
		add.w	d3,d2
		rts
; ---------------------------------------------------------------------------

loc_8B014:
		asr.w	#1,d2
		swap	d2
		asr.w	#1,d2
		rts
; ---------------------------------------------------------------------------

loc_8B01C:
		asr.w	#1,d2
		move.w	d2,d3
		asr.w	#2,d2
		add.w	d3,d2
		swap	d2
		asr.w	#1,d2
		move.w	d2,d3
		asr.w	#2,d2
		add.w	d3,d2
		rts
; ---------------------------------------------------------------------------

loc_8B030:
		asr.w	#1,d2
		move.w	d2,d3
		asr.w	#1,d2
		add.w	d3,d2
		swap	d2
		asr.w	#1,d2
		move.w	d2,d3
		asr.w	#1,d2
		add.w	d3,d2
		rts
; ---------------------------------------------------------------------------

loc_8B044:
		move.w	d2,d3
		asr.w	#3,d3
		sub.w	d3,d2
		swap	d2
		move.w	d2,d3
		asr.w	#3,d3
		sub.w	d3,d2

locret_8B052:
		rts

; =============== S U B R O U T I N E =======================================


sub_8B054:

		move.w	$10(a0),-(sp)
		jsr	Refresh_ChildPosition(pc)
		moveq	#$2B,d1
		moveq	#8,d2
		moveq	#8,d3
		move.w	(sp)+,d4
		jmp	(SolidObjectFull).l
; End of function sub_8B054


; =============== S U B R O U T I N E =======================================


sub_8B06A:
		move.w	$10(a0),-(sp)
		jsr	Refresh_ChildPositionAdjusted(pc)
		moveq	#$F,d1
		moveq	#8,d2
		moveq	#8,d3
		move.w	(sp)+,d4
		jmp	(SolidObjectFull).l
; End of function sub_8B06A


; =============== S U B R O U T I N E =======================================


sub_8B080:
		move.b	$2A(a0),$39(a0)
		bsr.s	sub_8B054
		move.b	$39(a0),d0
		move.b	$2A(a0),d1
		andi.b	#$18,d1
		beq.s	locret_8B0AE
		movea.w	$46(a0),a2
		lea	($FFFFB000).w,a1
		moveq	#3,d2
		bsr.w	sub_8B0B0
		lea	($FFFFB04A).w,a1
		moveq	#4,d2
		bsr.w	sub_8B0B0

locret_8B0AE:

		rts
; End of function sub_8B080


; =============== S U B R O U T I N E =======================================


sub_8B0B0:

		btst	d2,d1
		beq.s	locret_8B0AE
		move.w	$18(a1),d3
		smi	d4
		cmpi.w	#-$200,d3
		ble.s	loc_8B0C6
		cmpi.w	#$200,d3
		blt.s	locret_8B0AE

loc_8B0C6:
		btst	d2,d0
		beq.s	loc_8B0CC
		asr.w	#1,d3

loc_8B0CC:
		btst	#0,4(a2)
		beq.s	loc_8B0D6
		not.b	d4

loc_8B0D6:
		tst.b	d4
		bne.s	locret_8B0AE
		move.l	#loc_8AEBA,(a0)
		bset	#3,$38(a2)
		asr.w	#1,d3
		bmi.s	loc_8B0F8
		cmpi.w	#$400,d3
		ble.s	loc_8B102
		move.w	#$400,d3
		bra.w	loc_8B102
; ---------------------------------------------------------------------------

loc_8B0F8:
		cmpi.w	#-$400,d3
		bge.s	loc_8B102
		move.w	#-$400,d3

loc_8B102:

		move.w	d3,$3E(a2)
		asl.w	#1,d3
		move.w	d3,$18(a1)
		move.w	d3,$1C(a1)
		addq.w	#4,sp

locret_8B112:
		rts
; End of function sub_8B0B0


; =============== S U B R O U T I N E =======================================


sub_8B114:
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		beq.s	locret_8B112
		move.w	$10(a0),$2A(a0)
		move.w	$14(a0),$2C(a0)
		lea	ChildObjDat_8B178(pc),a2
		jsr	CreateChild6_Simple(pc)
		jmp	Go_Delete_Sprite_2(pc)
; End of function sub_8B114

; ---------------------------------------------------------------------------
ObjDat3_8B138:	dc.l Map_ICZPlatforms
		dc.w $23B6
		dc.w $80
		dc.b $20
		dc.b $10
		dc.b 7
		dc.b 0
word_8B144:	dc.w $43B6
		dc.w $280
		dc.b $80
		dc.b $80
		dc.b 8
		dc.b 0
ObjDat3_8B14C:	dc.l Map_ICZPlatforms
		dc.w $43B6
		dc.w $280
		dc.b 8
		dc.b 8
		dc.b 8
		dc.b 0
word_8B158:	dc.w $300
		dc.b $20
		dc.b $10
		dc.b $27
		dc.b 0
word_8B15E:	dc.w $300
		dc.b $30
		dc.b 8
		dc.b $27
		dc.b 0
ChildObjDat_8B164:dc.w 2
		dc.l loc_8AEA4
		dc.w 8
		dc.l loc_8AED4
		dc.w $1CF8
		dc.l loc_8AEEA
		dc.w 0
ChildObjDat_8B178:dc.w 7
		dc.l loc_8AF3E
ChildObjDat_8B17E:dc.w 1
		dc.l Obj_ICZSnowdust
		dc.w $1C10
		dc.l Obj_ICZSnowdust
		dc.w $1410
ChildObjDat_8B18C:dc.w 0
		dc.l Obj_ICZSnowdust
		dc.w $1C10
; ---------------------------------------------------------------------------

Obj_ICZStalagtite:

		jsr	Obj_WaitOffscreen(pc)
		lea	ObjDat3_8B27A(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_8B1AE,(a0)
		move.b	#$10,$1E(a0)
		rts
; ---------------------------------------------------------------------------

loc_8B1AE:
		bsr.w	sub_8B26A
		jsr	Find_SonicTails(pc)
		cmpi.w	#$70,d2
		bcc.s	loc_8B1D0
		move.l	#loc_8B1D4,(a0)
		move.w	#$F,$2E(a0)
		move.l	#loc_8B1EC,$34(a0)

loc_8B1D0:
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------

loc_8B1D4:
		moveq	#2,d0
		btst	#0,($FFFFFE0F).w
		beq.s	loc_8B1E0
		neg.w	d0

loc_8B1E0:
		add.w	d0,$10(a0)
		jsr	Obj_Wait(pc)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------

loc_8B1EC:
		move.l	#loc_8B1FA,(a0)
		move.b	#-$7E,$28(a0)
		rts
; ---------------------------------------------------------------------------

loc_8B1FA:
		jsr	(MoveSprite).l
		jsr	(ObjHitCeiling).l
		tst.w	d1
		bpl.s	loc_8B224
		move.l	#loc_8B228,(a0)
		clr.b	$28(a0)
		lea	ChildObjDat_8B292(pc),a2
		jsr	CreateChild6_Simple(pc)
		moveq	#$5D,d0
		jsr	(Play_Sound_2).l

loc_8B224:
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------

loc_8B228:
		bsr.w	sub_8B26A
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------

loc_8B230:

		lea	ObjDat3_8B286(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#AnimateRaw_MoveChkDel,(a0)
		move.l	#byte_8AB46,$30(a0)
		cmpi.b	#6,$2C(a0)
		bcc.s	loc_8B256
		move.l	#byte_8AB3E,$30(a0)

loc_8B256:
		jsr	(Random_Number).l
		andi.b	#3,d0
		move.b	d0,$23(a0)
		moveq	#0,d0
		jmp	Set_IndexedVelocity(pc)

; =============== S U B R O U T I N E =======================================


sub_8B26A:

		moveq	#$1B,d1
		moveq	#$20,d2
		moveq	#$20,d3
		move.w	$10(a0),d4
		jmp	(SolidObjectFull).l
; End of function sub_8B26A

; ---------------------------------------------------------------------------
ObjDat3_8B27A:	dc.l Map_ICZWallAndColumn
		dc.w $4001
		dc.w $280
		dc.b $10
		dc.b $20
		dc.b 7
		dc.b 0
ObjDat3_8B286:	dc.l Map_ICZPlatforms
		dc.w $C3B6
		dc.w $280
		dc.b 4
		dc.b 4
		dc.b $F
		dc.b 0
ChildObjDat_8B292:dc.w $B
		dc.l loc_8B230
		dc.w $27
		dc.b   $F, $27
		dc.b  $10, $27
		dc.b  $11, $FC
; ---------------------------------------------------------------------------

Obj_ICZIceSpikes:

		jsr	Obj_WaitOffscreen(pc)
		lea	ObjDat3_8B350(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		tst.b	$2C(a0)
		bne.s	loc_8B2CC
		move.l	#loc_8B2DA,(a0)
		lea	ChildObjDat_8B35C(pc),a2
		btst	#1,4(a0)
		beq.s	loc_8B2C8
		lea	ChildObjDat_8B364(pc),a2

loc_8B2C8:
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_8B2CC:
		move.l	#loc_8B2EE,(a0)
		move.b	#-$6E,$28(a0)
		rts
; ---------------------------------------------------------------------------

loc_8B2DA:
		moveq	#$17,d1
		moveq	#8,d2
		moveq	#8,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------

loc_8B2EE:
		jsr	Find_SonicTails(pc)
		cmpi.w	#$40,d2
		bcc.s	loc_8B30C
		move.l	#loc_8B310,(a0)
		move.w	#$F,$2E(a0)
		move.l	#loc_8B328,$34(a0)

loc_8B30C:
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------

loc_8B310:
		moveq	#2,d0
		btst	#0,($FFFFFE0F).w
		beq.s	loc_8B31C
		neg.w	d0

loc_8B31C:
		add.w	d0,$10(a0)
		jsr	Obj_Wait(pc)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------

loc_8B328:
		move.l	#MoveTouchChkDel,(a0)

locret_8B32E:
		rts
; ---------------------------------------------------------------------------

loc_8B330:

		move.b	#-$68,$28(a0)
		jsr	(Add_SpriteToCollisionResponseList).l
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		beq.w	locret_8B32E
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
ObjDat3_8B350:	dc.l Map_ICZWallAndColumn
		dc.w $4001
		dc.w $280
		dc.b $C
		dc.b $10
		dc.b 5
		dc.b 0
ChildObjDat_8B35C:dc.w 0
		dc.l loc_8B330
		dc.w $C
ChildObjDat_8B364:dc.w 0
		dc.l loc_8B330
		dc.w $F4
; ---------------------------------------------------------------------------

Obj_ICZIceCube:

		jsr	Obj_WaitOffscreen(pc)
		move.l	#loc_8B384,(a0)
		lea	ObjDat3_8B46C(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		jmp	(Sprite_OnScreen_Test).l
; ---------------------------------------------------------------------------

loc_8B384:
		move.b	($FFFFB020).w,$3A(a0)
		move.b	($FFFFB06A).w,$3B(a0)
		moveq	#$23,d1
		moveq	#$10,d2
		moveq	#$10,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		bsr.w	sub_8B3AA
		jmp	(Sprite_OnScreen_Test).l

; =============== S U B R O U T I N E =======================================


sub_8B3AA:
		move.b	$2A(a0),d0
		btst	#3,d0
		beq.s	loc_8B3C0
		lea	($FFFFB000).w,a1
		cmpi.b	#2,$3A(a0)
		beq.s	loc_8B3D2

loc_8B3C0:
		btst	#4,d0
		beq.s	locret_8B430
		lea	($FFFFB04A).w,a1
		cmpi.b	#2,$3B(a0)
		bne.s	locret_8B430

loc_8B3D2:
		bset	#2,$2A(a1)
		move.b	#$E,$1E(a1)
		move.b	#7,$1F(a1)
		move.b	#2,$20(a1)
		move.w	#-$300,$1A(a1)
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		move.b	#2,5(a1)
		btst	#4,$2A(a0)
		beq.s	loc_8B41A
		lea	($FFFFB04A).w,a1
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)

loc_8B41A:
		lea	ChildObjDat_8B480(pc),a2
		jsr	CreateChild1_Normal(pc)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		jsr	(Go_Delete_Sprite).l

locret_8B430:

		rts
; End of function sub_8B3AA

; ---------------------------------------------------------------------------

loc_8B432:

		lea	word_8B478(pc),a1
		jsr	SetUp_ObjAttributes2(pc)
		move.l	#AnimateRaw_MoveChkDel,(a0)
		move.l	#byte_8AB34,$30(a0)
		cmpi.b	#$C,$2C(a0)
		bcs.s	loc_8B458
		move.l	#byte_8AB3E,$30(a0)

loc_8B458:
		jsr	(Random_Number).l
		andi.b	#3,d0
		move.b	d0,$23(a0)
		moveq	#0,d0
		jmp	Set_IndexedVelocity(pc)
; ---------------------------------------------------------------------------
ObjDat3_8B46C:	dc.l Map_ICZPlatforms
		dc.w $43B6
		dc.w $80
		dc.b $18
		dc.b $10
		dc.b 3
		dc.b $2E
word_8B478:	dc.w $C3B6
		dc.w $280
		dc.b $20
		dc.b $20
		dc.b $12
		dc.b 0
ChildObjDat_8B480:dc.w $B
		dc.l loc_8B432
		dc.w $F8
		dc.l loc_8B432
		dc.w 8
		dc.l loc_8B432
		dc.w $F0F8
		dc.l loc_8B432
		dc.w $10F8
		dc.l loc_8B432
		dc.w $F008
		dc.l loc_8B432
		dc.w $1008
		dc.l loc_8B432
		dc.w 0
		dc.l loc_8B432
		dc.w 0
		dc.l loc_8B432
		dc.w 0
		dc.l loc_8B432
		dc.w 0
		dc.l loc_8B432
		dc.w 0
		dc.l loc_8B432
		dc.w 0
; ---------------------------------------------------------------------------

Obj_ICZHarmfulIce:

		jsr	Obj_WaitOffscreen(pc)
		lea	ObjDat3_8B532(pc),a1
		move.l	#Sprite_CheckDeleteTouch,(a0)
		tst.b	$2C(a0)
		beq.s	loc_8B4E8
		lea	ObjDat3_8B53E(pc),a1
		move.l	#loc_8B4EC,(a0)

loc_8B4E8:
		jmp	SetUp_ObjAttributes(pc)
; ---------------------------------------------------------------------------

loc_8B4EC:
		moveq	#0,d0
		move.b	$29(a0),d0
		bne.s	loc_8B4F8
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------

loc_8B4F8:
		add.w	d0,d0
		movea.w	loc_8B526+4(pc,d0.w),a1
		btst	#1,$2B(a1)
		bne.s	loc_8B512
		movea.l	a0,a2
		movea.l	a1,a0
		jsr	(HurtSonic2).l
		movea.l	a2,a0

loc_8B512:
		lea	ChildObjDat_8B54A(pc),a2
		jsr	CreateChild6_Simple(pc)
		jsr	Go_Delete_Sprite(pc)
		moveq	#-$80,d0
		jsr	(Play_Sound_2).l

loc_8B526:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
		dc.w $B000
		dc.w $B04A
		dc.w $B04A
ObjDat3_8B532:	dc.l Map_ICZPlatforms
		dc.w $43B6
		dc.w $280
		dc.b $10
		dc.b $18
		dc.b 5
		dc.b $82
ObjDat3_8B53E:	dc.l Map_ICZPlatforms
		dc.w $43B6
		dc.w $280
		dc.b $10
		dc.b $10
		dc.b 4
		dc.b $D7
ChildObjDat_8B54A:dc.w $B
		dc.l loc_8B230
; ---------------------------------------------------------------------------

Obj_ICZ_SnowPile:

		jsr	Obj_WaitOffscreen(pc)
		moveq	#0,d0
		move.b	$2C(a0),d0
		bclr	#7,d0
		lea	off_8B7F4(pc),a1
		lea	(a1,d0.w),a2
		move.l	(a2)+,(a0)
		movea.l	(a2)+,a1
		jmp	SetUp_ObjAttributes(pc)
; ---------------------------------------------------------------------------

loc_8B56E:
		lea	word_8B590(pc),a1
		jsr	Check_PlayerInRange(pc)
		tst.l	d0
		beq.s	loc_8B58C
		tst.w	d0
		beq.s	loc_8B582
		bsr.w	sub_8B598

loc_8B582:
		swap	d0
		tst.w	d0
		beq.s	loc_8B58C
		bsr.w	sub_8B598

loc_8B58C:

		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------
word_8B590:	dc.w  $FFD8,   $50, $FFE8,   $20

; =============== S U B R O U T I N E =======================================


sub_8B598:

		movea.w	d0,a3
		move.w	d0,$44(a0)
		cmpi.b	#9,$20(a3)
		beq.s	loc_8B5C6
		btst	#1,$2A(a3)
		bne.s	locret_8B5C4
		move.w	$18(a3),d2
		move.w	d2,d3
		bpl.s	loc_8B5B8
		neg.w	d2

loc_8B5B8:
		cmpi.w	#$600,d2
		bcc.s	loc_8B5C6
		asr.w	#1,d3
		move.w	d3,$1C(a3)

locret_8B5C4:
		rts
; ---------------------------------------------------------------------------

loc_8B5C6:

		move.w	a3,$44(a0)
		lea	ChildObjDat_8B84C(pc),a2
		jsr	CreateChild1_Normal(pc)
		jsr	(Go_Delete_Sprite).l
		addq.w	#4,sp

locret_8B5DA:
		rts
; End of function sub_8B598

; ---------------------------------------------------------------------------

loc_8B5DC:
		lea	word_8B60E(pc),a1
		jsr	Check_PlayerInRange(pc)
		tst.w	d0
		bne.s	loc_8B5EC
		jmp	Sprite_CheckDelete(pc)
; ---------------------------------------------------------------------------

loc_8B5EC:
		move.w	d0,$44(a0)
		beq.s	loc_8B608
		movea.w	d0,a1
		move.w	#$800,$18(a1)
		move.w	#$800,$1C(a1)
		lea	ChildObjDat_8B872(pc),a2
		jsr	CreateChild1_Normal(pc)

loc_8B608:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------
word_8B60E:	dc.w  $FFF8,   $10, $FFF0,   $20
; ---------------------------------------------------------------------------

loc_8B616:
		lea	word_8B658(pc),a1
		jsr	Check_PlayerInRange(pc)
		tst.w	d0
		bne.s	loc_8B626
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------

loc_8B626:
		move.w	d0,$44(a0)
		beq.s	loc_8B652
		movea.w	d0,a1
		move.w	#$800,$18(a1)
		move.w	#$800,$1C(a1)
		lea	ChildObjDat_8B880(pc),a2
		jsr	CreateChild1_Normal(pc)
		btst	#7,$2C(a0)
		beq.s	loc_8B652
		move.w	#$600,d0
		jsr	StartNewLevel(pc)

loc_8B652:

		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------
word_8B658:	dc.w  $FFF8,   $10, $FFF0,   $20
; ---------------------------------------------------------------------------

loc_8B660:

		move.w	a0,($FFFFFAAE).w
		btst	#5,$38(a0)
		bne.s	loc_8B6A8
		move.w	($FFFFEE80).w,$10(a0)
		move.w	($FFFFEE84).w,$14(a0)
		subq.w	#8,$14(a0)
		subq.w	#1,$2E(a0)
		bpl.s	locret_8B6A6
		move.w	#8,$2E(a0)
		move.b	($FFFFFAAD).w,d0
		addq.b	#1,d0
		cmpi.b	#$3C,d0
		bhi.s	locret_8B6A6
		move.b	d0,($FFFFFAAD).w
		jsr	(Create_New_Sprite).l
		bne.s	locret_8B6A6
		move.l	#loc_8B6AE,(a1)

locret_8B6A6:

		rts
; ---------------------------------------------------------------------------

loc_8B6A8:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_8B6AE:
		lea	ObjDat3_8B838(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_8B720,(a0)
		jsr	(Random_Number).l
		andi.w	#$1FF,d0
		cmpi.w	#$140,d0
		bcs.s	loc_8B6D2
		andi.w	#$3F,d0
		lsl.w	#2,d0

loc_8B6D2:
		add.w	($FFFFEE78).w,d0
		cmpi.w	#$380,d0
		bcs.s	loc_8B756
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d0
		subq.w	#4,d0
		move.w	d0,$14(a0)
		swap	d0
		move.w	d0,d1
		andi.w	#3,d0
		move.b	RawAni_8B714(pc,d0.w),$22(a0)
		add.w	d0,d0
		move.w	word_8B718(pc,d0.w),8(a0)
		andi.w	#$3C,d1
		subi.w	#$20,d1
		move.w	d1,$18(a0)
		move.w	#$100,$1A(a0)
		rts
; ---------------------------------------------------------------------------
RawAni_8B714:	dc.b   $B, $10,	 $B,  $B
word_8B718:	dc.w $80
		dc.w $380
		dc.w $80
		dc.w $80
; ---------------------------------------------------------------------------

loc_8B720:
		jsr	(MoveSprite2).l
		tst.b	4(a0)
		bmi.s	loc_8B732
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8B732:
		move.l	#loc_8B73A,(a0)
		rts
; ---------------------------------------------------------------------------

loc_8B73A:
		jsr	(MoveSprite2).l
		tst.b	4(a0)
		bpl.s	loc_8B756
		bchg	#0,$38(a0)
		bne.w	locret_8B5DA
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8B756:

		move.b	($FFFFFAAD).w,d0
		subq.b	#1,d0
		bmi.s	loc_8B762
		move.b	d0,($FFFFFAAD).w

loc_8B762:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_8B768:

		lea	word_8B844(pc),a1
		jsr	SetUp_ObjAttributes2(pc)
		move.l	#loc_8B786,(a0)
		move.l	#loc_8B790,$34(a0)
		bsr.w	sub_8B7A0
		jsr	Refresh_ChildPositionAdjusted(pc)

loc_8B786:
		jsr	Obj_Wait(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8B790:
		move.l	#loc_8B798,(a0)
		rts
; ---------------------------------------------------------------------------

loc_8B798:
		jsr	MoveSprite_LightGravity(pc)
		jmp	Sprite_CheckDeleteXY(pc)

; =============== S U B R O U T I N E =======================================


sub_8B7A0:
		movea.w	$46(a0),a1
		move.w	$44(a1),d0
		beq.s	locret_8B7DA
		movea.w	d0,a2
		lea	word_8B7DC(pc),a3
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,$2E(a0)
		add.w	d0,d0
		move.l	(a3,d0.w),$18(a0)
		btst	#0,4(a2)
		beq.s	locret_8B7DA
		bset	#0,4(a0)
		bset	#0,4(a1)
		neg.w	$18(a0)

locret_8B7DA:

		rts
; End of function sub_8B7A0

; ---------------------------------------------------------------------------
word_8B7DC:	dc.w  $FD00, $FE00
		dc.w  $FC00, $FD00
		dc.w  $FC00, $FD80
		dc.w  $FD80, $FE00
		dc.w  $FE00, $FE80
		dc.w  $FE00, $FF00
off_8B7F4:	dc.l loc_8B56E
		dc.l ObjDat3_8B814
		dc.l loc_8B5DC
		dc.l ObjDat3_8B820
		dc.l loc_8B616
		dc.l ObjDat3_8B82C
		dc.l loc_8B660
		dc.l ObjDat3_8B838
ObjDat3_8B814:	dc.l Map_ICZPlatforms
		dc.w $4377
		dc.w $80
		dc.b $18
		dc.b 8
		dc.b $20
		dc.b 0
ObjDat3_8B820:	dc.l Map_ICZPlatforms
		dc.w $C377
		dc.w $80
		dc.b 8
		dc.b $10
		dc.b $21
		dc.b 0
ObjDat3_8B82C:	dc.l Map_ICZPlatforms
		dc.w $C377
		dc.w $80
		dc.b $10
		dc.b $10
		dc.b $22
		dc.b 0
ObjDat3_8B838:	dc.l Map_ICZPlatforms

		dc.w $43B6
		dc.w $80
		dc.b 4
		dc.b 4
		dc.b $B
		dc.b 0
word_8B844:	dc.w $43B6
		dc.w $80
		dc.b 8
		dc.b 8
		dc.b 9
		dc.b 0
ChildObjDat_8B84C:dc.w 5
		dc.l loc_8B768
		dc.w $F8F8
		dc.l loc_8B768
		dc.w $8F8
		dc.l loc_8B768
		dc.w $E800
		dc.l loc_8B768
		dc.w $F800
		dc.l loc_8B768
		dc.w $800
		dc.l loc_8B768
		dc.w $1800
ChildObjDat_8B872:dc.w 1
		dc.l loc_8B768
		dc.w $F8
		dc.l loc_8B768
		dc.w 8
ChildObjDat_8B880:dc.w 3
		dc.l loc_8B768
		dc.w $F8F8
		dc.l loc_8B768
		dc.w 8
		dc.l loc_8B768
		dc.w $8F8
		dc.l loc_8B768
		dc.w $808
; ---------------------------------------------------------------------------

Obj_ICZ_TensionPlatform:

		lea	ObjDat3_8BABC(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_8B8B6,(a0)
		move.w	$14(a0),$30(a0)
		lea	ChildObjDat_8BAD0(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_8B8B6:
		bsr.w	sub_8B950
		bsr.w	sub_8BA1C
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------

loc_8B8C2:

		lea	word_8BAC8(pc),a1
		jsr	SetUp_ObjAttributes2(pc)
		move.l	#loc_8B8F2,(a0)
		tst.b	$2C(a0)
		beq.s	loc_8B8DC
		bset	#0,4(a0)

loc_8B8DC:
		bset	#6,4(a0)
		move.w	#2,$16(a0)
		bsr.w	sub_8B8FA
		move.b	#8,$22(a0)

loc_8B8F2:
		bsr.w	sub_8B930
		jmp	Child_Draw_Sprite(pc)

; =============== S U B R O U T I N E =======================================


sub_8B8FA:
		lea	$18(a0),a1
		move.w	$10(a0),d0
		move.w	$14(a0),d1
		moveq	#0,d2
		moveq	#1,d3

loc_8B90A:
		move.w	d0,d4
		move.w	word_8B92C(pc,d2.w),d5
		btst	#0,4(a0)
		beq.s	loc_8B91A
		neg.w	d5

loc_8B91A:
		add.w	d5,d4
		move.w	d4,(a1)+
		move.w	d1,(a1)+
		move.w	#8,(a1)+
		addq.w	#2,d2
		dbf	d3,loc_8B90A
		rts
; End of function sub_8B8FA

; ---------------------------------------------------------------------------
word_8B92C:	dc.w $C
		dc.w $18

; =============== S U B R O U T I N E =======================================


sub_8B930:
		movea.w	$46(a0),a1
		lea	$1A(a0),a2
		move.w	$14(a0),d0
		move.w	$14(a1),d1
		move.w	d1,d2
		sub.w	d0,d1
		asr.w	#1,d1
		add.w	d0,d1
		move.w	d1,(a2)
		addq.w	#6,a2
		move.w	d2,(a2)
		rts
; End of function sub_8B930


; =============== S U B R O U T I N E =======================================


sub_8B950:
		btst	#2,$38(a0)
		beq.s	locret_8B9D6
		move.w	#$80,d0
		move.w	$14(a0),d1
		move.w	$1A(a0),d2
		move.b	$39(a0),d3
		sub.w	$32(a0),d1
		scs	$39(a0)
		bcs.s	loc_8B978
		neg.w	d0
		bra.w	loc_8B97A
; ---------------------------------------------------------------------------

loc_8B978:
		neg.w	d1

loc_8B97A:
		cmp.b	$39(a0),d3
		beq.s	loc_8B9AA
		add.w	d0,d2
		add.w	d0,d2
		cmpi.w	#-$80,d2
		bge.s	loc_8B998
		cmpi.w	#-$400,d2
		bgt.s	loc_8B9AA
		bsr.w	sub_8B9D8
		bra.w	loc_8B9AA
; ---------------------------------------------------------------------------

loc_8B998:
		cmpi.w	#$80,d2
		bgt.s	loc_8B9AA
		cmpi.w	#1,d1
		bhi.s	loc_8B9AA
		bclr	#2,$38(a0)

loc_8B9AA:

		add.w	d0,d2
		move.w	#-$900,d3
		cmp.w	d3,d2
		bge.s	loc_8B9B8
		bra.w	loc_8B9BE
; ---------------------------------------------------------------------------

loc_8B9B8:
		neg.w	d3
		cmp.w	d3,d2
		ble.s	loc_8B9C0

loc_8B9BE:
		move.w	d3,d2

loc_8B9C0:
		move.w	d2,$1A(a0)
		jsr	(MoveSprite2).l
		cmpi.w	#$50,d1
		bcs.s	locret_8B9D6
		move.w	#-$100,$1A(a0)

locret_8B9D6:

		rts
; End of function sub_8B950


; =============== S U B R O U T I N E =======================================


sub_8B9D8:
		move.b	$3A(a0),d3
		andi.b	#$18,d3
		beq.s	locret_8BA1A
		btst	#3,d3
		beq.s	loc_8B9F0
		lea	($FFFFB000).w,a1
		bsr.w	sub_8B9FA

loc_8B9F0:
		btst	#4,d3
		beq.s	locret_8BA1A
		lea	($FFFFB04A).w,a1
; End of function sub_8B9D8


; =============== S U B R O U T I N E =======================================


sub_8B9FA:
		move.w	d2,$1A(a1)
		bset	#1,$2A(a1)
		bclr	#3,$2A(a1)
		clr.b	$40(a1)
		move.b	#$10,$20(a1)
		move.b	#2,5(a1)

locret_8BA1A:

		rts
; End of function sub_8B9FA


; =============== S U B R O U T I N E =======================================


sub_8BA1C:
		move.b	$2A(a0),$3A(a0)
		move.w	($FFFFB01A).w,-(sp)
		move.w	($FFFFB064).w,-(sp)
		moveq	#$23,d1
		moveq	#$14,d2
		moveq	#$B,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		move.l	(sp)+,d0
		move.b	$2A(a0),d1
		move.b	$3A(a0),d2
		move.b	d1,$3A(a0)
		eor.b	d1,d2
		andi.b	#$18,d2
		beq.s	locret_8BA7C
		bsr.w	sub_8BA9E
		bset	#2,$38(a0)
		clr.b	$39(a0)
		moveq	#3,d4
		btst	d4,d2
		beq.s	loc_8BA6C
		lea	($FFFFB000).w,a1
		bsr.w	sub_8BA7E

loc_8BA6C:
		moveq	#4,d4
		btst	d4,d2
		beq.s	locret_8BA7C
		swap	d0
		lea	($FFFFB04A).w,a1
		bsr.w	sub_8BA7E

locret_8BA7C:

		rts
; End of function sub_8BA1C


; =============== S U B R O U T I N E =======================================


sub_8BA7E:

		move.w	$1A(a0),d5
		btst	d4,d1
		bne.s	loc_8BA90
		tst.w	d0
		bpl.s	loc_8BA90
		add.w	d5,$1A(a1)
		neg.w	d0

loc_8BA90:
		add.w	d0,d5
		move.w	d5,d6
		asr.w	#2,d6
		sub.w	d6,d5
		move.w	d5,$1A(a0)
		rts
; End of function sub_8BA7E


; =============== S U B R O U T I N E =======================================


sub_8BA9E:
		moveq	#0,d5
		btst	#3,d1
		beq.s	loc_8BAA8
		addq.w	#8,d5

loc_8BAA8:
		btst	#4,d1
		beq.s	loc_8BAB0
		addq.w	#8,d5

loc_8BAB0:
		move.w	$30(a0),d3
		add.w	d5,d3
		move.w	d3,$32(a0)
		rts
; End of function sub_8BA9E

; ---------------------------------------------------------------------------
ObjDat3_8BABC:	dc.l Map_ICZPlatforms
		dc.w $4377
		dc.w $280
		dc.b $18
		dc.b $C
		dc.b $1F
		dc.b 0
word_8BAC8:	dc.w $43B6
		dc.w $280
		dc.b $40
		dc.b $40
		dc.b 8
		dc.b 0
ChildObjDat_8BAD0:dc.w 1
		dc.l loc_8B8C2
		dc.w $C800
		dc.l loc_8B8C2
		dc.w $3800
; ---------------------------------------------------------------------------

Obj_Penguinator:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8BAFE(pc,d0.w),d1
		jsr	off_8BAFE(pc,d1.w)
		lea	DPLCPtr_8BE02(pc),a2
		jsr	Perform_DPLC(pc)
		jmp	Sprite_CheckDeleteTouchSlotted(pc)
; ---------------------------------------------------------------------------
off_8BAFE:	dc.w loc_8BB0E-off_8BAFE

		dc.w loc_8BB6A-off_8BAFE
		dc.w loc_8BC04-off_8BAFE
		dc.w loc_8BC1E-off_8BAFE
		dc.w loc_8BC6C-off_8BAFE
		dc.w loc_8BCBA-off_8BAFE
		dc.w loc_8BCF4-off_8BAFE
		dc.w loc_8BD3C-off_8BAFE
; ---------------------------------------------------------------------------

loc_8BB0E:
		lea	ObjDat4_8BDDC(pc),a1
		jsr	SetUp_ObjAttributesSlotted(pc)
		bclr	#1,4(a0)
		beq.s	loc_8BB24
		bset	#7,$A(a0)

loc_8BB24:

		move.b	#2,5(a0)
		move.b	#$F,$1E(a0)
		move.b	#4,$1F(a0)
		bclr	#5,$38(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		clr.w	$2E(a0)
		move.l	#byte_8BE0A,$30(a0)
		move.l	#loc_8BBF4,$34(a0)
		moveq	#2,d0
		btst	#0,4(a0)
		bne.s	loc_8BB64
		neg.w	d0

loc_8BB64:
		move.w	d0,$40(a0)
		rts
; ---------------------------------------------------------------------------

loc_8BB6A:
		jsr	Animate_RawGetFaster(pc)
		beq.s	loc_8BB78
		cmpi.b	#2,$2E(a0)
		bls.s	loc_8BB90

loc_8BB78:
		move.w	$40(a0),d0
		move.w	$18(a0),d1
		add.w	d0,d1
		move.w	d1,$18(a0)
		jsr	(MoveSprite2).l
		jmp	ObjHitFloor2_DoRoutine(pc)
; ---------------------------------------------------------------------------

loc_8BB90:
		jsr	(ObjHitFloor).l
		tst.b	d3
		beq.s	loc_8BBAC
		btst	#0,4(a0)
		beq.s	loc_8BBA6
		bchg	#6,d3

loc_8BBA6:
		btst	#6,d3
		beq.s	loc_8BBE0

loc_8BBAC:

		move.b	#4,5(a0)
		move.w	#-$200,d0
		move.w	#$40,d1
		btst	#0,4(a0)
		beq.s	loc_8BBC6
		neg.w	d0
		neg.w	d1

loc_8BBC6:
		move.w	d0,$18(a0)
		move.w	d1,$40(a0)
		move.l	#byte_8BE11,$30(a0)
		move.l	#loc_8BC08,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8BBE0:
		move.b	#$E,5(a0)
		move.w	#$40,$2E(a0)
		move.l	#loc_8BBAC,$34(a0)

loc_8BBF4:


		neg.w	$18(a0)
		neg.w	$40(a0)
		bchg	#0,4(a0)
		rts
; ---------------------------------------------------------------------------

loc_8BC04:
		jmp	Move_AnimateRaw(pc)
; ---------------------------------------------------------------------------

loc_8BC08:


		move.b	#6,5(a0)
		move.b	#$B,$1E(a0)
		move.l	#loc_8BC26,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8BC1E:
		jsr	MoveSprite_LightGravity(pc)
		jmp	ObjHitFloor_DoRoutine(pc)
; ---------------------------------------------------------------------------

loc_8BC26:
		tst.b	d3
		move.b	d3,d4
		bpl.s	loc_8BC2E
		neg.b	d4

loc_8BC2E:
		andi.b	#-8,d4
		beq.s	loc_8BC52
		tst.w	$18(a0)
		bmi.s	loc_8BC3E
		bchg	#6,d3

loc_8BC3E:
		btst	#6,d3
		bne.s	loc_8BC52
		neg.w	$18(a0)
		neg.w	$40(a0)
		bchg	#0,4(a0)

loc_8BC52:

		move.b	#8,5(a0)
		move.w	#$20,$2E(a0)
		move.l	#loc_8BC94,$34(a0)
		clr.w	$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_8BC6C:
		bsr.w	sub_8BD88
		cmpi.w	#-2,d1
		blt.w	loc_8BBF4
		cmpi.w	#$C,d1
		bge.s	loc_8BC08
		add.w	d1,$14(a0)
		bsr.w	sub_8BD9C
		bsr.w	sub_8BDC2
		jsr	(MoveSprite2).l
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_8BC94:
		move.b	#$A,5(a0)
		moveq	#8,d0
		sub.b	$22(a0),d0
		move.b	d0,$23(a0)
		clr.b	$24(a0)
		move.l	#byte_8BE16,$30(a0)
		move.l	#loc_8BCDC,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8BCBA:
		bsr.w	sub_8BD88
		cmpi.w	#-2,d1
		blt.w	loc_8BBF4
		cmpi.w	#$C,d1
		bge.w	loc_8BC08
		add.w	d1,$14(a0)
		jsr	(MoveSprite2).l
		jmp	Animate_Raw(pc)
; ---------------------------------------------------------------------------

loc_8BCDC:
		move.b	#$C,5(a0)
		move.b	#0,$22(a0)
		move.b	#$F,$1E(a0)
		subq.w	#4,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_8BCF4:
		move.w	$18(a0),d0
		add.w	$40(a0),d0
		move.w	d0,$18(a0)
		beq.s	loc_8BD1C
		bsr.w	sub_8BD88
		cmpi.w	#-2,d1
		blt.s	loc_8BD1C
		cmpi.w	#$C,d1
		bge.s	loc_8BD1C
		add.w	d1,$14(a0)
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_8BD1C:

		move.b	#$E,5(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,$2E(a0)
		move.l	#loc_8BB24,$34(a0)
		bchg	#0,4(a0)
		rts
; ---------------------------------------------------------------------------

loc_8BD3C:
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

Obj_ICZSnowdust:

		lea	ObjDat3_8BDEE(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		jsr	Refresh_ChildPositionAdjusted(pc)
		moveq	#0,d0
		move.b	$2C(a0),d0
		beq.s	loc_8BD6C
		move.l	#Obj_Wait,(a0)
		lsl.w	#2,d0
		subq.w	#1,d0
		move.w	d0,$2E(a0)
		move.l	#loc_8BD6C,$34(a0)

locret_8BD6A:
		rts
; ---------------------------------------------------------------------------

loc_8BD6C:

		move.l	#loc_8BD7A,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)

loc_8BD7A:
		lea	byte_8BE1F(pc),a1
		jsr	Animate_RawNoSST(pc)
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_8BD88:

		move.w	$18(a0),d3
		ext.l	d3
		lsl.l	#8,d3
		add.l	$10(a0),d3
		swap	d3
		jmp	(ObjHitFloor2).l
; End of function sub_8BD88


; =============== S U B R O U T I N E =======================================


sub_8BD9C:
		moveq	#4,d0
		tst.b	d3
		beq.s	loc_8BDAC
		lsr.b	#3,d3
		andi.w	#$F,d3
		move.b	RawAni_8BDB2(pc,d3.w),d0

loc_8BDAC:
		move.b	d0,$22(a0)
		rts
; End of function sub_8BD9C

; ---------------------------------------------------------------------------
RawAni_8BDB2:	dc.b   4,  5,  6,  6,  7,  7,  8,  8,  8,  8,  7,  7,  6,  6,  5,  4

; =============== S U B R O U T I N E =======================================


sub_8BDC2:
		move.w	$2E(a0),d0
		andi.w	#3,d0
		bne.s	locret_8BD6A
		moveq	#-$38,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_8BDFA(pc),a2
		jmp	CreateChild1_Normal(pc)
; End of function sub_8BDC2

; ---------------------------------------------------------------------------
ObjDat4_8BDDC:	dc.w 3
		dc.w $2500
		dc.w $12
		dc.w 0
		dc.l Map_Penguinator
		dc.w $280
		dc.b $14
		dc.b $10
		dc.b 0
		dc.b $1A
ObjDat3_8BDEE:	dc.l Map_ICZSnowdust
		dc.w $2558
		dc.w 0
		dc.b 4
		dc.b $18
		dc.b 0
		dc.b 0
ChildObjDat_8BDFA:dc.w 0
		dc.l Obj_ICZSnowdust
		dc.w $C
DPLCPtr_8BE02:	dc.l ArtUnc_Penguinator
		dc.l DPLC_Penguinator
byte_8BE0A:	dc.b	7, $10
		dc.b	0,   1
		dc.b	0,   2
		dc.b  $FC
byte_8BE11:	dc.b	3,   3
		dc.b	3,   4
		dc.b  $F4
byte_8BE16:	dc.b	3,   8
		dc.b	8,   7
		dc.b	6,   5
		dc.b	4,   3
		dc.b  $F4
byte_8BE1F:	dc.b	0,   0,	  0,   1,   2,	 3,   4,   5,	4,   3,	  2,   1,   0, $F4,   0

; ---------------------------------------------------------------------------

Obj_StarPointer:

		jsr	(Obj_WaitOffscreen).l
		lea	ObjDat3_8BF8E(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.l	#loc_8BE74,(a0)
		bclr	#1,4(a0)
		beq.s	loc_8BE50
		bset	#7,$A(a0)

loc_8BE50:
		moveq	#0,d0
		move.b	$2C(a0),d0
		andi.w	#6,d0
		move.w	word_8BE6C(pc,d0.w),d4
		jsr	(Set_VelocityXTrackSonic).l
		lea	ChildObjDat_8BFA0(pc),a2
		jmp	CreateChild3_NormalRepeated(pc)
; ---------------------------------------------------------------------------
word_8BE6C:	dc.w  $FFC0, $FFA0, $FF80, $FF00
; ---------------------------------------------------------------------------

loc_8BE74:
		jsr	(MoveSprite2).l
		jsr	Find_SonicTails(pc)
		cmpi.w	#$80,d2
		bcc.s	loc_8BE92
		btst	#0,4(a0)
		beq.s	loc_8BE8E
		subq.w	#2,d0

loc_8BE8E:
		tst.w	d0
		beq.s	loc_8BE96

loc_8BE92:
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------

loc_8BE96:
		move.l	#loc_8BEA6,(a0)
		bset	#1,$38(a0)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------

loc_8BEA6:
		jsr	(MoveSprite2).l
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------

loc_8BEB0:
		lea	word_8BF9A(pc),a1
		jsr	SetUp_ObjAttributes3(pc)
		bset	#3,$2B(a0)
		move.b	#8,$1F(a0)
		move.l	#loc_8BEE6,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.b	#1,d0
		move.b	byte_8BEE2(pc,d0.w),$3C(a0)
		move.l	#loc_8BF64,$34(a0)
		rts
; ---------------------------------------------------------------------------
byte_8BEE2:	dc.b 0
		dc.b $40
		dc.b $80
		dc.b $C0
; ---------------------------------------------------------------------------

loc_8BEE6:
		btst	#0,($FFFFFE0F).w
		bne.s	loc_8BF3E
		movea.w	$46(a0),a1
		btst	#0,4(a1)
		beq.s	loc_8BF02
		addq.b	#1,$3C(a0)
		bra.w	loc_8BF06
; ---------------------------------------------------------------------------

loc_8BF02:
		subq.b	#1,$3C(a0)

loc_8BF06:
		bne.s	loc_8BF3E
		btst	#1,$38(a1)
		beq.s	loc_8BF3E
		move.l	#loc_8BF4C,(a0)
		move.w	$18(a1),d0
		asl.w	#1,d0
		move.l	#ObjHitWall_DoRoutine,$30(a0)
		move.w	#8,$44(a0)
		move.w	d0,$18(a0)
		bpl.s	loc_8BF3E
		move.l	#ObjHitWall2_DoRoutine,$30(a0)
		move.w	#-8,$44(a0)

loc_8BF3E:

		bsr.w	sub_8BF80
		moveq	#4,d2
		jsr	MoveSprite_CircularSimple(pc)
		jmp	Child_DrawTouch_Sprite(pc)
; ---------------------------------------------------------------------------

loc_8BF4C:
		jsr	(MoveSprite2).l
		movea.l	$30(a0),a1
		move.w	$44(a0),d3
		jsr	(a1)
		bsr.w	sub_8BF80
		jmp	Sprite_CheckDeleteTouchXY(pc)
; ---------------------------------------------------------------------------

loc_8BF64:
		move.l	#loc_8BF74,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8BF74:
		lea	byte_8BFA8(pc),a1
		jsr	Animate_RawNoSST(pc)
		jmp	Sprite_CheckDeleteTouchXY(pc)

; =============== S U B R O U T I N E =======================================


sub_8BF80:

		tst.b	$28(a0)
		bne.s	locret_8BF8C
		movea.l	$34(a0),a1
		jsr	(a1)

locret_8BF8C:
		rts
; End of function sub_8BF80

; ---------------------------------------------------------------------------
ObjDat3_8BF8E:	dc.l Map_StarPointer
		dc.w $2548
		dc.w $280
		dc.b 8
		dc.b 8
		dc.b 0
		dc.b $B
word_8BF9A:	dc.w $280
		dc.b 8
		dc.b 8
		dc.b 1
		dc.b $8B
ChildObjDat_8BFA0:dc.w 3
		dc.l loc_8BEB0
		dc.w 0
byte_8BFA8:	dc.b	3,   1,	  2,   3, $F4,	 0
; ---------------------------------------------------------------------------

Obj_SnaleBlaster:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8BFC6(pc,d0.w),d1
		jsr	off_8BFC6(pc,d1.w)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------
off_8BFC6:	dc.w loc_8BFD4-off_8BFC6

		dc.w loc_8BFF2-off_8BFC6
		dc.w loc_8C026-off_8BFC6
		dc.w loc_8C052-off_8BFC6
		dc.w loc_8C0AA-off_8BFC6
		dc.w loc_8C0D4-off_8BFC6
		dc.w loc_8C0F4-off_8BFC6
; ---------------------------------------------------------------------------

loc_8BFD4:
		lea	ObjDat3_8C266(pc),a1
		jsr	SetUp_ObjAttributes(pc)
		move.w	#$20,$2E(a0)
		move.l	#loc_8C00E,$34(a0)
		lea	ChildObjDat_8C28A(pc),a2
		jmp	CreateChild1_Normal(pc)
; ---------------------------------------------------------------------------

loc_8BFF2:
		move.b	#$1A,$28(a0)
		clr.b	$29(a0)
		btst	#1,$38(a0)

loc_8C002:
		bne.s	loc_8C00A
		move.b	#$7F,$29(a0)

loc_8C00A:
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_8C00E:
		move.b	#4,5(a0)
		move.l	#byte_8C2B6,$30(a0)
		move.l	#loc_8C030,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C026:
		move.b	#$1A,$28(a0)
		jmp	Animate_Raw(pc)
; ---------------------------------------------------------------------------

loc_8C030:
		move.w	#-2,$40(a0)
		move.l	#byte_8C2C0,$30(a0)

loc_8C03E:
		move.b	#6,5(a0)
		move.b	#2,$39(a0)
		bclr	#1,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C052:
		move.b	#$1A,$28(a0)
		move.b	#$7F,$29(a0)
		bsr.w	sub_8C23C
		jsr	Animate_RawMultiDelay(pc)
		tst.w	d2
		beq.s	locret_8C088
		moveq	#3,d0
		tst.w	$40(a0)
		bmi.s	loc_8C074
		moveq	#4,d0

loc_8C074:
		cmp.b	$22(a0),d0
		bne.s	locret_8C088
		move.w	$40(a0),d0
		add.w	d0,$14(a0)
		subq.b	#1,$39(a0)
		bmi.s	loc_8C08A

locret_8C088:

		rts
; ---------------------------------------------------------------------------

loc_8C08A:
		move.b	#2,5(a0)
		move.w	#$90,$2E(a0)
		bset	#1,$38(a0)
		move.l	#loc_8C03E,$34(a0)
		neg.w	$40(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C0AA:
		move.b	#$7F,$29(a0)
		subq.b	#1,$22(a0)
		beq.s	loc_8C0B8
		rts
; ---------------------------------------------------------------------------

loc_8C0B8:
		move.b	#$A,5(a0)
		move.b	#$7F,$29(a0)
		move.w	#$3B,$2E(a0)
		move.l	#loc_8C0DE,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C0D4:
		move.b	#$7F,$29(a0)
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_8C0DE:
		move.b	#$C,5(a0)
		move.w	#$F,$2E(a0)
		move.l	#loc_8C0F8,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C0F4:
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_8C0F8:
		move.b	#$1A,$28(a0)
		move.b	#$7F,$29(a0)
		move.w	#2,$2E(a0)
		addq.b	#1,$22(a0)
		cmpi.b	#3,$22(a0)
		bcs.s	locret_8C11C
		move.b	#6,5(a0)

locret_8C11C:
		rts
; ---------------------------------------------------------------------------

loc_8C11E:
		jsr	Refresh_ChildPositionAdjusted(pc)
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8C134(pc,d0.w),d1
		jsr	off_8C134(pc,d1.w)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------
off_8C134:	dc.w loc_8C13A-off_8C134

		dc.w loc_8C144-off_8C134
		dc.w Animate_RawMultiDelay-off_8C134
; ---------------------------------------------------------------------------

loc_8C13A:
		lea	word_8C272(pc),a1
		jmp	(SetUp_ObjAttributes3).l
; ---------------------------------------------------------------------------

loc_8C144:
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		bne.s	loc_8C152
		rts
; ---------------------------------------------------------------------------

loc_8C152:
		move.b	#4,5(a0)
		move.l	#byte_8C2C5,$30(a0)
		move.l	#loc_8C16A,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C16A:
		move.b	#2,5(a0)
		movea.w	$46(a0),a1
		bclr	#1,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_8C17C:

		jsr	Refresh_ChildPositionAdjusted(pc)
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8C192(pc,d0.w),d1
		jsr	off_8C192(pc,d1.w)
		jmp	Child_DrawTouch_Sprite(pc)
; ---------------------------------------------------------------------------
off_8C192:	dc.w loc_8C19A-off_8C192

		dc.w loc_8C1A4-off_8C192
		dc.w loc_8C1D8-off_8C192
		dc.w loc_8C226-off_8C192
; ---------------------------------------------------------------------------

loc_8C19A:
		lea	word_8C278(pc),a1
		jmp	(SetUp_ObjAttributes3).l
; ---------------------------------------------------------------------------

loc_8C1A4:
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		bne.s	loc_8C1B2
		rts
; ---------------------------------------------------------------------------

loc_8C1B2:
		move.b	#4,5(a0)
		move.l	#byte_8C2D0,$30(a0)
		tst.b	$2C(a0)
		beq.s	loc_8C1CE
		move.l	#byte_8C2D9,$30(a0)

loc_8C1CE:
		move.l	#loc_8C21E,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C1D8:
		jsr	Animate_RawMultiDelay(pc)
		tst.w	d2
		beq.s	locret_8C21C
		bmi.s	locret_8C21C
		cmpi.b	#4,$23(a0)
		bne.s	locret_8C21C
		tst.b	4(a0)
		bpl.s	locret_8C21C
		moveq	#$4D,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_8C29E(pc),a2
		jsr	(CreateChild2_Complex).l
		movea.w	$46(a0),a2
		btst	#0,4(a2)
		beq.s	loc_8C212
		neg.w	$18(a1)

loc_8C212:
		tst.b	$2C(a0)
		beq.s	locret_8C21C
		neg.w	$1A(a1)

locret_8C21C:

		rts
; ---------------------------------------------------------------------------

loc_8C21E:
		move.b	#6,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C226:
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		beq.s	loc_8C234
		rts
; ---------------------------------------------------------------------------

loc_8C234:
		move.b	#2,5(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_8C23C:
		jsr	Find_SonicTails(pc)
		cmpi.w	#$30,d2
		bcc.s	locret_8C254
		cmpi.w	#$30,d3
		bcc.s	locret_8C254
		cmpi.b	#2,$20(a1)
		beq.s	loc_8C256

locret_8C254:
		rts
; ---------------------------------------------------------------------------

loc_8C256:
		move.b	#8,5(a0)
		move.b	#3,$22(a0)
		addq.w	#4,sp
		rts
; End of function sub_8C23C

; ---------------------------------------------------------------------------
ObjDat3_8C266:	dc.l Map_SnaleBlaster
		dc.w $2524
		dc.w $200
		dc.b $10
		dc.b $10
		dc.b 0
		dc.b $B
word_8C272:	dc.w $180
		dc.b 4
		dc.b $C
		dc.b 5
		dc.b 0
word_8C278:	dc.w $200
		dc.b 4
		dc.b 4
		dc.b 7
		dc.b 0
ObjDat3_8C27E:	dc.l Map_SnaleBlaster
		dc.w $8524
		dc.w $200
		dc.b 4
		dc.b 4
		dc.b 9
		dc.b $98
ChildObjDat_8C28A:dc.w 2
		dc.l loc_8C17C
		dc.w $F800
		dc.l loc_8C17C
		dc.w $F807
		dc.l loc_8C11E
		dc.w $F804
ChildObjDat_8C29E:dc.w 0
		dc.l loc_86D4A
		dc.l ObjDat3_8C27E
		dc.l 0
		dc.l MoveSprite2
		dc.b 0
		dc.b 0
		dc.w $FE00
		dc.w $FF00
byte_8C2B6:	dc.b 5
		dc.b 0
		dc.b 1
		dc.b 2
		dc.b 3
		dc.b 4
		dc.b 4
		dc.b 4
		dc.b 4
		dc.b $F4
byte_8C2C0:	dc.b 4
		dc.b $F
		dc.b 3
		dc.b $F
		dc.b $FC
byte_8C2C5:	dc.b 5
		dc.b 2
		dc.b 6
		dc.b 2
		dc.b $A
		dc.b $5F
		dc.b 6
		dc.b 2
		dc.b 5
		dc.b 2
		dc.b $F4
byte_8C2D0:	dc.b 7
		dc.b 2
		dc.b 7
		dc.b $1F
		dc.b 8
		dc.b 3
		dc.b 7
		dc.b 0
		dc.b $F4
byte_8C2D9:	dc.b 7
		dc.b 2
		dc.b 7
		dc.b $2F
		dc.b 8
		dc.b 3
		dc.b 7
		dc.b 0
		dc.b $F4
; ---------------------------------------------------------------------------

Obj_Ribot:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8C2FA(pc,d0.w),d1
		jsr	off_8C2FA(pc,d1.w)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------

off_8C2FA:	dc.w loc_8C2FE-off_8C2FA
		dc.w loc_8C34E-off_8C2FA
; ---------------------------------------------------------------------------

loc_8C2FE:
		lea	ObjDat3_8C5CA(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bset	#2,$38(a0)
		move.b	$2C(a0),d0
		subq.b	#2,d0
		beq.s	loc_8C32A
		bpl.s	loc_8C33C
		move.l	#byte_8C626,$30(a0)
		lea	ChildObjDat_8C5E2(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_8C32A:
		move.l	#byte_8C626,$30(a0)
		lea	ChildObjDat_8C5F0(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_8C33C:
		move.l	#byte_8C62C,$30(a0)
		lea	ChildObjDat_8C5FE(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_8C34E:
		bclr	#2,$38(a0)
		beq.s	loc_8C36C
		andi.b	#-4,$38(a0)
		moveq	#0,d0
		bchg	#3,$38(a0)
		beq.s	loc_8C368
		moveq	#1,d0

loc_8C368:
		bset	d0,$38(a0)

loc_8C36C:
		jmp	Animate_Raw(pc)
; ---------------------------------------------------------------------------

loc_8C370:

		moveq	#0,d2
		movea.w	$46(a0),a1
		move.b	$2C(a1),d2
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8C38C(pc,d0.w),d1
		jsr	off_8C38C(pc,d1.w)
		jmp	Child_DrawTouch_Sprite(pc)
; ---------------------------------------------------------------------------
off_8C38C:	dc.w loc_8C396-off_8C38C

		dc.w loc_8C3BC-off_8C38C
		dc.w loc_8C428-off_8C38C
		dc.w loc_8C48E-off_8C38C
		dc.w loc_8C4BA-off_8C38C
; ---------------------------------------------------------------------------

loc_8C396:
		lea	word_8C5D6(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.b	#8,$1E(a0)
		move.b	#-$10,$43(a0)
		move.w	$10(a0),$3E(a0)
		move.w	$14(a0),$40(a0)
		bra.w	loc_8C594
; ---------------------------------------------------------------------------

loc_8C3BC:
		move.w	off_8C3C4(pc,d2.w),d3
		jmp	off_8C3C4(pc,d3.w)
; ---------------------------------------------------------------------------
off_8C3C4:	dc.w loc_8C3CA-off_8C3C4

		dc.w loc_8C3EC-off_8C3C4
		dc.w loc_8C41E-off_8C3C4
; ---------------------------------------------------------------------------

loc_8C3CA:
		moveq	#0,d0
		tst.b	$2C(a0)
		bne.s	loc_8C3D4
		moveq	#1,d0

loc_8C3D4:
		btst	d0,$38(a1)
		bne.s	loc_8C3DC
		rts
; ---------------------------------------------------------------------------

loc_8C3DC:
		move.b	#4,5(a0)
		move.l	#loc_8C456,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C3EC:
		moveq	#0,d0
		move.w	#$400,d1
		tst.b	$2C(a0)
		bne.s	loc_8C3FC
		moveq	#1,d0
		neg.w	d1

loc_8C3FC:
		btst	d0,$38(a1)
		bne.s	loc_8C404

locret_8C402:
		rts
; ---------------------------------------------------------------------------

loc_8C404:
		move.b	#4,5(a0)
		move.w	d1,$18(a0)
		move.w	#$F,$2E(a0)
		move.l	#loc_8C46A,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C41E:
		addq.b	#2,$3C(a0)
		moveq	#2,d2
		jmp	MoveSprite_CircularSimpleOffset(pc)
; ---------------------------------------------------------------------------

loc_8C428:
		move.w	off_8C430(pc,d2.w),d3
		jmp	off_8C430(pc,d3.w)
; ---------------------------------------------------------------------------
off_8C430:	dc.w loc_8C436-off_8C430

		dc.w loc_8C484-off_8C430
		dc.w loc_8C436-off_8C430
; ---------------------------------------------------------------------------

loc_8C436:
		move.w	$14(a0),d0
		sub.w	$40(a0),d0
		cmpi.w	#$80,d0
		bcc.s	loc_8C46A
		jsr	(MoveSprite).l
		tst.w	$1A(a0)
		bmi.w	locret_8C482
		jmp	ObjHitFloor_DoRoutine(pc)
; ---------------------------------------------------------------------------

loc_8C456:
		move.w	$1A(a0),d0
		cmpi.w	#$100,d0
		bcs.s	loc_8C46A
		asr.w	#2,d0
		neg.w	d0
		move.w	d0,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C46A:


		move.b	#6,5(a0)
		move.w	#$10,$2E(a0)
		move.l	#loc_8C4A0,$34(a0)
		clr.w	$1A(a0)

locret_8C482:
		rts
; ---------------------------------------------------------------------------

loc_8C484:
		jsr	(MoveSprite2).l
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_8C48E:
		move.w	off_8C496(pc,d2.w),d3
		jmp	off_8C496(pc,d3.w)
; ---------------------------------------------------------------------------
off_8C496:	dc.w loc_8C49C-off_8C496

		dc.w loc_8C49C-off_8C496
		dc.w loc_8C49C-off_8C496
; ---------------------------------------------------------------------------

loc_8C49C:
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_8C4A0:
		move.b	#8,5(a0)
		neg.w	$18(a0)
		move.w	#$F,$2E(a0)
		move.l	#loc_8C4DA,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C4BA:
		move.w	off_8C4C2(pc,d2.w),d3
		jmp	off_8C4C2(pc,d3.w)
; ---------------------------------------------------------------------------
off_8C4C2:	dc.w loc_8C4C8-off_8C4C2

		dc.w loc_8C4F8-off_8C4C2
		dc.w loc_8C4C8-off_8C4C2
; ---------------------------------------------------------------------------

loc_8C4C8:
		move.w	$14(a0),d0
		subq.w	#2,d0
		cmp.w	$40(a0),d0
		bls.s	loc_8C4DA
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C4DA:

		move.b	#2,5(a0)
		move.w	$3E(a0),$10(a0)
		move.w	$40(a0),$14(a0)
		movea.w	$46(a0),a1
		bset	#2,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_8C4F8:
		jsr	(MoveSprite2).l
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_8C502:

		lea	word_8C5DC(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_8C522,(a0)
		move.w	$10(a0),$3E(a0)
		move.w	$14(a0),$40(a0)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------

loc_8C522:
		movea.w	$46(a0),a1
		move.w	$10(a1),d2
		move.w	$14(a1),d3
		sub.w	$3E(a0),d2
		sub.w	$40(a0),d3
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	off_8C548(pc,d0.w),d1
		jsr	off_8C548(pc,d1.w)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------
off_8C548:	dc.w loc_8C54E-off_8C548

		dc.w loc_8C568-off_8C548
		dc.w loc_8C57E-off_8C548
; ---------------------------------------------------------------------------

loc_8C54E:
		asr.w	#2,d2
		neg.w	d2
		add.w	$10(a1),d2
		move.w	d2,$10(a0)
		asr.w	#2,d3
		neg.w	d3
		add.w	$14(a1),d3
		move.w	d3,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C568:
		asr.w	#1,d2
		add.w	$3E(a0),d2
		move.w	d2,$10(a0)
		asr.w	#1,d3
		add.w	$40(a0),d3
		move.w	d3,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C57E:
		asr.w	#2,d2
		add.w	$3E(a0),d2
		move.w	d2,$10(a0)
		asr.w	#2,d3
		add.w	$40(a0),d3
		move.w	d3,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C594:
		movea.w	$46(a0),a1
		move.b	$2C(a1),d0
		subq.b	#2,d0
		beq.s	loc_8C5AC
		bpl.s	loc_8C5C0
		lea	ChildObjDat_8C606(pc),a2
		jmp	(CreateChild3_NormalRepeated).l
; ---------------------------------------------------------------------------

loc_8C5AC:
		lea	ChildObjDat_8C60E(pc),a2
		tst.b	$2C(a0)
		beq.s	loc_8C5BA
		lea	ChildObjDat_8C616(pc),a2

loc_8C5BA:
		jmp	(CreateChild3_NormalRepeated).l
; ---------------------------------------------------------------------------

loc_8C5C0:
		lea	ChildObjDat_8C61E(pc),a2
		jmp	(CreateChild3_NormalRepeated).l
; ---------------------------------------------------------------------------
ObjDat3_8C5CA:	dc.l Map_Ribot
		dc.w $2547
		dc.w $280
		dc.b $10
		dc.b $C
		dc.b 0
		dc.b $B
word_8C5D6:	dc.w $200
		dc.b 8
		dc.b 8
		dc.b 7
		dc.b $97
word_8C5DC:	dc.w $200
		dc.b 4
		dc.b 4
		dc.b 6
		dc.b 0
ChildObjDat_8C5E2:dc.w 1
		dc.l loc_8C370
		dc.w $F40C
		dc.l loc_8C370
		dc.w $C0C
ChildObjDat_8C5F0:dc.w 1
		dc.l loc_8C370
		dc.w $E800
		dc.l loc_8C370
		dc.w $1800
ChildObjDat_8C5FE:dc.w 0
		dc.l loc_8C370
		dc.w $F0
ChildObjDat_8C606:dc.w 2
		dc.l loc_8C502
		dc.w $F4
ChildObjDat_8C60E:dc.w 2
		dc.l loc_8C502
		dc.w $C00
ChildObjDat_8C616:dc.w 2
		dc.l loc_8C502
		dc.w $F400
ChildObjDat_8C61E:dc.w 2
		dc.l loc_8C502
		dc.w 0
byte_8C626:	dc.b 7

		dc.b 0
		dc.b 1
		dc.b 2
		dc.b 1
		dc.b $FC
byte_8C62C:	dc.b 7
		dc.b 3
		dc.b 4
		dc.b 5
		dc.b 4
		dc.b $FC
; ---------------------------------------------------------------------------

Obj_Orbinaut:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8C64A(pc,d0.w),d1
		jsr	off_8C64A(pc,d1.w)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------
off_8C64A:	dc.w loc_8C64E-off_8C64A

		dc.w loc_8C662-off_8C64A
; ---------------------------------------------------------------------------

loc_8C64E:
		lea	ObjDat3_8C6F2(pc),a1
		jsr	(SetUp_ObjAttributes).l
		lea	ChildObjDat_8C704(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_8C662:
		lea	($FFFFB000).w,a1
		jsr	Find_OtherObject(pc)
		bclr	#0,4(a0)
		move.w	#-$80,d1
		tst.w	d0
		beq.s	loc_8C680
		bset	#0,4(a0)
		neg.w	d1

loc_8C680:
		move.w	d1,$18(a0)
		bsr.w	sub_8C6D4
		beq.w	locret_8C6F0
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_8C692:

		lea	word_8C6FE(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_8C6B0,(a0)
		move.b	$2C(a0),d0
		lsl.b	#5,d0
		move.b	d0,$3C(a0)
		jmp	Child_DrawTouch_Sprite(pc)
; ---------------------------------------------------------------------------

loc_8C6B0:
		movea.w	$46(a0),a1
		bsr.w	sub_8C6D4
		beq.s	loc_8C6CA
		moveq	#8,d0
		btst	#0,4(a1)
		beq.s	loc_8C6C6
		moveq	#-8,d0

loc_8C6C6:
		add.b	d0,$3C(a0)

loc_8C6CA:
		moveq	#4,d2
		jsr	MoveSprite_CircularSimple(pc)
		jmp	Child_DrawTouch_Sprite(pc)

; =============== S U B R O U T I N E =======================================


sub_8C6D4:

		lea	($FFFFB000).w,a2
		btst	#1,$2A(a2)
		bne.s	loc_8C6EC
		tst.w	$18(a2)
		bne.s	locret_8C6F0
		tst.w	$1A(a2)
		bne.s	locret_8C6F0

loc_8C6EC:
		moveq	#0,d0
		rts
; ---------------------------------------------------------------------------

locret_8C6F0:

		rts
; End of function sub_8C6D4

; ---------------------------------------------------------------------------
ObjDat3_8C6F2:	dc.l Map_Orbinaut
		dc.w $256E
		dc.w $280
		dc.b 8
		dc.b 8
		dc.b 0
		dc.b $B
word_8C6FE:	dc.w $280
		dc.b 8
		dc.b 8
		dc.b 1
		dc.b $8B
ChildObjDat_8C704:dc.w 3
		dc.l loc_8C692
		dc.w $10
		dc.l loc_8C692
		dc.w $1000
		dc.l loc_8C692
		dc.w $F0
		dc.l loc_8C692
		dc.b $F0 ; 
		dc.b 0
		dc.b 0
		dc.b 5
		dc.b 1
		dc.b 5
		dc.b 2
		dc.b 5
		dc.b 3
		dc.b 5
		dc.b $FC
		dc.b 0
; ---------------------------------------------------------------------------

Obj_Corkey:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8C740(pc,d0.w),d1
		jsr	off_8C740(pc,d1.w)
		jmp	Sprite_CheckDeleteTouch(pc)
; ---------------------------------------------------------------------------
off_8C740:	dc.w loc_8C746-off_8C740

		dc.w loc_8C79C-off_8C740
		dc.w loc_8C7CC-off_8C740
; ---------------------------------------------------------------------------

loc_8C746:
		lea	ObjDat3_8C8F4(pc),a1
		jsr	(SetUp_ObjAttributes).l
		moveq	#-1,d0
		btst	#0,4(a0)
		beq.s	loc_8C75C
		neg.w	d0

loc_8C75C:
		move.w	d0,$40(a0)
		move.b	$2C(a0),d0
		move.b	d0,$2F(a0)
		move.l	#loc_8C7BC,$34(a0)
		add.b	d0,d0
		move.b	d0,$2C(a0)
		lea	ChildObjDat_8C90E(pc),a2
		jsr	(CreateChild1_Normal).l

loc_8C780:
		jsr	(Random_Number).l
		andi.w	#$3F,d0
		move.w	d0,d1
		andi.w	#$30,d1
		bne.s	loc_8C796
		ori.w	#$30,d0

loc_8C796:
		move.w	d0,$3A(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C79C:
		subq.w	#1,$3A(a0)
		bmi.s	loc_8C7AE
		move.w	$40(a0),d0
		add.w	d0,$10(a0)
		jmp	Obj_Wait(pc)
; ---------------------------------------------------------------------------

loc_8C7AE:
		move.b	#4,5(a0)
		bset	#1,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C7BC:
		neg.w	$40(a0)
		clr.b	$2E(a0)
		move.b	$2C(a0),$2F(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C7CC:
		btst	#1,$38(a0)
		beq.s	loc_8C7D6
		rts
; ---------------------------------------------------------------------------

loc_8C7D6:
		move.b	#2,5(a0)
		bra.s	loc_8C780
; ---------------------------------------------------------------------------

loc_8C7DE:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8C7F0(pc,d0.w),d1
		jsr	off_8C7F0(pc,d1.w)
		jmp	Child_Draw_Sprite(pc)
; ---------------------------------------------------------------------------
off_8C7F0:	dc.w loc_8C7F8-off_8C7F0

		dc.w loc_8C802-off_8C7F0
		dc.w loc_8C82C-off_8C7F0
		dc.w loc_8C8A8-off_8C7F0
; ---------------------------------------------------------------------------

loc_8C7F8:
		lea	word_8C900(pc),a1
		jmp	(SetUp_ObjAttributes3).l
; ---------------------------------------------------------------------------

loc_8C802:
		jsr	(Refresh_ChildPositionAdjusted).l
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		beq.s	locret_8C82A
		move.b	#4,5(a0)
		move.l	#loc_8C88C,$34(a0)
		move.l	#byte_8C92E,$30(a0)

locret_8C82A:
		rts
; ---------------------------------------------------------------------------

loc_8C82C:
		jsr	(Animate_RawGetFaster).l
		tst.w	d2
		bpl.s	locret_8C84E
		cmpi.b	#4,$2F(a0)
		beq.s	loc_8C850
		cmpi.b	#5,$2F(a0)
		beq.s	loc_8C864
		cmpi.b	#6,$2F(a0)
		beq.s	loc_8C878

locret_8C84E:
		rts
; ---------------------------------------------------------------------------

loc_8C850:
		lea	ChildObjDat_8C916(pc),a2
		jsr	(CreateChild1_Normal).l
		move.l	#byte_8C933,$30(a1)
		rts
; ---------------------------------------------------------------------------

loc_8C864:
		lea	ChildObjDat_8C91E(pc),a2
		jsr	(CreateChild1_Normal).l
		move.l	#byte_8C93C,$30(a1)
		rts
; ---------------------------------------------------------------------------

loc_8C878:
		lea	ChildObjDat_8C926(pc),a2
		jsr	(CreateChild1_Normal).l
		move.l	#byte_8C945,$30(a1)
		rts
; ---------------------------------------------------------------------------

loc_8C88C:
		move.b	#6,5(a0)
		move.b	#2,$22(a0)
		move.w	#7,$2E(a0)
		move.l	#loc_8C8AE,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C8A8:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_8C8AE:
		move.b	#2,5(a0)
		move.b	#1,$22(a0)
		movea.w	$46(a0),a1
		bclr	#1,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_8C8C6:

		lea	word_8C906(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#loc_8C8E6,(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		moveq	#$5E,d0
		jsr	(Play_Sound_2).l

loc_8C8E6:
		addq.w	#1,$3A(a0)
		jsr	(Animate_RawMultiDelay).l
		jmp	Child_DrawTouch_Sprite(pc)
; ---------------------------------------------------------------------------
ObjDat3_8C8F4:	dc.l Map_Corkey
		dc.w $2558
		dc.w $280
		dc.b $10
		dc.b $C
		dc.b 0
		dc.b $B
word_8C900:	dc.w $280
		dc.b 8
		dc.b 4
		dc.b 1
		dc.b 0
word_8C906:	dc.w $558
		dc.w $280
		dc.b 4
		dc.b $50
		dc.b 0
		dc.b $A0
ChildObjDat_8C90E:dc.w 0
		dc.l loc_8C7DE
		dc.w $C
ChildObjDat_8C916:dc.w 0
		dc.l loc_8C8C6
		dc.w $FC54
ChildObjDat_8C91E:dc.w 0
		dc.l loc_8C8C6
		dc.w $454
ChildObjDat_8C926:dc.w 0
		dc.l loc_8C8C6
		dc.w $54
byte_8C92E:	dc.b 7
		dc.b $10
		dc.b 1
		dc.b 3
		dc.b $FC
byte_8C933:	dc.b 6
		dc.b 0
		dc.b 6
		dc.b 0
		dc.b 7
		dc.b 4
		dc.b 5
		dc.b 0
		dc.b $F4
byte_8C93C:	dc.b 5
		dc.b 0
		dc.b 5
		dc.b 0
		dc.b 7
		dc.b 4
		dc.b 6
		dc.b 0
		dc.b $F4
byte_8C945:	dc.b 4
		dc.b 0
		dc.b 5
		dc.b 0
		dc.b 7
		dc.b 0
		dc.b 4
		dc.b 0
		dc.b 5
		dc.b 0
		dc.b 7
		dc.b 0
		dc.b 4
		dc.b 0
		dc.b 5
		dc.b 0
		dc.b 7
		dc.b 0
		dc.b 4
		dc.b 0
		dc.b 5
		dc.b 0
		dc.b 7
		dc.b 0
		dc.b 4
		dc.b 0
		dc.b 5
		dc.b 0
		dc.b 7
		dc.b 0
		dc.b 6
		dc.b 3
		dc.b $F4
; ---------------------------------------------------------------------------

Obj_Flybot767:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8C988(pc,d0.w),d1
		jsr	off_8C988(pc,d1.w)
		lea	DPLCPtr_8CB22(pc),a2
		jsr	Perform_DPLC(pc)
		jmp	(Sprite_CheckDeleteTouchSlotted).l
; ---------------------------------------------------------------------------
off_8C988:	dc.w loc_8C994-off_8C988

		dc.w loc_8C9B2-off_8C988
		dc.w loc_8CA16-off_8C988
		dc.w loc_8CA60-off_8C988
		dc.w loc_8CA96-off_8C988
		dc.w loc_8CADA-off_8C988
; ---------------------------------------------------------------------------

loc_8C994:
		lea	ObjDat4_8CB10(pc),a1
		jsr	SetUp_ObjAttributesSlotted(pc)
		move.l	#byte_8CB2A,$30(a0)
		move.b	#0,$42(a0)
		move.b	#-$40,$43(a0)
		rts
; ---------------------------------------------------------------------------

loc_8C9B2:
		lea	($FFFFB000).w,a1
		move.w	#$200,d0
		moveq	#$10,d1
		jsr	Chase_ObjectXOnly(pc)
		move.w	#$100,d0
		moveq	#$10,d1
		jsr	Chase_ObjectYOnly(pc)
		jsr	(MoveSprite2).l
		lea	($FFFFB000).w,a1
		jsr	Find_OtherObject(pc)
		tst.w	d1
		beq.s	loc_8C9E2
		cmpi.w	#$60,d2
		bcs.s	loc_8C9EC

loc_8C9E2:
		jsr	Change_FlipXWithVelocity(pc)
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_8C9EC:
		move.b	#4,5(a0)
		clr.w	$1A(a0)
		move.w	$14(a0),$44(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		move.l	#byte_8CB36,$30(a0)
		move.l	#loc_8CA22,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8CA16:
		jsr	(MoveSprite2).l
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_8CA22:
		move.b	#6,5(a0)
		lea	($FFFFB000).w,a1
		jsr	Find_OtherObject(pc)
		move.w	#$200,d1
		bset	#0,4(a0)
		tst.w	d0
		bne.s	loc_8CA46
		neg.w	d1
		bclr	#0,4(a0)

loc_8CA46:
		move.w	d1,$18(a0)
		move.l	#byte_8CB3F,$30(a0)
		move.w	#$200,$1A(a0)
		move.w	#$20,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_8CA60:
		jsr	(MoveSprite2).l
		subq.w	#1,$2E(a0)
		bpl.s	loc_8CA74
		jsr	Find_SonicTails(pc)
		tst.w	d1
		beq.s	loc_8CA7A

loc_8CA74:
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_8CA7A:
		move.b	#8,5(a0)
		move.l	#byte_8CB4B,$30(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		neg.w	$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_8CA96:
		jsr	(MoveSprite2).l
		move.w	$14(a0),d0
		cmp.w	$44(a0),d0
		bcs.s	loc_8CAAC
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_8CAAC:
		move.b	#$A,5(a0)
		move.l	#byte_8CB2A,$30(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		clr.w	$18(a0)
		clr.w	$1A(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_8CB08,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8CADA:
		lea	($FFFFB000).w,a1
		move.w	#$200,d0
		moveq	#$10,d1
		jsr	Chase_ObjectXOnly(pc)
		move.w	#$100,d0
		moveq	#$10,d1
		jsr	Chase_ObjectYOnly(pc)
		jsr	(MoveSprite2).l
		jsr	Change_FlipXWithVelocity(pc)
		jsr	(Animate_Raw).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_8CB08:
		move.b	#2,5(a0)
		rts
; ---------------------------------------------------------------------------
ObjDat4_8CB10:	dc.w 2
		dc.w $A500
		dc.w $C
		dc.w 0
		dc.l Map_Flybot767
		dc.w $280
		dc.b $10
		dc.b $10
		dc.b 0
		dc.b $1A
DPLCPtr_8CB22:	dc.l ArtUnc_Flybot
		dc.l DPLC_Flybot
byte_8CB2A:	dc.b 4

		dc.b 0
		dc.b 1
		dc.b 2
		dc.b 3
		dc.b 4
		dc.b 5
		dc.b 6
		dc.b 7
		dc.b 8
		dc.b 9
		dc.b $FC
byte_8CB36:	dc.b 2
		dc.b $A
		dc.b $A
		dc.b $B
		dc.b $C
		dc.b $D
		dc.b $E
		dc.b $F
		dc.b $F4
byte_8CB3F:	dc.b 3
		dc.b $10
		dc.b $10
		dc.b $11
		dc.b $12
		dc.b $13
		dc.b $F8
		dc.b 8
		dc.b 3
		dc.b $13
		dc.b $13
		dc.b $FC
byte_8CB4B:	dc.b 3
		dc.b $A
		dc.b $A
		dc.b $14
		dc.b $F8
		dc.b 6
		dc.b 3
		dc.b $14
		dc.b $14
		dc.b $FC
		dc.b 0
; ---------------------------------------------------------------------------

Obj_C3_1:
		cmpi.b	#2,($FFFFB038).w
		beq.s	loc_8CB90
		lea	word_8CB96(pc),a1
		jsr	Check_CameraInRange(pc)
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8CB80(pc,d0.w),d1
		jsr	off_8CB80(pc,d1.w)
		jsr	(sub_8D1FC).l
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_8CB80:	dc.w loc_8CB9E-off_8CB80

		dc.w loc_8CBF2-off_8CB80
		dc.w loc_8CC2E-off_8CB80
		dc.w loc_8CC5A-off_8CB80
		dc.w loc_8CC84-off_8CB80
		dc.w loc_8CCB4-off_8CB80
		dc.w loc_8CCE8-off_8CB80
		dc.w loc_8CD30-off_8CB80
; ---------------------------------------------------------------------------

loc_8CB90:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
word_8CB96:	dc.w   $500,  $5E0, $3820, $3AC0
; ---------------------------------------------------------------------------

loc_8CB9E:
		lea	ObjDat3_8D230(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#-1,$29(a0)
		st	($FFFFFAAB).w
		jsr	(Swing_Setup1).l
		move.w	#$3820,($FFFFEE14).w
		move.w	#$3AE8,($FFFFEE16).w
		moveq	#$60,d0
		jsr	(Load_PLC).l
		lea	(ArtKosM_LBZMinibossBox).l,a1
		move.w	#-$7540,d2
		jsr	(Queue_Kos_Module).l
		lea	(Child1_MakeRoboHead3).l,a2
		jsr	(CreateChild1_Normal).l
		lea	ChildObjDat_8D254(pc),a2
		jmp	(CreateChild3_NormalRepeated).l
; ---------------------------------------------------------------------------

loc_8CBF2:
		lea	($FFFFB000).w,a1
		jsr	(Find_OtherObject).l
		tst.w	d1
		beq.s	loc_8CC20

loc_8CC00:
		cmpi.w	#$70,d2
		bcc.s	loc_8CC14
		cmpi.w	#$60,d3
		bcc.s	loc_8CC14
		btst	#1,$2A(a1)
		beq.s	loc_8CC20

loc_8CC14:

		jsr	(Swing_UpAndDown).l
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_8CC20:

		move.b	#4,5(a0)
		move.w	#-$400,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_8CC2E:
		cmpi.w	#$300,$14(a0)
		bcs.s	loc_8CC3C
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_8CC3C:
		move.b	#6,5(a0)
		bset	#0,4(a0)
		move.w	#$3EC0,$10(a0)
		move.w	#$1A0,$14(a0)
		jmp	(Swing_Setup1).l
; ---------------------------------------------------------------------------

loc_8CC5A:
		lea	($FFFFB000).w,a1
		cmpi.w	#$3B40,($FFFFEE78).w
		bcs.s	locret_8CC76
		cmpi.w	#$1C0,$14(a1)
		bcs.s	locret_8CC76
		btst	#1,$2A(a1)
		beq.s	loc_8CC78

locret_8CC76:

		rts
; ---------------------------------------------------------------------------

loc_8CC78:
		move.b	#8,5(a0)
		st	($FFFFEEC4).w
		rts
; ---------------------------------------------------------------------------

loc_8CC84:
		tst.w	($FFFFEEC4).w
		beq.s	loc_8CC8C
		rts
; ---------------------------------------------------------------------------

loc_8CC8C:
		move.b	#$A,5(a0)
		lea	(ArtKosM_LBZMinibossBox).l,a1
		move.w	#-$7540,d2
		jsr	(Queue_Kos_Module).l
		move.w	#$3EA0,($FFFFFA92).w
		lea	(Child6_IncLevX).l,a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_8CCB4:
		move.w	($FFFFEE78).w,d0
		cmpi.w	#$3E50,d0
		bcc.s	loc_8CCC2
		move.w	d0,($FFFFEE14).w

loc_8CCC2:
		jsr	(Find_SonicTails).l
		cmpi.w	#$60,d2
		bcs.s	loc_8CCDA
		jsr	(Swing_UpAndDown).l
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_8CCDA:
		move.b	#$C,5(a0)
		move.w	#-$400,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_8CCE8:
		cmpi.w	#$12C,$14(a0)
		bls.s	loc_8CCF6
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_8CCF6:
		move.b	#$E,5(a0)
		move.w	#$12C,$14(a0)
		bset	#1,$38(a0)
		move.w	#$200,$18(a0)
		move.w	#$200,$1A(a0)
		lea	(ArtKosM_LBZMiniboss).l,a1
		move.w	#-$6540,d2
		jsr	(Queue_Kos_Module).l
		lea	(Child1_MakeRoboShipFlame).l,a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_8CD30:
		jsr	(MoveSprite2).l
		cmpi.w	#$1B8,$14(a0)
		bcc.s	loc_8CD40
		rts
; ---------------------------------------------------------------------------

loc_8CD40:
		move.l	#loc_8CD4C,(a0)
		clr.w	$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_8CD4C:
		jsr	(MoveSprite2).l
		jsr	(sub_8D1FC).l
		jmp	Sprite_CheckDeleteTouch2(pc)
; ---------------------------------------------------------------------------

loc_8CD5C:
		move.l	#loc_8CD6C,(a0)
		lea	ChildObjDat_8D25C(pc),a2
		jmp	(CreateChild3_NormalRepeated).l
; ---------------------------------------------------------------------------

loc_8CD6C:
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		beq.s	loc_8CD92
		move.l	#Obj_Wait,(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_8CD98,$34(a0)
		move.w	#$160,$14(a0)

loc_8CD92:
		jmp	(Refresh_ChildPosition).l
; ---------------------------------------------------------------------------

loc_8CD98:
		bsr.w	sub_8D116

loc_8CD9C:
		bset	#3,$38(a0)
		moveq	#$50,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_8D264(pc),a2
		jsr	(CreateChild1_Normal).l
		jmp	Go_Delete_Sprite_2(pc)
; ---------------------------------------------------------------------------

Obj_C4_1:
		cmpi.b	#2,($FFFFB038).w
		beq.s	loc_8CDEA
		tst.b	($FFFFFAAB).w
		bne.s	loc_8CDEA
		move.l	#loc_8CDF2,(a0)
		move.w	#$3EA0,($FFFFEE16).w
		move.w	#$3C00,($FFFFEE14).w
		lea	ChildObjDat_8D25C(pc),a2
		jsr	(CreateChild3_NormalRepeated).l
		bsr.w	sub_8D116
		bra.w	sub_8D0EA
; ---------------------------------------------------------------------------

loc_8CDEA:

		move.l	#Delete_Sprite_If_Not_In_Range,(a0)
		rts
; ---------------------------------------------------------------------------

loc_8CDF2:
		lea	($FFFFB000).w,a1
		jsr	(Find_OtherObject).l
		cmpi.w	#$70,d2
		bcc.s	loc_8CE1C
		move.l	#Obj_Wait,(a0)
		move.w	#$3DA0,($FFFFEE14).w
		move.w	#$1F,$2E(a0)
		move.l	#loc_8CD9C,$34(a0)

loc_8CE1C:
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_8CE30
		rts
; ---------------------------------------------------------------------------

loc_8CE30:
		jmp	loc_85088(pc)
; ---------------------------------------------------------------------------

loc_8CE34:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8CE58(pc,d0.w),d1
		jsr	off_8CE58(pc,d1.w)
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_8CE54
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8CE54:
		jmp	Go_Delete_Sprite(pc)
; ---------------------------------------------------------------------------
off_8CE58:	dc.w loc_8CE64-off_8CE58

		dc.w loc_8CE72-off_8CE58
		dc.w loc_8CE9A-off_8CE58
		dc.w loc_8CEA8-off_8CE58
		dc.w loc_8CEF4-off_8CE58
		dc.w loc_8CF0A-off_8CE58
; ---------------------------------------------------------------------------

loc_8CE64:
		lea	ObjDat3_8D23C(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bra.w	loc_8D12C
; ---------------------------------------------------------------------------

loc_8CE72:
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		bne.s	loc_8CE84
		jmp	(Refresh_ChildPosition).l
; ---------------------------------------------------------------------------

loc_8CE84:
		move.b	#4,5(a0)
		cmpi.b	#2,($FFFFB038).w
		beq.s	locret_8CE98
		move.w	#$55,($FFFFEEC4).w

locret_8CE98:
		rts
; ---------------------------------------------------------------------------

loc_8CE9A:
		subq.w	#1,$2E(a0)
		bpl.s	locret_8CEA6
		move.b	#6,5(a0)

locret_8CEA6:
		rts
; ---------------------------------------------------------------------------

loc_8CEA8:
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_8CEAE:
		move.b	#8,5(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		subi.w	#$C,d0
		move.w	word_8CEEC(pc,d0.w),$1A(a0)
		add.w	d0,d0
		move.l	off_8CEDC(pc,d0.w),$30(a0)
		move.l	#loc_8CF10,$34(a0)
		move.w	#$5F,$2E(a0)
		rts
; ---------------------------------------------------------------------------
off_8CEDC:	dc.l byte_8D28A
		dc.l byte_8D28A
		dc.l byte_8D28F
		dc.l byte_8D28F
word_8CEEC:	dc.w  $FFC0,   $40, $FFC0,   $40
; ---------------------------------------------------------------------------

loc_8CEF4:
		jsr	(MoveSprite2).l
		subq.w	#1,$2E(a0)
		bmi.s	loc_8CF02
		rts
; ---------------------------------------------------------------------------

loc_8CF02:
		move.b	#$A,5(a0)

locret_8CF08:
		rts
; ---------------------------------------------------------------------------

loc_8CF0A:
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_8CF10:
		move.l	#loc_8CF1E,(a0)
		move.w	#$380,8(a0)
		rts
; ---------------------------------------------------------------------------

loc_8CF1E:
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_8CF36
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8CF36:
		cmpi.b	#2,($FFFFB038).w
		beq.s	loc_8CF52
		cmpi.b	#$C,$2C(a0)
		bne.s	loc_8CF5C
		lea	(PLC_83D3A).l,a1
		jsr	(Load_PLC_Raw).l

loc_8CF52:
		lea	PLC_8CF62(pc),a1
		jsr	(Load_PLC_Raw).l

loc_8CF5C:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
PLC_8CF62:	dc.w 0
		dc.l ArtNem_Bubbles
		dc.w $8B80
		dc.l ArtNem_LBZMisc
		dc.w $7860
word_8CF70:	dc.w   $7B6,  $9C0, $3BA0, $3CA0
		dc.w   $7B6,  $936, $3BC0, $3C80
; ---------------------------------------------------------------------------

Obj_C5_1:
		lea	word_8CF70(pc),a1
		jsr	(Check_CameraInRange).l
		move.w	(a1)+,($FFFFEE18).w
		move.w	(a1),($FFFFEE1A).w
		move.w	(a1)+,($FFFFEE12).w
		move.w	(a1)+,($FFFFEE14).w
		move.w	(a1)+,($FFFFEE16).w
		bsr.w	sub_8D0EA
		lea	ChildObjDat_8D26C(pc),a2
		jsr	(CreateChild1_Normal).l
		move.l	#loc_8CFB2,(a0)

loc_8CFB2:
		cmpi.w	#$932,($FFFFEE7C).w
		bcs.s	locret_8CFC6
		move.l	#loc_8CFC8,(a0)
		bset	#1,$38(a0)

locret_8CFC6:
		rts
; ---------------------------------------------------------------------------

loc_8CFC8:
		move.b	$38(a0),d0
		andi.b	#5,d0
		cmpi.b	#5,d0
		bne.w	locret_8CF08
		move.l	#loc_8D018,(a0)
		move.w	#$1F,$2E(a0)
		move.w	#$A80,d0
		move.w	d0,($FFFFFA98).w
		move.w	d0,($FFFFEE12).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_8CFFE
		move.l	#Obj_Song_Fade_ToLevelMusic,(a1)

loc_8CFFE:
		clr.b	($FFFFFE1E).w
		lea	(Child6_IncLevY).l,a2
		jsr	(CreateChild6_Simple).l
		lea	ChildObjDat_8D27A(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_8D018:
		subq.w	#1,$2E(a0)
		bmi.s	loc_8D020
		rts
; ---------------------------------------------------------------------------

loc_8D020:
		move.l	#loc_8D02E,(a0)
		move.w	#$55,($FFFFEEC4).w
		rts
; ---------------------------------------------------------------------------

loc_8D02E:
		cmpi.w	#$A7C,($FFFFEE7C).w
		bcs.s	locret_8D044
		move.l	#Wait_FadeToLevelMusic,(a0)
		move.l	#Obj_EndSignControl,$34(a0)

locret_8D044:
		rts
; ---------------------------------------------------------------------------

loc_8D046:

		move.l	#loc_8D056,(a0)
		lea	ChildObjDat_8D25C(pc),a2
		jmp	(CreateChild3_NormalRepeated).l
; ---------------------------------------------------------------------------

loc_8D056:
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		beq.s	locret_8D080
		move.l	#Obj_Wait,(a0)
		move.w	#$77,$2E(a0)
		move.l	#loc_8D082,$34(a0)
		tst.b	$2C(a0)
		bne.s	locret_8D080
		bsr.w	sub_8D116

locret_8D080:

		rts
; ---------------------------------------------------------------------------

loc_8D082:
		bset	#3,$38(a0)
		moveq	#$50,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_8D264(pc),a2
		jsr	(CreateChild1_Normal).l
		bne.s	loc_8D0AA
		movea.w	$46(a0),a2
		move.w	a2,$46(a1)
		move.b	$2C(a0),$2C(a1)

loc_8D0AA:
		jmp	Go_Delete_Sprite_2(pc)
; ---------------------------------------------------------------------------

loc_8D0AE:
		move.l	#Obj_Wait,(a0)
		move.w	#$FF,$2E(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_8D0E0(pc,d0.w),$10(a0)
		move.w	#$A20,$14(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------
word_8D0E0:	dc.w $3C40
		dc.w $3C80
		dc.w $3CC0
		dc.w $3D00
		dc.w $3D40

; =============== S U B R O U T I N E =======================================


sub_8D0EA:

		lea	(ArtKosM_LBZMiniboss).l,a1
		move.w	#-$6540,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_LBZMinibossBox).l,a1
		move.w	#-$7540,d2
		jsr	(Queue_Kos_Module).l
		lea	(PLC_83D64).l,a1
		jmp	(Load_PLC_Raw).l
; End of function sub_8D0EA


; =============== S U B R O U T I N E =======================================


sub_8D116:

		jsr	(Create_New_Sprite).l
		bne.s	locret_8D12A
		move.l	#Obj_Song_Fade_Transition,(a1)
		move.b	#$2E,$2C(a1)

locret_8D12A:
		rts
; End of function sub_8D116

; ---------------------------------------------------------------------------

loc_8D12C:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_8D170(pc,d0.w),$2E(a0)
		add.w	d0,d0
		move.l	off_8D184(pc,d0.w),$30(a0)
		move.l	off_8D1AC(pc,d0.w),$34(a0)
		lea	byte_8D1D4(pc),a1
		adda.w	d0,a1
		move.b	(a1)+,$22(a0)
		move.b	(a1)+,d1
		or.b	d1,4(a0)
		move.b	(a1)+,d1
		move.b	d1,$42(a0)
		ext.w	d1
		add.w	d1,$10(a0)
		move.b	(a1)+,d1
		move.b	d1,$43(a0)
		ext.w	d1
		add.w	d1,$14(a0)
		rts
; ---------------------------------------------------------------------------
word_8D170:	dc.w 0
		dc.w 0
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $10
		dc.w $40
		dc.w $50
		dc.w $70
		dc.w $60
off_8D184:	dc.l byte_8D280
		dc.l byte_8D280
		dc.l byte_8D285
		dc.l byte_8D285
		dc.l byte_8D285
		dc.l byte_8D285
		dc.l byte_8D294
		dc.l byte_8D294
		dc.l byte_8D298
		dc.l byte_8D298
off_8D1AC:	dc.l Go_Delete_Sprite
		dc.l Go_Delete_Sprite
		dc.l Go_Delete_Sprite
		dc.l Go_Delete_Sprite
		dc.l Go_Delete_Sprite
		dc.l Go_Delete_Sprite
		dc.l loc_8CEAE
		dc.l loc_8CEAE
		dc.l loc_8CEAE
		dc.l loc_8CEAE
byte_8D1D4:	dc.b	6,   0,	$F0,   0
		dc.b	6,   2,	$10,   0
		dc.b	9,   0,	  0, $14
		dc.b	9,   1,	  0,  $C
		dc.b	9,   0,	  0, $F4
		dc.b	9,   1,	  0, $EC
		dc.b	0,   0,	$F4, $F0
		dc.b	0,   3,	 $C, $10
		dc.b	3,   0,	$14, $F4
		dc.b	3,   3,	$EC,  $C

; =============== S U B R O U T I N E =======================================


sub_8D1FC:

		tst.b	$28(a0)
		bne.s	locret_8D22E
		tst.b	$20(a0)
		bne.s	loc_8D21C
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		bset	#6,$2A(a0)

loc_8D21C:
		subq.b	#1,$20(a0)
		bne.s	locret_8D22E
		bclr	#6,$2A(a0)
		move.b	$25(a0),$28(a0)

locret_8D22E:

		rts
; End of function sub_8D1FC

; ---------------------------------------------------------------------------
ObjDat3_8D230:	dc.l Map_RobotnikShip
		dc.w $52E
		dc.w $100
		dc.b $20
		dc.b $20
		dc.b $A
		dc.b $F
ObjDat3_8D23C:	dc.l Map_LBZMinibossBox
		dc.w $4456
		dc.w $100
		dc.b $14
		dc.b $14
		dc.b 0
		dc.b 0
		dc.l Map_Ring
		dc.w $A6BC
		dc.w 0
		dc.b 8
		dc.b 8
		dc.b 0
		dc.b 0
ChildObjDat_8D254:dc.w 0
		dc.l loc_8CD5C
		dc.w $34
ChildObjDat_8D25C:dc.w 9

		dc.l loc_8CE34
		dc.w 0
ChildObjDat_8D264:dc.w 0

		dc.l Obj_LBZMiniboss
		dc.w 0
ChildObjDat_8D26C:dc.w 1
		dc.l loc_8D046
		dc.w $E000
		dc.l loc_8D046
		dc.w $2000
ChildObjDat_8D27A:dc.w 4
		dc.l loc_8D0AE
byte_8D280:	dc.b 0
		dc.b 6
		dc.b 7
		dc.b 8
		dc.b $F4
byte_8D285:	dc.b 0
		dc.b 9
		dc.b $A
		dc.b $B
		dc.b $F4
byte_8D28A:	dc.b 5
		dc.b 0
		dc.b 1
		dc.b 2
		dc.b $F4
byte_8D28F:	dc.b 5
		dc.b 3
		dc.b 4
		dc.b 5
		dc.b $F4
byte_8D294:	dc.b 0
		dc.b 0
		dc.b 0
		dc.b $F4
byte_8D298:	dc.b 0
		dc.b 3
		dc.b 3
		dc.b $F4
; ---------------------------------------------------------------------------

Obj_C6_1:

		move.w	a0,($FFFFEED2).w
		lea	ObjDat3_8D562(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_8D2B6,(a0)
		bset	#0,4(a0)

loc_8D2B6:
		moveq	#0,d0
		move.b	$29(a0),d0
		beq.w	loc_8D33E
		clr.b	$29(a0)
		cmpi.b	#2,d0
		beq.w	loc_8D33E
		lea	($FFFFB000).w,a1
		tst.b	$2E(a1)
		bne.w	loc_8D33E
		move.l	#loc_8D370,(a0)
		move.b	#-$7D,$2E(a1)
		bclr	#0,4(a1)
		bclr	#0,$2A(a1)
		move.b	#5,$20(a1)
		bset	#7,$A(a1)
		move.w	#-$100,$1A(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_8D344,$34(a0)
		moveq	#-$30,d0
		jsr	(Play_Sound_2).l
		st	($FFFFF7FF).w
		move.w	#$6000,($FFFFFA92).w
		lea	(Child6_IncLevX).l,a2
		jsr	(CreateChild6_Simple).l
		lea	(Child1_MakeRoboShipFlame).l,a2
		jsr	(CreateChild1_Normal).l
		jsr	sub_8D53E(pc)

loc_8D33E:

		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------

loc_8D344:
		move.l	#loc_8D36A,(a0)
		move.w	$14(a0),$3A(a0)
		move.w	#$100,$18(a0)
		move.w	#$1DF,$2E(a0)
		move.l	#loc_8D38A,$34(a0)
		jmp	(Swing_Setup1).l
; ---------------------------------------------------------------------------

loc_8D36A:

		jsr	(Swing_UpAndDown).l

loc_8D370:
		jsr	(MoveSprite2).l
		bsr.w	sub_8D506
		jsr	(Obj_Wait).l
		jsr	sub_8D53E(pc)
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------

loc_8D38A:
		move.w	#$3F,$2E(a0)
		clr.w	$18(a0)
		move.l	#loc_8D39E,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8D39E:
		move.l	#loc_8D3AC,(a0)
		move.w	#$100,$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_8D3AC:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		bsr.w	sub_8D506
		movea.w	($FFFFFAA4).w,a1
		move.w	$10(a1),d0
		sub.w	$10(a0),d0
		cmpi.w	#$50,d0
		bcc.s	loc_8D3E8
		bset	#1,$38(a1)
		move.l	#loc_8D36A,(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_8D3F2,$34(a0)

loc_8D3E8:
		jsr	sub_8D53E(pc)
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------

loc_8D3F2:
		move.l	#loc_8D40E,(a0)
		move.w	#-$200,$18(a0)
		move.w	#-$200,$1A(a0)
		moveq	#$49,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_8D40E:
		jsr	(MoveSprite_LightGravity).l
		bsr.w	sub_8D506
		tst.w	$1A(a0)
		bmi.s	loc_8D446
		move.w	$14(a0),d0
		cmp.w	$3A(a0),d0
		bcs.s	loc_8D446
		move.l	#loc_8D36A,(a0)
		clr.w	$18(a0)
		move.w	#$5F,$2E(a0)
		move.l	#loc_8D450,$34(a0)
		jsr	(Swing_Setup1).l

loc_8D446:

		jsr	sub_8D53E(pc)
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------

loc_8D450:
		move.l	#loc_8D36A,(a0)
		st	($FFFFEECC).w
		st	($FFFFEEC6).w
		move.w	#$FF,$2E(a0)
		move.l	#loc_8D46E,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8D46E:
		move.l	#loc_8D47C,(a0)
		move.w	#$100,$18(a0)

locret_8D47A:
		rts
; ---------------------------------------------------------------------------

loc_8D47C:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		bsr.w	sub_8D506
		cmpi.w	#$4440,$10(a0)
		bcs.s	loc_8D4C2
		move.l	#loc_8D4CC,(a0)
		clr.w	($FFFFEECC).w
		lea	($FFFFB000).w,a1
		clr.b	$2E(a1)
		bset	#1,$2A(a1)
		move.w	#-$100,$18(a1)
		move.w	#-$600,$1A(a1)
		move.b	#2,$20(a1)
		clr.b	$40(a1)

loc_8D4C2:
		jsr	sub_8D53E(pc)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8D4CC:
		tst.b	4(a0)
		bpl.s	loc_8D4E4
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jmp	(Sprite_CheckDeleteTouch2).l
; ---------------------------------------------------------------------------

loc_8D4E4:
		jsr	(Create_New_Sprite).l
		bne.w	locret_8D47A
		move.l	#Obj_LBZ_FinalBoss1,(a1)
		move.w	#$44A0,$10(a1)
		move.w	#$780,$14(a1)
		jmp	(Go_Delete_Sprite_2).l

; =============== S U B R O U T I N E =======================================


sub_8D506:

		lea	($FFFFB000).w,a1
		move.w	$10(a0),d0
		subq.w	#4,d0
		move.w	d0,$10(a1)
		move.w	$14(a0),d0
		subi.w	#$12,d0
		move.w	d0,$14(a1)
		rts
; End of function sub_8D506

; ---------------------------------------------------------------------------
		lea	($FFFFB04A).w,a1
		tst.l	(a1)
		beq.s	loc_8D538
		tst.b	4(a1)
		bpl.s	loc_8D532
		rts
; ---------------------------------------------------------------------------

loc_8D532:
		clr.l	(a1)
		clr.l	($FFFFCC0A).w

loc_8D538:
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_8D53E:

		lea	($FFFFB000).w,a1
		moveq	#0,d0
		move.b	$38(a1),d0
		move.b	RawAni_8D55C(pc,d0.w),$22(a1)
		add.w	d0,d0
		movea.w	word_8D55E(pc,d0.w),a2
		clr.b	(a2)
		jmp	(Player_Load_PLC).l
; End of function sub_8D53E

; ---------------------------------------------------------------------------
RawAni_8D55C:	dc.b  $BA, $AD
word_8D55E:	dc.w $F766
		dc.w $F7DE
ObjDat3_8D562:	dc.l Map_RobotnikShip
		dc.w $852E
		dc.w $80
		dc.b $20
		dc.b $20
		dc.b $A
		dc.b $CA
		dc.w 0
		dc.l Obj_C6_1
		dc.w 0
		dc.b 0
		dc.b 5
		dc.b 1
		dc.b 5
		dc.b 2
		dc.b 5
		dc.b 3
		dc.b 5
		dc.b $FC
		dc.b 0
; ---------------------------------------------------------------------------

Obj_Madmole:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8D59E(pc,d0.w),d1
		jsr	off_8D59E(pc,d1.w)
		bsr.w	sub_8D876
		jmp	(Sprite_CheckDelete).l
; ---------------------------------------------------------------------------
off_8D59E:	dc.w loc_8D5A6-off_8D59E

		dc.w loc_8D5B0-off_8D59E
		dc.w loc_8D5D4-off_8D59E
		dc.w loc_8D5F4-off_8D59E
; ---------------------------------------------------------------------------

loc_8D5A6:
		lea	ObjDat3_8D9A8(pc),a1
		jmp	(SetUp_ObjAttributes).l
; ---------------------------------------------------------------------------

loc_8D5B0:
		jsr	(Find_SonicTails).l
		cmpi.w	#$A0,d2
		bcs.s	loc_8D5BE
		rts
; ---------------------------------------------------------------------------

loc_8D5BE:
		move.b	#4,5(a0)
		bset	#1,$38(a0)
		lea	ChildObjDat_8D9C0(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_8D5D4:
		btst	#1,$38(a0)
		beq.s	loc_8D5DE
		rts
; ---------------------------------------------------------------------------

loc_8D5DE:
		move.b	#6,5(a0)
		move.w	#$3C,$2E(a0)
		move.l	#loc_8D5FA,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8D5F4:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_8D5FA:
		move.b	#2,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_8D602:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8D616(pc,d0.w),d1
		jsr	off_8D616(pc,d1.w)
		jmp	(Child_DrawTouch_Sprite).l
; ---------------------------------------------------------------------------
off_8D616:	dc.w loc_8D620-off_8D616

		dc.w loc_8D636-off_8D616
		dc.w loc_8D656-off_8D616
		dc.w loc_8D67A-off_8D616
		dc.w loc_8D6CA-off_8D616
; ---------------------------------------------------------------------------

loc_8D620:
		lea	word_8D9B4(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.w	#-$100,$1A(a0)
		move.w	#$1F,$2E(a0)

loc_8D636:
		bsr.w	sub_8D886
		jsr	(MoveSprite2).l
		subq.w	#1,$2E(a0)
		bmi.s	loc_8D648
		rts
; ---------------------------------------------------------------------------

loc_8D648:
		move.b	#4,5(a0)
		move.w	#$1F,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_8D656:
		bsr.w	sub_8D886
		subq.w	#1,$2E(a0)
		bmi.s	loc_8D662
		rts
; ---------------------------------------------------------------------------

loc_8D662:
		move.b	#6,5(a0)
		move.l	#byte_8D9D8,$30(a0)
		move.l	#loc_8D680,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8D67A:
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_8D680:
		move.l	#byte_8D9DD,$30(a0)
		move.l	#loc_8D6AE,$34(a0)
		moveq	#$52,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_8D9C8(pc),a2
		btst	#0,4(a0)
		beq.s	loc_8D6A8
		lea	ChildObjDat_8D9D0(pc),a2

loc_8D6A8:
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_8D6AE:
		move.b	#8,5(a0)
		move.w	#$100,$1A(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_8D6D6,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8D6CA:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_8D6D6:
		movea.w	$46(a0),a1
		bclr	#1,$38(a1)
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_8D6E6:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8D73C(pc,d0.w),d1
		jsr	off_8D73C(pc,d1.w)
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_8D724
		move.w	$14(a0),d0
		sub.w	($FFFFEE7C).w,d0
		addi.w	#$80,d0
		cmpi.w	#$200,d0
		bhi.s	loc_8D724
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8D724:

		move.w	$44(a0),d0
		beq.s	loc_8D736
		movea.w	d0,a1
		bset	#1,$2A(a1)
		clr.b	$2E(a1)

loc_8D736:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------
off_8D73C:	dc.w loc_8D746-off_8D73C

		dc.w loc_8D768-off_8D73C
		dc.w loc_8D778-off_8D73C
		dc.w loc_8D79C-off_8D73C
		dc.w loc_8D7A8-off_8D73C
; ---------------------------------------------------------------------------

loc_8D746:
		lea	word_8D9BA(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.b	#$18,$1F(a0)
		move.b	#8,$1E(a0)
		move.l	#byte_8D9E7,$30(a0)
		bra.w	loc_8D89E
; ---------------------------------------------------------------------------

loc_8D768:
		bsr.w	sub_8D8E6
		jsr	(MoveSprite2).l
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_8D778:
		bsr.w	sub_8D94A
		jsr	(MoveSprite_LightGravity).l
		tst.w	$1A(a0)
		bmi.s	loc_8D78E
		jsr	(ObjHitFloor_DoRoutine).l

loc_8D78E:
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_8D794:
		move.w	#-$500,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_8D79C:
		jsr	(MoveSprite2).l
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_8D7A8:
		movea.w	$44(a0),a1
		bclr	#0,4(a1)
		tst.w	$18(a0)
		bmi.s	loc_8D7BE
		bset	#0,4(a1)

loc_8D7BE:
		tst.b	$2E(a1)
		beq.s	loc_8D83E
		moveq	#8,d1
		move.w	$10(a0),d0
		btst	#0,4(a1)
		bne.s	loc_8D7D4
		neg.w	d1

loc_8D7D4:
		add.w	d1,d0
		move.w	d0,$10(a1)
		move.w	$14(a0),d0
		addi.w	#8,d0
		move.w	d0,$14(a1)
		jsr	(MoveSprite_LightGravity).l
		tst.w	$18(a0)
		bmi.s	loc_8D800
		move.w	#$18,d3
		jsr	(ObjHitWall).l
		bra.w	loc_8D80A
; ---------------------------------------------------------------------------

loc_8D800:
		move.w	#-$18,d3
		jsr	(ObjHitWall2).l

loc_8D80A:
		tst.w	d1
		bmi.s	loc_8D820
		tst.w	$1A(a0)
		bmi.s	loc_8D81A
		jsr	(ObjHitFloor_DoRoutine).l

loc_8D81A:
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_8D820:
		movea.w	$44(a0),a1
		move.w	$18(a0),d0
		neg.w	d0
		move.w	d0,$18(a1)
		asr.w	#1,d0
		move.w	d0,$18(a0)

loc_8D834:
		bset	#1,$2A(a1)
		clr.b	$2E(a1)

loc_8D83E:
		move.b	#6,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_8D846:
		cmpi.w	#$A00,$1A(a0)
		bge.s	loc_8D85E
		move.w	#-$500,$1A(a0)
		moveq	#-$52,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_8D85E:
		movea.w	$44(a0),a1
		move.w	#-$200,$1A(a0)
		move.w	#-$300,$1A(a1)
		move.w	$18(a0),$18(a1)
		bra.s	loc_8D834

; =============== S U B R O U T I N E =======================================


sub_8D876:
		moveq	#$1F,d1
		moveq	#4,d2
		moveq	#5,d3
		move.w	$10(a0),d4
		jmp	(SolidObjectFull).l
; End of function sub_8D876


; =============== S U B R O U T I N E =======================================


sub_8D886:

		jsr	(Find_SonicTails).l
		bclr	#0,4(a0)
		tst.w	d0
		beq.s	locret_8D89C
		bset	#0,4(a0)

locret_8D89C:
		rts
; End of function sub_8D886

; ---------------------------------------------------------------------------

loc_8D89E:
		jsr	(Random_Number).l
		moveq	#0,d2
		tst.b	d0
		bpl.s	loc_8D8BA
		addq.w	#4,d2
		move.b	#4,5(a0)
		move.l	#loc_8D794,$34(a0)

loc_8D8BA:
		lea	word_8D8DE(pc,d2.w),a1
		move.w	(a1)+,d0
		movea.w	$46(a0),a2
		btst	#0,4(a2)
		beq.s	loc_8D8D4
		neg.w	d0
		bset	#0,4(a0)

loc_8D8D4:
		move.w	d0,$18(a0)
		move.w	(a1)+,$1A(a0)
		rts
; ---------------------------------------------------------------------------
word_8D8DE:	dc.w  $FA00,	 0
		dc.w  $FC80,  $200

; =============== S U B R O U T I N E =======================================


sub_8D8E6:
		move.b	$29(a0),d0
		beq.w	locret_8D942
		clr.b	$29(a0)
		andi.w	#3,d0
		add.w	d0,d0
		lea	locret_8D942(pc,d0.w),a1
		movea.w	(a1)+,a2
		btst	#1,$2B(a2)
		bne.s	locret_8D942
		tst.b	$2E(a2)
		bne.s	locret_8D942
		move.w	a2,$44(a0)
		move.b	#6,5(a0)
		moveq	#-$52,d0
		jsr	(Play_Sound_2).l
		move.w	$18(a0),d0
		lsl.w	#1,d0
		move.w	d0,$18(a2)
		move.w	d0,$1C(a2)
		move.w	#-$200,$1A(a2)
		bset	#1,$2A(a2)
		move.b	#$1A,$20(a2)
		clr.b	$3D(a2)

locret_8D942:

		rts
; End of function sub_8D8E6

; ---------------------------------------------------------------------------
		dc.w $B000
		dc.w $B04A
		dc.w $B04A

; =============== S U B R O U T I N E =======================================


sub_8D94A:
		move.b	$29(a0),d0
		beq.w	locret_8D9A6
		clr.b	$29(a0)
		andi.w	#3,d0
		add.w	d0,d0
		lea	locret_8D942(pc,d0.w),a1
		movea.w	(a1)+,a2
		btst	#1,$2B(a2)
		bne.s	locret_8D9A6
		tst.b	$2E(a2)
		bne.s	locret_8D9A6
		move.w	a2,$44(a0)
		move.b	#8,5(a0)
		move.w	#0,8(a0)
		move.l	#loc_8D846,$34(a0)
		moveq	#-$52,d0
		jsr	(Play_Sound_2).l
		bset	#1,$2A(a2)
		move.b	#1,$2E(a2)
		move.b	#$1A,$20(a2)
		clr.b	$3D(a2)

locret_8D9A6:

		rts
; End of function sub_8D94A

; ---------------------------------------------------------------------------
ObjDat3_8D9A8:	dc.l Map_Madmole
		dc.w $545
		dc.w $280
		dc.b $18
		dc.b 4
		dc.b $D
		dc.b 0
word_8D9B4:	dc.w $280
		dc.b $C
		dc.b $C
		dc.b 0
		dc.b $B
word_8D9BA:	dc.w $280
		dc.b 8
		dc.b 8
		dc.b 5
		dc.b $D8
ChildObjDat_8D9C0:dc.w 0
		dc.l loc_8D602
		dc.w $10
ChildObjDat_8D9C8:dc.w 0
		dc.l loc_8D6E6
		dc.w $F2F4
ChildObjDat_8D9D0:dc.w 0
		dc.l loc_8D6E6
		dc.w $EF4
byte_8D9D8:	dc.b 2
		dc.b 0
		dc.b 1
		dc.b 2
		dc.b $F4
byte_8D9DD:	dc.b 2
		dc.b 3
		dc.b 3
		dc.b 4
		dc.b 4
		dc.b 4
		dc.b 4
		dc.b 4
		dc.b 4
		dc.b $F4
byte_8D9E7:	dc.b 2
		dc.b 5
		dc.b 6
		dc.b 7
		dc.b 8
		dc.b 9
		dc.b $A
		dc.b $B
		dc.b $C
		dc.b $FC
		dc.b 0
Map_Madmole:	include "General\Sprites\Madmole\Map - Madmole.asm"

; ---------------------------------------------------------------------------

Obj_Mushmeanie:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8DB14(pc,d0.w),d1
		jsr	off_8DB14(pc,d1.w)
		bsr.w	sub_8DC6E
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------
off_8DB14:	dc.w loc_8DB1E-off_8DB14

		dc.w loc_8DB3E-off_8DB14
		dc.w loc_8DB64-off_8DB14
		dc.w loc_8DB94-off_8DB14
		dc.w loc_8DBEC-off_8DB14
; ---------------------------------------------------------------------------

loc_8DB1E:
		lea	ObjDat3_8DCCA(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#2,$39(a0)
		move.b	#$12,$1E(a0)
		lea	ChildObjDat_8DCDE(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_8DB3E:
		jsr	(Find_SonicTails).l
		cmpi.w	#$80,d2
		bcs.s	loc_8DB4C
		rts
; ---------------------------------------------------------------------------

loc_8DB4C:
		move.b	#4,5(a0)
		move.l	#byte_8DCE6,$30(a0)
		move.l	#loc_8DB76,$34(a0)

locret_8DB62:
		rts
; ---------------------------------------------------------------------------

loc_8DB64:
		jsr	(Animate_RawMultiDelay).l
		tst.w	d2
		bne.s	loc_8DB70
		rts
; ---------------------------------------------------------------------------

loc_8DB70:
		subq.w	#3,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_8DB76:

		move.b	#6,5(a0)
		move.w	#-$300,$1A(a0)
		move.l	#loc_8DBD4,$34(a0)
		move.w	#-$100,d4
		jmp	(Set_VelocityXTrackSonic).l
; ---------------------------------------------------------------------------

loc_8DB94:
		jsr	(MoveSprite_LightGravity).l
		tst.w	$18(a0)
		bmi.s	loc_8DBAC
		moveq	#8,d3
		jsr	(ObjHitWall).l
		bra.w	loc_8DBB4
; ---------------------------------------------------------------------------

loc_8DBAC:
		moveq	#-8,d3
		jsr	(ObjHitWall2).l

loc_8DBB4:
		tst.w	d1
		bpl.s	loc_8DBC6
		add.w	d1,$10(a0)
		neg.w	$18(a0)
		bchg	#0,4(a0)

loc_8DBC6:
		tst.w	$1A(a0)
		bmi.w	locret_8DB62
		jmp	(ObjHitFloor_DoRoutine).l
; ---------------------------------------------------------------------------

loc_8DBD4:
		move.b	#8,5(a0)
		move.l	#byte_8DCED,$30(a0)
		move.l	#loc_8DB76,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8DBEC:
		jsr	(Animate_RawMultiDelay).l
		tst.w	d2
		bne.s	loc_8DBF8
		rts
; ---------------------------------------------------------------------------

loc_8DBF8:
		moveq	#0,d0
		move.b	$23(a0),d0
		move.w	word_8DC08(pc,d0.w),d0
		add.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------
word_8DC08:	dc.w $FFFD
		dc.w 3
		dc.w 3
		dc.w $FFFD
		dc.w $FFFD
		dc.w $FFFD
; ---------------------------------------------------------------------------

loc_8DC14:
		lea	word_8DCD6(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#loc_8DC24,(a0)

loc_8DC24:
		movea.w	$46(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		btst	#6,$2A(a1)
		bne.s	loc_8DC42
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8DC42:
		move.l	#loc_8DC62,(a0)
		movea.w	$44(a1),a2
		move.w	#$200,d0
		tst.w	$18(a2)
		bmi.s	loc_8DC58
		neg.w	d0

loc_8DC58:
		move.w	d0,$18(a0)
		move.w	#-$200,$1A(a0)

loc_8DC62:
		jsr	(MoveSprite_LightGravity).l
		jmp	(Sprite_CheckDeleteXY).l

; =============== S U B R O U T I N E =======================================


sub_8DC6E:
		tst.b	$20(a0)
		beq.s	loc_8DC80
		subq.b	#1,$20(a0)
		bne.s	locret_8DCC2
		move.b	#-$29,$28(a0)

loc_8DC80:
		jsr	(Check_PlayerCollision).l
		beq.s	locret_8DCC2
		jsr	(Check_PlayerAttack).l
		bne.s	loc_8DC9C
		tst.b	$34(a1)
		bne.s	locret_8DCC2
		jmp	(HurtSonic_Directly).l
; ---------------------------------------------------------------------------

loc_8DC9C:
		subq.b	#1,$39(a0)
		beq.s	loc_8DCC4
		clr.b	$28(a0)
		clr.b	$29(a0)
		move.b	#$20,$20(a0)
		bset	#6,$2A(a0)
		neg.w	$18(a1)
		neg.w	$1A(a1)
		neg.w	$1C(a1)

locret_8DCC2:

		rts
; ---------------------------------------------------------------------------

loc_8DCC4:
		jmp	(EnemyDefeated).l
; End of function sub_8DC6E

; ---------------------------------------------------------------------------
ObjDat3_8DCCA:	dc.l Map_Mushmeanie
		dc.w $256D
		dc.w $280
		dc.b 8
		dc.b 8
		dc.b 1
		dc.b $D7
word_8DCD6:	dc.w $456D
		dc.w $200
		dc.b $C
		dc.b 8
		dc.b 0
		dc.b 0
ChildObjDat_8DCDE:dc.w 0
		dc.l loc_8DC14
		dc.w 0
byte_8DCE6:	dc.b 1
		dc.b 2
		dc.b 2
		dc.b 2
		dc.b 3
		dc.b 0
		dc.b $F4
byte_8DCED:	dc.b 3
		dc.b 2
		dc.b 2
		dc.b 2
		dc.b 1
		dc.b 2
		dc.b 2
		dc.b 2
		dc.b 3
		dc.b 0
		dc.b $F4
Map_Mushmeanie:	include "General\Sprites\Mushmeanie\Map - Mushmeanie.asm"

; ---------------------------------------------------------------------------

Obj_Dragonfly:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8DD4C(pc,d0.w),d1
		jsr	off_8DD4C(pc,d1.w)
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------
off_8DD4C:	dc.w loc_8DD52-off_8DD4C

		dc.w loc_8DDAA-off_8DD4C
		dc.w loc_8DDE6-off_8DD4C
; ---------------------------------------------------------------------------

loc_8DD52:
		lea	ObjDat3_8DF96(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#byte_8DFCE,$30(a0)
		lea	ChildObjDat_8DFAE(pc),a2
		jsr	(CreateChild1_Normal).l
		lea	ChildObjDat_8DFB6(pc),a2
		jsr	(CreateChild4_LinkListRepeated).l
		move.w	#$200,d0
		move.w	d0,$3E(a0)
		move.w	d0,$1A(a0)
		move.w	#8,$40(a0)
		bclr	#0,$38(a0)

loc_8DD90:
		move.w	#$200,d0
		move.w	d0,$3A(a0)
		move.w	d0,$18(a0)
		move.w	#$20,$3C(a0)
		bclr	#3,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_8DDAA:
		jsr	(Animate_Raw).l
		jsr	(Swing_LeftAndRight).l
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		tst.w	$1A(a0)
		beq.s	loc_8DDCA
		rts
; ---------------------------------------------------------------------------

loc_8DDCA:
		move.b	#4,5(a0)
		move.w	#$F,$2E(a0)
		move.l	#loc_8DDF8,$34(a0)
		bset	#2,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_8DDE6:
		jsr	(Swing_LeftAndRight).l
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_8DDF8:
		move.b	#2,5(a0)
		bclr	#2,$38(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		move.l	#byte_8DFC2,$30(a0)
		bchg	#1,$38(a0)
		bne.s	locret_8DE24
		move.l	#byte_8DFCE,$30(a0)

locret_8DE24:
		rts
; ---------------------------------------------------------------------------

loc_8DE26:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8DE3A(pc,d0.w),d1
		jsr	off_8DE3A(pc,d1.w)
		jmp	(Child_DrawTouch_Sprite).l
; ---------------------------------------------------------------------------
off_8DE3A:	dc.w loc_8DE44-off_8DE3A

		dc.w loc_8DE74-off_8DE3A
		dc.w loc_8DE8A-off_8DE3A
		dc.w loc_8DEB6-off_8DE3A
		dc.w loc_8DEF4-off_8DE3A
; ---------------------------------------------------------------------------

loc_8DE44:
		lea	word_8DFA8(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		bset	#1,4(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		cmpi.b	#$C,d0
		bne.s	loc_8DE66
		move.b	#6,$22(a0)

loc_8DE66:
		move.w	d0,$2E(a0)
		move.b	#1,$42(a0)
		bra.w	loc_8DF68
; ---------------------------------------------------------------------------

loc_8DE74:
		bsr.w	sub_8DF80
		subq.w	#1,$2E(a0)
		bmi.s	loc_8DE80
		rts
; ---------------------------------------------------------------------------

loc_8DE80:
		move.b	#4,5(a0)
		bra.w	loc_8DD90
; ---------------------------------------------------------------------------

loc_8DE8A:
		bsr.w	sub_8DF80
		jsr	(Swing_LeftAndRight).l
		jsr	(MoveSprite2).l
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		bne.s	loc_8DEA8
		rts
; ---------------------------------------------------------------------------

loc_8DEA8:
		move.b	#6,5(a0)
		bset	#2,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_8DEB6:
		jsr	(Swing_LeftAndRight).l
		jsr	(MoveSprite2).l
		movea.w	$46(a0),a1
		move.w	$14(a0),d0
		move.b	$42(a0),d1
		ext.w	d1
		add.w	d1,d0
		cmp.w	$14(a1),d0
		beq.s	loc_8DEDE
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_8DEDE:
		move.w	$14(a1),$14(a0)
		move.b	#8,5(a0)
		neg.b	$42(a0)
		neg.b	$43(a0)
		rts
; ---------------------------------------------------------------------------

loc_8DEF4:
		jsr	(Swing_LeftAndRight).l
		jsr	(MoveSprite2).l
		movea.w	$46(a0),a1
		move.w	$14(a1),d0
		move.b	$43(a0),d1
		ext.w	d1
		bmi.s	loc_8DF1A
		add.w	d1,d0
		cmp.w	$14(a0),d0
		bls.s	loc_8DF24
		rts
; ---------------------------------------------------------------------------

loc_8DF1A:
		add.w	d1,d0
		cmp.w	$14(a0),d0
		bcc.s	loc_8DF24
		rts
; ---------------------------------------------------------------------------

loc_8DF24:

		move.b	#4,5(a0)
		move.w	d0,$14(a0)
		bchg	#1,4(a0)
		bclr	#2,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_8DF3C:
		lea	word_8DFA2(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_8DF52,(a0)
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8DF52:
		jsr	(Refresh_ChildPosition).l
		lea	byte_8DFBC(pc),a1
		jsr	(Animate_RawNoSST).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8DF68:
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		move.b	byte_8DF78(pc,d0.w),$43(a0)
		rts
; ---------------------------------------------------------------------------
byte_8DF78:	dc.b $F4
		dc.b $FB
		dc.b $FB
		dc.b $FB
		dc.b $FB
		dc.b $FB
		dc.b $FB
		dc.b 0

; =============== S U B R O U T I N E =======================================


sub_8DF80:

		movea.w	$46(a0),a1
		move.w	$14(a1),d0
		move.b	$43(a0),d1
		ext.w	d1
		add.w	d1,d0
		move.w	d0,$14(a0)
		rts
; End of function sub_8DF80

; ---------------------------------------------------------------------------
ObjDat3_8DF96:	dc.l Map_Dragonfly
		dc.w $A538
		dc.w $280
		dc.b 8
		dc.b 8
		dc.b 4
		dc.b $17
word_8DFA2:	dc.w $280
		dc.b $20
		dc.b 8
		dc.b 7
		dc.b 0
word_8DFA8:	dc.w $280
		dc.b 4
		dc.b 4
		dc.b 5
		dc.b $98
ChildObjDat_8DFAE:dc.w 0
		dc.l loc_8DF3C
		dc.w 0
ChildObjDat_8DFB6:dc.w 6
		dc.l loc_8DE26
byte_8DFBC:	dc.b	0,   7,	  9,   8,   9, $FC
byte_8DFC2:	dc.b 3
		dc.b 0
		dc.b 1
		dc.b 2
		dc.b 3
		dc.b 4
		dc.b $F8
		dc.b 8
		dc.b $7F
		dc.b 4
		dc.b 4
		dc.b $FC
byte_8DFCE:	dc.b 3

		dc.b 4
		dc.b 3
		dc.b 2
		dc.b 1
		dc.b 0
		dc.b $F8
		dc.b 8
		dc.b $7F
		dc.b 0
		dc.b 0
		dc.b $FC
Map_Dragonfly:	include "General\Sprites\Robotnik\Map - Dragonfly.asm"

; ---------------------------------------------------------------------------

Obj_Butterdroid:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8E0C2(pc,d0.w),d1
		jsr	off_8E0C2(pc,d1.w)
		lea	DPLCPtr_8E11C(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Sprite_CheckDeleteTouchSlotted).l
; ---------------------------------------------------------------------------
off_8E0C2:	dc.w loc_8E0C6-off_8E0C2

		dc.w loc_8E0DA-off_8E0C2
; ---------------------------------------------------------------------------

loc_8E0C6:
		lea	ObjDat4_8E10A(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l
		move.l	#byte_8E124,$30(a0)
		rts
; ---------------------------------------------------------------------------

loc_8E0DA:
		jsr	(Find_SonicTails).l
		bclr	#0,4(a0)
		tst.w	d0
		beq.s	loc_8E0F0
		bset	#0,4(a0)

loc_8E0F0:
		move.w	#$100,d0
		move.w	#4,d1
		jsr	(Chase_Object).l
		jsr	(MoveSprite2).l
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------
ObjDat4_8E10A:	dc.w 3
		dc.w $A514
		dc.w 9
		dc.w 0
		dc.l Map_Butterdroid
		dc.w $280
		dc.b $C
		dc.b $C
		dc.b 0
		dc.b $17
DPLCPtr_8E11C:	dc.l ArtUnc_Butterdroid
		dc.l DPLC_Butterdroid
byte_8E124:	dc.b 7
		dc.b 0
		dc.b 1
		dc.b 2
		dc.b 3
		dc.b 4
		dc.b 3
		dc.b 2
		dc.b 1
		dc.b $FC
Map_Butterdroid:include "General\Sprites\Butterdroid\Map - Butterdroid.asm"

DPLC_Butterdroid:	include "General\Sprites\Butterdroid\DPLC - Butterdroid.asm"

; ---------------------------------------------------------------------------

Obj_Cluckoid:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8E1A2(pc,d0.w),d1
		jsr	off_8E1A2(pc,d1.w)
		lea	DPLCPtr_8E410(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Sprite_CheckDeleteTouchSlotted).l
; ---------------------------------------------------------------------------
off_8E1A2:	dc.w loc_8E1AA-off_8E1A2

		dc.w loc_8E1BE-off_8E1A2
		dc.w loc_8E1E2-off_8E1A2
		dc.w loc_8E21A-off_8E1A2
; ---------------------------------------------------------------------------

loc_8E1AA:
		lea	ObjDat4_8E3D8(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l
		lea	ChildObjDat_8E402(pc),a2
		jmp	(CreateChild10_NormalAdjusted).l
; ---------------------------------------------------------------------------

loc_8E1BE:
		jsr	(Find_SonicTails).l
		cmpi.w	#$80,d2
		bcc.s	locret_8E1D0
		cmpi.w	#$40,d3
		bcs.s	loc_8E1D2

locret_8E1D0:
		rts
; ---------------------------------------------------------------------------

loc_8E1D2:
		move.b	#4,5(a0)
		move.l	#loc_8E20C,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8E1E2:
		cmpi.b	#7,$22(a0)
		bcs.s	loc_8E202
		bset	#7,$38(a0)
		bne.s	loc_8E1FA
		moveq	#-$69,d0
		jsr	(Play_Sound_2).l

loc_8E1FA:
		bsr.w	sub_8E37C
		bsr.w	sub_8E2D4

loc_8E202:
		lea	byte_8E418(pc),a1
		jmp	(Animate_RawNoSSTMultiDelay).l
; ---------------------------------------------------------------------------

loc_8E20C:
		move.b	#6,5(a0)
		move.w	#$60,$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_8E21A:
		subq.w	#1,$2E(a0)
		bmi.s	loc_8E222
		rts
; ---------------------------------------------------------------------------

loc_8E222:
		move.b	#2,5(a0)
		move.b	#0,$22(a0)
		bclr	#7,$38(a0)

locret_8E234:
		rts
; ---------------------------------------------------------------------------

loc_8E236:
		lea	ObjDat3_8E3F6(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_8E250,(a0)
		bsr.w	sub_8E2EA
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8E250:
		tst.b	4(a0)
		bpl.s	loc_8E2B8
		moveq	#0,d1
		move.w	$18(a0),d0
		add.w	$40(a0),d0
		cmpi.w	#-$80,d0
		blt.s	loc_8E274
		cmpi.w	#$80,d0
		bgt.s	loc_8E274
		bset	#0,d1
		bra.w	loc_8E278
; ---------------------------------------------------------------------------

loc_8E274:

		move.w	d0,$18(a0)

loc_8E278:
		move.w	$1A(a0),d0
		addi.w	#8,d0
		bmi.s	loc_8E290
		cmpi.w	#$80,d0
		blt.s	loc_8E290
		bset	#1,d1
		bra.w	loc_8E294
; ---------------------------------------------------------------------------

loc_8E290:

		move.w	d0,$1A(a0)

loc_8E294:
		cmpi.b	#3,d1
		bne.s	loc_8E2A6
		move.l	#loc_3DBE0,(a0)
		move.w	#2,$34(a0)

loc_8E2A6:
		jsr	(sub_3DC3A).l
		jsr	(MoveSprite2).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8E2B8:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_8E2BE:
		lea	ObjDat3_8E3EA(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_8E2CE,(a0)

loc_8E2CE:
		jmp	(Child_Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_8E2D4:
		move.b	($FFFFFE0F).w,d0
		andi.b	#7,d0
		bne.w	locret_8E234
		lea	ChildObjDat_8E40A(pc),a2
		jmp	(CreateChild6_Simple).l
; End of function sub_8E2D4


; =============== S U B R O U T I N E =======================================


sub_8E2EA:
		jsr	(Random_Number).l
		movea.w	$46(a0),a1
		move.w	d0,d1
		moveq	#0,d2
		move.b	$2C(a1),d2
		lsl.w	#5,d2
		lea	word_8E438(pc),a2
		adda.w	d2,a2
		andi.w	#$1C,d1
		adda.w	d1,a2
		move.w	(a2)+,d2
		move.w	(a2)+,d3
		beq.s	loc_8E35C
		andi.w	#6,d0
		move.w	word_8E364(pc,d0.w),d0
		move.w	#-$20,d4
		btst	#0,4(a1)
		bne.s	loc_8E330
		bset	#0,4(a0)
		neg.w	d0
		neg.w	d2
		neg.w	d4

loc_8E330:
		move.w	d0,$18(a0)
		add.w	d2,$10(a0)
		add.w	d3,$14(a0)
		move.w	d4,$40(a0)
		swap	d0
		moveq	#0,d2
		tst.w	d0
		bpl.s	loc_8E34A
		moveq	#4,d2

loc_8E34A:
		andi.w	#6,d0
		move.w	word_8E36C(pc,d0.w),$1A(a0)
		move.l	off_8E374(pc,d2.w),$C(a0)
		rts
; ---------------------------------------------------------------------------

loc_8E35C:
		addq.w	#4,sp
		jmp	(Delete_Current_Sprite).l
; End of function sub_8E2EA

; ---------------------------------------------------------------------------
word_8E364:	dc.w $600
		dc.w $700
		dc.w $800
		dc.w $900
word_8E36C:	dc.w $FE80
		dc.w $FE00
		dc.w $FD80
		dc.w $FD00
off_8E374:	dc.l Map_MHZPollen
		dc.l Map_MHZBigLeaves

; =============== S U B R O U T I N E =======================================


sub_8E37C:
		lea	($FFFFB000).w,a1
		bsr.w	sub_8E388
		lea	($FFFFB04A).w,a1
; End of function sub_8E37C


; =============== S U B R O U T I N E =======================================


sub_8E388:
		cmpi.b	#8,$20(a1)
		beq.s	locret_8E3D6
		tst.b	$3D(a1)
		bne.s	locret_8E3D6
		tst.b	$2E(a1)
		bne.s	locret_8E3D6
		jsr	(Find_OtherObject).l
		cmpi.w	#$100,d2
		bcc.s	locret_8E3D6
		cmpi.w	#$40,d3
		bcc.s	locret_8E3D6
		move.w	d0,d4
		btst	#0,4(a0)
		bne.s	loc_8E3BA
		subq.w	#2,d4

loc_8E3BA:
		tst.w	d4
		beq.s	locret_8E3D6
		lsr.w	#4,d2
		andi.w	#$F,d2
		subi.w	#$F,d2
		neg.w	d2
		addq.w	#1,d2
		tst.w	d0
		bne.s	loc_8E3D2
		neg.w	d2

loc_8E3D2:
		add.w	d2,$10(a1)

locret_8E3D6:
		rts
; End of function sub_8E388

; ---------------------------------------------------------------------------
ObjDat4_8E3D8:	dc.w 1
		dc.w $A500
		dc.w $11
		dc.w 2
		dc.l Map_Cluckoid
		dc.w $280
		dc.b $14
		dc.b $10
		dc.b 0
		dc.b $1A
ObjDat3_8E3EA:	dc.l Map_CluckoidArrow
		dc.w $A522
		dc.w $280
		dc.b $10
		dc.b $C
		dc.b 0
		dc.b 0
ObjDat3_8E3F6:	dc.l Map_MHZPollen
		dc.w $E363
		dc.w 0
		dc.b 8
		dc.b 8
		dc.b 0
		dc.b 0
ChildObjDat_8E402:dc.w 0
		dc.l loc_8E2BE
		dc.w $1C
ChildObjDat_8E40A:dc.w 0
		dc.l loc_8E236
DPLCPtr_8E410:	dc.l ArtUnc_Cluckoid
		dc.l DPLC_Cluckoid
byte_8E418:	dc.b 0
		dc.b 7
		dc.b 1
		dc.b 7
		dc.b 2
		dc.b 7
		dc.b 3
		dc.b 7
		dc.b 4
		dc.b $2F
		dc.b 5
		dc.b 2
		dc.b 6
		dc.b 2
		dc.b 7
		dc.b 2
		dc.b 8
		dc.b 2
		dc.b 9
		dc.b 7
		dc.b $A
		dc.b 7
		dc.b $B
		dc.b 7
		dc.b $C
		dc.b 7
		dc.b $D
		dc.b $1F
		dc.b 0
		dc.b $F
		dc.b $F4
		dc.b 0
word_8E438:	dc.w	$10,   $28
		dc.w	$20,   $28
		dc.w	$30,   $28
		dc.w	$40,   $28
		dc.w	$50,   $28
		dc.w	$60,   $28
		dc.w	$70,   $28
		dc.w	$80,   $28
		dc.w	$10,   $28
		dc.w	$18,   $28
		dc.w	$30,   $48
		dc.w	$40,   $48
		dc.w	$50,   $48
		dc.w	$60,   $48
		dc.w	$70,   $48
		dc.w	$80,   $48
		dc.w	$10,   $28
		dc.w	$14,   $28
		dc.w	$18,   $28
		dc.w	$1C,   $28
		dc.w	$20,   $28
		dc.w	  0,	 0
		dc.w	  0,	 0
		dc.w	  0,	 0
		dc.w	$10,   $28
		dc.w	$18,   $28
		dc.w	$20,   $28
		dc.w	$30,   $48
		dc.w	$40,   $48
		dc.w	$50,   $48
		dc.w	$60,   $48
		dc.w	$80,   $68
DPLC_Cluckoid:	include "General\Sprites\Cluckoid\DPLC - Cluckoid.asm"

Map_CluckoidArrow:	include "General\Sprites\Cluckoid\Map - Cluckoid Arrow.asm"

Map_Cluckoid:	include "General\Sprites\Cluckoid\Map - Cluckoid.asm"

; ---------------------------------------------------------------------------

Obj_Skorp:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8E66A(pc,d0.w),d1
		jsr	off_8E66A(pc,d1.w)
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------
off_8E66A:	dc.w loc_8E670-off_8E66A

		dc.w loc_8E6B8-off_8E66A
		dc.w loc_8E732-off_8E66A
; ---------------------------------------------------------------------------

loc_8E670:
		lea	ObjDat3_8EA48(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#$B,$1E(a0)
		move.l	#loc_8E706,$34(a0)
		move.w	#-$80,d0
		btst	#0,4(a0)
		beq.s	loc_8E696
		neg.w	d0

loc_8E696:
		move.w	d0,$18(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		subq.w	#1,d0
		move.w	d0,$2E(a0)
		add.w	d0,d0
		addq.w	#1,d0
		move.w	d0,$3A(a0)
		lea	ChildObjDat_8EA5A(pc),a2
		jmp	(CreateChild4_LinkListRepeated).l
; ---------------------------------------------------------------------------

loc_8E6B8:
		lea	($FFFFB000).w,a1
		jsr	(Find_OtherObject).l
		btst	#0,4(a0)
		sne	d4
		tst.w	d0
		beq.s	loc_8E6D0
		not.b	d4

loc_8E6D0:
		tst.b	d4
		bne.s	loc_8E6E6
		cmpi.w	#$20,d2
		bcs.s	loc_8E6E6
		cmpi.w	#$80,d2
		bcc.s	loc_8E6E6
		cmpi.w	#$28,d3
		bcs.s	loc_8E718

loc_8E6E6:

		lea	byte_8EA60(pc),a1
		jsr	(Animate_RawNoSST).l
		jsr	(MoveSprite2).l
		jsr	(ObjHitFloor2_DoRoutine).l
		bne.w	locret_8E716
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_8E706:
		neg.w	$18(a0)
		bchg	#0,4(a0)
		move.w	$3A(a0),$2E(a0)

locret_8E716:
		rts
; ---------------------------------------------------------------------------

loc_8E718:
		move.b	#4,5(a0)
		bset	#1,$38(a0)
		move.w	$10(a1),$3E(a0)
		move.w	$14(a1),$40(a0)
		rts
; ---------------------------------------------------------------------------

loc_8E732:
		btst	#1,$38(a0)
		beq.s	loc_8E73C
		rts
; ---------------------------------------------------------------------------

loc_8E73C:
		move.b	#2,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_8E744:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8E778(pc,d0.w),d1
		jsr	off_8E778(pc,d1.w)
		movea.w	$44(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_8E772
		cmpi.b	#$A,$2C(a0)
		bne.s	loc_8E76C
		jsr	(Add_SpriteToCollisionResponseList).l

loc_8E76C:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8E772:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------
off_8E778:	dc.w loc_8E78C-off_8E778

		dc.w loc_8E7D4-off_8E778
		dc.w loc_8E828-off_8E778
		dc.w loc_8E868-off_8E778
		dc.w loc_8E88C-off_8E778
		dc.w loc_8E8C4-off_8E778
		dc.w loc_8E8BE-off_8E778
		dc.w loc_8E8BE-off_8E778
		dc.w loc_8E918-off_8E778
		dc.w loc_8E958-off_8E778
; ---------------------------------------------------------------------------

loc_8E78C:
		lea	word_8EA54(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		movea.w	$46(a0),a1
		move.b	$2C(a0),d0
		bne.s	loc_8E7B2
		move.b	#8,$42(a0)
		move.b	#-$10,$43(a0)
		move.w	$46(a0),$44(a1)

loc_8E7B2:
		move.w	$44(a1),$44(a0)
		cmpi.b	#$A,d0
		bne.s	loc_8E7D0
		move.b	#4,$22(a0)
		move.w	#$100,8(a0)
		move.b	#-$79,$28(a0)

loc_8E7D0:
		bsr.w	sub_8E982

loc_8E7D4:
		jsr	(Change_FlipXUseParent).l
		tst.b	$2C(a0)
		beq.s	loc_8E7F8
		movea.w	$44(a0),a1
		btst	#1,$38(a1)
		bne.s	loc_8E80E
		bsr.w	sub_8EA1C
		moveq	#5,d2
		jmp	(MoveSprite_CircularSimpleCheckFlip).l
; ---------------------------------------------------------------------------

loc_8E7F8:
		jsr	(Refresh_ChildPositionAdjusted).l
		movea.w	$46(a0),a1
		moveq	#0,d0

loc_8E804:
		move.b	$22(a1),d0
		sub.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------

loc_8E80E:
		move.b	#4,5(a0)
		move.l	#loc_8E87C,$34(a0)
		movea.w	$44(a0),a1
		andi.b	#-$D,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_8E828:
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		move.b	byte_8E862(pc,d0.w),d1
		move.b	$3C(a0),d2
		subq.b	#8,d2
		cmp.b	d1,d2
		bhi.s	loc_8E856
		move.b	#6,5(a0)
		move.b	d1,d2
		cmpi.b	#5,d0
		bne.s	loc_8E856
		movea.w	$44(a0),a1
		bset	#3,$38(a1)

loc_8E856:

		move.b	d2,$3C(a0)
		moveq	#5,d2
		jmp	(MoveSprite_CircularSimpleCheckFlip).l
; ---------------------------------------------------------------------------
byte_8E862:	dc.b 0
		dc.b $68
		dc.b $58
		dc.b $48
		dc.b $38
		dc.b $38
; ---------------------------------------------------------------------------

loc_8E868:
		movea.w	$44(a0),a1
		btst	#3,$38(a1)
		bne.s	loc_8E876
		rts
; ---------------------------------------------------------------------------

loc_8E876:
		movea.l	$34(a0),a1
		jmp	(a1)
; ---------------------------------------------------------------------------

loc_8E87C:
		move.b	#8,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_8E884:
		move.b	#$10,5(a0)
		rts
; ---------------------------------------------------------------------------

loc_8E88C:
		move.b	$3C(a0),d0
		addi.b	#$10,d0
		bpl.s	loc_8E8B2
		move.b	#$C,5(a0)
		move.w	#$F,$2E(a0)
		move.l	#loc_8E8CA,$34(a0)
		bsr.w	sub_8E9A4
		move.b	#-$80,d0

loc_8E8B2:
		move.b	d0,$3C(a0)
		moveq	#5,d2
		jmp	(MoveSprite_CircularSimpleCheckFlip).l
; ---------------------------------------------------------------------------

loc_8E8BE:
		jsr	(MoveSprite2).l

loc_8E8C4:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_8E8CA:
		move.b	#$A,5(a0)
		move.w	#$F,$2E(a0)
		move.l	#loc_8E8E0,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8E8E0:
		move.b	#$E,5(a0)
		neg.w	$18(a0)
		neg.w	$1A(a0)
		move.w	#$F,$2E(a0)
		move.l	#loc_8E8FE,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8E8FE:
		move.b	#4,5(a0)
		move.l	#loc_8E884,$34(a0)
		movea.w	$44(a0),a1
		bclr	#3,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_8E918:
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.w	#1,d0
		move.b	byte_8E952(pc,d0.w),d1
		move.b	$3C(a0),d2
		addq.b	#8,d2
		cmp.b	d1,d2
		bcs.s	loc_8E946
		move.b	#$12,5(a0)
		move.b	d1,d2
		cmpi.b	#5,d0
		bne.s	loc_8E946
		movea.w	$44(a0),a1
		bset	#2,$38(a1)

loc_8E946:

		move.b	d2,$3C(a0)
		moveq	#5,d2
		jmp	(MoveSprite_CircularSimpleCheckFlip).l
; ---------------------------------------------------------------------------
byte_8E952:	dc.b 0
		dc.b $90
		dc.b $A0
		dc.b $B0
		dc.b $B8
		dc.b $C0
; ---------------------------------------------------------------------------

loc_8E958:
		movea.w	$44(a0),a1
		btst	#2,$38(a1)
		bne.s	loc_8E966
		rts
; ---------------------------------------------------------------------------

loc_8E966:
		move.b	#2,5(a0)
		movea.w	$44(a0),a1
		bclr	#1,$38(a1)
		clr.b	$3B(a0)
		bclr	#0,$38(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_8E982:
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsr.b	#1,d0
		move.b	byte_8E992(pc,d0.w),$3C(a0)
		rts
; End of function sub_8E982

; ---------------------------------------------------------------------------
byte_8E992:	dc.b 0
		dc.b $90
		dc.b $A0
		dc.b $B0
		dc.b $B8
		dc.b $C0
; ---------------------------------------------------------------------------
		move.b	$2C(a0),d0
		lsr.b	#1,d0
		move.b	d0,$2E(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_8E9A4:
		movea.w	$44(a0),a1
		move.w	$3E(a1),d0
		sub.w	$10(a0),d0
		smi	d2
		bpl.s	loc_8E9B6
		neg.w	d0

loc_8E9B6:
		move.w	$40(a1),d1
		sub.w	$14(a0),d1
		smi	d3
		bpl.s	loc_8E9C4
		neg.w	d1

loc_8E9C4:
		moveq	#0,d4
		move.b	$2C(a0),d4
		move.w	off_8E9D2(pc,d4.w),d4
		jmp	off_8E9D2(pc,d4.w)
; End of function sub_8E9A4

; ---------------------------------------------------------------------------
off_8E9D2:	dc.w loc_8E9DE-off_8E9D2

		dc.w loc_8E9DE-off_8E9D2
		dc.w loc_8E9E6-off_8E9D2
		dc.w loc_8E9EE-off_8E9D2
		dc.w loc_8E9F6-off_8E9D2
		dc.w loc_8EA02-off_8E9D2
; ---------------------------------------------------------------------------

loc_8E9DE:
		move.w	#$3333,d4
		bra.w	loc_8E9FA
; ---------------------------------------------------------------------------

loc_8E9E6:
		move.w	#$6666,d4
		bra.w	loc_8E9FA
; ---------------------------------------------------------------------------

loc_8E9EE:
		move.w	#-$6667,d4
		bra.w	loc_8E9FA
; ---------------------------------------------------------------------------

loc_8E9F6:
		move.w	#-$3334,d4

loc_8E9FA:

		mulu.w	d4,d0
		swap	d0
		mulu.w	d4,d1
		swap	d1

loc_8EA02:
		asl.w	#4,d0
		tst.b	d2
		beq.s	loc_8EA0A
		neg.w	d0

loc_8EA0A:
		move.w	d0,$18(a0)
		asl.w	#4,d1
		tst.b	d3
		beq.s	loc_8EA16
		neg.w	d1

loc_8EA16:
		move.w	d1,$1A(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_8EA1C:
		subq.b	#1,$3B(a0)
		bpl.s	loc_8EA2E
		move.b	#$10,$3B(a0)
		bchg	#0,$38(a0)

loc_8EA2E:
		btst	#0,$3B(a0)
		bne.s	locret_8EA46
		moveq	#1,d0
		btst	#0,$38(a0)
		bne.s	loc_8EA42
		neg.w	d0

loc_8EA42:
		add.b	d0,$3C(a0)

locret_8EA46:
		rts
; End of function sub_8EA1C

; ---------------------------------------------------------------------------
ObjDat3_8EA48:	dc.l Map_Skorp
		dc.w $2536
		dc.w $180
		dc.b $10
		dc.b $14
		dc.b 0
		dc.b 6
word_8EA54:	dc.w $180
		dc.b $10
		dc.b $14
		dc.b 3
		dc.b 0
ChildObjDat_8EA5A:dc.w 5
		dc.l loc_8E744
byte_8EA60:	dc.b	9,   1,	  0,   1,   2, $FC
; ---------------------------------------------------------------------------

Obj_Sandworm:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8EA80(pc,d0.w),d1
		jsr	off_8EA80(pc,d1.w)
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------
off_8EA80:	dc.w loc_8EA88-off_8EA80

		dc.w loc_8EACC-off_8EA80
		dc.w loc_8EB2E-off_8EA80
		dc.w loc_8EACC-off_8EA80
; ---------------------------------------------------------------------------

loc_8EA88:
		lea	ObjDat3_8ED44(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bset	#7,$38(a0)
		move.l	#byte_8ED8C,$30(a0)
		lea	ChildObjDat_8ED66(pc),a2
		jsr	(CreateChild6_Simple).l

loc_8EAAA:

		move.w	#$7F,$2E(a0)
		move.l	#loc_8EAD2,$34(a0)
		btst	#7,$38(a0)
		beq.w	locret_8EBE0
		lea	ChildObjDat_8ED6C(pc),a2
		jmp	(CreateChild3_NormalRepeated).l
; ---------------------------------------------------------------------------

loc_8EACC:

		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_8EAD2:
		move.b	#4,5(a0)
		move.b	#-$75,$28(a0)
		btst	#7,$38(a0)
		beq.s	loc_8EAEC
		move.b	#$B,$28(a0)

loc_8EAEC:
		move.w	$14(a0),$3A(a0)
		move.w	#-$400,$1A(a0)
		moveq	#-$60,d0
		move.w	#-$200,d1
		btst	#0,4(a0)
		beq.s	loc_8EB0A
		neg.w	d0
		neg.w	d1

loc_8EB0A:
		add.w	d0,$10(a0)
		move.w	d1,$18(a0)
		btst	#7,$38(a0)
		beq.w	locret_8EBE0
		moveq	#$6C,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_8ED74(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_8EB2E:

		jsr	(Animate_Raw).l
		jsr	(MoveSprite_LightGravity).l
		move.w	$3A(a0),d0
		cmp.w	$14(a0),d0
		bhi.w	locret_8EBE0
		move.b	#6,5(a0)
		clr.b	$28(a0)
		move.w	d0,$14(a0)
		move.w	#$3F,$2E(a0)
		move.l	#loc_8EB7E,$34(a0)
		btst	#7,$38(a0)
		beq.w	locret_8EBE0
		moveq	#$6C,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_8ED74(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_8EB7E:
		move.b	#2,5(a0)
		bchg	#0,4(a0)
		bra.w	loc_8EAAA
; ---------------------------------------------------------------------------

loc_8EB8E:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8EBA4(pc,d0.w),d1
		jsr	off_8EBA4(pc,d1.w)
		moveq	#0,d0
		jmp	(Child_DrawTouch_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------
off_8EBA4:	dc.w loc_8EBAC-off_8EBA4

		dc.w loc_8EACC-off_8EBA4
		dc.w loc_8EB2E-off_8EBA4
		dc.w loc_8EACC-off_8EBA4
; ---------------------------------------------------------------------------

loc_8EBAC:
		lea	word_8ED60(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#byte_8ED90,$30(a0)
		jsr	(Change_FlipXUseParent).l
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,d1
		add.w	d0,d0
		add.w	d1,d0
		addq.w	#6,d0
		subq.w	#1,d0
		move.w	d0,$2E(a0)
		move.l	#loc_8EAAA,$34(a0)

locret_8EBE0:

		rts
; ---------------------------------------------------------------------------

loc_8EBE2:
		lea	word_8ED50(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#loc_8EC1C,(a0)
		move.l	#loc_8EC22,$34(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#2,d0
		move.w	d0,d1
		movea.w	$46(a0),a1
		btst	#0,4(a1)
		bne.s	loc_8EC12
		neg.w	d0

loc_8EC12:
		add.w	d0,$10(a0)
		subq.w	#1,d1
		move.w	d1,$2E(a0)

loc_8EC1C:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_8EC22:
		move.l	#loc_8EC46,(a0)
		move.l	#byte_8ED88,$30(a0)
		move.w	#-$80,$1A(a0)
		move.w	#$F,$2E(a0)
		move.l	#loc_8EC5E,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8EC46:
		jsr	(Animate_Raw).l
		jsr	(MoveSprite2).l
		jsr	(Obj_Wait).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8EC5E:
		move.w	#$40,$1A(a0)
		move.w	#$1F,$2E(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8EC74:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8EC88(pc,d0.w),d1
		jsr	off_8EC88(pc,d1.w)
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_8EC88:	dc.w loc_8EC92-off_8EC88

		dc.w loc_8ECB0-off_8EC88
		dc.w loc_8ECDA-off_8EC88
		dc.w loc_8ED02-off_8EC88
		dc.w loc_8ED3E-off_8EC88
; ---------------------------------------------------------------------------

loc_8EC92:
		lea	word_8ED58(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		move.w	d0,$2E(a0)
		move.l	#loc_8ECB6,$34(a0)

loc_8ECB0:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_8ECB6:
		move.b	#4,5(a0)
		move.l	#byte_8ED94,$30(a0)
		move.w	#-$400,$1A(a0)
		move.w	#7,$2E(a0)
		move.l	#loc_8ECEC,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8ECDA:
		jsr	(Animate_Raw).l
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_8ECEC:
		move.b	#6,5(a0)
		move.w	#$17,$2E(a0)
		move.l	#loc_8ED1E,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8ED02:
		moveq	#8,d0
		btst	#0,$2F(a0)
		bne.s	loc_8ED0E
		neg.w	d0

loc_8ED0E:
		add.w	d0,$14(a0)
		jsr	(Animate_Raw).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_8ED1E:
		move.b	#8,5(a0)
		clr.b	$24(a0)
		clr.b	$23(a0)
		move.l	#byte_8ED98,$30(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8ED3E:
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------
ObjDat3_8ED44:	dc.l Map_Sandworm
		dc.w $2557
		dc.w $280
		dc.b 8
		dc.b $C
		dc.b 0
		dc.b 0
word_8ED50:	dc.w $4557
		dc.w $200
		dc.b 8
		dc.b 4
		dc.b 3
		dc.b 0
word_8ED58:	dc.w $4557
		dc.w $200
		dc.b 4
		dc.b $10
		dc.b 5
		dc.b 0
word_8ED60:	dc.w $280
		dc.b 8
		dc.b 8
		dc.b 1
		dc.b 0
ChildObjDat_8ED66:dc.w 4
		dc.l loc_8EB8E
ChildObjDat_8ED6C:dc.w 7
		dc.l loc_8EBE2
		dc.w $F8
ChildObjDat_8ED74:dc.w 2

		dc.l loc_8EC74
		dc.w 4
		dc.l loc_8EC74
		dc.w $FC04
		dc.l loc_8EC74
		dc.w $404
byte_8ED88:	dc.b 1
		dc.b 3
		dc.b 4
		dc.b $FC
byte_8ED8C:	dc.b 9
		dc.b 0
		dc.b 2
		dc.b $FC
byte_8ED90:	dc.b $7E
		dc.b 1
		dc.b 1
		dc.b $FC
byte_8ED94:	dc.b 1
		dc.b 5
		dc.b 6
		dc.b $FC
byte_8ED98:	dc.b 7
		dc.b 3
		dc.b 7
		dc.b 3
		dc.b 8
		dc.b 5
		dc.b $F4
		dc.b 0
; ---------------------------------------------------------------------------

Obj_Rockn:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8EDBA(pc,d0.w),d1
		jsr	off_8EDBA(pc,d1.w)
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------
off_8EDBA:	dc.w loc_8EDC0-off_8EDBA

		dc.w loc_8EE1C-off_8EDBA
		dc.w loc_8EE3A-off_8EDBA
; ---------------------------------------------------------------------------

loc_8EDC0:
		lea	ObjDat3_8F04E(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.b	#7,$1E(a0)
		move.b	$2C(a0),d0
		bne.s	loc_8EDE4
		clr.w	$3A(a0)
		move.w	#$7FFF,$3C(a0)
		bra.w	loc_8EE02
; ---------------------------------------------------------------------------

loc_8EDE4:
		move.b	d0,d1
		andi.w	#$F0,d0
		neg.w	d0
		add.w	$10(a0),d0
		move.w	d0,$3A(a0)
		andi.w	#$F,d1
		lsl.w	#4,d1
		add.w	$10(a0),d1
		move.w	d1,$3C(a0)

loc_8EE02:
		moveq	#-$80,d0
		btst	#0,4(a0)
		beq.s	loc_8EE0E
		neg.w	d0

loc_8EE0E:
		move.w	d0,$18(a0)
		lea	ChildObjDat_8F072(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_8EE1C:
		btst	#2,$38(a0)
		beq.s	locret_8EE38
		move.b	#4,5(a0)
		move.b	#-$27,$28(a0)
		move.l	#loc_8EF1C,$34(a0)

locret_8EE38:

		rts
; ---------------------------------------------------------------------------

loc_8EE3A:
		lea	(byte_8F080).l,a1
		jsr	(Animate_RawNoSST).l
		bclr	#0,$38(a0)
		lea	($FFFFB000).w,a1
		move.w	$10(a1),d0
		cmp.w	$3A(a0),d0
		bcs.s	loc_8EE86
		cmp.w	$3C(a0),d0
		bcc.s	loc_8EE86
		move.w	$14(a1),d1
		sub.w	$14(a0),d1
		bpl.s	loc_8EE6C
		neg.w	d1

loc_8EE6C:
		cmpi.w	#$10,d1
		bcc.s	loc_8EE86
		bset	#0,$38(a0)
		moveq	#-$80,d1
		sub.w	$10(a0),d0
		bcs.s	loc_8EE82
		neg.w	d1

loc_8EE82:
		move.w	d1,$18(a0)

loc_8EE86:

		tst.w	$18(a0)
		beq.s	loc_8EE92
		jsr	(ObjHitFloor2_DoRoutine).l

loc_8EE92:
		move.w	$10(a0),d0
		move.w	$18(a0),d1
		bne.s	loc_8EEA6
		btst	#0,$38(a0)
		bne.s	loc_8EEDC
		tst.w	d1

loc_8EEA6:
		bmi.s	loc_8EEBC
		move.w	#$80,d1
		bset	#0,4(a0)
		cmp.w	$3C(a0),d0
		bcc.s	loc_8EECA
		bra.w	loc_8EED2
; ---------------------------------------------------------------------------

loc_8EEBC:
		moveq	#-$80,d1
		bclr	#0,4(a0)
		cmp.w	$3A(a0),d0
		bcc.s	loc_8EED2

loc_8EECA:
		neg.w	d1
		bchg	#0,4(a0)

loc_8EED2:

		move.w	d1,$18(a0)
		jsr	(MoveSprite2).l

loc_8EEDC:
		lea	word_8EF14(pc),a1
		jsr	(Check_PlayerInRange).l
		tst.w	d0
		beq.s	loc_8EEEE
		bsr.w	sub_8EEF4

loc_8EEEE:
		swap	d0
		tst.w	d0
		beq.s	locret_8EF12

; =============== S U B R O U T I N E =======================================


sub_8EEF4:
		movea.w	d0,a1
		jsr	(Check_PlayerAttack).l
		beq.s	locret_8EF12
		btst	#1,$2A(a1)
		bne.s	locret_8EF12
		move.w	a1,$44(a0)
		jsr	(EnemyDefeated).l
		addq.w	#4,sp

locret_8EF12:

		rts
; End of function sub_8EEF4

; ---------------------------------------------------------------------------
word_8EF14:	dc.w  $FFD7,   $52, $FFF0,   $20
; ---------------------------------------------------------------------------

loc_8EF1C:
		btst	#0,$38(a0)
		bne.s	loc_8EF36
		moveq	#-$80,d0
		bchg	#0,4(a0)
		bne.s	loc_8EF30
		neg.w	d0

loc_8EF30:
		move.w	d0,$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_8EF36:
		clr.w	$18(a0)
		rts
; ---------------------------------------------------------------------------

loc_8EF3C:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8EF7A(pc,d0.w),d1
		move.w	$10(a0),-(sp)
		jsr	off_8EF7A(pc,d1.w)
		moveq	#$23,d1
		moveq	#$10,d2
		moveq	#$11,d3
		move.w	(sp)+,d4
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_8EF6E
		jsr	(SolidObjectFull).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8EF6E:
		jsr	(Displace_PlayerOffObject).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------
off_8EF7A:	dc.w loc_8EF84-off_8EF7A

		dc.w loc_8EF94-off_8EF7A
		dc.w loc_8EFC4-off_8EF7A
		dc.w loc_8EFD8-off_8EF7A
		dc.w loc_8EFF6-off_8EF7A
; ---------------------------------------------------------------------------

loc_8EF84:
		lea	ObjDat3_8F05A(pc),a1
		jsr	(SetUp_ObjAttributes).l
		jmp	(Refresh_ChildPositionAdjusted).l
; ---------------------------------------------------------------------------

loc_8EF94:
		lea	($FFFFB000).w,a1
		jsr	(Find_OtherObject).l
		cmpi.w	#$28,d2
		bhi.w	locret_8EE38
		cmpi.w	#$40,d3
		bhi.w	locret_8EE38
		move.b	#4,5(a0)
		move.w	#7,$2E(a0)
		lea	ChildObjDat_8F07A(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_8EFC4:
		subq.w	#1,$2E(a0)
		bpl.s	locret_8EFD6
		move.b	#6,5(a0)
		move.w	#7,$2E(a0)

locret_8EFD6:
		rts
; ---------------------------------------------------------------------------

loc_8EFD8:
		subq.w	#2,$14(a0)
		subq.w	#1,$2E(a0)
		bmi.s	loc_8EFE4
		rts
; ---------------------------------------------------------------------------

loc_8EFE4:
		move.b	#8,5(a0)
		movea.w	$46(a0),a1
		bset	#2,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_8EFF6:
		movea.w	$46(a0),a1
		moveq	#-$18,d0
		tst.b	$22(a1)
		beq.s	loc_8F004
		moveq	#-$17,d0

loc_8F004:
		move.b	d0,$43(a0)
		jmp	(Refresh_ChildPositionAdjusted).l
; ---------------------------------------------------------------------------

loc_8F00E:
		lea	ObjDat3_8F066(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_8F024,(a0)
		move.w	#5,$2E(a0)

loc_8F024:
		subq.w	#1,$2E(a0)
		bpl.s	loc_8F036
		move.l	#loc_8F042,(a0)
		move.b	#3,$22(a0)

loc_8F036:
		jsr	(Refresh_ChildPositionAdjusted).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8F042:
		jsr	(Refresh_ChildPositionAdjusted).l
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------
ObjDat3_8F04E:	dc.l Map_Rockn
		dc.w $2500
		dc.w $280
		dc.b $10
		dc.b 8
		dc.b 0
		dc.b 0
ObjDat3_8F05A:	dc.l Map_SOZBreakableSandRock
		dc.w $43D9
		dc.w $200
		dc.b $18
		dc.b $10
		dc.b 0
		dc.b 0
ObjDat3_8F066:	dc.l Map_Rockn
		dc.w $2500
		dc.w $180
		dc.b $18
		dc.b $10
		dc.b 4
		dc.b 0
ChildObjDat_8F072:dc.w 0
		dc.l loc_8EF3C
		dc.w $F8
ChildObjDat_8F07A:dc.w 0
		dc.l loc_8F00E
byte_8F080:	dc.b	8,   0,	  1,   0,   2, $FC
Map_Rockn:include "General\Sprites\Rockn\Map - Rock'n.asm"

; ' <-- lol TextWrangler; it assumes ' is the string delimiter for all assembly files; I don't want
;     my screen to be filled with pink
; ---------------------------------------------------------------------------

Obj_SOZ_Ghosts:

		move.l	#loc_8F0CA,(a0)
		move.w	#$120,$10(a0)
		move.w	#$A0,$14(a0)

loc_8F0CA:
		cmpi.b	#2,($FFFFB038).w
		beq.s	loc_8F0DA
		tst.b	($FFFFFE2A).w
		beq.w	locret_8F436

loc_8F0DA:
		moveq	#0,d0
		move.b	($FFFFF7C3).w,d0
		beq.s	loc_8F112
		move.b	byte_8F118(pc,d0.w),d0
		move.b	($FFFFFAAD).w,d1
		cmp.b	d0,d1
		bcc.w	locret_8F436
		subq.w	#1,$3A(a0)
		bpl.w	locret_8F436
		addq.b	#1,d1
		move.b	d1,($FFFFFAAD).w
		cmp.b	d0,d1
		bcc.s	loc_8F108
		move.w	#$3F,$3A(a0)

loc_8F108:
		lea	ChildObjDat_8F674(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------

loc_8F112:
		clr.b	($FFFFFAAD).w
		rts
; ---------------------------------------------------------------------------
byte_8F118:	dc.b 0
		dc.b 1
		dc.b 2
		dc.b 2
		dc.b 3
		dc.b 3
; ---------------------------------------------------------------------------

loc_8F11E:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8F19A(pc,d0.w),d1
		jsr	off_8F19A(pc,d1.w)
		lea	DPLCPtr_8F67A(pc),a2
		jsr	(Perform_DPLC).l
		tst.b	4(a0)
		bpl.s	loc_8F16A
		tst.b	($FFFFF7C3).w
		beq.s	loc_8F174
		jsr	(Check_PlayerCollision).l
		beq.s	loc_8F15E
		jsr	(Check_PlayerAttack).l
		bne.s	loc_8F174
		tst.b	$34(a1)
		bne.s	loc_8F15E
		jsr	(HurtSonic_Directly).l

loc_8F15E:

		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8F16A:

		subq.b	#1,($FFFFFAAD).w
		jmp	(Go_Delete_SpriteSlotted2).l
; ---------------------------------------------------------------------------

loc_8F174:

		move.l	#loc_8F37A,(a0)
		move.l	#loc_8F16A,$34(a0)
		lea	byte_8F6BF(pc),a1
		jsr	(Set_Raw_Animation).l
		moveq	#-$76,d0
		jsr	(Play_Sound_2).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------
off_8F19A:	dc.w loc_8F1AC-off_8F19A

		dc.w loc_8F1DA-off_8F19A
		dc.w loc_8F1FE-off_8F19A
		dc.w loc_8F226-off_8F19A
		dc.w loc_8F26E-off_8F19A
		dc.w loc_8F2BE-off_8F19A
		dc.w loc_8F2E0-off_8F19A
		dc.w loc_8F322-off_8F19A
		dc.w loc_8F36E-off_8F19A
; ---------------------------------------------------------------------------

loc_8F1AC:
		lea	ObjDat4_8F61C(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l
		bclr	#2,4(a0)
		bset	#7,4(a0)
		move.b	($FFFFF7C3).w,$42(a0)
		move.b	($FFFFFAAD).w,$43(a0)
		bsr.w	sub_8F538
		moveq	#-$6E,d0
		jsr	(Play_Sound_2).l

loc_8F1DA:
		jsr	(Animate_RawMultiDelay).l
		tst.w	d2
		beq.s	locret_8F1F2
		cmpi.b	#5,($FFFFF7C3).w
		beq.s	loc_8F1F4
		move.b	#4,5(a0)

locret_8F1F2:
		rts
; ---------------------------------------------------------------------------

loc_8F1F4:

		move.b	#$C,5(a0)
		bra.w	loc_8F58E
; ---------------------------------------------------------------------------

loc_8F1FE:
		jsr	(Animate_RawMultiDelay).l
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		bsr.w	sub_8F4F0
		move.b	($FFFFF7C3).w,d0
		cmp.b	$42(a0),d0
		beq.s	locret_8F224
		move.b	#6,5(a0)

locret_8F224:
		rts
; ---------------------------------------------------------------------------

loc_8F226:
		jsr	(Animate_RawMultiDelay).l
		jsr	(Swing_UpAndDown).l
		tst.w	d3
		bne.s	loc_8F240
		jsr	(MoveSprite2).l
		bra.w	sub_8F4F0
; ---------------------------------------------------------------------------

loc_8F240:
		move.b	#8,5(a0)
		moveq	#0,d0
		move.b	($FFFFF7C3).w,d0
		move.b	byte_8F268(pc,d0.w),d1
		beq.w	locret_8F436
		move.b	d0,$42(a0)
		cmpi.b	#5,d0
		beq.s	loc_8F1F4
		move.b	#4,5(a0)
		bra.w	loc_8F58E
; ---------------------------------------------------------------------------
byte_8F268:	dc.b 0
		dc.b 0
		dc.b 0
		dc.b 1
		dc.b 0
		dc.b 1
; ---------------------------------------------------------------------------

loc_8F26E:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		bsr.w	sub_8F4F0
		jsr	(Animate_RawMultiDelay).l
		beq.s	locret_8F2B0
		cmpi.b	#2,$23(a0)
		bne.s	locret_8F2B0
		move.b	#$A,5(a0)
		move.b	($FFFFF7C3).w,d0
		move.b	d0,$42(a0)
		add.w	d0,d0
		andi.w	#$C,d0
		movea.l	off_8F2B2(pc,d0.w),a1
		move.b	(a1),$22(a0)
		jsr	(Set_Raw_Animation).l

locret_8F2B0:

		rts
; ---------------------------------------------------------------------------
off_8F2B2:	dc.l byte_8F6CC
		dc.l byte_8F6CC
		dc.l byte_8F6D4
; ---------------------------------------------------------------------------

loc_8F2BE:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		bsr.w	sub_8F4F0
		jsr	(Animate_RawMultiDelay).l
		tst.w	d2
		beq.s	locret_8F2DE
		move.b	#4,5(a0)

locret_8F2DE:
		rts
; ---------------------------------------------------------------------------

loc_8F2E0:
		jsr	(Animate_RawMultiDelay).l
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		move.w	$10(a0),d0
		tst.w	$18(a0)
		bmi.s	loc_8F304
		cmpi.w	#$1A0,d0
		bhi.s	loc_8F30A
		rts
; ---------------------------------------------------------------------------

loc_8F304:
		cmpi.w	#$A0,d0
		bcc.s	locret_8F320

loc_8F30A:
		move.b	#$E,5(a0)
		bchg	#0,4(a0)
		neg.w	$18(a0)
		move.w	#$3B,$2E(a0)

locret_8F320:
		rts
; ---------------------------------------------------------------------------

loc_8F322:
		jsr	(Animate_RawMultiDelay).l
		subq.w	#1,$2E(a0)
		bpl.w	locret_8F436
		move.b	#$10,5(a0)
		move.b	#-$29,$28(a0)
		bset	#2,4(a0)
		move.w	($FFFFEE78).w,d0
		move.w	$10(a0),d1
		subi.w	#$80,d1
		add.w	d1,d0
		move.w	d0,$10(a0)
		move.w	($FFFFEE7C).w,d0
		move.w	$14(a0),d1
		subi.w	#$80,d1
		add.w	d1,d0
		move.w	d0,$14(a0)
		move.w	#$100,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_8F36E:
		jsr	(Animate_RawMultiDelay).l
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_8F37A:
		jsr	(Animate_RawMultiDelay).l
		lea	DPLCPtr_8F67A(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_AB_2:
		moveq	#0,d0
		move.b	$2C(a0),d0
		movea.l	off_8F3BE(pc,d0.w),a1
		jsr	(Check_PlayerInRange).l
		tst.l	d0
		beq.w	locret_8F436
		tst.w	d0
		beq.w	locret_8F436
		moveq	#0,d0
		move.b	$2C(a0),d0
		movea.l	off_8F3C6(pc,d0.w),a1
		jsr	(a1)
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------
off_8F3BE:	dc.l word_8F3CE
		dc.l word_8F3D6
off_8F3C6:	dc.l loc_8F3DE
		dc.l loc_8F3F0
word_8F3CE:	dc.w  $FFF0,   $20, $FFC0,   $80
word_8F3D6:	dc.w  $FFF0,   $20, $FF80,  $100
; ---------------------------------------------------------------------------

loc_8F3DE:
		lea	PLC_8F3E8(pc),a1
		jmp	(Load_PLC_Raw).l
; ---------------------------------------------------------------------------
PLC_8F3E8:	dc.w 0
		dc.l ArtNem_EggCapsule
		dc.w $A6C0
; ---------------------------------------------------------------------------

loc_8F3F0:
		jmp	(LoadEnemyArt).l
; ---------------------------------------------------------------------------

Obj_AC_2_SOZ2_Ghost_Capsule:
		lea	ObjDat3_8F62E(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_89C14,(a0)

loc_8F406:
		move.b	#3,$2C(a0)
		lea	ChildObjDat_8F646(pc),a2
		jsr	(CreateChild1_Normal).l
		tst.b	($FFFFFE2A).w
		bne.s	loc_8F424
		cmpi.b	#2,($FFFFB038).w
		bne.s	locret_8F436

loc_8F424:
		move.l	#loc_89C54,(a0)
		move.b	#1,$22(a0)
		bset	#5,$38(a0)

locret_8F436:

		rts
; ---------------------------------------------------------------------------

loc_8F438:
		lea	(word_86B3E).l,a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_8672A,(a0)
		tst.b	($FFFFFE2A).w
		beq.s	locret_8F45C
		move.l	#loc_86754,(a0)
		move.b	#$C,$22(a0)

locret_8F45C:
		rts
; ---------------------------------------------------------------------------

loc_8F45E:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8F488(pc,d0.w),d1
		jsr	off_8F488(pc,d1.w)
		tst.b	$2C(a0)
		bne.s	loc_8F482
		lea	DPLCPtr_8F67A(pc),a2
		jsr	(Perform_DPLC).l
		jmp	(Sprite_CheckDeleteSlotted).l
; ---------------------------------------------------------------------------

loc_8F482:
		jmp	(Sprite_CheckDelete).l
; ---------------------------------------------------------------------------
off_8F488:	dc.w loc_8F48E-off_8F488

		dc.w loc_8F4D8-off_8F488
		dc.w loc_8F4E2-off_8F488
; ---------------------------------------------------------------------------

loc_8F48E:
		moveq	#0,d0
		move.b	$2C(a0),d0
		add.w	d0,d0
		lea	word_8F4C0(pc,d0.w),a1
		move.w	(a1)+,$18(a0)
		move.w	(a1)+,$40(a0)
		jsr	(Change_FlipXWithVelocity).l
		tst.w	d0
		bne.s	loc_8F4B6
		lea	ObjDat4_8F61C(pc),a1
		jmp	(SetUp_ObjAttributesSlotted).l
; ---------------------------------------------------------------------------

loc_8F4B6:
		lea	ObjDat3_8F63A(pc),a1
		jmp	(SetUp_ObjAttributes).l
; ---------------------------------------------------------------------------
word_8F4C0:	dc.w  $FE00, $FFE0
		dc.w   $200, $FFE0
		dc.w  $FD80, $FFE8
		dc.w   $280, $FFE8
		dc.w  $FD00, $FFF0
		dc.w   $300, $FFF0
; ---------------------------------------------------------------------------

loc_8F4D8:
		lea	byte_8F68E(pc),a1
		jsr	(Animate_RawNoSST).l

loc_8F4E2:
		move.w	$40(a0),d0
		add.w	d0,$1A(a0)
		jmp	(MoveSprite2).l

; =============== S U B R O U T I N E =======================================


sub_8F4F0:

		move.w	$10(a0),d0
		tst.w	$18(a0)
		bmi.s	loc_8F502
		cmpi.w	#$1A0,d0
		bhi.s	loc_8F508
		rts
; ---------------------------------------------------------------------------

loc_8F502:
		cmpi.w	#$A0,d0
		bcc.s	locret_8F512

loc_8F508:
		bchg	#0,4(a0)
		neg.w	$18(a0)

locret_8F512:
		rts
; End of function sub_8F4F0

; ---------------------------------------------------------------------------

loc_8F514:
		move.b	#1,($FFFFFE2A).w
		lea	(SOZ2_Start).l,a1
		move.w	(a1)+,($FFFFFE2E).w
		move.w	(a1)+,($FFFFFE30).w
		jsr	(Save_Level_Data).l
		lea	ChildObjDat_8F64E(pc),a2
		jmp	(CreateChild1_Normal).l

; =============== S U B R O U T I N E =======================================


sub_8F538:
		jsr	(Random_Number).l
		andi.w	#$FF,d0
		subi.w	#$7F,d0
		add.w	d0,$10(a0)
		moveq	#0,d1
		move.b	($FFFFF7C3).w,d1
		add.w	d1,d1
		move.w	word_8F582(pc,d1.w),d2
		cmpi.w	#$120,d0
		bcc.s	loc_8F564
		bset	#0,4(a0)
		neg.w	d2

loc_8F564:
		move.w	d2,$18(a0)
		andi.w	#$C,d1
		move.l	off_8F576(pc,d1.w),$30(a0)
		bra.w	loc_8F58E
; ---------------------------------------------------------------------------
off_8F576:	dc.l byte_8F682
		dc.l byte_8F695
		dc.l byte_8F6AA
word_8F582:	dc.w $FF00
		dc.w $FF00
		dc.w $FF00
		dc.w $FE80
		dc.w $FE80
		dc.w $FE00
; ---------------------------------------------------------------------------

loc_8F58E:

		moveq	#0,d0
		move.b	($FFFFF7C3).w,d0
		add.w	d0,d0
		move.w	word_8F582(pc,d0.w),d1
		tst.w	$18(a0)
		bmi.s	loc_8F5A2
		neg.w	d1

loc_8F5A2:
		move.w	d1,$18(a0)
		add.w	d0,d0
		movea.l	off_8F5C8(pc,d0.w),a1
		bclr	#0,$38(a0)
		jsr	(a1)
		tst.w	$1A(a0)
		bpl.s	loc_8F5C2
		bset	#0,$38(a0)
		neg.w	d0

loc_8F5C2:
		move.w	d0,$1A(a0)
		rts
; End of function sub_8F538

; ---------------------------------------------------------------------------
off_8F5C8:	dc.l loc_8F5E0
		dc.l loc_8F5E0
		dc.l loc_8F5E0
		dc.l loc_8F5F0
		dc.l loc_8F5F0
		dc.l loc_8F606
; ---------------------------------------------------------------------------

loc_8F5E0:
		move.w	#$40,d0
		move.w	d0,$3E(a0)
		move.w	#4,$40(a0)
		rts
; ---------------------------------------------------------------------------

loc_8F5F0:
		move.w	#$80,d0
		move.w	d0,$3E(a0)
		move.w	#8,$40(a0)
		bclr	#0,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_8F606:
		move.w	#$C0,d0
		move.w	d0,$3E(a0)
		move.w	#$10,$40(a0)
		bclr	#0,$38(a0)
		rts
; ---------------------------------------------------------------------------
ObjDat4_8F61C:	dc.w 2

		dc.w $A500
		dc.w $12
		dc.w 0
		dc.l Map_SOZGhosts
		dc.w 0
		dc.b $10
		dc.b $14
		dc.b 0
		dc.b 0
ObjDat3_8F62E:	dc.l Map_EggCapsule
		dc.w $8536
		dc.w $180
		dc.b $30
		dc.b $20
		dc.b 0
		dc.b 0
ObjDat3_8F63A:	dc.l Map_SOZGhosts
		dc.w $A500
		dc.w $200
		dc.b $30
		dc.b $20
		dc.b 0
		dc.b 0
ChildObjDat_8F646:dc.w 0
		dc.l loc_8F438
		dc.w $DC
ChildObjDat_8F64E:dc.w 5
		dc.l loc_8F45E
		dc.w $F8FC
		dc.l loc_8F45E
		dc.w $8FC
		dc.l loc_8F45E
		dc.w $10FC
		dc.l loc_8F45E
		dc.w $F0FC
		dc.l loc_8F45E
		dc.w $18FC
		dc.l loc_8F45E
		dc.w $E8FC
ChildObjDat_8F674:dc.w 0
		dc.l loc_8F11E
DPLCPtr_8F67A:	dc.l ArtUnc_SOZGhosts

		dc.l DPLC_SOZGhosts
byte_8F682:	dc.b  $11,   3
		dc.b  $11,   3
		dc.b  $10,   3
		dc.b   $F,   4
		dc.b   $E,   4
		dc.b  $F8,  $C
byte_8F68E:	dc.b 0
		dc.b 3
		dc.b 1
		dc.b 3
		dc.b 2
		dc.b 4
		dc.b $FC
byte_8F695:	dc.b  $11,   3
		dc.b  $11,   3
		dc.b  $10,   3
		dc.b   $F,   4
		dc.b   $E,   4
		dc.b   $D,   4
		dc.b  $F8,  $E
		dc.b	5,   3
		dc.b	6,   3
		dc.b	7,   4
		dc.b  $FC
byte_8F6AA:	dc.b  $11,   3
		dc.b  $11,   3
		dc.b  $10,   3
		dc.b   $F,   4
		dc.b   $E,   4
		dc.b   $D,   4
		dc.b  $F8,  $E
		dc.b   $A,   3
		dc.b   $B,   3
		dc.b   $C,   4
		dc.b  $FC
byte_8F6BF:	dc.b   $D,   4
		dc.b   $D,   4
		dc.b   $E,   4
		dc.b   $F,   4
		dc.b  $10,   3
		dc.b  $11,   3
		dc.b  $F4
byte_8F6CC:	dc.b	3,   7
		dc.b	3,   7
		dc.b	4,   7
		dc.b  $F8, $D7
byte_8F6D4:	dc.b	8,   7
		dc.b	8,   7
		dc.b	9,   7
		dc.b  $F8, $E4
DPLC_SOZGhosts:	include "General\Sprites\SOZ Ghosts\DPLC - SOZ Ghosts.asm"

; ---------------------------------------------------------------------------

Obj_Fireworm:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8F76A(pc,d0.w),d1
		jsr	off_8F76A(pc,d1.w)
		jmp	(Sprite_CheckDelete).l
; ---------------------------------------------------------------------------
off_8F76A:	dc.w loc_8F770-off_8F76A

		dc.w loc_8F77A-off_8F76A
		dc.w locret_8F7A2-off_8F76A
; ---------------------------------------------------------------------------

loc_8F770:
		lea	ObjDat3_8F9DE(pc),a1
		jmp	(SetUp_ObjAttributes).l
; ---------------------------------------------------------------------------

loc_8F77A:
		jsr	(Find_SonicTails).l
		cmpi.w	#$80,d2
		bcs.s	loc_8F788
		rts
; ---------------------------------------------------------------------------

loc_8F788:
		move.b	#4,5(a0)
		lea	ChildObjDat_8FA0E(pc),a2
		jsr	(CreateChild1_Normal).l
		bne.s	locret_8F7A0
		move.b	$2C(a0),$2C(a1)

locret_8F7A0:
		rts
; ---------------------------------------------------------------------------

locret_8F7A2:
		rts
; ---------------------------------------------------------------------------

loc_8F7A4:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8F7E0(pc,d0.w),d1
		jsr	off_8F7E0(pc,d1.w)
		lea	DPLCPtr_8FA38(pc),a2
		jsr	(Perform_DPLC).l
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_8F7DA
		jsr	(Add_SpriteToCollisionResponseList).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8F7DA:
		jmp	(Go_Delete_SpriteSlotted2).l
; ---------------------------------------------------------------------------
off_8F7E0:	dc.w loc_8F7EA-off_8F7E0

		dc.w loc_8F7F4-off_8F7E0
		dc.w loc_8F812-off_8F7E0
		dc.w loc_8F862-off_8F7E0
		dc.w loc_8F89A-off_8F7E0
; ---------------------------------------------------------------------------

loc_8F7EA:
		lea	ObjDat4_8F9EA(pc),a1
		jsr	(SetUp_ObjAttributesSlotted).l

loc_8F7F4:
		move.b	#4,5(a0)
		move.w	#3,$2E(a0)
		move.l	#loc_8F81E,$34(a0)
		move.w	#-$100,d4
		jmp	(Set_VelocityXTrackSonic).l
; ---------------------------------------------------------------------------

loc_8F812:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_8F81E:
		move.b	#1,$22(a0)
		lea	ChildObjDat_8FA16(pc),a2
		jsr	(CreateChild1_Normal).l

loc_8F82E:
		move.b	#6,5(a0)
		move.w	#-$100,$42(a0)
		move.l	#byte_8FA40,$30(a0)

loc_8F842:
		move.b	#8,$39(a0)
		move.w	#$80,d0
		move.w	d0,$3E(a0)
		move.w	d0,$1A(a0)
		move.w	#8,$40(a0)
		bclr	#0,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_8F862:

		jsr	(Swing_UpAndDown_Count).l
		bne.s	loc_8F876
		jsr	(MoveSprite2).l
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_8F876:
		move.b	#8,5(a0)
		move.w	$18(a0),$44(a0)
		move.w	$42(a0),$1A(a0)
		neg.w	$42(a0)
		clr.w	$2E(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		rts
; ---------------------------------------------------------------------------

loc_8F89A:

		lea	byte_8FA4D(pc),a1
		jsr	(Animate_RawNoSSTMultiDelayFlipX).l
		addq.w	#1,$2E(a0)
		tst.w	$44(a0)
		bmi.s	loc_8F8C6
		move.w	$18(a0),d0
		subi.w	#$10,d0
		cmpi.w	#-$100,d0
		ble.s	loc_8F8DE
		move.w	d0,$18(a0)
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_8F8C6:
		move.w	$18(a0),d0
		addi.w	#$10,d0
		cmpi.w	#$100,d0
		bge.s	loc_8F8DE
		move.w	d0,$18(a0)
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_8F8DE:

		move.b	#6,5(a0)
		clr.b	$23(a0)
		clr.b	$24(a0)
		bra.w	loc_8F842
; ---------------------------------------------------------------------------

loc_8F8F0:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8F906(pc,d0.w),d1
		jsr	off_8F906(pc,d1.w)
		moveq	#0,d0
		jmp	(Child_DrawTouch_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------
off_8F906:	dc.w loc_8F910-off_8F906

		dc.w loc_8F948-off_8F906
		dc.w loc_8F948-off_8F906
		dc.w loc_8F862-off_8F906
		dc.w loc_8F89A-off_8F906
; ---------------------------------------------------------------------------

loc_8F910:
		lea	ObjDat3_8F9FC(pc),a1
		jsr	(SetUp_ObjAttributes).l
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_8F940(pc,d0.w),$2E(a0)
		move.l	#loc_8F94E,$34(a0)
		movea.w	$46(a0),a1
		move.w	$18(a1),$18(a0)
		move.b	4(a1),4(a0)
		rts
; ---------------------------------------------------------------------------
word_8F940:	dc.w $B
		dc.w $16
		dc.w $21
		dc.w $2C
; ---------------------------------------------------------------------------

loc_8F948:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_8F94E:
		lea	ChildObjDat_8FA30(pc),a2
		jsr	(CreateChild1_Normal).l
		bra.w	loc_8F82E
; ---------------------------------------------------------------------------

loc_8F95C:
		jsr	(Refresh_ChildPositionAdjusted).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8F976(pc,d0.w),d1
		jsr	off_8F976(pc,d1.w)
		jmp	(Child_DrawTouch_Sprite).l
; ---------------------------------------------------------------------------
off_8F976:	dc.w loc_8F97C-off_8F976

		dc.w loc_8F99E-off_8F976
		dc.w loc_8F9C8-off_8F976
; ---------------------------------------------------------------------------

loc_8F97C:
		lea	word_8FA08(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#byte_8FA56,$30(a0)
		move.l	#loc_8F9A4,$34(a0)
		bset	#4,$2B(a0)
		rts
; ---------------------------------------------------------------------------

loc_8F99E:
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------

loc_8F9A4:

		move.b	#4,5(a0)
		move.b	#7,$22(a0)
		jsr	(Random_Number).l
		andi.w	#$3F,d0
		move.w	d0,$2E(a0)
		move.l	#loc_8F9CE,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8F9C8:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_8F9CE:
		move.b	#2,5(a0)
		move.l	#loc_8F9A4,$34(a0)
		rts
; ---------------------------------------------------------------------------
ObjDat3_8F9DE:	dc.l Map_FirewormSegments
		dc.w $E512
		dc.w $280
		dc.b $C
		dc.b $C
		dc.b 0
		dc.b 0
ObjDat4_8F9EA:	dc.w 1
		dc.w $A500
		dc.w 9
		dc.w 0
		dc.l Map_Fireworm
		dc.w $180
		dc.b $C
		dc.b $C
		dc.b 0
		dc.b $1A
ObjDat3_8F9FC:	dc.l Map_FirewormSegments
		dc.w $A512
		dc.w $200
		dc.b 8
		dc.b 8
		dc.b 1
		dc.b $98
word_8FA08:	dc.w $180
		dc.b 8
		dc.b 8
		dc.b 3
		dc.b $98
ChildObjDat_8FA0E:dc.w 0
		dc.l loc_8F7A4
		dc.w $F8
ChildObjDat_8FA16:dc.w 3
		dc.l loc_8F8F0
		dc.w 0
		dc.l loc_8F8F0
		dc.w 0
		dc.l loc_8F8F0
		dc.w 0
		dc.l loc_8F8F0
		dc.w 0
ChildObjDat_8FA30:dc.w 0
		dc.l loc_8F95C
		dc.w $F2
DPLCPtr_8FA38:	dc.l ArtUnc_Fireworm
		dc.l DPLC_Fireworm
byte_8FA40:	dc.b	1,   3
		dc.b	1,   6
		dc.b	2,   8
		dc.b	3,   1
		dc.b  $F8,  $A
		dc.b	3, $7F
		dc.b  $FC
byte_8FA4D:	dc.b	3,   7
		dc.b	2,   7
		dc.b  $42,   7
		dc.b	3, $7F
		dc.b  $FC
byte_8FA56:	dc.b	3,   4
		dc.b	4,   5
		dc.b	6, $F4
Map_FirewormSegments:	include "General\Sprites\Fireworm\Map - Fireworm Segments.asm"

DPLC_Fireworm:	include "General\Sprites\Fireworm\DPLC - Fireworm.asm"

Map_Fireworm:	include "General\Sprites\Fireworm\Map - Fireworm.asm"

; ---------------------------------------------------------------------------

Obj_LRZExplodingRock:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8FB3C(pc,d0.w),d1
		jsr	off_8FB3C(pc,d1.w)
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_8FB2A
		btst	#7,$2A(a0)
		bne.s	loc_8FB36
		moveq	#$17,d1
		moveq	#$C,d2
		moveq	#$B,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectFull).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8FB2A:
		jsr	(Displace_PlayerOffObject).l
		jmp	(loc_85088).l
; ---------------------------------------------------------------------------

loc_8FB36:
		jmp	(Displace_PlayerOffObject).l
; ---------------------------------------------------------------------------
off_8FB3C:	dc.w loc_8FB42-off_8FB3C

		dc.w loc_8FB4C-off_8FB3C
		dc.w loc_8FB70-off_8FB3C
; ---------------------------------------------------------------------------

loc_8FB42:
		lea	ObjDat3_8FBC4(pc),a1
		jmp	(SetUp_ObjAttributes).l
; ---------------------------------------------------------------------------

loc_8FB4C:
		jsr	(Find_SonicTails).l
		cmpi.w	#$40,d2
		bcc.s	locret_8FB6E
		move.b	#4,5(a0)
		move.l	#byte_8FC30,$30(a0)
		move.l	#loc_8FB76,$34(a0)

locret_8FB6E:
		rts
; ---------------------------------------------------------------------------

loc_8FB70:
		jmp	(Animate_RawMultiDelay).l
; ---------------------------------------------------------------------------

loc_8FB76:
		move.l	#Obj_Explosion,(a0)
		bset	#7,$2A(a0)
		clr.b	5(a0)
		lea	ChildObjDat_8FBD6(pc),a2
		jmp	(CreateChild2_Complex).l
; ---------------------------------------------------------------------------

loc_8FB90:

		movea.l	$3E(a0),a1
		jsr	(SetUp_ObjAttributes3).l
		bset	#3,$2B(a0)
		move.l	#loc_86D5E,(a0)
		move.b	$2C(a0),d0
		lsr.b	#2,d0
		addq.b	#6,d0
		move.b	d0,$22(a0)
		jmp	(Sprite_CheckDeleteTouchXY).l
; ---------------------------------------------------------------------------

loc_8FBB8:

		jsr	(MoveSprite).l
		jmp	(Animate_Raw).l
; ---------------------------------------------------------------------------
ObjDat3_8FBC4:	dc.l Map_LRZExplodingRock
		dc.w $530
		dc.w $280
		dc.b $C
		dc.b $C
		dc.b 0
		dc.b 0
word_8FBD0:	dc.w $280

		dc.b 8
		dc.b 4
		dc.b 0
		dc.b $98
ChildObjDat_8FBD6:dc.w 3
		dc.l loc_8FB90
		dc.l word_8FBD0
		dc.l byte_8FC8B
		dc.l loc_8FBB8
		dc.b $FC
		dc.b 4
		dc.w $FC00
		dc.w $FE00
		dc.l loc_8FB90
		dc.l word_8FBD0
		dc.l byte_8FC8B
		dc.l loc_8FBB8
		dc.b 4
		dc.b 4
		dc.w $400
		dc.w $FE00
		dc.l loc_8FB90
		dc.l word_8FBD0
		dc.l byte_8FC87
		dc.l loc_8FBB8
		dc.b $F8
		dc.b $F8
		dc.w $FE00
		dc.w $FC00
		dc.l loc_8FB90
		dc.l word_8FBD0
		dc.l byte_8FC87
		dc.l loc_8FBB8
		dc.b 8
		dc.b $F8
		dc.w $200
		dc.w $FC00
byte_8FC30:	dc.b	0,   7
		dc.b	1,   7
		dc.b	2,   7
		dc.b	3, $2F
		dc.b	4,   5
		dc.b	3,   5
		dc.b	4,   4
		dc.b	3,   4
		dc.b	4,   3
		dc.b	3,   3
		dc.b	4,   2
		dc.b	3,   2
		dc.b	4,   1
		dc.b	3,   1
		dc.b	4,   0
		dc.b	3,   0
		dc.b	4,   0
		dc.b	3,   0
		dc.b	4,   0
		dc.b	3,   0
		dc.b	4,   0
		dc.b	3,   0
		dc.b	4,   0
		dc.b	3,   0
		dc.b	4,   0
		dc.b	3,   0
		dc.b	4,   0
		dc.b	3,   0
		dc.b	4,   0
		dc.b	3,   0
		dc.b	4,   0
		dc.b	3,   0
		dc.b	4,   0
		dc.b	3,   0
		dc.b	4,   0
		dc.b	3,   0
		dc.b	4,   0
		dc.b	3,   0
		dc.b	4,   0
		dc.b	3,   0
		dc.b	4,   0
		dc.b	3,   0
		dc.b	5, $1F
		dc.b  $F4
byte_8FC87:	dc.b 0

		dc.b 6
		dc.b 8
		dc.b $FC
byte_8FC8B:	dc.b 0

		dc.b 7
		dc.b 9
		dc.b $FC
		dc.b 0
Map_LRZExplodingRock:include "Levels\LRZ\Misc Object Data\Map - Exploding Rock.asm"

; ---------------------------------------------------------------------------

Obj_Toxomister:

		jsr	(Obj_WaitOffscreen).l
		lea	ObjDat3_9002E(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_8FD76,(a0)
		bset	#6,4(a0)
		move.w	#1,$16(a0)
		lea	$18(a0),a1
		move.w	$10(a0),(a1)+
		move.w	$14(a0),d0
		moveq	#$18,d1
		btst	#1,4(a0)
		beq.s	loc_8FD6A
		neg.w	d1

loc_8FD6A:
		add.w	d1,d0
		move.w	d0,(a1)+
		move.w	#0,(a1)+
		bsr.w	sub_8FF72

loc_8FD76:

		movea.w	$44(a0),a1
		btst	#7,$2A(a1)
		beq.s	loc_8FD96
		move.l	#loc_8FDA0,(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_8FDB0,$34(a0)

loc_8FD96:
		bsr.w	sub_8FF5A
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------

loc_8FDA0:
		bsr.w	sub_8FF5A
		jsr	(Obj_Wait).l
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------

loc_8FDB0:
		move.l	#loc_8FD76,(a0)
		bra.w	sub_8FF72
; ---------------------------------------------------------------------------

loc_8FDBA:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_8FDCE(pc,d0.w),d1
		jsr	off_8FDCE(pc,d1.w)
		jmp	(Child_AddToTouchList).l
; ---------------------------------------------------------------------------
off_8FDCE:	dc.w loc_8FDD8-off_8FDCE

		dc.w loc_8FE06-off_8FDCE
		dc.w loc_8FE26-off_8FDCE
		dc.w loc_8FE06-off_8FDCE
		dc.w loc_8FE50-off_8FDCE
; ---------------------------------------------------------------------------

loc_8FDD8:
		lea	word_9003A(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.b	#-$28,$28(a0)
		move.b	#$18,$1E(a0)
		move.w	#$6F,$2E(a0)
		move.l	#loc_8FE10,$34(a0)
		lea	ChildObjDat_90048(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_8FE06:
		bsr.w	sub_8FF8C
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_8FE10:
		move.b	#4,5(a0)
		move.w	#$40,$1A(a0)
		move.l	#loc_8FE36,$34(a0)

locret_8FE24:

		rts
; ---------------------------------------------------------------------------

loc_8FE26:
		bsr.w	sub_8FF8C
		jsr	(MoveSprite2).l
		jmp	(ObjHitFloor_DoRoutine).l
; ---------------------------------------------------------------------------

loc_8FE36:
		move.b	#6,5(a0)
		clr.w	$1A(a0)
		move.w	#$7F,$2E(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_8FE50:
		movea.w	$44(a0),a1
		cmpi.b	#9,$20(a1)
		beq.s	loc_8FE82
		jsr	(Check_LRControllerShake).l
		bne.s	loc_8FE88
		movea.w	$44(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		bsr.w	sub_8FFE0
		jsr	(sub_881FE).l
		beq.w	locret_8FE24

loc_8FE82:
		bset	#2,$38(a0)

loc_8FE88:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_8FE8E:

		lea	word_9003A(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_8FEC8,(a0)
		move.l	#byte_90074,$30(a0)
		move.b	$2C(a0),d0
		subi.b	#$C,d0
		neg.b	d0
		move.b	d0,$2C(a0)
		lsl.b	#2,d0
		move.b	d0,$2F(a0)
		move.l	#loc_8FED4,$34(a0)
		jmp	(Child_CheckParent).l
; ---------------------------------------------------------------------------

loc_8FEC8:
		jsr	(Obj_Wait).l
		jmp	(Child_CheckParent).l
; ---------------------------------------------------------------------------

loc_8FED4:
		move.l	#loc_8FEDC,(a0)
		rts
; ---------------------------------------------------------------------------

loc_8FEDC:
		movea.w	$46(a0),a1
		btst	#7,$2A(a1)
		bne.s	loc_8FF12
		jsr	(Refresh_ChildPosition).l
		jsr	(Animate_Raw).l
		btst	#0,($FFFFFE0F).w
		sne	d0
		btst	#0,$2C(a0)
		beq.s	loc_8FF06
		not.b	d0

loc_8FF06:
		tst.b	d0
		bne.w	locret_8FE24
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_8FF12:
		clr.w	$18(a0)
		btst	#2,$38(a1)
		beq.s	loc_8FF22
		bsr.w	loc_90002

loc_8FF22:
		clr.w	$1A(a0)
		move.l	#loc_8FF42,(a0)
		move.l	#byte_90085,$30(a0)
		move.l	#Go_Delete_Sprite,$34(a0)
		jmp	(Sprite_CheckDeleteXY).l
; ---------------------------------------------------------------------------

loc_8FF42:
		addi.w	#-$10,$1A(a0)
		jsr	(MoveSprite2).l
		jsr	(Animate_Raw).l
		jmp	(Sprite_CheckDeleteXY).l

; =============== S U B R O U T I N E =======================================


sub_8FF5A:

		move.b	($FFFFFE0F).w,d0
		andi.b	#7,d0
		bne.w	locret_8FE24
		jsr	(Find_SonicTails).l
		jmp	(Change_FlipX).l
; End of function sub_8FF5A


; =============== S U B R O U T I N E =======================================


sub_8FF72:

		moveq	#-$69,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_90040(pc),a2
		jsr	(CreateChild10_NormalAdjusted).l
		bne.s	locret_8FF8A
		move.w	a1,$44(a0)

locret_8FF8A:
		rts
; End of function sub_8FF72


; =============== S U B R O U T I N E =======================================


sub_8FF8C:

		move.b	$29(a0),d0
		beq.w	locret_8FE24
		clr.b	$29(a0)
		andi.w	#3,d0
		lsl.w	#2,d0
		lea	loc_8FFCC+4(pc,d0.w),a1
		movea.w	(a1)+,a2
		cmpi.b	#2,$20(a2)
		beq.w	locret_8FE24
		btst	#6,$2B(a2)
		bne.w	locret_8FE24
		move.w	a2,$44(a0)
		movea.w	(a1)+,a2
		move.w	a2,$3E(a0)
		move.w	(a2),$3A(a0)
		move.b	#8,5(a0)

loc_8FFCC:
		move.w	#$3B,$2E(a0)
		rts
; End of function sub_8FF8C

; ---------------------------------------------------------------------------
		dc.w  $B000, $F604
		dc.w  $B04A, $F606
		dc.w  $B000, $F604

; =============== S U B R O U T I N E =======================================


sub_8FFE0:
		move.w	$18(a1),d0
		asr.w	#3,d0
		sub.w	d0,$18(a1)
		moveq	#$1C,d0
		btst	#1,$2A(a1)
		beq.s	loc_8FFF6
		moveq	#$1A,d0

loc_8FFF6:
		move.w	(a1,d0.w),d1
		asr.w	#3,d1
		sub.w	d1,(a1,d0.w)
		rts
; End of function sub_8FFE0

; ---------------------------------------------------------------------------

loc_90002:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	byte_90020(pc,d0.w),d0
		movea.w	$44(a1),a2
		btst	#0,4(a2)
		bne.s	loc_9001A
		neg.w	d0

loc_9001A:
		move.w	d0,$18(a0)
		rts
; ---------------------------------------------------------------------------
byte_90020:	dc.b	1,   0,	  1, $80
		dc.b	2,   0,	  1, $80
		dc.b	1,   0,	  2,   0
		dc.b	1, $80
ObjDat3_9002E:	dc.l Map_Toxomister
		dc.w $A562
		dc.w $280
		dc.b 8
		dc.b 8
		dc.b 1
		dc.b $18
word_9003A:	dc.w 0

		dc.b 8
		dc.b 8
		dc.b 2
		dc.b 0
ChildObjDat_90040:dc.w 0
		dc.l loc_8FDBA
		dc.w $F408
ChildObjDat_90048:dc.w 6
		dc.l loc_8FE8E
		dc.w $F404
		dc.l loc_8FE8E
		dc.w $C04
		dc.l loc_8FE8E
		dc.w $F8FC
		dc.l loc_8FE8E
		dc.w $8FC
		dc.l loc_8FE8E
		dc.w $FC
		dc.l loc_8FE8E
		dc.w $FC04
		dc.l loc_8FE8E
		dc.w $404
byte_90074:	dc.b 7
		dc.b 2
		dc.b 3
		dc.b 4
		dc.b 5
		dc.b 6
		dc.b 7
		dc.b $F8
		dc.b 9
		dc.b 7
		dc.b 6
		dc.b 5
		dc.b 4
		dc.b 5
		dc.b 6
		dc.b 7
		dc.b $FC
byte_90085:	dc.b 7
		dc.b 7
		dc.b 6
		dc.b 5
		dc.b 4
		dc.b 3
		dc.b 2
		dc.b $F4
		dc.b 0
Map_Toxomister:	include "General\Sprites\Toxomister\Map - Toxomister.asm"

; ---------------------------------------------------------------------------

Obj_LRZRockCrusher:
		lea	word_901B8(pc),a1
		tst.b	$2C(a0)
		beq.s	loc_900FE
		lea	word_901C4(pc),a1

loc_900FE:
		jsr	(Check_CameraInRange).l
		move.l	#loc_901D0,(a0)
		move.w	($FFFFEE18).w,($FFFFFA96).w
		move.w	($FFFFEE12).w,($FFFFFA98).w
		move.w	($FFFFEE14).w,($FFFFFA94).w
		move.w	($FFFFEE16).w,($FFFFFA92).w
		move.w	(a1),$1C(a0)
		move.w	(a1)+,($FFFFEE16).w
		move.w	(a1)+,($FFFFEE12).w
		lea	ObjDat3_90608(pc),a1
		jsr	(SetUp_ObjAttributes).l
		clr.b	5(a0)
		move.b	#-1,$29(a0)
		move.b	#$40,$1E(a0)
		tst.b	$2C(a0)
		beq.s	loc_90154
		bset	#7,$A(a0)

loc_90154:
		lea	ChildObjDat_9067A(pc),a2
		jsr	(CreateChild6_Simple).l
		bne.s	loc_90188
		move.b	#-$75,$2C(a1)
		tst.b	$2C(a0)
		bne.s	loc_9017C
		move.w	#$F40,$10(a1)
		move.w	#$760,$14(a1)
		bra.w	loc_90188
; ---------------------------------------------------------------------------

loc_9017C:
		move.w	#$540,$10(a1)
		move.w	#$860,$14(a1)

loc_90188:

		lea	(ArtKosM_LRZRockCrusher).l,a1
		move.w	#-$5A40,d2
		jsr	(Queue_Kos_Module).l
		lea	(PLC_83D64).l,a1
		jsr	(Load_PLC_Raw).l
		lea	Pal_LRZRockCrusher(pc),a1
		jsr	(PalLoad_Line1).l
		lea	ChildObjDat_90626(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------
word_901B8:	dc.w $5E0
		dc.w $740
		dc.w $DC0
		dc.w $EC0
		dc.w $EA0
		dc.w $6A0
word_901C4:	dc.w $680
		dc.w $880
		dc.w $400
		dc.w $780
		dc.w $4A0
		dc.w $790
; ---------------------------------------------------------------------------

loc_901D0:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_901EA(pc,d0.w),d1
		jsr	off_901EA(pc,d1.w)
		jsr	(sub_905A8).l
		jmp	(Draw_And_Touch_Sprite).l
; ---------------------------------------------------------------------------
off_901EA:	dc.w loc_901F4-off_901EA

		dc.w loc_9026E-off_901EA
		dc.w loc_902F0-off_901EA
		dc.w loc_902FE-off_901EA
		dc.w loc_90338-off_901EA
; ---------------------------------------------------------------------------

loc_901F4:
		btst	#0,$27(a0)
		bne.s	loc_90210
		move.w	($FFFFEE12).w,d0
		cmp.w	($FFFFEE1A).w,d0
		bne.s	loc_90210
		move.w	d0,($FFFFEE18).w
		bset	#0,$27(a0)

loc_90210:

		btst	#1,$27(a0)
		bne.s	loc_9022E
		move.w	($FFFFEE78).w,($FFFFEE14).w
		move.w	$1C(a0),d0
		cmp.w	($FFFFEE78).w,d0
		bhi.s	loc_9022E
		bset	#1,$27(a0)

loc_9022E:

		move.b	$27(a0),d0
		andi.b	#3,d0
		cmpi.b	#3,d0
		bne.s	locret_9026C
		move.b	#2,5(a0)
		clr.b	$27(a0)
		clr.w	$1C(a0)
		clr.b	$26(a0)
		bset	#2,$38(a0)
		jsr	(Create_New_Sprite).l
		bne.s	locret_9026C
		move.l	#loc_90502,(a1)
		move.b	$2C(a0),$2C(a1)
		move.w	a0,$46(a1)

locret_9026C:

		rts
; ---------------------------------------------------------------------------

loc_9026E:
		moveq	#-$34,d0
		jsr	(sub_85E52).l
		moveq	#1,d0
		bchg	#0,$38(a0)
		beq.s	loc_90282
		neg.w	d0

loc_90282:
		add.w	d0,$14(a0)
		jsr	(ObjHitFloor).l
		tst.w	d1
		bpl.s	loc_902BE
		move.w	$10(a0),d0
		andi.w	#-$80,d0
		sub.w	($FFFFF7DA).w,d0
		cmpi.w	#$280,d0
		bhi.s	loc_902B6
		move.w	$14(a0),d0
		sub.w	($FFFFEE7C).w,d0
		addi.w	#$80,d0
		cmpi.w	#$200,d0
		bls.w	locret_9026C

loc_902B6:
		clr.b	($FFFFEECC).w
		bra.w	loc_90368
; ---------------------------------------------------------------------------

loc_902BE:
		move.b	#4,5(a0)
		ori.b	#$28,$38(a0)
		move.w	#$27,$2E(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	word_902EC(pc,d0.w),$3A(a0)
		move.w	($FFFFFA98).w,($FFFFEE12).w
		lea	Child7_ChangeLevSize(pc),a2
		jmp	(CreateChild7_Normal2).l
; ---------------------------------------------------------------------------
word_902EC:	dc.w $850
		dc.w $950
; ---------------------------------------------------------------------------

loc_902F0:
		subq.w	#1,$2E(a0)
		bpl.s	locret_902FC
		move.b	#6,5(a0)

locret_902FC:
		rts
; ---------------------------------------------------------------------------

loc_902FE:
		jsr	(MoveSprite).l
		move.w	$14(a0),d0
		cmp.w	$3A(a0),d0
		bcc.s	loc_90310
		rts
; ---------------------------------------------------------------------------

loc_90310:
		move.b	#8,5(a0)
		move.w	#$40,$1A(a0)
		move.w	#$7F,$2E(a0)
		move.l	#loc_90352,$34(a0)
		lea	(Child6_CreateBossExplosion).l,a2
		jsr	(CreateChild6_Simple).l
		rts
; ---------------------------------------------------------------------------

loc_90338:
		cmpi.w	#$40,$2E(a0)
		bne.s	loc_90346
		bset	#7,$2A(a0)

loc_90346:
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_90352:
		move.l	#Obj_Wait,(a0)
		move.w	#$BF,$2E(a0)
		move.l	#loc_90368,$34(a0)
		rts
; ---------------------------------------------------------------------------

loc_90368:

		lea	(ArtKosM_FirewormSegments).l,a1
		move.w	#-$5DC0,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_Iwamodoki).l,a1
		move.w	#-$5A00,d2
		jsr	(Queue_Kos_Module).l
		lea	(Pal_LRZ1).l,a1
		jsr	(PalLoad_Line1).l
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_9039A:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_903C2(pc,d0.w),d1
		jsr	off_903C2(pc,d1.w)
		cmpi.b	#8,$2C(a0)
		bcs.s	loc_903BA
		move.b	#-1,$29(a0)
		bsr.w	sub_905A8

loc_903BA:
		moveq	#0,d0
		jmp	(Child_DrawTouch_Sprite_FlickerMove).l
; ---------------------------------------------------------------------------
off_903C2:	dc.w loc_903CC-off_903C2

		dc.w loc_903F4-off_903C2
		dc.w loc_90408-off_903C2
		dc.w loc_90436-off_903C2
		dc.w loc_904B4-off_903C2
; ---------------------------------------------------------------------------

loc_903CC:
		lea	word_90614(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.b	$2C(a0),d0
		cmpi.b	#8,d0
		bcs.s	loc_903EC
		move.b	#2,$22(a0)
		move.b	#$12,$28(a0)

loc_903EC:
		andi.b	#4,d0
		move.b	d0,$2E(a0)

loc_903F4:
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		beq.w	locret_9026C
		move.b	#4,5(a0)

loc_90408:
		subq.b	#1,$2E(a0)
		bmi.s	loc_90426
		movea.w	$46(a0),a1
		btst	#3,$38(a1)
		beq.s	loc_90420
		move.b	#8,5(a0)

loc_90420:
		jmp	(Refresh_ChildPosition).l
; ---------------------------------------------------------------------------

loc_90426:
		move.b	#6,5(a0)
		move.b	#2,$39(a0)
		clr.b	$40(a0)

loc_90436:
		move.b	$40(a0),d0
		add.b	d0,$43(a0)
		subq.b	#1,$2E(a0)
		bpl.s	loc_9048A
		subq.b	#1,$39(a0)
		bmi.s	loc_90490
		move.b	$2C(a0),d3
		andi.w	#8,d3
		bne.s	loc_9046E
		btst	#2,$38(a0)
		beq.s	loc_9046E
		bchg	#1,$38(a0)
		bne.s	loc_9046E
		lea	ChildObjDat_90658(pc),a2
		jsr	(CreateChild3_NormalRepeated).l

loc_9046E:

		lsr.w	#1,d3
		moveq	#0,d1
		bchg	#2,$38(a0)
		beq.s	loc_9047C
		moveq	#2,d1

loc_9047C:
		add.w	d1,d3
		lea	byte_904AC(pc,d3.w),a1
		move.b	(a1)+,$2E(a0)
		move.b	(a1)+,$40(a0)

loc_9048A:
		jmp	(Refresh_ChildPosition).l
; ---------------------------------------------------------------------------

loc_90490:
		move.b	#4,5(a0)
		move.b	$2C(a0),d0
		andi.b	#8,d0
		lsr.b	#1,d0
		addq.b	#4,d0
		move.b	d0,$2E(a0)
		jmp	(Refresh_ChildPosition).l
; ---------------------------------------------------------------------------
byte_904AC:	dc.b	1,   8
		dc.b	3, $FC
		dc.b	3, $FC
		dc.b	7,   2
; ---------------------------------------------------------------------------

loc_904B4:
		jmp	(Refresh_ChildPosition).l
; ---------------------------------------------------------------------------

loc_904BA:
		lea	ObjDat3_9061A(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_43A6C,(a0)
		bset	#7,4(a0)
		jsr	(Random_Number).l
		andi.w	#$1FF,d0
		move.w	#$200,d1
		tst.b	$2C(a0)
		beq.s	loc_904E8
		neg.w	d0
		neg.w	d1

loc_904E8:
		add.w	d1,d0
		move.w	d0,$18(a0)
		swap	d0
		andi.w	#$1FF,d0
		move.w	#$300,d1
		add.w	d1,d0
		neg.w	d0
		move.w	d0,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_90502:
		move.l	#loc_90512,(a0)
		move.w	#$B3,$2E(a0)
		st	($FFFFEECC).w

loc_90512:
		subq.w	#1,$2E(a0)
		bpl.w	locret_9026C
		tst.b	$2C(a0)
		bne.s	loc_9056E
		st	($FFFFEEDE).w
		clr.b	($FFFFEECC).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_90548
		move.l	#Obj_LRZCollapsingBridge,(a1)
		move.b	#1,$32(a1)
		move.w	#$F00,$10(a1)
		move.w	#$760,$14(a1)

loc_90548:
		jsr	(Create_New_Sprite).l
		bne.s	loc_90568
		move.l	#Obj_LRZCollapsingBridge,(a1)
		move.b	#1,$32(a1)
		move.w	#$F80,$10(a1)
		move.w	#$760,$14(a1)

loc_90568:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_9056E:
		st	($FFFFEEDF).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_90592
		move.l	#Obj_LRZCollapsingBridge,(a1)
		move.b	#1,$32(a1)
		move.w	#$540,$10(a1)
		move.w	#$860,$14(a1)

loc_90592:
		move.w	($FFFFFA98).w,($FFFFEE12).w
		lea	Child7_ChangeLevSize(pc),a2
		jsr	(CreateChild7_Normal2).l
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_905A8:

		tst.b	$28(a0)
		bne.s	locret_905E6
		tst.b	$20(a0)
		bne.s	loc_905C8
		move.b	#$20,$20(a0)
		moveq	#$6E,d0
		jsr	(Play_Sound_2).l
		move.b	#-1,$29(a0)

loc_905C8:
		moveq	#0,d0
		btst	#0,$20(a0)
		bne.s	loc_905D6
		addi.w	#6,d0

loc_905D6:
		bsr.w	sub_905E8
		subq.b	#1,$20(a0)
		bne.s	locret_905E6
		move.b	$25(a0),$28(a0)

locret_905E6:

		rts
; End of function sub_905A8


; =============== S U B R O U T I N E =======================================


sub_905E8:
		lea	word_905F6(pc),a1
		lea	word_905FC(pc,d0.w),a2
		jmp	(CopyWordData_3).l
; End of function sub_905E8

; ---------------------------------------------------------------------------
word_905F6:	dc.w $FC36
		dc.w $FC3A
		dc.w $FC3C
word_905FC:	dc.w $20
		dc.w $866
		dc.w $644
		dc.w $EEE
		dc.w $AAA
		dc.w $CCC
ObjDat3_90608:	dc.l Map_LRZRockCrusher
		dc.w $252E
		dc.w $180
		dc.b $80
		dc.b $40
		dc.b 0
		dc.b $10
word_90614:	dc.w $200
		dc.b $C
		dc.b $14
		dc.b 1
		dc.b $8B
ObjDat3_9061A:	dc.l Map_LRZRockDebris
		dc.w $C0D3
		dc.w 0
		dc.b 4
		dc.b 4
		dc.b 0
		dc.b 0
ChildObjDat_90626:dc.w 7
		dc.l loc_9039A
		dc.w $E41C
		dc.l loc_9039A
		dc.w $1C1C
		dc.l loc_9039A
		dc.w $DC1C
		dc.l loc_9039A
		dc.w $241C
		dc.l loc_9039A
		dc.w $E4DC
		dc.l loc_9039A
		dc.w $1CDC
		dc.l loc_9039A
		dc.w $DCDC
		dc.l loc_9039A
		dc.w $24DC
ChildObjDat_90658:dc.w 1
		dc.l loc_904BA
		dc.w $C
Child7_ChangeLevSize:dc.w 3

		dc.l Obj_DecLevStartYGradual
		dc.w 0
		dc.l Obj_IncLevEndYGradual
		dc.w 0
		dc.l Obj_DecLevStartXGradual
		dc.w 0
		dc.l Obj_IncLevEndXGradual
		dc.w 0
ChildObjDat_9067A:dc.w 0
		dc.l Obj_8B
Pal_LRZRockCrusher:	binclude "Levels\LRZ\Palettes\Rock Crusher.bin"

; ---------------------------------------------------------------------------

Obj_B0_2:

		lea	ObjDat3_90FAC(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_90700,(a0)
		move.w	a0,($FFFFFABA).w
		move.b	#-$10,($FFFFFABC).w
		move.b	#-$18,($FFFFFABD).w
		lea	(off_914CE).l,a1
		lea	($FFFFFADE).w,a2
		move.l	(a1)+,(a2)+
		move.l	(a1)+,(a2)+
		clr.w	(a2)
		move.w	#$1640,$10(a0)
		move.w	#$340,$14(a0)
		move.w	#$1F3F,($FFFFF634).w
		lea	($FFFFFFB2).w,a1
		moveq	#3,d0
		moveq	#6,d1

loc_906EA:
		cmp.b	(a1)+,d0
		bne.s	loc_90700
		dbf	d1,loc_906EA
		st	$26(a0)
		lea	ChildObjDat_90FE4(pc),a2
		jsr	(CreateChild6_Simple).l

loc_90700:

		tst.b	4(a0)
		bpl.s	loc_9072E
		tst.b	$26(a0)
		bne.s	loc_9071A
		move.l	#$6A00660,($FFFFFC62).w
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------

loc_9071A:
		tst.b	($FFFFFAC1).w
		bne.s	loc_9072E
		lea	off_914CE(pc),a1
		lea	($FFFFFC62).w,a2
		jsr	(Run_PalRotationScript2).l

loc_9072E:

		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------

loc_90734:
		lea	word_90FB8(pc),a1
		jsr	(SetUp_ObjAttributes2).l
		move.l	#loc_90744,(a0)

loc_90744:
		movea.w	$46(a0),a1
		move.w	$10(a1),$10(a0)
		move.w	$14(a1),$14(a0)
		moveq	#0,d0
		move.b	$3B(a1),d0
		lsr.w	#1,d0
		move.b	RawAni_90768(pc,d0.w),$22(a0)
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------
RawAni_90768:	dc.b  $1D, $1D,	$1D,  $C,  $D,	$E, $1D,  $F, $10, $11,	$1D, $1D
; ---------------------------------------------------------------------------

Obj_B4_2:

		lea	ObjDat3_90FC0(pc),a1
		jsr	(SetUp_ObjAttributes).l
		moveq	#0,d0
		move.b	$2C(a0),d0
		lea	($FFFFFFB2).w,a1
		moveq	#0,d1
		move.b	(a1,d0.w),d1
		move.w	d1,d2
		add.w	d2,d2
		move.w	off_9079A(pc,d2.w),d2
		jmp	off_9079A(pc,d2.w)
; ---------------------------------------------------------------------------
off_9079A:	dc.w loc_907A2-off_9079A

		dc.w loc_907A8-off_9079A
		dc.w loc_907A8-off_9079A
		dc.w loc_907DE-off_9079A
; ---------------------------------------------------------------------------

loc_907A2:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_907A8:
		move.l	#loc_908DE,(a0)
		move.w	#-$7B89,$A(a0)
		bset	#0,$38(a0)
		bsr.w	sub_9084E
		bsr.w	sub_90832
		btst	#7,$38(a0)
		beq.s	loc_907D8
		move.l	#loc_90880,(a0)
		move.b	d0,$22(a0)
		bsr.w	sub_907FA

loc_907D8:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_907DE:
		move.b	d0,$22(a0)
		move.l	#loc_9089E,(a0)
		bsr.w	sub_9084E
		bsr.w	sub_90832
		bsr.w	sub_907FA
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_907FA:

		move.w	d0,d1
		lsl.w	#2,d1
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_90808
		addq.w	#2,d1

loc_90808:
		move.w	word_90816(pc,d1.w),d0
		move.w	d0,$A(a0)
		move.w	d0,$3A(a0)
		rts
; End of function sub_907FA

; ---------------------------------------------------------------------------
word_90816:	dc.w $C3B5
		dc.w $C3B5
		dc.w $83B5
		dc.w $A3B5
		dc.w $C3B5
		dc.w $C3B5
		dc.w $83B5
		dc.w $A3B5
		dc.w $83B5
		dc.w $83B5
		dc.w $A3B5
		dc.w $83B5
		dc.w $E3B5
		dc.w $E3B5

; =============== S U B R O U T I N E =======================================


sub_90832:

		move.w	d0,d1
		add.w	d1,d1
		move.w	word_9083E(pc,d1.w),8(a0)
		rts
; End of function sub_90832

; ---------------------------------------------------------------------------
word_9083E:	dc.w $200
		dc.w $80
		dc.w $80
		dc.w $200
		dc.w $200
		dc.w $200
		dc.w $200
		dc.w $200

; =============== S U B R O U T I N E =======================================


sub_9084E:

		move.w	d0,d1
		lsl.w	#2,d1
		lea	word_90860(pc,d1.w),a1
		move.w	(a1)+,$10(a0)
		move.w	(a1)+,$14(a0)
		rts
; End of function sub_9084E

; ---------------------------------------------------------------------------
word_90860:	dc.w  $1640,  $368
		dc.w  $15E0,  $3A0
		dc.w  $16A0,  $3A0
		dc.w  $15A0,  $350
		dc.w  $16E0,  $350
		dc.w  $1550,  $390
		dc.w  $1730,  $390
		dc.w  $1640,  $3AC
; ---------------------------------------------------------------------------

loc_90880:
		btst	#5,$38(a0)
		beq.s	loc_9089E
		move.l	#loc_908DE,(a0)
		move.b	#$1E,$22(a0)
		move.w	#-$7B89,$A(a0)
		bra.w	loc_908DE
; ---------------------------------------------------------------------------

loc_9089E:

		move.b	($FFFFFAC0).w,d0
		bpl.s	loc_908BE
		bclr	#7,d0
		cmp.b	$2C(a0),d0
		bne.s	loc_908BE
		move.b	#$1E,$22(a0)
		move.w	#-$7B89,$A(a0)
		bra.w	loc_908DE
; ---------------------------------------------------------------------------

loc_908BE:

		move.b	$2C(a0),$22(a0)
		move.w	$3A(a0),$A(a0)
		btst	#0,($FFFFFE0F).w
		beq.s	loc_908DE
		move.b	#7,$22(a0)
		move.w	#-$7C4B,$A(a0)

loc_908DE:

		move.w	#$1B,d1
		move.w	#$10,d2
		move.w	#$10,d3
		move.w	$10(a0),d4
		jsr	(SolidObjectTop).l
		btst	#3,$2A(a0)
		beq.s	loc_90920
		btst	#0,$38(a0)
		beq.s	loc_90920
		move.l	#loc_90926,(a0)
		move.w	#$F,$2E(a0)
		lea	($FFFFB000).w,a1
		move.b	#-$7F,$2E(a1)
		move.w	#$500,$20(a1)

loc_90920:

		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_90926:
		subq.w	#1,$2E(a0)
		bpl.s	loc_9095E
		moveq	#-$51,d0
		jsr	(Play_Sound_2).l
		move.b	$2C(a0),($FFFFFE16).w
		move.b	#1,($FFFFFE48).w
		move.b	#$34,($FFFFF600).w
		move.b	#1,($FFFFFF97).w
		move.b	#1,($FFFFFFBB).w
		move.b	($FFFFFE49).w,($FFFFFE2A).w
		move.b	($FFFFB02B).w,($FFFFFF96).w

loc_9095E:
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

Obj_B5_2:
		lea	(ArtKosM_HPZSmallEmeralds).l,a1
		move.w	#-$6A80,d2
		jsr	(Queue_Kos_Module).l
		lea	(ArtKosM_Teleporter).l,a1
		move.w	#-$6F00,d2
		jsr	(Queue_Kos_Module).l
		lea	(Pal_CutsceneKnux1).l,a1
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_90998
		lea	(Pal_SonicTails).l,a1

loc_90998:
		lea	($FFFFFCA0).w,a2
		moveq	#7,d0

loc_9099E:
		move.l	(a1)+,(a2)+
		dbf	d0,loc_9099E
		lea	(Pal_HPZ2_B).l,a1
		lea	($FFFFFCC0).w,a2
		moveq	#$F,d6

loc_909B0:
		move.l	(a1)+,(a2)+
		dbf	d6,loc_909B0
		move.l	#$6A00660,($FFFFFCE2).w
		jsr	(Create_New_Sprite).l
		bne.s	loc_909CC
		move.l	#Obj_B0_2,(a1)

loc_909CC:
		jsr	(Create_New_Sprite).l
		bne.s	loc_909EA
		move.l	#Obj_SSZHPZTeleporter,(a1)
		move.w	#$1640,$10(a1)
		move.w	#$3C7,$14(a1)
		move.w	a1,$44(a0)

loc_909EA:
		tst.w	($FFFFEF6C).w
		beq.s	loc_90A10
		moveq	#0,d2
		moveq	#6,d3

loc_909F4:
		jsr	(Create_New_Sprite).l
		move.l	#Obj_B4_2,(a1)
		move.b	d2,$2C(a1)
		addq.w	#1,d2
		dbf	d3,loc_909F4

loc_90A0A:
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_90A10:
		move.l	#loc_90A72,(a0)
		move.w	#$1F,$2E(a0)
		lea	($FFFFFFB2).w,a2
		moveq	#2,d1
		moveq	#0,d2
		moveq	#6,d3

loc_90A26:
		cmp.b	(a2)+,d1
		bhi.s	loc_90A3A
		jsr	(Create_New_Sprite).l
		move.l	#Obj_B4_2,(a1)
		move.b	d2,$2C(a1)

loc_90A3A:
		addq.w	#1,d2
		dbf	d3,loc_90A26
		lea	($FFFFB000).w,a1
		bsr.w	sub_90A4C
		lea	($FFFFB04A).w,a1

; =============== S U B R O U T I N E =======================================


sub_90A4C:
		move.b	#-$7D,$2E(a1)
		bset	#7,$A(a1)
		move.b	#0,$22(a1)
		move.b	#$1C,$20(a1)
		move.w	#$1640,$10(a1)
		move.w	#$3A3,$14(a1)
		rts
; End of function sub_90A4C

; ---------------------------------------------------------------------------

loc_90A72:
		subq.w	#1,$2E(a0)
		bpl.s	locret_90A92
		move.l	#loc_90A94,(a0)
		jsr	(Create_New_Sprite).l
		bne.s	locret_90A92
		move.l	#loc_90CA2,(a1)
		move.b	#7,$2C(a1)

locret_90A92:

		rts
; ---------------------------------------------------------------------------

loc_90A94:
		bclr	#0,($FFFFFAB8).w
		beq.w	locret_90C32
		lea	($FFFFFFB2).w,a1
		lea	byte_90B1A(pc),a2
		lea	($FFFFFA82).w,a3
		lea	word_90B0C(pc),a4
		lea	($FFFFFAB0).w,a5
		moveq	#0,d0
		moveq	#0,d1
		moveq	#0,d2
		moveq	#6,d3

loc_90ABA:
		move.b	(a2)+,d0
		move.b	(a1,d0.w),d4
		beq.s	loc_90AD2
		cmpi.b	#1,d4
		bne.s	loc_90AD2
		move.b	d0,(a5)+
		add.w	d0,d0
		move.w	(a4,d0.w),(a3)+
		moveq	#1,d1

loc_90AD2:

		cmpi.b	#2,d4
		bne.s	loc_90ADA
		moveq	#1,d2

loc_90ADA:
		dbf	d3,loc_90ABA
		clr.w	(a3)
		tst.w	d1
		bne.s	loc_90AF2
		tst.w	d2
		bne.s	loc_90AEE
		bset	#5,$38(a0)

loc_90AEE:
		bra.w	loc_90C16
; ---------------------------------------------------------------------------

loc_90AF2:
		move.l	#loc_90B22,(a0)
		move.w	#$21F,$2E(a0)
		st	($FFFFFFBA).w
		lea	word_90FEA(pc),a2
		jmp	(CreateChild6_Simple).l
; ---------------------------------------------------------------------------
word_90B0C:	dc.w $15A0
		dc.w $1540
		dc.w $1600
		dc.w $1520
		dc.w $1620
		dc.w $1520
		dc.w $1620
byte_90B1A:	dc.b 5
		dc.b 3
		dc.b 1
		dc.b 0
		dc.b 2
		dc.b 4
		dc.b 6
		dc.b 0
; ---------------------------------------------------------------------------

loc_90B22:
		subq.w	#1,$2E(a0)
		bpl.w	locret_90C32
		move.l	#loc_90BF4,$34(a0)

loc_90B32:
		move.l	#loc_90BD2,(a0)
		st	($FFFFEE0A).w
		moveq	#0,d0
		move.b	$39(a0),d0
		addq.b	#1,$39(a0)
		lea	($FFFFFAB0).w,a1
		moveq	#0,d1
		move.b	(a1,d0.w),d1
		move.b	d1,$3C(a0)
		add.w	d0,d0
		lea	($FFFFFA82).w,a1
		move.w	(a1,d0.w),$3A(a0)
		bne.s	loc_90B72
		move.l	#loc_90C16,$34(a0)
		move.w	#$15A0,$3A(a0)
		moveq	#2,d1

loc_90B72:
		add.w	d1,d1
		lea	byte_90BBC(pc,d1.w),a2
		lea	($FFFFB000).w,a1
		bsr.w	sub_90B84
		lea	($FFFFB04A).w,a1

; =============== S U B R O U T I N E =======================================


sub_90B84:
		bclr	#0,4(a1)
		bclr	#0,$2A(a1)
		tst.b	(a2)
		beq.s	loc_90BA0
		bset	#0,4(a1)
		bset	#0,$2A(a1)

loc_90BA0:
		moveq	#0,d0
		move.b	1(a2),d0
		add.b	$38(a1),d0
		move.b	RawAni_90BCA(pc,d0.w),$22(a1)
		move.l	a2,-(sp)
		jsr	(Player_Load_PLC2).l
		movea.l	(sp)+,a2
		rts
; End of function sub_90B84

; ---------------------------------------------------------------------------
byte_90BBC:	dc.b	1,   4
		dc.b	1,   0
		dc.b	0,   0
		dc.b	1,   4
		dc.b	0,   4
		dc.b	1,   0
		dc.b	0,   0
RawAni_90BCA:	dc.b  $BA, $AD,	$56,   0, $C4, $B0, $D6,   0
; ---------------------------------------------------------------------------

loc_90BD2:
		move.w	($FFFFEE78).w,d0
		moveq	#-$10,d1
		sub.w	$3A(a0),d0
		bpl.s	loc_90BE2
		neg.w	d0
		neg.w	d1

loc_90BE2:
		cmpi.w	#$10,d0
		bcs.s	loc_90BEE
		add.w	d1,($FFFFEE78).w
		rts
; ---------------------------------------------------------------------------

loc_90BEE:
		movea.l	$34(a0),a1
		jmp	(a1)
; ---------------------------------------------------------------------------

loc_90BF4:
		move.l	#loc_90C2A,(a0)
		move.w	#$1F,$2E(a0)
		jsr	(Create_New_Sprite).l
		bne.s	locret_90C14
		move.l	#loc_90CA2,(a1)
		move.b	$3C(a0),$2C(a1)

locret_90C14:
		rts
; ---------------------------------------------------------------------------

loc_90C16:

		move.l	#loc_90C34,(a0)
		clr.b	($FFFFEE0A).w
		clr.b	($FFFFB02E).w
		clr.b	($FFFFB078).w
		rts
; ---------------------------------------------------------------------------

loc_90C2A:
		subq.w	#1,$2E(a0)
		bmi.w	loc_90B32

locret_90C32:

		rts
; ---------------------------------------------------------------------------

loc_90C34:
		lea	($FFFFB000).w,a1
		move.w	$10(a1),d0
		subi.w	#$1640,d0
		bpl.s	loc_90C44
		neg.w	d0

loc_90C44:
		cmpi.w	#8,d0
		bcs.s	loc_90C58
		cmpi.w	#$18,d0
		bcs.s	locret_90CA0
		bset	#3,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_90C58:
		bclr	#3,$38(a0)
		beq.s	locret_90CA0
		movea.w	$44(a0),a1
		btst	#3,$2A(a1)
		beq.s	locret_90CA0
		btst	#5,$38(a0)
		beq.s	locret_90CA0
		moveq	#-$51,d0
		jsr	(Play_Sound_2).l
		move.w	#1,($FFFFFE02).w
		move.b	($FFFFFE49).w,($FFFFFE2A).w
		move.w	($FFFFFE4A).w,($FFFFFE10).w
		move.w	($FFFFFF9C).w,($FFFFEE4E).w
		move.b	($FFFFB02B).w,($FFFFFF96).w
		ori.b	#-$80,($FFFFFE2A).w

locret_90CA0:

		rts
; ---------------------------------------------------------------------------

loc_90CA2:

		lea	ObjDat3_90FCC(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_90CF4,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		lsl.w	#2,d0
		lea	word_90CD4(pc,d0.w),a1
		move.w	(a1)+,$10(a0)
		move.w	(a1)+,$3A(a0)
		move.w	($FFFFEE7C).w,d0
		subi.w	#$80,d0
		move.w	d0,$14(a0)
		rts
; ---------------------------------------------------------------------------
word_90CD4:	dc.w  $1640,  $300
		dc.w  $15E0,  $328
		dc.w  $16A0,  $328
		dc.w  $15A0,  $2D8
		dc.w  $16E0,  $2D8
		dc.w  $1550,  $318
		dc.w  $1730,  $318
		dc.w  $1640,  $340
; ---------------------------------------------------------------------------

loc_90CF4:
		move.w	$14(a0),d0
		addi.w	#$10,d0
		move.w	d0,$14(a0)
		cmp.w	$3A(a0),d0
		bcs.s	loc_90D20
		move.l	#loc_90D30,(a0)
		move.w	#$3F,$2E(a0)
		move.w	#8,($FFFFEECC).w
		moveq	#$54,d0
		jsr	(Play_Sound_2).l

loc_90D20:

		btst	#0,($FFFFFE0F).w
		bne.w	locret_90C32
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_90D30:
		subq.w	#1,$2E(a0)
		bmi.s	loc_90D42
		cmpi.w	#$20,$2E(a0)
		bne.s	loc_90D20
		bsr.w	sub_90E9A

loc_90D42:
		move.l	#loc_90D52,(a0)
		move.l	#loc_90D5E,$34(a0)
		bra.s	loc_90D20
; ---------------------------------------------------------------------------

loc_90D52:
		lea	byte_90FF6(pc),a1
		jsr	(Animate_RawNoSST).l
		bra.s	loc_90D20
; ---------------------------------------------------------------------------

loc_90D5E:
		bset	#0,($FFFFFAB8).w
		move.w	$44(a0),d0
		beq.s	loc_90D72
		movea.w	d0,a1
		bset	#5,$38(a1)

loc_90D72:
		jmp	(Go_Delete_Sprite).l
; ---------------------------------------------------------------------------

loc_90D78:
		move.l	#loc_90DA2,(a0)
		bset	#2,4(a0)
		move.w	#-$80,$1A(a0)
		move.w	#$7F,$2E(a0)
		moveq	#-$48,d0
		jsr	(Play_Sound_2).l
		lea	ChildObjDat_90FF0(pc),a2
		jsr	(CreateChild6_Simple).l

loc_90DA2:
		jsr	(MoveSprite2).l
		subq.w	#1,$2E(a0)
		bpl.s	locret_90DD6
		move.l	#loc_90DDC,(a0)
		lea	($FFFFB000).w,a1
		bsr.w	sub_90DC0
		lea	($FFFFB04A).w,a1

; =============== S U B R O U T I N E =======================================


sub_90DC0:
		moveq	#0,d0
		move.b	$38(a1),d0
		move.b	byte_90DD8(pc,d0.w),$22(a1)
		move.l	a2,-(sp)
		jsr	(Player_Load_PLC2).l
		movea.l	(sp)+,a2

locret_90DD6:
		rts
; End of function sub_90DC0

; ---------------------------------------------------------------------------
byte_90DD8:	dc.b $C4
		dc.b $B0
		dc.b $D6
		dc.b 0
; ---------------------------------------------------------------------------

loc_90DDC:
		cmpi.b	#$7F,$27(a0)
		bne.s	locret_90DFA
		bset	#2,$38(a0)
		bset	#7,$38(a0)
		bne.s	locret_90DFA
		moveq	#-$64,d0
		jsr	(Play_Sound_2).l

locret_90DFA:

		rts
; ---------------------------------------------------------------------------

loc_90DFC:
		lea	ObjDat3_90FD8(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_90E1C,(a0)
		bset	#7,4(a0)
		move.w	#$7F,$2E(a0)
		bsr.w	sub_90F0A

loc_90E1C:
		move.w	$3A(a0),d0
		addi.w	#$10,d0
		move.w	d0,$3A(a0)
		cmpi.w	#$1800,d0
		bcs.s	loc_90E34
		move.l	#loc_90E4E,(a0)

loc_90E34:

		addq.b	#4,$3C(a0)
		jsr	(MoveSprite_Circular).l

loc_90E3E:

		btst	#0,($FFFFFE0F).w
		bne.w	locret_90C32
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_90E4E:
		move.b	$3D(a0),d0
		sub.b	$3C(a0),d0
		cmpi.b	#4,d0
		bcs.s	loc_90E5E
		bra.s	loc_90E34
; ---------------------------------------------------------------------------

loc_90E5E:
		move.l	#loc_90E72,(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		movea.w	$46(a0),a1
		bset	d0,$27(a1)

loc_90E72:
		movea.w	$46(a0),a1
		btst	#2,$38(a1)
		beq.s	loc_90E3E
		move.l	#loc_90E86,(a0)
		bra.s	loc_90E3E
; ---------------------------------------------------------------------------

loc_90E86:
		tst.b	4(a0)
		bpl.s	loc_90E94
		jsr	(MoveSprite2).l
		bra.s	loc_90E3E
; ---------------------------------------------------------------------------

loc_90E94:
		jmp	(Delete_Current_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_90E9A:
		cmpi.b	#7,$2C(a0)
		bne.s	loc_90ED0
		lea	($FFFFB000).w,a1
		bsr.w	sub_90EAE
		lea	($FFFFB04A).w,a1
; End of function sub_90E9A


; =============== S U B R O U T I N E =======================================


sub_90EAE:
		moveq	#0,d0
		move.b	$38(a1),d0
		cmpi.b	#1,d0
		bne.s	loc_90EBE
		addq.w	#4,$14(a1)

loc_90EBE:
		move.b	RawAni_90F06(pc,d0.w),$22(a1)
		move.b	#5,$20(a1)
		jmp	(Player_Load_PLC2).l
; End of function sub_90EAE

; ---------------------------------------------------------------------------

loc_90ED0:
		lea	($FFFFFFB2).w,a1
		moveq	#0,d0
		move.b	$2C(a0),d0
		addq.b	#1,(a1,d0.w)
		jsr	(Create_New_Sprite).l
		bne.s	loc_90EFC
		move.l	#Obj_B4_2,(a1)
		move.b	$2C(a0),$2C(a1)
		bset	#7,$38(a1)
		move.w	a1,$44(a0)

loc_90EFC:
		st	($FFFFEF56).w
		jmp	(SaveGame_SpecialStage).l
; ---------------------------------------------------------------------------
RawAni_90F06:	dc.b  $BA, $AD,	$56,   0

; =============== S U B R O U T I N E =======================================


sub_90F0A:
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,d1
		lsr.w	#1,d0
		move.b	d0,$2C(a0)
		move.b	byte_90F64(pc,d0.w),$3C(a0)
		move.b	byte_90F6C(pc,d0.w),$3D(a0)
		lea	($FFFFFFB2).w,a1
		move.b	(a1,d0.w),d2
		beq.s	loc_90F54
		cmpi.b	#2,d2
		bcc.s	loc_90F54
		move.b	d0,$22(a0)
		add.w	d1,d1
		move.l	word_90F74(pc,d1.w),$18(a0)
		cmpi.w	#3,($FFFFFF08).w
		bne.s	loc_90F4A
		addq.w	#2,d1

loc_90F4A:
		move.w	word_90F90(pc,d1.w),d2
		move.w	d2,$A(a0)
		rts
; ---------------------------------------------------------------------------

loc_90F54:

		movea.w	$46(a0),a1
		bset	d0,$27(a1)
		addq.w	#4,sp
		jmp	(Delete_Current_Sprite).l
; End of function sub_90F0A

; ---------------------------------------------------------------------------
byte_90F64:	dc.b 0
		dc.b $24
		dc.b $48
		dc.b $6C
		dc.b $90
		dc.b $B4
		dc.b $D8
		dc.b 0
byte_90F6C:	dc.b $80
		dc.b $86
		dc.b $7A
		dc.b $8C
		dc.b $74
		dc.b $92
		dc.b $6E
		dc.b 0
word_90F74:	dc.w	  0, $FC00
		dc.w  $FF08, $FC20
		dc.w	$F8, $FC20
		dc.w  $FE20, $FC7C
		dc.w   $1E0, $FC7C
		dc.w  $FD54, $FD0C
		dc.w   $2AC, $FD0C
word_90F90:	dc.w $C4AC
		dc.w $C4AC
		dc.w $84AC
		dc.w $A4AC
		dc.w $C4AC
		dc.w $C4AC
		dc.w $84AC
		dc.w $A4AC
		dc.w $84AC
		dc.w $A4AC
		dc.w $84AC
		dc.w $A4AC
		dc.w $E4AC
		dc.w $E4AC
ObjDat3_90FAC:	dc.l Map_HPZEmeraldMisc
		dc.w $63B5
		dc.w $200
		dc.b $20
		dc.b $18
		dc.b $B
		dc.b 0
word_90FB8:	dc.w $43B5
		dc.w $180
		dc.b $10
		dc.b $10
		dc.b $C
		dc.b 0
ObjDat3_90FC0:	dc.l Map_HPZEmeraldMisc
		dc.w 0
		dc.w $80
		dc.b $18
		dc.b $10
		dc.b $1E
		dc.b 0
ObjDat3_90FCC:	dc.l Map_HPZEmeraldMisc
		dc.w $83B5
		dc.w 0
		dc.b $10
		dc.b $80
		dc.b 8
		dc.b 0
ObjDat3_90FD8:	dc.l Map_HPZChaosEmeralds
		dc.w $A4AC
		dc.w $180
		dc.b 4
		dc.b 4
		dc.b 0
		dc.b 0
ChildObjDat_90FE4:dc.w 0
		dc.l loc_90734
word_90FEA:	dc.w 0
		dc.l loc_90D78
ChildObjDat_90FF0:dc.w 6
		dc.l loc_90DFC
byte_90FF6:	dc.b	0, $1D,	$1F, $1D, $20, $1D, $21, $1D, $22, $1D,	$23, $1D, $24, $1D, $F4,   0

Map_HPZEmeraldMisc:	include "Levels\HPZ\Misc Object Data\Map - Emerald Misc Art.asm"

Map_HPZChaosEmeralds:	include "Levels\HPZ\Misc Object Data\Map - Chaos Emeralds.asm"

off_914CE:	dc.l off_914EE

		dc.w 1
		dc.b 0
		dc.b $F
		dc.b 1
		dc.b 9
		dc.b 2
		dc.b 9
		dc.b 3
		dc.b 7
		dc.b 4
		dc.b 7
		dc.b 5
		dc.b 5
		dc.b 6
		dc.b 5
		dc.b 5
		dc.b 5
		dc.b 4
		dc.b 7
		dc.b 3
		dc.b 7
		dc.b 2
		dc.b 9
		dc.b 1
		dc.b 9
		dc.b $FF
		dc.b $FC
off_914EE:	dc.w word_914FC-off_914EE

		dc.w word_91500-off_914EE
		dc.w word_91504-off_914EE
		dc.w word_91508-off_914EE
		dc.w word_9150C-off_914EE
		dc.w word_91510-off_914EE
		dc.w word_91514-off_914EE
word_914FC:	dc.w $6A0
		dc.w $660
word_91500:	dc.w $8C0
		dc.w $680
word_91504:	dc.w $AC0
		dc.w $680
word_91508:	dc.w $CE0
		dc.w $880
word_9150C:	dc.w $CE6
		dc.w $6A2
word_91510:	dc.w $CE8
		dc.w $AC0
word_91514:	dc.w $EEC
		dc.w $CE8
; ---------------------------------------------------------------------------

Obj_EggRobo:

		jsr	(Obj_WaitOffscreen).l
		bsr.w	sub_9185E
		movea.l	(a0),a1
		jmp	(a1)
; ---------------------------------------------------------------------------

loc_91526:
		move.b	$40(a0),d0
		subi.b	#3,d0
		cmpi.b	#4,d0
		bcs.s	loc_91548
		cmp.b	$41(a0),d0
		beq.s	loc_91548
		move.b	d0,$40(a0)
		move.b	d0,$41(a0)
		jsr	(Perform_Art_Scaling).l

loc_91548:

		move.w	$3C(a0),d0
		subq.w	#1,d0
		move.w	d0,$3C(a0)
		add.w	d0,$1A(a0)
		bpl.s	loc_9155E
		tst.b	4(a0)
		bpl.s	loc_91570

loc_9155E:
		jsr	(sub_86180).l
		jsr	(sub_8619A).l
		jmp	(Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_91570:
		move.b	$2C(a0),d0
		andi.w	#$F0,d0
		lsr.w	#4,d0
		move.w	($FFFFFA82).w,d1
		bset	d0,d1
		move.w	d1,($FFFFFA82).w
		lea	(ArtKosM_EggRoboBadnik).l,a1
		move.w	#-$6000,d2
		jsr	(Queue_Kos_Module).l
		jmp	(Delete_Current_Sprite).l
; ---------------------------------------------------------------------------

loc_9159A:

		bsr.w	sub_91988
		move.w	$30(a0),$32(a0)
		move.w	$14(a0),$30(a0)
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		lea	($FFFFB000).w,a1
		jsr	(Find_OtherObject).l
		jsr	(Change_FlipX).l
		cmpi.w	#8,d3
		bhi.s	loc_915D8
		move.l	#loc_915DE,(a0)
		bset	#1,$38(a0)

loc_915D8:
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------

loc_915DE:
		bsr.w	sub_91988
		btst	#1,$38(a0)
		bne.s	loc_915F0
		move.l	#loc_9159A,(a0)

loc_915F0:
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------

loc_915F6:
		move.b	($FFFFFE0F).w,d0
		andi.b	#$F,d0
		bne.s	loc_91648
		tst.b	4(a0)
		bpl.s	loc_91648
		lea	ChildObjDat_919E6(pc),a2
		jsr	(CreateChild6_Simple).l
		subq.b	#1,$39(a0)
		bpl.s	loc_91648
		move.l	#loc_9164E,(a0)
		lea	ObjDat3_919A6(pc),a1
		jsr	(SetUp_ObjAttributes).l
		bclr	#7,$A(a0)
		move.w	#-$300,d0
		btst	#0,4(a0)
		beq.s	loc_9163A
		neg.w	d0

loc_9163A:
		move.w	d0,$18(a0)
		lea	ChildObjDat_919D0(pc),a2
		jsr	(CreateChild1_Normal).l

loc_91648:

		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------

loc_9164E:
		bsr.w	sub_91988
		addi.w	#-$10,$1A(a0)
		jsr	(MoveSprite2).l
		move.w	$1A(a0),d0
		cmpi.w	#-$200,d0
		bgt.s	loc_91678
		move.l	#loc_9167E,(a0)
		clr.w	$18(a0)
		bset	#7,$A(a0)

loc_91678:
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------

loc_9167E:
		bsr.w	sub_91988
		addi.w	#$20,$1A(a0)
		jsr	(MoveSprite2).l
		move.w	$1A(a0),d0
		cmpi.w	#$100,d0
		blt.s	loc_916A2
		move.l	#loc_9159A,(a0)
		bsr.w	sub_918E2

loc_916A2:
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------

loc_916A8:
		lea	word_919BE(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		movea.w	$46(a0),a1
		btst	#2,4(a1)
		bne.s	loc_916C4
		bclr	#2,4(a0)

loc_916C4:
		move.l	#loc_916CC,(a0)
		rts
; ---------------------------------------------------------------------------

loc_916CC:
		jsr	(Refresh_ChildPositionAdjusted).l
		moveq	#6,d0
		move.w	$1A(a1),d1
		bmi.s	loc_916E4
		moveq	#5,d0
		cmpi.w	#$20,d1
		bcs.s	loc_916E4
		moveq	#4,d0

loc_916E4:

		move.b	d0,$22(a0)
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_916EE:
		lea	word_919C4(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		movea.w	$46(a0),a1
		btst	#2,4(a1)
		bne.s	loc_9170A
		bclr	#2,4(a0)

loc_9170A:
		move.l	#loc_91712,(a0)
		rts
; ---------------------------------------------------------------------------

loc_91712:

		bsr.w	sub_91930
		btst	#1,$38(a1)
		beq.s	loc_91734
		move.l	#loc_9173A,(a0)
		move.w	#$5F,$2E(a0)
		lea	ChildObjDat_919DE(pc),a2
		jsr	(CreateChild10_NormalAdjusted).l

loc_91734:
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_9173A:
		subq.w	#1,$2E(a0)
		bpl.s	loc_91750
		move.l	#loc_91712,(a0)
		movea.w	$46(a0),a1
		bclr	#1,$38(a1)

loc_91750:
		jmp	(Child_Draw_Sprite).l
; ---------------------------------------------------------------------------

loc_91756:
		lea	word_919CA(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_9176C,(a0)
		move.w	#$1F,$2E(a0)

loc_9176C:
		moveq	#0,d0
		btst	#0,($FFFFFE0F).w
		beq.s	loc_91778
		moveq	#7,d0

loc_91778:
		move.b	d0,$22(a0)
		subq.w	#1,$2E(a0)
		bpl.s	loc_917AE
		move.l	#loc_917B4,(a0)
		move.b	#7,$22(a0)
		move.b	#-$64,$28(a0)
		move.w	#-$800,d0
		btst	#0,4(a0)
		beq.s	loc_917A2
		neg.w	d0

loc_917A2:
		move.w	d0,$18(a0)
		moveq	#$5E,d0
		jsr	(Play_Sound_2).l

loc_917AE:
		jmp	(Child_DrawTouch_Sprite).l
; ---------------------------------------------------------------------------

loc_917B4:
		jsr	(MoveSprite2).l
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------

loc_917C0:
		move.l	#Obj_Animal,(a0)
		addq.b	#2,5(a0)
		jsr	(Random_Number).l
		move.w	#$580,$A(a0)
		andi.w	#1,d0
		beq.s	loc_917E2
		move.w	#$592,$A(a0)

loc_917E2:
		move.b	d0,$30(a0)
		lsl.w	#3,d0
		lea	(word_2C7EA).l,a1
		adda.w	d0,a1
		move.w	(a1)+,d1
		movea.w	$46(a0),a2
		btst	#0,4(a2)
		beq.s	loc_91800
		neg.w	d1

loc_91800:
		move.w	d1,$18(a0)
		move.w	(a1)+,$34(a0)
		move.l	(a1)+,$C(a0)
		swap	d0
		andi.w	#$1FF,d0
		cmpi.w	#$100,d0
		bcc.s	loc_9181C
		move.w	#$100,d0

loc_9181C:
		neg.w	d0
		move.w	d0,$1A(a0)
		move.b	#$C,$1E(a0)
		move.b	#4,4(a0)
		bset	#0,4(a0)
		move.w	#$300,8(a0)
		move.b	#8,7(a0)
		move.b	#7,$24(a0)
		move.b	#1,$22(a0)
		move.b	$30(a0),d0
		add.b	d0,d0
		addq.b	#4,d0
		move.b	d0,5(a0)
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_9185E:
		move.b	$2C(a0),d0
		andi.w	#$F,d0
		move.w	off_9186E(pc,d0.w),d0
		jmp	off_9186E(pc,d0.w)
; End of function sub_9185E

; ---------------------------------------------------------------------------
off_9186E:	dc.w loc_91874-off_9186E

		dc.w loc_918C4-off_9186E
		dc.w loc_918FC-off_9186E
; ---------------------------------------------------------------------------

loc_91874:
		lea	ObjDat3_9199A(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_91526,(a0)
		move.w	#-$6000,$3A(a0)
		move.w	#-$80,d0
		btst	#0,4(a0)
		bne.s	loc_91898
		neg.w	d0

loc_91898:
		move.w	d0,$18(a0)
		move.w	$10(a0),$30(a0)
		move.w	$14(a0),$34(a0)
		move.b	#$7F,$40(a0)
		move.l	#ArtScaled_EggRoboFly,$42(a0)
		btst	#0,4(a0)
		move.w	#$180,$1A(a0)

locret_918C2:
		rts
; ---------------------------------------------------------------------------

loc_918C4:
		bsr.w	sub_91914
		lea	ObjDat3_919A6(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_9159A,(a0)
		lea	ChildObjDat_919D0(pc),a2
		jsr	(CreateChild1_Normal).l

; =============== S U B R O U T I N E =======================================


sub_918E2:
		move.w	#$100,d0
		move.w	d0,$3E(a0)
		move.w	d0,$1A(a0)
		move.w	#8,$40(a0)
		bclr	#0,$38(a0)
		rts
; End of function sub_918E2

; ---------------------------------------------------------------------------

loc_918FC:
		lea	ObjDat3_919B2(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.l	#loc_915F6,(a0)
		move.b	#4,$39(a0)
		rts

; =============== S U B R O U T I N E =======================================


sub_91914:
		move.b	$2C(a0),d0
		andi.w	#$F0,d0
		lsr.w	#4,d0
		move.w	($FFFFFA82).w,d1
		btst	d0,d1
		bne.w	locret_918C2
		addq.w	#8,sp
		jmp	(loc_85088).l
; End of function sub_91914


; =============== S U B R O U T I N E =======================================


sub_91930:
		movea.w	$46(a0),a1
		move.w	$10(a1),d0
		move.b	$42(a0),d1
		ext.w	d1
		bclr	#0,4(a0)
		btst	#0,4(a1)
		beq.s	loc_91954
		neg.w	d1
		bset	#0,4(a0)

loc_91954:
		add.w	d1,d0
		move.w	d0,$10(a0)
		move.w	$32(a1),d0
		bne.s	loc_91964
		move.w	$14(a1),d0

loc_91964:
		move.b	$43(a0),d1
		ext.w	d1
		bclr	#1,4(a0)
		btst	#1,4(a1)
		beq.s	loc_91980
		neg.w	d1
		bset	#1,4(a0)

loc_91980:
		add.w	d1,d0
		move.w	d0,$14(a0)
		rts
; End of function sub_91930


; =============== S U B R O U T I N E =======================================


sub_91988:

		moveq	#1,d0
		btst	#0,($FFFFFE0F).w
		beq.s	loc_91994
		moveq	#3,d0

loc_91994:
		move.b	d0,$22(a0)
		rts
; End of function sub_91988

; ---------------------------------------------------------------------------
ObjDat3_9199A:	dc.l Map_ScaledArt
		dc.w $A500
		dc.w $280
		dc.b $20
		dc.b $20
		dc.b 0
		dc.b 0
ObjDat3_919A6:	dc.l Map_EggRobo

		dc.w $8500
		dc.w $280
		dc.b $14
		dc.b $18
		dc.b 1
		dc.b 6
ObjDat3_919B2:	dc.l Map_EggRobo
		dc.w $8500
		dc.w $280
		dc.b 4
		dc.b 4
		dc.b 0
		dc.b 0
word_919BE:	dc.w $280
		dc.b $C
		dc.b $10
		dc.b 6
		dc.b 0
word_919C4:	dc.w $280
		dc.b $10
		dc.b $C
		dc.b 2
		dc.b 0
word_919CA:	dc.w $280
		dc.b $20
		dc.b 4
		dc.b 7
		dc.b 0
ChildObjDat_919D0:dc.w 1

		dc.l loc_916A8
		dc.b $F4
		dc.b $1C
		dc.l loc_916EE
		dc.b $E4
		dc.b $FC
ChildObjDat_919DE:dc.w 0
		dc.l loc_91756
		dc.b $B
		dc.b $FC
ChildObjDat_919E6:dc.w 0
		dc.l loc_917C0
; ---------------------------------------------------------------------------

Obj_Spikebonker:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_91A06(pc,d0.w),d1
		jsr	off_91A06(pc,d1.w)
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------
off_91A06:	dc.w loc_91A0C-off_91A06

		dc.w loc_91A6A-off_91A06
		dc.w loc_91AC2-off_91A06
; ---------------------------------------------------------------------------

loc_91A0C:
		lea	ObjDat3_91C1A(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.w	#-$80,d0
		btst	#0,4(a0)
		beq.s	loc_91A24
		neg.w	d0

loc_91A24:
		move.w	d0,$18(a0)
		moveq	#0,d0
		move.b	$2C(a0),d0
		move.w	d0,d1
		subq.w	#1,d0
		move.w	d0,$2E(a0)
		add.w	d1,d1
		subq.w	#1,d1
		move.w	d1,$3A(a0)
		move.l	#loc_91AB0,$34(a0)
		lea	ChildObjDat_91C2C(pc),a2
		jsr	(CreateChild1_Normal).l
		move.w	#$40,d0
		move.w	d0,$3E(a0)
		move.w	d0,$1A(a0)
		move.w	#4,$40(a0)
		bclr	#0,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_91A6A:
		lea	($FFFFB000).w,a1
		jsr	(Find_OtherObject).l
		cmpi.w	#$60,d2
		bcc.s	loc_91A88
		btst	#0,4(a0)
		beq.s	loc_91A84
		subq.w	#2,d0

loc_91A84:
		tst.w	d0
		beq.s	loc_91A9A

loc_91A88:
		jsr	(Swing_UpAndDown).l
		jsr	(MoveSprite2).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_91A9A:
		move.b	#4,5(a0)
		bset	#3,$38(a0)
		moveq	#-$76,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_91AB0:
		neg.w	$18(a0)
		bchg	#0,4(a0)
		move.w	$3A(a0),$2E(a0)
		rts
; ---------------------------------------------------------------------------

loc_91AC2:
		btst	#3,$38(a0)
		bne.s	locret_91AD0
		move.b	#2,5(a0)

locret_91AD0:
		rts
; ---------------------------------------------------------------------------

loc_91AD2:
		lea	word_91C26(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_91AEC,(a0)
		lea	ChildObjDat_91C34(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_91AEC:

		jsr	(Refresh_ChildPositionAdjusted).l
		movea.w	$44(a0),a1
		move.b	$3C(a1),d0
		bne.s	loc_91B08
		movea.w	$46(a0),a2
		btst	#3,$38(a2)
		bne.s	loc_91B14

loc_91B08:
		subq.b	#8,d0
		move.b	d0,$3C(a1)
		jmp	(Child_CheckParent).l
; ---------------------------------------------------------------------------

loc_91B14:
		move.l	#loc_91B3E,(a0)
		moveq	#-4,d0
		btst	#0,4(a0)
		beq.s	loc_91B26
		neg.w	d0

loc_91B26:
		move.w	d0,$18(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_91B68,$34(a0)
		jmp	(Child_CheckParent).l
; ---------------------------------------------------------------------------

loc_91B3E:

		move.w	$10(a0),d0
		add.w	$18(a0),d0
		move.w	d0,$10(a0)
		jsr	(Obj_Wait).l
		jmp	(Child_CheckParent).l
; ---------------------------------------------------------------------------

loc_91B56:
		move.l	#loc_91AEC,(a0)
		movea.w	$46(a0),a1
		bclr	#3,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_91B68:
		move.l	#loc_91B70,(a0)
		rts
; ---------------------------------------------------------------------------

loc_91B70:
		movea.w	$44(a0),a1
		move.b	$3C(a1),d0
		cmpi.b	#-$80,d0
		beq.s	loc_91B8A
		subq.b	#8,d0
		move.b	d0,$3C(a1)
		jmp	(Child_CheckParent).l
; ---------------------------------------------------------------------------

loc_91B8A:
		move.l	#loc_91B3E,(a0)
		neg.w	$18(a0)
		move.w	#$1F,$2E(a0)
		move.l	#loc_91B56,$34(a0)
		jmp	(Child_CheckParent).l
; ---------------------------------------------------------------------------

loc_91BA8:
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_91BBC(pc,d0.w),d1
		jsr	off_91BBC(pc,d1.w)
		jmp	(Child_DrawTouch_Sprite).l
; ---------------------------------------------------------------------------
off_91BBC:	dc.w loc_91BC0-off_91BBC

		dc.w loc_91BD4-off_91BBC
; ---------------------------------------------------------------------------

loc_91BC0:
		lea	word_91C26(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		movea.w	$46(a0),a1
		move.w	a0,$44(a1)
		rts
; ---------------------------------------------------------------------------

loc_91BD4:
		move.b	$3C(a0),d0
		bsr.w	sub_91BFA
		move.w	#$200,8(a0)
		addi.b	#$40,d0
		bpl.s	loc_91BEE
		move.w	#$280,8(a0)

loc_91BEE:
		lea	(AngleLookup_1).l,a1
		jmp	(MoveSprite_AngleXLookupOffset).l

; =============== S U B R O U T I N E =======================================


sub_91BFA:
		moveq	#0,d1

loc_91BFC:
		lea	byte_91C0E(pc,d1.w),a1
		cmp.b	(a1)+,d0
		bls.s	loc_91C08
		addq.w	#2,d1
		bra.s	loc_91BFC
; ---------------------------------------------------------------------------

loc_91C08:
		move.b	(a1),$22(a0)
		rts
; End of function sub_91BFA

; ---------------------------------------------------------------------------
byte_91C0E:	dc.b 0
		dc.b 1
		dc.b $30
		dc.b 1
		dc.b $50
		dc.b 2
		dc.b $B0
		dc.b 3
		dc.b $D0
		dc.b 2
		dc.b $FF
		dc.b 1
ObjDat3_91C1A:	dc.l Map_Spikebonker
		dc.w $A500
		dc.w $280
		dc.b $10
		dc.b $14
		dc.b 0
		dc.b $1A
word_91C26:	dc.w $200

		dc.b $10
		dc.b $10
		dc.b 1
		dc.b $9A
ChildObjDat_91C2C:dc.w 0
		dc.l loc_91AD2
		dc.w $14
ChildObjDat_91C34:dc.w 0
		dc.l loc_91BA8
		dc.w 0
; ---------------------------------------------------------------------------

Obj_Chainspike:

		jsr	(Obj_WaitOffscreen).l
		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_91C56(pc,d0.w),d1
		jsr	off_91C56(pc,d1.w)
		jmp	(Sprite_CheckDeleteTouch).l
; ---------------------------------------------------------------------------
off_91C56:	dc.w loc_91C62-off_91C56

		dc.w loc_91C9A-off_91C56
		dc.w loc_91CC2-off_91C56
		dc.w loc_91D0C-off_91C56
		dc.w loc_91D20-off_91C56
		dc.w loc_91D36-off_91C56
; ---------------------------------------------------------------------------

loc_91C62:
		lea	ObjDat3_91EDA(pc),a1
		jsr	(SetUp_ObjAttributes).l
		move.w	#-$1200,d0
		move.w	#$180,d1
		btst	#0,4(a0)
		beq.s	loc_91C80
		neg.w	d0
		neg.w	d1

loc_91C80:
		move.w	d0,$3E(a0)
		move.w	d1,$3C(a0)
		move.l	#loc_91CA6,$34(a0)
		lea	ChildObjDat_91EEC(pc),a2
		jmp	(CreateChild1_Normal).l
; ---------------------------------------------------------------------------

loc_91C9A:
		jsr	(sub_91E7E).l
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_91CA6:

		move.b	#4,5(a0)
		move.w	$3E(a0),$18(a0)
		move.w	$3C(a0),$40(a0)
		moveq	#$74,d0
		jsr	(Play_Sound_2).l
		rts
; ---------------------------------------------------------------------------

loc_91CC2:
		jsr	(sub_91E7E).l
		move.w	$18(a0),d0
		moveq	#$C,d2
		move.w	$40(a0),d1
		bmi.s	loc_91CD6
		neg.w	d2

loc_91CD6:
		add.w	d2,d1
		move.w	d1,$40(a0)
		add.w	d1,d0
		smi	d2
		tst.w	$3E(a0)
		bpl.s	loc_91CE8
		not.b	d2

loc_91CE8:
		tst.b	d2
		bne.s	loc_91CF6
		move.w	d0,$18(a0)
		jmp	(MoveSprite2).l
; ---------------------------------------------------------------------------

loc_91CF6:
		move.b	#2,5(a0)
		move.w	#$77,$2E(a0)
		neg.w	$3E(a0)
		neg.w	$3C(a0)
		rts
; ---------------------------------------------------------------------------

loc_91D0C:
		jmp	(Animate_RawGetFaster).l
; ---------------------------------------------------------------------------

loc_91D12:
		move.b	#8,5(a0)
		bset	#1,$38(a0)
		rts
; ---------------------------------------------------------------------------

loc_91D20:
		btst	#1,$38(a0)
		bne.s	locret_91D34
		move.b	#$A,5(a0)
		move.b	#$1F,$39(a0)

locret_91D34:
		rts
; ---------------------------------------------------------------------------

loc_91D36:
		subq.b	#1,$39(a0)
		bpl.s	locret_91D50
		move.b	$3A(a0),5(a0)
		move.w	$26(a0),$2E(a0)
		move.l	#loc_91CA6,$34(a0)

locret_91D50:
		rts
; ---------------------------------------------------------------------------

loc_91D52:

		moveq	#0,d0
		move.b	5(a0),d0
		move.w	off_91D66(pc,d0.w),d1
		jsr	off_91D66(pc,d1.w)
		jmp	(Child_DrawTouch_Sprite).l
; ---------------------------------------------------------------------------
off_91D66:	dc.w loc_91D6C-off_91D66

		dc.w loc_91D8C-off_91D66
		dc.w loc_91DE2-off_91D66
; ---------------------------------------------------------------------------

loc_91D6C:
		lea	word_91EE6(pc),a1
		jsr	(SetUp_ObjAttributes3).l
		move.l	#loc_91E46,$34(a0)
		tst.b	$2C(a0)
		beq.s	locret_91D8A
		bset	#1,4(a0)

locret_91D8A:
		rts
; ---------------------------------------------------------------------------

loc_91D8C:
		jsr	(Refresh_ChildPosition).l
		movea.w	$46(a0),a1
		btst	#1,$38(a1)
		beq.s	locret_91DE0
		btst	#1,4(a1)
		sne	d0
		tst.b	$2C(a0)
		beq.s	loc_91DAE
		not.b	d0

loc_91DAE:
		tst.b	d0
		bne.s	locret_91DE0
		move.b	#4,5(a0)
		move.b	#$18,$28(a0)
		move.b	#-1,$29(a0)
		moveq	#8,d0
		btst	#1,4(a1)
		beq.s	loc_91DD0
		neg.w	d0

loc_91DD0:
		move.w	d0,$1A(a0)
		move.w	$14(a0),$3A(a0)
		move.w	#$17,$2E(a0)

locret_91DE0:

		rts
; ---------------------------------------------------------------------------

loc_91DE2:
		move.w	$14(a0),d0
		add.w	$1A(a0),d0
		move.w	d0,$14(a0)
		bsr.w	sub_91EB0
		cmp.w	$3A(a0),d0
		beq.s	loc_91E22
		btst	#1,4(a0)
		sne	d0
		tst.w	$1A(a0)
		bmi.s	loc_91E08
		not.b	d0

loc_91E08:
		tst.b	d0
		beq.s	loc_91E1C
		jsr	(ObjHitFloor).l
		tst.w	d1
		bmi.s	loc_91E46
		tst.b	$28(a0)
		beq.s	loc_91E40

loc_91E1C:
		jmp	(Obj_Wait).l
; ---------------------------------------------------------------------------

loc_91E22:
		move.b	#2,5(a0)
		move.b	#-$68,$28(a0)
		move.b	#2,$22(a0)
		movea.w	$46(a0),a1
		bclr	#1,$38(a1)
		rts
; ---------------------------------------------------------------------------

loc_91E40:
		move.b	#$18,$28(a0)

loc_91E46:

		move.w	#$5F,$2E(a0)
		move.w	$1A(a0),d0
		asr.w	#2,d0
		neg.w	d0
		move.w	d0,$1A(a0)
		rts
; ---------------------------------------------------------------------------

loc_91E5A:

		move.b	#-$68,$28(a0)
		move.b	#8,7(a0)
		move.b	#8,6(a0)
		move.l	#loc_91E72,(a0)

loc_91E72:
		jsr	(Refresh_ChildPosition).l
		jmp	(Child_AddToTouchList).l

; =============== S U B R O U T I N E =======================================


sub_91E7E:

		jsr	(Find_SonicTails).l
		cmpi.w	#$10,d2
		bcc.s	locret_91EAE
		move.b	5(a0),$3A(a0)
		move.b	#6,5(a0)
		move.w	$2E(a0),$26(a0)
		move.l	#byte_91F06,$30(a0)
		move.l	#loc_91D12,$34(a0)
		addq.w	#4,sp

locret_91EAE:
		rts
; End of function sub_91E7E


; =============== S U B R O U T I N E =======================================


sub_91EB0:
		move.w	$3A(a0),d1
		sub.w	d0,d1
		bpl.s	loc_91EBA
		neg.w	d1

loc_91EBA:
		moveq	#0,d2
		moveq	#$18,d3
		moveq	#3,d4

loc_91EC0:
		add.w	d3,d2
		cmp.w	d2,d1
		bls.s	loc_91ECC
		dbf	d4,loc_91EC0
		moveq	#0,d4

loc_91ECC:
		move.b	RawAni_91ED4(pc,d4.w),$22(a0)
		rts
; End of function sub_91EB0

; ---------------------------------------------------------------------------
RawAni_91ED4:	dc.b	7,   6,	  5,   4,   2,	 0
ObjDat3_91EDA:	dc.l Map_Chainspike
		dc.w $A542
		dc.w $280
		dc.b $18
		dc.b $C
		dc.b 0
		dc.b $1A
word_91EE6:	dc.w $280
		dc.b 8
		dc.b $80
		dc.b 2
		dc.b $98
ChildObjDat_91EEC:dc.w 3
		dc.l loc_91D52
		dc.w $14
		dc.l loc_91D52
		dc.w $EC
		dc.l loc_91E5A
		dc.w $1400
		dc.l loc_91E5A
		dc.w $EC00
byte_91F06:	dc.b 5
		dc.b 6
		dc.b 0
		dc.b 3
		dc.b $FC
		dc.b $FF
LevelLoadBlock:	dc.l AIZ1_8x8_Primary_KosM+$B000000
				dc.l AIZ1_8x8_Secondary_KosM+$B000000
				dc.l AIZ1_16x16_Primary_Kos+$A000000
				dc.l AIZ1_16x16_Secondary_Kos+$A000000
				dc.l AIZ1_128x128_Kos
				dc.l AIZ1_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l AIZ2_8x8_Primary_KosM+$C000000
				dc.l AIZ2_8x8_Secondary_KosM+$C000000
				dc.l AIZ2_16x16_Primary_Kos+$B000000
				dc.l AIZ2_16x16_Secondary_Kos+$B000000
				dc.l AIZ2_128x128_Kos
				dc.l AIZ2_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l HCZ_8x8_Primary_KosM+$E000000
				dc.l HCZ1_8x8_Secondary_KosM+$F000000
				dc.l HCZ_16x16_Primary_Kos+$C000000
				dc.l HCZ1_16x16_Secondary_Kos+$C000000
				dc.l HCZ_128x128_Primary_Kos
				dc.l HCZ1_128x128_Secondary_Kos
; ---------------------------------------------------------------------------
				dc.l HCZ_8x8_Primary_KosM+$10000000
				dc.l HCZ2_8x8_Secondary_KosM+$11000000
				dc.l HCZ_16x16_Primary_Kos+$D000000
				dc.l HCZ2_16x16_Secondary_Kos+$D000000
				dc.l HCZ_128x128_Primary_Kos
				dc.l HCZ2_128x128_Secondary_Kos
; ---------------------------------------------------------------------------
				dc.l MGZ_8x8_Primary_KosM+$12000000
				dc.l MGZ1_8x8_Secondary_KosM+$12000000
				dc.l MGZ_16x16_Primary_Kos+$E000000
				dc.l MGZ1_16x16_Secondary_Kos+$E000000
				dc.l MGZ_128x128_Primary_Kos
				dc.l MGZ1_128x128_Secondary_Kos
; ---------------------------------------------------------------------------
				dc.l MGZ_8x8_Primary_KosM+$14000000
				dc.l MGZ2_8x8_Secondary_KosM+$14000000
				dc.l MGZ_16x16_Primary_Kos+$F000000
				dc.l MGZ2_16x16_Secondary_Kos+$F000000
				dc.l MGZ_128x128_Primary_Kos
				dc.l MGZ2_128x128_Secondary_Kos
; ---------------------------------------------------------------------------
				dc.l CNZ_8x8_KosM+$16000000
				dc.l CNZ_8x8_KosM+$17000000
				dc.l CNZ_16x16_Kos+$10000000
				dc.l CNZ_16x16_Kos+$10000000
				dc.l CNZ_128x128_Kos
				dc.l CNZ_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l CNZ_8x8_KosM+$18000000
				dc.l CNZ_8x8_KosM+$19000000
				dc.l CNZ_16x16_Kos+$11000000
				dc.l CNZ_16x16_Kos+$11000000
				dc.l CNZ_128x128_Kos
				dc.l CNZ_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_FBZ+$1A000000
				dc.l ArtKosM_FBZ+$1A000000
				dc.l FBZ_16x16_Kos+$12000000
				dc.l FBZ_16x16_Kos+$12000000
				dc.l FBZ_128x128_Kos
				dc.l FBZ_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_FBZ+$1C000000
				dc.l ArtKosM_FBZ+$1C000000
				dc.l FBZ_16x16_Kos+$13000000
				dc.l FBZ_16x16_Kos+$13000000
				dc.l FBZ_128x128_Kos
				dc.l FBZ_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l ICZ_8x8_Primary_KosM+$1E000000
				dc.l ICZ1_8x8_Secondary_KosM+$1E000000
				dc.l ICZ_16x16_Primary_Kos+$14000000
				dc.l ICZ1_16x16_Secondary_Kos+$14000000
				dc.l ICZ_128x128_Primary_Kos
				dc.l ICZ1_128x128_Secondary_Kos
; ---------------------------------------------------------------------------
				dc.l ICZ_8x8_Primary_KosM+$20000000
				dc.l ICZ2_8x8_Secondary_KosM+$20000000
				dc.l ICZ_16x16_Primary_Kos+$15000000
				dc.l ICZ2_16x16_Secondary_Kos+$15000000
				dc.l ICZ_128x128_Primary_Kos
				dc.l ICZ2_128x128_Secondary_Kos
; ---------------------------------------------------------------------------
				dc.l LBZ_8x8_Primary_KosM+$22000000
				dc.l LBZ1_8x8_Secondary_KosM+$22000000
				dc.l LBZ_16x16_Primary_Kos+$16000000
				dc.l LBZ1_16x16_Secondary_Kos+$16000000
				dc.l LBZ1_128x128_Kos
				dc.l LBZ1_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l LBZ_8x8_Primary_KosM+$24000000
				dc.l LBZ2_8x8_Secondary_KosM+$25000000
				dc.l LBZ_16x16_Primary_Kos+$17000000
				dc.l LBZ2_16x16_Secondary_Kos+$17000000
				dc.l LBZ2_128x128_Kos
				dc.l LBZ2_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_MHZ_Primary+$26000000
				dc.l ArtKosM_MHZ_Secondary+$26000000
				dc.l MHZ_16x16_Primary_Kos+$18000000
				dc.l MHZ_16x16_Secondary_Kos+$18000000
				dc.l MHZ_128x128_Primary_Kos
				dc.l MHZ_128x128_Secondary_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_MHZ_Primary+$28000000
				dc.l ArtKosM_MHZ_Secondary+$28000000
				dc.l MHZ_16x16_Primary_Kos+$19000000
				dc.l MHZ_16x16_Secondary_Kos+$19000000
				dc.l MHZ_128x128_Primary_Kos
				dc.l MHZ_128x128_Secondary_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_SOZ_Primary+$2A000000
				dc.l ArtKosM_SOZ1_Secondary+$2A000000
				dc.l SOZ_16x16_Primary_Kos+$1A000000
				dc.l SOZ1_16x16_Secondary_Kos+$1A000000
				dc.l SOZ_128x128_Kos
				dc.l SOZ_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_SOZ_Primary+$2C000000
				dc.l ArtKosM_SOZ2_Secondary+$2C000000
				dc.l SOZ_16x16_Primary_Kos+$1B000000
				dc.l SOZ2_16x16_Secondary_Kos+$1B000000
				dc.l SOZ_128x128_Kos
				dc.l SOZ_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_LRZ_Primary+$2E000000
				dc.l ArtKosM_LRZ1_Secondary+$2F000000
				dc.l LRZ_16x16_Primary_Kos+$1C000000
				dc.l LRZ1_16x16_Secondary_Kos+$1C000000
				dc.l LRZ_128x128_Primary_Kos
				dc.l LRZ1_128x128_Secondary_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_LRZ_Primary+$30000000
				dc.l ArtKosM_LRZ2_Secondary+$30000000
				dc.l LRZ_16x16_Primary_Kos+$1D000000
				dc.l LRZ2_16x16_Secondary_Kos+$1D000000
				dc.l LRZ_128x128_Primary_Kos
				dc.l LRZ2_128x128_Secondary_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_SSZ1_Primary+$32000000
				dc.l ArtKosM_SSZ1_Secondary+$32000000
				dc.l SSZ1_16x16_Primary_Kos+$1E000000
				dc.l SSZ1_16x16_Secondary_Kos+$1E000000
				dc.l SSZ1_128x128_Primary_Kos
				dc.l SSZ1_128x128_Secondary_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_SSZ2+$34000000
				dc.l ArtKosM_SSZ2+$34000000
				dc.l SSZ2_16x16_Kos+$1F000000
				dc.l SSZ2_16x16_Kos+$1F000000
				dc.l SSZ2_128x128_Kos
				dc.l SSZ2_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_DEZ_Primary+$36000000
				dc.l ArtKosM_DEZ1_Secondary+$36000000
				dc.l DEZ_16x16_Primary_Kos+$20000000
				dc.l DEZ1_16x16_Secondary_Kos+$20000000
				dc.l DEZ_128x128_Kos
				dc.l DEZ_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_DEZ_Primary+$38000000
				dc.l ArtKosM_DEZ2_Secondary+$38000000
				dc.l DEZ_16x16_Primary_Kos+$21000000
				dc.l DEZ2_16x16_Secondary_Kos+$21000000
				dc.l DEZ_128x128_Kos
				dc.l DEZ_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_DDZ+$3A000000
				dc.l ArtKosM_DDZ+$3A000000
				dc.l DDZ_16x16_Kos+$22000000
				dc.l DDZ_16x16_Kos+$22000000
				dc.l DDZ_128x128_Kos
				dc.l DDZ_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_DDZ+$3C000000
				dc.l ArtKosM_DDZ+$3C000000
				dc.l DDZ_16x16_Kos+$23000000
				dc.l DDZ_16x16_Kos+$23000000
				dc.l DDZ_128x128_Kos
				dc.l DDZ_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l AIZ1_8x8_Primary_KosM+$B000000
				dc.l AIZ1_8x8_MainLevel_KosM+$B000000
				dc.l AIZ1_16x16_Primary_Kos+$2A000000
				dc.l AIZ1_16x16_MainLevel_Kos+$2A000000
				dc.l AIZ1_128x128_Kos
				dc.l AIZ1_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_SSZ2+$40000000
				dc.l ArtKosM_SSZ2+$40000000
				dc.l SSZ2_16x16_Kos+$25000000
				dc.l SSZ2_16x16_Kos+$25000000
				dc.l SSZ2_128x128_Kos
				dc.l SSZ2_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l ALZ_8x8_KosM+$42000000
				dc.l ALZ_8x8_KosM+$42000000
				dc.l ALZ_16x16_Kos+$26000000
				dc.l ALZ_16x16_Kos+$26000000
				dc.l ALZ_128x128_Kos
				dc.l ALZ_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l ALZ_8x8_KosM+$42000000
				dc.l ALZ_8x8_KosM+$42000000
				dc.l ALZ_16x16_Kos+$27000000
				dc.l ALZ_16x16_Kos+$27000000
				dc.l ALZ_128x128_Kos
				dc.l ALZ_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l BPZ_8x8_KosM+$43000000
				dc.l BPZ_8x8_KosM+$43000000
				dc.l BPZ_16x16_Kos+$28000000
				dc.l BPZ_16x16_Kos+$28000000
				dc.l BPZ_128x128_Kos
				dc.l BPZ_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l BPZ_8x8_KosM+$43000000
				dc.l BPZ_8x8_KosM+$43000000
				dc.l BPZ_16x16_Kos+$29000000
				dc.l BPZ_16x16_Kos+$29000000
				dc.l BPZ_128x128_Kos
				dc.l BPZ_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l DPZ_8x8_KosM+$44000000
				dc.l DPZ_8x8_KosM+$44000000
				dc.l DPZ_16x16_Kos+$34000000
				dc.l DPZ_16x16_Kos+$34000000
				dc.l DPZ_128x128_Kos
				dc.l DPZ_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l DPZ_8x8_KosM+$44000000
				dc.l DPZ_8x8_KosM+$44000000
				dc.l DPZ_16x16_Kos+$34000000
				dc.l DPZ_16x16_Kos+$34000000
				dc.l DPZ_128x128_Kos
				dc.l DPZ_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l CGZ_8x8_KosM+$45000000
				dc.l CGZ_8x8_KosM+$45000000
				dc.l CGZ_16x16_Kos+$35000000
				dc.l CGZ_16x16_Kos+$35000000
				dc.l CGZ_128x128_Kos
				dc.l CGZ_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l CGZ_8x8_KosM+$45000000
				dc.l CGZ_8x8_KosM+$45000000
				dc.l CGZ_16x16_Kos+$35000000
				dc.l CGZ_16x16_Kos+$35000000
				dc.l CGZ_128x128_Kos
				dc.l CGZ_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l EMZ_8x8_KosM+$46000000
				dc.l EMZ_8x8_KosM+$46000000
				dc.l EMZ_16x16_Kos+$36000000
				dc.l EMZ_16x16_Kos+$36000000
				dc.l EMZ_128x128_Kos
				dc.l EMZ_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l EMZ_8x8_KosM+$46000000
				dc.l EMZ_8x8_KosM+$46000000
				dc.l EMZ_16x16_Kos+$36000000
				dc.l EMZ_16x16_Kos+$36000000
				dc.l EMZ_128x128_Kos
				dc.l EMZ_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l Gumball_8x8_KosM+$47000000
				dc.l Gumball_8x8_KosM+$47000000
				dc.l Gumball_16x16_Kos+$33000000
				dc.l Gumball_16x16_Kos+$33000000
				dc.l Gumball_128x128_Kos
				dc.l Gumball_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l Gumball_8x8_KosM+$47000000
				dc.l Gumball_8x8_KosM+$47000000
				dc.l Gumball_16x16_Kos+$33000000
				dc.l Gumball_16x16_Kos+$33000000
				dc.l Gumball_128x128_Kos
				dc.l Gumball_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_Pachinko+$50000000
				dc.l ArtKosM_Pachinko+$50000000
				dc.l Pachinko_16x16_Kos+$37000000
				dc.l Pachinko_16x16_Kos+$37000000
				dc.l Pachinko_128x128_Kos
				dc.l Pachinko_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_Pachinko+$50000000
				dc.l ArtKosM_Pachinko+$50000000
				dc.l Pachinko_16x16_Kos+$37000000
				dc.l Pachinko_16x16_Kos+$37000000
				dc.l Pachinko_128x128_Kos
				dc.l Pachinko_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_Slots+$51000000
				dc.l ArtKosM_Slots+$51000000
				dc.l Slots_16x16_Kos+$38000000
				dc.l Slots_16x16_Kos+$38000000
				dc.l Slots_128x128_Kos
				dc.l Slots_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_Slots+$51000000
				dc.l ArtKosM_Slots+$51000000
				dc.l Slots_16x16_Kos+$38000000
				dc.l Slots_16x16_Kos+$38000000
				dc.l Slots_128x128_Kos
				dc.l Slots_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_HPZ_Primary+$48000000
				dc.l ArtKosM_LRZ3_Secondary+$48000000
				dc.l HPZ_16x16_Primary_Kos+$3E000000
				dc.l LRZ3_16x16_Secondary_Kos+$3E000000
				dc.l HPZ_128x128_Primary_Kos
				dc.l LRZ3_128x128_Secondary_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_HPZ_Primary+$48000000
				dc.l ArtKosM_HPZ_Secondary+$48000000
				dc.l HPZ_16x16_Primary_Kos+$3F000000
				dc.l HPZ_16x16_Secondary_Kos+$3F000000
				dc.l HPZ_128x128_Primary_Kos
				dc.l HPZ_128x128_Secondary_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_DEZ3+$4C000000
				dc.l ArtKosM_DEZ3+$4C000000
				dc.l DEZ3_16x16_Kos+$40000000
				dc.l DEZ3_16x16_Kos+$40000000
				dc.l DEZ3_128x128_Kos
				dc.l DEZ3_128x128_Kos
; ---------------------------------------------------------------------------
				dc.l ArtKosM_HPZ_Primary+$48000000
				dc.l ArtKosM_HPZ_Secondary+$48000000
				dc.l HPZ_16x16_Primary_Kos+$3F000000
				dc.l HPZ_16x16_Secondary_Kos+$3F000000
				dc.l HPZ_128x128_Primary_Kos
				dc.l HPZ_128x128_Secondary_Kos
; ---------------------------------------------------------------------------

Offs_PLC:	dc.w PLC_00-Offs_PLC				; Unused
		dc.w PLC_01-Offs_PLC					; Sonic life icon/universal level graphics
		dc.w PLC_02-Offs_PLC					; Explosions + Squirrel/Flicky
		dc.w PLC_03-Offs_PLC					; Game Over text
		dc.w PLC_04-Offs_PLC					; Signpost art
		dc.w PLC_05-Offs_PLC					; Knuckles life icon/universal level graphics
		dc.w PLC_06-Offs_PLC					; 2P mode specific art
		dc.w PLC_07-Offs_PLC					; Tails life icon/universal level graphics
		dc.w PLC_08-Offs_PLC					; Monitor art only
		dc.w PLC_SphereTest-Offs_PLC			; Repeat of 08
		dc.w PLC_0A-Offs_PLC					; AIZ Intro graphics
		dc.w PLC_0B_AIZ1-Offs_PLC				; AIZ 1 PLCs
		dc.w PLC_0C_0D-Offs_PLC					; AIZ 2 PLCs
		dc.w PLC_0C_0D-Offs_PLC
		dc.w PLC_0E-Offs_PLC					; HCZ 1 PLC 1
		dc.w PLC_0F-Offs_PLC					; HCZ 1 PLC 2
		dc.w PLC_10-Offs_PLC					; HCZ 2 PLC 1
		dc.w PLC_11-Offs_PLC					; HCZ 2 PLC 2
		dc.w PLC_12_13-Offs_PLC					; MGZ 1
		dc.w PLC_12_13-Offs_PLC					; MGZ 1
		dc.w PLC_14_15-Offs_PLC					; MGZ 2
		dc.w PLC_14_15-Offs_PLC					; MGZ 2
		dc.w PLC_16_17_18_19-Offs_PLC			; CNZ
		dc.w PLC_16_17_18_19-Offs_PLC
		dc.w PLC_16_17_18_19-Offs_PLC
		dc.w PLC_16_17_18_19-Offs_PLC
		dc.w PLC_1A_1B-Offs_PLC
		dc.w PLC_1A_1B-Offs_PLC
		dc.w PLC_1C_1D-Offs_PLC
		dc.w PLC_1C_1D-Offs_PLC
		dc.w PLC_1E_1F-Offs_PLC
		dc.w PLC_1E_1F-Offs_PLC
		dc.w PLC_20_21-Offs_PLC
		dc.w PLC_20_21-Offs_PLC
		dc.w PLC_22_23-Offs_PLC
		dc.w PLC_22_23-Offs_PLC
		dc.w PLC_24-Offs_PLC
		dc.w PLC_25-Offs_PLC			; LBZ 2 Misc art
		dc.w PLC_26_27_28_29-Offs_PLC
		dc.w PLC_26_27_28_29-Offs_PLC
		dc.w PLC_26_27_28_29-Offs_PLC
		dc.w PLC_26_27_28_29-Offs_PLC
		dc.w PLC_2A_2B-Offs_PLC
		dc.w PLC_2A_2B-Offs_PLC
		dc.w PLC_2C_2D-Offs_PLC
		dc.w PLC_2C_2D-Offs_PLC
		dc.w PLC_2E_2F-Offs_PLC
		dc.w PLC_2E_2F-Offs_PLC
		dc.w PLC_30_31-Offs_PLC
		dc.w PLC_30_31-Offs_PLC
		dc.w PLC_32_33_34_35-Offs_PLC
		dc.w PLC_32_33_34_35-Offs_PLC
		dc.w PLC_32_33_34_35-Offs_PLC
		dc.w PLC_32_33_34_35-Offs_PLC
		dc.w PLC_36_37-Offs_PLC
		dc.w PLC_36_37-Offs_PLC
		dc.w PLC_38_39-Offs_PLC
		dc.w PLC_38_39-Offs_PLC
		dc.w PLC_3A_3B_3C_3D_3E_3F-Offs_PLC
		dc.w PLC_3A_3B_3C_3D_3E_3F-Offs_PLC
		dc.w PLC_3A_3B_3C_3D_3E_3F-Offs_PLC
		dc.w PLC_3A_3B_3C_3D_3E_3F-Offs_PLC
		dc.w PLC_3A_3B_3C_3D_3E_3F-Offs_PLC
		dc.w PLC_3A_3B_3C_3D_3E_3F-Offs_PLC
		dc.w PLC_40_41-Offs_PLC
		dc.w PLC_40_41-Offs_PLC
		dc.w PLC_42-Offs_PLC
		dc.w PLC_43-Offs_PLC
		dc.w PLC_44-Offs_PLC
		dc.w PLC_45-Offs_PLC
		dc.w PLC_46-Offs_PLC
		dc.w PLC_47-Offs_PLC
		dc.w PLC_48_49_4A_4B-Offs_PLC
		dc.w PLC_48_49_4A_4B-Offs_PLC
		dc.w PLC_48_49_4A_4B-Offs_PLC
		dc.w PLC_48_49_4A_4B-Offs_PLC
		dc.w PLC_4C_4D-Offs_PLC
		dc.w PLC_4C_4D-Offs_PLC
		dc.w PLC_4E_4F-Offs_PLC
		dc.w PLC_4E_4F-Offs_PLC
		dc.w PLC_50-Offs_PLC
		dc.w PLC_51-Offs_PLC
		dc.w PLC_52-Offs_PLC
		dc.w PLC_53_Through_5A-Offs_PLC
		dc.w PLC_53_Through_5A-Offs_PLC
		dc.w PLC_53_Through_5A-Offs_PLC
		dc.w PLC_53_Through_5A-Offs_PLC
		dc.w PLC_53_Through_5A-Offs_PLC
		dc.w PLC_53_Through_5A-Offs_PLC
		dc.w PLC_53_Through_5A-Offs_PLC
		dc.w PLC_53_Through_5A-Offs_PLC
		dc.w PLC_5B-Offs_PLC
		dc.w PLC_5C_5D-Offs_PLC
		dc.w PLC_5C_5D-Offs_PLC
		dc.w PLC_5E-Offs_PLC
		dc.w PLC_5F-Offs_PLC
		dc.w PLC_60-Offs_PLC
		dc.w PLC_61-Offs_PLC
		dc.w PLC_62_Through_6A-Offs_PLC
		dc.w PLC_62_Through_6A-Offs_PLC
		dc.w PLC_62_Through_6A-Offs_PLC
		dc.w PLC_62_Through_6A-Offs_PLC
		dc.w PLC_62_Through_6A-Offs_PLC
		dc.w PLC_62_Through_6A-Offs_PLC
		dc.w PLC_62_Through_6A-Offs_PLC
		dc.w PLC_62_Through_6A-Offs_PLC
		dc.w PLC_62_Through_6A-Offs_PLC
		dc.w PLC_6B-Offs_PLC
		dc.w PLC_6C-Offs_PLC
		dc.w PLC_6D-Offs_PLC
		dc.w PLC_6E-Offs_PLC
		dc.w PLC_6F-Offs_PLC
		dc.w PLC_70-Offs_PLC
		dc.w PLC_71-Offs_PLC
		dc.w PLC_72_73_74_75_76-Offs_PLC
		dc.w PLC_72_73_74_75_76-Offs_PLC
		dc.w PLC_72_73_74_75_76-Offs_PLC
		dc.w PLC_72_73_74_75_76-Offs_PLC
		dc.w PLC_72_73_74_75_76-Offs_PLC
		dc.w PLC_77-Offs_PLC
		dc.w PLC_78_79_7A_7B-Offs_PLC
		dc.w PLC_78_79_7A_7B-Offs_PLC
		dc.w PLC_78_79_7A_7B-Offs_PLC
		dc.w PLC_78_79_7A_7B-Offs_PLC
PLC_00:		dc.w 3
		dc.l ArtNem_SonicLifeIcon		; Unused evidently
		dc.w $FA80
		dc.l ArtNem_Ring
		dc.w $D780
		dc.l ArtNem_EnemyPts
		dc.w $BC80
		dc.l ArtNem_Monitors
		dc.w $9880
PLC_01:		dc.w 3
		dc.l ArtNem_SonicLifeIcon
		dc.w $FA80
		dc.l ArtNem_Monitors
		dc.w $9880
		dc.l ArtNem_Ring
		dc.w $D780
		dc.l ArtNem_EnemyPts
		dc.w $BC80
PLC_02:		dc.w 2
		dc.l ArtNem_Explosion
		dc.w $B400
		dc.l ArtNem_Squirrel
		dc.w $B000
		dc.l ArtNem_BlueFlicky
		dc.w $B240
PLC_03:		dc.w 0
		dc.l ArtNem_GameOver
		dc.w $F380
PLC_04:		dc.w 0
		dc.l ArtNem_S2Signpost
		dc.w $A000
PLC_05:		dc.w 3
		dc.l ArtNem_KnucklesLifeIcon
		dc.w $FA80
		dc.l ArtNem_Monitors
		dc.w $9880
		dc.l ArtNem_Ring
		dc.w $D780
		dc.l ArtNem_EnemyPts
		dc.w $BC80
PLC_06:		dc.w 2
		dc.l ArtNem_2PArt_2	;S3DATA
		dc.w $7220
		dc.l ArtNem_2PArt_1	;S3DATA
		dc.w $75A0
		dc.l ArtNem_2PArt_3	;S3DATA
		dc.w $78C0
PLC_07:		dc.w 3
		dc.l ArtNem_TailsLifeIcon
		dc.w $FA80
		dc.l ArtNem_Monitors
		dc.w $9880
		dc.l ArtNem_Ring
		dc.w $D780
		dc.l ArtNem_EnemyPts
		dc.w $BC80
PLC_08:		dc.w 0
		dc.l ArtNem_Monitors
		dc.w $9880
PLC_SphereTest:	dc.w 0
		dc.l ArtNem_Monitors
		dc.w $9880
PLC_0A:		dc.w 0
		dc.l ArtNem_AIZIntroSprites
		dc.w $7A20
PLC_0B_AIZ1:	dc.w 5
		dc.l ArtNem_AIZSwingVine
		dc.w $8360
		dc.l ArtNem_AIZSlideRope
		dc.w $6480
		dc.l ArtNem_AIZMisc1
		dc.w $6660
		dc.l ArtNem_AIZFallingLog
		dc.w $79E0
		dc.l ArtNem_Bubbles
		dc.w $8B80
		dc.l ArtNem_AIZCorkFloor
		dc.w $7EE0
PLC_0C_0D:	dc.w 5
		dc.l ArtNem_AIZMisc2
		dc.w $5D20
		dc.l ArtNem_AIZSwingVine
		dc.w $8360
		dc.l ArtNem_AIZBackgroundTree
		dc.w $8700
		dc.l ArtNem_Bubbles
		dc.w $8B80
		dc.l ArtNem_GrayButton
		dc.w $8AC0
		dc.l ArtNem_AIZCorkFloor2	;S3DATA
		dc.w $8800
PLC_0E:	dc.w 5
		dc.l ArtNem_Bubbles
		dc.w $8B80
		dc.l ArtNem_HCZMisc	;S3DATA
		dc.w $7940
		dc.l ArtNem_HCZButton	;S3DATA
		dc.w $84C0
		dc.l ArtNem_HCZWaterRush	;S3DATA
		dc.w $6F40
		dc.l ArtNem_HCZWaveSplash	;S3DATA
		dc.w $85C0
		dc.l ArtNem_HCZSpikeBall	;S3DATA
		dc.w $87C0
PLC_0F:	dc.w 0
		dc.l ArtNem_HCZDragonfly	;S3DATA
		dc.w $8980
PLC_10:	dc.w 5
		dc.l ArtNem_Bubbles
		dc.w $8B80
		dc.l ArtNem_HCZMisc	;S3DATA
		dc.w $7940
		dc.l ArtNem_HCZButton	;S3DATA
		dc.w $84C0
		dc.l ArtNem_HCZWaveSplash	;S3DATA
		dc.w $85C0
		dc.l ArtNem_HCZSpikeBall	;S3DATA
		dc.w $87C0
		dc.l ArtNem_HCZ2Slide	;S3DATA
		dc.w $6B80
PLC_11:	dc.w 2
		dc.l ArtNem_HCZ2KnuxWall	;S3DATA
		dc.w $6A00
		dc.l ArtNem_HCZ2BlockPlat	;S3DATA
		dc.w $500
		dc.l ArtNem_HCZDragonfly	;S3DATA
		dc.w $8980
PLC_12_13:	dc.w 3
		dc.l ArtNem_MGZMisc1	;S3DATA
		dc.w $6BE0
		dc.l ArtNem_MGZMisc2	;S3DATA
		dc.w $7FE0
		dc.l ArtNem_MGZSigns	;S3DATA
		dc.w $8A20
		dc.l ArtNem_DiagonalSpring	;S3DATA
		dc.w $8F00
PLC_14_15:	dc.w 3
		dc.l ArtNem_MGZMisc1	;S3DATA
		dc.w $6BE0
		dc.l ArtNem_MGZMisc2	;S3DATA
		dc.w $7FE0
		dc.l ArtNem_MGZSigns	;S3DATA
		dc.w $8A20
		dc.l ArtNem_DiagonalSpring
		dc.w $8F00
PLC_16_17_18_19:	dc.w 2
		dc.l ArtNem_CNZMisc	;S3DATA
		dc.w $6A20
		dc.l ArtNem_Bubbles
		dc.w $8B80
		dc.l ArtNem_CNZPlatform	;S3DATA
		dc.w $8600
PLC_1A_1B:	dc.w 2
		dc.l ArtNem_FBZMisc
		dc.w $6F20
		dc.l ArtNem_FBZOutdoors
		dc.w $5CA0
		dc.l ArtNem_FBZEggCapsule
		dc.w $6BA0
PLC_1C_1D:	dc.w 2
		dc.l ArtNem_FBZMisc
		dc.w $6F20
		dc.l ArtNem_FBZMisc2
		dc.w $5A40
		dc.l ArtNem_FBZEggCapsule
		dc.w $6BA0
PLC_1E_1F:	dc.w 5
		dc.l ArtNem_SnowboardDust
		dc.w $D700
		dc.l ArtNem_DiagonalSpring
		dc.w $8740
		dc.l ArtNem_GrayButton
		dc.w $8AC0
		dc.l ArtNem_ICZMisc1	;S3DATA
		dc.w $76C0
		dc.l ArtNem_ICZIntroSprites	;S3DATA
		dc.w $68E0
		dc.l ArtNem_ICZTeleport
		dc.w $AE00
PLC_20_21:	dc.w 4
		dc.l ArtNem_DiagonalSpring
		dc.w $8740
		dc.l ArtNem_GrayButton
		dc.w $8AC0
		dc.l ArtNem_ICZMisc1	;S3DATA
		dc.w $76C0
		dc.l ArtNem_ICZMisc2	;S3DATA
		dc.w $6EE0
		dc.l ArtNem_Bubbles
		dc.w $8B80
PLC_22_23:	dc.w 1
		dc.l ArtNem_LBZMisc	;S3DATA
		dc.w $7860
		dc.l ArtNem_LBZTubeTrans	;S3DATA
		dc.w $8AA0
PLC_24:	dc.w 1
		dc.l ArtNem_LBZMisc	;S3DATA
		dc.w $7860
		dc.l ArtNem_Bubbles
		dc.w $8B80
PLC_25:	dc.w 0
		dc.l ArtNem_LBZ2Misc	;S3DATA
		dc.w $5D40
PLC_26_27_28_29:	dc.w 2
		dc.l ArtNem_DiagonalSpring
		dc.w $8F00
		dc.l ArtNem_MHZMisc
		dc.w $68E0
		dc.l ArtNem_GrayButton
		dc.w $6820
PLC_2A_2B:	dc.w 1
		dc.l ArtNem_SOZMisc
		dc.w $7920
		dc.l ArtNem_SOZTile
		dc.w $7800
PLC_2C_2D:	dc.w 1
		dc.l ArtNem_SOZMisc
		dc.w $7920
		dc.l ArtNem_SOZ2Extra
		dc.w $75E0
PLC_2E_2F:	dc.w 2
		dc.l ArtNem_LRZMisc
		dc.w $7420
		dc.l ArtNem_LRZSpikes
		dc.w $8700
		dc.l ArtNem_LRZBigSpike
		dc.w $8840
PLC_30_31:	dc.w 1
		dc.l ArtNem_LRZ2Misc
		dc.w $81A0
		dc.l ArtNem_LRZ2Drum
		dc.w $75A0
PLC_32_33_34_35:	dc.w 1
		dc.l ArtNem_SSZMisc
		dc.w $5A80
		dc.l ArtNem_GrayButton
		dc.w $91C0
PLC_36_37:	dc.w 1
		dc.l ArtNem_DEZMisc
		dc.w $69A0
		dc.l ArtNem_DEZMiniboss
		dc.w $5F80
PLC_38_39:	dc.w 1
		dc.l ArtNem_DEZMisc
		dc.w $69A0
		dc.l ArtNem_DEZ2Extra
		dc.w $6640
PLC_3A_3B_3C_3D_3E_3F:	dc.w 0
		dc.l ArtNem_DiagonalSpring
		dc.w $8740
PLC_40_41:	dc.w $FFFF
PLC_42:	dc.w 7
		dc.l ArtNem_2PDashdust	;S3DATA
		dc.w $FC00
		dc.l ArtNem_2PStartPost	;S3DATA
		dc.w $D780
		dc.l ArtNem_2PLapNum	;S3DATA
		dc.w $E000
		dc.l ArtNem_2PTime	;S3DATA
		dc.w $C000
		dc.l ArtNem_2PPosIcon	;S3DATA
		dc.w $EBC0
		dc.l ArtNem_2PArt_2	;S3DATA
		dc.w $7220
		dc.l ArtNem_2PArt_1	;S3DATA
		dc.w $75A0
		dc.l ArtNem_2PArt_3	;S3DATA
		dc.w $78C0
PLC_43:	dc.w 8
		dc.l ArtNem_BPZMisc	;S3DATA
		dc.w $6000
		dc.l ArtNem_2PDashdust	;S3DATA
		dc.w $FC00
		dc.l ArtNem_2PStartPost	;S3DATA
		dc.w $D780
		dc.l ArtNem_2PLapNum	;S3DATA
		dc.w $E000
		dc.l ArtNem_2PTime	;S3DATA
		dc.w $C000
		dc.l ArtNem_2PPosIcon	;S3DATA
		dc.w $EBC0
		dc.l ArtNem_2PArt_2	;S3DATA
		dc.w $7220
		dc.l ArtNem_2PArt_1	;S3DATA
		dc.w $75A0
		dc.l ArtNem_2PArt_3	;S3DATA
		dc.w $78C0
PLC_44:	dc.w 8
		dc.l ArtNem_DPZMisc	;S3DATA
		dc.w $5000
		dc.l ArtNem_2PDashdust	;S3DATA
		dc.w $FC00
		dc.l ArtNem_2PStartPost	;S3DATA
		dc.w $D780
		dc.l ArtNem_2PLapNum	;S3DATA
		dc.w $E000
		dc.l ArtNem_2PTime	;S3DATA
		dc.w $C000
		dc.l ArtNem_2PPosIcon	;S3DATA
		dc.w $EBC0
		dc.l ArtNem_2PArt_2	;S3DATA
		dc.w $7220
		dc.l ArtNem_2PArt_1	;S3DATA
		dc.w $75A0
		dc.l ArtNem_2PArt_3	;S3DATA
		dc.w $78C0
PLC_45:	dc.w 8
		dc.l ArtNem_CGZMisc	;S3DATA
		dc.w $6000
		dc.l ArtNem_2PDashdust	;S3DATA
		dc.w $FC00
		dc.l ArtNem_2PStartPost	;S3DATA
		dc.w $D780
		dc.l ArtNem_2PLapNum	;S3DATA
		dc.w $E000
		dc.l ArtNem_2PTime	;S3DATA
		dc.w $C000
		dc.l ArtNem_2PPosIcon	;S3DATA
		dc.w $EBC0
		dc.l ArtNem_2PArt_2	;S3DATA
		dc.w $7220
		dc.l ArtNem_2PArt_1	;S3DATA
		dc.w $75A0
		dc.l ArtNem_2PArt_3	;S3DATA
		dc.w $78C0
PLC_46:	dc.w 8
		dc.l ArtNem_EMZMisc	;S3DATA
		dc.w $6000
		dc.l ArtNem_2PDashdust	;S3DATA
		dc.w $FC00
		dc.l ArtNem_2PStartPost	;S3DATA
		dc.w $D780
		dc.l ArtNem_2PLapNum	;S3DATA
		dc.w $E000
		dc.l ArtNem_2PTime	;S3DATA
		dc.w $C000
		dc.l ArtNem_2PPosIcon	;S3DATA
		dc.w $EBC0
		dc.l ArtNem_2PArt_2	;S3DATA
		dc.w $7220
		dc.l ArtNem_2PArt_1	;S3DATA
		dc.w $75A0
		dc.l ArtNem_2PArt_3	;S3DATA
		dc.w $78C0
PLC_47:	dc.w 0
		dc.l ArtNem_BonusStage
		dc.w $2B60
PLC_48_49_4A_4B:	dc.w 1
		dc.l ArtNem_HPZEmeraldMisc
		dc.w $76A0
		dc.l ArtNem_HPZGrayEmerald
		dc.w $8EE0
PLC_4C_4D:	dc.w 0
		dc.l ArtNem_FBZRobtonikRun
		dc.w $B180
PLC_4E_4F:	dc.w 0
		dc.l ArtNem_SpikesSprings
		dc.w $9280
PLC_50:	dc.w 1
		dc.l ArtNem_PachinkoMain
		dc.w $59A0
		dc.l ArtNem_BonusStage
		dc.w $7100
PLC_51:	dc.w 0
		dc.l ArtNem_SlotsBlocks
		dc.w $6760
PLC_52:	dc.w 3
		dc.l ArtNem_MilesLifeIcon
		dc.w $FA80
		dc.l ArtNem_Monitors
		dc.w $9880
		dc.l ArtNem_Ring
		dc.w $D780
		dc.l ArtNem_EnemyPts
		dc.w $BC80
PLC_53_Through_5A:	dc.w 3
		dc.l ArtNem_AIZMiniboss	;S3DATA
		dc.w $8340
		dc.l ArtNem_AIZMinibossSmall	;S3DATA
		dc.w $8E80
		dc.l ArtNem_AIZBossFire	;S3DATA
		dc.w $9040
		dc.l ArtNem_BossExplosion
		dc.w $9A40
PLC_5B:	dc.w 1
		dc.l ArtNem_HCZMiniboss	;S3DATA
		dc.w $6080
		dc.l ArtNem_BossExplosion
		dc.w $A000
PLC_5C_5D:	dc.w 1
		dc.l ArtNem_CNZMiniboss	;S3DATA
		dc.w $A5C0
		dc.l ArtNem_BossExplosion
		dc.w $A000
PLC_5E:	dc.w 0
		dc.l ArtNem_BossExplosion
		dc.w $A000
PLC_5F:	dc.w 1
		dc.l ArtNem_ICZMiniboss	;S3DATA
		dc.w $9520
		dc.l ArtNem_BossExplosion
		dc.w $A000
PLC_60:	dc.w 1
		dc.l ArtNem_RobotnikShip
		dc.w $A5C0
		dc.l ArtNem_LBZKnuxBomb	;S3DATA
		dc.w $9AC0
PLC_61:	dc.w 0
		dc.l ArtNem_BossExplosion
		dc.w $A000
PLC_62_Through_6A:	dc.w 3
		dc.l ArtNem_FBZ2Subboss
		dc.w $A5C0
		dc.l ArtNem_FBZRobtonikStand
		dc.w $8CC0
		dc.l ArtNem_FBZRobtonikRun
		dc.w $9520
		dc.l ArtNem_BossExplosion
		dc.w $A000
PLC_6B:	dc.w 1
		dc.l ArtNem_RobotnikShip
		dc.w $A5C0
		dc.l ArtNem_BossExplosion
		dc.w $9A40
PLC_6C:	dc.w 3
		dc.l ArtNem_HCZEndBoss	;S3DATA
		dc.w $6400
		dc.l ArtNem_RobotnikShip
		dc.w $A5C0
		dc.l ArtNem_BossExplosion
		dc.w $A000
		dc.l ArtNem_EggCapsule
		dc.w $9280
PLC_6D:	dc.w 2
		dc.l ArtNem_RobotnikShip
		dc.w $A5C0
		dc.l ArtNem_BossExplosion
		dc.w $A000
		dc.l ArtNem_EggCapsule
		dc.w $9280
PLC_6E:	dc.w 3
		dc.l ArtNem_CNZEndBoss	;S3DATA
		dc.w $8600
		dc.l ArtNem_RobotnikShip
		dc.w $A5C0
		dc.l ArtNem_BossExplosion
		dc.w $A000
		dc.l ArtNem_EggCapsule
		dc.w $9280
PLC_6F:	dc.w 5
		dc.l ArtNem_FBZEndBoss
		dc.w $8000
		dc.l ArtNem_FBZRobtonikHead
		dc.w $8600
		dc.l ArtNem_FBZEndBossFlame
		dc.w $8A00
		dc.l ArtNem_RobotnikShip
		dc.w $A5C0
		dc.l ArtNem_BossExplosion
		dc.w $A000
		dc.l ArtNem_EggCapsule
		dc.w $9280
PLC_70:	dc.w 3
		dc.l ArtNem_ICZEndBoss	;S3DATA
		dc.w $54C0
		dc.l ArtNem_RobotnikShip
		dc.w $A5C0
		dc.l ArtNem_BossExplosion
		dc.w $A000
		dc.l ArtNem_EggCapsule
		dc.w $9280
PLC_71:	dc.w 1
		dc.l ArtNem_LBZFinalBoss1	;S3DATA
		dc.w $7540
		dc.l ArtNem_BossExplosion
		dc.w $A000
PLC_72_73_74_75_76:	dc.w 2
		dc.l ArtNem_FBZRobtonikStand
		dc.w $8CC0
		dc.l ArtNem_FBZRobtonikRun
		dc.w $9520
		dc.l ArtNem_BossExplosion
		dc.w $A000
PLC_77:	dc.w 2
		dc.l ArtNem_RobotnikShip
		dc.w $A5C0
		dc.l ArtNem_FBZRobtonikRun
		dc.w $9520
		dc.l ArtNem_BossExplosion
		dc.w $A000
PLC_78_79_7A_7B:	dc.w 1
		dc.l ArtNem_RobotnikShip
		dc.w $A5C0
		dc.l ArtNem_BossExplosion
		dc.w $A000

; =============== S U B R O U T I N E =======================================


DebugMode:

		moveq	#0,d0
		move.b	($FFFFFE08).w,d0
		move.w	off_92A1C(pc,d0.w),d1
		jmp	off_92A1C(pc,d1.w)
; End of function DebugMode

; ---------------------------------------------------------------------------
off_92A1C:	dc.w loc_92A20-off_92A1C

		dc.w loc_92AB0-off_92A1C
; ---------------------------------------------------------------------------

loc_92A20:
		addq.b	#2,($FFFFFE08).w
		move.l	$C(a0),($FFFFFFCA).w
		cmpi.b	#6,5(a0)
		bcc.s	loc_92A38
		move.w	$A(a0),($FFFFFFCE).w

loc_92A38:
		move.w	($FFFFEEAA).w,d0
		and.w	d0,($FFFFB014).w
		and.w	d0,($FFFFEE7C).w
		clr.b	($FFFFEE0A).w
		clr.w	($FFFFF7C8).w
		bclr	#6,$2A(a0)
		beq.s	loc_92A6E
		movea.l	a0,a1
		jsr	(Player_ResetAirTimer).l
		move.w	#$600,($FFFFF760).w
		move.w	#$C,($FFFFF762).w
		move.w	#$80,($FFFFF764).w

loc_92A6E:
		move.b	#0,$22(a0)
		move.b	#0,$20(a0)
		moveq	#0,d0
		move.w	($FFFFFE10).w,d0
		ror.b	#1,d0
		lsr.w	#6,d0
		andi.w	#$7E,d0
		lea	(DebugOffs).l,a2
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d6
		cmp.b	($FFFFFE06).w,d6
		bhi.s	loc_92AA0
		move.b	#0,($FFFFFE06).w

loc_92AA0:
		bsr.w	sub_92C88
		move.b	#$C,($FFFFFE0A).w
		move.b	#1,($FFFFFE0B).w

loc_92AB0:
		moveq	#0,d0
		move.w	($FFFFFE10).w,d0
		ror.b	#1,d0
		lsr.w	#6,d0
		andi.w	#$7E,d0
		lea	(DebugOffs).l,a2
		adda.w	(a2,d0.w),a2
		move.w	(a2)+,d6
		bsr.w	sub_92AD4
		jmp	(Draw_Sprite).l

; =============== S U B R O U T I N E =======================================


sub_92AD4:
		moveq	#0,d4
		move.w	#1,d1
		move.b	($FFFFF605).w,d4
		andi.w	#$F,d4
		bne.s	loc_92B16
		move.b	($FFFFF604).w,d0
		andi.w	#$F,d0
		bne.s	loc_92AFE
		move.b	#$C,($FFFFFE0A).w
		move.b	#$F,($FFFFFE0B).w
		bra.w	loc_92B7A
; ---------------------------------------------------------------------------

loc_92AFE:
		subq.b	#1,($FFFFFE0A).w
		bne.s	loc_92B1A
		move.b	#1,($FFFFFE0A).w
		addq.b	#1,($FFFFFE0B).w
		bne.s	loc_92B16
		move.b	#-1,($FFFFFE0B).w

loc_92B16:

		move.b	($FFFFF604).w,d4

loc_92B1A:
		moveq	#0,d1
		move.b	($FFFFFE0B).w,d1
		addq.w	#1,d1
		swap	d1
		asr.l	#4,d1
		move.l	$14(a0),d2
		move.l	$10(a0),d3
		btst	#0,d4
		beq.s	loc_92B44
		sub.l	d1,d2
		moveq	#0,d0
		move.w	($FFFFEE18).w,d0
		swap	d0
		cmp.l	d0,d2
		bge.s	loc_92B44
		move.l	d0,d2

loc_92B44:

		btst	#1,d4
		beq.s	loc_92B5E
		add.l	d1,d2
		moveq	#0,d0
		move.w	($FFFFEE12).w,d0
		addi.w	#$DF,d0
		swap	d0
		cmp.l	d0,d2
		blt.s	loc_92B5E
		move.l	d0,d2

loc_92B5E:

		btst	#2,d4
		beq.s	loc_92B6A
		sub.l	d1,d3
		bcc.s	loc_92B6A
		moveq	#0,d3

loc_92B6A:

		btst	#3,d4
		beq.s	loc_92B72
		add.l	d1,d3

loc_92B72:
		move.l	d2,$14(a0)
		move.l	d3,$10(a0)

loc_92B7A:
		btst	#6,($FFFFF604).w
		beq.s	loc_92BB2
		btst	#5,($FFFFF605).w
		beq.s	loc_92B96
		subq.b	#1,($FFFFFE06).w
		bcc.s	loc_92BAE
		add.b	d6,($FFFFFE06).w
		bra.s	loc_92BAE
; ---------------------------------------------------------------------------

loc_92B96:
		btst	#6,($FFFFF605).w
		beq.s	loc_92BB2
		addq.b	#1,($FFFFFE06).w
		cmp.b	($FFFFFE06).w,d6
		bhi.s	loc_92BAE
		move.b	#0,($FFFFFE06).w

loc_92BAE:

		bra.w	sub_92C88
; ---------------------------------------------------------------------------

loc_92BB2:

		btst	#5,($FFFFF605).w
		beq.s	loc_92C0C
		jsr	(Create_New_Sprite).l
		bne.s	loc_92C0C
		move.w	$10(a0),$10(a1)
		move.w	$14(a0),$14(a1)
		move.b	4(a0),4(a1)
		move.b	4(a0),$2A(a1)
		andi.b	#$7F,$2A(a1)
		moveq	#0,d0
		move.b	($FFFFFE06).w,d0
		add.w	d0,d0
		move.w	d0,d1
		lsl.w	#2,d0
		add.w	d1,d0
		move.b	4(a2,d0.w),$2C(a1)
		move.l	(a2,d0.w),(a1)
		move.b	#0,(a1)
		cmpi.l	#Obj_Monitor,(a1)
		bne.s	locret_92C0A
		move.b	#9,$2C(a1)

locret_92C0A:
		rts
; ---------------------------------------------------------------------------

loc_92C0C:

		btst	#4,($FFFFF605).w
		beq.s	locret_92C52
		moveq	#0,d0
		move.w	d0,($FFFFFE08).w
		move	#$2700,sr
		jsr	(sub_DE9C).l
		move.b	#1,($FFFFFE1F).w
		move.b	#-$80,($FFFFFE1D).w
		move	#$2300,sr
		lea	($FFFFB000).w,a1
		move.l	($FFFFFFCA).w,$C(a1)
		move.w	($FFFFFFCE).w,$A(a1)
		bsr.s	sub_92C54
		move.b	#$13,$1E(a1)
		move.b	#9,$1F(a1)

locret_92C52:
		rts
; End of function sub_92AD4


; =============== S U B R O U T I N E =======================================


sub_92C54:
		move.b	d0,$20(a1)
		move.w	d0,$12(a1)
		move.w	d0,$16(a1)
		move.b	d0,$2E(a1)
		move.b	d0,$3D(a1)
		move.w	d0,$18(a1)
		move.w	d0,$1A(a1)
		move.w	d0,$1C(a1)
		andi.b	#1,$2A(a1)
		ori.b	#2,$2A(a1)
		move.b	#2,5(a1)
		rts
; End of function sub_92C54


; =============== S U B R O U T I N E =======================================


sub_92C88:

		moveq	#0,d0
		move.b	($FFFFFE06).w,d0
		add.w	d0,d0
		move.w	d0,d1
		lsl.w	#2,d0
		add.w	d1,d0
		move.l	4(a2,d0.w),$C(a0)
		move.w	8(a2,d0.w),$A(a0)
		move.b	(a2,d0.w),$22(a0)
		rts
; End of function sub_92C88

; ---------------------------------------------------------------------------
DebugOffs:	include "Levels\Misc\Debug list pointers.asm"

Debug_AIZ1:	include "Levels\AIZ\Debug\Act 1.asm"
Debug_AIZ2:	include "Levels\AIZ\Debug\Act 2.asm"
Debug_HCZ:	include "Levels\HCZ\Debug\Main.asm"
Debug_MGZ:	include "Levels\MGZ\Debug\Main.asm"
Debug_CNZ:	include "Levels\CNZ\Debug\Main.asm"
Debug_FBZ1:	include "Levels\FBZ\Debug\Act 1.asm"
Debug_FBZ2:	include "Levels\FBZ\Debug\Act 2.asm"
Debug_ICZ1:	include "Levels\ICZ\Debug\Act 1.asm"
Debug_ICZ2:	include "Levels\ICZ\Debug\Act 2.asm"
Debug_LBZ1:	include "Levels\LBZ\Debug\Act 1.asm"
Debug_LBZ2:	include "Levels\LBZ\Debug\Act 2.asm"
Debug_MHZ:	include "Levels\MHZ\Debug\Main.asm"
Debug_SOZ1:	include "Levels\SOZ\Debug\Act 1.asm"
Debug_SOZ2:	include "Levels\SOZ\Debug\Act 2.asm"
Debug_LRZ1:	include "Levels\LRZ\Debug\Act 1.asm"
Debug_LRZ2:	include "Levels\LRZ\Debug\Act 2.asm"
Debug_SSZ:	include "Levels\SSZ\Debug\Main.asm"
Debug_DEZ1:	include "Levels\DEZ\Debug\Act 1.asm"
Debug_DEZ2:	include "Levels\DEZ\Debug\Act 2.asm"
Debug_DDZ:	include "Levels\DDZ\Debug\Main.asm"
DebugDEZBoss:	include "Levels\DEZ\Debug\Boss.asm"
Debug_Ending:	include "Levels\SSZ\Debug\Ending.asm"
Debug_ALZ:	include "Levels\ALZ\Debug\Main.asm"
Debug_BPZ:	include "Levels\BPZ\Debug\Main.asm"
Debug_DPZ:	include "Levels\DPZ\Debug\Main.asm"
Debug_CGZ:	include "Levels\CGZ\Debug\Main.asm"
Debug_EMZ:	include "Levels\EMZ\Debug\Main.asm"
Debug_Pachinko_Special:include "Levels\Pachinko\Debug\Main.asm"
Debug_HPZ:	include "Levels\HPZ\Debug\Main.asm"
Debug_Gumball_Special:include "Levels\Gumball\Debug\Main.asm"
Sprite_Listing3:include "Levels\Misc\Object list - Sonic 3.asm"
Sprite_ListingK:include "Levels\Misc\Object list - Sonic & Knuckles.asm"

;Sprite_Listing_Padding:
		if ~~strip_padding
			align $1000
		else
			even
		endif

AngleArray:	binclude "Levels\Misc\angles.bin"

HeightMaps:	binclude "Levels\Misc\Height Maps.bin"
HeightMapsRot:	binclude "Levels\Misc\Height Maps Rotated.bin"
	if Sonic3_Complete=0
SolidIndexes:	dc.l Solid_AIZ1
		dc.l Solid_AIZ2
		dc.l Solid_HCZ1
		dc.l Solid_HCZ2
		dc.l Solid_MGZ1
		dc.l Solid_MGZ2
		dc.l Solid_CNZ
		dc.l Solid_CNZ
		dc.l Solid_FBZ
		dc.l Solid_FBZ
		dc.l Solid_ICZ1
		dc.l Solid_ICZ2
		dc.l Solid_LBZ1
		dc.l Solid_LBZ2
		dc.l Solid_MHZ
		dc.l Solid_MHZ
		dc.l Solid_SOZ
		dc.l Solid_SOZ
		dc.l Solid_LRZ1
		dc.l Solid_LRZ2
		dc.l Solid_SSZ1
		dc.l Solid_SSZ2
		dc.l Solid_DEZ
		dc.l Solid_DEZ
		dc.l Solid_DDZ
		dc.l Solid_DDZ
		dc.l Solid_Pachinko_Special
		dc.l Solid_Pachinko_Special
		dc.l Solid_ALZ
		dc.l Solid_ALZ
		dc.l Solid_BPZ
		dc.l Solid_BPZ
		dc.l Solid_DPZ
		dc.l Solid_DPZ
		dc.l Solid_CGZ
		dc.l Solid_CGZ
		dc.l Solid_EMZ
		dc.l Solid_EMZ
		dc.l Solid_Gumball_Special
		dc.l Solid_Gumball_Special
		dc.l Solid_Pachinko_Special
		dc.l Solid_Pachinko_Special
		dc.l Solid_Slots_Special
		dc.l Solid_Slots_Special
		dc.l Solid_LRZBoss
		dc.l Solid_HPZ
		dc.l Solid_HPZ
		dc.l Solid_HPZ
	else
SolidIndexes:	dc.l Solid_AIZ1+1
		dc.l Solid_AIZ2+1
		dc.l Solid_HCZ1+1
		dc.l Solid_HCZ2+1
		dc.l Solid_MGZ1+1
		dc.l Solid_MGZ2+1
		dc.l Solid_CNZ+1
		dc.l Solid_CNZ+1
		dc.l Solid_FBZ
		dc.l Solid_FBZ
		dc.l Solid_ICZ1+1
		dc.l Solid_ICZ2+1
		dc.l Solid_LBZ1+1
		dc.l Solid_LBZ2+1
		dc.l Solid_MHZ
		dc.l Solid_MHZ
		dc.l Solid_SOZ
		dc.l Solid_SOZ
		dc.l Solid_LRZ1
		dc.l Solid_LRZ2
		dc.l Solid_SSZ1
		dc.l Solid_SSZ2
		dc.l Solid_DEZ
		dc.l Solid_DEZ
		dc.l Solid_DDZ
		dc.l Solid_DDZ
		dc.l Solid_Pachinko_Special
		dc.l Solid_Pachinko_Special
		dc.l Solid_ALZ+1
		dc.l Solid_ALZ+1
		dc.l Solid_BPZ+1
		dc.l Solid_BPZ+1
		dc.l Solid_DPZ+1
		dc.l Solid_DPZ+1
		dc.l Solid_CGZ+1
		dc.l Solid_CGZ+1
		dc.l Solid_EMZ+1
		dc.l Solid_EMZ+1
		dc.l Solid_Gumball_Special+1
		dc.l Solid_Gumball_Special+1
		dc.l Solid_Pachinko_Special
		dc.l Solid_Pachinko_Special
		dc.l Solid_Slots_Special
		dc.l Solid_Slots_Special
		dc.l Solid_LRZBoss
		dc.l Solid_HPZ
		dc.l Solid_HPZ
		dc.l Solid_HPZ
	endif
Solid_FBZ:					binclude "Levels\FBZ\Collision\1.bin"
Solid_MHZ:					binclude "Levels\MHZ\Collision\1.bin"
Solid_Unknown:				binclude "Levels\Misc\Unknown Collision.bin"
Solid_SOZ:					binclude "Levels\SOZ\Collision\1.bin"
Solid_LRZ1:					binclude "Levels\LRZ\Collision\1.bin"
Solid_LRZ2:					binclude "Levels\LRZ\Collision\2.bin"
Solid_SSZ1:					binclude "Levels\SSZ\Collision\1.bin"
Solid_SSZ2:					binclude "Levels\SSZ\Collision\2.bin"
Solid_DEZ:					binclude "Levels\DEZ\Collision\1.bin"
Solid_DDZ:					binclude "Levels\DDZ\Collision\1.bin"
Solid_Pachinko_Special:		binclude "Levels\Pachinko\Collision\1.bin"
Solid_Slots_Special:		binclude "Levels\Slots\Collision\1.bin"
Solid_LRZBoss:				binclude "Levels\LRZ\Collision\3.bin"
Solid_HPZ:					binclude "Levels\HPZ\Collision\1.bin"
LevelPtrs:	dc.l Layout_AIZ1	; 0
		dc.l Layout_AIZ2	; 1
		dc.l Layout_HCZ1	; 2
		dc.l Layout_HCZ2	; 3
		dc.l Layout_MGZ1	; 4
		dc.l Layout_MGZ2	; 5
		dc.l Layout_CNZ1	; 6
		dc.l Layout_CNZ2	; 7
		dc.l Layout_FBZ1	; 8
		dc.l Layout_FBZ2	; 9
		dc.l Layout_ICZ1	; 10
		dc.l Layout_ICZ2	; 11
		dc.l Layout_LBZ1	; 12
		dc.l Layout_LBZ2	; 13
		dc.l Layout_MHZ1	; 14
		dc.l Layout_MHZ2	; 15
		dc.l Layout_SOZ1	; 16
		dc.l Layout_SOZ2	; 17
		dc.l Layout_LRZ1	; 18
		dc.l Layout_LRZ2	; 19
		dc.l Layout_SSZ1	; 20
		dc.l Layout_SSZ2	; 21
		dc.l Layout_DEZ1	; 22
		dc.l Layout_DEZ2	; 23
		dc.l Layout_DDZ		; 24
		dc.l Layout_DDZ		; 25
		dc.l Layout_SSZ2	; 26
		dc.l Layout_SSZ2	; 27
		dc.l Layout_ALZ		; 28
		dc.l Layout_ALZ		; 29
		dc.l Layout_BPZ		; 30
		dc.l Layout_BPZ		; 31
		dc.l Layout_DPZ		; 32
		dc.l Layout_DPZ		; 33
		dc.l Layout_CGZ		; 34
		dc.l Layout_CGZ		; 35
		dc.l Layout_EMZ		; 36
		dc.l Layout_EMZ		; 37
		dc.l Layout_Gumball_Special; 38
		dc.l Layout_Gumball_Special; 39
		dc.l Layout_Pachinko_Special; 40
		dc.l Layout_Pachinko_Special; 41
		dc.l Layout_Slots_Special; 42
		dc.l Layout_Slots_Special; 43
		dc.l Layout_LRZBoss	; 44
		dc.l Layout_HPZ		; 45
		dc.l Layout_DEZBoss	; 46
		dc.l Layout_HPZ		; 47
Layout_FBZ1:	binclude "Levels\FBZ\Layout\1.bin"
Layout_FBZ2:	binclude "Levels\FBZ\Layout\2.bin"
Layout_MHZ1:	binclude "Levels\MHZ\Layout\1.bin"
Layout_MHZ2:	binclude "Levels\MHZ\Layout\2.bin"
Layout_SOZ1:	binclude "Levels\SOZ\Layout\1.bin"
Layout_SOZ2:	binclude "Levels\SOZ\Layout\2.bin"
Layout_LRZ1:	binclude "Levels\LRZ\Layout\1.bin"
Layout_LRZ2:	binclude "Levels\LRZ\Layout\2.bin"
Layout_SSZ1:	binclude "Levels\SSZ\Layout\1.bin"
Layout_SSZ2:	binclude "Levels\SSZ\Layout\2.bin"
Layout_DEZ1:	binclude "Levels\DEZ\Layout\1.bin"
Layout_DEZ2:	binclude "Levels\DEZ\Layout\2.bin"
Layout_DDZ:	binclude "Levels\DDZ\Layout\1.bin"
Layout_Pachinko_Special:binclude "Levels\Pachinko\Layout\1.bin"
Layout_Slots_Special:binclude "Levels\Slots\Layout\1.bin"
Layout_LRZBoss:	binclude "Levels\LRZ\Layout\3.bin"
Layout_HPZ:	binclude "Levels\HPZ\Layout\1.bin"

Layout_DEZBoss:	binclude "Levels\DEZ\Layout\3.bin"
MHZ_Custom_Layout:binclude "Levels\MHZ\Layout\3.bin"
PalPoint:
	include "Levels\Misc\Palette pointers.asm"
Pal_Unknown1:	binclude "Levels\Misc\Palettes\Unknown 1.bin"

Pal_Unknown2: binclude "Levels\Misc\Palettes\Unknown 2.bin"

Pal_Unknown3: binclude "Levels\Misc\Palettes\Unknown 3.bin"

Pal_SonicTails: binclude "General\Sprites\Sonic\Palettes\SonicAndTails.bin"

Pal_SonicTailsS2:	binclude "General\Sprites\Sonic\Palettes\\SonicAndTailsS2.bin" 

Pal_Knuckles:	binclude "General\Sprites\Knuckles\Palettes\Main.bin"

Pal_AIZIntro:	binclude "Levels\AIZ\Palettes\Intro.bin"

Pal_AIZ:	binclude "Levels\AIZ\Palettes\Main.bin"

Pal_AIZFire:	binclude "Levels\AIZ\Palettes\Fire.bin"

Pal_AIZBoss:	binclude "Levels\AIZ\Palettes\Boss.bin"

Pal_AIZ_Water:	binclude "Levels\AIZ\Palettes\Water.bin"

Pal_AIZ2_Water:	binclude "Levels\AIZ\Palettes\Act 2 Water.bin"

Pal_HCZ1:	binclude "Levels\HCZ\Palettes\1.bin"

Pal_HCZ2:	binclude "Levels\HCZ\Palettes\2.bin"

Pal_HCZ1_Water:	binclude "Levels\HCZ\Palettes\Act 1 Water.bin"

Pal_HCZ2_Water:	binclude "Levels\HCZ\Palettes\Act 2 Water.bin"

Pal_MGZ:	binclude "Levels\MGZ\Palettes\Main.bin"


Pal_CNZ:	binclude "Levels\CNZ\Palettes\Main.bin"

Pal_CNZ_Water:	binclude "Levels\CNZ\Palettes\Water.bin"

Pal_FBZ1:	binclude "Levels\FBZ\Palettes\FBZ1.bin"

Pal_FBZ2:	binclude "Levels\FBZ\Palettes\FBZ2.bin"

Pal_ICZ1:	binclude "Levels\ICZ\Palettes\1.bin"

Pal_ICZ2:	binclude "Levels\ICZ\Palettes\2.bin"


Pal_ICZ2_Water:	binclude "Levels\ICZ\Palettes\Act 2 Water.bin"

Pal_LBZ1:	binclude "Levels\LBZ\Palettes\1.bin"


Pal_LBZ2:	binclude "Levels\LBZ\Palettes\2.bin"

Pal_LBZ_Water:	binclude "Levels\LBZ\Palettes\Act 2 Water.bin"


Pal_LBZ_Water2:	binclude "Levels\LBZ\Palettes\Act 2 Water 2.bin"

Pal_MHZ1:	binclude "Levels\MHZ\Palettes\1.bin"

Pal_MHZ2:	binclude "Levels\MHZ\Palettes\2.bin"


Pal_SOZ1:	binclude "Levels\SOZ\Palettes\1.bin"

Pal_S0Z2:	binclude "Levels\SOZ\Palettes\2.bin"

Pal_SOZ1_Clone:	binclude "Levels\SOZ\Palettes\Act 1 Clone.bin"

Pal_SOZ2_Extra:	binclude "Levels\SOZ\Palettes\Act 2 Extra.bin"

Pal_LRZ1:	binclude "Levels\LRZ\Palettes\1.bin"


Pal_LRZ2:	binclude "Levels\LRZ\Palettes\2.bin"


Pal_SSZ1:	binclude "Levels\SSZ\Palettes\1.bin"


Pal_SSZ2:	binclude "Levels\SSZ\Palettes\2.bin"

Pal_EndingObjects:	binclude "General\Ending\Palettes\Objects.bin"


Pal_Ending1:	binclude "General\Ending\Palettes\Ending 1.bin"


Pal_Ending2:	binclude "General\Ending\Palettes\Ending 2.bin"


Pal_DEZ1:	binclude "Levels\DEZ\Palettes\1.bin"

Pal_DEZ2:	binclude "Levels\DEZ\Palettes\2.bin"

Pal_DDZ:	binclude "Levels\DDZ\Palettes\Main.bin"


Pal_ALZ:	binclude "Levels\ALZ\Palettes\Main.bin"


Pal_BPZ:	binclude "Levels\BPZ\Palettes\Main.bin"


Pal_DPZ:	binclude "Levels\DPZ\Palettes\Main.bin"

Pal_CGZ:	binclude "Levels\CGZ\Palettes\Main.bin"

Pal_EMZ:	binclude "Levels\EMZ\Palettes\Main.bin"

Pal_Gumball_Special:binclude "Levels\Gumball\Palettes\Main.bin"

Pal_Pachinko_Special:binclude "Levels\Pachinko\Palettes\Main.bin"

Pal_Slot_Special:binclude "Levels\Slots\Palettes\Main.bin"

Pal_LRZBoss:	binclude "Levels\LRZ\Palettes\Boss Act.bin"

Pal_HPZ_A:	binclude "Levels\HPZ\Palettes\1_A.bin"


Pal_HPZ_B:	binclude "Levels\HPZ\Palettes\1_B.bin"

Pal_DEZBoss:	binclude "Levels\DEZ\Palettes\Boss.bin"


ArtUnc_AirCountDown:binclude "General\Sprites\Air Countdown\Air Countdown.bin"

ArtUnc_SONICMILES:binclude "General\Sprites\S2Menu\SONICMILES.bin"

ArtUnc_SStageSonic:binclude "General\Sprites\Sonic\Art\SStage Sonic.bin"

	include "General\Sprites\Sonic\Map - SStage Sonic.asm"

ArtUnc_SStageKnuckles:binclude "General\Sprites\Knuckles\Art\SStage Knuckles.bin"

	include "General\Sprites\Knuckles\Map - SStage Knuckles.asm"

ArtNem_SStageShadow:	binclude "General\Special Stage\Nemesis Art\Shadow.bin"
	even
ArtNem_GetBlueSpheres:	binclude "General\Special Stage\Nemesis Art\Get Blue Spheres.bin"
	even
ArtNem_GBSArrow:	binclude "General\Special Stage\Nemesis Art\Get Blue Spheres Arrow.bin"
	even
ArtNem_SStageDigits:	binclude "General\Special Stage\Nemesis Art\Digits.bin"
	even
ArtNem_SStageIcons:	binclude "General\Special Stage\Nemesis Art\Icons.bin"
	even
ArtNem_SStageSphere:	binclude "General\Special Stage\Nemesis Art\Sphere.bin"
	even
ArtNem_SStageRing:	binclude "General\Special Stage\Nemesis Art\Ring.bin"
	even
ArtKosM_SStageChaosEmerald:binclude "General\Special Stage\KosinskiM Art\Special Stage Chaos Emerald.bin"
	even
ArtKosM_SStageSuperEmerald:binclude "General\Special Stage\KosinskiM Art\Special Stage Super Emerald.bin"
	even
MapEni_SStageBG:	binclude "General\Special Stage\Enigma Map\BG.bin"
	even
ArtNem_SStageBG:	binclude "General\Special Stage\Nemesis Art\BG.bin"
	even
MapEni_SStageLayout:	binclude "General\Special Stage\Enigma Map\Layout.bin"
	even
ArtNem_SStageLayout:	binclude "General\Special Stage\Nemesis Art\Layout.bin"
	even
SStageKos_PerspectiveMaps:	binclude "General\Special Stage\Layout\Perspective Maps.bin"
	even

;SStage_Padding:
	if ~~strip_padding
		cnop0 -$40,$100
	endif

ArtUnc_AniFBZ__0:	binclude "Levels\FBZ\Animated Tiles\0.bin"
	even
ArtUnc_AniFBZ__1:	binclude "Levels\FBZ\Animated Tiles\1.bin"
	even
ArtUnc_AniFBZ__2:	binclude "Levels\FBZ\Animated Tiles\2.bin"
	even
ArtUnc_AniFBZ__3:	binclude "Levels\FBZ\Animated Tiles\3.bin"
	even
ArtUnc_AniFBZ__4:	binclude "Levels\FBZ\Animated Tiles\4.bin"
	even
ArtUnc_AniMHZ__BG:	binclude "Levels\MHZ\Animated Tiles\BG 1.bin"
	even
ArtUnc_AniMHZ__BG2:	binclude "Levels\MHZ\Animated Tiles\BG 2.bin"
	even
ArtUnc_AniMHZ__0:	binclude "Levels\MHZ\Animated Tiles\0.bin"
	even
ArtUnc_AniMHZ__1:	binclude "Levels\MHZ\Animated Tiles\1.bin"
	even
ArtUnc_AniMHZ__2:	binclude "Levels\MHZ\Animated Tiles\2.bin"
	even
ArtUnc_AniMHZ__3:	binclude "Levels\MHZ\Animated Tiles\3.bin"
	even
ArtUnc_AniSOZ1_BG:	binclude "Levels\SOZ\Animated Tiles\Act1 BG 1.bin"
	even
ArtUnc_AniSOZ1_BG2:	binclude "Levels\SOZ\Animated Tiles\Act1 BG 2.bin"
	even
ArtUnc_AniSOZ2_BG:	binclude "Levels\SOZ\Animated Tiles\Act2 BG.bin"
	even
ArtUnc_AniLRZ__BG:	binclude "Levels\LRZ\Animated Tiles\BG 1.bin"
	even
ArtUnc_AniLRZ__BG2:	binclude "Levels\LRZ\Animated Tiles\BG 2.bin"
	even
ArtUnc_AniLRZ1_0:	binclude "Levels\LRZ\Animated Tiles\Act1 0.bin"
	even
ArtUnc_AniLRZ1_1:	binclude "Levels\LRZ\Animated Tiles\Act1 1.bin"
	even
ArtUnc_AniLRZ2_0:	binclude "Levels\LRZ\Animated Tiles\Act2 0.bin"
	even
ArtUnc_AniLRZ2_1:	binclude "Levels\LRZ\Animated Tiles\Act2 1.bin"
	even
ArtUnc_AniHPZ__0:	binclude "Levels\HPZ\Animated Tiles\0.bin"
	even
ArtUnc_AniHPZ__1:	binclude "Levels\HPZ\Animated Tiles\1.bin"
	even
ArtUnc_AniHPZ__2:	binclude "Levels\HPZ\Animated Tiles\2.bin"
	even
ArtUnc_AniHPZ__3:	binclude "Levels\HPZ\Animated Tiles\3.bin"
	even
ArtUnc_AniSSZ__0:	binclude "Levels\SSZ\Animated Tiles\0.bin"
	even
ArtUnc_AniSSZ__1:	binclude "Levels\SSZ\Animated Tiles\1.bin"
	even
ArtUnc_AniSSZ__2:	binclude "Levels\SSZ\Animated Tiles\2.bin"
	even
ArtUnc_AniSSZ__3:	binclude "Levels\SSZ\Animated Tiles\3.bin"
	even
ArtUnc_AniSSZ__4:	binclude "Levels\SSZ\Animated Tiles\4.bin"
	even
ArtUnc_AniSSZ__5:	binclude "Levels\SSZ\Animated Tiles\5.bin"
	even
ArtUnc_AniDEZ__0:	binclude "Levels\DEZ\Animated Tiles\0.bin"
	even
ArtUnc_AniDEZ__1:	binclude "Levels\DEZ\Animated Tiles\1.bin"
	even
ArtUnc_AniDEZ__2:	binclude "Levels\DEZ\Animated Tiles\2.bin"
	even
ArtUnc_AniDEZ__3:	binclude "Levels\DEZ\Animated Tiles\3.bin"
	even
ArtUnc_AniDEZ__4:	binclude "Levels\DEZ\Animated Tiles\4.bin"
	even
ArtUnc_AniDEZ__5:	binclude "Levels\DEZ\Animated Tiles\5.bin"
	even
ArtUnc_AniDEZ__6:	binclude "Levels\DEZ\Animated Tiles\6.bin"
	even
ArtUnc_AniDEZ__7:	binclude "Levels\DEZ\Animated Tiles\7.bin"
	even
ArtUnc_AniPachinko:binclude "Levels\Pachinko\Animated Tiles\0.bin"
	even
ArtNem_S22POptions:binclude "General\Sprites\S2Menu\2P Options.bin"
	even

MapEni_S22POptions:binclude "General\Sprites\S2Menu\2P Options Enigma.bin"

LRZ1_Rock_Placement:	binclude "Levels\LRZ\Misc\Act 1 Rock Placement.bin"

LRZ2_Rock_Placement:	binclude "Levels\LRZ\Misc\Act 2 Rock Placement.bin"

Map_SKTitle_SonicFall:	include "General\Title\Map - SK Sonic Falling.asm"
	even
Map_SKTitle_DeathEgg:	include "General\Title\Map - SK Death Egg.asm"
	even
Map_SKTitle_Banner:	include "General\Title\Map - SK Banner.asm"
	even
Map_SKTitle_Mountain:	include "General\Title\Map - SK Mountain.asm"
	even
MapEni_SKTitle_Sega:			binclude "General\Title\Enigma Map\SK SEGA.bin"
	even
MapEni_SKTitle_Frame1:				binclude "General\Title\Enigma Map\SK SonicKnux Frame 1.bin"
	even
MapEni_SKTitle_Frame2:				binclude "General\Title\Enigma Map\SK SonicKnux Frame 2.bin"
	even
MapEni_SKTitle_Frame3:				binclude "General\Title\Enigma Map\SK SonicKnux Frame 3.bin"
	even
MapEni_SKTitle_Frame4:				binclude "General\Title\Enigma Map\SK SonicKnux Frame 4.bin"
	even
MapEni_SKTitle_Background:		binclude "General\Title\Enigma Map\SK Background.bin"
	even
ArtKos_BigSEGA:					binclude "General\Title\Kosinski Art\SK Big SEGA.bin"
	even
ArtKos_SKTitleScreenBG:			binclude "General\Title\Kosinski Art\SK Screen Background.bin"
	even
ArtKosM_SonicKnuxStand:			binclude "General\Title\KosinskiM Art\SK Sonic Knuckles.bin"
	even
ArtKosM_SonicLand:				binclude "General\Title\KosinskiM Art\SK Sonic Land Frames.bin"
	even
ArtKos_SKTitle_SonicFall:		binclude "General\Title\Kosinski Art\SK Sonic Falling.bin"
	even
ArtKos_SKTitle_DeathEgg:		binclude "General\Title\Kosinski Art\SK Death Egg.bin"
	even
ArtKos_SKTitle_Mountain:		binclude "General\Title\Kosinski Art\SK Mountain Sprite.bin"
	even
ArtKosM_SKTitle_Banner:			binclude "General\Title\KosinskiM Art\SK Banner.bin"
	even
ArtKos_SKTitle_SonKnuxHand:		binclude "General\Title\Kosinski Art\SK Sonic and Knuckles Hands.bin"
	even
ArtKosM_SKTitle_Menu:			binclude "General\Title\KosinskiM Art\SK Menu.bin"
	even
ArtNem_Title_ANDKnuckles:	binclude "General\Title\Nemesis Art\SK ANDKnuckles.bin"
	even
ArtKosM_ResultsKNUCKLES:				binclude "General\Sprites\Results\Results KNUCKLES.bin"
	even
ArtKosM_ResultsGeneral:		binclude "General\Sprites\Results\Results General.bin"
	even
ArtKosM_TitleCardNum1:	binclude "General\Sprites\Title Card\Title Card Number 1.bin"
	even

ArtKosM_TitleCardNum2:	binclude "General\Sprites\Title Card\Title Card Number 2.bin"
	even

ArtKosM_TitleCardRedAct:	binclude "General\Sprites\Title Card\Title Card Red ACT.bin"
	even
ArtKosM_FBZTitleCard:	binclude "Levels\FBZ\KosinskiM Art\Title Card.bin"
	even
ArtKosM_BonusTitleCard:	binclude "General\Sprites\Title Card\Bonus Title Card.bin"
	even
ArtNem_BossExplosion:	binclude "General\Sprites\Boss Explosion\Boss Explosion.bin"
	even

ArtNem_RobotnikShip:	binclude "General\Sprites\Robotnik\Ship.bin"
	even

ArtNem_FBZRobtonikHead:	binclude "General\Sprites\Robotnik\FBZ Robotnik Head.bin"
	even
ArtNem_FBZRobtonikStand:	binclude "General\Sprites\Robotnik\FBZ Robotnik Stand.bin"
	even

ArtNem_FBZRobtonikRun:	binclude "General\Sprites\Robotnik\FBZ Robotnik Run.bin"
	even

ArtUnc_SSEntryRing:	binclude "General\Sprites\SS Entry\Entry Ring.bin"
	even
ArtUnc_SSEntryFlash:	binclude "General\Sprites\SS Entry\Entry Flash.bin"
	even
ArtKosM_BadnikExplosion:	binclude "General\Sprites\Enemy Misc\Badnik Explosion.bin"
	even
ArtNem_FBZMinibossUnused:	binclude "Levels\FBZ\Nemesis Art\Miniboss Unused.bin"
	even
ArtNem_FBZ2Subboss:	binclude "Levels\FBZ\Nemesis Art\Act 2 Subboss.bin"
	even

ArtNem_FBZEndBoss:	binclude "Levels\FBZ\Nemesis Art\End Boss.bin"
	even
ArtKosM_Blaster:	binclude "General\Sprites\Blaster\Blaster.bin"
	even
ArtKosM_Technosqueek:	binclude "General\Sprites\Technosqueek\Technosqueek.bin"
	even
ArtUnc_EndSigns:	binclude "General\Sprites\Signpost\End Signs.bin"
	even
ArtNem_SignpostStub:	binclude "General\Sprites\Signpost\Stub.bin"
	even
ArtNem_EggCapsule:	binclude "General\Sprites\Robotnik\Egg Capsule.bin"
	even

ArtNem_BlueSphereText:	binclude "General\Blue Sphere\Nemesis Art\Large Text.bin"
	even

ArtNem_FBZEndBossFlame:	binclude "Levels\FBZ\Nemesis Art\End Boss Flame.bin"
	even
ArtKosM_ANDKnuckles:dc.w $4C0
ArtKos_ANDKnuckles: binclude "General\Title\Kosinski Art\SK ANDKnuckles Subtitle.bin"
	even

;Padding_DE684:
	if ~~strip_padding
		cnop -$600,$1000
	endif

ArtNem_Knux_Ending_Pose:binclude "General\Ending\Nemesis Art\Knuckles Ending Pose.bin"

	if Sonic3_Complete=0
; Some sprite pointers below point to S2 or S2K data, which we're not dealing with in this disassembly for the time being
; As such, they are intentionally left unlabelled
S2K_Sprite_Lists:dc.l S2KSprite_EHZ1	 ; 0
		dc.l S2KSprite_EHZ2		; 1
		dc.l S2KSprite_NULL		; 2
		dc.l S2KSprite_NULL		; 3
		dc.l S2KSprite_NULL		; 4
		dc.l S2KSprite_NULL		; 5
		dc.l S2KSprite_NULL		; 6
		dc.l S2KSprite_NULL		; 7
		dc.l S2KSprite_MTZ1		; 8
		dc.l S2KSprite_MTZ2		; 9
		dc.l S2KSprite_MTZ3		; 10
		dc.l S2KSprite_MTZ3		; 11
		dc.l S2KSprite_WFZ		; 12
		dc.l S2KSprite_NULL2		; 13
		dc.l S2KSprite_HTZ1		; 14
		dc.l S2KSprite_HTZ2		; 15
		dc.l $2E8C80		;byte_2E8C80	; 16
		dc.l $2E8D94		;byte_2E8D94	; 17
		dc.l S2KSprite_NULL		; 18
		dc.l S2KSprite_NULL		; 19
		dc.l S2KSprite_OOZ1		; 20
		dc.l S2KSprite_OOZ2		; 21
		dc.l S2KSprite_MCZ1		; 22
		dc.l S2KSprite_MCZ2		; 23
		dc.l $33F06E		;byte_33F06E	; 24
		dc.l $33F74C		;byte_33F74C	; 25
		dc.l S2KSprite_CPZ1		; 26
		dc.l S2KSprite_CPZ2		; 27
		dc.l $2EB230		;byte_2EB230	; 28
		dc.l $2EB254		;byte_2EB254	; 29
		dc.l S2KSprite_ARZ1		; 30
		dc.l S2KSprite_ARZ2		; 31
		dc.l $2EBBDE		;byte_2EBBDE	; 32
		dc.l $2EBD4C		;byte_2EBD4C	; 33
		dc.b $FF ;
		dc.b $FF ;
		dc.b   0 ;
		dc.b   0 ;
		dc.b   0 ;
		dc.b   0 ;
S2KSprite_EHZ1:		binclude "Levels\Misc\S2K Object Pos\EHZ 1.bin"
S2KSprite_EHZ2:		binclude "Levels\Misc\S2K Object Pos\EHZ 2.bin"
S2KSprite_MTZ1:		binclude "Levels\Misc\S2K Object Pos\MTZ 1.bin"
S2KSprite_MTZ2:		binclude "Levels\Misc\S2K Object Pos\MTZ 2.bin"
S2KSprite_MTZ3:		binclude "Levels\Misc\S2K Object Pos\MTZ 3.bin"
S2KSprite_WFZ:		binclude "Levels\Misc\S2K Object Pos\WFZ.bin"
S2KSprite_NULL2:	dc.w  $FFFF,	 0,	0
S2KSprite_HTZ1:		binclude "Levels\Misc\S2K Object Pos\HTZ 1.bin"
S2KSprite_HTZ2:		binclude "Levels\Misc\S2K Object Pos\HTZ 2.bin"
S2KSprite_OOZ1:		binclude "Levels\Misc\S2K Object Pos\OOZ 1.bin"
S2KSprite_OOZ2:		binclude "Levels\Misc\S2K Object Pos\OOZ 2.bin"
S2KSprite_MCZ1:		binclude "Levels\Misc\S2K Object Pos\MCZ 1.bin"
S2KSprite_MCZ2:		binclude "Levels\Misc\S2K Object Pos\MCZ 2.bin"
S2KSprite_CPZ1:		binclude "Levels\Misc\S2K Object Pos\CPZ 1.bin"
S2KSprite_CPZ2:		binclude "Levels\Misc\S2K Object Pos\CPZ 2.bin"
S2KSprite_ARZ1:		binclude "Levels\Misc\S2K Object Pos\ARZ 1.bin"
S2KSprite_ARZ2:		binclude "Levels\Misc\S2K Object Pos\ARZ 2.bin"
S2KSprite_NULL:	dc.w  $FFFF,	 0,	0
	endif

	if Sonic3_Complete=0	
		; org instead of cnop because the sound driver expects the music to be at this exact location
		org $E4104

Music_Credits:	binclude "Sound\Music\Credits.bin"
Music_GameOver:	binclude "Sound\Music\Game Over.bin"
Music_Continue:	binclude "Sound\Music\Continue.bin"
Music_LevelOuttro:binclude "Sound\Music\Level Outro.bin"
Music_Invincible:binclude "Sound\Music\Invincible.bin"
Music_Menu:	binclude "Sound\Music\Menu.bin"
Music_FinalBoss:binclude "Sound\Music\Final Boss.bin"
Music_GameComplete:binclude "Sound\Music\Game Complete.bin"
Music_FBZ1:	binclude "Sound\Music\FBZ1.bin"
Music_FBZ2:	binclude "Sound\Music\FBZ2.bin"
Music_MHZ1:	binclude "Sound\Music\MHZ1.bin"
Music_MHZ2:	binclude "Sound\Music\MHZ2.bin"
Music_SOZ1:	binclude "Sound\Music\SOZ1.bin"
Music_SOZ2:	binclude "Sound\Music\SOZ2.bin"
Music_LRZ1:	binclude "Sound\Music\LRZ1.bin"
Music_LRZ2:	binclude "Sound\Music\LRZ2.bin"
Music_SSZ:	binclude "Sound\Music\SSZ.bin"
Music_DEZ1:	binclude "Sound\Music\DEZ1.bin"
Music_DEZ2:	binclude "Sound\Music\DEZ2.bin"
Music_Miniboss:	binclude "Sound\Music\Miniboss.bin"
Music_ZoneBoss:	binclude "Sound\Music\Zone Boss.bin"
Music_DDZ:	binclude "Sound\Music\DDZ.bin"
Music_Pachinko:	binclude "Sound\Music\Pachinko.bin"
Music_SpecialStage:binclude "Sound\Music\Special Stage.bin"
Music_Slots:	binclude "Sound\Music\Slots.bin"
Music_Knuckles:	binclude "Sound\Music\Knuckles.bin"
Music_Title:	binclude "Sound\Music\Title.bin"
Music_1UP:	binclude "Sound\Music\1UP.bin"
Music_ChaosEmerald:binclude "Sound\Music\Chaos Emerald.bin"

;MusicPadding2:
		; org instead of align because this location is hard-coded into the sound driver
		org $F0000

DAC_Offsets:	dc.w ((((DAC_81_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_81_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_82_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_82_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_83_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_83_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_84_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_84_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_85_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_85_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_86_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_86_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_87_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_87_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_88_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_88_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_89_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_89_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_8A_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_8A_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_8B_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_8B_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_8C_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_8C_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_8D_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_8D_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_8E_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_8E_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_8F_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_8F_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_90_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_90_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_91_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_91_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_92_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_92_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_93_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_93_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_94_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_94_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_95_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_95_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_96_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_96_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_97_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_97_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_98_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_98_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_99_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_99_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_9A_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_9A_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_9B_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_9B_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_9C_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_9C_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_9D_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_9D_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_9E_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_9E_Setup&$7FFF)+$8000)>>8)
		dc.w ((((DAC_9F_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_9F_Setup&$7FFF)+$8000)>>8)
		dc.w $CD81
		dc.w $D281
		dc.w $F81
		dc.w $1481
		dc.w $1981
		dc.w $1E81
		dc.w $2381
		dc.w $2881
		dc.w $2D81
		dc.w $3281
		dc.w $3781
		dc.w $3C81
		dc.w $4181
		dc.w $4681
		dc.w $4B81
		dc.w $5081
		dc.w $5581
		dc.w $5A81
		dc.w ((((DAC_B2_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_B2_Setup&$7FFF)+$8000)>>8)	; B2
		dc.w ((((DAC_B3_Setup&$7FFF)+$8000)<<8)&$FF00)+(((DAC_B3_Setup&$7FFF)+$8000)>>8)	; B3
		dc.w $6981
		dc.w $6E81
		dc.w $7381
		dc.w $7881
		dc.w $7D81
		dc.w $7D81
		dc.w $8281
		dc.w $8781
		dc.w $8C81
		dc.w $9181
		dc.w $9681
		dc.w $9B81
		dc.w $A081
		dc.w $A581
		dc.w $AA81
		dc.w $AF81
		dc.w $B481
DAC_81_Setup:	dc.b 4
		dc.w $7E07
		dc.w ((((DAC_81_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_81_Data&$7FFF)+$8000)>>8)
DAC_82_Setup:	dc.b $E
		dc.w $6D04
		dc.w ((((DAC_82_83_84_85_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_82_83_84_85_Data&$7FFF)+$8000)>>8)
DAC_83_Setup:	dc.b $14
		dc.w $6D04
		dc.w ((((DAC_82_83_84_85_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_82_83_84_85_Data&$7FFF)+$8000)>>8)
DAC_84_Setup:	dc.b $1A
		dc.w $6D04
		dc.w ((((DAC_82_83_84_85_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_82_83_84_85_Data&$7FFF)+$8000)>>8)
DAC_85_Setup:	dc.b $20
		dc.w $6D04
		dc.w ((((DAC_82_83_84_85_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_82_83_84_85_Data&$7FFF)+$8000)>>8)
DAC_86_Setup:	dc.b 4
		dc.w $CF02
		dc.w ((((DAC_86_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_86_Data&$7FFF)+$8000)>>8)
DAC_87_Setup:	dc.b 4
		dc.w $1C07
		dc.w ((((DAC_87_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_87_Data&$7FFF)+$8000)>>8)
DAC_88_Setup:	dc.b 6
		dc.w $2712
		dc.w ((((DAC_88_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_88_Data&$7FFF)+$8000)>>8)
DAC_89_Setup:	dc.b $A
		dc.w $FD09
		dc.w ((((DAC_89_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_89_Data&$7FFF)+$8000)>>8)
DAC_8A_Setup:	dc.b $14
		dc.w $6001
		dc.w ((((DAC_8A_8B_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_8A_8B_Data&$7FFF)+$8000)>>8)
DAC_8B_Setup:	dc.b $1B
		dc.w $6001
		dc.w ((((DAC_8A_8B_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_8A_8B_Data&$7FFF)+$8000)>>8)
DAC_8C_Setup:	dc.b 8
		dc.w $6000
		dc.w ((((DAC_8C_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_8C_Data&$7FFF)+$8000)>>8)
DAC_8D_Setup:	dc.b $B
		dc.w $8704
		dc.w ((((DAC_8D_8E_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_8D_8E_Data&$7FFF)+$8000)>>8)
DAC_8E_Setup:	dc.b $11
		dc.w $8704
		dc.w ((((DAC_8D_8E_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_8D_8E_Data&$7FFF)+$8000)>>8)
DAC_8F_Setup:	dc.b 8
		dc.w $EF04
		dc.w ((((DAC_8F_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_8F_Data&$7FFF)+$8000)>>8)
DAC_90_Setup:	dc.b 3
		dc.w $2206
		dc.w ((((DAC_90_91_92_93_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_90_91_92_93_Data&$7FFF)+$8000)>>8)
DAC_91_Setup:	dc.b 7
		dc.w $2206
		dc.w ((((DAC_90_91_92_93_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_90_91_92_93_Data&$7FFF)+$8000)>>8)
DAC_92_Setup:	dc.b $A
		dc.w $2206
		dc.w ((((DAC_90_91_92_93_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_90_91_92_93_Data&$7FFF)+$8000)>>8)
DAC_93_Setup:	dc.b $E
		dc.w $2206
		dc.w ((((DAC_90_91_92_93_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_90_91_92_93_Data&$7FFF)+$8000)>>8)
DAC_94_Setup:	dc.b 6
		dc.w $5B09
		dc.w ((((DAC_94_95_96_97_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_94_95_96_97_Data&$7FFF)+$8000)>>8)
DAC_95_Setup:	dc.b $A
		dc.w $5B09
		dc.w ((((DAC_94_95_96_97_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_94_95_96_97_Data&$7FFF)+$8000)>>8)
DAC_96_Setup:	dc.b $D
		dc.w $5B09
		dc.w ((((DAC_94_95_96_97_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_94_95_96_97_Data&$7FFF)+$8000)>>8)
DAC_97_Setup:	dc.b $12
		dc.w $5B09
		dc.w ((((DAC_94_95_96_97_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_94_95_96_97_Data&$7FFF)+$8000)>>8)
DAC_98_Setup:	dc.b $B
		dc.w $680C
		dc.w ((((DAC_98_99_9A_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_98_99_9A_Data&$7FFF)+$8000)>>8)
DAC_99_Setup:	dc.b $13
		dc.w $680C
		dc.w ((((DAC_98_99_9A_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_98_99_9A_Data&$7FFF)+$8000)>>8)
DAC_9A_Setup:	dc.b $16
		dc.w $680C
		dc.w ((((DAC_98_99_9A_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_98_99_9A_Data&$7FFF)+$8000)>>8)
DAC_9B_Setup:	dc.b $C
		dc.w $2006
		dc.w ((((DAC_9B_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_9B_Data&$7FFF)+$8000)>>8)
DAC_A2_Setup:	dc.b $A
		dc.w $580D
		dc.w $F9BB
DAC_A3_Setup:	dc.b $18
		dc.w $9E02
		dc.w $51C9
DAC_A4_Setup:	dc.b $18
		dc.w $8A02
		dc.w $EFCB
DAC_A5_Setup:	dc.b $C
		dc.w $600C
		dc.w $79CE
DAC_A6_Setup:	dc.b 9
		dc.w $D606
		dc.w $D9DA
DAC_A7_Setup:	dc.b $18
		dc.w $F206
		dc.w $AFE1
DAC_A8_Setup:	dc.b $18
		dc.w $7A03
		dc.w $A1E8
DAC_A9_Setup:	dc.b $C
		dc.w $4F0A
		dc.w $1BEC
DAC_AA_Setup:	dc.b $A
		dc.w $8E06
		dc.w $6AF6
DAC_AB_Setup:	dc.b $D
		dc.w $409
		dc.w $D781
DAC_AC_Setup:	dc.b 6
		dc.w $8105
		dc.w $DB8A
DAC_AD_Setup:	dc.b $10
		dc.w $BC01
		dc.w $5C90
DAC_AE_Setup:	dc.b $18
		dc.w $BC01
		dc.w $5C90
DAC_AF_Setup:	dc.b 9
		dc.w $6C03
		dc.w $1892
DAC_B0_Setup:	dc.b $12
		dc.w $6C03
		dc.w $1892
DAC_B1_Setup:	dc.b $18
		dc.w $850B
		dc.w $E0A8
DAC_B2_Setup:	dc.b $16
		dc.w $4808
		dc.w ((((DAC_B2_B3_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_B2_B3_Data&$7FFF)+$8000)>>8)
DAC_B3_Setup:	dc.b $20
		dc.w $4808
		dc.w ((((DAC_B2_B3_Data&$7FFF)+$8000)<<8)&$FF00)+(((DAC_B2_B3_Data&$7FFF)+$8000)>>8)
DAC_B4_Setup:	dc.b $C
		dc.w $FD05
		dc.w $ADBC
DAC_B5_Setup:	dc.b $C
		dc.w $4006
		dc.w $AAC2
DAC_B6_Setup:	dc.b $C
		dc.w $5505
		dc.w $EAC8
DAC_B7_Setup:	dc.b $18
		dc.w $B104
		dc.w $3FCE
DAC_B8_B9_Setup:dc.b $C
		dc.w $3A06
		dc.w $F0D2
DAC_BA_Setup:	dc.b $18
		dc.w $B304
		dc.w $2AD9
DAC_BB_Setup:	dc.b $18
		dc.w $B601
		dc.w $DDDD
DAC_BC_Setup:	dc.b $18
		dc.w $B708
		dc.w $93DF
DAC_BD_Setup:	dc.b $C
		dc.w $BE05
		dc.w $4AE8
DAC_BE_Setup:	dc.b $C
		dc.w $1007
		dc.w $8EE
DAC_BF_Setup:	dc.b $1C
		dc.w $DC01
		dc.w $18F5
DAC_C0_Setup:	dc.b $B
		dc.w $3608
		dc.w $F4F6
DAC_C1_Setup:	dc.b $F
		dc.w $FD05
		dc.w $ADBC
DAC_C2_Setup:	dc.b $11
		dc.w $FD05
		dc.w $ADBC
DAC_C3_Setup:	dc.b $12
		dc.w $FD05
		dc.w $ADBC
DAC_C4_Setup:	dc.b $B
		dc.w $FD05
		dc.w $ADBC
DAC_9C_Setup:	dc.b $A
		dc.w $3203
		dc.w $F787
DAC_9D_Setup:	dc.b $18
		dc.w $4902
		dc.w $298B
DAC_9E_Setup:	dc.b $18
		dc.w $8002
		dc.w $728D
DAC_9F_Setup:	dc.b $C
		dc.w $A512
		dc.w $F28F
DAC_A0_Setup:	dc.b $C
		dc.w $BA0D
		dc.w $97A2
DAC_A1_Setup:	dc.b $A
		dc.w $A80B
		dc.w $51B0
DAC_86_Data:			binclude "Sound\DAC\86.bin"
DAC_81_Data:			binclude "Sound\DAC\81.bin"
DAC_82_83_84_85_Data:	binclude "Sound\DAC\82-85.bin"
DAC_94_95_96_97_Data:	binclude "Sound\DAC\94-97.bin"
DAC_90_91_92_93_Data:	binclude "Sound\DAC\90-93.bin"
DAC_88_Data:			binclude "Sound\DAC\88.bin"
DAC_8A_8B_Data:			binclude "Sound\DAC\8A-8B.bin"
DAC_8C_Data:			binclude "Sound\DAC\8C.bin"
DAC_8D_8E_Data:			binclude "Sound\DAC\8D-8E.bin"
DAC_87_Data:			binclude "Sound\DAC\87.bin"
DAC_8F_Data:			binclude "Sound\DAC\8F.bin"
DAC_89_Data:			binclude "Sound\DAC\89.bin"
DAC_98_99_9A_Data:		binclude "Sound\DAC\98-9A.bin"
DAC_9B_Data:			binclude "Sound\DAC\9B.bin"
DAC_B2_B3_Data:			binclude "Sound\DAC\B2-B3.bin"

;DAC_Padding1:
		align $10

Z80_Snd_Driver:	binclude "Sound\Z80 Sound Driver.bin"

Z80_Snd_Driver2:binclude "Sound\Z80 Sound Driver 2.bin"

;SoundPadding:
		; org instead of align because this location is hard-coded into the Z80 driver
		org $F8000

SEGA_PCM:	binclude "Sound\Sega PCM.bin"
		even
Sound_33:	binclude "Sound\SFX\33.bin"
Sound_34:	binclude "Sound\SFX\34.bin"
Sound_35:	binclude "Sound\SFX\35.bin"
Sound_36:	binclude "Sound\SFX\36.bin"
Sound_37:	binclude "Sound\SFX\37.bin"
Sound_38:	binclude "Sound\SFX\38.bin"
Sound_39:	binclude "Sound\SFX\39.bin"
Sound_3A:	binclude "Sound\SFX\3A.bin"
Sound_3B:	binclude "Sound\SFX\3B.bin"
Sound_3C:	binclude "Sound\SFX\3C.bin"
Sound_3D:	binclude "Sound\SFX\3D.bin"
Sound_3E:	binclude "Sound\SFX\3E.bin"
Sound_3F:	binclude "Sound\SFX\3F.bin"
Sound_40:	binclude "Sound\SFX\40.bin"
Sound_41:	binclude "Sound\SFX\41.bin"
Sound_42:	binclude "Sound\SFX\42.bin"
Sound_43:	binclude "Sound\SFX\43.bin"
Sound_44:	binclude "Sound\SFX\44.bin"
Sound_45:	binclude "Sound\SFX\45.bin"
Sound_46:	binclude "Sound\SFX\46.bin"
Sound_47:	binclude "Sound\SFX\47.bin"
Sound_48:	binclude "Sound\SFX\48.bin"
Sound_49:	binclude "Sound\SFX\49.bin"
Sound_4A:	binclude "Sound\SFX\4A.bin"
Sound_4B:	binclude "Sound\SFX\4B.bin"
Sound_4C:	binclude "Sound\SFX\4C.bin"
Sound_4D:	binclude "Sound\SFX\4D.bin"
Sound_4E:	binclude "Sound\SFX\4E.bin"
Sound_4F:	binclude "Sound\SFX\4F.bin"
Sound_50:	binclude "Sound\SFX\50.bin"
Sound_51:	binclude "Sound\SFX\51.bin"
Sound_52:	binclude "Sound\SFX\52.bin"
Sound_53:	binclude "Sound\SFX\53.bin"
Sound_54:	binclude "Sound\SFX\54.bin"
Sound_55:	binclude "Sound\SFX\55.bin"
Sound_56:	binclude "Sound\SFX\56.bin"
Sound_57:	binclude "Sound\SFX\57.bin"
Sound_58:	binclude "Sound\SFX\58.bin"
Sound_59:	binclude "Sound\SFX\59.bin"
Sound_5A:	binclude "Sound\SFX\5A.bin"
Sound_5B:	binclude "Sound\SFX\5B.bin"
Sound_5C:	binclude "Sound\SFX\5C.bin"
Sound_5D:	binclude "Sound\SFX\5D.bin"
Sound_5E:	binclude "Sound\SFX\5E.bin"
Sound_5F:	binclude "Sound\SFX\5F.bin"
Sound_60:	binclude "Sound\SFX\60.bin"
Sound_61:	binclude "Sound\SFX\61.bin"
Sound_62:	binclude "Sound\SFX\62.bin"
Sound_63:	binclude "Sound\SFX\63.bin"
Sound_64:	binclude "Sound\SFX\64.bin"
Sound_65:	binclude "Sound\SFX\65.bin"
Sound_66:	binclude "Sound\SFX\66.bin"
Sound_67:	binclude "Sound\SFX\67.bin"
Sound_68:	binclude "Sound\SFX\68.bin"
Sound_69:	binclude "Sound\SFX\69.bin"
Sound_6A:	binclude "Sound\SFX\6A.bin"
Sound_6B:	binclude "Sound\SFX\6B.bin"
Sound_6C:	binclude "Sound\SFX\6C.bin"
Sound_6D:	binclude "Sound\SFX\6D.bin"
Sound_6E:	binclude "Sound\SFX\6E.bin"
Sound_6F:	binclude "Sound\SFX\6F.bin"
Sound_70:	binclude "Sound\SFX\70.bin"
Sound_71:	binclude "Sound\SFX\71.bin"
Sound_72:	binclude "Sound\SFX\72.bin"
Sound_73:	binclude "Sound\SFX\73.bin"
Sound_74:	binclude "Sound\SFX\74.bin"
Sound_75:	binclude "Sound\SFX\75.bin"
Sound_76:	binclude "Sound\SFX\76.bin"
Sound_77:	binclude "Sound\SFX\77.bin"
Sound_78:	binclude "Sound\SFX\78.bin"
Sound_79:	binclude "Sound\SFX\79.bin"
Sound_7A:	binclude "Sound\SFX\7A.bin"
Sound_7B:	binclude "Sound\SFX\7B.bin"
Sound_7C:	binclude "Sound\SFX\7C.bin"
Sound_7D:	binclude "Sound\SFX\7D.bin"
Sound_7E:	binclude "Sound\SFX\7E.bin"
Sound_7F:	binclude "Sound\SFX\7F.bin"
Sound_80:	binclude "Sound\SFX\80.bin"
Sound_81:	binclude "Sound\SFX\81.bin"
Sound_82:	binclude "Sound\SFX\82.bin"
Sound_83:	binclude "Sound\SFX\83.bin"
Sound_84:	binclude "Sound\SFX\84.bin"
Sound_85:	binclude "Sound\SFX\85.bin"
Sound_86:	binclude "Sound\SFX\86.bin"
Sound_87:	binclude "Sound\SFX\87.bin"
Sound_88:	binclude "Sound\SFX\88.bin"
Sound_89:	binclude "Sound\SFX\89.bin"
Sound_8A:	binclude "Sound\SFX\8A.bin"
Sound_8B:	binclude "Sound\SFX\8B.bin"
Sound_8C:	binclude "Sound\SFX\8C.bin"
Sound_8D:	binclude "Sound\SFX\8D.bin"
Sound_8E:	binclude "Sound\SFX\8E.bin"
Sound_8F:	binclude "Sound\SFX\8F.bin"
Sound_90:	binclude "Sound\SFX\90.bin"
Sound_91:	binclude "Sound\SFX\91.bin"
Sound_92:	binclude "Sound\SFX\92.bin"
Sound_93:	binclude "Sound\SFX\93.bin"
Sound_94:	binclude "Sound\SFX\94.bin"
Sound_95:	binclude "Sound\SFX\95.bin"
Sound_96:	binclude "Sound\SFX\96.bin"
Sound_97:	binclude "Sound\SFX\97.bin"
Sound_98:	binclude "Sound\SFX\98.bin"
Sound_99:	binclude "Sound\SFX\99.bin"
Sound_9A:	binclude "Sound\SFX\9A.bin"
Sound_9B:	binclude "Sound\SFX\9B.bin"
Sound_9C:	binclude "Sound\SFX\9C.bin"
Sound_9D:	binclude "Sound\SFX\9D.bin"
Sound_9E:	binclude "Sound\SFX\9E.bin"
Sound_9F:	binclude "Sound\SFX\9F.bin"
Sound_A0:	binclude "Sound\SFX\A0.bin"
Sound_A1:	binclude "Sound\SFX\A1.bin"
Sound_A2:	binclude "Sound\SFX\A2.bin"
Sound_A3:	binclude "Sound\SFX\A3.bin"
Sound_A4:	binclude "Sound\SFX\A4.bin"
Sound_A5:	binclude "Sound\SFX\A5.bin"
Sound_A6:	binclude "Sound\SFX\A6.bin"
Sound_A7:	binclude "Sound\SFX\A7.bin"
Sound_A8:	binclude "Sound\SFX\A8.bin"
Sound_A9:	binclude "Sound\SFX\A9.bin"
Sound_AA:	binclude "Sound\SFX\AA.bin"
Sound_AB:	binclude "Sound\SFX\AB.bin"
Sound_AC:	binclude "Sound\SFX\AC.bin"
Sound_AD:	binclude "Sound\SFX\AD.bin"
Sound_AE:	binclude "Sound\SFX\AE.bin"
Sound_AF:	binclude "Sound\SFX\AF.bin"
Sound_B0:	binclude "Sound\SFX\B0.bin"
Sound_B1:	binclude "Sound\SFX\B1.bin"
Sound_B2:	binclude "Sound\SFX\B2.bin"
Sound_B3:	binclude "Sound\SFX\B3.bin"
Sound_B4:	binclude "Sound\SFX\B4.bin"
Sound_B5:	binclude "Sound\SFX\B5.bin"
Sound_B6:	binclude "Sound\SFX\B6.bin"
Sound_B7:	binclude "Sound\SFX\B7.bin"
Sound_B8:	binclude "Sound\SFX\B8.bin"
Sound_B9:	binclude "Sound\SFX\B9.bin"
Sound_BA:	binclude "Sound\SFX\BA.bin"
Sound_BB:	binclude "Sound\SFX\BB.bin"
Sound_BC:	binclude "Sound\SFX\BC.bin"
Sound_BD:	binclude "Sound\SFX\BD.bin"
Sound_BE:	binclude "Sound\SFX\BE.bin"
Sound_BF:	binclude "Sound\SFX\BF.bin"
Sound_C0:	binclude "Sound\SFX\C0.bin"
Sound_C1:	binclude "Sound\SFX\C1.bin"
Sound_C2:	binclude "Sound\SFX\C2.bin"
Sound_C3:	binclude "Sound\SFX\C3.bin"
Sound_C4:	binclude "Sound\SFX\C4.bin"
Sound_C5:	binclude "Sound\SFX\C5.bin"
Sound_C6:	binclude "Sound\SFX\C6.bin"
Sound_C7:	binclude "Sound\SFX\C7.bin"
Sound_C8:	binclude "Sound\SFX\C8.bin"
Sound_C9:	binclude "Sound\SFX\C9.bin"
Sound_CA:	binclude "Sound\SFX\CA.bin"
Sound_CB:	binclude "Sound\SFX\CB.bin"
Sound_CC:	binclude "Sound\SFX\CC.bin"
Sound_CD:	binclude "Sound\SFX\CD.bin"
Sound_CE:	binclude "Sound\SFX\CE.bin"
Sound_CF:	binclude "Sound\SFX\CF.bin"
Sound_D0:	binclude "Sound\SFX\D0.bin"
Sound_D1:	binclude "Sound\SFX\D1.bin"
Sound_D2:	binclude "Sound\SFX\D2.bin"
Sound_D3:	binclude "Sound\SFX\D3.bin"
Sound_D4:	binclude "Sound\SFX\D4.bin"
Sound_D5:	binclude "Sound\SFX\D5.bin"
Sound_D6:	binclude "Sound\SFX\D6.bin"
Sound_D7:	binclude "Sound\SFX\D7.bin"
Sound_D8:	binclude "Sound\SFX\D8.bin"
Sound_D9:	binclude "Sound\SFX\D9.bin"
Sound_DA:	binclude "Sound\SFX\DA.bin"
Sound_DB:	binclude "Sound\SFX\DB.bin"

	else
Z80_Snd_Driver: include "Sound\Z80 Sound Driver.asm"
	endif
;SFX_Padding:
		align $8000

ArtUnc_Sonic:	binclude "General\Sprites\Sonic\Art\Sonic.bin"
	even
ArtUnc_Knux:	binclude "General\Sprites\Knuckles\Art\Knuckles.bin"
	even
ArtUnc_Sonic_Extra:binclude "General\Sprites\Sonic\Art\Sonic Extra.bin"
	even
ArtUnc_Tails_Extra:binclude "General\Sprites\Tails\Art\Tails Extra.bin"
	even
Map_Sonic:	include "General\Sprites\Sonic\Map - Sonic.asm"

PLC_Sonic:	include "General\Sprites\Sonic\Sonic pattern load cues.asm"

Map_Tails:	include "General\Sprites\Tails\Map - Tails.asm"

PLC_Tails:	include "General\Sprites\Tails\Tails pattern load cues.asm"

Map_Knuckles:	include "General\Sprites\Knuckles\Map - Knuckles.asm"

PLC_Knuckles:	include "General\Sprites\Knuckles\Knuckles pattern load cues.asm"

ArtKosM_HyperSonicStars:binclude "General\Sprites\Sonic\Art\Hyper Sonic Stars.bin"
	even
ArtKosM_SuperTailsBirds:binclude "General\Sprites\Tails\Art\Super Tails birds.bin"
	even
ArtNem_FBZMisc:	binclude "Levels\FBZ\Nemesis Art\Misc Art 1.bin"
	even

ArtNem_FBZOutdoors:	binclude "Levels\FBZ\Nemesis Art\Outdoors.bin"
	even
ArtNem_FBZMisc2:	binclude "Levels\FBZ\Nemesis Art\Misc Art 2.bin"
	even
ArtNem_MHZMisc:	binclude "Levels\MHZ\Nemesis Art\Misc Art.bin"
	even
ArtNem_SOZMisc:	binclude "Levels\SOZ\Nemesis Art\Misc Art.bin"
	even

ArtNem_SOZTile:	binclude "Levels\SOZ\Nemesis Art\Tile.bin"
	even
ArtNem_SOZ2Extra:	binclude "Levels\SOZ\Nemesis Art\Act 2 Extra Art.bin"
	even
ArtNem_LRZMisc:	binclude "Levels\LRZ\Nemesis Art\Misc Art.bin"
	even
ArtNem_LRZSpikes:	binclude "Levels\LRZ\Nemesis Art\Spike Crush.bin"
	even
ArtNem_LRZBigSpike:	binclude "Levels\LRZ\Nemesis Art\Big Spike Ball.bin"
	even
ArtNem_LRZ2Misc:	binclude "Levels\LRZ\Nemesis Art\Act 2 Misc Art.bin"
	even
ArtNem_LRZ2Drum:	binclude "Levels\LRZ\Nemesis Art\Act 2 Spinning Drum.bin"
	even
ArtNem_SSZMisc:	binclude "Levels\SSZ\Nemesis Art\Misc.bin"
	even
ArtKosM_SSZSpiralRamp:	binclude "Levels\SSZ\KosinskiM Art\Spiral Ramp.bin"
	even
ArtNem_DEZMisc:	binclude "Levels\DEZ\Nemesis Art\Misc Art.bin"
	even

ArtNem_DEZMiniboss:	binclude "Levels\DEZ\Nemesis Art\Miniboss.bin"
	even
ArtNem_DEZ2Extra:	binclude "Levels\DEZ\Nemesis Art\Act 2 Extra Art.bin"
	even
ArtNem_PachinkoMain:	binclude "Levels\Pachinko\Nemesis Art\Main.bin"
	even
ArtKos_PachinkoBG1:		binclude "Levels\Pachinko\Kosinski Art\Animated BG 1.bin"
	even
ArtKos_PachinkoBG2:		binclude "Levels\Pachinko\Kosinski Art\Animated BG 2.bin"
	even
PalKos_Pachinko:		binclude "Levels\Pachinko\Palettes\Compressed Pal.bin"
	even
ArtNem_SlotsBlocks:	binclude "Levels\Slots\Nemesis Art\Blocks.bin"
	even
ArtUnc_SlotOptions:		binclude "Levels\Slots\Uncompressed Art\Options.bin"
	even
ArtKosM_SSZTeleport:		binclude "Levels\SSZ\KosinskiM Art\Teleporter Beam.bin"
	even
ArtNem_ICZTeleport:	binclude "Levels\ICZ\Nemesis Art\Teleporter Beam.bin"
	even
ArtKosM_MHZEndBossPillar:		binclude "Levels\MHZ\KosinskiM Art\End Boss Pillar.bin"
	even
ArtKosM_MHZShipPropeller:		binclude "Levels\MHZ\KosinskiM Art\Ship Propeller.bin"
	even
ArtKosM_LRZ2DeathEggBG:		binclude "Levels\LRZ\KosinskiM Art\BG Death Egg.bin"
	even
ArtUnc_DEZFBLaser:	binclude "Levels\DEZ\Uncompressed Art\Final Boss Laser.bin"
	even

ArtKos_SaveScreen:binclude "General\Save Menu\Kosinski Art\SK Extra.bin"
	even
ArtKosM_SSResultsSUPER:		binclude "General\Special Stage\KosinskiM Art\SSResults SUPER.bin"
	even
ArtKosM_SSResultsSUPERk:		binclude "General\Special Stage\KosinskiM Art\SSResults SUPER (K).bin"
	even
ArtKosM_SSResultsHYPER:		binclude "General\Special Stage\KosinskiM Art\SSResults HYPER.bin"
	even
ArtKosM_SSResultsHYPERk:		binclude "General\Special Stage\KosinskiM Art\SSResults HYPER (K).bin"
	even
ArtKosM_ResultsSONIC:	binclude "General\Sprites\Results\Results SONIC.bin"
	even
ArtKosM_SSResults:	dc.b  $12, $A0
ArtKos_SSResultsGeneral:		binclude "General\Special Stage\Kosinski Art\SSResults General.bin"
	even
ArtKos_SSResultsTKIcons:		binclude "General\Special Stage\Kosinski Art\SSResults Tails Knuckles Icons.bin"
	even
ArtKosM_TitleCardSKZone:binclude "General\Sprites\Title Card\Title Card SK Zone.bin"
	even
ArtKosM_TitleCardS3KZone:binclude "General\Sprites\Title Card\Title Card S3K Zone.bin"
	even
ArtKosM_MHZTitleCard:binclude "Levels\MHZ\KosinskiM Art\Title Card.bin"
	even
ArtKosM_SOZTitleCard:binclude "Levels\SOZ\KosinskiM Art\Title Card.bin"
	even
ArtKosM_LRZTitleCard:binclude "Levels\LRZ\KosinskiM Art\Title Card.bin"
	even
ArtKosM_SSZTitleCard:binclude "Levels\SSZ\KosinskiM Art\Title Card.bin"
	even
ArtKosM_DEZTitleCard:binclude "Levels\DEZ\KosinskiM Art\Title Card.bin"
	even
ArtKosM_DDZTitleCard:binclude "Levels\DDZ\KosinskiM Art\Title Card.bin"
	even
ArtKosM_HPZTitleCard:binclude "Levels\HPZ\KosinskiM Art\Title Card.bin"
	even
ArtKos_SaveScreenSKZone:	binclude "General\Save Menu\Kosinski Art\SK Zone Art.bin"
	even
ArtKos_SaveScreenPortrait:	binclude "General\Save Menu\Kosinski Art\Portraits.bin"
	even
DemoDat_MHZ:	binclude "Levels\MHZ\Demodata\1.bin"

DemoDat_FBZ:	binclude "Levels\FBZ\Demodata\1.bin"

DemoDat_SOZ:	binclude "Levels\SOZ\Demodata\1.bin"

DemoDat_SpecialStage:	binclude "General\Special Stage\Demodata\1.bin"
	even
ArtKosM_EggRoboHead:dc.w $400
	even
ArtKos_EggRoboHead:		binclude "General\Sprites\Robotnik\Egg Robo Head.bin"
	even
ArtNem_EggRoboRun:	binclude "General\Sprites\Robotnik\Egg Robo Run.bin"
	even
ArtNem_EggRoboStand:	binclude "General\Sprites\Robotnik\Egg Robo Stand.bin"
	even
ArtKosM_KnuxFinalBossCrane:		binclude "General\Sprites\Robotnik\Robotnik Ship Crane.bin"
	even
ArtKosM_IslandLiftGfx:		binclude "General\Ending\KosinskiM Art\Island Lift Animated Tiles.bin"
	even
ArtKosM_EndingAnimals:		binclude "General\Ending\KosinskiM Art\Pelican and Dolphin.bin"
	even
ArtKosM_EggRoboSKEnding:		binclude "General\Ending\KosinskiM Art\Egg Robo.bin"
	even
ArtKosM_NormalSonicEndPose:		binclude "General\Ending\KosinskiM Art\Normal Sonic Ending Pose.bin"
	even
ArtKosM_SuperSonicEndPose:	binclude "General\Ending\KosinskiM Art\Super Sonic Ending Pose.bin"
	even
ArtKosM_SonicPlaneEnding:		binclude "General\Ending\KosinskiM Art\Sonic Plane Ending.bin"
	even
ArtKosM_RobotnikSmug:	dc.w	  $7A0
ArtKos_RobotnikSmug:	binclude "General\Ending\Kosinski Art\Robotnik Standing Smug.bin"
	even
ArtKosM_SonicPlane:	binclude "General\Ending\KosinskiM Art\Sonic Plane.bin"
	even
ArtKosM_KnuxEnding:	binclude "General\Sprites\Knuckles\Cutscene\Knuckles Ending Cutscene.bin"
	even
ArtKosM_SKPoseBanner:	dc.w	  $900
ArtKos_SKPoseBanner:	binclude "General\Ending\Kosinski Art\Sonic Knuckles Pose Banner.bin"
	even
ArtKosM_S3PoseBanner:	binclude "General\Ending\KosinskiM Art\Sonic 3 Pose Banner.bin"
	even
ArtUnc_KnuxIntroLay:	binclude "General\Sprites\Knuckles\Cutscene\Intro Laying.bin"
	even
ArtKosM_KnuxIntroBomb:		binclude "General\Sprites\Knuckles\Cutscene\Knuckles Intro Bomb.bin"
	even
ArtKosM_FBZExitHall:	binclude "Levels\FBZ\KosinskiM Art\Exit Hall.bin"
	even
ArtKosM_FBZMiniboss:		binclude "Levels\FBZ\KosinskiM Art\Miniboss.bin"
	even
ArtKosM_FBZCloud:		binclude "Levels\FBZ\KosinskiM Art\Cloud.bin"
	even
ArtKosM_FBZBossPillar:			binclude "Levels\FBZ\KosinskiM Art\Before Boss Pillar.bin"
	even
ArtKosM_FBZExitDoor:	binclude "Levels\FBZ\KosinskiM Art\Exit Door.bin"
	even
ArtNem_FBZEggCapsule:	binclude "Levels\FBZ\Nemesis Art\Egg Capsule.bin"
	even

ArtKosM_FBZButton:		binclude "Levels\FBZ\KosinskiM Art\Button.bin"
	even
ArtKosM_Madmole:		binclude "General\Sprites\Madmole\Madmole.bin"
	even

ArtKosM_Mushmeanie:		binclude "General\Sprites\Mushmeanie\Mushmeanie.bin"
	even

ArtKosM_Dragonfly:		binclude "General\Sprites\Dragonfly\Dragonfly.bin"
	even

ArtKosM_CluckoidArrow:	binclude "General\Sprites\Cluckoid\Cluckoid Arrow.bin"
	even
ArtUnc_Butterdroid:	binclude "General\Sprites\Butterdroid\Butterdroid.bin"
	even
ArtUnc_Cluckoid:	binclude "General\Sprites\Cluckoid\Cluckoid.bin"
	even
ArtKosM_MHZMiniboss:	binclude "Levels\MHZ\KosinskiM Art\Miniboss.bin"
	even
ArtKosM_MHZMinibossLog:	binclude "Levels\MHZ\KosinskiM Art\Miniboss Log.bin"
	even
ArtKosM_MHZEndBossSpikes:	binclude "Levels\MHZ\KosinskiM Art\End Boss Spikes.bin"
	even
ArtKosM_MHZKnuxPeer:	binclude "General\Sprites\Knuckles\Cutscene\Knuckles Peering.bin"
	even
ArtUnc_MHZKnuxPress:	binclude "General\Sprites\Knuckles\Cutscene\MHZ2 Press.bin"
	even
ArtKosM_MHZKnuxSwitch:	binclude "General\Sprites\Knuckles\Cutscene\Knuckles MHZ Switch.bin"
	even
ArtKosM_MHZEndBoss:	binclude "Levels\MHZ\KosinskiM Art\End Boss.bin"
	even
ArtKosM_Skorp:binclude "General\Sprites\Skorp\Skorp.bin"
	even
ArtKosM_Sandworm:binclude "General\Sprites\Sandworm\Sandworm.bin"
	even
ArtKosM_Rockn:binclude "General\Sprites\Rockn\Rock'n.bin"
	even
ArtUnc_SOZGhosts:	binclude "General\Sprites\SOZ Ghosts\SOZ Ghosts.bin"
	even
ArtKosM_SOZMiniboss:	binclude "Levels\SOZ\KosinskiM Art\Miniboss.bin"
	even
ArtKosM_SOZSand:	binclude "Levels\SOZ\KosinskiM Art\Sand Particles.bin"
	even
ArtKosM_SOZEndBoss:	binclude "Levels\SOZ\KosinskiM Art\End Boss.bin"
	even
ArtUnc_Fireworm:	binclude "General\Sprites\Fireworm\Fireworm.bin"
	even
ArtKosM_FirewormSegments:binclude "General\Sprites\Fireworm\Fireworm Segments.bin"
	even
ArtKosM_Iwamodoki:binclude "General\Sprites\Iwamodoki\Iwamodoki.bin"
	even
ArtKosM_Toxomister:binclude "General\Sprites\Toxomister\Toxomister.bin"
	even
ArtKosM_LRZRockCrusher:	binclude "Levels\LRZ\KosinskiM Art\Rock Crusher.bin"
	even
ArtKosM_LRZMiniboss:	binclude "Levels\LRZ\KosinskiM Art\Miniboss.bin"
	even
ArtKosM_LRZ3Autoscroll:	binclude "Levels\LRZ\KosinskiM Art\Autoscroll.bin"
	even
ArtKosM_LRZ3DeathEggFlash:	binclude "Levels\LRZ\KosinskiM Art\Death Egg Flash.bin"
	even
ArtKosM_LRZ3PlatformDebris:	binclude "Levels\LRZ\KosinskiM Art\Platform Debris.bin"
	even
ArtKosM_LRZEndBoss:	binclude "Levels\LRZ\KosinskiM Art\End Boss.bin"
	even
ArtKosM_LRZKnuxBoulder:	binclude "Levels\LRZ\KosinskiM Art\Knuckles Boulder.bin"
	even
ArtUnc_HPZKnucklesGrab:	binclude "General\Sprites\Knuckles\Cutscene\HPZ Emerald Grab.bin"
	even
ArtKosM_HPZKnuxDizzy:	binclude "Levels\HPZ\KosinskiM Art\Knuckles Dizzy Stars.bin"
	even
ArtNem_HPZEmeraldMisc:	binclude "Levels\HPZ\Nemesis Art\Emerald Misc Art.bin"
	even
ArtNem_HPZGrayEmerald:	binclude "Levels\HPZ\Nemesis Art\Gray Emerald.bin"
	even
ArtKosM_Teleporter:binclude "General\Sprites\Teleporter\Teleporter.bin"
	even

ArtKosM_HPZSmallEmeralds:	binclude "Levels\HPZ\KosinskiM Art\Special Stage Emeralds.bin"
	even
ArtUnc_MechaSonic:	binclude "General\Sprites\Mecha Sonic\Mecha Sonic.bin"
	even
ArtKosM_EggRoboBadnik:binclude "General\Sprites\Egg Robo Badnik\Egg Robo Badnik.bin"
	even

ArtScaled_EggRoboFly:	binclude "General\Sprites\Robotnik\Egg Robo Fly Scaled.bin"
	even
ArtKosM_MechaSonicHead:	binclude "General\Sprites\Mecha Sonic\Mecha Sonic Head.bin"
	even
ArtUnc_SSZDeathEggCloud:	binclude "General\Sprites\SSZ Death Egg Cloud\SSZ Death Egg Cloud.bin"
	even
ArtKosM_SSZDeathEggSmall:	binclude "Levels\SSZ\KosinskiM Art\Death Egg Small.bin"
	even
ArtUnc_SSZKnucklesTired:	binclude "General\Sprites\Knuckles\Cutscene\SSZ Tired.bin"
	even
ArtKosM_SSZGHZMisc:	binclude "Levels\SSZ\KosinskiM Art\GHZ Ball and Chain.bin"
	even
ArtKosM_SSZMTZOrbs:	binclude "Levels\SSZ\KosinskiM Art\MTZ Orbs.bin"
	even
ArtKosM_MechaSonicExtra:	binclude "General\Sprites\Mecha Sonic\Mecha Sonic Extra Art.bin"
	even
ArtKosM_HPZMasterEmerald:	dc.w	 $880
	even
ArtKos_HPZMasterEmerald:	binclude "Levels\HPZ\Kosinski Art\Master Emerald.bin"
	even
ArtKosM_Spikebonker:binclude "General\Sprites\Spikebonker\Spikebonker.bin"
	even
ArtKosM_Chainspike:binclude "General\Sprites\Chainspike\Chainspike.bin"
	even
ArtKosM_DEZMinibossMisc:	binclude "Levels\DEZ\KosinskiM Art\Miniboss Misc Art.bin"
	even
ArtKosM_DEZEndBoss:	binclude "Levels\DEZ\KosinskiM Art\End Boss.bin"
	even
ArtKosM_DEZFinalBossMisc:	binclude "Levels\DEZ\KosinskiM Art\Final Boss Misc Art.bin"
	even
ArtKosM_MasterEmerald:	binclude "General\Sprites\Master Emerald\Master Emerald.bin"
	even
ArtKosM_DEZFinalBossDebris:	binclude "Levels\DEZ\KosinskiM Art\Final Boss Debris.bin"
	even
ArtKosM_DDZMisc:	binclude "Levels\DDZ\KosinskiM Art\Misc Art.bin"
	even
AngleLookup_1:	dc.b    0,   0,   1,   1,   1,   1,   2,   2,   2,   3,   3,   3,   3,   4,   4,   4,   5,   5,   5,   5
		dc.b    6,   6,   6,   6,   7,   7,   7,   7,   8,   8,   8,   8,   8,   9,   9,   9,   9,   9,  $A,  $A
		dc.b   $A,  $A,  $A,  $A,  $B,  $B,  $B,  $B,  $B,  $B,  $B,  $B,  $B,  $C,  $C,  $C,  $C,  $C,  $C,  $C
		dc.b   $C,  $C,  $C,  $C
AngleLookup_2:	dc.b    0,   1,   1,   2,   2,   3,   4,   4,   5,   5,   6,   6,   7,   8,   8,   9,   9,  $A,  $A,  $B
		dc.b   $B,  $C,  $C,  $D,  $D,  $E,  $E,  $F,  $F, $10, $10, $11, $11, $11, $12, $12, $13, $13, $13, $14
		dc.b  $14, $14, $15, $15, $15, $15, $16, $16, $16, $16, $17, $17, $17, $17, $17, $17, $18, $18, $18, $18
		dc.b  $18, $18, $18, $18
AngleLookup_3:	dc.b    0,   1,   2,   3,   4,   4,   5,   6,   7,   8,   9,  $A,  $A,  $B,  $C,  $D,  $E,  $F,  $F, $10
		dc.b  $11, $12, $13, $13, $14, $15, $15, $16, $17, $18, $18, $19, $19, $1A, $1B, $1B, $1C, $1C, $1D, $1D
		dc.b  $1E, $1E, $1F, $1F, $20, $20, $21, $21, $21, $22, $22, $22, $22, $23, $23, $23, $23, $23, $24, $24
		dc.b  $24, $24, $24, $24
	even
Map_Spikebonker:include "General\Sprites\Spikebonker\Map - Spikebonker.asm"

Map_Chainspike:	include "General\Sprites\Chainspike\Map - Chainspike.asm"

Map_EggRobo:	include "General\Sprites\Robotnik\Map - Eggrobo.asm"

Map_DEZMiniboss:	include "Levels\DEZ\Misc Object Data\Map - Miniboss.asm"

Map_MechaSonic:	include "General\Sprites\Mecha Sonic\Map - Mecha Sonic.asm"

Map_MechaSonicExtra:	include "General\Sprites\Mecha Sonic\Map - Mecha Sonic Extra.asm"

DPLC_MechaSonic:	include "General\Sprites\Mecha Sonic\DPLC - Mecha Sonic.asm"

Map_SpriteMask:	include "General\Sprites\Level Misc\Map - Sprite Mask.asm"

Map_DEZEndBoss:	include "Levels\DEZ\Misc Object Data\Map - End Boss.asm"

Map_MHZEndBoss:	include "Levels\MHZ\Misc Object Data\Map - End Boss.asm"

Map_MHZMiniboss:	include "Levels\MHZ\Misc Object Data\Map - Miniboss.asm"

Map_MHZMinibossTree:	include "Levels\MHZ\Misc Object Data\Map - Miniboss Tree.asm"

Map_MHZMinibossLog:	include "Levels\MHZ\Misc Object Data\Map - Miniboss Log.asm"

Map_EggRoboStand:	include "General\Sprites\Robotnik\Map - Egg Robo Stand.asm"

Map_EggRoboRun:	include "General\Sprites\Robotnik\Map - Egg Robo Run.asm"

Map_Skorp:	include "General\Sprites\Skorp\Map - Skorp.asm"

Map_Sandworm:	include "General\Sprites\Sandworm\Map - Sandworm.asm"

Map_LRZRockCrusher:	include "Levels\LRZ\Misc Object Data\Map - Rock Crusher.asm"

Map_SSZMTZOrbs:	include "Levels\SSZ\Misc Object Data\Map - MTZ Orbs.asm"

Map_SSZGHZMisc:	include "Levels\SSZ\Misc Object Data\Map - GHZ Misc.asm"

Map_LRZMiniboss:	include "Levels\LRZ\Misc Object Data\Map - Miniboss.asm"

Map_FBZEggCapsule:	include "Levels\FBZ\Misc Object Data\Map - Egg Capsule.asm"

Map_SOZGhosts:	include "General\Sprites\SOZ Ghosts\Map - SOZ Ghosts.asm"

Map_LRZEndBoss:	include "Levels\LRZ\Misc Object Data\Map - End Boss.asm"

Map_LRZ3Platform:	include "Levels\LRZ\Misc Object Data\Map - Act 3 Platform.asm"

Map_LRZ3Autoscroll:	include "Levels\LRZ\Misc Object Data\Map - Act 3 Autoscroll.asm"

Map_LRZ3DeathEggFlash:	include "Levels\LRZ\Misc Object Data\Map - Act 3 Death Egg Flash.asm"

Map_LRZ3Debris:	include "Levels\LRZ\Misc Object Data\Map - Act 3 Platform Debris.asm"

Map_DEZFinalBossMisc:	include "Levels\DEZ\Misc Object Data\Map - Final Boss Misc.asm"

Map_BossMasterEmerald:	dc.w 4

		dc.b	0, $24,	  0,   5, $E8,	$E
		dc.b	0,   0,	$FF, $E0, $E8,	$E
		dc.b	8,   0,	  0,   0,   0,	 4
		dc.b	0,  $C,	$FF, $E0,   0,	$E
		dc.b	0,  $E,	$FF, $F0,   0,	 4
		dc.b	0, $1A,	  0, $10,   0,	 2
		dc.b  $E8,  $F,	  0, $1C, $FF, $F0
		dc.b	8,   5,	  0, $2C, $FF, $F0
Map_DEZFinalBossDebris:	include "Levels\DEZ\Misc Object Data\Map - Final Boss Debris.asm"
	even
ArtKosM_StarPost_Stars1:binclude "General\Sprites\Starpost\Starpost Stars 1.bin"
	even
ArtKosM_StarPostStars2:binclude "General\Sprites\Starpost\Starpost Stars 2.bin"
	even
ArtKosM_StarPostStars3:binclude "General\Sprites\Starpost\Starpost Stars 3.bin"
	even
MapEni_BlueSphereTitleFG:binclude "General\Blue Sphere\Enigma Map\Title FG.bin"
	even
ArtKos_BlueSphereChar:	binclude "General\Blue Sphere\Kosinski Art\Characters.bin"
	even
Map_BlueSphereCharSprite:	include "General\Blue Sphere\Map - Character Sprites.asm"
	even
ArtKos_BlueSphereCharSprite:	binclude "General\Blue Sphere\Kosinski Art\Character Sprites.bin"
	even
ArtKos_BlueSphereNormalText:	binclude "General\Blue Sphere\Kosinski Art\Normal Text.bin hi "
	even
MapEni_BlueSphereTitleBG:	binclude "General\Blue Sphere\Enigma Map\Title BG.bin"
	even

ArtNem_BlueSphereSKLogo:	binclude "General\Blue Sphere\Nemesis Art\SK Logo.bin"
	even

ArtNem_BlueSphereTails:	binclude "General\Blue Sphere\Nemesis Art\Tails Pose.bin"
	even
ArtNem_MilesLifeIcon:	binclude "General\Sprites\HUD Icon\Miles Life Icon.bin"
	even
ArtUnc_Invincibility:	binclude "General\Sprites\Shields\Invincibility.bin"
	even

ArtUnc_DashDust:binclude "General\Sprites\Dash Dust\Dash Dust.bin"
	even

ArtUnc_SuperSonicKnux_Stars:binclude "General\Sprites\Shields\Super Sonic and Knuckles Stars.bin"
	even

ArtUnc_InstaShield:binclude "General\Sprites\Shields\Insta-Shield.bin"
	even
ArtUnc_FireShield:binclude "General\Sprites\Shields\Fire Shield.bin"
	even
ArtUnc_LightningShield:binclude "General\Sprites\Shields\Lightning Shield.bin"
	even
ArtUnc_LightningShield_Sparks:binclude "General\Sprites\Shields\Sparks.bin"
	even
ArtUnc_BubbleShield:binclude "General\Sprites\Shields\Bubble Shield.bin"
	even
ArtNem_GrayButton:binclude "General\Sprites\Buttons\Gray Button.bin"
	even

ArtNem_DiagonalSpring:	binclude "General\Sprites\Level Misc\Diagonal Spring.bin"
	even

ArtNem_SonicLifeIcon:binclude "General\Sprites\HUD Icon\Sonic life icon.bin"
	even

ArtNem_KnucklesLifeIcon:binclude "General\Sprites\HUD Icon\Knuckles life icon.bin"
	even
ArtNem_Monitors:binclude "General\Sprites\Monitors\Monitors.bin"
	even

ArtNem_S2Signpost:	binclude "General\Sprites\S2Menu\Signpost.bin"
	even
ArtNem_Bubbles:	binclude "General\Sprites\Bubbles\Bubbles.bin"
	even

ArtNem_GameOver:	binclude "General\Sprites\Game Over\GameOver.bin"
	even
ArtNem_Explosion:binclude "General\Sprites\Enemy Misc\Explosion.bin"
	even

ArtNem_SpikesSprings:	binclude "General\Sprites\Level Misc\SpikesSprings.bin"
	even

ArtNem_Ring:	binclude "General\Sprites\Ring\Ring.bin"
	even

ArtNem_EnemyPts:binclude "General\Sprites\Enemy Misc\Enemy points.bin"
	even

ArtNem_Bunny:	binclude "General\Sprites\Animals\Bunny.bin"
	even

ArtNem_BlueFlicky:	binclude "General\Sprites\Animals\Blue Flicky.bin"
	even

ArtNem_Chicken:	binclude "General\Sprites\Animals\Chicken.bin"
	even

ArtNem_Penguin:	binclude "General\Sprites\Animals\Penguin.bin"
	even
ArtNem_Squirrel:	binclude "General\Sprites\Animals\Squirrel.bin"
	even

ArtNem_Rabbit:	binclude "General\Sprites\Animals\Rabbit.bin"
	even

ArtNem_BonusStage:	binclude "General\Sprites\Bonus\Bonus Stage.bin"
	even

;LevDataPadding:
	if ~~strip_padding
		align $100
	endif

FBZ_16x16_Kos:	binclude "Levels\FBZ\Blocks\Primary.bin"
ArtKosM_FBZ:	binclude "Levels\FBZ\Tiles\Primary.bin"
FBZ_128x128_Kos:binclude "Levels\FBZ\Chunks\Primary.bin"

MHZ_16x16_Primary_Kos:binclude "Levels\MHZ\Blocks\Primary.bin"
ArtKosM_MHZ_Primary:binclude "Levels\MHZ\Tiles\Primary.bin"
MHZ_128x128_Primary_Kos:binclude "Levels\MHZ\Chunks\Primary.bin"
MHZ_16x16_Secondary_Kos:binclude "Levels\MHZ\Blocks\Secondary.bin"
ArtKosM_MHZ_Secondary:binclude "Levels\MHZ\Tiles\Secondary.bin"
MHZ_128x128_Secondary_Kos:binclude "Levels\MHZ\Chunks\Secondary.bin"
MHZ_16x16_Custom_Kos:binclude "Levels\MHZ\Blocks\Custom.bin"
ArtKosM_MHZ_Custom: binclude "Levels\MHZ\Tiles\Custom.bin"
MHZ_128x128_Custom_Kos:binclude "Levels\MHZ\Chunks\Custom.bin"

SOZ_16x16_Primary_Kos:binclude "Levels\SOZ\Blocks\Primary.bin"
ArtKosM_SOZ_Primary:binclude "Levels\SOZ\Tiles\Primary.bin"
SOZ_128x128_Kos:binclude "Levels\SOZ\Chunks\Primary.bin"

SOZ1_16x16_Secondary_Kos:binclude "Levels\SOZ\Blocks\Act 1 Secondary.bin"
ArtKosM_SOZ1_Secondary:binclude "Levels\SOZ\Tiles\Act 1 Secondary.bin"
SOZ1_16x16_Custom_Kos:binclude "Levels\SOZ\Blocks\Act 1 Custom.bin"
ArtKosM_SOZ1_Custom:binclude "Levels\SOZ\Tiles\Act 1 Custom.bin"

SOZ2_16x16_Secondary_Kos:binclude "Levels\SOZ\Blocks\Act 2 Secondary.bin"
ArtKosM_SOZ2_Secondary:binclude "Levels\SOZ\Tiles\Act 2 Secondary.bin"
SOZ2_16x16_Custom_Kos:binclude "Levels\SOZ\Blocks\Act 2 Custom.bin"
ArtKosM_SOZ2_Custom:binclude "Levels\SOZ\Tiles\Act 2 Custom.bin"

LRZ_16x16_Primary_Kos:binclude "Levels\LRZ\Blocks\Primary.bin"
ArtKosM_LRZ_Primary:binclude "Levels\LRZ\Tiles\Primary.bin"
LRZ_128x128_Primary_Kos:binclude "Levels\LRZ\Chunks\Primary.bin"
LRZ1_16x16_Secondary_Kos:binclude "Levels\LRZ\Blocks\Act 1 Secondary.bin"
ArtKosM_LRZ1_Secondary:binclude "Levels\LRZ\Tiles\Act 1 Secondary.bin"
LRZ1_128x128_Secondary_Kos:binclude "Levels\LRZ\Chunks\Act 1 Secondary.bin"

LRZ2_16x16_Secondary_Kos:binclude "Levels\LRZ\Blocks\Act 2 Secondary.bin"
ArtKosM_LRZ2_Secondary:binclude "Levels\LRZ\Tiles\Act 2 Secondary.bin"
LRZ2_128x128_Secondary_Kos:binclude "Levels\LRZ\Chunks\Act 2 Secondary.bin"

HPZ_16x16_Primary_Kos:binclude "Levels\HPZ\Blocks\Primary.bin"
ArtKosM_HPZ_Primary:binclude "Levels\HPZ\Tiles\Primary.bin"
HPZ_128x128_Primary_Kos:binclude "Levels\HPZ\Chunks\Primary.bin"

LRZ3_16x16_Secondary_Kos:binclude "Levels\LRZ\Blocks\Act 3 Secondary.bin"
ArtKosM_LRZ3_Secondary:binclude "Levels\LRZ\Tiles\Boss Secondary.bin"
LRZ3_128x128_Secondary_Kos:binclude "Levels\LRZ\Chunks\Act 3 Secondary.bin"

HPZ_16x16_Secondary_Kos:binclude "Levels\HPZ\Blocks\Secondary.bin"
ArtKosM_HPZ_Secondary:binclude "Levels\HPZ\Tiles\Secondary.bin"
HPZ_128x128_Secondary_Kos:binclude "Levels\HPZ\Chunks\Secondary.bin"

SSZ1_16x16_Primary_Kos:binclude "Levels\SSZ\Blocks\Act 1 Primary.bin"
ArtKosM_SSZ1_Primary:binclude "Levels\SSZ\Tiles\Act 1 Primary.bin"

SSZ1_128x128_Primary_Kos:binclude "Levels\SSZ\Chunks\Act 1 Primary.bin"
SSZ1_16x16_Secondary_Kos:binclude "Levels\SSZ\Blocks\Act 1 Secondary.bin"
ArtKosM_SSZ1_Secondary:binclude "Levels\SSZ\Tiles\Act 1 Secondary.bin"

SSZ1_128x128_Secondary_Kos:binclude "Levels\SSZ\Chunks\Act 1 Secondary.bin"
SSZ1_16x16_Custom_Kos:binclude "Levels\SSZ\Blocks\Act 1 Custom.bin"
ArtKosM_SSZ1_Custom:binclude "Levels\SSZ\Tiles\Act 1 Custom.bin"
SSZ1_128x128_Custom_Kos:binclude "Levels\SSZ\Chunks\Act 1 Custom.bin"

SSZ2_16x16_Kos:	binclude "Levels\SSZ\Blocks\Act 2.bin"
ArtKosM_SSZ2:	binclude "Levels\SSZ\Tiles\Act 2.bin"
SSZ2_128x128_Kos:binclude "Levels\SSZ\Chunks\Act 2.bin"

DEZ_16x16_Primary_Kos:binclude "Levels\DEZ\Blocks\Primary.bin"
ArtKosM_DEZ_Primary:binclude "Levels\DEZ\Tiles\Primary.bin"
DEZ_128x128_Kos:binclude "Levels\DEZ\Chunks\Primary.bin"

DEZ1_16x16_Secondary_Kos:binclude "Levels\DEZ\Blocks\Act 1 Secondary.bin"
ArtKosM_DEZ1_Secondary:binclude "Levels\DEZ\Tiles\Act 1 Secondary.bin"

DEZ2_16x16_Secondary_Kos:binclude "Levels\DEZ\Blocks\Act 2 Secondary.bin"
ArtKosM_DEZ2_Secondary:binclude "Levels\DEZ\Tiles\Act 2 Secondary.bin"

DEZ3_16x16_Kos:	binclude "Levels\DEZ\Blocks\Act 3.bin"
ArtKosM_DEZ3:	binclude "Levels\DEZ\Tiles\Final Boss Act.bin"
DEZ3_128x128_Kos:binclude "Levels\DEZ\Chunks\Act 3.bin"

DDZ_16x16_Kos:	binclude "Levels\DDZ\Blocks\Primary.bin"
ArtKosM_DDZ:	binclude "Levels\DDZ\Tiles\Primary.bin"
DDZ_128x128_Kos:binclude "Levels\DDZ\Chunks\Primary.bin"

Pachinko_16x16_Kos:binclude "Levels\Pachinko\Blocks\Primary.bin"
ArtKosM_Pachinko:binclude "Levels\Pachinko\Tiles\Pachinko.bin"
Pachinko_128x128_Kos:binclude "Levels\Pachinko\Chunks\Primary.bin"

Slots_16x16_Kos:binclude "Levels\Slots\Blocks\Primary.bin"
ArtKosM_Slots:	binclude "Levels\Slots\Tiles\Slots.bin"
Slots_128x128_Kos:binclude "Levels\Slots\Chunks\Primary.bin"

;UnknownDataPadding:
	if ~~strip_padding
		align $	100
	else
		even
	endif

Character_Speeds:	dc.w   $600,   $10,  $20, 0		; Sonic
			dc.w   $4C0,   $1C,  $70, 0		; Tails
			dc.w   $580,   $10, $200, 0		; Knuckles
Sonic_Start_Locations:
; 		include "Levels\Misc\Sonic Start Positions.asm"
		binclude "Levels\AIZ\Start Location\Sonic\1.bin"
		binclude "Levels\AIZ\Start Location\Sonic\2.bin"
		binclude "Levels\HCZ\Start Location\Sonic\1.bin"
		binclude "Levels\HCZ\Start Location\Sonic\2.bin"
		binclude "Levels\MGZ\Start Location\Sonic\1.bin"
		binclude "Levels\MGZ\Start Location\Sonic\2.bin"
		binclude "Levels\CNZ\Start Location\Sonic\1.bin"
		binclude "Levels\CNZ\Start Location\Sonic\2.bin"
		binclude "Levels\FBZ\Start Location\Sonic\1.bin"
		binclude "Levels\FBZ\Start Location\Sonic\2.bin"
		binclude "Levels\ICZ\Start Location\Sonic\1.bin"
		binclude "Levels\ICZ\Start Location\Sonic\2.bin"
		binclude "Levels\LBZ\Start Location\Sonic\1.bin"
		binclude "Levels\LBZ\Start Location\Sonic\2.bin"
		binclude "Levels\MHZ\Start Location\Sonic\1.bin"
		binclude "Levels\MHZ\Start Location\Sonic\2.bin"
		binclude "Levels\SOZ\Start Location\Sonic\1.bin"
SOZ2_Start:	binclude "Levels\SOZ\Start Location\Sonic\2.bin"
		binclude "Levels\LRZ\Start Location\Sonic\1.bin"
		binclude "Levels\LRZ\Start Location\Sonic\2.bin"
		binclude "Levels\SSZ\Start Location\Sonic\1.bin"
		binclude "Levels\SSZ\Start Location\Sonic\2.bin"
		binclude "Levels\DEZ\Start Location\Sonic\1.bin"
		binclude "Levels\DEZ\Start Location\Sonic\2.bin"
		binclude "Levels\DDZ\Start Location\Sonic\1.bin"
		binclude "Levels\DDZ\Start Location\Sonic\2.bin"
		binclude "Levels\AIZ\Start Location\Sonic\Intro.bin"
		binclude "Levels\SSZ\Start Location\Sonic\Ending.bin"
		binclude "Levels\ALZ\Start Location\Sonic\1.bin"
		binclude "Levels\ALZ\Start Location\Sonic\2.bin"
		binclude "Levels\BPZ\Start Location\Sonic\1.bin"
		binclude "Levels\BPZ\Start Location\Sonic\2.bin"
		binclude "Levels\DPZ\Start Location\Sonic\1.bin"
		binclude "Levels\DPZ\Start Location\Sonic\2.bin"
		binclude "Levels\CGZ\Start Location\Sonic\1.bin"
		binclude "Levels\CGZ\Start Location\Sonic\2.bin"
		binclude "Levels\EMZ\Start Location\Sonic\1.bin"
		binclude "Levels\EMZ\Start Location\Sonic\2.bin"
		binclude "Levels\Gumball\Start Location\Sonic\1.bin"
		binclude "Levels\Gumball\Start Location\Sonic\2.bin"
		binclude "Levels\Pachinko\Start Location\Sonic\1.bin"
		binclude "Levels\Pachinko\Start Location\Sonic\2.bin"
		binclude "Levels\Slots\Start Location\Sonic\1.bin"
		binclude "Levels\Slots\Start Location\Sonic\2.bin"
		binclude "Levels\LRZ\Start Location\Sonic\Boss.bin"
		binclude "Levels\HPZ\Start Location\Sonic\1.bin"
		binclude "Levels\DEZ\Start Location\Sonic\Boss.bin"
		binclude "Levels\HPZ\Start Location\Sonic\Special Stage.bin"
Knux_Start_Locations:
; 		include "Levels\Misc\Knuckles Start Positions.asm"
		binclude "Levels\AIZ\Start Location\Knuckles\1.bin"
		binclude "Levels\AIZ\Start Location\Knuckles\2.bin"
		binclude "Levels\HCZ\Start Location\Knuckles\1.bin"
		binclude "Levels\HCZ\Start Location\Knuckles\2.bin"
		binclude "Levels\MGZ\Start Location\Knuckles\1.bin"
		binclude "Levels\MGZ\Start Location\Knuckles\2.bin"
		binclude "Levels\CNZ\Start Location\Knuckles\1.bin"
		binclude "Levels\CNZ\Start Location\Knuckles\2.bin"
		binclude "Levels\FBZ\Start Location\Knuckles\1.bin"
		binclude "Levels\FBZ\Start Location\Knuckles\2.bin"
		binclude "Levels\ICZ\Start Location\Knuckles\1.bin"
		binclude "Levels\ICZ\Start Location\Knuckles\2.bin"
		binclude "Levels\LBZ\Start Location\Knuckles\1.bin"
		binclude "Levels\LBZ\Start Location\Knuckles\2.bin"
		binclude "Levels\MHZ\Start Location\Knuckles\1.bin"
		binclude "Levels\MHZ\Start Location\Knuckles\2.bin"
		binclude "Levels\SOZ\Start Location\Knuckles\1.bin"
		binclude "Levels\SOZ\Start Location\Knuckles\2.bin"
		binclude "Levels\LRZ\Start Location\Knuckles\1.bin"
		binclude "Levels\LRZ\Start Location\Knuckles\2.bin"
		binclude "Levels\SSZ\Start Location\Knuckles\1.bin"
		binclude "Levels\SSZ\Start Location\Knuckles\2.bin"
		binclude "Levels\DEZ\Start Location\Knuckles\1.bin"
		binclude "Levels\DEZ\Start Location\Knuckles\2.bin"
		binclude "Levels\DDZ\Start Location\Knuckles\1.bin"
		binclude "Levels\DDZ\Start Location\Knuckles\2.bin"
		binclude "Levels\AIZ\Start Location\Knuckles\Intro.bin"
		binclude "Levels\SSZ\Start Location\Knuckles\Ending.bin"
		binclude "Levels\ALZ\Start Location\Knuckles\1.bin"
		binclude "Levels\ALZ\Start Location\Knuckles\2.bin"
		binclude "Levels\BPZ\Start Location\Knuckles\1.bin"
		binclude "Levels\BPZ\Start Location\Knuckles\2.bin"
		binclude "Levels\DPZ\Start Location\Knuckles\1.bin"
		binclude "Levels\DPZ\Start Location\Knuckles\2.bin"
		binclude "Levels\CGZ\Start Location\Knuckles\1.bin"
		binclude "Levels\CGZ\Start Location\Knuckles\2.bin"
		binclude "Levels\EMZ\Start Location\Knuckles\1.bin"
		binclude "Levels\EMZ\Start Location\Knuckles\2.bin"
		binclude "Levels\Gumball\Start Location\Knuckles\1.bin"
		binclude "Levels\Gumball\Start Location\Knuckles\2.bin"
		binclude "Levels\Pachinko\Start Location\Knuckles\1.bin"
		binclude "Levels\Pachinko\Start Location\Knuckles\2.bin"
		binclude "Levels\Slots\Start Location\Knuckles\1.bin"
		binclude "Levels\Slots\Start Location\Knuckles\2.bin"
		binclude "Levels\LRZ\Start Location\Knuckles\Boss.bin"
		binclude "Levels\HPZ\Start Location\Knuckles\1.bin"
		binclude "Levels\DEZ\Start Location\Knuckles\Boss.bin"
		binclude "Levels\HPZ\Start Location\Knuckles\Special Stage.bin"
SpriteLocPtrs:	dc.l AIZ1_Sprites
		dc.l AIZ2_Sprites
		dc.l HCZ1_Sprites
		dc.l HCZ2_Sprites
		dc.l MGZ1_Sprites
		dc.l MGZ2_Sprites
		dc.l CNZ1_Sprites
		dc.l CNZ2_Sprites
		dc.l FBZ1_Sprites
		dc.l FBZ2_Sprites
		dc.l ICZ1_Sprites
		dc.l ICZ2_Sprites
		dc.l LBZ1_Sprites
		dc.l LBZ2_Sprites
		dc.l MHZ1_Sprites
		dc.l MHZ2_Sprites
		dc.l SOZ1_Sprites
		dc.l SOZ2_Sprites
		dc.l LRZ1_Sprites
		dc.l LRZ2_Sprites
		dc.l SSZ1_Sprites
		dc.l SSZ2_SPrites
		dc.l DEZ1_Sprites
		dc.l DEZ2_Sprites
		dc.l DDZ1_Sprites
		dc.l DDZ2_Sprites
		dc.l Ending_Sprites
		dc.l Ending_Sprites
		dc.l ALZ_Sprites
		dc.l ALZ_Sprites
		dc.l BPZ_Sprites
		dc.l BPZ_Sprites
		dc.l DPZ_Sprites
		dc.l DPZ_Sprites
		dc.l CGZ_Sprites
		dc.l CGZ_Sprites
		dc.l EMZ_Sprites
		dc.l EMZ_Sprites
		dc.l Gumball_Sprites
		dc.l Gumball_Sprites
		dc.l Pachinko_Sprites
		dc.l Pachinko_Sprites
		dc.l Slots_Sprites
		dc.l Slots_Sprites
		dc.l LRZ3_Sprites
		dc.l HPZ_Sprites
		dc.l DEZ3_Sprites
		dc.l HPZMini_Sprites
RingLocPtrs:	dc.l AIZ1_Rings
		dc.l AIZ2_Rings
		dc.l HCZ1_Rings
		dc.l HCZ2_Rings
		dc.l MGZ1_Rings
		dc.l MGZ2_Rings
		dc.l CNZ1_Rings
		dc.l CNZ2_Rings
		dc.l FBZ1_Rings
		dc.l FBZ2_Rings
		dc.l ICZ1_Rings
		dc.l ICZ2_Rings
		dc.l LBZ1_Rings
		dc.l LBZ2_Rings
		dc.l MHZ1_Rings
		dc.l MHZ2_Rings
		dc.l SOZ1_Rings
		dc.l SOZ2_Rings
		dc.l LRZ1_Rings
		dc.l LRZ2_Rings
		dc.l SSZ1_Rings
		dc.l SSZ2_Rings
		dc.l DEZ1_Rings
		dc.l DEZ2_Rings
		dc.l DDZ1_Rings
		dc.l DDZ2_Rings
		dc.l Ending_Rings
		dc.l Ending_Rings
		dc.l ALZ_Rings
		dc.l ALZ_Rings
		dc.l BPZ_Rings
		dc.l BPZ_Rings
		dc.l DPZ_Rings
		dc.l DPZ_Rings
		dc.l CGZ_Rings
		dc.l CGZ_Rings
		dc.l EMZ_Rings
		dc.l EMZ_Rings
		dc.l Gumball_Rings
		dc.l Gumball_Rings
		dc.l Pachinko_Rings
		dc.l Pachinko_Rings
		dc.l Slots_Rings
		dc.l Slots_Rings
		dc.l LRZ3_Rings
		dc.l HPZ_Rings
		dc.l DEZ3_Rings
		dc.l DEZ3_Rings
AutoTunnel_Data:	dc.l AutoTunnel_00
		dc.l AutoTunnel_01_02
		dc.l AutoTunnel_01_02
		dc.l AutoTunnel_03
		dc.l AutoTunnel_04
		dc.l AutoTunnel_05
		dc.l AutoTunnel_06
		dc.l AutoTunnel_07
		dc.l AutoTunnel_08
		dc.l AutoTunnel_09
		dc.l AutoTunnel_0A
		dc.l AutoTunnel_0B
		dc.l AutoTunnel_0C
		dc.l AutoTunnel_0D
		dc.l AutoTunnel_0E
		dc.l AutoTunnel_0F
		dc.l AutoTunnel_10
		dc.l AutoTunnel_11
		dc.l AutoTunnel_12
		dc.l AutoTunnel_13
		dc.l AutoTunnel_14
		dc.l AutoTunnel_15		; LRZ2 first
		dc.l AutoTunnel_16
		dc.l AutoTunnel_17
		dc.l AutoTunnel_18
		dc.l AutoTunnel_19
		dc.l SpriteTerminatB
		dc.l SpriteTerminatB
		dc.l SpriteTerminatB
		dc.l SpriteTerminatB
		dc.l SpriteTerminatB
		dc.l SpriteTerminatB
FBZSnakePlatform_Data:	dc.l word_1EE2D4

		dc.l word_1EE2E4
		dc.l word_1EE2F4
		dc.l word_1EE310
		dc.l word_1EE330
		dc.l word_1EE350
		dc.l word_1EE36C
		dc.l word_1EE398
		dc.l SpriteTerminat7
		dc.l SpriteTerminat7
		dc.l SpriteTerminat7
		dc.l SpriteTerminat7
		dc.l SpriteTerminat7
		dc.l SpriteTerminat7
		dc.l SpriteTerminat7
		dc.l SpriteTerminat7
SOZRockRideInfo:dc.l word_1F6C70
		dc.l word_1F6C78
		dc.l word_1F6C82
		dc.l word_1F6C8E
		dc.l word_1F6C9A
		dc.l word_1F6CA6
		dc.l word_1F6CB0
		dc.l word_1F6CBC
		dc.l word_1F6CC2
		dc.l word_1F6CCA
		dc.l word_1F6CD4
		dc.l word_1F6CDA
		dc.l word_1F6CDA
		dc.l word_1F6CDA
		dc.l word_1F6CDA
		dc.l word_1F6CDA
		dc.l word_1F6CDA
		dc.l word_1F6CDA
		dc.l word_1F6CDA
		dc.l word_1F6CDA
		dc.l word_1F6CDA
		dc.l word_1F6CDA
		dc.l word_1F6CDA
		dc.l word_1F6CDA
		dc.l word_1F6CDA
		dc.l word_1F6CDA
		dc.l word_1F6CDA
		dc.l word_1F6CDA
		dc.l word_1F6CDA
		dc.l word_1F6CDA
		dc.l word_1F6CDA
		dc.l word_1F6CDA
DEZTunnelPaths:	dc.l word_1FB49E
		dc.l word_1FB518
		dc.l word_1FB5B2
		dc.l word_1FB5B2
		dc.l word_1FB5F0
		dc.l word_1FB646
		dc.l word_1FB6B4
		dc.l word_1FB6CE
SSCompressedLayoutPtrs:
		dc.l SSLayoutData1_Kos
		dc.l SSLayoutData2_Kos
SlotBonusLayout:
		binclude "Levels\Slots\SSLayout\Bonus Player Start.bin"
		binclude "Levels\Slots\SSLayout\Bonus Layout.bin"

byte_1E4484:	dc.b    1,   3,   1,   3,   8,   3,   8,   5,   1,   3,   6,   4,   1,   7,   6,   5,   8,   6,   4,   3
		dc.b    4,   3,   4,   5,   8,   4,   5,   3,   7,   3,   8,   3,   6,   5,   6,   7,   4,   3,   7,   5
		dc.b    6,   4,   6,   4,   7,   3,   3,   5,   4,   3,   4,   6,   3,   4,   3,   7,   4,   3,   4,   3
		dc.b    4,   3,   4,   3
byte_1E44C4:	dc.b  $50, $32,	$28, $23, $23, $1E, $1E, $14, $14,  $A,	 $A,  $A,  $A,	 5,   5,   5

SpriteTerminat1:dc.w  $FFFF,	 0,	0
AIZ1_Sprites:	binclude "Levels\AIZ\Object Pos\1.bin"
AIZ2_Sprites:	binclude "Levels\AIZ\Object Pos\2.bin"
AIZ1_Rings:	binclude "Levels\AIZ\Ring Pos\1.bin"
AIZ2_Rings:	binclude "Levels\AIZ\Ring Pos\2.bin"
SpriteTerminat2:dc.w  $FFFF,	 0,	0
HCZ1_Sprites:	binclude "Levels\HCZ\Object Pos\1.bin"
HCZ2_Sprites:	binclude "Levels\HCZ\Object Pos\2.bin"
HCZ1_Rings:	binclude "Levels\HCZ\Ring Pos\1.bin"
HCZ2_Rings:	binclude "Levels\HCZ\Ring Pos\2.bin"
SpriteTerminat3:dc.w  $FFFF,	 0,	0
MGZ1_Sprites:	binclude "Levels\MGZ\Object Pos\1.bin"
MGZ1_Rings:	binclude "Levels\MGZ\Ring Pos\1.bin"
SpriteTerminat4:dc.w  $FFFF,	 0,	0
MGZ2_Sprites:	binclude "Levels\MGZ\Object Pos\2.bin"
MGZ2_Rings:	binclude "Levels\MGZ\Ring Pos\2.bin"
SpriteTerminat5:dc.w  $FFFF,	 0,	0
CNZ1_Sprites:	binclude "Levels\CNZ\Object Pos\1.bin"
CNZ2_Sprites:	binclude "Levels\CNZ\Object Pos\2.bin"
CNZ1_Rings:	binclude "Levels\CNZ\Ring Pos\1.bin"
CNZ2_Rings:	binclude "Levels\CNZ\Ring Pos\2.bin"
SpriteTerminat6:dc.w  $FFFF,	 0,	0
FBZ1_Sprites:	binclude "Levels\FBZ\Object Pos\1.bin"
FBZ2_Sprites:	binclude "Levels\FBZ\Object Pos\2.bin"
FBZ1_Rings:	binclude "Levels\FBZ\Ring Pos\1.bin"
FBZ2_Rings:	binclude "Levels\FBZ\Ring Pos\2.bin"
word_1EE2D4:	dc.w $10F1
		dc.w $118C
		dc.w $118C
		dc.w $770
		dc.w $10F1
		dc.w $770
		dc.w $FFFF
		dc.w $3C
word_1EE2E4:	dc.w $1174
		dc.w $120F
		dc.w $1174
		dc.w $7F0
		dc.w $120F
		dc.w $7F0
		dc.w $FFFF
		dc.w $3C
word_1EE2F4:	dc.w $C56
		dc.w $D64
		dc.w $D64
		dc.w $420
		dc.w $C56
		dc.w $420
		dc.w $C56
		dc.w $510
		dc.w $D64
		dc.w $510
		dc.w $D64
		dc.w $420
		dc.w $FFFF
		dc.w 0
word_1EE310:	dc.w $B64
		dc.w $CE3
		dc.w $C1A
		dc.w $317
		dc.w $CE3
		dc.w $317
		dc.w $CE3
		dc.w $3C8
		dc.w $B64
		dc.w $3C8
		dc.w $B64
		dc.w $317
		dc.w $C1A
		dc.w $317
		dc.w $FFFF
		dc.w 0
word_1EE330:	dc.w $B64
		dc.w $CE3
		dc.w $C1B
		dc.w $3C8
		dc.w $B65
		dc.w $3C8
		dc.w $B65
		dc.w $317
		dc.w $CE3
		dc.w $317
		dc.w $CE3
		dc.w $3C8
		dc.w $C1B
		dc.w $3C8
		dc.w $FFFF
		dc.w 0
word_1EE350:	dc.w $C56
		dc.w $D64
		dc.w $C56
		dc.w $510
		dc.w $D64
		dc.w $510
		dc.w $D64
		dc.w $420
		dc.w $C56
		dc.w $420
		dc.w $C56
		dc.w $510
		dc.w $FFFF
		dc.w 0
word_1EE36C:	dc.w $1D79
		dc.w $1EEB
		dc.w $1EEB
		dc.w $213
		dc.w $1EEB
		dc.w $400
		dc.w $1D79
		dc.w $400
		dc.w $1D79
		dc.w $319
		dc.w $1E82
		dc.w $319
		dc.w $1E82
		dc.w $369
		dc.w $1E1E
		dc.w $369
		dc.w $1E1E
		dc.w $213
		dc.w $1EEB
		dc.w $213
		dc.w $FFFF
		dc.w 0
word_1EE398:	dc.w $1D79
		dc.w $1EEB
		dc.w $1E82
		dc.w $319
		dc.w $1E82
		dc.w $369
		dc.w $1E1E
		dc.w $369
		dc.w $1E1E
		dc.w $213
		dc.w $1EEB
		dc.w $213
		dc.w $1EEB
		dc.w $400
		dc.w $1D79
		dc.w $400
		dc.w $1D79
		dc.w $319
		dc.w $1E82
		dc.w $319
		dc.w $FFFF
		dc.w 0
SpriteTerminat7:dc.w  $FFFF,	 0,	0
ICZ1_Sprites:	binclude "Levels\ICZ\Object Pos\1.bin"
ICZ2_Sprites:	binclude "Levels\ICZ\Object Pos\2.bin"
ICZ1_Rings:	binclude "Levels\ICZ\Ring Pos\1.bin"
ICZ2_Rings:	binclude "Levels\ICZ\Ring Pos\2.bin"
SpriteTerminat8:dc.w  $FFFF,	 0,	0
LBZ1_Sprites:	binclude "Levels\LBZ\Object Pos\1.bin"
LBZ2_Sprites:	binclude "Levels\LBZ\Object Pos\2.bin"
LBZ1_Rings:	binclude "Levels\LBZ\Ring Pos\1.bin"
LBZ2_Rings:	binclude "Levels\LBZ\Ring Pos\2.bin"
AutoTunnel_00:	dc.w $C
		dc.w   $F60,  $578
		dc.w   $F60,  $548
		dc.w   $F60,  $378
AutoTunnel_01_02:	dc.w $38
		dc.w   $D40,  $770
		dc.w   $D48,  $770
		dc.w   $D50,  $770
		dc.w   $D58,  $770
		dc.w   $D60,  $770
		dc.w   $DB0,  $770
		dc.w   $DD0,  $77C
		dc.w   $DE0,  $79C
		dc.w   $DD6,  $7BC
		dc.w   $DB6,  $7CE
		dc.w   $D96,  $7CE
		dc.w   $D86,  $7C8
		dc.w   $D70,  $7A8
		dc.w   $D70,  $688
AutoTunnel_03:	dc.w $28
		dc.w   $D30,  $770
		dc.w   $DB0,  $770
		dc.w   $DD0,  $77C
		dc.w   $DE0,  $79C
		dc.w   $DD6,  $7BC
		dc.w   $DB6,  $7CE
		dc.w   $D96,  $7CE
		dc.w   $D86,  $7C8
		dc.w   $D70,  $7A8
		dc.w   $D70,  $748
AutoTunnel_04:	dc.w $38
		dc.w  $2CC0,  $9F0
		dc.w  $2CC8,  $9F0
		dc.w  $2CD0,  $9F0
		dc.w  $2CD8,  $9F0
		dc.w  $2CE0,  $9F0
		dc.w  $2D30,  $9F0
		dc.w  $2D50,  $9FC
		dc.w  $2D60,  $A1C
		dc.w  $2D56,  $A3C
		dc.w  $2D36,  $A4E
		dc.w  $2D16,  $A4E
		dc.w  $2D06,  $A48
		dc.w  $2CF0,  $A28
		dc.w  $2CF0,  $908
AutoTunnel_05:	dc.w $28
		dc.w  $2CB0,  $9F0
		dc.w  $2D30,  $9F0
		dc.w  $2D50,  $9FC
		dc.w  $2D60,  $A1C
		dc.w  $2D56,  $A3C
		dc.w  $2D36,  $A4E
		dc.w  $2D16,  $A4E
		dc.w  $2D06,  $A48
		dc.w  $2CF0,  $A28
		dc.w  $2CF0,  $9C8
AutoTunnel_06:	dc.w $38
		dc.w  $3640,  $A70
		dc.w  $3648,  $A70
		dc.w  $3650,  $A70
		dc.w  $3658,  $A70
		dc.w  $3660,  $A70
		dc.w  $36B0,  $A70
		dc.w  $36D0,  $A7C
		dc.w  $36E0,  $A9C
		dc.w  $36D6,  $ABC
		dc.w  $36B6,  $ACE
		dc.w  $3696,  $ACE
		dc.w  $3686,  $AC8
		dc.w  $3670,  $AA8
		dc.w  $3670,  $988
AutoTunnel_07:	dc.w $28
		dc.w  $3630,  $A70
		dc.w  $36B0,  $A70
		dc.w  $36D0,  $A7C
		dc.w  $36E0,  $A9C
		dc.w  $36D6,  $ABC
		dc.w  $36B6,  $ACE
		dc.w  $3696,  $ACE
		dc.w  $3686,  $AC8
		dc.w  $3670,  $AA8
		dc.w  $3670,  $A48
AutoTunnel_08:	dc.w $38
		dc.w  $37C0,  $7F0
		dc.w  $37C8,  $7F0
		dc.w  $37D0,  $7F0
		dc.w  $37D8,  $7F0
		dc.w  $37E0,  $7F0
		dc.w  $3830,  $7F0
		dc.w  $3850,  $7FC
		dc.w  $3860,  $81C
		dc.w  $3856,  $83C
		dc.w  $3836,  $84E
		dc.w  $3816,  $84E
		dc.w  $3806,  $848
		dc.w  $37F0,  $828
		dc.w  $37F0,  $708
AutoTunnel_09:	dc.w $28
		dc.w  $37B0,  $7F0
		dc.w  $3830,  $7F0
		dc.w  $3850,  $7FC
		dc.w  $3860,  $81C
		dc.w  $3856,  $83C
		dc.w  $3836,  $84E
		dc.w  $3816,  $84E
		dc.w  $3806,  $848
		dc.w  $37F0,  $828
		dc.w  $37F0,  $7C8
AutoTunnel_0A:	dc.w $38
		dc.w  $29C0,  $470
		dc.w  $29C8,  $470
		dc.w  $29D0,  $470
		dc.w  $29D8,  $470
		dc.w  $29E0,  $470
		dc.w  $2A30,  $470
		dc.w  $2A50,  $47C
		dc.w  $2A60,  $49C
		dc.w  $2A56,  $4BC
		dc.w  $2A36,  $4CE
		dc.w  $2A16,  $4CE
		dc.w  $2A06,  $4C8
		dc.w  $29F0,  $4A8
		dc.w  $29F0,  $388
AutoTunnel_0B:	dc.w $28
		dc.w  $29B0,  $470
		dc.w  $2A30,  $470
		dc.w  $2A50,  $47C
		dc.w  $2A60,  $49C
		dc.w  $2A56,  $4BC
		dc.w  $2A36,  $4CE
		dc.w  $2A16,  $4CE
		dc.w  $2A06,  $4C8
		dc.w  $29F0,  $4A8
		dc.w  $29F0,  $448
AutoTunnel_0C:	dc.w $104
		dc.w  $26C0,  $530
		dc.w  $26C0,  $6E0
		dc.w  $26B2,  $700
		dc.w  $2692,  $710
		dc.w  $25F2,  $710
		dc.w  $25D2,  $704
		dc.w  $25C0,  $6E4
		dc.w  $25C0,  $4B4
		dc.w  $25B0,  $484
		dc.w  $2590,  $464
		dc.w  $2560,  $450
		dc.w  $24D0,  $450
		dc.w  $2490,  $43B
		dc.w  $2450,  $41F
		dc.w  $2400,  $410
		dc.w  $2300,  $410
		dc.w  $22D0,  $415
		dc.w  $22A0,  $42B
		dc.w  $2280,  $448
		dc.w  $2240,  $468
		dc.w  $2200,  $470
		dc.w  $21C0,  $468
		dc.w  $2180,  $448
		dc.w  $2160,  $42B
		dc.w  $2130,  $415
		dc.w  $2100,  $410
		dc.w  $20D0,  $415
		dc.w  $20A0,  $42B
		dc.w  $2080,  $448
		dc.w  $2040,  $468
		dc.w  $2000,  $470
		dc.w  $1FC0,  $468
		dc.w  $1F80,  $448
		dc.w  $1F60,  $42B
		dc.w  $1F30,  $415
		dc.w  $1F00,  $410
		dc.w  $1ED0,  $415
		dc.w  $1EA0,  $42B
		dc.w  $1E80,  $448
		dc.w  $1E40,  $468
		dc.w  $1E00,  $470
		dc.w  $1C70,  $470
		dc.w  $1C40,  $440
		dc.w  $1C40,  $320
		dc.w  $1C50,  $300
		dc.w  $1C70,  $2F0
		dc.w  $1F80,  $2F0
		dc.w  $1FD0,  $2E4
		dc.w  $2000,  $2C8
		dc.w  $2020,  $2AB
		dc.w  $2040,  $29A
		dc.w  $2080,  $290
		dc.w  $20C0,  $2A7
		dc.w  $2170,  $357
		dc.w  $21B0,  $370
		dc.w  $2400,  $370
		dc.w  $2440,  $380
		dc.w  $2480,  $390
		dc.w  $24B0,  $384
		dc.w  $24C0,  $364
		dc.w  $24C0,   $C4
		dc.w  $2490,   $90
		dc.w  $2450,   $9C
		dc.w  $2440,   $CC
		dc.w  $2440,   $FC
AutoTunnel_0D:	dc.w $64
		dc.w  $33C0,  $130
		dc.w  $33C0,  $1E0
		dc.w  $33D0,  $200
		dc.w  $3400,  $210
		dc.w  $3450,  $220
		dc.w  $34A0,  $270
		dc.w  $34C0,  $2A0
		dc.w  $34C0,  $460
		dc.w  $34CE,  $480
		dc.w  $34F0,  $490
		dc.w  $3710,  $490
		dc.w  $372E,  $480
		dc.w  $3740,  $460
		dc.w  $3740,  $330
		dc.w  $3720,  $310
		dc.w  $35F0,  $310
		dc.w  $35CE,  $300
		dc.w  $35C0,  $2E0
		dc.w  $35C0,   $40
		dc.w  $35CC,   $20
		dc.w  $3600,   $10
		dc.w  $3690,   $10
		dc.w  $36B4,   $20
		dc.w  $36C0,   $40
		dc.w  $36C0,   $80
AutoTunnel_0E:	dc.w $38
		dc.w  $14C0,  $AB0
		dc.w  $14C0,  $B60
		dc.w  $14D0,  $B80
		dc.w  $14F0,  $B90
		dc.w  $1610,  $B90
		dc.w  $1630,  $B80
		dc.w  $1640,  $B60
		dc.w  $1640,  $8C0
		dc.w  $1650,  $8A0
		dc.w  $1670,  $890
		dc.w  $1890,  $890
		dc.w  $18B0,  $89C
		dc.w  $18C0,  $8BC
		dc.w  $18C0,  $8FC
AutoTunnel_0F:	dc.w $38
		dc.w  $3840,  $730
		dc.w  $3840,  $860
		dc.w  $3832,  $880
		dc.w  $3802,  $890
		dc.w  $37D2,  $884
		dc.w  $37C0,  $864
		dc.w  $37C0,  $3D4
		dc.w  $37D0,  $3B4
		dc.w  $37F0,  $39C
		dc.w  $3820,  $390
		dc.w  $3990,  $390
		dc.w  $39B0,  $39C
		dc.w  $39C0,  $3BC
		dc.w  $39C0,  $3FC
AutoTunnel_10:	dc.w $7C
		dc.w   $F60,  $5C8
		dc.w   $F60,  $950
		dc.w   $F64,  $980
		dc.w   $F68,  $990
		dc.w   $F73,  $9B0
		dc.w   $F82,  $9D0
		dc.w   $F8C,  $9E0
		dc.w   $F98,  $9F0
		dc.w   $FA5,  $A00
		dc.w   $FB5,  $A10
		dc.w   $FC5,  $A1C
		dc.w   $FD5,  $A28
		dc.w   $FF5,  $A38
		dc.w  $1005,  $A40
		dc.w  $1025,  $A4A
		dc.w  $1035,  $A4C
		dc.w  $1055,  $A50
		dc.w  $1265,  $A50
		dc.w  $12A5,  $A48
		dc.w  $12C5,  $A3C
		dc.w  $12E5,  $A2C
		dc.w  $12F5,  $A20
		dc.w  $1305,  $A14
		dc.w  $1315,  $A08
		dc.w  $1320,  $9F8
		dc.w  $132F,  $9E8
		dc.w  $1343,  $9C8
		dc.w  $1350,  $9A8
		dc.w  $135A,  $988
		dc.w  $1360,  $958
		dc.w  $1360,  $878
AutoTunnel_11:	dc.w $7C
		dc.w  $3760,  $1C8
		dc.w  $3760,  $510
		dc.w  $375A,  $540
		dc.w  $3750,  $560
		dc.w  $3743,  $580
		dc.w  $372F,  $5A0
		dc.w  $3720,  $5B0
		dc.w  $3715,  $5C0
		dc.w  $3705,  $5CC
		dc.w  $36F5,  $5D8
		dc.w  $36E5,  $5E4
		dc.w  $36C5,  $5F4
		dc.w  $36A5,  $600
		dc.w  $3665,  $608
		dc.w  $3655,  $608
		dc.w  $3635,  $604
		dc.w  $3625,  $602
		dc.w  $3605,  $5F8
		dc.w  $35F5,  $5F0
		dc.w  $35D5,  $5E0
		dc.w  $35C5,  $5D4
		dc.w  $35B5,  $5C8
		dc.w  $35A5,  $5B8
		dc.w  $3598,  $5A8
		dc.w  $358C,  $598
		dc.w  $3582,  $588
		dc.w  $3573,  $568
		dc.w  $3568,  $548
		dc.w  $3564,  $538
		dc.w  $3560,  $508
		dc.w  $3560,  $478
AutoTunnel_12:	dc.w $7C
		dc.w  $3460,  $5C8
		dc.w  $3460,  $690
		dc.w  $345A,  $6C0
		dc.w  $3450,  $6E0
		dc.w  $3443,  $700
		dc.w  $342F,  $720
		dc.w  $3420,  $730
		dc.w  $3415,  $740
		dc.w  $3405,  $74C
		dc.w  $33F5,  $758
		dc.w  $33E5,  $764
		dc.w  $33C5,  $774
		dc.w  $33A5,  $780
		dc.w  $3365,  $788
		dc.w  $3355,  $788
		dc.w  $3335,  $784
		dc.w  $3325,  $782
		dc.w  $3305,  $778
		dc.w  $32F5,  $770
		dc.w  $32D5,  $760
		dc.w  $32C5,  $754
		dc.w  $32B5,  $748
		dc.w  $32A5,  $738
		dc.w  $3298,  $728
		dc.w  $328C,  $718
		dc.w  $3282,  $708
		dc.w  $3273,  $6E8
		dc.w  $3268,  $6C8
		dc.w  $3264,  $6B8
		dc.w  $3260,  $688
		dc.w  $3260,  $5F8
AutoTunnel_13:	dc.w $28
		dc.w  $1C70,  $730
		dc.w  $1C70,  $6C0
		dc.w  $1C62,  $6A0
		dc.w  $1C42,  $692
		dc.w  $1C32,  $692
		dc.w  $1C12,  $69B
		dc.w  $1C00,  $6BB
		dc.w  $1C08,  $6DB
		dc.w  $1C28,  $6F0
		dc.w  $1CA8,  $6F0
AutoTunnel_14:	dc.w $28
		dc.w  $3670,  $830
		dc.w  $3670,  $7C0
		dc.w  $3662,  $7A0
		dc.w  $3642,  $792
		dc.w  $3632,  $792
		dc.w  $3612,  $79B
		dc.w  $3600,  $7BB
		dc.w  $3608,  $7DB
		dc.w  $3628,  $7F0
		dc.w  $36A8,  $7F0
SpriteTerminat9:dc.w  $FFFF,	 0,	0
MHZ1_Sprites:	binclude "Levels\MHZ\Object Pos\1.bin"
MHZ2_Sprites:	binclude "Levels\MHZ\Object Pos\2.bin"
MHZ1_Rings:	binclude "Levels\MHZ\Ring Pos\1.bin"
MHZ2_Rings:	binclude "Levels\MHZ\Ring Pos\2.bin"
SpriteTerminatA:dc.w  $FFFF,	 0,	0
SOZ1_Sprites:	binclude "Levels\SOZ\Object Pos\1.bin"
SOZ2_Sprites:	binclude "Levels\SOZ\Object Pos\2.bin"
SOZ1_Rings:	binclude "Levels\SOZ\Ring Pos\1.bin"
SOZ2_Rings:	binclude "Levels\SOZ\Ring Pos\2.bin"
word_1F6C70:	dc.w   $A68, $13A0
		dc.w   $D00, $FFFF
word_1F6C78:	dc.w   $A70, $19C0
		dc.w   $AD2, $1AF0
		dc.w  $FFFF
word_1F6C82:	dc.w   $470, $1F40
		dc.w   $490, $1FA0
		dc.w   $D00, $FFFF
word_1F6C8E:	dc.w   $AD0, $2D80
		dc.w   $B00, $2E30
		dc.w   $D00, $FFFF
word_1F6C9A:	dc.w   $450, $24C0
		dc.w   $4F0, $2560
		dc.w   $D00, $FFFF
word_1F6CA6:	dc.w   $270, $1600
		dc.w   $2D2, $1730
		dc.w  $FFFF
word_1F6CB0:	dc.w   $A68, $2740
		dc.w   $A80, $2838
		dc.w   $D00, $FFFF
word_1F6CBC:	dc.w   $5EC, $47F0
		dc.w  $FFFF
word_1F6CC2:	dc.w   $4E0, $4620
		dc.w   $600, $FFFF
word_1F6CCA:	dc.w   $630,  $460
		dc.w   $652,  $4F0
		dc.w  $FFFF
word_1F6CD4:	dc.w   $6F0, $2D70
		dc.w  $FFFF
word_1F6CDA:	dc.w $FFFF
AutoTunnel_15:	dc.w	$30, $11B8
		dc.w   $6F0, $1270
		dc.w   $6F0, $128C
		dc.w   $6F3, $12A1
		dc.w   $6FE, $12AD
		dc.w   $710, $12B0
		dc.w   $728, $12B0
		dc.w   $8B0, $12AC
		dc.w   $8D1, $12A0
		dc.w   $8E3, $128C
		dc.w   $8EE, $1270
		dc.w   $8F0, $11B8
		dc.w   $8F0
AutoTunnel_16:	dc.w	$80, $17B8
		dc.w   $B70, $1870
		dc.w   $B70, $1890
		dc.w   $B6D, $18A0
		dc.w   $B63, $18AD
		dc.w   $B53, $18B0
		dc.w   $B33, $18B0
		dc.w   $8B0, $18B2
		dc.w   $893, $18BC
		dc.w   $880, $18CE
		dc.w   $872, $18F0
		dc.w   $870, $1A70
		dc.w   $870, $1A90
		dc.w   $86D, $1AA2
		dc.w   $862, $1AAE
		dc.w   $84E, $1AB0
		dc.w   $830, $1AB0
		dc.w   $6B0, $1AB2
		dc.w   $692, $1ABD
		dc.w   $67E, $1AD2
		dc.w   $671, $1AF0
		dc.w   $670, $1B70
		dc.w   $670, $1B90
		dc.w   $66D, $1BA2
		dc.w   $662, $1BAF
		dc.w   $64E, $1BB0
		dc.w   $630, $1BB0
		dc.w   $4B0, $1BB0
		dc.w   $495, $1BA2
		dc.w   $47E, $1B8D
		dc.w   $471, $1B70
		dc.w   $470, $1AB8
		dc.w   $470
AutoTunnel_17:	dc.w	$2C, $22B8
		dc.w	$70, $2370
		dc.w	$70, $2390
		dc.w	$73, $23A1
		dc.w	$7E, $23AD
		dc.w	$90, $23B0
		dc.w	$B0, $23B0
		dc.w   $1B0, $23B2
		dc.w   $1D1, $23BF
		dc.w   $1E4, $23D6
		dc.w   $1F0, $2448
		dc.w   $1F0
AutoTunnel_18:	dc.w	$58, $2D48
		dc.w   $7F0, $2CF0
		dc.w   $7F0, $2CD0
		dc.w   $7EE, $2CBD
		dc.w   $7E3, $2CB2
		dc.w   $7D0, $2CB0
		dc.w   $7B0, $2CB0
		dc.w   $430, $2CB1
		dc.w   $411, $2CBB
		dc.w   $3FF, $2CCF
		dc.w   $3F2, $2CF0
		dc.w   $3F0, $2D70
		dc.w   $3F0, $2D90
		dc.w   $3ED, $2DA2
		dc.w   $3E2, $2DAF
		dc.w   $3CE, $2DB0
		dc.w   $3B0, $2DB0
		dc.w   $330, $2DB2
		dc.w   $311, $2DBC
		dc.w   $2FE, $2DD1
		dc.w   $2F1, $2DEF
		dc.w   $2F0, $30F0
		dc.w   $2F0
AutoTunnel_19:	dc.w	$30, $3A38
		dc.w   $3F0, $3AF0
		dc.w   $3F0, $3B10
		dc.w   $3EE, $3B23
		dc.w   $3E0, $3B2F
		dc.w   $3CA, $3B30
		dc.w   $3B0, $3B30
		dc.w   $230, $3B32
		dc.w   $211, $3B3C
		dc.w   $1FF, $3B50
		dc.w   $1F2, $3B70
		dc.w   $1F0, $3BC8
		dc.w   $1F0
SpriteTerminatB:dc.w  $FFFF,	 0,	0
LRZ1_Sprites:	binclude "Levels\LRZ\Object Pos\1.bin"
LRZ2_Sprites:	binclude "Levels\LRZ\Object Pos\2.bin"
LRZ1_Rings:	binclude "Levels\LRZ\Ring Pos\1.bin"
LRZ2_Rings:	binclude "Levels\LRZ\Ring Pos\2.bin"
SpriteTerminatC:dc.w  $FFFF,	 0,	0
SSZ1_Sprites:	binclude "Levels\SSZ\Object Pos\1.bin"
SSZ2_SPrites:	binclude "Levels\SSZ\Object Pos\2.bin"
SSZ1_Rings:	binclude "Levels\SSZ\Ring Pos\1.bin"
SSZ2_Rings:	binclude "Levels\SSZ\Ring Pos\2.bin"
SpriteTerminatD:dc.w  $FFFF,	 0,	0
DEZ1_Sprites:	binclude "Levels\DEZ\Object Pos\1.bin"
DEZ2_Sprites:	binclude "Levels\DEZ\Object Pos\2.bin"
DEZ1_Rings:	binclude "Levels\DEZ\Ring Pos\1.bin"
DEZ2_Rings:	binclude "Levels\DEZ\Ring Pos\2.bin"
word_1FB49E:	dc.w $1E
		dc.w  $1B80,  $331
		dc.w  $1BD8,  $328
		dc.w  $1C8C,  $328
		dc.w  $8004,  $400
		dc.w  $8108,  $800
		dc.w  $80FC, $7C80
		dc.w  $80FC, $7C40
		dc.w  $81F8, $3880
		dc.w  $8004,  $480
		dc.w  $8108, $8840
		dc.w  $81F8, $B840
		dc.w  $8108, $C840
		dc.w  $8004, $44C0
		dc.w  $8108, $C800
		dc.w  $81F8, $7880
		dc.w  $8004,  $440
		dc.w  $80FC, $BC80
		dc.w  $8108,  $800
		dc.w  $81F8, $7840
		dc.w  $8004, $C400
		dc.w  $8108,  $800
		dc.w  $8004,  $840
		dc.w  $8108, $4840
		dc.w  $8004, $4480
		dc.w  $81F8, $F880
		dc.w  $80FC, $7C00
		dc.w  $81F8, $F880
		dc.w  $202C,  $1A8
		dc.w  $81F8, $7880
		dc.w  $20D4,  $1A8
word_1FB518:	dc.w $26
		dc.w  $2B80,  $3B1
		dc.w  $2BD8,  $3A8
		dc.w  $2C78,  $3A8
		dc.w  $8004,  $4C0
		dc.w  $8108, $C8C0
		dc.w  $8004, $C400
		dc.w  $81F8, $7840
		dc.w  $8108, $C800
		dc.w  $8004,  $480
		dc.w  $81F8, $F800
		dc.w  $8108, $88C0
		dc.w  $8004, $C440
		dc.w  $8108, $48C0
		dc.w  $8004, $C440
		dc.w  $81F8, $B840
		dc.w  $80FC, $3C80
		dc.w  $81F8, $7800
		dc.w  $80FC, $FC40
		dc.w  $81F8, $38C0
		dc.w  $80FC, $BC40
		dc.w  $81F8, $38C0
		dc.w  $80FC, $BC40
		dc.w  $81F8, $38C0
		dc.w  $80FC, $BC40
		dc.w  $81F8, $38C0
		dc.w  $80FC, $BC80
		dc.w  $3044,  $268
		dc.w  $81F8, $7880
		dc.w  $80FC, $7CC0
		dc.w  $81F8, $B880
		dc.w  $8108,  $800
		dc.w  $8004,  $440
		dc.w  $81F8, $B880
		dc.w  $80FC, $7CC0
		dc.w  $81F8, $B880
		dc.w  $3140,  $228
		dc.w  $81F8, $7880
		dc.w  $31D0,  $228
word_1FB5B2:	dc.w $F
		dc.w  $1D00,  $1B1
		dc.w  $1D54,  $1A8
		dc.w  $1E08,  $1A8
		dc.w  $8004,  $400
		dc.w  $8108,  $800
		dc.w  $81F8, $7880
		dc.w  $81F8, $78C0
		dc.w  $80FC, $BC40
		dc.w  $8108, $C8C0
		dc.w  $8108, $C800
		dc.w  $1F44,  $228
		dc.w  $81F8, $7840
		dc.w  $8108, $C8C0
		dc.w  $81F8, $3880
		dc.w  $204C,  $228
word_1FB5F0:	dc.w $15
		dc.w  $2B80,  $5B1
		dc.w  $2BD8,  $5A8
		dc.w  $2C80,  $5A8
		dc.w  $8108,  $800
		dc.w  $8004,  $400
		dc.w  $2CC8,  $5A8
		dc.w  $80FC, $7C40
		dc.w  $8004, $C440
		dc.w  $8108, $4840
		dc.w  $8108, $4880
		dc.w  $80FC, $FC80
		dc.w  $81F8, $7800
		dc.w  $8108, $8880
		dc.w  $8004, $8400
		dc.w  $2EBC,  $668
		dc.w  $81F8, $7800
		dc.w  $80FC, $FC80
		dc.w  $8108,  $8C0
		dc.w  $8004, $C000
		dc.w  $2F08,  $628
		dc.w  $2F44,  $628
word_1FB646:	dc.w $1B
		dc.w  $2F00,  $8F1
		dc.w  $2EA8,  $8E8
		dc.w  $2DF4,  $8E8
		dc.w  $80FC, $FCC0
		dc.w  $81F8, $B880
		dc.w  $80FC, $7C00
		dc.w  $80FC, $FC00
		dc.w  $8108, $8840
		dc.w  $8004, $4000
		dc.w  $8108,  $880
		dc.w  $8004, $8480
		dc.w  $81F8, $F840
		dc.w  $80FC, $40C0
		dc.w  $8108, $48C0
		dc.w  $81F8, $3840
		dc.w  $2C34,  $9DC
		dc.w  $8004, $C440
		dc.w  $2D34,  $9AC
		dc.w  $8108, $4880
		dc.w  $81F8, $F800
		dc.w  $8108, $8880
		dc.w  $2C88,  $96C
		dc.w  $80FC, $FC00
		dc.w  $81F8, $F8C0
		dc.w  $8108, $48C0
		dc.w  $81F8, $3800
		dc.w  $2AB0,  $968
word_1FB6B4:	dc.w 6
		dc.w  $2C00,  $6B1
		dc.w  $2BA8,  $6A8
		dc.w  $2AF4,  $688
		dc.w  $8304, $8480
		dc.w  $8304, $8480
		dc.w  $2A40,  $4E8
word_1FB6CE:	dc.w 9
		dc.w  $2500,  $38E
		dc.w  $24A8,  $398
		dc.w  $240C,  $398
		dc.w  $8204, $8480
		dc.w  $8204, $8480
		dc.w  $8204, $8480
		dc.w  $8204, $84C0
		dc.w  $8204, $C400
		dc.w  $24D8,  $638
SpriteTerminatE:dc.w  $FFFF,	 0,	0
DDZ1_Sprites:	binclude "Levels\DDZ\Object Pos\1.bin"
DDZ2_Sprites:	binclude "Levels\DDZ\Object Pos\2.bin"
DDZ1_Rings:	binclude "Levels\DDZ\Ring Pos\1.bin"
DDZ2_Rings:	binclude "Levels\DDZ\Ring Pos\2.bin"
SpriteTerminatF:dc.w  $FFFF,	 0,	0
Ending_Sprites:	binclude "Levels\SSZ\Object Pos\Ending.bin"
Ending_Rings:	binclude "Levels\SSZ\Ring Pos\Ending.bin"
SpriteTerminatG:dc.w  $FFFF,	 0,	0
ALZ_Sprites:	binclude "Levels\ALZ\Object Pos\1.bin"
ALZ_Rings:	binclude "Levels\ALZ\Ring Pos\1.bin"
SpriteTerminatH:dc.w  $FFFF,	 0,	0
BPZ_Sprites:	binclude "Levels\BPZ\Object Pos\1.bin"
BPZ_Rings:	binclude "Levels\BPZ\Ring Pos\1.bin"
SpriteTerminatI:dc.w  $FFFF,	 0,	0
DPZ_Sprites:	binclude "Levels\DPZ\Object Pos\1.bin"
DPZ_Rings:	binclude "Levels\DPZ\Ring Pos\1.bin"
SpriteTerminatJ:dc.w  $FFFF,	 0,	0
CGZ_Sprites:	binclude "Levels\CGZ\Object Pos\1.bin"
CGZ_Rings:	binclude "Levels\CGZ\Ring Pos\1.bin"
SpriteTerminatK:dc.w  $FFFF,	 0,	0
EMZ_Sprites:	binclude "Levels\EMZ\Object Pos\1.bin"
EMZ_Rings:	binclude "Levels\EMZ\Ring Pos\1.bin"
SpriteTerminatL:dc.w  $FFFF,	 0,	0
Gumball_Sprites:binclude "Levels\Gumball\Object Pos\1.bin"
Gumball_Rings:	binclude "Levels\Gumball\Ring Pos\1.bin"
SpriteTerminatM:dc.w  $FFFF,	 0,	0
Pachinko_Sprites:binclude "Levels\Pachinko\Object Pos\1.bin"
Pachinko_Rings:	binclude "Levels\Pachinko\Ring Pos\1.bin"
SpriteTerminatN:dc.w  $FFFF,	 0,	0
Slots_Sprites:	binclude "Levels\Slots\Object Pos\1.bin"
Slots_Rings:	binclude "Levels\Slots\Ring Pos\1.bin"
SpriteTerminatO:dc.w  $FFFF,	 0,	0
LRZ3_Sprites:	binclude "Levels\LRZ\Object Pos\3.bin"
HPZ_Sprites:	binclude "Levels\HPZ\Object Pos\1.bin"
LRZ3_Rings:	binclude "Levels\LRZ\Ring Pos\3.bin"
HPZ_Rings:	binclude "Levels\HPZ\Ring Pos\1.bin"
DEZ3_Sprites:	binclude "Levels\DEZ\Object Pos\3.bin"
HPZMini_Sprites:binclude "Levels\HPZ\Object Pos\Mini.bin"
DEZ3_Rings:	binclude "Levels\DEZ\Ring Pos\3.bin"
SSLayoutData1_Kos:		binclude "General\Special Stage\Layout\SK Set 1.bin"
SSLayoutData2_Kos:		binclude "General\Special Stage\Layout\SK Set 2.bin"

;EndROMPadding:
	; AS would automatically strip this padding if we didn't specifically declare one byte at the end
	if ~~strip_padding && (*)&(*-1)
		cnop -1,2<<lastbit(*)
		dc.b $FF
	else
		even
	endif

EndOfROM:
	if Sonic3_Complete=0
		org $200000	; needed if you want to combine the ROM with Sonic 3 or Sonic 2 and the UPMEM
		include "Lockon S3\LockOn Pointers.asm"
	else
		include "Lockon S3\LockOn Data.asm"
	endif

		END
